-- MySQL dump 10.13  Distrib 5.7.26, for macos10.14 (x86_64)
--
-- Host: localhost    Database: marshall
-- ------------------------------------------------------
-- Server version	5.7.26

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `transientBucket`
--

DROP TABLE IF EXISTS `transientBucket`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `transientBucket` (
  `primaryKeyId` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'The primary key for this table',
  `transientBucketId` bigint(20) NOT NULL COMMENT 'This is set to the primaryKeyId of the **first** entry of this object into the database (i.e. earliest dateCreated)',
  `masterIDFlag` int(11) NOT NULL DEFAULT '0' COMMENT 'If this flag is set (=1) then the transient is assigned this name as it''s master ID. If not set (=0) then there is another entry in this table where the master ID has been set.',
  `name` varchar(40) NOT NULL COMMENT 'the name of the transient given by the reporting survey.',
  `survey` varchar(45) DEFAULT 'unknown' COMMENT 'the survey reporting observation of this transient',
  `raDeg` double DEFAULT NULL COMMENT 'RA is decimal degreed',
  `decDeg` double DEFAULT NULL COMMENT 'DEC in decimal degrees',
  `raDegErr` double DEFAULT NULL,
  `decDegErr` double DEFAULT NULL,
  `observationDate` datetime DEFAULT NULL COMMENT 'the survey observation date',
  `observationMJD` double DEFAULT NULL COMMENT 'the survey observation MJD',
  `magnitude` float DEFAULT NULL COMMENT 'the survey discovery magnitude',
  `magnitudeError` float DEFAULT NULL,
  `filter` varchar(20) DEFAULT NULL COMMENT 'survey discovery filter',
  `transientRedshift` float DEFAULT NULL COMMENT 'redshift as measured from a spectrum of the transient',
  `transientRedshiftNotes` varchar(40) DEFAULT NULL COMMENT 'transient redshift notes',
  `spectralType` varchar(100) DEFAULT NULL COMMENT 'the spectral classification given by the reporting survey (if any)',
  `discoveryPhase` varchar(20) DEFAULT NULL COMMENT 'the discovery phase given by the reporting survey (if any)',
  `dateCreated` datetime DEFAULT CURRENT_TIMESTAMP,
  `dateLastModified` datetime DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `surveyObjectUrl` varchar(400) DEFAULT NULL COMMENT 'the url for dedicated webpage of transients supplied by the reporting survey (if any)',
  `transientTypePrediction` varchar(40) DEFAULT NULL COMMENT 'an attempt at predicting the transient type by the reporting survey.',
  `transientTypePredicationSource` varchar(40) DEFAULT NULL COMMENT 'the name of the source/catalogue that was used to predict the transient type',
  `hostRedshift` float DEFAULT NULL COMMENT 'redshift measure for the host',
  `hostRedshiftType` varchar(10) DEFAULT NULL COMMENT 'type of redshift measure for the host galaxy\n',
  `referenceImageUrl` varchar(500) DEFAULT NULL COMMENT 'true or false',
  `targetImageUrl` varchar(500) DEFAULT NULL COMMENT 'true or false',
  `subtractedImageUrl` varchar(500) DEFAULT NULL,
  `tripletImageUrl` varchar(500) DEFAULT NULL,
  `htm16ID` bigint(20) unsigned DEFAULT NULL COMMENT 'HTM Level 16',
  `telescope` varchar(100) DEFAULT NULL,
  `instrument` varchar(100) DEFAULT NULL,
  `reducer` varchar(100) DEFAULT NULL,
  `lastNonDetectionDate` datetime DEFAULT NULL,
  `lastNonDetectionMJD` double DEFAULT NULL,
  `dateLastRead` datetime DEFAULT NULL,
  `finderImageUrl` varchar(450) DEFAULT NULL,
  `lightcurveURL` varchar(450) DEFAULT NULL,
  `classificationWRTMax` varchar(45) DEFAULT NULL,
  `classificationPhase` int(11) DEFAULT NULL,
  `limitingMag` tinyint(4) DEFAULT '0',
  `sherlockClassification` varchar(200) DEFAULT NULL,
  `tmpFlag` int(11) DEFAULT NULL,
  `replacedByRowId` bigint(20) DEFAULT '0',
  `dateDeleted` datetime DEFAULT NULL,
  `updated` tinyint(4) DEFAULT '0',
  `htm13ID` int(11) DEFAULT NULL,
  `htm10ID` int(11) DEFAULT NULL,
  `cz` double DEFAULT NULL,
  `cx` double DEFAULT NULL,
  `htm20ID` bigint(20) DEFAULT NULL,
  `cy` double DEFAULT NULL,
  PRIMARY KEY (`primaryKeyId`) KEY_BLOCK_SIZE=1024,
  UNIQUE KEY `primaryKey_UNIQUE` (`primaryKeyId`) KEY_BLOCK_SIZE=1024,
  UNIQUE KEY `name_observationmjd_magnitude_filter_survey` (`name`,`observationMJD`,`magnitude`,`filter`,`survey`,`replacedByRowId`) KEY_BLOCK_SIZE=1024,
  UNIQUE KEY `name_observationmjd_magnitude_filter` (`name`,`observationMJD`,`magnitude`,`filter`,`replacedByRowId`),
  UNIQUE KEY `name_survey_obsmjd_decDeg_classification` (`name`,`survey`,`decDeg`,`observationMJD`,`replacedByRowId`,`spectralType`) KEY_BLOCK_SIZE=1024,
  KEY `idx_htm16ID` (`htm16ID`) KEY_BLOCK_SIZE=1024,
  KEY `idx_name` (`name`) KEY_BLOCK_SIZE=1024,
  KEY `tbi` (`transientBucketId`),
  KEY `masterflag` (`masterIDFlag`),
  KEY `idx_htm10ID` (`htm13ID`),
  KEY `idx_htm13ID` (`htm13ID`),
  KEY `idx_transientBucketId` (`transientBucketId`),
  KEY `idx_replacedByRowId` (`replacedByRowId`),
  KEY `idx_sherlockClassifcaition` (`sherlockClassification`),
  KEY `idx_magnitude` (`magnitude`),
  KEY `idx_htm20ID` (`htm20ID`),
  KEY `idx_dateLastModified` (`dateLastModified`),
  KEY `idx_observationmjd` (`observationMJD`),
  KEY `idx_observationDate` (`observationDate`),
  KEY `idx_surveyObjectUrl` (`surveyObjectUrl`),
  KEY `idx_dateCreated` (`dateCreated`),
  KEY `idx_replace_master` (`replacedByRowId`,`masterIDFlag`),
  FULLTEXT KEY `fulltext` (`name`,`survey`,`surveyObjectUrl`),
  FULLTEXT KEY `fulltext_name_survey_surveyObjectUrl` (`name`,`survey`,`surveyObjectUrl`),
  FULLTEXT KEY `fulltext_name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=42027450 DEFAULT CHARSET=utf8 ROW_FORMAT=COMPRESSED KEY_BLOCK_SIZE=8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `transientBucket`
--
-- WHERE:  1 limit 10000

LOCK TABLES `transientBucket` WRITE;
/*!40000 ALTER TABLE `transientBucket` DISABLE KEYS */;
INSERT INTO `transientBucket` VALUES (1,48203,1,'LSQ13cho','LSQ',358.356708333,-6.45577777777778,NULL,NULL,'2012-07-07 11:18:33',56115.42955,18.6996,0.2048,'gr-LSQ',NULL,NULL,'IIb',NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_history.html','sne',NULL,NULL,NULL,NULL,'https://f87e10c6-a-05bac853-s-sites.googlegroups.com/a/pessto.org/wiki/pessto-wiki/home/finder-chart-repo/PSNJ13124116p1236018_fc.png',NULL,'https://f87e10c6-a-05bac853-s-sites.googlegroups.com/a/pessto.org/wiki/pessto-wiki/home/finder-chart-repo/PSNJ13124116p1236018_fc.png?attachauth=ANoY7crcR6M5pLKEFfk_hAsSAia3UJtRY1MsQe6f0oZBcpimNCcDM0mQQffRQ30AHs941uUlRh6fEzPT_cbmz8DrAclJD8v7NcP8aPvr6pd-1_sCfnd_oLNITBH2TkaiI_jEtg_FOn8kgL8W-ECV4FCmVHU3p-WJxHs3SULnezSEAlLWuZDda7uBitnZuHXnFvqnHWA9njNgjPDh7D5PVMSxFf1lLvUULPU0fFkBZG6H87Jbo2Dd0kc9_jv11Yb_VNtnPJVqPuKz6-CwbKbHXotwSgfxWT8FZw%3D%3D',49431272838,NULL,NULL,NULL,'2011-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,772363638,12068181,NULL,NULL,NULL,NULL),(2,48203,0,'LSQ12dlc','LSQ',36.8000416666667,-6.45563888888889,NULL,NULL,'2012-07-09 09:11:22',56117.3412299999,19.0466,0.1169,'gr-LSQ',NULL,NULL,'II',NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_history.html','sne',NULL,NULL,NULL,NULL,'http://www.das.uchile.cl/~gpignata/pessto/PSNJ08070669-2803101.gif',NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_snap_42931.gif',34941112030,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,545954875,8530544,NULL,NULL,NULL,NULL),(3,48203,0,'LSQ12dlc','LSQ',36.8,-50.5980833333333,NULL,NULL,'2012-07-09 10:28:01',56117.3944600001,19.2612,0.0897,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_history.html','sne',NULL,NULL,NULL,NULL,'http://cador.obs-hp.fr/sn_tarot/PSN_J06161835-2122329/NGC2207_20130301b.png',NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_snap_42932.gif',38190280452,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,596723132,9323798,NULL,NULL,NULL,NULL),(4,48203,0,'LSQ12dlc','LSQ',36.7999583333333,-6.45566666666667,NULL,NULL,'2012-07-11 10:46:54',56119.4075799999,18.3799,0.0864,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_snap_43084.gif',34941112030,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,545954875,8530544,NULL,NULL,NULL,NULL),(5,48203,0,'LSQ12dlc','LSQ',36.800125,-6.45577777777778,NULL,NULL,'2012-07-11 11:14:14',56119.4265600001,19.028,0.106,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_snap_43085.gif',34941112030,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,545954875,8530544,NULL,NULL,NULL,NULL),(6,48203,0,'LSQ12dlc','LSQ',36.8000416666667,-6.45566666666667,NULL,NULL,'2012-07-15 11:15:12',56123.42723,19.5923,0.0647,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_snap_43539.gif',34941112030,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,545954875,8530544,NULL,NULL,NULL,NULL),(7,48203,0,'LSQ12dlc','LSQ',36.8,-6.45563888888889,NULL,NULL,'2012-07-15 11:33:55',56123.4402200002,19.4087,0.0941,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_snap_43540.gif',34941112030,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,545954875,8530544,NULL,NULL,NULL,NULL),(8,48203,0,'LSQ12dlc','LSQ',36.7999583333333,-6.45558333333333,NULL,NULL,'2012-07-17 09:48:44',56125.3671800001,19.3993,0.091,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_snap_43889.gif',34941112030,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,545954875,8530544,NULL,NULL,NULL,NULL),(9,48203,0,'LSQ12dlc','LSQ',36.7999583333333,-6.45563888888889,NULL,NULL,'2012-07-17 11:21:38',56125.4317000001,19.2419,0.0877,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_snap_43890.gif',34941112030,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,545954875,8530544,NULL,NULL,NULL,NULL),(10,48203,0,'LSQ12dlc','LSQ',36.7999583333333,-50.598083333,NULL,NULL,'2012-07-23 08:29:03',56131.3118500002,18.7236,0.142,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_snap_45274.gif',38190280452,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,596723132,9323798,NULL,NULL,NULL,NULL),(11,48203,0,'LSQ12dlc','LSQ',36.8000416666667,-50.5980833333333,NULL,NULL,'2012-07-23 10:02:36',56131.3768099998,19.4502,0.1976,'gr-LSQ',NULL,NULL,'II',NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_snap_45275.gif',38190280452,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,596723132,9323798,NULL,NULL,NULL,NULL),(12,48203,0,'LSQ12dlc','LSQ',36.8,-6.45566666666667,NULL,NULL,'2012-07-25 08:50:32',56133.3267600001,19.5774,0.0803,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_snap_45809.gif',34941112030,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,545954875,8530544,NULL,NULL,NULL,NULL),(13,48203,0,'LSQ12dlc','LSQ',36.8000416666667,-6.45569444444444,NULL,NULL,'2012-07-25 10:12:50',56133.3839199999,19.4406,0.0946,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_snap_45810.gif',34941112030,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,545954875,8530544,NULL,NULL,NULL,NULL),(14,48203,0,'LSQ12dlc','LSQ',36.8,-6.45563888888889,NULL,NULL,'2012-07-27 08:03:51',56135.2943500001,18.749,0.0862,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_snap_46293.gif',34941112030,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,545954875,8530544,NULL,NULL,NULL,NULL),(15,48203,0,'LSQ12dlc','LSQ',36.7999583333333,-6.45561111111111,NULL,NULL,'2012-07-29 08:08:47',56137.2977700001,19.287,0.1554,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_snap_47236.gif',34941112030,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,545954875,8530544,NULL,NULL,NULL,NULL),(16,48203,0,'LSQ12dlc','LSQ',36.8000416666667,-6.45561111111111,NULL,NULL,'2012-07-29 11:12:49',56137.42557,19.361,0.0951,'gr-LSQ',NULL,NULL,'Ib/c',NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlc/LSQ12dlc_snap_47237.gif',34941112030,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,545954875,8530544,NULL,NULL,NULL,NULL),(17,17,1,'LSQ12dkp','LSQ',30.1440416666667,-0.500972222222222,NULL,NULL,'2012-07-09 08:53:23',56117.3287499999,21.027,0.114,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkp/LSQ12dkp_history.html','sne',NULL,0.117,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkp/LSQ12dkp_snap_42905.gif',35004557700,NULL,NULL,NULL,'2012-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546946214,8546034,NULL,NULL,NULL,NULL),(18,17,0,'LSQ12dkp','LSQ',30.1440416666667,-0.500944444444444,NULL,NULL,'2012-07-09 10:21:15',56117.3897600002,20.7617,0.1176,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkp/LSQ12dkp_history.html','sne',NULL,0.117,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkp/LSQ12dkp_snap_42906.gif',35004557700,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546946214,8546034,NULL,NULL,NULL,NULL),(19,17,0,'LSQ12dkp','LSQ',30.1440416666667,-0.500916666666667,NULL,NULL,'2012-07-27 08:47:54',56135.3249400002,21.9312,0.2097,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkp/LSQ12dkp_history.html','sne',NULL,0.117,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkp/LSQ12dkp_snap_46278.gif',35004557700,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546946214,8546034,NULL,NULL,NULL,NULL),(20,17,0,'LSQ12dkp','LSQ',30.144125,-0.500916666666667,NULL,NULL,'2012-07-27 10:11:38',56135.3830900001,21.6159,0.1686,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkp/LSQ12dkp_history.html','sne',NULL,0.117,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkp/LSQ12dkp_snap_46279.gif',35004557700,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546946214,8546034,NULL,NULL,NULL,NULL),(21,21,1,'LSQ12dkj','LSQ',240.155291666667,-2.56011111111111,NULL,NULL,'2012-07-09 01:32:04',56117.0222800002,19.5949,0.1093,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkj/LSQ12dkj_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkj/LSQ12dkj_snap_42893.gif',45529877078,NULL,NULL,NULL,'2012-07-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,711404329,11115692,NULL,NULL,NULL,NULL),(22,21,0,'LSQ12dkj','LSQ',240.155291666667,-2.56013888888889,NULL,NULL,'2012-07-09 03:32:40',56117.1060299999,20.3157,0.1468,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkj/LSQ12dkj_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkj/LSQ12dkj_snap_42894.gif',45529877078,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,711404329,11115692,NULL,NULL,NULL,NULL),(23,21,0,'LSQ12dkj','LSQ',240.155333333333,-2.56022222222222,NULL,NULL,'2012-07-23 01:07:57',56131.0055300002,20.0699,0.1592,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkj/LSQ12dkj_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkj/LSQ12dkj_snap_45281.gif',45529877078,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,711404329,11115692,NULL,NULL,NULL,NULL),(24,21,0,'LSQ12dkj','LSQ',240.155416666667,-2.56013888888889,NULL,NULL,'2012-07-29 00:43:33',56136.9885800001,19.2189,0.1592,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkj/LSQ12dkj_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkj/LSQ12dkj_snap_47231.gif',45529877078,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,711404329,11115692,NULL,NULL,NULL,NULL),(25,21,0,'LSQ12dkj','LSQ',240.155416666667,-2.56016666666667,NULL,NULL,'2012-07-29 02:44:18',56137.0724399998,19.8449,0.1489,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkj/LSQ12dkj_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkj/LSQ12dkj_snap_47232.gif',45529877078,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,711404329,11115692,NULL,NULL,NULL,NULL),(26,26,1,'LSQ12dkh','LSQ',231.71625,-0.877361111111111,NULL,NULL,'2012-07-07 01:32:45',56115.02275,20.3629,0.1355,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_snap_42955.gif',45403731771,NULL,NULL,NULL,'2012-07-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,709433308,11084895,NULL,NULL,NULL,NULL),(27,26,0,'LSQ12dkh','LSQ',231.716125,-0.877388888888889,NULL,NULL,'2012-07-09 00:59:28',56116.99963,19.5941,0.0945,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_snap_42889.gif',45403731771,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,709433308,11084895,NULL,NULL,NULL,NULL),(28,26,0,'LSQ12dkh','LSQ',231.716208333333,-0.877416666666667,NULL,NULL,'2012-07-09 03:00:00',56117.0833399999,19.5378,0.1052,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_snap_42890.gif',45403731771,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,709433308,11084895,NULL,NULL,NULL,NULL),(29,26,0,'LSQ12dkh','LSQ',231.71625,-0.877416666666667,NULL,NULL,'2012-07-11 01:00:12',56119.0001500002,19.4312,0.0762,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_snap_43077.gif',45403731771,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,709433308,11084895,NULL,NULL,NULL,NULL),(30,26,0,'LSQ12dkh','LSQ',231.716166666667,-0.877416666666667,NULL,NULL,'2012-07-13 01:00:50',56121.0005800002,19.2794,0.071,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_snap_43312.gif',45403731771,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,709433308,11084895,NULL,NULL,NULL,NULL),(31,26,0,'LSQ12dkh','LSQ',231.71625,-0.877416666666667,NULL,NULL,'2012-07-19 00:52:45',56126.9949699999,19.0737,0.0584,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_snap_44731.gif',45403731771,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,709433308,11084895,NULL,NULL,NULL,NULL),(32,26,0,'LSQ12dkh','LSQ',231.716166666667,-0.877444444444444,NULL,NULL,'2012-07-23 00:40:24',56130.9863900002,19.1715,0.0788,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_snap_45265.gif',45403731771,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,709433308,11084895,NULL,NULL,NULL,NULL),(33,26,0,'LSQ12dkh','LSQ',231.716375,-0.877388888888889,NULL,NULL,'2012-07-27 02:03:38',56135.0441999999,19.4193,0.1814,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_snap_46292.gif',45403731771,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,709433308,11084895,NULL,NULL,NULL,NULL),(34,26,0,'LSQ12dkh','LSQ',231.716333333333,-0.877416666666667,NULL,NULL,'2012-07-29 01:20:52',56137.0145,19.487,0.15,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkh/LSQ12dkh_snap_47226.gif',45403731771,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,709433308,11084895,NULL,NULL,NULL,NULL),(35,35,1,'LSQ12dkg','LSQ',41.2560833333333,-0.730111111111111,NULL,NULL,'2012-07-09 09:42:04',56117.3625500002,17.1124,0.0275,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkg/LSQ12dkg_history.html','sne-nice',NULL,0.05426,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkg/LSQ12dkg_snap_42887.gif',34903707595,NULL,NULL,NULL,'2010-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545370431,8521412,NULL,NULL,NULL,NULL),(36,35,0,'LSQ12dkg','LSQ',41.2560833333333,-0.730194444444444,NULL,NULL,'2012-07-09 10:41:37',56117.4039099999,17.3142,0.0277,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkg/LSQ12dkg_history.html','sne-nice',NULL,0.05426,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkg/LSQ12dkg_snap_42888.gif',34903707595,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545370431,8521412,NULL,NULL,NULL,NULL),(37,35,0,'LSQ12dkg','LSQ',41.2560833333333,-0.730138888888889,NULL,NULL,'2012-07-23 09:19:21',56131.3467799998,18.2903,0.1,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkg/LSQ12dkg_history.html','sne-nice',NULL,0.05426,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkg/LSQ12dkg_snap_45262.gif',34903707595,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545370431,8521412,NULL,NULL,NULL,NULL),(38,35,0,'LSQ12dkg','LSQ',41.2560833333333,-0.730222222222222,NULL,NULL,'2012-07-23 10:27:45',56131.3942800001,18.1947,0.0587,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkg/LSQ12dkg_history.html','sne-nice',NULL,0.05426,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkg/LSQ12dkg_snap_45263.gif',34903707595,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545370431,8521412,NULL,NULL,NULL,NULL),(39,35,0,'LSQ12dkg','LSQ',41.256125,-0.730083333333333,NULL,NULL,'2012-07-27 09:01:27',56135.3343500001,17.961,0.04,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkg/LSQ12dkg_history.html','sne-nice',NULL,0.05426,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkg/LSQ12dkg_snap_46261.gif',34903707595,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545370431,8521412,NULL,NULL,NULL,NULL),(40,35,0,'LSQ12dkg','LSQ',41.256125,-0.730166666666667,NULL,NULL,'2012-07-27 10:18:25',56135.3878000001,17.8458,0.035,'gr-LSQ',NULL,NULL,'unknown',NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkg/LSQ12dkg_history.html','sne-nice',NULL,0.05426,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkg/LSQ12dkg_snap_46262.gif',34903707595,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545370431,8521412,NULL,NULL,NULL,NULL),(41,35,0,'LSQ12dkg','LSQ',41.25625,-0.730055555555556,NULL,NULL,'2012-07-29 09:03:06',56137.33549,17.9797,0.0443,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkg/LSQ12dkg_history.html','sne-nice',NULL,0.05426,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkg/LSQ12dkg_snap_47219.gif',34903707595,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545370431,8521412,NULL,NULL,NULL,NULL),(42,35,0,'LSQ12dkg','LSQ',41.2560833333333,-0.730111111111111,NULL,NULL,'2012-07-29 10:18:07',56137.3875899999,18.1234,0.0366,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkg/LSQ12dkg_history.html','sne-nice',NULL,0.05426,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dkg/LSQ12dkg_snap_47220.gif',34903707595,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545370431,8521412,NULL,NULL,NULL,NULL),(43,43,1,'LSQ12dka','LSQ',338.102833333333,-0.856361111111111,NULL,NULL,'2012-07-05 05:40:41',56113.1949200002,18.8961,0.1487,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dka/LSQ12dka_history.html','sne-nice',NULL,0.08942,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dka/LSQ12dka_snap_42950.gif',50332511730,NULL,NULL,NULL,'2012-06-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,786445495,12288210,NULL,NULL,NULL,NULL),(44,43,0,'LSQ12dka','LSQ',338.10275,-0.856333333333333,NULL,NULL,'2012-07-05 07:39:47',56113.2776299999,18.7869,0.1814,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dka/LSQ12dka_history.html','sne-nice',NULL,0.08942,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dka/LSQ12dka_snap_42951.gif',50332511730,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,786445495,12288210,NULL,NULL,NULL,NULL),(45,43,0,'LSQ12dka','LSQ',338.10275,-0.856277777777778,NULL,NULL,'2012-07-09 05:24:09',56117.1834399998,19.1211,0.1298,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dka/LSQ12dka_history.html','sne-nice',NULL,0.08942,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dka/LSQ12dka_snap_42875.gif',50332511730,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,786445495,12288210,NULL,NULL,NULL,NULL),(46,43,0,'LSQ12dka','LSQ',338.102708333333,-0.85625,NULL,NULL,'2012-07-09 07:24:13',56117.26682,18.8167,0.1424,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dka/LSQ12dka_history.html','sne-nice',NULL,0.08942,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dka/LSQ12dka_snap_42876.gif',50332511730,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,786445495,12288210,NULL,NULL,NULL,NULL),(47,43,0,'LSQ12dka','LSQ',338.102666666667,-0.856027777777778,NULL,NULL,'2012-07-27 06:21:42',56135.2234100001,20.015,0.1974,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dka/LSQ12dka_history.html','sne-nice',NULL,0.08942,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dka/LSQ12dka_snap_46253.gif',50332511730,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,786445495,12288210,NULL,NULL,NULL,NULL),(48,48,1,'LSQ12djy','LSQ',246.300958333333,4.90677777777778,NULL,NULL,'2012-07-05 01:56:19',56113.0391199999,18.0289,0.0449,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_snap_42943.gif',56443767718,NULL,NULL,NULL,'2012-06-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881933870,13780216,NULL,NULL,NULL,NULL),(49,48,0,'LSQ12djy','LSQ',246.300958333333,4.90680555555556,NULL,NULL,'2012-07-05 03:56:57',56113.1228900002,18.1297,0.0466,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_snap_42944.gif',56443767718,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881933870,13780216,NULL,NULL,NULL,NULL),(50,48,0,'LSQ12djy','LSQ',246.300958333333,4.90680555555556,NULL,NULL,'2012-07-07 02:24:16',56115.05853,18.1298,0.029,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_snap_42945.gif',56443767718,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881933870,13780216,NULL,NULL,NULL,NULL),(51,48,0,'LSQ12djy','LSQ',246.301,4.90680555555556,NULL,NULL,'2012-07-07 04:24:40',56115.1421300001,18.1697,0.0403,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_snap_42946.gif',56443767718,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881933870,13780216,NULL,NULL,NULL,NULL),(52,48,0,'LSQ12djy','LSQ',246.300958333333,4.90680555555556,NULL,NULL,'2012-07-09 01:55:42',56117.0386899998,18.3821,0.0288,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_snap_42871.gif',56443767718,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881933870,13780216,NULL,NULL,NULL,NULL),(53,48,0,'LSQ12djy','LSQ',246.300958333333,4.90680555555556,NULL,NULL,'2012-07-09 04:00:00',56117.1250100001,18.3096,0.0282,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_snap_42872.gif',56443767718,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881933870,13780216,NULL,NULL,NULL,NULL),(54,48,0,'LSQ12djy','LSQ',246.300958333333,4.90680555555556,NULL,NULL,'2012-07-23 01:29:59',56131.0208299998,18.9199,0.045,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_snap_45319.gif',56443767718,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881933870,13780216,NULL,NULL,NULL,NULL),(55,48,0,'LSQ12djy','LSQ',246.301041666667,4.90680555555556,NULL,NULL,'2012-07-23 03:30:27',56131.1044800002,18.9359,0.0725,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_snap_45320.gif',56443767718,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881933870,13780216,NULL,NULL,NULL,NULL),(56,48,0,'LSQ12djy','LSQ',246.300916666667,4.90688888888889,NULL,NULL,'2012-08-04 04:14:28',56143.1350500002,19.5919,0.2,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djy/LSQ12djy_snap_49563.gif',56443767718,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881933870,13780216,NULL,NULL,NULL,NULL),(57,57,1,'LSQ12djx','LSQ',248.4625,6.95141666666667,NULL,NULL,'2012-07-05 01:49:33',56113.0344199999,19.1453,0.1155,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_snap_42939.gif',56765709353,NULL,NULL,NULL,'2012-06-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,886964208,13858815,NULL,NULL,NULL,NULL),(58,57,0,'LSQ12djx','LSQ',248.462458333333,6.95147222222222,NULL,NULL,'2012-07-05 03:50:11',56113.1181899998,18.8666,0.0831,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_snap_42940.gif',56765709353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,886964208,13858815,NULL,NULL,NULL,NULL),(59,57,0,'LSQ12djx','LSQ',248.462541666667,6.95144444444444,NULL,NULL,'2012-07-07 02:17:30',56115.0538300001,19.12,0.0618,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_snap_42941.gif',56765709353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,886964208,13858815,NULL,NULL,NULL,NULL),(60,57,0,'LSQ12djx','LSQ',248.4625,6.95138888888889,NULL,NULL,'2012-07-07 04:17:52',56115.13741,19.059,0.071,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_snap_42942.gif',56765709353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,886964208,13858815,NULL,NULL,NULL,NULL),(61,57,0,'LSQ12djx','LSQ',248.462458333333,6.95144444444444,NULL,NULL,'2012-07-09 01:48:57',56117.034,19.2363,0.0464,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_snap_42869.gif',56765709353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,886964208,13858815,NULL,NULL,NULL,NULL),(62,57,0,'LSQ12djx','LSQ',248.462458333333,6.95141666666667,NULL,NULL,'2012-07-09 03:53:13',56117.1203000001,19.2126,0.0473,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_snap_42870.gif',56765709353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,886964208,13858815,NULL,NULL,NULL,NULL),(63,57,0,'LSQ12djx','LSQ',248.462458333333,6.95147222222222,NULL,NULL,'2012-07-13 02:02:59',56121.0437400001,19.1939,0.0455,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_snap_43316.gif',56765709353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,886964208,13858815,NULL,NULL,NULL,NULL),(64,57,0,'LSQ12djx','LSQ',248.462541666667,6.95147222222222,NULL,NULL,'2012-07-15 01:55:40',56123.0386600001,19.0007,0.0424,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_snap_43544.gif',56765709353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,886964208,13858815,NULL,NULL,NULL,NULL),(65,57,0,'LSQ12djx','LSQ',248.462458333333,6.95141666666667,NULL,NULL,'2012-07-19 01:39:49',56127.0276600001,19.2197,0.0429,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_snap_44738.gif',56765709353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,886964208,13858815,NULL,NULL,NULL,NULL),(66,57,0,'LSQ12djx','LSQ',248.462583333333,6.95138888888889,NULL,NULL,'2012-07-21 01:32:09',56129.0223300001,19.1103,0.1772,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_snap_45025.gif',56765709353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,886964208,13858815,NULL,NULL,NULL,NULL),(67,57,0,'LSQ12djx','LSQ',248.4625,6.95141666666667,NULL,NULL,'2012-07-23 01:23:15',56131.01615,19.3938,0.0625,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_snap_45302.gif',56765709353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,886964208,13858815,NULL,NULL,NULL,NULL),(68,57,0,'LSQ12djx','LSQ',248.462625,6.95136111111111,NULL,NULL,'2012-07-23 03:25:22',56131.10096,19.1293,0.1369,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_snap_45303.gif',56765709353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,886964208,13858815,NULL,NULL,NULL,NULL),(69,57,0,'LSQ12djx','LSQ',248.462458333333,6.95141666666667,NULL,NULL,'2012-07-27 01:06:59',56135.0048600002,18.6993,0.0819,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_snap_46323.gif',56765709353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,886964208,13858815,NULL,NULL,NULL,NULL),(70,57,0,'LSQ12djx','LSQ',248.4625,6.95138888888889,NULL,NULL,'2012-07-29 00:58:44',56136.9991299999,18.7317,0.1158,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_snap_47314.gif',56765709353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,886964208,13858815,NULL,NULL,NULL,NULL),(71,57,0,'LSQ12djx','LSQ',248.462541666667,6.95141666666667,NULL,NULL,'2012-07-29 03:01:22',56137.0842900001,18.7971,0.1407,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_snap_47315.gif',56765709353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,886964208,13858815,NULL,NULL,NULL,NULL),(72,57,0,'LSQ12djx','LSQ',248.462666666667,6.95141666666667,NULL,NULL,'2012-08-04 04:30:50',56143.1464200001,18.3345,0.1387,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djx/LSQ12djx_snap_49560.gif',56765709353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,886964208,13858815,NULL,NULL,NULL,NULL),(73,73,1,'LSQ12djv','LSQ',251.267375,5.61513888888889,NULL,NULL,'2012-07-07 02:34:25',56115.0655700001,19.7859,0.1241,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djv/LSQ12djv_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djv/LSQ12djv_snap_42936.gif',56714908272,NULL,NULL,NULL,'2012-07-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,886170441,13846413,NULL,NULL,NULL,NULL),(74,73,0,'LSQ12djv','LSQ',251.267333333333,5.61519444444444,NULL,NULL,'2012-07-07 04:34:49',56115.1491800002,20.1178,0.1648,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djv/LSQ12djv_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djv/LSQ12djv_snap_42937.gif',56714908272,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,886170441,13846413,NULL,NULL,NULL,NULL),(75,73,0,'LSQ12djv','LSQ',251.267333333333,5.61519444444444,NULL,NULL,'2012-07-09 02:05:51',56117.0457299999,19.2958,0.0937,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djv/LSQ12djv_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djv/LSQ12djv_snap_42863.gif',56714908272,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,886170441,13846413,NULL,NULL,NULL,NULL),(76,73,0,'LSQ12djv','LSQ',251.267291666667,5.61511111111111,NULL,NULL,'2012-07-09 04:10:08',56117.1320400001,19.2703,0.107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djv/LSQ12djv_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djv/LSQ12djv_snap_42864.gif',56714908272,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,886170441,13846413,NULL,NULL,NULL,NULL),(77,73,0,'LSQ12djv','LSQ',251.267291666667,5.61519444444444,NULL,NULL,'2012-07-15 02:10:55',56123.0492500002,20.1471,0.1642,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djv/LSQ12djv_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djv/LSQ12djv_snap_43526.gif',56714908272,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,886170441,13846413,NULL,NULL,NULL,NULL),(78,73,0,'LSQ12djv','LSQ',251.267375,5.61516666666667,NULL,NULL,'2012-07-23 01:40:09',56131.02789,20.7259,0.1468,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djv/LSQ12djv_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djv/LSQ12djv_snap_45256.gif',56714908272,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,886170441,13846413,NULL,NULL,NULL,NULL),(79,73,0,'LSQ12djv','LSQ',251.267458333333,5.61530555555556,NULL,NULL,'2012-07-23 03:40:37',56131.11154,20.4017,0.1652,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djv/LSQ12djv_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djv/LSQ12djv_snap_45257.gif',56714908272,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,886170441,13846413,NULL,NULL,NULL,NULL),(80,73,0,'LSQ12djv','LSQ',251.267375,5.61522222222222,NULL,NULL,'2012-07-25 01:58:43',56133.0407799999,20.0141,0.1785,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djv/LSQ12djv_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djv/LSQ12djv_snap_45791.gif',56714908272,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,886170441,13846413,NULL,NULL,NULL,NULL),(81,81,1,'LSQ12dli','LSQ',43.4815,-23.7229444444444,NULL,NULL,'2012-07-10 11:23:32',56118.4330199999,19.2841,0.066,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dli/LSQ12dli_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dli/LSQ12dli_snap_43065.gif',37937014005,NULL,NULL,NULL,'2012-07-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,592765843,9261966,NULL,NULL,NULL,NULL),(82,81,0,'LSQ12dli','LSQ',43.4815,-23.7230277777778,NULL,NULL,'2012-07-10 11:36:12',56118.4418100002,19.4068,0.0883,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dli/LSQ12dli_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dli/LSQ12dli_snap_43066.gif',37937014005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,592765843,9261966,NULL,NULL,NULL,NULL),(83,81,0,'LSQ12dli','LSQ',43.4815833333333,-23.7228888888889,NULL,NULL,'2012-07-20 11:05:00',56128.4201400001,20.1197,0.2032,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dli/LSQ12dli_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dli/LSQ12dli_snap_44861.gif',37937014005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,592765843,9261966,NULL,NULL,NULL,NULL),(84,81,0,'LSQ12dli','LSQ',43.4815,-23.7229166666667,NULL,NULL,'2012-07-20 11:22:10',56128.4320700001,20.2801,0.1592,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dli/LSQ12dli_history.html','radio source',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dli/LSQ12dli_snap_44862.gif',37937014005,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,592765843,9261966,NULL,NULL,NULL,NULL),(85,85,1,'LSQ12dlf','LSQ',27.6241666666667,-21.8126111111111,NULL,NULL,'2012-07-10 09:37:26',56118.35934,18.7585,0.0718,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_snap_43059.gif',35034119519,NULL,NULL,NULL,'2012-07-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547408117,8553251,NULL,NULL,NULL,NULL),(86,85,0,'LSQ12dlf','LSQ',27.624125,-21.8126388888889,NULL,NULL,'2012-07-10 10:50:57',56118.4103899999,18.6088,0.0641,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_snap_43060.gif',35034119519,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547408117,8553251,NULL,NULL,NULL,NULL),(87,85,0,'LSQ12dlf','LSQ',27.624125,-21.8126388888889,NULL,NULL,'2012-07-16 10:55:40',56124.4136600001,18.4228,0.0768,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_snap_43771.gif',35034119519,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547408117,8553251,NULL,NULL,NULL,NULL),(88,85,0,'LSQ12dlf','LSQ',27.624,-21.8126388888889,NULL,NULL,'2012-07-16 11:28:09',56124.43622,18.2271,0.0441,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_snap_43772.gif',35034119519,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547408117,8553251,NULL,NULL,NULL,NULL),(89,85,0,'LSQ12dlf','LSQ',27.624125,-21.8126111111111,NULL,NULL,'2012-07-18 11:20:19',56126.4307800001,18.4692,0.0405,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_snap_44459.gif',35034119519,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547408117,8553251,NULL,NULL,NULL,NULL),(90,85,0,'LSQ12dlf','LSQ',27.6242083333333,-21.8126666666667,NULL,NULL,'2012-07-22 08:37:04',56130.3174100001,18.274,0.0331,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_snap_45129.gif',35034119519,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547408117,8553251,NULL,NULL,NULL,NULL),(91,85,0,'LSQ12dlf','LSQ',27.6240833333333,-21.8126111111111,NULL,NULL,'2012-07-24 10:54:00',56132.4125100002,18.278,0.0307,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_snap_45559.gif',35034119519,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547408117,8553251,NULL,NULL,NULL,NULL),(92,85,0,'LSQ12dlf','LSQ',27.624125,-21.8126111111111,NULL,NULL,'2012-07-28 06:52:54',56136.2450799998,18.1292,0.0661,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_snap_46640.gif',35034119519,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547408117,8553251,NULL,NULL,NULL,NULL),(93,85,0,'LSQ12dlf','LSQ',27.624125,-21.8126111111111,NULL,NULL,'2012-07-28 08:52:39',56136.3282300001,18.1933,0.0316,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_snap_46641.gif',35034119519,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547408117,8553251,NULL,NULL,NULL,NULL),(94,85,0,'LSQ12dlf','LSQ',27.6241666666667,-21.8125833333333,NULL,NULL,'2012-07-30 07:10:31',56138.2573099998,18.1587,0.0665,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_snap_48379.gif',35034119519,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547408117,8553251,NULL,NULL,NULL,NULL),(95,85,0,'LSQ12dlf','LSQ',27.6241666666667,-21.8125833333333,NULL,NULL,'2012-07-30 09:12:02',56138.3417000002,18.1793,0.0449,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlf/LSQ12dlf_snap_48380.gif',35034119519,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547408117,8553251,NULL,NULL,NULL,NULL),(96,96,1,'LSQ12dle','LSQ',25.1842916666667,-25.2649166666667,NULL,NULL,'2012-07-10 09:37:26',56118.35934,18.4788,0.0677,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_43057.gif',34695840990,NULL,NULL,NULL,'2012-07-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(97,96,0,'LSQ12dle','LSQ',25.1843333333333,-25.2648888888889,NULL,NULL,'2012-07-10 10:50:57',56118.4103899999,18.3289,0.0563,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_43058.gif',34695840990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(98,96,0,'LSQ12dle','LSQ',25.184375,-25.2648611111111,NULL,NULL,'2012-07-16 10:55:40',56124.4136600001,17.2062,0.0189,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_43769.gif',34695840990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(99,96,0,'LSQ12dle','LSQ',25.1843333333333,-25.2648611111111,NULL,NULL,'2012-07-16 11:28:09',56124.43622,17.1474,0.0191,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_43770.gif',34695840990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(100,96,0,'LSQ12dle','LSQ',25.1843333333333,-25.2648888888889,NULL,NULL,'2012-07-18 11:01:24',56126.4176400001,17.1901,0.0169,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_44460.gif',34695840990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(101,96,0,'LSQ12dle','LSQ',25.1843333333333,-25.2648888888889,NULL,NULL,'2012-07-18 11:20:19',56126.4307800001,17.0951,0.018,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_44461.gif',34695840990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(102,96,0,'LSQ12dle','LSQ',25.1843333333333,-25.2648611111111,NULL,NULL,'2012-07-20 10:51:26',56128.41072,16.9765,0.024,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_44865.gif',34695840990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(103,96,0,'LSQ12dle','LSQ',25.1843333333333,-25.2648611111111,NULL,NULL,'2012-07-20 11:15:25',56128.4273799998,17.0303,0.0257,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_44866.gif',34695840990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(104,96,0,'LSQ12dle','LSQ',25.1843333333333,-25.2648888888889,NULL,NULL,'2012-07-22 08:37:04',56130.3174100001,16.9932,0.0153,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_45127.gif',34695840990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(105,96,0,'LSQ12dle','LSQ',25.1843333333333,-25.2648888888889,NULL,NULL,'2012-07-22 10:06:31',56130.37953,16.9697,0.0165,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_45128.gif',34695840990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(106,96,0,'LSQ12dle','LSQ',25.1843333333333,-25.2648888888889,NULL,NULL,'2012-07-24 10:54:00',56132.4125100002,16.9652,0.0148,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_45557.gif',34695840990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(107,96,0,'LSQ12dle','LSQ',25.1843333333333,-25.2648611111111,NULL,NULL,'2012-07-24 11:14:39',56132.4268499999,16.995,0.0145,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_45558.gif',34695840990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(108,96,0,'LSQ12dle','LSQ',25.184375,-25.2648888888889,NULL,NULL,'2012-07-26 09:05:30',56134.3371600001,17.0595,0.0204,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_46090.gif',34695840990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(109,96,0,'LSQ12dle','LSQ',25.1843333333333,-25.2648611111111,NULL,NULL,'2012-07-26 10:19:55',56134.3888400001,17.0683,0.0162,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_46091.gif',34695840990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(110,96,0,'LSQ12dle','LSQ',25.1842916666667,-25.2648888888889,NULL,NULL,'2012-07-28 06:52:54',56136.2450799998,17.1401,0.0272,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_46643.gif',34695840990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(111,96,0,'LSQ12dle','LSQ',25.1843333333333,-25.2648611111111,NULL,NULL,'2012-07-28 08:52:39',56136.3282300001,17.2298,0.0194,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_46644.gif',34695840990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(112,96,0,'LSQ12dle','LSQ',25.184375,-25.2649166666667,NULL,NULL,'2012-07-30 07:10:31',56138.2573099998,17.189,0.0317,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_48381.gif',34695840990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(113,96,0,'LSQ12dle','LSQ',25.1842916666667,-25.2648611111111,NULL,NULL,'2012-07-30 09:12:02',56138.3417000002,17.1939,0.0248,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_history.html','sne-nice',NULL,0.051005,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dle/LSQ12dle_snap_48382.gif',34695840990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(114,114,1,'LSQ12dlz','LSQ',310.10525,-25.5417222222222,NULL,NULL,'2012-07-11 05:37:30',56119.1927100001,20.4608,0.1179,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlz/LSQ12dlz_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlz/LSQ12dlz_snap_43498.gif',51319425935,NULL,NULL,NULL,'2012-07-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,801866030,12529156,NULL,NULL,NULL,NULL),(115,114,0,'LSQ12dlz','LSQ',310.105208333333,-25.5417777777778,NULL,NULL,'2012-07-11 05:44:53',56119.19784,20.6471,0.1092,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlz/LSQ12dlz_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlz/LSQ12dlz_snap_43499.gif',51319425935,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,801866030,12529156,NULL,NULL,NULL,NULL),(116,114,0,'LSQ12dlz','LSQ',310.105166666667,-25.5418055555556,NULL,NULL,'2012-07-11 07:54:51',56119.2881,20.7159,0.1756,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlz/LSQ12dlz_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlz/LSQ12dlz_snap_43500.gif',51319425934,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,801866030,12529156,NULL,NULL,NULL,NULL),(117,114,0,'LSQ12dlz','LSQ',310.105375,-25.5417222222222,NULL,NULL,'2012-07-11 09:52:47',56119.36999,20.4384,0.1291,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlz/LSQ12dlz_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlz/LSQ12dlz_snap_43501.gif',51319425935,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,801866030,12529156,NULL,NULL,NULL,NULL),(118,114,0,'LSQ12dlz','LSQ',310.105291666667,-25.5418333333333,NULL,NULL,'2012-07-12 06:02:49',56120.2102999999,20.8037,0.126,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlz/LSQ12dlz_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlz/LSQ12dlz_snap_43502.gif',51319425935,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,801866030,12529156,NULL,NULL,NULL,NULL),(119,114,0,'LSQ12dlz','LSQ',310.105333333333,-25.5417222222222,NULL,NULL,'2012-07-12 08:41:47',56120.32069,20.4916,0.1022,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlz/LSQ12dlz_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlz/LSQ12dlz_snap_43503.gif',51319425935,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,801866030,12529156,NULL,NULL,NULL,NULL),(120,114,0,'LSQ12dlz','LSQ',310.105166666667,-25.54175,NULL,NULL,'2012-07-13 03:52:24',56121.1197299999,20.4092,0.1079,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlz/LSQ12dlz_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlz/LSQ12dlz_snap_43445.gif',51319425934,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,801866030,12529156,NULL,NULL,NULL,NULL),(121,114,0,'LSQ12dlz','LSQ',310.105291666667,-25.54175,NULL,NULL,'2012-07-13 07:23:56',56121.26663,20.3789,0.141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlz/LSQ12dlz_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlz/LSQ12dlz_snap_43446.gif',51319425935,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,801866030,12529156,NULL,NULL,NULL,NULL),(122,122,1,'LSQ12dlx','LSQ',302.489708333333,-23.8511944444444,NULL,NULL,'2012-07-11 02:39:45',56119.0692799999,18.1862,0.0225,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_43480.gif',50808405417,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(123,122,0,'LSQ12dlx','LSQ',302.489708333333,-23.8512777777778,NULL,NULL,'2012-07-11 02:47:09',56119.0744099999,18.2964,0.0258,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_43481.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(124,122,0,'LSQ12dlx','LSQ',302.489666666667,-23.85125,NULL,NULL,'2012-07-11 04:41:56',56119.1541300002,18.2742,0.0214,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_43482.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(125,122,0,'LSQ12dlx','LSQ',302.489625,-23.8512777777778,NULL,NULL,'2012-07-11 04:49:19',56119.15925,18.4023,0.0239,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_43483.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(126,122,0,'LSQ12dlx','LSQ',302.489708333333,-23.85125,NULL,NULL,'2012-07-11 08:16:58',56119.3034600001,18.1838,0.0426,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_43484.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(127,122,0,'LSQ12dlx','LSQ',302.48975,-23.8512222222222,NULL,NULL,'2012-07-11 08:24:21',56119.30858,18.1291,0.0338,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_43485.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(128,122,0,'LSQ12dlx','LSQ',302.489708333333,-23.8512777777778,NULL,NULL,'2012-07-12 04:56:21',56120.16414,18.1414,0.02,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_43486.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(129,122,0,'LSQ12dlx','LSQ',302.489625,-23.85125,NULL,NULL,'2012-07-12 05:03:44',56120.1692599999,18.4487,0.0207,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_43487.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(130,122,0,'LSQ12dlx','LSQ',302.489625,-23.85125,NULL,NULL,'2012-07-12 07:42:46',56120.2796999998,18.5012,0.025,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_43488.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(131,122,0,'LSQ12dlx','LSQ',302.489791666667,-23.85125,NULL,NULL,'2012-07-12 07:50:09',56120.2848299998,18.3878,0.0274,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_43489.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(132,122,0,'LSQ12dlx','LSQ',302.489833333333,-23.8510555555556,NULL,NULL,'2012-07-12 10:26:02',56120.3930899999,18.1031,0.0314,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_43490.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(133,122,0,'LSQ12dlx','LSQ',302.489916666667,-23.8511944444444,NULL,NULL,'2012-07-12 10:35:20',56120.3995400001,18.1501,0.0339,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_43491.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(134,122,0,'LSQ12dlx','LSQ',302.489666666667,-23.8512777777778,NULL,NULL,'2012-07-13 02:17:19',56121.0537,18.3069,0.023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_43441.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(135,122,0,'LSQ12dlx','LSQ',302.489666666667,-23.85125,NULL,NULL,'2012-07-13 04:18:19',56121.1377300001,18.1716,0.0232,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_43442.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(136,122,0,'LSQ12dlx','LSQ',302.489666666667,-23.85125,NULL,NULL,'2012-07-13 06:39:32',56121.2357899998,18.5882,0.0493,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_43492.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(137,122,0,'LSQ12dlx','LSQ',302.48975,-23.8511388888889,NULL,NULL,'2012-07-16 02:04:41',56124.0449299999,18.1407,0.0258,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_43787.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(138,122,0,'LSQ12dlx','LSQ',302.48975,-23.8511388888889,NULL,NULL,'2012-07-16 04:18:46',56124.1380400001,18.232,0.0256,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_43788.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(139,122,0,'LSQ12dlx','LSQ',302.489625,-23.85125,NULL,NULL,'2012-07-18 01:54:45',56126.0380299999,18.5418,0.0279,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_44508.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(140,122,0,'LSQ12dlx','LSQ',302.489583333333,-23.8512777777778,NULL,NULL,'2012-07-18 03:59:13',56126.1244600001,18.9384,0.0414,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_44509.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(141,122,0,'LSQ12dlx','LSQ',302.489666666667,-23.85125,NULL,NULL,'2012-07-18 06:28:22',56126.22804,18.6667,0.0339,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_44510.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(142,122,0,'LSQ12dlx','LSQ',302.489833333333,-23.8511944444444,NULL,NULL,'2012-07-22 01:39:48',56130.0276500001,18.4067,0.0619,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_45176.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(143,122,0,'LSQ12dlx','LSQ',302.489708333333,-23.8512222222222,NULL,NULL,'2012-07-22 06:34:56',56130.2326000002,18.9604,0.0421,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_45177.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(144,122,0,'LSQ12dlx','LSQ',302.489583333333,-23.8513055555556,NULL,NULL,'2012-07-25 01:34:18',56133.0238299998,19.3159,0.0629,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_45889.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(145,122,0,'LSQ12dlx','LSQ',302.48975,-23.8511111111111,NULL,NULL,'2012-07-25 03:36:22',56133.1085899998,18.6311,0.0383,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_45890.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(146,122,0,'LSQ12dlx','LSQ',302.489708333333,-23.8511666666667,NULL,NULL,'2012-07-25 06:30:21',56133.2294200002,19.0034,0.038,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_45891.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(147,122,0,'LSQ12dlx','LSQ',302.489583333333,-23.8512777777778,NULL,NULL,'2012-07-26 01:59:50',56134.0415599998,19.7681,0.0719,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_46145.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(148,122,0,'LSQ12dlx','LSQ',302.48975,-23.8511666666667,NULL,NULL,'2012-07-26 04:02:57',56134.1270499998,18.692,0.0423,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_46146.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(149,122,0,'LSQ12dlx','LSQ',302.48975,-23.8511111111111,NULL,NULL,'2012-07-26 07:54:19',56134.28773,18.7369,0.0447,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_history.html','sne',NULL,0.073811,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dlx/LSQ12dlx_snap_46147.gif',50808405417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793881334,12404395,NULL,NULL,NULL,NULL),(150,150,1,'LSQ12dmi','LSQ',22.948375,-3.6745,NULL,NULL,'2012-07-07 10:10:23',56115.38222,18.2779,0.0769,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_44438.gif',35241776632,NULL,NULL,NULL,'2012-07-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(151,150,0,'LSQ12dmi','LSQ',22.948625,-3.6745,NULL,NULL,'2012-07-07 10:12:05',56115.3834000002,18.5047,0.0854,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_43714.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(152,150,0,'LSQ12dmi','LSQ',22.948625,-3.67447222222222,NULL,NULL,'2012-07-09 10:05:11',56117.3785999999,18.7937,0.0808,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_43715.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(153,150,0,'LSQ12dmi','LSQ',22.9485416666667,-3.67461111111111,NULL,NULL,'2012-07-11 09:25:54',56119.35133,17.8281,0.1499,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_44439.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(154,150,0,'LSQ12dmi','LSQ',22.948625,-3.67452777777778,NULL,NULL,'2012-07-15 11:05:04',56123.42019,18.895,0.069,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_43676.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(155,150,0,'LSQ12dmi','LSQ',22.9485,-3.6745,NULL,NULL,'2012-07-15 11:06:44',56123.42135,18.6626,0.0564,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_44440.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(156,150,0,'LSQ12dmi','LSQ',22.9486666666667,-3.67447222222222,NULL,NULL,'2012-07-15 11:22:04',56123.432,19.1105,0.0779,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_43677.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(157,150,0,'LSQ12dmi','LSQ',22.948625,-3.6745,NULL,NULL,'2012-07-17 09:38:34',56125.3601199999,19.2922,0.0899,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_43883.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(158,150,0,'LSQ12dmi','LSQ',22.948625,-3.67444444444444,NULL,NULL,'2012-07-17 09:40:16',56125.3613,19.0003,0.0725,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_44334.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(159,150,0,'LSQ12dmi','LSQ',22.9486666666667,-3.67444444444444,NULL,NULL,'2012-07-17 10:38:56',56125.4020400001,18.983,0.068,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_44335.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(160,150,0,'LSQ12dmi','LSQ',22.948625,-3.67438888888889,NULL,NULL,'2012-07-17 11:26:43',56125.4352299999,19.1348,0.0935,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_43884.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(161,150,0,'LSQ12dmi','LSQ',22.9485833333333,-3.67444444444444,NULL,NULL,'2012-07-21 09:32:57',56129.35622,19.309,0.1666,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_45021.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(162,150,0,'LSQ12dmi','LSQ',22.9484583333333,-3.67447222222222,NULL,NULL,'2012-07-23 08:12:06',56131.30008,19.2493,0.1673,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_45295.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(163,150,0,'LSQ12dmi','LSQ',22.948625,-3.67447222222222,NULL,NULL,'2012-07-23 08:13:48',56131.30125,18.6612,0.1043,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_45293.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(164,150,0,'LSQ12dmi','LSQ',22.948625,-3.67438888888889,NULL,NULL,'2012-07-23 09:55:51',56131.37212,18.8559,0.21,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_45294.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(165,150,0,'LSQ12dmi','LSQ',22.9486666666667,-3.67444444444444,NULL,NULL,'2012-07-25 08:40:22',56133.31971,19.7745,0.1224,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_45839.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(166,150,0,'LSQ12dmi','LSQ',22.948625,-3.67447222222222,NULL,NULL,'2012-07-25 08:42:04',56133.32088,19.401,0.1061,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_45837.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(167,150,0,'LSQ12dmi','LSQ',22.9485833333333,-3.67438888888889,NULL,NULL,'2012-07-25 10:24:40',56133.3921400001,19.7076,0.1112,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_45838.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(168,150,0,'LSQ12dmi','LSQ',22.948625,-3.67452777777778,NULL,NULL,'2012-07-27 07:55:26',56135.2884999998,19.6958,0.1154,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_46305.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(169,150,0,'LSQ12dmi','LSQ',22.948625,-3.67447222222222,NULL,NULL,'2012-07-27 09:44:46',56135.3644300001,19.9832,0.1404,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_46306.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(170,150,0,'LSQ12dmi','LSQ',22.9485833333333,-3.67444444444444,NULL,NULL,'2012-07-27 11:15:56',56135.4277400002,19.8744,0.1375,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_46307.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(171,150,0,'LSQ12dmi','LSQ',22.9485,-3.67444444444444,NULL,NULL,'2012-07-29 07:51:52',56137.2860300001,19.827,0.1681,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_47291.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(172,150,0,'LSQ12dmi','LSQ',22.9484583333333,-3.67466666666667,NULL,NULL,'2012-07-29 11:14:30',56137.42674,18.9333,0.0728,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_47292.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(173,173,1,'LSQ12dnk','LSQ',10.4951666666667,-25.1883055555556,NULL,NULL,'2012-07-01 07:32:03',56109.27226,19.4504,0.0842,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_history.html','outburst?',NULL,0.112638,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_snap_44192.gif',34798720798,NULL,NULL,NULL,'2012-06-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,543730012,8495781,NULL,NULL,NULL,NULL),(174,173,0,'LSQ12dnk','LSQ',10.4952083333333,-25.1883888888889,NULL,NULL,'2012-07-01 09:32:07',56109.3556400002,18.709,0.0486,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_history.html','outburst?',NULL,0.112638,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_snap_44193.gif',34798720785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,543730012,8495781,NULL,NULL,NULL,NULL),(175,173,0,'LSQ12dnk','LSQ',10.4952916666667,-25.18825,NULL,NULL,'2012-07-03 09:18:25',56111.34613,16.7867,0.0206,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_history.html','outburst?',NULL,0.112638,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_snap_44194.gif',34798720785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,543730012,8495781,NULL,NULL,NULL,NULL),(176,173,0,'LSQ12dnk','LSQ',10.495375,-25.1882777777778,NULL,NULL,'2012-07-04 11:35:59',56112.44166,18.0758,0.0492,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_history.html','outburst?',NULL,0.112638,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_snap_44195.gif',34798720785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,543730012,8495781,NULL,NULL,NULL,NULL),(177,173,0,'LSQ12dnk','LSQ',10.495375,-25.1885555555556,NULL,NULL,'2012-07-06 09:05:28',56114.3371299999,18.1346,0.0385,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_history.html','outburst?',NULL,0.112638,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_snap_44196.gif',34798720787,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,543730012,8495781,NULL,NULL,NULL,NULL),(178,173,0,'LSQ12dnk','LSQ',10.49525,-25.1882222222222,NULL,NULL,'2012-07-10 09:22:11',56118.3487499999,18.3158,0.0486,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_history.html','outburst?',NULL,0.112638,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_snap_44197.gif',34798720798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,543730012,8495781,NULL,NULL,NULL,NULL),(179,173,0,'LSQ12dnk','LSQ',10.4952916666667,-25.1883888888889,NULL,NULL,'2012-07-10 11:06:12',56118.4209799999,18.519,0.0414,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_history.html','outburst?',NULL,0.112638,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_snap_44198.gif',34798720785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,543730012,8495781,NULL,NULL,NULL,NULL),(180,173,0,'LSQ12dnk','LSQ',10.49525,-25.1883333333333,NULL,NULL,'2012-07-16 10:40:26',56124.4030900002,18.8746,0.0404,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_history.html','outburst?',NULL,0.112638,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_snap_44102.gif',34798720785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,543730012,8495781,NULL,NULL,NULL,NULL),(181,173,0,'LSQ12dnk','LSQ',10.4953333333333,-25.1885277777778,NULL,NULL,'2012-07-16 11:36:36',56124.44209,18.5264,0.0447,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_history.html','outburst?',NULL,0.112638,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_snap_44103.gif',34798720787,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,543730012,8495781,NULL,NULL,NULL,NULL),(182,173,0,'LSQ12dnk','LSQ',10.4953333333333,-25.1883333333333,NULL,NULL,'2012-07-18 10:46:09',56126.4070600001,19.5664,0.0622,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_history.html','outburst?',NULL,0.112638,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_snap_44472.gif',34798720785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,543730012,8495781,NULL,NULL,NULL,NULL),(183,173,0,'LSQ12dnk','LSQ',10.495375,-25.1881666666667,NULL,NULL,'2012-07-20 10:31:09',56128.3966399999,20.5188,0.1842,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_history.html','outburst?',NULL,0.112638,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_snap_44880.gif',34798720785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,543730012,8495781,NULL,NULL,NULL,NULL),(184,173,0,'LSQ12dnk','LSQ',10.4953333333333,-25.1883888888889,NULL,NULL,'2012-07-22 08:21:50',56130.3068400002,20.0082,0.1216,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_history.html','outburst?',NULL,0.112638,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_snap_45144.gif',34798720785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,543730012,8495781,NULL,NULL,NULL,NULL),(185,173,0,'LSQ12dnk','LSQ',10.49525,-25.1881111111111,NULL,NULL,'2012-07-24 10:38:46',56132.4019300002,18.101,0.0243,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_history.html','outburst?',NULL,0.112638,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_snap_45566.gif',34798720798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,543730012,8495781,NULL,NULL,NULL,NULL),(186,173,0,'LSQ12dnk','LSQ',10.49525,-25.1884444444444,NULL,NULL,'2012-07-24 11:35:00',56132.44098,18.3537,0.0416,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_history.html','outburst?',NULL,0.112638,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_snap_45567.gif',34798720787,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,543730012,8495781,NULL,NULL,NULL,NULL),(187,173,0,'LSQ12dnk','LSQ',10.4953333333333,-25.1884444444444,NULL,NULL,'2012-07-26 10:42:14',56134.4043399999,19.7322,0.0697,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_history.html','outburst?',NULL,0.112638,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_snap_46096.gif',34798720787,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,543730012,8495781,NULL,NULL,NULL,NULL),(188,173,0,'LSQ12dnk','LSQ',10.495375,-25.1883888888889,NULL,NULL,'2012-07-28 05:38:34',56136.1934600002,20.4626,0.1641,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_history.html','outburst?',NULL,0.112638,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dnk/LSQ12dnk_snap_46659.gif',34798720785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,543730012,8495781,NULL,NULL,NULL,NULL),(189,189,1,'LSQ12dpx','LSQ',348.56125,-6.96694444444444,NULL,NULL,'2012-07-05 06:16:54',56113.2200799999,17.818,0.0659,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_snap_44411.gif',49602146390,NULL,NULL,NULL,'2012-06-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,775033537,12109899,NULL,NULL,NULL,NULL),(190,189,0,'LSQ12dpx','LSQ',348.561208333333,-6.96666666666667,NULL,NULL,'2012-07-05 08:15:59',56113.30277,17.9752,0.0497,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_snap_44412.gif',49602146390,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,775033537,12109899,NULL,NULL,NULL,NULL),(191,189,0,'LSQ12dpx','LSQ',348.561208333333,-6.96658333333333,NULL,NULL,'2012-07-07 08:06:27',56115.2961499998,17.5734,0.0468,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_snap_44413.gif',49602146390,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,775033537,12109899,NULL,NULL,NULL,NULL),(192,189,0,'LSQ12dpx','LSQ',348.561333333333,-6.9665,NULL,NULL,'2012-07-17 10:20:20',56125.38913,17.4705,0.0303,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_snap_44364.gif',49602146390,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,775033537,12109899,NULL,NULL,NULL,NULL),(193,189,0,'LSQ12dpx','LSQ',348.561208333333,-6.96641666666667,NULL,NULL,'2012-07-17 11:05:21',56125.4203900001,17.6247,0.0298,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_snap_44365.gif',49602146390,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,775033537,12109899,NULL,NULL,NULL,NULL),(194,189,0,'LSQ12dpx','LSQ',348.561333333333,-6.96663888888889,NULL,NULL,'2012-07-23 05:08:30',56131.17258,17.9871,0.0602,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_snap_45356.gif',49602146390,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,775033537,12109899,NULL,NULL,NULL,NULL),(195,189,0,'LSQ12dpx','LSQ',348.561208333333,-6.96672222222222,NULL,NULL,'2012-07-25 11:10:56',56133.4242699998,17.801,0.0304,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_snap_45912.gif',49602146390,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,775033537,12109899,NULL,NULL,NULL,NULL),(196,189,0,'LSQ12dpx','LSQ',348.561208333333,-6.96644444444444,NULL,NULL,'2012-07-25 11:26:12',56133.43487,17.3443,0.0271,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_snap_45913.gif',49602146390,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,775033537,12109899,NULL,NULL,NULL,NULL),(197,189,0,'LSQ12dpx','LSQ',348.561166666667,-6.96675,NULL,NULL,'2012-07-31 10:47:47',56139.4081899999,18.4087,0.0553,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_snap_48819.gif',49602146390,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,775033537,12109899,NULL,NULL,NULL,NULL),(198,198,1,'LSQ12dpw','LSQ',345.619791666667,-7.10825,NULL,NULL,'2012-07-05 07:58:29',56113.2906200001,19.315,0.1975,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpw/LSQ12dpw_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpw/LSQ12dpw_snap_44403.gif',49487021214,NULL,NULL,NULL,'2012-06-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773234706,12081792,NULL,NULL,NULL,NULL),(199,198,0,'LSQ12dpw','LSQ',345.620083333333,-7.10830555555555,NULL,NULL,'2012-07-17 10:16:57',56125.3867799998,19.7948,0.1619,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpw/LSQ12dpw_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpw/LSQ12dpw_snap_44362.gif',49487021214,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773234706,12081792,NULL,NULL,NULL,NULL),(200,198,0,'LSQ12dpw','LSQ',345.620208333333,-7.10833333333333,NULL,NULL,'2012-07-17 11:07:02',56125.4215600002,19.4497,0.129,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpw/LSQ12dpw_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpw/LSQ12dpw_snap_44363.gif',49487021214,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773234706,12081792,NULL,NULL,NULL,NULL),(201,198,0,'LSQ12dpw','LSQ',345.620208333333,-7.10822222222222,NULL,NULL,'2012-07-25 11:07:34',56133.4219300002,20.2847,0.1816,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpw/LSQ12dpw_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpw/LSQ12dpw_snap_45918.gif',49487021214,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773234706,12081792,NULL,NULL,NULL,NULL),(202,202,1,'LSQ12dpv','LSQ',337.130583333333,-6.07302777777778,NULL,NULL,'2012-07-09 05:11:53',56117.1749300002,20.0394,0.1492,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpv/LSQ12dpv_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpv/LSQ12dpv_snap_44402.gif',50390558413,NULL,NULL,NULL,'2012-07-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,787352475,12302382,NULL,NULL,NULL,NULL),(203,202,0,'LSQ12dpv','LSQ',337.130625,-6.073,NULL,NULL,'2012-07-17 10:11:53',56125.38326,19.9201,0.1064,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpv/LSQ12dpv_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpv/LSQ12dpv_snap_44360.gif',50390558413,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,787352475,12302382,NULL,NULL,NULL,NULL),(204,202,0,'LSQ12dpv','LSQ',337.130583333333,-6.073,NULL,NULL,'2012-07-17 10:55:14',56125.4133600001,19.7412,0.0847,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpv/LSQ12dpv_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpv/LSQ12dpv_snap_44361.gif',50390558413,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,787352475,12302382,NULL,NULL,NULL,NULL),(205,202,0,'LSQ12dpv','LSQ',337.130625,-6.07291666666667,NULL,NULL,'2012-07-25 11:02:29',56133.4183999998,20.7785,0.1885,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpv/LSQ12dpv_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpv/LSQ12dpv_snap_45916.gif',50390558413,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,787352475,12302382,NULL,NULL,NULL,NULL),(206,202,0,'LSQ12dpv','LSQ',337.1305,-6.07291666666667,NULL,NULL,'2012-07-25 11:19:28',56133.4301900002,19.6917,0.0873,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpv/LSQ12dpv_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpv/LSQ12dpv_snap_45917.gif',50390558413,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,787352475,12302382,NULL,NULL,NULL,NULL),(207,202,0,'LSQ12dpv','LSQ',337.130541666667,-6.07280555555556,NULL,NULL,'2012-07-31 09:20:11',56139.3473499999,20.0047,0.2095,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpv/LSQ12dpv_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpv/LSQ12dpv_snap_48822.gif',50390558413,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,787352475,12302382,NULL,NULL,NULL,NULL),(208,208,1,'LSQ12dpq','LSQ',329.243,-7.13511111111111,NULL,NULL,'2012-07-05 04:53:40',56113.1622799998,17.3555,0.098,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_history.html','sne or agn',NULL,0.12054,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_snap_44386.gif',49923915501,NULL,NULL,NULL,'2012-06-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,780061179,12188455,NULL,NULL,NULL,NULL),(209,208,0,'LSQ12dpq','LSQ',329.242833333333,-7.13516666666667,NULL,NULL,'2012-07-05 06:55:35',56113.24694,19.2309,0.2007,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_history.html','sne or agn',NULL,0.12054,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_snap_44387.gif',49923915503,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,780061179,12188455,NULL,NULL,NULL,NULL),(210,208,0,'LSQ12dpq','LSQ',329.242708333333,-7.13538888888889,NULL,NULL,'2012-07-11 11:29:03',56119.4368500002,18.7863,0.122,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_history.html','sne or agn',NULL,0.12054,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_snap_44388.gif',49923915503,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,780061179,12188455,NULL,NULL,NULL,NULL),(211,208,0,'LSQ12dpq','LSQ',329.242416666667,-7.13552777777778,NULL,NULL,'2012-07-16 10:15:18',56124.3856299999,21.239,0.1356,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_history.html','sne or agn',NULL,0.12054,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_snap_44389.gif',49923915503,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,780061179,12188455,NULL,NULL,NULL,NULL),(212,208,0,'LSQ12dpq','LSQ',329.242875,-7.13516666666667,NULL,NULL,'2012-07-17 10:03:25',56125.37738,19.2508,0.1261,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_history.html','sne or agn',NULL,0.12054,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_snap_44350.gif',49923915503,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,780061179,12188455,NULL,NULL,NULL,NULL),(213,208,0,'LSQ12dpq','LSQ',329.243041666667,-7.13513888888889,NULL,NULL,'2012-07-17 10:51:51',56125.4110099999,18.4782,0.0415,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_history.html','sne or agn',NULL,0.12054,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_snap_44351.gif',49923915503,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,780061179,12188455,NULL,NULL,NULL,NULL),(214,208,0,'LSQ12dpq','LSQ',329.242791666667,-7.13511111111111,NULL,NULL,'2012-07-23 06:20:29',56131.2225600001,17.4667,0.0885,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_history.html','sne or agn',NULL,0.12054,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_snap_45332.gif',49923915501,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,780061179,12188455,NULL,NULL,NULL,NULL),(215,208,0,'LSQ12dpq','LSQ',329.242833333333,-7.135,NULL,NULL,'2012-07-27 06:03:03',56135.2104600002,18.9261,0.0974,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_history.html','sne or agn',NULL,0.12054,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_snap_46371.gif',49923915501,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,780061179,12188455,NULL,NULL,NULL,NULL),(216,216,1,'LSQ12dpp','LSQ',317.584625,-7.24022222222222,NULL,NULL,'2012-07-11 07:28:49',56119.2700200002,20.7192,0.1533,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_snap_44383.gif',50792332356,NULL,NULL,NULL,'2012-07-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793630193,12400471,NULL,NULL,NULL,NULL),(217,216,0,'LSQ12dpp','LSQ',317.5845,-7.24016666666667,NULL,NULL,'2012-07-12 10:33:32',56120.3982899999,20.6474,0.1599,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_snap_44384.gif',50792332356,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793630193,12400471,NULL,NULL,NULL,NULL),(218,216,0,'LSQ12dpp','LSQ',317.584583333333,-7.24022222222222,NULL,NULL,'2012-07-16 09:44:05',56124.3639500001,20.6407,0.1308,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_snap_44385.gif',50792332356,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793630193,12400471,NULL,NULL,NULL,NULL),(219,216,0,'LSQ12dpp','LSQ',317.584541666667,-7.24013888888889,NULL,NULL,'2012-07-17 07:47:36',56125.2830599998,20.6678,0.1272,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_snap_44348.gif',50792332356,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793630193,12400471,NULL,NULL,NULL,NULL),(220,216,0,'LSQ12dpp','LSQ',317.584541666667,-7.24008333333333,NULL,NULL,'2012-07-17 09:26:00',56125.3514,20.3069,0.1112,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_snap_44349.gif',50792332356,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793630193,12400471,NULL,NULL,NULL,NULL),(221,216,0,'LSQ12dpp','LSQ',317.584375,-7.24030555555556,NULL,NULL,'2012-07-18 06:35:51',56126.23324,21.0328,0.1833,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_snap_44506.gif',50792332356,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793630193,12400471,NULL,NULL,NULL,NULL),(222,216,0,'LSQ12dpp','LSQ',317.584541666667,-7.24008333333333,NULL,NULL,'2012-07-19 05:13:55',56127.1763399998,20.9929,0.1767,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_snap_44757.gif',50792332356,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793630193,12400471,NULL,NULL,NULL,NULL),(223,216,0,'LSQ12dpp','LSQ',317.584541666667,-7.24002777777778,NULL,NULL,'2012-07-24 02:56:41',56132.0810400001,20.7714,0.1473,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_snap_45595.gif',50792332356,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793630193,12400471,NULL,NULL,NULL,NULL),(224,216,0,'LSQ12dpp','LSQ',317.5845,-7.24019444444444,NULL,NULL,'2012-07-24 08:51:56',56132.3277400001,20.7264,0.162,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_snap_45596.gif',50792332356,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793630193,12400471,NULL,NULL,NULL,NULL),(225,216,0,'LSQ12dpp','LSQ',317.5845,-7.24030555555556,NULL,NULL,'2012-07-24 08:57:19',56132.3314800002,21.1058,0.1272,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_snap_45597.gif',50792332356,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793630193,12400471,NULL,NULL,NULL,NULL),(226,216,0,'LSQ12dpp','LSQ',317.584625,-7.24008333333333,NULL,NULL,'2012-07-25 06:41:30',56133.23716,20.9601,0.1574,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_snap_45872.gif',50792332356,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793630193,12400471,NULL,NULL,NULL,NULL),(227,216,0,'LSQ12dpp','LSQ',317.584458333333,-7.24019444444444,NULL,NULL,'2012-07-31 08:35:43',56139.31647,19.9383,0.1713,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpp/LSQ12dpp_snap_48802.gif',50792332356,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793630193,12400471,NULL,NULL,NULL,NULL),(228,228,1,'LSQ12dpn','LSQ',47.8050833333333,-5.48566666666667,NULL,NULL,'2012-07-17 09:58:54',56125.3742399998,19.1269,0.1218,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_snap_44344.gif',37858580920,NULL,NULL,NULL,'2012-07-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591540326,9242817,NULL,NULL,NULL,NULL),(229,228,0,'LSQ12dpn','LSQ',47.8050833333333,-5.48569444444444,NULL,NULL,'2012-07-17 11:16:35',56125.4281899999,19.367,0.1264,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_snap_44345.gif',37858580920,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591540326,9242817,NULL,NULL,NULL,NULL),(230,228,0,'LSQ12dpn','LSQ',47.80525,-5.48561111111111,NULL,NULL,'2012-07-21 11:19:52',56129.43047,18.8779,0.1976,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_snap_45029.gif',37858580920,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591540326,9242817,NULL,NULL,NULL,NULL),(231,228,0,'LSQ12dpn','LSQ',47.80525,-5.48566666666667,NULL,NULL,'2012-07-23 10:57:48',56131.4151499998,18.9324,0.1918,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_snap_45345.gif',37858580920,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591540326,9242817,NULL,NULL,NULL,NULL),(232,228,0,'LSQ12dpn','LSQ',47.8050833333333,-5.48569444444444,NULL,NULL,'2012-07-25 10:52:55',56133.41175,18.5104,0.0726,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_snap_45868.gif',37858580920,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591540326,9242817,NULL,NULL,NULL,NULL),(233,228,0,'LSQ12dpn','LSQ',47.805125,-5.48569444444444,NULL,NULL,'2012-07-25 11:35:43',56133.44148,18.5765,0.135,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_snap_45869.gif',37858580920,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591540326,9242817,NULL,NULL,NULL,NULL),(234,228,0,'LSQ12dpn','LSQ',47.80525,-5.48572222222222,NULL,NULL,'2012-07-27 08:49:37',56135.3261299999,18.573,0.0883,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_snap_46372.gif',37858580920,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591540326,9242817,NULL,NULL,NULL,NULL),(235,228,0,'LSQ12dpn','LSQ',47.805125,-5.48572222222222,NULL,NULL,'2012-07-27 10:53:42',56135.4123,18.7979,0.0648,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_snap_46373.gif',37858580920,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591540326,9242817,NULL,NULL,NULL,NULL),(236,228,0,'LSQ12dpn','LSQ',47.8052083333333,-5.48572222222222,NULL,NULL,'2012-07-29 08:40:39',56137.3199,18.6224,0.0974,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_snap_47382.gif',37858580920,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591540326,9242817,NULL,NULL,NULL,NULL),(237,228,0,'LSQ12dpn','LSQ',47.8051666666667,-5.48572222222222,NULL,NULL,'2012-07-29 10:54:36',56137.41292,18.8624,0.0646,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_snap_47383.gif',37858580920,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591540326,9242817,NULL,NULL,NULL,NULL),(238,228,0,'LSQ12dpn','LSQ',47.8050416666667,-5.48577777777778,NULL,NULL,'2012-07-31 08:38:45',56139.3185800002,18.8245,0.1377,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_snap_48794.gif',37858580920,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591540326,9242817,NULL,NULL,NULL,NULL),(239,228,0,'LSQ12dpn','LSQ',47.8047083333333,-5.48544444444444,NULL,NULL,'2012-08-04 10:13:01',56143.38405,18.8081,0.1968,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_snap_49566.gif',37858580920,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591540326,9242817,NULL,NULL,NULL,NULL),(240,240,1,'LSQ12dpl','LSQ',40.6969583333333,-4.93511111111111,NULL,NULL,'2012-07-09 10:36:33',56117.4003900001,20.086,0.1464,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpl/LSQ12dpl_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpl/LSQ12dpl_snap_44380.gif',34905732548,NULL,NULL,NULL,'2012-07-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545402071,8521907,NULL,NULL,NULL,NULL),(241,240,0,'LSQ12dpl','LSQ',40.69675,-4.93547222222222,NULL,NULL,'2012-07-17 09:52:07',56125.3695299998,20.4515,0.1334,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpl/LSQ12dpl_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpl/LSQ12dpl_snap_44340.gif',34905732548,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545402071,8521907,NULL,NULL,NULL,NULL),(242,240,0,'LSQ12dpl','LSQ',40.696875,-4.93530555555556,NULL,NULL,'2012-07-17 11:19:57',56125.43053,20.4567,0.1318,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpl/LSQ12dpl_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpl/LSQ12dpl_snap_44341.gif',34905732548,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545402071,8521907,NULL,NULL,NULL,NULL),(243,240,0,'LSQ12dpl','LSQ',40.69675,-4.93544444444444,NULL,NULL,'2012-07-27 08:18:13',56135.3043200001,20.4527,0.1364,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpl/LSQ12dpl_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpl/LSQ12dpl_snap_46358.gif',34905732548,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545402071,8521907,NULL,NULL,NULL,NULL),(244,240,0,'LSQ12dpl','LSQ',40.6969583333333,-4.93525,NULL,NULL,'2012-07-27 11:10:12',56135.4237600002,20.5855,0.1337,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpl/LSQ12dpl_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpl/LSQ12dpl_snap_46359.gif',34905732548,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545402071,8521907,NULL,NULL,NULL,NULL),(245,245,1,'LSQ12dpk','LSQ',35.6905833333333,-2.87938888888889,NULL,NULL,'2012-07-17 09:48:44',56125.3671800001,20.2081,0.157,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpk/LSQ12dpk_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpk/LSQ12dpk_snap_44338.gif',34928386426,NULL,NULL,NULL,'2012-07-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545756037,8527438,NULL,NULL,NULL,NULL),(246,245,0,'LSQ12dpk','LSQ',35.6907083333333,-2.87930555555556,NULL,NULL,'2012-07-17 11:21:38',56125.4317000001,20.3766,0.1659,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpk/LSQ12dpk_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpk/LSQ12dpk_snap_44339.gif',34928386426,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545756037,8527438,NULL,NULL,NULL,NULL),(247,245,0,'LSQ12dpk','LSQ',35.6905416666667,-2.87944444444444,NULL,NULL,'2012-07-27 09:51:31',56135.3691199999,20.1637,0.1363,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpk/LSQ12dpk_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpk/LSQ12dpk_snap_46379.gif',34928386426,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545756037,8527438,NULL,NULL,NULL,NULL),(248,245,0,'LSQ12dpk','LSQ',35.69075,-2.8795,NULL,NULL,'2012-07-29 08:08:47',56137.2977700001,20.0237,0.2156,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpk/LSQ12dpk_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpk/LSQ12dpk_snap_47402.gif',34928386426,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545756037,8527438,NULL,NULL,NULL,NULL),(249,245,0,'LSQ12dpk','LSQ',35.6905416666667,-2.87936111111111,NULL,NULL,'2012-07-29 11:12:49',56137.42557,20.3446,0.1502,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpk/LSQ12dpk_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpk/LSQ12dpk_snap_47403.gif',34928386426,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545756037,8527438,NULL,NULL,NULL,NULL),(250,250,1,'LSQ12dpi','LSQ',18.804625,-3.19494444444444,NULL,NULL,'2012-07-07 10:15:27',56115.3857399998,19.094,0.1575,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_snap_44407.gif',34503822819,NULL,NULL,NULL,'2012-07-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539122231,8423784,NULL,NULL,NULL,NULL),(251,250,0,'LSQ12dpi','LSQ',18.804625,-3.19497222222222,NULL,NULL,'2012-07-09 08:06:48',56117.2963999999,19.4463,0.1839,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_snap_44408.gif',34503822819,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539122231,8423784,NULL,NULL,NULL,NULL),(252,250,0,'LSQ12dpi','LSQ',18.8044583333333,-3.19480555555556,NULL,NULL,'2012-07-09 10:31:25',56117.3968199999,18.8455,0.0979,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_snap_44409.gif',34503822819,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539122231,8423784,NULL,NULL,NULL,NULL),(253,250,0,'LSQ12dpi','LSQ',18.8045416666667,-3.19486111111111,NULL,NULL,'2012-07-11 10:27:57',56119.3944100002,18.7576,0.0847,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_snap_44410.gif',34503822819,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539122231,8423784,NULL,NULL,NULL,NULL),(254,250,0,'LSQ12dpi','LSQ',18.804625,-3.19486111111111,NULL,NULL,'2012-07-17 09:35:11',56125.3577700001,19.7269,0.1266,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_snap_44332.gif',34503822819,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539122231,8423784,NULL,NULL,NULL,NULL),(255,250,0,'LSQ12dpi','LSQ',18.8042916666667,-3.19491666666667,NULL,NULL,'2012-07-17 11:28:25',56125.4364100001,19.1614,0.1308,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_snap_44333.gif',34503822819,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539122231,8423784,NULL,NULL,NULL,NULL),(256,250,0,'LSQ12dpi','LSQ',18.8047916666667,-3.19480555555556,NULL,NULL,'2012-07-19 11:18:52',56127.4297799999,19.9354,0.1544,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_snap_44756.gif',34503822819,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539122231,8423784,NULL,NULL,NULL,NULL),(257,250,0,'LSQ12dpi','LSQ',18.8045833333333,-3.19486111111111,NULL,NULL,'2012-07-21 09:27:53',56129.3527000002,18.1869,0.0639,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_snap_45031.gif',34503822819,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539122231,8423784,NULL,NULL,NULL,NULL),(258,250,0,'LSQ12dpi','LSQ',18.80475,-3.195,NULL,NULL,'2012-07-25 10:29:44',56133.3956499998,19.7893,0.1302,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_snap_45876.gif',34503822819,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539122231,8423784,NULL,NULL,NULL,NULL),(259,250,0,'LSQ12dpi','LSQ',18.80475,-3.19497222222222,NULL,NULL,'2012-07-27 07:50:22',56135.28498,19.6003,0.1201,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_snap_46369.gif',34503822819,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539122231,8423784,NULL,NULL,NULL,NULL),(260,250,0,'LSQ12dpi','LSQ',18.8046666666667,-3.19491666666667,NULL,NULL,'2012-07-29 09:41:08',56137.3618999999,19.649,0.1255,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_snap_47379.gif',34503822819,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539122231,8423784,NULL,NULL,NULL,NULL),(261,261,1,'LSQ12dqy','LSQ',215.646916666667,-24.4561944444444,NULL,NULL,'2012-07-08 00:35:13',56115.9827899998,20.316,0.1267,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqy/LSQ12dqy_history.html','possible sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqy/LSQ12dqy_snap_44673.gif',46565389206,NULL,NULL,NULL,'2012-07-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,727584206,11368503,NULL,NULL,NULL,NULL),(262,261,0,'LSQ12dqy','LSQ',215.647166666667,-24.45625,NULL,NULL,'2012-07-08 02:36:08',56116.0667599998,20.3079,0.1964,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqy/LSQ12dqy_history.html','possible sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqy/LSQ12dqy_snap_44674.gif',46565389206,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,727584206,11368503,NULL,NULL,NULL,NULL),(263,261,0,'LSQ12dqy','LSQ',215.647,-24.45625,NULL,NULL,'2012-07-10 00:50:54',56117.9936899999,20.1211,0.1173,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqy/LSQ12dqy_history.html','possible sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqy/LSQ12dqy_snap_44675.gif',46565389206,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,727584206,11368503,NULL,NULL,NULL,NULL),(264,261,0,'LSQ12dqy','LSQ',215.646875,-24.4563055555556,NULL,NULL,'2012-07-16 00:28:53',56123.9783999999,20.0568,0.1092,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqy/LSQ12dqy_history.html','possible sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqy/LSQ12dqy_snap_44676.gif',46565389206,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,727584206,11368503,NULL,NULL,NULL,NULL),(265,261,0,'LSQ12dqy','LSQ',215.646916666667,-24.45625,NULL,NULL,'2012-07-18 00:23:33',56125.9746900001,20.0953,0.1174,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqy/LSQ12dqy_history.html','possible sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqy/LSQ12dqy_snap_44650.gif',46565389206,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,727584206,11368503,NULL,NULL,NULL,NULL),(266,261,0,'LSQ12dqy','LSQ',215.646958333333,-24.45625,NULL,NULL,'2012-07-18 02:31:08',56126.06329,20.1626,0.105,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqy/LSQ12dqy_history.html','possible sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqy/LSQ12dqy_snap_44651.gif',46565389206,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,727584206,11368503,NULL,NULL,NULL,NULL),(267,261,0,'LSQ12dqy','LSQ',215.646833333333,-24.4562777777778,NULL,NULL,'2012-07-24 01:16:31',56132.0114699998,20.7291,0.1603,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqy/LSQ12dqy_history.html','possible sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqy/LSQ12dqy_snap_45617.gif',46565389206,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,727584206,11368503,NULL,NULL,NULL,NULL),(268,268,1,'LSQ12dqv','LSQ',213.945583333333,-18.4865277777778,NULL,NULL,'2012-07-08 00:28:24',56115.9780600001,20.1496,0.1545,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqv/LSQ12dqv_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqv/LSQ12dqv_snap_44713.gif',46563340370,NULL,NULL,NULL,'2012-07-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,727552193,11368003,NULL,NULL,NULL,NULL),(269,268,0,'LSQ12dqv','LSQ',213.945708333333,-18.4865,NULL,NULL,'2012-07-10 00:35:08',56117.9827399999,19.7451,0.1626,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqv/LSQ12dqv_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqv/LSQ12dqv_snap_44714.gif',46563340381,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,727552193,11368003,NULL,NULL,NULL,NULL),(270,268,0,'LSQ12dqv','LSQ',213.945625,-18.4864722222222,NULL,NULL,'2012-07-16 00:21:57',56123.97358,18.648,0.0994,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqv/LSQ12dqv_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqv/LSQ12dqv_snap_44715.gif',46563340381,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,727552193,11368003,NULL,NULL,NULL,NULL),(271,268,0,'LSQ12dqv','LSQ',213.945583333333,-18.4864444444444,NULL,NULL,'2012-07-18 00:16:42',56125.9699400002,18.4675,0.0768,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqv/LSQ12dqv_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqv/LSQ12dqv_snap_44644.gif',46563340381,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,727552193,11368003,NULL,NULL,NULL,NULL),(272,268,0,'LSQ12dqv','LSQ',213.945625,-18.4864722222222,NULL,NULL,'2012-07-18 02:18:28',56126.0545000001,18.7975,0.0624,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqv/LSQ12dqv_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqv/LSQ12dqv_snap_44645.gif',46563340381,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,727552193,11368003,NULL,NULL,NULL,NULL),(273,268,0,'LSQ12dqv','LSQ',213.945708333333,-18.4864722222222,NULL,NULL,'2012-07-24 01:26:39',56132.0185099998,18.5352,0.0859,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqv/LSQ12dqv_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqv/LSQ12dqv_snap_45613.gif',46563340381,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,727552193,11368003,NULL,NULL,NULL,NULL),(274,268,0,'LSQ12dqv','LSQ',213.945625,-18.4865,NULL,NULL,'2012-07-28 00:54:16',56135.99602,18.583,0.1211,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqv/LSQ12dqv_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dqv/LSQ12dqv_snap_46690.gif',46563340381,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,727552193,11368003,NULL,NULL,NULL,NULL),(275,275,1,'LSQ12drx','LSQ',22.887125,-22.3731388888889,NULL,NULL,'2012-07-10 09:34:03',56118.3569800002,20.358,0.1772,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_45244.gif',35176085309,NULL,NULL,NULL,'2012-07-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(276,275,0,'LSQ12drx','LSQ',22.8871666666667,-22.3730833333333,NULL,NULL,'2012-07-10 10:54:20',56118.4127400001,20.3446,0.1681,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_45245.gif',35176085309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(277,275,0,'LSQ12drx','LSQ',22.8871666666667,-22.3731111111111,NULL,NULL,'2012-07-16 10:52:17',56124.4113099999,20.4711,0.1447,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_45246.gif',35176085309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(278,275,0,'LSQ12drx','LSQ',22.887125,-22.3731111111111,NULL,NULL,'2012-07-16 11:16:20',56124.4280099999,20.7813,0.1735,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_45247.gif',35176085309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(279,275,0,'LSQ12drx','LSQ',22.887125,-22.3731388888889,NULL,NULL,'2012-07-18 10:58:01',56126.4152899999,20.408,0.1524,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_45248.gif',35176085309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(280,275,0,'LSQ12drx','LSQ',22.8872916666667,-22.3731111111111,NULL,NULL,'2012-07-18 11:32:09',56126.4389999998,19.9927,0.1917,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_45249.gif',35176085309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(281,275,0,'LSQ12drx','LSQ',22.8871666666667,-22.3731388888889,NULL,NULL,'2012-07-20 10:48:03',56128.4083699998,19.9296,0.1755,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_45250.gif',35176085309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(282,275,0,'LSQ12drx','LSQ',22.8871666666667,-22.3731111111111,NULL,NULL,'2012-07-20 11:34:02',56128.44031,20.1197,0.1372,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_45251.gif',35176085309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(283,275,0,'LSQ12drx','LSQ',22.8870833333333,-22.3731666666667,NULL,NULL,'2012-07-22 08:33:40',56130.3150499999,19.9378,0.1273,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_45242.gif',35176085309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(284,275,0,'LSQ12drx','LSQ',22.887125,-22.3730833333333,NULL,NULL,'2012-07-22 10:04:50',56130.37836,20.0243,0.1371,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_45243.gif',35176085309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(285,275,0,'LSQ12drx','LSQ',22.887125,-22.3731388888889,NULL,NULL,'2012-07-24 10:50:38',56132.41017,19.5832,0.0842,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_45548.gif',35176085309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(286,275,0,'LSQ12drx','LSQ',22.8870833333333,-22.3731111111111,NULL,NULL,'2012-07-24 11:12:57',56132.4256699998,19.4542,0.08,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_45549.gif',35176085309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(287,275,0,'LSQ12drx','LSQ',22.887125,-22.3730833333333,NULL,NULL,'2012-07-26 09:02:07',56134.3348099999,19.3318,0.0756,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_46086.gif',35176085309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(288,275,0,'LSQ12drx','LSQ',22.8871666666667,-22.3731111111111,NULL,NULL,'2012-07-26 10:26:45',56134.3935799999,19.3796,0.0749,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_46087.gif',35176085309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(289,275,0,'LSQ12drx','LSQ',22.887,-22.3731388888889,NULL,NULL,'2012-07-28 06:35:26',56136.2329500001,19.3754,0.1113,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_46633.gif',35176085309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(290,275,0,'LSQ12drx','LSQ',22.8871666666667,-22.3731666666667,NULL,NULL,'2012-07-28 08:35:11',56136.31611,19.3953,0.0843,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_46634.gif',35176085309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(291,275,0,'LSQ12drx','LSQ',22.8871666666667,-22.3730277777778,NULL,NULL,'2012-07-30 07:07:07',56138.25495,19.6008,0.1946,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_48375.gif',35176085309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(292,275,0,'LSQ12drx','LSQ',22.8871666666667,-22.3731388888889,NULL,NULL,'2012-07-30 09:08:39',56138.33935,19.3977,0.1045,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_history.html','galaxy merger',NULL,0.110143,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drx/LSQ12drx_snap_48376.gif',35176085309,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,549626332,8587911,NULL,NULL,NULL,NULL),(293,293,1,'LSQ12dsr','LSQ',217.725958333333,-5.55697222222222,NULL,NULL,'2012-07-17 00:19:37',56124.9719600002,20.1075,0.1152,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsr/LSQ12dsr_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsr/LSQ12dsr_snap_45758.gif',43551714785,NULL,NULL,NULL,'2012-07-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,680495543,10632742,NULL,NULL,NULL,NULL),(294,293,0,'LSQ12dsr','LSQ',217.726,-5.55691666666667,NULL,NULL,'2012-07-19 00:14:36',56126.9684799998,19.7758,0.1182,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsr/LSQ12dsr_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsr/LSQ12dsr_snap_45759.gif',43551714785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,680495543,10632742,NULL,NULL,NULL,NULL),(295,293,0,'LSQ12dsr','LSQ',217.726083333333,-5.55691666666667,NULL,NULL,'2012-07-23 01:53:51',56131.0373999998,19.4451,0.0724,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsr/LSQ12dsr_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsr/LSQ12dsr_snap_45729.gif',43551714785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,680495543,10632742,NULL,NULL,NULL,NULL),(296,293,0,'LSQ12dsr','LSQ',217.726041666667,-5.55688888888889,NULL,NULL,'2012-07-23 02:00:44',56131.0421799999,19.655,0.0847,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsr/LSQ12dsr_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsr/LSQ12dsr_snap_45730.gif',43551714785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,680495543,10632742,NULL,NULL,NULL,NULL),(297,297,1,'LSQ12dsc','LSQ',244.916291666667,4.21602777777778,NULL,NULL,'2012-07-19 01:31:21',56127.0217800001,20.2766,0.1583,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsc/LSQ12dsc_history.html','possible sne ',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsc/LSQ12dsc_snap_45750.gif',56499892140,NULL,NULL,NULL,'2012-07-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,882810814,13793918,NULL,NULL,NULL,NULL),(298,297,0,'LSQ12dsc','LSQ',244.916416666667,4.21613888888889,NULL,NULL,'2012-07-23 01:14:44',56131.0102400002,19.9232,0.1404,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsc/LSQ12dsc_history.html','possible sne ',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsc/LSQ12dsc_snap_45697.gif',56499892140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,882810814,13793918,NULL,NULL,NULL,NULL),(299,297,0,'LSQ12dsc','LSQ',244.916458333333,4.21597222222222,NULL,NULL,'2012-07-23 01:45:13',56131.0314099998,20.1838,0.1362,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsc/LSQ12dsc_history.html','possible sne ',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsc/LSQ12dsc_snap_45698.gif',56499892140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,882810814,13793918,NULL,NULL,NULL,NULL),(300,297,0,'LSQ12dsc','LSQ',244.916333333333,4.21602777777778,NULL,NULL,'2012-07-27 01:28:59',56135.0201300001,19.8902,0.2053,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsc/LSQ12dsc_history.html','possible sne ',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsc/LSQ12dsc_snap_46382.gif',56499892140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,882810814,13793918,NULL,NULL,NULL,NULL),(301,297,0,'LSQ12dsc','LSQ',244.916458333333,4.21616666666667,NULL,NULL,'2012-07-29 00:50:17',56136.9932599999,19.4438,0.194,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsc/LSQ12dsc_history.html','possible sne ',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsc/LSQ12dsc_snap_47384.gif',56499892140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,882810814,13793918,NULL,NULL,NULL,NULL),(302,302,1,'LSQ12dsb','LSQ',227.564333333333,3.53186111111111,NULL,NULL,'2012-07-13 00:33:06',56120.9813199998,20.5262,0.1508,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsb/LSQ12dsb_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsb/LSQ12dsb_snap_45747.gif',56381043115,NULL,NULL,NULL,'2012-07-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,880953798,13764903,NULL,NULL,NULL,NULL),(303,302,0,'LSQ12dsb','LSQ',227.564333333333,3.53186111111111,NULL,NULL,'2012-07-17 00:28:11',56124.9779099999,19.8049,0.1057,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsb/LSQ12dsb_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsb/LSQ12dsb_snap_45748.gif',56381043115,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,880953798,13764903,NULL,NULL,NULL,NULL),(304,302,0,'LSQ12dsb','LSQ',227.56425,3.53191666666667,NULL,NULL,'2012-07-19 00:23:08',56126.9744000002,19.3974,0.1296,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsb/LSQ12dsb_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsb/LSQ12dsb_snap_45749.gif',56381043115,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,880953798,13764903,NULL,NULL,NULL,NULL),(305,302,0,'LSQ12dsb','LSQ',227.564375,3.53188888888889,NULL,NULL,'2012-07-23 00:10:56',56130.9659299999,19.4943,0.1037,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsb/LSQ12dsb_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsb/LSQ12dsb_snap_45695.gif',56381043115,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,880953798,13764903,NULL,NULL,NULL,NULL),(306,302,0,'LSQ12dsb','LSQ',227.564333333333,3.53186111111111,NULL,NULL,'2012-07-23 01:48:41',56131.0338099999,19.3666,0.0855,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsb/LSQ12dsb_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsb/LSQ12dsb_snap_45696.gif',56381043115,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,880953798,13764903,NULL,NULL,NULL,NULL),(307,307,1,'LSQ12drz','LSQ',252.072625,19.2898333333333,NULL,NULL,'2012-07-23 00:47:21',56130.9912200002,19.0912,0.059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drz/LSQ12drz_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drz/LSQ12drz_snap_45691.gif',56682128644,NULL,NULL,NULL,'2012-07-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,885658260,13838410,NULL,NULL,NULL,NULL),(308,307,0,'LSQ12drz','LSQ',252.072708333333,19.2897777777778,NULL,NULL,'2012-07-23 02:47:21',56131.0745600001,18.67,0.1103,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drz/LSQ12drz_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drz/LSQ12drz_snap_45692.gif',56682128644,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,885658260,13838410,NULL,NULL,NULL,NULL),(309,307,0,'LSQ12drz','LSQ',252.072625,19.2898611111111,NULL,NULL,'2012-07-27 01:58:25',56135.0405700002,19.1014,0.1091,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drz/LSQ12drz_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drz/LSQ12drz_snap_46390.gif',56682130440,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,885658288,13838410,NULL,NULL,NULL,NULL),(310,307,0,'LSQ12drz','LSQ',252.07275,19.2897777777778,NULL,NULL,'2012-07-27 03:16:30',56135.0948000001,19.1691,0.1152,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drz/LSQ12drz_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drz/LSQ12drz_snap_46391.gif',56682128644,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,885658260,13838410,NULL,NULL,NULL,NULL),(311,307,0,'LSQ12drz','LSQ',252.072458333333,19.28975,NULL,NULL,'2012-07-29 02:23:31',56137.0580000002,19.0147,0.1713,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drz/LSQ12drz_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12drz/LSQ12drz_snap_47397.gif',56682128644,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,885658260,13838410,NULL,NULL,NULL,NULL),(312,312,1,'LSQ12dxl','LSQ',254.771,16.6041111111111,NULL,NULL,'2012-07-07 03:59:11',56115.1244399999,20.6517,0.1914,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dxl/LSQ12dxl_history.html','galactic variability',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dxl/LSQ12dxl_snap_47809.gif',56901257269,NULL,NULL,NULL,'2012-07-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,889082144,13891908,NULL,NULL,NULL,NULL),(313,312,0,'LSQ12dxl','LSQ',254.771125,16.6040833333333,NULL,NULL,'2012-07-09 01:30:12',56117.02098,20.1972,0.0952,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dxl/LSQ12dxl_history.html','galactic variability',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dxl/LSQ12dxl_snap_47810.gif',56901257269,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,889082144,13891908,NULL,NULL,NULL,NULL),(314,312,0,'LSQ12dxl','LSQ',254.771083333333,16.604,NULL,NULL,'2012-07-27 00:49:55',56134.9929999998,19.9522,0.1559,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dxl/LSQ12dxl_history.html','galactic variability',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dxl/LSQ12dxl_snap_47726.gif',56901257226,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,889082144,13891908,NULL,NULL,NULL,NULL),(315,312,0,'LSQ12dxl','LSQ',254.771083333333,16.6039166666667,NULL,NULL,'2012-07-27 02:50:36',56135.07681,20.4601,0.1429,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dxl/LSQ12dxl_history.html','galactic variability',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dxl/LSQ12dxl_snap_47727.gif',56901257226,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,889082144,13891908,NULL,NULL,NULL,NULL),(316,316,1,'LSQ12dww','LSQ',229.472291666667,4.87497222222222,NULL,NULL,'2012-07-05 00:48:02',56112.9916900001,19.6549,0.1233,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_history.html','sne-pec',NULL,0.04572,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_snap_47738.gif',56380598798,NULL,NULL,NULL,'2012-06-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,880946856,13764794,NULL,NULL,NULL,NULL),(317,316,0,'LSQ12dww','LSQ',229.472208333333,4.87491666666667,NULL,NULL,'2012-07-05 02:48:44',56113.07552,20.0415,0.2012,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_history.html','sne-pec',NULL,0.04572,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_snap_47739.gif',56380598798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,880946856,13764794,NULL,NULL,NULL,NULL),(318,316,0,'LSQ12dww','LSQ',229.472208333333,4.87491666666667,NULL,NULL,'2012-07-07 01:15:33',56115.0108099999,20.7136,0.184,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_history.html','sne-pec',NULL,0.04572,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_snap_47740.gif',56380598798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,880946856,13764794,NULL,NULL,NULL,NULL),(319,316,0,'LSQ12dww','LSQ',229.472208333333,4.87491666666667,NULL,NULL,'2012-07-07 03:16:23',56115.0947199999,19.8764,0.1241,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_history.html','sne-pec',NULL,0.04572,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_snap_47741.gif',56380598798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,880946856,13764794,NULL,NULL,NULL,NULL),(320,316,0,'LSQ12dww','LSQ',229.472291666667,4.87494444444444,NULL,NULL,'2012-07-09 00:47:11',56116.9911099998,19.9205,0.0979,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_history.html','sne-pec',NULL,0.04572,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_snap_47742.gif',56380598798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,880946856,13764794,NULL,NULL,NULL,NULL),(321,316,0,'LSQ12dww','LSQ',229.47225,4.87497222222222,NULL,NULL,'2012-07-09 02:47:47',56117.0748600001,19.9743,0.1049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_history.html','sne-pec',NULL,0.04572,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_snap_47743.gif',56380598798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,880946856,13764794,NULL,NULL,NULL,NULL),(322,316,0,'LSQ12dww','LSQ',229.472333333333,4.875,NULL,NULL,'2012-07-11 00:44:17',56118.9890899998,20.0801,0.1097,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_history.html','sne-pec',NULL,0.04572,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_snap_47744.gif',56380598798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,880946856,13764794,NULL,NULL,NULL,NULL),(323,316,0,'LSQ12dww','LSQ',229.472208333333,4.87494444444444,NULL,NULL,'2012-07-13 00:45:15',56120.9897599998,20.0111,0.1108,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_history.html','sne-pec',NULL,0.04572,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_snap_47745.gif',56380598798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,880946856,13764794,NULL,NULL,NULL,NULL),(324,316,0,'LSQ12dww','LSQ',229.472208333333,4.875,NULL,NULL,'2012-07-17 00:40:16',56124.9863,19.7383,0.0873,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_history.html','sne-pec',NULL,0.04572,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_snap_47746.gif',56380598798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,880946856,13764794,NULL,NULL,NULL,NULL),(325,316,0,'LSQ12dww','LSQ',229.47225,4.87494444444444,NULL,NULL,'2012-07-19 00:38:51',56126.98532,20.4226,0.1463,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_history.html','sne-pec',NULL,0.04572,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_snap_47747.gif',56380598798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,880946856,13764794,NULL,NULL,NULL,NULL),(326,316,0,'LSQ12dww','LSQ',229.47225,4.87497222222222,NULL,NULL,'2012-07-23 00:26:40',56130.9768599998,19.9327,0.1169,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_history.html','sne-pec',NULL,0.04572,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_snap_47748.gif',56380598798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,880946856,13764794,NULL,NULL,NULL,NULL),(327,316,0,'LSQ12dww','LSQ',229.472291666667,4.87497222222222,NULL,NULL,'2012-07-23 02:26:48',56131.0602799999,20.2465,0.2142,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_history.html','sne-pec',NULL,0.04572,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_snap_47749.gif',56380598798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,880946856,13764794,NULL,NULL,NULL,NULL),(328,316,0,'LSQ12dww','LSQ',229.472291666667,4.87486111111111,NULL,NULL,'2012-07-27 02:17:13',56135.05363,19.996,0.1675,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_history.html','sne-pec',NULL,0.04572,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_snap_47696.gif',56380598798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,880946856,13764794,NULL,NULL,NULL,NULL),(329,316,0,'LSQ12dww','LSQ',229.472416666667,4.87486111111111,NULL,NULL,'2012-07-27 02:26:11',56135.0598599999,19.6131,0.1312,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_history.html','sne-pec',NULL,0.04572,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_snap_47697.gif',56380598798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,880946856,13764794,NULL,NULL,NULL,NULL),(330,316,0,'LSQ12dww','LSQ',229.4725,4.87486111111111,NULL,NULL,'2012-07-29 01:41:42',56137.0289599998,19.4218,0.1747,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_history.html','sne-pec',NULL,0.04572,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_snap_47829.gif',56380598798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,880946856,13764794,NULL,NULL,NULL,NULL),(331,316,0,'LSQ12dww','LSQ',229.472416666667,4.87491666666667,NULL,NULL,'2012-07-29 01:45:04',56137.0312999999,19.0573,0.1888,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_history.html','sne-pec',NULL,0.04572,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dww/LSQ12dww_snap_47830.gif',56380598798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,880946856,13764794,NULL,NULL,NULL,NULL),(332,332,1,'LSQ12dwl','LSQ',333.173125,0.511972222222222,NULL,NULL,'2012-07-27 03:59:55',56135.1249500001,15.923,0.0096,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_history.html','sne-nice!',NULL,0.01377,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_snap_47674.gif',52152344380,NULL,NULL,NULL,'2012-07-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814880380,12732505,NULL,NULL,NULL,NULL),(333,332,0,'LSQ12dwl','LSQ',333.173125,0.511972222222222,NULL,NULL,'2012-07-27 06:14:55',56135.2187000001,15.7761,0.0069,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_history.html','sne-nice!',NULL,0.01377,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_snap_47675.gif',52152344380,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814880380,12732505,NULL,NULL,NULL,NULL),(334,332,0,'LSQ12dwl','LSQ',333.173125,0.511972222222222,NULL,NULL,'2012-07-29 03:54:34',56137.1212300002,15.3768,0.0072,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_history.html','sne-nice!',NULL,0.01377,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_snap_47823.gif',52152344380,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814880380,12732505,NULL,NULL,NULL,NULL),(335,332,0,'LSQ12dwl','LSQ',333.173125,0.511972222222222,NULL,NULL,'2012-07-29 06:11:17',56137.2161699999,15.2692,0.0054,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_history.html','sne-nice!',NULL,0.01377,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_snap_47824.gif',52152344380,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814880380,12732505,NULL,NULL,NULL,NULL),(336,336,1,'LSQ12dwf','LSQ',323.475041666667,0.149083333333333,NULL,NULL,'2012-07-24 03:43:01',56132.1132100001,20.4806,0.0995,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_history.html','sn',NULL,0.12212,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_snap_47194.gif',52106900277,NULL,NULL,NULL,'2012-07-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,814170316,12721411,NULL,NULL,NULL,NULL),(337,336,0,'LSQ12dwf','LSQ',323.474958333333,0.149055555555556,NULL,NULL,'2012-07-24 06:56:32',56132.2475999999,20.7393,0.1449,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_history.html','sn',NULL,0.12212,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_snap_47195.gif',52106900276,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,814170316,12721411,NULL,NULL,NULL,NULL),(338,336,0,'LSQ12dwf','LSQ',323.474958333333,0.149,NULL,NULL,'2012-07-24 09:23:24',56132.3495900002,20.7981,0.1187,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_history.html','sn',NULL,0.12212,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_snap_47196.gif',52106900232,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,814170316,12721411,NULL,NULL,NULL,NULL),(339,336,0,'LSQ12dwf','LSQ',323.475166666667,0.149083333333333,NULL,NULL,'2012-07-27 03:37:56',56135.1096800002,20.1494,0.1527,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_history.html','sn',NULL,0.12212,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_snap_47108.gif',52106900277,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,814170316,12721411,NULL,NULL,NULL,NULL),(340,336,0,'LSQ12dwf','LSQ',323.475083333333,0.149138888888889,NULL,NULL,'2012-07-27 05:38:21',56135.1932999999,19.6316,0.1081,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_history.html','sn',NULL,0.12212,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_snap_47109.gif',52106900277,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,814170316,12721411,NULL,NULL,NULL,NULL),(341,336,0,'LSQ12dwf','LSQ',323.475,0.149,NULL,NULL,'2012-07-29 03:32:34',56137.1059599998,19.5105,0.1217,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_history.html','sn',NULL,0.12212,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_snap_47421.gif',52106900235,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,814170316,12721411,NULL,NULL,NULL,NULL),(342,336,0,'LSQ12dwf','LSQ',323.475083333333,0.149055555555556,NULL,NULL,'2012-07-29 05:34:39',56137.19074,19.8062,0.1255,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_history.html','sn',NULL,0.12212,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_snap_47422.gif',52106900277,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,814170316,12721411,NULL,NULL,NULL,NULL),(343,343,1,'LSQ12dvr','LSQ',39.5682083333333,-2.43908333333333,NULL,NULL,'2012-07-23 10:27:45',56131.3942800001,17.6925,0.0306,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvr/LSQ12dvr_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvr/LSQ12dvr_snap_47152.gif',34958364933,NULL,NULL,NULL,'2012-07-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,546224452,8534757,NULL,NULL,NULL,NULL),(344,343,0,'LSQ12dvr','LSQ',39.5680833333333,-2.43886111111111,NULL,NULL,'2012-07-27 09:01:27',56135.3343500001,17.6513,0.0201,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvr/LSQ12dvr_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvr/LSQ12dvr_snap_47080.gif',34958364935,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,546224452,8534757,NULL,NULL,NULL,NULL),(345,343,0,'LSQ12dvr','LSQ',39.5681666666667,-2.43888888888889,NULL,NULL,'2012-07-27 10:18:25',56135.3878000001,17.6037,0.0221,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvr/LSQ12dvr_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvr/LSQ12dvr_snap_47081.gif',34958364933,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,546224452,8534757,NULL,NULL,NULL,NULL),(346,343,0,'LSQ12dvr','LSQ',39.5677916666667,-2.43811111111111,NULL,NULL,'2012-07-29 09:03:06',56137.33549,17.5701,0.0191,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvr/LSQ12dvr_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvr/LSQ12dvr_snap_48072.gif',34958364932,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,546224452,8534757,NULL,NULL,NULL,NULL),(347,343,0,'LSQ12dvr','LSQ',39.56775,-2.43816666666667,NULL,NULL,'2012-07-29 10:18:07',56137.3875899999,17.5986,0.0173,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvr/LSQ12dvr_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvr/LSQ12dvr_snap_48073.gif',34958364932,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,546224452,8534757,NULL,NULL,NULL,NULL),(348,348,1,'LSQ12dvl','LSQ',27.33375,1.71094444444444,NULL,NULL,'2012-07-23 10:22:40',56131.3907499998,19.363,0.194,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvl/LSQ12dvl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvl/LSQ12dvl_snap_47139.gif',67037024368,NULL,NULL,NULL,'2012-07-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1047453505,16366461,NULL,NULL,NULL,NULL),(349,348,0,'LSQ12dvl','LSQ',27.3337083333333,1.71094444444444,NULL,NULL,'2012-07-27 08:47:54',56135.3249400002,19.4635,0.1493,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvl/LSQ12dvl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvl/LSQ12dvl_snap_47068.gif',67037024368,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1047453505,16366461,NULL,NULL,NULL,NULL),(350,348,0,'LSQ12dvl','LSQ',27.3337083333333,1.71094444444444,NULL,NULL,'2012-07-27 10:11:38',56135.3830900001,19.072,0.1312,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvl/LSQ12dvl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvl/LSQ12dvl_snap_47069.gif',67037024368,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1047453505,16366461,NULL,NULL,NULL,NULL),(351,348,0,'LSQ12dvl','LSQ',27.3336666666667,1.71102777777778,NULL,NULL,'2012-07-29 08:49:22',56137.32595,18.8461,0.1842,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvl/LSQ12dvl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvl/LSQ12dvl_snap_47358.gif',67037024368,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1047453505,16366461,NULL,NULL,NULL,NULL),(352,348,0,'LSQ12dvl','LSQ',27.3338333333333,1.71094444444444,NULL,NULL,'2012-07-31 10:24:51',56139.3922600001,18.6161,0.1579,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvl/LSQ12dvl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvl/LSQ12dvl_snap_48837.gif',67037024368,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1047453505,16366461,NULL,NULL,NULL,NULL),(353,353,1,'LSQ12dvj','LSQ',28.3065416666667,-1.85125,NULL,NULL,'2012-07-23 10:22:40',56131.3907499998,20.0125,0.0863,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvj/LSQ12dvj_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvj/LSQ12dvj_snap_47133.gif',35020647697,NULL,NULL,NULL,'2012-07-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547197620,8549962,NULL,NULL,NULL,NULL),(354,353,0,'LSQ12dvj','LSQ',28.3065416666667,-1.85116666666667,NULL,NULL,'2012-07-27 08:47:54',56135.3249400002,19.9649,0.0759,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvj/LSQ12dvj_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvj/LSQ12dvj_snap_47064.gif',35020647710,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547197620,8549962,NULL,NULL,NULL,NULL),(355,353,0,'LSQ12dvj','LSQ',28.306625,-1.85119444444444,NULL,NULL,'2012-07-27 10:11:38',56135.3830900001,19.7987,0.0635,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvj/LSQ12dvj_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvj/LSQ12dvj_snap_47065.gif',35020647710,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547197620,8549962,NULL,NULL,NULL,NULL),(356,353,0,'LSQ12dvj','LSQ',28.306625,-1.85125,NULL,NULL,'2012-07-29 08:49:22',56137.32595,19.7222,0.0734,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvj/LSQ12dvj_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvj/LSQ12dvj_snap_47367.gif',35020647697,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547197620,8549962,NULL,NULL,NULL,NULL),(357,353,0,'LSQ12dvj','LSQ',28.306625,-1.85122222222222,NULL,NULL,'2012-07-29 10:11:18',56137.3828500002,19.7985,0.0642,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvj/LSQ12dvj_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dvj/LSQ12dvj_snap_47368.gif',35020647710,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547197620,8549962,NULL,NULL,NULL,NULL),(358,358,1,'LSQ12duw','LSQ',9.04120833333333,-2.58319444444444,NULL,NULL,'2012-07-27 08:27:02',56135.3104400001,20.4697,0.1353,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12duw/LSQ12duw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12duw/LSQ12duw_snap_47038.gif',34579098878,NULL,NULL,NULL,'2012-07-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,540298419,8442162,NULL,NULL,NULL,NULL),(359,358,0,'LSQ12duw','LSQ',9.041125,-2.58327777777778,NULL,NULL,'2012-07-27 11:04:37',56135.4198799999,20.5953,0.1477,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12duw/LSQ12duw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12duw/LSQ12duw_snap_47039.gif',34579098878,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,540298419,8442162,NULL,NULL,NULL,NULL),(360,358,0,'LSQ12duw','LSQ',9.04070833333333,-2.58291666666667,NULL,NULL,'2012-07-29 11:03:55',56137.4193899999,19.4155,0.0958,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12duw/LSQ12duw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12duw/LSQ12duw_snap_47363.gif',34579098878,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,540298419,8442162,NULL,NULL,NULL,NULL),(361,358,0,'LSQ12duw','LSQ',9.041125,-2.58336111111111,NULL,NULL,'2012-07-31 10:33:15',56139.3980999999,20.5182,0.179,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12duw/LSQ12duw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12duw/LSQ12duw_snap_48782.gif',34579098879,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,540298419,8442162,NULL,NULL,NULL,NULL),(362,362,1,'LSQ12dum','LSQ',0.243875,0.85725,NULL,NULL,'2012-07-23 08:36:16',56131.3168600001,19.7418,0.2104,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_snap_47021.gif',66572724993,NULL,NULL,NULL,'2012-07-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1040198828,16253106,NULL,NULL,NULL,NULL),(363,362,0,'LSQ12dum','LSQ',0.243833333333333,0.857361111111111,NULL,NULL,'2012-07-23 10:06:23',56131.3794399998,20.0513,0.1599,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_snap_47022.gif',66572724993,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1040198828,16253106,NULL,NULL,NULL,NULL),(364,362,0,'LSQ12dum','LSQ',0.243791666666667,0.857388888888889,NULL,NULL,'2012-07-27 08:14:24',56135.30167,19.3982,0.0613,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_snap_46856.gif',66572724993,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1040198828,16253106,NULL,NULL,NULL,NULL),(365,362,0,'LSQ12dum','LSQ',0.24375,0.857388888888889,NULL,NULL,'2012-07-27 11:12:20',56135.4252399998,19.4635,0.0803,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_snap_46857.gif',66572724993,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1040198828,16253106,NULL,NULL,NULL,NULL),(366,362,0,'LSQ12dum','LSQ',0.24375,0.857416666666667,NULL,NULL,'2012-07-29 08:16:00',56137.30278,19.2016,0.0782,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_snap_47307.gif',66572724993,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1040198828,16253106,NULL,NULL,NULL,NULL),(367,362,0,'LSQ12dum','LSQ',0.243791666666667,0.857388888888889,NULL,NULL,'2012-07-29 11:09:00',56137.4229199998,19.124,0.0645,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_snap_47308.gif',66572724993,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1040198828,16253106,NULL,NULL,NULL,NULL),(368,362,0,'LSQ12dum','LSQ',0.24375,0.857333333333333,NULL,NULL,'2012-07-31 08:46:10',56139.3237299998,19.1075,0.0962,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_snap_48842.gif',66572724993,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1040198828,16253106,NULL,NULL,NULL,NULL),(369,362,0,'LSQ12dum','LSQ',0.243791666666667,0.857416666666667,NULL,NULL,'2012-07-31 10:09:37',56139.3816800001,19.164,0.0883,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_snap_48843.gif',66572724993,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1040198828,16253106,NULL,NULL,NULL,NULL),(370,370,1,'LSQ12dtg','LSQ',358.90675,-6.24955555555556,NULL,NULL,'2012-07-17 09:16:50',56125.34503,20.1338,0.1031,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_history.html','variable?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_snap_46883.gif',49433754184,NULL,NULL,NULL,'2012-07-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,772402409,12068787,NULL,NULL,NULL,NULL),(371,370,0,'LSQ12dtg','LSQ',358.906791666667,-6.24991666666667,NULL,NULL,'2012-07-17 10:27:06',56125.3938199999,20.5062,0.1473,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_history.html','variable?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_snap_46884.gif',49433740676,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,772402198,12068784,NULL,NULL,NULL,NULL),(372,370,0,'LSQ12dtg','LSQ',358.9065,-6.25008333333333,NULL,NULL,'2012-07-23 07:53:30',56131.2871599998,18.4852,0.0719,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_history.html','variable?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_snap_46885.gif',49433740676,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,772402198,12068784,NULL,NULL,NULL,NULL),(373,370,0,'LSQ12dtg','LSQ',358.906416666667,-6.25030555555556,NULL,NULL,'2012-07-23 09:45:42',56131.3650699998,19.62,0.1669,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_history.html','variable?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_snap_46886.gif',49433740728,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,772402198,12068784,NULL,NULL,NULL,NULL),(374,370,0,'LSQ12dtg','LSQ',358.906625,-6.25005555555556,NULL,NULL,'2012-07-25 08:14:17',56133.3015899998,18.2327,0.0331,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_history.html','variable?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_snap_46887.gif',49433740676,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,772402198,12068784,NULL,NULL,NULL,NULL),(375,370,0,'LSQ12dtg','LSQ',358.906708333333,-6.24983333333333,NULL,NULL,'2012-07-25 10:48:56',56133.4089899999,19.2541,0.0705,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_history.html','variable?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_snap_46888.gif',49433740676,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,772402198,12068784,NULL,NULL,NULL,NULL),(376,370,0,'LSQ12dtg','LSQ',358.906583333333,-6.25008333333333,NULL,NULL,'2012-07-27 07:33:25',56135.2732099998,17.8464,0.0238,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_history.html','variable?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_snap_46792.gif',49433740676,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,772402198,12068784,NULL,NULL,NULL,NULL),(377,370,0,'LSQ12dtg','LSQ',358.906583333333,-6.25008333333333,NULL,NULL,'2012-07-27 09:32:55',56135.3561999998,18.294,0.0351,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_history.html','variable?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_snap_46793.gif',49433740676,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,772402198,12068784,NULL,NULL,NULL,NULL),(378,370,0,'LSQ12dtg','LSQ',358.906541666667,-6.25,NULL,NULL,'2012-07-29 07:33:15',56137.2730999999,18.7179,0.0712,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_history.html','variable?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_snap_47255.gif',49433740676,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,772402198,12068784,NULL,NULL,NULL,NULL),(379,370,0,'LSQ12dtg','LSQ',358.906583333333,-6.25008333333333,NULL,NULL,'2012-07-29 09:32:38',56137.3560000001,17.9012,0.0227,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_history.html','variable?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_snap_47256.gif',49433740676,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,772402198,12068784,NULL,NULL,NULL,NULL),(380,370,0,'LSQ12dtg','LSQ',358.906625,-6.25,NULL,NULL,'2012-07-31 09:32:11',56139.3556900001,17.7826,0.0365,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_history.html','variable?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_snap_48848.gif',49433740676,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,772402198,12068784,NULL,NULL,NULL,NULL),(381,381,1,'LSQ12dtf','LSQ',0.283833333333333,-6.23308333333333,NULL,NULL,'2012-07-15 08:41:42',56123.32063,19.1874,0.0969,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_snap_46784.gif',34385843399,NULL,NULL,NULL,'2012-07-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537278803,8394981,NULL,NULL,NULL,NULL),(382,381,0,'LSQ12dtf','LSQ',0.283625,-6.23297222222222,NULL,NULL,'2012-07-15 10:59:49',56123.4165500002,19.2628,0.0808,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_snap_46785.gif',34385843399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537278803,8394981,NULL,NULL,NULL,NULL),(383,381,0,'LSQ12dtf','LSQ',0.283833333333333,-6.233,NULL,NULL,'2012-07-17 09:15:08',56125.3438499998,18.6796,0.0571,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_snap_46786.gif',34385843399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537278803,8394981,NULL,NULL,NULL,NULL),(384,381,0,'LSQ12dtf','LSQ',0.283666666666667,-6.233,NULL,NULL,'2012-07-17 11:35:13',56125.4411300002,18.7424,0.0767,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_snap_46787.gif',34385843399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537278803,8394981,NULL,NULL,NULL,NULL),(385,381,0,'LSQ12dtf','LSQ',0.2835,-6.233,NULL,NULL,'2012-07-19 11:01:56',56127.4180200002,18.7492,0.0951,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_snap_46788.gif',34385843399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537278803,8394981,NULL,NULL,NULL,NULL),(386,381,0,'LSQ12dtf','LSQ',0.283833333333333,-6.23297222222222,NULL,NULL,'2012-07-23 07:51:50',56131.2859999998,18.9165,0.1392,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_snap_46789.gif',34385843399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537278803,8394981,NULL,NULL,NULL,NULL),(387,381,0,'LSQ12dtf','LSQ',0.283791666666667,-6.23308333333333,NULL,NULL,'2012-07-25 08:12:36',56133.3004200002,19.2966,0.0954,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_snap_46790.gif',34385843399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537278803,8394981,NULL,NULL,NULL,NULL),(388,381,0,'LSQ12dtf','LSQ',0.283625,-6.23302777777778,NULL,NULL,'2012-07-25 10:50:37',56133.41016,19.0011,0.0609,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_snap_46791.gif',34385843399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537278803,8394981,NULL,NULL,NULL,NULL),(389,381,0,'LSQ12dtf','LSQ',0.2835,-6.23302777777778,NULL,NULL,'2012-07-27 07:31:44',56135.2720400002,20.1324,0.1099,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_snap_46780.gif',34385843399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537278803,8394981,NULL,NULL,NULL,NULL),(390,381,0,'LSQ12dtf','LSQ',0.283666666666667,-6.23308333333333,NULL,NULL,'2012-07-27 09:31:12',56135.3550100001,19.739,0.0971,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_snap_46781.gif',34385843399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537278803,8394981,NULL,NULL,NULL,NULL),(391,381,0,'LSQ12dtf','LSQ',0.284166666666667,-6.23308333333333,NULL,NULL,'2012-07-31 09:30:31',56139.3545300001,19.0886,0.158,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_snap_48740.gif',34385843399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537278803,8394981,NULL,NULL,NULL,NULL),(392,392,1,'LSQ12dyc','LSQ',8.985,-20.7407222222222,NULL,NULL,'2012-07-08 11:10:38',56116.4240600001,17.3585,0.039,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyc/LSQ12dyc_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyc/LSQ12dyc_snap_47943.gif',35359289499,NULL,NULL,NULL,'2012-07-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,552488898,8632639,NULL,NULL,NULL,NULL),(393,392,0,'LSQ12dyc','LSQ',8.984875,-20.7406666666667,NULL,NULL,'2012-07-28 06:27:00',56136.2270900002,18.094,0.0508,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyc/LSQ12dyc_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyc/LSQ12dyc_snap_47866.gif',35359289499,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,552488898,8632639,NULL,NULL,NULL,NULL),(394,392,0,'LSQ12dyc','LSQ',8.98508333333333,-20.7406388888889,NULL,NULL,'2012-07-28 08:26:43',56136.3102299999,18.3494,0.0473,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyc/LSQ12dyc_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyc/LSQ12dyc_snap_47867.gif',35359289499,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,552488898,8632639,NULL,NULL,NULL,NULL),(395,392,0,'LSQ12dyc','LSQ',8.98508333333333,-20.7406944444444,NULL,NULL,'2012-07-30 07:26:42',56138.2685500002,18.3843,0.0862,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyc/LSQ12dyc_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyc/LSQ12dyc_snap_48463.gif',35359289499,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,552488898,8632639,NULL,NULL,NULL,NULL),(396,396,1,'LSQ12dya','LSQ',346.8545,-23.5859166666667,NULL,NULL,'2012-07-28 04:16:55',56136.1367500001,12.2864,0.1638,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dya/LSQ12dya_history.html','interesting?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dya/LSQ12dya_snap_47862.gif',50298140916,NULL,NULL,NULL,'2012-07-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,785908451,12279819,NULL,NULL,NULL,NULL),(397,396,0,'LSQ12dya','LSQ',346.85425,-23.58575,NULL,NULL,'2012-07-28 06:18:17',56136.2210400002,11.1201,0.0074,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dya/LSQ12dya_history.html','interesting?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dya/LSQ12dya_snap_47863.gif',50298140919,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,785908451,12279819,NULL,NULL,NULL,NULL),(398,398,1,'LSQ12dzt','LSQ',44.4754583333333,-1.50394444444444,NULL,NULL,'2012-07-27 09:04:50',56135.3366999999,17.8963,0.034,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzt/LSQ12dzt_history.html','sne-very nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzt/LSQ12dzt_snap_48160.gif',37849891215,NULL,NULL,NULL,'2012-07-23 09:33:07',56131.398,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591404550,9240696,NULL,NULL,NULL,NULL),(399,398,0,'LSQ12dzt','LSQ',44.475375,-1.50397222222222,NULL,NULL,'2012-07-27 10:45:17',56135.4064500001,17.7695,0.0239,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzt/LSQ12dzt_history.html','sne-very nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzt/LSQ12dzt_snap_48161.gif',37849891213,NULL,NULL,NULL,'2012-07-23 09:33:07',56131.398,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591404550,9240696,NULL,NULL,NULL,NULL),(400,398,0,'LSQ12dzt','LSQ',44.4752083333333,-1.50394444444444,NULL,NULL,'2012-07-29 09:06:30',56137.3378499998,16.7644,0.0109,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzt/LSQ12dzt_history.html','sne-very nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzt/LSQ12dzt_snap_48076.gif',37849891213,NULL,NULL,NULL,'2012-07-23 09:33:07',56131.398,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591404550,9240696,NULL,NULL,NULL,NULL),(401,398,0,'LSQ12dzt','LSQ',44.4752083333333,-1.50394444444444,NULL,NULL,'2012-07-29 10:19:48',56137.38876,16.7445,0.0091,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzt/LSQ12dzt_history.html','sne-very nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzt/LSQ12dzt_snap_48077.gif',37849891213,NULL,NULL,NULL,'2012-07-23 09:33:07',56131.398,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591404550,9240696,NULL,NULL,NULL,NULL),(402,402,1,'LSQ12dzd','LSQ',4.162375,-0.358027777777778,NULL,NULL,'2012-07-23 11:09:45',56131.42344,20.3313,0.1831,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzd/LSQ12dzd_history.html','sne???',NULL,0.07471,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzd/LSQ12dzd_snap_48131.gif',34372011761,NULL,NULL,NULL,'2012-07-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537062683,8391604,NULL,NULL,NULL,NULL),(403,402,0,'LSQ12dzd','LSQ',4.16241666666667,-0.357972222222222,NULL,NULL,'2012-07-27 08:23:39',56135.3081,19.6941,0.0975,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzd/LSQ12dzd_history.html','sne???',NULL,0.07471,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzd/LSQ12dzd_snap_48132.gif',34372011761,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537062683,8391604,NULL,NULL,NULL,NULL),(404,402,0,'LSQ12dzd','LSQ',4.1625,-0.357972222222222,NULL,NULL,'2012-07-27 09:59:21',56135.3745599999,20.234,0.1204,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzd/LSQ12dzd_history.html','sne???',NULL,0.07471,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzd/LSQ12dzd_snap_48133.gif',34372011761,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537062683,8391604,NULL,NULL,NULL,NULL),(405,402,0,'LSQ12dzd','LSQ',4.16254166666667,-0.358027777777778,NULL,NULL,'2012-07-29 08:21:05',56137.3063099999,19.9612,0.1387,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzd/LSQ12dzd_history.html','sne???',NULL,0.07471,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzd/LSQ12dzd_snap_48040.gif',34372011761,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537062683,8391604,NULL,NULL,NULL,NULL),(406,402,0,'LSQ12dzd','LSQ',4.16241666666667,-0.357972222222222,NULL,NULL,'2012-07-29 09:58:23',56137.3738799999,19.5673,0.0949,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzd/LSQ12dzd_history.html','sne???',NULL,0.07471,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzd/LSQ12dzd_snap_48041.gif',34372011761,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537062683,8391604,NULL,NULL,NULL,NULL),(407,407,1,'LSQ12dyw','LSQ',352.353666666667,-7.38908333333333,NULL,NULL,'2012-07-17 10:25:24',56125.3926400002,19.3734,0.0942,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_snap_48113.gif',49660467229,NULL,NULL,NULL,'2012-07-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,775944800,12124137,NULL,NULL,NULL,NULL),(408,407,0,'LSQ12dyw','LSQ',352.353416666667,-7.38894444444445,NULL,NULL,'2012-07-17 11:02:00',56125.4180600001,19.2507,0.0634,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_snap_48114.gif',49660467229,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,775944800,12124137,NULL,NULL,NULL,NULL),(409,407,0,'LSQ12dyw','LSQ',352.353416666667,-7.389,NULL,NULL,'2012-07-23 05:26:06',56131.1847999999,18.9507,0.1271,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_snap_48115.gif',49660467229,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,775944800,12124137,NULL,NULL,NULL,NULL),(410,407,0,'LSQ12dyw','LSQ',352.353458333333,-7.38902777777778,NULL,NULL,'2012-07-23 07:27:23',56131.26902,18.9169,0.0978,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_snap_48116.gif',49660467229,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,775944800,12124137,NULL,NULL,NULL,NULL),(411,407,0,'LSQ12dyw','LSQ',352.353416666667,-7.38897222222222,NULL,NULL,'2012-07-27 05:09:14',56135.1730800001,18.9048,0.0747,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_snap_48117.gif',49660467229,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,775944800,12124137,NULL,NULL,NULL,NULL),(412,407,0,'LSQ12dyw','LSQ',352.353333333333,-7.38905555555556,NULL,NULL,'2012-07-27 07:09:31',56135.2566200001,18.7161,0.0433,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_snap_48118.gif',49660467229,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,775944800,12124137,NULL,NULL,NULL,NULL),(413,407,0,'LSQ12dyw','LSQ',352.353083333333,-7.38894444444445,NULL,NULL,'2012-07-29 04:56:42',56137.16438,18.6649,0.0756,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_snap_48026.gif',49660467229,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,775944800,12124137,NULL,NULL,NULL,NULL),(414,407,0,'LSQ12dyw','LSQ',352.353291666667,-7.38897222222222,NULL,NULL,'2012-07-29 06:58:57',56137.2492800001,18.6481,0.0531,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_snap_48027.gif',49660467229,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,775944800,12124137,NULL,NULL,NULL,NULL),(415,407,0,'LSQ12dyw','LSQ',352.353458333333,-7.38897222222222,NULL,NULL,'2012-07-31 08:33:34',56139.3149799998,18.5063,0.0737,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_snap_48869.gif',49660467229,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,775944800,12124137,NULL,NULL,NULL,NULL),(416,407,0,'LSQ12dyw','LSQ',352.353416666667,-7.389,NULL,NULL,'2012-07-31 10:03:10',56139.3772100001,18.5594,0.0652,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_snap_48870.gif',49660467229,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,775944800,12124137,NULL,NULL,NULL,NULL),(417,417,1,'LSQ12dyt','LSQ',345.311166666667,-6.72166666666667,NULL,NULL,'2012-07-27 04:37:31',56135.1510600001,19.8541,0.1429,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyt/LSQ12dyt_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyt/LSQ12dyt_snap_48110.gif',49487242571,NULL,NULL,NULL,'2012-07-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,773238165,12081846,NULL,NULL,NULL,NULL),(418,417,0,'LSQ12dyt','LSQ',345.311083333333,-6.72152777777778,NULL,NULL,'2012-07-27 06:42:10',56135.2376199998,18.6546,0.0668,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyt/LSQ12dyt_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyt/LSQ12dyt_snap_48111.gif',49487242571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,773238165,12081846,NULL,NULL,NULL,NULL),(419,417,0,'LSQ12dyt','LSQ',345.311125,-6.72161111111111,NULL,NULL,'2012-07-29 04:30:37',56137.1462699999,17.8791,0.0403,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyt/LSQ12dyt_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyt/LSQ12dyt_snap_48020.gif',49487242571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,773238165,12081846,NULL,NULL,NULL,NULL),(420,417,0,'LSQ12dyt','LSQ',345.311166666667,-6.72158333333333,NULL,NULL,'2012-07-29 06:48:45',56137.2421900001,18.0193,0.0447,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyt/LSQ12dyt_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyt/LSQ12dyt_snap_48021.gif',49487242571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,773238165,12081846,NULL,NULL,NULL,NULL),(421,417,0,'LSQ12dyt','LSQ',345.311125,-6.72152777777778,NULL,NULL,'2012-07-31 08:26:47',56139.3102699998,17.8981,0.0673,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyt/LSQ12dyt_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyt/LSQ12dyt_snap_48872.gif',49487242571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,773238165,12081846,NULL,NULL,NULL,NULL),(422,417,0,'LSQ12dyt','LSQ',345.311166666667,-6.72158333333333,NULL,NULL,'2012-07-31 09:59:47',56139.3748599999,18.0358,0.071,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyt/LSQ12dyt_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyt/LSQ12dyt_snap_48873.gif',49487242571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,773238165,12081846,NULL,NULL,NULL,NULL),(423,423,1,'LSQ12ecu','LSQ',356.538125,-19.3575833333333,NULL,NULL,'2012-07-30 04:49:57',56138.1596900001,18.7746,0.1212,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecu/LSQ12ecu_history.html','sne',NULL,0.005974,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecu/LSQ12ecu_snap_49023.gif',49535940995,NULL,NULL,NULL,'2012-07-28 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,773999078,12093735,NULL,NULL,NULL,NULL),(424,423,0,'LSQ12ecu','LSQ',356.538166666667,-19.3576111111111,NULL,NULL,'2012-07-30 06:52:33',56138.2448300002,19.8001,0.1277,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecu/LSQ12ecu_history.html','sne',NULL,0.005974,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecu/LSQ12ecu_snap_49024.gif',49535940995,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,773999078,12093735,NULL,NULL,NULL,NULL),(425,425,1,'LSQ12ecp','LSQ',21.7569583333333,-17.3654444444444,NULL,NULL,'2012-07-28 08:40:16',56136.3196299998,17.9065,0.0274,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecp/LSQ12ecp_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecp/LSQ12ecp_snap_49165.gif',35188002643,NULL,NULL,NULL,'2012-07-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549812541,8590820,NULL,NULL,NULL,NULL),(426,425,0,'LSQ12ecp','LSQ',21.7569166666667,-17.3654722222222,NULL,NULL,'2012-07-30 07:51:07',56138.2855000002,18.0767,0.0396,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecp/LSQ12ecp_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecp/LSQ12ecp_snap_49013.gif',35188002642,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549812541,8590820,NULL,NULL,NULL,NULL),(427,425,0,'LSQ12ecp','LSQ',21.7569583333333,-17.3654444444444,NULL,NULL,'2012-07-30 09:42:01',56138.36252,18.0383,0.0347,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecp/LSQ12ecp_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecp/LSQ12ecp_snap_49014.gif',35188002643,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549812541,8590820,NULL,NULL,NULL,NULL),(428,428,1,'LSQ12ecd','LSQ',339.4785,-21.1293888888889,NULL,NULL,'2012-07-22 11:05:21',56130.4203900001,19.4667,0.1612,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecd/LSQ12ecd_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecd/LSQ12ecd_snap_49081.gif',50257618254,NULL,NULL,NULL,'2012-07-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785275285,12269926,NULL,NULL,NULL,NULL),(429,428,0,'LSQ12ecd','LSQ',339.478208333333,-21.1295,NULL,NULL,'2012-07-26 11:08:25',56134.42252,18.9193,0.0796,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecd/LSQ12ecd_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecd/LSQ12ecd_snap_49082.gif',50257618254,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785275285,12269926,NULL,NULL,NULL,NULL),(430,428,0,'LSQ12ecd','LSQ',339.47825,-21.1295277777778,NULL,NULL,'2012-07-26 11:21:56',56134.4319000002,18.6971,0.0762,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecd/LSQ12ecd_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecd/LSQ12ecd_snap_49083.gif',50257618254,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785275285,12269926,NULL,NULL,NULL,NULL),(431,428,0,'LSQ12ecd','LSQ',339.47825,-21.1294722222222,NULL,NULL,'2012-07-28 03:41:30',56136.11216,18.8627,0.1098,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecd/LSQ12ecd_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecd/LSQ12ecd_snap_49084.gif',50257618254,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785275285,12269926,NULL,NULL,NULL,NULL),(432,428,0,'LSQ12ecd','LSQ',339.47825,-21.1294444444444,NULL,NULL,'2012-07-28 05:50:57',56136.20206,18.8043,0.0827,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecd/LSQ12ecd_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecd/LSQ12ecd_snap_49085.gif',50257618254,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785275285,12269926,NULL,NULL,NULL,NULL),(433,428,0,'LSQ12ecd','LSQ',339.478208333333,-21.1294166666667,NULL,NULL,'2012-07-30 04:10:37',56138.1323799998,18.6505,0.101,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecd/LSQ12ecd_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecd/LSQ12ecd_snap_48989.gif',50257618254,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785275285,12269926,NULL,NULL,NULL,NULL),(434,428,0,'LSQ12ecd','LSQ',339.478083333333,-21.1294722222222,NULL,NULL,'2012-07-30 06:10:44',56138.2157899998,18.7177,0.0826,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecd/LSQ12ecd_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecd/LSQ12ecd_snap_48990.gif',50257618254,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785275285,12269926,NULL,NULL,NULL,NULL),(435,435,1,'LSQ12ecb','LSQ',337.79475,-24.8876111111111,NULL,NULL,'2012-07-22 11:03:39',56130.41921,19.9478,0.1815,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_49070.gif',50073090666,NULL,NULL,NULL,'2012-07-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(436,435,0,'LSQ12ecb','LSQ',337.795,-24.8874444444444,NULL,NULL,'2012-07-22 11:05:21',56130.4203900001,20.0592,0.2057,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_49069.gif',50073090668,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(437,435,0,'LSQ12ecb','LSQ',337.79475,-24.8875277777778,NULL,NULL,'2012-07-26 11:06:43',56134.4213399999,18.7645,0.0774,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_49073.gif',50073090668,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(438,435,0,'LSQ12ecb','LSQ',337.795041666667,-24.8873611111111,NULL,NULL,'2012-07-26 11:08:25',56134.42252,18.5542,0.0534,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_49071.gif',50073090668,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(439,435,0,'LSQ12ecb','LSQ',337.794625,-24.8875,NULL,NULL,'2012-07-26 11:20:15',56134.4307300001,18.6995,0.0794,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_49074.gif',50073090666,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(440,435,0,'LSQ12ecb','LSQ',337.794958333333,-24.8875,NULL,NULL,'2012-07-26 11:21:56',56134.4319000002,18.5151,0.0555,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_49072.gif',50073090668,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(441,435,0,'LSQ12ecb','LSQ',337.794583333333,-24.8874722222222,NULL,NULL,'2012-07-28 03:39:50',56136.111,18.46,0.0823,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_49077.gif',50073090666,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(442,435,0,'LSQ12ecb','LSQ',337.794833333333,-24.8874444444444,NULL,NULL,'2012-07-28 03:41:30',56136.11216,18.3857,0.0776,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_49075.gif',50073090668,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(443,435,0,'LSQ12ecb','LSQ',337.794625,-24.8875,NULL,NULL,'2012-07-28 05:49:16',56136.20089,18.2862,0.0586,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_49078.gif',50073090666,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(444,435,0,'LSQ12ecb','LSQ',337.794875,-24.8874166666667,NULL,NULL,'2012-07-28 05:50:57',56136.20206,18.533,0.0656,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_49076.gif',50073090668,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(445,435,0,'LSQ12ecb','LSQ',337.794541666667,-24.8874444444444,NULL,NULL,'2012-07-30 04:08:54',56138.1311900001,18.4004,0.0714,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_48983.gif',50073090666,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(446,435,0,'LSQ12ecb','LSQ',337.794791666667,-24.8874722222222,NULL,NULL,'2012-07-30 04:10:37',56138.1323799998,18.073,0.0882,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_48985.gif',50073090668,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(447,435,0,'LSQ12ecb','LSQ',337.794708333333,-24.8875,NULL,NULL,'2012-07-30 06:09:03',56138.2146200002,18.2554,0.0568,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_48984.gif',50073090666,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(448,435,0,'LSQ12ecb','LSQ',337.794791666667,-24.8874722222222,NULL,NULL,'2012-07-30 06:10:44',56138.2157899998,18.2818,0.0807,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_48986.gif',50073090668,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(449,435,0,'LSQ12ecb','LSQ',337.794916666667,-24.8874722222222,NULL,NULL,'2012-08-01 03:25:30',56140.1010500002,18.1324,0.1414,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_49208.gif',50073090668,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(450,435,0,'LSQ12ecb','LSQ',337.794708333333,-24.8875555555556,NULL,NULL,'2012-08-05 05:08:11',56144.1723600002,18.2218,0.2128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_49598.gif',50073090666,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(451,451,1,'LSQ12eea','LSQ',358.399333333333,-6.38316666666667,NULL,NULL,'2012-07-05 06:53:38',56113.2455899999,19.3633,0.144,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eea/LSQ12eea_history.html','sne?',NULL,0.045465,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eea/LSQ12eea_snap_49427.gif',49431273985,NULL,NULL,NULL,'2012-06-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772363656,12068182,NULL,NULL,NULL,NULL),(452,451,0,'LSQ12eea','LSQ',358.399333333333,-6.38316666666667,NULL,NULL,'2012-07-29 05:17:22',56137.1787299998,19.4586,0.1116,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eea/LSQ12eea_history.html','sne?',NULL,0.045465,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eea/LSQ12eea_snap_49428.gif',49431273985,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772363656,12068182,NULL,NULL,NULL,NULL),(453,451,0,'LSQ12eea','LSQ',358.399625,-6.38336111111111,NULL,NULL,'2012-07-31 08:44:28',56139.3225500002,18.5394,0.1157,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eea/LSQ12eea_history.html','sne?',NULL,0.045465,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eea/LSQ12eea_snap_49309.gif',49431273985,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772363656,12068182,NULL,NULL,NULL,NULL),(454,451,0,'LSQ12eea','LSQ',358.399333333333,-6.38327777777778,NULL,NULL,'2012-07-31 10:41:21',56139.4037199998,18.0487,0.0734,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eea/LSQ12eea_history.html','sne?',NULL,0.045465,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eea/LSQ12eea_snap_49310.gif',49431273985,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772363656,12068182,NULL,NULL,NULL,NULL),(455,455,1,'LSQ12edt','LSQ',41.46675,0.18025,NULL,NULL,'2012-07-31 11:18:02',56139.4291900001,20.6744,0.1524,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edt/LSQ12edt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edt/LSQ12edt_snap_49295.gif',66850723408,NULL,NULL,NULL,'2012-07-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044542553,16320977,NULL,NULL,NULL,NULL),(456,455,0,'LSQ12edt','LSQ',41.4665416666667,0.18025,NULL,NULL,'2012-07-31 11:24:48',56139.4339000001,19.8127,0.0982,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edt/LSQ12edt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edt/LSQ12edt_snap_49296.gif',66850723408,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044542553,16320977,NULL,NULL,NULL,NULL),(457,457,1,'LSQ12edo','LSQ',51.5782083333333,-3.29761111111111,NULL,NULL,'2012-07-25 10:58:00',56133.4152799998,19.1096,0.1418,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_snap_49368.gif',36842019075,NULL,NULL,NULL,'2012-07-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575656548,8994633,NULL,NULL,NULL,NULL),(458,457,0,'LSQ12edo','LSQ',51.578625,-3.29766666666667,NULL,NULL,'2012-07-27 10:21:48',56135.3901499999,18.8834,0.1097,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_snap_49369.gif',36842019075,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575656548,8994633,NULL,NULL,NULL,NULL),(459,457,0,'LSQ12edo','LSQ',51.5784583333333,-3.29763888888889,NULL,NULL,'2012-07-29 10:16:24',56137.3864000002,18.6759,0.1424,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_snap_49370.gif',36842019075,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575656548,8994633,NULL,NULL,NULL,NULL),(460,457,0,'LSQ12edo','LSQ',51.5784166666667,-3.29761111111111,NULL,NULL,'2012-07-31 08:51:52',56139.3276900002,18.3913,0.122,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_snap_49285.gif',36842019075,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575656548,8994633,NULL,NULL,NULL,NULL),(461,457,0,'LSQ12edo','LSQ',51.5784583333333,-3.29772222222222,NULL,NULL,'2012-07-31 10:37:09',56139.40081,18.9142,0.1158,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_snap_49286.gif',36842019075,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575656548,8994633,NULL,NULL,NULL,NULL),(462,462,1,'LSQ12edk','LSQ',47.2391666666667,-2.95441666666667,NULL,NULL,'2012-07-17 11:16:35',56125.4281899999,19.2438,0.1357,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_history.html','sne',NULL,0.0082,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_snap_49351.gif',36790348504,NULL,NULL,NULL,'2012-07-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574849195,8982018,NULL,NULL,NULL,NULL),(463,462,0,'LSQ12edk','LSQ',47.2394166666667,-2.95466666666667,NULL,NULL,'2012-07-23 10:57:48',56131.4151499998,18.3389,0.1904,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_history.html','sne',NULL,0.0082,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_snap_49352.gif',36790348536,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574849195,8982018,NULL,NULL,NULL,NULL),(464,462,0,'LSQ12edk','LSQ',47.239375,-2.95436111111111,NULL,NULL,'2012-07-25 11:35:43',56133.44148,18.5233,0.1946,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_history.html','sne',NULL,0.0082,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_snap_49353.gif',36790348536,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574849195,8982018,NULL,NULL,NULL,NULL),(465,462,0,'LSQ12edk','LSQ',47.2390833333333,-2.95433333333333,NULL,NULL,'2012-07-31 08:38:45',56139.3185800002,18.8149,0.1412,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_history.html','sne',NULL,0.0082,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_snap_49277.gif',36790348504,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574849195,8982018,NULL,NULL,NULL,NULL),(466,462,0,'LSQ12edk','LSQ',47.2392916666667,-2.95441666666667,NULL,NULL,'2012-07-31 10:45:23',56139.4065200002,18.3946,0.1338,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_history.html','sne',NULL,0.0082,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_snap_49278.gif',36790348536,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574849195,8982018,NULL,NULL,NULL,NULL),(467,467,1,'LSQ12eew','LSQ',316.854,-13.3195,NULL,NULL,'2012-07-08 06:23:47',56116.22486,19.6097,0.1359,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eew/LSQ12eew_history.html','sne?',NULL,0.082147,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eew/LSQ12eew_snap_49547.gif',50960592643,NULL,NULL,NULL,'2012-07-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,796259260,12441550,NULL,NULL,NULL,NULL),(468,467,0,'LSQ12eew','LSQ',316.854125,-13.3193888888889,NULL,NULL,'2012-07-28 04:25:37',56136.1428,18.8017,0.0783,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eew/LSQ12eew_history.html','sne?',NULL,0.082147,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eew/LSQ12eew_snap_49548.gif',50960592643,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,796259260,12441550,NULL,NULL,NULL,NULL),(469,467,0,'LSQ12eew','LSQ',316.854166666667,-13.3193888888889,NULL,NULL,'2012-07-30 03:04:14',56138.0862799999,18.8164,0.1146,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eew/LSQ12eew_history.html','sne?',NULL,0.082147,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eew/LSQ12eew_snap_49549.gif',50960592643,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,796259260,12441550,NULL,NULL,NULL,NULL),(470,467,0,'LSQ12eew','LSQ',316.854208333333,-13.3194166666667,NULL,NULL,'2012-08-01 02:04:16',56140.0446299999,18.5965,0.1422,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eew/LSQ12eew_history.html','sne?',NULL,0.082147,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eew/LSQ12eew_snap_49502.gif',50960592643,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,796259260,12441550,NULL,NULL,NULL,NULL),(471,467,0,'LSQ12eew','LSQ',316.854375,-13.3194722222222,NULL,NULL,'2012-08-01 04:06:00',56140.1291700001,18.3082,0.1113,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eew/LSQ12eew_history.html','sne?',NULL,0.082147,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eew/LSQ12eew_snap_49503.gif',50960592643,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,796259260,12441550,NULL,NULL,NULL,NULL),(472,472,1,'LSQ12eeq','LSQ',313.204416666667,-16.5600555555556,NULL,NULL,'2012-07-13 04:14:38',56121.1351700001,20.5025,0.1296,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_snap_49526.gif',50992845486,NULL,NULL,NULL,'2012-07-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796763210,12449425,NULL,NULL,NULL,NULL),(473,472,0,'LSQ12eeq','LSQ',313.204375,-16.5600555555556,NULL,NULL,'2012-07-28 02:07:15',56136.0467099999,18.8031,0.0845,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_snap_49527.gif',50992845486,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796763210,12449425,NULL,NULL,NULL,NULL),(474,472,0,'LSQ12eeq','LSQ',313.203458333333,-16.5599444444444,NULL,NULL,'2012-07-30 01:59:10',56138.04109,19.1421,0.1308,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_snap_49528.gif',50992845486,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796763210,12449425,NULL,NULL,NULL,NULL),(475,472,0,'LSQ12eeq','LSQ',313.204208333333,-16.5600555555556,NULL,NULL,'2012-08-01 01:51:13',56140.0355699998,18.5242,0.1487,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_snap_49490.gif',50992845486,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796763210,12449425,NULL,NULL,NULL,NULL),(476,472,0,'LSQ12eeq','LSQ',313.204083333333,-16.5601388888889,NULL,NULL,'2012-08-01 03:53:27',56140.1204599999,18.3835,0.128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_snap_49491.gif',50992845486,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796763210,12449425,NULL,NULL,NULL,NULL),(477,472,0,'LSQ12eeq','LSQ',313.204541666667,-16.5601388888889,NULL,NULL,'2012-08-05 01:35:04',56144.0243600002,17.7383,0.1049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-07 00:21:36','2012-08-07 00:21:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_snap_49601.gif',50992845478,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796763210,12449425,NULL,NULL,NULL,NULL),(478,478,1,'PS1-12bah','Pan-STARRS1',276.247225448,22.5591838579,NULL,NULL,'2012-05-15 15:36:54',56062.6089589,19.0075,0.0377883,'z',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1182459331223333000/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56062/1182459331223333000_56062.608_488089_2706_target.jpeg',NULL,NULL,54568800782,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,852637512,13322461,NULL,NULL,NULL,NULL),(479,478,0,'PS1-12bah','Pan-STARRS1',276.247252108,22.5591744449,NULL,NULL,'2012-07-28 08:05:20',56136.2953788,17.3449,0.00643286,'i',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1182459331223333000/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56136/1182459331223333000_56136.295_501270_853_target.jpeg',NULL,NULL,54568800782,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,852637512,13322461,NULL,NULL,NULL,NULL),(480,478,0,'PS1-12bah','Pan-STARRS1',276.247251145,22.5591730685,NULL,NULL,'2012-07-28 08:21:10',56136.3063697,17.3609,0.0065057,'i',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1182459331223333000/','sn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,54568800782,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,852637512,13322461,NULL,NULL,NULL,NULL),(481,478,0,'PS1-12bah','Pan-STARRS1',276.247249679,22.5591707761,NULL,NULL,'2012-07-28 10:49:53',56136.409644,17.2824,0.00767984,'r',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1182459331223333000/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56136/1182459331223333000_56136.409_501460_625_target.jpeg',NULL,NULL,54568800782,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,852637512,13322461,NULL,NULL,NULL,NULL),(482,478,0,'PS1-12bah','Pan-STARRS1',276.24725208,22.5591685039,NULL,NULL,'2012-07-28 11:04:03',56136.4194882,17.2769,0.00706203,'r',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1182459331223333000/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56136/1182459331223333000_56136.419_501510_592_target.jpeg',NULL,NULL,54568800782,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,852637512,13322461,NULL,NULL,NULL,NULL),(483,483,1,'PS1-12bai','Pan-STARRS1',317.475613274,16.5144306093,NULL,NULL,'2012-05-19 15:26:42',56066.6018824,19.7404,0.065482,'z',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1210954141163051900/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56066/1210954141163051900_56066.601_490245_3473_target.jpeg',NULL,NULL,55288186833,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,863877919,13498092,NULL,NULL,NULL,NULL),(484,483,0,'PS1-12bai','Pan-STARRS1',317.475607459,16.5144183666,NULL,NULL,'2012-05-19 15:35:32',56066.6080178,19.465,0.0466104,'z',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1210954141163051900/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56066/1210954141163051900_56066.608_490264_2139_target.jpeg',NULL,NULL,55288186833,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,863877919,13498092,NULL,NULL,NULL,NULL),(485,483,0,'PS1-12bai','Pan-STARRS1',317.475615609,16.5144053905,NULL,NULL,'2012-07-28 13:01:59',56136.5013865,17.174,0.00621908,'g',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1210954141163051900/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56136/1210954141163051900_56136.501_501596_268_target.jpeg',NULL,NULL,55288186833,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,863877919,13498092,NULL,NULL,NULL,NULL),(486,483,0,'PS1-12bai','Pan-STARRS1',317.475617146,16.5144110899,NULL,NULL,'2012-07-28 13:17:02',56136.5118399,17.0304,0.00557996,'g',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1210954141163051900/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56136/1210954141163051900_56136.511_501613_236_target.jpeg',NULL,NULL,55288186833,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,863877919,13498092,NULL,NULL,NULL,NULL),(487,483,0,'PS1-12bai','Pan-STARRS1',317.475616847,16.5144098051,NULL,NULL,'2012-07-28 13:47:32',56136.5330143,16.8945,0.00528547,'g',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1210954141163051900/','sn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,55288186833,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,863877919,13498092,NULL,NULL,NULL,NULL),(488,483,0,'PS1-12bai','Pan-STARRS1',317.475611183,16.5144084587,NULL,NULL,'2012-07-29 09:55:05',56137.3715905,16.6762,0.00474301,'i',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1210954141163051900/','sn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,55288186833,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,863877919,13498092,NULL,NULL,NULL,NULL),(489,483,0,'PS1-12bai','Pan-STARRS1',317.47560956,16.5144023168,NULL,NULL,'2012-07-29 10:10:44',56137.3824583,16.5423,0.00436778,'i',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1210954141163051900/','sn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,55288186833,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,863877919,13498092,NULL,NULL,NULL,NULL),(490,483,0,'PS1-12bai','Pan-STARRS1',317.475604584,16.5144107896,NULL,NULL,'2012-07-30 13:34:51',56138.5242052,16.6443,0.00450604,'i',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1210954141163051900/','sn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,55288186833,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,863877919,13498092,NULL,NULL,NULL,NULL),(491,483,0,'PS1-12bai','Pan-STARRS1',317.47560695,16.5144049364,NULL,NULL,'2012-07-30 13:50:25',56138.5350195,16.771,0.00495634,'i',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1210954141163051900/','sn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,55288186833,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,863877919,13498092,NULL,NULL,NULL,NULL),(492,492,1,'PS1-12baj','Pan-STARRS1',357.473017917,-9.26860035513,NULL,NULL,'2012-07-28 15:34:34',56136.6073394,19.8382,0.069707,'z',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1234953520091606900/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56136/1234953520091606900_56136.607_501695_355_target.jpeg',NULL,NULL,49612235860,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,775191185,12112362,NULL,NULL,NULL,NULL),(493,492,0,'PS1-12baj','Pan-STARRS1',357.47303713,-9.26860342331,NULL,NULL,'2012-07-28 15:51:12',56136.6188941,19.8088,0.0733816,'z',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1234953520091606900/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56136/1234953520091606900_56136.618_501719_252_target.jpeg',NULL,NULL,49612235860,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,775191185,12112362,NULL,NULL,NULL,NULL),(494,494,1,'PS1-12bag','Pan-STARRS1',1.74740143572,-8.96008317593,NULL,NULL,'2012-07-28 15:23:13',56136.5994599,19.3578,0.043632,'z',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1000659370085736200/','agn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56136/1000659370085736200_56136.599_501680_261_target.jpeg',NULL,NULL,34378395010,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,537162422,8393162,NULL,NULL,NULL,NULL),(495,494,0,'PS1-12bag','Pan-STARRS1',1.74740059304,-8.96007660321,NULL,NULL,'2012-07-28 15:39:52',56136.6110219,19.4054,0.0487866,'z',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1000659370085736200/','agn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56136/1000659370085736200_56136.611_501703_403_target.jpeg',NULL,NULL,34378395010,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,537162422,8393162,NULL,NULL,NULL,NULL),(496,496,1,'PS1-12bap','Pan-STARRS1',309.891349012,26.1569508418,NULL,NULL,'2012-06-05 13:24:47',56083.5172191,17.0715,0.00991525,'z',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1203933921260925000/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56083/1203933921260925000_56083.517_493843_1431_target.jpeg',NULL,NULL,55731630643,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,870806728,13606355,NULL,NULL,NULL,NULL),(497,496,0,'PS1-12bap','Pan-STARRS1',309.891354895,26.156945097,NULL,NULL,'2012-06-05 13:41:50',56083.5290594,17.0904,0.00990929,'z',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1203933921260925000/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56083/1203933921260925000_56083.529_493866_1502_target.jpeg',NULL,NULL,55731630643,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,870806728,13606355,NULL,NULL,NULL,NULL),(498,496,0,'PS1-12bap','Pan-STARRS1',309.891366228,26.156944298,NULL,NULL,'2012-07-29 13:33:24',56137.5232054,17.7641,0.0102383,'g',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1203933921260925000/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56137/1203933921260925000_56137.523_502175_1198_target.jpeg',NULL,NULL,55731630643,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,870806728,13606355,NULL,NULL,NULL,NULL),(499,496,0,'PS1-12bap','Pan-STARRS1',309.891364454,26.1569468547,NULL,NULL,'2012-07-29 13:49:22',56137.5342898,17.7805,0.0099802,'g',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1203933921260925000/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56137/1203933921260925000_56137.534_502192_1255_target.jpeg',NULL,NULL,55731630643,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,870806728,13606355,NULL,NULL,NULL,NULL),(500,496,0,'PS1-12bap','Pan-STARRS1',309.891365004,26.1569541848,NULL,NULL,'2012-08-05 08:32:58',56144.3145669,19.506,0.0376389,'i',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1203933921260925000/','sn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,55731630643,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,870806728,13606355,NULL,NULL,NULL,NULL),(501,501,0,'PS1-12baq','Pan-STARRS1',312.082503374,15.2376194547,NULL,NULL,'2012-07-28 12:56:28',56136.4975524,19.1472,0.0210366,'g',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2019-12-24 20:38:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1204819801151415400/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56136/1204819801151415400_56136.497_501590_1044_target.jpeg',NULL,NULL,55260164875,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,863440076,13491251,NULL,NULL,NULL,NULL),(502,501,0,'PS1-12baq','Pan-STARRS1',312.082507757,15.2376308502,NULL,NULL,'2012-07-28 13:11:34',56136.5080336,19.1277,0.0202536,'g',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1204819801151415400/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56136/1204819801151415400_56136.508_501606_1123_target.jpeg',NULL,NULL,55260164875,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,863440076,13491251,NULL,NULL,NULL,NULL),(503,501,0,'PS1-12baq','Pan-STARRS1',312.082516599,15.2376355815,NULL,NULL,'2012-07-29 09:49:12',56137.3675068,19.792,0.0435509,'i',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1204819801151415400/','sn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,55260164875,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,863440076,13491251,NULL,NULL,NULL,NULL),(504,501,0,'PS1-12baq','Pan-STARRS1',312.082520333,15.2376484849,NULL,NULL,'2012-07-29 10:04:50',56137.3783653,19.803,0.0405927,'i',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1204819801151415400/','sn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,55260164875,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,863440076,13491251,NULL,NULL,NULL,NULL),(505,505,1,'PS1-12bar','Pan-STARRS1',281.637652872,63.7497576913,NULL,NULL,'2012-07-30 09:37:45',56138.3595579,19.7653,0.046025,'i',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1184633011634459200/','sn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,53073322157,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,829270658,12957354,NULL,NULL,NULL,NULL),(506,505,0,'PS1-12bar','Pan-STARRS1',281.637628549,63.7497943114,NULL,NULL,'2012-07-30 09:55:08',56138.3716212,19.7733,0.0490857,'i',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1184633011634459200/','sn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,53073322157,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,829270658,12957354,NULL,NULL,NULL,NULL),(507,505,0,'PS1-12bar','Pan-STARRS1',281.637557281,63.7497936344,NULL,NULL,'2012-07-30 10:12:27',56138.383657,19.3748,0.0443278,'r',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1184633011634459200/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56138/1184633011634459200_56138.383_502522_568_target.jpeg',NULL,NULL,53073322157,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,829270658,12957354,NULL,NULL,NULL,NULL),(508,505,0,'PS1-12bar','Pan-STARRS1',281.637602439,63.7497817787,NULL,NULL,'2012-07-30 10:29:04',56138.3951956,19.3993,0.0395044,'r',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1184633011634459200/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56138/1184633011634459200_56138.395_502540_592_target.jpeg',NULL,NULL,53073322157,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,829270658,12957354,NULL,NULL,NULL,NULL),(509,505,0,'PS1-12bar','Pan-STARRS1',281.637677568,63.7498266797,NULL,NULL,'2012-08-04 08:13:22',56143.3009501,20.1237,0.135133,'z',NULL,NULL,NULL,NULL,'2012-08-07 23:54:53','2012-08-07 23:54:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1184633011634459200/','sn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,53073322157,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,829270658,12957354,NULL,NULL,NULL,NULL),(510,189,0,'LSQ12dpx','LSQ',348.561291666667,-6.96683333333333,NULL,NULL,'2012-08-06 09:03:20',56145.3356499998,17.088,0.1112,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-08 15:52:20','2012-08-08 15:52:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_snap_49730.gif',49602146390,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,775033537,12109899,NULL,NULL,NULL,NULL),(511,198,0,'LSQ12dpw','LSQ',345.61975,-7.10836111111111,NULL,NULL,'2012-08-06 04:30:33',56145.14622,19.0157,0.1901,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-08 15:52:20','2012-08-08 15:52:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpw/LSQ12dpw_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpw/LSQ12dpw_snap_49733.gif',49487021206,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773234706,12081792,NULL,NULL,NULL,NULL),(512,198,0,'LSQ12dpw','LSQ',345.620125,-7.10825,NULL,NULL,'2012-08-06 06:30:39',56145.2296199999,17.2099,0.1766,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-08 15:52:20','2012-08-08 15:52:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpw/LSQ12dpw_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpw/LSQ12dpw_snap_49734.gif',49487021214,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773234706,12081792,NULL,NULL,NULL,NULL),(513,332,0,'LSQ12dwl','LSQ',333.173125,0.511944444444444,NULL,NULL,'2012-08-06 03:19:19',56145.09675,14.803,0.0137,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-08 15:52:20','2012-08-08 15:52:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_history.html','sne-nice!',NULL,0.01377,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_snap_49748.gif',52152344380,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814880380,12732505,NULL,NULL,NULL,NULL),(514,332,0,'LSQ12dwl','LSQ',333.173125,0.512,NULL,NULL,'2012-08-06 05:20:01',56145.1805699999,14.81,0.005,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-08 15:52:20','2012-08-08 15:52:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_history.html','sne-nice!',NULL,0.01377,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_snap_49749.gif',52152344378,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814880380,12732505,NULL,NULL,NULL,NULL),(515,336,0,'LSQ12dwf','LSQ',323.475208333333,0.148944444444444,NULL,NULL,'2012-08-06 02:46:49',56145.07418,13.5554,0.1846,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-08 15:52:20','2012-08-08 15:52:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_history.html','sn',NULL,0.12212,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_snap_49742.gif',52106900234,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,814170316,12721411,NULL,NULL,NULL,NULL),(516,435,0,'LSQ12ecb','LSQ',337.794666666667,-24.8875,NULL,NULL,'2012-08-07 04:45:12',56146.1563900001,18.0467,0.0457,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-08 15:52:20','2012-08-08 15:52:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_49898.gif',50073090666,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(517,435,0,'LSQ12ecb','LSQ',337.794916666667,-24.8874166666667,NULL,NULL,'2012-08-07 04:46:53',56146.1575600002,18.0044,0.0443,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-08 15:52:20','2012-08-08 15:52:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_49896.gif',50073090668,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(518,435,0,'LSQ12ecb','LSQ',337.794708333333,-24.8875,NULL,NULL,'2012-08-07 06:52:15',56146.24462,18.0174,0.0541,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-08 15:52:20','2012-08-08 15:52:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_49899.gif',50073090666,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(519,435,0,'LSQ12ecb','LSQ',337.794958333333,-24.8873888888889,NULL,NULL,'2012-08-07 06:53:56',56146.2457900001,18.0421,0.0417,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-08 15:52:20','2012-08-08 15:52:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_49897.gif',50073090668,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(520,472,0,'LSQ12eeq','LSQ',313.204333333333,-16.5600277777778,NULL,NULL,'2012-08-07 05:28:42',56146.1866000001,19.2125,0.0885,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-08 15:52:20','2012-08-08 15:52:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_snap_49905.gif',50992845486,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796763210,12449425,NULL,NULL,NULL,NULL),(521,521,1,'PS1-12bat','Pan-STARRS1',221.132343226,2.96487440242,NULL,NULL,'2012-04-27 12:51:02',56044.4937787,18.28,0.0106736,'r',NULL,NULL,NULL,NULL,'2012-08-08 19:00:20','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1144431761025753500/','agn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56044/1144431761025753500_56044.493_481924_184_target.jpeg',NULL,NULL,58263843864,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,910372560,14224571,NULL,NULL,NULL,NULL),(522,521,0,'PS1-12bat','Pan-STARRS1',221.13236969,2.96486717126,NULL,NULL,'2012-08-04 07:26:02',56143.2680899,18.0304,0.0233384,'z',NULL,NULL,NULL,NULL,'2012-08-08 19:00:20','2012-08-08 19:00:20','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1144431761025753500/','agn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56143/1144431761025753500_56143.268_504152_209_target.jpeg',NULL,NULL,58263843864,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,910372560,14224571,NULL,NULL,NULL,NULL),(523,521,0,'PS1-12bat','Pan-STARRS1',221.132364767,2.96485575711,NULL,NULL,'2012-08-04 07:41:32',56143.2788494,18.0812,0.0266641,'z',NULL,NULL,NULL,NULL,'2012-08-08 19:00:20','2012-08-08 19:00:20','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1144431761025753500/','agn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56143/1144431761025753500_56143.278_504174_218_target.jpeg',NULL,NULL,58263843864,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,910372560,14224571,NULL,NULL,NULL,NULL),(524,524,1,'PS1-12bas','Pan-STARRS1',18.5520411887,6.37945763624,NULL,NULL,'2012-08-02 14:35:54',56141.5666039,19.6577,0.076857,'z',NULL,NULL,NULL,NULL,'2012-08-08 19:00:20','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1011412481062246000/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56141/1011412481062246000_56141.566_503410_474_target.jpeg',NULL,NULL,67569964911,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1055780701,16496573,NULL,NULL,NULL,NULL),(525,524,0,'PS1-12bas','Pan-STARRS1',18.5520184633,6.37946827392,NULL,NULL,'2012-08-02 14:53:21',56141.5787257,19.5446,0.0640095,'z',NULL,NULL,NULL,NULL,'2012-08-08 19:00:20','2012-08-08 19:00:20','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1011412481062246000/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56141/1011412481062246000_56141.578_503434_329_target.jpeg',NULL,NULL,67569964911,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1055780701,16496573,NULL,NULL,NULL,NULL),(526,189,0,'LSQ12dpx','LSQ',348.561291666667,-6.96727777777778,NULL,NULL,'2012-08-08 08:16:51',56147.3033699999,17.8448,0.0389,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 07:45:22','2012-08-09 07:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_snap_50117.gif',49602146390,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,775033537,12109899,NULL,NULL,NULL,NULL),(527,189,0,'LSQ12dpx','LSQ',348.561291666667,-6.9665,NULL,NULL,'2012-08-08 09:54:43',56147.3713400001,18.1982,0.0518,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 07:45:22','2012-08-09 07:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_snap_50118.gif',49602146390,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,775033537,12109899,NULL,NULL,NULL,NULL),(528,202,0,'LSQ12dpv','LSQ',337.130333333333,-6.07302777777778,NULL,NULL,'2012-08-08 05:28:25',56147.1864100001,20.3863,0.1363,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 07:45:22','2012-08-09 07:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpv/LSQ12dpv_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpv/LSQ12dpv_snap_50108.gif',50390558409,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,787352475,12302382,NULL,NULL,NULL,NULL),(529,208,0,'LSQ12dpq','LSQ',329.242916666667,-7.135,NULL,NULL,'2012-08-08 04:45:11',56147.1563800001,18.171,0.0546,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 07:45:22','2012-08-09 07:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_history.html','sne or agn',NULL,0.12054,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpq/LSQ12dpq_snap_50087.gif',49923915501,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,780061179,12188455,NULL,NULL,NULL,NULL),(530,228,0,'LSQ12dpn','LSQ',47.805375,-5.48552777777778,NULL,NULL,'2012-08-08 08:12:39',56147.3004600001,18.56,0.167,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 07:45:22','2012-08-09 07:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_snap_50101.gif',37858580920,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591540326,9242817,NULL,NULL,NULL,NULL),(531,250,0,'LSQ12dpi','LSQ',18.8045833333333,-3.19469444444444,NULL,NULL,'2012-08-08 10:21:00',56147.3895899998,19.1435,0.1927,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 07:45:22','2012-08-09 07:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_snap_50085.gif',34503822819,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539122231,8423784,NULL,NULL,NULL,NULL),(532,297,0,'LSQ12dsc','LSQ',244.916458333333,4.21605555555556,NULL,NULL,'2012-08-08 00:41:07',56146.9868899998,20.6644,0.1609,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 07:45:22','2012-08-09 07:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsc/LSQ12dsc_history.html','possible sne ',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dsc/LSQ12dsc_snap_50086.gif',56499892140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,882810814,13793918,NULL,NULL,NULL,NULL),(533,332,0,'LSQ12dwl','LSQ',333.173166666667,0.512,NULL,NULL,'2012-08-08 03:11:49',56147.09155,14.7064,0.003,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 07:45:22','2012-08-09 07:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_history.html','sne-nice!',NULL,0.01377,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_snap_50165.gif',52152344380,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814880380,12732505,NULL,NULL,NULL,NULL),(534,332,0,'LSQ12dwl','LSQ',333.173166666667,0.511972222222222,NULL,NULL,'2012-08-08 05:14:51',56147.1769900001,14.762,0.0032,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 07:45:22','2012-08-09 07:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_history.html','sne-nice!',NULL,0.01377,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_snap_50166.gif',52152344380,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814880380,12732505,NULL,NULL,NULL,NULL),(535,336,0,'LSQ12dwf','LSQ',323.475083333333,0.149055555555556,NULL,NULL,'2012-08-08 02:37:36',56147.0677800002,20.0168,0.113,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 07:45:22','2012-08-09 07:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_history.html','sn',NULL,0.12212,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_snap_50150.gif',52106900277,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,814170316,12721411,NULL,NULL,NULL,NULL),(536,336,0,'LSQ12dwf','LSQ',323.475041666667,0.149055555555556,NULL,NULL,'2012-08-08 04:38:26',56147.1516999998,20.082,0.0931,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 07:45:22','2012-08-09 07:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_history.html','sn',NULL,0.12212,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_snap_50151.gif',52106900277,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,814170316,12721411,NULL,NULL,NULL,NULL),(537,362,0,'LSQ12dum','LSQ',0.24375,0.857361111111111,NULL,NULL,'2012-08-08 10:36:06',56147.40007,19.6263,0.1099,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 07:45:22','2012-08-09 07:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_snap_50144.gif',66572724993,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1040198828,16253106,NULL,NULL,NULL,NULL),(538,362,0,'LSQ12dum','LSQ',0.243833333333333,0.857472222222222,NULL,NULL,'2012-08-08 11:25:47',56147.4345800001,19.3294,0.2097,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 07:45:22','2012-08-09 07:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_snap_50145.gif',66572724993,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1040198828,16253106,NULL,NULL,NULL,NULL),(539,407,0,'LSQ12dyw','LSQ',352.353416666667,-7.38905555555556,NULL,NULL,'2012-08-08 08:30:33',56147.3128900002,18.4961,0.0575,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 07:45:22','2012-08-09 07:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_snap_50206.gif',49660467229,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,775944800,12124137,NULL,NULL,NULL,NULL),(540,407,0,'LSQ12dyw','LSQ',352.353208333333,-7.38891666666667,NULL,NULL,'2012-08-08 10:08:15',56147.3807399999,18.4915,0.0506,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 07:45:22','2012-08-09 07:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_snap_50207.gif',49660467229,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,775944800,12124137,NULL,NULL,NULL,NULL),(541,457,0,'LSQ12edo','LSQ',51.5784166666667,-3.29752777777778,NULL,NULL,'2012-08-08 08:26:21',56147.3099699998,18.8399,0.1377,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 07:45:22','2012-08-09 07:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_snap_50126.gif',36842019075,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575656548,8994633,NULL,NULL,NULL,NULL),(542,542,1,'PSNJ21253403-4016432','TOCP',321.391766666667,-40.2786888888889,NULL,NULL,'2012-06-27 00:00:00',56105,15.5,0.3,'unfiltered',NULL,NULL,NULL,NULL,'2012-08-09 14:45:20','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'http://www.das.uchile.cl/~gpignata/pessto/PSNJ21253403-4016432.gif',51356335194,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,802442737,12538167,NULL,NULL,NULL,NULL),(543,543,1,'PSNJ20032484-5557192','TOCP',300.8535,-55.955325,NULL,NULL,'2012-06-27 00:00:00',56105,15.5,0.3,'unfiltered',NULL,NULL,NULL,NULL,'2012-08-09 14:45:20','2020-04-28 09:08:48',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'http://www.das.uchile.cl/~gpignata/pessto/PSNJ20032484-5557192.gif',49049600212,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,766400003,11975000,NULL,NULL,NULL,NULL),(544,544,1,'LSQ12egf','LSQ',342.308791666667,1.74255555555556,NULL,NULL,'2012-07-05 05:24:00',56113.2250100002,19.2909,0.1348,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 15:45:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_50372.gif',51679416304,NULL,NULL,NULL,'2012-06-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(545,544,0,'LSQ12egf','LSQ',342.308708333333,1.74247222222222,NULL,NULL,'2012-07-05 07:26:35',56113.3101300001,18.8054,0.0936,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 15:45:25','2012-08-09 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_50373.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(546,544,0,'LSQ12egf','LSQ',342.309333333333,1.74280555555556,NULL,NULL,'2012-07-07 05:14:22',56115.21832,19.3915,0.1345,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 15:45:25','2012-08-09 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_50374.gif',51679416276,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(547,544,0,'LSQ12egf','LSQ',342.30875,1.7425,NULL,NULL,'2012-07-07 07:14:56',56115.30204,18.9726,0.1152,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 15:45:25','2012-08-09 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_50375.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(548,544,0,'LSQ12egf','LSQ',342.308916666667,1.7425,NULL,NULL,'2012-07-23 04:27:50',56131.1860000002,18.3959,0.053,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 15:45:25','2012-08-09 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_50376.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(549,544,0,'LSQ12egf','LSQ',342.308875,1.74255555555556,NULL,NULL,'2012-07-23 06:48:22',56131.2835900001,18.9626,0.075,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 15:45:25','2012-08-09 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_50377.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(550,544,0,'LSQ12egf','LSQ',342.308708333333,1.7425,NULL,NULL,'2012-07-27 04:27:59',56135.1861,19.0037,0.0679,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 15:45:25','2012-08-09 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_50378.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(551,544,0,'LSQ12egf','LSQ',342.30875,1.74261111111111,NULL,NULL,'2012-07-27 06:28:18',56135.2696600002,18.9684,0.0525,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 15:45:25','2012-08-09 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_50379.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(552,544,0,'LSQ12egf','LSQ',342.309041666667,1.74280555555556,NULL,NULL,'2012-07-29 04:05:20',56137.17038,19.5871,0.1743,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 15:45:25','2012-08-09 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_50380.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(553,544,0,'LSQ12egf','LSQ',342.308791666667,1.74247222222222,NULL,NULL,'2012-07-29 06:24:36',56137.2670900002,19.396,0.1044,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 15:45:25','2012-08-09 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_50381.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(554,544,0,'LSQ12egf','LSQ',342.309,1.74261111111111,NULL,NULL,'2012-07-31 10:07:19',56139.4217500002,19.4986,0.0711,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 15:45:25','2012-08-09 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_50382.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(555,544,0,'LSQ12egf','LSQ',342.308875,1.74275,NULL,NULL,'2012-08-08 03:14:23',56147.1349999998,20.1351,0.1365,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 15:45:25','2012-08-09 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_50331.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(556,544,0,'LSQ12egf','LSQ',342.309041666667,1.74275,NULL,NULL,'2012-08-08 05:14:34',56147.21845,19.7331,0.1144,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-09 15:45:25','2012-08-09 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_50332.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(557,557,1,'LSQ12ege','LSQ',252.716541666667,2.87413888888889,NULL,NULL,'2012-07-15 01:12:36',56123.0504200002,20.4853,0.2151,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-09 15:45:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_snap_50371.gif',55981405188,NULL,NULL,NULL,'2012-07-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,874709456,13667335,NULL,NULL,NULL,NULL),(558,557,0,'LSQ12ege','LSQ',252.715958333333,2.87455555555556,NULL,NULL,'2012-08-07 23:34:22',56146.9822,19.2516,0.0832,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-09 15:45:25','2012-08-09 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_snap_50329.gif',55981393928,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,874709280,13667332,NULL,NULL,NULL,NULL),(559,557,0,'LSQ12ege','LSQ',252.716,2.87452777777778,NULL,NULL,'2012-08-08 01:34:54',56147.0659099999,18.877,0.0661,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-09 15:45:25','2012-08-09 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_snap_50330.gif',55981393928,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,874709280,13667332,NULL,NULL,NULL,NULL),(560,560,1,'LSQ12ehh','LSQ',246.802,2.08336111111111,NULL,NULL,'2012-04-23 06:34:12',56040.2737599998,20.5828,0.1917,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-09 16:45:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_snap_50510.gif',56440595287,NULL,NULL,NULL,'2012-04-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881884301,13779442,NULL,NULL,NULL,NULL),(561,560,0,'LSQ12ehh','LSQ',246.801625,2.08341666666667,NULL,NULL,'2012-07-27 00:15:28',56135.0107499999,19.866,0.1641,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-09 16:45:25','2012-08-09 16:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_snap_50511.gif',56440595284,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881884301,13779442,NULL,NULL,NULL,NULL),(562,560,0,'LSQ12ehh','LSQ',246.801458333333,2.08341666666667,NULL,NULL,'2012-07-29 02:08:07',56137.08898,19.9193,0.1511,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-09 16:45:25','2012-08-09 16:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_snap_50512.gif',56440595284,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881884301,13779442,NULL,NULL,NULL,NULL),(563,560,0,'LSQ12ehh','LSQ',246.801541666667,2.08344444444444,NULL,NULL,'2012-08-07 23:29:16',56146.97866,19.2861,0.0514,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-09 16:45:25','2012-08-09 16:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_snap_50464.gif',56440595284,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881884301,13779442,NULL,NULL,NULL,NULL),(564,560,0,'LSQ12ehh','LSQ',246.8015,2.08341666666667,NULL,NULL,'2012-08-08 01:29:51',56147.0624000002,19.4608,0.0497,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-09 16:45:25','2012-08-09 16:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_snap_50465.gif',56440595284,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881884301,13779442,NULL,NULL,NULL,NULL),(565,428,0,'LSQ12ecd','LSQ',339.478541666667,-21.1294444444444,NULL,NULL,'2012-08-09 04:07:26',56148.1718299999,18.5691,0.1168,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-10 03:45:22','2012-08-10 03:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecd/LSQ12ecd_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecd/LSQ12ecd_snap_50521.gif',50257618254,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785275285,12269926,NULL,NULL,NULL,NULL),(566,435,0,'LSQ12ecb','LSQ',337.794625,-24.8875277777778,NULL,NULL,'2012-08-09 01:53:00',56148.0784800001,18.2246,0.0415,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-10 03:45:22','2012-08-10 03:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_50537.gif',50073090666,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(567,435,0,'LSQ12ecb','LSQ',337.794708333333,-24.8874722222222,NULL,NULL,'2012-08-09 01:54:41',56148.0796500002,18.2411,0.045,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-10 03:45:22','2012-08-10 03:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_50535.gif',50073090668,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(568,435,0,'LSQ12ecb','LSQ',337.794666666667,-24.8875,NULL,NULL,'2012-08-09 04:05:44',56148.1706500002,18.4038,0.0367,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-10 03:45:22','2012-08-10 03:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_50538.gif',50073090666,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(569,435,0,'LSQ12ecb','LSQ',337.794833333333,-24.8874722222222,NULL,NULL,'2012-08-09 04:07:26',56148.1718299999,18.2945,0.0403,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-10 03:45:22','2012-08-10 03:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_50536.gif',50073090668,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(570,472,0,'LSQ12eeq','LSQ',313.203583333333,-16.5599166666667,NULL,NULL,'2012-08-09 02:16:10',56148.0945700002,18.4594,0.0526,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-10 03:45:22','2012-08-10 03:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_snap_50556.gif',50992845486,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796763210,12449425,NULL,NULL,NULL,NULL),(571,571,1,'LSQ12ehj','LSQ',347.315666666667,7.04825,NULL,NULL,'2012-08-08 05:50:16',56147.2432499998,18.659,0.0736,'gr-LSQ',NULL,NULL,'AGN',NULL,'2012-08-10 15:45:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_snap_50468.gif',51719133726,NULL,NULL,NULL,'2012-08-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,808111464,12626741,NULL,NULL,NULL,NULL),(572,571,0,'LSQ12ehj','LSQ',347.315708333333,7.04827777777778,NULL,NULL,'2012-08-08 07:50:41',56147.32687,18.4789,0.0713,'gr-LSQ',NULL,NULL,'AGN',NULL,'2012-08-10 15:45:22','2012-08-10 15:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_snap_50469.gif',51719133726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,808111464,12626741,NULL,NULL,NULL,NULL),(573,573,1,'LSQ12ehn','LSQ',53.8109166666667,-18.4273888888889,NULL,NULL,'2012-07-28 08:35:17',56136.3578400002,20.1796,0.1193,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-10 15:45:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_history.html','variable or unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_snap_50648.gif',38005697462,NULL,NULL,NULL,'2011-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,593839022,9278734,NULL,NULL,NULL,NULL),(574,573,0,'LSQ12ehn','LSQ',53.8109166666667,-18.4273333333333,NULL,NULL,'2012-07-28 09:35:15',56136.3994900002,20.3145,0.1199,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-10 15:45:22','2012-08-10 15:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_history.html','variable or unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_snap_50649.gif',38005697462,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,593839022,9278734,NULL,NULL,NULL,NULL),(575,573,0,'LSQ12ehn','LSQ',53.811,-18.4273888888889,NULL,NULL,'2012-07-30 07:41:32',56138.32051,19.6753,0.2056,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-10 15:45:22','2012-08-10 15:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_history.html','variable or unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_snap_50650.gif',38005697462,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,593839022,9278734,NULL,NULL,NULL,NULL),(576,573,0,'LSQ12ehn','LSQ',53.8109583333333,-18.4273333333333,NULL,NULL,'2012-07-30 09:08:04',56138.3806099999,20.0753,0.0851,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-10 15:45:22','2012-08-10 15:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_history.html','variable or unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_snap_50651.gif',38005697462,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,593839022,9278734,NULL,NULL,NULL,NULL),(577,573,0,'LSQ12ehn','LSQ',53.811,-18.4273055555556,NULL,NULL,'2012-08-09 10:09:19',56148.4231400001,20.4118,0.1017,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-10 15:45:22','2012-08-10 15:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_history.html','variable or unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_snap_50640.gif',38005697462,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,593839022,9278734,NULL,NULL,NULL,NULL),(578,573,0,'LSQ12ehn','LSQ',53.811,-18.4273888888889,NULL,NULL,'2012-08-09 10:17:49',56148.4290399998,20.0091,0.1319,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-10 15:45:22','2012-08-10 15:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_history.html','variable or unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_snap_50641.gif',38005697462,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,593839022,9278734,NULL,NULL,NULL,NULL),(579,579,1,'LSQ12ehm','LSQ',55.0169583333333,-17.8017222222222,NULL,NULL,'2012-08-09 10:09:19',56148.4231400001,18.5302,0.068,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-10 15:45:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehm/LSQ12ehm_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehm/LSQ12ehm_snap_50638.gif',38011902031,NULL,NULL,NULL,'2012-08-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593935969,9280249,NULL,NULL,NULL,NULL),(580,579,0,'LSQ12ehm','LSQ',55.0169583333333,-17.8017777777778,NULL,NULL,'2012-08-09 10:17:49',56148.4290399998,18.1673,0.0744,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-10 15:45:22','2012-08-10 15:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehm/LSQ12ehm_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehm/LSQ12ehm_snap_50639.gif',38011902031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593935969,9280249,NULL,NULL,NULL,NULL),(581,581,1,'LSQ12ehl','LSQ',72.5277083333333,-21.7752777777778,NULL,NULL,'2012-08-09 10:04:05',56148.4195099999,17.7974,0.0402,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-10 15:45:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_snap_50636.gif',37345461187,NULL,NULL,NULL,'2012-01-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583522831,9117544,NULL,NULL,NULL,NULL),(582,581,0,'LSQ12ehl','LSQ',72.5276666666667,-21.77525,NULL,NULL,'2012-08-09 10:14:25',56148.42668,17.7687,0.0271,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-10 15:45:22','2012-08-10 15:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_snap_50637.gif',37345461187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583522831,9117544,NULL,NULL,NULL,NULL),(583,150,0,'LSQ12dmi','LSQ',22.9483333333333,-3.67475,NULL,NULL,'2012-08-10 08:39:02',56149.36045,19.7935,0.1518,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_50690.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(584,189,0,'LSQ12dpx','LSQ',348.561208333333,-6.96652777777778,NULL,NULL,'2012-08-10 09:32:02',56149.3972499999,17.2936,0.0307,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_snap_50781.gif',49602146390,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,775033537,12109899,NULL,NULL,NULL,NULL),(585,189,0,'LSQ12dpx','LSQ',348.561208333333,-6.96652777777778,NULL,NULL,'2012-08-10 10:22:42',56149.4324400001,17.4055,0.0375,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpx/LSQ12dpx_snap_50782.gif',49602146390,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,775033537,12109899,NULL,NULL,NULL,NULL),(586,198,0,'LSQ12dpw','LSQ',345.619875,-7.10816666666667,NULL,NULL,'2012-08-10 06:00:19',56149.2502299999,19.1647,0.1049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpw/LSQ12dpw_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpw/LSQ12dpw_snap_50769.gif',49487021214,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773234706,12081792,NULL,NULL,NULL,NULL),(587,198,0,'LSQ12dpw','LSQ',345.619583333333,-7.10825,NULL,NULL,'2012-08-10 07:59:58',56149.3333200002,19.4826,0.1218,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpw/LSQ12dpw_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpw/LSQ12dpw_snap_50770.gif',49487021206,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773234706,12081792,NULL,NULL,NULL,NULL),(588,202,0,'LSQ12dpv','LSQ',337.130541666667,-6.07302777777778,NULL,NULL,'2012-08-10 04:21:20',56149.1814899999,20.7273,0.146,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpv/LSQ12dpv_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpv/LSQ12dpv_snap_50784.gif',50390558413,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,787352475,12302382,NULL,NULL,NULL,NULL),(589,228,0,'LSQ12dpn','LSQ',47.805125,-5.48575,NULL,NULL,'2012-08-10 07:25:24',56149.3093099999,19.5407,0.1419,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_snap_50750.gif',37858580920,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591540326,9242817,NULL,NULL,NULL,NULL),(590,228,0,'LSQ12dpn','LSQ',47.805125,-5.48566666666667,NULL,NULL,'2012-08-10 08:57:50',56149.3735000002,19.5984,0.1806,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpn/LSQ12dpn_snap_50751.gif',37858580920,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591540326,9242817,NULL,NULL,NULL,NULL),(591,250,0,'LSQ12dpi','LSQ',18.8044166666667,-3.19486111111111,NULL,NULL,'2012-08-10 06:45:06',56149.2813200001,18.8188,0.0865,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_snap_50738.gif',34503822819,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539122231,8423784,NULL,NULL,NULL,NULL),(592,332,0,'LSQ12dwl','LSQ',333.173125,0.512,NULL,NULL,'2012-08-10 02:04:33',56149.0865000002,14.6743,0.0029,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_history.html','sne-nice!',NULL,0.01377,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_snap_50843.gif',52152344378,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814880380,12732505,NULL,NULL,NULL,NULL),(593,332,0,'LSQ12dwl','LSQ',333.173166666667,0.511944444444444,NULL,NULL,'2012-08-10 04:07:48',56149.17209,14.5799,0.0342,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_history.html','sne-nice!',NULL,0.01377,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_snap_50844.gif',52152344380,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814880380,12732505,NULL,NULL,NULL,NULL),(594,336,0,'LSQ12dwf','LSQ',323.475041666667,0.149027777777778,NULL,NULL,'2012-08-10 01:25:54',56149.0596599998,19.9129,0.1071,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_history.html','sn',NULL,0.12212,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_snap_50836.gif',52106900234,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,814170316,12721411,NULL,NULL,NULL,NULL),(595,336,0,'LSQ12dwf','LSQ',323.474958333333,0.149055555555556,NULL,NULL,'2012-08-10 03:27:56',56149.1444000001,20.4588,0.1453,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_history.html','sn',NULL,0.12212,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwf/LSQ12dwf_snap_50837.gif',52106900276,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,814170316,12721411,NULL,NULL,NULL,NULL),(596,358,0,'LSQ12duw','LSQ',9.04104166666667,-2.583,NULL,NULL,'2012-08-10 09:50:37',56149.41016,20.47,0.1743,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12duw/LSQ12duw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12duw/LSQ12duw_snap_50732.gif',34579098878,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,540298419,8442162,NULL,NULL,NULL,NULL),(597,362,0,'LSQ12dum','LSQ',0.243791666666667,0.857388888888889,NULL,NULL,'2012-08-10 09:42:10',56149.40429,19.4992,0.0945,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_snap_50824.gif',66572724993,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1040198828,16253106,NULL,NULL,NULL,NULL),(598,362,0,'LSQ12dum','LSQ',0.243833333333333,0.857388888888889,NULL,NULL,'2012-08-10 10:15:55',56149.42772,19.5683,0.103,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dum/LSQ12dum_snap_50825.gif',66572724993,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1040198828,16253106,NULL,NULL,NULL,NULL),(599,381,0,'LSQ12dtf','LSQ',0.283375,-6.23297222222222,NULL,NULL,'2012-08-10 08:24:00',56149.3500000001,20.5549,0.1699,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_snap_50662.gif',34385843396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537278803,8394981,NULL,NULL,NULL,NULL),(600,402,0,'LSQ12dzd','LSQ',4.16241666666667,-0.357944444444444,NULL,NULL,'2012-08-10 09:47:14',56149.4078099998,20.2273,0.1825,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzd/LSQ12dzd_history.html','sne???',NULL,0.07471,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzd/LSQ12dzd_snap_50875.gif',34372011761,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537062683,8391604,NULL,NULL,NULL,NULL),(601,407,0,'LSQ12dyw','LSQ',352.353416666667,-7.38891666666667,NULL,NULL,'2012-08-10 09:37:07',56149.4007799998,18.4459,0.0415,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_snap_50878.gif',49660467229,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,775944800,12124137,NULL,NULL,NULL,NULL),(602,407,0,'LSQ12dyw','LSQ',352.353333333333,-7.389,NULL,NULL,'2012-08-10 10:02:22',56149.4183200002,18.5806,0.049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dyw/LSQ12dyw_snap_50879.gif',49660467229,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,775944800,12124137,NULL,NULL,NULL,NULL),(603,457,0,'LSQ12edo','LSQ',51.578125,-3.29752777777778,NULL,NULL,'2012-08-10 07:38:53',56149.31868,17.5784,0.0618,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_snap_50790.gif',36842019075,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575656548,8994633,NULL,NULL,NULL,NULL),(604,457,0,'LSQ12edo','LSQ',51.5785416666667,-3.29769444444444,NULL,NULL,'2012-08-10 09:02:53',56149.3770099999,19.2948,0.1301,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_snap_50791.gif',36842019075,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575656548,8994633,NULL,NULL,NULL,NULL),(605,462,0,'LSQ12edk','LSQ',47.239,-2.95447222222222,NULL,NULL,'2012-08-10 07:25:24',56149.3093099999,19.11,0.196,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_history.html','sne',NULL,0.0082,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_snap_50808.gif',36790348504,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574849195,8982018,NULL,NULL,NULL,NULL),(606,544,0,'LSQ12egf','LSQ',342.308708333333,1.74241666666667,NULL,NULL,'2012-08-10 03:07:05',56149.1299299998,19.0403,0.0698,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_50910.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(607,544,0,'LSQ12egf','LSQ',342.308666666667,1.74252777777778,NULL,NULL,'2012-08-10 05:07:35',56149.2135999999,19.0279,0.0506,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_50911.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(608,557,0,'LSQ12ege','LSQ',252.716,2.87458333333333,NULL,NULL,'2012-08-10 00:52:09',56149.0362200001,18.5607,0.07,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_snap_50930.gif',55981393928,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,874709280,13667332,NULL,NULL,NULL,NULL),(609,560,0,'LSQ12ehh','LSQ',246.8015,2.08347222222222,NULL,NULL,'2012-08-10 01:06:06',56149.0459099999,19.2252,0.0519,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_snap_50915.gif',56440595284,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881884301,13779442,NULL,NULL,NULL,NULL),(610,571,0,'LSQ12ehj','LSQ',347.315708333333,7.04825,NULL,NULL,'2012-08-10 07:46:24',56149.3239000002,18.6274,0.0505,'gr-LSQ',NULL,NULL,'AGN',NULL,'2012-08-11 06:45:25','2012-08-11 06:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_snap_50916.gif',51719133726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,808111464,12626741,NULL,NULL,NULL,NULL),(611,611,1,'LSQ12eid','LSQ',4.408375,-5.38275,NULL,NULL,'2012-07-29 06:34:56',56137.2742699999,19.9358,0.1452,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-11 16:45:24','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_snap_51160.gif',34413529726,NULL,NULL,NULL,'2012-07-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537711401,8401740,NULL,NULL,NULL,NULL),(612,611,0,'LSQ12eid','LSQ',4.40833333333333,-5.38275,NULL,NULL,'2012-07-31 10:05:32',56139.4205100001,19.3654,0.0805,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-11 16:45:24','2012-08-11 16:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_snap_51161.gif',34413529726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537711401,8401740,NULL,NULL,NULL,NULL),(613,611,0,'LSQ12eid','LSQ',4.40833333333333,-5.38286111111111,NULL,NULL,'2012-08-08 06:14:41',56147.2601999999,17.8679,0.0581,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-11 16:45:24','2012-08-11 16:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_snap_51162.gif',34413529726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537711401,8401740,NULL,NULL,NULL,NULL),(614,611,0,'LSQ12eid','LSQ',4.408375,-5.38275,NULL,NULL,'2012-08-08 08:15:05',56147.34381,18.1069,0.0419,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-11 16:45:24','2012-08-11 16:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_snap_51163.gif',34413529726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537711401,8401740,NULL,NULL,NULL,NULL),(615,611,0,'LSQ12eid','LSQ',4.40820833333333,-5.38277777777778,NULL,NULL,'2012-08-10 06:31:35',56149.2719399999,18.084,0.0329,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-11 16:45:24','2012-08-11 16:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_snap_51111.gif',34413529726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537711401,8401740,NULL,NULL,NULL,NULL),(616,611,0,'LSQ12eid','LSQ',4.40808333333333,-5.38283333333333,NULL,NULL,'2012-08-10 09:14:54',56149.3853500001,18.0722,0.0479,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-11 16:45:24','2012-08-11 16:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_snap_51112.gif',34413529726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537711401,8401740,NULL,NULL,NULL,NULL),(617,617,1,'LSQ12eib','LSQ',8.040875,-7.38152777777778,NULL,NULL,'2012-07-31 06:38:38',56139.2768399999,18.9377,0.1506,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 16:45:24','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_snap_51156.gif',34627856184,NULL,NULL,NULL,'2012-07-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541060252,8454066,NULL,NULL,NULL,NULL),(618,617,0,'LSQ12eib','LSQ',8.04095833333333,-7.38155555555555,NULL,NULL,'2012-07-31 08:35:34',56139.3580399998,19.1286,0.144,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 16:45:24','2012-08-11 16:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_snap_51157.gif',34627856184,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541060252,8454066,NULL,NULL,NULL,NULL),(619,617,0,'LSQ12eib','LSQ',8.041,-7.38155555555555,NULL,NULL,'2012-08-08 06:27:02',56147.26878,18.7594,0.0776,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 16:45:24','2012-08-11 16:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_snap_51158.gif',34627856184,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541060252,8454066,NULL,NULL,NULL,NULL),(620,617,0,'LSQ12eib','LSQ',8.040875,-7.38152777777778,NULL,NULL,'2012-08-08 08:26:57',56147.3520499999,18.6532,0.076,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 16:45:24','2012-08-11 16:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_snap_51159.gif',34627856184,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541060252,8454066,NULL,NULL,NULL,NULL),(621,617,0,'LSQ12eib','LSQ',8.04095833333333,-7.38152777777778,NULL,NULL,'2012-08-10 06:36:38',56149.2754500001,18.8262,0.0528,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 16:45:24','2012-08-11 16:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_snap_51107.gif',34627856184,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541060252,8454066,NULL,NULL,NULL,NULL),(622,617,0,'LSQ12eib','LSQ',8.04066666666667,-7.3815,NULL,NULL,'2012-08-10 09:09:49',56149.3818199998,18.657,0.0603,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 16:45:24','2012-08-11 16:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_snap_51108.gif',34627856184,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541060252,8454066,NULL,NULL,NULL,NULL),(623,623,1,'LSQ12ehw','LSQ',357.061833333333,-7.17166666666667,NULL,NULL,'2012-08-08 07:33:57',56147.31525,19.5216,0.1119,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-11 16:45:24','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehw/LSQ12ehw_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehw/LSQ12ehw_snap_51129.gif',49435432346,NULL,NULL,NULL,'2012-08-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772428630,12069197,NULL,NULL,NULL,NULL),(624,623,0,'LSQ12ehw','LSQ',357.061833333333,-7.17166666666667,NULL,NULL,'2012-08-08 09:01:26',56147.3760000002,19.6484,0.1723,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-11 16:45:24','2012-08-11 16:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehw/LSQ12ehw_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehw/LSQ12ehw_snap_51130.gif',49435432346,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772428630,12069197,NULL,NULL,NULL,NULL),(625,623,0,'LSQ12ehw','LSQ',357.061833333333,-7.17163888888889,NULL,NULL,'2012-08-10 09:40:28',56149.4031099998,19.1804,0.0773,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-11 16:45:24','2012-08-11 16:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehw/LSQ12ehw_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehw/LSQ12ehw_snap_51097.gif',49435432346,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772428630,12069197,NULL,NULL,NULL,NULL),(626,623,0,'LSQ12ehw','LSQ',357.061875,-7.17177777777778,NULL,NULL,'2012-08-10 10:17:36',56149.4289000002,19.3434,0.1215,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-11 16:45:24','2012-08-11 16:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehw/LSQ12ehw_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehw/LSQ12ehw_snap_51098.gif',49435432346,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772428630,12069197,NULL,NULL,NULL,NULL),(627,627,1,'LSQ12eht','LSQ',354.3595,10.3063333333333,NULL,NULL,'2012-08-08 05:58:49',56147.2491799998,19.8216,0.1394,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 16:45:24','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eht/LSQ12eht_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eht/LSQ12eht_snap_51122.gif',51778995065,NULL,NULL,NULL,'2012-08-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,809046797,12641356,NULL,NULL,NULL,NULL),(628,627,0,'LSQ12eht','LSQ',354.359375,10.3062777777778,NULL,NULL,'2012-08-08 07:59:07',56147.3327299999,19.6511,0.1307,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 16:45:24','2012-08-11 16:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eht/LSQ12eht_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eht/LSQ12eht_snap_51123.gif',51778995065,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,809046797,12641356,NULL,NULL,NULL,NULL),(629,627,0,'LSQ12eht','LSQ',354.359458333333,10.3064166666667,NULL,NULL,'2012-08-10 05:58:35',56149.24902,19.6256,0.1002,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 16:45:24','2012-08-11 16:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eht/LSQ12eht_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eht/LSQ12eht_snap_51091.gif',51778995065,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,809046797,12641356,NULL,NULL,NULL,NULL),(630,627,0,'LSQ12eht','LSQ',354.359416666667,10.3064166666667,NULL,NULL,'2012-08-10 07:58:16',56149.33213,19.4427,0.0955,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 16:45:24','2012-08-11 16:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eht/LSQ12eht_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eht/LSQ12eht_snap_51092.gif',51778995065,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,809046797,12641356,NULL,NULL,NULL,NULL),(631,472,0,'LSQ12eeq','LSQ',313.204583333333,-16.5599722222222,NULL,NULL,'2012-08-11 00:31:48',56150.0220900001,19.6694,0.105,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-11 19:45:24','2012-08-11 19:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_snap_51170.gif',50992845486,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796763210,12449425,NULL,NULL,NULL,NULL),(632,150,0,'LSQ12dmi','LSQ',22.948,-3.67463888888889,NULL,NULL,'2012-08-12 08:23:49',56151.3498800001,20.03,0.1698,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-13 02:45:26','2012-08-13 02:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dmi/LSQ12dmi_snap_51227.gif',35241776632,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550652759,8603949,NULL,NULL,NULL,NULL),(633,250,0,'LSQ12dpi','LSQ',18.8049166666667,-3.195,NULL,NULL,'2012-08-12 08:07:16',56151.3383800001,20.1555,0.1478,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-13 02:45:26','2012-08-13 02:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_snap_51269.gif',34503822819,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539122231,8423784,NULL,NULL,NULL,NULL),(634,250,0,'LSQ12dpi','LSQ',18.8045,-3.19494444444444,NULL,NULL,'2012-08-12 09:42:02',56151.4042000002,19.1118,0.0936,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-13 02:45:26','2012-08-13 02:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dpi/LSQ12dpi_snap_51270.gif',34503822819,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539122231,8423784,NULL,NULL,NULL,NULL),(635,312,0,'LSQ12dxl','LSQ',254.771166666667,16.6041388888889,NULL,NULL,'2012-08-12 01:16:08',56151.0528799999,20.6379,0.1256,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-13 02:45:26','2012-08-13 02:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dxl/LSQ12dxl_history.html','galactic variability',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dxl/LSQ12dxl_snap_51301.gif',56901257269,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,889082144,13891908,NULL,NULL,NULL,NULL),(636,381,0,'LSQ12dtf','LSQ',0.283541666666667,-6.23297222222222,NULL,NULL,'2012-08-12 07:50:21',56151.3266400001,19.8514,0.1671,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-13 02:45:26','2012-08-13 02:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtf/LSQ12dtf_snap_51202.gif',34385843399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537278803,8394981,NULL,NULL,NULL,NULL),(637,557,0,'LSQ12ege','LSQ',252.715875,2.87455555555556,NULL,NULL,'2012-08-11 23:27:46',56150.97762,18.7264,0.0686,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-13 02:45:26','2012-08-13 02:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_snap_51317.gif',55981393928,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,874709280,13667332,NULL,NULL,NULL,NULL),(638,560,0,'LSQ12ehh','LSQ',246.801458333333,2.08344444444444,NULL,NULL,'2012-08-11 23:32:51',56150.9811499999,19.5542,0.0582,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-13 02:45:26','2012-08-13 02:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_snap_51314.gif',56440595284,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881884301,13779442,NULL,NULL,NULL,NULL),(639,560,0,'LSQ12ehh','LSQ',246.801458333333,2.08341666666667,NULL,NULL,'2012-08-11 23:36:14',56150.9835000001,19.4039,0.0573,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-13 02:45:26','2012-08-13 02:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_snap_51315.gif',56440595284,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881884301,13779442,NULL,NULL,NULL,NULL),(640,611,0,'LSQ12eid','LSQ',4.40829166666667,-5.38277777777778,NULL,NULL,'2012-08-12 07:53:45',56151.3289999999,18.1278,0.0472,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-13 02:45:26','2012-08-13 02:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_snap_51246.gif',34413529726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537711401,8401740,NULL,NULL,NULL,NULL),(641,611,0,'LSQ12eid','LSQ',4.40833333333333,-5.38275,NULL,NULL,'2012-08-12 09:55:31',56151.4135599998,18.0815,0.0329,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-13 02:45:26','2012-08-13 02:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_snap_51247.gif',34413529726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537711401,8401740,NULL,NULL,NULL,NULL),(642,617,0,'LSQ12eib','LSQ',8.04095833333333,-7.38152777777778,NULL,NULL,'2012-08-12 07:58:49',56151.3325200002,19.0648,0.0548,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-13 02:45:26','2012-08-13 02:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_snap_51248.gif',34627856184,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541060252,8454066,NULL,NULL,NULL,NULL),(643,617,0,'LSQ12eib','LSQ',8.04108333333333,-7.38155555555555,NULL,NULL,'2012-08-12 09:50:28',56151.4100500001,19.0052,0.0572,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-13 02:45:26','2012-08-13 02:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_snap_51249.gif',34627856132,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541060252,8454066,NULL,NULL,NULL,NULL),(644,644,1,'LSQ12eij','LSQ',353.852416666667,-20.5113333333333,NULL,NULL,'2012-08-12 07:05:27',56151.2954600002,19.252,0.039,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-13 15:45:34','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eij/LSQ12eij_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eij/LSQ12eij_snap_51416.gif',50275077940,NULL,NULL,NULL,'2012-08-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785548092,12274188,NULL,NULL,NULL,NULL),(645,644,0,'LSQ12eij','LSQ',353.852416666667,-20.5113333333333,NULL,NULL,'2012-08-12 09:06:52',56151.37977,19.3949,0.0568,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-13 15:45:34','2012-08-13 15:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eij/LSQ12eij_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eij/LSQ12eij_snap_51417.gif',50275077940,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785548092,12274188,NULL,NULL,NULL,NULL),(646,646,1,'LSQ12eiq','LSQ',32.5290833333333,-5.57641666666667,NULL,NULL,'2011-12-15 01:07:07',55910.0466200002,20.1703,0.1134,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-13 18:45:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_snap_51525.gif',35142165909,NULL,NULL,NULL,'2011-12-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549096342,8579630,NULL,NULL,NULL,NULL),(647,646,0,'LSQ12eiq','LSQ',32.528875,-5.57658333333333,NULL,NULL,'2012-07-15 10:11:49',56123.4248799998,21.1003,0.1792,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-13 18:45:22','2012-08-13 18:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_snap_51526.gif',35142165909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549096342,8579630,NULL,NULL,NULL,NULL),(648,646,0,'LSQ12eiq','LSQ',32.5293333333333,-5.57613888888889,NULL,NULL,'2012-08-08 06:54:12',56147.2876499998,19.2592,0.1173,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-13 18:45:22','2012-08-13 18:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_snap_51527.gif',35142165909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549096342,8579630,NULL,NULL,NULL,NULL),(649,646,0,'LSQ12eiq','LSQ',32.5295,-5.57608333333333,NULL,NULL,'2012-08-10 06:59:23',56149.2912499998,18.8232,0.0573,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-13 18:45:22','2012-08-13 18:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_snap_51528.gif',35142165909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549096342,8579630,NULL,NULL,NULL,NULL),(650,646,0,'LSQ12eiq','LSQ',32.5292916666667,-5.57611111111111,NULL,NULL,'2012-08-10 08:42:25',56149.3627999998,18.9175,0.057,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-13 18:45:22','2012-08-13 18:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_snap_51529.gif',35142165909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549096342,8579630,NULL,NULL,NULL,NULL),(651,646,0,'LSQ12eiq','LSQ',32.529375,-5.57605555555556,NULL,NULL,'2012-08-12 10:04:14',56151.4196100002,18.7319,0.0396,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-13 18:45:22','2012-08-13 18:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_snap_51442.gif',35142165909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549096342,8579630,NULL,NULL,NULL,NULL),(652,646,0,'LSQ12eiq','LSQ',32.5295,-5.57608333333333,NULL,NULL,'2012-08-12 10:22:50',56151.4325299999,18.7734,0.0642,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-13 18:45:22','2012-08-13 18:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_snap_51443.gif',35142165909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549096342,8579630,NULL,NULL,NULL,NULL),(653,478,0,'PS1-12bah','Pan-STARRS1',276.247255165,22.559172102,NULL,NULL,'2012-08-09 09:24:29',56148.3920118,17.1947,0.00595375,'g',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1182459331223333000/','sn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,54568800782,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,852637512,13322461,NULL,NULL,NULL,NULL),(654,478,0,'PS1-12bah','Pan-STARRS1',276.24725563,22.5591726713,NULL,NULL,'2012-08-09 09:40:07',56148.4028648,17.1649,0.00602876,'g',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1182459331223333000/','sn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,54568800782,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,852637512,13322461,NULL,NULL,NULL,NULL),(655,496,0,'PS1-12bap','Pan-STARRS1',309.891358551,26.1569336782,NULL,NULL,'2012-08-05 07:50:25',56144.3266798,19.529,0.0443415,'i',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1203933921260925000/','sn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,55731630643,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,870806728,13606355,NULL,NULL,NULL,NULL),(656,505,0,'PS1-12bar','Pan-STARRS1',281.637648493,63.7498206219,NULL,NULL,'2012-08-10 06:18:49',56149.2630718,20.592,0.0543534,'g',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1184633011634459200/','sn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,53073322157,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,829270658,12957354,NULL,NULL,NULL,NULL),(657,505,0,'PS1-12bar','Pan-STARRS1',281.637681727,63.7498092547,NULL,NULL,'2012-08-10 06:35:28',56149.2746387,20.5615,0.0513097,'g',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1184633011634459200/','sn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,53073322157,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,829270658,12957354,NULL,NULL,NULL,NULL),(658,658,1,'PS1-12bcc','Pan-STARRS1',278.91270014,41.276081818,NULL,NULL,'2012-04-12 14:54:06',56029.6209127,19.6547,0.0721122,'z',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1183539041411633800/','agn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56029/1183539041411633800_56029.620_475221_1644_target.jpeg',NULL,NULL,54820594501,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,856571789,13383934,NULL,NULL,NULL,NULL),(659,658,0,'PS1-12bcc','Pan-STARRS1',278.912728915,41.2761115241,NULL,NULL,'2012-06-15 13:27:56',56093.5610704,19.8933,0.033209,'r',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1183539041411633800/','agn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56093/1183539041411633800_56093.561_499917_1422_target.jpeg',NULL,NULL,54820594501,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,856571789,13383934,NULL,NULL,NULL,NULL),(660,658,0,'PS1-12bcc','Pan-STARRS1',278.912737247,41.2761052827,NULL,NULL,'2012-06-15 13:43:11',56093.5716639,19.6656,0.0272068,'r',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1183539041411633800/','agn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56093/1183539041411633800_56093.571_499933_1440_target.jpeg',NULL,NULL,54820594501,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,856571789,13383934,NULL,NULL,NULL,NULL),(661,658,0,'PS1-12bcc','Pan-STARRS1',278.912719709,41.2761004118,NULL,NULL,'2012-08-07 06:41:34',56146.2788747,16.8947,0.00529018,'g',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1183539041411633800/','agn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56146/1183539041411633800_56146.278_506258_217_target.jpeg',NULL,NULL,54820594501,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,856571789,13383934,NULL,NULL,NULL,NULL),(662,658,0,'PS1-12bcc','Pan-STARRS1',278.912719733,41.276101055,NULL,NULL,'2012-08-07 06:57:34',56146.2899803,16.8581,0.00516518,'g',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1183539041411633800/','agn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56146/1183539041411633800_56146.289_506275_221_target.jpeg',NULL,NULL,54820594501,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,856571789,13383934,NULL,NULL,NULL,NULL),(663,663,0,'PS1-12bcd','Pan-STARRS1',279.17719683,78.2000463719,NULL,NULL,'2012-06-05 11:12:55',56083.4673138,18.7245,0.0567864,'z',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2019-10-11 20:38:49','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1183642521781200100/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56083/1183642521781200100_56083.467_493748_503_target.jpeg',NULL,NULL,52717045536,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,823703836,12870372,NULL,NULL,NULL,NULL),(664,663,0,'PS1-12bcd','Pan-STARRS1',279.177340945,78.2000783084,NULL,NULL,'2012-06-05 11:22:09',56083.4737183,18.6678,0.0554529,'z',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1183642521781200100/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56083/1183642521781200100_56083.473_493762_671_target.jpeg',NULL,NULL,52717045536,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,823703836,12870372,NULL,NULL,NULL,NULL),(665,663,0,'PS1-12bcd','Pan-STARRS1',279.177287806,78.2000149079,NULL,NULL,'2012-08-05 06:26:37',56144.2684847,17.3177,0.00696293,'g',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1183642521781200100/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56144/1183642521781200100_56144.268_504857_149_target.jpeg',NULL,NULL,52717045536,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,823703836,12870372,NULL,NULL,NULL,NULL),(666,663,0,'PS1-12bcd','Pan-STARRS1',279.177294399,78.2000090459,NULL,NULL,'2012-08-05 06:36:50',56144.2755894,17.3509,0.00702326,'g',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1183642521781200100/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56144/1183642521781200100_56144.275_504869_137_target.jpeg',NULL,NULL,52717045536,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,823703836,12870372,NULL,NULL,NULL,NULL),(667,663,0,'PS1-12bcd','Pan-STARRS1',279.177318113,78.2000271136,NULL,NULL,'2012-08-05 06:47:09',56144.282745,17.3831,0.00691404,'r',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1183642521781200100/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56144/1183642521781200100_56144.282_504879_193_target.jpeg',NULL,NULL,52717045536,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,823703836,12870372,NULL,NULL,NULL,NULL),(668,663,0,'PS1-12bcd','Pan-STARRS1',279.177325487,78.200025874,NULL,NULL,'2012-08-05 06:56:51',56144.2894839,17.4087,0.00704838,'r',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1183642521781200100/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56144/1183642521781200100_56144.289_504891_190_target.jpeg',NULL,NULL,52717045536,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,823703836,12870372,NULL,NULL,NULL,NULL),(669,669,1,'PS1-12bcb','Pan-STARRS1',269.041711196,46.6663274581,NULL,NULL,'2012-06-12 10:50:56',56090.4520412,19.4854,0.0227541,'r',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1175610001463958700/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56090/1175610001463958700_56090.452_497865_357_target.jpeg',NULL,NULL,57448944982,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,897639765,14025621,NULL,NULL,NULL,NULL),(670,669,0,'PS1-12bcb','Pan-STARRS1',269.041690806,46.6663171903,NULL,NULL,'2012-06-12 11:19:57',56090.4721929,19.3613,0.026236,'i',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1175610001463958700/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56090/1175610001463958700_56090.472_497897_817_target.jpeg',NULL,NULL,57448944982,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,897639765,14025621,NULL,NULL,NULL,NULL),(671,669,0,'PS1-12bcb','Pan-STARRS1',269.041705601,46.6663164229,NULL,NULL,'2012-06-12 11:35:37',56090.4830685,19.3726,0.0264857,'i',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1175610001463958700/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56090/1175610001463958700_56090.483_497913_758_target.jpeg',NULL,NULL,57448944982,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,897639765,14025621,NULL,NULL,NULL,NULL),(672,669,0,'PS1-12bcb','Pan-STARRS1',269.041707476,46.6663179729,NULL,NULL,'2012-08-06 07:59:22',56145.3329027,19.423,0.0295188,'r',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1175610001463958700/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56145/1175610001463958700_56145.332_505643_435_target.jpeg',NULL,NULL,57448944982,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,897639765,14025621,NULL,NULL,NULL,NULL),(673,669,0,'PS1-12bcb','Pan-STARRS1',269.041690537,46.6663139945,NULL,NULL,'2012-08-06 08:13:45',56145.3428887,19.3688,0.0268795,'r',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1175610001463958700/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56145/1175610001463958700_56145.342_505659_404_target.jpeg',NULL,NULL,57448944982,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,897639765,14025621,NULL,NULL,NULL,NULL),(674,674,1,'PS1-12bca','Pan-STARRS1',268.547938158,48.1243953145,NULL,NULL,'2012-06-12 11:36:34',56090.4837318,20.2413,0.052285,'i',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1175411501480727800/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56090/1175411501480727800_56090.483_497914_1097_target.jpeg',NULL,NULL,57460908137,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,897826689,14028542,NULL,NULL,NULL,NULL),(675,674,0,'PS1-12bca','Pan-STARRS1',268.547943309,48.1243776406,NULL,NULL,'2012-08-06 08:00:14',56145.3335059,19.8346,0.0432495,'r',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1175411501480727800/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56145/1175411501480727800_56145.333_505644_804_target.jpeg',NULL,NULL,57460908137,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,897826689,14028542,NULL,NULL,NULL,NULL),(676,674,0,'PS1-12bca','Pan-STARRS1',268.547914221,48.124380672,NULL,NULL,'2012-08-06 08:14:37',56145.3434896,19.7907,0.0397345,'r',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1175411501480727800/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56145/1175411501480727800_56145.343_505660_670_target.jpeg',NULL,NULL,57460908137,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,897826689,14028542,NULL,NULL,NULL,NULL),(677,677,1,'PS1-12bby','Pan-STARRS1',222.292217648,-0.860626227018,NULL,NULL,'2012-08-04 06:31:40',56143.2719939,19.7336,0.0945935,'z',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1144910130005138200/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56143/1144910130005138200_56143.271_504160_594_target.jpeg',NULL,NULL,43501814880,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,679715857,10620560,NULL,NULL,NULL,NULL),(678,677,0,'PS1-12bby','Pan-STARRS1',222.292242247,-0.860628527693,NULL,NULL,'2012-08-04 06:47:12',56143.2827794,19.7461,0.0988411,'z',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1144910130005138200/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56143/1144910130005138200_56143.282_504182_736_target.jpeg',NULL,NULL,43501814880,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,679715857,10620560,NULL,NULL,NULL,NULL),(679,679,1,'PS1-12bbz','Pan-STARRS1',265.555446112,48.8709538522,NULL,NULL,'2012-08-06 06:09:23',56145.2565195,19.6233,0.0278078,'g',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1174213311485215400/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56145/1174213311485215400_56145.256_505532_486_target.jpeg',NULL,NULL,57458255417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,897785240,14027894,NULL,NULL,NULL,NULL),(680,679,0,'PS1-12bbz','Pan-STARRS1',265.555467558,48.870962174,NULL,NULL,'2012-08-06 06:25:05',56145.2674246,19.5556,0.0249662,'g',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1174213311485215400/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56145/1174213311485215400_56145.267_505581_468_target.jpeg',NULL,NULL,57458255417,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,897785240,14027894,NULL,NULL,NULL,NULL),(681,681,1,'PS1-12bcj','Pan-STARRS1',329.483829746,-7.38859559601,NULL,NULL,'2012-06-16 14:08:32',56094.5892627,18.1297,0.0190138,'z',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1215756110072318900/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56094/1215756110072318900_56094.589_500534_295_target.jpeg',NULL,NULL,49924002725,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,780062542,12188477,NULL,NULL,NULL,NULL),(682,681,0,'PS1-12bcj','Pan-STARRS1',329.483826929,-7.38860085761,NULL,NULL,'2012-06-16 14:24:45',56094.6005275,18.1164,0.019899,'z',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1215756110072318900/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56094/1215756110072318900_56094.600_500550_324_target.jpeg',NULL,NULL,49924002725,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,780062542,12188477,NULL,NULL,NULL,NULL),(683,681,0,'PS1-12bcj','Pan-STARRS1',329.483839032,-7.38858794508,NULL,NULL,'2012-08-06 09:45:08',56145.4063466,19.0794,0.0256169,'i',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1215756110072318900/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56145/1215756110072318900_56145.406_505740_462_target.jpeg',NULL,NULL,49924002725,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,780062542,12188477,NULL,NULL,NULL,NULL),(684,681,0,'PS1-12bcj','Pan-STARRS1',329.483827625,-7.38859995126,NULL,NULL,'2012-08-06 10:00:40',56145.4171384,19.062,0.0256441,'i',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1215756110072318900/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56145/1215756110072318900_56145.417_505756_458_target.jpeg',NULL,NULL,49924002725,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,780062542,12188477,NULL,NULL,NULL,NULL),(685,685,1,'PS1-12bcg','Pan-STARRS1',34.6261005007,-0.45615004647,NULL,NULL,'2012-08-04 14:05:19',56143.5870312,18.0266,0.019525,'z',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1021830260002722100/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56143/1021830260002722100_56143.587_504653_167_target.jpeg',NULL,NULL,34914087818,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545532622,8523947,NULL,NULL,NULL,NULL),(686,685,0,'PS1-12bcg','Pan-STARRS1',34.6260979546,-0.456161057491,NULL,NULL,'2012-08-04 14:20:32',56143.5975937,18.0077,0.0177074,'z',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1021830260002722100/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56143/1021830260002722100_56143.597_504674_158_target.jpeg',NULL,NULL,34914087818,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545532622,8523947,NULL,NULL,NULL,NULL),(687,687,1,'PS1-12bcf','Pan-STARRS1',33.2973388806,0.364601268549,NULL,NULL,'2012-08-04 14:05:19',56143.5870312,19.6106,0.0653377,'z',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1021311361002152500/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56143/1021311361002152500_56143.587_504653_282_target.jpeg',NULL,NULL,66991673491,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1046744898,16355389,NULL,NULL,NULL,NULL),(688,687,0,'PS1-12bcf','Pan-STARRS1',33.2973416552,0.364640213896,NULL,NULL,'2012-08-04 14:20:32',56143.5975937,19.7071,0.066534,'z',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1021311361002152500/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56143/1021311361002152500_56143.597_504674_350_target.jpeg',NULL,NULL,66991673491,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1046744898,16355389,NULL,NULL,NULL,NULL),(689,689,1,'PS1-12bci','Pan-STARRS1',324.582515025,-6.90536756795,NULL,NULL,'2012-08-06 09:43:04',56145.4049128,19.3174,0.0279908,'i',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1213819800065419300/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56145/1213819800065419300_56145.404_505738_571_target.jpeg',NULL,NULL,49682141053,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,776283453,12129428,NULL,NULL,NULL,NULL),(691,691,1,'PS1-12bch','Pan-STARRS1',37.141866732,24.1646723684,NULL,NULL,'2012-08-08 14:28:59',56147.6034668,17.7423,0.0177358,'z',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1022834041240952800/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56147/1022834041240952800_56147.603_507239_204_target.jpeg',NULL,NULL,68086492146,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1063851439,16622678,NULL,NULL,NULL,NULL),(692,691,0,'PS1-12bch','Pan-STARRS1',37.1418617799,24.1646670354,NULL,NULL,'2012-08-08 14:46:23',56147.6155542,17.7732,0.0175042,'z',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1022834041240952800/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56147/1022834041240952800_56147.615_507261_182_target.jpeg',NULL,NULL,68086492146,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1063851439,16622678,NULL,NULL,NULL,NULL),(693,693,1,'PS1-12bce','Pan-STARRS1',16.4931066639,-8.91040709726,NULL,NULL,'2012-08-09 14:22:31',56148.5989747,17.4087,0.0121014,'z',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1010558340085437400/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56148/1010558340085437400_56148.598_507789_50_target.jpeg',NULL,NULL,35261956458,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,550968069,8608876,NULL,NULL,NULL,NULL),(694,693,0,'PS1-12bce','Pan-STARRS1',16.4931104555,-8.91040973255,NULL,NULL,'2012-08-09 14:24:01',56148.6000186,17.0589,0.00922582,'z',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1010558340085437400/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56148/1010558340085437400_56148.600_507791_85_target.jpeg',NULL,NULL,35261956458,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,550968069,8608876,NULL,NULL,NULL,NULL),(695,693,0,'PS1-12bce','Pan-STARRS1',16.4931044868,-8.91039947889,NULL,NULL,'2012-08-09 14:39:34',56148.6108198,16.2515,0.00623449,'z',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1010558340085437400/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56148/1010558340085437400_56148.610_507812_24_target.jpeg',NULL,NULL,35261956458,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,550968069,8608876,NULL,NULL,NULL,NULL),(696,693,0,'PS1-12bce','Pan-STARRS1',16.493110651,-8.91040956629,NULL,NULL,'2012-08-09 14:41:04',56148.6118616,16.4162,0.0069189,'z',NULL,NULL,NULL,NULL,'2012-08-15 14:45:21','2012-08-15 14:45:21','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1010558340085437400/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56148/1010558340085437400_56148.611_507814_60_target.jpeg',NULL,NULL,35261956458,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,550968069,8608876,NULL,NULL,NULL,NULL),(697,697,1,'LSQ12eix','LSQ',40.2240833333333,-6.53880555555556,NULL,NULL,'2012-07-11 09:51:59',56119.4111000001,20.0789,0.2139,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_51549.gif',34934513405,NULL,NULL,NULL,'2012-07-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(698,697,0,'LSQ12eix','LSQ',40.224,-6.53875,NULL,NULL,'2012-07-11 10:33:27',56119.4399000001,19.7396,0.1339,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_51550.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(699,697,0,'LSQ12eix','LSQ',40.2240833333333,-6.53883333333333,NULL,NULL,'2012-07-15 10:20:21',56123.4308000002,19.802,0.1813,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_51551.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(700,697,0,'LSQ12eix','LSQ',40.224125,-6.53883333333333,NULL,NULL,'2012-07-15 10:30:32',56123.4378800001,19.7273,0.1142,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_51552.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(701,697,0,'LSQ12eix','LSQ',40.224125,-6.53880555555556,NULL,NULL,'2012-07-17 08:53:49',56125.3707099999,19.7827,0.1199,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_51553.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(702,697,0,'LSQ12eix','LSQ',40.224125,-6.53886111111111,NULL,NULL,'2012-07-17 09:45:43',56125.4067500001,20.2572,0.1877,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_51554.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(703,697,0,'LSQ12eix','LSQ',40.2241666666667,-6.53877777777778,NULL,NULL,'2012-07-25 07:55:36',56133.3302799999,19.5773,0.1661,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_51555.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(704,697,0,'LSQ12eix','LSQ',40.224125,-6.53880555555556,NULL,NULL,'2012-07-25 09:16:12',56133.3862600001,20.0352,0.1526,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_51556.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(705,697,0,'LSQ12eix','LSQ',40.2240833333333,-6.53888888888889,NULL,NULL,'2012-07-27 08:57:19',56135.3731399998,19.6709,0.1528,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_51557.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(706,697,0,'LSQ12eix','LSQ',40.224,-6.53877777777778,NULL,NULL,'2012-07-29 07:13:50',56137.3012799998,19.6613,0.1531,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_51558.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(707,697,0,'LSQ12eix','LSQ',40.224125,-6.53875,NULL,NULL,'2012-07-29 08:54:36',56137.3712599999,19.5986,0.1523,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_51559.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(708,697,0,'LSQ12eix','LSQ',40.22425,-6.53883333333333,NULL,NULL,'2012-07-31 08:52:28',56139.3697700002,19.4617,0.2016,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_51560.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(709,697,0,'LSQ12eix','LSQ',40.2241666666667,-6.53883333333333,NULL,NULL,'2012-08-10 07:20:19',56149.3057800001,19.2537,0.1596,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_51561.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(710,697,0,'LSQ12eix','LSQ',40.224125,-6.53880555555556,NULL,NULL,'2012-08-10 08:52:46',56149.36998,19.0264,0.1399,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_51562.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(711,697,0,'LSQ12eix','LSQ',40.2240833333333,-6.53880555555556,NULL,NULL,'2012-08-12 10:12:40',56151.4254700001,19.2789,0.1361,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_51456.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(712,697,0,'LSQ12eix','LSQ',40.2241666666667,-6.53880555555556,NULL,NULL,'2012-08-12 10:17:44',56151.4289899999,19.7433,0.1335,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_51457.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(713,713,1,'LSQ12eit','LSQ',243.688958333333,-0.467166666666667,NULL,NULL,'2012-04-21 06:15:20',56038.2606500001,19.9966,0.1996,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_history.html','sne?',NULL,0.043744,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_snap_51543.gif',45506477318,NULL,NULL,NULL,'2012-04-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,711038708,11109979,NULL,NULL,NULL,NULL),(714,713,0,'LSQ12eit','LSQ',243.688875,-0.467194444444444,NULL,NULL,'2012-07-09 00:47:17',56117.03284,18.6267,0.1074,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_history.html','sne?',NULL,0.043744,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_snap_51544.gif',45506477318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,711038708,11109979,NULL,NULL,NULL,NULL),(715,713,0,'LSQ12eit','LSQ',243.688833333333,-0.46725,NULL,NULL,'2012-07-09 02:47:55',56117.1166099999,18.9786,0.1167,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_history.html','sne?',NULL,0.043744,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_snap_51545.gif',45506477318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,711038708,11109979,NULL,NULL,NULL,NULL),(716,713,0,'LSQ12eit','LSQ',243.688833333333,-0.467194444444444,NULL,NULL,'2012-07-23 00:21:31',56131.0149500002,19.0251,0.1024,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_history.html','sne?',NULL,0.043744,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_snap_51546.gif',45506477318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,711038708,11109979,NULL,NULL,NULL,NULL),(717,713,0,'LSQ12eit','LSQ',243.688833333333,-0.467138888888889,NULL,NULL,'2012-07-27 00:05:18',56135.0036900002,18.3516,0.1485,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_history.html','sne?',NULL,0.043744,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_snap_51547.gif',45506477318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,711038708,11109979,NULL,NULL,NULL,NULL),(718,713,0,'LSQ12eit','LSQ',243.68875,-0.46725,NULL,NULL,'2012-08-08 01:26:17',56147.0599199999,18.7995,0.1164,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_history.html','sne?',NULL,0.043744,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_snap_51548.gif',45506477318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,711038708,11109979,NULL,NULL,NULL,NULL),(719,713,0,'LSQ12eit','LSQ',243.688208333333,-0.467388888888889,NULL,NULL,'2012-08-10 01:35:34',56149.0663700001,19.5241,0.2022,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_history.html','sne?',NULL,0.043744,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_snap_51563.gif',45506477326,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,711038708,11109979,NULL,NULL,NULL,NULL),(720,713,0,'LSQ12eit','LSQ',243.688916666667,-0.467305555555556,NULL,NULL,'2012-08-11 23:39:40',56150.9858800001,19.2907,0.1242,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_history.html','sne?',NULL,0.043744,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_snap_51448.gif',45506477318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,711038708,11109979,NULL,NULL,NULL,NULL),(721,713,0,'LSQ12eit','LSQ',243.688916666667,-0.467194444444444,NULL,NULL,'2012-08-11 23:52:50',56150.9950299999,19.2782,0.1314,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_history.html','sne?',NULL,0.043744,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eit/LSQ12eit_snap_51449.gif',45506477318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,711038708,11109979,NULL,NULL,NULL,NULL),(722,722,1,'LSQ12eir','LSQ',34.10075,-3.01941666666667,NULL,NULL,'2012-08-10 07:01:05',56149.2924199998,18.7014,0.0862,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_snap_51530.gif',35133634952,NULL,NULL,NULL,'2012-08-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548963046,8577547,NULL,NULL,NULL,NULL),(723,722,0,'LSQ12eir','LSQ',34.1007083333333,-3.01941666666667,NULL,NULL,'2012-08-10 08:44:07',56149.3639799999,18.7626,0.0693,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_snap_51531.gif',35133634952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548963046,8577547,NULL,NULL,NULL,NULL),(724,722,0,'LSQ12eir','LSQ',34.10075,-3.01944444444444,NULL,NULL,'2012-08-12 10:05:56',56151.4207899999,18.7087,0.0728,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_snap_51444.gif',35133634952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548963046,8577547,NULL,NULL,NULL,NULL),(725,722,0,'LSQ12eir','LSQ',34.10075,-3.01936111111111,NULL,NULL,'2012-08-12 10:14:21',56151.4266400002,18.6164,0.0751,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_snap_51445.gif',35133634952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548963046,8577547,NULL,NULL,NULL,NULL),(726,726,1,'LSQ12eil','LSQ',1.67291666666667,-6.28088888888889,NULL,NULL,'2012-08-10 08:25:41',56149.3511700002,19.9726,0.2049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eil/LSQ12eil_history.html','sne - young ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eil/LSQ12eil_snap_51475.gif',34387815364,NULL,NULL,NULL,'2012-08-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537309615,8395462,NULL,NULL,NULL,NULL),(727,726,0,'LSQ12eil','LSQ',1.672875,-6.28083333333333,NULL,NULL,'2012-08-12 07:52:03',56151.3278199998,20.1364,0.1286,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eil/LSQ12eil_history.html','sne - young ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eil/LSQ12eil_snap_51432.gif',34387815364,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537309615,8395462,NULL,NULL,NULL,NULL),(728,726,0,'LSQ12eil','LSQ',1.67279166666667,-6.28086111111111,NULL,NULL,'2012-08-12 09:57:12',56151.4147299998,19.84,0.167,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eil/LSQ12eil_history.html','sne - young ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eil/LSQ12eil_snap_51433.gif',34387815364,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537309615,8395462,NULL,NULL,NULL,NULL),(729,729,1,'LSQ12eig','LSQ',335.277125,-16.6261111111111,NULL,NULL,'2012-07-08 05:45:49',56116.24016,19.0668,0.1654,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eig/LSQ12eig_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eig/LSQ12eig_snap_51423.gif',50238735843,NULL,NULL,NULL,'2012-07-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784980247,12265316,NULL,NULL,NULL,NULL),(730,729,0,'LSQ12eig','LSQ',335.27675,-16.6262777777778,NULL,NULL,'2012-07-30 03:26:02',56138.1430899999,20.6533,0.2102,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eig/LSQ12eig_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eig/LSQ12eig_snap_51424.gif',50238735841,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784980247,12265316,NULL,NULL,NULL,NULL),(731,729,0,'LSQ12eig','LSQ',335.276833333333,-16.6261111111111,NULL,NULL,'2012-08-11 01:55:30',56150.0802099998,21.0119,0.1339,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eig/LSQ12eig_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eig/LSQ12eig_snap_51425.gif',50238735841,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784980247,12265316,NULL,NULL,NULL,NULL),(732,729,0,'LSQ12eig','LSQ',335.276291666667,-16.6262777777778,NULL,NULL,'2012-08-12 01:38:03',56151.0680999998,21.236,0.1231,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eig/LSQ12eig_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eig/LSQ12eig_snap_51409.gif',50238735841,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784980247,12265316,NULL,NULL,NULL,NULL),(733,729,0,'LSQ12eig','LSQ',335.276625,-16.6263055555556,NULL,NULL,'2012-08-12 05:46:40',56151.2407499999,20.0219,0.0737,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eig/LSQ12eig_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eig/LSQ12eig_snap_51410.gif',50238735841,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784980247,12265316,NULL,NULL,NULL,NULL),(734,734,1,'LSQ12eif','LSQ',335.979791666667,-17.6941944444444,NULL,NULL,'2012-08-11 01:55:30',56150.0802099998,19.6883,0.1306,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eif/LSQ12eif_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eif/LSQ12eif_snap_51420.gif',50239067131,NULL,NULL,NULL,'2012-08-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784985423,12265397,NULL,NULL,NULL,NULL),(735,734,0,'LSQ12eif','LSQ',335.979666666667,-17.6941666666667,NULL,NULL,'2012-08-11 04:23:24',56150.1829200001,20.2793,0.1817,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eif/LSQ12eif_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eif/LSQ12eif_snap_51421.gif',50239067131,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784985423,12265397,NULL,NULL,NULL,NULL),(736,734,0,'LSQ12eif','LSQ',335.979833333333,-17.6941666666667,NULL,NULL,'2012-08-12 01:38:03',56151.0680999998,19.606,0.1193,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eif/LSQ12eif_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eif/LSQ12eif_snap_51407.gif',50239067131,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784985423,12265397,NULL,NULL,NULL,NULL),(737,734,0,'LSQ12eif','LSQ',335.979958333333,-17.69425,NULL,NULL,'2012-08-12 03:38:17',56151.1515899999,18.6552,0.1161,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eif/LSQ12eif_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eif/LSQ12eif_snap_51422.gif',50239067131,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784985423,12265397,NULL,NULL,NULL,NULL),(738,734,0,'LSQ12eif','LSQ',335.979625,-17.69425,NULL,NULL,'2012-08-12 05:46:40',56151.2407499999,18.6832,0.1086,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eif/LSQ12eif_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eif/LSQ12eif_snap_51408.gif',50239067131,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784985423,12265397,NULL,NULL,NULL,NULL),(739,739,1,'LSQ12eie','LSQ',336.09575,-17.6378055555556,NULL,NULL,'2012-07-06 05:55:13',56114.2466799999,18.6433,0.2059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eie/LSQ12eie_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eie/LSQ12eie_snap_51418.gif',50239093071,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784985829,12265403,NULL,NULL,NULL,NULL),(740,739,0,'LSQ12eie','LSQ',336.095666666667,-17.6379444444444,NULL,NULL,'2012-08-11 04:23:24',56150.1829200001,19.5761,0.0981,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eie/LSQ12eie_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eie/LSQ12eie_snap_51419.gif',50239093069,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784985829,12265403,NULL,NULL,NULL,NULL),(741,739,0,'LSQ12eie','LSQ',336.095625,-17.6377777777778,NULL,NULL,'2012-08-12 01:38:03',56151.0680999998,19.9493,0.0947,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eie/LSQ12eie_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eie/LSQ12eie_snap_51405.gif',50239093071,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784985829,12265403,NULL,NULL,NULL,NULL),(742,739,0,'LSQ12eie','LSQ',336.095625,-17.6378333333333,NULL,NULL,'2012-08-12 03:38:17',56151.1515899999,19.6264,0.1228,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 15:45:25','2012-08-15 15:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eie/LSQ12eie_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eie/LSQ12eie_snap_51406.gif',50239093069,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784985829,12265403,NULL,NULL,NULL,NULL),(743,472,0,'LSQ12eeq','LSQ',313.204458333333,-16.5600277777778,NULL,NULL,'2012-08-15 00:47:53',56154.0332599999,20.1742,0.161,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 17:45:31','2012-08-15 17:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_snap_51582.gif',50992845486,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796763210,12449425,NULL,NULL,NULL,NULL),(744,644,0,'LSQ12eij','LSQ',353.852458333333,-20.5113333333333,NULL,NULL,'2012-08-15 02:48:52',56154.1172699998,19.4069,0.0558,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-15 17:45:31','2012-08-15 17:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eij/LSQ12eij_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eij/LSQ12eij_snap_51578.gif',50275077940,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785548092,12274188,NULL,NULL,NULL,NULL),(745,745,1,'LSQ12ejl','LSQ',301.377,-19.8933333333333,NULL,NULL,'2012-07-26 00:37:55',56134.0263399999,19.9526,0.0943,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-16 00:15:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejl/LSQ12ejl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejl/LSQ12ejl_snap_51700.gif',50813731843,NULL,NULL,NULL,'2012-07-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,793964560,12405696,NULL,NULL,NULL,NULL),(746,745,0,'LSQ12ejl','LSQ',301.377125,-19.8933333333333,NULL,NULL,'2012-08-14 23:55:50',56153.9971099999,20.8713,0.1479,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-16 00:15:25','2012-08-16 00:15:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejl/LSQ12ejl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejl/LSQ12ejl_snap_51679.gif',50813731843,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,793964560,12405696,NULL,NULL,NULL,NULL),(747,745,0,'LSQ12ejl','LSQ',301.377,-19.8934444444444,NULL,NULL,'2012-08-15 03:56:49',56154.1644600001,21.0473,0.1365,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-16 00:15:25','2012-08-16 00:15:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejl/LSQ12ejl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejl/LSQ12ejl_snap_51680.gif',50813731843,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,793964560,12405696,NULL,NULL,NULL,NULL),(748,748,1,'LSQ12eji','LSQ',301.496916666667,-19.33375,NULL,NULL,'2012-08-14 23:55:50',56153.9971099999,17.6034,0.0107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-16 00:15:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eji/LSQ12eji_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eji/LSQ12eji_snap_51672.gif',50810834511,NULL,NULL,NULL,'2012-07-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793919289,12404988,NULL,NULL,NULL,NULL),(749,748,0,'LSQ12eji','LSQ',301.496958333333,-19.33375,NULL,NULL,'2012-08-15 01:56:09',56154.0806700001,17.6481,0.0141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-16 00:15:25','2012-08-16 00:15:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eji/LSQ12eji_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eji/LSQ12eji_snap_51674.gif',50810834511,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793919289,12404988,NULL,NULL,NULL,NULL),(750,748,0,'LSQ12eji','LSQ',301.497,-19.33375,NULL,NULL,'2012-08-15 03:56:49',56154.1644600001,17.6048,0.0118,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-16 00:15:25','2012-08-16 00:15:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eji/LSQ12eji_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eji/LSQ12eji_snap_51673.gif',50810834511,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793919289,12404988,NULL,NULL,NULL,NULL),(751,751,0,'LSQ12ejf','LSQ',300.237916666667,-17.8160555555556,NULL,NULL,'2012-07-26 00:34:14',56134.0237799999,20.2593,0.1475,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-16 00:15:25','2019-12-24 20:38:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_history.html','sn ',NULL,0.65,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_snap_51694.gif',47978099725,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,749657808,11713403,NULL,NULL,NULL,NULL),(752,751,0,'LSQ12ejf','LSQ',300.237958333333,-17.8161111111111,NULL,NULL,'2012-07-26 02:48:03',56134.1167100002,19.8032,0.0967,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-16 00:15:25','2012-08-16 00:15:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_history.html','sn ',NULL,0.65,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_snap_51695.gif',47978099725,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,749657808,11713403,NULL,NULL,NULL,NULL),(753,751,0,'LSQ12ejf','LSQ',300.23775,-17.8160555555556,NULL,NULL,'2012-07-26 06:08:38',56134.2560000001,19.6469,0.0914,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-16 00:15:25','2012-08-16 00:15:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_history.html','sn ',NULL,0.65,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_snap_51696.gif',47978099721,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,749657808,11713403,NULL,NULL,NULL,NULL),(754,751,0,'LSQ12ejf','LSQ',300.23775,-17.816,NULL,NULL,'2012-08-14 23:52:08',56153.9945399999,18.726,0.0466,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-16 00:15:25','2012-08-16 00:15:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_history.html','sn ',NULL,0.65,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_snap_51665.gif',47978099721,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,749657808,11713403,NULL,NULL,NULL,NULL),(755,751,0,'LSQ12ejf','LSQ',300.237875,-17.8160277777778,NULL,NULL,'2012-08-15 01:52:28',56154.0781100001,18.6771,0.0499,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-16 00:15:25','2012-08-16 00:15:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_history.html','sn ',NULL,0.65,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_snap_51667.gif',47978099721,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,749657808,11713403,NULL,NULL,NULL,NULL),(756,751,0,'LSQ12ejf','LSQ',300.23775,-17.8160277777778,NULL,NULL,'2012-08-15 03:53:07',56154.1618900001,19.0694,0.0834,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-16 00:15:25','2012-08-16 00:15:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_history.html','sn ',NULL,0.65,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_snap_51666.gif',47978099721,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,749657808,11713403,NULL,NULL,NULL,NULL),(757,757,1,'LSQ12ejd','LSQ',300.880208333333,-19.8604166666667,NULL,NULL,'2012-07-26 02:48:03',56134.1167100002,20.8986,0.1405,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-16 00:15:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_history.html','sn?',NULL,0.083168,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_snap_51691.gif',50813697248,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793964019,12405687,NULL,NULL,NULL,NULL),(758,757,0,'LSQ12ejd','LSQ',300.880375,-19.8605555555556,NULL,NULL,'2012-07-26 06:08:38',56134.2560000001,20.165,0.0854,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-16 00:15:25','2012-08-16 00:15:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_history.html','sn?',NULL,0.083168,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_snap_51692.gif',50813697251,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793964019,12405687,NULL,NULL,NULL,NULL),(759,757,0,'LSQ12ejd','LSQ',300.880416666667,-19.8605,NULL,NULL,'2012-08-14 23:52:08',56153.9945399999,20.8325,0.1431,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-16 00:15:25','2012-08-16 00:15:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_history.html','sn?',NULL,0.083168,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_snap_51660.gif',50813697251,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793964019,12405687,NULL,NULL,NULL,NULL),(760,757,0,'LSQ12ejd','LSQ',300.880666666667,-19.8604166666667,NULL,NULL,'2012-08-15 01:52:28',56154.0781100001,20.5678,0.123,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-16 00:15:25','2012-08-16 00:15:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_history.html','sn?',NULL,0.083168,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_snap_51662.gif',50813697251,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793964019,12405687,NULL,NULL,NULL,NULL),(761,757,0,'LSQ12ejd','LSQ',300.88075,-19.8604166666667,NULL,NULL,'2012-08-15 03:53:07',56154.1618900001,19.9959,0.1566,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-16 00:15:25','2012-08-16 00:15:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_history.html','sn?',NULL,0.083168,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_snap_51661.gif',50813697251,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793964019,12405687,NULL,NULL,NULL,NULL),(762,762,1,'PSNJ19371572-4218271','TOCP',294.315504166667,-42.3075388888889,NULL,NULL,'2012-08-12 00:00:00',56151,17.2,0.5,'unfiltered',NULL,NULL,NULL,NULL,'2012-08-18 16:15:28','2020-04-28 09:08:48',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'http://www.das.uchile.cl/~gpignata/pessto/PSNJ19371572-4218271.gif',51268024318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,801062879,12516607,NULL,NULL,NULL,NULL),(763,644,0,'LSQ12eij','LSQ',353.8525,-20.5113055555556,NULL,NULL,'2012-08-18 08:44:28',56157.3642199999,19.4013,0.0521,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 17:45:28','2012-08-18 17:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eij/LSQ12eij_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eij/LSQ12eij_snap_51719.gif',50275077940,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785548092,12274188,NULL,NULL,NULL,NULL),(764,748,0,'LSQ12eji','LSQ',301.497,-19.3337777777778,NULL,NULL,'2012-08-18 04:45:41',56157.1984000001,17.8642,0.0136,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 17:45:28','2012-08-18 17:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eji/LSQ12eji_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eji/LSQ12eji_snap_51724.gif',50810834511,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793919289,12404988,NULL,NULL,NULL,NULL),(765,751,0,'LSQ12ejf','LSQ',300.23775,-17.8160555555556,NULL,NULL,'2012-08-18 04:42:00',56157.1958400002,18.3247,0.0287,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 17:45:28','2012-08-18 17:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_history.html','sn ',NULL,0.65,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_snap_51721.gif',47978099721,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,749657808,11713403,NULL,NULL,NULL,NULL),(766,757,0,'LSQ12ejd','LSQ',300.88075,-19.8602222222222,NULL,NULL,'2012-08-18 04:42:00',56157.1958400002,20.419,0.1024,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 17:45:28','2012-08-18 17:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_history.html','sn?',NULL,0.083168,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_snap_51726.gif',50813697251,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793964019,12405687,NULL,NULL,NULL,NULL),(767,767,1,'LSQ12ejs','LSQ',351.870208333333,-5.38625,NULL,NULL,'2012-08-10 10:00:40',56149.41714,19.0835,0.1638,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejs/LSQ12ejs_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejs/LSQ12ejs_snap_51789.gif',49638442806,NULL,NULL,NULL,'2012-08-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775600668,12118760,NULL,NULL,NULL,NULL),(768,767,0,'LSQ12ejs','LSQ',351.8705,-5.38608333333333,NULL,NULL,'2012-08-15 03:22:58',56154.1409499999,19.8722,0.1273,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejs/LSQ12ejs_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejs/LSQ12ejs_snap_51790.gif',49638442788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775600668,12118760,NULL,NULL,NULL,NULL),(769,767,0,'LSQ12ejs','LSQ',351.870541666667,-5.38611111111111,NULL,NULL,'2012-08-18 08:09:52',56157.3401899999,19.6359,0.1049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejs/LSQ12ejs_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejs/LSQ12ejs_snap_51759.gif',49638442788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775600668,12118760,NULL,NULL,NULL,NULL),(770,767,0,'LSQ12ejs','LSQ',351.870166666667,-5.38616666666667,NULL,NULL,'2012-08-18 09:58:35',56157.4156900002,20.5912,0.1503,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejs/LSQ12ejs_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejs/LSQ12ejs_snap_51760.gif',49638442807,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775600668,12118760,NULL,NULL,NULL,NULL),(771,771,1,'LSQ12ejr','LSQ',351.924375,-5.08997222222222,NULL,NULL,'2012-07-05 05:30:46',56113.2297100001,17.445,0.1193,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_snap_51804.gif',49638300038,NULL,NULL,NULL,'2012-06-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775598438,12118725,NULL,NULL,NULL,NULL),(772,771,0,'LSQ12ejr','LSQ',351.924833333333,-5.09013888888889,NULL,NULL,'2012-07-17 10:03:40',56125.41922,19.9565,0.1491,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_snap_51781.gif',49638300039,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775598438,12118725,NULL,NULL,NULL,NULL),(773,771,0,'LSQ12ejr','LSQ',351.924791666667,-5.09016666666667,NULL,NULL,'2012-07-27 04:07:33',56135.17191,19.6272,0.199,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_snap_51782.gif',49638300038,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775598438,12118725,NULL,NULL,NULL,NULL),(774,771,0,'LSQ12ejr','LSQ',351.925208333333,-5.09030555555556,NULL,NULL,'2012-07-29 03:54:59',56137.1631900002,17.3265,0.0347,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_snap_51783.gif',49638300039,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775598438,12118725,NULL,NULL,NULL,NULL),(775,771,0,'LSQ12ejr','LSQ',351.924791666667,-5.09016666666667,NULL,NULL,'2012-07-31 09:01:29',56139.37604,19.224,0.1922,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_snap_51784.gif',49638300038,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775598438,12118725,NULL,NULL,NULL,NULL),(776,771,0,'LSQ12ejr','LSQ',351.925041666667,-5.09030555555556,NULL,NULL,'2012-08-08 09:09:57',56147.38191,18.8905,0.1599,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_snap_51785.gif',49638300039,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775598438,12118725,NULL,NULL,NULL,NULL),(777,771,0,'LSQ12ejr','LSQ',351.9245,-5.09011111111111,NULL,NULL,'2012-08-10 09:35:24',56149.39959,19.9172,0.1838,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_snap_51805.gif',49638300038,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775598438,12118725,NULL,NULL,NULL,NULL),(778,771,0,'LSQ12ejr','LSQ',351.925,-5.09022222222222,NULL,NULL,'2012-08-10 10:00:40',56149.41714,19.4178,0.1798,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_snap_51786.gif',49638300039,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775598438,12118725,NULL,NULL,NULL,NULL),(779,771,0,'LSQ12ejr','LSQ',351.92475,-5.09019444444444,NULL,NULL,'2012-08-15 03:22:58',56154.1409499999,19.5406,0.1077,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_snap_51787.gif',49638300038,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775598438,12118725,NULL,NULL,NULL,NULL),(780,771,0,'LSQ12ejr','LSQ',351.925375,-5.09011111111111,NULL,NULL,'2012-08-18 05:47:29',56157.24131,20.4766,0.1612,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_snap_51757.gif',49638300037,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775598438,12118725,NULL,NULL,NULL,NULL),(781,771,0,'LSQ12ejr','LSQ',351.925083333333,-5.09013888888889,NULL,NULL,'2012-08-18 08:09:52',56157.3401899999,19.7056,0.0924,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_snap_51758.gif',49638300037,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775598438,12118725,NULL,NULL,NULL,NULL),(782,771,0,'LSQ12ejr','LSQ',351.924916666667,-5.08986111111111,NULL,NULL,'2012-08-18 09:58:35',56157.4156900002,20.4594,0.15,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_snap_51788.gif',49638300044,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775598438,12118725,NULL,NULL,NULL,NULL),(783,783,1,'LSQ12ejq','LSQ',353.857,-6.95041666666667,NULL,NULL,'2012-07-07 07:21:43',56115.30675,19.985,0.1533,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejq/LSQ12ejq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejq/LSQ12ejq_snap_51761.gif',49647415926,NULL,NULL,NULL,'2012-07-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,775740873,12120951,NULL,NULL,NULL,NULL),(784,783,0,'LSQ12ejq','LSQ',353.857708333333,-6.95,NULL,NULL,'2012-08-10 10:00:40',56149.41714,18.4005,0.0717,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejq/LSQ12ejq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejq/LSQ12ejq_snap_51762.gif',49647415908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,775740873,12120951,NULL,NULL,NULL,NULL),(785,783,0,'LSQ12ejq','LSQ',353.857666666667,-6.94988888888889,NULL,NULL,'2012-08-15 03:22:58',56154.1409499999,20.8853,0.1772,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejq/LSQ12ejq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejq/LSQ12ejq_snap_51763.gif',49647415908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,775740873,12120951,NULL,NULL,NULL,NULL),(786,783,0,'LSQ12ejq','LSQ',353.857791666667,-6.94986111111111,NULL,NULL,'2012-08-18 08:09:52',56157.3401899999,20.7721,0.1091,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejq/LSQ12ejq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejq/LSQ12ejq_snap_51755.gif',49647415908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,775740873,12120951,NULL,NULL,NULL,NULL),(787,783,0,'LSQ12ejq','LSQ',353.8575,-6.94986111111111,NULL,NULL,'2012-08-18 09:58:35',56157.4156900002,21.0608,0.1386,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejq/LSQ12ejq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejq/LSQ12ejq_snap_51756.gif',49647415924,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,775740873,12120951,NULL,NULL,NULL,NULL),(788,788,1,'LSQ12ejo','LSQ',353.49225,-3.31555555555556,NULL,NULL,'2012-07-17 10:03:40',56125.41922,20.5937,0.1863,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_snap_51776.gif',49414528108,NULL,NULL,NULL,'2012-07-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772102001,12064093,NULL,NULL,NULL,NULL),(789,788,0,'LSQ12ejo','LSQ',353.492041666667,-3.31552777777778,NULL,NULL,'2012-07-27 06:07:50',56135.2554500001,20.7211,0.1676,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_snap_51777.gif',49414528108,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772102001,12064093,NULL,NULL,NULL,NULL),(790,788,0,'LSQ12ejo','LSQ',353.492333333333,-3.31569444444444,NULL,NULL,'2012-08-08 07:28:52',56147.3117200001,20.2049,0.1455,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_snap_51778.gif',49414528108,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772102001,12064093,NULL,NULL,NULL,NULL),(791,788,0,'LSQ12ejo','LSQ',353.492375,-3.31563888888889,NULL,NULL,'2012-08-10 10:00:40',56149.41714,20.0615,0.2071,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_snap_51779.gif',49414528108,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772102001,12064093,NULL,NULL,NULL,NULL),(792,788,0,'LSQ12ejo','LSQ',353.492083333333,-3.31561111111111,NULL,NULL,'2012-08-15 03:22:58',56154.1409499999,20.8043,0.1641,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_snap_51780.gif',49414528108,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772102001,12064093,NULL,NULL,NULL,NULL),(793,788,0,'LSQ12ejo','LSQ',353.49225,-3.31558333333333,NULL,NULL,'2012-08-18 05:47:29',56157.24131,20.1514,0.1057,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_snap_51751.gif',49414528108,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772102001,12064093,NULL,NULL,NULL,NULL),(794,788,0,'LSQ12ejo','LSQ',353.492208333333,-3.31555555555556,NULL,NULL,'2012-08-18 08:09:52',56157.3401899999,20.1501,0.1201,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_snap_51752.gif',49414528108,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772102001,12064093,NULL,NULL,NULL,NULL),(795,795,1,'LSQ12ejn','LSQ',303.86825,-22.37,NULL,NULL,'2012-07-11 01:50:51',56119.0769799999,20.755,0.1872,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_snap_51764.gif',50806837566,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793856836,12404013,NULL,NULL,NULL,NULL),(796,795,0,'LSQ12ejn','LSQ',303.8685,-22.37,NULL,NULL,'2012-07-11 03:45:38',56119.1566900001,20.9305,0.1361,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_snap_51765.gif',50806837566,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793856836,12404013,NULL,NULL,NULL,NULL),(797,795,0,'LSQ12ejn','LSQ',303.868458333333,-22.3699722222222,NULL,NULL,'2012-07-13 03:22:01',56121.14029,21.452,0.1872,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_snap_51766.gif',50806837566,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793856836,12404013,NULL,NULL,NULL,NULL),(798,795,0,'LSQ12ejn','LSQ',303.868541666667,-22.3700277777778,NULL,NULL,'2012-07-13 05:43:12',56121.2383400002,20.8909,0.161,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_snap_51767.gif',50806837566,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793856836,12404013,NULL,NULL,NULL,NULL),(799,795,0,'LSQ12ejn','LSQ',303.868458333333,-22.37,NULL,NULL,'2012-07-16 08:14:19',56124.3432800001,21.0755,0.1619,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_snap_51768.gif',50806837566,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793856836,12404013,NULL,NULL,NULL,NULL),(800,795,0,'LSQ12ejn','LSQ',303.868333333333,-22.3699444444444,NULL,NULL,'2012-07-18 00:58:27',56126.0405999999,21.0432,0.1626,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_snap_51769.gif',50806837566,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793856836,12404013,NULL,NULL,NULL,NULL),(801,795,0,'LSQ12ejn','LSQ',303.868166666667,-22.3699722222222,NULL,NULL,'2012-07-18 05:32:04',56126.23061,20.9159,0.1484,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_snap_51770.gif',50806837566,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793856836,12404013,NULL,NULL,NULL,NULL),(802,795,0,'LSQ12ejn','LSQ',303.868916666667,-22.3700555555556,NULL,NULL,'2012-07-25 00:38:00',56133.0263899998,20.8426,0.157,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_snap_51803.gif',50806837566,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793856836,12404013,NULL,NULL,NULL,NULL),(803,795,0,'LSQ12ejn','LSQ',303.868541666667,-22.3699166666667,NULL,NULL,'2012-07-25 02:40:03',56133.1111499998,20.9183,0.1382,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_snap_51771.gif',50806837566,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793856836,12404013,NULL,NULL,NULL,NULL),(804,795,0,'LSQ12ejn','LSQ',303.8685,-22.3699166666667,NULL,NULL,'2012-07-25 05:34:03',56133.2319899998,21.079,0.2014,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_snap_51772.gif',50806837566,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793856836,12404013,NULL,NULL,NULL,NULL),(805,795,0,'LSQ12ejn','LSQ',303.868416666667,-22.37,NULL,NULL,'2012-07-26 01:03:31',56134.0441200002,20.4578,0.2013,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_snap_51773.gif',50806837566,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793856836,12404013,NULL,NULL,NULL,NULL),(806,795,0,'LSQ12ejn','LSQ',303.868416666667,-22.3699166666667,NULL,NULL,'2012-07-26 06:58:01',56134.2903,20.9974,0.1939,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_snap_51774.gif',50806837566,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793856836,12404013,NULL,NULL,NULL,NULL),(807,795,0,'LSQ12ejn','LSQ',303.8685,-22.37,NULL,NULL,'2012-08-12 01:26:37',56151.0601599999,21.0436,0.2021,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_snap_51775.gif',50806837566,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793856836,12404013,NULL,NULL,NULL,NULL),(808,795,0,'LSQ12ejn','LSQ',303.86825,-22.3699722222222,NULL,NULL,'2012-08-18 04:38:17',56157.1932600001,21.0204,0.139,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_snap_51749.gif',50806837566,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793856836,12404013,NULL,NULL,NULL,NULL),(809,795,0,'LSQ12ejn','LSQ',303.868,-22.3696944444444,NULL,NULL,'2012-08-18 07:21:48',56157.30681,20.0972,0.121,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-18 23:45:26','2012-08-18 23:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_snap_51750.gif',50806837567,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793856836,12404013,NULL,NULL,NULL,NULL),(810,771,0,'LSQ12ejr','LSQ',351.92425,-5.09008333333333,NULL,NULL,'2012-07-29 05:57:16',56137.24811,19.5213,0.2146,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_snap_51829.gif',49638300038,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775598438,12118725,NULL,NULL,NULL,NULL),(811,811,1,'LSQ12ejy','LSQ',355.411291666667,-22.7780555555556,NULL,NULL,'2012-08-12 04:45:39',56151.1983699999,18.9493,0.1231,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_51825.gif',50274702770,NULL,NULL,NULL,'2012-08-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(812,811,0,'LSQ12ejy','LSQ',355.41125,-22.7780833333333,NULL,NULL,'2012-08-12 07:05:27',56151.2954600002,18.5744,0.0964,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_51826.gif',50274702770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(813,811,0,'LSQ12ejy','LSQ',355.411333333333,-22.7780555555556,NULL,NULL,'2012-08-12 09:06:52',56151.37977,18.6395,0.1118,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_51827.gif',50274702741,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(814,811,0,'LSQ12ejy','LSQ',355.411333333333,-22.7780555555556,NULL,NULL,'2012-08-15 02:48:52',56154.1172699998,18.4037,0.0887,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_51828.gif',50274702741,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(815,811,0,'LSQ12ejy','LSQ',355.411416666667,-22.7781388888889,NULL,NULL,'2012-08-18 06:29:34',56157.2705399999,18.4105,0.0781,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_51801.gif',50274702741,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(816,811,0,'LSQ12ejy','LSQ',355.411291666667,-22.7781388888889,NULL,NULL,'2012-08-18 08:44:28',56157.3642199999,18.3876,0.0835,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_51802.gif',50274702770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(817,817,1,'LSQ12ejx','LSQ',355.038666666667,-21.8748055555556,NULL,NULL,'2012-08-12 04:45:39',56151.1983699999,21.2119,0.1401,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_snap_51821.gif',50276293318,NULL,NULL,NULL,'2012-08-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,785567083,12274485,NULL,NULL,NULL,NULL),(818,817,0,'LSQ12ejx','LSQ',355.038625,-21.8748055555556,NULL,NULL,'2012-08-12 07:05:27',56151.2954600002,21.6411,0.1481,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_snap_51822.gif',50276293318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,785567083,12274485,NULL,NULL,NULL,NULL),(819,817,0,'LSQ12ejx','LSQ',355.038583333333,-21.8748055555556,NULL,NULL,'2012-08-12 09:06:52',56151.37977,21.1353,0.1453,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_snap_51823.gif',50276293318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,785567083,12274485,NULL,NULL,NULL,NULL),(820,817,0,'LSQ12ejx','LSQ',355.038583333333,-21.8748055555556,NULL,NULL,'2012-08-15 02:48:52',56154.1172699998,21.0926,0.1182,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_snap_51824.gif',50276293318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,785567083,12274485,NULL,NULL,NULL,NULL),(821,817,0,'LSQ12ejx','LSQ',355.038666666667,-21.8747777777778,NULL,NULL,'2012-08-18 06:29:34',56157.2705399999,20.8499,0.1237,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_snap_51799.gif',50276293318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,785567083,12274485,NULL,NULL,NULL,NULL),(822,817,0,'LSQ12ejx','LSQ',355.038625,-21.8747777777778,NULL,NULL,'2012-08-18 08:44:28',56157.3642199999,20.6644,0.1035,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_snap_51800.gif',50276293318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,785567083,12274485,NULL,NULL,NULL,NULL),(823,823,1,'LSQ12ejw','LSQ',357.600875,-24.6793055555556,NULL,NULL,'2012-08-12 09:06:52',56151.37977,20.0248,0.166,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_snap_51820.gif',50012664937,NULL,NULL,NULL,'2012-08-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,781447889,12210123,NULL,NULL,NULL,NULL),(824,823,0,'LSQ12ejw','LSQ',357.601,-24.6793888888889,NULL,NULL,'2012-08-18 06:29:34',56157.2705399999,20.0078,0.1433,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_snap_51797.gif',50012664937,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,781447889,12210123,NULL,NULL,NULL,NULL),(825,823,0,'LSQ12ejw','LSQ',357.601083333333,-24.6792222222222,NULL,NULL,'2012-08-18 08:44:28',56157.3642199999,16.948,0.0669,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_snap_51798.gif',50012665062,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,781447891,12210123,NULL,NULL,NULL,NULL),(826,826,1,'LSQ12eju','LSQ',350.748916666667,-7.43313888888889,NULL,NULL,'2012-07-17 09:23:43',56125.3914800002,20.2836,0.2152,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_51808.gif',49649863586,NULL,NULL,NULL,'2012-07-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(827,826,0,'LSQ12eju','LSQ',350.748958333333,-7.43333333333333,NULL,NULL,'2012-07-17 10:03:40',56125.41922,20.2937,0.2029,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_51809.gif',49649863586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(828,826,0,'LSQ12eju','LSQ',350.748916666667,-7.43311111111111,NULL,NULL,'2012-07-27 06:07:50',56135.2554500001,19.9539,0.1269,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_51810.gif',49649863617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779119,12121548,NULL,NULL,NULL,NULL),(829,826,0,'LSQ12eju','LSQ',350.748916666667,-7.43325,NULL,NULL,'2012-07-29 03:54:59',56137.1631900002,19.4399,0.1885,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_51811.gif',49649863586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(830,826,0,'LSQ12eju','LSQ',350.748916666667,-7.43316666666667,NULL,NULL,'2012-07-31 07:31:53',56139.3138100002,19.0691,0.1701,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_51812.gif',49649863586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(831,826,0,'LSQ12eju','LSQ',350.74875,-7.43316666666667,NULL,NULL,'2012-07-31 09:01:29',56139.37604,19.4333,0.1858,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_51813.gif',49649863587,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(832,826,0,'LSQ12eju','LSQ',350.74875,-7.43330555555556,NULL,NULL,'2012-08-08 09:09:57',56147.38191,19.4987,0.173,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_51814.gif',49649863587,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(833,826,0,'LSQ12eju','LSQ',350.748833333333,-7.43322222222222,NULL,NULL,'2012-08-10 09:35:24',56149.39959,19.5165,0.1628,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_51815.gif',49649863586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(834,826,0,'LSQ12eju','LSQ',350.748875,-7.43322222222222,NULL,NULL,'2012-08-10 10:00:40',56149.41714,19.6497,0.1593,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_51816.gif',49649863586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(835,826,0,'LSQ12eju','LSQ',350.748833333333,-7.43322222222222,NULL,NULL,'2012-08-15 03:22:58',56154.1409499999,20.1592,0.1226,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_51817.gif',49649863586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(836,826,0,'LSQ12eju','LSQ',350.7495,-7.43325,NULL,NULL,'2012-08-18 05:47:29',56157.24131,20.389,0.1132,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_51818.gif',49649863617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779119,12121548,NULL,NULL,NULL,NULL),(837,826,0,'LSQ12eju','LSQ',350.748833333333,-7.43325,NULL,NULL,'2012-08-18 08:09:52',56157.3401899999,19.7692,0.0672,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_51793.gif',49649863586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(838,826,0,'LSQ12eju','LSQ',350.748916666667,-7.43322222222222,NULL,NULL,'2012-08-18 09:58:35',56157.4156900002,19.9428,0.0841,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-19 00:45:27','2012-08-19 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_51794.gif',49649863586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(839,472,0,'LSQ12eeq','LSQ',313.204208333333,-16.55975,NULL,NULL,'2012-08-19 00:30:53',56158.0214499999,19.4981,0.1069,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 07:45:27','2012-08-20 07:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eeq/LSQ12eeq_snap_51869.gif',50992845486,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796763210,12449425,NULL,NULL,NULL,NULL),(840,544,0,'LSQ12egf','LSQ',342.308666666667,1.74263888888889,NULL,NULL,'2012-08-19 02:26:37',56158.10182,19.3115,0.0328,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 07:45:27','2012-08-20 07:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_51891.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(841,544,0,'LSQ12egf','LSQ',342.308833333333,1.74275,NULL,NULL,'2012-08-19 05:24:05',56158.2250600001,20.3775,0.1515,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 07:45:27','2012-08-20 07:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_51892.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(842,544,0,'LSQ12egf','LSQ',342.308625,1.74255555555556,NULL,NULL,'2012-08-19 07:41:26',56158.3204399999,19.2024,0.0341,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 07:45:27','2012-08-20 07:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_51893.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(843,571,0,'LSQ12ehj','LSQ',347.3155,7.04825,NULL,NULL,'2012-08-19 03:03:29',56158.1274299999,18.5573,0.0223,'gr-LSQ',NULL,NULL,'AGN',NULL,'2012-08-20 07:45:27','2012-08-20 07:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_snap_51900.gif',51719133726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,808111464,12626741,NULL,NULL,NULL,NULL),(844,571,0,'LSQ12ehj','LSQ',347.315583333333,7.04825,NULL,NULL,'2012-08-19 05:35:07',56158.2327299998,18.5533,0.0194,'gr-LSQ',NULL,NULL,'AGN',NULL,'2012-08-20 07:45:27','2012-08-20 07:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_snap_51901.gif',51719133726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,808111464,12626741,NULL,NULL,NULL,NULL),(845,571,0,'LSQ12ehj','LSQ',347.315583333333,7.04830555555556,NULL,NULL,'2012-08-19 07:52:31',56158.3281399999,18.4896,0.0229,'gr-LSQ',NULL,NULL,'AGN',NULL,'2012-08-20 07:45:27','2012-08-20 07:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_snap_51902.gif',51719133726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,808111464,12626741,NULL,NULL,NULL,NULL),(846,627,0,'LSQ12eht','LSQ',354.359291666667,10.3063333333333,NULL,NULL,'2012-08-19 03:48:34',56158.1587299998,20.4991,0.0901,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 07:45:27','2012-08-20 07:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eht/LSQ12eht_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eht/LSQ12eht_snap_51837.gif',51778995065,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,809046797,12641356,NULL,NULL,NULL,NULL),(847,627,0,'LSQ12eht','LSQ',354.359291666667,10.3063611111111,NULL,NULL,'2012-08-19 06:19:28',56158.26352,20.1135,0.0659,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 07:45:27','2012-08-20 07:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eht/LSQ12eht_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eht/LSQ12eht_snap_51838.gif',51778995065,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,809046797,12641356,NULL,NULL,NULL,NULL),(848,627,0,'LSQ12eht','LSQ',354.359291666667,10.3063333333333,NULL,NULL,'2012-08-19 08:29:37',56158.3539100001,20.0312,0.0673,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 07:45:27','2012-08-20 07:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eht/LSQ12eht_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eht/LSQ12eht_snap_51839.gif',51778995065,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,809046797,12641356,NULL,NULL,NULL,NULL),(849,849,1,'LSQ12eka','LSQ',353.038458333333,5.10011111111111,NULL,NULL,'2012-08-19 06:34:13',56158.2737699999,20.8584,0.1346,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 18:45:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eka/LSQ12eka_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eka/LSQ12eka_snap_51967.gif',51762700589,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,808792196,12637378,NULL,NULL,NULL,NULL),(850,849,0,'LSQ12eka','LSQ',353.038458333333,5.10013888888889,NULL,NULL,'2012-08-19 08:44:24',56158.36417,21.0106,0.1528,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 18:45:25','2012-08-20 18:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eka/LSQ12eka_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eka/LSQ12eka_snap_51968.gif',51762700589,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,808792196,12637378,NULL,NULL,NULL,NULL),(851,851,1,'LSQ12ekx','LSQ',354.105208333333,8.07225,NULL,NULL,'2012-08-19 06:15:46',56158.2609600001,20.7965,0.1638,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekx/LSQ12ekx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekx/LSQ12ekx_snap_52048.gif',51792538858,NULL,NULL,NULL,'2012-08-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,809258419,12644662,NULL,NULL,NULL,NULL),(852,851,0,'LSQ12ekx','LSQ',354.105166666667,8.07225,NULL,NULL,'2012-08-19 08:25:55',56158.3513400001,21.0745,0.1375,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2012-08-20 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekx/LSQ12ekx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekx/LSQ12ekx_snap_52049.gif',51792538858,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,809258419,12644662,NULL,NULL,NULL,NULL),(853,853,1,'LSQ12ekw','LSQ',353.275833333333,9.55786111111111,NULL,NULL,'2012-08-19 06:19:28',56158.26352,20.2351,0.095,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekw/LSQ12ekw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekw/LSQ12ekw_snap_52044.gif',51799641073,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,809369391,12646396,NULL,NULL,NULL,NULL),(854,853,0,'LSQ12ekw','LSQ',353.27575,9.55788888888889,NULL,NULL,'2012-08-19 08:29:37',56158.3539100001,20.1983,0.0999,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2012-08-20 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekw/LSQ12ekw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekw/LSQ12ekw_snap_52045.gif',51799641073,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,809369391,12646396,NULL,NULL,NULL,NULL),(855,855,1,'LSQ12eku','LSQ',352.120916666667,8.88397222222222,NULL,NULL,'2012-08-19 03:44:53',56158.1561699999,19.3903,0.0736,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eku/LSQ12eku_history.html','agn or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eku/LSQ12eku_snap_52040.gif',51797474876,NULL,NULL,NULL,'2012-08-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,809335544,12645867,NULL,NULL,NULL,NULL),(856,855,0,'LSQ12eku','LSQ',352.121166666667,8.88391666666667,NULL,NULL,'2012-08-19 06:15:46',56158.2609600001,19.6266,0.0769,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2012-08-20 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eku/LSQ12eku_history.html','agn or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eku/LSQ12eku_snap_52041.gif',51797474876,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,809335544,12645867,NULL,NULL,NULL,NULL),(857,855,0,'LSQ12eku','LSQ',352.121083333333,8.88402777777778,NULL,NULL,'2012-08-19 08:25:55',56158.3513400001,19.4491,0.0768,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2012-08-20 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eku/LSQ12eku_history.html','agn or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eku/LSQ12eku_snap_52056.gif',51797474876,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,809335544,12645867,NULL,NULL,NULL,NULL),(858,858,1,'LSQ12eks','LSQ',345.26725,-6.69516666666667,NULL,NULL,'2012-08-19 02:22:55',56158.09925,18.5634,0.024,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eks/LSQ12eks_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eks/LSQ12eks_snap_52006.gif',49487173961,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773237093,12081829,NULL,NULL,NULL,NULL),(859,858,0,'LSQ12eks','LSQ',345.26725,-6.69519444444444,NULL,NULL,'2012-08-19 06:12:04',56158.2583900001,18.746,0.0249,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2012-08-20 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eks/LSQ12eks_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eks/LSQ12eks_snap_52036.gif',49487173961,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773237093,12081829,NULL,NULL,NULL,NULL),(860,858,0,'LSQ12eks','LSQ',345.267208333333,-6.69519444444444,NULL,NULL,'2012-08-19 08:22:11',56158.3487399998,18.5253,0.0273,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2012-08-20 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eks/LSQ12eks_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eks/LSQ12eks_snap_52007.gif',49487173965,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773237093,12081829,NULL,NULL,NULL,NULL),(861,861,0,'LSQ12ekr','LSQ',344.380416666667,-6.24475,NULL,NULL,'2012-07-17 10:07:02',56125.4215600002,20.1092,0.1068,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-12-24 20:38:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_history.html','agn or old?',NULL,0.090066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_snap_52026.gif',49488043284,NULL,NULL,NULL,'2012-07-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,773250676,12082041,NULL,NULL,NULL,NULL),(862,861,0,'LSQ12ekr','LSQ',344.3805,-6.24466666666667,NULL,NULL,'2012-07-25 10:07:34',56133.4219300002,19.8188,0.0893,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-08-21 00:25:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_history.html','agn or old?',NULL,0.090066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_snap_52050.gif',49488043284,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,773250676,12082041,NULL,NULL,NULL,NULL),(863,861,0,'LSQ12ekr','LSQ',344.380208333333,-6.24475,NULL,NULL,'2012-07-25 10:21:08',56133.4313500002,19.8948,0.1071,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-08-21 00:25:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_history.html','agn or old?',NULL,0.090066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_snap_52027.gif',49488043284,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,773250676,12082041,NULL,NULL,NULL,NULL),(864,861,0,'LSQ12ekr','LSQ',344.379708333333,-6.24538888888889,NULL,NULL,'2012-07-27 03:35:48',56135.1498699998,19.5823,0.1865,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-08-21 00:25:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_history.html','agn or old?',NULL,0.090066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_snap_52028.gif',49488043314,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,773250676,12082041,NULL,NULL,NULL,NULL),(865,861,0,'LSQ12ekr','LSQ',344.380291666667,-6.24511111111111,NULL,NULL,'2012-07-27 05:40:26',56135.23642,20.1052,0.1144,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-08-21 00:25:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_history.html','agn or old?',NULL,0.090066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_snap_52029.gif',49488043287,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,773250676,12082041,NULL,NULL,NULL,NULL),(866,861,0,'LSQ12ekr','LSQ',344.379708333333,-6.24488888888889,NULL,NULL,'2012-07-29 05:47:04',56137.2410200001,19.581,0.1083,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-08-21 00:25:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_history.html','agn or old?',NULL,0.090066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_snap_52030.gif',49488043315,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,773250676,12082041,NULL,NULL,NULL,NULL),(867,861,0,'LSQ12ekr','LSQ',344.38025,-6.24483333333333,NULL,NULL,'2012-07-31 09:49:28',56139.4093599999,19.1496,0.1526,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-08-21 00:25:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_history.html','agn or old?',NULL,0.090066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_snap_52031.gif',49488043284,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,773250676,12082041,NULL,NULL,NULL,NULL),(868,861,0,'LSQ12ekr','LSQ',344.379666666667,-6.24527777777778,NULL,NULL,'2012-08-06 03:30:33',56145.14622,18.9005,0.1165,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-08-21 00:25:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_history.html','agn or old?',NULL,0.090066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_snap_52032.gif',49488043314,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,773250676,12082041,NULL,NULL,NULL,NULL),(869,861,0,'LSQ12ekr','LSQ',344.379916666667,-6.24486111111111,NULL,NULL,'2012-08-10 06:00:19',56149.2502299999,19.7229,0.0996,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-08-21 00:25:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_history.html','agn or old?',NULL,0.090066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_snap_52033.gif',49488043312,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,773250676,12082041,NULL,NULL,NULL,NULL),(870,861,0,'LSQ12ekr','LSQ',344.380041666667,-6.24477777777778,NULL,NULL,'2012-08-10 07:59:58',56149.3333200002,19.1488,0.125,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-08-21 00:25:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_history.html','agn or old?',NULL,0.090066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_snap_52034.gif',49488043312,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,773250676,12082041,NULL,NULL,NULL,NULL),(871,861,0,'LSQ12ekr','LSQ',344.379708333333,-6.24497222222222,NULL,NULL,'2012-08-19 02:19:14',56158.09669,19.6759,0.0761,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-08-21 00:25:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_history.html','agn or old?',NULL,0.090066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_snap_52002.gif',49488043315,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,773250676,12082041,NULL,NULL,NULL,NULL),(872,861,0,'LSQ12ekr','LSQ',344.379833333333,-6.24486111111111,NULL,NULL,'2012-08-19 06:08:23',56158.2558300002,19.9785,0.0827,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-08-21 00:25:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_history.html','agn or old?',NULL,0.090066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_snap_52003.gif',49488043315,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,773250676,12082041,NULL,NULL,NULL,NULL),(873,861,0,'LSQ12ekr','LSQ',344.379583333333,-6.24494444444444,NULL,NULL,'2012-08-19 08:18:29',56158.3461699998,19.532,0.0414,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-08-21 00:25:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_history.html','agn or old?',NULL,0.090066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_snap_52035.gif',49488043315,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,773250676,12082041,NULL,NULL,NULL,NULL),(874,874,1,'LSQ12eko','LSQ',348.718833333333,-3.04391666666667,NULL,NULL,'2012-08-19 03:59:38',56158.1664200001,20.7352,0.1188,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eko/LSQ12eko_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eko/LSQ12eko_snap_51996.gif',49633301517,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775520336,12117505,NULL,NULL,NULL,NULL),(875,874,0,'LSQ12eko','LSQ',348.71925,-3.04405555555556,NULL,NULL,'2012-08-19 08:48:04',56158.3667199998,20.252,0.1334,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2012-08-20 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eko/LSQ12eko_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eko/LSQ12eko_snap_51997.gif',49633301506,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775520336,12117505,NULL,NULL,NULL,NULL),(876,876,1,'LSQ12ekl','LSQ',347.856041666667,-1.86508333333333,NULL,NULL,'2012-08-19 02:33:59',56158.1069399999,19.7684,0.0527,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekl/LSQ12ekl_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekl/LSQ12ekl_snap_51990.gif',49495526397,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773367599,12083868,NULL,NULL,NULL,NULL),(877,876,0,'LSQ12ekl','LSQ',347.856041666667,-1.86505555555556,NULL,NULL,'2012-08-19 06:23:10',56158.26609,19.7437,0.0473,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2012-08-20 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekl/LSQ12ekl_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekl/LSQ12ekl_snap_52022.gif',49495526397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773367599,12083868,NULL,NULL,NULL,NULL),(878,876,0,'LSQ12ekl','LSQ',347.856125,-1.86505555555556,NULL,NULL,'2012-08-19 08:33:19',56158.35647,19.6952,0.0508,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2012-08-20 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekl/LSQ12ekl_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekl/LSQ12ekl_snap_51991.gif',49495526397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773367599,12083868,NULL,NULL,NULL,NULL),(879,879,1,'LSQ12ekf','LSQ',347.24925,7.45072222222222,NULL,NULL,'2012-08-19 03:03:29',56158.1274299999,20.5241,0.1303,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekf/LSQ12ekf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekf/LSQ12ekf_snap_51977.gif',51721564658,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,808149447,12627335,NULL,NULL,NULL,NULL),(880,879,0,'LSQ12ekf','LSQ',347.24925,7.45063888888889,NULL,NULL,'2012-08-19 05:35:07',56158.2327299998,20.0944,0.1324,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2012-08-20 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekf/LSQ12ekf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekf/LSQ12ekf_snap_51978.gif',51721564658,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,808149447,12627335,NULL,NULL,NULL,NULL),(881,879,0,'LSQ12ekf','LSQ',347.249291666667,7.45066666666667,NULL,NULL,'2012-08-19 07:52:31',56158.3281399999,20.5562,0.1366,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 19:45:27','2012-08-20 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekf/LSQ12ekf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekf/LSQ12ekf_snap_52018.gif',51721564658,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,808149447,12627335,NULL,NULL,NULL,NULL),(882,370,0,'LSQ12dtg','LSQ',358.9065,-6.24958333333333,NULL,NULL,'2012-08-20 09:43:17',56159.4050599998,20.8195,0.1763,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_history.html','variable?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dtg/LSQ12dtg_snap_52187.gif',49433754184,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,772402409,12068787,NULL,NULL,NULL,NULL),(883,457,0,'LSQ12edo','LSQ',51.5785833333333,-3.29775,NULL,NULL,'2012-08-20 09:55:36',56159.4136199998,19.3623,0.1162,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_snap_52155.gif',36842019075,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575656548,8994633,NULL,NULL,NULL,NULL),(884,457,0,'LSQ12edo','LSQ',51.5785416666667,-3.29769444444444,NULL,NULL,'2012-08-20 10:05:49',56159.4207100002,19.1753,0.104,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_snap_52156.gif',36842019075,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575656548,8994633,NULL,NULL,NULL,NULL),(885,462,0,'LSQ12edk','LSQ',47.239,-2.95444444444444,NULL,NULL,'2012-08-20 09:50:31',56159.4100899999,19.066,0.1743,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_history.html','sne',NULL,0.0082,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_snap_52172.gif',36790348504,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574849195,8982018,NULL,NULL,NULL,NULL),(886,611,0,'LSQ12eid','LSQ',4.408375,-5.38275,NULL,NULL,'2012-08-20 07:30:44',56159.3130100002,18.429,0.0337,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_snap_52100.gif',34413529726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537711401,8401740,NULL,NULL,NULL,NULL),(887,611,0,'LSQ12eid','LSQ',4.40841666666667,-5.38277777777778,NULL,NULL,'2012-08-20 09:41:36',56159.4038900002,18.2917,0.0317,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_snap_52101.gif',34413529726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537711401,8401740,NULL,NULL,NULL,NULL),(888,617,0,'LSQ12eib','LSQ',8.04120833333333,-7.38152777777778,NULL,NULL,'2012-08-20 07:35:47',56159.3165199999,19.7271,0.0761,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_snap_52095.gif',34627856132,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541060252,8454066,NULL,NULL,NULL,NULL),(889,617,0,'LSQ12eib','LSQ',8.041,-7.3815,NULL,NULL,'2012-08-20 09:36:30',56159.4003499998,19.7329,0.0943,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_snap_52096.gif',34627856184,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541060252,8454066,NULL,NULL,NULL,NULL),(890,646,0,'LSQ12eiq','LSQ',32.5293333333333,-5.57611111111111,NULL,NULL,'2012-08-20 07:54:21',56159.3294199998,18.6289,0.0326,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_snap_52139.gif',35142165909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549096342,8579630,NULL,NULL,NULL,NULL),(891,646,0,'LSQ12eiq','LSQ',32.5295,-5.57608333333333,NULL,NULL,'2012-08-20 09:17:55',56159.3874499998,18.6573,0.033,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_snap_52140.gif',35142165909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549096342,8579630,NULL,NULL,NULL,NULL),(892,697,0,'LSQ12eix','LSQ',40.2242083333333,-6.53883333333333,NULL,NULL,'2012-08-20 08:11:22',56159.3412299999,19.6158,0.1356,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_52137.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(893,697,0,'LSQ12eix','LSQ',40.2242083333333,-6.53886111111111,NULL,NULL,'2012-08-20 09:14:32',56159.3851000001,19.9392,0.1127,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_52138.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(894,722,0,'LSQ12eir','LSQ',34.1007083333333,-3.01941666666667,NULL,NULL,'2012-08-20 07:56:03',56159.3306,18.8121,0.0662,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_snap_52149.gif',35133634952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548963046,8577547,NULL,NULL,NULL,NULL),(895,722,0,'LSQ12eir','LSQ',34.10075,-3.01938888888889,NULL,NULL,'2012-08-20 09:09:29',56159.3815899999,18.8554,0.0673,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_snap_52150.gif',35133634952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548963046,8577547,NULL,NULL,NULL,NULL),(896,726,0,'LSQ12eil','LSQ',1.67291666666667,-6.28097222222222,NULL,NULL,'2012-08-20 07:29:02',56159.31183,19.9375,0.1309,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eil/LSQ12eil_history.html','sne - young ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eil/LSQ12eil_snap_52147.gif',34387815364,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537309615,8395462,NULL,NULL,NULL,NULL),(897,751,0,'LSQ12ejf','LSQ',300.23775,-17.8160277777778,NULL,NULL,'2012-08-20 00:22:22',56159.0155400001,17.8865,0.019,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_history.html','sn ',NULL,0.65,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_snap_52182.gif',47978099721,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,749657808,11713403,NULL,NULL,NULL,NULL),(898,751,0,'LSQ12ejf','LSQ',300.23775,-17.816,NULL,NULL,'2012-08-20 02:24:31',56159.10036,17.9017,0.0167,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_history.html','sn ',NULL,0.65,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_snap_52183.gif',47978099721,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,749657808,11713403,NULL,NULL,NULL,NULL),(899,751,0,'LSQ12ejf','LSQ',300.237791666667,-17.8160277777778,NULL,NULL,'2012-08-20 05:35:06',56159.2327100001,17.8016,0.0171,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_history.html','sn ',NULL,0.65,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_snap_52184.gif',47978099721,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,749657808,11713403,NULL,NULL,NULL,NULL),(900,757,0,'LSQ12ejd','LSQ',300.880666666667,-19.8602777777778,NULL,NULL,'2012-08-20 00:22:22',56159.0155400001,20.1374,0.0865,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_history.html','sn?',NULL,0.083168,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_snap_52185.gif',50813697251,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793964019,12405687,NULL,NULL,NULL,NULL),(901,757,0,'LSQ12ejd','LSQ',300.880791666667,-19.8603888888889,NULL,NULL,'2012-08-20 02:24:31',56159.10036,20.7842,0.1174,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_history.html','sn?',NULL,0.083168,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_snap_52186.gif',50813697251,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793964019,12405687,NULL,NULL,NULL,NULL),(902,767,0,'LSQ12ejs','LSQ',351.870375,-5.38608333333333,NULL,NULL,'2012-08-20 08:24:48',56159.3505600002,20.0083,0.0733,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejs/LSQ12ejs_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejs/LSQ12ejs_snap_52200.gif',49638442804,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775600668,12118760,NULL,NULL,NULL,NULL),(903,771,0,'LSQ12ejr','LSQ',351.925208333333,-5.09027777777778,NULL,NULL,'2012-08-20 04:16:58',56159.17845,18.3955,0.0359,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_snap_52195.gif',49638300039,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775598438,12118725,NULL,NULL,NULL,NULL),(904,771,0,'LSQ12ejr','LSQ',351.925,-5.09025,NULL,NULL,'2012-08-20 06:31:33',56159.2719100001,20.3176,0.1384,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_snap_52196.gif',49638300039,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775598438,12118725,NULL,NULL,NULL,NULL),(905,783,0,'LSQ12ejq','LSQ',353.857416666667,-6.94975,NULL,NULL,'2012-08-20 04:16:58',56159.17845,18.8625,0.0286,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejq/LSQ12ejq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejq/LSQ12ejq_snap_52197.gif',49647415924,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,775740873,12120951,NULL,NULL,NULL,NULL),(906,783,0,'LSQ12ejq','LSQ',353.857708333333,-6.94997222222222,NULL,NULL,'2012-08-20 06:31:33',56159.2719100001,20.9451,0.1017,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejq/LSQ12ejq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejq/LSQ12ejq_snap_52198.gif',49647415908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,775740873,12120951,NULL,NULL,NULL,NULL),(907,783,0,'LSQ12ejq','LSQ',353.857625,-6.94994444444444,NULL,NULL,'2012-08-20 08:24:48',56159.3505600002,20.8675,0.1064,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejq/LSQ12ejq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejq/LSQ12ejq_snap_52199.gif',49647415908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,775740873,12120951,NULL,NULL,NULL,NULL),(908,788,0,'LSQ12ejo','LSQ',353.492083333333,-3.31558333333333,NULL,NULL,'2012-08-20 04:16:58',56159.17845,20.5215,0.0937,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_snap_52191.gif',49414528108,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772102001,12064093,NULL,NULL,NULL,NULL),(909,788,0,'LSQ12ejo','LSQ',353.492125,-3.31558333333333,NULL,NULL,'2012-08-20 06:31:33',56159.2719100001,20.899,0.1917,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_snap_52192.gif',49414528108,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772102001,12064093,NULL,NULL,NULL,NULL),(910,788,0,'LSQ12ejo','LSQ',353.492125,-3.31544444444444,NULL,NULL,'2012-08-20 08:24:48',56159.3505600002,21.0044,0.1247,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_snap_52193.gif',49414528108,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772102001,12064093,NULL,NULL,NULL,NULL),(911,795,0,'LSQ12ejn','LSQ',303.868583333333,-22.3702222222222,NULL,NULL,'2012-08-20 05:42:29',56159.2378400001,19.762,0.0973,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_snap_52194.gif',50806837566,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793856836,12404013,NULL,NULL,NULL,NULL),(912,826,0,'LSQ12eju','LSQ',350.748833333333,-7.43313888888889,NULL,NULL,'2012-08-20 04:16:58',56159.17845,19.7292,0.0688,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_52204.gif',49649863586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(913,826,0,'LSQ12eju','LSQ',350.748833333333,-7.43316666666667,NULL,NULL,'2012-08-20 06:31:33',56159.2719100001,19.727,0.0627,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_52205.gif',49649863586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(914,826,0,'LSQ12eju','LSQ',350.748916666667,-7.43313888888889,NULL,NULL,'2012-08-20 08:24:48',56159.3505600002,19.7205,0.0661,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-20 20:45:28','2012-08-20 20:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_52206.gif',49649863586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(915,915,1,'LSQ12elk','LSQ',31.3318333333333,-5.97241666666667,NULL,NULL,'2012-08-10 07:01:05',56149.2924199998,20.0091,0.1812,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_snap_52404.gif',35137599396,NULL,NULL,NULL,'2012-08-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,549024990,8578515,NULL,NULL,NULL,NULL),(916,915,0,'LSQ12elk','LSQ',31.331875,-5.97222222222222,NULL,NULL,'2012-08-10 08:44:07',56149.3639799999,20.0696,0.1441,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_snap_52405.gif',35137599396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,549024990,8578515,NULL,NULL,NULL,NULL),(917,915,0,'LSQ12elk','LSQ',31.3317916666667,-5.97233333333333,NULL,NULL,'2012-08-12 10:05:56',56151.4207899999,19.5354,0.0939,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_snap_52406.gif',35137599396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,549024990,8578515,NULL,NULL,NULL,NULL),(918,915,0,'LSQ12elk','LSQ',31.3317916666667,-5.97236111111111,NULL,NULL,'2012-08-12 10:14:21',56151.4266400002,19.3653,0.1225,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_snap_52407.gif',35137599396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,549024990,8578515,NULL,NULL,NULL,NULL),(919,915,0,'LSQ12elk','LSQ',31.331875,-5.97233333333333,NULL,NULL,'2012-08-20 07:56:03',56159.3306,19.4464,0.0632,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_snap_52373.gif',35137599396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,549024990,8578515,NULL,NULL,NULL,NULL),(920,915,0,'LSQ12elk','LSQ',31.3319166666667,-5.97236111111111,NULL,NULL,'2012-08-20 09:09:29',56159.3815899999,19.331,0.0618,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_snap_52374.gif',35137599396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,549024990,8578515,NULL,NULL,NULL,NULL),(922,921,1,'LSQ12elj','LSQ',31.0349166666667,-4.82077777777778,NULL,NULL,'2012-07-27 07:02:10',56135.29318,20.8978,0.1653,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_history.html','sne?',NULL,0.0829,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_snap_52394.gif',35139786209,NULL,NULL,NULL,'2011-12-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549059159,8579049,NULL,NULL,NULL,NULL),(923,921,0,'LSQ12elj','LSQ',31.0349583333333,-4.82075,NULL,NULL,'2012-07-27 08:48:08',56135.3667700002,20.7253,0.1515,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_history.html','sne?',NULL,0.0829,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_snap_52395.gif',35139786209,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549059159,8579049,NULL,NULL,NULL,NULL),(924,921,0,'LSQ12elj','LSQ',31.0350833333333,-4.82063888888889,NULL,NULL,'2012-07-29 07:07:06',56137.2966,20.0923,0.192,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_history.html','sne?',NULL,0.0829,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_snap_52396.gif',35139786209,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549059159,8579049,NULL,NULL,NULL,NULL),(925,921,0,'LSQ12elj','LSQ',31.0349166666667,-4.82075,NULL,NULL,'2012-07-29 08:51:14',56137.3689199998,20.0827,0.1042,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_history.html','sne?',NULL,0.0829,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_snap_52397.gif',35139786209,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549059159,8579049,NULL,NULL,NULL,NULL),(926,921,0,'LSQ12elj','LSQ',31.0350416666667,-4.82055555555556,NULL,NULL,'2012-07-31 08:49:05',56139.3674300001,19.6068,0.1871,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_history.html','sne?',NULL,0.0829,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_snap_52398.gif',35139786209,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549059159,8579049,NULL,NULL,NULL,NULL),(927,921,0,'LSQ12elj','LSQ',31.035,-4.82052777777778,NULL,NULL,'2012-08-06 08:08:51',56145.3394900002,18.8191,0.2153,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_history.html','sne?',NULL,0.0829,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_snap_52399.gif',35139786209,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549059159,8579049,NULL,NULL,NULL,NULL),(928,921,0,'LSQ12elj','LSQ',31.0349166666667,-4.82072222222222,NULL,NULL,'2012-08-10 07:01:05',56149.2924199998,19.4331,0.0872,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_history.html','sne?',NULL,0.0829,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_snap_52400.gif',35139786209,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549059159,8579049,NULL,NULL,NULL,NULL),(929,921,0,'LSQ12elj','LSQ',31.0349583333333,-4.82055555555556,NULL,NULL,'2012-08-10 08:44:07',56149.3639799999,19.4035,0.0849,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_history.html','sne?',NULL,0.0829,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_snap_52401.gif',35139786209,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549059159,8579049,NULL,NULL,NULL,NULL),(930,921,0,'LSQ12elj','LSQ',31.0349583333333,-4.82061111111111,NULL,NULL,'2012-08-12 10:05:56',56151.4207899999,19.4231,0.0747,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_history.html','sne?',NULL,0.0829,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_snap_52402.gif',35139786209,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549059159,8579049,NULL,NULL,NULL,NULL),(931,921,0,'LSQ12elj','LSQ',31.0350416666667,-4.82055555555556,NULL,NULL,'2012-08-12 10:14:21',56151.4266400002,19.495,0.1306,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_history.html','sne?',NULL,0.0829,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_snap_52403.gif',35139786209,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549059159,8579049,NULL,NULL,NULL,NULL),(932,921,0,'LSQ12elj','LSQ',31.0350416666667,-4.82066666666667,NULL,NULL,'2012-08-20 07:56:03',56159.3306,19.9786,0.0882,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_history.html','sne?',NULL,0.0829,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_snap_52371.gif',35139786209,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549059159,8579049,NULL,NULL,NULL,NULL),(933,921,0,'LSQ12elj','LSQ',31.0349166666667,-4.82066666666667,NULL,NULL,'2012-08-20 09:09:29',56159.3815899999,19.7403,0.0798,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_history.html','sne?',NULL,0.0829,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_snap_52372.gif',35139786209,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549059159,8579049,NULL,NULL,NULL,NULL),(934,934,1,'LSQ12eli','LSQ',51.1982083333333,-6.86372222222222,NULL,NULL,'2012-08-10 07:37:11',56149.3174999999,18.646,0.1121,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eli/LSQ12eli_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eli/LSQ12eli_snap_52391.gif',36804372250,NULL,NULL,NULL,'2012-08-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,575068316,8985442,NULL,NULL,NULL,NULL),(935,934,0,'LSQ12eli','LSQ',51.1981666666667,-6.86375,NULL,NULL,'2012-08-10 09:01:12',56149.3758399999,19.1384,0.1599,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eli/LSQ12eli_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eli/LSQ12eli_snap_52392.gif',36804372250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,575068316,8985442,NULL,NULL,NULL,NULL),(936,934,0,'LSQ12eli','LSQ',51.198125,-6.86366666666667,NULL,NULL,'2012-08-20 09:53:54',56159.4124400001,18.8742,0.1017,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eli/LSQ12eli_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eli/LSQ12eli_snap_52369.gif',36804372250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,575068316,8985442,NULL,NULL,NULL,NULL),(937,934,0,'LSQ12eli','LSQ',51.19825,-6.86372222222222,NULL,NULL,'2012-08-20 10:14:18',56159.4265999999,18.4039,0.1304,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eli/LSQ12eli_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eli/LSQ12eli_snap_52370.gif',36804372252,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,575068316,8985442,NULL,NULL,NULL,NULL),(938,938,1,'LSQ12elh','LSQ',51.3040833333333,-6.13441666666667,NULL,NULL,'2012-07-25 09:58:00',56133.4152799998,19.1818,0.1425,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elh/LSQ12elh_history.html','sne?',NULL,0.06982,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elh/LSQ12elh_snap_52387.gif',36803371237,NULL,NULL,NULL,'2012-07-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575052675,8985198,NULL,NULL,NULL,NULL),(939,938,0,'LSQ12elh','LSQ',51.3040416666667,-6.13444444444445,NULL,NULL,'2012-07-27 09:21:48',56135.3901499999,19.191,0.0989,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elh/LSQ12elh_history.html','sne?',NULL,0.06982,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elh/LSQ12elh_snap_52388.gif',36803371237,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575052675,8985198,NULL,NULL,NULL,NULL),(940,938,0,'LSQ12elh','LSQ',51.304125,-6.13433333333333,NULL,NULL,'2012-07-29 09:16:24',56137.3864000002,18.8873,0.1033,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elh/LSQ12elh_history.html','sne?',NULL,0.06982,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elh/LSQ12elh_snap_52389.gif',36803371237,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575052675,8985198,NULL,NULL,NULL,NULL),(941,938,0,'LSQ12elh','LSQ',51.3041666666667,-6.13444444444445,NULL,NULL,'2012-08-10 09:02:53',56149.3770099999,19.1877,0.1706,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elh/LSQ12elh_history.html','sne?',NULL,0.06982,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elh/LSQ12elh_snap_52390.gif',36803371237,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575052675,8985198,NULL,NULL,NULL,NULL),(942,938,0,'LSQ12elh','LSQ',51.304125,-6.1345,NULL,NULL,'2012-08-20 09:55:36',56159.4136199998,19.1129,0.0988,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elh/LSQ12elh_history.html','sne?',NULL,0.06982,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elh/LSQ12elh_snap_52367.gif',36803371237,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575052675,8985198,NULL,NULL,NULL,NULL),(943,938,0,'LSQ12elh','LSQ',51.304125,-6.13447222222222,NULL,NULL,'2012-08-20 10:05:49',56159.4207100002,18.9907,0.1282,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elh/LSQ12elh_history.html','sne?',NULL,0.06982,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elh/LSQ12elh_snap_52368.gif',36803371237,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575052675,8985198,NULL,NULL,NULL,NULL),(944,944,1,'LSQ12elf','LSQ',57.3404166666667,-3.49958333333333,NULL,NULL,'2012-08-10 08:12:48',56149.3422300001,19.8091,0.1615,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elf/LSQ12elf_history.html','possibly old sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elf/LSQ12elf_snap_52385.gif',37009717198,NULL,NULL,NULL,'2012-08-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578276831,9035575,NULL,NULL,NULL,NULL),(945,944,0,'LSQ12elf','LSQ',57.3403333333333,-3.49961111111111,NULL,NULL,'2012-08-20 09:58:59',56159.41597,19.7741,0.1338,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elf/LSQ12elf_history.html','possibly old sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elf/LSQ12elf_snap_52363.gif',37009717198,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578276831,9035575,NULL,NULL,NULL,NULL),(946,944,0,'LSQ12elf','LSQ',57.3404166666667,-3.49961111111111,NULL,NULL,'2012-08-20 10:07:30',56159.4218799998,19.6328,0.1116,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elf/LSQ12elf_history.html','possibly old sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elf/LSQ12elf_snap_52364.gif',37009717198,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578276831,9035575,NULL,NULL,NULL,NULL),(947,947,1,'LSQ12ele','LSQ',62.6977083333333,-7.07011111111111,NULL,NULL,'2012-08-20 10:02:21',56159.4183100001,20.3019,0.1428,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ele/LSQ12ele_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ele/LSQ12ele_snap_52361.gif',36955954125,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577436783,9022449,NULL,NULL,NULL,NULL),(948,947,0,'LSQ12ele','LSQ',62.6975833333333,-7.07013888888889,NULL,NULL,'2012-08-20 10:09:12',56159.4230599999,20.2412,0.1585,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ele/LSQ12ele_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ele/LSQ12ele_snap_52362.gif',36955954125,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577436783,9022449,NULL,NULL,NULL,NULL),(949,949,1,'LSQ12eld','LSQ',306.786916666667,-4.64341666666667,NULL,NULL,'2012-08-20 00:10:56',56159.0076000001,20.3088,0.1163,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_history.html','variable or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_snap_52384.gif',47835908586,NULL,NULL,NULL,'2012-06-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747436071,11678688,NULL,NULL,NULL,NULL),(950,949,0,'LSQ12eld','LSQ',306.787,-4.64344444444444,NULL,NULL,'2012-08-20 02:13:10',56159.0924800001,19.8571,0.0919,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_history.html','variable or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_snap_52359.gif',47835908586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747436071,11678688,NULL,NULL,NULL,NULL),(951,949,0,'LSQ12eld','LSQ',306.787,-4.64341666666667,NULL,NULL,'2012-08-20 05:31:23',56159.23013,20.6724,0.1452,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_history.html','variable or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_snap_52360.gif',47835908586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747436071,11678688,NULL,NULL,NULL,NULL),(952,952,1,'LSQ12elc','LSQ',306.669208333333,-4.56158333333333,NULL,NULL,'2012-08-20 02:13:10',56159.0924800001,20.3572,0.1672,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_snap_52357.gif',47834277690,NULL,NULL,NULL,'2012-06-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747410588,11678290,NULL,NULL,NULL,NULL),(953,952,0,'LSQ12elc','LSQ',306.669041666667,-4.56163888888889,NULL,NULL,'2012-08-20 05:31:23',56159.23013,20.6676,0.1676,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_snap_52358.gif',47834277690,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747410588,11678290,NULL,NULL,NULL,NULL),(954,954,1,'LSQ12ela','LSQ',353.607583333333,-3.68661111111111,NULL,NULL,'2012-07-27 06:07:50',56135.2554500001,19.7934,0.0842,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ela/LSQ12ela_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ela/LSQ12ela_snap_52380.gif',49417146764,NULL,NULL,NULL,'2012-07-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,772142918,12064733,NULL,NULL,NULL,NULL),(955,954,0,'LSQ12ela','LSQ',353.607416666667,-3.68655555555556,NULL,NULL,'2012-08-18 08:09:52',56157.3401899999,20.6521,0.1433,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ela/LSQ12ela_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ela/LSQ12ela_snap_52381.gif',49417146764,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,772142918,12064733,NULL,NULL,NULL,NULL),(956,954,0,'LSQ12ela','LSQ',353.608166666667,-3.68680555555556,NULL,NULL,'2012-08-20 04:16:58',56159.17845,20.8115,0.1218,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ela/LSQ12ela_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ela/LSQ12ela_snap_52353.gif',49417146767,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,772142918,12064733,NULL,NULL,NULL,NULL),(957,954,0,'LSQ12ela','LSQ',353.608041666667,-3.68680555555556,NULL,NULL,'2012-08-20 06:31:33',56159.2719100001,20.4497,0.13,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ela/LSQ12ela_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ela/LSQ12ela_snap_52354.gif',49417146767,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,772142918,12064733,NULL,NULL,NULL,NULL),(958,958,1,'LSQ12ekz','LSQ',353.51625,-3.70047222222222,NULL,NULL,'2012-08-20 04:16:58',56159.17845,20.9541,0.1572,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekz/LSQ12ekz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekz/LSQ12ekz_snap_52351.gif',49417144169,NULL,NULL,NULL,'2012-08-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772142877,12064732,NULL,NULL,NULL,NULL),(959,958,0,'LSQ12ekz','LSQ',353.51625,-3.70044444444444,NULL,NULL,'2012-08-20 06:31:33',56159.2719100001,20.6019,0.1343,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-21 15:45:30','2012-08-21 15:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekz/LSQ12ekz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekz/LSQ12ekz_snap_52352.gif',49417144169,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772142877,12064732,NULL,NULL,NULL,NULL),(960,581,0,'LSQ12ehl','LSQ',72.5277083333333,-21.7752777777778,NULL,NULL,'2012-08-21 10:04:30',56160.4197999998,18.4676,0.0431,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 08:45:35','2012-08-22 08:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_snap_52431.gif',37345461187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583522831,9117544,NULL,NULL,NULL,NULL),(961,581,0,'LSQ12ehl','LSQ',72.5277083333333,-21.7752777777778,NULL,NULL,'2012-08-21 10:12:57',56160.4256600002,18.7692,0.1135,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 08:45:35','2012-08-22 08:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_snap_52432.gif',37345461187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583522831,9117544,NULL,NULL,NULL,NULL),(962,751,0,'LSQ12ejf','LSQ',300.23775,-17.8160555555556,NULL,NULL,'2012-08-21 00:13:26',56160.0093399999,18.0304,0.0199,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 08:45:35','2012-08-22 08:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_history.html','sn ',NULL,0.65,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_snap_52469.gif',47978099721,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,749657808,11713403,NULL,NULL,NULL,NULL),(963,751,0,'LSQ12ejf','LSQ',300.237791666667,-17.8160277777778,NULL,NULL,'2012-08-21 02:19:34',56160.09693,18.1375,0.0185,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 08:45:35','2012-08-22 08:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_history.html','sn ',NULL,0.65,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_snap_52470.gif',47978099721,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,749657808,11713403,NULL,NULL,NULL,NULL),(964,751,0,'LSQ12ejf','LSQ',300.237875,-17.8160555555556,NULL,NULL,'2012-08-21 05:24:57',56160.2256700001,18.2071,0.0275,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 08:45:35','2012-08-22 08:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_history.html','sn ',NULL,0.65,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejf/LSQ12ejf_snap_52471.gif',47978099721,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,749657808,11713403,NULL,NULL,NULL,NULL),(965,757,0,'LSQ12ejd','LSQ',300.88075,-19.8605,NULL,NULL,'2012-08-21 00:13:26',56160.0093399999,20.5798,0.1015,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 08:45:35','2012-08-22 08:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_history.html','sn?',NULL,0.083168,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_snap_52480.gif',50813697251,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793964019,12405687,NULL,NULL,NULL,NULL),(966,757,0,'LSQ12ejd','LSQ',300.880625,-19.8603611111111,NULL,NULL,'2012-08-21 05:24:57',56160.2256700001,20.1385,0.1031,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 08:45:35','2012-08-22 08:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_history.html','sn?',NULL,0.083168,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejd/LSQ12ejd_snap_52481.gif',50813697251,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793964019,12405687,NULL,NULL,NULL,NULL),(967,949,0,'LSQ12eld','LSQ',306.786958333333,-4.64341666666667,NULL,NULL,'2012-08-21 00:02:09',56160.0014999998,20.2317,0.1244,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 08:45:35','2012-08-22 08:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_history.html','variable or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_snap_52487.gif',47835908586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747436071,11678688,NULL,NULL,NULL,NULL),(968,949,0,'LSQ12eld','LSQ',306.787,-4.64341666666667,NULL,NULL,'2012-08-21 02:08:08',56160.0889900001,20.0975,0.1285,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 08:45:35','2012-08-22 08:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_history.html','variable or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_snap_52488.gif',47835908586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747436071,11678688,NULL,NULL,NULL,NULL),(969,949,0,'LSQ12eld','LSQ',306.787,-4.64341666666667,NULL,NULL,'2012-08-21 04:09:03',56160.1729600001,19.9238,0.1297,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 08:45:35','2012-08-22 08:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_history.html','variable or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_snap_52489.gif',47835908586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747436071,11678688,NULL,NULL,NULL,NULL),(970,952,0,'LSQ12elc','LSQ',306.669208333333,-4.56147222222222,NULL,NULL,'2012-08-21 00:02:09',56160.0014999998,20.3228,0.1299,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 08:45:35','2012-08-22 08:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_snap_52485.gif',47834277690,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747410588,11678290,NULL,NULL,NULL,NULL),(971,952,0,'LSQ12elc','LSQ',306.669125,-4.56155555555556,NULL,NULL,'2012-08-21 04:09:03',56160.1729600001,20.8978,0.1502,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 08:45:35','2012-08-22 08:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_snap_52486.gif',47834277690,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747410588,11678290,NULL,NULL,NULL,NULL),(972,332,0,'LSQ12dwl','LSQ',333.173083333333,0.512027777777778,NULL,NULL,'2012-08-22 02:55:46',56161.12207,14.7892,0.0022,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 19:45:30','2012-08-22 19:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_history.html','sne-nice!',NULL,0.01377,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_snap_52668.gif',52152344378,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814880380,12732505,NULL,NULL,NULL,NULL),(973,332,0,'LSQ12dwl','LSQ',333.173083333333,0.512027777777778,NULL,NULL,'2012-08-22 05:46:39',56161.2407399998,14.7992,0.0028,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 19:45:30','2012-08-22 19:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_history.html','sne-nice!',NULL,0.01377,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_snap_52669.gif',52152344378,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814880380,12732505,NULL,NULL,NULL,NULL),(974,332,0,'LSQ12dwl','LSQ',333.173125,0.511972222222222,NULL,NULL,'2012-08-22 08:21:40',56161.3483799999,15.1491,0.0184,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 19:45:30','2012-08-22 19:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_history.html','sne-nice!',NULL,0.01377,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dwl/LSQ12dwl_snap_52670.gif',52152344380,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814880380,12732505,NULL,NULL,NULL,NULL),(975,557,0,'LSQ12ege','LSQ',252.715958333333,2.87452777777778,NULL,NULL,'2012-08-22 00:01:27',56161.0010099998,18.5764,0.0531,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-22 19:45:30','2012-08-22 19:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_snap_52706.gif',55981393928,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,874709280,13667332,NULL,NULL,NULL,NULL),(976,560,0,'LSQ12ehh','LSQ',246.801333333333,2.08344444444444,NULL,NULL,'2012-08-22 00:06:33',56161.0045500002,20.6169,0.1084,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-22 19:45:30','2012-08-22 19:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_snap_52702.gif',56440595284,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881884301,13779442,NULL,NULL,NULL,NULL),(977,560,0,'LSQ12ehh','LSQ',246.801375,2.0835,NULL,NULL,'2012-08-22 00:09:55',56161.0068899998,20.7545,0.1196,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-22 19:45:30','2012-08-22 19:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehh/LSQ12ehh_snap_52703.gif',56440595284,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,881884301,13779442,NULL,NULL,NULL,NULL),(978,611,0,'LSQ12eid','LSQ',4.40816666666667,-5.38280555555555,NULL,NULL,'2012-08-22 08:51:38',56161.36919,18.2795,0.1148,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-22 19:45:30','2012-08-22 19:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_snap_52636.gif',34413529726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537711401,8401740,NULL,NULL,NULL,NULL),(979,795,0,'LSQ12ejn','LSQ',303.868166666667,-22.3699722222222,NULL,NULL,'2012-08-22 06:21:04',56161.2646300001,20.7866,0.1444,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 19:45:30','2012-08-22 19:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejn/LSQ12ejn_snap_52672.gif',50806837566,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,793856836,12404013,NULL,NULL,NULL,NULL),(980,949,0,'LSQ12eld','LSQ',306.787,-4.64338888888889,NULL,NULL,'2012-08-21 23:42:16',56160.9876899999,20.2737,0.1114,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 19:45:30','2012-08-22 19:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_history.html','variable or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_snap_52677.gif',47835908586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747436071,11678688,NULL,NULL,NULL,NULL),(981,949,0,'LSQ12eld','LSQ',306.786958333333,-4.64341666666667,NULL,NULL,'2012-08-22 03:03:27',56161.1274000001,19.4043,0.0528,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 19:45:30','2012-08-22 19:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_history.html','variable or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_snap_52678.gif',47835908586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747436071,11678688,NULL,NULL,NULL,NULL),(982,949,0,'LSQ12eld','LSQ',306.787,-4.64338888888889,NULL,NULL,'2012-08-22 06:02:01',56161.25141,19.6957,0.1128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 19:45:30','2012-08-22 19:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_history.html','variable or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eld/LSQ12eld_snap_52679.gif',47835908586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747436071,11678688,NULL,NULL,NULL,NULL),(983,952,0,'LSQ12elc','LSQ',306.66925,-4.56152777777778,NULL,NULL,'2012-08-21 23:42:16',56160.9876899999,20.4342,0.163,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 19:45:30','2012-08-22 19:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_snap_52674.gif',47834277690,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747410588,11678290,NULL,NULL,NULL,NULL),(984,952,0,'LSQ12elc','LSQ',306.669,-4.56152777777778,NULL,NULL,'2012-08-22 03:03:27',56161.1274000001,20.6085,0.1397,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 19:45:30','2012-08-22 19:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_snap_52675.gif',47834277690,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747410588,11678290,NULL,NULL,NULL,NULL),(985,952,0,'LSQ12elc','LSQ',306.669,-4.5615,NULL,NULL,'2012-08-22 06:02:01',56161.25141,20.4662,0.1104,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 19:45:30','2012-08-22 19:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_snap_52676.gif',47834277690,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747410588,11678290,NULL,NULL,NULL,NULL),(986,986,1,'LSQ12elv','LSQ',44.2788333333333,-21.8778333333333,NULL,NULL,'2012-07-30 08:47:15',56138.3661500001,20.5347,0.1923,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elv/LSQ12elv_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elv/LSQ12elv_snap_52568.gif',38064771756,NULL,NULL,NULL,'2012-07-28 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594762058,9293157,NULL,NULL,NULL,NULL),(987,986,0,'LSQ12elv','LSQ',44.2789583333333,-21.8778611111111,NULL,NULL,'2012-08-21 07:51:18',56160.3273,19.4315,0.1153,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elv/LSQ12elv_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elv/LSQ12elv_snap_52561.gif',38064771756,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594762058,9293157,NULL,NULL,NULL,NULL),(988,986,0,'LSQ12elv','LSQ',44.2790416666667,-21.8779166666667,NULL,NULL,'2012-08-21 09:21:23',56160.3898499999,19.477,0.081,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elv/LSQ12elv_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elv/LSQ12elv_snap_52562.gif',38064771756,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594762058,9293157,NULL,NULL,NULL,NULL),(989,989,0,'LSQ12elu','LSQ',70.4357083333333,-22.9943611111111,NULL,NULL,'2012-08-05 09:31:56',56144.3971799999,18.4014,0.1856,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2019-10-11 20:38:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_snap_52614.gif',37338457798,NULL,NULL,NULL,'2012-01-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,583413403,9115834,NULL,NULL,NULL,NULL),(990,989,0,'LSQ12elu','LSQ',70.435625,-22.9941111111111,NULL,NULL,'2012-08-21 10:01:06',56160.41744,18.8766,0.1078,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2019-09-06 21:34:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_snap_52559.gif',37338457798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,583413403,9115834,NULL,NULL,NULL,NULL),(991,989,0,'LSQ12elu','LSQ',70.4355416666667,-22.9941111111111,NULL,NULL,'2012-08-21 10:07:53',56160.42215,19.3531,0.1404,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2019-09-06 21:34:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_snap_52560.gif',37338457798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,583413403,9115834,NULL,NULL,NULL,NULL),(992,992,1,'LSQ12elt','LSQ',302.779875,-23.1457222222222,NULL,NULL,'2012-08-10 23:24:46',56149.97554,19.3211,0.0824,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52601.gif',50808789842,NULL,NULL,NULL,'2012-07-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(993,992,0,'LSQ12elt','LSQ',302.779791666667,-23.14575,NULL,NULL,'2012-08-11 01:25:03',56150.05907,19.3428,0.0719,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52602.gif',50808789842,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(994,992,0,'LSQ12elt','LSQ',302.779875,-23.14575,NULL,NULL,'2012-08-11 03:26:42',56150.1435500002,19.1923,0.0649,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52603.gif',50808789842,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(995,992,0,'LSQ12elt','LSQ',302.779875,-23.1457222222222,NULL,NULL,'2012-08-11 23:23:28',56150.9746400001,19.1431,0.0804,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52604.gif',50808789842,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(996,992,0,'LSQ12elt','LSQ',302.77975,-23.1456944444444,NULL,NULL,'2012-08-12 01:26:37',56151.0601599999,19.0464,0.0636,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52605.gif',50808789842,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(997,992,0,'LSQ12elt','LSQ',302.779791666667,-23.1457222222222,NULL,NULL,'2012-08-15 00:03:11',56154.0022200001,19.1434,0.0671,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52606.gif',50808789842,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(998,992,0,'LSQ12elt','LSQ',302.779791666667,-23.1456944444444,NULL,NULL,'2012-08-15 02:03:33',56154.0858,19.0994,0.0703,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52607.gif',50808789842,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(999,992,0,'LSQ12elt','LSQ',302.779875,-23.14575,NULL,NULL,'2012-08-15 04:04:10',56154.1695699999,18.6636,0.0788,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52608.gif',50808789842,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(1000,992,0,'LSQ12elt','LSQ',302.779791666667,-23.14575,NULL,NULL,'2012-08-18 04:38:17',56157.1932600001,19.4397,0.0739,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52609.gif',50808789842,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(1001,992,0,'LSQ12elt','LSQ',302.780041666667,-23.1456666666667,NULL,NULL,'2012-08-18 07:21:48',56157.30681,18.9976,0.075,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52610.gif',50808789842,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(1002,992,0,'LSQ12elt','LSQ',302.779791666667,-23.14575,NULL,NULL,'2012-08-20 00:33:55',56159.0235600001,19.5321,0.0829,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52611.gif',50808789842,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(1003,992,0,'LSQ12elt','LSQ',302.779833333333,-23.1457222222222,NULL,NULL,'2012-08-20 02:36:11',56159.1084699999,19.0188,0.0667,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52612.gif',50808789842,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(1004,992,0,'LSQ12elt','LSQ',302.779791666667,-23.1456944444444,NULL,NULL,'2012-08-21 00:20:50',56160.0144699998,19.3765,0.0989,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52557.gif',50808789842,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(1005,992,0,'LSQ12elt','LSQ',302.77975,-23.1457222222222,NULL,NULL,'2012-08-21 02:26:57',56160.1020599999,19.4055,0.0731,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52613.gif',50808789842,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(1006,992,0,'LSQ12elt','LSQ',302.779833333333,-23.1456944444444,NULL,NULL,'2012-08-21 05:32:21',56160.2308100001,19.0433,0.1399,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52558.gif',50808789842,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(1007,992,0,'LSQ12elt','LSQ',302.77975,-23.1457222222222,NULL,NULL,'2012-08-21 23:49:41',56160.99284,19.5218,0.0844,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52689.gif',50808789842,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(1008,992,0,'LSQ12elt','LSQ',302.77975,-23.1457222222222,NULL,NULL,'2012-08-22 03:19:20',56161.1384299998,19.2434,0.0919,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52690.gif',50808789842,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(1009,992,0,'LSQ12elt','LSQ',302.779833333333,-23.14575,NULL,NULL,'2012-08-22 06:21:04',56161.2646300001,19.1294,0.0894,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elt/LSQ12elt_snap_52691.gif',50808789842,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(1010,1010,1,'LSQ12elr','LSQ',76.6274583333333,-25.5124166666667,NULL,NULL,'2012-08-09 10:05:47',56148.4206900001,19.6988,0.1225,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elr/LSQ12elr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elr/LSQ12elr_snap_52579.gif',37247051297,NULL,NULL,NULL,'2012-01-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581985176,9093518,NULL,NULL,NULL,NULL),(1011,1010,0,'LSQ12elr','LSQ',76.62725,-25.5123888888889,NULL,NULL,'2012-08-09 10:16:06',56148.4278500001,19.3985,0.0962,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elr/LSQ12elr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elr/LSQ12elr_snap_52580.gif',37247051297,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581985176,9093518,NULL,NULL,NULL,NULL),(1012,1010,0,'LSQ12elr','LSQ',76.62725,-25.5121388888889,NULL,NULL,'2012-08-21 10:06:11',56160.4209699999,18.6429,0.0671,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elr/LSQ12elr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elr/LSQ12elr_snap_52553.gif',37247051297,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581985176,9093518,NULL,NULL,NULL,NULL),(1013,1010,0,'LSQ12elr','LSQ',76.6272916666667,-25.5120833333333,NULL,NULL,'2012-08-21 10:11:15',56160.4244900001,18.4396,0.0922,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elr/LSQ12elr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elr/LSQ12elr_snap_52554.gif',37247051297,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581985176,9093518,NULL,NULL,NULL,NULL),(1014,1014,0,'LSQ12elq','LSQ',308.064416666667,1.48769444444444,NULL,NULL,'2012-08-19 23:41:36',56158.9872300001,17.5527,0.0166,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2019-10-11 20:38:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elq/LSQ12elq_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elq/LSQ12elq_snap_52575.gif',53996973989,NULL,NULL,NULL,'2012-06-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,843702718,13182854,NULL,NULL,NULL,NULL),(1015,1014,0,'LSQ12elq','LSQ',308.064416666667,1.48772222222222,NULL,NULL,'2012-08-20 01:43:00',56159.0715299998,17.6042,0.0218,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elq/LSQ12elq_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elq/LSQ12elq_snap_52576.gif',53996973989,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,843702718,13182854,NULL,NULL,NULL,NULL),(1016,1014,0,'LSQ12elq','LSQ',308.064375,1.48769444444444,NULL,NULL,'2012-08-20 03:46:01',56159.1569599998,17.4668,0.0342,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elq/LSQ12elq_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elq/LSQ12elq_snap_52577.gif',53996973989,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,843702718,13182854,NULL,NULL,NULL,NULL),(1017,1014,0,'LSQ12elq','LSQ',308.064416666667,1.48769444444444,NULL,NULL,'2012-08-20 23:47:23',56159.99125,17.7419,0.0222,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elq/LSQ12elq_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elq/LSQ12elq_snap_52551.gif',53996973989,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,843702718,13182854,NULL,NULL,NULL,NULL),(1018,1014,0,'LSQ12elq','LSQ',308.064416666667,1.48769444444444,NULL,NULL,'2012-08-21 01:53:23',56160.0787499999,17.6287,0.0352,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elq/LSQ12elq_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elq/LSQ12elq_snap_52578.gif',53996973989,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,843702718,13182854,NULL,NULL,NULL,NULL),(1019,1014,0,'LSQ12elq','LSQ',308.064458333333,1.48769444444444,NULL,NULL,'2012-08-21 03:54:16',56160.1626900001,17.6986,0.0248,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elq/LSQ12elq_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elq/LSQ12elq_snap_52552.gif',53996973989,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,843702718,13182854,NULL,NULL,NULL,NULL),(1020,1020,1,'LSQ12elo','LSQ',318.356583333333,-6.59958333333333,NULL,NULL,'2012-08-12 00:52:05',56151.0361700002,21.1315,0.1853,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elo/LSQ12elo_history.html','sne?',NULL,0.12145,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elo/LSQ12elo_snap_52569.gif',50789822544,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793590977,12399859,NULL,NULL,NULL,NULL),(1021,1020,0,'LSQ12elo','LSQ',318.356666666667,-6.59933333333333,NULL,NULL,'2012-08-20 01:24:42',56159.05883,20.9025,0.2058,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elo/LSQ12elo_history.html','sne?',NULL,0.12145,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elo/LSQ12elo_snap_52570.gif',50789822656,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793590979,12399859,NULL,NULL,NULL,NULL),(1022,1020,0,'LSQ12elo','LSQ',318.356541666667,-6.59958333333333,NULL,NULL,'2012-08-21 00:46:58',56160.0326200002,20.6966,0.1272,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elo/LSQ12elo_history.html','sne?',NULL,0.12145,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elo/LSQ12elo_snap_52571.gif',50789822659,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793590979,12399859,NULL,NULL,NULL,NULL),(1023,1020,0,'LSQ12elo','LSQ',318.356541666667,-6.59955555555555,NULL,NULL,'2012-08-21 03:04:14',56160.1279500001,20.5072,0.1076,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elo/LSQ12elo_history.html','sne?',NULL,0.12145,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elo/LSQ12elo_snap_52547.gif',50789822659,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793590979,12399859,NULL,NULL,NULL,NULL),(1024,1020,0,'LSQ12elo','LSQ',318.3565,-6.59952777777778,NULL,NULL,'2012-08-21 06:02:19',56160.2516200002,20.7612,0.099,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elo/LSQ12elo_history.html','sne?',NULL,0.12145,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elo/LSQ12elo_snap_52548.gif',50789822659,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793590979,12399859,NULL,NULL,NULL,NULL),(1025,1020,0,'LSQ12elo','LSQ',318.35675,-6.59963888888889,NULL,NULL,'2012-08-22 00:14:35',56161.0101299998,20.8919,0.1594,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-22 20:45:31','2012-08-22 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elo/LSQ12elo_history.html','sne?',NULL,0.12145,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elo/LSQ12elo_snap_52685.gif',50789822547,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793590977,12399859,NULL,NULL,NULL,NULL),(1026,1026,1,'LSQ12elz','LSQ',329.397708333333,-0.839194444444444,NULL,NULL,'2012-07-27 02:44:41',56135.1143700001,19.2497,0.1421,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-23 16:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_history.html','sne?',NULL,0.21853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_snap_52796.gif',49826069800,NULL,NULL,NULL,'2012-07-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778532340,12164567,NULL,NULL,NULL,NULL),(1027,1026,0,'LSQ12elz','LSQ',329.397541666667,-0.839111111111111,NULL,NULL,'2012-07-27 04:59:41',56135.2081200001,20.6747,0.1722,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-23 16:45:32','2012-08-23 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_history.html','sne?',NULL,0.21853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_snap_52797.gif',49826069800,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778532340,12164567,NULL,NULL,NULL,NULL),(1028,1026,0,'LSQ12elz','LSQ',329.3975,-0.839166666666667,NULL,NULL,'2012-07-29 04:56:02',56137.2055799998,20.6362,0.1781,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-23 16:45:32','2012-08-23 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_history.html','sne?',NULL,0.21853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_snap_52798.gif',49826069800,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778532340,12164567,NULL,NULL,NULL,NULL),(1029,1026,0,'LSQ12elz','LSQ',329.397416666667,-0.83925,NULL,NULL,'2012-08-08 03:51:59',56147.1611100002,20.1028,0.1492,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-23 16:45:32','2012-08-23 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_history.html','sne?',NULL,0.21853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_snap_52799.gif',49826069800,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778532340,12164567,NULL,NULL,NULL,NULL),(1030,1026,0,'LSQ12elz','LSQ',329.3975,-0.839194444444444,NULL,NULL,'2012-08-22 00:57:14',56161.03975,20.5842,0.1289,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-23 16:45:32','2012-08-23 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_history.html','sne?',NULL,0.21853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_snap_52764.gif',49826069800,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778532340,12164567,NULL,NULL,NULL,NULL),(1031,1026,0,'LSQ12elz','LSQ',329.397375,-0.83925,NULL,NULL,'2012-08-22 04:45:34',56161.19832,21.3092,0.186,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-23 16:45:32','2012-08-23 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_history.html','sne?',NULL,0.21853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_snap_52800.gif',49826069800,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778532340,12164567,NULL,NULL,NULL,NULL),(1032,1026,0,'LSQ12elz','LSQ',329.3975,-0.83925,NULL,NULL,'2012-08-22 07:43:38',56161.3219699999,20.5988,0.138,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-23 16:45:32','2012-08-23 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_history.html','sne?',NULL,0.21853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_snap_52765.gif',49826069800,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778532340,12164567,NULL,NULL,NULL,NULL),(1033,1033,1,'LSQ12ely','LSQ',329.641333333333,-1.70502777777778,NULL,NULL,'2012-07-09 05:50:02',56117.24309,19.9718,0.1718,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-23 16:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ely/LSQ12ely_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ely/LSQ12ely_snap_52793.gif',49828188398,NULL,NULL,NULL,'2012-07-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778565443,12165085,NULL,NULL,NULL,NULL),(1034,1033,0,'LSQ12ely','LSQ',329.641291666667,-1.70505555555556,NULL,NULL,'2012-07-21 06:14:38',56129.2601700001,19.2222,0.1838,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-23 16:45:32','2012-08-23 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ely/LSQ12ely_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ely/LSQ12ely_snap_52794.gif',49828188398,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778565443,12165085,NULL,NULL,NULL,NULL),(1035,1033,0,'LSQ12ely','LSQ',329.641291666667,-1.70488888888889,NULL,NULL,'2012-07-23 05:17:06',56131.2202099999,19.2154,0.1491,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-23 16:45:32','2012-08-23 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ely/LSQ12ely_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ely/LSQ12ely_snap_52795.gif',49828188398,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778565443,12165085,NULL,NULL,NULL,NULL),(1036,1033,0,'LSQ12ely','LSQ',329.641333333333,-1.70502777777778,NULL,NULL,'2012-08-22 04:45:34',56161.19832,20.7335,0.1353,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-23 16:45:32','2012-08-23 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ely/LSQ12ely_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ely/LSQ12ely_snap_52762.gif',49828188398,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778565443,12165085,NULL,NULL,NULL,NULL),(1037,1033,0,'LSQ12ely','LSQ',329.64125,-1.705,NULL,NULL,'2012-08-22 07:43:38',56161.3219699999,19.8428,0.1422,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-23 16:45:32','2012-08-23 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ely/LSQ12ely_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ely/LSQ12ely_snap_52763.gif',49828188398,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778565443,12165085,NULL,NULL,NULL,NULL),(1038,952,0,'LSQ12elc','LSQ',306.669375,-4.56163888888889,NULL,NULL,'2012-08-23 01:28:05',56162.0611800002,19.6242,0.1023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-23 19:45:32','2012-08-23 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_snap_52832.gif',47834277690,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747410588,11678290,NULL,NULL,NULL,NULL),(1039,952,0,'LSQ12elc','LSQ',306.66925,-4.56147222222222,NULL,NULL,'2012-08-23 04:04:41',56162.1699199998,20.6075,0.1414,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-23 19:45:32','2012-08-23 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elc/LSQ12elc_snap_52833.gif',47834277690,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747410588,11678290,NULL,NULL,NULL,NULL),(1040,1026,0,'LSQ12elz','LSQ',329.397666666667,-0.839138888888889,NULL,NULL,'2012-08-23 02:09:05',56162.08965,20.3251,0.1513,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-23 19:45:32','2012-08-23 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_history.html','sne?',NULL,0.21853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_snap_52818.gif',49826069800,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778532340,12164567,NULL,NULL,NULL,NULL),(1041,1026,0,'LSQ12elz','LSQ',329.397291666667,-0.839194444444444,NULL,NULL,'2012-08-23 04:38:15',56162.1932399999,21.187,0.1859,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-23 19:45:32','2012-08-23 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_history.html','sne?',NULL,0.21853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_snap_52819.gif',49826069800,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778532340,12164567,NULL,NULL,NULL,NULL),(1042,1042,1,'LSQ12emd','LSQ',306.4815,-6.20341666666667,NULL,NULL,'2012-08-20 02:13:10',56159.0924800001,21.4843,0.1707,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-24 16:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emd/LSQ12emd_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emd/LSQ12emd_snap_52870.gif',47825825943,NULL,NULL,NULL,'2012-06-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747278530,11676227,NULL,NULL,NULL,NULL),(1043,1042,0,'LSQ12emd','LSQ',306.481208333333,-6.20305555555556,NULL,NULL,'2012-08-21 00:02:09',56160.0014999998,20.8046,0.1803,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-24 16:45:32','2012-08-24 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emd/LSQ12emd_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emd/LSQ12emd_snap_52885.gif',47825825941,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747278530,11676227,NULL,NULL,NULL,NULL),(1044,1042,0,'LSQ12emd','LSQ',306.4815,-6.20327777777778,NULL,NULL,'2012-08-22 06:02:01',56161.25141,20.5466,0.1132,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-24 16:45:32','2012-08-24 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emd/LSQ12emd_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emd/LSQ12emd_snap_52871.gif',47825825943,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747278530,11676227,NULL,NULL,NULL,NULL),(1045,1042,0,'LSQ12emd','LSQ',306.481958333333,-6.20352777777778,NULL,NULL,'2012-08-23 01:28:05',56162.0611800002,21.1954,0.1484,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-24 16:45:32','2012-08-24 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emd/LSQ12emd_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emd/LSQ12emd_snap_52868.gif',47825825942,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747278530,11676227,NULL,NULL,NULL,NULL),(1046,1042,0,'LSQ12emd','LSQ',306.482375,-6.20347222222222,NULL,NULL,'2012-08-23 04:04:41',56162.1699199998,20.9133,0.1603,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-24 16:45:32','2012-08-24 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emd/LSQ12emd_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emd/LSQ12emd_snap_52869.gif',47825825942,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747278530,11676227,NULL,NULL,NULL,NULL),(1047,1047,1,'LSQ12emc','LSQ',309.749333333333,-5.03875,NULL,NULL,'2012-08-20 00:10:56',56159.0076000001,19.3838,0.1125,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-24 16:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emc/LSQ12emc_history.html','variable or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emc/LSQ12emc_snap_52880.gif',47839885908,NULL,NULL,NULL,'2012-06-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747498217,11679659,NULL,NULL,NULL,NULL),(1048,1047,0,'LSQ12emc','LSQ',309.749458333333,-5.03869444444444,NULL,NULL,'2012-08-21 00:02:09',56160.0014999998,19.3938,0.0994,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-24 16:45:32','2012-08-24 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emc/LSQ12emc_history.html','variable or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emc/LSQ12emc_snap_52881.gif',47839885908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747498217,11679659,NULL,NULL,NULL,NULL),(1049,1047,0,'LSQ12emc','LSQ',309.7495,-5.03869444444444,NULL,NULL,'2012-08-21 04:09:03',56160.1729600001,19.3936,0.0858,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-24 16:45:32','2012-08-24 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emc/LSQ12emc_history.html','variable or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emc/LSQ12emc_snap_52882.gif',47839885908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747498217,11679659,NULL,NULL,NULL,NULL),(1050,1047,0,'LSQ12emc','LSQ',309.749416666667,-5.03869444444444,NULL,NULL,'2012-08-21 23:42:16',56160.9876899999,19.3605,0.0892,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-24 16:45:32','2012-08-24 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emc/LSQ12emc_history.html','variable or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emc/LSQ12emc_snap_52883.gif',47839885908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747498217,11679659,NULL,NULL,NULL,NULL),(1051,1047,0,'LSQ12emc','LSQ',309.7495,-5.03861111111111,NULL,NULL,'2012-08-22 06:02:01',56161.25141,19.2165,0.0908,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-24 16:45:32','2012-08-24 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emc/LSQ12emc_history.html','variable or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emc/LSQ12emc_snap_52884.gif',47839885908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747498217,11679659,NULL,NULL,NULL,NULL),(1052,1047,0,'LSQ12emc','LSQ',309.7495,-5.03858333333333,NULL,NULL,'2012-08-23 01:28:05',56162.0611800002,19.1097,0.1191,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-24 16:45:32','2012-08-24 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emc/LSQ12emc_history.html','variable or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emc/LSQ12emc_snap_52866.gif',47839885908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747498217,11679659,NULL,NULL,NULL,NULL),(1053,1047,0,'LSQ12emc','LSQ',309.7495,-5.03866666666667,NULL,NULL,'2012-08-23 04:04:41',56162.1699199998,18.9505,0.1193,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-24 16:45:32','2012-08-24 16:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emc/LSQ12emc_history.html','variable or sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emc/LSQ12emc_snap_52867.gif',47839885908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747498217,11679659,NULL,NULL,NULL,NULL),(1054,581,0,'LSQ12ehl','LSQ',72.5276666666667,-21.7752777777778,NULL,NULL,'2012-08-25 09:03:21',56164.37733,18.8282,0.0428,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-25 18:45:29','2012-08-25 18:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_snap_52886.gif',37345461187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583522831,9117544,NULL,NULL,NULL,NULL),(1055,581,0,'LSQ12ehl','LSQ',72.5277083333333,-21.7752777777778,NULL,NULL,'2012-08-25 09:43:11',56164.4049999998,19.0207,0.0468,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-25 18:45:29','2012-08-25 18:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_snap_52887.gif',37345461187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583522831,9117544,NULL,NULL,NULL,NULL),(1056,986,0,'LSQ12elv','LSQ',44.2789583333333,-21.8779166666667,NULL,NULL,'2012-08-25 08:39:39',56164.36087,19.6973,0.1371,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-25 18:45:29','2012-08-25 18:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elv/LSQ12elv_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elv/LSQ12elv_snap_52914.gif',38064771756,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594762058,9293157,NULL,NULL,NULL,NULL),(1057,986,0,'LSQ12elv','LSQ',44.2789583333333,-21.8779444444444,NULL,NULL,'2012-08-25 09:55:02',56164.41322,19.6357,0.1046,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-25 18:45:29','2012-08-25 18:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elv/LSQ12elv_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elv/LSQ12elv_snap_52915.gif',38064771756,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594762058,9293157,NULL,NULL,NULL,NULL),(1058,989,0,'LSQ12elu','LSQ',70.435625,-22.9941388888889,NULL,NULL,'2012-08-25 08:59:58',56164.3749799998,19.2729,0.0812,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-25 18:45:29','2019-09-06 21:34:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_snap_52912.gif',37338457798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,583413403,9115834,NULL,NULL,NULL,NULL),(1059,989,0,'LSQ12elu','LSQ',70.435625,-22.9941111111111,NULL,NULL,'2012-08-25 09:44:53',56164.4061799999,19.3408,0.0869,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-25 18:45:29','2019-09-06 21:34:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_snap_52913.gif',37338457798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,583413403,9115834,NULL,NULL,NULL,NULL),(1060,1060,1,'LSQ12emi','LSQ',75.0574583333333,-22.1881666666667,NULL,NULL,'2012-08-21 10:04:30',56160.4197999998,19.515,0.0948,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-25 21:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emi/LSQ12emi_history.html','sne-nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emi/LSQ12emi_snap_52954.gif',37549808027,NULL,NULL,NULL,'2012-08-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586715750,9167433,NULL,NULL,NULL,NULL),(1061,1060,0,'LSQ12emi','LSQ',75.0574166666667,-22.1882222222222,NULL,NULL,'2012-08-21 10:12:57',56160.4256600002,19.6254,0.1912,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-25 21:45:29','2012-08-25 21:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emi/LSQ12emi_history.html','sne-nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emi/LSQ12emi_snap_52955.gif',37549808027,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586715750,9167433,NULL,NULL,NULL,NULL),(1062,1060,0,'LSQ12emi','LSQ',75.0574583333333,-22.1883055555556,NULL,NULL,'2012-08-25 09:03:21',56164.37733,19.5697,0.0938,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-25 21:45:29','2012-08-25 21:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emi/LSQ12emi_history.html','sne-nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emi/LSQ12emi_snap_52932.gif',37549808027,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586715750,9167433,NULL,NULL,NULL,NULL),(1063,1060,0,'LSQ12emi','LSQ',75.0574166666667,-22.18825,NULL,NULL,'2012-08-25 09:43:11',56164.4049999998,19.5834,0.0784,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-25 21:45:29','2012-08-25 21:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emi/LSQ12emi_history.html','sne-nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emi/LSQ12emi_snap_52933.gif',37549808027,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586715750,9167433,NULL,NULL,NULL,NULL),(1064,402,0,'LSQ12dzd','LSQ',4.16229166666667,-0.357944444444444,NULL,NULL,'2012-08-26 09:10:30',56165.3823000002,19.0475,0.0779,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzd/LSQ12dzd_history.html','sne???',NULL,0.07471,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzd/LSQ12dzd_snap_53085.gif',34372011761,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537062683,8391604,NULL,NULL,NULL,NULL),(1065,402,0,'LSQ12dzd','LSQ',4.1625,-0.357944444444444,NULL,NULL,'2012-08-26 09:41:48',56165.4040299999,19.934,0.134,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzd/LSQ12dzd_history.html','sne???',NULL,0.07471,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzd/LSQ12dzd_snap_53086.gif',34372011761,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537062683,8391604,NULL,NULL,NULL,NULL),(1066,457,0,'LSQ12edo','LSQ',51.5786666666667,-3.29769444444444,NULL,NULL,'2012-08-26 09:51:06',56165.4104900002,18.9175,0.0937,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_snap_53039.gif',36842019075,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575656548,8994633,NULL,NULL,NULL,NULL),(1067,462,0,'LSQ12edk','LSQ',47.2392916666667,-2.95436111111111,NULL,NULL,'2012-08-26 08:47:35',56165.36638,18.8661,0.1453,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_history.html','sne',NULL,0.0082,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_snap_53052.gif',36790348536,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574849195,8982018,NULL,NULL,NULL,NULL),(1068,462,0,'LSQ12edk','LSQ',47.23925,-2.95427777777778,NULL,NULL,'2012-08-26 09:29:06',56165.3952100002,18.902,0.1572,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_history.html','sne',NULL,0.0082,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_snap_53053.gif',36790348504,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574849195,8982018,NULL,NULL,NULL,NULL),(1069,611,0,'LSQ12eid','LSQ',4.40825,-5.38275,NULL,NULL,'2012-08-26 08:10:16',56165.3404700002,18.7774,0.0438,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_snap_52990.gif',34413529726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537711401,8401740,NULL,NULL,NULL,NULL),(1070,617,0,'LSQ12eib','LSQ',8.041125,-7.38158333333333,NULL,NULL,'2012-08-26 08:15:23',56165.3440200002,20.4817,0.1235,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_snap_52994.gif',34627856132,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541060252,8454066,NULL,NULL,NULL,NULL),(1071,617,0,'LSQ12eib','LSQ',8.04104166666667,-7.38155555555555,NULL,NULL,'2012-08-26 09:13:53',56165.3846499999,19.8223,0.0899,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_snap_52995.gif',34627856132,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541060252,8454066,NULL,NULL,NULL,NULL),(1072,646,0,'LSQ12eiq','LSQ',32.5293333333333,-5.57611111111111,NULL,NULL,'2012-08-26 08:34:03',56165.3569899998,18.9154,0.0403,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_snap_53023.gif',35142165909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549096342,8579630,NULL,NULL,NULL,NULL),(1073,646,0,'LSQ12eiq','LSQ',32.529375,-5.57611111111111,NULL,NULL,'2012-08-26 09:22:20',56165.3905099998,18.8506,0.04,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_snap_53024.gif',35142165909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549096342,8579630,NULL,NULL,NULL,NULL),(1074,697,0,'LSQ12eix','LSQ',40.224125,-6.53877777777778,NULL,NULL,'2012-08-26 08:42:31',56165.3628600002,19.7193,0.1069,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_53033.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(1075,697,0,'LSQ12eix','LSQ',40.2241666666667,-6.53877777777778,NULL,NULL,'2012-08-26 09:27:24',56165.3940300001,19.6545,0.1316,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_53034.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(1076,722,0,'LSQ12eir','LSQ',34.10075,-3.01938888888889,NULL,NULL,'2012-08-26 08:35:45',56165.3581599998,19.4493,0.1168,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_snap_53027.gif',35133634952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548963046,8577547,NULL,NULL,NULL,NULL),(1077,722,0,'LSQ12eir','LSQ',34.1007916666667,-3.01938888888889,NULL,NULL,'2012-08-26 09:24:01',56165.3916799999,19.2985,0.1015,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_snap_53028.gif',35133634952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548963046,8577547,NULL,NULL,NULL,NULL),(1078,726,0,'LSQ12eil','LSQ',1.67283333333333,-6.28097222222222,NULL,NULL,'2012-08-26 08:08:36',56165.3393100002,20.1979,0.1904,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eil/LSQ12eil_history.html','sne - young ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eil/LSQ12eil_snap_53036.gif',34387815364,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537309615,8395462,NULL,NULL,NULL,NULL),(1079,915,0,'LSQ12elk','LSQ',31.3317916666667,-5.97230555555556,NULL,NULL,'2012-08-26 08:35:45',56165.3581599998,19.2845,0.0608,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_snap_53079.gif',35137599396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,549024990,8578515,NULL,NULL,NULL,NULL),(1080,915,0,'LSQ12elk','LSQ',31.3318333333333,-5.97233333333333,NULL,NULL,'2012-08-26 09:24:01',56165.3916799999,19.4607,0.0635,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_snap_53080.gif',35137599396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,549024990,8578515,NULL,NULL,NULL,NULL),(1081,934,0,'LSQ12eli','LSQ',51.1981666666667,-6.86366666666667,NULL,NULL,'2012-08-26 08:50:58',56165.3687300002,18.9486,0.0846,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eli/LSQ12eli_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eli/LSQ12eli_snap_53077.gif',36804372250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,575068316,8985442,NULL,NULL,NULL,NULL),(1082,934,0,'LSQ12eli','LSQ',51.19825,-6.86363888888889,NULL,NULL,'2012-08-26 09:52:47',56165.4116600002,18.6298,0.1138,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eli/LSQ12eli_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eli/LSQ12eli_snap_53078.gif',36804372250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,575068316,8985442,NULL,NULL,NULL,NULL),(1083,938,0,'LSQ12elh','LSQ',51.3041666666667,-6.1345,NULL,NULL,'2012-08-26 08:52:39',56165.3698999998,19.3682,0.1257,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elh/LSQ12elh_history.html','sne?',NULL,0.06982,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elh/LSQ12elh_snap_53075.gif',36803371237,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575052675,8985198,NULL,NULL,NULL,NULL),(1084,938,0,'LSQ12elh','LSQ',51.3041666666667,-6.13441666666667,NULL,NULL,'2012-08-26 09:51:06',56165.4104900002,19.2186,0.1035,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elh/LSQ12elh_history.html','sne?',NULL,0.06982,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elh/LSQ12elh_snap_53076.gif',36803371237,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575052675,8985198,NULL,NULL,NULL,NULL),(1085,944,0,'LSQ12elf','LSQ',57.3404583333333,-3.49952777777778,NULL,NULL,'2012-08-26 08:56:03',56165.3722600001,19.6812,0.1249,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elf/LSQ12elf_history.html','possibly old sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elf/LSQ12elf_snap_53073.gif',37009717198,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578276831,9035575,NULL,NULL,NULL,NULL),(1086,944,0,'LSQ12elf','LSQ',57.3405833333333,-3.49944444444444,NULL,NULL,'2012-08-26 09:34:10',56165.39873,19.5682,0.0941,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elf/LSQ12elf_history.html','possibly old sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elf/LSQ12elf_snap_53074.gif',37009717198,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578276831,9035575,NULL,NULL,NULL,NULL),(1087,947,0,'LSQ12ele','LSQ',62.6979166666667,-7.07033333333333,NULL,NULL,'2012-08-26 08:59:24',56165.3745900001,19.7283,0.1586,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ele/LSQ12ele_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ele/LSQ12ele_snap_53071.gif',36955954114,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577436783,9022449,NULL,NULL,NULL,NULL),(1088,947,0,'LSQ12ele','LSQ',62.6977916666667,-7.07005555555556,NULL,NULL,'2012-08-26 09:47:43',56165.40814,19.7023,0.1225,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-26 16:45:29','2012-08-26 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ele/LSQ12ele_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ele/LSQ12ele_snap_53072.gif',36955954125,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577436783,9022449,NULL,NULL,NULL,NULL),(1089,1089,1,'LSQ12emj','LSQ',12.5860416666667,-4.175,NULL,NULL,'2012-07-07 08:43:48',56115.3637600001,20.2947,0.1783,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 01:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emj/LSQ12emj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emj/LSQ12emj_snap_53246.gif',34518817227,NULL,NULL,NULL,'2012-07-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539356519,8427445,NULL,NULL,NULL,NULL),(1090,1089,0,'LSQ12emj','LSQ',12.5860416666667,-4.17511111111111,NULL,NULL,'2012-07-19 10:34:11',56127.4404099998,20.4209,0.1748,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 01:45:31','2012-08-27 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emj/LSQ12emj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emj/LSQ12emj_snap_53247.gif',34518817227,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539356519,8427445,NULL,NULL,NULL,NULL),(1091,1089,0,'LSQ12emj','LSQ',12.5860833333333,-4.17530555555556,NULL,NULL,'2012-08-04 05:04:52',56143.21172,19.749,0.2091,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 01:45:31','2012-08-27 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emj/LSQ12emj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emj/LSQ12emj_snap_53248.gif',34518817227,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539356519,8427445,NULL,NULL,NULL,NULL),(1092,1089,0,'LSQ12emj','LSQ',12.5856666666667,-4.17527777777778,NULL,NULL,'2012-08-10 08:32:17',56149.3557600002,21.4005,0.1732,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 01:45:31','2012-08-27 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emj/LSQ12emj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emj/LSQ12emj_snap_53249.gif',34518817225,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539356519,8427445,NULL,NULL,NULL,NULL),(1093,1089,0,'LSQ12emj','LSQ',12.585875,-4.175,NULL,NULL,'2012-08-12 08:00:30',56151.3336900002,21.2702,0.172,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 01:45:31','2012-08-27 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emj/LSQ12emj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emj/LSQ12emj_snap_53250.gif',34518817227,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539356519,8427445,NULL,NULL,NULL,NULL),(1094,1089,0,'LSQ12emj','LSQ',12.585625,-4.17530555555556,NULL,NULL,'2012-08-20 09:34:49',56159.3991800002,21.4064,0.1642,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 01:45:31','2012-08-27 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emj/LSQ12emj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emj/LSQ12emj_snap_53251.gif',34518817225,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539356519,8427445,NULL,NULL,NULL,NULL),(1095,1089,0,'LSQ12emj','LSQ',12.5855833333333,-4.17505555555556,NULL,NULL,'2012-08-26 08:17:04',56165.3451899998,21.1432,0.1329,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 01:45:31','2012-08-27 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emj/LSQ12emj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emj/LSQ12emj_snap_53195.gif',34518817225,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539356519,8427445,NULL,NULL,NULL,NULL),(1096,1089,0,'LSQ12emj','LSQ',12.5858333333333,-4.17522222222222,NULL,NULL,'2012-08-26 10:09:42',56165.4234099998,21.0108,0.1675,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 01:45:31','2012-08-27 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emj/LSQ12emj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emj/LSQ12emj_snap_53196.gif',34518817227,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539356519,8427445,NULL,NULL,NULL,NULL),(1097,1097,1,'LSQ12enc','LSQ',66.971125,-3.19430555555556,NULL,NULL,'2012-08-26 09:02:49',56165.37696,19.2688,0.0874,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enc/LSQ12enc_history.html','sne??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enc/LSQ12enc_snap_53399.gif',36919365798,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,576865090,9013517,NULL,NULL,NULL,NULL),(1098,1097,0,'LSQ12enc','LSQ',66.9710416666667,-3.19430555555556,NULL,NULL,'2012-08-26 09:37:34',56165.4010899998,19.1231,0.0831,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2012-08-27 02:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enc/LSQ12enc_history.html','sne??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enc/LSQ12enc_snap_53400.gif',36919366489,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,576865101,9013517,NULL,NULL,NULL,NULL),(1099,1099,1,'LSQ12enb','LSQ',4.19720833333333,-0.644222222222222,NULL,NULL,'2012-07-07 06:21:55',56115.26523,19.0028,0.1352,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_history.html','agn?',NULL,0.06394,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_snap_53391.gif',34371929527,NULL,NULL,NULL,'2012-07-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537061398,8391584,NULL,NULL,NULL,NULL),(1100,1099,0,'LSQ12enb','LSQ',4.19716666666667,-0.644305555555556,NULL,NULL,'2012-07-23 07:39:39',56131.3192099999,18.6262,0.0863,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2012-08-27 02:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_history.html','agn?',NULL,0.06394,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_snap_53392.gif',34371929527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537061398,8391584,NULL,NULL,NULL,NULL),(1101,1099,0,'LSQ12enb','LSQ',4.196625,-0.644527777777778,NULL,NULL,'2012-07-23 10:11:26',56131.4246100001,19.1626,0.1615,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2012-08-27 02:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_history.html','agn?',NULL,0.06394,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_snap_53393.gif',34371929527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537061398,8391584,NULL,NULL,NULL,NULL),(1102,1099,0,'LSQ12enb','LSQ',4.197125,-0.644083333333333,NULL,NULL,'2012-07-29 08:56:42',56137.3727099998,20.4878,0.171,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2012-08-27 02:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_history.html','agn?',NULL,0.06394,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_snap_53394.gif',34371929527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537061398,8391584,NULL,NULL,NULL,NULL),(1103,1099,0,'LSQ12enb','LSQ',4.19720833333333,-0.644277777777778,NULL,NULL,'2012-07-31 09:13:00',56139.3840299998,18.8649,0.0857,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2012-08-27 02:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_history.html','agn?',NULL,0.06394,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_snap_53395.gif',34371929527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537061398,8391584,NULL,NULL,NULL,NULL),(1104,1099,0,'LSQ12enb','LSQ',4.197,-0.644416666666667,NULL,NULL,'2012-08-08 09:39:29',56147.4024200002,19.1552,0.1123,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2012-08-27 02:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_history.html','agn?',NULL,0.06394,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_snap_53396.gif',34371929527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537061398,8391584,NULL,NULL,NULL,NULL),(1105,1099,0,'LSQ12enb','LSQ',4.19716666666667,-0.644583333333333,NULL,NULL,'2012-08-10 09:45:32',56149.4066300001,19.5076,0.1523,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2012-08-27 02:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_history.html','agn?',NULL,0.06394,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_snap_53397.gif',34371929527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537061398,8391584,NULL,NULL,NULL,NULL),(1106,1099,0,'LSQ12enb','LSQ',4.197125,-0.644694444444444,NULL,NULL,'2012-08-10 10:14:13',56149.42655,19.9569,0.1573,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2012-08-27 02:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_history.html','agn?',NULL,0.06394,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_snap_53398.gif',34371929527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537061398,8391584,NULL,NULL,NULL,NULL),(1107,1099,0,'LSQ12enb','LSQ',4.19725,-0.644277777777778,NULL,NULL,'2012-08-26 09:08:48',56165.38112,18.6988,0.0493,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2012-08-27 02:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_history.html','agn?',NULL,0.06394,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_snap_53231.gif',34371929527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537061398,8391584,NULL,NULL,NULL,NULL),(1108,1099,0,'LSQ12enb','LSQ',4.196875,-0.644277777777778,NULL,NULL,'2012-08-26 09:43:30',56165.40521,19.7993,0.1371,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2012-08-27 02:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_history.html','agn?',NULL,0.06394,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_snap_53232.gif',34371929527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537061398,8391584,NULL,NULL,NULL,NULL),(1109,1109,1,'LSQ12emx','LSQ',57.5732083333333,-5.23116666666667,NULL,NULL,'2012-08-20 10:07:30',56159.4218799998,18.6131,0.1268,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emx/LSQ12emx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emx/LSQ12emx_snap_53387.gif',37007224837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578237888,9034967,NULL,NULL,NULL,NULL),(1110,1109,0,'LSQ12emx','LSQ',57.5730833333333,-5.23119444444444,NULL,NULL,'2012-08-26 08:56:03',56165.3722600001,18.577,0.1025,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2012-08-27 02:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emx/LSQ12emx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emx/LSQ12emx_snap_53223.gif',37007224837,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578237888,9034967,NULL,NULL,NULL,NULL),(1111,1109,0,'LSQ12emx','LSQ',57.573,-5.23122222222222,NULL,NULL,'2012-08-26 09:34:10',56165.39873,18.787,0.1209,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2012-08-27 02:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emx/LSQ12emx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emx/LSQ12emx_snap_53224.gif',37007224837,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578237888,9034967,NULL,NULL,NULL,NULL),(1112,1112,1,'LSQ12emp','LSQ',40.585625,-6.70636111111111,NULL,NULL,'2012-07-15 10:18:38',56123.42961,19.8279,0.1098,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emp/LSQ12emp_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emp/LSQ12emp_snap_53313.gif',37874773295,NULL,NULL,NULL,'2012-07-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,591793332,9246770,NULL,NULL,NULL,NULL),(1113,1112,0,'LSQ12emp','LSQ',40.584875,-6.70658333333333,NULL,NULL,'2012-07-17 10:19:57',56125.43053,20.1442,0.1508,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2012-08-27 02:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emp/LSQ12emp_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emp/LSQ12emp_snap_53314.gif',37874773293,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,591793332,9246770,NULL,NULL,NULL,NULL),(1114,1112,0,'LSQ12emp','LSQ',40.5847083333333,-6.70655555555556,NULL,NULL,'2012-07-23 10:15:15',56131.4272599998,20.151,0.1463,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2012-08-27 02:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emp/LSQ12emp_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emp/LSQ12emp_snap_53315.gif',37874773293,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,591793332,9246770,NULL,NULL,NULL,NULL),(1115,1112,0,'LSQ12emp','LSQ',40.5857916666667,-6.70641666666667,NULL,NULL,'2012-07-31 09:53:40',56139.4122799998,20.0724,0.1929,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2012-08-27 02:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emp/LSQ12emp_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emp/LSQ12emp_snap_53316.gif',37874773295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,591793332,9246770,NULL,NULL,NULL,NULL),(1116,1112,0,'LSQ12emp','LSQ',40.585375,-6.70655555555556,NULL,NULL,'2012-08-26 08:40:49',56165.3616800001,19.9282,0.1072,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2012-08-27 02:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emp/LSQ12emp_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emp/LSQ12emp_snap_53207.gif',37874773293,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,591793332,9246770,NULL,NULL,NULL,NULL),(1117,1112,0,'LSQ12emp','LSQ',40.5850416666667,-6.70652777777778,NULL,NULL,'2012-08-26 09:25:43',56165.39286,20.2336,0.1159,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-27 02:45:39','2012-08-27 02:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emp/LSQ12emp_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emp/LSQ12emp_snap_53208.gif',37874773293,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,591793332,9246770,NULL,NULL,NULL,NULL),(1118,1118,1,'LSQ12egy','LSQ',359.941416666667,-6.35219444444444,NULL,NULL,'2012-08-08 06:09:08',56147.2563499999,19.0941,0.1415,'gr-LSQ',NULL,NULL,'II',NULL,'2012-08-27 19:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_snap_50369.gif',49430463909,NULL,NULL,NULL,'2012-08-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772350998,12067984,NULL,NULL,NULL,NULL),(1119,1118,0,'LSQ12egy','LSQ',359.941458333333,-6.35219444444444,NULL,NULL,'2012-08-08 08:09:33',56147.3399700001,18.7328,0.1009,'gr-LSQ',NULL,NULL,'II',NULL,'2012-08-27 19:45:32','2012-08-27 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_snap_50370.gif',49430463909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772350998,12067984,NULL,NULL,NULL,NULL),(1120,1118,0,'LSQ12egy','LSQ',359.9415,-6.35222222222222,NULL,NULL,'2012-08-10 06:26:17',56149.2682599998,18.904,0.1087,'gr-LSQ',NULL,NULL,'II',NULL,'2012-08-27 19:45:32','2012-08-27 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_snap_50900.gif',49430463909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772350998,12067984,NULL,NULL,NULL,NULL),(1121,1118,0,'LSQ12egy','LSQ',359.941625,-6.35230555555555,NULL,NULL,'2012-08-10 08:25:41',56149.3511700002,18.9583,0.0743,'gr-LSQ',NULL,NULL,'II',NULL,'2012-08-27 19:45:32','2012-08-27 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_snap_50901.gif',49430463909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772350998,12067984,NULL,NULL,NULL,NULL),(1122,1118,0,'LSQ12egy','LSQ',359.941583333333,-6.35219444444444,NULL,NULL,'2012-08-12 07:52:03',56151.3278199998,19.1808,0.071,'gr-LSQ',NULL,NULL,'II',NULL,'2012-08-27 19:45:32','2012-08-27 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_snap_51310.gif',49430463909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772350998,12067984,NULL,NULL,NULL,NULL),(1123,1118,0,'LSQ12egy','LSQ',359.941625,-6.35211111111111,NULL,NULL,'2012-08-12 09:57:12',56151.4147299998,18.8652,0.0954,'gr-LSQ',NULL,NULL,'II',NULL,'2012-08-27 19:45:32','2012-08-27 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_snap_51311.gif',49430463909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772350998,12067984,NULL,NULL,NULL,NULL),(1124,1118,0,'LSQ12egy','LSQ',359.941291666667,-6.35213888888889,NULL,NULL,'2012-08-20 07:29:02',56159.31183,19.3463,0.0988,'gr-LSQ',NULL,NULL,'II',NULL,'2012-08-27 19:45:32','2012-08-27 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_snap_52220.gif',49430463909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772350998,12067984,NULL,NULL,NULL,NULL),(1125,1118,0,'LSQ12egy','LSQ',359.941583333333,-6.35216666666667,NULL,NULL,'2012-08-20 09:43:17',56159.4050599998,19.2605,0.0872,'gr-LSQ',NULL,NULL,'II',NULL,'2012-08-27 19:45:32','2012-08-27 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_snap_52221.gif',49430463909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772350998,12067984,NULL,NULL,NULL,NULL),(1126,1118,0,'LSQ12egy','LSQ',359.941625,-6.35225,NULL,NULL,'2012-08-26 08:08:36',56165.3393100002,19.3601,0.1331,'gr-LSQ',NULL,NULL,'II',NULL,'2012-08-27 19:45:32','2012-08-27 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_snap_53087.gif',49430463909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772350998,12067984,NULL,NULL,NULL,NULL),(1127,435,0,'LSQ12ecb','LSQ',337.794583333333,-24.8874444444444,NULL,NULL,'2012-08-27 01:43:05',56166.0715899998,19.2714,0.1103,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 06:45:33','2012-08-28 06:45:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_53505.gif',50073090666,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(1128,435,0,'LSQ12ecb','LSQ',337.794958333333,-24.8874722222222,NULL,NULL,'2012-08-27 01:44:45',56166.0727499998,19.4947,0.1531,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 06:45:33','2012-08-28 06:45:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_53503.gif',50073090668,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(1129,435,0,'LSQ12ecb','LSQ',337.794666666667,-24.8875277777778,NULL,NULL,'2012-08-27 03:53:30',56166.1621599998,19.3107,0.1074,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 06:45:33','2012-08-28 06:45:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_53506.gif',50073090666,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(1130,435,0,'LSQ12ecb','LSQ',337.794541666667,-24.8873888888889,NULL,NULL,'2012-08-27 03:55:11',56166.1633299999,19.2821,0.1668,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 06:45:33','2012-08-28 06:45:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_history.html','sne',NULL,0.0819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ecb/LSQ12ecb_snap_53504.gif',50073090666,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(1131,573,0,'LSQ12ehn','LSQ',53.8109166666667,-18.4273611111111,NULL,NULL,'2012-08-27 08:40:17',56166.3613100001,20.0597,0.0749,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 06:45:33','2012-08-28 06:45:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_history.html','variable or unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_snap_53463.gif',38005697462,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,593839022,9278734,NULL,NULL,NULL,NULL),(1132,573,0,'LSQ12ehn','LSQ',53.8109583333333,-18.4274166666667,NULL,NULL,'2012-08-27 09:24:48',56166.3922299999,20.0903,0.0888,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 06:45:33','2012-08-28 06:45:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_history.html','variable or unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_snap_53464.gif',38005697462,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,593839022,9278734,NULL,NULL,NULL,NULL),(1133,581,0,'LSQ12ehl','LSQ',72.5276666666667,-21.7752777777778,NULL,NULL,'2012-08-27 08:25:03',56166.3507300001,18.9516,0.0465,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 06:45:33','2012-08-28 06:45:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_snap_53448.gif',37345461187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583522831,9117544,NULL,NULL,NULL,NULL),(1134,581,0,'LSQ12ehl','LSQ',72.5277083333333,-21.77525,NULL,NULL,'2012-08-27 09:23:05',56166.3910400001,18.9322,0.0434,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 06:45:33','2012-08-28 06:45:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_snap_53449.gif',37345461187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583522831,9117544,NULL,NULL,NULL,NULL),(1135,729,0,'LSQ12eig','LSQ',335.276666666667,-16.6261388888889,NULL,NULL,'2012-08-27 01:32:55',56166.0645300001,19.0308,0.1046,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 06:45:33','2012-08-28 06:45:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eig/LSQ12eig_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eig/LSQ12eig_snap_53508.gif',50238735841,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784980247,12265316,NULL,NULL,NULL,NULL),(1136,986,0,'LSQ12elv','LSQ',44.2790416666667,-21.8779444444444,NULL,NULL,'2012-08-27 07:17:50',56166.30406,19.9357,0.2008,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 06:45:33','2012-08-28 06:45:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elv/LSQ12elv_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elv/LSQ12elv_snap_53528.gif',38064771756,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594762058,9293157,NULL,NULL,NULL,NULL),(1137,989,0,'LSQ12elu','LSQ',70.4355833333333,-22.9941388888889,NULL,NULL,'2012-08-27 06:53:33',56166.2871900001,19.0675,0.1267,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 06:45:33','2019-09-06 21:34:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_snap_53526.gif',37338457798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,583413403,9115834,NULL,NULL,NULL,NULL),(1138,989,0,'LSQ12elu','LSQ',70.435625,-22.9941388888889,NULL,NULL,'2012-08-27 08:33:31',56166.3566100001,19.427,0.0873,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 06:45:33','2019-09-06 21:34:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_snap_53527.gif',37338457798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,583413403,9115834,NULL,NULL,NULL,NULL),(1139,1060,0,'LSQ12emi','LSQ',75.0574166666667,-22.18825,NULL,NULL,'2012-08-27 08:25:03',56166.3507300001,19.7026,0.0927,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 06:45:33','2012-08-28 06:45:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emi/LSQ12emi_history.html','sne-nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emi/LSQ12emi_snap_53488.gif',37549808027,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586715750,9167433,NULL,NULL,NULL,NULL),(1140,1060,0,'LSQ12emi','LSQ',75.0574166666667,-22.18825,NULL,NULL,'2012-08-27 09:23:05',56166.3910400001,19.6241,0.0749,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 06:45:33','2012-08-28 06:45:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emi/LSQ12emi_history.html','sne-nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emi/LSQ12emi_snap_53489.gif',37549808027,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586715750,9167433,NULL,NULL,NULL,NULL),(1141,1141,1,'LSQ12epq','LSQ',311.085958333333,-17.6551666666667,NULL,NULL,'2012-07-16 06:22:00',56124.2652799999,18.5676,0.0481,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epq/LSQ12epq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epq/LSQ12epq_snap_54016.gif',50973821038,NULL,NULL,NULL,'2012-07-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,796465953,12444780,NULL,NULL,NULL,NULL),(1142,1141,0,'LSQ12epq','LSQ',311.085791666667,-17.6552777777778,NULL,NULL,'2012-07-16 08:56:51',56124.3728200002,18.7023,0.0645,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epq/LSQ12epq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epq/LSQ12epq_snap_54017.gif',50973821038,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,796465953,12444780,NULL,NULL,NULL,NULL),(1143,1141,0,'LSQ12epq','LSQ',311.086,-17.6551666666667,NULL,NULL,'2012-08-27 00:13:07',56166.0091200001,17.9959,0.1191,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epq/LSQ12epq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epq/LSQ12epq_snap_53907.gif',50973821038,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,796465953,12444780,NULL,NULL,NULL,NULL),(1144,1141,0,'LSQ12epq','LSQ',311.086,-17.6551388888889,NULL,NULL,'2012-08-27 02:15:33',56166.0941400002,18.1263,0.1189,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epq/LSQ12epq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epq/LSQ12epq_snap_53908.gif',50973821030,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,796465953,12444780,NULL,NULL,NULL,NULL),(1145,1145,1,'LSQ12epp','LSQ',311.838208333333,-18.6798611111111,NULL,NULL,'2012-07-16 04:07:14',56124.1716999998,19.3449,0.1388,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_snap_54009.gif',50990609188,NULL,NULL,NULL,'2012-07-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796728268,12448879,NULL,NULL,NULL,NULL),(1146,1145,0,'LSQ12epp','LSQ',311.838125,-18.6799166666667,NULL,NULL,'2012-07-16 06:18:19',56124.26272,19.5273,0.1032,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_snap_54010.gif',50990609188,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796728268,12448879,NULL,NULL,NULL,NULL),(1147,1145,0,'LSQ12epp','LSQ',311.838041666667,-18.6799722222222,NULL,NULL,'2012-07-16 08:53:11',56124.3702699998,20.0673,0.1953,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_snap_54011.gif',50990609188,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796728268,12448879,NULL,NULL,NULL,NULL),(1148,1145,0,'LSQ12epp','LSQ',311.838166666667,-18.6799166666667,NULL,NULL,'2012-07-22 01:10:12',56130.0487500001,19.5045,0.1352,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_snap_54012.gif',50990609188,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796728268,12448879,NULL,NULL,NULL,NULL),(1149,1145,0,'LSQ12epp','LSQ',311.837583333333,-18.6803333333333,NULL,NULL,'2012-07-22 07:03:48',56130.2943099998,20.3969,0.209,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_snap_54013.gif',50990609188,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796728268,12448879,NULL,NULL,NULL,NULL),(1150,1145,0,'LSQ12epp','LSQ',311.838291666667,-18.6796944444444,NULL,NULL,'2012-07-28 02:43:23',56136.1134700002,18.7513,0.1375,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_snap_54014.gif',50990609188,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796728268,12448879,NULL,NULL,NULL,NULL),(1151,1145,0,'LSQ12epp','LSQ',311.838291666667,-18.6798888888889,NULL,NULL,'2012-08-10 23:48:07',56149.99175,19.8866,0.1493,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_snap_54015.gif',50990609188,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796728268,12448879,NULL,NULL,NULL,NULL),(1152,1145,0,'LSQ12epp','LSQ',311.837875,-18.6801944444444,NULL,NULL,'2012-08-27 00:11:26',56166.0079399999,16.6548,0.0658,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_snap_53905.gif',50990609188,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796728268,12448879,NULL,NULL,NULL,NULL),(1153,1145,0,'LSQ12epp','LSQ',311.838208333333,-18.6800555555556,NULL,NULL,'2012-08-27 02:13:51',56166.09296,17.6476,0.1019,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epp/LSQ12epp_snap_53906.gif',50990609188,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796728268,12448879,NULL,NULL,NULL,NULL),(1154,1154,1,'LSQ12epl','LSQ',78.7472916666667,-19.2884444444444,NULL,NULL,'2012-08-27 08:57:10',56166.37304,21.1087,0.1664,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epl/LSQ12epl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epl/LSQ12epl_snap_53897.gif',37425226681,NULL,NULL,NULL,'2012-08-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584769166,9137018,NULL,NULL,NULL,NULL),(1155,1154,0,'LSQ12epl','LSQ',78.7473333333333,-19.2884444444444,NULL,NULL,'2012-08-27 09:33:14',56166.3980899998,21.0538,0.1663,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epl/LSQ12epl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epl/LSQ12epl_snap_53898.gif',37425226681,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584769166,9137018,NULL,NULL,NULL,NULL),(1156,1156,1,'LSQ12epi','LSQ',71.9270416666667,-18.5434444444444,NULL,NULL,'2012-08-27 08:53:46',56166.3706800002,20.7418,0.1542,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epi/LSQ12epi_history.html','sne',NULL,0.074692,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epi/LSQ12epi_snap_53891.gif',37556785581,NULL,NULL,NULL,'2012-08-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586824774,9169137,NULL,NULL,NULL,NULL),(1157,1156,0,'LSQ12epi','LSQ',71.9270416666667,-18.5435,NULL,NULL,'2012-08-27 09:31:33',56166.3969200002,20.7627,0.1592,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epi/LSQ12epi_history.html','sne',NULL,0.074692,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epi/LSQ12epi_snap_53892.gif',37556785581,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586824774,9169137,NULL,NULL,NULL,NULL),(1158,1158,1,'LSQ12eph','LSQ',73.3724166666667,-21.0657222222222,NULL,NULL,'2012-08-05 09:09:50',56144.3818399999,17.0471,0.1506,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eph/LSQ12eph_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eph/LSQ12eph_snap_53992.gif',37344097653,NULL,NULL,NULL,'2012-08-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583501525,9117211,NULL,NULL,NULL,NULL),(1159,1158,0,'LSQ12eph','LSQ',73.3721666666667,-21.0655833333333,NULL,NULL,'2012-08-05 09:49:46',56144.4095700001,18.3429,0.1086,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eph/LSQ12eph_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eph/LSQ12eph_snap_53993.gif',37344097653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583501525,9117211,NULL,NULL,NULL,NULL),(1160,1158,0,'LSQ12eph','LSQ',73.372,-21.0655,NULL,NULL,'2012-08-27 08:53:46',56166.3706800002,19.8312,0.0877,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eph/LSQ12eph_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eph/LSQ12eph_snap_53889.gif',37344097610,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583501525,9117211,NULL,NULL,NULL,NULL),(1161,1158,0,'LSQ12eph','LSQ',73.3719583333333,-21.0655277777778,NULL,NULL,'2012-08-27 09:31:33',56166.3969200002,20.0173,0.1014,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eph/LSQ12eph_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eph/LSQ12eph_snap_53890.gif',37344097610,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583501525,9117211,NULL,NULL,NULL,NULL),(1162,1162,1,'LSQ12epg','LSQ',74.4789583333333,-21.0233333333333,NULL,NULL,'2012-08-27 08:53:46',56166.3706800002,19.8494,0.1107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epg/LSQ12epg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epg/LSQ12epg_snap_53887.gif',37549696809,NULL,NULL,NULL,'2012-08-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586714012,9167406,NULL,NULL,NULL,NULL),(1163,1162,0,'LSQ12epg','LSQ',74.4789166666667,-21.0234444444444,NULL,NULL,'2012-08-27 09:31:33',56166.3969200002,19.9216,0.1389,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epg/LSQ12epg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epg/LSQ12epg_snap_53888.gif',37549696809,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586714012,9167406,NULL,NULL,NULL,NULL),(1164,1164,1,'LSQ12epf','LSQ',73.5524166666667,-18.6885277777778,NULL,NULL,'2012-08-27 08:52:04',56166.3695,18.6342,0.0954,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epf/LSQ12epf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epf/LSQ12epf_snap_53885.gif',37558685697,NULL,NULL,NULL,'2012-08-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586854464,9169601,NULL,NULL,NULL,NULL),(1165,1164,0,'LSQ12epf','LSQ',73.5524583333333,-18.6885,NULL,NULL,'2012-08-27 09:55:58',56166.4138699998,18.7008,0.0864,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epf/LSQ12epf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epf/LSQ12epf_snap_53886.gif',37558685697,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586854464,9169601,NULL,NULL,NULL,NULL),(1166,1166,1,'LSQ12epd','LSQ',67.7811666666667,-19.8607777777778,NULL,NULL,'2012-08-27 08:50:23',56166.36833,19.4195,0.1174,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epd/LSQ12epd_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epd/LSQ12epd_snap_53879.gif',37378876812,NULL,NULL,NULL,'2012-08-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,584044950,9125702,NULL,NULL,NULL,NULL),(1167,1166,0,'LSQ12epd','LSQ',67.7810833333333,-19.8607222222222,NULL,NULL,'2012-08-27 09:29:52',56166.3957500001,18.9149,0.0742,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epd/LSQ12epd_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epd/LSQ12epd_snap_53880.gif',37378876812,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,584044950,9125702,NULL,NULL,NULL,NULL),(1168,1168,1,'LSQ12epc','LSQ',68.1962916666667,-16.4376666666667,NULL,NULL,'2012-08-27 08:50:23',56166.36833,18.5818,0.03,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epc/LSQ12epc_history.html','sne-very nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epc/LSQ12epc_snap_53877.gif',37355834039,NULL,NULL,NULL,'2012-08-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583684906,9120076,NULL,NULL,NULL,NULL),(1169,1168,0,'LSQ12epc','LSQ',68.1962916666667,-16.4376944444444,NULL,NULL,'2012-08-27 09:29:52',56166.3957500001,18.4306,0.0331,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epc/LSQ12epc_history.html','sne-very nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epc/LSQ12epc_snap_53878.gif',37355834039,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583684906,9120076,NULL,NULL,NULL,NULL),(1170,1170,1,'LSQ12eou','LSQ',61.4215416666667,-19.1896666666667,NULL,NULL,'2012-08-09 10:12:42',56148.4254899998,19.7225,0.1429,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eou/LSQ12eou_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eou/LSQ12eou_snap_53984.gif',36855805416,NULL,NULL,NULL,'2012-08-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,575871959,8997999,NULL,NULL,NULL,NULL),(1171,1170,0,'LSQ12eou','LSQ',61.4215833333333,-19.1896111111111,NULL,NULL,'2012-08-09 10:19:31',56148.43022,19.7655,0.1441,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eou/LSQ12eou_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eou/LSQ12eou_snap_53985.gif',36855805416,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,575871959,8997999,NULL,NULL,NULL,NULL),(1172,1170,0,'LSQ12eou','LSQ',61.4216666666667,-19.1896944444444,NULL,NULL,'2012-08-27 08:43:40',56166.3636599998,19.5714,0.1314,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eou/LSQ12eou_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eou/LSQ12eou_snap_53861.gif',36855805416,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,575871959,8997999,NULL,NULL,NULL,NULL),(1173,1170,0,'LSQ12eou','LSQ',61.42175,-19.1898333333333,NULL,NULL,'2012-08-27 09:26:29',56166.3933999999,19.5515,0.1245,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eou/LSQ12eou_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eou/LSQ12eou_snap_53862.gif',36855805416,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,575871959,8997999,NULL,NULL,NULL,NULL),(1174,1174,1,'LSQ12eor','LSQ',57.7149166666667,-16.9243611111111,NULL,NULL,'2012-07-28 09:48:23',56136.4086099998,18.0611,0.0586,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eor/LSQ12eor_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eor/LSQ12eor_snap_53939.gif',36881294756,NULL,NULL,NULL,'2011-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576270230,9004222,NULL,NULL,NULL,NULL),(1175,1174,0,'LSQ12eor','LSQ',57.7149583333333,-16.9244166666667,NULL,NULL,'2012-07-30 09:25:49',56138.3929300001,18.397,0.0551,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eor/LSQ12eor_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eor/LSQ12eor_snap_53940.gif',36881294756,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576270230,9004222,NULL,NULL,NULL,NULL),(1176,1174,0,'LSQ12eor','LSQ',57.715,-16.9243333333333,NULL,NULL,'2012-08-05 08:46:05',56144.36534,17.8923,0.1804,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eor/LSQ12eor_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eor/LSQ12eor_snap_53941.gif',36881294756,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576270230,9004222,NULL,NULL,NULL,NULL),(1177,1174,0,'LSQ12eor','LSQ',57.7149166666667,-16.9243333333333,NULL,NULL,'2012-08-27 08:41:59',56166.3624900002,18.6417,0.0718,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eor/LSQ12eor_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eor/LSQ12eor_snap_53855.gif',36881294756,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576270230,9004222,NULL,NULL,NULL,NULL),(1178,1174,0,'LSQ12eor','LSQ',57.715,-16.9243888888889,NULL,NULL,'2012-08-27 10:01:03',56166.4174000002,18.3406,0.081,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eor/LSQ12eor_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eor/LSQ12eor_snap_53856.gif',36881294756,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576270230,9004222,NULL,NULL,NULL,NULL),(1179,1179,1,'LSQ12eoo','LSQ',35.0484583333333,-19.03075,NULL,NULL,'2012-07-06 07:49:31',56114.3260599999,19.4534,0.1746,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoo/LSQ12eoo_history.html','sne?',NULL,0.136284,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoo/LSQ12eoo_snap_53934.gif',37974006116,NULL,NULL,NULL,'2011-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593343845,9270997,NULL,NULL,NULL,NULL),(1180,1179,0,'LSQ12eoo','LSQ',35.047875,-19.0304444444444,NULL,NULL,'2012-07-28 06:24:33',56136.2670499999,18.514,0.1347,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoo/LSQ12eoo_history.html','sne?',NULL,0.136284,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoo/LSQ12eoo_snap_53935.gif',37974006117,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593343845,9270997,NULL,NULL,NULL,NULL),(1181,1179,0,'LSQ12eoo','LSQ',35.04725,-19.0302222222222,NULL,NULL,'2012-07-28 08:24:19',56136.35023,19.3248,0.1484,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoo/LSQ12eoo_history.html','sne?',NULL,0.136284,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoo/LSQ12eoo_snap_53936.gif',37974006117,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593343845,9270997,NULL,NULL,NULL,NULL),(1182,1179,0,'LSQ12eoo','LSQ',35.0480833333333,-19.0306388888889,NULL,NULL,'2012-07-30 09:43:57',56138.4055300001,19.2529,0.1687,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoo/LSQ12eoo_history.html','sne?',NULL,0.136284,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoo/LSQ12eoo_snap_53937.gif',37974006117,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593343845,9270997,NULL,NULL,NULL,NULL),(1183,1179,0,'LSQ12eoo','LSQ',35.0480416666667,-19.0305,NULL,NULL,'2012-08-27 06:02:51',56166.2519899998,18.4955,0.1324,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoo/LSQ12eoo_history.html','sne?',NULL,0.136284,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoo/LSQ12eoo_snap_53849.gif',37974006117,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593343845,9270997,NULL,NULL,NULL,NULL),(1184,1179,0,'LSQ12eoo','LSQ',35.0477916666667,-19.0304444444444,NULL,NULL,'2012-08-27 08:05:54',56166.3374399999,18.1113,0.0793,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoo/LSQ12eoo_history.html','sne?',NULL,0.136284,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoo/LSQ12eoo_snap_53850.gif',37974006117,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593343845,9270997,NULL,NULL,NULL,NULL),(1185,1185,1,'LSQ12eom','LSQ',28.2500416666667,-18.1508888888889,NULL,NULL,'2012-08-27 05:59:28',56166.24963,19.7871,0.1565,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eom/LSQ12eom_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eom/LSQ12eom_snap_53845.gif',35086441365,NULL,NULL,NULL,'2012-08-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548225646,8566025,NULL,NULL,NULL,NULL),(1186,1185,0,'LSQ12eom','LSQ',28.2499583333333,-18.1509166666667,NULL,NULL,'2012-08-27 08:02:31',56166.3350900002,19.8768,0.1069,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eom/LSQ12eom_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eom/LSQ12eom_snap_53846.gif',35086441365,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548225646,8566025,NULL,NULL,NULL,NULL),(1187,1187,1,'LSQ12eok','LSQ',28.2188333333333,-18.1269444444444,NULL,NULL,'2012-07-28 06:11:56',56136.2582899998,18.4377,0.0753,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_snap_53970.gif',35086449258,NULL,NULL,NULL,'2012-07-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,548225769,8566027,NULL,NULL,NULL,NULL),(1188,1187,0,'LSQ12eok','LSQ',28.2187916666667,-18.1270277777778,NULL,NULL,'2012-07-28 08:12:14',56136.3418299998,18.8201,0.051,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_snap_53971.gif',35086449258,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,548225769,8566027,NULL,NULL,NULL,NULL),(1189,1187,0,'LSQ12eok','LSQ',28.2188333333333,-18.127,NULL,NULL,'2012-07-30 07:08:40',56138.2976899999,17.8335,0.0405,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_snap_53972.gif',35086449258,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,548225769,8566027,NULL,NULL,NULL,NULL),(1190,1187,0,'LSQ12eok','LSQ',28.218875,-18.1269722222222,NULL,NULL,'2012-07-30 09:49:02',56138.40906,17.9091,0.0373,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_snap_53973.gif',35086449258,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,548225769,8566027,NULL,NULL,NULL,NULL),(1191,1187,0,'LSQ12eok','LSQ',28.2189166666667,-18.127,NULL,NULL,'2012-08-05 07:31:29',56144.31354,16.7072,0.0497,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_snap_53974.gif',35086449258,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,548225769,8566027,NULL,NULL,NULL,NULL),(1192,1187,0,'LSQ12eok','LSQ',28.2189583333333,-18.1270277777778,NULL,NULL,'2012-08-27 05:57:46',56166.2484599999,17.7264,0.0311,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_snap_53841.gif',35086449258,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,548225769,8566027,NULL,NULL,NULL,NULL),(1193,1187,0,'LSQ12eok','LSQ',28.2188333333333,-18.127,NULL,NULL,'2012-08-27 08:00:50',56166.3339200001,17.6063,0.0202,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_snap_53842.gif',35086449258,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,548225769,8566027,NULL,NULL,NULL,NULL),(1194,1194,1,'LSQ12eog','LSQ',341.963625,-23.5885555555556,NULL,NULL,'2012-07-06 06:23:28',56114.2662999998,16.5173,0.0678,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eog/LSQ12eog_history.html','sne?',NULL,0.07675,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eog/LSQ12eog_snap_53943.gif',50224358479,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784755601,12261806,NULL,NULL,NULL,NULL),(1195,1194,0,'LSQ12eog','LSQ',341.963916666667,-23.5885277777778,NULL,NULL,'2012-07-22 10:07:02',56130.4215600002,19.0269,0.1902,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eog/LSQ12eog_history.html','sne?',NULL,0.07675,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eog/LSQ12eog_snap_53944.gif',50224358477,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784755601,12261806,NULL,NULL,NULL,NULL),(1196,1194,0,'LSQ12eog','LSQ',341.963666666667,-23.5885833333333,NULL,NULL,'2012-07-30 03:12:18',56138.1335499999,19.2898,0.1155,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eog/LSQ12eog_history.html','sne?',NULL,0.07675,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eog/LSQ12eog_snap_53945.gif',50224358479,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784755601,12261806,NULL,NULL,NULL,NULL),(1197,1194,0,'LSQ12eog','LSQ',341.963291666667,-23.5886111111111,NULL,NULL,'2012-08-07 05:55:37',56146.2469600001,18.3328,0.0761,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eog/LSQ12eog_history.html','sne?',NULL,0.07675,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eog/LSQ12eog_snap_53946.gif',50224358476,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784755601,12261806,NULL,NULL,NULL,NULL),(1198,1194,0,'LSQ12eog','LSQ',341.964166666667,-23.5883333333333,NULL,NULL,'2012-08-09 04:12:30',56148.1753500002,19.2282,0.0951,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eog/LSQ12eog_history.html','sne?',NULL,0.07675,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eog/LSQ12eog_snap_53947.gif',50224358477,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784755601,12261806,NULL,NULL,NULL,NULL),(1199,1194,0,'LSQ12eog','LSQ',341.963583333333,-23.5886111111111,NULL,NULL,'2012-08-27 01:56:35',56166.08097,18.9483,0.1153,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eog/LSQ12eog_history.html','sne?',NULL,0.07675,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eog/LSQ12eog_snap_53833.gif',50224358476,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784755601,12261806,NULL,NULL,NULL,NULL),(1200,1194,0,'LSQ12eog','LSQ',341.963458333333,-23.5885277777778,NULL,NULL,'2012-08-27 04:07:02',56166.1715600002,17.91,0.0983,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eog/LSQ12eog_history.html','sne?',NULL,0.07675,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eog/LSQ12eog_snap_53834.gif',50224358476,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784755601,12261806,NULL,NULL,NULL,NULL),(1201,1201,1,'LSQ12eod','LSQ',319.040166666667,-24.1268611111111,NULL,NULL,'2012-08-15 01:10:05',56154.04868,20.3534,0.1503,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eod/LSQ12eod_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eod/LSQ12eod_snap_53826.gif',50917408090,NULL,NULL,NULL,'2012-08-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,795584501,12431007,NULL,NULL,NULL,NULL),(1202,1201,0,'LSQ12eod','LSQ',319.040208333333,-24.1268055555556,NULL,NULL,'2012-08-19 00:53:01',56158.03682,19.7947,0.0858,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eod/LSQ12eod_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eod/LSQ12eod_snap_53827.gif',50917408090,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,795584501,12431007,NULL,NULL,NULL,NULL),(1203,1201,0,'LSQ12eod','LSQ',319.04025,-24.1268055555556,NULL,NULL,'2012-08-27 00:48:50',56166.0339199998,19.5769,0.1613,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eod/LSQ12eod_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eod/LSQ12eod_snap_53680.gif',50917408090,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,795584501,12431007,NULL,NULL,NULL,NULL),(1204,1201,0,'LSQ12eod','LSQ',319.040208333333,-24.1268055555556,NULL,NULL,'2012-08-27 02:59:11',56166.1244399999,19.8413,0.1267,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eod/LSQ12eod_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eod/LSQ12eod_snap_53681.gif',50917408090,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,795584501,12431007,NULL,NULL,NULL,NULL),(1205,1205,1,'LSQ12eoc','LSQ',317.283416666667,-22.2568611111111,NULL,NULL,'2012-07-08 04:58:24',56116.2072299998,18.7897,0.1472,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_snap_53822.gif',50904231018,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,795378609,12427790,NULL,NULL,NULL,NULL),(1206,1205,0,'LSQ12eoc','LSQ',317.28375,-22.2571944444444,NULL,NULL,'2012-07-13 06:53:27',56121.28712,19.5671,0.1018,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_snap_53823.gif',50904231018,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,795378609,12427790,NULL,NULL,NULL,NULL),(1207,1205,0,'LSQ12eoc','LSQ',317.283833333333,-22.2569722222222,NULL,NULL,'2012-07-19 02:20:19',56127.0974499998,18.4262,0.0421,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_snap_53824.gif',50904231018,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,795378609,12427790,NULL,NULL,NULL,NULL),(1208,1205,0,'LSQ12eoc','LSQ',317.283041666667,-22.2569444444444,NULL,NULL,'2012-07-28 01:10:38',56136.0490600001,19.4863,0.1395,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_snap_53933.gif',50904231025,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,795378609,12427790,NULL,NULL,NULL,NULL),(1209,1205,0,'LSQ12eoc','LSQ',317.283458333333,-22.2570833333333,NULL,NULL,'2012-08-09 00:22:21',56148.01553,20.4808,0.162,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_snap_53825.gif',50904231018,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,795378609,12427790,NULL,NULL,NULL,NULL),(1210,1205,0,'LSQ12eoc','LSQ',317.283708333333,-22.2571111111111,NULL,NULL,'2012-08-27 00:36:55',56166.0256400001,18.2498,0.099,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_snap_53678.gif',50904231018,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,795378609,12427790,NULL,NULL,NULL,NULL),(1211,1205,0,'LSQ12eoc','LSQ',317.283833333333,-22.2571111111111,NULL,NULL,'2012-08-27 02:39:18',56166.11063,18.0098,0.0953,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_snap_53679.gif',50904231018,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,795378609,12427790,NULL,NULL,NULL,NULL),(1212,1212,1,'LSQ12env','LSQ',79.9316666666667,-24.6253333333333,NULL,NULL,'2012-08-25 09:08:24',56164.3808400002,19.2846,0.108,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12env/LSQ12env_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12env/LSQ12env_snap_53705.gif',37130844292,NULL,NULL,NULL,'2012-02-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580169442,9065147,NULL,NULL,NULL,NULL),(1213,1212,0,'LSQ12env','LSQ',79.9316666666667,-24.6252222222222,NULL,NULL,'2012-08-25 09:39:49',56164.4026600001,19.3251,0.1136,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12env/LSQ12env_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12env/LSQ12env_snap_53706.gif',37130844292,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580169442,9065147,NULL,NULL,NULL,NULL),(1214,1212,0,'LSQ12env','LSQ',79.93175,-24.6253055555556,NULL,NULL,'2012-08-27 08:30:08',56166.3542599999,19.441,0.1251,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12env/LSQ12env_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12env/LSQ12env_snap_53664.gif',37130830920,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580169233,9065144,NULL,NULL,NULL,NULL),(1215,1212,0,'LSQ12env','LSQ',79.931625,-24.6253611111111,NULL,NULL,'2012-08-27 09:19:42',56166.3886899999,19.3679,0.1001,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12env/LSQ12env_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12env/LSQ12env_snap_53665.gif',37130844292,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580169442,9065147,NULL,NULL,NULL,NULL),(1216,1216,1,'LSQ12ens','LSQ',79.1612083333333,-25.06175,NULL,NULL,'2012-08-27 08:28:25',56166.3530700002,20.1073,0.1232,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ens/LSQ12ens_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ens/LSQ12ens_snap_53658.gif',37131980291,NULL,NULL,NULL,'2012-08-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,580187192,9065424,NULL,NULL,NULL,NULL),(1217,1216,0,'LSQ12ens','LSQ',79.1610833333333,-25.0617777777778,NULL,NULL,'2012-08-27 09:21:23',56166.38986,20.1895,0.1305,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ens/LSQ12ens_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ens/LSQ12ens_snap_53659.gif',37131980291,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,580187192,9065424,NULL,NULL,NULL,NULL),(1218,1218,1,'LSQ12enp','LSQ',80.7665833333333,-24.2645277777778,NULL,NULL,'2012-08-27 08:28:25',56166.3530700002,20.4032,0.1412,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enp/LSQ12enp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enp/LSQ12enp_snap_53652.gif',37141750864,NULL,NULL,NULL,'2012-08-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580339857,9067810,NULL,NULL,NULL,NULL),(1219,1218,0,'LSQ12enp','LSQ',80.7665,-24.2645833333333,NULL,NULL,'2012-08-27 09:21:23',56166.38986,18.9181,0.0953,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enp/LSQ12enp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enp/LSQ12enp_snap_53653.gif',37141750864,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580339857,9067810,NULL,NULL,NULL,NULL),(1220,1220,1,'LSQ12eno','LSQ',74.4076666666667,-25.1766111111111,NULL,NULL,'2012-08-09 10:16:06',56148.4278500001,20.3244,0.2162,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eno/LSQ12eno_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eno/LSQ12eno_snap_53698.gif',37227330578,NULL,NULL,NULL,'2012-01-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581677040,9088703,NULL,NULL,NULL,NULL),(1221,1220,0,'LSQ12eno','LSQ',74.4079583333333,-25.1763333333333,NULL,NULL,'2012-08-25 09:38:07',56164.4014699999,20.6718,0.1888,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eno/LSQ12eno_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eno/LSQ12eno_snap_53699.gif',37227330081,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581677032,9088703,NULL,NULL,NULL,NULL),(1222,1220,0,'LSQ12eno','LSQ',74.4079166666667,-25.1765555555556,NULL,NULL,'2012-08-27 08:26:44',56166.3519000001,21.2498,0.1675,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eno/LSQ12eno_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eno/LSQ12eno_snap_53650.gif',37227330081,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581677032,9088703,NULL,NULL,NULL,NULL),(1223,1220,0,'LSQ12eno','LSQ',74.4080416666667,-25.1763888888889,NULL,NULL,'2012-08-27 09:18:01',56166.3875199999,20.8946,0.1506,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eno/LSQ12eno_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eno/LSQ12eno_snap_53651.gif',37227330081,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581677032,9088703,NULL,NULL,NULL,NULL),(1224,1224,1,'LSQ12enl','LSQ',74.92375,-24.2499444444444,NULL,NULL,'2012-08-09 10:14:25',56148.42668,19.9258,0.1593,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enl/LSQ12enl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enl/LSQ12enl_snap_53688.gif',37213664024,NULL,NULL,NULL,'2012-01-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,581463500,9085367,NULL,NULL,NULL,NULL),(1225,1224,0,'LSQ12enl','LSQ',74.9236666666667,-24.2500555555556,NULL,NULL,'2012-08-25 09:43:11',56164.4049999998,19.773,0.1051,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enl/LSQ12enl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enl/LSQ12enl_snap_53689.gif',37213664024,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,581463500,9085367,NULL,NULL,NULL,NULL),(1226,1224,0,'LSQ12enl','LSQ',74.9239583333333,-24.2499444444444,NULL,NULL,'2012-08-27 08:25:03',56166.3507300001,20.5609,0.1553,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enl/LSQ12enl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enl/LSQ12enl_snap_53644.gif',37213664024,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,581463500,9085367,NULL,NULL,NULL,NULL),(1227,1224,0,'LSQ12enl','LSQ',74.9236666666667,-24.2500833333333,NULL,NULL,'2012-08-27 09:23:05',56166.3910400001,20.1717,0.1271,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enl/LSQ12enl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enl/LSQ12enl_snap_53645.gif',37213664024,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,581463500,9085367,NULL,NULL,NULL,NULL),(1228,1228,1,'LSQ12enj','LSQ',70.639125,-24.0433888888889,NULL,NULL,'2012-08-21 10:07:53',56160.42215,19.2667,0.1886,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enj/LSQ12enj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enj/LSQ12enj_snap_53684.gif',37337805598,NULL,NULL,NULL,'2012-08-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583403212,9115675,NULL,NULL,NULL,NULL),(1229,1228,0,'LSQ12enj','LSQ',70.6392916666667,-24.0434444444444,NULL,NULL,'2012-08-25 08:59:58',56164.3749799998,19.4517,0.1095,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enj/LSQ12enj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enj/LSQ12enj_snap_53685.gif',37337805598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583403212,9115675,NULL,NULL,NULL,NULL),(1230,1228,0,'LSQ12enj','LSQ',70.63925,-24.0433333333333,NULL,NULL,'2012-08-25 09:44:53',56164.4061799999,19.4762,0.144,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enj/LSQ12enj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enj/LSQ12enj_snap_53686.gif',37337805598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583403212,9115675,NULL,NULL,NULL,NULL),(1231,1228,0,'LSQ12enj','LSQ',70.6391666666667,-24.0434166666667,NULL,NULL,'2012-08-27 06:53:33',56166.2871900001,19.298,0.1632,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enj/LSQ12enj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enj/LSQ12enj_snap_53640.gif',37337805598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583403212,9115675,NULL,NULL,NULL,NULL),(1232,1228,0,'LSQ12enj','LSQ',70.63925,-24.0434166666667,NULL,NULL,'2012-08-27 08:33:31',56166.3566100001,19.4356,0.0863,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 21:45:35','2012-08-28 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enj/LSQ12enj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enj/LSQ12enj_snap_53641.gif',37337805598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583403212,9115675,NULL,NULL,NULL,NULL),(1233,1233,1,'LSQ12eqa','LSQ',339.820375,-19.6164444444444,NULL,NULL,'2012-07-28 04:54:20',56136.2044000002,19.6187,0.1141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 22:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqa/LSQ12eqa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqa/LSQ12eqa_snap_54066.gif',50250522592,NULL,NULL,NULL,'2012-07-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785164415,12268193,NULL,NULL,NULL,NULL),(1234,1233,0,'LSQ12eqa','LSQ',339.820083333333,-19.6163333333333,NULL,NULL,'2012-07-30 03:33:02',56138.1479500001,18.7965,0.1533,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 22:45:35','2012-08-28 22:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqa/LSQ12eqa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqa/LSQ12eqa_snap_54067.gif',50250522384,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785164412,12268193,NULL,NULL,NULL,NULL),(1235,1233,0,'LSQ12eqa','LSQ',339.82025,-19.6161666666667,NULL,NULL,'2012-07-30 05:35:37',56138.2330700001,18.8632,0.1042,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 22:45:35','2012-08-28 22:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqa/LSQ12eqa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqa/LSQ12eqa_snap_54068.gif',50250522384,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785164412,12268193,NULL,NULL,NULL,NULL),(1236,1233,0,'LSQ12eqa','LSQ',339.820166666667,-19.6161388888889,NULL,NULL,'2012-08-09 04:59:57',56148.2083100001,17.7154,0.0423,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 22:45:35','2012-08-28 22:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqa/LSQ12eqa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqa/LSQ12eqa_snap_54069.gif',50250522384,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785164412,12268193,NULL,NULL,NULL,NULL),(1237,1233,0,'LSQ12eqa','LSQ',339.820125,-19.6162777777778,NULL,NULL,'2012-08-12 07:39:19',56151.3189699999,18.787,0.0467,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 22:45:35','2012-08-28 22:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqa/LSQ12eqa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqa/LSQ12eqa_snap_54070.gif',50250522384,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785164412,12268193,NULL,NULL,NULL,NULL),(1238,1233,0,'LSQ12eqa','LSQ',339.820625,-19.6160277777778,NULL,NULL,'2012-08-27 01:48:07',56166.0750899999,18.6137,0.0894,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 22:45:35','2012-08-28 22:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqa/LSQ12eqa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqa/LSQ12eqa_snap_53927.gif',50250522592,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785164415,12268193,NULL,NULL,NULL,NULL),(1239,1233,0,'LSQ12eqa','LSQ',339.820416666667,-19.6161944444444,NULL,NULL,'2012-08-27 03:58:35',56166.1656900002,18.8875,0.1499,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 22:45:35','2012-08-28 22:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqa/LSQ12eqa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqa/LSQ12eqa_snap_53928.gif',50250522592,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785164415,12268193,NULL,NULL,NULL,NULL),(1240,1240,1,'LSQ12epy','LSQ',339.397125,-18.3271111111111,NULL,NULL,'2012-08-12 04:23:15',56151.1828200002,20.403,0.1081,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 22:45:35','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epy/LSQ12epy_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epy/LSQ12epy_snap_54058.gif',50251458903,NULL,NULL,NULL,'2012-08-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785179045,12268422,NULL,NULL,NULL,NULL),(1241,1240,0,'LSQ12epy','LSQ',339.396916666667,-18.3271388888889,NULL,NULL,'2012-08-27 01:46:26',56166.0739199999,19.4005,0.1429,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 22:45:35','2012-08-28 22:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epy/LSQ12epy_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epy/LSQ12epy_snap_53923.gif',50251458903,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785179045,12268422,NULL,NULL,NULL,NULL),(1242,1240,0,'LSQ12epy','LSQ',339.396958333333,-18.3268888888889,NULL,NULL,'2012-08-27 03:56:53',56166.16451,19.0618,0.1204,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-28 22:45:35','2012-08-28 22:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epy/LSQ12epy_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epy/LSQ12epy_snap_53924.gif',50251458900,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785179045,12268422,NULL,NULL,NULL,NULL),(1243,451,0,'LSQ12eea','LSQ',358.399166666667,-6.38319444444444,NULL,NULL,'2012-08-28 05:43:10',56167.23832,17.8842,0.0846,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eea/LSQ12eea_history.html','sne?',NULL,0.045465,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eea/LSQ12eea_snap_54262.gif',49431273985,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772363656,12068182,NULL,NULL,NULL,NULL),(1244,451,0,'LSQ12eea','LSQ',358.39925,-6.38305555555556,NULL,NULL,'2012-08-28 07:45:03',56167.32296,18.8366,0.1132,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eea/LSQ12eea_history.html','sne?',NULL,0.045465,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eea/LSQ12eea_snap_54263.gif',49431273985,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772363656,12068182,NULL,NULL,NULL,NULL),(1245,457,0,'LSQ12edo','LSQ',51.57825,-3.29761111111111,NULL,NULL,'2012-08-28 08:10:18',56167.3404899999,18.4859,0.1046,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_snap_54231.gif',36842019075,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575656548,8994633,NULL,NULL,NULL,NULL),(1246,457,0,'LSQ12edo','LSQ',51.578375,-3.29791666666667,NULL,NULL,'2012-08-28 09:09:42',56167.3817400001,19.099,0.118,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edo/LSQ12edo_snap_54232.gif',36842019075,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575656548,8994633,NULL,NULL,NULL,NULL),(1247,462,0,'LSQ12edk','LSQ',47.2393333333333,-2.95430555555556,NULL,NULL,'2012-08-28 08:05:14',56167.3369700001,18.1997,0.0824,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_history.html','sne',NULL,0.0082,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12edk/LSQ12edk_snap_54258.gif',36790348536,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574849195,8982018,NULL,NULL,NULL,NULL),(1248,544,0,'LSQ12egf','LSQ',342.308833333333,1.74255555555556,NULL,NULL,'2012-08-28 04:28:05',56167.1861700001,19.3969,0.0963,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_54372.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(1249,544,0,'LSQ12egf','LSQ',342.308791666667,1.7425,NULL,NULL,'2012-08-28 06:28:24',56167.2697299998,18.9975,0.0799,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_54373.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(1250,557,0,'LSQ12ege','LSQ',252.715916666667,2.8745,NULL,NULL,'2012-08-27 23:38:23',56166.9849999999,18.6271,0.0988,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_snap_54392.gif',55981393928,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,874709280,13667332,NULL,NULL,NULL,NULL),(1251,557,0,'LSQ12ege','LSQ',252.715916666667,2.87458333333333,NULL,NULL,'2012-08-28 01:01:58',56167.0430399999,18.8664,0.1149,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_snap_54393.gif',55981393928,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,874709280,13667332,NULL,NULL,NULL,NULL),(1252,571,0,'LSQ12ehj','LSQ',347.315666666667,7.04827777777778,NULL,NULL,'2012-08-28 04:33:09',56167.1896899999,18.6118,0.0692,'gr-LSQ',NULL,NULL,'AGN',NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_snap_54377.gif',51719133726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,808111464,12626741,NULL,NULL,NULL,NULL),(1253,571,0,'LSQ12ehj','LSQ',347.315625,7.04827777777778,NULL,NULL,'2012-08-28 06:33:28',56167.2732500001,18.5484,0.0726,'gr-LSQ',NULL,NULL,'AGN',NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_snap_54378.gif',51719133726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,808111464,12626741,NULL,NULL,NULL,NULL),(1254,1118,0,'LSQ12egy','LSQ',359.941458333333,-6.35227777777778,NULL,NULL,'2012-08-28 05:49:56',56167.2430199999,19.5661,0.1395,'gr-LSQ',NULL,NULL,'II',NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_snap_54362.gif',49430463909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772350998,12067984,NULL,NULL,NULL,NULL),(1255,1118,0,'LSQ12egy','LSQ',359.941416666667,-6.35225,NULL,NULL,'2012-08-28 07:51:48',56167.3276499999,19.4478,0.1882,'gr-LSQ',NULL,NULL,'II',NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_snap_54363.gif',49430463909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772350998,12067984,NULL,NULL,NULL,NULL),(1256,611,0,'LSQ12eid','LSQ',4.40816666666667,-5.38286111111111,NULL,NULL,'2012-08-28 05:55:12',56167.2466699998,18.8611,0.0665,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_snap_54147.gif',34413529726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537711401,8401740,NULL,NULL,NULL,NULL),(1257,611,0,'LSQ12eid','LSQ',4.408375,-5.38275,NULL,NULL,'2012-08-28 07:58:02',56167.3319700002,18.7324,0.055,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_snap_54148.gif',34413529726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537711401,8401740,NULL,NULL,NULL,NULL),(1258,617,0,'LSQ12eib','LSQ',8.041,-7.3815,NULL,NULL,'2012-08-28 08:03:07',56167.3355,19.8139,0.1395,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_snap_54144.gif',34627856184,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541060252,8454066,NULL,NULL,NULL,NULL),(1259,623,0,'LSQ12ehw','LSQ',357.061833333333,-7.17163888888889,NULL,NULL,'2012-08-28 05:43:10',56167.23832,19.6559,0.1496,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehw/LSQ12ehw_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehw/LSQ12ehw_snap_54167.gif',49435432346,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772428630,12069197,NULL,NULL,NULL,NULL),(1260,623,0,'LSQ12ehw','LSQ',357.061875,-7.17172222222222,NULL,NULL,'2012-08-28 07:45:03',56167.32296,20.08,0.1644,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehw/LSQ12ehw_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehw/LSQ12ehw_snap_54168.gif',49435432346,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772428630,12069197,NULL,NULL,NULL,NULL),(1261,646,0,'LSQ12eiq','LSQ',32.5294166666667,-5.57613888888889,NULL,NULL,'2012-08-28 07:07:59',56167.2972200001,18.9115,0.0611,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_snap_54204.gif',35142165909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549096342,8579630,NULL,NULL,NULL,NULL),(1262,646,0,'LSQ12eiq','LSQ',32.5295416666667,-5.57605555555556,NULL,NULL,'2012-08-28 08:45:42',56167.3650799999,18.9101,0.0485,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_snap_54205.gif',35142165909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549096342,8579630,NULL,NULL,NULL,NULL),(1263,697,0,'LSQ12eix','LSQ',40.2240833333333,-6.53883333333333,NULL,NULL,'2012-08-28 07:41:14',56167.3203099999,19.4963,0.151,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_54194.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(1264,697,0,'LSQ12eix','LSQ',40.224125,-6.53880555555556,NULL,NULL,'2012-08-28 08:54:41',56167.3713099998,19.5292,0.1325,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_54195.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(1265,722,0,'LSQ12eir','LSQ',34.10075,-3.01947222222222,NULL,NULL,'2012-08-28 07:09:40',56167.2983900001,19.6105,0.1734,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_snap_54208.gif',35133634952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548963046,8577547,NULL,NULL,NULL,NULL),(1266,722,0,'LSQ12eir','LSQ',34.10075,-3.01944444444444,NULL,NULL,'2012-08-28 08:44:00',56167.3639000002,18.9808,0.1105,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_snap_54209.gif',35133634952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548963046,8577547,NULL,NULL,NULL,NULL),(1267,726,0,'LSQ12eil','LSQ',1.672875,-6.28086111111111,NULL,NULL,'2012-08-28 05:49:56',56167.2430199999,19.5448,0.1581,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eil/LSQ12eil_history.html','sne - young ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eil/LSQ12eil_snap_54200.gif',34387815364,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537309615,8395462,NULL,NULL,NULL,NULL),(1268,726,0,'LSQ12eil','LSQ',1.67270833333333,-6.28083333333333,NULL,NULL,'2012-08-28 07:51:48',56167.3276499999,19.8139,0.1981,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eil/LSQ12eil_history.html','sne - young ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eil/LSQ12eil_snap_54201.gif',34387815364,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537309615,8395462,NULL,NULL,NULL,NULL),(1269,771,0,'LSQ12ejr','LSQ',351.924791666667,-5.09005555555555,NULL,NULL,'2012-08-28 05:29:18',56167.2286899998,18.2083,0.1359,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejr/LSQ12ejr_snap_54285.gif',49638300038,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775598438,12118725,NULL,NULL,NULL,NULL),(1270,826,0,'LSQ12eju','LSQ',350.748791666667,-7.43338888888889,NULL,NULL,'2012-08-28 05:29:18',56167.2286899998,19.5471,0.1756,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_54294.gif',49649863587,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(1271,826,0,'LSQ12eju','LSQ',350.748833333333,-7.43327777777778,NULL,NULL,'2012-08-28 07:30:19',56167.3127199998,19.8477,0.1517,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_54295.gif',49649863586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(1272,858,0,'LSQ12eks','LSQ',345.267375,-6.69516666666667,NULL,NULL,'2012-08-28 04:55:32',56167.20524,19.0096,0.0828,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eks/LSQ12eks_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eks/LSQ12eks_snap_54302.gif',49487173961,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773237093,12081829,NULL,NULL,NULL,NULL),(1273,858,0,'LSQ12eks','LSQ',345.267416666667,-6.69516666666667,NULL,NULL,'2012-08-28 06:55:50',56167.2887800001,19.1788,0.0988,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eks/LSQ12eks_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eks/LSQ12eks_snap_54303.gif',49487173961,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773237093,12081829,NULL,NULL,NULL,NULL),(1274,861,0,'LSQ12ekr','LSQ',344.37975,-6.24488888888889,NULL,NULL,'2012-08-28 04:53:49',56167.2040499998,19.9233,0.1901,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2019-08-21 00:25:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_history.html','agn or old?',NULL,0.090066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_snap_54304.gif',49488043315,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,773250676,12082041,NULL,NULL,NULL,NULL),(1275,861,0,'LSQ12ekr','LSQ',344.37975,-6.24491666666667,NULL,NULL,'2012-08-28 06:54:08',56167.2875999999,19.9253,0.1417,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2019-08-21 00:25:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_history.html','agn or old?',NULL,0.090066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_snap_54305.gif',49488043315,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,773250676,12082041,NULL,NULL,NULL,NULL),(1276,915,0,'LSQ12elk','LSQ',31.3318333333333,-5.97238888888889,NULL,NULL,'2012-08-28 07:09:40',56167.2983900001,19.4279,0.1257,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_snap_54330.gif',35137599396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,549024990,8578515,NULL,NULL,NULL,NULL),(1277,915,0,'LSQ12elk','LSQ',31.3318333333333,-5.97230555555556,NULL,NULL,'2012-08-28 08:44:00',56167.3639000002,19.4652,0.073,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_snap_54331.gif',35137599396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,549024990,8578515,NULL,NULL,NULL,NULL),(1278,921,0,'LSQ12elj','LSQ',31.0349583333333,-4.82058333333333,NULL,NULL,'2012-08-28 08:44:00',56167.3639000002,20.3675,0.1225,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_history.html','sne?',NULL,0.0829,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elj/LSQ12elj_snap_54332.gif',35139786209,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549059159,8579049,NULL,NULL,NULL,NULL),(1279,934,0,'LSQ12eli','LSQ',51.1983333333333,-6.86369444444444,NULL,NULL,'2012-08-28 08:08:37',56167.3393199998,19.3749,0.1936,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eli/LSQ12eli_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eli/LSQ12eli_snap_54328.gif',36804372252,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,575068316,8985442,NULL,NULL,NULL,NULL),(1280,934,0,'LSQ12eli','LSQ',51.1981666666667,-6.86366666666667,NULL,NULL,'2012-08-28 09:11:23',56167.3829100002,19.2209,0.1471,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eli/LSQ12eli_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eli/LSQ12eli_snap_54329.gif',36804372250,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,575068316,8985442,NULL,NULL,NULL,NULL),(1281,947,0,'LSQ12ele','LSQ',62.697625,-7.07022222222222,NULL,NULL,'2012-08-28 09:18:07',56167.3875899999,20.0389,0.1277,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ele/LSQ12ele_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ele/LSQ12ele_snap_54333.gif',36955954125,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577436783,9022449,NULL,NULL,NULL,NULL),(1282,1026,0,'LSQ12elz','LSQ',329.397708333333,-0.839194444444444,NULL,NULL,'2012-08-28 00:31:09',56167.0216399999,19.7529,0.2022,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_history.html','sne?',NULL,0.21853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_snap_54170.gif',49826069800,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778532340,12164567,NULL,NULL,NULL,NULL),(1283,1097,0,'LSQ12enc','LSQ',66.9710833333333,-3.19430555555556,NULL,NULL,'2012-08-28 08:31:39',56167.3553200001,19.1673,0.0954,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enc/LSQ12enc_history.html','sne??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enc/LSQ12enc_snap_54283.gif',36919366489,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,576865101,9013517,NULL,NULL,NULL,NULL),(1284,1097,0,'LSQ12enc','LSQ',66.9710416666667,-3.19436111111111,NULL,NULL,'2012-08-28 09:19:49',56167.3887700001,19.1746,0.0803,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enc/LSQ12enc_history.html','sne??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enc/LSQ12enc_snap_54284.gif',36919366489,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,576865101,9013517,NULL,NULL,NULL,NULL),(1285,1099,0,'LSQ12enb','LSQ',4.19729166666667,-0.644055555555555,NULL,NULL,'2012-08-28 09:32:17',56167.3974299999,18.7424,0.0572,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_history.html','agn?',NULL,0.06394,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_snap_54227.gif',34371929527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537061398,8391584,NULL,NULL,NULL,NULL),(1286,1109,0,'LSQ12emx','LSQ',57.5730833333333,-5.23116666666667,NULL,NULL,'2012-08-28 09:16:26',56167.3864199999,18.5045,0.095,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 03:45:40','2012-08-29 03:45:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emx/LSQ12emx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emx/LSQ12emx_snap_54296.gif',37007224837,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578237888,9034967,NULL,NULL,NULL,NULL),(1287,1287,1,'LSQ12erd','LSQ',10.60625,0.864694444444444,NULL,NULL,'2012-08-28 09:05:56',56167.3791299998,19.4802,0.1313,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erd/LSQ12erd_history.html','sne?',NULL,0.16679,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erd/LSQ12erd_snap_54605.gif',66807779648,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,1043871557,16310493,NULL,NULL,NULL,NULL),(1288,1287,0,'LSQ12erd','LSQ',10.606125,0.864777777777778,NULL,NULL,'2012-08-28 09:39:03',56167.4021200002,19.9384,0.1653,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erd/LSQ12erd_history.html','sne?',NULL,0.16679,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erd/LSQ12erd_snap_54606.gif',66807779648,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,1043871557,16310493,NULL,NULL,NULL,NULL),(1289,1289,1,'LSQ12erc','LSQ',8.771125,1.48155555555556,NULL,NULL,'2012-08-04 08:53:52',56143.3707499998,19.3985,0.1634,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_snap_54687.gif',66590313565,NULL,NULL,NULL,'2012-07-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1040473649,16257400,NULL,NULL,NULL,NULL),(1290,1289,0,'LSQ12erc','LSQ',8.77129166666667,1.48144444444444,NULL,NULL,'2012-08-08 09:44:34',56147.40595,19.8754,0.1479,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_snap_54688.gif',66590313565,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1040473649,16257400,NULL,NULL,NULL,NULL),(1291,1289,0,'LSQ12erc','LSQ',8.77120833333333,1.48161111111111,NULL,NULL,'2012-08-08 10:20:40',56147.4310300001,19.3192,0.1234,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_snap_54689.gif',66590313565,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1040473649,16257400,NULL,NULL,NULL,NULL),(1292,1289,0,'LSQ12erc','LSQ',8.77091666666667,1.48147222222222,NULL,NULL,'2012-08-10 10:07:27',56149.42185,20.2439,0.1642,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_snap_54690.gif',66590313561,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1040473649,16257400,NULL,NULL,NULL,NULL),(1293,1289,0,'LSQ12erc','LSQ',8.771,1.48144444444444,NULL,NULL,'2012-08-28 09:00:10',56167.37512,20.3742,0.1626,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_snap_54603.gif',66590313561,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1040473649,16257400,NULL,NULL,NULL,NULL),(1294,1289,0,'LSQ12erc','LSQ',8.77104166666667,1.48141666666667,NULL,NULL,'2012-08-28 09:33:59',56167.3986,19.6311,0.1077,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_snap_54604.gif',66590313561,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1040473649,16257400,NULL,NULL,NULL,NULL),(1295,1295,1,'LSQ12era','LSQ',324.270583333333,0.478972222222222,NULL,NULL,'2012-08-28 00:15:34',56167.01082,17.3558,0.0578,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12era/LSQ12era_history.html','sne?',NULL,0.05021,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12era/LSQ12era_snap_54599.gif',52096398906,NULL,NULL,NULL,'2012-08-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814006232,12718847,NULL,NULL,NULL,NULL),(1296,1295,0,'LSQ12era','LSQ',324.270583333333,0.479,NULL,NULL,'2012-08-28 02:14:51',56167.0936500002,17.3624,0.0586,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12era/LSQ12era_history.html','sne?',NULL,0.05021,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12era/LSQ12era_snap_54600.gif',52096398906,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814006232,12718847,NULL,NULL,NULL,NULL),(1297,1297,1,'LSQ12eqy','LSQ',328.247125,0.566916666666667,NULL,NULL,'2012-08-06 02:00:19',56145.0835600002,18.0055,0.0828,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqy/LSQ12eqy_history.html','sne?',NULL,0.07381,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqy/LSQ12eqy_snap_54680.gif',52178899047,NULL,NULL,NULL,'2012-07-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,815295297,12738989,NULL,NULL,NULL,NULL),(1298,1297,0,'LSQ12eqy','LSQ',328.247416666667,0.567194444444444,NULL,NULL,'2012-08-28 00:31:09',56167.0216399999,18.9537,0.141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqy/LSQ12eqy_history.html','sne?',NULL,0.07381,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqy/LSQ12eqy_snap_54593.gif',52178899046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,815295297,12738989,NULL,NULL,NULL,NULL),(1299,1297,0,'LSQ12eqy','LSQ',328.247375,0.567111111111111,NULL,NULL,'2012-08-28 02:31:56',56167.1055200002,18.1713,0.1251,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqy/LSQ12eqy_history.html','sne?',NULL,0.07381,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqy/LSQ12eqy_snap_54594.gif',52178899046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,815295297,12738989,NULL,NULL,NULL,NULL),(1300,1300,1,'LSQ12eqw','LSQ',331.09925,-1.79319444444444,NULL,NULL,'2012-08-08 02:11:49',56147.09155,20.4673,0.1282,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqw/LSQ12eqw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqw/LSQ12eqw_snap_54670.gif',49822866147,NULL,NULL,NULL,'2012-08-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,778482283,12163785,NULL,NULL,NULL,NULL),(1301,1300,0,'LSQ12eqw','LSQ',331.099291666667,-1.79302777777778,NULL,NULL,'2012-08-08 04:14:51',56147.1769900001,19.758,0.1029,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqw/LSQ12eqw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqw/LSQ12eqw_snap_54671.gif',49822866145,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,778482283,12163785,NULL,NULL,NULL,NULL),(1302,1300,0,'LSQ12eqw','LSQ',331.099208333333,-1.79316666666667,NULL,NULL,'2012-08-10 02:04:33',56149.0865000002,20.3958,0.1374,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqw/LSQ12eqw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqw/LSQ12eqw_snap_54672.gif',49822866147,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,778482283,12163785,NULL,NULL,NULL,NULL),(1303,1300,0,'LSQ12eqw','LSQ',331.099,-1.79308333333333,NULL,NULL,'2012-08-22 02:55:46',56161.12207,20.1278,0.0784,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqw/LSQ12eqw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqw/LSQ12eqw_snap_54673.gif',49822866147,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,778482283,12163785,NULL,NULL,NULL,NULL),(1304,1300,0,'LSQ12eqw','LSQ',331.098958333333,-1.79291666666667,NULL,NULL,'2012-08-22 05:46:39',56161.2407399998,20.3939,0.1065,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqw/LSQ12eqw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqw/LSQ12eqw_snap_54674.gif',49822866147,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,778482283,12163785,NULL,NULL,NULL,NULL),(1305,1300,0,'LSQ12eqw','LSQ',331.09925,-1.79325,NULL,NULL,'2012-08-28 00:52:11',56167.0362399998,19.5523,0.1444,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqw/LSQ12eqw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqw/LSQ12eqw_snap_54589.gif',49822866147,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,778482283,12163785,NULL,NULL,NULL,NULL),(1306,1300,0,'LSQ12eqw','LSQ',331.099333333333,-1.79305555555556,NULL,NULL,'2012-08-28 02:57:02',56167.1229400001,19.9168,0.1519,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqw/LSQ12eqw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqw/LSQ12eqw_snap_54590.gif',49822866145,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,778482283,12163785,NULL,NULL,NULL,NULL),(1307,1307,1,'LSQ12eqv','LSQ',338.3895,-1.16272222222222,NULL,NULL,'2012-08-23 03:34:44',56162.1491299998,18.5039,0.0365,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqv/LSQ12eqv_history.html','sne',NULL,0.05648,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqv/LSQ12eqv_snap_54669.gif',50332414104,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,786443970,12288187,NULL,NULL,NULL,NULL),(1308,1307,0,'LSQ12eqv','LSQ',338.389708333333,-1.16269444444444,NULL,NULL,'2012-08-28 01:29:20',56167.0620400002,18.0517,0.0619,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqv/LSQ12eqv_history.html','sne',NULL,0.05648,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqv/LSQ12eqv_snap_54587.gif',50332414136,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,786443970,12288187,NULL,NULL,NULL,NULL),(1309,1307,0,'LSQ12eqv','LSQ',338.38975,-1.16266666666667,NULL,NULL,'2012-08-28 03:29:32',56167.1455100002,17.9558,0.0455,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqv/LSQ12eqv_history.html','sne',NULL,0.05648,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqv/LSQ12eqv_snap_54588.gif',50332414136,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,786443970,12288187,NULL,NULL,NULL,NULL),(1310,1310,1,'LSQ12eqs','LSQ',346.33325,3.24355555555556,NULL,NULL,'2012-08-19 02:48:45',56158.1171900001,19.7482,0.0649,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqs/LSQ12eqs_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqs/LSQ12eqs_snap_54627.gif',51696025755,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,807750402,12621100,NULL,NULL,NULL,NULL),(1311,1310,0,'LSQ12eqs','LSQ',346.33325,3.24355555555556,NULL,NULL,'2012-08-19 08:11:04',56158.3410299998,19.6653,0.0566,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqs/LSQ12eqs_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqs/LSQ12eqs_snap_54628.gif',51696025755,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,807750402,12621100,NULL,NULL,NULL,NULL),(1312,1310,0,'LSQ12eqs','LSQ',346.333208333333,3.24358333333333,NULL,NULL,'2012-08-28 04:45:01',56167.1979299998,18.9803,0.0894,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqs/LSQ12eqs_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqs/LSQ12eqs_snap_54581.gif',51696025755,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,807750402,12621100,NULL,NULL,NULL,NULL),(1313,1310,0,'LSQ12eqs','LSQ',346.333291666667,3.24358333333333,NULL,NULL,'2012-08-28 06:45:25',56167.2815399999,19.067,0.089,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqs/LSQ12eqs_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqs/LSQ12eqs_snap_54582.gif',51696025755,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,807750402,12621100,NULL,NULL,NULL,NULL),(1314,1314,1,'LSQ12eql','LSQ',63.2167083333333,-7.00136111111111,NULL,NULL,'2011-12-15 01:34:16',55910.0654699998,20.4111,0.1633,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eql/LSQ12eql_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eql/LSQ12eql_snap_54666.gif',36954694319,NULL,NULL,NULL,'2011-12-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,577417098,9022142,NULL,NULL,NULL,NULL),(1315,1314,0,'LSQ12eql','LSQ',63.2165416666667,-7.00147222222222,NULL,NULL,'2011-12-15 03:36:44',55910.1505100001,20.5755,0.2007,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eql/LSQ12eql_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eql/LSQ12eql_snap_54667.gif',36954694319,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,577417098,9022142,NULL,NULL,NULL,NULL),(1316,1314,0,'LSQ12eql','LSQ',63.2165833333333,-7.00127777777778,NULL,NULL,'2012-08-26 09:35:52',56165.3999100002,20.7672,0.2012,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eql/LSQ12eql_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eql/LSQ12eql_snap_54668.gif',36954694319,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,577417098,9022142,NULL,NULL,NULL,NULL),(1317,1314,0,'LSQ12eql','LSQ',63.2165,-7.00122222222222,NULL,NULL,'2012-08-28 08:29:56',56167.3541299999,20.0107,0.1559,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eql/LSQ12eql_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eql/LSQ12eql_snap_54567.gif',36954694319,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,577417098,9022142,NULL,NULL,NULL,NULL),(1318,1314,0,'LSQ12eql','LSQ',63.2160833333333,-7.00127777777778,NULL,NULL,'2012-08-28 09:24:53',56167.3922899999,20.3658,0.1547,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eql/LSQ12eql_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eql/LSQ12eql_snap_54568.gif',36954694318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,577417098,9022142,NULL,NULL,NULL,NULL),(1319,1319,1,'LSQ12eqi','LSQ',13.3140416666667,-3.55155555555556,NULL,NULL,'2012-08-10 06:40:01',56149.2777999998,21.1962,0.1316,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqi/LSQ12eqi_history.html','sn?',NULL,0.051639,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqi/LSQ12eqi_snap_54656.gif',34516868825,NULL,NULL,NULL,'2012-08-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539326075,8426969,NULL,NULL,NULL,NULL),(1320,1319,0,'LSQ12eqi','LSQ',13.3137083333333,-3.5515,NULL,NULL,'2012-08-10 08:33:58',56149.3569299998,21.576,0.1673,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqi/LSQ12eqi_history.html','sn?',NULL,0.051639,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqi/LSQ12eqi_snap_54657.gif',34516868825,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539326075,8426969,NULL,NULL,NULL,NULL),(1321,1319,0,'LSQ12eqi','LSQ',13.314125,-3.55138888888889,NULL,NULL,'2012-08-20 09:33:08',56159.3980100001,19.8175,0.0393,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqi/LSQ12eqi_history.html','sn?',NULL,0.051639,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqi/LSQ12eqi_snap_54658.gif',34516868825,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539326075,8426969,NULL,NULL,NULL,NULL),(1322,1319,0,'LSQ12eqi','LSQ',13.3141666666667,-3.55133333333333,NULL,NULL,'2012-08-26 08:18:48',56165.3463900001,20.9871,0.1178,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqi/LSQ12eqi_history.html','sn?',NULL,0.051639,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqi/LSQ12eqi_snap_54659.gif',34516868825,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539326075,8426969,NULL,NULL,NULL,NULL),(1323,1319,0,'LSQ12eqi','LSQ',13.314125,-3.5515,NULL,NULL,'2012-08-28 06:12:31',56167.2587000001,20.0192,0.0901,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqi/LSQ12eqi_history.html','sn?',NULL,0.051639,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqi/LSQ12eqi_snap_54561.gif',34516868825,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539326075,8426969,NULL,NULL,NULL,NULL),(1324,1319,0,'LSQ12eqi','LSQ',13.313875,-3.55133333333333,NULL,NULL,'2012-08-28 08:12:29',56167.3420099998,19.1172,0.0455,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-29 21:45:37','2012-08-29 21:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqi/LSQ12eqi_history.html','sn?',NULL,0.051639,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqi/LSQ12eqi_snap_54562.gif',34516868825,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539326075,8426969,NULL,NULL,NULL,NULL),(1325,573,0,'LSQ12ehn','LSQ',53.811,-18.4273888888889,NULL,NULL,'2012-08-29 07:39:20',56168.3189900001,20.0704,0.1443,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_history.html','variable or unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_snap_54711.gif',38005697462,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,593839022,9278734,NULL,NULL,NULL,NULL),(1326,573,0,'LSQ12ehn','LSQ',53.8110416666667,-18.4274166666667,NULL,NULL,'2012-08-29 09:40:31',56168.4031400001,19.9874,0.0786,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_history.html','variable or unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehn/LSQ12ehn_snap_54712.gif',38005697462,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,593839022,9278734,NULL,NULL,NULL,NULL),(1327,581,0,'LSQ12ehl','LSQ',72.52775,-21.77525,NULL,NULL,'2012-08-29 07:30:37',56168.31293,18.6793,0.1208,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_snap_54697.gif',37345461187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583522831,9117544,NULL,NULL,NULL,NULL),(1328,581,0,'LSQ12ehl','LSQ',72.5277083333333,-21.77525,NULL,NULL,'2012-08-29 08:51:02',56168.3687800001,19.0975,0.0812,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehl/LSQ12ehl_snap_54698.gif',37345461187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583522831,9117544,NULL,NULL,NULL,NULL),(1329,989,0,'LSQ12elu','LSQ',70.4355833333333,-22.9940555555556,NULL,NULL,'2012-08-29 06:59:32',56168.2913500001,19.2171,0.1796,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2019-09-06 21:34:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_snap_54763.gif',37338457798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,583413403,9115834,NULL,NULL,NULL,NULL),(1330,989,0,'LSQ12elu','LSQ',70.4355833333333,-22.9941111111111,NULL,NULL,'2012-08-29 08:33:44',56168.35677,19.2671,0.1618,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2019-09-06 21:34:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elu/LSQ12elu_snap_54764.gif',37338457798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,583413403,9115834,NULL,NULL,NULL,NULL),(1331,1060,0,'LSQ12emi','LSQ',75.0574166666667,-22.1881388888889,NULL,NULL,'2012-08-29 07:30:37',56168.31293,19.1668,0.1866,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emi/LSQ12emi_history.html','sne-nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emi/LSQ12emi_snap_54723.gif',37549808027,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586715750,9167433,NULL,NULL,NULL,NULL),(1332,1060,0,'LSQ12emi','LSQ',75.0574166666667,-22.1881388888889,NULL,NULL,'2012-08-29 08:51:02',56168.3687800001,19.5325,0.1251,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emi/LSQ12emi_history.html','sne-nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12emi/LSQ12emi_snap_54724.gif',37549808027,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586715750,9167433,NULL,NULL,NULL,NULL),(1333,1168,0,'LSQ12epc','LSQ',68.1963333333333,-16.4376666666667,NULL,NULL,'2012-08-29 07:52:52',56168.3283799998,18.3151,0.0899,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epc/LSQ12epc_history.html','sne-very nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epc/LSQ12epc_snap_54759.gif',37355834039,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583684906,9120076,NULL,NULL,NULL,NULL),(1334,1168,0,'LSQ12epc','LSQ',68.1963333333333,-16.4376666666667,NULL,NULL,'2012-08-29 08:59:33',56168.37469,18.4292,0.0672,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epc/LSQ12epc_history.html','sne-very nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epc/LSQ12epc_snap_54760.gif',37355834039,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583684906,9120076,NULL,NULL,NULL,NULL),(1335,1174,0,'LSQ12eor','LSQ',57.7149583333333,-16.9243333333333,NULL,NULL,'2012-08-29 07:41:01',56168.3201600001,18.5871,0.1164,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eor/LSQ12eor_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eor/LSQ12eor_snap_54773.gif',36881294756,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576270230,9004222,NULL,NULL,NULL,NULL),(1336,1174,0,'LSQ12eor','LSQ',57.715,-16.9243888888889,NULL,NULL,'2012-08-29 08:54:28',56168.3711600001,18.2493,0.0975,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eor/LSQ12eor_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eor/LSQ12eor_snap_54774.gif',36881294756,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576270230,9004222,NULL,NULL,NULL,NULL),(1337,1185,0,'LSQ12eom','LSQ',28.250125,-18.1509444444444,NULL,NULL,'2012-08-29 04:34:26',56168.1905800002,19.8371,0.1944,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eom/LSQ12eom_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eom/LSQ12eom_snap_54804.gif',35086441365,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548225646,8566025,NULL,NULL,NULL,NULL),(1338,1187,0,'LSQ12eok','LSQ',28.2187916666667,-18.1270277777778,NULL,NULL,'2012-08-29 04:32:44',56168.1894,17.6333,0.0442,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_snap_54801.gif',35086449258,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,548225769,8566027,NULL,NULL,NULL,NULL),(1339,1187,0,'LSQ12eok','LSQ',28.219,-18.127,NULL,NULL,'2012-08-29 06:31:45',56168.2720499998,17.6782,0.0729,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eok/LSQ12eok_snap_54802.gif',35086449258,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,548225769,8566027,NULL,NULL,NULL,NULL),(1340,1216,0,'LSQ12ens','LSQ',79.1612083333333,-25.0617777777778,NULL,NULL,'2012-08-29 09:45:45',56168.4067799998,19.7135,0.1329,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ens/LSQ12ens_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ens/LSQ12ens_snap_54787.gif',37131980291,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,580187192,9065424,NULL,NULL,NULL,NULL),(1341,1218,0,'LSQ12enp','LSQ',80.7666666666667,-24.2646111111111,NULL,NULL,'2012-08-29 07:33:59',56168.3152700001,19.4998,0.1672,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enp/LSQ12enp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enp/LSQ12enp_snap_54753.gif',37141750864,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580339857,9067810,NULL,NULL,NULL,NULL),(1342,1220,0,'LSQ12eno','LSQ',74.4075416666667,-25.1767777777778,NULL,NULL,'2012-08-29 08:52:45',56168.3699699999,19.6795,0.1468,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eno/LSQ12eno_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eno/LSQ12eno_snap_54788.gif',37227330578,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581677040,9088703,NULL,NULL,NULL,NULL),(1343,1224,0,'LSQ12enl','LSQ',74.9237083333333,-24.25,NULL,NULL,'2012-08-29 07:30:37',56168.31293,18.538,0.1298,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enl/LSQ12enl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enl/LSQ12enl_snap_54752.gif',37213664024,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,581463500,9085367,NULL,NULL,NULL,NULL),(1344,1228,0,'LSQ12enj','LSQ',70.6392916666667,-24.0433333333333,NULL,NULL,'2012-08-29 08:33:44',56168.35677,19.1746,0.1949,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enj/LSQ12enj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enj/LSQ12enj_snap_54783.gif',37337805598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583403212,9115675,NULL,NULL,NULL,NULL),(1345,1240,0,'LSQ12epy','LSQ',339.396833333333,-18.3270833333333,NULL,NULL,'2012-08-29 02:50:20',56168.1182900001,19.4623,0.1531,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 05:45:36','2012-08-30 05:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epy/LSQ12epy_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epy/LSQ12epy_snap_54779.gif',50251458903,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785179045,12268422,NULL,NULL,NULL,NULL),(1346,1346,1,'LSQ12err','LSQ',348.143791666667,-22.1853611111111,NULL,NULL,'2012-07-01 07:01:37',56109.2927899999,19.4626,0.1492,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 17:45:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12err/LSQ12err_history.html','sne?',NULL,0.110973,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12err/LSQ12err_snap_54921.gif',50300863986,NULL,NULL,NULL,'2012-06-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785950999,12280484,NULL,NULL,NULL,NULL),(1347,1346,0,'LSQ12err','LSQ',348.143208333333,-22.1851111111111,NULL,NULL,'2012-08-01 03:00:36',56140.1254199999,18.4325,0.1806,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 17:45:36','2012-08-30 17:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12err/LSQ12err_history.html','sne?',NULL,0.110973,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12err/LSQ12err_snap_54922.gif',50300863986,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785950999,12280484,NULL,NULL,NULL,NULL),(1348,1346,0,'LSQ12err','LSQ',348.143166666667,-22.1854166666667,NULL,NULL,'2012-08-07 03:53:40',56146.1622799998,20.1374,0.1531,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 17:45:36','2012-08-30 17:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12err/LSQ12err_history.html','sne?',NULL,0.110973,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12err/LSQ12err_snap_54923.gif',50300863986,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785950999,12280484,NULL,NULL,NULL,NULL),(1349,1346,0,'LSQ12err','LSQ',348.143458333333,-22.1851666666667,NULL,NULL,'2012-08-29 01:05:37',56168.0455700001,17.6113,0.137,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 17:45:36','2012-08-30 17:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12err/LSQ12err_history.html','sne?',NULL,0.110973,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12err/LSQ12err_snap_54855.gif',50300863986,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785950999,12280484,NULL,NULL,NULL,NULL),(1350,1346,0,'LSQ12err','LSQ',348.143666666667,-22.1854166666667,NULL,NULL,'2012-08-29 03:08:57',56168.1312199999,18.3883,0.1273,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 17:45:36','2012-08-30 17:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12err/LSQ12err_history.html','sne?',NULL,0.110973,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12err/LSQ12err_snap_54856.gif',50300863987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785950999,12280484,NULL,NULL,NULL,NULL),(1351,1351,1,'LSQ12erp','LSQ',347.613333333333,-22.173,NULL,NULL,'2012-08-27 04:20:34',56166.18095,19.7529,0.1408,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 17:45:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erp/LSQ12erp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erp/LSQ12erp_snap_54919.gif',50300580081,NULL,NULL,NULL,'2012-08-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785946563,12280415,NULL,NULL,NULL,NULL),(1352,1351,0,'LSQ12erp','LSQ',347.613083333333,-22.1729722222222,NULL,NULL,'2012-08-27 06:22:28',56166.2656100001,19.7682,0.1858,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 17:45:36','2012-08-30 17:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erp/LSQ12erp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erp/LSQ12erp_snap_54920.gif',50300580081,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785946563,12280415,NULL,NULL,NULL,NULL),(1353,1351,0,'LSQ12erp','LSQ',347.613083333333,-22.173,NULL,NULL,'2012-08-29 01:03:54',56168.0443799999,18.6771,0.1191,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 17:45:36','2012-08-30 17:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erp/LSQ12erp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erp/LSQ12erp_snap_54851.gif',50300580081,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785946563,12280415,NULL,NULL,NULL,NULL),(1354,1351,0,'LSQ12erp','LSQ',347.613041666667,-22.1730277777778,NULL,NULL,'2012-08-29 03:07:14',56168.1300300001,17.7013,0.1062,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 17:45:36','2012-08-30 17:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erp/LSQ12erp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erp/LSQ12erp_snap_54852.gif',50300580081,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785946563,12280415,NULL,NULL,NULL,NULL),(1355,1355,1,'LSQ12erl','LSQ',328.12325,-22.1982222222222,NULL,NULL,'2012-08-01 02:12:00',56140.09167,17.7884,0.1361,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 17:45:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erl/LSQ12erl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erl/LSQ12erl_snap_54899.gif',50881760614,NULL,NULL,NULL,'2012-07-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795027509,12422304,NULL,NULL,NULL,NULL),(1356,1355,0,'LSQ12erl','LSQ',328.123291666667,-22.1981111111111,NULL,NULL,'2012-08-28 23:59:22',56167.99957,17.3716,0.1446,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 17:45:36','2012-08-30 17:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erl/LSQ12erl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erl/LSQ12erl_snap_54843.gif',50881760614,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795027509,12422304,NULL,NULL,NULL,NULL),(1357,1355,0,'LSQ12erl','LSQ',328.123458333333,-22.1983055555556,NULL,NULL,'2012-08-29 02:01:16',56168.0842200001,17.7014,0.1107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 17:45:36','2012-08-30 17:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erl/LSQ12erl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erl/LSQ12erl_snap_54844.gif',50881760614,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795027509,12422304,NULL,NULL,NULL,NULL),(1358,1358,1,'LSQ12esf','LSQ',66.69975,-19.8695833333333,NULL,NULL,'2012-08-27 08:50:23',56166.36833,18.3924,0.0278,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esf/LSQ12esf_history.html','sne-nice',NULL,0.033306,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esf/LSQ12esf_snap_54945.gif',37368917072,NULL,NULL,NULL,'2012-08-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583889329,9123270,NULL,NULL,NULL,NULL),(1359,1358,0,'LSQ12esf','LSQ',66.69975,-19.8695833333333,NULL,NULL,'2012-08-27 09:29:52',56166.3957500001,18.5045,0.0292,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2012-08-30 18:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esf/LSQ12esf_history.html','sne-nice',NULL,0.033306,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esf/LSQ12esf_snap_54946.gif',37368917072,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583889329,9123270,NULL,NULL,NULL,NULL),(1360,1358,0,'LSQ12esf','LSQ',66.69975,-19.8695555555556,NULL,NULL,'2012-08-29 07:52:52',56168.3283799998,18.366,0.0753,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2012-08-30 18:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esf/LSQ12esf_history.html','sne-nice',NULL,0.033306,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esf/LSQ12esf_snap_54883.gif',37368917072,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583889329,9123270,NULL,NULL,NULL,NULL),(1361,1358,0,'LSQ12esf','LSQ',66.6997916666667,-19.8695833333333,NULL,NULL,'2012-08-29 08:59:33',56168.37469,18.297,0.0786,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2012-08-30 18:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esf/LSQ12esf_history.html','sne-nice',NULL,0.033306,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esf/LSQ12esf_snap_54884.gif',37368917072,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583889329,9123270,NULL,NULL,NULL,NULL),(1362,1362,1,'LSQ12esc','LSQ',65.5290833333333,-17.1624444444444,NULL,NULL,'2012-08-27 08:45:21',56166.3648299999,20.3336,0.1765,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esc/LSQ12esc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esc/LSQ12esc_snap_54942.gif',37354263475,NULL,NULL,NULL,'2012-08-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583660366,9119693,NULL,NULL,NULL,NULL),(1363,1362,0,'LSQ12esc','LSQ',65.5284166666667,-17.1625277777778,NULL,NULL,'2012-08-27 09:59:19',56166.4161999999,20.8527,0.1805,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2012-08-30 18:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esc/LSQ12esc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esc/LSQ12esc_snap_54943.gif',37354263475,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583660366,9119693,NULL,NULL,NULL,NULL),(1364,1362,0,'LSQ12esc','LSQ',65.5287083333333,-17.1625,NULL,NULL,'2012-08-29 07:47:47',56168.32485,19.9146,0.1367,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2012-08-30 18:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esc/LSQ12esc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esc/LSQ12esc_snap_54877.gif',37354263475,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583660366,9119693,NULL,NULL,NULL,NULL),(1365,1362,0,'LSQ12esc','LSQ',65.529,-17.1623611111111,NULL,NULL,'2012-08-29 09:38:47',56168.4019399998,20.2704,0.1518,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2012-08-30 18:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esc/LSQ12esc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esc/LSQ12esc_snap_54878.gif',37354263475,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583660366,9119693,NULL,NULL,NULL,NULL),(1366,1366,1,'LSQ12esb','LSQ',60.7909583333333,-20.8234444444444,NULL,NULL,'2012-08-09 10:11:00',56148.4243100001,19.7081,0.0854,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esb/LSQ12esb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esb/LSQ12esb_snap_54941.gif',36852253562,NULL,NULL,NULL,'2012-08-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575816461,8997132,NULL,NULL,NULL,NULL),(1367,1366,0,'LSQ12esb','LSQ',60.7912916666667,-20.8235555555556,NULL,NULL,'2012-08-29 07:41:01',56168.3201600001,18.865,0.0734,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2012-08-30 18:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esb/LSQ12esb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esb/LSQ12esb_snap_54875.gif',36852253509,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575816461,8997132,NULL,NULL,NULL,NULL),(1368,1366,0,'LSQ12esb','LSQ',60.7914583333333,-20.8235833333333,NULL,NULL,'2012-08-29 08:54:28',56168.3711600001,19.2284,0.0754,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2012-08-30 18:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esb/LSQ12esb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esb/LSQ12esb_snap_54876.gif',36852253516,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575816461,8997132,NULL,NULL,NULL,NULL),(1369,1369,1,'LSQ12ery','LSQ',36.7847916666667,-17.1805277777778,NULL,NULL,'2012-08-27 08:07:35',56166.33861,20.8132,0.143,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ery/LSQ12ery_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ery/LSQ12ery_snap_54936.gif',37962960538,NULL,NULL,NULL,'2012-08-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593171258,9268300,NULL,NULL,NULL,NULL),(1370,1369,0,'LSQ12ery','LSQ',36.7847083333333,-17.1806388888889,NULL,NULL,'2012-08-29 04:49:50',56168.2012800002,18.6884,0.1217,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2012-08-30 18:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ery/LSQ12ery_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ery/LSQ12ery_snap_54869.gif',37962960538,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593171258,9268300,NULL,NULL,NULL,NULL),(1371,1369,0,'LSQ12ery','LSQ',36.7849166666667,-17.1805277777778,NULL,NULL,'2012-08-29 06:49:07',56168.2841099999,18.5976,0.1078,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2012-08-30 18:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ery/LSQ12ery_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ery/LSQ12ery_snap_54870.gif',37962960538,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593171258,9268300,NULL,NULL,NULL,NULL),(1372,1372,1,'LSQ12eru','LSQ',350.361583333333,-22.1618055555556,NULL,NULL,'2012-08-27 06:30:55',56166.27147,19.7106,0.1241,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eru/LSQ12eru_history.html','sne?',NULL,0.086016,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eru/LSQ12eru_snap_54925.gif',50304911514,NULL,NULL,NULL,'2012-08-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,786014242,12281472,NULL,NULL,NULL,NULL),(1373,1372,0,'LSQ12eru','LSQ',350.361208333333,-22.1620277777778,NULL,NULL,'2012-08-29 01:26:10',56168.0598399998,18.5852,0.1307,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2012-08-30 18:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eru/LSQ12eru_history.html','sne?',NULL,0.086016,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eru/LSQ12eru_snap_54861.gif',50304911545,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,786014242,12281472,NULL,NULL,NULL,NULL),(1374,1372,0,'LSQ12eru','LSQ',350.36125,-22.1620833333333,NULL,NULL,'2012-08-29 03:26:01',56168.1430700002,18.4128,0.16,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2012-08-30 18:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eru/LSQ12eru_history.html','sne?',NULL,0.086016,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eru/LSQ12eru_snap_54862.gif',50304911545,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,786014242,12281472,NULL,NULL,NULL,NULL),(1375,1375,1,'LSQ12ers','LSQ',345.5155,-22.8755277777778,NULL,NULL,'2012-08-27 06:24:09',56166.2667800002,18.9932,0.0976,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ers/LSQ12ers_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ers/LSQ12ers_snap_54924.gif',50214718088,NULL,NULL,NULL,'2012-08-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784604970,12259452,NULL,NULL,NULL,NULL),(1376,1375,0,'LSQ12ers','LSQ',345.515583333333,-22.8753888888889,NULL,NULL,'2012-08-29 01:05:37',56168.0455700001,18.1147,0.1225,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2012-08-30 18:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ers/LSQ12ers_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ers/LSQ12ers_snap_54857.gif',50214718088,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784604970,12259452,NULL,NULL,NULL,NULL),(1377,1375,0,'LSQ12ers','LSQ',345.515541666667,-22.8755277777778,NULL,NULL,'2012-08-29 03:08:57',56168.1312199999,18.7291,0.1549,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-30 18:45:36','2012-08-30 18:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ers/LSQ12ers_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ers/LSQ12ers_snap_54858.gif',50214718088,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784604970,12259452,NULL,NULL,NULL,NULL),(1378,544,0,'LSQ12egf','LSQ',342.308708333333,1.74255555555556,NULL,NULL,'2012-08-30 03:47:31',56169.1579999998,18.4368,0.0836,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egf/LSQ12egf_snap_55123.gif',51679416304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807490879,12617044,NULL,NULL,NULL,NULL),(1379,557,0,'LSQ12ege','LSQ',252.715916666667,2.87447222222222,NULL,NULL,'2012-08-29 23:36:43',56168.9838399999,18.8558,0.1429,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ege/LSQ12ege_snap_55141.gif',55981393928,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,874709280,13667332,NULL,NULL,NULL,NULL),(1380,571,0,'LSQ12ehj','LSQ',347.315541666667,7.04827777777778,NULL,NULL,'2012-08-30 02:16:09',56169.09455,18.5955,0.1121,'gr-LSQ',NULL,NULL,'AGN',NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_snap_55127.gif',51719133726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,808111464,12626741,NULL,NULL,NULL,NULL),(1381,571,0,'LSQ12ehj','LSQ',347.315666666667,7.04827777777778,NULL,NULL,'2012-08-30 04:18:02',56169.1791900001,18.5069,0.0748,'gr-LSQ',NULL,NULL,'AGN',NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ehj/LSQ12ehj_snap_55128.gif',51719133726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,808111464,12626741,NULL,NULL,NULL,NULL),(1382,1118,0,'LSQ12egy','LSQ',359.9415,-6.35216666666667,NULL,NULL,'2012-08-30 07:32:24',56169.3141700001,19.4668,0.1618,'gr-LSQ',NULL,NULL,'II',NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egy/LSQ12egy_snap_55119.gif',49430463909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772350998,12067984,NULL,NULL,NULL,NULL),(1383,611,0,'LSQ12eid','LSQ',4.40825,-5.38272222222222,NULL,NULL,'2012-08-30 05:37:31',56169.2343899999,19.2703,0.2085,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_snap_54997.gif',34413529726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537711401,8401740,NULL,NULL,NULL,NULL),(1384,617,0,'LSQ12eib','LSQ',8.04091666666667,-7.3815,NULL,NULL,'2012-08-30 05:42:35',56169.2379100001,18.9828,0.1879,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eib/LSQ12eib_snap_54995.gif',34627856184,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541060252,8454066,NULL,NULL,NULL,NULL),(1385,646,0,'LSQ12eiq','LSQ',32.529375,-5.57611111111111,NULL,NULL,'2012-08-30 06:01:11',56169.2508299998,18.9093,0.0865,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_snap_55022.gif',35142165909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549096342,8579630,NULL,NULL,NULL,NULL),(1386,697,0,'LSQ12eix','LSQ',40.224125,-6.53880555555556,NULL,NULL,'2012-08-30 06:09:44',56169.2567599998,19.6414,0.1711,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eix/LSQ12eix_snap_55026.gif',34934513405,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,545851771,8528933,NULL,NULL,NULL,NULL),(1387,722,0,'LSQ12eir','LSQ',34.1007083333333,-3.01922222222222,NULL,NULL,'2012-08-30 08:02:50',56169.33531,19.4247,0.2034,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eir/LSQ12eir_snap_55024.gif',35133634996,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548963046,8577547,NULL,NULL,NULL,NULL),(1388,858,0,'LSQ12eks','LSQ',345.267458333333,-6.69525,NULL,NULL,'2012-08-30 01:50:39',56169.0768499998,19.4077,0.1868,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eks/LSQ12eks_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eks/LSQ12eks_snap_55079.gif',49487173961,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773237093,12081829,NULL,NULL,NULL,NULL),(1389,858,0,'LSQ12eks','LSQ',345.267375,-6.69525,NULL,NULL,'2012-08-30 03:52:35',56169.1615200001,19.097,0.1673,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eks/LSQ12eks_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eks/LSQ12eks_snap_55080.gif',49487173961,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773237093,12081829,NULL,NULL,NULL,NULL),(1390,876,0,'LSQ12ekl','LSQ',347.856083333333,-1.86508333333333,NULL,NULL,'2012-08-30 02:11:04',56169.0910299998,18.2924,0.0734,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekl/LSQ12ekl_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekl/LSQ12ekl_snap_55089.gif',49495526397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773367599,12083868,NULL,NULL,NULL,NULL),(1391,876,0,'LSQ12ekl','LSQ',347.856125,-1.86505555555556,NULL,NULL,'2012-08-30 04:12:57',56169.1756699998,18.4022,0.0774,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekl/LSQ12ekl_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekl/LSQ12ekl_snap_55090.gif',49495526397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773367599,12083868,NULL,NULL,NULL,NULL),(1392,915,0,'LSQ12elk','LSQ',31.3318333333333,-5.97230555555556,NULL,NULL,'2012-08-30 06:02:55',56169.2520300001,19.4508,0.1711,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_snap_55099.gif',35137599396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,549024990,8578515,NULL,NULL,NULL,NULL),(1393,915,0,'LSQ12elk','LSQ',31.3318333333333,-5.97230555555556,NULL,NULL,'2012-08-30 08:02:50',56169.33531,19.8621,0.1387,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_snap_55100.gif',35137599396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,549024990,8578515,NULL,NULL,NULL,NULL),(1394,947,0,'LSQ12ele','LSQ',62.6980416666667,-7.07047222222222,NULL,NULL,'2012-08-30 08:16:22',56169.3446999998,18.7305,0.2093,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ele/LSQ12ele_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ele/LSQ12ele_snap_55102.gif',36955954114,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577436783,9022449,NULL,NULL,NULL,NULL),(1395,1097,0,'LSQ12enc','LSQ',66.971125,-3.19427777777778,NULL,NULL,'2012-08-30 06:57:17',56169.2897899998,18.9892,0.1662,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enc/LSQ12enc_history.html','sne??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enc/LSQ12enc_snap_55064.gif',36919365798,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,576865090,9013517,NULL,NULL,NULL,NULL),(1396,1099,0,'LSQ12enb','LSQ',4.19695833333333,-0.644194444444444,NULL,NULL,'2012-08-30 07:34:06',56169.3153499998,19.6443,0.1761,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_history.html','agn?',NULL,0.06394,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_snap_55044.gif',34371929527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537061398,8391584,NULL,NULL,NULL,NULL),(1397,1287,0,'LSQ12erd','LSQ',10.6061666666667,0.864666666666667,NULL,NULL,'2012-08-30 07:03:08',56169.29385,19.2033,0.1944,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erd/LSQ12erd_history.html','sne?',NULL,0.16679,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erd/LSQ12erd_snap_55144.gif',66807779648,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,1043871557,16310493,NULL,NULL,NULL,NULL),(1398,1289,0,'LSQ12erc','LSQ',8.77054166666667,1.48155555555556,NULL,NULL,'2012-08-30 06:30:38',56169.27128,19.4085,0.1375,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_snap_55150.gif',66590313561,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1040473649,16257400,NULL,NULL,NULL,NULL),(1399,1289,0,'LSQ12erc','LSQ',8.77120833333333,1.48152777777778,NULL,NULL,'2012-08-30 08:18:42',56169.34632,18.822,0.1234,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_snap_55151.gif',66590313565,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1040473649,16257400,NULL,NULL,NULL,NULL),(1400,1307,0,'LSQ12eqv','LSQ',338.389625,-1.16269444444444,NULL,NULL,'2012-08-30 01:21:45',56169.0567800002,17.8261,0.0777,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqv/LSQ12eqv_history.html','sne',NULL,0.05648,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqv/LSQ12eqv_snap_55147.gif',50332414136,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,786443970,12288187,NULL,NULL,NULL,NULL),(1401,1307,0,'LSQ12eqv','LSQ',338.389708333333,-1.16263888888889,NULL,NULL,'2012-08-30 03:23:45',56169.1414999999,17.5777,0.078,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqv/LSQ12eqv_history.html','sne',NULL,0.05648,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqv/LSQ12eqv_snap_55148.gif',50332414136,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,786443970,12288187,NULL,NULL,NULL,NULL),(1402,1310,0,'LSQ12eqs','LSQ',346.333125,3.24358333333333,NULL,NULL,'2012-08-30 02:04:13',56169.0862699999,18.5995,0.148,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqs/LSQ12eqs_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqs/LSQ12eqs_snap_55154.gif',51696025755,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,807750402,12621100,NULL,NULL,NULL,NULL),(1403,1310,0,'LSQ12eqs','LSQ',346.333166666667,3.2435,NULL,NULL,'2012-08-30 04:06:11',56169.1709699999,19.0342,0.1204,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqs/LSQ12eqs_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqs/LSQ12eqs_snap_55155.gif',51696025755,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,807750402,12621100,NULL,NULL,NULL,NULL),(1404,1319,0,'LSQ12eqi','LSQ',13.31375,-3.55161111111111,NULL,NULL,'2012-08-30 05:45:59',56169.24027,20.0256,0.0921,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 03:45:38','2012-08-31 03:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqi/LSQ12eqi_history.html','sn?',NULL,0.051639,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqi/LSQ12eqi_snap_55158.gif',34516868825,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539326075,8426969,NULL,NULL,NULL,NULL),(1405,646,0,'LSQ12eiq','LSQ',32.5293333333333,-5.57616666666667,NULL,NULL,'2012-08-30 06:02:55',56169.2520300001,18.9089,0.0873,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 14:45:37','2012-08-31 14:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_snap_55261.gif',35142165909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549096342,8579630,NULL,NULL,NULL,NULL),(1406,646,0,'LSQ12eiq','LSQ',32.5293333333333,-5.57622222222222,NULL,NULL,'2012-08-30 08:02:50',56169.33531,18.8236,0.0812,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 14:45:37','2012-08-31 14:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eiq/LSQ12eiq_snap_55262.gif',35142165909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549096342,8579630,NULL,NULL,NULL,NULL),(1407,876,0,'LSQ12ekl','LSQ',347.856208333333,-1.86511111111111,NULL,NULL,'2012-08-30 02:12:46',56169.0921999998,18.2613,0.0743,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 16:45:36','2012-08-31 16:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekl/LSQ12ekl_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekl/LSQ12ekl_snap_55367.gif',49495526397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773367599,12083868,NULL,NULL,NULL,NULL),(1408,876,0,'LSQ12ekl','LSQ',347.856166666667,-1.86513888888889,NULL,NULL,'2012-08-30 04:14:38',56169.1768399999,18.3577,0.0604,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 16:45:36','2012-08-31 16:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekl/LSQ12ekl_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekl/LSQ12ekl_snap_55368.gif',49495526397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773367599,12083868,NULL,NULL,NULL,NULL),(1409,1409,1,'LSQ12etj','LSQ',354.85375,-1.44855555555556,NULL,NULL,'2012-08-08 10:13:47',56147.4262399999,19.8744,0.1523,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 17:45:38','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12etj/LSQ12etj_history.html','sn?? or agn',NULL,0.022539,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12etj/LSQ12etj_snap_55416.gif',49454673138,NULL,NULL,NULL,'2012-08-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772729267,12073894,NULL,NULL,NULL,NULL),(1410,1409,0,'LSQ12etj','LSQ',354.85375,-1.4485,NULL,NULL,'2012-08-19 04:23:00',56158.1826499999,20.1488,0.1078,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 17:45:38','2012-08-31 17:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12etj/LSQ12etj_history.html','sn?? or agn',NULL,0.022539,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12etj/LSQ12etj_snap_55417.gif',49454673138,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772729267,12073894,NULL,NULL,NULL,NULL),(1411,1409,0,'LSQ12etj','LSQ',354.85375,-1.44836111111111,NULL,NULL,'2012-08-30 05:20:38',56169.22267,19.1387,0.1348,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 17:45:38','2012-08-31 17:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12etj/LSQ12etj_history.html','sn?? or agn',NULL,0.022539,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12etj/LSQ12etj_snap_55371.gif',49454673138,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772729267,12073894,NULL,NULL,NULL,NULL),(1412,1409,0,'LSQ12etj','LSQ',354.85375,-1.44855555555556,NULL,NULL,'2012-08-30 07:20:33',56169.3059399999,18.9748,0.1329,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 17:45:38','2012-08-31 17:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12etj/LSQ12etj_history.html','sn?? or agn',NULL,0.022539,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12etj/LSQ12etj_snap_55372.gif',49454673138,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772729267,12073894,NULL,NULL,NULL,NULL),(1413,1413,1,'LSQ12etc','LSQ',335.135791666667,0.552944444444444,NULL,NULL,'2012-08-23 05:37:24',56162.2343100002,19.6606,0.0513,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 17:45:38','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12etc/LSQ12etc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12etc/LSQ12etc_snap_55353.gif',52145872977,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,814779265,12730926,NULL,NULL,NULL,NULL),(1414,1413,0,'LSQ12etc','LSQ',335.136416666667,0.553055555555556,NULL,NULL,'2012-08-28 03:24:15',56167.1418499998,19.7321,0.1402,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 17:45:38','2012-08-31 17:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12etc/LSQ12etc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12etc/LSQ12etc_snap_55354.gif',52145872976,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,814779265,12730926,NULL,NULL,NULL,NULL),(1415,1413,0,'LSQ12etc','LSQ',335.135833333333,0.552972222222222,NULL,NULL,'2012-08-30 01:16:34',56169.0531799998,17.5756,0.1029,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 17:45:38','2012-08-31 17:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12etc/LSQ12etc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12etc/LSQ12etc_snap_55309.gif',52145872977,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,814779265,12730926,NULL,NULL,NULL,NULL),(1416,1413,0,'LSQ12etc','LSQ',335.135791666667,0.552916666666667,NULL,NULL,'2012-08-30 03:18:32',56169.1378799998,17.8687,0.1016,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 17:45:38','2012-08-31 17:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12etc/LSQ12etc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12etc/LSQ12etc_snap_55310.gif',52145872979,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,814779265,12730926,NULL,NULL,NULL,NULL),(1417,1417,1,'LSQ12esy','LSQ',359.015541666667,0.309277777777778,NULL,NULL,'2012-08-28 07:48:26',56167.3253100002,13.772,0.0015,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 17:45:38','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esy/LSQ12esy_history.html','variable?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esy/LSQ12esy_snap_55347.gif',51540358796,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,805318106,12583095,NULL,NULL,NULL,NULL),(1418,1417,0,'LSQ12esy','LSQ',359.0155,0.30925,NULL,NULL,'2012-08-30 05:29:04',56169.22853,14.256,0.0026,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 17:45:38','2012-08-31 17:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esy/LSQ12esy_history.html','variable?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esy/LSQ12esy_snap_55301.gif',51540358796,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,805318106,12583095,NULL,NULL,NULL,NULL),(1419,1417,0,'LSQ12esy','LSQ',359.015541666667,0.309277777777778,NULL,NULL,'2012-08-30 07:29:02',56169.31183,14.2776,0.0026,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 17:45:38','2012-08-31 17:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esy/LSQ12esy_history.html','variable?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esy/LSQ12esy_snap_55302.gif',51540358796,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,805318106,12583095,NULL,NULL,NULL,NULL),(1420,1420,1,'LSQ12esq','LSQ',240.877208333333,-6.27063888888889,NULL,NULL,'2012-08-28 00:39:16',56167.02727,19.0793,0.1499,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 17:45:38','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esq/LSQ12esq_history.html','sne-nice',NULL,0.030351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esq/LSQ12esq_snap_55322.gif',45571174319,NULL,NULL,NULL,'2012-08-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,712049598,11125774,NULL,NULL,NULL,NULL),(1421,1420,0,'LSQ12esq','LSQ',240.877333333333,-6.27063888888889,NULL,NULL,'2012-08-30 00:02:20',56169.0016299998,19.2611,0.1662,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 17:45:38','2012-08-31 17:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esq/LSQ12esq_history.html','sne-nice',NULL,0.030351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esq/LSQ12esq_snap_55285.gif',45571174318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,712049598,11125774,NULL,NULL,NULL,NULL),(1422,1420,0,'LSQ12esq','LSQ',240.877208333333,-6.27069444444444,NULL,NULL,'2012-08-30 00:58:26',56169.0405799998,19.7179,0.1402,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-08-31 17:45:38','2012-08-31 17:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esq/LSQ12esq_history.html','sne-nice',NULL,0.030351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12esq/LSQ12esq_snap_55286.gif',45571174319,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,712049598,11125774,NULL,NULL,NULL,NULL),(1423,1423,1,'SSS120817-002822-305723','CRTS-SSS',7.09095,-30.95642,NULL,NULL,'2012-08-17 00:00:00',56156,19.09,NULL,NULL,NULL,NULL,NULL,NULL,'2012-09-03 18:56:13','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120817/1208170310044215046.html','supernova',NULL,0.051,NULL,NULL,'NULL',NULL,NULL,34889867327,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'SN',NULL,0,NULL,0,545154176,8518034,NULL,NULL,NULL,NULL),(1424,1240,0,'LSQ12epy','LSQ',339.396958333333,-18.3268333333333,NULL,NULL,'2012-09-03 04:31:50',56173.18878,18.9715,0.2163,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-03 21:45:38','2012-09-03 21:45:38','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epy/LSQ12epy_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epy/LSQ12epy_snap_55797.gif',50251458900,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785179045,12268422,NULL,NULL,NULL,NULL),(1425,48203,0,'LSQ12dlc','atel',36.8,-6.45563888889,NULL,NULL,'2012-07-11 00:00:00',56119,NULL,NULL,NULL,0.06,NULL,'IIP',NULL,'2012-09-03 23:25:01','2012-09-03 23:25:01','http://www.astronomerstelegram.org/?read=4311',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,34941112030,'UT 2.2m','SNIFS','Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,545954875,8530544,NULL,NULL,NULL,NULL),(1426,1426,1,'LSQ12evf','LSQ',335.365583333333,-24.5856111111111,NULL,NULL,'2012-08-27 01:29:33',56166.06219,19.8257,0.1584,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 02:45:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evf/LSQ12evf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evf/LSQ12evf_snap_55820.gif',50066844723,NULL,NULL,NULL,'2012-08-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782294448,12223350,NULL,NULL,NULL,NULL),(1427,1426,0,'LSQ12evf','LSQ',335.365625,-24.5856388888889,NULL,NULL,'2012-08-27 03:39:59',56166.15277,19.9767,0.1726,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 02:45:36','2012-09-04 02:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evf/LSQ12evf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evf/LSQ12evf_snap_55821.gif',50066844723,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782294448,12223350,NULL,NULL,NULL,NULL),(1428,1426,0,'LSQ12evf','LSQ',335.365625,-24.5854722222222,NULL,NULL,'2012-09-03 04:11:21',56173.1745600002,19.6612,0.1583,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 02:45:36','2012-09-04 02:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evf/LSQ12evf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evf/LSQ12evf_snap_55813.gif',50066844723,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782294448,12223350,NULL,NULL,NULL,NULL),(1429,1426,0,'LSQ12evf','LSQ',335.365666666667,-24.5854722222222,NULL,NULL,'2012-09-03 06:11:19',56173.2578699999,19.2062,0.1643,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 02:45:36','2012-09-04 02:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evf/LSQ12evf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evf/LSQ12evf_snap_55814.gif',50066844723,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782294448,12223350,NULL,NULL,NULL,NULL),(1430,1430,1,'LSQ12eve','LSQ',328.319208333333,-21.7153611111111,NULL,NULL,'2012-08-27 01:17:40',56166.05394,19.6738,0.1245,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 02:45:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eve/LSQ12eve_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eve/LSQ12eve_snap_55817.gif',50881668328,NULL,NULL,NULL,'2012-08-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795026067,12422282,NULL,NULL,NULL,NULL),(1431,1430,0,'LSQ12eve','LSQ',328.319125,-21.7153888888889,NULL,NULL,'2012-08-27 03:28:03',56166.1444899999,19.5712,0.1114,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 02:45:36','2012-09-04 02:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eve/LSQ12eve_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eve/LSQ12eve_snap_55818.gif',50881668328,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795026067,12422282,NULL,NULL,NULL,NULL),(1432,1430,0,'LSQ12eve','LSQ',328.319125,-21.7154722222222,NULL,NULL,'2012-08-29 02:01:16',56168.0842200001,19.2015,0.134,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 02:45:36','2012-09-04 02:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eve/LSQ12eve_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eve/LSQ12eve_snap_55819.gif',50881668328,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795026067,12422282,NULL,NULL,NULL,NULL),(1433,1430,0,'LSQ12eve','LSQ',328.31925,-21.7153333333333,NULL,NULL,'2012-09-03 04:06:17',56173.1710399999,19.2997,0.1172,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 02:45:36','2012-09-04 02:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eve/LSQ12eve_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eve/LSQ12eve_snap_55811.gif',50881668328,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795026067,12422282,NULL,NULL,NULL,NULL),(1434,1430,0,'LSQ12eve','LSQ',328.319125,-21.7153055555556,NULL,NULL,'2012-09-03 06:06:13',56173.2543199998,19.2042,0.126,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 02:45:36','2012-09-04 02:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eve/LSQ12eve_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eve/LSQ12eve_snap_55812.gif',50881668328,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795026067,12422282,NULL,NULL,NULL,NULL),(1435,1060,0,'LSQ12emi','pessto',75.0574583333,-22.1881666667,NULL,NULL,'2012-08-26 00:00:00',56165,NULL,NULL,NULL,0.05,NULL,'Ic',NULL,'2012-09-04 10:53:44','2012-09-04 10:53:44','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37549808027,'NTT','EFOSC2 Gm13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586715750,9167433,NULL,NULL,NULL,NULL),(1436,992,0,'LSQ12elt','pessto',302.779875,-23.1457222222,NULL,NULL,'2012-08-26 00:00:00',56165,NULL,NULL,NULL,0.1,NULL,'Ia',NULL,'2012-09-04 11:14:45','2012-09-04 11:14:45','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50808789842,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793887341,12404489,NULL,NULL,NULL,NULL),(1437,934,0,'LSQ12eli','pessto',51.1982083333,-6.86372222222,NULL,NULL,'2012-08-25 00:00:00',56164,NULL,NULL,NULL,0.15,NULL,'Ia',NULL,'2012-09-04 11:23:40','2012-09-04 11:23:40','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,36804372250,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,575068316,8985442,NULL,NULL,NULL,NULL),(1438,915,0,'LSQ12elk','pessto',31.3318333333,-5.97241666667,NULL,NULL,'2012-08-25 00:00:00',56164,NULL,NULL,NULL,0.12,NULL,'Ia',NULL,'2012-09-04 11:27:19','2012-09-04 11:27:19','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35137599396,'NTT','EFOSC2','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,549024990,8578515,NULL,NULL,NULL,NULL),(1439,876,0,'LSQ12ekl','atel',347.856041667,-1.86508333333,NULL,NULL,'2012-08-22 00:00:00',56161,NULL,NULL,NULL,0.082,NULL,'Ia',NULL,'2012-09-04 11:31:27','2012-09-04 11:31:27','http://www.astronomerstelegram.org/?read=4331',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,49495526397,'UH_2p2m','SNIFS','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773367599,12083868,NULL,NULL,NULL,NULL),(1440,858,0,'LSQ12eks','atel',345.26725,-6.69516666667,NULL,NULL,'2012-08-22 00:00:00',56161,NULL,NULL,NULL,0.094,NULL,'Ia',NULL,'2012-09-04 12:14:29','2012-09-04 12:14:29','http://www.astronomerstelegram.org/?read=4331',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,49487173961,'UH_2.2m','SNIFS','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773237093,12081829,NULL,NULL,NULL,NULL),(1441,762,0,'PSNJ19371572-4218271','pessto',294.315504167,-42.3075388889,NULL,NULL,'2012-08-18 00:00:00',56157,NULL,NULL,NULL,0.02,NULL,'IIP',NULL,'2012-09-04 12:31:21','2012-09-04 12:31:21','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,51268024318,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,801062879,12516607,NULL,NULL,NULL,NULL),(1442,1014,0,'LSQ12elq','pessto',308.064416667,1.48769444444,NULL,NULL,'2012-08-25 00:00:00',56164,NULL,NULL,NULL,NULL,NULL,'variable star',NULL,'2012-09-04 12:37:56','2012-09-04 12:37:56','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,53996973989,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,843702718,13182854,NULL,NULL,NULL,NULL),(1443,1047,0,'LSQ12emc','pessto',309.749333333,-5.03875,NULL,NULL,'2012-08-25 00:00:00',56164,NULL,NULL,NULL,NULL,NULL,'variable star',NULL,'2012-09-04 12:56:23','2012-09-04 12:56:23','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,47839885908,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,747498217,11679659,NULL,NULL,NULL,NULL),(1444,543,0,'PSNJ20032484-5557192','pessto',300.8535,-55.955325,NULL,NULL,'2012-08-07 00:00:00',56146,NULL,NULL,NULL,0.015,NULL,'Ia',NULL,'2012-09-04 14:29:44','2012-09-04 14:29:44','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,49049600212,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,766400003,11975000,NULL,NULL,NULL,NULL),(1445,542,0,'PSNJ21253403-4016432','pessto',321.391766667,-40.2786888889,NULL,NULL,'2012-08-07 00:00:00',56146,NULL,NULL,NULL,0.017,NULL,'Ia',NULL,'2012-09-04 14:31:54','2012-09-04 14:31:54','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,51356335194,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,802442737,12538167,NULL,NULL,NULL,NULL),(1446,691,0,'PS1-12bch','Pan-STARRS1',37.141866732,24.1646723684,NULL,NULL,'2012-08-21 00:00:00',56160,NULL,NULL,NULL,0.02,NULL,'IIb',NULL,'2012-09-04 14:34:25','2019-08-19 23:13:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1022834041240952800/',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,68086492146,'WHT','ISIS','Darryl Wright',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1063851439,16622678,NULL,NULL,NULL,NULL),(1447,1447,1,'LSQ12euv','LSQ',328.523833333333,-5.83372222222222,NULL,NULL,'2012-08-28 00:18:57',56167.0131700002,19.6959,0.1662,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 14:45:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euv/LSQ12euv_history.html','sn?',NULL,0.357,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euv/LSQ12euv_snap_55762.gif',49890107103,NULL,NULL,NULL,'2012-08-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,779532923,12180201,NULL,NULL,NULL,NULL),(1448,1447,0,'LSQ12euv','LSQ',328.523875,-5.83369444444444,NULL,NULL,'2012-08-28 02:18:15',56167.09601,19.5176,0.1399,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 14:45:36','2012-09-04 14:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euv/LSQ12euv_history.html','sn?',NULL,0.357,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euv/LSQ12euv_snap_55763.gif',49890107103,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,779532923,12180201,NULL,NULL,NULL,NULL),(1449,1447,0,'LSQ12euv','LSQ',328.523666666667,-5.83375,NULL,NULL,'2012-09-02 00:00:19',56172.0002299999,19.1004,0.1193,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 14:45:36','2012-09-04 14:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euv/LSQ12euv_history.html','sn?',NULL,0.357,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euv/LSQ12euv_snap_55686.gif',49890107101,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,779532923,12180201,NULL,NULL,NULL,NULL),(1450,1447,0,'LSQ12euv','LSQ',328.523916666667,-5.83366666666667,NULL,NULL,'2012-09-02 02:02:23',56172.085,19.2098,0.1278,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 14:45:36','2012-09-04 14:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euv/LSQ12euv_history.html','sn?',NULL,0.357,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euv/LSQ12euv_snap_55687.gif',49890107103,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,779532923,12180201,NULL,NULL,NULL,NULL),(1451,1451,0,'LSQ12euu','LSQ',322.784083333333,-6.70402777777778,NULL,NULL,'2012-08-22 00:30:28',56161.02116,19.8563,0.1415,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 14:45:36','2019-10-11 20:38:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_snap_55761.gif',49683505270,NULL,NULL,NULL,'2012-08-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776304769,12129762,NULL,NULL,NULL,NULL),(1452,1451,0,'LSQ12euu','LSQ',322.784083333333,-6.70402777777778,NULL,NULL,'2012-09-01 23:48:29',56171.9920100002,19.0422,0.1159,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 14:45:36','2012-09-04 14:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_snap_55684.gif',49683505270,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776304769,12129762,NULL,NULL,NULL,NULL),(1453,1451,0,'LSQ12euu','LSQ',322.784083333333,-6.70408333333333,NULL,NULL,'2012-09-02 01:50:27',56172.0767100002,18.9315,0.169,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 14:45:36','2012-09-04 14:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_snap_55685.gif',49683505270,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776304769,12129762,NULL,NULL,NULL,NULL),(1454,1454,1,'LSQ12eus','LSQ',335.192208333333,0.522361111111111,NULL,NULL,'2012-08-28 01:24:02',56167.0583600001,19.0237,0.15,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 14:45:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eus/LSQ12eus_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eus/LSQ12eus_snap_55754.gif',52145877361,NULL,NULL,NULL,'2012-08-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,814779333,12730927,NULL,NULL,NULL,NULL),(1455,1454,0,'LSQ12eus','LSQ',335.191833333333,0.522583333333333,NULL,NULL,'2012-08-30 01:16:34',56169.0531799998,17.9725,0.131,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 14:45:36','2012-09-04 14:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eus/LSQ12eus_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eus/LSQ12eus_snap_55755.gif',52145877355,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,814779333,12730927,NULL,NULL,NULL,NULL),(1456,1454,0,'LSQ12eus','LSQ',335.191875,0.522527777777778,NULL,NULL,'2012-09-02 00:48:47',56172.03388,17.1878,0.0738,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 14:45:36','2012-09-04 14:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eus/LSQ12eus_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eus/LSQ12eus_snap_55680.gif',52145877355,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,814779333,12730927,NULL,NULL,NULL,NULL),(1457,1454,0,'LSQ12eus','LSQ',335.19175,0.522416666666667,NULL,NULL,'2012-09-02 02:48:41',56172.1171499998,17.7452,0.1186,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 14:45:36','2012-09-04 14:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eus/LSQ12eus_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eus/LSQ12eus_snap_55681.gif',52145877355,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,814779333,12730927,NULL,NULL,NULL,NULL),(1458,1458,1,'LSQ12eui','LSQ',51.85675,-11.5907777777778,NULL,NULL,'2012-09-02 06:12:41',56172.25881,18.9351,0.1613,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 14:45:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_snap_55656.gif',37886492397,NULL,NULL,NULL,'2012-09-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591976443,9249631,NULL,NULL,NULL,NULL),(1459,1458,0,'LSQ12eui','LSQ',51.8569166666667,-11.5911111111111,NULL,NULL,'2012-09-02 08:09:25',56172.3398799999,18.4782,0.1335,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 14:45:36','2012-09-04 14:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_snap_55657.gif',37886492399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591976443,9249631,NULL,NULL,NULL,NULL),(1460,1460,1,'LSQ12eue','LSQ',38.8794166666667,-7.49277777777778,NULL,NULL,'2012-09-02 04:28:25',56172.1864100001,18.9056,0.1511,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 14:45:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eue/LSQ12eue_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eue/LSQ12eue_snap_55646.gif',34938434364,NULL,NULL,NULL,'2012-09-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545913036,8529891,NULL,NULL,NULL,NULL),(1461,1460,0,'LSQ12eue','LSQ',38.8793333333333,-7.49280555555556,NULL,NULL,'2012-09-02 06:30:18',56172.2710500001,18.9361,0.1605,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 14:45:36','2012-09-04 14:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eue/LSQ12eue_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eue/LSQ12eue_snap_55647.gif',34938434364,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545913036,8529891,NULL,NULL,NULL,NULL),(1463,472,0,'LSQ12eeq','pessto',313.204416667,-16.5600555556,NULL,NULL,'2012-08-07 00:00:00',56146,NULL,NULL,NULL,NULL,NULL,'variable star',NULL,'2012-09-04 15:12:01','2012-09-04 15:12:01','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50992845486,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,796763210,12449425,NULL,NULL,NULL,NULL),(1464,611,0,'LSQ12eid','LSQ',4.40841666666667,-5.38283333333333,NULL,NULL,'2012-09-04 09:01:48',56174.3762599998,19.1856,0.1732,'gr-LSQ',NULL,NULL,'Ia',NULL,'2012-09-04 17:45:37','2012-09-04 17:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eid/LSQ12eid_snap_55831.gif',34413529726,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537711401,8401740,NULL,NULL,NULL,NULL),(1465,1289,0,'LSQ12erc','LSQ',8.771,1.48172222222222,NULL,NULL,'2012-09-04 07:45:58',56174.3235900002,18.9548,0.1232,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 17:45:37','2012-09-04 17:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_snap_55853.gif',66590313565,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1040473649,16257400,NULL,NULL,NULL,NULL),(1466,1289,0,'LSQ12erc','LSQ',8.771125,1.48133333333333,NULL,NULL,'2012-09-04 07:54:47',56174.3297199998,19.0254,0.1358,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-04 17:45:37','2012-09-04 17:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_snap_55854.gif',66590313561,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1040473649,16257400,NULL,NULL,NULL,NULL),(1467,921,0,'LSQ12elj','pessto',31.0349166667,-4.82077777778,NULL,NULL,'2012-08-26 00:00:00',56165,NULL,NULL,NULL,0.09,NULL,'Ia',NULL,'2012-09-04 17:50:14','2012-09-04 17:50:14','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35139786209,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549059159,8579049,NULL,NULL,NULL,NULL),(1468,689,0,'PS1-12bci','Pan-STARRS1',324.582515025,-6.90536756795,NULL,NULL,'2012-08-21 00:00:00',56160,NULL,NULL,NULL,0,NULL,'variable star',NULL,'2012-09-05 09:35:36','2019-08-19 23:13:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1213819800065419300/',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,49682141053,'WHT','ISIS','Darryl Wright',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,776283453,12129428,NULL,NULL,NULL,NULL),(1469,425,0,'LSQ12ecp','pessto',21.7569583333,-17.3654444444,NULL,NULL,'2012-08-07 00:00:00',56146,NULL,NULL,NULL,0.077,NULL,'Ia',NULL,'2012-09-05 09:39:58','2012-09-05 09:39:58','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35188002643,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549812541,8590820,NULL,NULL,NULL,NULL),(1470,435,0,'LSQ12ecb','pessto',337.79475,-24.8876111111,NULL,NULL,'2012-08-07 00:00:00',56146,NULL,NULL,NULL,0.089,NULL,'unknown',NULL,'2012-09-05 09:41:34','2012-09-05 09:41:34','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50073090666,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,782392041,12224875,NULL,NULL,NULL,NULL),(1472,1472,1,'SN2012ec','TOCP',41.4995,-7.57417,NULL,NULL,'2012-08-11 00:00:00',56150,14.5,NULL,NULL,NULL,NULL,NULL,NULL,'2012-09-05 08:15:42','2020-04-28 09:08:48','http://www.cbat.eps.harvard.edu/iau/cbet/003200/CBET003201.txt','supernova',NULL,0.00469,NULL,NULL,'http://farm8.staticflickr.com/7275/7771441224_597103075a_b.jpg',NULL,NULL,37875151026,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591799234,9246863,NULL,NULL,NULL,NULL),(1473,423,0,'LSQ12ecu','pessto',356.538125,-19.3575833333,NULL,NULL,'2012-08-07 00:00:00',56146,NULL,NULL,NULL,0.006,NULL,'unknown',NULL,'2012-09-05 14:59:22','2012-09-05 14:59:22','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,49535940995,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,773999078,12093735,NULL,NULL,NULL,NULL),(1474,1472,0,'SN2012ec','CBET',41.4995,-7.57417,NULL,NULL,'2012-08-12 00:00:00',56151,NULL,NULL,NULL,0.00469,NULL,'IIP',NULL,'2012-09-05 15:10:40','2012-09-05 15:10:40','http://www.cbat.eps.harvard.edu/iau/cbet/003200/CBET003201.txt',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37875151026,'ANU_2m','WiFeS','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591799234,9246863,NULL,NULL,NULL,NULL),(1475,1475,1,'SN2012dy','TOCP',319.71125,-57.64514,NULL,NULL,'2012-08-03 00:00:00',56142,15.6,NULL,NULL,NULL,NULL,NULL,NULL,'2012-09-05 16:16:11','2020-04-28 09:08:48','http://www.cbat.eps.harvard.edu/iau/cbet/003100/CBET003197.txt','supernova',NULL,0.01,NULL,NULL,'http://farm9.staticflickr.com/8423/7739392156_d39b5826a9_b.jpg',NULL,NULL,49133728063,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,767714500,11995539,NULL,NULL,NULL,NULL),(1476,1475,0,'SN2012dy','CBET',319.71125,-57.64514,NULL,NULL,'2012-08-05 00:00:00',56144,NULL,NULL,NULL,0.01,NULL,'IIb',NULL,'2012-09-05 15:17:21','2012-09-05 15:17:21','http://www.cbat.eps.harvard.edu/iau/cbet/003100/CBET003197.txt',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,49133728063,'SALT','RSS','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,767714500,11995539,NULL,NULL,NULL,NULL),(1477,417,0,'LSQ12dyt','atel',345.311166667,-6.72166666667,NULL,NULL,'2012-08-02 00:00:00',56141,NULL,NULL,NULL,0,NULL,'variable star',NULL,'2012-09-05 16:10:50','2012-09-05 16:10:50','http://www.astronomerstelegram.org/?read=4311',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,49487242571,'UH_2p2m','SNIFS','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,773238165,12081846,NULL,NULL,NULL,NULL),(1478,428,0,'LSQ12ecd','pessto',339.4785,-21.1293888889,NULL,NULL,'2012-08-08 00:00:00',56147,NULL,NULL,NULL,0.09,NULL,'Ia',NULL,'2012-09-05 16:58:44','2012-09-05 16:58:44','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50257618254,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785275285,12269926,NULL,NULL,NULL,NULL),(1479,407,0,'LSQ12dyw','pessto',352.353666667,-7.38908333333,NULL,NULL,'2012-08-07 00:00:00',56146,NULL,NULL,NULL,0.09,NULL,'unknown',NULL,'2012-09-05 17:16:45','2019-10-11 14:09:07','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,49660467229,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,1182471,NULL,0,775944800,12124137,NULL,NULL,NULL,NULL),(1480,85,0,'LSQ12dlf','pessto',27.6241666667,-21.8126111111,NULL,NULL,'2012-08-07 00:00:00',56146,NULL,NULL,NULL,0.25,NULL,'Ic peculiar',NULL,'2012-09-05 17:21:15','2019-10-11 14:09:07','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35034119519,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,1182499,NULL,0,547408117,8553251,NULL,NULL,NULL,NULL),(1481,1481,1,'SSS120810-231802-560926','CRTS-SSS',349.50757,-56.15713,NULL,NULL,'2012-08-10 00:00:00',56149,18,NULL,NULL,NULL,NULL,NULL,NULL,'2012-09-05 11:25:10','2019-10-11 14:10:04','http://crts.caltech.edu/ATEL/SSS/1208100551024104013.atel.html','supernova',NULL,0,NULL,NULL,'http://crts.caltech.edu/ATEL/SSS/1208100551024104013/1208100551024104013-0001.arch.jpg',NULL,NULL,48810736786,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,762667762,11916683,NULL,NULL,NULL,NULL),(1482,1481,0,'SSS120810-231802-560926','pessto',349.50757,-56.15713,NULL,NULL,'2012-08-17 00:00:00',56156,NULL,NULL,NULL,0.2,NULL,'Ic peculiar',NULL,'2012-09-05 17:27:10','2019-10-11 14:09:07','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,48810736786,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,1182665,NULL,0,762667762,11916683,NULL,NULL,NULL,NULL),(1483,1483,1,'SSS120816-012937-175040','CRTS-SSS',22.40618,-17.84455,NULL,NULL,'2012-08-16 00:00:00',56155,17.9,NULL,NULL,NULL,NULL,NULL,NULL,'2012-09-05 17:35:31','2019-10-11 14:10:04','http://crts.caltech.edu/ATEL/SSS/1208160170114103042.atel.html','supernova',NULL,0,NULL,NULL,'http://crts.caltech.edu/ATEL/SSS/1208160170114103042/1208160170114103042-0001.arch.jpg',NULL,NULL,35194431803,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,549912996,8592390,NULL,NULL,NULL,NULL),(1484,396,0,'LSQ12dya','atel',346.8545,-23.5859166667,NULL,NULL,'2012-08-02 00:00:00',56141,NULL,NULL,NULL,0,NULL,'unknown',NULL,'2012-09-05 17:46:01','2012-09-05 17:46:01','http://www.astronomerstelegram.org/?read=4311',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50298140916,'UH_2p2m','SNIFS','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,785908451,12279819,NULL,NULL,NULL,NULL),(1485,1485,1,'SSS120811-124603-165210','CRTS-SSS',191.51084,-16.86946,NULL,NULL,'2012-08-15 00:00:00',56154,18.6,NULL,NULL,NULL,NULL,NULL,NULL,'2012-09-05 17:49:53','2019-10-11 14:10:04','http://crts.caltech.edu/ATEL/SSS/1208110170924114100.atel.html','supernova',NULL,0,NULL,NULL,'http://crts.caltech.edu/ATEL/SSS/1208110170924114100/1208110170924114100-0001.arch.jpg',NULL,NULL,43931795834,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,686434309,10725536,NULL,NULL,NULL,NULL),(1486,1486,1,'SNHunt143','SNHunt',357.25747,-16.54264,NULL,NULL,'2012-07-30 00:00:00',56138,18,NULL,'R',NULL,NULL,NULL,NULL,'2012-09-05 12:03:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/Current/20120730_24.html','supernova',NULL,0,NULL,NULL,'http://farm8.staticflickr.com/7123/7749586940_0513eab757_b.jpg',NULL,NULL,49587337283,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,774802145,12106283,NULL,NULL,NULL,NULL),(1487,1487,1,'SNHunt140','SNHunt',193.9165,-39.53837,NULL,NULL,'2012-07-07 00:00:00',56115,17,NULL,'R',NULL,NULL,NULL,NULL,'2012-09-05 12:08:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/Current/20120707_89.html','supernova',NULL,0.01047,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20010855/jpg/108550390764104313_20120707_01_4.jpg',NULL,NULL,46757243354,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,730581927,11415342,NULL,NULL,NULL,NULL),(1488,1488,1,'SN2012ca','TOCP',280.28021,-41.794,NULL,NULL,'2012-04-25 00:00:00',56042,14.8,NULL,NULL,NULL,NULL,NULL,NULL,'2012-09-05 12:41:02','2020-04-28 09:08:48','NULL','supernova',NULL,0.01946,NULL,NULL,'/pessto/private/marshall/other_assets/remote_finders/2012ca_fc_20130227.jpg',NULL,NULL,51060883888,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,797826310,12466036,NULL,NULL,NULL,NULL),(1489,1488,0,'SN2012ca','pessto',280.28021,-41.794,NULL,NULL,'2012-04-29 00:00:00',56046,NULL,NULL,NULL,0.0195,NULL,'IIn',NULL,'2012-09-05 18:42:30','2012-09-05 18:42:30','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,51060883888,'NTT','EFOSC2 Gr13','Stefano Valenti',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,797826310,12466036,NULL,NULL,NULL,NULL),(1490,1201,0,'LSQ12eod','LSQ',319.040166666667,-24.1268333333333,NULL,NULL,'2012-09-05 00:46:23',56175.0322199999,20.1818,0.1087,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-05 21:45:35','2012-09-05 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eod/LSQ12eod_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eod/LSQ12eod_snap_55936.gif',50917408090,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,795584501,12431007,NULL,NULL,NULL,NULL),(1491,1201,0,'LSQ12eod','LSQ',319.040125,-24.1268055555556,NULL,NULL,'2012-09-05 02:55:45',56175.1220499999,20.4291,0.2052,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-05 21:45:35','2012-09-05 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eod/LSQ12eod_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eod/LSQ12eod_snap_55937.gif',50917408090,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,795584501,12431007,NULL,NULL,NULL,NULL),(1492,1233,0,'LSQ12eqa','LSQ',339.820166666667,-19.6163333333333,NULL,NULL,'2012-09-05 06:07:55',56175.2555,18.2626,0.1076,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-05 21:45:35','2012-09-05 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqa/LSQ12eqa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqa/LSQ12eqa_snap_55946.gif',50250522384,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785164412,12268193,NULL,NULL,NULL,NULL),(1493,1240,0,'LSQ12epy','LSQ',339.396916666667,-18.3269444444444,NULL,NULL,'2012-09-05 04:05:53',56175.1707600001,19.6294,0.1418,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-05 21:45:35','2012-09-05 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epy/LSQ12epy_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12epy/LSQ12epy_snap_55934.gif',50251458900,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785179045,12268422,NULL,NULL,NULL,NULL),(1494,1426,0,'LSQ12evf','LSQ',335.365541666667,-24.5855277777778,NULL,NULL,'2012-09-05 01:36:00',56175.0666700001,19.8212,0.0983,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-05 21:45:35','2012-09-05 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evf/LSQ12evf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evf/LSQ12evf_snap_55916.gif',50066844723,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782294448,12223350,NULL,NULL,NULL,NULL),(1495,1430,0,'LSQ12eve','LSQ',328.319125,-21.7154166666667,NULL,NULL,'2012-09-05 01:30:55',56175.0631400002,18.9941,0.0489,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-05 21:45:35','2012-09-05 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eve/LSQ12eve_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eve/LSQ12eve_snap_55918.gif',50881668328,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795026067,12422282,NULL,NULL,NULL,NULL),(1496,1430,0,'LSQ12eve','LSQ',328.319083333333,-21.7153888888889,NULL,NULL,'2012-09-05 03:40:26',56175.1530800001,18.9218,0.0572,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-05 21:45:35','2012-09-05 21:45:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eve/LSQ12eve_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eve/LSQ12eve_snap_55919.gif',50881668328,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795026067,12422282,NULL,NULL,NULL,NULL),(1498,1498,1,'LSQ12djg','LSQ',238.669,-8.5086,NULL,NULL,'2012-08-05 00:00:00',56144,18.75,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-05 17:36:53','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djg/LSQ12djg_history.html','agn',NULL,0,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djg/LSQ12djg_snap_42616.gif',NULL,NULL,45633447719,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,713022620,11140978,NULL,NULL,NULL,NULL),(1499,332,0,'LSQ12dwl','non-pessto atel',333.173125,0.511972222222,NULL,NULL,'2012-07-27 00:00:00',56135,NULL,NULL,NULL,0.0137,NULL,'Ic peculiar',NULL,'2012-09-05 23:51:40','2012-09-05 23:51:40','http://www.astronomerstelegram.org/?read=4398',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,52152344380,'P200','DS','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814880380,12732505,NULL,NULL,NULL,NULL),(1500,96,0,'LSQ12dle','pessto',25.1842916667,-25.2649166667,NULL,NULL,'2012-08-08 00:00:00',56147,NULL,NULL,NULL,0.05,NULL,'Ia',NULL,'2012-09-06 00:03:50','2012-09-06 00:03:50','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,34695840990,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542122515,8470664,NULL,NULL,NULL,NULL),(1501,343,0,'LSQ12dvr','pessto',39.5682083333,-2.43908333333,NULL,NULL,'2012-08-07 00:00:00',56146,NULL,NULL,NULL,0,NULL,'variable star',NULL,'2012-09-06 00:05:13','2012-09-06 00:05:13','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,34958364933,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,546224452,8534757,NULL,NULL,NULL,NULL),(1502,1502,1,'LSQ12dhs','LSQ',215.1405,-16.5966,NULL,NULL,'2012-07-06 00:00:00',56114,17.7,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 00:07:41','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dhs/LSQ12dhs_history.html','supernova',NULL,0.0408,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dhs/LSQ12dhs_snap_42138.gif',NULL,NULL,46554965008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,727421328,11365958,NULL,NULL,NULL,NULL),(1503,1503,1,'LSQ12dhe','LSQ',234.4163,6.6161,NULL,NULL,'2012-07-05 12:00:00',56113.5,18,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 00:11:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dhe/LSQ12dhe_history.html','supernova',NULL,0,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dhe/LSQ12dhe_snap_41892.gif',NULL,NULL,56414422997,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,881475359,13773052,NULL,NULL,NULL,NULL),(1504,1504,1,'LSQ12dgs','LSQ',356.4808,-6.0914,NULL,NULL,'2012-06-24 00:00:00',56102,18.5,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 00:15:11','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dgs/LSQ12dgs_history.html','supernova',NULL,0,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dgs/LSQ12dgs_snap_41866.gif',NULL,NULL,49436998382,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,772453099,12069579,NULL,NULL,NULL,NULL),(1505,353,0,'LSQ12dvj','pessto',28.3065416667,-1.85125,NULL,NULL,'2012-08-09 00:00:00',56148,NULL,NULL,NULL,0.13,NULL,'Ia peculiar',NULL,'2012-09-06 00:18:03','2012-09-06 00:18:03','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35020647697,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547197620,8549962,NULL,NULL,NULL,NULL),(1506,336,0,'LSQ12dwf','pessto',323.475041667,0.149083333333,NULL,NULL,'2012-08-08 00:00:00',56147,NULL,NULL,NULL,0.12,NULL,'Ia',NULL,'2012-09-06 00:20:02','2012-09-06 00:20:02','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,52106900277,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,814170316,12721411,NULL,NULL,NULL,NULL),(1507,307,0,'LSQ12drz','pessto',252.072625,19.2898333333,NULL,NULL,'2012-08-07 00:00:00',56146,NULL,NULL,NULL,0.137,NULL,'Ia',NULL,'2012-09-06 00:22:00','2012-09-06 00:22:00','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,56682128644,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,885658260,13838410,NULL,NULL,NULL,NULL),(1508,316,0,'LSQ12dww','pessto',229.472291667,4.87497222222,NULL,NULL,'2012-08-09 00:00:00',56148,NULL,NULL,NULL,0,NULL,'variable star',NULL,'2012-09-06 00:22:45','2012-09-06 00:22:45','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,56380598798,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,880946856,13764794,NULL,NULL,NULL,NULL),(1509,1509,0,'PSNJ02554120-2725276','TOCP',43.92167,-27.42433,NULL,NULL,'2012-08-22 00:00:00',56161,17.2,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-09-06 00:30:23','2019-10-12 20:41:36','http://www.cbat.eps.harvard.edu/unconf/followups/J02554120-2725276.html','supernova',NULL,0.0176,NULL,NULL,'http://www.rochesterastronomy.org/sn2012/e417m3s1.jpg',NULL,NULL,38605987746,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603218558,9425289,NULL,NULL,NULL,NULL),(1510,1510,0,'PSNJ23054871+1419564','TOCP',346.45296,14.33233,NULL,NULL,'2012-08-21 00:00:00',56160,19.2,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-09-05 18:36:01','2019-10-12 20:41:36','http://www.cbat.eps.harvard.edu/unconf/followups/J23054871 1419564.html','supernova',NULL,0,NULL,NULL,'http://farm8.staticflickr.com/7248/7879070720_ab1af6b738_b.jpg',NULL,NULL,52561414916,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,821272108,12832376,NULL,NULL,NULL,NULL),(1511,1511,0,'PSNJ21015899-4816259','TOCP',315.49579,-48.27386,NULL,NULL,'2012-08-19 00:00:00',56158,15.6,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-09-05 18:40:27','2019-10-12 20:41:36','http://cador.obs-hp.fr/sn_tarot/PSN_J21015899-4816259','supernova',NULL,0.0186,NULL,NULL,'http://farm9.staticflickr.com/8290/7827294480_ee5e292bc1_o.png',NULL,NULL,51351056248,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,802360253,12536878,NULL,NULL,NULL,NULL),(1512,1512,1,'SNHunt144','SNHunt',318.03714,-47.05388,NULL,NULL,'2012-08-06 00:00:00',56145,16.8,NULL,'R',NULL,NULL,NULL,NULL,'2012-09-06 01:43:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/Current/20120806_298.html','supernova',NULL,0,NULL,NULL,'http://farm9.staticflickr.com/8293/7744079614_153746b561_o.jpg',NULL,NULL,51400628406,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,803134818,12548981,NULL,NULL,NULL,NULL),(1513,1513,1,'SSS120814-221352-124146','CRTS-SSS',333.4661,-12.69603,NULL,NULL,'2012-08-14 00:00:00',56153,18.4,NULL,NULL,NULL,NULL,NULL,NULL,'2012-09-05 18:50:40','2019-10-11 14:10:04','http://crts.caltech.edu/ATEL/SSS/1208140131634121666.atel.html','supernova',NULL,0,NULL,NULL,'http://crts.caltech.edu/ATEL/SSS/1208140131634121666/1208140131634121666-0003.arch.jpg',NULL,NULL,49746502596,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,777289103,12145142,NULL,NULL,NULL,NULL),(1514,1513,0,'SSS120814-221352-124146','pessto',333.4661,-12.69603,NULL,NULL,'2012-08-26 00:00:00',56165,NULL,NULL,NULL,0.08,NULL,'Ia',NULL,'2012-09-06 00:51:53','2012-09-06 00:51:53','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,49746502596,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,777289103,12145142,NULL,NULL,NULL,NULL),(1515,1512,0,'SNHunt144','pessto',318.03714,-47.05388,NULL,NULL,'2012-08-07 00:00:00',56146,NULL,NULL,NULL,0.028,NULL,'Ia',NULL,'2012-09-06 00:52:45','2012-09-06 00:52:45','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,51400628406,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,803134818,12548981,NULL,NULL,NULL,NULL),(1516,1511,0,'PSNJ21015899-4816259','pessto',315.49579,-48.27386,NULL,NULL,'2012-08-26 00:00:00',56165,NULL,NULL,NULL,0.019,NULL,'Ia',NULL,'2012-09-06 00:53:47','2012-09-06 00:53:47','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,51351056248,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,802360253,12536878,NULL,NULL,NULL,NULL),(1517,1510,0,'PSNJ23054871+1419564','pessto',346.45296,14.33233,NULL,NULL,'2012-08-26 00:00:00',56165,NULL,NULL,NULL,0.11,NULL,'Ia peculiar',NULL,'2012-09-06 00:54:44','2012-09-06 00:54:44','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,52561414916,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,821272108,12832376,NULL,NULL,NULL,NULL),(1518,1509,0,'PSNJ02554120-2725276','pessto',43.92167,-27.42433,NULL,NULL,'2012-08-26 00:00:00',56165,NULL,NULL,NULL,0.02,NULL,'Ia peculiar',NULL,'2012-09-06 00:56:55','2012-09-06 00:56:55','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38605987746,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603218558,9425289,NULL,NULL,NULL,NULL),(1519,1519,1,'SNHunt141','SNHunt',204.4884,-17.90755,NULL,NULL,'2012-07-24 00:00:00',56132,15.6,NULL,'R',NULL,NULL,NULL,NULL,'2012-09-06 01:07:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/Current/20120724_54.html','supernova',NULL,0.00452,NULL,NULL,'http://farm9.staticflickr.com/8283/7880288434_b6629255fb_b.jpg',NULL,NULL,43780786638,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,684074791,10688668,NULL,NULL,NULL,NULL),(1520,1519,0,'SNHunt141','pessto',204.4884,-17.90755,NULL,NULL,'2012-08-08 00:00:00',56147,NULL,NULL,NULL,0.004,NULL,'IIP',NULL,'2012-09-06 01:09:44','2012-09-06 01:09:44','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43780786638,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,684074791,10688668,NULL,NULL,NULL,NULL),(1521,1521,0,'SNHunt142','SNHunt',314.47465,-51.87356,NULL,NULL,'2012-07-25 00:00:00',56133,18.9,NULL,'R',NULL,NULL,NULL,NULL,'2012-09-06 01:13:03','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/Current/20120725_79.html','supernova',NULL,0.0156,NULL,NULL,'http://farm9.staticflickr.com/8287/7660396306_f282c7582f_b.jpg',NULL,NULL,51341548799,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,802211699,12534557,NULL,NULL,NULL,NULL),(1522,1522,1,'LSQ12egz','LSQ',58.8607,-7.0874,NULL,NULL,'2012-08-08 19:11:59',56147.8,18.7,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 02:20:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egz/LSQ12egz_history.html','unknown',NULL,0,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12egz/LSQ12egz_snap_50448.gif',NULL,NULL,37037239971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,578706874,9042294,NULL,NULL,NULL,NULL),(1523,1523,1,'LSQ12eho','LSQ',318.3398,-19.9759,NULL,NULL,'2012-08-07 14:24:00',56146.6,19.3,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 01:22:04','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eho/LSQ12eho_history.html','supernova',NULL,0,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eho/LSQ12eho_snap_50652.gif',NULL,NULL,50940566374,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,795946349,12436661,NULL,NULL,NULL,NULL),(1524,1522,0,'LSQ12egz','pessto',58.8607,-7.0874,NULL,NULL,'2012-08-10 00:00:00',56149,NULL,NULL,NULL,0,NULL,'unknown',NULL,'2012-09-06 01:26:39','2012-09-06 01:26:39','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37037239971,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,578706874,9042294,NULL,NULL,NULL,NULL),(1525,1523,0,'LSQ12eho','pessto',318.3398,-19.9759,NULL,NULL,'2012-08-10 00:00:00',56149,NULL,NULL,NULL,0,NULL,'unknown',NULL,'2012-09-06 01:27:53','2012-09-06 01:27:53','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50940566374,'NTT','EFOS2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,795946349,12436661,NULL,NULL,NULL,NULL),(1526,1521,0,'SNHunt142','pessto',314.47465,-51.87356,NULL,NULL,'2012-08-08 00:00:00',56147,NULL,NULL,NULL,0.016,NULL,'Ic',NULL,'2012-09-06 01:30:42','2012-09-06 01:30:42','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,51341548799,'NTT','EFOSC2 Gr13','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,802211699,12534557,NULL,NULL,NULL,NULL),(1527,1527,1,'SSS120807-233315-330852','CRTS-SSS',353.31184,-33.14778,NULL,NULL,'2012-08-07 00:00:00',56146,18.2,NULL,NULL,NULL,NULL,NULL,NULL,'2012-09-06 01:32:40','2019-10-11 14:10:04','http://crts.caltech.edu/ATEL/SSS/1208070331494112436.atel.html','supernova',NULL,0,NULL,NULL,'http://crts.caltech.edu/ATEL/SSS/1208070331494112436/1208070331494112436-0001.arch.jpg',NULL,NULL,50174744747,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,783980386,12249693,NULL,NULL,NULL,NULL),(1528,1527,0,'SSS120807-233315-330852','pessto',353.31184,-33.14778,NULL,NULL,'2012-08-17 00:00:00',56156,NULL,NULL,NULL,0.03,NULL,'IIP',NULL,'2012-09-06 01:33:37','2012-09-06 01:33:37','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50174744747,'NTT','EFOSC2','Morgan Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,783980386,12249693,NULL,NULL,NULL,NULL),(1529,1529,1,'LSQ12deo','LSQ',353.873,-24.8304,NULL,NULL,'2012-06-19 00:00:00',56097,20.2,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 01:37:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12deo/LSQ12deo_history.html','supernova',NULL,0,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12deo/LSQ12deo_snap_41219.gif',NULL,NULL,50058717786,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782167465,12221366,NULL,NULL,NULL,NULL),(1530,1530,1,'LSQ12dlj','LSQ',237.221,-9.7528,NULL,NULL,'2012-07-08 00:00:00',56116,20.3,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-05 19:41:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djl/LSQ12djl_history.html','supernova',NULL,0,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12djl/LSQ12djl_snap_42597.gif',NULL,NULL,45605790081,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,712590470,11134226,NULL,NULL,NULL,NULL),(1531,1531,0,'PSNJ23501925+1637562','TOCP',357.58021,16.63228,NULL,NULL,'2012-08-18 00:00:00',56157,18.1,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-09-06 03:49:10','2019-10-12 20:41:36','http://www.astronomerstelegram.org/?read=4317','supernova',NULL,0,NULL,NULL,'http://master.sai.msu.ru/static/OT/235019.25163756.2_1.png',NULL,NULL,51663184044,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807237250,12613082,NULL,NULL,NULL,NULL),(1532,1531,0,'PSNJ23501925+1637562','CBET',357.58021,16.63228,NULL,NULL,'2012-08-21 00:00:00',56160,NULL,NULL,NULL,0.08,NULL,'Ia',NULL,'2012-09-06 09:52:48','2012-09-06 09:52:48','http://www.cbat.eps.harvard.edu/iau/cbet/003200/CBET003206.txt',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,51663184044,'NOT','ALFOSC','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,807237250,12613082,NULL,NULL,NULL,NULL),(1533,398,0,'LSQ12dzt','LSQ',44.4755,-1.504,NULL,NULL,'2012-07-27 19:11:59',56135.8,17.9,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 09:54:44','2012-09-06 09:54:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzt/LSQ12dzt_history.html','supernova',NULL,0,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12dzt/LSQ12dzt_snap_48160.gif',NULL,NULL,37849891215,NULL,NULL,NULL,'2012-07-23 09:33:07',56131.398,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591404550,9240696,NULL,NULL,NULL,NULL),(1534,398,0,'LSQ12dzt','atel',44.4754583333,-1.50394444444,NULL,NULL,'2012-08-02 00:00:00',56141,NULL,NULL,NULL,0.037,NULL,'IIn',NULL,'2012-09-06 09:57:31','2012-09-06 09:57:31','http://www.astronomerstelegram.org/?read=4311',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37849891215,'UH_2p2m','SNIFS','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591404550,9240696,NULL,NULL,NULL,NULL),(1535,1535,0,'SNHunt145','SNHunt',311.31367,-5.62281,NULL,NULL,'2012-08-13 00:00:00',56152,16.4,NULL,'R',NULL,NULL,NULL,NULL,'2012-09-06 10:02:26','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/Current/20120813_105.html','supernova',NULL,0.0274,NULL,NULL,'http://farm8.staticflickr.com/7109/7791806424_61bd503ee8_b.jpg',NULL,NULL,50738665227,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,792791644,12387369,NULL,NULL,NULL,NULL),(1536,1535,0,'SN2012ee','IAU',311.31367,-5.62281,NULL,NULL,'2012-08-13 00:00:00',56152,16.4,NULL,NULL,NULL,NULL,NULL,NULL,'2012-09-06 10:06:05','2012-09-06 10:06:05','http://www.cbat.eps.harvard.edu/iau/cbet/003200/CBET003205.txt','supernova',NULL,0.027,NULL,NULL,'http://farm8.staticflickr.com/7109/7791806424_61bd503ee8_b.jpg',NULL,NULL,50738665227,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,792791644,12387369,NULL,NULL,NULL,NULL),(1537,1535,0,'SNHunt145','CBET',311.31367,-5.62281,NULL,NULL,'2012-08-17 23:16:48',56156.97,NULL,NULL,NULL,0.027,NULL,'Ia',NULL,'2012-09-06 10:09:06','2012-09-06 10:09:06','http://www.cbat.eps.harvard.edu/iau/cbet/003200/CBET003205.txt',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50738665227,'Ekar_1p8m','AFOSC','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,792791644,12387369,NULL,NULL,NULL,NULL),(1538,1538,0,'CSS120813-153936-024101','CRTS-CSS',234.90189,-2.68354,NULL,NULL,'2012-08-13 00:00:00',56152,17.7,NULL,'R',NULL,NULL,NULL,NULL,'2012-09-06 04:13:41','2019-10-12 20:41:36','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1208130010844101062.atel.html','supernova',NULL,0,NULL,NULL,'http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1208130010844101062/1208130010844101062-0001.arch.jpg',NULL,NULL,45413652819,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,709588325,11087317,NULL,NULL,NULL,NULL),(1539,1538,0,'CSS120813-153936-024101','atel',234.90189,-2.68354,NULL,NULL,'2012-08-17 00:00:00',56156,NULL,NULL,NULL,0.015,NULL,'II',NULL,'2012-09-06 10:16:27','2012-09-06 10:16:27','http://www.astronomerstelegram.org/?read=4312',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,45413652819,'Ekar_1p8m','AFOSC','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,709588325,11087317,NULL,NULL,NULL,NULL),(1540,685,0,'PS1_12bcg','Pan-STARRS1',34.62608,-0.45614,NULL,NULL,'2012-08-04 14:24:00',56143.6,18,NULL,NULL,NULL,NULL,NULL,NULL,'2012-09-06 10:20:30','2019-08-19 23:13:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1021830260002722100/','variable star',NULL,0,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56143/1021830260002722100_56143.597_504674_158_target.fits',NULL,NULL,34914087818,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545532622,8523947,NULL,NULL,NULL,NULL),(1541,685,0,'PS1-12bcg','Pan-STARRS1',34.6261005007,-0.45615004647,NULL,NULL,'2012-08-21 00:00:00',56160,NULL,NULL,NULL,0,NULL,'variable star',NULL,'2012-09-06 10:23:47','2019-08-19 23:13:53','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1021830260002722100/',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,34914087818,'WHT','ISIS','Darryl Wright',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545532622,8523947,NULL,NULL,NULL,NULL),(1542,1542,0,'PSNJ15395722-3033192','TOCP',234.98842,-30.55533,NULL,NULL,'2012-08-18 09:35:59',56157.4,17.2,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-09-06 04:29:40','2019-10-12 20:41:36','http://www.cbat.eps.harvard.edu/iau/cbet/003200/CBET003213.txt','supernova',NULL,0.0182,NULL,NULL,'http://spaceobs.org/images/TOCP/PSNJ15395722-3033192-20120820.png',NULL,NULL,47175762859,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,737121294,11517520,NULL,NULL,NULL,NULL),(1543,1542,0,'PSNJ15395722-3033192','CBET',234.98842,-30.55533,NULL,NULL,'2012-08-25 00:00:00',56164,NULL,NULL,NULL,0.0182,NULL,'Ia',NULL,'2012-09-06 10:30:43','2012-09-06 10:30:43','http://www.cbat.eps.harvard.edu/iau/cbet/003200/CBET003213.txt',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,47175762859,'NTT','EFOSC2 Gr13','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,737121294,11517520,NULL,NULL,NULL,NULL),(1544,1544,0,'PSNJ14242911-1645392','TOCP',216.12129,-16.76089,NULL,NULL,'2012-08-12 00:00:00',56151,16.3,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-09-06 11:38:53','2019-10-12 20:41:36','http://www.cbat.eps.harvard.edu/unconf/followups/J14242911-1645392.html','supernova',NULL,0.0089,NULL,NULL,'http://www.rochesterastronomy.org/sn2012/n5597s2.jpg',NULL,NULL,46556516621,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,727445572,11366337,NULL,NULL,NULL,NULL),(1545,1544,0,'PSNJ14242911-1645392','TOCP',216.12129,-16.76089,NULL,NULL,'2012-08-24 00:00:00',56163,NULL,NULL,NULL,0.008,NULL,'IIb',NULL,'2012-09-06 10:39:55','2012-09-06 10:39:55','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46556516621,'NTT','EFOSC2 Gr13','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,727445572,11366337,NULL,NULL,NULL,NULL),(1546,332,0,'CSS120825-221242+003043','CRTS-CSS',333.17314,0.51201,NULL,NULL,'2012-08-25 00:00:00',56164,15.8,NULL,'R',NULL,NULL,NULL,NULL,'2012-09-06 10:42:18','2012-09-06 10:42:18','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1208251011194110586.atel.html','supernova',NULL,0,NULL,NULL,'http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1208251011194110586/1208251011194110586-0001.arch.jpg',NULL,NULL,52152344378,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814880380,12732505,NULL,NULL,NULL,NULL),(1547,1547,1,'PSNJ02263653+1208555','TOCP',36.65221,12.14875,NULL,NULL,'2012-08-27 00:00:00',56166,17.6,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-09-06 10:47:11','2019-10-11 14:10:04','http://www.cbat.eps.harvard.edu/unconf/followups/J02263653 1208555.html','supernova',NULL,0.0275,NULL,NULL,'http://www.astrofilisenesi.it/public/Sne/Uploads/PSN_in_NGC0927.jpg',NULL,NULL,67947771383,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1061683927,16588811,NULL,NULL,NULL,NULL),(1548,1547,0,'PSNJ02263653+1208555','atel',36.65221,12.14875,NULL,NULL,'2012-08-29 00:00:00',56168,NULL,NULL,NULL,0.028,NULL,'Ia',NULL,'2012-09-06 10:48:25','2012-09-06 10:48:25','http://www.astronomerstelegram.org/?read=4348',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,67947771383,'UH_2p2m','SNIFS','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1061683927,16588811,NULL,NULL,NULL,NULL),(1549,1549,1,'PSNJ03412317-1745348','TOCP',55.34654,-17.75967,NULL,NULL,'2012-08-27 00:00:00',56166,17.4,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-09-06 12:16:38','2019-10-11 14:10:04','http://www.cbat.eps.harvard.edu/unconf/followups/J03412317-1745348.html','supernova',NULL,0.0239,NULL,NULL,'http://farm9.staticflickr.com/8300/7876367506_0d898dff7d_b.jpg',NULL,NULL,38011729532,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593933273,9280207,NULL,NULL,NULL,NULL),(1550,1550,0,'PSNJ04371913-6908254','TOCP',69.32971,-69.14039,NULL,NULL,'2012-08-27 00:00:00',56166,17.5,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-09-06 11:18:29','2019-10-12 20:41:36','http://www.cbat.eps.harvard.edu/unconf/followups/J04371913-6908254.html','supernova',NULL,0.0605,NULL,NULL,'http://farm9.staticflickr.com/8462/7891154554_bffc0ecc94_b.jpg',NULL,NULL,36436638088,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,569322470,8895663,NULL,NULL,NULL,NULL),(1551,1551,1,'SNhunt146','SNHunt',49.713,-13.06312,NULL,NULL,'2012-08-28 00:00:00',56167,18.2,NULL,'R',NULL,NULL,NULL,NULL,'2012-09-06 11:36:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/Current/20120828_350.html','supernova',NULL,0.0311,NULL,NULL,'http://farm9.staticflickr.com/8178/7893886008_c1d2e25a82_b.jpg',NULL,NULL,38082367977,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,595036999,9297453,NULL,NULL,NULL,NULL),(1552,1552,1,'SNhunt147','SNhunt',218.84541,-13.73247,NULL,NULL,'2012-09-03 00:00:00',56173,17,NULL,'R',NULL,NULL,NULL,NULL,'2012-09-06 05:38:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/Current/20120903_9.html','supernova',NULL,0.0139,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20010863/jpg/108630131074105149_20120903_01_4.jpg',NULL,NULL,46677585064,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,729337266,11395894,NULL,NULL,NULL,NULL),(1553,1553,1,'SSS120828-233202-454503','CRTS-SSS',353.00907,-45.75089,NULL,NULL,'2012-08-28 00:00:00',56167,17.8,NULL,NULL,NULL,NULL,NULL,NULL,'2012-09-06 06:11:54','2019-10-11 14:10:04','http://crts.caltech.edu/ATEL/SSS/1208280451264106073.atel.html','supernova',NULL,0,NULL,NULL,'http://crts.caltech.edu/ATEL/SSS/1208280451264106073/1208280451264106073-0001.arch.jpg',NULL,NULL,50476903066,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,788701610,12323462,NULL,NULL,NULL,NULL),(1554,1554,0,'SSS120827-010014-304831','CRTS-SSS',15.05988,-30.80858,NULL,NULL,'2012-08-27 00:00:00',56166,15.4,NULL,NULL,NULL,NULL,NULL,NULL,'2012-09-06 08:18:13','2019-10-12 20:41:36','http://crts.caltech.edu/ATEL/SSS/1208270090244119566.atel.html','supernova',NULL,0.0322,NULL,NULL,'http://crts.caltech.edu/ATEL/SSS/1208270310074114752/1208270310074114752-0003.arch.jpg',NULL,NULL,34740993705,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542828026,8481687,NULL,NULL,NULL,NULL),(1555,1555,0,'SSS120827-031304-082332','CRTS-SSS',48.26734,-8.39214,NULL,NULL,'2012-08-27 00:00:00',56166,17.2,NULL,NULL,NULL,NULL,NULL,NULL,'2012-09-06 14:20:18','2019-10-12 20:41:36','http://crts.caltech.edu/ATEL/SSS/1208270090244119566.atel.html','supernova',NULL,0.0299,NULL,NULL,'http://crts.caltech.edu/ATEL/SSS/1208270090244119566/1208270090244119566-0001.arch.jpg',NULL,NULL,37888921026,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,592014391,9250224,NULL,NULL,NULL,NULL),(1556,1556,0,'CSS120828-231622+241519','CRTS-CSS',349.09205,24.25517,NULL,NULL,'2012-08-28 00:00:00',56167,18.8,NULL,NULL,NULL,NULL,NULL,NULL,'2012-09-06 15:26:41','2019-10-12 20:41:36','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1208281231154134578.atel.html','supernova',NULL,0,NULL,NULL,'http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1208281231154134578/1208281231154134578-0001.arch.jpg',NULL,NULL,51977526954,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,812148858,12689825,NULL,NULL,NULL,NULL),(1557,1557,1,'LSQ12evn','LSQ',311.892625,-17.1578611111111,NULL,NULL,'2012-08-07 04:13:27',56146.1760100001,19.3367,0.0806,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 15:45:34','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_56019.gif',50992570481,NULL,NULL,NULL,'2012-08-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1558,1557,0,'LSQ12evn','LSQ',311.892875,-17.1579166666667,NULL,NULL,'2012-08-09 01:56:36',56148.0809800001,18.3122,0.0429,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 15:45:34','2012-09-06 15:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_56020.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1559,1557,0,'LSQ12evn','LSQ',311.892791666667,-17.1581388888889,NULL,NULL,'2012-08-10 23:48:07',56149.99175,18.6705,0.0692,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 15:45:34','2012-09-06 15:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_56021.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1560,1557,0,'LSQ12evn','LSQ',311.892708333333,-17.1578333333333,NULL,NULL,'2012-08-15 00:32:29',56154.02256,17.9943,0.0305,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 15:45:34','2012-09-06 15:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_56022.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1561,1557,0,'LSQ12evn','LSQ',311.892708333333,-17.1579166666667,NULL,NULL,'2012-08-19 00:15:40',56158.01088,17.9733,0.0319,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 15:45:34','2012-09-06 15:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_56023.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1562,1557,0,'LSQ12evn','LSQ',311.892708333333,-17.1577222222222,NULL,NULL,'2012-08-21 01:09:14',56160.0480900002,17.8513,0.0441,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 15:45:34','2012-09-06 15:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_56024.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1563,1557,0,'LSQ12evn','LSQ',311.892625,-17.1578055555556,NULL,NULL,'2012-08-27 02:13:51',56166.09296,17.7691,0.0717,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 15:45:34','2012-09-06 15:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_56025.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1564,1557,0,'LSQ12evn','LSQ',311.892708333333,-17.1579166666667,NULL,NULL,'2012-09-04 23:58:44',56174.9991299999,18.5252,0.0473,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 15:45:34','2012-09-06 15:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_56003.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1565,1557,0,'LSQ12evn','LSQ',311.89275,-17.1578055555556,NULL,NULL,'2012-09-05 02:00:03',56175.0833700001,18.3605,0.041,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 15:45:34','2012-09-06 15:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_56004.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1566,1566,1,'LSQ12evm','LSQ',336.765708333333,-23.6769444444444,NULL,NULL,'2012-09-05 04:04:12',56175.1695900001,19.32,0.1324,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 15:45:34','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evm/LSQ12evm_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evm/LSQ12evm_snap_56001.gif',50212210897,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784565795,12258840,NULL,NULL,NULL,NULL),(1567,1566,0,'LSQ12evm','LSQ',336.765708333333,-23.6769444444444,NULL,NULL,'2012-09-05 06:04:32',56175.2531499998,19.3216,0.107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 15:45:34','2012-09-06 15:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evm/LSQ12evm_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evm/LSQ12evm_snap_56002.gif',50212210897,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784565795,12258840,NULL,NULL,NULL,NULL),(1568,1568,1,'LSQ12evl','LSQ',309.547291666667,-20.9068333333333,NULL,NULL,'2012-09-04 23:58:44',56174.9991299999,20.3684,0.1308,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 15:45:34','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_snap_55999.gif',50824114763,NULL,NULL,NULL,'2012-08-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,794126793,12408231,NULL,NULL,NULL,NULL),(1569,1568,0,'LSQ12evl','LSQ',309.54725,-20.9068611111111,NULL,NULL,'2012-09-05 02:00:03',56175.0833700001,20.377,0.1235,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 15:45:34','2012-09-06 15:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_snap_56000.gif',50824114763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,794126793,12408231,NULL,NULL,NULL,NULL),(1570,1570,1,'LSQ12evo','LSQ',317.5235,-25.5899,NULL,NULL,'2012-08-27 12:00:00',56166.5,19.9,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 10:04:41','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_history.html','supernova',NULL,0,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_snap_56005.gif',NULL,NULL,51425622868,NULL,NULL,NULL,'2012-08-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,803525357,12555083,NULL,NULL,NULL,NULL),(1571,1570,0,'LSQ12evo','LSQ',317.523458333333,-25.5899444444444,NULL,NULL,'2012-08-27 00:35:14',56166.0244700001,19.9346,0.1686,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 16:45:34','2012-09-06 16:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_snap_56026.gif',51425622868,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,803525357,12555083,NULL,NULL,NULL,NULL),(1572,1570,0,'LSQ12evo','LSQ',317.523416666667,-25.5899722222222,NULL,NULL,'2012-09-05 00:26:03',56175.0181,18.9462,0.1015,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 16:45:34','2012-09-06 16:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_snap_56005.gif',51425622868,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,803525357,12555083,NULL,NULL,NULL,NULL),(1573,1570,0,'LSQ12evo','LSQ',317.523333333333,-25.5900277777778,NULL,NULL,'2012-09-05 02:35:25',56175.1079299999,19.2899,0.0961,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 16:45:34','2012-09-06 16:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_snap_56006.gif',51425622868,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,803525357,12555083,NULL,NULL,NULL,NULL),(1574,1511,0,'PSNJ21015899-4816259','TOCP',315.49579,-48.273861,NULL,NULL,'2012-08-19 12:00:00',56158.5,15.3,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-09-06 19:51:11','2012-09-06 19:51:11','http://www.astronomerstelegram.org/?read=4339','supernova',NULL,0.01859,NULL,NULL,'https://c2.staticflickr.com/8/7136/7848777388_141ec55ba6_o.jpg',NULL,NULL,51351056248,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,802360253,12536878,NULL,NULL,NULL,NULL),(1575,1430,0,'LSQ12eve','LSQ',328.319208333,-21.7153611111,NULL,NULL,'2012-09-07 00:00:00',56177,NULL,NULL,NULL,0.098,NULL,'Ia',NULL,'2012-09-06 21:41:38','2012-09-06 21:41:38','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50881668328,'ANU','WiFeS','Childress',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795026067,12422282,NULL,NULL,NULL,NULL),(1576,1375,0,'LSQ12ers','LSQ',345.5155,-22.8755277778,NULL,NULL,'2012-09-07 00:00:00',56177,NULL,NULL,NULL,0.099,NULL,'Ia',NULL,'2012-09-06 21:46:31','2012-09-06 21:46:31','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50214718088,'ANU','WiFeS','Childress',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784604970,12259452,NULL,NULL,NULL,NULL),(1577,1447,0,'LSQ12euv','LSQ',328.523791666667,-5.834,NULL,NULL,'2012-09-06 03:00:36',56176.1254199999,20.0188,0.1846,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-06 22:45:34','2012-09-06 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euv/LSQ12euv_history.html','sn?',NULL,0.357,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euv/LSQ12euv_snap_56031.gif',49890107101,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,779532923,12180201,NULL,NULL,NULL,NULL),(1578,1355,0,'LSQ12erl','LSQ',328.12325,-22.1982222222,NULL,NULL,'2012-09-06 00:00:00',56176,NULL,NULL,NULL,0.073,NULL,'unknown',NULL,'2012-09-06 23:24:10','2012-09-06 23:24:10','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50881760614,'ANU_2p2m','WiFeS','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795027509,12422304,NULL,NULL,NULL,NULL),(1579,1451,0,'LSQ12euu','LSQ',322.784083333,-6.70402777778,NULL,NULL,'2012-09-06 00:00:00',56176,NULL,NULL,NULL,0.098,NULL,'Ia',NULL,'2012-09-06 23:26:20','2012-09-06 23:26:20','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,49683505270,'ANU_2p2m','WiFeS','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776304769,12129762,NULL,NULL,NULL,NULL),(1580,1447,0,'LSQ12euv','LSQ',328.523833333,-5.83372222222,NULL,NULL,'2012-09-06 00:00:00',56176,NULL,NULL,NULL,0.137,NULL,'unknown',NULL,'2012-09-06 23:30:11','2012-09-06 23:30:11','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,49890107103,'ANU_2p2m','WiFeS','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,779532923,12180201,NULL,NULL,NULL,NULL),(1581,1413,0,'LSQ12etc','LSQ',335.135791667,0.552944444444,NULL,NULL,'2012-09-06 00:00:00',56176,NULL,NULL,NULL,0,NULL,'variable star',NULL,'2012-09-06 23:31:43','2012-09-06 23:31:43','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,52145872977,'ANU_2p2m','WiFeS','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,814779265,12730926,NULL,NULL,NULL,NULL),(1582,1454,0,'LSQ12eus','LSQ',335.192208333,0.522361111111,NULL,NULL,'2012-09-06 00:00:00',56176,NULL,NULL,NULL,0,NULL,'variable star',NULL,'2012-09-06 23:32:44','2012-09-06 23:32:44','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,52145877361,'ANU_2p2m','WiFeS','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,814779333,12730927,NULL,NULL,NULL,NULL),(1583,1351,0,'LSQ12erp','LSQ',347.613333333,-22.173,NULL,NULL,'2012-09-06 00:00:00',56176,NULL,NULL,NULL,0,NULL,'variable star',NULL,'2012-09-06 23:37:21','2012-09-06 23:37:21','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50300580081,'ANU_2p2m','WiFeS','Anon Reducer',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785946563,12280415,NULL,NULL,NULL,NULL),(1584,1584,1,'PTF12iiq','PTF',42.532333,-0.265124,NULL,NULL,'2012-08-31 00:00:00',56170,18,NULL,NULL,NULL,NULL,NULL,NULL,'2012-09-07 08:40:11','2019-10-11 14:10:04','http://navtara.caltech.edu/cgi-bin/ptf/view_source.cgi?name=12iiq','supernova',NULL,0.0291,NULL,NULL,'http://navtara.caltech.edu/ptf/thumbs/12iiq_ref.png',NULL,NULL,34897860426,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545279069,8519985,NULL,NULL,NULL,NULL),(1585,1584,0,'PTF12iiq','PTF',42.532333,-0.265124,NULL,NULL,'2012-09-01 00:00:00',56171,NULL,NULL,NULL,0.0291,NULL,'Ia',NULL,'2012-09-07 08:43:38','2012-09-07 08:43:38','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,34897860426,'UH88','SNIFS','None',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545279069,8519985,NULL,NULL,NULL,NULL),(1586,1554,0,'SSS120827-010014-304831','CRTS-SSS',15.05988,-30.80858,NULL,NULL,'2012-09-08 00:00:00',56178,NULL,NULL,NULL,0.033,NULL,'Ia',NULL,'2012-09-08 06:20:06','2012-09-08 06:20:06','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,34740993705,'ANU','WiFeS','Childress',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542828026,8481687,NULL,NULL,NULL,NULL),(1587,1551,0,'SNhunt146','pessto',49.713,-13.06312,NULL,NULL,'2012-09-08 00:00:00',56178,NULL,NULL,NULL,0.032,NULL,'Ia',NULL,'2012-09-08 08:23:23','2012-09-08 08:23:23','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38082367977,'NTT','EFOSC','Yen Chen Pan',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,595036999,9297453,NULL,NULL,NULL,NULL),(1588,1423,0,'SSS120817-002822-305723','pessto',7.09095,-30.95642,NULL,NULL,'2012-09-08 19:11:59',56178.8,NULL,NULL,NULL,0.05,NULL,'Ia',NULL,'2012-09-08 08:55:26','2012-09-08 08:55:26','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,34889867327,'NTT','EFOSC','Yen Chen Pan',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545154176,8518034,NULL,NULL,NULL,NULL),(1589,1174,0,'LSQ12eor','pessto',57.7149166667,-16.9243611111,NULL,NULL,'2012-09-08 19:11:59',56178.8,NULL,NULL,NULL,0.04,NULL,'II',NULL,'2012-09-08 10:04:01','2012-09-08 10:04:01','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,36881294756,'NTT','EFOSC','Yen Chen Pan',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576270230,9004222,NULL,NULL,NULL,NULL),(1590,1566,0,'LSQ12evm','LSQ',336.765833333333,-23.6768611111111,NULL,NULL,'2012-09-07 04:06:19',56177.1710600001,19.577,0.1364,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-09 08:45:36','2012-09-09 08:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evm/LSQ12evm_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evm/LSQ12evm_snap_56052.gif',50212210897,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784565795,12258840,NULL,NULL,NULL,NULL),(1591,644,0,'LSQ12eij','LSQ',353.852458333333,-20.5113611111111,NULL,NULL,'2012-09-08 07:33:10',56178.3147,20.3859,0.1572,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-09 13:45:32','2012-09-09 13:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eij/LSQ12eij_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eij/LSQ12eij_snap_56069.gif',50275077896,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785548092,12274188,NULL,NULL,NULL,NULL),(1592,644,0,'LSQ12eij','LSQ',353.852375,-20.5112777777778,NULL,NULL,'2012-09-09 02:59:55',56179.1249500001,19.8286,0.072,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 03:45:32','2012-09-10 03:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eij/LSQ12eij_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eij/LSQ12eij_snap_56073.gif',50275077940,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785548092,12274188,NULL,NULL,NULL,NULL),(1593,644,0,'LSQ12eij','LSQ',353.8525,-20.5113888888889,NULL,NULL,'2012-09-09 05:02:23',56179.2099899999,20.3366,0.0952,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 03:45:32','2012-09-10 03:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eij/LSQ12eij_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eij/LSQ12eij_snap_56074.gif',50275077896,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785548092,12274188,NULL,NULL,NULL,NULL),(1594,823,0,'LSQ12ejw','LSQ',357.601041666667,-24.6792777777778,NULL,NULL,'2012-09-09 00:57:23',56179.0398599999,19.0272,0.1165,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 03:45:32','2012-09-10 03:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_snap_56082.gif',50012665062,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,781447891,12210123,NULL,NULL,NULL,NULL),(1595,823,0,'LSQ12ejw','LSQ',357.600958333333,-24.6792777777778,NULL,NULL,'2012-09-09 02:59:55',56179.1249500001,17.0898,0.0818,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 03:45:32','2012-09-10 03:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_snap_56083.gif',50012664937,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,781447889,12210123,NULL,NULL,NULL,NULL),(1596,1557,0,'LSQ12evn','LSQ',311.892625,-17.1579166666667,NULL,NULL,'2012-09-09 00:00:42',56179.00049,18.733,0.048,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 03:45:32','2012-09-10 03:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_56086.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1597,1570,0,'LSQ12evo','LSQ',317.523458333333,-25.59,NULL,NULL,'2012-09-09 00:27:59',56179.0194399999,19.3742,0.1397,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 03:45:32','2012-09-10 03:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_snap_56084.gif',51425622868,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,803525357,12555083,NULL,NULL,NULL,NULL),(1598,1483,0,'SSS120816-012937-175040','pessto',22.40618,-17.84455,NULL,NULL,'2012-09-10 19:11:59',56180.8,NULL,NULL,NULL,0.07,NULL,'Ia',NULL,'2012-09-10 08:56:25','2012-09-10 08:56:25','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35194431803,'NTT','EFOSC','Yen Chen',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,549912996,8592390,NULL,NULL,NULL,NULL),(1599,1599,1,'LSQ12evr','LSQ',27.4370833333333,-27.5272777777778,NULL,NULL,'2012-09-08 03:31:19',56178.1467499998,21.0924,0.1373,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evr/LSQ12evr_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evr/LSQ12evr_snap_56113.gif',38254315647,NULL,NULL,NULL,'2012-09-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597723681,9339432,NULL,NULL,NULL,NULL),(1600,1599,0,'LSQ12evr','LSQ',27.437,-27.5274722222222,NULL,NULL,'2012-09-08 05:59:17',56178.24951,20.6734,0.1226,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2012-09-10 20:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evr/LSQ12evr_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evr/LSQ12evr_snap_56114.gif',38254315647,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597723681,9339432,NULL,NULL,NULL,NULL),(1601,1599,0,'LSQ12evr','LSQ',27.4364583333333,-27.5276388888889,NULL,NULL,'2012-09-09 03:11:37',56179.13307,20.9836,0.1359,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2012-09-10 20:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evr/LSQ12evr_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evr/LSQ12evr_snap_56186.gif',38254315645,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597723681,9339432,NULL,NULL,NULL,NULL),(1602,1602,1,'LSQ12ewh','LSQ',353.865916666667,-24.3461666666667,NULL,NULL,'2012-08-12 04:45:39',56151.1983699999,21.1629,0.1026,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_snap_56178.gif',50055645510,NULL,NULL,NULL,'2012-08-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,782119461,12220616,NULL,NULL,NULL,NULL),(1603,1602,0,'LSQ12ewh','LSQ',353.866,-24.3461666666667,NULL,NULL,'2012-08-12 07:05:27',56151.2954600002,20.9767,0.0988,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2012-09-10 20:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_snap_56179.gif',50055645510,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,782119461,12220616,NULL,NULL,NULL,NULL),(1604,1602,0,'LSQ12ewh','LSQ',353.866,-24.3461666666667,NULL,NULL,'2012-08-12 09:06:52',56151.37977,21.0498,0.1025,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2012-09-10 20:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_snap_56180.gif',50055645510,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,782119461,12220616,NULL,NULL,NULL,NULL),(1605,1602,0,'LSQ12ewh','LSQ',353.865958333333,-24.3461666666667,NULL,NULL,'2012-08-15 02:48:52',56154.1172699998,20.8443,0.1283,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2012-09-10 20:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_snap_56181.gif',50055645510,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,782119461,12220616,NULL,NULL,NULL,NULL),(1606,1602,0,'LSQ12ewh','LSQ',353.866,-24.3462222222222,NULL,NULL,'2012-08-18 08:44:28',56157.3642199999,20.5916,0.1097,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2012-09-10 20:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_snap_56182.gif',50055645510,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,782119461,12220616,NULL,NULL,NULL,NULL),(1607,1602,0,'LSQ12ewh','LSQ',353.866041666667,-24.3461944444444,NULL,NULL,'2012-09-09 00:57:23',56179.0398599999,20.8972,0.1433,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2012-09-10 20:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_snap_56147.gif',50055645510,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,782119461,12220616,NULL,NULL,NULL,NULL),(1608,1602,0,'LSQ12ewh','LSQ',353.866041666667,-24.3461944444444,NULL,NULL,'2012-09-09 02:59:55',56179.1249500001,21.0194,0.1549,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2012-09-10 20:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_snap_56148.gif',50055645510,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,782119461,12220616,NULL,NULL,NULL,NULL),(1609,1609,1,'LSQ12ewa','LSQ',353.000416666667,-3.63072222222222,NULL,NULL,'2012-08-28 04:00:32',56167.1670400002,19.2036,0.1532,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewa/LSQ12ewa_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewa/LSQ12ewa_snap_56157.gif',49416648630,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772135134,12064611,NULL,NULL,NULL,NULL),(1610,1609,0,'LSQ12ewa','LSQ',353.000125,-3.63072222222222,NULL,NULL,'2012-08-30 03:54:17',56169.1627000002,19.1511,0.1981,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2012-09-10 20:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewa/LSQ12ewa_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewa/LSQ12ewa_snap_56158.gif',49416648630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772135134,12064611,NULL,NULL,NULL,NULL),(1611,1609,0,'LSQ12ewa','LSQ',353.000333333333,-3.63047222222222,NULL,NULL,'2012-09-05 03:26:34',56175.1434499999,19.3845,0.1537,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2012-09-10 20:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewa/LSQ12ewa_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewa/LSQ12ewa_snap_56159.gif',49416648630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772135134,12064611,NULL,NULL,NULL,NULL),(1612,1609,0,'LSQ12ewa','LSQ',353,-3.63075,NULL,NULL,'2012-09-09 01:12:57',56179.0506600002,19.0752,0.1142,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2012-09-10 20:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewa/LSQ12ewa_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewa/LSQ12ewa_snap_56131.gif',49416648630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772135134,12064611,NULL,NULL,NULL,NULL),(1613,1609,0,'LSQ12ewa','LSQ',353.000083333333,-3.63069444444444,NULL,NULL,'2012-09-09 03:15:35',56179.13583,19.1368,0.1036,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2012-09-10 20:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewa/LSQ12ewa_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewa/LSQ12ewa_snap_56132.gif',49416648630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772135134,12064611,NULL,NULL,NULL,NULL),(1614,1614,1,'LSQ12evz','LSQ',25.7012916666667,-29.8614722222222,NULL,NULL,'2012-09-09 05:14:02',56179.21808,21.505,0.1389,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evz/LSQ12evz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evz/LSQ12evz_snap_56129.gif',38265679391,NULL,NULL,NULL,'2012-09-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,597901240,9342206,NULL,NULL,NULL,NULL),(1615,1614,0,'LSQ12evz','LSQ',25.7015,-29.8613333333333,NULL,NULL,'2012-09-09 07:14:45',56179.3019099999,21.4629,0.1335,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2012-09-10 20:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evz/LSQ12evz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evz/LSQ12evz_snap_56130.gif',38265679391,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,597901240,9342206,NULL,NULL,NULL,NULL),(1616,1616,1,'LSQ12evy','LSQ',25.0972916666667,-29.7412222222222,NULL,NULL,'2012-09-09 05:14:02',56179.21808,22.2878,0.1616,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_history.html','sn?',NULL,0.242061,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_snap_56127.gif',38265285488,NULL,NULL,NULL,'2012-09-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597895085,9342110,NULL,NULL,NULL,NULL),(1617,1616,0,'LSQ12evy','LSQ',25.0970833333333,-29.74125,NULL,NULL,'2012-09-09 07:14:45',56179.3019099999,22.2821,0.1565,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2012-09-10 20:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_history.html','sn?',NULL,0.242061,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_snap_56128.gif',38265285488,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597895085,9342110,NULL,NULL,NULL,NULL),(1618,1618,1,'LSQ12evw','LSQ',28.8267916666667,-29.9607222222222,NULL,NULL,'2012-09-09 05:14:02',56179.21808,20.2576,0.1175,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_56123.gif',38262027470,NULL,NULL,NULL,'2012-09-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1619,1618,0,'LSQ12evw','LSQ',28.826625,-29.9608333333333,NULL,NULL,'2012-09-09 07:14:45',56179.3019099999,20.4204,0.1463,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2012-09-10 20:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_56124.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1620,1620,1,'LSQ12evv','LSQ',28.7776666666667,-27.6871111111111,NULL,NULL,'2012-09-09 03:11:37',56179.13307,19.8694,0.1205,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_snap_56156.gif',38401172066,NULL,NULL,NULL,'2012-09-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600018313,9375286,NULL,NULL,NULL,NULL),(1621,1620,0,'LSQ12evv','LSQ',28.7777083333333,-27.6870555555556,NULL,NULL,'2012-09-09 05:14:02',56179.21808,19.1619,0.1425,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2012-09-10 20:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_snap_56121.gif',38401172066,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600018313,9375286,NULL,NULL,NULL,NULL),(1622,1620,0,'LSQ12evv','LSQ',28.77775,-27.6871666666667,NULL,NULL,'2012-09-09 07:14:45',56179.3019099999,17.8316,0.0826,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-10 20:45:29','2012-09-10 20:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_snap_56122.gif',38401172067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600018313,9375286,NULL,NULL,NULL,NULL),(1623,811,0,'LSQ12ejy','LSQ',355.411333333333,-22.7781388888889,NULL,NULL,'2012-09-10 03:02:21',56180.1266399999,18.4584,0.102,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 01:45:31','2012-09-12 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_56229.gif',50274702770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(1624,811,0,'LSQ12ejy','LSQ',355.411208333333,-22.7781388888889,NULL,NULL,'2012-09-10 05:23:14',56180.2244699998,18.3844,0.0916,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 01:45:31','2012-09-12 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_56230.gif',50274702770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(1625,817,0,'LSQ12ejx','LSQ',355.03875,-21.8748333333333,NULL,NULL,'2012-09-10 05:23:14',56180.2244699998,21.1731,0.176,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 01:45:31','2012-09-12 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_snap_56231.gif',50276293318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,785567083,12274485,NULL,NULL,NULL,NULL),(1626,1185,0,'LSQ12eom','LSQ',28.2500416666667,-18.1508888888889,NULL,NULL,'2012-09-10 04:11:53',56180.1749200001,20.2664,0.0837,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 01:45:31','2012-09-12 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eom/LSQ12eom_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eom/LSQ12eom_snap_56269.gif',35086441365,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548225646,8566025,NULL,NULL,NULL,NULL),(1627,1185,0,'LSQ12eom','LSQ',28.2500416666667,-18.1509166666667,NULL,NULL,'2012-09-10 06:46:10',56180.2820700002,20.5726,0.097,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 01:45:31','2012-09-12 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eom/LSQ12eom_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eom/LSQ12eom_snap_56270.gif',35086441365,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548225646,8566025,NULL,NULL,NULL,NULL),(1628,1185,0,'LSQ12eom','LSQ',28.25,-18.1509444444444,NULL,NULL,'2012-09-10 08:46:58',56180.3659600001,20.6035,0.1103,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 01:45:31','2012-09-12 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eom/LSQ12eom_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eom/LSQ12eom_snap_56271.gif',35086441365,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548225646,8566025,NULL,NULL,NULL,NULL),(1629,1602,0,'LSQ12ewh','LSQ',353.866166666667,-24.3461111111111,NULL,NULL,'2012-09-10 00:58:50',56180.0408600001,21.2023,0.186,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 01:45:31','2012-09-12 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_snap_56238.gif',50055645961,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,782119468,12220616,NULL,NULL,NULL,NULL),(1630,1602,0,'LSQ12ewh','LSQ',353.866041666667,-24.3461388888889,NULL,NULL,'2012-09-10 03:02:21',56180.1266399999,21.3327,0.1287,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 01:45:31','2012-09-12 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_snap_56239.gif',50055645510,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,782119461,12220616,NULL,NULL,NULL,NULL),(1631,1602,0,'LSQ12ewh','LSQ',353.866083333333,-24.3461388888889,NULL,NULL,'2012-09-10 05:23:14',56180.2244699998,20.8947,0.1259,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 01:45:31','2012-09-12 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewh/LSQ12ewh_snap_56240.gif',50055645510,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,782119461,12220616,NULL,NULL,NULL,NULL),(1632,1609,0,'LSQ12ewa','LSQ',353.00025,-3.63058333333333,NULL,NULL,'2012-09-10 03:06:04',56180.12922,19.2179,0.1179,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 01:45:31','2012-09-12 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewa/LSQ12ewa_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewa/LSQ12ewa_snap_56246.gif',49416648630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772135134,12064611,NULL,NULL,NULL,NULL),(1633,1614,0,'LSQ12evz','LSQ',25.7019166666667,-29.8614444444444,NULL,NULL,'2012-09-10 03:50:04',56180.1597799999,21.4401,0.1283,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 01:45:31','2012-09-12 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evz/LSQ12evz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evz/LSQ12evz_snap_56258.gif',38265679391,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,597901240,9342206,NULL,NULL,NULL,NULL),(1634,1616,0,'LSQ12evy','LSQ',25.0973333333333,-29.7411111111111,NULL,NULL,'2012-09-10 06:08:34',56180.2559500001,21.9823,0.1055,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 01:45:31','2012-09-12 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_history.html','sn?',NULL,0.242061,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_snap_56241.gif',38265285480,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597895085,9342110,NULL,NULL,NULL,NULL),(1635,1618,0,'LSQ12evw','LSQ',28.8266666666667,-29.9609166666667,NULL,NULL,'2012-09-10 03:50:04',56180.1597799999,20.1229,0.1279,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 01:45:31','2012-09-12 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_56244.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1636,1620,0,'LSQ12evv','LSQ',28.7777916666667,-27.6871666666667,NULL,NULL,'2012-09-10 03:50:04',56180.1597799999,19.9118,0.1833,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 01:45:31','2012-09-12 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_snap_56245.gif',38401172067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600018313,9375286,NULL,NULL,NULL,NULL),(1637,811,0,'LSQ12ejy','LSQ',355.411166666667,-22.7781388888889,NULL,NULL,'2012-09-11 00:52:31',56181.0364799998,19.0841,0.1378,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 14:45:30','2012-09-12 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_56327.gif',50274702770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(1638,811,0,'LSQ12ejy','LSQ',355.411125,-22.7780277777778,NULL,NULL,'2012-09-11 02:51:57',56181.1194199999,18.5558,0.098,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 14:45:30','2012-09-12 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_56328.gif',50274702770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(1639,811,0,'LSQ12ejy','LSQ',355.411541666667,-22.7781111111111,NULL,NULL,'2012-09-11 04:55:06',56181.2049400001,18.7264,0.1219,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 14:45:30','2012-09-12 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_56329.gif',50274702741,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(1640,1557,0,'LSQ12evn','LSQ',311.89275,-17.158,NULL,NULL,'2012-09-11 00:01:37',56181.0011300002,18.4682,0.0613,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 14:45:30','2012-09-12 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_56336.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1641,1568,0,'LSQ12evl','LSQ',309.547208333333,-20.9068611111111,NULL,NULL,'2012-09-11 00:01:37',56181.0011300002,20.0354,0.1142,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 14:45:30','2012-09-12 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_snap_56333.gif',50824114763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,794126793,12408231,NULL,NULL,NULL,NULL),(1642,1570,0,'LSQ12evo','LSQ',317.5235,-25.5899166666667,NULL,NULL,'2012-09-11 00:29:07',56181.0202199998,19.5322,0.1425,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 14:45:30','2012-09-12 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_snap_56334.gif',51425622868,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,803525357,12555083,NULL,NULL,NULL,NULL),(1643,1616,0,'LSQ12evy','LSQ',25.097375,-29.7413055555556,NULL,NULL,'2012-09-11 03:47:14',56181.1578099998,22.7267,0.16,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 14:45:30','2012-09-12 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_history.html','sn?',NULL,0.242061,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_snap_56347.gif',38265285488,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597895085,9342110,NULL,NULL,NULL,NULL),(1644,1618,0,'LSQ12evw','LSQ',28.8265416666667,-29.9608333333333,NULL,NULL,'2012-09-11 03:47:14',56181.1578099998,20.0191,0.1034,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 14:45:30','2012-09-12 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_56345.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1645,1618,0,'LSQ12evw','LSQ',28.8265416666667,-29.9608611111111,NULL,NULL,'2012-09-11 06:03:33',56181.2524700002,20.0995,0.1017,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-12 14:45:30','2012-09-12 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_56346.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1646,1646,1,'LSQ12ewu','LSQ',317.788875,-6.94127777777778,NULL,NULL,'2012-09-09 23:41:40',56179.98728,19.2513,0.1009,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 01:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewu/LSQ12ewu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewu/LSQ12ewu_snap_56431.gif',50789486443,NULL,NULL,NULL,'2012-09-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'BS',NULL,0,NULL,0,793585725,12399776,NULL,NULL,NULL,NULL),(1647,1646,0,'LSQ12ewu','LSQ',317.788791666667,-6.94125,NULL,NULL,'2012-09-10 01:44:53',56180.07284,19.7413,0.1023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 01:45:31','2012-09-13 01:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewu/LSQ12ewu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewu/LSQ12ewu_snap_56432.gif',50789486443,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'BS',NULL,0,NULL,0,793585725,12399776,NULL,NULL,NULL,NULL),(1648,811,0,'LSQ12ejy','LSQ',355.411125,-22.7780833333333,NULL,NULL,'2012-09-12 02:46:35',56182.1156899999,18.3885,0.0984,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_56630.gif',50274702770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(1649,811,0,'LSQ12ejy','LSQ',355.411,-22.7781111111111,NULL,NULL,'2012-09-12 04:47:46',56182.1998399999,19.0365,0.1173,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_56631.gif',50274702771,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(1650,817,0,'LSQ12ejx','LSQ',355.038708333333,-21.8748611111111,NULL,NULL,'2012-09-12 02:46:35',56182.1156899999,21.6771,0.1933,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_snap_56626.gif',50276293318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,785567083,12274485,NULL,NULL,NULL,NULL),(1651,823,0,'LSQ12ejw','LSQ',357.601083333333,-24.6791944444444,NULL,NULL,'2012-09-12 00:47:01',56182.03266,19.6961,0.1207,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_snap_56643.gif',50012665062,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,781447891,12210123,NULL,NULL,NULL,NULL),(1652,823,0,'LSQ12ejw','LSQ',357.600875,-24.6791666666667,NULL,NULL,'2012-09-12 04:47:46',56182.1998399999,19.4731,0.149,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_snap_56644.gif',50012664937,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,781447889,12210123,NULL,NULL,NULL,NULL),(1653,915,0,'LSQ12elk','LSQ',31.3317916666667,-5.97233333333333,NULL,NULL,'2012-09-12 07:06:34',56182.29623,19.981,0.1444,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_snap_56659.gif',35137599396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,549024990,8578515,NULL,NULL,NULL,NULL),(1654,915,0,'LSQ12elk','LSQ',31.33175,-5.97230555555556,NULL,NULL,'2012-09-12 08:28:27',56182.3530999999,20.0788,0.1532,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_snap_56660.gif',35137599396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,549024990,8578515,NULL,NULL,NULL,NULL),(1655,1020,0,'LSQ12elo','LSQ',318.356708333333,-6.59952777777778,NULL,NULL,'2012-09-12 02:18:05',56182.0959000001,20.8569,0.1807,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elo/LSQ12elo_history.html','sne?',NULL,0.12145,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elo/LSQ12elo_snap_56689.gif',50789822544,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793590977,12399859,NULL,NULL,NULL,NULL),(1656,1026,0,'LSQ12elz','LSQ',329.397541666667,-0.839222222222222,NULL,NULL,'2012-09-12 00:21:47',56182.0151300002,20.4417,0.1242,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_history.html','sne?',NULL,0.21853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_snap_56744.gif',49826069800,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778532340,12164567,NULL,NULL,NULL,NULL),(1657,1289,0,'LSQ12erc','LSQ',8.77129166666667,1.48133333333333,NULL,NULL,'2012-09-12 09:08:34',56182.3809500001,18.1139,0.0478,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_snap_56765.gif',66590313565,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1040473649,16257400,NULL,NULL,NULL,NULL),(1658,1451,0,'LSQ12euu','LSQ',322.784166666667,-6.70405555555556,NULL,NULL,'2012-09-12 00:16:36',56182.0115299998,19.1328,0.083,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_snap_56585.gif',49683505265,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776304769,12129762,NULL,NULL,NULL,NULL),(1659,1451,0,'LSQ12euu','LSQ',322.784125,-6.70402777777778,NULL,NULL,'2012-09-12 02:52:16',56182.1196300001,19.4809,0.0872,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_snap_56586.gif',49683505265,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776304769,12129762,NULL,NULL,NULL,NULL),(1660,1458,0,'LSQ12eui','LSQ',51.856875,-11.5908888888889,NULL,NULL,'2012-09-12 06:27:54',56182.26938,19.6897,0.1587,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_snap_56645.gif',37886492397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591976443,9249631,NULL,NULL,NULL,NULL),(1661,1458,0,'LSQ12eui','LSQ',51.8568333333333,-11.5907777777778,NULL,NULL,'2012-09-12 08:10:34',56182.3406799999,19.8122,0.1489,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_snap_56646.gif',37886492397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591976443,9249631,NULL,NULL,NULL,NULL),(1662,1616,0,'LSQ12evy','LSQ',25.0973333333333,-29.7412777777778,NULL,NULL,'2012-09-12 02:58:28',56182.1239399998,22.4184,0.16,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_history.html','sn?',NULL,0.242061,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_snap_56678.gif',38265285488,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597895085,9342110,NULL,NULL,NULL,NULL),(1663,1616,0,'LSQ12evy','LSQ',25.09725,-29.7411666666667,NULL,NULL,'2012-09-12 07:01:05',56182.2924299999,22.3386,0.1444,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_history.html','sn?',NULL,0.242061,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_snap_56679.gif',38265285488,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597895085,9342110,NULL,NULL,NULL,NULL),(1664,1618,0,'LSQ12evw','LSQ',28.8264583333333,-29.96075,NULL,NULL,'2012-09-12 02:58:28',56182.1239399998,20.0436,0.103,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_56661.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1665,1618,0,'LSQ12evw','LSQ',28.8265833333333,-29.9608333333333,NULL,NULL,'2012-09-12 04:59:13',56182.2078,20.2989,0.1159,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_56662.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1666,1618,0,'LSQ12evw','LSQ',28.826375,-29.9608611111111,NULL,NULL,'2012-09-12 07:01:05',56182.2924299999,20.1173,0.0867,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_56663.gif',38262027462,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1667,1620,0,'LSQ12evv','LSQ',28.7778333333333,-27.68725,NULL,NULL,'2012-09-12 02:58:28',56182.1239399998,20.1932,0.2154,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_snap_56667.gif',38401172067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600018313,9375286,NULL,NULL,NULL,NULL),(1668,1620,0,'LSQ12evv','LSQ',28.7779166666667,-27.6872777777778,NULL,NULL,'2012-09-12 04:59:13',56182.2078,18.5187,0.118,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-13 22:45:29','2012-09-13 22:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_snap_56668.gif',38401172067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600018313,9375286,NULL,NULL,NULL,NULL),(1669,1669,0,'PSNJ02452841-6207214','TOCP',41.36838,-62.12261,NULL,NULL,'2012-07-17 00:00:00',56125,17.7,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-09-13 19:05:07','2020-01-13 20:37:59','http://www.cbat.eps.harvard.edu/unconf/followups/J02452841-6207214.html','supernova',NULL,0,NULL,NULL,'NULL',NULL,NULL,36260997780,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,566578090,8852782,NULL,NULL,NULL,NULL),(1670,1670,1,'LSQ12exp','LSQ',354.286416666667,-24.1555555555556,NULL,NULL,'2012-09-09 00:57:23',56179.0398599999,19.6143,0.0828,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 17:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_57021.gif',50055472816,NULL,NULL,NULL,'2012-09-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1671,1670,0,'LSQ12exp','LSQ',354.286291666667,-24.1555,NULL,NULL,'2012-09-10 03:02:21',56180.1266399999,19.2735,0.0617,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 17:45:30','2012-09-14 17:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_57022.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1672,1670,0,'LSQ12exp','LSQ',354.286333333333,-24.1554166666667,NULL,NULL,'2012-09-10 05:23:14',56180.2244699998,19.6348,0.0705,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 17:45:30','2012-09-14 17:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_57023.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1673,1670,0,'LSQ12exp','LSQ',354.286458333333,-24.1556111111111,NULL,NULL,'2012-09-11 00:52:31',56181.0364799998,19.2115,0.0671,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 17:45:30','2012-09-14 17:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_57024.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1674,1670,0,'LSQ12exp','LSQ',354.28625,-24.1554722222222,NULL,NULL,'2012-09-11 02:51:57',56181.1194199999,19.7755,0.0636,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 17:45:30','2012-09-14 17:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_57025.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1675,1670,0,'LSQ12exp','LSQ',354.286375,-24.1554444444444,NULL,NULL,'2012-09-11 04:55:06',56181.2049400001,19.7879,0.0733,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 17:45:30','2012-09-14 17:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_57026.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1676,1670,0,'LSQ12exp','LSQ',354.286375,-24.1554722222222,NULL,NULL,'2012-09-12 00:47:01',56182.03266,19.7836,0.0757,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 17:45:30','2012-09-14 17:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_56975.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1677,1670,0,'LSQ12exp','LSQ',354.286416666667,-24.1554444444444,NULL,NULL,'2012-09-12 02:46:35',56182.1156899999,19.9345,0.0622,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 17:45:30','2012-09-14 17:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_56977.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1678,1670,0,'LSQ12exp','LSQ',354.286416666667,-24.1554722222222,NULL,NULL,'2012-09-12 04:47:46',56182.1998399999,19.8039,0.0613,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 17:45:30','2012-09-14 17:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_56976.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1679,1679,1,'LSQ12exl','LSQ',356.054625,-24.201,NULL,NULL,'2012-09-09 02:59:55',56179.1249500001,20.8592,0.1938,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 17:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_57005.gif',50003648244,NULL,NULL,NULL,'2012-09-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1680,1679,0,'LSQ12exl','LSQ',356.054541666667,-24.2010555555556,NULL,NULL,'2012-09-09 05:02:23',56179.2099899999,21.4001,0.1509,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 17:45:30','2012-09-14 17:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_57006.gif',50003648247,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1681,1679,0,'LSQ12exl','LSQ',356.054458333333,-24.2011388888889,NULL,NULL,'2012-09-10 00:58:50',56180.0408600001,20.3523,0.1561,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 17:45:30','2012-09-14 17:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_57007.gif',50003648247,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1682,1679,0,'LSQ12exl','LSQ',356.054291666667,-24.2009722222222,NULL,NULL,'2012-09-11 00:52:31',56181.0364799998,20.1918,0.1302,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 17:45:30','2012-09-14 17:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_57008.gif',50003648244,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1683,1679,0,'LSQ12exl','LSQ',356.054375,-24.201,NULL,NULL,'2012-09-11 02:51:57',56181.1194199999,20.5268,0.0999,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 17:45:30','2012-09-14 17:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_57009.gif',50003648244,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1684,1679,0,'LSQ12exl','LSQ',356.054375,-24.201,NULL,NULL,'2012-09-12 00:47:01',56182.03266,19.8493,0.112,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 17:45:30','2012-09-14 17:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_57010.gif',50003648244,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1685,1679,0,'LSQ12exl','LSQ',356.054291666667,-24.2008888888889,NULL,NULL,'2012-09-12 02:46:35',56182.1156899999,20.4816,0.0774,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 17:45:30','2012-09-14 17:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_56967.gif',50003648244,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1686,1679,0,'LSQ12exl','LSQ',356.054375,-24.2009722222222,NULL,NULL,'2012-09-12 04:47:46',56182.1998399999,20.7048,0.108,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 17:45:30','2012-09-14 17:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_56968.gif',50003648244,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1687,811,0,'LSQ12ejy','LSQ',355.411208333333,-22.7781388888889,NULL,NULL,'2012-09-13 00:48:47',56183.03388,19.2158,0.1288,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_57151.gif',50274702770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(1688,811,0,'LSQ12ejy','LSQ',355.411333333333,-22.7781111111111,NULL,NULL,'2012-09-13 02:50:13',56183.11821,19.2751,0.1365,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_57152.gif',50274702770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(1689,811,0,'LSQ12ejy','LSQ',355.411125,-22.7781111111111,NULL,NULL,'2012-09-13 04:50:55',56183.2020299998,18.7218,0.095,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_57153.gif',50274702770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(1690,817,0,'LSQ12ejx','LSQ',355.038583333333,-21.8748333333333,NULL,NULL,'2012-09-13 00:48:47',56183.03388,21.3566,0.2053,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_snap_57156.gif',50276293318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,785567083,12274485,NULL,NULL,NULL,NULL),(1691,817,0,'LSQ12ejx','LSQ',355.038541666667,-21.8748333333333,NULL,NULL,'2012-09-13 04:50:55',56183.2020299998,21.5041,0.1764,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_snap_57157.gif',50276293318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,785567083,12274485,NULL,NULL,NULL,NULL),(1692,823,0,'LSQ12ejw','LSQ',357.601166666667,-24.6794722222222,NULL,NULL,'2012-09-13 04:50:55',56183.2020299998,19.5998,0.0903,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_snap_57158.gif',50012665062,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,781447891,12210123,NULL,NULL,NULL,NULL),(1693,1205,0,'LSQ12eoc','LSQ',317.283541666667,-22.2569722222222,NULL,NULL,'2012-09-13 01:58:35',56183.0823599999,19.9808,0.1442,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_snap_57230.gif',50904231018,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,795378609,12427790,NULL,NULL,NULL,NULL),(1694,1557,0,'LSQ12evn','LSQ',311.892666666667,-17.1578611111111,NULL,NULL,'2012-09-13 03:37:49',56183.1512699998,18.6523,0.0526,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_57161.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1695,1568,0,'LSQ12evl','LSQ',309.547333333333,-20.9068333333333,NULL,NULL,'2012-09-13 01:21:21',56183.0564999999,20.268,0.128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_snap_57163.gif',50824114763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,794126793,12408231,NULL,NULL,NULL,NULL),(1696,1568,0,'LSQ12evl','LSQ',309.54725,-20.9068888888889,NULL,NULL,'2012-09-13 03:37:49',56183.1512699998,20.2802,0.1226,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_snap_57164.gif',50824114763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,794126793,12408231,NULL,NULL,NULL,NULL),(1697,1570,0,'LSQ12evo','LSQ',317.523458333333,-25.5899722222222,NULL,NULL,'2012-09-13 01:56:54',56183.0811899998,19.5649,0.1367,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_snap_57162.gif',51425622868,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,803525357,12555083,NULL,NULL,NULL,NULL),(1698,1616,0,'LSQ12evy','LSQ',25.0973333333333,-29.7413333333333,NULL,NULL,'2012-09-13 02:54:11',56183.12097,22.7659,0.2098,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_history.html','sn?',NULL,0.242061,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_snap_57177.gif',38265285488,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597895085,9342110,NULL,NULL,NULL,NULL),(1699,1616,0,'LSQ12evy','LSQ',25.0971666666667,-29.7411944444444,NULL,NULL,'2012-09-13 06:55:30',56183.2885500002,22.3304,0.1466,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_history.html','sn?',NULL,0.242061,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_snap_57178.gif',38265285488,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597895085,9342110,NULL,NULL,NULL,NULL),(1700,1618,0,'LSQ12evw','LSQ',28.8265416666667,-29.9609444444444,NULL,NULL,'2012-09-13 02:54:11',56183.12097,20.2713,0.1194,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_57168.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1701,1618,0,'LSQ12evw','LSQ',28.8265416666667,-29.9609444444444,NULL,NULL,'2012-09-13 04:54:53',56183.2047899999,20.2327,0.1116,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_57169.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1702,1618,0,'LSQ12evw','LSQ',28.8265833333333,-29.9609166666667,NULL,NULL,'2012-09-13 06:55:30',56183.2885500002,20.5275,0.1258,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_57170.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1703,1670,0,'LSQ12exp','LSQ',354.286416666667,-24.1555555555556,NULL,NULL,'2012-09-13 00:48:47',56183.03388,19.464,0.0685,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_57231.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1704,1670,0,'LSQ12exp','LSQ',354.286458333333,-24.1554722222222,NULL,NULL,'2012-09-13 02:50:13',56183.11821,19.8106,0.0644,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_57232.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1705,1670,0,'LSQ12exp','LSQ',354.286291666667,-24.1553888888889,NULL,NULL,'2012-09-13 04:50:55',56183.2020299998,19.8525,0.0621,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_57233.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1706,1679,0,'LSQ12exl','LSQ',356.054291666667,-24.2009444444444,NULL,NULL,'2012-09-13 00:48:47',56183.03388,20.4031,0.1136,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_57247.gif',50003648244,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1707,1679,0,'LSQ12exl','LSQ',356.054625,-24.2010555555556,NULL,NULL,'2012-09-13 02:50:13',56183.11821,20.8673,0.1187,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_57248.gif',50003648247,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1708,1679,0,'LSQ12exl','LSQ',356.054375,-24.201,NULL,NULL,'2012-09-13 04:50:55',56183.2020299998,20.7051,0.0949,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 19:45:31','2012-09-14 19:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_57249.gif',50003648244,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1709,1709,1,'LSQ12ezm','LSQ',334.361625,-1.87375,NULL,NULL,'2012-09-02 00:47:04',56172.0326899998,18.3823,0.2102,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezm/LSQ12ezm_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezm/LSQ12ezm_snap_57413.gif',49800495953,NULL,NULL,NULL,'2012-08-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,778132749,12158324,NULL,NULL,NULL,NULL),(1710,1709,0,'LSQ12ezm','LSQ',334.361416666667,-1.87375,NULL,NULL,'2012-09-02 02:47:00',56172.1159799998,18.7045,0.1666,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezm/LSQ12ezm_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezm/LSQ12ezm_snap_57414.gif',49800495953,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,778132749,12158324,NULL,NULL,NULL,NULL),(1711,1709,0,'LSQ12ezm','LSQ',334.361625,-1.87375,NULL,NULL,'2012-09-12 01:34:22',56182.0655399999,18.7653,0.0509,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezm/LSQ12ezm_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezm/LSQ12ezm_snap_57395.gif',49800495953,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,778132749,12158324,NULL,NULL,NULL,NULL),(1712,1709,0,'LSQ12ezm','LSQ',334.361666666667,-1.87375,NULL,NULL,'2012-09-12 04:51:35',56182.2024900001,18.7179,0.0481,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezm/LSQ12ezm_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezm/LSQ12ezm_snap_57396.gif',49800495953,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,778132749,12158324,NULL,NULL,NULL,NULL),(1713,1713,1,'LSQ12ezk','LSQ',11.2832083333333,0.354638888888889,NULL,NULL,'2012-08-28 09:05:56',56167.3791299998,20.2206,0.1953,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezk/LSQ12ezk_history.html','sn??',NULL,0.06548,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezk/LSQ12ezk_snap_57411.gif',66672869557,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041763586,16277556,NULL,NULL,NULL,NULL),(1714,1713,0,'LSQ12ezk','LSQ',11.2832916666667,0.354555555555556,NULL,NULL,'2012-09-12 05:42:23',56182.23777,19.2111,0.0608,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezk/LSQ12ezk_history.html','sn??',NULL,0.06548,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezk/LSQ12ezk_snap_57391.gif',66672869557,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041763586,16277556,NULL,NULL,NULL,NULL),(1715,1713,0,'LSQ12ezk','LSQ',11.2832083333333,0.35475,NULL,NULL,'2012-09-12 07:41:45',56182.3206600002,20.1793,0.1145,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezk/LSQ12ezk_history.html','sn??',NULL,0.06548,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezk/LSQ12ezk_snap_57392.gif',66672869557,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041763586,16277556,NULL,NULL,NULL,NULL),(1716,1716,1,'LSQ12ezi','LSQ',7.598375,-0.209361111111111,NULL,NULL,'2012-09-12 09:06:52',56182.3797800001,19.726,0.1489,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezi/LSQ12ezi_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezi/LSQ12ezi_snap_57387.gif',34400562260,NULL,NULL,NULL,'2012-09-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537508785,8398574,NULL,NULL,NULL,NULL),(1717,1716,0,'LSQ12ezi','LSQ',7.59820833333333,-0.209527777777778,NULL,NULL,'2012-09-12 09:23:36',56182.39139,19.4599,0.1461,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezi/LSQ12ezi_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezi/LSQ12ezi_snap_57388.gif',34400562260,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537508785,8398574,NULL,NULL,NULL,NULL),(1718,1718,1,'LSQ12eyo','LSQ',43.8213333333333,-7.89752777777778,NULL,NULL,'2012-09-12 06:21:06',56182.2646599999,19.5083,0.1629,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eyo/LSQ12eyo_history.html','sn?',NULL,0.03116,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eyo/LSQ12eyo_snap_57329.gif',37913944767,NULL,NULL,NULL,'2012-09-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592405386,9256334,NULL,NULL,NULL,NULL),(1719,1718,0,'LSQ12eyo','LSQ',43.8209583333333,-7.89738888888889,NULL,NULL,'2012-09-12 08:07:09',56182.33831,19.5292,0.1243,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eyo/LSQ12eyo_history.html','sn?',NULL,0.03116,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eyo/LSQ12eyo_snap_57330.gif',37913944767,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592405386,9256334,NULL,NULL,NULL,NULL),(1720,1720,1,'LSQ12ezu','LSQ',355.0765,-21.1558888888889,NULL,NULL,'2012-08-27 07:25:19',56166.3092499999,19.8111,0.2153,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_snap_57457.gif',50277624863,NULL,NULL,NULL,'2012-08-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785587888,12274810,NULL,NULL,NULL,NULL),(1721,1720,0,'LSQ12ezu','LSQ',355.076625,-21.1560555555556,NULL,NULL,'2012-09-03 05:33:19',56173.2314800001,18.672,0.2121,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_snap_57458.gif',50277624862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785587888,12274810,NULL,NULL,NULL,NULL),(1722,1720,0,'LSQ12ezu','LSQ',355.076625,-21.1560277777778,NULL,NULL,'2012-09-05 07:15:16',56175.3022699999,18.4493,0.1874,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_snap_57459.gif',50277624862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785587888,12274810,NULL,NULL,NULL,NULL),(1723,1720,0,'LSQ12ezu','LSQ',355.076708333333,-21.1559444444444,NULL,NULL,'2012-09-13 09:03:28',56183.3774100002,18.334,0.0835,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_snap_57429.gif',50277624863,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785587888,12274810,NULL,NULL,NULL,NULL),(1724,1720,0,'LSQ12ezu','LSQ',355.076625,-21.1560277777778,NULL,NULL,'2012-09-13 09:08:32',56183.38093,18.6154,0.0955,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_snap_57430.gif',50277624862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785587888,12274810,NULL,NULL,NULL,NULL),(1725,1725,1,'LSQ12ezs','LSQ',310.557625,-21.6615833333333,NULL,NULL,'2012-09-05 00:10:50',56175.0075300001,19.1517,0.0723,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_snap_57451.gif',50825557719,NULL,NULL,NULL,'2012-08-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794149339,12408583,NULL,NULL,NULL,NULL),(1726,1725,0,'LSQ12ezs','LSQ',310.557791666667,-21.6615555555556,NULL,NULL,'2012-09-05 02:20:11',56175.09736,19.155,0.0911,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_snap_57452.gif',50825557717,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794149339,12408583,NULL,NULL,NULL,NULL),(1727,1725,0,'LSQ12ezs','LSQ',310.557708333333,-21.6615555555556,NULL,NULL,'2012-09-09 00:12:46',56179.00887,18.9922,0.0545,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_snap_57453.gif',50825557717,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794149339,12408583,NULL,NULL,NULL,NULL),(1728,1725,0,'LSQ12ezs','LSQ',310.557708333333,-21.6615277777778,NULL,NULL,'2012-09-11 00:13:43',56181.0095299999,18.9938,0.06,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_snap_57454.gif',50825557717,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794149339,12408583,NULL,NULL,NULL,NULL),(1729,1725,0,'LSQ12ezs','LSQ',310.557666666667,-21.6615555555556,NULL,NULL,'2012-09-13 01:33:25',56183.06488,19.0037,0.0572,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_snap_57425.gif',50825557717,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794149339,12408583,NULL,NULL,NULL,NULL),(1730,1725,0,'LSQ12ezs','LSQ',310.557666666667,-21.6615555555556,NULL,NULL,'2012-09-13 03:49:52',56183.1596300001,19.2097,0.0558,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_snap_57426.gif',50825557717,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794149339,12408583,NULL,NULL,NULL,NULL),(1731,1731,1,'LSQ12ezr','LSQ',311.786416666667,-21.5498611111111,NULL,NULL,'2012-08-15 00:41:02',56154.0285,20.4077,0.1628,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezr/LSQ12ezr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezr/LSQ12ezr_snap_57449.gif',50825432373,NULL,NULL,NULL,'2012-08-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794147380,12408552,NULL,NULL,NULL,NULL),(1732,1731,0,'LSQ12ezr','LSQ',311.786375,-21.5498333333333,NULL,NULL,'2012-08-19 00:24:06',56158.0167399999,20.9179,0.1975,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezr/LSQ12ezr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezr/LSQ12ezr_snap_57450.gif',50825432373,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794147380,12408552,NULL,NULL,NULL,NULL),(1733,1731,0,'LSQ12ezr','LSQ',311.786458333333,-21.5498055555556,NULL,NULL,'2012-09-13 01:33:25',56183.06488,19.5185,0.0903,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezr/LSQ12ezr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezr/LSQ12ezr_snap_57423.gif',50825432373,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794147380,12408552,NULL,NULL,NULL,NULL),(1734,1731,0,'LSQ12ezr','LSQ',311.786291666667,-21.5499722222222,NULL,NULL,'2012-09-13 03:49:52',56183.1596300001,19.0045,0.107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezr/LSQ12ezr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezr/LSQ12ezr_snap_57424.gif',50825432373,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794147380,12408552,NULL,NULL,NULL,NULL),(1735,1735,1,'LSQ12ezn','LSQ',54.439875,-37.26575,NULL,NULL,'2012-09-13 06:18:35',56183.26291,19.6147,0.0743,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_57415.gif',38556577295,NULL,NULL,NULL,'2012-09-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(1736,1735,0,'LSQ12ezn','LSQ',54.4399166666667,-37.26575,NULL,NULL,'2012-09-13 08:10:50',56183.3408599999,19.6046,0.0686,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-14 21:45:32','2012-09-14 21:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_57416.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(1737,788,0,'LSQ12ejo','LSQ',353.492125,-3.31552777777778,NULL,NULL,'2012-09-14 04:12:49',56184.17557,20.6825,0.1412,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_snap_57620.gif',49414528108,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772102001,12064093,NULL,NULL,NULL,NULL),(1738,788,0,'LSQ12ejo','LSQ',353.492083333333,-3.31561111111111,NULL,NULL,'2012-09-14 06:14:11',56184.2598600001,20.6159,0.161,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejo/LSQ12ejo_snap_57621.gif',49414528108,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,772102001,12064093,NULL,NULL,NULL,NULL),(1739,811,0,'LSQ12ejy','LSQ',355.411208333333,-22.7780833333333,NULL,NULL,'2012-09-14 02:32:58',56184.10623,18.9276,0.0982,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_57625.gif',50274702770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(1740,811,0,'LSQ12ejy','LSQ',355.411208333333,-22.7780555555556,NULL,NULL,'2012-09-14 04:34:44',56184.1907899999,18.4885,0.0936,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_57626.gif',50274702770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(1741,811,0,'LSQ12ejy','LSQ',355.411166666667,-22.7781666666667,NULL,NULL,'2012-09-14 06:34:25',56184.27391,19.2033,0.1012,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_57627.gif',50274702770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(1742,817,0,'LSQ12ejx','LSQ',355.0385,-21.8748333333333,NULL,NULL,'2012-09-14 02:32:58',56184.10623,22.0444,0.1835,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_snap_57634.gif',50276293318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,785567083,12274485,NULL,NULL,NULL,NULL),(1743,817,0,'LSQ12ejx','LSQ',355.038583333333,-21.8748055555556,NULL,NULL,'2012-09-14 04:34:44',56184.1907899999,21.538,0.1844,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_snap_57635.gif',50276293318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,785567083,12274485,NULL,NULL,NULL,NULL),(1744,823,0,'LSQ12ejw','LSQ',357.600958333333,-24.6792777777778,NULL,NULL,'2012-09-14 06:34:25',56184.27391,20.0672,0.1023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_snap_57636.gif',50012664937,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,781447889,12210123,NULL,NULL,NULL,NULL),(1745,826,0,'LSQ12eju','LSQ',350.748833333333,-7.43319444444445,NULL,NULL,'2012-09-14 04:12:49',56184.17557,20.0881,0.1618,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_57623.gif',49649863586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(1746,826,0,'LSQ12eju','LSQ',350.748875,-7.43319444444445,NULL,NULL,'2012-09-14 06:14:11',56184.2598600001,19.7069,0.1542,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eju/LSQ12eju_snap_57624.gif',49649863586,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,775779118,12121548,NULL,NULL,NULL,NULL),(1747,858,0,'LSQ12eks','LSQ',345.267458333333,-6.69513888888889,NULL,NULL,'2012-09-14 05:46:34',56184.2406799998,20.4662,0.1363,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eks/LSQ12eks_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eks/LSQ12eks_snap_57640.gif',49487173961,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773237093,12081829,NULL,NULL,NULL,NULL),(1748,861,0,'LSQ12ekr','LSQ',344.3795,-6.24525,NULL,NULL,'2012-09-14 03:43:29',56184.1551999999,20.901,0.1666,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2019-08-21 00:25:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_history.html','agn or old?',NULL,0.090066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_snap_57641.gif',49488043314,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,773250676,12082041,NULL,NULL,NULL,NULL),(1749,861,0,'LSQ12ekr','LSQ',344.379333333333,-6.24522222222222,NULL,NULL,'2012-09-14 05:44:53',56184.2395100002,20.7863,0.1521,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2019-08-21 00:25:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_history.html','agn or old?',NULL,0.090066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ekr/LSQ12ekr_snap_57642.gif',49488043314,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,773250676,12082041,NULL,NULL,NULL,NULL),(1750,915,0,'LSQ12elk','LSQ',31.3318333333333,-5.97238888888889,NULL,NULL,'2012-09-14 08:28:47',56184.3533299998,20.3843,0.1091,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_snap_57676.gif',35137599396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,549024990,8578515,NULL,NULL,NULL,NULL),(1751,915,0,'LSQ12elk','LSQ',31.331875,-5.97236111111111,NULL,NULL,'2012-09-14 09:08:49',56184.3811300001,20.7346,0.128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elk/LSQ12elk_snap_57677.gif',35137599396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,549024990,8578515,NULL,NULL,NULL,NULL),(1752,954,0,'LSQ12ela','LSQ',353.607291666667,-3.68669444444444,NULL,NULL,'2012-09-14 06:14:11',56184.2598600001,20.5574,0.1286,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ela/LSQ12ela_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ela/LSQ12ela_snap_57670.gif',49417146764,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,772142918,12064733,NULL,NULL,NULL,NULL),(1753,1310,0,'LSQ12eqs','LSQ',346.333333333333,3.24355555555556,NULL,NULL,'2012-09-14 05:29:03',56184.2285099998,19.2167,0.0504,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqs/LSQ12eqs_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqs/LSQ12eqs_snap_57769.gif',51696025755,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,807750402,12621100,NULL,NULL,NULL,NULL),(1754,1458,0,'LSQ12eui','LSQ',51.85675,-11.5909444444444,NULL,NULL,'2012-09-14 07:57:33',56184.33164,19.6993,0.1427,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_snap_57646.gif',37886492397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591976443,9249631,NULL,NULL,NULL,NULL),(1755,1458,0,'LSQ12eui','LSQ',51.8568333333333,-11.5911111111111,NULL,NULL,'2012-09-14 08:52:58',56184.3701200001,19.1338,0.0907,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_snap_57647.gif',37886492399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591976443,9249631,NULL,NULL,NULL,NULL),(1756,1616,0,'LSQ12evy','LSQ',25.097375,-29.7411944444444,NULL,NULL,'2012-09-14 02:48:08',56184.1167600001,22.5035,0.1918,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_history.html','sn?',NULL,0.242061,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_snap_57681.gif',38265285480,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597895085,9342110,NULL,NULL,NULL,NULL),(1757,1616,0,'LSQ12evy','LSQ',25.0972083333333,-29.7412777777778,NULL,NULL,'2012-09-14 04:49:55',56184.2013400001,22.9063,0.1841,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_history.html','sn?',NULL,0.242061,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_snap_57682.gif',38265285488,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597895085,9342110,NULL,NULL,NULL,NULL),(1758,1616,0,'LSQ12evy','LSQ',25.09725,-29.7411944444444,NULL,NULL,'2012-09-14 06:49:33',56184.2844199999,22.3485,0.141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_history.html','sn?',NULL,0.242061,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_snap_57683.gif',38265285488,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597895085,9342110,NULL,NULL,NULL,NULL),(1759,1618,0,'LSQ12evw','LSQ',28.8265833333333,-29.9607777777778,NULL,NULL,'2012-09-14 02:48:08',56184.1167600001,20.1823,0.1034,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_57658.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1760,1618,0,'LSQ12evw','LSQ',28.8265833333333,-29.9608888888889,NULL,NULL,'2012-09-14 04:49:55',56184.2013400001,20.3624,0.1119,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_57659.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1761,1618,0,'LSQ12evw','LSQ',28.8265416666667,-29.9608333333333,NULL,NULL,'2012-09-14 06:49:33',56184.2844199999,20.2823,0.0921,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_57660.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1762,1620,0,'LSQ12evv','LSQ',28.7777083333333,-27.6873055555556,NULL,NULL,'2012-09-14 02:48:08',56184.1167600001,19.1704,0.1353,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_snap_57657.gif',38401172067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600018313,9375286,NULL,NULL,NULL,NULL),(1763,1670,0,'LSQ12exp','LSQ',354.28625,-24.1554444444444,NULL,NULL,'2012-09-14 02:32:58',56184.10623,19.6909,0.0569,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_57730.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1764,1670,0,'LSQ12exp','LSQ',354.286416666667,-24.1555,NULL,NULL,'2012-09-14 04:34:44',56184.1907899999,19.5128,0.0558,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_57731.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1765,1670,0,'LSQ12exp','LSQ',354.286291666667,-24.1554166666667,NULL,NULL,'2012-09-14 06:34:25',56184.27391,19.6717,0.0585,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_57732.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1766,1679,0,'LSQ12exl','LSQ',356.054541666667,-24.2010277777778,NULL,NULL,'2012-09-14 02:32:58',56184.10623,20.3913,0.1114,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_57723.gif',50003648247,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1767,1679,0,'LSQ12exl','LSQ',356.054458333333,-24.2009722222222,NULL,NULL,'2012-09-14 04:34:44',56184.1907899999,20.2783,0.0927,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_57724.gif',50003648244,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1768,1679,0,'LSQ12exl','LSQ',356.054541666667,-24.2010277777778,NULL,NULL,'2012-09-14 06:34:25',56184.27391,20.7079,0.139,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 06:45:41','2012-09-15 06:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_57725.gif',50003648247,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1769,1769,0,'PTF12iqw','PTF',36.210492,16.181395,NULL,NULL,'2012-09-13 00:00:00',56183,21.36,NULL,NULL,NULL,NULL,NULL,NULL,'2012-09-15 18:46:26','2019-10-12 20:41:36','NULL','supernova',NULL,0.027,NULL,NULL,'NULL',NULL,NULL,68081858590,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1063779040,16621547,NULL,NULL,NULL,NULL),(1770,1769,0,'PTF12iqw','pessto',36.210492,16.181395,NULL,NULL,'2012-09-14 00:00:00',56184,NULL,NULL,NULL,0.027,NULL,'II',NULL,'2012-09-15 17:48:24','2012-09-15 17:48:24','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,68081858590,'Gemini N','GMOS','Jerod Parrent',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1063779040,16621547,NULL,NULL,NULL,NULL),(1771,811,0,'LSQ12ejy','LSQ',355.411166666667,-22.7781388888889,NULL,NULL,'2012-09-15 00:34:36',56185.02403,19.8855,0.1517,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_57963.gif',50274702770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(1772,811,0,'LSQ12ejy','LSQ',355.411,-22.7780833333333,NULL,NULL,'2012-09-15 02:34:59',56185.10763,18.9193,0.0999,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_57964.gif',50274702771,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(1773,811,0,'LSQ12ejy','LSQ',355.411083333333,-22.7780833333333,NULL,NULL,'2012-09-15 04:35:02',56185.1910000001,19.3817,0.1375,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejy/LSQ12ejy_snap_57965.gif',50274702771,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,785542230,12274097,NULL,NULL,NULL,NULL),(1774,817,0,'LSQ12ejx','LSQ',355.038583333333,-21.87475,NULL,NULL,'2012-09-15 04:35:02',56185.1910000001,21.6495,0.1583,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejx/LSQ12ejx_snap_57960.gif',50276293318,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,785567083,12274485,NULL,NULL,NULL,NULL),(1775,823,0,'LSQ12ejw','LSQ',357.600791666667,-24.6791944444444,NULL,NULL,'2012-09-15 00:34:36',56185.02403,18.1077,0.0538,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_snap_57961.gif',50012664937,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,781447889,12210123,NULL,NULL,NULL,NULL),(1776,823,0,'LSQ12ejw','LSQ',357.600875,-24.6791944444444,NULL,NULL,'2012-09-15 04:35:02',56185.1910000001,18.6197,0.0682,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ejw/LSQ12ejw_snap_57962.gif',50012664937,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,781447889,12210123,NULL,NULL,NULL,NULL),(1777,1201,0,'LSQ12eod','LSQ',319.04025,-24.1268333333333,NULL,NULL,'2012-09-15 00:58:01',56185.0402899999,21.0963,0.2127,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eod/LSQ12eod_history.html','hostless?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eod/LSQ12eod_snap_58016.gif',50917408090,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,795584501,12431007,NULL,NULL,NULL,NULL),(1778,1205,0,'LSQ12eoc','LSQ',317.28425,-22.2571944444444,NULL,NULL,'2012-09-15 03:23:47',56185.1415200001,20.2052,0.1412,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_snap_58021.gif',50904231018,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,795378609,12427790,NULL,NULL,NULL,NULL),(1779,1557,0,'LSQ12evn','LSQ',311.892666666667,-17.1579444444444,NULL,NULL,'2012-09-15 00:03:16',56185.0022700001,18.872,0.059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_57970.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1780,1557,0,'LSQ12evn','LSQ',311.892666666667,-17.1579166666667,NULL,NULL,'2012-09-15 02:47:05',56185.1160400002,18.8771,0.0747,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_57971.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1781,1568,0,'LSQ12evl','LSQ',309.547333333333,-20.9068888888889,NULL,NULL,'2012-09-15 00:03:16',56185.0022700001,20.4412,0.1972,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_snap_57973.gif',50824114763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,794126793,12408231,NULL,NULL,NULL,NULL),(1782,1568,0,'LSQ12evl','LSQ',309.547291666667,-20.9068611111111,NULL,NULL,'2012-09-15 02:47:05',56185.1160400002,20.5527,0.2155,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_snap_57974.gif',50824114763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,794126793,12408231,NULL,NULL,NULL,NULL),(1783,1570,0,'LSQ12evo','LSQ',317.523458333333,-25.5898888888889,NULL,NULL,'2012-09-15 00:30:42',56185.0213299999,19.2906,0.148,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_snap_57972.gif',51425622868,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,803525357,12555083,NULL,NULL,NULL,NULL),(1784,1618,0,'LSQ12evw','LSQ',28.8265416666667,-29.9608888888889,NULL,NULL,'2012-09-15 02:38:57',56185.11039,20.0625,0.1362,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_57989.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1785,1618,0,'LSQ12evw','LSQ',28.8264166666667,-29.9608611111111,NULL,NULL,'2012-09-15 06:38:49',56185.2769599999,20.2774,0.1052,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_57990.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1786,1620,0,'LSQ12evv','LSQ',28.778,-27.687,NULL,NULL,'2012-09-15 04:39:00',56185.1937500001,19.3391,0.1102,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_snap_57987.gif',38401172067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600018313,9375286,NULL,NULL,NULL,NULL),(1787,1670,0,'LSQ12exp','LSQ',354.286541666667,-24.1556944444444,NULL,NULL,'2012-09-15 00:34:36',56185.02403,19.3972,0.0677,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_58028.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1788,1670,0,'LSQ12exp','LSQ',354.286375,-24.1555,NULL,NULL,'2012-09-15 02:34:59',56185.10763,19.7338,0.0583,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_58029.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1789,1670,0,'LSQ12exp','LSQ',354.286291666667,-24.1554166666667,NULL,NULL,'2012-09-15 04:35:02',56185.1910000001,19.7171,0.0647,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_58030.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1790,1679,0,'LSQ12exl','LSQ',356.054333333333,-24.2009722222222,NULL,NULL,'2012-09-15 00:34:36',56185.02403,20.0495,0.1172,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_58068.gif',50003648244,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1791,1679,0,'LSQ12exl','LSQ',356.0545,-24.201,NULL,NULL,'2012-09-15 02:34:59',56185.10763,20.3725,0.1132,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_58069.gif',50003648244,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1792,1679,0,'LSQ12exl','LSQ',356.054416666667,-24.2009722222222,NULL,NULL,'2012-09-15 04:35:02',56185.1910000001,20.717,0.1198,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_58070.gif',50003648244,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1793,1720,0,'LSQ12ezu','LSQ',355.076541666667,-21.156,NULL,NULL,'2012-09-15 05:04:14',56185.2112799999,19.0512,0.1083,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_snap_58057.gif',50277624862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785587888,12274810,NULL,NULL,NULL,NULL),(1794,1720,0,'LSQ12ezu','LSQ',355.076625,-21.156,NULL,NULL,'2012-09-15 07:17:47',56185.3040200002,18.7605,0.0959,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_snap_58058.gif',50277624863,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785587888,12274810,NULL,NULL,NULL,NULL),(1795,1725,0,'LSQ12ezs','LSQ',310.557625,-21.6615555555556,NULL,NULL,'2012-09-15 00:15:31',56185.0107800001,19.2335,0.0652,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_snap_58055.gif',50825557719,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794149339,12408583,NULL,NULL,NULL,NULL),(1796,1725,0,'LSQ12ezs','LSQ',310.557666666667,-21.6615555555556,NULL,NULL,'2012-09-15 03:02:00',56185.1263899999,19.1908,0.0672,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_snap_58056.gif',50825557717,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794149339,12408583,NULL,NULL,NULL,NULL),(1797,1731,0,'LSQ12ezr','LSQ',311.787,-21.5501944444444,NULL,NULL,'2012-09-15 03:02:00',56185.1263899999,19.6529,0.1252,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezr/LSQ12ezr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezr/LSQ12ezr_snap_58052.gif',50825432380,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794147380,12408552,NULL,NULL,NULL,NULL),(1798,1735,0,'LSQ12ezn','LSQ',54.4398333333333,-37.26575,NULL,NULL,'2012-09-15 06:46:02',56185.2819699999,19.0988,0.0508,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_58059.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(1799,1735,0,'LSQ12ezn','LSQ',54.4398333333333,-37.2657222222222,NULL,NULL,'2012-09-15 08:32:51',56185.3561499999,19.0572,0.0482,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-15 22:45:34','2012-09-15 22:45:34','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_58060.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(1800,1800,1,'LSQ12fat','LSQ',356.181,3.10844444444444,NULL,NULL,'2012-09-14 04:09:26',56184.1732200002,20.6185,0.1676,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fat/LSQ12fat_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fat/LSQ12fat_snap_58132.gif',51603275523,NULL,NULL,NULL,'2012-09-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,806301180,12598455,NULL,NULL,NULL,NULL),(1801,1800,0,'LSQ12fat','LSQ',356.181291666667,3.10833333333333,NULL,NULL,'2012-09-14 06:10:47',56184.2574999998,19.7687,0.0968,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fat/LSQ12fat_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fat/LSQ12fat_snap_58133.gif',51603275523,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,806301180,12598455,NULL,NULL,NULL,NULL),(1802,1802,1,'LSQ12fas','LSQ',1.62958333333333,2.00305555555556,NULL,NULL,'2012-09-14 04:21:38',56184.18169,20.9163,0.1594,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fas/LSQ12fas_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fas/LSQ12fas_snap_58130.gif',66588638541,NULL,NULL,NULL,'2012-07-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1040447477,16256991,NULL,NULL,NULL,NULL),(1803,1802,0,'LSQ12fas','LSQ',1.62966666666667,2.00291666666667,NULL,NULL,'2012-09-14 06:22:52',56184.2658799998,20.0393,0.1691,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fas/LSQ12fas_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fas/LSQ12fas_snap_58131.gif',66588638541,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1040447477,16256991,NULL,NULL,NULL,NULL),(1804,1804,1,'LSQ12fap','LSQ',343.293166666667,-3.27513888888889,NULL,NULL,'2012-08-19 06:12:04',56158.2583900001,20.5355,0.112,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fap/LSQ12fap_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fap/LSQ12fap_snap_58207.gif',49520267198,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773754174,12089908,NULL,NULL,NULL,NULL),(1805,1804,0,'LSQ12fap','LSQ',343.293208333333,-3.27525,NULL,NULL,'2012-08-19 08:22:11',56158.3487399998,20.697,0.168,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fap/LSQ12fap_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fap/LSQ12fap_snap_58208.gif',49520267198,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773754174,12089908,NULL,NULL,NULL,NULL),(1806,1804,0,'LSQ12fap','LSQ',343.2935,-3.27511111111111,NULL,NULL,'2012-09-14 03:45:10',56184.15637,20.3068,0.167,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fap/LSQ12fap_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fap/LSQ12fap_snap_58122.gif',49520267198,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773754174,12089908,NULL,NULL,NULL,NULL),(1807,1804,0,'LSQ12fap','LSQ',343.293708333333,-3.27502777777778,NULL,NULL,'2012-09-14 05:46:34',56184.2406799998,19.9586,0.1398,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fap/LSQ12fap_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fap/LSQ12fap_snap_58123.gif',49520267198,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773754174,12089908,NULL,NULL,NULL,NULL),(1808,1808,1,'LSQ12fal','LSQ',21.858625,-3.76283333333333,NULL,NULL,'2012-08-22 09:05:10',56161.3785899999,18.9048,0.079,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_snap_58183.gif',35246476730,NULL,NULL,NULL,'2012-08-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,550726198,8605096,NULL,NULL,NULL,NULL),(1809,1808,0,'LSQ12fal','LSQ',21.8579583333333,-3.76297222222222,NULL,NULL,'2012-08-26 08:23:55',56165.3499500002,20.1259,0.1967,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_snap_58184.gif',35246476677,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,550726198,8605096,NULL,NULL,NULL,NULL),(1810,1808,0,'LSQ12fal','LSQ',21.8583333333333,-3.76277777777778,NULL,NULL,'2012-08-28 06:24:39',56167.26712,19.7357,0.1376,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_snap_58185.gif',35246476730,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,550726198,8605096,NULL,NULL,NULL,NULL),(1811,1808,0,'LSQ12fal','LSQ',21.8582916666667,-3.76283333333333,NULL,NULL,'2012-08-30 05:51:05',56169.2438099999,19.6733,0.1535,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_snap_58186.gif',35246476677,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,550726198,8605096,NULL,NULL,NULL,NULL),(1812,1808,0,'LSQ12fal','LSQ',21.8585416666667,-3.76288888888889,NULL,NULL,'2012-09-02 05:46:45',56172.2408099999,19.8583,0.1831,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_snap_58187.gif',35246476730,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,550726198,8605096,NULL,NULL,NULL,NULL),(1813,1808,0,'LSQ12fal','LSQ',21.8588333333333,-3.763,NULL,NULL,'2012-09-12 06:47:08',56182.2827400002,19.271,0.0607,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_snap_58188.gif',35246476730,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,550726198,8605096,NULL,NULL,NULL,NULL),(1814,1808,0,'LSQ12fal','LSQ',21.85875,-3.76288888888889,NULL,NULL,'2012-09-14 08:16:54',56184.3450799999,19.377,0.1052,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_snap_58114.gif',35246476730,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,550726198,8605096,NULL,NULL,NULL,NULL),(1815,1808,0,'LSQ12fal','LSQ',21.8584583333333,-3.76291666666667,NULL,NULL,'2012-09-14 09:17:21',56184.3870600001,19.1696,0.0679,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_snap_58115.gif',35246476730,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,550726198,8605096,NULL,NULL,NULL,NULL),(1816,1816,1,'LSQ12fak','LSQ',56.3515833333333,-10.5703611111111,NULL,NULL,'2012-09-12 06:31:18',56182.2717400002,20.0245,0.1113,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_snap_58181.gif',37026669944,NULL,NULL,NULL,'2012-09-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578541717,9039714,NULL,NULL,NULL,NULL),(1817,1816,0,'LSQ12fak','LSQ',56.3515833333333,-10.5703611111111,NULL,NULL,'2012-09-12 08:44:28',56182.3642199999,19.6889,0.1087,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_snap_58182.gif',37026669944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578541717,9039714,NULL,NULL,NULL,NULL),(1818,1816,0,'LSQ12fak','LSQ',56.3516666666667,-10.5702777777778,NULL,NULL,'2012-09-14 08:00:55',56184.3339800001,19.4582,0.1372,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_snap_58112.gif',37026669944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578541717,9039714,NULL,NULL,NULL,NULL),(1819,1816,0,'LSQ12fak','LSQ',56.3515833333333,-10.5703888888889,NULL,NULL,'2012-09-14 08:54:38',56184.3712800001,19.4322,0.1027,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_snap_58113.gif',37026669944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578541717,9039714,NULL,NULL,NULL,NULL),(1820,1820,1,'LSQ12fag','LSQ',25.3704166666667,-29.6439722222222,NULL,NULL,'2012-09-08 03:31:19',56178.1467499998,21.9227,0.1884,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58169.gif',38265521124,NULL,NULL,NULL,'2012-09-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1821,1820,0,'LSQ12fag','LSQ',25.3707083333333,-29.6440833333333,NULL,NULL,'2012-09-09 07:14:45',56179.3019099999,21.6991,0.1515,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58170.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1822,1820,0,'LSQ12fag','LSQ',25.370625,-29.644,NULL,NULL,'2012-09-10 03:50:04',56180.1597799999,21.6176,0.09,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58171.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1823,1820,0,'LSQ12fag','LSQ',25.3707083333333,-29.6440555555556,NULL,NULL,'2012-09-11 03:47:14',56181.1578099998,21.4806,0.0765,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58172.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1824,1820,0,'LSQ12fag','LSQ',25.3706666666667,-29.6440555555556,NULL,NULL,'2012-09-11 06:03:33',56181.2524700002,21.4031,0.0826,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58173.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1825,1820,0,'LSQ12fag','LSQ',25.370625,-29.6439722222222,NULL,NULL,'2012-09-12 02:58:28',56182.1239399998,21.1587,0.0663,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58174.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1826,1820,0,'LSQ12fag','LSQ',25.370625,-29.644,NULL,NULL,'2012-09-12 04:59:13',56182.2078,21.3596,0.0682,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58175.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1827,1820,0,'LSQ12fag','LSQ',25.370625,-29.6439722222222,NULL,NULL,'2012-09-12 07:01:05',56182.2924299999,21.2024,0.0601,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58176.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1828,1820,0,'LSQ12fag','LSQ',25.370625,-29.6440277777778,NULL,NULL,'2012-09-13 02:54:11',56183.12097,21.3428,0.0779,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58177.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1829,1820,0,'LSQ12fag','LSQ',25.370625,-29.6440277777778,NULL,NULL,'2012-09-13 04:54:53',56183.2047899999,21.159,0.0607,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58178.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1830,1820,0,'LSQ12fag','LSQ',25.3706666666667,-29.6440277777778,NULL,NULL,'2012-09-13 06:55:30',56183.2885500002,21.3192,0.0706,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58179.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1831,1820,0,'LSQ12fag','LSQ',25.3706666666667,-29.644,NULL,NULL,'2012-09-14 02:48:08',56184.1167600001,21.1924,0.0646,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58103.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1832,1820,0,'LSQ12fag','LSQ',25.3706666666667,-29.644,NULL,NULL,'2012-09-14 04:49:55',56184.2013400001,21.1989,0.063,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58105.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1833,1820,0,'LSQ12fag','LSQ',25.3706666666667,-29.644,NULL,NULL,'2012-09-14 06:49:33',56184.2844199999,21.2143,0.0685,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58104.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1834,1820,0,'LSQ12fag','LSQ',25.3706666666667,-29.644,NULL,NULL,'2012-09-15 02:38:57',56185.11039,21.2127,0.0637,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58253.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1835,1820,0,'LSQ12fag','LSQ',25.3706666666667,-29.6439722222222,NULL,NULL,'2012-09-15 04:39:00',56185.1937500001,21.1151,0.0675,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58254.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1836,1820,0,'LSQ12fag','LSQ',25.3707083333333,-29.644,NULL,NULL,'2012-09-15 06:38:49',56185.2769599999,21.1002,0.063,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-16 18:45:31','2012-09-16 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58255.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1837,1837,0,'PSNJ01184597+1459402','TOCP',19.69188,14.99442,NULL,NULL,'2012-09-11 00:00:00',56181,15.5,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-09-17 03:23:22','2019-10-12 20:41:36','NULL','supernova',NULL,0.023,NULL,NULL,'http://www.astrofilisenesi.it/public/Sne/Uploads/PSN_in_UGC00838.jpg',NULL,NULL,67601059096,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1056266548,16504164,NULL,NULL,NULL,NULL),(1838,1566,0,'LSQ12evm','pessto',336.765708333,-23.6769444444,NULL,NULL,'2012-09-17 14:39:50',56187.611,NULL,NULL,NULL,0.136,NULL,'IIn',NULL,'2012-09-17 03:46:26','2012-09-17 03:46:26','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50212210897,'NTT','EFOSC','Yen Chen Pan',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784565795,12258840,NULL,NULL,NULL,NULL),(1839,1568,0,'LSQ12evl','pessto',309.547291667,-20.9068333333,NULL,NULL,'2012-09-17 15:34:33',56187.649,NULL,NULL,NULL,0.15,NULL,'Ia',NULL,'2012-09-17 04:38:16','2012-09-17 04:38:16','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50824114763,'NTT','EFOSC','Yen Chen Pan',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,794126793,12408231,NULL,NULL,NULL,NULL),(1840,1570,0,'LSQ12evo','pessto',317.5235,-25.5899,NULL,NULL,'2012-09-08 00:00:00',56178,NULL,NULL,NULL,0.1,NULL,'Ia',NULL,'2012-09-17 05:14:41','2012-09-17 05:14:41','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,51425622868,'NTT','EFOSC','Yen Chen Pan',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,803525357,12555083,NULL,NULL,NULL,NULL),(1841,1669,0,'PSNJ02452841-6207214','pessto',41.36838,-62.12261,NULL,NULL,'2012-09-17 00:00:00',56187,NULL,NULL,NULL,0.026,NULL,'II',NULL,'2012-09-17 08:19:45','2012-09-17 08:19:45','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,36260997780,'NTT','EFOSC','Yen Chen Pan',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,566578090,8852782,NULL,NULL,NULL,NULL),(1843,1735,0,'LSQ12ezn','pessto',54.439875,-37.26575,NULL,NULL,'2012-09-17 00:00:00',56187,NULL,NULL,NULL,0,NULL,'unknown',NULL,'2012-09-17 09:08:09','2012-09-17 09:08:09','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38556577295,'NTT','EFOSC','Yen Chen Pan',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(1844,1550,0,'PSNJ04371913-6908254','pessto',69.32971,-69.14039,NULL,NULL,'2012-09-17 00:00:00',56187,NULL,NULL,NULL,0.063,NULL,'Ia',NULL,'2012-09-17 09:40:39','2012-09-17 09:40:39','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,36436638088,'NTT','EFOSC','Yen Chen Pan',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,569322470,8895663,NULL,NULL,NULL,NULL),(1845,1837,0,'PSNJ01184597+1459402','pessto',19.69188,14.99442,NULL,NULL,'2012-09-17 00:00:00',56187,NULL,NULL,NULL,0,NULL,'unknown',NULL,'2012-09-17 10:43:56','2012-09-17 10:43:56','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,67601059096,'NTT','EFOSC','Yen Chen Pan',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1056266548,16504164,NULL,NULL,NULL,NULL),(1846,1020,0,'LSQ12elo','LSQ',318.356625,-6.59952777777778,NULL,NULL,'2012-09-16 00:03:54',56186.0027100001,20.3636,0.1875,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elo/LSQ12elo_history.html','sne?',NULL,0.12145,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elo/LSQ12elo_snap_58462.gif',50789822544,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793590977,12399859,NULL,NULL,NULL,NULL),(1847,1026,0,'LSQ12elz','LSQ',329.397625,-0.83925,NULL,NULL,'2012-09-16 00:35:21',56186.0245599998,20.5719,0.1918,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_history.html','sne?',NULL,0.21853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12elz/LSQ12elz_snap_58506.gif',49826069800,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778532340,12164567,NULL,NULL,NULL,NULL),(1848,1033,0,'LSQ12ely','LSQ',329.641416666667,-1.70513888888889,NULL,NULL,'2012-09-16 04:02:08',56186.1681499998,20.6957,0.199,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ely/LSQ12ely_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ely/LSQ12ely_snap_58278.gif',49828188398,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778565443,12165085,NULL,NULL,NULL,NULL),(1849,1287,0,'LSQ12erd','LSQ',10.6061666666667,0.864722222222222,NULL,NULL,'2012-09-16 07:27:33',56186.3108000001,20.1909,0.1888,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erd/LSQ12erd_history.html','sne?',NULL,0.16679,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erd/LSQ12erd_snap_58536.gif',66807779648,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,1043871557,16310493,NULL,NULL,NULL,NULL),(1850,1289,0,'LSQ12erc','LSQ',8.77091666666667,1.48144444444444,NULL,NULL,'2012-09-16 07:13:27',56186.3010100001,18.1232,0.0364,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_snap_58558.gif',66590313561,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1040473649,16257400,NULL,NULL,NULL,NULL),(1851,1295,0,'LSQ12era','LSQ',324.270875,0.478833333333333,NULL,NULL,'2012-09-16 00:07:17',56186.0050599999,19.2745,0.1323,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12era/LSQ12era_history.html','sne?',NULL,0.05021,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12era/LSQ12era_snap_58549.gif',52096398906,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814006232,12718847,NULL,NULL,NULL,NULL),(1852,1451,0,'LSQ12euu','LSQ',322.784166666667,-6.70405555555556,NULL,NULL,'2012-09-16 00:26:00',56186.0180600001,19.5548,0.1087,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_snap_58362.gif',49683505265,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776304769,12129762,NULL,NULL,NULL,NULL),(1853,1451,0,'LSQ12euu','LSQ',322.784083333333,-6.70405555555556,NULL,NULL,'2012-09-16 03:48:23',56186.1586099998,19.7049,0.1434,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_snap_58363.gif',49683505270,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776304769,12129762,NULL,NULL,NULL,NULL),(1854,1458,0,'LSQ12eui','LSQ',51.8567083333333,-11.5908611111111,NULL,NULL,'2012-09-16 06:43:43',56186.2803600002,19.2418,0.1091,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_snap_58426.gif',37886492397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591976443,9249631,NULL,NULL,NULL,NULL),(1855,1458,0,'LSQ12eui','LSQ',51.8568333333333,-11.5908611111111,NULL,NULL,'2012-09-16 08:18:02',56186.3458599998,19.5317,0.1332,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_snap_58427.gif',37886492397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591976443,9249631,NULL,NULL,NULL,NULL),(1856,1460,0,'LSQ12eue','LSQ',38.879375,-7.49275,NULL,NULL,'2012-09-16 06:03:23',56186.2523500002,19.4622,0.0726,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eue/LSQ12eue_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eue/LSQ12eue_snap_58379.gif',34938434364,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545913036,8529891,NULL,NULL,NULL,NULL),(1857,1460,0,'LSQ12eue','LSQ',38.8793333333333,-7.49272222222222,NULL,NULL,'2012-09-16 07:54:31',56186.3295300002,19.335,0.0677,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eue/LSQ12eue_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eue/LSQ12eue_snap_58380.gif',34938434364,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545913036,8529891,NULL,NULL,NULL,NULL),(1858,1616,0,'LSQ12evy','LSQ',25.09725,-29.7411666666667,NULL,NULL,'2012-09-16 06:45:40',56186.2817199999,22.5105,0.1769,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_history.html','sn?',NULL,0.242061,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_snap_58445.gif',38265285488,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597895085,9342110,NULL,NULL,NULL,NULL),(1859,1618,0,'LSQ12evw','LSQ',28.8265,-29.9608611111111,NULL,NULL,'2012-09-16 02:41:26',56186.1121100001,20.1588,0.0939,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_58433.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1860,1618,0,'LSQ12evw','LSQ',28.8265833333333,-29.9608333333333,NULL,NULL,'2012-09-16 04:43:12',56186.19667,20.12,0.1087,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_58434.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1861,1618,0,'LSQ12evw','LSQ',28.8265416666667,-29.9608611111111,NULL,NULL,'2012-09-16 06:45:40',56186.2817199999,20.5617,0.1521,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_58435.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1862,1620,0,'LSQ12evv','LSQ',28.7785,-27.687,NULL,NULL,'2012-09-14 06:49:33',56184.2844199999,19.3002,0.1217,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_snap_58727.gif',38401172065,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600018313,9375286,NULL,NULL,NULL,NULL),(1863,1620,0,'LSQ12evv','LSQ',28.7784583333333,-27.6871111111111,NULL,NULL,'2012-09-16 02:41:26',56186.1121100001,19.4164,0.1523,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_snap_58451.gif',38401172065,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600018313,9375286,NULL,NULL,NULL,NULL),(1864,1620,0,'LSQ12evv','LSQ',28.7784583333333,-27.6871111111111,NULL,NULL,'2012-09-16 06:45:40',56186.2817199999,19.5515,0.1631,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_snap_58452.gif',38401172065,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600018313,9375286,NULL,NULL,NULL,NULL),(1865,1646,0,'LSQ12ewu','LSQ',317.788958333333,-6.94141666666667,NULL,NULL,'2012-09-15 23:47:44',56185.9914899999,19.1295,0.071,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewu/LSQ12ewu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewu/LSQ12ewu_snap_58481.gif',50789486443,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'BS',NULL,0,NULL,0,793585725,12399776,NULL,NULL,NULL,NULL),(1866,1646,0,'LSQ12ewu','LSQ',317.788833333333,-6.94133333333333,NULL,NULL,'2012-09-16 01:49:43',56186.0762,19.7742,0.1431,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewu/LSQ12ewu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewu/LSQ12ewu_snap_58482.gif',50789486443,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'BS',NULL,0,NULL,0,793585725,12399776,NULL,NULL,NULL,NULL),(1867,1670,0,'LSQ12exp','LSQ',354.286458333333,-24.1554444444444,NULL,NULL,'2012-09-16 00:31:27',56186.0218500001,19.3262,0.0627,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_58503.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1868,1670,0,'LSQ12exp','LSQ',354.286291666667,-24.1554444444444,NULL,NULL,'2012-09-16 02:37:26',56186.1093299999,19.6363,0.0578,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_58504.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1869,1670,0,'LSQ12exp','LSQ',354.286333333333,-24.1554722222222,NULL,NULL,'2012-09-16 04:39:12',56186.1938999998,19.7389,0.0563,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_58505.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1870,1679,0,'LSQ12exl','LSQ',356.054375,-24.2008888888889,NULL,NULL,'2012-09-16 00:31:27',56186.0218500001,19.8361,0.1148,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_58573.gif',50003648244,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1871,1679,0,'LSQ12exl','LSQ',356.054333333333,-24.2009444444444,NULL,NULL,'2012-09-16 02:37:26',56186.1093299999,20.4394,0.1023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_58574.gif',50003648244,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1872,1679,0,'LSQ12exl','LSQ',356.054333333333,-24.2009166666667,NULL,NULL,'2012-09-16 04:39:12',56186.1938999998,20.402,0.1077,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_58575.gif',50003648244,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1873,1718,0,'LSQ12eyo','LSQ',43.8210416666667,-7.89752777777778,NULL,NULL,'2012-09-16 06:10:10',56186.2570699998,19.7251,0.1537,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eyo/LSQ12eyo_history.html','sn?',NULL,0.03116,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eyo/LSQ12eyo_snap_58532.gif',37913944767,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592405386,9256334,NULL,NULL,NULL,NULL),(1874,1718,0,'LSQ12eyo','LSQ',43.8212083333333,-7.89752777777778,NULL,NULL,'2012-09-16 07:57:55',56186.33189,19.8545,0.2033,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eyo/LSQ12eyo_history.html','sn?',NULL,0.03116,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eyo/LSQ12eyo_snap_58533.gif',37913944767,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592405386,9256334,NULL,NULL,NULL,NULL),(1875,1816,0,'LSQ12fak','LSQ',56.351625,-10.5704166666667,NULL,NULL,'2012-09-16 06:58:43',56186.2907799999,19.6208,0.1144,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_snap_58428.gif',37026669944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578541717,9039714,NULL,NULL,NULL,NULL),(1876,1816,0,'LSQ12fak','LSQ',56.3516666666667,-10.5704166666667,NULL,NULL,'2012-09-16 08:23:09',56186.3494199999,19.4545,0.1304,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_snap_58429.gif',37026669944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578541717,9039714,NULL,NULL,NULL,NULL),(1877,1820,0,'LSQ12fag','LSQ',25.3706666666667,-29.6440555555556,NULL,NULL,'2012-09-16 02:41:26',56186.1121100001,21.0737,0.0611,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58417.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1878,1820,0,'LSQ12fag','LSQ',25.37075,-29.6440555555556,NULL,NULL,'2012-09-16 04:43:12',56186.19667,21.3176,0.0741,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58418.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1879,1820,0,'LSQ12fag','LSQ',25.370625,-29.644,NULL,NULL,'2012-09-16 06:45:40',56186.2817199999,21.0397,0.0574,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-18 19:45:27','2012-09-18 19:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58419.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1880,1557,0,'LSQ12evn','LSQ',311.89275,-17.1578055555556,NULL,NULL,'2012-09-17 00:04:16',56187.0029699998,18.4951,0.0443,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_58962.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1881,1557,0,'LSQ12evn','LSQ',311.892666666667,-17.1579166666667,NULL,NULL,'2012-09-17 02:15:44',56187.0942600002,19.2257,0.0718,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_58963.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1882,1568,0,'LSQ12evl','LSQ',309.547208333333,-20.9068333333333,NULL,NULL,'2012-09-17 00:04:16',56187.0029699998,20.7218,0.1465,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_snap_58958.gif',50824114763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,794126793,12408231,NULL,NULL,NULL,NULL),(1883,1568,0,'LSQ12evl','LSQ',309.547416666667,-20.9069444444444,NULL,NULL,'2012-09-17 02:15:44',56187.0942600002,20.9058,0.1846,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evl/LSQ12evl_snap_58959.gif',50824114763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,794126793,12408231,NULL,NULL,NULL,NULL),(1884,1570,0,'LSQ12evo','LSQ',317.523625,-25.5899722222222,NULL,NULL,'2012-09-17 00:36:12',56187.0251500001,19.9794,0.1965,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evo/LSQ12evo_snap_58957.gif',51425622868,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,803525357,12555083,NULL,NULL,NULL,NULL),(1885,1599,0,'LSQ12evr','LSQ',27.437375,-27.5274444444444,NULL,NULL,'2012-09-17 02:31:30',56187.1052100002,21.6202,0.1793,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evr/LSQ12evr_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evr/LSQ12evr_snap_58968.gif',38254315647,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597723681,9339432,NULL,NULL,NULL,NULL),(1886,1614,0,'LSQ12evz','LSQ',25.7008333333333,-29.8620277777778,NULL,NULL,'2012-09-16 04:43:12',56186.19667,21.339,0.1153,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evz/LSQ12evz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evz/LSQ12evz_snap_59058.gif',38265679390,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,597901240,9342206,NULL,NULL,NULL,NULL),(1887,1614,0,'LSQ12evz','LSQ',25.7012916666667,-29.8615555555556,NULL,NULL,'2012-09-17 04:31:39',56187.1886499999,21.438,0.1302,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evz/LSQ12evz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evz/LSQ12evz_snap_58982.gif',38265679391,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,597901240,9342206,NULL,NULL,NULL,NULL),(1888,1670,0,'LSQ12exp','LSQ',354.286458333333,-24.1555277777778,NULL,NULL,'2012-09-17 00:25:18',56187.0175800002,19.3123,0.0666,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_59006.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1889,1670,0,'LSQ12exp','LSQ',354.286375,-24.1555,NULL,NULL,'2012-09-17 02:27:29',56187.10243,19.5255,0.0564,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_59007.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1890,1670,0,'LSQ12exp','LSQ',354.286333333333,-24.1554722222222,NULL,NULL,'2012-09-17 04:27:40',56187.1858799998,19.6644,0.0554,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exp/LSQ12exp_snap_59008.gif',50055472816,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782116762,12220574,NULL,NULL,NULL,NULL),(1891,1679,0,'LSQ12exl','LSQ',356.054416666667,-24.2009166666667,NULL,NULL,'2012-09-17 02:27:29',56187.10243,20.4667,0.1384,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_59020.gif',50003648244,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1892,1725,0,'LSQ12ezs','LSQ',310.557708333333,-21.6615833333333,NULL,NULL,'2012-09-17 00:16:20',56187.0113499998,19.2497,0.0781,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_snap_58949.gif',50825557717,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794149339,12408583,NULL,NULL,NULL,NULL),(1893,1735,0,'LSQ12ezn','LSQ',54.440125,-37.2658055555556,NULL,NULL,'2012-09-17 06:04:32',56187.2531499998,19.2645,0.0991,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_59018.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(1894,1735,0,'LSQ12ezn','LSQ',54.4400833333333,-37.2656944444444,NULL,NULL,'2012-09-17 07:54:44',56187.32968,19.2764,0.1456,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_59019.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(1895,1820,0,'LSQ12fag','LSQ',25.370625,-29.6440277777778,NULL,NULL,'2012-09-17 02:31:30',56187.1052100002,21.1711,0.0786,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58953.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1896,1820,0,'LSQ12fag','LSQ',25.3706666666667,-29.6439722222222,NULL,NULL,'2012-09-17 04:31:39',56187.1886499999,20.9365,0.0632,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58954.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1897,1820,0,'LSQ12fag','LSQ',25.3707916666667,-29.644,NULL,NULL,'2012-09-17 06:32:38',56187.2726699999,21.4851,0.1673,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 03:45:31','2012-09-19 03:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_58955.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1898,1620,0,'LSQ12evv','LSQ',28.7777916666667,-27.6873611111111,NULL,NULL,'2012-09-18 07:59:26',56188.3329400001,18.0528,0.1089,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 10:45:28','2012-09-19 10:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_snap_59074.gif',38401172067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600018313,9375286,NULL,NULL,NULL,NULL),(1899,1646,0,'LSQ12ewu','LSQ',317.788708333333,-6.94155555555556,NULL,NULL,'2012-09-18 00:58:21',56188.0405299999,20.2173,0.1759,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 10:45:28','2012-09-19 10:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewu/LSQ12ewu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ewu/LSQ12ewu_snap_59083.gif',50789486443,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'BS',NULL,0,NULL,0,793585725,12399776,NULL,NULL,NULL,NULL),(1900,1820,0,'LSQ12fag','LSQ',25.3706666666667,-29.6440555555556,NULL,NULL,'2012-09-18 06:58:11',56188.2904099999,21.0971,0.0723,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 10:45:28','2012-09-19 10:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_59068.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1901,1820,0,'LSQ12fag','LSQ',25.3705416666667,-29.6440277777778,NULL,NULL,'2012-09-18 07:59:26',56188.3329400001,21.0485,0.2058,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 10:45:28','2012-09-19 10:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_59069.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1902,1902,1,'LSQ12fbd','LSQ',355.432541666667,-20.7286666666667,NULL,NULL,'2012-09-14 06:34:25',56184.27391,21.0124,0.1766,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 15:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbd/LSQ12fbd_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbd/LSQ12fbd_snap_58774.gif',50280653352,NULL,NULL,NULL,'2012-09-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785635208,12275550,NULL,NULL,NULL,NULL),(1903,1902,0,'LSQ12fbd','LSQ',355.432541666667,-20.7287222222222,NULL,NULL,'2012-09-16 00:31:27',56186.0218500001,20.5006,0.1409,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 15:45:27','2012-09-19 15:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbd/LSQ12fbd_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbd/LSQ12fbd_snap_58736.gif',50280653352,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785635208,12275550,NULL,NULL,NULL,NULL),(1904,1902,0,'LSQ12fbd','LSQ',355.432625,-20.7285555555556,NULL,NULL,'2012-09-16 02:37:26',56186.1093299999,20.5811,0.124,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 15:45:27','2012-09-19 15:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbd/LSQ12fbd_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbd/LSQ12fbd_snap_58737.gif',50280653352,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785635208,12275550,NULL,NULL,NULL,NULL),(1905,1902,0,'LSQ12fbd','LSQ',355.432625,-20.7282777777778,NULL,NULL,'2012-09-16 04:39:12',56186.1938999998,20.275,0.1056,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 15:45:27','2012-09-19 15:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbd/LSQ12fbd_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbd/LSQ12fbd_snap_58775.gif',50280653352,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785635208,12275550,NULL,NULL,NULL,NULL),(1906,1906,1,'LSQ12fck','LSQ',13.7215,-0.986361111111111,NULL,NULL,'2012-09-16 05:26:46',56186.2269299999,16.6966,0.0327,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 16:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fck/LSQ12fck_history.html','old sne',NULL,0.14663,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fck/LSQ12fck_snap_58841.gif',34525395353,NULL,NULL,NULL,'2012-09-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539459302,8429051,NULL,NULL,NULL,NULL),(1907,1906,0,'LSQ12fck','LSQ',13.7215,-0.986333333333333,NULL,NULL,'2012-09-16 07:27:33',56186.3108000001,18.5817,0.0491,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 16:45:27','2012-09-19 16:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fck/LSQ12fck_history.html','old sne',NULL,0.14663,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fck/LSQ12fck_snap_58842.gif',34525395353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539459302,8429051,NULL,NULL,NULL,NULL),(1908,1908,1,'LSQ12fch','LSQ',324.576791666667,-4.00636111111111,NULL,NULL,'2012-09-16 00:26:00',56186.0180600001,20.146,0.1654,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 16:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_history.html','faint brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_snap_58835.gif',49706541067,NULL,NULL,NULL,'2012-09-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776664704,12135386,NULL,NULL,NULL,NULL),(1909,1908,0,'LSQ12fch','LSQ',324.576791666667,-4.00633333333333,NULL,NULL,'2012-09-16 03:48:23',56186.1586099998,20.5262,0.1699,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 16:45:27','2012-09-19 16:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_history.html','faint brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_snap_58836.gif',49706541067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776664704,12135386,NULL,NULL,NULL,NULL),(1910,1910,1,'LSQ12fcd','LSQ',321.597083333333,-5.39577777777778,NULL,NULL,'2012-08-21 00:46:58',56160.0326200002,20.9669,0.1364,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 16:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fcd/LSQ12fcd_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fcd/LSQ12fcd_snap_58897.gif',49721248880,NULL,NULL,NULL,'2012-08-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,776894513,12138976,NULL,NULL,NULL,NULL),(1911,1910,0,'LSQ12fcd','LSQ',321.596916666667,-5.39583333333333,NULL,NULL,'2012-09-16 00:03:54',56186.0027100001,19.0284,0.1135,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 16:45:27','2012-09-19 16:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fcd/LSQ12fcd_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fcd/LSQ12fcd_snap_58827.gif',49721248872,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,776894513,12138976,NULL,NULL,NULL,NULL),(1912,1910,0,'LSQ12fcd','LSQ',321.597041666667,-5.39572222222222,NULL,NULL,'2012-09-16 03:09:26',56186.1315600001,18.7938,0.1215,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 16:45:27','2012-09-19 16:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fcd/LSQ12fcd_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fcd/LSQ12fcd_snap_58828.gif',49721248880,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,776894513,12138976,NULL,NULL,NULL,NULL),(1913,1913,0,'LSQ12fbz','LSQ',31.9909583333333,-6.09372222222222,NULL,NULL,'2012-09-12 08:30:09',56182.3542800001,18.7328,0.0391,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 16:45:27','2020-01-13 20:37:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbz/LSQ12fbz_history.html','old sne',NULL,0.071686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbz/LSQ12fbz_snap_58884.gif',35154560675,NULL,NULL,NULL,'2012-09-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549290010,8582656,NULL,NULL,NULL,NULL),(1914,1913,0,'LSQ12fbz','LSQ',31.9909166666667,-6.09377777777778,NULL,NULL,'2012-09-16 08:38:55',56186.3603599998,19.8017,0.085,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 16:45:27','2012-09-19 16:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbz/LSQ12fbz_history.html','old sne',NULL,0.071686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbz/LSQ12fbz_snap_58819.gif',35154560675,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549290010,8582656,NULL,NULL,NULL,NULL),(1915,1913,0,'LSQ12fbz','LSQ',31.9909166666667,-6.09375,NULL,NULL,'2012-09-16 09:15:08',56186.38552,19.7688,0.1112,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-19 16:45:27','2012-09-19 16:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbz/LSQ12fbz_history.html','old sne',NULL,0.071686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbz/LSQ12fbz_snap_58820.gif',35154560675,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549290010,8582656,NULL,NULL,NULL,NULL),(1916,1620,0,'LSQ12evv','LSQ',28.778125,-27.6874166666667,NULL,NULL,'2012-09-19 07:29:21',56189.3120599999,19.3563,0.1088,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-22 19:45:26','2012-09-22 19:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_snap_59280.gif',38401172067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600018313,9375286,NULL,NULL,NULL,NULL),(1917,1679,0,'LSQ12exl','LSQ',356.054458333333,-24.201,NULL,NULL,'2012-09-19 05:01:11',56189.2091600001,20.2647,0.1173,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-22 19:45:26','2012-09-22 19:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12exl/LSQ12exl_snap_59303.gif',50003648244,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,781307003,12207921,NULL,NULL,NULL,NULL),(1918,1720,0,'LSQ12ezu','LSQ',355.076625,-21.1559722222222,NULL,NULL,'2012-09-19 04:44:07',56189.1973100002,18.3602,0.0859,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-22 19:45:26','2012-09-22 19:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_snap_59297.gif',50277624863,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785587888,12274810,NULL,NULL,NULL,NULL),(1919,1720,0,'LSQ12ezu','LSQ',355.076583333333,-21.156,NULL,NULL,'2012-09-19 06:43:39',56189.2803199999,18.3799,0.0878,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-22 19:45:26','2012-09-22 19:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezu/LSQ12ezu_snap_59298.gif',50277624862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785587888,12274810,NULL,NULL,NULL,NULL),(1920,1735,0,'LSQ12ezn','LSQ',54.4399583333333,-37.2657777777778,NULL,NULL,'2012-09-19 08:45:12',56189.36473,19.2457,0.0538,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-22 19:45:26','2012-09-22 19:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_59299.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(1921,1735,0,'LSQ12ezn','LSQ',54.44,-37.2658055555556,NULL,NULL,'2012-09-19 09:42:23',56189.4044400002,19.2156,0.0895,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-22 19:45:26','2012-09-22 19:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_59300.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(1922,1820,0,'LSQ12fag','LSQ',25.370625,-29.6439722222222,NULL,NULL,'2012-09-19 05:29:26',56189.22878,20.9802,0.0664,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-22 19:45:26','2012-09-22 19:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_59268.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1923,1099,0,'LSQ12enb','LSQ',4.19716666666667,-0.644277777777778,NULL,NULL,'2012-09-22 04:30:56',56192.1881499998,18.7644,0.0608,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_history.html','agn?',NULL,0.06394,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12enb/LSQ12enb_snap_59501.gif',34371929527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537061398,8391584,NULL,NULL,NULL,NULL),(1924,1289,0,'LSQ12erc','LSQ',8.77075,1.48147222222222,NULL,NULL,'2012-09-22 04:48:25',56192.2003000001,19.7928,0.1332,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12erc/LSQ12erc_snap_59642.gif',66590313561,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1040473649,16257400,NULL,NULL,NULL,NULL),(1925,1295,0,'LSQ12era','LSQ',324.270333333333,0.478888888888889,NULL,NULL,'2012-09-22 02:28:25',56192.1030700002,18.4976,0.0627,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12era/LSQ12era_history.html','sne?',NULL,0.05021,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12era/LSQ12era_snap_59649.gif',52096398853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814006232,12718847,NULL,NULL,NULL,NULL),(1926,1297,0,'LSQ12eqy','LSQ',328.247541666667,0.566833333333333,NULL,NULL,'2012-09-22 00:43:52',56192.0304700001,19.8319,0.1384,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqy/LSQ12eqy_history.html','sne?',NULL,0.07381,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eqy/LSQ12eqy_snap_59643.gif',52178899046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,815295297,12738989,NULL,NULL,NULL,NULL),(1927,1451,0,'LSQ12euu','LSQ',322.784083333333,-6.70402777777778,NULL,NULL,'2012-09-22 00:42:10',56192.02929,19.7901,0.1754,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_snap_59506.gif',49683505270,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776304769,12129762,NULL,NULL,NULL,NULL),(1928,1451,0,'LSQ12euu','LSQ',322.784083333333,-6.70405555555556,NULL,NULL,'2012-09-22 03:03:38',56192.1275300002,19.9287,0.1989,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12euu/LSQ12euu_snap_59507.gif',49683505270,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776304769,12129762,NULL,NULL,NULL,NULL),(1929,1458,0,'LSQ12eui','LSQ',51.8567083333333,-11.5909444444444,NULL,NULL,'2012-09-22 07:33:57',56192.31525,19.3973,0.1452,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_snap_59552.gif',37886492397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591976443,9249631,NULL,NULL,NULL,NULL),(1930,1458,0,'LSQ12eui','LSQ',51.856875,-11.5908333333333,NULL,NULL,'2012-09-22 08:36:56',56192.3589900001,19.1743,0.1012,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_snap_59553.gif',37886492397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591976443,9249631,NULL,NULL,NULL,NULL),(1931,1460,0,'LSQ12eue','LSQ',38.879375,-7.49277777777778,NULL,NULL,'2012-09-22 07:58:22',56192.3322100001,18.8442,0.0672,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eue/LSQ12eue_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eue/LSQ12eue_snap_59517.gif',34938434364,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545913036,8529891,NULL,NULL,NULL,NULL),(1932,1616,0,'LSQ12evy','LSQ',25.09725,-29.7412222222222,NULL,NULL,'2012-09-22 02:11:19',56192.0912000001,22.1882,0.15,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_history.html','sn?',NULL,0.242061,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_snap_59563.gif',38265285488,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597895085,9342110,NULL,NULL,NULL,NULL),(1933,1618,0,'LSQ12evw','LSQ',28.8265833333333,-29.9608888888889,NULL,NULL,'2012-09-22 02:11:19',56192.0912000001,20.0444,0.132,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_59564.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1934,1618,0,'LSQ12evw','LSQ',28.8265416666667,-29.9608333333333,NULL,NULL,'2012-09-22 04:10:51',56192.1742099999,20.2498,0.105,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_59565.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1935,1808,0,'LSQ12fal','LSQ',21.8583333333333,-3.76277777777778,NULL,NULL,'2012-09-22 08:33:12',56192.3563999999,20.0393,0.1631,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_snap_59524.gif',35246476730,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,550726198,8605096,NULL,NULL,NULL,NULL),(1936,1816,0,'LSQ12fak','LSQ',56.3515833333333,-10.5703611111111,NULL,NULL,'2012-09-22 07:37:20',56192.3176000002,19.5125,0.1104,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_snap_59556.gif',37026669944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578541717,9039714,NULL,NULL,NULL,NULL),(1937,1816,0,'LSQ12fak','LSQ',56.3516666666667,-10.5703611111111,NULL,NULL,'2012-09-22 08:38:37',56192.3601600002,19.3978,0.1001,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_snap_59557.gif',37026669944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578541717,9039714,NULL,NULL,NULL,NULL),(1938,1820,0,'LSQ12fag','LSQ',25.3706666666667,-29.6440277777778,NULL,NULL,'2012-09-22 02:11:19',56192.0912000001,21.0971,0.0756,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_59558.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1939,1820,0,'LSQ12fag','LSQ',25.370625,-29.644,NULL,NULL,'2012-09-22 04:10:51',56192.1742099999,21.0649,0.0654,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_59559.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1940,1906,0,'LSQ12fck','LSQ',13.7215,-0.986222222222222,NULL,NULL,'2012-09-22 07:02:22',56192.2933200002,18.3242,0.0935,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fck/LSQ12fck_history.html','old sne',NULL,0.14663,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fck/LSQ12fck_snap_59598.gif',34525395353,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539459302,8429051,NULL,NULL,NULL,NULL),(1941,1908,0,'LSQ12fch','LSQ',324.576833333333,-4.00633333333333,NULL,NULL,'2012-09-22 00:42:10',56192.02929,19.7724,0.112,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_history.html','faint brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_snap_59599.gif',49706541067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776664704,12135386,NULL,NULL,NULL,NULL),(1942,1908,0,'LSQ12fch','LSQ',324.576791666667,-4.00638888888889,NULL,NULL,'2012-09-22 03:03:38',56192.1275300002,19.9164,0.1283,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 08:45:27','2012-09-23 08:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_history.html','faint brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_snap_59600.gif',49706541067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776664704,12135386,NULL,NULL,NULL,NULL),(1943,1295,0,'LSQ12era','LSQ',324.269916666667,0.478666666666667,NULL,NULL,'2012-09-22 00:17:38',56192.0122500001,19.4695,0.1211,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 12:45:26','2012-09-23 12:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12era/LSQ12era_history.html','sne?',NULL,0.05021,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12era/LSQ12era_snap_59761.gif',52096398853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,814006232,12718847,NULL,NULL,NULL,NULL),(1944,1908,0,'LSQ12fch','LSQ',324.576916666667,-4.00636111111111,NULL,NULL,'2012-09-22 00:40:28',56192.0281099998,19.6994,0.142,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2012-09-23 18:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_history.html','faint brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_snap_59806.gif',49706541067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776664704,12135386,NULL,NULL,NULL,NULL),(1945,1908,0,'LSQ12fch','LSQ',324.576916666667,-4.00630555555556,NULL,NULL,'2012-09-22 03:01:56',56192.12635,19.8662,0.1393,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2012-09-23 18:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_history.html','faint brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_snap_59807.gif',49706541067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776664704,12135386,NULL,NULL,NULL,NULL),(1946,1946,1,'LSQ12feq','LSQ',318.16,0.534611111111111,NULL,NULL,'2012-09-11 23:47:40',56181.99144,19.826,0.1728,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feq/LSQ12feq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feq/LSQ12feq_snap_59956.gif',52091264094,NULL,NULL,NULL,'2012-09-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,813926001,12717593,NULL,NULL,NULL,NULL),(1947,1946,0,'LSQ12feq','LSQ',318.160041666667,0.534611111111111,NULL,NULL,'2012-09-12 01:55:48',56182.08042,20.1272,0.154,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2012-09-23 18:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feq/LSQ12feq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feq/LSQ12feq_snap_59957.gif',52091264094,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,813926001,12717593,NULL,NULL,NULL,NULL),(1948,1946,0,'LSQ12feq','LSQ',318.160041666667,0.534666666666667,NULL,NULL,'2012-09-15 23:49:25',56185.99266,19.9911,0.1915,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2012-09-23 18:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feq/LSQ12feq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feq/LSQ12feq_snap_59958.gif',52091264094,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,813926001,12717593,NULL,NULL,NULL,NULL),(1949,1946,0,'LSQ12feq','LSQ',318.160083333333,0.534583333333333,NULL,NULL,'2012-09-16 02:00:18',56186.0835500001,19.5861,0.1744,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2012-09-23 18:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feq/LSQ12feq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feq/LSQ12feq_snap_59959.gif',52091264094,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,813926001,12717593,NULL,NULL,NULL,NULL),(1950,1946,0,'LSQ12feq','LSQ',318.160041666667,0.534666666666667,NULL,NULL,'2012-09-21 23:56:56',56191.9978800002,18.9051,0.14,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2012-09-23 18:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feq/LSQ12feq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feq/LSQ12feq_snap_59925.gif',52091264094,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,813926001,12717593,NULL,NULL,NULL,NULL),(1951,1946,0,'LSQ12feq','LSQ',318.16,0.534722222222222,NULL,NULL,'2012-09-22 01:56:46',56192.08109,19.6807,0.1489,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2012-09-23 18:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feq/LSQ12feq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feq/LSQ12feq_snap_59926.gif',52091264094,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,813926001,12717593,NULL,NULL,NULL,NULL),(1952,1952,1,'LSQ12feo','LSQ',7.691,-0.538777777777778,NULL,NULL,'2012-08-28 09:35:40',56167.39977,19.5736,0.1802,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feo/LSQ12feo_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feo/LSQ12feo_snap_59948.gif',34400497202,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537507768,8398558,NULL,NULL,NULL,NULL),(1953,1952,0,'LSQ12feo','LSQ',7.69108333333333,-0.538722222222222,NULL,NULL,'2012-09-16 05:10:57',56186.21594,18.5791,0.1014,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2012-09-23 18:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feo/LSQ12feo_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feo/LSQ12feo_snap_59949.gif',34400497202,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537507768,8398558,NULL,NULL,NULL,NULL),(1954,1952,0,'LSQ12feo','LSQ',7.69133333333333,-0.538611111111111,NULL,NULL,'2012-09-22 04:46:43',56192.19912,16.8397,0.0711,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2012-09-23 18:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feo/LSQ12feo_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feo/LSQ12feo_snap_59921.gif',34400497202,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537507768,8398558,NULL,NULL,NULL,NULL),(1955,1952,0,'LSQ12feo','LSQ',7.69120833333333,-0.53875,NULL,NULL,'2012-09-22 07:26:36',56192.3101499998,18.6002,0.1397,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2012-09-23 18:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feo/LSQ12feo_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feo/LSQ12feo_snap_59922.gif',34400497202,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,537507768,8398558,NULL,NULL,NULL,NULL),(1956,1956,1,'LSQ12fem','LSQ',5.01625,-0.500138888888889,NULL,NULL,'2012-08-26 09:10:30',56165.3823000002,19.2104,0.1258,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fem/LSQ12fem_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fem/LSQ12fem_snap_59943.gif',34368320120,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,537005001,8390703,NULL,NULL,NULL,NULL),(1957,1956,0,'LSQ12fem','LSQ',5.016375,-0.500055555555556,NULL,NULL,'2012-09-22 04:32:38',56192.18933,17.081,0.0804,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2012-09-23 18:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fem/LSQ12fem_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fem/LSQ12fem_snap_59917.gif',34368320120,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,537005001,8390703,NULL,NULL,NULL,NULL),(1958,1956,0,'LSQ12fem','LSQ',5.01645833333333,-0.500027777777778,NULL,NULL,'2012-09-22 06:32:49',56192.2727899998,15.2131,0.0587,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2012-09-23 18:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fem/LSQ12fem_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fem/LSQ12fem_snap_59918.gif',34368320120,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,537005001,8390703,NULL,NULL,NULL,NULL),(1959,1959,1,'LSQ12feh','LSQ',314.582583333333,-6.29713888888889,NULL,NULL,'2012-09-10 01:44:53',56180.07284,20.5646,0.1271,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feh/LSQ12feh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feh/LSQ12feh_snap_59908.gif',50795139950,NULL,NULL,NULL,'2012-09-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,793674061,12401157,NULL,NULL,NULL,NULL),(1960,1959,0,'LSQ12feh','LSQ',314.582375,-6.29677777777778,NULL,NULL,'2012-09-21 23:55:14',56191.9967,19.856,0.118,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2012-09-23 18:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feh/LSQ12feh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feh/LSQ12feh_snap_59804.gif',50795139950,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,793674061,12401157,NULL,NULL,NULL,NULL),(1961,1959,0,'LSQ12feh','LSQ',314.582375,-6.29680555555556,NULL,NULL,'2012-09-22 01:55:04',56192.0799099999,19.831,0.1086,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2012-09-23 18:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feh/LSQ12feh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feh/LSQ12feh_snap_59805.gif',50795139950,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,793674061,12401157,NULL,NULL,NULL,NULL),(1962,1962,1,'LSQ12fdx','LSQ',40.149375,-9.437,NULL,NULL,'2012-09-12 08:51:16',56182.36894,20.5249,0.2035,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_history.html','sn?',NULL,1.925,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_snap_59838.gif',37880582031,NULL,NULL,NULL,'2012-09-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,591884094,9248188,NULL,NULL,NULL,NULL),(1963,1962,0,'LSQ12fdx','LSQ',40.1494166666667,-9.43697222222222,NULL,NULL,'2012-09-22 06:18:20',56192.2627400002,19.2009,0.1271,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2012-09-23 18:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_history.html','sn?',NULL,1.925,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_snap_59784.gif',37880582031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,591884094,9248188,NULL,NULL,NULL,NULL),(1964,1962,0,'LSQ12fdx','LSQ',40.1493333333333,-9.43719444444445,NULL,NULL,'2012-09-22 08:08:31',56192.3392500002,18.0936,0.0815,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-23 18:45:28','2012-09-23 18:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_history.html','sn?',NULL,1.925,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_snap_59785.gif',37880582031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,591884094,9248188,NULL,NULL,NULL,NULL),(1965,1965,0,'PSNJ19065165-6142163','TOCP',286.71454,-61.70489,NULL,NULL,'2012-09-24 00:00:00',56194,20.5,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-09-23 19:02:26','2019-10-12 20:41:36','NULL','supernova',NULL,0,NULL,NULL,'NULL',NULL,NULL,48946256384,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,764785256,11949769,NULL,NULL,NULL,NULL),(1966,1965,0,'PSNJ19065165-6142163','pessto',286.71454,-61.70489,NULL,NULL,'2012-09-24 00:00:00',56194,NULL,NULL,NULL,0.03,NULL,'Ia',NULL,'2012-09-24 01:38:49','2012-09-24 01:38:49','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,48946256384,'NTT','EFOSC','Yen Chen Pan',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,764785256,11949769,NULL,NULL,NULL,NULL),(1967,1205,0,'LSQ12eoc','LSQ',317.2835,-22.2570277777778,NULL,NULL,'2012-09-23 01:39:16',56193.0689400001,19.5902,0.1777,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-24 01:45:28','2012-09-24 01:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eoc/LSQ12eoc_snap_60003.gif',50904231018,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,795378609,12427790,NULL,NULL,NULL,NULL),(1968,1557,0,'LSQ12evn','LSQ',311.892708333333,-17.1578611111111,NULL,NULL,'2012-09-23 00:49:06',56193.0340999998,18.8827,0.074,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-24 01:45:28','2012-09-24 01:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_59977.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1969,1557,0,'LSQ12evn','LSQ',311.89275,-17.158,NULL,NULL,'2012-09-23 03:00:30',56193.1253499999,18.9689,0.0761,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-24 01:45:28','2012-09-24 01:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_59978.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(1970,1616,0,'LSQ12evy','LSQ',25.09725,-29.7408888888889,NULL,NULL,'2012-09-23 02:10:38',56193.0907200002,22.0073,0.1834,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-24 01:45:28','2012-09-24 01:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_history.html','sn?',NULL,0.242061,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evy/LSQ12evy_snap_59989.gif',38265285480,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,597895085,9342110,NULL,NULL,NULL,NULL),(1971,1618,0,'LSQ12evw','LSQ',28.8264166666667,-29.9607777777778,NULL,NULL,'2012-09-23 02:10:38',56193.0907200002,20.334,0.1681,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-24 01:45:28','2012-09-24 01:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_59990.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1972,1618,0,'LSQ12evw','LSQ',28.8265,-29.9609166666667,NULL,NULL,'2012-09-23 04:12:30',56193.1753500002,20.3563,0.1467,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-24 01:45:28','2012-09-24 01:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_59991.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1973,1618,0,'LSQ12evw','LSQ',28.8264166666667,-29.9608888888889,NULL,NULL,'2012-09-23 06:14:22',56193.2599800001,20.258,0.1301,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-24 01:45:28','2012-09-24 01:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evw/LSQ12evw_snap_59992.gif',38262027470,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597844179,9341315,NULL,NULL,NULL,NULL),(1974,1725,0,'LSQ12ezs','LSQ',310.557666666667,-21.6615277777778,NULL,NULL,'2012-09-23 01:13:14',56193.0508599998,19.3462,0.1182,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-24 01:45:28','2012-09-24 01:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_snap_59972.gif',50825557717,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794149339,12408583,NULL,NULL,NULL,NULL),(1975,1735,0,'LSQ12ezn','LSQ',54.4399583333333,-37.26575,NULL,NULL,'2012-09-23 06:21:35',56193.2649900001,19.3573,0.0695,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-24 01:45:28','2012-09-24 01:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_60027.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(1976,1735,0,'LSQ12ezn','LSQ',54.44,-37.2657777777778,NULL,NULL,'2012-09-23 08:06:33',56193.3378900001,19.2667,0.088,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-24 01:45:28','2012-09-24 01:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_60028.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(1977,1820,0,'LSQ12fag','LSQ',25.370625,-29.6440277777778,NULL,NULL,'2012-09-23 02:10:38',56193.0907200002,21.2541,0.0881,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-24 01:45:28','2012-09-24 01:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_59974.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1978,1820,0,'LSQ12fag','LSQ',25.3706666666667,-29.644,NULL,NULL,'2012-09-23 04:12:30',56193.1753500002,21.2608,0.1011,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-24 01:45:28','2012-09-24 01:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_59975.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1979,1820,0,'LSQ12fag','LSQ',25.3707083333333,-29.644,NULL,NULL,'2012-09-23 06:14:22',56193.2599800001,21.0523,0.0709,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-24 01:45:28','2012-09-24 01:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_59976.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(1980,1725,0,'LSQ12ezs','pessto',310.557625,-21.6615833333,NULL,NULL,'2012-09-24 00:00:00',56194,NULL,NULL,NULL,0.1,NULL,'Ia',NULL,'2012-09-24 02:30:04','2012-09-24 02:30:04','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50825557719,'NTT','EFOSC','Yen Chen Pan',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794149339,12408583,NULL,NULL,NULL,NULL),(1981,1908,0,'LSQ12fch','pessto',324.576791667,-4.00636111111,NULL,NULL,'2012-09-24 00:00:00',56194,NULL,NULL,NULL,0.17,NULL,'Ia',NULL,'2012-09-24 04:26:13','2012-09-24 04:26:13','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,49706541067,'NTT','EFOSC','Yen Chen Pan',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776664704,12135386,NULL,NULL,NULL,NULL),(1982,1709,0,'LSQ12ezm','pessto',334.361625,-1.87375,NULL,NULL,'2012-09-24 00:00:00',56194,NULL,NULL,NULL,0.11,NULL,'Ia',NULL,'2012-09-24 06:24:21','2012-09-24 06:24:21','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,49800495953,'NTT','EFOSC','Yen Chen Pan',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,778132749,12158324,NULL,NULL,NULL,NULL),(1983,1720,0,'LSQ12ezu','pessto',355.0765,-21.1558888889,NULL,NULL,'2012-09-24 00:00:00',56194,NULL,NULL,NULL,0.12,NULL,'Ia',NULL,'2012-09-24 10:19:00','2012-09-24 10:19:00','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50277624863,'NTT','EFOSC','Yen Chen Pan',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785587888,12274810,NULL,NULL,NULL,NULL),(1984,1962,0,'LSQ12fdx','pessto',40.149375,-9.437,NULL,NULL,'2012-09-24 00:00:00',56194,NULL,NULL,NULL,1.95,NULL,'AGN',NULL,'2012-09-24 11:04:08','2012-09-24 11:04:08','NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37880582031,'NTT','EFOSC','Yen Chen Pan',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,591884094,9248188,NULL,NULL,NULL,NULL),(1985,1454,0,'LSQ12eus','LSQ',335.192333333333,0.522555555555556,NULL,NULL,'2012-09-24 04:14:00',56194.1763900002,19.4618,0.115,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 06:45:24','2012-09-27 06:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eus/LSQ12eus_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eus/LSQ12eus_snap_60255.gif',52145877361,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,814779333,12730927,NULL,NULL,NULL,NULL),(1986,1458,0,'LSQ12eui','LSQ',51.8569583333333,-11.5908611111111,NULL,NULL,'2012-09-24 08:45:54',56194.36521,18.9994,0.1611,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 06:45:24','2012-09-27 06:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_snap_60251.gif',37886492397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591976443,9249631,NULL,NULL,NULL,NULL),(1987,1458,0,'LSQ12eui','LSQ',51.8567083333333,-11.5906666666667,NULL,NULL,'2012-09-24 09:33:25',56194.3982099998,18.7427,0.1629,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 06:45:24','2012-09-27 06:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_snap_60252.gif',37886492397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591976443,9249631,NULL,NULL,NULL,NULL),(1988,1460,0,'LSQ12eue','LSQ',38.8794166666667,-7.49272222222222,NULL,NULL,'2012-09-24 08:33:58',56194.3569299998,19.0136,0.0735,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 06:45:24','2012-09-27 06:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eue/LSQ12eue_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eue/LSQ12eue_snap_60219.gif',34938434364,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545913036,8529891,NULL,NULL,NULL,NULL),(1989,1709,0,'LSQ12ezm','LSQ',334.36175,-1.87372222222222,NULL,NULL,'2012-09-24 04:12:18',56194.17521,18.826,0.2014,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 06:45:24','2012-09-27 06:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezm/LSQ12ezm_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezm/LSQ12ezm_snap_60330.gif',49800495953,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,778132749,12158324,NULL,NULL,NULL,NULL),(1990,1808,0,'LSQ12fal','LSQ',21.858375,-3.76283333333333,NULL,NULL,'2012-09-24 09:01:42',56194.3761900002,20.3518,0.1748,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 06:45:24','2012-09-27 06:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_snap_60225.gif',35246476730,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,550726198,8605096,NULL,NULL,NULL,NULL),(1991,1816,0,'LSQ12fak','LSQ',56.351625,-10.5704166666667,NULL,NULL,'2012-09-24 08:49:17',56194.3675600002,19.384,0.1395,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 06:45:24','2012-09-27 06:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_snap_60256.gif',37026669944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578541717,9039714,NULL,NULL,NULL,NULL),(1992,1816,0,'LSQ12fak','LSQ',56.3517083333333,-10.5703611111111,NULL,NULL,'2012-09-24 09:13:43',56194.3845299999,19.5137,0.1789,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 06:45:24','2012-09-27 06:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_snap_60257.gif',37026669944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578541717,9039714,NULL,NULL,NULL,NULL),(1993,1908,0,'LSQ12fch','LSQ',324.576916666667,-4.00627777777778,NULL,NULL,'2012-09-24 00:44:40',56194.0310200001,19.3202,0.1263,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 06:45:24','2012-09-27 06:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_history.html','faint brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_snap_60298.gif',49706541067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776664704,12135386,NULL,NULL,NULL,NULL),(1994,1908,0,'LSQ12fch','LSQ',324.576833333333,-4.00630555555556,NULL,NULL,'2012-09-24 00:46:21',56194.0321900002,19.4894,0.1479,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 06:45:24','2012-09-27 06:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_history.html','faint brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_snap_60300.gif',49706541067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776664704,12135386,NULL,NULL,NULL,NULL),(1995,1908,0,'LSQ12fch','LSQ',324.576875,-4.00625,NULL,NULL,'2012-09-24 02:46:57',56194.1159399999,19.5724,0.1267,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 06:45:24','2012-09-27 06:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_history.html','faint brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_snap_60299.gif',49706541067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776664704,12135386,NULL,NULL,NULL,NULL),(1996,1908,0,'LSQ12fch','LSQ',324.576833333333,-4.00630555555556,NULL,NULL,'2012-09-24 02:48:40',56194.1171300001,19.7392,0.2059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 06:45:24','2012-09-27 06:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_history.html','faint brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_snap_60301.gif',49706541067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776664704,12135386,NULL,NULL,NULL,NULL),(1997,1946,0,'LSQ12feq','LSQ',318.160041666667,0.534666666666667,NULL,NULL,'2012-09-24 01:59:37',56194.0830700002,19.2764,0.177,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 06:45:24','2012-09-27 06:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feq/LSQ12feq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12feq/LSQ12feq_snap_60372.gif',52091264094,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,813926001,12717593,NULL,NULL,NULL,NULL),(1998,1956,0,'LSQ12fem','LSQ',5.01670833333333,-0.500083333333333,NULL,NULL,'2012-09-24 06:28:22',56194.2697100001,16.5731,0.0912,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 06:45:24','2012-09-27 06:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fem/LSQ12fem_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fem/LSQ12fem_snap_60373.gif',34368320120,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,537005001,8390703,NULL,NULL,NULL,NULL),(1999,1962,0,'LSQ12fdx','LSQ',40.1494166666667,-9.43711111111111,NULL,NULL,'2012-09-24 06:05:29',56194.2538100001,19.1105,0.1235,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 06:45:24','2012-09-27 06:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_history.html','sn?',NULL,1.925,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_snap_60369.gif',37880582031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,591884094,9248188,NULL,NULL,NULL,NULL),(2000,2000,1,'LSQ12ffj','LSQ',318.925166666667,-4.90455555555556,NULL,NULL,'2012-09-22 02:26:44',56192.1019000001,20.3181,0.1575,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 16:45:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffj/LSQ12ffj_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffj/LSQ12ffj_snap_60500.gif',49665570238,NULL,NULL,NULL,'2012-09-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776024534,12125383,NULL,NULL,NULL,NULL);
INSERT INTO `transientBucket` VALUES (2001,2000,0,'LSQ12ffj','LSQ',318.92525,-4.90461111111111,NULL,NULL,'2012-09-24 00:18:36',56194.0129200001,19.8512,0.1571,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 16:45:19','2012-09-27 16:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffj/LSQ12ffj_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffj/LSQ12ffj_snap_60492.gif',49665570225,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776024534,12125383,NULL,NULL,NULL,NULL),(2002,2000,0,'LSQ12ffj','LSQ',318.925125,-4.90455555555556,NULL,NULL,'2012-09-24 02:21:01',56194.0979300002,19.4442,0.1582,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-27 16:45:19','2012-09-27 16:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffj/LSQ12ffj_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffj/LSQ12ffj_snap_60493.gif',49665570238,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776024534,12125383,NULL,NULL,NULL,NULL),(2003,1430,0,'LSQ12eve','LSQ',328.319208333333,-21.7153333333333,NULL,NULL,'2012-09-25 01:26:56',56195.0603800002,20.0928,0.2165,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 00:45:19','2012-09-29 00:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eve/LSQ12eve_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eve/LSQ12eve_snap_60523.gif',50881668328,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795026067,12422282,NULL,NULL,NULL,NULL),(2004,1566,0,'LSQ12evm','LSQ',336.765625,-23.6769444444444,NULL,NULL,'2012-09-25 01:52:58',56195.0784499999,18.5282,0.0763,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 00:45:19','2012-09-29 00:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evm/LSQ12evm_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evm/LSQ12evm_snap_60527.gif',50212210897,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784565795,12258840,NULL,NULL,NULL,NULL),(2005,1566,0,'LSQ12evm','LSQ',336.765666666667,-23.6769722222222,NULL,NULL,'2012-09-25 04:04:26',56195.1697499999,18.6114,0.0755,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 00:45:19','2012-09-29 00:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evm/LSQ12evm_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evm/LSQ12evm_snap_60528.gif',50212210897,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784565795,12258840,NULL,NULL,NULL,NULL),(2006,1735,0,'LSQ12ezn','LSQ',54.4398333333333,-37.26575,NULL,NULL,'2012-09-25 05:30:16',56195.2293600002,19.2147,0.0797,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 00:45:19','2012-09-29 00:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_60548.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(2007,1735,0,'LSQ12ezn','LSQ',54.439875,-37.26575,NULL,NULL,'2012-09-25 07:29:40',56195.3122700001,19.2402,0.0558,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 00:45:19','2012-09-29 00:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_60549.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(2008,1454,0,'LSQ12eus','LSQ',335.191958333333,0.522638888888889,NULL,NULL,'2012-09-26 01:05:13',56196.0452899998,18.0788,0.0799,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 07:45:25','2012-09-29 07:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eus/LSQ12eus_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eus/LSQ12eus_snap_60717.gif',52145877352,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,814779333,12730927,NULL,NULL,NULL,NULL),(2009,1458,0,'LSQ12eui','LSQ',51.8568333333333,-11.5908333333333,NULL,NULL,'2012-09-26 05:33:12',56196.2313999999,18.8387,0.1374,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 07:45:25','2012-09-29 07:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_snap_60715.gif',37886492397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591976443,9249631,NULL,NULL,NULL,NULL),(2010,1458,0,'LSQ12eui','LSQ',51.856625,-11.5908888888889,NULL,NULL,'2012-09-26 07:34:22',56196.3155399999,19.1389,0.1926,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 07:45:25','2012-09-29 07:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eui/LSQ12eui_snap_60716.gif',37886492397,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591976443,9249631,NULL,NULL,NULL,NULL),(2011,1460,0,'LSQ12eue','LSQ',38.8794583333333,-7.49275,NULL,NULL,'2012-09-26 05:19:41',56196.2220100001,18.9334,0.0765,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 07:45:25','2012-09-29 07:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eue/LSQ12eue_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eue/LSQ12eue_snap_60672.gif',34938434364,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545913036,8529891,NULL,NULL,NULL,NULL),(2012,1460,0,'LSQ12eue','LSQ',38.87925,-7.49277777777778,NULL,NULL,'2012-09-26 07:20:48',56196.3061199998,19.1626,0.0848,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 07:45:25','2012-09-29 07:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eue/LSQ12eue_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eue/LSQ12eue_snap_60673.gif',34938434364,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545913036,8529891,NULL,NULL,NULL,NULL),(2013,1709,0,'LSQ12ezm','LSQ',334.361625,-1.87383333333333,NULL,NULL,'2012-09-26 01:03:31',56196.0441200002,19.2805,0.1578,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 07:45:25','2012-09-29 07:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezm/LSQ12ezm_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezm/LSQ12ezm_snap_60775.gif',49800495953,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,778132749,12158324,NULL,NULL,NULL,NULL),(2014,1709,0,'LSQ12ezm','LSQ',334.361791666667,-1.87375,NULL,NULL,'2012-09-26 03:08:02',56196.1305900002,19.3881,0.1657,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 07:45:25','2012-09-29 07:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezm/LSQ12ezm_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezm/LSQ12ezm_snap_60776.gif',49800495953,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,778132749,12158324,NULL,NULL,NULL,NULL),(2015,1713,0,'LSQ12ezk','LSQ',11.2835833333333,0.354638888888889,NULL,NULL,'2012-09-26 07:59:47',56196.3331900002,19.8298,0.1498,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 07:45:25','2012-09-29 07:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezk/LSQ12ezk_history.html','sn??',NULL,0.06548,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezk/LSQ12ezk_snap_60773.gif',66672869557,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041763586,16277556,NULL,NULL,NULL,NULL),(2016,1808,0,'LSQ12fal','LSQ',21.8583333333333,-3.76286111111111,NULL,NULL,'2012-09-26 07:00:08',56196.29177,19.7259,0.1303,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 07:45:25','2012-09-29 07:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_snap_60679.gif',35246476730,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,550726198,8605096,NULL,NULL,NULL,NULL),(2017,1816,0,'LSQ12fak','LSQ',56.3516666666667,-10.5703055555556,NULL,NULL,'2012-09-26 05:36:36',56196.2337500001,19.8053,0.1399,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 07:45:25','2012-09-29 07:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_snap_60710.gif',37026669944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578541717,9039714,NULL,NULL,NULL,NULL),(2018,1816,0,'LSQ12fak','LSQ',56.3516666666667,-10.5703333333333,NULL,NULL,'2012-09-26 07:50:38',56196.3268300002,19.6086,0.127,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 07:45:25','2012-09-29 07:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_snap_60711.gif',37026669944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578541717,9039714,NULL,NULL,NULL,NULL),(2019,1913,0,'LSQ12fbz','LSQ',31.9909583333333,-6.09369444444444,NULL,NULL,'2012-09-26 08:46:01',56196.3653000002,19.3771,0.0782,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 07:45:25','2012-09-29 07:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbz/LSQ12fbz_history.html','old sne',NULL,0.071686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbz/LSQ12fbz_snap_60771.gif',35154560675,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549290010,8582656,NULL,NULL,NULL,NULL),(2020,1962,0,'LSQ12fdx','LSQ',40.149375,-9.43716666666667,NULL,NULL,'2012-09-26 07:22:30',56196.3073,20.5643,0.2096,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 07:45:25','2012-09-29 07:45:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_history.html','sn?',NULL,1.925,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_snap_60841.gif',37880582031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,591884094,9248188,NULL,NULL,NULL,NULL),(2021,2021,1,'LSQ12ffm','LSQ',78.9939166666667,8.74283333333333,NULL,NULL,'2012-09-19 06:58:43',56189.2907799999,19.944,0.0956,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffm/LSQ12ffm_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffm/LSQ12ffm_snap_60509.gif',64640634086,NULL,NULL,NULL,'2012-01-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,1010009907,15781404,NULL,NULL,NULL,NULL),(2022,2021,0,'LSQ12ffm','LSQ',78.9938333333333,8.74277777777778,NULL,NULL,'2012-09-19 07:02:23',56189.2933299998,19.944,0.0873,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2012-09-29 19:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffm/LSQ12ffm_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffm/LSQ12ffm_snap_60510.gif',64640634087,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,1010009907,15781404,NULL,NULL,NULL,NULL),(2023,2021,0,'LSQ12ffm','LSQ',78.9939583333333,8.74275,NULL,NULL,'2012-09-24 06:36:11',56194.27513,20.0836,0.0899,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2012-09-29 19:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffm/LSQ12ffm_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffm/LSQ12ffm_snap_60498.gif',64640634086,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,1010009907,15781404,NULL,NULL,NULL,NULL),(2024,2021,0,'LSQ12ffm','LSQ',78.993875,8.74275,NULL,NULL,'2012-09-24 06:56:31',56194.2892499999,19.7571,0.103,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2012-09-29 19:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffm/LSQ12ffm_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffm/LSQ12ffm_snap_60499.gif',64640634086,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,1010009907,15781404,NULL,NULL,NULL,NULL),(2025,2025,1,'LSQ12ffo','LSQ',330.44,-22.2058333333333,NULL,NULL,'2012-09-03 04:06:17',56173.1710399999,18.6642,0.1243,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffo/LSQ12ffo_history.html','sne - nice',NULL,0.065395,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffo/LSQ12ffo_snap_61003.gif',50869971912,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794843311,12419426,NULL,NULL,NULL,NULL),(2026,2025,0,'LSQ12ffo','LSQ',330.439916666667,-22.2059166666667,NULL,NULL,'2012-09-03 06:06:13',56173.2543199998,18.6135,0.1511,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2012-09-29 19:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffo/LSQ12ffo_history.html','sne - nice',NULL,0.065395,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffo/LSQ12ffo_snap_61004.gif',50869971912,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794843311,12419426,NULL,NULL,NULL,NULL),(2027,2025,0,'LSQ12ffo','LSQ',330.440125,-22.2059444444444,NULL,NULL,'2012-09-25 01:26:56',56195.0603800002,16.6933,0.0468,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2012-09-29 19:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffo/LSQ12ffo_history.html','sne - nice',NULL,0.065395,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffo/LSQ12ffo_snap_60998.gif',50869971912,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794843311,12419426,NULL,NULL,NULL,NULL),(2028,2025,0,'LSQ12ffo','LSQ',330.440041666667,-22.2058611111111,NULL,NULL,'2012-09-25 03:37:50',56195.1512799999,16.6563,0.0391,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2012-09-29 19:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffo/LSQ12ffo_history.html','sne - nice',NULL,0.065395,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffo/LSQ12ffo_snap_60999.gif',50869971912,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794843311,12419426,NULL,NULL,NULL,NULL),(2029,2029,1,'LSQ12ffn','LSQ',320.646875,-20.6636111111111,NULL,NULL,'2012-09-09 00:55:16',56179.0383899999,19.126,0.0966,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_snap_61000.gif',50912843629,NULL,NULL,NULL,'2012-09-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795513181,12429893,NULL,NULL,NULL,NULL),(2030,2029,0,'LSQ12ffn','LSQ',320.646583333333,-20.6633888888889,NULL,NULL,'2012-09-15 00:52:55',56185.03675,19.7207,0.1141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2012-09-29 19:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_snap_61001.gif',50912843625,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795513181,12429893,NULL,NULL,NULL,NULL),(2031,2029,0,'LSQ12ffn','LSQ',320.646166666667,-20.6635555555556,NULL,NULL,'2012-09-17 00:53:52',56187.0374099999,18.6868,0.0519,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2012-09-29 19:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_snap_61002.gif',50912843625,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795513181,12429893,NULL,NULL,NULL,NULL),(2032,2029,0,'LSQ12ffn','LSQ',320.646416666667,-20.6635277777778,NULL,NULL,'2012-09-25 00:31:07',56195.0216100002,18.0219,0.1025,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2012-09-29 19:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_snap_60996.gif',50912843625,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795513181,12429893,NULL,NULL,NULL,NULL),(2033,2029,0,'LSQ12ffn','LSQ',320.646291666667,-20.6634444444444,NULL,NULL,'2012-09-25 02:37:53',56195.10965,18.5145,0.1226,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2012-09-29 19:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_snap_60997.gif',50912843625,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795513181,12429893,NULL,NULL,NULL,NULL),(2034,2034,1,'LSQ12ffp','LSQ',348.376375,-6.23963888888889,NULL,NULL,'2012-08-30 02:30:02',56169.1041899999,19.0069,0.1932,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffp/LSQ12ffp_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffp/LSQ12ffp_snap_61011.gif',49480390113,NULL,NULL,NULL,'2012-08-28 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773131095,12080173,NULL,NULL,NULL,NULL),(2035,2034,0,'LSQ12ffp','LSQ',348.376125,-6.23977777777778,NULL,NULL,'2012-09-14 03:57:17',56184.1647899998,19.1151,0.0629,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2012-09-29 19:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffp/LSQ12ffp_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffp/LSQ12ffp_snap_61012.gif',49480389986,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773131093,12080173,NULL,NULL,NULL,NULL),(2036,2034,0,'LSQ12ffp','LSQ',348.376166666667,-6.23977777777778,NULL,NULL,'2012-09-14 05:58:43',56184.2491100002,19.2909,0.07,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2012-09-29 19:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffp/LSQ12ffp_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffp/LSQ12ffp_snap_61013.gif',49480389986,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773131093,12080173,NULL,NULL,NULL,NULL),(2037,2034,0,'LSQ12ffp','LSQ',348.375875,-6.23977777777778,NULL,NULL,'2012-09-26 01:45:12',56196.0730599998,19.2863,0.1138,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2012-09-29 19:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffp/LSQ12ffp_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffp/LSQ12ffp_snap_61005.gif',49480389986,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773131093,12080173,NULL,NULL,NULL,NULL),(2038,2034,0,'LSQ12ffp','LSQ',348.375916666667,-6.23977777777778,NULL,NULL,'2012-09-26 03:49:26',56196.1593399998,19.3486,0.1219,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-29 19:45:21','2012-09-29 19:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffp/LSQ12ffp_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffp/LSQ12ffp_snap_61006.gif',49480389986,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,773131093,12080173,NULL,NULL,NULL,NULL),(2039,1426,0,'LSQ12evf','LSQ',335.365541666667,-24.5855277777778,NULL,NULL,'2012-09-30 04:31:01',56200.1882099998,19.4454,0.1708,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 20:45:20','2012-09-30 20:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evf/LSQ12evf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evf/LSQ12evf_snap_61036.gif',50066844723,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782294448,12223350,NULL,NULL,NULL,NULL),(2040,1566,0,'LSQ12evm','LSQ',336.765625,-23.6769722222222,NULL,NULL,'2012-09-30 02:50:20',56200.1182900001,18.4369,0.0884,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 20:45:20','2012-09-30 20:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evm/LSQ12evm_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evm/LSQ12evm_snap_61038.gif',50212210897,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784565795,12258840,NULL,NULL,NULL,NULL),(2041,1566,0,'LSQ12evm','LSQ',336.765708333333,-23.6769444444444,NULL,NULL,'2012-09-30 04:49:43',56200.2012,18.6596,0.1069,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 20:45:20','2012-09-30 20:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evm/LSQ12evm_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evm/LSQ12evm_snap_61039.gif',50212210897,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784565795,12258840,NULL,NULL,NULL,NULL),(2042,1735,0,'LSQ12ezn','LSQ',54.4397916666667,-37.2657222222222,NULL,NULL,'2012-09-30 06:29:51',56200.27073,19.3294,0.1083,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 20:45:20','2012-09-30 20:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_61047.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(2043,1735,0,'LSQ12ezn','LSQ',54.4399583333333,-37.2657222222222,NULL,NULL,'2012-09-30 07:59:01',56200.3326599998,19.7147,0.1364,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 20:45:20','2012-09-30 20:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_61048.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(2044,2044,1,'LSQ12ffx','LSQ',335.201041666667,-20.6737222222222,NULL,NULL,'2012-07-01 04:15:31',56109.1774499998,18.6663,0.2097,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_snap_61105.gif',50207229407,NULL,NULL,NULL,'2012-06-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784487959,12257624,NULL,NULL,NULL,NULL),(2045,2044,0,'LSQ12ffx','LSQ',335.201,-20.6738055555556,NULL,NULL,'2012-09-03 06:14:43',56173.2602200001,17.0872,0.1057,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_snap_61106.gif',50207229407,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784487959,12257624,NULL,NULL,NULL,NULL),(2046,2044,0,'LSQ12ffx','LSQ',335.200833333333,-20.6737222222222,NULL,NULL,'2012-09-05 05:48:27',56175.24199,19.3432,0.1868,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_snap_61107.gif',50207229407,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784487959,12257624,NULL,NULL,NULL,NULL),(2047,2044,0,'LSQ12ffx','LSQ',335.200875,-20.6736666666667,NULL,NULL,'2012-09-30 02:34:54',56200.1075800001,18.3354,0.1226,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_snap_61088.gif',50207229407,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784487959,12257624,NULL,NULL,NULL,NULL),(2048,2044,0,'LSQ12ffx','LSQ',335.200875,-20.6736111111111,NULL,NULL,'2012-09-30 04:34:24',56200.19056,18.5009,0.1162,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_snap_61089.gif',50207229407,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784487959,12257624,NULL,NULL,NULL,NULL),(2049,2049,1,'LSQ12ffv','LSQ',353.964916666667,-22.1026944444444,NULL,NULL,'2012-07-01 06:21:33',56109.2649699999,19.3607,0.161,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_history.html','agn?',NULL,0.112098,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_snap_61100.gif',50276565095,NULL,NULL,NULL,'2012-06-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785571329,12274552,NULL,NULL,NULL,NULL),(2050,2049,0,'LSQ12ffv','LSQ',353.96475,-22.1027222222222,NULL,NULL,'2012-07-01 08:21:34',56109.3483199999,20.2526,0.2079,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_history.html','agn?',NULL,0.112098,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_snap_61101.gif',50276565095,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785571329,12274552,NULL,NULL,NULL,NULL),(2051,2049,0,'LSQ12ffv','LSQ',353.965458333333,-22.1025,NULL,NULL,'2012-09-15 05:04:14',56185.2112799999,20.241,0.1254,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_history.html','agn?',NULL,0.112098,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_snap_61102.gif',50276565092,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785571329,12274552,NULL,NULL,NULL,NULL),(2052,2049,0,'LSQ12ffv','LSQ',353.964916666667,-22.1026111111111,NULL,NULL,'2012-09-19 06:43:39',56189.2803199999,17.1346,0.0115,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_history.html','agn?',NULL,0.112098,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_snap_61103.gif',50276565095,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785571329,12274552,NULL,NULL,NULL,NULL),(2053,2049,0,'LSQ12ffv','LSQ',353.96475,-22.1027777777778,NULL,NULL,'2012-09-25 06:19:52',56195.2637999998,20.2834,0.2101,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_history.html','agn?',NULL,0.112098,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_snap_61104.gif',50276565095,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785571329,12274552,NULL,NULL,NULL,NULL),(2054,2049,0,'LSQ12ffv','LSQ',353.964916666667,-22.1025833333333,NULL,NULL,'2012-09-30 04:02:40',56200.1685199998,17.5396,0.0775,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_history.html','agn?',NULL,0.112098,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_snap_61084.gif',50276565095,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785571329,12274552,NULL,NULL,NULL,NULL),(2055,2049,0,'LSQ12ffv','LSQ',353.964875,-22.10275,NULL,NULL,'2012-09-30 06:05:49',56200.25404,17.9086,0.094,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_history.html','agn?',NULL,0.112098,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_snap_61085.gif',50276565095,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785571329,12274552,NULL,NULL,NULL,NULL),(2056,2056,1,'LSQ12ffu','LSQ',353.758541666667,-22.2102222222222,NULL,NULL,'2012-09-05 05:15:36',56175.2191699999,19.9126,0.1525,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_snap_61096.gif',50273699794,NULL,NULL,NULL,'2012-09-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785526559,12273852,NULL,NULL,NULL,NULL),(2057,2056,0,'LSQ12ffu','LSQ',353.758166666667,-22.2099722222222,NULL,NULL,'2012-09-07 05:17:45',56177.2206700002,19.0072,0.0874,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_snap_61097.gif',50273699794,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785526559,12273852,NULL,NULL,NULL,NULL),(2058,2056,0,'LSQ12ffu','LSQ',353.758208333333,-22.2101666666667,NULL,NULL,'2012-09-13 09:03:28',56183.3774100002,19.8713,0.1491,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_snap_61098.gif',50273699794,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785526559,12273852,NULL,NULL,NULL,NULL),(2059,2056,0,'LSQ12ffu','LSQ',353.757958333333,-22.2103888888889,NULL,NULL,'2012-09-25 06:19:52',56195.2637999998,19.7483,0.1451,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_snap_61099.gif',50273699734,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785526558,12273852,NULL,NULL,NULL,NULL),(2060,2056,0,'LSQ12ffu','LSQ',353.757833333333,-22.2098888888889,NULL,NULL,'2012-09-30 04:02:40',56200.1685199998,17.5129,0.0742,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_snap_61082.gif',50273699805,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785526559,12273852,NULL,NULL,NULL,NULL),(2061,2056,0,'LSQ12ffu','LSQ',353.757875,-22.2100277777778,NULL,NULL,'2012-09-30 06:05:49',56200.25404,18.1543,0.1388,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_snap_61083.gif',50273699805,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785526559,12273852,NULL,NULL,NULL,NULL),(2062,2062,1,'LSQ12ffs','LSQ',333.479083333333,-24.52125,NULL,NULL,'2012-09-03 04:13:03',56173.1757299998,18.4604,0.0998,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_history.html','sne',NULL,0.077797,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_snap_61090.gif',50532995243,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,789578050,12337157,NULL,NULL,NULL,NULL),(2063,2062,0,'LSQ12ffs','LSQ',333.479208333333,-24.52125,NULL,NULL,'2012-09-05 01:37:41',56175.0678400001,19.785,0.1377,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_history.html','sne',NULL,0.077797,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_snap_61091.gif',50532995243,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,789578050,12337157,NULL,NULL,NULL,NULL),(2064,2062,0,'LSQ12ffs','LSQ',333.479291666667,-24.5210555555556,NULL,NULL,'2012-09-25 01:33:54',56195.0652100001,18.395,0.0854,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_history.html','sne',NULL,0.077797,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_snap_61092.gif',50532995241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,789578050,12337157,NULL,NULL,NULL,NULL),(2065,2062,0,'LSQ12ffs','LSQ',333.479416666667,-24.5210833333333,NULL,NULL,'2012-09-25 03:44:35',56195.1559700002,18.6516,0.0948,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_history.html','sne',NULL,0.077797,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_snap_61093.gif',50532995243,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,789578050,12337157,NULL,NULL,NULL,NULL),(2066,2062,0,'LSQ12ffs','LSQ',333.47925,-24.5210555555556,NULL,NULL,'2012-09-30 02:33:13',56200.10641,19.0629,0.1394,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_history.html','sne',NULL,0.077797,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_snap_61078.gif',50532995241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,789578050,12337157,NULL,NULL,NULL,NULL),(2067,2062,0,'LSQ12ffs','LSQ',333.479208333333,-24.5211388888889,NULL,NULL,'2012-09-30 04:32:43',56200.18939,18.6972,0.1073,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 21:45:20','2012-09-30 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_history.html','sne',NULL,0.077797,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_snap_61079.gif',50532995243,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,789578050,12337157,NULL,NULL,NULL,NULL),(2068,2068,1,'LSQ12fgb','LSQ',345.267541666667,-17.5893888888889,NULL,NULL,'2012-09-30 03:10:40',56200.1324100001,17.5963,0.1323,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 22:45:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgb/LSQ12fgb_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgb/LSQ12fgb_snap_61126.gif',50455817381,NULL,NULL,NULL,'2012-09-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,788372146,12318314,NULL,NULL,NULL,NULL),(2069,2068,0,'LSQ12fgb','LSQ',345.2675,-17.5893888888889,NULL,NULL,'2012-09-30 05:10:06',56200.2153500002,17.4515,0.1502,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 22:45:22','2012-09-30 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgb/LSQ12fgb_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgb/LSQ12fgb_snap_61127.gif',50455817381,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,788372146,12318314,NULL,NULL,NULL,NULL),(2070,2070,1,'LSQ12ffz','LSQ',336.665583333333,-17.6383611111111,NULL,NULL,'2012-09-25 03:47:58',56195.1583199999,18.4487,0.1322,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 22:45:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffz/LSQ12ffz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffz/LSQ12ffz_snap_61133.gif',50237257514,NULL,NULL,NULL,'2012-09-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784957148,12264955,NULL,NULL,NULL,NULL),(2071,2070,0,'LSQ12ffz','LSQ',336.665708333333,-17.6382777777778,NULL,NULL,'2012-09-30 02:36:36',56200.1087500001,18.3703,0.1465,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 22:45:22','2012-09-30 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffz/LSQ12ffz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffz/LSQ12ffz_snap_61122.gif',50237257514,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784957148,12264955,NULL,NULL,NULL,NULL),(2072,2070,0,'LSQ12ffz','LSQ',336.665708333333,-17.63825,NULL,NULL,'2012-09-30 04:36:06',56200.1917400002,17.9208,0.124,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 22:45:22','2012-09-30 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffz/LSQ12ffz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffz/LSQ12ffz_snap_61123.gif',50237257514,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784957148,12264955,NULL,NULL,NULL,NULL),(2073,2073,1,'LSQ12ffy','LSQ',336.594416666667,-17.6665555555556,NULL,NULL,'2012-09-03 04:16:26',56173.1780900001,19.2089,0.1213,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 22:45:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffy/LSQ12ffy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffy/LSQ12ffy_snap_61130.gif',50237031041,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784953610,12264900,NULL,NULL,NULL,NULL),(2074,2073,0,'LSQ12ffy','LSQ',336.594375,-17.6665,NULL,NULL,'2012-09-25 01:37:18',56195.06757,20.201,0.1905,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 22:45:22','2012-09-30 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffy/LSQ12ffy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffy/LSQ12ffy_snap_61131.gif',50237031041,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784953610,12264900,NULL,NULL,NULL,NULL),(2075,2073,0,'LSQ12ffy','LSQ',336.594416666667,-17.6665277777778,NULL,NULL,'2012-09-25 03:47:58',56195.1583199999,18.8145,0.095,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 22:45:22','2012-09-30 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffy/LSQ12ffy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffy/LSQ12ffy_snap_61132.gif',50237031041,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784953610,12264900,NULL,NULL,NULL,NULL),(2076,2073,0,'LSQ12ffy','LSQ',336.594416666667,-17.6665277777778,NULL,NULL,'2012-09-30 02:36:36',56200.1087500001,18.5442,0.0978,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 22:45:22','2012-09-30 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffy/LSQ12ffy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffy/LSQ12ffy_snap_61120.gif',50237031041,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784953610,12264900,NULL,NULL,NULL,NULL),(2077,2073,0,'LSQ12ffy','LSQ',336.594416666667,-17.6665555555556,NULL,NULL,'2012-09-30 04:36:06',56200.1917400002,18.1854,0.1066,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-09-30 22:45:22','2012-09-30 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffy/LSQ12ffy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffy/LSQ12ffy_snap_61121.gif',50237031041,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784953610,12264900,NULL,NULL,NULL,NULL),(2078,2078,1,'MLS120925-075208+194445','CRTS-MLS',118.03538,19.74588,NULL,NULL,'2012-09-25 00:00:00',56195,20.6,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-01 14:25:49','2019-10-11 14:10:04','http://crts.caltech.edu/ATEL/MLS/1209251201034104513.atel.html','supernova',NULL,0,NULL,NULL,'http://crts.caltech.edu/ATEL/MLS/1209251201034104513/1209251201034104513-0001.arch.jpg',NULL,NULL,62629099704,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'SN',NULL,0,NULL,0,978579682,15290307,NULL,NULL,NULL,NULL),(2079,2079,1,'MLS120925-022454+132926','CRTS-MLS',36.22643,13.49057,NULL,NULL,'2012-09-25 00:00:00',56195,20.5,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-01 08:27:20','2019-10-11 14:10:04','http://crts.caltech.edu/ATEL/MLS/1209251130334105936.atel.html','supernova',NULL,0,NULL,NULL,'http://crts.caltech.edu/ATEL/MLS/1209251130334105936/1209251130334105936-0001.arch.jpg',NULL,NULL,68066015234,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'SN',NULL,0,NULL,0,1063531488,16617679,NULL,NULL,NULL,NULL),(2080,2080,1,'SNHunt148','CRTS',7.02095,-58.10181,NULL,NULL,'2012-09-08 00:00:00',56178,18.1,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-01 14:31:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/Current/20120908_191.html','supernova',NULL,0.034,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20010813/jpg/108130570024100157_20120908_01_4.jpg',NULL,NULL,36220843723,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,565950683,8842979,NULL,NULL,NULL,NULL),(2081,2081,1,'MLS120922-211231-121002','CRTS-MLS',318.1301,-12.16711,NULL,NULL,'2012-09-22 00:00:00',56192,18.6,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-01 08:35:10','2019-10-11 14:10:04','http://crts.caltech.edu/ATEL/MLS/1209220122894117931.atel.html','supernova',NULL,0,NULL,NULL,'http://crts.caltech.edu/ATEL/MLS/1209220122894117931/1209220122894117931-0002.arch.jpg',NULL,NULL,50777940511,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793405320,12396958,NULL,NULL,NULL,NULL),(2082,2082,1,'CSS120925-003040+123156','CRTS-CSS',7.66862,12.53233,NULL,NULL,'2012-09-25 00:00:00',56195,18.9,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-01 15:36:58','2019-10-11 14:10:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209251120034120839.atel.html','supernova',NULL,0,NULL,NULL,'http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209251120034120839/1209251120034120839-0001.arch.jpg',NULL,NULL,66749501117,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1042960954,16296264,NULL,NULL,NULL,NULL),(2083,2083,1,'CSS120924-025113+202319','CRTS-CSS',42.80435,20.38864,NULL,NULL,'2012-09-25 00:00:00',56195,19.5,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-01 14:39:14','2019-10-11 14:10:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209241210154109886.atel.html','supernova',NULL,0,NULL,NULL,'http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209241210154109886/1209241210154109886-0002.arch.jpg',NULL,NULL,68122905200,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'SN',NULL,0,NULL,0,1064420393,16631568,NULL,NULL,NULL,NULL),(2084,2084,0,'PSNJ20313345-4409173','TOCP',307.88937,-44.15481,NULL,NULL,'2012-09-22 00:00:00',56192,17.3,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-10-01 09:01:28','2019-10-12 20:41:36','http://www.cbat.eps.harvard.edu/unconf/followups/J20313345-4409173.html','supernova',NULL,0,NULL,NULL,'http://farm9.staticflickr.com/8170/8042721429_22d9eb646a_b.jpg',NULL,NULL,51378851395,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,802794553,12543664,NULL,NULL,NULL,NULL),(2085,2085,1,'MASTERJ045303.80+182623.5','MASTER',73.26583,18.43986,NULL,NULL,'2012-09-25 00:00:00',56195,18.8,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-01 09:43:55','2019-10-11 14:10:04','http://www.astronomerstelegram.org/?read=4422','supernova',NULL,0,NULL,NULL,'http://master.sai.msu.ru/static/OT/045303.80182623.5.png',NULL,NULL,65453882149,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,1022716908,15979951,NULL,NULL,NULL,NULL),(2086,2086,1,'MASTERJ231327.31+262622.0','MASTER',348.36379,26.43944,NULL,NULL,'2012-09-18 00:00:00',56188,18.1,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-01 15:46:07','2019-10-11 14:10:04','http://www.astronomerstelegram.org/?read=4413','supernova',NULL,0,NULL,NULL,'http://master.sai.msu.ru/static/OT/231327.31262622.0.png',NULL,NULL,52010729781,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,812667652,12697932,NULL,NULL,NULL,NULL),(2087,1426,0,'LSQ12evf','LSQ',335.365625,-24.5855277777778,NULL,NULL,'2012-10-01 01:47:23',56201.0745799998,19.2885,0.1232,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-01 22:45:22','2012-10-01 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evf/LSQ12evf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evf/LSQ12evf_snap_61154.gif',50066844723,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782294448,12223350,NULL,NULL,NULL,NULL),(2088,1426,0,'LSQ12evf','LSQ',335.365708333333,-24.5855,NULL,NULL,'2012-10-01 03:48:48',56201.1588900001,20.0712,0.2092,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-01 22:45:22','2012-10-01 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evf/LSQ12evf_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evf/LSQ12evf_snap_61155.gif',50066844723,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,782294448,12223350,NULL,NULL,NULL,NULL),(2089,1557,0,'LSQ12evn','LSQ',311.892666666667,-17.1578333333333,NULL,NULL,'2012-10-01 00:15:02',56201.0104499999,19.9145,0.168,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-01 22:45:22','2012-10-01 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_61165.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(2090,1557,0,'LSQ12evn','LSQ',311.89275,-17.1578333333333,NULL,NULL,'2012-10-01 02:16:31',56201.0948100002,18.986,0.1156,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-01 22:45:22','2012-10-01 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_history.html','sn',NULL,0.044828,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evn/LSQ12evn_snap_61166.gif',50992570481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796758913,12449358,NULL,NULL,NULL,NULL),(2091,1566,0,'LSQ12evm','LSQ',336.765708333333,-23.6769444444444,NULL,NULL,'2012-10-01 02:06:00',56201.08751,18.5198,0.0837,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-01 22:45:22','2012-10-01 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evm/LSQ12evm_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evm/LSQ12evm_snap_61164.gif',50212210897,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784565795,12258840,NULL,NULL,NULL,NULL),(2092,1620,0,'LSQ12evv','LSQ',28.7784166666667,-27.6877222222222,NULL,NULL,'2012-10-01 08:32:23',56201.3558299998,17.5774,0.16,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-01 22:45:22','2012-10-01 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12evv/LSQ12evv_snap_61173.gif',38401172067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600018313,9375286,NULL,NULL,NULL,NULL),(2093,1725,0,'LSQ12ezs','LSQ',310.557666666667,-21.6612222222222,NULL,NULL,'2012-10-01 00:23:45',56201.0164999999,19.5262,0.1783,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-01 22:45:22','2012-10-01 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_snap_61162.gif',50825557717,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794149339,12408583,NULL,NULL,NULL,NULL),(2094,1731,0,'LSQ12ezr','LSQ',311.78625,-21.5498055555556,NULL,NULL,'2012-10-01 00:23:45',56201.0164999999,19.9949,0.1727,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-01 22:45:22','2012-10-01 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezr/LSQ12ezr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezr/LSQ12ezr_snap_61163.gif',50825432373,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794147380,12408552,NULL,NULL,NULL,NULL),(2095,1735,0,'LSQ12ezn','LSQ',54.44,-37.26575,NULL,NULL,'2012-10-01 05:14:02',56201.2180900001,20.0559,0.1897,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-01 22:45:22','2012-10-01 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_61184.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(2096,1735,0,'LSQ12ezn','LSQ',54.4400833333333,-37.2658888888889,NULL,NULL,'2012-10-01 07:17:02',56201.3034999999,19.8208,0.1882,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-01 22:45:22','2012-10-01 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_61185.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(2097,2029,0,'LSQ12ffn','LSQ',320.645916666667,-20.6632777777778,NULL,NULL,'2012-10-01 00:50:55',56201.0353600001,19.4965,0.1253,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-01 22:45:22','2012-10-01 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_snap_61141.gif',50912843625,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795513181,12429893,NULL,NULL,NULL,NULL),(2098,2029,0,'LSQ12ffn','LSQ',320.647083333333,-20.6633611111111,NULL,NULL,'2012-10-01 02:52:26',56201.1197500001,19.3733,0.2086,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-01 22:45:22','2012-10-01 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_snap_61142.gif',50912843629,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795513181,12429893,NULL,NULL,NULL,NULL),(2099,2062,0,'LSQ12ffs','LSQ',333.47925,-24.5211944444444,NULL,NULL,'2012-10-01 01:49:04',56201.0757499998,18.5863,0.128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-01 22:45:22','2012-10-01 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_history.html','sne',NULL,0.077797,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_snap_61148.gif',50532995243,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,789578050,12337157,NULL,NULL,NULL,NULL),(2100,2068,0,'LSQ12fgb','LSQ',345.267458333333,-17.5894166666667,NULL,NULL,'2012-10-01 02:07:41',56201.08868,18.7409,0.1669,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-01 22:45:22','2012-10-01 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgb/LSQ12fgb_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgb/LSQ12fgb_snap_61146.gif',50455817388,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,788372146,12318314,NULL,NULL,NULL,NULL),(2101,2073,0,'LSQ12ffy','LSQ',336.5945,-17.6665277777778,NULL,NULL,'2012-10-01 01:52:27',56201.0781,19.754,0.1398,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-01 22:45:22','2012-10-01 22:45:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffy/LSQ12ffy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffy/LSQ12ffy_snap_61144.gif',50237031041,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784953610,12264900,NULL,NULL,NULL,NULL),(2102,2102,1,'LSQ12fgj','LSQ',311.268833333333,-23.17675,NULL,NULL,'2012-07-01 04:38:57',56109.1937199999,18.815,0.1328,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-02 01:45:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_61298.gif',50833605458,NULL,NULL,NULL,'2012-06-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275085,12410548,NULL,NULL,NULL,NULL),(2103,2102,0,'LSQ12fgj','LSQ',311.268625,-23.1768888888889,NULL,NULL,'2012-09-05 00:09:10',56175.0063700001,18.8783,0.078,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-02 01:45:21','2012-10-02 01:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_61299.gif',50833604769,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275074,12410548,NULL,NULL,NULL,NULL),(2104,2102,0,'LSQ12fgj','LSQ',311.268708333333,-23.1768888888889,NULL,NULL,'2012-09-05 02:18:29',56175.0961799999,19.1801,0.128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-02 01:45:21','2012-10-02 01:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_61300.gif',50833604769,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275074,12410548,NULL,NULL,NULL,NULL),(2105,2102,0,'LSQ12fgj','LSQ',311.268916666667,-23.1766944444444,NULL,NULL,'2012-09-09 00:11:05',56179.0077,20.2316,0.1852,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-02 01:45:21','2012-10-02 01:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_61301.gif',50833605458,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275085,12410548,NULL,NULL,NULL,NULL),(2106,2102,0,'LSQ12fgj','LSQ',311.268708333333,-23.1768333333333,NULL,NULL,'2012-09-11 00:12:02',56181.0083599999,19.2373,0.0967,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-02 01:45:21','2012-10-02 01:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_61302.gif',50833604769,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275074,12410548,NULL,NULL,NULL,NULL),(2107,2102,0,'LSQ12fgj','LSQ',311.268708333333,-23.17675,NULL,NULL,'2012-09-15 00:13:50',56185.0096100001,18.8704,0.0818,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-02 01:45:21','2012-10-02 01:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_61303.gif',50833605458,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275085,12410548,NULL,NULL,NULL,NULL),(2108,2102,0,'LSQ12fgj','LSQ',311.268583333333,-23.1768333333333,NULL,NULL,'2012-09-15 03:00:19',56185.1252199998,19.404,0.1215,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-02 01:45:21','2012-10-02 01:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_61304.gif',50833604769,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275074,12410548,NULL,NULL,NULL,NULL),(2109,2102,0,'LSQ12fgj','LSQ',311.268666666667,-23.1769166666667,NULL,NULL,'2012-09-17 00:14:40',56187.0101899998,19.0487,0.0826,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-02 01:45:21','2012-10-02 01:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_61305.gif',50833604769,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275074,12410548,NULL,NULL,NULL,NULL),(2110,2102,0,'LSQ12fgj','LSQ',311.268916666667,-23.1768333333333,NULL,NULL,'2012-09-17 03:15:28',56187.1357499999,20.0881,0.1437,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-02 01:45:21','2012-10-02 01:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_61306.gif',50833605458,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275085,12410548,NULL,NULL,NULL,NULL),(2111,2102,0,'LSQ12fgj','LSQ',311.268833333333,-23.1768333333333,NULL,NULL,'2012-09-23 01:11:33',56193.0496899998,19.5803,0.1436,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-02 01:45:21','2012-10-02 01:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_61307.gif',50833605458,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275085,12410548,NULL,NULL,NULL,NULL),(2112,2102,0,'LSQ12fgj','LSQ',311.268708333333,-23.17675,NULL,NULL,'2012-10-01 00:22:05',56201.0153399999,19.0492,0.1258,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-02 01:45:21','2012-10-02 01:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_61236.gif',50833605458,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275085,12410548,NULL,NULL,NULL,NULL),(2113,2102,0,'LSQ12fgj','LSQ',311.268708333333,-23.1769166666667,NULL,NULL,'2012-10-01 02:23:23',56201.0995800002,18.7869,0.1205,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-02 01:45:21','2012-10-02 01:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_61237.gif',50833604769,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275074,12410548,NULL,NULL,NULL,NULL),(2114,1718,0,'LSQ12eyo','LSQ',43.8208333333333,-7.89725,NULL,NULL,'2012-10-02 05:22:20',56202.2238500002,19.1296,0.1599,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-02 18:45:20','2012-10-02 18:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eyo/LSQ12eyo_history.html','sn?',NULL,0.03116,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12eyo/LSQ12eyo_snap_61430.gif',37913944766,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592405386,9256334,NULL,NULL,NULL,NULL),(2115,1816,0,'LSQ12fak','LSQ',56.351625,-10.5703611111111,NULL,NULL,'2012-10-02 05:55:25',56202.24682,19.1287,0.155,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-02 18:45:20','2012-10-02 18:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_snap_61384.gif',37026669944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578541717,9039714,NULL,NULL,NULL,NULL),(2116,1908,0,'LSQ12fch','LSQ',324.576958333333,-4.00625,NULL,NULL,'2012-10-02 00:17:54',56202.0124400002,19.8213,0.1645,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-02 18:45:20','2012-10-02 18:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_history.html','faint brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_snap_61417.gif',49706541067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776664704,12135386,NULL,NULL,NULL,NULL),(2117,1913,0,'LSQ12fbz','LSQ',31.9908333333333,-6.09377777777778,NULL,NULL,'2012-10-02 05:30:54',56202.2297999999,18.5168,0.1572,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-02 18:45:20','2012-10-02 18:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbz/LSQ12fbz_history.html','old sne',NULL,0.071686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbz/LSQ12fbz_snap_61462.gif',35154560675,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549290010,8582656,NULL,NULL,NULL,NULL),(2118,2118,1,'LSQ12fhh','LSQ',49.1314583333333,-0.467666666666667,NULL,NULL,'2012-10-02 05:41:34',56202.2372099999,17.4965,0.0604,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhh/LSQ12fhh_history.html','sne- nice',NULL,0.02268,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhh/LSQ12fhh_snap_61563.gif',36787815618,NULL,NULL,NULL,'2012-07-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574809619,8981400,NULL,NULL,NULL,NULL),(2119,2118,0,'LSQ12fhh','LSQ',49.1313333333333,-0.467638888888889,NULL,NULL,'2012-10-02 07:34:01',56202.3152899998,18.3023,0.1094,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2012-10-03 12:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhh/LSQ12fhh_history.html','sne- nice',NULL,0.02268,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhh/LSQ12fhh_snap_61564.gif',36787815618,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574809619,8981400,NULL,NULL,NULL,NULL),(2120,2120,1,'LSQ12fhg','LSQ',44.2426666666667,-1.15494444444444,NULL,NULL,'2012-10-02 05:39:52',56202.2360299998,17.0453,0.0333,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhg/LSQ12fhg_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhg/LSQ12fhg_snap_61561.gif',37849875156,NULL,NULL,NULL,'2012-07-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591404299,9240692,NULL,NULL,NULL,NULL),(2121,2120,0,'LSQ12fhg','LSQ',44.2425416666667,-1.15497222222222,NULL,NULL,'2012-10-02 07:44:19',56202.3224499999,17.8219,0.0784,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2012-10-03 12:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhg/LSQ12fhg_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhg/LSQ12fhg_snap_61562.gif',37849875156,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591404299,9240692,NULL,NULL,NULL,NULL),(2122,2122,1,'LSQ12fhe','LSQ',323.038791666667,-5.726,NULL,NULL,'2012-10-02 00:17:54',56202.0124400002,16.0117,0.0082,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_history.html','sne - nice',NULL,0.027472,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_snap_61555.gif',49713333864,NULL,NULL,NULL,'2012-09-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776770841,12137044,NULL,NULL,NULL,NULL),(2123,2122,0,'LSQ12fhe','LSQ',323.038958333333,-5.72611111111111,NULL,NULL,'2012-10-02 00:19:36',56202.0136199999,16.2668,0.0117,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2012-10-03 12:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_history.html','sne - nice',NULL,0.027472,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_snap_61557.gif',49713333872,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776770841,12137044,NULL,NULL,NULL,NULL),(2124,2122,0,'LSQ12fhe','LSQ',323.03875,-5.72613888888889,NULL,NULL,'2012-10-02 02:17:01',56202.09516,15.8298,0.0133,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2012-10-03 12:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_history.html','sne - nice',NULL,0.027472,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_snap_61556.gif',49713333864,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776770841,12137044,NULL,NULL,NULL,NULL),(2125,2122,0,'LSQ12fhe','LSQ',323.038916666667,-5.72611111111111,NULL,NULL,'2012-10-02 02:18:42',56202.0963300001,16.1896,0.0142,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2012-10-03 12:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_history.html','sne - nice',NULL,0.027472,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_snap_61558.gif',49713333864,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776770841,12137044,NULL,NULL,NULL,NULL),(2126,2126,1,'LSQ12fgy','LSQ',64.7325416666667,-4.1985,NULL,NULL,'2012-10-02 04:31:22',56202.1884599999,17.2588,0.1189,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_snap_61543.gif',36966141626,NULL,NULL,NULL,'2012-08-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577595962,9024936,NULL,NULL,NULL,NULL),(2127,2126,0,'LSQ12fgy','LSQ',64.7325833333333,-4.19844444444445,NULL,NULL,'2012-10-02 06:33:32',56202.2732899999,17.5484,0.0791,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2012-10-03 12:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_snap_61544.gif',36966141573,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577595962,9024936,NULL,NULL,NULL,NULL),(2128,2128,1,'LSQ12fgx','LSQ',53.73375,-6.88136111111111,NULL,NULL,'2012-08-20 09:55:36',56159.4136199998,16.4164,0.0102,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_history.html','liklely cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_snap_61583.gif',36800660497,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575010320,8984536,NULL,NULL,NULL,NULL),(2129,2128,0,'LSQ12fgx','LSQ',53.73375,-6.88136111111111,NULL,NULL,'2012-08-20 10:05:49',56159.4207100002,16.4225,0.0113,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2012-10-03 12:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_history.html','liklely cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_snap_61584.gif',36800660497,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575010320,8984536,NULL,NULL,NULL,NULL),(2130,2128,0,'LSQ12fgx','LSQ',53.7337916666667,-6.88141666666667,NULL,NULL,'2012-08-28 08:10:18',56167.3404899999,16.4185,0.0132,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2012-10-03 12:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_history.html','liklely cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_snap_61585.gif',36800660497,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575010320,8984536,NULL,NULL,NULL,NULL),(2131,2128,0,'LSQ12fgx','LSQ',53.7337916666667,-6.88138888888889,NULL,NULL,'2012-08-28 09:09:42',56167.3817400001,16.4326,0.0106,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2012-10-03 12:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_history.html','liklely cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_snap_61586.gif',36800660497,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575010320,8984536,NULL,NULL,NULL,NULL),(2132,2128,0,'LSQ12fgx','LSQ',53.7337916666667,-6.88138888888889,NULL,NULL,'2012-10-02 04:13:52',56202.1762999999,16.3058,0.0467,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2012-10-03 12:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_history.html','liklely cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_snap_61541.gif',36800660497,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575010320,8984536,NULL,NULL,NULL,NULL),(2133,2128,0,'LSQ12fgx','LSQ',53.7337916666667,-6.88141666666667,NULL,NULL,'2012-10-02 06:15:59',56202.2610999998,16.4098,0.0226,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2012-10-03 12:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_history.html','liklely cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_snap_61542.gif',36800660497,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575010320,8984536,NULL,NULL,NULL,NULL),(2134,2134,1,'LSQ12fgu','LSQ',40.8720416666667,-7.52602777777778,NULL,NULL,'2012-10-02 03:18:35',56202.13791,18.4752,0.0883,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgu/LSQ12fgu_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgu/LSQ12fgu_snap_61534.gif',37875275062,NULL,NULL,NULL,'2012-09-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,591801172,9246893,NULL,NULL,NULL,NULL),(2135,2134,0,'LSQ12fgu','LSQ',40.8722916666667,-7.52611111111111,NULL,NULL,'2012-10-02 05:18:56',56202.2214899999,19.1461,0.1203,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2012-10-03 12:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgu/LSQ12fgu_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgu/LSQ12fgu_snap_61535.gif',37875275062,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,591801172,9246893,NULL,NULL,NULL,NULL),(2136,2136,1,'LSQ12fgt','LSQ',35.9504166666667,-10.8664722222222,NULL,NULL,'2012-09-04 06:52:10',56174.2862300002,18.072,0.1039,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgt/LSQ12fgt_history.html','cv or sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgt/LSQ12fgt_snap_61538.gif',34930745410,NULL,NULL,NULL,'2012-09-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,545792897,8528014,NULL,NULL,NULL,NULL),(2137,2136,0,'LSQ12fgt','LSQ',35.95025,-10.8668055555556,NULL,NULL,'2012-10-02 03:13:29',56202.1343700001,17.9005,0.0505,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2012-10-03 12:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgt/LSQ12fgt_history.html','cv or sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgt/LSQ12fgt_snap_61532.gif',34930712705,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,545792386,8528006,NULL,NULL,NULL,NULL),(2138,2136,0,'LSQ12fgt','LSQ',35.9506666666667,-10.8667222222222,NULL,NULL,'2012-10-02 05:13:52',56202.2179700001,17.3104,0.0277,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-03 12:45:29','2012-10-03 12:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgt/LSQ12fgt_history.html','cv or sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgt/LSQ12fgt_snap_61533.gif',34930712705,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,545792386,8528006,NULL,NULL,NULL,NULL),(2139,2139,1,'SN2009ip','LBV',335.78467,-28.947779,NULL,NULL,'2012-10-05 00:00:00',56205,13.9,NULL,'V',NULL,NULL,NULL,NULL,'2012-10-05 10:43:53','2020-04-28 09:08:48','http://www.rochesterastronomy.org/snimages/','supernova',NULL,0.00594,NULL,NULL,'http://www.das.uchile.cl/proyectoCHASE/sne_2009/carta_sne_2009ip.jpg',NULL,NULL,50544555654,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,789758682,12339979,NULL,NULL,NULL,NULL),(2140,2139,0,'SN2009ip','CBET',335.78467,-28.947779,NULL,NULL,'2012-10-05 00:00:00',56205,NULL,NULL,NULL,0.00594,NULL,'II peculiar',NULL,'2012-10-05 09:59:25','2012-10-05 09:59:25','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,'http://www.das.uchile.cl/proyectoCHASE/sne_2009/carta_sne_2009ip.jpg',NULL,NULL,50544555654,'NTT','gm16','CI',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,789758682,12339979,NULL,NULL,NULL,NULL),(2142,2142,1,'CSS121004-204336-055316','CRTS-CSS',310.89961,-5.88787,NULL,NULL,'2012-10-05 00:00:00',56205,17.4,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-05 10:42:33','2019-10-11 14:10:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210040071104182143.atel.html','supernova',NULL,0,NULL,NULL,'http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210040071104182143/1210040071104182143.find.jpg',NULL,NULL,50738541085,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,792789704,12387339,NULL,NULL,NULL,NULL),(2143,2143,1,'CSS120926-171458+344754','CRTS-CSS',258.74065,34.79828,NULL,NULL,'2012-09-27 00:00:00',56197,18.7,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-05 10:48:19','2019-10-11 14:10:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209261350774119449.atel.html','unknown',NULL,0,NULL,NULL,'http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209261350774119449/1209261350774119449.find.jpg',NULL,NULL,56351560770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,880493137,13757705,NULL,NULL,NULL,NULL),(2144,2086,0,'CSS120918-231327+262622','CRTS-CSS',348.36341,26.43945,NULL,NULL,'2012-09-19 00:00:00',56189,18.22,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-05 11:55:13','2012-10-05 11:55:13','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209181261134125108.atel.html','supernova',NULL,0,NULL,NULL,'http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209181261134125108/1209181261134125108-0001.arch.jpg',NULL,NULL,52010729781,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,812667652,12697932,NULL,NULL,NULL,NULL),(2145,2145,1,'CSS120916-013813+211109','CRTS-CSS',24.55447,21.18588,NULL,NULL,'2012-09-17 00:00:00',56187,19.27,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-05 12:06:27','2019-10-11 14:10:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209161210094128601.atel.html','unknown',NULL,0,NULL,NULL,'http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209161210094128601/1209161210094128601.find.jpg',NULL,NULL,67391515782,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1052992434,16453006,NULL,NULL,NULL,NULL),(2147,2080,0,'SNhunt148','CRTS',7.02095,-58.10181,NULL,NULL,'2012-09-15 00:00:00',56185,18.1,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-05 12:55:23','2012-10-05 12:55:23','http://nesssi.cacr.caltech.edu/catalina/Current/20120908_191.html','supernova',NULL,0.0343,NULL,NULL,'https://c1.staticflickr.com/9/8309/8018705769_4ce28d597f_o.jpg',NULL,NULL,36220843723,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,565950683,8842979,NULL,NULL,NULL,NULL),(2148,2148,1,'MLS120921-000809-012132','CRTS-MLS',2.03769,-1.35882,NULL,NULL,'2012-09-22 00:00:00',56192,19.97,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-05 12:40:57','2019-10-11 14:10:04','http://crts.caltech.edu/ATEL/MLS/1209210010024111928.atel.html','unknown',NULL,0,NULL,NULL,'http://crts.caltech.edu/ATEL/MLS/1209210010024111928/1209210010024111928-0003.arch.jpg',NULL,NULL,34373713639,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'SN',NULL,0,NULL,0,537089275,8392019,NULL,NULL,NULL,NULL),(2149,2149,1,'MLS120917-234810-080902','CRTS-MLS',357.04372,-8.15069,NULL,NULL,'2012-09-20 00:00:00',56190,19.7,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-05 12:47:10','2019-10-11 14:10:04','http://crts.caltech.edu/ATEL/MLS/1209170083284107802.atel.html','supernova',NULL,0,NULL,NULL,'http://crts.caltech.edu/ATEL/MLS/1209170083284107802/1209170083284107802-0001.arch.jpg',NULL,NULL,49435139114,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,772424048,12069125,NULL,NULL,NULL,NULL),(2151,2081,0,'MLS120922-211231-121002','CRTS-MLS',318.1301,-12.16711,NULL,NULL,'2012-09-23 00:00:00',56193,18.56,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-05 12:52:58','2012-10-05 12:52:58','http://crts.caltech.edu/ATEL/MLS/1209220122894117931.atel.html','unknown',NULL,0,NULL,NULL,'http://crts.caltech.edu/ATEL/MLS/1209220122894117931/1209220122894117931-0002.arch.jpg',NULL,NULL,50777940511,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,793405320,12396958,NULL,NULL,NULL,NULL),(2152,2152,0,'SNhunt121','CRTS',100.677291666667,-27.4471666666667,NULL,NULL,'2012-04-13 10:19:12',56030.43,17.7,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-05 20:06:52','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/Current/20120412_646.html','supernova',NULL,0.0076,NULL,NULL,'https://dl.dropbox.com/u/28579834/FC_hunt121.png',NULL,NULL,39139645881,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,611556966,9555577,NULL,NULL,NULL,NULL),(2153,644,0,'LSQ12eij','pessto',353.852416667,-20.5113333333,NULL,NULL,'2012-08-12 00:00:00',56151,NULL,NULL,NULL,0.0076,NULL,'Ic peculiar',NULL,'2012-10-05 19:42:04','2012-10-05 19:42:04','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50275077940,'NTT','EFOSC','Valenti',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785548092,12274188,NULL,NULL,NULL,NULL),(2154,2152,0,'SNhunt121','pessto',100.677291667,-27.4471666667,NULL,NULL,'2012-04-14 12:28:48',56031.52,NULL,NULL,NULL,0.0076,NULL,'Ic peculiar',NULL,'2012-10-05 19:44:22','2012-10-05 19:44:22','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,39139645881,'NTT','EFOSC','valenti',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,611556966,9555577,NULL,NULL,NULL,NULL),(2155,1725,0,'LSQ12ezs','LSQ',310.557666666667,-21.6615277777778,NULL,NULL,'2012-10-02 23:58:17',56202.9988099998,19.55,0.1284,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-06 21:45:20','2012-10-06 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_snap_61709.gif',50825557717,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794149339,12408583,NULL,NULL,NULL,NULL),(2156,1725,0,'LSQ12ezs','LSQ',310.55775,-21.6615555555556,NULL,NULL,'2012-10-03 01:59:32',56203.0830100002,19.8245,0.1652,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-06 21:45:20','2012-10-06 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_snap_61710.gif',50825557717,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794149339,12408583,NULL,NULL,NULL,NULL),(2157,1735,0,'LSQ12ezn','LSQ',54.4399583333333,-37.2657222222222,NULL,NULL,'2012-10-03 05:08:49',56203.2144599999,19.8389,0.1285,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-06 21:45:20','2012-10-06 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_61748.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(2158,1735,0,'LSQ12ezn','LSQ',54.4399166666667,-37.2657222222222,NULL,NULL,'2012-10-03 07:09:04',56203.2979700002,19.6192,0.1171,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-06 21:45:20','2012-10-06 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_61749.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(2159,2029,0,'LSQ12ffn','LSQ',320.646291666667,-20.6633888888889,NULL,NULL,'2012-10-03 00:25:26',56203.01767,19.7421,0.1299,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-06 21:45:20','2012-10-06 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_snap_61669.gif',50912843625,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795513181,12429893,NULL,NULL,NULL,NULL),(2160,2044,0,'LSQ12ffx','LSQ',335.200625,-20.6736388888889,NULL,NULL,'2012-10-03 03:26:24',56203.14334,19.7922,0.1602,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-06 21:45:20','2012-10-06 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_snap_61680.gif',50207229407,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784487959,12257624,NULL,NULL,NULL,NULL),(2161,2049,0,'LSQ12ffv','LSQ',353.964708333333,-22.1028333333333,NULL,NULL,'2012-10-03 03:51:58',56203.1610900001,20.0323,0.1609,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-06 21:45:20','2012-10-06 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_history.html','agn?',NULL,0.112098,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_snap_61681.gif',50276565094,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785571329,12274552,NULL,NULL,NULL,NULL),(2162,2056,0,'LSQ12ffu','LSQ',353.758208333333,-22.2101388888889,NULL,NULL,'2012-10-03 05:52:30',56203.2448,19.9129,0.1824,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-06 21:45:20','2012-10-06 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_snap_61670.gif',50273699794,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785526559,12273852,NULL,NULL,NULL,NULL),(2163,2062,0,'LSQ12ffs','LSQ',333.47925,-24.5211944444444,NULL,NULL,'2012-10-03 01:23:26',56203.0579499998,18.7974,0.092,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-06 21:45:20','2012-10-06 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_history.html','sne',NULL,0.077797,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_snap_61687.gif',50532995243,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,789578050,12337157,NULL,NULL,NULL,NULL),(2164,2062,0,'LSQ12ffs','LSQ',333.479291666667,-24.5211666666667,NULL,NULL,'2012-10-03 03:24:44',56203.14218,19.0473,0.0907,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-06 21:45:20','2012-10-06 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_history.html','sne',NULL,0.077797,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_snap_61688.gif',50532995243,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,789578050,12337157,NULL,NULL,NULL,NULL),(2165,2068,0,'LSQ12fgb','LSQ',345.267416666667,-17.5894166666667,NULL,NULL,'2012-10-03 01:42:05',56203.0709000002,20.0321,0.1791,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-06 21:45:20','2012-10-06 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgb/LSQ12fgb_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgb/LSQ12fgb_snap_61685.gif',50455817388,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,788372146,12318314,NULL,NULL,NULL,NULL),(2166,2102,0,'LSQ12fgj','LSQ',311.268875,-23.1766111111111,NULL,NULL,'2012-10-02 23:56:35',56202.9976300001,19.6429,0.1204,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-06 21:45:20','2012-10-06 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_61715.gif',50833605458,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275085,12410548,NULL,NULL,NULL,NULL),(2167,2102,0,'LSQ12fgj','LSQ',311.268708333333,-23.1768611111111,NULL,NULL,'2012-10-03 01:57:49',56203.08182,19.6427,0.1689,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-06 21:45:20','2012-10-06 21:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_61716.gif',50833604769,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275074,12410548,NULL,NULL,NULL,NULL),(2168,2126,0,'LSQ12fgy','pessto',64.7325416667,-4.1985,NULL,NULL,'2012-10-07 20:52:48',56207.87,NULL,NULL,NULL,0.08,NULL,'agn?',NULL,'2012-10-07 21:19:42','2012-10-07 21:19:42','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,36966141626,'NTT','EFOSC2','Cosimo Inserra',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577595962,9024936,NULL,NULL,NULL,NULL),(2169,2118,0,'LSQ12fhh','pessto',49.1314583333,-0.467666666667,NULL,NULL,'2012-10-07 20:52:48',56207.87,NULL,NULL,NULL,0.02,NULL,'II',NULL,'2012-10-07 21:21:17','2012-10-07 21:21:17','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,36787815618,'NTT','EFOSC2','Cosimo Inserra',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574809619,8981400,NULL,NULL,NULL,NULL),(2170,2122,0,'LSQ12fhe','atel',323.038791667,-5.726,NULL,NULL,'2012-10-03 00:00:00',56203,NULL,NULL,NULL,0.027,NULL,'Ia peculiar',NULL,'2012-10-08 00:08:54','2012-10-08 00:08:54','http://www.astronomerstelegram.org/?read=4461',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,49713333864,'UH 2p2m','SNIFS','anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776770841,12137044,NULL,NULL,NULL,NULL),(2171,357185,1,'PSNJ01232438+0925545','non-pessto atel',20.85,9.4317,NULL,NULL,'2012-10-06 00:00:00',56206,NULL,NULL,NULL,0.007,NULL,'Ibc',NULL,'2012-10-08 00:13:31','2019-10-11 14:10:04','http://www.astronomerstelegram.org/?read=4461',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,67533641822,'UH 2p2m','SNIFS','anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1055213153,16487705,NULL,NULL,NULL,NULL),(2172,2172,1,'CSS121006-232854+085452','CRTS-CSS',352.22702,8.91432,NULL,NULL,'2012-10-07 00:00:00',56207,18.3,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-08 10:02:18','2019-10-11 14:10:04','http://voeventnet.caltech.edu/feeds/ATEL/CSS/1210061091254108515.atel.html','supernova',NULL,0,NULL,NULL,'http://voeventnet.caltech.edu/feeds/ATEL/CSS/1210061091254108515/1210061091254108515-0001.arch.jpg',NULL,NULL,51797447596,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,809335118,12645861,NULL,NULL,NULL,NULL),(2173,2173,1,'CSS121006-015926+014412','CRTS-CSS',29.85829,1.73662,NULL,NULL,'2012-10-07 00:00:00',56207,17.5,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-08 04:04:49','2019-10-11 14:10:04','http://voeventnet.caltech.edu/feeds/ATEL/CSS/1210061010114123149.atel.html','supernova',NULL,0,NULL,NULL,'http://voeventnet.caltech.edu/feeds/ATEL/CSS/1210061010114123149/1210061010114123149-0001.arch.jpg',NULL,NULL,67007717200,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1046995581,16359305,NULL,NULL,NULL,NULL),(2174,2174,1,'CSS121005-212556+122328','CRTS-CSS',321.48275,12.39105,NULL,NULL,'2012-10-06 00:00:00',56206,17.3,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-08 10:08:25','2019-10-11 14:10:04','http://voeventnet.caltech.edu/feeds/ATEL/CSS/1210051121134133632.atel.html','supernova',NULL,0,NULL,NULL,'http://voeventnet.caltech.edu/feeds/ATEL/CSS/1210051121134133632/1210051121134133632-0001.arch.jpg',NULL,NULL,55266515267,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,863539301,13492801,NULL,NULL,NULL,NULL),(2175,2175,1,'MLS121006-234856-023650','CRTS-MLS',357.23536,-2.61383,NULL,NULL,'2012-10-07 00:00:00',56207,18.8,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-08 10:11:36','2019-10-11 14:10:04','http://crts.caltech.edu/ATEL/MLS/1210060023314107007.atel.html','unknown',NULL,0,NULL,NULL,'http://crts.caltech.edu/ATEL/MLS/1210060023314107007/1210060023314107007-0002.arch.jpg',NULL,NULL,49404745158,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,771949143,12061705,NULL,NULL,NULL,NULL),(2176,2176,1,'MLS121004-005748+061812','CRTS-MLS',14.44846,6.30334,NULL,NULL,'2012-10-05 00:00:00',56205,19.1,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-08 10:14:43','2019-10-11 14:10:04','http://crts.caltech.edu/ATEL/MLS/1210041050144111266.atel.html','unknown',NULL,0,NULL,NULL,'http://crts.caltech.edu/ATEL/MLS/1210041050144111266/1210041050144111266-0002.arch.jpg',NULL,NULL,66666507217,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'SN',NULL,0,NULL,0,1041664175,16276002,NULL,NULL,NULL,NULL),(2177,1725,0,'LSQ12ezs','LSQ',310.557625,-21.6616388888889,NULL,NULL,'2012-10-05 02:00:34',56205.0837300001,20.3612,0.1591,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 10:45:19','2012-10-09 10:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezs/LSQ12ezs_snap_61866.gif',50825557719,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794149339,12408583,NULL,NULL,NULL,NULL),(2178,1731,0,'LSQ12ezr','LSQ',311.786333333333,-21.5498888888889,NULL,NULL,'2012-10-05 02:00:34',56205.0837300001,18.5636,0.0455,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 10:45:19','2012-10-09 10:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezr/LSQ12ezr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezr/LSQ12ezr_snap_61867.gif',50825432373,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794147380,12408552,NULL,NULL,NULL,NULL),(2179,1735,0,'LSQ12ezn','LSQ',54.4399166666667,-37.2657777777778,NULL,NULL,'2012-10-05 05:04:45',56205.2116399999,19.3481,0.0829,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 10:45:19','2012-10-09 10:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_61901.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(2180,2025,0,'LSQ12ffo','LSQ',330.44,-22.2058333333333,NULL,NULL,'2012-10-05 01:07:16',56205.04672,20.7467,0.1342,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 10:45:19','2012-10-09 10:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffo/LSQ12ffo_history.html','sne - nice',NULL,0.065395,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffo/LSQ12ffo_snap_61846.gif',50869971912,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794843311,12419426,NULL,NULL,NULL,NULL),(2181,2029,0,'LSQ12ffn','LSQ',320.646,-20.6631944444444,NULL,NULL,'2012-10-05 02:27:37',56205.1025200002,19.2276,0.1152,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 10:45:19','2012-10-09 10:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_snap_61848.gif',50912843625,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795513181,12429893,NULL,NULL,NULL,NULL),(2182,2062,0,'LSQ12ffs','LSQ',333.479333333333,-24.5211944444444,NULL,NULL,'2012-10-05 03:25:47',56205.1429099999,18.7489,0.1099,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 10:45:19','2012-10-09 10:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_history.html','sne',NULL,0.077797,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_snap_61855.gif',50532995243,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,789578050,12337157,NULL,NULL,NULL,NULL),(2183,2068,0,'LSQ12fgb','LSQ',345.266916666667,-17.5894444444444,NULL,NULL,'2012-10-05 01:43:05',56205.0715899998,20.0282,0.1806,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 10:45:19','2012-10-09 10:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgb/LSQ12fgb_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgb/LSQ12fgb_snap_61851.gif',50455817388,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,788372146,12318314,NULL,NULL,NULL,NULL),(2184,2068,0,'LSQ12fgb','LSQ',345.267291666667,-17.5893888888889,NULL,NULL,'2012-10-05 03:44:32',56205.1559299999,18.9808,0.1027,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 10:45:19','2012-10-09 10:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgb/LSQ12fgb_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgb/LSQ12fgb_snap_61852.gif',50455817388,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,788372146,12318314,NULL,NULL,NULL,NULL),(2185,2102,0,'LSQ12fgj','LSQ',311.268833333333,-23.1767222222222,NULL,NULL,'2012-10-05 01:58:53',56205.08256,19.4671,0.1132,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 10:45:19','2012-10-09 10:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_61868.gif',50833605458,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275085,12410548,NULL,NULL,NULL,NULL),(2186,1735,0,'LSQ12ezn','LSQ',54.4400416666667,-37.2658055555556,NULL,NULL,'2012-10-07 08:02:43',56207.3352199998,19.8187,0.1026,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 12:45:17','2012-10-09 12:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_61940.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(2187,2187,1,'CSS121008-014245+213928','CRTS-CSS',25.68653,21.65791,NULL,NULL,'2012-10-09 00:00:00',56209,17,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-09 16:10:49','2019-10-11 14:10:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210081210094133123.atel.html','supernova',NULL,0,NULL,NULL,'http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210081210094133123/1210081210094133123-0001.arch.jpg',NULL,NULL,67379548386,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1052805443,16450085,NULL,NULL,NULL,NULL),(2188,2188,1,'LSQ12fhs','LSQ',343.097666666667,-20.6148055555556,NULL,NULL,'2012-10-05 01:43:05',56205.0715899998,19.1514,0.078,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 17:45:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhs/LSQ12fhs_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhs/LSQ12fhs_snap_61947.gif',50220581215,NULL,NULL,NULL,'2012-10-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784696581,12260884,NULL,NULL,NULL,NULL),(2189,2188,0,'LSQ12fhs','LSQ',343.097666666667,-20.6148611111111,NULL,NULL,'2012-10-05 03:44:32',56205.1559299999,19.1238,0.0883,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 17:45:20','2012-10-09 17:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhs/LSQ12fhs_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhs/LSQ12fhs_snap_61948.gif',50220581215,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784696581,12260884,NULL,NULL,NULL,NULL),(2190,2190,1,'LSQ12fhr','LSQ',313.742458333333,-20.6426944444444,NULL,NULL,'2012-10-01 00:32:11',56201.0223599998,19.2729,0.1765,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 17:45:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhr/LSQ12fhr_history.html','sne past max?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhr/LSQ12fhr_snap_61951.gif',50949841681,NULL,NULL,NULL,'2012-09-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796091276,12438926,NULL,NULL,NULL,NULL),(2191,2190,0,'LSQ12fhr','LSQ',313.742625,-20.6426944444444,NULL,NULL,'2012-10-01 02:33:48',56201.1068099998,19.2602,0.1966,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 17:45:20','2012-10-09 17:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhr/LSQ12fhr_history.html','sne past max?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhr/LSQ12fhr_snap_61952.gif',50949841683,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796091276,12438926,NULL,NULL,NULL,NULL),(2192,2190,0,'LSQ12fhr','LSQ',313.742541666667,-20.6427777777778,NULL,NULL,'2012-10-03 00:06:44',56203.0046799998,20.4669,0.1407,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 17:45:20','2012-10-09 17:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhr/LSQ12fhr_history.html','sne past max?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhr/LSQ12fhr_snap_61953.gif',50949841681,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796091276,12438926,NULL,NULL,NULL,NULL),(2193,2190,0,'LSQ12fhr','LSQ',313.742625,-20.6428333333333,NULL,NULL,'2012-10-03 02:07:59',56203.0888800002,20.1274,0.1877,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 17:45:20','2012-10-09 17:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhr/LSQ12fhr_history.html','sne past max?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhr/LSQ12fhr_snap_61954.gif',50949841681,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796091276,12438926,NULL,NULL,NULL,NULL),(2194,2190,0,'LSQ12fhr','LSQ',313.742583333333,-20.6428055555556,NULL,NULL,'2012-10-05 00:07:37',56205.0052899998,20.4756,0.1521,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 17:45:20','2012-10-09 17:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhr/LSQ12fhr_history.html','sne past max?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhr/LSQ12fhr_snap_61945.gif',50949841681,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796091276,12438926,NULL,NULL,NULL,NULL),(2195,2190,0,'LSQ12fhr','LSQ',313.742625,-20.6427777777778,NULL,NULL,'2012-10-05 02:08:59',56205.0895799999,20.5177,0.1565,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 17:45:20','2012-10-09 17:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhr/LSQ12fhr_history.html','sne past max?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhr/LSQ12fhr_snap_61946.gif',50949841681,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796091276,12438926,NULL,NULL,NULL,NULL),(2196,2196,1,'LSQ12fhq','LSQ',333.663166666667,-21.5687777777778,NULL,NULL,'2012-10-03 01:23:26',56203.0579499998,19.5552,0.1027,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 17:45:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhq/LSQ12fhq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhq/LSQ12fhq_snap_61949.gif',49728887306,NULL,NULL,NULL,'2012-10-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'BS',NULL,0,NULL,0,777013864,12140841,NULL,NULL,NULL,NULL),(2197,2196,0,'LSQ12fhq','LSQ',333.663125,-21.5688333333333,NULL,NULL,'2012-10-03 03:24:44',56203.14218,19.7215,0.1213,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 17:45:20','2012-10-09 17:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhq/LSQ12fhq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhq/LSQ12fhq_snap_61950.gif',49728887349,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'BS',NULL,0,NULL,0,777013864,12140841,NULL,NULL,NULL,NULL),(2198,2196,0,'LSQ12fhq','LSQ',333.663166666667,-21.5687777777778,NULL,NULL,'2012-10-05 01:24:25',56205.0586299999,18.8257,0.0566,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 17:45:20','2012-10-09 17:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhq/LSQ12fhq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhq/LSQ12fhq_snap_61943.gif',49728887306,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'BS',NULL,0,NULL,0,777013864,12140841,NULL,NULL,NULL,NULL),(2199,2196,0,'LSQ12fhq','LSQ',333.66325,-21.5687777777778,NULL,NULL,'2012-10-05 03:25:47',56205.1429099999,18.7577,0.0918,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-09 17:45:20','2012-10-09 17:45:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhq/LSQ12fhq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhq/LSQ12fhq_snap_61944.gif',49728887306,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'BS',NULL,0,NULL,0,777013864,12140841,NULL,NULL,NULL,NULL),(2200,293259,0,'PSNJ00373938+1021290','TOCP',9.41408333333333,10.3580555555556,NULL,NULL,'2012-10-07 00:00:00',56207,16.5,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-10-10 01:11:37','2019-10-12 20:41:36','http://www.cbat.eps.harvard.edu/unconf/followups/J00373938 1021290.html','supernova',NULL,0.015,NULL,NULL,'http://www.cortinastelle.it/PSNJ00373938_1021290_20121009.jpg',NULL,NULL,66788804045,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1043575063,16305860,NULL,NULL,NULL,NULL),(2201,1820,0,'LSQ12fag','LSQ',25.370625,-29.6439722222222,NULL,NULL,'2012-10-08 06:41:07',56208.27856,22.1222,0.1432,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-10 01:45:18','2012-10-10 01:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_62003.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(2202,1735,0,'LSQ12ezn','LSQ',54.4400416666667,-37.2656944444444,NULL,NULL,'2012-10-09 07:07:39',56209.2969900002,19.9205,0.1011,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-10 04:45:21','2012-10-10 04:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ezn/LSQ12ezn_snap_62153.gif',38556577295,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602446520,9413226,NULL,NULL,NULL,NULL),(2203,2102,0,'LSQ12fgj','LSQ',311.268791666667,-23.1768888888889,NULL,NULL,'2012-10-09 00:02:11',56209.0015199999,19.892,0.1485,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-10 04:45:21','2012-10-10 04:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_62132.gif',50833605458,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275085,12410548,NULL,NULL,NULL,NULL),(2204,2173,0,'CSS121006-015926+014412','pessto',29.85829,1.73662,NULL,NULL,'2012-10-09 12:00:00',56209.5,NULL,NULL,NULL,0.08,NULL,'Ia peculiar',NULL,'2012-10-10 15:26:13','2012-10-10 15:26:13','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,67007717200,'NTT','EFOSC2','Cosimo Inserra',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1046995581,16359305,NULL,NULL,NULL,NULL),(2205,2174,0,'CSS121005-212556+122328','pessto',321.48275,12.39105,NULL,NULL,'2012-10-09 12:00:00',56209.5,NULL,NULL,NULL,0.04,NULL,'Ia',NULL,'2012-10-10 15:27:03','2012-10-10 15:27:03','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,55266515267,'NTT','EFOSC2','Cosimo Inserra',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,863539301,13492801,NULL,NULL,NULL,NULL),(2206,2128,0,'LSQ12fgx','pessto',53.73375,-6.88136111111,NULL,NULL,'2012-10-09 12:00:00',56209.5,NULL,NULL,NULL,0,NULL,'variable star',NULL,'2012-10-10 15:28:02','2012-10-10 15:28:02','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,36800660497,'NTT','EFOSC2','Cosimo Inserra',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575010320,8984536,NULL,NULL,NULL,NULL),(2207,2021,0,'LSQ12ffm','pessto',78.9939166667,8.74283333333,NULL,NULL,'2012-10-09 12:00:00',56209.5,NULL,NULL,NULL,0.15,NULL,'I',NULL,'2012-10-10 15:28:57','2012-10-10 15:28:57','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,64640634086,'NTT','EFOSC2','Cosimo Inserra',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,1010009907,15781404,NULL,NULL,NULL,NULL),(2208,2142,0,'CSS121004-204336-055316','pessto',310.89961,-5.88787,NULL,NULL,'2012-10-09 12:00:00',56209.5,NULL,NULL,NULL,0,NULL,'variable star',NULL,'2012-10-10 15:29:37','2012-10-10 15:29:37','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50738541085,'NTT','EFOSC2','Cosimo Inserra',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,792789704,12387339,NULL,NULL,NULL,NULL),(2209,2187,0,'CSS121008-014245+213928','pessto',25.68653,21.65791,NULL,NULL,'2012-10-10 12:00:00',56210.5,NULL,NULL,NULL,0.05,NULL,'Ia',NULL,'2012-10-10 16:46:01','2012-10-10 16:46:01','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,67379548386,'NTT','EFOSC2','Cosimo Inserra',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1052805443,16450085,NULL,NULL,NULL,NULL),(2210,2176,0,'MLS121004-005748+061812','pessto',14.44846,6.30334,NULL,NULL,'2012-10-10 12:00:00',56210.5,NULL,NULL,NULL,0.14,NULL,'Ia peculiar',NULL,'2012-10-10 16:46:45','2012-10-10 16:46:45','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,66666507217,'NTT','EFOSC2','Cosimo Inserra',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1041664175,16276002,NULL,NULL,NULL,NULL),(2211,2084,0,'PSNJ20313345-4409173','pessto',307.88937,-44.15481,NULL,NULL,'2012-10-10 12:00:00',56210.5,NULL,NULL,NULL,0.02,NULL,'II',NULL,'2012-10-10 16:47:29','2012-10-10 16:47:29','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,51378851395,'NTT','EFOSC2','Cosimo Inserra',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,802794553,12543664,NULL,NULL,NULL,NULL),(2212,2080,0,'SNHunt148','pessto',7.02095,-58.10181,NULL,NULL,'2012-10-10 12:00:00',56210.5,NULL,NULL,NULL,0.034,NULL,'II',NULL,'2012-10-10 16:48:05','2012-10-10 16:48:05','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,36220843723,'NTT','EFOSC2','Cosimo Inserra',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,565950683,8842979,NULL,NULL,NULL,NULL),(2213,1808,0,'LSQ12fal','LSQ',21.8589583333333,-3.76291666666667,NULL,NULL,'2012-10-10 06:28:24',56210.2697299998,17.3389,0.0248,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-11 21:45:16','2012-10-11 21:45:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fal/LSQ12fal_snap_62440.gif',35246476730,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,550726198,8605096,NULL,NULL,NULL,NULL),(2214,1816,0,'LSQ12fak','LSQ',56.351625,-10.5703333333333,NULL,NULL,'2012-10-10 07:00:51',56210.29226,19.2919,0.1238,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-11 21:45:16','2012-10-11 21:45:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_snap_62466.gif',37026669944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578541717,9039714,NULL,NULL,NULL,NULL),(2215,1816,0,'LSQ12fak','LSQ',56.3515833333333,-10.5703888888889,NULL,NULL,'2012-10-10 08:09:21',56210.33983,19.1559,0.1287,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-11 21:45:16','2012-10-11 21:45:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fak/LSQ12fak_snap_62467.gif',37026669944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578541717,9039714,NULL,NULL,NULL,NULL),(2216,1820,0,'LSQ12fag','LSQ',25.3707083333333,-29.6440555555556,NULL,NULL,'2012-10-10 01:00:22',56210.0419299998,22.1041,0.2041,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-11 21:45:16','2012-10-11 21:45:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_62472.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(2217,1820,0,'LSQ12fag','LSQ',25.3706666666667,-29.6440277777778,NULL,NULL,'2012-10-10 04:59:41',56210.2081200001,22.0996,0.1133,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-11 21:45:16','2012-10-11 21:45:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fag/LSQ12fag_snap_62473.gif',38265521124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597898767,9342168,NULL,NULL,NULL,NULL),(2218,1913,0,'LSQ12fbz','LSQ',31.990875,-6.09377777777778,NULL,NULL,'2012-10-10 03:51:03',56210.1604599999,19.3486,0.0412,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-11 21:45:16','2012-10-11 21:45:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbz/LSQ12fbz_history.html','old sne',NULL,0.071686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbz/LSQ12fbz_snap_62664.gif',35154560675,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549290010,8582656,NULL,NULL,NULL,NULL),(2219,1962,0,'LSQ12fdx','LSQ',40.1495,-9.43708333333333,NULL,NULL,'2012-10-10 07:29:55',56210.3124500001,19.5051,0.1231,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-11 21:45:16','2012-10-11 21:45:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_history.html','sn?',NULL,1.925,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_snap_62641.gif',37880582031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,591884094,9248188,NULL,NULL,NULL,NULL),(2220,2122,0,'LSQ12fhe','LSQ',323.03875,-5.72602777777778,NULL,NULL,'2012-10-10 02:42:13',56210.1126600001,15.3776,0.0041,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-11 21:45:16','2012-10-11 21:45:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_history.html','sne - nice',NULL,0.027472,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_snap_62495.gif',49713333864,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776770841,12137044,NULL,NULL,NULL,NULL),(2221,2122,0,'LSQ12fhe','LSQ',323.038916666667,-5.72613888888889,NULL,NULL,'2012-10-10 02:43:54',56210.1138300002,15.4726,0.0046,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-11 21:45:16','2012-10-11 21:45:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_history.html','sne - nice',NULL,0.027472,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_snap_62496.gif',49713333864,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776770841,12137044,NULL,NULL,NULL,NULL),(2222,2126,0,'LSQ12fgy','LSQ',64.7325416666667,-4.19852777777778,NULL,NULL,'2012-10-10 08:14:24',56210.3433400001,17.251,0.0218,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-11 21:45:16','2012-10-11 21:45:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_snap_62497.gif',36966141626,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577595962,9024936,NULL,NULL,NULL,NULL),(2223,2126,0,'LSQ12fgy','LSQ',64.7325,-4.1985,NULL,NULL,'2012-10-10 08:45:43',56210.36509,17.2118,0.0218,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-11 21:45:16','2012-10-11 21:45:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_snap_62498.gif',36966141626,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577595962,9024936,NULL,NULL,NULL,NULL),(2224,2128,0,'LSQ12fgx','LSQ',53.73375,-6.88141666666667,NULL,NULL,'2012-10-10 08:59:52',56210.3749099998,16.291,0.0105,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-11 21:45:16','2012-10-11 21:45:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_history.html','liklely cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_snap_62494.gif',36800660497,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575010320,8984536,NULL,NULL,NULL,NULL),(2225,2188,0,'LSQ12fhs','non-pessto atel',343.097666667,-20.6148055556,NULL,NULL,'2012-10-11 00:00:00',56211,NULL,NULL,NULL,0.033,NULL,'Ia peculiar',NULL,'2012-10-12 10:55:02','2012-10-12 10:55:02','http://www.astronomerstelegram.org/?read=4476',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50220581215,'UH2.2m','SNIFS','NSF',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784696581,12260884,NULL,NULL,NULL,NULL),(2226,2226,1,'LSQ12fiq','LSQ',70.42,-9.89294444444444,NULL,NULL,'2012-10-08 07:26:24',56208.3100000001,19.7132,0.1187,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 14:45:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_snap_62939.gif',37499689591,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585932649,9155197,NULL,NULL,NULL,NULL),(2227,2226,0,'LSQ12fiq','LSQ',70.4199583333333,-9.89297222222222,NULL,NULL,'2012-10-10 07:40:10',56210.3195699998,19.7513,0.102,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 14:45:15','2012-10-12 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_snap_62901.gif',37499689591,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585932649,9155197,NULL,NULL,NULL,NULL),(2228,2226,0,'LSQ12fiq','LSQ',70.419875,-9.89291666666667,NULL,NULL,'2012-10-10 08:28:26',56210.3530899999,19.6217,0.087,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 14:45:15','2012-10-12 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_snap_62902.gif',37499689591,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585932649,9155197,NULL,NULL,NULL,NULL),(2229,2229,1,'LSQ12fin','LSQ',51.39525,-10.7910277777778,NULL,NULL,'2012-09-24 08:42:31',56194.3628699998,20.0948,0.1834,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 14:45:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fin/LSQ12fin_history.html','sne?',NULL,0.086383,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fin/LSQ12fin_snap_62922.gif',37886243700,NULL,NULL,NULL,'2012-09-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,591972557,9249571,NULL,NULL,NULL,NULL),(2230,2229,0,'LSQ12fin','LSQ',51.3950833333333,-10.7910833333333,NULL,NULL,'2012-10-10 05:27:16',56210.2272800002,19.8489,0.1334,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 14:45:15','2012-10-12 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fin/LSQ12fin_history.html','sne?',NULL,0.086383,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fin/LSQ12fin_snap_62895.gif',37886243700,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,591972557,9249571,NULL,NULL,NULL,NULL),(2231,2229,0,'LSQ12fin','LSQ',51.3950833333333,-10.7907777777778,NULL,NULL,'2012-10-10 07:21:29',56210.3065900002,19.0927,0.0884,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 14:45:15','2012-10-12 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fin/LSQ12fin_history.html','sne?',NULL,0.086383,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fin/LSQ12fin_snap_62896.gif',37886243700,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,591972557,9249571,NULL,NULL,NULL,NULL),(2232,2232,1,'LSQ12fik','LSQ',56.764375,-10.9834166666667,NULL,NULL,'2012-09-14 07:59:14',56184.3328100001,19.9924,0.1614,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 14:45:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_62903.gif',37025736046,NULL,NULL,NULL,'2012-09-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2233,2232,0,'LSQ12fik','LSQ',56.7643333333333,-10.9833611111111,NULL,NULL,'2012-09-14 09:28:41',56184.3949199999,20.2228,0.1635,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 14:45:15','2012-10-12 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_62904.gif',37025736046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2234,2232,0,'LSQ12fik','LSQ',56.7643333333333,-10.9832777777778,NULL,NULL,'2012-09-16 06:57:02',56186.2896099999,19.8063,0.1547,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 14:45:15','2012-10-12 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_62905.gif',37025736046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2235,2232,0,'LSQ12fik','LSQ',56.764375,-10.9834722222222,NULL,NULL,'2012-09-16 08:21:27',56186.3482300001,19.782,0.1269,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 14:45:15','2012-10-12 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_62906.gif',37025736046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2236,2232,0,'LSQ12fik','LSQ',56.7643333333333,-10.9834722222222,NULL,NULL,'2012-09-22 07:35:38',56192.31642,18.8733,0.0829,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 14:45:15','2012-10-12 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_62907.gif',37025736046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2237,2232,0,'LSQ12fik','LSQ',56.7643333333333,-10.9833333333333,NULL,NULL,'2012-09-22 08:40:18',56192.3613300002,19.655,0.196,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 14:45:15','2012-10-12 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_62908.gif',37025736046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2238,2232,0,'LSQ12fik','LSQ',56.764375,-10.9834166666667,NULL,NULL,'2012-09-24 09:12:02',56194.3833599999,19.7541,0.1361,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 14:45:15','2012-10-12 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_62909.gif',37025736046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2239,2232,0,'LSQ12fik','LSQ',56.764375,-10.9835833333333,NULL,NULL,'2012-10-10 06:59:10',56210.29109,19.2528,0.1548,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 14:45:15','2012-10-12 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_62889.gif',37025736046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2240,2232,0,'LSQ12fik','LSQ',56.76425,-10.98325,NULL,NULL,'2012-10-10 08:11:03',56210.3410100001,19.5314,0.133,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 14:45:15','2012-10-12 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_62890.gif',37025736033,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2241,2241,0,'LSQ12fjm','LSQ',69.0455416666667,-5.0815,NULL,NULL,'2012-10-02 05:34:36',56202.2323699999,18.568,0.1153,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 15:45:15','2019-10-12 20:41:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_snap_63033.gif',37460190228,NULL,NULL,NULL,'2012-08-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585315472,9145554,NULL,NULL,NULL,NULL),(2242,2241,0,'LSQ12fjm','LSQ',69.0454583333333,-5.0815,NULL,NULL,'2012-10-02 07:47:53',56202.32492,18.0849,0.0766,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 15:45:15','2012-10-12 15:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_snap_63034.gif',37460190228,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585315472,9145554,NULL,NULL,NULL,NULL),(2243,2241,0,'LSQ12fjm','LSQ',69.0454166666667,-5.08155555555556,NULL,NULL,'2012-10-10 08:16:07',56210.3445299999,18.2946,0.0455,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 15:45:15','2012-10-12 15:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_snap_62984.gif',37460190228,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585315472,9145554,NULL,NULL,NULL,NULL),(2244,2241,0,'LSQ12fjm','LSQ',69.0454166666667,-5.08155555555556,NULL,NULL,'2012-10-10 08:56:29',56210.37256,18.2273,0.0453,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 15:45:15','2012-10-12 15:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_snap_62985.gif',37460190228,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585315472,9145554,NULL,NULL,NULL,NULL),(2245,2245,1,'LSQ12fjj','LSQ',65.3272083333333,-5.78147222222222,NULL,NULL,'2012-10-10 08:12:44',56210.3421800002,19.5203,0.16,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 15:45:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjj/LSQ12fjj_history.html','sne or asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjj/LSQ12fjj_snap_62978.gif',36965144235,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577580378,9024693,NULL,NULL,NULL,NULL),(2246,2245,0,'LSQ12fjj','LSQ',65.3271666666667,-5.78130555555556,NULL,NULL,'2012-10-10 08:44:04',56210.3639400001,19.4106,0.124,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 15:45:15','2012-10-12 15:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjj/LSQ12fjj_history.html','sne or asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjj/LSQ12fjj_snap_62979.gif',36965144235,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577580378,9024693,NULL,NULL,NULL,NULL),(2247,2247,1,'LSQ12fji','LSQ',57.31225,-6.10366666666667,NULL,NULL,'2012-10-02 04:17:13',56202.17863,17.4303,0.1415,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 15:45:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_63027.gif',37029491966,NULL,NULL,NULL,'2012-08-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2248,2247,0,'LSQ12fji','LSQ',57.312375,-6.10372222222222,NULL,NULL,'2012-10-02 06:19:23',56202.2634700001,17.6746,0.0703,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 15:45:15','2012-10-12 15:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_63028.gif',37029491967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2249,2247,0,'LSQ12fji','LSQ',57.3123333333333,-6.10361111111111,NULL,NULL,'2012-10-10 08:04:16',56210.3363000001,18.1722,0.0454,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 15:45:15','2012-10-12 15:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_62976.gif',37029491966,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2250,2247,0,'LSQ12fji','LSQ',57.3122916666667,-6.10363888888889,NULL,NULL,'2012-10-10 08:40:41',56210.3615899999,18.1536,0.0432,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 15:45:15','2012-10-12 15:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_62977.gif',37029491966,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2252,2252,1,'LSQ12fjf','LSQ',28.9169166666667,0.159222222222222,NULL,NULL,'2012-10-10 01:42:57',56210.0715000001,22.6139,0.1,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjf/LSQ12fjf_history.html','sne- hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjf/LSQ12fjf_snap_63023.gif',67000262571,NULL,NULL,NULL,'2012-10-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1046879102,16357485,NULL,NULL,NULL,NULL),(2253,2252,0,'LSQ12fjf','LSQ',28.916875,0.15925,NULL,NULL,'2012-10-10 03:43:42',56210.1553500001,22.5953,0.1204,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2012-10-12 16:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjf/LSQ12fjf_history.html','sne- hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjf/LSQ12fjf_snap_63024.gif',67000262571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1046879102,16357485,NULL,NULL,NULL,NULL),(2254,2252,0,'LSQ12fjf','LSQ',28.9169166666667,0.159194444444444,NULL,NULL,'2012-10-10 05:43:37',56210.23863,22.5834,0.1064,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2012-10-12 16:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjf/LSQ12fjf_history.html','sne- hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjf/LSQ12fjf_snap_62968.gif',67000262571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1046879102,16357485,NULL,NULL,NULL,NULL),(2255,2252,0,'LSQ12fjf','LSQ',28.917125,0.159222222222222,NULL,NULL,'2012-10-10 06:48:52',56210.28394,22.9071,0.1467,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2012-10-12 16:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjf/LSQ12fjf_history.html','sne- hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjf/LSQ12fjf_snap_62969.gif',67000262570,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1046879102,16357485,NULL,NULL,NULL,NULL),(2256,2256,1,'LSQ12fjd','LSQ',31.546125,-1.65897222222222,NULL,NULL,'2012-10-08 06:52:19',56208.2863400001,20.5162,0.1525,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjd/LSQ12fjd_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjd/LSQ12fjd_snap_63018.gif',35000118411,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546876850,8544950,NULL,NULL,NULL,NULL),(2257,2256,0,'LSQ12fjd','LSQ',31.5461666666667,-1.65861111111111,NULL,NULL,'2012-10-10 03:58:27',56210.1655999999,20.3916,0.1571,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2012-10-12 16:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjd/LSQ12fjd_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjd/LSQ12fjd_snap_62964.gif',35000118411,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546876850,8544950,NULL,NULL,NULL,NULL),(2258,2256,0,'LSQ12fjd','LSQ',31.5465,-1.65875,NULL,NULL,'2012-10-10 05:58:24',56210.2488899999,21.4476,0.1316,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2012-10-12 16:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjd/LSQ12fjd_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjd/LSQ12fjd_snap_62965.gif',35000118411,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546876850,8544950,NULL,NULL,NULL,NULL),(2259,2259,1,'LSQ12fjb','LSQ',32.8862083333333,0.125333333333333,NULL,NULL,'2012-10-10 05:08:38',56210.2143399999,20.1767,0.1418,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjb/LSQ12fjb_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjb/LSQ12fjb_snap_62960.gif',66992073124,NULL,NULL,NULL,'2012-10-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1046751142,16355486,NULL,NULL,NULL,NULL),(2260,2259,0,'LSQ12fjb','LSQ',32.8865,0.125138888888889,NULL,NULL,'2012-10-10 05:58:24',56210.2488899999,20.9477,0.1301,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2012-10-12 16:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjb/LSQ12fjb_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjb/LSQ12fjb_snap_62961.gif',66992073124,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1046751142,16355486,NULL,NULL,NULL,NULL),(2261,2261,1,'LSQ12fja','LSQ',27.9985,-1.64808333333333,NULL,NULL,'2012-10-10 01:46:38',56210.07406,24.0346,0.1387,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fja/LSQ12fja_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fja/LSQ12fja_snap_62958.gif',35021897256,NULL,NULL,NULL,'2012-10-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547217144,8550267,NULL,NULL,NULL,NULL),(2262,2261,0,'LSQ12fja','LSQ',27.9985416666667,-1.64819444444444,NULL,NULL,'2012-10-10 03:47:23',56210.1579100001,24.2974,0.1427,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2012-10-12 16:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fja/LSQ12fja_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fja/LSQ12fja_snap_62959.gif',35021897256,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547217144,8550267,NULL,NULL,NULL,NULL),(2263,2261,0,'LSQ12fja','LSQ',27.9987916666667,-1.64813888888889,NULL,NULL,'2012-10-10 05:47:19',56210.2412,24.9543,0.204,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2012-10-12 16:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fja/LSQ12fja_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fja/LSQ12fja_snap_63015.gif',35021897264,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547217144,8550267,NULL,NULL,NULL,NULL),(2264,2264,1,'LSQ12fix','LSQ',28.6688333333333,-2.7185,NULL,NULL,'2012-10-10 01:42:57',56210.0715000001,16.4617,0.1133,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fix/LSQ12fix_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fix/LSQ12fix_snap_62952.gif',35002561410,NULL,NULL,NULL,'2012-10-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546915022,8545547,NULL,NULL,NULL,NULL),(2265,2264,0,'LSQ12fix','LSQ',28.6688333333333,-2.71838888888889,NULL,NULL,'2012-10-10 03:43:42',56210.1553500001,20.1945,0.0917,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2012-10-12 16:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fix/LSQ12fix_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fix/LSQ12fix_snap_63008.gif',35002561410,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546915022,8545547,NULL,NULL,NULL,NULL),(2266,2264,0,'LSQ12fix','LSQ',28.6689166666667,-2.71841666666667,NULL,NULL,'2012-10-10 05:43:37',56210.23863,16.5404,0.1021,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2012-10-12 16:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fix/LSQ12fix_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fix/LSQ12fix_snap_62953.gif',35002561410,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546915022,8545547,NULL,NULL,NULL,NULL),(2267,2264,0,'LSQ12fix','LSQ',28.668875,-2.71844444444444,NULL,NULL,'2012-10-10 06:48:52',56210.28394,20.0979,0.1646,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2012-10-12 16:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fix/LSQ12fix_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fix/LSQ12fix_snap_63009.gif',35002561410,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546915022,8545547,NULL,NULL,NULL,NULL),(2268,2268,1,'LSQ12fit','LSQ',34.7382083333333,-1.65808333333333,NULL,NULL,'2012-10-10 08:19:47',56210.3470800002,20.268,0.1596,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fit/LSQ12fit_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fit/LSQ12fit_snap_62944.gif',34915237392,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545550584,8524227,NULL,NULL,NULL,NULL),(2269,2268,0,'LSQ12fit','LSQ',34.7382916666667,-1.65794444444444,NULL,NULL,'2012-10-10 08:54:30',56210.3711899999,19.6162,0.1241,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2012-10-12 16:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fit/LSQ12fit_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fit/LSQ12fit_snap_62945.gif',34915237392,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545550584,8524227,NULL,NULL,NULL,NULL),(2270,2270,1,'LSQ12fis','LSQ',32.5652916666667,1.72111111111111,NULL,NULL,'2012-10-10 02:01:25',56210.0843199999,23.7637,0.1489,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fis/LSQ12fis_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fis/LSQ12fis_snap_62942.gif',67060952008,NULL,NULL,NULL,'2012-10-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1047827375,16372302,NULL,NULL,NULL,NULL),(2271,2270,0,'LSQ12fis','LSQ',32.56525,1.72113888888889,NULL,NULL,'2012-10-10 04:02:09',56210.1681599999,23.5702,0.1156,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2012-10-12 16:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fis/LSQ12fis_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fis/LSQ12fis_snap_62986.gif',67060952008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1047827375,16372302,NULL,NULL,NULL,NULL),(2272,2270,0,'LSQ12fis','LSQ',32.5650833333333,1.721,NULL,NULL,'2012-10-10 06:02:05',56210.2514499999,23.7277,0.1535,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-12 16:45:17','2012-10-12 16:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fis/LSQ12fis_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fis/LSQ12fis_snap_62943.gif',67060951892,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1047827373,16372302,NULL,NULL,NULL,NULL),(2273,293259,0,'PSNJ00373938+1021290','pessto',9.41408333333,10.3580555556,NULL,NULL,'2012-10-10 00:00:00',56207,NULL,NULL,NULL,0.015,NULL,'IIP',NULL,'2012-10-12 17:08:48','2012-10-12 17:08:48','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,66788804045,'NTT','EFOSC','Patrick El Hage',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1043575063,16305860,NULL,NULL,NULL,NULL),(2274,2274,1,'PS1-12btz','Pan-STARRS1',12.2076581124,7.76491412287,NULL,NULL,'2012-10-08 11:49:00',56208.4923656,18.6733,0.014469,'i',NULL,NULL,NULL,NULL,'2012-10-13 11:45:13','2019-10-11 14:10:04','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1004849831074553600/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56208/1004849831074553600_56208.492_528167_265_target.jpeg',NULL,NULL,66663077485,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1041610585,16275165,NULL,NULL,NULL,NULL),(2275,2274,0,'PS1-12btz','Pan-STARRS1',12.2076577182,7.76491397246,NULL,NULL,'2012-10-11 11:13:54',56211.4679902,18.8139,0.0158859,'g',NULL,NULL,NULL,NULL,'2012-10-13 11:45:13','2012-10-13 11:45:13','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1004849831074553600/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56211/1004849831074553600_56211.467_530175_135_target.jpeg',NULL,NULL,66663077485,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1041610585,16275165,NULL,NULL,NULL,NULL),(2276,2274,0,'PS1-12btz','Pan-STARRS1',12.2076592598,7.76491894667,NULL,NULL,'2012-10-11 11:32:04',56211.4806028,18.8268,0.0162407,'g',NULL,NULL,NULL,NULL,'2012-10-13 11:45:13','2012-10-13 11:45:13','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1004849831074553600/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56211/1004849831074553600_56211.480_530195_138_target.jpeg',NULL,NULL,66663077485,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1041610585,16275165,NULL,NULL,NULL,NULL),(2277,2029,0,'LSQ12ffn','LSQ',320.646583333333,-20.6634722222222,NULL,NULL,'2012-10-11 00:49:03',56211.0340700001,17.9926,0.0497,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-13 16:45:15','2012-10-13 16:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffn/LSQ12ffn_snap_63038.gif',50912843625,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795513181,12429893,NULL,NULL,NULL,NULL),(2278,2102,0,'LSQ12fgj','LSQ',311.26875,-23.1767777777778,NULL,NULL,'2012-10-11 00:18:06',56211.0125699998,19.9567,0.2023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-13 16:45:15','2012-10-13 16:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_63082.gif',50833605458,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275085,12410548,NULL,NULL,NULL,NULL),(2279,2102,0,'LSQ12fgj','LSQ',311.2685,-23.1769166666667,NULL,NULL,'2012-10-11 02:19:39',56211.09699,19.5953,0.1128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-13 16:45:15','2012-10-13 16:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgj/LSQ12fgj_snap_63083.gif',50833604769,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794275074,12410548,NULL,NULL,NULL,NULL),(2280,2190,0,'LSQ12fhr','LSQ',313.742625,-20.6428333333333,NULL,NULL,'2012-10-11 00:28:16',56211.0196400001,20.8706,0.1924,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-13 16:45:15','2012-10-13 16:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhr/LSQ12fhr_history.html','sne past max?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhr/LSQ12fhr_snap_63125.gif',50949841681,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796091276,12438926,NULL,NULL,NULL,NULL),(2281,2190,0,'LSQ12fhr','LSQ',313.7425,-20.6428055555556,NULL,NULL,'2012-10-11 02:29:48',56211.10403,21.0147,0.1938,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-13 16:45:15','2012-10-13 16:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhr/LSQ12fhr_history.html','sne past max?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhr/LSQ12fhr_snap_63126.gif',50949841681,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,796091276,12438926,NULL,NULL,NULL,NULL),(2282,2252,0,'LSQ12fjf','LSQ',28.9169583333333,0.159194444444444,NULL,NULL,'2012-10-11 01:39:10',56211.0688700001,22.6933,0.1079,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-13 16:45:15','2012-10-13 16:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjf/LSQ12fjf_history.html','sne- hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjf/LSQ12fjf_snap_63176.gif',67000262571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1046879102,16357485,NULL,NULL,NULL,NULL),(2283,2252,0,'LSQ12fjf','LSQ',28.916875,0.159194444444444,NULL,NULL,'2012-10-11 03:39:49',56211.1526600001,23.0921,0.0935,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-13 16:45:15','2012-10-13 16:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjf/LSQ12fjf_history.html','sne- hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjf/LSQ12fjf_snap_63177.gif',67000262571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1046879102,16357485,NULL,NULL,NULL,NULL),(2284,2252,0,'LSQ12fjf','LSQ',28.916875,0.159222222222222,NULL,NULL,'2012-10-11 05:41:47',56211.2373500001,23.3163,0.0959,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-13 16:45:15','2012-10-13 16:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjf/LSQ12fjf_history.html','sne- hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjf/LSQ12fjf_snap_63178.gif',67000262571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1046879102,16357485,NULL,NULL,NULL,NULL),(2285,2256,0,'LSQ12fjd','LSQ',31.5467916666667,-1.65875,NULL,NULL,'2012-10-11 03:56:21',56211.16414,22.0013,0.1859,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-13 16:45:15','2012-10-13 16:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjd/LSQ12fjd_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjd/LSQ12fjd_snap_63203.gif',35000118409,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546876850,8544950,NULL,NULL,NULL,NULL),(2286,2256,0,'LSQ12fjd','LSQ',31.546125,-1.65863888888889,NULL,NULL,'2012-10-11 05:56:40',56211.2476900001,21.662,0.1707,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-13 16:45:15','2012-10-13 16:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjd/LSQ12fjd_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjd/LSQ12fjd_snap_63204.gif',35000118411,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546876850,8544950,NULL,NULL,NULL,NULL),(2287,2261,0,'LSQ12fja','LSQ',27.9985833333333,-1.64805555555556,NULL,NULL,'2012-10-11 03:43:31',56211.1552300001,24.4402,0.1404,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-13 16:45:15','2012-10-13 16:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fja/LSQ12fja_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fja/LSQ12fja_snap_63172.gif',35021897256,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547217144,8550267,NULL,NULL,NULL,NULL),(2288,2264,0,'LSQ12fix','LSQ',28.6688333333333,-2.71838888888889,NULL,NULL,'2012-10-11 01:39:10',56211.0688700001,18.5312,0.0967,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-13 16:45:15','2012-10-13 16:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fix/LSQ12fix_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fix/LSQ12fix_snap_63192.gif',35002561410,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546915022,8545547,NULL,NULL,NULL,NULL),(2289,2264,0,'LSQ12fix','LSQ',28.668875,-2.71847222222222,NULL,NULL,'2012-10-11 03:39:49',56211.1526600001,18.6772,0.1418,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-13 16:45:15','2012-10-13 16:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fix/LSQ12fix_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fix/LSQ12fix_snap_63193.gif',35002561410,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546915022,8545547,NULL,NULL,NULL,NULL),(2290,2264,0,'LSQ12fix','LSQ',28.6687916666667,-2.71844444444444,NULL,NULL,'2012-10-11 05:41:47',56211.2373500001,18.8411,0.1231,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-13 16:45:15','2012-10-13 16:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fix/LSQ12fix_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fix/LSQ12fix_snap_63194.gif',35002561410,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546915022,8545547,NULL,NULL,NULL,NULL),(2291,2270,0,'LSQ12fis','LSQ',32.5650416666667,1.72113888888889,NULL,NULL,'2012-10-11 04:00:02',56211.1666999999,24.1754,0.1622,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-13 16:45:15','2012-10-13 16:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fis/LSQ12fis_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fis/LSQ12fis_snap_63195.gif',67060951892,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1047827373,16372302,NULL,NULL,NULL,NULL),(2292,2274,0,'PS1-12btz','Pan-STARRS1',12.2076581123807,7.76491412287055,NULL,NULL,'2012-10-08 11:49:00',56208.4923656341,18.6733,0.014469,'i',NULL,NULL,NULL,NULL,'2012-10-14 01:15:14','2012-10-14 01:15:14','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1004849831074553600/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56208/1004849831074553600_56208.492_528167_265_target.jpeg',NULL,NULL,66663077485,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1041610585,16275165,NULL,NULL,NULL,NULL),(2293,2274,0,'PS1-12btz','Pan-STARRS1',12.2076577181556,7.76491397245781,NULL,NULL,'2012-10-11 11:13:54',56211.4679901801,18.8139,0.0158859,'g',NULL,NULL,NULL,NULL,'2012-10-14 01:15:14','2012-10-14 01:15:14','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1004849831074553600/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56211/1004849831074553600_56211.467_530175_135_target.jpeg',NULL,NULL,66663077485,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1041610585,16275165,NULL,NULL,NULL,NULL),(2294,2274,0,'PS1-12btz','Pan-STARRS1',12.207659259788,7.76491894666941,NULL,NULL,'2012-10-11 11:32:04',56211.4806027758,18.8268,0.0162407,'g',NULL,NULL,NULL,NULL,'2012-10-14 01:15:14','2012-10-14 01:15:14','http://star.pst.qub.ac.uk/sne/ps1fgss/psdb/candidate/1004849831074553600/','sn',NULL,NULL,NULL,NULL,'http://star.pst.qub.ac.uk/sne/ps1fgss/site_media/images/data/ps1fgss/56211/1004849831074553600_56211.480_530195_138_target.jpeg',NULL,NULL,66663077485,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1041610585,16275165,NULL,NULL,NULL,NULL),(2295,2295,1,'LSQ12fjr','LSQ',30.50425,-1.93283333333333,NULL,NULL,'2012-10-10 03:58:27',56210.1655999999,19.4933,0.0813,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 14:45:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_snap_63381.gif',35013987766,NULL,NULL,NULL,'2012-10-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547093558,8548336,NULL,NULL,NULL,NULL),(2296,2295,0,'LSQ12fjr','LSQ',30.5042916666667,-1.93283333333333,NULL,NULL,'2012-10-10 05:58:24',56210.2488899999,19.8099,0.0576,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 14:45:15','2012-10-14 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_snap_63382.gif',35013987766,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547093558,8548336,NULL,NULL,NULL,NULL),(2297,2295,0,'LSQ12fjr','LSQ',30.50425,-1.93291666666667,NULL,NULL,'2012-10-10 07:07:58',56210.29721,20.1177,0.0971,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 14:45:15','2012-10-14 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_snap_63383.gif',35013987766,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547093558,8548336,NULL,NULL,NULL,NULL),(2298,2295,0,'LSQ12fjr','LSQ',30.5040833333333,-1.93291666666667,NULL,NULL,'2012-10-11 01:57:02',56211.08128,19.8068,0.0861,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 14:45:15','2012-10-14 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_snap_63384.gif',35013987766,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547093558,8548336,NULL,NULL,NULL,NULL),(2299,2295,0,'LSQ12fjr','LSQ',30.50425,-1.93286111111111,NULL,NULL,'2012-10-11 03:56:21',56211.16414,20.056,0.0622,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 14:45:15','2012-10-14 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_snap_63365.gif',35013987766,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547093558,8548336,NULL,NULL,NULL,NULL),(2300,2295,0,'LSQ12fjr','LSQ',30.5042083333333,-1.93280555555556,NULL,NULL,'2012-10-11 05:56:40',56211.2476900001,19.929,0.0587,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 14:45:15','2012-10-14 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_snap_63366.gif',35013987766,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547093558,8548336,NULL,NULL,NULL,NULL),(2301,2301,1,'LSQ12fjq','LSQ',30.803125,-1.48125,NULL,NULL,'2012-10-10 01:57:44',56210.08176,23.3952,0.2036,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 14:45:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjq/LSQ12fjq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjq/LSQ12fjq_snap_63378.gif',35012628399,NULL,NULL,NULL,'2012-10-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547072318,8548004,NULL,NULL,NULL,NULL),(2302,2301,0,'LSQ12fjq','LSQ',30.803,-1.48127777777778,NULL,NULL,'2012-10-10 05:58:24',56210.2488899999,23.2392,0.1346,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 14:45:15','2012-10-14 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjq/LSQ12fjq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjq/LSQ12fjq_snap_63379.gif',35012628398,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547072318,8548004,NULL,NULL,NULL,NULL),(2303,2301,0,'LSQ12fjq','LSQ',30.8030416666667,-1.48122222222222,NULL,NULL,'2012-10-11 01:57:02',56211.08128,23.2751,0.1951,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 14:45:15','2012-10-14 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjq/LSQ12fjq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjq/LSQ12fjq_snap_63380.gif',35012628398,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547072318,8548004,NULL,NULL,NULL,NULL),(2304,2301,0,'LSQ12fjq','LSQ',30.8030416666667,-1.48122222222222,NULL,NULL,'2012-10-11 03:56:21',56211.16414,23.2485,0.1552,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 14:45:15','2012-10-14 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjq/LSQ12fjq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjq/LSQ12fjq_snap_63363.gif',35012628398,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547072318,8548004,NULL,NULL,NULL,NULL),(2305,2301,0,'LSQ12fjq','LSQ',30.803,-1.48122222222222,NULL,NULL,'2012-10-11 05:56:40',56211.2476900001,23.2993,0.1538,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 14:45:15','2012-10-14 14:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjq/LSQ12fjq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjq/LSQ12fjq_snap_63364.gif',35012628398,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547072318,8548004,NULL,NULL,NULL,NULL),(2306,1908,0,'LSQ12fch','LSQ',324.576875,-4.00633333333333,NULL,NULL,'2012-10-12 00:41:57',56212.0291400002,20.1497,0.182,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 17:45:15','2012-10-14 17:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_history.html','faint brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fch/LSQ12fch_snap_63538.gif',49706541067,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776664704,12135386,NULL,NULL,NULL,NULL),(2307,1913,0,'LSQ12fbz','LSQ',31.9910416666667,-6.09394444444444,NULL,NULL,'2012-10-12 07:51:16',56212.3272699998,19.2587,0.0691,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 17:45:15','2012-10-14 17:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbz/LSQ12fbz_history.html','old sne',NULL,0.071686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fbz/LSQ12fbz_snap_63610.gif',35154560674,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549290010,8582656,NULL,NULL,NULL,NULL),(2308,1962,0,'LSQ12fdx','LSQ',40.1495833333333,-9.43713888888889,NULL,NULL,'2012-10-12 07:17:42',56212.3039600002,19.3315,0.1193,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 17:45:15','2012-10-14 17:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_history.html','sn?',NULL,1.925,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_snap_63600.gif',37880582031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,591884094,9248188,NULL,NULL,NULL,NULL),(2309,1962,0,'LSQ12fdx','LSQ',40.1494583333333,-9.43711111111111,NULL,NULL,'2012-10-12 09:04:41',56212.3782600001,20.4335,0.1829,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 17:45:15','2012-10-14 17:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_history.html','sn?',NULL,1.925,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_snap_63601.gif',37880582031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,591884094,9248188,NULL,NULL,NULL,NULL),(2310,2122,0,'LSQ12fhe','LSQ',323.03875,-5.72602777777778,NULL,NULL,'2012-10-12 00:41:57',56212.0291400002,15.3593,0.0049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 17:45:15','2012-10-14 17:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_history.html','sne - nice',NULL,0.027472,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_snap_63480.gif',49713333864,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776770841,12137044,NULL,NULL,NULL,NULL),(2311,2122,0,'LSQ12fhe','LSQ',323.038875,-5.72613888888889,NULL,NULL,'2012-10-12 00:43:38',56212.0303099998,15.5213,0.0061,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 17:45:15','2012-10-14 17:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_history.html','sne - nice',NULL,0.027472,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_snap_63481.gif',49713333864,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776770841,12137044,NULL,NULL,NULL,NULL),(2312,2128,0,'LSQ12fgx','LSQ',53.73375,-6.88138888888889,NULL,NULL,'2012-10-12 08:09:54',56212.3402100001,16.436,0.0106,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 17:45:15','2012-10-14 17:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_history.html','liklely cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_snap_63479.gif',36800660497,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575010320,8984536,NULL,NULL,NULL,NULL),(2313,2226,0,'LSQ12fiq','LSQ',70.4199166666667,-9.89291666666667,NULL,NULL,'2012-10-12 07:45:35',56212.32333,19.3293,0.0988,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 17:45:15','2012-10-14 17:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_snap_63552.gif',37499689591,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585932649,9155197,NULL,NULL,NULL,NULL),(2314,2226,0,'LSQ12fiq','LSQ',70.4199166666667,-9.89294444444444,NULL,NULL,'2012-10-12 08:30:18',56212.3543799999,19.4201,0.1023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 17:45:15','2012-10-14 17:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_snap_63553.gif',37499689591,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585932649,9155197,NULL,NULL,NULL,NULL),(2315,2232,0,'LSQ12fik','LSQ',56.764625,-10.9834444444444,NULL,NULL,'2012-10-12 07:29:32',56212.3121799999,19.7283,0.1999,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 17:45:15','2012-10-14 17:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_63556.gif',37025736046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2316,2232,0,'LSQ12fik','LSQ',56.7644166666667,-10.9835555555556,NULL,NULL,'2012-10-12 08:21:51',56212.3485099999,18.8902,0.1298,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 17:45:15','2012-10-14 17:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_63557.gif',37025736046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2317,2247,0,'LSQ12fji','LSQ',57.3123333333333,-6.10372222222222,NULL,NULL,'2012-10-12 08:13:16',56212.3425500002,18.2493,0.0504,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 17:45:15','2012-10-14 17:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_63569.gif',37029491967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2318,2247,0,'LSQ12fji','LSQ',57.312375,-6.10369444444444,NULL,NULL,'2012-10-12 08:44:09',56212.3640000001,18.1843,0.0573,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-14 17:45:15','2012-10-14 17:45:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_63570.gif',37029491967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2319,2025,0,'LSQ12ffo','LSQ',330.439708333333,-22.2058333333333,NULL,NULL,'2012-10-13 03:27:23',56213.14402,20.8259,0.1748,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 12:45:14','2012-10-15 12:45:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffo/LSQ12ffo_history.html','sne - nice',NULL,0.065395,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffo/LSQ12ffo_snap_63692.gif',50869971912,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794843311,12419426,NULL,NULL,NULL,NULL),(2320,2320,1,'LSQ12fjs','LSQ',32.49125,-0.317888888888889,NULL,NULL,'2012-10-10 02:01:25',56210.0843199999,23.5274,0.1789,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjs/LSQ12fjs_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjs/LSQ12fjs_snap_63385.gif',34997777879,NULL,NULL,NULL,'2012-10-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,546840279,8544379,NULL,NULL,NULL,NULL),(2321,2320,0,'LSQ12fjs','LSQ',32.4912083333333,-0.317916666666667,NULL,NULL,'2012-10-10 06:02:05',56210.2514499999,23.6926,0.1357,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjs/LSQ12fjs_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjs/LSQ12fjs_snap_63386.gif',34997777879,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,546840279,8544379,NULL,NULL,NULL,NULL),(2322,2320,0,'LSQ12fjs','LSQ',32.4912916666667,-0.317916666666667,NULL,NULL,'2012-10-11 02:00:43',56211.08384,23.7956,0.1437,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjs/LSQ12fjs_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjs/LSQ12fjs_snap_63387.gif',34997777879,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,546840279,8544379,NULL,NULL,NULL,NULL),(2323,2320,0,'LSQ12fjs','LSQ',32.49125,-0.317888888888889,NULL,NULL,'2012-10-11 04:00:02',56211.1666999999,23.2771,0.1137,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjs/LSQ12fjs_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjs/LSQ12fjs_snap_63367.gif',34997777879,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,546840279,8544379,NULL,NULL,NULL,NULL),(2324,2320,0,'LSQ12fjs','LSQ',32.4912083333333,-0.317916666666667,NULL,NULL,'2012-10-11 06:00:21',56211.25025,23.2635,0.0896,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjs/LSQ12fjs_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjs/LSQ12fjs_snap_63368.gif',34997777879,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,546840279,8544379,NULL,NULL,NULL,NULL),(2325,2325,1,'LSQ12fjo','LSQ',31.29375,0.562805555555556,NULL,NULL,'2012-10-10 04:02:09',56210.1681599999,21.54,0.0566,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjo/LSQ12fjo_history.html','sne - nice',NULL,0.15605,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjo/LSQ12fjo_snap_63371.gif',66994399294,NULL,NULL,NULL,'2012-10-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1046787488,16356054,NULL,NULL,NULL,NULL),(2326,2325,0,'LSQ12fjo','LSQ',31.2935833333333,0.562805555555556,NULL,NULL,'2012-10-11 02:00:43',56211.08384,20.7578,0.0488,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjo/LSQ12fjo_history.html','sne - nice',NULL,0.15605,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjo/LSQ12fjo_snap_63359.gif',66994399294,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1046787488,16356054,NULL,NULL,NULL,NULL),(2327,2325,0,'LSQ12fjo','LSQ',31.2935416666667,0.562861111111111,NULL,NULL,'2012-10-11 04:00:02',56211.1666999999,20.3939,0.0563,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjo/LSQ12fjo_history.html','sne - nice',NULL,0.15605,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjo/LSQ12fjo_snap_63372.gif',66994399294,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1046787488,16356054,NULL,NULL,NULL,NULL),(2328,2325,0,'LSQ12fjo','LSQ',31.2935833333333,0.562833333333333,NULL,NULL,'2012-10-11 06:00:21',56211.25025,20.5352,0.0423,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjo/LSQ12fjo_history.html','sne - nice',NULL,0.15605,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjo/LSQ12fjo_snap_63360.gif',66994399294,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1046787488,16356054,NULL,NULL,NULL,NULL),(2329,2329,1,'LSQ12fki','LSQ',35.7691666666667,9.99619444444444,NULL,NULL,'2012-10-10 06:57:17',56210.2897899998,19.582,0.1376,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fki/LSQ12fki_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fki/LSQ12fki_snap_63846.gif',66858857584,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1044669649,16322963,NULL,NULL,NULL,NULL),(2330,2329,0,'LSQ12fki','LSQ',35.7693333333333,9.99622222222222,NULL,NULL,'2012-10-12 02:40:24',56212.1113999998,19.6622,0.1214,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fki/LSQ12fki_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fki/LSQ12fki_snap_63842.gif',66858857584,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1044669649,16322963,NULL,NULL,NULL,NULL),(2331,2329,0,'LSQ12fki','LSQ',35.76925,9.99616666666667,NULL,NULL,'2012-10-12 07:39:53',56212.3193700002,19.8683,0.0994,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fki/LSQ12fki_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fki/LSQ12fki_snap_63843.gif',66858857584,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1044669649,16322963,NULL,NULL,NULL,NULL),(2332,2329,0,'LSQ12fki','LSQ',35.769125,9.99622222222222,NULL,NULL,'2012-10-13 02:36:24',56213.1086200001,20.0451,0.1678,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fki/LSQ12fki_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fki/LSQ12fki_snap_63880.gif',66858857584,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1044669649,16322963,NULL,NULL,NULL,NULL),(2333,2333,1,'LSQ12fkh','LSQ',37.7215833333333,9.59466666666667,NULL,NULL,'2012-10-12 02:40:24',56212.1113999998,20.8994,0.1794,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkh/LSQ12fkh_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkh/LSQ12fkh_snap_63845.gif',66860301346,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044692208,16323315,NULL,NULL,NULL,NULL),(2334,2333,0,'LSQ12fkh','LSQ',37.7215,9.59480555555556,NULL,NULL,'2012-10-12 06:19:18',56212.2634100001,20.2899,0.1504,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkh/LSQ12fkh_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkh/LSQ12fkh_snap_63840.gif',66860301346,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044692208,16323315,NULL,NULL,NULL,NULL),(2335,2333,0,'LSQ12fkh','LSQ',37.7214583333333,9.59477777777778,NULL,NULL,'2012-10-12 07:39:53',56212.3193700002,18.7641,0.055,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkh/LSQ12fkh_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkh/LSQ12fkh_snap_63841.gif',66860301346,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044692208,16323315,NULL,NULL,NULL,NULL),(2336,2336,1,'LSQ12fkf','LSQ',22.8802083333333,3.41608333333333,NULL,NULL,'2012-10-12 04:07:39',56212.1719900002,19.5361,0.1166,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_snap_63836.gif',67518050300,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1054969535,16483898,NULL,NULL,NULL,NULL),(2337,2336,0,'LSQ12fkf','LSQ',22.8801666666667,3.41605555555556,NULL,NULL,'2012-10-12 06:58:58',56212.2909499998,19.2735,0.1339,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_snap_63837.gif',67518050300,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1054969535,16483898,NULL,NULL,NULL,NULL),(2338,2338,1,'LSQ12fkd','LSQ',322.897833333333,-0.997083333333333,NULL,NULL,'2012-10-10 02:31:55',56210.1055000001,20.0896,0.1709,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkd/LSQ12fkd_history.html','sne - nice',NULL,0.04937,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkd/LSQ12fkd_snap_63844.gif',49701151080,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,776580485,12134070,NULL,NULL,NULL,NULL),(2339,2338,0,'LSQ12fkd','LSQ',322.89775,-0.997111111111111,NULL,NULL,'2012-10-12 00:31:44',56212.0220400002,19.9762,0.1193,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkd/LSQ12fkd_history.html','sne - nice',NULL,0.04937,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkd/LSQ12fkd_snap_63832.gif',49701151080,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,776580485,12134070,NULL,NULL,NULL,NULL),(2340,2338,0,'LSQ12fkd','LSQ',322.898,-0.997027777777778,NULL,NULL,'2012-10-12 02:32:47',56212.1061,19.9284,0.1322,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkd/LSQ12fkd_history.html','sne - nice',NULL,0.04937,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkd/LSQ12fkd_snap_63833.gif',49701151088,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,776580485,12134070,NULL,NULL,NULL,NULL),(2341,2341,1,'LSQ12fkc','LSQ',334.886416666667,-4.11166666666667,NULL,NULL,'2012-10-12 01:30:44',56212.0630199998,19.8124,0.1221,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkc/LSQ12fkc_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkc/LSQ12fkc_snap_63830.gif',49850991382,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778921740,12170652,NULL,NULL,NULL,NULL),(2342,2341,0,'LSQ12fkc','LSQ',334.886416666667,-4.11175,NULL,NULL,'2012-10-12 03:30:23',56212.1461100001,19.7977,0.155,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkc/LSQ12fkc_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkc/LSQ12fkc_snap_63831.gif',49850991382,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778921740,12170652,NULL,NULL,NULL,NULL),(2343,2343,1,'LSQ12fkb','LSQ',335.49425,-5.92138888888889,NULL,NULL,'2012-10-12 01:29:03',56212.0618500002,20.2514,0.1383,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkb/LSQ12fkb_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkb/LSQ12fkb_snap_63828.gif',49849934990,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778905234,12170394,NULL,NULL,NULL,NULL),(2344,2343,0,'LSQ12fkb','LSQ',335.49425,-5.92136111111111,NULL,NULL,'2012-10-12 03:28:42',56212.14494,20.013,0.1276,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkb/LSQ12fkb_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkb/LSQ12fkb_snap_63829.gif',49849934990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778905234,12170394,NULL,NULL,NULL,NULL),(2345,2345,1,'LSQ12fjz','LSQ',46.6902083333333,-6.1495,NULL,NULL,'2012-08-28 09:14:45',56167.3852499998,19.6063,0.2051,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjz/LSQ12fjz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjz/LSQ12fjz_snap_63819.gif',37905517932,NULL,NULL,NULL,'2012-08-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592273717,9254276,NULL,NULL,NULL,NULL),(2346,2345,0,'LSQ12fjz','LSQ',46.6905416666667,-6.14938888888889,NULL,NULL,'2012-10-10 09:03:15',56210.37726,19.4133,0.2116,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjz/LSQ12fjz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjz/LSQ12fjz_snap_63820.gif',37905517935,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592273717,9254276,NULL,NULL,NULL,NULL),(2347,2345,0,'LSQ12fjz','LSQ',46.6906666666667,-6.14922222222222,NULL,NULL,'2012-10-12 08:04:49',56212.3366800002,19.8368,0.1422,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjz/LSQ12fjz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjz/LSQ12fjz_snap_63790.gif',37905517933,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592273717,9254276,NULL,NULL,NULL,NULL),(2348,2345,0,'LSQ12fjz','LSQ',46.6907916666667,-6.14944444444444,NULL,NULL,'2012-10-12 08:39:06',56212.3604899999,19.6958,0.1274,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjz/LSQ12fjz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjz/LSQ12fjz_snap_63791.gif',37905517931,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592273717,9254276,NULL,NULL,NULL,NULL),(2349,2349,1,'LSQ12fjy','LSQ',32.5965416666667,-6.75577777777778,NULL,NULL,'2012-10-08 02:44:14',56208.1140600001,18.5373,0.0352,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_snap_63813.gif',35150329089,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549223892,8581623,NULL,NULL,NULL,NULL),(2350,2349,0,'LSQ12fjy','LSQ',32.5965416666667,-6.75588888888889,NULL,NULL,'2012-10-10 01:50:19',56210.0766199999,18.5307,0.0282,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_snap_63814.gif',35150329089,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549223892,8581623,NULL,NULL,NULL,NULL),(2351,2349,0,'LSQ12fjy','LSQ',32.5965833333333,-6.75583333333333,NULL,NULL,'2012-10-10 03:51:03',56210.1604599999,18.518,0.028,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_snap_63815.gif',35150329089,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549223892,8581623,NULL,NULL,NULL,NULL),(2352,2349,0,'LSQ12fjy','LSQ',32.5965416666667,-6.75583333333333,NULL,NULL,'2012-10-10 05:51:00',56210.24376,18.4853,0.0251,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_snap_63816.gif',35150329089,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549223892,8581623,NULL,NULL,NULL,NULL),(2353,2349,0,'LSQ12fjy','LSQ',32.5965833333333,-6.75586111111111,NULL,NULL,'2012-10-10 07:42:17',56210.3210399998,18.5874,0.0446,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_snap_63817.gif',35150329089,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549223892,8581623,NULL,NULL,NULL,NULL),(2354,2349,0,'LSQ12fjy','LSQ',32.5966666666667,-6.75591666666667,NULL,NULL,'2012-10-10 09:09:59',56210.3819400002,18.4602,0.0625,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_snap_63818.gif',35150329089,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549223892,8581623,NULL,NULL,NULL,NULL),(2355,2349,0,'LSQ12fjy','LSQ',32.596625,-6.75588888888889,NULL,NULL,'2012-10-12 07:51:16',56212.3272699998,18.6647,0.0595,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_snap_63788.gif',35150329089,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549223892,8581623,NULL,NULL,NULL,NULL),(2356,2349,0,'LSQ12fjy','LSQ',32.596625,-6.75586111111111,NULL,NULL,'2012-10-12 08:32:21',56212.3558,18.7468,0.0507,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_snap_63789.gif',35150329089,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549223892,8581623,NULL,NULL,NULL,NULL),(2357,2357,1,'LSQ12fjx','LSQ',69.6076666666667,-10.1938611111111,NULL,NULL,'2012-09-16 08:11:51',56186.3415700002,20.2492,0.195,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_63804.gif',37469589788,NULL,NULL,NULL,'2012-09-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2358,2357,0,'LSQ12fjx','LSQ',69.6076666666667,-10.1938333333333,NULL,NULL,'2012-09-16 08:59:40',56186.3747800002,19.8806,0.1601,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_63805.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2359,2357,0,'LSQ12fjx','LSQ',69.6077083333333,-10.1939166666667,NULL,NULL,'2012-09-22 08:30:53',56192.3547899998,20.0637,0.174,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_63806.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2360,2357,0,'LSQ12fjx','LSQ',69.60775,-10.1938888888889,NULL,NULL,'2012-09-22 09:05:06',56192.37855,20.0141,0.1824,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_63807.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2361,2357,0,'LSQ12fjx','LSQ',69.6077083333333,-10.1939444444444,NULL,NULL,'2012-09-24 09:26:40',56194.3935199999,20.0216,0.1913,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_63808.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2362,2357,0,'LSQ12fjx','LSQ',69.60775,-10.1938611111111,NULL,NULL,'2012-09-26 07:41:07',56196.3202300002,20.2329,0.1757,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_63809.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2363,2357,0,'LSQ12fjx','LSQ',69.6075833333333,-10.1936666666667,NULL,NULL,'2012-10-08 07:26:24',56208.3100000001,19.2625,0.1303,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_63810.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2364,2357,0,'LSQ12fjx','LSQ',69.6076666666667,-10.1938055555556,NULL,NULL,'2012-10-10 07:40:10',56210.3195699998,19.221,0.129,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_63811.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2365,2357,0,'LSQ12fjx','LSQ',69.6077083333333,-10.1938333333333,NULL,NULL,'2012-10-10 08:28:26',56210.3530899999,19.3011,0.1321,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_63812.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2366,2357,0,'LSQ12fjx','LSQ',69.60775,-10.1938888888889,NULL,NULL,'2012-10-12 07:45:35',56212.32333,19.7711,0.1536,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_63786.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2367,2357,0,'LSQ12fjx','LSQ',69.60775,-10.1938888888889,NULL,NULL,'2012-10-12 08:30:18',56212.3543799999,19.8314,0.1515,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_63787.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2368,2368,1,'LSQ12fjw','LSQ',56.3841666666667,-7.39666666666667,NULL,NULL,'2012-09-16 06:58:43',56186.2907799999,19.2947,0.1163,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_history.html','sne - nice',NULL,0.02832,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_snap_63800.gif',37031203527,NULL,NULL,NULL,'2012-09-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578612555,9040821,NULL,NULL,NULL,NULL),(2369,2368,0,'LSQ12fjw','LSQ',56.384125,-7.39655555555556,NULL,NULL,'2012-09-16 08:23:09',56186.3494199999,19.6344,0.1447,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_history.html','sne - nice',NULL,0.02832,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_snap_63801.gif',37031203527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578612555,9040821,NULL,NULL,NULL,NULL),(2370,2368,0,'LSQ12fjw','LSQ',56.3845,-7.39627777777778,NULL,NULL,'2012-09-22 07:37:20',56192.3176000002,19.448,0.1349,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_history.html','sne - nice',NULL,0.02832,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_snap_63802.gif',37031203526,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578612555,9040821,NULL,NULL,NULL,NULL),(2371,2368,0,'LSQ12fjw','LSQ',56.3844583333333,-7.39625,NULL,NULL,'2012-10-10 08:09:21',56210.33983,18.0607,0.0527,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_history.html','sne - nice',NULL,0.02832,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_snap_63803.gif',37031203526,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578612555,9040821,NULL,NULL,NULL,NULL),(2372,2368,0,'LSQ12fjw','LSQ',56.3840833333333,-7.39647222222222,NULL,NULL,'2012-10-12 07:31:12',56212.3133399999,18.2005,0.0568,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_history.html','sne - nice',NULL,0.02832,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_snap_63784.gif',37031203527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578612555,9040821,NULL,NULL,NULL,NULL),(2373,2368,0,'LSQ12fjw','LSQ',56.3841666666667,-7.39666666666667,NULL,NULL,'2012-10-12 08:23:33',56212.3496900001,18.963,0.0899,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2012-10-15 15:45:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_history.html','sne - nice',NULL,0.02832,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_snap_63785.gif',37031203527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578612555,9040821,NULL,NULL,NULL,NULL),(2374,2374,0,'LSQ12fkm','LSQ',328.735125,-23.7349444444444,NULL,NULL,'2012-07-01 05:49:56',56109.2430199999,19.3949,0.1198,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-10-11 20:38:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_history.html','sne?',NULL,0.069024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_snap_63875.gif',50883020785,NULL,NULL,NULL,'2012-06-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795047199,12422612,NULL,NULL,NULL,NULL),(2375,2374,0,'LSQ12fkm','LSQ',328.735375,-23.7348611111111,NULL,NULL,'2012-09-25 03:36:10',56195.1501199999,19.2903,0.1245,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-09-20 18:19:47','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_history.html','sne?',NULL,0.069024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_snap_63876.gif',50883020785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795047199,12422612,NULL,NULL,NULL,NULL),(2376,2374,0,'LSQ12fkm','LSQ',328.735458333333,-23.735,NULL,NULL,'2012-10-03 01:04:43',56203.04495,19.9902,0.1768,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-09-20 18:19:47','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_history.html','sne?',NULL,0.069024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_snap_63877.gif',50883020778,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795047199,12422612,NULL,NULL,NULL,NULL),(2377,2374,0,'LSQ12fkm','LSQ',328.735458333333,-23.7349444444444,NULL,NULL,'2012-10-03 03:06:02',56203.1291899998,19.8712,0.1439,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-09-20 18:19:47','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_history.html','sne?',NULL,0.069024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_snap_63878.gif',50883020785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795047199,12422612,NULL,NULL,NULL,NULL),(2378,2374,0,'LSQ12fkm','LSQ',328.735541666667,-23.7349722222222,NULL,NULL,'2012-10-09 01:16:28',56209.0531100002,20.3134,0.1448,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-09-20 18:19:47','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_history.html','sne?',NULL,0.069024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_snap_63879.gif',50883020778,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795047199,12422612,NULL,NULL,NULL,NULL),(2379,2374,0,'LSQ12fkm','LSQ',328.735625,-23.7349722222222,NULL,NULL,'2012-10-13 01:26:29',56213.06006,19.7111,0.1075,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-09-20 18:19:47','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_history.html','sne?',NULL,0.069024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_snap_63853.gif',50883020778,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795047199,12422612,NULL,NULL,NULL,NULL),(2380,2374,0,'LSQ12fkm','LSQ',328.735541666667,-23.7349166666667,NULL,NULL,'2012-10-13 03:25:42',56213.1428499999,19.6688,0.1063,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 15:45:17','2019-09-20 18:19:47','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_history.html','sne?',NULL,0.069024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_snap_63854.gif',50883020778,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795047199,12422612,NULL,NULL,NULL,NULL),(2381,2241,0,'LSQ12fjm','pessto',69.0455416667,-5.0815,NULL,NULL,'2012-10-15 08:38:23',56215.36,NULL,NULL,NULL,0.03,NULL,'II',NULL,'2012-10-15 18:38:14','2012-10-15 18:38:14','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37460190228,'NTT','EFOSC2','N Elias M Fraser',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585315472,9145554,NULL,NULL,NULL,NULL),(2382,2382,1,'LSQ12bgl','LSQ',161.9446,-6.0724,NULL,NULL,'2012-03-13 00:00:00',55999,19.33,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41796679107,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,653073111,10204267,NULL,NULL,NULL,NULL),(2383,2383,1,'LSQ12bia','LSQ',157.140791667,-10.5782,NULL,NULL,'2012-03-18 00:00:00',56004,18.36,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41761665407,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,652526021,10195719,NULL,NULL,NULL,NULL),(2384,2397,1,'CSS120419-150732+203260','CRTS-CSS',226.883333333,20.54988,NULL,NULL,'2012-03-19 00:00:00',56005,18.5,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59535372207,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,930240190,14535002,NULL,NULL,NULL,NULL),(2385,2385,1,'LSQ12bjm','LSQ',211.9745,-12.7713055556,NULL,NULL,'2012-03-21 00:00:00',56007,16.9,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43644168585,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,681940134,10655314,NULL,NULL,NULL,NULL),(2386,2386,1,'LSQ12biu','LSQ',214.83605,-19.84363,NULL,NULL,'2012-03-21 00:00:00',56007,19.39,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46563650122,NULL,NULL,NULL,'2012-05-31 02:22:33',56078.099,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,727557033,11368078,NULL,NULL,NULL,NULL),(2387,2387,1,'LSQ12bjw','LSQ',213.119708333,-16.5926111111,NULL,NULL,'2012-03-22 00:00:00',56008,19.9,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46546603269,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,727290676,11363916,NULL,NULL,NULL,NULL),(2388,2388,1,'SNhunt119','CRTS',102.804308333,-30.4163,NULL,NULL,'2012-03-23 00:00:00',56009,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,39179751900,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,612183623,9565369,NULL,NULL,NULL,NULL),(2389,2389,1,'LSQ12blb','LSQ',221.992208333,17.5348888889,NULL,NULL,'2012-03-27 00:00:00',56013,18.29,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59588179207,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,931065300,14547895,NULL,NULL,NULL,NULL),(2390,2390,1,'LSQ12bqd','LSQ',197.909,-16.3961111111,NULL,NULL,'2012-03-29 00:00:00',56015,19.3,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,44008015351,NULL,NULL,NULL,'2012-03-01 07:26:24',55987.31,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,687625239,10744144,NULL,NULL,NULL,NULL),(2391,2391,1,'LSQ12bmn','LSQ',216.797083333,18.5901111111,NULL,NULL,'2012-03-30 00:00:00',56016,18.11,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59480629345,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,929384833,14521638,NULL,NULL,NULL,NULL),(2392,2392,1,'LSQ12bpo','LSQ',170.8937,-12.3997,NULL,NULL,'2012-03-30 00:00:00',56016,19.71,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,40972838903,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640200607,10003134,NULL,NULL,NULL,NULL),(2393,2393,1,'LSQ12bnb','LSQ',177.115791667,-2.46280555556,NULL,NULL,'2012-03-31 00:00:00',56017,19,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,40807664003,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,637619750,9962808,NULL,NULL,NULL,NULL),(2394,2394,1,'LSQ12bov','LSQ',209.2935,16.2855,NULL,NULL,'2012-03-31 00:00:00',56017,20.3,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,58384089156,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,912251393,14253928,NULL,NULL,NULL,NULL),(2395,2395,1,'LSQ12bpc','LSQ',222.222916667,15.6148055556,NULL,NULL,'2012-03-31 00:00:00',56017,18.5,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59553041933,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,930516280,14539316,NULL,NULL,NULL,NULL),(2396,2396,1,'LSQ12bnt','LSQ',192.8843,4.0238,NULL,NULL,'2012-04-01 00:00:00',56018,19.58,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,58093498785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,907710918,14182983,NULL,NULL,NULL,NULL),(2397,2397,0,'LSQ12bpg','LSQ',226.8817,20.5501,NULL,NULL,'2012-04-01 00:00:00',56018,19.07,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2012-10-15 21:40:26',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59535372205,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,930240190,14535002,NULL,NULL,NULL,NULL),(2398,2398,1,'LSQ12bph','LSQ',236.885079167,23.07955,NULL,NULL,'2012-04-01 00:00:00',56018,19.25,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59396961033,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,928077516,14501211,NULL,NULL,NULL,NULL),(2399,2399,1,'LSQ12bqn','LSQ',127.181208333,-9.07380555556,NULL,NULL,'2012-04-02 00:00:00',56019,19.6,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,39240394995,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,613131171,9580174,NULL,NULL,NULL,NULL),(2400,2400,1,'LSQ12bpr','LSQ',236.8395,-3.54359,NULL,NULL,'2012-04-02 00:00:00',56019,19.77,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,45599095171,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,712485862,11132591,NULL,NULL,NULL,NULL),(2401,2401,1,'LSQ12bpy','LSQ',204.1682,-21.8543,NULL,NULL,'2012-04-03 00:00:00',56020,20.44,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43771135957,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,683923999,10686312,NULL,NULL,NULL,NULL),(2402,2402,1,'LSQ12brb','LSQ',213.7203,20.1518,NULL,NULL,'2012-04-05 00:00:00',56022,17.91,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59520064553,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,930001008,14531265,NULL,NULL,NULL,NULL),(2403,2403,1,'LSQ12bri','LSQ',203.951416667,-21.3981944444,NULL,NULL,'2012-04-06 00:00:00',56023,17.08,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43768304901,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,683879764,10685621,NULL,NULL,NULL,NULL),(2404,2404,1,'LSQ12brs','LSQ',207.8225,-11.9236944444,NULL,NULL,'2012-04-06 00:00:00',56023,17.7,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43694422437,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,682725350,10667583,NULL,NULL,NULL,NULL),(2405,2405,1,'LSQ12brw','LSQ',155.18075,-4.5558,NULL,NULL,'2012-04-07 00:00:00',56024,17.45,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41263063781,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644735371,10073990,NULL,NULL,NULL,NULL),(2406,2406,1,'LSQ12brx','LSQ',154.499583333,-5.603,NULL,NULL,'2012-04-07 00:00:00',56024,17.62,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41261812717,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,644715823,10073684,NULL,NULL,NULL,NULL),(2407,2407,1,'LSQ12bry','LSQ',154.1607,-6.7766,NULL,NULL,'2012-04-07 00:00:00',56024,17.27,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2020-04-28 09:08:48',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41251120959,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644548764,10071074,NULL,NULL,NULL,NULL),(2408,2408,1,'LSQ12btn','LSQ',140.377083333,-9.6916,NULL,NULL,'2012-04-08 00:00:00',56025,18.25,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,42193606488,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,659275101,10301173,NULL,NULL,NULL,NULL),(2409,2409,1,'LSQ12btw','LSQ',152.620083333,5.5368,NULL,NULL,'2012-04-09 00:00:00',56026,19.14,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,60786776821,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,949793387,14840521,NULL,NULL,NULL,NULL),(2410,2410,1,'CSS120413-132702-014513','CRTS-CSS',201.7585,-1.75352777778,NULL,NULL,'2012-04-13 00:00:00',56030,18.5,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43826049300,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,684782020,10699719,NULL,NULL,NULL,NULL),(2411,2411,1,'CSS120415-170824+030104','CRTS-CSS',257.101458333,3.01763888889,NULL,NULL,'2012-04-15 00:00:00',56032,18.5,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,55991126758,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,874861355,13669708,NULL,NULL,NULL,NULL),(2412,2412,1,'LSQ12bve','LSQ',190.243,-5.36361111111,NULL,NULL,'2012-04-15 00:00:00',56032,18.77,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43179596086,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,674681188,10541893,NULL,NULL,NULL,NULL),(2413,2413,1,'LSQ12bvl','LSQ',213.252708333,-5.8035,NULL,NULL,'2012-04-15 00:00:00',56032,18.22,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43732424844,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,683319138,10676861,NULL,NULL,NULL,NULL),(2414,2414,1,'CSS120416-091631+075020','CRTS-CSS',139.127375,7.83894444444,NULL,NULL,'2012-04-16 00:00:00',56033,19,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,63647901483,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,994498460,15539038,NULL,NULL,NULL,NULL),(2415,2415,1,'LSQ12bxw','LSQ',166.325083333,-8.58138888889,NULL,NULL,'2012-04-16 00:00:00',56033,18.1,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,40900115170,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,639064299,9985379,NULL,NULL,NULL,NULL),(2416,2416,1,'CSS120416-131835+213833','CRTS-CSS',199.646791667,21.6425555556,NULL,NULL,'2012-04-16 00:00:00',56033,19.7,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,58847320006,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,919489375,14367021,NULL,NULL,NULL,NULL),(2417,2417,1,'LSQ12bxu','LSQ',216.852291667,-20.907,NULL,NULL,'2012-04-16 00:00:00',56033,19.66,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46570763074,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,727668173,11369815,NULL,NULL,NULL,NULL),(2418,2418,1,'LSQ12bxv','LSQ',216.814791667,-12.2118055556,NULL,NULL,'2012-04-16 00:00:00',56033,19.23,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46456209685,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,725878276,11341848,NULL,NULL,NULL,NULL),(2419,2419,1,'LSQ12bxp','LSQ',233.067708333,-22.4743888889,NULL,NULL,'2012-04-16 00:00:00',56033,18.79,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46631181033,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,728612203,11384565,NULL,NULL,NULL,NULL),(2420,2420,1,'SSS120416-211543-192250','CRTS-SSS',318.930291667,-19.3805833333,NULL,NULL,'2012-04-16 00:00:00',56033,17.3,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50940006679,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,795937604,12436525,NULL,NULL,NULL,NULL),(2421,2421,1,'LSQ12byu','LSQ',184.0245,9.63530555556,NULL,NULL,'2012-04-17 00:00:00',56034,20.4,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,58216627387,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,909634802,14213043,NULL,NULL,NULL,NULL),(2422,2422,1,'LSQ12byi','LSQ',237.047416667,-3.59930555556,NULL,NULL,'2012-04-17 00:00:00',56034,19.01,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,45599528907,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,712492639,11132697,NULL,NULL,NULL,NULL),(2423,2423,1,'CSS120418-113531+054254','CRTS-CSS',173.87925,5.71502777778,NULL,NULL,'2012-04-18 00:00:00',56035,19.1,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,60381363933,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,943458811,14741543,NULL,NULL,NULL,NULL),(2424,2424,1,'CSS120418-125049+222228','CRTS-CSS',192.702125,22.3745277778,NULL,NULL,'2012-04-18 00:00:00',56035,18.3,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,58891481222,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,920179394,14377803,NULL,NULL,NULL,NULL),(2425,2425,1,'LSQ12bzs','LSQ',228.419916667,-19.4485,NULL,NULL,'2012-04-18 00:00:00',56035,19.48,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46645886497,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,728841976,11388155,NULL,NULL,NULL,NULL),(2426,2426,1,'LSQ12cbn','LSQ',222.002291667,20.8313055556,NULL,NULL,'2012-04-19 00:00:00',56036,20.5,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59532270364,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,930191724,14534245,NULL,NULL,NULL,NULL),(2427,2427,1,'LSQ12cbo','LSQ',224.909,21.318,NULL,NULL,'2012-04-19 00:00:00',56036,19.9,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59541387455,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,930334178,14536471,NULL,NULL,NULL,NULL),(2428,2428,1,'LSQ12bzz','LSQ',158.827916667,-4.4345,NULL,NULL,'2012-04-19 00:00:00',56036,19.6,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41757803697,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,652465682,10194776,NULL,NULL,NULL,NULL),(2429,2429,1,'CSS120419-143825+175814','CRTS-CSS',219.605375,17.9705833333,NULL,NULL,'2012-04-19 00:00:00',56036,20,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59480331093,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'SN',NULL,0,NULL,0,929380173,14521565,NULL,NULL,NULL,NULL),(2430,2430,1,'LSQ12caf','LSQ',244.6015,-4.14919444444,NULL,NULL,'2012-04-19 00:00:00',56036,19.5,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,45556409953,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,711818905,11122170,NULL,NULL,NULL,NULL),(2431,2401,0,'CSS120420-133640-215116','CRTS-CSS',204.168416667,-21.8544166667,NULL,NULL,'2012-04-20 00:00:00',56037,19.4,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2012-10-15 21:40:26',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43771135957,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,683923999,10686312,NULL,NULL,NULL,NULL),(2432,2432,1,'LSQ12ccc','LSQ',216.130583333,-10.5893888889,NULL,NULL,'2012-04-20 00:00:00',56037,19.7,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43523564787,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,680055699,10625870,NULL,NULL,NULL,NULL),(2433,2433,1,'LSQ12cby','LSQ',204.561583333,-20.2996944444,NULL,NULL,'2012-04-20 00:00:00',56037,19,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43763203951,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,683800061,10684375,NULL,NULL,NULL,NULL),(2434,2434,1,'LSQ12cca','LSQ',209.776791667,-14.5961111111,NULL,NULL,'2012-04-20 00:00:00',56037,19.1,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43674355085,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,682411798,10662684,NULL,NULL,NULL,NULL),(2435,2435,1,'SSS120420-204522-504405','CRTS-SSS',311.342041667,-50.7347777778,NULL,NULL,'2012-04-20 00:00:00',56037,17.2,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,51347767049,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,802308860,12536075,NULL,NULL,NULL,NULL),(2436,2429,0,'LSQ12ccx','LSQ',219.605708333,17.971,NULL,NULL,'2012-04-21 00:00:00',56038,19.9,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2012-10-15 21:40:26',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59480331093,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,929380173,14521565,NULL,NULL,NULL,NULL),(2437,2437,1,'LSQ12cda','LSQ',207.509708333,9.62980555556,NULL,NULL,'2012-04-21 00:00:00',56038,19.5,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,58467331402,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,913552053,14274250,NULL,NULL,NULL,NULL),(2438,2438,1,'MASTERJ134201.21-023856.2','MASTER',205.505041667,-2.64894444444,NULL,NULL,'2012-04-21 00:00:00',56038,19.4,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43566442202,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,680725659,10636338,NULL,NULL,NULL,NULL),(2439,2439,1,'CSS120421-143501-071918','CRTS-CSS',218.753166667,-7.32161111111,NULL,NULL,'2012-04-21 00:00:00',56038,19.4,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43527523746,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,680117558,10626836,NULL,NULL,NULL,NULL),(2440,2440,1,'LSQ12cdl','LSQ',193.4165,-18.5073055556,NULL,NULL,'2012-04-22 00:00:00',56039,19.1,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43985406341,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,687271974,10738624,NULL,NULL,NULL,NULL),(2441,2441,1,'PSNJ20522510-0546156','TOCP',313.104583333,-5.771,NULL,NULL,'2012-04-22 00:00:00',56039,17.8,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2020-04-28 09:08:48',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50740101287,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,792814082,12387720,NULL,NULL,NULL,NULL),(2442,2442,1,'LSQ12cer','LSQ',199.285208333,-20.4116111111,NULL,NULL,'2012-04-24 00:00:00',56041,17.7,NULL,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43799086357,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,684360724,10693136,NULL,NULL,NULL,NULL),(2443,2443,1,'CSS120424-151613-095504','CRTS-CSS',229.054375,-9.91775,NULL,NULL,'2012-04-24 00:00:00',56041,19.4,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46488950349,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,726389849,11349841,NULL,NULL,NULL,NULL),(2444,1488,0,'PSNJ18410706-4147374','TOCP',280.279416667,-41.7937222222,NULL,NULL,'2012-04-25 00:00:00',56042,14.5,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2012-10-15 21:40:26',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,51060883888,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,797826310,12466036,NULL,NULL,NULL,NULL),(2445,2445,1,'MLS120429-134155-143539','CRTS-MLS',205.480541667,-14.5940277778,NULL,NULL,'2012-04-29 00:00:00',56046,19.7,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43669191770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,682331121,10661423,NULL,NULL,NULL,NULL),(2446,2446,1,'MLS120429-133606-113718','CRTS-MLS',204.023291667,-11.6215277778,NULL,NULL,'2012-04-29 00:00:00',56046,19.2,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-15 21:40:26','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43855726851,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,1,'SN',NULL,0,NULL,0,685245732,10706964,NULL,NULL,NULL,NULL),(2447,2426,0,'LSQ12cbn','pessto',222.002291667,20.8313055556,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,0.194,NULL,'Ia-pec',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59532270364,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,930191724,14534245,NULL,NULL,NULL,NULL),(2448,2429,0,'LSQ12ccx','pessto',219.605375,17.9705833333,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,0.171,NULL,NULL,NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59480331093,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,929380173,14521565,NULL,NULL,NULL,NULL),(2449,2440,0,'LSQ12cdl','pessto',193.4165,-18.5073055556,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,0.114,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43985406341,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,687271974,10738624,NULL,NULL,NULL,NULL),(2450,2437,0,'LSQ12cda','pessto',207.509708333,9.62980555556,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,0.138,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,58467331402,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,913552053,14274250,NULL,NULL,NULL,NULL),(2451,2445,0,'MLS120429-134155-143539','pessto',205.480541667,-14.5940277778,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,0.141,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43669191770,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,682331121,10661423,NULL,NULL,NULL,NULL),(2452,2438,0,'MASTERJ134201.21-023856.2','pessto',205.505041667,-2.64894444444,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,0.13,NULL,'II?',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43566442202,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,680725659,10636338,NULL,NULL,NULL,NULL),(2453,2446,0,'MLS120429-133606-113718','pessto',204.023291667,-11.6215277778,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,0.074,NULL,'Ia-pec',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43855726851,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,685245732,10706964,NULL,NULL,NULL,NULL),(2454,2401,0,'CSS120420-133640-215116','pessto',204.1682,-21.8543,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,0.111,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43771135957,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,683923999,10686312,NULL,NULL,NULL,NULL),(2455,2432,0,'LSQ12ccc','pessto',216.130583333,-10.5893888889,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,0.18,NULL,'Ia-pec',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43523564787,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,680055699,10625870,NULL,NULL,NULL,NULL),(2456,2442,0,'LSQ12cer','pessto',199.285208333,-20.4116111111,NULL,NULL,'2012-04-29 00:00:00',56046,NULL,NULL,NULL,0.024,NULL,'II',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43799086357,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,684360724,10693136,NULL,NULL,NULL,NULL),(2457,2433,0,'LSQ12cby','pessto',204.561583333,-20.2996944444,NULL,NULL,'2012-04-29 00:00:00',56046,NULL,NULL,NULL,0.093,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43763203951,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,683800061,10684375,NULL,NULL,NULL,NULL),(2458,2427,0,'LSQ12cbo','pessto',224.909,21.318,NULL,NULL,'2012-04-29 00:00:00',56046,NULL,NULL,NULL,0.123,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59541387455,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,930334178,14536471,NULL,NULL,NULL,NULL),(2459,2434,0,'LSQ12cca','pessto',209.776791667,-14.5961111111,NULL,NULL,'2012-04-29 00:00:00',56046,NULL,NULL,NULL,0.104,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43674355085,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,682411798,10662684,NULL,NULL,NULL,NULL),(2460,2439,0,'CSS120421-143501-071918','pessto',218.753166667,-7.32161111111,NULL,NULL,'2012-04-29 00:00:00',56046,NULL,NULL,NULL,0.066,NULL,'II',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43527523746,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,680117558,10626836,NULL,NULL,NULL,NULL),(2461,2443,0,'CSS120424-151613-095504','pessto',229.054375,-9.91775,NULL,NULL,'2012-04-29 00:00:00',56046,NULL,NULL,NULL,0.116,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46488950349,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,726389849,11349841,NULL,NULL,NULL,NULL),(2462,2441,0,'PSNJ20522510-0546156','pessto',313.104583333,-5.771,NULL,NULL,'2012-04-29 00:00:00',56046,NULL,NULL,NULL,0.02,NULL,'II',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50740101287,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,792814082,12387720,NULL,NULL,NULL,NULL),(2463,1488,0,'PSNJ18410706-4147374','pessto',280.28021,-41.794,NULL,NULL,'2012-04-29 00:00:00',56046,NULL,NULL,NULL,0.019,NULL,'IIn',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,51060883888,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,797826310,12466036,NULL,NULL,NULL,NULL),(2464,2428,0,'LSQ12bzz','pessto',158.827916667,-4.4345,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.073,NULL,'Ia-pec',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41757803697,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,652465682,10194776,NULL,NULL,NULL,NULL),(2465,2414,0,'CSS120416-091631+075020','pessto',139.127375,7.83894444444,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.119,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,63647901483,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,994498460,15539038,NULL,NULL,NULL,NULL),(2466,2423,0,'CSS120418-113531+054254','pessto',173.87925,5.71502777778,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.103,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,60381363933,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,943458811,14741543,NULL,NULL,NULL,NULL),(2467,2399,0,'LSQ12bqn','pessto',127.181208333,-9.07380555556,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.091,NULL,'Ic?',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,39240394995,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,613131171,9580174,NULL,NULL,NULL,NULL),(2468,2415,0,'LSQ12bxw','pessto',166.325083333,-8.58138888889,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.1,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,40900115170,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,639064299,9985379,NULL,NULL,NULL,NULL),(2469,2393,0,'LSQ12bnb','pessto',177.115791667,-2.46280555556,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.085,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,40807664003,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,637619750,9962808,NULL,NULL,NULL,NULL),(2470,2416,0,'CSS120416-131835+213833','pessto',199.646791667,21.6425555556,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.063,NULL,'IIP',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,58847320006,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,919489375,14367021,NULL,NULL,NULL,NULL),(2471,2394,0,'LSQ12bov','pessto',209.2935,16.2855,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.063,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,58384089156,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,912251393,14253928,NULL,NULL,NULL,NULL),(2472,2429,0,'CSS120419-143825+175814','pessto',219.605375,17.9705833333,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.179,NULL,'Ia-pec',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59480331093,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,929380173,14521565,NULL,NULL,NULL,NULL),(2473,2395,0,'LSQ12bpc','pessto',222.222916667,15.6148055556,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.05,NULL,'Ia-pec',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59553041933,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,930516280,14539316,NULL,NULL,NULL,NULL),(2474,2390,0,'LSQ12bqd','pessto',197.909,-16.3961111111,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.041,NULL,'IIn',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,44008015351,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,687625239,10744144,NULL,NULL,NULL,NULL),(2475,2385,0,'LSQ12bjm','pessto',211.9745,-12.7713055556,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.053,NULL,'Ia-pec',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43644168585,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,681940134,10655314,NULL,NULL,NULL,NULL),(2476,2387,0,'LSQ12bjw','pessto',213.119708333,-16.5926111111,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.1,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46546603269,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,727290676,11363916,NULL,NULL,NULL,NULL),(2477,2430,0,'LSQ12caf','pessto',244.6015,-4.14919444444,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.095,NULL,'Ia-pec',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,45556409953,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,711818905,11122170,NULL,NULL,NULL,NULL),(2478,2421,0,'LSQ12byu','pessto',184.0245,9.63530555556,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.34,NULL,'Ia-pec',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,58216627387,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,909634802,14213043,NULL,NULL,NULL,NULL),(2479,2411,0,'CSS120415-170824+030104','pessto',257.101458333,3.01763888889,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.077,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,55991126758,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,874861355,13669708,NULL,NULL,NULL,NULL),(2480,2435,0,'SSS120420-204522-504405','pessto',311.342041667,-50.7347777778,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.013,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,51347767049,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,802308860,12536075,NULL,NULL,NULL,NULL),(2481,2424,0,'CSS120418-125049+222228','pessto',192.702125,22.3745277778,NULL,NULL,'2012-04-21 00:00:00',56038,NULL,NULL,NULL,0.072,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,58891481222,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,920179394,14377803,NULL,NULL,NULL,NULL),(2482,2410,0,'CSS120413-132702-014513','pessto',201.7585,-1.75352777778,NULL,NULL,'2012-04-20 00:00:00',56037,NULL,NULL,NULL,0.084,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43826049300,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,684782020,10699719,NULL,NULL,NULL,NULL),(2483,2391,0,'LSQ12bmn','pessto',216.797083333,18.5901111111,NULL,NULL,'2012-04-20 00:00:00',56037,NULL,NULL,NULL,0.083,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59480629345,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,929384833,14521638,NULL,NULL,NULL,NULL),(2484,2412,0,'LSQ12bve','pessto',190.243,-5.36361111111,NULL,NULL,'2012-04-20 00:00:00',56037,NULL,NULL,NULL,0.08,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43179596086,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,674681188,10541893,NULL,NULL,NULL,NULL),(2485,2389,0,'LSQ12blb','pessto',221.992208333,17.5348888889,NULL,NULL,'2012-04-20 00:00:00',56037,NULL,NULL,NULL,0.052,NULL,'IIP',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59588179207,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,931065300,14547895,NULL,NULL,NULL,NULL),(2486,2397,0,'CSS120419-150732+203260','pessto',226.8817,20.5501,NULL,NULL,'2012-04-20 00:00:00',56037,NULL,NULL,NULL,0.077,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59535372205,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,930240190,14535002,NULL,NULL,NULL,NULL),(2487,2413,0,'LSQ12bvl','pessto',213.252708333,-5.8035,NULL,NULL,'2012-04-20 00:00:00',56037,NULL,NULL,NULL,0.065,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43732424844,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,683319138,10676861,NULL,NULL,NULL,NULL),(2488,2417,0,'LSQ12bxu','pessto',216.852291667,-20.907,NULL,NULL,'2012-04-20 00:00:00',56037,NULL,NULL,NULL,0.124,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46570763074,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,727668173,11369815,NULL,NULL,NULL,NULL),(2489,2422,0,'LSQ12byi','pessto',237.047416667,-3.59930555556,NULL,NULL,'2012-04-20 00:00:00',56037,NULL,NULL,NULL,0.104,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,45599528907,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,712492639,11132697,NULL,NULL,NULL,NULL),(2490,2418,0,'LSQ12bxv','pessto',216.814791667,-12.2118055556,NULL,NULL,'2012-04-20 00:00:00',56037,NULL,NULL,NULL,0.098,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46456209685,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,725878276,11341848,NULL,NULL,NULL,NULL),(2491,2425,0,'LSQ12bzs','pessto',228.419916667,-19.4485,NULL,NULL,'2012-04-20 00:00:00',56037,NULL,NULL,NULL,0.085,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46645886497,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,728841976,11388155,NULL,NULL,NULL,NULL),(2492,2419,0,'LSQ12bxp','pessto',233.067708333,-22.4743888889,NULL,NULL,'2012-04-20 00:00:00',56037,NULL,NULL,NULL,0.11,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46631181033,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,728612203,11384565,NULL,NULL,NULL,NULL),(2493,2420,0,'SSS120416-211543-192250','pessto',318.930291667,-19.3805833333,NULL,NULL,'2012-04-20 00:00:00',56037,NULL,NULL,NULL,0.04,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50940006679,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,795937604,12436525,NULL,NULL,NULL,NULL),(2494,2386,0,'LSQ12biu','pessto',214.83605,-19.84363,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.136,NULL,'IIn',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46563650122,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,727557033,11368078,NULL,NULL,NULL,NULL),(2495,2396,0,'LSQ12bnt','pessto',192.8843,4.0238,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.129,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,58093498785,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,907710918,14182983,NULL,NULL,NULL,NULL),(2496,2397,0,'LSQ12bpg','pessto',226.8817,20.5501,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.076,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59535372205,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,930240190,14535002,NULL,NULL,NULL,NULL),(2497,2400,0,'LSQ12bpr','pessto',236.8395,-3.54359,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.102,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,45599095171,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,712485862,11132591,NULL,NULL,NULL,NULL),(2498,2401,0,'LSQ12bpy','pessto',204.1682,-21.8543,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.11,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43771135957,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,683923999,10686312,NULL,NULL,NULL,NULL),(2499,2402,0,'LSQ12brb','pessto',213.7203,20.1518,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.081,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59520064553,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,930001008,14531265,NULL,NULL,NULL,NULL),(2500,2403,0,'LSQ12bri','pessto',203.951416667,-21.3981944444,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.03,NULL,'II',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43768304901,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,683879764,10685621,NULL,NULL,NULL,NULL),(2501,2404,0,'LSQ12brs','pessto',207.8225,-11.9236944444,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.065,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43694422437,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,682725350,10667583,NULL,NULL,NULL,NULL),(2502,2405,0,'LSQ12brw','pessto',155.18075,-4.5558,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.04,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41263063781,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644735371,10073990,NULL,NULL,NULL,NULL),(2503,2406,0,'LSQ12brx','pessto',154.499583333,-5.603,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.054,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41261812717,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,644715823,10073684,NULL,NULL,NULL,NULL),(2504,2407,0,'LSQ12bry','pessto',154.1607,-6.7766,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.042,NULL,'IIn',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41251120959,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644548764,10071074,NULL,NULL,NULL,NULL),(2505,2408,0,'LSQ12btn','pessto',140.377083333,-9.6916,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.057,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,42193606488,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,659275101,10301173,NULL,NULL,NULL,NULL),(2506,2409,0,'LSQ12btw','pessto',152.620083333,5.5368,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.057,NULL,'Ibn',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,60786776821,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,949793387,14840521,NULL,NULL,NULL,NULL),(2507,2398,0,'LSQ12bph','pessto',236.885079167,23.07955,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.045,NULL,'Ic',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59396961033,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,928077516,14501211,NULL,NULL,NULL,NULL),(2508,2388,0,'SNhunt119','pessto',102.804308333,-30.4163,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.025,NULL,'II',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,39179751900,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,612183623,9565369,NULL,NULL,NULL,NULL),(2509,2383,0,'LSQ12bia','pessto',157.140791667,-10.5782,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.053,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41761665407,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,652526021,10195719,NULL,NULL,NULL,NULL),(2510,2382,0,'LSQ12bgl','pessto',161.9446,-6.0724,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.091,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41796679107,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,653073111,10204267,NULL,NULL,NULL,NULL),(2511,2392,0,'LSQ12bpo','pessto',170.8937,-12.3997,NULL,NULL,'2012-04-12 00:00:00',56029,NULL,NULL,NULL,0.12,NULL,'Ia',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,40972838903,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640200607,10003134,NULL,NULL,NULL,NULL),(2513,2513,1,'LSQ12cay','LSQ',249.019333333,5.70997222222,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,56717571036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,886212047,13847063,NULL,NULL,NULL,NULL),(2514,2514,1,'PS1-12agm','Pan-STARRS1',209.287666667,-1.20711111111,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43595429786,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,681178590,10643415,NULL,NULL,NULL,NULL),(2515,2515,1,'CSS120421-135954+263914','CRTS-CSS',209.975,26.6538888889,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,60011095694,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,937673370,14651146,NULL,NULL,NULL,NULL),(2516,2516,1,'LSQ12cbu','LSQ',251.4949,-23.1775,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,45931795146,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,717684299,11213817,NULL,NULL,NULL,NULL),(2517,2517,1,'CSS120415-170341-063047','CRTS-CSS',255.92042,-6.51306,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,45194591501,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,706165492,11033835,NULL,NULL,NULL,NULL),(2518,2518,1,'LSQ12brm','LSQ',236.9565,-21.3335,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46579054824,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,727797731,11371839,NULL,NULL,NULL,NULL),(2519,2519,1,'LSQ12caa','LSQ',193.59075,-6.95666666667,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43130388224,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,673912316,10529879,NULL,NULL,NULL,NULL),(2520,2520,1,'MASTERJ114525.38+212019.8','MASTER',176.35575,21.3388333333,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,61085038720,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,954453730,14913339,NULL,NULL,NULL,NULL),(2521,2421,0,'LSQ12byu','LSQ',184.024958333,9.63563888889,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2012-10-16 09:46:48',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,58216627387,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,909634802,14213043,NULL,NULL,NULL,NULL),(2522,2522,1,'PS1-12yo','Pan-STARRS1',200.066958333,15.9215833333,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59013787017,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,922090422,14407662,NULL,NULL,NULL,NULL),(2523,2523,1,'MASTERJ111440.10+103905.2','MASTER',168.667083333,10.6514444444,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,60331341723,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,942677214,14729331,NULL,NULL,NULL,NULL),(2524,2524,1,'LSQ12ayr','LSQ',150.237833333,7.94275,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,60924044661,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,951938197,14874034,NULL,NULL,NULL,NULL),(2525,2525,1,'LSQ12biv','LSQ',215.106125,-16.8263055556,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46556000926,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,727437514,11366211,NULL,NULL,NULL,NULL),(2526,2526,1,'LSQ12bkt','LSQ',122.290958333,3.33722222222,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,62777625252,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,980900394,15326568,NULL,NULL,NULL,NULL),(2527,2527,1,'LSQ12bql','LSQ',193.538166667,-4.98552777778,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43138223253,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,674034738,10531792,NULL,NULL,NULL,NULL),(2528,2528,1,'LSQ12bsx','LSQ',251.0226,-24.8579,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,45806395904,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,715724936,11183202,NULL,NULL,NULL,NULL),(2529,2529,1,'LSQ12btf','LSQ',185.433583333,-17.5970555556,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43021111677,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,672204869,10503201,NULL,NULL,NULL,NULL),(2530,2530,1,'LSQ12btv','LSQ',155.832875,2.01694444444,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,60748889906,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,949201404,14831271,NULL,NULL,NULL,NULL),(2531,2531,1,'LSQ12bua','LSQ',148.245366667,-0.972583333333,NULL,NULL,'2012-04-19 00:00:00',56036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-16 09:46:48','2019-10-11 14:10:04',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41224892209,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644138940,10064670,NULL,NULL,NULL,NULL),(2532,2523,0,'MASTERJ111440.10+103905.2','pessto',168.667083333,10.6514444444,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'galaxy',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,60331341723,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,942677214,14729331,NULL,NULL,NULL,NULL),(2533,2524,0,'LSQ12ayr','pessto',150.237833333,7.94275,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'not visible',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,60924044661,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,951938197,14874034,NULL,NULL,NULL,NULL),(2534,2421,0,'LSQ12byu','pessto',184.0245,9.63530555556,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,58216627387,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,909634802,14213043,NULL,NULL,NULL,NULL),(2535,2520,0,'MASTERJ114525.38+212019.8','pessto',176.35575,21.3388333333,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'not visible',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,61085038720,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,954453730,14913339,NULL,NULL,NULL,NULL),(2536,2518,0,'LSQ12brm','pessto',236.9565,-21.3335,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'not visible',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46579054824,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,727797731,11371839,NULL,NULL,NULL,NULL),(2537,2517,0,'CSS120415-170341-063047','pessto',255.92042,-6.51306,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'not visible',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,45194591501,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,706165492,11033835,NULL,NULL,NULL,NULL),(2538,2514,0,'PS1-12agm','pessto',209.287666667,-1.20711111111,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'not visible',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43595429786,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,681178590,10643415,NULL,NULL,NULL,NULL),(2539,2513,0,'LSQ12cay','pessto',249.019333333,5.70997222222,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'not visible',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,56717571036,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,886212047,13847063,NULL,NULL,NULL,NULL),(2540,2515,0,'CSS120421-135954+263914','pessto',209.975,26.6538888889,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'noisy - unclear',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,60011095694,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,937673370,14651146,NULL,NULL,NULL,NULL),(2541,2516,0,'LSQ12cbu','pessto',251.4949,-23.1775,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'not visible',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,45931795146,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,717684299,11213817,NULL,NULL,NULL,NULL),(2542,2519,0,'LSQ12caa','pessto',193.59075,-6.95666666667,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'not visible',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43130388224,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,673912316,10529879,NULL,NULL,NULL,NULL),(2543,2522,0,'PS1-12yo','pessto',200.066958333,15.9215833333,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'noisy - unclear',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,59013787017,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,922090422,14407662,NULL,NULL,NULL,NULL),(2544,2525,0,'LSQ12biv','pessto',215.106125,-16.8263055556,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'not visible',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46556000926,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,727437514,11366211,NULL,NULL,NULL,NULL),(2545,2526,0,'LSQ12bkt','pessto',122.290958333,3.33722222222,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'not visible',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,62777625252,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,980900394,15326568,NULL,NULL,NULL,NULL),(2546,2527,0,'LSQ12bql','pessto',193.538166667,-4.98552777778,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'galaxy',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43138223253,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,674034738,10531792,NULL,NULL,NULL,NULL),(2547,2528,0,'LSQ12bsx','pessto',251.0226,-24.8579,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'not visible',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,45806395904,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,715724936,11183202,NULL,NULL,NULL,NULL),(2548,2529,0,'LSQ12btf','pessto',185.433583333,-17.5970555556,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'galaxy',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43021111677,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,672204869,10503201,NULL,NULL,NULL,NULL),(2549,2530,0,'LSQ12btv','pessto',155.832875,2.01694444444,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'galaxy',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,60748889906,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,949201404,14831271,NULL,NULL,NULL,NULL),(2550,2531,0,'LSQ12bua','pessto',148.245366667,-0.972583333333,NULL,NULL,'2012-04-30 00:00:00',56047,NULL,NULL,NULL,NULL,NULL,'not visible',NULL,'2012-10-15 21:17:00','2012-10-15 21:17:00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41224892209,NULL,NULL,'Anon',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644138940,10064670,NULL,NULL,NULL,NULL),(2551,1962,0,'LSQ12fdx','LSQ',40.1495416666667,-9.437,NULL,NULL,'2012-10-14 07:17:41',56214.3039500001,19.6278,0.1404,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_history.html','sn?',NULL,1.925,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_snap_64222.gif',37880582031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,591884094,9248188,NULL,NULL,NULL,NULL),(2552,2044,0,'LSQ12ffx','LSQ',335.200666666667,-20.6736944444444,NULL,NULL,'2012-10-15 01:42:02',56215.0708599999,20.5298,0.14,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_snap_64351.gif',50207229407,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784487959,12257624,NULL,NULL,NULL,NULL),(2553,2068,0,'LSQ12fgb','LSQ',345.267416666667,-17.5894444444444,NULL,NULL,'2012-10-15 01:59:24',56215.08292,20.6609,0.2029,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgb/LSQ12fgb_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgb/LSQ12fgb_snap_64352.gif',50455817388,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,788372146,12318314,NULL,NULL,NULL,NULL),(2554,2126,0,'LSQ12fgy','LSQ',64.7326666666667,-4.19852777777778,NULL,NULL,'2012-10-14 07:01:31',56214.2927299999,17.6053,0.0453,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_snap_63917.gif',36966141573,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577595962,9024936,NULL,NULL,NULL,NULL),(2555,2126,0,'LSQ12fgy','LSQ',64.7325,-4.19852777777778,NULL,NULL,'2012-10-14 08:07:37',56214.3386300001,17.2934,0.0213,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_snap_63918.gif',36966141626,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577595962,9024936,NULL,NULL,NULL,NULL),(2556,2188,0,'LSQ12fhs','LSQ',343.097708333333,-20.6148333333333,NULL,NULL,'2012-10-15 01:59:24',56215.08292,17.7971,0.0237,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhs/LSQ12fhs_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhs/LSQ12fhs_snap_64329.gif',50220581215,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784696581,12260884,NULL,NULL,NULL,NULL),(2557,2188,0,'LSQ12fhs','LSQ',343.097708333333,-20.6148055555556,NULL,NULL,'2012-10-15 04:00:23',56215.1669399999,17.7391,0.0241,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhs/LSQ12fhs_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhs/LSQ12fhs_snap_64330.gif',50220581212,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784696581,12260884,NULL,NULL,NULL,NULL),(2558,2226,0,'LSQ12fiq','LSQ',70.4199166666667,-9.89286111111111,NULL,NULL,'2012-10-14 06:12:04',56214.2583900001,19.288,0.0881,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_snap_64156.gif',37499689591,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585932649,9155197,NULL,NULL,NULL,NULL),(2559,2229,0,'LSQ12fin','LSQ',51.3952916666667,-10.7909722222222,NULL,NULL,'2012-10-14 07:22:46',56214.30748,19.9579,0.1563,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fin/LSQ12fin_history.html','sne?',NULL,0.086383,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fin/LSQ12fin_snap_64148.gif',37886243700,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,591972557,9249571,NULL,NULL,NULL,NULL),(2560,2232,0,'LSQ12fik','LSQ',56.76425,-10.9831111111111,NULL,NULL,'2012-10-14 05:37:53',56214.23465,18.9453,0.0875,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_64164.gif',37025736033,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2561,2241,0,'LSQ12fjm','LSQ',69.045375,-5.08152777777778,NULL,NULL,'2012-10-14 08:20:09',56214.3473299998,18.1446,0.0435,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_snap_63909.gif',37460190256,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585315472,9145554,NULL,NULL,NULL,NULL),(2562,2241,0,'LSQ12fjm','LSQ',69.0454583333333,-5.08152777777778,NULL,NULL,'2012-10-14 08:46:27',56214.3656000001,18.1877,0.0478,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_snap_63910.gif',37460190228,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585315472,9145554,NULL,NULL,NULL,NULL),(2563,2245,0,'LSQ12fjj','LSQ',65.3272083333333,-5.78133333333333,NULL,NULL,'2012-10-14 06:59:49',56214.2915400001,20.0776,0.2145,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjj/LSQ12fjj_history.html','sne or asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjj/LSQ12fjj_snap_64167.gif',36965144235,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577580378,9024693,NULL,NULL,NULL,NULL),(2564,2247,0,'LSQ12fji','LSQ',57.312375,-6.10361111111111,NULL,NULL,'2012-10-14 06:45:44',56214.2817600002,18.5813,0.0626,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_63907.gif',37029491967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2565,2247,0,'LSQ12fji','LSQ',57.312375,-6.10363888888889,NULL,NULL,'2012-10-14 06:47:25',56214.2829300002,18.4423,0.0546,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_64171.gif',37029491967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2566,2247,0,'LSQ12fji','LSQ',57.3123333333333,-6.10366666666667,NULL,NULL,'2012-10-14 07:59:09',56214.3327500001,18.7963,0.0636,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_64172.gif',37029491966,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2567,2247,0,'LSQ12fji','LSQ',57.312375,-6.10363888888889,NULL,NULL,'2012-10-14 08:04:14',56214.3362799999,18.3151,0.0509,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_63908.gif',37029491967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2568,2268,0,'LSQ12fit','LSQ',34.7379583333333,-1.65825,NULL,NULL,'2012-10-14 08:23:51',56214.3498999998,19.9658,0.1225,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fit/LSQ12fit_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fit/LSQ12fit_snap_64179.gif',34915237392,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545550584,8524227,NULL,NULL,NULL,NULL),(2569,2270,0,'LSQ12fis','LSQ',32.56525,1.72111111111111,NULL,NULL,'2012-10-14 04:57:50',56214.20683,23.7278,0.1979,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fis/LSQ12fis_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fis/LSQ12fis_snap_64180.gif',67060952008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1047827375,16372302,NULL,NULL,NULL,NULL),(2570,2295,0,'LSQ12fjr','LSQ',30.5041666666667,-1.93280555555556,NULL,NULL,'2012-10-14 06:56:08',56214.2889899998,20.2897,0.1192,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_snap_63996.gif',35013987766,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547093558,8548336,NULL,NULL,NULL,NULL),(2571,2320,0,'LSQ12fjs','LSQ',32.49125,-0.318138888888889,NULL,NULL,'2012-10-14 06:57:50',56214.2901699999,22.8058,0.1887,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjs/LSQ12fjs_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjs/LSQ12fjs_snap_63998.gif',34997777879,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,546840279,8544379,NULL,NULL,NULL,NULL),(2572,2336,0,'LSQ12fkf','LSQ',22.880125,3.41605555555556,NULL,NULL,'2012-10-14 05:54:25',56214.2461299999,19.0724,0.1011,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_snap_64092.gif',67518050300,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1054969535,16483898,NULL,NULL,NULL,NULL),(2573,2349,0,'LSQ12fjy','LSQ',32.5965833333333,-6.75586111111111,NULL,NULL,'2012-10-14 07:10:24',56214.2988900002,18.7291,0.0553,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2012-10-16 12:45:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_snap_64034.gif',35150329089,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549223892,8581623,NULL,NULL,NULL,NULL),(2574,2374,0,'LSQ12fkm','LSQ',328.735291666667,-23.735,NULL,NULL,'2012-10-15 01:16:40',56215.0532499999,19.2094,0.0892,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2019-09-20 18:19:47','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_history.html','sne?',NULL,0.069024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_snap_64335.gif',50883020785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795047199,12422612,NULL,NULL,NULL,NULL),(2575,2374,0,'LSQ12fkm','LSQ',328.7355,-23.735,NULL,NULL,'2012-10-15 03:18:19',56215.13772,19.308,0.0766,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 12:45:18','2019-09-20 18:19:47','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_history.html','sne?',NULL,0.069024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_snap_64336.gif',50883020778,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795047199,12422612,NULL,NULL,NULL,NULL),(2576,2576,1,'LSQ12fkx','LSQ',345.092958333333,2.89944444444444,NULL,NULL,'2012-10-12 01:39:16',56212.0689400001,19.5952,0.1076,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_snap_63978.gif',51738378612,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,808412165,12631440,NULL,NULL,NULL,NULL),(2577,2576,0,'LSQ12fkx','LSQ',345.092958333333,2.89936111111111,NULL,NULL,'2012-10-12 03:40:44',56212.1532899998,19.7978,0.1006,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_snap_63979.gif',51738378612,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,808412165,12631440,NULL,NULL,NULL,NULL),(2578,2576,0,'LSQ12fkx','LSQ',345.092958333333,2.89947222222222,NULL,NULL,'2012-10-14 01:33:16',56214.0647700001,19.8419,0.0911,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_snap_63933.gif',51738378612,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,808412165,12631440,NULL,NULL,NULL,NULL),(2579,2576,0,'LSQ12fkx','LSQ',345.093,2.89941666666667,NULL,NULL,'2012-10-14 03:32:34',56214.1476199999,20.0433,0.1044,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_snap_63934.gif',51738378612,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,808412165,12631440,NULL,NULL,NULL,NULL),(2580,2580,1,'LSQ12fks','LSQ',65.5729166666667,-6.22886111111111,NULL,NULL,'2012-08-28 08:31:39',56167.3553200001,19.7435,0.1734,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_snap_63974.gif',36948141630,NULL,NULL,NULL,'2012-08-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577314712,9020542,NULL,NULL,NULL,NULL),(2581,2580,0,'LSQ12fks','LSQ',65.5728333333333,-6.22894444444444,NULL,NULL,'2012-08-28 09:19:49',56167.3887700001,19.4268,0.1206,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_snap_63975.gif',36948141617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577314712,9020542,NULL,NULL,NULL,NULL),(2582,2580,0,'LSQ12fks','LSQ',65.573,-6.22897222222222,NULL,NULL,'2012-10-02 06:33:32',56202.2732899999,18.6606,0.2009,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_snap_63976.gif',36948141630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577314712,9020542,NULL,NULL,NULL,NULL),(2583,2580,0,'LSQ12fks','LSQ',65.5735,-6.22919444444444,NULL,NULL,'2012-10-10 08:14:24',56210.3433400001,18.4652,0.0688,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_snap_63977.gif',36948141630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577314712,9020542,NULL,NULL,NULL,NULL),(2584,2580,0,'LSQ12fks','LSQ',65.573125,-6.22902777777778,NULL,NULL,'2012-10-14 07:01:31',56214.2927299999,19.4105,0.135,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_snap_63915.gif',36948141630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577314712,9020542,NULL,NULL,NULL,NULL),(2585,2580,0,'LSQ12fks','LSQ',65.573125,-6.22891666666667,NULL,NULL,'2012-10-14 08:07:37',56214.3386300001,19.1822,0.0854,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_snap_63916.gif',36948141630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577314712,9020542,NULL,NULL,NULL,NULL),(2586,2586,1,'LSQ12fkr','LSQ',56.151625,-5.82819444444444,NULL,NULL,'2012-10-10 08:39:00',56210.3604199998,19.2995,0.1408,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkr/LSQ12fkr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkr/LSQ12fkr_snap_63953.gif',36998458500,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578100914,9032826,NULL,NULL,NULL,NULL),(2587,2586,0,'LSQ12fkr','LSQ',56.1515416666667,-5.82830555555556,NULL,NULL,'2012-10-12 08:11:35',56212.3413800001,19.8173,0.1465,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkr/LSQ12fkr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkr/LSQ12fkr_snap_63954.gif',36998458552,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578100914,9032826,NULL,NULL,NULL,NULL),(2588,2586,0,'LSQ12fkr','LSQ',56.1516666666667,-5.82827777777778,NULL,NULL,'2012-10-12 08:42:29',56212.3628400001,19.9725,0.1409,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkr/LSQ12fkr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkr/LSQ12fkr_snap_63955.gif',36998458500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578100914,9032826,NULL,NULL,NULL,NULL),(2589,2586,0,'LSQ12fkr','LSQ',56.151625,-5.82811111111111,NULL,NULL,'2012-10-14 06:45:44',56214.2817600002,19.5526,0.1032,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkr/LSQ12fkr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkr/LSQ12fkr_snap_63905.gif',36998458500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578100914,9032826,NULL,NULL,NULL,NULL),(2590,2586,0,'LSQ12fkr','LSQ',56.1516666666667,-5.82822222222222,NULL,NULL,'2012-10-14 08:04:14',56214.3362799999,20.1727,0.1176,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkr/LSQ12fkr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkr/LSQ12fkr_snap_63906.gif',36998458500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578100914,9032826,NULL,NULL,NULL,NULL),(2591,2591,1,'LSQ12fkq','LSQ',35.03875,-5.71102777777778,NULL,NULL,'2010-11-22 01:37:23',55522.0676299999,18.9018,0.1359,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_63937.gif',34917798481,NULL,NULL,NULL,'2010-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2592,2591,0,'LSQ12fkq','LSQ',35.0388333333333,-5.71122222222222,NULL,NULL,'2012-08-20 08:06:18',56159.3377100001,20.038,0.1025,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_63938.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2593,2591,0,'LSQ12fkq','LSQ',35.038875,-5.71094444444444,NULL,NULL,'2012-08-20 09:11:08',56159.3827399998,20.4604,0.1335,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_63939.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2594,2591,0,'LSQ12fkq','LSQ',35.0390833333333,-5.71122222222222,NULL,NULL,'2012-10-02 05:58:55',56202.2492499999,19.1624,0.1403,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_63940.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2595,2591,0,'LSQ12fkq','LSQ',35.0389166666667,-5.71116666666667,NULL,NULL,'2012-10-10 07:45:40',56210.32339,18.3912,0.039,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_63943.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2596,2591,0,'LSQ12fkq','LSQ',35.0392916666667,-5.71127777777778,NULL,NULL,'2012-10-10 07:47:21',56210.3245600001,20.5821,0.1299,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_63941.gif',34917798483,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2597,2591,0,'LSQ12fkq','LSQ',35.0391666666667,-5.71133333333333,NULL,NULL,'2012-10-10 08:32:14',56210.3557199999,19.4228,0.0673,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_63942.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2598,2591,0,'LSQ12fkq','LSQ',35.0389583333333,-5.71119444444444,NULL,NULL,'2012-10-10 09:08:19',56210.3807799998,18.4427,0.0568,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_63944.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2599,2591,0,'LSQ12fkq','LSQ',35.0389166666667,-5.71119444444444,NULL,NULL,'2012-10-12 07:54:39',56212.32962,18.405,0.0415,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_63947.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2600,2591,0,'LSQ12fkq','LSQ',35.039125,-5.71127777777778,NULL,NULL,'2012-10-12 07:56:21',56212.3308100002,19.161,0.0775,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_63945.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2601,2591,0,'LSQ12fkq','LSQ',35.03925,-5.71133333333333,NULL,NULL,'2012-10-12 08:52:35',56212.36986,19.7134,0.0942,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_63946.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2602,2591,0,'LSQ12fkq','LSQ',35.0389166666667,-5.71111111111111,NULL,NULL,'2012-10-12 08:54:16',56212.37103,18.4814,0.0513,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_63948.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2603,2591,0,'LSQ12fkq','LSQ',35.0389166666667,-5.71122222222222,NULL,NULL,'2012-10-14 06:14:04',56214.25978,18.8962,0.0505,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_63901.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2604,2591,0,'LSQ12fkq','LSQ',35.0391666666667,-5.71130555555556,NULL,NULL,'2012-10-14 06:15:46',56214.26095,19.1669,0.0569,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_63903.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2605,2591,0,'LSQ12fkq','LSQ',35.039125,-5.71130555555556,NULL,NULL,'2012-10-14 07:43:32',56214.3218999999,19.1831,0.0667,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_63904.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2606,2591,0,'LSQ12fkq','LSQ',35.0388333333333,-5.71122222222222,NULL,NULL,'2012-10-14 07:52:00',56214.3277799999,18.6399,0.0396,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 14:45:19','2012-10-16 14:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_63902.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2607,1962,0,'LSQ12fdx','LSQ',40.1496666666667,-9.437,NULL,NULL,'2012-10-16 05:41:46',56216.23734,20.3201,0.1871,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_history.html','sn?',NULL,1.925,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_snap_64742.gif',37880582031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,591884094,9248188,NULL,NULL,NULL,NULL),(2608,2122,0,'LSQ12fhe','LSQ',323.038708333333,-5.72602777777778,NULL,NULL,'2012-10-16 00:25:48',56216.01792,15.3994,0.0045,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_history.html','sne - nice',NULL,0.027472,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_snap_64546.gif',49713333864,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776770841,12137044,NULL,NULL,NULL,NULL),(2609,2122,0,'LSQ12fhe','LSQ',323.038875,-5.72613888888889,NULL,NULL,'2012-10-16 00:27:29',56216.0190900001,15.5179,0.0046,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_history.html','sne - nice',NULL,0.027472,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_snap_64547.gif',49713333864,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776770841,12137044,NULL,NULL,NULL,NULL),(2610,2126,0,'LSQ12fgy','LSQ',64.7325416666667,-4.19847222222222,NULL,NULL,'2012-10-16 08:37:56',56216.3596800002,17.2512,0.0208,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_snap_64543.gif',36966141626,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577595962,9024936,NULL,NULL,NULL,NULL),(2611,2126,0,'LSQ12fgy','LSQ',64.7324583333333,-4.1985,NULL,NULL,'2012-10-16 08:53:26',56216.3704499998,17.3149,0.0223,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_snap_64544.gif',36966141626,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577595962,9024936,NULL,NULL,NULL,NULL),(2612,2128,0,'LSQ12fgx','LSQ',53.73375,-6.88136111111111,NULL,NULL,'2012-10-16 06:45:38',56216.2817000002,16.4177,0.0107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_history.html','liklely cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_snap_64545.gif',36800660497,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575010320,8984536,NULL,NULL,NULL,NULL),(2613,2226,0,'LSQ12fiq','LSQ',70.4199583333333,-9.89286111111111,NULL,NULL,'2012-10-16 06:22:58',56216.2659499999,19.2564,0.0719,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_snap_64673.gif',37499689591,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585932649,9155197,NULL,NULL,NULL,NULL),(2614,2226,0,'LSQ12fiq','LSQ',70.4199166666667,-9.89286111111111,NULL,NULL,'2012-10-16 07:46:31',56216.3239799999,19.4121,0.0756,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_snap_64674.gif',37499689591,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585932649,9155197,NULL,NULL,NULL,NULL),(2615,2232,0,'LSQ12fik','LSQ',56.7643333333333,-10.9835277777778,NULL,NULL,'2012-10-16 06:11:07',56216.2577300002,19.5043,0.1163,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_64671.gif',37025736046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2616,2232,0,'LSQ12fik','LSQ',56.76425,-10.9833888888889,NULL,NULL,'2012-10-16 08:10:43',56216.3407800002,19.6153,0.1285,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_64672.gif',37025736046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2617,2241,0,'LSQ12fjm','LSQ',69.045375,-5.08152777777778,NULL,NULL,'2012-10-16 08:39:38',56216.3608599999,18.1275,0.0412,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_snap_64706.gif',37460190256,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585315472,9145554,NULL,NULL,NULL,NULL),(2618,2241,0,'LSQ12fjm','LSQ',69.0454166666667,-5.08152777777778,NULL,NULL,'2012-10-16 09:05:49',56216.37904,18.0591,0.0526,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_snap_64707.gif',37460190256,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585315472,9145554,NULL,NULL,NULL,NULL),(2619,2245,0,'LSQ12fjj','LSQ',65.3271666666667,-5.78138888888889,NULL,NULL,'2012-10-16 08:36:15',56216.3585100002,19.5086,0.1707,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjj/LSQ12fjj_history.html','sne or asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjj/LSQ12fjj_snap_64688.gif',36965144235,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577580378,9024693,NULL,NULL,NULL,NULL),(2620,2247,0,'LSQ12fji','LSQ',57.3124166666667,-6.10361111111111,NULL,NULL,'2012-10-16 08:29:29',56216.3538099998,18.4324,0.0519,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_64681.gif',37029491967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2621,2247,0,'LSQ12fji','LSQ',57.3123333333333,-6.10366666666667,NULL,NULL,'2012-10-16 08:31:10',56216.3549799998,18.6235,0.0564,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_64680.gif',37029491966,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2622,2270,0,'LSQ12fis','LSQ',32.5651666666667,1.72108333333333,NULL,NULL,'2012-10-16 04:51:53',56216.2026999998,21.9431,0.0583,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fis/LSQ12fis_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fis/LSQ12fis_snap_64703.gif',67060951892,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1047827373,16372302,NULL,NULL,NULL,NULL),(2623,2295,0,'LSQ12fjr','LSQ',30.5042916666667,-1.93283333333333,NULL,NULL,'2012-10-16 04:50:12',56216.2015300002,20.6619,0.2021,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_snap_64438.gif',35013987766,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547093558,8548336,NULL,NULL,NULL,NULL),(2624,2336,0,'LSQ12fkf','LSQ',22.8799166666667,3.41602777777778,NULL,NULL,'2012-10-16 02:04:17',56216.0863100002,19.1914,0.1011,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_snap_64541.gif',67518050303,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1054969535,16483898,NULL,NULL,NULL,NULL),(2625,2336,0,'LSQ12fkf','LSQ',22.880125,3.416,NULL,NULL,'2012-10-16 04:05:56',56216.1707899999,19.1356,0.14,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_snap_64542.gif',67518050300,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1054969535,16483898,NULL,NULL,NULL,NULL),(2626,2343,0,'LSQ12fkb','LSQ',335.494125,-5.92133333333333,NULL,NULL,'2012-10-16 01:16:20',56216.05302,20.1798,0.1328,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkb/LSQ12fkb_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkb/LSQ12fkb_snap_64516.gif',49849934990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778905234,12170394,NULL,NULL,NULL,NULL),(2627,2357,0,'LSQ12fjx','LSQ',69.6077083333333,-10.1937777777778,NULL,NULL,'2012-10-16 06:22:58',56216.2659499999,19.4605,0.1364,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_64510.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2628,2357,0,'LSQ12fjx','LSQ',69.607875,-10.1938333333333,NULL,NULL,'2012-10-16 07:46:31',56216.3239799999,20.0053,0.1552,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_64511.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2629,2368,0,'LSQ12fjw','LSQ',56.3842916666667,-7.39608333333333,NULL,NULL,'2012-10-16 07:41:27',56216.3204600001,18.9076,0.0959,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_history.html','sne - nice',NULL,0.02832,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_snap_64503.gif',37031203527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578612555,9040821,NULL,NULL,NULL,NULL),(2630,2576,0,'LSQ12fkx','LSQ',345.093041666667,2.89944444444444,NULL,NULL,'2012-10-16 01:24:53',56216.05895,19.86,0.0896,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_snap_64555.gif',51738378612,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,808412165,12631440,NULL,NULL,NULL,NULL),(2631,2576,0,'LSQ12fkx','LSQ',345.093,2.89936111111111,NULL,NULL,'2012-10-16 03:26:59',56216.1437400002,19.7656,0.0945,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_snap_64556.gif',51738378612,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,808412165,12631440,NULL,NULL,NULL,NULL),(2632,2580,0,'LSQ12fks','LSQ',65.5732083333333,-6.22902777777778,NULL,NULL,'2012-10-16 08:37:56',56216.3596800002,19.9834,0.1734,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_snap_64565.gif',36948141630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577314712,9020542,NULL,NULL,NULL,NULL),(2633,2580,0,'LSQ12fks','LSQ',65.573125,-6.22908333333333,NULL,NULL,'2012-10-16 08:53:26',56216.3704499998,19.5624,0.1363,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_snap_64566.gif',36948141630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577314712,9020542,NULL,NULL,NULL,NULL),(2634,2586,0,'LSQ12fkr','LSQ',56.151625,-5.82825,NULL,NULL,'2012-10-16 08:29:29',56216.3538099998,19.7501,0.1795,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkr/LSQ12fkr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkr/LSQ12fkr_snap_64646.gif',36998458500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578100914,9032826,NULL,NULL,NULL,NULL),(2635,2591,0,'LSQ12fkq','LSQ',35.0390416666667,-5.71127777777778,NULL,NULL,'2012-10-16 06:30:22',56216.2710899999,19.2123,0.0596,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_64558.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2636,2591,0,'LSQ12fkq','LSQ',35.0389166666667,-5.71111111111111,NULL,NULL,'2012-10-16 07:50:12',56216.3265300002,18.5611,0.0476,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_64559.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2637,2591,0,'LSQ12fkq','LSQ',35.038875,-5.71122222222222,NULL,NULL,'2012-10-16 08:05:27',56216.3371199998,19.3074,0.0645,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-16 21:45:19','2012-10-16 21:45:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_64560.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2638,2226,0,'LSQ12fiq','pessto',70.42,-9.89294444444,NULL,NULL,'2012-10-17 08:09:35',56217.34,NULL,NULL,NULL,0.15,NULL,'Ia',NULL,'2012-10-17 10:56:11','2012-10-17 10:56:11','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37499689591,'NTT','EFOSC2','Nancy EliasRosa Antonia MoralesGaroffolo',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585932649,9155197,NULL,NULL,NULL,NULL),(2639,2232,0,'LSQ12fik','atel',56.764375,-10.9834166667,NULL,NULL,'2012-10-16 00:00:00',56216,NULL,NULL,NULL,0,NULL,'AGN',NULL,'2012-10-17 13:33:52','2012-10-17 13:33:52','http://www.astronomerstelegram.org/?read=4492',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37025736046,'UH 2.2m','SNIFS','SN factory II',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2640,2640,1,'LSQ12flu','LSQ',344.467208333333,0.899611111111111,NULL,NULL,'2012-10-16 01:36:10',56216.0667900001,19.0591,0.0443,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flu/LSQ12flu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flu/LSQ12flu_snap_64930.gif',51699671670,NULL,NULL,NULL,'2012-09-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,807807369,12621990,NULL,NULL,NULL,NULL),(2641,2640,0,'LSQ12flu','LSQ',344.46725,0.899638888888889,NULL,NULL,'2012-10-16 03:36:01',56216.1500200001,19.0622,0.0478,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flu/LSQ12flu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flu/LSQ12flu_snap_64931.gif',51699671670,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,807807369,12621990,NULL,NULL,NULL,NULL),(2642,2642,1,'LSQ12fls','LSQ',35.3907083333333,2.64305555555556,NULL,NULL,'2012-10-14 05:05:04',56214.2118600002,16.9111,0.0117,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fls/LSQ12fls_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fls/LSQ12fls_snap_65040.gif',66888306583,NULL,NULL,NULL,'2010-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045129790,16330152,NULL,NULL,NULL,NULL),(2643,2642,0,'LSQ12fls','LSQ',35.3907916666667,2.643,NULL,NULL,'2012-10-14 07:05:11',56214.2952700001,16.7901,0.0104,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fls/LSQ12fls_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fls/LSQ12fls_snap_65041.gif',66888306583,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045129790,16330152,NULL,NULL,NULL,NULL),(2644,2642,0,'LSQ12fls','LSQ',35.3907916666667,2.643,NULL,NULL,'2012-10-16 04:55:16',56216.20505,16.896,0.0108,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fls/LSQ12fls_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fls/LSQ12fls_snap_64926.gif',66888306583,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045129790,16330152,NULL,NULL,NULL,NULL),(2645,2642,0,'LSQ12fls','LSQ',35.390875,2.64305555555556,NULL,NULL,'2012-10-16 06:56:02',56216.2889200002,16.8074,0.0119,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fls/LSQ12fls_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fls/LSQ12fls_snap_64927.gif',66888306583,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045129790,16330152,NULL,NULL,NULL,NULL),(2646,2646,1,'LSQ12flr','LSQ',35.4300833333333,2.49688888888889,NULL,NULL,'2012-10-14 07:05:11',56214.2952700001,19.3758,0.107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flr/LSQ12flr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flr/LSQ12flr_snap_65039.gif',66888428907,NULL,NULL,NULL,'2010-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045131701,16330182,NULL,NULL,NULL,NULL),(2647,2646,0,'LSQ12flr','LSQ',35.4300833333333,2.49691666666667,NULL,NULL,'2012-10-16 04:55:16',56216.20505,19.5986,0.0702,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flr/LSQ12flr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flr/LSQ12flr_snap_64924.gif',66888428907,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045131701,16330182,NULL,NULL,NULL,NULL),(2648,2646,0,'LSQ12flr','LSQ',35.430125,2.49697222222222,NULL,NULL,'2012-10-16 06:56:02',56216.2889200002,19.6968,0.076,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flr/LSQ12flr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flr/LSQ12flr_snap_64925.gif',66888428907,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045131701,16330182,NULL,NULL,NULL,NULL),(2649,2649,1,'LSQ12fll','LSQ',328.636666666667,-6.23113888888889,NULL,NULL,'2012-10-04 01:34:20',56204.0655200002,20.7695,0.1574,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fll/LSQ12fll_history.html','sne?',NULL,0.858,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fll/LSQ12fll_snap_65001.gif',49921794452,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,780028038,12187938,NULL,NULL,NULL,NULL),(2650,2649,0,'LSQ12fll','LSQ',328.636666666667,-6.23108333333333,NULL,NULL,'2012-10-10 03:04:33',56210.1281599998,20.0227,0.1107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fll/LSQ12fll_history.html','sne?',NULL,0.858,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fll/LSQ12fll_snap_65002.gif',49921794452,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,780028038,12187938,NULL,NULL,NULL,NULL),(2651,2649,0,'LSQ12fll','LSQ',328.636666666667,-6.23102777777778,NULL,NULL,'2012-10-14 00:53:33',56214.0371900001,20.2562,0.1867,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fll/LSQ12fll_history.html','sne?',NULL,0.858,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fll/LSQ12fll_snap_65003.gif',49921794452,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,780028038,12187938,NULL,NULL,NULL,NULL),(2652,2649,0,'LSQ12fll','LSQ',328.636666666667,-6.231,NULL,NULL,'2012-10-14 02:53:58',56214.1208199998,20.1454,0.0929,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fll/LSQ12fll_history.html','sne?',NULL,0.858,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fll/LSQ12fll_snap_65004.gif',49921794452,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,780028038,12187938,NULL,NULL,NULL,NULL),(2653,2649,0,'LSQ12fll','LSQ',328.636625,-6.23108333333333,NULL,NULL,'2012-10-16 00:46:47',56216.0324900001,20.0464,0.1107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fll/LSQ12fll_history.html','sne?',NULL,0.858,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fll/LSQ12fll_snap_64912.gif',49921794452,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,780028038,12187938,NULL,NULL,NULL,NULL),(2654,2649,0,'LSQ12fll','LSQ',328.636708333333,-6.23105555555556,NULL,NULL,'2012-10-16 02:46:38',56216.1157200001,20.1789,0.1122,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fll/LSQ12fll_history.html','sne?',NULL,0.858,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fll/LSQ12fll_snap_64913.gif',49921794452,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,780028038,12187938,NULL,NULL,NULL,NULL),(2655,2655,1,'LSQ12fli','LSQ',67.7674166666667,-7.20380555555556,NULL,NULL,'2012-10-10 08:17:49',56210.34571,19.4609,0.1823,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_snap_64998.gif',37505778949,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586027796,9156684,NULL,NULL,NULL,NULL),(2656,2655,0,'LSQ12fli','LSQ',67.7675416666667,-7.20380555555556,NULL,NULL,'2012-10-10 08:47:25',56210.3662700001,19.8394,0.1602,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_snap_64999.gif',37505778949,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586027796,9156684,NULL,NULL,NULL,NULL),(2657,2655,0,'LSQ12fli','LSQ',67.7674583333333,-7.20377777777778,NULL,NULL,'2012-10-14 08:48:09',56214.3667799998,19.2643,0.1736,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_snap_65000.gif',37505778949,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586027796,9156684,NULL,NULL,NULL,NULL),(2658,2655,0,'LSQ12fli','LSQ',67.7674583333333,-7.20380555555556,NULL,NULL,'2012-10-16 08:41:19',56216.36203,18.8843,0.1215,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_snap_64906.gif',37505778949,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586027796,9156684,NULL,NULL,NULL,NULL),(2659,2655,0,'LSQ12fli','LSQ',67.7674583333333,-7.20386111111111,NULL,NULL,'2012-10-16 08:55:07',56216.3716199999,18.9058,0.1272,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_snap_64907.gif',37505778949,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586027796,9156684,NULL,NULL,NULL,NULL),(2660,2660,1,'LSQ12flb','LSQ',68.1233333333333,-3.30727777777778,NULL,NULL,'2012-10-16 08:39:38',56216.3608599999,18.8605,0.0885,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flb/LSQ12flb_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flb/LSQ12flb_snap_64892.gif',37462033171,NULL,NULL,NULL,'2012-10-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,585344268,9146004,NULL,NULL,NULL,NULL),(2661,2660,0,'LSQ12flb','LSQ',68.12325,-3.30713888888889,NULL,NULL,'2012-10-16 09:05:49',56216.37904,18.7764,0.1357,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flb/LSQ12flb_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flb/LSQ12flb_snap_64893.gif',37462033170,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,585344268,9146004,NULL,NULL,NULL,NULL),(2662,2662,1,'LSQ12fkz','LSQ',65.0195,-4.06147222222222,NULL,NULL,'2012-08-28 09:24:53',56167.3922899999,20.1321,0.1603,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_snap_65005.gif',36920772805,NULL,NULL,NULL,'2012-08-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,576887075,9013860,NULL,NULL,NULL,NULL),(2663,2662,0,'LSQ12fkz','LSQ',65.0195833333333,-4.06147222222222,NULL,NULL,'2012-10-10 08:12:44',56210.3421800002,19.912,0.1703,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_snap_65006.gif',36920772805,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,576887075,9013860,NULL,NULL,NULL,NULL),(2664,2662,0,'LSQ12fkz','LSQ',65.0195833333333,-4.06130555555556,NULL,NULL,'2012-10-14 06:59:49',56214.2915400001,19.8134,0.1525,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_snap_65007.gif',36920772805,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,576887075,9013860,NULL,NULL,NULL,NULL),(2665,2662,0,'LSQ12fkz','LSQ',65.0195416666667,-4.06158333333333,NULL,NULL,'2012-10-14 08:05:55',56214.33745,19.623,0.1124,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_snap_65008.gif',36920772812,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,576887075,9013860,NULL,NULL,NULL,NULL),(2666,2662,0,'LSQ12fkz','LSQ',65.0195833333333,-4.06144444444444,NULL,NULL,'2012-10-16 08:36:15',56216.3585100002,19.4389,0.0997,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_snap_64888.gif',36920772805,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,576887075,9013860,NULL,NULL,NULL,NULL),(2667,2662,0,'LSQ12fkz','LSQ',65.0195833333333,-4.0615,NULL,NULL,'2012-10-16 09:07:30',56216.3802100001,19.5661,0.1601,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 16:48:10','2012-10-17 16:48:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_snap_64889.gif',36920772805,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,576887075,9013860,NULL,NULL,NULL,NULL),(2668,2025,0,'LSQ12ffo','LSQ',330.439708333333,-22.2059444444444,NULL,NULL,'2012-10-17 01:12:23',56217.05027,20.1656,0.1425,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 21:45:21','2012-10-17 21:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffo/LSQ12ffo_history.html','sne - nice',NULL,0.065395,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffo/LSQ12ffo_snap_65050.gif',50869971912,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794843311,12419426,NULL,NULL,NULL,NULL),(2669,2188,0,'LSQ12fhs','LSQ',343.097666666667,-20.6148333333333,NULL,NULL,'2012-10-17 02:00:10',56217.0834499998,17.6981,0.0243,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 21:45:21','2012-10-17 21:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhs/LSQ12fhs_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhs/LSQ12fhs_snap_65094.gif',50220581215,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784696581,12260884,NULL,NULL,NULL,NULL),(2670,2188,0,'LSQ12fhs','LSQ',343.097708333333,-20.6148055555556,NULL,NULL,'2012-10-17 04:02:01',56217.1680700001,17.6599,0.0273,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 21:45:21','2012-10-17 21:45:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhs/LSQ12fhs_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhs/LSQ12fhs_snap_65095.gif',50220581212,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784696581,12260884,NULL,NULL,NULL,NULL),(2671,2374,0,'LSQ12fkm','LSQ',328.735625,-23.7346666666667,NULL,NULL,'2012-10-17 01:10:42',56217.0490999999,20.0258,0.1376,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 21:45:21','2019-09-20 18:19:47','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_history.html','sne?',NULL,0.069024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_snap_65067.gif',50883020785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795047199,12422612,NULL,NULL,NULL,NULL),(2672,2374,0,'LSQ12fkm','LSQ',328.735375,-23.7349166666667,NULL,NULL,'2012-10-17 03:11:08',56217.1327399998,19.5562,0.0855,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-17 21:45:21','2019-09-20 18:19:47','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_history.html','sne?',NULL,0.069024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_snap_65068.gif',50883020785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795047199,12422612,NULL,NULL,NULL,NULL),(2673,1962,0,'LSQ12fdx','LSQ',40.1494166666667,-9.43713888888889,NULL,NULL,'2012-10-18 05:09:04',56218.2146399999,19.7157,0.1407,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_history.html','sn?',NULL,1.925,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_snap_65440.gif',37880582031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,591884094,9248188,NULL,NULL,NULL,NULL),(2674,1962,0,'LSQ12fdx','LSQ',40.1494583333333,-9.43708333333333,NULL,NULL,'2012-10-18 07:40:16',56218.3196399999,19.6726,0.1353,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_history.html','sn?',NULL,1.925,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_snap_65441.gif',37880582031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,591884094,9248188,NULL,NULL,NULL,NULL),(2675,2118,0,'LSQ12fhh','LSQ',49.1314166666667,-0.467722222222222,NULL,NULL,'2012-10-18 08:21:21',56218.3481600001,17.3713,0.0421,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhh/LSQ12fhh_history.html','sne- nice',NULL,0.02268,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhh/LSQ12fhh_snap_65275.gif',36787815618,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574809619,8981400,NULL,NULL,NULL,NULL),(2676,2118,0,'LSQ12fhh','LSQ',49.1314166666667,-0.467722222222222,NULL,NULL,'2012-10-18 08:43:45',56218.3637199998,17.2617,0.0361,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhh/LSQ12fhh_history.html','sne- nice',NULL,0.02268,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhh/LSQ12fhh_snap_65276.gif',36787815618,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574809619,8981400,NULL,NULL,NULL,NULL),(2677,2122,0,'LSQ12fhe','LSQ',323.03875,-5.72602777777778,NULL,NULL,'2012-10-18 00:19:27',56218.01351,15.4051,0.0048,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_history.html','sne - nice',NULL,0.027472,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_snap_65273.gif',49713333864,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776770841,12137044,NULL,NULL,NULL,NULL),(2678,2122,0,'LSQ12fhe','LSQ',323.038875,-5.72611111111111,NULL,NULL,'2012-10-18 00:21:09',56218.0146900001,15.5213,0.0049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_history.html','sne - nice',NULL,0.027472,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhe/LSQ12fhe_snap_65274.gif',49713333864,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,776770841,12137044,NULL,NULL,NULL,NULL),(2679,2126,0,'LSQ12fgy','LSQ',64.7325,-4.19852777777778,NULL,NULL,'2012-10-18 08:09:17',56218.3397900001,17.6401,0.0277,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_snap_65271.gif',36966141626,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577595962,9024936,NULL,NULL,NULL,NULL),(2680,2126,0,'LSQ12fgy','LSQ',64.7325416666667,-4.19852777777778,NULL,NULL,'2012-10-18 08:38:25',56218.36002,17.5946,0.0241,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_snap_65272.gif',36966141626,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577595962,9024936,NULL,NULL,NULL,NULL),(2681,2128,0,'LSQ12fgx','LSQ',53.7337916666667,-6.88136111111111,NULL,NULL,'2012-10-18 06:33:21',56218.2731599999,16.4418,0.011,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_history.html','liklely cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_snap_65277.gif',36800660497,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575010320,8984536,NULL,NULL,NULL,NULL),(2682,2128,0,'LSQ12fgx','LSQ',53.73375,-6.88136111111111,NULL,NULL,'2012-10-18 07:50:26',56218.32669,16.356,0.0101,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_history.html','liklely cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgx/LSQ12fgx_snap_65278.gif',36800660497,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575010320,8984536,NULL,NULL,NULL,NULL),(2683,2226,0,'LSQ12fiq','LSQ',70.4199583333333,-9.89294444444444,NULL,NULL,'2012-10-18 05:52:53',56218.2450600001,19.4085,0.0742,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_snap_65380.gif',37499689591,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585932649,9155197,NULL,NULL,NULL,NULL),(2684,2226,0,'LSQ12fiq','LSQ',70.4199166666667,-9.89291666666667,NULL,NULL,'2012-10-18 07:30:01',56218.3125200002,19.5023,0.085,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_snap_65381.gif',37499689591,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585932649,9155197,NULL,NULL,NULL,NULL),(2685,2229,0,'LSQ12fin','LSQ',51.3952083333333,-10.7908055555556,NULL,NULL,'2012-10-18 07:26:29',56218.31006,19.8914,0.1398,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fin/LSQ12fin_history.html','sne?',NULL,0.086383,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fin/LSQ12fin_snap_65363.gif',37886243700,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,591972557,9249571,NULL,NULL,NULL,NULL),(2686,2232,0,'LSQ12fik','LSQ',56.7648333333333,-10.9832777777778,NULL,NULL,'2012-10-18 05:22:35',56218.2240200001,19.4859,0.1831,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_65376.gif',37025736046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2687,2241,0,'LSQ12fjm','LSQ',69.0454166666667,-5.08152777777778,NULL,NULL,'2012-10-18 08:10:58',56218.3409600002,17.9771,0.041,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_snap_65402.gif',37460190256,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585315472,9145554,NULL,NULL,NULL,NULL),(2688,2241,0,'LSQ12fjm','LSQ',69.0454166666667,-5.08152777777778,NULL,NULL,'2012-10-18 08:55:45',56218.3720499999,17.9572,0.0468,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_snap_65403.gif',37460190256,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585315472,9145554,NULL,NULL,NULL,NULL),(2689,2247,0,'LSQ12fji','LSQ',57.3124166666667,-6.10363888888889,NULL,NULL,'2012-10-18 06:35:02',56218.27434,18.5246,0.0846,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_65384.gif',37029491967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2690,2247,0,'LSQ12fji','LSQ',57.3123333333333,-6.10369444444444,NULL,NULL,'2012-10-18 06:36:44',56218.2755100001,18.7842,0.0715,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_65382.gif',37029491966,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2691,2247,0,'LSQ12fji','LSQ',57.312375,-6.10369444444444,NULL,NULL,'2012-10-18 07:52:07',56218.3278700002,18.3288,0.0886,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_65383.gif',37029491967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2692,2247,0,'LSQ12fji','LSQ',57.3124583333333,-6.10366666666667,NULL,NULL,'2012-10-18 07:57:12',56218.3313899999,18.6526,0.0693,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_65385.gif',37029491967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2693,2268,0,'LSQ12fit','LSQ',34.7380833333333,-1.65813888888889,NULL,NULL,'2012-10-18 06:59:23',56218.2912400002,20.1582,0.1373,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fit/LSQ12fit_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fit/LSQ12fit_snap_65401.gif',34915237392,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545550584,8524227,NULL,NULL,NULL,NULL),(2694,2336,0,'LSQ12fkf','LSQ',22.8801666666667,3.41602777777778,NULL,NULL,'2012-10-18 03:41:11',56218.1535999998,19.5248,0.1453,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_snap_65284.gif',67518050300,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1054969535,16483898,NULL,NULL,NULL,NULL),(2695,2336,0,'LSQ12fkf','LSQ',22.8803333333333,3.41605555555556,NULL,NULL,'2012-10-18 05:42:00',56218.2375099999,19.8898,0.1303,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_snap_65285.gif',67518050300,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1054969535,16483898,NULL,NULL,NULL,NULL),(2696,2341,0,'LSQ12fkc','LSQ',334.886583333333,-4.11163888888889,NULL,NULL,'2012-10-18 01:07:14',56218.0466999998,19.9051,0.1259,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkc/LSQ12fkc_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkc/LSQ12fkc_snap_65242.gif',49850991383,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778921740,12170652,NULL,NULL,NULL,NULL),(2697,2343,0,'LSQ12fkb','LSQ',335.494208333333,-5.92133333333333,NULL,NULL,'2012-10-18 01:05:32',56218.0455200002,20.4955,0.1764,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkb/LSQ12fkb_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkb/LSQ12fkb_snap_65240.gif',49849934990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778905234,12170394,NULL,NULL,NULL,NULL),(2698,2343,0,'LSQ12fkb','LSQ',335.49425,-5.92136111111111,NULL,NULL,'2012-10-18 03:07:22',56218.1301199999,19.8286,0.1115,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkb/LSQ12fkb_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkb/LSQ12fkb_snap_65241.gif',49849934990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778905234,12170394,NULL,NULL,NULL,NULL),(2699,2349,0,'LSQ12fjy','LSQ',32.5966666666667,-6.75586111111111,NULL,NULL,'2012-10-18 04:55:33',56218.2052500001,19.0327,0.0575,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_snap_65221.gif',35150329089,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549223892,8581623,NULL,NULL,NULL,NULL),(2700,2349,0,'LSQ12fjy','LSQ',32.596625,-6.75594444444444,NULL,NULL,'2012-10-18 07:41:57',56218.3208099999,19.2904,0.0876,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_snap_65222.gif',35150329089,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549223892,8581623,NULL,NULL,NULL,NULL),(2701,2357,0,'LSQ12fjx','LSQ',69.60775,-10.194,NULL,NULL,'2012-10-18 05:52:53',56218.2450600001,20.2138,0.1781,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_65229.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2702,2357,0,'LSQ12fjx','LSQ',69.6076666666667,-10.1938611111111,NULL,NULL,'2012-10-18 07:30:01',56218.3125200002,19.9854,0.1731,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_65230.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2703,2368,0,'LSQ12fjw','LSQ',56.3845833333333,-7.39630555555556,NULL,NULL,'2012-10-18 05:24:18',56218.2252099998,18.9682,0.0866,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_history.html','sne - nice',NULL,0.02832,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_snap_65226.gif',37031203526,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578612555,9040821,NULL,NULL,NULL,NULL),(2704,2576,0,'LSQ12fkx','LSQ',345.093,2.89941666666667,NULL,NULL,'2012-10-18 01:15:55',56218.05272,20.0634,0.1057,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_snap_65288.gif',51738378612,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,808412165,12631440,NULL,NULL,NULL,NULL),(2705,2576,0,'LSQ12fkx','LSQ',345.093,2.89941666666667,NULL,NULL,'2012-10-18 03:17:40',56218.1372799999,20.2219,0.1214,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_snap_65289.gif',51738378612,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,808412165,12631440,NULL,NULL,NULL,NULL),(2706,2580,0,'LSQ12fks','LSQ',65.5730833333333,-6.229,NULL,NULL,'2012-10-18 08:09:17',56218.3397900001,19.8401,0.1313,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_snap_65300.gif',36948141630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577314712,9020542,NULL,NULL,NULL,NULL),(2707,2580,0,'LSQ12fks','LSQ',65.5730833333333,-6.22905555555556,NULL,NULL,'2012-10-18 08:38:25',56218.36002,19.986,0.1598,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_snap_65301.gif',36948141630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577314712,9020542,NULL,NULL,NULL,NULL),(2708,2591,0,'LSQ12fkq','LSQ',35.038875,-5.71113888888889,NULL,NULL,'2012-10-18 06:18:08',56218.2626,18.7755,0.0489,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_65296.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2709,2591,0,'LSQ12fkq','LSQ',35.039125,-5.71136111111111,NULL,NULL,'2012-10-18 06:19:49',56218.2637700001,19.4282,0.0631,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_65294.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2710,2591,0,'LSQ12fkq','LSQ',35.0391666666667,-5.71133333333333,NULL,NULL,'2012-10-18 07:43:39',56218.32198,19.9441,0.0873,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_65295.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2711,2591,0,'LSQ12fkq','LSQ',35.0389166666667,-5.71113888888889,NULL,NULL,'2012-10-18 08:05:39',56218.3372599999,18.6204,0.0566,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_65297.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2712,2640,0,'LSQ12flu','LSQ',344.46725,0.899555555555556,NULL,NULL,'2012-10-18 01:29:59',56218.0624899999,18.954,0.0425,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flu/LSQ12flu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flu/LSQ12flu_snap_65397.gif',51699671670,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,807807369,12621990,NULL,NULL,NULL,NULL),(2713,2649,0,'LSQ12fll','LSQ',328.636708333333,-6.23108333333333,NULL,NULL,'2012-10-18 00:38:08',56218.0264900001,20.1254,0.1102,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fll/LSQ12fll_history.html','sne?',NULL,0.858,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fll/LSQ12fll_snap_65348.gif',49921794452,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,780028038,12187938,NULL,NULL,NULL,NULL),(2714,2655,0,'LSQ12fli','LSQ',67.7674583333333,-7.20372222222222,NULL,NULL,'2012-10-18 08:12:40',56218.3421299998,18.7689,0.1406,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_snap_65359.gif',37505778949,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586027796,9156684,NULL,NULL,NULL,NULL),(2715,2655,0,'LSQ12fli','LSQ',67.7673333333333,-7.20375,NULL,NULL,'2012-10-18 08:40:07',56218.3612000002,18.7415,0.1267,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_snap_65360.gif',37505778949,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586027796,9156684,NULL,NULL,NULL,NULL),(2716,2660,0,'LSQ12flb','LSQ',68.12325,-3.30719444444444,NULL,NULL,'2012-10-18 08:10:58',56218.3409600002,18.6626,0.0649,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flb/LSQ12flb_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flb/LSQ12flb_snap_65346.gif',37462033170,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,585344268,9146004,NULL,NULL,NULL,NULL),(2717,2660,0,'LSQ12flb','LSQ',68.1232083333333,-3.30727777777778,NULL,NULL,'2012-10-18 08:55:45',56218.3720499999,18.4702,0.0935,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flb/LSQ12flb_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flb/LSQ12flb_snap_65347.gif',37462033171,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,585344268,9146004,NULL,NULL,NULL,NULL),(2718,2662,0,'LSQ12fkz','LSQ',65.0195833333333,-4.06147222222222,NULL,NULL,'2012-10-18 08:07:36',56218.3386200001,19.1175,0.0868,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_snap_65353.gif',36920772805,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,576887075,9013860,NULL,NULL,NULL,NULL),(2719,2662,0,'LSQ12fkz','LSQ',65.0195416666667,-4.06147222222222,NULL,NULL,'2012-10-18 08:57:27',56218.3732400001,19.3776,0.107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-19 04:45:24','2012-10-19 04:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_snap_65354.gif',36920772805,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,576887075,9013860,NULL,NULL,NULL,NULL),(2720,2642,0,'LSQ12fls','atel',35.3907083333,2.64305555556,NULL,NULL,'2012-10-18 00:00:00',56218,NULL,NULL,NULL,0.04,NULL,'Ia',NULL,'2012-10-19 09:26:37','2012-10-19 09:26:37','http://www.astronomerstelegram.org/?read=4497',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,66888306583,'Hawaii 2.2m','SuperNova Integral Field Spectrograph','NSF II',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045129790,16330152,NULL,NULL,NULL,NULL),(2721,2721,1,'CSS121015-004244+132827','CRTS-CSS',10.68478,13.47403,NULL,NULL,'2012-10-18 00:00:00',56218,18.3,NULL,'R',NULL,NULL,NULL,NULL,'2012-10-19 10:19:48','2019-10-11 14:10:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210151120044133047.atel.html','supernova',NULL,0,NULL,NULL,'http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210151120044133047/1210151120044133047.find.jpg',NULL,NULL,67465270359,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1054144849,16471013,NULL,NULL,NULL,NULL),(2722,2721,0,'CSS121015-004244+132827','atel',10.68478,13.47403,NULL,NULL,'2012-10-19 00:00:00',56219,NULL,NULL,NULL,0,NULL,'I',NULL,'2012-10-19 10:20:56','2019-10-11 14:09:07','http://www.astronomerstelegram.org/?read=4498',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,67465270359,'Palomar 5m','DBSP','CRTS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,1182322,NULL,0,1054144849,16471013,NULL,NULL,NULL,NULL),(2723,2172,0,'CSS121006-232854+085452','atel',352.22702,8.91432,NULL,NULL,'2012-10-14 00:00:00',56214,NULL,NULL,NULL,0,NULL,'Ia',NULL,'2012-10-19 11:16:15','2012-10-19 11:16:15','http://www.astronomerstelegram.org/?read=4498',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,51797447596,'Palomar 5m','DBSP','CRTS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,809335118,12645861,NULL,NULL,NULL,NULL),(2724,2143,0,'CSS120926-171458+344754','atel',258.74065,34.79828,NULL,NULL,'2012-10-14 00:00:00',56214,NULL,NULL,NULL,0,NULL,'Ia',NULL,'2012-10-19 11:18:46','2012-10-19 11:18:46','http://www.astronomerstelegram.org/?read=4498',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,56351560770,'Palomar 5m','DBSP','CRTS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,880493137,13757705,NULL,NULL,NULL,NULL),(2725,2725,1,'LSQ12fmx','LSQ',48.2170833333333,-0.203555555555556,NULL,NULL,'2012-10-14 08:35:39',56214.3580999998,20.2715,0.2107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 01:45:24','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_snap_65798.gif',36785353942,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574771155,8980799,NULL,NULL,NULL,NULL),(2726,2725,0,'LSQ12fmx','LSQ',48.21725,-0.203583333333333,NULL,NULL,'2012-10-18 08:21:21',56218.3481600001,19.0225,0.1014,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 01:45:24','2012-10-20 01:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_snap_65762.gif',36785353942,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574771155,8980799,NULL,NULL,NULL,NULL),(2727,2725,0,'LSQ12fmx','LSQ',48.2171666666667,-0.203527777777778,NULL,NULL,'2012-10-18 08:23:02',56218.3493300001,19.1654,0.0992,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 01:45:24','2012-10-20 01:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_snap_65766.gif',36785353942,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574771155,8980799,NULL,NULL,NULL,NULL),(2728,2725,0,'LSQ12fmx','LSQ',48.21725,-0.203527777777778,NULL,NULL,'2012-10-18 08:43:45',56218.3637199998,19.1957,0.0773,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 01:45:24','2012-10-20 01:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_snap_65763.gif',36785353942,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574771155,8980799,NULL,NULL,NULL,NULL),(2729,2725,0,'LSQ12fmx','LSQ',48.2171666666667,-0.203583333333333,NULL,NULL,'2012-10-18 08:45:27',56218.3648999999,18.8541,0.1054,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 01:45:24','2012-10-20 01:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_snap_65767.gif',36785353942,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574771155,8980799,NULL,NULL,NULL,NULL),(2730,2730,1,'LSQ12fml','LSQ',56.015625,-3.28822222222222,NULL,NULL,'2012-10-14 08:04:14',56214.3362799999,20.5785,0.2083,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 01:45:24','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fml/LSQ12fml_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fml/LSQ12fml_snap_65716.gif',37008688674,NULL,NULL,NULL,'2012-10-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578260760,9035324,NULL,NULL,NULL,NULL),(2731,2730,0,'LSQ12fml','LSQ',56.0155833333333,-3.28819444444444,NULL,NULL,'2012-10-18 06:35:02',56218.27434,20.2195,0.1637,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 01:45:24','2012-10-20 01:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fml/LSQ12fml_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fml/LSQ12fml_snap_65590.gif',37008688674,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578260760,9035324,NULL,NULL,NULL,NULL),(2732,2730,0,'LSQ12fml','LSQ',56.0155833333333,-3.28822222222222,NULL,NULL,'2012-10-18 07:57:12',56218.3313899999,20.011,0.1336,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 01:45:24','2012-10-20 01:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fml/LSQ12fml_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fml/LSQ12fml_snap_65591.gif',37008688674,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578260760,9035324,NULL,NULL,NULL,NULL),(2733,2733,1,'LSQ12fmd','LSQ',54.9455,-7.50536111111111,NULL,NULL,'2012-10-12 07:26:07',56212.30981,19.564,0.1056,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 01:45:24','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_history.html','sne-nice',NULL,0.11854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_snap_65646.gif',37019211459,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578425179,9037893,NULL,NULL,NULL,NULL),(2734,2733,0,'LSQ12fmd','LSQ',54.945375,-7.50533333333333,NULL,NULL,'2012-10-12 09:01:18',56212.3759099999,19.8401,0.1377,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 01:45:24','2012-10-20 01:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_history.html','sne-nice',NULL,0.11854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_snap_65647.gif',37019211459,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578425179,9037893,NULL,NULL,NULL,NULL),(2735,2733,0,'LSQ12fmd','LSQ',54.9454583333333,-7.50538888888889,NULL,NULL,'2012-10-14 05:34:30',56214.2322999998,20.0245,0.1222,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 01:45:24','2012-10-20 01:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_history.html','sne-nice',NULL,0.11854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_snap_65648.gif',37019211459,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578425179,9037893,NULL,NULL,NULL,NULL),(2736,2733,0,'LSQ12fmd','LSQ',54.9454583333333,-7.50536111111111,NULL,NULL,'2012-10-14 07:29:32',56214.3121799999,19.5906,0.1113,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 01:45:24','2012-10-20 01:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_history.html','sne-nice',NULL,0.11854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_snap_65649.gif',37019211459,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578425179,9037893,NULL,NULL,NULL,NULL),(2737,2733,0,'LSQ12fmd','LSQ',54.9455833333333,-7.50533333333333,NULL,NULL,'2012-10-16 06:07:43',56216.2553699999,19.1951,0.0835,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 01:45:24','2012-10-20 01:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_history.html','sne-nice',NULL,0.11854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_snap_65650.gif',37019211459,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578425179,9037893,NULL,NULL,NULL,NULL),(2738,2733,0,'LSQ12fmd','LSQ',54.9455833333333,-7.50530555555556,NULL,NULL,'2012-10-16 08:14:04',56216.3431099998,19.1469,0.0723,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 01:45:24','2012-10-20 01:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_history.html','sne-nice',NULL,0.11854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_snap_65651.gif',37019211459,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578425179,9037893,NULL,NULL,NULL,NULL),(2739,2733,0,'LSQ12fmd','LSQ',54.9454583333333,-7.50536111111111,NULL,NULL,'2012-10-18 05:19:13',56218.22168,19.0517,0.0717,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 01:45:24','2012-10-20 01:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_history.html','sne-nice',NULL,0.11854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_snap_65574.gif',37019211459,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578425179,9037893,NULL,NULL,NULL,NULL),(2740,2733,0,'LSQ12fmd','LSQ',54.9455416666667,-7.50538888888889,NULL,NULL,'2012-10-18 07:12:56',56218.3006500001,18.9202,0.0707,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 01:45:24','2012-10-20 01:45:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_history.html','sne-nice',NULL,0.11854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_snap_65575.gif',37019211459,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578425179,9037893,NULL,NULL,NULL,NULL),(2741,1962,0,'LSQ12fdx','LSQ',40.1494583333333,-9.43716666666667,NULL,NULL,'2012-10-20 05:26:12',56220.2265300001,19.3175,0.1158,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_history.html','sn?',NULL,1.925,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_snap_66112.gif',37880582031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,591884094,9248188,NULL,NULL,NULL,NULL),(2742,1962,0,'LSQ12fdx','LSQ',40.1495,-9.43708333333333,NULL,NULL,'2012-10-20 08:23:28',56220.3496300001,19.6183,0.1391,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_history.html','sn?',NULL,1.925,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fdx/LSQ12fdx_snap_66113.gif',37880582031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,591884094,9248188,NULL,NULL,NULL,NULL),(2743,2118,0,'LSQ12fhh','LSQ',49.1314166666667,-0.467611111111111,NULL,NULL,'2012-10-20 08:41:02',56220.3618399999,16.8798,0.0331,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhh/LSQ12fhh_history.html','sne- nice',NULL,0.02268,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhh/LSQ12fhh_snap_65954.gif',36787815619,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574809619,8981400,NULL,NULL,NULL,NULL),(2744,2118,0,'LSQ12fhh','LSQ',49.131375,-0.46775,NULL,NULL,'2012-10-20 08:59:59',56220.3749899999,16.7992,0.0528,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhh/LSQ12fhh_history.html','sne- nice',NULL,0.02268,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhh/LSQ12fhh_snap_65955.gif',36787815618,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574809619,8981400,NULL,NULL,NULL,NULL),(2745,2126,0,'LSQ12fgy','LSQ',64.7325833333333,-4.19847222222222,NULL,NULL,'2012-10-20 06:33:01',56220.27293,17.5235,0.0264,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_snap_65949.gif',36966141626,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577595962,9024936,NULL,NULL,NULL,NULL),(2746,2126,0,'LSQ12fgy','LSQ',64.7324583333333,-4.19852777777778,NULL,NULL,'2012-10-20 07:49:15',56220.3258699998,17.7059,0.0376,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_snap_65950.gif',36966141626,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577595962,9024936,NULL,NULL,NULL,NULL),(2747,2226,0,'LSQ12fiq','LSQ',70.4199166666667,-9.89288888888889,NULL,NULL,'2012-10-20 06:07:20',56220.2551000002,19.3375,0.0742,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_snap_66037.gif',37499689591,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585932649,9155197,NULL,NULL,NULL,NULL),(2748,2226,0,'LSQ12fiq','LSQ',70.4199166666667,-9.89286111111111,NULL,NULL,'2012-10-20 08:03:10',56220.3355399999,19.2921,0.0769,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_snap_66038.gif',37499689591,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585932649,9155197,NULL,NULL,NULL,NULL),(2749,2232,0,'LSQ12fik','LSQ',56.7643333333333,-10.9833888888889,NULL,NULL,'2012-10-20 05:55:33',56220.2469100002,19.4941,0.1897,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_66035.gif',37025736046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2750,2241,0,'LSQ12fjm','LSQ',69.0454166666667,-5.08152777777778,NULL,NULL,'2012-10-20 08:30:39',56220.3546199999,18.1359,0.0403,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_snap_66078.gif',37460190256,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585315472,9145554,NULL,NULL,NULL,NULL),(2751,2241,0,'LSQ12fjm','LSQ',69.0454166666667,-5.0815,NULL,NULL,'2012-10-20 08:47:49',56220.3665499999,18.1084,0.041,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_snap_66079.gif',37460190256,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585315472,9145554,NULL,NULL,NULL,NULL),(2752,2247,0,'LSQ12fji','LSQ',57.3122916666667,-6.10366666666667,NULL,NULL,'2012-10-20 06:24:33',56220.26706,18.6464,0.0659,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_66063.gif',37029491966,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2753,2247,0,'LSQ12fji','LSQ',57.3124166666667,-6.10375,NULL,NULL,'2012-10-20 06:26:15',56220.2682400001,18.8913,0.0794,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_66061.gif',37029491967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2754,2247,0,'LSQ12fji','LSQ',57.3125,-6.10372222222222,NULL,NULL,'2012-10-20 07:52:37',56220.3282099999,18.9548,0.0758,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_66062.gif',37029491967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2755,2247,0,'LSQ12fji','LSQ',57.312375,-6.10361111111111,NULL,NULL,'2012-10-20 07:54:20',56220.3294000002,18.6936,0.0795,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_66064.gif',37029491967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2756,2252,0,'LSQ12fjf','LSQ',28.917125,0.159222222222222,NULL,NULL,'2012-10-20 04:29:26',56220.1871099998,22.9692,0.2014,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjf/LSQ12fjf_history.html','sne- hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjf/LSQ12fjf_snap_66058.gif',67000262570,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1046879102,16357485,NULL,NULL,NULL,NULL),(2757,2295,0,'LSQ12fjr','LSQ',30.5042083333333,-1.93288888888889,NULL,NULL,'2012-10-20 04:34:29',56220.19062,20.8593,0.152,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjr/LSQ12fjr_snap_65821.gif',35013987766,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,547093558,8548336,NULL,NULL,NULL,NULL),(2758,2336,0,'LSQ12fkf','LSQ',22.880125,3.41597222222222,NULL,NULL,'2012-10-20 01:49:35',56220.0761099998,19.0825,0.1654,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_snap_65956.gif',67518050300,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1054969535,16483898,NULL,NULL,NULL,NULL),(2759,2336,0,'LSQ12fkf','LSQ',22.880125,3.41602777777778,NULL,NULL,'2012-10-20 03:49:51',56220.15962,19.2015,0.1397,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_snap_65957.gif',67518050300,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1054969535,16483898,NULL,NULL,NULL,NULL),(2760,2343,0,'LSQ12fkb','LSQ',335.494208333333,-5.92136111111111,NULL,NULL,'2012-10-20 00:58:39',56220.0407400001,19.9142,0.1074,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkb/LSQ12fkb_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkb/LSQ12fkb_snap_65911.gif',49849934990,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,778905234,12170394,NULL,NULL,NULL,NULL),(2761,2357,0,'LSQ12fjx','LSQ',69.6076666666667,-10.1939166666667,NULL,NULL,'2012-10-20 06:07:20',56220.2551000002,20.1112,0.1515,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_65907.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2762,2357,0,'LSQ12fjx','LSQ',69.6077916666667,-10.1938333333333,NULL,NULL,'2012-10-20 08:03:10',56220.3355399999,20.4262,0.1346,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_65908.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2763,2368,0,'LSQ12fjw','LSQ',56.3841666666667,-7.39638888888889,NULL,NULL,'2012-10-20 08:09:55',56220.3402300002,19.4344,0.1139,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_history.html','sne - nice',NULL,0.02832,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_snap_65895.gif',37031203527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578612555,9040821,NULL,NULL,NULL,NULL),(2764,2576,0,'LSQ12fkx','LSQ',345.093166666667,2.89941666666667,NULL,NULL,'2012-10-20 01:09:02',56220.04794,20.1279,0.1759,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkx/LSQ12fkx_snap_65963.gif',51738378615,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,808412165,12631440,NULL,NULL,NULL,NULL),(2765,2580,0,'LSQ12fks','LSQ',65.5732916666667,-6.22886111111111,NULL,NULL,'2012-10-20 06:33:01',56220.27293,19.3532,0.115,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_snap_65960.gif',36948141630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577314712,9020542,NULL,NULL,NULL,NULL),(2766,2586,0,'LSQ12fkr','LSQ',56.1516666666667,-5.82830555555556,NULL,NULL,'2012-10-20 07:54:20',56220.3294000002,19.9755,0.189,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkr/LSQ12fkr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkr/LSQ12fkr_snap_66002.gif',36998458500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578100914,9032826,NULL,NULL,NULL,NULL),(2767,2591,0,'LSQ12fkq','LSQ',35.039125,-5.71133333333333,NULL,NULL,'2012-10-20 06:09:20',56220.2564900001,20.0763,0.1254,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_65965.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2768,2591,0,'LSQ12fkq','LSQ',35.0392083333333,-5.71136111111111,NULL,NULL,'2012-10-20 07:37:24',56220.3176500001,19.6483,0.0814,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkq/LSQ12fkq_snap_65966.gif',34917798481,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545590601,8524853,NULL,NULL,NULL,NULL),(2769,2640,0,'LSQ12flu','LSQ',344.467375,0.899611111111111,NULL,NULL,'2012-10-20 01:19:32',56220.0552400001,18.9241,0.0583,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flu/LSQ12flu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flu/LSQ12flu_snap_66069.gif',51699671670,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,807807369,12621990,NULL,NULL,NULL,NULL),(2770,2640,0,'LSQ12flu','LSQ',344.467208333333,0.899611111111111,NULL,NULL,'2012-10-20 03:23:29',56220.1413099999,18.9689,0.047,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flu/LSQ12flu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flu/LSQ12flu_snap_66070.gif',51699671670,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,807807369,12621990,NULL,NULL,NULL,NULL),(2771,2642,0,'LSQ12fls','LSQ',35.3907916666667,2.64305555555556,NULL,NULL,'2012-10-20 04:39:35',56220.19416,17.1883,0.0139,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fls/LSQ12fls_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fls/LSQ12fls_snap_66040.gif',66888306583,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045129790,16330152,NULL,NULL,NULL,NULL),(2772,2642,0,'LSQ12fls','LSQ',35.3907916666667,2.64305555555556,NULL,NULL,'2012-10-20 06:40:06',56220.2778500002,17.1817,0.0129,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fls/LSQ12fls_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fls/LSQ12fls_snap_66041.gif',66888306583,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045129790,16330152,NULL,NULL,NULL,NULL),(2773,2646,0,'LSQ12flr','LSQ',35.43,2.49694444444444,NULL,NULL,'2012-10-20 06:40:06',56220.2778500002,19.4597,0.0698,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flr/LSQ12flr_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flr/LSQ12flr_snap_66026.gif',66888428907,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045131701,16330182,NULL,NULL,NULL,NULL),(2774,2655,0,'LSQ12fli','LSQ',67.7672916666667,-7.20388888888889,NULL,NULL,'2012-10-20 08:49:31',56220.36772,18.7295,0.1211,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_snap_66020.gif',37505778949,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586027796,9156684,NULL,NULL,NULL,NULL),(2775,2660,0,'LSQ12flb','LSQ',68.1233333333333,-3.30730555555556,NULL,NULL,'2012-10-20 08:30:39',56220.3546199999,18.6077,0.0769,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flb/LSQ12flb_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flb/LSQ12flb_snap_66013.gif',37462033171,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,585344268,9146004,NULL,NULL,NULL,NULL),(2776,2660,0,'LSQ12flb','LSQ',68.1232916666667,-3.30727777777778,NULL,NULL,'2012-10-20 08:47:49',56220.3665499999,18.6602,0.0924,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flb/LSQ12flb_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flb/LSQ12flb_snap_66014.gif',37462033171,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,585344268,9146004,NULL,NULL,NULL,NULL),(2777,2662,0,'LSQ12fkz','LSQ',65.0195833333333,-4.06155555555556,NULL,NULL,'2012-10-20 06:31:20',56220.2717599999,19.8459,0.1407,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_snap_66015.gif',36920772812,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,576887075,9013860,NULL,NULL,NULL,NULL),(2778,2662,0,'LSQ12fkz','LSQ',65.0195,-4.06152777777778,NULL,NULL,'2012-10-20 07:50:56',56220.3270399999,19.6843,0.1173,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_snap_66016.gif',36920772812,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,576887075,9013860,NULL,NULL,NULL,NULL),(2779,2725,0,'LSQ12fmx','LSQ',48.21725,-0.203527777777778,NULL,NULL,'2012-10-20 08:41:02',56220.3618399999,18.6029,0.0505,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_snap_65891.gif',36785353942,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574771155,8980799,NULL,NULL,NULL,NULL),(2780,2725,0,'LSQ12fmx','LSQ',48.217125,-0.203555555555556,NULL,NULL,'2012-10-20 08:42:44',56220.36301,18.6817,0.0648,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_snap_65889.gif',36785353942,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574771155,8980799,NULL,NULL,NULL,NULL),(2781,2725,0,'LSQ12fmx','LSQ',48.2171666666667,-0.203527777777778,NULL,NULL,'2012-10-20 08:58:17',56220.3738099998,18.7287,0.079,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_snap_65890.gif',36785353942,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574771155,8980799,NULL,NULL,NULL,NULL),(2782,2725,0,'LSQ12fmx','LSQ',48.2172916666667,-0.203555555555556,NULL,NULL,'2012-10-20 08:59:59',56220.3749899999,18.5649,0.0794,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmx/LSQ12fmx_snap_65892.gif',36785353942,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574771155,8980799,NULL,NULL,NULL,NULL),(2783,2730,0,'LSQ12fml','LSQ',56.0155416666667,-3.28822222222222,NULL,NULL,'2012-10-20 06:24:33',56220.26706,19.7444,0.1679,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fml/LSQ12fml_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fml/LSQ12fml_snap_65848.gif',37008688674,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578260760,9035324,NULL,NULL,NULL,NULL),(2784,2730,0,'LSQ12fml','LSQ',56.0155833333333,-3.28825,NULL,NULL,'2012-10-20 07:54:20',56220.3294000002,19.9676,0.1385,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fml/LSQ12fml_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fml/LSQ12fml_snap_65849.gif',37008688674,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578260760,9035324,NULL,NULL,NULL,NULL),(2785,2733,0,'LSQ12fmd','LSQ',54.9455833333333,-7.50533333333333,NULL,NULL,'2012-10-20 05:52:09',56220.2445499999,18.7667,0.0605,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_history.html','sne-nice',NULL,0.11854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_snap_65971.gif',37019211459,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578425179,9037893,NULL,NULL,NULL,NULL),(2786,2733,0,'LSQ12fmd','LSQ',54.9454583333333,-7.50536111111111,NULL,NULL,'2012-10-20 08:15:00',56220.3437600001,18.8165,0.0608,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 16:45:26','2012-10-20 16:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_history.html','sne-nice',NULL,0.11854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_snap_65972.gif',37019211459,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578425179,9037893,NULL,NULL,NULL,NULL),(2787,2787,1,'LSQ12fnt','LSQ',53.1725,-1.18647222222222,NULL,NULL,'2012-10-20 08:44:26',56220.3641900001,19.2355,0.0808,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnt/LSQ12fnt_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnt/LSQ12fnt_snap_66278.gif',36816048052,NULL,NULL,NULL,'2012-10-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575250750,8988292,NULL,NULL,NULL,NULL),(2788,2787,0,'LSQ12fnt','LSQ',53.1725833333333,-1.18638888888889,NULL,NULL,'2012-10-20 08:54:55',56220.3714700001,19.2279,0.1287,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnt/LSQ12fnt_history.html','sne-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnt/LSQ12fnt_snap_66279.gif',36816048052,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575250750,8988292,NULL,NULL,NULL,NULL),(2789,2789,1,'LSQ12fns','LSQ',43.2630416666667,-0.375,NULL,NULL,'2012-10-14 08:32:16',56214.3557500001,20.9774,0.1985,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fns/LSQ12fns_history.html','sn?',NULL,0.20269,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fns/LSQ12fns_snap_66391.gif',34898397606,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545287462,8520116,NULL,NULL,NULL,NULL),(2790,2789,0,'LSQ12fns','LSQ',43.2630833333333,-0.374916666666667,NULL,NULL,'2012-10-16 08:50:02',56216.36809,20.5069,0.1708,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fns/LSQ12fns_history.html','sn?',NULL,0.20269,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fns/LSQ12fns_snap_66392.gif',34898397606,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545287462,8520116,NULL,NULL,NULL,NULL),(2791,2789,0,'LSQ12fns','LSQ',43.2633333333333,-0.375194444444444,NULL,NULL,'2012-10-18 08:50:29',56218.3684,20.3192,0.1812,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fns/LSQ12fns_history.html','sn?',NULL,0.20269,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fns/LSQ12fns_snap_66393.gif',34898397606,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545287462,8520116,NULL,NULL,NULL,NULL),(2792,2789,0,'LSQ12fns','LSQ',43.2632916666667,-0.374944444444444,NULL,NULL,'2012-10-20 08:39:21',56220.3606599998,20.0373,0.1198,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fns/LSQ12fns_history.html','sn?',NULL,0.20269,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fns/LSQ12fns_snap_66276.gif',34898397606,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545287462,8520116,NULL,NULL,NULL,NULL),(2793,2789,0,'LSQ12fns','LSQ',43.263375,-0.375027777777778,NULL,NULL,'2012-10-20 08:53:08',56220.3702400001,20.1457,0.1376,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fns/LSQ12fns_history.html','sn?',NULL,0.20269,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fns/LSQ12fns_snap_66277.gif',34898397606,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545287462,8520116,NULL,NULL,NULL,NULL),(2794,2794,1,'LSQ12fnq','LSQ',23.3745416666667,1.48766666666667,NULL,NULL,'2012-10-02 03:01:42',56202.1261900002,17.1275,0.06,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_snap_66384.gif',66978187147,NULL,NULL,NULL,'2012-07-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1046534174,16352096,NULL,NULL,NULL,NULL),(2795,2794,0,'LSQ12fnq','LSQ',23.3745,1.48761111111111,NULL,NULL,'2012-10-02 05:02:03',56202.20976,16.5502,0.0528,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_snap_66385.gif',66978187147,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1046534174,16352096,NULL,NULL,NULL,NULL),(2796,2794,0,'LSQ12fnq','LSQ',23.374375,1.48755555555556,NULL,NULL,'2012-10-08 03:34:29',56208.1489499998,16.9505,0.028,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_snap_66386.gif',66978187147,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1046534174,16352096,NULL,NULL,NULL,NULL),(2797,2794,0,'LSQ12fnq','LSQ',23.374625,1.48755555555556,NULL,NULL,'2012-10-08 05:34:54',56208.23257,17.1764,0.0337,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_snap_66387.gif',66978187147,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1046534174,16352096,NULL,NULL,NULL,NULL),(2798,2794,0,'LSQ12fnq','LSQ',23.3745416666667,1.48752777777778,NULL,NULL,'2012-10-10 06:33:28',56210.2732500001,16.9852,0.0277,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_snap_66388.gif',66978187147,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1046534174,16352096,NULL,NULL,NULL,NULL),(2799,2794,0,'LSQ12fnq','LSQ',23.3745416666667,1.48763888888889,NULL,NULL,'2012-10-16 02:15:32',56216.0941300001,17.6682,0.0531,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_snap_66389.gif',66978187147,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1046534174,16352096,NULL,NULL,NULL,NULL),(2800,2794,0,'LSQ12fnq','LSQ',23.3745416666667,1.48758333333333,NULL,NULL,'2012-10-16 04:37:37',56216.1927899998,17.6919,0.0363,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_snap_66390.gif',66978187147,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1046534174,16352096,NULL,NULL,NULL,NULL),(2801,2794,0,'LSQ12fnq','LSQ',23.3745416666667,1.48763888888889,NULL,NULL,'2012-10-20 01:56:20',56220.08079,18.0099,0.0548,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_snap_66272.gif',66978187147,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1046534174,16352096,NULL,NULL,NULL,NULL),(2802,2794,0,'LSQ12fnq','LSQ',23.374625,1.48769444444444,NULL,NULL,'2012-10-20 03:56:38',56220.1643300001,17.8177,0.0513,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_snap_66273.gif',66978187147,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1046534174,16352096,NULL,NULL,NULL,NULL),(2803,2803,1,'LSQ12fnm','LSQ',27.0519166666667,-3.68691666666667,NULL,NULL,'2012-10-11 03:32:25',56211.1475200001,21.0914,0.1301,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnm/LSQ12fnm_history.html','sn???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnm/LSQ12fnm_snap_66353.gif',35030238231,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547347472,8552304,NULL,NULL,NULL,NULL),(2804,2803,0,'LSQ12fnm','LSQ',27.052,-3.68688888888889,NULL,NULL,'2012-10-11 05:34:24',56211.2322300002,21.2195,0.1502,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnm/LSQ12fnm_history.html','sn???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnm/LSQ12fnm_snap_66354.gif',35030238231,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547347472,8552304,NULL,NULL,NULL,NULL),(2805,2803,0,'LSQ12fnm','LSQ',27.052,-3.68697222222222,NULL,NULL,'2012-10-16 04:48:30',56216.2003500001,20.2114,0.1285,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnm/LSQ12fnm_history.html','sn???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnm/LSQ12fnm_snap_66355.gif',35030238231,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547347472,8552304,NULL,NULL,NULL,NULL),(2806,2803,0,'LSQ12fnm','LSQ',27.0520833333333,-3.68691666666667,NULL,NULL,'2012-10-16 06:49:16',56216.2842199998,19.8212,0.1652,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnm/LSQ12fnm_history.html','sn???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnm/LSQ12fnm_snap_66356.gif',35030238231,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547347472,8552304,NULL,NULL,NULL,NULL),(2807,2803,0,'LSQ12fnm','LSQ',27.0520416666667,-3.68694444444444,NULL,NULL,'2012-10-20 04:32:49',56220.18946,20.25,0.1442,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnm/LSQ12fnm_history.html','sn???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnm/LSQ12fnm_snap_66264.gif',35030238231,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547347472,8552304,NULL,NULL,NULL,NULL),(2808,2803,0,'LSQ12fnm','LSQ',27.0520416666667,-3.68697222222222,NULL,NULL,'2012-10-20 08:28:33',56220.3531599999,20.3022,0.157,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-20 18:45:26','2012-10-20 18:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnm/LSQ12fnm_history.html','sn???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnm/LSQ12fnm_snap_66265.gif',35030238231,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547347472,8552304,NULL,NULL,NULL,NULL),(2809,2062,0,'LSQ12ffs','LSQ',333.479416666667,-24.5211388888889,NULL,NULL,'2012-10-19 03:24:52',56219.1422799998,19.9564,0.1672,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 04:45:29','2012-10-21 04:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_history.html','sne',NULL,0.077797,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffs/LSQ12ffs_snap_66467.gif',50532995243,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,789578050,12337157,NULL,NULL,NULL,NULL),(2810,2196,0,'LSQ12fhq','LSQ',333.663166666667,-21.5687777777778,NULL,NULL,'2012-10-19 01:25:07',56219.0591099998,18.2047,0.0344,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 04:45:29','2012-10-21 04:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhq/LSQ12fhq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhq/LSQ12fhq_snap_66488.gif',49728887306,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'BS',NULL,0,NULL,0,777013864,12140841,NULL,NULL,NULL,NULL),(2811,2196,0,'LSQ12fhq','LSQ',333.663166666667,-21.56875,NULL,NULL,'2012-10-19 03:24:52',56219.1422799998,18.1859,0.0315,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 04:45:29','2012-10-21 04:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhq/LSQ12fhq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhq/LSQ12fhq_snap_66489.gif',49728887306,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'BS',NULL,0,NULL,0,777013864,12140841,NULL,NULL,NULL,NULL),(2812,2374,0,'LSQ12fkm','LSQ',328.735416666667,-23.7348611111111,NULL,NULL,'2012-10-19 01:01:35',56219.0427700002,19.2663,0.0784,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 04:45:29','2019-09-20 18:19:47','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_history.html','sne?',NULL,0.069024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_snap_66475.gif',50883020785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795047199,12422612,NULL,NULL,NULL,NULL),(2813,2813,1,'LSQ12foo','LSQ',348.8855,-18.6659444444444,NULL,NULL,'2012-10-19 01:53:59',56219.0791600002,18.295,0.0912,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 17:45:26','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12foo/LSQ12foo_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12foo/LSQ12foo_snap_66550.gif',50315373299,NULL,NULL,NULL,'2012-10-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,786177707,12284026,NULL,NULL,NULL,NULL),(2814,2813,0,'LSQ12foo','LSQ',348.8855,-18.6658611111111,NULL,NULL,'2012-10-19 03:53:42',56219.1623,18.4006,0.0921,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 17:45:26','2012-10-21 17:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12foo/LSQ12foo_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12foo/LSQ12foo_snap_66551.gif',50315373299,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,786177707,12284026,NULL,NULL,NULL,NULL),(2815,2815,1,'LSQ12fom','LSQ',347.119333333333,-21.6680555555556,NULL,NULL,'2012-10-15 02:09:33',56215.0899700001,19.6169,0.1325,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 17:45:26','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fom/LSQ12fom_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fom/LSQ12fom_snap_66576.gif',50300598676,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785946854,12280419,NULL,NULL,NULL,NULL),(2816,2815,0,'LSQ12fom','LSQ',347.119166666667,-21.6682222222222,NULL,NULL,'2012-10-19 01:52:16',56219.07797,19.7918,0.1593,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 17:45:26','2012-10-21 17:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fom/LSQ12fom_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fom/LSQ12fom_snap_66546.gif',50300598676,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785946854,12280419,NULL,NULL,NULL,NULL),(2817,2815,0,'LSQ12fom','LSQ',347.119291666667,-21.6681666666667,NULL,NULL,'2012-10-19 03:52:01',56219.1611299999,19.8871,0.1478,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 17:45:26','2012-10-21 17:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fom/LSQ12fom_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fom/LSQ12fom_snap_66547.gif',50300598676,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785946854,12280419,NULL,NULL,NULL,NULL),(2818,2818,1,'LSQ12foj','LSQ',345.208125,-22.4436388888889,NULL,NULL,'2012-10-15 04:08:53',56215.1728400001,19.7854,0.1732,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 17:45:26','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12foj/LSQ12foj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12foj/LSQ12foj_snap_66552.gif',50217891886,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784654560,12260227,NULL,NULL,NULL,NULL),(2819,2818,0,'LSQ12foj','LSQ',345.208333333333,-22.4439722222222,NULL,NULL,'2012-10-19 01:50:36',56219.07681,18.881,0.1345,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 17:45:26','2012-10-21 17:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12foj/LSQ12foj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12foj/LSQ12foj_snap_66540.gif',50217891873,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784654560,12260227,NULL,NULL,NULL,NULL),(2820,2818,0,'LSQ12foj','LSQ',345.208166666667,-22.4437777777778,NULL,NULL,'2012-10-19 03:50:18',56219.1599400002,19.518,0.162,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 17:45:26','2012-10-21 17:45:26','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12foj/LSQ12foj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12foj/LSQ12foj_snap_66541.gif',50217891886,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784654560,12260227,NULL,NULL,NULL,NULL),(2821,2655,0,'LSQ12fli','pessto',67.7674166667,-7.20380555556,NULL,NULL,'2012-10-21 07:51:35',56221.327495,NULL,NULL,NULL,0.132,NULL,'Ia',NULL,'2012-10-21 18:06:28','2012-10-21 18:06:28','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37505778949,'NTT','EFOSC','Nancy Elias Rosa',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586027796,9156684,NULL,NULL,NULL,NULL),(2822,2733,0,'LSQ12fmd','pessto',54.9455,-7.50536111111,NULL,NULL,'2012-10-21 08:35:36',56221.35806,NULL,NULL,NULL,0.112,NULL,'Ia',NULL,'2012-10-21 18:08:19','2012-10-21 18:08:19','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37019211459,'NTT','EFOSC','Nancy Elias Rosa',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578425179,9037893,NULL,NULL,NULL,NULL),(2823,2025,0,'LSQ12ffo','LSQ',330.439791666667,-22.2059444444444,NULL,NULL,'2012-10-21 02:57:17',56221.1231200001,20.8184,0.185,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 18:45:27','2012-10-21 18:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffo/LSQ12ffo_history.html','sne - nice',NULL,0.065395,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffo/LSQ12ffo_snap_66579.gif',50869971912,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,794843311,12419426,NULL,NULL,NULL,NULL),(2824,2044,0,'LSQ12ffx','LSQ',335.20075,-20.6738333333333,NULL,NULL,'2012-10-21 03:17:26',56221.13711,20.8437,0.1402,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 18:45:27','2012-10-21 18:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_snap_66591.gif',50207229406,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784487959,12257624,NULL,NULL,NULL,NULL),(2825,2056,0,'LSQ12ffu','LSQ',353.758208333333,-22.21025,NULL,NULL,'2012-10-21 02:39:51',56221.1110100001,19.013,0.0935,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 18:45:27','2012-10-21 18:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_snap_66586.gif',50273699794,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785526559,12273852,NULL,NULL,NULL,NULL),(2826,2374,0,'LSQ12fkm','LSQ',328.735541666667,-23.7348611111111,NULL,NULL,'2012-10-21 00:55:30',56221.0385500002,19.4419,0.1391,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 18:45:27','2019-09-20 18:19:47','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_history.html','sne?',NULL,0.069024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_snap_66601.gif',50883020778,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795047199,12422612,NULL,NULL,NULL,NULL),(2827,2374,0,'LSQ12fkm','LSQ',328.735416666667,-23.7350555555556,NULL,NULL,'2012-10-21 02:55:37',56221.1219600001,19.7697,0.1161,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 18:45:27','2019-09-20 18:19:47','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_history.html','sne?',NULL,0.069024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_snap_66602.gif',50883020778,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795047199,12422612,NULL,NULL,NULL,NULL),(2828,2828,1,'LSQ12fpc','LSQ',357.246666666667,9.62736111111111,NULL,NULL,'2012-10-07 05:15:36',56207.2191699999,18.3346,0.0184,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 20:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpc/LSQ12fpc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpc/LSQ12fpc_snap_66702.gif',51777353231,NULL,NULL,NULL,'2012-10-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,809021144,12640955,NULL,NULL,NULL,NULL),(2829,2828,0,'LSQ12fpc','LSQ',357.246708333333,9.62725,NULL,NULL,'2012-10-21 00:21:48',56221.0151399998,17.1356,0.011,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 20:45:27','2012-10-21 20:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpc/LSQ12fpc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpc/LSQ12fpc_snap_66653.gif',51777353229,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,809021144,12640955,NULL,NULL,NULL,NULL),(2830,2828,0,'LSQ12fpc','LSQ',357.246791666667,9.62727777777778,NULL,NULL,'2012-10-21 02:09:17',56221.0897900001,16.7266,0.0146,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 20:45:27','2012-10-21 20:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpc/LSQ12fpc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpc/LSQ12fpc_snap_66654.gif',51777353229,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,809021144,12640955,NULL,NULL,NULL,NULL),(2831,2828,0,'LSQ12fpc','LSQ',357.246708333333,9.62761111111111,NULL,NULL,'2012-10-21 03:54:36',56221.16292,17.5484,0.0195,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 20:45:27','2012-10-21 20:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpc/LSQ12fpc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpc/LSQ12fpc_snap_66703.gif',51777353231,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,809021144,12640955,NULL,NULL,NULL,NULL),(2832,2832,1,'LSQ12fpb','LSQ',357.827583333333,6.17747222222222,NULL,NULL,'2012-10-21 00:21:48',56221.0151399998,18.9324,0.083,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 20:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpb/LSQ12fpb_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpb/LSQ12fpb_snap_66651.gif',51567013181,NULL,NULL,NULL,'2012-10-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,805734580,12589602,NULL,NULL,NULL,NULL),(2833,2832,0,'LSQ12fpb','LSQ',357.827666666667,6.17744444444445,NULL,NULL,'2012-10-21 03:54:36',56221.16292,18.9961,0.085,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 20:45:27','2012-10-21 20:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpb/LSQ12fpb_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpb/LSQ12fpb_snap_66652.gif',51567013181,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,805734580,12589602,NULL,NULL,NULL,NULL),(2834,2834,1,'LSQ12fpa','LSQ',355.07425,2.85063888888889,NULL,NULL,'2012-10-07 03:57:05',56207.1646500002,19.6074,0.0953,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 20:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpa/LSQ12fpa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpa/LSQ12fpa_snap_66700.gif',51605537725,NULL,NULL,NULL,'2012-09-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,806336526,12599008,NULL,NULL,NULL,NULL),(2835,2834,0,'LSQ12fpa','LSQ',355.074125,2.85058333333333,NULL,NULL,'2012-10-21 00:32:55',56221.02287,19.5423,0.0709,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 20:45:27','2012-10-21 20:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpa/LSQ12fpa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpa/LSQ12fpa_snap_66649.gif',51605537725,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,806336526,12599008,NULL,NULL,NULL,NULL),(2836,2834,0,'LSQ12fpa','LSQ',355.074125,2.85063888888889,NULL,NULL,'2012-10-21 02:20:23',56221.0974900001,19.4325,0.0961,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 20:45:27','2012-10-21 20:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpa/LSQ12fpa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpa/LSQ12fpa_snap_66650.gif',51605537725,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,806336526,12599008,NULL,NULL,NULL,NULL),(2837,2834,0,'LSQ12fpa','LSQ',355.074291666667,2.85063888888889,NULL,NULL,'2012-10-21 04:08:12',56221.1723699998,19.2245,0.0881,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 20:45:27','2012-10-21 20:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpa/LSQ12fpa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpa/LSQ12fpa_snap_66701.gif',51605537725,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,806336526,12599008,NULL,NULL,NULL,NULL),(2838,2838,1,'LSQ12fos','LSQ',330.666041666667,-22.0346388888889,NULL,NULL,'2012-10-17 01:10:42',56217.0490999999,18.3808,0.1824,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 20:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fos/LSQ12fos_history.html','sne?',NULL,0.064751,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fos/LSQ12fos_snap_66677.gif',50870538671,NULL,NULL,NULL,'2012-10-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794852166,12419565,NULL,NULL,NULL,NULL),(2839,2838,0,'LSQ12fos','LSQ',330.666083333333,-22.0346388888889,NULL,NULL,'2012-10-19 01:01:35',56219.0427700002,18.5805,0.1807,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 20:45:27','2012-10-21 20:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fos/LSQ12fos_history.html','sne?',NULL,0.064751,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fos/LSQ12fos_snap_66678.gif',50870538671,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794852166,12419565,NULL,NULL,NULL,NULL),(2840,2838,0,'LSQ12fos','LSQ',330.666208333333,-22.0345833333333,NULL,NULL,'2012-10-21 00:55:30',56221.0385500002,19.148,0.1101,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 20:45:27','2012-10-21 20:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fos/LSQ12fos_history.html','sne?',NULL,0.064751,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fos/LSQ12fos_snap_66633.gif',50870538671,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794852166,12419565,NULL,NULL,NULL,NULL),(2841,2838,0,'LSQ12fos','LSQ',330.666166666667,-22.0346111111111,NULL,NULL,'2012-10-21 02:55:37',56221.1219600001,18.0153,0.1242,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 20:45:27','2012-10-21 20:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fos/LSQ12fos_history.html','sne?',NULL,0.064751,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fos/LSQ12fos_snap_66634.gif',50870538671,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794852166,12419565,NULL,NULL,NULL,NULL),(2842,2842,1,'LSQ12fpk','LSQ',357.646625,9.61619444444444,NULL,NULL,'2012-10-07 04:24:12',56207.1834800001,18.2544,0.0264,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 21:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpk/LSQ12fpk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpk/LSQ12fpk_snap_66706.gif',51777400930,NULL,NULL,NULL,'2012-10-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,809021889,12640967,NULL,NULL,NULL,NULL),(2843,2842,0,'LSQ12fpk','LSQ',357.646791666667,9.61616666666667,NULL,NULL,'2012-10-07 05:19:18',56207.2217399999,18.9695,0.0496,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 21:45:27','2012-10-21 21:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpk/LSQ12fpk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpk/LSQ12fpk_snap_66707.gif',51777401059,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,809021891,12640967,NULL,NULL,NULL,NULL),(2844,2842,0,'LSQ12fpk','LSQ',357.646708333333,9.61616666666667,NULL,NULL,'2012-10-07 06:14:34',56207.2601200002,19.3166,0.097,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 21:45:27','2012-10-21 21:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpk/LSQ12fpk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpk/LSQ12fpk_snap_66708.gif',51777400930,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,809021889,12640967,NULL,NULL,NULL,NULL),(2845,2842,0,'LSQ12fpk','LSQ',357.646708333333,9.61613888888889,NULL,NULL,'2012-10-21 00:25:31',56221.0177199999,18.0591,0.0338,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 21:45:27','2012-10-21 21:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpk/LSQ12fpk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpk/LSQ12fpk_snap_66670.gif',51777401057,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,809021891,12640967,NULL,NULL,NULL,NULL),(2846,2842,0,'LSQ12fpk','LSQ',357.646666666667,9.61605555555555,NULL,NULL,'2012-10-21 02:12:59',56221.09235,18.1961,0.0449,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 21:45:27','2012-10-21 21:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpk/LSQ12fpk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpk/LSQ12fpk_snap_66671.gif',51777401057,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,809021891,12640967,NULL,NULL,NULL,NULL),(2847,2842,0,'LSQ12fpk','LSQ',357.646625,9.61613888888889,NULL,NULL,'2012-10-21 03:58:18',56221.16549,17.8206,0.0288,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-21 21:45:27','2012-10-21 21:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpk/LSQ12fpk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpk/LSQ12fpk_snap_66709.gif',51777400930,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,809021889,12640967,NULL,NULL,NULL,NULL),(2848,2787,0,'LSQ12fnt','pessto',53.1725,-1.18647222222,NULL,NULL,'2012-10-21 07:51:35',56221.327495,NULL,NULL,NULL,0.019,NULL,'Ic',NULL,'2012-10-21 22:45:33','2012-10-21 22:45:33','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,36816048052,'NTT','EFOSC2','Nancy Elias Rosa',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575250750,8988292,NULL,NULL,NULL,NULL),(2849,2333,0,'LSQ12fkh','pessto',37.7215833333,9.59466666667,NULL,NULL,'2012-10-21 07:28:21',56221.311364,NULL,NULL,NULL,0.144,NULL,'unknown',NULL,'2012-10-21 22:50:36','2012-10-21 22:50:36','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,66860301346,'NTT','EFOSC2','Nancy Elias Rosa',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044692208,16323315,NULL,NULL,NULL,NULL),(2850,2725,0,'LSQ12fmx','atel',48.2170833333,-0.203555555556,NULL,NULL,'2012-10-21 00:00:00',56221,NULL,NULL,NULL,0,NULL,'Ia',NULL,'2012-10-22 13:40:03','2012-10-22 13:40:03','http://www.astronomerstelegram.org/?read=4505',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,36785353942,'Hawaii 2.2-meter telescope','SuperNova Integral Field Spectrograph','NSFII',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574771155,8980799,NULL,NULL,NULL,NULL),(2851,2226,0,'LSQ12fiq','LSQ',70.4199166666667,-9.89288888888889,NULL,NULL,'2012-10-22 08:07:41',56222.33867,19.6413,0.1077,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-22 13:45:27','2012-10-22 13:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_snap_66776.gif',37499689591,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585932649,9155197,NULL,NULL,NULL,NULL),(2852,2226,0,'LSQ12fiq','LSQ',70.4199583333333,-9.89288888888889,NULL,NULL,'2012-10-22 08:35:31',56222.358,19.4393,0.0896,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-22 13:45:27','2012-10-22 13:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_snap_66777.gif',37499689591,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585932649,9155197,NULL,NULL,NULL,NULL),(2853,2357,0,'LSQ12fjx','LSQ',69.607875,-10.1939166666667,NULL,NULL,'2012-10-22 08:07:41',56222.33867,19.453,0.1294,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-22 13:45:27','2012-10-22 13:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_66731.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2854,2357,0,'LSQ12fjx','LSQ',69.6075833333333,-10.1939166666667,NULL,NULL,'2012-10-22 08:35:31',56222.358,19.4413,0.1319,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-22 13:45:27','2012-10-22 13:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_66732.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2855,2368,0,'LSQ12fjw','LSQ',56.3842916666667,-7.39613888888889,NULL,NULL,'2012-10-22 07:57:30',56222.3316000002,18.6727,0.0795,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-22 13:45:27','2012-10-22 13:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_history.html','sne - nice',NULL,0.02832,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_snap_66728.gif',37031203527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578612555,9040821,NULL,NULL,NULL,NULL),(2856,2368,0,'LSQ12fjw','LSQ',56.38425,-7.39636111111111,NULL,NULL,'2012-10-22 08:44:21',56222.3641400002,18.1974,0.0494,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-22 13:45:27','2012-10-22 13:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_history.html','sne - nice',NULL,0.02832,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_snap_66729.gif',37031203527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578612555,9040821,NULL,NULL,NULL,NULL),(2857,2733,0,'LSQ12fmd','LSQ',54.9455,-7.50530555555556,NULL,NULL,'2012-10-22 07:52:26',56222.3280799999,18.7938,0.0662,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-22 13:45:27','2012-10-22 13:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_history.html','sne-nice',NULL,0.11854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_snap_66746.gif',37019211459,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578425179,9037893,NULL,NULL,NULL,NULL),(2858,2733,0,'LSQ12fmd','LSQ',54.9455416666667,-7.50536111111111,NULL,NULL,'2012-10-22 08:27:03',56222.3521199999,18.7794,0.0671,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-22 13:45:27','2012-10-22 13:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_history.html','sne-nice',NULL,0.11854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_snap_66747.gif',37019211459,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578425179,9037893,NULL,NULL,NULL,NULL),(2859,2859,1,'LSQ12fpn','LSQ',43.1860416666667,-8.01855555555556,NULL,NULL,'2012-10-10 05:20:30',56210.2225799998,21.1494,0.1927,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-22 16:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpn/LSQ12fpn_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpn/LSQ12fpn_snap_66840.gif',37909640484,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592338132,9255283,NULL,NULL,NULL,NULL),(2860,2859,0,'LSQ12fpn','LSQ',43.186,-8.01847222222222,NULL,NULL,'2012-10-16 05:43:27',56216.2385100001,20.9023,0.1775,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-22 16:45:27','2012-10-22 16:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpn/LSQ12fpn_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpn/LSQ12fpn_snap_66841.gif',37909640484,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592338132,9255283,NULL,NULL,NULL,NULL),(2861,2859,0,'LSQ12fpn','LSQ',43.1855416666667,-8.01913888888889,NULL,NULL,'2012-10-20 05:27:53',56220.2277000002,20.4046,0.2156,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-22 16:45:27','2012-10-22 16:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpn/LSQ12fpn_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpn/LSQ12fpn_snap_66842.gif',37909629496,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592337960,9255280,NULL,NULL,NULL,NULL),(2862,2859,0,'LSQ12fpn','LSQ',43.1857916666667,-8.01916666666667,NULL,NULL,'2012-10-20 08:21:46',56220.34846,20.7714,0.1757,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-22 16:45:27','2012-10-22 16:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpn/LSQ12fpn_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpn/LSQ12fpn_snap_66843.gif',37909629444,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592337960,9255280,NULL,NULL,NULL,NULL),(2863,2859,0,'LSQ12fpn','LSQ',43.1857083333333,-8.01905555555556,NULL,NULL,'2012-10-22 07:43:58',56222.3221999998,20.0573,0.1306,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-22 16:45:27','2012-10-22 16:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpn/LSQ12fpn_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpn/LSQ12fpn_snap_66832.gif',37909629496,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592337960,9255280,NULL,NULL,NULL,NULL),(2864,2859,0,'LSQ12fpn','LSQ',43.1857916666667,-8.01891666666667,NULL,NULL,'2012-10-22 08:51:06',56222.3688300001,19.5942,0.1046,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-22 16:45:27','2012-10-22 16:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpn/LSQ12fpn_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpn/LSQ12fpn_snap_66833.gif',37909629496,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592337960,9255280,NULL,NULL,NULL,NULL),(2865,2865,1,'LSQ12fpl','LSQ',35.3445,-10.7851666666667,NULL,NULL,'2012-10-14 07:36:16',56214.3168600001,21.1549,0.2066,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-22 16:45:27','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpl/LSQ12fpl_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpl/LSQ12fpl_snap_66836.gif',35118512334,NULL,NULL,NULL,'2012-10-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,548726755,8573855,NULL,NULL,NULL,NULL),(2866,2865,0,'LSQ12fpl','LSQ',35.3444166666667,-10.78525,NULL,NULL,'2012-10-22 07:38:53',56222.31868,19.6624,0.0815,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-22 16:45:27','2012-10-22 16:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpl/LSQ12fpl_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpl/LSQ12fpl_snap_66828.gif',35118512334,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,548726755,8573855,NULL,NULL,NULL,NULL),(2867,2865,0,'LSQ12fpl','LSQ',35.3444583333333,-10.7850277777778,NULL,NULL,'2012-10-22 08:20:17',56222.34742,20.6959,0.1368,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-22 16:45:27','2012-10-22 16:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpl/LSQ12fpl_history.html','sn??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpl/LSQ12fpl_snap_66829.gif',35118512335,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,548726755,8573855,NULL,NULL,NULL,NULL),(2868,2056,0,'LSQ12ffu','LSQ',353.758208333333,-22.2103333333333,NULL,NULL,'2012-10-23 02:06:08',56223.0876000002,19.3342,0.1216,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 00:45:27','2012-10-24 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_snap_66980.gif',50273699729,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785526558,12273852,NULL,NULL,NULL,NULL),(2869,2818,0,'LSQ12foj','LSQ',345.208291666667,-22.4439722222222,NULL,NULL,'2012-10-23 03:35:43',56223.1498099999,19.1856,0.1885,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 00:45:27','2012-10-24 00:45:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12foj/LSQ12foj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12foj/LSQ12foj_snap_67014.gif',50217891886,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,784654560,12260227,NULL,NULL,NULL,NULL),(2870,2870,1,'LSQ12fqi','LSQ',55.8408333333333,-36.8534444444444,NULL,NULL,'2012-10-05 05:04:45',56205.2116399999,18.5066,0.1755,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 03:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqi/LSQ12fqi_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqi/LSQ12fqi_snap_67047.gif',38557401062,NULL,NULL,NULL,'2012-10-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602459391,9413427,NULL,NULL,NULL,NULL),(2871,2870,0,'LSQ12fqi','LSQ',55.841125,-36.8533333333333,NULL,NULL,'2012-10-23 05:49:16',56223.2425500001,18.216,0.1685,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 03:45:30','2012-10-24 03:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqi/LSQ12fqi_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqi/LSQ12fqi_snap_67033.gif',38557401062,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602459391,9413427,NULL,NULL,NULL,NULL),(2872,2870,0,'LSQ12fqi','LSQ',55.8409166666667,-36.8533055555556,NULL,NULL,'2012-10-23 08:29:16',56223.35366,16.7144,0.1118,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 03:45:30','2012-10-24 03:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqi/LSQ12fqi_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqi/LSQ12fqi_snap_67034.gif',38557401062,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602459391,9413427,NULL,NULL,NULL,NULL),(2873,2126,0,'LSQ12fgy','LSQ',64.7325416666667,-4.19852777777778,NULL,NULL,'2012-10-24 07:57:59',56224.3319399999,17.8383,0.0355,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_snap_67148.gif',36966141626,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577595962,9024936,NULL,NULL,NULL,NULL),(2874,2126,0,'LSQ12fgy','LSQ',64.7324583333333,-4.19852777777778,NULL,NULL,'2012-10-24 08:28:52',56224.3533899998,18.1242,0.0384,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fgy/LSQ12fgy_snap_67149.gif',36966141626,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577595962,9024936,NULL,NULL,NULL,NULL),(2875,2226,0,'LSQ12fiq','LSQ',70.4199166666667,-9.89291666666667,NULL,NULL,'2012-10-24 07:34:03',56224.3153200001,19.6457,0.1054,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_snap_67213.gif',37499689591,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585932649,9155197,NULL,NULL,NULL,NULL),(2876,2226,0,'LSQ12fiq','LSQ',70.42,-9.89288888888889,NULL,NULL,'2012-10-24 08:16:48',56224.3450099998,19.5114,0.1061,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fiq/LSQ12fiq_snap_67214.gif',37499689591,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585932649,9155197,NULL,NULL,NULL,NULL),(2877,2232,0,'LSQ12fik','LSQ',56.7644583333333,-10.9834166666667,NULL,NULL,'2012-10-24 08:51:06',56224.3688300001,19.1537,0.1809,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_67216.gif',37025736046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(2878,2241,0,'LSQ12fjm','LSQ',69.0454166666667,-5.08152777777778,NULL,NULL,'2012-10-24 07:59:40',56224.33311,18.042,0.0406,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_snap_67239.gif',37460190256,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585315472,9145554,NULL,NULL,NULL,NULL),(2879,2241,0,'LSQ12fjm','LSQ',69.0454166666667,-5.08147222222222,NULL,NULL,'2012-10-24 08:32:15',56224.35574,18.0113,0.0422,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_snap_67240.gif',37460190256,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585315472,9145554,NULL,NULL,NULL,NULL),(2880,2247,0,'LSQ12fji','LSQ',57.3125,-6.10366666666667,NULL,NULL,'2012-10-24 07:49:31',56224.3260599999,18.9537,0.0834,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_67225.gif',37029491967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2881,2247,0,'LSQ12fji','LSQ',57.3124166666667,-6.10372222222222,NULL,NULL,'2012-10-24 07:51:12',56224.3272299999,19.3701,0.1218,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_67223.gif',37029491967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2882,2247,0,'LSQ12fji','LSQ',57.312375,-6.10372222222222,NULL,NULL,'2012-10-24 08:25:30',56224.3510500002,19.1182,0.1029,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_67224.gif',37029491967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2883,2247,0,'LSQ12fji','LSQ',57.3125416666667,-6.10366666666667,NULL,NULL,'2012-10-24 08:37:20',56224.3592699999,18.6955,0.1106,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fji/LSQ12fji_snap_67226.gif',37029491967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578585811,9040403,NULL,NULL,NULL,NULL),(2884,2336,0,'LSQ12fkf','LSQ',22.880125,3.41597222222222,NULL,NULL,'2012-10-24 01:10:52',56224.0492199999,18.728,0.2095,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkf/LSQ12fkf_snap_67152.gif',67518050300,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1054969535,16483898,NULL,NULL,NULL,NULL),(2885,2349,0,'LSQ12fjy','LSQ',32.5964583333333,-6.75594444444444,NULL,NULL,'2012-10-24 06:27:55',56224.26939,19.2832,0.181,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjy/LSQ12fjy_snap_67125.gif',35150329089,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549223892,8581623,NULL,NULL,NULL,NULL),(2886,2357,0,'LSQ12fjx','LSQ',69.6076666666667,-10.1938611111111,NULL,NULL,'2012-10-24 07:34:03',56224.3153200001,19.5717,0.138,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_67132.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2887,2357,0,'LSQ12fjx','LSQ',69.6077083333333,-10.1939166666667,NULL,NULL,'2012-10-24 08:16:48',56224.3450099998,20.2773,0.1854,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjx/LSQ12fjx_snap_67133.gif',37469589788,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585462340,9147849,NULL,NULL,NULL,NULL),(2888,2368,0,'LSQ12fjw','LSQ',56.3841666666667,-7.39644444444444,NULL,NULL,'2012-10-24 07:23:53',56224.3082599998,19.6796,0.13,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_history.html','sne - nice',NULL,0.02832,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_snap_67130.gif',37031203527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578612555,9040821,NULL,NULL,NULL,NULL),(2889,2580,0,'LSQ12fks','LSQ',65.5730416666667,-6.22902777777778,NULL,NULL,'2012-10-24 07:57:59',56224.3319399999,19.8211,0.138,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_snap_67159.gif',36948141630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577314712,9020542,NULL,NULL,NULL,NULL),(2890,2580,0,'LSQ12fks','LSQ',65.573,-6.22897222222222,NULL,NULL,'2012-10-24 08:28:52',56224.3533899998,19.7696,0.1476,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_snap_67160.gif',36948141630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577314712,9020542,NULL,NULL,NULL,NULL),(2891,2642,0,'LSQ12fls','LSQ',35.3909166666667,2.64297222222222,NULL,NULL,'2012-10-24 06:22:45',56224.2658000002,17.1372,0.0507,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fls/LSQ12fls_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fls/LSQ12fls_snap_67200.gif',66888306583,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045129790,16330152,NULL,NULL,NULL,NULL),(2892,2655,0,'LSQ12fli','LSQ',67.7674583333333,-7.20380555555556,NULL,NULL,'2012-10-24 08:30:33',56224.3545599999,18.5727,0.1239,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_history.html','hostless sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fli/LSQ12fli_snap_67199.gif',37505778949,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586027796,9156684,NULL,NULL,NULL,NULL),(2893,2660,0,'LSQ12flb','LSQ',68.1232916666667,-3.30727777777778,NULL,NULL,'2012-10-24 07:59:40',56224.33311,18.6296,0.0778,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flb/LSQ12flb_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flb/LSQ12flb_snap_67202.gif',37462033171,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,585344268,9146004,NULL,NULL,NULL,NULL),(2894,2660,0,'LSQ12flb','LSQ',68.12325,-3.30722222222222,NULL,NULL,'2012-10-24 08:32:15',56224.35574,18.4685,0.0928,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flb/LSQ12flb_history.html','sne???',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12flb/LSQ12flb_snap_67203.gif',37462033170,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,585344268,9146004,NULL,NULL,NULL,NULL),(2895,2662,0,'LSQ12fkz','LSQ',65.0195416666667,-4.06152777777778,NULL,NULL,'2012-10-24 07:56:17',56224.3307599998,19.9287,0.2002,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkz/LSQ12fkz_snap_67201.gif',36920772812,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,576887075,9013860,NULL,NULL,NULL,NULL),(2896,2730,0,'LSQ12fml','LSQ',56.015625,-3.28813888888889,NULL,NULL,'2012-10-24 07:49:31',56224.3260599999,19.7288,0.1085,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fml/LSQ12fml_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fml/LSQ12fml_snap_67107.gif',37008688674,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578260760,9035324,NULL,NULL,NULL,NULL),(2897,2733,0,'LSQ12fmd','LSQ',54.9455,-7.50533333333333,NULL,NULL,'2012-10-24 07:18:50',56224.3047500001,18.8362,0.0736,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_history.html','sne-nice',NULL,0.11854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_snap_67153.gif',37019211459,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578425179,9037893,NULL,NULL,NULL,NULL),(2898,2733,0,'LSQ12fmd','LSQ',54.9455416666667,-7.50533333333333,NULL,NULL,'2012-10-24 08:52:48',56224.3700100002,18.7663,0.0723,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_history.html','sne-nice',NULL,0.11854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fmd/LSQ12fmd_snap_67154.gif',37019211459,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578425179,9037893,NULL,NULL,NULL,NULL),(2899,2794,0,'LSQ12fnq','LSQ',23.3745416666667,1.48763888888889,NULL,NULL,'2012-10-24 01:24:29',56224.0586700002,17.8352,0.2162,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fnq/LSQ12fnq_snap_67258.gif',66978187147,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1046534174,16352096,NULL,NULL,NULL,NULL),(2900,2900,1,'LSQ12fqb','LSQ',70.887,-11.9014444444444,NULL,NULL,'2012-09-22 08:29:11',56192.3536100001,19.5718,0.1428,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_66927.gif',37539439936,NULL,NULL,NULL,'2012-09-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553749,9164902,NULL,NULL,NULL,NULL),(2901,2900,0,'LSQ12fqb','LSQ',70.8874166666667,-11.9014166666667,NULL,NULL,'2012-10-10 09:12:04',56210.3833900001,18.7616,0.0746,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_66928.gif',37539441792,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553778,9164902,NULL,NULL,NULL,NULL),(2902,2900,0,'LSQ12fqb','LSQ',70.8871666666667,-11.9013611111111,NULL,NULL,'2012-10-12 07:43:53',56212.3221499999,15.7505,0.0612,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_66929.gif',37539440384,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553756,9164902,NULL,NULL,NULL,NULL),(2903,2900,0,'LSQ12fqb','LSQ',70.8880416666667,-11.9005833333333,NULL,NULL,'2012-10-14 06:10:22',56214.25721,20.7211,0.1974,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_66930.gif',37539442240,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553785,9164902,NULL,NULL,NULL,NULL),(2904,2900,0,'LSQ12fqb','LSQ',70.8877083333333,-11.9010555555556,NULL,NULL,'2012-10-14 07:53:59',56214.3291600002,19.4619,0.1945,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_66931.gif',37539442240,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553785,9164902,NULL,NULL,NULL,NULL),(2905,2900,0,'LSQ12fqb','LSQ',70.8873333333333,-11.9013611111111,NULL,NULL,'2012-10-16 07:48:13',56216.32516,18.7424,0.1006,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_66932.gif',37539440384,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553756,9164902,NULL,NULL,NULL,NULL),(2906,2900,0,'LSQ12fqb','LSQ',70.8877916666667,-11.9011944444444,NULL,NULL,'2012-10-20 06:05:40',56220.2539400002,19.7792,0.1182,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_66933.gif',37539442240,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553785,9164902,NULL,NULL,NULL,NULL),(2907,2900,0,'LSQ12fqb','LSQ',70.887625,-11.9011388888889,NULL,NULL,'2012-10-22 08:05:59',56222.3374999999,18.0625,0.0781,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_66881.gif',37539442240,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553785,9164902,NULL,NULL,NULL,NULL),(2908,2900,0,'LSQ12fqb','LSQ',70.8875416666667,-11.9012777777778,NULL,NULL,'2012-10-22 08:33:50',56222.3568299999,19.5089,0.1567,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_66882.gif',37539442240,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553785,9164902,NULL,NULL,NULL,NULL),(2909,2900,0,'LSQ12fqb','LSQ',70.887625,-11.9013055555556,NULL,NULL,'2012-10-24 07:32:23',56224.3141600001,19.3585,0.1417,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_67277.gif',37539442240,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553785,9164902,NULL,NULL,NULL,NULL),(2910,2910,1,'LSQ12fqa','LSQ',64.3617083333333,-8.61152777777778,NULL,NULL,'2012-10-22 08:04:18',56222.3363299998,19.6618,0.0922,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqa/LSQ12fqa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqa/LSQ12fqa_snap_66879.gif',36959373901,NULL,NULL,NULL,'2012-10-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577490217,9023284,NULL,NULL,NULL,NULL),(2911,2910,0,'LSQ12fqa','LSQ',64.361875,-8.61155555555555,NULL,NULL,'2012-10-22 08:37:12',56222.3591700001,20.3122,0.1443,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqa/LSQ12fqa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqa/LSQ12fqa_snap_66880.gif',36959373897,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577490217,9023284,NULL,NULL,NULL,NULL),(2912,2912,1,'LSQ12fpz','LSQ',64.473625,-8.48719444444444,NULL,NULL,'2012-10-16 06:19:35',56216.2636000002,20.5043,0.1471,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpz/LSQ12fpz_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpz/LSQ12fpz_snap_66926.gif',36959365563,NULL,NULL,NULL,'2012-10-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577490086,9023282,NULL,NULL,NULL,NULL),(2913,2912,0,'LSQ12fpz','LSQ',64.4737083333333,-8.48741666666667,NULL,NULL,'2012-10-22 08:04:18',56222.3363299998,18.8901,0.0505,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpz/LSQ12fpz_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpz/LSQ12fpz_snap_66877.gif',36959365563,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577490086,9023282,NULL,NULL,NULL,NULL),(2914,2912,0,'LSQ12fpz','LSQ',64.4737083333333,-8.48736111111111,NULL,NULL,'2012-10-22 08:37:12',56222.3591700001,20.2293,0.1292,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpz/LSQ12fpz_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpz/LSQ12fpz_snap_66878.gif',36959365563,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577490086,9023282,NULL,NULL,NULL,NULL),(2915,2915,1,'LSQ12fpv','LSQ',56.9062916666667,-8.73211111111111,NULL,NULL,'2012-10-08 07:14:34',56208.3017899999,18.8004,0.1492,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_history.html','sn?',NULL,0.034397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_snap_66917.gif',37021133909,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578455217,9038362,NULL,NULL,NULL,NULL),(2916,2915,0,'LSQ12fpv','LSQ',56.9054166666667,-8.73155555555556,NULL,NULL,'2012-10-12 07:29:32',56212.3121799999,19.9965,0.1335,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_history.html','sn?',NULL,0.034397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_snap_66918.gif',37021133916,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578455217,9038362,NULL,NULL,NULL,NULL),(2917,2915,0,'LSQ12fpv','LSQ',56.9055833333333,-8.73211111111111,NULL,NULL,'2012-10-16 06:11:07',56216.2577300002,20.0932,0.1631,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_history.html','sn?',NULL,0.034397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_snap_66919.gif',37021133916,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578455217,9038362,NULL,NULL,NULL,NULL),(2918,2915,0,'LSQ12fpv','LSQ',56.9063333333333,-8.73216666666667,NULL,NULL,'2012-10-16 08:10:43',56216.3407800002,20.3333,0.1482,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_history.html','sn?',NULL,0.034397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_snap_66959.gif',37021133909,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578455217,9038362,NULL,NULL,NULL,NULL),(2919,2915,0,'LSQ12fpv','LSQ',56.9055,-8.73180555555555,NULL,NULL,'2012-10-22 07:55:49',56222.3304300001,19.6435,0.1246,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_history.html','sn?',NULL,0.034397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_snap_66869.gif',37021133916,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578455217,9038362,NULL,NULL,NULL,NULL),(2920,2915,0,'LSQ12fpv','LSQ',56.90575,-8.73186111111111,NULL,NULL,'2012-10-22 08:46:02',56222.3653099998,20.1168,0.1497,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 16:45:29','2012-10-24 16:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_history.html','sn?',NULL,0.034397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_snap_66870.gif',37021133916,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578455217,9038362,NULL,NULL,NULL,NULL),(2921,1472,0,'LSQ12fly','LSQ',41.499375,-7.57322222222222,NULL,NULL,'2012-09-22 06:18:20',56192.2627400002,14.766,0.0032,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_history.html','sne - nice',NULL,0.00436,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_snap_65610.gif',37875151025,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591799234,9246863,NULL,NULL,NULL,NULL),(2922,1472,0,'LSQ12fly','LSQ',41.499375,-7.57322222222222,NULL,NULL,'2012-09-22 08:08:31',56192.3392500002,14.5982,0.0053,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_history.html','sne - nice',NULL,0.00436,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_snap_65611.gif',37875151025,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591799234,9246863,NULL,NULL,NULL,NULL),(2923,1472,0,'LSQ12fly','LSQ',41.4994166666667,-7.57316666666667,NULL,NULL,'2012-10-14 05:24:21',56214.2252500001,14.7302,0.0032,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_history.html','sne - nice',NULL,0.00436,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_snap_65612.gif',37875151025,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591799234,9246863,NULL,NULL,NULL,NULL),(2924,1472,0,'LSQ12fly','LSQ',41.499375,-7.57325,NULL,NULL,'2012-10-14 07:17:41',56214.3039500001,14.9687,0.0034,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_history.html','sne - nice',NULL,0.00436,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_snap_65613.gif',37875151025,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591799234,9246863,NULL,NULL,NULL,NULL),(2925,1472,0,'LSQ12fly','LSQ',41.4993333333333,-7.57325,NULL,NULL,'2012-10-16 05:41:46',56216.23734,14.6864,0.0028,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_history.html','sne - nice',NULL,0.00436,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_snap_65614.gif',37875151025,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591799234,9246863,NULL,NULL,NULL,NULL),(2926,1472,0,'LSQ12fly','LSQ',41.499375,-7.57322222222222,NULL,NULL,'2012-10-16 08:20:51',56216.3478199998,14.7192,0.0029,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_history.html','sne - nice',NULL,0.00436,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_snap_65615.gif',37875151025,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591799234,9246863,NULL,NULL,NULL,NULL),(2927,1472,0,'LSQ12fly','LSQ',41.499375,-7.57322222222222,NULL,NULL,'2012-10-18 05:09:04',56218.2146399999,14.7468,0.0027,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_history.html','sne - nice',NULL,0.00436,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_snap_65564.gif',37875151025,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591799234,9246863,NULL,NULL,NULL,NULL),(2928,1472,0,'LSQ12fly','LSQ',41.4993333333333,-7.57319444444444,NULL,NULL,'2012-10-18 07:40:16',56218.3196399999,14.7412,0.0026,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_history.html','sne - nice',NULL,0.00436,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_snap_65565.gif',37875151025,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591799234,9246863,NULL,NULL,NULL,NULL),(2929,1472,0,'LSQ12fly','LSQ',41.499375,-7.57319444444444,NULL,NULL,'2012-10-20 05:26:12',56220.2265300001,14.7638,0.0026,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_history.html','sne - nice',NULL,0.00436,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_snap_65815.gif',37875151025,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591799234,9246863,NULL,NULL,NULL,NULL),(2930,1472,0,'LSQ12fly','LSQ',41.4993333333333,-7.57319444444444,NULL,NULL,'2012-10-20 08:23:28',56220.3496300001,14.7532,0.0028,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_history.html','sne - nice',NULL,0.00436,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_snap_65816.gif',37875151025,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591799234,9246863,NULL,NULL,NULL,NULL),(2931,1472,0,'LSQ12fly','LSQ',41.499375,-7.57322222222222,NULL,NULL,'2012-10-22 07:42:16',56222.3210300002,14.8607,0.0036,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_history.html','sne - nice',NULL,0.00436,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_snap_66710.gif',37875151025,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591799234,9246863,NULL,NULL,NULL,NULL),(2932,1472,0,'LSQ12fly','LSQ',41.499375,-7.57322222222222,NULL,NULL,'2012-10-22 08:52:48',56222.3700000001,14.8298,0.0036,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_history.html','sne - nice',NULL,0.00436,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_snap_66711.gif',37875151025,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591799234,9246863,NULL,NULL,NULL,NULL),(2933,1472,0,'LSQ12fly','LSQ',41.4993333333333,-7.57319444444444,NULL,NULL,'2012-10-24 07:08:42',56224.2977100001,14.8304,0.0029,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_history.html','sne - nice',NULL,0.00436,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_snap_67091.gif',37875151025,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591799234,9246863,NULL,NULL,NULL,NULL),(2934,1472,0,'LSQ12fly','LSQ',41.499375,-7.57322222222222,NULL,NULL,'2012-10-24 08:57:52',56224.37353,14.7063,0.0039,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_history.html','sne - nice',NULL,0.00436,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fly/LSQ12fly_snap_67092.gif',37875151025,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591799234,9246863,NULL,NULL,NULL,NULL),(2935,2935,1,'LSQ12fpx','LSQ',64.6495,-8.48208333333333,NULL,NULL,'2012-10-22 08:04:18',56222.3363299998,18.9593,0.0507,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpx/LSQ12fpx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpx/LSQ12fpx_snap_66873.gif',36959279540,NULL,NULL,NULL,'2012-10-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,577488742,9023261,NULL,NULL,NULL,NULL),(2936,2935,0,'LSQ12fpx','LSQ',64.6495416666667,-8.48208333333333,NULL,NULL,'2012-10-22 08:37:12',56222.3591700001,20.384,0.1374,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpx/LSQ12fpx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpx/LSQ12fpx_snap_66874.gif',36959279540,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,577488742,9023261,NULL,NULL,NULL,NULL),(2937,2937,1,'LSQ12fpr','LSQ',47.573375,-10.5156944444444,NULL,NULL,'2012-10-22 07:49:03',56222.3257399998,18.5065,0.0663,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpr/LSQ12fpr_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpr/LSQ12fpr_snap_66861.gif',37894166865,NULL,NULL,NULL,'2012-10-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592096357,9251505,NULL,NULL,NULL,NULL),(2938,2937,0,'LSQ12fpr','LSQ',47.5732916666667,-10.5153333333333,NULL,NULL,'2012-10-22 08:49:25',56222.36766,17.8249,0.0516,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpr/LSQ12fpr_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpr/LSQ12fpr_snap_66862.gif',37894166867,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592096357,9251505,NULL,NULL,NULL,NULL),(2939,2939,1,'LSQ12fpp','LSQ',50.866625,-12.0055833333333,NULL,NULL,'2012-09-22 06:27:12',56192.2688899999,18.8191,0.1116,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_66891.gif',37885516712,NULL,NULL,NULL,'2012-09-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(2940,2939,0,'LSQ12fpp','LSQ',50.8665,-12.0053333333333,NULL,NULL,'2012-09-22 08:05:09',56192.3369100001,19.0919,0.1309,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_66892.gif',37885516712,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(2941,2939,0,'LSQ12fpp','LSQ',50.8660416666667,-12.0058888888889,NULL,NULL,'2012-10-02 03:23:38',56202.1414200002,17.3391,0.1611,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_66954.gif',37885516720,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(2942,2939,0,'LSQ12fpp','LSQ',50.8665416666667,-12.0053611111111,NULL,NULL,'2012-10-10 05:25:35',56210.2261000001,19.1134,0.1726,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_66893.gif',37885516712,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(2943,2939,0,'LSQ12fpp','LSQ',50.8662916666667,-12.0055,NULL,NULL,'2012-10-12 08:18:29',56212.3461699998,18.8225,0.0887,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_66894.gif',37885516712,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(2944,2939,0,'LSQ12fpp','LSQ',50.8667916666667,-12.0053055555556,NULL,NULL,'2012-10-14 05:31:07',56214.2299500001,20.0346,0.1964,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_66895.gif',37885516712,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(2945,2939,0,'LSQ12fpp','LSQ',50.8664166666667,-12.0054444444444,NULL,NULL,'2012-10-14 07:21:02',56214.3062800001,19.2659,0.1256,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_66896.gif',37885516712,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(2946,2939,0,'LSQ12fpp','LSQ',50.866375,-12.0054722222222,NULL,NULL,'2012-10-16 08:17:28',56216.3454700001,19.1437,0.1563,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_66897.gif',37885516712,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(2947,2939,0,'LSQ12fpp','LSQ',50.8665,-12.0055555555556,NULL,NULL,'2012-10-18 05:15:50',56218.2193300002,19.1658,0.1129,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_66898.gif',37885516712,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(2948,2939,0,'LSQ12fpp','LSQ',50.8663333333333,-12.0054722222222,NULL,NULL,'2012-10-18 07:28:11',56218.3112400002,19.2479,0.1304,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_66899.gif',37885516712,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(2949,2939,0,'LSQ12fpp','LSQ',50.8664166666667,-12.0054444444444,NULL,NULL,'2012-10-20 08:16:41',56220.3449300001,19.2617,0.1172,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_66900.gif',37885516712,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(2950,2939,0,'LSQ12fpp','LSQ',50.866875,-12.0053055555556,NULL,NULL,'2012-10-22 07:49:03',56222.3257399998,18.5104,0.1361,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_66857.gif',37885516712,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(2951,2939,0,'LSQ12fpp','LSQ',50.8668333333333,-12.0054166666667,NULL,NULL,'2012-10-22 08:49:25',56222.36766,18.3953,0.1178,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_66858.gif',37885516712,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(2952,2939,0,'LSQ12fpp','LSQ',50.8663333333333,-12.0054444444444,NULL,NULL,'2012-10-24 07:15:28',56224.30241,18.8197,0.1766,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-24 17:45:29','2012-10-24 17:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_67275.gif',37885516712,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(2953,2044,0,'LSQ12ffx','LSQ',335.201,-20.6736944444444,NULL,NULL,'2012-10-25 03:04:09',56225.1278900001,17.9455,0.1598,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 02:45:30','2012-10-26 02:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffx/LSQ12ffx_snap_67535.gif',50207229407,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784487959,12257624,NULL,NULL,NULL,NULL),(2954,2070,0,'LSQ12ffz','LSQ',336.665666666667,-17.6382777777778,NULL,NULL,'2012-10-25 03:05:50',56225.1290600002,17.8525,0.1371,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 02:45:30','2012-10-26 02:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffz/LSQ12ffz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffz/LSQ12ffz_snap_67544.gif',50237257514,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,784957148,12264955,NULL,NULL,NULL,NULL),(2955,2196,0,'LSQ12fhq','LSQ',333.663166666667,-21.5688055555556,NULL,NULL,'2012-10-25 01:01:54',56225.04299,18.5822,0.1092,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 02:45:30','2012-10-26 02:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhq/LSQ12fhq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fhq/LSQ12fhq_snap_67555.gif',49728887306,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'BS',NULL,0,NULL,0,777013864,12140841,NULL,NULL,NULL,NULL),(2956,2374,0,'LSQ12fkm','LSQ',328.735625,-23.7348888888889,NULL,NULL,'2012-10-25 00:38:23',56225.02666,19.11,0.2138,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 02:45:30','2019-09-20 18:19:47','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_history.html','sne?',NULL,0.069024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fkm/LSQ12fkm_snap_67549.gif',50883020778,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,795047199,12422612,NULL,NULL,NULL,NULL),(2957,2838,0,'LSQ12fos','LSQ',330.666166666667,-22.0346388888889,NULL,NULL,'2012-10-25 00:38:23',56225.02666,18.1925,0.1942,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 02:45:30','2012-10-26 02:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fos/LSQ12fos_history.html','sne?',NULL,0.064751,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fos/LSQ12fos_snap_67577.gif',50870538671,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794852166,12419565,NULL,NULL,NULL,NULL),(2958,2838,0,'LSQ12fos','LSQ',330.666083333333,-22.0344722222222,NULL,NULL,'2012-10-25 02:37:58',56225.10971,18.1845,0.1702,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 02:45:30','2012-10-26 02:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fos/LSQ12fos_history.html','sne?',NULL,0.064751,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fos/LSQ12fos_snap_67578.gif',50870538671,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,794852166,12419565,NULL,NULL,NULL,NULL),(2959,2959,1,'LSQ12frb','LSQ',51.5676666666667,-5.16413888888889,NULL,NULL,'2012-08-28 09:09:42',56167.3817400001,19.7056,0.1441,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 14:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_snap_67485.gif',36840221571,NULL,NULL,NULL,'2012-08-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,575628462,8994194,NULL,NULL,NULL,NULL),(2960,2959,0,'LSQ12frb','LSQ',51.5677916666667,-5.16419444444444,NULL,NULL,'2012-10-10 08:00:53',56210.3339499999,19.8255,0.1541,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 14:45:30','2012-10-26 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_snap_67486.gif',36840221571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,575628462,8994194,NULL,NULL,NULL,NULL),(2961,2959,0,'LSQ12frb','LSQ',51.5678333333333,-5.16422222222222,NULL,NULL,'2012-10-10 08:59:52',56210.3749099998,19.8501,0.1354,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 14:45:30','2012-10-26 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_snap_67487.gif',36840221571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,575628462,8994194,NULL,NULL,NULL,NULL),(2962,2959,0,'LSQ12frb','LSQ',51.5675833333333,-5.16408333333333,NULL,NULL,'2012-10-14 07:57:29',56214.3315900001,20.0234,0.1467,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 14:45:30','2012-10-26 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_snap_67488.gif',36840221571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,575628462,8994194,NULL,NULL,NULL,NULL),(2963,2959,0,'LSQ12frb','LSQ',51.56775,-5.16452777777778,NULL,NULL,'2012-10-16 07:58:40',56216.3324099998,17.5427,0.1961,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 14:45:30','2012-10-26 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_snap_67489.gif',36840221571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,575628462,8994194,NULL,NULL,NULL,NULL),(2964,2959,0,'LSQ12frb','LSQ',51.567875,-5.16419444444444,NULL,NULL,'2012-10-18 06:33:21',56218.2731599999,19.6715,0.1292,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 14:45:30','2012-10-26 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_snap_67490.gif',36840221571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,575628462,8994194,NULL,NULL,NULL,NULL),(2965,2959,0,'LSQ12frb','LSQ',51.5675833333333,-5.16427777777778,NULL,NULL,'2012-10-18 07:50:26',56218.32669,19.5183,0.1409,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 14:45:30','2012-10-26 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_snap_67491.gif',36840221571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,575628462,8994194,NULL,NULL,NULL,NULL),(2966,2959,0,'LSQ12frb','LSQ',51.5677083333333,-5.16419444444444,NULL,NULL,'2012-10-20 07:44:11',56220.3223600001,20.0297,0.1675,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 14:45:30','2012-10-26 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_snap_67492.gif',36840221571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,575628462,8994194,NULL,NULL,NULL,NULL),(2967,2959,0,'LSQ12frb','LSQ',51.5677916666667,-5.16433333333333,NULL,NULL,'2012-10-24 07:47:49',56224.3248800002,16.8537,0.1584,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 14:45:30','2012-10-26 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_snap_67453.gif',36840221571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,575628462,8994194,NULL,NULL,NULL,NULL),(2968,2959,0,'LSQ12frb','LSQ',51.5678333333333,-5.16436111111111,NULL,NULL,'2012-10-24 08:23:48',56224.34987,18.5246,0.1006,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 14:45:30','2012-10-26 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_snap_67454.gif',36840221571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,575628462,8994194,NULL,NULL,NULL,NULL),(2969,2969,1,'LSQ12fqz','LSQ',46.69975,-6.77147222222222,NULL,NULL,'2012-10-12 08:49:12',56212.3675099998,19.4417,0.1022,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 14:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqz/LSQ12fqz_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqz/LSQ12fqz_snap_67478.gif',37905636157,NULL,NULL,NULL,'2012-10-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592275564,9254305,NULL,NULL,NULL,NULL),(2970,2969,0,'LSQ12fqz','LSQ',46.70025,-6.771,NULL,NULL,'2012-10-24 07:41:05',56224.3202,19.8337,0.138,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 14:45:30','2012-10-26 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqz/LSQ12fqz_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqz/LSQ12fqz_snap_67449.gif',37905636156,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592275564,9254305,NULL,NULL,NULL,NULL),(2971,2969,0,'LSQ12fqz','LSQ',46.7004583333333,-6.77116666666667,NULL,NULL,'2012-10-24 08:20:24',56224.3475100002,19.3292,0.1058,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-26 14:45:30','2012-10-26 14:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqz/LSQ12fqz_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqz/LSQ12fqz_snap_67450.gif',37905636159,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592275564,9254305,NULL,NULL,NULL,NULL),(2972,2972,1,'LSQ12fse','LSQ',23.329625,-14.71275,NULL,NULL,'2012-10-25 06:10:22',56225.2571999999,18.0821,0.0501,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-27 07:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fse/LSQ12fse_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fse/LSQ12fse_snap_67634.gif',35185003902,NULL,NULL,NULL,'2012-10-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549765685,8590088,NULL,NULL,NULL,NULL),(2973,2972,0,'LSQ12fse','LSQ',23.3297083333333,-14.7128055555556,NULL,NULL,'2012-10-25 08:02:06',56225.3347999998,18.0352,0.0349,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-27 07:45:30','2012-10-27 07:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fse/LSQ12fse_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fse/LSQ12fse_snap_67635.gif',35185003902,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549765685,8590088,NULL,NULL,NULL,NULL),(2974,2974,1,'LSQ12frx','LSQ',12.98825,-23.7101666666667,NULL,NULL,'2012-10-25 03:02:07',56225.1264800001,18.2004,0.0618,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-27 07:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_snap_67620.gif',35316090512,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(2975,2974,0,'LSQ12frx','LSQ',12.9882916666667,-23.7101666666667,NULL,NULL,'2012-10-25 05:04:00',56225.2111200001,18.1482,0.0605,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-27 07:45:30','2012-10-27 07:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_snap_67621.gif',35316090512,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(2976,2976,1,'LSQ12fro','LSQ',46.4135416666667,-33.5880833333333,NULL,NULL,'2012-10-25 05:37:12',56225.2341700001,18.6979,0.0911,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-27 07:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fro/LSQ12fro_history.html','CV?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fro/LSQ12fro_snap_67602.gif',38648187714,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603877933,9435592,NULL,NULL,NULL,NULL),(2977,2976,0,'LSQ12fro','LSQ',46.4138333333333,-33.5880833333333,NULL,NULL,'2012-10-25 07:17:55',56225.3041099999,18.4788,0.0444,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-27 07:45:30','2012-10-27 07:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fro/LSQ12fro_history.html','CV?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fro/LSQ12fro_snap_67603.gif',38648187714,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603877933,9435592,NULL,NULL,NULL,NULL),(2978,2978,1,'LSQ12fri','LSQ',39.9744583333333,-34.7340833333333,NULL,NULL,'2012-10-25 04:50:08',56225.2014899999,18.4921,0.11,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-27 07:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fri/LSQ12fri_history.html','Brightening!!!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fri/LSQ12fri_snap_67590.gif',38633072543,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603641758,9431902,NULL,NULL,NULL,NULL),(2979,2978,0,'LSQ12fri','LSQ',39.9743333333333,-34.7340277777778,NULL,NULL,'2012-10-25 06:49:18',56225.2842399999,18.9185,0.0864,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-27 07:45:30','2012-10-27 07:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fri/LSQ12fri_history.html','Brightening!!!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fri/LSQ12fri_snap_67591.gif',38633072543,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603641758,9431902,NULL,NULL,NULL,NULL),(2980,2049,0,'LSQ12ffv','LSQ',353.965333333333,-22.1025277777778,NULL,NULL,'2012-10-26 02:47:13',56226.11613,19.1115,0.1801,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-27 18:45:31','2012-10-27 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_history.html','agn?',NULL,0.112098,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffv/LSQ12ffv_snap_67693.gif',50276565092,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,785571329,12274552,NULL,NULL,NULL,NULL),(2981,2056,0,'LSQ12ffu','LSQ',353.757958333333,-22.2100555555556,NULL,NULL,'2012-10-26 00:47:21',56226.0328899999,19.0837,0.136,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-27 18:45:31','2012-10-27 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_snap_67689.gif',50273699805,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785526559,12273852,NULL,NULL,NULL,NULL),(2982,2056,0,'LSQ12ffu','LSQ',353.758125,-22.21,NULL,NULL,'2012-10-26 02:47:13',56226.11613,18.4469,0.1035,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-27 18:45:31','2012-10-27 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ffu/LSQ12ffu_snap_67690.gif',50273699794,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785526559,12273852,NULL,NULL,NULL,NULL),(2983,2974,0,'LSQ12frx','LSQ',12.9882083333333,-23.7101666666667,NULL,NULL,'2012-10-26 01:56:03',56226.0806,18.3494,0.062,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-27 18:45:31','2012-10-27 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_snap_67751.gif',35316090512,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(2984,2974,0,'LSQ12frx','LSQ',12.9882916666667,-23.7101944444444,NULL,NULL,'2012-10-26 03:58:16',56226.1654699999,18.3076,0.0635,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-27 18:45:31','2012-10-27 18:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_snap_67752.gif',35316090512,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(2985,2985,1,'LSQ12fsh','LSQ',12.776625,-39.1600277777778,NULL,NULL,'2012-10-26 02:04:32',56226.0864900001,18.0636,0.0481,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 19:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_67776.gif',38166915083,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(2986,2985,0,'LSQ12fsh','LSQ',12.7767916666667,-39.1599722222222,NULL,NULL,'2012-10-26 04:06:44',56226.17135,18.0723,0.0327,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 19:45:30','2012-10-28 19:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_67777.gif',38166915082,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(2987,2987,1,'LSQ12fsj','LSQ',73.7291666666667,-36.3250277777778,NULL,NULL,'2012-10-25 05:24:44',56225.2255199999,19.6654,0.1284,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 20:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_67803.gif',37816670598,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(2988,2987,0,'LSQ12fsj','LSQ',73.7292083333333,-36.3249722222222,NULL,NULL,'2012-10-25 07:12:01',56225.30002,19.8286,0.0813,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 20:45:31','2012-10-28 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_67804.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(2989,2987,0,'LSQ12fsj','LSQ',73.72925,-36.3249722222222,NULL,NULL,'2012-10-26 04:42:38',56226.1962799998,19.1777,0.0781,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 20:45:31','2012-10-28 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_67780.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(2990,2987,0,'LSQ12fsj','LSQ',73.7292083333333,-36.3249722222222,NULL,NULL,'2012-10-26 06:43:04',56226.27991,19.2276,0.0567,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 20:45:31','2012-10-28 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_67781.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(2991,2991,1,'LSQ12fsi','LSQ',1.5045,-35.1924166666667,NULL,NULL,'2012-10-26 01:00:54',56226.0422999999,18.4895,0.136,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 20:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_history.html','Old',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_snap_67778.gif',34665129379,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,541642646,8463166,NULL,NULL,NULL,NULL),(2992,2991,0,'LSQ12fsi','LSQ',1.50458333333333,-35.1926666666667,NULL,NULL,'2012-10-26 03:00:45',56226.1255299998,19.7058,0.1508,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 20:45:31','2012-10-28 20:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_history.html','Old',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_snap_67779.gif',34665129379,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,541642646,8463166,NULL,NULL,NULL,NULL),(2993,2993,1,'LSQ12fss','LSQ',18.715875,-30.0939444444444,NULL,NULL,'2012-10-26 02:16:28',56226.0947699999,18.3555,0.1322,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 21:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_67798.gif',34734808839,NULL,NULL,NULL,'2012-10-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(2994,2993,0,'LSQ12fss','LSQ',18.715875,-30.0939722222222,NULL,NULL,'2012-10-26 04:18:44',56226.1796800001,18.3226,0.0579,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 21:45:30','2012-10-28 21:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_67799.gif',34734808839,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(2995,2995,1,'LSQ12fsp','LSQ',357.212,-38.5518888888889,NULL,NULL,'2012-10-25 02:01:24',56225.0843099998,16.7626,0.0286,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 21:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_history.html','Bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_snap_67806.gif',49991723132,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781120673,12205010,NULL,NULL,NULL,NULL),(2996,2995,0,'LSQ12fsp','LSQ',357.212125,-38.5519444444444,NULL,NULL,'2012-10-25 04:01:55',56225.1680000001,16.6121,0.0196,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 21:45:30','2012-10-28 21:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_history.html','Bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_snap_67807.gif',49991723130,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781120673,12205010,NULL,NULL,NULL,NULL),(2997,2995,0,'LSQ12fsp','LSQ',357.212,-38.5519444444444,NULL,NULL,'2012-10-26 00:54:06',56226.0375799998,16.4895,0.0152,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 21:45:30','2012-10-28 21:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_history.html','Bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_snap_67792.gif',49991723132,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781120673,12205010,NULL,NULL,NULL,NULL),(2998,2995,0,'LSQ12fsp','LSQ',357.212,-38.5519722222222,NULL,NULL,'2012-10-26 02:53:59',56226.1208299999,16.4473,0.0179,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 21:45:30','2012-10-28 21:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_history.html','Bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_snap_67793.gif',49991723132,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781120673,12205010,NULL,NULL,NULL,NULL),(2999,2999,1,'LSQ12fsn','LSQ',10.6064166666667,-34.0972777777778,NULL,NULL,'2012-10-26 01:44:41',56226.0726999999,14.8279,0.0066,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 21:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_history.html','Unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_snap_67788.gif',34872861140,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544888455,8513882,NULL,NULL,NULL,NULL),(3000,2999,0,'LSQ12fsn','LSQ',10.606375,-34.0972777777778,NULL,NULL,'2012-10-26 03:46:58',56226.1576200002,15.5038,0.0069,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 21:45:30','2012-10-28 21:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_history.html','Unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_snap_67789.gif',34872861140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544888455,8513882,NULL,NULL,NULL,NULL),(3001,3001,1,'LSQ12fth','LSQ',47.8228333333333,-25.1096388888889,NULL,NULL,'2012-10-26 05:57:02',56226.2479400001,17.4021,0.0407,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_67840.gif',38018766862,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3002,3001,0,'LSQ12fth','LSQ',47.8225416666667,-25.10975,NULL,NULL,'2012-10-26 05:58:42',56226.2491000001,18.1322,0.0368,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_67842.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3003,3001,0,'LSQ12fth','LSQ',47.8225416666667,-25.10975,NULL,NULL,'2012-10-26 07:28:10',56226.3112300001,18.0999,0.0352,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_67843.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3004,3001,0,'LSQ12fth','LSQ',47.82275,-25.1096388888889,NULL,NULL,'2012-10-26 07:50:11',56226.3265200001,17.7124,0.0277,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_67841.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3005,3005,1,'LSQ12ftg','LSQ',44.9482083333333,-23.7169444444444,NULL,NULL,'2012-10-26 05:55:20',56226.24676,18.5791,0.0942,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftg/LSQ12ftg_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftg/LSQ12ftg_snap_67838.gif',38051514190,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594554909,9289920,NULL,NULL,NULL,NULL),(3006,3005,0,'LSQ12ftg','LSQ',44.9482916666667,-23.7168888888889,NULL,NULL,'2012-10-26 07:26:29',56226.31006,18.2979,0.0865,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftg/LSQ12ftg_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftg/LSQ12ftg_snap_67839.gif',38051514190,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594554909,9289920,NULL,NULL,NULL,NULL),(3007,3007,1,'LSQ12fte','LSQ',52.1528333333333,-24.8718888888889,NULL,NULL,'2012-10-26 06:00:24',56226.2502799998,19.0646,0.1289,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_snap_67834.gif',38021943870,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594092872,9282701,NULL,NULL,NULL,NULL),(3008,3007,0,'LSQ12fte','LSQ',52.1529583333333,-24.8718333333333,NULL,NULL,'2012-10-26 07:48:29',56226.32534,20.0235,0.1295,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_snap_67835.gif',38021943862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594092872,9282701,NULL,NULL,NULL,NULL),(3009,3009,1,'LSQ12ftd','LSQ',64.2445833333333,-24.1446666666667,NULL,NULL,'2012-10-26 06:10:35',56226.2573600002,19.032,0.1319,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_67826.gif',37178445164,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3010,3009,0,'LSQ12ftd','LSQ',64.244625,-24.1448055555556,NULL,NULL,'2012-10-26 06:12:17',56226.2585399998,19.4237,0.109,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_67830.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3011,3009,0,'LSQ12ftd','LSQ',64.2445833333333,-24.1448055555556,NULL,NULL,'2012-10-26 07:34:58',56226.3159500002,19.2374,0.1295,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_67831.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3012,3009,0,'LSQ12ftd','LSQ',64.24475,-24.1446944444444,NULL,NULL,'2012-10-26 07:43:25',56226.3218200002,18.6954,0.0956,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_67827.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3013,3013,1,'LSQ12ftc','LSQ',64.8030833333333,-24.3553055555556,NULL,NULL,'2012-10-26 06:10:35',56226.2573600002,19.2116,0.0883,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_67824.gif',37179083500,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3014,3013,0,'LSQ12ftc','LSQ',64.8028333333333,-24.3551388888889,NULL,NULL,'2012-10-26 06:12:17',56226.2585399998,18.787,0.0778,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_67832.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3015,3013,0,'LSQ12ftc','LSQ',64.8028333333333,-24.3552222222222,NULL,NULL,'2012-10-26 07:34:58',56226.3159500002,18.6715,0.0616,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_67833.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3016,3013,0,'LSQ12ftc','LSQ',64.8031666666667,-24.35525,NULL,NULL,'2012-10-26 07:43:25',56226.3218200002,18.9313,0.06,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_67825.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3017,3017,1,'LSQ12ftb','LSQ',65.4215833333333,-23.7053611111111,NULL,NULL,'2012-10-26 06:10:35',56226.2573600002,17.883,0.0377,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_67822.gif',37314276029,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3018,3017,0,'LSQ12ftb','LSQ',65.422,-23.70525,NULL,NULL,'2012-10-26 06:12:17',56226.2585399998,18.1306,0.043,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_67828.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3019,3017,0,'LSQ12ftb','LSQ',65.4220416666667,-23.70525,NULL,NULL,'2012-10-26 07:34:58',56226.3159500002,18.0137,0.0361,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_67829.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3020,3017,0,'LSQ12ftb','LSQ',65.42175,-23.70525,NULL,NULL,'2012-10-26 07:43:25',56226.3218200002,17.5632,0.0405,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_67823.gif',37314276018,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3021,3021,1,'LSQ12fta','LSQ',353.339208333333,-33.0118333333333,NULL,NULL,'2012-10-25 01:39:16',56225.0689400001,18.9751,0.1041,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fta/LSQ12fta_history.html','AGN?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fta/LSQ12fta_snap_67857.gif',50174717533,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,783979961,12249686,NULL,NULL,NULL,NULL),(3022,3021,0,'LSQ12fta','LSQ',353.33875,-33.0116944444444,NULL,NULL,'2012-10-26 00:37:14',56226.0258599999,17.7997,0.042,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fta/LSQ12fta_history.html','AGN?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fta/LSQ12fta_snap_67820.gif',50174717533,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,783979961,12249686,NULL,NULL,NULL,NULL),(3023,3021,0,'LSQ12fta','LSQ',353.33875,-33.0116388888889,NULL,NULL,'2012-10-26 02:37:05',56226.1090899999,17.8419,0.0435,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fta/LSQ12fta_history.html','AGN?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fta/LSQ12fta_snap_67821.gif',50174717533,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,783979961,12249686,NULL,NULL,NULL,NULL),(3024,3024,1,'LSQ12fsu','LSQ',358.064208333333,-34.2621388888889,NULL,NULL,'2012-10-25 01:58:02',56225.0819700002,18.588,0.1099,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsu/LSQ12fsu_history.html','Slow rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsu/LSQ12fsu_snap_67854.gif',49947390750,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,780427980,12194187,NULL,NULL,NULL,NULL),(3025,3024,0,'LSQ12fsu','LSQ',358.064333333333,-34.2624722222222,NULL,NULL,'2012-10-26 00:50:43',56226.03523,18.2914,0.0607,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsu/LSQ12fsu_history.html','Slow rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsu/LSQ12fsu_snap_67808.gif',49947390751,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,780427980,12194187,NULL,NULL,NULL,NULL),(3026,3024,0,'LSQ12fsu','LSQ',358.064458333333,-34.2624444444444,NULL,NULL,'2012-10-26 02:50:36',56226.1184800002,19.2605,0.1045,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-10-28 22:45:32','2012-10-28 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsu/LSQ12fsu_history.html','Slow rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsu/LSQ12fsu_snap_67809.gif',49947390751,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,780427980,12194187,NULL,NULL,NULL,NULL),(3027,3027,0,'PSNJ03333599-3607377','TOCP',53.4004166666667,-36.1261111111111,NULL,NULL,'2012-10-27 01:11:59',56227.05,16,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-10-30 06:06:44','2019-10-12 20:41:36','http://www.astronomerstelegram.org/?read=4523','supernova',NULL,0.0041,NULL,NULL,'NULL',NULL,NULL,38567734073,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602620844,9415950,NULL,NULL,NULL,NULL),(3028,3027,0,'PSNJ03333599-3607377','atel',53.4004166667,-36.1261111111,NULL,NULL,'2012-10-28 00:00:00',56228,NULL,NULL,NULL,0.004,NULL,'Ia',NULL,'2012-10-30 11:14:52','2012-10-30 11:14:52','http://www.astronomerstelegram.org/?read=4525',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38567734073,'SSO 2.2-m','WiFeS','Mike Childress',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602620844,9415950,NULL,NULL,NULL,NULL),(3029,2974,0,'LSQ12frx','atel',12.98825,-23.7101666667,NULL,NULL,'2012-10-28 12:00:00',56228.5,NULL,NULL,NULL,0.03,NULL,'Ibc',NULL,'2012-10-31 19:38:14','2012-10-31 19:38:14','http://www.astronomerstelegram.org/?read=4526',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35316090512,'UH 2.2m','SNIFS','SNfactory',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(3030,2972,0,'LSQ12fse','atel',23.329625,-14.71275,NULL,NULL,'2012-10-28 12:00:00',56228.5,NULL,NULL,NULL,0.06,NULL,'Ia',NULL,'2012-10-31 19:39:22','2012-10-31 19:39:22','http://www.astronomerstelegram.org/?read=4526',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35185003902,'UH 2.2m','SNIFS','SNfactory',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549765685,8590088,NULL,NULL,NULL,NULL),(3031,3017,0,'LSQ12ftb','LSQ',65.4215833333,-23.7053611111,NULL,NULL,'2012-10-31 12:00:00',56231.5,NULL,NULL,NULL,0.04,NULL,'II',NULL,'2012-10-31 19:41:57','2012-10-31 19:41:57','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37314276029,'UH 2.2m','SNIFS','SNfactory',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3032,3001,0,'LSQ12fth','LSQ',47.8228333333,-25.1096388889,NULL,NULL,'2012-10-31 12:00:00',56231.5,NULL,NULL,NULL,0.022,NULL,'II',NULL,'2012-10-31 19:43:08','2012-10-31 19:43:08','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38018766862,'UH 2.2m','SNIFS','SNfactory',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3033,3033,1,'LSQ12fvf','LSQ',7.617375,6.94572222222222,NULL,NULL,'2012-10-31 01:12:39',56231.0504600001,19.1535,0.1049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 13:45:28','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvf/LSQ12fvf_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvf/LSQ12fvf_snap_68056.gif',66839103492,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044360992,16318140,NULL,NULL,NULL,NULL),(3034,3033,0,'LSQ12fvf','LSQ',7.61754166666667,6.94569444444444,NULL,NULL,'2012-10-31 03:14:50',56231.1353099998,19.3947,0.1358,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 13:45:28','2012-11-01 13:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvf/LSQ12fvf_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvf/LSQ12fvf_snap_68057.gif',66839103492,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044360992,16318140,NULL,NULL,NULL,NULL),(3035,3035,1,'LSQ12fux','LSQ',19.35625,0.586833333333333,NULL,NULL,'2012-10-31 02:28:43',56231.1032799999,17.7626,0.1088,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 13:45:28','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fux/LSQ12fux_history.html','sne - good',NULL,0.05924,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fux/LSQ12fux_snap_68040.gif',66652909103,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041451704,16272682,NULL,NULL,NULL,NULL),(3036,3035,0,'LSQ12fux','LSQ',19.35625,0.586666666666667,NULL,NULL,'2012-10-31 04:30:49',56231.1880700001,17.6406,0.141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 13:45:28','2012-11-01 13:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fux/LSQ12fux_history.html','sne - good',NULL,0.05924,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fux/LSQ12fux_snap_68041.gif',66652909103,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041451704,16272682,NULL,NULL,NULL,NULL),(3037,3037,1,'LSQ12fuw','LSQ',19.2002083333333,0.540972222222222,NULL,NULL,'2012-10-27 01:17:13',56227.05363,17.1669,0.1084,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 13:45:28','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuw/LSQ12fuw_history.html','sne - good',NULL,0.04476,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuw/LSQ12fuw_snap_68073.gif',66652921966,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041451905,16272686,NULL,NULL,NULL,NULL),(3038,3037,0,'LSQ12fuw','LSQ',19.2002083333333,0.540944444444444,NULL,NULL,'2012-10-31 02:28:43',56231.1032799999,17.4329,0.0785,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 13:45:28','2012-11-01 13:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuw/LSQ12fuw_history.html','sne - good',NULL,0.04476,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuw/LSQ12fuw_snap_68038.gif',66652921966,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041451905,16272686,NULL,NULL,NULL,NULL),(3039,3037,0,'LSQ12fuw','LSQ',19.20025,0.541027777777778,NULL,NULL,'2012-10-31 04:30:49',56231.1880700001,17.2669,0.1054,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 13:45:28','2012-11-01 13:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuw/LSQ12fuw_history.html','sne - good',NULL,0.04476,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuw/LSQ12fuw_snap_68039.gif',66652921966,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041451905,16272686,NULL,NULL,NULL,NULL),(3040,3040,1,'LSQ12fuv','LSQ',22.0850416666667,-2.54691666666667,NULL,NULL,'2012-10-31 02:28:43',56231.1032799999,18.7925,0.1237,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 13:45:28','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuv/LSQ12fuv_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuv/LSQ12fuv_snap_68036.gif',35234940193,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,550545940,8602280,NULL,NULL,NULL,NULL),(3041,3040,0,'LSQ12fuv','LSQ',22.0852083333333,-2.54688888888889,NULL,NULL,'2012-10-31 04:30:49',56231.1880700001,18.5475,0.0973,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 13:45:28','2012-11-01 13:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuv/LSQ12fuv_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuv/LSQ12fuv_snap_68037.gif',35234940195,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,550545940,8602280,NULL,NULL,NULL,NULL),(3042,3042,1,'LSQ12fuu','LSQ',358.84525,-2.27702777777778,NULL,NULL,'2012-10-31 01:09:08',56231.0480200001,18.8286,0.0893,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 13:45:28','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuu/LSQ12fuu_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuu/LSQ12fuu_snap_68034.gif',49406600211,NULL,NULL,NULL,'2012-09-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,771978128,12062158,NULL,NULL,NULL,NULL),(3043,3042,0,'LSQ12fuu','LSQ',358.845125,-2.27694444444444,NULL,NULL,'2012-10-31 03:11:26',56231.13295,19.7347,0.1653,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 13:45:28','2012-11-01 13:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuu/LSQ12fuu_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuu/LSQ12fuu_snap_68035.gif',49406600211,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,771978128,12062158,NULL,NULL,NULL,NULL),(3044,3044,1,'LSQ12ftn','LSQ',2.53920833333333,-19.1405277777778,NULL,NULL,'2012-10-27 01:01:41',56227.0428399998,18.6273,0.1628,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 13:45:28','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_snap_67971.gif',34442362275,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538161910,8408779,NULL,NULL,NULL,NULL),(3045,3044,0,'LSQ12ftn','LSQ',2.53929166666667,-19.1404444444444,NULL,NULL,'2012-10-31 02:07:46',56231.08873,18.972,0.098,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 13:45:28','2012-11-01 13:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_snap_67963.gif',34442362275,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538161910,8408779,NULL,NULL,NULL,NULL),(3046,3044,0,'LSQ12ftn','LSQ',2.53929166666667,-19.1404444444444,NULL,NULL,'2012-10-31 04:09:59',56231.1736099999,18.7768,0.0943,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 13:45:28','2012-11-01 13:45:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_snap_67964.gif',34442362275,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538161910,8408779,NULL,NULL,NULL,NULL),(3047,3047,1,'LSQ12fun','LSQ',355.184708333333,-0.351722222222222,NULL,NULL,'2012-10-31 00:57:08',56231.0396799999,18.6721,0.0996,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fun/LSQ12fun_history.html','sne or asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fun/LSQ12fun_snap_68018.gif',49397192770,NULL,NULL,NULL,'2012-09-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,771831137,12059861,NULL,NULL,NULL,NULL),(3048,3047,0,'LSQ12fun','LSQ',355.18475,-0.351722222222222,NULL,NULL,'2012-10-31 02:59:19',56231.1245300001,18.8673,0.0991,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2012-11-01 14:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fun/LSQ12fun_history.html','sne or asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fun/LSQ12fun_snap_68019.gif',49397192770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,771831137,12059861,NULL,NULL,NULL,NULL),(3049,3049,1,'LSQ12fuk','LSQ',74.566125,-16.2994722222222,NULL,NULL,'2012-10-31 05:29:03',56231.2285099998,15.3913,0.0066,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_history.html','sne - bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_snap_68012.gif',37569693502,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587026460,9172288,NULL,NULL,NULL,NULL),(3050,3049,0,'LSQ12fuk','LSQ',74.5662083333333,-16.2994166666667,NULL,NULL,'2012-10-31 07:11:14',56231.29947,15.3873,0.0067,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2012-11-01 14:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_history.html','sne - bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_snap_68013.gif',37569693502,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587026460,9172288,NULL,NULL,NULL,NULL),(3051,3051,1,'LSQ12fui','LSQ',70.95175,-13.3013888888889,NULL,NULL,'2012-10-31 05:27:22',56231.2273400002,18.4274,0.0912,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_snap_68008.gif',37542571140,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586602674,9165666,NULL,NULL,NULL,NULL),(3052,3051,0,'LSQ12fui','LSQ',70.9517083333333,-13.3014166666667,NULL,NULL,'2012-10-31 08:15:46',56231.3442899999,18.4299,0.0679,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2012-11-01 14:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_snap_68009.gif',37542571140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586602674,9165666,NULL,NULL,NULL,NULL),(3053,3053,1,'LSQ12fug','LSQ',63.5352916666667,-13.1428611111111,NULL,NULL,'2012-10-31 05:20:32',56231.2226,18.4025,0.1301,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fug/LSQ12fug_history.html','sne?',NULL,0.032095,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fug/LSQ12fug_snap_68004.gif',36861016118,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575953376,8999271,NULL,NULL,NULL,NULL),(3054,3053,0,'LSQ12fug','LSQ',63.5352916666667,-13.1428055555556,NULL,NULL,'2012-10-31 08:19:08',56231.34663,17.5905,0.1165,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2012-11-01 14:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fug/LSQ12fug_history.html','sne?',NULL,0.032095,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fug/LSQ12fug_snap_68005.gif',36861016118,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575953376,8999271,NULL,NULL,NULL,NULL),(3055,3055,1,'LSQ12fue','LSQ',5.97175,-14.4288055555556,NULL,NULL,'2012-10-27 00:57:36',56227.0400100001,18.5705,0.0898,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fue/LSQ12fue_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fue/LSQ12fue_snap_68063.gif',34454135446,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,538345866,8411654,NULL,NULL,NULL,NULL),(3056,3055,0,'LSQ12fue','LSQ',5.97191666666667,-14.4290277777778,NULL,NULL,'2012-10-31 02:02:11',56231.0848599998,19.4016,0.1411,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2012-11-01 14:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fue/LSQ12fue_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fue/LSQ12fue_snap_68000.gif',34454135446,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,538345866,8411654,NULL,NULL,NULL,NULL),(3057,3055,0,'LSQ12fue','LSQ',5.97195833333333,-14.4288333333333,NULL,NULL,'2012-10-31 04:04:30',56231.1697999998,19.2654,0.1425,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2012-11-01 14:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fue/LSQ12fue_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fue/LSQ12fue_snap_68001.gif',34454135446,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,538345866,8411654,NULL,NULL,NULL,NULL),(3058,3058,1,'LSQ12fuc','LSQ',75.0465416666667,-20.0073888888889,NULL,NULL,'2012-10-31 05:04:57',56231.21178,18.9485,0.1314,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_history.html','sne - good',NULL,0.041789,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_snap_67996.gif',37564014387,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586937724,9170901,NULL,NULL,NULL,NULL),(3059,3058,0,'LSQ12fuc','LSQ',75.0465833333333,-20.0073055555556,NULL,NULL,'2012-10-31 06:59:11',56231.2911,20.1163,0.1674,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2012-11-01 14:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_history.html','sne - good',NULL,0.041789,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_snap_67997.gif',37564014387,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586937724,9170901,NULL,NULL,NULL,NULL),(3060,3060,1,'LSQ12ftz','LSQ',74.7339583333333,-20.3273888888889,NULL,NULL,'2012-10-31 05:03:15',56231.2105999999,18.2792,0.0776,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_snap_67990.gif',37561880973,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586904390,9170381,NULL,NULL,NULL,NULL),(3061,3060,0,'LSQ12ftz','LSQ',74.734,-20.3273888888889,NULL,NULL,'2012-10-31 08:27:55',56231.3527199998,18.4353,0.0926,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2012-11-01 14:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_snap_67991.gif',37561880973,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586904390,9170381,NULL,NULL,NULL,NULL),(3062,3062,1,'LSQ12ftu','LSQ',51.19675,-17.6560833333333,NULL,NULL,'2012-10-31 02:41:29',56231.1121499999,17.7863,0.1235,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftu/LSQ12ftu_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftu/LSQ12ftu_snap_67980.gif',38008126944,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593876983,9279327,NULL,NULL,NULL,NULL),(3063,3062,0,'LSQ12ftu','LSQ',51.19675,-17.6561111111111,NULL,NULL,'2012-10-31 04:43:01',56231.1965399999,17.6813,0.0997,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2012-11-01 14:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftu/LSQ12ftu_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftu/LSQ12ftu_snap_67981.gif',38008126944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593876983,9279327,NULL,NULL,NULL,NULL),(3064,3064,1,'LSQ12ftr','LSQ',66.6722083333333,-20.9704166666667,NULL,NULL,'2012-10-31 04:58:11',56231.2070800001,16.4111,0.0172,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_history.html','sne or comet',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_snap_67974.gif',37323194914,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583174920,9112108,NULL,NULL,NULL,NULL),(3065,3064,0,'LSQ12ftr','LSQ',66.6722916666667,-20.9704166666667,NULL,NULL,'2012-10-31 06:55:48',56231.2887599999,16.5214,0.02,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 14:45:29','2012-11-01 14:45:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_history.html','sne or comet',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_snap_67975.gif',37323194914,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583174920,9112108,NULL,NULL,NULL,NULL),(3066,3035,0,'LSQ12fuy','LSQ',19.3754166666667,0.593472222222222,NULL,NULL,'2012-10-27 01:17:13',56227.05363,18.3446,0.1234,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 16:45:30','2012-11-01 16:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuy/LSQ12fuy_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuy/LSQ12fuy_snap_68074.gif',66652936649,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041452135,16272689,NULL,NULL,NULL,NULL),(3067,3035,0,'LSQ12fuy','LSQ',19.3754583333333,0.593416666666667,NULL,NULL,'2012-10-31 02:28:43',56231.1032799999,18.282,0.0992,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 16:45:30','2012-11-01 16:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuy/LSQ12fuy_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuy/LSQ12fuy_snap_68042.gif',66652936649,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041452135,16272689,NULL,NULL,NULL,NULL),(3068,3035,0,'LSQ12fuy','LSQ',19.3754166666667,0.5935,NULL,NULL,'2012-10-31 04:30:49',56231.1880700001,18.202,0.0962,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 16:45:30','2012-11-01 16:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuy/LSQ12fuy_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuy/LSQ12fuy_snap_68043.gif',66652936649,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041452135,16272689,NULL,NULL,NULL,NULL),(3069,3069,1,'LSQ12fus','LSQ',15.9785416666667,-5.93861111111111,NULL,NULL,'2012-10-27 01:15:33',56227.05247,19.1645,0.1419,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 16:45:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_snap_68066.gif',34532215196,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539565862,8430716,NULL,NULL,NULL,NULL),(3070,3069,0,'LSQ12fus','LSQ',15.978625,-5.93844444444444,NULL,NULL,'2012-10-31 02:27:00',56231.1020900002,19.4888,0.1561,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 16:45:30','2012-11-01 16:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_snap_68030.gif',34532215196,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539565862,8430716,NULL,NULL,NULL,NULL),(3071,3069,0,'LSQ12fus','LSQ',15.9785833333333,-5.93855555555556,NULL,NULL,'2012-10-31 04:29:08',56231.1869000001,19.3647,0.1333,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 16:45:30','2012-11-01 16:45:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_snap_68031.gif',34532215196,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539565862,8430716,NULL,NULL,NULL,NULL),(3072,2815,0,'LSQ12fom','LSQ',347.119291666667,-21.66825,NULL,NULL,'2012-11-01 00:20:06',56232.0139600001,19.0568,0.1379,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fom/LSQ12fom_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fom/LSQ12fom_snap_68161.gif',50300598676,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785946854,12280419,NULL,NULL,NULL,NULL),(3073,2974,0,'LSQ12frx','LSQ',12.98825,-23.7101944444444,NULL,NULL,'2012-11-01 01:39:19',56232.0689699999,18.745,0.0542,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_snap_68156.gif',35316090512,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(3074,2974,0,'LSQ12frx','LSQ',12.98825,-23.7101944444444,NULL,NULL,'2012-11-01 03:41:03',56232.1535100001,18.7021,0.0723,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_snap_68157.gif',35316090512,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(3075,2985,0,'LSQ12fsh','LSQ',12.7766666666667,-39.16,NULL,NULL,'2012-11-01 01:47:46',56232.0748399999,18.0214,0.0336,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_68200.gif',38166915083,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(3076,2985,0,'LSQ12fsh','LSQ',12.7765833333333,-39.1599166666667,NULL,NULL,'2012-11-01 03:49:38',56232.1594699998,18.0958,0.0387,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_68201.gif',38166915083,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(3077,2987,0,'LSQ12fsj','LSQ',73.72925,-36.325,NULL,NULL,'2012-11-01 04:35:31',56232.1913399999,17.0106,0.0126,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_68208.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(3078,2987,0,'LSQ12fsj','LSQ',73.7292916666667,-36.325,NULL,NULL,'2012-11-01 06:36:31',56232.2753699999,16.9579,0.0118,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_68209.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(3079,2991,0,'LSQ12fsi','LSQ',1.50466666666667,-35.1925277777778,NULL,NULL,'2012-11-01 00:52:28',56232.0364399999,19.99,0.1458,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_history.html','Old',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_snap_68198.gif',34665129379,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,541642646,8463166,NULL,NULL,NULL,NULL),(3080,2991,0,'LSQ12fsi','LSQ',1.50475,-35.1926388888889,NULL,NULL,'2012-11-01 02:54:10',56232.12096,19.2901,0.1146,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_history.html','Old',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_snap_68199.gif',34665129379,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,541642646,8463166,NULL,NULL,NULL,NULL),(3081,2993,0,'LSQ12fss','LSQ',18.7157916666667,-30.0939722222222,NULL,NULL,'2012-11-01 01:59:34',56232.0830399999,18.8282,0.0532,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_68210.gif',34734808837,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(3082,2993,0,'LSQ12fss','LSQ',18.7158333333333,-30.0939722222222,NULL,NULL,'2012-11-01 04:01:29',56232.1677000001,18.6968,0.0483,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_68211.gif',34734808837,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(3083,2995,0,'LSQ12fsp','LSQ',357.212,-38.5519722222222,NULL,NULL,'2012-11-01 00:45:40',56232.0317199999,15.9412,0.0059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_history.html','Bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_snap_68194.gif',49991723132,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781120673,12205010,NULL,NULL,NULL,NULL),(3084,2995,0,'LSQ12fsp','LSQ',357.212,-38.5519444444444,NULL,NULL,'2012-11-01 02:47:25',56232.1162700001,15.9327,0.0083,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_history.html','Bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_snap_68195.gif',49991723132,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781120673,12205010,NULL,NULL,NULL,NULL),(3085,2999,0,'LSQ12fsn','LSQ',10.606375,-34.0972777777778,NULL,NULL,'2012-11-01 01:32:30',56232.0642400002,14.8539,0.007,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_history.html','Unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_snap_68205.gif',34872861140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544888455,8513882,NULL,NULL,NULL,NULL),(3086,2999,0,'LSQ12fsn','LSQ',10.6064166666667,-34.0972777777778,NULL,NULL,'2012-11-01 03:34:17',56232.1488100002,15.8037,0.0109,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_history.html','Unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_snap_68206.gif',34872861140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544888455,8513882,NULL,NULL,NULL,NULL),(3087,3001,0,'LSQ12fth','LSQ',47.8227083333333,-25.1096111111111,NULL,NULL,'2012-11-01 05:37:37',56232.2344599999,17.7539,0.0478,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_68180.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3088,3001,0,'LSQ12fth','LSQ',47.8225416666667,-25.10975,NULL,NULL,'2012-11-01 05:39:18',56232.23563,18.1072,0.0437,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_68182.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3089,3001,0,'LSQ12fth','LSQ',47.82275,-25.1096388888889,NULL,NULL,'2012-11-01 07:14:50',56232.3019699999,17.6283,0.0493,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_68181.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3090,3001,0,'LSQ12fth','LSQ',47.8225416666667,-25.1097222222222,NULL,NULL,'2012-11-01 07:16:31',56232.30314,18.0445,0.0466,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_68183.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3091,3005,0,'LSQ12ftg','LSQ',44.9482083333333,-23.7169444444444,NULL,NULL,'2012-11-01 05:35:56',56232.2332899999,18.9106,0.1331,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftg/LSQ12ftg_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftg/LSQ12ftg_snap_68219.gif',38051514190,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594554909,9289920,NULL,NULL,NULL,NULL),(3092,3007,0,'LSQ12fte','LSQ',52.1529166666667,-24.8718888888889,NULL,NULL,'2012-11-01 05:40:58',56232.23679,19.7943,0.2106,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_snap_68216.gif',38021943862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594092872,9282701,NULL,NULL,NULL,NULL),(3093,3009,0,'LSQ12ftd','LSQ',64.2445833333333,-24.1447222222222,NULL,NULL,'2012-11-01 05:51:06',56232.2438300001,19.0978,0.1409,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_68177.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3094,3009,0,'LSQ12ftd','LSQ',64.2446666666667,-24.1447777777778,NULL,NULL,'2012-11-01 05:52:48',56232.2450000001,19.6181,0.1518,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_68178.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3095,3009,0,'LSQ12ftd','LSQ',64.2445416666667,-24.1447777777778,NULL,NULL,'2012-11-01 07:23:17',56232.3078399999,19.2044,0.195,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_68179.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3096,3013,0,'LSQ12ftc','LSQ',64.8029583333333,-24.3552777777778,NULL,NULL,'2012-11-01 05:51:06',56232.2438300001,18.9022,0.087,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_68186.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3097,3013,0,'LSQ12ftc','LSQ',64.80275,-24.3551666666667,NULL,NULL,'2012-11-01 05:52:48',56232.2450000001,18.7442,0.0996,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_68188.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3098,3013,0,'LSQ12ftc','LSQ',64.8030416666667,-24.35525,NULL,NULL,'2012-11-01 07:21:36',56232.3066699998,18.939,0.1054,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_68187.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3099,3013,0,'LSQ12ftc','LSQ',64.8028333333333,-24.3551666666667,NULL,NULL,'2012-11-01 07:23:17',56232.3078399999,18.9568,0.1041,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_68189.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3100,3017,0,'LSQ12ftb','LSQ',65.4214166666667,-23.7053611111111,NULL,NULL,'2012-11-01 05:51:06',56232.2438300001,17.8653,0.0641,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_68212.gif',37314276031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3101,3017,0,'LSQ12ftb','LSQ',65.422,-23.70525,NULL,NULL,'2012-11-01 05:52:48',56232.2450000001,18.3566,0.0649,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_68214.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3102,3017,0,'LSQ12ftb','LSQ',65.4215,-23.7053611111111,NULL,NULL,'2012-11-01 07:21:36',56232.3066699998,17.8972,0.0664,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_68213.gif',37314276031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3103,3017,0,'LSQ12ftb','LSQ',65.4219583333333,-23.7052777777778,NULL,NULL,'2012-11-01 07:23:17',56232.3078399999,18.2093,0.0703,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_68215.gif',37314276018,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3104,3021,0,'LSQ12fta','LSQ',353.338833333333,-33.0115,NULL,NULL,'2012-11-01 00:25:09',56232.0174699998,17.0243,0.0151,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fta/LSQ12fta_history.html','AGN?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fta/LSQ12fta_snap_68184.gif',50174717533,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,783979961,12249686,NULL,NULL,NULL,NULL),(3105,3021,0,'LSQ12fta','LSQ',353.338791666667,-33.0116944444444,NULL,NULL,'2012-11-01 02:27:05',56232.1021500002,17.8923,0.0447,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-01 22:45:32','2012-11-01 22:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fta/LSQ12fta_history.html','AGN?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fta/LSQ12fta_snap_68185.gif',50174717533,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,783979961,12249686,NULL,NULL,NULL,NULL),(3106,3106,1,'LSQ12fsw','LSQ',74.1662916666667,-30.1311944444444,NULL,NULL,'2012-10-26 05:46:37',56226.24071,18.599,0.0911,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_snap_67812.gif',37203066251,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,581297910,9082779,NULL,NULL,NULL,NULL),(3107,3106,0,'LSQ12fsw','LSQ',74.1660833333333,-30.1313055555556,NULL,NULL,'2012-10-26 07:55:31',56226.33023,18.8272,0.0931,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2012-11-02 15:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_snap_67813.gif',37203066251,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,581297910,9082779,NULL,NULL,NULL,NULL),(3108,3106,0,'LSQ12fsw','LSQ',74.1662083333333,-30.1311666666667,NULL,NULL,'2012-11-01 05:27:06',56232.2271599998,18.5265,0.0939,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2012-11-02 15:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_snap_68217.gif',37203066251,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,581297910,9082779,NULL,NULL,NULL,NULL),(3109,3106,0,'LSQ12fsw','LSQ',74.1658333333333,-30.1308333333333,NULL,NULL,'2012-11-01 07:47:17',56232.3245100002,17.9341,0.061,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2012-11-02 15:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_snap_68218.gif',37203066249,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,581297910,9082779,NULL,NULL,NULL,NULL),(3110,3110,1,'LSQ12fvw','LSQ',43.0017083333333,-25.5421388888889,NULL,NULL,'2012-11-01 05:34:14',56232.2321100002,18.5679,0.0934,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvw/LSQ12fvw_history.html','sn - nice',NULL,0.1101,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvw/LSQ12fvw_snap_68252.gif',38420117951,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600314342,9379911,NULL,NULL,NULL,NULL),(3111,3110,0,'LSQ12fvw','LSQ',43.0015,-25.5421111111111,NULL,NULL,'2012-11-01 07:43:34',56232.3219300001,18.6639,0.1437,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2012-11-02 15:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvw/LSQ12fvw_history.html','sn - nice',NULL,0.1101,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvw/LSQ12fvw_snap_68253.gif',38420117951,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600314342,9379911,NULL,NULL,NULL,NULL),(3112,3112,1,'LSQ12fvu','LSQ',53.5190416666667,-21.8744166666667,NULL,NULL,'2012-11-01 05:42:40',56232.2379700001,19.5783,0.1421,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_68248.gif',38040994987,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(3113,3112,0,'LSQ12fvu','LSQ',53.5189583333333,-21.8744722222222,NULL,NULL,'2012-11-01 07:38:28',56232.3183900001,19.7415,0.1335,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2012-11-02 15:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_68249.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(3114,3114,1,'LSQ12fvq','LSQ',19.15075,-31.4520555555556,NULL,NULL,'2012-11-01 01:57:54',56232.08188,19.1562,0.0855,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_68238.gif',34735616008,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(3115,3114,0,'LSQ12fvq','LSQ',19.150625,-31.4520277777778,NULL,NULL,'2012-11-01 01:59:34',56232.0830399999,18.9566,0.0686,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2012-11-02 15:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_68240.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(3116,3114,0,'LSQ12fvq','LSQ',19.1508333333333,-31.4520277777778,NULL,NULL,'2012-11-01 03:59:48',56232.16653,19.1924,0.0801,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2012-11-02 15:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_68239.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(3117,3114,0,'LSQ12fvq','LSQ',19.1506666666667,-31.4520833333333,NULL,NULL,'2012-11-01 04:01:29',56232.1677000001,19.0474,0.0781,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2012-11-02 15:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_68241.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(3118,3118,1,'LSQ12fvp','LSQ',10.7100833333333,-34.1603333333333,NULL,NULL,'2012-10-26 01:44:41',56226.0726999999,16.7249,0.0294,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_68264.gif',34872963970,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(3119,3118,0,'LSQ12fvp','LSQ',10.710125,-34.1602777777778,NULL,NULL,'2012-10-26 03:46:58',56226.1576200002,17.3335,0.0303,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2012-11-02 15:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_68265.gif',34872963970,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(3120,3118,0,'LSQ12fvp','LSQ',10.7100416666667,-34.1603055555556,NULL,NULL,'2012-11-01 01:32:30',56232.0642400002,16.7106,0.0301,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2012-11-02 15:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_68236.gif',34872963971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(3121,3118,0,'LSQ12fvp','LSQ',10.710125,-34.1603055555556,NULL,NULL,'2012-11-01 03:34:17',56232.1488100002,17.632,0.0427,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2012-11-02 15:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_68237.gif',34872963970,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(3122,3122,1,'LSQ12fvn','LSQ',16.3919583333333,-35.4906944444444,NULL,NULL,'2012-10-26 04:08:26',56226.1725300001,19.6868,0.0841,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_68261.gif',38269278617,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(3123,3122,0,'LSQ12fvn','LSQ',16.3919583333333,-35.4907777777778,NULL,NULL,'2012-11-01 01:49:27',56232.07601,19.7181,0.075,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2012-11-02 15:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_68232.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(3124,3122,0,'LSQ12fvn','LSQ',16.3919583333333,-35.4908611111111,NULL,NULL,'2012-11-01 03:51:20',56232.16065,19.8436,0.0873,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2012-11-02 15:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_68233.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(3125,3125,0,'LSQ12fvl','LSQ',75.2085,-38.6531388888889,NULL,NULL,'2012-11-01 04:35:31',56232.1913399999,18.9434,0.1483,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2019-10-12 20:41:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_68228.gif',37599217320,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(3126,3125,0,'LSQ12fvl','LSQ',75.2085416666667,-38.65325,NULL,NULL,'2012-11-01 06:36:31',56232.2753699999,18.8704,0.1059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-02 15:45:31','2012-11-02 15:45:31','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_68229.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(3127,3049,0,'LSQ12fuk','LSQ',74.566125,-16.2994722222,NULL,NULL,'2012-11-02 12:00:00',56233.5,NULL,NULL,NULL,0.02,NULL,'Ia',NULL,'2012-11-02 21:11:37','2012-11-02 21:11:37','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37569693502,'UH 2.2m','SNIFS','SNfactory',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587026460,9172288,NULL,NULL,NULL,NULL),(3128,3058,0,'LSQ12fuc','LSQ',75.0465416667,-20.0073888889,NULL,NULL,'2012-11-02 12:00:00',56233.5,NULL,NULL,NULL,0.042,NULL,'II peculiar',NULL,'2012-11-02 21:13:33','2012-11-02 21:13:33','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37564014387,'UH 2.2m','SNIFS','SNfactory',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586937724,9170901,NULL,NULL,NULL,NULL),(3129,3033,0,'LSQ12fvf','LSQ',7.61754166666667,6.94569444444444,NULL,NULL,'2012-11-02 00:34:35',56233.0240199999,19.1864,0.0668,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvf/LSQ12fvf_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvf/LSQ12fvf_snap_68434.gif',66839103492,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044360992,16318140,NULL,NULL,NULL,NULL),(3130,3033,0,'LSQ12fvf','LSQ',7.61754166666667,6.94569444444444,NULL,NULL,'2012-11-02 02:36:08',56233.10843,19.0553,0.0939,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvf/LSQ12fvf_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvf/LSQ12fvf_snap_68435.gif',66839103492,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044360992,16318140,NULL,NULL,NULL,NULL),(3131,3042,0,'LSQ12fuu','LSQ',358.84525,-2.27711111111111,NULL,NULL,'2012-11-02 00:32:53',56233.0228400002,18.8064,0.0541,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuu/LSQ12fuu_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuu/LSQ12fuu_snap_68418.gif',49406600211,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,771978128,12062158,NULL,NULL,NULL,NULL),(3132,3042,0,'LSQ12fuu','LSQ',358.845333333333,-2.27713888888889,NULL,NULL,'2012-11-02 02:34:27',56233.10726,19.0962,0.0826,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuu/LSQ12fuu_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuu/LSQ12fuu_snap_68419.gif',49406600211,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,771978128,12062158,NULL,NULL,NULL,NULL),(3133,3044,0,'LSQ12ftn','LSQ',2.53929166666667,-19.1404444444444,NULL,NULL,'2012-11-02 01:31:28',56233.0635299999,18.7737,0.0594,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_snap_68279.gif',34442362275,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538161910,8408779,NULL,NULL,NULL,NULL),(3134,3044,0,'LSQ12ftn','LSQ',2.53929166666667,-19.1404166666667,NULL,NULL,'2012-11-02 03:33:17',56233.14812,18.7954,0.0722,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_snap_68280.gif',34442362275,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538161910,8408779,NULL,NULL,NULL,NULL),(3135,3047,0,'LSQ12fun','LSQ',355.184791666667,-0.351777777777778,NULL,NULL,'2012-11-02 00:20:43',56233.0143900001,18.8486,0.0535,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fun/LSQ12fun_history.html','sne or asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fun/LSQ12fun_snap_68444.gif',49397192770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,771831137,12059861,NULL,NULL,NULL,NULL),(3136,3047,0,'LSQ12fun','LSQ',355.184833333333,-0.351722222222222,NULL,NULL,'2012-11-02 02:22:20',56233.0988500002,18.7886,0.067,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fun/LSQ12fun_history.html','sne or asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fun/LSQ12fun_snap_68445.gif',49397192770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,771831137,12059861,NULL,NULL,NULL,NULL),(3137,3049,0,'LSQ12fuk','LSQ',74.566125,-16.2994444444444,NULL,NULL,'2012-11-02 04:56:36',56233.2059800001,15.3358,0.0068,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_history.html','sne - bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_snap_68328.gif',37569693502,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587026460,9172288,NULL,NULL,NULL,NULL),(3138,3049,0,'LSQ12fuk','LSQ',74.5661666666667,-16.2994166666667,NULL,NULL,'2012-11-02 07:57:35',56233.3316600001,15.3773,0.0055,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_history.html','sne - bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_snap_68329.gif',37569693502,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587026460,9172288,NULL,NULL,NULL,NULL),(3139,3051,0,'LSQ12fui','LSQ',70.9517083333333,-13.3014166666667,NULL,NULL,'2012-11-02 04:54:55',56233.20481,18.5048,0.0625,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_snap_68330.gif',37542571140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586602674,9165666,NULL,NULL,NULL,NULL),(3140,3051,0,'LSQ12fui','LSQ',70.95175,-13.3013888888889,NULL,NULL,'2012-11-02 06:52:47',56233.2866600002,18.4477,0.0618,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_snap_68331.gif',37542571140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586602674,9165666,NULL,NULL,NULL,NULL),(3141,3058,0,'LSQ12fuc','LSQ',75.0465,-20.00725,NULL,NULL,'2012-11-02 04:32:38',56233.18934,19.3387,0.1058,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_history.html','sne - good',NULL,0.041789,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_snap_68281.gif',37564014387,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586937724,9170901,NULL,NULL,NULL,NULL),(3142,3058,0,'LSQ12fuc','LSQ',75.0465,-20.0072777777778,NULL,NULL,'2012-11-02 06:32:10',56233.2723400001,19.135,0.094,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_history.html','sne - good',NULL,0.041789,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_snap_68282.gif',37564014387,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586937724,9170901,NULL,NULL,NULL,NULL),(3143,3060,0,'LSQ12ftz','LSQ',74.7339583333333,-20.3274166666667,NULL,NULL,'2012-11-02 04:30:57',56233.18817,18.9361,0.0755,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_snap_68437.gif',37561880973,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586904390,9170381,NULL,NULL,NULL,NULL),(3144,3060,0,'LSQ12ftz','LSQ',74.7340416666667,-20.3274444444444,NULL,NULL,'2012-11-02 06:30:29',56233.2711700001,18.3211,0.0832,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_snap_68438.gif',37561880973,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586904390,9170381,NULL,NULL,NULL,NULL),(3145,3064,0,'LSQ12ftr','LSQ',66.67225,-20.9704166666667,NULL,NULL,'2012-11-02 04:25:52',56233.1846400001,16.577,0.0178,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_history.html','sne or comet',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_snap_68340.gif',37323194914,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583174920,9112108,NULL,NULL,NULL,NULL),(3146,3064,0,'LSQ12ftr','LSQ',66.67225,-20.9703888888889,NULL,NULL,'2012-11-02 06:25:24',56233.2676499998,16.5853,0.0175,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_history.html','sne or comet',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_snap_68341.gif',37323194914,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583174920,9112108,NULL,NULL,NULL,NULL),(3147,3035,0,'LSQ12fuy','LSQ',19.3754583333333,0.593638888888889,NULL,NULL,'2012-11-02 01:52:19',56233.0780000002,19.6579,0.1103,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuy/LSQ12fuy_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuy/LSQ12fuy_snap_68433.gif',66652936653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041452135,16272689,NULL,NULL,NULL,NULL),(3148,3069,0,'LSQ12fus','LSQ',15.9787916666667,-5.9385,NULL,NULL,'2012-11-02 01:50:36',56233.07681,19.555,0.1036,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_snap_68290.gif',34532215196,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539565862,8430716,NULL,NULL,NULL,NULL),(3149,3069,0,'LSQ12fus','LSQ',15.978625,-5.93861111111111,NULL,NULL,'2012-11-02 03:52:22',56233.1613699999,19.6793,0.1211,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 19:45:32','2012-11-03 19:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_snap_68291.gif',34532215196,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539565862,8430716,NULL,NULL,NULL,NULL),(3150,3150,1,'LSQ12fvz','LSQ',60.5280416666667,-20.3228611111111,NULL,NULL,'2012-10-31 04:51:27',56231.2023999998,19.1374,0.1455,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 22:45:33','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvz/LSQ12fvz_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvz/LSQ12fvz_snap_68484.gif',36853079254,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575829363,8997333,NULL,NULL,NULL,NULL),(3151,3150,0,'LSQ12fvz','LSQ',60.5280833333333,-20.3229444444444,NULL,NULL,'2012-11-02 04:19:07',56233.1799499998,19.6124,0.1191,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 22:45:33','2012-11-03 22:45:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvz/LSQ12fvz_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvz/LSQ12fvz_snap_68482.gif',36853079254,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575829363,8997333,NULL,NULL,NULL,NULL),(3152,3150,0,'LSQ12fvz','LSQ',60.5279583333333,-20.3228055555556,NULL,NULL,'2012-11-02 06:18:39',56233.26296,18.8531,0.1283,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-03 22:45:33','2012-11-03 22:45:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvz/LSQ12fvz_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvz/LSQ12fvz_snap_68483.gif',36853079254,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575829363,8997333,NULL,NULL,NULL,NULL),(3153,3153,1,'LSQ12fwb','LSQ',6.35504166666667,6.70713888888889,NULL,NULL,'2012-10-31 01:12:39',56231.0504600001,16.6943,0.0245,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 01:45:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwb/LSQ12fwb_history.html','sne - nice',NULL,0.029834,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwb/LSQ12fwb_snap_68530.gif',66827155915,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044174311,16315223,NULL,NULL,NULL,NULL),(3154,3153,0,'LSQ12fwb','LSQ',6.35508333333333,6.70719444444444,NULL,NULL,'2012-11-02 00:34:35',56233.0240199999,18.4601,0.0414,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 01:45:32','2012-11-04 01:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwb/LSQ12fwb_history.html','sne - nice',NULL,0.029834,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwb/LSQ12fwb_snap_68489.gif',66827155915,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044174311,16315223,NULL,NULL,NULL,NULL),(3155,3153,0,'LSQ12fwb','LSQ',6.355125,6.70719444444444,NULL,NULL,'2012-11-02 02:36:08',56233.10843,18.471,0.0559,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 01:45:32','2012-11-04 01:45:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwb/LSQ12fwb_history.html','sne - nice',NULL,0.029834,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwb/LSQ12fwb_snap_68490.gif',66827155915,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044174311,16315223,NULL,NULL,NULL,NULL),(3156,2815,0,'LSQ12fom','LSQ',347.119291666667,-21.6681666666667,NULL,NULL,'2012-11-03 00:20:41',56234.01437,19.4266,0.1494,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fom/LSQ12fom_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fom/LSQ12fom_snap_68630.gif',50300598676,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785946854,12280419,NULL,NULL,NULL,NULL),(3157,2815,0,'LSQ12fom','LSQ',347.119333333333,-21.6681111111111,NULL,NULL,'2012-11-03 02:23:02',56234.0993300001,19.3895,0.1213,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fom/LSQ12fom_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fom/LSQ12fom_snap_68631.gif',50300598676,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785946854,12280419,NULL,NULL,NULL,NULL),(3158,2974,0,'LSQ12frx','LSQ',12.9882083333333,-23.7101944444444,NULL,NULL,'2012-11-03 01:40:17',56234.06965,18.91,0.0415,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_snap_68620.gif',35316090512,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(3159,2974,0,'LSQ12frx','LSQ',12.9881666666667,-23.7101944444444,NULL,NULL,'2012-11-03 03:42:07',56234.1542500001,19.077,0.0712,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_snap_68621.gif',35316090512,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(3160,3160,1,'LSQ12frr','LSQ',351.37875,-30.1274166666667,NULL,NULL,'2012-10-25 01:40:56',56225.0701000001,17.4883,0.0477,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_history.html','sne hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_snap_67608.gif',50188188166,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,784190440,12252975,NULL,NULL,NULL,NULL),(3161,3160,0,'LSQ12frr','LSQ',351.378708333333,-30.1273888888889,NULL,NULL,'2012-10-25 03:41:29',56225.15381,17.4632,0.0381,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_history.html','sne hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_snap_67609.gif',50188188166,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,784190440,12252975,NULL,NULL,NULL,NULL),(3162,3160,0,'LSQ12frr','LSQ',351.378708333333,-30.1273611111111,NULL,NULL,'2012-10-26 00:38:56',56226.0270400001,17.562,0.0371,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_history.html','sne hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_snap_67760.gif',50188188166,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,784190440,12252975,NULL,NULL,NULL,NULL),(3163,3160,0,'LSQ12frr','LSQ',351.378708333333,-30.1273611111111,NULL,NULL,'2012-10-26 02:38:45',56226.1102499999,17.4758,0.0341,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_history.html','sne hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_snap_67761.gif',50188188166,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,784190440,12252975,NULL,NULL,NULL,NULL),(3164,3160,0,'LSQ12frr','LSQ',351.37875,-30.1273888888889,NULL,NULL,'2012-11-01 00:26:51',56232.01865,17.9274,0.0285,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_history.html','sne hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_snap_68162.gif',50188188166,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,784190440,12252975,NULL,NULL,NULL,NULL),(3165,3160,0,'LSQ12frr','LSQ',351.378708333333,-30.1273888888889,NULL,NULL,'2012-11-01 02:28:47',56232.1033299998,17.8609,0.0401,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_history.html','sne hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_snap_68163.gif',50188188166,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,784190440,12252975,NULL,NULL,NULL,NULL),(3166,3160,0,'LSQ12frr','LSQ',351.378666666667,-30.1273611111111,NULL,NULL,'2012-11-03 00:27:25',56234.0190499998,18.0574,0.0343,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_history.html','sne hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_snap_68626.gif',50188188166,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,784190440,12252975,NULL,NULL,NULL,NULL),(3167,3160,0,'LSQ12frr','LSQ',351.378708333333,-30.1273611111111,NULL,NULL,'2012-11-03 02:29:47',56234.10402,18.0791,0.0343,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_history.html','sne hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_snap_68627.gif',50188188166,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,784190440,12252975,NULL,NULL,NULL,NULL),(3168,2985,0,'LSQ12fsh','LSQ',12.7767916666667,-39.16,NULL,NULL,'2012-11-03 01:48:44',56234.07552,18.1859,0.0346,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_68713.gif',38166915082,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(3169,2985,0,'LSQ12fsh','LSQ',12.7769166666667,-39.16,NULL,NULL,'2012-11-03 03:50:38',56234.16017,18.0901,0.0315,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_68714.gif',38166915082,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(3170,2987,0,'LSQ12fsj','LSQ',73.72925,-36.325,NULL,NULL,'2012-11-03 04:36:33',56234.1920599998,16.5759,0.0077,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_68710.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(3171,2987,0,'LSQ12fsj','LSQ',73.72925,-36.3250277777778,NULL,NULL,'2012-11-03 06:37:12',56234.2758399998,16.5402,0.0076,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_68711.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(3172,2991,0,'LSQ12fsi','LSQ',1.50475,-35.1925555555556,NULL,NULL,'2012-11-03 00:52:54',56234.0367399999,19.1674,0.0682,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_history.html','Old',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_snap_68719.gif',34665129379,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,541642646,8463166,NULL,NULL,NULL,NULL),(3173,2991,0,'LSQ12fsi','LSQ',1.50470833333333,-35.1925555555556,NULL,NULL,'2012-11-03 02:55:12',56234.1216699998,20.0203,0.1587,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_history.html','Old',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_snap_68720.gif',34665129379,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,541642646,8463166,NULL,NULL,NULL,NULL),(3174,2993,0,'LSQ12fss','LSQ',18.7158333333333,-30.0939722222222,NULL,NULL,'2012-11-03 02:00:36',56234.0837599998,19.0521,0.0424,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_68704.gif',34734808837,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(3175,2993,0,'LSQ12fss','LSQ',18.715875,-30.0939722222222,NULL,NULL,'2012-11-03 04:02:33',56234.1684400002,18.7527,0.0452,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_68705.gif',34734808839,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(3176,2995,0,'LSQ12fsp','LSQ',357.212041666667,-38.5519444444444,NULL,NULL,'2012-11-03 00:46:08',56234.03204,15.9042,0.0059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_history.html','Bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_snap_68699.gif',49991723132,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781120673,12205010,NULL,NULL,NULL,NULL),(3177,2995,0,'LSQ12fsp','LSQ',357.212,-38.5519444444444,NULL,NULL,'2012-11-03 02:48:25',56234.1169599998,15.9169,0.0067,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_history.html','Bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_snap_68700.gif',49991723132,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781120673,12205010,NULL,NULL,NULL,NULL),(3178,2999,0,'LSQ12fsn','LSQ',10.6064166666667,-34.09725,NULL,NULL,'2012-11-03 01:33:23',56234.0648599998,15.5938,0.009,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_history.html','Unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_snap_68703.gif',34872861140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544888455,8513882,NULL,NULL,NULL,NULL),(3179,3001,0,'LSQ12fth','LSQ',47.8226666666667,-25.1096111111111,NULL,NULL,'2012-11-03 05:39:29',56234.2357600001,17.7676,0.0356,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_68670.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3180,3001,0,'LSQ12fth','LSQ',47.8225416666667,-25.1097222222222,NULL,NULL,'2012-11-03 05:41:10',56234.2369300001,18.0751,0.0385,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_68672.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3181,3001,0,'LSQ12fth','LSQ',47.822625,-25.1097222222222,NULL,NULL,'2012-11-03 07:15:24',56234.3023700002,18.293,0.0493,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_68673.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3182,3001,0,'LSQ12fth','LSQ',47.82275,-25.1096111111111,NULL,NULL,'2012-11-03 07:40:49',56234.32002,17.841,0.0959,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_68671.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3183,3005,0,'LSQ12ftg','LSQ',44.948125,-23.7169722222222,NULL,NULL,'2012-11-03 05:37:47',56234.2345799999,18.6424,0.0976,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftg/LSQ12ftg_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftg/LSQ12ftg_snap_68701.gif',38051514190,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594554909,9289920,NULL,NULL,NULL,NULL),(3184,3007,0,'LSQ12fte','LSQ',52.15275,-24.8717777777778,NULL,NULL,'2012-11-03 05:42:54',56234.23813,19.6251,0.1281,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_snap_68702.gif',38021943870,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594092872,9282701,NULL,NULL,NULL,NULL),(3185,3009,0,'LSQ12ftd','LSQ',64.2447083333333,-24.14475,NULL,NULL,'2012-11-03 05:53:47',56234.2456899998,19.0375,0.1082,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_68666.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3186,3009,0,'LSQ12ftd','LSQ',64.2445416666667,-24.1446944444444,NULL,NULL,'2012-11-03 05:55:28',56234.2468599998,19.812,0.134,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_68668.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3187,3009,0,'LSQ12ftd','LSQ',64.2445833333333,-24.14475,NULL,NULL,'2012-11-03 07:22:10',56234.3070700001,19.0828,0.1358,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_68667.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3188,3009,0,'LSQ12ftd','LSQ',64.2445416666667,-24.1447777777778,NULL,NULL,'2012-11-03 07:23:51',56234.3082400002,19.6632,0.1255,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_68669.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3189,3013,0,'LSQ12ftc','LSQ',64.8030833333333,-24.3552777777778,NULL,NULL,'2012-11-03 05:53:47',56234.2456899998,18.9056,0.0829,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_68674.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3190,3013,0,'LSQ12ftc','LSQ',64.8028333333333,-24.3551666666667,NULL,NULL,'2012-11-03 05:55:28',56234.2468599998,18.9657,0.0921,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_68676.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3191,3013,0,'LSQ12ftc','LSQ',64.8030833333333,-24.35525,NULL,NULL,'2012-11-03 07:22:10',56234.3070700001,19.0283,0.0909,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_68675.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3192,3013,0,'LSQ12ftc','LSQ',64.802875,-24.3551666666667,NULL,NULL,'2012-11-03 07:23:51',56234.3082400002,18.8315,0.0801,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_68677.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3193,3017,0,'LSQ12ftb','LSQ',65.4214583333333,-23.7053611111111,NULL,NULL,'2012-11-03 05:53:47',56234.2456899998,18.0592,0.0612,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_68715.gif',37314276031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3194,3017,0,'LSQ12ftb','LSQ',65.422,-23.7052222222222,NULL,NULL,'2012-11-03 05:55:28',56234.2468599998,18.4486,0.0691,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_68717.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3195,3017,0,'LSQ12ftb','LSQ',65.4215,-23.7053611111111,NULL,NULL,'2012-11-03 07:22:10',56234.3070700001,18.0654,0.0623,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_68716.gif',37314276031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3196,3017,0,'LSQ12ftb','LSQ',65.422,-23.70525,NULL,NULL,'2012-11-03 07:23:51',56234.3082400002,18.414,0.0635,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_68718.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3197,3021,0,'LSQ12fta','LSQ',353.33875,-33.0116111111111,NULL,NULL,'2012-11-03 02:28:06',56234.1028499999,17.3005,0.0199,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fta/LSQ12fta_history.html','AGN?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fta/LSQ12fta_snap_68678.gif',50174717533,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,783979961,12249686,NULL,NULL,NULL,NULL),(3198,3106,0,'LSQ12fsw','LSQ',74.166375,-30.1313333333333,NULL,NULL,'2012-11-03 05:28:59',56234.22847,18.0226,0.1401,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_snap_68724.gif',37203066251,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,581297910,9082779,NULL,NULL,NULL,NULL),(3199,3106,0,'LSQ12fsw','LSQ',74.1664166666667,-30.13125,NULL,NULL,'2012-11-03 07:10:09',56234.2987199998,18.4348,0.1017,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_snap_68725.gif',37203066251,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,581297910,9082779,NULL,NULL,NULL,NULL),(3200,3110,0,'LSQ12fvw','LSQ',43.0017083333333,-25.5420277777778,NULL,NULL,'2012-11-03 05:36:06',56234.2334099999,19.0799,0.0904,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvw/LSQ12fvw_history.html','sn - nice',NULL,0.1101,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvw/LSQ12fvw_snap_68581.gif',38420117951,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600314342,9379911,NULL,NULL,NULL,NULL),(3201,3110,0,'LSQ12fvw','LSQ',43.0017916666667,-25.5421388888889,NULL,NULL,'2012-11-03 07:42:30',56234.32119,18.6911,0.1315,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvw/LSQ12fvw_history.html','sn - nice',NULL,0.1101,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvw/LSQ12fvw_snap_68582.gif',38420117951,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600314342,9379911,NULL,NULL,NULL,NULL),(3202,3112,0,'LSQ12fvu','LSQ',53.5190833333333,-21.8745,NULL,NULL,'2012-11-03 05:44:34',56234.2392899999,19.2631,0.0879,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_68583.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(3203,3112,0,'LSQ12fvu','LSQ',53.5189583333333,-21.8744444444444,NULL,NULL,'2012-11-03 07:17:06',56234.3035499998,19.0094,0.08,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_68584.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(3204,3114,0,'LSQ12fvq','LSQ',19.1507916666667,-31.4520833333333,NULL,NULL,'2012-11-03 01:58:55',56234.0825899998,18.8538,0.0308,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_68599.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(3205,3114,0,'LSQ12fvq','LSQ',19.1506666666667,-31.4520833333333,NULL,NULL,'2012-11-03 02:00:36',56234.0837599998,18.9193,0.0361,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_68597.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(3206,3114,0,'LSQ12fvq','LSQ',19.1507916666667,-31.4520833333333,NULL,NULL,'2012-11-03 04:00:52',56234.1672700001,18.8627,0.0511,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_68600.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(3207,3114,0,'LSQ12fvq','LSQ',19.1506666666667,-31.4520833333333,NULL,NULL,'2012-11-03 04:02:33',56234.1684400002,18.9319,0.0448,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_68598.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(3208,3118,0,'LSQ12fvp','LSQ',10.710125,-34.1603333333333,NULL,NULL,'2012-11-03 01:33:23',56234.0648599998,17.5774,0.0422,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_68594.gif',34872963970,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(3209,3118,0,'LSQ12fvp','LSQ',10.7101666666667,-34.1603333333333,NULL,NULL,'2012-11-03 03:35:21',56234.1495500002,16.983,0.0314,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_68595.gif',34872963970,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(3210,3122,0,'LSQ12fvn','LSQ',16.3919166666667,-35.49075,NULL,NULL,'2012-11-03 01:50:26',56234.07669,19.9221,0.0537,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_68608.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(3211,3122,0,'LSQ12fvn','LSQ',16.392,-35.4907777777778,NULL,NULL,'2012-11-03 03:52:19',56234.1613400001,19.7648,0.0657,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_68609.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(3212,3125,0,'LSQ12fvl','LSQ',75.2085833333333,-38.6531666666667,NULL,NULL,'2012-11-03 04:36:33',56234.1920599998,18.38,0.0689,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_68601.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(3213,3125,0,'LSQ12fvl','LSQ',75.2085,-38.6531666666667,NULL,NULL,'2012-11-03 06:37:12',56234.2758399998,18.2598,0.0649,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_68602.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(3214,3214,1,'LSQ12fvs','LSQ',358.452041666667,-32.0598333333333,NULL,NULL,'2012-10-25 01:59:43',56225.0831399998,18.1211,0.0843,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_history.html','sne?',NULL,0.0606,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_snap_68266.gif',50033234904,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781769295,12215145,NULL,NULL,NULL,NULL),(3215,3214,0,'LSQ12fvs','LSQ',358.452208333333,-32.05975,NULL,NULL,'2012-10-25 04:00:13',56225.1668199999,18.4549,0.1038,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_history.html','sne?',NULL,0.0606,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_snap_68267.gif',50033234904,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781769295,12215145,NULL,NULL,NULL,NULL),(3216,3214,0,'LSQ12fvs','LSQ',358.452166666667,-32.06,NULL,NULL,'2012-10-26 00:52:24',56226.0364000001,18.5064,0.1025,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_history.html','sne?',NULL,0.0606,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_snap_68268.gif',50033234904,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781769295,12215145,NULL,NULL,NULL,NULL),(3217,3214,0,'LSQ12fvs','LSQ',358.452166666667,-32.06,NULL,NULL,'2012-10-26 02:52:18',56226.1196599999,18.1906,0.0768,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_history.html','sne?',NULL,0.0606,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_snap_68269.gif',50033234904,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781769295,12215145,NULL,NULL,NULL,NULL),(3218,3214,0,'LSQ12fvs','LSQ',358.452166666667,-32.0599722222222,NULL,NULL,'2012-11-01 00:44:00',56232.0305599999,18.5502,0.0907,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_history.html','sne?',NULL,0.0606,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_snap_68244.gif',50033234904,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781769295,12215145,NULL,NULL,NULL,NULL),(3219,3214,0,'LSQ12fvs','LSQ',358.452125,-32.0599444444444,NULL,NULL,'2012-11-01 02:45:44',56232.1151000001,17.911,0.06,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_history.html','sne?',NULL,0.0606,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_snap_68245.gif',50033234904,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781769295,12215145,NULL,NULL,NULL,NULL),(3220,3214,0,'LSQ12fvs','LSQ',358.452166666667,-32.06,NULL,NULL,'2012-11-03 00:44:26',56234.0308599998,18.6281,0.0928,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_history.html','sne?',NULL,0.0606,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_snap_68606.gif',50033234904,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781769295,12215145,NULL,NULL,NULL,NULL),(3221,3214,0,'LSQ12fvs','LSQ',358.452166666667,-32.0599444444444,NULL,NULL,'2012-11-03 02:46:44',56234.1157900002,18.1796,0.0624,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_history.html','sne?',NULL,0.0606,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_snap_68607.gif',50033234904,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781769295,12215145,NULL,NULL,NULL,NULL),(3222,3222,1,'LSQ12fvm','LSQ',47.950625,-38.8036111111111,NULL,NULL,'2012-10-25 05:06:08',56225.2126000002,19.1349,0.1408,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_68258.gif',38600095449,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126491,9423851,NULL,NULL,NULL,NULL),(3223,3222,0,'LSQ12fvm','LSQ',47.9507916666667,-38.8036111111111,NULL,NULL,'2012-10-26 04:24:03',56226.1833700002,19.3304,0.1074,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_68259.gif',38600095449,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126491,9423851,NULL,NULL,NULL,NULL),(3224,3222,0,'LSQ12fvm','LSQ',47.950875,-38.8035555555556,NULL,NULL,'2012-10-26 06:24:23',56226.26694,19.2873,0.1283,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_68260.gif',38600095382,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126490,9423851,NULL,NULL,NULL,NULL),(3225,3222,0,'LSQ12fvm','LSQ',47.9509166666667,-38.8036388888889,NULL,NULL,'2012-11-01 04:16:57',56232.1784399999,19.3618,0.1436,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_68230.gif',38600095382,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126490,9423851,NULL,NULL,NULL,NULL),(3226,3222,0,'LSQ12fvm','LSQ',47.9509583333333,-38.8036666666667,NULL,NULL,'2012-11-01 06:17:54',56232.2624400002,18.9928,0.1505,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_68231.gif',38600095382,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126490,9423851,NULL,NULL,NULL,NULL),(3227,3222,0,'LSQ12fvm','LSQ',47.951,-38.8036388888889,NULL,NULL,'2012-11-03 04:17:55',56234.1791099999,19.1945,0.1348,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_68585.gif',38600095382,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126490,9423851,NULL,NULL,NULL,NULL),(3228,3222,0,'LSQ12fvm','LSQ',47.9507916666667,-38.8036666666667,NULL,NULL,'2012-11-03 06:18:36',56234.2629200001,18.8697,0.1015,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_68586.gif',38600095449,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126491,9423851,NULL,NULL,NULL,NULL),(3229,3229,1,'LSQ12fvk','LSQ',0.974458333333333,-36.1124444444444,NULL,NULL,'2012-10-26 01:20:40',56226.0560300001,18.5245,0.1427,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_history.html','sne?',NULL,0.07307,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_snap_68257.gif',34677267107,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541832298,8466129,NULL,NULL,NULL,NULL),(3230,3229,0,'LSQ12fvk','LSQ',0.974625,-36.1123888888889,NULL,NULL,'2012-11-01 00:54:08',56232.0375999999,18.9828,0.1289,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_history.html','sne?',NULL,0.07307,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_snap_68226.gif',34677267107,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541832298,8466129,NULL,NULL,NULL,NULL),(3231,3229,0,'LSQ12fvk','LSQ',0.9745,-36.1123333333333,NULL,NULL,'2012-11-01 02:55:52',56232.1221400001,18.9786,0.1578,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_history.html','sne?',NULL,0.07307,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_snap_68227.gif',34677267107,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541832298,8466129,NULL,NULL,NULL,NULL),(3232,3229,0,'LSQ12fvk','LSQ',0.974708333333333,-36.1125,NULL,NULL,'2012-11-03 00:54:36',56234.03792,20.6134,0.1632,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_history.html','sne?',NULL,0.07307,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_snap_68587.gif',34677267107,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541832298,8466129,NULL,NULL,NULL,NULL),(3233,3229,0,'LSQ12fvk','LSQ',0.974541666666667,-36.1123055555556,NULL,NULL,'2012-11-03 02:56:54',56234.1228499999,19.9568,0.1954,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 02:45:37','2012-11-04 02:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_history.html','sne?',NULL,0.07307,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_snap_68588.gif',34677267107,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541832298,8466129,NULL,NULL,NULL,NULL),(3234,3234,1,'LSQ12fwu','LSQ',357.674583333333,-37.2143333333333,NULL,NULL,'2012-11-01 00:47:23',56232.0329100001,19.8395,0.1298,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 03:45:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_snap_68559.gif',49956994282,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,780578035,12196531,NULL,NULL,NULL,NULL),(3235,3234,0,'LSQ12fwu','LSQ',357.674541666667,-37.2143333333333,NULL,NULL,'2012-11-03 00:47:49',56234.03321,20.0698,0.144,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 03:45:36','2012-11-04 03:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_snap_68553.gif',49956994282,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,780578035,12196531,NULL,NULL,NULL,NULL),(3236,3234,0,'LSQ12fwu','LSQ',357.674583333333,-37.2143333333333,NULL,NULL,'2012-11-03 02:50:06',56234.1181299998,19.6311,0.1569,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 03:45:36','2012-11-04 03:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_snap_68554.gif',49956994282,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,780578035,12196531,NULL,NULL,NULL,NULL),(3237,3237,1,'LSQ12fwt','LSQ',54.0467916666667,-37.4259166666667,NULL,NULL,'2012-10-17 06:14:00',56217.25973,20.3644,0.2117,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 03:45:36','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_68557.gif',38589273853,NULL,NULL,NULL,'2012-10-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(3238,3237,0,'LSQ12fwt','LSQ',54.0464583333333,-37.4259444444444,NULL,NULL,'2012-10-17 07:41:18',56217.3203500002,20.5834,0.1532,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 03:45:36','2012-11-04 03:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_68558.gif',38589273853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(3239,3237,0,'LSQ12fwt','LSQ',54.0465,-37.426,NULL,NULL,'2012-11-03 04:23:04',56234.1826900002,19.1907,0.1086,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 03:45:36','2012-11-04 03:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_68551.gif',38589273853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(3240,3237,0,'LSQ12fwt','LSQ',54.0464166666667,-37.4260277777778,NULL,NULL,'2012-11-03 06:23:40',56234.2664399999,19.4068,0.0964,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 03:45:36','2012-11-04 03:45:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_68552.gif',38589273853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(3245,3245,1,'LSQ12fwz','LSQ',21.2805416666667,-26.1291666666667,NULL,NULL,'2012-11-03 02:10:48',56234.0908400002,18.9364,0.0637,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 04:45:37','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_68741.gif',34700926908,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(3246,3245,0,'LSQ12fwz','LSQ',21.2805416666667,-26.1291666666667,NULL,NULL,'2012-11-03 04:12:44',56234.17551,19.0407,0.0923,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 04:45:37','2012-11-04 04:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_68742.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(3247,3247,1,'LSQ12fwy','LSQ',20.6035833333333,-28.1006944444444,NULL,NULL,'2012-11-03 01:57:14',56234.0814200002,19.9557,0.0588,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 04:45:37','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwy/LSQ12fwy_history.html','sne - nice',NULL,0.081453,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwy/LSQ12fwy_snap_68739.gif',34751625109,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542994142,8484283,NULL,NULL,NULL,NULL),(3248,3247,0,'LSQ12fwy','LSQ',20.6035833333333,-28.1008611111111,NULL,NULL,'2012-11-03 03:59:10',56234.16609,19.8598,0.0825,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 04:45:37','2012-11-04 04:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwy/LSQ12fwy_history.html','sne - nice',NULL,0.081453,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwy/LSQ12fwy_snap_68740.gif',34751625138,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542994142,8484283,NULL,NULL,NULL,NULL),(3249,3249,1,'LSQ12fww','LSQ',62.5345,-34.1650277777778,NULL,NULL,'2012-10-25 05:47:30',56225.2413300001,18.8644,0.0834,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 04:45:37','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_68759.gif',37708009531,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(3250,3249,0,'LSQ12fww','LSQ',62.534625,-34.1648333333333,NULL,NULL,'2012-10-26 04:59:57',56226.2083000001,18.8096,0.0622,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 04:45:37','2012-11-04 04:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_68760.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(3251,3249,0,'LSQ12fww','LSQ',62.5345833333333,-34.1648888888889,NULL,NULL,'2012-11-03 04:53:51',56234.20407,18.8451,0.0596,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 04:45:37','2012-11-04 04:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_68735.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(3252,3249,0,'LSQ12fww','LSQ',62.5344583333333,-34.1650833333333,NULL,NULL,'2012-11-03 08:06:01',56234.3375200001,18.6825,0.0566,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 04:45:37','2012-11-04 04:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_68736.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(3253,3253,1,'LSQ12fxj','LSQ',75.1702916666667,-25.9277222222222,NULL,NULL,'2012-10-26 05:48:19',56226.2418900002,17.7292,0.0513,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 15:45:37','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_snap_68794.gif',37225960888,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581655638,9088369,NULL,NULL,NULL,NULL),(3254,3253,0,'LSQ12fxj','LSQ',75.170375,-25.9277222222222,NULL,NULL,'2012-10-26 07:22:48',56226.3075100002,17.8166,0.0396,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 15:45:37','2012-11-04 15:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_snap_68795.gif',37225960891,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581655638,9088369,NULL,NULL,NULL,NULL),(3255,3253,0,'LSQ12fxj','LSQ',75.1702916666667,-25.9278333333333,NULL,NULL,'2012-11-01 05:28:48',56232.2283399999,18.4804,0.0852,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 15:45:37','2012-11-04 15:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_snap_68796.gif',37225960888,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581655638,9088369,NULL,NULL,NULL,NULL),(3256,3253,0,'LSQ12fxj','LSQ',75.1703333333333,-25.9278055555556,NULL,NULL,'2012-11-01 07:45:35',56232.32333,18.3581,0.0627,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 15:45:37','2012-11-04 15:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_snap_68797.gif',37225960888,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581655638,9088369,NULL,NULL,NULL,NULL),(3257,3253,0,'LSQ12fxj','LSQ',75.1703333333333,-25.9278055555556,NULL,NULL,'2012-11-03 05:30:40',56234.22963,18.3435,0.0725,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 15:45:37','2012-11-04 15:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_snap_68780.gif',37225960888,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581655638,9088369,NULL,NULL,NULL,NULL),(3258,3253,0,'LSQ12fxj','LSQ',75.1702916666667,-25.9278055555556,NULL,NULL,'2012-11-03 07:11:49',56234.2998799998,18.3211,0.0654,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 15:45:37','2012-11-04 15:45:37','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_snap_68781.gif',37225960888,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581655638,9088369,NULL,NULL,NULL,NULL),(3259,3259,1,'LSQ12fwn','LSQ',13.285625,-3.97372222222222,NULL,NULL,'2012-10-31 04:15:11',56231.17722,19.5591,0.1494,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwn/LSQ12fwn_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwn/LSQ12fwn_snap_68544.gif',34546872308,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,539794879,8434294,NULL,NULL,NULL,NULL),(3260,3259,0,'LSQ12fwn','LSQ',13.2857916666667,-3.97386111111111,NULL,NULL,'2012-11-02 01:36:38',56233.0671100002,20.3379,0.1006,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwn/LSQ12fwn_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwn/LSQ12fwn_snap_68513.gif',34546872311,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,539794879,8434294,NULL,NULL,NULL,NULL),(3261,3259,0,'LSQ12fwn','LSQ',13.2858333333333,-3.97380555555556,NULL,NULL,'2012-11-02 03:38:31',56233.1517500002,20.3931,0.1136,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwn/LSQ12fwn_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwn/LSQ12fwn_snap_68514.gif',34546872311,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,539794879,8434294,NULL,NULL,NULL,NULL),(3262,3262,1,'LSQ12fwm','LSQ',7.706875,-7.05705555555556,NULL,NULL,'2012-10-31 01:57:07',56231.08134,19.5565,0.1128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwm/LSQ12fwm_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwm/LSQ12fwm_snap_68542.gif',34625393869,NULL,NULL,NULL,'2012-09-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,541021779,8453465,NULL,NULL,NULL,NULL),(3263,3262,0,'LSQ12fwm','LSQ',7.70670833333333,-7.05697222222222,NULL,NULL,'2012-10-31 03:59:26',56231.16628,19.7323,0.1694,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwm/LSQ12fwm_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwm/LSQ12fwm_snap_68543.gif',34625393869,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,541021779,8453465,NULL,NULL,NULL,NULL),(3264,3262,0,'LSQ12fwm','LSQ',7.706875,-7.05697222222222,NULL,NULL,'2012-11-02 01:14:23',56233.0516599999,19.8357,0.074,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwm/LSQ12fwm_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwm/LSQ12fwm_snap_68511.gif',34625393869,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,541021779,8453465,NULL,NULL,NULL,NULL),(3265,3262,0,'LSQ12fwm','LSQ',7.706875,-7.05702777777778,NULL,NULL,'2012-11-02 03:15:59',56233.1360999998,19.9209,0.0954,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwm/LSQ12fwm_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwm/LSQ12fwm_snap_68512.gif',34625393869,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,541021779,8453465,NULL,NULL,NULL,NULL),(3266,3266,1,'LSQ12fwl','LSQ',4.12708333333333,-2.86275,NULL,NULL,'2012-10-31 01:44:55',56231.0728699998,18.281,0.0773,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwl/LSQ12fwl_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwl/LSQ12fwl_snap_68540.gif',34423192334,NULL,NULL,NULL,'2012-09-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537862380,8404099,NULL,NULL,NULL,NULL),(3267,3266,0,'LSQ12fwl','LSQ',4.12708333333333,-2.86280555555556,NULL,NULL,'2012-10-31 03:47:14',56231.1578099998,18.2343,0.0845,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwl/LSQ12fwl_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwl/LSQ12fwl_snap_68541.gif',34423192334,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537862380,8404099,NULL,NULL,NULL,NULL),(3268,3266,0,'LSQ12fwl','LSQ',4.127,-2.86275,NULL,NULL,'2012-11-02 01:02:08',56233.0431499998,18.4359,0.0463,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwl/LSQ12fwl_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwl/LSQ12fwl_snap_68509.gif',34423192334,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537862380,8404099,NULL,NULL,NULL,NULL),(3269,3266,0,'LSQ12fwl','LSQ',4.127,-2.86280555555556,NULL,NULL,'2012-11-02 03:03:42',56233.1275800001,18.325,0.0597,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwl/LSQ12fwl_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwl/LSQ12fwl_snap_68510.gif',34423192334,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537862380,8404099,NULL,NULL,NULL,NULL),(3270,3270,1,'LSQ12fwi','LSQ',65.3630416666667,-13.9311666666667,NULL,NULL,'2012-10-31 07:09:31',56231.2982800002,18.9256,0.1335,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwi/LSQ12fwi_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwi/LSQ12fwi_snap_68535.gif',37347678296,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583557473,9118085,NULL,NULL,NULL,NULL),(3271,3270,0,'LSQ12fwi','LSQ',65.3633333333333,-13.93125,NULL,NULL,'2012-11-02 04:51:34',56233.20248,19.0809,0.1564,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwi/LSQ12fwi_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwi/LSQ12fwi_snap_68503.gif',37347679140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583557486,9118085,NULL,NULL,NULL,NULL),(3272,3270,0,'LSQ12fwi','LSQ',65.3633333333333,-13.9310833333333,NULL,NULL,'2012-11-02 06:51:06',56233.2854900002,18.9994,0.1466,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwi/LSQ12fwi_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwi/LSQ12fwi_snap_68504.gif',37347679140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583557486,9118085,NULL,NULL,NULL,NULL),(3273,3273,1,'LSQ12fwf','LSQ',20.227125,-0.525611111111111,NULL,NULL,'2012-10-27 01:17:13',56227.05363,18.0427,0.1063,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_history.html','sne?',NULL,0.09287,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_snap_68531.gif',34496037887,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539000591,8421884,NULL,NULL,NULL,NULL),(3274,3273,0,'LSQ12fwf','LSQ',20.2270833333333,-0.525583333333333,NULL,NULL,'2012-10-31 02:28:43',56231.1032799999,17.992,0.1605,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_history.html','sne?',NULL,0.09287,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_snap_68532.gif',34496037887,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539000591,8421884,NULL,NULL,NULL,NULL),(3275,3273,0,'LSQ12fwf','LSQ',20.2270416666667,-0.525611111111111,NULL,NULL,'2012-10-31 04:30:49',56231.1880700001,18.7008,0.1482,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_history.html','sne?',NULL,0.09287,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_snap_68533.gif',34496037887,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539000591,8421884,NULL,NULL,NULL,NULL),(3276,3273,0,'LSQ12fwf','LSQ',20.2270833333333,-0.525722222222222,NULL,NULL,'2012-11-02 01:52:19',56233.0780000002,19.5217,0.1586,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_history.html','sne?',NULL,0.09287,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_snap_68497.gif',34496037887,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539000591,8421884,NULL,NULL,NULL,NULL),(3277,3273,0,'LSQ12fwf','LSQ',20.2272083333333,-0.52575,NULL,NULL,'2012-11-02 03:54:02',56233.1625299999,18.9157,0.1291,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_history.html','sne?',NULL,0.09287,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_snap_68498.gif',34496037884,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539000591,8421884,NULL,NULL,NULL,NULL),(3278,3278,1,'LSQ12fwe','LSQ',9.043625,4.86469444444444,NULL,NULL,'2012-10-31 03:34:58',56231.1492900001,19.0485,0.1761,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwe/LSQ12fwe_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwe/LSQ12fwe_snap_68529.gif',66820332832,NULL,NULL,NULL,'2012-09-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044067700,16313557,NULL,NULL,NULL,NULL),(3279,3278,0,'LSQ12fwe','LSQ',9.04358333333333,4.86469444444444,NULL,NULL,'2012-11-02 00:51:57',56233.03608,19.4449,0.0937,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwe/LSQ12fwe_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwe/LSQ12fwe_snap_68495.gif',66820332832,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044067700,16313557,NULL,NULL,NULL,NULL),(3280,3278,0,'LSQ12fwe','LSQ',9.04370833333333,4.86472222222222,NULL,NULL,'2012-11-02 02:53:28',56233.12047,19.4627,0.1036,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwe/LSQ12fwe_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwe/LSQ12fwe_snap_68496.gif',66820332832,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044067700,16313557,NULL,NULL,NULL,NULL),(3281,3281,1,'LSQ12fwd','LSQ',56.3923333333333,-0.35725,NULL,NULL,'2012-10-31 06:12:33',56231.2587199998,19.1426,0.1853,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_history.html','agn?',NULL,0.10854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_snap_68527.gif',36993805999,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578028218,9031690,NULL,NULL,NULL,NULL),(3282,3281,0,'LSQ12fwd','LSQ',56.3923333333333,-0.357361111111111,NULL,NULL,'2012-11-02 05:39:19',56233.2356400001,18.7486,0.1481,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_history.html','agn?',NULL,0.10854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_snap_68493.gif',36993805999,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578028218,9031690,NULL,NULL,NULL,NULL),(3283,3281,0,'LSQ12fwd','LSQ',56.3923333333333,-0.35725,NULL,NULL,'2012-11-02 07:15:04',56233.3021399998,18.9721,0.1466,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_history.html','agn?',NULL,0.10854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_snap_68494.gif',36993805999,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578028218,9031690,NULL,NULL,NULL,NULL),(3284,3284,1,'LSQ12fxk','LSQ',57.945375,-22.1756944444444,NULL,NULL,'2012-11-01 07:19:55',56232.3054999998,18.8149,0.1974,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_snap_68793.gif',37996998851,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593703107,9276611,NULL,NULL,NULL,NULL),(3285,3284,0,'LSQ12fxk','LSQ',57.9454583333333,-22.1758888888889,NULL,NULL,'2012-11-03 05:47:57',56234.2416400001,18.9173,0.1602,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_snap_68782.gif',37996998851,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593703107,9276611,NULL,NULL,NULL,NULL),(3286,3284,0,'LSQ12fxk','LSQ',57.945375,-22.1758611111111,NULL,NULL,'2012-11-03 07:18:47',56234.3047199999,18.9009,0.1642,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_snap_68783.gif',37996998851,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593703107,9276611,NULL,NULL,NULL,NULL),(3287,3287,1,'LSQ12fxc','LSQ',47.815625,-22.4542222222222,NULL,NULL,'2012-10-26 05:57:02',56226.2479400001,18.8478,0.0967,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_68755.gif',38030912757,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(3288,3287,0,'LSQ12fxc','LSQ',47.815625,-22.4541944444444,NULL,NULL,'2012-10-26 07:50:11',56226.3265200001,19.4345,0.1142,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_68756.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(3289,3287,0,'LSQ12fxc','LSQ',47.8156666666667,-22.4541111111111,NULL,NULL,'2012-11-01 05:37:37',56232.2344599999,19.2843,0.1456,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_68757.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(3290,3287,0,'LSQ12fxc','LSQ',47.8157083333333,-22.4541388888889,NULL,NULL,'2012-11-01 07:14:50',56232.3019699999,18.9294,0.1275,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_68758.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(3291,3287,0,'LSQ12fxc','LSQ',47.815625,-22.4541666666667,NULL,NULL,'2012-11-03 05:39:29',56234.2357600001,19.1207,0.1175,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_68747.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(3292,3287,0,'LSQ12fxc','LSQ',47.81575,-22.4541944444444,NULL,NULL,'2012-11-03 07:40:49',56234.32002,18.5458,0.14,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_68748.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(3293,3293,1,'LSQ12fxa','LSQ',358.600875,-30.1613888888889,NULL,NULL,'2012-11-03 00:49:31',56234.0343900002,20.1693,0.1396,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxa/LSQ12fxa_history.html','agn?',NULL,0.1428,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxa/LSQ12fxa_snap_68743.gif',50044826551,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781950414,12217975,NULL,NULL,NULL,NULL),(3294,3293,0,'LSQ12fxa','LSQ',358.6005,-30.1614166666667,NULL,NULL,'2012-11-03 02:51:48',56234.11931,20.2228,0.1451,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxa/LSQ12fxa_history.html','agn?',NULL,0.1428,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxa/LSQ12fxa_snap_68744.gif',50044826551,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781950414,12217975,NULL,NULL,NULL,NULL),(3295,3295,1,'LSQ12fwx','LSQ',359.5415,-29.7360277777778,NULL,NULL,'2012-11-01 03:02:43',56232.12689,19.7355,0.1026,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_history.html','sne - nice',NULL,0.0972,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_snap_68761.gif',50036319036,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781817484,12215898,NULL,NULL,NULL,NULL),(3296,3295,0,'LSQ12fwx','LSQ',359.541625,-29.7361111111111,NULL,NULL,'2012-11-03 00:59:49',56234.0415400001,19.3972,0.0518,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_history.html','sne - nice',NULL,0.0972,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_snap_68737.gif',50036319036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781817484,12215898,NULL,NULL,NULL,NULL),(3297,3295,0,'LSQ12fwx','LSQ',359.541541666667,-29.7360833333333,NULL,NULL,'2012-11-03 03:03:38',56234.1275300002,19.1359,0.0613,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 16:45:39','2012-11-04 16:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_history.html','sne - nice',NULL,0.0972,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_snap_68738.gif',50036319036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781817484,12215898,NULL,NULL,NULL,NULL),(3298,2232,0,'LSQ12fik','LSQ',56.7649583333333,-10.9834166666667,NULL,NULL,'2012-11-04 07:52:02',56235.3278100002,18.1934,0.0628,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_68968.gif',37025736046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(3299,2241,0,'LSQ12fjm','LSQ',69.0454583333333,-5.08180555555556,NULL,NULL,'2012-11-04 05:35:28',56235.2329699998,18.6554,0.0879,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_snap_68959.gif',37460190231,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585315472,9145554,NULL,NULL,NULL,NULL),(3300,2368,0,'LSQ12fjw','LSQ',56.383625,-7.39655555555556,NULL,NULL,'2012-11-04 05:10:03',56235.21532,19.0422,0.1326,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_history.html','sne - nice',NULL,0.02832,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_snap_68876.gif',37031203525,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578612555,9040821,NULL,NULL,NULL,NULL),(3301,2580,0,'LSQ12fks','LSQ',65.5735,-6.22908333333333,NULL,NULL,'2012-11-04 07:11:24',56235.29959,18.493,0.1235,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_snap_69019.gif',36948141630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577314712,9020542,NULL,NULL,NULL,NULL),(3302,2813,0,'LSQ12foo','LSQ',348.885375,-18.6660277777778,NULL,NULL,'2012-11-04 02:27:43',56235.1025899998,17.9102,0.0769,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12foo/LSQ12foo_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12foo/LSQ12foo_snap_68983.gif',50315373299,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,786177707,12284026,NULL,NULL,NULL,NULL),(3303,2900,0,'LSQ12fqb','LSQ',70.8874583333333,-11.9015,NULL,NULL,'2012-11-04 05:18:31',56235.2212,19.3138,0.1123,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_69059.gif',37539441792,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553778,9164902,NULL,NULL,NULL,NULL),(3304,2939,0,'LSQ12fpp','LSQ',50.8667916666667,-12.0056111111111,NULL,NULL,'2012-11-04 07:55:24',56235.3301499998,18.3764,0.1388,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_68853.gif',37885516712,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(3305,3033,0,'LSQ12fvf','LSQ',7.61741666666667,6.94566666666667,NULL,NULL,'2012-11-04 00:36:53',56235.02562,19.1791,0.059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvf/LSQ12fvf_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvf/LSQ12fvf_snap_69042.gif',66839103492,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044360992,16318140,NULL,NULL,NULL,NULL),(3306,3033,0,'LSQ12fvf','LSQ',7.61754166666667,6.94566666666667,NULL,NULL,'2012-11-04 02:37:58',56235.1096999999,19.269,0.0678,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvf/LSQ12fvf_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvf/LSQ12fvf_snap_69043.gif',66839103492,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044360992,16318140,NULL,NULL,NULL,NULL),(3307,3040,0,'LSQ12fuv','LSQ',22.0849166666667,-2.54727777777778,NULL,NULL,'2012-11-04 01:53:53',56235.0790900001,20.6468,0.1937,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuv/LSQ12fuv_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuv/LSQ12fuv_snap_69031.gif',35234940193,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,550545940,8602280,NULL,NULL,NULL,NULL),(3308,3042,0,'LSQ12fuu','LSQ',358.8455,-2.27708333333333,NULL,NULL,'2012-11-04 00:33:27',56235.02324,19.3999,0.0829,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuu/LSQ12fuu_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuu/LSQ12fuu_snap_69032.gif',49406600211,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,771978128,12062158,NULL,NULL,NULL,NULL),(3309,3042,0,'LSQ12fuu','LSQ',358.845125,-2.27702777777778,NULL,NULL,'2012-11-04 02:34:34',56235.1073400001,20.274,0.1251,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuu/LSQ12fuu_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuu/LSQ12fuu_snap_69033.gif',49406600211,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,771978128,12062158,NULL,NULL,NULL,NULL),(3310,3044,0,'LSQ12ftn','LSQ',2.53929166666667,-19.1404444444444,NULL,NULL,'2012-11-04 01:32:51',56235.0644899998,18.7354,0.0573,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_snap_68813.gif',34442362275,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538161910,8408779,NULL,NULL,NULL,NULL),(3311,3044,0,'LSQ12ftn','LSQ',2.53933333333333,-19.1404444444444,NULL,NULL,'2012-11-04 03:32:56',56235.1478800001,18.6797,0.0836,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_snap_68814.gif',34442362275,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538161910,8408779,NULL,NULL,NULL,NULL),(3312,3047,0,'LSQ12fun','LSQ',355.184791666667,-0.35175,NULL,NULL,'2012-11-04 00:21:16',56235.0147699998,18.8954,0.0712,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fun/LSQ12fun_history.html','sne or asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fun/LSQ12fun_snap_69051.gif',49397192770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,771831137,12059861,NULL,NULL,NULL,NULL),(3313,3047,0,'LSQ12fun','LSQ',355.184791666667,-0.351777777777778,NULL,NULL,'2012-11-04 02:22:28',56235.0989399999,18.8834,0.0565,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fun/LSQ12fun_history.html','sne or asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fun/LSQ12fun_snap_69052.gif',49397192770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,771831137,12059861,NULL,NULL,NULL,NULL),(3314,3049,0,'LSQ12fuk','LSQ',74.566125,-16.2994444444444,NULL,NULL,'2012-11-04 04:58:01',56235.2069600001,15.3687,0.0044,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_history.html','sne - bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_snap_68909.gif',37569693502,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587026460,9172288,NULL,NULL,NULL,NULL),(3315,3049,0,'LSQ12fuk','LSQ',74.5662083333333,-16.2994166666667,NULL,NULL,'2012-11-04 07:57:19',56235.3314700001,15.3891,0.0043,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_history.html','sne - bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_snap_68910.gif',37569693502,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587026460,9172288,NULL,NULL,NULL,NULL),(3316,3051,0,'LSQ12fui','LSQ',70.95175,-13.3013611111111,NULL,NULL,'2012-11-04 04:56:20',56235.20579,18.4853,0.045,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_snap_68913.gif',37542571140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586602674,9165666,NULL,NULL,NULL,NULL),(3317,3051,0,'LSQ12fui','LSQ',70.95175,-13.3013888888889,NULL,NULL,'2012-11-04 06:52:31',56235.2864799998,18.5965,0.0505,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_snap_68914.gif',37542571140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586602674,9165666,NULL,NULL,NULL,NULL),(3318,3058,0,'LSQ12fuc','LSQ',75.0465416666667,-20.00725,NULL,NULL,'2012-11-04 04:34:01',56235.1902899998,18.927,0.0739,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_history.html','sne - good',NULL,0.041789,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_snap_68820.gif',37564014387,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586937724,9170901,NULL,NULL,NULL,NULL),(3319,3058,0,'LSQ12fuc','LSQ',75.0465416666667,-20.00725,NULL,NULL,'2012-11-04 06:35:17',56235.2745099999,19.2614,0.0737,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_history.html','sne - good',NULL,0.041789,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_snap_68821.gif',37564014387,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586937724,9170901,NULL,NULL,NULL,NULL),(3320,3060,0,'LSQ12ftz','LSQ',74.7340833333333,-20.3274166666667,NULL,NULL,'2012-11-04 04:32:19',56235.1891200002,18.7001,0.0657,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_snap_69056.gif',37561880973,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586904390,9170381,NULL,NULL,NULL,NULL),(3321,3060,0,'LSQ12ftz','LSQ',74.734,-20.3273888888889,NULL,NULL,'2012-11-04 06:33:36',56235.2733399998,18.8337,0.049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_snap_69057.gif',37561880973,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586904390,9170381,NULL,NULL,NULL,NULL),(3322,3064,0,'LSQ12ftr','LSQ',66.67225,-20.9704166666667,NULL,NULL,'2012-11-04 04:27:14',56235.1855899999,16.7427,0.014,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_history.html','sne or comet',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_snap_68922.gif',37323194914,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583174920,9112108,NULL,NULL,NULL,NULL),(3323,3064,0,'LSQ12ftr','LSQ',66.67225,-20.9704166666667,NULL,NULL,'2012-11-04 06:28:31',56235.26981,16.7586,0.014,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_history.html','sne or comet',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_snap_68923.gif',37323194914,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583174920,9112108,NULL,NULL,NULL,NULL),(3324,3069,0,'LSQ12fus','LSQ',15.9785833333333,-5.93841666666667,NULL,NULL,'2012-11-04 01:52:12',56235.0779200001,20.1778,0.1089,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_snap_68830.gif',34532215199,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539565862,8430716,NULL,NULL,NULL,NULL),(3325,3069,0,'LSQ12fus','LSQ',15.978625,-5.93847222222222,NULL,NULL,'2012-11-04 03:52:01',56235.1611299999,19.6023,0.1008,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_snap_68831.gif',34532215196,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539565862,8430716,NULL,NULL,NULL,NULL),(3326,3150,0,'LSQ12fvz','LSQ',60.5280416666667,-20.3228333333333,NULL,NULL,'2012-11-04 04:20:29',56235.1809,18.9423,0.088,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvz/LSQ12fvz_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvz/LSQ12fvz_snap_68834.gif',36853079254,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575829363,8997333,NULL,NULL,NULL,NULL),(3327,3150,0,'LSQ12fvz','LSQ',60.5280833333333,-20.3229166666667,NULL,NULL,'2012-11-04 06:21:48',56235.2651399998,19.1161,0.0983,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvz/LSQ12fvz_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvz/LSQ12fvz_snap_68835.gif',36853079254,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575829363,8997333,NULL,NULL,NULL,NULL),(3328,3153,0,'LSQ12fwb','LSQ',6.35504166666667,6.70722222222222,NULL,NULL,'2012-11-04 00:36:53',56235.02562,18.7346,0.0518,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwb/LSQ12fwb_history.html','sne - nice',NULL,0.029834,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwb/LSQ12fwb_snap_68843.gif',66827155915,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044174311,16315223,NULL,NULL,NULL,NULL),(3329,3153,0,'LSQ12fwb','LSQ',6.35504166666667,6.70725,NULL,NULL,'2012-11-04 02:37:58',56235.1096999999,18.8036,0.057,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwb/LSQ12fwb_history.html','sne - nice',NULL,0.029834,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwb/LSQ12fwb_snap_68844.gif',66827155915,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044174311,16315223,NULL,NULL,NULL,NULL),(3330,3259,0,'LSQ12fwn','LSQ',13.2858333333333,-3.97377777777778,NULL,NULL,'2012-11-04 01:38:03',56235.0680999998,20.5512,0.1147,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwn/LSQ12fwn_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwn/LSQ12fwn_snap_68870.gif',34546872308,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,539794879,8434294,NULL,NULL,NULL,NULL),(3331,3259,0,'LSQ12fwn','LSQ',13.2858333333333,-3.97380555555556,NULL,NULL,'2012-11-04 03:38:05',56235.1514499998,20.4055,0.1006,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwn/LSQ12fwn_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwn/LSQ12fwn_snap_68871.gif',34546872311,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,539794879,8434294,NULL,NULL,NULL,NULL),(3332,3262,0,'LSQ12fwm','LSQ',7.70679166666667,-7.05694444444444,NULL,NULL,'2012-11-04 01:22:11',56235.0570800002,19.8784,0.0739,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwm/LSQ12fwm_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwm/LSQ12fwm_snap_68856.gif',34625393869,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,541021779,8453465,NULL,NULL,NULL,NULL),(3333,3262,0,'LSQ12fwm','LSQ',7.706875,-7.05705555555556,NULL,NULL,'2012-11-04 03:22:16',56235.14047,19.7182,0.0748,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwm/LSQ12fwm_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwm/LSQ12fwm_snap_68857.gif',34625393869,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,541021779,8453465,NULL,NULL,NULL,NULL),(3334,3266,0,'LSQ12fwl','LSQ',4.127,-2.86275,NULL,NULL,'2012-11-04 01:03:25',56235.0440500001,18.5854,0.0512,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwl/LSQ12fwl_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwl/LSQ12fwl_snap_68891.gif',34423192334,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537862380,8404099,NULL,NULL,NULL,NULL),(3335,3266,0,'LSQ12fwl','LSQ',4.12695833333333,-2.86277777777778,NULL,NULL,'2012-11-04 03:03:48',56235.1276500002,18.5096,0.0499,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwl/LSQ12fwl_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwl/LSQ12fwl_snap_68892.gif',34423192334,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,537862380,8404099,NULL,NULL,NULL,NULL),(3336,3273,0,'LSQ12fwf','LSQ',20.2272916666667,-0.525694444444444,NULL,NULL,'2012-11-04 01:53:53',56235.0790900001,19.6493,0.1601,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_history.html','sne?',NULL,0.09287,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_snap_68840.gif',34496037884,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539000591,8421884,NULL,NULL,NULL,NULL),(3337,3273,0,'LSQ12fwf','LSQ',20.2270833333333,-0.525583333333333,NULL,NULL,'2012-11-04 03:53:42',56235.1623,18.8386,0.1148,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_history.html','sne?',NULL,0.09287,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_snap_68841.gif',34496037887,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539000591,8421884,NULL,NULL,NULL,NULL),(3338,3278,0,'LSQ12fwe','LSQ',9.04345833333333,4.86469444444444,NULL,NULL,'2012-11-04 00:53:10',56235.0369299999,19.7392,0.0899,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwe/LSQ12fwe_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwe/LSQ12fwe_snap_68838.gif',66820331792,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044067684,16313557,NULL,NULL,NULL,NULL),(3339,3278,0,'LSQ12fwe','LSQ',9.04354166666667,4.86472222222222,NULL,NULL,'2012-11-04 02:53:37',56235.1205699998,19.5336,0.0837,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwe/LSQ12fwe_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwe/LSQ12fwe_snap_68839.gif',66820332832,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044067700,16313557,NULL,NULL,NULL,NULL),(3340,3281,0,'LSQ12fwd','LSQ',56.3922916666667,-0.357222222222222,NULL,NULL,'2012-11-04 05:40:39',56235.2365700002,18.5843,0.0832,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_history.html','agn?',NULL,0.10854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_snap_68884.gif',36993805998,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578028218,9031690,NULL,NULL,NULL,NULL),(3341,3281,0,'LSQ12fwd','LSQ',56.3923333333333,-0.357277777777778,NULL,NULL,'2012-11-04 07:14:47',56235.3019400002,19.0565,0.0841,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 19:45:39','2012-11-04 19:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_history.html','agn?',NULL,0.10854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_snap_68885.gif',36993805999,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578028218,9031690,NULL,NULL,NULL,NULL),(3342,2368,0,'LSQ12fjw','LSQ',56.3843333333333,-7.39644444444444,NULL,NULL,'2012-11-02 06:59:45',56233.2914999998,18.6474,0.1373,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 23:45:39','2012-11-04 23:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_history.html','sne - nice',NULL,0.02832,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_snap_69135.gif',37031203527,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578612555,9040821,NULL,NULL,NULL,NULL),(3343,2580,0,'LSQ12fks','LSQ',65.5732916666667,-6.22916666666667,NULL,NULL,'2012-11-02 07:11:41',56233.2997900001,18.5403,0.1036,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 23:45:39','2012-11-04 23:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_snap_69154.gif',36948141630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577314712,9020542,NULL,NULL,NULL,NULL),(3344,2900,0,'LSQ12fqb','LSQ',70.887875,-11.9013888888889,NULL,NULL,'2012-11-02 05:17:13',56233.2203000002,18.1812,0.1531,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 23:45:39','2012-11-04 23:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_69163.gif',37539442496,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553789,9164902,NULL,NULL,NULL,NULL),(3345,2900,0,'LSQ12fqb','LSQ',70.8875833333333,-11.9013611111111,NULL,NULL,'2012-11-02 07:47:13',56233.3244599998,19.1691,0.1702,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-04 23:45:39','2012-11-04 23:45:39','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_69164.gif',37539442240,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553785,9164902,NULL,NULL,NULL,NULL),(3346,3346,1,'LSQ12fzb','LSQ',34.17725,20.66925,NULL,NULL,'2012-11-04 02:10:02',56235.0903099999,19.8901,0.134,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzb/LSQ12fzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzb/LSQ12fzb_snap_69269.gif',68109800746,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1064215636,16628369,NULL,NULL,NULL,NULL),(3347,3346,0,'LSQ12fzb','LSQ',34.1772083333333,20.6693333333333,NULL,NULL,'2012-11-04 04:09:59',56235.1735999999,19.7315,0.1236,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzb/LSQ12fzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzb/LSQ12fzb_snap_69270.gif',68109800746,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1064215636,16628369,NULL,NULL,NULL,NULL),(3348,3348,1,'LSQ12fza','LSQ',34.893625,21.2727222222222,NULL,NULL,'2012-11-04 02:10:02',56235.0903099999,19.3571,0.0943,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fza/LSQ12fza_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fza/LSQ12fza_snap_69267.gif',68112332845,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1064255200,16628987,NULL,NULL,NULL,NULL),(3349,3348,0,'LSQ12fza','LSQ',34.8936666666667,21.2726388888889,NULL,NULL,'2012-11-04 04:09:59',56235.1735999999,19.9814,0.1313,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fza/LSQ12fza_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fza/LSQ12fza_snap_69268.gif',68112332845,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1064255200,16628987,NULL,NULL,NULL,NULL),(3350,3350,1,'LSQ12fyy','LSQ',24.3754583333333,16.6959166666667,NULL,NULL,'2012-11-02 01:09:06',56233.0479899999,20.4733,0.1708,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_snap_69360.gif',67419126530,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1053423852,16459747,NULL,NULL,NULL,NULL),(3351,3350,0,'LSQ12fyy','LSQ',24.375625,16.6959166666667,NULL,NULL,'2012-11-04 01:08:47',56235.0477700001,19.7483,0.1175,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_snap_69263.gif',67419126530,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1053423852,16459747,NULL,NULL,NULL,NULL),(3352,3350,0,'LSQ12fyy','LSQ',24.3756666666667,16.6956944444444,NULL,NULL,'2012-11-04 03:09:10',56235.1313700001,19.6201,0.1025,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_snap_69264.gif',67419126530,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1053423852,16459747,NULL,NULL,NULL,NULL),(3353,3353,1,'LSQ12fyw','LSQ',5.83766666666667,10.2637777777778,NULL,NULL,'2012-11-02 00:22:24',56233.0155600002,20.2221,0.1503,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyw/LSQ12fyw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyw/LSQ12fyw_snap_69337.gif',66832336198,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044255253,16316488,NULL,NULL,NULL,NULL),(3354,3353,0,'LSQ12fyw','LSQ',5.83779166666667,10.2637222222222,NULL,NULL,'2012-11-04 00:22:58',56235.0159499999,20.479,0.1457,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyw/LSQ12fyw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyw/LSQ12fyw_snap_69259.gif',66832336198,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044255253,16316488,NULL,NULL,NULL,NULL),(3355,3353,0,'LSQ12fyw','LSQ',5.83766666666667,10.2636666666667,NULL,NULL,'2012-11-04 02:24:10',56235.1001200001,20.277,0.1276,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyw/LSQ12fyw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyw/LSQ12fyw_snap_69260.gif',66832336198,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044255253,16316488,NULL,NULL,NULL,NULL),(3356,3356,1,'LSQ12fyv','LSQ',63.556875,2.86305555555556,NULL,NULL,'2012-11-02 05:56:11',56233.2473599999,20.1769,0.1768,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyv/LSQ12fyv_history.html','sne?',NULL,0.040024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyv/LSQ12fyv_snap_69336.gif',65084187378,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1016940427,15889694,NULL,NULL,NULL,NULL),(3357,3356,0,'LSQ12fyv','LSQ',63.5568333333333,2.86291666666667,NULL,NULL,'2012-11-04 05:57:39',56235.2483700002,20.9836,0.1009,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyv/LSQ12fyv_history.html','sne?',NULL,0.040024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyv/LSQ12fyv_snap_69257.gif',65084187378,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1016940427,15889694,NULL,NULL,NULL,NULL),(3358,3356,0,'LSQ12fyv','LSQ',63.5569166666667,2.86294444444444,NULL,NULL,'2012-11-04 07:23:15',56235.3078200002,21.2226,0.103,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyv/LSQ12fyv_history.html','sne?',NULL,0.040024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyv/LSQ12fyv_snap_69258.gif',65084187378,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1016940427,15889694,NULL,NULL,NULL,NULL),(3359,3359,1,'LSQ12fyt','LSQ',8.57354166666667,4.16269444444444,NULL,NULL,'2012-10-31 03:33:17',56231.14812,19.8454,0.1811,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_snap_69351.gif',66821045461,NULL,NULL,NULL,'2012-09-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044078835,16313731,NULL,NULL,NULL,NULL),(3360,3359,0,'LSQ12fyt','LSQ',8.57358333333333,4.16280555555556,NULL,NULL,'2012-11-02 00:50:15',56233.0348999999,20.0071,0.0997,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_snap_69352.gif',66821045463,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044078835,16313731,NULL,NULL,NULL,NULL),(3361,3359,0,'LSQ12fyt','LSQ',8.57358333333333,4.16277777777778,NULL,NULL,'2012-11-02 02:51:48',56233.11931,19.7087,0.206,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_snap_69353.gif',66821045461,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044078835,16313731,NULL,NULL,NULL,NULL),(3362,3359,0,'LSQ12fyt','LSQ',8.57358333333333,4.16280555555556,NULL,NULL,'2012-11-04 00:51:28',56235.0357499998,19.7832,0.1466,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_snap_69253.gif',66821045463,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044078835,16313731,NULL,NULL,NULL,NULL),(3363,3359,0,'LSQ12fyt','LSQ',8.57358333333333,4.16280555555556,NULL,NULL,'2012-11-04 02:51:56',56235.1194000002,20.0032,0.1338,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_snap_69254.gif',66821045463,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044078835,16313731,NULL,NULL,NULL,NULL),(3364,3364,1,'LSQ12fyp','LSQ',12.1207916666667,-0.718305555555556,NULL,NULL,'2012-10-31 02:03:59',56231.0861,19.5329,0.1519,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyp/LSQ12fyp_history.html','agn?',NULL,0.04272,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyp/LSQ12fyp_snap_69344.gif',34514673967,NULL,NULL,NULL,'2012-09-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539291780,8426434,NULL,NULL,NULL,NULL),(3365,3364,0,'LSQ12fyp','LSQ',12.12075,-0.718027777777778,NULL,NULL,'2012-10-31 04:06:14',56231.1710000001,18.1842,0.0733,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyp/LSQ12fyp_history.html','agn?',NULL,0.04272,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyp/LSQ12fyp_snap_69345.gif',34514673967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539291780,8426434,NULL,NULL,NULL,NULL),(3366,3364,0,'LSQ12fyp','LSQ',12.1210416666667,-0.717861111111111,NULL,NULL,'2012-11-02 01:27:35',56233.0608299999,18.8685,0.0634,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyp/LSQ12fyp_history.html','agn?',NULL,0.04272,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyp/LSQ12fyp_snap_69346.gif',34514673966,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539291780,8426434,NULL,NULL,NULL,NULL),(3367,3364,0,'LSQ12fyp','LSQ',12.1207916666667,-0.718083333333333,NULL,NULL,'2012-11-04 01:29:01',56235.0618199999,18.4445,0.0454,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyp/LSQ12fyp_history.html','agn?',NULL,0.04272,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyp/LSQ12fyp_snap_69245.gif',34514673967,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539291780,8426434,NULL,NULL,NULL,NULL),(3368,3364,0,'LSQ12fyp','LSQ',12.1209166666667,-0.717833333333333,NULL,NULL,'2012-11-04 03:29:07',56235.1452299999,19.4478,0.1108,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyp/LSQ12fyp_history.html','agn?',NULL,0.04272,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyp/LSQ12fyp_snap_69246.gif',34514673966,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539291780,8426434,NULL,NULL,NULL,NULL),(3369,3369,1,'LSQ12fym','LSQ',359.004375,-1.45211111111111,NULL,NULL,'2012-10-31 01:09:08',56231.0480200001,19.7244,0.1719,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fym/LSQ12fym_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fym/LSQ12fym_snap_69331.gif',49394894490,NULL,NULL,NULL,'2012-09-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,771795226,12059300,NULL,NULL,NULL,NULL),(3370,3369,0,'LSQ12fym','LSQ',359.004333333333,-1.45219444444444,NULL,NULL,'2012-11-02 00:32:53',56233.0228400002,20.2215,0.1296,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fym/LSQ12fym_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fym/LSQ12fym_snap_69332.gif',49394894490,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,771795226,12059300,NULL,NULL,NULL,NULL),(3371,3369,0,'LSQ12fym','LSQ',359.004375,-1.45216666666667,NULL,NULL,'2012-11-02 02:34:27',56233.10726,20.1969,0.1621,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fym/LSQ12fym_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fym/LSQ12fym_snap_69333.gif',49394894490,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,771795226,12059300,NULL,NULL,NULL,NULL),(3372,3369,0,'LSQ12fym','LSQ',359.004333333333,-1.45216666666667,NULL,NULL,'2012-11-04 00:33:27',56235.02324,20.3436,0.1289,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fym/LSQ12fym_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fym/LSQ12fym_snap_69239.gif',49394894490,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,771795226,12059300,NULL,NULL,NULL,NULL),(3373,3369,0,'LSQ12fym','LSQ',359.004291666667,-1.45216666666667,NULL,NULL,'2012-11-04 02:34:34',56235.1073400001,20.1121,0.1093,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fym/LSQ12fym_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fym/LSQ12fym_snap_69240.gif',49394894490,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,771795226,12059300,NULL,NULL,NULL,NULL),(3374,3374,1,'LSQ12fyg','LSQ',68.9834166666667,-4.04516666666667,NULL,NULL,'2011-12-15 04:54:03',55910.2042100001,19.7129,0.1818,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyg/LSQ12fyg_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyg/LSQ12fyg_snap_69320.gif',37463478355,NULL,NULL,NULL,'2011-12-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585366849,9146357,NULL,NULL,NULL,NULL),(3375,3374,0,'LSQ12fyg','LSQ',68.983375,-4.04533333333333,NULL,NULL,'2012-10-14 08:20:09',56214.3473299998,20.2425,0.1727,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyg/LSQ12fyg_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyg/LSQ12fyg_snap_69321.gif',37463478352,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585366849,9146357,NULL,NULL,NULL,NULL),(3376,3374,0,'LSQ12fyg','LSQ',68.983125,-4.04497222222222,NULL,NULL,'2012-11-04 05:35:28',56235.2329699998,19.23,0.1699,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyg/LSQ12fyg_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyg/LSQ12fyg_snap_69227.gif',37463478352,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585366849,9146357,NULL,NULL,NULL,NULL),(3377,3374,0,'LSQ12fyg','LSQ',68.9830833333333,-4.04505555555556,NULL,NULL,'2012-11-04 07:38:30',56235.3184099998,18.2948,0.1061,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyg/LSQ12fyg_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyg/LSQ12fyg_snap_69228.gif',37463478352,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585366849,9146357,NULL,NULL,NULL,NULL),(3378,3378,1,'LSQ12fyf','LSQ',63.8234583333333,-7.06958333333333,NULL,NULL,'2012-11-04 05:33:46',56235.2317900001,18.4878,0.1195,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_snap_69225.gif',36956960238,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577452503,9022695,NULL,NULL,NULL,NULL),(3379,3378,0,'LSQ12fyf','LSQ',63.8235,-7.06947222222222,NULL,NULL,'2012-11-04 07:11:24',56235.29959,18.7213,0.1392,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_snap_69226.gif',36956960238,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577452503,9022695,NULL,NULL,NULL,NULL),(3380,3380,1,'LSQ12fye','LSQ',62.7185416666667,-4.92319444444444,NULL,NULL,'2012-10-20 07:47:34',56220.3247000002,19.6985,0.1758,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_69316.gif',36961736787,NULL,NULL,NULL,'2012-10-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(3381,3380,0,'LSQ12fye','LSQ',62.7185416666667,-4.92302777777778,NULL,NULL,'2012-10-24 08:27:11',56224.3522199998,19.1811,0.115,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_69317.gif',36961736785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(3382,3380,0,'LSQ12fye','LSQ',62.7185416666667,-4.92308333333333,NULL,NULL,'2012-11-02 05:29:10',56233.22859,17.6917,0.1023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_69318.gif',36961736785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(3383,3380,0,'LSQ12fye','LSQ',62.7185,-4.92305555555556,NULL,NULL,'2012-11-02 07:10:00',56233.29862,18.1122,0.1021,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_69319.gif',36961736785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(3384,3380,0,'LSQ12fye','LSQ',62.7185833333333,-4.92308333333333,NULL,NULL,'2012-11-04 05:30:22',56235.2294299998,18.2684,0.0951,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_69223.gif',36961736785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(3385,3380,0,'LSQ12fye','LSQ',62.7184583333333,-4.92302777777778,NULL,NULL,'2012-11-04 07:09:42',56235.2984099998,18.4255,0.0974,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_69224.gif',36961736785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(3386,3386,1,'LSQ12fyb','LSQ',53.6892916666667,-3.73916666666667,NULL,NULL,'2012-08-20 09:55:36',56159.4136199998,19.7762,0.1225,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_69297.gif',36820699944,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(3387,3386,0,'LSQ12fyb','LSQ',53.6891666666667,-3.73916666666667,NULL,NULL,'2012-10-12 08:45:50',56212.3651700001,19.2867,0.1454,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_69298.gif',36820699944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(3388,3386,0,'LSQ12fyb','LSQ',53.6895416666667,-3.73911111111111,NULL,NULL,'2012-10-16 07:58:40',56216.3324099998,20.0609,0.1446,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_69299.gif',36820699952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(3389,3386,0,'LSQ12fyb','LSQ',53.6891666666667,-3.73911111111111,NULL,NULL,'2012-10-18 06:33:21',56218.2731599999,19.1507,0.0727,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_69300.gif',36820699944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(3390,3386,0,'LSQ12fyb','LSQ',53.6892916666667,-3.73919444444444,NULL,NULL,'2012-10-20 06:22:52',56220.2658899999,19.6069,0.1902,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_69301.gif',36820699944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(3391,3386,0,'LSQ12fyb','LSQ',53.689,-3.73908333333333,NULL,NULL,'2012-10-20 07:44:11',56220.3223600001,19.3332,0.0928,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_69302.gif',36820699944,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(3392,3386,0,'LSQ12fyb','LSQ',53.6886666666667,-3.73902777777778,NULL,NULL,'2012-10-24 08:23:48',56224.34987,19.3968,0.1341,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_69303.gif',36820700116,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323439,8989428,NULL,NULL,NULL,NULL),(3393,3386,0,'LSQ12fyb','LSQ',53.689375,-3.73863888888889,NULL,NULL,'2012-11-02 05:22:23',56233.2238799999,19.3294,0.16,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_69304.gif',36820699952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(3394,3386,0,'LSQ12fyb','LSQ',53.6894166666667,-3.7385,NULL,NULL,'2012-11-02 07:06:37',56233.2962699998,19.1927,0.1624,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_69305.gif',36820699952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(3395,3386,0,'LSQ12fyb','LSQ',53.6892916666667,-3.73858333333333,NULL,NULL,'2012-11-04 05:23:36',56235.2247299999,19.2904,0.1207,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_69217.gif',36820699952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(3396,3386,0,'LSQ12fyb','LSQ',53.6891666666667,-3.7385,NULL,NULL,'2012-11-04 07:06:21',56235.2960799998,19.6414,0.1675,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_69218.gif',36820699952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(3397,3397,1,'LSQ12fxz','LSQ',15.4682083333333,-4.95916666666667,NULL,NULL,'2012-11-04 01:50:28',56235.0767199998,19.3623,0.1446,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxz/LSQ12fxz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxz/LSQ12fxz_snap_69213.gif',34551283441,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539863803,8435371,NULL,NULL,NULL,NULL),(3398,3397,0,'LSQ12fxz','LSQ',15.4683333333333,-4.95911111111111,NULL,NULL,'2012-11-04 03:50:21',56235.1599699999,19.2575,0.1314,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxz/LSQ12fxz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxz/LSQ12fxz_snap_69214.gif',34551283441,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539863803,8435371,NULL,NULL,NULL,NULL),(3399,3399,1,'LSQ12fxy','LSQ',50.1275833333333,-11.2953888888889,NULL,NULL,'2012-11-04 05:03:20',56235.2106499998,19.0439,0.124,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_snap_69211.gif',37885680965,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591963765,9249433,NULL,NULL,NULL,NULL),(3400,3399,0,'LSQ12fxy','LSQ',50.1275416666667,-11.2956666666667,NULL,NULL,'2012-11-04 06:56:07',56235.2889700001,18.8429,0.1468,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_snap_69212.gif',37885680972,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591963765,9249433,NULL,NULL,NULL,NULL),(3401,3401,0,'LSQ12fxx','LSQ',51.1459166666667,-10.1414722222222,NULL,NULL,'2012-11-02 05:01:58',56233.2097100001,17.3392,0.0563,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2019-12-24 20:38:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxx/LSQ12fxx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxx/LSQ12fxx_snap_69292.gif',37884403751,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591943808,9249122,NULL,NULL,NULL,NULL),(3402,3401,0,'LSQ12fxx','LSQ',51.145875,-10.1413888888889,NULL,NULL,'2012-11-02 06:56:23',56233.2891600002,17.026,0.0406,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxx/LSQ12fxx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxx/LSQ12fxx_snap_69293.gif',37884403751,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591943808,9249122,NULL,NULL,NULL,NULL),(3403,3401,0,'LSQ12fxx','LSQ',51.1458333333333,-10.1413611111111,NULL,NULL,'2012-11-04 05:03:20',56235.2106499998,17.4719,0.0427,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxx/LSQ12fxx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxx/LSQ12fxx_snap_69209.gif',37884403751,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591943808,9249122,NULL,NULL,NULL,NULL),(3404,3401,0,'LSQ12fxx','LSQ',51.1458333333333,-10.1413888888889,NULL,NULL,'2012-11-04 06:56:07',56235.2889700001,17.4554,0.0427,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxx/LSQ12fxx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxx/LSQ12fxx_snap_69210.gif',37884403751,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591943808,9249122,NULL,NULL,NULL,NULL),(3405,3405,1,'LSQ12fxv','LSQ',358.93225,-12.6411666666667,NULL,NULL,'2012-11-02 01:00:25',56233.0419600001,19.7299,0.1522,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_snap_69290.gif',49546365664,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,774161963,12096280,NULL,NULL,NULL,NULL),(3406,3405,0,'LSQ12fxv','LSQ',358.932291666667,-12.6411944444444,NULL,NULL,'2012-11-02 03:02:00',56233.1264,19.77,0.1336,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_snap_69291.gif',49546365664,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,774161963,12096280,NULL,NULL,NULL,NULL),(3407,3405,0,'LSQ12fxv','LSQ',358.93225,-12.6412222222222,NULL,NULL,'2012-11-04 01:01:43',56235.0428599999,20.1455,0.1407,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_snap_69205.gif',49546365664,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,774161963,12096280,NULL,NULL,NULL,NULL),(3408,3405,0,'LSQ12fxv','LSQ',358.932291666667,-12.6411944444444,NULL,NULL,'2012-11-04 03:02:07',56235.1264800001,20.1476,0.1521,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_snap_69206.gif',49546365664,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,774161963,12096280,NULL,NULL,NULL,NULL),(3409,3409,1,'LSQ12fxu','LSQ',356.792208333333,-13.2493611111111,NULL,NULL,'2012-10-25 03:50:04',56225.1597799999,17.6932,0.1227,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_snap_69286.gif',49549307031,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,774207922,12096998,NULL,NULL,NULL,NULL),(3410,3409,0,'LSQ12fxu','LSQ',356.792208333333,-13.2493333333333,NULL,NULL,'2012-10-31 01:21:18',56231.0564600001,17.91,0.0945,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_snap_69287.gif',49549307031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,774207922,12096998,NULL,NULL,NULL,NULL),(3411,3409,0,'LSQ12fxu','LSQ',356.792166666667,-13.2493333333333,NULL,NULL,'2012-10-31 03:23:30',56231.1413199999,18.0183,0.0894,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_snap_69288.gif',49549307030,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,774207922,12096998,NULL,NULL,NULL,NULL),(3412,3409,0,'LSQ12fxu','LSQ',356.79225,-13.2493888888889,NULL,NULL,'2012-11-02 02:46:39',56233.1157300002,18.0768,0.0877,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_snap_69289.gif',49549307031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,774207922,12096998,NULL,NULL,NULL,NULL),(3413,3409,0,'LSQ12fxu','LSQ',356.792208333333,-13.2493611111111,NULL,NULL,'2012-11-04 00:46:22',56235.0321999998,18.0545,0.0755,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_snap_69203.gif',49549307031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,774207922,12096998,NULL,NULL,NULL,NULL),(3414,3409,0,'LSQ12fxu','LSQ',356.79225,-13.2493333333333,NULL,NULL,'2012-11-04 02:46:51',56235.1158699999,18.2171,0.0747,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 01:45:42','2012-11-05 01:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_snap_69204.gif',49549307031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,774207922,12096998,NULL,NULL,NULL,NULL),(3415,2815,0,'LSQ12fom','LSQ',347.119291666667,-21.6681944444444,NULL,NULL,'2012-11-05 00:41:40',56236.0289400001,19.8204,0.1701,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fom/LSQ12fom_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fom/LSQ12fom_snap_69538.gif',50300598676,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785946854,12280419,NULL,NULL,NULL,NULL),(3416,2974,0,'LSQ12frx','LSQ',12.98825,-23.7101944444444,NULL,NULL,'2012-11-05 02:01:22',56236.0842900001,19.1216,0.0462,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_snap_69500.gif',35316090512,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(3417,2974,0,'LSQ12frx','LSQ',12.9882083333333,-23.7101944444444,NULL,NULL,'2012-11-05 04:22:48',56236.1825000001,18.9698,0.0471,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_snap_69501.gif',35316090512,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(3418,2976,0,'LSQ12fro','LSQ',46.4142916666667,-33.5878055555556,NULL,NULL,'2012-11-05 08:22:52',56236.3492200002,17.6524,0.0342,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fro/LSQ12fro_history.html','CV?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fro/LSQ12fro_snap_69546.gif',38648187714,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603877933,9435592,NULL,NULL,NULL,NULL),(3419,3160,0,'LSQ12frr','LSQ',351.378708333333,-30.1273888888889,NULL,NULL,'2012-11-05 00:51:47',56236.0359700001,17.8798,0.0328,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_history.html','sne hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_snap_69541.gif',50188188166,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,784190440,12252975,NULL,NULL,NULL,NULL),(3420,3160,0,'LSQ12frr','LSQ',351.378708333333,-30.1273888888889,NULL,NULL,'2012-11-05 02:53:13',56236.12029,18.0815,0.0351,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_history.html','sne hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_snap_69542.gif',50188188166,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,784190440,12252975,NULL,NULL,NULL,NULL),(3421,2985,0,'LSQ12fsh','LSQ',12.7767083333333,-39.16,NULL,NULL,'2012-11-05 02:29:11',56236.1036,18.2397,0.0305,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_69609.gif',38166915082,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(3422,2985,0,'LSQ12fsh','LSQ',12.776625,-39.16,NULL,NULL,'2012-11-05 04:31:15',56236.1883700001,18.2753,0.0329,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_69610.gif',38166915083,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(3423,2987,0,'LSQ12fsj','LSQ',73.72925,-36.3250277777778,NULL,NULL,'2012-11-05 04:56:57',56236.2062200001,16.2855,0.0054,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_69606.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(3424,2987,0,'LSQ12fsj','LSQ',73.7293333333333,-36.3250277777778,NULL,NULL,'2012-11-05 08:26:32',56236.3517700001,16.281,0.0056,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_69607.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(3425,2991,0,'LSQ12fsi','LSQ',1.504625,-35.1924166666667,NULL,NULL,'2012-11-05 03:20:07',56236.1389700002,20.3413,0.1415,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_history.html','Old',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_snap_69608.gif',34665129379,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,541642646,8463166,NULL,NULL,NULL,NULL),(3426,2995,0,'LSQ12fsp','LSQ',357.212,-38.5519444444444,NULL,NULL,'2012-11-05 01:12:01',56236.05002,15.8624,0.006,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_history.html','Bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_snap_69600.gif',49991723132,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781120673,12205010,NULL,NULL,NULL,NULL),(3427,2995,0,'LSQ12fsp','LSQ',357.212083333333,-38.5519444444444,NULL,NULL,'2012-11-05 03:13:20',56236.1342699998,15.9226,0.0056,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_history.html','Bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_snap_69601.gif',49991723132,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781120673,12205010,NULL,NULL,NULL,NULL),(3428,2999,0,'LSQ12fsn','LSQ',10.6064166666667,-34.0972777777778,NULL,NULL,'2012-11-05 01:54:35',56236.0795800001,15.3639,0.0094,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_history.html','Unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_snap_69602.gif',34872861140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544888455,8513882,NULL,NULL,NULL,NULL),(3429,2999,0,'LSQ12fsn','LSQ',10.6063333333333,-34.0972777777778,NULL,NULL,'2012-11-05 04:11:34',56236.1747099999,15.0476,0.0094,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_history.html','Unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_snap_69603.gif',34872861140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544888455,8513882,NULL,NULL,NULL,NULL),(3430,3001,0,'LSQ12fth','LSQ',47.82275,-25.1095555555556,NULL,NULL,'2012-11-05 07:24:15',56236.3085099999,17.8154,0.0338,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_69561.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3431,3001,0,'LSQ12fth','LSQ',47.8225833333333,-25.10975,NULL,NULL,'2012-11-05 07:25:54',56236.3096599998,18.3025,0.0395,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_69562.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3432,3005,0,'LSQ12ftg','LSQ',44.9481666666667,-23.7168611111111,NULL,NULL,'2012-11-05 05:57:08',56236.2480100002,18.927,0.107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftg/LSQ12ftg_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftg/LSQ12ftg_snap_69589.gif',38051514190,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594554909,9289920,NULL,NULL,NULL,NULL),(3433,3005,0,'LSQ12ftg','LSQ',44.94825,-23.7169166666667,NULL,NULL,'2012-11-05 07:53:36',56236.32889,18.3702,0.1004,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftg/LSQ12ftg_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftg/LSQ12ftg_snap_69590.gif',38051514190,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594554909,9289920,NULL,NULL,NULL,NULL),(3434,3007,0,'LSQ12fte','LSQ',52.1527916666667,-24.8718333333333,NULL,NULL,'2012-11-05 06:02:12',56236.25153,19.9626,0.1462,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_snap_69591.gif',38021943870,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594092872,9282701,NULL,NULL,NULL,NULL),(3435,3007,0,'LSQ12fte','LSQ',52.1527916666667,-24.8718333333333,NULL,NULL,'2012-11-05 07:51:47',56236.3276300002,19.3933,0.1232,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_snap_69592.gif',38021943870,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594092872,9282701,NULL,NULL,NULL,NULL),(3436,3009,0,'LSQ12ftd','LSQ',64.2445416666667,-24.1447777777778,NULL,NULL,'2012-11-05 06:14:00',56236.25973,18.8939,0.1149,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_69565.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3437,3009,0,'LSQ12ftd','LSQ',64.2445833333333,-24.1446944444444,NULL,NULL,'2012-11-05 07:31:04',56236.3132500001,19.473,0.1122,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_69566.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3438,3009,0,'LSQ12ftd','LSQ',64.244625,-24.1446944444444,NULL,NULL,'2012-11-05 07:44:59',56236.3229100001,18.6105,0.1029,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_69564.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3439,3013,0,'LSQ12ftc','LSQ',64.8030833333333,-24.3552777777778,NULL,NULL,'2012-11-05 06:12:18',56236.2585499999,19.3149,0.1007,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_69567.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3440,3013,0,'LSQ12ftc','LSQ',64.802875,-24.3551944444444,NULL,NULL,'2012-11-05 06:14:00',56236.25973,19.1807,0.0849,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_69569.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3441,3013,0,'LSQ12ftc','LSQ',64.8028333333333,-24.3551388888889,NULL,NULL,'2012-11-05 07:31:04',56236.3132500001,19.0797,0.0974,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_69570.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3442,3013,0,'LSQ12ftc','LSQ',64.8031666666667,-24.3553055555556,NULL,NULL,'2012-11-05 07:44:59',56236.3229100001,19.333,0.0968,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_69568.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3443,3017,0,'LSQ12ftb','LSQ',65.4214583333333,-23.7053611111111,NULL,NULL,'2012-11-05 06:12:18',56236.2585499999,18.0957,0.0651,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_69593.gif',37314276031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3444,3017,0,'LSQ12ftb','LSQ',65.422,-23.7052222222222,NULL,NULL,'2012-11-05 06:14:00',56236.25973,18.2955,0.0517,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_69595.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3445,3017,0,'LSQ12ftb','LSQ',65.4220416666667,-23.70525,NULL,NULL,'2012-11-05 07:31:04',56236.3132500001,18.3875,0.0494,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_69596.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3446,3017,0,'LSQ12ftb','LSQ',65.4214166666667,-23.7053888888889,NULL,NULL,'2012-11-05 07:44:59',56236.3229100001,17.597,0.0515,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_69594.gif',37314276031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3447,3021,0,'LSQ12fta','LSQ',353.338833333333,-33.0116666666667,NULL,NULL,'2012-11-05 00:50:06',56236.0348,17.9265,0.0245,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fta/LSQ12fta_history.html','AGN?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fta/LSQ12fta_snap_69571.gif',50174717533,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,783979961,12249686,NULL,NULL,NULL,NULL),(3448,3021,0,'LSQ12fta','LSQ',353.33875,-33.0116388888889,NULL,NULL,'2012-11-05 02:51:31',56236.1191199999,17.4718,0.0235,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fta/LSQ12fta_history.html','AGN?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fta/LSQ12fta_snap_69572.gif',50174717533,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,783979961,12249686,NULL,NULL,NULL,NULL),(3449,3110,0,'LSQ12fvw','LSQ',43.00175,-25.54225,NULL,NULL,'2012-11-05 05:55:26',56236.2468400002,18.6195,0.1117,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvw/LSQ12fvw_history.html','sn - nice',NULL,0.1101,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvw/LSQ12fvw_snap_69471.gif',38420117951,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600314342,9379911,NULL,NULL,NULL,NULL),(3450,3110,0,'LSQ12fvw','LSQ',43.00175,-25.5421666666667,NULL,NULL,'2012-11-05 07:55:17',56236.3300600001,18.7363,0.0852,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvw/LSQ12fvw_history.html','sn - nice',NULL,0.1101,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvw/LSQ12fvw_snap_69472.gif',38420117951,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600314342,9379911,NULL,NULL,NULL,NULL),(3451,3112,0,'LSQ12fvu','LSQ',53.5190416666667,-21.8744444444444,NULL,NULL,'2012-11-05 06:03:53',56236.2527000001,18.9875,0.0672,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_69465.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(3452,3112,0,'LSQ12fvu','LSQ',53.5190833333333,-21.8744444444444,NULL,NULL,'2012-11-05 07:50:04',56236.32644,19.2575,0.0909,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_69466.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(3453,3118,0,'LSQ12fvp','LSQ',10.7101666666667,-34.1603333333333,NULL,NULL,'2012-11-05 01:54:35',56236.0795800001,17.3076,0.0404,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_69483.gif',34872963970,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(3454,3118,0,'LSQ12fvp','LSQ',10.710125,-34.1603333333333,NULL,NULL,'2012-11-05 04:11:34',56236.1747099999,17.0781,0.0365,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_69484.gif',34872963970,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(3455,3122,0,'LSQ12fvn','LSQ',16.391875,-35.49075,NULL,NULL,'2012-11-05 02:30:52',56236.1047700001,19.8033,0.0532,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_69508.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(3456,3122,0,'LSQ12fvn','LSQ',16.3919583333333,-35.4907222222222,NULL,NULL,'2012-11-05 04:32:56',56236.1895400002,19.7718,0.0829,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_69509.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(3457,3125,0,'LSQ12fvl','LSQ',75.2085,-38.6531666666667,NULL,NULL,'2012-11-05 04:56:57',56236.2062200001,18.0428,0.047,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_69498.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(3458,3125,0,'LSQ12fvl','LSQ',75.2085416666667,-38.6531388888889,NULL,NULL,'2012-11-05 08:26:32',56236.3517700001,17.9836,0.0495,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_69499.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(3459,3214,0,'LSQ12fvs','LSQ',358.452125,-32.06,NULL,NULL,'2012-11-05 01:05:25',56236.0454299999,18.4728,0.0782,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_history.html','sne?',NULL,0.0606,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_snap_69511.gif',50033234904,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781769295,12215145,NULL,NULL,NULL,NULL),(3460,3214,0,'LSQ12fvs','LSQ',358.452125,-32.06,NULL,NULL,'2012-11-05 03:06:46',56236.1296999999,18.3669,0.0655,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_history.html','sne?',NULL,0.0606,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_snap_69512.gif',50033234904,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781769295,12215145,NULL,NULL,NULL,NULL),(3461,3229,0,'LSQ12fvk','LSQ',0.974458333333333,-36.1123055555556,NULL,NULL,'2012-11-05 03:21:48',56236.1401399998,20.5787,0.1822,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_history.html','sne?',NULL,0.07307,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_snap_69477.gif',34677267107,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541832298,8466129,NULL,NULL,NULL,NULL),(3462,3234,0,'LSQ12fwu','LSQ',357.6745,-37.2143055555556,NULL,NULL,'2012-11-05 01:13:42',56236.05119,20.0304,0.1545,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_snap_69452.gif',49956994282,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,780578035,12196531,NULL,NULL,NULL,NULL),(3463,3234,0,'LSQ12fwu','LSQ',357.674625,-37.2143055555556,NULL,NULL,'2012-11-05 03:15:02',56236.1354499999,19.9212,0.1591,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_snap_69453.gif',49956994282,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,780578035,12196531,NULL,NULL,NULL,NULL),(3464,3237,0,'LSQ12fwt','LSQ',54.0465416666667,-37.4260277777778,NULL,NULL,'2012-11-05 04:43:26',56236.1968399999,19.3216,0.0718,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_69457.gif',38589273853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(3465,3237,0,'LSQ12fwt','LSQ',54.0464166666667,-37.4259722222222,NULL,NULL,'2012-11-05 06:45:18',56236.2814600002,19.5486,0.0885,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_69458.gif',38589273853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(3467,3245,0,'LSQ12fwz','LSQ',21.2805,-26.1291388888889,NULL,NULL,'2012-11-05 06:26:33',56236.2684399998,18.8753,0.0929,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_69463.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(3468,3245,0,'LSQ12fwz','LSQ',21.2805,-26.1291666666667,NULL,NULL,'2012-11-05 06:29:56',56236.27079,18.7561,0.0739,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_69464.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(3469,3249,0,'LSQ12fww','LSQ',62.5344583333333,-34.1650555555556,NULL,NULL,'2012-11-05 08:16:07',56236.3445299999,18.8407,0.0526,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_69475.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(3470,3253,0,'LSQ12fxj','LSQ',75.1703333333333,-25.9278611111111,NULL,NULL,'2012-11-05 05:50:02',56236.24309,18.4899,0.0569,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_snap_69490.gif',37225960888,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581655638,9088369,NULL,NULL,NULL,NULL),(3471,3253,0,'LSQ12fxj','LSQ',75.1702916666667,-25.9278611111111,NULL,NULL,'2012-11-05 07:57:13',56236.3314100001,18.5836,0.0591,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_snap_69491.gif',37225960888,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581655638,9088369,NULL,NULL,NULL,NULL),(3472,3284,0,'LSQ12fxk','LSQ',57.9454166666667,-22.1760555555556,NULL,NULL,'2012-11-05 06:07:16',56236.2550499998,19.2632,0.1852,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_snap_69488.gif',37996998851,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593703107,9276611,NULL,NULL,NULL,NULL),(3473,3284,0,'LSQ12fxk','LSQ',57.9454166666667,-22.176,NULL,NULL,'2012-11-05 07:27:41',56236.3108999999,19.0581,0.1819,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_snap_69489.gif',37996998851,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593703107,9276611,NULL,NULL,NULL,NULL),(3474,3287,0,'LSQ12fxc','LSQ',47.815625,-22.4541388888889,NULL,NULL,'2012-11-05 07:24:15',56236.3085099999,19.2274,0.1531,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_69460.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(3475,3293,0,'LSQ12fxa','LSQ',358.600083333333,-30.1613611111111,NULL,NULL,'2012-11-05 01:15:23',56236.0523600001,20.5824,0.1474,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxa/LSQ12fxa_history.html','agn?',NULL,0.1428,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxa/LSQ12fxa_snap_69476.gif',50044826551,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781950414,12217975,NULL,NULL,NULL,NULL),(3476,3295,0,'LSQ12fwx','LSQ',359.541625,-29.7362222222222,NULL,NULL,'2012-11-05 01:25:45',56236.05956,19.5579,0.0689,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_history.html','sne - nice',NULL,0.0972,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_snap_69467.gif',50036319036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781817484,12215898,NULL,NULL,NULL,NULL),(3477,3295,0,'LSQ12fwx','LSQ',359.541541666667,-29.7360833333333,NULL,NULL,'2012-11-05 03:27:01',56236.14377,19.7956,0.0803,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_history.html','sne - nice',NULL,0.0972,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_snap_69468.gif',50036319036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781817484,12215898,NULL,NULL,NULL,NULL),(3478,3478,1,'LSQ12fxn','LSQ',53.6279166666667,-27.3571111111111,NULL,NULL,'2012-11-02 01:23:33',56233.05803,20.1968,0.146,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxn/LSQ12fxn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxn/LSQ12fxn_snap_69279.gif',38580994895,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602828045,9419188,NULL,NULL,NULL,NULL),(3479,3478,0,'LSQ12fxn','LSQ',53.6284166666667,-27.357,NULL,NULL,'2012-11-04 01:12:38',56235.0504399999,19.7529,0.0963,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxn/LSQ12fxn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxn/LSQ12fxn_snap_69189.gif',38580994894,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602828045,9419188,NULL,NULL,NULL,NULL),(3480,3478,0,'LSQ12fxn','LSQ',53.6284166666667,-27.3569722222222,NULL,NULL,'2012-11-04 03:12:59',56235.1340200002,20.3752,0.123,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 16:45:44','2012-11-05 16:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxn/LSQ12fxn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxn/LSQ12fxn_snap_69190.gif',38580994894,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602828045,9419188,NULL,NULL,NULL,NULL),(3481,3481,1,'LSQ12fzc','LSQ',43.0447083333333,-35.9739166666667,NULL,NULL,'2012-11-03 04:14:32',56234.1767600002,17.7532,0.069,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 17:45:45','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_69392.gif',38652782971,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(3482,3481,0,'LSQ12fzc','LSQ',43.0447083333333,-35.9737777777778,NULL,NULL,'2012-11-03 06:15:13',56234.2605699999,18.3932,0.0918,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 17:45:45','2012-11-05 17:45:45','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_69393.gif',38652782971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(3483,3481,0,'LSQ12fzc','LSQ',43.04475,-35.9738055555556,NULL,NULL,'2012-11-05 04:34:58',56236.1909599998,17.5915,0.0611,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 17:45:45','2012-11-05 17:45:45','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_69362.gif',38652782971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(3484,3481,0,'LSQ12fzc','LSQ',43.04475,-35.9737777777778,NULL,NULL,'2012-11-05 06:36:50',56236.2755900002,18.0479,0.0833,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 17:45:45','2012-11-05 17:45:45','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_69363.gif',38652782971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(3485,3485,1,'LSQ12gbj','LSQ',66.047625,-25.4150555555556,NULL,NULL,'2012-10-26 07:43:25',56226.3218200002,19.4028,0.095,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_snap_69832.gif',37181674004,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,580963656,9077557,NULL,NULL,NULL,NULL),(3486,3485,0,'LSQ12gbj','LSQ',66.0475833333333,-25.4151111111111,NULL,NULL,'2012-11-01 07:21:36',56232.3066699998,19.1635,0.1669,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_snap_69833.gif',37181674004,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,580963656,9077557,NULL,NULL,NULL,NULL),(3487,3485,0,'LSQ12gbj','LSQ',66.0475416666667,-25.4151388888889,NULL,NULL,'2012-11-03 07:22:10',56234.3070700001,19.3894,0.1438,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_snap_69834.gif',37181674004,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,580963656,9077557,NULL,NULL,NULL,NULL),(3488,3485,0,'LSQ12gbj','LSQ',66.0475833333333,-25.4151111111111,NULL,NULL,'2012-11-05 06:12:18',56236.2585499999,19.2539,0.1291,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_snap_69718.gif',37181674004,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,580963656,9077557,NULL,NULL,NULL,NULL),(3489,3485,0,'LSQ12gbj','LSQ',66.0475416666667,-25.4151111111111,NULL,NULL,'2012-11-05 07:44:59',56236.3229100001,19.4645,0.1027,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_snap_69719.gif',37181674004,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,580963656,9077557,NULL,NULL,NULL,NULL),(3490,3490,1,'LSQ12gba','LSQ',42.9313333333333,-25.4113055555556,NULL,NULL,'2012-10-26 05:53:38',56226.2455899999,19.3462,0.0969,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gba/LSQ12gba_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gba/LSQ12gba_snap_69813.gif',38420145454,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,600314772,9379918,NULL,NULL,NULL,NULL),(3491,3490,0,'LSQ12gba','LSQ',42.93125,-25.4113611111111,NULL,NULL,'2012-10-26 07:51:52',56226.3276900002,19.0204,0.0907,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gba/LSQ12gba_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gba/LSQ12gba_snap_69814.gif',38420145454,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,600314772,9379918,NULL,NULL,NULL,NULL),(3492,3490,0,'LSQ12gba','LSQ',42.9312083333333,-25.4113611111111,NULL,NULL,'2012-11-01 05:34:14',56232.2321100002,19.5043,0.1229,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gba/LSQ12gba_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gba/LSQ12gba_snap_69815.gif',38420145454,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,600314772,9379918,NULL,NULL,NULL,NULL),(3493,3490,0,'LSQ12gba','LSQ',42.93125,-25.4113333333333,NULL,NULL,'2012-11-03 05:36:06',56234.2334099999,19.5571,0.1335,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gba/LSQ12gba_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gba/LSQ12gba_snap_69816.gif',38420145454,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,600314772,9379918,NULL,NULL,NULL,NULL),(3494,3490,0,'LSQ12gba','LSQ',42.9312916666667,-25.4114166666667,NULL,NULL,'2012-11-03 07:42:30',56234.32119,19.7067,0.1867,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gba/LSQ12gba_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gba/LSQ12gba_snap_69817.gif',38420145454,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,600314772,9379918,NULL,NULL,NULL,NULL),(3495,3490,0,'LSQ12gba','LSQ',42.93125,-25.4113888888889,NULL,NULL,'2012-11-05 05:55:26',56236.2468400002,19.5739,0.1676,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gba/LSQ12gba_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gba/LSQ12gba_snap_69700.gif',38420145454,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,600314772,9379918,NULL,NULL,NULL,NULL),(3496,3490,0,'LSQ12gba','LSQ',42.9312916666667,-25.4113611111111,NULL,NULL,'2012-11-05 07:55:17',56236.3300600001,19.9625,0.1207,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gba/LSQ12gba_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gba/LSQ12gba_snap_69701.gif',38420145454,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,600314772,9379918,NULL,NULL,NULL,NULL),(3497,3497,1,'LSQ12gay','LSQ',22.6860416666667,-24.5999722222222,NULL,NULL,'2012-11-01 02:04:39',56232.0865699998,19.3196,0.1271,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_snap_69809.gif',34701767715,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,542215120,8472111,NULL,NULL,NULL,NULL),(3498,3497,0,'LSQ12gay','LSQ',22.6860416666667,-24.6000833333333,NULL,NULL,'2012-11-01 04:06:38',56232.1712799999,18.9389,0.0983,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_snap_69810.gif',34701767715,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,542215120,8472111,NULL,NULL,NULL,NULL),(3499,3497,0,'LSQ12gay','LSQ',22.686125,-24.5998888888889,NULL,NULL,'2012-11-03 02:05:45',56234.08733,19.3984,0.0809,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_snap_69811.gif',34701767715,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,542215120,8472111,NULL,NULL,NULL,NULL),(3500,3497,0,'LSQ12gay','LSQ',22.686125,-24.5999722222222,NULL,NULL,'2012-11-05 06:33:19',56236.2731400002,19.5047,0.1246,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_snap_69696.gif',34701767715,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,542215120,8472111,NULL,NULL,NULL,NULL),(3501,3497,0,'LSQ12gay','LSQ',22.6860833333333,-24.6,NULL,NULL,'2012-11-05 07:01:05',56236.2924299999,19.338,0.1136,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_snap_69697.gif',34701767715,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,542215120,8472111,NULL,NULL,NULL,NULL),(3502,3502,1,'LSQ12gav','LSQ',355.827666666667,-24.8746388888889,NULL,NULL,'2012-11-01 02:42:20',56232.1127399998,19.5503,0.1854,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_snap_69802.gif',50001954988,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781280546,12207508,NULL,NULL,NULL,NULL),(3503,3502,0,'LSQ12gav','LSQ',355.82775,-24.8745833333333,NULL,NULL,'2012-11-03 00:41:03',56234.0285100001,19.9221,0.1133,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_snap_69803.gif',50001954991,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781280546,12207508,NULL,NULL,NULL,NULL),(3504,3502,0,'LSQ12gav','LSQ',355.827666666667,-24.8746111111111,NULL,NULL,'2012-11-03 02:43:21',56234.11344,19.912,0.1638,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_snap_69804.gif',50001954988,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781280546,12207508,NULL,NULL,NULL,NULL),(3505,3502,0,'LSQ12gav','LSQ',355.827666666667,-24.8746111111111,NULL,NULL,'2012-11-05 01:02:02',56236.0430800002,19.7605,0.1028,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_snap_69690.gif',50001954988,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781280546,12207508,NULL,NULL,NULL,NULL),(3506,3502,0,'LSQ12gav','LSQ',355.827666666667,-24.8745833333333,NULL,NULL,'2012-11-05 03:03:23',56236.1273500002,19.7257,0.1443,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_snap_69691.gif',50001954988,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781280546,12207508,NULL,NULL,NULL,NULL),(3507,3507,1,'LSQ12gas','LSQ',79.6800416666667,-24.4505277777778,NULL,NULL,'2012-10-26 08:11:12',56226.34112,19.5855,0.0792,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gas/LSQ12gas_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gas/LSQ12gas_snap_69775.gif',37130798399,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,580168724,9065136,NULL,NULL,NULL,NULL),(3508,3507,0,'LSQ12gas','LSQ',79.68025,-24.4505833333333,NULL,NULL,'2012-10-26 08:36:29',56226.35867,20.8685,0.1784,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gas/LSQ12gas_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gas/LSQ12gas_snap_69776.gif',37130798396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,580168724,9065136,NULL,NULL,NULL,NULL),(3509,3507,0,'LSQ12gas','LSQ',79.68,-24.4505555555556,NULL,NULL,'2012-11-01 06:02:57',56232.2520599999,19.6161,0.1714,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gas/LSQ12gas_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gas/LSQ12gas_snap_69777.gif',37130798399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,580168724,9065136,NULL,NULL,NULL,NULL),(3510,3507,0,'LSQ12gas','LSQ',79.680125,-24.4505277777778,NULL,NULL,'2012-11-03 06:05:37',56234.25391,19.3402,0.1676,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gas/LSQ12gas_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gas/LSQ12gas_snap_69778.gif',37130798399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,580168724,9065136,NULL,NULL,NULL,NULL),(3511,3507,0,'LSQ12gas','LSQ',79.68,-24.4505277777778,NULL,NULL,'2012-11-03 07:29:00',56234.3118099999,19.4489,0.1637,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gas/LSQ12gas_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gas/LSQ12gas_snap_69779.gif',37130798399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,580168724,9065136,NULL,NULL,NULL,NULL),(3512,3507,0,'LSQ12gas','LSQ',79.68,-24.4506111111111,NULL,NULL,'2012-11-05 06:24:08',56236.2667700001,19.6514,0.1601,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gas/LSQ12gas_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gas/LSQ12gas_snap_69684.gif',37130798399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,580168724,9065136,NULL,NULL,NULL,NULL),(3513,3507,0,'LSQ12gas','LSQ',79.6800833333333,-24.4505277777778,NULL,NULL,'2012-11-05 07:36:09',56236.31678,19.9077,0.1409,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gas/LSQ12gas_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gas/LSQ12gas_snap_69685.gif',37130798399,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,580168724,9065136,NULL,NULL,NULL,NULL),(3514,3514,1,'LSQ12gaq','LSQ',65.3837916666667,-25.3801944444444,NULL,NULL,'2012-11-03 07:23:51',56234.3082400002,20.065,0.2065,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_snap_69806.gif',37182103829,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580970372,9077662,NULL,NULL,NULL,NULL),(3515,3514,0,'LSQ12gaq','LSQ',65.383875,-25.3801944444444,NULL,NULL,'2012-11-05 06:14:00',56236.25973,20.1331,0.147,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_snap_69680.gif',37182103829,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580970372,9077662,NULL,NULL,NULL,NULL),(3516,3514,0,'LSQ12gaq','LSQ',65.384,-25.3801111111111,NULL,NULL,'2012-11-05 07:31:04',56236.3132500001,19.8453,0.123,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_snap_69681.gif',37182103829,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580970372,9077662,NULL,NULL,NULL,NULL),(3517,3517,1,'LSQ12gap','LSQ',66.2457083333333,-25.18425,NULL,NULL,'2012-11-03 07:22:10',56234.3070700001,19.9633,0.1714,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gap/LSQ12gap_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gap/LSQ12gap_snap_69805.gif',37181152649,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,580955510,9077429,NULL,NULL,NULL,NULL),(3518,3517,0,'LSQ12gap','LSQ',66.2455833333333,-25.1843333333333,NULL,NULL,'2012-11-05 06:12:18',56236.2585499999,19.9149,0.1389,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gap/LSQ12gap_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gap/LSQ12gap_snap_69678.gif',37181152649,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,580955510,9077429,NULL,NULL,NULL,NULL),(3519,3517,0,'LSQ12gap','LSQ',66.245625,-25.1845555555556,NULL,NULL,'2012-11-05 07:44:59',56236.3229100001,19.8077,0.1631,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gap/LSQ12gap_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gap/LSQ12gap_snap_69679.gif',37181152649,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,580955510,9077429,NULL,NULL,NULL,NULL),(3520,3520,1,'LSQ12gak','LSQ',21.5754166666667,-23.3501666666667,NULL,NULL,'2012-10-25 06:20:32',56225.2642700002,19.7726,0.1713,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_snap_69771.gif',35177372187,NULL,NULL,NULL,'2012-10-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549646440,8588225,NULL,NULL,NULL,NULL),(3521,3520,0,'LSQ12gak','LSQ',21.5754583333333,-23.3503055555556,NULL,NULL,'2012-11-01 04:08:19',56232.17245,19.4238,0.1452,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_snap_69772.gif',35177372187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549646440,8588225,NULL,NULL,NULL,NULL),(3522,3520,0,'LSQ12gak','LSQ',21.5754166666667,-23.3501944444444,NULL,NULL,'2012-11-05 06:31:38',56236.2719700001,19.1073,0.1247,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_snap_69668.gif',35177372187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549646440,8588225,NULL,NULL,NULL,NULL),(3523,3520,0,'LSQ12gak','LSQ',21.5755,-23.3501666666667,NULL,NULL,'2012-11-05 06:35:01',56236.2743199999,19.262,0.1502,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_snap_69669.gif',35177372187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549646440,8588225,NULL,NULL,NULL,NULL),(3524,3524,1,'LSQ12gaf','LSQ',350.60125,-33.102,NULL,NULL,'2012-11-01 00:25:09',56232.0174699998,19.9304,0.1159,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaf/LSQ12gaf_history.html','sne - nice',NULL,0.1716,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaf/LSQ12gaf_snap_69759.gif',50183258630,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784113416,12251772,NULL,NULL,NULL,NULL),(3525,3524,0,'LSQ12gaf','LSQ',350.601166666667,-33.1020277777778,NULL,NULL,'2012-11-01 02:27:05',56232.1021500002,20.0757,0.2004,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaf/LSQ12gaf_history.html','sne - nice',NULL,0.1716,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaf/LSQ12gaf_snap_69760.gif',50183258630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784113416,12251772,NULL,NULL,NULL,NULL),(3526,3524,0,'LSQ12gaf','LSQ',350.601208333333,-33.1020277777778,NULL,NULL,'2012-11-03 00:25:44',56234.0178800002,20.3148,0.1744,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaf/LSQ12gaf_history.html','sne - nice',NULL,0.1716,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaf/LSQ12gaf_snap_69761.gif',50183258630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784113416,12251772,NULL,NULL,NULL,NULL),(3527,3524,0,'LSQ12gaf','LSQ',350.60125,-33.1019722222222,NULL,NULL,'2012-11-03 02:28:06',56234.1028499999,20.0589,0.1323,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaf/LSQ12gaf_history.html','sne - nice',NULL,0.1716,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaf/LSQ12gaf_snap_69762.gif',50183258630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784113416,12251772,NULL,NULL,NULL,NULL),(3528,3524,0,'LSQ12gaf','LSQ',350.601166666667,-33.1019444444444,NULL,NULL,'2012-11-05 00:50:06',56236.0348,19.9898,0.1347,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaf/LSQ12gaf_history.html','sne - nice',NULL,0.1716,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaf/LSQ12gaf_snap_69658.gif',50183258638,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784113416,12251772,NULL,NULL,NULL,NULL),(3529,3524,0,'LSQ12gaf','LSQ',350.601208333333,-33.1019722222222,NULL,NULL,'2012-11-05 02:51:31',56236.1191199999,19.9261,0.1298,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaf/LSQ12gaf_history.html','sne - nice',NULL,0.1716,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaf/LSQ12gaf_snap_69659.gif',50183258630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784113416,12251772,NULL,NULL,NULL,NULL),(3530,3530,1,'LSQ12gad','LSQ',52.302125,-30.6227777777778,NULL,NULL,'2012-10-25 05:42:20',56225.2377399998,19.736,0.1355,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_69754.gif',38573258241,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(3531,3530,0,'LSQ12gad','LSQ',52.30225,-30.6235833333333,NULL,NULL,'2012-10-26 06:55:24',56226.2884800001,19.7658,0.1547,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_69755.gif',38573253890,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707092,9417298,NULL,NULL,NULL,NULL),(3532,3530,0,'LSQ12gad','LSQ',52.302,-30.6228611111111,NULL,NULL,'2012-11-01 04:47:43',56232.1998100001,18.3403,0.0844,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_69756.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(3533,3530,0,'LSQ12gad','LSQ',52.3021666666667,-30.6229444444444,NULL,NULL,'2012-11-01 06:48:43',56232.2838400002,19.1259,0.1128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_69757.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(3534,3530,0,'LSQ12gad','LSQ',52.3022083333333,-30.6229722222222,NULL,NULL,'2012-11-03 06:49:28',56234.2843599999,18.9216,0.1009,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_69758.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(3535,3530,0,'LSQ12gad','LSQ',52.302,-30.6229166666667,NULL,NULL,'2012-11-05 05:09:10',56236.2146999999,18.7109,0.0849,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_69654.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(3536,3530,0,'LSQ12gad','LSQ',52.3020416666667,-30.6228611111111,NULL,NULL,'2012-11-05 06:59:06',56236.2910500001,18.7041,0.1019,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_69655.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(3537,3537,1,'LSQ12gab','LSQ',81.8937083333333,-31.3135277777778,NULL,NULL,'2012-11-03 06:59:37',56234.2914100001,17.6245,0.0765,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_snap_69747.gif',37311362015,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,582990031,9109219,NULL,NULL,NULL,NULL),(3538,3537,0,'LSQ12gab','LSQ',81.8940833333333,-31.3133611111111,NULL,NULL,'2012-11-05 05:29:24',56236.2287599999,18.4362,0.0885,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_snap_69648.gif',37311362015,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,582990031,9109219,NULL,NULL,NULL,NULL),(3539,3537,0,'LSQ12gab','LSQ',81.8938333333333,-31.3133888888889,NULL,NULL,'2012-11-05 08:07:39',56236.3386499998,19.0868,0.1225,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_snap_69649.gif',37311362015,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,582990031,9109219,NULL,NULL,NULL,NULL),(3540,3540,1,'LSQ12fzz','LSQ',81.49325,-34.4572222222222,NULL,NULL,'2012-11-03 05:07:29',56234.2135399999,13.9006,0.0023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_69750.gif',37267383653,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(3541,3540,0,'LSQ12fzz','LSQ',81.4931666666667,-34.45725,NULL,NULL,'2012-11-03 05:09:11',56234.21472,13.9711,0.0022,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_69752.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(3542,3540,0,'LSQ12fzz','LSQ',81.4931666666667,-34.45725,NULL,NULL,'2012-11-03 06:59:37',56234.2914100001,13.9968,0.0024,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_69753.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(3543,3540,0,'LSQ12fzz','LSQ',81.4932916666667,-34.4572222222222,NULL,NULL,'2012-11-03 07:57:32',56234.3316299999,13.9508,0.0023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_69751.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(3544,3540,0,'LSQ12fzz','LSQ',81.49325,-34.4572222222222,NULL,NULL,'2012-11-05 05:27:42',56236.2275800002,15.7615,0.0091,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_69644.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(3545,3540,0,'LSQ12fzz','LSQ',81.4932083333333,-34.4572777777778,NULL,NULL,'2012-11-05 05:29:24',56236.2287599999,15.8354,0.0083,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_69650.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(3546,3540,0,'LSQ12fzz','LSQ',81.4932083333333,-34.4572777777778,NULL,NULL,'2012-11-05 08:07:39',56236.3386499998,15.9112,0.0088,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_69651.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(3547,3540,0,'LSQ12fzz','LSQ',81.4932916666667,-34.4572222222222,NULL,NULL,'2012-11-05 08:09:21',56236.33983,15.8395,0.0092,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_69645.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(3548,3548,1,'LSQ12fzu','LSQ',74.8827916666667,-38.40925,NULL,NULL,'2012-11-03 04:34:52',56234.1908800001,20.0624,0.2041,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_69742.gif',37599816278,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(3549,3548,0,'LSQ12fzu','LSQ',74.88325,-38.4093333333333,NULL,NULL,'2012-11-05 04:55:16',56236.20505,19.7799,0.1342,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_69634.gif',37599816286,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(3550,3548,0,'LSQ12fzu','LSQ',74.8830833333333,-38.40925,NULL,NULL,'2012-11-05 08:28:14',56236.3529500002,20.1583,0.1617,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_69635.gif',37599816286,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(3551,3551,1,'LSQ12fzr','LSQ',49.1792916666667,-30.2704444444444,NULL,NULL,'2012-11-01 04:42:38',56232.1962799998,19.5272,0.1543,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_69732.gif',38545017983,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(3552,3551,0,'LSQ12fzr','LSQ',49.179375,-30.2703611111111,NULL,NULL,'2012-11-01 06:43:39',56232.2803199999,19.5137,0.1385,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_69733.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(3553,3551,0,'LSQ12fzr','LSQ',49.1793333333333,-30.2704444444444,NULL,NULL,'2012-11-03 06:44:23',56234.2808300001,19.2643,0.122,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_69734.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(3554,3551,0,'LSQ12fzr','LSQ',49.1794166666667,-30.2705,NULL,NULL,'2012-11-05 05:04:05',56236.21117,19.0381,0.0876,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_69628.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(3555,3551,0,'LSQ12fzr','LSQ',49.1793333333333,-30.2704444444444,NULL,NULL,'2012-11-05 08:22:52',56236.3492200002,19.182,0.1061,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 18:45:49','2012-11-05 18:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_69629.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(3556,3112,0,'LSQ12fvu','LSQ',53.5190416667,-21.8744166667,NULL,NULL,'2012-11-05 12:00:00',56236.5,NULL,NULL,NULL,0.11,NULL,'Ia',NULL,'2012-11-05 19:36:47','2012-11-05 19:36:47','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38040994987,'UH 2.2m','SNIFS','SNfactory',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(3557,3557,1,'LSQ12gal','LSQ',42.7885,-25.4052777777778,NULL,NULL,'2012-10-26 05:55:20',56226.24676,18.9574,0.158,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 19:45:48','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gal/LSQ12gal_history.html','sne?',NULL,0.1066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gal/LSQ12gal_snap_69773.gif',38420091451,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313928,9379905,NULL,NULL,NULL,NULL),(3558,3557,0,'LSQ12gal','LSQ',42.7885416666667,-25.4052777777778,NULL,NULL,'2012-11-03 05:37:47',56234.2345799999,19.6889,0.1206,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 19:45:48','2012-11-05 19:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gal/LSQ12gal_history.html','sne?',NULL,0.1066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gal/LSQ12gal_snap_69774.gif',38420091451,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313928,9379905,NULL,NULL,NULL,NULL),(3559,3557,0,'LSQ12gal','LSQ',42.788625,-25.4053888888889,NULL,NULL,'2012-11-05 05:57:08',56236.2480100002,19.3337,0.1593,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 19:45:48','2012-11-05 19:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gal/LSQ12gal_history.html','sne?',NULL,0.1066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gal/LSQ12gal_snap_69670.gif',38420091449,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313928,9379905,NULL,NULL,NULL,NULL),(3560,3557,0,'LSQ12gal','LSQ',42.7885,-25.4053888888889,NULL,NULL,'2012-11-05 07:53:36',56236.32889,19.3228,0.1351,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-05 19:45:48','2012-11-05 19:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gal/LSQ12gal_history.html','sne?',NULL,0.1066,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gal/LSQ12gal_snap_69671.gif',38420091451,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313928,9379905,NULL,NULL,NULL,NULL),(3561,3241,1,'LSQ12fxd','pessto',80.5709583333,-25.5964166667,NULL,NULL,'2012-11-05 00:00:00',56236,NULL,NULL,NULL,0.032,NULL,'Ia',NULL,'2012-11-06 11:26:55','2019-10-11 14:10:04','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37143373844,'NTT','EFOSC','Anderson',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580365216,9068206,NULL,NULL,NULL,NULL),(3562,3562,1,'OGLE-2012-SN-028','OGLE',42.08925,-74.4444444444444,NULL,NULL,'2012-11-06 06:43:11',56237.28,19.7,NULL,NULL,NULL,NULL,NULL,NULL,'2012-11-07 09:18:19','2019-10-11 14:10:04','http://ogle.astrouw.edu.pl/ogle4/transients/transients.html','supernova',NULL,0,NULL,NULL,'http://ogle.astrouw.edu.pl/ogle4/transients/transients.html',NULL,NULL,35601793815,NULL,NULL,NULL,'2012-10-21 06:04:18',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,556278028,8691844,NULL,NULL,NULL,NULL),(3563,3563,1,'OGLE-2012-SN-027','OGLE',23.7968333333333,-73.5935277777778,NULL,NULL,'2012-11-06 16:48:00',56237.7,19.8,NULL,NULL,NULL,NULL,NULL,NULL,'2012-11-07 21:14:02','2019-10-11 14:10:04','http://ogle.astrouw.edu.pl/ogle4/transients/transients.html','supernova',NULL,0,NULL,NULL,'http://ogle.astrouw.edu.pl/ogle4/transients/transients.html',NULL,NULL,35609445495,NULL,NULL,NULL,'2012-07-25 09:14:29',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,556397585,8693712,NULL,NULL,NULL,NULL),(3564,3564,1,'OGLE-2012_SN-029','OGLE',51.3902083333333,-72.7438333333333,NULL,NULL,'2012-11-06 19:40:47',56237.82,19.6,NULL,NULL,NULL,NULL,NULL,NULL,'2012-11-07 20:20:00','2019-10-11 14:10:04','http://ogle.astrouw.edu.pl/ogle4/transients/transients.html','supernova',NULL,0,NULL,NULL,'NULL',NULL,NULL,36410716331,NULL,NULL,NULL,'2012-09-15 07:26:44',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,568917442,8889335,NULL,NULL,NULL,NULL),(3565,2232,0,'LSQ12fik','LSQ',56.765,-10.9835,NULL,NULL,'2012-11-06 05:38:06',56237.2348000002,19.4633,0.1382,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fik/LSQ12fik_snap_69972.gif',37025736046,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578527125,9039486,NULL,NULL,NULL,NULL),(3566,2241,0,'LSQ12fjm','LSQ',69.0454583333333,-5.08180555555556,NULL,NULL,'2012-11-06 06:05:15',56237.2536499999,19.6401,0.1599,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjm/LSQ12fjm_snap_69864.gif',37460190231,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585315472,9145554,NULL,NULL,NULL,NULL),(3567,2580,0,'LSQ12fks','LSQ',65.5735416666667,-6.229,NULL,NULL,'2012-11-06 06:03:34',56237.2524799998,18.3151,0.1019,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_snap_69991.gif',36948141630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577314712,9020542,NULL,NULL,NULL,NULL),(3568,2580,0,'LSQ12fks','LSQ',65.5735833333333,-6.22908333333333,NULL,NULL,'2012-11-06 07:28:05',56237.3111800002,18.309,0.1012,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fks/LSQ12fks_snap_69992.gif',36948141622,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577314712,9020542,NULL,NULL,NULL,NULL),(3569,2900,0,'LSQ12fqb','LSQ',70.8875416666667,-11.9016388888889,NULL,NULL,'2012-11-06 05:48:14',56237.2418399998,20.117,0.21,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_70012.gif',37539441792,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553778,9164902,NULL,NULL,NULL,NULL),(3570,3033,0,'LSQ12fvf','LSQ',7.6175,6.94566666666667,NULL,NULL,'2012-11-06 01:21:48',56237.05681,19.2762,0.0666,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvf/LSQ12fvf_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvf/LSQ12fvf_snap_70014.gif',66839103492,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044360992,16318140,NULL,NULL,NULL,NULL),(3571,3033,0,'LSQ12fvf','LSQ',7.61758333333333,6.94569444444444,NULL,NULL,'2012-11-06 03:21:04',56237.1396400002,19.2312,0.066,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvf/LSQ12fvf_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvf/LSQ12fvf_snap_70015.gif',66839103492,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044360992,16318140,NULL,NULL,NULL,NULL),(3572,3040,0,'LSQ12fuv','LSQ',22.0855,-2.54669444444444,NULL,NULL,'2012-11-06 02:41:30',56237.11216,20.2841,0.1614,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuv/LSQ12fuv_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuv/LSQ12fuv_snap_70001.gif',35234940195,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,550545940,8602280,NULL,NULL,NULL,NULL),(3573,3042,0,'LSQ12fuu','LSQ',358.845791666667,-2.27675,NULL,NULL,'2012-11-06 01:20:06',56237.0556299998,19.7896,0.1312,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuu/LSQ12fuu_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuu/LSQ12fuu_snap_70002.gif',49406604320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,771978192,12062159,NULL,NULL,NULL,NULL),(3574,3047,0,'LSQ12fun','LSQ',355.184791666667,-0.351777777777778,NULL,NULL,'2012-11-06 00:57:42',56237.0400800002,18.9442,0.0615,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fun/LSQ12fun_history.html','sne or asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fun/LSQ12fun_snap_70019.gif',49397192770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,771831137,12059861,NULL,NULL,NULL,NULL),(3575,3047,0,'LSQ12fun','LSQ',355.184875,-0.35175,NULL,NULL,'2012-11-06 03:03:33',56237.1274700002,18.9642,0.0803,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fun/LSQ12fun_history.html','sne or asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fun/LSQ12fun_snap_70020.gif',49397192770,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,771831137,12059861,NULL,NULL,NULL,NULL),(3576,3049,0,'LSQ12fuk','LSQ',74.566125,-16.2994166666667,NULL,NULL,'2012-11-06 05:27:44',56237.2275999999,15.4334,0.0038,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_history.html','sne - bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_snap_69930.gif',37569693502,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587026460,9172288,NULL,NULL,NULL,NULL),(3577,3049,0,'LSQ12fuk','LSQ',74.5661666666667,-16.2994444444444,NULL,NULL,'2012-11-06 08:07:14',56237.3383599999,15.3593,0.005,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_history.html','sne - bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_snap_69931.gif',37569693502,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587026460,9172288,NULL,NULL,NULL,NULL),(3578,3051,0,'LSQ12fui','LSQ',70.9517083333333,-13.3014166666667,NULL,NULL,'2012-11-06 05:26:02',56237.2264200002,18.7456,0.0445,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_snap_69936.gif',37542571140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586602674,9165666,NULL,NULL,NULL,NULL),(3579,3058,0,'LSQ12fuc','LSQ',75.0465416666667,-20.0071111111111,NULL,NULL,'2012-11-06 05:03:44',56237.2109300001,19.6482,0.0686,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_history.html','sne - good',NULL,0.041789,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_snap_69878.gif',37564014385,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586937724,9170901,NULL,NULL,NULL,NULL),(3580,3058,0,'LSQ12fuc','LSQ',75.0464583333333,-20.00725,NULL,NULL,'2012-11-06 08:22:43',56237.3491199999,20.0571,0.1004,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_history.html','sne - good',NULL,0.041789,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_snap_69879.gif',37564014387,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586937724,9170901,NULL,NULL,NULL,NULL),(3581,3060,0,'LSQ12ftz','LSQ',74.7340416666667,-20.32725,NULL,NULL,'2012-11-06 05:02:03',56237.20976,18.7947,0.0583,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_snap_70009.gif',37561880975,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586904390,9170381,NULL,NULL,NULL,NULL),(3582,3064,0,'LSQ12ftr','LSQ',66.67225,-20.9704166666667,NULL,NULL,'2012-11-06 04:48:35',56237.20041,16.8656,0.013,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_history.html','sne or comet',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_snap_69940.gif',37323194914,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583174920,9112108,NULL,NULL,NULL,NULL),(3583,3064,0,'LSQ12ftr','LSQ',66.67225,-20.9703888888889,NULL,NULL,'2012-11-06 06:48:37',56237.2837700001,16.9123,0.0142,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_history.html','sne or comet',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_snap_69941.gif',37323194914,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583174920,9112108,NULL,NULL,NULL,NULL),(3584,3150,0,'LSQ12fvz','LSQ',60.528,-20.3228611111111,NULL,NULL,'2012-11-06 04:37:55',56237.193,19.0344,0.0618,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvz/LSQ12fvz_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvz/LSQ12fvz_snap_69892.gif',36853079254,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575829363,8997333,NULL,NULL,NULL,NULL),(3585,3153,0,'LSQ12fwb','LSQ',6.35504166666667,6.70719444444444,NULL,NULL,'2012-11-06 01:21:48',56237.05681,17.7826,0.0409,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwb/LSQ12fwb_history.html','sne - nice',NULL,0.029834,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwb/LSQ12fwb_snap_69896.gif',66827155915,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044174311,16315223,NULL,NULL,NULL,NULL),(3586,3153,0,'LSQ12fwb','LSQ',6.35508333333333,6.70716666666667,NULL,NULL,'2012-11-06 03:21:04',56237.1396400002,18.75,0.0559,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwb/LSQ12fwb_history.html','sne - nice',NULL,0.029834,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwb/LSQ12fwb_snap_69897.gif',66827155915,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044174311,16315223,NULL,NULL,NULL,NULL),(3587,3270,0,'LSQ12fwi','LSQ',65.3633333333333,-13.9310277777778,NULL,NULL,'2012-11-06 05:22:39',56237.22407,20.2775,0.1716,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwi/LSQ12fwi_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwi/LSQ12fwi_snap_69898.gif',37347679140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583557486,9118085,NULL,NULL,NULL,NULL),(3588,3270,0,'LSQ12fwi','LSQ',65.3631666666667,-13.9311666666667,NULL,NULL,'2012-11-06 07:05:27',56237.2954600002,19.4252,0.1084,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwi/LSQ12fwi_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwi/LSQ12fwi_snap_69899.gif',37347678296,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583557473,9118085,NULL,NULL,NULL,NULL),(3589,3278,0,'LSQ12fwe','LSQ',9.04358333333333,4.86475,NULL,NULL,'2012-11-06 01:37:23',56237.0676299999,19.62,0.0793,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwe/LSQ12fwe_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwe/LSQ12fwe_snap_69894.gif',66820332832,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044067700,16313557,NULL,NULL,NULL,NULL),(3590,3278,0,'LSQ12fwe','LSQ',9.04366666666667,4.86469444444444,NULL,NULL,'2012-11-06 03:36:32',56237.15038,19.5167,0.0786,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwe/LSQ12fwe_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwe/LSQ12fwe_snap_69895.gif',66820332832,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044067700,16313557,NULL,NULL,NULL,NULL),(3591,3281,0,'LSQ12fwd','LSQ',56.3923333333333,-0.35725,NULL,NULL,'2012-11-06 06:10:17',56237.25715,18.7724,0.1208,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_history.html','agn?',NULL,0.10854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_snap_69910.gif',36993805999,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578028218,9031690,NULL,NULL,NULL,NULL),(3592,3346,0,'LSQ12fzb','LSQ',34.17725,20.6692777777778,NULL,NULL,'2012-11-06 02:05:46',56237.0873400001,19.7394,0.0963,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzb/LSQ12fzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzb/LSQ12fzb_snap_69886.gif',68109800746,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1064215636,16628369,NULL,NULL,NULL,NULL),(3593,3348,0,'LSQ12fza','LSQ',34.8935833333333,21.2726388888889,NULL,NULL,'2012-11-06 02:05:46',56237.0873400001,20.1199,0.1252,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fza/LSQ12fza_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fza/LSQ12fza_snap_69921.gif',68112332845,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1064255200,16628987,NULL,NULL,NULL,NULL),(3594,3350,0,'LSQ12fyy','LSQ',24.3759583333333,16.6956666666667,NULL,NULL,'2012-11-06 01:52:58',56237.0784499999,19.3471,0.0866,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_snap_69890.gif',67419126541,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1053423852,16459747,NULL,NULL,NULL,NULL),(3595,3350,0,'LSQ12fyy','LSQ',24.3754166666667,16.6955555555556,NULL,NULL,'2012-11-06 03:53:08',56237.1619000002,19.8108,0.1208,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_snap_69891.gif',67419126530,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1053423852,16459747,NULL,NULL,NULL,NULL),(3596,3353,0,'LSQ12fyw','LSQ',5.83779166666667,10.2636944444444,NULL,NULL,'2012-11-06 00:59:24',56237.0412599999,20.6586,0.1428,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyw/LSQ12fyw_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyw/LSQ12fyw_snap_69905.gif',66832336198,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044255253,16316488,NULL,NULL,NULL,NULL),(3597,3359,0,'LSQ12fyt','LSQ',8.57358333333333,4.16277777777778,NULL,NULL,'2012-11-06 01:35:41',56237.0664499998,20.2768,0.1225,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_snap_69888.gif',66821045461,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044078835,16313731,NULL,NULL,NULL,NULL),(3598,3359,0,'LSQ12fyt','LSQ',8.5735,4.16272222222222,NULL,NULL,'2012-11-06 03:34:51',56237.1492099999,20.1337,0.1173,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_snap_69889.gif',66821045461,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044078835,16313731,NULL,NULL,NULL,NULL),(3599,3378,0,'LSQ12fyf','LSQ',63.8234583333333,-7.06955555555556,NULL,NULL,'2012-11-06 06:03:34',56237.2524799998,18.6698,0.1369,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_snap_69876.gif',36956960238,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577452503,9022695,NULL,NULL,NULL,NULL),(3600,3378,0,'LSQ12fyf','LSQ',63.8233333333333,-7.06955555555556,NULL,NULL,'2012-11-06 07:28:05',56237.3111800002,18.7013,0.2051,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_snap_69877.gif',36956960238,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577452503,9022695,NULL,NULL,NULL,NULL),(3601,3380,0,'LSQ12fye','LSQ',62.7185,-4.92311111111111,NULL,NULL,'2012-11-06 06:00:08',56237.2500999998,18.0838,0.1032,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_69873.gif',36961736785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(3602,3380,0,'LSQ12fye','LSQ',62.7185416666667,-4.92311111111111,NULL,NULL,'2012-11-06 07:24:19',56237.3085599998,18.1707,0.1771,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_69874.gif',36961736785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(3603,3386,0,'LSQ12fyb','LSQ',53.6892083333333,-3.73858333333333,NULL,NULL,'2012-11-06 05:53:24',56237.2454200001,20.1715,0.19,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_69880.gif',36820699952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(3604,3401,0,'LSQ12fxx','LSQ',51.1459166666667,-10.1414166666667,NULL,NULL,'2012-11-06 05:33:02',56237.2312799999,17.9636,0.049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxx/LSQ12fxx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxx/LSQ12fxx_snap_69946.gif',37884403751,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591943808,9249122,NULL,NULL,NULL,NULL),(3605,3405,0,'LSQ12fxv','LSQ',358.932333333333,-12.6411944444444,NULL,NULL,'2012-11-06 01:45:52',56237.0735300002,20.0775,0.1792,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_snap_69868.gif',49546365664,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,774161963,12096280,NULL,NULL,NULL,NULL),(3606,3405,0,'LSQ12fxv','LSQ',358.932291666667,-12.6412222222222,NULL,NULL,'2012-11-06 03:47:38',56237.15809,20.273,0.1533,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_snap_69869.gif',49546365664,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,774161963,12096280,NULL,NULL,NULL,NULL),(3607,3409,0,'LSQ12fxu','LSQ',356.792125,-13.2494166666667,NULL,NULL,'2012-11-06 01:30:27',56237.0628200001,17.7373,0.0764,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_snap_69902.gif',49549307030,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,774207922,12096998,NULL,NULL,NULL,NULL),(3608,3409,0,'LSQ12fxu','LSQ',356.792208333333,-13.2493333333333,NULL,NULL,'2012-11-06 03:29:46',56237.1456800001,18.159,0.0771,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-07 23:45:49','2012-11-07 23:45:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_snap_69903.gif',49549307031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,774207922,12096998,NULL,NULL,NULL,NULL),(3609,2815,0,'LSQ12fom','LSQ',347.119291666667,-21.6681666666667,NULL,NULL,'2012-11-07 02:45:00',56238.1145899999,19.9313,0.1597,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fom/LSQ12fom_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fom/LSQ12fom_snap_70167.gif',50300598676,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,785946854,12280419,NULL,NULL,NULL,NULL),(3610,3160,0,'LSQ12frr','LSQ',351.378666666667,-30.1273611111111,NULL,NULL,'2012-11-07 00:39:18',56238.0273000002,18.0974,0.0331,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_history.html','sne hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_snap_70166.gif',50188188166,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,784190440,12252975,NULL,NULL,NULL,NULL),(3611,2987,0,'LSQ12fsj','LSQ',73.72925,-36.3250277777778,NULL,NULL,'2012-11-07 05:26:26',56238.2267,16.1078,0.0041,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_70196.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(3612,2987,0,'LSQ12fsj','LSQ',73.72925,-36.3250277777778,NULL,NULL,'2012-11-07 07:07:03',56238.2965699998,16.0981,0.0044,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_70197.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(3613,2991,0,'LSQ12fsi','LSQ',1.50466666666667,-35.1925277777778,NULL,NULL,'2012-11-07 01:50:37',56238.0768200001,20.1002,0.1523,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_history.html','Old',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_snap_70198.gif',34665129379,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,541642646,8463166,NULL,NULL,NULL,NULL),(3614,3001,0,'LSQ12fth','LSQ',47.82275,-25.1096111111111,NULL,NULL,'2012-11-07 06:38:19',56238.2766200001,17.8782,0.0288,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_70180.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3615,3001,0,'LSQ12fth','LSQ',47.8225833333333,-25.1097222222222,NULL,NULL,'2012-11-07 06:40:01',56238.2777900002,18.1849,0.0327,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_70182.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3616,3001,0,'LSQ12fth','LSQ',47.82275,-25.1096388888889,NULL,NULL,'2012-11-07 07:45:18',56238.3231299999,17.8818,0.0443,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_70181.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3617,3007,0,'LSQ12fte','LSQ',52.1527916666667,-24.8716944444444,NULL,NULL,'2012-11-07 06:48:35',56238.2837399999,19.8006,0.1171,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_snap_70201.gif',38021943870,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594092872,9282701,NULL,NULL,NULL,NULL),(3618,3007,0,'LSQ12fte','LSQ',52.1528333333333,-24.87175,NULL,NULL,'2012-11-07 07:59:12',56238.3327799998,19.5802,0.1478,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_snap_70202.gif',38021943870,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594092872,9282701,NULL,NULL,NULL,NULL),(3619,3009,0,'LSQ12ftd','LSQ',64.2446666666667,-24.1448055555556,NULL,NULL,'2012-11-07 08:30:40',56238.35464,19.2628,0.1859,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_70178.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3620,3009,0,'LSQ12ftd','LSQ',64.2444583333333,-24.1447222222222,NULL,NULL,'2012-11-07 08:32:22',56238.3558200002,19.7908,0.1603,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_70179.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3621,3013,0,'LSQ12ftc','LSQ',64.803125,-24.3551944444444,NULL,NULL,'2012-11-07 08:30:40',56238.35464,19.485,0.1598,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_70183.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3622,3013,0,'LSQ12ftc','LSQ',64.802875,-24.3551388888889,NULL,NULL,'2012-11-07 08:32:22',56238.3558200002,19.2296,0.1121,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_70184.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3623,3013,0,'LSQ12ftc','LSQ',64.8027916666667,-24.3551944444444,NULL,NULL,'2012-11-07 08:47:36',56238.3664000002,19.0576,0.1418,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_70185.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3624,3017,0,'LSQ12ftb','LSQ',65.4215416666667,-23.7053333333333,NULL,NULL,'2012-11-07 08:30:40',56238.35464,18.2404,0.0845,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_70203.gif',37314276029,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3625,3017,0,'LSQ12ftb','LSQ',65.4220833333333,-23.7052222222222,NULL,NULL,'2012-11-07 08:32:22',56238.3558200002,18.4941,0.0859,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_70204.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3626,3017,0,'LSQ12ftb','LSQ',65.4220416666667,-23.7051944444444,NULL,NULL,'2012-11-07 08:47:36',56238.3664000002,18.2213,0.0959,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_70205.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3627,3112,0,'LSQ12fvu','LSQ',53.5190833333333,-21.8744722222222,NULL,NULL,'2012-11-07 06:50:17',56238.28492,18.6288,0.0443,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_70086.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(3628,3112,0,'LSQ12fvu','LSQ',53.519125,-21.8745555555556,NULL,NULL,'2012-11-07 07:54:08',56238.32926,19.0655,0.0811,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_70087.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(3629,3125,0,'LSQ12fvl','LSQ',75.2085416666667,-38.6531388888889,NULL,NULL,'2012-11-07 05:26:26',56238.2267,17.9189,0.0331,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_70135.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(3630,3125,0,'LSQ12fvl','LSQ',75.2085,-38.6531666666667,NULL,NULL,'2012-11-07 07:07:03',56238.2965699998,17.9028,0.0442,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_70136.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(3631,3222,0,'LSQ12fvm','LSQ',47.9509166666667,-38.8036666666667,NULL,NULL,'2012-11-07 03:43:57',56238.1555300001,19.5191,0.0852,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_70097.gif',38600095382,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126490,9423851,NULL,NULL,NULL,NULL),(3632,3222,0,'LSQ12fvm','LSQ',47.9508333333333,-38.8036111111111,NULL,NULL,'2012-11-07 05:43:39',56238.2386500002,20.4392,0.1527,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_70098.gif',38600095382,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126490,9423851,NULL,NULL,NULL,NULL),(3633,3229,0,'LSQ12fvk','LSQ',0.9745,-36.1127222222222,NULL,NULL,'2012-11-07 01:52:18',56238.0779900001,20.5274,0.1997,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_history.html','sne?',NULL,0.07307,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_snap_70100.gif',34677267105,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541832298,8466129,NULL,NULL,NULL,NULL),(3634,3237,0,'LSQ12fwt','LSQ',54.0465,-37.4260277777778,NULL,NULL,'2012-11-07 04:08:40',56238.1726899999,19.6073,0.0774,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_70118.gif',38589273853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(3635,3237,0,'LSQ12fwt','LSQ',54.0465,-37.426,NULL,NULL,'2012-11-07 06:09:14',56238.25642,19.6471,0.0869,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_70119.gif',38589273853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(3636,3249,0,'LSQ12fww','LSQ',62.5345,-34.1650277777778,NULL,NULL,'2012-11-07 05:50:23',56238.24333,18.789,0.0482,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_70093.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(3637,3249,0,'LSQ12fww','LSQ',62.5343333333333,-34.1648888888889,NULL,NULL,'2012-11-07 08:20:18',56238.3474400002,18.7588,0.0562,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_70094.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(3638,3253,0,'LSQ12fxj','LSQ',75.1702916666667,-25.9278055555556,NULL,NULL,'2012-11-07 06:29:34',56238.2705399999,18.7475,0.0532,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_snap_70125.gif',37225960888,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581655638,9088369,NULL,NULL,NULL,NULL),(3639,3253,0,'LSQ12fxj','LSQ',75.1702916666667,-25.92775,NULL,NULL,'2012-11-07 07:38:14',56238.3182199998,18.3664,0.0514,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_snap_70126.gif',37225960888,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581655638,9088369,NULL,NULL,NULL,NULL),(3640,3287,0,'LSQ12fxc','LSQ',47.8156666666667,-22.4541944444444,NULL,NULL,'2012-11-07 06:38:19',56238.2766200001,19.0048,0.0954,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_70121.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(3641,3287,0,'LSQ12fxc','LSQ',47.8155416666667,-22.4541666666667,NULL,NULL,'2012-11-07 07:45:18',56238.3231299999,18.5455,0.1139,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_70122.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(3642,3293,0,'LSQ12fxa','LSQ',358.600291666667,-30.1614166666667,NULL,NULL,'2012-11-07 03:47:58',56238.1583199999,20.6321,0.15,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxa/LSQ12fxa_history.html','agn?',NULL,0.1428,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxa/LSQ12fxa_snap_70063.gif',50044826551,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781950414,12217975,NULL,NULL,NULL,NULL),(3643,3350,0,'LSQ12fyy','LSQ',24.3754583333333,16.6956944444444,NULL,NULL,'2012-11-07 00:52:56',56238.03676,19.8984,0.1099,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_snap_70066.gif',67419126530,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1053423852,16459747,NULL,NULL,NULL,NULL),(3644,3350,0,'LSQ12fyy','LSQ',24.3759583333333,16.6956944444444,NULL,NULL,'2012-11-07 02:33:31',56238.1066100001,19.0164,0.0734,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_snap_70067.gif',67419126541,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1053423852,16459747,NULL,NULL,NULL,NULL),(3645,3350,0,'LSQ12fyy','LSQ',24.3752916666667,16.6956388888889,NULL,NULL,'2012-11-07 04:15:12',56238.17723,19.5316,0.0669,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_snap_70068.gif',67419126530,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1053423852,16459747,NULL,NULL,NULL,NULL),(3646,3481,0,'LSQ12fzc','LSQ',43.0446666666667,-35.9738055555556,NULL,NULL,'2012-11-07 03:40:33',56238.1531699998,18.6491,0.0924,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_70075.gif',38652782971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(3647,3481,0,'LSQ12fzc','LSQ',43.0447083333333,-35.9738055555556,NULL,NULL,'2012-11-07 05:40:17',56238.2363100001,18.6008,0.1212,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_70076.gif',38652782971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(3648,3485,0,'LSQ12gbj','LSQ',66.0475416666667,-25.4150277777778,NULL,NULL,'2012-11-07 08:30:40',56238.35464,19.4305,0.1526,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_snap_70092.gif',37181674216,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,580963659,9077557,NULL,NULL,NULL,NULL),(3649,3502,0,'LSQ12gav','LSQ',355.827666666667,-24.8745833333333,NULL,NULL,'2012-11-07 01:37:10',56238.0674800002,19.6481,0.0991,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_snap_70139.gif',50001954988,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781280546,12207508,NULL,NULL,NULL,NULL),(3650,3502,0,'LSQ12gav','LSQ',355.827708333333,-24.8745833333333,NULL,NULL,'2012-11-07 03:36:35',56238.1504099998,19.4224,0.0887,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_snap_70140.gif',50001954988,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781280546,12207508,NULL,NULL,NULL,NULL),(3651,3524,0,'LSQ12gaf','LSQ',350.601208333333,-33.102,NULL,NULL,'2012-11-07 00:37:37',56238.0261300001,20.1329,0.1548,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaf/LSQ12gaf_history.html','sne - nice',NULL,0.1716,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaf/LSQ12gaf_snap_70112.gif',50183258630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784113416,12251772,NULL,NULL,NULL,NULL),(3652,3530,0,'LSQ12gad','LSQ',52.302,-30.6228888888889,NULL,NULL,'2012-11-07 05:36:53',56238.2339499998,18.514,0.0647,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_70108.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(3653,3530,0,'LSQ12gad','LSQ',52.3021666666667,-30.6228888888889,NULL,NULL,'2012-11-07 07:12:25',56238.3002900002,18.6491,0.0788,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_70109.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(3654,3540,0,'LSQ12fzz','LSQ',81.493375,-34.4575555555556,NULL,NULL,'2012-11-07 06:05:37',56238.25391,19.3662,0.097,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_70110.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(3655,3540,0,'LSQ12fzz','LSQ',81.4933333333333,-34.4575555555556,NULL,NULL,'2012-11-07 07:25:56',56238.3096799999,18.8224,0.0594,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_70111.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(3656,3548,0,'LSQ12fzu','LSQ',74.883,-38.4091944444444,NULL,NULL,'2012-11-07 05:24:45',56238.2255299999,20.057,0.1355,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_70103.gif',37599816278,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(3657,3548,0,'LSQ12fzu','LSQ',74.8830416666667,-38.4093055555556,NULL,NULL,'2012-11-07 08:25:33',56238.3510799999,20.1061,0.1594,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_70104.gif',37599816286,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(3658,3551,0,'LSQ12fzr','LSQ',49.179375,-30.2704444444444,NULL,NULL,'2012-11-07 05:31:49',56238.23043,19.2394,0.0925,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_70161.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(3659,3551,0,'LSQ12fzr','LSQ',49.1794583333333,-30.2704722222222,NULL,NULL,'2012-11-07 07:15:48',56238.30265,18.8776,0.0945,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 03:45:52','2012-11-08 03:45:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_70162.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(3660,3563,0,'OGLE-2012-SN-027','pessto',23.7968333333,-73.5935277778,NULL,NULL,'2012-11-07 00:00:00',56238,NULL,NULL,NULL,0,NULL,'I',NULL,'2012-11-08 13:34:27','2012-11-08 13:34:27','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35609445495,'NTT','EFOSC','Francisco','2012-07-25 09:14:29',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,556397585,8693712,NULL,NULL,NULL,NULL),(3661,3114,0,'LSQ12fvq','pessto',19.15075,-31.4520555556,NULL,NULL,'2012-11-06 00:00:00',56237,NULL,NULL,NULL,0.035,NULL,'II',NULL,'2012-11-08 13:37:08','2012-11-08 13:37:08','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,34735616008,'NTT','EFOSC','Joe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(3662,3530,0,'LSQ12gad','pessto',52.302125,-30.6227777778,NULL,NULL,'2012-11-06 00:00:00',56237,NULL,NULL,NULL,0,NULL,'unknown',NULL,'2012-11-08 13:38:38','2012-11-08 13:38:38','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38573258241,'NTT','EFOSC','Francisco',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(3663,3551,0,'LSQ12fzr','pessto',49.1792916667,-30.2704444444,NULL,NULL,'2012-11-06 00:00:00',56237,NULL,NULL,NULL,0.145,NULL,'Ia',NULL,'2012-11-08 13:40:34','2012-11-08 13:40:34','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38545017983,'NTT','EFOSC','Joe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(3664,3249,0,'LSQ12fww','pessto',62.5345,-34.1650277778,NULL,NULL,'2012-11-05 00:00:00',56236,NULL,NULL,NULL,0,NULL,'unknown',NULL,'2012-11-08 13:41:37','2012-11-08 13:41:37','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37708009531,'NTT','EFOSC','Francisco',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(3665,3125,0,'LSQ12fvl','pessto',75.2084583333,-38.65325,NULL,NULL,'2012-11-05 00:00:00',56236,NULL,NULL,NULL,0.056,NULL,'Ia',NULL,'2012-11-08 13:42:14','2012-11-08 13:42:14','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37599217320,'NTT','EFOSC','Joe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(3666,3237,0,'LSQ12fwt','pessto',54.0467916667,-37.4259166667,NULL,NULL,'2012-11-05 00:00:00',56236,NULL,NULL,NULL,0.136,NULL,'Ia',NULL,'2012-11-08 13:42:59','2012-11-08 13:42:59','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38589273853,'NTT','EFOSC','Francisco',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(3667,3009,0,'LSQ12ftd','pessto',64.2445833333,-24.1446666667,NULL,NULL,'2012-11-05 00:00:00',56236,NULL,NULL,NULL,0.092,NULL,'Ia',NULL,'2012-11-08 13:43:28','2012-11-08 13:43:28','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37178445164,'NTT','EFOSC','Joe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3668,3051,0,'LSQ12fui','pessto',70.95175,-13.3013888889,NULL,NULL,'2012-11-05 00:00:00',56236,NULL,NULL,NULL,0.027,NULL,'II',NULL,'2012-11-08 13:44:08','2012-11-08 13:44:08','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37542571140,'NTT','EFOSC','Francisco',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586602674,9165666,NULL,NULL,NULL,NULL),(3669,3064,0,'LSQ12ftr','pessto',66.6722083333,-20.9704166667,NULL,NULL,'2012-11-04 00:00:00',56235,NULL,NULL,NULL,0,NULL,'unknown',NULL,'2012-11-08 13:45:11','2012-11-08 13:45:11','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37323194914,'NTT','EFOSC','Joe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583174920,9112108,NULL,NULL,NULL,NULL),(3670,2368,0,'LSQ12fjw','LSQ',56.383875,-7.39658333333333,NULL,NULL,'2012-11-08 07:20:17',56239.3057599999,19.7291,0.145,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_history.html','sne - nice',NULL,0.02832,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fjw/LSQ12fjw_snap_70290.gif',37031203525,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578612555,9040821,NULL,NULL,NULL,NULL),(3671,2900,0,'LSQ12fqb','LSQ',70.8872916666667,-11.90175,NULL,NULL,'2012-11-08 06:05:26',56239.2537799999,19.8989,0.1958,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_70412.gif',37539439936,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553749,9164902,NULL,NULL,NULL,NULL),(3672,2900,0,'LSQ12fqb','LSQ',70.8874166666667,-11.9014722222222,NULL,NULL,'2012-11-08 08:08:15',56239.3390700002,19.7574,0.1095,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_70413.gif',37539441792,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553778,9164902,NULL,NULL,NULL,NULL),(3673,2915,0,'LSQ12fpv','LSQ',56.9054166666667,-8.732,NULL,NULL,'2012-11-08 07:18:36',56239.3045899998,20.1127,0.1613,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_history.html','sn?',NULL,0.034397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_snap_70405.gif',37021133916,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578455217,9038362,NULL,NULL,NULL,NULL),(3674,2937,0,'LSQ12fpr','LSQ',47.5738333333333,-10.5154166666667,NULL,NULL,'2012-11-08 05:45:06',56239.23966,20.0331,0.1611,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpr/LSQ12fpr_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpr/LSQ12fpr_snap_70273.gif',37894166867,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592096357,9251505,NULL,NULL,NULL,NULL),(3675,2939,0,'LSQ12fpp','LSQ',50.8667083333333,-12.0055555555556,NULL,NULL,'2012-11-08 08:15:00',56239.3437600001,18.834,0.1222,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_70278.gif',37885516712,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(3676,3044,0,'LSQ12ftn','LSQ',2.53933333333333,-19.1404722222222,NULL,NULL,'2012-11-08 02:04:14',56239.0862799999,18.7061,0.0493,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_snap_70235.gif',34442362275,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538161910,8408779,NULL,NULL,NULL,NULL),(3677,3049,0,'LSQ12fuk','LSQ',74.5662083333333,-16.2994444444444,NULL,NULL,'2012-11-08 05:41:33',56239.2371899998,15.4787,0.0036,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_history.html','sne - bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_snap_70319.gif',37569693502,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587026460,9172288,NULL,NULL,NULL,NULL),(3678,3049,0,'LSQ12fuk','LSQ',74.5662083333333,-16.2994444444444,NULL,NULL,'2012-11-08 08:16:54',56239.3450699998,15.4662,0.0037,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_history.html','sne - bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuk/LSQ12fuk_snap_70320.gif',37569693502,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587026460,9172288,NULL,NULL,NULL,NULL),(3679,3051,0,'LSQ12fui','LSQ',70.9517916666667,-13.3013611111111,NULL,NULL,'2012-11-08 05:39:48',56239.2359799999,18.9078,0.0455,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_snap_70317.gif',37542571140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586602674,9165666,NULL,NULL,NULL,NULL),(3680,3051,0,'LSQ12fui','LSQ',70.9517083333333,-13.3013611111111,NULL,NULL,'2012-11-08 07:13:17',56239.3009000001,18.7743,0.041,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fui/LSQ12fui_snap_70318.gif',37542571140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586602674,9165666,NULL,NULL,NULL,NULL),(3681,3053,0,'LSQ12fug','LSQ',63.5357916666667,-13.1428888888889,NULL,NULL,'2012-11-08 05:33:02',56239.2312799999,19.9521,0.1355,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fug/LSQ12fug_history.html','sne?',NULL,0.032095,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fug/LSQ12fug_snap_70325.gif',36861016119,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575953376,8999271,NULL,NULL,NULL,NULL),(3682,3053,0,'LSQ12fug','LSQ',63.53575,-13.1424444444444,NULL,NULL,'2012-11-08 07:09:52',56239.2985200002,20.2808,0.1467,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fug/LSQ12fug_history.html','sne?',NULL,0.032095,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fug/LSQ12fug_snap_70326.gif',36861016119,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575953376,8999271,NULL,NULL,NULL,NULL),(3683,3058,0,'LSQ12fuc','LSQ',75.046625,-20.0071666666667,NULL,NULL,'2012-11-08 05:17:30',56239.2204900002,20.0047,0.0744,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_history.html','sne - good',NULL,0.041789,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_snap_70258.gif',37564014385,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586937724,9170901,NULL,NULL,NULL,NULL),(3684,3058,0,'LSQ12fuc','LSQ',75.0465416666667,-20.0071666666667,NULL,NULL,'2012-11-08 07:02:53',56239.2936800001,19.3208,0.0524,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_history.html','sne - good',NULL,0.041789,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_snap_70259.gif',37564014385,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586937724,9170901,NULL,NULL,NULL,NULL),(3685,3060,0,'LSQ12ftz','LSQ',74.7340416666667,-20.3273888888889,NULL,NULL,'2012-11-08 05:15:46',56239.2192899999,19.2611,0.0432,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_snap_70410.gif',37561880973,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586904390,9170381,NULL,NULL,NULL,NULL),(3686,3060,0,'LSQ12ftz','LSQ',74.734,-20.3273888888889,NULL,NULL,'2012-11-08 07:01:12',56239.2925100001,19.3473,0.0475,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftz/LSQ12ftz_snap_70411.gif',37561880973,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586904390,9170381,NULL,NULL,NULL,NULL),(3687,3064,0,'LSQ12ftr','LSQ',66.67225,-20.9704166666667,NULL,NULL,'2012-11-08 05:03:23',56239.2106900001,17.014,0.0126,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_history.html','sne or comet',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_snap_70329.gif',37323194914,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583174920,9112108,NULL,NULL,NULL,NULL),(3688,3064,0,'LSQ12ftr','LSQ',66.6722916666667,-20.9704444444444,NULL,NULL,'2012-11-08 08:30:38',56239.3546099998,16.9857,0.0151,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_history.html','sne or comet',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftr/LSQ12ftr_snap_70330.gif',37323194914,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583174920,9112108,NULL,NULL,NULL,NULL),(3689,3150,0,'LSQ12fvz','LSQ',60.5280416666667,-20.3228611111111,NULL,NULL,'2012-11-08 04:51:59',56239.2027699999,19.0005,0.047,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvz/LSQ12fvz_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvz/LSQ12fvz_snap_70270.gif',36853079254,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575829363,8997333,NULL,NULL,NULL,NULL),(3690,3150,0,'LSQ12fvz','LSQ',60.5280833333333,-20.3228611111111,NULL,NULL,'2012-11-08 08:34:01',56239.35696,19.0087,0.0711,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvz/LSQ12fvz_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvz/LSQ12fvz_snap_70271.gif',36853079254,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575829363,8997333,NULL,NULL,NULL,NULL),(3691,3259,0,'LSQ12fwn','LSQ',13.28575,-3.97375,NULL,NULL,'2012-11-08 02:09:24',56239.0898699998,20.8435,0.1458,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwn/LSQ12fwn_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwn/LSQ12fwn_snap_70293.gif',34546872308,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,539794879,8434294,NULL,NULL,NULL,NULL),(3692,3270,0,'LSQ12fwi','LSQ',65.3632916666667,-13.9311111111111,NULL,NULL,'2012-11-08 07:11:33',56239.2996899998,19.2273,0.1107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwi/LSQ12fwi_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwi/LSQ12fwi_snap_70274.gif',37347679140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583557486,9118085,NULL,NULL,NULL,NULL),(3693,3278,0,'LSQ12fwe','LSQ',9.0435,4.86469444444444,NULL,NULL,'2012-11-08 03:30:36',56239.1462500002,19.6809,0.0846,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwe/LSQ12fwe_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwe/LSQ12fwe_snap_70275.gif',66820331792,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1044067684,16313557,NULL,NULL,NULL,NULL),(3694,3281,0,'LSQ12fwd','LSQ',56.3923333333333,-0.35725,NULL,NULL,'2012-11-08 06:27:30',56239.2691000002,18.7733,0.053,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_history.html','agn?',NULL,0.10854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_snap_70299.gif',36993805999,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578028218,9031690,NULL,NULL,NULL,NULL),(3695,3281,0,'LSQ12fwd','LSQ',56.3923333333333,-0.357277777777778,NULL,NULL,'2012-11-08 07:56:16',56239.3307500002,19.06,0.0765,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_history.html','agn?',NULL,0.10854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_snap_70300.gif',36993805999,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578028218,9031690,NULL,NULL,NULL,NULL),(3696,3350,0,'LSQ12fyy','LSQ',24.3755416666667,16.69575,NULL,NULL,'2012-11-08 01:46:03',56239.0736500002,19.7581,0.1135,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_snap_70266.gif',67419126530,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1053423852,16459747,NULL,NULL,NULL,NULL),(3697,3356,0,'LSQ12fyv','LSQ',63.557125,2.86297222222222,NULL,NULL,'2012-11-08 07:44:29',56239.3225599998,21.11,0.0858,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyv/LSQ12fyv_history.html','sne?',NULL,0.040024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyv/LSQ12fyv_snap_70284.gif',65084187378,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1016940427,15889694,NULL,NULL,NULL,NULL),(3698,3359,0,'LSQ12fyt','LSQ',8.57358333333333,4.16286111111111,NULL,NULL,'2012-11-08 01:28:17',56239.0613099998,20.2756,0.1191,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_snap_70267.gif',66821045463,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044078835,16313731,NULL,NULL,NULL,NULL),(3699,3359,0,'LSQ12fyt','LSQ',8.57358333333333,4.16277777777778,NULL,NULL,'2012-11-08 03:28:54',56239.1450800002,20.3874,0.1772,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyt/LSQ12fyt_snap_70268.gif',66821045461,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044078835,16313731,NULL,NULL,NULL,NULL),(3700,3374,0,'LSQ12fyg','LSQ',68.9829583333333,-4.04513888888889,NULL,NULL,'2012-11-08 07:36:00',56239.3166700001,20.566,0.1656,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyg/LSQ12fyg_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyg/LSQ12fyg_snap_70263.gif',37463478352,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585366849,9146357,NULL,NULL,NULL,NULL),(3701,3378,0,'LSQ12fyf','LSQ',63.8234583333333,-7.06941666666667,NULL,NULL,'2012-11-08 06:20:41',56239.26437,19.0658,0.1012,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_snap_70244.gif',36956960238,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577452503,9022695,NULL,NULL,NULL,NULL),(3702,3378,0,'LSQ12fyf','LSQ',63.8234166666667,-7.0695,NULL,NULL,'2012-11-08 07:59:44',56239.3331499998,18.7796,0.0775,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_snap_70245.gif',36956960238,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577452503,9022695,NULL,NULL,NULL,NULL),(3703,3380,0,'LSQ12fye','LSQ',62.7185833333333,-4.92305555555556,NULL,NULL,'2012-11-08 06:17:19',56239.2620299999,18.568,0.0782,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_70246.gif',36961736785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(3704,3380,0,'LSQ12fye','LSQ',62.7185416666667,-4.92311111111111,NULL,NULL,'2012-11-08 07:32:13',56239.3140500002,18.6582,0.1024,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_70247.gif',36961736785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(3705,3386,0,'LSQ12fyb','LSQ',53.6893333333333,-3.73852777777778,NULL,NULL,'2012-11-08 06:10:33',56239.2573299999,20.3012,0.1557,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_70242.gif',36820699952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(3706,3386,0,'LSQ12fyb','LSQ',53.689125,-3.73844444444444,NULL,NULL,'2012-11-08 07:28:50',56239.3116899999,19.9208,0.1518,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_70243.gif',36820699952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(3707,3399,0,'LSQ12fxy','LSQ',50.1272916666667,-11.2958333333333,NULL,NULL,'2012-11-08 07:16:54',56239.3034100002,19.2485,0.1436,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_snap_70264.gif',37885680972,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591963765,9249433,NULL,NULL,NULL,NULL),(3708,3401,0,'LSQ12fxx','LSQ',51.1459583333333,-10.1414444444444,NULL,NULL,'2012-11-08 05:46:47',56239.24083,18.2935,0.0484,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxx/LSQ12fxx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxx/LSQ12fxx_snap_70344.gif',37884403751,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591943808,9249122,NULL,NULL,NULL,NULL),(3709,3401,0,'LSQ12fxx','LSQ',51.1459166666667,-10.1414444444444,NULL,NULL,'2012-11-08 07:16:54',56239.3034100002,18.4391,0.0629,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxx/LSQ12fxx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxx/LSQ12fxx_snap_70345.gif',37884403751,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591943808,9249122,NULL,NULL,NULL,NULL),(3710,3405,0,'LSQ12fxv','LSQ',358.932333333333,-12.64125,NULL,NULL,'2012-11-08 01:38:47',56239.0685999999,19.8871,0.1625,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_snap_70253.gif',49546365664,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,774161963,12096280,NULL,NULL,NULL,NULL),(3711,3405,0,'LSQ12fxv','LSQ',358.932291666667,-12.6411944444444,NULL,NULL,'2012-11-08 03:40:03',56239.15282,20.1376,0.1313,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_snap_70254.gif',49546365664,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,774161963,12096280,NULL,NULL,NULL,NULL),(3712,3409,0,'LSQ12fxu','LSQ',356.792208333333,-13.2493333333333,NULL,NULL,'2012-11-08 01:23:08',56239.0577400001,18.6501,0.0846,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_snap_70279.gif',49549307031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,774207922,12096998,NULL,NULL,NULL,NULL),(3713,3409,0,'LSQ12fxu','LSQ',356.79225,-13.2493333333333,NULL,NULL,'2012-11-08 03:23:49',56239.1415499998,18.3401,0.1006,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxu/LSQ12fxu_snap_70280.gif',49549307031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,774207922,12096998,NULL,NULL,NULL,NULL),(3714,3478,0,'LSQ12fxn','LSQ',53.6287916666667,-27.3569166666667,NULL,NULL,'2012-11-08 03:19:23',56239.1384700001,19.5846,0.0589,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 16:45:48','2012-11-08 16:45:48','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxn/LSQ12fxn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxn/LSQ12fxn_snap_70255.gif',38580994894,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602828045,9419188,NULL,NULL,NULL,NULL),(3715,3715,1,'LSQ12gbt','LSQ',22.5429166666667,9.38822222222222,NULL,NULL,'2012-11-06 00:24:34',56237.0170700001,19.6199,0.1291,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 17:45:49','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbt/LSQ12gbt_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbt/LSQ12gbt_snap_70219.gif',67542604792,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1055353199,16489893,NULL,NULL,NULL,NULL),(3716,3715,0,'LSQ12gbt','LSQ',22.5429583333333,9.38825,NULL,NULL,'2012-11-06 02:22:13',56237.09877,19.7318,0.1233,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 17:45:49','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbt/LSQ12gbt_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbt/LSQ12gbt_snap_70220.gif',67542604792,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1055353199,16489893,NULL,NULL,NULL,NULL),(3717,3717,1,'LSQ12gbs','LSQ',354.375666666667,-15.9424166666667,NULL,NULL,'2012-11-02 00:45:06',56233.0313300001,20.7255,0.1758,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 17:45:49','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbs/LSQ12gbs_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbs/LSQ12gbs_snap_70226.gif',49584293597,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,774754587,12105540,NULL,NULL,NULL,NULL),(3718,3717,0,'LSQ12gbs','LSQ',354.375541666667,-15.9426388888889,NULL,NULL,'2012-11-04 00:46:22',56235.0321999998,20.0551,0.1131,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 17:45:49','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbs/LSQ12gbs_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbs/LSQ12gbs_snap_70227.gif',49584293586,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,774754587,12105540,NULL,NULL,NULL,NULL),(3719,3717,0,'LSQ12gbs','LSQ',354.375833333333,-15.9423888888889,NULL,NULL,'2012-11-06 01:30:27',56237.0628200001,20.3722,0.1641,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 17:45:49','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbs/LSQ12gbs_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbs/LSQ12gbs_snap_70217.gif',49584293597,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,774754587,12105540,NULL,NULL,NULL,NULL),(3720,3717,0,'LSQ12gbs','LSQ',354.375708333333,-15.9423333333333,NULL,NULL,'2012-11-06 03:29:46',56237.1456800001,20.0265,0.1293,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 17:45:49','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbs/LSQ12gbs_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbs/LSQ12gbs_snap_70218.gif',49584293597,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,774754587,12105540,NULL,NULL,NULL,NULL),(3721,3721,1,'LSQ12gby','LSQ',19.3464166666667,9.27797222222222,NULL,NULL,'2012-11-06 00:24:34',56237.0170700001,18.8749,0.0486,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 18:45:50','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gby/LSQ12gby_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gby/LSQ12gby_snap_70490.gif',67564633006,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1055697390,16495271,NULL,NULL,NULL,NULL),(3722,3721,0,'LSQ12gby','LSQ',19.3464583333333,9.27797222222222,NULL,NULL,'2012-11-06 02:22:13',56237.09877,18.7996,0.0577,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 18:45:50','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gby/LSQ12gby_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gby/LSQ12gby_snap_70492.gif',67564633006,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1055697390,16495271,NULL,NULL,NULL,NULL),(3723,3721,0,'LSQ12gby','LSQ',19.3464583333333,9.27797222222222,NULL,NULL,'2012-11-06 04:21:25',56237.1815399998,18.7069,0.0578,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 18:45:50','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gby/LSQ12gby_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gby/LSQ12gby_snap_70491.gif',67564633006,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1055697390,16495271,NULL,NULL,NULL,NULL),(3724,3724,1,'LSQ12gbw','LSQ',21.3145833333333,9.56072222222222,NULL,NULL,'2012-11-06 00:24:34',56237.0170700001,20.7535,0.1314,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 18:45:50','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbw/LSQ12gbw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbw/LSQ12gbw_snap_70486.gif',67541900530,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1055342195,16489721,NULL,NULL,NULL,NULL),(3725,3724,0,'LSQ12gbw','LSQ',21.3146666666667,9.56083333333333,NULL,NULL,'2012-11-06 02:22:13',56237.09877,20.4294,0.1435,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 18:45:50','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbw/LSQ12gbw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbw/LSQ12gbw_snap_70487.gif',67541900530,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1055342195,16489721,NULL,NULL,NULL,NULL),(3726,3726,1,'LSQ12gcq','LSQ',60.7307083333333,5.94247222222222,NULL,NULL,'2012-11-04 05:54:16',56235.24602,18.6552,0.0627,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcq/LSQ12gcq_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcq/LSQ12gcq_snap_70565.gif',65200466967,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,1018757296,15918082,NULL,NULL,NULL,NULL),(3727,3726,0,'LSQ12gcq','LSQ',60.730625,5.94230555555556,NULL,NULL,'2012-11-06 06:31:01',56237.2715500002,16.5488,0.1247,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcq/LSQ12gcq_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcq/LSQ12gcq_snap_70527.gif',65200466967,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,1018757296,15918082,NULL,NULL,NULL,NULL),(3728,3726,0,'LSQ12gcq','LSQ',60.730375,5.94252777777778,NULL,NULL,'2012-11-06 07:39:56',56237.3193999999,17.3155,0.1311,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcq/LSQ12gcq_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcq/LSQ12gcq_snap_70528.gif',65200466967,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,1018757296,15918082,NULL,NULL,NULL,NULL),(3729,3729,1,'LSQ12gcp','LSQ',70.5655833333333,-15.3286944444444,NULL,NULL,'2012-11-02 07:59:17',56233.3328399998,19.6127,0.1854,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_snap_70563.gif',37536334293,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586505223,9164144,NULL,NULL,NULL,NULL),(3730,3729,0,'LSQ12gcp','LSQ',70.5655,-15.3286944444444,NULL,NULL,'2012-11-04 04:54:39',56235.20462,19.9615,0.188,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_snap_70564.gif',37536334293,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586505223,9164144,NULL,NULL,NULL,NULL),(3731,3729,0,'LSQ12gcp','LSQ',70.5654583333333,-15.3286944444444,NULL,NULL,'2012-11-06 05:24:21',56237.2252500001,20.7224,0.1679,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_snap_70525.gif',37536334293,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586505223,9164144,NULL,NULL,NULL,NULL),(3732,3729,0,'LSQ12gcp','LSQ',70.5655833333333,-15.3289166666667,NULL,NULL,'2012-11-06 08:08:55',56237.33953,19.4002,0.093,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_snap_70526.gif',37536334293,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586505223,9164144,NULL,NULL,NULL,NULL),(3733,3729,0,'LSQ12gcp','LSQ',70.565625,-15.3287777777778,NULL,NULL,'2012-11-08 05:38:07',56239.2348099998,20.3798,0.1152,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_snap_70683.gif',37536334293,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586505223,9164144,NULL,NULL,NULL,NULL),(3734,3729,0,'LSQ12gcp','LSQ',70.5656666666667,-15.3288888888889,NULL,NULL,'2012-11-08 08:18:36',56239.34626,19.4664,0.0794,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_snap_70684.gif',37536334293,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586505223,9164144,NULL,NULL,NULL,NULL),(3735,3735,1,'LSQ12gco','LSQ',67.6797916666667,-15.8021388888889,NULL,NULL,'2012-11-04 04:52:57',56235.2034399998,19.5157,0.1491,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gco/LSQ12gco_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gco/LSQ12gco_snap_70561.gif',37360517900,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,583758092,9121220,NULL,NULL,NULL,NULL),(3736,3735,0,'LSQ12gco','LSQ',67.6798333333333,-15.8020555555556,NULL,NULL,'2012-11-04 08:00:41',56235.3338100002,19.8062,0.1905,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gco/LSQ12gco_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gco/LSQ12gco_snap_70562.gif',37360517900,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,583758092,9121220,NULL,NULL,NULL,NULL),(3737,3735,0,'LSQ12gco','LSQ',67.679875,-15.8022222222222,NULL,NULL,'2012-11-06 05:22:39',56237.22407,19.5552,0.1368,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gco/LSQ12gco_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gco/LSQ12gco_snap_70523.gif',37360517900,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,583758092,9121220,NULL,NULL,NULL,NULL),(3738,3735,0,'LSQ12gco','LSQ',67.6799166666667,-15.8022777777778,NULL,NULL,'2012-11-06 07:05:27',56237.2954600002,19.841,0.1492,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gco/LSQ12gco_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gco/LSQ12gco_snap_70524.gif',37360517893,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,583758092,9121220,NULL,NULL,NULL,NULL),(3739,3735,0,'LSQ12gco','LSQ',67.6799583333333,-15.8022222222222,NULL,NULL,'2012-11-08 07:11:33',56239.2996899998,19.7947,0.1301,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gco/LSQ12gco_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gco/LSQ12gco_snap_70685.gif',37360517900,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,583758092,9121220,NULL,NULL,NULL,NULL),(3740,3740,1,'LSQ12gcn','LSQ',67.481125,-12.0793333333333,NULL,NULL,'2012-11-02 06:51:06',56233.2854900002,19.3909,0.1556,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_snap_70558.gif',37533040332,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586453755,9163339,NULL,NULL,NULL,NULL),(3741,3740,0,'LSQ12gcn','LSQ',67.4811666666667,-12.0791111111111,NULL,NULL,'2012-11-04 04:52:57',56235.2034399998,19.3979,0.1423,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_snap_70559.gif',37533040335,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586453755,9163339,NULL,NULL,NULL,NULL),(3742,3740,0,'LSQ12gcn','LSQ',67.48075,-12.0792777777778,NULL,NULL,'2012-11-04 08:00:41',56235.3338100002,18.5363,0.1074,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_snap_70560.gif',37533040332,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586453755,9163339,NULL,NULL,NULL,NULL),(3743,3740,0,'LSQ12gcn','LSQ',67.4807083333333,-12.0791666666667,NULL,NULL,'2012-11-06 05:22:39',56237.22407,18.4395,0.0957,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_snap_70521.gif',37533040335,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586453755,9163339,NULL,NULL,NULL,NULL),(3744,3740,0,'LSQ12gcn','LSQ',67.4807916666667,-12.0792777777778,NULL,NULL,'2012-11-06 07:05:27',56237.2954600002,19.0508,0.1351,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_snap_70522.gif',37533040332,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586453755,9163339,NULL,NULL,NULL,NULL),(3745,3740,0,'LSQ12gcn','LSQ',67.4810833333333,-12.07925,NULL,NULL,'2012-11-08 07:11:33',56239.2996899998,19.5616,0.1897,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_snap_70681.gif',37533040335,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586453755,9163339,NULL,NULL,NULL,NULL),(3746,3746,1,'LSQ12gcm','LSQ',59.1727083333333,-12.5713611111111,NULL,NULL,'2012-11-06 05:15:53',56237.2193700001,20.0744,0.1304,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcm/LSQ12gcm_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcm/LSQ12gcm_snap_70519.gif',36885694052,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,576338969,9005296,NULL,NULL,NULL,NULL),(3747,3746,0,'LSQ12gcm','LSQ',59.172625,-12.5713333333333,NULL,NULL,'2012-11-06 07:02:05',56237.29312,20.1429,0.1591,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcm/LSQ12gcm_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcm/LSQ12gcm_snap_70520.gif',36885694052,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,576338969,9005296,NULL,NULL,NULL,NULL),(3748,3746,0,'LSQ12gcm','LSQ',59.1727083333333,-12.5714444444444,NULL,NULL,'2012-11-08 05:29:40',56239.2289399998,20.4424,0.1371,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcm/LSQ12gcm_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcm/LSQ12gcm_snap_70686.gif',36885694052,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,576338969,9005296,NULL,NULL,NULL,NULL),(3749,3746,0,'LSQ12gcm','LSQ',59.1726666666667,-12.5713611111111,NULL,NULL,'2012-11-08 07:08:10',56239.29734,20.2821,0.1667,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcm/LSQ12gcm_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcm/LSQ12gcm_snap_70687.gif',36885694052,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,576338969,9005296,NULL,NULL,NULL,NULL),(3750,3750,1,'LSQ12gcl','LSQ',60.4602083333333,-12.6624722222222,NULL,NULL,'2012-10-31 05:17:09',56231.2202499998,19.397,0.1342,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcl/LSQ12gcl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcl/LSQ12gcl_snap_70555.gif',36864727705,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,576011370,9000177,NULL,NULL,NULL,NULL),(3751,3750,0,'LSQ12gcl','LSQ',60.4602083333333,-12.6623055555556,NULL,NULL,'2012-11-02 04:44:47',56233.19777,20.2638,0.1331,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcl/LSQ12gcl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcl/LSQ12gcl_snap_70556.gif',36864727705,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,576011370,9000177,NULL,NULL,NULL,NULL),(3752,3750,0,'LSQ12gcl','LSQ',60.4602916666667,-12.66275,NULL,NULL,'2012-11-06 05:15:53',56237.2193700001,19.6009,0.0645,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcl/LSQ12gcl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcl/LSQ12gcl_snap_70517.gif',36864727705,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,576011370,9000177,NULL,NULL,NULL,NULL),(3753,3750,0,'LSQ12gcl','LSQ',60.4599583333333,-12.6625,NULL,NULL,'2012-11-06 07:02:05',56237.29312,20.7709,0.1605,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcl/LSQ12gcl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcl/LSQ12gcl_snap_70518.gif',36864727705,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,576011370,9000177,NULL,NULL,NULL,NULL),(3754,3754,1,'LSQ12gck','LSQ',0.0506666666666667,-15.07575,NULL,NULL,'2012-11-04 03:07:11',56235.1299999999,19.9292,0.1171,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gck/LSQ12gck_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gck/LSQ12gck_snap_70557.gif',34467171595,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538549556,8414836,NULL,NULL,NULL,NULL),(3755,3754,0,'LSQ12gck','LSQ',0.0505416666666667,-15.0753611111111,NULL,NULL,'2012-11-06 01:50:57',56237.07706,20.1252,0.1258,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gck/LSQ12gck_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gck/LSQ12gck_snap_70515.gif',34467171593,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538549556,8414836,NULL,NULL,NULL,NULL),(3756,3754,0,'LSQ12gck','LSQ',0.05075,-15.0756944444444,NULL,NULL,'2012-11-06 03:51:01',56237.1604300002,20.1524,0.1396,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gck/LSQ12gck_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gck/LSQ12gck_snap_70516.gif',34467171595,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538549556,8414836,NULL,NULL,NULL,NULL),(3757,3754,0,'LSQ12gck','LSQ',0.0505833333333333,-15.0755833333333,NULL,NULL,'2012-11-08 01:43:53',56239.0721499999,20.3782,0.1373,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gck/LSQ12gck_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gck/LSQ12gck_snap_70689.gif',34467171595,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538549556,8414836,NULL,NULL,NULL,NULL),(3758,3754,0,'LSQ12gck','LSQ',0.0507916666666667,-15.0756666666667,NULL,NULL,'2012-11-08 03:43:25',56239.1551600001,20.3426,0.1549,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gck/LSQ12gck_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gck/LSQ12gck_snap_70690.gif',34467171592,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538549556,8414836,NULL,NULL,NULL,NULL),(3759,3759,1,'LSQ12gch','LSQ',75.1155416666667,-19.9498055555556,NULL,NULL,'2012-11-02 06:32:10',56233.2723400001,19.6432,0.1182,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_snap_70550.gif',37564131566,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586939555,9170930,NULL,NULL,NULL,NULL),(3760,3759,0,'LSQ12gch','LSQ',75.11575,-19.9498055555556,NULL,NULL,'2012-11-04 04:34:01',56235.1902899998,19.6878,0.0927,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_snap_70551.gif',37564131567,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586939555,9170930,NULL,NULL,NULL,NULL),(3761,3759,0,'LSQ12gch','LSQ',75.1154166666667,-19.94975,NULL,NULL,'2012-11-06 05:03:44',56237.2109300001,20.8381,0.1464,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_snap_70509.gif',37564131566,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586939555,9170930,NULL,NULL,NULL,NULL),(3762,3759,0,'LSQ12gch','LSQ',75.1151666666667,-19.9498333333333,NULL,NULL,'2012-11-06 08:22:43',56237.3491199999,20.4757,0.1645,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_snap_70510.gif',37564131558,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586939555,9170930,NULL,NULL,NULL,NULL),(3763,3759,0,'LSQ12gch','LSQ',75.1155,-19.9499444444444,NULL,NULL,'2012-11-08 05:17:30',56239.2204900002,20.2819,0.0736,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_snap_70680.gif',37564131566,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586939555,9170930,NULL,NULL,NULL,NULL),(3764,3764,1,'LSQ12gcd','LSQ',59.5836666666667,-18.6200833333333,NULL,NULL,'2012-10-31 04:51:27',56231.2023999998,18.9269,0.1929,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_snap_70540.gif',36851844463,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575810069,8997032,NULL,NULL,NULL,NULL),(3765,3764,0,'LSQ12gcd','LSQ',59.5835,-18.6201666666667,NULL,NULL,'2012-11-04 04:20:29',56235.1809,19.7812,0.1671,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_snap_70541.gif',36851844463,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575810069,8997032,NULL,NULL,NULL,NULL),(3766,3764,0,'LSQ12gcd','LSQ',59.5837083333333,-18.6201666666667,NULL,NULL,'2012-11-04 06:21:48',56235.2651399998,19.4814,0.1332,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_snap_70542.gif',36851844463,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575810069,8997032,NULL,NULL,NULL,NULL),(3767,3764,0,'LSQ12gcd','LSQ',59.5835,-18.6201388888889,NULL,NULL,'2012-11-06 04:37:55',56237.193,20.1256,0.156,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_snap_70501.gif',36851844463,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575810069,8997032,NULL,NULL,NULL,NULL),(3768,3764,0,'LSQ12gcd','LSQ',59.583625,-18.6201388888889,NULL,NULL,'2012-11-06 06:37:54',56237.2763200002,19.6315,0.1229,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_snap_70502.gif',36851844463,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575810069,8997032,NULL,NULL,NULL,NULL),(3769,3764,0,'LSQ12gcd','LSQ',59.5829583333333,-18.6201944444444,NULL,NULL,'2012-11-08 08:34:01',56239.35696,19.636,0.1455,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_snap_70674.gif',36851844453,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575810069,8997032,NULL,NULL,NULL,NULL),(3770,3770,1,'LSQ12gbz','LSQ',66.585,-10.1035833333333,NULL,NULL,'2012-11-04 05:16:49',56235.2200199999,19.3604,0.1871,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_history.html','sne - nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_snap_70535.gif',37466637666,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585416213,9147128,NULL,NULL,NULL,NULL),(3771,3770,0,'LSQ12gbz','LSQ',66.5849583333333,-10.1035277777778,NULL,NULL,'2012-11-04 07:02:53',56235.29367,19.4134,0.1229,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_history.html','sne - nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_snap_70536.gif',37466637666,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585416213,9147128,NULL,NULL,NULL,NULL),(3772,3770,0,'LSQ12gbz','LSQ',66.5849166666667,-10.1035,NULL,NULL,'2012-11-06 05:46:34',56237.2406799998,18.9914,0.0756,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_history.html','sne - nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_snap_70493.gif',37466637666,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585416213,9147128,NULL,NULL,NULL,NULL),(3773,3770,0,'LSQ12gbz','LSQ',66.5849583333333,-10.1035833333333,NULL,NULL,'2012-11-06 07:17:30',56237.30382,19.0222,0.0975,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_history.html','sne - nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_snap_70494.gif',37466637666,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585416213,9147128,NULL,NULL,NULL,NULL),(3774,3770,0,'LSQ12gbz','LSQ',66.5849583333333,-10.1035833333333,NULL,NULL,'2012-11-08 06:03:46',56239.2526199999,18.8467,0.0611,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_history.html','sne - nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_snap_70676.gif',37466637666,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585416213,9147128,NULL,NULL,NULL,NULL),(3775,3770,0,'LSQ12gbz','LSQ',66.5849166666667,-10.1035555555556,NULL,NULL,'2012-11-08 07:25:21',56239.3092800002,18.9429,0.0681,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_history.html','sne - nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_snap_70677.gif',37466637666,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585416213,9147128,NULL,NULL,NULL,NULL),(3776,3776,1,'LSQ12gbx','LSQ',21.3094583333333,9.62536111111111,NULL,NULL,'2012-11-06 00:24:34',56237.0170700001,20.2748,0.1194,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbx/LSQ12gbx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbx/LSQ12gbx_snap_70534.gif',67541894593,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1055342103,16489720,NULL,NULL,NULL,NULL),(3777,3776,0,'LSQ12gbx','LSQ',21.3095,9.62530555555556,NULL,NULL,'2012-11-06 02:22:13',56237.09877,19.8786,0.1034,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbx/LSQ12gbx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbx/LSQ12gbx_snap_70488.gif',67541894593,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1055342103,16489720,NULL,NULL,NULL,NULL),(3778,3776,0,'LSQ12gbx','LSQ',21.309375,9.62522222222222,NULL,NULL,'2012-11-06 04:21:25',56237.1815399998,20.1851,0.1293,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbx/LSQ12gbx_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbx/LSQ12gbx_snap_70489.gif',67541894593,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1055342103,16489720,NULL,NULL,NULL,NULL),(3779,3779,1,'LSQ12gbu','LSQ',22.3757916666667,10.3004166666667,NULL,NULL,'2012-11-06 00:24:34',56237.0170700001,20.7169,0.14,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbu/LSQ12gbu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbu/LSQ12gbu_snap_70221.gif',67544240154,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1055378752,16490293,NULL,NULL,NULL,NULL),(3780,3779,0,'LSQ12gbu','LSQ',22.375625,10.3003055555556,NULL,NULL,'2012-11-06 02:22:13',56237.09877,21.1102,0.1644,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbu/LSQ12gbu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbu/LSQ12gbu_snap_70222.gif',67544240155,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1055378752,16490293,NULL,NULL,NULL,NULL),(3781,3779,0,'LSQ12gbu','LSQ',22.37575,10.3003888888889,NULL,NULL,'2012-11-06 04:21:25',56237.1815399998,21.106,0.1581,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbu/LSQ12gbu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbu/LSQ12gbu_snap_70234.gif',67544240155,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1055378752,16490293,NULL,NULL,NULL,NULL),(3782,3782,1,'LSQ12gbq','LSQ',60.2248333333333,-14.5961944444444,NULL,NULL,'2012-11-02 04:44:47',56233.19777,17.653,0.1096,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbq/LSQ12gbq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbq/LSQ12gbq_snap_70232.gif',36896426567,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576506665,9007916,NULL,NULL,NULL,NULL),(3783,3782,0,'LSQ12gbq','LSQ',60.224875,-14.5961388888889,NULL,NULL,'2012-11-02 06:44:20',56233.2807900002,18.4751,0.1475,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbq/LSQ12gbq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbq/LSQ12gbq_snap_70233.gif',36896426567,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576506665,9007916,NULL,NULL,NULL,NULL),(3784,3782,0,'LSQ12gbq','LSQ',60.2250416666667,-14.59625,NULL,NULL,'2012-11-06 05:15:53',56237.2193700001,18.2,0.131,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbq/LSQ12gbq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbq/LSQ12gbq_snap_70213.gif',36896426567,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576506665,9007916,NULL,NULL,NULL,NULL),(3785,3782,0,'LSQ12gbq','LSQ',60.2249166666667,-14.5963333333333,NULL,NULL,'2012-11-06 07:02:05',56237.29312,19.0136,0.0939,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbq/LSQ12gbq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbq/LSQ12gbq_snap_70214.gif',36896426567,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576506665,9007916,NULL,NULL,NULL,NULL),(3786,3786,1,'LSQ12gef','LSQ',25.1405416666667,18.5100833333333,NULL,NULL,'2012-11-02 01:09:06',56233.0479899999,19.1569,0.1324,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_snap_70769.gif',67385903372,NULL,NULL,NULL,'2012-10-31 03:53:16',56231.162,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1052904740,16451636,NULL,NULL,NULL,NULL),(3787,3786,0,'LSQ12gef','LSQ',25.1404166666667,18.51025,NULL,NULL,'2012-11-02 03:09:07',56233.1313399998,18.7368,0.1171,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_snap_70770.gif',67385903372,NULL,NULL,NULL,'2012-10-31 03:53:16',56231.162,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1052904740,16451636,NULL,NULL,NULL,NULL),(3788,3786,0,'LSQ12gef','LSQ',25.1404583333333,18.5101111111111,NULL,NULL,'2012-11-04 01:08:47',56235.0477700001,18.9423,0.0711,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_snap_70771.gif',67385903372,NULL,NULL,NULL,'2012-10-31 03:53:16',56231.162,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1052904740,16451636,NULL,NULL,NULL,NULL),(3789,3786,0,'LSQ12gef','LSQ',25.1404583333333,18.5100277777778,NULL,NULL,'2012-11-04 03:09:10',56235.1313700001,19.2615,0.0867,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_snap_70772.gif',67385903372,NULL,NULL,NULL,'2012-10-31 03:53:16',56231.162,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1052904740,16451636,NULL,NULL,NULL,NULL),(3790,3786,0,'LSQ12gef','LSQ',25.1404583333333,18.51,NULL,NULL,'2012-11-06 01:52:58',56237.0784499999,18.9994,0.0781,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_snap_70773.gif',67385903372,NULL,NULL,NULL,'2012-10-31 03:53:16',56231.162,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1052904740,16451636,NULL,NULL,NULL,NULL),(3791,3786,0,'LSQ12gef','LSQ',25.1404166666667,18.5101111111111,NULL,NULL,'2012-11-06 03:53:08',56237.1619000002,18.4994,0.0703,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_snap_70774.gif',67385903372,NULL,NULL,NULL,'2012-10-31 03:53:16',56231.162,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1052904740,16451636,NULL,NULL,NULL,NULL),(3792,3786,0,'LSQ12gef','LSQ',25.1403333333333,18.5101111111111,NULL,NULL,'2012-11-07 00:52:56',56238.03676,18.5438,0.0398,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_snap_70740.gif',67385903372,NULL,NULL,NULL,'2012-10-31 03:53:16',56231.162,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1052904740,16451636,NULL,NULL,NULL,NULL),(3793,3786,0,'LSQ12gef','LSQ',25.140375,18.5101111111111,NULL,NULL,'2012-11-07 02:33:31',56238.1066100001,18.5399,0.0359,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_snap_70775.gif',67385903372,NULL,NULL,NULL,'2012-10-31 03:53:16',56231.162,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1052904740,16451636,NULL,NULL,NULL,NULL),(3794,3786,0,'LSQ12gef','LSQ',25.1403333333333,18.5101388888889,NULL,NULL,'2012-11-07 04:15:12',56238.17723,18.3072,0.0318,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_snap_70741.gif',67385903372,NULL,NULL,NULL,'2012-10-31 03:53:16',56231.162,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1052904740,16451636,NULL,NULL,NULL,NULL),(3795,3786,0,'LSQ12gef','LSQ',25.1405,18.5101111111111,NULL,NULL,'2012-11-08 01:46:03',56239.0736500002,18.3205,0.0534,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_snap_70778.gif',67385903372,NULL,NULL,NULL,'2012-10-31 03:53:16',56231.162,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1052904740,16451636,NULL,NULL,NULL,NULL),(3796,3786,0,'LSQ12gef','LSQ',25.1404166666667,18.5100833333333,NULL,NULL,'2012-11-08 03:45:29',56239.1565899998,18.3704,0.0513,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_snap_70779.gif',67385903372,NULL,NULL,NULL,'2012-10-31 03:53:16',56231.162,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1052904740,16451636,NULL,NULL,NULL,NULL),(3797,3797,1,'LSQ12gdj','LSQ',358.680458333333,-25.6761666666667,NULL,NULL,'2012-11-07 01:47:14',56238.0744699999,18.3967,0.0626,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdj/LSQ12gdj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdj/LSQ12gdj_snap_70602.gif',50005825249,NULL,NULL,NULL,'2012-11-05 01:14:52',56236.052,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781341019,12208453,NULL,NULL,NULL,NULL),(3798,3797,0,'LSQ12gdj','LSQ',358.6805,-25.6761111111111,NULL,NULL,'2012-11-07 03:47:58',56238.1583199999,18.2625,0.0641,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdj/LSQ12gdj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdj/LSQ12gdj_snap_70603.gif',50005825251,NULL,NULL,NULL,'2012-11-05 01:14:52',56236.052,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781341019,12208453,NULL,NULL,NULL,NULL),(3799,3799,1,'LSQ12gdi','LSQ',346.628958333333,-28.7686944444444,NULL,NULL,'2012-11-03 00:12:14',56234.0085,19.3765,0.133,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdi/LSQ12gdi_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdi/LSQ12gdi_snap_70658.gif',50135209438,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,783362647,12240041,NULL,NULL,NULL,NULL),(3800,3799,0,'LSQ12gdi','LSQ',346.628958333333,-28.7686666666667,NULL,NULL,'2012-11-07 00:24:03',56238.0167100001,19.6173,0.077,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdi/LSQ12gdi_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdi/LSQ12gdi_snap_70600.gif',50135209438,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,783362647,12240041,NULL,NULL,NULL,NULL),(3801,3799,0,'LSQ12gdi','LSQ',346.628916666667,-28.76875,NULL,NULL,'2012-11-07 02:24:29',56238.1003399999,19.7661,0.0852,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdi/LSQ12gdi_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdi/LSQ12gdi_snap_70601.gif',50135209438,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,783362647,12240041,NULL,NULL,NULL,NULL),(3802,3802,1,'LSQ12gdg','LSQ',74.8031666666667,-25.9331388888889,NULL,NULL,'2012-11-01 05:28:48',56232.2283399999,18.8515,0.1496,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdg/LSQ12gdg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdg/LSQ12gdg_snap_70646.gif',37227729909,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,581683279,9088801,NULL,NULL,NULL,NULL),(3803,3802,0,'LSQ12gdg','LSQ',74.803375,-25.9332222222222,NULL,NULL,'2012-11-01 07:45:35',56232.32333,19.2059,0.1782,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdg/LSQ12gdg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdg/LSQ12gdg_snap_70647.gif',37227729909,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,581683279,9088801,NULL,NULL,NULL,NULL),(3804,3802,0,'LSQ12gdg','LSQ',74.8032916666667,-25.9333055555556,NULL,NULL,'2012-11-03 05:30:40',56234.22963,18.6243,0.1149,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdg/LSQ12gdg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdg/LSQ12gdg_snap_70648.gif',37227729909,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,581683279,9088801,NULL,NULL,NULL,NULL),(3805,3802,0,'LSQ12gdg','LSQ',74.8034583333333,-25.9331944444444,NULL,NULL,'2012-11-03 07:11:49',56234.2998799998,18.8466,0.1195,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdg/LSQ12gdg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdg/LSQ12gdg_snap_70649.gif',37227729909,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,581683279,9088801,NULL,NULL,NULL,NULL),(3806,3802,0,'LSQ12gdg','LSQ',74.8032916666667,-25.93325,NULL,NULL,'2012-11-05 07:57:13',56236.3314100001,19.1449,0.1283,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdg/LSQ12gdg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdg/LSQ12gdg_snap_70650.gif',37227729909,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,581683279,9088801,NULL,NULL,NULL,NULL),(3807,3802,0,'LSQ12gdg','LSQ',74.8035416666667,-25.933,NULL,NULL,'2012-11-07 06:29:34',56238.2705399999,18.7163,0.0868,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdg/LSQ12gdg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdg/LSQ12gdg_snap_70596.gif',37227729909,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,581683279,9088801,NULL,NULL,NULL,NULL),(3808,3802,0,'LSQ12gdg','LSQ',74.8032916666667,-25.9331388888889,NULL,NULL,'2012-11-07 07:38:14',56238.3182199998,18.6518,0.0887,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdg/LSQ12gdg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdg/LSQ12gdg_snap_70597.gif',37227729909,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,581683279,9088801,NULL,NULL,NULL,NULL),(3809,3809,1,'LSQ12gdd','LSQ',53.6042916666667,-26.7740277777778,NULL,NULL,'2012-11-02 01:21:51',56233.0568499998,20.4933,0.1538,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70639.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(3810,3809,0,'LSQ12gdd','LSQ',53.6042916666667,-26.774,NULL,NULL,'2012-11-03 01:15:52',56234.0526899998,20.3559,0.1485,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70640.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(3811,3809,0,'LSQ12gdd','LSQ',53.604375,-26.7740277777778,NULL,NULL,'2012-11-04 01:10:56',56235.0492699998,20.3304,0.1253,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70641.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(3812,3809,0,'LSQ12gdd','LSQ',53.6042083333333,-26.7740277777778,NULL,NULL,'2012-11-04 03:11:18',56235.1328500002,20.5727,0.1358,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70642.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(3813,3809,0,'LSQ12gdd','LSQ',53.60425,-26.7740277777778,NULL,NULL,'2012-11-05 03:09:12',56236.1313900002,20.3231,0.1308,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70643.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(3814,3809,0,'LSQ12gdd','LSQ',53.6043333333333,-26.7740277777778,NULL,NULL,'2012-11-07 01:16:26',56238.0530900001,19.7308,0.0775,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70590.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(3815,3809,0,'LSQ12gdd','LSQ',53.6042083333333,-26.7740277777778,NULL,NULL,'2012-11-07 03:19:03',56238.1382300002,19.9336,0.0899,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70591.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(3816,3809,0,'LSQ12gdd','LSQ',53.6042083333333,-26.774,NULL,NULL,'2012-11-08 01:15:00',56239.0520899999,19.9932,0.0774,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70692.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(3817,3809,0,'LSQ12gdd','LSQ',53.60425,-26.7740277777778,NULL,NULL,'2012-11-08 03:15:42',56239.1359100002,20.0334,0.0604,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70693.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(3818,3818,0,'LSQ12gdc','LSQ',74.1528333333333,-31.6034444444444,NULL,NULL,'2012-11-05 07:06:37',56236.2962699998,18.0497,0.1187,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-12-24 20:38:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_70638.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(3819,3818,0,'LSQ12gdc','LSQ',74.1528333333333,-31.6034444444444,NULL,NULL,'2012-11-07 06:00:35',56238.2504099999,17.605,0.0599,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_70588.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(3820,3818,0,'LSQ12gdc','LSQ',74.1528333333333,-31.6034166666667,NULL,NULL,'2012-11-07 08:15:13',56238.3439099998,17.5881,0.0705,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_70589.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(3821,3821,1,'LSQ12gcw','LSQ',68.3187083333333,-38.1013055555556,NULL,NULL,'2012-11-01 04:30:26',56232.18781,19.6004,0.1328,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_70622.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(3822,3821,0,'LSQ12gcw','LSQ',68.31875,-38.1013611111111,NULL,NULL,'2012-11-01 06:31:26',56232.2718400001,20.2649,0.1904,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_70623.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(3823,3821,0,'LSQ12gcw','LSQ',68.3187083333333,-38.1013611111111,NULL,NULL,'2012-11-03 04:31:29',56234.18854,19.7616,0.2023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_70624.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(3824,3821,0,'LSQ12gcw','LSQ',68.318375,-38.1013888888889,NULL,NULL,'2012-11-03 06:32:09',56234.2723300001,20.1352,0.1848,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_70625.gif',37823536133,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(3825,3821,0,'LSQ12gcw','LSQ',68.31875,-38.1013888888889,NULL,NULL,'2012-11-05 04:51:53',56236.2026999998,19.9479,0.1045,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_70626.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(3826,3821,0,'LSQ12gcw','LSQ',68.3189583333333,-38.1013888888889,NULL,NULL,'2012-11-05 06:50:23',56236.2849900001,19.8655,0.126,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_70627.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(3827,3821,0,'LSQ12gcw','LSQ',68.3187083333333,-38.1013888888889,NULL,NULL,'2012-11-07 05:21:22',56238.2231800002,19.7639,0.1023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_70576.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(3828,3821,0,'LSQ12gcw','LSQ',68.3187083333333,-38.1013611111111,NULL,NULL,'2012-11-07 08:28:54',56238.35341,19.9431,0.1643,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 19:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_70577.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(3829,3809,0,'LSQ12gdd','LSQ',53.6035,-26.774,NULL,NULL,'2012-11-08 01:18:41',56239.0546499998,19.9942,0.0721,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 20:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70795.gif',38579529024,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(3830,3809,0,'LSQ12gdd','LSQ',53.6035,-26.7739444444444,NULL,NULL,'2012-11-08 03:19:23',56239.1384700001,19.6402,0.0619,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 20:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70796.gif',38579529027,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(3831,3809,0,'LSQ12gdd','LSQ',53.6035416666667,-26.7739444444444,NULL,NULL,'2012-11-02 01:23:33',56233.05803,19.8427,0.1084,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 21:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70858.gif',38579529027,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(3832,3809,0,'LSQ12gdd','LSQ',53.6035416666667,-26.7739722222222,NULL,NULL,'2012-11-03 01:17:34',56234.0538699999,20.1748,0.1299,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 21:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70859.gif',38579529024,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(3833,3809,0,'LSQ12gdd','LSQ',53.6035833333333,-26.7739722222222,NULL,NULL,'2012-11-03 03:17:47',56234.1373600001,19.9738,0.1504,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 21:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70860.gif',38579529024,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(3834,3809,0,'LSQ12gdd','LSQ',53.6035416666667,-26.7739722222222,NULL,NULL,'2012-11-04 01:12:38',56235.0504399999,20.0718,0.1335,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 21:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70861.gif',38579529024,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(3835,3809,0,'LSQ12gdd','LSQ',53.6035416666667,-26.774,NULL,NULL,'2012-11-04 03:12:59',56235.1340200002,20.0153,0.111,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 21:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70862.gif',38579529024,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(3836,3809,0,'LSQ12gdd','LSQ',53.6035833333333,-26.774,NULL,NULL,'2012-11-05 01:09:34',56236.0483200001,20.1929,0.1465,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 21:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70863.gif',38579529024,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(3837,3809,0,'LSQ12gdd','LSQ',53.6035,-26.7740277777778,NULL,NULL,'2012-11-05 03:10:52',56236.1325500002,20.1924,0.1173,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 21:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70864.gif',38579529024,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(3838,3809,0,'LSQ12gdd','LSQ',53.6035,-26.7739722222222,NULL,NULL,'2012-11-07 01:20:08',56238.05565,19.7272,0.0704,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 21:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70865.gif',38579529024,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(3839,3809,0,'LSQ12gdd','LSQ',53.6035,-26.774,NULL,NULL,'2012-11-07 03:22:45',56238.1408099998,19.8677,0.0652,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 21:45:54','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70866.gif',38579529024,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(3840,3840,1,'LSQ12ger','LSQ',70.3192916666667,-17.1045555555556,NULL,NULL,'2012-11-02 06:27:06',56233.26883,19.8936,0.1548,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 21:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ger/LSQ12ger_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ger/LSQ12ger_snap_70847.gif',37535473676,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586491776,9163934,NULL,NULL,NULL,NULL),(3841,3840,0,'LSQ12ger','LSQ',70.3193333333333,-17.1045,NULL,NULL,'2012-11-06 04:50:15',56237.20157,20.255,0.1367,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 21:45:54','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ger/LSQ12ger_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ger/LSQ12ger_snap_70848.gif',37535473676,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586491776,9163934,NULL,NULL,NULL,NULL),(3842,3840,0,'LSQ12ger','LSQ',70.3194583333333,-17.1044722222222,NULL,NULL,'2012-11-06 08:26:06',56237.35146,20.3498,0.1825,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 21:45:54','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ger/LSQ12ger_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ger/LSQ12ger_snap_70849.gif',37535473676,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586491776,9163934,NULL,NULL,NULL,NULL),(3843,3840,0,'LSQ12ger','LSQ',70.319375,-17.1045833333333,NULL,NULL,'2012-11-08 05:05:07',56239.2118899999,20.7346,0.1461,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 21:45:54','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ger/LSQ12ger_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ger/LSQ12ger_snap_70809.gif',37535473676,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586491776,9163934,NULL,NULL,NULL,NULL),(3844,3840,0,'LSQ12ger','LSQ',70.3194583333333,-17.1045833333333,NULL,NULL,'2012-11-08 06:59:31',56239.29134,20.0902,0.1674,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 21:45:54','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ger/LSQ12ger_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ger/LSQ12ger_snap_70810.gif',37535473676,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586491776,9163934,NULL,NULL,NULL,NULL),(3845,3845,1,'LSQ12geg','LSQ',55.053125,-26.7930277777778,NULL,NULL,'2012-11-07 01:16:26',56238.0530900001,20.7659,0.1034,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_snap_70780.gif',38582715225,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602854925,9419608,NULL,NULL,NULL,NULL),(3846,3845,0,'LSQ12geg','LSQ',55.053375,-26.7930555555556,NULL,NULL,'2012-11-07 03:19:03',56238.1382300002,20.2498,0.0778,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_snap_70781.gif',38582715225,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602854925,9419608,NULL,NULL,NULL,NULL),(3847,3845,0,'LSQ12geg','LSQ',55.05275,-26.793,NULL,NULL,'2012-11-08 01:15:00',56239.0520899999,21.9006,0.1767,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_snap_70852.gif',38582715225,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602854925,9419608,NULL,NULL,NULL,NULL),(3848,3848,1,'LSQ12get','LSQ',75.5435416666667,-20.9544722222222,NULL,NULL,'2012-11-02 06:32:10',56233.2723400001,18.7162,0.1172,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12get/LSQ12get_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12get/LSQ12get_snap_70850.gif',37550558380,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586727474,9167616,NULL,NULL,NULL,NULL),(3849,3848,0,'LSQ12get','LSQ',75.5432916666667,-20.9546666666667,NULL,NULL,'2012-11-08 05:17:30',56239.2204900002,20.3669,0.1131,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12get/LSQ12get_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12get/LSQ12get_snap_70813.gif',37550558380,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586727474,9167616,NULL,NULL,NULL,NULL),(3850,3848,0,'LSQ12get','LSQ',75.5432916666667,-20.9546666666667,NULL,NULL,'2012-11-08 07:02:53',56239.2936800001,20.4987,0.1249,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12get/LSQ12get_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12get/LSQ12get_snap_70814.gif',37550558380,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586727474,9167616,NULL,NULL,NULL,NULL),(3851,3851,1,'LSQ12ges','LSQ',74.9863333333333,-19.46425,NULL,NULL,'2012-11-08 05:15:46',56239.2192899999,20.1803,0.093,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_snap_70811.gif',37563466777,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586929168,9170768,NULL,NULL,NULL,NULL),(3852,3851,0,'LSQ12ges','LSQ',74.986375,-19.4643888888889,NULL,NULL,'2012-11-08 07:01:12',56239.2925100001,21.0317,0.1496,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_snap_70812.gif',37563466779,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586929168,9170768,NULL,NULL,NULL,NULL),(3853,3853,1,'LSQ12geq','LSQ',71.3340416666667,-21.0598611111111,NULL,NULL,'2012-11-04 04:28:57',56235.1867800001,20.3898,0.1552,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geq/LSQ12geq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geq/LSQ12geq_snap_70844.gif',37334614580,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,583353352,9114896,NULL,NULL,NULL,NULL),(3854,3853,0,'LSQ12geq','LSQ',71.334,-21.05975,NULL,NULL,'2012-11-04 06:30:14',56235.2710000002,20.3114,0.1412,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geq/LSQ12geq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geq/LSQ12geq_snap_70845.gif',37334614580,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,583353352,9114896,NULL,NULL,NULL,NULL),(3855,3853,0,'LSQ12geq','LSQ',71.3339166666667,-21.0597222222222,NULL,NULL,'2012-11-06 04:50:15',56237.20157,20.8428,0.1462,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geq/LSQ12geq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geq/LSQ12geq_snap_70846.gif',37334614580,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,583353352,9114896,NULL,NULL,NULL,NULL),(3856,3853,0,'LSQ12geq','LSQ',71.333875,-21.0596666666667,NULL,NULL,'2012-11-08 05:05:07',56239.2118899999,20.2931,0.1428,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geq/LSQ12geq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geq/LSQ12geq_snap_70807.gif',37334614580,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,583353352,9114896,NULL,NULL,NULL,NULL),(3857,3853,0,'LSQ12geq','LSQ',71.334,-21.0597222222222,NULL,NULL,'2012-11-08 06:59:31',56239.29134,20.5422,0.1293,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geq/LSQ12geq_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geq/LSQ12geq_snap_70808.gif',37334614580,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,583353352,9114896,NULL,NULL,NULL,NULL),(3858,3858,1,'LSQ12gep','LSQ',66.151625,-20.3381944444444,NULL,NULL,'2012-11-04 04:25:33',56235.1844199998,18.7923,0.1397,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gep/LSQ12gep_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gep/LSQ12gep_snap_70840.gif',37323473740,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583179277,9112176,NULL,NULL,NULL,NULL),(3859,3858,0,'LSQ12gep','LSQ',66.1518333333333,-20.3381666666667,NULL,NULL,'2012-11-04 06:26:51',56235.26865,18.8716,0.139,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gep/LSQ12gep_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gep/LSQ12gep_snap_70841.gif',37323473733,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583179277,9112176,NULL,NULL,NULL,NULL),(3860,3858,0,'LSQ12gep','LSQ',66.1514166666667,-20.3379166666667,NULL,NULL,'2012-11-06 04:46:54',56237.19924,19.3257,0.1444,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gep/LSQ12gep_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gep/LSQ12gep_snap_70842.gif',37323473740,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583179277,9112176,NULL,NULL,NULL,NULL),(3861,3858,0,'LSQ12gep','LSQ',66.1515,-20.33825,NULL,NULL,'2012-11-06 06:46:54',56237.2825799999,19.149,0.1441,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gep/LSQ12gep_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gep/LSQ12gep_snap_70843.gif',37323473740,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583179277,9112176,NULL,NULL,NULL,NULL),(3862,3858,0,'LSQ12gep','LSQ',66.1514583333333,-20.3378055555556,NULL,NULL,'2012-11-08 05:01:43',56239.2095300001,20.0768,0.114,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gep/LSQ12gep_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gep/LSQ12gep_snap_70805.gif',37323473740,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583179277,9112176,NULL,NULL,NULL,NULL),(3863,3858,0,'LSQ12gep','LSQ',66.1517916666667,-20.338,NULL,NULL,'2012-11-08 08:32:20',56239.3557899999,19.1995,0.1384,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gep/LSQ12gep_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gep/LSQ12gep_snap_70806.gif',37323473733,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583179277,9112176,NULL,NULL,NULL,NULL),(3864,3864,1,'LSQ12gel','LSQ',55.7508333333333,-26.6940833333333,NULL,NULL,'2012-11-04 03:12:59',56235.1340200002,21.0511,0.1635,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_snap_70825.gif',38528356173,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602005565,9406336,NULL,NULL,NULL,NULL),(3865,3864,0,'LSQ12gel','LSQ',55.7505416666667,-26.6940277777778,NULL,NULL,'2012-11-07 03:22:45',56238.1408099998,19.0182,0.0424,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_snap_70826.gif',38528356173,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602005565,9406336,NULL,NULL,NULL,NULL),(3866,3864,0,'LSQ12gel','LSQ',55.7508333333333,-26.6940277777778,NULL,NULL,'2012-11-08 01:18:41',56239.0546499998,19.5852,0.0532,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_snap_70793.gif',38528356173,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602005565,9406336,NULL,NULL,NULL,NULL),(3867,3864,0,'LSQ12gel','LSQ',55.7504583333333,-26.6940277777778,NULL,NULL,'2012-11-08 03:19:23',56239.1384700001,19.0974,0.0461,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_snap_70794.gif',38528356173,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602005565,9406336,NULL,NULL,NULL,NULL),(3868,3868,1,'LSQ12gek','LSQ',55.5484166666667,-26.7352222222222,NULL,NULL,'2012-11-07 03:22:45',56238.1408099998,18.1682,0.0296,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_snap_70824.gif',38579734652,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602808353,9418880,NULL,NULL,NULL,NULL),(3869,3868,0,'LSQ12gek','LSQ',55.5483333333333,-26.7351111111111,NULL,NULL,'2012-11-08 01:18:41',56239.0546499998,19.9623,0.0986,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-06 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_snap_70791.gif',38579734652,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602808353,9418880,NULL,NULL,NULL,NULL),(3870,3868,0,'LSQ12gek','LSQ',55.5485,-26.7352222222222,NULL,NULL,'2012-11-08 03:19:23',56239.1384700001,18.3311,0.0406,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-08 22:45:55','2012-12-06 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_snap_70792.gif',38579734652,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602808353,9418880,NULL,NULL,NULL,NULL),(3871,3809,0,'LSQ12gdd','LSQ',53.60425,-26.7740555555556,NULL,NULL,'2012-11-06 01:03:23',56237.0440199999,19.5413,0.0702,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 03:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70878.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(3872,3809,0,'LSQ12gdd','LSQ',53.6034166666667,-26.7739444444444,NULL,NULL,'2012-11-06 01:09:03',56237.0479600001,19.5653,0.0753,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 03:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70876.gif',38579529027,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(3873,3809,0,'LSQ12gdd','LSQ',53.6042916666667,-26.7740277777778,NULL,NULL,'2012-11-06 03:06:04',56237.12922,20.0562,0.0524,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 03:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70879.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(3874,3809,0,'LSQ12gdd','LSQ',53.603375,-26.7739166666667,NULL,NULL,'2012-11-06 03:11:45',56237.1331699998,19.6651,0.1547,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 03:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_70877.gif',38579529027,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(3875,3845,0,'LSQ12geg','LSQ',55.053,-26.7932777777778,NULL,NULL,'2012-11-06 01:03:23',56237.0440199999,21.3727,0.131,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 03:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_snap_70880.gif',38582715225,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602854925,9419608,NULL,NULL,NULL,NULL),(3876,3845,0,'LSQ12geg','LSQ',55.0529583333333,-26.7928611111111,NULL,NULL,'2012-11-06 03:06:04',56237.12922,18.7204,0.0425,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 03:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_snap_70881.gif',38582715225,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602854925,9419608,NULL,NULL,NULL,NULL),(3877,3868,0,'LSQ12gek','LSQ',55.5482916666667,-26.7351111111111,NULL,NULL,'2012-11-06 03:11:45',56237.1331699998,17.8747,0.0329,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 03:45:56','2012-12-06 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_snap_70882.gif',38579734652,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602808353,9418880,NULL,NULL,NULL,NULL),(3878,3878,1,'LSQ12gfp','LSQ',63.8425833333333,-1.73316666666667,NULL,NULL,'2012-10-31 06:19:18',56231.2634100001,18.4218,0.1793,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 15:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfp/LSQ12gfp_history.html','old sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfp/LSQ12gfp_snap_71007.gif',36915961080,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,576811891,9012685,NULL,NULL,NULL,NULL),(3879,3878,0,'LSQ12gfp','LSQ',63.8423333333333,-1.73322222222222,NULL,NULL,'2012-11-02 07:18:27',56233.3044799999,19.3397,0.1356,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 15:45:54','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfp/LSQ12gfp_history.html','old sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfp/LSQ12gfp_snap_71008.gif',36915961080,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,576811891,9012685,NULL,NULL,NULL,NULL),(3880,3878,0,'LSQ12gfp','LSQ',63.8425,-1.73313888888889,NULL,NULL,'2012-11-04 05:47:25',56235.2412700001,20.0089,0.1515,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 15:45:54','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfp/LSQ12gfp_history.html','old sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfp/LSQ12gfp_snap_71009.gif',36915961080,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,576811891,9012685,NULL,NULL,NULL,NULL),(3881,3878,0,'LSQ12gfp','LSQ',63.8424166666667,-1.73327777777778,NULL,NULL,'2012-11-08 06:34:16',56239.2738000001,20.92,0.1644,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 15:45:54','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfp/LSQ12gfp_history.html','old sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfp/LSQ12gfp_snap_70921.gif',36915961080,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,576811891,9012685,NULL,NULL,NULL,NULL),(3882,3878,0,'LSQ12gfp','LSQ',63.84225,-1.73322222222222,NULL,NULL,'2012-11-08 07:41:07',56239.3202200001,20.4037,0.1388,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 15:45:54','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfp/LSQ12gfp_history.html','old sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfp/LSQ12gfp_snap_70922.gif',36915961080,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,576811891,9012685,NULL,NULL,NULL,NULL),(3883,3883,1,'LSQ12gfh','LSQ',53.69025,-6.84394444444444,NULL,NULL,'2012-10-10 08:59:52',56210.3749099998,19.5896,0.1475,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 15:45:54','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_history.html','sne??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_snap_70987.gif',36800390527,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575006101,8984470,NULL,NULL,NULL,NULL),(3884,3883,0,'LSQ12gfh','LSQ',53.6904166666667,-6.844,NULL,NULL,'2012-10-24 07:47:49',56224.3248800002,19.1074,0.0859,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 15:45:54','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_history.html','sne??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_snap_70988.gif',36800390527,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575006101,8984470,NULL,NULL,NULL,NULL),(3885,3883,0,'LSQ12gfh','LSQ',53.6905416666667,-6.84377777777778,NULL,NULL,'2012-11-02 07:06:37',56233.2962699998,16.9207,0.0256,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 15:45:54','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_history.html','sne??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_snap_70989.gif',36800390526,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575006101,8984470,NULL,NULL,NULL,NULL),(3886,3883,0,'LSQ12gfh','LSQ',53.690375,-6.84394444444444,NULL,NULL,'2012-11-04 07:06:21',56235.2960799998,16.9236,0.0199,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 15:45:54','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_history.html','sne??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_snap_70990.gif',36800390527,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575006101,8984470,NULL,NULL,NULL,NULL),(3887,3883,0,'LSQ12gfh','LSQ',53.6905416666667,-6.84380555555556,NULL,NULL,'2012-11-08 06:10:33',56239.2573299999,16.9172,0.0153,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 15:45:54','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_history.html','sne??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_snap_70905.gif',36800390526,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575006101,8984470,NULL,NULL,NULL,NULL),(3888,3883,0,'LSQ12gfh','LSQ',53.6905416666667,-6.84380555555556,NULL,NULL,'2012-11-08 07:28:50',56239.3116899999,16.9906,0.0172,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 15:45:54','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_history.html','sne??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_snap_70906.gif',36800390526,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575006101,8984470,NULL,NULL,NULL,NULL),(3889,3889,1,'LSQ12gft','LSQ',56.5038333333333,-28.9318888888889,NULL,NULL,'2012-10-26 01:48:36',56226.0754200001,19.5991,0.211,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 16:45:56','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gft/LSQ12gft_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gft/LSQ12gft_snap_71026.gif',38583605078,NULL,NULL,NULL,'2012-10-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602868829,9419825,NULL,NULL,NULL,NULL),(3890,3889,0,'LSQ12gft','LSQ',56.504375,-28.9318055555556,NULL,NULL,'2012-11-06 01:09:03',56237.0479600001,20.9805,0.113,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 16:45:56','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gft/LSQ12gft_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gft/LSQ12gft_snap_71018.gif',38583605078,NULL,NULL,NULL,'2012-10-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602868829,9419825,NULL,NULL,NULL,NULL),(3891,3889,0,'LSQ12gft','LSQ',56.5044166666667,-28.9320555555556,NULL,NULL,'2012-11-06 03:11:45',56237.1331699998,20.0097,0.1084,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 16:45:56','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gft/LSQ12gft_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gft/LSQ12gft_snap_71019.gif',38583605079,NULL,NULL,NULL,'2012-10-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602868829,9419825,NULL,NULL,NULL,NULL),(3892,3889,0,'LSQ12gft','LSQ',56.5046666666667,-28.9316111111111,NULL,NULL,'2012-11-07 01:20:08',56238.05565,20.5084,0.123,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 16:45:56','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gft/LSQ12gft_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gft/LSQ12gft_snap_71028.gif',38583605079,NULL,NULL,NULL,'2012-10-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602868829,9419825,NULL,NULL,NULL,NULL),(3893,3893,1,'LSQ12gfs','LSQ',55.3094583333333,-26.7208055555556,NULL,NULL,'2012-11-03 01:15:52',56234.0526899998,20.8094,0.14,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 16:45:56','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_snap_71024.gif',38579773067,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602808954,9418889,NULL,NULL,NULL,NULL),(3894,3893,0,'LSQ12gfs','LSQ',55.3094166666667,-26.7208333333333,NULL,NULL,'2012-11-04 03:11:18',56235.1328500002,21.1699,0.1726,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 16:45:56','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_snap_71025.gif',38579773067,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602808954,9418889,NULL,NULL,NULL,NULL),(3895,3893,0,'LSQ12gfs','LSQ',55.3095833333333,-26.7208055555556,NULL,NULL,'2012-11-06 01:03:23',56237.0440199999,19.8529,0.0444,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 16:45:56','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_snap_71016.gif',38579773067,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602808954,9418889,NULL,NULL,NULL,NULL),(3896,3893,0,'LSQ12gfs','LSQ',55.3098333333333,-26.72075,NULL,NULL,'2012-11-06 03:06:04',56237.12922,20.1928,0.1249,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 16:45:56','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_snap_71017.gif',38579773067,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602808954,9418889,NULL,NULL,NULL,NULL),(3897,3893,0,'LSQ12gfs','LSQ',55.3094583333333,-26.7207222222222,NULL,NULL,'2012-11-07 03:19:03',56238.1382300002,21.0244,0.12,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 16:45:56','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_snap_71027.gif',38579773067,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602808954,9418889,NULL,NULL,NULL,NULL),(3898,3898,1,'LSQ12gfi','LSQ',53.5566666666667,-6.84194444444444,NULL,NULL,'2012-11-02 07:06:37',56233.2962699998,15.2093,0.0064,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 18:45:56','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfi/LSQ12gfi_history.html','CV?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfi/LSQ12gfi_snap_70991.gif',36800371307,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575005801,8984465,NULL,NULL,NULL,NULL),(3899,3898,0,'LSQ12gfi','LSQ',53.5565,-6.84205555555556,NULL,NULL,'2012-11-04 07:06:21',56235.2960799998,15.2117,0.0052,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 18:45:56','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfi/LSQ12gfi_history.html','CV?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfi/LSQ12gfi_snap_70992.gif',36800371306,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575005801,8984465,NULL,NULL,NULL,NULL),(3900,3898,0,'LSQ12gfi','LSQ',53.5566666666667,-6.84194444444444,NULL,NULL,'2012-11-08 06:10:33',56239.2573299999,15.21,0.0043,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 18:45:56','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfi/LSQ12gfi_history.html','CV?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfi/LSQ12gfi_snap_70907.gif',36800371307,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575005801,8984465,NULL,NULL,NULL,NULL),(3901,3898,0,'LSQ12gfi','LSQ',53.5566666666667,-6.84194444444444,NULL,NULL,'2012-11-08 07:28:50',56239.3116899999,15.2141,0.0046,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 18:45:56','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfi/LSQ12gfi_history.html','CV?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfi/LSQ12gfi_snap_70908.gif',36800371307,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575005801,8984465,NULL,NULL,NULL,NULL),(3902,3902,1,'LSQ12gev','LSQ',0.408541666666667,-15.9622777777778,NULL,NULL,'2012-11-08 01:42:12',56239.0709799998,11.9741,0.0305,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 18:45:56','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gev/LSQ12gev_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gev/LSQ12gev_snap_70817.gif',34465619652,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,538525307,8414457,NULL,NULL,NULL,NULL),(3903,3902,0,'LSQ12gev','LSQ',0.40825,-15.962,NULL,NULL,'2012-11-08 03:41:44',56239.15399,10.0918,0.0307,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 18:45:56','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gev/LSQ12gev_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gev/LSQ12gev_snap_70818.gif',34465619652,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,538525307,8414457,NULL,NULL,NULL,NULL),(3904,3902,0,'LSQ12geu','LSQ',0.405041666666667,-15.9714444444444,NULL,NULL,'2012-11-08 01:42:12',56239.0709799998,12.1132,0.0318,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 18:45:56','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geu/LSQ12geu_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geu/LSQ12geu_snap_70815.gif',34465616358,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,538525255,8414457,NULL,NULL,NULL,NULL),(3905,3902,0,'LSQ12geu','LSQ',0.405041666666667,-15.9714722222222,NULL,NULL,'2012-11-08 03:41:44',56239.15399,10.0818,0.0292,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-09 18:45:56','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geu/LSQ12geu_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geu/LSQ12geu_snap_70816.gif',34465616358,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,538525255,8414457,NULL,NULL,NULL,NULL),(3906,3906,0,'PSNJ02324096-391756','TOCP',38.1706708333333,-39.2989555555556,NULL,NULL,'2012-11-10 03:50:24',56241.16,14.1,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-11-10 18:55:45','2019-10-12 20:41:36','NULL','supernova',NULL,0.0047,NULL,NULL,'http://www.das.uchile.cl/~gpignata/pessto/PSNJ02324096-3917562.gif',NULL,NULL,38623139302,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603486551,9429477,NULL,NULL,NULL,NULL),(3907,2974,0,'LSQ12frx','LSQ',12.98825,-23.7101666666667,NULL,NULL,'2012-11-09 04:13:12',56240.1758400002,18.9753,0.067,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_snap_71124.gif',35316090512,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(3908,3160,0,'LSQ12frr','LSQ',351.37875,-30.1273888888889,NULL,NULL,'2012-11-09 01:05:06',56240.0452100001,18.0319,0.0321,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_history.html','sne hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_snap_71151.gif',50188188166,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,784190440,12252975,NULL,NULL,NULL,NULL),(3909,3160,0,'LSQ12frr','LSQ',351.378791666667,-30.1273888888889,NULL,NULL,'2012-11-09 03:05:21',56240.1287199999,18.3913,0.045,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_history.html','sne hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frr/LSQ12frr_snap_71152.gif',50188188166,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,784190440,12252975,NULL,NULL,NULL,NULL),(3910,2985,0,'LSQ12fsh','LSQ',12.7767916666667,-39.16,NULL,NULL,'2012-11-09 02:21:26',56240.09822,18.4718,0.0332,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_71187.gif',38166915082,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(3911,2985,0,'LSQ12fsh','LSQ',12.776875,-39.1599444444444,NULL,NULL,'2012-11-09 04:21:40',56240.1817200002,18.5084,0.0323,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_71188.gif',38166915082,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(3912,2991,0,'LSQ12fsi','LSQ',1.50491666666667,-35.1926388888889,NULL,NULL,'2012-11-09 01:30:33',56240.0628900002,18.6239,0.0307,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_history.html','Old',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_snap_71194.gif',34665129379,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,541642646,8463166,NULL,NULL,NULL,NULL),(3913,2991,0,'LSQ12fsi','LSQ',1.50495833333333,-35.1925833333333,NULL,NULL,'2012-11-09 03:30:48',56240.1463899999,20.7397,0.1755,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_history.html','Old',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_snap_71195.gif',34665129379,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,541642646,8463166,NULL,NULL,NULL,NULL),(3914,2993,0,'LSQ12fss','LSQ',18.715875,-30.0939166666667,NULL,NULL,'2012-11-09 02:33:17',56240.1064499998,19.597,0.0641,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_71182.gif',34734808839,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(3915,2995,0,'LSQ12fsp','LSQ',357.212041666667,-38.5519166666667,NULL,NULL,'2012-11-09 01:23:50',56240.05822,16.0266,0.0069,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_history.html','Bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_snap_71186.gif',49991723132,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781120673,12205010,NULL,NULL,NULL,NULL),(3916,3001,0,'LSQ12fth','LSQ',47.8227916666667,-25.1096111111111,NULL,NULL,'2012-11-09 06:06:08',56240.2542699999,17.9428,0.0535,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_71173.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3917,3001,0,'LSQ12fth','LSQ',47.8225416666667,-25.1097222222222,NULL,NULL,'2012-11-09 07:27:00',56240.31042,18.4339,0.0374,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_71175.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3918,3001,0,'LSQ12fth','LSQ',47.82275,-25.1096111111111,NULL,NULL,'2012-11-09 07:54:46',56240.3297100002,17.8456,0.0309,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_71174.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3919,3007,0,'LSQ12fte','LSQ',52.152875,-24.8718611111111,NULL,NULL,'2012-11-09 07:53:05',56240.3285400001,19.4208,0.1371,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_snap_71193.gif',38021943870,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594092872,9282701,NULL,NULL,NULL,NULL),(3920,3009,0,'LSQ12ftd','LSQ',64.2444166666667,-24.1447222222222,NULL,NULL,'2012-11-09 06:21:22',56240.2648399998,19.7723,0.1465,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_71171.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3921,3009,0,'LSQ12ftd','LSQ',64.244625,-24.1448888888889,NULL,NULL,'2012-11-09 07:33:46',56240.3151199999,19.596,0.1418,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_71172.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3922,3009,0,'LSQ12ftd','LSQ',64.2445833333333,-24.1446944444444,NULL,NULL,'2012-11-09 07:48:02',56240.3250299999,19.5827,0.1399,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_71170.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3923,3013,0,'LSQ12ftc','LSQ',64.803125,-24.3553333333333,NULL,NULL,'2012-11-09 07:48:02',56240.3250299999,19.8898,0.1011,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_71166.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(3924,3017,0,'LSQ12ftb','LSQ',65.4215416666667,-23.7053333333333,NULL,NULL,'2012-11-09 06:19:40',56240.2636600002,17.9464,0.0338,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_71189.gif',37314276029,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3925,3017,0,'LSQ12ftb','LSQ',65.4220416666667,-23.7051944444444,NULL,NULL,'2012-11-09 06:21:22',56240.2648399998,18.3412,0.0401,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_71191.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3926,3017,0,'LSQ12ftb','LSQ',65.4220833333333,-23.7051944444444,NULL,NULL,'2012-11-09 07:33:46',56240.3151199999,18.5468,0.0447,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_71192.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3927,3017,0,'LSQ12ftb','LSQ',65.4215,-23.7053611111111,NULL,NULL,'2012-11-09 07:48:02',56240.3250299999,18.2631,0.036,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_71190.gif',37314276031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(3928,3024,0,'LSQ12fsu','LSQ',358.064333333333,-34.2621111111111,NULL,NULL,'2012-11-09 01:20:24',56240.05584,18.7232,0.0507,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsu/LSQ12fsu_history.html','Slow rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsu/LSQ12fsu_snap_71179.gif',49947390750,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,780427980,12194187,NULL,NULL,NULL,NULL),(3929,3112,0,'LSQ12fvu','LSQ',53.519125,-21.8744722222222,NULL,NULL,'2012-11-09 06:11:13',56240.2577900002,18.9957,0.0453,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_71084.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(3930,3112,0,'LSQ12fvu','LSQ',53.5190833333333,-21.8744722222222,NULL,NULL,'2012-11-09 07:28:41',56240.3115900001,19.0118,0.0845,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_71085.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(3931,3114,0,'LSQ12fvq','LSQ',19.1507083333333,-31.4520833333333,NULL,NULL,'2012-11-09 02:31:36',56240.1052799998,18.4446,0.0419,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_71116.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(3932,3114,0,'LSQ12fvq','LSQ',19.1506666666667,-31.4520833333333,NULL,NULL,'2012-11-09 02:33:17',56240.1064499998,18.6173,0.0363,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_71114.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(3933,3114,0,'LSQ12fvq','LSQ',19.1507916666667,-31.4520833333333,NULL,NULL,'2012-11-09 04:31:49',56240.1887699999,18.4937,0.0385,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_71117.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(3934,3114,0,'LSQ12fvq','LSQ',19.15075,-31.4520277777778,NULL,NULL,'2012-11-09 04:33:31',56240.18995,18.5847,0.0314,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_71115.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(3935,3122,0,'LSQ12fvn','LSQ',16.3920416666667,-35.49075,NULL,NULL,'2012-11-09 02:23:07',56240.0993900001,19.9183,0.0642,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_71125.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(3936,3122,0,'LSQ12fvn','LSQ',16.3920833333333,-35.4907777777778,NULL,NULL,'2012-11-09 04:23:21',56240.1828899998,20.0238,0.0719,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_71126.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(3937,3125,0,'LSQ12fvl','LSQ',75.2085416666667,-38.6531666666667,NULL,NULL,'2012-11-09 05:09:19',56240.2148099998,18.2364,0.0403,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_71118.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(3938,3125,0,'LSQ12fvl','LSQ',75.2085416666667,-38.6531944444444,NULL,NULL,'2012-11-09 06:57:23',56240.2898599999,18.0023,0.0378,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_71119.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(3939,3222,0,'LSQ12fvm','LSQ',47.9508333333333,-38.8036388888889,NULL,NULL,'2012-11-09 08:34:29',56240.3572900002,19.435,0.1756,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_71090.gif',38600095449,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126491,9423851,NULL,NULL,NULL,NULL),(3940,3229,0,'LSQ12fvk','LSQ',0.974333333333333,-36.1123055555556,NULL,NULL,'2012-11-09 01:32:15',56240.0640699998,18.9237,0.0967,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_history.html','sne?',NULL,0.07307,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_snap_71091.gif',34677267107,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541832298,8466129,NULL,NULL,NULL,NULL),(3941,3234,0,'LSQ12fwu','LSQ',357.674666666667,-37.21425,NULL,NULL,'2012-11-09 01:25:31',56240.0593900001,20.0955,0.1943,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_snap_71137.gif',49956994282,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,780578035,12196531,NULL,NULL,NULL,NULL),(3942,3237,0,'LSQ12fwt','LSQ',54.0467083333333,-37.4260555555555,NULL,NULL,'2012-11-09 04:55:43',56240.2053700001,20.0609,0.1007,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_71102.gif',38589273853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(3943,3237,0,'LSQ12fwt','LSQ',54.0465,-37.4260277777778,NULL,NULL,'2012-11-09 06:50:38',56240.28517,19.8525,0.0831,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_71103.gif',38589273853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(3944,3245,0,'LSQ12fwz','LSQ',21.2804583333333,-26.1292222222222,NULL,NULL,'2012-11-09 02:43:35',56240.1135999998,18.9809,0.0696,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_71107.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(3945,3245,0,'LSQ12fwz','LSQ',21.2804583333333,-26.1291666666667,NULL,NULL,'2012-11-09 04:43:43',56240.1970299999,18.7698,0.0606,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_71108.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(3946,3247,0,'LSQ12fwy','LSQ',20.6037916666667,-28.1007777777778,NULL,NULL,'2012-11-09 04:30:08',56240.1875999998,20.6913,0.1064,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwy/LSQ12fwy_history.html','sne - nice',NULL,0.081453,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwy/LSQ12fwy_snap_71099.gif',34751625138,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542994142,8484283,NULL,NULL,NULL,NULL),(3947,3253,0,'LSQ12fxj','LSQ',75.170375,-25.9278888888889,NULL,NULL,'2012-11-09 06:00:51',56240.2505999999,19.1037,0.0581,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_snap_71111.gif',37225960888,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581655638,9088369,NULL,NULL,NULL,NULL),(3948,3253,0,'LSQ12fxj','LSQ',75.1703333333333,-25.9277777777778,NULL,NULL,'2012-11-09 07:23:24',56240.3079200001,18.608,0.0527,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxj/LSQ12fxj_snap_71112.gif',37225960888,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581655638,9088369,NULL,NULL,NULL,NULL),(3949,3284,0,'LSQ12fxk','LSQ',57.946,-22.1755555555556,NULL,NULL,'2012-11-09 07:30:23',56240.3127700002,20.2915,0.1606,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_snap_71110.gif',37996998851,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593703107,9276611,NULL,NULL,NULL,NULL),(3950,3287,0,'LSQ12fxc','LSQ',47.8154583333333,-22.4541944444444,NULL,NULL,'2012-11-09 07:54:46',56240.3297100002,18.7303,0.0794,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_71101.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(3951,3293,0,'LSQ12fxa','LSQ',358.600625,-30.1615555555556,NULL,NULL,'2012-11-09 03:27:25',56240.1440400002,21.2769,0.1857,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxa/LSQ12fxa_history.html','agn?',NULL,0.1428,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxa/LSQ12fxa_snap_71059.gif',50044826551,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781950414,12217975,NULL,NULL,NULL,NULL),(3952,3481,0,'LSQ12fzc','LSQ',43.0447083333333,-35.9738333333333,NULL,NULL,'2012-11-09 06:47:12',56240.28278,19.1546,0.1128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_71075.gif',38652782971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(3953,3502,0,'LSQ12gav','LSQ',355.827708333333,-24.8747222222222,NULL,NULL,'2012-11-09 03:18:57',56240.1381600001,19.4459,0.0939,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_snap_71133.gif',50001954988,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781280546,12207508,NULL,NULL,NULL,NULL),(3954,3520,0,'LSQ12gak','LSQ',21.575375,-23.3503611111111,NULL,NULL,'2012-11-09 04:40:20',56240.1946800002,20.2901,0.1695,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_snap_71076.gif',35177372187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549646440,8588225,NULL,NULL,NULL,NULL),(3955,3524,0,'LSQ12gaf','LSQ',350.60125,-33.1021111111111,NULL,NULL,'2012-11-09 03:03:40',56240.1275499999,20.4849,0.2149,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaf/LSQ12gaf_history.html','sne - nice',NULL,0.1716,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaf/LSQ12gaf_snap_71097.gif',50183258630,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,784113416,12251772,NULL,NULL,NULL,NULL),(3956,3548,0,'LSQ12fzu','LSQ',74.8832083333333,-38.4092777777778,NULL,NULL,'2012-11-09 08:24:21',56240.3502500001,19.933,0.1411,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_71098.gif',37599816286,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(3957,3551,0,'LSQ12fzr','LSQ',49.1794166666667,-30.2704166666667,NULL,NULL,'2012-11-09 05:14:42',56240.2185499999,19.3626,0.0915,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_71147.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(3958,3551,0,'LSQ12fzr','LSQ',49.179375,-30.2704444444444,NULL,NULL,'2012-11-09 08:20:41',56240.3476999998,19.0951,0.0971,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-11-10 23:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_71148.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(3959,3797,0,'LSQ12gdj','LSQ',358.680583333333,-25.6761666666667,NULL,NULL,'2012-11-09 01:27:12',56240.0605600001,14.4953,0.0193,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdj/LSQ12gdj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdj/LSQ12gdj_snap_71163.gif',50005825251,NULL,NULL,NULL,'2012-11-05 01:14:52',56236.052,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781341019,12208453,NULL,NULL,NULL,NULL),(3960,3802,0,'LSQ12gdg','LSQ',74.8035,-25.9331944444444,NULL,NULL,'2012-11-09 07:23:24',56240.3079200001,18.4756,0.075,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdg/LSQ12gdg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdg/LSQ12gdg_snap_71072.gif',37227729909,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,581683279,9088801,NULL,NULL,NULL,NULL),(3961,3809,0,'LSQ12gdd','LSQ',53.6043333333333,-26.7740833333333,NULL,NULL,'2012-11-09 00:51:51',56240.0360099999,19.7642,0.0949,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_71130.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(3962,3818,0,'LSQ12gdc','LSQ',74.1528333333333,-31.6034166666667,NULL,NULL,'2012-11-09 05:35:04',56240.23269,16.7672,0.0325,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_71164.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(3963,3818,0,'LSQ12gdc','LSQ',74.1528333333333,-31.6034444444444,NULL,NULL,'2012-11-09 08:10:33',56240.3406600002,16.5653,0.0256,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_71165.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(3964,3821,0,'LSQ12gcw','LSQ',68.319,-38.1014166666667,NULL,NULL,'2012-11-09 05:04:14',56240.2112799999,20.1225,0.1108,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_71064.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(3965,3821,0,'LSQ12gcw','LSQ',68.3189583333333,-38.1014166666667,NULL,NULL,'2012-11-09 08:26:02',56240.3514200002,19.9396,0.108,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_71065.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(3966,3864,0,'LSQ12gel','LSQ',55.7509583333333,-26.694,NULL,NULL,'2012-11-09 00:55:31',56240.0385599998,21.0025,0.1141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-10 23:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_snap_71140.gif',38528356173,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602005565,9406336,NULL,NULL,NULL,NULL),(3967,3868,0,'LSQ12gek','LSQ',55.5484166667,-26.7352222222,NULL,NULL,'2012-10-11 00:00:00',56211,NULL,NULL,NULL,0,NULL,'unknown',NULL,'2012-11-11 08:27:41','2012-12-06 20:46:14','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38579734652,'Dupont','WFCCD','Nidia Morrel','2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602808353,9418880,NULL,NULL,NULL,NULL),(3969,3797,0,'LSQ12gdj','atel',358.680458333,-25.6761666667,NULL,NULL,'2012-11-10 12:00:00',56241.5,NULL,NULL,NULL,0.03032,NULL,'Ia peculiar',NULL,'2012-11-11 12:08:56','2012-12-04 13:09:52','http://www.astronomerstelegram.org/?read=4566',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50005825249,'UH 2.2m','SNIFS','SNfactory','2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781341019,12208453,NULL,NULL,NULL,NULL),(3970,3721,0,'LSQ12gby','atel',19.3464166667,9.27797222222,NULL,NULL,'2012-11-10 12:00:00',56241.5,NULL,NULL,NULL,0.086,NULL,'Ia',NULL,'2012-11-11 12:15:47','2012-12-04 13:09:52','http://www.astronomerstelegram.org/?read=4566',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,67564633006,'UH 2.2m','SNIFS','SNfactory','2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1055697390,16495271,NULL,NULL,NULL,NULL),(3971,3770,0,'LSQ12gbz','atel',66.585,-10.1035833333,NULL,NULL,'2012-11-10 12:00:00',56241.5,NULL,NULL,NULL,0.028,NULL,'Ic',NULL,'2012-11-11 12:20:29','2012-12-04 13:09:52','http://www.astronomerstelegram.org/?read=4566',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37466637666,'UH 2.2m','SNIFS','SNfactory','2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585416213,9147128,NULL,NULL,NULL,NULL),(3972,3786,0,'LSQ12gef','atel',25.1405416667,18.5100833333,NULL,NULL,'2012-11-10 12:00:00',56241.5,NULL,NULL,NULL,0.065,NULL,'Ia',NULL,'2012-11-11 12:23:26','2012-12-04 13:09:52','http://www.astronomerstelegram.org/?read=4566',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,67385903372,'UH 2.2m','SNIFS','SNfactory','2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1052904740,16451636,NULL,NULL,NULL,NULL),(3973,2912,0,'LSQ12fpz','LSQ',64.4739166666667,-8.48738888888889,NULL,NULL,'2012-11-10 06:23:12',56241.2661199998,18.0753,0.0413,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-11-11 12:45:55','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpz/LSQ12fpz_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpz/LSQ12fpz_snap_71206.gif',36959365563,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577490086,9023282,NULL,NULL,NULL,NULL),(3974,2935,0,'LSQ12fpx','LSQ',64.6498333333333,-8.48205555555556,NULL,NULL,'2012-11-10 06:23:12',56241.2661199998,18.8945,0.067,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-11-11 12:45:55','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpx/LSQ12fpx_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpx/LSQ12fpx_snap_71219.gif',36959279540,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,577488742,9023261,NULL,NULL,NULL,NULL),(3975,3040,0,'LSQ12fuv','LSQ',22.0854166666667,-2.54702777777778,NULL,NULL,'2012-11-10 02:25:31',56241.1010599998,18.4331,0.0591,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-11-11 12:45:55','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuv/LSQ12fuv_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuv/LSQ12fuv_snap_71268.gif',35234940195,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,550545940,8602280,NULL,NULL,NULL,NULL),(3976,3044,0,'LSQ12ftn','LSQ',2.53933333333333,-19.1404444444444,NULL,NULL,'2012-11-10 01:57:40',56241.0817200001,19.0739,0.0693,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-11-11 12:45:55','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_snap_71198.gif',34442362275,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538161910,8408779,NULL,NULL,NULL,NULL),(3977,3069,0,'LSQ12fus','LSQ',15.978875,-5.93880555555556,NULL,NULL,'2012-11-10 02:20:05',56241.0972899999,18.8827,0.0514,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-11-11 12:45:55','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_snap_71201.gif',34532215196,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539565862,8430716,NULL,NULL,NULL,NULL),(3978,3350,0,'LSQ12fyy','LSQ',24.37575,16.6956944444444,NULL,NULL,'2012-11-10 03:39:33',56241.1524700001,20.2352,0.1573,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-11-11 12:45:55','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_snap_71203.gif',67419126530,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1053423852,16459747,NULL,NULL,NULL,NULL),(3979,3401,0,'LSQ12fxx','LSQ',51.146,-10.1415,NULL,NULL,'2012-11-10 03:37:33',56241.1510800002,19.5698,0.1417,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-11-11 12:45:55','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxx/LSQ12fxx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxx/LSQ12fxx_snap_71238.gif',37884403751,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591943808,9249122,NULL,NULL,NULL,NULL),(3980,3729,0,'LSQ12gcp','LSQ',70.5655,-15.32875,NULL,NULL,'2012-11-10 06:01:01',56241.2507099998,20.5906,0.1296,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_snap_71204.gif',37536334293,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586505223,9164144,NULL,NULL,NULL,NULL),(3981,3759,0,'LSQ12gch','LSQ',75.1150833333333,-19.9496944444444,NULL,NULL,'2012-11-10 05:25:31',56241.2260599998,21.337,0.2034,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_snap_71255.gif',37564131558,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586939555,9170930,NULL,NULL,NULL,NULL),(3982,3889,0,'LSQ12gft','LSQ',56.5036666666667,-28.9321666666667,NULL,NULL,'2012-11-10 00:59:29',56241.0413099998,20.9017,0.1289,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gft/LSQ12gft_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gft/LSQ12gft_snap_71251.gif',38583605078,NULL,NULL,NULL,'2012-10-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602868829,9419825,NULL,NULL,NULL,NULL),(3983,3786,0,'LSQ12gef','LSQ',25.1404583333333,18.5101111111111,NULL,NULL,'2012-11-10 01:39:06',56241.0688200002,18.6562,0.0649,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_snap_71235.gif',67385903372,NULL,NULL,NULL,'2012-10-31 03:53:16',56231.162,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1052904740,16451636,NULL,NULL,NULL,NULL),(3984,3786,0,'LSQ12gef','LSQ',25.1405,18.5100277777778,NULL,NULL,'2012-11-10 03:39:33',56241.1524700001,19.1642,0.092,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_snap_71236.gif',67385903372,NULL,NULL,NULL,'2012-10-31 03:53:16',56231.162,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1052904740,16451636,NULL,NULL,NULL,NULL),(3985,3809,0,'LSQ12gdd','LSQ',53.60425,-26.7740277777778,NULL,NULL,'2012-11-10 00:55:47',56241.0387400002,20.0255,0.1046,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_71228.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(3986,3809,0,'LSQ12gdd','LSQ',53.6035416666667,-26.7739444444444,NULL,NULL,'2012-11-10 00:59:29',56241.0413099998,20.2911,0.0953,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_71226.gif',38579529027,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(3987,3809,0,'LSQ12gdd','LSQ',53.6042083333333,-26.7740555555556,NULL,NULL,'2012-11-10 03:01:14',56241.12586,20.1927,0.0762,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_71229.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(3988,3809,0,'LSQ12gdd','LSQ',53.6035,-26.7739444444444,NULL,NULL,'2012-11-10 03:04:54',56241.1284099999,19.9107,0.0712,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_71227.gif',38579529027,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(3989,3851,0,'LSQ12ges','LSQ',74.9864583333333,-19.4644444444444,NULL,NULL,'2012-11-10 07:03:52',56241.2943600002,20.9129,0.1501,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_snap_71264.gif',37563466777,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586929168,9170768,NULL,NULL,NULL,NULL),(3990,3864,0,'LSQ12gel','LSQ',55.75075,-26.694,NULL,NULL,'2012-11-10 03:04:54',56241.1284099999,19.3641,0.0425,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 12:45:55','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_snap_71240.gif',38528356173,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602005565,9406336,NULL,NULL,NULL,NULL),(3991,2987,0,'LSQ12fsj','LSQ',73.72925,-36.325,NULL,NULL,'2012-11-11 05:36:16',56242.2335299999,15.8565,0.0031,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_71430.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(3992,2987,0,'LSQ12fsj','LSQ',73.7292916666667,-36.3250277777778,NULL,NULL,'2012-11-11 07:10:44',56242.2991300002,15.9835,0.0043,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_71431.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(3993,2995,0,'LSQ12fsp','LSQ',357.212,-38.5519722222222,NULL,NULL,'2012-11-11 01:23:32',56242.0580099998,16.0758,0.0068,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_history.html','Bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsp/LSQ12fsp_snap_71422.gif',49991723132,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781120673,12205010,NULL,NULL,NULL,NULL),(3994,3001,0,'LSQ12fth','LSQ',47.8227083333333,-25.1096388888889,NULL,NULL,'2012-11-11 06:48:36',56242.28376,17.9468,0.0246,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_71406.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3995,3001,0,'LSQ12fth','LSQ',47.8227083333333,-25.1096111111111,NULL,NULL,'2012-11-11 07:48:23',56242.3252699999,17.9463,0.0264,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_71407.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(3996,3007,0,'LSQ12fte','LSQ',52.1529166666667,-24.8718333333333,NULL,NULL,'2012-11-11 06:58:51',56242.2908700001,20.5721,0.1474,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_snap_71420.gif',38021943862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594092872,9282701,NULL,NULL,NULL,NULL),(3997,3009,0,'LSQ12ftd','LSQ',64.2445416666667,-24.1446944444444,NULL,NULL,'2012-11-11 08:18:04',56242.34589,19.1687,0.1049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_71409.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3998,3009,0,'LSQ12ftd','LSQ',64.2445416666667,-24.1447222222222,NULL,NULL,'2012-11-11 08:31:33',56242.35525,19.8292,0.1393,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_71411.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(3999,3009,0,'LSQ12ftd','LSQ',64.24475,-24.14475,NULL,NULL,'2012-11-11 08:43:27',56242.3635100001,18.6422,0.1307,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_71410.gif',37178445167,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(4000,3013,0,'LSQ12ftc','LSQ',64.8029583333333,-24.35525,NULL,NULL,'2012-11-11 08:18:04',56242.34589,20.2611,0.126,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_71402.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(4001,3013,0,'LSQ12ftc','LSQ',64.8027916666667,-24.3551944444444,NULL,NULL,'2012-11-11 08:19:45',56242.3470600001,19.5201,0.084,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_71404.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(4002,3013,0,'LSQ12ftc','LSQ',64.802875,-24.3551944444444,NULL,NULL,'2012-11-11 08:31:33',56242.35525,19.4239,0.0884,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_71405.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(4003,3013,0,'LSQ12ftc','LSQ',64.803,-24.3553055555556,NULL,NULL,'2012-11-11 08:43:27',56242.3635100001,19.8619,0.1537,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_71403.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(4004,3017,0,'LSQ12ftb','LSQ',65.4214166666667,-23.7053611111111,NULL,NULL,'2012-11-11 08:18:04',56242.34589,18.2901,0.0399,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_71425.gif',37314276031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(4005,3017,0,'LSQ12ftb','LSQ',65.422,-23.7052222222222,NULL,NULL,'2012-11-11 08:19:45',56242.3470600001,18.5494,0.0774,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_71427.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(4006,3017,0,'LSQ12ftb','LSQ',65.4220416666667,-23.7052222222222,NULL,NULL,'2012-11-11 08:31:33',56242.35525,18.497,0.0485,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_71428.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(4007,3017,0,'LSQ12ftb','LSQ',65.4214166666667,-23.7053333333333,NULL,NULL,'2012-11-11 08:43:27',56242.3635100001,18.0084,0.0786,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_71426.gif',37314276031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(4008,3106,0,'LSQ12fsw','LSQ',74.16575,-30.1308333333333,NULL,NULL,'2012-11-11 06:22:40',56242.2657499998,18.8836,0.0909,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_snap_71432.gif',37203066249,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,581297910,9082779,NULL,NULL,NULL,NULL),(4009,3106,0,'LSQ12fsw','LSQ',74.1659583333333,-30.1309444444444,NULL,NULL,'2012-11-11 07:39:57',56242.31941,19.3947,0.133,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_snap_71433.gif',37203066251,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,581297910,9082779,NULL,NULL,NULL,NULL),(4010,3112,0,'LSQ12fvu','LSQ',53.5190416666667,-21.8744444444444,NULL,NULL,'2012-11-11 07:00:33',56242.2920499998,18.8229,0.0403,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_71310.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(4011,3112,0,'LSQ12fvu','LSQ',53.5190416666667,-21.8744722222222,NULL,NULL,'2012-11-11 07:52:16',56242.32797,18.8632,0.0469,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_71311.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(4012,3125,0,'LSQ12fvl','LSQ',75.2085416666667,-38.6531666666667,NULL,NULL,'2012-11-11 05:36:16',56242.2335299999,17.8211,0.0255,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_71342.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(4013,3125,0,'LSQ12fvl','LSQ',75.2085,-38.6531666666667,NULL,NULL,'2012-11-11 07:10:44',56242.2991300002,17.8343,0.0281,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_71343.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(4014,3222,0,'LSQ12fvm','LSQ',47.950875,-38.8036111111111,NULL,NULL,'2012-11-11 04:42:10',56242.1959500001,20.0273,0.1649,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_71315.gif',38600095382,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126490,9423851,NULL,NULL,NULL,NULL),(4015,3222,0,'LSQ12fvm','LSQ',47.9509583333333,-38.8035555555556,NULL,NULL,'2012-11-11 06:41:44',56242.27899,20.3334,0.1725,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_71316.gif',38600095382,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126490,9423851,NULL,NULL,NULL,NULL),(4016,3234,0,'LSQ12fwu','LSQ',357.6745,-37.2143055555556,NULL,NULL,'2012-11-11 01:25:13',56242.0591799999,20.0201,0.1713,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_snap_71379.gif',49956994282,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,780578035,12196531,NULL,NULL,NULL,NULL),(4017,3237,0,'LSQ12fwt','LSQ',54.0464583333333,-37.426,NULL,NULL,'2012-11-11 04:47:14',56242.1994699999,19.9015,0.0834,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_71333.gif',38589273853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(4018,3237,0,'LSQ12fwt','LSQ',54.0465416666667,-37.4260277777778,NULL,NULL,'2012-11-11 06:45:07',56242.2813400002,20.0684,0.0966,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_71334.gif',38589273853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(4021,3284,0,'LSQ12fxk','LSQ',57.9452083333333,-22.1761388888889,NULL,NULL,'2012-11-11 07:03:55',56242.2943899999,19.3415,0.1724,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_snap_71339.gif',37996998850,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593703107,9276611,NULL,NULL,NULL,NULL),(4022,3287,0,'LSQ12fxc','LSQ',47.8156666666667,-22.4541944444444,NULL,NULL,'2012-11-11 06:48:36',56242.28376,19.1084,0.0954,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_71335.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(4023,3481,0,'LSQ12fzc','LSQ',43.0446666666667,-35.9738055555556,NULL,NULL,'2012-11-11 04:35:19',56242.1911999998,18.6784,0.1048,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_71294.gif',38652782971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(4024,3481,0,'LSQ12fzc','LSQ',43.044625,-35.9738333333333,NULL,NULL,'2012-11-11 06:34:57',56242.27428,18.3615,0.0812,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_71295.gif',38652782971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(4025,3485,0,'LSQ12gbj','LSQ',66.0475416666667,-25.4150833333333,NULL,NULL,'2012-11-11 08:18:04',56242.34589,19.4578,0.1125,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_snap_71308.gif',37181674004,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,580963656,9077557,NULL,NULL,NULL,NULL),(4026,3485,0,'LSQ12gbj','LSQ',66.0474583333333,-25.4150555555556,NULL,NULL,'2012-11-11 08:43:27',56242.3635100001,19.2026,0.1133,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_snap_71309.gif',37181674004,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,580963656,9077557,NULL,NULL,NULL,NULL),(4027,3502,0,'LSQ12gav','LSQ',355.827625,-24.8746111111111,NULL,NULL,'2012-11-11 01:21:45',56242.0567800002,19.2469,0.0756,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_snap_71371.gif',50001954988,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781280546,12207508,NULL,NULL,NULL,NULL),(4028,3514,0,'LSQ12gaq','LSQ',65.3839166666667,-25.38,NULL,NULL,'2012-11-11 08:19:45',56242.3470600001,20.4814,0.1461,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_snap_71369.gif',37182103829,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580970372,9077662,NULL,NULL,NULL,NULL),(4029,3530,0,'LSQ12gad','LSQ',52.302125,-30.6229444444444,NULL,NULL,'2012-11-11 05:46:46',56242.2408199999,19.3474,0.1542,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_71323.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(4030,3537,0,'LSQ12gab','LSQ',81.8938333333333,-31.3134444444444,NULL,NULL,'2012-11-11 06:07:04',56242.2549100001,19.4437,0.071,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_snap_71327.gif',37311362015,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,582990031,9109219,NULL,NULL,NULL,NULL),(4031,3537,0,'LSQ12gab','LSQ',81.8941666666667,-31.3133611111111,NULL,NULL,'2012-11-11 07:50:23',56242.3266599998,19.9491,0.0997,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_snap_71328.gif',37311362015,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,582990031,9109219,NULL,NULL,NULL,NULL),(4032,3540,0,'LSQ12fzz','LSQ',81.4932083333333,-34.4575833333333,NULL,NULL,'2012-11-11 06:07:04',56242.2549100001,20.2124,0.141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_71325.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(4033,3540,0,'LSQ12fzz','LSQ',81.4932083333333,-34.4577222222222,NULL,NULL,'2012-11-11 07:50:23',56242.3266599998,20.3221,0.1577,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_71326.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(4034,3548,0,'LSQ12fzu','LSQ',74.883,-38.4093888888889,NULL,NULL,'2012-11-11 05:34:34',56242.2323400001,20.6266,0.1549,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_71329.gif',37599816286,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(4035,3548,0,'LSQ12fzu','LSQ',74.8829583333333,-38.40925,NULL,NULL,'2012-11-11 07:09:02',56242.29795,20.4633,0.1683,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_71330.gif',37599816286,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(4036,3551,0,'LSQ12fzr','LSQ',49.179375,-30.2704722222222,NULL,NULL,'2012-11-11 05:41:41',56242.2372900001,19.2401,0.0883,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_71389.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(4037,3551,0,'LSQ12fzr','LSQ',49.1793333333333,-30.2704722222222,NULL,NULL,'2012-11-11 07:12:38',56242.3004399999,19.1051,0.093,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-11-11 13:45:56','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_71390.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(4038,3893,0,'LSQ12gfs','LSQ',55.3095833333333,-26.7208055555556,NULL,NULL,'2012-11-11 01:00:19',56242.04189,21.6981,0.1788,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_snap_71393.gif',38579773067,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602808954,9418889,NULL,NULL,NULL,NULL);
INSERT INTO `transientBucket` VALUES (4039,3809,0,'LSQ12gdd','LSQ',53.6041666666667,-26.7739722222222,NULL,NULL,'2012-11-11 01:00:19',56242.04189,19.7927,0.1008,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_71356.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(4040,3809,0,'LSQ12gdd','LSQ',53.6034583333333,-26.7739722222222,NULL,NULL,'2012-11-11 01:03:59',56242.0444399999,20.0454,0.0918,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_71354.gif',38579529024,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(4041,3809,0,'LSQ12gdd','LSQ',53.6042916666667,-26.774,NULL,NULL,'2012-11-11 04:22:48',56242.1825000001,20.3993,0.0881,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_71357.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(4042,3809,0,'LSQ12gdd','LSQ',53.6034583333333,-26.7739444444444,NULL,NULL,'2012-11-11 04:26:29',56242.18506,19.8556,0.0662,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_71355.gif',38579529027,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(4043,3818,0,'LSQ12gdc','LSQ',74.1527916666667,-31.6034444444444,NULL,NULL,'2012-11-11 06:02:00',56242.2513899999,18.1552,0.0808,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_71400.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(4044,3818,0,'LSQ12gdc','LSQ',74.1529583333333,-31.6033888888889,NULL,NULL,'2012-11-11 07:22:46',56242.30748,18.0426,0.1079,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_71401.gif',37210281095,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(4045,3821,0,'LSQ12gcw','LSQ',68.31875,-38.1014166666667,NULL,NULL,'2012-11-11 05:22:30',56242.2239600001,19.7899,0.0884,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_71287.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(4046,3821,0,'LSQ12gcw','LSQ',68.3187083333333,-38.1013888888889,NULL,NULL,'2012-11-11 07:07:21',56242.29678,19.9068,0.0835,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_71288.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(4047,3845,0,'LSQ12geg','LSQ',55.053,-26.7928888888889,NULL,NULL,'2012-11-11 01:00:19',56242.04189,19.3882,0.0506,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_snap_71374.gif',38582715225,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602854925,9419608,NULL,NULL,NULL,NULL),(4048,3845,0,'LSQ12geg','LSQ',55.0532083333333,-26.7930555555556,NULL,NULL,'2012-11-11 04:22:48',56242.1825000001,21.0103,0.1102,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_snap_71375.gif',38582715225,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602854925,9419608,NULL,NULL,NULL,NULL),(4049,3868,0,'LSQ12gek','LSQ',55.5484583333333,-26.7351388888889,NULL,NULL,'2012-11-11 01:03:59',56242.0444399999,20.0184,0.1148,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 13:45:56','2012-12-06 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_snap_71414.gif',38579734652,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602808353,9418880,NULL,NULL,NULL,NULL),(4050,4050,1,'LSQ12ggi','LSQ',64.4165833333333,-18.5516944444444,NULL,NULL,'2012-11-08 06:51:23',56239.2856899998,20.7887,0.1938,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggi/LSQ12ggi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggi/LSQ12ggi_snap_71463.gif',36847117779,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575736215,8995878,NULL,NULL,NULL,NULL),(4051,4050,0,'LSQ12ggi','LSQ',64.4161666666667,-18.5515,NULL,NULL,'2012-11-10 05:03:10',56241.2105399999,19.6105,0.0839,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2012-11-11 18:45:57','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggi/LSQ12ggi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggi/LSQ12ggi_snap_71453.gif',36847117779,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575736215,8995878,NULL,NULL,NULL,NULL),(4052,4050,0,'LSQ12ggi','LSQ',64.416375,-18.5515555555556,NULL,NULL,'2012-11-10 06:53:46',56241.2873399998,19.8919,0.0897,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2012-11-11 18:45:57','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggi/LSQ12ggi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggi/LSQ12ggi_snap_71454.gif',36847117779,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575736215,8995878,NULL,NULL,NULL,NULL),(4053,4050,0,'LSQ12ggh','LSQ',64.4449583333333,-18.5526666666667,NULL,NULL,'2012-11-08 06:51:23',56239.2856899998,21.2981,0.2006,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2012-11-11 18:45:57','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggh/LSQ12ggh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggh/LSQ12ggh_snap_71469.gif',36847117363,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575736208,8995878,NULL,NULL,NULL,NULL),(4054,4050,0,'LSQ12ggh','LSQ',64.444625,-18.5522222222222,NULL,NULL,'2012-11-10 05:03:10',56241.2105399999,19.4744,0.0864,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2012-11-11 18:45:57','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggh/LSQ12ggh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggh/LSQ12ggh_snap_71451.gif',36847117362,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575736208,8995878,NULL,NULL,NULL,NULL),(4055,4050,0,'LSQ12ggh','LSQ',64.44475,-18.5524166666667,NULL,NULL,'2012-11-10 06:53:46',56241.2873399998,19.5717,0.0648,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2012-11-11 18:45:57','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggh/LSQ12ggh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggh/LSQ12ggh_snap_71452.gif',36847117362,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575736208,8995878,NULL,NULL,NULL,NULL),(4056,4056,1,'LSQ12ghe','LSQ',68.5490833333333,-23.0559722222222,NULL,NULL,'2012-11-11 08:21:27',56242.3482400002,19.0454,0.058,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_71504.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(4057,4056,0,'LSQ12ghe','LSQ',68.5490416666667,-23.0559722222222,NULL,NULL,'2012-11-11 08:41:46',56242.36234,18.8408,0.0816,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_71505.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(4058,4058,1,'LSQ12ggy','LSQ',54.0127083333333,-25.3436666666667,NULL,NULL,'2012-11-07 06:48:35',56238.2837399999,20.7787,0.1649,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggy/LSQ12ggy_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggy/LSQ12ggy_snap_71510.gif',38545689795,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602276403,9410568,NULL,NULL,NULL,NULL),(4059,4058,0,'LSQ12ggy','LSQ',54.01275,-25.3440833333333,NULL,NULL,'2012-11-11 06:58:51',56242.2908700001,20.0628,0.1027,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggy/LSQ12ggy_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggy/LSQ12ggy_snap_71492.gif',38545689795,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602276403,9410568,NULL,NULL,NULL,NULL),(4060,4058,0,'LSQ12ggy','LSQ',54.01275,-25.3440833333333,NULL,NULL,'2012-11-11 07:57:20',56242.3314899998,20.0921,0.1175,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggy/LSQ12ggy_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggy/LSQ12ggy_snap_71493.gif',38545689795,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602276403,9410568,NULL,NULL,NULL,NULL),(4061,4061,1,'LSQ12ggx','LSQ',47.8960833333333,-22.3203611111111,NULL,NULL,'2012-11-09 06:07:50',56240.25544,20.1825,0.1373,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_71508.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(4062,4061,0,'LSQ12ggx','LSQ',47.8959583333333,-22.3202222222222,NULL,NULL,'2012-11-09 07:27:00',56240.31042,19.9911,0.2072,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_71509.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(4063,4061,0,'LSQ12ggx','LSQ',47.8960833333333,-22.3203055555556,NULL,NULL,'2012-11-11 06:50:18',56242.2849400002,19.39,0.1003,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_71490.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(4064,4061,0,'LSQ12ggx','LSQ',47.8960833333333,-22.3203333333333,NULL,NULL,'2012-11-11 07:46:42',56242.3240999999,19.2681,0.1059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_71491.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(4065,4065,1,'LSQ12ggs','LSQ',54.2058333333333,-33.4581666666667,NULL,NULL,'2012-11-11 05:45:04',56242.2396399998,19.8962,0.0922,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggs/LSQ12ggs_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggs/LSQ12ggs_snap_71480.gif',38565149718,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602580464,9415319,NULL,NULL,NULL,NULL),(4066,4065,0,'LSQ12ggs','LSQ',54.206125,-33.4581944444444,NULL,NULL,'2012-11-11 08:09:22',56242.33984,20.2665,0.1289,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggs/LSQ12ggs_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggs/LSQ12ggs_snap_71481.gif',38565149718,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602580464,9415319,NULL,NULL,NULL,NULL),(4067,4067,1,'LSQ12ggq','LSQ',69.4289166666667,-35.8658611111111,NULL,NULL,'2012-11-07 05:21:22',56238.2231800002,21.2832,0.193,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_71516.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(4068,4067,0,'LSQ12ggq','LSQ',69.4289166666667,-35.8658611111111,NULL,NULL,'2012-11-11 05:22:30',56242.2239600001,20.2337,0.0799,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_71476.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(4069,4067,0,'LSQ12ggq','LSQ',69.4289583333333,-35.8658611111111,NULL,NULL,'2012-11-11 07:07:21',56242.29678,20.1676,0.0874,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-11 18:45:57','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_71477.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(4070,3481,0,'LSQ12fzc','atel',43.0447083333,-35.9739166667,NULL,NULL,'2012-11-08 00:00:00',56239,NULL,NULL,NULL,0.12,NULL,'Ia',NULL,'2012-11-12 02:01:38','2012-11-12 02:01:38','http://www.astronomerstelegram.org/?read=4563',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38652782971,'du Pont','WFCCD','not given',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(4071,3153,0,'LSQ12fwb','atel',6.35504166667,6.70713888889,NULL,NULL,'2012-11-05 00:00:00',56236,NULL,NULL,NULL,0.03,NULL,'IIb',NULL,'2012-11-12 02:05:21','2012-11-12 02:05:21','http://www.astronomerstelegram.org/?read=4563',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,66827155915,'du Pont','FIRE','not given',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044174311,16315223,NULL,NULL,NULL,NULL),(4072,4072,1,'LSQ12gif','LSQ',3.339,-23.9136388888889,NULL,NULL,'2012-11-09 01:45:45',56240.0734399999,21.0024,0.1627,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 14:45:55','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gif/LSQ12gif_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gif/LSQ12gif_snap_71623.gif',34772252121,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,543316439,8489319,NULL,NULL,NULL,NULL),(4073,4072,0,'LSQ12gif','LSQ',3.33916666666667,-23.9134722222222,NULL,NULL,'2012-11-09 03:46:01',56240.1569599998,20.7971,0.156,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 14:45:55','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gif/LSQ12gif_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gif/LSQ12gif_snap_71624.gif',34772252121,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,543316439,8489319,NULL,NULL,NULL,NULL),(4074,4072,0,'LSQ12gif','LSQ',3.338875,-23.9137222222222,NULL,NULL,'2012-11-11 03:47:05',56242.1576999999,20.4828,0.1465,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 14:45:55','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gif/LSQ12gif_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gif/LSQ12gif_snap_71678.gif',34772252121,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,543316439,8489319,NULL,NULL,NULL,NULL),(4075,4075,1,'LSQ12ghf','LSQ',1.155875,-35.5167222222222,NULL,NULL,'2012-10-26 01:20:40',56226.0560300001,15.6343,0.0067,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 14:45:55','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_history.html','very bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_snap_71571.gif',34663125229,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,541611331,8462677,NULL,NULL,NULL,NULL),(4076,4075,0,'LSQ12ghf','LSQ',1.15579166666667,-35.5167222222222,NULL,NULL,'2012-10-26 03:02:26',56226.1266999999,15.6076,0.0059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 14:45:55','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_history.html','very bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_snap_71572.gif',34663125229,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,541611331,8462677,NULL,NULL,NULL,NULL),(4077,4075,0,'LSQ12ghf','LSQ',1.155875,-35.5167222222222,NULL,NULL,'2012-11-03 02:56:54',56234.1228499999,15.9752,0.0062,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 14:45:55','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_history.html','very bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_snap_71573.gif',34663125229,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,541611331,8462677,NULL,NULL,NULL,NULL),(4078,4075,0,'LSQ12ghf','LSQ',1.15583333333333,-35.5167222222222,NULL,NULL,'2012-11-05 03:21:48',56236.1401399998,16.0905,0.0066,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 14:45:55','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_history.html','very bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_snap_71574.gif',34663125229,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,541611331,8462677,NULL,NULL,NULL,NULL),(4079,4075,0,'LSQ12ghf','LSQ',1.15579166666667,-35.5167222222222,NULL,NULL,'2012-11-07 01:52:18',56238.0779900001,16.9286,0.0194,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 14:45:55','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_history.html','very bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_snap_71575.gif',34663125229,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,541611331,8462677,NULL,NULL,NULL,NULL),(4080,4075,0,'LSQ12ghf','LSQ',1.15591666666667,-35.5166666666667,NULL,NULL,'2012-11-09 01:32:15',56240.0640699998,18.9415,0.0559,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 14:45:55','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_history.html','very bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_snap_71551.gif',34663125229,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,541611331,8462677,NULL,NULL,NULL,NULL),(4081,4075,0,'LSQ12ghf','LSQ',1.15595833333333,-35.5166388888889,NULL,NULL,'2012-11-09 03:32:30',56240.14757,19.1588,0.069,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 14:45:55','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_history.html','very bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_snap_71552.gif',34663125229,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,541611331,8462677,NULL,NULL,NULL,NULL),(4082,4082,1,'LSQ12ggo','LSQ',60.4302083333333,-34.9307222222222,NULL,NULL,'2012-11-05 06:48:42',56236.28382,20.0762,0.1798,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 14:45:55','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_snap_71514.gif',37676606780,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588696980,9198390,NULL,NULL,NULL,NULL),(4083,4082,0,'LSQ12ggo','LSQ',60.4301666666667,-34.9307222222222,NULL,NULL,'2012-11-07 06:43:25',56238.2801600001,20.1475,0.1905,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 14:45:55','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_snap_71515.gif',37676606780,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588696980,9198390,NULL,NULL,NULL,NULL),(4084,4082,0,'LSQ12ggo','LSQ',60.4302916666667,-34.9308333333333,NULL,NULL,'2012-11-11 04:57:39',56242.2067100001,20.5578,0.1542,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 14:45:55','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_snap_71472.gif',37676606780,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588696980,9198390,NULL,NULL,NULL,NULL),(4085,4082,0,'LSQ12ggo','LSQ',60.4302916666667,-34.9308611111111,NULL,NULL,'2012-11-11 06:55:22',56242.28846,20.2254,0.1645,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 14:45:55','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_snap_71473.gif',37676606780,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588696980,9198390,NULL,NULL,NULL,NULL),(4086,2900,0,'LSQ12fqb','LSQ',70.8874583333333,-11.9013888888889,NULL,NULL,'2012-11-12 06:33:21',56243.2731699999,19.7695,0.1279,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_72007.gif',37539442240,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553785,9164902,NULL,NULL,NULL,NULL),(4087,2900,0,'LSQ12fqb','LSQ',70.8874166666667,-11.9016111111111,NULL,NULL,'2012-11-12 07:38:13',56243.3182100002,19.6077,0.1275,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_72008.gif',37539441792,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553778,9164902,NULL,NULL,NULL,NULL),(4088,2915,0,'LSQ12fpv','LSQ',56.9052916666667,-8.73216666666667,NULL,NULL,'2012-11-12 08:08:38',56243.3393399999,20.2502,0.1834,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_history.html','sn?',NULL,0.034397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_snap_72000.gif',37021133916,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578455217,9038362,NULL,NULL,NULL,NULL),(4089,2939,0,'LSQ12fpp','LSQ',50.866625,-12.0056388888889,NULL,NULL,'2012-11-12 02:32:49',56243.1061300002,19.4759,0.1516,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_71882.gif',37885516712,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(4090,2959,0,'LSQ12frb','LSQ',51.5678333333333,-5.16444444444444,NULL,NULL,'2012-11-12 02:45:41',56243.1150600002,19.6259,0.1207,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_snap_71898.gif',36840221571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,575628462,8994194,NULL,NULL,NULL,NULL),(4091,3058,0,'LSQ12fuc','LSQ',75.0468333333333,-20.0075277777778,NULL,NULL,'2012-11-12 05:55:30',56243.24688,20.3646,0.1203,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_history.html','sne - good',NULL,0.041789,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuc/LSQ12fuc_snap_71868.gif',37564014387,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586937724,9170901,NULL,NULL,NULL,NULL),(4092,3035,0,'LSQ12fuy','LSQ',19.375375,0.593777777777778,NULL,NULL,'2012-11-12 02:14:41',56243.0935399998,20.0744,0.1652,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuy/LSQ12fuy_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuy/LSQ12fuy_snap_72005.gif',66652936653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041452135,16272689,NULL,NULL,NULL,NULL),(4093,3069,0,'LSQ12fus','LSQ',15.978625,-5.93855555555556,NULL,NULL,'2012-11-12 02:12:59',56243.0923600001,19.9996,0.1113,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_snap_71873.gif',34532215196,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539565862,8430716,NULL,NULL,NULL,NULL),(4094,3281,0,'LSQ12fwd','LSQ',56.3918333333333,-0.357138888888889,NULL,NULL,'2012-11-12 05:19:34',56243.22193,20.2122,0.1454,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_history.html','agn?',NULL,0.10854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_snap_71892.gif',36993805998,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578028218,9031690,NULL,NULL,NULL,NULL),(4095,3356,0,'LSQ12fyv','LSQ',63.5570416666667,2.86286111111111,NULL,NULL,'2012-11-12 07:05:36',56243.29556,21.4556,0.1038,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyv/LSQ12fyv_history.html','sne?',NULL,0.040024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyv/LSQ12fyv_snap_71887.gif',65084187378,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1016940427,15889694,NULL,NULL,NULL,NULL),(4096,3356,0,'LSQ12fyv','LSQ',63.5567916666667,2.863,NULL,NULL,'2012-11-12 07:55:07',56243.3299500002,21.2696,0.0837,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyv/LSQ12fyv_history.html','sne?',NULL,0.040024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyv/LSQ12fyv_snap_71888.gif',65084187378,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1016940427,15889694,NULL,NULL,NULL,NULL),(4097,3378,0,'LSQ12fyf','LSQ',63.8234583333333,-7.06947222222222,NULL,NULL,'2012-11-12 06:48:38',56243.2837800002,19.0407,0.0791,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_snap_71864.gif',36956960238,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577452503,9022695,NULL,NULL,NULL,NULL),(4098,3378,0,'LSQ12fyf','LSQ',63.823375,-7.06947222222222,NULL,NULL,'2012-11-12 07:46:41',56243.3240899998,19.0113,0.0831,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_snap_71865.gif',36956960238,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577452503,9022695,NULL,NULL,NULL,NULL),(4099,3380,0,'LSQ12fye','LSQ',62.7185,-4.923,NULL,NULL,'2012-11-12 06:41:49',56243.27905,18.5633,0.0803,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_71862.gif',36961736785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(4100,3380,0,'LSQ12fye','LSQ',62.7185,-4.92305555555556,NULL,NULL,'2012-11-12 07:43:18',56243.32174,18.3564,0.0785,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_71863.gif',36961736785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(4101,3386,0,'LSQ12fyb','LSQ',53.6895833333333,-3.73855555555556,NULL,NULL,'2012-11-12 02:45:41',56243.1150600002,19.3446,0.1051,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_71860.gif',36820699952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(4102,3386,0,'LSQ12fyb','LSQ',53.6893333333333,-3.73838888888889,NULL,NULL,'2012-11-12 04:46:28',56243.19894,19.611,0.105,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_71861.gif',36820699952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(4103,3399,0,'LSQ12fxy','LSQ',50.1275416666667,-11.29575,NULL,NULL,'2012-11-12 04:39:39',56243.1942099999,19.7786,0.1319,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_snap_71870.gif',37885680972,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591963765,9249433,NULL,NULL,NULL,NULL),(4104,3405,0,'LSQ12fxv','LSQ',358.932291666667,-12.64125,NULL,NULL,'2012-11-12 01:24:33',56243.0587200001,20.5243,0.1799,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-11-12 17:45:59','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxv/LSQ12fxv_snap_71858.gif',49546365664,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,774161963,12096280,NULL,NULL,NULL,NULL),(4105,3729,0,'LSQ12gcp','LSQ',70.5654583333333,-15.3291944444444,NULL,NULL,'2012-11-12 06:04:03',56243.2528200001,19.4495,0.0645,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_snap_71874.gif',37536334322,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586505223,9164144,NULL,NULL,NULL,NULL),(4106,3729,0,'LSQ12gcp','LSQ',70.5655833333333,-15.3292777777778,NULL,NULL,'2012-11-12 08:13:50',56243.34295,21.1364,0.1874,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_snap_71875.gif',37536334322,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586505223,9164144,NULL,NULL,NULL,NULL),(4107,3740,0,'LSQ12gcn','LSQ',67.481125,-12.0793055555556,NULL,NULL,'2012-11-12 07:22:53',56243.3075600001,19.4643,0.1054,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_snap_71966.gif',37533040332,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586453755,9163339,NULL,NULL,NULL,NULL),(4108,3764,0,'LSQ12gcd','LSQ',59.5834166666667,-18.6201944444444,NULL,NULL,'2012-11-12 05:38:03',56243.2347599999,19.5481,0.142,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_snap_71866.gif',36851844463,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575810069,8997032,NULL,NULL,NULL,NULL),(4109,3770,0,'LSQ12gbz','LSQ',66.5849583333333,-10.1035555555556,NULL,NULL,'2012-11-12 06:22:48',56243.26584,18.8274,0.0545,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_history.html','sne - nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_snap_71894.gif',37466637666,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585416213,9147128,NULL,NULL,NULL,NULL),(4110,3770,0,'LSQ12gbz','LSQ',66.5849166666667,-10.1035555555556,NULL,NULL,'2012-11-12 07:33:09',56243.3146899999,18.7048,0.0531,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_history.html','sne - nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_snap_71895.gif',37466637666,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585416213,9147128,NULL,NULL,NULL,NULL),(4111,3893,0,'LSQ12gfs','LSQ',55.3095,-26.7206666666667,NULL,NULL,'2012-11-12 02:01:21',56243.0842800001,21.7399,0.1617,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_snap_71955.gif',38579773067,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602808954,9418889,NULL,NULL,NULL,NULL),(4112,3809,0,'LSQ12gdd','LSQ',53.6042083333333,-26.7740277777778,NULL,NULL,'2012-11-12 02:01:21',56243.0842800001,20.1229,0.0914,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_71905.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(4113,3809,0,'LSQ12gdd','LSQ',53.6035,-26.7739444444444,NULL,NULL,'2012-11-12 02:05:02',56243.08684,20.0007,0.0743,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_71903.gif',38579529027,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(4114,3809,0,'LSQ12gdd','LSQ',53.6042083333333,-26.774,NULL,NULL,'2012-11-12 04:03:38',56243.1691899998,20.1284,0.0699,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_71906.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(4115,3809,0,'LSQ12gdd','LSQ',53.6034166666667,-26.7739166666667,NULL,NULL,'2012-11-12 04:07:19',56243.1717500002,19.8864,0.0696,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_71904.gif',38579529027,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(4116,3845,0,'LSQ12geg','LSQ',55.052875,-26.7930833333333,NULL,NULL,'2012-11-12 04:03:38',56243.1691899998,21.4549,0.1418,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_snap_71924.gif',38582715225,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602854925,9419608,NULL,NULL,NULL,NULL),(4117,3883,0,'LSQ12gfh','LSQ',53.6905833333333,-6.84380555555556,NULL,NULL,'2012-11-12 04:46:28',56243.19894,16.9734,0.0155,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_history.html','sne??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_snap_71977.gif',36800390526,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575006101,8984470,NULL,NULL,NULL,NULL),(4118,4118,1,'LSQ12ghd','LSQ',71.8645833333333,-21.3293055555556,NULL,NULL,'2012-11-11 08:21:27',56242.3482400002,19.0176,0.0494,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_71502.gif',37342671080,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479235,9116863,NULL,NULL,NULL,NULL),(4119,4118,0,'LSQ12ghd','LSQ',71.8646666666667,-21.3295,NULL,NULL,'2012-11-11 08:41:46',56242.36234,19.5637,0.107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_71503.gif',37342671080,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479235,9116863,NULL,NULL,NULL,NULL),(4120,4120,1,'LSQ12ghc','LSQ',66.2228333333333,-21.2026944444444,NULL,NULL,'2012-10-26 06:10:35',56226.2573600002,17.2774,0.0297,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_71540.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(4121,4120,0,'LSQ12ghc','LSQ',66.2228333333333,-21.2026944444444,NULL,NULL,'2012-10-26 07:43:25',56226.3218200002,17.2978,0.0227,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_71541.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(4122,4120,0,'LSQ12ghc','LSQ',66.222875,-21.2026944444444,NULL,NULL,'2012-11-01 05:51:06',56232.2438300001,17.1045,0.0296,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_71542.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(4123,4120,0,'LSQ12ghc','LSQ',66.222875,-21.2026944444444,NULL,NULL,'2012-11-01 07:21:36',56232.3066699998,17.0454,0.0309,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_71543.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(4124,4120,0,'LSQ12ghc','LSQ',66.2227916666667,-21.2026944444444,NULL,NULL,'2012-11-03 05:53:47',56234.2456899998,17.0603,0.0234,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_71544.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(4125,4120,0,'LSQ12ghc','LSQ',66.2227916666667,-21.2026666666667,NULL,NULL,'2012-11-03 07:22:10',56234.3070700001,17.0441,0.0244,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_71545.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(4126,4120,0,'LSQ12ghc','LSQ',66.2227916666667,-21.2026944444444,NULL,NULL,'2012-11-05 06:12:18',56236.2585499999,17.0781,0.0231,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_71546.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(4127,4120,0,'LSQ12ghc','LSQ',66.223,-21.2026388888889,NULL,NULL,'2012-11-05 07:44:59',56236.3229100001,17.0475,0.0246,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_71547.gif',37325531170,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(4128,4120,0,'LSQ12ghc','LSQ',66.222875,-21.2026666666667,NULL,NULL,'2012-11-07 08:30:40',56238.35464,17.1189,0.033,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_71548.gif',37325531170,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(4129,4120,0,'LSQ12ghc','LSQ',66.222875,-21.2026944444444,NULL,NULL,'2012-11-09 06:19:40',56240.2636600002,17.2946,0.0231,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_71549.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(4130,4120,0,'LSQ12ghc','LSQ',66.2227916666667,-21.2026666666667,NULL,NULL,'2012-11-09 07:48:02',56240.3250299999,17.3185,0.0228,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_71550.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(4131,4120,0,'LSQ12ghc','LSQ',66.2227916666667,-21.2026666666667,NULL,NULL,'2012-11-11 08:18:04',56242.34589,17.321,0.0236,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_71500.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(4132,4120,0,'LSQ12ghc','LSQ',66.2227916666667,-21.2026944444444,NULL,NULL,'2012-11-11 08:43:27',56242.3635100001,17.1666,0.0294,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_71501.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(4133,4133,1,'LSQ12gha','LSQ',57.2167916666667,-23.42225,NULL,NULL,'2012-11-09 06:14:35',56240.2601299998,19.5916,0.1381,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gha/LSQ12gha_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gha/LSQ12gha_snap_71517.gif',37995371538,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593677680,9276213,NULL,NULL,NULL,NULL),(4134,4133,0,'LSQ12gha','LSQ',57.2165416666667,-23.4220833333333,NULL,NULL,'2012-11-11 07:03:55',56242.2943899999,20.5121,0.166,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gha/LSQ12gha_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gha/LSQ12gha_snap_71496.gif',37995371538,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593677680,9276213,NULL,NULL,NULL,NULL),(4135,4133,0,'LSQ12gha','LSQ',57.2165833333333,-23.4220277777778,NULL,NULL,'2012-11-11 07:53:57',56242.32914,19.4117,0.1119,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gha/LSQ12gha_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gha/LSQ12gha_snap_71497.gif',37995371538,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593677680,9276213,NULL,NULL,NULL,NULL),(4136,4136,1,'LSQ12ggz','LSQ',56.3262083333333,-23.8723055555556,NULL,NULL,'2012-10-26 06:03:47',56226.25263,18.6075,0.0827,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_snap_71512.gif',37995959908,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593686873,9276357,NULL,NULL,NULL,NULL),(4137,4136,0,'LSQ12ggz','LSQ',56.3260833333333,-23.8723333333333,NULL,NULL,'2012-10-26 07:46:48',56226.3241699999,19.0003,0.0519,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_snap_71513.gif',37995959908,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593686873,9276357,NULL,NULL,NULL,NULL),(4138,4136,0,'LSQ12ggz','LSQ',56.326,-23.8723611111111,NULL,NULL,'2012-11-11 07:02:13',56242.2932099998,20.0784,0.0811,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_snap_71494.gif',37995959908,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593686873,9276357,NULL,NULL,NULL,NULL),(4139,4136,0,'LSQ12ggz','LSQ',56.3260416666667,-23.8723055555556,NULL,NULL,'2012-11-11 07:55:38',56242.3303100001,19.8746,0.0925,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_snap_71495.gif',37995959908,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593686873,9276357,NULL,NULL,NULL,NULL),(4140,4140,1,'LSQ12ggw','LSQ',49.5528333333333,-21.4535277777778,NULL,NULL,'2012-10-26 05:57:02',56226.2479400001,20.1796,0.1976,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggw/LSQ12ggw_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggw/LSQ12ggw_snap_71506.gif',38028965827,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,594202591,9284415,NULL,NULL,NULL,NULL),(4141,4140,0,'LSQ12ggw','LSQ',49.5534166666667,-21.4534166666667,NULL,NULL,'2012-11-09 07:54:46',56240.3297100002,20.2101,0.1189,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggw/LSQ12ggw_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggw/LSQ12ggw_snap_71507.gif',38028965827,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,594202591,9284415,NULL,NULL,NULL,NULL),(4142,4140,0,'LSQ12ggw','LSQ',49.5531666666667,-21.4534444444444,NULL,NULL,'2012-11-11 06:48:36',56242.28376,20.5971,0.1347,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggw/LSQ12ggw_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggw/LSQ12ggw_snap_71488.gif',38028965827,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,594202591,9284415,NULL,NULL,NULL,NULL),(4143,4140,0,'LSQ12ggw','LSQ',49.55325,-21.4533611111111,NULL,NULL,'2012-11-11 07:48:23',56242.3252699999,20.655,0.1656,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggw/LSQ12ggw_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggw/LSQ12ggw_snap_71489.gif',38028965827,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,594202591,9284415,NULL,NULL,NULL,NULL),(4144,4144,1,'LSQ12ggu','LSQ',52.9391666666667,-28.9199444444444,NULL,NULL,'2012-11-02 01:21:51',56233.0568499998,20.414,0.2037,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_snap_71528.gif',38584680256,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602885629,9420087,NULL,NULL,NULL,NULL),(4145,4144,0,'LSQ12ggu','LSQ',52.9389166666667,-28.9200555555556,NULL,NULL,'2012-11-06 01:03:23',56237.0440199999,21.4132,0.125,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_snap_71529.gif',38584680256,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602885629,9420087,NULL,NULL,NULL,NULL),(4146,4144,0,'LSQ12ggu','LSQ',52.9389166666667,-28.9200277777778,NULL,NULL,'2012-11-06 03:06:04',56237.12922,21.1952,0.1553,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_snap_71530.gif',38584680256,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602885629,9420087,NULL,NULL,NULL,NULL),(4147,4144,0,'LSQ12ggu','LSQ',52.9389583333333,-28.9199722222222,NULL,NULL,'2012-11-07 01:16:26',56238.0530900001,21.146,0.1599,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_snap_71531.gif',38584680256,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602885629,9420087,NULL,NULL,NULL,NULL),(4148,4144,0,'LSQ12ggu','LSQ',52.939125,-28.9201666666667,NULL,NULL,'2012-11-07 03:19:03',56238.1382300002,21.3292,0.145,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_snap_71532.gif',38584680256,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602885629,9420087,NULL,NULL,NULL,NULL),(4149,4144,0,'LSQ12ggu','LSQ',52.9389583333333,-28.9200555555556,NULL,NULL,'2012-11-08 01:15:00',56239.0520899999,21.2771,0.1734,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_snap_71533.gif',38584680256,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602885629,9420087,NULL,NULL,NULL,NULL),(4150,4144,0,'LSQ12ggu','LSQ',52.939,-28.9200833333333,NULL,NULL,'2012-11-08 03:15:42',56239.1359100002,21.0812,0.1421,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_snap_71534.gif',38584680256,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602885629,9420087,NULL,NULL,NULL,NULL),(4151,4144,0,'LSQ12ggu','LSQ',52.9392916666667,-28.9199444444444,NULL,NULL,'2012-11-10 03:01:14',56241.12586,20.4108,0.086,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_snap_71535.gif',38584680256,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602885629,9420087,NULL,NULL,NULL,NULL),(4152,4144,0,'LSQ12ggu','LSQ',52.9389583333333,-28.92,NULL,NULL,'2012-11-11 01:00:19',56242.04189,21.1938,0.1541,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_snap_71484.gif',38584680256,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602885629,9420087,NULL,NULL,NULL,NULL),(4153,4144,0,'LSQ12ggu','LSQ',52.938875,-28.92,NULL,NULL,'2012-11-11 04:22:48',56242.1825000001,20.9638,0.1198,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_snap_71485.gif',38584680256,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602885629,9420087,NULL,NULL,NULL,NULL),(4154,4144,0,'LSQ12ggu','LSQ',52.9389166666667,-28.9200277777778,NULL,NULL,'2012-11-12 02:01:21',56243.0842800001,21.1573,0.1533,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_snap_71995.gif',38584680256,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602885629,9420087,NULL,NULL,NULL,NULL),(4155,4144,0,'LSQ12ggu','LSQ',52.9389166666667,-28.9200555555556,NULL,NULL,'2012-11-12 04:03:38',56243.1691899998,21.4015,0.1402,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_snap_71996.gif',38584680256,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602885629,9420087,NULL,NULL,NULL,NULL),(4156,4156,0,'LSQ12ggn','LSQ',58.0249166666667,-39.0651944444444,NULL,NULL,'2012-11-09 06:50:38',56240.28517,16.1405,0.0094,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2019-12-24 20:38:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_71511.gif',37665320689,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(4157,4156,0,'LSQ12ggn','LSQ',58.0249166666667,-39.0651944444444,NULL,NULL,'2012-11-11 04:47:14',56242.1994699999,16.4193,0.0101,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_71470.gif',37665320689,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(4158,4156,0,'LSQ12ggn','LSQ',58.0249166666667,-39.0652222222222,NULL,NULL,'2012-11-11 06:45:07',56242.2813400002,16.4653,0.0102,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 17:45:59','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_71471.gif',37665320689,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(4159,4159,0,'LSQ12gjg','LSQ',69.8504166666667,-5.53480555555556,NULL,NULL,'2012-11-12 06:52:01',56243.2861299999,15.2962,0.0036,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 18:46:00','2019-10-11 20:38:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_snap_71775.gif',37457458286,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,585272785,9144887,NULL,NULL,NULL,NULL),(4160,4159,0,'LSQ12gjg','LSQ',69.8504166666667,-5.53480555555556,NULL,NULL,'2012-11-12 08:01:52',56243.3346299999,15.2572,0.0035,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 18:46:00','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_snap_71776.gif',37457458286,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,585272785,9144887,NULL,NULL,NULL,NULL),(4161,4161,1,'LSQ12gjf','LSQ',65.2339166666667,-4.91102777777778,NULL,NULL,'2012-11-12 06:46:58',56243.2826200002,19.9469,0.1525,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 18:46:00','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjf/LSQ12gjf_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjf/LSQ12gjf_snap_71773.gif',36968219847,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,577628435,9025444,NULL,NULL,NULL,NULL),(4162,4161,0,'LSQ12gjf','LSQ',65.2338333333333,-4.91130555555556,NULL,NULL,'2012-11-12 07:44:59',56243.3229100001,20.07,0.1488,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 18:46:00','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjf/LSQ12gjf_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjf/LSQ12gjf_snap_71774.gif',36968219845,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,577628435,9025444,NULL,NULL,NULL,NULL),(4163,4163,1,'LSQ12gje','LSQ',55.4508333333333,-2.83622222222222,NULL,NULL,'2012-11-12 06:38:27',56243.2767099999,19.3952,0.1105,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 18:46:00','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gje/LSQ12gje_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gje/LSQ12gje_snap_71771.gif',36822871960,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,575357374,8989958,NULL,NULL,NULL,NULL),(4164,4163,0,'LSQ12gje','LSQ',55.451,-2.83611111111111,NULL,NULL,'2012-11-12 08:05:15',56243.3369900002,18.8744,0.0894,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 18:46:00','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gje/LSQ12gje_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gje/LSQ12gje_snap_71772.gif',36822871960,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,575357374,8989958,NULL,NULL,NULL,NULL),(4165,4165,1,'LSQ12gjc','LSQ',52.6707916666667,-6.37305555555556,NULL,NULL,'2012-11-04 05:23:36',56235.2247299999,19.5788,0.1525,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 18:46:00','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_71837.gif',36797933958,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(4166,4165,0,'LSQ12gjc','LSQ',52.6709583333333,-6.37280555555555,NULL,NULL,'2012-11-06 05:53:24',56237.2454200001,19.4823,0.1589,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 18:46:00','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_71838.gif',36797933958,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(4167,4165,0,'LSQ12gjc','LSQ',52.6708333333333,-6.37297222222222,NULL,NULL,'2012-11-08 06:10:33',56239.2573299999,19.2032,0.1059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 18:46:00','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_71839.gif',36797933958,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(4168,4165,0,'LSQ12gjc','LSQ',52.6709583333333,-6.37283333333333,NULL,NULL,'2012-11-08 07:28:50',56239.3116899999,19.1064,0.1131,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 18:46:00','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_71840.gif',36797933958,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(4169,4165,0,'LSQ12gjc','LSQ',52.6707916666667,-6.37297222222222,NULL,NULL,'2012-11-12 02:45:41',56243.1150600002,19.1631,0.1043,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 18:46:00','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_71767.gif',36797933958,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(4170,4165,0,'LSQ12gjc','LSQ',52.6709166666667,-6.37280555555555,NULL,NULL,'2012-11-12 04:46:28',56243.19894,19.1366,0.0988,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 18:46:00','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_71768.gif',36797933958,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(4171,4171,1,'LSQ12giz','LSQ',63.4552083333333,-10.0443055555556,NULL,NULL,'2012-11-12 06:19:27',56243.26351,20.0408,0.1404,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 18:46:00','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giz/LSQ12giz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giz/LSQ12giz_snap_71761.gif',36979075824,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577798059,9028094,NULL,NULL,NULL,NULL),(4172,4171,0,'LSQ12giz','LSQ',63.4555,-10.0444166666667,NULL,NULL,'2012-11-12 07:31:26',56243.3135000002,19.9792,0.1694,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 18:46:00','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giz/LSQ12giz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giz/LSQ12giz_snap_71762.gif',36979075816,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577798059,9028094,NULL,NULL,NULL,NULL),(4173,4173,1,'LSQ12giy','LSQ',60.103375,-10.5716944444444,NULL,NULL,'2012-11-04 07:50:21',56235.3266400001,19.793,0.2092,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 19:46:00','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giy/LSQ12giy_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giy/LSQ12giy_snap_71810.gif',36987791452,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577934241,9030222,NULL,NULL,NULL,NULL),(4174,4173,0,'LSQ12giy','LSQ',60.103375,-10.5716666666667,NULL,NULL,'2012-11-12 06:17:45',56243.2623299998,20.0228,0.1079,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 19:46:00','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giy/LSQ12giy_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giy/LSQ12giy_snap_71759.gif',36987791452,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577934241,9030222,NULL,NULL,NULL,NULL),(4175,4173,0,'LSQ12giy','LSQ',60.103375,-10.5716944444444,NULL,NULL,'2012-11-12 07:36:31',56243.31703,20.3974,0.1084,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-12 19:46:00','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giy/LSQ12giy_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giy/LSQ12giy_snap_71760.gif',36987791452,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577934241,9030222,NULL,NULL,NULL,NULL),(4176,4176,0,'chase_ESO-9015','CHASE',135.52275,-64.9054805555556,NULL,NULL,'2012-11-06 00:00:00',56237,17.5,NULL,NULL,NULL,NULL,NULL,NULL,'2012-11-13 12:31:22','2019-10-12 20:41:36','NULL','supernova',NULL,0.0056,NULL,NULL,'NULL',NULL,NULL,40786428378,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,637287943,9957624,NULL,NULL,NULL,NULL),(4177,4176,0,'chase_ESO-9015','pessto',135.52275,-64.9054805556,NULL,NULL,'2012-11-07 00:00:00',56238,NULL,NULL,NULL,0.0056,NULL,'II',NULL,'2012-11-13 11:34:05','2012-11-13 11:34:05','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,40786428378,'NTT','EFOSC2','Marchi',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,637287943,9957624,NULL,NULL,NULL,NULL),(4178,3906,0,'PSNJ02324096-391756','pessto',38.1706708333,-39.2989555556,NULL,NULL,'2012-11-13 05:31:11',56244.23,NULL,NULL,NULL,0.0048,NULL,'II',NULL,'2012-11-13 19:48:41','2012-11-13 19:48:41','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38623139302,'NTT','EFOSC2','Bufano Gonzalez',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603486551,9429477,NULL,NULL,NULL,NULL),(4179,4067,0,'LSQ12ggq','pessto',69.4289166667,-35.8658611111,NULL,NULL,'2012-11-13 04:48:00',56244.2,NULL,NULL,NULL,0.119,NULL,'Ia',NULL,'2012-11-13 19:51:12','2012-12-04 13:09:51','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37691520944,'NTT','EFOSC2','Bufano Gonzalez','2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(4180,2974,0,'LSQ12frx','LSQ',12.9882083333333,-23.7102222222222,NULL,NULL,'2012-11-13 04:00:35',56244.16708,19.5295,0.0598,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_snap_72150.gif',35316090512,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(4181,2985,0,'LSQ12fsh','LSQ',12.7767083333333,-39.16,NULL,NULL,'2012-11-13 02:09:16',56244.08977,18.7494,0.0405,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_72249.gif',38166915082,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(4182,2985,0,'LSQ12fsh','LSQ',12.7767083333333,-39.1600277777778,NULL,NULL,'2012-11-13 04:13:48',56244.1762600001,18.8365,0.0408,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_72250.gif',38166915082,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(4183,2987,0,'LSQ12fsj','LSQ',73.72925,-36.3250277777778,NULL,NULL,'2012-11-13 05:23:27',56244.22462,15.9638,0.0036,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_72243.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(4184,2987,0,'LSQ12fsj','LSQ',73.7292916666667,-36.3250277777778,NULL,NULL,'2012-11-13 07:02:53',56244.2936800001,15.9925,0.0037,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_72244.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(4185,2991,0,'LSQ12fsi','LSQ',1.50491666666667,-35.19275,NULL,NULL,'2012-11-13 01:21:44',56244.0567600001,20.3202,0.1517,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_history.html','Old',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_snap_72248.gif',34665129379,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,541642646,8463166,NULL,NULL,NULL,NULL),(4186,2993,0,'LSQ12fss','LSQ',18.7159166666667,-30.0939166666667,NULL,NULL,'2012-11-13 02:21:09',56244.09803,19.9681,0.0774,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_72260.gif',34734808839,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(4187,2993,0,'LSQ12fss','LSQ',18.7159166666667,-30.0939444444444,NULL,NULL,'2012-11-13 04:37:35',56244.1927700001,19.7029,0.0615,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_72261.gif',34734808839,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(4188,2999,0,'LSQ12fsn','LSQ',10.6065,-34.09725,NULL,NULL,'2012-11-13 01:53:57',56244.07914,15.0783,0.0058,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_history.html','Unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_snap_72273.gif',34872861140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544888455,8513882,NULL,NULL,NULL,NULL),(4189,3001,0,'LSQ12fth','LSQ',47.8225416666667,-25.10975,NULL,NULL,'2012-11-13 06:13:37',56244.2594599999,18.6576,0.0409,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_72231.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(4190,3001,0,'LSQ12fth','LSQ',47.8227083333333,-25.1096666666667,NULL,NULL,'2012-11-13 06:39:18',56244.2773000002,18.0752,0.0266,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_72229.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(4191,3001,0,'LSQ12fth','LSQ',47.8225416666667,-25.1097222222222,NULL,NULL,'2012-11-13 06:41:00',56244.2784799999,18.4576,0.0275,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_72232.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(4192,3001,0,'LSQ12fth','LSQ',47.82275,-25.1096388888889,NULL,NULL,'2012-11-13 07:42:48',56244.3213999998,18.0755,0.0289,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_72230.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(4193,3009,0,'LSQ12ftd','LSQ',64.2445833333333,-24.1446944444444,NULL,NULL,'2012-11-13 06:25:26',56244.26767,19.4965,0.1202,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_72216.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(4194,3009,0,'LSQ12ftd','LSQ',64.2445416666667,-24.14475,NULL,NULL,'2012-11-13 06:27:08',56244.2688500001,20.339,0.1823,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_72218.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(4195,3009,0,'LSQ12ftd','LSQ',64.2445833333333,-24.1447222222222,NULL,NULL,'2012-11-13 07:48:10',56244.3251200002,19.6735,0.1285,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_72219.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(4196,3009,0,'LSQ12ftd','LSQ',64.2445416666667,-24.1446666666667,NULL,NULL,'2012-11-13 07:49:50',56244.3262800002,19.629,0.1094,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_72217.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(4197,3013,0,'LSQ12ftc','LSQ',64.8030833333333,-24.3552222222222,NULL,NULL,'2012-11-13 06:25:26',56244.26767,20.1198,0.1094,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_72220.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(4198,3013,0,'LSQ12ftc','LSQ',64.8029166666667,-24.3551666666667,NULL,NULL,'2012-11-13 06:27:08',56244.2688500001,19.9046,0.0942,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_72222.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(4199,3013,0,'LSQ12ftc','LSQ',64.8028333333333,-24.3551388888889,NULL,NULL,'2012-11-13 07:48:10',56244.3251200002,19.733,0.083,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_72223.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(4200,3013,0,'LSQ12ftc','LSQ',64.8030833333333,-24.3552777777778,NULL,NULL,'2012-11-13 07:49:50',56244.3262800002,20.1025,0.1133,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_72221.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(4201,3017,0,'LSQ12ftb','LSQ',65.4215,-23.7053611111111,NULL,NULL,'2012-11-13 06:25:26',56244.26767,18.2558,0.0339,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_72276.gif',37314276031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(4202,3017,0,'LSQ12ftb','LSQ',65.4220416666667,-23.7052222222222,NULL,NULL,'2012-11-13 06:27:08',56244.2688500001,18.6785,0.0435,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_72278.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(4203,3017,0,'LSQ12ftb','LSQ',65.4220416666667,-23.7052222222222,NULL,NULL,'2012-11-13 07:48:10',56244.3251200002,18.5621,0.0383,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_72279.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(4204,3017,0,'LSQ12ftb','LSQ',65.4215416666667,-23.7053333333333,NULL,NULL,'2012-11-13 07:49:50',56244.3262800002,18.2043,0.0456,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_72277.gif',37314276029,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(4205,3106,0,'LSQ12fsw','LSQ',74.165875,-30.1308055555556,NULL,NULL,'2012-11-13 06:06:38',56244.2546100002,19.9703,0.1938,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_snap_72245.gif',37203066249,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,581297910,9082779,NULL,NULL,NULL,NULL),(4206,3112,0,'LSQ12fvu','LSQ',53.5190833333333,-21.8744722222222,NULL,NULL,'2012-11-13 06:17:01',56244.2618200001,18.8872,0.0487,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_72091.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(4207,3112,0,'LSQ12fvu','LSQ',53.5190833333333,-21.8744722222222,NULL,NULL,'2012-11-13 07:30:39',56244.3129599998,18.9772,0.0441,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_72092.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(4208,3114,0,'LSQ12fvq','LSQ',19.15075,-31.4520833333333,NULL,NULL,'2012-11-13 02:19:28',56244.0968599999,18.5838,0.0313,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_72155.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(4209,3114,0,'LSQ12fvq','LSQ',19.1507916666667,-31.4520277777778,NULL,NULL,'2012-11-13 02:21:09',56244.09803,18.5907,0.0305,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_72153.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(4210,3114,0,'LSQ12fvq','LSQ',19.1507916666667,-31.4520833333333,NULL,NULL,'2012-11-13 04:35:54',56244.1916,18.2903,0.0379,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_72156.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(4211,3114,0,'LSQ12fvq','LSQ',19.1507083333333,-31.4520833333333,NULL,NULL,'2012-11-13 04:37:35',56244.1927700001,18.6205,0.0267,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_72154.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(4212,3118,0,'LSQ12fvp','LSQ',10.710125,-34.1603333333333,NULL,NULL,'2012-11-13 01:53:57',56244.07914,17.2755,0.0333,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_72114.gif',34872963970,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(4213,3122,0,'LSQ12fvn','LSQ',16.392,-35.4907777777778,NULL,NULL,'2012-11-13 02:10:58',56244.0909500001,20.1256,0.0648,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_72158.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(4214,3122,0,'LSQ12fvn','LSQ',16.3919166666667,-35.4908055555556,NULL,NULL,'2012-11-13 04:15:29',56244.1774300002,19.9996,0.064,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_72159.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(4215,3125,0,'LSQ12fvl','LSQ',75.2085,-38.6531944444444,NULL,NULL,'2012-11-13 05:23:27',56244.22462,18.1683,0.0376,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_72148.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(4216,3125,0,'LSQ12fvl','LSQ',75.2085416666667,-38.6532222222222,NULL,NULL,'2012-11-13 07:02:53',56244.2936800001,17.9152,0.0314,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_72149.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(4217,3222,0,'LSQ12fvm','LSQ',47.950875,-38.8036111111111,NULL,NULL,'2012-11-13 06:54:26',56244.2878100001,20.7277,0.2004,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_72100.gif',38600095382,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126490,9423851,NULL,NULL,NULL,NULL),(4218,3229,0,'LSQ12fvk','LSQ',0.974333333333333,-36.1122222222222,NULL,NULL,'2012-11-13 01:23:26',56244.0579499998,19.856,0.1393,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_history.html','sne?',NULL,0.07307,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_snap_72103.gif',34677267104,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541832298,8466129,NULL,NULL,NULL,NULL),(4219,3234,0,'LSQ12fwu','LSQ',357.674583333333,-37.2142777777778,NULL,NULL,'2012-11-13 01:16:39',56244.0532300002,20.1546,0.1182,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_snap_72186.gif',49956994282,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,780578035,12196531,NULL,NULL,NULL,NULL),(4220,3234,0,'LSQ12fwu','LSQ',357.674583333333,-37.2143333333333,NULL,NULL,'2012-11-13 03:16:36',56244.1365299998,19.86,0.1261,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_snap_72187.gif',49956994282,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,780578035,12196531,NULL,NULL,NULL,NULL),(4221,3237,0,'LSQ12fwt','LSQ',54.0464166666667,-37.4260277777778,NULL,NULL,'2012-11-13 08:26:02',56244.3514200002,20.453,0.154,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_72126.gif',38589273853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(4224,3245,0,'LSQ12fwz','LSQ',21.2805833333333,-26.1291666666667,NULL,NULL,'2012-11-13 02:47:56',56244.1166300001,18.7503,0.0553,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_72124.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(4225,3245,0,'LSQ12fwz','LSQ',21.2805416666667,-26.1291666666667,NULL,NULL,'2012-11-13 04:47:46',56244.1998399999,18.8103,0.0488,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_72125.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(4226,3249,0,'LSQ12fww','LSQ',62.5344166666667,-34.165,NULL,NULL,'2012-11-13 08:12:19',56244.3418899998,19.0147,0.0482,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_72088.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(4227,3287,0,'LSQ12fxc','LSQ',47.8155416666667,-22.4542222222222,NULL,NULL,'2012-11-13 06:39:18',56244.2773000002,19.0564,0.0898,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_72136.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(4228,3287,0,'LSQ12fxc','LSQ',47.81575,-22.4541111111111,NULL,NULL,'2012-11-13 07:42:48',56244.3213999998,19.6345,0.1115,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_72137.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(4229,3293,0,'LSQ12fxa','LSQ',358.600375,-30.1614722222222,NULL,NULL,'2012-11-13 01:18:20',56244.0543999998,20.9137,0.1812,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxa/LSQ12fxa_history.html','agn?',NULL,0.1428,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxa/LSQ12fxa_snap_72061.gif',50044826551,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781950414,12217975,NULL,NULL,NULL,NULL),(4230,3295,0,'LSQ12fwx','LSQ',359.541625,-29.7360555555556,NULL,NULL,'2012-11-13 03:30:04',56244.1458899998,20.1077,0.0899,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_history.html','sne - nice',NULL,0.0972,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_snap_72197.gif',50036319036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781817484,12215898,NULL,NULL,NULL,NULL),(4231,3481,0,'LSQ12fzc','LSQ',43.04475,-35.9738611111111,NULL,NULL,'2012-11-13 02:54:56',56244.1214899998,19.6151,0.1644,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_72080.gif',38652782971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(4232,3485,0,'LSQ12gbj','LSQ',66.04775,-25.4151666666667,NULL,NULL,'2012-11-13 06:25:26',56244.26767,19.9503,0.1078,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_snap_72098.gif',37181674004,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,580963656,9077557,NULL,NULL,NULL,NULL),(4233,3485,0,'LSQ12gbj','LSQ',66.047625,-25.4150833333333,NULL,NULL,'2012-11-13 07:49:50',56244.3262800002,19.6326,0.1141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_snap_72099.gif',37181674004,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,580963656,9077557,NULL,NULL,NULL,NULL),(4234,3497,0,'LSQ12gay','LSQ',22.6857916666667,-24.6005833333333,NULL,NULL,'2012-11-13 02:38:18',56244.1099399999,21.0403,0.1842,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_snap_72140.gif',34701767715,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,542215120,8472111,NULL,NULL,NULL,NULL),(4235,3502,0,'LSQ12gav','LSQ',355.82775,-24.8746388888889,NULL,NULL,'2012-11-13 01:14:51',56244.0519900001,19.577,0.0909,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_snap_72175.gif',50001954988,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781280546,12207508,NULL,NULL,NULL,NULL),(4236,3502,0,'LSQ12gav','LSQ',355.827666666667,-24.8745555555556,NULL,NULL,'2012-11-13 03:14:53',56244.13534,19.2161,0.0782,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_snap_72176.gif',50001954988,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781280546,12207508,NULL,NULL,NULL,NULL),(4237,3514,0,'LSQ12gaq','LSQ',65.3839583333333,-25.3801666666667,NULL,NULL,'2012-11-13 07:48:10',56244.3251200002,20.9639,0.1645,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_snap_72178.gif',37182103829,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580970372,9077662,NULL,NULL,NULL,NULL),(4238,3520,0,'LSQ12gak','LSQ',21.5754166666667,-23.3501944444444,NULL,NULL,'2012-11-13 04:44:23',56244.1974900002,19.7359,0.1322,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_snap_72085.gif',35177372187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549646440,8588225,NULL,NULL,NULL,NULL),(4239,3530,0,'LSQ12gad','LSQ',52.3021666666667,-30.6228888888889,NULL,NULL,'2012-11-13 05:30:27',56244.2294899998,19.2721,0.1731,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_72122.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(4240,3530,0,'LSQ12gad','LSQ',52.3020416666667,-30.6229722222222,NULL,NULL,'2012-11-13 07:06:29',56244.29617,19.6701,0.1241,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_72123.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(4241,3537,0,'LSQ12gab','LSQ',81.8936666666667,-31.3133333333333,NULL,NULL,'2012-11-13 05:51:00',56244.24376,20.4104,0.1391,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_snap_72117.gif',37311362015,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,582990031,9109219,NULL,NULL,NULL,NULL),(4242,3537,0,'LSQ12gab','LSQ',81.8941666666667,-31.3134166666667,NULL,NULL,'2012-11-13 07:16:38',56244.3032200001,20.0129,0.1147,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_snap_72118.gif',37311362015,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,582990031,9109219,NULL,NULL,NULL,NULL),(4243,3540,0,'LSQ12fzz','LSQ',81.4934583333333,-34.4575555555556,NULL,NULL,'2012-11-13 07:16:38',56244.3032200001,18.2102,0.0281,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_72119.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(4244,3551,0,'LSQ12fzr','LSQ',49.1794166666667,-30.2705,NULL,NULL,'2012-11-13 03:01:42',56244.1261900002,19.4556,0.0933,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_72199.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(4245,3551,0,'LSQ12fzr','LSQ',49.1794166666667,-30.2704444444444,NULL,NULL,'2012-11-13 05:01:28',56244.2093600002,19.3385,0.0821,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-11-14 12:46:02','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_72200.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(4246,3889,0,'LSQ12gft','LSQ',56.504125,-28.9319166666667,NULL,NULL,'2012-11-13 01:08:42',56244.0477100001,20.9055,0.1694,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gft/LSQ12gft_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gft/LSQ12gft_snap_72204.gif',38583605078,NULL,NULL,NULL,'2012-10-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602868829,9419825,NULL,NULL,NULL,NULL),(4247,3797,0,'LSQ12gdj','LSQ',358.680458333333,-25.6761111111111,NULL,NULL,'2012-11-13 01:18:20',56244.0543999998,15.9701,0.0076,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdj/LSQ12gdj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdj/LSQ12gdj_snap_72214.gif',50005825251,NULL,NULL,NULL,'2012-11-05 01:14:52',56236.052,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781341019,12208453,NULL,NULL,NULL,NULL),(4248,3797,0,'LSQ12gdj','LSQ',358.680416666667,-25.6761388888889,NULL,NULL,'2012-11-13 03:18:17',56244.1376999998,15.9505,0.0075,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdj/LSQ12gdj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdj/LSQ12gdj_snap_72215.gif',50005825249,NULL,NULL,NULL,'2012-11-05 01:14:52',56236.052,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781341019,12208453,NULL,NULL,NULL,NULL),(4249,3809,0,'LSQ12gdd','LSQ',53.6044166666667,-26.7740555555556,NULL,NULL,'2012-11-13 01:05:00',56244.0451500001,20.2331,0.0943,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_72166.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(4250,3809,0,'LSQ12gdd','LSQ',53.6035833333333,-26.7739444444444,NULL,NULL,'2012-11-13 01:08:42',56244.0477100001,20.3232,0.1165,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_72164.gif',38579529027,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(4251,3809,0,'LSQ12gdd','LSQ',53.6042083333333,-26.7740277777778,NULL,NULL,'2012-11-13 03:05:05',56244.1285399999,20.3918,0.0833,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_72167.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(4252,3809,0,'LSQ12gdd','LSQ',53.6035416666667,-26.7740277777778,NULL,NULL,'2012-11-13 03:08:47',56244.1310999999,20.0425,0.075,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_72165.gif',38579529024,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(4253,3818,0,'LSQ12gdc','LSQ',74.152875,-31.6034444444444,NULL,NULL,'2012-11-13 05:45:55',56244.2402300001,17.7712,0.0768,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_72208.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(4254,3818,0,'LSQ12gdc','LSQ',74.1529166666667,-31.6034444444444,NULL,NULL,'2012-11-13 08:07:12',56244.3383399998,18.0946,0.0644,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_72209.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(4255,3821,0,'LSQ12gcw','LSQ',68.31875,-38.1014444444444,NULL,NULL,'2012-11-13 05:18:22',56244.2210900001,19.8887,0.0833,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_72076.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(4256,3821,0,'LSQ12gcw','LSQ',68.3184583333333,-38.1013333333333,NULL,NULL,'2012-11-13 08:20:57',56244.3478899999,19.6099,0.0772,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_72077.gif',37823536133,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(4257,3864,0,'LSQ12gel','LSQ',55.750625,-26.6940277777778,NULL,NULL,'2012-11-13 03:08:47',56244.1310999999,20.195,0.1009,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_snap_72192.gif',38528356173,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602005565,9406336,NULL,NULL,NULL,NULL),(4258,4075,0,'LSQ12ghf','LSQ',1.15595833333333,-35.5166944444444,NULL,NULL,'2012-11-13 01:23:26',56244.0579499998,19.6055,0.0811,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_history.html','very bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_snap_72288.gif',34663125229,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,541611331,8462677,NULL,NULL,NULL,NULL),(4259,4075,0,'LSQ12ghf','LSQ',1.15595833333333,-35.5166388888889,NULL,NULL,'2012-11-13 03:23:21',56244.1412200001,19.507,0.095,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_history.html','very bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_snap_72289.gif',34663125229,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,541611331,8462677,NULL,NULL,NULL,NULL),(4260,4056,0,'LSQ12ghe','LSQ',68.5490416666667,-23.0559722222222,NULL,NULL,'2012-11-13 06:28:50',56244.2700299998,19.3526,0.0654,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_72254.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(4261,4056,0,'LSQ12ghe','LSQ',68.5490416666667,-23.0559444444444,NULL,NULL,'2012-11-13 07:35:44',56244.3164900001,19.226,0.0591,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_72255.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(4262,4058,0,'LSQ12ggy','LSQ',54.0126666666667,-25.3440833333333,NULL,NULL,'2012-11-13 07:28:57',56244.3117800001,20.2006,0.1188,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggy/LSQ12ggy_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggy/LSQ12ggy_snap_72256.gif',38545689795,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602276403,9410568,NULL,NULL,NULL,NULL),(4263,4061,0,'LSQ12ggx','LSQ',47.8960833333333,-22.3203611111111,NULL,NULL,'2012-11-13 06:13:37',56244.2594599999,19.6355,0.1301,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_72308.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(4264,4061,0,'LSQ12ggx','LSQ',47.8960833333333,-22.3203611111111,NULL,NULL,'2012-11-13 06:41:00',56244.2784799999,19.6325,0.0995,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_72309.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(4265,4067,0,'LSQ12ggq','LSQ',69.428875,-35.8658055555556,NULL,NULL,'2012-11-13 05:18:22',56244.2210900001,19.8395,0.0687,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_72274.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(4266,4067,0,'LSQ12ggq','LSQ',69.4289166666667,-35.8658611111111,NULL,NULL,'2012-11-13 08:20:57',56244.3478899999,19.8674,0.0719,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_72275.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(4267,4082,0,'LSQ12ggo','LSQ',60.4303333333333,-34.9308611111111,NULL,NULL,'2012-11-13 05:13:17',56244.2175599998,20.8237,0.1908,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_snap_72252.gif',37676606780,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588696980,9198390,NULL,NULL,NULL,NULL),(4268,4082,0,'LSQ12ggo','LSQ',60.4303333333333,-34.9308333333333,NULL,NULL,'2012-11-13 06:57:48',56244.2901499998,20.5941,0.1484,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_snap_72253.gif',37676606780,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588696980,9198390,NULL,NULL,NULL,NULL),(4269,4118,0,'LSQ12ghd','LSQ',71.864125,-21.3292222222222,NULL,NULL,'2012-11-13 06:28:50',56244.2700299998,19.8849,0.098,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_72246.gif',37342670896,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479232,9116863,NULL,NULL,NULL,NULL),(4270,4118,0,'LSQ12ghd','LSQ',71.8647916666667,-21.3294722222222,NULL,NULL,'2012-11-13 07:35:44',56244.3164900001,20.4076,0.1142,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_72247.gif',37342671080,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479235,9116863,NULL,NULL,NULL,NULL),(4271,4120,0,'LSQ12ghc','LSQ',66.223,-21.2026666666667,NULL,NULL,'2012-11-13 06:25:26',56244.26767,17.5827,0.0302,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_72268.gif',37325531170,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(4272,4120,0,'LSQ12ghc','LSQ',66.22275,-21.2026944444444,NULL,NULL,'2012-11-13 07:49:50',56244.3262800002,17.4878,0.0261,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_72269.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(4273,4133,0,'LSQ12gha','LSQ',57.2165833333333,-23.4219444444444,NULL,NULL,'2012-11-13 06:20:23',56244.2641599998,20.0796,0.1865,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gha/LSQ12gha_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gha/LSQ12gha_snap_72265.gif',37995371538,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593677680,9276213,NULL,NULL,NULL,NULL),(4274,4140,0,'LSQ12ggw','LSQ',49.5531666666667,-21.4535277777778,NULL,NULL,'2012-11-13 06:39:18',56244.2773000002,20.872,0.1732,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggw/LSQ12ggw_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggw/LSQ12ggw_snap_72272.gif',38028965827,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,594202591,9284415,NULL,NULL,NULL,NULL),(4275,4144,0,'LSQ12ggu','LSQ',52.9389583333333,-28.9198888888889,NULL,NULL,'2012-11-13 03:05:05',56244.1285399999,20.8108,0.1757,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_snap_72251.gif',38584679552,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602885618,9420087,NULL,NULL,NULL,NULL),(4276,4156,0,'LSQ12ggn','LSQ',58.0249583333333,-39.0652222222222,NULL,NULL,'2012-11-13 05:09:55',56244.2152200001,16.6878,0.0119,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_72262.gif',37665320689,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(4277,4156,0,'LSQ12ggn','LSQ',58.0250416666667,-39.06525,NULL,NULL,'2012-11-13 08:26:02',56244.3514200002,16.6343,0.013,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 12:46:02','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_72263.gif',37665320689,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(4278,2730,0,'LSQ12fml','LSQ',56.0149583333333,-3.28875,NULL,NULL,'2012-11-14 07:48:31',56245.3253600001,19.4658,0.1308,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-11-14 17:46:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fml/LSQ12fml_history.html','sne',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fml/LSQ12fml_snap_72540.gif',37008688685,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578260760,9035324,NULL,NULL,NULL,NULL),(4279,2900,0,'LSQ12fqb','LSQ',70.8875416666667,-11.9015277777778,NULL,NULL,'2012-11-14 06:01:59',56245.2513799998,18.8962,0.0777,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-11-14 17:46:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_72677.gif',37539442496,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553789,9164902,NULL,NULL,NULL,NULL),(4280,2915,0,'LSQ12fpv','LSQ',56.9055,-8.73188888888889,NULL,NULL,'2012-11-14 05:51:46',56245.2442899998,18.6602,0.0816,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-11-14 17:46:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_history.html','sn?',NULL,0.034397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_snap_72668.gif',37021133916,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578455217,9038362,NULL,NULL,NULL,NULL),(4281,2915,0,'LSQ12fpv','LSQ',56.9055,-8.73186111111111,NULL,NULL,'2012-11-14 07:58:58',56245.33262,20.0693,0.1447,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-11-14 17:46:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_history.html','sn?',NULL,0.034397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_snap_72669.gif',37021133916,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578455217,9038362,NULL,NULL,NULL,NULL),(4282,2959,0,'LSQ12frb','LSQ',51.5673333333333,-5.16391666666667,NULL,NULL,'2012-11-14 05:05:09',56245.2119100001,19.4784,0.1813,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-11-14 17:46:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frb/LSQ12frb_snap_72560.gif',36840221571,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,575628462,8994194,NULL,NULL,NULL,NULL),(4283,3273,0,'LSQ12fwf','LSQ',20.2270416666667,-0.525861111111111,NULL,NULL,'2012-11-14 02:09:09',56245.0896899998,19.8322,0.1922,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-11-14 17:46:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_history.html','sne?',NULL,0.09287,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_snap_72541.gif',34496037884,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539000591,8421884,NULL,NULL,NULL,NULL),(4284,3281,0,'LSQ12fwd','LSQ',56.39175,-0.357222222222222,NULL,NULL,'2012-11-14 05:12:08',56245.2167699998,19.4584,0.0912,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-11-14 17:46:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_history.html','agn?',NULL,0.10854,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwd/LSQ12fwd_snap_72555.gif',36993805998,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578028218,9031690,NULL,NULL,NULL,NULL),(4285,3346,0,'LSQ12fzb','LSQ',34.1771666666667,20.6692777777778,NULL,NULL,'2012-11-14 01:36:09',56245.06678,20.0551,0.1206,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-11-14 17:46:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzb/LSQ12fzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzb/LSQ12fzb_snap_72535.gif',68109800746,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1064215636,16628369,NULL,NULL,NULL,NULL),(4286,3348,0,'LSQ12fza','LSQ',34.8935416666667,21.2726111111111,NULL,NULL,'2012-11-14 01:36:09',56245.06678,19.6106,0.0984,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-11-14 17:46:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fza/LSQ12fza_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fza/LSQ12fza_snap_72564.gif',68112332845,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1064255200,16628987,NULL,NULL,NULL,NULL),(4287,3350,0,'LSQ12fyy','LSQ',24.37525,16.6959444444444,NULL,NULL,'2012-11-14 01:23:11',56245.0577699998,19.2539,0.0879,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-11-14 17:46:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_snap_72534.gif',67419126530,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1053423852,16459747,NULL,NULL,NULL,NULL),(4288,3374,0,'LSQ12fyg','LSQ',68.983,-4.04513888888889,NULL,NULL,'2012-11-14 06:19:47',56245.2637499999,20.2267,0.135,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-11-14 17:46:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyg/LSQ12fyg_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyg/LSQ12fyg_snap_72531.gif',37463478352,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585366849,9146357,NULL,NULL,NULL,NULL),(4289,3378,0,'LSQ12fyf','LSQ',63.8234166666667,-7.06952777777778,NULL,NULL,'2012-11-14 06:14:36',56245.2601399999,19.1505,0.074,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-11-14 17:46:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_snap_72522.gif',36956960238,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577452503,9022695,NULL,NULL,NULL,NULL),(4290,3378,0,'LSQ12fyf','LSQ',63.8234166666667,-7.06947222222222,NULL,NULL,'2012-11-14 07:27:51',56245.3110099998,19.275,0.0966,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-11-14 17:46:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_snap_72523.gif',36956960238,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577452503,9022695,NULL,NULL,NULL,NULL),(4291,3380,0,'LSQ12fye','LSQ',62.7185416666667,-4.92305555555556,NULL,NULL,'2012-11-14 06:11:13',56245.2577999998,18.7532,0.0682,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-11-14 17:46:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_72519.gif',36961736785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(4292,3380,0,'LSQ12fye','LSQ',62.7184583333333,-4.92308333333333,NULL,NULL,'2012-11-14 07:26:09',56245.3098300002,18.7486,0.0998,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-11-14 17:46:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_72520.gif',36961736787,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(4293,3386,0,'LSQ12fyb','LSQ',53.6895416666667,-3.7385,NULL,NULL,'2012-11-14 03:04:01',56245.1277899998,19.78,0.1295,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-11-14 17:46:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_72524.gif',36820699952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(4294,3399,0,'LSQ12fxy','LSQ',50.1275416666667,-11.2956666666667,NULL,NULL,'2012-11-14 02:56:36',56245.1226499998,20.0991,0.1932,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-11-14 17:46:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_snap_72529.gif',37885680972,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591963765,9249433,NULL,NULL,NULL,NULL),(4295,3746,0,'LSQ12gcm','LSQ',59.1725833333333,-12.5713888888889,NULL,NULL,'2012-11-14 05:15:33',56245.2191400002,21.1671,0.1832,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcm/LSQ12gcm_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcm/LSQ12gcm_snap_72628.gif',36885694052,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,576338969,9005296,NULL,NULL,NULL,NULL),(4296,3750,0,'LSQ12gcl','LSQ',60.4599583333333,-12.6629444444444,NULL,NULL,'2012-11-14 07:06:59',56245.2965199999,20.5931,0.1313,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcl/LSQ12gcl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcl/LSQ12gcl_snap_72629.gif',36864727705,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,576011370,9000177,NULL,NULL,NULL,NULL),(4297,3764,0,'LSQ12gcd','LSQ',59.5835,-18.6201388888889,NULL,NULL,'2012-11-14 05:39:44',56245.23593,18.8996,0.0784,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_snap_72518.gif',36851844463,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575810069,8997032,NULL,NULL,NULL,NULL),(4298,3770,0,'LSQ12gbz','LSQ',66.584875,-10.1035277777778,NULL,NULL,'2012-11-14 06:00:18',56245.2502100002,18.8285,0.058,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_history.html','sne - nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_snap_72556.gif',37466637666,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585416213,9147128,NULL,NULL,NULL,NULL),(4299,3770,0,'LSQ12gbz','LSQ',66.5849583333333,-10.1035833333333,NULL,NULL,'2012-11-14 07:21:05',56245.3063099999,19.0753,0.0787,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_history.html','sne - nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_snap_72557.gif',37466637666,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585416213,9147128,NULL,NULL,NULL,NULL),(4300,3893,0,'LSQ12gfs','LSQ',55.3095416666667,-26.72075,NULL,NULL,'2012-11-14 03:12:50',56245.1339199999,21.084,0.1094,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_snap_72622.gif',38579773067,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602808954,9418889,NULL,NULL,NULL,NULL),(4301,3786,0,'LSQ12gef','LSQ',25.1404583333333,18.5101111111111,NULL,NULL,'2012-11-14 01:23:11',56245.0577699998,18.3677,0.0427,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_snap_72583.gif',67385903372,NULL,NULL,NULL,'2012-10-31 03:53:16',56231.162,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1052904740,16451636,NULL,NULL,NULL,NULL),(4302,3809,0,'LSQ12gdd','LSQ',53.60425,-26.7740277777778,NULL,NULL,'2012-11-14 01:11:35',56245.04972,19.909,0.1008,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_72577.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(4303,3809,0,'LSQ12gdd','LSQ',53.6035416666667,-26.7739444444444,NULL,NULL,'2012-11-14 01:15:16',56245.0522799999,20.0841,0.0878,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_72575.gif',38579529027,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(4304,3809,0,'LSQ12gdd','LSQ',53.6042916666667,-26.7740277777778,NULL,NULL,'2012-11-14 03:12:50',56245.1339199999,20.6269,0.0936,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_72578.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(4305,3809,0,'LSQ12gdd','LSQ',53.6034583333333,-26.7739444444444,NULL,NULL,'2012-11-14 03:16:37',56245.1365499999,20.0988,0.0831,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_72576.gif',38579529027,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(4306,3845,0,'LSQ12geg','LSQ',55.0532916666667,-26.793,NULL,NULL,'2012-11-14 01:11:35',56245.04972,21.5849,0.1534,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_snap_72587.gif',38582715225,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602854925,9419608,NULL,NULL,NULL,NULL),(4307,3851,0,'LSQ12ges','LSQ',74.98625,-19.4645555555556,NULL,NULL,'2012-11-14 04:47:47',56245.19985,19.7455,0.0846,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_snap_72647.gif',37563466779,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586929168,9170768,NULL,NULL,NULL,NULL),(4308,3864,0,'LSQ12gel','LSQ',55.75075,-26.6940555555556,NULL,NULL,'2012-11-14 01:15:16',56245.0522799999,21.6355,0.16,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_snap_72595.gif',38528356173,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602005565,9406336,NULL,NULL,NULL,NULL),(4309,3883,0,'LSQ12gfh','LSQ',53.6905,-6.84380555555556,NULL,NULL,'2012-11-14 05:05:09',56245.2119100001,16.9887,0.015,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_history.html','sne??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_snap_72641.gif',36800390526,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575006101,8984470,NULL,NULL,NULL,NULL),(4310,3898,0,'LSQ12gfi','LSQ',53.556625,-6.84191666666667,NULL,NULL,'2012-11-14 05:05:09',56245.2119100001,15.2188,0.0042,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfi/LSQ12gfi_history.html','CV?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfi/LSQ12gfi_snap_72640.gif',36800371307,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575005801,8984465,NULL,NULL,NULL,NULL),(4311,4144,0,'LSQ12ggu','LSQ',52.939,-28.9200555555556,NULL,NULL,'2012-11-14 03:12:50',56245.1339199999,21.4501,0.1754,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggu/LSQ12ggu_snap_72665.gif',38584680256,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602885629,9420087,NULL,NULL,NULL,NULL),(4312,4159,0,'LSQ12gjg','LSQ',69.850375,-5.53480555555556,NULL,NULL,'2012-11-14 06:21:29',56245.26492,14.4152,0.0023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_snap_72684.gif',37457458286,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,585272785,9144887,NULL,NULL,NULL,NULL),(4313,4159,0,'LSQ12gjg','LSQ',69.8504166666667,-5.53480555555556,NULL,NULL,'2012-11-14 07:31:14',56245.31336,14.4988,0.0022,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_snap_72685.gif',37457458286,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,585272785,9144887,NULL,NULL,NULL,NULL),(4314,4165,0,'LSQ12gjc','LSQ',52.670875,-6.37286111111111,NULL,NULL,'2012-11-14 03:04:01',56245.1277899998,19.2645,0.1217,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_72687.gif',36797933958,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(4315,4165,0,'LSQ12gjc','LSQ',52.6707916666667,-6.373,NULL,NULL,'2012-11-14 05:05:09',56245.2119100001,19.124,0.0969,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_72688.gif',36797933958,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(4316,4173,0,'LSQ12giy','LSQ',60.1034166666667,-10.5716111111111,NULL,NULL,'2012-11-14 05:55:09',56245.24664,20.2203,0.1123,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giy/LSQ12giy_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giy/LSQ12giy_snap_72690.gif',36987791452,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577934241,9030222,NULL,NULL,NULL,NULL),(4317,4317,1,'LSQ12gkk','LSQ',76.869,-23.8546388888889,NULL,NULL,'2012-11-11 08:28:12',56242.35292,20.7523,0.1529,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_72426.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(4318,4317,0,'LSQ12gkk','LSQ',76.8690416666667,-23.8546388888889,NULL,NULL,'2012-11-13 06:35:36',56244.2747300002,20.7932,0.1414,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_72392.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(4319,4317,0,'LSQ12gkk','LSQ',76.8690416666667,-23.8545833333333,NULL,NULL,'2012-11-13 07:39:06',56244.3188299998,20.7704,0.1274,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_72393.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(4320,4320,1,'LSQ12gki','LSQ',17.6022916666667,-22.4757777777778,NULL,NULL,'2012-11-03 03:55:47',56234.1637400002,19.86,0.2071,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_snap_72422.gif',35214805816,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,550231340,8597364,NULL,NULL,NULL,NULL),(4321,4320,0,'LSQ12gki','LSQ',17.602375,-22.4758333333333,NULL,NULL,'2012-11-09 04:26:45',56240.1852500001,19.2045,0.0634,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_snap_72423.gif',35214805816,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,550231340,8597364,NULL,NULL,NULL,NULL),(4322,4320,0,'LSQ12gki','LSQ',17.6024583333333,-22.4758055555556,NULL,NULL,'2012-11-13 02:14:24',56244.0933400001,18.7585,0.0822,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_snap_72388.gif',35214805816,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,550231340,8597364,NULL,NULL,NULL,NULL),(4323,4320,0,'LSQ12gki','LSQ',17.6024166666667,-22.4758055555556,NULL,NULL,'2012-11-13 04:18:59',56244.17985,19.0685,0.0671,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_snap_72389.gif',35214805816,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,550231340,8597364,NULL,NULL,NULL,NULL),(4324,4324,1,'LSQ12gke','LSQ',0.167208333333333,-27.1032777777778,NULL,NULL,'2012-10-25 04:08:59',56225.1729100002,18.8588,0.1071,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_history.html','sne?',NULL,0.069557,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_snap_72406.gif',34767217141,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,543237767,8488090,NULL,NULL,NULL,NULL),(4325,4324,0,'LSQ12gke','LSQ',0.167333333333333,-27.1032222222222,NULL,NULL,'2012-11-03 00:51:13',56234.0355699998,19.892,0.1671,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_history.html','sne?',NULL,0.069557,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_snap_72407.gif',34767217141,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,543237767,8488090,NULL,NULL,NULL,NULL),(4326,4324,0,'LSQ12gke','LSQ',0.167125,-27.10325,NULL,NULL,'2012-11-05 01:27:27',56236.0607400001,19.1853,0.1213,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_history.html','sne?',NULL,0.069557,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_snap_72408.gif',34767217143,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,543237767,8488090,NULL,NULL,NULL,NULL),(4327,4324,0,'LSQ12gke','LSQ',0.16725,-27.1031666666667,NULL,NULL,'2012-11-05 03:18:25',56236.1378000001,20.094,0.1643,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_history.html','sne?',NULL,0.069557,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_snap_72409.gif',34767217141,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,543237767,8488090,NULL,NULL,NULL,NULL),(4328,4324,0,'LSQ12gke','LSQ',0.167083333333333,-27.1033333333333,NULL,NULL,'2012-11-07 03:49:40',56238.1595000001,19.7335,0.1753,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_history.html','sne?',NULL,0.069557,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_snap_72410.gif',34767217143,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,543237767,8488090,NULL,NULL,NULL,NULL),(4329,4324,0,'LSQ12gke','LSQ',0.167083333333333,-27.1035555555556,NULL,NULL,'2012-11-13 01:20:02',56244.0555799999,19.985,0.142,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_history.html','sne?',NULL,0.069557,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_snap_72380.gif',34767217143,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,543237767,8488090,NULL,NULL,NULL,NULL),(4330,4324,0,'LSQ12gke','LSQ',0.167208333333333,-27.1033055555556,NULL,NULL,'2012-11-13 03:19:59',56244.13888,19.8692,0.1187,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_history.html','sne?',NULL,0.069557,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_snap_72381.gif',34767217141,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,543237767,8488090,NULL,NULL,NULL,NULL),(4331,4331,1,'LSQ12gka','LSQ',16.323375,-26.7014166666667,NULL,NULL,'2012-11-13 02:16:05',56244.0945100002,20.838,0.1495,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_snap_72354.gif',34725499594,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542585931,8477905,NULL,NULL,NULL,NULL),(4332,4331,0,'LSQ12gka','LSQ',16.3235,-26.7015555555556,NULL,NULL,'2012-11-13 04:32:32',56244.1892599999,19.5174,0.0889,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_snap_72355.gif',34725499594,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542585931,8477905,NULL,NULL,NULL,NULL),(4333,4333,1,'LSQ12gjz','LSQ',7.02683333333333,-29.097,NULL,NULL,'2012-11-13 01:48:54',56244.0756299999,20.0521,0.1009,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjz/LSQ12gjz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjz/LSQ12gjz_snap_72352.gif',34888280959,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545129389,8517646,NULL,NULL,NULL,NULL),(4334,4333,0,'LSQ12gjz','LSQ',7.02658333333333,-29.0970833333333,NULL,NULL,'2012-11-13 03:48:43',56244.1588400002,20.8576,0.1461,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjz/LSQ12gjz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjz/LSQ12gjz_snap_72353.gif',34888280957,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545129389,8517646,NULL,NULL,NULL,NULL),(4335,4335,1,'LSQ12gjv','LSQ',55.645875,-31.3634166666667,NULL,NULL,'2012-11-01 06:52:07',56232.2862,19.6134,0.1385,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjv/LSQ12gjv_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjv/LSQ12gjv_snap_72361.gif',38585895204,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602904612,9420384,NULL,NULL,NULL,NULL),(4336,4335,0,'LSQ12gjv','LSQ',55.645625,-31.3634444444444,NULL,NULL,'2012-11-09 05:23:09',56240.2244199999,21.2214,0.1976,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjv/LSQ12gjv_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjv/LSQ12gjv_snap_72362.gif',38585895204,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602904612,9420384,NULL,NULL,NULL,NULL),(4337,4335,0,'LSQ12gjv','LSQ',55.6460833333333,-31.3637777777778,NULL,NULL,'2012-11-09 07:04:27',56240.29476,20.7219,0.1524,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjv/LSQ12gjv_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjv/LSQ12gjv_snap_72363.gif',38585895220,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602904612,9420384,NULL,NULL,NULL,NULL),(4338,4335,0,'LSQ12gjv','LSQ',55.645625,-31.36325,NULL,NULL,'2012-11-13 05:34:01',56244.23196,20.6219,0.1558,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjv/LSQ12gjv_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjv/LSQ12gjv_snap_72344.gif',38585895204,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602904612,9420384,NULL,NULL,NULL,NULL),(4339,4335,0,'LSQ12gjv','LSQ',55.6455,-31.36325,NULL,NULL,'2012-11-13 07:08:10',56244.29734,20.4711,0.1614,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjv/LSQ12gjv_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjv/LSQ12gjv_snap_72345.gif',38585895204,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602904612,9420384,NULL,NULL,NULL,NULL),(4340,4340,1,'LSQ12gju','LSQ',11.9497083333333,-34.6518055555556,NULL,NULL,'2012-11-05 04:27:52',56236.1860199999,18.9582,0.0972,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gju/LSQ12gju_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gju/LSQ12gju_snap_72360.gif',34865347578,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,544771055,8512047,NULL,NULL,NULL,NULL),(4341,4340,0,'LSQ12gju','LSQ',11.9499583333333,-34.6518888888889,NULL,NULL,'2012-11-13 02:05:53',56244.0874299998,20.3037,0.1606,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gju/LSQ12gju_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gju/LSQ12gju_snap_72342.gif',34865347578,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,544771055,8512047,NULL,NULL,NULL,NULL),(4342,4340,0,'LSQ12gju','LSQ',11.949875,-34.6519722222222,NULL,NULL,'2012-11-13 04:10:24',56244.1738999998,20.4857,0.1612,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gju/LSQ12gju_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gju/LSQ12gju_snap_72343.gif',34865347578,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,544771055,8512047,NULL,NULL,NULL,NULL),(4343,4343,1,'LSQ12gjt','LSQ',6.905125,-30.5744166666667,NULL,NULL,'2012-11-13 01:40:21',56244.0696899998,20.4586,0.1349,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjt/LSQ12gjt_history.html','sne?',NULL,0.114853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjt/LSQ12gjt_snap_72340.gif',34857031270,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,544641113,8510017,NULL,NULL,NULL,NULL),(4344,4343,0,'LSQ12gjt','LSQ',6.905,-30.5746666666667,NULL,NULL,'2012-11-13 03:40:14',56244.15295,20.9889,0.1595,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjt/LSQ12gjt_history.html','sne?',NULL,0.114853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjt/LSQ12gjt_snap_72341.gif',34857031270,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,544641113,8510017,NULL,NULL,NULL,NULL),(4345,4345,1,'LSQ12gjo','LSQ',0.551916666666667,-37.3913611111111,NULL,NULL,'2012-11-03 00:52:54',56234.0367399999,19.8813,0.1079,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjo/LSQ12gjo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjo/LSQ12gjo_snap_72326.gif',34668377393,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541693396,8463959,NULL,NULL,NULL,NULL),(4346,4345,0,'LSQ12gjo','LSQ',0.552083333333333,-37.3913611111111,NULL,NULL,'2012-11-07 01:50:37',56238.0768200001,20.5616,0.1669,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjo/LSQ12gjo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjo/LSQ12gjo_snap_72327.gif',34668377393,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541693396,8463959,NULL,NULL,NULL,NULL),(4347,4345,0,'LSQ12gjo','LSQ',0.551708333333333,-37.3913055555556,NULL,NULL,'2012-11-13 01:21:44',56244.0567600001,20.6731,0.1613,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjo/LSQ12gjo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjo/LSQ12gjo_snap_72318.gif',34668377393,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541693396,8463959,NULL,NULL,NULL,NULL),(4348,4345,0,'LSQ12gjo','LSQ',0.552166666666667,-37.3912222222222,NULL,NULL,'2012-11-13 03:21:40',56244.14005,20.4742,0.1387,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 17:46:04','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjo/LSQ12gjo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjo/LSQ12gjo_snap_72319.gif',34668377393,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541693396,8463959,NULL,NULL,NULL,NULL),(4349,4349,1,'LSQ12gld','LSQ',60.8971666666667,-1.52591666666667,NULL,NULL,'2012-10-31 06:14:13',56231.2598799998,17.1149,0.0511,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gld/LSQ12gld_history.html','sne?',NULL,0.054825,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gld/LSQ12gld_snap_72827.gif',36937794522,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577153039,9018016,NULL,NULL,NULL,NULL),(4350,4349,0,'LSQ12gld','LSQ',60.89725,-1.52608333333333,NULL,NULL,'2012-10-31 07:33:21',56231.31483,18.1587,0.1633,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gld/LSQ12gld_history.html','sne?',NULL,0.054825,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gld/LSQ12gld_snap_72828.gif',36937794522,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577153039,9018016,NULL,NULL,NULL,NULL),(4351,4349,0,'LSQ12gld','LSQ',60.8979583333333,-1.52583333333333,NULL,NULL,'2012-11-04 05:42:21',56235.2377499999,19.5727,0.1243,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gld/LSQ12gld_history.html','sne?',NULL,0.054825,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gld/LSQ12gld_snap_72829.gif',36937794522,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577153039,9018016,NULL,NULL,NULL,NULL),(4352,4349,0,'LSQ12gld','LSQ',60.8972916666667,-1.52586111111111,NULL,NULL,'2012-11-04 07:35:09',56235.3160799998,19.6748,0.1251,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gld/LSQ12gld_history.html','sne?',NULL,0.054825,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gld/LSQ12gld_snap_72830.gif',36937794522,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577153039,9018016,NULL,NULL,NULL,NULL),(4353,4349,0,'LSQ12gld','LSQ',60.8972083333333,-1.52569444444444,NULL,NULL,'2012-11-08 06:29:12',56239.2702799998,20.3333,0.1277,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gld/LSQ12gld_history.html','sne?',NULL,0.054825,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gld/LSQ12gld_snap_72831.gif',36937794522,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577153039,9018016,NULL,NULL,NULL,NULL),(4354,4349,0,'LSQ12gld','LSQ',60.8973333333333,-1.52577777777778,NULL,NULL,'2012-11-14 06:23:11',56245.2661100002,18.9513,0.0604,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gld/LSQ12gld_history.html','sne?',NULL,0.054825,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gld/LSQ12gld_snap_72772.gif',36937794522,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577153039,9018016,NULL,NULL,NULL,NULL),(4355,4349,0,'LSQ12gld','LSQ',60.89725,-1.52577777777778,NULL,NULL,'2012-11-14 07:32:55',56245.3145300001,18.8751,0.0733,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gld/LSQ12gld_history.html','sne?',NULL,0.054825,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gld/LSQ12gld_snap_72773.gif',36937794522,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577153039,9018016,NULL,NULL,NULL,NULL),(4356,4356,1,'LSQ12gla','LSQ',50.066875,-9.48133333333333,NULL,NULL,'2012-10-10 05:27:16',56210.2272800002,19.6782,0.1251,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_snap_72801.gif',37898099251,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,592157800,9252465,NULL,NULL,NULL,NULL),(4357,4356,0,'LSQ12gla','LSQ',50.06725,-9.48088888888889,NULL,NULL,'2012-11-08 05:46:47',56239.24083,20.2374,0.1364,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_snap_72802.gif',37898099251,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,592157800,9252465,NULL,NULL,NULL,NULL),(4358,4356,0,'LSQ12gla','LSQ',50.067125,-9.48086111111111,NULL,NULL,'2012-11-12 02:34:31',56243.1073099999,20.2963,0.1637,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_snap_72803.gif',37898099251,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,592157800,9252465,NULL,NULL,NULL,NULL),(4359,4356,0,'LSQ12gla','LSQ',50.0672916666667,-9.48083333333333,NULL,NULL,'2012-11-12 04:39:39',56243.1942099999,20.1719,0.2158,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_snap_72804.gif',37898099251,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,592157800,9252465,NULL,NULL,NULL,NULL),(4360,4356,0,'LSQ12gla','LSQ',50.06725,-9.48088888888889,NULL,NULL,'2012-11-14 02:56:36',56245.1226499998,19.8001,0.1303,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_snap_72766.gif',37898099251,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,592157800,9252465,NULL,NULL,NULL,NULL),(4361,4356,0,'LSQ12gla','LSQ',50.0671666666667,-9.48086111111111,NULL,NULL,'2012-11-14 04:58:22',56245.2072000001,19.719,0.1101,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_snap_72767.gif',37898099251,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,592157800,9252465,NULL,NULL,NULL,NULL),(4362,4362,1,'LSQ12gkx','LSQ',56.6781666666667,-26.35675,NULL,NULL,'2012-11-08 01:18:41',56239.0546499998,22.1067,0.1722,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_snap_72776.gif',38528720443,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602011256,9406425,NULL,NULL,NULL,NULL),(4363,4362,0,'LSQ12gkx','LSQ',56.677875,-26.3566944444444,NULL,NULL,'2012-11-10 03:04:54',56241.1284099999,22.0524,0.1821,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_snap_72777.gif',38528720443,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602011256,9406425,NULL,NULL,NULL,NULL),(4364,4362,0,'LSQ12gkx','LSQ',56.678,-26.3568611111111,NULL,NULL,'2012-11-11 01:03:59',56242.0444399999,21.579,0.1432,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_snap_72778.gif',38528720443,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602011256,9406425,NULL,NULL,NULL,NULL),(4365,4362,0,'LSQ12gkx','LSQ',56.6779583333333,-26.3567777777778,NULL,NULL,'2012-11-12 04:07:19',56243.1717500002,21.382,0.1247,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_snap_72779.gif',38528720443,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602011256,9406425,NULL,NULL,NULL,NULL),(4366,4362,0,'LSQ12gkx','LSQ',56.6779583333333,-26.3569166666667,NULL,NULL,'2012-11-13 03:08:47',56244.1310999999,21.5155,0.1273,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_snap_72780.gif',38528720443,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602011256,9406425,NULL,NULL,NULL,NULL),(4367,4362,0,'LSQ12gkx','LSQ',56.6779583333333,-26.3569166666667,NULL,NULL,'2012-11-14 01:15:16',56245.0522799999,21.2691,0.1373,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_snap_72760.gif',38528720443,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602011256,9406425,NULL,NULL,NULL,NULL),(4368,4362,0,'LSQ12gkx','LSQ',56.6779166666667,-26.3568611111111,NULL,NULL,'2012-11-14 03:16:37',56245.1365499999,21.4814,0.1411,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-14 19:46:05','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_snap_72761.gif',38528720443,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602011256,9406425,NULL,NULL,NULL,NULL),(4369,4331,0,'LSQ12gka','LSQ',16.323375,-26.7014166667,NULL,NULL,'2012-11-15 09:35:59',56246.4,NULL,NULL,NULL,0.13,NULL,'Ia',NULL,'2012-11-15 22:42:20','2012-12-04 13:09:51','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,34725499594,'UH 2.2m','SNIFS','SNfactory','2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542585931,8477905,NULL,NULL,NULL,NULL),(4370,3715,0,'LSQ12gbt','LSQ',22.5429166667,9.38822222222,NULL,NULL,'2012-11-15 09:35:59',56246.4,NULL,NULL,NULL,0.07,NULL,'Ibc',NULL,'2012-11-15 22:48:35','2012-12-04 13:09:52','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,67542604792,'UH 2.2m','SNIFS','SNfactory','2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1055353199,16489893,NULL,NULL,NULL,NULL),(4371,2974,0,'LSQ12frx','LSQ',12.9882916666667,-23.7102222222222,NULL,NULL,'2012-11-15 01:53:12',56246.0786199998,19.226,0.0532,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_snap_72970.gif',35316090512,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(4372,2976,0,'LSQ12fro','LSQ',46.4136666666667,-33.5881944444444,NULL,NULL,'2012-11-15 05:01:14',56246.2091899998,19.1863,0.1196,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fro/LSQ12fro_history.html','CV?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fro/LSQ12fro_snap_73011.gif',38648187714,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603877933,9435592,NULL,NULL,NULL,NULL),(4373,2985,0,'LSQ12fsh','LSQ',12.7767083333333,-39.1600277777778,NULL,NULL,'2012-11-15 02:01:39',56246.0844800002,18.9033,0.0509,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_73072.gif',38166915082,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(4374,2987,0,'LSQ12fsj','LSQ',73.7292916666667,-36.3250277777778,NULL,NULL,'2012-11-15 05:26:45',56246.2269199998,16.0146,0.0038,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_73069.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(4375,2987,0,'LSQ12fsj','LSQ',73.7292916666667,-36.3250277777778,NULL,NULL,'2012-11-15 07:04:50',56246.2950300002,16.0126,0.0038,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_73070.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(4376,2993,0,'LSQ12fss','LSQ',18.7157916666667,-30.094,NULL,NULL,'2012-11-15 02:13:36',56246.0927800001,19.7028,0.073,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_73059.gif',34734808837,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(4377,2993,0,'LSQ12fss','LSQ',18.7158333333333,-30.0939166666667,NULL,NULL,'2012-11-15 04:37:19',56246.1925900001,19.7956,0.0677,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_73060.gif',34734808839,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(4378,2999,0,'LSQ12fsn','LSQ',10.6064166666667,-34.0972777777778,NULL,NULL,'2012-11-15 01:49:49',56246.0762700001,14.7669,0.005,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_history.html','Unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_snap_73079.gif',34872861140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544888455,8513882,NULL,NULL,NULL,NULL),(4379,3001,0,'LSQ12fth','LSQ',47.82275,-25.1096666666667,NULL,NULL,'2012-11-15 02:41:04',56246.1118600001,18.0114,0.0279,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_73027.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(4380,3001,0,'LSQ12fth','LSQ',47.8227083333333,-25.1096666666667,NULL,NULL,'2012-11-15 05:04:37',56246.21154,18.3224,0.0443,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_73028.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(4381,3007,0,'LSQ12fte','LSQ',52.1527916666667,-24.8717222222222,NULL,NULL,'2012-11-15 06:16:31',56246.2614799999,20.0989,0.1273,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_snap_73080.gif',38021943870,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594092872,9282701,NULL,NULL,NULL,NULL),(4382,3007,0,'LSQ12fte','LSQ',52.1525416666667,-24.8715833333333,NULL,NULL,'2012-11-15 07:52:45',56246.3283000002,19.7767,0.1214,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_snap_73081.gif',38021943871,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594092872,9282701,NULL,NULL,NULL,NULL),(4383,3009,0,'LSQ12ftd','LSQ',64.2446666666667,-24.1447222222222,NULL,NULL,'2012-11-15 06:26:40',56246.26853,20.2326,0.113,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_73029.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(4384,3009,0,'LSQ12ftd','LSQ',64.244625,-24.1447777777778,NULL,NULL,'2012-11-15 06:28:23',56246.2697200002,20.3478,0.1784,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_73031.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(4385,3009,0,'LSQ12ftd','LSQ',64.2445,-24.1446666666667,NULL,NULL,'2012-11-15 07:34:06',56246.3153499998,20.3931,0.1472,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_73030.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(4386,3009,0,'LSQ12ftd','LSQ',64.244625,-24.1447777777778,NULL,NULL,'2012-11-15 07:35:47',56246.3165199999,20.059,0.1516,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_73032.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(4387,3013,0,'LSQ12ftc','LSQ',64.8030416666667,-24.3553055555556,NULL,NULL,'2012-11-15 06:26:40',56246.26853,19.9929,0.1153,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_73033.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(4388,3013,0,'LSQ12ftc','LSQ',64.802875,-24.3551666666667,NULL,NULL,'2012-11-15 06:28:23',56246.2697200002,19.8009,0.1022,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_73035.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(4389,3013,0,'LSQ12ftc','LSQ',64.8032083333333,-24.3553333333333,NULL,NULL,'2012-11-15 07:34:06',56246.3153499998,20.026,0.1065,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_73034.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(4390,3013,0,'LSQ12ftc','LSQ',64.802875,-24.3551666666667,NULL,NULL,'2012-11-15 07:35:47',56246.3165199999,19.5879,0.1076,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_73036.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(4391,3017,0,'LSQ12ftb','LSQ',65.4215,-23.7053611111111,NULL,NULL,'2012-11-15 06:26:40',56246.26853,18.0903,0.0486,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_73053.gif',37314276031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(4392,3017,0,'LSQ12ftb','LSQ',65.4215,-23.7053333333333,NULL,NULL,'2012-11-15 07:34:06',56246.3153499998,18.272,0.0436,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_73054.gif',37314276031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(4393,3017,0,'LSQ12ftb','LSQ',65.4220416666667,-23.70525,NULL,NULL,'2012-11-15 07:35:47',56246.3165199999,18.5936,0.0505,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_73055.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(4394,3112,0,'LSQ12fvu','LSQ',53.51875,-21.8744166666667,NULL,NULL,'2012-11-15 06:18:12',56246.2626499999,18.9339,0.0692,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_72918.gif',38040994984,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(4395,3112,0,'LSQ12fvu','LSQ',53.5190833333333,-21.8744444444444,NULL,NULL,'2012-11-15 07:51:03',56246.32712,18.9608,0.048,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_72919.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(4396,3114,0,'LSQ12fvq','LSQ',19.1507916666667,-31.4520555555556,NULL,NULL,'2012-11-15 02:11:54',56246.0915999999,18.531,0.0288,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_72965.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(4397,3114,0,'LSQ12fvq','LSQ',19.1507083333333,-31.4520555555556,NULL,NULL,'2012-11-15 02:13:36',56246.0927800001,18.5826,0.0268,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_72963.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(4398,3114,0,'LSQ12fvq','LSQ',19.1506666666667,-31.4520555555556,NULL,NULL,'2012-11-15 04:37:19',56246.1925900001,18.5958,0.0269,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_72964.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(4399,3118,0,'LSQ12fvp','LSQ',10.710125,-34.1603055555556,NULL,NULL,'2012-11-15 01:49:49',56246.0762700001,16.6864,0.0224,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_72946.gif',34872963970,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(4400,3122,0,'LSQ12fvn','LSQ',16.391875,-35.49075,NULL,NULL,'2012-11-15 02:03:21',56246.0856699999,20.0604,0.0714,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_72974.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(4401,3125,0,'LSQ12fvl','LSQ',75.208625,-38.6531388888889,NULL,NULL,'2012-11-15 05:26:45',56246.2269199998,18.1412,0.0402,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_72966.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(4402,3125,0,'LSQ12fvl','LSQ',75.2085416666667,-38.6531388888889,NULL,NULL,'2012-11-15 07:04:50',56246.2950300002,18.1369,0.0365,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_72967.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(4403,3214,0,'LSQ12fvs','LSQ',358.452125,-32.06,NULL,NULL,'2012-11-15 01:07:14',56246.0466999998,18.4119,0.0623,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_history.html','sne?',NULL,0.0606,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvs/LSQ12fvs_snap_72972.gif',50033234904,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781769295,12215145,NULL,NULL,NULL,NULL),(4404,3222,0,'LSQ12fvm','LSQ',47.9509583333333,-38.8036666666667,NULL,NULL,'2012-11-15 05:08:04',56246.2139400002,20.022,0.1208,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_72933.gif',38600095382,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126490,9423851,NULL,NULL,NULL,NULL),(4405,3222,0,'LSQ12fvm','LSQ',47.9507916666667,-38.8035277777778,NULL,NULL,'2012-11-15 06:56:15',56246.2890699999,20.6869,0.1573,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_72934.gif',38600095382,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126490,9423851,NULL,NULL,NULL,NULL),(4406,3234,0,'LSQ12fwu','LSQ',357.6745,-37.2144166666667,NULL,NULL,'2012-11-15 01:08:55',56246.0478699999,19.7535,0.1615,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_snap_72996.gif',49956994282,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,780578035,12196531,NULL,NULL,NULL,NULL),(4407,3237,0,'LSQ12fwt','LSQ',54.0464166666667,-37.426,NULL,NULL,'2012-11-15 08:25:28',56246.3510199999,20.1602,0.1476,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_72949.gif',38589273853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(4410,3245,0,'LSQ12fwz','LSQ',21.2805,-26.1291388888889,NULL,NULL,'2012-11-15 02:23:47',56246.09986,18.6555,0.0495,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_72950.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(4411,3245,0,'LSQ12fwz','LSQ',21.2805416666667,-26.1291666666667,NULL,NULL,'2012-11-15 04:47:34',56246.1997000002,18.7121,0.0507,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_72951.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(4412,3247,0,'LSQ12fwy','LSQ',20.6035416666667,-28.1008055555556,NULL,NULL,'2012-11-15 04:35:37',56246.19141,21.4309,0.1624,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwy/LSQ12fwy_history.html','sne - nice',NULL,0.081453,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwy/LSQ12fwy_snap_72953.gif',34751625109,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542994142,8484283,NULL,NULL,NULL,NULL),(4413,3249,0,'LSQ12fww','LSQ',62.5344583333333,-34.1650555555556,NULL,NULL,'2012-11-15 05:38:47',56246.2352700001,18.8377,0.0495,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_72922.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(4414,3249,0,'LSQ12fww','LSQ',62.5342083333333,-34.1648888888889,NULL,NULL,'2012-11-15 07:10:05',56246.29868,18.8343,0.0576,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_72923.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(4415,3284,0,'LSQ12fxk','LSQ',57.9454166666667,-22.1758611111111,NULL,NULL,'2012-11-15 06:21:36',56246.2650100002,18.8626,0.1508,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_snap_72961.gif',37996998851,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593703107,9276611,NULL,NULL,NULL,NULL),(4416,3284,0,'LSQ12fxk','LSQ',57.9454166666667,-22.1760277777778,NULL,NULL,'2012-11-15 07:32:25',56246.3141800002,19.8644,0.1349,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_snap_72962.gif',37996998851,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593703107,9276611,NULL,NULL,NULL,NULL),(4417,3287,0,'LSQ12fxc','LSQ',47.815875,-22.4541666666667,NULL,NULL,'2012-11-15 05:04:37',56246.21154,19.6629,0.112,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_72959.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(4418,3293,0,'LSQ12fxa','LSQ',358.600791666667,-30.1613611111111,NULL,NULL,'2012-11-15 01:10:38',56246.0490600001,20.7059,0.1789,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxa/LSQ12fxa_history.html','agn?',NULL,0.1428,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxa/LSQ12fxa_snap_72887.gif',50044826551,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781950414,12217975,NULL,NULL,NULL,NULL),(4419,3295,0,'LSQ12fwx','LSQ',359.541666666667,-29.7361111111111,NULL,NULL,'2012-11-15 01:22:31',56246.0573100001,20.1369,0.0892,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_history.html','sne - nice',NULL,0.0972,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_snap_73001.gif',50036319036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781817484,12215898,NULL,NULL,NULL,NULL),(4420,3478,0,'LSQ12fxn','LSQ',53.6284166666667,-27.3569722222222,NULL,NULL,'2012-11-15 00:56:14',56246.0390599999,19.8322,0.0992,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxn/LSQ12fxn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxn/LSQ12fxn_snap_72894.gif',38580994894,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602828045,9419188,NULL,NULL,NULL,NULL),(4421,3478,0,'LSQ12fxn','LSQ',53.628125,-27.3570555555556,NULL,NULL,'2012-11-15 04:33:24',56246.1898699999,20.8671,0.163,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxn/LSQ12fxn_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxn/LSQ12fxn_snap_72895.gif',38580994894,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602828045,9419188,NULL,NULL,NULL,NULL),(4422,3497,0,'LSQ12gay','LSQ',22.6860833333333,-24.6,NULL,NULL,'2012-11-15 02:18:44',56246.0963499998,19.5118,0.0824,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_snap_72957.gif',34701767715,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,542215120,8472111,NULL,NULL,NULL,NULL),(4423,3497,0,'LSQ12gay','LSQ',22.685375,-24.6005277777778,NULL,NULL,'2012-11-15 04:42:29',56246.1961699999,20.4509,0.1452,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_snap_72958.gif',34701767714,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,542215120,8472111,NULL,NULL,NULL,NULL),(4424,3502,0,'LSQ12gav','LSQ',355.827583333333,-24.8745833333333,NULL,NULL,'2012-11-15 01:03:52',56246.0443600002,19.2617,0.0928,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gav/LSQ12gav_snap_72992.gif',50001954988,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781280546,12207508,NULL,NULL,NULL,NULL),(4425,3530,0,'LSQ12gad','LSQ',52.3019166666667,-30.6228055555556,NULL,NULL,'2012-11-15 07:08:23',56246.2974999999,18.5338,0.0945,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_72948.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(4426,3548,0,'LSQ12fzu','LSQ',74.8829583333333,-38.4094444444444,NULL,NULL,'2012-11-15 05:25:03',56246.2257300001,19.6587,0.1269,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_72944.gif',37599816286,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(4427,3548,0,'LSQ12fzu','LSQ',74.8830416666667,-38.4094722222222,NULL,NULL,'2012-11-15 07:03:10',56246.2938700002,20.5277,0.1856,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_72945.gif',37599816286,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(4428,3551,0,'LSQ12fzr','LSQ',49.179375,-30.2704722222222,NULL,NULL,'2012-11-15 02:37:38',56246.10947,19.405,0.1473,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_73003.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(4429,3551,0,'LSQ12fzr','LSQ',49.1793333333333,-30.2705,NULL,NULL,'2012-11-15 05:01:14',56246.2091899998,19.2922,0.0892,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-11-16 12:46:06','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_73004.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(4430,3893,0,'LSQ12gfs','LSQ',55.3095833333333,-26.7208055555556,NULL,NULL,'2012-11-15 04:31:43',56246.1886999998,20.1321,0.1052,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_snap_73014.gif',38579773067,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602808954,9418889,NULL,NULL,NULL,NULL),(4431,3797,0,'LSQ12gdj','LSQ',358.680416666667,-25.6761388888889,NULL,NULL,'2012-11-15 01:10:38',56246.0490600001,15.1902,0.007,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdj/LSQ12gdj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdj/LSQ12gdj_snap_73020.gif',50005825249,NULL,NULL,NULL,'2012-11-05 01:14:52',56236.052,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781341019,12208453,NULL,NULL,NULL,NULL),(4432,3809,0,'LSQ12gdd','LSQ',53.6043333333333,-26.7740833333333,NULL,NULL,'2012-11-15 00:54:33',56246.0378899998,20.7074,0.1754,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_72981.gif',38579529475,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(4433,3809,0,'LSQ12gdd','LSQ',53.6034583333333,-26.774,NULL,NULL,'2012-11-15 00:56:14',56246.0390599999,20.5374,0.1682,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_72979.gif',38579529024,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(4434,3809,0,'LSQ12gdd','LSQ',53.6035416666667,-26.7739444444444,NULL,NULL,'2012-11-15 04:33:24',56246.1898699999,20.8315,0.1794,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_72980.gif',38579529027,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(4435,3818,0,'LSQ12gdc','LSQ',74.1526666666667,-31.6034444444444,NULL,NULL,'2012-11-15 05:48:54',56246.2423,17.816,0.1232,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_73021.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(4436,3818,0,'LSQ12gdc','LSQ',74.1528333333333,-31.6034444444444,NULL,NULL,'2012-11-15 08:06:37',56246.3379299999,17.5629,0.0616,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_73022.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(4437,3821,0,'LSQ12gcw','LSQ',68.3188333333333,-38.1013611111111,NULL,NULL,'2012-11-15 05:21:40',56246.2233899999,19.7526,0.1031,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_72901.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(4438,3821,0,'LSQ12gcw','LSQ',68.318875,-38.1012777777778,NULL,NULL,'2012-11-15 08:20:23',56246.3474900001,19.792,0.0857,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_72902.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(4439,4075,0,'LSQ12ghf','LSQ',1.15575,-35.5166944444444,NULL,NULL,'2012-11-15 01:15:44',56246.0526000001,19.905,0.1217,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_history.html','very bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_snap_73084.gif',34663125229,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,541611331,8462677,NULL,NULL,NULL,NULL),(4440,4056,0,'LSQ12ghe','LSQ',68.549,-23.0559444444444,NULL,NULL,'2012-11-15 06:30:04',56246.2708899998,19.0671,0.0544,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_73063.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(4441,4056,0,'LSQ12ghe','LSQ',68.549,-23.0559722222222,NULL,NULL,'2012-11-15 07:45:58',56246.3235900002,19.2956,0.0665,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_73064.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(4442,4061,0,'LSQ12ggx','LSQ',47.8960833333333,-22.3203611111111,NULL,NULL,'2012-11-15 05:06:18',56246.2127100001,19.4103,0.1014,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_73099.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(4443,4067,0,'LSQ12ggq','LSQ',69.428875,-35.8658611111111,NULL,NULL,'2012-11-15 05:21:40',56246.2233899999,19.8086,0.0697,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_73074.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(4444,4067,0,'LSQ12ggq','LSQ',69.4289166666667,-35.8658333333333,NULL,NULL,'2012-11-15 08:20:23',56246.3474900001,19.7888,0.0716,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_73075.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(4445,4082,0,'LSQ12ggo','LSQ',60.4302916666667,-34.9308888888889,NULL,NULL,'2012-11-15 05:16:36',56246.2198700001,20.4965,0.1754,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_snap_73056.gif',37676606780,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588696980,9198390,NULL,NULL,NULL,NULL),(4446,4082,0,'LSQ12ggo','LSQ',60.4302083333333,-34.9308333333333,NULL,NULL,'2012-11-15 08:22:05',56246.3486700002,20.0192,0.1155,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_snap_73057.gif',37676606780,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588696980,9198390,NULL,NULL,NULL,NULL),(4447,4118,0,'LSQ12ghd','LSQ',71.8647916666667,-21.3293333333333,NULL,NULL,'2012-11-15 07:45:58',56246.3235900002,20.3312,0.1402,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_73065.gif',37342671080,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479235,9116863,NULL,NULL,NULL,NULL),(4448,4120,0,'LSQ12ghc','LSQ',66.2229166666667,-21.2026944444444,NULL,NULL,'2012-11-15 07:34:06',56246.3153499998,17.334,0.0217,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_73076.gif',37325531170,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(4449,4133,0,'LSQ12gha','LSQ',57.216375,-23.4220277777778,NULL,NULL,'2012-11-15 06:21:36',56246.2650100002,19.5983,0.1605,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gha/LSQ12gha_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gha/LSQ12gha_snap_73077.gif',37995371538,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593677680,9276213,NULL,NULL,NULL,NULL),(4450,4133,0,'LSQ12gha','LSQ',57.2165,-23.422,NULL,NULL,'2012-11-15 07:32:25',56246.3141800002,19.5376,0.1128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gha/LSQ12gha_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gha/LSQ12gha_snap_73078.gif',37995371538,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593677680,9276213,NULL,NULL,NULL,NULL),(4451,4156,0,'LSQ12ggn','LSQ',58.0249166666667,-39.0651944444444,NULL,NULL,'2012-11-15 05:13:13',56246.2175199999,16.7086,0.0147,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_73061.gif',37665320689,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(4452,4156,0,'LSQ12ggn','LSQ',58.025,-39.0652222222222,NULL,NULL,'2012-11-15 08:25:28',56246.3510199999,16.8028,0.0149,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_73062.gif',37665320689,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(4453,4317,0,'LSQ12gkk','LSQ',76.8690416666667,-23.8546111111111,NULL,NULL,'2012-11-15 06:36:49',56246.2755700001,20.1721,0.0951,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_72935.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(4454,4317,0,'LSQ12gkk','LSQ',76.8690416666667,-23.8546388888889,NULL,NULL,'2012-11-15 07:42:36',56246.32125,19.9861,0.0878,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_72936.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(4455,4320,0,'LSQ12gki','LSQ',17.602375,-22.4758333333333,NULL,NULL,'2012-11-15 02:06:49',56246.0880700001,19.0361,0.0989,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_snap_73039.gif',35214805816,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,550231340,8597364,NULL,NULL,NULL,NULL),(4456,4324,0,'LSQ12gke','LSQ',0.167208333333333,-27.1032777777778,NULL,NULL,'2012-11-15 01:12:19',56246.0502300002,19.6186,0.1495,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_history.html','sne?',NULL,0.069557,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_snap_72947.gif',34767217141,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,543237767,8488090,NULL,NULL,NULL,NULL),(4457,4331,0,'LSQ12gka','LSQ',16.3234166666667,-26.7015277777778,NULL,NULL,'2012-11-15 02:08:31',56246.0892500002,19.5729,0.0835,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_snap_72897.gif',34725499594,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542585931,8477905,NULL,NULL,NULL,NULL),(4458,4333,0,'LSQ12gjz','LSQ',7.02729166666667,-29.0965,NULL,NULL,'2012-11-15 01:41:13',56246.0702999998,20.4134,0.1907,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjz/LSQ12gjz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjz/LSQ12gjz_snap_73052.gif',34888280957,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545129389,8517646,NULL,NULL,NULL,NULL),(4459,4335,0,'LSQ12gjv','LSQ',55.64575,-31.3632222222222,NULL,NULL,'2012-11-15 05:37:06',56246.2341,19.7789,0.121,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 12:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjv/LSQ12gjv_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjv/LSQ12gjv_snap_73023.gif',38585895204,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602904612,9420384,NULL,NULL,NULL,NULL),(4460,4362,0,'LSQ12gkx','pessto',56.6781666667,-26.35675,NULL,NULL,'2012-11-15 07:26:24',56246.31,NULL,NULL,NULL,0.255,NULL,'Ia',NULL,'2012-11-16 14:52:45','2012-12-04 13:09:51','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38528720443,'NTT','EFOSC2','Gonzalez Bufano','2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602011256,9406425,NULL,NULL,NULL,NULL),(4461,4165,0,'LSQ12gjc','pessto',52.6707916667,-6.37305555556,NULL,NULL,'2012-11-15 07:55:12',56246.33,NULL,NULL,NULL,0.173,NULL,'Ia',NULL,'2012-11-16 14:59:16','2012-12-04 13:09:51','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,36797933958,'NTT','EFOSC2','Gonzalez Bufano','2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(5246,5246,1,'LSQ12gln','LSQ',80.7475833333333,-33.4643055555556,NULL,NULL,'2012-11-13 07:16:38',56244.3032200001,20.8277,0.1858,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 21:46:06','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_73106.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(5247,5246,0,'LSQ12gln','LSQ',80.7475,-33.46425,NULL,NULL,'2012-11-15 05:53:58',56246.2458199998,19.8736,0.1185,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 21:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_73104.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(5248,5246,0,'LSQ12gln','LSQ',80.7475416666667,-33.4643611111111,NULL,NULL,'2012-11-15 07:18:33',56246.30455,19.9327,0.1089,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 21:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_73105.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(5249,5249,1,'LSQ12glk','LSQ',19.5815833333333,-38.36025,NULL,NULL,'2012-11-13 04:40:59',56244.1951299999,20.7256,0.1143,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 21:46:06','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_72870.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5250,5249,0,'LSQ12glk','LSQ',19.5815416666667,-38.36025,NULL,NULL,'2012-11-15 02:16:59',56246.0951299998,20.6508,0.1371,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 21:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_72864.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5251,5249,0,'LSQ12glk','LSQ',19.5815416666667,-38.36025,NULL,NULL,'2012-11-15 04:40:42',56246.1949399998,20.4164,0.1139,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 21:46:06','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_72865.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5252,2900,0,'LSQ12fqb','LSQ',70.8874583333333,-11.9014166666667,NULL,NULL,'2012-11-16 05:53:13',56247.2453000001,19.6788,0.1157,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_73280.gif',37539442496,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553789,9164902,NULL,NULL,NULL,NULL),(5253,2915,0,'LSQ12fpv','LSQ',56.9054166666667,-8.73211111111111,NULL,NULL,'2012-11-16 05:43:03',56247.2382399999,19.8213,0.14,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_history.html','sn?',NULL,0.034397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_snap_73278.gif',37021133916,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578455217,9038362,NULL,NULL,NULL,NULL),(5254,2915,0,'LSQ12fpv','LSQ',56.9053333333333,-8.73194444444444,NULL,NULL,'2012-11-16 08:01:08',56247.3341299999,20.0331,0.1533,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_history.html','sn?',NULL,0.034397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_snap_73279.gif',37021133916,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578455217,9038362,NULL,NULL,NULL,NULL),(5255,2939,0,'LSQ12fpp','LSQ',50.866625,-12.0054444444444,NULL,NULL,'2012-11-16 04:30:25',56247.1877899999,18.6819,0.1249,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_history.html','agn/sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpp/LSQ12fpp_snap_73160.gif',37885516712,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,591961198,9249393,NULL,NULL,NULL,NULL),(5256,3044,0,'LSQ12ftn','LSQ',2.53929166666667,-19.1404444444444,NULL,NULL,'2012-11-16 01:33:34',56247.0649799998,19.1167,0.0737,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_snap_73124.gif',34442362275,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538161910,8408779,NULL,NULL,NULL,NULL),(5257,3044,0,'LSQ12ftn','LSQ',2.53925,-19.1404444444444,NULL,NULL,'2012-11-16 03:32:55',56247.1478599999,19.0017,0.0603,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_snap_73125.gif',34442362275,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538161910,8408779,NULL,NULL,NULL,NULL),(5258,3035,0,'LSQ12fuy','LSQ',19.37525,0.593666666666667,NULL,NULL,'2012-11-16 04:01:35',56247.1677700002,19.4948,0.0932,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuy/LSQ12fuy_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuy/LSQ12fuy_snap_73275.gif',66652936653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041452135,16272689,NULL,NULL,NULL,NULL),(5259,3069,0,'LSQ12fus','LSQ',15.978625,-5.93847222222222,NULL,NULL,'2012-11-16 03:56:08',56247.1639899998,20.1445,0.1232,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fus/LSQ12fus_snap_73145.gif',34532215196,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539565862,8430716,NULL,NULL,NULL,NULL),(5260,3273,0,'LSQ12fwf','LSQ',20.2271666666667,-0.525861111111111,NULL,NULL,'2012-11-16 02:02:09',56247.0848300001,20.1404,0.191,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_history.html','sne?',NULL,0.09287,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_snap_73155.gif',34496037884,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539000591,8421884,NULL,NULL,NULL,NULL),(5261,3273,0,'LSQ12fwf','LSQ',20.2272083333333,-0.52575,NULL,NULL,'2012-11-16 04:01:35',56247.1677700002,19.9462,0.201,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_history.html','sne?',NULL,0.09287,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_snap_73156.gif',34496037884,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539000591,8421884,NULL,NULL,NULL,NULL),(5262,3350,0,'LSQ12fyy','LSQ',24.3757916666667,16.69575,NULL,NULL,'2012-11-16 01:15:00',56247.0520899999,19.9502,0.1338,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyy/LSQ12fyy_snap_73149.gif',67419126530,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1053423852,16459747,NULL,NULL,NULL,NULL),(5263,3356,0,'LSQ12fyv','LSQ',63.5567916666667,2.86277777777778,NULL,NULL,'2012-11-16 07:31:10',56247.3133200002,22.313,0.1542,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyv/LSQ12fyv_history.html','sne?',NULL,0.040024,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyv/LSQ12fyv_snap_73164.gif',65084187378,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1016940427,15889694,NULL,NULL,NULL,NULL),(5264,3374,0,'LSQ12fyg','LSQ',68.983,-4.04502777777778,NULL,NULL,'2012-11-16 07:34:33',56247.3156699999,20.3799,0.1408,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyg/LSQ12fyg_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyg/LSQ12fyg_snap_73148.gif',37463478352,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585366849,9146357,NULL,NULL,NULL,NULL),(5265,3378,0,'LSQ12fyf','LSQ',63.823375,-7.06947222222222,NULL,NULL,'2012-11-16 06:01:40',56247.25116,19.2418,0.0854,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_snap_73141.gif',36956960238,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577452503,9022695,NULL,NULL,NULL,NULL),(5266,3378,0,'LSQ12fyf','LSQ',63.8234166666667,-7.06955555555556,NULL,NULL,'2012-11-16 07:21:01',56247.3062700001,19.0444,0.0933,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_snap_73142.gif',36956960238,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577452503,9022695,NULL,NULL,NULL,NULL),(5267,3380,0,'LSQ12fye','LSQ',62.7185416666667,-4.92305555555556,NULL,NULL,'2012-11-16 05:58:17',56247.2488099998,18.8057,0.102,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_73137.gif',36961736785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(5268,3380,0,'LSQ12fye','LSQ',62.7184583333333,-4.92308333333333,NULL,NULL,'2012-11-16 07:19:20',56247.3051,18.4523,0.1134,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_73138.gif',36961736787,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(5269,3386,0,'LSQ12fyb','LSQ',53.6892916666667,-3.73841666666667,NULL,NULL,'2012-11-16 02:29:19',56247.1036999999,19.3207,0.1292,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_73134.gif',36820699952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(5270,3399,0,'LSQ12fxy','LSQ',50.1275416666667,-11.2955833333333,NULL,NULL,'2012-11-16 02:25:58',56247.1013699998,19.5525,0.1345,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-11-16 23:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_snap_73143.gif',37885680972,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591963765,9249433,NULL,NULL,NULL,NULL),(5271,3729,0,'LSQ12gcp','LSQ',70.565375,-15.3291111111111,NULL,NULL,'2012-11-16 05:36:15',56247.2335100002,20.2604,0.1232,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_snap_73150.gif',37536334322,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586505223,9164144,NULL,NULL,NULL,NULL),(5272,3729,0,'LSQ12gcp','LSQ',70.5652916666667,-15.329,NULL,NULL,'2012-11-16 08:04:36',56247.33653,21.3374,0.1866,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcp/LSQ12gcp_snap_73151.gif',37536334322,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586505223,9164144,NULL,NULL,NULL,NULL),(5273,3740,0,'LSQ12gcn','LSQ',67.4809583333333,-12.0793055555556,NULL,NULL,'2012-11-16 05:34:34',56247.2323400001,18.6397,0.0588,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_snap_73234.gif',37533040332,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586453755,9163339,NULL,NULL,NULL,NULL),(5274,3740,0,'LSQ12gcn','LSQ',67.4808333333333,-12.0793055555556,NULL,NULL,'2012-11-16 07:07:26',56247.29684,18.9855,0.1212,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_snap_73235.gif',37533040332,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586453755,9163339,NULL,NULL,NULL,NULL),(5275,3746,0,'LSQ12gcm','LSQ',59.1727083333333,-12.5713611111111,NULL,NULL,'2012-11-16 07:02:22',56247.2933200002,20.3291,0.1578,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcm/LSQ12gcm_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcm/LSQ12gcm_snap_73242.gif',36885694052,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,576338969,9005296,NULL,NULL,NULL,NULL),(5276,3750,0,'LSQ12gcl','LSQ',60.4600833333333,-12.6627777777778,NULL,NULL,'2012-11-16 07:02:22',56247.2933200002,19.893,0.0912,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcl/LSQ12gcl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcl/LSQ12gcl_snap_73243.gif',36864727705,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,576011370,9000177,NULL,NULL,NULL,NULL),(5277,3764,0,'LSQ12gcd','LSQ',59.5837083333333,-18.62025,NULL,NULL,'2012-11-16 03:25:24',56247.1426499998,18.6083,0.1624,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_snap_73135.gif',36851844463,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575810069,8997032,NULL,NULL,NULL,NULL),(5278,3764,0,'LSQ12gcd','LSQ',59.5832083333333,-18.6201666666667,NULL,NULL,'2012-11-16 05:24:24',56247.2252799999,19.2652,0.1322,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_snap_73136.gif',36851844463,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575810069,8997032,NULL,NULL,NULL,NULL),(5279,3770,0,'LSQ12gbz','LSQ',66.5849166666667,-10.1035833333333,NULL,NULL,'2012-11-16 05:51:31',56247.2441199999,18.8519,0.0571,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_history.html','sne - nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_snap_73172.gif',37466637666,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585416213,9147128,NULL,NULL,NULL,NULL),(5280,3770,0,'LSQ12gbz','LSQ',66.5849166666667,-10.1035833333333,NULL,NULL,'2012-11-16 07:15:57',56247.3027499998,18.9732,0.0717,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_history.html','sne - nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_snap_73173.gif',37466637666,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585416213,9147128,NULL,NULL,NULL,NULL),(5281,3786,0,'LSQ12gef','LSQ',25.1404166666667,18.5100833333333,NULL,NULL,'2012-11-16 01:15:00',56247.0520899999,18.3425,0.0407,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gef/LSQ12gef_snap_73201.gif',67385903372,NULL,NULL,NULL,'2012-10-31 03:53:16',56231.162,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1052904740,16451636,NULL,NULL,NULL,NULL),(5282,3851,0,'LSQ12ges','LSQ',74.98625,-19.4645555555556,NULL,NULL,'2012-11-16 05:12:27',56247.21698,20.3884,0.1162,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_snap_73256.gif',37563466779,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586929168,9170768,NULL,NULL,NULL,NULL),(5283,4159,0,'LSQ12gjg','LSQ',69.850375,-5.53480555555556,NULL,NULL,'2012-11-16 06:05:03',56247.2535100002,14.7045,0.0024,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_snap_73300.gif',37457458286,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,585272785,9144887,NULL,NULL,NULL,NULL),(5284,4159,0,'LSQ12gjg','LSQ',69.850375,-5.53480555555556,NULL,NULL,'2012-11-16 07:22:43',56247.3074500002,14.8019,0.0026,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_snap_73301.gif',37457458286,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,585272785,9144887,NULL,NULL,NULL,NULL),(5285,4165,0,'LSQ12gjc','LSQ',52.6709166666667,-6.37283333333333,NULL,NULL,'2012-11-16 02:29:19',56247.1036999999,19.2725,0.114,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_73294.gif',36797933958,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(5286,4165,0,'LSQ12gjc','LSQ',52.6707916666667,-6.37302777777778,NULL,NULL,'2012-11-16 04:35:28',56247.1913000001,19.2067,0.1036,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_73295.gif',36797933958,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(5287,4171,0,'LSQ12giz','LSQ',63.4554583333333,-10.0444166666667,NULL,NULL,'2012-11-16 07:14:17',56247.3015899998,20.1895,0.1886,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-16 23:46:08','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giz/LSQ12giz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giz/LSQ12giz_snap_73289.gif',36979075816,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577798059,9028094,NULL,NULL,NULL,NULL),(5288,2974,0,'LSQ12frx','LSQ',12.9882916666667,-23.7101666666667,NULL,NULL,'2012-11-17 01:44:49',56248.0728000002,19.1239,0.083,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_snap_73411.gif',35316090512,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(5289,2974,0,'LSQ12frx','LSQ',12.9882083333333,-23.7101666666667,NULL,NULL,'2012-11-17 03:44:41',56248.1560399998,19.2817,0.0551,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_snap_73412.gif',35316090512,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(5290,2985,0,'LSQ12fsh','LSQ',12.776625,-39.1600555555556,NULL,NULL,'2012-11-17 01:53:17',56248.0786799998,19.0265,0.0648,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_73543.gif',38166915083,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(5291,2985,0,'LSQ12fsh','LSQ',12.77675,-39.1600277777778,NULL,NULL,'2012-11-17 03:53:09',56248.1619099998,19.1112,0.0554,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_73544.gif',38166915082,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(5292,2987,0,'LSQ12fsj','LSQ',73.7292916666667,-36.3250277777778,NULL,NULL,'2012-11-17 02:58:01',56248.1236299998,16.0992,0.0055,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_73545.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(5293,2987,0,'LSQ12fsj','LSQ',73.7293333333333,-36.3250277777778,NULL,NULL,'2012-11-17 04:57:42',56248.2067399998,16.1313,0.0042,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_73546.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(5294,2991,0,'LSQ12fsi','LSQ',1.50433333333333,-35.1925,NULL,NULL,'2012-11-17 01:07:20',56248.0467699999,20.3913,0.1454,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_history.html','Old',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_snap_73466.gif',34665129379,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,541642646,8463166,NULL,NULL,NULL,NULL),(5295,2993,0,'LSQ12fss','LSQ',18.715875,-30.0939722222222,NULL,NULL,'2012-11-17 02:05:20',56248.0870400001,19.9553,0.0829,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_73510.gif',34734808839,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(5296,2993,0,'LSQ12fss','LSQ',18.7159166666667,-30.0939722222222,NULL,NULL,'2012-11-17 04:05:05',56248.1702000001,20.0993,0.0831,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_73511.gif',34734808839,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(5297,2999,0,'LSQ12fsn','LSQ',10.6064166666667,-34.09725,NULL,NULL,'2012-11-17 01:37:56',56248.0680200001,15.0869,0.0057,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_history.html','Unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_snap_73472.gif',34872861140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544888455,8513882,NULL,NULL,NULL,NULL),(5298,2999,0,'LSQ12fsn','LSQ',10.6064166666667,-34.0972222222222,NULL,NULL,'2012-11-17 03:37:50',56248.1512799999,15.3584,0.0053,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_history.html','Unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_snap_73473.gif',34872861140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544888455,8513882,NULL,NULL,NULL,NULL),(5299,3001,0,'LSQ12fth','LSQ',47.82275,-25.1096944444444,NULL,NULL,'2012-11-17 02:32:36',56248.10598,18.3546,0.037,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_73438.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(5300,3001,0,'LSQ12fth','LSQ',47.8225833333333,-25.10975,NULL,NULL,'2012-11-17 02:34:18',56248.1071600001,18.4716,0.0377,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_73440.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(5301,3001,0,'LSQ12fth','LSQ',47.8228333333333,-25.1096388888889,NULL,NULL,'2012-11-17 04:32:21',56248.1891399999,17.7698,0.026,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_73439.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(5302,3009,0,'LSQ12ftd','LSQ',64.244625,-24.1447222222222,NULL,NULL,'2012-11-17 05:56:24',56248.2475000001,20.2137,0.1495,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_73436.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(5303,3009,0,'LSQ12ftd','LSQ',64.2445,-24.1447222222222,NULL,NULL,'2012-11-17 05:58:05',56248.2486800002,19.9151,0.1535,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_73437.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(5304,3013,0,'LSQ12ftc','LSQ',64.80325,-24.3553888888889,NULL,NULL,'2012-11-17 05:56:24',56248.2475000001,20.6173,0.1614,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_73538.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(5305,3013,0,'LSQ12ftc','LSQ',64.802875,-24.3551666666667,NULL,NULL,'2012-11-17 05:58:05',56248.2486800002,20.1113,0.111,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_73539.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(5306,3017,0,'LSQ12ftb','LSQ',65.421375,-23.7053611111111,NULL,NULL,'2012-11-17 05:56:24',56248.2475000001,18.2623,0.041,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_73509.gif',37314276031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(5307,3112,0,'LSQ12fvu','LSQ',53.5190833333333,-21.8744722222222,NULL,NULL,'2012-11-17 05:47:55',56248.2416099999,18.9281,0.0447,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_73526.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(5308,3114,0,'LSQ12fvq','LSQ',19.1507916666667,-31.4520555555556,NULL,NULL,'2012-11-17 02:03:38',56248.08586,18.6295,0.0286,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_73495.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(5309,3114,0,'LSQ12fvq','LSQ',19.1507083333333,-31.4520833333333,NULL,NULL,'2012-11-17 02:05:20',56248.0870400001,18.6381,0.0289,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_73493.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(5310,3114,0,'LSQ12fvq','LSQ',19.1508333333333,-31.4520555555556,NULL,NULL,'2012-11-17 04:03:23',56248.1690199999,18.6335,0.0294,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_73496.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(5311,3114,0,'LSQ12fvq','LSQ',19.15075,-31.4520555555556,NULL,NULL,'2012-11-17 04:05:05',56248.1702000001,18.6686,0.0277,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_73494.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(5312,3118,0,'LSQ12fvp','LSQ',10.7102083333333,-34.1603333333333,NULL,NULL,'2012-11-17 01:37:56',56248.0680200001,17.2483,0.0325,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_73391.gif',34872963970,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(5313,3118,0,'LSQ12fvp','LSQ',10.710125,-34.1603333333333,NULL,NULL,'2012-11-17 03:37:50',56248.1512799999,17.3497,0.024,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_73392.gif',34872963970,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(5314,3122,0,'LSQ12fvn','LSQ',16.3919583333333,-35.49075,NULL,NULL,'2012-11-17 01:55:10',56248.0799799999,20.0847,0.0708,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_73497.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(5315,3122,0,'LSQ12fvn','LSQ',16.3919166666667,-35.4907777777778,NULL,NULL,'2012-11-17 03:54:50',56248.1630799999,20.1582,0.0769,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_73498.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(5316,3125,0,'LSQ12fvl','LSQ',75.2085833333333,-38.6531388888889,NULL,NULL,'2012-11-17 02:58:01',56248.1236299998,18.6238,0.0548,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_73527.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(5317,3125,0,'LSQ12fvl','LSQ',75.2085833333333,-38.6531666666667,NULL,NULL,'2012-11-17 04:57:42',56248.2067399998,18.7003,0.0597,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_73528.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(5318,3229,0,'LSQ12fvk','LSQ',0.974791666666667,-36.1124166666667,NULL,NULL,'2012-11-17 01:09:02',56248.04794,20.4906,0.1639,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_history.html','sne?',NULL,0.07307,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_snap_73379.gif',34677267107,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541832298,8466129,NULL,NULL,NULL,NULL),(5319,3229,0,'LSQ12fvk','LSQ',0.974666666666667,-36.1126666666667,NULL,NULL,'2012-11-17 03:09:01',56248.1312699998,20.6045,0.1764,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_history.html','sne?',NULL,0.07307,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvk/LSQ12fvk_snap_73380.gif',34677267105,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541832298,8466129,NULL,NULL,NULL,NULL),(5320,3234,0,'LSQ12fwu','LSQ',357.6745,-37.2144166666667,NULL,NULL,'2012-11-17 01:02:15',56248.04324,20.213,0.1344,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwu/LSQ12fwu_snap_73491.gif',49956994282,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,780578035,12196531,NULL,NULL,NULL,NULL),(5321,3237,0,'LSQ12fwt','LSQ',54.0465,-37.4259722222222,NULL,NULL,'2012-11-17 02:44:28',56248.1142199999,21.1897,0.1694,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_73532.gif',38589273853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(5322,3237,0,'LSQ12fwt','LSQ',54.0465416666667,-37.4259722222222,NULL,NULL,'2012-11-17 04:44:10',56248.19734,20.8109,0.1378,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_73533.gif',38589273853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(5324,3245,0,'LSQ12fwz','LSQ',21.2805416666667,-26.1291666666667,NULL,NULL,'2012-11-17 02:15:32',56248.0941300001,18.7589,0.0523,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_73402.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(5325,3245,0,'LSQ12fwz','LSQ',21.2805,-26.1291944444444,NULL,NULL,'2012-11-17 04:15:16',56248.1772699999,18.8902,0.055,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_73403.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(5326,3249,0,'LSQ12fww','LSQ',62.5344166666667,-34.1648888888889,NULL,NULL,'2012-11-17 05:09:53',56248.2152,18.8587,0.054,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_73378.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(5327,3287,0,'LSQ12fxc','LSQ',47.8157083333333,-22.4542222222222,NULL,NULL,'2012-11-17 02:32:36',56248.10598,19.1394,0.0834,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_73399.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(5328,3287,0,'LSQ12fxc','LSQ',47.815625,-22.4541388888889,NULL,NULL,'2012-11-17 04:32:21',56248.1891399999,19.4321,0.1018,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_73400.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(5329,3293,0,'LSQ12fxa','LSQ',358.600833333333,-30.1615833333333,NULL,NULL,'2012-11-17 03:03:59',56248.1277700001,20.623,0.1613,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxa/LSQ12fxa_history.html','agn?',NULL,0.1428,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxa/LSQ12fxa_snap_73354.gif',50044826551,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781950414,12217975,NULL,NULL,NULL,NULL),(5330,3295,0,'LSQ12fwx','LSQ',359.541458333333,-29.7360555555556,NULL,NULL,'2012-11-17 01:14:07',56248.0514699998,19.4568,0.0523,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_history.html','sne - nice',NULL,0.0972,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_snap_73423.gif',50036319036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781817484,12215898,NULL,NULL,NULL,NULL),(5331,3295,0,'LSQ12fwx','LSQ',359.541541666667,-29.7361111111111,NULL,NULL,'2012-11-17 03:14:06',56248.1348000001,19.5313,0.0584,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_history.html','sne - nice',NULL,0.0972,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwx/LSQ12fwx_snap_73424.gif',50036319036,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,781817484,12215898,NULL,NULL,NULL,NULL),(5332,3481,0,'LSQ12fzc','LSQ',43.0445833333333,-35.9738055555556,NULL,NULL,'2012-11-17 02:22:26',56248.0989199998,19.0273,0.1741,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_73370.gif',38652782969,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(5333,3481,0,'LSQ12fzc','LSQ',43.0446666666667,-35.97375,NULL,NULL,'2012-11-17 04:22:11',56248.1820800002,18.8235,0.1108,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_73371.gif',38652782971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(5334,3497,0,'LSQ12gay','LSQ',22.68625,-24.6001111111111,NULL,NULL,'2012-11-17 02:10:30',56248.09063,19.6636,0.094,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_snap_73404.gif',34701767715,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,542215120,8472111,NULL,NULL,NULL,NULL),(5335,3520,0,'LSQ12gak','LSQ',21.5755,-23.3501666666667,NULL,NULL,'2012-11-17 02:12:10',56248.09179,19.6559,0.1232,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_snap_73373.gif',35177372187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549646440,8588225,NULL,NULL,NULL,NULL),(5336,3520,0,'LSQ12gak','LSQ',21.5754166666667,-23.3503888888889,NULL,NULL,'2012-11-17 04:11:53',56248.1749200001,20.3553,0.2102,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_snap_73374.gif',35177372187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549646440,8588225,NULL,NULL,NULL,NULL),(5337,3530,0,'LSQ12gad','LSQ',52.3020833333333,-30.6228611111111,NULL,NULL,'2012-11-17 05:04:45',56248.2116399999,19.2717,0.1157,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_73540.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(5338,3548,0,'LSQ12fzu','LSQ',74.8828333333333,-38.4092222222222,NULL,NULL,'2012-11-17 02:56:19',56248.1224500001,19.475,0.1077,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_73394.gif',37599816278,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(5339,3551,0,'LSQ12fzr','LSQ',49.1794166666667,-30.2704722222222,NULL,NULL,'2012-11-17 02:29:12',56248.1036200002,19.3501,0.1314,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_73529.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(5340,3551,0,'LSQ12fzr','LSQ',49.1794166666667,-30.2705277777778,NULL,NULL,'2012-11-17 04:28:58',56248.1867900002,19.2647,0.1267,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-11-17 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_73530.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(5341,3797,0,'LSQ12gdj','LSQ',358.680458333333,-25.6761666666667,NULL,NULL,'2012-11-17 03:03:59',56248.1277700001,15.0347,0.0064,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdj/LSQ12gdj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdj/LSQ12gdj_snap_73431.gif',50005825249,NULL,NULL,NULL,'2012-11-05 01:14:52',56236.052,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,781341019,12208453,NULL,NULL,NULL,NULL),(5342,3809,0,'LSQ12gdd','LSQ',53.6040416666667,-26.7740277777778,NULL,NULL,'2012-11-17 00:58:09',56248.0403900002,20.9381,0.1978,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_73520.gif',38579529472,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805148,9418830,NULL,NULL,NULL,NULL),(5343,3818,0,'LSQ12gdc','LSQ',74.15275,-31.6034166666667,NULL,NULL,'2012-11-17 05:22:05',56248.2236700002,17.6489,0.0575,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_73432.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(5344,3821,0,'LSQ12gcw','LSQ',68.318875,-38.1013333333333,NULL,NULL,'2012-11-17 02:52:56',56248.1200999999,19.9968,0.098,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_73475.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(5345,3821,0,'LSQ12gcw','LSQ',68.3184166666667,-38.1013055555556,NULL,NULL,'2012-11-17 04:52:35',56248.2031899998,19.7001,0.085,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_73476.gif',37823536133,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(5346,4075,0,'LSQ12ghf','LSQ',1.15595833333333,-35.5166666666667,NULL,NULL,'2012-11-17 01:09:02',56248.04794,20.0953,0.1515,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_history.html','very bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_snap_73512.gif',34663125229,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,541611331,8462677,NULL,NULL,NULL,NULL),(5347,4075,0,'LSQ12ghf','LSQ',1.155875,-35.5167222222222,NULL,NULL,'2012-11-17 03:09:01',56248.1312699998,19.9421,0.1088,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_history.html','very bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_snap_73513.gif',34663125229,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,541611331,8462677,NULL,NULL,NULL,NULL),(5348,4056,0,'LSQ12ghe','LSQ',68.5490416666667,-23.0559166666667,NULL,NULL,'2012-11-17 05:59:47',56248.2498499998,19.3283,0.0666,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_73471.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(5349,4061,0,'LSQ12ggx','LSQ',47.8960416666667,-22.3203055555556,NULL,NULL,'2012-11-17 02:34:18',56248.1071600001,19.5406,0.1037,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_73551.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(5350,4061,0,'LSQ12ggx','LSQ',47.8960833333333,-22.3203611111111,NULL,NULL,'2012-11-17 04:34:02',56248.19031,19.7036,0.1214,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_73552.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(5351,4067,0,'LSQ12ggq','LSQ',69.4289583333333,-35.8658333333333,NULL,NULL,'2012-11-17 02:52:56',56248.1200999999,19.6625,0.0623,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_73518.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(5352,4067,0,'LSQ12ggq','LSQ',69.4289583333333,-35.8658888888889,NULL,NULL,'2012-11-17 04:52:35',56248.2031899998,19.9188,0.0773,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_73519.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(5353,4082,0,'LSQ12ggo','LSQ',60.4302083333333,-34.9308333333333,NULL,NULL,'2012-11-17 02:47:53',56248.1165900002,20.8789,0.1774,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_snap_73516.gif',37676606780,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588696980,9198390,NULL,NULL,NULL,NULL),(5354,4082,0,'LSQ12ggo','LSQ',60.43025,-34.9309166666667,NULL,NULL,'2012-11-17 04:47:33',56248.1996900002,20.3509,0.1405,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_snap_73517.gif',37676606780,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588696980,9198390,NULL,NULL,NULL,NULL),(5355,4118,0,'LSQ12ghd','LSQ',71.8650833333333,-21.3295277777778,NULL,NULL,'2012-11-17 05:59:47',56248.2498499998,20.9531,0.199,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_73505.gif',37342671080,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479235,9116863,NULL,NULL,NULL,NULL),(5356,4120,0,'LSQ12ghc','LSQ',66.2230833333333,-21.2026944444444,NULL,NULL,'2012-11-17 05:56:24',56248.2475000001,17.3158,0.0256,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_73470.gif',37325531170,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(5357,4140,0,'LSQ12ggw','LSQ',49.5532916666667,-21.4533611111111,NULL,NULL,'2012-11-17 04:32:21',56248.1891399999,20.9924,0.1655,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggw/LSQ12ggw_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggw/LSQ12ggw_snap_73461.gif',38028965827,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,594202591,9284415,NULL,NULL,NULL,NULL),(5358,4156,0,'LSQ12ggn','LSQ',58.0248333333333,-39.0651666666667,NULL,NULL,'2012-11-17 02:44:28',56248.1142199999,17.0023,0.0287,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_73459.gif',37665320682,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(5359,4156,0,'LSQ12ggn','LSQ',58.024875,-39.0651666666667,NULL,NULL,'2012-11-17 04:44:10',56248.19734,16.9585,0.019,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_73460.gif',37665320682,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(5360,4317,0,'LSQ12gkk','LSQ',76.8690833333333,-23.8546388888889,NULL,NULL,'2012-11-17 06:06:33',56248.2545500002,20.03,0.0854,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_73387.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(5361,4320,0,'LSQ12gki','LSQ',17.602375,-22.4757777777778,NULL,NULL,'2012-11-17 01:58:35',56248.0823499998,19.0502,0.0797,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_snap_73441.gif',35214805816,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,550231340,8597364,NULL,NULL,NULL,NULL),(5362,4320,0,'LSQ12gki','LSQ',17.602375,-22.4758055555556,NULL,NULL,'2012-11-17 03:58:20',56248.1655100002,19.0669,0.0938,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_snap_73442.gif',35214805816,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,550231340,8597364,NULL,NULL,NULL,NULL),(5363,4324,0,'LSQ12gke','LSQ',0.167208333333333,-27.1032777777778,NULL,NULL,'2012-11-17 01:05:39',56248.0455999998,19.7198,0.1554,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_history.html','sne?',NULL,0.069557,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_snap_73395.gif',34767217141,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,543237767,8488090,NULL,NULL,NULL,NULL),(5364,4324,0,'LSQ12gke','LSQ',0.167291666666667,-27.10325,NULL,NULL,'2012-11-17 03:05:40',56248.1289400002,19.6011,0.137,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_history.html','sne?',NULL,0.069557,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gke/LSQ12gke_snap_73396.gif',34767217141,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,543237767,8488090,NULL,NULL,NULL,NULL),(5365,4331,0,'LSQ12gka','LSQ',16.323375,-26.7014444444444,NULL,NULL,'2012-11-17 02:00:16',56248.0835199999,20.008,0.1061,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_snap_73362.gif',34725499594,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542585931,8477905,NULL,NULL,NULL,NULL),(5366,4331,0,'LSQ12gka','LSQ',16.3233333333333,-26.7014722222222,NULL,NULL,'2012-11-17 04:00:01',56248.1666799998,19.9678,0.0862,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_snap_73363.gif',34725499594,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542585931,8477905,NULL,NULL,NULL,NULL),(5367,4333,0,'LSQ12gjz','LSQ',7.02641666666667,-29.0970277777778,NULL,NULL,'2012-11-17 01:32:51',56248.0644899998,19.1062,0.0503,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjz/LSQ12gjz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjz/LSQ12gjz_snap_73452.gif',34888280957,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545129389,8517646,NULL,NULL,NULL,NULL),(5368,4343,0,'LSQ12gjt','LSQ',6.905,-30.5745,NULL,NULL,'2012-11-17 03:24:15',56248.1418499998,20.5929,0.1422,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjt/LSQ12gjt_history.html','sne?',NULL,0.114853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjt/LSQ12gjt_snap_73433.gif',34857031270,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,544641113,8510017,NULL,NULL,NULL,NULL),(5369,4362,0,'LSQ12gkx','LSQ',56.6780833333333,-26.35675,NULL,NULL,'2012-11-17 03:01:35',56248.1261,21.2011,0.1916,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_snap_73397.gif',38528720443,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602011256,9406425,NULL,NULL,NULL,NULL),(5370,5246,0,'LSQ12gln','LSQ',80.7474166666667,-33.4641388888889,NULL,NULL,'2012-11-17 05:27:09',56248.22719,19.258,0.0813,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_73548.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(5371,5249,0,'LSQ12glk','LSQ',19.5816666666667,-38.36025,NULL,NULL,'2012-11-17 02:08:43',56248.0893899999,20.322,0.1001,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_73457.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5372,5249,0,'LSQ12glk','LSQ',19.5815833333333,-38.3602777777778,NULL,NULL,'2012-11-17 04:08:26',56248.1725300001,20.4891,0.1078,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 12:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_73458.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5373,4333,0,'LSQ12gjz','LSQ',7.02616666666667,-29.0968611111111,NULL,NULL,'2012-11-17 03:32:47',56248.1477700002,19.6561,0.1038,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 13:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjz/LSQ12gjz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjz/LSQ12gjz_snap_73561.gif',34888280946,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545129389,8517646,NULL,NULL,NULL,NULL),(5374,5374,1,'LSQ12gly','LSQ',141.5765,-11.9567222222222,NULL,NULL,'2012-11-16 06:39:52',56247.2776899999,19.4431,0.1189,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 14:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gly/LSQ12gly_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gly/LSQ12gly_snap_73574.gif',42181379441,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,659084053,10298188,NULL,NULL,NULL,NULL),(5375,5374,0,'LSQ12gly','LSQ',141.5765,-11.9566666666667,NULL,NULL,'2012-11-16 07:46:37',56247.3240399999,19.0956,0.0976,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 14:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gly/LSQ12gly_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gly/LSQ12gly_snap_73575.gif',42181379441,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,659084053,10298188,NULL,NULL,NULL,NULL),(5376,5376,1,'LSQ12glw','LSQ',143.033416666667,-9.68130555555556,NULL,NULL,'2012-11-16 06:39:52',56247.2776899999,19.3505,0.1476,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 14:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glw/LSQ12glw_history.html','sne?',NULL,0.054681,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glw/LSQ12glw_snap_73570.gif',41090785025,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642043516,10031929,NULL,NULL,NULL,NULL),(5377,5376,0,'LSQ12glw','LSQ',143.033208333333,-9.68127777777778,NULL,NULL,'2012-11-16 07:46:37',56247.3240399999,19.1395,0.0986,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 14:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glw/LSQ12glw_history.html','sne?',NULL,0.054681,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glw/LSQ12glw_snap_73571.gif',41090785038,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642043516,10031929,NULL,NULL,NULL,NULL),(5378,5249,0,'LSQ12glk','LSQ',19.5815833333333,-38.3602777777778,NULL,NULL,'2012-11-17 02:07:02',56248.0882199998,20.3697,0.1151,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 16:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_73616.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5379,5249,0,'LSQ12glk','LSQ',19.5816666666667,-38.3603055555556,NULL,NULL,'2012-11-17 04:06:46',56248.1713700001,20.3674,0.1223,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 16:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_73617.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5380,5249,0,'LSQ12glk','LSQ',19.5818333333333,-38.3603888888889,NULL,NULL,'2012-11-13 02:22:52',56244.0992200002,20.6276,0.1711,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 17:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_73658.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5381,5249,0,'LSQ12glk','LSQ',19.5816666666667,-38.3602777777778,NULL,NULL,'2012-11-13 04:39:17',56244.1939500002,20.818,0.156,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 17:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_73659.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5382,5249,0,'LSQ12glk','LSQ',19.5816666666667,-38.3603055555556,NULL,NULL,'2012-11-15 04:39:01',56246.1937699998,20.1998,0.1019,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 17:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_73660.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5383,5383,1,'LSQ12glt','LSQ',50.0834583333333,-15.23775,NULL,NULL,'2012-11-16 02:43:10',56247.11332,18.8201,0.0797,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 22:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glt/LSQ12glt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glt/LSQ12glt_snap_73564.gif',38081917180,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,595029955,9297343,NULL,NULL,NULL,NULL),(5384,5383,0,'LSQ12glt','LSQ',50.0834166666667,-15.23775,NULL,NULL,'2012-11-16 04:56:59',56247.2062499998,18.855,0.0782,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-17 22:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glt/LSQ12glt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glt/LSQ12glt_snap_73565.gif',38081917180,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,595029955,9297343,NULL,NULL,NULL,NULL),(5385,5385,1,'LSQ12gmu','LSQ',13.3710416666667,-33.52375,NULL,NULL,'2012-11-17 01:49:54',56248.0763300001,19.9596,0.1514,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 04:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmu/LSQ12gmu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmu/LSQ12gmu_snap_73675.gif',34864584044,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,544759125,8511861,NULL,NULL,NULL,NULL),(5386,5385,0,'LSQ12gmu','LSQ',13.371125,-33.5238611111111,NULL,NULL,'2012-11-17 03:49:45',56248.1595600001,19.5962,0.1168,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 04:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmu/LSQ12gmu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmu/LSQ12gmu_snap_73676.gif',34864584044,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,544759125,8511861,NULL,NULL,NULL,NULL),(5387,5387,1,'LSQ12gmi','LSQ',7.83645833333333,-38.5855555555556,NULL,NULL,'2012-10-26 03:53:08',56226.1619000002,20.4794,0.1958,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 04:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_history.html','Unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_snap_73632.gif',34688565688,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,542008838,8468888,NULL,NULL,NULL,NULL),(5388,5387,0,'LSQ12gmi','LSQ',7.836375,-38.5853055555556,NULL,NULL,'2012-11-01 01:34:12',56232.0654199999,19.8022,0.1554,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 04:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_history.html','Unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_snap_73633.gif',34688565688,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,542008838,8468888,NULL,NULL,NULL,NULL),(5389,5387,0,'LSQ12gmi','LSQ',7.83633333333333,-38.5854166666667,NULL,NULL,'2012-11-01 03:35:58',56232.1499800002,19.9679,0.1817,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 04:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_history.html','Unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_snap_73634.gif',34688565688,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,542008838,8468888,NULL,NULL,NULL,NULL),(5390,5387,0,'LSQ12gmi','LSQ',7.83641666666667,-38.5854166666667,NULL,NULL,'2012-11-03 01:35:04',56234.0660299999,19.7074,0.1081,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 04:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_history.html','Unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_snap_73635.gif',34688565688,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,542008838,8468888,NULL,NULL,NULL,NULL),(5391,5387,0,'LSQ12gmi','LSQ',7.836375,-38.5853611111111,NULL,NULL,'2012-11-03 03:37:02',56234.1507199998,19.4343,0.1191,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 04:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_history.html','Unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_snap_73636.gif',34688565688,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,542008838,8468888,NULL,NULL,NULL,NULL),(5392,5387,0,'LSQ12gmi','LSQ',7.836375,-38.5853055555556,NULL,NULL,'2012-11-05 01:56:17',56236.0807599998,19.503,0.1123,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 04:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_history.html','Unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_snap_73637.gif',34688565688,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,542008838,8468888,NULL,NULL,NULL,NULL),(5393,5387,0,'LSQ12gmi','LSQ',7.83641666666667,-38.5853611111111,NULL,NULL,'2012-11-05 04:13:16',56236.17588,19.5105,0.0937,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 04:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_history.html','Unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_snap_73638.gif',34688565688,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,542008838,8468888,NULL,NULL,NULL,NULL),(5394,5387,0,'LSQ12gmi','LSQ',7.83633333333333,-38.5853055555556,NULL,NULL,'2012-11-13 03:55:29',56244.1635400001,19.7031,0.0879,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 04:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_history.html','Unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_snap_73639.gif',34688565688,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,542008838,8468888,NULL,NULL,NULL,NULL),(5395,5387,0,'LSQ12gmi','LSQ',7.83641666666667,-38.5853611111111,NULL,NULL,'2012-11-17 01:39:38',56248.0691900002,19.5337,0.0906,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 04:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_history.html','Unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_snap_73610.gif',34688565688,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,542008838,8468888,NULL,NULL,NULL,NULL),(5396,5387,0,'LSQ12gmi','LSQ',7.83629166666667,-38.5853888888889,NULL,NULL,'2012-11-17 03:39:31',56248.1524499999,19.5737,0.0873,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 04:46:10','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_history.html','Unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_snap_73611.gif',34688565688,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,542008838,8468888,NULL,NULL,NULL,NULL),(5397,5397,1,'LSQ12gne','LSQ',14.5204583333333,-25.5831388888889,NULL,NULL,'2012-10-25 03:00:25',56225.1253,19.6839,0.1523,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 05:46:11','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_snap_73755.gif',34713622310,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542400348,8475005,NULL,NULL,NULL,NULL),(5398,5397,0,'LSQ12gne','LSQ',14.5209166666667,-25.58325,NULL,NULL,'2012-11-01 03:39:22',56232.15234,19.4252,0.1185,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 05:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_snap_73756.gif',34713622310,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542400348,8475005,NULL,NULL,NULL,NULL),(5399,5397,0,'LSQ12gne','LSQ',14.5209166666667,-25.5832222222222,NULL,NULL,'2012-11-03 03:40:26',56234.1530800001,19.6272,0.118,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 05:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_snap_73757.gif',34713622310,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542400348,8475005,NULL,NULL,NULL,NULL),(5400,5397,0,'LSQ12gne','LSQ',14.520875,-25.5832222222222,NULL,NULL,'2012-11-05 04:21:06',56236.1813300001,19.8474,0.2037,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 05:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_snap_73758.gif',34713622310,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542400348,8475005,NULL,NULL,NULL,NULL),(5401,5397,0,'LSQ12gne','LSQ',14.52075,-25.5830833333333,NULL,NULL,'2012-11-09 04:11:32',56240.1746800002,20.0565,0.1258,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 05:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_snap_73759.gif',34713622310,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542400348,8475005,NULL,NULL,NULL,NULL),(5402,5397,0,'LSQ12gne','LSQ',14.5207083333333,-25.5833055555556,NULL,NULL,'2012-11-13 01:59:07',56244.0827199998,20.7097,0.169,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 05:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_snap_73760.gif',34713622310,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542400348,8475005,NULL,NULL,NULL,NULL),(5403,5397,0,'LSQ12gne','LSQ',14.5209583333333,-25.5833888888889,NULL,NULL,'2012-11-13 03:58:54',56244.16591,19.9545,0.1068,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 05:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_snap_73761.gif',34713622310,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542400348,8475005,NULL,NULL,NULL,NULL),(5404,5397,0,'LSQ12gne','LSQ',14.5205,-25.5831666666667,NULL,NULL,'2012-11-17 01:43:07',56248.0716200001,19.5423,0.0882,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 05:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_snap_73695.gif',34713622310,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542400348,8475005,NULL,NULL,NULL,NULL),(5405,5397,0,'LSQ12gne','LSQ',14.5207083333333,-25.5831666666667,NULL,NULL,'2012-11-17 03:43:00',56248.1548700002,19.4928,0.079,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 05:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_snap_73696.gif',34713622310,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542400348,8475005,NULL,NULL,NULL,NULL),(5406,2900,0,'LSQ12fqb','LSQ',70.8875416666667,-11.9016111111111,NULL,NULL,'2012-11-18 07:48:00',56249.3250099998,19.2537,0.1001,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-11-18 12:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fqb/LSQ12fqb_snap_73853.gif',37539441792,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586553778,9164902,NULL,NULL,NULL,NULL),(5407,2915,0,'LSQ12fpv','LSQ',56.9054583333333,-8.73183333333333,NULL,NULL,'2012-11-18 07:08:55',56249.2978699999,19.6243,0.1427,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-11-18 12:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_history.html','sn?',NULL,0.034397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fpv/LSQ12fpv_snap_73857.gif',37021133916,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578455217,9038362,NULL,NULL,NULL,NULL),(5408,3374,0,'LSQ12fyg','LSQ',68.9830416666667,-4.04505555555556,NULL,NULL,'2012-11-18 05:57:33',56249.2483100002,20.0592,0.1215,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-11-18 12:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyg/LSQ12fyg_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyg/LSQ12fyg_snap_73778.gif',37463478352,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585366849,9146357,NULL,NULL,NULL,NULL),(5409,3378,0,'LSQ12fyf','LSQ',63.8235416666667,-7.06947222222222,NULL,NULL,'2012-11-18 05:55:51',56249.24712,19.6206,0.1112,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-11-18 12:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_snap_73774.gif',36956960238,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577452503,9022695,NULL,NULL,NULL,NULL),(5410,3378,0,'LSQ12fyf','LSQ',63.8234166666667,-7.06952777777778,NULL,NULL,'2012-11-18 07:17:22',56249.3037299998,19.462,0.1145,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-11-18 12:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyf/LSQ12fyf_snap_73775.gif',36956960238,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577452503,9022695,NULL,NULL,NULL,NULL),(5411,3380,0,'LSQ12fye','LSQ',62.718625,-4.923,NULL,NULL,'2012-11-18 05:52:28',56249.2447799998,18.9088,0.137,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-11-18 12:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_73771.gif',36961736785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(5412,3380,0,'LSQ12fye','LSQ',62.7185416666667,-4.92313888888889,NULL,NULL,'2012-11-18 07:15:41',56249.3025600002,19.0079,0.1391,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-11-18 12:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fye/LSQ12fye_snap_73772.gif',36961736785,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577527137,9023861,NULL,NULL,NULL,NULL),(5413,3386,0,'LSQ12fyb','LSQ',53.6892916666667,-3.73858333333333,NULL,NULL,'2012-11-18 04:14:43',56249.1768899998,19.43,0.0941,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-11-18 12:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_73773.gif',36820699952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(5414,3740,0,'LSQ12gcn','LSQ',67.4805833333333,-12.0791111111111,NULL,NULL,'2012-11-18 05:10:56',56249.2159299999,18.9885,0.1646,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_snap_73822.gif',37533040335,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586453755,9163339,NULL,NULL,NULL,NULL),(5415,3740,0,'LSQ12gcn','LSQ',67.481,-12.0793055555556,NULL,NULL,'2012-11-18 06:54:59',56249.2881900002,19.208,0.1063,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_history.html','variable ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcn/LSQ12gcn_snap_73823.gif',37533040332,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586453755,9163339,NULL,NULL,NULL,NULL),(5416,3746,0,'LSQ12gcm','LSQ',59.17275,-12.5713055555556,NULL,NULL,'2012-11-18 05:04:11',56249.2112400001,21.0536,0.208,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcm/LSQ12gcm_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcm/LSQ12gcm_snap_73825.gif',36885694052,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,576338969,9005296,NULL,NULL,NULL,NULL),(5417,3764,0,'LSQ12gcd','LSQ',59.58375,-18.6201388888889,NULL,NULL,'2012-11-18 04:43:43',56249.1970299999,18.8577,0.0867,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_snap_73769.gif',36851844463,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575810069,8997032,NULL,NULL,NULL,NULL),(5418,3764,0,'LSQ12gcd','LSQ',59.5835,-18.6201666666667,NULL,NULL,'2012-11-18 06:43:00',56249.2798700002,19.2832,0.1375,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_snap_73770.gif',36851844463,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575810069,8997032,NULL,NULL,NULL,NULL),(5419,3770,0,'LSQ12gbz','LSQ',66.5849166666667,-10.1035277777778,NULL,NULL,'2012-11-18 05:45:43',56249.24009,19.1734,0.077,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_history.html','sne - nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_snap_73790.gif',37466637666,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585416213,9147128,NULL,NULL,NULL,NULL),(5420,3770,0,'LSQ12gbz','LSQ',66.584875,-10.1035555555556,NULL,NULL,'2012-11-18 07:12:18',56249.30021,19.0461,0.0706,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_history.html','sne - nice!',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbz/LSQ12gbz_snap_73791.gif',37466637666,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585416213,9147128,NULL,NULL,NULL,NULL),(5421,3851,0,'LSQ12ges','LSQ',74.98625,-19.4645277777778,NULL,NULL,'2012-11-18 08:01:46',56249.3345699999,20.6543,0.1495,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_snap_73838.gif',37563466779,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586929168,9170768,NULL,NULL,NULL,NULL),(5422,4159,0,'LSQ12gjg','LSQ',69.8503333333333,-5.53480555555556,NULL,NULL,'2012-11-18 05:59:15',56249.2494899998,14.6776,0.0034,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_snap_73862.gif',37457458286,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,585272785,9144887,NULL,NULL,NULL,NULL),(5423,4159,0,'LSQ12gjg','LSQ',69.850375,-5.53480555555556,NULL,NULL,'2012-11-18 07:19:03',56249.3048999999,14.8666,0.0029,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_snap_73863.gif',37457458286,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,585272785,9144887,NULL,NULL,NULL,NULL),(5424,4165,0,'LSQ12gjc','LSQ',52.6709166666667,-6.37288888888889,NULL,NULL,'2012-11-18 04:14:43',56249.1768899998,19.2625,0.1189,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_73866.gif',36797933958,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(5425,4165,0,'LSQ12gjc','LSQ',52.670875,-6.37283333333333,NULL,NULL,'2012-11-18 06:14:50',56249.2603099998,19.4592,0.1415,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_73867.gif',36797933958,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(5426,4171,0,'LSQ12giz','LSQ',63.455375,-10.0441666666667,NULL,NULL,'2012-11-18 05:42:20',56249.2377399998,20.2308,0.1901,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giz/LSQ12giz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giz/LSQ12giz_snap_73868.gif',36979075816,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577798059,9028094,NULL,NULL,NULL,NULL),(5427,4173,0,'LSQ12giy','LSQ',60.1034583333333,-10.5716944444444,NULL,NULL,'2012-11-18 05:40:38',56249.2365600001,20.3874,0.1199,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giy/LSQ12giy_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giy/LSQ12giy_snap_73859.gif',36987791452,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577934241,9030222,NULL,NULL,NULL,NULL),(5428,5383,0,'LSQ12glt','LSQ',50.0836666666667,-15.2377222222222,NULL,NULL,'2012-11-18 04:25:00',56249.1840300001,18.8263,0.0719,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glt/LSQ12glt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glt/LSQ12glt_snap_73876.gif',38081917183,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,595029955,9297343,NULL,NULL,NULL,NULL),(5429,5383,0,'LSQ12glt','LSQ',50.083625,-15.2378333333333,NULL,NULL,'2012-11-18 06:25:18',56249.2675800002,18.7796,0.0613,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 12:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glt/LSQ12glt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glt/LSQ12glt_snap_73877.gif',38081917180,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,595029955,9297343,NULL,NULL,NULL,NULL),(5430,5430,1,'LSQ12gnk','LSQ',37.0960833333333,-6.87738888888889,NULL,NULL,'2012-11-16 01:05:05',56247.0452000001,20.0129,0.0841,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 18:46:12','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnk/LSQ12gnk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnk/LSQ12gnk_snap_73943.gif',34941243523,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,545956930,8530577,NULL,NULL,NULL,NULL),(5431,5430,0,'LSQ12gnk','LSQ',37.0960833333333,-6.87744444444445,NULL,NULL,'2012-11-18 03:25:05',56249.14243,20.179,0.0917,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 18:46:12','2012-11-18 18:46:12','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnk/LSQ12gnk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnk/LSQ12gnk_snap_73939.gif',34941243523,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,545956930,8530577,NULL,NULL,NULL,NULL),(5432,5430,0,'LSQ12gnk','LSQ',37.0960416666667,-6.87741666666667,NULL,NULL,'2012-11-18 05:20:03',56249.2222600002,20.1817,0.0898,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 18:46:12','2012-11-18 18:46:12','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnk/LSQ12gnk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnk/LSQ12gnk_snap_73940.gif',34941243523,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,545956930,8530577,NULL,NULL,NULL,NULL),(5433,5433,1,'LSQ12gni','LSQ',35.8250833333333,-5.39705555555556,NULL,NULL,'2012-11-18 03:21:24',56249.1398700001,18.2758,0.0494,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 18:46:12','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gni/LSQ12gni_history.html','Old hostless sn?',NULL,0.8281,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gni/LSQ12gni_snap_73935.gif',34947828215,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,546059815,8532184,NULL,NULL,NULL,NULL),(5434,5433,0,'LSQ12gni','LSQ',35.8250833333333,-5.39705555555556,NULL,NULL,'2012-11-18 05:16:21',56249.2196900002,18.9785,0.0757,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-18 18:46:12','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gni/LSQ12gni_history.html','Old hostless sn?',NULL,0.8281,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gni/LSQ12gni_snap_73936.gif',34947828215,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,546059815,8532184,NULL,NULL,NULL,NULL),(5436,2974,0,'LSQ12frx','LSQ',12.98825,-23.7101944444444,NULL,NULL,'2012-11-19 01:38:03',56250.0680999998,19.4722,0.0664,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_snap_74008.gif',35316090512,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(5437,2974,0,'LSQ12frx','LSQ',12.9881666666667,-23.7101944444444,NULL,NULL,'2012-11-19 03:38:04',56250.1514400002,19.5097,0.0908,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12frx/LSQ12frx_snap_74009.gif',35316090512,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,551813914,8622092,NULL,NULL,NULL,NULL),(5438,2985,0,'LSQ12fsh','LSQ',12.7767083333333,-39.1600555555556,NULL,NULL,'2012-11-19 01:46:30',56250.0739600002,19.1545,0.1046,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_74159.gif',38166915083,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(5439,2985,0,'LSQ12fsh','LSQ',12.7767083333333,-39.1600277777778,NULL,NULL,'2012-11-19 03:46:33',56250.1573299998,19.0658,0.0603,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_74160.gif',38166915082,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(5440,2987,0,'LSQ12fsj','LSQ',73.72925,-36.3250277777778,NULL,NULL,'2012-11-19 02:58:10',56250.1237300001,16.1992,0.0048,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_74161.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(5441,2987,0,'LSQ12fsj','LSQ',73.7292916666667,-36.3250277777778,NULL,NULL,'2012-11-19 04:57:56',56250.2069000001,16.1979,0.0043,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_74162.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(5442,2991,0,'LSQ12fsi','LSQ',1.50479166666667,-35.1925555555556,NULL,NULL,'2012-11-19 01:04:05',56250.0445099999,19.1895,0.066,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_history.html','Old',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsi/LSQ12fsi_snap_74082.gif',34665129379,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,541642646,8463166,NULL,NULL,NULL,NULL),(5443,2993,0,'LSQ12fss','LSQ',18.7158333333333,-30.0939722222222,NULL,NULL,'2012-11-19 01:58:20',56250.0821799999,19.8597,0.1106,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_74124.gif',34734808837,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(5444,2993,0,'LSQ12fss','LSQ',18.715875,-30.0939166666667,NULL,NULL,'2012-11-19 03:58:26',56250.1655899999,19.8564,0.0884,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_74125.gif',34734808839,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(5445,2999,0,'LSQ12fsn','LSQ',10.606375,-34.09725,NULL,NULL,'2012-11-19 01:31:11',56250.0633299998,14.7949,0.0067,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_history.html','Unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_snap_74066.gif',34872861140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544888455,8513882,NULL,NULL,NULL,NULL),(5446,2999,0,'LSQ12fsn','LSQ',10.6064166666667,-34.0972777777778,NULL,NULL,'2012-11-19 03:31:14',56250.1466899998,14.9062,0.0059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_history.html','Unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_snap_74067.gif',34872861140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544888455,8513882,NULL,NULL,NULL,NULL),(5447,3001,0,'LSQ12fth','LSQ',47.82275,-25.1096388888889,NULL,NULL,'2012-11-19 02:25:48',56250.1012599999,17.9318,0.0334,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_74041.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(5448,3001,0,'LSQ12fth','LSQ',47.82275,-25.1096666666667,NULL,NULL,'2012-11-19 04:25:45',56250.1845499999,18.0259,0.0272,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_74042.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(5449,3001,0,'LSQ12fth','LSQ',47.8225833333333,-25.1097222222222,NULL,NULL,'2012-11-19 04:27:27',56250.18573,18.3356,0.0325,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_74043.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(5450,3009,0,'LSQ12ftd','LSQ',64.2445416666667,-24.1446944444444,NULL,NULL,'2012-11-19 05:47:23',56250.24125,20.2627,0.1817,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_74047.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(5451,3009,0,'LSQ12ftd','LSQ',64.2445833333333,-24.14475,NULL,NULL,'2012-11-19 05:49:05',56250.24242,20.3481,0.1264,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_74049.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(5452,3009,0,'LSQ12ftd','LSQ',64.2447083333333,-24.1447777777778,NULL,NULL,'2012-11-19 07:24:43',56250.3088400001,19.1897,0.11,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_74050.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(5453,3009,0,'LSQ12ftd','LSQ',64.2446666666667,-24.14475,NULL,NULL,'2012-11-19 07:26:25',56250.3100200002,20.5869,0.2121,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_74048.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(5454,3013,0,'LSQ12ftc','LSQ',64.8030833333333,-24.3553611111111,NULL,NULL,'2012-11-19 05:47:23',56250.24125,20.323,0.1256,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_74152.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(5455,3013,0,'LSQ12ftc','LSQ',64.8028333333333,-24.3551944444444,NULL,NULL,'2012-11-19 07:24:43',56250.3088400001,19.988,0.1259,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_74154.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(5456,3013,0,'LSQ12ftc','LSQ',64.8031666666667,-24.3553333333333,NULL,NULL,'2012-11-19 07:26:25',56250.3100200002,20.393,0.139,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_74153.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(5457,3017,0,'LSQ12ftb','LSQ',65.4220416666667,-23.70525,NULL,NULL,'2012-11-19 05:49:05',56250.24242,18.6989,0.0519,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_74127.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(5458,3017,0,'LSQ12ftb','LSQ',65.422,-23.7052222222222,NULL,NULL,'2012-11-19 07:24:43',56250.3088400001,18.7261,0.0541,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_74128.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(5459,3017,0,'LSQ12ftb','LSQ',65.4215,-23.7053333333333,NULL,NULL,'2012-11-19 07:26:25',56250.3100200002,18.0492,0.0728,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_74126.gif',37314276031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(5460,3106,0,'LSQ12fsw','LSQ',74.1659583333333,-30.1306944444444,NULL,NULL,'2012-11-19 05:33:43',56250.2317499998,19.3954,0.1296,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_snap_74068.gif',37203066249,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,581297910,9082779,NULL,NULL,NULL,NULL),(5461,3112,0,'LSQ12fvu','LSQ',53.5187083333333,-21.8744166666667,NULL,NULL,'2012-11-19 02:41:09',56250.11191,19.0672,0.0634,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_74150.gif',38040994984,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(5462,3112,0,'LSQ12fvu','LSQ',53.5190416666667,-21.8745,NULL,NULL,'2012-11-19 04:40:56',56250.1951000001,18.8611,0.1333,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_74151.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(5463,3114,0,'LSQ12fvq','LSQ',19.15075,-31.4520555555556,NULL,NULL,'2012-11-19 01:56:39',56250.0810099998,18.5734,0.0354,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_74104.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(5464,3114,0,'LSQ12fvq','LSQ',19.150625,-31.4520833333333,NULL,NULL,'2012-11-19 01:58:20',56250.0821799999,18.47,0.035,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_74102.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(5465,3114,0,'LSQ12fvq','LSQ',19.1507916666667,-31.4520555555556,NULL,NULL,'2012-11-19 03:56:45',56250.1644100002,18.7234,0.0294,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_74105.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(5466,3114,0,'LSQ12fvq','LSQ',19.1506666666667,-31.4520833333333,NULL,NULL,'2012-11-19 03:58:26',56250.1655899999,18.6195,0.0276,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_74103.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(5467,3118,0,'LSQ12fvp','LSQ',10.7101666666667,-34.1603611111111,NULL,NULL,'2012-11-19 01:31:11',56250.0633299998,16.9423,0.0312,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_73991.gif',34872963970,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(5468,3118,0,'LSQ12fvp','LSQ',10.7100833333333,-34.1602777777778,NULL,NULL,'2012-11-19 03:31:14',56250.1466899998,16.6224,0.025,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_73992.gif',34872963970,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(5469,3122,0,'LSQ12fvn','LSQ',16.391875,-35.49075,NULL,NULL,'2012-11-19 01:48:12',56250.0751399999,20.1633,0.085,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_74112.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(5470,3122,0,'LSQ12fvn','LSQ',16.391875,-35.4907222222222,NULL,NULL,'2012-11-19 03:48:14',56250.1584999999,20.0147,0.0657,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_74113.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(5471,3125,0,'LSQ12fvl','LSQ',75.2085416666667,-38.6531388888889,NULL,NULL,'2012-11-19 02:58:10',56250.1237300001,18.5491,0.0605,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_74139.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(5472,3125,0,'LSQ12fvl','LSQ',75.2085416666667,-38.6531944444444,NULL,NULL,'2012-11-19 04:57:56',56250.2069000001,18.8267,0.075,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_74140.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(5473,3222,0,'LSQ12fvm','LSQ',47.95075,-38.8036666666667,NULL,NULL,'2012-11-19 02:32:35',56250.1059699999,20.2218,0.2002,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_73976.gif',38600095449,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126491,9423851,NULL,NULL,NULL,NULL),(5474,3237,0,'LSQ12fwt','LSQ',54.0464166666667,-37.426,NULL,NULL,'2012-11-19 02:44:38',56250.1143299998,20.2748,0.2012,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_74167.gif',38589273853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(5475,3237,0,'LSQ12fwt','LSQ',54.0465833333333,-37.4260277777778,NULL,NULL,'2012-11-19 04:44:21',56250.19747,20.9342,0.1766,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwt/LSQ12fwt_snap_74168.gif',38589273853,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602957403,9421209,NULL,NULL,NULL,NULL),(5478,3245,0,'LSQ12fwz','LSQ',21.2805,-26.1291666666667,NULL,NULL,'2012-11-19 04:08:40',56250.1726899999,18.9936,0.0583,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_73999.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(5479,3249,0,'LSQ12fww','LSQ',62.5344583333333,-34.1650555555556,NULL,NULL,'2012-11-19 05:06:32',56250.21288,18.8652,0.0612,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_73972.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(5480,3249,0,'LSQ12fww','LSQ',62.534375,-34.1650277777778,NULL,NULL,'2012-11-19 07:46:54',56250.32424,18.8544,0.0466,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_73973.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(5481,3287,0,'LSQ12fxc','LSQ',47.8157083333333,-22.45425,NULL,NULL,'2012-11-19 02:25:48',56250.1012599999,18.8594,0.0876,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_74000.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(5482,3287,0,'LSQ12fxc','LSQ',47.8158333333333,-22.4541111111111,NULL,NULL,'2012-11-19 04:25:45',56250.1845499999,19.9783,0.1396,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_74001.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(5483,3481,0,'LSQ12fzc','LSQ',43.044625,-35.9738055555556,NULL,NULL,'2012-11-19 02:15:32',56250.0941300001,19.486,0.1939,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_73966.gif',38652782971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(5484,3481,0,'LSQ12fzc','LSQ',43.0445833333333,-35.9737777777778,NULL,NULL,'2012-11-19 04:15:34',56250.1774800001,19.6726,0.1873,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_73967.gif',38652782969,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(5485,3497,0,'LSQ12gay','LSQ',22.6854583333333,-24.6005277777778,NULL,NULL,'2012-11-19 02:03:31',56250.0857799998,20.1182,0.177,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_snap_74004.gif',34701767715,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,542215120,8472111,NULL,NULL,NULL,NULL),(5486,3497,0,'LSQ12gay','LSQ',22.6860833333333,-24.5998333333333,NULL,NULL,'2012-11-19 04:03:35',56250.16916,19.8226,0.116,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_snap_74005.gif',34701767714,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,542215120,8472111,NULL,NULL,NULL,NULL),(5487,3514,0,'LSQ12gaq','LSQ',65.3839583333333,-25.3801111111111,NULL,NULL,'2012-11-19 05:49:05',56250.24242,19.2866,0.0751,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_snap_74017.gif',37182103829,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580970372,9077662,NULL,NULL,NULL,NULL),(5488,3520,0,'LSQ12gak','LSQ',21.5754583333333,-23.3502777777778,NULL,NULL,'2012-11-19 02:05:11',56250.0869399998,19.6043,0.1516,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_snap_73970.gif',35177372187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549646440,8588225,NULL,NULL,NULL,NULL),(5489,3520,0,'LSQ12gak','LSQ',21.5754583333333,-23.3503055555556,NULL,NULL,'2012-11-19 04:05:15',56250.17032,19.3784,0.1048,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_snap_73971.gif',35177372187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549646440,8588225,NULL,NULL,NULL,NULL),(5490,3530,0,'LSQ12gad','LSQ',52.3022083333333,-30.6229722222222,NULL,NULL,'2012-11-19 02:37:39',56250.1094900002,18.6631,0.0698,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_74155.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(5491,3530,0,'LSQ12gad','LSQ',52.3019583333333,-30.6228611111111,NULL,NULL,'2012-11-19 04:37:33',56250.1927499999,18.6613,0.0956,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_74156.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(5492,3540,0,'LSQ12fzz','LSQ',81.49375,-34.4575,NULL,NULL,'2012-11-19 07:40:07',56250.31953,19.9316,0.1664,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_73998.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(5493,3548,0,'LSQ12fzu','LSQ',74.882875,-38.4091944444444,NULL,NULL,'2012-11-19 02:56:29',56250.12256,19.8196,0.1385,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_73995.gif',37599816278,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(5494,3548,0,'LSQ12fzu','LSQ',74.8830833333333,-38.4092222222222,NULL,NULL,'2012-11-19 04:56:14',56250.20572,19.5156,0.0978,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_73996.gif',37599816286,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(5495,3551,0,'LSQ12fzr','LSQ',49.1793333333333,-30.2704722222222,NULL,NULL,'2012-11-19 02:22:24',56250.09889,19.3707,0.1777,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_74147.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(5496,3551,0,'LSQ12fzr','LSQ',49.1793333333333,-30.2704722222222,NULL,NULL,'2012-11-19 04:22:21',56250.1821900001,19.6687,0.1268,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-11-19 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_74148.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(5497,3818,0,'LSQ12gdc','LSQ',74.1527916666667,-31.6034166666667,NULL,NULL,'2012-11-19 05:16:41',56250.2199200001,17.2052,0.0546,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_74038.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(5498,3818,0,'LSQ12gdc','LSQ',74.1528333333333,-31.6033888888889,NULL,NULL,'2012-11-19 06:57:29',56250.2899199999,17.2654,0.0513,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_74039.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(5499,3821,0,'LSQ12gcw','LSQ',68.3187916666667,-38.1013888888889,NULL,NULL,'2012-11-19 02:53:05',56250.1201999998,19.5706,0.0949,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_74070.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(5500,3821,0,'LSQ12gcw','LSQ',68.3187916666667,-38.1013888888889,NULL,NULL,'2012-11-19 04:52:51',56250.2033699998,19.6511,0.0827,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_74071.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(5501,4072,0,'LSQ12gif','LSQ',3.33895833333333,-23.9136666666667,NULL,NULL,'2012-11-19 03:10:54',56250.13258,20.3561,0.1544,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gif/LSQ12gif_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gif/LSQ12gif_snap_74123.gif',34772252121,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,543316439,8489319,NULL,NULL,NULL,NULL),(5502,4075,0,'LSQ12ghf','LSQ',1.15583333333333,-35.5167777777778,NULL,NULL,'2012-11-19 01:05:46',56250.04568,19.9815,0.1597,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_history.html','very bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_snap_74145.gif',34663125229,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,541611331,8462677,NULL,NULL,NULL,NULL),(5503,4075,0,'LSQ12ghf','LSQ',1.155875,-35.51675,NULL,NULL,'2012-11-19 03:05:50',56250.1290600002,19.8365,0.1242,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_history.html','very bright',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghf/LSQ12ghf_snap_74146.gif',34663125229,NULL,NULL,NULL,'2012-09-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,541611331,8462677,NULL,NULL,NULL,NULL),(5504,4056,0,'LSQ12ghe','LSQ',68.549,-23.0559722222222,NULL,NULL,'2012-11-19 05:50:47',56250.2436000002,19.3329,0.0632,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_74092.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(5505,4056,0,'LSQ12ghe','LSQ',68.549,-23.0559444444444,NULL,NULL,'2012-11-19 07:14:34',56250.3017899999,19.2956,0.0707,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_74093.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(5506,4061,0,'LSQ12ggx','LSQ',47.8960833333333,-22.3203333333333,NULL,NULL,'2012-11-19 02:27:29',56250.10243,19.4299,0.1228,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_74175.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(5507,4061,0,'LSQ12ggx','LSQ',47.896125,-22.3203611111111,NULL,NULL,'2012-11-19 04:27:27',56250.18573,19.4929,0.1339,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_74176.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(5508,4067,0,'LSQ12ggq','LSQ',69.4289166666667,-35.8658611111111,NULL,NULL,'2012-11-19 02:53:05',56250.1201999998,19.5069,0.0625,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_74133.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(5509,4067,0,'LSQ12ggq','LSQ',69.4289166666667,-35.8658333333333,NULL,NULL,'2012-11-19 04:52:51',56250.2033699998,19.7343,0.0654,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_74134.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(5510,4082,0,'LSQ12ggo','LSQ',60.43025,-34.9309166666667,NULL,NULL,'2012-11-19 02:48:01',56250.11668,20.101,0.1284,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_snap_74130.gif',37676606780,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588696980,9198390,NULL,NULL,NULL,NULL),(5511,4082,0,'LSQ12ggo','LSQ',60.43025,-34.9308888888889,NULL,NULL,'2012-11-19 04:47:42',56250.1998000001,20.3156,0.128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_snap_74131.gif',37676606780,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588696980,9198390,NULL,NULL,NULL,NULL),(5512,4118,0,'LSQ12ghd','LSQ',71.8642916666667,-21.3294444444444,NULL,NULL,'2012-11-19 05:50:47',56250.2436000002,21.0356,0.17,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_74119.gif',37342670868,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479232,9116863,NULL,NULL,NULL,NULL),(5513,4118,0,'LSQ12ghd','LSQ',71.8647916666667,-21.3292777777778,NULL,NULL,'2012-11-19 07:14:34',56250.3017899999,19.4669,0.0935,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_74120.gif',37342671080,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479235,9116863,NULL,NULL,NULL,NULL),(5514,4120,0,'LSQ12ghc','LSQ',66.2234583333333,-21.2026666666667,NULL,NULL,'2012-11-19 05:47:23',56250.24125,17.0325,0.0245,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_74090.gif',37325531170,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(5515,4120,0,'LSQ12ghc','LSQ',66.222875,-21.2026666666667,NULL,NULL,'2012-11-19 07:26:25',56250.3100200002,17.3077,0.0233,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_74091.gif',37325531170,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(5516,4133,0,'LSQ12gha','LSQ',57.2165416666667,-23.4220277777778,NULL,NULL,'2012-11-19 07:28:06',56250.3111899998,19.7457,0.1823,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gha/LSQ12gha_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gha/LSQ12gha_snap_74073.gif',37995371538,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593677680,9276213,NULL,NULL,NULL,NULL),(5517,4156,0,'LSQ12ggn','LSQ',58.024875,-39.0652222222222,NULL,NULL,'2012-11-19 02:44:38',56250.1143299998,17.2152,0.024,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_74083.gif',37665320689,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(5518,4156,0,'LSQ12ggn','LSQ',58.024875,-39.0652222222222,NULL,NULL,'2012-11-19 04:44:21',56250.19747,17.2769,0.0232,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_74084.gif',37665320689,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(5519,4317,0,'LSQ12gkk','LSQ',76.869,-23.8545833333333,NULL,NULL,'2012-11-19 05:57:33',56250.2483000001,19.8972,0.0795,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_73987.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(5520,4317,0,'LSQ12gkk','LSQ',76.869,-23.8546111111111,NULL,NULL,'2012-11-19 07:17:59',56250.3041599998,19.9034,0.0832,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_73988.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(5521,4320,0,'LSQ12gki','LSQ',17.6023333333333,-22.4758055555556,NULL,NULL,'2012-11-19 01:51:36',56250.0775000001,19.0913,0.0738,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_snap_74045.gif',35214805816,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,550231340,8597364,NULL,NULL,NULL,NULL),(5522,4320,0,'LSQ12gki','LSQ',17.6023333333333,-22.4758333333333,NULL,NULL,'2012-11-19 03:51:40',56250.1608899999,19.1042,0.0618,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_snap_74046.gif',35214805816,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,550231340,8597364,NULL,NULL,NULL,NULL),(5523,4331,0,'LSQ12gka','LSQ',16.3234166666667,-26.7014722222222,NULL,NULL,'2012-11-19 01:53:17',56250.0786700002,19.0285,0.0724,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_snap_73953.gif',34725499594,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542585931,8477905,NULL,NULL,NULL,NULL),(5524,4331,0,'LSQ12gka','LSQ',16.3234166666667,-26.7015,NULL,NULL,'2012-11-19 03:53:21',56250.16206,19.3935,0.0765,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_snap_73954.gif',34725499594,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542585931,8477905,NULL,NULL,NULL,NULL),(5525,4333,0,'LSQ12gjz','LSQ',7.02645833333333,-29.0965555555556,NULL,NULL,'2012-11-19 03:26:09',56250.14316,20.7748,0.1794,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjz/LSQ12gjz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjz/LSQ12gjz_snap_74059.gif',34888280957,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545129389,8517646,NULL,NULL,NULL,NULL),(5526,4343,0,'LSQ12gjt','LSQ',6.904875,-30.5745277777778,NULL,NULL,'2012-11-19 01:14:15',56250.0515700001,19.8327,0.1024,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjt/LSQ12gjt_history.html','sne?',NULL,0.114853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjt/LSQ12gjt_snap_74036.gif',34857031270,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,544641113,8510017,NULL,NULL,NULL,NULL),(5527,4343,0,'LSQ12gjt','LSQ',6.90504166666667,-30.5744722222222,NULL,NULL,'2012-11-19 03:14:17',56250.1349200001,20.3636,0.1293,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjt/LSQ12gjt_history.html','sne?',NULL,0.114853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjt/LSQ12gjt_snap_74037.gif',34857031270,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,544641113,8510017,NULL,NULL,NULL,NULL),(5528,4345,0,'LSQ12gjo','LSQ',0.551666666666667,-37.3913333333333,NULL,NULL,'2012-11-19 01:04:05',56250.0445099999,20.6431,0.2019,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjo/LSQ12gjo_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjo/LSQ12gjo_snap_74027.gif',34668377393,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,541693396,8463959,NULL,NULL,NULL,NULL),(5529,4362,0,'LSQ12gkx','LSQ',56.678,-26.3568333333333,NULL,NULL,'2012-11-19 01:01:42',56250.0428499999,21.4092,0.207,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_snap_73994.gif',38528720443,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602011256,9406425,NULL,NULL,NULL,NULL),(5530,5246,0,'LSQ12gln','LSQ',80.7475,-33.46425,NULL,NULL,'2012-11-19 05:21:46',56250.2234499999,18.8932,0.0665,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_74171.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(5531,5246,0,'LSQ12gln','LSQ',80.7475416666667,-33.46425,NULL,NULL,'2012-11-19 07:38:24',56250.3183400002,18.885,0.0649,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_74172.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(5532,5249,0,'LSQ12glk','LSQ',19.5815833333333,-38.3603055555556,NULL,NULL,'2012-11-19 02:00:02',56250.08336,19.796,0.1441,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_74087.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5533,5249,0,'LSQ12glk','LSQ',19.581625,-38.3603055555556,NULL,NULL,'2012-11-19 02:01:43',56250.0845300001,20.4275,0.1189,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_74085.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5534,5249,0,'LSQ12glk','LSQ',19.5816666666667,-38.3602777777778,NULL,NULL,'2012-11-19 04:00:08',56250.1667599999,20.4933,0.1556,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_74088.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5535,5249,0,'LSQ12glk','LSQ',19.5815833333333,-38.36025,NULL,NULL,'2012-11-19 04:01:49',56250.16793,20.3117,0.1029,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_74086.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5536,5387,0,'LSQ12gmi','LSQ',7.83625,-38.5853333333333,NULL,NULL,'2012-11-19 01:32:52',56250.0644999999,19.6164,0.194,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_history.html','Unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_snap_74180.gif',34688565688,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,542008838,8468888,NULL,NULL,NULL,NULL),(5537,5387,0,'LSQ12gmi','LSQ',7.83633333333333,-38.5853333333333,NULL,NULL,'2012-11-19 03:32:55',56250.1478599999,19.5718,0.1504,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_history.html','Unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_snap_74181.gif',34688565688,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,542008838,8468888,NULL,NULL,NULL,NULL),(5538,5397,0,'LSQ12gne','LSQ',14.5207916666667,-25.5831944444444,NULL,NULL,'2012-11-19 03:36:21',56250.1502499999,20.241,0.1508,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 16:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_snap_74202.gif',34713622310,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542400348,8475005,NULL,NULL,NULL,NULL),(5539,5539,1,'LSQ12gpb','LSQ',20.3198333333333,-22.3257777777778,NULL,NULL,'2012-11-05 06:33:19',56236.2731400002,19.4818,0.1806,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpb/LSQ12gpb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpb/LSQ12gpb_snap_74506.gif',35223189339,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550362333,8599411,NULL,NULL,NULL,NULL),(5540,5539,0,'LSQ12gpb','LSQ',20.3198333333333,-22.3258611111111,NULL,NULL,'2012-11-09 04:38:39',56240.1935100001,20.1486,0.139,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpb/LSQ12gpb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpb/LSQ12gpb_snap_74507.gif',35223189339,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550362333,8599411,NULL,NULL,NULL,NULL),(5541,5539,0,'LSQ12gpb','LSQ',20.319625,-22.3258333333333,NULL,NULL,'2012-11-13 04:42:41',56244.19631,20.0032,0.1262,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpb/LSQ12gpb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpb/LSQ12gpb_snap_74508.gif',35223189339,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550362333,8599411,NULL,NULL,NULL,NULL),(5542,5539,0,'LSQ12gpb','LSQ',20.3197916666667,-22.3258888888889,NULL,NULL,'2012-11-15 04:42:29',56246.1961699999,19.8291,0.1355,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpb/LSQ12gpb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpb/LSQ12gpb_snap_74509.gif',35223189339,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550362333,8599411,NULL,NULL,NULL,NULL),(5543,5539,0,'LSQ12gpb','LSQ',20.3197916666667,-22.3258055555556,NULL,NULL,'2012-11-17 04:10:12',56248.1737500001,20.375,0.166,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpb/LSQ12gpb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpb/LSQ12gpb_snap_74510.gif',35223189339,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550362333,8599411,NULL,NULL,NULL,NULL),(5544,5539,0,'LSQ12gpb','LSQ',20.3197083333333,-22.3258333333333,NULL,NULL,'2012-11-19 02:03:31',56250.0857799998,19.8912,0.1267,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpb/LSQ12gpb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpb/LSQ12gpb_snap_74495.gif',35223189339,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550362333,8599411,NULL,NULL,NULL,NULL),(5545,5539,0,'LSQ12gpb','LSQ',20.3198333333333,-22.3258333333333,NULL,NULL,'2012-11-19 04:03:35',56250.16916,20.0615,0.1541,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpb/LSQ12gpb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpb/LSQ12gpb_snap_74496.gif',35223189339,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550362333,8599411,NULL,NULL,NULL,NULL),(5546,5546,1,'LSQ12gpa','LSQ',6.006375,-21.0637777777778,NULL,NULL,'2012-11-15 01:27:36',56246.0608399999,14.9677,0.1138,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpa/LSQ12gpa_history.html','fading',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpa/LSQ12gpa_snap_74504.gif',35305381751,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,551646589,8619477,NULL,NULL,NULL,NULL),(5547,5546,0,'LSQ12gpa','LSQ',6.00641666666667,-21.0638611111111,NULL,NULL,'2012-11-17 03:19:11',56248.13833,16.6021,0.1401,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-11-19 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpa/LSQ12gpa_history.html','fading',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpa/LSQ12gpa_snap_74505.gif',35305381751,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,551646589,8619477,NULL,NULL,NULL,NULL),(5548,5546,0,'LSQ12gpa','LSQ',6.00645833333333,-21.0637222222222,NULL,NULL,'2012-11-19 01:09:09',56250.0480300002,18.3184,0.1655,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-11-19 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpa/LSQ12gpa_history.html','fading',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpa/LSQ12gpa_snap_74493.gif',35305381751,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,551646589,8619477,NULL,NULL,NULL,NULL),(5549,5546,0,'LSQ12gpa','LSQ',6.00654166666667,-21.06375,NULL,NULL,'2012-11-19 03:09:13',56250.1314099999,16.6406,0.0937,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-11-19 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpa/LSQ12gpa_history.html','fading',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpa/LSQ12gpa_snap_74494.gif',35305381751,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,551646589,8619477,NULL,NULL,NULL,NULL),(5550,5550,1,'LSQ12goy','LSQ',68.8833333333333,-26.4606388888889,NULL,NULL,'2012-11-19 05:30:19',56250.22939,20.2342,0.1519,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_74383.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(5551,5550,0,'LSQ12goy','LSQ',68.8834583333333,-26.4606944444444,NULL,NULL,'2012-11-19 07:04:18',56250.2946600001,19.918,0.127,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_74384.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(5552,5552,1,'LSQ12gox','LSQ',62.918625,-26.3520555555556,NULL,NULL,'2012-11-15 06:02:46',56246.2519299998,19.6337,0.1102,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gox/LSQ12gox_history.html','hostless unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gox/LSQ12gox_snap_74488.gif',37651761178,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,588308768,9192324,NULL,NULL,NULL,NULL),(5553,5552,0,'LSQ12gox','LSQ',62.918625,-26.352,NULL,NULL,'2012-11-15 07:59:39',56246.3330999999,19.6756,0.0983,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-11-19 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gox/LSQ12gox_history.html','hostless unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gox/LSQ12gox_snap_74489.gif',37651761178,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,588308768,9192324,NULL,NULL,NULL,NULL),(5554,5552,0,'LSQ12gox','LSQ',62.9186666666667,-26.3520833333333,NULL,NULL,'2012-11-17 05:32:28',56248.2308899998,20.0432,0.1095,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-11-19 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gox/LSQ12gox_history.html','hostless unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gox/LSQ12gox_snap_74490.gif',37651761178,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,588308768,9192324,NULL,NULL,NULL,NULL),(5555,5552,0,'LSQ12gox','LSQ',62.918625,-26.3521111111111,NULL,NULL,'2012-11-19 05:26:55',56250.2270300002,19.7306,0.1047,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-11-19 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gox/LSQ12gox_history.html','hostless unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gox/LSQ12gox_snap_74381.gif',37651761178,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,588308768,9192324,NULL,NULL,NULL,NULL),(5556,5552,0,'LSQ12gox','LSQ',62.9185416666667,-26.3520833333333,NULL,NULL,'2012-11-19 07:36:40',56250.3171299999,19.6991,0.1094,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-11-19 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gox/LSQ12gox_history.html','hostless unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gox/LSQ12gox_snap_74382.gif',37651761178,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,588308768,9192324,NULL,NULL,NULL,NULL),(5557,5557,1,'LSQ12gow','LSQ',48.1342083333333,-28.9633055555556,NULL,NULL,'2012-11-13 05:53:07',56244.24523,19.767,0.1418,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_74484.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(5558,5557,0,'LSQ12gow','LSQ',48.1343333333333,-28.9633888888889,NULL,NULL,'2012-11-15 05:56:00',56246.2472299999,18.8222,0.1196,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_74485.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(5559,5557,0,'LSQ12gow','LSQ',48.1341666666667,-28.9634444444444,NULL,NULL,'2012-11-15 08:03:02',56246.3354400001,18.1536,0.0699,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_74486.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(5560,5557,0,'LSQ12gow','LSQ',48.133875,-28.9632777777778,NULL,NULL,'2012-11-17 04:35:44',56248.1914900001,18.8833,0.0897,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_74487.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(5561,5557,0,'LSQ12gow','LSQ',48.134375,-28.9632222222222,NULL,NULL,'2012-11-19 02:29:11',56250.1036,18.3503,0.101,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_74379.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(5562,5557,0,'LSQ12gow','LSQ',48.134,-28.9633333333333,NULL,NULL,'2012-11-19 04:29:08',56250.1869000001,18.7785,0.1311,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_74380.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(5563,5563,1,'LSQ12got','LSQ',80.9652083333333,-30.5171388888889,NULL,NULL,'2012-11-19 05:21:46',56250.2234499999,19.34,0.1339,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12got/LSQ12got_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12got/LSQ12got_snap_74373.gif',37308864421,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,582951006,9108609,NULL,NULL,NULL,NULL),(5564,5563,0,'LSQ12got','LSQ',80.965375,-30.5171388888889,NULL,NULL,'2012-11-19 07:38:24',56250.3183400002,20.1155,0.1557,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12got/LSQ12got_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12got/LSQ12got_snap_74374.gif',37308864438,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,582951006,9108609,NULL,NULL,NULL,NULL),(5565,5565,1,'LSQ12goj','LSQ',11.8022916666667,-33.37075,NULL,NULL,'2012-11-01 01:32:30',56232.0642400002,19.5536,0.1755,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goj/LSQ12goj_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goj/LSQ12goj_snap_74430.gif',34879507473,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,544992304,8515504,NULL,NULL,NULL,NULL),(5566,5565,0,'LSQ12goj','LSQ',11.8021666666667,-33.3707777777778,NULL,NULL,'2012-11-19 01:31:11',56250.0633299998,18.9557,0.0878,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-11-19 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goj/LSQ12goj_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goj/LSQ12goj_snap_74353.gif',34879507473,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,544992304,8515504,NULL,NULL,NULL,NULL),(5567,5565,0,'LSQ12goj','LSQ',11.8022083333333,-33.3707777777778,NULL,NULL,'2012-11-19 03:31:14',56250.1466899998,18.443,0.0436,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-11-19 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goj/LSQ12goj_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goj/LSQ12goj_snap_74354.gif',34879507473,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,544992304,8515504,NULL,NULL,NULL,NULL),(5568,5568,1,'LSQ12gnu','LSQ',19.51575,-36.6119444444444,NULL,NULL,'2012-11-13 02:22:52',56244.0992200002,21.437,0.1553,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_history.html','sn - nice',NULL,0.073214,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_snap_74281.gif',38275123499,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598048804,9344512,NULL,NULL,NULL,NULL),(5569,5568,0,'LSQ12gnu','LSQ',19.51575,-36.612,NULL,NULL,'2012-11-13 04:39:17',56244.1939500002,20.9868,0.1096,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_history.html','sn - nice',NULL,0.073214,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_snap_74282.gif',38275123499,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598048804,9344512,NULL,NULL,NULL,NULL),(5570,5568,0,'LSQ12gnu','LSQ',19.51575,-36.6120277777778,NULL,NULL,'2012-11-15 04:39:01',56246.1937699998,20.6756,0.1382,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_history.html','sn - nice',NULL,0.073214,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_snap_74283.gif',38275123499,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598048804,9344512,NULL,NULL,NULL,NULL),(5571,5568,0,'LSQ12gnu','LSQ',19.5156666666667,-36.6120555555556,NULL,NULL,'2012-11-17 02:07:02',56248.0882199998,20.9759,0.1424,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_history.html','sn - nice',NULL,0.073214,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_snap_74284.gif',38275123499,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598048804,9344512,NULL,NULL,NULL,NULL),(5572,5568,0,'LSQ12gnu','LSQ',19.5157083333333,-36.6120277777778,NULL,NULL,'2012-11-17 04:06:46',56248.1713700001,21.6465,0.2063,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_history.html','sn - nice',NULL,0.073214,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_snap_74285.gif',38275123499,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598048804,9344512,NULL,NULL,NULL,NULL),(5573,5568,0,'LSQ12gnu','LSQ',19.5157916666667,-36.6120277777778,NULL,NULL,'2012-11-19 02:00:02',56250.08336,20.6039,0.1317,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_history.html','sn - nice',NULL,0.073214,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_snap_74224.gif',38275123499,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598048804,9344512,NULL,NULL,NULL,NULL),(5574,5568,0,'LSQ12gnu','LSQ',19.5157083333333,-36.6119722222222,NULL,NULL,'2012-11-19 04:00:08',56250.1667599999,20.4911,0.1379,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_history.html','sn - nice',NULL,0.073214,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_snap_74225.gif',38275123499,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598048804,9344512,NULL,NULL,NULL,NULL),(5575,5575,1,'LSQ12gns','LSQ',16.0612916666667,-35.2393333333333,NULL,NULL,'2012-11-13 04:15:29',56244.1774300002,21.1758,0.1461,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gns/LSQ12gns_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gns/LSQ12gns_snap_74269.gif',38269795746,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597965558,9343211,NULL,NULL,NULL,NULL),(5576,5575,0,'LSQ12gns','LSQ',16.0608333333333,-35.23975,NULL,NULL,'2012-11-17 03:54:50',56248.1630799999,21.2488,0.1738,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-11-19 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gns/LSQ12gns_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gns/LSQ12gns_snap_74270.gif',38269795746,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597965558,9343211,NULL,NULL,NULL,NULL),(5577,5575,0,'LSQ12gns','LSQ',16.0609583333333,-35.2394722222222,NULL,NULL,'2012-11-19 01:48:12',56250.0751399999,21.0517,0.16,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-11-19 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gns/LSQ12gns_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gns/LSQ12gns_snap_74220.gif',38269795746,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597965558,9343211,NULL,NULL,NULL,NULL),(5578,5575,0,'LSQ12gns','LSQ',16.060875,-35.2397222222222,NULL,NULL,'2012-11-19 03:48:14',56250.1584999999,20.8348,0.1424,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-11-19 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gns/LSQ12gns_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gns/LSQ12gns_snap_74221.gif',38269795746,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597965558,9343211,NULL,NULL,NULL,NULL),(5579,5579,1,'LSQ12gno','LSQ',3.62820833333333,-35.4190555555556,NULL,NULL,'2012-11-17 01:27:36',56248.0608399999,19.8153,0.1531,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gno/LSQ12gno_history.html','sn - nice',NULL,0.0883,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gno/LSQ12gno_snap_74248.gif',34676126738,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,541814480,8465851,NULL,NULL,NULL,NULL),(5580,5579,0,'LSQ12gno','LSQ',3.62829166666667,-35.4190833333333,NULL,NULL,'2012-11-17 03:27:38',56248.1442,19.6989,0.1364,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gno/LSQ12gno_history.html','sn - nice',NULL,0.0883,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gno/LSQ12gno_snap_74249.gif',34676126738,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,541814480,8465851,NULL,NULL,NULL,NULL),(5581,5579,0,'LSQ12gno','LSQ',3.62833333333333,-35.4190833333333,NULL,NULL,'2012-11-19 01:21:00',56250.05626,19.5561,0.1238,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gno/LSQ12gno_history.html','sn - nice',NULL,0.0883,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gno/LSQ12gno_snap_74212.gif',34676126738,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,541814480,8465851,NULL,NULL,NULL,NULL),(5582,5579,0,'LSQ12gno','LSQ',3.62816666666667,-35.4190833333333,NULL,NULL,'2012-11-19 03:21:03',56250.13962,19.8268,0.1604,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-19 20:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gno/LSQ12gno_history.html','sn - nice',NULL,0.0883,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gno/LSQ12gno_snap_74213.gif',34676126738,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,541814480,8465851,NULL,NULL,NULL,NULL),(5583,3409,0,'LSQ12fxu','atel',356.792208333,-13.2493611111,NULL,NULL,'2012-11-19 12:00:00',56250.5,NULL,NULL,NULL,0.062,NULL,'II',NULL,'2012-11-20 10:34:00','2012-11-20 10:34:00','http://www.astronomerstelegram.org/?read=4587',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,49549307031,'du-Â­pont','WFCCD','CSP',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,774207922,12096998,NULL,NULL,NULL,NULL),(5584,4317,0,'LSQ12gkk','atel',76.869,-23.8546388889,NULL,NULL,'2012-11-19 12:00:00',56250.5,NULL,NULL,NULL,0.059,NULL,'Ic',NULL,'2012-11-20 10:35:15','2012-12-04 13:09:51','http://www.astronomerstelegram.org/?read=4587',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37413193574,'du-Â­pont','WFCCD','CSP','2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(5585,3044,0,'LSQ12ftn','LSQ',2.53929166666667,-19.1404166666667,NULL,NULL,'2012-11-20 01:17:37',56251.0539099998,19.286,0.1149,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-20 20:46:13','2012-11-20 20:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_snap_74547.gif',34442362275,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538161910,8408779,NULL,NULL,NULL,NULL),(5586,3035,0,'LSQ12fuy','LSQ',19.3753333333333,0.5935,NULL,NULL,'2012-11-20 03:46:27',56251.1572599998,19.056,0.1705,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-20 20:46:13','2012-11-20 20:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuy/LSQ12fuy_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuy/LSQ12fuy_snap_74589.gif',66652936649,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041452135,16272689,NULL,NULL,NULL,NULL),(5587,3273,0,'LSQ12fwf','LSQ',20.227125,-0.52575,NULL,NULL,'2012-11-20 01:46:09',56251.0737200002,19.123,0.1333,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-20 20:46:13','2012-11-20 20:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_history.html','sne?',NULL,0.09287,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_snap_74553.gif',34496037884,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539000591,8421884,NULL,NULL,NULL,NULL),(5588,3273,0,'LSQ12fwf','LSQ',20.2270416666667,-0.525583333333333,NULL,NULL,'2012-11-20 03:46:27',56251.1572599998,18.3686,0.1274,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-20 20:46:13','2012-11-20 20:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_history.html','sne?',NULL,0.09287,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_snap_74554.gif',34496037887,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539000591,8421884,NULL,NULL,NULL,NULL),(5589,3346,0,'LSQ12fzb','LSQ',34.1771666666667,20.6693055555556,NULL,NULL,'2012-11-20 01:08:26',56251.0475300001,20.208,0.1795,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-20 20:46:13','2012-11-20 20:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzb/LSQ12fzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzb/LSQ12fzb_snap_74552.gif',68109800746,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1064215636,16628369,NULL,NULL,NULL,NULL),(5590,3348,0,'LSQ12fza','LSQ',34.8935416666667,21.2726111111111,NULL,NULL,'2012-11-20 01:08:26',56251.0475300001,19.5132,0.1178,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-20 20:46:13','2012-11-20 20:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fza/LSQ12fza_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fza/LSQ12fza_snap_74564.gif',68112332845,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1064255200,16628987,NULL,NULL,NULL,NULL),(5591,3397,0,'LSQ12fxz','LSQ',15.4683333333333,-4.95913888888889,NULL,NULL,'2012-11-20 01:38:58',56251.0687299999,19.699,0.2126,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-20 20:46:13','2012-11-20 20:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxz/LSQ12fxz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxz/LSQ12fxz_snap_74550.gif',34551283441,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,539863803,8435371,NULL,NULL,NULL,NULL),(5592,3399,0,'LSQ12fxy','LSQ',50.12775,-11.2956388888889,NULL,NULL,'2012-11-20 02:05:58',56251.0874800002,20.0475,0.2101,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-20 20:46:13','2012-11-20 20:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_snap_74549.gif',37885680965,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591963765,9249433,NULL,NULL,NULL,NULL),(5593,4165,0,'LSQ12gjc','LSQ',52.67075,-6.373,NULL,NULL,'2012-11-20 02:09:21',56251.08983,19.0234,0.1097,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-20 20:46:13','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_74590.gif',36797933958,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(5594,5383,0,'LSQ12glt','LSQ',50.0835,-15.2377777777778,NULL,NULL,'2012-11-20 04:23:20',56251.1828800002,18.8986,0.099,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-20 20:46:13','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glt/LSQ12glt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glt/LSQ12glt_snap_74593.gif',38081917180,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,595029955,9297343,NULL,NULL,NULL,NULL),(5595,4056,0,'LSQ12ghe','atel',68.5490833333,-23.0559722222,NULL,NULL,'2012-11-19 00:00:00',56250,NULL,NULL,NULL,0.065,NULL,'unknown',NULL,'2012-11-21 09:16:53','2012-12-04 13:09:51','http://www.astronomerstelegram.org/?read=4592',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37320555166,'du point','wfccd','CSP','2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(5596,5568,0,'LSQ12gnu','atel',19.51575,-36.6119444444,NULL,NULL,'2012-11-19 00:00:00',56250,NULL,NULL,NULL,0.07,NULL,'II',NULL,'2012-11-21 09:18:09','2012-12-04 13:09:51','http://www.astronomerstelegram.org/?read=4592',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38275123499,'du point','wfccd','CSP','2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598048804,9344512,NULL,NULL,NULL,NULL),(5597,5597,0,'PSNJ01140746-3239077','TOCP',18.5310833333333,-32.6521388888889,NULL,NULL,'2012-11-21 00:00:00',56252,16.4,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-11-21 15:16:15','2019-10-12 20:41:36','http://www.cbat.eps.harvard.edu/unconf/followups/J01140746-3239077.html','supernova',NULL,0.0119,NULL,NULL,'http://www.cbat.eps.harvard.edu/unconf/followups/J01140746-3239077.html',NULL,NULL,38278292957,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598098327,9345286,NULL,NULL,NULL,NULL),(5598,4854,1,'OGLE-2012-SN-005','pessto',45.2120416667,-70.5198333333,NULL,NULL,'2012-11-13 00:00:00',56251.5,NULL,NULL,NULL,0.076,NULL,'Ia',NULL,'2012-11-21 17:23:32','2019-10-11 14:10:04','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,36456882732,'NTT','EFOSC2','Santiago Gonzalez','2012-08-28 09:14:36',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,569638792,8900606,NULL,NULL,NULL,NULL),(5599,4320,0,'LSQ12gki','pessto',17.6022916667,-22.4757777778,NULL,NULL,'2012-11-13 00:00:00',56251.5,NULL,NULL,NULL,0.123,NULL,'Ia',NULL,'2012-11-21 17:25:11','2019-08-18 22:06:58','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35214805816,'NTT','EFOSC2','Francisco Forster','2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,550231340,8597364,NULL,NULL,NULL,NULL),(5600,4163,0,'LSQ12gje','pessto',55.4508333333,-2.83622222222,NULL,NULL,'2012-11-13 00:00:00',56251.5,NULL,NULL,NULL,0,NULL,'unknown',NULL,'2012-11-21 17:26:08','2019-08-18 22:06:58','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,36822871960,'NTT','EFOSC2','Joe Anderson','2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,575357374,8989958,NULL,NULL,NULL,NULL),(5601,5246,0,'LSQ12gln','pessto',80.7475833333,-33.4643055556,NULL,NULL,'2012-11-21 00:00:00',56252,NULL,NULL,NULL,0.104,NULL,'Ia',NULL,'2012-11-22 15:51:36','2012-12-04 13:09:51','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37267966630,'NTT','EFOSC2','francisco and santiago','2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(5602,3035,0,'LSQ12fux','LSQ',19.3560833333333,0.586833333333333,NULL,NULL,'2012-11-22 01:38:06',56253.06813,18.3845,0.0735,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-11-23 03:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fux/LSQ12fux_history.html','sne - good',NULL,0.05924,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fux/LSQ12fux_snap_74711.gif',66652909103,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041451704,16272682,NULL,NULL,NULL,NULL),(5603,3044,0,'LSQ12ftn','LSQ',2.53920833333333,-19.1403611111111,NULL,NULL,'2012-11-22 03:09:11',56253.1313800002,19.4548,0.2082,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-11-23 03:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftn/LSQ12ftn_snap_74631.gif',34442362275,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,538161910,8408779,NULL,NULL,NULL,NULL),(5604,3055,0,'LSQ12fue','LSQ',5.972,-14.4288333333333,NULL,NULL,'2012-11-22 03:05:11',56253.12861,18.6667,0.1408,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-11-23 03:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fue/LSQ12fue_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fue/LSQ12fue_snap_74640.gif',34454135446,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,538345866,8411654,NULL,NULL,NULL,NULL),(5605,3035,0,'LSQ12fuy','LSQ',19.375375,0.5935,NULL,NULL,'2012-11-22 01:38:06',56253.06813,18.659,0.063,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-11-23 03:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuy/LSQ12fuy_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fuy/LSQ12fuy_snap_74713.gif',66652936649,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1041452135,16272689,NULL,NULL,NULL,NULL),(5606,3273,0,'LSQ12fwf','LSQ',20.227125,-0.525666666666667,NULL,NULL,'2012-11-22 01:38:06',56253.06813,18.6464,0.0966,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-11-23 03:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_history.html','sne?',NULL,0.09287,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwf/LSQ12fwf_snap_74643.gif',34496037887,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,539000591,8421884,NULL,NULL,NULL,NULL),(5607,3386,0,'LSQ12fyb','LSQ',53.6894583333333,-3.73858333333333,NULL,NULL,'2012-11-22 02:01:09',56253.0841399999,19.6035,0.2012,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-11-23 03:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_74635.gif',36820699952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(5608,3386,0,'LSQ12fyb','LSQ',53.6893333333333,-3.73861111111111,NULL,NULL,'2012-11-22 04:00:35',56253.16708,19.7189,0.1637,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-11-23 03:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_74636.gif',36820699952,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(5609,3399,0,'LSQ12fxy','LSQ',50.1274583333333,-11.2955,NULL,NULL,'2012-11-22 01:57:45',56253.0817800001,19.4067,0.1653,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-11-23 03:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_snap_74641.gif',37885680972,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591963765,9249433,NULL,NULL,NULL,NULL),(5610,3764,0,'LSQ12gcd','LSQ',59.5835,-18.6201388888889,NULL,NULL,'2012-11-22 02:52:46',56253.11998,19.1984,0.1139,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcd/LSQ12gcd_snap_74634.gif',36851844463,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575810069,8997032,NULL,NULL,NULL,NULL),(5611,3883,0,'LSQ12gfh','LSQ',53.6905,-6.84377777777778,NULL,NULL,'2012-11-22 02:01:09',56253.0841399999,16.785,0.0346,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_history.html','sne??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_snap_74698.gif',36800390526,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575006101,8984470,NULL,NULL,NULL,NULL),(5612,4159,0,'LSQ12gjg','LSQ',69.8504166666667,-5.53477777777778,NULL,NULL,'2012-11-22 05:40:45',56253.2366399998,15.436,0.0067,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_snap_74715.gif',37457458286,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,585272785,9144887,NULL,NULL,NULL,NULL),(5613,4159,0,'LSQ12gjg','LSQ',69.8504166666667,-5.53483333333333,NULL,NULL,'2012-11-22 07:09:33',56253.2982999999,15.3923,0.0075,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjg/LSQ12gjg_snap_74716.gif',37457458286,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,585272785,9144887,NULL,NULL,NULL,NULL),(5614,4165,0,'LSQ12gjc','LSQ',52.6709583333333,-6.37275,NULL,NULL,'2012-11-22 04:00:35',56253.16708,19.0252,0.1388,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_74724.gif',36797933959,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(5615,4171,0,'LSQ12giz','LSQ',63.4557083333333,-10.0445555555556,NULL,NULL,'2012-11-22 05:27:15',56253.2272600001,19.4618,0.1468,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giz/LSQ12giz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12giz/LSQ12giz_snap_74721.gif',36979075816,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577798059,9028094,NULL,NULL,NULL,NULL),(5616,4349,0,'LSQ12gld','LSQ',60.89725,-1.52588888888889,NULL,NULL,'2012-11-22 04:26:43',56253.1852199999,17.495,0.0477,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gld/LSQ12gld_history.html','sne?',NULL,0.054825,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gld/LSQ12gld_snap_74685.gif',36937794522,NULL,NULL,NULL,'2012-10-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,577153039,9018016,NULL,NULL,NULL,NULL),(5617,4356,0,'LSQ12gla','LSQ',50.0672083333333,-9.48086111111111,NULL,NULL,'2012-11-22 03:57:11',56253.1647199998,19.4846,0.1288,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_snap_74683.gif',37898099251,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,592157800,9252465,NULL,NULL,NULL,NULL),(5618,5383,0,'LSQ12glt','LSQ',50.0837916666667,-15.23775,NULL,NULL,'2012-11-22 02:15:00',56253.09375,18.4988,0.0706,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glt/LSQ12glt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glt/LSQ12glt_snap_74728.gif',38081917183,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,595029955,9297343,NULL,NULL,NULL,NULL),(5619,5383,0,'LSQ12glt','LSQ',50.084,-15.2377222222222,NULL,NULL,'2012-11-22 04:14:25',56253.17668,18.5851,0.1309,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 03:46:15','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glt/LSQ12glt_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glt/LSQ12glt_snap_74729.gif',38081917183,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,595029955,9297343,NULL,NULL,NULL,NULL),(5620,5620,0,'chase_NGC3469','CHASE',164.2394,-14.2938472222222,NULL,NULL,'2012-11-22 07:43:20',56253.32177,17.2,NULL,NULL,NULL,NULL,NULL,NULL,'2012-11-23 09:46:09','2019-10-12 20:41:36','NULL','supernova',NULL,0.0155,NULL,NULL,'http://spaceobs.org/images/TOCP/PSNJ10565746-1417378-20121124.png',NULL,NULL,41869744922,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,654214764,10222105,NULL,NULL,NULL,NULL),(5621,3125,0,'chase_MCG-06-12-002','CHASE',75.208575,-38.6531972222222,NULL,NULL,'2012-11-22 07:44:43',56253.32272,18.2,NULL,NULL,NULL,NULL,NULL,NULL,'2012-11-23 09:46:09','2012-11-23 09:46:09','NULL','supernova',NULL,0.05597,NULL,NULL,'NULL',NULL,NULL,37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(5622,2985,0,'LSQ12fsh','LSQ',12.7765833333333,-39.1600277777778,NULL,NULL,'2012-11-21 01:42:29',56252.07118,19.1484,0.07,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_74930.gif',38166915083,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(5623,2985,0,'LSQ12fsh','LSQ',12.7767083333333,-39.16,NULL,NULL,'2012-11-21 03:43:48',56252.1554200002,19.058,0.0721,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_74931.gif',38166915082,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(5624,2987,0,'LSQ12fsj','LSQ',73.7294166666667,-36.3250277777778,NULL,NULL,'2012-11-21 02:53:50',56252.12072,16.2963,0.0325,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_74932.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(5625,2987,0,'LSQ12fsj','LSQ',73.7292916666667,-36.3250277777778,NULL,NULL,'2012-11-21 04:55:14',56252.2050299998,16.3292,0.0049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_74933.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(5626,2993,0,'LSQ12fss','LSQ',18.7157083333333,-30.0939722222222,NULL,NULL,'2012-11-21 01:54:23',56252.07944,19.7156,0.0887,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_74905.gif',34734808837,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(5627,2993,0,'LSQ12fss','LSQ',18.7158333333333,-30.0940277777778,NULL,NULL,'2012-11-21 03:55:41',56252.1636800002,19.7537,0.1522,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_74906.gif',34734808837,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(5628,2999,0,'LSQ12fsn','LSQ',10.6064166666667,-34.0972777777778,NULL,NULL,'2012-11-21 01:27:12',56252.0605600001,15.8123,0.0095,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_history.html','Unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_snap_74869.gif',34872861140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544888455,8513882,NULL,NULL,NULL,NULL),(5629,2999,0,'LSQ12fsn','LSQ',10.6064166666667,-34.09725,NULL,NULL,'2012-11-21 03:28:29',56252.1447899998,15.5364,0.0115,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_history.html','Unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_snap_74870.gif',34872861140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544888455,8513882,NULL,NULL,NULL,NULL),(5630,3001,0,'LSQ12fth','LSQ',47.82275,-25.1096388888889,NULL,NULL,'2012-11-21 02:21:40',56252.0983799999,17.9068,0.0344,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_74850.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(5631,3001,0,'LSQ12fth','LSQ',47.8225416666667,-25.1097222222222,NULL,NULL,'2012-11-21 02:23:21',56252.0995499999,18.2398,0.0437,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_74852.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(5632,3001,0,'LSQ12fth','LSQ',47.8227083333333,-25.1096388888889,NULL,NULL,'2012-11-21 04:22:59',56252.1826300002,17.9514,0.0322,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_74851.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(5633,3001,0,'LSQ12fth','LSQ',47.822625,-25.10975,NULL,NULL,'2012-11-21 04:24:40',56252.1838000002,18.5552,0.0411,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_74853.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(5634,3007,0,'LSQ12fte','LSQ',52.152625,-24.87175,NULL,NULL,'2012-11-21 04:36:33',56252.1920500002,19.8278,0.1171,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_snap_74936.gif',38021943870,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594092872,9282701,NULL,NULL,NULL,NULL),(5635,3009,0,'LSQ12ftd','LSQ',64.2445833333333,-24.1446944444444,NULL,NULL,'2012-11-21 05:44:32',56252.2392600002,19.2969,0.1463,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_74847.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(5636,3009,0,'LSQ12ftd','LSQ',64.2445416666667,-24.1447777777778,NULL,NULL,'2012-11-21 05:46:13',56252.2404299998,20.3791,0.1829,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_74849.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(5637,3009,0,'LSQ12ftd','LSQ',64.2447083333333,-24.14475,NULL,NULL,'2012-11-21 07:24:54',56252.3089600001,20.3174,0.1713,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_74848.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(5638,3013,0,'LSQ12ftc','LSQ',64.8029583333333,-24.3553055555556,NULL,NULL,'2012-11-21 05:44:32',56252.2392600002,20.5222,0.1602,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_74943.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(5639,3013,0,'LSQ12ftc','LSQ',64.80275,-24.3552222222222,NULL,NULL,'2012-11-21 05:46:13',56252.2404299998,19.9612,0.1301,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_74945.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(5640,3013,0,'LSQ12ftc','LSQ',64.8026666666667,-24.3551388888889,NULL,NULL,'2012-11-21 07:23:13',56252.30779,19.6366,0.0867,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_74946.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(5641,3013,0,'LSQ12ftc','LSQ',64.803125,-24.3552222222222,NULL,NULL,'2012-11-21 07:24:54',56252.3089600001,20.5395,0.1569,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_74944.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(5642,3017,0,'LSQ12ftb','LSQ',65.4214583333333,-23.7053611111111,NULL,NULL,'2012-11-21 05:44:32',56252.2392600002,18.2096,0.1034,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_74907.gif',37314276031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(5643,3017,0,'LSQ12ftb','LSQ',65.4220416666667,-23.7051944444444,NULL,NULL,'2012-11-21 05:46:13',56252.2404299998,18.7824,0.0701,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_74909.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(5644,3017,0,'LSQ12ftb','LSQ',65.4220416666667,-23.70525,NULL,NULL,'2012-11-21 07:23:13',56252.30779,18.7934,0.0642,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_74910.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(5645,3017,0,'LSQ12ftb','LSQ',65.4215,-23.7053333333333,NULL,NULL,'2012-11-21 07:24:54',56252.3089600001,18.1196,0.0518,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_74908.gif',37314276031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(5646,3110,0,'LSQ12fvw','LSQ',43.0010416666667,-25.5425833333333,NULL,NULL,'2012-11-21 02:08:04',56252.0889400002,19.8029,0.1169,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvw/LSQ12fvw_history.html','sn - nice',NULL,0.1101,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvw/LSQ12fvw_snap_74779.gif',38420117950,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600314342,9379911,NULL,NULL,NULL,NULL),(5647,3112,0,'LSQ12fvu','LSQ',53.5190833333333,-21.8744444444444,NULL,NULL,'2012-11-21 02:36:53',56252.1089499998,19.1802,0.0911,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_74915.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(5648,3112,0,'LSQ12fvu','LSQ',53.5190416666667,-21.8744722222222,NULL,NULL,'2012-11-21 04:38:14',56252.1932199998,19.1322,0.0638,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_74916.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(5649,3114,0,'LSQ12fvq','LSQ',19.1506666666667,-31.4520555555556,NULL,NULL,'2012-11-21 01:54:23',56252.07944,18.6147,0.0351,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_74897.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(5650,3114,0,'LSQ12fvq','LSQ',19.15075,-31.4520555555556,NULL,NULL,'2012-11-21 03:55:41',56252.1636800002,18.589,0.0462,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_74898.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(5651,3118,0,'LSQ12fvp','LSQ',10.7100833333333,-34.1603055555556,NULL,NULL,'2012-11-21 01:27:12',56252.0605600001,17.6821,0.0407,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_74799.gif',34872963970,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(5652,3118,0,'LSQ12fvp','LSQ',10.7101666666667,-34.1603055555556,NULL,NULL,'2012-11-21 03:28:29',56252.1447899998,17.4255,0.0503,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_74800.gif',34872963970,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(5653,3122,0,'LSQ12fvn','LSQ',16.3919166666667,-35.4907222222222,NULL,NULL,'2012-11-21 01:44:11',56252.0723600001,20.1412,0.0916,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_74899.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(5654,3122,0,'LSQ12fvn','LSQ',16.3920416666667,-35.4908055555556,NULL,NULL,'2012-11-21 03:45:30',56252.1565999999,19.8203,0.1569,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_74900.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(5655,3125,0,'LSQ12fvl','LSQ',75.208625,-38.6531666666667,NULL,NULL,'2012-11-21 04:55:14',56252.2050299998,18.7654,0.0705,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_74929.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(5656,3222,0,'LSQ12fvm','LSQ',47.9510416666667,-38.8037222222222,NULL,NULL,'2012-11-21 02:28:25',56252.1030700002,19.8722,0.1801,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_74782.gif',38600095382,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126490,9423851,NULL,NULL,NULL,NULL),(5657,3222,0,'LSQ12fvm','LSQ',47.951,-38.8036944444444,NULL,NULL,'2012-11-21 04:29:46',56252.1873400002,20.062,0.1768,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvm/LSQ12fvm_snap_74783.gif',38600095382,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603126490,9423851,NULL,NULL,NULL,NULL),(5660,3245,0,'LSQ12fwz','LSQ',21.2804583333333,-26.1291388888889,NULL,NULL,'2012-11-21 02:04:35',56252.0865199999,19.04,0.0894,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_74808.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(5661,3245,0,'LSQ12fwz','LSQ',21.2805416666667,-26.1291111111111,NULL,NULL,'2012-11-21 04:05:56',56252.1707899999,18.758,0.0869,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_74809.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(5662,3249,0,'LSQ12fww','LSQ',62.5344583333333,-34.1650833333333,NULL,NULL,'2012-11-21 05:03:47',56252.2109699999,18.7152,0.0635,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_74776.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(5663,3287,0,'LSQ12fxc','LSQ',47.8157083333333,-22.4542222222222,NULL,NULL,'2012-11-21 02:21:40',56252.0983799999,18.7578,0.0884,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_74810.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(5664,3287,0,'LSQ12fxc','LSQ',47.81575,-22.4541666666667,NULL,NULL,'2012-11-21 04:22:59',56252.1826300002,19.4631,0.1344,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_74811.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(5665,3481,0,'LSQ12fzc','LSQ',43.0447083333333,-35.9737777777778,NULL,NULL,'2012-11-21 02:11:28',56252.0913,19.361,0.176,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_74768.gif',38652782971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(5666,3481,0,'LSQ12fzc','LSQ',43.0446666666667,-35.9738611111111,NULL,NULL,'2012-11-21 04:12:49',56252.17557,19.054,0.169,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_74769.gif',38652782971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(5667,3485,0,'LSQ12gbj','LSQ',66.0475,-25.4150833333333,NULL,NULL,'2012-11-21 07:24:54',56252.3089600001,19.3656,0.0877,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_snap_74777.gif',37181674004,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,580963656,9077557,NULL,NULL,NULL,NULL),(5668,3514,0,'LSQ12gaq','LSQ',65.383875,-25.3801388888889,NULL,NULL,'2012-11-21 05:46:13',56252.2404299998,19.8098,0.1044,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_snap_74820.gif',37182103829,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580970372,9077662,NULL,NULL,NULL,NULL),(5669,3530,0,'LSQ12gad','LSQ',52.302125,-30.6228888888889,NULL,NULL,'2012-11-21 02:33:29',56252.10659,18.6887,0.0942,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_74947.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(5670,3530,0,'LSQ12gad','LSQ',52.3023333333333,-30.6228888888889,NULL,NULL,'2012-11-21 04:34:50',56252.19086,19.4892,0.1613,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_74948.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(5671,3537,0,'LSQ12gab','LSQ',81.8943333333333,-31.3134166666667,NULL,NULL,'2012-11-21 05:18:59',56252.2215200001,20.2193,0.157,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_snap_74797.gif',37311362014,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,582990031,9109219,NULL,NULL,NULL,NULL),(5672,3537,0,'LSQ12gab','LSQ',81.8937083333333,-31.3133888888889,NULL,NULL,'2012-11-21 07:36:54',56252.3173000002,19.383,0.0824,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_snap_74798.gif',37311362015,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,582990031,9109219,NULL,NULL,NULL,NULL),(5673,3540,0,'LSQ12fzz','LSQ',81.4934166666667,-34.4576111111111,NULL,NULL,'2012-11-21 05:18:59',56252.2215200001,19.9125,0.1417,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_74801.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(5674,3548,0,'LSQ12fzu','LSQ',74.8828333333333,-38.4092222222222,NULL,NULL,'2012-11-21 04:53:32',56252.2038500002,19.2365,0.0984,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_74805.gif',37599816278,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(5675,3551,0,'LSQ12fzr','LSQ',49.17925,-30.2705,NULL,NULL,'2012-11-21 02:18:14',56252.0959999999,19.4033,0.125,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_74922.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(5676,3551,0,'LSQ12fzr','LSQ',49.17925,-30.2705277777778,NULL,NULL,'2012-11-21 04:19:35',56252.1802699999,19.4546,0.1284,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-11-23 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_74923.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(5677,3818,0,'LSQ12gdc','LSQ',74.1527916666667,-31.6034444444444,NULL,NULL,'2012-11-21 05:13:56',56252.21801,17.2286,0.072,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_74838.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(5678,3818,0,'LSQ12gdc','LSQ',74.1528333333333,-31.6034166666667,NULL,NULL,'2012-11-21 06:56:01',56252.2889100001,17.2012,0.047,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_74839.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(5679,3821,0,'LSQ12gcw','LSQ',68.3187083333333,-38.1013888888889,NULL,NULL,'2012-11-21 04:50:11',56252.2015200001,19.3967,0.0796,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_74878.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(5680,4056,0,'LSQ12ghe','LSQ',68.549,-23.0559444444444,NULL,NULL,'2012-11-21 05:47:55',56252.2416099999,19.282,0.0657,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_74871.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(5681,4056,0,'LSQ12ghe','LSQ',68.5490416666667,-23.0559444444444,NULL,NULL,'2012-11-21 07:13:05',56252.30076,19.2599,0.0704,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_74872.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(5682,4061,0,'LSQ12ggx','LSQ',47.8960833333333,-22.3203888888889,NULL,NULL,'2012-11-21 02:23:21',56252.0995499999,19.321,0.1168,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_74955.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(5683,4061,0,'LSQ12ggx','LSQ',47.8960416666667,-22.3203333333333,NULL,NULL,'2012-11-21 04:24:40',56252.1838000002,19.3124,0.1051,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_74956.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(5684,4082,0,'LSQ12ggo','LSQ',60.4302083333333,-34.9308333333333,NULL,NULL,'2012-11-21 04:45:04',56252.1979700001,20.2514,0.1296,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_snap_74928.gif',37676606780,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588696980,9198390,NULL,NULL,NULL,NULL),(5685,4118,0,'LSQ12ghd','LSQ',71.8652083333333,-21.3295277777778,NULL,NULL,'2012-11-21 05:47:55',56252.2416099999,20.6769,0.1403,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_74911.gif',37342671080,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479235,9116863,NULL,NULL,NULL,NULL),(5686,4118,0,'LSQ12ghd','LSQ',71.865,-21.3295555555556,NULL,NULL,'2012-11-21 07:13:05',56252.30076,20.1105,0.1467,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_74912.gif',37342671080,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479235,9116863,NULL,NULL,NULL,NULL),(5687,4120,0,'LSQ12ghc','LSQ',66.2228333333333,-21.2026944444444,NULL,NULL,'2012-11-21 05:44:32',56252.2392600002,17.5968,0.0296,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_74874.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(5688,4120,0,'LSQ12ghc','LSQ',66.2229166666667,-21.2026666666667,NULL,NULL,'2012-11-21 07:24:54',56252.3089600001,17.4424,0.033,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_74875.gif',37325531170,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(5689,4156,0,'LSQ12ggn','LSQ',58.0249166666667,-39.0653055555556,NULL,NULL,'2012-11-21 02:40:17',56252.1113100001,17.3084,0.0269,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_74865.gif',37665320689,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(5690,4156,0,'LSQ12ggn','LSQ',58.0249583333333,-39.06525,NULL,NULL,'2012-11-21 04:41:43',56252.19564,17.5222,0.0291,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_74866.gif',37665320689,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(5691,4317,0,'LSQ12gkk','LSQ',76.8690416666667,-23.8546111111111,NULL,NULL,'2012-11-21 05:54:40',56252.2463000002,19.5398,0.0621,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_74793.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(5692,4317,0,'LSQ12gkk','LSQ',76.869,-23.8546111111111,NULL,NULL,'2012-11-21 07:16:27',56252.3031000001,19.6297,0.0681,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_74794.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(5693,4320,0,'LSQ12gki','LSQ',17.6024583333333,-22.4758055555556,NULL,NULL,'2012-11-21 01:47:38',56252.0747500001,19.1192,0.107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_snap_74845.gif',35214805816,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,550231340,8597364,NULL,NULL,NULL,NULL),(5694,4320,0,'LSQ12gki','LSQ',17.6022916666667,-22.4758055555556,NULL,NULL,'2012-11-21 03:48:55',56252.1589799998,19.1577,0.123,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_snap_74846.gif',35214805816,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,550231340,8597364,NULL,NULL,NULL,NULL),(5695,4331,0,'LSQ12gka','LSQ',16.3234583333333,-26.7014722222222,NULL,NULL,'2012-11-21 01:49:18',56252.0759100001,19.1502,0.0901,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_snap_74763.gif',34725499594,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542585931,8477905,NULL,NULL,NULL,NULL),(5696,4331,0,'LSQ12gka','LSQ',16.3234583333333,-26.7015277777778,NULL,NULL,'2012-11-21 03:50:37',56252.16016,19.0296,0.0972,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_snap_74764.gif',34725499594,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542585931,8477905,NULL,NULL,NULL,NULL),(5697,4333,0,'LSQ12gjz','LSQ',7.02641666666667,-29.09675,NULL,NULL,'2012-11-21 01:22:08',56252.0570399999,20.3943,0.1897,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjz/LSQ12gjz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjz/LSQ12gjz_snap_74859.gif',34888280957,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545129389,8517646,NULL,NULL,NULL,NULL),(5698,4335,0,'LSQ12gjv','LSQ',55.64575,-31.3631944444444,NULL,NULL,'2012-11-21 05:02:06',56252.2097999998,20.6048,0.1935,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjv/LSQ12gjv_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjv/LSQ12gjv_snap_74841.gif',38585895204,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602904612,9420384,NULL,NULL,NULL,NULL),(5699,4340,0,'LSQ12gju','LSQ',11.94975,-34.6518055555556,NULL,NULL,'2012-11-21 03:40:25',56252.15307,19.127,0.1385,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gju/LSQ12gju_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gju/LSQ12gju_snap_74758.gif',34865347578,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,544771055,8512047,NULL,NULL,NULL,NULL),(5700,4343,0,'LSQ12gjt','LSQ',6.90504166666667,-30.5745833333333,NULL,NULL,'2012-11-21 01:10:17',56252.0488100001,20.1939,0.1478,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjt/LSQ12gjt_history.html','sne?',NULL,0.114853,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjt/LSQ12gjt_snap_74840.gif',34857031270,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,544641113,8510017,NULL,NULL,NULL,NULL),(5701,5246,0,'LSQ12gln','LSQ',80.7475416666667,-33.4642222222222,NULL,NULL,'2012-11-21 05:18:59',56252.2215200001,18.6227,0.0518,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_74951.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(5702,5246,0,'LSQ12gln','LSQ',80.7475416666667,-33.4642222222222,NULL,NULL,'2012-11-21 07:36:54',56252.3173000002,18.4908,0.0438,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_74952.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(5703,5249,0,'LSQ12glk','LSQ',19.581625,-38.36025,NULL,NULL,'2012-11-21 01:56:05',56252.0806200001,20.0565,0.1207,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_74863.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5704,5249,0,'LSQ12glk','LSQ',19.581625,-38.3601666666667,NULL,NULL,'2012-11-21 01:57:48',56252.0818099999,20.1846,0.1052,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_74861.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5705,5249,0,'LSQ12glk','LSQ',19.5817083333333,-38.3602777777778,NULL,NULL,'2012-11-21 03:57:24',56252.16487,20.1507,0.1568,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_74864.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5706,5249,0,'LSQ12glk','LSQ',19.5815833333333,-38.3602222222222,NULL,NULL,'2012-11-21 03:59:05',56252.16604,20.4138,0.1768,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_74862.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5707,5387,0,'LSQ12gmi','LSQ',7.83633333333333,-38.5853333333333,NULL,NULL,'2012-11-21 01:28:54',56252.0617399998,19.6517,0.1341,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_history.html','Unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_snap_74964.gif',34688565688,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,542008838,8468888,NULL,NULL,NULL,NULL),(5708,5397,0,'LSQ12gne','LSQ',14.520875,-25.5833611111111,NULL,NULL,'2012-11-21 01:32:21',56252.0641399999,19.9157,0.1319,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_snap_74967.gif',34713622310,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542400348,8475005,NULL,NULL,NULL,NULL),(5709,5539,0,'LSQ12gpb','LSQ',20.3197083333333,-22.3258333333333,NULL,NULL,'2012-11-21 01:59:32',56252.0830100002,19.8695,0.162,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpb/LSQ12gpb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpb/LSQ12gpb_snap_75012.gif',35223189339,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,550362333,8599411,NULL,NULL,NULL,NULL),(5710,5550,0,'LSQ12goy','LSQ',68.883375,-26.4606944444444,NULL,NULL,'2012-11-21 05:27:34',56252.2274799999,20.0839,0.1332,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_74991.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(5711,5550,0,'LSQ12goy','LSQ',68.883375,-26.4606666666667,NULL,NULL,'2012-11-21 07:02:51',56252.2936499999,19.8743,0.1061,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_74992.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(5712,5557,0,'LSQ12gow','LSQ',48.1342916666667,-28.9632777777778,NULL,NULL,'2012-11-21 04:26:22',56252.1849799999,19.1252,0.1246,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_74995.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(5713,5568,0,'LSQ12gnu','LSQ',19.5157916666667,-36.6121111111111,NULL,NULL,'2012-11-21 01:56:05',56252.0806200001,20.6622,0.1299,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_history.html','sn - nice',NULL,0.073214,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_snap_74990.gif',38275123499,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598048804,9344512,NULL,NULL,NULL,NULL),(5714,5579,0,'LSQ12gno','LSQ',3.628125,-35.4191111111111,NULL,NULL,'2012-11-21 01:17:03',56252.05351,19.5346,0.1838,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 12:46:14','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gno/LSQ12gno_history.html','sn - nice',NULL,0.0883,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gno/LSQ12gno_snap_74987.gif',34676126738,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,541814480,8465851,NULL,NULL,NULL,NULL),(5715,2985,0,'LSQ12fsh','LSQ',12.776625,-39.1600555555556,NULL,NULL,'2012-11-23 01:37:48',56254.0679199998,19.1624,0.0994,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_75412.gif',38166915083,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(5716,2985,0,'LSQ12fsh','LSQ',12.77675,-39.1600555555556,NULL,NULL,'2012-11-23 03:38:15',56254.1515700002,19.1996,0.0987,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsh/LSQ12fsh_snap_75413.gif',38166915082,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,596358048,9318094,NULL,NULL,NULL,NULL),(5717,2987,0,'LSQ12fsj','LSQ',73.7292916666667,-36.325,NULL,NULL,'2012-11-23 02:49:14',56254.1175299999,16.4226,0.0071,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsj/LSQ12fsj_snap_75399.gif',37816670598,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590885478,9232585,NULL,NULL,NULL,NULL),(5718,2993,0,'LSQ12fss','LSQ',18.71575,-30.0939166666667,NULL,NULL,'2012-11-23 01:49:41',56254.0761699998,19.3768,0.1163,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_75382.gif',34734808837,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(5719,2993,0,'LSQ12fss','LSQ',18.7158333333333,-30.0939722222222,NULL,NULL,'2012-11-23 03:50:15',56254.1598999999,19.5169,0.1112,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_history.html','sn-nice',NULL,0.0824,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fss/LSQ12fss_snap_75383.gif',34734808837,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542731388,8480177,NULL,NULL,NULL,NULL),(5720,2999,0,'LSQ12fsn','LSQ',10.6064166666667,-34.09725,NULL,NULL,'2012-11-23 01:22:28',56254.0572700002,15.5133,0.0069,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_history.html','Unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_snap_75343.gif',34872861140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544888455,8513882,NULL,NULL,NULL,NULL),(5721,2999,0,'LSQ12fsn','LSQ',10.6064166666667,-34.0972777777778,NULL,NULL,'2012-11-23 03:22:14',56254.1404499998,15.304,0.0063,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_history.html','Unusual',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsn/LSQ12fsn_snap_75344.gif',34872861140,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544888455,8513882,NULL,NULL,NULL,NULL),(5722,3001,0,'LSQ12fth','LSQ',47.8227916666667,-25.1096111111111,NULL,NULL,'2012-11-23 02:16:59',56254.0951299998,18.0427,0.0431,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_75314.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(5723,3001,0,'LSQ12fth','LSQ',47.822625,-25.1096944444444,NULL,NULL,'2012-11-23 02:18:43',56254.0963400002,18.2912,0.0449,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_75316.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(5724,3001,0,'LSQ12fth','LSQ',47.82275,-25.1096388888889,NULL,NULL,'2012-11-23 04:17:31',56254.1788400002,17.8663,0.0397,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_75315.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(5725,3001,0,'LSQ12fth','LSQ',47.8225416666667,-25.1097777777778,NULL,NULL,'2012-11-23 04:19:12',56254.1800099998,18.4861,0.0436,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fth/LSQ12fth_snap_75317.gif',38018766862,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594043232,9281925,NULL,NULL,NULL,NULL),(5726,3007,0,'LSQ12fte','LSQ',52.152875,-24.8717222222222,NULL,NULL,'2012-11-23 02:30:34',56254.10457,19.9288,0.175,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_snap_75403.gif',38021943870,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594092872,9282701,NULL,NULL,NULL,NULL),(5727,3007,0,'LSQ12fte','LSQ',52.1527083333333,-24.8718055555556,NULL,NULL,'2012-11-23 04:31:03',56254.18823,19.4842,0.0991,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_history.html','Past peak',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fte/LSQ12fte_snap_75404.gif',38021943870,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594092872,9282701,NULL,NULL,NULL,NULL),(5728,3009,0,'LSQ12ftd','LSQ',64.2445833333333,-24.1449444444444,NULL,NULL,'2012-11-23 05:42:57',56254.2381699998,20.0877,0.2134,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_75311.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(5729,3009,0,'LSQ12ftd','LSQ',64.2445,-24.14475,NULL,NULL,'2012-11-23 07:21:13',56254.3064100002,20.3484,0.1507,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftd/LSQ12ftd_snap_75312.gif',37178445164,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580913205,9076768,NULL,NULL,NULL,NULL),(5730,3013,0,'LSQ12ftc','LSQ',64.8027916666667,-24.3551388888889,NULL,NULL,'2012-11-23 05:42:57',56254.2381699998,19.6535,0.1537,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_75406.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(5731,3013,0,'LSQ12ftc','LSQ',64.8029166666667,-24.3551388888889,NULL,NULL,'2012-11-23 07:21:13',56254.3064100002,20.0546,0.1326,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_75407.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(5732,3013,0,'LSQ12ftc','LSQ',64.8029583333333,-24.3552777777778,NULL,NULL,'2012-11-23 07:22:54',56254.3075799998,20.4486,0.1501,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftc/LSQ12ftc_snap_75405.gif',37179083500,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580923179,9076924,NULL,NULL,NULL,NULL),(5733,3017,0,'LSQ12ftb','LSQ',65.422,-23.7052222222222,NULL,NULL,'2012-11-23 05:42:57',56254.2381699998,18.7702,0.069,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_75378.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(5734,3017,0,'LSQ12ftb','LSQ',65.422,-23.7052222222222,NULL,NULL,'2012-11-23 07:21:13',56254.3064100002,18.8717,0.079,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_75379.gif',37314276019,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(5735,3017,0,'LSQ12ftb','LSQ',65.4214583333333,-23.7053333333333,NULL,NULL,'2012-11-23 07:22:54',56254.3075799998,18.3937,0.0537,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_history.html','sn-nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ftb/LSQ12ftb_snap_75377.gif',37314276031,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583035562,9109930,NULL,NULL,NULL,NULL),(5736,3106,0,'LSQ12fsw','LSQ',74.1659583333333,-30.1308888888889,NULL,NULL,'2012-11-23 05:25:33',56254.2260799999,18.1428,0.0751,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fsw/LSQ12fsw_snap_75345.gif',37203066251,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,581297910,9082779,NULL,NULL,NULL,NULL),(5737,3112,0,'LSQ12fvu','LSQ',53.5190416666667,-21.8744722222222,NULL,NULL,'2012-11-23 02:32:16',56254.1057500001,19.1771,0.0845,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_75386.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(5738,3112,0,'LSQ12fvu','LSQ',53.5190833333333,-21.8744444444444,NULL,NULL,'2012-11-23 04:32:44',56254.1894,19.4054,0.0863,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_75387.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(5739,3114,0,'LSQ12fvq','LSQ',19.1507916666667,-31.4520555555556,NULL,NULL,'2012-11-23 01:48:00',56254.0750000002,18.566,0.0536,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_75366.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(5740,3114,0,'LSQ12fvq','LSQ',19.1507083333333,-31.4520833333333,NULL,NULL,'2012-11-23 01:49:41',56254.0761699998,18.6522,0.05,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_75364.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(5741,3114,0,'LSQ12fvq','LSQ',19.1506666666667,-31.4520833333333,NULL,NULL,'2012-11-23 03:50:15',56254.1598999999,18.5924,0.0455,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_75365.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(5742,3118,0,'LSQ12fvp','LSQ',10.710125,-34.1603055555556,NULL,NULL,'2012-11-23 01:22:28',56254.0572700002,17.4263,0.0309,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_75258.gif',34872963970,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(5743,3118,0,'LSQ12fvp','LSQ',10.7100833333333,-34.1603333333333,NULL,NULL,'2012-11-23 03:22:14',56254.1404499998,17.2444,0.0277,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvp/LSQ12fvp_snap_75259.gif',34872963970,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,544890062,8513907,NULL,NULL,NULL,NULL),(5744,3122,0,'LSQ12fvn','LSQ',16.3918333333333,-35.4907222222222,NULL,NULL,'2012-11-23 01:39:29',56254.0690899999,20.1903,0.1084,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_75367.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(5745,3122,0,'LSQ12fvn','LSQ',16.3919583333333,-35.49075,NULL,NULL,'2012-11-23 03:39:56',56254.1527399998,20.1982,0.1035,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvn/LSQ12fvn_snap_75368.gif',38269278617,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597957478,9343085,NULL,NULL,NULL,NULL),(5746,3125,0,'LSQ12fvl','LSQ',75.2084583333333,-38.6531388888889,NULL,NULL,'2012-11-23 02:49:14',56254.1175299999,19.0654,0.1054,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_75385.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(5749,3245,0,'LSQ12fwz','LSQ',21.2805416666667,-26.1291388888889,NULL,NULL,'2012-11-23 01:59:57',56254.0833000001,19.0459,0.1479,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_75267.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(5750,3245,0,'LSQ12fwz','LSQ',21.2805,-26.1290833333333,NULL,NULL,'2012-11-23 04:00:26',56254.1669700001,18.9647,0.1057,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_75268.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(5751,3249,0,'LSQ12fww','LSQ',62.5344166666667,-34.1649444444444,NULL,NULL,'2012-11-23 02:57:51',56254.1235099998,18.858,0.0555,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_75240.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(5752,3249,0,'LSQ12fww','LSQ',62.5344166666667,-34.1649444444444,NULL,NULL,'2012-11-23 04:58:16',56254.2071400001,18.7841,0.0477,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_75241.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(5753,3284,0,'LSQ12fxk','LSQ',57.9454583333333,-22.1759166666667,NULL,NULL,'2012-11-23 05:36:11',56254.2334699999,19.1383,0.162,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_snap_75274.gif',37996998851,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593703107,9276611,NULL,NULL,NULL,NULL),(5754,3287,0,'LSQ12fxc','LSQ',47.8157916666667,-22.4541944444444,NULL,NULL,'2012-11-23 02:16:59',56254.0951299998,19.454,0.1428,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_75270.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(5755,3481,0,'LSQ12fzc','LSQ',43.0447083333333,-35.9738888888889,NULL,NULL,'2012-11-23 02:06:48',56254.08806,19.0586,0.1569,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_75234.gif',38652782971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(5756,3481,0,'LSQ12fzc','LSQ',43.04475,-35.9737777777778,NULL,NULL,'2012-11-23 04:07:22',56254.1717900001,18.9001,0.1503,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_75235.gif',38652782971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(5757,3485,0,'LSQ12gbj','LSQ',66.0475416666667,-25.415,NULL,NULL,'2012-11-23 07:22:54',56254.3075799998,19.2928,0.0808,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_snap_75239.gif',37181674216,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,580963659,9077557,NULL,NULL,NULL,NULL),(5758,3507,0,'LSQ12gas','LSQ',79.68025,-24.4506388888889,NULL,NULL,'2012-11-23 05:53:09',56254.2452500002,20.0809,0.1446,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gas/LSQ12gas_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gas/LSQ12gas_snap_75269.gif',37130798396,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,580168724,9065136,NULL,NULL,NULL,NULL),(5759,3514,0,'LSQ12gaq','LSQ',65.3839166666667,-25.3801388888889,NULL,NULL,'2012-11-23 05:42:57',56254.2381699998,20.2624,0.1726,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_snap_75286.gif',37182103829,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580970372,9077662,NULL,NULL,NULL,NULL),(5760,3530,0,'LSQ12gad','LSQ',52.3020833333333,-30.6229444444444,NULL,NULL,'2012-11-23 02:28:53',56254.1033999999,19.3707,0.1241,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_75409.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(5761,3530,0,'LSQ12gad','LSQ',52.302125,-30.6228888888889,NULL,NULL,'2012-11-23 04:29:21',56254.1870599999,18.6865,0.0805,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_75410.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(5762,3537,0,'LSQ12gab','LSQ',81.8936666666667,-31.3135,NULL,NULL,'2012-11-23 05:13:33',56254.2177499998,18.4545,0.0878,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_snap_75262.gif',37311362015,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,582990031,9109219,NULL,NULL,NULL,NULL),(5763,3537,0,'LSQ12gab','LSQ',81.8940416666667,-31.3133333333333,NULL,NULL,'2012-11-23 06:55:37',56254.2886299998,19.7378,0.0839,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_snap_75263.gif',37311362015,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,582990031,9109219,NULL,NULL,NULL,NULL),(5764,3540,0,'LSQ12fzz','LSQ',81.4934166666667,-34.4575277777778,NULL,NULL,'2012-11-23 05:13:33',56254.2177499998,19.6149,0.1349,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_75260.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(5765,3540,0,'LSQ12fzz','LSQ',81.4933333333333,-34.4576666666667,NULL,NULL,'2012-11-23 06:55:37',56254.2886299998,19.8517,0.1099,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_75261.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(5766,3548,0,'LSQ12fzu','LSQ',74.8830833333333,-38.4094444444444,NULL,NULL,'2012-11-23 02:47:32',56254.1163499998,20.1459,0.1798,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-11-23 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_75264.gif',37599816286,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(5767,3893,0,'LSQ12gfs','LSQ',55.309375,-26.7209166666667,NULL,NULL,'2012-11-23 01:03:02',56254.0437799999,20.4199,0.1579,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_snap_75297.gif',38579773067,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602808954,9418889,NULL,NULL,NULL,NULL),(5768,3818,0,'LSQ12gdc','LSQ',74.1527916666667,-31.6034166666667,NULL,NULL,'2012-11-23 05:08:26',56254.2141999998,17.3384,0.0556,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_75309.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(5769,3818,0,'LSQ12gdc','LSQ',74.1528333333333,-31.6034166666667,NULL,NULL,'2012-11-23 07:36:33',56254.3170599998,17.2565,0.044,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_75310.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(5770,3821,0,'LSQ12gcw','LSQ',68.3187916666667,-38.1012222222222,NULL,NULL,'2012-11-23 02:44:11',56254.1140200002,19.2242,0.1304,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_75354.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(5771,3821,0,'LSQ12gcw','LSQ',68.3187916666667,-38.1014166666667,NULL,NULL,'2012-11-23 04:44:36',56254.1976399999,19.0631,0.1059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_75355.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(5772,3864,0,'LSQ12gel','LSQ',55.75075,-26.6941666666667,NULL,NULL,'2012-11-23 03:06:18',56254.1293799998,20.3202,0.2124,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_snap_75293.gif',38528356173,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602005565,9406336,NULL,NULL,NULL,NULL),(5773,4056,0,'LSQ12ghe','LSQ',68.5489583333333,-23.0559444444444,NULL,NULL,'2012-11-23 05:44:41',56254.2393700001,19.4483,0.0893,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_75352.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(5774,4056,0,'LSQ12ghe','LSQ',68.549,-23.0559722222222,NULL,NULL,'2012-11-23 07:11:03',56254.29935,19.4765,0.0758,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_75353.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(5775,4061,0,'LSQ12ggx','LSQ',47.8960833333333,-22.3203888888889,NULL,NULL,'2012-11-23 02:18:43',56254.0963400002,19.7326,0.153,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_75418.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(5776,4061,0,'LSQ12ggx','LSQ',47.8960833333333,-22.3203611111111,NULL,NULL,'2012-11-23 04:19:12',56254.1800099998,19.5619,0.1516,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_75419.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(5777,4067,0,'LSQ12ggq','LSQ',69.4289583333333,-35.8658333333333,NULL,NULL,'2012-11-23 02:44:11',56254.1140200002,19.3145,0.0759,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_75395.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(5778,4118,0,'LSQ12ghd','LSQ',71.865,-21.3294166666667,NULL,NULL,'2012-11-23 05:44:41',56254.2393700001,19.1953,0.0862,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_75380.gif',37342671080,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479235,9116863,NULL,NULL,NULL,NULL),(5779,4118,0,'LSQ12ghd','LSQ',71.8650416666667,-21.3294166666667,NULL,NULL,'2012-11-23 07:11:03',56254.29935,20.1482,0.1023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_75381.gif',37342671080,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479235,9116863,NULL,NULL,NULL,NULL),(5780,4120,0,'LSQ12ghc','LSQ',66.2228333333333,-21.2026944444444,NULL,NULL,'2012-11-23 07:22:54',56254.3075799998,17.5152,0.0298,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_75349.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(5781,4156,0,'LSQ12ggn','LSQ',58.0249583333333,-39.0652777777778,NULL,NULL,'2012-11-23 02:35:43',56254.1081400001,17.6694,0.0396,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_75338.gif',37665320689,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(5782,4156,0,'LSQ12ggn','LSQ',58.0249583333333,-39.0653055555556,NULL,NULL,'2012-11-23 04:36:08',56254.1917599998,17.6719,0.0398,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_75339.gif',37665320689,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(5783,4317,0,'LSQ12gkk','LSQ',76.869,-23.8545833333333,NULL,NULL,'2012-11-23 05:51:27',56254.24407,19.4423,0.0768,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_75249.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(5784,4317,0,'LSQ12gkk','LSQ',76.8690416666667,-23.8545833333333,NULL,NULL,'2012-11-23 07:14:26',56254.3016900001,19.8079,0.0737,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_75250.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(5785,4320,0,'LSQ12gki','LSQ',17.6024166666667,-22.4758333333333,NULL,NULL,'2012-11-23 01:42:55',56254.0714799999,19.3809,0.1363,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_snap_75318.gif',35214805816,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,550231340,8597364,NULL,NULL,NULL,NULL),(5786,4320,0,'LSQ12gki','LSQ',17.602375,-22.4758055555556,NULL,NULL,'2012-11-23 03:43:26',56254.1551700002,19.1139,0.1134,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gki/LSQ12gki_snap_75319.gif',35214805816,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,550231340,8597364,NULL,NULL,NULL,NULL),(5787,4331,0,'LSQ12gka','LSQ',16.3234166666667,-26.7014722222222,NULL,NULL,'2012-11-23 01:44:36',56254.07265,19.2962,0.1498,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_snap_75225.gif',34725499594,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542585931,8477905,NULL,NULL,NULL,NULL),(5788,4331,0,'LSQ12gka','LSQ',16.323375,-26.7014444444444,NULL,NULL,'2012-11-23 03:45:10',56254.15637,19.0146,0.1233,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gka/LSQ12gka_snap_75226.gif',34725499594,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542585931,8477905,NULL,NULL,NULL,NULL),(5789,4333,0,'LSQ12gjz','LSQ',7.02670833333333,-29.0968055555556,NULL,NULL,'2012-11-23 03:17:09',56254.13692,20.0382,0.1526,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjz/LSQ12gjz_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjz/LSQ12gjz_snap_75329.gif',34888280957,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545129389,8517646,NULL,NULL,NULL,NULL),(5790,5246,0,'LSQ12gln','LSQ',80.7475,-33.4642222222222,NULL,NULL,'2012-11-23 05:13:33',56254.2177499998,18.2262,0.0498,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_75414.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(5791,5246,0,'LSQ12gln','LSQ',80.7475833333333,-33.4642222222222,NULL,NULL,'2012-11-23 06:55:37',56254.2886299998,18.4457,0.0392,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_75415.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(5792,5249,0,'LSQ12glk','LSQ',19.5817083333333,-38.3602777777778,NULL,NULL,'2012-11-23 01:51:23',56254.0773499999,20.2889,0.2123,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_75333.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5793,5249,0,'LSQ12glk','LSQ',19.581625,-38.3601944444444,NULL,NULL,'2012-11-23 01:53:04',56254.07852,20.7829,0.1725,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_75331.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5794,5249,0,'LSQ12glk','LSQ',19.5815833333333,-38.3602222222222,NULL,NULL,'2012-11-23 03:51:55',56254.1610599998,19.836,0.1508,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_75334.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5795,5249,0,'LSQ12glk','LSQ',19.5815416666667,-38.36025,NULL,NULL,'2012-11-23 03:53:36',56254.1622299999,20.1816,0.1421,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_75332.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5796,5387,0,'LSQ12gmi','LSQ',7.836375,-38.5853055555556,NULL,NULL,'2012-11-23 03:23:56',56254.14163,19.8836,0.2083,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_history.html','Unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gmi/LSQ12gmi_snap_75426.gif',34688565688,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,542008838,8468888,NULL,NULL,NULL,NULL),(5797,5397,0,'LSQ12gne','LSQ',14.5205833333333,-25.58325,NULL,NULL,'2012-11-23 01:27:35',56254.0608299999,19.4579,0.1246,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gne/LSQ12gne_snap_75437.gif',34713622310,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542400348,8475005,NULL,NULL,NULL,NULL),(5798,5550,0,'LSQ12goy','LSQ',68.8834166666667,-26.46075,NULL,NULL,'2012-11-23 05:22:10',56254.2237300002,19.5484,0.1161,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_75466.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(5799,5550,0,'LSQ12goy','LSQ',68.8834583333333,-26.4606666666667,NULL,NULL,'2012-11-23 07:27:59',56254.3111,19.7841,0.1133,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_75467.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(5800,5557,0,'LSQ12gow','LSQ',48.13375,-28.9632222222222,NULL,NULL,'2012-11-23 02:20:24',56254.0975100002,19.1341,0.1081,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_75462.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(5801,5557,0,'LSQ12gow','LSQ',48.1340416666667,-28.9633055555556,NULL,NULL,'2012-11-23 04:20:53',56254.1811799998,19.0153,0.1356,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_75463.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(5802,5568,0,'LSQ12gnu','LSQ',19.5156666666667,-36.6120277777778,NULL,NULL,'2012-11-23 01:51:23',56254.0773499999,20.1837,0.1731,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_history.html','sn - nice',NULL,0.073214,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_snap_75449.gif',38275123499,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598048804,9344512,NULL,NULL,NULL,NULL),(5803,5568,0,'LSQ12gnu','LSQ',19.5158333333333,-36.6120277777778,NULL,NULL,'2012-11-23 03:51:55',56254.1610599998,20.6251,0.1435,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_history.html','sn - nice',NULL,0.073214,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_snap_75450.gif',38275123499,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598048804,9344512,NULL,NULL,NULL,NULL),(5804,5579,0,'LSQ12gno','LSQ',3.62820833333333,-35.4190277777778,NULL,NULL,'2012-11-23 01:12:07',56254.05009,19.5519,0.1361,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gno/LSQ12gno_history.html','sn - nice',NULL,0.0883,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gno/LSQ12gno_snap_75451.gif',34676126738,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,541814480,8465851,NULL,NULL,NULL,NULL),(5805,5579,0,'LSQ12gno','LSQ',3.62825,-35.4190555555556,NULL,NULL,'2012-11-23 03:11:59',56254.1333300001,19.4062,0.1682,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 13:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gno/LSQ12gno_history.html','sn - nice',NULL,0.0883,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gno/LSQ12gno_snap_75452.gif',34676126738,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,541814480,8465851,NULL,NULL,NULL,NULL),(5806,5597,0,'LSQ12gqn','LSQ',18.5311666666667,-32.6523888888889,NULL,NULL,'2012-11-17 02:03:38',56248.08586,20.0531,0.1292,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 16:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqn/LSQ12gqn_history.html','sn - nice',NULL,0.011952,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqn/LSQ12gqn_snap_75551.gif',38278292957,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598098327,9345286,NULL,NULL,NULL,NULL),(5807,5597,0,'LSQ12gqn','LSQ',18.5312916666667,-32.6523055555556,NULL,NULL,'2012-11-17 04:03:23',56248.1690199999,20.2789,0.14,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 16:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqn/LSQ12gqn_history.html','sn - nice',NULL,0.011952,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqn/LSQ12gqn_snap_75552.gif',38278292957,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598098327,9345286,NULL,NULL,NULL,NULL),(5808,5597,0,'LSQ12gqn','LSQ',18.5306666666667,-32.6520277777778,NULL,NULL,'2012-11-19 03:56:45',56250.1644100002,18.8111,0.0452,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 16:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqn/LSQ12gqn_history.html','sn - nice',NULL,0.011952,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqn/LSQ12gqn_snap_75553.gif',38278292957,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598098327,9345286,NULL,NULL,NULL,NULL),(5809,5597,0,'LSQ12gqn','LSQ',18.5306666666667,-32.6520277777778,NULL,NULL,'2012-11-21 01:52:43',56252.07828,17.5366,0.0171,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 16:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqn/LSQ12gqn_history.html','sn - nice',NULL,0.011952,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqn/LSQ12gqn_snap_75499.gif',38278292957,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598098327,9345286,NULL,NULL,NULL,NULL),(5810,5597,0,'LSQ12gqn','LSQ',18.53075,-32.6520555555556,NULL,NULL,'2012-11-21 03:54:00',56252.1625100002,17.7296,0.025,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 16:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqn/LSQ12gqn_history.html','sn - nice',NULL,0.011952,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqn/LSQ12gqn_snap_75500.gif',38278292957,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598098327,9345286,NULL,NULL,NULL,NULL),(5811,5597,0,'LSQ12gqn','LSQ',18.5307083333333,-32.6520555555556,NULL,NULL,'2012-11-23 01:48:00',56254.0750000002,16.9101,0.0102,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 16:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqn/LSQ12gqn_history.html','sn - nice',NULL,0.011952,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqn/LSQ12gqn_snap_75572.gif',38278292957,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598098327,9345286,NULL,NULL,NULL,NULL),(5812,5597,0,'LSQ12gqn','LSQ',18.5306666666667,-32.6520277777778,NULL,NULL,'2012-11-23 03:48:31',56254.1587,16.93,0.0114,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 16:46:18','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqn/LSQ12gqn_history.html','sn - nice',NULL,0.011952,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqn/LSQ12gqn_snap_75573.gif',38278292957,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598098327,9345286,NULL,NULL,NULL,NULL),(5813,5813,1,'LSQ12gpw','LSQ',48.2427083333333,-11.7111111111111,NULL,NULL,'2012-11-20 02:05:58',56251.0874800002,18.2341,0.1181,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 16:46:18','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_75153.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(5814,5813,0,'LSQ12gpw','LSQ',48.2426666666667,-11.7111111111111,NULL,NULL,'2012-11-22 01:57:45',56253.0817800001,17.8376,0.0949,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 16:46:18','2012-12-06 23:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_75049.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(5815,5813,0,'LSQ12gpw','LSQ',48.2426666666667,-11.7111666666667,NULL,NULL,'2012-11-22 03:57:11',56253.1647199998,17.8289,0.0612,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 16:46:18','2012-12-06 23:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_75050.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(5816,5816,1,'LSQ12grj','LSQ',58.062,-22.1815833333333,NULL,NULL,'2012-11-05 06:07:16',56236.2550499998,17.8382,0.0913,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_history.html','sn?',NULL,0.061819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_snap_75713.gif',37996988353,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593702943,9276608,NULL,NULL,NULL,NULL),(5817,5816,0,'LSQ12grj','LSQ',58.0620833333333,-22.1815833333333,NULL,NULL,'2012-11-09 06:14:35',56240.2601299998,19.6478,0.1002,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_history.html','sn?',NULL,0.061819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_snap_75714.gif',37996988353,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593702943,9276608,NULL,NULL,NULL,NULL),(5818,5816,0,'LSQ12grj','LSQ',58.0620833333333,-22.1815277777778,NULL,NULL,'2012-11-15 07:32:25',56246.3141800002,19.6623,0.1774,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_history.html','sn?',NULL,0.061819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_snap_75715.gif',37996988353,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593702943,9276608,NULL,NULL,NULL,NULL),(5819,5816,0,'LSQ12grj','LSQ',58.0620416666667,-22.1815,NULL,NULL,'2012-11-19 07:28:06',56250.3111899998,19.7628,0.2128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_history.html','sn?',NULL,0.061819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_snap_75716.gif',37996988353,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593702943,9276608,NULL,NULL,NULL,NULL),(5820,5816,0,'LSQ12grj','LSQ',58.062125,-22.1814166666667,NULL,NULL,'2012-11-21 05:39:28',56252.23575,18.8904,0.0931,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_history.html','sn?',NULL,0.061819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_snap_75615.gif',37996988353,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593702943,9276608,NULL,NULL,NULL,NULL),(5821,5816,0,'LSQ12grj','LSQ',58.0620416666667,-22.1815277777778,NULL,NULL,'2012-11-21 07:26:35',56252.3101300001,19.8532,0.1427,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_history.html','sn?',NULL,0.061819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_snap_75616.gif',37996988353,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593702943,9276608,NULL,NULL,NULL,NULL),(5822,5816,0,'LSQ12grj','LSQ',58.062125,-22.1815555555556,NULL,NULL,'2012-11-23 05:36:11',56254.2334699999,18.4201,0.1229,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_history.html','sn?',NULL,0.061819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_snap_75896.gif',37996988353,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593702943,9276608,NULL,NULL,NULL,NULL),(5823,5823,1,'LSQ12grh','LSQ',48.0765416666667,-24.5530555555556,NULL,NULL,'2012-11-19 04:27:27',56250.18573,19.8383,0.1284,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_75712.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(5824,5823,0,'LSQ12grh','LSQ',48.0765833333333,-24.5529722222222,NULL,NULL,'2012-11-21 02:23:21',56252.0995499999,18.5766,0.0516,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_75611.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(5825,5823,0,'LSQ12grh','LSQ',48.076625,-24.5529444444444,NULL,NULL,'2012-11-21 04:24:40',56252.1838000002,18.4975,0.0435,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_75612.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(5826,5823,0,'LSQ12grh','LSQ',48.0765833333333,-24.5529722222222,NULL,NULL,'2012-11-23 02:18:43',56254.0963400002,18.5531,0.0529,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_75897.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(5827,5823,0,'LSQ12grh','LSQ',48.076625,-24.5529722222222,NULL,NULL,'2012-11-23 04:19:12',56254.1800099998,18.4873,0.0554,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_75898.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(5828,5828,1,'LSQ12grc','LSQ',72.818875,-29.83775,NULL,NULL,'2012-11-03 05:30:40',56234.22963,17.8521,0.0488,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grc/LSQ12grc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grc/LSQ12grc_snap_75685.gif',37200375387,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581255865,9082122,NULL,NULL,NULL,NULL),(5829,5828,0,'LSQ12grc','LSQ',72.8189583333333,-29.8376944444444,NULL,NULL,'2012-11-21 05:32:38',56252.2310000001,18.0401,0.0623,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-11-23 17:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grc/LSQ12grc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grc/LSQ12grc_snap_75601.gif',37200375387,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581255865,9082122,NULL,NULL,NULL,NULL),(5830,5828,0,'LSQ12grc','LSQ',72.8189166666667,-29.8376944444444,NULL,NULL,'2012-11-21 07:30:04',56252.3125499999,17.9887,0.0604,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-11-23 17:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grc/LSQ12grc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grc/LSQ12grc_snap_75602.gif',37200375387,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581255865,9082122,NULL,NULL,NULL,NULL),(5831,5831,1,'LSQ12gra','LSQ',51.126,-28.2918055555556,NULL,NULL,'2012-11-17 02:37:41',56248.1095099999,20.4282,0.2069,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_75679.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(5832,5831,0,'LSQ12gra','LSQ',51.1259166666667,-28.2917777777778,NULL,NULL,'2012-11-17 04:37:25',56248.1926600002,20.0839,0.1614,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_75680.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(5833,5831,0,'LSQ12gra','LSQ',51.126125,-28.2918333333333,NULL,NULL,'2012-11-19 02:30:52',56250.1047800002,19.3365,0.1306,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_75681.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(5834,5831,0,'LSQ12gra','LSQ',51.1259166666667,-28.2918055555556,NULL,NULL,'2012-11-19 04:30:49',56250.1880700001,19.7211,0.1194,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_75682.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(5835,5831,0,'LSQ12gra','LSQ',51.126,-28.2917777777778,NULL,NULL,'2012-11-21 02:26:43',56252.10189,19.4931,0.1115,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_75597.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(5836,5831,0,'LSQ12gra','LSQ',51.126,-28.2918055555556,NULL,NULL,'2012-11-21 04:28:04',56252.18616,19.3632,0.1048,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_75598.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(5837,5831,0,'LSQ12gra','LSQ',51.1260833333333,-28.2918055555556,NULL,NULL,'2012-11-23 02:22:05',56254.0986799998,19.2206,0.0953,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_75893.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(5838,5831,0,'LSQ12gra','LSQ',51.126,-28.29175,NULL,NULL,'2012-11-23 04:22:35',56254.18236,19.2036,0.1307,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_75894.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(5839,5839,0,'LSQ12gqq','LSQ',18.8637916666667,-31.3977777777778,NULL,NULL,'2012-11-01 01:59:34',56232.0830399999,19.6401,0.0874,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2019-10-11 20:38:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_75621.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5840,5839,0,'LSQ12gqq','LSQ',18.8638333333333,-31.3977777777778,NULL,NULL,'2012-11-01 04:01:29',56232.1677000001,19.6631,0.0975,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_75622.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5841,5839,0,'LSQ12gqq','LSQ',18.8637083333333,-31.3978055555556,NULL,NULL,'2012-11-03 02:00:36',56234.0837599998,19.5866,0.0635,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_75623.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5842,5839,0,'LSQ12gqq','LSQ',18.8638333333333,-31.3977777777778,NULL,NULL,'2012-11-03 04:02:33',56234.1684400002,19.7299,0.0786,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_75624.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5843,5839,0,'LSQ12gqq','LSQ',18.864,-31.3978055555556,NULL,NULL,'2012-11-09 04:33:31',56240.18995,20.1658,0.0726,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_75625.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5844,5839,0,'LSQ12gqq','LSQ',18.8639166666667,-31.3978055555556,NULL,NULL,'2012-11-13 02:21:09',56244.09803,19.6555,0.0765,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_75626.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5845,5839,0,'LSQ12gqq','LSQ',18.8639166666667,-31.3976944444444,NULL,NULL,'2012-11-13 04:37:35',56244.1927700001,19.4946,0.0518,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_75627.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5846,5839,0,'LSQ12gqq','LSQ',18.863875,-31.39775,NULL,NULL,'2012-11-15 02:13:36',56246.0927800001,19.1811,0.0447,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_75628.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5847,5839,0,'LSQ12gqq','LSQ',18.8640416666667,-31.3978333333333,NULL,NULL,'2012-11-15 04:37:19',56246.1925900001,19.7192,0.0612,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_75629.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5848,5839,0,'LSQ12gqq','LSQ',18.8639583333333,-31.39775,NULL,NULL,'2012-11-17 02:05:20',56248.0870400001,19.4866,0.0521,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_75630.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5849,5839,0,'LSQ12gqq','LSQ',18.8639166666667,-31.3977777777778,NULL,NULL,'2012-11-17 04:05:05',56248.1702000001,19.4136,0.0472,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_75631.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5850,5839,0,'LSQ12gqq','LSQ',18.8638333333333,-31.3977777777778,NULL,NULL,'2012-11-19 01:58:20',56250.0821799999,19.0599,0.051,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_75632.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5851,5839,0,'LSQ12gqq','LSQ',18.863875,-31.39775,NULL,NULL,'2012-11-19 03:58:26',56250.1655899999,19.6306,0.0639,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_75633.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5852,5839,0,'LSQ12gqq','LSQ',18.8639166666667,-31.3977777777778,NULL,NULL,'2012-11-21 01:54:23',56252.07944,19.2705,0.0588,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_75577.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5853,5839,0,'LSQ12gqq','LSQ',18.863875,-31.39775,NULL,NULL,'2012-11-21 03:55:41',56252.1636800002,19.3539,0.09,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_75578.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5854,5839,0,'LSQ12gqq','LSQ',18.8638333333333,-31.39775,NULL,NULL,'2012-11-23 01:49:41',56254.0761699998,19.1723,0.0927,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_75900.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5855,5839,0,'LSQ12gqq','LSQ',18.863875,-31.3977777777778,NULL,NULL,'2012-11-23 03:50:15',56254.1598999999,19.3823,0.0749,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_75901.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5856,5856,1,'LSQ12gsh','LSQ',72.1755833333333,-30.9984722222222,NULL,NULL,'2012-11-09 05:33:23',56240.2315199999,18.4535,0.0501,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_75988.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(5857,5856,0,'LSQ12gsh','LSQ',72.1755,-30.9984166666667,NULL,NULL,'2012-11-11 08:00:55',56242.3339800001,18.5778,0.0761,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_75989.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(5858,5856,0,'LSQ12gsh','LSQ',72.17575,-30.9983055555556,NULL,NULL,'2012-11-15 05:47:13',56246.24113,18.0205,0.0854,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_75990.gif',37207941504,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581374086,9083970,NULL,NULL,NULL,NULL),(5859,5856,0,'LSQ12gsh','LSQ',72.1754166666667,-30.9983055555556,NULL,NULL,'2012-11-15 07:15:10',56246.3022099999,18.2747,0.064,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_75991.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(5860,5856,0,'LSQ12gsh','LSQ',72.175625,-30.9983055555556,NULL,NULL,'2012-11-17 05:20:24',56248.2225000001,18.1991,0.0569,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_75992.gif',37207941504,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581374086,9083970,NULL,NULL,NULL,NULL),(5861,5856,0,'LSQ12gsh','LSQ',72.1755833333333,-30.9982222222222,NULL,NULL,'2012-11-19 05:14:59',56250.2187399999,18.0306,0.0628,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_75993.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(5862,5856,0,'LSQ12gsh','LSQ',72.1755416666667,-30.9982777777778,NULL,NULL,'2012-11-19 07:41:47',56250.32069,18.1474,0.0471,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_75994.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(5863,5856,0,'LSQ12gsh','LSQ',72.1756666666667,-30.9983333333333,NULL,NULL,'2012-11-21 05:12:14',56252.2168399999,17.8637,0.0596,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_75995.gif',37207941504,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581374086,9083970,NULL,NULL,NULL,NULL),(5864,5856,0,'LSQ12gsh','LSQ',72.1755,-30.9983055555556,NULL,NULL,'2012-11-23 05:06:45',56254.2130300002,17.7632,0.0567,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_75921.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(5865,5856,0,'LSQ12gsh','LSQ',72.1754166666667,-30.9982777777778,NULL,NULL,'2012-11-23 06:53:54',56254.2874400001,18.3793,0.0425,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_75922.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(5866,5866,1,'LSQ12gsa','LSQ',19.124,-30.8897777777778,NULL,NULL,'2012-11-19 01:58:20',56250.0821799999,20.2565,0.0695,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_history.html','sn?',NULL,0.075,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_snap_75877.gif',34736605677,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,542759463,8480616,NULL,NULL,NULL,NULL),(5867,5866,0,'LSQ12gsa','LSQ',19.1239583333333,-30.8898055555556,NULL,NULL,'2012-11-19 03:58:26',56250.1655899999,20.3758,0.0946,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_history.html','sn?',NULL,0.075,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_snap_75878.gif',34736605677,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,542759463,8480616,NULL,NULL,NULL,NULL),(5868,5866,0,'LSQ12gsa','LSQ',19.1239583333333,-30.8898333333333,NULL,NULL,'2012-11-21 01:54:23',56252.07944,20.3289,0.1217,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_history.html','sn?',NULL,0.075,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_snap_75879.gif',34736605677,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,542759463,8480616,NULL,NULL,NULL,NULL),(5869,5866,0,'LSQ12gsa','LSQ',19.1240416666667,-30.8898333333333,NULL,NULL,'2012-11-21 03:55:41',56252.1636800002,20.0992,0.1071,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_history.html','sn?',NULL,0.075,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_snap_75880.gif',34736605677,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,542759463,8480616,NULL,NULL,NULL,NULL),(5870,5866,0,'LSQ12gsa','LSQ',19.123875,-30.8899166666667,NULL,NULL,'2012-11-23 01:49:41',56254.0761699998,19.3937,0.1131,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_history.html','sn?',NULL,0.075,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_snap_75753.gif',34736605677,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,542759463,8480616,NULL,NULL,NULL,NULL),(5871,5866,0,'LSQ12gsa','LSQ',19.1239166666667,-30.8898333333333,NULL,NULL,'2012-11-23 03:50:15',56254.1598999999,20.2806,0.1395,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_history.html','sn?',NULL,0.075,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_snap_75754.gif',34736605677,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,542759463,8480616,NULL,NULL,NULL,NULL),(5872,5872,1,'LSQ12grz','LSQ',15.6156666666667,-33.4921944444444,NULL,NULL,'2012-11-19 01:44:48',56250.07278,20.6378,0.1377,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grz/LSQ12grz_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grz/LSQ12grz_snap_75875.gif',34732917465,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542701835,8479716,NULL,NULL,NULL,NULL),(5873,5872,0,'LSQ12grz','LSQ',15.6153333333333,-33.4921666666667,NULL,NULL,'2012-11-19 03:44:49',56250.15613,19.8149,0.0864,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grz/LSQ12grz_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grz/LSQ12grz_snap_75876.gif',34732917465,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542701835,8479716,NULL,NULL,NULL,NULL),(5874,5872,0,'LSQ12grz','LSQ',15.6153333333333,-33.4923333333333,NULL,NULL,'2012-11-23 01:36:03',56254.0667099999,19.6247,0.0773,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grz/LSQ12grz_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grz/LSQ12grz_snap_75751.gif',34732917465,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542701835,8479716,NULL,NULL,NULL,NULL),(5875,5872,0,'LSQ12grz','LSQ',15.6152916666667,-33.4923055555556,NULL,NULL,'2012-11-23 03:36:35',56254.1504099998,18.9967,0.0474,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 17:46:22','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grz/LSQ12grz_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grz/LSQ12grz_snap_75752.gif',34732917465,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542701835,8479716,NULL,NULL,NULL,NULL),(5876,5876,1,'LSQ12gsv','LSQ',71.5319583333333,-25.26675,NULL,NULL,'2012-11-17 05:59:47',56248.2498499998,20.1222,0.1624,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 18:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_76090.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(5877,5876,0,'LSQ12gsv','LSQ',71.5319583333333,-25.26675,NULL,NULL,'2012-11-19 05:50:47',56250.2436000002,19.8113,0.1232,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 18:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_76091.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(5878,5876,0,'LSQ12gsv','LSQ',71.532,-25.2667777777778,NULL,NULL,'2012-11-19 07:14:34',56250.3017899999,19.6227,0.1375,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 18:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_76092.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(5879,5876,0,'LSQ12gsv','LSQ',71.5319166666667,-25.26675,NULL,NULL,'2012-11-21 05:47:55',56252.2416099999,19.6809,0.1121,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 18:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_76093.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(5880,5876,0,'LSQ12gsv','LSQ',71.532,-25.2667777777778,NULL,NULL,'2012-11-21 07:13:05',56252.30076,19.3573,0.0914,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 18:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_76094.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(5881,5876,0,'LSQ12gsv','LSQ',71.532,-25.2667777777778,NULL,NULL,'2012-11-23 05:44:41',56254.2393700001,19.6,0.1598,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 18:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_75949.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(5882,5876,0,'LSQ12gsv','LSQ',71.5319583333333,-25.2666944444444,NULL,NULL,'2012-11-23 07:11:03',56254.29935,19.2311,0.1027,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 18:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_75950.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(5883,5883,1,'LSQ12gsr','LSQ',12.224375,-25.0203888888889,NULL,NULL,'2012-11-03 01:40:17',56234.06965,20.4196,0.1941,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 18:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsr/LSQ12gsr_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsr/LSQ12gsr_snap_76068.gif',34830015438,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,544218991,8503421,NULL,NULL,NULL,NULL),(5884,5883,0,'LSQ12gsr','LSQ',12.2244583333333,-25.0203333333333,NULL,NULL,'2012-11-05 02:01:22',56236.0842900001,20.4588,0.202,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 18:46:20','2012-11-23 18:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsr/LSQ12gsr_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsr/LSQ12gsr_snap_76069.gif',34830015438,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,544218991,8503421,NULL,NULL,NULL,NULL),(5885,5883,0,'LSQ12gsr','LSQ',12.2245416666667,-25.0203333333333,NULL,NULL,'2012-11-13 04:00:35',56244.16708,20.6251,0.1764,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 18:46:20','2012-11-23 18:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsr/LSQ12gsr_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsr/LSQ12gsr_snap_76070.gif',34830015438,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,544218991,8503421,NULL,NULL,NULL,NULL),(5886,5883,0,'LSQ12gsr','LSQ',12.2244583333333,-25.0202777777778,NULL,NULL,'2012-11-19 01:38:03',56250.0680999998,20.3731,0.207,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 18:46:20','2012-11-23 18:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsr/LSQ12gsr_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsr/LSQ12gsr_snap_76071.gif',34830015438,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,544218991,8503421,NULL,NULL,NULL,NULL),(5887,5883,0,'LSQ12gsr','LSQ',12.224375,-25.0203333333333,NULL,NULL,'2012-11-19 03:38:04',56250.1514400002,19.7619,0.141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 18:46:20','2012-11-23 18:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsr/LSQ12gsr_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsr/LSQ12gsr_snap_76072.gif',34830015438,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,544218991,8503421,NULL,NULL,NULL,NULL),(5888,5883,0,'LSQ12gsr','LSQ',12.2244583333333,-25.0203333333333,NULL,NULL,'2012-11-23 01:29:16',56254.0619999999,19.4374,0.1634,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 18:46:20','2012-11-23 18:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsr/LSQ12gsr_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsr/LSQ12gsr_snap_75941.gif',34830015438,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,544218991,8503421,NULL,NULL,NULL,NULL),(5889,5883,0,'LSQ12gsr','LSQ',12.2244583333333,-25.0202222222222,NULL,NULL,'2012-11-23 03:29:47',56254.1456900002,18.6148,0.1024,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-23 18:46:20','2012-11-23 18:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsr/LSQ12gsr_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsr/LSQ12gsr_snap_75942.gif',34830015439,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,544218991,8503421,NULL,NULL,NULL,NULL),(5890,3112,0,'LSQ12fvu','LSQ',53.5190416666667,-21.8744444444444,NULL,NULL,'2012-11-24 02:52:08',56255.1195399999,19.2095,0.1045,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_76235.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(5891,3112,0,'LSQ12fvu','LSQ',53.519,-21.8744722222222,NULL,NULL,'2012-11-24 04:52:46',56255.2033199999,19.4836,0.1049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_76236.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(5892,3114,0,'LSQ12fvq','LSQ',19.1506666666667,-31.4520833333333,NULL,NULL,'2012-11-24 01:13:35',56255.0510999998,18.544,0.0467,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_76217.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(5893,3114,0,'LSQ12fvq','LSQ',19.1507083333333,-31.4520277777778,NULL,NULL,'2012-11-24 03:13:46',56255.1345700002,18.6325,0.0553,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_76218.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(5894,3125,0,'LSQ12fvl','LSQ',75.2085416666667,-38.6532222222222,NULL,NULL,'2012-11-24 05:16:41',56255.2199200001,18.9991,0.103,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_76233.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(5895,3125,0,'LSQ12fvl','LSQ',75.2085416666667,-38.6531666666667,NULL,NULL,'2012-11-24 06:56:51',56255.2894799998,19.0024,0.0746,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_76234.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(5898,3245,0,'LSQ12fwz','LSQ',21.2805,-26.1291388888889,NULL,NULL,'2012-11-24 03:24:09',56255.1417800002,19.416,0.1307,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_76133.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(5899,3249,0,'LSQ12fww','LSQ',62.534375,-34.1649444444444,NULL,NULL,'2012-11-24 05:21:51',56255.2235099999,18.7958,0.0591,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_76114.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(5900,3249,0,'LSQ12fww','LSQ',62.5344166666667,-34.1648611111111,NULL,NULL,'2012-11-24 07:49:46',56255.3262299998,18.8823,0.0488,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_76115.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(5901,3284,0,'LSQ12fxk','LSQ',57.9454583333333,-22.1760277777778,NULL,NULL,'2012-11-24 03:02:38',56255.12684,18.7511,0.169,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_snap_76135.gif',37996998851,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593703107,9276611,NULL,NULL,NULL,NULL),(5902,3284,0,'LSQ12fxk','LSQ',57.9452083333333,-22.176,NULL,NULL,'2012-11-24 05:03:06',56255.21049,18.4949,0.1391,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_snap_76136.gif',37996998850,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593703107,9276611,NULL,NULL,NULL,NULL),(5903,3287,0,'LSQ12fxc','LSQ',47.81575,-22.4541388888889,NULL,NULL,'2012-11-24 02:36:53',56255.1089499998,18.6913,0.1016,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_76131.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(5904,3287,0,'LSQ12fxc','LSQ',47.8157083333333,-22.4541111111111,NULL,NULL,'2012-11-24 04:37:32',56255.1927399999,19.164,0.1306,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_76132.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(5905,3481,0,'LSQ12fzc','LSQ',43.0445,-35.9737222222222,NULL,NULL,'2012-11-24 02:26:38',56255.1018300001,19.8807,0.1699,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_76111.gif',38652782969,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(5906,3481,0,'LSQ12fzc','LSQ',43.04475,-35.9738333333333,NULL,NULL,'2012-11-24 04:27:25',56255.1857099999,18.5808,0.1248,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzc/LSQ12fzc_snap_76112.gif',38652782971,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603949733,9436714,NULL,NULL,NULL,NULL),(5907,3517,0,'LSQ12gap','LSQ',66.2455833333333,-25.1844722222222,NULL,NULL,'2012-11-24 05:59:19',56255.2495300001,19.68,0.1781,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gap/LSQ12gap_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gap/LSQ12gap_snap_76144.gif',37181152649,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,580955510,9077429,NULL,NULL,NULL,NULL),(5908,3520,0,'LSQ12gak','LSQ',21.5754166666667,-23.3502222222222,NULL,NULL,'2012-11-24 03:20:38',56255.1393400002,18.9121,0.1587,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_snap_76113.gif',35177372187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549646440,8588225,NULL,NULL,NULL,NULL),(5909,3530,0,'LSQ12gad','LSQ',52.302125,-30.6229722222222,NULL,NULL,'2012-11-24 04:49:23',56255.2009700001,19.2701,0.142,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_76245.gif',38573258241,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(5910,3540,0,'LSQ12fzz','LSQ',81.4934166666667,-34.4575833333333,NULL,NULL,'2012-11-24 07:07:03',56255.2965699998,19.6642,0.1155,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_76128.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(5911,3548,0,'LSQ12fzu','LSQ',74.8828333333333,-38.4093611111111,NULL,NULL,'2012-11-24 05:14:59',56255.2187399999,19.8546,0.153,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_76129.gif',37599816286,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(5912,3551,0,'LSQ12fzr','LSQ',49.179375,-30.2704444444444,NULL,NULL,'2012-11-24 02:33:24',56255.10653,19.5415,0.205,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-11-24 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_76240.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(5913,3893,0,'LSQ12gfs','LSQ',55.3098333333333,-26.7206944444444,NULL,NULL,'2012-11-24 03:04:20',56255.1280100001,19.7475,0.1444,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_snap_76159.gif',38579773067,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602808954,9418889,NULL,NULL,NULL,NULL),(5914,3818,0,'LSQ12gdc','LSQ',74.1527916666667,-31.6033888888889,NULL,NULL,'2012-11-24 05:31:58',56255.2305399999,17.1721,0.0567,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_76166.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(5915,3818,0,'LSQ12gdc','LSQ',74.1527916666667,-31.6034444444444,NULL,NULL,'2012-11-24 07:44:40',56255.3226899998,17.1789,0.0426,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_76167.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(5916,3821,0,'LSQ12gcw','LSQ',68.31875,-38.1013611111111,NULL,NULL,'2012-11-24 05:11:35',56255.2163800001,19.3576,0.1237,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_76202.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(5917,3821,0,'LSQ12gcw','LSQ',68.3187916666667,-38.1013611111111,NULL,NULL,'2012-11-24 07:54:55',56255.32981,19.5435,0.0727,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_76203.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(5918,3845,0,'LSQ12geg','LSQ',55.053125,-26.7928333333333,NULL,NULL,'2012-11-24 03:04:20',56255.1280100001,18.728,0.0589,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_snap_76152.gif',38582715225,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602854925,9419608,NULL,NULL,NULL,NULL),(5919,3864,0,'LSQ12gel','LSQ',55.750875,-26.6940555555556,NULL,NULL,'2012-11-24 01:07:50',56255.0471100002,18.3821,0.0715,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_snap_76157.gif',38528356173,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602005565,9406336,NULL,NULL,NULL,NULL),(5920,3864,0,'LSQ12gel','LSQ',55.7505833333333,-26.6941388888889,NULL,NULL,'2012-11-24 03:08:02',56255.1305800001,19.394,0.0809,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_snap_76158.gif',38528356173,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602005565,9406336,NULL,NULL,NULL,NULL),(5921,3868,0,'LSQ12gek','LSQ',55.5484166666667,-26.7351944444444,NULL,NULL,'2012-11-24 01:07:50',56255.0471100002,17.4285,0.0391,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-06 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_snap_76181.gif',38579734652,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602808353,9418880,NULL,NULL,NULL,NULL),(5922,3868,0,'LSQ12gek','LSQ',55.5484166666667,-26.7352222222222,NULL,NULL,'2012-11-24 03:08:02',56255.1305800001,17.7514,0.0317,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-06 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_snap_76182.gif',38579734652,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602808353,9418880,NULL,NULL,NULL,NULL),(5923,4056,0,'LSQ12ghe','LSQ',68.5490416666667,-23.0558888888889,NULL,NULL,'2012-11-24 06:02:42',56255.2518799999,19.1524,0.0948,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_76200.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(5924,4056,0,'LSQ12ghe','LSQ',68.5489583333333,-23.0560277777778,NULL,NULL,'2012-11-24 07:29:14',56255.3119700002,19.7516,0.0956,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_76201.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(5925,4061,0,'LSQ12ggx','LSQ',47.896,-22.3204166666667,NULL,NULL,'2012-11-24 04:39:13',56255.1939099999,19.645,0.1605,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_76256.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(5926,4067,0,'LSQ12ggq','LSQ',69.428875,-35.8658611111111,NULL,NULL,'2012-11-24 05:11:35',56255.2163800001,19.9846,0.1095,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_76231.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(5927,4067,0,'LSQ12ggq','LSQ',69.4289166666667,-35.8658333333333,NULL,NULL,'2012-11-24 07:54:55',56255.32981,19.8029,0.0692,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_76232.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(5928,4118,0,'LSQ12ghd','LSQ',71.86475,-21.3294444444444,NULL,NULL,'2012-11-24 06:02:42',56255.2518799999,20.2097,0.1248,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_76230.gif',37342671080,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479235,9116863,NULL,NULL,NULL,NULL),(5929,4120,0,'LSQ12ghc','LSQ',66.2230416666667,-21.2026944444444,NULL,NULL,'2012-11-24 05:59:19',56255.2495300001,17.7942,0.0413,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_76197.gif',37325531170,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(5930,4120,0,'LSQ12ghc','LSQ',66.2230416666667,-21.2026944444444,NULL,NULL,'2012-11-24 07:30:56',56255.3131499998,17.6333,0.0295,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_76198.gif',37325531170,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(5931,4156,0,'LSQ12ggn','LSQ',58.0250416666667,-39.0652777777778,NULL,NULL,'2012-11-24 02:55:52',56255.12213,17.9701,0.0521,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_76193.gif',37665320689,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(5932,4156,0,'LSQ12ggn','LSQ',58.025,-39.06525,NULL,NULL,'2012-11-24 04:56:21',56255.2058000001,17.7465,0.0438,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_76194.gif',37665320689,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(5933,4317,0,'LSQ12gkk','LSQ',76.869,-23.8546111111111,NULL,NULL,'2012-11-24 06:09:26',56255.2565600001,19.5568,0.102,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_76124.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(5934,4317,0,'LSQ12gkk','LSQ',76.8690416666667,-23.8546111111111,NULL,NULL,'2012-11-24 07:25:52',56255.30963,19.5511,0.0653,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_76125.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(5935,4362,0,'LSQ12gkx','LSQ',56.6779583333333,-26.3566944444444,NULL,NULL,'2012-11-24 03:08:02',56255.1305800001,21.3618,0.162,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkx/LSQ12gkx_snap_76130.gif',38528720443,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602011256,9406425,NULL,NULL,NULL,NULL),(5936,5246,0,'LSQ12gln','LSQ',80.7475,-33.4642222222222,NULL,NULL,'2012-11-24 05:37:01',56255.2340500001,18.1696,0.0549,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_76252.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(5937,5246,0,'LSQ12gln','LSQ',80.7475416666667,-33.4642222222222,NULL,NULL,'2012-11-24 07:07:03',56255.2965699998,18.3756,0.0434,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_76253.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(5938,5249,0,'LSQ12glk','LSQ',19.5817083333333,-38.3602777777778,NULL,NULL,'2012-11-24 01:16:58',56255.0534600001,20.531,0.1681,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_76190.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5939,5249,0,'LSQ12glk','LSQ',19.58175,-38.3602222222222,NULL,NULL,'2012-11-24 03:15:27',56255.1357399998,20.4109,0.1326,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_76192.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5940,5249,0,'LSQ12glk','LSQ',19.581625,-38.3602777777778,NULL,NULL,'2012-11-24 03:17:09',56255.13692,20.9056,0.2157,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_76191.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(5941,5550,0,'LSQ12goy','LSQ',68.8834166666667,-26.4607222222222,NULL,NULL,'2012-11-24 05:45:40',56255.2400500001,19.3859,0.1104,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_76279.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(5942,5550,0,'LSQ12goy','LSQ',68.8834166666667,-26.4606388888889,NULL,NULL,'2012-11-24 07:37:47',56255.3179100002,19.5396,0.0921,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_76280.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(5943,5557,0,'LSQ12gow','LSQ',48.134125,-28.9631388888889,NULL,NULL,'2012-11-24 02:40:14',56255.1112799998,18.5669,0.1295,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_76277.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(5944,5557,0,'LSQ12gow','LSQ',48.1344166666667,-28.9632777777778,NULL,NULL,'2012-11-24 04:40:54',56255.19508,18.885,0.1363,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_76278.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(5945,5568,0,'LSQ12gnu','LSQ',19.5156666666667,-36.6119166666667,NULL,NULL,'2012-11-24 01:15:16',56255.0522799999,19.9408,0.1557,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_history.html','sn - nice',NULL,0.073214,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_snap_76273.gif',38275123499,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598048804,9344512,NULL,NULL,NULL,NULL),(5946,5816,0,'LSQ12grj','LSQ',58.0620416666667,-22.1816388888889,NULL,NULL,'2012-11-24 03:02:38',56255.12684,17.4006,0.0862,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_history.html','sn?',NULL,0.061819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_snap_76304.gif',37996988353,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593702943,9276608,NULL,NULL,NULL,NULL),(5947,5823,0,'LSQ12grh','LSQ',48.0765833333333,-24.5529722222222,NULL,NULL,'2012-11-24 02:38:34',56255.1101199999,18.5205,0.0767,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_76307.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(5948,5823,0,'LSQ12grh','LSQ',48.0767083333333,-24.5529722222222,NULL,NULL,'2012-11-24 04:39:13',56255.1939099999,18.6417,0.0697,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_76308.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(5949,5831,0,'LSQ12gra','LSQ',51.126125,-28.29175,NULL,NULL,'2012-11-24 02:41:57',56255.1124700001,18.7185,0.1389,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_76302.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(5950,5831,0,'LSQ12gra','LSQ',51.1259583333333,-28.2918055555556,NULL,NULL,'2012-11-24 04:42:36',56255.1962600001,19.1391,0.1066,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_76303.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(5951,5839,0,'LSQ12gqq','LSQ',18.8639583333333,-31.3977777777778,NULL,NULL,'2012-11-24 01:13:35',56255.0510999998,19.4719,0.1104,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_76300.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5952,5839,0,'LSQ12gqq','LSQ',18.8638333333333,-31.39775,NULL,NULL,'2012-11-24 03:13:46',56255.1345700002,19.4495,0.1035,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_76301.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(5953,5856,0,'LSQ12gsh','LSQ',72.1754583333333,-30.9983611111111,NULL,NULL,'2012-11-24 05:30:16',56255.2293600002,17.7472,0.062,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_76324.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(5954,5856,0,'LSQ12gsh','LSQ',72.1755,-30.9982777777778,NULL,NULL,'2012-11-24 07:03:40',56255.29422,17.8379,0.0482,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_76325.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(5955,5866,0,'LSQ12gsa','LSQ',19.1239583333333,-30.8897777777778,NULL,NULL,'2012-11-24 01:13:35',56255.0510999998,19.9009,0.1084,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_history.html','sn?',NULL,0.075,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_snap_76318.gif',34736605677,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,542759463,8480616,NULL,NULL,NULL,NULL),(5956,5866,0,'LSQ12gsa','LSQ',19.1240416666667,-30.8898611111111,NULL,NULL,'2012-11-24 03:13:46',56255.1345700002,20.2558,0.1931,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_history.html','sn?',NULL,0.075,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_snap_76319.gif',34736605677,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,542759463,8480616,NULL,NULL,NULL,NULL),(5957,5876,0,'LSQ12gsv','LSQ',71.5320416666667,-25.2667777777778,NULL,NULL,'2012-11-24 06:02:42',56255.2518799999,19.7098,0.1204,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_76326.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(5958,5876,0,'LSQ12gsv','LSQ',71.532,-25.2667222222222,NULL,NULL,'2012-11-24 07:29:14',56255.3119700002,19.2731,0.1216,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 14:46:11','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_76327.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(5959,5959,1,'LSQ12gtm','LSQ',69.959625,-34.1290555555556,NULL,NULL,'2012-11-15 07:15:10',56246.3022099999,21.172,0.1746,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_76417.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(5960,5959,0,'LSQ12gtm','LSQ',69.96,-34.1288055555556,NULL,NULL,'2012-11-19 07:41:47',56250.32069,20.9335,0.1672,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_76418.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(5961,5959,0,'LSQ12gtm','LSQ',69.9596666666667,-34.1286944444444,NULL,NULL,'2012-11-21 05:12:14',56252.2168399999,20.2781,0.1331,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_76419.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(5962,5959,0,'LSQ12gtm','LSQ',69.9598333333333,-34.1286944444444,NULL,NULL,'2012-11-21 07:40:17',56252.31965,19.8648,0.1059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_76420.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(5963,5959,0,'LSQ12gtm','LSQ',69.9597916666667,-34.1286944444444,NULL,NULL,'2012-11-23 05:06:45',56254.2130300002,19.3071,0.0792,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_76421.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(5964,5959,0,'LSQ12gtm','LSQ',69.959875,-34.1286944444444,NULL,NULL,'2012-11-23 06:53:54',56254.2874400001,20.1224,0.111,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_76422.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(5965,5959,0,'LSQ12gtm','LSQ',69.9597916666667,-34.1285833333333,NULL,NULL,'2012-11-24 05:30:16',56255.2293600002,19.4566,0.1064,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_76380.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(5966,5959,0,'LSQ12gtm','LSQ',69.9597916666667,-34.1287222222222,NULL,NULL,'2012-11-24 07:03:40',56255.29422,19.6229,0.0863,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_76381.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(5967,5967,1,'LSQ12gtj','LSQ',62.5654166666667,-34.1038888888889,NULL,NULL,'2012-11-23 04:58:16',56254.2071400001,19.6123,0.1359,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtj/LSQ12gtj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtj/LSQ12gtj_snap_76410.gif',37708721431,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589198772,9206230,NULL,NULL,NULL,NULL),(5968,5967,0,'LSQ12gtj','LSQ',62.5654166666667,-34.1038611111111,NULL,NULL,'2012-11-24 05:21:51',56255.2235099999,19.1339,0.1221,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtj/LSQ12gtj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtj/LSQ12gtj_snap_76374.gif',37708721431,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589198772,9206230,NULL,NULL,NULL,NULL),(5969,5967,0,'LSQ12gtj','LSQ',62.5653333333333,-34.10375,NULL,NULL,'2012-11-24 07:49:46',56255.3262299998,19.4044,0.08,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtj/LSQ12gtj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtj/LSQ12gtj_snap_76375.gif',37708721431,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589198772,9206230,NULL,NULL,NULL,NULL),(5970,5970,1,'LSQ12gti','LSQ',40.073875,-34.4597222222222,NULL,NULL,'2012-11-24 02:07:52',56255.0888,18.6757,0.1281,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_76372.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(5971,5970,0,'LSQ12gti','LSQ',40.0738333333333,-34.4597222222222,NULL,NULL,'2012-11-24 04:08:40',56255.1726899999,18.4223,0.112,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_76373.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(5972,5972,1,'LSQ12gtg','LSQ',24.6826666666667,-30.2355,NULL,NULL,'2012-11-24 01:27:08',56255.0605100002,18.7918,0.0876,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtg/LSQ12gtg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtg/LSQ12gtg_snap_76368.gif',38258248349,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597785130,9340392,NULL,NULL,NULL,NULL),(5973,5972,0,'LSQ12gtg','LSQ',24.682625,-30.2355555555556,NULL,NULL,'2012-11-24 03:27:33',56255.14414,19.2427,0.1059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2012-11-24 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtg/LSQ12gtg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtg/LSQ12gtg_snap_76369.gif',38258248345,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,597785130,9340392,NULL,NULL,NULL,NULL),(5974,5974,1,'LSQ12gte','LSQ',20.1437916666667,-34.1218055555556,NULL,NULL,'2012-11-01 01:59:34',56232.0830399999,20.0679,0.1881,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gte/LSQ12gte_history.html','sn?',NULL,0.012725,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gte/LSQ12gte_snap_76408.gif',38285361946,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598208780,9347012,NULL,NULL,NULL,NULL),(5975,5974,0,'LSQ12gte','LSQ',20.1440416666667,-34.1217777777778,NULL,NULL,'2012-11-23 01:49:41',56254.0761699998,19.4986,0.1185,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gte/LSQ12gte_history.html','sn?',NULL,0.012725,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gte/LSQ12gte_snap_76409.gif',38285361946,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598208780,9347012,NULL,NULL,NULL,NULL),(5976,5974,0,'LSQ12gte','LSQ',20.14425,-34.1216111111111,NULL,NULL,'2012-11-24 01:13:35',56255.0510999998,20.4045,0.1585,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gte/LSQ12gte_history.html','sn?',NULL,0.012725,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gte/LSQ12gte_snap_76364.gif',38285361946,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598208780,9347012,NULL,NULL,NULL,NULL),(5977,5974,0,'LSQ12gte','LSQ',20.1439166666667,-34.1219166666667,NULL,NULL,'2012-11-24 03:13:46',56255.1345700002,19.4465,0.0807,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-24 18:46:13','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gte/LSQ12gte_history.html','sn?',NULL,0.012725,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gte/LSQ12gte_snap_76365.gif',38285361946,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598208780,9347012,NULL,NULL,NULL,NULL),(5978,3726,0,'LSQ12gcq','LSQ',60.730625,5.94269444444444,NULL,NULL,'2012-11-25 03:00:53',56256.1256200001,18.3079,0.11,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-25 17:46:13','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcq/LSQ12gcq_history.html','brightening',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcq/LSQ12gcq_snap_76494.gif',65200466967,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,1018757296,15918082,NULL,NULL,NULL,NULL),(5979,3759,0,'LSQ12gch','LSQ',75.1155,-19.9498333333333,NULL,NULL,'2012-11-25 05:08:05',56256.2139499998,20.3162,0.174,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-25 17:46:13','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_snap_76493.gif',37564131566,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586939555,9170930,NULL,NULL,NULL,NULL),(5980,5376,0,'LSQ12glw','LSQ',143.033166666667,-9.68127777777778,NULL,NULL,'2012-11-25 08:04:01',56256.3361300002,19.8576,0.1865,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-25 17:46:13','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glw/LSQ12glw_history.html','sne?',NULL,0.054681,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glw/LSQ12glw_snap_76503.gif',41090785038,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642043516,10031929,NULL,NULL,NULL,NULL),(5981,5813,0,'LSQ12gpw','LSQ',48.2427083333333,-11.7111388888889,NULL,NULL,'2012-11-25 02:50:47',56256.1186000002,16.9704,0.0615,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-25 17:46:13','2012-12-06 23:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_76506.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(5982,5813,0,'LSQ12gpw','LSQ',48.2426666666667,-11.7111944444444,NULL,NULL,'2012-11-25 04:54:25',56256.2044600002,17.1826,0.0715,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-25 17:46:13','2012-12-06 23:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_76507.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(5983,5983,1,'LSQ12gul','LSQ',43.0337916666667,-0.0361111111111111,NULL,NULL,'2012-11-25 02:07:48',56256.0887500001,18.5359,0.0916,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_76613.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(5984,5983,0,'LSQ12gul','LSQ',43.03375,-0.0360277777777778,NULL,NULL,'2012-11-25 04:09:29',56256.1732600001,18.4991,0.0909,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_76614.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(5985,5985,1,'LSQ12guj','LSQ',36.2344583333333,5.12119444444444,NULL,NULL,'2012-11-25 01:29:40',56256.0622700001,18.4104,0.0946,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_snap_76609.gif',66894622375,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045228474,16331694,NULL,NULL,NULL,NULL),(5986,5985,0,'LSQ12guj','LSQ',36.2345,5.12122222222222,NULL,NULL,'2012-11-25 03:31:20',56256.14677,18.0215,0.1367,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_snap_76610.gif',66894622375,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045228474,16331694,NULL,NULL,NULL,NULL),(5987,5987,1,'LSQ12gug','LSQ',140.612125,-6.47722222222222,NULL,NULL,'2012-11-25 06:09:00',56256.2562600002,18.7598,0.0761,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gug/LSQ12gug_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gug/LSQ12gug_snap_76603.gif',41096530790,NULL,NULL,NULL,'2012-04-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,642133293,10033332,NULL,NULL,NULL,NULL),(5988,5987,0,'LSQ12gug','LSQ',140.612125,-6.47722222222222,NULL,NULL,'2012-11-25 07:22:28',56256.3072700002,19.0231,0.0648,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gug/LSQ12gug_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gug/LSQ12gug_snap_76604.gif',41096530790,NULL,NULL,NULL,'2012-04-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,642133293,10033332,NULL,NULL,NULL,NULL),(5989,5989,1,'LSQ12guf','LSQ',144.931333333333,-3.73063888888889,NULL,NULL,'2012-11-25 06:30:05',56256.2708999999,18.9216,0.1468,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guf/LSQ12guf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guf/LSQ12guf_snap_76601.gif',41114462936,NULL,NULL,NULL,'2012-05-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,642413483,10037710,NULL,NULL,NULL,NULL),(5990,5989,0,'LSQ12guf','LSQ',144.931208333333,-3.73058333333333,NULL,NULL,'2012-11-25 07:34:27',56256.3155999999,19.3837,0.1199,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guf/LSQ12guf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guf/LSQ12guf_snap_76602.gif',41114462936,NULL,NULL,NULL,'2012-05-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,642413483,10037710,NULL,NULL,NULL,NULL),(5991,5991,1,'LSQ12gub','LSQ',145.626291666667,-11.0261666666667,NULL,NULL,'2012-11-25 06:25:01',56256.2673800001,20.0314,0.1592,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gub/LSQ12gub_history.html','sn?',NULL,0.035244,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gub/LSQ12gub_snap_76561.gif',41306840942,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645419389,10084677,NULL,NULL,NULL,NULL),(5992,5991,0,'LSQ12gub','LSQ',145.626,-11.0259166666667,NULL,NULL,'2012-11-25 07:57:16',56256.3314399999,19.2838,0.0618,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gub/LSQ12gub_history.html','sn?',NULL,0.035244,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gub/LSQ12gub_snap_76562.gif',41306840934,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645419389,10084677,NULL,NULL,NULL,NULL),(5993,5993,1,'LSQ12gtz','LSQ',48.3621666666667,-7.35788888888889,NULL,NULL,'2012-08-20 09:52:13',56159.41127,20.1508,0.161,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76621.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(5994,5993,0,'LSQ12gtz','LSQ',48.3626666666667,-7.35761111111111,NULL,NULL,'2012-08-28 08:06:56',56167.3381500002,19.5355,0.1764,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76697.gif',37904478839,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(5995,5993,0,'LSQ12gtz','LSQ',48.363,-7.35755555555555,NULL,NULL,'2012-08-28 09:13:03',56167.3840700001,19.7911,0.1487,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76698.gif',37904478839,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(5996,5993,0,'LSQ12gtz','LSQ',48.3627083333333,-7.35755555555555,NULL,NULL,'2012-10-10 07:57:30',56210.3316000002,19.4784,0.1259,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76699.gif',37904478839,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(5997,5993,0,'LSQ12gtz','LSQ',48.3629583333333,-7.35755555555555,NULL,NULL,'2012-10-12 08:40:47',56212.3616599999,19.5706,0.1405,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76700.gif',37904478839,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(5998,5993,0,'LSQ12gtz','LSQ',48.3629583333333,-7.35766666666667,NULL,NULL,'2012-10-16 07:55:17',56216.3300600001,19.1434,0.111,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76694.gif',37904478839,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(5999,5993,0,'LSQ12gtz','LSQ',48.3630416666667,-7.35755555555555,NULL,NULL,'2012-10-18 06:29:57',56218.2708100001,19.1539,0.1109,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76701.gif',37904478839,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(6000,5993,0,'LSQ12gtz','LSQ',48.3632083333333,-7.35788888888889,NULL,NULL,'2012-10-20 07:56:02',56220.3305899999,20.2132,0.152,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76622.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(6001,5993,0,'LSQ12gtz','LSQ',48.3627916666667,-7.35772222222222,NULL,NULL,'2012-10-22 09:02:53',56222.3770099999,19.3495,0.1673,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76695.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(6002,5993,0,'LSQ12gtz','LSQ',48.3627916666667,-7.35730555555556,NULL,NULL,'2012-10-24 08:22:07',56224.3487,19.2016,0.1419,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76703.gif',37904478839,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(6003,5993,0,'LSQ12gtz','LSQ',48.3630833333333,-7.35758333333333,NULL,NULL,'2012-11-06 05:33:02',56237.2312799999,20.2182,0.185,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76702.gif',37904478839,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(6004,5993,0,'LSQ12gtz','LSQ',48.3625,-7.35838888888889,NULL,NULL,'2012-11-20 02:05:58',56251.0874800002,19.7244,0.1516,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76587.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(6005,5993,0,'LSQ12gtz','LSQ',48.3627083333333,-7.3585,NULL,NULL,'2012-11-22 03:57:11',56253.1647199998,19.6152,0.1467,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76588.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(6006,5993,0,'LSQ12gtz','LSQ',48.3627916666667,-7.35838888888889,NULL,NULL,'2012-11-25 02:38:40',56256.1101899999,17.5219,0.1179,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76597.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(6007,5993,0,'LSQ12gtz','LSQ',48.36275,-7.35844444444444,NULL,NULL,'2012-11-25 02:50:47',56256.1186000002,19.1169,0.1594,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76557.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(6008,5993,0,'LSQ12gtz','LSQ',48.3628333333333,-7.35847222222222,NULL,NULL,'2012-11-25 04:42:18',56256.1960499999,18.3561,0.1328,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76598.gif',37904478844,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(6009,5993,0,'LSQ12gtz','LSQ',48.3627916666667,-7.35844444444444,NULL,NULL,'2012-11-25 04:54:25',56256.2044600002,18.6333,0.1382,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 00:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76558.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(6010,6010,1,'LSQ12gun','LSQ',146.326958333333,0.807861111111111,NULL,NULL,'2012-11-25 06:40:13',56256.2779299999,19.0159,0.1253,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 01:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gun/LSQ12gun_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gun/LSQ12gun_snap_76617.gif',60902174160,NULL,NULL,NULL,'2012-03-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,951596471,14868694,NULL,NULL,NULL,NULL),(6011,6010,0,'LSQ12gun','LSQ',146.327166666667,0.807833333333333,NULL,NULL,'2012-11-25 07:41:18',56256.3203500002,18.6009,0.0546,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 01:46:14','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gun/LSQ12gun_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gun/LSQ12gun_snap_76618.gif',60902174160,NULL,NULL,NULL,'2012-03-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,951596471,14868694,NULL,NULL,NULL,NULL),(6012,6012,1,'LSQ12gum','LSQ',140.764875,-2.62205555555556,NULL,NULL,'2012-11-25 06:16:30',56256.2614600002,19.7823,0.1539,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 01:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gum/LSQ12gum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gum/LSQ12gum_snap_76615.gif',41127022392,NULL,NULL,NULL,'2012-03-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642609724,10040776,NULL,NULL,NULL,NULL),(6013,6012,0,'LSQ12gum','LSQ',140.764875,-2.62202777777778,NULL,NULL,'2012-11-25 07:27:33',56256.3108000001,19.8025,0.1254,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 01:46:14','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gum/LSQ12gum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gum/LSQ12gum_snap_76616.gif',41127022392,NULL,NULL,NULL,'2012-03-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642609724,10040776,NULL,NULL,NULL,NULL),(6014,6014,1,'LSQ12gty','LSQ',73.3359166666667,-14.9325555555556,NULL,NULL,'2012-11-16 05:39:38',56247.2358599999,20.5612,0.1508,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 16:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_76582.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(6015,6014,0,'LSQ12gty','LSQ',73.3359583333333,-14.9326666666667,NULL,NULL,'2012-11-16 08:02:55',56247.3353599999,20.8045,0.1766,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 16:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_76583.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(6016,6014,0,'LSQ12gty','LSQ',73.3359166666667,-14.9325555555556,NULL,NULL,'2012-11-18 05:33:00',56249.2312500002,20.1313,0.1122,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 16:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_76584.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(6017,6014,0,'LSQ12gty','LSQ',73.3358333333333,-14.9324444444444,NULL,NULL,'2012-11-18 07:56:34',56249.3309499999,20.92,0.1916,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 16:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_76585.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(6018,6014,0,'LSQ12gty','LSQ',73.335875,-14.9325277777778,NULL,NULL,'2012-11-22 05:21:14',56253.22309,19.6226,0.0998,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 16:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_76586.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(6019,6014,0,'LSQ12gty','LSQ',73.3360416666667,-14.9326388888889,NULL,NULL,'2012-11-25 05:09:46',56256.2151199998,19.3824,0.1143,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 16:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_76555.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(6020,6014,0,'LSQ12gty','LSQ',73.3359583333333,-14.9326111111111,NULL,NULL,'2012-11-25 06:55:11',56256.2883299999,19.4007,0.1117,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 16:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_76556.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(6021,6021,1,'LSQ12gtx','LSQ',149.76025,-13.9694722222222,NULL,NULL,'2012-11-25 06:18:16',56256.2626899998,19.3972,0.1049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 16:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtx/LSQ12gtx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtx/LSQ12gtx_snap_76553.gif',41191975503,NULL,NULL,NULL,'2012-05-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,643624617,10056634,NULL,NULL,NULL,NULL),(6022,6021,0,'LSQ12gtx','LSQ',149.76025,-13.9695,NULL,NULL,'2012-11-25 08:00:37',56256.3337699999,19.5454,0.0563,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-26 16:46:13','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtx/LSQ12gtx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtx/LSQ12gtx_snap_76554.gif',41191975503,NULL,NULL,NULL,'2012-05-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,643624617,10056634,NULL,NULL,NULL,NULL),(6023,3399,0,'LSQ12fxy','LSQ',50.1276666666667,-11.2955277777778,NULL,NULL,'2012-11-27 02:43:29',56258.1135399998,18.4348,0.1707,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-11-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxy/LSQ12fxy_snap_76709.gif',37885680965,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591963765,9249433,NULL,NULL,NULL,NULL),(6024,3851,0,'LSQ12ges','LSQ',74.9864166666667,-19.4645277777778,NULL,NULL,'2012-11-27 02:55:26',56258.1218300001,19.3766,0.2019,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_snap_76748.gif',37563466779,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586929168,9170768,NULL,NULL,NULL,NULL),(6025,5376,0,'LSQ12glw','LSQ',143.033166666667,-9.68130555555556,NULL,NULL,'2012-11-27 05:56:40',56258.2476900001,19.9149,0.2046,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glw/LSQ12glw_history.html','sne?',NULL,0.054681,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glw/LSQ12glw_snap_76771.gif',41090785025,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642043516,10031929,NULL,NULL,NULL,NULL),(6026,5813,0,'LSQ12gpw','LSQ',48.2425833333333,-11.7111666666667,NULL,NULL,'2012-11-27 02:43:29',56258.1135399998,16.8824,0.064,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-06 23:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_76789.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(6027,5813,0,'LSQ12gpw','LSQ',48.2425416666667,-11.7111388888889,NULL,NULL,'2012-11-27 04:46:48',56258.1991699999,16.456,0.0638,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-06 23:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_76790.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(6028,5983,0,'LSQ12gul','LSQ',43.0336666666667,-0.036,NULL,NULL,'2012-11-27 02:04:05',56258.0861800001,18.2993,0.1021,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_76758.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(6029,5983,0,'LSQ12gul','LSQ',43.03375,-0.0360555555555556,NULL,NULL,'2012-11-27 04:07:09',56258.1716399998,18.2709,0.0987,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_76759.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(6030,5985,0,'LSQ12guj','LSQ',36.2344166666667,5.12116666666667,NULL,NULL,'2012-11-27 01:35:03',56258.0660100002,18.2227,0.1203,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_snap_76760.gif',66894622375,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045228474,16331694,NULL,NULL,NULL,NULL),(6031,5985,0,'LSQ12guj','LSQ',36.2344583333333,5.12116666666667,NULL,NULL,'2012-11-27 03:36:01',56258.1500200001,18.3834,0.103,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_snap_76761.gif',66894622375,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045228474,16331694,NULL,NULL,NULL,NULL),(6032,5987,0,'LSQ12gug','LSQ',140.612125,-6.47730555555556,NULL,NULL,'2012-11-27 06:01:45',56258.25122,18.8876,0.1464,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gug/LSQ12gug_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gug/LSQ12gug_snap_76743.gif',41096530790,NULL,NULL,NULL,'2012-04-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,642133293,10033332,NULL,NULL,NULL,NULL),(6033,5987,0,'LSQ12gug','LSQ',140.612083333333,-6.47725,NULL,NULL,'2012-11-27 07:19:52',56258.30547,18.7503,0.0729,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gug/LSQ12gug_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gug/LSQ12gug_snap_76744.gif',41096530790,NULL,NULL,NULL,'2012-04-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,642133293,10033332,NULL,NULL,NULL,NULL),(6034,5991,0,'LSQ12gub','LSQ',145.625458333333,-11.0255833333333,NULL,NULL,'2012-11-27 06:13:22',56258.25929,19.5578,0.1206,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gub/LSQ12gub_history.html','sn?',NULL,0.035244,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gub/LSQ12gub_snap_76781.gif',41306840935,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645419389,10084677,NULL,NULL,NULL,NULL),(6035,5993,0,'LSQ12gtz','LSQ',48.362625,-7.35836111111111,NULL,NULL,'2012-11-27 04:46:48',56258.1991699999,18.7588,0.1697,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_76776.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(6036,6010,0,'LSQ12gun','LSQ',146.32725,0.807861111111111,NULL,NULL,'2012-11-27 07:54:27',56258.3294899999,19.1277,0.1808,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gun/LSQ12gun_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gun/LSQ12gun_snap_76777.gif',60902174096,NULL,NULL,NULL,'2012-03-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,951596470,14868694,NULL,NULL,NULL,NULL),(6037,6012,0,'LSQ12gum','LSQ',140.764833333333,-2.62219444444444,NULL,NULL,'2012-11-27 06:08:09',56258.2556699999,19.3069,0.211,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gum/LSQ12gum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gum/LSQ12gum_snap_76762.gif',41127022340,NULL,NULL,NULL,'2012-03-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642609724,10040776,NULL,NULL,NULL,NULL),(6038,6012,0,'LSQ12gum','LSQ',140.764875,-2.62219444444444,NULL,NULL,'2012-11-27 07:23:15',56258.3078200002,19.4262,0.1256,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gum/LSQ12gum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gum/LSQ12gum_snap_76763.gif',41127022340,NULL,NULL,NULL,'2012-03-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642609724,10040776,NULL,NULL,NULL,NULL),(6039,6014,0,'LSQ12gty','LSQ',73.3359166666667,-14.9325555555556,NULL,NULL,'2012-11-27 02:58:49',56258.1241799998,19.2103,0.1215,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_76786.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(6040,6014,0,'LSQ12gty','LSQ',73.3360416666667,-14.9325833333333,NULL,NULL,'2012-11-27 05:02:10',56258.2098400001,19.2403,0.1508,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_76787.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(6041,6021,0,'LSQ12gtx','LSQ',149.760333333333,-13.9694722222222,NULL,NULL,'2012-11-27 06:09:57',56258.2569200001,19.5394,0.1315,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtx/LSQ12gtx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtx/LSQ12gtx_snap_76782.gif',41191975503,NULL,NULL,NULL,'2012-05-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,643624617,10056634,NULL,NULL,NULL,NULL),(6042,6021,0,'LSQ12gtx','LSQ',149.76025,-13.9695,NULL,NULL,'2012-11-27 08:01:25',56258.3343199999,19.5997,0.1032,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-27 18:46:15','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtx/LSQ12gtx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtx/LSQ12gtx_snap_76783.gif',41191975503,NULL,NULL,NULL,'2012-05-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,643624617,10056634,NULL,NULL,NULL,NULL),(6043,3112,0,'LSQ12fvu','LSQ',53.5188333333333,-21.8744444444444,NULL,NULL,'2012-11-26 02:54:28',56257.1211600001,19.4654,0.1417,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_77129.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(6044,3112,0,'LSQ12fvu','LSQ',53.5190416666667,-21.8744166666667,NULL,NULL,'2012-11-26 04:55:24',56257.2051499998,19.0156,0.1219,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvu/LSQ12fvu_snap_77130.gif',38040994987,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594390546,9287352,NULL,NULL,NULL,NULL),(6045,3114,0,'LSQ12fvq','LSQ',19.1506666666667,-31.4520277777778,NULL,NULL,'2012-11-26 01:15:16',56257.0522699999,18.6285,0.0467,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_77110.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(6046,3114,0,'LSQ12fvq','LSQ',19.150625,-31.4520833333333,NULL,NULL,'2012-11-26 03:16:17',56257.13631,18.5188,0.0511,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_history.html','sn - nice',NULL,0.035,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvq/LSQ12fvq_snap_77111.gif',34735616008,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542744000,8480375,NULL,NULL,NULL,NULL),(6047,3125,0,'LSQ12fvl','LSQ',75.2085,-38.65325,NULL,NULL,'2012-11-26 05:19:08',56257.22163,19.0193,0.145,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_77131.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(6048,3125,0,'LSQ12fvl','LSQ',75.2084583333333,-38.65325,NULL,NULL,'2012-11-26 06:57:41',56257.29006,19.3347,0.1331,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_history.html','sn - nice',NULL,0.055969,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fvl/LSQ12fvl_snap_77132.gif',37599217320,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587487770,9179496,NULL,NULL,NULL,NULL),(6051,3245,0,'LSQ12fwz','LSQ',21.2804583333333,-26.1291944444444,NULL,NULL,'2012-11-26 01:25:27',56257.0593500002,19.4461,0.1464,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_77023.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(6052,3245,0,'LSQ12fwz','LSQ',21.2804166666667,-26.1291388888889,NULL,NULL,'2012-11-26 03:26:35',56257.14347,18.8622,0.1595,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fwz/LSQ12fwz_snap_77024.gif',34700926908,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542201982,8471905,NULL,NULL,NULL,NULL),(6053,3249,0,'LSQ12fww','LSQ',62.5345833333333,-34.1648611111111,NULL,NULL,'2012-11-26 05:24:17',56257.2252000002,18.7607,0.0618,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fww/LSQ12fww_snap_77004.gif',37708009531,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589187648,9206057,NULL,NULL,NULL,NULL),(6054,3284,0,'LSQ12fxk','LSQ',57.9455,-22.1760277777778,NULL,NULL,'2012-11-26 03:04:45',56257.1283,18.8605,0.1991,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_snap_77025.gif',37996998851,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593703107,9276611,NULL,NULL,NULL,NULL),(6055,3287,0,'LSQ12fxc','LSQ',47.8158333333333,-22.4541388888889,NULL,NULL,'2012-11-26 02:39:06',56257.1104899999,19.2897,0.1555,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_77021.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(6056,3287,0,'LSQ12fxc','LSQ',47.8155833333333,-22.4543055555556,NULL,NULL,'2012-11-26 04:39:50',56257.1943299999,18.3965,0.1089,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_77022.gif',38030912757,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(6057,3485,0,'LSQ12gbj','LSQ',66.0475833333333,-25.4150277777778,NULL,NULL,'2012-11-26 07:33:25',56257.31488,19.0669,0.1049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_snap_77002.gif',37181674216,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,580963659,9077557,NULL,NULL,NULL,NULL),(6058,3517,0,'LSQ12gap','LSQ',66.2454583333333,-25.1845277777778,NULL,NULL,'2012-11-26 06:00:07',56257.2500900002,19.2702,0.1709,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gap/LSQ12gap_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gap/LSQ12gap_snap_77034.gif',37181152649,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,580955510,9077429,NULL,NULL,NULL,NULL),(6059,3520,0,'LSQ12gak','LSQ',21.5756666666667,-23.3504444444444,NULL,NULL,'2012-11-26 01:22:04',56257.057,19.2774,0.1544,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gak/LSQ12gak_snap_77000.gif',35177372187,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549646440,8588225,NULL,NULL,NULL,NULL),(6060,3530,0,'LSQ12gad','LSQ',52.3019166666667,-30.6229166666667,NULL,NULL,'2012-11-26 04:51:47',56257.2026300002,18.7547,0.1322,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_77144.gif',38573253890,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707092,9417298,NULL,NULL,NULL,NULL),(6061,3537,0,'LSQ12gab','LSQ',81.8944166666667,-31.3134166666667,NULL,NULL,'2012-11-26 05:39:31',56257.2357800002,17.9233,0.0979,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_snap_77016.gif',37311362014,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,582990031,9109219,NULL,NULL,NULL,NULL),(6062,3537,0,'LSQ12gab','LSQ',81.8939166666667,-31.3133611111111,NULL,NULL,'2012-11-26 07:07:52',56257.2971299998,18.5636,0.0695,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_snap_77017.gif',37311362015,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,582990031,9109219,NULL,NULL,NULL,NULL),(6063,3540,0,'LSQ12fzz','LSQ',81.493375,-34.4575555555556,NULL,NULL,'2012-11-26 05:39:31',56257.2357800002,19.4463,0.1225,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_77018.gif',37267383653,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(6064,3548,0,'LSQ12fzu','LSQ',74.88275,-38.4091388888889,NULL,NULL,'2012-11-26 05:17:27',56257.22046,19.6135,0.1461,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_77015.gif',37599816278,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(6065,3551,0,'LSQ12fzr','LSQ',49.1792083333333,-30.2704444444444,NULL,NULL,'2012-11-26 04:36:26',56257.19197,19.5719,0.1523,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-11-28 02:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_77135.gif',38545017983,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(6066,3893,0,'LSQ12gfs','LSQ',55.3098333333333,-26.7206944444444,NULL,NULL,'2012-11-26 03:06:46',56257.1296999999,18.969,0.1215,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_snap_77055.gif',38579773067,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602808954,9418889,NULL,NULL,NULL,NULL),(6067,3821,0,'LSQ12gcw','LSQ',68.3189583333333,-38.1014166666667,NULL,NULL,'2012-11-26 05:14:04',56257.2181099998,19.3235,0.1167,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_77097.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(6068,3821,0,'LSQ12gcw','LSQ',68.3187916666667,-38.1013333333333,NULL,NULL,'2012-11-26 07:53:44',56257.3289899998,19.3263,0.0949,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_77098.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(6069,3845,0,'LSQ12geg','LSQ',55.052875,-26.7929166666667,NULL,NULL,'2012-11-26 03:06:46',56257.1296999999,18.685,0.1043,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_snap_77041.gif',38582715225,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602854925,9419608,NULL,NULL,NULL,NULL),(6070,3864,0,'LSQ12gel','LSQ',55.750625,-26.6940555555556,NULL,NULL,'2012-11-26 03:10:27',56257.1322599999,17.2083,0.0281,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_snap_77044.gif',38528356173,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602005565,9406336,NULL,NULL,NULL,NULL),(6071,4056,0,'LSQ12ghe','LSQ',68.549,-23.0559722222222,NULL,NULL,'2012-11-26 06:03:30',56257.25244,19.2466,0.1834,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_77090.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(6072,4056,0,'LSQ12ghe','LSQ',68.549,-23.056,NULL,NULL,'2012-11-26 07:19:43',56257.3053700002,19.3039,0.1328,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_77091.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(6073,4061,0,'LSQ12ggx','LSQ',47.8961666666667,-22.32025,NULL,NULL,'2012-11-26 02:40:47',56257.1116599999,19.3831,0.1723,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_77157.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(6074,4067,0,'LSQ12ggq','LSQ',69.4289583333333,-35.8657777777778,NULL,NULL,'2012-11-26 05:14:04',56257.2181099998,19.8838,0.1239,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_77127.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(6075,4067,0,'LSQ12ggq','LSQ',69.4289166666667,-35.8658055555556,NULL,NULL,'2012-11-26 07:53:44',56257.3289899998,19.4136,0.0862,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_77128.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(6076,4120,0,'LSQ12ghc','LSQ',66.22275,-21.2026944444444,NULL,NULL,'2012-11-26 06:00:07',56257.2500900002,17.5227,0.0381,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_77088.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(6077,4120,0,'LSQ12ghc','LSQ',66.2228333333333,-21.2026944444444,NULL,NULL,'2012-11-26 07:33:25',56257.31488,17.5705,0.0397,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_77089.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(6078,4136,0,'LSQ12ggz','LSQ',56.3259166666667,-23.8723333333333,NULL,NULL,'2012-11-26 03:03:04',56257.1271299999,19.1284,0.113,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_snap_77151.gif',37995959908,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593686873,9276357,NULL,NULL,NULL,NULL),(6079,4136,0,'LSQ12ggz','LSQ',56.3260416666667,-23.8723888888889,NULL,NULL,'2012-11-26 05:03:52',56257.2110199998,19.5917,0.1238,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_snap_77152.gif',37995959908,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593686873,9276357,NULL,NULL,NULL,NULL),(6080,4156,0,'LSQ12ggn','LSQ',58.0249583333333,-39.0653055555556,NULL,NULL,'2012-11-26 02:58:00',56257.1236200002,17.7378,0.0544,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_77086.gif',37665320689,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(6081,4156,0,'LSQ12ggn','LSQ',58.024875,-39.06525,NULL,NULL,'2012-11-26 04:58:48',56257.2075100001,17.764,0.0548,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_history.html','CV ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggn/LSQ12ggn_snap_77087.gif',37665320689,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588520635,9195634,NULL,NULL,NULL,NULL),(6082,4317,0,'LSQ12gkk','LSQ',76.8689583333333,-23.8545833333333,NULL,NULL,'2012-11-26 06:10:16',56257.2571299998,19.3739,0.0977,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_77011.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(6083,4317,0,'LSQ12gkk','LSQ',76.8690416666667,-23.8545555555556,NULL,NULL,'2012-11-26 07:23:07',56257.3077199999,19.6793,0.1042,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_77012.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(6084,5246,0,'LSQ12gln','LSQ',80.7475833333333,-33.4642222222222,NULL,NULL,'2012-11-26 05:39:31',56257.2357800002,18.1402,0.0678,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_77153.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(6085,5246,0,'LSQ12gln','LSQ',80.7475416666667,-33.46425,NULL,NULL,'2012-11-26 07:07:52',56257.2971299998,18.1553,0.0528,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_77154.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(6086,5249,0,'LSQ12glk','LSQ',19.5815833333333,-38.3601388888889,NULL,NULL,'2012-11-26 03:19:39',56257.1386500001,20.6564,0.1649,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glk/LSQ12glk_snap_77085.gif',38350353467,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,599224272,9362879,NULL,NULL,NULL,NULL),(6087,5550,0,'LSQ12goy','LSQ',68.883375,-26.4606388888889,NULL,NULL,'2012-11-26 05:46:27',56257.2406000001,18.8992,0.1156,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_77227.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(6088,5550,0,'LSQ12goy','LSQ',68.8835,-26.4606111111111,NULL,NULL,'2012-11-26 07:40:11',56257.3195799999,19.5328,0.146,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_77228.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(6089,5557,0,'LSQ12gow','LSQ',48.1341666666667,-28.9634166666667,NULL,NULL,'2012-11-26 04:46:43',56257.1991099999,18.3058,0.1123,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_77225.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(6090,5568,0,'LSQ12gnu','LSQ',19.5156666666667,-36.612,NULL,NULL,'2012-11-26 01:16:57',56257.0534399999,20.2849,0.1479,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_history.html','sn - nice',NULL,0.073214,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_snap_77215.gif',38275123499,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598048804,9344512,NULL,NULL,NULL,NULL),(6091,5568,0,'LSQ12gnu','LSQ',19.5156666666667,-36.6120833333333,NULL,NULL,'2012-11-26 03:17:58',56257.13748,20.3393,0.1686,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_history.html','sn - nice',NULL,0.073214,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gnu/LSQ12gnu_snap_77216.gif',38275123499,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598048804,9344512,NULL,NULL,NULL,NULL),(6092,5823,0,'LSQ12grh','LSQ',48.0765416666667,-24.5529444444444,NULL,NULL,'2012-11-26 02:40:47',56257.1116599999,18.8749,0.0909,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_77241.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(6093,5823,0,'LSQ12grh','LSQ',48.0765833333333,-24.553,NULL,NULL,'2012-11-26 04:41:32',56257.19551,18.9959,0.1065,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_77242.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(6094,5831,0,'LSQ12gra','LSQ',51.126,-28.29175,NULL,NULL,'2012-11-26 02:47:40',56257.11644,18.9615,0.1497,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_77244.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(6095,5831,0,'LSQ12gra','LSQ',51.1259583333333,-28.2918055555556,NULL,NULL,'2012-11-26 04:48:25',56257.2002900001,19.0286,0.1242,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_77245.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(6096,5839,0,'LSQ12gqq','LSQ',18.8639166666667,-31.39775,NULL,NULL,'2012-11-26 01:15:16',56257.0522699999,19.5523,0.0908,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_77238.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(6097,5839,0,'LSQ12gqq','LSQ',18.863875,-31.3977777777778,NULL,NULL,'2012-11-26 03:16:17',56257.13631,19.6358,0.1023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_77239.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(6098,5856,0,'LSQ12gsh','LSQ',72.1754583333333,-30.9981666666667,NULL,NULL,'2012-11-26 05:32:43',56257.2310600001,18.4084,0.0724,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_77192.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(6099,5856,0,'LSQ12gsh','LSQ',72.175625,-30.9983055555556,NULL,NULL,'2012-11-26 07:04:28',56257.29477,17.3391,0.0671,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_77193.gif',37207941504,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581374086,9083970,NULL,NULL,NULL,NULL),(6100,5866,0,'LSQ12gsa','LSQ',19.1239583333333,-30.8897777777778,NULL,NULL,'2012-11-26 01:15:16',56257.0522699999,20.2202,0.1353,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_history.html','sn?',NULL,0.075,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_snap_77184.gif',34736605677,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,542759463,8480616,NULL,NULL,NULL,NULL),(6101,5866,0,'LSQ12gsa','LSQ',19.1239583333333,-30.88975,NULL,NULL,'2012-11-26 03:16:17',56257.13631,19.8811,0.1081,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_history.html','sn?',NULL,0.075,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsa/LSQ12gsa_snap_77185.gif',34736605677,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,542759463,8480616,NULL,NULL,NULL,NULL),(6102,5876,0,'LSQ12gsv','LSQ',71.5320416666667,-25.2668055555556,NULL,NULL,'2012-11-26 06:03:30',56257.25244,19.3862,0.1738,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_77174.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(6103,5876,0,'LSQ12gsv','LSQ',71.532,-25.2668055555556,NULL,NULL,'2012-11-26 07:19:43',56257.3053700002,19.5251,0.1526,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_77175.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(6104,5959,0,'LSQ12gtm','LSQ',69.9597916666667,-34.1286666666667,NULL,NULL,'2012-11-26 05:32:43',56257.2310600001,19.3084,0.1254,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_77163.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(6105,5959,0,'LSQ12gtm','LSQ',69.95975,-34.1286388888889,NULL,NULL,'2012-11-26 07:04:28',56257.29477,19.5223,0.1232,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_77164.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(6106,5970,0,'LSQ12gti','LSQ',40.0740416666667,-34.4597222222222,NULL,NULL,'2012-11-26 02:09:57',56257.0902499999,18.2593,0.1097,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_77207.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(6107,5970,0,'LSQ12gti','LSQ',40.073875,-34.4596944444444,NULL,NULL,'2012-11-26 04:10:51',56257.1742099999,18.4792,0.1183,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_77208.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(6108,6010,0,'LSQ12gun','LSQ',146.327083333333,0.808027777777778,NULL,NULL,'2012-03-23 02:19:21',56009.0967799998,20.6366,0.2143,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 02:46:16','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gun/LSQ12gun_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gun/LSQ12gun_snap_76979.gif',60902174160,NULL,NULL,NULL,'2012-03-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,951596471,14868694,NULL,NULL,NULL,NULL),(6109,6109,1,'LSQ12gwg','LSQ',71.3164583333333,-29.0706944444444,NULL,NULL,'2012-11-21 05:32:38',56252.2310000001,20.6864,0.1795,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_77443.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(6110,6109,0,'LSQ12gwg','LSQ',71.3165833333333,-29.0706111111111,NULL,NULL,'2012-11-21 07:30:04',56252.3125499999,20.0959,0.1327,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_77444.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(6111,6109,0,'LSQ12gwg','LSQ',71.3165416666667,-29.0706666666667,NULL,NULL,'2012-11-23 05:27:14',56254.22725,19.7038,0.1662,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_77445.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(6112,6109,0,'LSQ12gwg','LSQ',71.3167083333333,-29.0705555555556,NULL,NULL,'2012-11-23 07:02:30',56254.2934099999,20.2131,0.1315,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_77446.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(6113,6109,0,'LSQ12gwg','LSQ',71.31675,-29.0706666666667,NULL,NULL,'2012-11-24 05:50:46',56255.2435900001,19.7859,0.1783,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_77447.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(6114,6109,0,'LSQ12gwg','LSQ',71.3165,-29.0706944444444,NULL,NULL,'2012-11-24 07:13:56',56255.3013499998,19.941,0.1132,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_77448.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(6115,6109,0,'LSQ12gwg','LSQ',71.3165416666667,-29.0707222222222,NULL,NULL,'2012-11-26 05:51:33',56257.2441400001,19.2576,0.1289,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_77385.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(6116,6109,0,'LSQ12gwg','LSQ',71.3166666666667,-29.0706111111111,NULL,NULL,'2012-11-26 07:14:38',56257.3018399999,19.3624,0.1586,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_77386.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(6117,6117,1,'LSQ12gwf','LSQ',31.6625416666667,-31.2921944444444,NULL,NULL,'2012-11-26 01:56:20',56257.08079,17.9495,0.126,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_history.html','sn?',NULL,0.1321,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_snap_77383.gif',38445793246,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,600715519,9386179,NULL,NULL,NULL,NULL),(6118,6117,0,'LSQ12gwf','LSQ',31.6622916666667,-31.2922777777778,NULL,NULL,'2012-11-26 03:57:11',56257.1647199998,17.2298,0.0624,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_history.html','sn?',NULL,0.1321,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_snap_77384.gif',38445793246,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,600715519,9386179,NULL,NULL,NULL,NULL),(6119,6119,1,'LSQ12gwd','LSQ',26.4444583333333,-31.256,NULL,NULL,'2012-11-26 01:40:50',56257.0700300001,18.5644,0.1045,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwd/LSQ12gwd_history.html','sn?',NULL,0.0554,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwd/LSQ12gwd_snap_77379.gif',38307761501,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,598558773,9352480,NULL,NULL,NULL,NULL),(6120,6119,0,'LSQ12gwd','LSQ',26.4444583333333,-31.2560277777778,NULL,NULL,'2012-11-26 03:41:51',56257.1540700002,18.4123,0.1588,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwd/LSQ12gwd_history.html','sn?',NULL,0.0554,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwd/LSQ12gwd_snap_77380.gif',38307761501,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,598558773,9352480,NULL,NULL,NULL,NULL),(6121,6121,1,'LSQ12gwc','LSQ',55.8400833333333,-26.7370555555556,NULL,NULL,'2012-11-06 01:09:03',56237.0479600001,20.7936,0.1405,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_77434.gif',38526264409,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(6122,6121,0,'LSQ12gwc','LSQ',55.8400833333333,-26.7371666666667,NULL,NULL,'2012-11-06 03:11:45',56237.1331699998,20.5397,0.0989,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_77435.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(6123,6121,0,'LSQ12gwc','LSQ',55.8399583333333,-26.7372222222222,NULL,NULL,'2012-11-07 03:22:45',56238.1408099998,20.7052,0.1121,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_77436.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(6124,6121,0,'LSQ12gwc','LSQ',55.84,-26.7371944444444,NULL,NULL,'2012-11-08 03:19:23',56239.1384700001,20.5369,0.0934,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_77437.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(6125,6121,0,'LSQ12gwc','LSQ',55.8399583333333,-26.7370833333333,NULL,NULL,'2012-11-11 04:26:29',56242.18506,20.9275,0.1288,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_77438.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(6126,6121,0,'LSQ12gwc','LSQ',55.8401666666667,-26.7371944444444,NULL,NULL,'2012-11-12 04:07:19',56243.1717500002,20.4818,0.0699,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_77439.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(6127,6121,0,'LSQ12gwc','LSQ',55.8402916666667,-26.7372222222222,NULL,NULL,'2012-11-13 01:08:42',56244.0477100001,21.3721,0.1455,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_77440.gif',38526264409,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(6128,6121,0,'LSQ12gwc','LSQ',55.8400416666667,-26.7371666666667,NULL,NULL,'2012-11-24 01:07:50',56255.0471100002,20.0465,0.146,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_77441.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(6129,6121,0,'LSQ12gwc','LSQ',55.8399166666667,-26.7371111111111,NULL,NULL,'2012-11-24 03:08:02',56255.1305800001,20.4006,0.126,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_77442.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(6130,6121,0,'LSQ12gwc','LSQ',55.84,-26.7371388888889,NULL,NULL,'2012-11-26 01:09:31',56257.0482800002,19.4904,0.1333,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_77377.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(6131,6121,0,'LSQ12gwc','LSQ',55.8400416666667,-26.7371666666667,NULL,NULL,'2012-11-26 03:10:27',56257.1322599999,18.7203,0.0662,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_77378.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(6132,6132,1,'LSQ12gwb','LSQ',54.0082083333333,-29.7771666666667,NULL,NULL,'2012-11-07 01:16:26',56238.0530900001,22.534,0.2095,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_history.html','sn?',NULL,0.1516,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_snap_77428.gif',38584840201,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602888128,9420127,NULL,NULL,NULL,NULL),(6133,6132,0,'LSQ12gwb','LSQ',54.0084166666667,-29.7771666666667,NULL,NULL,'2012-11-08 03:15:42',56239.1359100002,21.9734,0.1477,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_history.html','sn?',NULL,0.1516,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_snap_77429.gif',38584840201,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602888128,9420127,NULL,NULL,NULL,NULL),(6134,6132,0,'LSQ12gwb','LSQ',54.0082916666667,-29.7768888888889,NULL,NULL,'2012-11-13 01:05:00',56244.0451500001,21.2076,0.1712,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_history.html','sn?',NULL,0.1516,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_snap_77430.gif',38584840201,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602888128,9420127,NULL,NULL,NULL,NULL),(6135,6132,0,'LSQ12gwb','LSQ',54.0082083333333,-29.7773611111111,NULL,NULL,'2012-11-14 03:12:50',56245.1339199999,22.4058,0.1756,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_history.html','sn?',NULL,0.1516,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_snap_77431.gif',38584840201,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602888128,9420127,NULL,NULL,NULL,NULL),(6136,6132,0,'LSQ12gwb','LSQ',54.0080833333333,-29.7770555555556,NULL,NULL,'2012-11-24 01:04:09',56255.0445500002,20.2864,0.15,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_history.html','sn?',NULL,0.1516,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_snap_77432.gif',38584840201,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602888128,9420127,NULL,NULL,NULL,NULL),(6137,6132,0,'LSQ12gwb','LSQ',54.0080833333333,-29.7771388888889,NULL,NULL,'2012-11-24 03:04:20',56255.1280100001,19.8669,0.1331,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_history.html','sn?',NULL,0.1516,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_snap_77433.gif',38584840201,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602888128,9420127,NULL,NULL,NULL,NULL),(6138,6132,0,'LSQ12gwb','LSQ',54.0079166666667,-29.7771944444444,NULL,NULL,'2012-11-26 01:05:50',56257.0457199998,20.2443,0.1136,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_history.html','sn?',NULL,0.1516,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_snap_77375.gif',38584840203,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602888128,9420127,NULL,NULL,NULL,NULL),(6139,6132,0,'LSQ12gwb','LSQ',54.0079583333333,-29.7771111111111,NULL,NULL,'2012-11-26 03:06:46',56257.1296999999,19.8122,0.083,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_history.html','sn?',NULL,0.1516,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_snap_77376.gif',38584840201,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602888128,9420127,NULL,NULL,NULL,NULL),(6140,6140,1,'LSQ12gvz','LSQ',67.4929583333333,-29.7281111111111,NULL,NULL,'2012-11-21 07:02:51',56252.2936499999,18.2713,0.064,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvz/LSQ12gvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvz/LSQ12gvz_snap_77420.gif',37657477973,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,588398093,9193720,NULL,NULL,NULL,NULL),(6141,6140,0,'LSQ12gvz','LSQ',67.4930416666667,-29.7280833333333,NULL,NULL,'2012-11-23 05:22:10',56254.2237300002,17.9827,0.0592,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvz/LSQ12gvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvz/LSQ12gvz_snap_77421.gif',37657477973,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,588398093,9193720,NULL,NULL,NULL,NULL),(6142,6140,0,'LSQ12gvz','LSQ',67.4930833333333,-29.7281666666667,NULL,NULL,'2012-11-26 05:46:27',56257.2406000001,18.9249,0.1392,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvz/LSQ12gvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvz/LSQ12gvz_snap_77371.gif',37657477973,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,588398093,9193720,NULL,NULL,NULL,NULL),(6143,6140,0,'LSQ12gvz','LSQ',67.493375,-29.7283055555556,NULL,NULL,'2012-11-26 07:40:11',56257.3195799999,18.7973,0.1552,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvz/LSQ12gvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvz/LSQ12gvz_snap_77372.gif',37657477973,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,588398093,9193720,NULL,NULL,NULL,NULL),(6144,6144,1,'LSQ12gvw','LSQ',17.5192083333333,-31.9529444444444,NULL,NULL,'2012-11-03 04:02:33',56234.1684400002,20.0393,0.0971,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_history.html','sn - nice',NULL,0.1397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_snap_77405.gif',34744530696,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542883292,8482551,NULL,NULL,NULL,NULL),(6145,6144,0,'LSQ12gvw','LSQ',17.5191666666667,-31.9529722222222,NULL,NULL,'2012-11-21 01:54:23',56252.07944,19.5927,0.0884,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_history.html','sn - nice',NULL,0.1397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_snap_77406.gif',34744530696,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542883292,8482551,NULL,NULL,NULL,NULL),(6146,6144,0,'LSQ12gvw','LSQ',17.519125,-31.953,NULL,NULL,'2012-11-23 03:50:15',56254.1598999999,19.1274,0.0687,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_history.html','sn - nice',NULL,0.1397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_snap_77407.gif',34744530696,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542883292,8482551,NULL,NULL,NULL,NULL),(6147,6144,0,'LSQ12gvw','LSQ',17.519125,-31.9528888888889,NULL,NULL,'2012-11-24 01:13:35',56255.0510999998,19.5161,0.0943,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_history.html','sn - nice',NULL,0.1397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_snap_77408.gif',34744530696,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542883292,8482551,NULL,NULL,NULL,NULL),(6148,6144,0,'LSQ12gvw','LSQ',17.51925,-31.9528055555556,NULL,NULL,'2012-11-26 01:15:16',56257.0522699999,19.1401,0.1089,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_history.html','sn - nice',NULL,0.1397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_snap_77365.gif',34744530696,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542883292,8482551,NULL,NULL,NULL,NULL),(6149,6144,0,'LSQ12gvw','LSQ',17.5193333333333,-31.9528611111111,NULL,NULL,'2012-11-26 03:16:17',56257.13631,19.0264,0.1221,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_history.html','sn - nice',NULL,0.1397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_snap_77366.gif',34744530696,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542883292,8482551,NULL,NULL,NULL,NULL),(6150,6150,1,'LSQ12gvs','LSQ',64.3945833333333,-38.8895833333333,NULL,NULL,'2012-11-23 02:40:48',56254.11167,19.3581,0.0869,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_77347.gif',37791067653,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(6151,6150,0,'LSQ12gvs','LSQ',64.3944166666667,-38.8894722222222,NULL,NULL,'2012-11-23 04:41:12',56254.1952800001,19.4986,0.1156,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_77348.gif',37791067655,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(6152,6150,0,'LSQ12gvs','LSQ',64.3943333333333,-38.8894722222222,NULL,NULL,'2012-11-24 07:58:18',56255.3321600002,18.8909,0.0534,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_77349.gif',37791067652,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(6153,6150,0,'LSQ12gvs','LSQ',64.3945,-38.8895,NULL,NULL,'2012-11-26 05:10:38',56257.2157200002,18.0649,0.0399,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_77273.gif',37791067655,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(6154,6150,0,'LSQ12gvs','LSQ',64.3944166666667,-38.8894722222222,NULL,NULL,'2012-11-26 07:57:07',56257.33134,18.1073,0.0304,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_77274.gif',37791067655,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(6155,6155,1,'LSQ12gve','LSQ',51.1094583333333,-11.6691388888889,NULL,NULL,'2012-10-10 05:27:16',56210.2272800002,19.8928,0.1495,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_76927.gif',37885390163,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(6156,6155,0,'LSQ12gve','LSQ',51.1093333333333,-11.6691388888889,NULL,NULL,'2012-10-12 07:24:27',56212.30865,19.072,0.1448,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_76928.gif',37885390163,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(6157,6155,0,'LSQ12gve','LSQ',51.1094583333333,-11.6691944444444,NULL,NULL,'2012-10-12 08:20:10',56212.3473399999,20.2962,0.1821,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_76929.gif',37885390163,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(6158,6155,0,'LSQ12gve','LSQ',51.1100416666667,-11.6696111111111,NULL,NULL,'2012-10-16 06:06:02',56216.2541899998,19.9749,0.1653,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_76930.gif',37885390161,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(6159,6155,0,'LSQ12gve','LSQ',51.1095833333333,-11.6691111111111,NULL,NULL,'2012-10-16 08:15:48',56216.3443100001,18.1669,0.0845,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_76931.gif',37885390163,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(6160,6155,0,'LSQ12gve','LSQ',51.1098333333333,-11.6695,NULL,NULL,'2012-10-24 07:17:09',56224.3035800001,19.6584,0.1274,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_76932.gif',37885390161,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(6161,6155,0,'LSQ12gve','LSQ',51.1096666666667,-11.6695,NULL,NULL,'2012-11-06 07:10:44',56237.2991300002,18.7892,0.1788,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_76933.gif',37885390161,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(6162,6155,0,'LSQ12gve','LSQ',51.109875,-11.6695,NULL,NULL,'2012-11-08 07:16:54',56239.3034100002,18.8542,0.1348,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_76934.gif',37885390161,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(6163,6155,0,'LSQ12gve','LSQ',51.110125,-11.6694166666667,NULL,NULL,'2012-11-10 03:37:33',56241.1510800002,16.8777,0.0414,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_76935.gif',37885390161,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(6164,6155,0,'LSQ12gve','LSQ',51.1099583333333,-11.6696111111111,NULL,NULL,'2012-11-25 02:50:47',56256.1186000002,18.4893,0.0912,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_76936.gif',37885390161,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(6165,6155,0,'LSQ12gve','LSQ',51.1095833333333,-11.6694444444444,NULL,NULL,'2012-11-27 02:43:29',56258.1135399998,18.2361,0.1338,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_76858.gif',37885390161,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(6166,6155,0,'LSQ12gve','LSQ',51.109625,-11.6694166666667,NULL,NULL,'2012-11-27 04:46:48',56258.1991699999,17.3769,0.0727,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_76859.gif',37885390161,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(6167,6167,1,'LSQ12gvb','LSQ',46.528,-2.58205555555556,NULL,NULL,'2012-10-18 08:19:39',56218.34699,20.0468,0.2088,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_76912.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(6168,6167,0,'LSQ12gvb','LSQ',46.5281666666667,-2.58213888888889,NULL,NULL,'2012-10-20 08:53:08',56220.3702400001,19.8644,0.2116,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_76913.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(6169,6167,0,'LSQ12gvb','LSQ',46.5284166666667,-2.58213888888889,NULL,NULL,'2012-11-25 04:11:10',56256.1744300001,17.0391,0.0796,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_76914.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(6170,6167,0,'LSQ12gvb','LSQ',46.5284583333333,-2.58211111111111,NULL,NULL,'2012-11-27 02:05:47',56258.0873500002,17.608,0.136,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_76852.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(6171,6167,0,'LSQ12gvb','LSQ',46.528375,-2.58216666666667,NULL,NULL,'2012-11-27 04:08:50',56258.1728099999,17.2787,0.111,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_76853.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(6172,6172,1,'LSQ12guy','LSQ',151.693041666667,-6.18858333333333,NULL,NULL,'2012-11-27 06:38:57',56258.2770500001,18.4947,0.1067,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guy/LSQ12guy_history.html','sn?',NULL,0.055375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guy/LSQ12guy_snap_76846.gif',41247382850,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,644490357,10070161,NULL,NULL,NULL,NULL),(6173,6172,0,'LSQ12guy','LSQ',151.693125,-6.18858333333333,NULL,NULL,'2012-11-27 07:38:34',56258.3184600002,18.9249,0.119,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guy/LSQ12guy_history.html','sn?',NULL,0.055375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guy/LSQ12guy_snap_76847.gif',41247382850,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,644490357,10070161,NULL,NULL,NULL,NULL),(6174,6174,1,'LSQ12gur','LSQ',154.06625,-16.6475,NULL,NULL,'2012-11-25 06:23:19',56256.2662,19.6088,0.167,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gur/LSQ12gur_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gur/LSQ12gur_snap_76833.gif',41163689304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643182645,10049728,NULL,NULL,NULL,NULL),(6175,6174,0,'LSQ12gur','LSQ',154.066416666667,-16.6473888888889,NULL,NULL,'2012-11-27 06:18:27',56258.2628199998,19.2232,0.1423,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-11-28 15:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gur/LSQ12gur_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gur/LSQ12gur_snap_76829.gif',41163689336,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643182645,10049728,NULL,NULL,NULL,NULL),(6176,6174,0,'LSQ12gur','LSQ',154.066125,-16.6476111111111,NULL,NULL,'2012-11-27 07:56:17',56258.3307599998,19.2409,0.1257,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-11-28 15:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gur/LSQ12gur_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gur/LSQ12gur_snap_76830.gif',41163689304,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643182645,10049728,NULL,NULL,NULL,NULL),(6177,6177,1,'LSQ12guq','LSQ',39.2714583333333,-20.5101666666667,NULL,NULL,'2012-11-27 02:16:02',56258.0944699999,18.6998,0.1346,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guq/LSQ12guq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guq/LSQ12guq_snap_76827.gif',37939057755,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592797777,9262465,NULL,NULL,NULL,NULL),(6178,6177,0,'LSQ12guq','LSQ',39.2716666666667,-20.5101111111111,NULL,NULL,'2012-11-27 04:19:10',56258.17998,18.7037,0.1279,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guq/LSQ12guq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guq/LSQ12guq_snap_76828.gif',37939057755,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592797777,9262465,NULL,NULL,NULL,NULL),(6179,6179,1,'LSQ12gup','LSQ',20.1577916666667,-17.6860833333333,NULL,NULL,'2012-11-27 01:24:47',56258.0588799999,17.8542,0.0646,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gup/LSQ12gup_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gup/LSQ12gup_snap_76825.gif',35187015732,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549797120,8590580,NULL,NULL,NULL,NULL),(6180,6179,0,'LSQ12gup','LSQ',20.1578333333333,-17.6861388888889,NULL,NULL,'2012-11-27 03:25:43',56258.14286,18.3347,0.0879,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 15:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gup/LSQ12gup_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gup/LSQ12gup_snap_76826.gif',35187015732,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549797120,8590580,NULL,NULL,NULL,NULL),(6181,6012,0,'LSQ12gum','LSQ',140.764916666667,-2.62205555555556,NULL,NULL,'2012-03-31 01:34:09',56017.0653900001,19.4729,0.1674,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gum/LSQ12gum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gum/LSQ12gum_snap_77499.gif',41127022392,NULL,NULL,NULL,'2012-03-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642609724,10040776,NULL,NULL,NULL,NULL),(6182,6182,1,'LSQ12gwl','LSQ',55.021875,-21.50475,NULL,NULL,'2012-11-03 07:17:06',56234.3035499998,19.9072,0.1212,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_snap_77494.gif',38047180768,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594487199,9288862,NULL,NULL,NULL,NULL),(6183,6182,0,'LSQ12gwl','LSQ',55.0219166666667,-21.5046388888889,NULL,NULL,'2012-11-15 06:18:12',56246.2626499999,20.8052,0.166,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_snap_77495.gif',38047180768,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594487199,9288862,NULL,NULL,NULL,NULL),(6184,6182,0,'LSQ12gwl','LSQ',55.0220416666667,-21.5048333333333,NULL,NULL,'2012-11-21 02:36:53',56252.1089499998,19.7405,0.1327,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_snap_77496.gif',38047180560,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594487196,9288862,NULL,NULL,NULL,NULL),(6185,6182,0,'LSQ12gwl','LSQ',55.0219583333333,-21.5048055555556,NULL,NULL,'2012-11-23 04:32:44',56254.1894,20.0063,0.1141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_snap_77497.gif',38047180768,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594487199,9288862,NULL,NULL,NULL,NULL),(6186,6182,0,'LSQ12gwl','LSQ',55.0214166666667,-21.5047777777778,NULL,NULL,'2012-11-26 02:54:28',56257.1211600001,20.2651,0.1602,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_snap_77457.gif',38047180768,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594487199,9288862,NULL,NULL,NULL,NULL),(6187,6182,0,'LSQ12gwl','LSQ',55.0214583333333,-21.5045277777778,NULL,NULL,'2012-11-26 04:55:24',56257.2051499998,20.1422,0.1576,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_snap_77458.gif',38047180768,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594487199,9288862,NULL,NULL,NULL,NULL),(6188,6188,1,'LSQ12gwk','LSQ',44.3659583333333,-25.3956111111111,NULL,NULL,'2012-11-05 07:55:17',56236.3300600001,20.6063,0.2006,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_77482.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(6189,6188,0,'LSQ12gwk','LSQ',44.3660416666667,-25.39525,NULL,NULL,'2012-11-07 06:34:56',56238.2742599999,19.5675,0.1445,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_77483.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(6190,6188,0,'LSQ12gwk','LSQ',44.3660416666667,-25.3955277777778,NULL,NULL,'2012-11-11 04:31:52',56242.1888000001,19.9259,0.1847,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_77484.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(6191,6188,0,'LSQ12gwk','LSQ',44.366,-25.3954166666667,NULL,NULL,'2012-11-11 06:31:30',56242.2718799999,20.162,0.1555,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_77485.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(6192,6188,0,'LSQ12gwk','LSQ',44.3660833333333,-25.3952222222222,NULL,NULL,'2012-11-15 04:50:57',56246.20206,20.2155,0.1561,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_77486.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(6193,6188,0,'LSQ12gwk','LSQ',44.3662916666667,-25.3951944444444,NULL,NULL,'2012-11-17 04:18:47',56248.1797199999,20.3644,0.1528,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_77487.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(6194,6188,0,'LSQ12gwk','LSQ',44.366,-25.3954722222222,NULL,NULL,'2012-11-19 02:12:07',56250.0917500001,19.6702,0.1369,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_77488.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(6195,6188,0,'LSQ12gwk','LSQ',44.36625,-25.3954722222222,NULL,NULL,'2012-11-21 02:08:04',56252.0889400002,19.6365,0.1193,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_77489.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(6196,6188,0,'LSQ12gwk','LSQ',44.3662083333333,-25.3950833333333,NULL,NULL,'2012-11-21 04:09:26',56252.1732200002,20.1276,0.1932,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_77490.gif',38420060774,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(6197,6188,0,'LSQ12gwk','LSQ',44.3662083333333,-25.3952222222222,NULL,NULL,'2012-11-23 02:03:25',56254.0857099998,20.4261,0.2129,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_77491.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(6198,6188,0,'LSQ12gwk','LSQ',44.366,-25.3953333333333,NULL,NULL,'2012-11-23 04:03:56',56254.1694,19.8143,0.1449,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_77492.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(6199,6188,0,'LSQ12gwk','LSQ',44.3665,-25.3950555555556,NULL,NULL,'2012-11-24 02:23:15',56255.0994799999,19.4838,0.1447,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_77493.gif',38420060774,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(6200,6188,0,'LSQ12gwk','LSQ',44.3661666666667,-25.3953333333333,NULL,NULL,'2012-11-26 02:25:24',56257.1009800001,19.7071,0.1521,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_77455.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(6201,6188,0,'LSQ12gwk','LSQ',44.3660833333333,-25.3955277777778,NULL,NULL,'2012-11-26 04:26:07',56257.18481,19.0854,0.146,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_77456.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(6202,6202,1,'LSQ12gwe','LSQ',28.3097916666667,-33.1558611111111,NULL,NULL,'2012-11-26 01:42:31',56257.0712000001,20.3393,0.1533,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwe/LSQ12gwe_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwe/LSQ12gwe_snap_77381.gif',38310012650,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,598593947,9353030,NULL,NULL,NULL,NULL),(6203,6202,0,'LSQ12gwe','LSQ',28.3097083333333,-33.1559444444444,NULL,NULL,'2012-11-26 03:43:32',56257.1552400002,20.144,0.1479,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwe/LSQ12gwe_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwe/LSQ12gwe_snap_77382.gif',38310012650,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,598593947,9353030,NULL,NULL,NULL,NULL),(6204,6204,1,'LSQ12guu','LSQ',24.469,-16.26925,NULL,NULL,'2012-10-25 08:02:06',56225.3347999998,14.8914,0.0031,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guu/LSQ12guu_history.html','unusual variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guu/LSQ12guu_snap_76878.gif',35192089516,NULL,NULL,NULL,'2012-10-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,549876398,8591818,NULL,NULL,NULL,NULL),(6205,6204,0,'LSQ12guu','LSQ',24.468875,-16.26925,NULL,NULL,'2012-11-27 01:31:35',56258.0636,14.8376,0.0049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guu/LSQ12guu_history.html','unusual variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guu/LSQ12guu_snap_76838.gif',35192089516,NULL,NULL,NULL,'2012-10-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,549876398,8591818,NULL,NULL,NULL,NULL),(6206,6204,0,'LSQ12guu','LSQ',24.4689166666667,-16.2693333333333,NULL,NULL,'2012-11-27 03:32:35',56258.14763,15.8798,0.0097,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 20:46:19','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guu/LSQ12guu_history.html','unusual variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guu/LSQ12guu_snap_76839.gif',35192089516,NULL,NULL,NULL,'2012-10-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,549876398,8591818,NULL,NULL,NULL,NULL),(6207,6012,0,'LSQ12gum','LSQ',140.764958333333,-2.62222222222222,NULL,NULL,'2012-04-01 01:30:35',56018.0629099999,19.6348,0.1365,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-28 21:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gum/LSQ12gum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gum/LSQ12gum_snap_77501.gif',41127022340,NULL,NULL,NULL,'2012-03-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642609724,10040776,NULL,NULL,NULL,NULL),(6208,6012,0,'LSQ12gum','LSQ',140.764875,-2.62208333333333,NULL,NULL,'2012-04-07 00:28:37',56024.01988,19.4542,0.1583,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-29 04:46:21','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gum/LSQ12gum_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gum/LSQ12gum_snap_77503.gif',41127022392,NULL,NULL,NULL,'2012-03-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642609724,10040776,NULL,NULL,NULL,NULL),(6209,6209,1,'LSQ12gwn','LSQ',157.355875,-20.0197222222222,NULL,NULL,'2012-11-27 06:35:29',56258.27465,18.3034,0.0824,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-29 17:46:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwn/LSQ12gwn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwn/LSQ12gwn_snap_77511.gif',41663494579,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,650992102,10171751,NULL,NULL,NULL,NULL),(6210,6209,0,'LSQ12gwn','LSQ',157.356416666667,-20.0198888888889,NULL,NULL,'2012-11-29 07:36:47',56260.3172200001,18.8159,0.1139,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-29 17:46:15','2012-11-29 17:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwn/LSQ12gwn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwn/LSQ12gwn_snap_77509.gif',41663494577,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,650992102,10171751,NULL,NULL,NULL,NULL),(6211,6209,0,'LSQ12gwn','LSQ',157.356333333333,-20.02,NULL,NULL,'2012-11-29 08:06:46',56260.3380399998,18.7493,0.1056,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-11-29 17:46:15','2012-11-29 17:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwn/LSQ12gwn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwn/LSQ12gwn_snap_77510.gif',41663494577,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,650992102,10171751,NULL,NULL,NULL,NULL),(6860,6860,1,'CSS121107-023126+073032','CRTS-CSS',37.85946,7.50887,NULL,NULL,'2012-11-07 07:43:20',56238.32970299991,18.9242,0.030039,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:18','2019-10-11 14:10:04','http://nunuku.cacr.caltech.edu/catalina/20121107/1211071070144131502.html',' Supernova ','css ng',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121107/jpg/1211071070144131502.master.jpg',NULL,NULL,66870290120,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:18','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211071070144131502.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121107/1211071070144131502p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1044848283,16325754,NULL,NULL,NULL,NULL),(6861,6861,0,'CSS121013-025604+005601','CRTS-CSS',44.01826,0.93362,NULL,NULL,'2012-10-13 08:31:26',56213.36191400001,19.2393,0.039518,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:20','2019-10-12 20:41:36','http://nunuku.cacr.caltech.edu/catalina/20121013/1210131010164113786.html',' Supernova ','css ng',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121013/jpg/1210131010164113786.master.jpg',NULL,NULL,66840898905,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:20','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210131010164113786.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121013/1210131010164113786p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,1044389045,16318578,NULL,NULL,NULL,NULL),(6862,6862,1,'CSS121013-012715+005224','CRTS-CSS',21.81079,0.87337,NULL,NULL,'2012-10-13 07:47:32',56213.33372099977,19.0832,0.03558,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:20','2019-10-11 14:10:04','http://nunuku.cacr.caltech.edu/catalina/20121013/1210131010084212549.html',' Supernova ','css ng',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121013/jpg/1210131010084212549.master.jpg',NULL,NULL,67512114322,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:20','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210131010084212549.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121013/1210131010084212549p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1054876786,16482449,NULL,NULL,NULL,NULL),(6863,2083,0,'CSS120924-025113+202319','CRTS-CSS',42.80435,20.38864,NULL,NULL,'2012-09-24 11:28:03',56194.48054300016,19.4938,0.044454,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:21','2019-08-18 22:06:58','http://nesssi.cacr.caltech.edu/catalina/20120924/1209241210154109886.html',' Supernova ','css ng',NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120924/jpg/1209241210154109886.master.jpg',NULL,NULL,68122905200,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209241210154109886.atel.html','http://nesssi.cacr.caltech.edu/catalina/20120924/1209241210154109886p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1064420393,16631568,NULL,NULL,NULL,NULL),(6864,6864,1,'CSS121106-223422+115843','CRTS-CSS',338.58992,11.97849,NULL,NULL,'2012-11-06 02:44:19',56237.121152000036,17.2272,0.013389,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:21','2019-10-11 14:10:04','http://nunuku.cacr.caltech.edu/catalina/20121106/1211061121194114499.html','Supernova or Other','css p60',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121106/jpg/1211061121194114499.master.jpg',NULL,NULL,52580852054,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211061121194114499.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121106/1211061121194114499p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,821575813,12837122,NULL,NULL,NULL,NULL),(6865,6865,1,'CSS121104-215546-160056','CRTS-CSS',328.9418,-16.01564,NULL,NULL,'2012-11-04 02:10:59',56235.0977289998,19.1515,0.037613,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:21','2019-10-11 14:10:04','http://nunuku.cacr.caltech.edu/catalina/20121104/1211040151144115708.html','Supernova or Other','css p60',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121104/jpg/1211040151144115708.master.jpg',NULL,NULL,49784688532,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211040151144115708.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121104/1211040151144115708p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,777885758,12154464,NULL,NULL,NULL,NULL),(6866,6866,1,'CSS121102-020858+324040','CRTS-CSS',32.24018,32.6777,NULL,NULL,'2012-11-02 09:41:05',56233.41267800005,16.2813,0.010259,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:22','2019-10-11 14:10:04','http://nunuku.cacr.caltech.edu/catalina/20121102/1211021320104124291.html','Supernova or Other','css p60',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121102/jpg/1211021320104124291.master.jpg',NULL,NULL,68626915358,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211021320104124291.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121102/1211021320104124291p.html',NULL,NULL,0,'AGN',NULL,0,NULL,0,1072295552,16754618,NULL,NULL,NULL,NULL),(6867,6867,0,'CSS121026-164652+565105','CRTS-CSS',251.71873,56.8515,NULL,NULL,'2012-10-26 02:07:23',56226.09297099989,17.9644,0.02431,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:22','2019-10-12 20:41:36','http://nunuku.cacr.caltech.edu/catalina/20121026/1210261570504105230.html',' Supernova ','css p60',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121026/jpg/1210261570504105230.master.jpg',NULL,NULL,57707182704,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210261570504105230.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121026/1210261570504105230p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,901674729,14088667,NULL,NULL,NULL,NULL),(6868,6868,1,'CSS121026-165528+590727','CRTS-CSS',253.86609,59.12406,NULL,NULL,'2012-10-26 02:06:40',56226.09247000003,18.7524,0.034815,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:23','2019-10-11 14:10:04','http://nunuku.cacr.caltech.edu/catalina/20121026/1210261570514139359.html',' Supernova ','css p60',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121026/jpg/1210261570514139359.master.jpg',NULL,NULL,57702993251,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210261570514139359.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121026/1210261570514139359p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,901609269,14087644,NULL,NULL,NULL,NULL),(6870,2721,0,'CSS121015-004244+132827','CRTS-CSS',10.68478,13.47403,NULL,NULL,'2012-10-15 05:58:37',56215.25927900011,18.2873,0.025948,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:24','2019-08-18 22:06:58','http://nunuku.cacr.caltech.edu/catalina/20121015/1210151120044133047.html',' Supernova ','css p60',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121015/jpg/1210151120044133047.master.jpg',NULL,NULL,67465270359,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210151120044133047.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121015/1210151120044133047p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1054144849,16471013,NULL,NULL,NULL,NULL),(6871,6871,1,'CSS121011-163803+372814','CRTS-CSS',249.51397,37.47047,NULL,NULL,'2012-10-11 03:22:45',56211.148138000164,16.8154,0.013318,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:24','2019-10-11 14:10:04','http://nunuku.cacr.caltech.edu/catalina/20121011/1210111380724113233.html',' Supernova ','css p60',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121011/jpg/1210111380724113233.master.jpg',NULL,NULL,59821232531,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210111380724113233.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121011/1210111380724113233p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,934706758,14604793,NULL,NULL,NULL,NULL),(6872,6872,1,'CSS121004-234546+231402','CRTS-CSS',356.4417,23.23382,NULL,NULL,'2012-10-04 08:56:03',56204.379102000035,18.5632,0.030148,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121004/1210041231174109433.html',' Supernova ','css p60',NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121004/jpg/1210041231174109433.master.jpg',NULL,NULL,51951956687,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210041231174109433.atel.html','http://nesssi.cacr.caltech.edu/catalina/20121004/1210041231174109433p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,811749323,12683583,NULL,NULL,NULL,NULL),(6873,6873,1,'CSS120926-040338-104946','CRTS-CSS',60.90987,-10.82931,NULL,NULL,'2012-09-26 10:18:34',56196.43630099995,17.4793,0.028545,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120926/1209260090224105038.html','Supernova or Other','css p60',NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120926/jpg/1209260090224105038.master.jpg',NULL,NULL,36988642833,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209260090224105038.atel.html','http://nesssi.cacr.caltech.edu/catalina/20120926/1209260090224105038p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,577947544,9030430,NULL,NULL,NULL,NULL),(6874,6874,0,'CSS120926-174312+364602','CRTS-CSS',265.80076,36.76736,NULL,NULL,'2012-09-26 03:22:35',56196.146980000194,17.5947,0.018635,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:25','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120926/1209261380774102309.html',' Supernova ','css p60',NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120926/jpg/1209261380774102309.master.jpg',NULL,NULL,56147295808,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209261380774102309.atel.html','http://nesssi.cacr.caltech.edu/catalina/20120926/1209261380774102309p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,877301497,13707835,NULL,NULL,NULL,NULL),(6875,2143,0,'CSS120926-171458+344754','CRTS-CSS',258.74065,34.79828,NULL,NULL,'2012-09-26 02:42:51',56196.11993099982,18.7024,0.031525,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:26','2019-08-18 22:06:58','http://nesssi.cacr.caltech.edu/catalina/20120926/1209261350774119449.html',' Supernova ','css p60',NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120926/jpg/1209261350774119449.master.jpg',NULL,NULL,56351560770,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209261350774119449.atel.html','http://nesssi.cacr.caltech.edu/catalina/20120926/1209261350774119449p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,880493137,13757705,NULL,NULL,NULL,NULL),(6876,2082,0,'CSS120925-003040+123156','CRTS-CSS',7.66862,12.53233,NULL,NULL,'2012-09-25 08:57:02',56195.37843400007,18.9366,0.030849,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:26','2019-08-18 22:06:58','http://nesssi.cacr.caltech.edu/catalina/20120925/1209251120034120839.html',' Supernova ','css p60',NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120925/jpg/1209251120034120839.master.jpg',NULL,NULL,66749501117,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209251120034120839.atel.html','http://nesssi.cacr.caltech.edu/catalina/20120925/1209251120034120839p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1042960954,16296264,NULL,NULL,NULL,NULL),(6877,6877,1,'CSS121011-043024+352112','CRTS-CSS',67.59915,35.35331,NULL,NULL,'2012-10-11 06:46:08',56211.289985000156,17.6032,0.022374,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:26','2019-10-11 14:10:04','http://nunuku.cacr.caltech.edu/catalina/20121011/1210111350204155747.html',' Other ','css wc',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121011/jpg/1210111350204155747.master.jpg',NULL,NULL,68339538299,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210111350204155747.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121011/1210111350204155747p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1067805285,16684457,NULL,NULL,NULL,NULL),(6878,6878,1,'CSS121009-014901-103707','CRTS-CSS',27.25381,-10.61857,NULL,NULL,'2012-10-09 10:52:32',56209.458858000115,18.7548,0.032302,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:27','2019-10-11 14:10:04','http://nunuku.cacr.caltech.edu/catalina/20121009/1210090090104107398.html','Supernova or Other','css wc',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121009/jpg/1210090090104107398.master.jpg',NULL,NULL,35113149384,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210090090104107398.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121009/1210090090104107398p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548642959,8572546,NULL,NULL,NULL,NULL),(6879,6879,1,'CSS121009-011101-172841','CRTS-CSS',17.7543,-17.47819,NULL,NULL,'2012-10-09 09:16:24',56209.39210799988,17.2568,0.016381,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:27','2019-10-11 14:10:04','http://nunuku.cacr.caltech.edu/catalina/20121009/1210090180074131839.html',' Supernova ','css wc',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121009/jpg/1210090180074131839.master.jpg',NULL,NULL,35420225404,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210090180074131839.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121009/1210090180074131839p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,553441021,8647515,NULL,NULL,NULL,NULL),(6880,6880,1,'CSS121009-014120-093343','CRTS-CSS',25.33279,-9.56205,NULL,NULL,'2012-10-09 08:14:56',56209.34952200018,18.9007,0.033183,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:28','2019-10-11 14:10:04','http://nunuku.cacr.caltech.edu/catalina/20121009/1210090090094131313.html',' Supernova ','css wc',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121009/jpg/1210090090094131313.master.jpg',NULL,NULL,34983863870,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210090090094131313.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121009/1210090090094131313p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,546622872,8540982,NULL,NULL,NULL,NULL),(6881,6881,1,'CSS121009-003303-171918','CRTS-CSS',8.26349,-17.32177,NULL,NULL,'2012-10-09 07:40:28',56209.32478100015,18.961,0.035091,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:28','2019-10-11 14:10:04','http://nunuku.cacr.caltech.edu/catalina/20121009/1210090180034141802.html','Supernova or Other','css wc',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121009/jpg/1210090180034141802.master.jpg',NULL,NULL,35356286383,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210090180034141802.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121009/1210090180034141802p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,552441974,8631905,NULL,NULL,NULL,NULL),(6882,6882,1,'CSS121009-222623-200236','CRTS-CSS',336.59437,-20.04335,NULL,NULL,'2012-10-09 04:02:17',56209.1739889998,19.2752,0.040289,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:28','2019-10-11 14:10:04','http://nunuku.cacr.caltech.edu/catalina/20121009/1210090211144147393.html',' Supernova ','css wc',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121009/jpg/1210090211144147393.master.jpg',NULL,NULL,50253613801,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210090211144147393.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121009/1210090211144147393p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,785212715,12268948,NULL,NULL,NULL,NULL),(6883,2187,0,'CSS121008-014245+213928','CRTS-CSS',25.68653,21.65791,NULL,NULL,'2012-10-08 08:41:00',56208.36687400006,17.0021,0.01426,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:29','2019-08-18 22:06:58','http://nunuku.cacr.caltech.edu/catalina/20121008/1210081210094133123.html',' Supernova ','css wc',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121008/jpg/1210081210094133123.master.jpg',NULL,NULL,67379548386,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210081210094133123.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121008/1210081210094133123p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1052805443,16450085,NULL,NULL,NULL,NULL),(6884,6884,1,'CSS121008-020128+205712','CRTS-CSS',30.36783,20.95331,NULL,NULL,'2012-10-08 08:42:39',56208.36799600022,19.4142,0.043659,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:29','2019-10-11 14:10:04','http://nunuku.cacr.caltech.edu/catalina/20121008/1210081210114120908.html',' Supernova ','css wc',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121008/jpg/1210081210114120908.master.jpg',NULL,NULL,68055580210,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210081210114120908.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121008/1210081210114120908p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1063368440,16615131,NULL,NULL,NULL,NULL),(6885,6885,1,'CSS121008-020224+121637','CRTS-CSS',30.60101,12.27701,NULL,NULL,'2012-10-08 08:36:08',56208.36351099983,19.8605,0.053332,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:30','2019-10-11 14:10:04','http://nunuku.cacr.caltech.edu/catalina/20121008/1210081120114116244.html',' Supernova ','css wc',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121008/jpg/1210081120114116244.master.jpg',NULL,NULL,66949511250,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210081120114116244.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121008/1210081120114116244p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1046086113,16345095,NULL,NULL,NULL,NULL),(6886,6886,1,'CSS121008-222627+264706','CRTS-CSS',336.61384,26.78498,NULL,NULL,'2012-10-08 02:08:55',56208.09357499983,18.8867,0.033292,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:30','2019-10-11 14:10:04','http://nunuku.cacr.caltech.edu/catalina/20121008/1210081261094137553.html',' UVCeti Variable or Supernova ','css wc',NULL,NULL,NULL,'http://nunuku.cacr.caltech.edu/catalina/20121008/jpg/1210081261094137553.master.jpg',NULL,NULL,51888958927,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210081261094137553.atel.html','http://nunuku.cacr.caltech.edu/catalina/20121008/1210081261094137553p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,810764983,12668202,NULL,NULL,NULL,NULL),(6887,2173,0,'CSS121006-015926+014412','CRTS-CSS',29.85829,1.73662,NULL,NULL,'2012-10-06 09:51:02',56206.417301000096,17.5424,0.018997,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:30','2019-08-18 22:06:58','http://nesssi.cacr.caltech.edu/catalina/20121006/1210061010114123149.html',' Supernova ','css wc',NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121006/jpg/1210061010114123149.master.jpg',NULL,NULL,67007717200,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210061010114123149.atel.html','http://nesssi.cacr.caltech.edu/catalina/20121006/1210061010114123149p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1046995581,16359305,NULL,NULL,NULL,NULL),(6888,2172,0,'CSS121006-232854+085452','CRTS-CSS',352.22702,8.91432,NULL,NULL,'2012-10-06 03:51:09',56206.167200000025,18.3124,0.02883,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:31','2019-08-18 22:06:58','http://nesssi.cacr.caltech.edu/catalina/20121006/1210061091254108515.html',' Supernova ','css wc',NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121006/jpg/1210061091254108515.master.jpg',NULL,NULL,51797447596,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210061091254108515.atel.html','http://nesssi.cacr.caltech.edu/catalina/20121006/1210061091254108515p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,809335118,12645861,NULL,NULL,NULL,NULL),(6889,2576,0,'CSS121005-230022+025357','CRTS-CSS',345.0932,2.89924,NULL,NULL,'2012-10-05 04:24:49',56205.192187000066,18.3341,0.02639,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:31','2019-08-18 22:06:58','http://nesssi.cacr.caltech.edu/catalina/20121005/1210051041234102585.html',' Supernova ','css wc',NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121005/jpg/1210051041234102585.master.jpg',NULL,NULL,51738378615,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210051041234102585.atel.html','http://nesssi.cacr.caltech.edu/catalina/20121005/1210051041234102585p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,808412165,12631440,NULL,NULL,NULL,NULL),(6890,6890,1,'CSS121005-230710+080203','CRTS-CSS',346.79011,8.03405,NULL,NULL,'2012-10-05 04:26:23',56205.19330300018,20.1572,0.059763,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121005/1210051071234141464.html',' Other ','css wc',NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121005/jpg/1210051071234141464.master.jpg',NULL,NULL,51723280650,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:32','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210051071234141464.atel.html','http://nesssi.cacr.caltech.edu/catalina/20121005/1210051071234141464p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,808176260,12627754,NULL,NULL,NULL,NULL),(6891,6891,1,'CSS121005-212625+201948','CRTS-CSS',321.60467,20.33012,NULL,NULL,'2012-10-05 02:30:37',56205.11190599995,16.2799,0.010661,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121005/1210051211094121504.html',' Other Other ','css wc',NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121005/jpg/1210051211094121504.master.jpg',NULL,NULL,55149145492,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:32','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210051211094121504.atel.html','http://nesssi.cacr.caltech.edu/catalina/20121005/1210051211094121504p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,861705398,13464146,NULL,NULL,NULL,NULL),(6892,2174,0,'CSS121005-212556+122328','CRTS-CSS',321.48275,12.39105,NULL,NULL,'2012-10-05 02:35:28',56205.11521500023,17.3,0.017076,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:32','2019-08-18 22:06:58','http://nesssi.cacr.caltech.edu/catalina/20121005/1210051121134133632.html',' Supernova ','css wc',NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121005/jpg/1210051121134133632.master.jpg',NULL,NULL,55266515267,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:32','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210051121134133632.atel.html','http://nesssi.cacr.caltech.edu/catalina/20121005/1210051121134133632p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,863539301,13492801,NULL,NULL,NULL,NULL),(6893,6893,1,'CSS121005-211339+150233','CRTS-CSS',318.41173,15.04238,NULL,NULL,'2012-10-05 02:27:23',56205.10964399995,18.7926,0.033924,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121005/1210051151104133364.html',' Other ','css wc',NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121005/jpg/1210051151104133364.master.jpg',NULL,NULL,55277779158,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:33','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210051151104133364.atel.html','http://nesssi.cacr.caltech.edu/catalina/20121005/1210051151104133364p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,863715299,13495551,NULL,NULL,NULL,NULL),(6894,6894,0,'CSS120923-224402+155150','CRTS-CSS',341.00683,15.86402,NULL,NULL,'2012-09-23 04:56:07',56193.20963500021,17.8291,0.021248,'R4',NULL,NULL,NULL,NULL,'2012-11-30 23:51:33','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120923/1209231151184132183.html',' Supernova ','css wc',NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120923/jpg/1209231151184132183.master.jpg',NULL,NULL,52590755276,NULL,NULL,NULL,NULL,NULL,'2012-11-30 23:51:33','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209231151184132183.atel.html','http://nesssi.cacr.caltech.edu/catalina/20120923/1209231151184132183p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,821730551,12839539,NULL,NULL,NULL,NULL),(6933,3284,0,'LSQ12fxk','LSQ',57.9454166666667,-22.176,NULL,NULL,'2012-11-30 03:20:33',56261.1392799998,17.4823,0.1545,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_snap_77577.gif',37996998851,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593703107,9276611,NULL,NULL,NULL,NULL),(6934,3284,0,'LSQ12fxk','LSQ',57.9454166666667,-22.1758333333333,NULL,NULL,'2012-11-30 05:20:36',56261.2226499999,18.3176,0.1914,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxk/LSQ12fxk_snap_77578.gif',37996998851,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593703107,9276611,NULL,NULL,NULL,NULL),(6935,3287,0,'LSQ12fxc','LSQ',47.81575,-22.4541666666667,NULL,NULL,'2012-11-30 02:54:03',56261.1208700002,19.2605,0.1547,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fxc/LSQ12fxc_snap_77576.gif',38030912757,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594233011,9284890,NULL,NULL,NULL,NULL),(6936,3386,0,'LSQ12fyb','LSQ',53.6895416666667,-3.73852777777778,NULL,NULL,'2012-12-01 03:03:28',56262.1274100002,19.4881,0.1712,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_77663.gif',36820699952,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(6937,3386,0,'LSQ12fyb','LSQ',53.689125,-3.73875,NULL,NULL,'2012-12-01 05:04:44',56262.2116299998,19.5074,0.1719,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fyb/LSQ12fyb_snap_77664.gif',36820699944,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,575323436,8989428,NULL,NULL,NULL,NULL),(6938,3485,0,'LSQ12gbj','LSQ',66.0475833333333,-25.4151666666667,NULL,NULL,'2012-12-02 05:52:07',56263.2445299998,19.8125,0.1534,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_snap_77939.gif',37181674004,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,580963656,9077557,NULL,NULL,NULL,NULL),(6939,3485,0,'LSQ12gbj','LSQ',66.0475833333333,-25.4151388888889,NULL,NULL,'2012-12-02 07:41:13',56263.3202900002,19.7197,0.1398,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gbj/LSQ12gbj_snap_77940.gif',37181674004,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,580963656,9077557,NULL,NULL,NULL,NULL),(6940,3497,0,'LSQ12gay','LSQ',22.68625,-24.5999722222222,NULL,NULL,'2012-12-02 01:26:35',56263.0601300001,19.6584,0.0898,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gay/LSQ12gay_snap_78177.gif',34701767715,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,542215120,8472111,NULL,NULL,NULL,NULL),(6941,3514,0,'LSQ12gaq','LSQ',65.3840416666667,-25.38025,NULL,NULL,'2012-12-02 05:53:47',56263.2456899998,19.7616,0.1412,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gaq/LSQ12gaq_snap_78180.gif',37182103829,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,580970372,9077662,NULL,NULL,NULL,NULL),(6942,3517,0,'LSQ12gap','LSQ',66.2455833333333,-25.1846388888889,NULL,NULL,'2012-12-02 07:41:13',56263.3202900002,18.5671,0.0883,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gap/LSQ12gap_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gap/LSQ12gap_snap_78179.gif',37181152649,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,580955510,9077429,NULL,NULL,NULL,NULL),(6943,3530,0,'LSQ12gad','LSQ',52.302125,-30.6228888888889,NULL,NULL,'2012-12-02 02:57:01',56263.1229300001,18.7262,0.0923,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_history.html','sne - good',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gad/LSQ12gad_snap_78051.gif',38573258241,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602707160,9417299,NULL,NULL,NULL,NULL),(6944,3537,0,'LSQ12gab','LSQ',81.89425,-31.3134166666667,NULL,NULL,'2012-12-02 05:40:17',56263.2363100001,18.4542,0.1214,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_snap_78174.gif',37311362015,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,582990031,9109219,NULL,NULL,NULL,NULL),(6945,3537,0,'LSQ12gab','LSQ',81.8940416666667,-31.3133611111111,NULL,NULL,'2012-12-02 07:07:40',56263.2969999998,20.1526,0.1991,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gab/LSQ12gab_snap_78175.gif',37311362015,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,582990031,9109219,NULL,NULL,NULL,NULL),(6946,3540,0,'LSQ12fzz','LSQ',81.4933333333333,-34.4575555555556,NULL,NULL,'2012-12-02 07:07:40',56263.2969999998,19.1294,0.1025,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_history.html','cv',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzz/LSQ12fzz_snap_77956.gif',37267383653,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582302869,9098482,NULL,NULL,NULL,NULL),(6947,3548,0,'LSQ12fzu','LSQ',74.8829583333333,-38.4091666666667,NULL,NULL,'2012-12-02 05:21:31',56263.22328,19.2877,0.1028,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_78172.gif',37599816278,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(6948,3548,0,'LSQ12fzu','LSQ',74.883,-38.4093055555556,NULL,NULL,'2012-12-02 07:56:24',56263.33084,19.4279,0.1214,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzu/LSQ12fzu_snap_78173.gif',37599816286,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587497129,9179642,NULL,NULL,NULL,NULL),(6949,3551,0,'LSQ12fzr','LSQ',49.1793333333333,-30.2704444444444,NULL,NULL,'2012-12-02 02:41:47',56263.1123600001,20.0093,0.1587,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12fzr/LSQ12fzr_snap_78040.gif',38545017983,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602265905,9410404,NULL,NULL,NULL,NULL),(6950,3759,0,'LSQ12gch','LSQ',75.1154166666667,-19.9497777777778,NULL,NULL,'2012-12-03 05:19:41',56264.2220100001,19.749,0.1117,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_snap_78431.gif',37564131566,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586939555,9170930,NULL,NULL,NULL,NULL),(6951,3759,0,'LSQ12gch','LSQ',75.1159583333333,-19.9500277777778,NULL,NULL,'2012-12-03 06:57:57',56264.2902500001,20.2372,0.1417,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gch/LSQ12gch_snap_78432.gif',37564131567,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586939555,9170930,NULL,NULL,NULL,NULL),(6952,3889,0,'LSQ12gft','LSQ',56.5040416666667,-28.9320833333333,NULL,NULL,'2012-12-02 01:15:36',56263.0525000002,21.4274,0.1871,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gft/LSQ12gft_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gft/LSQ12gft_snap_77976.gif',38583605078,NULL,NULL,NULL,'2012-10-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602868829,9419825,NULL,NULL,NULL,NULL),(6953,3893,0,'LSQ12gfs','LSQ',55.309625,-26.72075,NULL,NULL,'2012-12-02 01:11:54',56263.0499399998,20.9092,0.1788,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_snap_77978.gif',38579773067,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602808954,9418889,NULL,NULL,NULL,NULL),(6954,3893,0,'LSQ12gfs','LSQ',55.3095416666667,-26.7207222222222,NULL,NULL,'2012-12-02 03:10:52',56263.1325500002,21.0523,0.1613,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfs/LSQ12gfs_snap_77979.gif',38579773067,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602808954,9418889,NULL,NULL,NULL,NULL),(6955,3809,0,'LSQ12gdd','LSQ',53.6035833333333,-26.7738055555556,NULL,NULL,'2012-12-02 03:14:35',56263.1351299998,20.9941,0.2021,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdd/LSQ12gdd_snap_78043.gif',38579529027,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602805141,9418830,NULL,NULL,NULL,NULL),(6956,3818,0,'LSQ12gdc','LSQ',74.1527083333333,-31.6033055555556,NULL,NULL,'2012-11-30 05:42:44',56261.23801,17.8553,0.1641,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_77529.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(6957,3818,0,'LSQ12gdc','LSQ',74.1527083333333,-31.6034166666667,NULL,NULL,'2012-12-02 07:49:37',56263.3261299999,19.4796,0.1697,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_77986.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(6958,3821,0,'LSQ12gcw','LSQ',68.318875,-38.1013611111111,NULL,NULL,'2012-11-30 05:25:43',56261.2261999999,19.1195,0.1927,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_77532.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(6959,3821,0,'LSQ12gcw','LSQ',68.3187916666667,-38.1013333333333,NULL,NULL,'2012-12-02 05:18:08',56263.2209299998,19.1309,0.1096,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_78003.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(6960,3821,0,'LSQ12gcw','LSQ',68.3188333333333,-38.1013888888889,NULL,NULL,'2012-12-02 07:59:47',56263.3331900002,19.1667,0.093,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_78004.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(6961,3845,0,'LSQ12geg','LSQ',55.0529583333333,-26.7929444444444,NULL,NULL,'2012-12-02 01:11:54',56263.0499399998,19.3715,0.042,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12geg/LSQ12geg_snap_77968.gif',38582715225,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602854925,9419608,NULL,NULL,NULL,NULL),(6962,3851,0,'LSQ12ges','LSQ',74.98575,-19.4638611111111,NULL,NULL,'2012-12-03 05:17:59',56264.22083,20.3833,0.1541,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_snap_78522.gif',37563466780,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586929168,9170768,NULL,NULL,NULL,NULL),(6963,3864,0,'LSQ12gel','LSQ',55.7507916666667,-26.6942777777778,NULL,NULL,'2012-12-02 01:15:36',56263.0525000002,21.3948,0.1697,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_snap_77970.gif',38528356173,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602005565,9406336,NULL,NULL,NULL,NULL),(6964,3864,0,'LSQ12gel','LSQ',55.7505833333333,-26.6940833333333,NULL,NULL,'2012-12-02 03:14:35',56263.1351299998,19.1318,0.0687,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:52','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_snap_77971.gif',38528356173,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602005565,9406336,NULL,NULL,NULL,NULL),(6965,3868,0,'LSQ12gek','LSQ',55.5485,-26.7351944444444,NULL,NULL,'2012-12-02 01:15:36',56263.0525000002,18.2617,0.0302,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-06 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_snap_77995.gif',38579734652,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602808353,9418880,NULL,NULL,NULL,NULL),(6966,3868,0,'LSQ12gek','LSQ',55.5485,-26.7352777777778,NULL,NULL,'2012-12-02 03:14:35',56263.1351299998,17.7225,0.0292,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-06 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_snap_77996.gif',38579734652,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602808353,9418880,NULL,NULL,NULL,NULL),(6967,3883,0,'LSQ12gfh','LSQ',53.6905416666667,-6.84380555555556,NULL,NULL,'2012-12-03 03:06:10',56264.1292900001,16.938,0.0182,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_history.html','sne??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_snap_78437.gif',36800390526,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575006101,8984470,NULL,NULL,NULL,NULL),(6968,4056,0,'LSQ12ghe','LSQ',68.549,-23.0559722222222,NULL,NULL,'2012-12-02 07:33:18',56263.3147999998,19.2507,0.1197,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_78001.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(6969,4061,0,'LSQ12ggx','LSQ',47.8962083333333,-22.3203055555556,NULL,NULL,'2012-12-02 02:46:51',56263.1158699999,19.6951,0.1996,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_78056.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(6970,4061,0,'LSQ12ggx','LSQ',47.8960833333333,-22.3203055555556,NULL,NULL,'2012-12-02 04:47:02',56263.1993399998,19.6203,0.1708,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_78057.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(6971,4067,0,'LSQ12ggq','LSQ',69.42875,-35.8658055555556,NULL,NULL,'2012-11-30 05:25:43',56261.2261999999,19.5404,0.1919,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_77542.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(6972,4067,0,'LSQ12ggq','LSQ',69.428875,-35.8657222222222,NULL,NULL,'2012-12-02 05:18:08',56263.2209299998,20.3081,0.1255,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_78035.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(6973,4067,0,'LSQ12ggq','LSQ',69.4289583333333,-35.86575,NULL,NULL,'2012-12-02 07:59:47',56263.3331900002,19.965,0.1136,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_78036.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(6974,4118,0,'LSQ12ghd','LSQ',71.8646666666667,-21.3294166666667,NULL,NULL,'2012-12-02 07:33:18',56263.3147999998,20.2519,0.1993,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_78031.gif',37342671080,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479235,9116863,NULL,NULL,NULL,NULL),(6975,4120,0,'LSQ12ghc','LSQ',66.2227916666667,-21.2026944444444,NULL,NULL,'2012-12-02 05:52:07',56263.2445299998,17.7643,0.039,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_77997.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(6976,4120,0,'LSQ12ghc','LSQ',66.2229583333333,-21.2027777777778,NULL,NULL,'2012-12-02 07:41:13',56263.3202900002,18.59,0.0883,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_77998.gif',37325531170,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(6977,4133,0,'LSQ12gha','LSQ',57.2159583333333,-23.4218055555556,NULL,NULL,'2012-12-02 03:09:11',56263.1313800002,18.8641,0.1189,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gha/LSQ12gha_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gha/LSQ12gha_snap_78002.gif',37995371538,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593677680,9276213,NULL,NULL,NULL,NULL),(6978,4165,0,'LSQ12gjc','LSQ',52.6710416666667,-6.37280555555555,NULL,NULL,'2012-12-01 03:03:28',56262.1274100002,19.457,0.1734,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_77715.gif',36797933958,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(6979,4165,0,'LSQ12gjc','LSQ',52.6707916666667,-6.37291666666667,NULL,NULL,'2012-12-01 05:04:44',56262.2116299998,19.1775,0.1654,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_77716.gif',36797933958,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(6980,4317,0,'LSQ12gkk','LSQ',76.8689583333333,-23.8546388888889,NULL,NULL,'2012-12-02 06:02:14',56263.2515599998,19.7758,0.1881,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_77953.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(6981,4317,0,'LSQ12gkk','LSQ',76.8689583333333,-23.8546111111111,NULL,NULL,'2012-12-02 07:24:49',56263.3089100001,19.9273,0.13,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_77954.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(6982,5246,0,'LSQ12gln','LSQ',80.7475416666667,-33.4641944444444,NULL,NULL,'2012-12-02 05:40:17',56263.2363100001,18.1364,0.0537,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_78063.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(6983,5246,0,'LSQ12gln','LSQ',80.7475416666667,-33.4642222222222,NULL,NULL,'2012-12-02 07:07:40',56263.2969999998,18.2199,0.058,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_78064.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(6984,5376,0,'LSQ12glw','LSQ',143.033083333333,-9.68086111111111,NULL,NULL,'2012-12-01 05:40:04',56262.2361599999,19.5272,0.1465,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glw/LSQ12glw_history.html','sne?',NULL,0.054681,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glw/LSQ12glw_snap_77729.gif',41090785039,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642043516,10031929,NULL,NULL,NULL,NULL),(6985,5550,0,'LSQ12goy','LSQ',68.8834166666667,-26.4607222222222,NULL,NULL,'2012-12-02 05:41:58',56263.2374800001,19.422,0.1215,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_78127.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(6986,5550,0,'LSQ12goy','LSQ',68.8835,-26.4606388888889,NULL,NULL,'2012-12-02 07:46:16',56263.3237999999,19.1095,0.1076,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_78128.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(6987,5816,0,'LSQ12grj','LSQ',58.0620833333333,-22.1815277777778,NULL,NULL,'2012-12-02 05:13:03',56263.2174,17.9675,0.1298,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_history.html','sn?',NULL,0.061819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_snap_78166.gif',37996988353,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593702943,9276608,NULL,NULL,NULL,NULL),(6988,5823,0,'LSQ12grh','LSQ',48.0765833333333,-24.5529166666667,NULL,NULL,'2012-11-30 02:55:44',56261.1220399998,18.8377,0.1454,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_77573.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(6989,5823,0,'LSQ12grh','LSQ',48.0765833333333,-24.553,NULL,NULL,'2012-12-02 02:46:51',56263.1158699999,18.8588,0.0782,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_78163.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(6990,5823,0,'LSQ12grh','LSQ',48.0766666666667,-24.5529722222222,NULL,NULL,'2012-12-02 04:47:02',56263.1993399998,18.8155,0.0612,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_78164.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(6991,5831,0,'LSQ12gra','LSQ',51.1259583333333,-28.2918055555556,NULL,NULL,'2012-12-02 02:50:15',56263.1182300001,19.0988,0.1239,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_78161.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(6992,5831,0,'LSQ12gra','LSQ',51.1259166666667,-28.29175,NULL,NULL,'2012-12-02 04:50:26',56263.20169,18.9245,0.0827,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_78162.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(6993,5839,0,'LSQ12gqq','LSQ',18.8644166666667,-31.39775,NULL,NULL,'2012-12-02 01:21:20',56263.0564899999,19.4914,0.0823,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_78159.gif',34735485234,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(6994,5839,0,'LSQ12gqq','LSQ',18.86375,-31.3978055555556,NULL,NULL,'2012-12-02 03:22:02',56263.1403100002,19.6067,0.0832,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_78160.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(6995,5813,0,'LSQ12gpw','LSQ',48.242625,-11.7111111111111,NULL,NULL,'2012-12-01 03:00:06',56262.1250700001,16.5693,0.0241,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-06 23:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_77777.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(6996,5813,0,'LSQ12gpw','LSQ',48.2426666666667,-11.7111666666667,NULL,NULL,'2012-12-01 05:01:20',56262.20927,16.6251,0.0239,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-06 23:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_77778.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(6997,5813,0,'LSQ12gpw','LSQ',48.2426666666667,-11.7111666666667,NULL,NULL,'2012-12-03 03:02:49',56264.12696,16.5313,0.0167,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-06 23:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_78494.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(6998,5813,0,'LSQ12gpw','LSQ',48.2426666666667,-11.7111666666667,NULL,NULL,'2012-12-03 05:06:02',56264.2125300001,16.521,0.0169,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-06 23:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_78495.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(6999,5856,0,'LSQ12gsh','LSQ',72.1755,-30.9982777777778,NULL,NULL,'2012-11-30 05:41:02',56261.2368399999,17.4857,0.0885,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_77552.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(7000,5856,0,'LSQ12gsh','LSQ',72.1755833333333,-30.9983611111111,NULL,NULL,'2012-12-02 07:04:17',56263.2946500001,17.9759,0.0817,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_78075.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(7001,5876,0,'LSQ12gsv','LSQ',71.5319583333333,-25.26675,NULL,NULL,'2012-12-02 05:55:30',56263.24688,19.4137,0.1164,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_78073.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(7002,5876,0,'LSQ12gsv','LSQ',71.532,-25.26675,NULL,NULL,'2012-12-02 07:33:18',56263.3147999998,19.7231,0.1411,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_78074.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(7003,5959,0,'LSQ12gtm','LSQ',69.9597916666667,-34.1287777777778,NULL,NULL,'2012-11-30 05:41:02',56261.2368399999,19.1692,0.1546,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_77546.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(7004,5959,0,'LSQ12gtm','LSQ',69.9599166666667,-34.1287222222222,NULL,NULL,'2012-12-02 07:04:17',56263.2946500001,19.4298,0.1027,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_78060.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(7005,5970,0,'LSQ12gti','LSQ',40.0739583333333,-34.45975,NULL,NULL,'2012-11-30 02:24:53',56261.1006200002,18.0343,0.1869,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_77556.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(7006,5970,0,'LSQ12gti','LSQ',40.0738333333333,-34.45975,NULL,NULL,'2012-11-30 04:26:10',56261.1848399998,18.1137,0.167,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_77557.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(7007,5970,0,'LSQ12gti','LSQ',40.0738333333333,-34.4597222222222,NULL,NULL,'2012-12-02 02:16:11',56263.0945799998,18.1232,0.071,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_78099.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(7008,5970,0,'LSQ12gti','LSQ',40.0739166666667,-34.4596388888889,NULL,NULL,'2012-12-02 04:16:24',56263.1780599998,18.1846,0.0928,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_78100.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(7009,5983,0,'LSQ12gul','LSQ',43.0337916666667,-0.0361111111111111,NULL,NULL,'2012-12-01 02:17:13',56262.0952900001,18.227,0.0537,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_77721.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(7010,5983,0,'LSQ12gul','LSQ',43.0338333333333,-0.0360833333333333,NULL,NULL,'2012-12-01 04:18:28',56262.1795000001,18.3586,0.0573,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_77722.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(7011,5983,0,'LSQ12gul','LSQ',43.0337916666667,-0.0360555555555556,NULL,NULL,'2012-12-03 02:19:43',56264.0970299998,18.2833,0.0363,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_78440.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(7012,5983,0,'LSQ12gul','LSQ',43.0337916666667,-0.0360555555555556,NULL,NULL,'2012-12-03 04:20:53',56264.1811799998,18.2579,0.0421,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_78441.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(7013,5985,0,'LSQ12guj','LSQ',36.2344583333333,5.12116666666667,NULL,NULL,'2012-12-01 01:39:00',56262.0687600002,18.141,0.0387,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_snap_77723.gif',66894622375,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045228474,16331694,NULL,NULL,NULL,NULL),(7014,5985,0,'LSQ12guj','LSQ',36.2344583333333,5.12119444444444,NULL,NULL,'2012-12-01 03:40:13',56262.1529299999,18.2088,0.0496,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_snap_77724.gif',66894622375,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045228474,16331694,NULL,NULL,NULL,NULL),(7015,5985,0,'LSQ12guj','LSQ',36.2344583333333,5.12116666666667,NULL,NULL,'2012-12-03 01:41:23',56264.0704100002,18.1587,0.0273,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_snap_78442.gif',66894622375,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045228474,16331694,NULL,NULL,NULL,NULL),(7016,5985,0,'LSQ12guj','LSQ',36.2344583333333,5.12119444444444,NULL,NULL,'2012-12-03 03:42:46',56264.1546999998,18.0836,0.0354,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_snap_78443.gif',66894622375,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045228474,16331694,NULL,NULL,NULL,NULL),(7017,5987,0,'LSQ12gug','LSQ',140.612083333333,-6.47716666666667,NULL,NULL,'2012-12-01 07:10:51',56262.2992099999,19.044,0.0994,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gug/LSQ12gug_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gug/LSQ12gug_snap_77705.gif',41096530790,NULL,NULL,NULL,'2012-04-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,642133293,10033332,NULL,NULL,NULL,NULL),(7018,5987,0,'LSQ12gug','LSQ',140.612,-6.47725,NULL,NULL,'2012-12-03 05:33:57',56264.2319100001,19.3047,0.1448,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gug/LSQ12gug_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gug/LSQ12gug_snap_78420.gif',41096530790,NULL,NULL,NULL,'2012-04-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,642133293,10033332,NULL,NULL,NULL,NULL),(7019,5987,0,'LSQ12gug','LSQ',140.612083333333,-6.47722222222222,NULL,NULL,'2012-12-03 08:15:58',56264.3444300001,18.7436,0.1359,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gug/LSQ12gug_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gug/LSQ12gug_snap_78421.gif',41096530790,NULL,NULL,NULL,'2012-04-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,642133293,10033332,NULL,NULL,NULL,NULL),(7020,5989,0,'LSQ12guf','LSQ',144.931333333333,-3.73075,NULL,NULL,'2012-12-01 08:04:24',56262.3363899998,18.6608,0.1412,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guf/LSQ12guf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guf/LSQ12guf_snap_77704.gif',41114462936,NULL,NULL,NULL,'2012-05-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,642413483,10037710,NULL,NULL,NULL,NULL),(7021,5989,0,'LSQ12guf','LSQ',144.931333333333,-3.73075,NULL,NULL,'2012-12-03 07:17:30',56264.30382,19.4239,0.1302,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guf/LSQ12guf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guf/LSQ12guf_snap_78422.gif',41114462936,NULL,NULL,NULL,'2012-05-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,642413483,10037710,NULL,NULL,NULL,NULL),(7022,5993,0,'LSQ12gtz','LSQ',48.3627916666667,-7.35838888888889,NULL,NULL,'2012-12-01 02:47:50',56262.11656,17.7216,0.0564,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_77751.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7023,5993,0,'LSQ12gtz','LSQ',48.36275,-7.35847222222222,NULL,NULL,'2012-12-01 03:00:06',56262.1250700001,18.5925,0.0858,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_77749.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7024,5993,0,'LSQ12gtz','LSQ',48.363,-7.35819444444444,NULL,NULL,'2012-12-01 04:49:15',56262.2008699998,17.5685,0.0643,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_77752.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7025,5993,0,'LSQ12gtz','LSQ',48.36275,-7.35841666666667,NULL,NULL,'2012-12-01 05:01:20',56262.20927,18.5059,0.0693,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_77750.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7026,5993,0,'LSQ12gtz','LSQ',48.3627083333333,-7.35847222222222,NULL,NULL,'2012-12-03 03:02:49',56264.12696,18.6321,0.0736,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_78454.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7027,5993,0,'LSQ12gtz','LSQ',48.36275,-7.35838888888889,NULL,NULL,'2012-12-03 04:51:59',56264.2027699999,18.3194,0.0683,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_78456.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7028,5993,0,'LSQ12gtz','LSQ',48.3627916666667,-7.35838888888889,NULL,NULL,'2012-12-03 05:06:02',56264.2125300001,18.4431,0.0841,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_78455.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7029,6010,0,'LSQ12gun','LSQ',146.327125,0.807805555555556,NULL,NULL,'2012-12-01 07:29:36',56262.3122299998,19.462,0.1798,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gun/LSQ12gun_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gun/LSQ12gun_snap_77753.gif',60902174160,NULL,NULL,NULL,'2012-03-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,951596471,14868694,NULL,NULL,NULL,NULL),(7030,6014,0,'LSQ12gty','LSQ',73.336,-14.9325277777778,NULL,NULL,'2012-12-01 05:16:45',56262.21997,18.9174,0.1185,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_77747.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(7031,6014,0,'LSQ12gty','LSQ',73.3359583333333,-14.9325277777778,NULL,NULL,'2012-12-01 06:59:31',56262.29134,19.2495,0.1263,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_77748.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(7032,6014,0,'LSQ12gty','LSQ',73.336,-14.9325277777778,NULL,NULL,'2012-12-03 05:21:23',56264.2231899998,19.0599,0.092,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_78458.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(7033,6014,0,'LSQ12gty','LSQ',73.336,-14.9325833333333,NULL,NULL,'2012-12-03 07:01:19',56264.2925900002,19.0444,0.1097,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_78459.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(7034,6021,0,'LSQ12gtx','LSQ',149.760208333333,-13.9695277777778,NULL,NULL,'2012-12-01 05:56:32',56262.2475999999,19.8394,0.1588,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtx/LSQ12gtx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtx/LSQ12gtx_snap_77745.gif',41191975503,NULL,NULL,NULL,'2012-05-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,643624617,10056634,NULL,NULL,NULL,NULL),(7035,6021,0,'LSQ12gtx','LSQ',149.760291666667,-13.9694722222222,NULL,NULL,'2012-12-01 07:16:00',56262.30278,19.5039,0.1281,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtx/LSQ12gtx_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtx/LSQ12gtx_snap_77746.gif',41191975503,NULL,NULL,NULL,'2012-05-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,643624617,10056634,NULL,NULL,NULL,NULL),(7036,6109,0,'LSQ12gwg','LSQ',71.316625,-29.0706388888889,NULL,NULL,'2012-12-02 05:47:02',56263.2409999999,19.6399,0.1288,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_78145.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(7037,6117,0,'LSQ12gwf','LSQ',31.6622083333333,-31.29225,NULL,NULL,'2012-12-02 04:02:46',56263.1685899999,18.379,0.0957,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_history.html','sn?',NULL,0.1321,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_snap_78144.gif',38445793246,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,600715519,9386179,NULL,NULL,NULL,NULL),(7038,6121,0,'LSQ12gwc','LSQ',55.8400833333333,-26.7372222222222,NULL,NULL,'2012-12-02 01:15:36',56263.0525000002,21.3138,0.1742,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_78138.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(7039,6121,0,'LSQ12gwc','LSQ',55.8400416666667,-26.7371666666667,NULL,NULL,'2012-12-02 03:14:35',56263.1351299998,20.3571,0.118,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_78139.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(7040,6144,0,'LSQ12gvw','LSQ',17.5188333333333,-31.9530833333333,NULL,NULL,'2012-11-30 01:30:25',56261.0627899999,18.9891,0.1545,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_history.html','sn - nice',NULL,0.1397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_snap_77570.gif',34744530696,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542883292,8482551,NULL,NULL,NULL,NULL),(7041,6144,0,'LSQ12gvw','LSQ',17.5192083333333,-31.9528888888889,NULL,NULL,'2012-12-02 01:21:20',56263.0564899999,19.5576,0.0552,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_history.html','sn - nice',NULL,0.1397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_snap_78134.gif',34744530696,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542883292,8482551,NULL,NULL,NULL,NULL),(7042,6144,0,'LSQ12gvw','LSQ',17.5189166666667,-31.9528888888889,NULL,NULL,'2012-12-02 03:22:02',56263.1403100002,19.0845,0.1108,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_history.html','sn - nice',NULL,0.1397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_snap_78135.gif',34744530696,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542883292,8482551,NULL,NULL,NULL,NULL),(7043,6150,0,'LSQ12gvs','LSQ',64.3944166666667,-38.8895277777778,NULL,NULL,'2012-11-30 05:22:22',56261.2238699999,17.4829,0.1028,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_77566.gif',37791067653,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(7044,6150,0,'LSQ12gvs','LSQ',64.3945,-38.8894722222222,NULL,NULL,'2012-12-02 05:14:46',56263.2185900002,18.2764,0.0398,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_78130.gif',37791067655,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(7045,6150,0,'LSQ12gvs','LSQ',64.3944166666667,-38.8894722222222,NULL,NULL,'2012-12-02 06:55:49',56263.28877,18.2319,0.0343,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_78131.gif',37791067655,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(7046,6188,0,'LSQ12gwk','LSQ',44.366375,-25.3955277777778,NULL,NULL,'2012-11-30 04:41:27',56261.1954600001,18.848,0.156,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_77571.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(7047,6188,0,'LSQ12gwk','LSQ',44.366,-25.3954444444444,NULL,NULL,'2012-12-02 04:31:47',56263.1887400001,19.1799,0.114,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_78146.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(7048,6167,0,'LSQ12gvb','LSQ',46.5284166666667,-2.58222222222222,NULL,NULL,'2012-12-01 02:18:55',56262.0964799998,18.6614,0.0969,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_77765.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(7049,6167,0,'LSQ12gvb','LSQ',46.528375,-2.58216666666667,NULL,NULL,'2012-12-01 04:20:09',56262.1806700001,19.3033,0.1477,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_77766.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(7050,6167,0,'LSQ12gvb','LSQ',46.5283333333333,-2.58219444444444,NULL,NULL,'2012-12-03 02:21:23',56264.0981899998,18.8251,0.0716,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_78487.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(7051,6167,0,'LSQ12gvb','LSQ',46.5284166666667,-2.58213888888889,NULL,NULL,'2012-12-03 04:22:35',56264.18236,19.9021,0.1704,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_78488.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(7052,6172,0,'LSQ12guy','LSQ',151.692958333333,-6.18869444444444,NULL,NULL,'2012-12-01 06:22:01',56262.26529,19.3875,0.1638,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guy/LSQ12guy_history.html','sn?',NULL,0.055375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guy/LSQ12guy_snap_77760.gif',41247382850,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,644490357,10070161,NULL,NULL,NULL,NULL),(7053,6172,0,'LSQ12guy','LSQ',151.692958333333,-6.18861111111111,NULL,NULL,'2012-12-03 06:08:28',56264.2558800001,18.7702,0.1143,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guy/LSQ12guy_history.html','sn?',NULL,0.055375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guy/LSQ12guy_snap_78480.gif',41247382850,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,644490357,10070161,NULL,NULL,NULL,NULL),(7054,6177,0,'LSQ12guq','LSQ',39.271375,-20.5101666666667,NULL,NULL,'2012-12-01 04:33:52',56262.19019,19.1809,0.1348,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guq/LSQ12guq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guq/LSQ12guq_snap_77754.gif',37939057755,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592797777,9262465,NULL,NULL,NULL,NULL),(7055,6204,0,'LSQ12guu','LSQ',24.468875,-16.2692777777778,NULL,NULL,'2012-12-03 01:37:49',56264.0679299999,14.7842,0.0026,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guu/LSQ12guu_history.html','unusual variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guu/LSQ12guu_snap_78471.gif',35192089516,NULL,NULL,NULL,'2012-10-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,549876398,8591818,NULL,NULL,NULL,NULL),(7056,6209,0,'LSQ12gwn','LSQ',157.356,-20.0196388888889,NULL,NULL,'2012-12-01 06:18:33',56262.2628899999,18.12,0.0545,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwn/LSQ12gwn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwn/LSQ12gwn_snap_77662.gif',41663494577,NULL,NULL,NULL,'2012-05-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,650992102,10171751,NULL,NULL,NULL,NULL),(7057,7057,1,'LSQ12gwp','LSQ',35.477125,-34.3146944444444,NULL,NULL,'2012-11-24 03:54:59',56255.1631900002,20.0522,0.1956,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwp/LSQ12gwp_history.html','sn?',NULL,0.0205,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwp/LSQ12gwp_snap_77597.gif',38419063033,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,600297859,9379654,NULL,NULL,NULL,NULL),(7058,7057,0,'LSQ12gwp','LSQ',35.4771666666667,-34.3143888888889,NULL,NULL,'2012-11-30 02:11:16',56261.0911599998,16.2934,0.0371,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwp/LSQ12gwp_history.html','sn?',NULL,0.0205,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwp/LSQ12gwp_snap_77584.gif',38419063033,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,600297859,9379654,NULL,NULL,NULL,NULL),(7059,7057,0,'LSQ12gwp','LSQ',35.4772916666667,-34.3143611111111,NULL,NULL,'2012-11-30 04:12:37',56261.1754299998,17.1112,0.0294,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwp/LSQ12gwp_history.html','sn?',NULL,0.0205,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwp/LSQ12gwp_snap_77585.gif',38419063033,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,600297859,9379654,NULL,NULL,NULL,NULL),(7060,7060,1,'LSQ12gwo','LSQ',41.8849166666667,-38.8545277777778,NULL,NULL,'2012-11-24 04:13:46',56255.1762299999,20.5635,0.2106,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwo/LSQ12gwo_history.html','sn?',NULL,0.062947,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwo/LSQ12gwo_snap_77596.gif',38629474459,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,603585538,9431024,NULL,NULL,NULL,NULL),(7061,7060,0,'LSQ12gwo','LSQ',41.8850833333333,-38.85475,NULL,NULL,'2012-11-30 02:30:14',56261.1043400001,18.5949,0.1279,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwo/LSQ12gwo_history.html','sn?',NULL,0.062947,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwo/LSQ12gwo_snap_77582.gif',38629474459,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,603585538,9431024,NULL,NULL,NULL,NULL),(7062,7060,0,'LSQ12gwo','LSQ',41.88475,-38.8545277777778,NULL,NULL,'2012-11-30 04:31:15',56261.1883700001,19.8647,0.149,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwo/LSQ12gwo_history.html','sn?',NULL,0.062947,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwo/LSQ12gwo_snap_77583.gif',38629474459,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,603585538,9431024,NULL,NULL,NULL,NULL),(7063,7063,1,'LSQ12gxj','LSQ',43.2390416666667,1.60675,NULL,NULL,'2012-12-01 02:18:55',56262.0964799998,19.4092,0.1447,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_77891.gif',66842134735,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(7064,7063,0,'LSQ12gxj','LSQ',43.2390416666667,1.60675,NULL,NULL,'2012-12-01 04:20:09',56262.1806700001,18.7955,0.1451,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_77892.gif',66842134735,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(7065,7063,0,'LSQ12gxj','LSQ',43.2390833333333,1.60672222222222,NULL,NULL,'2012-12-03 02:21:23',56264.0981899998,19.2977,0.112,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_78369.gif',66842134735,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(7066,7063,0,'LSQ12gxj','LSQ',43.2392083333333,1.60672222222222,NULL,NULL,'2012-12-03 04:22:35',56264.18236,19.2119,0.1189,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_78370.gif',66842134735,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(7067,7067,1,'LSQ12gxh','LSQ',152.531916666667,-7.00355555555556,NULL,NULL,'2012-12-01 06:53:20',56262.2870399999,18.0923,0.0647,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxh/LSQ12gxh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxh/LSQ12gxh_snap_77887.gif',41250965852,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644546341,10071036,NULL,NULL,NULL,NULL),(7068,7067,0,'LSQ12gxh','LSQ',152.531958333333,-7.00358333333333,NULL,NULL,'2012-12-01 07:43:52',56262.3221300002,18.2558,0.0665,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxh/LSQ12gxh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxh/LSQ12gxh_snap_77888.gif',41250965852,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644546341,10071036,NULL,NULL,NULL,NULL),(7069,7067,0,'LSQ12gxh','LSQ',152.531916666667,-7.00358333333333,NULL,NULL,'2012-12-03 06:48:25',56264.28363,17.9147,0.0664,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxh/LSQ12gxh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxh/LSQ12gxh_snap_78345.gif',41250965852,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644546341,10071036,NULL,NULL,NULL,NULL),(7070,7067,0,'LSQ12gxh','LSQ',152.531958333333,-7.00361111111111,NULL,NULL,'2012-12-03 07:41:57',56264.3207999999,18.0964,0.0732,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxh/LSQ12gxh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxh/LSQ12gxh_snap_78346.gif',41250965852,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644546341,10071036,NULL,NULL,NULL,NULL),(7071,7071,1,'LSQ12gxd','LSQ',36.0342916666667,-3.46422222222222,NULL,NULL,'2012-12-01 01:10:50',56262.0491999998,20.0835,0.1285,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_77879.gif',34918978036,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(7072,7071,0,'LSQ12gxd','LSQ',36.0342083333333,-3.46425,NULL,NULL,'2012-12-01 03:12:08',56262.1334299999,19.8856,0.1551,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_77880.gif',34918978036,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(7073,7071,0,'LSQ12gxd','LSQ',36.0342916666667,-3.46422222222222,NULL,NULL,'2012-12-03 01:13:23',56264.0509700002,19.8521,0.121,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_78352.gif',34918978036,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(7074,7071,0,'LSQ12gxd','LSQ',36.0342083333333,-3.46422222222222,NULL,NULL,'2012-12-03 03:14:53',56264.13534,19.8852,0.1456,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-03 15:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_78353.gif',34918978036,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(7075,7075,1,'LSQ12gxb','LSQ',142.838791666667,-11.6296666666667,NULL,NULL,'2012-12-01 05:40:04',56262.2361599999,19.4921,0.1557,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_snap_77875.gif',42178887818,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,659045122,10297580,NULL,NULL,NULL,NULL),(7076,7075,0,'LSQ12gxb','LSQ',142.838875,-11.6295555555556,NULL,NULL,'2012-12-01 07:07:28',56262.2968600001,20.007,0.1331,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-05 11:16:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_snap_77876.gif',42178887818,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,659045122,10297580,NULL,NULL,NULL,NULL),(7077,7075,0,'LSQ12gxb','LSQ',142.838833333333,-11.6296111111111,NULL,NULL,'2012-12-03 05:28:52',56264.2283899998,18.753,0.0995,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-05 11:16:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_snap_78348.gif',42178887818,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,659045122,10297580,NULL,NULL,NULL,NULL),(7078,7075,0,'LSQ12gxb','LSQ',142.838875,-11.6295555555556,NULL,NULL,'2012-12-03 08:19:21',56264.3467799998,19.6033,0.0916,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-05 11:16:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_snap_78349.gif',42178887818,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,659045122,10297580,NULL,NULL,NULL,NULL),(7079,7079,1,'LSQ12gwy','LSQ',160.883416666667,-13.289,NULL,NULL,'2012-12-01 06:28:48',56262.27,15.4267,0.0066,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwy/LSQ12gwy_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwy/LSQ12gwy_snap_77869.gif',41838066142,NULL,NULL,NULL,'2012-05-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653719783,10214371,NULL,NULL,NULL,NULL),(7080,7079,0,'LSQ12gwy','LSQ',160.883416666667,-13.289,NULL,NULL,'2012-12-01 07:33:05',56262.3146500001,15.4257,0.0062,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwy/LSQ12gwy_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwy/LSQ12gwy_snap_77870.gif',41838066142,NULL,NULL,NULL,'2012-05-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653719783,10214371,NULL,NULL,NULL,NULL),(7081,7079,0,'LSQ12gwy','LSQ',160.883458333333,-13.2889722222222,NULL,NULL,'2012-12-03 06:22:14',56264.2654400002,15.5767,0.0057,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwy/LSQ12gwy_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwy/LSQ12gwy_snap_78367.gif',41838066142,NULL,NULL,NULL,'2012-05-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653719783,10214371,NULL,NULL,NULL,NULL),(7082,7079,0,'LSQ12gwy','LSQ',160.883458333333,-13.289,NULL,NULL,'2012-12-03 07:29:21',56264.3120499998,15.5492,0.0048,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 15:46:20','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwy/LSQ12gwy_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwy/LSQ12gwy_snap_78368.gif',41838066142,NULL,NULL,NULL,'2012-05-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653719783,10214371,NULL,NULL,NULL,NULL),(7083,7083,1,'LSQ12gyr','LSQ',43.2103333333333,-7.71222222222222,NULL,NULL,'2012-11-25 02:33:37',56256.1066800002,19.2797,0.2023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_history.html','sne - nice',NULL,0.11794,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_snap_78683.gif',37909543298,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592336614,9255259,NULL,NULL,NULL,NULL),(7084,7083,0,'LSQ12gyr','LSQ',43.2103333333333,-7.71222222222222,NULL,NULL,'2012-11-25 04:37:13',56256.19252,18.6644,0.1479,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-03 20:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_history.html','sne - nice',NULL,0.11794,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_snap_78684.gif',37909543298,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592336614,9255259,NULL,NULL,NULL,NULL),(7085,7083,0,'LSQ12gyr','LSQ',43.210375,-7.71219444444445,NULL,NULL,'2012-11-27 02:26:19',56258.1016199999,19.2827,0.1794,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-03 20:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_history.html','sne - nice',NULL,0.11794,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_snap_78685.gif',37909543298,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592336614,9255259,NULL,NULL,NULL,NULL),(7086,7083,0,'LSQ12gyr','LSQ',43.2104583333333,-7.71222222222222,NULL,NULL,'2012-11-27 04:29:28',56258.1871400001,18.6617,0.1794,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-03 20:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_history.html','sne - nice',NULL,0.11794,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_snap_78686.gif',37909543298,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592336614,9255259,NULL,NULL,NULL,NULL),(7087,7083,0,'LSQ12gyr','LSQ',43.21025,-7.71227777777778,NULL,NULL,'2012-12-01 02:42:46',56262.1130400002,19.0854,0.182,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-03 20:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_history.html','sne - nice',NULL,0.11794,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_snap_78687.gif',37909543298,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592336614,9255259,NULL,NULL,NULL,NULL),(7088,7083,0,'LSQ12gyr','LSQ',43.2102083333333,-7.71219444444445,NULL,NULL,'2012-12-01 04:44:10',56262.19734,18.8481,0.1715,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-03 20:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_history.html','sne - nice',NULL,0.11794,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_snap_78688.gif',37909543298,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592336614,9255259,NULL,NULL,NULL,NULL),(7089,7083,0,'LSQ12gyr','LSQ',43.2103333333333,-7.71230555555556,NULL,NULL,'2012-12-03 02:45:30',56264.1149400002,19.1421,0.1518,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-03 20:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_history.html','sne - nice',NULL,0.11794,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_snap_78631.gif',37909543298,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592336614,9255259,NULL,NULL,NULL,NULL),(7090,7083,0,'LSQ12gyr','LSQ',43.2103333333333,-7.71219444444445,NULL,NULL,'2012-12-03 04:46:51',56264.1992100002,19.5884,0.1349,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-03 20:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_history.html','sne - nice',NULL,0.11794,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_snap_78632.gif',37909543298,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592336614,9255259,NULL,NULL,NULL,NULL),(7091,7091,1,'LSQ12gyg','LSQ',160.024375,-16.6615555555556,NULL,NULL,'2012-12-01 07:55:50',56262.3304499998,19.5588,0.1377,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyg/LSQ12gyg_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyg/LSQ12gyg_snap_78633.gif',41830546329,NULL,NULL,NULL,'2012-05-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,653602286,10212535,NULL,NULL,NULL,NULL),(7092,7091,0,'LSQ12gyg','LSQ',160.024375,-16.6614166666667,NULL,NULL,'2012-12-03 06:38:15',56264.2765700002,19.2692,0.1369,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-03 20:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyg/LSQ12gyg_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyg/LSQ12gyg_snap_78609.gif',41830546329,NULL,NULL,NULL,'2012-05-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,653602286,10212535,NULL,NULL,NULL,NULL),(7093,7091,0,'LSQ12gyg','LSQ',160.024458333333,-16.6614444444444,NULL,NULL,'2012-12-03 07:57:12',56264.3314,19.3959,0.1324,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-03 20:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyg/LSQ12gyg_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyg/LSQ12gyg_snap_78610.gif',41830546329,NULL,NULL,NULL,'2012-05-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,653602286,10212535,NULL,NULL,NULL,NULL),(7094,7094,1,'LSQ12gye','LSQ',161.59425,-20.3266388888889,NULL,NULL,'2012-12-03 06:38:15',56264.2765700002,17.76,0.0261,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gye/LSQ12gye_history.html','possible asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gye/LSQ12gye_snap_78605.gif',41631758270,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650496222,10164003,NULL,NULL,NULL,NULL),(7095,7094,0,'LSQ12gye','LSQ',161.594291666667,-20.3265555555556,NULL,NULL,'2012-12-03 07:57:12',56264.3314,17.8249,0.0245,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-03 20:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gye/LSQ12gye_history.html','possible asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gye/LSQ12gye_snap_78606.gif',41631758262,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650496222,10164003,NULL,NULL,NULL,NULL),(7096,7096,1,'LSQ12gyd','LSQ',76.3870833333333,-18.0351944444444,NULL,NULL,'2012-12-01 05:15:04',56262.2187999999,19.3545,0.1992,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_78643.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(7097,7096,0,'LSQ12gyd','LSQ',76.3870833333333,-18.0351111111111,NULL,NULL,'2012-12-03 05:19:41',56264.2220100001,20.1954,0.165,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-03 20:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_78603.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(7098,7096,0,'LSQ12gyd','LSQ',76.3871666666667,-18.0350833333333,NULL,NULL,'2012-12-03 06:57:57',56264.2902500001,20.0688,0.1577,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-03 20:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_78604.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(7099,7099,1,'LSQ12gyc','LSQ',41.4586666666667,-17.9293333333333,NULL,NULL,'2012-11-25 04:44:05',56256.19729,18.6566,0.182,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_78638.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(7100,7099,0,'LSQ12gyc','LSQ',41.4586666666667,-17.9293888888889,NULL,NULL,'2012-11-27 02:33:11',56258.1063799998,18.1796,0.1951,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_78639.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(7101,7099,0,'LSQ12gyc','LSQ',41.4586666666667,-17.9293888888889,NULL,NULL,'2012-11-27 04:36:21',56258.1919100001,17.9213,0.1779,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_78640.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(7102,7099,0,'LSQ12gyc','LSQ',41.4585833333333,-17.9293888888889,NULL,NULL,'2012-12-01 02:49:38',56262.1178100002,17.8418,0.1016,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_78641.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(7103,7099,0,'LSQ12gyc','LSQ',41.458625,-17.9293611111111,NULL,NULL,'2012-12-01 04:51:02',56262.20211,17.7981,0.0816,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_78642.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(7104,7099,0,'LSQ12gyc','LSQ',41.4585833333333,-17.9294166666667,NULL,NULL,'2012-12-03 02:52:22',56264.1197100002,17.779,0.0822,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_78601.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(7105,7099,0,'LSQ12gyc','LSQ',41.4586666666667,-17.9293611111111,NULL,NULL,'2012-12-03 04:53:44',56264.2039899998,17.8054,0.0597,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 20:46:22','2012-12-04 13:09:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_78602.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(7106,7106,1,'LSQ12gxv','LSQ',70.42225,-22.1971666666667,NULL,NULL,'2012-11-03 05:57:09',56234.2480299999,18.58,0.1315,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 21:46:24','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_history.html','sne - nice',NULL,0.066686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_snap_78282.gif',37340201663,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583440650,9116260,NULL,NULL,NULL,NULL),(7107,7106,0,'LSQ12gxv','LSQ',70.4220416666667,-22.1974444444444,NULL,NULL,'2012-11-05 07:43:18',56236.32174,20.4547,0.192,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 21:46:24','2012-12-03 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_history.html','sne - nice',NULL,0.066686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_snap_78283.gif',37340201662,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583440650,9116260,NULL,NULL,NULL,NULL),(7108,7106,0,'LSQ12gxv','LSQ',70.422125,-22.1976666666667,NULL,NULL,'2012-11-11 08:21:27',56242.3482400002,21.0136,0.213,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 21:46:24','2012-12-03 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_history.html','sne - nice',NULL,0.066686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_snap_78284.gif',37340201662,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583440650,9116260,NULL,NULL,NULL,NULL),(7109,7106,0,'LSQ12gxv','LSQ',70.422125,-22.1974722222222,NULL,NULL,'2012-11-19 07:14:34',56250.3017899999,19.3054,0.1304,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 21:46:24','2012-12-03 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_history.html','sne - nice',NULL,0.066686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_snap_78285.gif',37340201662,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583440650,9116260,NULL,NULL,NULL,NULL),(7110,7106,0,'LSQ12gxv','LSQ',70.4224583333333,-22.1974444444444,NULL,NULL,'2012-11-24 06:02:42',56255.2518799999,19.1285,0.1442,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 21:46:24','2012-12-03 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_history.html','sne - nice',NULL,0.066686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_snap_78286.gif',37340201663,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583440650,9116260,NULL,NULL,NULL,NULL),(7111,7106,0,'LSQ12gxv','LSQ',70.4224166666667,-22.1973333333333,NULL,NULL,'2012-12-02 05:55:30',56263.24688,17.7684,0.0612,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 21:46:24','2012-12-03 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_history.html','sne - nice',NULL,0.066686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_snap_78206.gif',37340201663,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583440650,9116260,NULL,NULL,NULL,NULL),(7112,7106,0,'LSQ12gxv','LSQ',70.4224166666667,-22.1973333333333,NULL,NULL,'2012-12-02 07:33:18',56263.3147999998,17.4043,0.0557,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-03 21:46:24','2012-12-03 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_history.html','sne - nice',NULL,0.066686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_snap_78207.gif',37340201663,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583440650,9116260,NULL,NULL,NULL,NULL),(7113,6357,1,'OGLE-2012-SN-032','pessto',80.5335416667,-66.1631111111,NULL,NULL,'2012-11-14 12:00:00',56253,NULL,NULL,NULL,0.063,NULL,'Ia',NULL,'2012-12-03 22:03:05','2019-10-11 14:10:04','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35846265356,'NTT','EFOSC','Joe Anderson','2012-11-01 08:59:38',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,560097896,8751529,NULL,NULL,NULL,NULL),(7114,6701,1,'OGLE-2012-SN-007','pessto',45.306,-75.0211388889,NULL,NULL,'2012-11-14 12:00:00',56253,NULL,NULL,NULL,0.059438,NULL,'Ia',NULL,'2012-12-03 22:04:27','2019-10-11 14:10:04','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35638964401,'NTT','EFOSC','Joe Anderson','2012-07-15 09:29:06',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,556858818,8700919,NULL,NULL,NULL,NULL),(7115,5597,0,'PSNJ01140746-3239077','pessto',18.5306666667,-32.6520277778,NULL,NULL,'2012-11-14 12:00:00',56253,NULL,NULL,NULL,0.012,NULL,'Ia',NULL,'2012-12-03 22:06:15','2019-08-18 22:06:58','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38278292957,'BTT','EFOSC','Joe Anderson','2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598098327,9345286,NULL,NULL,NULL,NULL),(7116,7116,1,'LSQ12gzh','LSQ',44.805,7.26138888888889,NULL,NULL,'2012-12-03 02:00:18',56264.0835500001,20.28,0.1465,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzh/LSQ12gzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzh/LSQ12gzh_snap_78719.gif',67978103970,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1062157874,16596216,NULL,NULL,NULL,NULL),(7117,7116,0,'LSQ12gzh','LSQ',44.805,7.26144444444444,NULL,NULL,'2012-12-03 04:01:38',56264.16781,19.3524,0.1387,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzh/LSQ12gzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzh/LSQ12gzh_snap_78720.gif',67978103970,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1062157874,16596216,NULL,NULL,NULL,NULL),(7118,7118,1,'LSQ12gzb','LSQ',37.0446666666667,-5.94602777777778,NULL,NULL,'2012-12-01 01:10:50',56262.0491999998,20.2243,0.0918,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_78749.gif',34948583495,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(7119,7118,0,'LSQ12gzb','LSQ',37.0447083333333,-5.94611111111111,NULL,NULL,'2012-12-01 03:12:08',56262.1334299999,20.2611,0.1261,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_78750.gif',34948583495,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(7120,7118,0,'LSQ12gzb','LSQ',37.0446666666667,-5.94605555555556,NULL,NULL,'2012-12-03 01:13:23',56264.0509700002,20.1246,0.0777,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_78707.gif',34948583495,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(7121,7118,0,'LSQ12gzb','LSQ',37.0447083333333,-5.94611111111111,NULL,NULL,'2012-12-03 03:14:53',56264.13534,20.0279,0.0918,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_78708.gif',34948583495,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(7122,7122,1,'LSQ12gza','LSQ',35.893125,-5.90747222222222,NULL,NULL,'2012-12-01 01:10:50',56262.0491999998,19.788,0.1168,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_78748.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(7123,7122,0,'LSQ12gza','LSQ',35.8930833333333,-5.90733333333333,NULL,NULL,'2012-12-03 01:13:23',56264.0509700002,20.5604,0.1361,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_78705.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(7124,7122,0,'LSQ12gza','LSQ',35.893,-5.90730555555556,NULL,NULL,'2012-12-03 03:14:53',56264.13534,20.7115,0.162,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_78706.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(7125,7125,1,'LSQ12gyx','LSQ',157.480541666667,-11.6235277777778,NULL,NULL,'2012-12-03 06:17:09',56264.26192,19.4519,0.146,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyx/LSQ12gyx_history.html','sne or asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyx/LSQ12gyx_snap_78699.gif',41760237182,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,652503705,10195370,NULL,NULL,NULL,NULL),(7126,7125,0,'LSQ12gyx','LSQ',157.480333333333,-11.6234722222222,NULL,NULL,'2012-12-03 07:25:58',56264.3097000001,19.3937,0.1457,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyx/LSQ12gyx_history.html','sne or asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyx/LSQ12gyx_snap_78700.gif',41760237169,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,652503705,10195370,NULL,NULL,NULL,NULL),(7127,7127,1,'LSQ12gyw','LSQ',28.5179166666667,-10.3499444444444,NULL,NULL,'2012-12-01 01:42:24',56262.07112,19.844,0.1373,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyw/LSQ12gyw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyw/LSQ12gyw_snap_78735.gif',35111082183,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548610659,8572041,NULL,NULL,NULL,NULL),(7128,7127,0,'LSQ12gyw','LSQ',28.5178333333333,-10.3499166666667,NULL,NULL,'2012-12-01 03:43:37',56262.1552900001,19.81,0.1588,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyw/LSQ12gyw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyw/LSQ12gyw_snap_78736.gif',35111082183,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548610659,8572041,NULL,NULL,NULL,NULL),(7129,7127,0,'LSQ12gyw','LSQ',28.517625,-10.3499444444444,NULL,NULL,'2012-12-03 01:44:48',56264.07278,20.994,0.1231,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyw/LSQ12gyw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyw/LSQ12gyw_snap_78697.gif',35111082183,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548610659,8572041,NULL,NULL,NULL,NULL),(7130,7127,0,'LSQ12gyw','LSQ',28.5177083333333,-10.35,NULL,NULL,'2012-12-03 03:46:10',56264.1570700002,21.1186,0.166,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyw/LSQ12gyw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyw/LSQ12gyw_snap_78698.gif',35111082183,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548610659,8572041,NULL,NULL,NULL,NULL),(7131,7131,1,'LSQ12gyv','LSQ',50.471,-10.0815,NULL,NULL,'2012-12-01 04:59:39',56262.2080999999,18.9993,0.1488,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_snap_78734.gif',37898370242,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592162035,9252531,NULL,NULL,NULL,NULL),(7132,7131,0,'LSQ12gyv','LSQ',50.470875,-10.0815277777778,NULL,NULL,'2012-12-03 03:01:07',56264.1257799999,18.5758,0.107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_snap_78695.gif',37898370242,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592162035,9252531,NULL,NULL,NULL,NULL),(7133,7131,0,'LSQ12gyv','LSQ',50.4709166666667,-10.0815,NULL,NULL,'2012-12-03 05:04:22',56264.2113700002,18.5669,0.1,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_snap_78696.gif',37898370242,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592162035,9252531,NULL,NULL,NULL,NULL),(7134,7134,1,'LSQ12gyn','LSQ',44.708,-14.9488611111111,NULL,NULL,'2012-11-20 01:58:58',56251.08262,19.9386,0.1689,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_78658.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(7135,7134,0,'LSQ12gyn','LSQ',44.7079583333333,-14.9488055555556,NULL,NULL,'2012-11-22 01:50:44',56253.0769000002,19.5783,0.14,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_78659.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(7136,7134,0,'LSQ12gyn','LSQ',44.708,-14.9488333333333,NULL,NULL,'2012-11-22 03:50:13',56253.1598800002,19.7914,0.1347,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_78660.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(7137,7134,0,'LSQ12gyn','LSQ',44.708,-14.9487222222222,NULL,NULL,'2012-12-01 02:56:43',56262.1227199999,19.4421,0.2048,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_78661.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(7138,7134,0,'LSQ12gyn','LSQ',44.708,-14.94875,NULL,NULL,'2012-12-01 04:57:58',56262.2069299999,19.2797,0.1364,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_78662.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(7139,7134,0,'LSQ12gyn','LSQ',44.7079583333333,-14.9488055555556,NULL,NULL,'2012-12-03 02:59:26',56264.1246099998,19.6279,0.124,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_78623.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(7140,7134,0,'LSQ12gyn','LSQ',44.708,-14.9488055555556,NULL,NULL,'2012-12-03 05:02:41',56264.2102000001,19.5724,0.121,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 02:46:30','2012-12-04 02:46:30','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_78624.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(7142,7099,0,'LSQ12gyc','pessto',41.4586666667,-17.9293333333,NULL,NULL,'2012-12-04 02:24:00',56265.1,NULL,NULL,NULL,0.09,NULL,'Ia',NULL,'2012-12-04 12:00:15','2012-12-04 13:09:50','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38105873563,'NTT','EFOSC2','Mark','2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(7143,6273,1,'OGLE-2012-SN-040','pessto',91.756625,-69.35475,NULL,NULL,'2012-12-04 07:11:59',56265.3,NULL,NULL,NULL,0.014,NULL,'Ia peculiar',NULL,'2012-12-04 12:03:40','2019-10-11 14:10:04','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,39866462664,'NTT','EFOSC2','Mark',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,622913479,9733023,NULL,NULL,NULL,NULL),(7144,4061,0,'LSQ12ggx','pessto',47.8960833333,-22.3203611111,NULL,NULL,'2012-11-11 00:00:00',56242,NULL,NULL,NULL,0.069,NULL,'unknown',NULL,'2012-12-04 13:18:18','2012-12-04 13:46:18','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38031055901,'NTT','EFOSC2','Bufano','2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(7145,3818,0,'LSQ12gdc','LSQ',74.1527916666667,-31.6033611111111,NULL,NULL,'2012-12-04 05:31:32',56265.2302399999,19.352,0.1551,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_78851.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(7146,3818,0,'LSQ12gdc','LSQ',74.1527916666667,-31.6033888888889,NULL,NULL,'2012-12-04 07:50:57',56265.32706,18.8999,0.2008,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_history.html','blazar ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gdc/LSQ12gdc_snap_78852.gif',37210281094,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581410642,9084541,NULL,NULL,NULL,NULL),(7147,3821,0,'LSQ12gcw','LSQ',68.3187916666667,-38.1013333333333,NULL,NULL,'2012-12-04 05:14:28',56265.21838,19.2426,0.0748,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_78874.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(7148,3821,0,'LSQ12gcw','LSQ',68.3187083333333,-38.1013611111111,NULL,NULL,'2012-12-04 06:55:35',56265.2886100002,19.2493,0.0771,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_history.html','agn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gcw/LSQ12gcw_snap_78875.gif',37823536135,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,590992752,9234261,NULL,NULL,NULL,NULL),(7149,3864,0,'LSQ12gel','LSQ',55.7504583333333,-26.694,NULL,NULL,'2012-12-04 01:17:25',56265.0537700001,20.009,0.0862,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gel/LSQ12gel_snap_78837.gif',38528356173,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602005565,9406336,NULL,NULL,NULL,NULL),(7150,3868,0,'LSQ12gek','LSQ',55.5484583333333,-26.7351944444444,NULL,NULL,'2012-12-04 01:17:25',56265.0537700001,18.3411,0.038,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-06 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_snap_78861.gif',38579734652,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602808353,9418880,NULL,NULL,NULL,NULL),(7151,3868,0,'LSQ12gek','LSQ',55.5483333333333,-26.7353333333333,NULL,NULL,'2012-12-04 03:17:46',56265.1373399999,18.8748,0.0512,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-06 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_snap_78862.gif',38579734652,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602808353,9418880,NULL,NULL,NULL,NULL),(7152,4056,0,'LSQ12ghe','LSQ',68.5490416666667,-23.0559722222222,NULL,NULL,'2012-12-04 05:48:26',56265.2419699999,19.7348,0.1271,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_78872.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(7153,4056,0,'LSQ12ghe','LSQ',68.549,-23.0558055555556,NULL,NULL,'2012-12-04 07:42:33',56265.3212199998,19.5811,0.1288,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_78873.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(7154,4061,0,'LSQ12ggx','LSQ',47.8960416666667,-22.3203611111111,NULL,NULL,'2012-12-04 02:48:22',56265.11693,19.9015,0.1819,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_78924.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(7155,4061,0,'LSQ12ggx','LSQ',47.8960833333333,-22.3203333333333,NULL,NULL,'2012-12-04 04:48:46',56265.2005400001,19.9108,0.1601,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_78925.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(7156,4067,0,'LSQ12ggq','LSQ',69.4289166666667,-35.8658611111111,NULL,NULL,'2012-12-04 05:14:28',56265.21838,20.1599,0.1134,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_78904.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(7157,4067,0,'LSQ12ggq','LSQ',69.4288333333333,-35.8658611111111,NULL,NULL,'2012-12-04 06:55:35',56265.2886100002,20.2794,0.1233,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_78905.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(7158,4118,0,'LSQ12ghd','LSQ',71.8647083333333,-21.3295,NULL,NULL,'2012-12-04 05:48:26',56265.2419699999,19.9542,0.1054,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_78895.gif',37342671080,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479235,9116863,NULL,NULL,NULL,NULL),(7159,4118,0,'LSQ12ghd','LSQ',71.8645833333333,-21.3294444444444,NULL,NULL,'2012-12-04 07:42:33',56265.3212199998,19.9727,0.1239,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_78896.gif',37342671080,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479235,9116863,NULL,NULL,NULL,NULL),(7160,4120,0,'LSQ12ghc','LSQ',66.22275,-21.2026666666667,NULL,NULL,'2012-12-04 06:05:24',56265.2537600002,17.9417,0.042,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_78870.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(7161,4120,0,'LSQ12ghc','LSQ',66.22275,-21.2026666666667,NULL,NULL,'2012-12-04 07:21:02',56265.3062800001,17.8719,0.0424,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_78871.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(7162,4136,0,'LSQ12ggz','LSQ',56.3258333333333,-23.8723888888889,NULL,NULL,'2012-12-04 05:10:59',56265.2159699998,19.8658,0.1675,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_snap_78929.gif',37995959908,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593686873,9276357,NULL,NULL,NULL,NULL),(7163,4317,0,'LSQ12gkk','LSQ',76.8690833333333,-23.8545555555556,NULL,NULL,'2012-12-04 05:55:12',56265.2466699998,19.6578,0.1149,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_78816.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(7164,4317,0,'LSQ12gkk','LSQ',76.869,-23.8546111111111,NULL,NULL,'2012-12-04 07:39:10',56265.3188700001,19.7656,0.1179,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_78817.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(7165,5246,0,'LSQ12gln','LSQ',80.7475833333333,-33.46425,NULL,NULL,'2012-12-04 05:36:36',56265.2337500001,18.3204,0.0492,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_78920.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(7166,5246,0,'LSQ12gln','LSQ',80.7475416666667,-33.46425,NULL,NULL,'2012-12-04 07:05:44',56265.2956500002,18.3717,0.0585,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_78921.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(7167,5550,0,'LSQ12goy','LSQ',68.8834583333333,-26.4607222222222,NULL,NULL,'2012-12-04 05:38:17',56265.2349299998,19.424,0.1036,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_78975.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(7168,5550,0,'LSQ12goy','LSQ',68.8834166666667,-26.4607222222222,NULL,NULL,'2012-12-04 07:47:34',56265.3247099998,19.4454,0.1282,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_78976.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(7169,5557,0,'LSQ12gow','LSQ',48.1345416666667,-28.9633055555556,NULL,NULL,'2012-12-04 02:50:04',56265.1181100002,18.8293,0.1007,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_78985.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(7170,5823,0,'LSQ12grh','LSQ',48.076625,-24.5529722222222,NULL,NULL,'2012-12-04 02:48:22',56265.11693,18.8624,0.0579,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_79022.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(7171,5823,0,'LSQ12grh','LSQ',48.0765833333333,-24.5529444444444,NULL,NULL,'2012-12-04 04:48:46',56265.2005400001,18.8243,0.0536,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_79023.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(7172,5839,0,'LSQ12gqq','LSQ',18.8637916666667,-31.39775,NULL,NULL,'2012-12-04 01:23:11',56265.0577699998,19.7576,0.0666,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_79020.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(7173,5839,0,'LSQ12gqq','LSQ',18.8638333333333,-31.39775,NULL,NULL,'2012-12-04 03:23:36',56265.14139,19.7929,0.0943,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_history.html','sn?',NULL,0.0531,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gqq/LSQ12gqq_snap_79021.gif',34735485245,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542741956,8480343,NULL,NULL,NULL,NULL),(7174,5856,0,'LSQ12gsh','LSQ',72.175625,-30.9982777777778,NULL,NULL,'2012-12-04 05:29:49',56265.2290400001,18.0018,0.0889,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_78946.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(7175,5856,0,'LSQ12gsh','LSQ',72.1755,-30.9982777777778,NULL,NULL,'2012-12-04 07:02:21',56265.2933,17.8485,0.0712,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_78947.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(7176,5876,0,'LSQ12gsv','LSQ',71.532,-25.2667777777778,NULL,NULL,'2012-12-04 05:48:26',56265.2419699999,19.7155,0.1196,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_78943.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(7177,5959,0,'LSQ12gtm','LSQ',69.9598333333333,-34.1287222222222,NULL,NULL,'2012-12-04 05:29:49',56265.2290400001,19.714,0.1228,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_78918.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(7178,5959,0,'LSQ12gtm','LSQ',69.9598333333333,-34.12875,NULL,NULL,'2012-12-04 07:02:21',56265.2933,19.757,0.1099,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_78919.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(7179,5970,0,'LSQ12gti','LSQ',40.0738333333333,-34.4596388888889,NULL,NULL,'2012-12-04 02:17:43',56265.09564,17.957,0.0586,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_78953.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(7180,5970,0,'LSQ12gti','LSQ',40.073875,-34.4596666666667,NULL,NULL,'2012-12-04 04:18:03',56265.1792100002,18.0369,0.063,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_78954.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(7181,5974,0,'LSQ12gte','LSQ',20.1440416666667,-34.1217777777778,NULL,NULL,'2012-12-04 03:23:36',56265.14139,20.0382,0.0996,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gte/LSQ12gte_history.html','sn?',NULL,0.012725,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gte/LSQ12gte_snap_78961.gif',38285361946,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,598208780,9347012,NULL,NULL,NULL,NULL),(7182,6109,0,'LSQ12gwg','LSQ',71.316625,-29.0706666666667,NULL,NULL,'2012-12-04 05:43:21',56265.23844,19.3277,0.1016,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_79005.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(7183,6109,0,'LSQ12gwg','LSQ',71.3165833333333,-29.0706944444444,NULL,NULL,'2012-12-04 07:09:07',56265.298,19.1974,0.128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_79006.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(7184,6117,0,'LSQ12gwf','LSQ',31.6620833333333,-31.2923611111111,NULL,NULL,'2012-12-04 02:04:05',56265.0861800001,19.4467,0.1128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_history.html','sn?',NULL,0.1321,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_snap_79007.gif',38445793238,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,600715519,9386179,NULL,NULL,NULL,NULL),(7185,6117,0,'LSQ12gwf','LSQ',31.6624583333333,-31.2921666666667,NULL,NULL,'2012-12-04 04:04:24',56265.1697300002,18.5611,0.0971,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_history.html','sn?',NULL,0.1321,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_snap_79008.gif',38445793246,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,600715519,9386179,NULL,NULL,NULL,NULL),(7186,6119,0,'LSQ12gwd','LSQ',26.4444583333333,-31.2559444444444,NULL,NULL,'2012-12-04 03:49:01',56265.1590399998,19.7588,0.1834,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwd/LSQ12gwd_history.html','sn?',NULL,0.0554,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwd/LSQ12gwd_snap_79003.gif',38307761501,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,598558773,9352480,NULL,NULL,NULL,NULL),(7187,6121,0,'LSQ12gwc','LSQ',55.8400416666667,-26.7371666666667,NULL,NULL,'2012-12-04 01:17:25',56265.0537700001,20.7916,0.1006,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_79000.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(7188,6132,0,'LSQ12gwb','LSQ',54.008,-29.7770555555556,NULL,NULL,'2012-12-04 01:13:45',56265.0512199998,21.1123,0.0855,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_history.html','sn?',NULL,0.1516,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_snap_79001.gif',38584840201,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602888128,9420127,NULL,NULL,NULL,NULL),(7189,6132,0,'LSQ12gwb','LSQ',54.0084166666667,-29.7771944444444,NULL,NULL,'2012-12-04 03:14:04',56265.13478,22.1657,0.1827,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_history.html','sn?',NULL,0.1516,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_snap_79002.gif',38584840201,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602888128,9420127,NULL,NULL,NULL,NULL),(7190,6144,0,'LSQ12gvw','LSQ',17.519375,-31.9528333333333,NULL,NULL,'2012-12-04 01:23:11',56265.0577699998,20.4911,0.0964,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_history.html','sn - nice',NULL,0.1397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_snap_78991.gif',34744530696,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542883292,8482551,NULL,NULL,NULL,NULL),(7191,6144,0,'LSQ12gvw','LSQ',17.519375,-31.95275,NULL,NULL,'2012-12-04 03:23:36',56265.14139,20.2425,0.1156,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_history.html','sn - nice',NULL,0.1397,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvw/LSQ12gvw_snap_78992.gif',34744530696,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,542883292,8482551,NULL,NULL,NULL,NULL),(7192,6150,0,'LSQ12gvs','LSQ',64.3944583333333,-38.8894722222222,NULL,NULL,'2012-12-04 06:08:49',56265.2561300001,18.475,0.0362,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_78982.gif',37791067655,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(7193,6150,0,'LSQ12gvs','LSQ',64.3944166666667,-38.8895277777778,NULL,NULL,'2012-12-04 07:19:16',56265.3050500001,18.5664,0.0441,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_78983.gif',37791067653,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(7194,6182,0,'LSQ12gwl','LSQ',55.021125,-21.5045833333333,NULL,NULL,'2012-12-04 03:01:58',56265.1263700002,20.8319,0.1706,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_snap_79012.gif',38047180771,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594487199,9288862,NULL,NULL,NULL,NULL),(7195,6188,0,'LSQ12gwk','LSQ',44.3662083333333,-25.3950555555556,NULL,NULL,'2012-12-04 04:33:33',56265.1899700002,19.815,0.1459,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_79011.gif',38420060774,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(7196,7057,0,'LSQ12gwp','LSQ',35.4772916666667,-34.3143055555555,NULL,NULL,'2012-12-04 04:04:24',56265.1697300002,19.8725,0.1155,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwp/LSQ12gwp_history.html','sn?',NULL,0.0205,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwp/LSQ12gwp_snap_78778.gif',38419063033,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,600297859,9379654,NULL,NULL,NULL,NULL),(7197,7060,0,'LSQ12gwo','LSQ',41.8850416666667,-38.8548888888889,NULL,NULL,'2012-12-04 04:23:19',56265.1828700001,20.3127,0.1216,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 13:46:15','2012-12-04 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwo/LSQ12gwo_history.html','sn?',NULL,0.062947,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwo/LSQ12gwo_snap_78774.gif',38629474459,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,603585538,9431024,NULL,NULL,NULL,NULL),(7243,7243,1,'LSQ12gzm','LSQ',40.1817083333333,-34.7405,NULL,NULL,'2012-12-02 02:23:04',56263.0993599999,19.3746,0.1546,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_snap_79126.gif',38633055142,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603641486,9431898,NULL,NULL,NULL,NULL),(7244,7243,0,'LSQ12gzm','LSQ',40.18175,-34.7405555555556,NULL,NULL,'2012-12-04 02:24:35',56265.10041,18.4336,0.0993,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_snap_79059.gif',38633055142,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603641486,9431898,NULL,NULL,NULL,NULL),(7245,7243,0,'LSQ12gzm','LSQ',40.1817083333333,-34.7405,NULL,NULL,'2012-12-04 04:25:01',56265.1840499998,18.7691,0.1027,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_snap_79060.gif',38633055142,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603641486,9431898,NULL,NULL,NULL,NULL),(7246,7246,1,'LSQ12gzl','LSQ',41.028875,-37.1565277777778,NULL,NULL,'2012-11-24 02:14:41',56255.0935399998,18.4423,0.0698,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_snap_79099.gif',38634771280,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603668301,9432317,NULL,NULL,NULL,NULL),(7247,7246,0,'LSQ12gzl','LSQ',41.028875,-37.1565555555556,NULL,NULL,'2012-11-24 04:15:27',56255.1773999999,19.835,0.167,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2012-12-04 19:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_snap_79100.gif',38634771280,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603668301,9432317,NULL,NULL,NULL,NULL),(7248,7246,0,'LSQ12gzl','LSQ',41.0289583333333,-37.1565555555556,NULL,NULL,'2012-11-26 02:16:52',56257.0950500001,19.2547,0.1605,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2012-12-04 19:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_snap_79101.gif',38634771280,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603668301,9432317,NULL,NULL,NULL,NULL),(7249,7246,0,'LSQ12gzl','LSQ',41.028875,-37.1565555555556,NULL,NULL,'2012-11-26 04:17:41',56257.1789500001,19.2738,0.1369,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2012-12-04 19:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_snap_79102.gif',38634771280,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603668301,9432317,NULL,NULL,NULL,NULL),(7250,7246,0,'LSQ12gzl','LSQ',41.028875,-37.1565555555556,NULL,NULL,'2012-11-30 04:32:56',56261.1895400002,19.2928,0.1384,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2012-12-04 19:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_snap_79103.gif',38634771280,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603668301,9432317,NULL,NULL,NULL,NULL),(7251,7246,0,'LSQ12gzl','LSQ',41.028875,-37.1566388888889,NULL,NULL,'2012-12-02 04:23:19',56263.1828700001,19.5003,0.1378,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2012-12-04 19:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_snap_79104.gif',38634771280,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603668301,9432317,NULL,NULL,NULL,NULL),(7252,7246,0,'LSQ12gzl','LSQ',41.029,-37.1565555555556,NULL,NULL,'2012-12-04 02:24:35',56265.10041,17.2575,0.0997,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2012-12-04 19:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_snap_79057.gif',38634771280,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603668301,9432317,NULL,NULL,NULL,NULL),(7253,7246,0,'LSQ12gzl','LSQ',41.0289166666667,-37.1567222222222,NULL,NULL,'2012-12-04 04:25:01',56265.1840499998,17.1033,0.1192,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2012-12-04 19:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_snap_79058.gif',38634771280,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603668301,9432317,NULL,NULL,NULL,NULL),(7254,7254,1,'LSQ12gzk','LSQ',41.0457083333333,-37.0320555555556,NULL,NULL,'2012-11-24 04:15:27',56255.1773999999,18.1054,0.0543,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_snap_79093.gif',38634729855,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603667653,9432307,NULL,NULL,NULL,NULL),(7255,7254,0,'LSQ12gzk','LSQ',41.045375,-37.0318333333333,NULL,NULL,'2012-11-26 02:16:52',56257.0950500001,19.4022,0.186,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2012-12-04 19:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_snap_79094.gif',38634729852,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603667653,9432307,NULL,NULL,NULL,NULL),(7256,7254,0,'LSQ12gzk','LSQ',41.04575,-37.0321111111111,NULL,NULL,'2012-11-26 04:17:41',56257.1789500001,18.4797,0.0879,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2012-12-04 19:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_snap_79095.gif',38634729855,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603667653,9432307,NULL,NULL,NULL,NULL),(7257,7254,0,'LSQ12gzk','LSQ',41.044875,-37.0323055555556,NULL,NULL,'2012-11-30 02:31:56',56261.1055100001,17.879,0.0665,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2012-12-04 19:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_snap_79096.gif',38634729853,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603667653,9432307,NULL,NULL,NULL,NULL),(7258,7254,0,'LSQ12gzk','LSQ',41.0449166666667,-37.03225,NULL,NULL,'2012-11-30 04:32:56',56261.1895400002,18.8695,0.1218,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2012-12-04 19:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_snap_79097.gif',38634729853,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603667653,9432307,NULL,NULL,NULL,NULL),(7259,7254,0,'LSQ12gzk','LSQ',41.0458333333333,-37.0321388888889,NULL,NULL,'2012-12-02 04:23:19',56263.1828700001,19.2676,0.108,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2012-12-04 19:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_snap_79098.gif',38634729855,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603667653,9432307,NULL,NULL,NULL,NULL),(7260,7254,0,'LSQ12gzk','LSQ',41.0452916666667,-37.0320277777778,NULL,NULL,'2012-12-04 02:24:35',56265.10041,14.8622,0.0312,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2012-12-04 19:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_snap_79055.gif',38634729855,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603667653,9432307,NULL,NULL,NULL,NULL),(7261,7254,0,'LSQ12gzk','LSQ',41.045375,-37.0320833333333,NULL,NULL,'2012-12-04 04:25:01',56265.1840499998,14.0945,0.0129,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-04 19:46:17','2012-12-04 19:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_snap_79056.gif',38634729855,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603667653,9432307,NULL,NULL,NULL,NULL),(7267,5620,0,'SN2012hf','pessto',164.2394,-14.2938472222,NULL,NULL,'2012-11-14 12:00:00',56253,NULL,NULL,NULL,0.015497,NULL,'Ic',NULL,'2012-12-05 10:03:03','2019-08-18 22:06:58','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41869744922,'NTT','EFOSC','Joe Anderson',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,654214764,10222105,NULL,NULL,NULL,NULL),(7268,7075,0,'LSQ12gxb','pessto',142.838791667,-11.6296666667,NULL,NULL,'2012-12-04 00:00:00',56265,NULL,NULL,NULL,0.05,NULL,'I peculiar',NULL,'2012-12-05 10:50:07','2019-10-11 14:09:07','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,42178887818,'NTT','EFOSC2','Smartt','2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,1182481,NULL,0,659045122,10297580,NULL,NULL,NULL,NULL),(7271,3851,0,'LSQ12ges','LSQ',74.9862916666667,-19.4644444444444,NULL,NULL,'2012-12-05 05:10:03',56266.21532,20.3869,0.2073,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ges/LSQ12ges_snap_79939.gif',37563466779,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586929168,9170768,NULL,NULL,NULL,NULL),(7272,3883,0,'LSQ12gfh','LSQ',53.6905,-6.84377777777778,NULL,NULL,'2012-12-05 03:01:43',56266.1261999998,16.9306,0.0152,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_history.html','sne??',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gfh/LSQ12gfh_snap_79865.gif',36800390526,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575006101,8984470,NULL,NULL,NULL,NULL),(7273,4165,0,'LSQ12gjc','LSQ',52.6709166666667,-6.37286111111111,NULL,NULL,'2012-12-05 05:01:28',56266.2093600002,20.0402,0.1801,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_79867.gif',36797933958,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(7274,4356,0,'LSQ12gla','LSQ',50.0670416666667,-9.48097222222222,NULL,NULL,'2012-12-05 02:58:20',56266.1238500001,20.6277,0.1789,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_snap_79846.gif',37898099251,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,592157800,9252465,NULL,NULL,NULL,NULL),(7275,4356,0,'LSQ12gla','LSQ',50.067125,-9.48080555555556,NULL,NULL,'2012-12-05 04:58:07',56266.2070300002,19.6053,0.1997,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_snap_79847.gif',37898099251,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,592157800,9252465,NULL,NULL,NULL,NULL),(7276,5376,0,'LSQ12glw','LSQ',143.033375,-9.68069444444444,NULL,NULL,'2012-12-05 05:22:39',56266.22407,19.1101,0.1503,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glw/LSQ12glw_history.html','sne?',NULL,0.054681,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glw/LSQ12glw_snap_79882.gif',41090785038,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642043516,10031929,NULL,NULL,NULL,NULL),(7277,5813,0,'LSQ12gpw','LSQ',48.2426666666667,-11.7111111111111,NULL,NULL,'2012-12-05 02:58:20',56266.1238500001,16.48,0.0132,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-06 23:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_79920.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(7278,5813,0,'LSQ12gpw','LSQ',48.2426666666667,-11.7111666666667,NULL,NULL,'2012-12-05 04:58:07',56266.2070300002,16.466,0.0159,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-06 23:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_79921.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(7279,5983,0,'LSQ12gul','LSQ',43.0337916666667,-0.0360833333333333,NULL,NULL,'2012-12-05 02:15:12',56266.0938900001,18.4249,0.0304,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_79871.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(7280,5983,0,'LSQ12gul','LSQ',43.0337916666667,-0.0360833333333333,NULL,NULL,'2012-12-05 04:15:21',56266.1773299999,18.2775,0.0398,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_79872.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(7281,5985,0,'LSQ12guj','LSQ',36.2344583333333,5.12116666666667,NULL,NULL,'2012-12-05 01:36:52',56266.06727,18.2372,0.0295,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_snap_79873.gif',66894622375,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045228474,16331694,NULL,NULL,NULL,NULL),(7282,5985,0,'LSQ12guj','LSQ',36.2344583333333,5.12116666666667,NULL,NULL,'2012-12-05 03:37:03',56266.15074,18.1848,0.029,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_snap_79874.gif',66894622375,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045228474,16331694,NULL,NULL,NULL,NULL),(7283,5993,0,'LSQ12gtz','LSQ',48.3627083333333,-7.35841666666667,NULL,NULL,'2012-12-05 02:46:05',56266.11534,18.2047,0.0378,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_79897.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7284,5993,0,'LSQ12gtz','LSQ',48.3627083333333,-7.3585,NULL,NULL,'2012-12-05 02:58:20',56266.1238500001,18.7927,0.0562,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_79895.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7285,5993,0,'LSQ12gtz','LSQ',48.362875,-7.35833333333333,NULL,NULL,'2012-12-05 04:45:57',56266.1985800001,17.7978,0.0446,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_79898.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7286,5993,0,'LSQ12gtz','LSQ',48.36275,-7.3585,NULL,NULL,'2012-12-05 04:58:07',56266.2070300002,18.6973,0.0826,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_79896.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7287,6014,0,'LSQ12gty','LSQ',73.3359583333333,-14.9325555555556,NULL,NULL,'2012-12-05 05:13:26',56266.2176700002,19.1081,0.0704,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_79893.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(7288,6014,0,'LSQ12gty','LSQ',73.336,-14.9325833333333,NULL,NULL,'2012-12-05 06:56:46',56266.2894299999,18.9776,0.087,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_79894.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(7289,6155,0,'LSQ12gve','LSQ',51.1098333333333,-11.6695555555556,NULL,NULL,'2012-12-05 02:58:20',56266.1238500001,17.6426,0.0657,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_79901.gif',37885390161,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(7290,6167,0,'LSQ12gvb','LSQ',46.52825,-2.58222222222222,NULL,NULL,'2012-12-05 02:16:53',56266.0950600002,18.4131,0.0756,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_79904.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(7291,6167,0,'LSQ12gvb','LSQ',46.5283333333333,-2.58219444444444,NULL,NULL,'2012-12-05 04:17:03',56266.17851,19.4685,0.1083,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_79905.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(7292,6204,0,'LSQ12guu','LSQ',24.4688333333333,-16.2693333333333,NULL,NULL,'2012-12-05 01:33:17',56266.0647900002,16.8547,0.0153,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guu/LSQ12guu_history.html','unusual variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guu/LSQ12guu_snap_79910.gif',35192089516,NULL,NULL,NULL,'2012-10-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,549876398,8591818,NULL,NULL,NULL,NULL),(7293,7063,0,'LSQ12gxj','LSQ',43.2392916666667,1.60675,NULL,NULL,'2012-12-05 02:16:53',56266.0950600002,19.0858,0.0938,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_79771.gif',66842134734,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(7294,7063,0,'LSQ12gxj','LSQ',43.23925,1.60675,NULL,NULL,'2012-12-05 04:17:03',56266.17851,19.3333,0.1255,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_79772.gif',66842134734,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(7295,7067,0,'LSQ12gxh','LSQ',152.531916666667,-7.00358333333333,NULL,NULL,'2012-12-05 06:20:51',56266.26449,17.8659,0.1107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxh/LSQ12gxh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxh/LSQ12gxh_snap_79758.gif',41250965852,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644546341,10071036,NULL,NULL,NULL,NULL),(7296,7071,0,'LSQ12gxd','LSQ',36.0342916666667,-3.46425,NULL,NULL,'2012-12-05 01:13:58',56266.05137,19.9269,0.1289,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_79756.gif',34918978036,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(7297,7071,0,'LSQ12gxd','LSQ',36.03425,-3.46422222222222,NULL,NULL,'2012-12-05 03:14:12',56266.1348700002,19.884,0.1254,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_79757.gif',34918978036,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(7298,7075,0,'LSQ12gxb','LSQ',142.838833333333,-11.6296111111111,NULL,NULL,'2012-12-05 05:22:39',56266.22407,19.6416,0.1157,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_snap_79752.gif',42178887818,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,659045122,10297580,NULL,NULL,NULL,NULL),(7299,7079,0,'LSQ12gwy','LSQ',160.883416666667,-13.289,NULL,NULL,'2012-12-05 06:15:40',56266.26088,15.7176,0.0076,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwy/LSQ12gwy_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwy/LSQ12gwy_snap_79777.gif',41838066142,NULL,NULL,NULL,'2012-05-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653719783,10214371,NULL,NULL,NULL,NULL),(7300,7079,0,'LSQ12gwy','LSQ',160.883458333333,-13.2889722222222,NULL,NULL,'2012-12-05 07:25:00',56266.3090300001,15.7537,0.0062,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwy/LSQ12gwy_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwy/LSQ12gwy_snap_79778.gif',41838066142,NULL,NULL,NULL,'2012-05-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653719783,10214371,NULL,NULL,NULL,NULL),(7301,7116,0,'LSQ12gzh','LSQ',44.8050416666667,7.26136111111111,NULL,NULL,'2012-12-05 01:55:43',56266.0803700001,20.0441,0.1546,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzh/LSQ12gzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzh/LSQ12gzh_snap_79773.gif',67978103970,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1062157874,16596216,NULL,NULL,NULL,NULL),(7302,7116,0,'LSQ12gzh','LSQ',44.8050416666667,7.26147222222222,NULL,NULL,'2012-12-05 03:56:05',56266.16395,19.9293,0.1184,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzh/LSQ12gzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzh/LSQ12gzh_snap_79774.gif',67978103970,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1062157874,16596216,NULL,NULL,NULL,NULL),(7303,7083,0,'LSQ12gyr','LSQ',43.2104166666667,-7.71225,NULL,NULL,'2012-12-05 02:41:00',56266.1118100001,19.6486,0.1525,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_history.html','sne - nice',NULL,0.11794,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_snap_79720.gif',37909543298,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592336614,9255259,NULL,NULL,NULL,NULL),(7304,7083,0,'LSQ12gyr','LSQ',43.2103333333333,-7.71225,NULL,NULL,'2012-12-05 04:40:52',56266.1950500002,19.4026,0.164,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_history.html','sne - nice',NULL,0.11794,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_snap_79721.gif',37909543298,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592336614,9255259,NULL,NULL,NULL,NULL),(7305,7094,0,'LSQ12gye','LSQ',161.594208333333,-20.3265,NULL,NULL,'2012-12-05 07:41:57',56266.3208099999,17.8719,0.0208,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gye/LSQ12gye_history.html','possible asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gye/LSQ12gye_snap_79739.gif',41631758262,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650496222,10164003,NULL,NULL,NULL,NULL),(7306,7096,0,'LSQ12gyd','LSQ',76.387125,-18.0351388888889,NULL,NULL,'2012-12-05 05:11:43',56266.2164799999,19.5106,0.09,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_79733.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(7307,7099,0,'LSQ12gyc','LSQ',41.458625,-17.9293888888889,NULL,NULL,'2012-12-05 02:47:50',56266.11656,17.6814,0.0472,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_79737.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(7308,7099,0,'LSQ12gyc','LSQ',41.458625,-17.9293333333333,NULL,NULL,'2012-12-05 04:47:43',56266.1998100001,17.6572,0.0687,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_79738.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(7309,7118,0,'LSQ12gzb','LSQ',37.0446666666667,-5.94608333333333,NULL,NULL,'2012-12-05 01:13:58',56266.05137,20.1652,0.0793,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_79791.gif',34948583495,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(7310,7118,0,'LSQ12gzb','LSQ',37.044625,-5.94608333333333,NULL,NULL,'2012-12-05 03:14:12',56266.1348700002,20.19,0.0771,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_79792.gif',34948583494,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(7311,7122,0,'LSQ12gza','LSQ',35.8930833333333,-5.90736111111111,NULL,NULL,'2012-12-05 01:13:58',56266.05137,20.2683,0.0798,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_79802.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(7312,7122,0,'LSQ12gza','LSQ',35.8930416666667,-5.90736111111111,NULL,NULL,'2012-12-05 03:14:12',56266.1348700002,20.345,0.1127,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_79803.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(7313,7127,0,'LSQ12gyw','LSQ',28.51775,-10.3499444444444,NULL,NULL,'2012-12-05 01:40:16',56266.0696399999,21.0387,0.0948,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyw/LSQ12gyw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyw/LSQ12gyw_snap_79793.gif',35111082183,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548610659,8572041,NULL,NULL,NULL,NULL),(7314,7127,0,'LSQ12gyw','LSQ',28.517625,-10.3498611111111,NULL,NULL,'2012-12-05 03:40:28',56266.1531099998,19.8992,0.0786,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyw/LSQ12gyw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyw/LSQ12gyw_snap_79794.gif',35111082183,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548610659,8572041,NULL,NULL,NULL,NULL),(7315,7131,0,'LSQ12gyv','LSQ',50.4707916666667,-10.0815,NULL,NULL,'2012-12-05 02:56:40',56266.1226900001,18.5546,0.0593,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_snap_79767.gif',37898370242,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592162035,9252531,NULL,NULL,NULL,NULL),(7316,7131,0,'LSQ12gyv','LSQ',50.4709166666667,-10.0815277777778,NULL,NULL,'2012-12-05 04:56:24',56266.20584,18.5679,0.0757,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_snap_79768.gif',37898370242,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592162035,9252531,NULL,NULL,NULL,NULL),(7317,7134,0,'LSQ12gyn','LSQ',44.7079583333333,-14.9488333333333,NULL,NULL,'2012-12-05 02:54:59',56266.12152,19.9557,0.141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_79754.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(7318,7134,0,'LSQ12gyn','LSQ',44.708,-14.9488055555556,NULL,NULL,'2012-12-05 04:54:44',56266.20468,19.6852,0.1216,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 18:46:13','2012-12-05 18:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_79755.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(7319,7319,1,'LSQ12hco','LSQ',48.624,-2.691,NULL,NULL,'2012-12-01 04:37:20',56262.1926000002,19.86,0.2103,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_snap_80113.gif',36791664995,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574869765,8982340,NULL,NULL,NULL,NULL),(7320,7319,0,'LSQ12hco','LSQ',48.6238333333333,-2.691,NULL,NULL,'2012-12-03 02:38:37',56264.1101600002,19.8127,0.1139,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_snap_80114.gif',36791664995,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574869765,8982340,NULL,NULL,NULL,NULL),(7321,7319,0,'LSQ12hco','LSQ',48.6239166666667,-2.69102777777778,NULL,NULL,'2012-12-03 04:38:19',56264.1932799998,19.5298,0.154,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_snap_80115.gif',36791664995,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574869765,8982340,NULL,NULL,NULL,NULL),(7322,7319,0,'LSQ12hco','LSQ',48.6237916666667,-2.69097222222222,NULL,NULL,'2012-12-05 02:34:03',56266.1069800002,20.0841,0.1212,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_snap_80054.gif',36791664995,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574869765,8982340,NULL,NULL,NULL,NULL),(7323,7319,0,'LSQ12hco','LSQ',48.6239166666667,-2.69111111111111,NULL,NULL,'2012-12-05 04:34:01',56266.1902999999,19.8763,0.1599,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_snap_80055.gif',36791664995,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574869765,8982340,NULL,NULL,NULL,NULL),(7324,7324,1,'LSQ12hcn','LSQ',39.599125,-1.66169444444444,NULL,NULL,'2012-12-05 02:01:05',56266.08409,17.8673,0.0213,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcn/LSQ12hcn_history.html','sn hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcn/LSQ12hcn_snap_80052.gif',34957695264,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,546213988,8534593,NULL,NULL,NULL,NULL),(7325,7324,0,'LSQ12hcn','LSQ',39.5991666666667,-1.66169444444444,NULL,NULL,'2012-12-05 04:01:12',56266.1675100001,18.846,0.0532,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcn/LSQ12hcn_history.html','sn hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcn/LSQ12hcn_snap_80053.gif',34957695264,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,546213988,8534593,NULL,NULL,NULL,NULL),(7326,7326,1,'LSQ12hcm','LSQ',55.5312916666667,4.23161111111111,NULL,NULL,'2012-12-05 02:53:07',56266.1202199999,19.9914,0.1009,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_history.html','sn nice',NULL,0.024457,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_snap_80050.gif',65206467034,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1018851047,15919547,NULL,NULL,NULL,NULL),(7327,7326,0,'LSQ12hcm','LSQ',55.5312916666667,4.23169444444444,NULL,NULL,'2012-12-05 04:52:58',56266.20346,19.8234,0.1197,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-06 11:16:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_history.html','sn nice',NULL,0.024457,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_snap_80051.gif',65206467034,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1018851047,15919547,NULL,NULL,NULL,NULL),(7328,7328,1,'LSQ12hcl','LSQ',42.9150416666667,-1.89855555555556,NULL,NULL,'2012-11-25 02:07:48',56256.0887500001,19.3652,0.1523,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_snap_80108.gif',34899428012,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545303562,8520368,NULL,NULL,NULL,NULL),(7329,7328,0,'LSQ12hcl','LSQ',42.9150416666667,-1.89855555555556,NULL,NULL,'2012-12-01 02:17:13',56262.0952900001,19.1978,0.125,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_snap_80109.gif',34899428012,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545303562,8520368,NULL,NULL,NULL,NULL),(7330,7328,0,'LSQ12hcl','LSQ',42.915,-1.89866666666667,NULL,NULL,'2012-12-01 04:18:28',56262.1795000001,18.9131,0.1393,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_snap_80110.gif',34899428012,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545303562,8520368,NULL,NULL,NULL,NULL),(7331,7328,0,'LSQ12hcl','LSQ',42.9150416666667,-1.89863888888889,NULL,NULL,'2012-12-03 02:19:43',56264.0970299998,19.4806,0.1496,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_snap_80111.gif',34899428012,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545303562,8520368,NULL,NULL,NULL,NULL),(7332,7328,0,'LSQ12hcl','LSQ',42.9150416666667,-1.89863888888889,NULL,NULL,'2012-12-03 04:20:53',56264.1811799998,19.3169,0.1048,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_snap_80112.gif',34899428012,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545303562,8520368,NULL,NULL,NULL,NULL),(7333,7328,0,'LSQ12hcl','LSQ',42.9150833333333,-1.89861111111111,NULL,NULL,'2012-12-05 02:15:12',56266.0938900001,19.4721,0.0673,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_snap_80048.gif',34899428012,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545303562,8520368,NULL,NULL,NULL,NULL),(7334,7328,0,'LSQ12hcl','LSQ',42.915,-1.89869444444444,NULL,NULL,'2012-12-05 04:15:21',56266.1773299999,19.597,0.1134,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_snap_80049.gif',34899428012,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545303562,8520368,NULL,NULL,NULL,NULL),(7335,7335,1,'LSQ12hcd','LSQ',144.619375,-8.7195,NULL,NULL,'2012-12-05 05:24:20',56266.2252400001,19.014,0.0855,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcd/LSQ12hcd_history.html','sn hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcd/LSQ12hcd_snap_80032.gif',41315096333,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645548380,10086693,NULL,NULL,NULL,NULL),(7336,7335,0,'LSQ12hcd','LSQ',144.619208333333,-8.71913888888889,NULL,NULL,'2012-12-05 07:01:05',56266.2924199998,19.4832,0.1438,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcd/LSQ12hcd_history.html','sn hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcd/LSQ12hcd_snap_80033.gif',41315096333,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645548380,10086693,NULL,NULL,NULL,NULL),(7337,7337,1,'LSQ12hcc','LSQ',143.778333333333,-8.55044444444444,NULL,NULL,'2012-12-03 08:19:21',56264.3467799998,19.0962,0.1482,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcc/LSQ12hcc_history.html','sn?',NULL,0.089982,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcc/LSQ12hcc_snap_80090.gif',41103056560,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642235258,10034925,NULL,NULL,NULL,NULL),(7338,7337,0,'LSQ12hcc','LSQ',143.778416666667,-8.55044444444444,NULL,NULL,'2012-12-05 05:22:39',56266.22407,18.5815,0.1062,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcc/LSQ12hcc_history.html','sn?',NULL,0.089982,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcc/LSQ12hcc_snap_80030.gif',41103056560,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642235258,10034925,NULL,NULL,NULL,NULL),(7339,7337,0,'LSQ12hcc','LSQ',143.778333333333,-8.55052777777778,NULL,NULL,'2012-12-05 07:02:47',56266.2936,18.517,0.0968,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcc/LSQ12hcc_history.html','sn?',NULL,0.089982,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcc/LSQ12hcc_snap_80031.gif',41103056560,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642235258,10034925,NULL,NULL,NULL,NULL),(7340,6878,0,'LSQ12hcb','LSQ',27.253875,-10.6183611111111,NULL,NULL,'2012-12-01 03:43:37',56262.1552900001,19.4747,0.1901,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcb/LSQ12hcb_history.html','sn hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcb/LSQ12hcb_snap_80088.gif',35113149387,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548642959,8572546,NULL,NULL,NULL,NULL),(7341,6878,0,'LSQ12hcb','LSQ',27.2539166666667,-10.6184444444444,NULL,NULL,'2012-12-03 01:44:48',56264.07278,19.9207,0.1679,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcb/LSQ12hcb_history.html','sn hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcb/LSQ12hcb_snap_80089.gif',35113149387,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548642959,8572546,NULL,NULL,NULL,NULL),(7342,6878,0,'LSQ12hcb','LSQ',27.2539166666667,-10.6185,NULL,NULL,'2012-12-05 01:40:16',56266.0696399999,19.7707,0.1361,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcb/LSQ12hcb_history.html','sn hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcb/LSQ12hcb_snap_80028.gif',35113149387,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548642959,8572546,NULL,NULL,NULL,NULL),(7343,6878,0,'LSQ12hcb','LSQ',27.2539583333333,-10.6184166666667,NULL,NULL,'2012-12-05 03:40:28',56266.1531099998,19.9357,0.1589,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcb/LSQ12hcb_history.html','sn hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcb/LSQ12hcb_snap_80029.gif',35113149387,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548642959,8572546,NULL,NULL,NULL,NULL),(7344,7344,1,'LSQ12hbz','LSQ',160.316958333333,-14.5202777777778,NULL,NULL,'2012-12-03 07:29:21',56264.3120499998,18.1754,0.0446,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbz/LSQ12hbz_history.html','sn hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbz/LSQ12hbz_snap_80086.gif',41838987253,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653734175,10214596,NULL,NULL,NULL,NULL),(7345,7344,0,'LSQ12hbz','LSQ',160.317208333333,-14.5203333333333,NULL,NULL,'2012-12-05 06:15:40',56266.26088,17.91,0.0506,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbz/LSQ12hbz_history.html','sn hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbz/LSQ12hbz_snap_80024.gif',41838987210,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653734175,10214596,NULL,NULL,NULL,NULL),(7346,7344,0,'LSQ12hbz','LSQ',160.31725,-14.52025,NULL,NULL,'2012-12-05 07:25:00',56266.3090300001,17.89,0.0347,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbz/LSQ12hbz_history.html','sn hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbz/LSQ12hbz_snap_80025.gif',41838987210,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653734175,10214596,NULL,NULL,NULL,NULL),(7347,7347,1,'LSQ12hbp','LSQ',21.7405416666667,-12.5435,NULL,NULL,'2012-12-03 01:25:54',56264.0596599998,20.6116,0.1458,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbp/LSQ12hbp_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbp/LSQ12hbp_snap_80062.gif',35401932898,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,553155201,8643050,NULL,NULL,NULL,NULL),(7348,7347,0,'LSQ12hbp','LSQ',21.7404583333333,-12.5435277777778,NULL,NULL,'2012-12-03 03:27:25',56264.1440400002,20.4163,0.1588,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbp/LSQ12hbp_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbp/LSQ12hbp_snap_80063.gif',35401932898,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,553155201,8643050,NULL,NULL,NULL,NULL),(7349,7347,0,'LSQ12hbp','LSQ',21.7405,-12.5435277777778,NULL,NULL,'2012-12-05 01:21:25',56266.0565399998,20.5994,0.1619,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbp/LSQ12hbp_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbp/LSQ12hbp_snap_80004.gif',35401932898,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,553155201,8643050,NULL,NULL,NULL,NULL),(7350,7347,0,'LSQ12hbp','LSQ',21.7405,-12.5434722222222,NULL,NULL,'2012-12-05 03:21:36',56266.1400100002,20.4369,0.1275,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-05 21:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbp/LSQ12hbp_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbp/LSQ12hbp_snap_80005.gif',35401932898,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,553155201,8643050,NULL,NULL,NULL,NULL),(7351,7351,1,'LSQ12hbo','LSQ',164.064833333333,-20.8588055555556,NULL,NULL,'2012-12-05 06:35:53',56266.2749200002,18.1693,0.038,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbo/LSQ12hbo_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbo/LSQ12hbo_snap_80002.gif',41856029840,NULL,NULL,NULL,'2012-06-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,654000466,10218757,NULL,NULL,NULL,NULL),(7352,7351,0,'LSQ12hbo','LSQ',164.064791666667,-20.8588055555556,NULL,NULL,'2012-12-05 07:36:52',56266.3172800001,18.0779,0.0382,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 21:46:16','2012-12-06 11:16:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbo/LSQ12hbo_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbo/LSQ12hbo_snap_80003.gif',41856029840,NULL,NULL,NULL,'2012-06-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,654000466,10218757,NULL,NULL,NULL,NULL),(7353,7353,1,'LSQ12hbx','LSQ',19.1099583333333,-16.4730833333333,NULL,NULL,'2012-12-05 05:17:27',56266.22046,19.4275,0.1064,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 22:46:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbx/LSQ12hbx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbx/LSQ12hbx_snap_80020.gif',35411741439,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,553308459,8645444,NULL,NULL,NULL,NULL),(7354,7353,0,'LSQ12hbx','LSQ',19.1099583333333,-16.4728611111111,NULL,NULL,'2012-12-05 05:19:07',56266.22162,19.2171,0.1072,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 22:46:15','2012-12-05 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbx/LSQ12hbx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbx/LSQ12hbx_snap_80021.gif',35411741439,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,553308459,8645444,NULL,NULL,NULL,NULL),(7355,7355,1,'LSQ12hbu','LSQ',152.378916666667,-16.1379444444444,NULL,NULL,'2012-12-05 05:42:30',56266.2378500002,19.3454,0.1082,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 22:46:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbu/LSQ12hbu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbu/LSQ12hbu_snap_80014.gif',41198551021,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643727359,10058239,NULL,NULL,NULL,NULL),(7356,7355,0,'LSQ12hbu','LSQ',152.378875,-16.1379722222222,NULL,NULL,'2012-12-05 07:09:46',56266.2984500001,20.2099,0.1544,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 22:46:15','2012-12-05 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbu/LSQ12hbu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbu/LSQ12hbu_snap_80015.gif',41198551021,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643727359,10058239,NULL,NULL,NULL,NULL),(7357,7357,1,'LSQ12hbt','LSQ',32.1595833333333,-13.1481944444444,NULL,NULL,'2012-12-05 02:06:10',56266.0876199999,19.2183,0.0797,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 22:46:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbt/LSQ12hbt_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbt/LSQ12hbt_snap_80012.gif',35054571753,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547727683,8558245,NULL,NULL,NULL,NULL),(7358,7357,0,'LSQ12hbt','LSQ',32.1595416666667,-13.1480555555556,NULL,NULL,'2012-12-05 04:06:23',56266.17111,19.9848,0.1337,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-05 22:46:15','2012-12-05 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbt/LSQ12hbt_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbt/LSQ12hbt_snap_80013.gif',35054571753,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547727683,8558245,NULL,NULL,NULL,NULL),(7359,7351,0,'LSQ12hbo','pessto',164.064833333,-20.8588055556,NULL,NULL,'2012-12-05 00:00:00',56266,NULL,NULL,NULL,0.013,NULL,'II',NULL,'2012-12-06 10:49:21','2012-12-06 11:16:35','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41856029840,'NTT','EFOSC2','Kate and Laurent','2012-06-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,654000466,10218757,NULL,NULL,NULL,NULL),(7360,7326,0,'LSQ12hcm','pessto',55.5312916667,4.23161111111,NULL,NULL,'2012-12-05 00:00:00',56266,NULL,NULL,NULL,0.025,NULL,'I',NULL,'2012-12-06 10:50:38','2012-12-06 11:16:35','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,65206467034,'NTT','EFOSC2','Kate and Laurent','2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1018851047,15919547,NULL,NULL,NULL,NULL),(7365,3868,0,'LSQ12gek','LSQ',55.5485,-26.7352222222222,NULL,NULL,'2012-12-06 01:18:39',56267.0546200001,18.8339,0.0424,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_snap_80282.gif',38579734652,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602808353,9418880,NULL,NULL,NULL,NULL),(7366,3868,0,'LSQ12gek','LSQ',55.548375,-26.7351666666667,NULL,NULL,'2012-12-06 03:18:45',56267.13803,18.2065,0.0308,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gek/LSQ12gek_snap_80283.gif',38579734652,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602808353,9418880,NULL,NULL,NULL,NULL),(7367,4056,0,'LSQ12ghe','LSQ',68.549,-23.0559722222222,NULL,NULL,'2012-12-06 05:44:00',56267.2388900002,20.1148,0.1272,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_80300.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(7368,4061,0,'LSQ12ggx','LSQ',47.8960833333333,-22.3203055555556,NULL,NULL,'2012-12-06 02:42:57',56267.1131600002,20.0726,0.1197,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_80347.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(7369,4061,0,'LSQ12ggx','LSQ',47.8960833333333,-22.3203888888889,NULL,NULL,'2012-12-06 04:42:37',56267.1962700002,19.7683,0.177,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_80348.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(7370,4067,0,'LSQ12ggq','LSQ',69.4289166666667,-35.8658333333333,NULL,NULL,'2012-12-06 05:16:55',56267.22009,20.534,0.1084,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_80314.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(7371,4067,0,'LSQ12ggq','LSQ',69.4288333333333,-35.8656944444444,NULL,NULL,'2012-12-06 06:56:23',56267.2891600002,20.3259,0.182,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_80315.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(7372,4082,0,'LSQ12ggo','LSQ',60.43025,-34.9308333333333,NULL,NULL,'2012-12-06 05:15:12',56267.2189000002,20.2886,0.211,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggo/LSQ12ggo_snap_80319.gif',37676606780,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588696980,9198390,NULL,NULL,NULL,NULL),(7373,4120,0,'LSQ12ghc','LSQ',66.2228333333333,-21.2026666666667,NULL,NULL,'2012-12-06 06:07:48',56267.2554199998,18.1732,0.0448,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_80296.gif',37325531171,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(7374,4120,0,'LSQ12ghc','LSQ',66.222875,-21.2025833333333,NULL,NULL,'2012-12-06 07:20:22',56267.3058199999,18.5311,0.0688,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_history.html','sne or agn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghc/LSQ12ghc_snap_80297.gif',37325531170,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,583211424,9112678,NULL,NULL,NULL,NULL),(7375,4136,0,'LSQ12ggz','LSQ',56.3259166666667,-23.8723611111111,NULL,NULL,'2012-12-06 03:04:57',56267.1284400001,20.3306,0.1277,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_snap_80349.gif',37995959908,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593686873,9276357,NULL,NULL,NULL,NULL),(7376,4136,0,'LSQ12ggz','LSQ',56.326,-23.8723611111111,NULL,NULL,'2012-12-06 05:04:42',56267.2116,20.5847,0.1641,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_snap_80350.gif',37995959908,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593686873,9276357,NULL,NULL,NULL,NULL),(7377,4140,0,'LSQ12ggw','LSQ',49.552625,-21.4534444444444,NULL,NULL,'2012-12-06 04:40:56',56267.1951000001,21.2099,0.2021,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggw/LSQ12ggw_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggw/LSQ12ggw_snap_80288.gif',38028965824,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,594202591,9284415,NULL,NULL,NULL,NULL),(7378,4317,0,'LSQ12gkk','LSQ',76.8690416666667,-23.8545555555556,NULL,NULL,'2012-12-06 05:50:47',56267.2436000002,20.0538,0.1026,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_80184.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(7379,4317,0,'LSQ12gkk','LSQ',76.8690416666667,-23.8545833333333,NULL,NULL,'2012-12-06 07:25:33',56267.3094100002,19.724,0.1147,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_80185.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(7380,4335,0,'LSQ12gjv','LSQ',55.645875,-31.3634722222222,NULL,NULL,'2012-12-06 05:03:01',56267.21043,20.4071,0.1417,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjv/LSQ12gjv_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjv/LSQ12gjv_snap_80487.gif',38585895204,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602904612,9420384,NULL,NULL,NULL,NULL),(7381,5246,0,'LSQ12gln','LSQ',80.7475416666667,-33.46425,NULL,NULL,'2012-12-06 05:35:32',56267.2330100001,18.525,0.0529,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_80343.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(7382,5246,0,'LSQ12gln','LSQ',80.7475416666667,-33.4641944444444,NULL,NULL,'2012-12-06 07:05:09',56267.29525,18.3881,0.0524,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_80344.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(7383,5550,0,'LSQ12goy','LSQ',68.883375,-26.4606944444444,NULL,NULL,'2012-12-06 05:55:51',56267.24712,19.5155,0.1005,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_80419.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(7384,5550,0,'LSQ12goy','LSQ',68.8834166666667,-26.4606944444444,NULL,NULL,'2012-12-06 07:13:35',56267.3011099999,19.3958,0.1008,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_80420.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(7385,5557,0,'LSQ12gow','LSQ',48.134,-28.9634444444444,NULL,NULL,'2012-12-06 02:44:38',56267.1143299998,19.0108,0.1141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_80425.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(7386,5557,0,'LSQ12gow','LSQ',48.1345416666667,-28.9630833333333,NULL,NULL,'2012-12-06 04:44:19',56267.1974499999,15.5945,0.0773,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_80426.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(7387,5823,0,'LSQ12grh','LSQ',48.076625,-24.5529722222222,NULL,NULL,'2012-12-06 02:42:57',56267.1131600002,18.7959,0.0432,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_80458.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(7388,5823,0,'LSQ12grh','LSQ',48.076625,-24.5529722222222,NULL,NULL,'2012-12-06 04:42:37',56267.1962700002,18.7964,0.0482,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_80459.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(7389,5831,0,'LSQ12gra','LSQ',51.1259166666667,-28.2917777777778,NULL,NULL,'2012-12-06 04:46:01',56267.19863,19.2478,0.0878,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_80455.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(7390,5856,0,'LSQ12gsh','LSQ',72.1755,-30.9981944444444,NULL,NULL,'2012-12-06 07:01:47',56267.2929099998,18.056,0.0742,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_80357.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(7391,5876,0,'LSQ12gsv','LSQ',71.5319166666667,-25.26675,NULL,NULL,'2012-12-06 05:44:00',56267.2388900002,19.8722,0.1128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_80374.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(7392,5876,0,'LSQ12gsv','LSQ',71.5319583333333,-25.2667222222222,NULL,NULL,'2012-12-06 07:42:41',56267.32131,19.8744,0.1137,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_80375.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(7393,5959,0,'LSQ12gtm','LSQ',69.95975,-34.1286666666667,NULL,NULL,'2012-12-06 05:28:46',56267.2283200002,19.6816,0.0889,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_80340.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(7394,5970,0,'LSQ12gti','LSQ',40.0737916666667,-34.4596388888889,NULL,NULL,'2012-12-06 02:12:21',56267.09191,17.9568,0.0428,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_80392.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(7395,5970,0,'LSQ12gti','LSQ',40.073875,-34.4596944444444,NULL,NULL,'2012-12-06 04:12:05',56267.1750599998,17.9874,0.0392,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_80393.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(7396,6109,0,'LSQ12gwg','LSQ',71.3166666666667,-29.0706944444444,NULL,NULL,'2012-12-06 05:38:55',56267.2353599998,19.2735,0.0855,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_80443.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(7397,6117,0,'LSQ12gwf','LSQ',31.6624583333333,-31.2920555555556,NULL,NULL,'2012-12-06 01:58:41',56267.0824199999,19.0668,0.0941,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_history.html','sn?',NULL,0.1321,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_snap_80442.gif',38445793246,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,600715519,9386179,NULL,NULL,NULL,NULL),(7398,6121,0,'LSQ12gwc','LSQ',55.8401666666667,-26.7371111111111,NULL,NULL,'2012-12-06 01:18:39',56267.0546200001,21.6274,0.1934,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_80437.gif',38526264409,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(7399,6121,0,'LSQ12gwc','LSQ',55.8400416666667,-26.7371388888889,NULL,NULL,'2012-12-06 03:18:45',56267.13803,21.3557,0.1721,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_80438.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(7400,6140,0,'LSQ12gvz','LSQ',67.4930416666667,-29.7282777777778,NULL,NULL,'2012-12-06 07:13:35',56267.3011099999,19.1872,0.1116,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvz/LSQ12gvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvz/LSQ12gvz_snap_80441.gif',37657477973,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,588398093,9193720,NULL,NULL,NULL,NULL),(7401,6150,0,'LSQ12gvs','LSQ',64.3944583333333,-38.8895,NULL,NULL,'2012-12-06 06:11:14',56267.2578099999,18.7428,0.04,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_80429.gif',37791067655,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(7402,6150,0,'LSQ12gvs','LSQ',64.394375,-38.8894722222222,NULL,NULL,'2012-12-06 07:15:17',56267.30229,18.6879,0.0448,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_80430.gif',37791067652,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(7403,6188,0,'LSQ12gwk','LSQ',44.3659583333333,-25.3955833333333,NULL,NULL,'2012-12-06 02:27:38',56267.1025299998,19.6043,0.0991,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_80445.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(7404,6202,0,'LSQ12gwe','LSQ',28.31,-33.156,NULL,NULL,'2012-12-06 03:44:46',56267.1560900002,19.9996,0.1066,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwe/LSQ12gwe_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwe/LSQ12gwe_snap_80444.gif',38310012651,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,598593947,9353030,NULL,NULL,NULL,NULL),(7405,7243,0,'LSQ12gzm','LSQ',40.181875,-34.7405277777778,NULL,NULL,'2012-12-06 02:19:08',56267.09663,18.7945,0.0912,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_snap_80174.gif',38633055142,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603641486,9431898,NULL,NULL,NULL,NULL),(7406,7243,0,'LSQ12gzm','LSQ',40.18175,-34.7404722222222,NULL,NULL,'2012-12-06 04:18:53',56267.17979,19.0016,0.0884,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 23:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_snap_80175.gif',38633055142,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603641486,9431898,NULL,NULL,NULL,NULL),(7407,7246,0,'LSQ12gzl','LSQ',41.0289583333333,-37.1565,NULL,NULL,'2012-12-06 02:19:08',56267.09663,18.3105,0.0435,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_snap_80238.gif',38634771280,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603668301,9432317,NULL,NULL,NULL,NULL),(7408,7246,0,'LSQ12gzl','LSQ',41.0289166666667,-37.1566111111111,NULL,NULL,'2012-12-06 04:18:53',56267.17979,20.6413,0.1774,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_snap_80239.gif',38634771280,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603668301,9432317,NULL,NULL,NULL,NULL),(7409,7254,0,'LSQ12gzk','LSQ',41.0447083333333,-37.0321388888889,NULL,NULL,'2012-12-06 04:18:53',56267.17979,19.5662,0.1058,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-06 20:46:10','2012-12-06 20:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_snap_80246.gif',38634729849,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603667653,9432307,NULL,NULL,NULL,NULL),(7410,5813,0,'LSQ12gpw','pessto',48.2427083333,-11.7111111111,NULL,NULL,'2012-12-06 04:48:00',56267.2,NULL,NULL,NULL,0.058,NULL,'Ia',NULL,'2012-12-06 23:15:43','2012-12-06 23:16:13','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37893397642,'NTT','EFOSC2','Pan','2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(7411,7063,0,'LSQ12gxj','pessto',43.2390416667,1.60675,NULL,NULL,'2012-12-06 02:24:00',56267.1,NULL,NULL,NULL,0.032,NULL,'Ia',NULL,'2012-12-06 23:22:39','2012-12-06 23:46:13','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,66842134735,'NTT','EFOSC2','Pan','2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(7412,7067,0,'LSQ12gxh','pessto',152.531916667,-7.00355555556,NULL,NULL,'2012-12-06 07:11:59',56267.3,NULL,NULL,NULL,0,NULL,'II',NULL,'2012-12-06 23:24:22','2012-12-06 23:46:13','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41250965852,'NTT','EFOSC2','Pan','2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644546341,10071036,NULL,NULL,NULL,NULL),(7413,7243,0,'LSQ12gzm','pessto',40.1817083333,-34.7405,NULL,NULL,'2012-12-06 04:48:00',56267.2,NULL,NULL,NULL,0.1,NULL,'Ia',NULL,'2012-12-06 23:26:24','2012-12-06 23:46:13','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38633055142,'NTT','EFOSC2','Pan','2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603641486,9431898,NULL,NULL,NULL,NULL),(7414,7079,0,'LSQ12gwy','pessto',160.883416667,-13.289,NULL,NULL,'2012-12-05 00:00:00',56266,NULL,NULL,NULL,0.018,NULL,'Ia',NULL,'2012-12-06 23:27:22','2012-12-06 23:46:13','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41838066142,'NTT','EFOSC2','Pan','2012-05-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653719783,10214371,NULL,NULL,NULL,NULL),(7415,7415,1,'LSQ12hcy','LSQ',69.0896666666667,-38.6321944444444,NULL,NULL,'2012-12-06 05:18:36',56267.22126,19.8843,0.1469,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 00:46:12','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcy/LSQ12hcy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcy/LSQ12hcy_snap_80575.gif',37823388895,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,590990451,9234225,NULL,NULL,NULL,NULL),(7416,7415,0,'LSQ12hcy','LSQ',69.0895833333333,-38.6321666666667,NULL,NULL,'2012-12-06 06:58:05',56267.2903399998,20.2118,0.1693,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 00:46:12','2012-12-07 00:46:12','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcy/LSQ12hcy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcy/LSQ12hcy_snap_80576.gif',37823388895,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,590990451,9234225,NULL,NULL,NULL,NULL),(7417,7417,1,'LSQ12hcu','LSQ',59.0957083333333,-36.575,NULL,NULL,'2012-11-15 05:16:36',56246.2198700001,20.8683,0.1829,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 00:46:12','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_history.html','sn?',NULL,0.07532,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_snap_80531.gif',37679401788,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588740652,9199072,NULL,NULL,NULL,NULL),(7418,7417,0,'LSQ12hcu','LSQ',59.0955416666667,-36.5750277777778,NULL,NULL,'2012-11-15 08:22:05',56246.3486700002,20.6659,0.1634,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 00:46:12','2012-12-07 00:46:12','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_history.html','sn?',NULL,0.07532,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_snap_80532.gif',37679401788,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588740652,9199072,NULL,NULL,NULL,NULL),(7419,7417,0,'LSQ12hcu','LSQ',59.0957916666667,-36.5749722222222,NULL,NULL,'2012-11-21 04:45:04',56252.1979700001,19.8391,0.1696,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 00:46:12','2012-12-07 00:46:12','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_history.html','sn?',NULL,0.07532,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_snap_80533.gif',37679401788,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588740652,9199072,NULL,NULL,NULL,NULL),(7420,7417,0,'LSQ12hcu','LSQ',59.095625,-36.5750555555556,NULL,NULL,'2012-11-23 04:39:30',56254.1941,20.5276,0.1768,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 00:46:12','2012-12-07 00:46:12','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_history.html','sn?',NULL,0.07532,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_snap_80534.gif',37679401788,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588740652,9199072,NULL,NULL,NULL,NULL),(7421,7417,0,'LSQ12hcu','LSQ',59.0957916666667,-36.5749722222222,NULL,NULL,'2012-12-04 06:39:04',56265.2771299998,20.0245,0.1924,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 00:46:12','2012-12-07 00:46:12','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_history.html','sn?',NULL,0.07532,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_snap_80535.gif',37679401788,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588740652,9199072,NULL,NULL,NULL,NULL),(7422,7417,0,'LSQ12hcu','LSQ',59.095625,-36.575,NULL,NULL,'2012-12-06 03:13:22',56267.13429,19.2803,0.1046,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 00:46:12','2012-12-07 00:46:12','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_history.html','sn?',NULL,0.07532,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_snap_80505.gif',37679401788,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588740652,9199072,NULL,NULL,NULL,NULL),(7423,7417,0,'LSQ12hcu','LSQ',59.0955,-36.575,NULL,NULL,'2012-12-06 05:15:12',56267.2189000002,19.6746,0.1564,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 00:46:12','2012-12-07 00:46:12','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_history.html','sn?',NULL,0.07532,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_snap_80506.gif',37679401788,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588740652,9199072,NULL,NULL,NULL,NULL),(7424,6182,0,'LSQ12gwl','LSQ',55.0220416666667,-21.5046944444444,NULL,NULL,'2012-12-06 02:56:28',56267.12255,20.7679,0.1418,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 03:46:13','2012-12-07 03:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_snap_80580.gif',38047180768,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594487199,9288862,NULL,NULL,NULL,NULL),(7432,7432,1,'LSQ12hdl','LSQ',53.435125,-30.3177777777778,NULL,NULL,'2012-11-07 05:36:53',56238.2339499998,20.2396,0.1985,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 15:46:12','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_history.html','sn?',NULL,0.130297,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_snap_80729.gif',38573467025,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602710422,9417350,NULL,NULL,NULL,NULL),(7433,7432,0,'LSQ12hdl','LSQ',53.4345416666667,-30.3174444444444,NULL,NULL,'2012-11-15 07:08:23',56246.2974999999,19.4487,0.1096,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 15:46:12','2012-12-16 12:16:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_history.html','sn?',NULL,0.130297,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_snap_80730.gif',38573467025,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602710422,9417350,NULL,NULL,NULL,NULL),(7434,7432,0,'LSQ12hdl','LSQ',53.4345,-30.3174722222222,NULL,NULL,'2012-11-21 04:34:50',56252.19086,19.2051,0.1091,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 15:46:12','2012-12-16 12:16:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_history.html','sn?',NULL,0.130297,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_snap_80988.gif',38573467025,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602710422,9417350,NULL,NULL,NULL,NULL),(7435,7432,0,'LSQ12hdl','LSQ',53.434875,-30.3175,NULL,NULL,'2012-12-04 02:58:33',56265.1239999998,19.3424,0.1045,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 15:46:12','2012-12-16 12:16:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_history.html','sn?',NULL,0.130297,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_snap_80731.gif',38573467025,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602710422,9417350,NULL,NULL,NULL,NULL),(7436,7432,0,'LSQ12hdl','LSQ',53.4351666666667,-30.3175,NULL,NULL,'2012-12-06 02:53:05',56267.1201999998,18.7395,0.0932,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 15:46:12','2012-12-16 12:16:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_history.html','sn?',NULL,0.130297,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_snap_80607.gif',38573467025,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602710422,9417350,NULL,NULL,NULL,NULL),(7437,7432,0,'LSQ12hdl','LSQ',53.43525,-30.3171944444444,NULL,NULL,'2012-12-06 04:52:47',56267.2033299999,18.4709,0.0734,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 15:46:12','2012-12-16 12:16:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_history.html','sn?',NULL,0.130297,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_snap_80608.gif',38573467025,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602710422,9417350,NULL,NULL,NULL,NULL),(7438,7438,1,'LSQ12hfh','LSQ',63.75425,-23.3600555555556,NULL,NULL,'2012-11-19 07:26:25',56250.3100200002,19.0958,0.1455,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hfh/LSQ12hfh_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hfh/LSQ12hfh_snap_81056.gif',37313388894,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583021701,9109714,NULL,NULL,NULL,NULL),(7439,7438,0,'LSQ12hfh','LSQ',63.7542083333333,-23.36025,NULL,NULL,'2012-12-02 05:52:07',56263.2445299998,18.89,0.1703,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2012-12-07 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hfh/LSQ12hfh_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hfh/LSQ12hfh_snap_81057.gif',37313388894,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583021701,9109714,NULL,NULL,NULL,NULL),(7440,7438,0,'LSQ12hfh','LSQ',63.754,-23.3601388888889,NULL,NULL,'2012-12-06 06:07:48',56267.2554199998,18.5924,0.1146,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2012-12-07 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hfh/LSQ12hfh_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hfh/LSQ12hfh_snap_80964.gif',37313388894,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583021701,9109714,NULL,NULL,NULL,NULL),(7441,7438,0,'LSQ12hfh','LSQ',63.7541666666667,-23.3601388888889,NULL,NULL,'2012-12-06 07:20:22',56267.3058199999,18.5782,0.1161,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2012-12-07 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hfh/LSQ12hfh_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hfh/LSQ12hfh_snap_80965.gif',37313388894,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,583021701,9109714,NULL,NULL,NULL,NULL),(7442,7442,1,'LSQ12hev','LSQ',67.04725,-29.5598055555556,NULL,NULL,'2012-12-02 05:43:39',56263.2386500002,19.2127,0.116,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hev/LSQ12hev_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hev/LSQ12hev_snap_81022.gif',37659944803,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588436637,9194322,NULL,NULL,NULL,NULL),(7443,7442,0,'LSQ12hev','LSQ',67.04725,-29.5600833333333,NULL,NULL,'2012-12-06 05:54:10',56267.2459499999,19.0018,0.0894,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2012-12-21 02:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hev/LSQ12hev_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hev/LSQ12hev_snap_80940.gif',37659944801,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588436637,9194322,NULL,NULL,NULL,NULL),(7444,7442,0,'LSQ12hev','LSQ',67.0474166666667,-29.5603333333333,NULL,NULL,'2012-12-06 05:57:33',56267.2483000001,18.7268,0.0985,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2012-12-21 02:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hev/LSQ12hev_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hev/LSQ12hev_snap_80941.gif',37659944801,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588436637,9194322,NULL,NULL,NULL,NULL),(7445,7445,1,'LSQ12heq','LSQ',53.2672916666667,-28.2137777777778,NULL,NULL,'2012-12-02 03:14:35',56263.1351299998,20.1241,0.0954,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_80929.gif',38581253600,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(7446,7445,0,'LSQ12heq','LSQ',53.26725,-28.21375,NULL,NULL,'2012-12-04 01:17:25',56265.0537700001,19.5607,0.0545,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2012-12-12 22:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_80930.gif',38581253603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(7447,7445,0,'LSQ12heq','LSQ',53.2673333333333,-28.2137777777778,NULL,NULL,'2012-12-04 03:17:46',56265.1373399999,19.544,0.0531,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2012-12-12 22:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_80931.gif',38581253600,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(7448,7445,0,'LSQ12heq','LSQ',53.26725,-28.2137222222222,NULL,NULL,'2012-12-06 01:18:39',56267.0546200001,19.3953,0.0424,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2012-12-12 22:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_80669.gif',38581253603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(7449,7445,0,'LSQ12heq','LSQ',53.2672916666667,-28.2137222222222,NULL,NULL,'2012-12-06 03:18:45',56267.13803,19.3906,0.0498,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2012-12-12 22:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_80670.gif',38581253603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(7450,7450,1,'LSQ12hdy','LSQ',22.66825,-28.7285,NULL,NULL,'2012-12-02 01:31:41',56263.0636800001,20.5803,0.0959,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdy/LSQ12hdy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdy/LSQ12hdy_snap_80841.gif',38259681079,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597807516,9340742,NULL,NULL,NULL,NULL),(7451,7450,0,'LSQ12hdy','LSQ',22.6682083333333,-28.7285,NULL,NULL,'2012-12-02 03:32:15',56263.1474000001,20.5438,0.1188,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2012-12-07 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdy/LSQ12hdy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdy/LSQ12hdy_snap_80842.gif',38259681077,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597807516,9340742,NULL,NULL,NULL,NULL),(7452,7450,0,'LSQ12hdy','LSQ',22.6681666666667,-28.7285555555556,NULL,NULL,'2012-12-04 01:33:24',56265.0648699999,20.4919,0.0817,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2012-12-07 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdy/LSQ12hdy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdy/LSQ12hdy_snap_80843.gif',38259681077,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597807516,9340742,NULL,NULL,NULL,NULL),(7453,7450,0,'LSQ12hdy','LSQ',22.6681666666667,-28.7285,NULL,NULL,'2012-12-04 03:33:46',56265.1484500002,20.5517,0.1155,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2012-12-07 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdy/LSQ12hdy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdy/LSQ12hdy_snap_80844.gif',38259681077,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597807516,9340742,NULL,NULL,NULL,NULL),(7454,7450,0,'LSQ12hdy','LSQ',22.6682083333333,-28.7285277777778,NULL,NULL,'2012-12-06 01:27:45',56267.0609400002,20.3779,0.0726,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2012-12-07 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdy/LSQ12hdy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdy/LSQ12hdy_snap_80633.gif',38259681077,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597807516,9340742,NULL,NULL,NULL,NULL),(7455,7450,0,'LSQ12hdy','LSQ',22.66825,-28.7285555555556,NULL,NULL,'2012-12-06 03:27:48',56267.1443099999,20.4209,0.0765,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2012-12-07 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdy/LSQ12hdy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdy/LSQ12hdy_snap_80634.gif',38259681079,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597807516,9340742,NULL,NULL,NULL,NULL),(7456,7456,1,'LSQ12hdn','LSQ',63.7042916666667,-32.2959444444444,NULL,NULL,'2012-12-06 06:29:17',56267.2703399998,19.367,0.1557,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_snap_80611.gif',37709622178,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589212846,9206450,NULL,NULL,NULL,NULL),(7457,7456,0,'LSQ12hdn','LSQ',63.7044166666667,-32.2959166666667,NULL,NULL,'2012-12-06 07:17:00',56267.3034799998,19.7429,0.148,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-07 16:46:13','2012-12-07 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_snap_80612.gif',37709622178,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589212846,9206450,NULL,NULL,NULL,NULL),(7458,4165,0,'LSQ12gjc','LSQ',52.6711666666667,-6.37286111111111,NULL,NULL,'2012-12-07 04:56:28',56268.2058899999,20.1204,0.1388,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gjc/LSQ12gjc_snap_81285.gif',36797933958,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,574967718,8983870,NULL,NULL,NULL,NULL),(7459,4356,0,'LSQ12gla','LSQ',50.067125,-9.481,NULL,NULL,'2012-12-07 02:51:31',56268.1191099999,20.5525,0.1764,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_snap_81269.gif',37898099251,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,592157800,9252465,NULL,NULL,NULL,NULL),(7460,4356,0,'LSQ12gla','LSQ',50.06725,-9.48091666666667,NULL,NULL,'2012-12-07 04:53:05',56268.2035400001,19.7494,0.1148,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_snap_81270.gif',37898099251,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,592157800,9252465,NULL,NULL,NULL,NULL),(7461,5376,0,'LSQ12glw','LSQ',143.033291666667,-9.68058333333333,NULL,NULL,'2012-12-07 05:12:45',56268.2171900002,19.6158,0.1564,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glw/LSQ12glw_history.html','sne?',NULL,0.054681,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glw/LSQ12glw_snap_81300.gif',41090785038,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642043516,10031929,NULL,NULL,NULL,NULL),(7462,5376,0,'LSQ12glw','LSQ',143.033166666667,-9.68066666666667,NULL,NULL,'2012-12-07 07:02:26',56268.29336,19.1772,0.1147,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glw/LSQ12glw_history.html','sne?',NULL,0.054681,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12glw/LSQ12glw_snap_81301.gif',41090785038,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642043516,10031929,NULL,NULL,NULL,NULL),(7463,5813,0,'LSQ12gpw','LSQ',48.2427083333333,-11.7110833333333,NULL,NULL,'2012-12-07 02:51:31',56268.1191099999,16.4198,0.0178,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_81333.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(7464,5813,0,'LSQ12gpw','LSQ',48.24275,-11.7111111111111,NULL,NULL,'2012-12-07 04:53:05',56268.2035400001,16.4584,0.0134,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_81334.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(7465,5983,0,'LSQ12gul','LSQ',43.0337916666667,-0.0360833333333333,NULL,NULL,'2012-12-07 02:08:41',56268.0893700002,18.5283,0.0425,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_81288.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(7466,5983,0,'LSQ12gul','LSQ',43.0338333333333,-0.0360833333333333,NULL,NULL,'2012-12-07 04:08:23',56268.1724899998,18.3604,0.0367,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_81289.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(7467,5985,0,'LSQ12guj','LSQ',36.2344583333333,5.12113888888889,NULL,NULL,'2012-12-07 03:10:39',56268.1324,18.2118,0.034,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_snap_81290.gif',66894622375,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045228474,16331694,NULL,NULL,NULL,NULL),(7468,5985,0,'LSQ12guj','LSQ',36.2345,5.12116666666667,NULL,NULL,'2012-12-07 04:20:24',56268.18084,18.2849,0.0322,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_snap_81291.gif',66894622375,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045228474,16331694,NULL,NULL,NULL,NULL),(7469,5991,0,'LSQ12gub','LSQ',145.626458333333,-11.0257222222222,NULL,NULL,'2012-12-07 05:40:12',56268.2362500001,19.3643,0.0951,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gub/LSQ12gub_history.html','sn?',NULL,0.035244,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gub/LSQ12gub_snap_81308.gif',41306840934,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645419389,10084677,NULL,NULL,NULL,NULL),(7470,5993,0,'LSQ12gtz','LSQ',48.36275,-7.35847222222222,NULL,NULL,'2012-12-07 02:39:26',56268.1107200002,18.6023,0.0593,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_81315.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7471,5993,0,'LSQ12gtz','LSQ',48.363,-7.35838888888889,NULL,NULL,'2012-12-07 04:41:05',56268.1952,18.1703,0.0434,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_81316.gif',37904478844,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7472,5993,0,'LSQ12gtz','LSQ',48.3627916666667,-7.35847222222222,NULL,NULL,'2012-12-07 04:53:05',56268.2035400001,18.9255,0.0629,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_81314.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7473,6014,0,'LSQ12gty','LSQ',73.3359583333333,-14.9326111111111,NULL,NULL,'2012-12-07 03:06:52',56268.12977,19.6997,0.0876,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_81306.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(7474,6014,0,'LSQ12gty','LSQ',73.336,-14.9325833333333,NULL,NULL,'2012-12-07 05:08:30',56268.2142400001,19.4951,0.0661,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_81307.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(7475,6155,0,'LSQ12gve','LSQ',51.1099583333333,-11.6691944444444,NULL,NULL,'2012-12-07 04:53:05',56268.2035400001,16.5171,0.04,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_81320.gif',37885390163,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(7476,6167,0,'LSQ12gvb','LSQ',46.5282916666667,-2.58222222222222,NULL,NULL,'2012-12-07 02:10:24',56268.0905599999,18.0475,0.0933,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_81318.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(7477,6167,0,'LSQ12gvb','LSQ',46.52825,-2.58211111111111,NULL,NULL,'2012-12-07 04:10:04',56268.1736599999,18.4308,0.0676,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_81319.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(7478,6177,0,'LSQ12guq','LSQ',39.27175,-20.5101111111111,NULL,NULL,'2012-12-07 04:25:35',56268.18444,18.8293,0.0836,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guq/LSQ12guq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guq/LSQ12guq_snap_81317.gif',37939057755,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592797777,9262465,NULL,NULL,NULL,NULL),(7479,7063,0,'LSQ12gxj','LSQ',43.239125,1.60675,NULL,NULL,'2012-12-07 02:10:24',56268.0905599999,18.4243,0.0603,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_81195.gif',66842134735,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(7480,7063,0,'LSQ12gxj','LSQ',43.239125,1.60672222222222,NULL,NULL,'2012-12-07 04:10:04',56268.1736599999,18.1528,0.0464,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_81196.gif',66842134735,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(7481,7067,0,'LSQ12gxh','LSQ',152.531958333333,-7.00361111111111,NULL,NULL,'2012-12-07 06:42:07',56268.2792500001,18.5423,0.101,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxh/LSQ12gxh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxh/LSQ12gxh_snap_81180.gif',41250965852,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644546341,10071036,NULL,NULL,NULL,NULL),(7482,7071,0,'LSQ12gxd','LSQ',36.034375,-3.46419444444444,NULL,NULL,'2012-12-07 01:19:37',56268.05529,19.7991,0.1341,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_81176.gif',34918978036,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(7483,7071,0,'LSQ12gxd','LSQ',36.03425,-3.46416666666667,NULL,NULL,'2012-12-07 03:19:16',56268.13839,19.8975,0.1042,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_81177.gif',34918978036,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(7484,7075,0,'LSQ12gxb','LSQ',142.838833333333,-11.6296388888889,NULL,NULL,'2012-12-07 07:02:26',56268.29336,18.5069,0.0692,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_snap_81175.gif',42178887818,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,659045122,10297580,NULL,NULL,NULL,NULL),(7485,7083,0,'LSQ12gyr','LSQ',43.210375,-7.71230555555556,NULL,NULL,'2012-12-07 02:34:22',56268.1072,18.9809,0.11,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_history.html','sne - nice',NULL,0.11794,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_snap_81152.gif',37909543298,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592336614,9255259,NULL,NULL,NULL,NULL),(7486,7083,0,'LSQ12gyr','LSQ',43.2102916666667,-7.71208333333333,NULL,NULL,'2012-12-07 04:36:01',56268.1916800002,19.5681,0.1419,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_history.html','sne - nice',NULL,0.11794,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_snap_81153.gif',37909543298,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592336614,9255259,NULL,NULL,NULL,NULL),(7487,7096,0,'LSQ12gyd','LSQ',76.3872083333333,-18.0351388888889,NULL,NULL,'2012-12-07 03:05:10',56268.1285899999,19.3881,0.0745,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_81164.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(7488,7096,0,'LSQ12gyd','LSQ',76.3872083333333,-18.0351666666667,NULL,NULL,'2012-12-07 05:06:48',56268.21306,19.5241,0.0729,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_81165.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(7489,7099,0,'LSQ12gyc','LSQ',41.458625,-17.9293611111111,NULL,NULL,'2012-12-07 02:41:08',56268.1118999999,17.7614,0.0715,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_81166.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(7490,7099,0,'LSQ12gyc','LSQ',41.458625,-17.9293611111111,NULL,NULL,'2012-12-07 04:42:48',56268.1963999998,17.7118,0.0538,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_81167.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(7491,7118,0,'LSQ12gzb','LSQ',37.0447083333333,-5.94605555555556,NULL,NULL,'2012-12-07 01:19:37',56268.05529,20.3992,0.0904,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_81200.gif',34948583495,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(7492,7118,0,'LSQ12gzb','LSQ',37.0446666666667,-5.94611111111111,NULL,NULL,'2012-12-07 03:19:16',56268.13839,20.3718,0.0864,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_81201.gif',34948583495,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(7493,7122,0,'LSQ12gza','LSQ',35.89325,-5.90747222222222,NULL,NULL,'2012-12-07 01:19:37',56268.05529,20.3086,0.1278,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_81203.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(7494,7122,0,'LSQ12gza','LSQ',35.8930416666667,-5.90736111111111,NULL,NULL,'2012-12-07 03:19:16',56268.13839,19.9491,0.0688,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_81204.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(7495,7127,0,'LSQ12gyw','LSQ',28.5175416666667,-10.34975,NULL,NULL,'2012-12-07 03:33:26',56268.1482199999,20.3517,0.1851,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyw/LSQ12gyw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyw/LSQ12gyw_snap_81199.gif',35111082183,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548610659,8572041,NULL,NULL,NULL,NULL),(7496,7131,0,'LSQ12gyv','LSQ',50.4709583333333,-10.0815277777778,NULL,NULL,'2012-12-07 04:51:24',56268.2023700001,18.7745,0.0661,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_snap_81188.gif',37898370242,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592162035,9252531,NULL,NULL,NULL,NULL),(7497,7134,0,'LSQ12gyn','LSQ',44.708,-14.9488611111111,NULL,NULL,'2012-12-07 02:48:07',56268.11675,20.2528,0.1566,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_81181.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(7498,7134,0,'LSQ12gyn','LSQ',44.708,-14.9488611111111,NULL,NULL,'2012-12-07 04:49:42',56268.2011899999,20.0007,0.1084,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_81182.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(7499,7319,0,'LSQ12hco','LSQ',48.6239583333333,-2.69105555555556,NULL,NULL,'2012-12-07 02:27:27',56268.1024000002,20.4528,0.1533,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_snap_81264.gif',36791664995,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574869765,8982340,NULL,NULL,NULL,NULL),(7500,7319,0,'LSQ12hco','LSQ',48.6239166666667,-2.691,NULL,NULL,'2012-12-07 04:29:06',56268.1868799999,19.886,0.0992,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_snap_81265.gif',36791664995,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574869765,8982340,NULL,NULL,NULL,NULL),(7501,7326,0,'LSQ12hcm','LSQ',55.531375,4.23163888888889,NULL,NULL,'2012-12-07 02:46:20',56268.11552,19.1853,0.0662,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_history.html','sn nice',NULL,0.024457,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_snap_81262.gif',65206467034,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1018851047,15919547,NULL,NULL,NULL,NULL),(7502,7326,0,'LSQ12hcm','LSQ',55.5313333333333,4.23166666666667,NULL,NULL,'2012-12-07 04:48:00',56268.2000000002,19.4704,0.069,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_history.html','sn nice',NULL,0.024457,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_snap_81263.gif',65206467034,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1018851047,15919547,NULL,NULL,NULL,NULL),(7503,7328,0,'LSQ12hcl','LSQ',42.915,-1.89866666666667,NULL,NULL,'2012-12-07 02:08:41',56268.0893700002,19.78,0.0865,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_snap_81240.gif',34899428012,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545303562,8520368,NULL,NULL,NULL,NULL),(7504,7328,0,'LSQ12hcl','LSQ',42.9150416666667,-1.89866666666667,NULL,NULL,'2012-12-07 04:08:23',56268.1724899998,19.8443,0.094,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_snap_81241.gif',34899428012,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545303562,8520368,NULL,NULL,NULL,NULL),(7505,7351,0,'LSQ12hbo','LSQ',164.06475,-20.8588055555556,NULL,NULL,'2012-12-07 06:28:34',56268.2698400002,18.105,0.0447,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbo/LSQ12hbo_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbo/LSQ12hbo_snap_81232.gif',41856029840,NULL,NULL,NULL,'2012-06-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,654000466,10218757,NULL,NULL,NULL,NULL),(7506,7351,0,'LSQ12hbo','LSQ',164.064791666667,-20.8588055555556,NULL,NULL,'2012-12-07 07:32:11',56268.3140199999,18.2243,0.0569,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 02:46:23','2012-12-08 02:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbo/LSQ12hbo_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbo/LSQ12hbo_snap_81233.gif',41856029840,NULL,NULL,NULL,'2012-06-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,654000466,10218757,NULL,NULL,NULL,NULL),(7507,7507,1,'LSQ12hgj','LSQ',154.207375,-16.1959444444444,NULL,NULL,'2012-12-07 05:48:39',56268.2421200001,20.2358,0.1483,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 18:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_snap_81461.gif',41166665802,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643229153,10050455,NULL,NULL,NULL,NULL),(7508,7507,0,'LSQ12hgj','LSQ',154.207333333333,-16.1959166666667,NULL,NULL,'2012-12-07 07:12:33',56268.30039,19.8245,0.1177,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 18:46:16','2012-12-08 18:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_snap_81462.gif',41166665802,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643229153,10050455,NULL,NULL,NULL,NULL),(7509,7509,1,'LSQ12hgh','LSQ',164.081958333333,-19.9496388888889,NULL,NULL,'2012-12-05 06:35:53',56266.2749200002,19.5835,0.0788,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 18:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgh/LSQ12hgh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgh/LSQ12hgh_snap_81483.gif',41856646685,NULL,NULL,NULL,'2012-06-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,654010104,10218907,NULL,NULL,NULL,NULL),(7510,7509,0,'LSQ12hgh','LSQ',164.081833333333,-19.9495,NULL,NULL,'2012-12-07 06:28:34',56268.2698400002,19.2784,0.0745,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 18:46:16','2012-12-08 18:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgh/LSQ12hgh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgh/LSQ12hgh_snap_81457.gif',41856646685,NULL,NULL,NULL,'2012-06-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,654010104,10218907,NULL,NULL,NULL,NULL),(7511,7509,0,'LSQ12hgh','LSQ',164.082041666667,-19.9495833333333,NULL,NULL,'2012-12-07 07:32:11',56268.3140199999,19.2788,0.0827,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 18:46:16','2012-12-08 18:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgh/LSQ12hgh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgh/LSQ12hgh_snap_81458.gif',41856646685,NULL,NULL,NULL,'2012-06-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,654010104,10218907,NULL,NULL,NULL,NULL),(7512,7512,1,'LSQ12hfu','LSQ',26.811375,-20.4144722222222,NULL,NULL,'2012-12-07 01:35:31',56268.0663399999,14.7889,0.0877,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 18:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hfu/LSQ12hfu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hfu/LSQ12hfu_snap_81429.gif',35045367429,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,547583866,8555997,NULL,NULL,NULL,NULL);
INSERT INTO `transientBucket` VALUES (7513,7512,0,'LSQ12hfu','LSQ',26.811625,-20.4143333333333,NULL,NULL,'2012-12-07 03:35:07',56268.1493899999,14.3559,0.0751,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 18:46:16','2012-12-08 18:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hfu/LSQ12hfu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hfu/LSQ12hfu_snap_81430.gif',35045367429,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,547583866,8555997,NULL,NULL,NULL,NULL),(7514,7514,1,'LSQ12hft','LSQ',26.1689583333333,-20.4018055555556,NULL,NULL,'2012-12-03 01:46:29',56264.0739500001,20.7931,0.1911,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 18:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hft/LSQ12hft_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hft/LSQ12hft_snap_81431.gif',35040430609,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,547506728,8554792,NULL,NULL,NULL,NULL),(7515,7514,0,'LSQ12hft','LSQ',26.168875,-20.4017777777778,NULL,NULL,'2012-12-05 03:42:09',56266.1542799999,20.9556,0.1783,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 18:46:16','2012-12-08 18:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hft/LSQ12hft_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hft/LSQ12hft_snap_81432.gif',35040430609,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,547506728,8554792,NULL,NULL,NULL,NULL),(7516,7514,0,'LSQ12hft','LSQ',26.169375,-20.4019722222222,NULL,NULL,'2012-12-07 01:35:31',56268.0663399999,20.1245,0.1201,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 18:46:16','2012-12-08 18:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hft/LSQ12hft_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hft/LSQ12hft_snap_81427.gif',35040430818,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,547506731,8554792,NULL,NULL,NULL,NULL),(7517,7514,0,'LSQ12hft','LSQ',26.1690416666667,-20.4021111111111,NULL,NULL,'2012-12-07 03:35:07',56268.1493899999,19.4913,0.0904,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 18:46:16','2012-12-08 18:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hft/LSQ12hft_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hft/LSQ12hft_snap_81428.gif',35040430818,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,547506731,8554792,NULL,NULL,NULL,NULL),(7518,7518,1,'LSQ12hho','LSQ',150.232083333333,5.61811111111111,NULL,NULL,'2012-12-07 06:14:13',56268.2598799998,19.4375,0.1236,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 19:46:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hho/LSQ12hho_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hho/LSQ12hho_snap_81546.gif',60905654053,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,951650844,14869544,NULL,NULL,NULL,NULL),(7519,7518,0,'LSQ12hho','LSQ',150.232,5.61827777777778,NULL,NULL,'2012-12-07 07:24:37',56268.30877,19.0519,0.0978,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 19:46:15','2012-12-08 19:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hho/LSQ12hho_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hho/LSQ12hho_snap_81547.gif',60905654053,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,951650844,14869544,NULL,NULL,NULL,NULL),(7520,7520,1,'LSQ12hhj','LSQ',140.128958333333,0.201611111111111,NULL,NULL,'2012-11-25 06:14:49',56256.2602900001,19.2846,0.1286,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 19:46:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhj/LSQ12hhj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhj/LSQ12hhj_snap_81616.gif',60670777183,NULL,NULL,NULL,'2012-04-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,947980893,14812201,NULL,NULL,NULL,NULL),(7521,7520,0,'LSQ12hhj','LSQ',140.128916666667,0.201527777777778,NULL,NULL,'2012-11-25 07:25:51',56256.30962,19.4292,0.1467,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 19:46:15','2012-12-08 19:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhj/LSQ12hhj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhj/LSQ12hhj_snap_81617.gif',60670777183,NULL,NULL,NULL,'2012-04-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,947980893,14812201,NULL,NULL,NULL,NULL),(7522,7520,0,'LSQ12hhj','LSQ',140.129208333333,0.201555555555556,NULL,NULL,'2012-11-27 06:06:27',56258.2544900002,18.8648,0.1911,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 19:46:15','2012-12-08 19:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhj/LSQ12hhj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhj/LSQ12hhj_snap_81618.gif',60670777183,NULL,NULL,NULL,'2012-04-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,947980893,14812201,NULL,NULL,NULL,NULL),(7523,7520,0,'LSQ12hhj','LSQ',140.129166666667,0.2015,NULL,NULL,'2012-11-27 07:21:35',56258.3066599998,18.4836,0.0924,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 19:46:15','2012-12-08 19:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhj/LSQ12hhj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhj/LSQ12hhj_snap_81619.gif',60670777183,NULL,NULL,NULL,'2012-04-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,947980893,14812201,NULL,NULL,NULL,NULL),(7524,7520,0,'LSQ12hhj','LSQ',140.129083333333,0.201555555555556,NULL,NULL,'2012-12-07 05:29:57',56268.22914,18.4648,0.0859,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 19:46:15','2012-12-08 19:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhj/LSQ12hhj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhj/LSQ12hhj_snap_81536.gif',60670777183,NULL,NULL,NULL,'2012-04-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,947980893,14812201,NULL,NULL,NULL,NULL),(7525,7520,0,'LSQ12hhj','LSQ',140.129083333333,0.2015,NULL,NULL,'2012-12-07 08:19:39',56268.34699,18.7626,0.0617,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 19:46:15','2012-12-08 19:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhj/LSQ12hhj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhj/LSQ12hhj_snap_81537.gif',60670777183,NULL,NULL,NULL,'2012-04-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,947980893,14812201,NULL,NULL,NULL,NULL),(7526,7526,1,'LSQ12hhg','LSQ',138.828791666667,-2.91658333333333,NULL,NULL,'2012-12-07 05:19:32',56268.2218999998,15.6582,0.1287,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 19:46:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhg/LSQ12hhg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhg/LSQ12hhg_snap_81530.gif',41083973123,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,641937080,10030266,NULL,NULL,NULL,NULL),(7527,7526,0,'LSQ12hhg','LSQ',138.828666666667,-2.91661111111111,NULL,NULL,'2012-12-07 07:00:42',56268.2921600002,15.2772,0.1095,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 19:46:15','2012-12-08 19:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhg/LSQ12hhg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhg/LSQ12hhg_snap_81531.gif',41083973120,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,641937080,10030266,NULL,NULL,NULL,NULL),(7528,7528,1,'LSQ12hhf','LSQ',138.864583333333,-2.59588888888889,NULL,NULL,'2012-11-25 08:05:47',56256.3373599998,20.9179,0.1699,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 19:46:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhf/LSQ12hhf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhf/LSQ12hhf_snap_81621.gif',41083908193,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641936065,10030251,NULL,NULL,NULL,NULL),(7529,7528,0,'LSQ12hhf','LSQ',138.864541666667,-2.59591666666667,NULL,NULL,'2012-11-27 05:53:18',56258.24535,19.7538,0.155,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 19:46:15','2012-12-08 19:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhf/LSQ12hhf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhf/LSQ12hhf_snap_81622.gif',41083908193,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641936065,10030251,NULL,NULL,NULL,NULL),(7530,7528,0,'LSQ12hhf','LSQ',138.864583333333,-2.59583333333333,NULL,NULL,'2012-11-27 08:06:30',56258.3378499998,19.8701,0.1373,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 19:46:15','2012-12-08 19:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhf/LSQ12hhf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhf/LSQ12hhf_snap_81623.gif',41083908195,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641936065,10030251,NULL,NULL,NULL,NULL),(7531,7528,0,'LSQ12hhf','LSQ',138.864708333333,-2.59566666666667,NULL,NULL,'2012-12-07 05:19:32',56268.2218999998,18.9401,0.1058,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 19:46:15','2012-12-08 19:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhf/LSQ12hhf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhf/LSQ12hhf_snap_81528.gif',41083908195,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641936065,10030251,NULL,NULL,NULL,NULL),(7532,7528,0,'LSQ12hhf','LSQ',138.864541666667,-2.59594444444444,NULL,NULL,'2012-12-07 07:00:42',56268.2921600002,18.7902,0.0951,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-08 19:46:15','2012-12-08 19:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhf/LSQ12hhf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hhf/LSQ12hhf_snap_81529.gif',41083908193,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641936065,10030251,NULL,NULL,NULL,NULL),(7546,4056,0,'LSQ12ghe','LSQ',68.549,-23.0559444444444,NULL,NULL,'2012-12-08 06:00:11',56269.2501300001,20.3478,0.1271,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_81843.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(7547,4056,0,'LSQ12ghe','LSQ',68.5490416666667,-23.0558888888889,NULL,NULL,'2012-12-08 07:16:27',56269.3031000001,19.9001,0.1588,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghe/LSQ12ghe_snap_81844.gif',37320555166,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583133674,9111463,NULL,NULL,NULL,NULL),(7548,4061,0,'LSQ12ggx','LSQ',47.8960833333333,-22.3203611111111,NULL,NULL,'2012-12-08 02:39:27',56269.1107299998,20.1462,0.1716,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_81893.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(7549,4061,0,'LSQ12ggx','LSQ',47.8960833333333,-22.3203611111111,NULL,NULL,'2012-12-08 04:40:16',56269.1946399999,20.0394,0.1284,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggx/LSQ12ggx_snap_81894.gif',38031055901,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,594235248,9284925,NULL,NULL,NULL,NULL),(7550,4067,0,'LSQ12ggq','LSQ',69.4288333333333,-35.8658333333333,NULL,NULL,'2012-12-08 05:56:43',56269.2477299999,21.0577,0.1388,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_81872.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(7551,4067,0,'LSQ12ggq','LSQ',69.4289583333333,-35.8658055555556,NULL,NULL,'2012-12-08 07:14:45',56269.3019099999,20.8078,0.1412,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggq/LSQ12ggq_snap_81873.gif',37691520944,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588930014,9202031,NULL,NULL,NULL,NULL),(7552,4118,0,'LSQ12ghd','LSQ',71.8649583333333,-21.3295277777778,NULL,NULL,'2012-12-08 06:00:11',56269.2501300001,20.6558,0.1854,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_81861.gif',37342671080,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479235,9116863,NULL,NULL,NULL,NULL),(7553,4118,0,'LSQ12ghd','LSQ',71.8645,-21.3295,NULL,NULL,'2012-12-08 07:16:27',56269.3031000001,20.0645,0.105,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ghd/LSQ12ghd_snap_81862.gif',37342670868,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583479232,9116863,NULL,NULL,NULL,NULL),(7554,4136,0,'LSQ12ggz','LSQ',56.3260416666667,-23.8723333333333,NULL,NULL,'2012-12-08 03:01:35',56269.1261,19.4532,0.0712,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_snap_81895.gif',37995959908,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593686873,9276357,NULL,NULL,NULL,NULL),(7555,4136,0,'LSQ12ggz','LSQ',56.3260416666667,-23.8723055555556,NULL,NULL,'2012-12-08 05:02:16',56269.2099100002,19.5918,0.0946,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_history.html','agn ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggz/LSQ12ggz_snap_81896.gif',37995959908,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,593686873,9276357,NULL,NULL,NULL,NULL),(7556,4140,0,'LSQ12ggw','LSQ',49.5531666666667,-21.4534166666667,NULL,NULL,'2012-12-08 04:38:34',56269.1934600002,20.8919,0.1573,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggw/LSQ12ggw_history.html','sne ?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12ggw/LSQ12ggw_snap_81841.gif',38028965827,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,594202591,9284415,NULL,NULL,NULL,NULL),(7557,4317,0,'LSQ12gkk','LSQ',76.869,-23.8546388888889,NULL,NULL,'2012-12-08 05:46:20',56269.24052,20.5659,0.1114,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_81702.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(7558,4317,0,'LSQ12gkk','LSQ',76.8689583333333,-23.8546388888889,NULL,NULL,'2012-12-08 07:13:02',56269.3007200002,20.4052,0.1632,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_81703.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(7559,5246,0,'LSQ12gln','LSQ',80.7475833333333,-33.4642222222222,NULL,NULL,'2012-12-08 05:34:28',56269.2322800001,18.6928,0.0435,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_81889.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(7560,5246,0,'LSQ12gln','LSQ',80.7475416666667,-33.4643055555556,NULL,NULL,'2012-12-08 07:04:35',56269.2948599998,18.6509,0.054,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_81890.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(7561,5550,0,'LSQ12goy','LSQ',68.8834583333333,-26.4606944444444,NULL,NULL,'2012-12-08 06:18:04',56269.2625500001,19.9741,0.1288,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_81945.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(7562,5550,0,'LSQ12goy','LSQ',68.883375,-26.4606944444444,NULL,NULL,'2012-12-08 07:19:50',56269.3054499999,19.6817,0.1048,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_81946.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(7563,5557,0,'LSQ12gow','LSQ',48.1344583333333,-28.9631944444444,NULL,NULL,'2012-12-08 04:41:57',56269.1958099999,19.0275,0.0807,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_81949.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(7564,5823,0,'LSQ12grh','LSQ',48.076625,-24.5529722222222,NULL,NULL,'2012-12-08 02:39:27',56269.1107299998,18.8828,0.0582,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_81979.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(7565,5823,0,'LSQ12grh','LSQ',48.0766666666667,-24.5529722222222,NULL,NULL,'2012-12-08 04:40:16',56269.1946399999,18.8095,0.052,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_81980.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(7566,5831,0,'LSQ12gra','LSQ',51.1260833333333,-28.2918055555556,NULL,NULL,'2012-12-08 02:42:49',56269.11307,19.2042,0.1083,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_81973.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(7567,5831,0,'LSQ12gra','LSQ',51.1259583333333,-28.2917777777778,NULL,NULL,'2012-12-08 04:43:39',56269.1969900001,19.1906,0.0836,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_81974.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(7568,5856,0,'LSQ12gsh','LSQ',72.1756666666667,-30.9982777777778,NULL,NULL,'2012-12-08 05:27:41',56269.22756,18.3314,0.0706,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_81902.gif',37207941504,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581374086,9083970,NULL,NULL,NULL,NULL),(7569,5856,0,'LSQ12gsh','LSQ',72.1755833333333,-30.9984166666667,NULL,NULL,'2012-12-08 07:01:12',56269.2925100001,18.0075,0.0781,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_81903.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(7570,5876,0,'LSQ12gsv','LSQ',71.5319583333333,-25.2667222222222,NULL,NULL,'2012-12-08 06:00:11',56269.2501300001,19.8189,0.1818,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_81916.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(7571,5959,0,'LSQ12gtm','LSQ',69.95975,-34.1287222222222,NULL,NULL,'2012-12-08 05:27:41',56269.22756,21.1543,0.1716,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_81887.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(7572,5959,0,'LSQ12gtm','LSQ',69.9597916666667,-34.1287222222222,NULL,NULL,'2012-12-08 07:01:12',56269.2925100001,20.0884,0.1419,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_81888.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(7573,5970,0,'LSQ12gti','LSQ',40.0737916666667,-34.4597222222222,NULL,NULL,'2012-12-08 02:08:46',56269.0894300002,18.0585,0.0526,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_81925.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(7574,5970,0,'LSQ12gti','LSQ',40.0738333333333,-34.4596666666667,NULL,NULL,'2012-12-08 04:09:46',56269.1734600002,17.9942,0.0533,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_81926.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(7575,6109,0,'LSQ12gwg','LSQ',71.31675,-29.0706666666667,NULL,NULL,'2012-12-08 05:37:52',56269.2346399999,19.8537,0.0933,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_81964.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(7576,6109,0,'LSQ12gwg','LSQ',71.31675,-29.0706666666667,NULL,NULL,'2012-12-08 07:06:16',56269.2960299999,19.4032,0.0925,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_81965.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(7577,6150,0,'LSQ12gvs','LSQ',64.3945416666667,-38.8895555555556,NULL,NULL,'2012-12-08 06:46:01',56269.2819599998,18.9897,0.0472,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_81940.gif',37791067653,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(7578,6150,0,'LSQ12gvs','LSQ',64.3945,-38.8894722222222,NULL,NULL,'2012-12-08 07:31:03',56269.31324,19.0576,0.045,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_81941.gif',37791067655,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(7579,6182,0,'LSQ12gwl','LSQ',55.0220833333333,-21.5047222222222,NULL,NULL,'2012-12-08 02:53:00',56269.1201399998,21.1311,0.1848,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_snap_81968.gif',38047180560,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594487196,9288862,NULL,NULL,NULL,NULL),(7580,6188,0,'LSQ12gwk','LSQ',44.3660833333333,-25.3954444444444,NULL,NULL,'2012-12-08 04:25:01',56269.1840499998,19.6574,0.0903,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_81967.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(7581,7243,0,'LSQ12gzm','LSQ',40.1817916666667,-34.7405833333333,NULL,NULL,'2012-12-08 02:15:42',56269.09424,18.9784,0.0884,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_snap_81686.gif',38633055142,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603641486,9431898,NULL,NULL,NULL,NULL),(7582,7243,0,'LSQ12gzm','LSQ',40.18175,-34.7405277777778,NULL,NULL,'2012-12-08 04:16:33',56269.1781700002,18.722,0.0677,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_snap_81687.gif',38633055142,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603641486,9431898,NULL,NULL,NULL,NULL),(7583,7246,0,'LSQ12gzl','LSQ',41.029,-37.1565277777778,NULL,NULL,'2012-12-08 04:16:33',56269.1781700002,18.3336,0.0543,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_snap_81738.gif',38634771280,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603668301,9432317,NULL,NULL,NULL,NULL),(7584,7254,0,'LSQ12gzk','LSQ',41.0453333333333,-37.0320833333333,NULL,NULL,'2012-12-08 02:15:42',56269.09424,19.5987,0.0948,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_snap_81751.gif',38634729855,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603667653,9432307,NULL,NULL,NULL,NULL),(7585,7442,0,'LSQ12hev','LSQ',67.04775,-29.5602777777778,NULL,NULL,'2012-12-08 06:16:23',56269.26138,19.567,0.1462,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-21 02:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hev/LSQ12hev_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hev/LSQ12hev_snap_81801.gif',37659944801,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588436637,9194322,NULL,NULL,NULL,NULL),(7586,7442,0,'LSQ12hev','LSQ',67.047875,-29.5603055555556,NULL,NULL,'2012-12-08 06:19:45',56269.2637200002,19.9465,0.1444,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-21 02:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hev/LSQ12hev_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hev/LSQ12hev_snap_81802.gif',37659944801,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588436637,9194322,NULL,NULL,NULL,NULL),(7587,7456,0,'LSQ12hdn','LSQ',63.7049583333333,-32.2958055555556,NULL,NULL,'2012-12-08 03:15:16',56269.1356100002,19.9092,0.1796,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 03:46:16','2012-12-09 03:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_snap_81775.gif',37709622185,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589212846,9206450,NULL,NULL,NULL,NULL),(7588,7442,0,'LSQ12hev','LSQ',67.0480416666667,-29.5595555555556,NULL,NULL,'2012-11-15 07:25:32',56246.3094000001,20.0769,0.2029,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 04:46:16','2012-12-21 02:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hev/LSQ12hev_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hev/LSQ12hev_snap_82007.gif',37659944814,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588436637,9194322,NULL,NULL,NULL,NULL),(7604,7604,1,'LSQ12hiu','LSQ',27.6095,-22.9923055555556,NULL,NULL,'2012-12-08 01:33:04',56269.06464,20.1963,0.1313,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 17:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hiu/LSQ12hiu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hiu/LSQ12hiu_snap_82048.gif',37917052528,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592453945,9257092,NULL,NULL,NULL,NULL),(7605,7604,0,'LSQ12hiu','LSQ',27.6094166666667,-22.9923333333333,NULL,NULL,'2012-12-08 03:33:10',56269.1480399999,19.803,0.1216,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 17:46:13','2012-12-09 17:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hiu/LSQ12hiu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hiu/LSQ12hiu_snap_82049.gif',37917052528,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592453945,9257092,NULL,NULL,NULL,NULL),(7606,7606,1,'LSQ12hio','LSQ',64.2505833333333,-27.6963055555556,NULL,NULL,'2012-12-02 07:28:13',56263.3112699999,19.0853,0.1853,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 17:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_snap_82216.gif',37661993378,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588468646,9194822,NULL,NULL,NULL,NULL),(7607,7606,0,'LSQ12hio','LSQ',64.2505,-27.6963333333333,NULL,NULL,'2012-12-06 06:22:32',56267.26565,19.7248,0.1338,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 17:46:13','2012-12-09 17:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_snap_82217.gif',37661993409,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588468647,9194822,NULL,NULL,NULL,NULL),(7608,7606,0,'LSQ12hio','LSQ',64.2505833333333,-27.6963055555556,NULL,NULL,'2012-12-06 07:18:41',56267.3046499998,19.5938,0.1898,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 17:46:13','2012-12-09 17:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_snap_82218.gif',37661993378,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588468646,9194822,NULL,NULL,NULL,NULL),(7609,7606,0,'LSQ12hio','LSQ',64.2505,-27.6962777777778,NULL,NULL,'2012-12-08 03:52:24',56269.16139,20.1678,0.1431,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 17:46:13','2012-12-09 17:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_snap_82036.gif',37661993378,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588468646,9194822,NULL,NULL,NULL,NULL),(7610,7606,0,'LSQ12hio','LSQ',64.2505416666667,-27.6962777777778,NULL,NULL,'2012-12-08 05:51:31',56269.2441099999,20.1293,0.1104,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 17:46:13','2012-12-09 17:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_snap_82037.gif',37661993378,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588468646,9194822,NULL,NULL,NULL,NULL),(7611,7611,1,'LSQ12hil','LSQ',51.8455833333333,-28.0476111111111,NULL,NULL,'2012-12-08 02:41:08',56269.1118999999,19.5153,0.144,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 17:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hil/LSQ12hil_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hil/LSQ12hil_snap_82030.gif',38547942290,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602311598,9411118,NULL,NULL,NULL,NULL),(7612,7611,0,'LSQ12hil','LSQ',51.845625,-28.0479166666667,NULL,NULL,'2012-12-08 04:41:57',56269.1958099999,19.2661,0.1387,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 17:46:13','2012-12-09 17:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hil/LSQ12hil_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hil/LSQ12hil_snap_82031.gif',38547942290,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602311598,9411118,NULL,NULL,NULL,NULL),(7613,7613,1,'LSQ12hje','LSQ',77.1707083333333,-20.9644444444444,NULL,NULL,'2012-12-06 05:50:47',56267.2436000002,20.1962,0.167,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 18:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_82262.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(7614,7613,0,'LSQ12hje','LSQ',77.17075,-20.9644722222222,NULL,NULL,'2012-12-08 05:46:20',56269.24052,19.7578,0.1232,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 18:46:14','2012-12-11 00:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_82068.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(7615,7613,0,'LSQ12hje','LSQ',77.1707083333333,-20.9645,NULL,NULL,'2012-12-08 07:13:02',56269.3007200002,19.2996,0.1492,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 18:46:14','2012-12-11 00:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_82069.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(7616,7616,1,'LSQ12hjb','LSQ',44.9632083333333,-25.2588055555556,NULL,NULL,'2012-11-13 02:53:11',56244.1202699998,20.6719,0.1528,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 18:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjb/LSQ12hjb_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjb/LSQ12hjb_snap_82221.gif',38419825663,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,600309775,9379840,NULL,NULL,NULL,NULL),(7617,7616,0,'LSQ12hjb','LSQ',44.9632916666667,-25.2590555555556,NULL,NULL,'2012-12-08 02:25:55',56269.1013400001,18.0003,0.1142,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 18:46:14','2012-12-09 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjb/LSQ12hjb_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjb/LSQ12hjb_snap_82062.gif',38419825663,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,600309775,9379840,NULL,NULL,NULL,NULL),(7618,7616,0,'LSQ12hjb','LSQ',44.9632083333333,-25.2589722222222,NULL,NULL,'2012-12-08 04:26:43',56269.1852299999,18.3351,0.1262,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 18:46:14','2012-12-09 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjb/LSQ12hjb_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjb/LSQ12hjb_snap_82063.gif',38419825663,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,600309775,9379840,NULL,NULL,NULL,NULL),(7619,7619,1,'LSQ12hja','LSQ',39.6253333333333,-21.3089722222222,NULL,NULL,'2012-12-06 02:15:43',56267.0942500001,20.0602,0.1847,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 18:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_snap_82219.gif',37939371952,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592802686,9262541,NULL,NULL,NULL,NULL),(7620,7619,0,'LSQ12hja','LSQ',39.62525,-21.3089722222222,NULL,NULL,'2012-12-06 04:15:29',56267.1774200001,19.664,0.1233,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 18:46:14','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_snap_82220.gif',37939371955,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592802686,9262541,NULL,NULL,NULL,NULL),(7621,7619,0,'LSQ12hja','LSQ',39.6253333333333,-21.3089722222222,NULL,NULL,'2012-12-08 02:12:15',56269.09185,19.6495,0.1445,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 18:46:14','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_snap_82060.gif',37939371952,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592802686,9262541,NULL,NULL,NULL,NULL),(7622,7619,0,'LSQ12hja','LSQ',39.6253333333333,-21.3089722222222,NULL,NULL,'2012-12-08 04:13:09',56269.1758099999,19.9399,0.1366,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 18:46:14','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_snap_82061.gif',37939371952,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592802686,9262541,NULL,NULL,NULL,NULL),(7623,7623,1,'LSQ12hiz','LSQ',40.759875,-25.1144166666667,NULL,NULL,'2012-12-04 02:21:06',56265.0979900002,19.9849,0.1563,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 18:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hiz/LSQ12hiz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hiz/LSQ12hiz_snap_82215.gif',37935411676,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592740807,9261575,NULL,NULL,NULL,NULL),(7624,7623,0,'LSQ12hiz','LSQ',40.7595833333333,-25.1141944444444,NULL,NULL,'2012-12-08 02:12:15',56269.09185,19.7572,0.1367,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 18:46:14','2012-12-09 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hiz/LSQ12hiz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hiz/LSQ12hiz_snap_82058.gif',37935411676,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592740807,9261575,NULL,NULL,NULL,NULL),(7625,7623,0,'LSQ12hiz','LSQ',40.7595833333333,-25.1141666666667,NULL,NULL,'2012-12-08 04:13:09',56269.1758099999,19.078,0.0903,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 18:46:14','2012-12-09 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hiz/LSQ12hiz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hiz/LSQ12hiz_snap_82059.gif',37935411676,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592740807,9261575,NULL,NULL,NULL,NULL),(7626,7626,1,'LSQ12hiy','LSQ',29.38875,-25.5981388888889,NULL,NULL,'2012-12-02 01:55:47',56263.0804099999,20.0363,0.1154,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 18:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hiy/LSQ12hiy_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hiy/LSQ12hiy_snap_82214.gif',38389047878,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,599828873,9372326,NULL,NULL,NULL,NULL),(7627,7626,0,'LSQ12hiy','LSQ',29.3886666666667,-25.5980277777778,NULL,NULL,'2012-12-08 01:46:41',56269.0740899998,16.2064,0.0973,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 18:46:14','2012-12-09 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hiy/LSQ12hiy_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hiy/LSQ12hiy_snap_82056.gif',38389047878,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,599828873,9372326,NULL,NULL,NULL,NULL),(7628,7626,0,'LSQ12hiy','LSQ',29.3887916666667,-25.5980555555556,NULL,NULL,'2012-12-08 03:46:56',56269.1576,16.0083,0.1103,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 18:46:14','2012-12-09 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hiy/LSQ12hiy_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hiy/LSQ12hiy_snap_82057.gif',38389047878,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,599828873,9372326,NULL,NULL,NULL,NULL),(7629,5983,0,'LSQ12gul','LSQ',43.0337083333333,-0.0360277777777778,NULL,NULL,'2012-12-09 02:00:49',56270.08391,18.6075,0.0387,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_82462.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(7630,5983,0,'LSQ12gul','LSQ',43.0337916666667,-0.0360833333333333,NULL,NULL,'2012-12-09 04:00:23',56270.1669399999,18.4957,0.042,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_82463.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(7631,5985,0,'LSQ12guj','LSQ',36.2344583333333,5.12116666666667,NULL,NULL,'2012-12-09 03:07:56',56270.1305200001,18.3348,0.0315,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_snap_82464.gif',66894622375,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045228474,16331694,NULL,NULL,NULL,NULL),(7632,5991,0,'LSQ12gub','LSQ',145.626208333333,-11.0263055555556,NULL,NULL,'2012-12-09 05:22:06',56270.2236899999,18.8357,0.0588,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gub/LSQ12gub_history.html','sn?',NULL,0.035244,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gub/LSQ12gub_snap_82484.gif',41306840942,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645419389,10084677,NULL,NULL,NULL,NULL),(7633,5993,0,'LSQ12gtz','LSQ',48.3627083333333,-7.35833333333333,NULL,NULL,'2012-12-09 02:31:36',56270.1052799998,18.8265,0.0617,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_82480.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7634,5993,0,'LSQ12gtz','LSQ',48.362875,-7.35836111111111,NULL,NULL,'2012-12-09 04:34:58',56270.1909599998,18.3654,0.059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_82481.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7635,6014,0,'LSQ12gty','LSQ',73.3359166666667,-14.9325277777778,NULL,NULL,'2012-12-09 02:58:50',56270.1242,19.3945,0.0618,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_82478.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(7636,6014,0,'LSQ12gty','LSQ',73.336,-14.9325277777778,NULL,NULL,'2012-12-09 05:02:35',56270.21013,19.6855,0.0706,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_82479.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(7637,6155,0,'LSQ12gve','LSQ',51.109875,-11.6695277777778,NULL,NULL,'2012-12-09 04:47:11',56270.1994400001,19.6968,0.1255,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_82491.gif',37885390161,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(7638,6167,0,'LSQ12gvb','LSQ',46.528375,-2.58208333333333,NULL,NULL,'2012-12-09 02:02:30',56270.0850800001,19.164,0.1082,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_82490.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(7639,6172,0,'LSQ12guy','LSQ',151.692875,-6.18872222222222,NULL,NULL,'2012-12-09 05:51:07',56270.2438400001,19.3466,0.0932,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guy/LSQ12guy_history.html','sn?',NULL,0.055375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guy/LSQ12guy_snap_82497.gif',41247382850,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,644490357,10070161,NULL,NULL,NULL,NULL),(7640,6177,0,'LSQ12guq','LSQ',39.2715,-20.5101111111111,NULL,NULL,'2012-12-09 02:16:09',56270.0945600001,19.3466,0.1312,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guq/LSQ12guq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guq/LSQ12guq_snap_82485.gif',37939057755,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592797777,9262465,NULL,NULL,NULL,NULL),(7641,6204,0,'LSQ12guu','LSQ',24.469,-16.2692777777778,NULL,NULL,'2012-12-09 03:09:40',56270.1317199999,15.8354,0.006,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guu/LSQ12guu_history.html','unusual variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guu/LSQ12guu_snap_82492.gif',35192089516,NULL,NULL,NULL,'2012-10-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,549876398,8591818,NULL,NULL,NULL,NULL),(7642,7063,0,'LSQ12gxj','LSQ',43.239125,1.60672222222222,NULL,NULL,'2012-12-09 02:02:30',56270.0850800001,17.8815,0.0399,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_82345.gif',66842134735,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(7643,7063,0,'LSQ12gxj','LSQ',43.239125,1.60672222222222,NULL,NULL,'2012-12-09 04:02:05',56270.16812,17.9327,0.0422,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_82346.gif',66842134735,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(7644,7071,0,'LSQ12gxd','LSQ',36.0339166666667,-3.46402777777778,NULL,NULL,'2012-12-09 01:18:31',56270.0545299998,20.158,0.1413,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_82324.gif',34918977994,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(7645,7071,0,'LSQ12gxd','LSQ',36.0342916666667,-3.46419444444444,NULL,NULL,'2012-12-09 03:18:13',56270.13766,19.9288,0.1162,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_82325.gif',34918978036,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(7646,7075,0,'LSQ12gxb','LSQ',142.838916666667,-11.6295833333333,NULL,NULL,'2012-12-09 05:06:53',56270.21312,19.5571,0.0753,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_snap_82322.gif',42178887818,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,659045122,10297580,NULL,NULL,NULL,NULL),(7647,7075,0,'LSQ12gxb','LSQ',142.838916666667,-11.6296111111111,NULL,NULL,'2012-12-09 08:25:53',56270.3513099998,19.5091,0.0684,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_snap_82323.gif',42178887818,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,659045122,10297580,NULL,NULL,NULL,NULL),(7648,7116,0,'LSQ12gzh','LSQ',44.80475,7.26169444444444,NULL,NULL,'2012-12-09 03:41:11',56270.1535999998,20.8816,0.178,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzh/LSQ12gzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzh/LSQ12gzh_snap_82342.gif',67978103970,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1062157874,16596216,NULL,NULL,NULL,NULL),(7649,7083,0,'LSQ12gyr','LSQ',43.2102083333333,-7.71230555555556,NULL,NULL,'2012-12-09 04:29:54',56270.18744,20.0365,0.2042,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_history.html','sne - nice',NULL,0.11794,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_snap_82305.gif',37909543298,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592336614,9255259,NULL,NULL,NULL,NULL),(7650,7099,0,'LSQ12gyc','LSQ',41.4585833333333,-17.9293888888889,NULL,NULL,'2012-12-09 02:33:18',56270.1064599999,17.6901,0.061,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_82310.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(7651,7099,0,'LSQ12gyc','LSQ',41.4586666666667,-17.9293611111111,NULL,NULL,'2012-12-09 04:36:52',56270.1922800001,17.8007,0.0671,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_82311.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(7652,7118,0,'LSQ12gzb','LSQ',37.04475,-5.94608333333333,NULL,NULL,'2012-12-09 01:18:31',56270.0545299998,20.2361,0.0764,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_82349.gif',34948583495,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(7653,7118,0,'LSQ12gzb','LSQ',37.0447083333333,-5.94611111111111,NULL,NULL,'2012-12-09 03:18:13',56270.13766,20.3518,0.0848,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_82350.gif',34948583495,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(7654,7122,0,'LSQ12gza','LSQ',35.8930833333333,-5.90733333333333,NULL,NULL,'2012-12-09 01:18:31',56270.0545299998,20.3769,0.0982,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_82355.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(7655,7122,0,'LSQ12gza','LSQ',35.8930416666667,-5.90736111111111,NULL,NULL,'2012-12-09 03:18:13',56270.13766,20.5087,0.1449,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_82356.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(7656,7131,0,'LSQ12gyv','LSQ',50.4708333333333,-10.0814444444444,NULL,NULL,'2012-12-09 02:41:48',56270.1123700002,18.5191,0.0628,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_snap_82337.gif',37898370242,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592162035,9252531,NULL,NULL,NULL,NULL),(7657,7131,0,'LSQ12gyv','LSQ',50.470875,-10.0815833333333,NULL,NULL,'2012-12-09 04:45:31',56270.1982800001,18.5119,0.0495,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_snap_82338.gif',37898370242,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592162035,9252531,NULL,NULL,NULL,NULL),(7658,7134,0,'LSQ12gyn','LSQ',44.7079583333333,-14.9488055555556,NULL,NULL,'2012-12-09 02:40:07',56270.1112000002,19.9338,0.1126,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_82327.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(7659,7134,0,'LSQ12gyn','LSQ',44.708,-14.9488611111111,NULL,NULL,'2012-12-09 04:43:48',56270.1970899999,20.0203,0.1259,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_82328.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(7660,7319,0,'LSQ12hco','LSQ',48.6239166666667,-2.69105555555556,NULL,NULL,'2012-12-09 02:19:39',56270.0969799999,20.0233,0.1429,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_snap_82399.gif',36791664995,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574869765,8982340,NULL,NULL,NULL,NULL),(7661,7319,0,'LSQ12hco','LSQ',48.6239166666667,-2.69102777777778,NULL,NULL,'2012-12-09 04:23:00',56270.1826399998,19.9339,0.117,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_snap_82400.gif',36791664995,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574869765,8982340,NULL,NULL,NULL,NULL),(7662,7326,0,'LSQ12hcm','LSQ',55.5312916666667,4.23166666666667,NULL,NULL,'2012-12-09 02:38:24',56270.1100099999,19.1345,0.0627,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_history.html','sn nice',NULL,0.024457,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_snap_82403.gif',65206467034,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1018851047,15919547,NULL,NULL,NULL,NULL),(7663,7326,0,'LSQ12hcm','LSQ',55.5313333333333,4.23163888888889,NULL,NULL,'2012-12-09 04:42:05',56270.1959000002,19.0792,0.0684,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_history.html','sn nice',NULL,0.024457,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_snap_82404.gif',65206467034,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1018851047,15919547,NULL,NULL,NULL,NULL),(7664,7328,0,'LSQ12hcl','LSQ',42.915,-1.89863888888889,NULL,NULL,'2012-12-09 02:00:49',56270.08391,19.71,0.079,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_snap_82378.gif',34899428012,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545303562,8520368,NULL,NULL,NULL,NULL),(7665,7328,0,'LSQ12hcl','LSQ',42.9150416666667,-1.89866666666667,NULL,NULL,'2012-12-09 04:00:23',56270.1669399999,19.548,0.1424,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_snap_82379.gif',34899428012,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545303562,8520368,NULL,NULL,NULL,NULL),(7666,7337,0,'LSQ12hcc','LSQ',143.778916666667,-8.55058333333333,NULL,NULL,'2012-12-09 08:25:53',56270.3513099998,19.0564,0.12,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcc/LSQ12hcc_history.html','sn?',NULL,0.089982,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcc/LSQ12hcc_snap_82387.gif',41103056532,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642235258,10034925,NULL,NULL,NULL,NULL),(7667,7351,0,'LSQ12hbo','LSQ',164.064833333333,-20.8588055555556,NULL,NULL,'2012-12-09 06:17:22',56270.2620700002,18.3218,0.0423,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbo/LSQ12hbo_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbo/LSQ12hbo_snap_82376.gif',41856029840,NULL,NULL,NULL,'2012-06-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,654000466,10218757,NULL,NULL,NULL,NULL),(7668,7355,0,'LSQ12hbu','LSQ',152.378583333333,-16.1378888888889,NULL,NULL,'2012-12-09 07:01:23',56270.29263,21.1863,0.1648,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbu/LSQ12hbu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbu/LSQ12hbu_snap_82405.gif',41198551010,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643727359,10058239,NULL,NULL,NULL,NULL),(7669,7514,0,'LSQ12hft','LSQ',26.1692916666667,-20.4020833333333,NULL,NULL,'2012-12-09 03:02:50',56270.1269700001,20.581,0.1826,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 22:46:14','2012-12-09 22:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hft/LSQ12hft_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hft/LSQ12hft_snap_82414.gif',35040430818,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,547506731,8554792,NULL,NULL,NULL,NULL),(7670,7670,1,'LSQ12hjm','LSQ',47.619625,-16.4935555555556,NULL,NULL,'2012-12-09 02:40:07',56270.1112000002,13.8431,0.0375,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 23:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjm/LSQ12hjm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjm/LSQ12hjm_snap_82615.gif',38111401116,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,595490642,9304541,NULL,NULL,NULL,NULL),(7671,7670,0,'LSQ12hjm','LSQ',47.6196666666667,-16.4936944444444,NULL,NULL,'2012-12-09 04:43:48',56270.1970899999,14.5722,0.0402,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-09 23:46:16','2012-12-11 02:16:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjm/LSQ12hjm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjm/LSQ12hjm_snap_82616.gif',38111401116,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,595490642,9304541,NULL,NULL,NULL,NULL),(7672,4317,0,'LSQ12gkk','LSQ',76.8689583333333,-23.8546111111111,NULL,NULL,'2012-12-10 06:31:53',56271.2721500001,20.5696,0.1239,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_82731.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(7673,4317,0,'LSQ12gkk','LSQ',76.869,-23.8545833333333,NULL,NULL,'2012-12-10 08:02:07',56271.3348099999,20.6223,0.1392,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_history.html','sne - nice',NULL,0.05351,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gkk/LSQ12gkk_snap_82732.gif',37413193574,NULL,NULL,NULL,'2012-11-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584581149,9134080,NULL,NULL,NULL,NULL),(7674,5246,0,'LSQ12gln','LSQ',80.7475,-33.4642222222222,NULL,NULL,'2012-12-10 06:15:45',56271.2609399999,18.88,0.0562,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_82852.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(7675,5246,0,'LSQ12gln','LSQ',80.7475416666667,-33.4642777777778,NULL,NULL,'2012-12-10 07:25:33',56271.3094199998,18.826,0.049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_82853.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(7676,5550,0,'LSQ12goy','LSQ',68.8834583333333,-26.4607222222222,NULL,NULL,'2012-12-10 07:17:07',56271.3035599999,19.6442,0.1079,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_82933.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(7677,5550,0,'LSQ12goy','LSQ',68.883375,-26.46075,NULL,NULL,'2012-12-10 07:45:53',56271.3235399998,19.9729,0.1224,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_82934.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(7678,5557,0,'LSQ12gow','LSQ',48.1346666666667,-28.9631666666667,NULL,NULL,'2012-12-10 04:44:17',56271.1974200001,18.927,0.0933,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_82929.gif',38543705024,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245391,9410084,NULL,NULL,NULL,NULL),(7679,5823,0,'LSQ12grh','LSQ',48.0765833333333,-24.5529722222222,NULL,NULL,'2012-12-10 02:43:20',56271.1134299999,18.8545,0.0512,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_82955.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(7680,5823,0,'LSQ12grh','LSQ',48.0765833333333,-24.5529722222222,NULL,NULL,'2012-12-10 04:42:36',56271.19625,18.9331,0.0614,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_82956.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(7681,5831,0,'LSQ12gra','LSQ',51.1259166666667,-28.2917777777778,NULL,NULL,'2012-12-10 02:46:43',56271.1157800001,19.4848,0.0821,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_82959.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(7682,5831,0,'LSQ12gra','LSQ',51.1259166666667,-28.2917777777778,NULL,NULL,'2012-12-10 04:45:58',56271.1985900002,19.457,0.076,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_82960.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(7683,5856,0,'LSQ12gsh','LSQ',72.175375,-30.9983611111111,NULL,NULL,'2012-12-10 06:49:45',56271.28455,18.2733,0.0706,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_82888.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(7684,5856,0,'LSQ12gsh','LSQ',72.175625,-30.9982222222222,NULL,NULL,'2012-12-10 06:53:09',56271.2869099998,18.0711,0.0699,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_82889.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(7685,5876,0,'LSQ12gsv','LSQ',71.532,-25.2667777777778,NULL,NULL,'2012-12-10 07:12:04',56271.3000500002,20.1623,0.1282,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_82877.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(7686,5876,0,'LSQ12gsv','LSQ',71.5319583333333,-25.26675,NULL,NULL,'2012-12-10 07:47:35',56271.3247199999,20.0115,0.1341,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_82878.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(7687,5959,0,'LSQ12gtm','LSQ',69.9597083333333,-34.1286944444444,NULL,NULL,'2012-12-10 06:53:09',56271.2869099998,20.6037,0.1662,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtm/LSQ12gtm_snap_82851.gif',37698291408,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589035803,9203684,NULL,NULL,NULL,NULL),(7688,5970,0,'LSQ12gti','LSQ',40.0738333333333,-34.4596388888889,NULL,NULL,'2012-12-10 02:12:40',56271.0921399998,17.7731,0.0368,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_82900.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(7689,5970,0,'LSQ12gti','LSQ',40.073875,-34.4596944444444,NULL,NULL,'2012-12-10 04:11:59',56271.1749900002,17.9458,0.0335,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_82901.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(7690,6109,0,'LSQ12gwg','LSQ',71.3165833333333,-29.0705555555556,NULL,NULL,'2012-12-10 06:17:26',56271.26211,19.7848,0.1059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_82947.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(7691,6109,0,'LSQ12gwg','LSQ',71.3165833333333,-29.0706944444444,NULL,NULL,'2012-12-10 06:48:04',56271.2833799999,19.876,0.1087,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_82948.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(7692,6132,0,'LSQ12gwb','LSQ',54.008125,-29.7771944444444,NULL,NULL,'2012-12-10 03:19:11',56271.13833,21.7788,0.1161,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_history.html','sn?',NULL,0.1516,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_snap_82943.gif',38584840201,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602888128,9420127,NULL,NULL,NULL,NULL),(7693,6182,0,'LSQ12gwl','LSQ',55.0221666666667,-21.50475,NULL,NULL,'2012-12-10 04:56:07',56271.2056399998,21.6147,0.1944,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_snap_82949.gif',38047180560,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594487196,9288862,NULL,NULL,NULL,NULL),(7694,6188,0,'LSQ12gwk','LSQ',44.366,-25.3954722222222,NULL,NULL,'2012-12-10 04:27:17',56271.1856200001,19.8183,0.1343,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_82951.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(7695,7106,0,'LSQ12gxv','LSQ',70.422,-22.1974444444444,NULL,NULL,'2012-12-10 07:12:04',56271.3000500002,19.7003,0.0722,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_history.html','sne - nice',NULL,0.066686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_snap_82706.gif',37340201662,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583440650,9116260,NULL,NULL,NULL,NULL),(7696,7243,0,'LSQ12gzm','LSQ',40.18175,-34.7405277777778,NULL,NULL,'2012-12-10 02:19:27',56271.0968499999,18.0419,0.0727,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_snap_82722.gif',38633055142,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603641486,9431898,NULL,NULL,NULL,NULL),(7697,7243,0,'LSQ12gzm','LSQ',40.18175,-34.7405555555556,NULL,NULL,'2012-12-10 04:18:50',56271.1797500001,16.7099,0.0573,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_snap_82723.gif',38633055142,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603641486,9431898,NULL,NULL,NULL,NULL),(7698,7254,0,'LSQ12gzk','LSQ',41.0457916666667,-37.0319722222222,NULL,NULL,'2012-12-10 04:18:50',56271.1797500001,19.3932,0.0958,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-10 14:46:09','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_snap_82765.gif',38634729855,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603667653,9432307,NULL,NULL,NULL,NULL),(7699,7432,0,'LSQ12hdl','LSQ',53.4347083333333,-30.3173333333333,NULL,NULL,'2012-12-10 02:53:28',56271.12047,18.2078,0.0481,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-16 12:16:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_history.html','sn?',NULL,0.130297,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_snap_82779.gif',38573467025,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602710422,9417350,NULL,NULL,NULL,NULL),(7700,7442,0,'LSQ12hev','LSQ',67.0480833333333,-29.5601388888889,NULL,NULL,'2012-12-10 07:15:27',56271.3023999999,19.8342,0.1412,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-21 02:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hev/LSQ12hev_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hev/LSQ12hev_snap_82794.gif',37659944801,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588436637,9194322,NULL,NULL,NULL,NULL),(7701,7613,0,'LSQ12hje','LSQ',77.1707916666667,-20.9645277777778,NULL,NULL,'2012-12-10 08:02:07',56271.3348099999,19.107,0.1453,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-11 00:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_82902.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(7702,7619,0,'LSQ12hja','LSQ',39.6252916666667,-21.309,NULL,NULL,'2012-12-10 02:16:03',56271.09448,19.4563,0.1164,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_snap_82914.gif',37939371952,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592802686,9262541,NULL,NULL,NULL,NULL),(7703,7619,0,'LSQ12hja','LSQ',39.6254166666667,-21.3090277777778,NULL,NULL,'2012-12-10 04:15:21',56271.1773299999,19.4097,0.1053,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 14:46:09','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_snap_82915.gif',37939371952,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592802686,9262541,NULL,NULL,NULL,NULL),(7704,7704,1,'LSQ12hkd','LSQ',34.2793333333333,-0.38375,NULL,NULL,'2012-12-09 03:13:07',56270.1341200001,19.6266,0.1193,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkd/LSQ12hkd_history.html','sn nice',NULL,0.27369,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkd/LSQ12hkd_snap_82684.gif',34914378906,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545537170,8524018,NULL,NULL,NULL,NULL),(7705,7704,0,'LSQ12hkd','LSQ',34.2791666666667,-0.383527777777778,NULL,NULL,'2012-12-09 03:16:31',56270.1364699998,19.6195,0.1223,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2012-12-10 15:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkd/LSQ12hkd_history.html','sn nice',NULL,0.27369,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkd/LSQ12hkd_snap_82685.gif',34914378908,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545537170,8524018,NULL,NULL,NULL,NULL),(7706,7706,1,'LSQ12hka','LSQ',162.676833333333,-6.84527777777778,NULL,NULL,'2012-12-09 06:47:51',56270.2832399998,19.68,0.1247,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hka/LSQ12hka_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hka/LSQ12hka_snap_82643.gif',41796865596,NULL,NULL,NULL,'2012-05-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,653076024,10204312,NULL,NULL,NULL,NULL),(7707,7706,0,'LSQ12hka','LSQ',162.676833333333,-6.84536111111111,NULL,NULL,'2012-12-09 07:41:33',56270.3205300001,19.9633,0.1322,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2012-12-10 15:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hka/LSQ12hka_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hka/LSQ12hka_snap_82644.gif',41796865596,NULL,NULL,NULL,'2012-05-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,653076024,10204312,NULL,NULL,NULL,NULL),(7708,7708,1,'LSQ12hjq','LSQ',37.161375,-11.6393333333333,NULL,NULL,'2012-12-05 02:07:52',56266.0888,20.4216,0.1972,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_snap_82655.gif',37867077887,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,591673091,9244892,NULL,NULL,NULL,NULL),(7709,7708,0,'LSQ12hjq','LSQ',37.1612916666667,-11.6393611111111,NULL,NULL,'2012-12-05 04:08:04',56266.1722800001,20.1783,0.2142,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_snap_82656.gif',37867077887,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,591673091,9244892,NULL,NULL,NULL,NULL),(7710,7708,0,'LSQ12hjq','LSQ',37.1614166666667,-11.63925,NULL,NULL,'2012-12-07 02:01:25',56268.0843199999,20.1051,0.1861,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_snap_82657.gif',37867077887,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,591673091,9244892,NULL,NULL,NULL,NULL),(7711,7708,0,'LSQ12hjq','LSQ',37.1613333333333,-11.6393611111111,NULL,NULL,'2012-12-07 04:01:07',56268.1674500001,19.8518,0.1492,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_snap_82658.gif',37867077887,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,591673091,9244892,NULL,NULL,NULL,NULL),(7712,7708,0,'LSQ12hjq','LSQ',37.16125,-11.6393611111111,NULL,NULL,'2012-12-09 01:53:35',56270.0788799999,19.7401,0.1295,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_snap_82623.gif',37867077887,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,591673091,9244892,NULL,NULL,NULL,NULL),(7713,7708,0,'LSQ12hjq','LSQ',37.16125,-11.6393888888889,NULL,NULL,'2012-12-09 03:53:09',56270.1619199999,19.9959,0.15,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_snap_82624.gif',37867077887,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,591673091,9244892,NULL,NULL,NULL,NULL),(7714,7714,1,'LSQ12hjp','LSQ',34.5941666666667,-10.6701944444444,NULL,NULL,'2012-10-08 06:07:16',56208.2550499998,19.1107,0.0915,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjp/LSQ12hjp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjp/LSQ12hjp_snap_82651.gif',35116028866,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,548687951,8573249,NULL,NULL,NULL,NULL),(7715,7714,0,'LSQ12hjp','LSQ',34.593625,-10.6701388888889,NULL,NULL,'2012-10-10 02:05:06',56210.0868799998,18.0072,0.0145,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2012-12-10 15:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjp/LSQ12hjp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjp/LSQ12hjp_snap_82652.gif',35116028873,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,548687951,8573249,NULL,NULL,NULL,NULL),(7716,7714,0,'LSQ12hjp','LSQ',34.593375,-10.67025,NULL,NULL,'2012-10-10 05:13:43',56210.2178699998,19.5714,0.0971,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2012-12-10 15:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjp/LSQ12hjp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjp/LSQ12hjp_snap_82653.gif',35116028873,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,548687951,8573249,NULL,NULL,NULL,NULL),(7717,7714,0,'LSQ12hjp','LSQ',34.5935416666667,-10.6700833333333,NULL,NULL,'2012-10-11 01:35:26',56211.0662799999,17.0698,0.0311,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2012-12-10 15:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjp/LSQ12hjp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjp/LSQ12hjp_snap_82654.gif',35116028873,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,548687951,8573249,NULL,NULL,NULL,NULL),(7718,7714,0,'LSQ12hjp','LSQ',34.5939166666667,-10.67,NULL,NULL,'2012-12-09 01:43:20',56270.0717600002,19.9773,0.1166,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2012-12-10 15:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjp/LSQ12hjp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjp/LSQ12hjp_snap_82621.gif',35116028877,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,548687951,8573249,NULL,NULL,NULL,NULL),(7719,7714,0,'LSQ12hjp','LSQ',34.59375,-10.6701388888889,NULL,NULL,'2012-12-09 03:42:59',56270.15485,20.4686,0.1402,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2012-12-10 15:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjp/LSQ12hjp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjp/LSQ12hjp_snap_82622.gif',35116028877,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,548687951,8573249,NULL,NULL,NULL,NULL),(7720,7720,1,'LSQ12hjg','LSQ',35.907625,-19.7132777777778,NULL,NULL,'2012-12-05 04:13:33',56266.1760800001,19.937,0.1504,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjg/LSQ12hjg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjg/LSQ12hjg_snap_82278.gif',37982523854,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593476935,9273077,NULL,NULL,NULL,NULL),(7721,7720,0,'LSQ12hjg','LSQ',35.9071666666667,-19.7131944444444,NULL,NULL,'2012-12-07 02:06:58',56268.08818,18.7257,0.0827,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2012-12-10 15:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjg/LSQ12hjg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjg/LSQ12hjg_snap_82279.gif',37982523854,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593476935,9273077,NULL,NULL,NULL,NULL),(7722,7720,0,'LSQ12hjg','LSQ',35.907125,-19.7131666666667,NULL,NULL,'2012-12-09 01:59:07',56270.0827299999,18.774,0.136,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2012-12-10 15:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjg/LSQ12hjg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjg/LSQ12hjg_snap_82270.gif',37982523854,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593476935,9273077,NULL,NULL,NULL,NULL),(7723,7720,0,'LSQ12hjg','LSQ',35.9072916666667,-19.7131388888889,NULL,NULL,'2012-12-09 03:58:35',56270.1656900002,19.5693,0.14,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 15:46:10','2012-12-10 15:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjg/LSQ12hjg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjg/LSQ12hjg_snap_82271.gif',37982523854,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593476935,9273077,NULL,NULL,NULL,NULL),(7729,7729,1,'LSQ12hkm','LSQ',56.0942083333333,2.74536111111111,NULL,NULL,'2012-12-05 02:51:25',56266.1190499999,20.4179,0.208,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_snap_83020.gif',65198525114,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018726954,15917608,NULL,NULL,NULL,NULL),(7730,7729,0,'LSQ12hkm','LSQ',56.0940833333333,2.74536111111111,NULL,NULL,'2012-12-05 04:51:17',56266.2022899999,20.299,0.1921,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-10 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_snap_83021.gif',65198525114,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018726954,15917608,NULL,NULL,NULL,NULL),(7731,7729,0,'LSQ12hkm','LSQ',56.0940416666667,2.74538888888889,NULL,NULL,'2012-12-07 02:44:39',56268.1143499999,19.6642,0.1532,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-10 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_snap_83022.gif',65198525116,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018726954,15917608,NULL,NULL,NULL,NULL),(7732,7729,0,'LSQ12hkm','LSQ',56.0942083333333,2.74533333333333,NULL,NULL,'2012-12-07 04:46:18',56268.19882,20.127,0.1766,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-10 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_snap_83023.gif',65198525114,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018726954,15917608,NULL,NULL,NULL,NULL),(7733,7729,0,'LSQ12hkm','LSQ',56.0941666666667,2.74533333333333,NULL,NULL,'2012-12-09 02:36:42',56270.1088299998,19.5674,0.1326,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-10 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_snap_83000.gif',65198525114,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018726954,15917608,NULL,NULL,NULL,NULL),(7734,7729,0,'LSQ12hkm','LSQ',56.094125,2.74533333333333,NULL,NULL,'2012-12-09 04:40:24',56270.1947300001,19.7638,0.1654,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-10 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_snap_83001.gif',65198525114,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018726954,15917608,NULL,NULL,NULL,NULL),(7735,7735,1,'LSQ12hkj','LSQ',148.182083333333,0.537166666666667,NULL,NULL,'2012-12-09 06:49:33',56270.2844099998,19.8338,0.1135,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkj/LSQ12hkj_history.html','sn?',NULL,0.07666,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkj/LSQ12hkj_snap_82994.gif',60768834972,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,949513046,14836141,NULL,NULL,NULL,NULL),(7736,7735,0,'LSQ12hkj','LSQ',148.182083333333,0.537194444444444,NULL,NULL,'2012-12-09 07:44:56',56270.3228799999,20.2817,0.1376,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-10 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkj/LSQ12hkj_history.html','sn?',NULL,0.07666,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkj/LSQ12hkj_snap_82995.gif',60768834972,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,949513046,14836141,NULL,NULL,NULL,NULL),(7737,7737,1,'LSQ12hlm','LSQ',41.3444166666667,-25.0536944444444,NULL,NULL,'2012-12-10 02:14:21',56271.0933099999,17.2769,0.1517,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlm/LSQ12hlm_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlm/LSQ12hlm_snap_83080.gif',37935453758,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592741464,9261585,NULL,NULL,NULL,NULL),(7738,7737,0,'LSQ12hlm','LSQ',41.34425,-25.0538333333333,NULL,NULL,'2012-12-10 04:13:40',56271.1761599998,16.4039,0.1277,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-10 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlm/LSQ12hlm_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlm/LSQ12hlm_snap_83081.gif',37935453745,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592741464,9261585,NULL,NULL,NULL,NULL),(7739,7739,1,'LSQ12hli','LSQ',70.9915833333333,-27.22625,NULL,NULL,'2012-12-08 07:43:58',56269.3222099999,20.4781,0.1806,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hli/LSQ12hli_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hli/LSQ12hli_snap_83214.gif',37241972916,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581905826,9092278,NULL,NULL,NULL,NULL),(7740,7739,0,'LSQ12hli','LSQ',70.9909166666667,-27.2265833333333,NULL,NULL,'2012-12-10 06:46:22',56271.2822099999,19.6698,0.0854,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-10 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hli/LSQ12hli_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hli/LSQ12hli_snap_83072.gif',37241972900,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581905826,9092278,NULL,NULL,NULL,NULL),(7741,7739,0,'LSQ12hli','LSQ',70.9911666666667,-27.2265555555556,NULL,NULL,'2012-12-10 07:42:31',56271.3212000001,20.0785,0.1076,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-10 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hli/LSQ12hli_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hli/LSQ12hli_snap_83073.gif',37241972900,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581905826,9092278,NULL,NULL,NULL,NULL),(7742,7742,1,'LSQ12hlh','LSQ',68.249875,-28.21375,NULL,NULL,'2012-11-17 05:37:33',56248.23441,20.3096,0.1605,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlh/LSQ12hlh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlh/LSQ12hlh_snap_83212.gif',37186492231,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581038941,9078733,NULL,NULL,NULL,NULL),(7743,7742,0,'LSQ12hlh','LSQ',68.249375,-28.2138055555556,NULL,NULL,'2012-11-19 07:06:00',56250.2958399998,19.5904,0.107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-10 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlh/LSQ12hlh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlh/LSQ12hlh_snap_83213.gif',37186492231,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581038941,9078733,NULL,NULL,NULL,NULL),(7744,7742,0,'LSQ12hlh','LSQ',68.2495833333333,-28.2134166666667,NULL,NULL,'2012-12-10 07:15:27',56271.3023999999,19.6302,0.1178,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-10 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlh/LSQ12hlh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlh/LSQ12hlh_snap_83070.gif',37186492231,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581038941,9078733,NULL,NULL,NULL,NULL),(7745,7742,0,'LSQ12hlh','LSQ',68.2498333333333,-28.21375,NULL,NULL,'2012-12-10 07:18:48',56271.30473,19.8413,0.1384,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-10 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlh/LSQ12hlh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlh/LSQ12hlh_snap_83071.gif',37186492231,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581038941,9078733,NULL,NULL,NULL,NULL),(7746,7746,1,'LSQ12hlf','LSQ',66.60125,-28.8988611111111,NULL,NULL,'2012-11-21 07:02:51',56252.2936499999,19.936,0.1444,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlf/LSQ12hlf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlf/LSQ12hlf_snap_83198.gif',37660496843,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588445263,9194457,NULL,NULL,NULL,NULL),(7747,7746,0,'LSQ12hlf','LSQ',66.6015,-28.8988333333333,NULL,NULL,'2012-12-02 07:46:16',56263.3237999999,19.6254,0.1941,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-10 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlf/LSQ12hlf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlf/LSQ12hlf_snap_83199.gif',37660496843,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588445263,9194457,NULL,NULL,NULL,NULL),(7748,7746,0,'LSQ12hlf','LSQ',66.6017083333333,-28.8986666666667,NULL,NULL,'2012-12-08 06:18:04',56269.2625500001,19.7391,0.1303,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-10 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlf/LSQ12hlf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlf/LSQ12hlf_snap_83200.gif',37660496840,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588445263,9194457,NULL,NULL,NULL,NULL),(7749,7746,0,'LSQ12hlf','LSQ',66.6011666666667,-28.8988888888889,NULL,NULL,'2012-12-10 07:17:07',56271.3035599999,19.3336,0.0913,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-10 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlf/LSQ12hlf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlf/LSQ12hlf_snap_83066.gif',37660496843,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588445263,9194457,NULL,NULL,NULL,NULL),(7750,7746,0,'LSQ12hlf','LSQ',66.6012083333333,-28.8988611111111,NULL,NULL,'2012-12-10 07:45:53',56271.3235399998,19.0494,0.09,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-10 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlf/LSQ12hlf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlf/LSQ12hlf_snap_83067.gif',37660496843,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588445263,9194457,NULL,NULL,NULL,NULL),(7751,7751,1,'LSQ12hle','LSQ',61.1043333333333,-29.1574722222222,NULL,NULL,'2012-12-02 06:26:03',56263.2681,19.9513,0.1719,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_snap_83197.gif',38530541650,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602039713,9406870,NULL,NULL,NULL,NULL),(7752,7751,0,'LSQ12hle','LSQ',61.1044166666667,-29.1577222222222,NULL,NULL,'2012-12-10 03:10:45',56271.1324700001,19.12,0.0566,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_snap_83064.gif',38530541650,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602039713,9406870,NULL,NULL,NULL,NULL),(7753,7751,0,'LSQ12hle','LSQ',61.1044166666667,-29.1578055555556,NULL,NULL,'2012-12-10 05:09:42',56271.21508,19.4377,0.0624,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_snap_83065.gif',38530541650,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602039713,9406870,NULL,NULL,NULL,NULL),(7754,7754,1,'LSQ12hkt','LSQ',38.3255,-26.1251111111111,NULL,NULL,'2012-12-10 02:09:17',56271.0897900001,19.793,0.143,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkt/LSQ12hkt_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkt/LSQ12hkt_snap_83042.gif',38428087534,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,600438867,9381857,NULL,NULL,NULL,NULL),(7755,7754,0,'LSQ12hkt','LSQ',38.3255,-26.1251111111111,NULL,NULL,'2012-12-10 04:08:35',56271.1726299999,19.7386,0.1038,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 17:46:16','2012-12-10 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkt/LSQ12hkt_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkt/LSQ12hkt_snap_83043.gif',38428087534,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,600438867,9381857,NULL,NULL,NULL,NULL),(7756,7756,1,'LSQ12hlv','LSQ',76.9715,-21.2463611111111,NULL,NULL,'2012-11-13 07:39:06',56244.3188299998,19.2932,0.1255,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlv/LSQ12hlv_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlv/LSQ12hlv_snap_83275.gif',37548641524,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586697523,9167148,NULL,NULL,NULL,NULL),(7757,7756,0,'LSQ12hlv','LSQ',76.9714166666667,-21.2462777777778,NULL,NULL,'2012-12-10 06:31:53',56271.2721500001,19.1259,0.1071,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlv/LSQ12hlv_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlv/LSQ12hlv_snap_83098.gif',37548641524,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586697523,9167148,NULL,NULL,NULL,NULL),(7758,7756,0,'LSQ12hlv','LSQ',76.971625,-21.2463611111111,NULL,NULL,'2012-12-10 08:02:07',56271.3348099999,18.5707,0.0853,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlv/LSQ12hlv_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlv/LSQ12hlv_snap_83099.gif',37548641524,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586697523,9167148,NULL,NULL,NULL,NULL),(7759,7759,1,'LSQ12hlt','LSQ',60.2087916666667,-24.5228611111111,NULL,NULL,'2012-11-23 07:09:21',56254.2981699998,20.8709,0.1682,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_snap_83266.gif',38522137142,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601908392,9404818,NULL,NULL,NULL,NULL),(7760,7759,0,'LSQ12hlt','LSQ',60.208875,-24.5228888888889,NULL,NULL,'2012-11-24 07:17:22',56255.3037299998,20.7138,0.1591,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_snap_83267.gif',38522137142,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601908392,9404818,NULL,NULL,NULL,NULL),(7761,7759,0,'LSQ12hlt','LSQ',60.208875,-24.5227777777778,NULL,NULL,'2012-12-02 06:12:28',56263.2586599998,19.93,0.1495,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_snap_83268.gif',38522137142,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601908392,9404818,NULL,NULL,NULL,NULL),(7762,7759,0,'LSQ12hlt','LSQ',60.20875,-24.5228888888889,NULL,NULL,'2012-12-04 06:32:03',56265.27226,20.2457,0.1865,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_snap_83269.gif',38522137142,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601908392,9404818,NULL,NULL,NULL,NULL),(7763,7759,0,'LSQ12hlt','LSQ',60.2087083333333,-24.5228055555556,NULL,NULL,'2012-12-06 06:27:35',56267.2691600001,20.564,0.1705,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_snap_83270.gif',38522137142,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601908392,9404818,NULL,NULL,NULL,NULL),(7764,7759,0,'LSQ12hlt','LSQ',60.20875,-24.5228333333333,NULL,NULL,'2012-12-06 06:40:53',56267.2784000002,20.0536,0.1437,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_snap_83271.gif',38522137142,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601908392,9404818,NULL,NULL,NULL,NULL),(7765,7759,0,'LSQ12hlt','LSQ',60.20875,-24.5229444444444,NULL,NULL,'2012-12-08 03:13:34',56269.1344300001,20.3695,0.1733,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_snap_83272.gif',38522137150,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601908392,9404818,NULL,NULL,NULL,NULL),(7766,7759,0,'LSQ12hlt','LSQ',60.2089166666667,-24.5229166666667,NULL,NULL,'2012-12-08 05:14:09',56269.2181600002,20.4794,0.1289,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_snap_83273.gif',38522137142,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601908392,9404818,NULL,NULL,NULL,NULL),(7767,7759,0,'LSQ12hlt','LSQ',60.2087083333333,-24.5228055555556,NULL,NULL,'2012-12-10 03:17:30',56271.1371599999,20.4167,0.1261,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_snap_83094.gif',38522137142,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601908392,9404818,NULL,NULL,NULL,NULL),(7768,7759,0,'LSQ12hlt','LSQ',60.2086666666667,-24.5228333333333,NULL,NULL,'2012-12-10 05:16:30',56271.2198000001,20.6571,0.1246,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_snap_83095.gif',38522137142,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601908392,9404818,NULL,NULL,NULL,NULL),(7769,7769,1,'LSQ12hln','LSQ',41.38825,-21.0492777777778,NULL,NULL,'2012-11-26 02:11:43',56257.0914799999,19.3917,0.161,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hln/LSQ12hln_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hln/LSQ12hln_snap_83220.gif',37939928714,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592811386,9262677,NULL,NULL,NULL,NULL),(7770,7769,0,'LSQ12hln','LSQ',41.3880833333333,-21.0495277777778,NULL,NULL,'2012-11-30 02:26:46',56261.1019299999,17.9462,0.1705,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hln/LSQ12hln_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hln/LSQ12hln_snap_83221.gif',37939928759,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592811386,9262677,NULL,NULL,NULL,NULL),(7771,7769,0,'LSQ12hln','LSQ',41.3884166666667,-21.0492222222222,NULL,NULL,'2012-12-02 02:17:55',56263.0957800001,19.9239,0.2067,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hln/LSQ12hln_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hln/LSQ12hln_snap_83222.gif',37939928715,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592811386,9262677,NULL,NULL,NULL,NULL),(7772,7769,0,'LSQ12hln','LSQ',41.3879583333333,-21.0491111111111,NULL,NULL,'2012-12-10 02:14:21',56271.0933099999,16.0935,0.0639,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hln/LSQ12hln_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hln/LSQ12hln_snap_83082.gif',37939928757,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592811386,9262677,NULL,NULL,NULL,NULL),(7773,7769,0,'LSQ12hln','LSQ',41.3879583333333,-21.0493055555556,NULL,NULL,'2012-12-10 04:13:40',56271.1761599998,17.1148,0.125,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hln/LSQ12hln_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hln/LSQ12hln_snap_83083.gif',37939928757,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592811386,9262677,NULL,NULL,NULL,NULL),(7774,7774,1,'LSQ12hky','LSQ',43.0664166666667,-26.0833888888889,NULL,NULL,'2012-12-08 02:19:06',56269.0965999998,21.0894,0.206,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hky/LSQ12hky_history.html','sn',NULL,0.1575,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hky/LSQ12hky_snap_83122.gif',38423641881,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,600369404,9380771,NULL,NULL,NULL,NULL),(7775,7774,0,'LSQ12hky','LSQ',43.066375,-26.0833888888889,NULL,NULL,'2012-12-10 02:22:50',56271.0992000001,20.2113,0.1399,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hky/LSQ12hky_history.html','sn',NULL,0.1575,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hky/LSQ12hky_snap_83052.gif',38423641881,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,600369404,9380771,NULL,NULL,NULL,NULL),(7776,7774,0,'LSQ12hky','LSQ',43.0664583333333,-26.0834444444444,NULL,NULL,'2012-12-10 04:22:14',56271.1821099999,19.6899,0.1108,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hky/LSQ12hky_history.html','sn',NULL,0.1575,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hky/LSQ12hky_snap_83053.gif',38423641881,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,600369404,9380771,NULL,NULL,NULL,NULL),(7777,7777,1,'LSQ12hkx','LSQ',43.275,-26.0279444444444,NULL,NULL,'2012-12-10 02:22:50',56271.0992000001,19.782,0.0987,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkx/LSQ12hkx_history.html','sn',NULL,0.1082,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkx/LSQ12hkx_snap_83050.gif',38420167590,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,600315118,9379923,NULL,NULL,NULL,NULL),(7778,7777,0,'LSQ12hkx','LSQ',43.2749583333333,-26.0280555555556,NULL,NULL,'2012-12-10 04:22:14',56271.1821099999,19.1305,0.097,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-10 19:46:20','2012-12-10 19:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkx/LSQ12hkx_history.html','sn',NULL,0.1082,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkx/LSQ12hkx_snap_83051.gif',38420167590,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,600315118,9379923,NULL,NULL,NULL,NULL),(7779,7613,0,'LSQ12hje','LSQ',77.1707083333,-20.9644444444,NULL,NULL,'2012-12-10 12:00:00',56271.5,NULL,NULL,NULL,0.1,NULL,'Ia',NULL,'2012-12-11 00:36:35','2012-12-11 00:46:14','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37415313422,'UH 2.2m','SNIFS','SNfactory','2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(7780,7670,0,'LSQ12hjm','LSQ',47.619625,-16.4935555556,NULL,NULL,'2012-12-10 12:00:00',56271.5,NULL,NULL,NULL,0.07,NULL,'Ia',NULL,'2012-12-11 02:13:38','2012-12-11 02:16:14','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38111401116,'UH 2.2m','SNIFS','SNfactory','2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,595490642,9304541,NULL,NULL,NULL,NULL),(7830,7445,0,'LSQ12heq','pessto',53.2672916667,-28.2137777778,NULL,NULL,'2012-12-12 00:00:00',56273,NULL,NULL,NULL,0.15,NULL,'I peculiar',NULL,'2012-12-12 15:59:18','2012-12-12 22:46:08','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38581253600,'NTT','EFOSC2','Stephen','2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(7831,7445,0,'LSQ12heq','LSQ',53.26725,-28.2137222222222,NULL,NULL,'2012-12-08 01:20:32',56269.0559299998,19.1498,0.0348,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-12 22:46:06','2012-12-12 22:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_81787.gif',38581253603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(7832,7445,0,'LSQ12heq','LSQ',53.2672916666667,-28.21375,NULL,NULL,'2012-12-08 03:22:20',56269.1405199999,19.1562,0.0363,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-12 22:46:06','2012-12-12 22:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_81788.gif',38581253603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(7833,7445,0,'LSQ12heq','LSQ',53.26725,-28.21375,NULL,NULL,'2012-12-10 01:21:56',56271.0569000002,19.0357,0.0306,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-12 22:46:06','2012-12-12 22:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_82782.gif',38581253603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(7834,7445,0,'LSQ12heq','LSQ',53.26725,-28.21375,NULL,NULL,'2012-12-10 03:22:53',56271.1409,19.1017,0.0384,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-12 22:46:06','2012-12-12 22:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_82783.gif',38581253603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(7835,4356,0,'LSQ12gla','LSQ',50.0672083333333,-9.48080555555556,NULL,NULL,'2012-12-11 04:41:37',56272.19557,20.693,0.1835,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gla/LSQ12gla_snap_83373.gif',37898099251,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,592157800,9252465,NULL,NULL,NULL,NULL),(7836,5813,0,'LSQ12gpw','LSQ',48.2427083333333,-11.7111388888889,NULL,NULL,'2012-12-11 02:40:28',56272.1114400001,16.4828,0.0143,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_83457.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(7837,5813,0,'LSQ12gpw','LSQ',48.2426666666667,-11.7111388888889,NULL,NULL,'2012-12-11 04:41:37',56272.19557,16.4539,0.0139,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_83458.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(7838,5983,0,'LSQ12gul','LSQ',43.0337916666667,-0.0361111111111111,NULL,NULL,'2012-12-11 03:02:43',56272.12689,18.4148,0.0338,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_83413.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(7839,5989,0,'LSQ12guf','LSQ',144.931833333333,-3.73113888888889,NULL,NULL,'2012-12-11 07:00:51',56272.29226,20.1655,0.2123,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guf/LSQ12guf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guf/LSQ12guf_snap_83378.gif',41114462868,NULL,NULL,NULL,'2012-05-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,642413482,10037710,NULL,NULL,NULL,NULL),(7840,5991,0,'LSQ12gub','LSQ',145.625583333333,-11.0258888888889,NULL,NULL,'2012-12-11 05:17:13',56272.2202900001,20.0001,0.1228,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gub/LSQ12gub_history.html','sn?',NULL,0.035244,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gub/LSQ12gub_snap_83433.gif',41306840934,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645419389,10084677,NULL,NULL,NULL,NULL),(7841,5991,0,'LSQ12gub','LSQ',145.626375,-11.0263055555556,NULL,NULL,'2012-12-11 06:55:41',56272.2886700002,20.5873,0.1443,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gub/LSQ12gub_history.html','sn?',NULL,0.035244,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gub/LSQ12gub_snap_83434.gif',41306840942,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645419389,10084677,NULL,NULL,NULL,NULL),(7842,5993,0,'LSQ12gtz','LSQ',48.3627916666667,-7.35836111111111,NULL,NULL,'2012-12-11 02:28:12',56272.10292,18.2952,0.0403,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_83431.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7843,5993,0,'LSQ12gtz','LSQ',48.3627083333333,-7.35847222222222,NULL,NULL,'2012-12-11 02:40:28',56272.1114400001,19.1232,0.0749,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_83429.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7844,5993,0,'LSQ12gtz','LSQ',48.3628333333333,-7.35838888888889,NULL,NULL,'2012-12-11 04:27:51',56272.1860099998,18.8341,0.0671,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_83432.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7845,5993,0,'LSQ12gtz','LSQ',48.3627083333333,-7.35847222222222,NULL,NULL,'2012-12-11 04:41:37',56272.19557,19.2591,0.078,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_83430.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7846,6014,0,'LSQ12gty','LSQ',73.3359166666667,-14.9325555555556,NULL,NULL,'2012-12-11 02:52:23',56272.1197199998,19.7,0.0695,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_83435.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(7847,6014,0,'LSQ12gty','LSQ',73.3359583333333,-14.9325833333333,NULL,NULL,'2012-12-11 04:51:50',56272.20267,19.851,0.0814,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_83436.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(7848,6167,0,'LSQ12gvb','LSQ',46.5283333333333,-2.58225,NULL,NULL,'2012-12-11 02:00:50',56272.0839200001,18.7358,0.0952,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_83452.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(7849,6167,0,'LSQ12gvb','LSQ',46.5282916666667,-2.58219444444444,NULL,NULL,'2012-12-11 03:04:24',56272.12806,19.3359,0.0984,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_83453.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(7850,6177,0,'LSQ12guq','LSQ',39.27175,-20.5100833333333,NULL,NULL,'2012-12-11 04:12:30',56272.1753500002,18.9039,0.1026,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guq/LSQ12guq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guq/LSQ12guq_snap_83437.gif',37939057755,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592797777,9262465,NULL,NULL,NULL,NULL),(7851,7063,0,'LSQ12gxj','LSQ',43.2390833333333,1.60672222222222,NULL,NULL,'2012-12-11 02:00:50',56272.0839200001,17.5575,0.028,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_83318.gif',66842134735,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(7852,7063,0,'LSQ12gxj','LSQ',43.239125,1.60675,NULL,NULL,'2012-12-11 03:04:24',56272.12806,17.642,0.0327,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_83319.gif',66842134735,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(7853,7071,0,'LSQ12gxd','LSQ',36.0342916666667,-3.46419444444444,NULL,NULL,'2012-12-11 01:18:52',56272.0547699998,19.7761,0.1005,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_83309.gif',34918978036,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(7854,7071,0,'LSQ12gxd','LSQ',36.03425,-3.46419444444444,NULL,NULL,'2012-12-11 03:18:25',56272.1378000001,20.0354,0.1134,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_83310.gif',34918978036,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(7855,7075,0,'LSQ12gxb','LSQ',142.838833333333,-11.6295555555556,NULL,NULL,'2012-12-11 05:03:35',56272.2108300002,19.8742,0.0752,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_snap_83308.gif',42178887818,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,659045122,10297580,NULL,NULL,NULL,NULL),(7856,7094,0,'LSQ12gye','LSQ',161.5945,-20.3265277777778,NULL,NULL,'2012-12-11 06:21:43',56272.2650899999,18.3705,0.0223,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gye/LSQ12gye_history.html','possible asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gye/LSQ12gye_snap_83301.gif',41631758262,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650496222,10164003,NULL,NULL,NULL,NULL),(7857,7096,0,'LSQ12gyd','LSQ',76.387125,-18.0351944444444,NULL,NULL,'2012-12-11 02:57:27',56272.12323,18.6785,0.0551,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_83297.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(7858,7096,0,'LSQ12gyd','LSQ',76.387125,-18.0351388888889,NULL,NULL,'2012-12-11 04:56:55',56272.2061999999,18.9133,0.0532,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_83298.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(7859,7099,0,'LSQ12gyc','LSQ',41.458625,-17.9293333333333,NULL,NULL,'2012-12-11 02:29:57',56272.10414,17.8161,0.0704,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_83299.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(7860,7099,0,'LSQ12gyc','LSQ',41.458625,-17.9293611111111,NULL,NULL,'2012-12-11 04:29:35',56272.1872200002,17.8771,0.0632,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_83300.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(7861,7118,0,'LSQ12gzb','LSQ',37.0447916666667,-5.94611111111111,NULL,NULL,'2012-12-11 01:18:52',56272.0547699998,20.3652,0.0913,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_83323.gif',34948583495,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(7862,7118,0,'LSQ12gzb','LSQ',37.0446666666667,-5.94613888888889,NULL,NULL,'2012-12-11 03:18:25',56272.1378000001,20.373,0.0773,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_83324.gif',34948583495,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(7863,7122,0,'LSQ12gza','LSQ',35.8930833333333,-5.90738888888889,NULL,NULL,'2012-12-11 01:18:52',56272.0547699998,20.0933,0.0686,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_83325.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(7864,7131,0,'LSQ12gyv','LSQ',50.4709166666667,-10.0814722222222,NULL,NULL,'2012-12-11 02:38:47',56272.1102700001,18.7554,0.0648,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_snap_83311.gif',37898370242,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592162035,9252531,NULL,NULL,NULL,NULL),(7865,7131,0,'LSQ12gyv','LSQ',50.4708333333333,-10.0815555555556,NULL,NULL,'2012-12-11 04:39:55',56272.1943899998,18.506,0.0567,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_snap_83312.gif',37898370242,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592162035,9252531,NULL,NULL,NULL,NULL),(7866,7134,0,'LSQ12gyn','LSQ',44.708,-14.9488055555556,NULL,NULL,'2012-12-11 02:37:06',56272.1091,20.211,0.122,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_83306.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(7867,7134,0,'LSQ12gyn','LSQ',44.7080416666667,-14.9488611111111,NULL,NULL,'2012-12-11 04:38:13',56272.1932100002,20.2634,0.1255,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_83307.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(7868,7319,0,'LSQ12hco','LSQ',48.6239583333333,-2.69108333333333,NULL,NULL,'2012-12-11 02:16:20',56272.0946800001,20.2356,0.1404,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_snap_83369.gif',36791664995,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574869765,8982340,NULL,NULL,NULL,NULL),(7869,7326,0,'LSQ12hcm','LSQ',55.5313333333333,4.23166666666667,NULL,NULL,'2012-12-11 02:35:19',56272.1078599999,18.9898,0.0487,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_history.html','sn nice',NULL,0.024457,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_snap_83370.gif',65206467034,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1018851047,15919547,NULL,NULL,NULL,NULL),(7870,7326,0,'LSQ12hcm','LSQ',55.531375,4.23163888888889,NULL,NULL,'2012-12-11 04:36:26',56272.19197,18.8063,0.0496,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_history.html','sn nice',NULL,0.024457,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_snap_83371.gif',65206467034,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1018851047,15919547,NULL,NULL,NULL,NULL),(7871,7328,0,'LSQ12hcl','LSQ',42.9149583333333,-1.89869444444444,NULL,NULL,'2012-12-11 03:02:43',56272.12689,19.9026,0.0949,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_snap_83350.gif',34899428012,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545303562,8520368,NULL,NULL,NULL,NULL),(7872,7355,0,'LSQ12hbu','LSQ',152.378916666667,-16.1379166666667,NULL,NULL,'2012-12-11 05:15:31',56272.21912,19.6269,0.1146,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbu/LSQ12hbu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbu/LSQ12hbu_snap_83372.gif',41198551021,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643727359,10058239,NULL,NULL,NULL,NULL),(7873,7357,0,'LSQ12hbt','LSQ',32.1596666666667,-13.1482222222222,NULL,NULL,'2012-12-11 03:15:02',56272.1354399999,20.495,0.1436,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbt/LSQ12hbt_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbt/LSQ12hbt_snap_83353.gif',35054571753,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,547727683,8558245,NULL,NULL,NULL,NULL),(7874,7507,0,'LSQ12hgj','LSQ',154.207375,-16.1958611111111,NULL,NULL,'2012-12-11 06:33:35',56272.2733300002,19.8968,0.1338,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_snap_83417.gif',41166665804,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643229153,10050455,NULL,NULL,NULL,NULL),(7875,7507,0,'LSQ12hgj','LSQ',154.207416666667,-16.1958888888889,NULL,NULL,'2012-12-11 07:34:09',56272.3153900001,20.5126,0.1684,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_snap_83418.gif',41166665802,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643229153,10050455,NULL,NULL,NULL,NULL),(7876,7670,0,'LSQ12hjm','LSQ',47.619625,-16.4936388888889,NULL,NULL,'2012-12-11 02:37:06',56272.1091,15.0353,0.0368,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjm/LSQ12hjm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjm/LSQ12hjm_snap_83365.gif',38111401116,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,595490642,9304541,NULL,NULL,NULL,NULL),(7877,7708,0,'LSQ12hjq','LSQ',37.16125,-11.6393333333333,NULL,NULL,'2012-12-11 03:11:39',56272.1331000002,19.5118,0.1117,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_snap_83358.gif',37867077887,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,591673091,9244892,NULL,NULL,NULL,NULL),(7878,7708,0,'LSQ12hjq','LSQ',37.1613333333333,-11.6393333333333,NULL,NULL,'2012-12-11 04:31:16',56272.1883899998,19.8133,0.1112,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_snap_83359.gif',37867077887,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,591673091,9244892,NULL,NULL,NULL,NULL),(7879,7729,0,'LSQ12hkm','LSQ',56.094125,2.74527777777778,NULL,NULL,'2012-12-11 02:33:37',56272.1066800002,19.9398,0.1425,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_snap_83375.gif',65198525114,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018726954,15917608,NULL,NULL,NULL,NULL),(7880,7729,0,'LSQ12hkm','LSQ',56.0940833333333,2.74533333333333,NULL,NULL,'2012-12-11 04:34:44',56272.1907899999,19.6347,0.1272,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 02:46:14','2012-12-13 02:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_snap_83376.gif',65198525114,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018726954,15917608,NULL,NULL,NULL,NULL),(7892,7892,1,'LSQ12hmk','LSQ',157.968041666667,-11.3061111111111,NULL,NULL,'2012-12-11 06:50:36',56272.2851399998,20.0534,0.145,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 14:46:08','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmk/LSQ12hmk_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmk/LSQ12hmk_snap_83590.gif',41760469595,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,652507337,10195427,NULL,NULL,NULL,NULL),(7893,7892,0,'LSQ12hmk','LSQ',157.968333333333,-11.3058611111111,NULL,NULL,'2012-12-11 07:42:42',56272.3213200001,20.117,0.1261,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 14:46:08','2012-12-13 14:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmk/LSQ12hmk_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmk/LSQ12hmk_snap_83591.gif',41760469595,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,652507337,10195427,NULL,NULL,NULL,NULL),(7894,7894,1,'LSQ12hlz','LSQ',74.4070416666667,-15.3166944444444,NULL,NULL,'2012-12-09 02:58:50',56270.1242,19.8245,0.1564,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 15:46:08','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_83563.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(7895,7894,0,'LSQ12hlz','LSQ',74.40725,-15.3167777777778,NULL,NULL,'2012-12-09 05:02:35',56270.21013,20.7813,0.1806,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 15:46:08','2012-12-16 12:16:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_83564.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(7896,7894,0,'LSQ12hlz','LSQ',74.4072916666667,-15.3168333333333,NULL,NULL,'2012-12-11 02:52:23',56272.1197199998,20.3051,0.1114,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 15:46:08','2012-12-16 12:16:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_83557.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(7897,7894,0,'LSQ12hlz','LSQ',74.4072083333333,-15.3167777777778,NULL,NULL,'2012-12-11 04:51:50',56272.20267,19.6768,0.1036,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 15:46:08','2012-12-16 12:16:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_83558.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(7898,7898,1,'LSQ12hlx','LSQ',169.0105,-20.0354444444444,NULL,NULL,'2012-12-09 07:34:48',56270.3158399998,19.5293,0.0986,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 15:46:08','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlx/LSQ12hlx_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlx/LSQ12hlx_snap_83565.gif',41719311129,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,651864236,10185378,NULL,NULL,NULL,NULL),(7899,7898,0,'LSQ12hlx','LSQ',169.01075,-20.0352777777778,NULL,NULL,'2012-12-11 06:28:29',56272.2697899998,18.7743,0.0397,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 15:46:08','2012-12-13 15:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlx/LSQ12hlx_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlx/LSQ12hlx_snap_83553.gif',41719311014,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,651864234,10185378,NULL,NULL,NULL,NULL),(7900,7898,0,'LSQ12hlx','LSQ',169.011083333333,-20.0353333333333,NULL,NULL,'2012-12-11 07:54:35',56272.3295800001,18.7383,0.0365,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 15:46:08','2012-12-13 15:46:08','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlx/LSQ12hlx_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlx/LSQ12hlx_snap_83554.gif',41719311014,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,651864234,10185378,NULL,NULL,NULL,NULL),(7901,7901,1,'LSQ12hna','LSQ',149.632541666667,5.03886111111111,NULL,NULL,'2012-12-11 06:02:55',56272.2520300001,19.9144,0.1468,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hna/LSQ12hna_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hna/LSQ12hna_snap_83622.gif',60906174032,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,951658969,14869671,NULL,NULL,NULL,NULL),(7902,7901,0,'LSQ12hna','LSQ',149.632583333333,5.03883333333333,NULL,NULL,'2012-12-11 07:23:30',56272.3079900001,20.0029,0.1305,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hna/LSQ12hna_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hna/LSQ12hna_snap_83623.gif',60906174304,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,951658973,14869671,NULL,NULL,NULL,NULL),(7903,7903,1,'LSQ12hmz','LSQ',58.745375,3.99697222222222,NULL,NULL,'2012-11-12 03:03:37',56243.1275200001,19.0606,0.1653,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmz/LSQ12hmz_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmz/LSQ12hmz_snap_83706.gif',65203589994,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018806093,15918845,NULL,NULL,NULL,NULL),(7904,7903,0,'LSQ12hmz','LSQ',58.745625,3.99705555555556,NULL,NULL,'2012-11-16 02:13:00',56247.0923700002,18.8904,0.2071,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmz/LSQ12hmz_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmz/LSQ12hmz_snap_83707.gif',65203589994,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018806093,15918845,NULL,NULL,NULL,NULL),(7905,7903,0,'LSQ12hmz','LSQ',58.7454583333333,3.99641666666667,NULL,NULL,'2012-11-22 01:48:57',56253.0756700002,18.3671,0.196,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmz/LSQ12hmz_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmz/LSQ12hmz_snap_83708.gif',65203589995,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018806093,15918845,NULL,NULL,NULL,NULL),(7906,7903,0,'LSQ12hmz','LSQ',58.745375,3.99680555555556,NULL,NULL,'2012-12-05 04:52:58',56266.20346,19.3404,0.2171,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmz/LSQ12hmz_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmz/LSQ12hmz_snap_83709.gif',65203589994,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018806093,15918845,NULL,NULL,NULL,NULL),(7907,7903,0,'LSQ12hmz','LSQ',58.7455,3.99683333333333,NULL,NULL,'2012-12-11 02:35:19',56272.1078599999,18.8527,0.153,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmz/LSQ12hmz_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmz/LSQ12hmz_snap_83620.gif',65203589994,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018806093,15918845,NULL,NULL,NULL,NULL),(7908,7903,0,'LSQ12hmz','LSQ',58.7454583333333,3.99680555555556,NULL,NULL,'2012-12-11 04:36:26',56272.19197,18.8048,0.1625,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmz/LSQ12hmz_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmz/LSQ12hmz_snap_83621.gif',65203589994,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018806093,15918845,NULL,NULL,NULL,NULL),(7909,7909,1,'LSQ12hmy','LSQ',136.547333333333,-2.21358333333333,NULL,NULL,'2012-12-09 05:15:21',56270.219,20.3762,0.1342,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_snap_83705.gif',42146871440,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,658544866,10289763,NULL,NULL,NULL,NULL),(7910,7909,0,'LSQ12hmy','LSQ',136.547208333333,-2.21366666666667,NULL,NULL,'2012-12-11 05:12:02',56272.2167000002,20.4148,0.1663,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_snap_83618.gif',42146871443,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,658544866,10289763,NULL,NULL,NULL,NULL),(7911,7909,0,'LSQ12hmy','LSQ',136.547333333333,-2.21369444444444,NULL,NULL,'2012-12-11 06:54:00',56272.2875000001,20.2308,0.1494,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_snap_83619.gif',42146871440,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,658544866,10289763,NULL,NULL,NULL,NULL),(7912,7912,1,'LSQ12hmv','LSQ',158.38625,-3.44944444444444,NULL,NULL,'2012-12-07 06:43:48',56268.2804200002,19.9578,0.1705,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmv/LSQ12hmv_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmv/LSQ12hmv_snap_83702.gif',41757113524,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,652454898,10194607,NULL,NULL,NULL,NULL),(7913,7912,0,'LSQ12hmv','LSQ',158.386208333333,-3.44952777777778,NULL,NULL,'2012-12-09 07:48:20',56270.3252400002,20.2884,0.13,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmv/LSQ12hmv_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmv/LSQ12hmv_snap_83703.gif',41757113524,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,652454898,10194607,NULL,NULL,NULL,NULL),(7914,7912,0,'LSQ12hmv','LSQ',158.386208333333,-3.44938888888889,NULL,NULL,'2012-12-11 08:16:40',56272.34491,20.0698,0.1434,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmv/LSQ12hmv_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmv/LSQ12hmv_snap_83612.gif',41757113524,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,652454898,10194607,NULL,NULL,NULL,NULL),(7915,7912,0,'LSQ12hmv','LSQ',158.386083333333,-3.44941666666667,NULL,NULL,'2012-12-11 08:25:31',56272.3510599998,20.1013,0.1309,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmv/LSQ12hmv_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmv/LSQ12hmv_snap_83613.gif',41757113524,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,652454898,10194607,NULL,NULL,NULL,NULL),(7916,7916,1,'LSQ12hmu','LSQ',146.83725,-4.90363888888889,NULL,NULL,'2012-12-01 06:08:24',56262.2558400002,18.991,0.1522,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmu/LSQ12hmu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmu/LSQ12hmu_snap_83696.gif',41294257290,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645222770,10081605,NULL,NULL,NULL,NULL),(7917,7916,0,'LSQ12hmu','LSQ',146.837375,-4.90369444444444,NULL,NULL,'2012-12-01 08:04:24',56262.3363899998,19.3467,0.1711,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmu/LSQ12hmu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmu/LSQ12hmu_snap_83697.gif',41294257290,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645222770,10081605,NULL,NULL,NULL,NULL),(7918,7916,0,'LSQ12hmu','LSQ',146.837416666667,-4.90363888888889,NULL,NULL,'2012-12-03 05:58:19',56264.24884,19.4519,0.1458,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmu/LSQ12hmu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmu/LSQ12hmu_snap_83698.gif',41294257290,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645222770,10081605,NULL,NULL,NULL,NULL),(7919,7916,0,'LSQ12hmu','LSQ',146.837375,-4.90372222222222,NULL,NULL,'2012-12-03 07:17:30',56264.30382,19.2675,0.1139,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmu/LSQ12hmu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmu/LSQ12hmu_snap_83699.gif',41294257290,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645222770,10081605,NULL,NULL,NULL,NULL),(7920,7916,0,'LSQ12hmu','LSQ',146.837375,-4.90361111111111,NULL,NULL,'2012-12-07 05:45:16',56268.2397799999,19.4109,0.1727,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmu/LSQ12hmu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmu/LSQ12hmu_snap_83700.gif',41294257290,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645222770,10081605,NULL,NULL,NULL,NULL),(7921,7916,0,'LSQ12hmu','LSQ',146.8375,-4.90375,NULL,NULL,'2012-12-09 07:04:47',56270.2949999999,20.2805,0.154,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmu/LSQ12hmu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmu/LSQ12hmu_snap_83701.gif',41294257290,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645222770,10081605,NULL,NULL,NULL,NULL),(7922,7916,0,'LSQ12hmu','LSQ',146.837458333333,-4.90377777777778,NULL,NULL,'2012-12-11 05:25:47',56272.2262400002,19.9536,0.1482,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmu/LSQ12hmu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmu/LSQ12hmu_snap_83610.gif',41294257290,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645222770,10081605,NULL,NULL,NULL,NULL),(7923,7916,0,'LSQ12hmu','LSQ',146.837416666667,-4.90363888888889,NULL,NULL,'2012-12-11 07:00:51',56272.29226,19.6839,0.1399,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmu/LSQ12hmu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmu/LSQ12hmu_snap_83611.gif',41294257290,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645222770,10081605,NULL,NULL,NULL,NULL),(7924,7924,1,'LSQ12hmt','LSQ',142.852125,-5.20355555555556,NULL,NULL,'2012-12-11 05:08:39',56272.21435,19.2103,0.1473,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmt/LSQ12hmt_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmt/LSQ12hmt_snap_83608.gif',41123772058,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,642558938,10039983,NULL,NULL,NULL,NULL),(7925,7924,0,'LSQ12hmt','LSQ',142.852166666667,-5.20361111111111,NULL,NULL,'2012-12-11 06:52:18',56272.28633,19.2452,0.1298,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmt/LSQ12hmt_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmt/LSQ12hmt_snap_83609.gif',41123772058,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,642558938,10039983,NULL,NULL,NULL,NULL),(7926,7926,1,'LSQ12hmm','LSQ',167.450333333333,-10.5910833333333,NULL,NULL,'2012-12-11 08:08:07',56272.33898,19.455,0.0801,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmm/LSQ12hmm_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmm/LSQ12hmm_snap_83594.gif',40886673516,NULL,NULL,NULL,'2012-05-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638854273,9982098,NULL,NULL,NULL,NULL),(7927,7926,0,'LSQ12hmm','LSQ',167.450208333333,-10.5910277777778,NULL,NULL,'2012-12-11 08:32:21',56272.3558100001,19.202,0.1059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmm/LSQ12hmm_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmm/LSQ12hmm_snap_83595.gif',40886673516,NULL,NULL,NULL,'2012-05-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638854273,9982098,NULL,NULL,NULL,NULL),(7928,7928,1,'LSQ12hmj','LSQ',149.863041666667,-7.89502777777778,NULL,NULL,'2012-12-11 06:45:31',56272.2816099999,18.6405,0.0818,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmj/LSQ12hmj_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmj/LSQ12hmj_snap_83588.gif',41333584061,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645837250,10091207,NULL,NULL,NULL,NULL),(7929,7928,0,'LSQ12hmj','LSQ',149.862875,-7.89519444444444,NULL,NULL,'2012-12-11 07:46:05',56272.3236699998,18.5211,0.0775,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmj/LSQ12hmj_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmj/LSQ12hmj_snap_83589.gif',41333584061,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645837250,10091207,NULL,NULL,NULL,NULL),(7930,7930,1,'LSQ12hmh','LSQ',147.713291666667,-9.60736111111111,NULL,NULL,'2012-12-11 05:18:54',56272.2214600001,19.0881,0.1553,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmh/LSQ12hmh_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmh/LSQ12hmh_snap_83584.gif',41328687980,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645760749,10090011,NULL,NULL,NULL,NULL),(7931,7930,0,'LSQ12hmh','LSQ',147.713375,-9.60741666666667,NULL,NULL,'2012-12-11 06:57:23',56272.2898499998,18.815,0.1223,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmh/LSQ12hmh_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmh/LSQ12hmh_snap_83585.gif',41328687980,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645760749,10090011,NULL,NULL,NULL,NULL),(7932,7932,1,'LSQ12hmd','LSQ',37.54,-8.60958333333333,NULL,NULL,'2012-12-11 03:09:58',56272.1319300001,19.0506,0.047,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmd/LSQ12hmd_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmd/LSQ12hmd_snap_83576.gif',34945554429,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546024287,8531629,NULL,NULL,NULL,NULL),(7933,7932,0,'LSQ12hmd','LSQ',37.5398333333333,-8.60936111111111,NULL,NULL,'2012-12-11 03:13:20',56272.1342699998,19.0072,0.044,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmd/LSQ12hmd_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmd/LSQ12hmd_snap_83577.gif',34945554429,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546024287,8531629,NULL,NULL,NULL,NULL),(7934,7934,1,'LSQ12hmc','LSQ',168.302958333333,-12.3910833333333,NULL,NULL,'2012-12-09 06:30:55',56270.2714800001,20.2856,0.2026,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmc/LSQ12hmc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmc/LSQ12hmc_snap_83625.gif',41691785886,NULL,NULL,NULL,'2012-06-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651434154,10178658,NULL,NULL,NULL,NULL),(7935,7934,0,'LSQ12hmc','LSQ',168.302916666667,-12.3909444444444,NULL,NULL,'2012-12-11 06:42:08',56272.2792600002,20.8698,0.141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmc/LSQ12hmc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmc/LSQ12hmc_snap_83574.gif',41691785886,NULL,NULL,NULL,'2012-06-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651434154,10178658,NULL,NULL,NULL,NULL),(7936,7934,0,'LSQ12hmc','LSQ',168.302875,-12.3911111111111,NULL,NULL,'2012-12-11 07:47:46',56272.3248399999,20.9721,0.1671,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmc/LSQ12hmc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmc/LSQ12hmc_snap_83575.gif',41691785886,NULL,NULL,NULL,'2012-06-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651434154,10178658,NULL,NULL,NULL,NULL),(7937,7937,1,'LSQ12hmb','LSQ',151.36775,-13.1326111111111,NULL,NULL,'2012-12-03 08:12:36',56264.3420899999,20.3129,0.2034,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_snap_83572.gif',41162875502,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643169929,10049530,NULL,NULL,NULL,NULL),(7938,7937,0,'LSQ12hmb','LSQ',151.367416666667,-13.1325277777778,NULL,NULL,'2012-12-07 07:05:47',56268.2956900001,19.8163,0.1618,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_snap_83573.gif',41162875500,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643169929,10049530,NULL,NULL,NULL,NULL),(7939,7937,0,'LSQ12hmb','LSQ',151.367041666667,-13.1323611111111,NULL,NULL,'2012-12-09 07:01:23',56270.29263,18.8075,0.153,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_snap_83624.gif',41162875493,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643169929,10049530,NULL,NULL,NULL,NULL),(7940,7937,0,'LSQ12hmb','LSQ',151.367666666667,-13.1325,NULL,NULL,'2012-12-11 05:15:31',56272.21912,20.2491,0.1492,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_snap_83561.gif',41162875494,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643169929,10049530,NULL,NULL,NULL,NULL),(7941,7937,0,'LSQ12hmb','LSQ',151.367916666667,-13.1325,NULL,NULL,'2012-12-11 07:07:41',56272.2970099999,18.8421,0.1619,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_snap_83562.gif',41162875494,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643169929,10049530,NULL,NULL,NULL,NULL),(7942,7942,1,'LSQ12hly','LSQ',46.9032916666667,-15.0358611111111,NULL,NULL,'2012-11-16 02:18:52',56247.09644,19.8583,0.1258,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hly/LSQ12hly_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hly/LSQ12hly_snap_83566.gif',38072903610,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594889118,9295142,NULL,NULL,NULL,NULL),(7943,7942,0,'LSQ12hly','LSQ',46.903125,-15.0360277777778,NULL,NULL,'2012-11-16 04:21:12',56247.18139,20.2105,0.1619,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hly/LSQ12hly_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hly/LSQ12hly_snap_83567.gif',38072903610,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594889118,9295142,NULL,NULL,NULL,NULL),(7944,7942,0,'LSQ12hly','LSQ',46.903375,-15.0359166666667,NULL,NULL,'2012-12-05 02:54:59',56266.12152,19.3923,0.0825,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hly/LSQ12hly_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hly/LSQ12hly_snap_83568.gif',38072903557,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594889118,9295142,NULL,NULL,NULL,NULL),(7945,7942,0,'LSQ12hly','LSQ',46.90325,-15.0359722222222,NULL,NULL,'2012-12-11 02:37:06',56272.1091,20.0032,0.1364,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hly/LSQ12hly_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hly/LSQ12hly_snap_83555.gif',38072903610,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594889118,9295142,NULL,NULL,NULL,NULL),(7946,7942,0,'LSQ12hly','LSQ',46.9033333333333,-15.0359166666667,NULL,NULL,'2012-12-11 04:38:13',56272.1932100002,19.4804,0.1194,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 16:46:21','2012-12-13 16:46:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hly/LSQ12hly_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hly/LSQ12hly_snap_83556.gif',38072903557,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594889118,9295142,NULL,NULL,NULL,NULL),(7947,7947,1,'LSQ12hml','LSQ',165.126916666667,-10.7346666666667,NULL,NULL,'2012-12-09 07:51:56',56270.3277400001,19.3019,0.1146,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 17:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hml/LSQ12hml_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hml/LSQ12hml_snap_83648.gif',41789303135,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,652957861,10202466,NULL,NULL,NULL,NULL),(7948,7947,0,'LSQ12hml','LSQ',165.127541666667,-10.7346111111111,NULL,NULL,'2012-12-11 08:04:45',56272.3366399999,18.9924,0.0772,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 17:46:16','2012-12-13 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hml/LSQ12hml_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hml/LSQ12hml_snap_83592.gif',41789303135,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,652957861,10202466,NULL,NULL,NULL,NULL),(7949,7947,0,'LSQ12hml','LSQ',165.1275,-10.7346388888889,NULL,NULL,'2012-12-11 08:20:03',56272.3472600002,19.0798,0.0794,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 17:46:16','2012-12-13 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hml/LSQ12hml_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hml/LSQ12hml_snap_83593.gif',41789303135,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,652957861,10202466,NULL,NULL,NULL,NULL),(7950,7950,1,'LSQ12hmg','LSQ',45.066375,-10.8630277777778,NULL,NULL,'2012-10-14 06:28:05',56214.26951,19.8886,0.196,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 17:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_snap_83636.gif',37900060497,NULL,NULL,NULL,'2012-10-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592188445,9252944,NULL,NULL,NULL,NULL),(7951,7950,0,'LSQ12hmg','LSQ',45.0670833333333,-10.863,NULL,NULL,'2012-12-07 04:37:42',56268.1928500002,20.3694,0.1769,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 17:46:16','2012-12-13 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_snap_83637.gif',37900060497,NULL,NULL,NULL,'2012-10-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592188445,9252944,NULL,NULL,NULL,NULL),(7952,7950,0,'LSQ12hmg','LSQ',45.0669583333333,-10.8628888888889,NULL,NULL,'2012-12-09 02:28:14',56270.1029400001,19.9494,0.1458,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 17:46:16','2012-12-13 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_snap_83638.gif',37900060497,NULL,NULL,NULL,'2012-10-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592188445,9252944,NULL,NULL,NULL,NULL),(7953,7950,0,'LSQ12hmg','LSQ',45.067,-10.8629166666667,NULL,NULL,'2012-12-09 04:31:35',56270.1886100001,19.923,0.1859,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 17:46:16','2012-12-13 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_snap_83639.gif',37900060497,NULL,NULL,NULL,'2012-10-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592188445,9252944,NULL,NULL,NULL,NULL),(7954,7950,0,'LSQ12hmg','LSQ',45.067,-10.8628333333333,NULL,NULL,'2012-12-11 02:24:49',56272.1005699998,20.1472,0.1647,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 17:46:16','2012-12-13 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_snap_83582.gif',37900060497,NULL,NULL,NULL,'2012-10-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592188445,9252944,NULL,NULL,NULL,NULL),(7955,7950,0,'LSQ12hmg','LSQ',45.067125,-10.8629166666667,NULL,NULL,'2012-12-11 04:24:28',56272.1836600001,19.7652,0.1263,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 17:46:16','2012-12-13 17:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_snap_83583.gif',37900060497,NULL,NULL,NULL,'2012-10-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592188445,9252944,NULL,NULL,NULL,NULL),(7956,5246,0,'LSQ12gln','LSQ',80.7475416666667,-33.4642222222222,NULL,NULL,'2012-12-12 05:45:19',56273.2398100002,18.8887,0.0497,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_83917.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(7957,5246,0,'LSQ12gln','LSQ',80.7475833333333,-33.4642222222222,NULL,NULL,'2012-12-12 07:14:19',56273.30161,18.9732,0.0757,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gln/LSQ12gln_snap_83918.gif',37267966630,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582311978,9098624,NULL,NULL,NULL,NULL),(7958,5550,0,'LSQ12goy','LSQ',68.8834166666667,-26.4606944444444,NULL,NULL,'2012-12-12 06:55:45',56273.2887200001,20.1583,0.1569,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_83990.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(7959,5557,0,'LSQ12gow','LSQ',48.134125,-28.96325,NULL,NULL,'2012-12-12 04:34:21',56273.1905299998,18.4754,0.0819,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_83989.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(7960,5816,0,'LSQ12grj','LSQ',58.0621666666667,-22.1815277777778,NULL,NULL,'2012-12-12 02:54:23',56273.1211100002,18.9491,0.1855,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_history.html','sn?',NULL,0.061819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_snap_84030.gif',37996988353,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593702943,9276608,NULL,NULL,NULL,NULL),(7961,5816,0,'LSQ12grj','LSQ',58.0620833333333,-22.1815,NULL,NULL,'2012-12-12 04:56:23',56273.2058299999,19.1204,0.1719,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_history.html','sn?',NULL,0.061819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_snap_84031.gif',37996988353,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593702943,9276608,NULL,NULL,NULL,NULL),(7962,5823,0,'LSQ12grh','LSQ',48.0765833333333,-24.5529722222222,NULL,NULL,'2012-12-12 02:30:36',56273.1045900001,18.8611,0.0494,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_84025.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(7963,5823,0,'LSQ12grh','LSQ',48.076625,-24.5529722222222,NULL,NULL,'2012-12-12 04:32:40',56273.1893600002,18.7968,0.0365,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_84026.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(7964,5831,0,'LSQ12gra','LSQ',51.1259583333333,-28.2917777777778,NULL,NULL,'2012-12-12 02:33:58',56273.1069299998,19.4868,0.1272,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_84023.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(7965,5831,0,'LSQ12gra','LSQ',51.1260416666667,-28.2917777777778,NULL,NULL,'2012-12-12 04:36:02',56273.1916999999,19.5275,0.1059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_84024.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(7966,5856,0,'LSQ12gsh','LSQ',72.1754583333333,-30.9981388888889,NULL,NULL,'2012-12-12 06:34:09',56273.2737199999,20.0336,0.1688,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_83942.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(7967,5970,0,'LSQ12gti','LSQ',40.0737916666667,-34.4596388888889,NULL,NULL,'2012-12-12 01:59:53',56273.0832600002,17.8599,0.0443,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_83959.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(7968,5970,0,'LSQ12gti','LSQ',40.0738333333333,-34.4596388888889,NULL,NULL,'2012-12-12 04:02:09',56273.1681599999,17.8207,0.0345,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_83960.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(7969,6109,0,'LSQ12gwg','LSQ',71.316625,-29.0706388888889,NULL,NULL,'2012-12-12 06:22:46',56273.2658199999,20.3229,0.1684,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_84013.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(7970,6109,0,'LSQ12gwg','LSQ',71.3166666666667,-29.0706944444444,NULL,NULL,'2012-12-12 06:26:11',56273.2681900002,20.3053,0.1657,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_84014.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(7971,6117,0,'LSQ12gwf','LSQ',31.6621666666667,-31.2921944444444,NULL,NULL,'2012-12-12 01:46:22',56273.07387,18.7192,0.0731,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_history.html','sn?',NULL,0.1321,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_snap_84015.gif',38445793246,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,600715519,9386179,NULL,NULL,NULL,NULL),(7972,6117,0,'LSQ12gwf','LSQ',31.6620833333333,-31.2922222222222,NULL,NULL,'2012-12-12 03:46:28',56273.1572799999,19.6929,0.1418,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_history.html','sn?',NULL,0.1321,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_snap_84016.gif',38445793246,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,600715519,9386179,NULL,NULL,NULL,NULL),(7973,6121,0,'LSQ12gwc','LSQ',55.840125,-26.7371666666667,NULL,NULL,'2012-12-12 03:23:37',56273.1414100002,21.0044,0.1208,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_84006.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(7974,6188,0,'LSQ12gwk','LSQ',44.3659166666667,-25.3956111111111,NULL,NULL,'2012-12-12 02:15:17',56273.0939500001,20.2023,0.2096,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_84020.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(7975,7057,0,'LSQ12gwp','LSQ',35.4772083333333,-34.3143888888889,NULL,NULL,'2012-12-12 03:46:28',56273.1572799999,19.1786,0.0697,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwp/LSQ12gwp_history.html','sn?',NULL,0.0205,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwp/LSQ12gwp_snap_83713.gif',38419063033,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,600297859,9379654,NULL,NULL,NULL,NULL),(7976,7243,0,'LSQ12gzm','LSQ',40.18175,-34.7405,NULL,NULL,'2012-12-12 02:06:50',56273.0880800001,17.7893,0.0596,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_snap_83742.gif',38633055142,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603641486,9431898,NULL,NULL,NULL,NULL),(7977,7243,0,'LSQ12gzm','LSQ',40.1817916666667,-34.7405277777778,NULL,NULL,'2012-12-12 04:09:00',56273.1729199998,18.6986,0.0554,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_snap_83743.gif',38633055142,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603641486,9431898,NULL,NULL,NULL,NULL),(7978,7246,0,'LSQ12gzl','LSQ',41.0289166666667,-37.1565277777778,NULL,NULL,'2012-12-12 04:09:00',56273.1729199998,18.2989,0.0797,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_snap_83793.gif',38634771280,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603668301,9432317,NULL,NULL,NULL,NULL),(7979,7254,0,'LSQ12gzk','LSQ',41.04575,-37.0321111111111,NULL,NULL,'2012-12-12 02:06:50',56273.0880800001,18.3819,0.053,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_snap_83790.gif',38634729855,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603667653,9432307,NULL,NULL,NULL,NULL),(7980,7445,0,'LSQ12heq','LSQ',53.26725,-28.2137777777778,NULL,NULL,'2012-12-12 01:23:28',56273.05797,19.0648,0.0324,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_83844.gif',38581253603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(7981,7445,0,'LSQ12heq','LSQ',53.2672916666667,-28.21375,NULL,NULL,'2012-12-12 03:23:37',56273.1414100002,19.0546,0.0318,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_83845.gif',38581253603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(7982,7456,0,'LSQ12hdn','LSQ',63.7042083333333,-32.2958888888889,NULL,NULL,'2012-12-12 03:06:18',56273.1293799998,19.0527,0.1304,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_snap_83939.gif',37709622209,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589212847,9206450,NULL,NULL,NULL,NULL),(7983,7606,0,'LSQ12hio','LSQ',64.2505416666667,-27.6963055555556,NULL,NULL,'2012-12-12 03:09:40',56273.1317199999,20.3122,0.1244,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_snap_83969.gif',37661993378,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588468646,9194822,NULL,NULL,NULL,NULL),(7984,7606,0,'LSQ12hio','LSQ',64.2505,-27.6963055555556,NULL,NULL,'2012-12-12 05:11:41',56273.2164500002,19.6937,0.1085,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_snap_83970.gif',37661993409,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588468647,9194822,NULL,NULL,NULL,NULL),(7985,7613,0,'LSQ12hje','LSQ',77.170875,-20.9645277777778,NULL,NULL,'2012-12-12 06:00:50',56273.2505899998,18.8519,0.079,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_83842.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(7986,7613,0,'LSQ12hje','LSQ',77.1709166666667,-20.9646111111111,NULL,NULL,'2012-12-12 07:17:42',56273.3039600002,18.8852,0.1135,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_83843.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(7987,7619,0,'LSQ12hja','LSQ',39.6252916666667,-21.3090277777778,NULL,NULL,'2012-12-12 02:03:21',56273.0856699999,19.3466,0.1073,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_snap_83799.gif',37939371955,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592802686,9262541,NULL,NULL,NULL,NULL),(7988,7619,0,'LSQ12hja','LSQ',39.625375,-21.3089722222222,NULL,NULL,'2012-12-12 04:05:30',56273.1704899999,19.3423,0.0988,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_snap_83800.gif',37939371952,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592802686,9262541,NULL,NULL,NULL,NULL),(7989,7751,0,'LSQ12hle','LSQ',61.1044583333333,-29.15775,NULL,NULL,'2012-12-12 04:59:46',56273.2081800001,19.1285,0.0599,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_snap_83858.gif',38530541650,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602039713,9406870,NULL,NULL,NULL,NULL),(7990,7754,0,'LSQ12hkt','LSQ',38.3255,-26.1251666666667,NULL,NULL,'2012-12-12 03:58:45',56273.1658000001,19.5392,0.1608,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkt/LSQ12hkt_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkt/LSQ12hkt_snap_83866.gif',38428087534,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,600438867,9381857,NULL,NULL,NULL,NULL),(7991,7759,0,'LSQ12hlt','LSQ',60.20875,-24.5228888888889,NULL,NULL,'2012-12-12 03:04:37',56273.1282100002,20.6973,0.1389,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_snap_83740.gif',38522137142,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601908392,9404818,NULL,NULL,NULL,NULL),(7992,7759,0,'LSQ12hlt','LSQ',60.20875,-24.5228611111111,NULL,NULL,'2012-12-12 05:06:37',56273.2129299999,20.7261,0.1604,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-13 22:46:15','2012-12-13 22:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_snap_83741.gif',38522137142,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601908392,9404818,NULL,NULL,NULL,NULL),(7993,5813,0,'LSQ12gpw','LSQ',48.2426666666667,-11.7111666666667,NULL,NULL,'2012-12-13 04:31:56',56274.18885,16.4752,0.0135,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_84268.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(7994,5983,0,'LSQ12gul','LSQ',43.03375,-0.0360833333333333,NULL,NULL,'2012-12-13 01:45:54',56274.0735499999,18.8383,0.0592,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_84233.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(7995,5983,0,'LSQ12gul','LSQ',43.0338333333333,-0.0360833333333333,NULL,NULL,'2012-12-13 03:45:17',56274.1564500001,18.7124,0.0454,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_84234.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(7996,5985,0,'LSQ12guj','LSQ',36.2344583333333,5.12113888888889,NULL,NULL,'2012-12-13 03:15:13',56274.1355699999,18.4803,0.0352,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_snap_84237.gif',66894622375,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045228474,16331694,NULL,NULL,NULL,NULL),(7997,5985,0,'LSQ12guj','LSQ',36.2345,5.12116666666667,NULL,NULL,'2012-12-13 04:11:17',56274.1745099998,18.5063,0.0386,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_snap_84238.gif',66894622375,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045228474,16331694,NULL,NULL,NULL,NULL),(7998,5993,0,'LSQ12gtz','LSQ',48.3627083333333,-7.35833333333333,NULL,NULL,'2012-12-13 02:16:39',56274.0948999999,18.8683,0.0624,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_84250.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(7999,5993,0,'LSQ12gtz','LSQ',48.3627916666667,-7.35841666666667,NULL,NULL,'2012-12-13 04:19:51',56274.1804599999,18.7616,0.0543,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_84251.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(8000,5993,0,'LSQ12gtz','LSQ',48.3627916666667,-7.35847222222222,NULL,NULL,'2012-12-13 04:31:56',56274.18885,19.3233,0.0856,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_84249.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(8001,6014,0,'LSQ12gty','LSQ',73.3359166666667,-14.9325277777778,NULL,NULL,'2012-12-13 02:40:39',56274.1115700002,19.4009,0.0582,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_84244.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(8002,6014,0,'LSQ12gty','LSQ',73.3359166666667,-14.9325,NULL,NULL,'2012-12-13 04:43:53',56274.1971499999,19.9187,0.086,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_84245.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(8003,6167,0,'LSQ12gvb','LSQ',46.5283333333333,-2.58222222222222,NULL,NULL,'2012-12-13 01:47:36',56274.07473,19.5134,0.1122,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_84258.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(8004,6204,0,'LSQ12guu','LSQ',24.4695416666667,-16.2694444444444,NULL,NULL,'2012-12-13 03:18:43',56274.1379999998,20.5193,0.1251,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guu/LSQ12guu_history.html','unusual variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guu/LSQ12guu_snap_84257.gif',35192089509,NULL,NULL,NULL,'2012-10-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,549876398,8591818,NULL,NULL,NULL,NULL),(8005,7063,0,'LSQ12gxj','LSQ',43.2390833333333,1.60669444444444,NULL,NULL,'2012-12-13 01:47:36',56274.07473,17.811,0.0409,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_84146.gif',66842134735,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(8006,7071,0,'LSQ12gxd','LSQ',36.0343333333333,-3.46419444444444,NULL,NULL,'2012-12-13 01:21:00',56274.05626,20.2487,0.1683,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_84142.gif',34918978036,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(8007,7071,0,'LSQ12gxd','LSQ',36.0342916666667,-3.46419444444444,NULL,NULL,'2012-12-13 03:22:07',56274.1403700002,19.9874,0.1332,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_84143.gif',34918978036,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(8008,7083,0,'LSQ12gyr','LSQ',43.2101666666667,-7.71233333333333,NULL,NULL,'2012-12-13 04:14:47',56274.1769400002,19.9279,0.1815,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_history.html','sne - nice',NULL,0.11794,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_snap_84122.gif',37909543298,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592336614,9255259,NULL,NULL,NULL,NULL),(8009,7096,0,'LSQ12gyd','LSQ',76.3870833333333,-18.0351666666667,NULL,NULL,'2012-12-13 02:45:43',56274.11509,18.7036,0.0453,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_84131.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(8010,7096,0,'LSQ12gyd','LSQ',76.387125,-18.0351388888889,NULL,NULL,'2012-12-13 04:48:58',56274.2006799998,18.7526,0.0427,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_84132.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(8011,7099,0,'LSQ12gyc','LSQ',41.4586666666667,-17.9293333333333,NULL,NULL,'2012-12-13 02:18:24',56274.0961199999,17.9873,0.0717,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_84128.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(8012,7099,0,'LSQ12gyc','LSQ',41.4586666666667,-17.9293888888889,NULL,NULL,'2012-12-13 04:21:36',56274.1816699998,17.8344,0.0662,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_84129.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(8013,7118,0,'LSQ12gzb','LSQ',37.044625,-5.94611111111111,NULL,NULL,'2012-12-13 01:21:00',56274.05626,20.6288,0.1564,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_84155.gif',34948583494,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(8014,7118,0,'LSQ12gzb','LSQ',37.0447083333333,-5.94613888888889,NULL,NULL,'2012-12-13 03:22:07',56274.1403700002,20.3409,0.1176,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_84156.gif',34948583495,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(8015,7122,0,'LSQ12gza','LSQ',35.893125,-5.90736111111111,NULL,NULL,'2012-12-13 01:21:00',56274.05626,20.2593,0.0921,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_84148.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(8016,7122,0,'LSQ12gza','LSQ',35.892875,-5.90744444444444,NULL,NULL,'2012-12-13 03:22:07',56274.1403700002,20.2631,0.1059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_84149.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(8017,7127,0,'LSQ12gyw','LSQ',28.5180416666667,-10.3499722222222,NULL,NULL,'2012-12-13 03:10:03',56274.1319900001,21.0065,0.1882,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyw/LSQ12gyw_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyw/LSQ12gyw_snap_84150.gif',35111082183,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548610659,8572041,NULL,NULL,NULL,NULL),(8018,7134,0,'LSQ12gyn','LSQ',44.708,-14.9488611111111,NULL,NULL,'2012-12-13 02:25:27',56274.1010099999,20.6589,0.1625,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_84138.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(8019,7134,0,'LSQ12gyn','LSQ',44.7079583333333,-14.9488611111111,NULL,NULL,'2012-12-13 04:28:33',56274.1864999998,20.4979,0.1463,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_84139.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(8020,7326,0,'LSQ12hcm','LSQ',55.5313333333333,4.23163888888889,NULL,NULL,'2012-12-13 02:23:35',56274.0997199998,19.0308,0.0569,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_history.html','sn nice',NULL,0.024457,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_snap_84195.gif',65206467034,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1018851047,15919547,NULL,NULL,NULL,NULL),(8021,7328,0,'LSQ12hcl','LSQ',42.914875,-1.89863888888889,NULL,NULL,'2012-12-13 01:45:54',56274.0735499999,20.0578,0.1284,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_snap_84173.gif',34899428012,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545303562,8520368,NULL,NULL,NULL,NULL),(8022,7328,0,'LSQ12hcl','LSQ',42.9149166666667,-1.89866666666667,NULL,NULL,'2012-12-13 03:45:17',56274.1564500001,20.0609,0.1238,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_snap_84174.gif',34899428012,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545303562,8520368,NULL,NULL,NULL,NULL),(8023,7514,0,'LSQ12hft','LSQ',26.1693333333333,-20.4019444444444,NULL,NULL,'2012-12-13 03:06:40',56274.1296399999,19.7993,0.0849,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hft/LSQ12hft_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hft/LSQ12hft_snap_84199.gif',35040430818,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,547506731,8554792,NULL,NULL,NULL,NULL),(8024,7514,0,'LSQ12hft','LSQ',26.1692916666667,-20.4021388888889,NULL,NULL,'2012-12-13 04:09:29',56274.1732600001,19.8092,0.1025,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hft/LSQ12hft_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hft/LSQ12hft_snap_84200.gif',35040430818,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,547506731,8554792,NULL,NULL,NULL,NULL),(8025,7670,0,'LSQ12hjm','LSQ',47.6195416666667,-16.4935833333333,NULL,NULL,'2012-12-13 02:25:27',56274.1010099999,15.3502,0.0343,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjm/LSQ12hjm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjm/LSQ12hjm_snap_84188.gif',38111401116,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,595490642,9304541,NULL,NULL,NULL,NULL),(8026,7708,0,'LSQ12hjq','LSQ',37.16125,-11.6393333333333,NULL,NULL,'2012-12-13 01:38:35',56274.0684699998,19.3487,0.1207,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_snap_84186.gif',37867077887,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,591673091,9244892,NULL,NULL,NULL,NULL),(8027,7708,0,'LSQ12hjq','LSQ',37.16125,-11.6393611111111,NULL,NULL,'2012-12-13 03:38:02',56274.15142,19.8837,0.1319,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-16 12:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_snap_84187.gif',37867077887,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,591673091,9244892,NULL,NULL,NULL,NULL),(8028,7894,0,'LSQ12hlz','LSQ',74.40725,-15.3166388888889,NULL,NULL,'2012-12-13 02:40:39',56274.1115700002,19.8462,0.1045,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-16 12:16:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_84203.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(8029,7894,0,'LSQ12hlz','LSQ',74.4072916666667,-15.31675,NULL,NULL,'2012-12-13 04:43:53',56274.1971499999,19.9333,0.0985,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-16 12:16:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_84204.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(8030,7903,0,'LSQ12hmz','LSQ',58.7454583333333,3.99675,NULL,NULL,'2012-12-13 02:23:35',56274.0997199998,18.7398,0.1404,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmz/LSQ12hmz_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmz/LSQ12hmz_snap_84227.gif',65203589995,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018806093,15918845,NULL,NULL,NULL,NULL),(8031,7942,0,'LSQ12hly','LSQ',46.9034166666667,-15.0359722222222,NULL,NULL,'2012-12-13 04:28:33',56274.1864999998,20.437,0.193,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hly/LSQ12hly_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hly/LSQ12hly_snap_84205.gif',38072903557,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594889118,9295142,NULL,NULL,NULL,NULL),(8032,7950,0,'LSQ12hmg','LSQ',45.067,-10.8629166666667,NULL,NULL,'2012-12-13 02:13:17',56274.0925599998,20.0858,0.1632,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_snap_84210.gif',37900060497,NULL,NULL,NULL,'2012-10-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592188445,9252944,NULL,NULL,NULL,NULL),(8033,7950,0,'LSQ12hmg','LSQ',45.0672083333333,-10.8629722222222,NULL,NULL,'2012-12-13 04:16:30',56274.1781299999,19.8063,0.1283,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 12:46:10','2012-12-14 12:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_snap_84211.gif',37900060497,NULL,NULL,NULL,'2012-10-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592188445,9252944,NULL,NULL,NULL,NULL),(8042,8042,1,'LSQ12hnl','LSQ',161.640125,-23.0020277777778,NULL,NULL,'2012-12-08 06:11:38',56269.2580800001,18.9293,0.0591,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnl/LSQ12hnl_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnl/LSQ12hnl_snap_84120.gif',41635984665,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650562260,10165035,NULL,NULL,NULL,NULL),(8043,8042,0,'LSQ12hnl','LSQ',161.640166666667,-23.0020277777778,NULL,NULL,'2012-12-10 06:36:26',56271.2753099999,18.0225,0.0212,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnl/LSQ12hnl_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnl/LSQ12hnl_snap_84121.gif',41635984665,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650562260,10165035,NULL,NULL,NULL,NULL),(8044,8042,0,'LSQ12hnl','LSQ',161.640166666667,-23.0020555555556,NULL,NULL,'2012-12-12 06:05:24',56273.2537500001,19.643,0.1004,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnl/LSQ12hnl_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnl/LSQ12hnl_snap_84118.gif',41635984665,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650562260,10165035,NULL,NULL,NULL,NULL),(8045,8042,0,'LSQ12hnl','LSQ',161.640166666667,-23.0019722222222,NULL,NULL,'2012-12-12 08:01:39',56273.3344899998,19.7628,0.0988,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnl/LSQ12hnl_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnl/LSQ12hnl_snap_84119.gif',41635984665,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650562260,10165035,NULL,NULL,NULL,NULL),(8046,8046,1,'LSQ12hnj','LSQ',78.103375,-25.7826666666667,NULL,NULL,'2012-12-10 06:19:07',56271.2632800001,19.5899,0.1011,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_84112.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8047,8046,0,'LSQ12hnj','LSQ',78.103375,-25.7825555555556,NULL,NULL,'2012-12-12 05:47:02',56273.2409999999,16.1983,0.0074,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-16 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_84068.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8048,8046,0,'LSQ12hnj','LSQ',78.1034166666667,-25.7826111111111,NULL,NULL,'2012-12-12 07:10:56',56273.2992699998,16.2663,0.0094,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-16 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_84069.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8049,8049,1,'LSQ12hni','LSQ',53.0507916666667,-26.7004722222222,NULL,NULL,'2012-12-06 01:18:39',56267.0546200001,19.5598,0.1112,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hni/LSQ12hni_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hni/LSQ12hni_snap_84110.gif',38549122897,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602330045,9411406,NULL,NULL,NULL,NULL),(8050,8049,0,'LSQ12hni','LSQ',53.050875,-26.7005555555556,NULL,NULL,'2012-12-10 01:21:56',56271.0569000002,19.246,0.0982,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hni/LSQ12hni_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hni/LSQ12hni_snap_84111.gif',38549122897,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602330045,9411406,NULL,NULL,NULL,NULL),(8051,8049,0,'LSQ12hni','LSQ',53.0506666666667,-26.7006388888889,NULL,NULL,'2012-12-12 01:23:28',56273.05797,19.2757,0.0996,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hni/LSQ12hni_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hni/LSQ12hni_snap_84066.gif',38549122897,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602330045,9411406,NULL,NULL,NULL,NULL),(8052,8049,0,'LSQ12hni','LSQ',53.05075,-26.7005,NULL,NULL,'2012-12-12 03:23:37',56273.1414100002,19.4972,0.1042,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hni/LSQ12hni_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hni/LSQ12hni_snap_84067.gif',38549122897,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602330045,9411406,NULL,NULL,NULL,NULL),(8053,8053,1,'LSQ12hnh','LSQ',53.7745833333333,-26.7650277777778,NULL,NULL,'2012-12-04 01:13:45',56265.0512199998,20.6622,0.1075,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_snap_84105.gif',38579501934,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602804717,9418823,NULL,NULL,NULL,NULL),(8054,8053,0,'LSQ12hnh','LSQ',53.7746666666667,-26.7650555555556,NULL,NULL,'2012-12-04 03:14:04',56265.13478,20.5863,0.1148,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_snap_84106.gif',38579501934,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602804717,9418823,NULL,NULL,NULL,NULL),(8055,8053,0,'LSQ12hnh','LSQ',53.77475,-26.7650277777778,NULL,NULL,'2012-12-08 03:18:39',56269.13796,20.273,0.1023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_snap_84107.gif',38579501934,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602804717,9418823,NULL,NULL,NULL,NULL),(8056,8053,0,'LSQ12hnh','LSQ',53.7746666666667,-26.7650277777778,NULL,NULL,'2012-12-10 01:18:09',56271.0542799998,20.1357,0.0715,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_snap_84108.gif',38579501934,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602804717,9418823,NULL,NULL,NULL,NULL),(8057,8053,0,'LSQ12hnh','LSQ',53.77475,-26.7650833333333,NULL,NULL,'2012-12-10 03:19:11',56271.13833,20.5299,0.1321,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_snap_84109.gif',38579501934,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602804717,9418823,NULL,NULL,NULL,NULL),(8058,8053,0,'LSQ12hnh','LSQ',53.774625,-26.7650277777778,NULL,NULL,'2012-12-12 01:19:48',56273.0554200001,20.5641,0.1276,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_snap_84064.gif',38579501934,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602804717,9418823,NULL,NULL,NULL,NULL),(8059,8053,0,'LSQ12hnh','LSQ',53.7745833333333,-26.765,NULL,NULL,'2012-12-12 03:19:56',56273.1388500002,20.4296,0.1219,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_snap_84065.gif',38579501934,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602804717,9418823,NULL,NULL,NULL,NULL),(8060,8060,1,'LSQ12hng','LSQ',44.052125,-28.8971388888889,NULL,NULL,'2012-12-12 02:23:52',56273.0999099999,19.6383,0.1132,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hng/LSQ12hng_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hng/LSQ12hng_snap_84062.gif',38605877170,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603216830,9425262,NULL,NULL,NULL,NULL),(8061,8060,0,'LSQ12hng','LSQ',44.05225,-28.8971666666667,NULL,NULL,'2012-12-12 04:25:53',56273.1846500002,19.6365,0.1029,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hng/LSQ12hng_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hng/LSQ12hng_snap_84063.gif',38605877170,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603216830,9425262,NULL,NULL,NULL,NULL),(8062,8062,1,'LSQ12hnc','LSQ',41.6077083333333,-33.4245833333333,NULL,NULL,'2012-10-25 05:35:30',56225.2329899999,19.0256,0.1077,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_snap_84077.gif',38638592817,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603728012,9433250,NULL,NULL,NULL,NULL),(8063,8062,0,'LSQ12hnc','LSQ',41.6080416666667,-33.42425,NULL,NULL,'2012-10-26 06:48:35',56226.2837399999,18.5843,0.1403,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_snap_84078.gif',38638592817,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603728012,9433250,NULL,NULL,NULL,NULL),(8064,8062,0,'LSQ12hnc','LSQ',41.6074583333333,-33.4239722222222,NULL,NULL,'2012-11-03 04:42:04',56234.19588,18.8518,0.1807,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_snap_84079.gif',38638592819,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603728012,9433250,NULL,NULL,NULL,NULL),(8065,8062,0,'LSQ12hnc','LSQ',41.60775,-33.4241111111111,NULL,NULL,'2012-11-07 05:38:35',56238.2351299999,18.6185,0.1169,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_snap_84080.gif',38638592819,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603728012,9433250,NULL,NULL,NULL,NULL),(8066,8062,0,'LSQ12hnc','LSQ',41.6075,-33.4243055555556,NULL,NULL,'2012-11-11 04:30:10',56242.18762,19.0026,0.2006,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_snap_84081.gif',38638592817,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603728012,9433250,NULL,NULL,NULL,NULL),(8067,8062,0,'LSQ12hnc','LSQ',41.6074583333333,-33.4244444444444,NULL,NULL,'2012-11-15 04:49:16',56246.2008799999,17.8813,0.1152,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_snap_84082.gif',38638592817,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603728012,9433250,NULL,NULL,NULL,NULL),(8068,8062,0,'LSQ12hnc','LSQ',41.6074166666667,-33.4242777777778,NULL,NULL,'2012-11-17 04:17:06',56248.1785499998,19.7323,0.1096,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_snap_84083.gif',38638592817,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603728012,9433250,NULL,NULL,NULL,NULL),(8069,8062,0,'LSQ12hnc','LSQ',41.6075,-33.4243611111111,NULL,NULL,'2012-11-21 04:07:45',56252.1720500002,18.037,0.1238,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_snap_84084.gif',38638592817,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603728012,9433250,NULL,NULL,NULL,NULL),(8070,8062,0,'LSQ12hnc','LSQ',41.6075416666667,-33.4245277777778,NULL,NULL,'2012-11-23 04:02:11',56254.1681900001,18.7846,0.1181,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_snap_84085.gif',38638592817,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603728012,9433250,NULL,NULL,NULL,NULL),(8071,8062,0,'LSQ12hnc','LSQ',41.6072083333333,-33.4243055555556,NULL,NULL,'2012-11-26 04:24:25',56257.1836299999,19.0005,0.1852,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_snap_84086.gif',38638592817,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603728012,9433250,NULL,NULL,NULL,NULL),(8072,8062,0,'LSQ12hnc','LSQ',41.607375,-33.4242222222222,NULL,NULL,'2012-12-04 02:31:26',56265.1051699999,19.3598,0.1127,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_snap_84087.gif',38638592817,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603728012,9433250,NULL,NULL,NULL,NULL),(8073,8062,0,'LSQ12hnc','LSQ',41.6073333333333,-33.4243611111111,NULL,NULL,'2012-12-10 02:26:13',56271.1015499998,18.5994,0.0854,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_snap_84088.gif',38638592817,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603728012,9433250,NULL,NULL,NULL,NULL),(8074,8062,0,'LSQ12hnc','LSQ',41.6074583333333,-33.4242777777778,NULL,NULL,'2012-12-12 02:13:36',56273.0927800001,18.9245,0.0903,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_snap_84054.gif',38638592817,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603728012,9433250,NULL,NULL,NULL,NULL),(8075,8062,0,'LSQ12hnc','LSQ',41.6074583333333,-33.4245,NULL,NULL,'2012-12-12 04:15:44',56273.1776000001,18.1067,0.1104,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_snap_84055.gif',38638592817,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603728012,9433250,NULL,NULL,NULL,NULL),(8076,8076,1,'LSQ12hnb','LSQ',35.0279583333333,-34.4662777777778,NULL,NULL,'2012-12-08 03:56:05',56269.16395,19.2983,0.0914,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnb/LSQ12hnb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnb/LSQ12hnb_snap_84072.gif',38419272428,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,600301131,9379705,NULL,NULL,NULL,NULL),(8077,8076,0,'LSQ12hnb','LSQ',35.0277916666667,-34.4664444444444,NULL,NULL,'2012-12-12 01:44:41',56273.0726999999,19.8287,0.1609,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnb/LSQ12hnb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnb/LSQ12hnb_snap_84052.gif',38419272428,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,600301131,9379705,NULL,NULL,NULL,NULL),(8078,8076,0,'LSQ12hnb','LSQ',35.0279166666667,-34.4664722222222,NULL,NULL,'2012-12-12 03:44:47',56273.1561099999,19.7928,0.1455,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-14 16:46:13','2012-12-14 16:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnb/LSQ12hnb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnb/LSQ12hnb_snap_84053.gif',38419272428,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,600301131,9379705,NULL,NULL,NULL,NULL),(8096,7894,0,'LSQ12hlz','pessto',74.4070416667,-15.3166944444,NULL,NULL,'2012-12-13 00:00:00',56274,NULL,NULL,NULL,0.11,NULL,'Ia',NULL,'2012-12-16 11:52:23','2012-12-16 12:16:14','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37576938141,'NTT','EFOSC2','YenChen Pan','2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(8097,7432,0,'LSQ12hdl','pessto',53.435125,-30.3177777778,NULL,NULL,'2012-12-11 00:00:00',56272,NULL,NULL,NULL,0.131,NULL,'IIn',NULL,'2012-12-16 11:55:36','2012-12-16 12:16:14','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38573467025,'NTT','EFOSC2','Kate Maguire','2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602710422,9417350,NULL,NULL,NULL,NULL),(8098,7619,0,'LSQ12hja','pessto',39.6253333333,-21.3089722222,NULL,NULL,'2012-12-12 00:00:00',56273,NULL,NULL,NULL,0.162,NULL,'Ia peculiar',NULL,'2012-12-16 12:23:07','2012-12-16 12:46:14','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37939371952,'NTT','EFOSC2','LeGuillou','2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592802686,9262541,NULL,NULL,NULL,NULL),(8099,7708,0,'LSQ12hjq','pessto',37.161375,-11.6393333333,NULL,NULL,'2012-12-12 00:00:00',56273,NULL,NULL,NULL,0.16,NULL,'Ia',NULL,'2012-12-16 12:25:21','2012-12-16 12:46:14','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37867077887,'NTT','EFOSC','LeGuillou','2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,591673091,9244892,NULL,NULL,NULL,NULL),(8100,7751,0,'LSQ12hle','pessto',61.1043333333,-29.1574722222,NULL,NULL,'2012-12-12 00:00:00',56273,NULL,NULL,NULL,0.11,NULL,'Ia',NULL,'2012-12-16 12:26:43','2012-12-16 12:46:14','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38530541650,'NTT','EFOSC2','LeGuillou','2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602039713,9406870,NULL,NULL,NULL,NULL),(8106,8046,0,'LSQ12hnj','atel',78.103375,-25.7826666667,NULL,NULL,'2012-12-15 12:00:00',56276.5,NULL,NULL,NULL,0.0146,NULL,'II',NULL,'2012-12-16 19:17:05','2012-12-16 19:46:19','http://www.astronomerstelegram.org/?read=4650',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37249489794,'UH 2.2m','SNIFS','SNfactory','2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8107,8107,0,'PSNJ06213846-5942506','TOCP',95.41025,-59.7140555555556,NULL,NULL,'2012-12-16 12:00:00',56277.5,14.8,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-12-16 13:32:33','2019-10-12 20:41:36','http://www.cbat.eps.harvard.edu/unconf/followups/J06213846-5942506.html','supernova',NULL,0.00756,NULL,NULL,'https://farm9.staticflickr.com/8207/8278646369_3343fd733b_b.jpg',NULL,NULL,40382256344,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,630972755,9858949,NULL,NULL,NULL,NULL),(8108,5550,0,'LSQ12goy','LSQ',68.8834583333333,-26.4607222222222,NULL,NULL,'2012-12-16 03:07:30',56277.1302100001,20.5468,0.1562,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_84945.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(8109,5550,0,'LSQ12goy','LSQ',68.8833333333333,-26.4606666666667,NULL,NULL,'2012-12-16 05:07:14',56277.2133599999,20.5569,0.1516,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12goy/LSQ12goy_snap_84946.gif',37191018632,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581109666,9079838,NULL,NULL,NULL,NULL),(8110,5557,0,'LSQ12gow','LSQ',48.1341666666667,-28.963,NULL,NULL,'2012-12-16 02:16:22',56277.0947099999,17.9151,0.0657,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gow/LSQ12gow_snap_84941.gif',38543704992,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602245390,9410084,NULL,NULL,NULL,NULL),(8111,5816,0,'LSQ12grj','LSQ',58.062125,-22.1815277777778,NULL,NULL,'2012-12-16 02:37:05',56277.1090899999,18.8069,0.1788,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_history.html','sn?',NULL,0.061819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_snap_84965.gif',37996988353,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593702943,9276608,NULL,NULL,NULL,NULL),(8112,5823,0,'LSQ12grh','LSQ',48.0765833333333,-24.5529444444444,NULL,NULL,'2012-12-16 02:14:40',56277.0935300002,18.9358,0.0527,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_84968.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(8113,5823,0,'LSQ12grh','LSQ',48.076625,-24.553,NULL,NULL,'2012-12-16 04:14:38',56277.1768299998,18.9102,0.0712,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_84969.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(8114,5813,0,'LSQ12gpw','LSQ',48.2427083333333,-11.7111111111111,NULL,NULL,'2012-12-15 04:24:22',56276.18359,16.5784,0.0154,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_84510.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(8115,5856,0,'LSQ12gsh','LSQ',72.1756666666667,-30.9982777777778,NULL,NULL,'2012-12-16 05:19:06',56277.2215999998,18.6864,0.1093,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_84893.gif',37207941504,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581374086,9083970,NULL,NULL,NULL,NULL),(8116,5876,0,'LSQ12gsv','LSQ',71.5319583333333,-25.2667222222222,NULL,NULL,'2012-12-16 05:10:37',56277.2157100001,20.2771,0.1264,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsv/LSQ12gsv_snap_84911.gif',37216350126,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,581505470,9086022,NULL,NULL,NULL,NULL),(8117,5970,0,'LSQ12gti','LSQ',40.0738333333333,-34.4596666666667,NULL,NULL,'2012-12-16 01:44:11',56277.0723600001,17.7551,0.0397,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_84922.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(8118,5970,0,'LSQ12gti','LSQ',40.0738333333333,-34.4596388888889,NULL,NULL,'2012-12-16 03:43:58',56277.1555400002,17.7522,0.0366,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gti/LSQ12gti_snap_84923.gif',38630254105,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603597720,9431214,NULL,NULL,NULL,NULL),(8119,5983,0,'LSQ12gul','LSQ',43.0337916666667,-0.0360555555555556,NULL,NULL,'2012-12-15 01:40:21',56276.0696899998,18.7949,0.0715,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_84468.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(8120,5983,0,'LSQ12gul','LSQ',43.0337916666667,-0.0360833333333333,NULL,NULL,'2012-12-15 03:39:38',56276.1525300001,19.1727,0.0555,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_84469.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(8121,5985,0,'LSQ12guj','LSQ',36.2344583333333,5.12113888888889,NULL,NULL,'2012-12-15 03:19:53',56276.1388099999,18.6544,0.04,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_snap_84466.gif',66894622375,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045228474,16331694,NULL,NULL,NULL,NULL),(8122,5985,0,'LSQ12guj','LSQ',36.2345,5.12116666666667,NULL,NULL,'2012-12-15 04:08:49',56276.1727900002,18.7574,0.0513,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guj/LSQ12guj_snap_84467.gif',66894622375,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1045228474,16331694,NULL,NULL,NULL,NULL),(8123,5991,0,'LSQ12gub','LSQ',145.625416666667,-11.0261111111111,NULL,NULL,'2012-12-15 08:26:37',56276.35182,20.7081,0.1426,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gub/LSQ12gub_history.html','sn?',NULL,0.035244,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gub/LSQ12gub_snap_84494.gif',41306840942,NULL,NULL,NULL,'2012-05-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645419389,10084677,NULL,NULL,NULL,NULL),(8124,5993,0,'LSQ12gtz','LSQ',48.362875,-7.35836111111111,NULL,NULL,'2012-12-15 04:12:12',56276.1751399999,18.6156,0.0667,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_84491.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(8125,5993,0,'LSQ12gtz','LSQ',48.3627916666667,-7.35847222222222,NULL,NULL,'2012-12-15 04:24:22',56276.18359,19.549,0.0997,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_84490.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(8126,6014,0,'LSQ12gty','LSQ',73.3359166666667,-14.9324444444444,NULL,NULL,'2012-12-15 02:35:08',56276.1077399999,19.8395,0.0883,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_84487.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(8127,6014,0,'LSQ12gty','LSQ',73.3359583333333,-14.9326111111111,NULL,NULL,'2012-12-15 04:36:15',56276.1918500001,19.9543,0.0951,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_84488.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(8128,6117,0,'LSQ12gwf','LSQ',31.6621666666667,-31.2923055555556,NULL,NULL,'2012-12-16 03:30:25',56277.1461299998,19.6322,0.1285,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_history.html','sn?',NULL,0.1321,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwf/LSQ12gwf_snap_84958.gif',38445793238,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,600715519,9386179,NULL,NULL,NULL,NULL),(8129,6121,0,'LSQ12gwc','LSQ',55.84,-26.7371666666667,NULL,NULL,'2012-12-16 01:25:05',56277.0590900001,20.6655,0.0932,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_84956.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(8130,6150,0,'LSQ12gvs','LSQ',64.3945416666667,-38.8895833333333,NULL,NULL,'2012-12-16 04:57:01',56277.20627,20.1276,0.0911,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_84944.gif',37791067653,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(8131,6182,0,'LSQ12gwl','LSQ',55.0217916666667,-21.5048055555556,NULL,NULL,'2012-12-16 02:28:14',56277.1029500002,21.1406,0.1487,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_snap_84962.gif',38047180768,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594487199,9288862,NULL,NULL,NULL,NULL),(8132,6182,0,'LSQ12gwl','LSQ',55.0217083333333,-21.5046666666667,NULL,NULL,'2012-12-16 04:28:11',56277.1862499998,20.5351,0.1163,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_snap_84963.gif',38047180768,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594487199,9288862,NULL,NULL,NULL,NULL),(8133,6188,0,'LSQ12gwk','LSQ',44.366,-25.3955277777778,NULL,NULL,'2012-12-16 01:59:27',56277.0829599998,19.5694,0.1169,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_84960.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(8134,6188,0,'LSQ12gwk','LSQ',44.3659583333333,-25.3955277777778,NULL,NULL,'2012-12-16 03:59:22',56277.1662300001,19.8328,0.124,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_84961.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(8135,6155,0,'LSQ12gve','LSQ',51.1100833333333,-11.6691944444444,NULL,NULL,'2012-12-15 02:23:10',56276.0994299999,19.1377,0.0754,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_84508.gif',37885390163,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(8136,6155,0,'LSQ12gve','LSQ',51.109625,-11.6695833333333,NULL,NULL,'2012-12-15 04:24:22',56276.18359,19.9065,0.1615,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_84509.gif',37885390161,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(8137,6167,0,'LSQ12gvb','LSQ',46.5282916666667,-2.58216666666667,NULL,NULL,'2012-12-15 01:42:02',56276.0708599999,19.6526,0.1422,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_84501.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(8138,6177,0,'LSQ12guq','LSQ',39.2717083333333,-20.5101111111111,NULL,NULL,'2012-12-15 03:55:04',56276.1632500002,20.5215,0.1851,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guq/LSQ12guq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guq/LSQ12guq_snap_84495.gif',37939057755,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592797777,9262465,NULL,NULL,NULL,NULL),(8139,7063,0,'LSQ12gxj','LSQ',43.23925,1.60677777777778,NULL,NULL,'2012-12-15 01:42:02',56276.0708599999,17.8073,0.0375,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_84338.gif',66842134734,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(8140,7063,0,'LSQ12gxj','LSQ',43.2391666666667,1.60669444444444,NULL,NULL,'2012-12-15 03:41:21',56276.1537199998,17.6259,0.0315,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_84339.gif',66842134735,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(8141,7071,0,'LSQ12gxd','LSQ',36.0343333333333,-3.46422222222222,NULL,NULL,'2012-12-15 03:21:35',56276.1399900001,20.5908,0.1192,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_84332.gif',34918978036,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(8142,7075,0,'LSQ12gxb','LSQ',142.838958333333,-11.6295833333333,NULL,NULL,'2012-12-15 08:31:41',56276.3553399998,19.3317,0.0855,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_snap_84331.gif',42178887818,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,659045122,10297580,NULL,NULL,NULL,NULL),(8143,7116,0,'LSQ12gzh','LSQ',44.8045833333333,7.26183333333333,NULL,NULL,'2012-12-15 02:54:21',56276.12108,21.029,0.2052,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzh/LSQ12gzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzh/LSQ12gzh_snap_84342.gif',67978103971,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,1062157874,16596216,NULL,NULL,NULL,NULL),(8144,7083,0,'LSQ12gyr','LSQ',43.2102916666667,-7.71222222222222,NULL,NULL,'2012-12-15 02:06:00',56276.08751,20.2403,0.1643,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_history.html','sne - nice',NULL,0.11794,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_snap_84308.gif',37909543298,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592336614,9255259,NULL,NULL,NULL,NULL),(8145,7094,0,'LSQ12gye','LSQ',161.59475,-20.3264444444444,NULL,NULL,'2012-12-15 08:07:49',56276.3387699998,18.0762,0.0172,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gye/LSQ12gye_history.html','possible asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gye/LSQ12gye_snap_84315.gif',41631758262,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650496222,10164003,NULL,NULL,NULL,NULL),(8146,7096,0,'LSQ12gyd','LSQ',76.387125,-18.0351666666667,NULL,NULL,'2012-12-15 02:40:13',56276.1112700002,18.6887,0.0398,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_84320.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(8147,7099,0,'LSQ12gyc','LSQ',41.4586666666667,-17.9293611111111,NULL,NULL,'2012-12-15 02:12:51',56276.0922599998,17.9949,0.0552,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_84321.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(8148,7099,0,'LSQ12gyc','LSQ',41.4587083333333,-17.9293611111111,NULL,NULL,'2012-12-15 04:13:54',56276.1763300002,17.9197,0.0777,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_84322.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(8149,7118,0,'LSQ12gzb','LSQ',37.04475,-5.94608333333333,NULL,NULL,'2012-12-15 01:22:04',56276.057,20.624,0.1068,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_84343.gif',34948583495,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(8150,7122,0,'LSQ12gza','LSQ',35.89325,-5.90730555555556,NULL,NULL,'2012-12-15 01:22:04',56276.057,20.3006,0.09,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_84351.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(8151,7122,0,'LSQ12gza','LSQ',35.8931666666667,-5.90736111111111,NULL,NULL,'2012-12-15 03:21:35',56276.1399900001,20.6205,0.1404,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_84352.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(8152,7131,0,'LSQ12gyv','LSQ',50.4709166666667,-10.0815277777778,NULL,NULL,'2012-12-15 04:22:40',56276.1824099999,18.7985,0.0737,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_snap_84335.gif',37898370242,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592162035,9252531,NULL,NULL,NULL,NULL),(8153,7134,0,'LSQ12gyn','LSQ',44.7080416666667,-14.9488888888889,NULL,NULL,'2012-12-15 02:19:47',56276.0970800002,20.4211,0.1728,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_84329.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(8154,7134,0,'LSQ12gyn','LSQ',44.7082083333333,-14.9489444444444,NULL,NULL,'2012-12-15 04:20:59',56276.1812399998,20.5912,0.211,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_84330.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(8155,7243,0,'LSQ12gzm','LSQ',40.18175,-34.7405,NULL,NULL,'2012-12-16 01:51:00',56277.0770899998,18.7479,0.0674,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_snap_84670.gif',38633055142,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603641486,9431898,NULL,NULL,NULL,NULL),(8156,7243,0,'LSQ12gzm','LSQ',40.18175,-34.7404722222222,NULL,NULL,'2012-12-16 03:50:49',56277.16029,18.6709,0.0616,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_snap_84671.gif',38633055142,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603641486,9431898,NULL,NULL,NULL,NULL),(8157,7246,0,'LSQ12gzl','LSQ',41.029,-37.1564722222222,NULL,NULL,'2012-12-16 03:50:49',56277.16029,19.2128,0.1158,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzl/LSQ12gzl_snap_84717.gif',38634771280,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603668301,9432317,NULL,NULL,NULL,NULL),(8158,7254,0,'LSQ12gzk','LSQ',41.0455833333333,-37.0318611111111,NULL,NULL,'2012-12-16 01:51:00',56277.0770899998,18.5467,0.048,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzk/LSQ12gzk_snap_84719.gif',38634729855,NULL,NULL,NULL,'2012-10-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603667653,9432307,NULL,NULL,NULL,NULL),(8159,7319,0,'LSQ12hco','LSQ',48.6239166666667,-2.691,NULL,NULL,'2012-12-15 01:59:13',56276.0828,20.3395,0.1316,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_snap_84402.gif',36791664995,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574869765,8982340,NULL,NULL,NULL,NULL),(8160,7319,0,'LSQ12hco','LSQ',48.6238333333333,-2.691,NULL,NULL,'2012-12-15 03:58:28',56276.16561,20.4828,0.2004,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_snap_84403.gif',36791664995,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574869765,8982340,NULL,NULL,NULL,NULL),(8161,7326,0,'LSQ12hcm','LSQ',55.5313333333333,4.23166666666667,NULL,NULL,'2012-12-15 02:18:02',56276.0958599998,19.0762,0.053,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_history.html','sn nice',NULL,0.024457,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_snap_84398.gif',65206467034,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1018851047,15919547,NULL,NULL,NULL,NULL),(8162,7326,0,'LSQ12hcm','LSQ',55.531375,4.23166666666667,NULL,NULL,'2012-12-15 04:19:05',56276.1799300001,18.9237,0.0565,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_history.html','sn nice',NULL,0.024457,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_snap_84399.gif',65206467034,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1018851047,15919547,NULL,NULL,NULL,NULL),(8163,7328,0,'LSQ12hcl','LSQ',42.9150833333333,-1.89863888888889,NULL,NULL,'2012-12-15 03:39:38',56276.1525300001,20.4042,0.1269,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcl/LSQ12hcl_snap_84377.gif',34899428012,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545303562,8520368,NULL,NULL,NULL,NULL),(8164,7344,0,'LSQ12hbz','LSQ',160.31675,-14.5202222222222,NULL,NULL,'2012-12-15 07:07:24',56276.2968100002,20.0502,0.1107,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbz/LSQ12hbz_history.html','sn hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbz/LSQ12hbz_snap_84404.gif',41838987260,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653734175,10214596,NULL,NULL,NULL,NULL),(8165,7355,0,'LSQ12hbu','LSQ',152.379166666667,-16.1379722222222,NULL,NULL,'2012-12-15 05:03:50',56276.2110000001,19.1908,0.0646,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbu/LSQ12hbu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbu/LSQ12hbu_snap_84405.gif',41198551021,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643727359,10058239,NULL,NULL,NULL,NULL),(8166,7417,0,'LSQ12hcu','LSQ',59.0956666666667,-36.5750555555556,NULL,NULL,'2012-12-16 02:45:30',56277.1149400002,20.667,0.1343,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_history.html','sn?',NULL,0.07532,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_snap_84752.gif',37679401788,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588740652,9199072,NULL,NULL,NULL,NULL),(8167,7445,0,'LSQ12heq','LSQ',53.2672916666667,-28.2137222222222,NULL,NULL,'2012-12-16 01:25:05',56277.0590900001,19.0117,0.0312,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_84778.gif',38581253603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(8168,7445,0,'LSQ12heq','LSQ',53.2673333333333,-28.21375,NULL,NULL,'2012-12-16 03:24:53',56277.1422899999,19.047,0.0607,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_84779.gif',38581253600,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(8169,7456,0,'LSQ12hdn','LSQ',63.7044166666667,-32.2959166666667,NULL,NULL,'2012-12-16 02:50:36',56277.1184800002,19.7987,0.1975,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_snap_84891.gif',37709622178,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589212846,9206450,NULL,NULL,NULL,NULL),(8170,7507,0,'LSQ12hgj','LSQ',154.207333333333,-16.1958611111111,NULL,NULL,'2012-12-15 05:17:27',56276.22046,20.6727,0.1459,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_snap_84481.gif',41166665804,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643229153,10050455,NULL,NULL,NULL,NULL),(8171,7507,0,'LSQ12hgj','LSQ',154.207375,-16.19575,NULL,NULL,'2012-12-15 06:56:43',56276.28939,20.1633,0.116,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_snap_84482.gif',41166665807,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643229153,10050455,NULL,NULL,NULL,NULL),(8172,7606,0,'LSQ12hio','LSQ',64.2505416666667,-27.69625,NULL,NULL,'2012-12-16 02:53:58',56277.1208199998,20.5792,0.1445,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_snap_84919.gif',37661993378,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588468646,9194822,NULL,NULL,NULL,NULL),(8173,7606,0,'LSQ12hio','LSQ',64.2505,-27.6963055555556,NULL,NULL,'2012-12-16 04:53:40',56277.2039399999,20.2928,0.1336,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_snap_84920.gif',37661993409,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588468647,9194822,NULL,NULL,NULL,NULL),(8174,7613,0,'LSQ12hje','LSQ',77.1707083333333,-20.9645,NULL,NULL,'2012-12-16 05:29:16',56277.22866,18.6969,0.0678,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_84766.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(8175,7613,0,'LSQ12hje','LSQ',77.1707916666667,-20.9645277777778,NULL,NULL,'2012-12-16 07:03:04',56277.2938000001,18.7331,0.0854,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_84767.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(8176,7619,0,'LSQ12hja','LSQ',39.6253333333333,-21.3089166666667,NULL,NULL,'2012-12-16 01:47:34',56277.0747099998,19.4116,0.1127,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_snap_84727.gif',37939371952,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592802686,9262541,NULL,NULL,NULL,NULL),(8177,7619,0,'LSQ12hja','LSQ',39.6253333333333,-21.3089722222222,NULL,NULL,'2012-12-16 03:47:21',56277.1578899999,19.6254,0.1155,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hja/LSQ12hja_snap_84728.gif',37939371952,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592802686,9262541,NULL,NULL,NULL,NULL),(8178,7670,0,'LSQ12hjm','LSQ',47.61975,-16.4936111111111,NULL,NULL,'2012-12-15 02:19:47',56276.0970800002,14.5709,0.0377,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjm/LSQ12hjm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjm/LSQ12hjm_snap_84394.gif',38111401116,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,595490642,9304541,NULL,NULL,NULL,NULL),(8179,7670,0,'LSQ12hjm','LSQ',47.6197083333333,-16.4936666666667,NULL,NULL,'2012-12-15 04:20:59',56276.1812399998,16.059,0.0511,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjm/LSQ12hjm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjm/LSQ12hjm_snap_84395.gif',38111401116,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,595490642,9304541,NULL,NULL,NULL,NULL),(8180,7706,0,'LSQ12hka','LSQ',162.676666666667,-6.84525,NULL,NULL,'2012-12-15 06:34:35',56276.2740199999,20.0809,0.148,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hka/LSQ12hka_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hka/LSQ12hka_snap_84318.gif',41796865596,NULL,NULL,NULL,'2012-05-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,653076024,10204312,NULL,NULL,NULL,NULL),(8181,7706,0,'LSQ12hka','LSQ',162.676708333333,-6.84516666666667,NULL,NULL,'2012-12-15 07:35:29',56276.3163100001,19.9624,0.1286,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hka/LSQ12hka_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hka/LSQ12hka_snap_84319.gif',41796865596,NULL,NULL,NULL,'2012-05-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,653076024,10204312,NULL,NULL,NULL,NULL),(8182,7708,0,'LSQ12hjq','LSQ',37.1612916666667,-11.6393611111111,NULL,NULL,'2012-12-15 03:32:23',56276.1474899999,19.4805,0.1132,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_snap_84389.gif',37867077887,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,591673091,9244892,NULL,NULL,NULL,NULL),(8183,7720,0,'LSQ12hjg','LSQ',35.9072083333333,-19.7131388888889,NULL,NULL,'2012-12-15 01:38:34',56276.0684500001,18.891,0.1092,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjg/LSQ12hjg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjg/LSQ12hjg_snap_84497.gif',37982523854,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593476935,9273077,NULL,NULL,NULL,NULL),(8184,7729,0,'LSQ12hkm','LSQ',56.0941666666667,2.74530555555556,NULL,NULL,'2012-12-15 02:16:21',56276.0946900002,19.4219,0.1077,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_snap_84412.gif',65198525114,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018726954,15917608,NULL,NULL,NULL,NULL),(8185,7729,0,'LSQ12hkm','LSQ',56.0940416666667,2.74530555555556,NULL,NULL,'2012-12-15 04:17:24',56276.17876,19.598,0.1498,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_snap_84413.gif',65198525114,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018726954,15917608,NULL,NULL,NULL,NULL),(8186,7754,0,'LSQ12hkt','LSQ',38.3254166666667,-26.1251666666667,NULL,NULL,'2012-12-16 01:40:47',56277.0699999998,20.1793,0.1618,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkt/LSQ12hkt_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkt/LSQ12hkt_snap_84808.gif',38428087534,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,600438867,9381857,NULL,NULL,NULL,NULL),(8187,7754,0,'LSQ12hkt','LSQ',38.3254583333333,-26.1251388888889,NULL,NULL,'2012-12-16 03:40:34',56277.1531799999,19.8062,0.1779,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkt/LSQ12hkt_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkt/LSQ12hkt_snap_84809.gif',38428087534,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,600438867,9381857,NULL,NULL,NULL,NULL),(8188,7759,0,'LSQ12hlt','LSQ',60.20875,-24.5228888888889,NULL,NULL,'2012-12-16 02:48:54',56277.1173,20.6924,0.2044,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_snap_84667.gif',38522137142,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601908392,9404818,NULL,NULL,NULL,NULL),(8189,7759,0,'LSQ12hlt','LSQ',60.20875,-24.5228055555556,NULL,NULL,'2012-12-16 04:48:36',56277.2004200001,20.9532,0.172,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlt/LSQ12hlt_snap_84668.gif',38522137142,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601908392,9404818,NULL,NULL,NULL,NULL),(8190,7777,0,'LSQ12hkx','LSQ',43.274875,-26.0281111111111,NULL,NULL,'2012-12-16 03:54:12',56277.1626499998,20.8873,0.1835,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkx/LSQ12hkx_history.html','sn',NULL,0.1082,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkx/LSQ12hkx_snap_84807.gif',38420167590,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,600315118,9379923,NULL,NULL,NULL,NULL),(8191,7894,0,'LSQ12hlz','LSQ',74.4073333333333,-15.31675,NULL,NULL,'2012-12-15 02:35:08',56276.1077399999,19.7471,0.0751,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_84477.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(8192,7894,0,'LSQ12hlz','LSQ',74.4073333333333,-15.3167777777778,NULL,NULL,'2012-12-15 04:36:15',56276.1918500001,19.7812,0.0797,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_84478.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(8193,7901,0,'LSQ12hna','LSQ',149.632625,5.03880555555556,NULL,NULL,'2012-12-15 05:46:41',56276.24076,20.3552,0.1516,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hna/LSQ12hna_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hna/LSQ12hna_snap_84432.gif',60906174304,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,951658973,14869671,NULL,NULL,NULL,NULL),(8194,7901,0,'LSQ12hna','LSQ',149.632708333333,5.03877777777778,NULL,NULL,'2012-12-15 07:12:54',56276.30063,19.7665,0.1089,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hna/LSQ12hna_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hna/LSQ12hna_snap_84433.gif',60906174304,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,951658973,14869671,NULL,NULL,NULL,NULL),(8195,7909,0,'LSQ12hmy','LSQ',136.54725,-2.21363888888889,NULL,NULL,'2012-12-15 04:52:24',56276.2030600002,19.7447,0.1765,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_snap_84480.gif',42146871440,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,658544866,10289763,NULL,NULL,NULL,NULL),(8196,7912,0,'LSQ12hmv','LSQ',158.386208333333,-3.44944444444444,NULL,NULL,'2012-12-15 06:29:32',56276.2705100002,20.7359,0.1704,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmv/LSQ12hmv_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmv/LSQ12hmv_snap_84430.gif',41757113524,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,652454898,10194607,NULL,NULL,NULL,NULL),(8197,7912,0,'LSQ12hmv','LSQ',158.38625,-3.44947222222222,NULL,NULL,'2012-12-15 07:45:46',56276.32345,20.6851,0.1597,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmv/LSQ12hmv_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmv/LSQ12hmv_snap_84431.gif',41757113524,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,652454898,10194607,NULL,NULL,NULL,NULL),(8198,7926,0,'LSQ12hmm','LSQ',167.45025,-10.5910833333333,NULL,NULL,'2012-12-15 06:21:00',56276.2645899998,19.1231,0.0597,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmm/LSQ12hmm_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmm/LSQ12hmm_snap_84442.gif',40886673516,NULL,NULL,NULL,'2012-05-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638854273,9982098,NULL,NULL,NULL,NULL),(8199,7926,0,'LSQ12hmm','LSQ',167.450375,-10.5910833333333,NULL,NULL,'2012-12-15 07:50:55',56276.3270299998,19.0284,0.058,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmm/LSQ12hmm_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmm/LSQ12hmm_snap_84443.gif',40886673516,NULL,NULL,NULL,'2012-05-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638854273,9982098,NULL,NULL,NULL,NULL),(8200,7934,0,'LSQ12hmc','LSQ',168.302958333333,-12.3910277777778,NULL,NULL,'2012-12-15 06:07:26',56276.2551699998,21.2526,0.1882,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmc/LSQ12hmc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmc/LSQ12hmc_snap_84474.gif',41691785886,NULL,NULL,NULL,'2012-06-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651434154,10178658,NULL,NULL,NULL,NULL),(8201,7950,0,'LSQ12hmg','LSQ',45.0670416666667,-10.8629166666667,NULL,NULL,'2012-12-15 02:07:42',56276.0886900001,20.2589,0.1836,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmg/LSQ12hmg_snap_84479.gif',37900060497,NULL,NULL,NULL,'2012-10-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592188445,9252944,NULL,NULL,NULL,NULL),(8202,8046,0,'LSQ12hnj','LSQ',78.1033333333333,-25.7825833333333,NULL,NULL,'2012-12-16 05:46:50',56277.2408599998,15.7466,0.0052,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_84851.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8203,8046,0,'LSQ12hnj','LSQ',78.1034583333333,-25.7826111111111,NULL,NULL,'2012-12-16 07:47:34',56277.3247000002,15.6615,0.0096,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_84852.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8204,8049,0,'LSQ12hni','LSQ',53.0507916666667,-26.7005833333333,NULL,NULL,'2012-12-16 01:25:05',56277.0590900001,20.0868,0.1701,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hni/LSQ12hni_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hni/LSQ12hni_snap_84834.gif',38549122897,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602330045,9411406,NULL,NULL,NULL,NULL),(8205,8053,0,'LSQ12hnh','LSQ',53.7745833333333,-26.765,NULL,NULL,'2012-12-16 01:21:24',56277.0565300002,20.6147,0.1451,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_snap_84854.gif',38579501934,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602804717,9418823,NULL,NULL,NULL,NULL),(8206,8053,0,'LSQ12hnh','LSQ',53.7747083333333,-26.7650555555556,NULL,NULL,'2012-12-16 03:21:10',56277.1397099998,20.7153,0.1541,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_snap_84855.gif',38579501934,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602804717,9418823,NULL,NULL,NULL,NULL),(8207,8062,0,'LSQ12hnc','LSQ',41.6073333333333,-33.4241944444444,NULL,NULL,'2012-12-16 01:57:46',56277.0817900002,19.7671,0.1361,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2012-12-16 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_snap_84858.gif',38638592817,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603728012,9433250,NULL,NULL,NULL,NULL),(8208,8208,1,'LSQ12hno','LSQ',55.67975,-2.66913888888889,NULL,NULL,'2012-12-07 04:59:51',56268.20823,19.9092,0.2084,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_84294.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(8209,8208,0,'LSQ12hno','LSQ',55.68025,-2.66947222222222,NULL,NULL,'2012-12-09 02:50:16',56270.1182499998,20.2122,0.165,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2013-01-03 13:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_84295.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(8210,8208,0,'LSQ12hno','LSQ',55.68025,-2.66936111111111,NULL,NULL,'2012-12-11 02:47:15',56272.1161500001,19.1969,0.0959,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2013-01-03 13:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_84296.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(8211,8208,0,'LSQ12hno','LSQ',55.6801666666667,-2.66941666666667,NULL,NULL,'2012-12-11 04:46:42',56272.1990999999,19.1929,0.1054,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2013-01-03 13:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_84297.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(8212,8208,0,'LSQ12hno','LSQ',55.68025,-2.66938888888889,NULL,NULL,'2012-12-13 02:35:33',56274.1080299998,18.5572,0.0504,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2013-01-03 13:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_84292.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(8213,8208,0,'LSQ12hno','LSQ',55.6802916666667,-2.66941666666667,NULL,NULL,'2012-12-13 04:38:42',56274.19355,18.5424,0.0658,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2013-01-03 13:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_84293.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(8214,8208,0,'LSQ12hno','LSQ',55.6803333333333,-2.66944444444444,NULL,NULL,'2012-12-15 02:29:57',56276.10414,18.0565,0.0403,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2013-01-03 13:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_84455.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(8215,8208,0,'LSQ12hno','LSQ',55.6802083333333,-2.66936111111111,NULL,NULL,'2012-12-15 04:31:07',56276.1882799999,17.9807,0.0646,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 20:46:18','2013-01-03 13:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_84456.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(8216,8216,1,'LSQ12hns','LSQ',167.904208333333,-10.7736666666667,NULL,NULL,'2012-12-15 06:22:43',56276.26578,18.6706,0.0486,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hns/LSQ12hns_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hns/LSQ12hns_snap_85013.gif',40886241208,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638847518,9981992,NULL,NULL,NULL,NULL),(8217,8216,0,'LSQ12hns','LSQ',167.904208333333,-10.7736666666667,NULL,NULL,'2012-12-15 07:49:14',56276.3258600002,18.7565,0.0553,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hns/LSQ12hns_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hns/LSQ12hns_snap_85014.gif',40886241208,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638847518,9981992,NULL,NULL,NULL,NULL),(8218,8218,1,'LSQ12hnr','LSQ',160.811666666667,-8.77805555555556,NULL,NULL,'2012-12-09 06:29:13',56270.2703,19.6305,0.1691,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_snap_85017.gif',41807774750,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653246480,10206976,NULL,NULL,NULL,NULL),(8219,8218,0,'LSQ12hnr','LSQ',160.8115,-8.77805555555556,NULL,NULL,'2012-12-09 07:33:06',56270.3146600001,19.7257,0.1726,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_snap_85018.gif',41807774750,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653246480,10206976,NULL,NULL,NULL,NULL),(8220,8218,0,'LSQ12hnr','LSQ',160.811541666667,-8.77805555555556,NULL,NULL,'2012-12-11 07:18:04',56272.3042199998,19.3788,0.1792,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_snap_85019.gif',41807774750,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653246480,10206976,NULL,NULL,NULL,NULL),(8221,8218,0,'LSQ12hnr','LSQ',160.811541666667,-8.778,NULL,NULL,'2012-12-11 07:56:16',56272.3307500002,19.508,0.1561,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_snap_85020.gif',41807774750,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653246480,10206976,NULL,NULL,NULL,NULL),(8222,8218,0,'LSQ12hnr','LSQ',160.811541666667,-8.778,NULL,NULL,'2012-12-15 06:05:45',56276.2540000002,19.0187,0.1027,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_snap_85011.gif',41807774750,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653246480,10206976,NULL,NULL,NULL,NULL),(8223,8218,0,'LSQ12hnr','LSQ',160.811541666667,-8.77797222222222,NULL,NULL,'2012-12-15 07:21:48',56276.30681,19.0366,0.1029,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_snap_85012.gif',41807774750,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653246480,10206976,NULL,NULL,NULL,NULL),(8224,8224,1,'LSQ12hnp','LSQ',27.3408333333333,-14.8349166666667,NULL,NULL,'2012-12-07 03:43:45',56268.15539,20.5669,0.1667,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnp/LSQ12hnp_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnp/LSQ12hnp_snap_85015.gif',35077845874,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548091341,8563927,NULL,NULL,NULL,NULL),(8225,8224,0,'LSQ12hnp','LSQ',27.3409583333333,-14.8347777777778,NULL,NULL,'2012-12-13 04:07:48',56274.17209,19.1889,0.1101,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-16 21:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnp/LSQ12hnp_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnp/LSQ12hnp_snap_85016.gif',35077845874,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548091341,8563927,NULL,NULL,NULL,NULL),(8226,8224,0,'LSQ12hnp','LSQ',27.3407916666667,-14.8346666666667,NULL,NULL,'2012-12-15 02:57:48',56276.1234800001,19.5096,0.1023,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-16 21:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnp/LSQ12hnp_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnp/LSQ12hnp_snap_85007.gif',35077845874,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548091341,8563927,NULL,NULL,NULL,NULL),(8227,8224,0,'LSQ12hnp','LSQ',27.3407916666667,-14.8348611111111,NULL,NULL,'2012-12-15 04:05:19',56276.1703699999,19.4218,0.1111,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-16 21:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnp/LSQ12hnp_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnp/LSQ12hnp_snap_85008.gif',35077845874,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,548091341,8563927,NULL,NULL,NULL,NULL),(8228,8228,1,'LSQ12hon','LSQ',57.893375,-24.2263888888889,NULL,NULL,'2012-12-10 05:06:19',56271.2127299998,19.8269,0.1555,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_85341.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(8229,8228,0,'LSQ12hon','LSQ',57.8935,-24.2264166666667,NULL,NULL,'2012-12-12 02:54:23',56273.1211100002,19.5711,0.182,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_85342.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(8230,8228,0,'LSQ12hon','LSQ',57.8934583333333,-24.2263333333333,NULL,NULL,'2012-12-12 04:56:23',56273.2058299999,19.4957,0.1518,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_85343.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(8231,8228,0,'LSQ12hon','LSQ',57.8934583333333,-24.2264444444444,NULL,NULL,'2012-12-16 02:37:05',56277.1090899999,19.1388,0.1139,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_85062.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(8232,8228,0,'LSQ12hon','LSQ',57.8934583333333,-24.2264166666667,NULL,NULL,'2012-12-16 04:38:21',56277.19331,19.3253,0.1279,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_85063.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(8233,8233,1,'LSQ12hnu','LSQ',56.4027083333333,-37.7379722222222,NULL,NULL,'2012-11-26 04:58:48',56257.2075100001,20.5085,0.1878,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_85083.gif',38557895447,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8234,8233,0,'LSQ12hnu','LSQ',56.4027083333333,-37.7380833333333,NULL,NULL,'2012-11-30 05:13:50',56261.21795,20.1025,0.1822,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-16 21:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_85084.gif',38557895447,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8235,8233,0,'LSQ12hnu','LSQ',56.4025416666667,-37.7380833333333,NULL,NULL,'2012-12-02 03:03:49',56263.1276600002,18.9625,0.097,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-16 21:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_85085.gif',38557895446,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8236,8233,0,'LSQ12hnu','LSQ',56.4025833333333,-37.7380555555556,NULL,NULL,'2012-12-02 05:04:12',56263.2112599998,19.3643,0.0761,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-16 21:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_85086.gif',38557895446,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8237,8233,0,'LSQ12hnu','LSQ',56.4025,-37.7380833333333,NULL,NULL,'2012-12-04 03:05:22',56265.12873,19.0424,0.0675,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-16 21:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_85087.gif',38557895446,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8238,8233,0,'LSQ12hnu','LSQ',56.4025833333333,-37.7380833333333,NULL,NULL,'2012-12-04 05:05:54',56265.2124399999,19.0658,0.0719,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-16 21:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_85088.gif',38557895446,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8239,8233,0,'LSQ12hnu','LSQ',56.4025833333333,-37.7380277777778,NULL,NULL,'2012-12-08 02:56:30',56269.1225700001,18.9828,0.0566,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-16 21:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_85089.gif',38557895447,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8240,8233,0,'LSQ12hnu','LSQ',56.4025833333333,-37.7380277777778,NULL,NULL,'2012-12-08 04:57:11',56269.2063799999,18.8996,0.0354,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-16 21:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_85090.gif',38557895447,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8241,8233,0,'LSQ12hnu','LSQ',56.4025416666667,-37.7380555555556,NULL,NULL,'2012-12-10 03:00:17',56271.1252000001,18.7434,0.0324,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-16 21:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_85091.gif',38557895446,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8242,8233,0,'LSQ12hnu','LSQ',56.4025833333333,-37.7380833333333,NULL,NULL,'2012-12-10 04:59:32',56271.2080100002,18.8427,0.0284,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-16 21:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_85092.gif',38557895446,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8243,8233,0,'LSQ12hnu','LSQ',56.4025416666667,-37.7380277777778,NULL,NULL,'2012-12-12 04:49:35',56273.2011099998,18.6979,0.0329,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-16 21:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_85093.gif',38557895446,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8244,8233,0,'LSQ12hnu','LSQ',56.4025416666667,-37.7380833333333,NULL,NULL,'2012-12-16 02:31:41',56277.1053399998,18.989,0.0333,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-16 21:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_85024.gif',38557895446,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8245,8233,0,'LSQ12hnu','LSQ',56.4025833333333,-37.7380833333333,NULL,NULL,'2012-12-16 04:31:35',56277.1886100001,18.9061,0.0384,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 21:46:20','2012-12-16 21:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_85025.gif',38557895446,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8246,8246,1,'LSQ12hnx','LSQ',38.82425,-30.9638055555556,NULL,NULL,'2012-12-10 04:11:59',56271.1749900002,20.2455,0.2145,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnx/LSQ12hnx_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnx/LSQ12hnx_snap_85106.gif',38436918154,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600576846,9384013,NULL,NULL,NULL,NULL),(8247,8246,0,'LSQ12hnx','LSQ',38.8242083333333,-30.9637222222222,NULL,NULL,'2012-12-12 04:02:09',56273.1681599999,19.8354,0.1804,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2013-01-03 15:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnx/LSQ12hnx_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnx/LSQ12hnx_snap_85107.gif',38436918154,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600576846,9384013,NULL,NULL,NULL,NULL),(8248,8246,0,'LSQ12hnx','LSQ',38.8241666666667,-30.9637222222222,NULL,NULL,'2012-12-16 01:44:11',56277.0723600001,19.7373,0.1616,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2013-01-03 15:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnx/LSQ12hnx_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnx/LSQ12hnx_snap_85030.gif',38436918154,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600576846,9384013,NULL,NULL,NULL,NULL),(8249,8246,0,'LSQ12hnx','LSQ',38.8242083333333,-30.96375,NULL,NULL,'2012-12-16 03:43:58',56277.1555400002,19.3724,0.138,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2013-01-03 15:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnx/LSQ12hnx_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnx/LSQ12hnx_snap_85031.gif',38436918154,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600576846,9384013,NULL,NULL,NULL,NULL),(8250,8250,1,'LSQ12hnv','LSQ',55.3599166666667,-37.8419166666667,NULL,NULL,'2012-12-10 04:59:32',56271.2080100002,21.5515,0.1934,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnv/LSQ12hnv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnv/LSQ12hnv_snap_85094.gif',38557694822,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602463981,9413499,NULL,NULL,NULL,NULL),(8251,8250,0,'LSQ12hnv','LSQ',55.360125,-37.8419166666667,NULL,NULL,'2012-12-16 02:31:41',56277.1053399998,21.0842,0.1578,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2012-12-16 22:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnv/LSQ12hnv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnv/LSQ12hnv_snap_85026.gif',38557694822,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602463981,9413499,NULL,NULL,NULL,NULL),(8252,8250,0,'LSQ12hnv','LSQ',55.360125,-37.8418888888889,NULL,NULL,'2012-12-16 04:31:35',56277.1886100001,20.8445,0.1397,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2012-12-16 22:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnv/LSQ12hnv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnv/LSQ12hnv_snap_85027.gif',38557694822,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602463981,9413499,NULL,NULL,NULL,NULL),(8253,8253,1,'LSQ12hnt','LSQ',40.3975416666667,-38.8374166666667,NULL,NULL,'2012-10-25 06:47:37',56225.2830699999,19.4435,0.1247,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_history.html','sn?',NULL,0.107584,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_snap_85072.gif',38636244303,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603691317,9432676,NULL,NULL,NULL,NULL),(8254,8253,0,'LSQ12hnt','LSQ',40.397375,-38.83725,NULL,NULL,'2012-11-24 02:13:00',56255.0923700002,19.5224,0.1967,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2012-12-16 22:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_history.html','sn?',NULL,0.107584,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_snap_85073.gif',38636244303,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603691317,9432676,NULL,NULL,NULL,NULL),(8255,8253,0,'LSQ12hnt','LSQ',40.397375,-38.83725,NULL,NULL,'2012-11-26 04:16:00',56257.17778,19.4941,0.1641,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2012-12-16 22:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_history.html','sn?',NULL,0.107584,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_snap_85074.gif',38636244303,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603691317,9432676,NULL,NULL,NULL,NULL),(8256,8253,0,'LSQ12hnt','LSQ',40.397375,-38.8375,NULL,NULL,'2012-12-02 02:21:23',56263.0981899998,18.8754,0.0869,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2012-12-16 22:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_history.html','sn?',NULL,0.107584,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_snap_85075.gif',38636244303,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603691317,9432676,NULL,NULL,NULL,NULL),(8257,8253,0,'LSQ12hnt','LSQ',40.3970416666667,-38.8373333333333,NULL,NULL,'2012-12-04 02:22:52',56265.0992200002,19.4662,0.1161,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2012-12-16 22:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_history.html','sn?',NULL,0.107584,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_snap_85076.gif',38636244303,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603691317,9432676,NULL,NULL,NULL,NULL),(8258,8253,0,'LSQ12hnt','LSQ',40.3974583333333,-38.8371388888889,NULL,NULL,'2012-12-06 04:17:11',56267.1786099998,19.8579,0.1299,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2012-12-16 22:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_history.html','sn?',NULL,0.107584,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_snap_85077.gif',38636244301,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603691317,9432676,NULL,NULL,NULL,NULL),(8259,8253,0,'LSQ12hnt','LSQ',40.3972083333333,-38.8374166666667,NULL,NULL,'2012-12-08 02:14:01',56269.0930699999,19.8878,0.2083,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2012-12-16 22:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_history.html','sn?',NULL,0.107584,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_snap_85078.gif',38636244303,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603691317,9432676,NULL,NULL,NULL,NULL),(8260,8253,0,'LSQ12hnt','LSQ',40.397375,-38.8374444444444,NULL,NULL,'2012-12-08 04:14:52',56269.1770000001,19.5247,0.1218,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2012-12-16 22:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_history.html','sn?',NULL,0.107584,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_snap_85079.gif',38636244303,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603691317,9432676,NULL,NULL,NULL,NULL),(8261,8253,0,'LSQ12hnt','LSQ',40.3970416666667,-38.8373888888889,NULL,NULL,'2012-12-10 04:17:09',56271.1785800001,18.8889,0.0804,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2012-12-16 22:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_history.html','sn?',NULL,0.107584,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_snap_85080.gif',38636244303,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603691317,9432676,NULL,NULL,NULL,NULL),(8262,8253,0,'LSQ12hnt','LSQ',40.3975833333333,-38.837,NULL,NULL,'2012-12-12 02:05:09',56273.0869100001,19.8565,0.1789,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2012-12-16 22:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_history.html','sn?',NULL,0.107584,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_snap_85081.gif',38636244301,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603691317,9432676,NULL,NULL,NULL,NULL),(8263,8253,0,'LSQ12hnt','LSQ',40.3972083333333,-38.83725,NULL,NULL,'2012-12-12 04:07:16',56273.17172,19.9607,0.1732,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2012-12-16 22:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_history.html','sn?',NULL,0.107584,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_snap_85082.gif',38636244303,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603691317,9432676,NULL,NULL,NULL,NULL),(8264,8253,0,'LSQ12hnt','LSQ',40.3973333333333,-38.8373055555556,NULL,NULL,'2012-12-16 01:49:18',56277.0759100001,18.5309,0.0695,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2012-12-16 22:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_history.html','sn?',NULL,0.107584,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_snap_85022.gif',38636244303,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603691317,9432676,NULL,NULL,NULL,NULL),(8265,8253,0,'LSQ12hnt','LSQ',40.397125,-38.8371666666667,NULL,NULL,'2012-12-16 03:49:07',56277.15912,19.8735,0.1385,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-16 22:46:16','2012-12-16 22:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_history.html','sn?',NULL,0.107584,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_snap_85023.gif',38636244303,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603691317,9432676,NULL,NULL,NULL,NULL),(8266,8266,1,'LSQ12hov','LSQ',148.308083333333,5.43944444444444,NULL,NULL,'2012-12-15 05:43:01',56276.2382100001,19.5052,0.0516,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hov/LSQ12hov_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hov/LSQ12hov_snap_85387.gif',60907519767,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,951679996,14869999,NULL,NULL,NULL,NULL),(8267,8266,0,'LSQ12hov','LSQ',148.308083333333,5.43947222222222,NULL,NULL,'2012-12-15 07:09:12',56276.2980599999,19.3134,0.0454,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2012-12-17 00:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hov/LSQ12hov_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hov/LSQ12hov_snap_85388.gif',60907519767,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,951679996,14869999,NULL,NULL,NULL,NULL),(8268,8268,1,'LSQ12hou','LSQ',142.378583333333,-1.81841666666667,NULL,NULL,'2012-12-15 05:14:03',56276.2181000002,20.0354,0.1357,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hou/LSQ12hou_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hou/LSQ12hou_snap_85385.gif',41110238256,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,642347472,10036679,NULL,NULL,NULL,NULL),(8269,8268,0,'LSQ12hou','LSQ',142.378625,-1.81844444444444,NULL,NULL,'2012-12-15 06:54:57',56276.2881700001,19.7306,0.1303,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2012-12-17 00:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hou/LSQ12hou_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hou/LSQ12hou_snap_85386.gif',41110238256,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,642347472,10036679,NULL,NULL,NULL,NULL),(8270,8270,1,'LSQ12hot','LSQ',49.4064583333333,0.815972222222222,NULL,NULL,'2012-12-05 04:34:01',56266.1902999999,20.4696,0.181,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hot/LSQ12hot_history.html','sn nice',NULL,0.02409,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hot/LSQ12hot_snap_85391.gif',64969723196,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1015151924,15861748,NULL,NULL,NULL,NULL),(8271,8270,0,'LSQ12hot','LSQ',49.4069583333333,0.816305555555556,NULL,NULL,'2012-12-15 01:59:13',56276.0828,19.8013,0.1149,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2013-01-03 18:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hot/LSQ12hot_history.html','sn nice',NULL,0.02409,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hot/LSQ12hot_snap_85383.gif',64969723199,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1015151924,15861748,NULL,NULL,NULL,NULL),(8272,8270,0,'LSQ12hot','LSQ',49.407,0.816305555555556,NULL,NULL,'2012-12-15 03:58:28',56276.16561,19.9319,0.1046,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2013-01-03 18:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hot/LSQ12hot_history.html','sn nice',NULL,0.02409,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hot/LSQ12hot_snap_85384.gif',64969723199,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1015151924,15861748,NULL,NULL,NULL,NULL),(8273,8273,1,'LSQ12hos','LSQ',161.536666666667,-3.35930555555556,NULL,NULL,'2012-12-09 07:46:38',56270.32406,19.6543,0.129,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hos/LSQ12hos_history.html','sn nice',NULL,0.11097,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hos/LSQ12hos_snap_85389.gif',40876271258,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638691738,9979558,NULL,NULL,NULL,NULL),(8274,8273,0,'LSQ12hos','LSQ',161.53675,-3.35927777777778,NULL,NULL,'2012-12-11 08:35:44',56272.3581500002,19.712,0.1962,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2013-01-12 18:20:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hos/LSQ12hos_history.html','sn nice',NULL,0.11097,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hos/LSQ12hos_snap_85390.gif',40876271258,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638691738,9979558,NULL,NULL,NULL,NULL),(8275,8273,0,'LSQ12hos','LSQ',161.536666666667,-3.35933333333333,NULL,NULL,'2012-12-15 06:32:54',56276.2728499998,19.4238,0.0662,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2013-01-12 18:20:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hos/LSQ12hos_history.html','sn nice',NULL,0.11097,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hos/LSQ12hos_snap_85381.gif',40876271258,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638691738,9979558,NULL,NULL,NULL,NULL),(8276,8273,0,'LSQ12hos','LSQ',161.536708333333,-3.35933333333333,NULL,NULL,'2012-12-15 07:44:04',56276.3222699999,19.43,0.0667,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2013-01-12 18:20:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hos/LSQ12hos_history.html','sn nice',NULL,0.11097,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hos/LSQ12hos_snap_85382.gif',40876271258,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638691738,9979558,NULL,NULL,NULL,NULL),(8277,8277,1,'LSQ12hpa','LSQ',177.646791666667,-23.7582222222222,NULL,NULL,'2012-12-16 06:32:56',56277.2728800001,19.1872,0.1697,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpa/LSQ12hpa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpa/LSQ12hpa_snap_85400.gif',41421504225,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,647211003,10112671,NULL,NULL,NULL,NULL),(8278,8277,0,'LSQ12hpa','LSQ',177.647083333333,-23.7584166666667,NULL,NULL,'2012-12-16 07:37:45',56277.3178900001,18.7613,0.1076,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2012-12-17 00:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpa/LSQ12hpa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpa/LSQ12hpa_snap_85401.gif',41421504225,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,647211003,10112671,NULL,NULL,NULL,NULL),(8279,8279,1,'LSQ12hoy','LSQ',161.318541666667,-25.1102777777778,NULL,NULL,'2012-12-02 07:36:21',56263.3169100001,20.3419,0.2035,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hoy/LSQ12hoy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hoy/LSQ12hoy_snap_85428.gif',41511507626,NULL,NULL,NULL,'2012-05-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,648617306,10134645,NULL,NULL,NULL,NULL),(8280,8279,0,'LSQ12hoy','LSQ',161.318583333333,-25.1101944444444,NULL,NULL,'2012-12-06 06:17:45',56267.2623299998,19.6002,0.1438,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2012-12-17 00:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hoy/LSQ12hoy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hoy/LSQ12hoy_snap_85429.gif',41511507626,NULL,NULL,NULL,'2012-05-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,648617306,10134645,NULL,NULL,NULL,NULL),(8281,8279,0,'LSQ12hoy','LSQ',161.318083333333,-25.1101944444444,NULL,NULL,'2012-12-08 06:11:38',56269.2580800001,19.8526,0.1289,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2012-12-17 00:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hoy/LSQ12hoy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hoy/LSQ12hoy_snap_85430.gif',41511507628,NULL,NULL,NULL,'2012-05-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,648617306,10134645,NULL,NULL,NULL,NULL),(8282,8279,0,'LSQ12hoy','LSQ',161.317958333333,-25.1100555555556,NULL,NULL,'2012-12-12 06:05:24',56273.2537500001,19.2195,0.0869,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2012-12-17 00:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hoy/LSQ12hoy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hoy/LSQ12hoy_snap_85431.gif',41511507628,NULL,NULL,NULL,'2012-05-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,648617306,10134645,NULL,NULL,NULL,NULL),(8283,8279,0,'LSQ12hoy','LSQ',161.317875,-25.1101388888889,NULL,NULL,'2012-12-12 08:01:39',56273.3344899998,19.6023,0.1092,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2012-12-17 00:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hoy/LSQ12hoy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hoy/LSQ12hoy_snap_85432.gif',41511507628,NULL,NULL,NULL,'2012-05-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,648617306,10134645,NULL,NULL,NULL,NULL),(8284,8279,0,'LSQ12hoy','LSQ',161.318,-25.1102222222222,NULL,NULL,'2012-12-16 05:40:31',56277.23648,20.1162,0.1356,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2012-12-17 00:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hoy/LSQ12hoy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hoy/LSQ12hoy_snap_85396.gif',41511507628,NULL,NULL,NULL,'2012-05-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,648617306,10134645,NULL,NULL,NULL,NULL),(8285,8279,0,'LSQ12hoy','LSQ',161.318,-25.1102222222222,NULL,NULL,'2012-12-16 07:09:18',56277.29813,19.8526,0.1306,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2012-12-17 00:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hoy/LSQ12hoy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hoy/LSQ12hoy_snap_85397.gif',41511507628,NULL,NULL,NULL,'2012-05-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,648617306,10134645,NULL,NULL,NULL,NULL),(8286,8286,1,'LSQ12hob','LSQ',38.28925,-30.0961944444444,NULL,NULL,'2012-12-16 01:39:06',56277.0688299998,18.8589,0.1635,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hob/LSQ12hob_history.html','sn?',NULL,0.129091,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hob/LSQ12hob_snap_85038.gif',38438279159,NULL,NULL,NULL,'2012-12-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,600598111,9384345,NULL,NULL,NULL,NULL),(8287,8286,0,'LSQ12hob','LSQ',38.2893333333333,-30.0961111111111,NULL,NULL,'2012-12-16 03:38:53',56277.1520099998,18.6692,0.1192,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 00:46:17','2012-12-17 00:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hob/LSQ12hob_history.html','sn?',NULL,0.129091,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hob/LSQ12hob_snap_85039.gif',38438279158,NULL,NULL,NULL,'2012-12-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,600598111,9384345,NULL,NULL,NULL,NULL),(8288,7071,0,'LSQ12gxd','LSQ',36.0343333333333,-3.46422222222222,NULL,NULL,'2012-12-17 02:58:24',56278.1239,19.914,0.1516,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 12:46:19','2012-12-17 12:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_85456.gif',34918978036,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(8289,7118,0,'LSQ12gzb','LSQ',37.0447083333333,-5.94611111111111,NULL,NULL,'2012-12-17 02:58:24',56278.1239,20.7522,0.111,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 12:46:19','2012-12-17 12:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_85459.gif',34948583495,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(8290,7122,0,'LSQ12gza','LSQ',35.893125,-5.90736111111111,NULL,NULL,'2012-12-17 02:58:24',56278.1239,20.3861,0.1294,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-17 12:46:19','2012-12-17 12:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_85460.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(8358,5816,0,'LSQ12grj','LSQ',58.0620833333333,-22.1815277777778,NULL,NULL,'2012-12-18 04:40:37',56279.1948799998,18.4963,0.1795,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_history.html','sn?',NULL,0.061819,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grj/LSQ12grj_snap_85763.gif',37996988353,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593702943,9276608,NULL,NULL,NULL,NULL),(8359,5823,0,'LSQ12grh','LSQ',48.0766666666667,-24.5529722222222,NULL,NULL,'2012-12-18 02:16:05',56279.0945100002,18.9196,0.0657,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_85767.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(8360,5823,0,'LSQ12grh','LSQ',48.076625,-24.5529444444444,NULL,NULL,'2012-12-18 04:16:47',56279.17833,18.8903,0.0506,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12grh/LSQ12grh_snap_85768.gif',38019012105,NULL,NULL,NULL,'2012-11-17 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594047064,9281985,NULL,NULL,NULL,NULL),(8361,5831,0,'LSQ12gra','LSQ',51.1259583333333,-28.2918055555556,NULL,NULL,'2012-12-18 02:19:28',56279.0968599999,19.7756,0.1591,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_85756.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(8362,5831,0,'LSQ12gra','LSQ',51.1259166666667,-28.2918333333333,NULL,NULL,'2012-12-18 04:20:10',56279.1806800002,20.0817,0.1826,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gra/LSQ12gra_snap_85757.gif',38550841575,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602356899,9411826,NULL,NULL,NULL,NULL),(8363,5856,0,'LSQ12gsh','LSQ',72.1755416666667,-30.9983055555556,NULL,NULL,'2012-12-18 05:21:25',56279.22321,18.7555,0.1263,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_85705.gif',37206102592,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581345353,9083521,NULL,NULL,NULL,NULL),(8364,6109,0,'LSQ12gwg','LSQ',71.3165833333333,-29.0706111111111,NULL,NULL,'2012-12-18 05:24:48',56279.2255600002,20.8127,0.2036,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_85750.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(8365,6121,0,'LSQ12gwc','LSQ',55.840125,-26.7371388888889,NULL,NULL,'2012-12-18 03:54:30',56279.16285,21.4814,0.1396,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_85744.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(8366,6140,0,'LSQ12gvz','LSQ',67.493125,-29.7281944444444,NULL,NULL,'2012-12-18 03:09:55',56279.1318899998,19.9228,0.1202,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvz/LSQ12gvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvz/LSQ12gvz_snap_85746.gif',37657477973,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,588398093,9193720,NULL,NULL,NULL,NULL),(8367,6140,0,'LSQ12gvz','LSQ',67.493,-29.7280833333333,NULL,NULL,'2012-12-18 05:09:29',56279.2149200002,18.3241,0.0507,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvz/LSQ12gvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvz/LSQ12gvz_snap_85747.gif',37657477973,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,588398093,9193720,NULL,NULL,NULL,NULL),(8368,6150,0,'LSQ12gvs','LSQ',64.3945,-38.8896111111111,NULL,NULL,'2012-12-18 02:59:40',56279.1247800002,19.9972,0.1326,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_85734.gif',37791067653,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(8369,6150,0,'LSQ12gvs','LSQ',64.3944583333333,-38.8895833333333,NULL,NULL,'2012-12-18 04:59:18',56279.2078499999,20.3127,0.1204,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_85735.gif',37791067653,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(8370,6188,0,'LSQ12gwk','LSQ',44.3662083333333,-25.3955,NULL,NULL,'2012-12-18 04:01:33',56279.16775,19.5021,0.0884,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_85754.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(8371,7445,0,'LSQ12heq','LSQ',53.26725,-28.21375,NULL,NULL,'2012-12-18 01:52:06',56279.07785,19.0067,0.0354,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_85594.gif',38581253603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(8372,7445,0,'LSQ12heq','LSQ',53.2673333333333,-28.21375,NULL,NULL,'2012-12-18 03:54:30',56279.16285,19.0252,0.0333,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_85595.gif',38581253600,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(8373,7606,0,'LSQ12hio','LSQ',64.2505,-27.6963055555556,NULL,NULL,'2012-12-18 04:55:55',56279.2055000002,20.2454,0.1476,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_snap_85718.gif',37661993409,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588468647,9194822,NULL,NULL,NULL,NULL),(8374,7613,0,'LSQ12hje','LSQ',77.1707083333333,-20.9645277777778,NULL,NULL,'2012-12-18 03:40:26',56279.1530800001,18.3536,0.0493,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_85589.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(8375,7613,0,'LSQ12hje','LSQ',77.17075,-20.9645277777778,NULL,NULL,'2012-12-18 05:48:59',56279.24235,18.6124,0.0646,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_85590.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(8376,7751,0,'LSQ12hle','LSQ',61.104375,-29.15775,NULL,NULL,'2012-12-18 04:44:00',56279.19723,19.0721,0.063,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_snap_85602.gif',38530541650,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602039713,9406870,NULL,NULL,NULL,NULL),(8377,8046,0,'LSQ12hnj','LSQ',78.1032916666667,-25.7825555555556,NULL,NULL,'2012-12-18 03:37:03',56279.1507299999,15.6472,0.0047,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_85650.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8378,8046,0,'LSQ12hnj','LSQ',78.103375,-25.7825833333333,NULL,NULL,'2012-12-18 05:45:36',56279.2400099998,15.5999,0.0044,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_85651.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8379,8053,0,'LSQ12hnh','LSQ',53.7746666666667,-26.7650555555556,NULL,NULL,'2012-12-18 01:48:25',56279.0752900001,20.5109,0.1341,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_snap_85659.gif',38579501934,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602804717,9418823,NULL,NULL,NULL,NULL),(8380,8053,0,'LSQ12hnh','LSQ',53.7746666666667,-26.7650555555556,NULL,NULL,'2012-12-18 03:50:49',56279.16029,20.8634,0.1708,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_snap_85660.gif',38579501934,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602804717,9418823,NULL,NULL,NULL,NULL),(8381,8228,0,'LSQ12hon','LSQ',57.8934583333333,-24.2264722222222,NULL,NULL,'2012-12-18 02:40:56',56279.1117699998,19.5045,0.1419,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_85487.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(8382,8228,0,'LSQ12hon','LSQ',57.8934166666667,-24.2263333333333,NULL,NULL,'2012-12-18 04:40:37',56279.1948799998,19.2699,0.1279,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_85488.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(8383,8233,0,'LSQ12hnu','LSQ',56.402625,-37.7380555555556,NULL,NULL,'2012-12-18 02:33:12',56279.1063899999,18.9623,0.0473,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_85524.gif',38557895447,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8384,8250,0,'LSQ12hnv','LSQ',55.3599583333333,-37.8418333333333,NULL,NULL,'2012-12-18 02:33:12',56279.1063899999,21.1004,0.1823,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 13:46:18','2012-12-18 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnv/LSQ12hnv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnv/LSQ12hnv_snap_85475.gif',38557694822,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602463981,9413499,NULL,NULL,NULL,NULL),(8385,8046,0,'LSQ12hnj','LSQ',78.1026666666667,-25.7826111111111,NULL,NULL,'2012-12-18 03:38:45',56279.15191,15.8482,0.0048,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_85829.gif',37249489805,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8386,8046,0,'LSQ12hnj','LSQ',78.1027083333333,-25.7826111111111,NULL,NULL,'2012-12-18 05:47:17',56279.2411799999,15.8512,0.0047,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_85830.gif',37249489805,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8387,8387,1,'LSQ12hpj','LSQ',72.1001666666667,-31.2976111111111,NULL,NULL,'2012-12-08 05:27:41',56269.22756,19.8751,0.1231,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_snap_85923.gif',37204796368,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581324943,9083202,NULL,NULL,NULL,NULL),(8388,8387,0,'LSQ12hpj','LSQ',72.1000833333333,-31.2976944444444,NULL,NULL,'2012-12-08 07:01:12',56269.2925100001,19.6499,0.2009,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_snap_85924.gif',37204796368,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581324943,9083202,NULL,NULL,NULL,NULL),(8389,8387,0,'LSQ12hpj','LSQ',72.1001666666667,-31.2977222222222,NULL,NULL,'2012-12-10 06:49:45',56271.28455,19.8002,0.13,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_snap_85925.gif',37204796368,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581324943,9083202,NULL,NULL,NULL,NULL),(8390,8387,0,'LSQ12hpj','LSQ',72.1000833333333,-31.2976111111111,NULL,NULL,'2012-12-16 03:19:22',56277.13846,19.6427,0.1311,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_snap_85926.gif',37204796368,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581324943,9083202,NULL,NULL,NULL,NULL),(8391,8387,0,'LSQ12hpj','LSQ',72.1000416666667,-31.2976666666667,NULL,NULL,'2012-12-16 05:19:06',56277.2215999998,19.5387,0.1723,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_snap_85927.gif',37204796368,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581324943,9083202,NULL,NULL,NULL,NULL),(8392,8387,0,'LSQ12hpj','LSQ',72.1000833333333,-31.2976111111111,NULL,NULL,'2012-12-18 03:21:47',56279.1401300002,19.4846,0.1662,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_snap_85809.gif',37204796368,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581324943,9083202,NULL,NULL,NULL,NULL),(8393,8387,0,'LSQ12hpj','LSQ',72.1000833333333,-31.2976111111111,NULL,NULL,'2012-12-18 05:21:25',56279.22321,19.5908,0.1589,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_snap_85810.gif',37204796368,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581324943,9083202,NULL,NULL,NULL,NULL),(8394,8394,1,'LSQ12hpe','LSQ',63.211375,-35.9909722222222,NULL,NULL,'2012-10-25 08:09:40',56225.3400500002,20.6071,0.1531,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_snap_85864.gif',37671088103,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588610751,9197042,NULL,NULL,NULL,NULL),(8395,8394,0,'LSQ12hpe','LSQ',63.212125,-35.9908611111111,NULL,NULL,'2012-11-05 04:48:30',56236.2003500001,19.7512,0.194,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_snap_85865.gif',37671088103,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588610751,9197042,NULL,NULL,NULL,NULL),(8396,8394,0,'LSQ12hpe','LSQ',63.2121666666667,-35.9909444444444,NULL,NULL,'2012-11-05 08:31:37',56236.3552899999,19.2583,0.1749,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_snap_85866.gif',37671088103,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588610751,9197042,NULL,NULL,NULL,NULL),(8397,8394,0,'LSQ12hpe','LSQ',63.2121666666667,-35.9908333333333,NULL,NULL,'2012-11-23 02:40:48',56254.11167,19.3489,0.1596,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_snap_85867.gif',37671088103,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588610751,9197042,NULL,NULL,NULL,NULL),(8398,8394,0,'LSQ12hpe','LSQ',63.212375,-35.9908333333333,NULL,NULL,'2012-11-23 04:41:12',56254.1952800001,19.513,0.1726,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_snap_85868.gif',37671088103,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588610751,9197042,NULL,NULL,NULL,NULL),(8399,8394,0,'LSQ12hpe','LSQ',63.2121666666667,-35.9908888888889,NULL,NULL,'2012-12-02 05:14:46',56263.2185900002,18.8274,0.1279,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_snap_85869.gif',37671088103,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588610751,9197042,NULL,NULL,NULL,NULL),(8400,8394,0,'LSQ12hpe','LSQ',63.212125,-35.9909444444444,NULL,NULL,'2012-12-02 06:55:49',56263.28877,20.1337,0.1706,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_snap_85870.gif',37671088103,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588610751,9197042,NULL,NULL,NULL,NULL),(8401,8394,0,'LSQ12hpe','LSQ',63.2120416666667,-35.9906944444444,NULL,NULL,'2012-12-04 06:08:49',56265.2561300001,18.8467,0.114,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_snap_85871.gif',37671088103,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588610751,9197042,NULL,NULL,NULL,NULL),(8402,8394,0,'LSQ12hpe','LSQ',63.2121666666667,-35.9909166666667,NULL,NULL,'2012-12-04 07:19:16',56265.3050500001,20.1017,0.1671,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_snap_85872.gif',37671088103,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588610751,9197042,NULL,NULL,NULL,NULL),(8403,8394,0,'LSQ12hpe','LSQ',63.212125,-35.9908611111111,NULL,NULL,'2012-12-08 07:31:03',56269.31324,19.0882,0.1205,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_snap_85873.gif',37671088103,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588610751,9197042,NULL,NULL,NULL,NULL),(8404,8394,0,'LSQ12hpe','LSQ',63.2123333333333,-35.9908888888889,NULL,NULL,'2012-12-16 02:57:21',56277.12316,18.9881,0.0928,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_snap_85874.gif',37671088103,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588610751,9197042,NULL,NULL,NULL,NULL),(8405,8394,0,'LSQ12hpe','LSQ',63.212,-35.9911111111111,NULL,NULL,'2012-12-18 02:59:40',56279.1247800002,18.1022,0.0787,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_snap_85799.gif',37671088101,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588610751,9197042,NULL,NULL,NULL,NULL),(8406,8394,0,'LSQ12hpe','LSQ',63.212125,-35.9908611111111,NULL,NULL,'2012-12-18 04:59:18',56279.2078499999,18.6873,0.0983,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 18:48:00','2012-12-18 18:48:00','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpe/LSQ12hpe_snap_85800.gif',37671088103,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,588610751,9197042,NULL,NULL,NULL,NULL),(8407,8046,0,'LSQ12hnj','LSQ',78.1027083333333,-25.7825833333333,NULL,NULL,'2012-12-16 05:48:31',56277.2420299998,16.0226,0.0054,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 19:46:22','2012-12-18 19:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_86043.gif',37249489805,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8408,8408,1,'LSQ12hqa','LSQ',160.241041666667,-21.7816666666667,NULL,NULL,'2012-12-12 08:01:39',56273.3344899998,20.2945,0.148,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 19:46:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_snap_86032.gif',41668171452,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,651065178,10172893,NULL,NULL,NULL,NULL),(8409,8408,0,'LSQ12hqa','LSQ',160.241125,-21.7816944444444,NULL,NULL,'2012-12-16 07:09:18',56277.29813,20.0218,0.1492,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 19:46:22','2012-12-18 19:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_snap_86033.gif',41668171452,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,651065178,10172893,NULL,NULL,NULL,NULL),(8410,8408,0,'LSQ12hqa','LSQ',160.241125,-21.78175,NULL,NULL,'2012-12-18 06:03:55',56279.2527299998,19.8651,0.1432,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 19:46:22','2012-12-18 19:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_snap_85845.gif',41668171452,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,651065178,10172893,NULL,NULL,NULL,NULL),(8411,8408,0,'LSQ12hqa','LSQ',160.24125,-21.7816666666667,NULL,NULL,'2012-12-18 07:40:47',56279.3199999998,19.7457,0.1316,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 19:46:22','2012-12-18 19:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_snap_85846.gif',41668171452,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,651065178,10172893,NULL,NULL,NULL,NULL),(8412,8412,1,'LSQ12hpy','LSQ',79.2732083333333,-24.5449166666667,NULL,NULL,'2012-12-04 07:39:10',56265.3188700001,19.616,0.1557,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 19:46:22','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_snap_86022.gif',37131195893,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580174935,9065233,NULL,NULL,NULL,NULL),(8413,8412,0,'LSQ12hpy','LSQ',79.2731666666667,-24.5448888888889,NULL,NULL,'2012-12-06 05:50:47',56267.2436000002,19.545,0.1002,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 19:46:22','2012-12-18 19:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_snap_86023.gif',37131195893,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580174935,9065233,NULL,NULL,NULL,NULL),(8414,8412,0,'LSQ12hpy','LSQ',79.273125,-24.5448611111111,NULL,NULL,'2012-12-06 07:25:33',56267.3094100002,19.8253,0.1076,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 19:46:22','2012-12-18 19:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_snap_86024.gif',37131195893,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580174935,9065233,NULL,NULL,NULL,NULL),(8415,8412,0,'LSQ12hpy','LSQ',79.2732083333333,-24.5448611111111,NULL,NULL,'2012-12-08 05:46:20',56269.24052,19.7798,0.0938,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 19:46:22','2012-12-18 19:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_snap_86025.gif',37131195893,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580174935,9065233,NULL,NULL,NULL,NULL),(8416,8412,0,'LSQ12hpy','LSQ',79.2731666666667,-24.5448611111111,NULL,NULL,'2012-12-10 06:31:53',56271.2721500001,19.9359,0.0934,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 19:46:22','2012-12-18 19:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_snap_86026.gif',37131195893,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580174935,9065233,NULL,NULL,NULL,NULL),(8417,8412,0,'LSQ12hpy','LSQ',79.2730833333333,-24.5448333333333,NULL,NULL,'2012-12-10 08:02:07',56271.3348099999,20.0173,0.1015,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 19:46:22','2012-12-18 19:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_snap_86027.gif',37131195893,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580174935,9065233,NULL,NULL,NULL,NULL),(8418,8412,0,'LSQ12hpy','LSQ',79.2732083333333,-24.5448611111111,NULL,NULL,'2012-12-12 06:00:50',56273.2505899998,19.826,0.0962,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 19:46:22','2012-12-18 19:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_snap_86028.gif',37131195893,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580174935,9065233,NULL,NULL,NULL,NULL),(8419,8412,0,'LSQ12hpy','LSQ',79.2732083333333,-24.5448611111111,NULL,NULL,'2012-12-12 07:17:42',56273.3039600002,20.1232,0.1258,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 19:46:22','2012-12-18 19:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_snap_86029.gif',37131195893,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580174935,9065233,NULL,NULL,NULL,NULL),(8420,8412,0,'LSQ12hpy','LSQ',79.2730833333333,-24.5449444444444,NULL,NULL,'2012-12-16 05:29:16',56277.22866,20.403,0.115,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 19:46:22','2012-12-18 19:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_snap_86030.gif',37131195893,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580174935,9065233,NULL,NULL,NULL,NULL),(8421,8412,0,'LSQ12hpy','LSQ',79.2730833333333,-24.5448611111111,NULL,NULL,'2012-12-16 07:03:04',56277.2938000001,20.3193,0.1529,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 19:46:22','2012-12-18 19:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_snap_86031.gif',37131195893,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580174935,9065233,NULL,NULL,NULL,NULL),(8422,8412,0,'LSQ12hpy','LSQ',79.2731666666667,-24.5449166666667,NULL,NULL,'2012-12-18 03:40:26',56279.1530800001,20.2524,0.1555,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 19:46:22','2012-12-18 19:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_snap_85841.gif',37131195893,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580174935,9065233,NULL,NULL,NULL,NULL),(8423,8412,0,'LSQ12hpy','LSQ',79.2730833333333,-24.5449166666667,NULL,NULL,'2012-12-18 05:48:59',56279.24235,19.9137,0.1449,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-18 19:46:22','2012-12-18 19:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_snap_85842.gif',37131195893,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580174935,9065233,NULL,NULL,NULL,NULL),(8424,8107,0,'PSNJ06213846-5942506','TOCP',95.41025,-59.71406,NULL,NULL,'2012-12-16 00:00:00',56277,14.8,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-12-19 10:33:53','2012-12-19 10:33:53','http://www.cbat.eps.harvard.edu/unconf/followups/J09491471-4754456.html','supernova',NULL,0.00756,NULL,NULL,'https://farm9.staticflickr.com/8207/8278646369_3343fd733b_b.jpg',NULL,NULL,40382256344,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,630972755,9858949,NULL,NULL,NULL,NULL),(8425,8425,0,'PSNJ09491471-4754456','TOCP',147.31129,-47.91267,NULL,NULL,'2012-12-15 00:00:00',56276,14.5,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-12-19 11:42:44','2019-10-12 20:41:36','http://www.cbat.eps.harvard.edu/unconf/followups/J09491471-4754456.html','supernova',NULL,0.006,NULL,NULL,'http://farm9.staticflickr.com/8496/8295289089_140340ff98_o.jpg',NULL,NULL,42076064057,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,657438500,10272476,NULL,NULL,NULL,NULL),(8426,8426,0,'PSNJ12472930-4319443','TOCP',191.87208,-43.32897,NULL,NULL,'2012-12-16 00:00:00',56277,16.1,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-12-19 11:53:41','2019-10-12 20:41:36','http://www.cbat.eps.harvard.edu/unconf/followups/J12472930-4319443.html','supernova',NULL,0.011,NULL,NULL,'NULL',NULL,NULL,46773787189,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,730840424,11419381,NULL,NULL,NULL,NULL),(8427,8427,1,'PSNJ09351166-1624178','TOCP',143.79858,-16.40494,NULL,NULL,'2012-12-17 00:00:00',56278,19.2,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-12-19 12:08:49','2019-10-11 14:10:04','http://www.cbat.eps.harvard.edu/unconf/followups/J09351166-1624178.html','supernova',NULL,0.0145,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20010841/jpg/108410170694102910_20121217_01_4.jpg',NULL,NULL,42312098601,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,661126540,10330102,NULL,NULL,NULL,NULL),(8428,5813,0,'LSQ12gpw','LSQ',48.2426666666667,-11.7111388888889,NULL,NULL,'2012-12-19 02:51:04',56280.1187999998,16.6727,0.0174,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_86219.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(8429,5813,0,'LSQ12gpw','LSQ',48.2426666666667,-11.7111388888889,NULL,NULL,'2012-12-19 02:54:28',56280.1211600001,16.7019,0.0168,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_history.html','sn -nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gpw/LSQ12gpw_snap_86220.gif',37893397642,NULL,NULL,NULL,'2012-11-14 04:58:04',56245.207,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592084338,9251317,NULL,NULL,NULL,NULL),(8430,5983,0,'LSQ12gul','LSQ',43.0337916666667,-0.0360833333333333,NULL,NULL,'2012-12-19 03:52:52',56280.1617200002,19.0671,0.0705,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_86188.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(8431,5993,0,'LSQ12gtz','LSQ',48.3628333333333,-7.35836111111111,NULL,NULL,'2012-12-19 02:51:04',56280.1187999998,19.6053,0.1081,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_86199.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(8432,5993,0,'LSQ12gtz','LSQ',48.36275,-7.3585,NULL,NULL,'2012-12-19 02:54:28',56280.1211600001,19.0204,0.1087,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_86200.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(8433,5993,0,'LSQ12gtz','LSQ',48.36275,-7.35838888888889,NULL,NULL,'2012-12-19 03:06:31',56280.12953,19.2198,0.1008,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_86201.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(8434,6014,0,'LSQ12gty','LSQ',73.336,-14.9325833333333,NULL,NULL,'2012-12-19 02:28:58',56280.1034499998,19.6872,0.1006,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_86203.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(8435,6014,0,'LSQ12gty','LSQ',73.336,-14.9325833333333,NULL,NULL,'2012-12-19 04:35:30',56280.1913299998,20.0528,0.0921,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_86204.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(8436,6155,0,'LSQ12gve','LSQ',51.10975,-11.6692777777778,NULL,NULL,'2012-12-19 02:51:04',56280.1187999998,18.801,0.1256,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_86214.gif',37885390163,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(8437,6155,0,'LSQ12gve','LSQ',51.1099166666667,-11.6693611111111,NULL,NULL,'2012-12-19 02:54:28',56280.1211600001,20.1748,0.2014,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_86215.gif',37885390161,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(8438,6167,0,'LSQ12gvb','LSQ',46.5284166666667,-2.58216666666667,NULL,NULL,'2012-12-19 03:51:12',56280.1605600002,18.746,0.0926,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_86210.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(8439,6167,0,'LSQ12gvb','LSQ',46.5283333333333,-2.58211111111111,NULL,NULL,'2012-12-19 03:54:33',56280.1628899998,19.4663,0.1115,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvb/LSQ12gvb_snap_86211.gif',37851588750,NULL,NULL,NULL,'2012-10-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591431074,9241110,NULL,NULL,NULL,NULL),(8440,6177,0,'LSQ12guq','LSQ',39.2717916666667,-20.5101388888889,NULL,NULL,'2012-12-19 03:32:25',56280.1475200001,18.8755,0.1072,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guq/LSQ12guq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guq/LSQ12guq_snap_86205.gif',37939057755,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592797777,9262465,NULL,NULL,NULL,NULL),(8441,7063,0,'LSQ12gxj','LSQ',43.2391666666667,1.60675,NULL,NULL,'2012-12-19 03:51:12',56280.1605600002,17.8248,0.036,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_86079.gif',66842134735,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(8442,7063,0,'LSQ12gxj','LSQ',43.239125,1.60675,NULL,NULL,'2012-12-19 03:54:33',56280.1628899998,17.7914,0.0357,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_86080.gif',66842134735,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(8443,7071,0,'LSQ12gxd','LSQ',36.03425,-3.46422222222222,NULL,NULL,'2012-12-19 01:44:32',56280.0726000001,20.3193,0.1874,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_86071.gif',34918978036,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(8444,7071,0,'LSQ12gxd','LSQ',36.0342916666667,-3.46422222222222,NULL,NULL,'2012-12-19 03:25:14',56280.1425299998,20.2222,0.1498,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_history.html','hostless sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxd/LSQ12gxd_snap_86072.gif',34918978036,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,545609031,8525141,NULL,NULL,NULL,NULL),(8445,7096,0,'LSQ12gyd','LSQ',76.387125,-18.0351111111111,NULL,NULL,'2012-12-19 02:34:03',56280.1069800002,18.5321,0.0404,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_86067.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(8446,7096,0,'LSQ12gyd','LSQ',76.387125,-18.0351388888889,NULL,NULL,'2012-12-19 04:44:54',56280.1978500001,18.7714,0.0362,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_86068.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(8447,7099,0,'LSQ12gyc','LSQ',41.458625,-17.9293333333333,NULL,NULL,'2012-12-19 03:04:46',56280.1283200001,18.2721,0.08,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_86066.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(8448,7118,0,'LSQ12gzb','LSQ',37.0446666666667,-5.94605555555556,NULL,NULL,'2012-12-19 01:44:32',56280.0726000001,20.8691,0.1335,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_86090.gif',34948583495,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(8449,7118,0,'LSQ12gzb','LSQ',37.04475,-5.94605555555556,NULL,NULL,'2012-12-19 03:25:14',56280.1425299998,21.0502,0.1433,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzb/LSQ12gzb_snap_86091.gif',34948583495,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,546071617,8532369,NULL,NULL,NULL,NULL),(8450,7122,0,'LSQ12gza','LSQ',35.893125,-5.90733333333333,NULL,NULL,'2012-12-19 01:44:32',56280.0726000001,21.383,0.1824,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_86084.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(8451,7122,0,'LSQ12gza','LSQ',35.893125,-5.90733333333333,NULL,NULL,'2012-12-19 03:25:14',56280.1425299998,20.6258,0.1532,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_86085.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(8452,7131,0,'LSQ12gyv','LSQ',50.4709583333333,-10.0815277777778,NULL,NULL,'2012-12-19 02:52:47',56280.11999,18.8402,0.0795,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_snap_86078.gif',37898370242,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592162035,9252531,NULL,NULL,NULL,NULL),(8453,7134,0,'LSQ12gyn','LSQ',44.708,-14.9488888888889,NULL,NULL,'2012-12-19 02:56:09',56280.1223300002,20.1114,0.1696,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_history.html','sne or variable',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyn/LSQ12gyn_snap_86073.gif',38104396940,NULL,NULL,NULL,'2012-11-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595381202,9302831,NULL,NULL,NULL,NULL),(8454,7319,0,'LSQ12hco','LSQ',48.6240416666667,-2.691,NULL,NULL,'2012-12-19 03:30:36',56280.1462599998,19.9589,0.1872,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hco/LSQ12hco_snap_86136.gif',36791664995,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,574869765,8982340,NULL,NULL,NULL,NULL),(8455,7326,0,'LSQ12hcm','LSQ',55.5312916666667,4.23163888888889,NULL,NULL,'2012-12-19 02:57:58',56280.12359,18.9941,0.0565,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_history.html','sn nice',NULL,0.024457,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_snap_86137.gif',65206467034,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1018851047,15919547,NULL,NULL,NULL,NULL),(8456,7326,0,'LSQ12hcm','LSQ',55.5313333333333,4.23161111111111,NULL,NULL,'2012-12-19 03:01:20',56280.1259300001,18.9299,0.0578,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_history.html','sn nice',NULL,0.024457,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_snap_86138.gif',65206467034,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1018851047,15919547,NULL,NULL,NULL,NULL),(8457,7445,0,'LSQ12heq','LSQ',53.26725,-28.21375,NULL,NULL,'2012-12-19 02:14:23',56280.0933300001,19.01,0.0378,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_86143.gif',38581253603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(8458,7708,0,'LSQ12hjq','LSQ',37.16125,-11.6393888888889,NULL,NULL,'2012-12-19 04:01:50',56280.1679400001,19.7166,0.1383,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_snap_86129.gif',37867077887,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,591673091,9244892,NULL,NULL,NULL,NULL),(8459,7708,0,'LSQ12hjq','LSQ',37.1612916666667,-11.6392777777778,NULL,NULL,'2012-12-19 04:59:07',56280.2077299999,19.6105,0.0978,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_snap_86130.gif',37867077887,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,591673091,9244892,NULL,NULL,NULL,NULL),(8460,7720,0,'LSQ12hjg','LSQ',35.9077916666667,-19.7138333333333,NULL,NULL,'2012-12-19 04:50:31',56280.20175,18.6344,0.1858,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjg/LSQ12hjg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjg/LSQ12hjg_snap_86206.gif',37982523854,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593476935,9273077,NULL,NULL,NULL,NULL),(8461,7729,0,'LSQ12hkm','LSQ',56.0940416666667,2.74527777777778,NULL,NULL,'2012-12-19 02:59:39',56280.12476,19.1776,0.1242,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_snap_86144.gif',65198525114,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018726954,15917608,NULL,NULL,NULL,NULL),(8462,7894,0,'LSQ12hlz','LSQ',74.407125,-15.3166944444444,NULL,NULL,'2012-12-19 02:28:58',56280.1034499998,18.8713,0.0753,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_86195.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(8463,7894,0,'LSQ12hlz','LSQ',74.4072916666667,-15.31675,NULL,NULL,'2012-12-19 04:35:30',56280.1913299998,19.4368,0.0693,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_86196.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(8464,7901,0,'LSQ12hna','LSQ',149.632666666667,5.03875,NULL,NULL,'2012-12-19 05:31:28',56280.23019,20.3308,0.1544,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2012-12-19 12:46:35','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hna/LSQ12hna_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hna/LSQ12hna_snap_86164.gif',60906174304,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,951658973,14869671,NULL,NULL,NULL,NULL),(8465,8208,0,'LSQ12hno','LSQ',55.6802916666667,-2.66938888888889,NULL,NULL,'2012-12-19 02:40:54',56280.1117400001,17.5438,0.0283,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2013-01-03 13:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_86183.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(8466,8270,0,'LSQ12hot','LSQ',49.407,0.816305555555556,NULL,NULL,'2012-12-19 03:30:36',56280.1462599998,19.0055,0.0492,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 12:46:35','2013-01-03 18:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hot/LSQ12hot_history.html','sn nice',NULL,0.02409,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hot/LSQ12hot_snap_86082.gif',64969723199,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1015151924,15861748,NULL,NULL,NULL,NULL),(8467,8467,1,'LSQ12hqs','LSQ',45.1309166666667,-11.4146388888889,NULL,NULL,'2012-12-19 03:11:34',56280.1330400002,17.8887,0.0367,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 17:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqs/LSQ12hqs_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqs/LSQ12hqs_snap_86266.gif',37900689754,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592198277,9253098,NULL,NULL,NULL,NULL),(8468,8467,0,'LSQ12hqs','LSQ',45.1308333333333,-11.4145555555556,NULL,NULL,'2012-12-19 03:14:57',56280.13539,17.9109,0.0393,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 17:46:20','2012-12-19 17:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqs/LSQ12hqs_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqs/LSQ12hqs_snap_86267.gif',37900689754,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592198277,9253098,NULL,NULL,NULL,NULL),(8469,8469,1,'LSQ12hqo','LSQ',31.67375,-8.64613888888889,NULL,NULL,'2012-10-08 04:59:37',56208.2080700002,20.3017,0.0838,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 17:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_snap_86306.gif',35162617725,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549415901,8584623,NULL,NULL,NULL,NULL),(8470,8469,0,'LSQ12hqo','LSQ',31.67275,-8.64594444444444,NULL,NULL,'2012-10-11 05:38:05',56211.2347900001,21.3745,0.1392,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 17:46:20','2012-12-19 17:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_snap_86307.gif',35162617723,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549415901,8584623,NULL,NULL,NULL,NULL),(8471,8469,0,'LSQ12hqo','LSQ',31.673125,-8.64608333333333,NULL,NULL,'2012-12-01 01:59:40',56262.08311,20.0462,0.1769,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 17:46:20','2012-12-19 17:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_snap_86308.gif',35162617721,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549415901,8584623,NULL,NULL,NULL,NULL),(8472,8469,0,'LSQ12hqo','LSQ',31.6731666666667,-8.64597222222222,NULL,NULL,'2012-12-01 04:00:58',56262.1673400002,20.0755,0.198,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 17:46:20','2012-12-19 17:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_snap_86309.gif',35162617721,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549415901,8584623,NULL,NULL,NULL,NULL),(8473,8469,0,'LSQ12hqo','LSQ',31.673625,-8.64647222222222,NULL,NULL,'2012-12-05 01:57:39',56266.0817100001,20.3484,0.1201,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 17:46:20','2012-12-19 17:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_snap_86310.gif',35162617725,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549415901,8584623,NULL,NULL,NULL,NULL),(8474,8469,0,'LSQ12hqo','LSQ',31.6739583333333,-8.64602777777778,NULL,NULL,'2012-12-07 01:51:15',56268.0772600002,19.7011,0.1346,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 17:46:20','2012-12-19 17:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_snap_86311.gif',35162617725,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549415901,8584623,NULL,NULL,NULL,NULL),(8475,8469,0,'LSQ12hqo','LSQ',31.6735,-8.64583333333333,NULL,NULL,'2012-12-13 01:28:23',56274.0613799999,20.0892,0.2082,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 17:46:20','2012-12-19 17:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_snap_86312.gif',35162617725,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549415901,8584623,NULL,NULL,NULL,NULL),(8476,8469,0,'LSQ12hqo','LSQ',31.6734583333333,-8.64608333333333,NULL,NULL,'2012-12-19 04:17:05',56280.1785400002,19.6677,0.0807,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 17:46:20','2012-12-19 17:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_snap_86258.gif',35162617721,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549415901,8584623,NULL,NULL,NULL,NULL),(8477,8469,0,'LSQ12hqo','LSQ',31.6734166666667,-8.64611111111111,NULL,NULL,'2012-12-19 04:53:54',56280.2041000002,18.7909,0.0477,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 17:46:20','2012-12-19 17:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqo/LSQ12hqo_snap_86259.gif',35162617721,NULL,NULL,NULL,'2012-10-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,549415901,8584623,NULL,NULL,NULL,NULL),(8478,8478,1,'LSQ12hqn','LSQ',31.5381666666667,-8.65622222222222,NULL,NULL,'2012-12-13 01:28:23',56274.0613799999,19.9333,0.1856,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 17:46:20','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqn/LSQ12hqn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqn/LSQ12hqn_snap_86305.gif',35164633975,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549447405,8585115,NULL,NULL,NULL,NULL),(8479,8478,0,'LSQ12hqn','LSQ',31.537875,-8.65633333333333,NULL,NULL,'2012-12-19 04:17:05',56280.1785400002,19.4723,0.13,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 17:46:20','2012-12-19 17:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqn/LSQ12hqn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqn/LSQ12hqn_snap_86256.gif',35164633975,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549447405,8585115,NULL,NULL,NULL,NULL),(8480,8478,0,'LSQ12hqn','LSQ',31.538,-8.65630555555556,NULL,NULL,'2012-12-19 04:53:54',56280.2041000002,19.1666,0.1004,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 17:46:20','2012-12-19 17:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqn/LSQ12hqn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqn/LSQ12hqn_snap_86257.gif',35164633975,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,549447405,8585115,NULL,NULL,NULL,NULL),(8481,8481,1,'LSQ12hri','LSQ',52.667875,3.09527777777778,NULL,NULL,'2012-12-19 03:18:29',56280.13784,18.4378,0.0602,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 18:50:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hri/LSQ12hri_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hri/LSQ12hri_snap_86428.gif',65025397238,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1016021831,15875341,NULL,NULL,NULL,NULL),(8482,8481,0,'LSQ12hri','LSQ',52.6675416666667,3.09536111111111,NULL,NULL,'2012-12-19 03:21:52',56280.1401900002,18.6972,0.0609,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 18:50:13','2012-12-19 18:50:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hri/LSQ12hri_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hri/LSQ12hri_snap_86429.gif',65025397221,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1016021831,15875341,NULL,NULL,NULL,NULL),(8483,8483,1,'LSQ12hrg','LSQ',50.4285,6.08336111111111,NULL,NULL,'2012-12-19 03:46:08',56280.15704,19.5195,0.1011,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 18:50:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hrg/LSQ12hrg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hrg/LSQ12hrg_snap_86424.gif',65016447254,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1015881988,15873156,NULL,NULL,NULL,NULL),(8484,8483,0,'LSQ12hrg','LSQ',50.4282916666667,6.08352777777778,NULL,NULL,'2012-12-19 03:49:31',56280.1593900002,19.6533,0.0816,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 18:50:13','2012-12-19 18:50:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hrg/LSQ12hrg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hrg/LSQ12hrg_snap_86425.gif',65016447465,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1015881991,15873156,NULL,NULL,NULL,NULL),(8485,8485,1,'LSQ12hrb','LSQ',41.1604583333333,-2.22766666666667,NULL,NULL,'2012-12-15 02:45:50',56276.1151700001,20.4186,0.1746,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 18:50:13','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hrb/LSQ12hrb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hrb/LSQ12hrb_snap_86451.gif',34909860231,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545466566,8522915,NULL,NULL,NULL,NULL),(8486,8485,0,'LSQ12hrb','LSQ',41.1605,-2.22758333333333,NULL,NULL,'2012-12-19 04:13:42',56280.17619,20.0605,0.1059,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 18:50:13','2012-12-19 18:50:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hrb/LSQ12hrb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hrb/LSQ12hrb_snap_86414.gif',34909860231,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545466566,8522915,NULL,NULL,NULL,NULL),(8487,8485,0,'LSQ12hrb','LSQ',41.1605,-2.22755555555556,NULL,NULL,'2012-12-19 04:47:02',56280.1993300002,20.0301,0.0987,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-19 18:50:13','2012-12-19 18:50:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hrb/LSQ12hrb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hrb/LSQ12hrb_snap_86415.gif',34909860231,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545466566,8522915,NULL,NULL,NULL,NULL),(8498,8425,0,'PSNJ09491471-4754456','pessto',147.311291667,-47.9126666667,NULL,NULL,'2012-12-19 00:00:00',56280,NULL,NULL,NULL,0.006,NULL,'IIb',NULL,'2012-12-20 10:31:36','2012-12-20 10:31:36','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,42076064057,'SALT','spectrograph','Giuliano',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,657438500,10272476,NULL,NULL,NULL,NULL),(8504,8504,0,'PSNJ10532275+1646349','TOCP',163.34479,16.77636,NULL,NULL,'2012-12-18 18:29:00',56279.77,18.6,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2012-12-20 17:45:02','2019-10-12 20:41:36','http://www.cbat.eps.harvard.edu/unconf/followups/J10532275 1646349.html','supernova',NULL,0.0036,NULL,NULL,'http://space.geocities.jp/yusastar77/supernova/PSNinN3447_121220.jpg',NULL,NULL,61200554061,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,956258657,14941541,NULL,NULL,NULL,NULL),(8505,5856,0,'LSQ12gsh','LSQ',72.1757916666667,-30.9983055555556,NULL,NULL,'2012-12-20 03:50:38',56281.16017,18.2116,0.0875,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_history.html','rising',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gsh/LSQ12gsh_snap_86662.gif',37207941504,NULL,NULL,NULL,'2012-11-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,581374086,9083970,NULL,NULL,NULL,NULL),(8506,6150,0,'LSQ12gvs','LSQ',64.3942916666667,-38.8895555555556,NULL,NULL,'2012-12-20 06:34:05',56281.2736800001,20.1573,0.1385,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_86678.gif',37791067707,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(8507,7442,0,'LSQ12hev','LSQ',67.0480833333333,-29.5605,NULL,NULL,'2012-12-20 04:33:46',56281.1901199999,19.906,0.1605,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hev/LSQ12hev_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hev/LSQ12hev_snap_86597.gif',37659944801,NULL,NULL,NULL,'2012-11-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588436637,9194322,NULL,NULL,NULL,NULL),(8508,7445,0,'LSQ12heq','LSQ',53.2672916666667,-28.21375,NULL,NULL,'2012-12-20 03:10:04',56281.1320000002,19.0726,0.044,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_86588.gif',38581253603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(8509,7456,0,'LSQ12hdn','LSQ',63.7042916666667,-32.296,NULL,NULL,'2012-12-20 06:32:24',56281.27251,19.23,0.1494,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_snap_86653.gif',37709622178,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589212846,9206450,NULL,NULL,NULL,NULL),(8510,7606,0,'LSQ12hio','LSQ',64.250625,-27.69625,NULL,NULL,'2012-12-20 04:52:24',56281.2030600002,20.7444,0.2032,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hio/LSQ12hio_snap_86670.gif',37661993378,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588468646,9194822,NULL,NULL,NULL,NULL),(8511,7613,0,'LSQ12hje','LSQ',77.1708333333333,-20.9645,NULL,NULL,'2012-12-20 04:09:26',56281.1732200002,18.5138,0.0602,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_86585.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(8512,7613,0,'LSQ12hje','LSQ',77.1708333333333,-20.9645277777778,NULL,NULL,'2012-12-20 06:17:01',56281.2618200001,18.5432,0.0611,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_86586.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(8513,7751,0,'LSQ12hle','LSQ',61.1045416666667,-29.1574444444444,NULL,NULL,'2012-12-20 05:35:00',56281.2326400001,19.142,0.0677,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_snap_86598.gif',38530541650,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602039713,9406870,NULL,NULL,NULL,NULL),(8514,8046,0,'LSQ12hnj','LSQ',78.103375,-25.7825277777778,NULL,NULL,'2012-12-20 04:06:03',56281.17087,15.5538,0.0049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_86627.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8515,8046,0,'LSQ12hnj','LSQ',78.1027083333333,-25.7826111111111,NULL,NULL,'2012-12-20 04:07:44',56281.1720400001,15.772,0.0048,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_86629.gif',37249489805,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8516,8046,0,'LSQ12hnj','LSQ',78.1033333333333,-25.7826111111111,NULL,NULL,'2012-12-20 06:11:40',56281.2581099998,15.4618,0.0049,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_86628.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8517,8046,0,'LSQ12hnj','LSQ',78.1026666666667,-25.7826111111111,NULL,NULL,'2012-12-20 06:13:22',56281.25929,15.8215,0.0055,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_86630.gif',37249489805,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8518,8053,0,'LSQ12hnh','LSQ',53.7749166666667,-26.7651666666667,NULL,NULL,'2012-12-20 03:06:22',56281.1294300002,20.8653,0.2084,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_snap_86631.gif',38579501926,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602804717,9418823,NULL,NULL,NULL,NULL),(8519,8053,0,'LSQ12hnh','LSQ',53.7745833333333,-26.7649444444444,NULL,NULL,'2012-12-20 04:55:48',56281.20542,20.7745,0.1125,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_snap_86632.gif',38579501934,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602804717,9418823,NULL,NULL,NULL,NULL),(8520,8228,0,'LSQ12hon','LSQ',57.8934166666667,-24.2263333333333,NULL,NULL,'2012-12-20 06:27:19',56281.2689800002,19.1891,0.1124,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_86494.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(8521,8387,0,'LSQ12hpj','LSQ',72.1000833333333,-31.2976944444444,NULL,NULL,'2012-12-20 03:50:38',56281.16017,19.4599,0.141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_snap_86551.gif',37204796368,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581324943,9083202,NULL,NULL,NULL,NULL),(8522,8387,0,'LSQ12hpj','LSQ',72.100125,-31.2976666666667,NULL,NULL,'2012-12-20 06:42:34',56281.2795699998,19.4698,0.1791,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_snap_86552.gif',37204796368,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581324943,9083202,NULL,NULL,NULL,NULL),(8523,8408,0,'LSQ12hqa','LSQ',160.241125,-21.7817222222222,NULL,NULL,'2012-12-20 07:06:06',56281.2959099999,19.3559,0.097,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_snap_86563.gif',41668171452,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,651065178,10172893,NULL,NULL,NULL,NULL),(8524,8412,0,'LSQ12hpy','LSQ',79.2732916666667,-24.5450277777778,NULL,NULL,'2012-12-20 06:17:01',56281.2618200001,19.8865,0.1329,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 02:46:18','2012-12-21 02:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_snap_86560.gif',37131195893,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580174935,9065233,NULL,NULL,NULL,NULL),(8525,8107,0,'PSNJ06213846-5942506','pessto',95.41025,-59.71406,NULL,NULL,'2012-12-21 00:00:00',56282,NULL,NULL,NULL,0.008,NULL,'Ia',NULL,'2012-12-21 13:43:49','2012-12-21 13:43:49','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,40382256344,'NTT','EFOSC2','Maguire',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,630972755,9858949,NULL,NULL,NULL,NULL),(8526,5983,0,'LSQ12gul','LSQ',43.03375,-0.0360277777777778,NULL,NULL,'2012-12-21 02:46:02',56282.1153099998,19.312,0.0998,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_87030.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(8527,5983,0,'LSQ12gul','LSQ',43.03375,-0.0361388888888889,NULL,NULL,'2012-12-21 04:02:15',56282.16823,19.3959,0.1097,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_history.html','sn?',NULL,0.06669,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gul/LSQ12gul_snap_87031.gif',34898256425,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,545285256,8520082,NULL,NULL,NULL,NULL),(8528,5993,0,'LSQ12gtz','LSQ',48.3627083333333,-7.35847222222222,NULL,NULL,'2012-12-21 01:59:39',56282.0830999999,19.4192,0.1648,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_87046.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(8529,5993,0,'LSQ12gtz','LSQ',48.3627916666667,-7.3585,NULL,NULL,'2012-12-21 03:48:33',56282.1587200002,19.1589,0.1329,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_87048.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(8530,5993,0,'LSQ12gtz','LSQ',48.3626666666667,-7.35844444444444,NULL,NULL,'2012-12-21 04:00:33',56282.1670499998,19.4931,0.1823,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_history.html','sn?',NULL,0.10493,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gtz/LSQ12gtz_snap_87047.gif',37904478837,NULL,NULL,NULL,'2012-08-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592257481,9254023,NULL,NULL,NULL,NULL),(8531,6014,0,'LSQ12gty','LSQ',73.3359166666667,-14.9325277777778,NULL,NULL,'2012-12-21 02:11:40',56282.0914400001,19.2624,0.0971,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_87049.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(8532,6014,0,'LSQ12gty','LSQ',73.3359583333333,-14.9325833333333,NULL,NULL,'2012-12-21 04:16:21',56282.1780300001,19.658,0.1007,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_history.html','sne - nice',NULL,0.135577,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gty/LSQ12gty_snap_87050.gif',37577087526,NULL,NULL,NULL,'2012-11-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,587141992,9174093,NULL,NULL,NULL,NULL),(8533,6121,0,'LSQ12gwc','LSQ',55.8399583333333,-26.7371944444444,NULL,NULL,'2012-12-21 01:22:36',56282.0573700001,20.434,0.1192,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_87068.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(8534,6155,0,'LSQ12gve','LSQ',51.1095833333333,-11.6691111111111,NULL,NULL,'2012-12-21 04:00:33',56282.1670499998,16.3061,0.0457,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_history.html','rising',NULL,0.031715,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gve/LSQ12gve_snap_87066.gif',37885390163,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,591959221,9249362,NULL,NULL,NULL,NULL),(8535,6172,0,'LSQ12guy','LSQ',151.692583333333,-6.18844444444444,NULL,NULL,'2012-12-21 05:03:19',56282.2106400002,20.5954,0.2004,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guy/LSQ12guy_history.html','sn?',NULL,0.055375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guy/LSQ12guy_snap_87056.gif',41247382850,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,644490357,10070161,NULL,NULL,NULL,NULL),(8536,7063,0,'LSQ12gxj','LSQ',43.239125,1.60669444444444,NULL,NULL,'2012-12-21 02:44:21',56282.1141400002,17.8432,0.0456,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_86916.gif',66842134735,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(8537,7063,0,'LSQ12gxj','LSQ',43.239125,1.60675,NULL,NULL,'2012-12-21 02:47:45',56282.1165,17.696,0.0392,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxj/LSQ12gxj_snap_86917.gif',66842134735,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044408355,16318880,NULL,NULL,NULL,NULL),(8538,7075,0,'LSQ12gxb','LSQ',142.838875,-11.6295277777778,NULL,NULL,'2012-12-21 06:24:15',56282.2668499998,20.0358,0.0838,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_snap_86904.gif',42178887818,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,659045122,10297580,NULL,NULL,NULL,NULL),(8539,7083,0,'LSQ12gyr','LSQ',43.2102916666667,-7.71211111111111,NULL,NULL,'2012-12-21 01:42:28',56282.0711599998,19.2614,0.1795,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_history.html','sne - nice',NULL,0.11794,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyr/LSQ12gyr_snap_86892.gif',37909543298,NULL,NULL,NULL,'2012-10-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592336614,9255259,NULL,NULL,NULL,NULL),(8540,7096,0,'LSQ12gyd','LSQ',76.387125,-18.0351388888889,NULL,NULL,'2012-12-21 02:16:45',56282.09497,18.6903,0.0511,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_86901.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(8541,7099,0,'LSQ12gyc','LSQ',41.458625,-17.9293888888889,NULL,NULL,'2012-12-21 01:49:16',56282.0758799999,18.4325,0.1671,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_86897.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(8542,7099,0,'LSQ12gyc','LSQ',41.4586666666667,-17.9293333333333,NULL,NULL,'2012-12-21 03:50:18',56282.1599400002,18.3317,0.1122,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyc/LSQ12gyc_snap_86898.gif',38105873563,NULL,NULL,NULL,'2012-08-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,595404274,9303191,NULL,NULL,NULL,NULL),(8543,7122,0,'LSQ12gza','LSQ',35.8929166666667,-5.90733333333333,NULL,NULL,'2012-12-21 01:04:16',56282.0446299999,20.5644,0.2055,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_history.html','sne - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gza/LSQ12gza_snap_86926.gif',34947372277,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,546052691,8532073,NULL,NULL,NULL,NULL),(8544,7131,0,'LSQ12gyv','LSQ',50.471,-10.0814722222222,NULL,NULL,'2012-12-21 01:57:58',56282.0819299999,18.9104,0.1289,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_snap_86911.gif',37898370242,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592162035,9252531,NULL,NULL,NULL,NULL),(8545,7131,0,'LSQ12gyv','LSQ',50.4709166666667,-10.0814722222222,NULL,NULL,'2012-12-21 03:58:52',56282.1658800002,18.8117,0.1595,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyv/LSQ12gyv_snap_86912.gif',37898370242,NULL,NULL,NULL,'2012-11-27 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,592162035,9252531,NULL,NULL,NULL,NULL),(8546,7326,0,'LSQ12hcm','LSQ',55.5313333333333,4.23163888888889,NULL,NULL,'2012-12-21 01:54:32',56282.0795399998,18.9772,0.0742,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_history.html','sn nice',NULL,0.024457,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcm/LSQ12hcm_snap_86972.gif',65206467034,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1018851047,15919547,NULL,NULL,NULL,NULL),(8547,7337,0,'LSQ12hcc','LSQ',143.778458333333,-8.55072222222222,NULL,NULL,'2012-12-21 06:24:15',56282.2668499998,21.2827,0.1963,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcc/LSQ12hcc_history.html','sn?',NULL,0.089982,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcc/LSQ12hcc_snap_86952.gif',41103056563,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642235258,10034925,NULL,NULL,NULL,NULL),(8548,7355,0,'LSQ12hbu','LSQ',152.379041666667,-16.1379444444444,NULL,NULL,'2012-12-21 04:36:02',56282.1916899998,19.3178,0.12,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbu/LSQ12hbu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbu/LSQ12hbu_snap_86976.gif',41198551021,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643727359,10058239,NULL,NULL,NULL,NULL),(8549,7355,0,'LSQ12hbu','LSQ',152.378791666667,-16.138,NULL,NULL,'2012-12-21 06:36:08',56282.2751000002,20.3241,0.1262,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbu/LSQ12hbu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbu/LSQ12hbu_snap_86977.gif',41198551021,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643727359,10058239,NULL,NULL,NULL,NULL),(8550,7507,0,'LSQ12hgj','LSQ',154.207291666667,-16.1957222222222,NULL,NULL,'2012-12-21 04:53:03',56282.2035099999,20.3651,0.1728,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_snap_87036.gif',41166665804,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643229153,10050455,NULL,NULL,NULL,NULL),(8551,7507,0,'LSQ12hgj','LSQ',154.207333333333,-16.1958055555556,NULL,NULL,'2012-12-21 06:46:16',56282.2821300002,19.8159,0.0927,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_snap_87037.gif',41166665804,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643229153,10050455,NULL,NULL,NULL,NULL),(8552,7514,0,'LSQ12hft','LSQ',26.16925,-20.4021388888889,NULL,NULL,'2012-12-21 03:38:23',56282.15166,19.2911,0.1955,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hft/LSQ12hft_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hft/LSQ12hft_snap_86988.gif',35040430818,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,547506731,8554792,NULL,NULL,NULL,NULL),(8553,7670,0,'LSQ12hjm','LSQ',47.6195833333333,-16.4936666666667,NULL,NULL,'2012-12-21 01:56:16',56282.0807500002,14.4332,0.0403,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjm/LSQ12hjm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjm/LSQ12hjm_snap_86968.gif',38111401116,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,595490642,9304541,NULL,NULL,NULL,NULL),(8554,7670,0,'LSQ12hjm','LSQ',47.6197083333333,-16.4936111111111,NULL,NULL,'2012-12-21 03:57:10',56282.1647000001,14.8747,0.0537,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjm/LSQ12hjm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjm/LSQ12hjm_snap_86969.gif',38111401116,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,595490642,9304541,NULL,NULL,NULL,NULL),(8555,7706,0,'LSQ12hka','LSQ',162.676791666667,-6.84538888888889,NULL,NULL,'2012-12-21 07:24:29',56282.3086799998,20.3277,0.1877,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hka/LSQ12hka_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hka/LSQ12hka_snap_86899.gif',41796865596,NULL,NULL,NULL,'2012-05-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,653076024,10204312,NULL,NULL,NULL,NULL),(8556,7708,0,'LSQ12hjq','LSQ',37.1612083333333,-11.6394444444444,NULL,NULL,'2012-12-21 02:55:00',56282.1215300001,19.7236,0.1757,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hjq/LSQ12hjq_snap_86964.gif',37867077887,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,591673091,9244892,NULL,NULL,NULL,NULL),(8557,7729,0,'LSQ12hkm','LSQ',56.0942083333333,2.74522222222222,NULL,NULL,'2012-12-21 01:52:50',56282.0783600002,19.3925,0.163,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_snap_86980.gif',65198525114,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018726954,15917608,NULL,NULL,NULL,NULL),(8558,7729,0,'LSQ12hkm','LSQ',56.0940416666667,2.74527777777778,NULL,NULL,'2012-12-21 03:53:42',56282.1623,19.3918,0.1497,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkm/LSQ12hkm_snap_86981.gif',65198525114,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1018726954,15917608,NULL,NULL,NULL,NULL),(8559,7735,0,'LSQ12hkj','LSQ',148.182083333333,0.537111111111111,NULL,NULL,'2012-12-21 06:15:47',56282.2609700002,20.5618,0.1491,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkj/LSQ12hkj_history.html','sn?',NULL,0.07666,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hkj/LSQ12hkj_snap_86907.gif',60768834972,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,949513046,14836141,NULL,NULL,NULL,NULL),(8560,7894,0,'LSQ12hlz','LSQ',74.4069583333333,-15.3166944444444,NULL,NULL,'2012-12-21 04:16:21',56282.1780300001,18.535,0.0557,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_87044.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(8561,7901,0,'LSQ12hna','LSQ',149.632583333333,5.03877777777778,NULL,NULL,'2012-12-21 05:22:18',56282.22383,19.792,0.1164,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hna/LSQ12hna_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hna/LSQ12hna_snap_87006.gif',60906174304,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,951658973,14869671,NULL,NULL,NULL,NULL),(8562,7901,0,'LSQ12hna','LSQ',149.632666666667,5.03863888888889,NULL,NULL,'2012-12-21 07:01:58',56282.2930399999,20.1986,0.1423,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hna/LSQ12hna_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hna/LSQ12hna_snap_87007.gif',60906174304,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,951658973,14869671,NULL,NULL,NULL,NULL),(8563,7909,0,'LSQ12hmy','LSQ',136.547333333333,-2.21372222222222,NULL,NULL,'2012-12-21 04:32:33',56282.18928,19.57,0.1542,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_snap_87035.gif',42146871440,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,658544866,10289763,NULL,NULL,NULL,NULL),(8564,7926,0,'LSQ12hmm','LSQ',167.450291666667,-10.5910555555556,NULL,NULL,'2012-12-21 05:56:59',56282.2479099999,18.9684,0.0539,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmm/LSQ12hmm_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmm/LSQ12hmm_snap_87012.gif',40886673516,NULL,NULL,NULL,'2012-05-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638854273,9982098,NULL,NULL,NULL,NULL),(8565,7926,0,'LSQ12hmm','LSQ',167.450208333333,-10.5910277777778,NULL,NULL,'2012-12-21 07:45:01',56282.3229299998,19.0469,0.048,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmm/LSQ12hmm_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmm/LSQ12hmm_snap_87013.gif',40886673516,NULL,NULL,NULL,'2012-05-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638854273,9982098,NULL,NULL,NULL,NULL),(8566,7934,0,'LSQ12hmc','LSQ',168.302875,-12.3908611111111,NULL,NULL,'2012-12-21 07:51:46',56282.3276200001,20.6829,0.12,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-21 15:47:03','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmc/LSQ12hmc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmc/LSQ12hmc_snap_87027.gif',41691785886,NULL,NULL,NULL,'2012-06-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651434154,10178658,NULL,NULL,NULL,NULL),(8567,8208,0,'LSQ12hno','LSQ',55.6803333333333,-2.66941666666667,NULL,NULL,'2012-12-21 02:06:26',56282.0878099999,17.4308,0.0376,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2013-01-03 13:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_87022.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(8568,8216,0,'LSQ12hns','LSQ',167.904166666667,-10.7736944444444,NULL,NULL,'2012-12-21 07:43:19',56282.3217500001,18.8987,0.055,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hns/LSQ12hns_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hns/LSQ12hns_snap_86891.gif',40886241208,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638847518,9981992,NULL,NULL,NULL,NULL),(8569,8218,0,'LSQ12hnr','LSQ',160.811541666667,-8.778,NULL,NULL,'2012-12-21 05:41:17',56282.2370099998,18.6144,0.0866,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_snap_86887.gif',41807774750,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653246480,10206976,NULL,NULL,NULL,NULL),(8570,8218,0,'LSQ12hnr','LSQ',160.811583333333,-8.77802777777778,NULL,NULL,'2012-12-21 07:10:50',56282.2991999998,18.6567,0.0791,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_snap_86888.gif',41807774750,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653246480,10206976,NULL,NULL,NULL,NULL),(8571,8270,0,'LSQ12hot','LSQ',49.4069583333333,0.816333333333333,NULL,NULL,'2012-12-21 01:37:16',56282.0675499998,18.9411,0.0606,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2013-01-03 18:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hot/LSQ12hot_history.html','sn nice',NULL,0.02409,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hot/LSQ12hot_snap_86920.gif',64969723199,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1015151924,15861748,NULL,NULL,NULL,NULL),(8572,8270,0,'LSQ12hot','LSQ',49.407,0.816305555555556,NULL,NULL,'2012-12-21 02:23:47',56282.09986,18.8932,0.0699,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2013-01-03 18:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hot/LSQ12hot_history.html','sn nice',NULL,0.02409,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hot/LSQ12hot_snap_86921.gif',64969723199,NULL,NULL,NULL,'2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1015151924,15861748,NULL,NULL,NULL,NULL),(8573,8273,0,'LSQ12hos','LSQ',161.536666666667,-3.35933333333333,NULL,NULL,'2012-12-21 06:08:59',56282.25624,19.2964,0.0636,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2013-01-12 18:20:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hos/LSQ12hos_history.html','sn nice',NULL,0.11097,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hos/LSQ12hos_snap_86918.gif',40876271258,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638691738,9979558,NULL,NULL,NULL,NULL),(8574,8273,0,'LSQ12hos','LSQ',161.536708333333,-3.35936111111111,NULL,NULL,'2012-12-21 07:38:10',56282.3181799999,19.1587,0.0531,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 15:47:03','2013-01-12 18:20:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hos/LSQ12hos_history.html','sn nice',NULL,0.11097,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hos/LSQ12hos_snap_86919.gif',40876271258,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638691738,9979558,NULL,NULL,NULL,NULL),(8575,6172,0,'LSQ12guy','LSQ',151.69225,-6.18833333333333,NULL,NULL,'2012-12-21 08:03:40',56282.3358800001,19.8967,0.1529,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 16:46:17','2012-12-21 16:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guy/LSQ12guy_history.html','sn?',NULL,0.055375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12guy/LSQ12guy_snap_87200.gif',41247382861,NULL,NULL,NULL,'2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,644490357,10070161,NULL,NULL,NULL,NULL),(8576,8576,1,'LSQ12hse','LSQ',180.09375,-21.8911388888889,NULL,NULL,'2012-12-20 07:00:58',56281.2923400002,18.9488,0.0872,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 16:46:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_snap_86859.gif',43016918029,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,672139344,10502177,NULL,NULL,NULL,NULL),(8577,8576,0,'LSQ12hse','LSQ',180.093958333333,-21.8910277777778,NULL,NULL,'2012-12-20 07:49:36',56281.3261199999,18.221,0.1056,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 16:46:17','2012-12-21 16:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_snap_86860.gif',43016918029,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,672139344,10502177,NULL,NULL,NULL,NULL),(8578,8578,1,'LSQ12hrl','LSQ',72.5196666666667,-35.342,NULL,NULL,'2012-12-20 03:47:15',56281.1578199998,20.321,0.1432,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 16:46:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hrl/LSQ12hrl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hrl/LSQ12hrl_snap_86730.gif',37685239553,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588831868,9200497,NULL,NULL,NULL,NULL),(8579,8578,0,'LSQ12hrl','LSQ',72.5198333333333,-35.3419722222222,NULL,NULL,'2012-12-20 04:25:14',56281.1841899999,21.1309,0.1505,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 16:46:17','2012-12-21 16:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hrl/LSQ12hrl_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hrl/LSQ12hrl_snap_86731.gif',37685239553,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588831868,9200497,NULL,NULL,NULL,NULL),(8580,8580,1,'LSQ12hsi','LSQ',29.1617083333333,-13.4341111111111,NULL,NULL,'2012-12-07 03:45:27',56268.1565700001,20.8514,0.2145,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 19:46:23','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hsi/LSQ12hsi_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hsi/LSQ12hsi_snap_87309.gif',35073350282,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548021098,8562829,NULL,NULL,NULL,NULL),(8581,8580,0,'LSQ12hsi','LSQ',29.16175,-13.4341388888889,NULL,NULL,'2012-12-09 01:37:54',56270.0679899999,20.4006,0.1587,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 19:46:23','2012-12-21 19:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hsi/LSQ12hsi_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hsi/LSQ12hsi_snap_87310.gif',35073350282,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548021098,8562829,NULL,NULL,NULL,NULL),(8582,8580,0,'LSQ12hsi','LSQ',29.16175,-13.4341944444444,NULL,NULL,'2012-12-13 02:53:04',56274.1201900002,19.8011,0.1052,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 19:46:23','2012-12-21 19:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hsi/LSQ12hsi_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hsi/LSQ12hsi_snap_87311.gif',35073350282,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548021098,8562829,NULL,NULL,NULL,NULL),(8583,8580,0,'LSQ12hsi','LSQ',29.16175,-13.4342222222222,NULL,NULL,'2012-12-13 02:56:26',56274.1225299998,19.9137,0.1014,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 19:46:23','2012-12-21 19:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hsi/LSQ12hsi_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hsi/LSQ12hsi_snap_87312.gif',35073350282,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548021098,8562829,NULL,NULL,NULL,NULL),(8584,8580,0,'LSQ12hsi','LSQ',29.1617916666667,-13.4341944444444,NULL,NULL,'2012-12-15 02:56:07',56276.12231,19.6521,0.0788,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 19:46:23','2012-12-21 19:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hsi/LSQ12hsi_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hsi/LSQ12hsi_snap_87313.gif',35073350282,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548021098,8562829,NULL,NULL,NULL,NULL),(8585,8580,0,'LSQ12hsi','LSQ',29.1617083333333,-13.4341944444444,NULL,NULL,'2012-12-15 02:59:30',56276.1246600002,19.7528,0.0871,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 19:46:23','2012-12-21 19:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hsi/LSQ12hsi_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hsi/LSQ12hsi_snap_87314.gif',35073350282,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548021098,8562829,NULL,NULL,NULL,NULL),(8586,8580,0,'LSQ12hsi','LSQ',29.16175,-13.4341666666667,NULL,NULL,'2012-12-21 03:24:40',56282.1421400001,19.6294,0.1346,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 19:46:23','2012-12-21 19:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hsi/LSQ12hsi_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hsi/LSQ12hsi_snap_87201.gif',35073350282,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548021098,8562829,NULL,NULL,NULL,NULL),(8587,8580,0,'LSQ12hsi','LSQ',29.1617916666667,-13.4341111111111,NULL,NULL,'2012-12-21 03:28:07',56282.1445300002,19.6939,0.1241,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 19:46:23','2012-12-21 19:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hsi/LSQ12hsi_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hsi/LSQ12hsi_snap_87202.gif',35073350282,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,548021098,8562829,NULL,NULL,NULL,NULL),(8600,8600,0,'LSQ12huh','LSQ',52.6829166666667,4.66805555555556,NULL,NULL,'2012-12-13 02:08:12',56274.0890299999,21.2537,0.1716,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2019-10-11 20:38:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huh/LSQ12huh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huh/LSQ12huh_snap_87532.gif',65014918089,NULL,NULL,NULL,'2012-12-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1015858095,15872782,NULL,NULL,NULL,NULL),(8601,8600,0,'LSQ12huh','LSQ',52.6829583333333,4.668,NULL,NULL,'2012-12-19 03:18:29',56280.13784,20.9821,0.1847,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-21 20:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huh/LSQ12huh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huh/LSQ12huh_snap_87533.gif',65014918089,NULL,NULL,NULL,'2012-12-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1015858095,15872782,NULL,NULL,NULL,NULL),(8602,8600,0,'LSQ12huh','LSQ',52.683,4.66808333333333,NULL,NULL,'2012-12-19 03:21:52',56280.1401900002,20.6351,0.1548,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-21 20:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huh/LSQ12huh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huh/LSQ12huh_snap_87534.gif',65014918089,NULL,NULL,NULL,'2012-12-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1015858095,15872782,NULL,NULL,NULL,NULL),(8603,8600,0,'LSQ12huh','LSQ',52.683,4.668,NULL,NULL,'2012-12-21 01:38:58',56282.0687299999,19.5369,0.0937,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-21 20:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huh/LSQ12huh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huh/LSQ12huh_snap_87303.gif',65014918089,NULL,NULL,NULL,'2012-12-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1015858095,15872782,NULL,NULL,NULL,NULL),(8604,8600,0,'LSQ12huh','LSQ',52.6830833333333,4.66797222222222,NULL,NULL,'2012-12-21 02:20:24',56282.0975100002,19.8776,0.1196,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-21 20:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huh/LSQ12huh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huh/LSQ12huh_snap_87304.gif',65014918089,NULL,NULL,NULL,'2012-12-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,1015858095,15872782,NULL,NULL,NULL,NULL),(8605,8605,1,'LSQ12hud','LSQ',144.305541666667,-2.20355555555556,NULL,NULL,'2012-11-25 07:41:18',56256.3203500002,21.0355,0.2136,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hud/LSQ12hud_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hud/LSQ12hud_snap_87513.gif',41120774225,NULL,NULL,NULL,'2012-04-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642512097,10039251,NULL,NULL,NULL,NULL),(8606,8605,0,'LSQ12hud','LSQ',144.305791666667,-2.20330555555556,NULL,NULL,'2012-12-09 05:52:48',56270.2450100002,20.0746,0.1194,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2013-01-05 11:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hud/LSQ12hud_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hud/LSQ12hud_snap_87514.gif',41120774338,NULL,NULL,NULL,'2012-04-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642512099,10039251,NULL,NULL,NULL,NULL),(8607,8605,0,'LSQ12hud','LSQ',144.305625,-2.2035,NULL,NULL,'2012-12-15 08:11:17',56276.3411699999,19.8337,0.0964,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2013-01-05 11:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hud/LSQ12hud_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hud/LSQ12hud_snap_87515.gif',41120774338,NULL,NULL,NULL,'2012-04-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642512099,10039251,NULL,NULL,NULL,NULL),(8608,8605,0,'LSQ12hud','LSQ',144.305708333333,-2.20358333333333,NULL,NULL,'2012-12-21 05:05:00',56282.2118099998,18.8742,0.076,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2013-01-05 11:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hud/LSQ12hud_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hud/LSQ12hud_snap_87295.gif',41120774338,NULL,NULL,NULL,'2012-04-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642512099,10039251,NULL,NULL,NULL,NULL),(8609,8605,0,'LSQ12hud','LSQ',144.305791666667,-2.20344444444444,NULL,NULL,'2012-12-21 06:51:23',56282.2856899998,18.9803,0.0489,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2013-01-05 11:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hud/LSQ12hud_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hud/LSQ12hud_snap_87296.gif',41120774338,NULL,NULL,NULL,'2012-04-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642512099,10039251,NULL,NULL,NULL,NULL),(8610,8610,1,'LSQ12hua','LSQ',38.50475,0.359416666666667,NULL,NULL,'2012-12-21 03:29:50',56282.1457199999,17.2289,0.0316,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hua/LSQ12hua_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hua/LSQ12hua_snap_87289.gif',66879072143,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044985502,16327898,NULL,NULL,NULL,NULL),(8611,8610,0,'LSQ12hua','LSQ',38.5047916666667,0.359722222222222,NULL,NULL,'2012-12-21 03:33:13',56282.1480700001,17.2378,0.0352,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-21 20:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hua/LSQ12hua_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hua/LSQ12hua_snap_87290.gif',66879072143,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1044985502,16327898,NULL,NULL,NULL,NULL),(8612,8612,1,'LSQ12htz','LSQ',164.423958333333,-4.01675,NULL,NULL,'2012-12-15 06:36:16',56276.27519,19.7268,0.1123,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htz/LSQ12htz_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htz/LSQ12htz_snap_87496.gif',40936097784,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,639626527,9994164,NULL,NULL,NULL,NULL),(8613,8612,0,'LSQ12htz','LSQ',164.424,-4.01669444444444,NULL,NULL,'2012-12-15 07:42:22',56276.3210900002,19.9614,0.1117,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-21 20:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htz/LSQ12htz_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htz/LSQ12htz_snap_87497.gif',40936097784,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,639626527,9994164,NULL,NULL,NULL,NULL),(8614,8612,0,'LSQ12htz','LSQ',164.424041666667,-4.01677777777778,NULL,NULL,'2012-12-21 06:12:23',56282.2586099999,19.7449,0.123,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-21 20:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htz/LSQ12htz_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htz/LSQ12htz_snap_87287.gif',40936097784,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,639626527,9994164,NULL,NULL,NULL,NULL),(8615,8612,0,'LSQ12htz','LSQ',164.424083333333,-4.01680555555556,NULL,NULL,'2012-12-21 07:36:29',56282.3170099999,19.5172,0.1008,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-21 20:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htz/LSQ12htz_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htz/LSQ12htz_snap_87288.gif',40936097784,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,639626527,9994164,NULL,NULL,NULL,NULL),(8616,8616,1,'LSQ12htv','LSQ',158.397708333333,-7.24408333333333,NULL,NULL,'2012-12-07 06:43:48',56268.2804200002,19.7071,0.1501,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htv/LSQ12htv_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htv/LSQ12htv_snap_87486.gif',41804198309,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653190598,10206103,NULL,NULL,NULL,NULL),(8617,8616,0,'LSQ12htv','LSQ',158.397833333333,-7.24422222222222,NULL,NULL,'2012-12-09 06:42:46',56270.2796999998,20.5883,0.1984,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-21 20:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htv/LSQ12htv_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htv/LSQ12htv_snap_87487.gif',41804198309,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653190598,10206103,NULL,NULL,NULL,NULL),(8618,8616,0,'LSQ12htv','LSQ',158.397708333333,-7.24419444444444,NULL,NULL,'2012-12-15 06:29:32',56276.2705100002,20.5605,0.1901,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-21 20:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htv/LSQ12htv_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htv/LSQ12htv_snap_87488.gif',41804198309,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653190598,10206103,NULL,NULL,NULL,NULL),(8619,8616,0,'LSQ12htv','LSQ',158.397833333333,-7.24425,NULL,NULL,'2012-12-15 07:45:46',56276.32345,20.4015,0.1801,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-21 20:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htv/LSQ12htv_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htv/LSQ12htv_snap_87489.gif',41804198309,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653190598,10206103,NULL,NULL,NULL,NULL),(8620,8616,0,'LSQ12htv','LSQ',158.39775,-7.24422222222222,NULL,NULL,'2012-12-21 06:03:43',56282.2525900002,19.8221,0.159,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-21 20:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htv/LSQ12htv_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htv/LSQ12htv_snap_87279.gif',41804198309,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653190598,10206103,NULL,NULL,NULL,NULL),(8621,8616,0,'LSQ12htv','LSQ',158.397708333333,-7.24425,NULL,NULL,'2012-12-21 07:41:34',56282.3205400002,20.0915,0.128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-21 20:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htv/LSQ12htv_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htv/LSQ12htv_snap_87280.gif',41804198309,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653190598,10206103,NULL,NULL,NULL,NULL),(8622,8622,1,'LSQ12htu','LSQ',152.904625,-7.38655555555556,NULL,NULL,'2012-12-21 05:55:16',56282.2467200002,20.1252,0.1557,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htu/LSQ12htu_history.html','sn nice',NULL,0.05245,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htu/LSQ12htu_snap_87277.gif',41250115247,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644533050,10070828,NULL,NULL,NULL,NULL),(8623,8622,0,'LSQ12htu','LSQ',152.904583333333,-7.38647222222222,NULL,NULL,'2012-12-21 07:17:36',56282.3039000002,19.6948,0.1332,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htu/LSQ12htu_history.html','sn nice',NULL,0.05245,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htu/LSQ12htu_snap_87278.gif',41250115247,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644533050,10070828,NULL,NULL,NULL,NULL),(8624,8624,1,'LSQ12htf','LSQ',163.394666666667,-10.6360277777778,NULL,NULL,'2012-12-15 07:54:18',56276.32938,20.829,0.1664,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htf/LSQ12htf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htf/LSQ12htf_snap_87413.gif',41786968111,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,652921376,10201896,NULL,NULL,NULL,NULL),(8625,8624,0,'LSQ12htf','LSQ',163.3945,-10.6360833333333,NULL,NULL,'2012-12-21 05:46:45',56282.2408099999,19.7918,0.1077,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-21 20:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htf/LSQ12htf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htf/LSQ12htf_snap_87247.gif',41786968109,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,652921376,10201896,NULL,NULL,NULL,NULL),(8626,8624,0,'LSQ12htf','LSQ',163.394625,-10.6359722222222,NULL,NULL,'2012-12-21 07:12:31',56282.3003699998,19.9838,0.099,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-21 20:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htf/LSQ12htf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htf/LSQ12htf_snap_87248.gif',41786968111,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,652921376,10201896,NULL,NULL,NULL,NULL),(8627,8627,1,'LSQ12hte','LSQ',160.092333333333,-9.44558333333333,NULL,NULL,'2012-12-15 07:20:04',56276.3056100002,19.9412,0.1189,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hte/LSQ12hte_history.html','sn nice',NULL,0.039704,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hte/LSQ12hte_snap_87412.gif',41795101596,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653048462,10203882,NULL,NULL,NULL,NULL),(8628,8627,0,'LSQ12hte','LSQ',160.092375,-9.44561111111111,NULL,NULL,'2012-12-21 05:39:35',56282.2358300001,20.2505,0.1413,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-21 20:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hte/LSQ12hte_history.html','sn nice',NULL,0.039704,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hte/LSQ12hte_snap_87245.gif',41795101596,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653048462,10203882,NULL,NULL,NULL,NULL),(8629,8627,0,'LSQ12hte','LSQ',160.092416666667,-9.44555555555556,NULL,NULL,'2012-12-21 07:09:08',56282.2980200001,20.2934,0.1561,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-21 20:46:25','2012-12-21 20:46:25','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hte/LSQ12hte_history.html','sn nice',NULL,0.039704,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hte/LSQ12hte_snap_87246.gif',41795101596,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653048462,10203882,NULL,NULL,NULL,NULL),(8630,6121,0,'LSQ12gwc','LSQ',55.8399583333333,-26.7371666666667,NULL,NULL,'2012-12-22 03:31:20',56283.1467599999,20.9127,0.1614,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_history.html','unknown',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwc/LSQ12gwc_snap_87853.gif',38526264411,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,601972881,9405826,NULL,NULL,NULL,NULL),(8631,6132,0,'LSQ12gwb','LSQ',54.008125,-29.7770555555556,NULL,NULL,'2012-12-22 01:25:47',56283.0595800001,21.3468,0.1581,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_history.html','sn?',NULL,0.1516,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_snap_87859.gif',38584840201,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602888128,9420127,NULL,NULL,NULL,NULL),(8632,6150,0,'LSQ12gvs','LSQ',64.3945416666667,-38.8894722222222,NULL,NULL,'2012-12-22 02:43:16',56283.1133900001,20.3376,0.1328,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_87850.gif',37791067655,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(8633,6182,0,'LSQ12gwl','LSQ',55.021875,-21.5045833333333,NULL,NULL,'2012-12-22 02:12:13',56283.0918200002,19.7213,0.0958,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_snap_87863.gif',38047180768,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594487199,9288862,NULL,NULL,NULL,NULL),(8634,6188,0,'LSQ12gwk','LSQ',44.36625,-25.3953888888889,NULL,NULL,'2012-12-22 01:43:21',56283.0717799999,20.0511,0.1664,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_87861.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(8635,6188,0,'LSQ12gwk','LSQ',44.366125,-25.3955,NULL,NULL,'2012-12-22 03:45:11',56283.1563800001,19.7323,0.1553,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_history.html','sne?',NULL,0.0635,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwk/LSQ12gwk_snap_87862.gif',38420060782,NULL,NULL,NULL,'2012-11-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600313449,9379897,NULL,NULL,NULL,NULL),(8636,7106,0,'LSQ12gxv','LSQ',70.4217916666667,-22.1970555555556,NULL,NULL,'2012-12-22 02:56:54',56283.1228499999,19.4833,0.1903,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_history.html','sne - nice',NULL,0.066686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_snap_87560.gif',37340201662,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583440650,9116260,NULL,NULL,NULL,NULL),(8637,7243,0,'LSQ12gzm','LSQ',40.1817083333333,-34.7405277777778,NULL,NULL,'2012-12-22 01:34:54',56283.0659099999,16.801,0.0706,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_snap_87578.gif',38633055142,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603641486,9431898,NULL,NULL,NULL,NULL),(8638,7243,0,'LSQ12gzm','LSQ',40.1817083333333,-34.7404722222222,NULL,NULL,'2012-12-22 03:36:44',56283.1505100001,18.896,0.0929,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gzm/LSQ12gzm_snap_87579.gif',38633055142,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603641486,9431898,NULL,NULL,NULL,NULL),(8639,7417,0,'LSQ12hcu','LSQ',59.0952083333333,-36.5750277777778,NULL,NULL,'2012-12-22 04:31:33',56283.1885799998,19.3202,0.1459,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_history.html','sn?',NULL,0.07532,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcu/LSQ12hcu_snap_87683.gif',37679401788,NULL,NULL,NULL,'2012-11-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588740652,9199072,NULL,NULL,NULL,NULL),(8640,7456,0,'LSQ12hdn','LSQ',63.7042083333333,-32.2960555555556,NULL,NULL,'2012-12-22 04:36:40',56283.1921299999,19.5808,0.1935,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_snap_87786.gif',37709622178,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589212846,9206450,NULL,NULL,NULL,NULL),(8641,7613,0,'LSQ12hje','LSQ',77.1708333333333,-20.9645,NULL,NULL,'2012-12-22 03:24:08',56283.1417700001,18.4072,0.0725,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_87695.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(8642,7613,0,'LSQ12hje','LSQ',77.1707916666667,-20.9644722222222,NULL,NULL,'2012-12-22 05:33:12',56283.2313899999,18.4985,0.0628,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_87696.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(8643,7751,0,'LSQ12hle','LSQ',61.1044166666667,-29.1577222222222,NULL,NULL,'2012-12-22 02:27:55',56283.1027299999,19.0695,0.0736,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_snap_87718.gif',38530541650,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602039713,9406870,NULL,NULL,NULL,NULL),(8644,8046,0,'LSQ12hnj','LSQ',78.1033333333333,-25.7825555555556,NULL,NULL,'2012-12-22 03:20:46',56283.13943,15.5748,0.005,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_87748.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8645,8046,0,'LSQ12hnj','LSQ',78.102625,-25.7826111111111,NULL,NULL,'2012-12-22 03:22:27',56283.1406,15.8004,0.0051,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_87750.gif',37249489807,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8646,8046,0,'LSQ12hnj','LSQ',78.103375,-25.7825833333333,NULL,NULL,'2012-12-22 05:29:49',56283.2290500002,15.5583,0.0046,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_87749.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8647,8046,0,'LSQ12hnj','LSQ',78.1026666666667,-25.7826111111111,NULL,NULL,'2012-12-22 05:31:31',56283.2302199998,15.8091,0.005,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_87751.gif',37249489805,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8648,8053,0,'LSQ12hnh','LSQ',53.7745833333333,-26.7649722222222,NULL,NULL,'2012-12-22 01:25:47',56283.0595800001,20.6738,0.1395,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnh/LSQ12hnh_snap_87765.gif',38579501934,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602804717,9418823,NULL,NULL,NULL,NULL),(8649,8062,0,'LSQ12hnc','LSQ',41.6074166666667,-33.4241388888889,NULL,NULL,'2012-12-22 01:41:40',56283.0706099998,18.9134,0.177,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnc/LSQ12hnc_snap_87764.gif',38638592817,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603728012,9433250,NULL,NULL,NULL,NULL),(8650,8228,0,'LSQ12hon','LSQ',57.8935,-24.2263611111111,NULL,NULL,'2012-12-22 02:22:29',56283.09895,19.1808,0.1337,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_87548.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(8651,8228,0,'LSQ12hon','LSQ',57.8934166666667,-24.2263333333333,NULL,NULL,'2012-12-22 04:24:33',56283.1837200001,19.0143,0.1196,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_87549.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(8652,8233,0,'LSQ12hnu','LSQ',56.4025416666667,-37.7380277777778,NULL,NULL,'2012-12-22 02:15:42',56283.09424,19.0632,0.0567,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_87601.gif',38557895446,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8653,8233,0,'LSQ12hnu','LSQ',56.4025,-37.7380555555556,NULL,NULL,'2012-12-22 04:17:47',56283.1790200002,19.0859,0.0545,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_87602.gif',38557895446,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8654,8253,0,'LSQ12hnt','LSQ',40.3975833333333,-38.8373055555556,NULL,NULL,'2012-12-22 01:33:12',56283.0647300002,19.5364,0.1306,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_history.html','sn?',NULL,0.107584,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnt/LSQ12hnt_snap_87605.gif',38636244301,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603691317,9432676,NULL,NULL,NULL,NULL),(8655,8387,0,'LSQ12hpj','LSQ',72.1,-31.2976666666667,NULL,NULL,'2012-12-22 03:05:30',56283.1288200002,19.8163,0.197,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_snap_87644.gif',37204796368,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581324943,9083202,NULL,NULL,NULL,NULL),(8656,8412,0,'LSQ12hpy','LSQ',79.2730416666667,-24.5449444444444,NULL,NULL,'2012-12-22 05:33:12',56283.2313899999,20.3215,0.1715,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpy/LSQ12hpy_snap_87663.gif',37131195893,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580174935,9065233,NULL,NULL,NULL,NULL),(8657,8576,0,'LSQ12hse','LSQ',180.093416666667,-21.8911111111111,NULL,NULL,'2012-12-22 06:24:27',56283.2669799998,19.7283,0.0932,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_snap_87698.gif',43016918031,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,672139344,10502177,NULL,NULL,NULL,NULL),(8658,8576,0,'LSQ12hse','LSQ',180.093416666667,-21.8914166666667,NULL,NULL,'2012-12-22 07:38:15',56283.3182399999,20.1039,0.1993,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 13:46:20','2012-12-22 13:46:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_snap_87699.gif',43016918029,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,672139344,10502177,NULL,NULL,NULL,NULL),(8668,8668,1,'LSQ12huk','LSQ',39.721125,-34.8220833333333,NULL,NULL,'2012-12-04 04:23:19',56265.1828700001,19.9767,0.2046,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 18:47:51','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huk/LSQ12huk_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huk/LSQ12huk_snap_87916.gif',38633535789,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603648996,9432015,NULL,NULL,NULL,NULL),(8669,8668,0,'LSQ12huk','LSQ',39.721125,-34.8220555555556,NULL,NULL,'2012-12-06 02:17:27',56267.09546,18.8142,0.1247,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 18:47:51','2012-12-22 18:47:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huk/LSQ12huk_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huk/LSQ12huk_snap_87917.gif',38633535789,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603648996,9432015,NULL,NULL,NULL,NULL),(8670,8668,0,'LSQ12huk','LSQ',39.721125,-34.8220833333333,NULL,NULL,'2012-12-08 02:14:01',56269.0930699999,18.655,0.1549,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 18:47:51','2012-12-22 18:47:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huk/LSQ12huk_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huk/LSQ12huk_snap_87918.gif',38633535789,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603648996,9432015,NULL,NULL,NULL,NULL),(8671,8668,0,'LSQ12huk','LSQ',39.7210833333333,-34.8221666666667,NULL,NULL,'2012-12-08 04:14:52',56269.1770000001,18.9369,0.1431,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 18:47:51','2012-12-22 18:47:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huk/LSQ12huk_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huk/LSQ12huk_snap_87919.gif',38633535789,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603648996,9432015,NULL,NULL,NULL,NULL),(8672,8668,0,'LSQ12huk','LSQ',39.7210416666667,-34.8221111111111,NULL,NULL,'2012-12-12 04:07:16',56273.17172,18.8536,0.108,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 18:47:51','2012-12-22 18:47:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huk/LSQ12huk_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huk/LSQ12huk_snap_87920.gif',38633535789,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603648996,9432015,NULL,NULL,NULL,NULL),(8673,8668,0,'LSQ12huk','LSQ',39.7210416666667,-34.8221111111111,NULL,NULL,'2012-12-16 01:49:18',56277.0759100001,18.4299,0.0988,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 18:47:51','2012-12-22 18:47:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huk/LSQ12huk_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huk/LSQ12huk_snap_87921.gif',38633535789,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603648996,9432015,NULL,NULL,NULL,NULL),(8674,8668,0,'LSQ12huk','LSQ',39.7209583333333,-34.8220833333333,NULL,NULL,'2012-12-22 01:33:12',56283.0647300002,18.2239,0.0948,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 18:47:51','2012-12-22 18:47:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huk/LSQ12huk_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huk/LSQ12huk_snap_87914.gif',38633535789,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603648996,9432015,NULL,NULL,NULL,NULL),(8675,8668,0,'LSQ12huk','LSQ',39.7209583333333,-34.8221111111111,NULL,NULL,'2012-12-22 03:35:02',56283.1493299999,18.0456,0.091,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 18:47:51','2012-12-22 18:47:51','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huk/LSQ12huk_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huk/LSQ12huk_snap_87915.gif',38633535789,NULL,NULL,NULL,'2012-12-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,603648996,9432015,NULL,NULL,NULL,NULL),(8676,8676,1,'LSQ12hvd','LSQ',42.1379166666667,-29.5781666666667,NULL,NULL,'2012-12-10 04:22:14',56271.1821099999,20.0131,0.142,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 20:46:23','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvd/LSQ12hvd_history.html','sn?',NULL,0.007138,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvd/LSQ12hvd_snap_88213.gif',38610779539,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603293430,9426459,NULL,NULL,NULL,NULL),(8677,8676,0,'LSQ12hvd','LSQ',42.1379583333333,-29.5783055555556,NULL,NULL,'2012-12-16 01:54:23',56277.07944,20.2538,0.1581,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 20:46:23','2012-12-22 20:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvd/LSQ12hvd_history.html','sn?',NULL,0.007138,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvd/LSQ12hvd_snap_88214.gif',38610779539,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603293430,9426459,NULL,NULL,NULL,NULL),(8678,8676,0,'LSQ12hvd','LSQ',42.1379166666667,-29.57825,NULL,NULL,'2012-12-16 03:54:12',56277.1626499998,20.3067,0.1508,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 20:46:23','2012-12-22 20:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvd/LSQ12hvd_history.html','sn?',NULL,0.007138,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvd/LSQ12hvd_snap_88215.gif',38610779539,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603293430,9426459,NULL,NULL,NULL,NULL),(8679,8676,0,'LSQ12hvd','LSQ',42.1381666666667,-29.5783611111111,NULL,NULL,'2012-12-18 01:55:47',56279.0804099999,19.9953,0.1785,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 20:46:23','2012-12-22 20:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvd/LSQ12hvd_history.html','sn?',NULL,0.007138,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvd/LSQ12hvd_snap_88216.gif',38610779539,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603293430,9426459,NULL,NULL,NULL,NULL),(8680,8676,0,'LSQ12hvd','LSQ',42.137625,-29.57825,NULL,NULL,'2012-12-22 01:38:17',56283.0682600001,19.3255,0.1297,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 20:46:23','2012-12-22 20:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvd/LSQ12hvd_history.html','sn?',NULL,0.007138,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvd/LSQ12hvd_snap_88152.gif',38610779536,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603293430,9426459,NULL,NULL,NULL,NULL),(8681,8676,0,'LSQ12hvd','LSQ',42.13775,-29.5782777777778,NULL,NULL,'2012-12-22 03:40:07',56283.1528599998,19.4466,0.1392,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 20:46:23','2012-12-22 20:46:23','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvd/LSQ12hvd_history.html','sn?',NULL,0.007138,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvd/LSQ12hvd_snap_88153.gif',38610779539,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,603293430,9426459,NULL,NULL,NULL,NULL),(8682,8682,0,'LSQ12hvv','LSQ',180.738333333333,-24.8483333333333,NULL,NULL,'2012-12-20 07:02:39',56281.2935100002,14.9171,0.0028,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2019-10-11 20:38:49','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvv/LSQ12hvv_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvv/LSQ12hvv_snap_88388.gif',43367150291,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,677611723,10587683,NULL,NULL,NULL,NULL),(8683,8682,0,'LSQ12hvv','LSQ',180.738375,-24.8482777777778,NULL,NULL,'2012-12-20 07:51:22',56281.3273399998,14.8533,0.0037,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvv/LSQ12hvv_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvv/LSQ12hvv_snap_88389.gif',43367150291,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,677611723,10587683,NULL,NULL,NULL,NULL),(8684,8682,0,'LSQ12hvv','LSQ',180.738333333333,-24.8483611111111,NULL,NULL,'2012-12-22 06:26:09',56283.26816,16.9578,0.0098,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvv/LSQ12hvv_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvv/LSQ12hvv_snap_88190.gif',43367150291,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,677611723,10587683,NULL,NULL,NULL,NULL),(8685,8682,0,'LSQ12hvv','LSQ',180.738333333333,-24.8483333333333,NULL,NULL,'2012-12-22 07:33:12',56283.3147300002,16.9646,0.0099,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvv/LSQ12hvv_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvv/LSQ12hvv_snap_88191.gif',43367150291,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,677611723,10587683,NULL,NULL,NULL,NULL),(8686,8686,1,'LSQ12hvj','LSQ',166.910958333333,-29.7113611111111,NULL,NULL,'2012-12-20 07:15:05',56281.3021499999,18.5618,0.0552,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_88211.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(8687,8686,0,'LSQ12hvj','LSQ',166.910958333333,-29.7114166666667,NULL,NULL,'2012-12-22 05:39:32',56283.2357899998,18.169,0.0491,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-30 09:16:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_88164.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(8688,8686,0,'LSQ12hvj','LSQ',166.910875,-29.7113611111111,NULL,NULL,'2012-12-22 07:31:30',56283.3135500001,18.0351,0.0405,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-30 09:16:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_88165.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(8689,8689,1,'LSQ12huy','LSQ',51.803875,-34.4969444444444,NULL,NULL,'2012-10-25 07:48:24',56225.32528,19.0897,0.0811,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88108.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8690,8689,0,'LSQ12huy','LSQ',51.8037916666667,-34.4968888888889,NULL,NULL,'2012-10-26 04:54:51',56226.2047600001,19.2827,0.1005,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88109.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8691,8689,0,'LSQ12huy','LSQ',51.8037916666667,-34.4968611111111,NULL,NULL,'2012-10-26 06:55:24',56226.2884800001,19.1144,0.0885,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88110.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8692,8689,0,'LSQ12huy','LSQ',51.8037083333333,-34.4968055555556,NULL,NULL,'2012-11-01 04:47:43',56232.1998100001,19.1915,0.1101,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88111.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8693,8689,0,'LSQ12huy','LSQ',51.8039166666667,-34.4969444444444,NULL,NULL,'2012-11-01 06:48:43',56232.2838400002,19.1519,0.0965,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88112.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8694,8689,0,'LSQ12huy','LSQ',51.803875,-34.4968888888889,NULL,NULL,'2012-11-03 04:48:49',56234.2005699999,19.305,0.1005,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88113.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8695,8689,0,'LSQ12huy','LSQ',51.8037916666667,-34.4970555555556,NULL,NULL,'2012-11-05 05:09:10',56236.2146999999,20.071,0.1281,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88114.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8696,8689,0,'LSQ12huy','LSQ',51.803875,-34.4968611111111,NULL,NULL,'2012-11-05 06:59:06',56236.2910500001,19.1668,0.0776,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88115.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8697,8689,0,'LSQ12huy','LSQ',51.8038333333333,-34.4968611111111,NULL,NULL,'2012-11-07 05:36:53',56238.2339499998,18.7411,0.0667,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88116.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8698,8689,0,'LSQ12huy','LSQ',51.8037916666667,-34.497,NULL,NULL,'2012-11-07 07:12:25',56238.3002900002,19.7434,0.1203,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88117.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8699,8689,0,'LSQ12huy','LSQ',51.8039166666667,-34.4968888888889,NULL,NULL,'2012-11-09 07:02:46',56240.2935899999,19.2863,0.0679,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88118.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8700,8689,0,'LSQ12huy','LSQ',51.804,-34.4968888888889,NULL,NULL,'2012-11-11 05:46:46',56242.2408199999,19.0781,0.085,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88119.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8701,8689,0,'LSQ12huy','LSQ',51.8040416666667,-34.4968611111111,NULL,NULL,'2012-11-11 08:07:41',56242.33867,18.9948,0.0645,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88120.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8702,8689,0,'LSQ12huy','LSQ',51.8036666666667,-34.4968888888889,NULL,NULL,'2012-11-15 07:08:23',56246.2974999999,19.3673,0.0783,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88121.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8703,8689,0,'LSQ12huy','LSQ',51.8037916666667,-34.4968333333333,NULL,NULL,'2012-11-19 02:37:39',56250.1094900002,19.006,0.0787,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88122.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8704,8689,0,'LSQ12huy','LSQ',51.8039166666667,-34.4968888888889,NULL,NULL,'2012-11-19 04:37:33',56250.1927499999,19.5682,0.0799,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88123.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8705,8689,0,'LSQ12huy','LSQ',51.8036666666667,-34.4968888888889,NULL,NULL,'2012-11-21 02:33:29',56252.10659,19.1415,0.0807,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88124.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8706,8689,0,'LSQ12huy','LSQ',51.8037916666667,-34.4968333333333,NULL,NULL,'2012-11-21 04:34:50',56252.19086,18.7837,0.0741,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88125.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8707,8689,0,'LSQ12huy','LSQ',51.8038333333333,-34.4968055555556,NULL,NULL,'2012-11-23 02:28:53',56254.1033999999,19.0013,0.0793,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88126.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8708,8689,0,'LSQ12huy','LSQ',51.8037083333333,-34.4968888888889,NULL,NULL,'2012-11-23 04:29:21',56254.1870599999,19.5743,0.1261,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88127.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8709,8689,0,'LSQ12huy','LSQ',51.803875,-34.4968611111111,NULL,NULL,'2012-11-24 02:48:45',56255.1171900001,19.1283,0.1237,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88128.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8710,8689,0,'LSQ12huy','LSQ',51.803875,-34.4969166666667,NULL,NULL,'2012-11-24 04:49:23',56255.2009700001,19.6808,0.1318,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88129.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8711,8689,0,'LSQ12huy','LSQ',51.8039583333333,-34.4969166666667,NULL,NULL,'2012-11-26 02:51:02',56257.1187800001,19.3316,0.1407,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88130.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8712,8689,0,'LSQ12huy','LSQ',51.8037083333333,-34.497,NULL,NULL,'2012-11-26 04:51:47',56257.2026300002,19.836,0.1319,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88131.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8713,8689,0,'LSQ12huy','LSQ',51.8036666666667,-34.4968888888889,NULL,NULL,'2012-12-04 02:58:33',56265.1239999998,19.248,0.078,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88132.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8714,8689,0,'LSQ12huy','LSQ',51.80375,-34.4968888888889,NULL,NULL,'2012-12-04 04:57:20',56265.2064899998,19.2254,0.0829,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88133.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8715,8689,0,'LSQ12huy','LSQ',51.8037916666667,-34.4969722222222,NULL,NULL,'2012-12-06 02:53:05',56267.1201999998,19.8201,0.119,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88134.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8716,8689,0,'LSQ12huy','LSQ',51.8040833333333,-34.4968611111111,NULL,NULL,'2012-12-08 02:49:37',56269.11779,19.3995,0.1075,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88135.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8717,8689,0,'LSQ12huy','LSQ',51.8038333333333,-34.4968055555556,NULL,NULL,'2012-12-08 04:50:25',56269.2016799999,19.2689,0.0828,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88136.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8718,8689,0,'LSQ12huy','LSQ',51.803875,-34.4968333333333,NULL,NULL,'2012-12-10 02:53:28',56271.12047,18.7527,0.0718,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88137.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8719,8689,0,'LSQ12huy','LSQ',51.8037916666667,-34.4969166666667,NULL,NULL,'2012-12-12 02:40:44',56273.1116300002,19.6617,0.0764,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88138.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8720,8689,0,'LSQ12huy','LSQ',51.80375,-34.4970833333333,NULL,NULL,'2012-12-12 04:42:48',56273.1963900002,20.6811,0.1711,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88139.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8721,8689,0,'LSQ12huy','LSQ',51.804,-34.4967777777778,NULL,NULL,'2012-12-16 02:24:49',56277.1005699998,19.5028,0.0865,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88140.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8722,8689,0,'LSQ12huy','LSQ',51.803875,-34.4967777777778,NULL,NULL,'2012-12-16 04:24:48',56277.18389,18.8555,0.0523,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88141.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8723,8689,0,'LSQ12huy','LSQ',51.8036666666667,-34.4968611111111,NULL,NULL,'2012-12-18 02:26:15',56279.1015699999,19.4749,0.1147,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88142.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8724,8689,0,'LSQ12huy','LSQ',51.8038333333333,-34.4968611111111,NULL,NULL,'2012-12-18 04:26:55',56279.1853700001,19.4417,0.0918,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_88143.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8725,8689,0,'LSQ12huy','LSQ',51.8037083333333,-34.4969444444444,NULL,NULL,'2012-12-22 02:08:51',56283.0894800001,19.1331,0.0979,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_87982.gif',38564019816,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562809,9415043,NULL,NULL,NULL,NULL),(8726,8689,0,'LSQ12huy','LSQ',51.803875,-34.4968888888889,NULL,NULL,'2012-12-22 04:10:56',56283.1742699998,19.1605,0.0894,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-22 21:46:24','2012-12-22 21:46:24','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12huy/LSQ12huy_snap_87983.gif',38564019940,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602562811,9415043,NULL,NULL,NULL,NULL),(8727,8504,0,'PSNJ10532275+1646349','CBET',163.34479,16.77636,NULL,NULL,'2012-12-20 12:00:00',56281.5,NULL,NULL,NULL,0.003559,NULL,'Ia',NULL,'2012-12-22 22:38:54','2012-12-22 22:38:54','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,61200554061,'MMT','Blue','Milisavljevic',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,956258657,14941541,NULL,NULL,NULL,NULL),(8729,6109,0,'LSQ12gwg','LSQ',71.3165833333333,-29.07075,NULL,NULL,'2012-12-23 04:43:31',56284.1968899998,19.8368,0.191,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwg/LSQ12gwg_snap_88718.gif',37239015777,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581859621,9091556,NULL,NULL,NULL,NULL),(8730,6132,0,'LSQ12gwb','LSQ',54.008375,-29.7770833333333,NULL,NULL,'2012-12-23 03:47:09',56284.1577499998,20.627,0.1734,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_history.html','sn?',NULL,0.1516,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwb/LSQ12gwb_snap_88717.gif',38584840201,NULL,NULL,NULL,'2012-11-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602888128,9420127,NULL,NULL,NULL,NULL),(8731,6150,0,'LSQ12gvs','LSQ',64.3945,-38.8896111111111,NULL,NULL,'2012-12-23 02:17:08',56284.0952400002,20.4707,0.1643,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gvs/LSQ12gvs_snap_88709.gif',37791067653,NULL,NULL,NULL,'2012-11-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,590485432,9226334,NULL,NULL,NULL,NULL),(8732,6182,0,'LSQ12gwl','LSQ',55.02175,-21.5047222222222,NULL,NULL,'2012-12-23 01:44:49',56284.0728000002,19.8957,0.1185,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_history.html','sne?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gwl/LSQ12gwl_snap_88719.gif',38047180768,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594487199,9288862,NULL,NULL,NULL,NULL),(8733,7445,0,'LSQ12heq','LSQ',53.2673333333333,-28.21375,NULL,NULL,'2012-12-23 01:48:13',56284.07516,19.0537,0.0693,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_88529.gif',38581253600,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(8734,7445,0,'LSQ12heq','LSQ',53.2673333333333,-28.21375,NULL,NULL,'2012-12-23 03:48:52',56284.15894,18.9671,0.0747,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_88530.gif',38581253600,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(8735,7456,0,'LSQ12hdn','LSQ',63.7042083333333,-32.2959444444444,NULL,NULL,'2012-12-23 02:10:21',56284.0905300002,19.2672,0.1808,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_snap_88637.gif',37709622209,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589212847,9206450,NULL,NULL,NULL,NULL),(8736,7613,0,'LSQ12hje','LSQ',77.1707916666667,-20.9645,NULL,NULL,'2012-12-23 02:57:54',56284.1235500001,18.4556,0.0652,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_88519.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(8737,7613,0,'LSQ12hje','LSQ',77.17075,-20.9645,NULL,NULL,'2012-12-23 04:58:48',56284.2075,18.5222,0.0804,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_88520.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(8738,7746,0,'LSQ12hlf','LSQ',66.601375,-28.8988888888889,NULL,NULL,'2012-12-23 04:28:06',56284.1861899998,18.8022,0.0962,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlf/LSQ12hlf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlf/LSQ12hlf_snap_88549.gif',37660496843,NULL,NULL,NULL,'2012-11-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588445263,9194457,NULL,NULL,NULL,NULL),(8739,7751,0,'LSQ12hle','LSQ',61.1043333333333,-29.1578055555556,NULL,NULL,'2012-12-23 02:01:52',56284.0846299999,18.9306,0.0655,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_snap_88546.gif',38530541650,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602039713,9406870,NULL,NULL,NULL,NULL),(8740,7751,0,'LSQ12hle','LSQ',61.1042916666667,-29.1577222222222,NULL,NULL,'2012-12-23 04:02:28',56284.1683899998,19.007,0.0673,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_snap_88547.gif',38530541650,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602039713,9406870,NULL,NULL,NULL,NULL),(8741,8046,0,'LSQ12hnj','LSQ',78.10325,-25.7825,NULL,NULL,'2012-12-23 02:54:31',56284.1211999999,15.6064,0.0055,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_88584.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8742,8046,0,'LSQ12hnj','LSQ',78.103375,-25.7825833333333,NULL,NULL,'2012-12-23 04:55:25',56284.2051599999,15.532,0.0055,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_88585.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8743,8046,0,'LSQ12hnj','LSQ',78.1027083333333,-25.7826111111111,NULL,NULL,'2012-12-23 04:57:06',56284.20633,15.7794,0.0064,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_88586.gif',37249489805,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8744,8228,0,'LSQ12hon','LSQ',57.893375,-24.2263611111111,NULL,NULL,'2012-12-23 01:58:28',56284.0822700001,18.8266,0.1264,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_88403.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(8745,8228,0,'LSQ12hon','LSQ',57.8934583333333,-24.2263055555556,NULL,NULL,'2012-12-23 03:59:05',56284.16604,18.9781,0.1471,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_88404.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(8746,8233,0,'LSQ12hnu','LSQ',56.4025833333333,-37.7380555555556,NULL,NULL,'2012-12-23 03:52:18',56284.16132,19.2639,0.0648,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_88447.gif',38557895446,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8747,8250,0,'LSQ12hnv','LSQ',55.3599583333333,-37.8418333333333,NULL,NULL,'2012-12-23 03:52:18',56284.16132,20.0274,0.1765,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnv/LSQ12hnv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnv/LSQ12hnv_snap_88390.gif',38557694822,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602463981,9413499,NULL,NULL,NULL,NULL),(8748,8387,0,'LSQ12hpj','LSQ',72.1000833333333,-31.2977222222222,NULL,NULL,'2012-12-23 02:39:19',56284.1106400001,19.7996,0.2031,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_snap_88491.gif',37204796368,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581324943,9083202,NULL,NULL,NULL,NULL),(8749,8387,0,'LSQ12hpj','LSQ',72.0999166666667,-31.2976666666667,NULL,NULL,'2012-12-23 04:40:08',56284.1945400001,19.7424,0.1985,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hpj/LSQ12hpj_snap_88492.gif',37204796368,NULL,NULL,NULL,'2012-12-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581324943,9083202,NULL,NULL,NULL,NULL),(8750,8408,0,'LSQ12hqa','LSQ',160.241166666667,-21.7815555555556,NULL,NULL,'2012-12-23 05:18:50',56284.2214199998,20.3556,0.1723,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_snap_88499.gif',41668171452,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,651065178,10172893,NULL,NULL,NULL,NULL),(8751,8576,0,'LSQ12hse','LSQ',180.093625,-21.891,NULL,NULL,'2012-12-23 06:20:00',56284.2638900001,18.3883,0.0674,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_snap_88533.gif',43016918029,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,672139344,10502177,NULL,NULL,NULL,NULL),(8752,8576,0,'LSQ12hse','LSQ',180.094,-21.8911944444444,NULL,NULL,'2012-12-23 07:32:42',56284.3143799999,19.7787,0.0963,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_snap_88534.gif',43016918029,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,672139344,10502177,NULL,NULL,NULL,NULL),(8753,8682,0,'LSQ12hvv','LSQ',180.738416666667,-24.8483611111111,NULL,NULL,'2012-12-23 06:21:42',56284.2650700002,19.1044,0.0628,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvv/LSQ12hvv_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvv/LSQ12hvv_snap_88654.gif',43367150291,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,677611723,10587683,NULL,NULL,NULL,NULL),(8754,8682,0,'LSQ12hvv','LSQ',180.738333333333,-24.8483333333333,NULL,NULL,'2012-12-23 07:31:01',56284.3132099998,18.4531,0.0331,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-23 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvv/LSQ12hvv_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvv/LSQ12hvv_snap_88655.gif',43367150291,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,677611723,10587683,NULL,NULL,NULL,NULL),(8755,8686,0,'LSQ12hvj','LSQ',166.910916666667,-29.7114166666667,NULL,NULL,'2012-12-23 05:34:23',56284.2322200001,18.2653,0.0544,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-30 09:16:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_88635.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(8756,8686,0,'LSQ12hvj','LSQ',166.910958333333,-29.7114166666667,NULL,NULL,'2012-12-23 07:08:13',56284.2973799999,18.3194,0.0351,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-23 15:46:18','2012-12-30 09:16:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_88636.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(8817,7075,0,'LSQ12gxb','LSQ',142.838875,-11.6295833333333,NULL,NULL,'2012-12-24 07:07:26',56285.29684,20.3583,0.0658,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 13:46:15','2012-12-24 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_snap_88781.gif',42178887818,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,659045122,10297580,NULL,NULL,NULL,NULL),(8818,7094,0,'LSQ12gye','LSQ',161.594666666667,-20.3264722222222,NULL,NULL,'2012-12-24 08:35:07',56285.3577200002,17.9787,0.0205,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 13:46:15','2012-12-24 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gye/LSQ12gye_history.html','possible asteroid',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gye/LSQ12gye_snap_88774.gif',41631758262,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650496222,10164003,NULL,NULL,NULL,NULL),(8819,7096,0,'LSQ12gyd','LSQ',76.387125,-18.0351666666667,NULL,NULL,'2012-12-24 02:53:24',56285.1204200001,18.707,0.0621,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 13:46:15','2012-12-24 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_88776.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(8820,7096,0,'LSQ12gyd','LSQ',76.3870833333333,-18.0351111111111,NULL,NULL,'2012-12-24 04:54:45',56285.20469,18.7442,0.0698,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 13:46:15','2012-12-24 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_88777.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(8821,7344,0,'LSQ12hbz','LSQ',160.317666666667,-14.5201388888889,NULL,NULL,'2012-12-24 08:26:38',56285.3518400001,18.2079,0.0307,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 13:46:15','2012-12-24 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbz/LSQ12hbz_history.html','sn hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hbz/LSQ12hbz_snap_88805.gif',41838987210,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653734175,10214596,NULL,NULL,NULL,NULL),(8822,7507,0,'LSQ12hgj','LSQ',154.207375,-16.1958055555556,NULL,NULL,'2012-12-24 05:19:39',56285.22199,19.8612,0.1369,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 13:46:15','2012-12-24 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_snap_88865.gif',41166665804,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643229153,10050455,NULL,NULL,NULL,NULL),(8823,7894,0,'LSQ12hlz','LSQ',74.4072083333333,-15.31675,NULL,NULL,'2012-12-24 02:48:21',56285.1169099999,18.8449,0.1046,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 13:46:15','2012-12-24 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_88862.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(8824,7894,0,'LSQ12hlz','LSQ',74.40725,-15.31675,NULL,NULL,'2012-12-24 04:49:40',56285.2011600002,18.8705,0.1193,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 13:46:15','2012-12-24 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_88863.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(8825,7909,0,'LSQ12hmy','LSQ',136.547291666667,-2.21369444444444,NULL,NULL,'2012-12-24 06:25:31',56285.26773,19.8474,0.1198,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 13:46:15','2012-12-24 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_snap_88864.gif',42146871440,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,658544866,10289763,NULL,NULL,NULL,NULL),(8826,8208,0,'LSQ12hno','LSQ',55.680125,-2.66938888888889,NULL,NULL,'2012-12-24 01:29:57',56285.0624699998,17.4034,0.0607,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 13:46:15','2013-01-03 13:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_88849.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(8827,8208,0,'LSQ12hno','LSQ',55.6802083333333,-2.66944444444444,NULL,NULL,'2012-12-24 03:31:15',56285.14671,17.3639,0.052,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 13:46:15','2013-01-03 13:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_88850.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(8828,8216,0,'LSQ12hns','LSQ',167.904208333333,-10.7736388888889,NULL,NULL,'2012-12-24 06:14:55',56285.2603600002,18.7589,0.0881,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 13:46:15','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hns/LSQ12hns_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hns/LSQ12hns_snap_88772.gif',40886241208,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638847518,9981992,NULL,NULL,NULL,NULL),(8829,8218,0,'LSQ12hnr','LSQ',160.811541666667,-8.778,NULL,NULL,'2012-12-24 06:01:21',56285.2509400002,18.7563,0.1032,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 13:46:15','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_snap_88768.gif',41807774750,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653246480,10206976,NULL,NULL,NULL,NULL),(8830,8218,0,'LSQ12hnr','LSQ',160.811541666667,-8.77797222222222,NULL,NULL,'2012-12-24 08:09:40',56285.3400500002,18.7642,0.0681,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 13:46:15','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_snap_88769.gif',41807774750,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653246480,10206976,NULL,NULL,NULL,NULL),(8831,8624,0,'LSQ12htf','LSQ',163.3945,-10.6360555555556,NULL,NULL,'2012-12-24 06:06:27',56285.2544800001,19.359,0.1069,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 13:46:15','2012-12-24 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htf/LSQ12htf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htf/LSQ12htf_snap_88823.gif',41786968109,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,652921376,10201896,NULL,NULL,NULL,NULL),(8832,8624,0,'LSQ12htf','LSQ',163.394541666667,-10.6360833333333,NULL,NULL,'2012-12-24 08:07:59',56285.3388800002,19.8337,0.0878,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 13:46:15','2012-12-24 13:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htf/LSQ12htf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htf/LSQ12htf_snap_88824.gif',41786968109,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,652921376,10201896,NULL,NULL,NULL,NULL),(8875,8875,1,'LSQ12hxo','LSQ',141.212708333333,21.6440277777778,NULL,NULL,'2012-12-24 06:48:11',56285.2834700001,19.2066,0.0758,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxo/LSQ12hxo_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxo/LSQ12hxo_snap_89540.gif',63708583584,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,995446618,15553853,NULL,NULL,NULL,NULL),(8876,8875,0,'LSQ12hxo','LSQ',141.212625,21.6440277777778,NULL,NULL,'2012-12-24 07:44:45',56285.3227499998,19.2925,0.0653,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxo/LSQ12hxo_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxo/LSQ12hxo_snap_89541.gif',63708583584,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,995446618,15553853,NULL,NULL,NULL,NULL),(8877,8877,1,'LSQ12hxn','LSQ',141.167333333333,22.4341666666667,NULL,NULL,'2012-12-24 06:48:11',56285.2834700001,17.6214,0.0294,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxn/LSQ12hxn_history.html','sn nice',NULL,0.07849,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxn/LSQ12hxn_snap_89538.gif',63715766096,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,995558845,15555606,NULL,NULL,NULL,NULL),(8878,8877,0,'LSQ12hxn','LSQ',141.167291666667,22.4341111111111,NULL,NULL,'2012-12-24 07:44:45',56285.3227499998,17.5897,0.0281,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2013-01-03 17:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxn/LSQ12hxn_history.html','sn nice',NULL,0.07849,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxn/LSQ12hxn_snap_89539.gif',63715766096,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,995558845,15555606,NULL,NULL,NULL,NULL),(8879,8879,1,'LSQ12hxi','LSQ',61.6559583333333,-0.729944444444445,NULL,NULL,'2012-11-14 06:24:52',56245.2672799998,19.0176,0.1229,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_snap_89581.gif',36935907237,NULL,NULL,NULL,'2012-11-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577123550,9017555,NULL,NULL,NULL,NULL),(8880,8879,0,'LSQ12hxi','LSQ',61.6560833333333,-0.730111111111111,NULL,NULL,'2012-11-16 06:08:26',56247.2558599999,19.3243,0.1788,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_snap_89582.gif',36935907237,NULL,NULL,NULL,'2012-11-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577123550,9017555,NULL,NULL,NULL,NULL),(8881,8879,0,'LSQ12hxi','LSQ',61.655875,-0.730027777777778,NULL,NULL,'2012-11-16 07:24:25',56247.3086299999,19.5052,0.164,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_snap_89583.gif',36935907244,NULL,NULL,NULL,'2012-11-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577123550,9017555,NULL,NULL,NULL,NULL),(8882,8879,0,'LSQ12hxi','LSQ',61.655875,-0.730194444444444,NULL,NULL,'2012-11-22 04:28:24',56253.1863899999,18.902,0.1571,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_snap_89584.gif',36935907244,NULL,NULL,NULL,'2012-11-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577123550,9017555,NULL,NULL,NULL,NULL),(8883,8879,0,'LSQ12hxi','LSQ',61.6558333333333,-0.730138888888889,NULL,NULL,'2012-12-24 01:48:48',56285.0755599998,18.4624,0.1143,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_snap_89528.gif',36935907244,NULL,NULL,NULL,'2012-11-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577123550,9017555,NULL,NULL,NULL,NULL),(8884,8879,0,'LSQ12hxi','LSQ',61.6557916666667,-0.730027777777778,NULL,NULL,'2012-12-24 03:50:06',56285.1598,18.7083,0.1445,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_snap_89529.gif',36935907244,NULL,NULL,NULL,'2012-11-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577123550,9017555,NULL,NULL,NULL,NULL),(8885,8885,1,'LSQ12hxh','LSQ',56.314375,-1.87122222222222,NULL,NULL,'2012-11-12 02:50:55',56243.1187,20.4447,0.1706,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_snap_89573.gif',36997676022,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'CV',NULL,0,NULL,0,578088687,9032635,NULL,NULL,NULL,NULL),(8886,8885,0,'LSQ12hxh','LSQ',56.3143333333333,-1.87116666666667,NULL,NULL,'2012-11-14 05:10:27',56245.2156000002,19.9987,0.1407,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_snap_89574.gif',36997676022,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'CV',NULL,0,NULL,0,578088687,9032635,NULL,NULL,NULL,NULL),(8887,8885,0,'LSQ12hxh','LSQ',56.314375,-1.87116666666667,NULL,NULL,'2012-11-16 02:34:33',56247.10733,20.1097,0.1501,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_snap_89575.gif',36997676022,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'CV',NULL,0,NULL,0,578088687,9032635,NULL,NULL,NULL,NULL),(8888,8885,0,'LSQ12hxh','LSQ',56.3144166666667,-1.87116666666667,NULL,NULL,'2012-12-01 03:05:10',56262.1285899999,19.9695,0.1723,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_snap_89576.gif',36997676022,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'CV',NULL,0,NULL,0,578088687,9032635,NULL,NULL,NULL,NULL),(8889,8885,0,'LSQ12hxh','LSQ',56.3145416666667,-1.87105555555556,NULL,NULL,'2012-12-05 03:03:24',56266.1273699999,21.0627,0.1953,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_snap_89577.gif',36997676022,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'CV',NULL,0,NULL,0,578088687,9032635,NULL,NULL,NULL,NULL),(8890,8885,0,'LSQ12hxh','LSQ',56.3144166666667,-1.87127777777778,NULL,NULL,'2012-12-09 04:52:16',56270.20297,20.8915,0.18,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_snap_89578.gif',36997676022,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'CV',NULL,0,NULL,0,578088687,9032635,NULL,NULL,NULL,NULL),(8891,8885,0,'LSQ12hxh','LSQ',56.3145,-1.87125,NULL,NULL,'2012-12-13 04:37:01',56274.1923799999,20.9366,0.2127,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_snap_89579.gif',36997676022,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'CV',NULL,0,NULL,0,578088687,9032635,NULL,NULL,NULL,NULL),(8892,8885,0,'LSQ12hxh','LSQ',56.3142083333333,-1.87113888888889,NULL,NULL,'2012-12-21 02:04:45',56282.0866399999,13.787,0.0017,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_snap_89580.gif',36997676005,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'CV',NULL,0,NULL,0,578088687,9032635,NULL,NULL,NULL,NULL),(8893,8885,0,'LSQ12hxh','LSQ',56.314125,-1.87116666666667,NULL,NULL,'2012-12-24 01:28:14',56285.06128,14.0893,0.0029,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_snap_89526.gif',36997676005,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'CV',NULL,0,NULL,0,578088687,9032635,NULL,NULL,NULL,NULL),(8894,8885,0,'LSQ12hxh','LSQ',56.3140833333333,-1.87116666666667,NULL,NULL,'2012-12-24 03:29:34',56285.1455399999,14.0211,0.0025,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxh/LSQ12hxh_snap_89527.gif',36997676005,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'CV',NULL,0,NULL,0,578088687,9032635,NULL,NULL,NULL,NULL),(8895,8895,1,'LSQ12hxg','LSQ',62.9475416666667,-5.91894444444444,NULL,NULL,'2012-12-24 02:12:44',56285.0921800002,19.1739,0.1431,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_89524.gif',36962123763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(8896,8895,0,'LSQ12hxg','LSQ',62.9475833333333,-5.91908333333333,NULL,NULL,'2012-12-24 04:14:04',56285.1764400001,18.8347,0.1128,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2013-01-02 15:16:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_89525.gif',36962123763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(8897,8897,1,'LSQ12hxd','LSQ',62.8152916666667,-7.834,NULL,NULL,'2012-11-02 07:50:37',56233.3268200001,20.1628,0.1388,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxd/LSQ12hxd_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxd/LSQ12hxd_snap_89554.gif',36953717250,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,577401832,9021903,NULL,NULL,NULL,NULL),(8898,8897,0,'LSQ12hxd','LSQ',62.8153333333333,-7.83397222222222,NULL,NULL,'2012-12-24 02:09:19',56285.0898099998,19.4064,0.1167,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxd/LSQ12hxd_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxd/LSQ12hxd_snap_89518.gif',36953717250,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,577401832,9021903,NULL,NULL,NULL,NULL),(8899,8897,0,'LSQ12hxd','LSQ',62.8153333333333,-7.83397222222222,NULL,NULL,'2012-12-24 04:10:42',56285.1740999999,19.4518,0.1184,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxd/LSQ12hxd_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxd/LSQ12hxd_snap_89519.gif',36953717250,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,577401832,9021903,NULL,NULL,NULL,NULL),(8900,8900,1,'LSQ12hxc','LSQ',57.9953333333333,-3.28861111111111,NULL,NULL,'2012-11-02 05:24:04',56233.22505,18.1584,0.0476,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxc/LSQ12hxc_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxc/LSQ12hxc_snap_89552.gif',37008350599,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,578255478,9035241,NULL,NULL,NULL,NULL),(8901,8900,0,'LSQ12hxc','LSQ',57.99525,-3.28858333333333,NULL,NULL,'2012-11-02 07:43:47',56233.3220799998,18.9669,0.0989,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxc/LSQ12hxc_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxc/LSQ12hxc_snap_89553.gif',37008350599,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,578255478,9035241,NULL,NULL,NULL,NULL),(8902,8900,0,'LSQ12hxc','LSQ',57.9950416666667,-3.28858333333333,NULL,NULL,'2012-12-24 01:41:52',56285.07075,16.9451,0.0566,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxc/LSQ12hxc_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxc/LSQ12hxc_snap_89516.gif',37008350599,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,578255478,9035241,NULL,NULL,NULL,NULL),(8903,8900,0,'LSQ12hxc','LSQ',57.99525,-3.28872222222222,NULL,NULL,'2012-12-24 03:43:09',56285.15497,17.662,0.0585,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxc/LSQ12hxc_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxc/LSQ12hxc_snap_89517.gif',37008350599,NULL,NULL,NULL,'2012-10-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,578255478,9035241,NULL,NULL,NULL,NULL),(8904,8904,1,'LSQ12hxb','LSQ',174.203291666667,-8.73036111111111,NULL,NULL,'2012-12-24 06:18:18',56285.2627099999,18.0791,0.0482,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxb/LSQ12hxb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxb/LSQ12hxb_snap_89514.gif',41063321975,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,641614405,10025225,NULL,NULL,NULL,NULL),(8905,8904,0,'LSQ12hxb','LSQ',174.203333333333,-8.73030555555555,NULL,NULL,'2012-12-24 07:29:47',56285.3123499998,18.218,0.03,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxb/LSQ12hxb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxb/LSQ12hxb_snap_89515.gif',41063321975,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,641614405,10025225,NULL,NULL,NULL,NULL),(8906,8906,1,'LSQ12hwy','LSQ',151.071083333333,-15.0923611111111,NULL,NULL,'2012-11-27 06:11:38',56258.2580900001,20.3631,0.1837,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_history.html','sn?',NULL,0.049834,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_snap_89544.gif',41190790293,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643606098,10056345,NULL,NULL,NULL,NULL),(8907,8906,0,'LSQ12hwy','LSQ',151.070875,-15.0929444444444,NULL,NULL,'2012-12-15 06:49:51',56276.28462,19.3818,0.0437,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_history.html','sn?',NULL,0.049834,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_snap_89545.gif',41190790322,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643606098,10056345,NULL,NULL,NULL,NULL),(8908,8906,0,'LSQ12hwy','LSQ',151.070916666667,-15.0933888888889,NULL,NULL,'2012-12-19 05:12:33',56280.2170500001,20.0402,0.1141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_history.html','sn?',NULL,0.049834,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_snap_89546.gif',41190790322,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643606098,10056345,NULL,NULL,NULL,NULL),(8909,8906,0,'LSQ12hwy','LSQ',151.070833333333,-15.0927777777778,NULL,NULL,'2012-12-21 06:36:08',56282.2751000002,20.7994,0.1431,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_history.html','sn?',NULL,0.049834,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_snap_89547.gif',41190790322,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643606098,10056345,NULL,NULL,NULL,NULL),(8910,8906,0,'LSQ12hwy','LSQ',151.070916666667,-15.0929166666667,NULL,NULL,'2012-12-24 05:16:16',56285.2196399998,19.7046,0.1164,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_history.html','sn?',NULL,0.049834,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_snap_89508.gif',41190790322,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643606098,10056345,NULL,NULL,NULL,NULL),(8911,8906,0,'LSQ12hwy','LSQ',151.070916666667,-15.0928611111111,NULL,NULL,'2012-12-24 06:58:48',56285.2908399999,19.5728,0.0644,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_history.html','sn?',NULL,0.049834,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_snap_89509.gif',41190790322,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643606098,10056345,NULL,NULL,NULL,NULL),(8912,8912,1,'LSQ12hvz','LSQ',59.6744583333333,-13.3246388888889,NULL,NULL,'2012-11-20 05:05:51',56251.2124000001,18.0863,0.1701,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_snap_89033.gif',36893561548,NULL,NULL,NULL,'2012-11-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576461899,9007217,NULL,NULL,NULL,NULL),(8913,8912,0,'LSQ12hvz','LSQ',59.67475,-13.3243888888889,NULL,NULL,'2012-12-24 02:05:58',56285.0874800002,18.3061,0.0663,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_snap_89015.gif',36893561548,NULL,NULL,NULL,'2012-11-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576461899,9007217,NULL,NULL,NULL,NULL),(8914,8912,0,'LSQ12hvz','LSQ',59.67475,-13.3244166666667,NULL,NULL,'2012-12-24 04:07:19',56285.1717500002,18.4976,0.0891,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_snap_89016.gif',36893561548,NULL,NULL,NULL,'2012-11-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576461899,9007217,NULL,NULL,NULL,NULL),(8915,8915,1,'LSQ12hvy','LSQ',154.816291666667,-17.0153055555556,NULL,NULL,'2012-12-09 07:03:05',56270.2938100002,20.7126,0.216,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_snap_89026.gif',41645999499,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650718742,10167480,NULL,NULL,NULL,NULL),(8916,8915,0,'LSQ12hvy','LSQ',154.816291666667,-17.0151666666667,NULL,NULL,'2012-12-11 05:22:18',56272.22383,19.9153,0.1995,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_snap_89027.gif',41645999498,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650718742,10167480,NULL,NULL,NULL,NULL),(8917,8915,0,'LSQ12hvy','LSQ',154.816291666667,-17.0153055555556,NULL,NULL,'2012-12-11 06:59:05',56272.29104,20.3521,0.1443,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_snap_89028.gif',41645999499,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650718742,10167480,NULL,NULL,NULL,NULL),(8918,8915,0,'LSQ12hvy','LSQ',154.816375,-17.0147777777778,NULL,NULL,'2012-12-15 05:07:12',56276.2133399998,19.0616,0.0785,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_snap_89029.gif',41645999498,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650718742,10167480,NULL,NULL,NULL,NULL),(8919,8915,0,'LSQ12hvy','LSQ',154.81625,-17.0151111111111,NULL,NULL,'2012-12-15 06:51:33',56276.2858000002,19.8547,0.1281,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_snap_89030.gif',41645999498,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650718742,10167480,NULL,NULL,NULL,NULL),(8920,8915,0,'LSQ12hvy','LSQ',154.816458333333,-17.0150833333333,NULL,NULL,'2012-12-21 04:42:50',56282.1964199999,19.1744,0.1213,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_snap_89031.gif',41645999498,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650718742,10167480,NULL,NULL,NULL,NULL),(8921,8915,0,'LSQ12hvy','LSQ',154.816416666667,-17.0151666666667,NULL,NULL,'2012-12-21 08:14:03',56282.3431000002,19.7822,0.0888,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_snap_89032.gif',41645999498,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650718742,10167480,NULL,NULL,NULL,NULL),(8922,8915,0,'LSQ12hvy','LSQ',154.816583333333,-17.015,NULL,NULL,'2012-12-24 04:59:09',56285.2077500001,19.0351,0.1038,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_snap_89013.gif',41645999498,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650718742,10167480,NULL,NULL,NULL,NULL),(8923,8915,0,'LSQ12hvy','LSQ',154.816416666667,-17.0151666666667,NULL,NULL,'2012-12-24 06:50:18',56285.2849400002,19.7194,0.0938,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 16:46:18','2012-12-24 16:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_snap_89014.gif',41645999498,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650718742,10167480,NULL,NULL,NULL,NULL),(8924,8924,1,'LSQ12hvw','LSQ',56.0881666666667,-20.5376666666667,NULL,NULL,'2012-11-04 04:17:07',56235.1785599999,20.182,0.1777,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 17:46:18','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvw/LSQ12hvw_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvw/LSQ12hvw_snap_89017.gif',38045333132,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594458330,9288411,NULL,NULL,NULL,NULL),(8925,8924,0,'LSQ12hvw','LSQ',56.0884583333333,-20.5370277777778,NULL,NULL,'2012-11-10 06:09:37',56241.2566800001,14.6138,0.0146,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 17:46:18','2012-12-24 17:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvw/LSQ12hvw_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvw/LSQ12hvw_snap_89018.gif',38045333132,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594458330,9288411,NULL,NULL,NULL,NULL),(8926,8924,0,'LSQ12hvw','LSQ',56.088375,-20.5368611111111,NULL,NULL,'2012-11-12 05:34:40',56243.2324100002,14.2147,0.0268,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 17:46:18','2012-12-24 17:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvw/LSQ12hvw_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvw/LSQ12hvw_snap_89542.gif',38045333132,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594458330,9288411,NULL,NULL,NULL,NULL),(8927,8924,0,'LSQ12hvw','LSQ',56.08875,-20.5370833333333,NULL,NULL,'2012-11-20 04:50:32',56251.2017700002,11.8737,0.0143,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 17:46:18','2012-12-24 17:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvw/LSQ12hvw_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvw/LSQ12hvw_snap_89543.gif',38045333130,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594458330,9288411,NULL,NULL,NULL,NULL),(8928,8924,0,'LSQ12hvw','LSQ',56.087875,-20.5375555555556,NULL,NULL,'2012-12-24 02:02:23',56285.0849899999,11.4324,0.0248,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 17:46:18','2012-12-24 17:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvw/LSQ12hvw_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvw/LSQ12hvw_snap_89009.gif',38045333132,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594458330,9288411,NULL,NULL,NULL,NULL),(8929,8924,0,'LSQ12hvw','LSQ',56.0879583333333,-20.5377222222222,NULL,NULL,'2012-12-24 04:03:44',56285.16927,11.9246,0.0236,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-24 17:46:18','2012-12-24 17:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvw/LSQ12hvw_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvw/LSQ12hvw_snap_89010.gif',38045333132,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,594458330,9288411,NULL,NULL,NULL,NULL),(8930,7106,0,'LSQ12gxv','LSQ',70.4224583333333,-22.1973055555556,NULL,NULL,'2012-12-25 02:31:31',56286.1052199998,17.7311,0.0614,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-25 15:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_history.html','sne - nice',NULL,0.066686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_snap_89649.gif',37340201663,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583440650,9116260,NULL,NULL,NULL,NULL),(8931,7106,0,'LSQ12gxv','LSQ',70.4224166666667,-22.19775,NULL,NULL,'2012-12-25 04:32:37',56286.1893199999,18.9809,0.1664,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-25 15:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_history.html','sne - nice',NULL,0.066686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_snap_89650.gif',37340201662,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583440650,9116260,NULL,NULL,NULL,NULL),(8932,7432,0,'LSQ12hdl','LSQ',53.43475,-30.3177222222222,NULL,NULL,'2012-12-25 03:43:13',56286.1550199999,19.0967,0.1602,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-25 15:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_history.html','sn?',NULL,0.130297,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_snap_89745.gif',38573467025,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602710422,9417350,NULL,NULL,NULL,NULL),(8933,7445,0,'LSQ12heq','LSQ',53.2673333333333,-28.21375,NULL,NULL,'2012-12-25 01:49:02',56286.0757200001,19.1056,0.0852,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-25 15:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_89754.gif',38581253600,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(8934,7445,0,'LSQ12heq','LSQ',53.2673333333333,-28.21375,NULL,NULL,'2012-12-25 03:49:59',56286.1597199999,19.0317,0.0871,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-25 15:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_89755.gif',38581253600,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(8935,7456,0,'LSQ12hdn','LSQ',63.7040416666667,-32.2959444444444,NULL,NULL,'2012-12-25 02:11:04',56286.0910299998,18.8201,0.1829,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-25 15:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdn/LSQ12hdn_snap_89835.gif',37709622209,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589212847,9206450,NULL,NULL,NULL,NULL),(8936,7613,0,'LSQ12hje','LSQ',77.1707083333333,-20.9645,NULL,NULL,'2012-12-25 02:59:24',56286.1245900001,18.3262,0.0786,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-25 15:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_89748.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(8937,7613,0,'LSQ12hje','LSQ',77.17075,-20.9645555555556,NULL,NULL,'2012-12-25 05:08:36',56286.2143100002,18.6337,0.0856,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-25 15:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_89749.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(8938,7751,0,'LSQ12hle','LSQ',61.104375,-29.1578333333333,NULL,NULL,'2012-12-25 04:03:38',56286.1691899998,19.0733,0.1001,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-25 15:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_snap_89762.gif',38530541650,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602039713,9406870,NULL,NULL,NULL,NULL),(8939,8046,0,'LSQ12hnj','LSQ',78.1033333333333,-25.7825555555556,NULL,NULL,'2012-12-25 02:56:02',56286.12225,15.6293,0.0062,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-25 15:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_89791.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8940,8046,0,'LSQ12hnj','LSQ',78.102625,-25.7826111111111,NULL,NULL,'2012-12-25 02:57:42',56286.12341,15.8955,0.0062,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-25 15:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_89793.gif',37249489807,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8941,8046,0,'LSQ12hnj','LSQ',78.1033333333333,-25.7825277777778,NULL,NULL,'2012-12-25 05:05:13',56286.21196,15.6989,0.0062,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-25 15:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_89792.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8942,8046,0,'LSQ12hnj','LSQ',78.102625,-25.7826111111111,NULL,NULL,'2012-12-25 05:06:55',56286.2131400001,15.8792,0.0067,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-25 15:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_89794.gif',37249489807,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(8943,8228,0,'LSQ12hon','LSQ',57.893375,-24.2264722222222,NULL,NULL,'2012-12-25 01:59:11',56286.0827700002,19.472,0.1667,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_89634.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(8944,8228,0,'LSQ12hon','LSQ',57.893375,-24.2263611111111,NULL,NULL,'2012-12-25 04:00:15',56286.1668500002,18.7431,0.1339,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_89635.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(8945,8233,0,'LSQ12hnu','LSQ',56.4025833333333,-37.7380833333333,NULL,NULL,'2012-12-25 01:52:26',56286.0780799999,19.2109,0.1035,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-25 15:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_89676.gif',38557895446,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(8946,8408,0,'LSQ12hqa','LSQ',160.241,-21.78175,NULL,NULL,'2012-12-25 05:19:53',56286.2221499998,18.5175,0.126,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-25 15:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_snap_89726.gif',41668171452,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,651065178,10172893,NULL,NULL,NULL,NULL),(8947,8686,0,'LSQ12hvj','LSQ',166.910875,-29.7113888888889,NULL,NULL,'2012-12-25 05:28:20',56286.2280100002,17.9193,0.0547,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-30 09:16:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_89836.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(8948,8686,0,'LSQ12hvj','LSQ',166.910916666667,-29.7113888888889,NULL,NULL,'2012-12-25 07:05:43',56286.2956400001,17.6756,0.0429,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 15:46:14','2012-12-30 09:16:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_89837.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(8949,8949,1,'LSQ12hyd','LSQ',174.637958333333,-24.2079166666667,NULL,NULL,'2012-12-22 06:08:20',56283.2557899999,19.4567,0.0728,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_snap_90138.gif',41410841875,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647044404,10110068,NULL,NULL,NULL,NULL),(8950,8949,0,'LSQ12hyd','LSQ',174.637916666667,-24.2079166666667,NULL,NULL,'2012-12-23 06:02:46',56284.2519299998,19.1239,0.0839,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_snap_90139.gif',41410841875,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647044404,10110068,NULL,NULL,NULL,NULL),(8951,8949,0,'LSQ12hyd','LSQ',174.637916666667,-24.2079166666667,NULL,NULL,'2012-12-25 05:54:34',56286.2462300002,18.8279,0.1475,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_snap_89970.gif',41410841875,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647044404,10110068,NULL,NULL,NULL,NULL),(8952,8949,0,'LSQ12hyd','LSQ',174.637833333333,-24.2079722222222,NULL,NULL,'2012-12-25 07:17:36',56286.3038900001,19.5872,0.1061,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_snap_89971.gif',41410841875,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647044404,10110068,NULL,NULL,NULL,NULL),(8953,8953,1,'LSQ12hyb','LSQ',62.8060416666667,-21.4523888888889,NULL,NULL,'2012-10-26 06:07:13',56226.25502,21.0176,0.2069,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyb/LSQ12hyb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyb/LSQ12hyb_snap_90135.gif',36844309728,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575692339,8995192,NULL,NULL,NULL,NULL),(8954,8953,0,'LSQ12hyb','LSQ',62.805375,-21.4524444444444,NULL,NULL,'2012-12-02 06:17:32',56263.2621800001,19.5954,0.1446,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyb/LSQ12hyb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyb/LSQ12hyb_snap_90136.gif',36844309600,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575692337,8995192,NULL,NULL,NULL,NULL),(8955,8953,0,'LSQ12hyb','LSQ',62.8061666666667,-21.4525,NULL,NULL,'2012-12-10 05:14:48',56271.2186199999,21.2371,0.136,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyb/LSQ12hyb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyb/LSQ12hyb_snap_90144.gif',36844309728,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575692339,8995192,NULL,NULL,NULL,NULL),(8956,8953,0,'LSQ12hyb','LSQ',62.805375,-21.4525,NULL,NULL,'2012-12-22 02:33:02',56283.1062799999,20.0701,0.1607,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyb/LSQ12hyb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyb/LSQ12hyb_snap_90137.gif',36844309600,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575692337,8995192,NULL,NULL,NULL,NULL),(8957,8953,0,'LSQ12hyb','LSQ',62.8054166666667,-21.4524166666667,NULL,NULL,'2012-12-25 02:07:42',56286.0886900001,19.5382,0.1451,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyb/LSQ12hyb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyb/LSQ12hyb_snap_89966.gif',36844309600,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575692337,8995192,NULL,NULL,NULL,NULL),(8958,8953,0,'LSQ12hyb','LSQ',62.8053333333333,-21.4523611111111,NULL,NULL,'2012-12-25 04:08:47',56286.1727700001,19.98,0.1179,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyb/LSQ12hyb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyb/LSQ12hyb_snap_89967.gif',36844309600,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575692337,8995192,NULL,NULL,NULL,NULL),(8959,8959,1,'LSQ12hxx','LSQ',49.9342916666667,-27.0071388888889,NULL,NULL,'2012-12-18 02:19:28',56279.0968599999,18.7474,0.0508,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_90076.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(8960,8959,0,'LSQ12hxx','LSQ',49.9342916666667,-27.0071666666667,NULL,NULL,'2012-12-18 04:20:10',56279.1806800002,18.6227,0.0519,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2013-01-01 08:16:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_90077.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(8961,8959,0,'LSQ12hxx','LSQ',49.9342916666667,-27.0071388888889,NULL,NULL,'2012-12-22 02:05:28',56283.0871299999,17.8484,0.0349,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2013-01-01 08:16:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_90078.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(8962,8959,0,'LSQ12hxx','LSQ',49.9343333333333,-27.0071388888889,NULL,NULL,'2012-12-22 04:07:33',56283.17191,17.7544,0.0324,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2013-01-01 08:16:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_90079.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(8963,8959,0,'LSQ12hxx','LSQ',49.9342916666667,-27.0071388888889,NULL,NULL,'2012-12-23 01:36:25',56284.06696,17.7413,0.0315,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2013-01-01 08:16:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_90080.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(8964,8959,0,'LSQ12hxx','LSQ',49.93425,-27.0071388888889,NULL,NULL,'2012-12-25 01:37:13',56286.06752,17.6104,0.0328,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2013-01-01 08:16:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_89958.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(8965,8959,0,'LSQ12hxx','LSQ',49.9343333333333,-27.0071111111111,NULL,NULL,'2012-12-25 03:38:09',56286.1515000002,17.5345,0.0319,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2013-01-01 08:16:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_89959.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(8966,8966,1,'LSQ12hxt','LSQ',56.8417083333333,-31.2004166666667,NULL,NULL,'2012-12-12 02:51:00',56273.11876,21.3202,0.1823,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_90053.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(8967,8966,0,'LSQ12hxt','LSQ',56.8415416666667,-31.2003611111111,NULL,NULL,'2012-12-20 06:15:13',56281.2605699999,19.5866,0.1387,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2013-01-03 17:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_90054.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(8968,8966,0,'LSQ12hxt','LSQ',56.8414583333333,-31.2003333333333,NULL,NULL,'2012-12-22 02:19:06',56283.0965999998,19.3593,0.1431,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2013-01-03 17:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_90055.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(8969,8966,0,'LSQ12hxt','LSQ',56.8414166666667,-31.2004166666667,NULL,NULL,'2012-12-22 04:21:10',56283.1813699999,19.3537,0.1496,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2013-01-03 17:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_90056.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(8970,8966,0,'LSQ12hxt','LSQ',56.8414166666667,-31.2004166666667,NULL,NULL,'2012-12-23 01:55:00',56284.07987,19.077,0.1361,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2013-01-03 17:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_90057.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(8971,8966,0,'LSQ12hxt','LSQ',56.841375,-31.2003333333333,NULL,NULL,'2012-12-23 03:55:41',56284.1636800002,19.5068,0.1506,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2013-01-03 17:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_90058.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(8972,8966,0,'LSQ12hxt','LSQ',56.8412916666667,-31.2003055555556,NULL,NULL,'2012-12-25 01:55:48',56286.08042,18.8367,0.1312,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2013-01-03 17:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_89948.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(8973,8966,0,'LSQ12hxt','LSQ',56.841375,-31.2003611111111,NULL,NULL,'2012-12-25 03:56:51',56286.1644799998,19.0162,0.1439,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2013-01-03 17:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_89949.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(8974,8974,1,'LSQ12hxp','LSQ',67.4702083333333,-35.1994444444444,NULL,NULL,'2012-10-25 05:17:57',56225.2208099999,20.4152,0.1253,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_89974.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(8975,8974,0,'LSQ12hxp','LSQ',67.4703333333333,-35.1993055555556,NULL,NULL,'2012-11-03 06:30:27',56234.2711499999,20.5744,0.1528,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_89975.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(8976,8974,0,'LSQ12hxp','LSQ',67.4701666666667,-35.1992777777778,NULL,NULL,'2012-11-05 08:29:55',56236.3541199998,20.4539,0.1337,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_89976.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(8977,8974,0,'LSQ12hxp','LSQ',67.4699583333333,-35.19925,NULL,NULL,'2012-11-17 02:51:16',56248.11894,21.1895,0.1199,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_89977.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(8978,8974,0,'LSQ12hxp','LSQ',67.4701666666667,-35.1993611111111,NULL,NULL,'2012-11-19 02:51:24',56250.1190300002,20.8432,0.1375,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_89978.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(8979,8974,0,'LSQ12hxp','LSQ',67.4704583333333,-35.1992777777778,NULL,NULL,'2012-12-04 06:03:42',56265.25257,20.1944,0.1674,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_89979.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(8980,8974,0,'LSQ12hxp','LSQ',67.4702083333333,-35.1994166666667,NULL,NULL,'2012-12-04 06:10:31',56265.2573099998,19.9439,0.152,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_89980.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(8981,8974,0,'LSQ12hxp','LSQ',67.4701666666667,-35.1995,NULL,NULL,'2012-12-06 06:06:03',56267.2542099999,20.5783,0.1854,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_89981.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(8982,8974,0,'LSQ12hxp','LSQ',67.4701666666667,-35.1995,NULL,NULL,'2012-12-06 06:12:56',56267.25899,20.4266,0.1887,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_89982.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(8983,8974,0,'LSQ12hxp','LSQ',67.4701666666667,-35.1993611111111,NULL,NULL,'2012-12-08 06:40:50',56269.2783599999,21.2894,0.1884,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_89983.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(8984,8974,0,'LSQ12hxp','LSQ',67.47025,-35.1994722222222,NULL,NULL,'2012-12-08 06:47:43',56269.28314,20.8929,0.143,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_89984.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(8985,8974,0,'LSQ12hxp','LSQ',67.4701666666667,-35.1993333333333,NULL,NULL,'2012-12-18 03:01:22',56279.1259499998,20.9942,0.137,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_89985.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(8986,8974,0,'LSQ12hxp','LSQ',67.4704166666667,-35.1994722222222,NULL,NULL,'2012-12-22 02:44:57',56283.1145600001,19.1763,0.101,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_89986.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(8987,8974,0,'LSQ12hxp','LSQ',67.470125,-35.1993333333333,NULL,NULL,'2012-12-22 04:45:07',56283.1979999999,20.0602,0.145,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_89987.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(8988,8974,0,'LSQ12hxp','LSQ',67.469875,-35.19925,NULL,NULL,'2012-12-25 02:19:33',56286.0969099998,19.4408,0.153,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_89940.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(8989,8974,0,'LSQ12hxp','LSQ',67.470125,-35.1995,NULL,NULL,'2012-12-25 04:20:45',56286.18108,19.1429,0.1232,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 19:46:19','2012-12-25 19:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_89941.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(8990,8953,0,'LSQ12hyb','LSQ',62.80625,-21.4524444444444,NULL,NULL,'2012-12-16 02:47:13',56277.11613,20.8817,0.1111,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-25 20:46:19','2012-12-25 20:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyb/LSQ12hyb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyb/LSQ12hyb_snap_90145.gif',36844309520,NULL,NULL,NULL,'2012-10-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,575692336,8995192,NULL,NULL,NULL,NULL),(9017,9017,1,'LSQ12hxu','LSQ',63.4705833333333,-31.3775555555556,NULL,NULL,'2012-12-25 02:11:04',56286.0910299998,20.0041,0.152,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-26 20:46:18','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxu/LSQ12hxu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxu/LSQ12hxu_snap_89952.gif',37709822855,NULL,NULL,NULL,'2012-12-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589215982,9206499,NULL,NULL,NULL,NULL),(9018,9017,0,'LSQ12hxu','LSQ',63.4706666666667,-31.3775833333333,NULL,NULL,'2012-12-25 04:12:11',56286.1751299999,20.1288,0.1591,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-26 20:46:18','2012-12-26 20:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxu/LSQ12hxu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxu/LSQ12hxu_snap_89953.gif',37709822855,NULL,NULL,NULL,'2012-12-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589215982,9206499,NULL,NULL,NULL,NULL),(9019,7075,0,'LSQ12gxb','LSQ',142.838875,-11.6296388888889,NULL,NULL,'2012-12-26 06:31:57',56287.2721899999,19.1343,0.0962,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 05:46:16','2012-12-27 05:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_snap_90161.gif',42178887818,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,659045122,10297580,NULL,NULL,NULL,NULL),(9020,7075,0,'LSQ12gxb','LSQ',142.838875,-11.6295555555556,NULL,NULL,'2012-12-26 07:37:50',56287.3179500001,20.0618,0.0884,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 05:46:16','2012-12-27 05:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_snap_90162.gif',42178887818,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,659045122,10297580,NULL,NULL,NULL,NULL),(9021,7096,0,'LSQ12gyd','LSQ',76.3870416666667,-18.0351111111111,NULL,NULL,'2012-12-26 02:55:03',56287.12157,18.7776,0.0804,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 05:46:16','2012-12-27 05:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_90155.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(9022,7337,0,'LSQ12hcc','LSQ',143.778458333333,-8.55077777777778,NULL,NULL,'2012-12-26 07:37:50',56287.3179500001,19.3863,0.149,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 05:46:16','2012-12-27 05:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcc/LSQ12hcc_history.html','sn?',NULL,0.089982,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcc/LSQ12hcc_snap_90177.gif',41103056563,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642235258,10034925,NULL,NULL,NULL,NULL),(9023,7909,0,'LSQ12hmy','LSQ',136.54725,-2.21369444444444,NULL,NULL,'2012-12-26 06:37:07',56287.2757799998,19.8311,0.1837,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 05:46:16','2012-12-27 05:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_snap_90245.gif',42146871440,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,658544866,10289763,NULL,NULL,NULL,NULL),(9024,7909,0,'LSQ12hmy','LSQ',136.54725,-2.21375,NULL,NULL,'2012-12-26 07:49:43',56287.3262,19.7941,0.1535,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 05:46:16','2012-12-27 05:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_snap_90246.gif',42146871443,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,658544866,10289763,NULL,NULL,NULL,NULL),(9025,7937,0,'LSQ12hmb','LSQ',151.368166666667,-13.1323888888889,NULL,NULL,'2012-12-26 06:40:41',56287.2782600001,9.0923,0.0402,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 05:46:16','2012-12-27 05:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_snap_90243.gif',41162875494,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643169929,10049530,NULL,NULL,NULL,NULL),(9026,7937,0,'LSQ12hmb','LSQ',151.367333333333,-13.1322777777778,NULL,NULL,'2012-12-26 07:41:13',56287.3202900002,19.1783,0.1572,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 05:46:16','2012-12-27 05:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_snap_90244.gif',41162875495,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643169929,10049530,NULL,NULL,NULL,NULL),(9027,8208,0,'LSQ12hno','LSQ',55.680125,-2.66936111111111,NULL,NULL,'2012-12-26 01:31:34',56287.0635899999,17.2736,0.07,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 05:46:16','2013-01-03 13:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_90237.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(9028,8879,0,'LSQ12hxi','LSQ',61.65575,-0.73025,NULL,NULL,'2012-12-26 05:37:44',56287.2345400001,17.5747,0.1111,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 05:46:16','2012-12-27 05:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_snap_90166.gif',36935907244,NULL,NULL,NULL,'2012-11-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577123550,9017555,NULL,NULL,NULL,NULL),(9029,8895,0,'LSQ12hxg','LSQ',62.9476666666667,-5.919,NULL,NULL,'2012-12-26 02:14:21',56287.0932999998,18.5845,0.1805,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 05:46:16','2013-01-02 15:16:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_90179.gif',36962123763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(9030,8895,0,'LSQ12hxg','LSQ',62.9477083333333,-5.91908333333333,NULL,NULL,'2012-12-26 05:05:13',56287.21196,18.35,0.1718,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 05:46:16','2013-01-02 15:16:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_90180.gif',36962123762,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(9031,8912,0,'LSQ12hvz','LSQ',59.6747916666667,-13.3244166666667,NULL,NULL,'2012-12-26 02:07:35',56287.08861,17.821,0.0944,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 05:46:16','2012-12-27 05:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_snap_90148.gif',36893561548,NULL,NULL,NULL,'2012-11-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576461899,9007217,NULL,NULL,NULL,NULL),(9032,8912,0,'LSQ12hvz','LSQ',59.6747916666667,-13.3243888888889,NULL,NULL,'2012-12-26 05:13:41',56287.2178400001,18.5116,0.0955,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 05:46:16','2012-12-27 05:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_snap_90149.gif',36893561548,NULL,NULL,NULL,'2012-11-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576461899,9007217,NULL,NULL,NULL,NULL),(9033,8912,0,'LSQ12hvz','LSQ',59.6747916666667,-13.3243888888889,NULL,NULL,'2012-12-26 06:06:59',56287.2548500001,18.4043,0.0926,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 05:46:16','2012-12-27 05:46:16','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_snap_90150.gif',36893561548,NULL,NULL,NULL,'2012-11-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576461899,9007217,NULL,NULL,NULL,NULL),(9034,8426,0,'PSNJ12472930-4319443','pessto',191.87208,-43.32897,NULL,NULL,'2012-12-13 12:00:00',56282,NULL,NULL,NULL,0.010941,NULL,'II',NULL,'2012-12-27 07:23:20','2019-08-18 22:06:58','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,46773787189,'SALT','RSS','Antezana',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,730840424,11419381,NULL,NULL,NULL,NULL),(9035,9035,1,'LSQ12hyv','LSQ',63.7127083333333,-16.2172777777778,NULL,NULL,'2012-11-12 06:45:13',56243.2814099998,18.2444,0.0523,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_snap_90492.gif',36871504833,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576117263,9001832,NULL,NULL,NULL,NULL),(9036,9035,0,'LSQ12hyv','LSQ',63.7125833333333,-16.2174722222222,NULL,NULL,'2012-11-14 05:18:57',56245.2215,20.0422,0.1294,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_snap_90493.gif',36871504845,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576117263,9001832,NULL,NULL,NULL,NULL),(9037,9035,0,'LSQ12hyv','LSQ',63.712625,-16.2173611111111,NULL,NULL,'2012-11-16 07:05:45',56247.2956699999,19.0427,0.0891,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_snap_90494.gif',36871504845,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576117263,9001832,NULL,NULL,NULL,NULL),(9038,9035,0,'LSQ12hyv','LSQ',63.712375,-16.2171388888889,NULL,NULL,'2012-11-22 06:56:00',56253.28889,18.8097,0.1174,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_snap_90495.gif',36871504847,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576117263,9001832,NULL,NULL,NULL,NULL),(9039,9035,0,'LSQ12hyv','LSQ',63.7125,-16.2174722222222,NULL,NULL,'2012-12-26 02:22:50',56287.0992000001,18.9118,0.165,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_snap_90496.gif',36871504845,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576117263,9001832,NULL,NULL,NULL,NULL),(9040,9035,0,'LSQ12hyv','LSQ',63.7127083333333,-16.2175,NULL,NULL,'2012-12-26 04:48:16',56287.2001899998,17.7377,0.0998,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_snap_90363.gif',36871504834,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576117263,9001832,NULL,NULL,NULL,NULL),(9041,9035,0,'LSQ12hyv','LSQ',63.71275,-16.2174444444444,NULL,NULL,'2012-12-26 04:55:01',56287.2048800001,18.4995,0.1417,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_snap_90364.gif',36871504834,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576117263,9001832,NULL,NULL,NULL,NULL),(9042,9042,1,'LSQ12hys','LSQ',66.3931666666667,-8.53611111111111,NULL,NULL,'2012-10-20 07:35:28',56220.3163000001,19.8592,0.1466,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_snap_90467.gif',37473130958,NULL,NULL,NULL,'2012-10-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585517671,9148713,NULL,NULL,NULL,NULL),(9043,9042,0,'LSQ12hys','LSQ',66.3932083333333,-8.53608333333333,NULL,NULL,'2012-10-24 08:15:07',56224.3438400002,20.2936,0.2098,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_snap_90468.gif',37473130958,NULL,NULL,NULL,'2012-10-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585517671,9148713,NULL,NULL,NULL,NULL),(9044,9042,0,'LSQ12hys','LSQ',66.3927083333333,-8.53572222222222,NULL,NULL,'2012-11-06 07:17:30',56237.30382,18.6117,0.1485,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_snap_90469.gif',37473130959,NULL,NULL,NULL,'2012-10-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585517671,9148713,NULL,NULL,NULL,NULL),(9045,9042,0,'LSQ12hys','LSQ',66.39275,-8.53555555555556,NULL,NULL,'2012-11-14 07:21:05',56245.3063099999,20.1145,0.1751,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_snap_90470.gif',37473130956,NULL,NULL,NULL,'2012-10-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585517671,9148713,NULL,NULL,NULL,NULL),(9046,9042,0,'LSQ12hys','LSQ',66.392875,-8.53588888888889,NULL,NULL,'2012-11-18 05:45:43',56249.24009,19.4855,0.1845,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_snap_90471.gif',37473130959,NULL,NULL,NULL,'2012-10-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585517671,9148713,NULL,NULL,NULL,NULL),(9047,9042,0,'LSQ12hys','LSQ',66.3925833333333,-8.53577777777778,NULL,NULL,'2012-12-26 04:46:35',56287.1990200002,17.8771,0.1277,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_snap_90356.gif',37473130959,NULL,NULL,NULL,'2012-10-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585517671,9148713,NULL,NULL,NULL,NULL),(9048,9042,0,'LSQ12hys','LSQ',66.392625,-8.53586111111111,NULL,NULL,'2012-12-26 04:51:38',56287.2025299999,17.5885,0.11,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_snap_90357.gif',37473130959,NULL,NULL,NULL,'2012-10-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585517671,9148713,NULL,NULL,NULL,NULL),(9049,9049,1,'LSQ12hyr','LSQ',64.063125,-10.95125,NULL,NULL,'2012-10-16 07:43:09',56216.3216400002,20.644,0.1806,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_history.html','sn',NULL,0.045375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_snap_90463.gif',36980827672,NULL,NULL,NULL,'2012-10-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577825432,9028522,NULL,NULL,NULL,NULL),(9050,9049,0,'LSQ12hyr','LSQ',64.0625416666667,-10.9516388888889,NULL,NULL,'2012-11-14 07:55:33',56245.3302500001,20.8621,0.18,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_history.html','sn',NULL,0.045375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_snap_90464.gif',36980827675,NULL,NULL,NULL,'2012-10-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577825432,9028522,NULL,NULL,NULL,NULL),(9051,9049,0,'LSQ12hyr','LSQ',64.0629166666667,-10.9515,NULL,NULL,'2012-11-18 07:49:41',56249.3261799999,20.6737,0.1831,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_history.html','sn',NULL,0.045375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_snap_90465.gif',36980827675,NULL,NULL,NULL,'2012-10-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577825432,9028522,NULL,NULL,NULL,NULL),(9052,9049,0,'LSQ12hyr','LSQ',64.062625,-10.9515833333333,NULL,NULL,'2012-12-24 04:24:14',56285.1834999998,19.3742,0.1144,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_history.html','sn',NULL,0.045375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_snap_90466.gif',36980827675,NULL,NULL,NULL,'2012-10-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577825432,9028522,NULL,NULL,NULL,NULL),(9053,9049,0,'LSQ12hyr','LSQ',64.0626666666667,-10.9515,NULL,NULL,'2012-12-26 02:24:31',56287.1003700001,18.425,0.1445,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_history.html','sn',NULL,0.045375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_snap_90353.gif',36980827675,NULL,NULL,NULL,'2012-10-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577825432,9028522,NULL,NULL,NULL,NULL),(9054,9049,0,'LSQ12hyr','LSQ',64.062625,-10.9515277777778,NULL,NULL,'2012-12-26 04:49:58',56287.2013699999,19.0683,0.165,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_history.html','sn',NULL,0.045375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_snap_90355.gif',36980827675,NULL,NULL,NULL,'2012-10-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577825432,9028522,NULL,NULL,NULL,NULL),(9055,9049,0,'LSQ12hyr','LSQ',64.0625833333333,-10.9516388888889,NULL,NULL,'2012-12-26 06:22:16',56287.26547,18.8308,0.1139,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_history.html','sn',NULL,0.045375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_snap_90354.gif',36980827675,NULL,NULL,NULL,'2012-10-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577825432,9028522,NULL,NULL,NULL,NULL),(9056,9056,1,'LSQ12hyo','LSQ',58.4468333333333,-8.56833333333333,NULL,NULL,'2012-10-12 08:23:33',56212.3496900001,19.7918,0.1033,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_history.html','sn?',NULL,0.032466,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_snap_90420.gif',37043464288,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578804129,9043814,NULL,NULL,NULL,NULL),(9057,9056,0,'LSQ12hyo','LSQ',58.4466666666667,-8.5685,NULL,NULL,'2012-10-14 05:39:34',56214.2358200001,19.2937,0.1275,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_history.html','sn?',NULL,0.032466,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_snap_90421.gif',37043464288,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578804129,9043814,NULL,NULL,NULL,NULL),(9058,9056,0,'LSQ12hyo','LSQ',58.4466666666667,-8.56841666666667,NULL,NULL,'2012-10-16 07:41:27',56216.3204600001,20.2848,0.1513,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_history.html','sn?',NULL,0.032466,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_snap_90422.gif',37043464288,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578804129,9043814,NULL,NULL,NULL,NULL),(9059,9056,0,'LSQ12hyo','LSQ',58.4467916666667,-8.56847222222222,NULL,NULL,'2012-10-20 08:09:55',56220.3402300002,19.8676,0.1144,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_history.html','sn?',NULL,0.032466,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_snap_90423.gif',37043464288,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578804129,9043814,NULL,NULL,NULL,NULL),(9060,9056,0,'LSQ12hyo','LSQ',58.447375,-8.56836111111111,NULL,NULL,'2012-11-02 05:08:47',56233.2144399998,19.3443,0.1495,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_history.html','sn?',NULL,0.032466,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_snap_90424.gif',37043464288,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578804129,9043814,NULL,NULL,NULL,NULL),(9061,9056,0,'LSQ12hyo','LSQ',58.4470833333333,-8.56841666666667,NULL,NULL,'2012-11-02 06:59:45',56233.2914999998,18.7542,0.0926,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_history.html','sn?',NULL,0.032466,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_snap_90425.gif',37043464288,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578804129,9043814,NULL,NULL,NULL,NULL),(9062,9056,0,'LSQ12hyo','LSQ',58.4470416666667,-8.56847222222222,NULL,NULL,'2012-11-04 05:10:03',56235.21532,18.6728,0.0623,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_history.html','sn?',NULL,0.032466,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_snap_90426.gif',37043464288,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578804129,9043814,NULL,NULL,NULL,NULL),(9063,9056,0,'LSQ12hyo','LSQ',58.4471666666667,-8.56808333333333,NULL,NULL,'2012-11-08 05:53:32',56239.2455199999,20.1253,0.1721,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_history.html','sn?',NULL,0.032466,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_snap_90427.gif',37043464288,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578804129,9043814,NULL,NULL,NULL,NULL),(9064,9056,0,'LSQ12hyo','LSQ',58.4471666666667,-8.56841666666667,NULL,NULL,'2012-11-14 05:53:27',56245.2454599999,17.6268,0.0245,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_history.html','sn?',NULL,0.032466,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_snap_90428.gif',37043464288,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578804129,9043814,NULL,NULL,NULL,NULL),(9065,9056,0,'LSQ12hyo','LSQ',58.44725,-8.56844444444444,NULL,NULL,'2012-12-24 01:57:14',56285.0814200002,17.4659,0.0545,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_history.html','sn?',NULL,0.032466,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_snap_90429.gif',37043464288,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578804129,9043814,NULL,NULL,NULL,NULL),(9066,9056,0,'LSQ12hyo','LSQ',58.447125,-8.56841666666667,NULL,NULL,'2012-12-24 03:58:39',56285.16573,18.1607,0.0733,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_history.html','sn?',NULL,0.032466,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_snap_90430.gif',37043464288,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578804129,9043814,NULL,NULL,NULL,NULL),(9067,9056,0,'LSQ12hyo','LSQ',58.4472083333333,-8.56847222222222,NULL,NULL,'2012-12-26 01:59:00',56287.0826400002,16.2483,0.0344,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_history.html','sn?',NULL,0.032466,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_snap_90348.gif',37043464288,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578804129,9043814,NULL,NULL,NULL,NULL),(9068,9056,0,'LSQ12hyo','LSQ',58.447125,-8.56838888888889,NULL,NULL,'2012-12-26 05:25:46',56287.2262300001,17.0204,0.0581,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_history.html','sn?',NULL,0.032466,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_snap_90346.gif',37043464288,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578804129,9043814,NULL,NULL,NULL,NULL),(9069,9056,0,'LSQ12hyo','LSQ',58.4471666666667,-8.56838888888889,NULL,NULL,'2012-12-26 05:29:10',56287.22859,17.0334,0.068,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_history.html','sn?',NULL,0.032466,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_snap_90347.gif',37043464288,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578804129,9043814,NULL,NULL,NULL,NULL),(9070,9070,1,'LSQ12hyn','LSQ',58.5544166666667,-8.54783333333333,NULL,NULL,'2012-10-12 08:23:33',56212.3496900001,19.9153,0.2109,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_snap_90407.gif',37043507332,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578804802,9043825,NULL,NULL,NULL,NULL),(9071,9070,0,'LSQ12hyn','LSQ',58.5545,-8.54780555555556,NULL,NULL,'2012-10-14 05:39:34',56214.2358200001,20.1343,0.141,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_snap_90408.gif',37043507332,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578804802,9043825,NULL,NULL,NULL,NULL),(9072,9070,0,'LSQ12hyn','LSQ',58.554625,-8.54758333333333,NULL,NULL,'2012-10-16 07:41:27',56216.3204600001,20.1898,0.1727,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_snap_90409.gif',37043507335,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578804802,9043825,NULL,NULL,NULL,NULL),(9073,9070,0,'LSQ12hyn','LSQ',58.55475,-8.54775,NULL,NULL,'2012-10-18 07:16:18',56218.3029900002,19.7958,0.103,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_snap_90410.gif',37043507335,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578804802,9043825,NULL,NULL,NULL,NULL),(9074,9070,0,'LSQ12hyn','LSQ',58.5542916666667,-8.54758333333333,NULL,NULL,'2012-10-20 05:57:14',56220.2480799998,20.2005,0.1499,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_snap_90411.gif',37043507332,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578804802,9043825,NULL,NULL,NULL,NULL),(9075,9070,0,'LSQ12hyn','LSQ',58.5549166666667,-8.54777777777778,NULL,NULL,'2012-10-24 07:23:53',56224.3082599998,19.8714,0.1164,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_snap_90412.gif',37043507335,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578804802,9043825,NULL,NULL,NULL,NULL),(9076,9070,0,'LSQ12hyn','LSQ',58.5549166666667,-8.54766666666667,NULL,NULL,'2012-10-24 08:11:44',56224.34149,19.8889,0.1373,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_snap_90413.gif',37043507335,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578804802,9043825,NULL,NULL,NULL,NULL),(9077,9070,0,'LSQ12hyn','LSQ',58.5544166666667,-8.54761111111111,NULL,NULL,'2012-11-02 06:59:45',56233.2914999998,19.0343,0.1093,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_snap_90414.gif',37043507332,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578804802,9043825,NULL,NULL,NULL,NULL),(9078,9070,0,'LSQ12hyn','LSQ',58.554625,-8.54763888888889,NULL,NULL,'2012-11-04 05:10:03',56235.21532,18.5893,0.0767,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_snap_90415.gif',37043507335,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578804802,9043825,NULL,NULL,NULL,NULL),(9079,9070,0,'LSQ12hyn','LSQ',58.555,-8.54772222222222,NULL,NULL,'2012-11-12 06:16:03',56243.2611500002,20.0092,0.1223,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_snap_90524.gif',37043507335,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578804802,9043825,NULL,NULL,NULL,NULL),(9080,9070,0,'LSQ12hyn','LSQ',58.5547916666667,-8.54758333333333,NULL,NULL,'2012-11-14 05:53:27',56245.2454599999,19.4807,0.0818,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_snap_90416.gif',37043507335,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578804802,9043825,NULL,NULL,NULL,NULL),(9081,9070,0,'LSQ12hyn','LSQ',58.5540833333333,-8.54766666666667,NULL,NULL,'2012-11-16 05:44:44',56247.2393999998,20.3823,0.1533,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_snap_90417.gif',37043478600,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578804353,9043818,NULL,NULL,NULL,NULL),(9082,9070,0,'LSQ12hyn','LSQ',58.5543333333333,-8.54775,NULL,NULL,'2012-11-18 07:10:37',56249.29904,20.5262,0.1779,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_snap_90418.gif',37043507332,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578804802,9043825,NULL,NULL,NULL,NULL),(9083,9070,0,'LSQ12hyn','LSQ',58.5543333333333,-8.54769444444444,NULL,NULL,'2012-12-26 01:59:00',56287.0826400002,17.6248,0.0824,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_snap_90419.gif',37043507332,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578804802,9043825,NULL,NULL,NULL,NULL),(9084,9070,0,'LSQ12hyn','LSQ',58.5543333333333,-8.54758333333333,NULL,NULL,'2012-12-26 05:25:46',56287.2262300001,18.7388,0.1198,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_snap_90344.gif',37043507332,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578804802,9043825,NULL,NULL,NULL,NULL),(9085,9070,0,'LSQ12hyn','LSQ',58.55425,-8.54761111111111,NULL,NULL,'2012-12-26 05:29:10',56287.22859,17.9762,0.1252,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_snap_90345.gif',37043478600,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578804353,9043818,NULL,NULL,NULL,NULL),(9086,9086,1,'LSQ12hyl','LSQ',70.7504583333333,-7.10836111111111,NULL,NULL,'2012-10-14 08:21:50',56214.3484999998,20.3982,0.1417,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_snap_90384.gif',37510217559,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586097149,9157767,NULL,NULL,NULL,NULL),(9087,9086,0,'LSQ12hyl','LSQ',70.7505,-7.10858333333333,NULL,NULL,'2012-10-20 08:32:21',56220.3558,20.3653,0.179,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_snap_90385.gif',37510217556,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586097149,9157767,NULL,NULL,NULL,NULL),(9088,9086,0,'LSQ12hyl','LSQ',70.7503333333333,-7.1085,NULL,NULL,'2012-10-24 08:30:33',56224.3545599999,20.5792,0.179,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_snap_90386.gif',37510217556,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586097149,9157767,NULL,NULL,NULL,NULL),(9089,9086,0,'LSQ12hyl','LSQ',70.75025,-7.10838888888889,NULL,NULL,'2012-11-06 06:06:55',56237.2548099998,20.4787,0.2116,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_snap_90387.gif',37510217559,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586097149,9157767,NULL,NULL,NULL,NULL),(9090,9086,0,'LSQ12hyl','LSQ',70.7502916666667,-7.10844444444444,NULL,NULL,'2012-11-12 06:52:01',56243.2861299999,20.6014,0.1497,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_snap_90388.gif',37510217556,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586097149,9157767,NULL,NULL,NULL,NULL),(9091,9086,0,'LSQ12hyl','LSQ',70.7502083333333,-7.10847222222222,NULL,NULL,'2012-11-12 08:01:52',56243.3346299999,20.5451,0.1605,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_snap_90389.gif',37510217556,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586097149,9157767,NULL,NULL,NULL,NULL),(9092,9086,0,'LSQ12hyl','LSQ',70.7504166666667,-7.10866666666667,NULL,NULL,'2012-11-22 07:09:33',56253.2982999999,19.6725,0.2016,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_snap_90390.gif',37510217556,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586097149,9157767,NULL,NULL,NULL,NULL),(9093,9086,0,'LSQ12hyl','LSQ',70.7505,-7.10861111111111,NULL,NULL,'2012-12-26 02:27:55',56287.1027199998,16.7598,0.0365,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_snap_90340.gif',37510217556,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586097149,9157767,NULL,NULL,NULL,NULL),(9094,9086,0,'LSQ12hyl','LSQ',70.7504166666667,-7.10852777777778,NULL,NULL,'2012-12-26 06:25:42',56287.2678499999,17.8456,0.0708,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_snap_90341.gif',37510217556,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586097149,9157767,NULL,NULL,NULL,NULL),(9095,9095,1,'LSQ12hyh','LSQ',57.0914166666667,-6.92491666666667,NULL,NULL,'2012-08-28 08:23:10',56167.3494299999,18.0762,0.0498,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyh/LSQ12hyh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyh/LSQ12hyh_snap_90330.gif',37030530954,NULL,NULL,NULL,'2012-08-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,578602046,9040656,NULL,NULL,NULL,NULL),(9096,9095,0,'LSQ12hyh','LSQ',57.091625,-6.92422222222222,NULL,NULL,'2012-10-20 06:24:33',56220.26706,17.899,0.0727,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyh/LSQ12hyh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyh/LSQ12hyh_snap_90331.gif',37030530949,NULL,NULL,NULL,'2012-08-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,578602046,9040656,NULL,NULL,NULL,NULL),(9097,9095,0,'LSQ12hyh','LSQ',57.0914583333333,-6.92433333333333,NULL,NULL,'2012-11-08 08:04:49',56239.3366800002,19.0307,0.0964,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyh/LSQ12hyh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyh/LSQ12hyh_snap_90332.gif',37030531002,NULL,NULL,NULL,'2012-08-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,578602046,9040656,NULL,NULL,NULL,NULL),(9098,9095,0,'LSQ12hyh','LSQ',57.0915416666667,-6.92436111111111,NULL,NULL,'2012-11-14 07:48:31',56245.3253600001,17.7296,0.0489,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyh/LSQ12hyh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyh/LSQ12hyh_snap_90333.gif',37030530949,NULL,NULL,NULL,'2012-08-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,578602046,9040656,NULL,NULL,NULL,NULL),(9099,9095,0,'LSQ12hyh','LSQ',57.0915416666667,-6.92430555555556,NULL,NULL,'2012-12-26 01:43:27',56287.0718499999,9.6313,0.0445,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyh/LSQ12hyh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyh/LSQ12hyh_snap_90324.gif',37030530949,NULL,NULL,NULL,'2012-08-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,578602046,9040656,NULL,NULL,NULL,NULL),(9100,9095,0,'LSQ12hyh','LSQ',57.0915,-6.92436111111111,NULL,NULL,'2012-12-26 05:46:20',56287.24052,10.071,0.0381,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyh/LSQ12hyh_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyh/LSQ12hyh_snap_90325.gif',37030531002,NULL,NULL,NULL,'2012-08-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,578602046,9040656,NULL,NULL,NULL,NULL),(9101,9101,1,'LSQ12hyg','LSQ',66.6069583333333,-2.58641666666667,NULL,NULL,'2012-11-06 06:24:16',56237.2668599999,18.3846,0.062,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_snap_90326.gif',36923620875,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576931576,9014555,NULL,NULL,NULL,NULL),(9102,9101,0,'LSQ12hyg','LSQ',66.606625,-2.58638888888889,NULL,NULL,'2012-11-08 07:41:07',56239.3202200001,18.3865,0.0781,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_snap_90327.gif',36923620875,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576931576,9014555,NULL,NULL,NULL,NULL),(9103,9101,0,'LSQ12hyg','LSQ',66.606875,-2.58633333333333,NULL,NULL,'2012-12-24 02:04:12',56285.0862599998,16.5992,0.0544,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_snap_90328.gif',36923620875,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576931576,9014555,NULL,NULL,NULL,NULL),(9104,9101,0,'LSQ12hyg','LSQ',66.60675,-2.58627777777778,NULL,NULL,'2012-12-24 04:05:36',56285.17056,16.7086,0.0532,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_snap_90329.gif',36923620875,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576931576,9014555,NULL,NULL,NULL,NULL),(9105,9101,0,'LSQ12hyg','LSQ',66.6068333333333,-2.58630555555556,NULL,NULL,'2012-12-26 02:05:53',56287.0874200002,17.2158,0.0626,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_snap_90322.gif',36923620875,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576931576,9014555,NULL,NULL,NULL,NULL),(9106,9101,0,'LSQ12hyg','LSQ',66.6068333333333,-2.58627777777778,NULL,NULL,'2012-12-26 05:49:43',56287.2428600001,16.5989,0.0451,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-27 18:46:15','2012-12-27 18:46:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_snap_90323.gif',36923620875,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576931576,9014555,NULL,NULL,NULL,NULL),(9152,7075,0,'LSQ12gxb','LSQ',142.839041666667,-11.6296388888889,NULL,NULL,'2012-12-28 07:17:16',56289.3036600002,19.7742,0.1871,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxb/LSQ12gxb_snap_90541.gif',42178887818,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,659045122,10297580,NULL,NULL,NULL,NULL),(9153,7096,0,'LSQ12gyd','LSQ',76.3870833333333,-18.0350833333333,NULL,NULL,'2012-12-28 02:55:34',56289.1219299999,18.9846,0.1227,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_90535.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(9154,7096,0,'LSQ12gyd','LSQ',76.3870833333333,-18.0350833333333,NULL,NULL,'2012-12-28 05:05:14',56289.2119700001,19.1578,0.1408,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_90536.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(9155,7337,0,'LSQ12hcc','LSQ',143.778541666667,-8.5505,NULL,NULL,'2012-12-28 05:52:21',56289.2446900001,17.499,0.0696,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcc/LSQ12hcc_history.html','sn?',NULL,0.089982,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcc/LSQ12hcc_snap_90555.gif',41103056560,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642235258,10034925,NULL,NULL,NULL,NULL),(9156,7337,0,'LSQ12hcc','LSQ',143.778458333333,-8.55055555555556,NULL,NULL,'2012-12-28 07:17:16',56289.3036600002,18.4475,0.1171,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcc/LSQ12hcc_history.html','sn?',NULL,0.089982,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hcc/LSQ12hcc_snap_90556.gif',41103056560,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642235258,10034925,NULL,NULL,NULL,NULL),(9157,7507,0,'LSQ12hgj','LSQ',154.207291666667,-16.1958333333333,NULL,NULL,'2012-12-28 05:30:07',56289.2292499999,19.2951,0.1912,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_snap_90630.gif',41166665804,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643229153,10050455,NULL,NULL,NULL,NULL),(9158,7507,0,'LSQ12hgj','LSQ',154.20725,-16.19575,NULL,NULL,'2012-12-28 08:31:09',56289.3549700002,20.3638,0.1903,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_snap_90631.gif',41166665804,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643229153,10050455,NULL,NULL,NULL,NULL),(9159,7934,0,'LSQ12hmc','LSQ',168.302708333333,-12.3908611111111,NULL,NULL,'2012-12-28 08:26:05',56289.35145,18.8205,0.0619,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmc/LSQ12hmc_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmc/LSQ12hmc_snap_90625.gif',41691785886,NULL,NULL,NULL,'2012-06-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651434154,10178658,NULL,NULL,NULL,NULL),(9160,7937,0,'LSQ12hmb','LSQ',151.367291666667,-13.1325277777778,NULL,NULL,'2012-12-28 05:26:44',56289.2269000001,18.9601,0.148,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_snap_90628.gif',41162875500,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643169929,10049530,NULL,NULL,NULL,NULL),(9161,7937,0,'LSQ12hmb','LSQ',151.367291666667,-13.1324722222222,NULL,NULL,'2012-12-28 07:05:11',56289.2952700001,18.7521,0.1064,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_snap_90629.gif',41162875493,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643169929,10049530,NULL,NULL,NULL,NULL),(9162,8208,0,'LSQ12hno','LSQ',55.6801666666667,-2.66941666666667,NULL,NULL,'2012-12-28 01:31:36',56289.0636200001,17.6515,0.0614,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2013-01-03 13:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_90618.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(9163,8208,0,'LSQ12hno','LSQ',55.6801666666667,-2.66941666666667,NULL,NULL,'2012-12-28 03:32:34',56289.1476199999,17.3417,0.0674,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2013-01-03 13:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_90619.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(9164,8216,0,'LSQ12hns','LSQ',167.904208333333,-10.7736111111111,NULL,NULL,'2012-12-28 06:33:16',56289.27311,18.9457,0.1227,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hns/LSQ12hns_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hns/LSQ12hns_snap_90532.gif',40886241208,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638847518,9981992,NULL,NULL,NULL,NULL),(9165,8216,0,'LSQ12hns','LSQ',167.90425,-10.7737222222222,NULL,NULL,'2012-12-28 08:01:45',56289.3345499998,18.9076,0.1115,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hns/LSQ12hns_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hns/LSQ12hns_snap_90533.gif',40886241208,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638847518,9981992,NULL,NULL,NULL,NULL),(9166,8218,0,'LSQ12hnr','LSQ',160.811541666667,-8.77794444444445,NULL,NULL,'2012-12-28 06:19:09',56289.2633000002,18.5884,0.1462,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_snap_90530.gif',41807774750,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653246480,10206976,NULL,NULL,NULL,NULL),(9167,8218,0,'LSQ12hnr','LSQ',160.811541666667,-8.77794444444445,NULL,NULL,'2012-12-28 07:31:24',56289.31348,18.3519,0.1239,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_snap_90531.gif',41807774750,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653246480,10206976,NULL,NULL,NULL,NULL),(9168,8624,0,'LSQ12htf','LSQ',163.394708333333,-10.6360555555556,NULL,NULL,'2012-12-28 06:24:28',56289.267,19.3234,0.2053,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htf/LSQ12htf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htf/LSQ12htf_snap_90594.gif',41786968111,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,652921376,10201896,NULL,NULL,NULL,NULL),(9169,8879,0,'LSQ12hxi','LSQ',61.6558333333333,-0.73,NULL,NULL,'2012-12-28 01:48:38',56289.0754499999,18.4391,0.196,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_snap_90545.gif',36935907244,NULL,NULL,NULL,'2012-11-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577123550,9017555,NULL,NULL,NULL,NULL),(9170,8895,0,'LSQ12hxg','LSQ',62.9475833333333,-5.91908333333333,NULL,NULL,'2012-12-28 02:14:46',56289.0935900002,18.3301,0.146,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2013-01-02 15:16:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_90560.gif',36962123763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(9171,8895,0,'LSQ12hxg','LSQ',62.9475416666667,-5.91905555555556,NULL,NULL,'2012-12-28 04:15:37',56289.1775199999,18.6835,0.1457,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2013-01-02 15:16:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_90561.gif',36962123763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(9172,8904,0,'LSQ12hxb','LSQ',174.203333333333,-8.73036111111111,NULL,NULL,'2012-12-28 06:36:39',56289.2754600001,18.3648,0.078,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxb/LSQ12hxb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxb/LSQ12hxb_snap_90550.gif',41063321975,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,641614405,10025225,NULL,NULL,NULL,NULL),(9173,8904,0,'LSQ12hxb','LSQ',174.203375,-8.73033333333333,NULL,NULL,'2012-12-28 07:40:07',56289.31953,18.3961,0.0733,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxb/LSQ12hxb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxb/LSQ12hxb_snap_90551.gif',41063321975,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,641614405,10025225,NULL,NULL,NULL,NULL),(9174,8912,0,'LSQ12hvz','LSQ',59.6747916666667,-13.3244166666667,NULL,NULL,'2012-12-28 02:07:58',56289.0888700001,18.6531,0.1032,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_snap_90528.gif',36893561548,NULL,NULL,NULL,'2012-11-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576461899,9007217,NULL,NULL,NULL,NULL),(9175,8912,0,'LSQ12hvz','LSQ',59.67475,-13.3243333333333,NULL,NULL,'2012-12-28 04:08:53',56289.1728400001,18.6286,0.112,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_snap_90529.gif',36893561548,NULL,NULL,NULL,'2012-11-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576461899,9007217,NULL,NULL,NULL,NULL),(9176,9086,0,'LSQ12hyl','LSQ',70.7505,-7.10852777777778,NULL,NULL,'2012-12-28 02:28:18',56289.10299,19.5634,0.193,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_snap_90581.gif',37510217556,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586097149,9157767,NULL,NULL,NULL,NULL),(9177,9086,0,'LSQ12hyl','LSQ',70.7505416666667,-7.1085,NULL,NULL,'2012-12-28 04:29:11',56289.1869399999,19.4071,0.1846,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyl/LSQ12hyl_snap_90582.gif',37510217556,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586097149,9157767,NULL,NULL,NULL,NULL),(9178,9101,0,'LSQ12hyg','LSQ',66.6069166666667,-2.58669444444444,NULL,NULL,'2012-12-28 02:06:14',56289.0876699998,18.6931,0.1111,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_snap_90563.gif',36923620875,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576931576,9014555,NULL,NULL,NULL,NULL),(9179,9101,0,'LSQ12hyg','LSQ',66.6067916666667,-2.58627777777778,NULL,NULL,'2012-12-28 04:07:07',56289.1716200002,16.8256,0.0413,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 18:46:18','2012-12-28 18:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_snap_90564.gif',36923620875,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576931576,9014555,NULL,NULL,NULL,NULL),(9180,9180,1,'LSQ12hzo','LSQ',136.200125,18.6495555555556,NULL,NULL,'2012-12-24 07:38:01',56285.31807,21.4347,0.1563,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzo/LSQ12hzo_history.html','sn?',NULL,0.11231,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzo/LSQ12hzo_snap_90931.gif',63876968330,NULL,NULL,NULL,'2012-04-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,998077630,15594962,NULL,NULL,NULL,NULL),(9181,9180,0,'LSQ12hzo','LSQ',136.200041666667,18.6496666666667,NULL,NULL,'2012-12-28 06:49:26',56289.2843300002,18.1071,0.136,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2013-01-03 17:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzo/LSQ12hzo_history.html','sn?',NULL,0.11231,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzo/LSQ12hzo_snap_90856.gif',63876968331,NULL,NULL,NULL,'2012-04-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,998077630,15594962,NULL,NULL,NULL,NULL),(9182,9180,0,'LSQ12hzo','LSQ',136.200125,18.6496111111111,NULL,NULL,'2012-12-28 07:45:52',56289.3235300002,17.9756,0.1305,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2013-01-03 17:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzo/LSQ12hzo_history.html','sn?',NULL,0.11231,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzo/LSQ12hzo_snap_90857.gif',63876968330,NULL,NULL,NULL,'2012-04-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,998077630,15594962,NULL,NULL,NULL,NULL),(9183,9183,1,'LSQ12hzj','LSQ',149.80175,-9.00230555555556,NULL,NULL,'2012-12-24 05:49:14',56285.2425299999,20.2844,0.1403,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_snap_90878.gif',41335019974,NULL,NULL,NULL,'2012-12-05 05:54:14',56266.246,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645859687,10091557,NULL,NULL,NULL,NULL),(9184,9183,0,'LSQ12hzj','LSQ',149.80175,-9.00230555555556,NULL,NULL,'2012-12-24 07:14:13',56285.3015399999,20.7217,0.1455,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2013-01-05 16:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_snap_90879.gif',41335019974,NULL,NULL,NULL,'2012-12-05 05:54:14',56266.246,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645859687,10091557,NULL,NULL,NULL,NULL),(9185,9183,0,'LSQ12hzj','LSQ',149.801791666667,-9.00227777777778,NULL,NULL,'2012-12-28 06:03:10',56289.2522100001,18.4368,0.0517,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2013-01-05 16:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_snap_90846.gif',41335019974,NULL,NULL,NULL,'2012-12-05 05:54:14',56266.246,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645859687,10091557,NULL,NULL,NULL,NULL),(9186,9183,0,'LSQ12hzj','LSQ',149.801833333333,-9.00227777777778,NULL,NULL,'2012-12-28 07:22:59',56289.3076300002,18.3336,0.0487,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2013-01-05 16:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_snap_90847.gif',41335019974,NULL,NULL,NULL,'2012-12-05 05:54:14',56266.246,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645859687,10091557,NULL,NULL,NULL,NULL),(9187,9187,1,'LSQ12hzi','LSQ',66.4565,-8.54575,NULL,NULL,'2012-11-04 05:16:49',56235.2200199999,19.0571,0.1152,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_snap_90870.gif',37473842553,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585528789,9148887,NULL,NULL,NULL,NULL),(9188,9187,0,'LSQ12hzi','LSQ',66.4565,-8.54575,NULL,NULL,'2012-11-04 07:02:53',56235.29367,18.994,0.1183,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2012-12-28 22:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_snap_90871.gif',37473842553,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585528789,9148887,NULL,NULL,NULL,NULL),(9189,9187,0,'LSQ12hzi','LSQ',66.456625,-8.54572222222222,NULL,NULL,'2012-11-06 05:46:34',56237.2406799998,19.5055,0.1466,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2012-12-28 22:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_snap_90872.gif',37473842553,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585528789,9148887,NULL,NULL,NULL,NULL),(9190,9187,0,'LSQ12hzi','LSQ',66.4565,-8.54569444444444,NULL,NULL,'2012-12-24 02:24:38',56285.1004499998,18.8239,0.1292,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2012-12-28 22:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_snap_90873.gif',37473842553,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585528789,9148887,NULL,NULL,NULL,NULL),(9191,9187,0,'LSQ12hzi','LSQ',66.4565416666667,-8.54575,NULL,NULL,'2012-12-24 04:25:54',56285.1846599998,19.1171,0.1893,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2012-12-28 22:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_snap_90874.gif',37473842553,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585528789,9148887,NULL,NULL,NULL,NULL),(9192,9187,0,'LSQ12hzi','LSQ',66.4565833333333,-8.54566666666667,NULL,NULL,'2012-12-26 02:26:13',56287.1015400002,18.7788,0.1406,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2012-12-28 22:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_snap_90875.gif',37473842553,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585528789,9148887,NULL,NULL,NULL,NULL),(9193,9187,0,'LSQ12hzi','LSQ',66.4564583333333,-8.54572222222222,NULL,NULL,'2012-12-26 04:46:35',56287.1990200002,18.9413,0.1515,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2012-12-28 22:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_snap_90876.gif',37473842553,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585528789,9148887,NULL,NULL,NULL,NULL),(9194,9187,0,'LSQ12hzi','LSQ',66.4565,-8.54563888888889,NULL,NULL,'2012-12-26 04:51:38',56287.2025299999,18.758,0.1088,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2012-12-28 22:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_snap_90877.gif',37473842553,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585528789,9148887,NULL,NULL,NULL,NULL),(9195,9187,0,'LSQ12hzi','LSQ',66.4565,-8.54566666666667,NULL,NULL,'2012-12-28 02:26:37',56289.10182,18.7398,0.1431,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2012-12-28 22:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_snap_90844.gif',37473842553,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585528789,9148887,NULL,NULL,NULL,NULL),(9196,9187,0,'LSQ12hzi','LSQ',66.4565,-8.54575,NULL,NULL,'2012-12-28 04:27:29',56289.1857599998,18.3492,0.1176,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2012-12-28 22:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_snap_90845.gif',37473842553,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585528789,9148887,NULL,NULL,NULL,NULL),(9197,9197,1,'LSQ12hzh','LSQ',66.4474166666667,-8.60930555555555,NULL,NULL,'2012-10-10 08:26:45',56210.3519199998,19.6382,0.1262,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_snap_90859.gif',37473128013,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585517625,9148712,NULL,NULL,NULL,NULL),(9198,9197,0,'LSQ12hzh','LSQ',66.4481666666667,-8.60938888888889,NULL,NULL,'2012-10-14 06:08:41',56214.2560399999,20.1286,0.1344,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2012-12-28 22:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_snap_90860.gif',37473128009,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585517625,9148712,NULL,NULL,NULL,NULL),(9199,9197,0,'LSQ12hzh','LSQ',66.4471666666667,-8.60938888888889,NULL,NULL,'2012-11-08 07:25:21',56239.3092800002,19.674,0.154,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2012-12-28 22:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_snap_90932.gif',37473128002,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585517625,9148712,NULL,NULL,NULL,NULL),(9200,9197,0,'LSQ12hzh','LSQ',66.4470833333333,-8.60955555555556,NULL,NULL,'2012-11-12 07:33:09',56243.3146899999,19.8087,0.1361,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2012-12-28 22:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_snap_90933.gif',37473128002,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585517625,9148712,NULL,NULL,NULL,NULL),(9201,9197,0,'LSQ12hzh','LSQ',66.44725,-8.60947222222222,NULL,NULL,'2012-11-14 06:00:18',56245.2502100002,18.8462,0.0813,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2012-12-28 22:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_snap_90861.gif',37473128002,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585517625,9148712,NULL,NULL,NULL,NULL),(9202,9197,0,'LSQ12hzh','LSQ',66.4472083333333,-8.60936111111111,NULL,NULL,'2012-11-14 07:21:05',56245.3063099999,20.1189,0.1647,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2012-12-28 22:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_snap_90862.gif',37473128002,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585517625,9148712,NULL,NULL,NULL,NULL),(9203,9197,0,'LSQ12hzh','LSQ',66.4477916666667,-8.60927777777778,NULL,NULL,'2012-12-26 02:26:13',56287.1015400002,17.6095,0.1217,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2012-12-28 22:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_snap_90863.gif',37473128013,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585517625,9148712,NULL,NULL,NULL,NULL),(9204,9197,0,'LSQ12hzh','LSQ',66.447875,-8.60938888888889,NULL,NULL,'2012-12-28 02:26:37',56289.10182,18.1619,0.1345,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2012-12-28 22:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_snap_90842.gif',37473128013,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585517625,9148712,NULL,NULL,NULL,NULL),(9205,9197,0,'LSQ12hzh','LSQ',66.4478333333333,-8.60933333333333,NULL,NULL,'2012-12-28 04:27:29',56289.1857599998,17.9681,0.1671,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-28 22:46:17','2012-12-28 22:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_snap_90843.gif',37473128013,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585517625,9148712,NULL,NULL,NULL,NULL),(9206,7106,0,'LSQ12gxv','LSQ',70.4224583333333,-22.1973055555556,NULL,NULL,'2012-12-29 02:39:25',56290.1107100002,16.9332,0.0551,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 16:46:22','2012-12-29 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_history.html','sne - nice',NULL,0.066686,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gxv/LSQ12gxv_snap_90959.gif',37340201663,NULL,NULL,NULL,'2012-11-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583440650,9116260,NULL,NULL,NULL,NULL),(9207,7445,0,'LSQ12heq','LSQ',53.267375,-28.21375,NULL,NULL,'2012-12-29 01:56:53',56290.0811800002,18.9854,0.1057,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 16:46:22','2012-12-29 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_91039.gif',38581253600,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(9208,7445,0,'LSQ12heq','LSQ',53.2673333333333,-28.2137222222222,NULL,NULL,'2012-12-29 03:56:50',56290.1644700002,19.1125,0.1075,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 16:46:22','2012-12-29 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_91040.gif',38581253600,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(9209,7613,0,'LSQ12hje','LSQ',77.1706666666667,-20.9645,NULL,NULL,'2012-12-29 03:06:46',56290.1296999999,18.7042,0.1314,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 16:46:22','2012-12-29 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_91035.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(9210,7613,0,'LSQ12hje','LSQ',77.17075,-20.9645,NULL,NULL,'2012-12-29 05:06:25',56290.2127899998,18.73,0.1546,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 16:46:22','2012-12-29 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_91036.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(9211,7751,0,'LSQ12hle','LSQ',61.1045416666667,-29.1576944444444,NULL,NULL,'2012-12-29 04:10:20',56290.1738499999,18.849,0.159,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 16:46:22','2012-12-29 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_snap_91062.gif',38530541650,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602039713,9406870,NULL,NULL,NULL,NULL),(9212,8046,0,'LSQ12hnj','LSQ',78.10325,-25.7825,NULL,NULL,'2012-12-29 03:03:23',56290.1273500002,15.8923,0.0079,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 16:46:22','2012-12-29 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_91088.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(9213,8046,0,'LSQ12hnj','LSQ',78.10325,-25.7825,NULL,NULL,'2012-12-29 05:03:02',56290.2104400001,15.8226,0.0103,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 16:46:22','2012-12-29 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_91089.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(9214,8046,0,'LSQ12hnj','LSQ',78.102875,-25.7827222222222,NULL,NULL,'2012-12-29 05:04:43',56290.2116100001,16.2308,0.0173,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 16:46:22','2012-12-29 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_91090.gif',37249489805,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(9215,8228,0,'LSQ12hon','LSQ',57.893375,-24.2264166666667,NULL,NULL,'2012-12-29 02:07:05',56290.0882600001,19.1541,0.186,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 16:46:22','2012-12-30 21:46:27','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_90948.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(9216,8686,0,'LSQ12hvj','LSQ',166.910875,-29.7113888888889,NULL,NULL,'2012-12-29 05:19:33',56290.2219199999,17.7866,0.0637,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 16:46:22','2012-12-30 09:16:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_91128.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(9217,8949,0,'LSQ12hyd','LSQ',174.637916666667,-24.2078888888889,NULL,NULL,'2012-12-29 05:37:45',56290.2345599998,19.2769,0.1417,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 16:46:22','2012-12-29 16:46:22','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_snap_91026.gif',41410841875,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647044404,10110068,NULL,NULL,NULL,NULL),(9218,8959,0,'LSQ12hxx','LSQ',49.93425,-27.0071111111111,NULL,NULL,'2012-12-29 01:44:47',56290.07277,17.4381,0.0306,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 16:46:22','2013-01-01 08:16:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_91053.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(9219,8959,0,'LSQ12hxx','LSQ',49.9342916666667,-27.0071111111111,NULL,NULL,'2012-12-29 03:45:00',56290.15625,17.6021,0.0375,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 16:46:22','2013-01-01 08:16:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_91054.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(9220,8966,0,'LSQ12hxt','LSQ',56.8413333333333,-31.2003611111111,NULL,NULL,'2012-12-29 02:03:44',56290.0859300001,18.62,0.1041,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 16:46:22','2013-01-03 17:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_91023.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(9221,8966,0,'LSQ12hxt','LSQ',56.841375,-31.2003611111111,NULL,NULL,'2012-12-29 04:03:36',56290.1691700001,18.5718,0.1225,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 16:46:22','2013-01-03 17:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_91024.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(9251,9251,1,'LSQ12hzu','LSQ',76.9717083333333,-20.9746666666667,NULL,NULL,'2012-11-13 06:35:36',56244.2747300002,20.5744,0.1962,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 21:46:24','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_91317.gif',37548507155,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(9252,9251,0,'LSQ12hzu','LSQ',76.9713333333333,-20.9749722222222,NULL,NULL,'2012-11-24 06:09:26',56255.2565600001,19.3981,0.1477,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 21:46:24','2013-01-02 09:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_91318.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(9253,9251,0,'LSQ12hzu','LSQ',76.9712083333333,-20.9748611111111,NULL,NULL,'2012-12-25 02:59:24',56286.1245900001,18.5222,0.0744,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 21:46:24','2013-01-02 09:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_91319.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(9254,9251,0,'LSQ12hzu','LSQ',76.9712083333333,-20.9748055555556,NULL,NULL,'2012-12-25 05:08:36',56286.2143100002,19.0068,0.1203,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 21:46:24','2013-01-02 09:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_91320.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(9255,9251,0,'LSQ12hzu','LSQ',76.9711666666667,-20.9747777777778,NULL,NULL,'2012-12-29 03:06:46',56290.1296999999,18.4496,0.0868,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 21:46:24','2013-01-02 09:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_91239.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(9256,9251,0,'LSQ12hzu','LSQ',76.9711666666667,-20.9747777777778,NULL,NULL,'2012-12-29 05:06:25',56290.2127899998,18.6954,0.1062,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 21:46:24','2013-01-02 09:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_91240.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(9257,9257,1,'LSQ12hzs','LSQ',60.4718333333333,-26.6638611111111,NULL,NULL,'2012-12-22 02:24:33',56283.1003899998,19.5888,0.1733,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 21:46:24','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_history.html','sn nice',NULL,0.07213,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_snap_91248.gif',38534445066,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602100704,9407823,NULL,NULL,NULL,NULL),(9258,9257,0,'LSQ12hzs','LSQ',60.4716666666667,-26.6639722222222,NULL,NULL,'2012-12-25 02:02:35',56286.08513,20.232,0.2113,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 21:46:24','2013-01-02 09:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_history.html','sn nice',NULL,0.07213,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_snap_91249.gif',38534445066,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602100704,9407823,NULL,NULL,NULL,NULL),(9259,9257,0,'LSQ12hzs','LSQ',60.4716666666667,-26.6638888888889,NULL,NULL,'2012-12-25 04:03:38',56286.1691899998,19.7007,0.155,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 21:46:24','2013-01-02 09:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_history.html','sn nice',NULL,0.07213,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_snap_91250.gif',38534445066,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602100704,9407823,NULL,NULL,NULL,NULL),(9260,9257,0,'LSQ12hzs','LSQ',60.471625,-26.6639722222222,NULL,NULL,'2012-12-29 02:10:27',56290.0906000002,19.0243,0.103,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 21:46:24','2013-01-02 09:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_history.html','sn nice',NULL,0.07213,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_snap_91235.gif',38534445066,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602100704,9407823,NULL,NULL,NULL,NULL),(9261,9257,0,'LSQ12hzs','LSQ',60.4717083333333,-26.6639722222222,NULL,NULL,'2012-12-29 04:10:20',56290.1738499999,18.6003,0.0958,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-29 21:46:24','2013-01-02 09:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_history.html','sn nice',NULL,0.07213,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_snap_91236.gif',38534445066,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602100704,9407823,NULL,NULL,NULL,NULL),(9262,8686,0,'LSQ12hvj','atel',166.910958333,-29.7113611111,NULL,NULL,'2012-12-27 00:00:00',56288,NULL,NULL,NULL,0.06,NULL,'Ia',NULL,'2012-12-30 09:12:31','2012-12-30 09:16:41','http://www.astronomerstelegram.org/?read=4685',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41600019118,'NOT','ALFOSC','Hadjiyska','2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(9263,7096,0,'LSQ12gyd','LSQ',76.387125,-18.0351111111111,NULL,NULL,'2012-12-30 02:54:38',56291.1212800001,19.3088,0.134,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 13:46:17','2012-12-30 13:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_history.html','sne - hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12gyd/LSQ12gyd_snap_91326.gif',37552105663,NULL,NULL,NULL,'2012-11-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586751650,9167994,NULL,NULL,NULL,NULL),(9264,7894,0,'LSQ12hlz','LSQ',74.4072083333333,-15.3167222222222,NULL,NULL,'2012-12-30 02:49:33',56291.1177500002,19.4958,0.1708,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 13:46:17','2012-12-30 13:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_91419.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(9265,8208,0,'LSQ12hno','LSQ',55.68025,-2.66941666666667,NULL,NULL,'2012-12-30 03:08:26',56291.1308599999,17.6045,0.0415,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 13:46:17','2013-01-03 13:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_91409.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(9266,8208,0,'LSQ12hno','LSQ',55.6801666666667,-2.66938888888889,NULL,NULL,'2012-12-30 04:24:08',56291.1834300002,17.606,0.0565,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 13:46:17','2013-01-03 13:16:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_91410.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(9267,8879,0,'LSQ12hxi','LSQ',61.6558333333333,-0.729888888888889,NULL,NULL,'2012-12-30 01:47:47',56291.07485,18.2973,0.1589,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 13:46:17','2012-12-30 13:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_snap_91336.gif',36935907244,NULL,NULL,NULL,'2012-11-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577123550,9017555,NULL,NULL,NULL,NULL),(9268,8895,0,'LSQ12hxg','LSQ',62.9475833333333,-5.91902777777778,NULL,NULL,'2012-12-30 02:13:42',56291.0928500001,18.2201,0.0679,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 13:46:17','2013-01-02 15:16:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_91342.gif',36962123763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(9269,8895,0,'LSQ12hxg','LSQ',62.9476666666667,-5.91902777777778,NULL,NULL,'2012-12-30 04:13:49',56291.1762700002,18.4702,0.0866,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 13:46:17','2013-01-02 15:16:15','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_91343.gif',36962123763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(9270,8912,0,'LSQ12hvz','LSQ',59.67475,-13.3243888888889,NULL,NULL,'2012-12-30 02:06:56',56291.0881500002,18.5593,0.0774,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 13:46:17','2012-12-30 13:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_snap_91323.gif',36893561548,NULL,NULL,NULL,'2012-11-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576461899,9007217,NULL,NULL,NULL,NULL),(9271,8912,0,'LSQ12hvz','LSQ',59.6747916666667,-13.3243888888889,NULL,NULL,'2012-12-30 04:07:03',56291.1715699998,18.5873,0.0893,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 13:46:17','2012-12-30 13:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_snap_91324.gif',36893561548,NULL,NULL,NULL,'2012-11-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576461899,9007217,NULL,NULL,NULL,NULL),(9272,9042,0,'LSQ12hys','LSQ',66.3928333333333,-8.53561111111111,NULL,NULL,'2012-12-30 02:25:41',56291.1011700002,18.5394,0.1644,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 13:46:17','2012-12-30 13:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_snap_91356.gif',37473130956,NULL,NULL,NULL,'2012-10-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585517671,9148713,NULL,NULL,NULL,NULL),(9273,9042,0,'LSQ12hys','LSQ',66.3927083333333,-8.53594444444444,NULL,NULL,'2012-12-30 04:30:58',56291.1881800001,18.1324,0.1542,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 13:46:17','2012-12-30 13:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_snap_91357.gif',37473130959,NULL,NULL,NULL,'2012-10-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585517671,9148713,NULL,NULL,NULL,NULL),(9274,9049,0,'LSQ12hyr','LSQ',64.0625416666667,-10.9515833333333,NULL,NULL,'2012-12-30 04:29:17',56291.18701,19.776,0.1402,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 13:46:17','2012-12-30 13:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_history.html','sn',NULL,0.045375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_snap_91378.gif',36980827675,NULL,NULL,NULL,'2012-10-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577825432,9028522,NULL,NULL,NULL,NULL),(9275,9056,0,'LSQ12hyo','LSQ',58.4470416666667,-8.56847222222222,NULL,NULL,'2012-12-30 03:58:24',56291.1655600001,17.5614,0.0819,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 13:46:17','2012-12-30 13:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_history.html','sn?',NULL,0.032466,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyo/LSQ12hyo_snap_91349.gif',37043464288,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,578804129,9043814,NULL,NULL,NULL,NULL),(9276,9070,0,'LSQ12hyn','LSQ',58.5542083333333,-8.54777777777778,NULL,NULL,'2012-12-30 03:58:24',56291.1655600001,19.0745,0.2044,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 13:46:17','2012-12-30 13:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyn/LSQ12hyn_snap_91360.gif',37043478600,NULL,NULL,NULL,'2012-10-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,578804353,9043818,NULL,NULL,NULL,NULL),(9277,9101,0,'LSQ12hyg','LSQ',66.6067083333333,-2.58636111111111,NULL,NULL,'2012-12-30 04:05:21',56291.1703900001,19.9722,0.1498,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 13:46:17','2012-12-30 13:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_snap_91346.gif',36923620875,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576931576,9014555,NULL,NULL,NULL,NULL),(9278,9187,0,'LSQ12hzi','LSQ',66.4565416666667,-8.54561111111111,NULL,NULL,'2012-12-30 02:25:41',56291.1011700002,19.524,0.1731,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 13:46:17','2012-12-30 13:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzi/LSQ12hzi_snap_91408.gif',37473842553,NULL,NULL,NULL,'2012-11-02 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,585528789,9148887,NULL,NULL,NULL,NULL),(9284,9284,1,'LSQ12hzv','LSQ',53.0535,-14.7141388888889,NULL,NULL,'2012-12-30 01:54:51',56291.0797600001,19.5204,0.1653,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 15:46:17','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzv/LSQ12hzv_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzv/LSQ12hzv_snap_91479.gif',38002289697,NULL,NULL,NULL,'2012-12-28 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593785776,9277902,NULL,NULL,NULL,NULL),(9285,9284,0,'LSQ12hzv','LSQ',53.0535,-14.7141111111111,NULL,NULL,'2012-12-30 03:55:01',56291.1632099999,19.1898,0.1505,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-30 15:46:17','2012-12-30 15:46:17','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzv/LSQ12hzv_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzv/LSQ12hzv_snap_91480.gif',38002289697,NULL,NULL,NULL,'2012-12-28 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593785776,9277902,NULL,NULL,NULL,NULL),(9286,8228,0,'LSQ12hon','pessto',57.893375,-24.2263888889,NULL,NULL,'2012-12-16 00:00:00',56277,NULL,NULL,NULL,0.185,NULL,'Ia',NULL,'2012-12-30 21:31:29','2012-12-30 21:46:27','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37994038644,'NTT','EFOSC2','LPHNE','2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(9287,8218,0,'LSQ12hnr','pessto',160.811666667,-8.77805555556,NULL,NULL,'2012-12-22 00:00:00',56283,NULL,NULL,NULL,0.135,NULL,'Ia',NULL,'2012-12-30 21:37:21','2012-12-30 21:46:27','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41807774750,'NTT','EFOSC2','LPHNE','2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653246480,10206976,NULL,NULL,NULL,NULL),(9288,8216,0,'LSQ12hns','pessto',167.904208333,-10.7736666667,NULL,NULL,'2012-12-22 00:00:00',56283,NULL,NULL,NULL,0.104,NULL,'IIn',NULL,'2012-12-30 21:39:29','2012-12-30 21:46:27','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,40886241208,'NTT','EFOSC','LPHNE','2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638847518,9981992,NULL,NULL,NULL,NULL),(9289,8622,0,'LSQ12htu','pessto',152.904625,-7.38655555556,NULL,NULL,'2012-12-22 00:00:00',56283,NULL,NULL,NULL,0.052,NULL,'IIb',NULL,'2012-12-30 21:46:24','2012-12-30 21:46:27','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41250115247,'NTT','EFOSC2','LPHNE','2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644533050,10070828,NULL,NULL,NULL,NULL),(9290,8427,0,'PSNJ09351166-1624178','pessto',143.79858,-16.40494,NULL,NULL,'2012-12-20 00:00:00',56281,NULL,NULL,NULL,0.015,NULL,'Ia',NULL,'2012-12-30 21:55:05','2012-12-30 21:55:05','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,42312098601,'NTT','EFOSC2','LPHNE',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,661126540,10330102,NULL,NULL,NULL,NULL),(9308,7432,0,'LSQ12hdl','LSQ',53.435125,-30.3176944444444,NULL,NULL,'2012-12-31 03:45:23',56292.1565200002,18.0573,0.0718,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_history.html','sn?',NULL,0.130297,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hdl/LSQ12hdl_snap_91642.gif',38573467025,NULL,NULL,NULL,'2012-11-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602710422,9417350,NULL,NULL,NULL,NULL),(9309,7445,0,'LSQ12heq','LSQ',53.2673333333333,-28.2137222222222,NULL,NULL,'2012-12-31 01:52:58',56292.07846,19.1591,0.0712,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_91649.gif',38581253600,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(9310,7445,0,'LSQ12heq','LSQ',53.267375,-28.21375,NULL,NULL,'2012-12-31 03:52:09',56292.1612200001,19.1947,0.0892,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12heq/LSQ12heq_snap_91650.gif',38581253600,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,602832087,9419251,NULL,NULL,NULL,NULL),(9311,7613,0,'LSQ12hje','LSQ',77.17075,-20.9645,NULL,NULL,'2012-12-31 03:02:49',56292.12696,18.7912,0.1104,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_91647.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(9312,7613,0,'LSQ12hje','LSQ',77.1707083333333,-20.9645555555556,NULL,NULL,'2012-12-31 05:02:07',56292.2098099999,18.9814,0.131,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_91648.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(9313,7751,0,'LSQ12hle','LSQ',61.104375,-29.1578333333333,NULL,NULL,'2012-12-31 04:05:55',56292.1707799998,19.7645,0.1593,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_snap_91674.gif',38530541650,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602039713,9406870,NULL,NULL,NULL,NULL),(9314,8046,0,'LSQ12hnj','LSQ',78.1033333333333,-25.7825555555556,NULL,NULL,'2012-12-31 02:59:26',56292.1246099998,15.9872,0.0075,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_91707.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(9315,8046,0,'LSQ12hnj','LSQ',78.1026666666667,-25.7825833333333,NULL,NULL,'2012-12-31 03:01:07',56292.1257799999,16.3305,0.0084,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_91709.gif',37249489805,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(9316,8046,0,'LSQ12hnj','LSQ',78.1033333333333,-25.7825277777778,NULL,NULL,'2012-12-31 04:58:43',56292.2074500001,15.9903,0.0084,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_91708.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(9317,8046,0,'LSQ12hnj','LSQ',78.102625,-25.7826111111111,NULL,NULL,'2012-12-31 05:00:24',56292.2086200002,16.1952,0.0104,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_91710.gif',37249489807,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(9318,8228,0,'LSQ12hon','LSQ',57.8934166666667,-24.2264166666667,NULL,NULL,'2012-12-31 02:03:13',56292.0855700001,19.2616,0.1337,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_91507.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(9319,8228,0,'LSQ12hon','LSQ',57.8935,-24.2263888888889,NULL,NULL,'2012-12-31 04:02:21',56292.1683100001,19.5872,0.1817,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_91508.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(9320,8233,0,'LSQ12hnu','LSQ',56.4025833333333,-37.7380277777778,NULL,NULL,'2012-12-31 01:56:21',56292.0808100002,19.9026,0.1187,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_91558.gif',38557895447,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(9321,8233,0,'LSQ12hnu','LSQ',56.4025833333333,-37.7380277777778,NULL,NULL,'2012-12-31 03:55:30',56292.1635500002,19.6734,0.093,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_91559.gif',38557895447,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(9322,8576,0,'LSQ12hse','LSQ',180.093416666667,-21.8910555555556,NULL,NULL,'2012-12-31 05:46:40',56292.2407499999,19.1426,0.1926,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_snap_91652.gif',43016918031,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,672139344,10502177,NULL,NULL,NULL,NULL),(9323,8686,0,'LSQ12hvj','LSQ',166.910916666667,-29.7113888888889,NULL,NULL,'2012-12-31 05:15:13',56292.2189099998,17.7137,0.0498,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_91766.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(9324,8949,0,'LSQ12hyd','LSQ',174.637833333333,-24.2079722222222,NULL,NULL,'2012-12-31 05:32:28',56292.2308899998,19.096,0.1151,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_snap_91631.gif',41410841875,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647044404,10110068,NULL,NULL,NULL,NULL),(9325,8959,0,'LSQ12hxx','LSQ',49.9342916666667,-27.0071388888889,NULL,NULL,'2012-12-31 01:41:08',56292.0702399998,17.4375,0.0238,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2013-01-01 08:16:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_91667.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(9326,8959,0,'LSQ12hxx','LSQ',49.9342916666667,-27.0070833333333,NULL,NULL,'2012-12-31 03:41:59',56292.1541599999,17.2969,0.0305,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2013-01-01 08:16:21','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_91668.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(9327,8966,0,'LSQ12hxt','LSQ',56.841375,-31.2003888888889,NULL,NULL,'2012-12-31 01:59:45',56292.0831599999,18.758,0.0883,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2013-01-03 17:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_91627.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(9328,8966,0,'LSQ12hxt','LSQ',56.8413333333333,-31.2003888888889,NULL,NULL,'2012-12-31 03:58:53',56292.1658999999,18.7078,0.1156,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2013-01-03 17:16:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_91628.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(9329,8974,0,'LSQ12hxp','LSQ',67.4704166666667,-35.1993333333333,NULL,NULL,'2012-12-31 02:23:35',56292.0997199998,19.7949,0.1541,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_91629.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(9330,9017,0,'LSQ12hxu','LSQ',63.4705,-31.3776111111111,NULL,NULL,'2012-12-31 04:14:24',56292.17667,20.0376,0.1836,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2012-12-31 13:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxu/LSQ12hxu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxu/LSQ12hxu_snap_91630.gif',37709822855,NULL,NULL,NULL,'2012-12-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589215982,9206499,NULL,NULL,NULL,NULL),(9331,9251,0,'LSQ12hzu','LSQ',76.9711666666667,-20.9748611111111,NULL,NULL,'2012-12-31 03:02:49',56292.12696,18.362,0.0647,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2013-01-02 09:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_91762.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(9332,9251,0,'LSQ12hzu','LSQ',76.97125,-20.9748333333333,NULL,NULL,'2012-12-31 05:02:07',56292.2098099999,18.1213,0.0625,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2013-01-02 09:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_91763.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(9333,9257,0,'LSQ12hzs','LSQ',60.4715833333333,-26.6639722222222,NULL,NULL,'2012-12-31 02:06:35',56292.0879099998,18.6319,0.0557,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2013-01-02 09:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_history.html','sn nice',NULL,0.07213,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_snap_91728.gif',38534445066,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602100704,9407823,NULL,NULL,NULL,NULL),(9334,9257,0,'LSQ12hzs','LSQ',60.471625,-26.6639444444444,NULL,NULL,'2012-12-31 04:05:55',56292.1707799998,18.2791,0.0545,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 13:46:18','2013-01-02 09:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_history.html','sn nice',NULL,0.07213,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_snap_91729.gif',38534445066,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602100704,9407823,NULL,NULL,NULL,NULL),(9336,9336,1,'LSQ12iaw','LSQ',171.461625,-23.2733611111111,NULL,NULL,'2012-12-25 05:37:25',56286.2343199998,19.1057,0.1591,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iaw/LSQ12iaw_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iaw/LSQ12iaw_snap_92042.gif',41714741892,NULL,NULL,NULL,'2012-12-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,651792842,10184263,NULL,NULL,NULL,NULL),(9337,9336,0,'LSQ12iaw','LSQ',171.461708333333,-23.2734166666667,NULL,NULL,'2012-12-31 05:29:05',56292.22854,19.0063,0.1422,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2012-12-31 18:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iaw/LSQ12iaw_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iaw/LSQ12iaw_snap_92025.gif',41714741892,NULL,NULL,NULL,'2012-12-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,651792842,10184263,NULL,NULL,NULL,NULL),(9338,9336,0,'LSQ12iaw','LSQ',171.461791666667,-23.2734166666667,NULL,NULL,'2012-12-31 07:20:08',56292.30565,18.782,0.13,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2012-12-31 18:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iaw/LSQ12iaw_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iaw/LSQ12iaw_snap_92026.gif',41714741892,NULL,NULL,NULL,'2012-12-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,651792842,10184263,NULL,NULL,NULL,NULL),(9339,9339,1,'LSQ12iav','LSQ',163.735333333333,-20.9999444444444,NULL,NULL,'2012-12-12 06:05:24',56273.2537500001,19.0673,0.2124,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iav/LSQ12iav_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iav/LSQ12iav_snap_92038.gif',41638967397,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,650608865,10165763,NULL,NULL,NULL,NULL),(9340,9339,0,'LSQ12iav','LSQ',163.735208333333,-20.9999722222222,NULL,NULL,'2012-12-18 06:03:55',56279.2527299998,16.2586,0.0956,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2012-12-31 18:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iav/LSQ12iav_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iav/LSQ12iav_snap_92039.gif',41638967397,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,650608865,10165763,NULL,NULL,NULL,NULL),(9341,9339,0,'LSQ12iav','LSQ',163.735333333333,-20.9998888888889,NULL,NULL,'2012-12-25 05:19:53',56286.2221499998,15.4109,0.0901,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2012-12-31 18:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iav/LSQ12iav_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iav/LSQ12iav_snap_92040.gif',41638967397,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,650608865,10165763,NULL,NULL,NULL,NULL),(9342,9339,0,'LSQ12iav','LSQ',163.735458333333,-21,NULL,NULL,'2012-12-29 07:49:59',56290.32638,17.0182,0.1153,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2012-12-31 18:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iav/LSQ12iav_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iav/LSQ12iav_snap_92041.gif',41638967397,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,650608865,10165763,NULL,NULL,NULL,NULL),(9343,9339,0,'LSQ12iav','LSQ',163.735375,-20.9999722222222,NULL,NULL,'2012-12-31 05:16:54',56292.2200799999,15.8744,0.1022,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2012-12-31 18:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iav/LSQ12iav_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iav/LSQ12iav_snap_92023.gif',41638967397,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,650608865,10165763,NULL,NULL,NULL,NULL),(9344,9339,0,'LSQ12iav','LSQ',163.735416666667,-20.9999444444444,NULL,NULL,'2012-12-31 07:50:45',56292.3269099998,16.7807,0.0983,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2012-12-31 18:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iav/LSQ12iav_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iav/LSQ12iav_snap_92024.gif',41638967397,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,650608865,10165763,NULL,NULL,NULL,NULL),(9345,9345,1,'LSQ12iao','LSQ',52.878625,-21.19525,NULL,NULL,'2012-12-23 03:45:26',56284.15656,18.1446,0.0728,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iao/LSQ12iao_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iao/LSQ12iao_snap_92049.gif',38049649326,NULL,NULL,NULL,'2012-12-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,594525770,9289465,NULL,NULL,NULL,NULL),(9346,9345,0,'LSQ12iao','LSQ',52.8785833333333,-21.1948055555556,NULL,NULL,'2012-12-31 01:49:36',56292.0761199999,18.7681,0.0939,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2012-12-31 18:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iao/LSQ12iao_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iao/LSQ12iao_snap_92009.gif',38049649327,NULL,NULL,NULL,'2012-12-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,594525770,9289465,NULL,NULL,NULL,NULL),(9347,9345,0,'LSQ12iao','LSQ',52.878875,-21.1946944444444,NULL,NULL,'2012-12-31 03:48:46',56292.1588699999,19.2764,0.1404,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2012-12-31 18:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iao/LSQ12iao_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iao/LSQ12iao_snap_92010.gif',38049649327,NULL,NULL,NULL,'2012-12-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,594525770,9289465,NULL,NULL,NULL,NULL),(9348,9348,1,'LSQ12iak','LSQ',170.613041666667,-26.7129166666667,NULL,NULL,'2012-12-20 07:15:05',56281.3021499999,19.2894,0.1423,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_snap_91997.gif',41429437529,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,647334961,10114608,NULL,NULL,NULL,NULL),(9349,9348,0,'LSQ12iak','LSQ',170.613208333333,-26.7129722222222,NULL,NULL,'2012-12-22 05:39:32',56283.2357899998,19.5623,0.1733,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2012-12-31 18:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_snap_91998.gif',41429437529,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,647334961,10114608,NULL,NULL,NULL,NULL),(9350,9348,0,'LSQ12iak','LSQ',170.613041666667,-26.7130277777778,NULL,NULL,'2012-12-31 05:15:13',56292.2189099998,18.6758,0.1377,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2012-12-31 18:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_snap_91895.gif',41429437529,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,647334961,10114608,NULL,NULL,NULL,NULL),(9351,9348,0,'LSQ12iak','LSQ',170.613083333333,-26.7129722222222,NULL,NULL,'2012-12-31 07:01:10',56292.2924799998,19.1124,0.1538,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2012-12-31 18:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_snap_91896.gif',41429437529,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,647334961,10114608,NULL,NULL,NULL,NULL),(9352,9352,1,'LSQ12iae','LSQ',63.302625,-30.7499166666667,NULL,NULL,'2012-12-31 02:15:06',56292.0938300001,19.6643,0.1104,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_snap_91883.gif',37654344365,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588349130,9192955,NULL,NULL,NULL,NULL),(9353,9352,0,'LSQ12iae','LSQ',63.3027083333333,-30.7498611111111,NULL,NULL,'2012-12-31 04:14:24',56292.17667,19.8579,0.1243,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2012-12-31 18:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_snap_91884.gif',37654344365,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588349130,9192955,NULL,NULL,NULL,NULL),(9354,9354,1,'LSQ12iaa','LSQ',64.26075,-36.9849166666667,NULL,NULL,'2012-12-31 02:21:52',56292.0985300001,17.8174,0.0845,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iaa/LSQ12iaa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iaa/LSQ12iaa_snap_91875.gif',37669407034,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588584484,9196632,NULL,NULL,NULL,NULL),(9355,9354,0,'LSQ12iaa','LSQ',64.260375,-36.9848055555556,NULL,NULL,'2012-12-31 04:21:12',56292.1814000001,17.6408,0.0864,'gr-LSQ',NULL,NULL,NULL,NULL,'2012-12-31 18:46:19','2012-12-31 18:46:19','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iaa/LSQ12iaa_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iaa/LSQ12iaa_snap_91876.gif',37669406981,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588584484,9196632,NULL,NULL,NULL,NULL),(9356,8959,0,'LSQ12hxx','atel',49.9342916667,-27.0071388889,NULL,NULL,'2012-12-30 00:00:00',56291,NULL,NULL,NULL,0.06941,NULL,'Ia',NULL,'2013-01-01 08:16:06','2013-01-01 08:16:21','http://www.astronomerstelegram.org/?read=4691',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38551558325,'UoH 2.2-m','SNIFS','Hadjiyska','2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(9357,9251,0,'LSQ12hzu','atel',76.9717083333,-20.9746666667,NULL,NULL,'2012-12-29 12:00:00',56290.5,NULL,NULL,NULL,0.03,NULL,'IIP',NULL,'2013-01-02 09:08:56','2013-01-02 09:16:40','http://www.astronomerstelegram.org/?read=4693',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,37548507155,'UH2.2','SNIFS','NSFII','2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(9358,9257,0,'LSQ12hzs','atel',60.4718333333,-26.6638611111,NULL,NULL,'2012-12-29 12:00:00',56290.5,NULL,NULL,NULL,0.07,NULL,'Ia',NULL,'2013-01-02 09:10:52','2013-01-02 09:16:40','http://www.astronomerstelegram.org/?read=4692',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38534445066,'NOT','ALFOSC','Hadjiyska','2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602100704,9407823,NULL,NULL,NULL,NULL),(9359,8895,0,'LSQ12hxg','pessto',62.9475416667,-5.91894444444,NULL,NULL,'2013-01-01 00:00:00',56293,NULL,NULL,NULL,0.039,NULL,'IIn',NULL,'2013-01-02 14:58:11','2013-01-02 15:16:15','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,36962123763,'NTT','EFOSC2','G Leloudas','2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(9360,9124,1,'OGLE-2012-SN-050','pessto',88.1431666667,-65.4499166667,NULL,NULL,'2013-01-02 06:00:00',56294.25,NULL,NULL,NULL,0.082,NULL,'IIn',NULL,'2013-01-02 18:13:54','2019-10-11 14:10:04','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35837612148,'NTT','EFOSC','Mattias Ergon and Giorgos Leloudas','2012-08-12 10:04:05',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,559962689,8749417,NULL,NULL,NULL,NULL),(9361,8833,1,'OGLE-2012-SN-049','pessto',9.450375,-70.74625,NULL,NULL,'2013-01-02 00:57:36',56294.04,NULL,NULL,NULL,0.07,NULL,'Ia',NULL,'2013-01-02 18:20:01','2019-10-11 14:10:04','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35578112518,'NTT','EFOSC','Mattias Ergon and Giorgos Leloudas','2012-07-25 10:42:59',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,555908008,8686062,NULL,NULL,NULL,NULL),(9362,8763,1,'OGLE-2012-SN-048','pessto',20.8092916667,-72.3318611111,NULL,NULL,'2013-01-02 01:40:47',56294.07,NULL,NULL,NULL,0.067,NULL,'IIn',NULL,'2013-01-02 18:21:23','2019-10-11 14:10:04','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35605628757,'NTT','EFOSC','Mattias Ergon and Giorgos Leloudas','2012-06-06 09:42:38',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,556337949,8692780,NULL,NULL,NULL,NULL),(9363,8208,0,'LSQ12hno','atel',55.67975,-2.66913888889,NULL,NULL,'2012-12-13 00:00:00',56274,NULL,NULL,NULL,0.05,NULL,'Ia',NULL,'2013-01-03 12:50:16','2013-01-03 13:16:13','http://www.astronomerstelegram.org/?read=4670',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,36811538950,'Dupont','WFCCCD','Yale','2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(9364,8246,0,'LSQ12hnx','pessto',38.82425,-30.9638055556,NULL,NULL,'2012-12-13 00:00:00',56274,NULL,NULL,NULL,0.16,NULL,'Ia',NULL,'2013-01-03 14:46:44','2013-01-03 15:16:11','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38436918154,'duPont','WFCCD','CSP','2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,600576846,9384013,NULL,NULL,NULL,NULL),(9365,974169,1,'OGLE-2012-SN-051','pessto',76.0279583333,-63.5825,NULL,NULL,'2013-01-03 04:48:00',56295.2,NULL,NULL,NULL,0.11,NULL,'Ia',NULL,'2013-01-03 17:00:06','2019-10-11 14:10:04','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35875127130,'NTT','EFOSC2','Giorgos','2012-12-10 07:34:25',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,560548861,8758575,NULL,NULL,NULL,NULL),(9366,8877,0,'LSQ12hxn','pessto',141.167333333,22.4341666667,NULL,NULL,'2013-01-03 07:11:59',56295.3,NULL,NULL,NULL,0.078,NULL,'Ia',NULL,'2013-01-03 17:04:55','2013-01-03 17:16:11','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,63715766096,'NTT','EFOSC2','Giorgos','2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,995558845,15555606,NULL,NULL,NULL,NULL),(9367,8966,0,'LSQ12hxt','pessto',56.8417083333,-31.2004166667,NULL,NULL,'2013-01-03 04:48:00',56295.2,NULL,NULL,NULL,0.12,NULL,'Ia',NULL,'2013-01-03 17:06:07','2013-01-03 17:16:11','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,38578234482,'NTT','EFOSC2','Giorgos','2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(9368,9180,0,'LSQ12hzo','pessto',136.200125,18.6495555556,NULL,NULL,'2013-01-03 04:48:00',56295.2,NULL,NULL,NULL,0.111,NULL,'unknown',NULL,'2013-01-03 17:08:21','2013-01-03 17:16:11','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,63876968330,'NTT','EFOSC2','Giorgos','2012-04-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,998077630,15594962,NULL,NULL,NULL,NULL),(9369,8270,0,'LSQ12hot','pessto',49.4064583333,0.815972222222,NULL,NULL,'2013-01-03 02:24:00',56295.1,NULL,NULL,NULL,0.0234,NULL,'IIn',NULL,'2013-01-03 18:09:34','2013-01-03 18:16:11','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,64969723196,'NTT','EFOSC2','Giorgos','2012-12-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1015151924,15861748,NULL,NULL,NULL,NULL),(9370,7507,0,'LSQ12hgj','LSQ',154.207083333333,-16.1957777777778,NULL,NULL,'2013-01-03 04:04:54',56295.1700800001,19.5592,0.1488,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-03 20:46:14','2013-01-03 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_snap_92186.gif',41166665804,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643229153,10050455,NULL,NULL,NULL,NULL),(9371,7507,0,'LSQ12hgj','LSQ',154.207166666667,-16.1958333333333,NULL,NULL,'2013-01-03 06:06:02',56295.2541999999,19.6778,0.1544,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-03 20:46:14','2013-01-03 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hgj/LSQ12hgj_snap_92187.gif',41166665804,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643229153,10050455,NULL,NULL,NULL,NULL),(9372,7894,0,'LSQ12hlz','LSQ',74.40725,-15.3167222222222,NULL,NULL,'2013-01-03 02:46:11',56295.1154100001,20.2264,0.1184,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-03 20:46:14','2013-01-03 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_92184.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(9373,7894,0,'LSQ12hlz','LSQ',74.407375,-15.31675,NULL,NULL,'2013-01-03 04:49:58',56295.2013699999,19.8852,0.1177,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-03 20:46:14','2013-01-03 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_92185.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(9374,7937,0,'LSQ12hmb','LSQ',151.3675,-13.1325833333333,NULL,NULL,'2013-01-03 05:48:23',56295.2419400001,20.4088,0.1931,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-03 20:46:14','2013-01-03 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_snap_92183.gif',41162875503,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643169929,10049530,NULL,NULL,NULL,NULL),(9375,8875,0,'LSQ12hxo','LSQ',141.212583333333,21.6440833333333,NULL,NULL,'2013-01-03 06:49:18',56295.2842399999,19.8055,0.1356,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-03 20:46:14','2013-01-03 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxo/LSQ12hxo_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxo/LSQ12hxo_snap_92121.gif',63708583584,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,995446618,15553853,NULL,NULL,NULL,NULL),(9376,8895,0,'LSQ12hxg','LSQ',62.947625,-5.91902777777778,NULL,NULL,'2013-01-03 03:35:42',56295.1497999998,18.09,0.0385,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-03 20:46:14','2013-01-03 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_92123.gif',36962123763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(9377,8895,0,'LSQ12hxg','LSQ',62.9476666666667,-5.91905555555556,NULL,NULL,'2013-01-03 04:48:17',56295.2001999998,18.0856,0.0542,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-03 20:46:14','2013-01-03 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_92124.gif',36962123763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(9378,9035,0,'LSQ12hyv','LSQ',63.71275,-16.2175277777778,NULL,NULL,'2013-01-03 03:18:18',56295.1377099999,18.3691,0.0723,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-03 20:46:14','2013-01-03 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_snap_92137.gif',36871504834,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576117263,9001832,NULL,NULL,NULL,NULL),(9379,9049,0,'LSQ12hyr','LSQ',64.062875,-10.9515,NULL,NULL,'2013-01-03 03:11:32',56295.13301,18.8631,0.0502,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-03 20:46:14','2013-01-03 20:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_history.html','sn',NULL,0.045375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_snap_92136.gif',36980827675,NULL,NULL,NULL,'2012-10-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577825432,9028522,NULL,NULL,NULL,NULL),(9380,9183,0,'LSQ12hzj','LSQ',149.80175,-9.00230555555556,NULL,NULL,'2013-01-03 03:59:50',56295.1665599998,16.9924,0.0193,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-03 20:46:14','2013-01-05 16:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_snap_92165.gif',41335019974,NULL,NULL,NULL,'2012-12-05 05:54:14',56266.246,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645859687,10091557,NULL,NULL,NULL,NULL),(9381,9183,0,'LSQ12hzj','LSQ',149.801833333333,-9.00225,NULL,NULL,'2013-01-03 06:00:58',56295.2506800001,16.9509,0.0166,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-03 20:46:14','2013-01-05 16:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_snap_92166.gif',41335019974,NULL,NULL,NULL,'2012-12-05 05:54:14',56266.246,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645859687,10091557,NULL,NULL,NULL,NULL),(9382,9382,1,'LSQ13d','LSQ',185.299625,-17.9326111111111,NULL,NULL,'2012-12-28 06:28:01',56289.2694600001,18.1654,0.0979,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 00:46:08','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13d/LSQ13d_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13d/LSQ13d_snap_92347.gif',43897988004,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,685906062,10717282,NULL,NULL,NULL,NULL),(9383,9382,0,'LSQ13d','LSQ',185.299666666667,-17.9326111111111,NULL,NULL,'2012-12-28 07:36:34',56289.3170699999,18.2571,0.0714,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 00:46:08','2013-01-05 12:16:53','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13d/LSQ13d_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13d/LSQ13d_snap_92348.gif',43897988004,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,685906062,10717282,NULL,NULL,NULL,NULL),(9384,9382,0,'LSQ13d','LSQ',185.299625,-17.9326666666667,NULL,NULL,'2013-01-03 06:15:32',56295.2607900002,18.0315,0.0791,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 00:46:08','2013-01-05 12:16:53','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13d/LSQ13d_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13d/LSQ13d_snap_92298.gif',43897988004,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,685906062,10717282,NULL,NULL,NULL,NULL),(9385,9382,0,'LSQ13d','LSQ',185.299666666667,-17.9325833333333,NULL,NULL,'2013-01-03 07:34:21',56295.3155299998,18.0419,0.0834,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 00:46:08','2013-01-05 12:16:53','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13d/LSQ13d_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13d/LSQ13d_snap_92299.gif',43897988004,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,685906062,10717282,NULL,NULL,NULL,NULL),(9386,9386,1,'LSQ13b','LSQ',170.889583333333,-20.3370555555556,NULL,NULL,'2012-12-24 08:19:52',56285.3471400002,20.8132,0.1944,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 00:46:08','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_snap_92343.gif',41739726553,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,652183227,10190362,NULL,NULL,NULL,NULL),(9387,9386,0,'LSQ13b','LSQ',170.889791666667,-20.3368888888889,NULL,NULL,'2013-01-03 05:05:07',56295.2118899999,18.1057,0.0903,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 00:46:08','2013-01-05 16:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_snap_92294.gif',41739726486,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,652183226,10190362,NULL,NULL,NULL,NULL),(9388,9386,0,'LSQ13b','LSQ',170.889666666667,-20.3369166666667,NULL,NULL,'2013-01-03 06:57:22',56295.2898400002,18.0232,0.0677,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 00:46:08','2013-01-05 16:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_snap_92295.gif',41739726486,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,652183226,10190362,NULL,NULL,NULL,NULL),(9389,9389,1,'LSQ13l','LSQ',155.694583333333,-7.48625,NULL,NULL,'2013-01-03 05:18:41',56295.2213099999,19.1461,0.1631,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 01:46:09','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_snap_92314.gif',41246135636,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644470869,10069857,NULL,NULL,NULL,NULL),(9390,9389,0,'LSQ13l','LSQ',155.694666666667,-7.48616666666667,NULL,NULL,'2013-01-03 07:04:15',56295.2946199998,18.5591,0.1204,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 01:46:09','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_snap_92315.gif',41246135636,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644470869,10069857,NULL,NULL,NULL,NULL),(9391,9391,1,'LSQ13i','LSQ',178.340791666667,-16.1571666666667,NULL,NULL,'2012-12-24 06:21:40',56285.26505,18.7172,0.1102,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 01:46:09','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13i/LSQ13i_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13i/LSQ13i_snap_92320.gif',40999072603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640610509,10009539,NULL,NULL,NULL,NULL),(9392,9391,0,'LSQ13i','LSQ',178.340791666667,-16.1571111111111,NULL,NULL,'2012-12-24 07:31:28',56285.3135199999,19.9816,0.0839,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 01:46:09','2013-01-05 12:16:53','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13i/LSQ13i_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13i/LSQ13i_snap_92321.gif',40999072603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640610509,10009539,NULL,NULL,NULL,NULL),(9393,9391,0,'LSQ13i','LSQ',178.340791666667,-16.1571666666667,NULL,NULL,'2012-12-28 06:08:28',56289.2558800001,18.954,0.1259,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 01:46:09','2013-01-05 12:16:53','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13i/LSQ13i_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13i/LSQ13i_snap_92322.gif',40999072603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640610509,10009539,NULL,NULL,NULL,NULL),(9394,9391,0,'LSQ13i','LSQ',178.340791666667,-16.1571388888889,NULL,NULL,'2012-12-28 08:11:55',56289.3416200001,19.989,0.1397,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 01:46:09','2013-01-05 12:16:53','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13i/LSQ13i_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13i/LSQ13i_snap_92323.gif',40999072603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640610509,10009539,NULL,NULL,NULL,NULL),(9395,9391,0,'LSQ13i','LSQ',178.340833333333,-16.1571388888889,NULL,NULL,'2013-01-03 05:44:46',56295.2394300001,18.793,0.1272,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 01:46:09','2013-01-05 12:16:53','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13i/LSQ13i_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13i/LSQ13i_snap_92308.gif',40999072603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640610509,10009539,NULL,NULL,NULL,NULL),(9396,9391,0,'LSQ13i','LSQ',178.340791666667,-16.1571388888889,NULL,NULL,'2013-01-03 07:16:56',56295.3034299999,18.6988,0.1109,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 01:46:09','2013-01-05 12:16:53','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13i/LSQ13i_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13i/LSQ13i_snap_92309.gif',40999072603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640610509,10009539,NULL,NULL,NULL,NULL),(9397,9397,1,'LSQ13h','LSQ',70.6753333333333,-14.6319166666667,NULL,NULL,'2013-01-03 02:41:05',56295.1118700001,20.5179,0.11,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 01:46:09','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_snap_92306.gif',37544086754,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586626355,9166036,NULL,NULL,NULL,NULL),(9398,9397,0,'LSQ13h','LSQ',70.67525,-14.6319166666667,NULL,NULL,'2013-01-03 04:43:07',56295.19661,19.8937,0.1486,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 01:46:09','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_snap_92307.gif',37544086545,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586626352,9166036,NULL,NULL,NULL,NULL),(9399,9399,1,'LSQ13g','LSQ',194.928708333333,-19.7049722222222,NULL,NULL,'2013-01-03 06:40:08',56295.27788,18.1084,0.0543,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 01:46:09','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13g/LSQ13g_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13g/LSQ13g_snap_92304.gif',43989620374,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,687337818,10739653,NULL,NULL,NULL,NULL),(9400,9399,0,'LSQ13g','LSQ',194.928791666667,-19.7049444444444,NULL,NULL,'2013-01-03 07:57:20',56295.3314899998,18.0955,0.0559,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 01:46:09','2013-01-09 16:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13g/LSQ13g_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13g/LSQ13g_snap_92305.gif',43989620374,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,687337818,10739653,NULL,NULL,NULL,NULL),(9445,7613,0,'LSQ12hje','LSQ',77.17075,-20.9644444444444,NULL,NULL,'2013-01-04 02:51:57',56296.1194199999,19.8894,0.1012,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hje/LSQ12hje_snap_92652.gif',37415313422,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,584614272,9134598,NULL,NULL,NULL,NULL),(9446,7751,0,'LSQ12hle','LSQ',61.1044583333333,-29.1577777777778,NULL,NULL,'2013-01-04 01:55:57',56296.0805299999,20.4945,0.1118,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_snap_92523.gif',38530541650,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602039713,9406870,NULL,NULL,NULL,NULL),(9447,7751,0,'LSQ12hle','LSQ',61.1044166666667,-29.1576666666667,NULL,NULL,'2013-01-04 03:55:16',56296.1633799998,19.8601,0.0923,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_snap_92524.gif',38530541650,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602039713,9406870,NULL,NULL,NULL,NULL),(9448,7756,0,'LSQ12hlv','LSQ',76.9715416666667,-21.24625,NULL,NULL,'2013-01-04 05:02:30',56296.21007,18.9709,0.1093,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlv/LSQ12hlv_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlv/LSQ12hlv_snap_92388.gif',37548641524,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586697523,9167148,NULL,NULL,NULL,NULL),(9449,8046,0,'LSQ12hnj','LSQ',78.1033333333333,-25.7825277777778,NULL,NULL,'2013-01-04 02:48:33',56296.11705,16.1449,0.0062,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_92571.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(9450,8046,0,'LSQ12hnj','LSQ',78.1027083333333,-25.7826111111111,NULL,NULL,'2013-01-04 02:50:15',56296.1182300001,16.4922,0.0072,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_92573.gif',37249489805,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(9451,8046,0,'LSQ12hnj','LSQ',78.103375,-25.7825277777778,NULL,NULL,'2013-01-04 04:59:07',56296.2077199998,16.2748,0.0083,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_92572.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(9452,8046,0,'LSQ12hnj','LSQ',78.1027083333333,-25.7825833333333,NULL,NULL,'2013-01-04 05:00:48',56296.2088899999,16.5499,0.0096,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_92574.gif',37249489805,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(9453,8228,0,'LSQ12hon','LSQ',57.8934166666667,-24.2264166666667,NULL,NULL,'2013-01-04 01:52:33',56296.0781700001,19.7606,0.1293,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_92647.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(9454,8228,0,'LSQ12hon','LSQ',57.893375,-24.2263611111111,NULL,NULL,'2013-01-04 03:51:53',56296.1610400002,19.6761,0.1208,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_92648.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(9455,8233,0,'LSQ12hnu','LSQ',56.4026666666667,-37.7380833333333,NULL,NULL,'2013-01-04 01:45:48',56296.0734799998,20.2372,0.1114,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_92404.gif',38557895447,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(9456,8233,0,'LSQ12hnu','LSQ',56.402625,-37.7380555555556,NULL,NULL,'2013-01-04 03:45:06',56296.1563300001,20.129,0.0883,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_92405.gif',38557895447,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(9457,8408,0,'LSQ12hqa','LSQ',160.241166666667,-21.7817777777778,NULL,NULL,'2013-01-04 07:04:30',56296.2947999998,19.6043,0.2009,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_snap_92461.gif',41668171452,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,651065178,10172893,NULL,NULL,NULL,NULL),(9458,8686,0,'LSQ12hvj','LSQ',166.910833333333,-29.7114444444444,NULL,NULL,'2013-01-04 05:15:45',56296.2192799998,17.2885,0.0577,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_92621.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(9459,8686,0,'LSQ12hvj','LSQ',166.910916666667,-29.7113333333333,NULL,NULL,'2013-01-04 07:02:48',56296.2936200001,17.2087,0.0558,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_92622.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(9460,8949,0,'LSQ12hyd','LSQ',174.637833333333,-24.2079722222222,NULL,NULL,'2013-01-04 05:34:22',56296.2322,19.1186,0.1243,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_snap_92487.gif',41410841875,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647044404,10110068,NULL,NULL,NULL,NULL),(9461,8949,0,'LSQ12hyd','LSQ',174.637791666667,-24.2081111111111,NULL,NULL,'2013-01-04 07:11:15',56296.2994900001,19.6659,0.1963,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_snap_92488.gif',41410841874,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647044404,10110068,NULL,NULL,NULL,NULL),(9462,8959,0,'LSQ12hxx','LSQ',49.9342916666667,-27.0071111111111,NULL,NULL,'2013-01-04 03:04:07',56296.12787,17.4976,0.016,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_92512.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(9463,8959,0,'LSQ12hxx','LSQ',49.9342916666667,-27.0071388888889,NULL,NULL,'2013-01-04 03:07:30',56296.1302100001,17.539,0.0182,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_92513.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(9464,8966,0,'LSQ12hxt','LSQ',56.8413333333333,-31.2003888888889,NULL,NULL,'2013-01-04 01:49:11',56296.07583,19.1353,0.0832,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_92484.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(9465,8966,0,'LSQ12hxt','LSQ',56.8413333333333,-31.2003888888889,NULL,NULL,'2013-01-04 03:48:29',56296.1586799999,19.1007,0.073,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_92485.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(9466,8974,0,'LSQ12hxp','LSQ',67.4700833333333,-35.1994444444444,NULL,NULL,'2013-01-04 02:12:54',56296.0923000001,20.8507,0.1297,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_92486.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(9467,9251,0,'LSQ12hzu','LSQ',76.9712083333333,-20.9748333333333,NULL,NULL,'2013-01-04 02:51:57',56296.1194199999,18.7202,0.0547,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_92611.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(9468,9251,0,'LSQ12hzu','LSQ',76.9712083333333,-20.9748333333333,NULL,NULL,'2013-01-04 05:02:30',56296.21007,18.6034,0.0657,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_92612.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(9469,9257,0,'LSQ12hzs','LSQ',60.4715833333333,-26.6639722222222,NULL,NULL,'2013-01-04 01:55:57',56296.0805299999,18.5688,0.0271,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_history.html','sn nice',NULL,0.07213,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_snap_92599.gif',38534445066,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602100704,9407823,NULL,NULL,NULL,NULL),(9470,9257,0,'LSQ12hzs','LSQ',60.471625,-26.6639444444444,NULL,NULL,'2013-01-04 03:55:16',56296.1633799998,18.5998,0.0363,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_history.html','sn nice',NULL,0.07213,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_snap_92600.gif',38534445066,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602100704,9407823,NULL,NULL,NULL,NULL),(9471,9348,0,'LSQ12iak','LSQ',170.613,-26.7128888888889,NULL,NULL,'2013-01-04 05:15:45',56296.2192799998,19.7818,0.2101,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_snap_92693.gif',41429437529,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,647334961,10114608,NULL,NULL,NULL,NULL),(9472,9348,0,'LSQ12iak','LSQ',170.613166666667,-26.7129722222222,NULL,NULL,'2013-01-04 07:02:48',56296.2936200001,18.8756,0.1397,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_snap_92694.gif',41429437529,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,647334961,10114608,NULL,NULL,NULL,NULL),(9473,9352,0,'LSQ12iae','LSQ',63.302625,-30.7499444444444,NULL,NULL,'2013-01-04 02:04:28',56296.0864400002,19.0489,0.0559,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_snap_92697.gif',37654344365,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588349130,9192955,NULL,NULL,NULL,NULL),(9474,9352,0,'LSQ12iae','LSQ',63.3026666666667,-30.7499166666667,NULL,NULL,'2013-01-04 04:03:44',56296.16927,18.9714,0.0501,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 14:46:13','2013-01-04 14:46:13','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_snap_92698.gif',37654344365,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588349130,9192955,NULL,NULL,NULL,NULL),(9475,9475,1,'LSQ13ac','LSQ',193.608333333333,-24.5701111111111,NULL,NULL,'2013-01-04 06:26:02',56296.2680899999,17.0023,0.032,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ac/LSQ13ac_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ac/LSQ13ac_snap_92811.gif',43302938005,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,676608406,10572006,NULL,NULL,NULL,NULL),(9476,9475,0,'LSQ13ac','LSQ',193.608333333333,-24.5701666666667,NULL,NULL,'2013-01-04 07:50:09',56296.3265,17.3243,0.0341,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ac/LSQ13ac_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ac/LSQ13ac_snap_92812.gif',43302938005,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,676608406,10572006,NULL,NULL,NULL,NULL),(9477,9477,1,'LSQ13ab','LSQ',168.103916666667,-21.9608888888889,NULL,NULL,'2012-12-18 06:07:18',56279.25508,19.0607,0.0604,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_92854.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(9478,9477,0,'LSQ13ab','LSQ',168.10375,-21.9608055555556,NULL,NULL,'2012-12-20 07:11:26',56281.2996100001,19.2532,0.0664,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_92855.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(9479,9477,0,'LSQ13ab','LSQ',168.10375,-21.9608333333333,NULL,NULL,'2012-12-23 05:26:17',56284.2265900001,19.0141,0.134,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_92856.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(9480,9477,0,'LSQ13ab','LSQ',168.103875,-21.9608611111111,NULL,NULL,'2012-12-23 07:03:07',56284.2938399999,18.0774,0.0188,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_92857.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(9481,9477,0,'LSQ13ab','LSQ',168.103833333333,-21.9609722222222,NULL,NULL,'2012-12-25 05:23:15',56286.2244899999,19.0345,0.1002,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_92858.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(9482,9477,0,'LSQ13ab','LSQ',168.103791666667,-21.9608888888889,NULL,NULL,'2012-12-25 07:15:53',56286.3026999999,18.1126,0.0358,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_92859.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(9483,9477,0,'LSQ13ab','LSQ',168.104166666667,-21.9610277777778,NULL,NULL,'2012-12-29 07:27:33',56290.3108000001,16.1312,0.01,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_92860.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(9484,9477,0,'LSQ13ab','LSQ',168.104083333333,-21.961,NULL,NULL,'2012-12-31 07:04:55',56292.2950900001,16.2064,0.0099,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_92861.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(9485,9477,0,'LSQ13ab','LSQ',168.103875,-21.9609722222222,NULL,NULL,'2013-01-04 05:27:36',56296.2275,17.3961,0.0353,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_92809.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(9486,9477,0,'LSQ13ab','LSQ',168.104083333333,-21.9609722222222,NULL,NULL,'2013-01-04 07:07:53',56296.29715,16.4773,0.0165,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_92810.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(9487,9487,1,'LSQ13aa','LSQ',68.8430416666667,-23.6361944444444,NULL,NULL,'2012-12-31 02:37:15',56292.1092099999,19.6985,0.1736,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_snap_92852.gif',37317539555,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583086555,9110727,NULL,NULL,NULL,NULL),(9488,9487,0,'LSQ13aa','LSQ',68.8429583333333,-23.6363055555556,NULL,NULL,'2012-12-31 04:36:31',56292.19203,19.1675,0.123,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_snap_92853.gif',37317539553,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583086555,9110727,NULL,NULL,NULL,NULL),(9489,9487,0,'LSQ13aa','LSQ',68.8429583333333,-23.6362222222222,NULL,NULL,'2013-01-04 02:26:26',56296.1017,19.4595,0.096,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_snap_92807.gif',37317539555,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583086555,9110727,NULL,NULL,NULL,NULL),(9490,9487,0,'LSQ13aa','LSQ',68.8429166666667,-23.63625,NULL,NULL,'2013-01-04 04:36:53',56296.1922900002,19.1905,0.0839,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_snap_92808.gif',37317539553,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583086555,9110727,NULL,NULL,NULL,NULL),(9491,9491,1,'LSQ13y','LSQ',175.837541666667,-29.1764444444444,NULL,NULL,'2012-12-29 07:15:40',56290.3025500001,19.744,0.125,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13y/LSQ13y_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13y/LSQ13y_snap_92844.gif',41451037042,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647672453,10119882,NULL,NULL,NULL,NULL),(9492,9491,0,'LSQ13y','LSQ',175.837375,-29.1765833333333,NULL,NULL,'2013-01-04 05:25:54',56296.22633,19.616,0.1305,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13y/LSQ13y_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13y/LSQ13y_snap_92803.gif',41451037042,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647672453,10119882,NULL,NULL,NULL,NULL),(9493,9491,0,'LSQ13y','LSQ',175.837583333333,-29.1764722222222,NULL,NULL,'2013-01-04 07:58:36',56296.33237,19.9779,0.1624,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13y/LSQ13y_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13y/LSQ13y_snap_92804.gif',41451037042,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647672453,10119882,NULL,NULL,NULL,NULL),(9494,9494,1,'LSQ13x','LSQ',178.997916666667,-26.0991111111111,NULL,NULL,'2013-01-04 05:24:12',56296.2251499998,18.0884,0.1299,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13x/LSQ13x_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13x/LSQ13x_snap_92801.gif',41417847270,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647153863,10111779,NULL,NULL,NULL,NULL),(9495,9494,0,'LSQ13x','LSQ',178.997833333333,-26.0992777777778,NULL,NULL,'2013-01-04 08:00:18',56296.3335500001,18.3932,0.1337,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13x/LSQ13x_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13x/LSQ13x_snap_92802.gif',41417847270,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647153863,10111779,NULL,NULL,NULL,NULL),(9496,9496,1,'LSQ13w','LSQ',78.277125,-26.33125,NULL,NULL,'2013-01-04 02:50:15',56296.1182300001,15.552,0.0031,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13w/LSQ13w_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13w/LSQ13w_snap_92799.gif',37248083181,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582001299,9093770,NULL,NULL,NULL,NULL),(9497,9496,0,'LSQ13w','LSQ',78.277125,-26.33125,NULL,NULL,'2013-01-04 05:00:48',56296.2088899999,15.6058,0.0038,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13w/LSQ13w_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13w/LSQ13w_snap_92800.gif',37248083181,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582001299,9093770,NULL,NULL,NULL,NULL),(9498,9498,1,'LSQ13v','LSQ',61.649375,-27.5638888888889,NULL,NULL,'2013-01-04 02:07:49',56296.0887699998,20.2523,0.1194,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_snap_92797.gif',38522804849,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601918825,9404981,NULL,NULL,NULL,NULL),(9499,9498,0,'LSQ13v','LSQ',61.6494166666667,-27.5638333333333,NULL,NULL,'2013-01-04 04:07:07',56296.1716200002,19.8573,0.1288,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_snap_92798.gif',38522804849,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601918825,9404981,NULL,NULL,NULL,NULL),(9500,9500,1,'LSQ13t','LSQ',69.6860416666667,-33.1608333333333,NULL,NULL,'2012-12-20 03:50:38',56281.16017,20.9512,0.1498,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_snap_92831.gif',37688970952,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588890171,9201408,NULL,NULL,NULL,NULL),(9501,9500,0,'LSQ13t','LSQ',69.6860833333333,-33.1607777777778,NULL,NULL,'2012-12-20 06:42:34',56281.2795699998,21.1278,0.1946,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_snap_92832.gif',37688970952,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588890171,9201408,NULL,NULL,NULL,NULL),(9502,9500,0,'LSQ13t','LSQ',69.6862083333333,-33.1608333333333,NULL,NULL,'2012-12-23 04:40:08',56284.1945400001,20.715,0.1978,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_snap_92833.gif',37688970952,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588890171,9201408,NULL,NULL,NULL,NULL),(9503,9500,0,'LSQ13t','LSQ',69.6860833333333,-33.1608333333333,NULL,NULL,'2012-12-25 02:40:03',56286.1111499998,20.4898,0.1687,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_snap_92834.gif',37688970952,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588890171,9201408,NULL,NULL,NULL,NULL),(9504,9500,0,'LSQ13t','LSQ',69.6860833333333,-33.1608333333333,NULL,NULL,'2012-12-25 04:41:07',56286.1952300002,20.4795,0.1649,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_snap_92835.gif',37688970952,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588890171,9201408,NULL,NULL,NULL,NULL),(9505,9500,0,'LSQ13t','LSQ',69.6861666666667,-33.1608888888889,NULL,NULL,'2012-12-31 02:44:07',56292.1139699998,20.4748,0.1553,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_snap_92836.gif',37688970952,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588890171,9201408,NULL,NULL,NULL,NULL),(9506,9500,0,'LSQ13t','LSQ',69.6860833333333,-33.1608333333333,NULL,NULL,'2013-01-04 02:33:13',56296.10641,20.8236,0.1257,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_snap_92793.gif',37688970952,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588890171,9201408,NULL,NULL,NULL,NULL),(9507,9500,0,'LSQ13t','LSQ',69.686125,-33.16075,NULL,NULL,'2013-01-04 04:43:46',56296.1970700002,20.3105,0.1188,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_snap_92794.gif',37688970952,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588890171,9201408,NULL,NULL,NULL,NULL),(9508,9508,1,'LSQ13s','LSQ',66.8668333333333,-31.832,NULL,NULL,'2012-12-18 05:06:06',56279.2125800001,19.093,0.1685,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_snap_92827.gif',37706710007,NULL,NULL,NULL,'2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,589167343,9205739,NULL,NULL,NULL,NULL),(9509,9508,0,'LSQ13s','LSQ',66.8668333333333,-31.8321388888889,NULL,NULL,'2012-12-22 04:50:21',56283.2016400001,18.8418,0.1591,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_snap_92828.gif',37706710007,NULL,NULL,NULL,'2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,589167343,9205739,NULL,NULL,NULL,NULL),(9510,9508,0,'LSQ13s','LSQ',66.8669583333333,-31.8320277777778,NULL,NULL,'2012-12-23 02:23:57',56284.0999699999,18.9412,0.195,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_snap_92829.gif',37706710007,NULL,NULL,NULL,'2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,589167343,9205739,NULL,NULL,NULL,NULL),(9511,9508,0,'LSQ13s','LSQ',66.866875,-31.8320555555556,NULL,NULL,'2012-12-31 02:28:47',56292.1033299998,19.0057,0.1968,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_snap_92830.gif',37706710007,NULL,NULL,NULL,'2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,589167343,9205739,NULL,NULL,NULL,NULL),(9512,9508,0,'LSQ13s','LSQ',66.866875,-31.8321388888889,NULL,NULL,'2013-01-04 02:17:59',56296.09583,19.0344,0.1463,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_snap_92791.gif',37706710007,NULL,NULL,NULL,'2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,589167343,9205739,NULL,NULL,NULL,NULL),(9513,9508,0,'LSQ13s','LSQ',66.8667916666667,-31.8320555555556,NULL,NULL,'2013-01-04 04:28:26',56296.1864200002,18.5469,0.1192,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_snap_92792.gif',37706710007,NULL,NULL,NULL,'2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,589167343,9205739,NULL,NULL,NULL,NULL),(9514,9514,1,'LSQ13r','LSQ',66.7956666666667,-32.6768333333333,NULL,NULL,'2012-12-20 06:03:11',56281.2522200001,18.9259,0.1489,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_snap_92822.gif',37705316407,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589145568,9205399,NULL,NULL,NULL,NULL),(9515,9514,0,'LSQ13r','LSQ',66.79575,-32.6768333333333,NULL,NULL,'2012-12-22 02:50:08',56283.11815,18.7916,0.1117,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_snap_92823.gif',37705316407,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589145568,9205399,NULL,NULL,NULL,NULL),(9516,9514,0,'LSQ13r','LSQ',66.7958333333333,-32.6768888888889,NULL,NULL,'2012-12-23 04:24:44',56284.1838500001,18.8671,0.1241,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_snap_92824.gif',37705316407,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589145568,9205399,NULL,NULL,NULL,NULL),(9517,9514,0,'LSQ13r','LSQ',66.79575,-32.6768611111111,NULL,NULL,'2012-12-25 02:24:43',56286.1005000002,18.5885,0.1264,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_snap_92825.gif',37705316407,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589145568,9205399,NULL,NULL,NULL,NULL),(9518,9514,0,'LSQ13r','LSQ',66.7956666666667,-32.6768333333333,NULL,NULL,'2012-12-25 04:25:52',56286.18463,19.0097,0.1868,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_snap_92826.gif',37705316407,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589145568,9205399,NULL,NULL,NULL,NULL),(9519,9514,0,'LSQ13r','LSQ',66.7957083333333,-32.6768888888889,NULL,NULL,'2013-01-04 02:17:59',56296.09583,18.9217,0.1227,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_snap_92789.gif',37705316407,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589145568,9205399,NULL,NULL,NULL,NULL),(9520,9514,0,'LSQ13r','LSQ',66.79575,-32.6769166666667,NULL,NULL,'2013-01-04 04:28:26',56296.1864200002,18.6529,0.0982,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_snap_92790.gif',37705316407,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589145568,9205399,NULL,NULL,NULL,NULL),(9521,9521,1,'LSQ13o','LSQ',62.469875,-33.6191666666667,NULL,NULL,'2012-12-06 06:29:17',56267.2703399998,20.3011,0.1535,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13o/LSQ13o_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13o/LSQ13o_snap_92813.gif',37708531111,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589195798,9206184,NULL,NULL,NULL,NULL),(9522,9521,0,'LSQ13o','LSQ',62.4697083333333,-33.6191944444444,NULL,NULL,'2012-12-31 02:15:06',56292.0938300001,19.874,0.1567,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13o/LSQ13o_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13o/LSQ13o_snap_92814.gif',37708531111,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589195798,9206184,NULL,NULL,NULL,NULL),(9523,9521,0,'LSQ13o','LSQ',62.47,-33.6191666666667,NULL,NULL,'2012-12-31 04:14:24',56292.17667,20.0901,0.1688,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13o/LSQ13o_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13o/LSQ13o_snap_92815.gif',37708531111,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589195798,9206184,NULL,NULL,NULL,NULL),(9524,9521,0,'LSQ13o','LSQ',62.4699166666667,-33.6191111111111,NULL,NULL,'2013-01-04 02:04:28',56296.0864400002,19.904,0.1165,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13o/LSQ13o_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13o/LSQ13o_snap_92783.gif',37708531111,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589195798,9206184,NULL,NULL,NULL,NULL),(9525,9521,0,'LSQ13o','LSQ',62.47,-33.6191666666667,NULL,NULL,'2013-01-04 04:03:44',56296.16927,20.1885,0.1687,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-04 17:46:10','2013-01-04 17:46:10','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13o/LSQ13o_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13o/LSQ13o_snap_92784.gif',37708531111,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,589195798,9206184,NULL,NULL,NULL,NULL),(9526,8605,0,'LSQ12hud','pessto',144.305541667,-2.20355555556,NULL,NULL,'2013-01-05 07:11:59',56297.3,NULL,NULL,NULL,0.088,NULL,'unknown',NULL,'2013-01-05 11:28:54','2013-01-05 11:46:25','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41120774225,'NTT','EFOSC2','Giorgos','2012-04-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,642512097,10039251,NULL,NULL,NULL,NULL),(9527,9389,0,'LSQ13l','pessto',155.694583333,-7.48625,NULL,NULL,'2013-01-05 07:11:59',56297.3,NULL,NULL,NULL,0.105,NULL,'Ia',NULL,'2013-01-05 11:31:49','2013-01-16 21:46:33','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41246135636,'NTT','EFOSC2','Giorgos','2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644470869,10069857,NULL,NULL,NULL,NULL),(9528,9391,0,'LSQ13i','pessto',178.340791667,-16.1571666667,NULL,NULL,'2013-01-05 07:11:59',56297.3,NULL,NULL,NULL,0.095,NULL,'IIn',NULL,'2013-01-05 11:56:56','2013-01-05 12:16:53','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,40999072603,'NTT','EFOSC2','Giorgos','2012-06-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640610509,10009539,NULL,NULL,NULL,NULL),(9529,9382,0,'LSQ13d','pessto',185.299625,-17.9326111111,NULL,NULL,'2013-01-05 07:11:59',56297.3,NULL,NULL,NULL,0.026,NULL,'IIP',NULL,'2013-01-05 12:00:00','2013-01-05 12:16:53','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43897988004,'NTT','EFOSC2','Giorgos','2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,685906062,10717282,NULL,NULL,NULL,NULL),(9538,9538,0,'PSNJ09040080-7203248','TOCP',136.003333333333,-72.0568888888889,NULL,NULL,'2013-01-03 12:00:00',56295.5,17.2,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2013-01-05 09:30:20','2019-10-12 20:41:36','http://www.cbat.eps.harvard.edu/unconf/followups/J09040080-7203248.html','supernova',NULL,0,NULL,NULL,'NULL',NULL,NULL,40739118984,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,636548734,9946073,NULL,NULL,NULL,NULL),(9539,9399,0,'LSQ13g','atel',194.928708333,-19.7049722222,NULL,NULL,'2013-01-04 00:00:00',56296,NULL,NULL,NULL,0.07,NULL,'Ia',NULL,'2013-01-05 15:45:53','2013-01-09 16:45:46','http://www.astronomerstelegram.org/?read=4701',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,43989620374,'University of Hawaii 2.2-meter','SuperNova Integral Field Spectrograph','','2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,687337818,10739653,NULL,NULL,NULL,NULL),(9540,7894,0,'LSQ12hlz','LSQ',74.407375,-15.3168888888889,NULL,NULL,'2013-01-05 02:24:31',56297.10036,20.7475,0.131,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_93033.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(9541,7894,0,'LSQ12hlz','LSQ',74.4072083333333,-15.3168055555556,NULL,NULL,'2013-01-05 04:36:06',56297.1917400002,19.2592,0.108,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_93034.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(9542,7898,0,'LSQ12hlx','LSQ',169.011416666667,-20.0352777777778,NULL,NULL,'2013-01-05 06:53:26',56297.2871099999,18.9282,0.071,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlx/LSQ12hlx_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlx/LSQ12hlx_snap_92948.gif',41719311014,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,651864234,10185378,NULL,NULL,NULL,NULL),(9543,7909,0,'LSQ12hmy','LSQ',136.547333333333,-2.21366666666667,NULL,NULL,'2013-01-05 03:20:49',56297.1394600002,20.8318,0.1695,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmy/LSQ12hmy_snap_93036.gif',42146871440,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,658544866,10289763,NULL,NULL,NULL,NULL),(9544,8208,0,'LSQ12hno','LSQ',55.6803333333333,-2.66941666666667,NULL,NULL,'2013-01-05 03:03:35',56297.1274999999,18.1283,0.0417,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_93015.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(9545,8208,0,'LSQ12hno','LSQ',55.6803333333333,-2.66944444444444,NULL,NULL,'2013-01-05 03:08:48',56297.13112,18.082,0.0382,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_93016.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(9546,8218,0,'LSQ12hnr','LSQ',160.811541666667,-8.77794444444445,NULL,NULL,'2013-01-05 06:06:33',56297.2545500002,19.328,0.1465,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_snap_92872.gif',41807774750,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653246480,10206976,NULL,NULL,NULL,NULL),(9547,8218,0,'LSQ12hnr','LSQ',160.811541666667,-8.77797222222222,NULL,NULL,'2013-01-05 07:27:51',56297.3110099998,18.9533,0.1336,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_snap_92873.gif',41807774750,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653246480,10206976,NULL,NULL,NULL,NULL),(9548,8624,0,'LSQ12htf','LSQ',163.394708333333,-10.636,NULL,NULL,'2013-01-05 06:11:59',56297.2583300001,20.5007,0.2027,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htf/LSQ12htf_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12htf/LSQ12htf_snap_92961.gif',41786968111,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,652921376,10201896,NULL,NULL,NULL,NULL),(9549,8895,0,'LSQ12hxg','LSQ',62.9476666666667,-5.91902777777778,NULL,NULL,'2013-01-05 03:50:13',56297.1598800002,18.1205,0.0312,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_92914.gif',36962123763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(9550,8904,0,'LSQ12hxb','LSQ',174.203416666667,-8.73030555555555,NULL,NULL,'2013-01-05 06:27:57',56297.2694100002,18.6111,0.0715,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxb/LSQ12hxb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxb/LSQ12hxb_snap_92907.gif',41063321975,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,641614405,10025225,NULL,NULL,NULL,NULL),(9551,8904,0,'LSQ12hxb','LSQ',174.203375,-8.73030555555555,NULL,NULL,'2013-01-05 07:38:42',56297.31855,18.8623,0.0757,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxb/LSQ12hxb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxb/LSQ12hxb_snap_92908.gif',41063321975,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,641614405,10025225,NULL,NULL,NULL,NULL),(9552,8912,0,'LSQ12hvz','LSQ',59.6748333333333,-13.3244166666667,NULL,NULL,'2013-01-05 01:42:06',56297.0709099998,19.0403,0.0554,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_snap_92880.gif',36893561548,NULL,NULL,NULL,'2012-11-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576461899,9007217,NULL,NULL,NULL,NULL),(9553,8912,0,'LSQ12hvz','LSQ',59.6748333333333,-13.3243888888889,NULL,NULL,'2013-01-05 03:43:28',56297.1551899998,19.1557,0.0607,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_snap_92881.gif',36893561548,NULL,NULL,NULL,'2012-11-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576461899,9007217,NULL,NULL,NULL,NULL),(9554,9035,0,'LSQ12hyv','LSQ',63.7127083333333,-16.2175277777778,NULL,NULL,'2013-01-05 01:57:25',56297.0815400002,20.2273,0.1389,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_snap_92940.gif',36871504834,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576117263,9001832,NULL,NULL,NULL,NULL),(9555,9042,0,'LSQ12hys','LSQ',66.392625,-8.53625,NULL,NULL,'2013-01-05 02:00:48',56297.0838899999,20.9199,0.2021,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hys/LSQ12hys_snap_92929.gif',37473130959,NULL,NULL,NULL,'2012-10-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585517671,9148713,NULL,NULL,NULL,NULL),(9556,9049,0,'LSQ12hyr','LSQ',64.0631666666667,-10.9516666666667,NULL,NULL,'2013-01-05 01:59:06',56297.0827100002,18.8133,0.035,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_history.html','sn',NULL,0.045375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_snap_92941.gif',36980827675,NULL,NULL,NULL,'2012-10-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577825432,9028522,NULL,NULL,NULL,NULL),(9557,9101,0,'LSQ12hyg','LSQ',66.60675,-2.58630555555556,NULL,NULL,'2013-01-05 03:41:43',56297.1539699999,19.2975,0.0603,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_snap_92922.gif',36923620875,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576931576,9014555,NULL,NULL,NULL,NULL),(9558,9183,0,'LSQ12hzj','LSQ',149.801833333333,-9.00225,NULL,NULL,'2013-01-05 05:53:57',56297.2458000001,16.8236,0.0086,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 16:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_snap_92986.gif',41335019974,NULL,NULL,NULL,'2012-12-05 05:54:14',56266.246,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645859687,10091557,NULL,NULL,NULL,NULL),(9559,9183,0,'LSQ12hzj','LSQ',149.801875,-9.00227777777778,NULL,NULL,'2013-01-05 08:16:26',56297.3447500002,16.8397,0.0087,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 16:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_snap_92987.gif',41335019974,NULL,NULL,NULL,'2012-12-05 05:54:14',56266.246,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645859687,10091557,NULL,NULL,NULL,NULL),(9560,9284,0,'LSQ12hzv','LSQ',53.0537916666667,-14.7140833333333,NULL,NULL,'2013-01-05 01:30:06',56297.0625800001,20.6428,0.1703,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzv/LSQ12hzv_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzv/LSQ12hzv_snap_93030.gif',38002289697,NULL,NULL,NULL,'2012-12-28 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593785776,9277902,NULL,NULL,NULL,NULL),(9561,9284,0,'LSQ12hzv','LSQ',53.0538333333333,-14.7140277777778,NULL,NULL,'2013-01-05 03:31:28',56297.1468600002,20.0468,0.1965,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzv/LSQ12hzv_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzv/LSQ12hzv_snap_93031.gif',38002289697,NULL,NULL,NULL,'2012-12-28 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593785776,9277902,NULL,NULL,NULL,NULL),(9562,9382,0,'LSQ13d','LSQ',185.29975,-17.9326388888889,NULL,NULL,'2013-01-05 05:57:45',56297.2484400002,17.8663,0.093,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13d/LSQ13d_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13d/LSQ13d_snap_93052.gif',43897987160,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,685906049,10717282,NULL,NULL,NULL,NULL),(9563,9382,0,'LSQ13d','LSQ',185.299625,-17.9326388888889,NULL,NULL,'2013-01-05 08:14:23',56297.3433300001,18.1711,0.084,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13d/LSQ13d_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13d/LSQ13d_snap_93053.gif',43897988004,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,685906062,10717282,NULL,NULL,NULL,NULL),(9564,9386,0,'LSQ13b','LSQ',170.889708333333,-20.3369722222222,NULL,NULL,'2013-01-05 04:59:11',56297.2077700002,18.2971,0.0652,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 16:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_snap_93063.gif',41739726486,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,652183226,10190362,NULL,NULL,NULL,NULL),(9565,9386,0,'LSQ13b','LSQ',170.889708333333,-20.3368888888889,NULL,NULL,'2013-01-05 06:55:07',56297.28828,18.397,0.0698,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 16:16:40','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_snap_93064.gif',41739726486,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,652183226,10190362,NULL,NULL,NULL,NULL),(9566,9389,0,'LSQ13l','LSQ',155.694666666667,-7.48616666666667,NULL,NULL,'2013-01-05 06:03:10',56297.2522,18.6495,0.0738,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_snap_93059.gif',41246135636,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644470869,10069857,NULL,NULL,NULL,NULL),(9567,9389,0,'LSQ13l','LSQ',155.694666666667,-7.48616666666667,NULL,NULL,'2013-01-05 07:26:10',56297.3098399998,18.534,0.0815,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_snap_93060.gif',41246135636,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644470869,10069857,NULL,NULL,NULL,NULL),(9568,9391,0,'LSQ13i','LSQ',178.340833333333,-16.1571944444444,NULL,NULL,'2013-01-05 05:44:17',56297.2390899998,18.7795,0.1203,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13i/LSQ13i_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13i/LSQ13i_snap_93050.gif',40999072603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640610509,10009539,NULL,NULL,NULL,NULL),(9569,9391,0,'LSQ13i','LSQ',178.34075,-16.1571666666667,NULL,NULL,'2013-01-05 07:17:10',56297.3035900001,18.8318,0.1468,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-05 15:46:18','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13i/LSQ13i_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13i/LSQ13i_snap_93051.gif',40999072603,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640610509,10009539,NULL,NULL,NULL,NULL),(9570,9397,0,'LSQ13h','LSQ',70.6753333333333,-14.6319444444444,NULL,NULL,'2013-01-05 02:19:26',56297.0968300002,20.3241,0.1268,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_snap_93065.gif',37544086545,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586626352,9166036,NULL,NULL,NULL,NULL),(9571,9397,0,'LSQ13h','LSQ',70.6752916666667,-14.6319722222222,NULL,NULL,'2013-01-05 04:30:58',56297.1881800001,20.3641,0.1697,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_snap_93066.gif',37544086545,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586626352,9166036,NULL,NULL,NULL,NULL),(9572,9399,0,'LSQ13g','LSQ',194.928666666667,-19.7049166666667,NULL,NULL,'2013-01-05 06:34:22',56297.2738700002,17.9999,0.0845,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-09 16:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13g/LSQ13g_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13g/LSQ13g_snap_93055.gif',43989620374,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,687337818,10739653,NULL,NULL,NULL,NULL),(9573,9399,0,'LSQ13g','LSQ',194.928708333333,-19.7049166666667,NULL,NULL,'2013-01-05 07:54:45',56297.32969,18.1059,0.0796,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 15:46:18','2013-01-09 16:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13g/LSQ13g_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13g/LSQ13g_snap_93056.gif',43989620374,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,687337818,10739653,NULL,NULL,NULL,NULL),(9574,9386,0,'LSQ13b','atel',170.889583333,-20.3370555556,NULL,NULL,'2013-01-04 00:00:00',56296,NULL,NULL,NULL,0.92,NULL,'unknown',NULL,'2013-01-05 15:48:19','2013-01-05 16:16:40','http://www.astronomerstelegram.org/?read=4701',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41739726553,'University of Hawaii 2.2-meter','SuperNova Integral Field Spectrograph','','2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,652183227,10190362,NULL,NULL,NULL,NULL),(9575,9183,0,'LSQ12hzj','atel',149.80175,-9.00230555556,NULL,NULL,'2013-01-04 00:00:00',56296,NULL,NULL,NULL,0.03,NULL,'Ia',NULL,'2013-01-05 15:50:26','2013-01-05 16:16:40','http://www.astronomerstelegram.org/?read=4701',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41335019974,'University of Hawaii 2.2-meter','SuperNova Integral Field Spectrograph','','2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645859687,10091557,NULL,NULL,NULL,NULL),(9576,9538,0,'PSNJ09040080-7203248','pessto',136.003333333,-72.0568888889,NULL,NULL,'2013-01-04 00:00:00',56296,NULL,NULL,NULL,0.038,NULL,'Ia',NULL,'2013-01-05 15:54:07','2013-01-05 15:54:07','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,40739118984,'NTT','EFOSC','Taddia  Leloudas',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,636548734,9946073,NULL,NULL,NULL,NULL),(9577,9577,1,'LSQ13bc','LSQ',133.8245,15.6191111111111,NULL,NULL,'2012-12-24 07:52:47',56285.3283299999,19.8617,0.1071,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bc/LSQ13bc_history.html','sn?',NULL,0.0708,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bc/LSQ13bc_snap_93303.gif',63884562163,NULL,NULL,NULL,'2012-04-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,998196283,15596816,NULL,NULL,NULL,NULL),(9578,9577,0,'LSQ13bc','LSQ',133.824333333333,15.6190833333333,NULL,NULL,'2012-12-28 06:47:45',56289.2831600001,18.442,0.1261,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bc/LSQ13bc_history.html','sn?',NULL,0.0708,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bc/LSQ13bc_snap_93304.gif',63884562163,NULL,NULL,NULL,'2012-04-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,998196283,15596816,NULL,NULL,NULL,NULL),(9579,9577,0,'LSQ13bc','LSQ',133.824541666667,15.6191388888889,NULL,NULL,'2013-01-03 06:13:11',56295.2591599999,19.0792,0.1339,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bc/LSQ13bc_history.html','sn?',NULL,0.0708,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bc/LSQ13bc_snap_93305.gif',63884562163,NULL,NULL,NULL,'2012-04-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,998196283,15596816,NULL,NULL,NULL,NULL),(9580,9577,0,'LSQ13bc','LSQ',133.824375,15.6190277777778,NULL,NULL,'2013-01-05 06:31:51',56297.2721199999,19.5922,0.0994,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bc/LSQ13bc_history.html','sn?',NULL,0.0708,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bc/LSQ13bc_snap_93301.gif',63884562163,NULL,NULL,NULL,'2012-04-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,998196283,15596816,NULL,NULL,NULL,NULL),(9581,9577,0,'LSQ13bc','LSQ',133.824458333333,15.6192222222222,NULL,NULL,'2013-01-05 07:40:50',56297.3200300001,19.5361,0.0941,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bc/LSQ13bc_history.html','sn?',NULL,0.0708,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bc/LSQ13bc_snap_93302.gif',63884562163,NULL,NULL,NULL,'2012-04-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,998196283,15596816,NULL,NULL,NULL,NULL),(9582,9582,1,'LSQ13ba','LSQ',162.662416666667,-10.8734722222222,NULL,NULL,'2013-01-05 06:13:41',56297.2595099998,18.7891,0.0811,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ba/LSQ13ba_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ba/LSQ13ba_snap_93255.gif',41784370026,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,652880781,10201262,NULL,NULL,NULL,NULL),(9583,9582,0,'LSQ13ba','LSQ',162.6625,-10.8735,NULL,NULL,'2013-01-05 07:31:39',56297.3136499999,18.7799,0.0735,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-12 18:20:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ba/LSQ13ba_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ba/LSQ13ba_snap_93256.gif',41784370026,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,652880781,10201262,NULL,NULL,NULL,NULL),(9584,9584,1,'LSQ13ay','LSQ',149.695333333333,-7.59113888888889,NULL,NULL,'2012-12-21 06:39:30',56282.2774399999,20.1525,0.1795,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_snap_93293.gif',41333894671,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645842104,10091282,NULL,NULL,NULL,NULL),(9585,9584,0,'LSQ13ay','LSQ',149.695291666667,-7.59108333333333,NULL,NULL,'2012-12-24 05:43:50',56285.2387799998,19.7176,0.138,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_snap_93294.gif',41333894671,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645842104,10091282,NULL,NULL,NULL,NULL),(9586,9584,0,'LSQ13ay','LSQ',149.695333333333,-7.59125,NULL,NULL,'2012-12-24 07:12:31',56285.3003600002,20.0208,0.1522,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_snap_93295.gif',41333894671,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645842104,10091282,NULL,NULL,NULL,NULL),(9587,9584,0,'LSQ13ay','LSQ',149.695416666667,-7.59119444444444,NULL,NULL,'2012-12-26 06:45:45',56287.2817799998,19.3418,0.1855,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_snap_93296.gif',41333894671,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645842104,10091282,NULL,NULL,NULL,NULL),(9588,9584,0,'LSQ13ay','LSQ',149.695416666667,-7.59116666666667,NULL,NULL,'2012-12-26 07:44:36',56287.3226399999,19.7495,0.2118,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_snap_93297.gif',41333894671,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645842104,10091282,NULL,NULL,NULL,NULL),(9589,9584,0,'LSQ13ay','LSQ',149.695291666667,-7.59102777777778,NULL,NULL,'2012-12-28 08:15:38',56289.3442000002,19.5944,0.2088,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_snap_93298.gif',41333894671,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645842104,10091282,NULL,NULL,NULL,NULL),(9590,9584,0,'LSQ13ay','LSQ',149.695375,-7.59111111111111,NULL,NULL,'2013-01-03 05:55:14',56295.2467,19.2613,0.1859,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_snap_93299.gif',41333894671,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645842104,10091282,NULL,NULL,NULL,NULL),(9591,9584,0,'LSQ13ay','LSQ',149.695416666667,-7.59113888888889,NULL,NULL,'2013-01-05 05:48:08',56297.2417700002,19.1296,0.1481,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_snap_93251.gif',41333894671,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645842104,10091282,NULL,NULL,NULL,NULL),(9592,9584,0,'LSQ13ay','LSQ',149.695333333333,-7.59125,NULL,NULL,'2013-01-05 07:19:10',56297.30498,19.3285,0.154,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_snap_93252.gif',41333894671,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645842104,10091282,NULL,NULL,NULL,NULL),(9593,9593,1,'LSQ13ax','LSQ',146.896625,-7.40836111111111,NULL,NULL,'2013-01-03 05:53:32',56295.2455199999,19.8288,0.1861,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_snap_93292.gif',41326341537,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645724086,10089438,NULL,NULL,NULL,NULL),(9594,9593,0,'LSQ13ax','LSQ',146.896583333333,-7.40844444444445,NULL,NULL,'2013-01-05 05:46:27',56297.2406000001,19.5319,0.1293,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-12 18:20:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_snap_93249.gif',41326341537,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645724086,10089438,NULL,NULL,NULL,NULL),(9595,9593,0,'LSQ13ax','LSQ',146.896625,-7.40844444444445,NULL,NULL,'2013-01-05 08:22:13',56297.34877,19.4761,0.1221,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-12 18:20:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_snap_93250.gif',41326341537,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645724086,10089438,NULL,NULL,NULL,NULL),(9596,9596,1,'LSQ13at','LSQ',187.250708333333,-15.5084722222222,NULL,NULL,'2012-12-28 06:38:26',56289.2766900002,18.8226,0.127,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_snap_93288.gif',43045835690,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,672591182,10509237,NULL,NULL,NULL,NULL),(9597,9596,0,'LSQ13at','LSQ',187.250666666667,-15.5084722222222,NULL,NULL,'2012-12-28 07:58:21',56289.33219,18.7103,0.1064,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_snap_93289.gif',43045835690,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,672591182,10509237,NULL,NULL,NULL,NULL),(9598,9596,0,'LSQ13at','LSQ',187.250833333333,-15.5085277777778,NULL,NULL,'2013-01-03 06:36:46',56295.2755399998,18.4443,0.0904,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_snap_93290.gif',43045835690,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,672591182,10509237,NULL,NULL,NULL,NULL),(9599,9596,0,'LSQ13at','LSQ',187.250833333333,-15.5085,NULL,NULL,'2013-01-03 07:59:02',56295.3326699999,18.5733,0.0673,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_snap_93291.gif',43045835690,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,672591182,10509237,NULL,NULL,NULL,NULL),(9600,9596,0,'LSQ13at','LSQ',187.250791666667,-15.5085277777778,NULL,NULL,'2013-01-05 06:08:27',56297.25587,18.4613,0.1248,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_snap_93241.gif',43045835690,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,672591182,10509237,NULL,NULL,NULL,NULL),(9601,9596,0,'LSQ13at','LSQ',187.250791666667,-15.5085555555556,NULL,NULL,'2013-01-05 08:08:46',56297.3394300002,18.202,0.0982,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_snap_93242.gif',43045835690,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,672591182,10509237,NULL,NULL,NULL,NULL),(9602,9602,1,'LSQ13as','LSQ',178.838958333333,-13.9714444444444,NULL,NULL,'2013-01-03 05:43:05',56295.23826,18.9945,0.1956,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_snap_93286.gif',40967582261,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,640118472,10001851,NULL,NULL,NULL,NULL),(9603,9602,0,'LSQ13as','LSQ',178.838791666667,-13.9714722222222,NULL,NULL,'2013-01-03 07:15:15',56295.3022599998,18.9452,0.1697,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_snap_93287.gif',40967582261,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,640118472,10001851,NULL,NULL,NULL,NULL),(9604,9602,0,'LSQ13as','LSQ',178.838875,-13.9714166666667,NULL,NULL,'2013-01-05 05:42:36',56297.2379200002,19.3066,0.1239,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_snap_93239.gif',40967582261,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,640118472,10001851,NULL,NULL,NULL,NULL),(9605,9602,0,'LSQ13as','LSQ',178.838833333333,-13.9713888888889,NULL,NULL,'2013-01-05 08:24:12',56297.3501400002,19.2149,0.0983,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_snap_93240.gif',40967582261,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,640118472,10001851,NULL,NULL,NULL,NULL),(9606,9606,1,'LSQ13ar','LSQ',173.712708333333,-15.8353888888889,NULL,NULL,'2013-01-05 05:35:50',56297.2332199998,19.4135,0.1327,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ar/LSQ13ar_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ar/LSQ13ar_snap_93237.gif',40974652544,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640228946,10003577,NULL,NULL,NULL,NULL),(9607,9606,0,'LSQ13ar','LSQ',173.71275,-15.8356111111111,NULL,NULL,'2013-01-05 08:27:34',56297.3524799999,19.1464,0.1019,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ar/LSQ13ar_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ar/LSQ13ar_snap_93238.gif',40974652544,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640228946,10003577,NULL,NULL,NULL,NULL),(9608,9608,1,'LSQ13ag','LSQ',75.549625,-17.9771666666667,NULL,NULL,'2012-12-28 02:55:34',56289.1219299999,18.6404,0.181,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_snap_93261.gif',37553411726,NULL,NULL,NULL,'2012-12-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,586772058,9168313,NULL,NULL,NULL,NULL),(9609,9608,0,'LSQ13ag','LSQ',75.5496666666667,-17.9771388888889,NULL,NULL,'2012-12-28 05:05:14',56289.2119700001,19.44,0.1854,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_snap_93262.gif',37553411726,NULL,NULL,NULL,'2012-12-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,586772058,9168313,NULL,NULL,NULL,NULL),(9610,9608,0,'LSQ13ag','LSQ',75.5495833333333,-17.9771666666667,NULL,NULL,'2012-12-30 02:54:38',56291.1212800001,18.5652,0.108,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_snap_93263.gif',37553411726,NULL,NULL,NULL,'2012-12-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,586772058,9168313,NULL,NULL,NULL,NULL),(9611,9608,0,'LSQ13ag','LSQ',75.549625,-17.9771666666667,NULL,NULL,'2013-01-03 02:51:13',56295.1189100002,18.1307,0.0389,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_snap_93264.gif',37553411726,NULL,NULL,NULL,'2012-12-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,586772058,9168313,NULL,NULL,NULL,NULL),(9612,9608,0,'LSQ13ag','LSQ',75.549625,-17.9771666666667,NULL,NULL,'2013-01-03 04:55:01',56295.2048800001,18.1253,0.0513,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_snap_93265.gif',37553411726,NULL,NULL,NULL,'2012-12-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,586772058,9168313,NULL,NULL,NULL,NULL),(9613,9608,0,'LSQ13ag','LSQ',75.549625,-17.9771388888889,NULL,NULL,'2013-01-05 02:29:34',56297.1038700002,17.9289,0.0354,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_snap_93215.gif',37553411726,NULL,NULL,NULL,'2012-12-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,586772058,9168313,NULL,NULL,NULL,NULL),(9614,9608,0,'LSQ13ag','LSQ',75.5496666666667,-17.9771666666667,NULL,NULL,'2013-01-05 04:41:09',56297.1952499999,17.8453,0.0419,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_snap_93216.gif',37553411726,NULL,NULL,NULL,'2012-12-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,586772058,9168313,NULL,NULL,NULL,NULL),(9615,9615,1,'LSQ13ae','LSQ',69.1567083333333,-18.6028333333333,NULL,NULL,'2013-01-05 02:16:03',56297.09449,20.6528,0.1486,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ae/LSQ13ae_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ae/LSQ13ae_snap_92865.gif',37364625951,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583822280,9122223,NULL,NULL,NULL,NULL),(9616,9615,0,'LSQ13ae','LSQ',69.1567916666667,-18.6031111111111,NULL,NULL,'2013-01-05 04:27:36',56297.1858399999,19.6678,0.1204,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ae/LSQ13ae_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ae/LSQ13ae_snap_92866.gif',37364625951,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583822280,9122223,NULL,NULL,NULL,NULL),(9617,9617,1,'LSQ13ad','LSQ',54.268625,-17.5794444444444,NULL,NULL,'2013-01-05 01:38:33',56297.0684400001,20.4219,0.1115,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ad/LSQ13ad_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ad/LSQ13ad_snap_92863.gif',38013957787,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,593968090,9280751,NULL,NULL,NULL,NULL),(9618,9617,0,'LSQ13ad','LSQ',54.2686666666667,-17.5793888888889,NULL,NULL,'2013-01-05 03:39:57',56297.1527499999,19.8886,0.0896,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-05 18:46:14','2013-01-05 18:46:14','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ad/LSQ13ad_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ad/LSQ13ad_snap_92864.gif',38013957787,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,593968090,9280751,NULL,NULL,NULL,NULL),(9619,7751,0,'LSQ12hle','LSQ',61.1045,-29.1576944444444,NULL,NULL,'2013-01-06 01:47:36',56298.07473,20.9328,0.1484,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hle/LSQ12hle_snap_93470.gif',38530541650,NULL,NULL,NULL,'2012-11-30 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602039713,9406870,NULL,NULL,NULL,NULL),(9620,7756,0,'LSQ12hlv','LSQ',76.9713333333333,-21.2462777777778,NULL,NULL,'2013-01-06 02:43:40',56298.1136599998,19.7041,0.135,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlv/LSQ12hlv_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlv/LSQ12hlv_snap_93344.gif',37548641524,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586697523,9167148,NULL,NULL,NULL,NULL),(9621,8046,0,'LSQ12hnj','LSQ',78.1033333333333,-25.7825277777778,NULL,NULL,'2013-01-06 02:40:18',56298.1113200001,16.3819,0.0076,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_93511.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(9622,8046,0,'LSQ12hnj','LSQ',78.1027083333333,-25.7825833333333,NULL,NULL,'2013-01-06 02:41:59',56298.1124900002,16.6207,0.0078,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_93513.gif',37249489805,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(9623,8046,0,'LSQ12hnj','LSQ',78.103375,-25.7825555555556,NULL,NULL,'2013-01-06 04:48:43',56298.2004999998,16.317,0.008,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_93512.gif',37249489794,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(9624,8046,0,'LSQ12hnj','LSQ',78.1027083333333,-25.7826111111111,NULL,NULL,'2013-01-06 04:50:24',56298.2016699999,16.6557,0.0086,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_history.html','sn nice',NULL,0.014727,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnj/LSQ12hnj_snap_93514.gif',37249489805,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,582023278,9094113,NULL,NULL,NULL,NULL),(9625,8049,0,'LSQ12hni','LSQ',53.0504583333333,-26.7003611111111,NULL,NULL,'2013-01-06 03:34:43',56298.1491200002,19.8531,0.1215,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hni/LSQ12hni_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hni/LSQ12hni_snap_93505.gif',38549122897,NULL,NULL,NULL,'2012-12-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602330045,9411406,NULL,NULL,NULL,NULL),(9626,8228,0,'LSQ12hon','LSQ',57.89325,-24.2264444444444,NULL,NULL,'2013-01-06 03:43:29',56298.1551999999,19.7986,0.1942,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_93575.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(9627,8233,0,'LSQ12hnu','LSQ',56.4027083333333,-37.738,NULL,NULL,'2013-01-06 01:37:28',56298.0676899999,20.4008,0.0917,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_93365.gif',38557895447,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(9628,8233,0,'LSQ12hnu','LSQ',56.40275,-37.7381111111111,NULL,NULL,'2013-01-06 02:55:48',56298.1220900002,20.4398,0.0841,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_93366.gif',38557895447,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(9629,8408,0,'LSQ12hqa','LSQ',160.241166666667,-21.7818333333333,NULL,NULL,'2013-01-06 05:10:15',56298.2154600001,19.3505,0.0871,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_snap_93409.gif',41668171452,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,651065178,10172893,NULL,NULL,NULL,NULL),(9630,8686,0,'LSQ12hvj','LSQ',166.910916666667,-29.7114166666667,NULL,NULL,'2013-01-06 05:05:11',56298.2119399998,17.915,0.0419,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_93554.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(9631,8949,0,'LSQ12hyd','LSQ',174.637833333333,-24.2078333333333,NULL,NULL,'2013-01-06 05:25:40',56298.2261600001,19.6781,0.182,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_snap_93430.gif',41410841875,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647044404,10110068,NULL,NULL,NULL,NULL),(9632,8949,0,'LSQ12hyd','LSQ',174.637916666667,-24.2079722222222,NULL,NULL,'2013-01-06 07:07:28',56298.2968600001,18.9625,0.1081,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_snap_93431.gif',41410841875,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647044404,10110068,NULL,NULL,NULL,NULL),(9633,8959,0,'LSQ12hxx','LSQ',49.9343333333333,-27.0071388888889,NULL,NULL,'2013-01-06 03:09:25',56298.13155,17.6155,0.0181,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_93459.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(9634,8959,0,'LSQ12hxx','LSQ',49.9343333333333,-27.0071666666667,NULL,NULL,'2013-01-06 03:12:48',56298.1338999998,17.7286,0.0191,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_93460.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(9635,8966,0,'LSQ12hxt','LSQ',56.8413333333333,-31.2003888888889,NULL,NULL,'2013-01-06 01:40:52',56298.0700500002,19.0477,0.0707,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_93426.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(9636,8966,0,'LSQ12hxt','LSQ',56.8413333333333,-31.2003888888889,NULL,NULL,'2013-01-06 03:40:07',56298.1528599998,19.2831,0.0593,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_93427.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(9637,9251,0,'LSQ12hzu','LSQ',76.9713333333333,-20.9748055555556,NULL,NULL,'2013-01-06 02:43:40',56298.1136599998,18.467,0.0516,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_93543.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(9638,9251,0,'LSQ12hzu','LSQ',76.9712083333333,-20.9748055555556,NULL,NULL,'2013-01-06 04:52:05',56298.2028399999,18.8446,0.0726,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_93544.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(9639,9257,0,'LSQ12hzs','LSQ',60.471625,-26.6639722222222,NULL,NULL,'2013-01-06 01:47:36',56298.07473,18.6,0.0274,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_history.html','sn nice',NULL,0.07213,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_snap_93540.gif',38534445066,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602100704,9407823,NULL,NULL,NULL,NULL),(9640,9257,0,'LSQ12hzs','LSQ',60.4715,-26.6637777777778,NULL,NULL,'2013-01-06 03:46:52',56298.1575500001,17.6627,0.023,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_history.html','sn nice',NULL,0.07213,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_snap_93541.gif',38534445066,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602100704,9407823,NULL,NULL,NULL,NULL),(9641,9352,0,'LSQ12iae','LSQ',63.3027083333333,-30.7499166666667,NULL,NULL,'2013-01-06 01:56:07',56298.0806399998,18.8503,0.0431,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_snap_93614.gif',37654344365,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588349130,9192955,NULL,NULL,NULL,NULL),(9642,9352,0,'LSQ12iae','LSQ',63.3026666666667,-30.7499722222222,NULL,NULL,'2013-01-06 03:55:22',56298.16346,18.8137,0.0523,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_snap_93615.gif',37654344361,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588349130,9192955,NULL,NULL,NULL,NULL),(9643,9475,0,'LSQ13ac','LSQ',193.608333333333,-24.5700555555556,NULL,NULL,'2013-01-06 06:18:16',56298.2626899998,17.397,0.0281,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ac/LSQ13ac_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ac/LSQ13ac_snap_93321.gif',43302938007,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,676608406,10572006,NULL,NULL,NULL,NULL),(9644,9477,0,'LSQ13ab','LSQ',168.103916666667,-21.961,NULL,NULL,'2013-01-06 05:18:50',56298.2214199998,16.7294,0.011,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_93322.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(9645,9477,0,'LSQ13ab','LSQ',168.104083333333,-21.9609722222222,NULL,NULL,'2013-01-06 07:04:07',56298.2945300001,16.6202,0.0135,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_93323.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(9646,9487,0,'LSQ13aa','LSQ',68.8429583333333,-23.6362222222222,NULL,NULL,'2013-01-06 02:18:10',56298.0959600001,19.3611,0.0698,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_snap_93317.gif',37317539555,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583086555,9110727,NULL,NULL,NULL,NULL),(9647,9487,0,'LSQ13aa','LSQ',68.8429166666667,-23.6362222222222,NULL,NULL,'2013-01-06 04:26:34',56298.18512,19.4718,0.0736,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_snap_93318.gif',37317539555,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583086555,9110727,NULL,NULL,NULL,NULL),(9648,9496,0,'LSQ13w','LSQ',78.2771666666667,-26.33125,NULL,NULL,'2013-01-06 02:41:59',56298.1124900002,17.7607,0.0144,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13w/LSQ13w_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13w/LSQ13w_snap_93313.gif',37248083177,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582001299,9093770,NULL,NULL,NULL,NULL),(9649,9496,0,'LSQ13w','LSQ',78.277125,-26.33125,NULL,NULL,'2013-01-06 04:50:24',56298.2016699999,17.8871,0.0171,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13w/LSQ13w_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13w/LSQ13w_snap_93314.gif',37248083181,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582001299,9093770,NULL,NULL,NULL,NULL),(9650,9498,0,'LSQ13v','LSQ',61.6493333333333,-27.5638888888889,NULL,NULL,'2013-01-06 01:59:30',56298.08299,20.0706,0.1092,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_snap_93315.gif',38522804849,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601918825,9404981,NULL,NULL,NULL,NULL),(9651,9498,0,'LSQ13v','LSQ',61.6493333333333,-27.5638611111111,NULL,NULL,'2013-01-06 03:58:46',56298.1658200002,20.2926,0.1148,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_snap_93316.gif',38522804849,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601918825,9404981,NULL,NULL,NULL,NULL),(9652,9500,0,'LSQ13t','LSQ',69.6860833333333,-33.1608055555556,NULL,NULL,'2013-01-06 02:25:02',56298.10072,21.0581,0.1315,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_snap_93423.gif',37688970952,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588890171,9201408,NULL,NULL,NULL,NULL),(9653,9500,0,'LSQ13t','LSQ',69.6860416666667,-33.1608333333333,NULL,NULL,'2013-01-06 04:33:24',56298.1898699999,21.2178,0.1335,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_snap_93424.gif',37688970952,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588890171,9201408,NULL,NULL,NULL,NULL),(9654,9508,0,'LSQ13s','LSQ',66.866875,-31.8321111111111,NULL,NULL,'2013-01-06 04:18:07',56298.17925,18.9909,0.1412,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 14:46:11','2013-01-06 14:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_snap_93306.gif',37706710007,NULL,NULL,NULL,'2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,589167343,9205739,NULL,NULL,NULL,NULL),(9655,9655,1,'LSQ13bd','LSQ',58.4530833333333,-37.4327777777778,NULL,NULL,'2013-01-04 01:57:40',56296.0817200001,20.7896,0.1314,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 17:46:11','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bd/LSQ13bd_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bd/LSQ13bd_snap_93724.gif',37667745058,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,588558516,9196226,NULL,NULL,NULL,NULL),(9656,9655,0,'LSQ13bd','LSQ',58.453125,-37.4328055555556,NULL,NULL,'2013-01-04 03:56:57',56296.1645599999,20.8493,0.1476,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 17:46:11','2013-01-06 17:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bd/LSQ13bd_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bd/LSQ13bd_snap_93725.gif',37667745058,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,588558516,9196226,NULL,NULL,NULL,NULL),(9657,9655,0,'LSQ13bd','LSQ',58.4531666666667,-37.4328333333333,NULL,NULL,'2013-01-06 01:49:17',56298.0759000001,20.6732,0.1496,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 17:46:11','2013-01-06 17:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bd/LSQ13bd_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bd/LSQ13bd_snap_93716.gif',37667745058,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,588558516,9196226,NULL,NULL,NULL,NULL),(9658,9655,0,'LSQ13bd','LSQ',58.453125,-37.4328611111111,NULL,NULL,'2013-01-06 03:48:34',56298.1587299998,20.7896,0.1319,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-06 17:46:11','2013-01-06 17:46:11','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bd/LSQ13bd_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bd/LSQ13bd_snap_93717.gif',37667745058,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,588558516,9196226,NULL,NULL,NULL,NULL),(9659,7894,0,'LSQ12hlz','LSQ',74.407375,-15.3167222222222,NULL,NULL,'2013-01-07 02:19:28',56299.0968599999,20.6452,0.1811,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_93967.gif',37576938137,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(9660,7894,0,'LSQ12hlz','LSQ',74.40725,-15.31675,NULL,NULL,'2013-01-07 04:27:47',56299.18597,20.1013,0.1308,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hlz/LSQ12hlz_snap_93968.gif',37576938141,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,587139658,9174057,NULL,NULL,NULL,NULL),(9661,7937,0,'LSQ12hmb','LSQ',151.367916666667,-13.1325,NULL,NULL,'2013-01-07 05:01:56',56299.2096799999,18.5163,0.1492,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hmb/LSQ12hmb_snap_93971.gif',41162875494,NULL,NULL,NULL,'2012-12-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,643169929,10049530,NULL,NULL,NULL,NULL),(9662,8208,0,'LSQ12hno','LSQ',55.6801666666667,-2.66938888888889,NULL,NULL,'2013-01-07 03:05:19',56299.1286999998,18.2541,0.0578,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_93945.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(9663,8208,0,'LSQ12hno','LSQ',55.6802916666667,-2.66941666666667,NULL,NULL,'2013-01-07 03:19:52',56299.1387999998,18.1863,0.039,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hno/LSQ12hno_snap_93946.gif',36811538950,NULL,NULL,NULL,'2012-12-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,575180296,8987192,NULL,NULL,NULL,NULL),(9664,8218,0,'LSQ12hnr','LSQ',160.811583333333,-8.77794444444445,NULL,NULL,'2013-01-07 06:06:55',56299.2548099998,19.4575,0.1517,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_snap_93763.gif',41807774750,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653246480,10206976,NULL,NULL,NULL,NULL),(9665,8218,0,'LSQ12hnr','LSQ',160.8115,-8.77802777777778,NULL,NULL,'2013-01-07 07:59:32',56299.3330100002,19.0015,0.1567,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnr/LSQ12hnr_snap_93764.gif',41807774750,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653246480,10206976,NULL,NULL,NULL,NULL),(9666,8879,0,'LSQ12hxi','LSQ',61.6559166666667,-0.730027777777778,NULL,NULL,'2013-01-07 02:43:17',56299.1134000001,18.085,0.0739,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxi/LSQ12hxi_snap_93801.gif',36935907244,NULL,NULL,NULL,'2012-11-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577123550,9017555,NULL,NULL,NULL,NULL),(9667,8895,0,'LSQ12hxg','LSQ',62.947625,-5.91902777777778,NULL,NULL,'2013-01-07 01:43:48',56299.0720899999,18.1724,0.0301,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_93843.gif',36962123763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(9668,8895,0,'LSQ12hxg','LSQ',62.9476666666667,-5.91902777777778,NULL,NULL,'2013-01-07 03:43:07',56299.1549499999,17.9724,0.0305,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_93844.gif',36962123763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(9669,8904,0,'LSQ12hxb','LSQ',174.203375,-8.73033333333333,NULL,NULL,'2013-01-07 06:28:34',56299.2698400002,19.0399,0.0649,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxb/LSQ12hxb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxb/LSQ12hxb_snap_93804.gif',41063321975,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,641614405,10025225,NULL,NULL,NULL,NULL),(9670,8904,0,'LSQ12hxb','LSQ',174.203375,-8.73030555555555,NULL,NULL,'2013-01-07 07:40:08',56299.3195400001,18.9816,0.0603,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxb/LSQ12hxb_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxb/LSQ12hxb_snap_93805.gif',41063321975,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,641614405,10025225,NULL,NULL,NULL,NULL),(9671,8906,0,'LSQ12hwy','LSQ',151.071,-15.0930833333333,NULL,NULL,'2013-01-07 06:56:44',56299.2894000001,18.2745,0.0269,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_history.html','sn?',NULL,0.049834,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_snap_93846.gif',41190790322,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643606098,10056345,NULL,NULL,NULL,NULL),(9672,8912,0,'LSQ12hvz','LSQ',59.6747916666667,-13.3243888888889,NULL,NULL,'2013-01-07 01:37:05',56299.0674200002,19.2191,0.07,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_snap_93794.gif',36893561548,NULL,NULL,NULL,'2012-11-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576461899,9007217,NULL,NULL,NULL,NULL),(9673,8912,0,'LSQ12hvz','LSQ',59.6748333333333,-13.3243888888889,NULL,NULL,'2013-01-07 03:36:23',56299.1502700001,19.1539,0.0681,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_snap_93795.gif',36893561548,NULL,NULL,NULL,'2012-11-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576461899,9007217,NULL,NULL,NULL,NULL),(9674,8915,0,'LSQ12hvy','LSQ',154.816333333333,-17.0151666666667,NULL,NULL,'2013-01-07 04:37:13',56299.19252,20.4571,0.1664,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_snap_93864.gif',41645999498,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650718742,10167480,NULL,NULL,NULL,NULL),(9675,8915,0,'LSQ12hvy','LSQ',154.816458333333,-17.0151666666667,NULL,NULL,'2013-01-07 06:44:45',56299.2810800001,20.6714,0.1543,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_snap_93865.gif',41645999498,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650718742,10167480,NULL,NULL,NULL,NULL),(9676,9035,0,'LSQ12hyv','LSQ',63.712875,-16.2173888888889,NULL,NULL,'2013-01-07 01:52:21',56299.07803,19.3875,0.138,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_snap_93870.gif',36871504835,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576117263,9001832,NULL,NULL,NULL,NULL),(9677,9035,0,'LSQ12hyv','LSQ',63.712,-16.2172222222222,NULL,NULL,'2013-01-07 03:51:39',56299.1608699998,19.6373,0.1864,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_snap_93871.gif',36871504847,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576117263,9001832,NULL,NULL,NULL,NULL),(9678,9049,0,'LSQ12hyr','LSQ',64.0627916666667,-10.9514444444444,NULL,NULL,'2013-01-07 01:54:03',56299.0792100001,19.5885,0.0743,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_history.html','sn',NULL,0.045375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_snap_93872.gif',36980827675,NULL,NULL,NULL,'2012-10-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577825432,9028522,NULL,NULL,NULL,NULL),(9679,9101,0,'LSQ12hyg','LSQ',66.60725,-2.58644444444444,NULL,NULL,'2013-01-07 01:35:22',56299.06623,17.9115,0.0294,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyg/LSQ12hyg_snap_93850.gif',36923620917,NULL,NULL,NULL,'2012-11-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576931576,9014555,NULL,NULL,NULL,NULL),(9680,9180,0,'LSQ12hzo','LSQ',136.200458333333,18.6495277777778,NULL,NULL,'2013-01-07 08:37:03',56299.3590699998,20.3806,0.1558,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzo/LSQ12hzo_history.html','sn?',NULL,0.11231,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzo/LSQ12hzo_snap_93942.gif',63876968330,NULL,NULL,NULL,'2012-04-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,998077630,15594962,NULL,NULL,NULL,NULL),(9681,9183,0,'LSQ12hzj','LSQ',149.801875,-9.00225,NULL,NULL,'2013-01-07 07:24:23',56299.3086100002,16.7466,0.0067,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_snap_93926.gif',41335019974,NULL,NULL,NULL,'2012-12-05 05:54:14',56266.246,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645859687,10091557,NULL,NULL,NULL,NULL),(9682,9197,0,'LSQ12hzh','LSQ',66.4471666666667,-8.60952777777778,NULL,NULL,'2013-01-07 01:55:44',56299.0803800002,20.1973,0.205,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_snap_93923.gif',37473128002,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585517625,9148712,NULL,NULL,NULL,NULL),(9683,9284,0,'LSQ12hzv','LSQ',53.05375,-14.7140555555556,NULL,NULL,'2013-01-07 02:31:23',56299.10513,19.6917,0.1444,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzv/LSQ12hzv_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzv/LSQ12hzv_snap_93960.gif',38002289697,NULL,NULL,NULL,'2012-12-28 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593785776,9277902,NULL,NULL,NULL,NULL),(9684,9284,0,'LSQ12hzv','LSQ',53.0536666666667,-14.7141666666667,NULL,NULL,'2013-01-07 03:58:24',56299.1655600001,19.9639,0.1433,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzv/LSQ12hzv_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzv/LSQ12hzv_snap_93961.gif',38002289697,NULL,NULL,NULL,'2012-12-28 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593785776,9277902,NULL,NULL,NULL,NULL),(9685,9382,0,'LSQ13d','LSQ',185.299625,-17.9325833333333,NULL,NULL,'2013-01-07 05:48:42',56299.2421599999,18.0548,0.0545,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13d/LSQ13d_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13d/LSQ13d_snap_93989.gif',43897988004,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,685906062,10717282,NULL,NULL,NULL,NULL),(9686,9382,0,'LSQ13d','LSQ',185.299666666667,-17.9326388888889,NULL,NULL,'2013-01-07 08:06:37',56299.3379299999,18.2669,0.0589,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13d/LSQ13d_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13d/LSQ13d_snap_93990.gif',43897988004,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,685906062,10717282,NULL,NULL,NULL,NULL),(9687,9386,0,'LSQ13b','LSQ',170.889666666667,-20.3369444444444,NULL,NULL,'2013-01-07 04:54:58',56299.2048399998,18.6812,0.0554,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_snap_93999.gif',41739726486,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,652183226,10190362,NULL,NULL,NULL,NULL),(9688,9386,0,'LSQ13b','LSQ',170.889666666667,-20.3368611111111,NULL,NULL,'2013-01-07 08:22:22',56299.3488699999,18.5077,0.0456,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_snap_94000.gif',41739726486,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,652183226,10190362,NULL,NULL,NULL,NULL),(9689,9389,0,'LSQ13l','LSQ',155.694666666667,-7.48616666666667,NULL,NULL,'2013-01-07 05:59:38',56299.24975,18.6869,0.0833,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_snap_93995.gif',41246135636,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644470869,10069857,NULL,NULL,NULL,NULL),(9690,9389,0,'LSQ13l','LSQ',155.694708333333,-7.48619444444444,NULL,NULL,'2013-01-07 08:02:54',56299.3353499998,18.6382,0.0667,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_snap_93996.gif',41246135636,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644470869,10069857,NULL,NULL,NULL,NULL),(9691,9397,0,'LSQ13h','LSQ',70.6752916666667,-14.6319444444444,NULL,NULL,'2013-01-07 02:14:23',56299.0933300001,20.5418,0.1067,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_snap_93985.gif',37544086545,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586626352,9166036,NULL,NULL,NULL,NULL),(9692,9397,0,'LSQ13h','LSQ',70.67525,-14.632,NULL,NULL,'2013-01-07 04:22:42',56299.1824400001,20.4013,0.1545,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_snap_93986.gif',37544086545,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586626352,9166036,NULL,NULL,NULL,NULL),(9693,9399,0,'LSQ13g','LSQ',194.92875,-19.7049444444444,NULL,NULL,'2013-01-07 06:23:19',56299.2662,18.3484,0.0524,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-09 16:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13g/LSQ13g_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13g/LSQ13g_snap_93987.gif',43989620374,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,687337818,10739653,NULL,NULL,NULL,NULL),(9694,9399,0,'LSQ13g','LSQ',194.92875,-19.7049166666667,NULL,NULL,'2013-01-07 07:36:36',56299.31709,18.2885,0.0496,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-09 16:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13g/LSQ13g_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13g/LSQ13g_snap_93988.gif',43989620374,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,687337818,10739653,NULL,NULL,NULL,NULL),(9695,9577,0,'LSQ13bc','LSQ',133.8245,15.6189722222222,NULL,NULL,'2013-01-07 07:42:16',56299.3210300002,19.7493,0.1423,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bc/LSQ13bc_history.html','sn?',NULL,0.0708,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bc/LSQ13bc_snap_93841.gif',63884562163,NULL,NULL,NULL,'2012-04-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,998196283,15596816,NULL,NULL,NULL,NULL),(9696,9582,0,'LSQ13ba','LSQ',162.662458333333,-10.8734722222222,NULL,NULL,'2013-01-07 06:14:13',56299.2598799998,18.8154,0.0504,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-12 18:20:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ba/LSQ13ba_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ba/LSQ13ba_snap_93836.gif',41784370026,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,652880781,10201262,NULL,NULL,NULL,NULL),(9697,9582,0,'LSQ13ba','LSQ',162.662458333333,-10.8734444444444,NULL,NULL,'2013-01-07 07:56:08',56299.3306499999,18.8339,0.0491,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-12 18:20:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ba/LSQ13ba_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ba/LSQ13ba_snap_93837.gif',41784370026,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,652880781,10201262,NULL,NULL,NULL,NULL),(9698,9584,0,'LSQ13ay','LSQ',149.695416666667,-7.59122222222222,NULL,NULL,'2013-01-07 03:29:56',56299.14579,19.8108,0.2102,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_snap_93828.gif',41333894671,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645842104,10091282,NULL,NULL,NULL,NULL),(9699,9593,0,'LSQ13ax','LSQ',146.896541666667,-7.40844444444445,NULL,NULL,'2013-01-07 03:28:15',56299.1446199999,19.3347,0.0941,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-12 18:20:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_snap_93825.gif',41326341537,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645724086,10089438,NULL,NULL,NULL,NULL),(9700,9593,0,'LSQ13ax','LSQ',146.896583333333,-7.40844444444445,NULL,NULL,'2013-01-07 05:28:05',56299.2278399998,19.3707,0.0929,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-12 18:20:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_snap_93826.gif',41326341537,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645724086,10089438,NULL,NULL,NULL,NULL),(9701,9596,0,'LSQ13at','LSQ',187.250791666667,-15.5085277777778,NULL,NULL,'2013-01-07 06:01:40',56299.25116,18.6426,0.0444,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_snap_93834.gif',43045835690,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,672591182,10509237,NULL,NULL,NULL,NULL),(9702,9596,0,'LSQ13at','LSQ',187.250708333333,-15.5084722222222,NULL,NULL,'2013-01-07 07:26:29',56299.31006,18.7047,0.0448,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_snap_93835.gif',43045835690,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,672591182,10509237,NULL,NULL,NULL,NULL),(9703,9602,0,'LSQ13as','LSQ',178.838833333333,-13.9714444444444,NULL,NULL,'2013-01-07 05:41:58',56299.2374800001,19.3181,0.0829,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_snap_93822.gif',40967582261,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,640118472,10001851,NULL,NULL,NULL,NULL),(9704,9602,0,'LSQ13as','LSQ',178.838791666667,-13.9714166666667,NULL,NULL,'2013-01-07 08:10:01',56299.3402900002,19.3197,0.0878,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_snap_93823.gif',40967582261,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,640118472,10001851,NULL,NULL,NULL,NULL),(9705,9606,0,'LSQ13ar','LSQ',173.712708333333,-15.8356111111111,NULL,NULL,'2013-01-07 05:38:35',56299.2351299999,20.353,0.1335,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ar/LSQ13ar_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ar/LSQ13ar_snap_93821.gif',40974652544,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640228946,10003577,NULL,NULL,NULL,NULL),(9706,9608,0,'LSQ13ag','LSQ',75.5496666666667,-17.9771666666667,NULL,NULL,'2013-01-07 02:24:32',56299.1003800002,17.9057,0.0352,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_snap_93814.gif',37553411726,NULL,NULL,NULL,'2012-12-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,586772058,9168313,NULL,NULL,NULL,NULL),(9707,9608,0,'LSQ13ag','LSQ',75.5496666666667,-17.9771666666667,NULL,NULL,'2013-01-07 04:32:51',56299.1894899998,17.8339,0.0371,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_snap_93815.gif',37553411726,NULL,NULL,NULL,'2012-12-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,586772058,9168313,NULL,NULL,NULL,NULL),(9708,9615,0,'LSQ13ae','LSQ',69.1568333333333,-18.6028055555556,NULL,NULL,'2013-01-07 02:11:02',56299.091,20.3178,0.1451,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ae/LSQ13ae_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ae/LSQ13ae_snap_93788.gif',37364625948,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583822280,9122223,NULL,NULL,NULL,NULL),(9709,9615,0,'LSQ13ae','LSQ',69.157,-18.6027222222222,NULL,NULL,'2013-01-07 04:19:19',56299.1800899999,20.0095,0.135,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ae/LSQ13ae_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ae/LSQ13ae_snap_93789.gif',37364625948,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583822280,9122223,NULL,NULL,NULL,NULL),(9710,9617,0,'LSQ13ad','LSQ',54.2686666666667,-17.5794166666667,NULL,NULL,'2013-01-07 01:33:36',56299.06501,19.7818,0.078,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ad/LSQ13ad_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ad/LSQ13ad_snap_93790.gif',38013957787,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,593968090,9280751,NULL,NULL,NULL,NULL),(9711,9617,0,'LSQ13ad','LSQ',54.2687083333333,-17.5794444444444,NULL,NULL,'2013-01-07 03:34:41',56299.14909,19.6153,0.0854,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 15:45:42','2013-01-07 15:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ad/LSQ13ad_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ad/LSQ13ad_snap_93791.gif',38013957787,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,593968090,9280751,NULL,NULL,NULL,NULL),(9712,9035,0,'LSQ12hyv','LSQ',63.7127916666667,-16.2166944444444,NULL,NULL,'2013-01-05 03:58:40',56297.1657500002,19.2083,0.1266,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 16:45:41','2013-01-07 16:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_snap_94155.gif',36871504846,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576117263,9001832,NULL,NULL,NULL,NULL),(9713,9713,1,'LSQ13bo','LSQ',161.640833333333,-17.6445555555556,NULL,NULL,'2013-01-05 06:51:42',56297.2859100001,20.267,0.1473,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 17:45:41','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bo/LSQ13bo_history.html','sn nice',NULL,0.112181,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bo/LSQ13bo_snap_94220.gif',41860113198,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,654064268,10219754,NULL,NULL,NULL,NULL),(9714,9713,0,'LSQ13bo','LSQ',161.640833333333,-17.6445555555556,NULL,NULL,'2013-01-07 04:48:11',56299.2001299998,20.575,0.1554,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 17:45:41','2013-01-07 17:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bo/LSQ13bo_history.html','sn nice',NULL,0.112181,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bo/LSQ13bo_snap_94164.gif',41860113198,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,654064268,10219754,NULL,NULL,NULL,NULL),(9715,9713,0,'LSQ13bo','LSQ',161.640791666667,-17.6445277777778,NULL,NULL,'2013-01-07 06:51:32',56299.2857900001,20.3419,0.1547,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 17:45:41','2013-01-07 17:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bo/LSQ13bo_history.html','sn nice',NULL,0.112181,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bo/LSQ13bo_snap_94165.gif',41860113198,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,654064268,10219754,NULL,NULL,NULL,NULL),(9716,9716,1,'LSQ13bn','LSQ',75.2495833333333,-17.74,NULL,NULL,'2013-01-03 02:51:13',56295.1189100002,19.9297,0.1158,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 17:45:41','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_history.html','sn nice',NULL,0.056389,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_snap_94217.gif',37570931536,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587045805,9172590,NULL,NULL,NULL,NULL),(9717,9716,0,'LSQ13bn','LSQ',75.2497083333333,-17.7399722222222,NULL,NULL,'2013-01-03 04:55:01',56295.2048800001,19.3156,0.1196,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 17:45:41','2013-01-07 17:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_history.html','sn nice',NULL,0.056389,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_snap_94218.gif',37570931536,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587045805,9172590,NULL,NULL,NULL,NULL),(9718,9716,0,'LSQ13bn','LSQ',75.2496666666667,-17.7400277777778,NULL,NULL,'2013-01-05 04:41:09',56297.1952499999,18.8939,0.094,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 17:45:41','2013-01-07 17:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_history.html','sn nice',NULL,0.056389,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_snap_94219.gif',37570931536,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587045805,9172590,NULL,NULL,NULL,NULL),(9719,9716,0,'LSQ13bn','LSQ',75.2497083333333,-17.7400277777778,NULL,NULL,'2013-01-07 02:24:32',56299.1003800002,19.1934,0.0769,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 17:45:41','2013-01-07 17:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_history.html','sn nice',NULL,0.056389,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_snap_94162.gif',37570931536,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587045805,9172590,NULL,NULL,NULL,NULL),(9720,9716,0,'LSQ13bn','LSQ',75.2496666666667,-17.7400277777778,NULL,NULL,'2013-01-07 04:32:51',56299.1894899998,19.6162,0.1052,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 17:45:41','2013-01-07 17:45:41','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_history.html','sn nice',NULL,0.056389,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_snap_94163.gif',37570931536,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587045805,9172590,NULL,NULL,NULL,NULL),(9721,9721,1,'LSQ13dg','LSQ',188.178083333333,-15.9291388888889,NULL,NULL,'2013-01-05 06:08:27',56297.25587,18.9715,0.1935,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dg/LSQ13dg_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dg/LSQ13dg_snap_94383.gif',43931014257,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686422097,10725345,NULL,NULL,NULL,NULL),(9722,9721,0,'LSQ13dg','LSQ',188.177958333333,-15.9292222222222,NULL,NULL,'2013-01-07 06:01:40',56299.25116,19.3029,0.096,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dg/LSQ13dg_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dg/LSQ13dg_snap_94342.gif',43931014257,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686422097,10725345,NULL,NULL,NULL,NULL),(9723,9721,0,'LSQ13dg','LSQ',188.178125,-15.92925,NULL,NULL,'2013-01-07 07:26:29',56299.31006,19.4103,0.0893,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dg/LSQ13dg_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dg/LSQ13dg_snap_94343.gif',43931014250,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686422097,10725345,NULL,NULL,NULL,NULL),(9724,9724,1,'LSQ13de','LSQ',55.0323333333333,-20.1699166666667,NULL,NULL,'2013-01-05 03:39:57',56297.1527499999,19.9569,0.0922,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13de/LSQ13de_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13de/LSQ13de_snap_94379.gif',38050214866,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594534607,9289603,NULL,NULL,NULL,NULL),(9725,9724,0,'LSQ13de','LSQ',55.0324583333333,-20.1698888888889,NULL,NULL,'2013-01-07 01:33:36',56299.06501,19.8156,0.0891,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13de/LSQ13de_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13de/LSQ13de_snap_94338.gif',38050214866,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594534607,9289603,NULL,NULL,NULL,NULL),(9726,9724,0,'LSQ13de','LSQ',55.0324166666667,-20.1699166666667,NULL,NULL,'2013-01-07 03:34:41',56299.14909,19.7243,0.0963,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13de/LSQ13de_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13de/LSQ13de_snap_94339.gif',38050214866,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594534607,9289603,NULL,NULL,NULL,NULL),(9727,9727,1,'LSQ13dd','LSQ',200.746208333333,-17.6014722222222,NULL,NULL,'2013-01-05 08:48:40',56297.3671300001,18.5433,0.1171,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dd/LSQ13dd_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dd/LSQ13dd_snap_94378.gif',43779846168,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,684060096,10688439,NULL,NULL,NULL,NULL),(9728,9727,0,'LSQ13dd','LSQ',200.746125,-17.6015555555556,NULL,NULL,'2013-01-07 08:31:07',56299.3549500001,19.372,0.0817,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dd/LSQ13dd_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dd/LSQ13dd_snap_94336.gif',43779846168,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,684060096,10688439,NULL,NULL,NULL,NULL),(9729,9727,0,'LSQ13dd','LSQ',200.746166666667,-17.6015555555556,NULL,NULL,'2013-01-07 08:41:19',56299.36203,19.3874,0.0935,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dd/LSQ13dd_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dd/LSQ13dd_snap_94337.gif',43779846168,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,684060096,10688439,NULL,NULL,NULL,NULL),(9730,9730,1,'LSQ13db','LSQ',171.275041666667,-10.7558333333333,NULL,NULL,'2012-12-24 07:29:47',56285.3123499998,20.3505,0.1742,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13db/LSQ13db_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13db/LSQ13db_snap_94374.gif',41010660284,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640791566,10012368,NULL,NULL,NULL,NULL),(9731,9730,0,'LSQ13db','LSQ',171.275,-10.7557777777778,NULL,NULL,'2012-12-28 06:36:39',56289.2754600001,19.7038,0.1597,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13db/LSQ13db_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13db/LSQ13db_snap_94375.gif',41010660284,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640791566,10012368,NULL,NULL,NULL,NULL),(9732,9730,0,'LSQ13db','LSQ',171.274916666667,-10.7557777777778,NULL,NULL,'2013-01-05 06:27:57',56297.2694100002,19.8563,0.1454,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13db/LSQ13db_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13db/LSQ13db_snap_94376.gif',41010660284,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640791566,10012368,NULL,NULL,NULL,NULL),(9733,9730,0,'LSQ13db','LSQ',171.274958333333,-10.75575,NULL,NULL,'2013-01-05 07:38:42',56297.31855,19.6348,0.1252,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13db/LSQ13db_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13db/LSQ13db_snap_94377.gif',41010660284,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640791566,10012368,NULL,NULL,NULL,NULL),(9734,9730,0,'LSQ13db','LSQ',171.275083333333,-10.7558055555556,NULL,NULL,'2013-01-07 06:28:34',56299.2698400002,20.0423,0.1105,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13db/LSQ13db_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13db/LSQ13db_snap_94332.gif',41010660284,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640791566,10012368,NULL,NULL,NULL,NULL),(9735,9730,0,'LSQ13db','LSQ',171.274916666667,-10.7556944444444,NULL,NULL,'2013-01-07 07:40:08',56299.3195400001,19.6665,0.1145,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13db/LSQ13db_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13db/LSQ13db_snap_94333.gif',41010660284,NULL,NULL,NULL,'2012-06-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640791566,10012368,NULL,NULL,NULL,NULL),(9736,9736,1,'LSQ13cz','LSQ',165.532125,-7.94677777777778,NULL,NULL,'2012-12-15 06:14:12',56276.2598700002,20.4037,0.1166,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_snap_94368.gif',40895593015,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,638993640,9984275,NULL,NULL,NULL,NULL),(9737,9736,0,'LSQ13cz','LSQ',165.532166666667,-7.94666666666667,NULL,NULL,'2012-12-15 07:54:18',56276.32938,20.4467,0.1245,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_snap_94369.gif',40895593015,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,638993640,9984275,NULL,NULL,NULL,NULL),(9738,9736,0,'LSQ13cz','LSQ',165.532166666667,-7.94680555555556,NULL,NULL,'2012-12-21 05:46:45',56282.2408099999,20.7013,0.1463,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_snap_94370.gif',40895593015,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,638993640,9984275,NULL,NULL,NULL,NULL),(9739,9736,0,'LSQ13cz','LSQ',165.532208333333,-7.94677777777778,NULL,NULL,'2012-12-21 07:12:31',56282.3003699998,20.527,0.1253,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_snap_94371.gif',40895593015,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,638993640,9984275,NULL,NULL,NULL,NULL),(9740,9736,0,'LSQ13cz','LSQ',165.532083333333,-7.94677777777778,NULL,NULL,'2012-12-24 08:07:59',56285.3388800002,20.5149,0.1202,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_snap_94372.gif',40895593015,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,638993640,9984275,NULL,NULL,NULL,NULL),(9741,9736,0,'LSQ13cz','LSQ',165.532083333333,-7.94672222222222,NULL,NULL,'2013-01-05 08:06:58',56297.33818,20.452,0.1459,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_snap_94373.gif',40895593015,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,638993640,9984275,NULL,NULL,NULL,NULL),(9742,9736,0,'LSQ13cz','LSQ',165.532125,-7.94675,NULL,NULL,'2013-01-07 06:12:33',56299.2587199998,20.2838,0.1665,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_snap_94328.gif',40895593015,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,638993640,9984275,NULL,NULL,NULL,NULL),(9743,9736,0,'LSQ13cz','LSQ',165.532083333333,-7.94680555555556,NULL,NULL,'2013-01-07 07:57:50',56299.3318400001,19.9408,0.0876,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_snap_94329.gif',40895593015,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,638993640,9984275,NULL,NULL,NULL,NULL),(9744,9744,1,'LSQ13cv','LSQ',144.436041666667,-10.6307777777778,NULL,NULL,'2013-01-03 03:31:13',56295.1466799998,19.3663,0.1412,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_snap_94346.gif',41307885070,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645435704,10084932,NULL,NULL,NULL,NULL),(9745,9744,0,'LSQ13cv','LSQ',144.436208333333,-10.63075,NULL,NULL,'2013-01-03 05:33:17',56295.2314499998,19.2818,0.1602,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_snap_94347.gif',41307885057,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645435704,10084932,NULL,NULL,NULL,NULL),(9746,9744,0,'LSQ13cv','LSQ',144.436208333333,-10.6307222222222,NULL,NULL,'2013-01-05 03:24:12',56297.1418099999,19.5922,0.0912,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_snap_94348.gif',41307885057,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645435704,10084932,NULL,NULL,NULL,NULL),(9747,9744,0,'LSQ13cv','LSQ',144.436041666667,-10.6307222222222,NULL,NULL,'2013-01-05 05:23:34',56297.2247100002,19.4794,0.0923,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_snap_94349.gif',41307885070,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645435704,10084932,NULL,NULL,NULL,NULL),(9748,9744,0,'LSQ13cv','LSQ',144.436125,-10.63075,NULL,NULL,'2013-01-07 03:15:15',56299.1356000002,19.6633,0.1127,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_snap_94320.gif',41307885070,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645435704,10084932,NULL,NULL,NULL,NULL),(9749,9744,0,'LSQ13cv','LSQ',144.436,-10.6306388888889,NULL,NULL,'2013-01-07 05:15:39',56299.2192099998,19.4581,0.0684,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_snap_94321.gif',41307885070,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645435704,10084932,NULL,NULL,NULL,NULL),(9750,9750,1,'LSQ13cu','LSQ',67.0929583333333,-8.68988888888889,NULL,NULL,'2013-01-03 03:11:32',56295.13301,20.0962,0.1169,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cu/LSQ13cu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cu/LSQ13cu_snap_94344.gif',37473429797,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585522340,9148786,NULL,NULL,NULL,NULL),(9751,9750,0,'LSQ13cu','LSQ',67.093,-8.68986111111111,NULL,NULL,'2013-01-05 01:59:06',56297.0827100002,21.2994,0.1698,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cu/LSQ13cu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cu/LSQ13cu_snap_94345.gif',37473429797,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585522340,9148786,NULL,NULL,NULL,NULL),(9752,9750,0,'LSQ13cu','LSQ',67.093,-8.68986111111111,NULL,NULL,'2013-01-07 01:54:03',56299.0792100001,20.5857,0.1546,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cu/LSQ13cu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cu/LSQ13cu_snap_94318.gif',37473429797,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585522340,9148786,NULL,NULL,NULL,NULL),(9753,9750,0,'LSQ13cu','LSQ',67.092875,-8.68983333333333,NULL,NULL,'2013-01-07 03:53:20',56299.1620399999,20.0975,0.125,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 18:45:44','2013-01-07 18:45:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cu/LSQ13cu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cu/LSQ13cu_snap_94319.gif',37473429797,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585522340,9148786,NULL,NULL,NULL,NULL),(9754,9754,1,'LSQ13cn','LSQ',192.124958333333,-15.0680555555556,NULL,NULL,'2013-01-07 06:17:49',56299.2623800002,20.2095,0.1595,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cn/LSQ13cn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cn/LSQ13cn_snap_94214.gif',43962702759,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,686917230,10733081,NULL,NULL,NULL,NULL),(9755,9754,0,'LSQ13cn','LSQ',192.125083333333,-15.0680277777778,NULL,NULL,'2013-01-07 07:34:54',56299.3159099999,19.6698,0.1114,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cn/LSQ13cn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cn/LSQ13cn_snap_94215.gif',43962702759,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,686917230,10733081,NULL,NULL,NULL,NULL),(9756,9756,1,'LSQ13cm','LSQ',193.145125,-15.7600555555556,NULL,NULL,'2013-01-03 06:45:13',56295.2814099998,19.7885,0.1729,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cm/LSQ13cm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cm/LSQ13cm_snap_94305.gif',43964652281,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,686947691,10733557,NULL,NULL,NULL,NULL),(9757,9756,0,'LSQ13cm','LSQ',193.145166666667,-15.7600833333333,NULL,NULL,'2013-01-07 06:17:49',56299.2623800002,19.6997,0.1069,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cm/LSQ13cm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cm/LSQ13cm_snap_94212.gif',43964652281,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,686947691,10733557,NULL,NULL,NULL,NULL),(9758,9756,0,'LSQ13cm','LSQ',193.145166666667,-15.7600555555556,NULL,NULL,'2013-01-07 07:34:54',56299.3159099999,19.8129,0.1098,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cm/LSQ13cm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cm/LSQ13cm_snap_94213.gif',43964652281,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,686947691,10733557,NULL,NULL,NULL,NULL),(9759,9759,1,'LSQ13ci','LSQ',185.96925,-13.5924444444444,NULL,NULL,'2012-12-28 06:38:26',56289.2766900002,18.5622,0.1086,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ci/LSQ13ci_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ci/LSQ13ci_snap_94295.gif',43038948445,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,672483569,10507555,NULL,NULL,NULL,NULL),(9760,9759,0,'LSQ13ci','LSQ',185.969208333333,-13.5923611111111,NULL,NULL,'2013-01-03 06:36:46',56295.2755399998,18.7366,0.1634,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ci/LSQ13ci_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ci/LSQ13ci_snap_94296.gif',43038948445,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,672483569,10507555,NULL,NULL,NULL,NULL),(9761,9759,0,'LSQ13ci','LSQ',185.969916666667,-13.5920555555556,NULL,NULL,'2013-01-07 06:01:40',56299.25116,18.904,0.1334,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ci/LSQ13ci_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ci/LSQ13ci_snap_94204.gif',43038948434,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,672483569,10507555,NULL,NULL,NULL,NULL),(9762,9759,0,'LSQ13ci','LSQ',185.969708333333,-13.5919722222222,NULL,NULL,'2013-01-07 07:26:29',56299.31006,20.1107,0.1514,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ci/LSQ13ci_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ci/LSQ13ci_snap_94205.gif',43038948434,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,672483569,10507555,NULL,NULL,NULL,NULL),(9763,9721,0,'LSQ13ch','LSQ',188.205,-15.9301388888889,NULL,NULL,'2012-12-28 06:38:26',56289.2766900002,16.7281,0.0246,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_snap_94297.gif',43931019429,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686422178,10725346,NULL,NULL,NULL,NULL),(9764,9721,0,'LSQ13ch','LSQ',188.204958333333,-15.9301388888889,NULL,NULL,'2012-12-28 07:58:21',56289.33219,16.6734,0.0201,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_snap_94298.gif',43931019429,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686422178,10725346,NULL,NULL,NULL,NULL),(9765,9721,0,'LSQ13ch','LSQ',188.205,-15.9301388888889,NULL,NULL,'2013-01-03 06:36:46',56295.2755399998,16.7203,0.0204,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_snap_94299.gif',43931019429,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686422178,10725346,NULL,NULL,NULL,NULL),(9766,9721,0,'LSQ13ch','LSQ',188.205041666667,-15.9301111111111,NULL,NULL,'2013-01-03 07:59:02',56295.3326699999,16.6831,0.0186,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_snap_94300.gif',43931019429,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686422178,10725346,NULL,NULL,NULL,NULL),(9767,9721,0,'LSQ13ch','LSQ',188.205041666667,-15.9301388888889,NULL,NULL,'2013-01-05 06:08:27',56297.25587,16.6281,0.0234,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_snap_94301.gif',43931019429,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686422178,10725346,NULL,NULL,NULL,NULL),(9768,9721,0,'LSQ13ch','LSQ',188.204958333333,-15.9301388888889,NULL,NULL,'2013-01-05 08:08:46',56297.3394300002,16.6577,0.0226,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_snap_94302.gif',43931019429,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686422178,10725346,NULL,NULL,NULL,NULL),(9769,9721,0,'LSQ13ch','LSQ',188.204916666667,-15.9301111111111,NULL,NULL,'2013-01-07 06:01:40',56299.25116,16.6711,0.0127,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_snap_94202.gif',43931019429,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686422178,10725346,NULL,NULL,NULL,NULL),(9770,9721,0,'LSQ13ch','LSQ',188.205,-15.9301111111111,NULL,NULL,'2013-01-07 07:26:29',56299.31006,16.696,0.0119,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_snap_94203.gif',43931019429,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686422178,10725346,NULL,NULL,NULL,NULL),(9771,9771,1,'LSQ13cg','LSQ',184.313833333333,-14.3307222222222,NULL,NULL,'2012-12-24 07:48:43',56285.3254999998,19.5901,0.13,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_snap_94291.gif',43082327559,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,673161368,10518146,NULL,NULL,NULL,NULL),(9772,9771,0,'LSQ13cg','LSQ',184.31375,-14.3304166666667,NULL,NULL,'2012-12-28 08:05:09',56289.3369200001,18.7425,0.1621,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_snap_94292.gif',43082327557,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,673161368,10518146,NULL,NULL,NULL,NULL),(9773,9771,0,'LSQ13cg','LSQ',184.313958333333,-14.3305555555556,NULL,NULL,'2013-01-03 07:37:45',56295.3178900001,19.2818,0.1951,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_snap_94293.gif',43082327559,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,673161368,10518146,NULL,NULL,NULL,NULL),(9774,9771,0,'LSQ13cg','LSQ',184.313541666667,-14.3303611111111,NULL,NULL,'2013-01-05 05:51:57',56297.2444099998,18.5036,0.144,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_snap_94294.gif',43082327557,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,673161368,10518146,NULL,NULL,NULL,NULL),(9775,9771,0,'LSQ13cg','LSQ',184.313583333333,-14.3305,NULL,NULL,'2013-01-07 05:47:02',56299.2409999999,19.4947,0.119,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_snap_94200.gif',43082327557,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,673161368,10518146,NULL,NULL,NULL,NULL),(9776,9771,0,'LSQ13cg','LSQ',184.313625,-14.3305277777778,NULL,NULL,'2013-01-07 07:18:54',56299.3048,19.5317,0.1382,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_snap_94201.gif',43082327557,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,673161368,10518146,NULL,NULL,NULL,NULL),(9777,9777,1,'LSQ13cf','LSQ',181.015916666667,-15.4947777777778,NULL,NULL,'2013-01-05 08:24:12',56297.3501400002,19.5608,0.1423,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cf/LSQ13cf_history.html','sn?',NULL,0.106417,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cf/LSQ13cf_snap_94290.gif',43058357343,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,672786833,10512294,NULL,NULL,NULL,NULL),(9778,9777,0,'LSQ13cf','LSQ',181.015875,-15.4948055555556,NULL,NULL,'2013-01-07 05:41:58',56299.2374800001,19.2697,0.1533,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cf/LSQ13cf_history.html','sn?',NULL,0.106417,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cf/LSQ13cf_snap_94198.gif',43058357343,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,672786833,10512294,NULL,NULL,NULL,NULL),(9779,9777,0,'LSQ13cf','LSQ',181.015791666667,-15.4946944444444,NULL,NULL,'2013-01-07 08:10:01',56299.3402900002,20.1412,0.1697,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cf/LSQ13cf_history.html','sn?',NULL,0.106417,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cf/LSQ13cf_snap_94199.gif',43058357343,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,672786833,10512294,NULL,NULL,NULL,NULL),(9780,9780,1,'LSQ13ce','LSQ',169.457958333333,-13.2116666666667,NULL,NULL,'2012-12-24 08:18:11',56285.3459700001,19.3494,0.1343,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_snap_94285.gif',41695045191,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651485081,10179454,NULL,NULL,NULL,NULL),(9781,9780,0,'LSQ13ce','LSQ',169.457875,-13.2120555555556,NULL,NULL,'2012-12-28 05:45:17',56289.23979,19.0442,0.2062,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_snap_94286.gif',41695045189,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651485081,10179454,NULL,NULL,NULL,NULL),(9782,9780,0,'LSQ13ce','LSQ',169.457875,-13.212,NULL,NULL,'2012-12-28 07:13:41',56289.30118,18.7058,0.1545,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_snap_94287.gif',41695045189,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651485081,10179454,NULL,NULL,NULL,NULL),(9783,9780,0,'LSQ13ce','LSQ',169.458,-13.2120555555556,NULL,NULL,'2013-01-05 05:32:27',56297.2308700001,17.6052,0.0705,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_snap_94288.gif',41695045189,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651485081,10179454,NULL,NULL,NULL,NULL),(9784,9780,0,'LSQ13ce','LSQ',169.457958333333,-13.2121111111111,NULL,NULL,'2013-01-05 07:10:24',56297.2988999998,18.3296,0.086,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_snap_94289.gif',41695045189,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651485081,10179454,NULL,NULL,NULL,NULL),(9785,9780,0,'LSQ13ce','LSQ',169.457791666667,-13.2120555555556,NULL,NULL,'2013-01-07 05:35:12',56299.2327800002,18.5878,0.0527,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_snap_94196.gif',41695045189,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651485081,10179454,NULL,NULL,NULL,NULL),(9786,9780,0,'LSQ13ce','LSQ',169.457958333333,-13.2120833333333,NULL,NULL,'2013-01-07 08:13:24',56299.34265,18.3886,0.0434,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_snap_94197.gif',41695045189,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651485081,10179454,NULL,NULL,NULL,NULL),(9787,9787,1,'LSQ13cc','LSQ',155.473833333333,-15.1203611111111,NULL,NULL,'2012-12-24 08:30:01',56285.3541799998,20.7211,0.2136,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_snap_94270.gif',41655946567,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650874165,10169908,NULL,NULL,NULL,NULL),(9788,9787,0,'LSQ13cc','LSQ',155.47375,-15.1203333333333,NULL,NULL,'2013-01-03 06:06:02',56295.2541999999,19.8076,0.1547,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_snap_94271.gif',41655946567,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650874165,10169908,NULL,NULL,NULL,NULL),(9789,9787,0,'LSQ13cc','LSQ',155.473833333333,-15.1203611111111,NULL,NULL,'2013-01-05 05:09:48',56297.2151500001,19.6553,0.1168,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_snap_94272.gif',41655946567,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650874165,10169908,NULL,NULL,NULL,NULL),(9790,9787,0,'LSQ13cc','LSQ',155.47375,-15.1203888888889,NULL,NULL,'2013-01-05 08:32:40',56297.3560299999,19.8139,0.1736,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_snap_94273.gif',41655946567,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650874165,10169908,NULL,NULL,NULL,NULL),(9791,9787,0,'LSQ13cc','LSQ',155.473875,-15.1202777777778,NULL,NULL,'2013-01-07 05:05:20',56299.2120400001,20.0988,0.1351,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_snap_94192.gif',41655946567,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650874165,10169908,NULL,NULL,NULL,NULL),(9792,9787,0,'LSQ13cc','LSQ',155.473875,-15.1202777777778,NULL,NULL,'2013-01-07 07:01:48',56299.2929199999,19.86,0.1302,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_snap_94193.gif',41655946567,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650874165,10169908,NULL,NULL,NULL,NULL),(9793,9793,1,'LSQ13cb','LSQ',155.630166666667,-12.0889722222222,NULL,NULL,'2012-12-28 08:31:09',56289.3549700002,18.3913,0.1543,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_history.html','sn nice',NULL,0.036025,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_snap_94266.gif',41825602641,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653525041,10211328,NULL,NULL,NULL,NULL),(9794,9793,0,'LSQ13cb','LSQ',155.630333333333,-12.0888333333333,NULL,NULL,'2013-01-03 06:06:02',56295.2541999999,19.1445,0.1326,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_history.html','sn nice',NULL,0.036025,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_snap_94267.gif',41825602641,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653525041,10211328,NULL,NULL,NULL,NULL),(9795,9793,0,'LSQ13cb','LSQ',155.630291666667,-12.0888333333333,NULL,NULL,'2013-01-05 05:09:48',56297.2151500001,19.6112,0.1277,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_history.html','sn nice',NULL,0.036025,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_snap_94268.gif',41825602641,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653525041,10211328,NULL,NULL,NULL,NULL),(9796,9793,0,'LSQ13cb','LSQ',155.630291666667,-12.0888333333333,NULL,NULL,'2013-01-05 08:32:40',56297.3560299999,19.4087,0.1153,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_history.html','sn nice',NULL,0.036025,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_snap_94269.gif',41825602641,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653525041,10211328,NULL,NULL,NULL,NULL),(9797,9793,0,'LSQ13cb','LSQ',155.630291666667,-12.0888611111111,NULL,NULL,'2013-01-07 05:05:20',56299.2120400001,19.7925,0.141,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_history.html','sn nice',NULL,0.036025,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_snap_94190.gif',41825602641,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653525041,10211328,NULL,NULL,NULL,NULL),(9798,9793,0,'LSQ13cb','LSQ',155.630291666667,-12.0888333333333,NULL,NULL,'2013-01-07 07:01:48',56299.2929199999,18.9863,0.095,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_history.html','sn nice',NULL,0.036025,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_snap_94191.gif',41825602641,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653525041,10211328,NULL,NULL,NULL,NULL),(9799,9799,1,'LSQ13bz','LSQ',74.9265,-12.609,NULL,NULL,'2013-01-03 02:47:51',56295.1165700001,19.2785,0.1624,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bz/LSQ13bz_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bz/LSQ13bz_snap_94258.gif',37520793527,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586262398,9160349,NULL,NULL,NULL,NULL),(9800,9799,0,'LSQ13bz','LSQ',74.926625,-12.6091388888889,NULL,NULL,'2013-01-05 04:37:47',56297.1929100002,18.1434,0.0881,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bz/LSQ13bz_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bz/LSQ13bz_snap_94259.gif',37520793527,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586262398,9160349,NULL,NULL,NULL,NULL),(9801,9799,0,'LSQ13bz','LSQ',74.9264166666667,-12.6090555555556,NULL,NULL,'2013-01-07 02:21:09',56299.09803,17.6347,0.0565,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bz/LSQ13bz_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bz/LSQ13bz_snap_94186.gif',37520793527,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586262398,9160349,NULL,NULL,NULL,NULL),(9802,9799,0,'LSQ13bz','LSQ',74.9265,-12.6089722222222,NULL,NULL,'2013-01-07 04:29:29',56299.1871500001,19.1495,0.1674,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bz/LSQ13bz_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bz/LSQ13bz_snap_94187.gif',37520793527,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586262398,9160349,NULL,NULL,NULL,NULL),(9803,9803,0,'LSQ13by','LSQ',63.844875,-12.0710277777778,NULL,NULL,'2012-12-24 02:21:15',56285.0981000001,19.708,0.1817,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2019-10-12 20:41:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13by/LSQ13by_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13by/LSQ13by_snap_94254.gif',36979384256,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577802879,9028169,NULL,NULL,NULL,NULL),(9804,9803,0,'LSQ13by','LSQ',63.8446666666667,-12.0705277777778,NULL,NULL,'2013-01-03 03:14:55',56295.1353600002,18.8237,0.128,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13by/LSQ13by_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13by/LSQ13by_snap_94255.gif',36979384144,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577802877,9028169,NULL,NULL,NULL,NULL),(9805,9803,0,'LSQ13by','LSQ',63.8447083333333,-12.0706944444444,NULL,NULL,'2013-01-05 01:57:25',56297.0815400002,19.779,0.1234,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13by/LSQ13by_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13by/LSQ13by_snap_94256.gif',36979384144,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577802877,9028169,NULL,NULL,NULL,NULL),(9806,9803,0,'LSQ13by','LSQ',63.8453333333333,-12.0706666666667,NULL,NULL,'2013-01-05 03:58:40',56297.1657500002,19.7354,0.1186,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13by/LSQ13by_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13by/LSQ13by_snap_94257.gif',36979384144,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577802877,9028169,NULL,NULL,NULL,NULL),(9807,9803,0,'LSQ13by','LSQ',63.844625,-12.0705277777778,NULL,NULL,'2013-01-07 01:52:21',56299.07803,19.8694,0.1582,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13by/LSQ13by_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13by/LSQ13by_snap_94184.gif',36979384144,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577802877,9028169,NULL,NULL,NULL,NULL),(9808,9803,0,'LSQ13by','LSQ',63.8447083333333,-12.0706666666667,NULL,NULL,'2013-01-07 03:51:39',56299.1608699998,19.6812,0.1426,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13by/LSQ13by_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13by/LSQ13by_snap_94185.gif',36979384144,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577802877,9028169,NULL,NULL,NULL,NULL),(9809,9809,1,'LSQ13bx','LSQ',63.0635833333333,-16.2729722222222,NULL,NULL,'2012-12-24 02:19:33',56285.0969199999,18.7975,0.1034,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_snap_94242.gif',36870326957,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576098858,9001544,NULL,NULL,NULL,NULL),(9810,9809,0,'LSQ13bx','LSQ',63.0635,-16.2730555555556,NULL,NULL,'2012-12-24 04:20:51',56285.1811500001,18.8035,0.0989,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_snap_94243.gif',36870326957,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576098858,9001544,NULL,NULL,NULL,NULL),(9811,9809,0,'LSQ13bx','LSQ',63.0635833333333,-16.2729722222222,NULL,NULL,'2012-12-26 02:21:08',56287.0980199999,18.6846,0.157,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_snap_94244.gif',36870326957,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576098858,9001544,NULL,NULL,NULL,NULL),(9812,9809,0,'LSQ13bx','LSQ',63.0634583333333,-16.2729444444444,NULL,NULL,'2012-12-26 04:53:21',56287.2037200001,18.5447,0.1038,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_snap_94245.gif',36870326957,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576098858,9001544,NULL,NULL,NULL,NULL),(9813,9809,0,'LSQ13bx','LSQ',63.0635,-16.273,NULL,NULL,'2012-12-26 06:17:08',56287.2618999998,18.9782,0.1382,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_snap_94246.gif',36870326957,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576098858,9001544,NULL,NULL,NULL,NULL),(9814,9809,0,'LSQ13bx','LSQ',63.0634583333333,-16.2730277777778,NULL,NULL,'2012-12-28 02:21:33',56289.0983099998,19.2018,0.1813,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_snap_94247.gif',36870326957,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576098858,9001544,NULL,NULL,NULL,NULL),(9815,9809,0,'LSQ13bx','LSQ',63.0634166666667,-16.2730833333333,NULL,NULL,'2012-12-28 04:22:27',56289.1822600001,19.0698,0.1545,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_snap_94248.gif',36870326957,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576098858,9001544,NULL,NULL,NULL,NULL),(9816,9809,0,'LSQ13bx','LSQ',63.0634583333333,-16.2729722222222,NULL,NULL,'2012-12-30 02:20:37',56291.09766,19.0227,0.0985,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_snap_94249.gif',36870326957,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576098858,9001544,NULL,NULL,NULL,NULL),(9817,9809,0,'LSQ13bx','LSQ',63.0635,-16.273,NULL,NULL,'2012-12-30 04:25:54',56291.1846599998,18.9464,0.1525,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_snap_94250.gif',36870326957,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576098858,9001544,NULL,NULL,NULL,NULL),(9818,9809,0,'LSQ13bx','LSQ',63.0634583333333,-16.2730277777778,NULL,NULL,'2013-01-03 03:16:37',56295.1365399999,19.2464,0.0866,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_snap_94251.gif',36870326957,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576098858,9001544,NULL,NULL,NULL,NULL),(9819,9809,0,'LSQ13bx','LSQ',63.0634583333333,-16.2730555555556,NULL,NULL,'2013-01-05 01:55:43',56297.08036,19.6512,0.0879,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_snap_94252.gif',36870326957,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576098858,9001544,NULL,NULL,NULL,NULL),(9820,9809,0,'LSQ13bx','LSQ',63.0634166666667,-16.2730277777778,NULL,NULL,'2013-01-05 03:56:59',56297.1645800001,19.5128,0.0943,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_snap_94253.gif',36870326957,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576098858,9001544,NULL,NULL,NULL,NULL),(9821,9809,0,'LSQ13bx','LSQ',63.0635833333333,-16.2730555555556,NULL,NULL,'2013-01-07 01:50:40',56299.0768599999,19.7575,0.1051,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_snap_94182.gif',36870326957,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576098858,9001544,NULL,NULL,NULL,NULL),(9822,9809,0,'LSQ13bx','LSQ',63.0634583333333,-16.273,NULL,NULL,'2013-01-07 03:49:58',56299.1597000002,19.5538,0.0958,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_snap_94183.gif',36870326957,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576098858,9001544,NULL,NULL,NULL,NULL),(9823,9823,1,'LSQ13bw','LSQ',63.1323333333333,-16.0994444444444,NULL,NULL,'2012-12-24 02:19:33',56285.0969199999,19.0199,0.1361,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_snap_94233.gif',36870550198,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576102346,9001599,NULL,NULL,NULL,NULL),(9824,9823,0,'LSQ13bw','LSQ',63.1323333333333,-16.0995,NULL,NULL,'2012-12-24 04:20:51',56285.1811500001,19.3306,0.1653,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_snap_94234.gif',36870550198,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576102346,9001599,NULL,NULL,NULL,NULL),(9825,9823,0,'LSQ13bw','LSQ',63.1324166666667,-16.0993611111111,NULL,NULL,'2012-12-26 02:21:08',56287.0980199999,19.4563,0.1691,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_snap_94235.gif',36870550181,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576102346,9001599,NULL,NULL,NULL,NULL),(9826,9823,0,'LSQ13bw','LSQ',63.1322916666667,-16.0995,NULL,NULL,'2012-12-26 04:53:21',56287.2037200001,18.6999,0.1166,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_snap_94236.gif',36870550198,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576102346,9001599,NULL,NULL,NULL,NULL),(9827,9823,0,'LSQ13bw','LSQ',63.1324166666667,-16.0992777777778,NULL,NULL,'2012-12-28 02:21:33',56289.0983099998,19.4771,0.2001,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_snap_94237.gif',36870550181,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576102346,9001599,NULL,NULL,NULL,NULL),(9828,9823,0,'LSQ13bw','LSQ',63.132375,-16.0994444444444,NULL,NULL,'2012-12-30 02:20:37',56291.09766,19.5031,0.1708,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_snap_94238.gif',36870550198,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576102346,9001599,NULL,NULL,NULL,NULL),(9829,9823,0,'LSQ13bw','LSQ',63.132375,-16.0994166666667,NULL,NULL,'2012-12-30 04:25:54',56291.1846599998,19.2061,0.2121,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_snap_94239.gif',36870550198,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576102346,9001599,NULL,NULL,NULL,NULL),(9830,9823,0,'LSQ13bw','LSQ',63.1324583333333,-16.0993888888889,NULL,NULL,'2013-01-03 03:16:37',56295.1365399999,19.686,0.1396,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_snap_94240.gif',36870550181,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576102346,9001599,NULL,NULL,NULL,NULL),(9831,9823,0,'LSQ13bw','LSQ',63.132375,-16.0995555555556,NULL,NULL,'2013-01-05 01:55:43',56297.08036,19.8991,0.1291,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_snap_94241.gif',36870550198,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576102346,9001599,NULL,NULL,NULL,NULL),(9832,9823,0,'LSQ13bw','LSQ',63.1325,-16.0993611111111,NULL,NULL,'2013-01-07 01:50:40',56299.0768599999,19.5888,0.1547,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_snap_94180.gif',36870550181,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576102346,9001599,NULL,NULL,NULL,NULL),(9833,9823,0,'LSQ13bw','LSQ',63.132375,-16.0994722222222,NULL,NULL,'2013-01-07 03:49:58',56299.1597000002,19.7312,0.1435,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_snap_94181.gif',36870550198,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576102346,9001599,NULL,NULL,NULL,NULL),(9834,9834,1,'LSQ13bs','LSQ',189.22425,-19.8683333333333,NULL,NULL,'2013-01-03 06:22:50',56295.2658600002,18.9405,0.1509,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bs/LSQ13bs_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bs/LSQ13bs_snap_94227.gif',43954133567,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686783336,10730989,NULL,NULL,NULL,NULL),(9835,9834,0,'LSQ13bs','LSQ',189.22425,-19.8683055555556,NULL,NULL,'2013-01-03 07:41:08',56295.3202399998,18.626,0.1237,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bs/LSQ13bs_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bs/LSQ13bs_snap_94228.gif',43954133567,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686783336,10730989,NULL,NULL,NULL,NULL),(9836,9834,0,'LSQ13bs','LSQ',189.224166666667,-19.8682777777778,NULL,NULL,'2013-01-07 06:08:54',56299.2561900001,19.3335,0.1228,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bs/LSQ13bs_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bs/LSQ13bs_snap_94172.gif',43954133567,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686783336,10730989,NULL,NULL,NULL,NULL),(9837,9834,0,'LSQ13bs','LSQ',189.224333333333,-19.8683611111111,NULL,NULL,'2013-01-07 07:29:51',56299.3124000002,18.6391,0.0901,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bs/LSQ13bs_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bs/LSQ13bs_snap_94173.gif',43954133567,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686783336,10730989,NULL,NULL,NULL,NULL),(9838,9838,1,'LSQ13bp','LSQ',166.447375,-17.1760555555556,NULL,NULL,'2012-12-21 05:34:33',56282.23233,19.5542,0.1095,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bp/LSQ13bp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bp/LSQ13bp_snap_94221.gif',41864381299,NULL,NULL,NULL,'2012-12-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,654130957,10220796,NULL,NULL,NULL,NULL),(9839,9838,0,'LSQ13bp','LSQ',166.447291666667,-17.17625,NULL,NULL,'2013-01-03 06:59:03',56295.2910099998,19.9546,0.1855,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bp/LSQ13bp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bp/LSQ13bp_snap_94222.gif',41864381298,NULL,NULL,NULL,'2012-12-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,654130957,10220796,NULL,NULL,NULL,NULL),(9840,9838,0,'LSQ13bp','LSQ',166.4475,-17.1762222222222,NULL,NULL,'2013-01-07 04:51:35',56299.2024900001,20.0536,0.1695,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bp/LSQ13bp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bp/LSQ13bp_snap_94166.gif',41864381299,NULL,NULL,NULL,'2012-12-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,654130957,10220796,NULL,NULL,NULL,NULL),(9841,9838,0,'LSQ13bp','LSQ',166.447416666667,-17.1761666666667,NULL,NULL,'2013-01-07 08:25:45',56299.3512200001,19.368,0.133,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bp/LSQ13bp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bp/LSQ13bp_snap_94167.gif',41864381299,NULL,NULL,NULL,'2012-12-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,654130957,10220796,NULL,NULL,NULL,NULL),(9842,9842,1,'LSQ13bm','LSQ',58.0565833333333,-17.9240277777778,NULL,NULL,'2013-01-07 01:47:17',56299.0745100002,20.1114,0.1649,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bm/LSQ13bm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bm/LSQ13bm_snap_94160.gif',38009026472,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593891038,9279547,NULL,NULL,NULL,NULL),(9843,9842,0,'LSQ13bm','LSQ',58.056375,-17.9241388888889,NULL,NULL,'2013-01-07 03:46:35',56299.15735,19.6145,0.1662,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-07 19:45:46','2013-01-07 19:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bm/LSQ13bm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bm/LSQ13bm_snap_94161.gif',38009026472,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,593891038,9279547,NULL,NULL,NULL,NULL),(9844,9844,0,'PSNJ23284503-4119562','TOCP',352.187625,-41.3322777777778,NULL,NULL,'2013-01-05 10:48:00',56297.45,17.1,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2013-01-09 09:31:27','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/Current/20130105_736.html','supernova',NULL,0.005,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20010882/jpg/108820411354107041_20130105_01_4.jpg',NULL,NULL,50471017593,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,788609649,12322025,NULL,NULL,NULL,NULL),(9846,8875,0,'LSQ12hxo','LSQ',141.212666666667,21.6440555555556,NULL,NULL,'2013-01-09 04:49:50',56301.2012800002,19.2959,0.075,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxo/LSQ12hxo_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxo/LSQ12hxo_snap_94421.gif',63708583584,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,995446618,15553853,NULL,NULL,NULL,NULL),(9847,8875,0,'LSQ12hxo','LSQ',141.212625,21.6440555555556,NULL,NULL,'2013-01-09 06:49:11',56301.2841599998,19.2193,0.0729,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxo/LSQ12hxo_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxo/LSQ12hxo_snap_94422.gif',63708583584,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,995446618,15553853,NULL,NULL,NULL,NULL),(9848,8877,0,'LSQ12hxn','LSQ',141.16725,22.4339722222222,NULL,NULL,'2013-01-09 04:49:50',56301.2012800002,17.6807,0.0409,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxn/LSQ12hxn_history.html','sn nice',NULL,0.07849,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxn/LSQ12hxn_snap_94429.gif',63715766096,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,995558845,15555606,NULL,NULL,NULL,NULL),(9849,8877,0,'LSQ12hxn','LSQ',141.167333333333,22.4341944444444,NULL,NULL,'2013-01-09 06:49:11',56301.2841599998,18.3498,0.0426,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxn/LSQ12hxn_history.html','sn nice',NULL,0.07849,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxn/LSQ12hxn_snap_94430.gif',63715766096,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,995558845,15555606,NULL,NULL,NULL,NULL),(9850,8895,0,'LSQ12hxg','LSQ',62.9475833333333,-5.91902777777778,NULL,NULL,'2013-01-09 02:58:29',56301.1239499999,18.047,0.0293,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_94431.gif',36962123763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(9851,8915,0,'LSQ12hvy','LSQ',154.816458333333,-17.0151111111111,NULL,NULL,'2013-01-09 03:27:12',56301.1439,20.18,0.1396,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvy/LSQ12hvy_snap_94444.gif',41645999498,NULL,NULL,NULL,'2012-12-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650718742,10167480,NULL,NULL,NULL,NULL),(9852,9049,0,'LSQ12hyr','LSQ',64.062625,-10.9515277777778,NULL,NULL,'2013-01-09 02:44:57',56301.1145500001,20.08,0.081,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_history.html','sn',NULL,0.045375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_snap_94448.gif',36980827675,NULL,NULL,NULL,'2012-10-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577825432,9028522,NULL,NULL,NULL,NULL),(9853,9197,0,'LSQ12hzh','LSQ',66.447875,-8.60941666666667,NULL,NULL,'2013-01-09 02:41:34',56301.1121999999,19.4525,0.1344,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_snap_94499.gif',37473128013,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585517625,9148712,NULL,NULL,NULL,NULL),(9854,9386,0,'LSQ13b','LSQ',170.889708333333,-20.3369166666667,NULL,NULL,'2013-01-09 04:57:00',56301.2062599999,19.3441,0.0867,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_snap_94549.gif',41739726486,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,652183226,10190362,NULL,NULL,NULL,NULL),(9855,9386,0,'LSQ13b','LSQ',170.889625,-20.3369722222222,NULL,NULL,'2013-01-09 06:54:39',56301.2879599999,19.5345,0.0884,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_snap_94550.gif',41739726486,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,652183226,10190362,NULL,NULL,NULL,NULL),(9856,9397,0,'LSQ13h','LSQ',70.6753333333333,-14.6319722222222,NULL,NULL,'2013-01-09 02:16:07',56301.0945299999,20.5163,0.1168,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_snap_94558.gif',37544086545,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586626352,9166036,NULL,NULL,NULL,NULL),(9857,9397,0,'LSQ13h','LSQ',70.67525,-14.6319444444444,NULL,NULL,'2013-01-09 04:21:19',56301.1814700002,20.4218,0.1368,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_snap_94559.gif',37544086545,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586626352,9166036,NULL,NULL,NULL,NULL),(9858,9399,0,'LSQ13g','LSQ',194.92875,-19.7049166666667,NULL,NULL,'2013-01-09 06:22:22',56301.2655400001,18.641,0.0409,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13g/LSQ13g_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13g/LSQ13g_snap_94553.gif',43989620374,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,687337818,10739653,NULL,NULL,NULL,NULL),(9859,9399,0,'LSQ13g','LSQ',194.92875,-19.7049166666667,NULL,NULL,'2013-01-09 07:48:01',56301.3250199999,18.6461,0.0353,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:46','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13g/LSQ13g_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13g/LSQ13g_snap_94554.gif',43989620374,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,687337818,10739653,NULL,NULL,NULL,NULL),(9860,9584,0,'LSQ13ay','LSQ',149.695416666667,-7.59108333333333,NULL,NULL,'2013-01-09 03:20:26',56301.1392000001,20.0268,0.1605,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_snap_94423.gif',41333894671,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645842104,10091282,NULL,NULL,NULL,NULL),(9861,9584,0,'LSQ13ay','LSQ',149.695458333333,-7.59119444444444,NULL,NULL,'2013-01-09 05:21:38',56301.2233600002,20.051,0.1784,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_snap_94424.gif',41333894671,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645842104,10091282,NULL,NULL,NULL,NULL),(9862,9593,0,'LSQ13ax','LSQ',146.896625,-7.40841666666667,NULL,NULL,'2013-01-09 05:19:56',56301.22218,19.4091,0.0912,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-12 18:20:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_snap_94515.gif',41326341537,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645724086,10089438,NULL,NULL,NULL,NULL),(9863,9596,0,'LSQ13at','LSQ',187.250791666667,-15.5085277777778,NULL,NULL,'2013-01-09 07:53:06',56301.3285500002,18.7583,0.0357,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_snap_94516.gif',43045835690,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,672591182,10509237,NULL,NULL,NULL,NULL),(9864,9602,0,'LSQ13as','LSQ',178.838833333333,-13.9715,NULL,NULL,'2013-01-09 07:35:57',56301.3166399999,19.2781,0.0758,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_snap_94418.gif',40967582261,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,640118472,10001851,NULL,NULL,NULL,NULL),(9865,9602,0,'LSQ13as','LSQ',178.838791666667,-13.9714722222222,NULL,NULL,'2013-01-09 08:17:06',56301.3452099999,19.3969,0.093,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_snap_94419.gif',40967582261,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,640118472,10001851,NULL,NULL,NULL,NULL),(9866,9606,0,'LSQ13ar','LSQ',173.713,-15.8355277777778,NULL,NULL,'2013-01-09 07:32:34',56301.3142900001,20.0356,0.0987,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ar/LSQ13ar_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ar/LSQ13ar_snap_94420.gif',40974652544,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,640228946,10003577,NULL,NULL,NULL,NULL),(9867,9608,0,'LSQ13ag','LSQ',75.5496666666667,-17.9771666666667,NULL,NULL,'2013-01-09 02:26:14',56301.1015599999,17.8068,0.0357,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_snap_94517.gif',37553411726,NULL,NULL,NULL,'2012-12-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,586772058,9168313,NULL,NULL,NULL,NULL),(9868,9608,0,'LSQ13ag','LSQ',75.549625,-17.9771666666667,NULL,NULL,'2013-01-09 04:31:28',56301.1885299999,17.8382,0.0342,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_snap_94518.gif',37553411726,NULL,NULL,NULL,'2012-12-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,586772058,9168313,NULL,NULL,NULL,NULL),(9869,9713,0,'LSQ13bo','LSQ',161.640833333333,-17.6444444444444,NULL,NULL,'2013-01-09 04:46:05',56301.1986699998,20.1637,0.1091,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bo/LSQ13bo_history.html','sn nice',NULL,0.112181,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bo/LSQ13bo_snap_94481.gif',41860113198,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,654064268,10219754,NULL,NULL,NULL,NULL),(9870,9713,0,'LSQ13bo','LSQ',161.640666666667,-17.6446111111111,NULL,NULL,'2013-01-09 06:45:26',56301.28156,20.3628,0.1203,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bo/LSQ13bo_history.html','sn nice',NULL,0.112181,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bo/LSQ13bo_snap_94482.gif',41860113198,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,654064268,10219754,NULL,NULL,NULL,NULL),(9871,9716,0,'LSQ13bn','LSQ',75.2495833333333,-17.7399722222222,NULL,NULL,'2013-01-09 02:26:14',56301.1015599999,19.5593,0.094,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_history.html','sn nice',NULL,0.056389,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_snap_94540.gif',37570931536,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587045805,9172590,NULL,NULL,NULL,NULL),(9872,9716,0,'LSQ13bn','LSQ',75.2496666666667,-17.74,NULL,NULL,'2013-01-09 04:31:28',56301.1885299999,19.0799,0.0712,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_history.html','sn nice',NULL,0.056389,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_snap_94541.gif',37570931536,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587045805,9172590,NULL,NULL,NULL,NULL),(9873,9721,0,'LSQ13dg','LSQ',188.178083333333,-15.9291944444444,NULL,NULL,'2013-01-09 07:53:06',56301.3285500002,19.4177,0.1,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dg/LSQ13dg_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dg/LSQ13dg_snap_94509.gif',43931014250,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686422097,10725345,NULL,NULL,NULL,NULL),(9874,9727,0,'LSQ13dd','LSQ',200.746166666667,-17.6015555555556,NULL,NULL,'2013-01-09 07:16:57',56301.3034399999,19.4295,0.0699,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dd/LSQ13dd_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dd/LSQ13dd_snap_94538.gif',43779846168,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,684060096,10688439,NULL,NULL,NULL,NULL),(9875,9727,0,'LSQ13dd','LSQ',200.746208333333,-17.6015833333333,NULL,NULL,'2013-01-09 08:04:56',56301.3367599999,19.3181,0.0642,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dd/LSQ13dd_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dd/LSQ13dd_snap_94539.gif',43779846168,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,684060096,10688439,NULL,NULL,NULL,NULL),(9876,9744,0,'LSQ13cv','LSQ',144.436041666667,-10.63075,NULL,NULL,'2013-01-09 03:04:38',56301.1282199998,19.5885,0.0692,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_snap_94526.gif',41307885070,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645435704,10084932,NULL,NULL,NULL,NULL),(9877,9744,0,'LSQ13cv','LSQ',144.436125,-10.6306666666667,NULL,NULL,'2013-01-09 05:04:07',56301.2111999998,19.1874,0.0791,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_snap_94527.gif',41307885057,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645435704,10084932,NULL,NULL,NULL,NULL),(9878,9750,0,'LSQ13cu','LSQ',67.0929166666667,-8.68983333333333,NULL,NULL,'2013-01-09 02:44:57',56301.1145500001,20.8309,0.1817,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cu/LSQ13cu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cu/LSQ13cu_snap_94506.gif',37473429797,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585522340,9148786,NULL,NULL,NULL,NULL),(9879,9756,0,'LSQ13cm','LSQ',193.145166666667,-15.7600833333333,NULL,NULL,'2013-01-09 07:58:10',56301.33207,19.678,0.0839,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cm/LSQ13cm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cm/LSQ13cm_snap_94502.gif',43964652281,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,686947691,10733557,NULL,NULL,NULL,NULL),(9880,9721,0,'LSQ13ch','LSQ',188.204958333333,-15.9300833333333,NULL,NULL,'2013-01-09 07:53:06',56301.3285500002,16.6885,0.0104,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_snap_94503.gif',43931019429,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686422178,10725346,NULL,NULL,NULL,NULL),(9881,9771,0,'LSQ13cg','LSQ',184.313583333333,-14.3305,NULL,NULL,'2013-01-09 07:51:24',56301.3273700001,19.1677,0.1081,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_snap_94492.gif',43082327557,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,673161368,10518146,NULL,NULL,NULL,NULL),(9882,9780,0,'LSQ13ce','LSQ',169.457875,-13.2121111111111,NULL,NULL,'2013-01-09 07:22:21',56301.3071900001,18.7646,0.0377,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_snap_94451.gif',41695045189,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651485081,10179454,NULL,NULL,NULL,NULL),(9883,9780,0,'LSQ13ce','LSQ',169.457875,-13.2121111111111,NULL,NULL,'2013-01-09 08:10:19',56301.3404999999,18.8052,0.0369,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_snap_94452.gif',41695045189,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651485081,10179454,NULL,NULL,NULL,NULL),(9884,9787,0,'LSQ13cc','LSQ',155.473875,-15.1203055555556,NULL,NULL,'2013-01-09 05:14:52',56301.2186599998,20.0578,0.0977,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_snap_94475.gif',41655946567,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650874165,10169908,NULL,NULL,NULL,NULL),(9885,9787,0,'LSQ13cc','LSQ',155.473833333333,-15.1203055555556,NULL,NULL,'2013-01-09 07:03:13',56301.29391,20.1665,0.1279,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_snap_94476.gif',41655946567,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650874165,10169908,NULL,NULL,NULL,NULL),(9886,9793,0,'LSQ13cb','LSQ',155.630208333333,-12.0888611111111,NULL,NULL,'2013-01-09 05:14:52',56301.2186599998,18.866,0.084,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_history.html','sn nice',NULL,0.036025,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_snap_94469.gif',41825602641,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653525041,10211328,NULL,NULL,NULL,NULL),(9887,9799,0,'LSQ13bz','LSQ',74.9265416666667,-12.6090277777778,NULL,NULL,'2013-01-09 02:22:51',56301.0992100001,19.0939,0.1384,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bz/LSQ13bz_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bz/LSQ13bz_snap_94453.gif',37520793527,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586262398,9160349,NULL,NULL,NULL,NULL),(9888,9803,0,'LSQ13by','LSQ',63.844875,-12.0708055555556,NULL,NULL,'2013-01-09 02:50:01',56301.1180699999,19.8466,0.1444,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13by/LSQ13by_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13by/LSQ13by_snap_94450.gif',36979384144,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577802877,9028169,NULL,NULL,NULL,NULL),(9889,9809,0,'LSQ13bx','LSQ',63.0634583333333,-16.2730277777778,NULL,NULL,'2013-01-09 02:48:20',56301.1168999998,19.7653,0.1122,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_snap_94520.gif',36870326957,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576098858,9001544,NULL,NULL,NULL,NULL),(9890,9823,0,'LSQ13bw','LSQ',63.1323333333333,-16.0995,NULL,NULL,'2013-01-09 02:48:20',56301.1168999998,19.7856,0.1334,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bw/LSQ13bw_snap_94455.gif',36870550198,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576102346,9001599,NULL,NULL,NULL,NULL),(9891,9834,0,'LSQ13bs','LSQ',189.224291666667,-19.8682777777778,NULL,NULL,'2013-01-09 06:01:42',56301.2511900002,18.8421,0.0842,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bs/LSQ13bs_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bs/LSQ13bs_snap_94490.gif',43954133567,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686783336,10730989,NULL,NULL,NULL,NULL),(9892,9834,0,'LSQ13bs','LSQ',189.224666666667,-19.86825,NULL,NULL,'2013-01-09 07:29:10',56301.3119299999,19.3141,0.1074,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 16:45:42','2013-01-09 16:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bs/LSQ13bs_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bs/LSQ13bs_snap_94491.gif',43954133567,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686783336,10730989,NULL,NULL,NULL,NULL),(9893,9893,1,'LSQ13dm','LSQ',180.486375,-17.0239722222222,NULL,NULL,'2013-01-07 05:19:22',56299.2217899999,19.8103,0.1083,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 17:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dm/LSQ13dm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dm/LSQ13dm_snap_94700.gif',43025366247,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,672271347,10504239,NULL,NULL,NULL,NULL),(9894,9893,0,'LSQ13dm','LSQ',180.486375,-17.0240833333333,NULL,NULL,'2013-01-09 05:11:22',56301.2162299999,19.6134,0.1103,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 17:45:42','2013-01-09 17:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dm/LSQ13dm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dm/LSQ13dm_snap_94664.gif',43025366247,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,672271347,10504239,NULL,NULL,NULL,NULL),(9895,9893,0,'LSQ13dm','LSQ',180.486291666667,-17.0241111111111,NULL,NULL,'2013-01-09 07:01:25',56301.2926599998,19.3051,0.0649,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 17:45:42','2013-01-09 17:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dm/LSQ13dm_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dm/LSQ13dm_snap_94665.gif',43025366247,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,672271347,10504239,NULL,NULL,NULL,NULL),(9896,9896,1,'LSQ13di','LSQ',64.4084583333333,-18.2049166666667,NULL,NULL,'2013-01-07 02:00:50',56299.0839200001,20.7258,0.1717,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 17:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13di/LSQ13di_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13di/LSQ13di_snap_94691.gif',36847022794,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,575734731,8995855,NULL,NULL,NULL,NULL),(9897,9896,0,'LSQ13di','LSQ',64.408375,-18.205,NULL,NULL,'2013-01-09 02:34:42',56301.1074399999,19.5512,0.087,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 17:45:42','2013-01-09 17:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13di/LSQ13di_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13di/LSQ13di_snap_94656.gif',36847022842,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,575734731,8995855,NULL,NULL,NULL,NULL),(9898,9896,0,'LSQ13di','LSQ',64.4084166666667,-18.2049722222222,NULL,NULL,'2013-01-09 02:38:04',56301.1097800001,19.6781,0.1064,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 17:45:42','2013-01-09 17:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13di/LSQ13di_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13di/LSQ13di_snap_94657.gif',36847022789,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,575734731,8995855,NULL,NULL,NULL,NULL),(9899,9899,1,'LSQ13dh','LSQ',65.8625833333333,-20.6382222222222,NULL,NULL,'2013-01-07 02:00:50',56299.0839200001,20.1322,0.1743,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 17:45:42','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dh/LSQ13dh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dh/LSQ13dh_snap_94690.gif',37323734068,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583183344,9112239,NULL,NULL,NULL,NULL),(9900,9899,0,'LSQ13dh','LSQ',65.8623333333333,-20.6379722222222,NULL,NULL,'2013-01-09 02:34:42',56301.1074399999,19.5809,0.1518,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 17:45:42','2013-01-09 17:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dh/LSQ13dh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dh/LSQ13dh_snap_94654.gif',37323734068,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583183344,9112239,NULL,NULL,NULL,NULL),(9901,9899,0,'LSQ13dh','LSQ',65.8626666666667,-20.638,NULL,NULL,'2013-01-09 02:38:04',56301.1097800001,19.6283,0.1264,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-09 17:45:42','2013-01-09 17:45:42','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dh/LSQ13dh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dh/LSQ13dh_snap_94655.gif',37323734068,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583183344,9112239,NULL,NULL,NULL,NULL),(10328,10296,1,'OGLE-2013-SN-001','atel',11.626825,-65.138,NULL,NULL,'2013-01-08 02:24:00',56300.1,NULL,NULL,NULL,0.09,NULL,'Ia',NULL,'2013-01-10 09:15:55','2019-10-11 14:10:04','http://www.astronomerstelegram.org/?read=4721',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,36096724015,'du Pont 2.5m','WFCCD','J L Prieto','2012-07-03 09:15:27',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,564011312,8812676,NULL,NULL,NULL,NULL),(10329,10236,1,'OGLE-2013-SN-002','atel',20.8767375,-64.6619805556,NULL,NULL,'2013-01-08 02:24:00',56300.1,NULL,NULL,NULL,0.0722,NULL,'II',NULL,'2013-01-10 09:24:32','2019-10-11 14:10:04','http://www.astronomerstelegram.org/?read=4721',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,36345771998,'du Pont 2.5m','WFCCD','J L Prieto','2012-07-02 06:50:27',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,567902687,8873479,NULL,NULL,NULL,NULL),(10330,9844,0,'PSNJ23284503-4119562','atel',352.187625,-41.3322777778,NULL,NULL,'2013-01-08 00:57:36',56300.04,NULL,NULL,NULL,0.005,NULL,'Ibc',NULL,'2013-01-10 12:48:56','2013-01-10 12:48:56','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,50471017593,'du Pont 2.5m','WFCCD','J L Prieto',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,788609649,12322025,NULL,NULL,NULL,NULL),(10343,9844,0,'SN2013F','CBET',352.187625,-41.3322777777778,NULL,NULL,'2013-01-11 00:00:00',56303,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2000-01-01 00:00:00','2000-01-01 00:00:00','http://nesssi.cacr.caltech.edu/catalina/Current/20130105_736.html',NULL,NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20010882/jpg/108820411354107041_20130105_01_4.jpg',NULL,NULL,50471017593,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,788609649,12322025,NULL,NULL,NULL,NULL),(10344,9582,0,'LSQ13ba','atel',162.662416667,-10.8734722222,NULL,NULL,'2013-01-11 14:24:00',56303.6,NULL,NULL,NULL,0.09,NULL,'Ia',NULL,'2013-01-12 14:13:41','2013-01-12 18:20:44','http://www.astronomerstelegram.org/?read=4728',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41784370026,'UH 2.2m','SNIFS','SNfactory','2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,652880781,10201262,NULL,NULL,NULL,NULL),(10345,9593,0,'LSQ13ax','pessto',146.896625,-7.40836111111,NULL,NULL,'2013-01-12 07:11:59',56304.3,NULL,NULL,NULL,0.16,NULL,'Ia',NULL,'2013-01-12 17:49:53','2013-01-12 18:20:44','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41326341537,'NTT','EFOSC','Giorgos Leloudas and Mattias Ergon','2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645724086,10089438,NULL,NULL,NULL,NULL),(10346,8273,0,'LSQ12hos','pessto',161.536666667,-3.35930555556,NULL,NULL,'2013-01-12 08:24:00',56304.35,NULL,NULL,NULL,0.111,NULL,'Ia',NULL,'2013-01-12 17:51:02','2013-01-12 18:20:44','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,40876271258,'NTT','EFOSC','Girgos Leloudas and Mattias Ergon','2012-05-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,638691738,9979558,NULL,NULL,NULL,NULL),(10347,8228,0,'LSQ12hon','LSQ',57.893375,-24.2263611111111,NULL,NULL,'2013-01-08 01:36:50',56300.0672499998,20.1087,0.1533,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_94956.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(10348,8228,0,'LSQ12hon','LSQ',57.8934166666667,-24.2263888888889,NULL,NULL,'2013-01-08 03:35:45',56300.14983,20.2947,0.1739,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_94957.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(10349,8228,0,'LSQ12hon','LSQ',57.8932916666667,-24.2263611111111,NULL,NULL,'2013-01-10 02:40:22',56302.1113700001,20.3351,0.1758,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_95610.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(10350,8228,0,'LSQ12hon','LSQ',57.8934166666667,-24.2264166666667,NULL,NULL,'2013-01-10 02:45:38',56302.11503,20.1719,0.1663,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hon/LSQ12hon_snap_95611.gif',37994038644,NULL,NULL,NULL,'2012-12-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,593656853,9275888,NULL,NULL,NULL,NULL),(10351,8233,0,'LSQ12hnu','LSQ',56.402625,-37.7380555555556,NULL,NULL,'2013-01-08 01:30:05',56300.06256,20.3191,0.0899,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_94860.gif',38557895447,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(10352,8233,0,'LSQ12hnu','LSQ',56.4025833333333,-37.7380277777778,NULL,NULL,'2013-01-08 02:48:45',56300.1171900001,20.4096,0.0979,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_94861.gif',38557895447,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(10353,8233,0,'LSQ12hnu','LSQ',56.402625,-37.7380555555556,NULL,NULL,'2013-01-10 02:47:25',56302.1162700001,20.2538,0.0906,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_95356.gif',38557895447,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(10354,8233,0,'LSQ12hnu','LSQ',56.4025833333333,-37.7380277777778,NULL,NULL,'2013-01-10 02:50:47',56302.1186099998,20.4277,0.0969,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hnu/LSQ12hnu_snap_95357.gif',38557895447,NULL,NULL,NULL,'2012-11-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602467116,9413548,NULL,NULL,NULL,NULL),(10355,8408,0,'LSQ12hqa','LSQ',160.241125,-21.7815833333333,NULL,NULL,'2013-01-08 05:10:01',56300.2152900002,20.7911,0.1532,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_snap_95029.gif',41668171452,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,651065178,10172893,NULL,NULL,NULL,NULL),(10356,8408,0,'LSQ12hqa','LSQ',160.241125,-21.7816944444444,NULL,NULL,'2013-01-10 05:04:57',56302.21178,20.2485,0.1416,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_snap_95417.gif',41668171452,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,651065178,10172893,NULL,NULL,NULL,NULL),(10357,8576,0,'LSQ12hse','LSQ',180.094041666667,-21.8911111111111,NULL,NULL,'2013-01-08 05:23:34',56300.2247000001,19.5834,0.1092,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_snap_94961.gif',43016918029,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,672139344,10502177,NULL,NULL,NULL,NULL),(10358,8576,0,'LSQ12hse','LSQ',180.093041666667,-21.8911944444444,NULL,NULL,'2013-01-08 07:07:35',56300.2969399998,19.1198,0.1522,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_snap_94962.gif',43016918031,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,672139344,10502177,NULL,NULL,NULL,NULL),(10359,8576,0,'LSQ12hse','LSQ',180.093791666667,-21.8910833333333,NULL,NULL,'2013-01-12 07:16:50',56304.3033599998,20.7963,0.1768,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hse/LSQ12hse_snap_96402.gif',43016918029,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,672139344,10502177,NULL,NULL,NULL,NULL),(10360,8686,0,'LSQ12hvj','LSQ',166.910875,-29.7114166666667,NULL,NULL,'2013-01-08 05:01:33',56300.2094200002,18.3413,0.04,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_94940.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(10361,8686,0,'LSQ12hvj','LSQ',166.910916666667,-29.7114166666667,NULL,NULL,'2013-01-08 06:59:07',56300.2910600002,18.1605,0.042,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_94941.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(10362,8686,0,'LSQ12hvj','LSQ',166.910958333333,-29.7114166666667,NULL,NULL,'2013-01-10 04:53:04',56302.20352,18.2995,0.0374,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_95593.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(10363,8686,0,'LSQ12hvj','LSQ',166.910875,-29.7114166666667,NULL,NULL,'2013-01-10 04:56:27',56302.2058700002,18.1842,0.0493,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_95594.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(10364,8686,0,'LSQ12hvj','LSQ',166.910916666667,-29.7114444444444,NULL,NULL,'2013-01-12 04:55:43',56304.2053700001,18.6232,0.066,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_96382.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(10365,8686,0,'LSQ12hvj','LSQ',166.910958333333,-29.7113888888889,NULL,NULL,'2013-01-12 06:56:32',56304.28926,18.6174,0.0964,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_96383.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(10366,8906,0,'LSQ12hwy','LSQ',151.070875,-15.0928333333333,NULL,NULL,'2013-01-11 03:13:48',56303.1345899999,20.2521,0.111,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_history.html','sn?',NULL,0.049834,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_snap_95789.gif',41190790322,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643606098,10056345,NULL,NULL,NULL,NULL),(10367,8949,0,'LSQ12hyd','LSQ',174.637875,-24.2078888888889,NULL,NULL,'2013-01-08 05:20:11',56300.2223499999,19.826,0.0823,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_snap_94886.gif',41410841875,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647044404,10110068,NULL,NULL,NULL,NULL),(10368,8949,0,'LSQ12hyd','LSQ',174.637875,-24.2079166666667,NULL,NULL,'2013-01-10 05:15:05',56302.21881,19.8186,0.0803,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_snap_95456.gif',41410841875,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647044404,10110068,NULL,NULL,NULL,NULL),(10369,8949,0,'LSQ12hyd','LSQ',174.638,-24.2079166666667,NULL,NULL,'2013-01-10 08:05:15',56302.3369800001,20.1562,0.1181,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_snap_95457.gif',41410841875,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647044404,10110068,NULL,NULL,NULL,NULL),(10370,8959,0,'LSQ12hxx','LSQ',49.93425,-27.0071388888889,NULL,NULL,'2013-01-08 03:13:22',56300.13429,17.7757,0.0221,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_94900.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(10371,8959,0,'LSQ12hxx','LSQ',49.9342916666667,-27.0071666666667,NULL,NULL,'2013-01-08 03:16:45',56300.1366400002,17.7944,0.0203,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_94901.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(10372,8959,0,'LSQ12hxx','LSQ',49.9343333333333,-27.0071388888889,NULL,NULL,'2013-01-10 03:15:27',56302.1357300002,17.8527,0.0252,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_95484.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(10373,8959,0,'LSQ12hxx','LSQ',49.9342916666667,-27.0071388888889,NULL,NULL,'2013-01-10 03:18:49',56302.1380699999,18.0673,0.0267,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_95485.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(10374,8966,0,'LSQ12hxt','LSQ',56.8412916666667,-31.2003611111111,NULL,NULL,'2013-01-08 01:33:27',56300.0649000001,19.2631,0.1013,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_94877.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(10375,8966,0,'LSQ12hxt','LSQ',56.8413333333333,-31.2003611111111,NULL,NULL,'2013-01-08 03:32:22',56300.1474799998,19.2438,0.0657,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_94878.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(10376,8966,0,'LSQ12hxt','LSQ',56.8413333333333,-31.2003611111111,NULL,NULL,'2013-01-10 02:38:41',56302.1102,19.3783,0.0966,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_95446.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(10377,8966,0,'LSQ12hxt','LSQ',56.8414166666667,-31.2003888888889,NULL,NULL,'2013-01-10 05:30:29',56302.22951,19.2124,0.084,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_95447.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(10378,8974,0,'LSQ12hxp','LSQ',67.4702083333333,-35.1993611111111,NULL,NULL,'2013-01-08 01:57:12',56300.0814,21.1484,0.2158,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_94879.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(10379,8974,0,'LSQ12hxp','LSQ',67.47025,-35.1995,NULL,NULL,'2013-01-08 03:58:11',56300.1654099999,20.8404,0.1965,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_94880.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(10380,8974,0,'LSQ12hxp','LSQ',67.4700833333333,-35.1993055555556,NULL,NULL,'2013-01-12 03:14:45',56304.1352499998,20.1069,0.1186,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_96289.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(10381,9017,0,'LSQ12hxu','LSQ',63.4705416666667,-31.3776388888889,NULL,NULL,'2013-01-10 01:40:45',56302.0699700001,20.0458,0.143,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxu/LSQ12hxu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxu/LSQ12hxu_snap_95445.gif',37709822855,NULL,NULL,NULL,'2012-12-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,589215982,9206499,NULL,NULL,NULL,NULL),(10382,9183,0,'LSQ12hzj','LSQ',149.801791666667,-9.00225,NULL,NULL,'2013-01-11 03:42:54',56303.1548000001,16.7321,0.007,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_snap_95819.gif',41335019974,NULL,NULL,NULL,'2012-12-05 05:54:14',56266.246,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645859687,10091557,NULL,NULL,NULL,NULL);
INSERT INTO `transientBucket` VALUES (10383,9183,0,'LSQ12hzj','LSQ',149.801791666667,-9.00225,NULL,NULL,'2013-01-11 05:51:31',56303.2441099999,16.7997,0.0077,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_snap_95820.gif',41335019974,NULL,NULL,NULL,'2012-12-05 05:54:14',56266.246,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645859687,10091557,NULL,NULL,NULL,NULL),(10384,9251,0,'LSQ12hzu','LSQ',76.9712083333333,-20.9748055555556,NULL,NULL,'2013-01-08 02:36:31',56300.1087000002,18.8999,0.0669,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_94935.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(10385,9251,0,'LSQ12hzu','LSQ',76.9712083333333,-20.9748055555556,NULL,NULL,'2013-01-08 04:48:19',56300.20022,18.8985,0.0782,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_94936.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(10386,9251,0,'LSQ12hzu','LSQ',76.97125,-20.9747222222222,NULL,NULL,'2013-01-10 02:28:18',56302.10299,18.3808,0.0551,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_95589.gif',37548507155,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(10387,9251,0,'LSQ12hzu','LSQ',76.9711666666667,-20.9748333333333,NULL,NULL,'2013-01-10 04:41:19',56302.1953699999,18.986,0.0886,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_95590.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(10388,9251,0,'LSQ12hzu','LSQ',76.9713333333333,-20.9748055555556,NULL,NULL,'2013-01-12 02:37:15',56304.1092099999,18.61,0.0639,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_96378.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(10389,9251,0,'LSQ12hzu','LSQ',76.9713333333333,-20.97475,NULL,NULL,'2013-01-12 04:42:29',56304.1961699999,18.031,0.0443,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_96379.gif',37548507155,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(10390,9257,0,'LSQ12hzs','LSQ',60.471625,-26.6639444444444,NULL,NULL,'2013-01-08 03:39:06',56300.1521600001,18.0818,0.0197,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_history.html','sn nice',NULL,0.07213,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_snap_95144.gif',38534445066,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602100704,9407823,NULL,NULL,NULL,NULL),(10391,9257,0,'LSQ12hzs','LSQ',60.471625,-26.6639722222222,NULL,NULL,'2013-01-10 01:32:15',56302.0640699998,18.2194,0.0255,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_history.html','sn nice',NULL,0.07213,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_snap_95572.gif',38534445066,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602100704,9407823,NULL,NULL,NULL,NULL),(10392,9257,0,'LSQ12hzs','LSQ',60.471625,-26.6639444444444,NULL,NULL,'2013-01-10 03:32:24',56302.14751,18.1792,0.0271,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_history.html','sn nice',NULL,0.07213,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_snap_95573.gif',38534445066,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602100704,9407823,NULL,NULL,NULL,NULL),(10393,9348,0,'LSQ12iak','LSQ',170.612833333333,-26.7131666666667,NULL,NULL,'2013-01-08 05:01:33',56300.2094200002,19.4393,0.1326,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_snap_94979.gif',41429437531,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,647334961,10114608,NULL,NULL,NULL,NULL),(10394,9348,0,'LSQ12iak','LSQ',170.613041666667,-26.7128888888889,NULL,NULL,'2013-01-08 06:59:07',56300.2910600002,18.9369,0.1283,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_snap_94980.gif',41429437529,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,647334961,10114608,NULL,NULL,NULL,NULL),(10395,9348,0,'LSQ12iak','LSQ',170.61325,-26.7129722222222,NULL,NULL,'2013-01-12 04:55:43',56304.2053700001,19.1934,0.1562,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_snap_96420.gif',41429437529,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,647334961,10114608,NULL,NULL,NULL,NULL),(10396,9348,0,'LSQ12iak','LSQ',170.613166666667,-26.7130277777778,NULL,NULL,'2013-01-12 06:56:32',56304.28926,19.947,0.167,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_snap_96421.gif',41429437529,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,647334961,10114608,NULL,NULL,NULL,NULL),(10397,9352,0,'LSQ12iae','LSQ',63.302625,-30.7499444444444,NULL,NULL,'2013-01-08 01:48:45',56300.07553,18.5916,0.0379,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_snap_94825.gif',37654344365,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588349130,9192955,NULL,NULL,NULL,NULL),(10398,9352,0,'LSQ12iae','LSQ',63.302625,-30.7499722222222,NULL,NULL,'2013-01-08 03:49:45',56300.15955,18.5246,0.0362,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_snap_94826.gif',37654344365,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588349130,9192955,NULL,NULL,NULL,NULL),(10399,9352,0,'LSQ12iae','LSQ',63.302625,-30.7499444444444,NULL,NULL,'2013-01-10 01:40:45',56302.0699700001,18.4501,0.0325,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_snap_95654.gif',37654344365,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588349130,9192955,NULL,NULL,NULL,NULL),(10400,9352,0,'LSQ12iae','LSQ',63.3026666666667,-30.7499444444444,NULL,NULL,'2013-01-10 03:40:57',56302.15344,18.509,0.0347,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_snap_95655.gif',37654344365,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588349130,9192955,NULL,NULL,NULL,NULL),(10401,9352,0,'LSQ12iae','LSQ',63.3026666666667,-30.7499722222222,NULL,NULL,'2013-01-12 03:24:53',56304.1422899999,18.4318,0.0326,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_snap_96418.gif',37654344361,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588349130,9192955,NULL,NULL,NULL,NULL),(10402,9386,0,'LSQ13b','LSQ',170.889666666667,-20.3369444444444,NULL,NULL,'2013-01-11 05:08:57',56303.2145500001,19.6701,0.1092,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_snap_95850.gif',41739726486,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,652183226,10190362,NULL,NULL,NULL,NULL),(10403,9397,0,'LSQ13h','LSQ',70.6753333333333,-14.6319444444444,NULL,NULL,'2013-01-11 03:23:56',56303.14163,20.5746,0.1557,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_snap_95848.gif',37544086545,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586626352,9166036,NULL,NULL,NULL,NULL),(10404,9397,0,'LSQ13h','LSQ',70.675375,-14.6319166666667,NULL,NULL,'2013-01-11 03:27:19',56303.1439800002,20.3482,0.1273,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_snap_95849.gif',37544086754,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586626355,9166036,NULL,NULL,NULL,NULL),(10405,9477,0,'LSQ13ab','LSQ',168.104166666667,-21.9610833333333,NULL,NULL,'2013-01-08 05:13:24',56300.2176399999,16.1707,0.0059,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_95018.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(10406,9477,0,'LSQ13ab','LSQ',168.103875,-21.9609166666667,NULL,NULL,'2013-01-08 08:03:27',56300.3357299999,17.4018,0.0134,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_95019.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(10407,9477,0,'LSQ13ab','LSQ',168.104083333333,-21.961,NULL,NULL,'2013-01-10 05:08:20',56302.2141300002,16.2743,0.006,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_95309.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(10408,9477,0,'LSQ13ab','LSQ',168.104041666667,-21.9609444444444,NULL,NULL,'2013-01-10 08:08:38',56302.3393299999,17.6443,0.0178,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_95310.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(10409,9477,0,'LSQ13ab','LSQ',168.104166666667,-21.9610833333333,NULL,NULL,'2013-01-12 05:07:36',56304.2136200001,16.4084,0.008,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_96240.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(10410,9477,0,'LSQ13ab','LSQ',168.103875,-21.9609444444444,NULL,NULL,'2013-01-12 07:01:36',56304.2927799998,17.3159,0.0141,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_96241.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(10411,9487,0,'LSQ13aa','LSQ',68.8429166666667,-23.6362222222222,NULL,NULL,'2013-01-08 02:14:20',56300.0932900002,19.1638,0.0823,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_snap_94752.gif',37317539555,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583086555,9110727,NULL,NULL,NULL,NULL),(10412,9487,0,'LSQ13aa','LSQ',68.843,-23.63625,NULL,NULL,'2013-01-08 04:26:19',56300.1849500001,19.2355,0.0697,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_snap_94753.gif',37317539553,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583086555,9110727,NULL,NULL,NULL,NULL),(10413,9487,0,'LSQ13aa','LSQ',68.8429583333333,-23.6362222222222,NULL,NULL,'2013-01-10 02:02:49',56302.0852899998,19.1318,0.0717,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_snap_95307.gif',37317539555,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583086555,9110727,NULL,NULL,NULL,NULL),(10414,9487,0,'LSQ13aa','LSQ',68.8429583333333,-23.6362222222222,NULL,NULL,'2013-01-10 04:15:48',56302.17765,19.1083,0.0832,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_snap_95308.gif',37317539555,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583086555,9110727,NULL,NULL,NULL,NULL),(10415,9487,0,'LSQ13aa','LSQ',68.8429583333333,-23.6361944444444,NULL,NULL,'2013-01-12 02:15:12',56304.0938900001,19.2621,0.0847,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_snap_96235.gif',37317539555,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583086555,9110727,NULL,NULL,NULL,NULL),(10416,9487,0,'LSQ13aa','LSQ',68.843,-23.6362222222222,NULL,NULL,'2013-01-12 02:54:24',56304.1211199998,19.3161,0.093,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_snap_96236.gif',37317539555,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583086555,9110727,NULL,NULL,NULL,NULL),(10417,9496,0,'LSQ13w','LSQ',78.276875,-26.3313888888889,NULL,NULL,'2013-01-08 02:34:50',56300.1075300002,21.1347,0.1492,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13w/LSQ13w_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13w/LSQ13w_snap_94848.gif',37248083181,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,582001299,9093770,NULL,NULL,NULL,NULL),(10418,9498,0,'LSQ13v','LSQ',61.6492916666667,-27.5638611111111,NULL,NULL,'2013-01-08 01:52:08',56300.0778800002,19.8661,0.1047,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_snap_95095.gif',38522804849,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601918825,9404981,NULL,NULL,NULL,NULL),(10419,9498,0,'LSQ13v','LSQ',61.6493333333333,-27.5638611111111,NULL,NULL,'2013-01-08 03:53:07',56300.1618900001,19.6552,0.0848,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_snap_95096.gif',38522804849,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601918825,9404981,NULL,NULL,NULL,NULL),(10420,9498,0,'LSQ13v','LSQ',61.6492916666667,-27.5638611111111,NULL,NULL,'2013-01-10 01:44:06',56302.0723000001,19.4175,0.0747,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_snap_95304.gif',38522804849,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601918825,9404981,NULL,NULL,NULL,NULL),(10421,9498,0,'LSQ13v','LSQ',61.6493333333333,-27.5638333333333,NULL,NULL,'2013-01-10 03:44:21',56302.1557999998,19.4364,0.0772,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_snap_95305.gif',38522804849,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601918825,9404981,NULL,NULL,NULL,NULL),(10422,9498,0,'LSQ13v','LSQ',61.6493333333333,-27.5638888888889,NULL,NULL,'2013-01-12 03:18:08',56304.1376,19.7751,0.0944,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_snap_96233.gif',38522804849,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601918825,9404981,NULL,NULL,NULL,NULL),(10423,9498,0,'LSQ13v','LSQ',61.6493333333333,-27.5638888888889,NULL,NULL,'2013-01-12 04:32:21',56304.1891399999,19.4411,0.0857,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_snap_96234.gif',38522804849,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601918825,9404981,NULL,NULL,NULL,NULL),(10424,9500,0,'LSQ13t','LSQ',69.686,-33.1608055555556,NULL,NULL,'2013-01-08 02:17:49',56300.09571,20.7338,0.1373,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_snap_95032.gif',37688970952,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588890171,9201408,NULL,NULL,NULL,NULL),(10425,9500,0,'LSQ13t','LSQ',69.6862083333333,-33.1609166666667,NULL,NULL,'2013-01-08 04:29:42',56300.1872999999,21.3358,0.1592,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13t/LSQ13t_snap_95033.gif',37688970952,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588890171,9201408,NULL,NULL,NULL,NULL),(10426,9508,0,'LSQ13s','LSQ',66.8669583333333,-31.8321666666667,NULL,NULL,'2013-01-08 04:14:26',56300.1766900001,18.7797,0.1221,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_snap_95094.gif',37706710007,NULL,NULL,NULL,'2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,589167343,9205739,NULL,NULL,NULL,NULL),(10427,9508,0,'LSQ13s','LSQ',66.866875,-31.8321111111111,NULL,NULL,'2013-01-10 01:54:15',56302.0793499998,19.2744,0.1774,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_snap_95300.gif',37706710007,NULL,NULL,NULL,'2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,589167343,9205739,NULL,NULL,NULL,NULL),(10428,9508,0,'LSQ13s','LSQ',66.86675,-31.8321111111111,NULL,NULL,'2013-01-10 04:03:39',56302.16921,18.753,0.1361,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13s/LSQ13s_snap_95301.gif',37706710004,NULL,NULL,NULL,'2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,589167343,9205739,NULL,NULL,NULL,NULL),(10429,9514,0,'LSQ13r','LSQ',66.7958333333333,-32.6768888888889,NULL,NULL,'2013-01-08 04:14:26',56300.1766900001,19.5097,0.2085,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_snap_95093.gif',37705316407,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589145568,9205399,NULL,NULL,NULL,NULL),(10430,9514,0,'LSQ13r','LSQ',66.795875,-32.6768888888889,NULL,NULL,'2013-01-10 04:03:39',56302.16921,19.1014,0.1404,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_snap_95295.gif',37705316407,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589145568,9205399,NULL,NULL,NULL,NULL),(10431,9514,0,'LSQ13r','LSQ',66.7957916666667,-32.6769166666667,NULL,NULL,'2013-01-12 03:02:51',56304.1269899998,19.5152,0.1849,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13r/LSQ13r_snap_96232.gif',37705316407,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,589145568,9205399,NULL,NULL,NULL,NULL),(10432,9593,0,'LSQ13ax','LSQ',146.896625,-7.40841666666667,NULL,NULL,'2013-01-11 03:10:26',56303.1322499998,19.2722,0.1164,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:44','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_snap_95823.gif',41326341537,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645724086,10089438,NULL,NULL,NULL,NULL),(10433,9608,0,'LSQ13ag','LSQ',75.549625,-17.9771666666667,NULL,NULL,'2013-01-11 02:45:44',56303.1151000001,17.8594,0.0327,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_snap_95824.gif',37553411726,NULL,NULL,NULL,'2012-12-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,586772058,9168313,NULL,NULL,NULL,NULL),(10434,9608,0,'LSQ13ag','LSQ',75.549625,-17.9771111111111,NULL,NULL,'2013-01-11 02:49:06',56303.1174400002,17.8207,0.0354,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_snap_95825.gif',37553411726,NULL,NULL,NULL,'2012-12-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,586772058,9168313,NULL,NULL,NULL,NULL),(10435,9655,0,'LSQ13bd','LSQ',58.4530833333333,-37.4327777777778,NULL,NULL,'2013-01-08 01:41:53',56300.07076,20.7001,0.1388,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bd/LSQ13bd_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bd/LSQ13bd_snap_94892.gif',37667745058,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,588558516,9196226,NULL,NULL,NULL,NULL),(10436,9655,0,'LSQ13bd','LSQ',58.4530833333333,-37.4327777777778,NULL,NULL,'2013-01-08 03:40:48',56300.1533400002,21.032,0.1672,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bd/LSQ13bd_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bd/LSQ13bd_snap_94893.gif',37667745058,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,588558516,9196226,NULL,NULL,NULL,NULL),(10437,9655,0,'LSQ13bd','LSQ',58.4530833333333,-37.4327777777778,NULL,NULL,'2013-01-10 01:33:56',56302.0652399999,20.7847,0.1474,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bd/LSQ13bd_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bd/LSQ13bd_snap_95464.gif',37667745058,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,588558516,9196226,NULL,NULL,NULL,NULL),(10438,9655,0,'LSQ13bd','LSQ',58.453125,-37.4328333333333,NULL,NULL,'2013-01-10 03:34:05',56302.14867,20.6301,0.1345,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bd/LSQ13bd_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bd/LSQ13bd_snap_95465.gif',37667745058,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,588558516,9196226,NULL,NULL,NULL,NULL),(10439,9713,0,'LSQ13bo','LSQ',161.640833333333,-17.6445277777778,NULL,NULL,'2013-01-11 05:02:10',56303.2098400001,20.6545,0.1436,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bo/LSQ13bo_history.html','sn nice',NULL,0.112181,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bo/LSQ13bo_snap_95816.gif',41860113198,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,654064268,10219754,NULL,NULL,NULL,NULL),(10440,9716,0,'LSQ13bn','LSQ',75.2494583333333,-17.7399166666667,NULL,NULL,'2013-01-11 02:45:44',56303.1151000001,19.8638,0.1126,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_history.html','sn nice',NULL,0.056389,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_snap_95838.gif',37570931536,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587045805,9172590,NULL,NULL,NULL,NULL),(10441,9716,0,'LSQ13bn','LSQ',75.249625,-17.74,NULL,NULL,'2013-01-11 02:49:06',56303.1174400002,19.3736,0.0869,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_history.html','sn nice',NULL,0.056389,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_snap_95839.gif',37570931536,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587045805,9172590,NULL,NULL,NULL,NULL),(10442,9744,0,'LSQ13cv','LSQ',144.436,-10.63075,NULL,NULL,'2013-01-11 02:58:24',56303.1239,19.4753,0.0589,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_snap_95828.gif',41307885070,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645435704,10084932,NULL,NULL,NULL,NULL),(10443,9744,0,'LSQ13cv','LSQ',144.436125,-10.6307222222222,NULL,NULL,'2013-01-11 04:58:47',56303.2074899999,19.5504,0.0998,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_snap_95829.gif',41307885070,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645435704,10084932,NULL,NULL,NULL,NULL),(10444,9793,0,'LSQ13cb','LSQ',155.630375,-12.0889166666667,NULL,NULL,'2013-01-11 03:30:29',56303.1461800002,19.875,0.1872,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_history.html','sn nice',NULL,0.036025,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_snap_95811.gif',41825602641,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653525041,10211328,NULL,NULL,NULL,NULL),(10445,9793,0,'LSQ13cb','LSQ',155.630333333333,-12.08875,NULL,NULL,'2013-01-11 03:33:53',56303.14854,19.9948,0.1752,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_history.html','sn nice',NULL,0.036025,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_snap_95812.gif',41825602641,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653525041,10211328,NULL,NULL,NULL,NULL),(10446,9799,0,'LSQ13bz','LSQ',74.9265833333333,-12.6089444444444,NULL,NULL,'2013-01-11 03:02:40',56303.1268600002,18.6708,0.0979,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bz/LSQ13bz_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bz/LSQ13bz_snap_95800.gif',37520793527,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586262398,9160349,NULL,NULL,NULL,NULL),(10447,10447,1,'LSQ13es','LSQ',203.648375,-22.2409722222222,NULL,NULL,'2013-01-08 06:45:05',56300.28131,19.4221,0.1064,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13es/LSQ13es_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13es/LSQ13es_snap_95287.gif',43771398303,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,683928098,10686376,NULL,NULL,NULL,NULL),(10448,10447,0,'LSQ13es','LSQ',203.648375,-22.2408055555556,NULL,NULL,'2013-01-08 07:48:12',56300.3251499999,19.9858,0.1317,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13es/LSQ13es_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13es/LSQ13es_snap_95288.gif',43771398303,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,683928098,10686376,NULL,NULL,NULL,NULL),(10449,10449,1,'LSQ13eo','LSQ',171.624833333333,-23.6549166666667,NULL,NULL,'2013-01-08 05:16:48',56300.2200000002,19.2284,0.0524,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eo/LSQ13eo_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eo/LSQ13eo_snap_95207.gif',41432958761,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647389980,10115468,NULL,NULL,NULL,NULL),(10450,10449,0,'LSQ13eo','LSQ',171.624791666667,-23.6548888888889,NULL,NULL,'2013-01-08 07:04:12',56300.2945900001,19.96,0.0937,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eo/LSQ13eo_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eo/LSQ13eo_snap_95208.gif',41432958761,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647389980,10115468,NULL,NULL,NULL,NULL),(10451,10451,1,'LSQ13em','LSQ',164.653333333333,-22.8128611111111,NULL,NULL,'2012-12-23 05:26:17',56284.2265900001,19.9674,0.1432,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_snap_95268.gif',41628312266,NULL,NULL,NULL,'2012-12-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650442379,10163162,NULL,NULL,NULL,NULL),(10452,10451,0,'LSQ13em','LSQ',164.653333333333,-22.8128333333333,NULL,NULL,'2012-12-29 07:27:33',56290.3108000001,20.1352,0.1828,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_snap_95269.gif',41628312266,NULL,NULL,NULL,'2012-12-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650442379,10163162,NULL,NULL,NULL,NULL),(10453,10451,0,'LSQ13em','LSQ',164.653333333333,-22.81275,NULL,NULL,'2012-12-31 07:04:55',56292.2950900001,19.5564,0.1226,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_snap_95270.gif',41628312266,NULL,NULL,NULL,'2012-12-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650442379,10163162,NULL,NULL,NULL,NULL),(10454,10451,0,'LSQ13em','LSQ',164.653375,-22.8127777777778,NULL,NULL,'2013-01-04 07:07:53',56296.29715,19.5958,0.1778,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_snap_95271.gif',41628312268,NULL,NULL,NULL,'2012-12-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650442379,10163162,NULL,NULL,NULL,NULL),(10455,10451,0,'LSQ13em','LSQ',164.653333333333,-22.8127777777778,NULL,NULL,'2013-01-06 05:18:50',56298.2214199998,20.2265,0.1635,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_snap_95272.gif',41628312266,NULL,NULL,NULL,'2012-12-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650442379,10163162,NULL,NULL,NULL,NULL),(10456,10451,0,'LSQ13em','LSQ',164.653458333333,-22.8126944444444,NULL,NULL,'2013-01-06 07:04:07',56298.2945300001,20.0233,0.1542,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_snap_95273.gif',41628312268,NULL,NULL,NULL,'2012-12-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650442379,10163162,NULL,NULL,NULL,NULL),(10457,10451,0,'LSQ13em','LSQ',164.653333333333,-22.8127777777778,NULL,NULL,'2013-01-08 05:13:24',56300.2176399999,20.0276,0.0878,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_snap_95203.gif',41628312266,NULL,NULL,NULL,'2012-12-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650442379,10163162,NULL,NULL,NULL,NULL),(10458,10451,0,'LSQ13em','LSQ',164.65325,-22.81275,NULL,NULL,'2013-01-08 08:03:27',56300.3357299999,20.0405,0.088,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_snap_95204.gif',41628312266,NULL,NULL,NULL,'2012-12-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650442379,10163162,NULL,NULL,NULL,NULL),(10459,10451,0,'LSQ13em','LSQ',164.653333333333,-22.8127777777778,NULL,NULL,'2013-01-10 05:08:20',56302.2141300002,19.6811,0.0768,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_snap_95382.gif',41628312266,NULL,NULL,NULL,'2012-12-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650442379,10163162,NULL,NULL,NULL,NULL),(10460,10451,0,'LSQ13em','LSQ',164.653291666667,-22.8127777777778,NULL,NULL,'2013-01-10 08:08:38',56302.3393299999,20.2411,0.1076,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_snap_95383.gif',41628312266,NULL,NULL,NULL,'2012-12-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650442379,10163162,NULL,NULL,NULL,NULL),(10461,10451,0,'LSQ13em','LSQ',164.653208333333,-22.8126944444444,NULL,NULL,'2013-01-12 07:01:36',56304.2927799998,20.7993,0.1535,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_snap_96269.gif',41628312266,NULL,NULL,NULL,'2012-12-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650442379,10163162,NULL,NULL,NULL,NULL),(10462,10462,1,'LSQ13ej','LSQ',186.3765,-28.44,NULL,NULL,'2013-01-08 05:45:55',56300.24022,19.7183,0.0964,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ej/LSQ13ej_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ej/LSQ13ej_snap_95197.gif',43403700564,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,678182821,10596606,NULL,NULL,NULL,NULL),(10463,10462,0,'LSQ13ej','LSQ',186.376416666667,-28.4399722222222,NULL,NULL,'2013-01-08 07:19:29',56300.3051999998,19.5241,0.1437,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ej/LSQ13ej_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ej/LSQ13ej_snap_95198.gif',43403700564,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,678182821,10596606,NULL,NULL,NULL,NULL),(10464,10462,0,'LSQ13ej','LSQ',186.376416666667,-28.4400555555556,NULL,NULL,'2013-01-10 05:39:06',56302.2354899999,19.2911,0.1338,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ej/LSQ13ej_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ej/LSQ13ej_snap_95374.gif',43403700564,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,678182821,10596606,NULL,NULL,NULL,NULL),(10465,10462,0,'LSQ13ej','LSQ',186.376458333333,-28.4399444444444,NULL,NULL,'2013-01-10 07:15:57',56302.3027499998,19.825,0.1392,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ej/LSQ13ej_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ej/LSQ13ej_snap_95375.gif',43403700564,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,678182821,10596606,NULL,NULL,NULL,NULL),(10466,10462,0,'LSQ13ej','LSQ',186.376458333333,-28.44,NULL,NULL,'2013-01-12 05:29:41',56304.2289499999,19.9842,0.1703,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ej/LSQ13ej_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ej/LSQ13ej_snap_96264.gif',43403700564,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,678182821,10596606,NULL,NULL,NULL,NULL),(10467,10462,0,'LSQ13ej','LSQ',186.376458333333,-28.44,NULL,NULL,'2013-01-12 07:13:26',56304.301,20.0136,0.1332,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ej/LSQ13ej_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ej/LSQ13ej_snap_96265.gif',43403700564,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,678182821,10596606,NULL,NULL,NULL,NULL),(10468,10468,1,'LSQ13ei','LSQ',177.033708333333,-27.6064444444444,NULL,NULL,'2013-01-06 05:17:09',56298.2202499998,18.7568,0.1298,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_snap_95255.gif',41463471513,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,647866742,10122917,NULL,NULL,NULL,NULL),(10469,10468,0,'LSQ13ei','LSQ',177.033875,-27.6065277777778,NULL,NULL,'2013-01-08 05:08:19',56300.2141100001,19.235,0.1233,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_snap_95195.gif',41463471513,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,647866742,10122917,NULL,NULL,NULL,NULL),(10470,10468,0,'LSQ13ei','LSQ',177.033875,-27.6065833333333,NULL,NULL,'2013-01-08 08:05:09',56300.3369100001,19.0303,0.0975,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_snap_95196.gif',41463471513,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,647866742,10122917,NULL,NULL,NULL,NULL),(10471,10468,0,'LSQ13ei','LSQ',177.033833333333,-27.6065555555556,NULL,NULL,'2013-01-10 05:03:13',56302.2105700001,19.5879,0.1628,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_snap_95362.gif',41463471513,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,647866742,10122917,NULL,NULL,NULL,NULL),(10472,10468,0,'LSQ13ei','LSQ',177.033833333333,-27.6066944444444,NULL,NULL,'2013-01-10 08:10:20',56302.34051,19.2007,0.1424,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_snap_95363.gif',41463471513,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,647866742,10122917,NULL,NULL,NULL,NULL),(10473,10468,0,'LSQ13ei','LSQ',177.033875,-27.6066944444444,NULL,NULL,'2013-01-12 06:59:54',56304.2916000001,19.3871,0.1659,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_snap_96288.gif',41463471513,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,647866742,10122917,NULL,NULL,NULL,NULL),(10474,10474,1,'LSQ13eh','LSQ',73.39525,-28.4290833333333,NULL,NULL,'2013-01-04 02:34:54',56296.1075800001,19.7948,0.0991,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_snap_95251.gif',37231969715,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581749526,9089836,NULL,NULL,NULL,NULL),(10475,10474,0,'LSQ13eh','LSQ',73.395125,-28.4290555555556,NULL,NULL,'2013-01-04 04:45:27',56296.1982399998,19.6714,0.1177,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_snap_95252.gif',37231969715,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581749526,9089836,NULL,NULL,NULL,NULL),(10476,10474,0,'LSQ13eh','LSQ',73.3952083333333,-28.4290555555556,NULL,NULL,'2013-01-06 02:26:44',56298.1019000001,19.598,0.083,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_snap_95253.gif',37231969715,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581749526,9089836,NULL,NULL,NULL,NULL),(10477,10474,0,'LSQ13eh','LSQ',73.3952083333333,-28.4290833333333,NULL,NULL,'2013-01-06 04:35:05',56298.1910399999,19.6542,0.0901,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_snap_95254.gif',37231969715,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581749526,9089836,NULL,NULL,NULL,NULL),(10478,10474,0,'LSQ13eh','LSQ',73.3952083333333,-28.4290833333333,NULL,NULL,'2013-01-08 02:19:31',56300.0968900002,19.4852,0.0828,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_snap_95193.gif',37231969715,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581749526,9089836,NULL,NULL,NULL,NULL),(10479,10474,0,'LSQ13eh','LSQ',73.3951666666667,-28.4290833333333,NULL,NULL,'2013-01-08 04:31:24',56300.18848,19.4713,0.0759,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_snap_95194.gif',37231969715,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581749526,9089836,NULL,NULL,NULL,NULL),(10480,10474,0,'LSQ13eh','LSQ',73.395125,-28.4290833333333,NULL,NULL,'2013-01-10 02:11:17',56302.09118,19.2676,0.0893,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_snap_95360.gif',37231969715,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581749526,9089836,NULL,NULL,NULL,NULL),(10481,10474,0,'LSQ13eh','LSQ',73.3952083333333,-28.4290833333333,NULL,NULL,'2013-01-10 04:24:22',56302.18359,19.444,0.0807,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_snap_95361.gif',37231969715,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581749526,9089836,NULL,NULL,NULL,NULL),(10482,10474,0,'LSQ13eh','LSQ',73.3952083333333,-28.4290555555556,NULL,NULL,'2013-01-12 02:20:16',56304.0974099999,19.4352,0.0773,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_snap_96259.gif',37231969715,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581749526,9089836,NULL,NULL,NULL,NULL),(10483,10483,1,'LSQ13ef','LSQ',59.4138333333333,-29.9436111111111,NULL,NULL,'2013-01-04 01:54:15',56296.0793499998,20.3639,0.1741,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ef/LSQ13ef_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ef/LSQ13ef_snap_95235.gif',38532402434,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602068788,9407324,NULL,NULL,NULL,NULL),(10484,10483,0,'LSQ13ef','LSQ',59.413875,-29.9435833333333,NULL,NULL,'2013-01-04 03:53:34',56296.1622100002,20.6521,0.2078,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ef/LSQ13ef_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ef/LSQ13ef_snap_95236.gif',38532402434,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602068788,9407324,NULL,NULL,NULL,NULL),(10485,10483,0,'LSQ13ef','LSQ',59.4137083333333,-29.9436111111111,NULL,NULL,'2013-01-06 03:45:10',56298.15637,19.9976,0.1106,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ef/LSQ13ef_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ef/LSQ13ef_snap_95237.gif',38532402435,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602068788,9407324,NULL,NULL,NULL,NULL),(10486,10483,0,'LSQ13ef','LSQ',59.4137916666667,-29.9435555555556,NULL,NULL,'2013-01-08 01:38:30',56300.0684099998,19.7773,0.0942,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ef/LSQ13ef_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ef/LSQ13ef_snap_95189.gif',38532402435,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602068788,9407324,NULL,NULL,NULL,NULL),(10487,10483,0,'LSQ13ef','LSQ',59.4138333333333,-29.9435833333333,NULL,NULL,'2013-01-08 03:37:26',56300.1510000001,19.7083,0.122,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ef/LSQ13ef_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ef/LSQ13ef_snap_95190.gif',38532402435,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602068788,9407324,NULL,NULL,NULL,NULL),(10488,10483,0,'LSQ13ef','LSQ',59.41375,-29.9436388888889,NULL,NULL,'2013-01-10 01:30:35',56302.0629099999,19.4048,0.0763,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ef/LSQ13ef_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ef/LSQ13ef_snap_95411.gif',38532402435,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602068788,9407324,NULL,NULL,NULL,NULL),(10489,10483,0,'LSQ13ef','LSQ',59.4138333333333,-29.9435833333333,NULL,NULL,'2013-01-10 03:30:38',56302.14628,19.6191,0.0901,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ef/LSQ13ef_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ef/LSQ13ef_snap_95412.gif',38532402435,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602068788,9407324,NULL,NULL,NULL,NULL),(10490,10490,1,'LSQ13ed','LSQ',66.346625,-31.9113333333333,NULL,NULL,'2012-12-29 02:34:21',56290.1071899999,18.468,0.1418,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_snap_95226.gif',37705971658,NULL,NULL,NULL,'2012-12-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589155807,9205559,NULL,NULL,NULL,NULL),(10491,10490,0,'LSQ13ed','LSQ',66.346625,-31.9113611111111,NULL,NULL,'2012-12-29 04:34:15',56290.1904600002,18.8297,0.1389,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_snap_95227.gif',37705971658,NULL,NULL,NULL,'2012-12-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589155807,9205559,NULL,NULL,NULL,NULL),(10492,10490,0,'LSQ13ed','LSQ',66.346625,-31.9113611111111,NULL,NULL,'2012-12-31 02:30:28',56292.1044999999,18.3686,0.0932,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_snap_95228.gif',37705971658,NULL,NULL,NULL,'2012-12-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589155807,9205559,NULL,NULL,NULL,NULL),(10493,10490,0,'LSQ13ed','LSQ',66.3467083333333,-31.9113333333333,NULL,NULL,'2012-12-31 04:29:45',56292.1873300001,18.4055,0.108,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_snap_95229.gif',37705971658,NULL,NULL,NULL,'2012-12-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589155807,9205559,NULL,NULL,NULL,NULL),(10494,10490,0,'LSQ13ed','LSQ',66.3466666666667,-31.9113333333333,NULL,NULL,'2013-01-04 02:19:41',56296.0970100001,18.6272,0.0876,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_snap_95230.gif',37705971658,NULL,NULL,NULL,'2012-12-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589155807,9205559,NULL,NULL,NULL,NULL),(10495,10490,0,'LSQ13ed','LSQ',66.3466666666667,-31.9113611111111,NULL,NULL,'2013-01-04 04:30:07',56296.1875900002,18.5362,0.0741,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_snap_95231.gif',37705971658,NULL,NULL,NULL,'2012-12-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589155807,9205559,NULL,NULL,NULL,NULL),(10496,10490,0,'LSQ13ed','LSQ',66.3466666666667,-31.9113333333333,NULL,NULL,'2013-01-06 02:11:24',56298.0912500001,18.6986,0.0644,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_snap_95232.gif',37705971658,NULL,NULL,NULL,'2012-12-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589155807,9205559,NULL,NULL,NULL,NULL),(10497,10490,0,'LSQ13ed','LSQ',66.3466666666667,-31.9113611111111,NULL,NULL,'2013-01-06 04:19:49',56298.1804300002,18.6861,0.0568,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_snap_95233.gif',37705971658,NULL,NULL,NULL,'2012-12-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589155807,9205559,NULL,NULL,NULL,NULL),(10498,10490,0,'LSQ13ed','LSQ',66.346625,-31.9113333333333,NULL,NULL,'2013-01-08 02:04:05',56300.08617,18.673,0.0878,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_snap_95185.gif',37705971658,NULL,NULL,NULL,'2012-12-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589155807,9205559,NULL,NULL,NULL,NULL),(10499,10490,0,'LSQ13ed','LSQ',66.3466666666667,-31.9113055555556,NULL,NULL,'2013-01-08 04:16:07',56300.1778600002,18.7492,0.0715,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_snap_95186.gif',37705971658,NULL,NULL,NULL,'2012-12-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589155807,9205559,NULL,NULL,NULL,NULL),(10500,10490,0,'LSQ13ed','LSQ',66.3467083333333,-31.9113333333333,NULL,NULL,'2013-01-10 01:56:02',56302.0805899999,18.6867,0.1544,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_snap_95435.gif',37705971658,NULL,NULL,NULL,'2012-12-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589155807,9205559,NULL,NULL,NULL,NULL),(10501,10490,0,'LSQ13ed','LSQ',66.3466666666667,-31.9113333333333,NULL,NULL,'2013-01-10 04:05:21',56302.1703900001,18.6854,0.1691,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_snap_95436.gif',37705971658,NULL,NULL,NULL,'2012-12-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589155807,9205559,NULL,NULL,NULL,NULL),(10502,10490,0,'LSQ13ed','LSQ',66.3466666666667,-31.9113611111111,NULL,NULL,'2013-01-12 03:04:33',56304.1281599998,18.9453,0.2033,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_snap_96287.gif',37705971658,NULL,NULL,NULL,'2012-12-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589155807,9205559,NULL,NULL,NULL,NULL),(10503,10503,1,'LSQ13dz','LSQ',43.68225,-37.4161388888889,NULL,NULL,'2013-01-04 03:14:17',56296.1349200001,19.9674,0.1148,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dz/LSQ13dz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dz/LSQ13dz_snap_95213.gif',38645042647,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,603828791,9434824,NULL,NULL,NULL,NULL),(10504,10503,0,'LSQ13dz','LSQ',43.682125,-37.4160833333333,NULL,NULL,'2013-01-04 03:17:39',56296.1372600002,19.9188,0.0924,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dz/LSQ13dz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dz/LSQ13dz_snap_95214.gif',38645042647,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,603828791,9434824,NULL,NULL,NULL,NULL),(10505,10503,0,'LSQ13dz','LSQ',43.6821666666667,-37.4161111111111,NULL,NULL,'2013-01-06 03:17:52',56298.13741,19.9939,0.0922,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dz/LSQ13dz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dz/LSQ13dz_snap_95215.gif',38645042647,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,603828791,9434824,NULL,NULL,NULL,NULL),(10506,10503,0,'LSQ13dz','LSQ',43.6821666666667,-37.4161388888889,NULL,NULL,'2013-01-06 03:22:56',56298.1409300002,19.805,0.0822,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dz/LSQ13dz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dz/LSQ13dz_snap_95216.gif',38645042647,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,603828791,9434824,NULL,NULL,NULL,NULL),(10507,10503,0,'LSQ13dz','LSQ',43.682125,-37.4160833333333,NULL,NULL,'2013-01-08 03:23:30',56300.14133,19.3918,0.0657,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dz/LSQ13dz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dz/LSQ13dz_snap_95177.gif',38645042647,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,603828791,9434824,NULL,NULL,NULL,NULL),(10508,10503,0,'LSQ13dz','LSQ',43.68225,-37.4161111111111,NULL,NULL,'2013-01-08 03:26:53',56300.1436700001,19.2628,0.0631,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dz/LSQ13dz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dz/LSQ13dz_snap_95178.gif',38645042647,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,603828791,9434824,NULL,NULL,NULL,NULL),(10509,10503,0,'LSQ13dz','LSQ',43.68225,-37.4160833333333,NULL,NULL,'2013-01-10 03:25:35',56302.1427699998,19.0527,0.0635,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dz/LSQ13dz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dz/LSQ13dz_snap_95379.gif',38645042647,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,603828791,9434824,NULL,NULL,NULL,NULL),(10510,10503,0,'LSQ13dz','LSQ',43.6822083333333,-37.4160833333333,NULL,NULL,'2013-01-10 03:28:56',56302.1450999998,19.216,0.0656,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dz/LSQ13dz_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dz/LSQ13dz_snap_95380.gif',38645042647,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,603828791,9434824,NULL,NULL,NULL,NULL),(10511,10511,1,'LSQ13dw','LSQ',137.761875,-2.48938888888889,NULL,NULL,'2012-12-11 05:12:02',56272.2167000002,20.8883,0.1421,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_snap_94739.gif',41086338785,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641974043,10030844,NULL,NULL,NULL,NULL),(10512,10511,0,'LSQ13dw','LSQ',137.762,-2.4895,NULL,NULL,'2012-12-15 04:52:24',56276.2030600002,19.9417,0.1584,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_snap_94740.gif',41086338785,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641974043,10030844,NULL,NULL,NULL,NULL),(10513,10511,0,'LSQ13dw','LSQ',137.762,-2.48947222222222,NULL,NULL,'2012-12-21 04:32:33',56282.18928,20.5437,0.2093,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_snap_94741.gif',41086338785,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641974043,10030844,NULL,NULL,NULL,NULL),(10514,10511,0,'LSQ13dw','LSQ',137.761958333333,-2.48961111111111,NULL,NULL,'2012-12-28 06:44:13',56289.2807100001,20.1325,0.1949,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_snap_94742.gif',41086338785,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641974043,10030844,NULL,NULL,NULL,NULL),(10515,10511,0,'LSQ13dw','LSQ',137.761666666667,-2.48958333333333,NULL,NULL,'2012-12-28 07:44:10',56289.32234,19.9601,0.1971,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_snap_94743.gif',41086338785,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641974043,10030844,NULL,NULL,NULL,NULL),(10516,10511,0,'LSQ13dw','LSQ',137.761833333333,-2.48963888888889,NULL,NULL,'2012-12-30 03:43:31',56291.1552300001,18.4065,0.201,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_snap_94744.gif',41086338785,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641974043,10030844,NULL,NULL,NULL,NULL),(10517,10511,0,'LSQ13dw','LSQ',137.762083333333,-2.48961111111111,NULL,NULL,'2013-01-03 03:27:50',56295.14433,19.4777,0.1397,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_snap_94745.gif',41086338785,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641974043,10030844,NULL,NULL,NULL,NULL),(10518,10511,0,'LSQ13dw','LSQ',137.762166666667,-2.48955555555556,NULL,NULL,'2013-01-03 05:29:54',56295.2291000001,19.993,0.1346,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_snap_94746.gif',41086338787,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641974043,10030844,NULL,NULL,NULL,NULL),(10519,10511,0,'LSQ13dw','LSQ',137.762041666667,-2.48958333333333,NULL,NULL,'2013-01-07 03:11:49',56299.1332100001,20.0164,0.0914,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_snap_94747.gif',41086338785,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641974043,10030844,NULL,NULL,NULL,NULL),(10520,10511,0,'LSQ13dw','LSQ',137.762,-2.48972222222222,NULL,NULL,'2013-01-07 05:12:13',56299.2168200002,21.01,0.1713,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_snap_94748.gif',41086338785,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641974043,10030844,NULL,NULL,NULL,NULL),(10521,10511,0,'LSQ13dw','LSQ',137.761958333333,-2.48969444444444,NULL,NULL,'2013-01-09 03:08:01',56301.13057,20.3939,0.1111,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_snap_94684.gif',41086338785,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641974043,10030844,NULL,NULL,NULL,NULL),(10522,10511,0,'LSQ13dw','LSQ',137.761916666667,-2.48972222222222,NULL,NULL,'2013-01-09 05:07:35',56301.2135999999,20.9802,0.144,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_snap_94685.gif',41086338785,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641974043,10030844,NULL,NULL,NULL,NULL),(10523,10511,0,'LSQ13dw','LSQ',137.762041666667,-2.48963888888889,NULL,NULL,'2013-01-11 04:55:23',56303.2051300001,20.5121,0.1224,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_snap_95844.gif',41086338785,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641974043,10030844,NULL,NULL,NULL,NULL),(10524,10524,1,'LSQ13ds','LSQ',152.524958333333,-16.1156944444444,NULL,NULL,'2013-01-05 05:08:07',56297.21398,19.5677,0.1656,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ds/LSQ13ds_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ds/LSQ13ds_snap_94729.gif',41198398643,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,643724978,10058202,NULL,NULL,NULL,NULL),(10525,10524,0,'LSQ13ds','LSQ',152.524625,-16.1156944444444,NULL,NULL,'2013-01-05 08:34:22',56297.3572,19.7566,0.1207,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-13 11:36:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ds/LSQ13ds_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ds/LSQ13ds_snap_94730.gif',41198398641,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,643724978,10058202,NULL,NULL,NULL,NULL),(10526,10524,0,'LSQ13ds','LSQ',152.524666666667,-16.1156944444444,NULL,NULL,'2013-01-09 05:13:11',56301.2174900002,19.4159,0.0804,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-13 11:36:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ds/LSQ13ds_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ds/LSQ13ds_snap_94676.gif',41198398641,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,643724978,10058202,NULL,NULL,NULL,NULL),(10527,10524,0,'LSQ13ds','LSQ',152.524708333333,-16.1156944444444,NULL,NULL,'2013-01-09 07:08:17',56301.2974299998,19.694,0.0995,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-13 11:36:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ds/LSQ13ds_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ds/LSQ13ds_snap_94677.gif',41198398641,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,643724978,10058202,NULL,NULL,NULL,NULL),(10528,10524,0,'LSQ13ds','LSQ',152.524708333333,-16.1156666666667,NULL,NULL,'2013-01-11 03:32:11',56303.1473599998,19.1822,0.1284,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-13 11:36:50','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ds/LSQ13ds_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ds/LSQ13ds_snap_95776.gif',41198398641,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,643724978,10058202,NULL,NULL,NULL,NULL),(10529,10529,1,'LSQ13dr','LSQ',152.41275,-15.5315277777778,NULL,NULL,'2012-12-11 05:15:31',56272.21912,19.6736,0.1581,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_snap_94721.gif',41165095736,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643204620,10050072,NULL,NULL,NULL,NULL),(10530,10529,0,'LSQ13dr','LSQ',152.413375,-15.5310555555556,NULL,NULL,'2012-12-11 07:07:41',56272.2970099999,19.4849,0.132,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_snap_94722.gif',41165095704,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643204620,10050072,NULL,NULL,NULL,NULL),(10531,10529,0,'LSQ13dr','LSQ',152.413625,-15.5308611111111,NULL,NULL,'2012-12-15 05:03:50',56276.2110000001,19.4268,0.1204,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_snap_94723.gif',41165095588,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643204618,10050072,NULL,NULL,NULL,NULL),(10532,10529,0,'LSQ13dr','LSQ',152.413583333333,-15.5309722222222,NULL,NULL,'2012-12-19 05:12:33',56280.2170500001,19.5957,0.134,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_snap_94724.gif',41165095704,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643204620,10050072,NULL,NULL,NULL,NULL),(10533,10529,0,'LSQ13dr','LSQ',152.4135,-15.5310277777778,NULL,NULL,'2012-12-21 04:36:02',56282.1916899998,19.2407,0.1252,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_snap_94725.gif',41165095704,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643204620,10050072,NULL,NULL,NULL,NULL),(10534,10529,0,'LSQ13dr','LSQ',152.413375,-15.5308888888889,NULL,NULL,'2012-12-24 05:16:16',56285.2196399998,20.3136,0.1565,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_snap_94726.gif',41165095704,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643204620,10050072,NULL,NULL,NULL,NULL),(10535,10529,0,'LSQ13dr','LSQ',152.413208333333,-15.5313055555556,NULL,NULL,'2013-01-03 03:45:23',56295.1565200002,19.6461,0.1789,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_snap_94727.gif',41165095704,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643204620,10050072,NULL,NULL,NULL,NULL),(10536,10529,0,'LSQ13dr','LSQ',152.413625,-15.5309166666667,NULL,NULL,'2013-01-05 05:02:44',56297.2102399999,20.2799,0.1328,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_snap_94728.gif',41165095588,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643204618,10050072,NULL,NULL,NULL,NULL),(10537,10529,0,'LSQ13dr','LSQ',152.413375,-15.5310555555556,NULL,NULL,'2013-01-09 03:23:49',56301.1415499998,19.4073,0.1106,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_snap_94674.gif',41165095704,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643204620,10050072,NULL,NULL,NULL,NULL),(10538,10529,0,'LSQ13dr','LSQ',152.413041666667,-15.5311944444444,NULL,NULL,'2013-01-09 05:25:02',56301.22572,19.046,0.0836,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_snap_94675.gif',41165095704,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643204620,10050072,NULL,NULL,NULL,NULL),(10539,10539,1,'LSQ13do','LSQ',70.3165,-15.62575,NULL,NULL,'2013-01-05 02:17:45',56297.0956600001,20.9059,0.1608,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_snap_94705.gif',37538165033,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586533828,9164591,NULL,NULL,NULL,NULL),(10540,10539,0,'LSQ13do','LSQ',70.316625,-15.62575,NULL,NULL,'2013-01-05 04:29:17',56297.18701,20.3924,0.1607,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_snap_94706.gif',37538165033,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586533828,9164591,NULL,NULL,NULL,NULL),(10541,10539,0,'LSQ13do','LSQ',70.3165416666667,-15.62575,NULL,NULL,'2013-01-07 02:12:42',56299.09216,20.5204,0.1888,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_snap_94707.gif',37538165033,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586533828,9164591,NULL,NULL,NULL,NULL),(10542,10539,0,'LSQ13do','LSQ',70.3165,-15.6256666666667,NULL,NULL,'2013-01-07 04:21:01',56299.1812700001,20.0936,0.1585,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_snap_94708.gif',37538165033,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586533828,9164591,NULL,NULL,NULL,NULL),(10543,10539,0,'LSQ13do','LSQ',70.3165416666667,-15.62575,NULL,NULL,'2013-01-09 02:14:26',56301.0933599998,20.276,0.1216,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_snap_94668.gif',37538165033,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586533828,9164591,NULL,NULL,NULL,NULL),(10544,10539,0,'LSQ13do','LSQ',70.316625,-15.62575,NULL,NULL,'2013-01-09 04:19:37',56301.1803000001,20.284,0.1465,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_snap_94669.gif',37538165033,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586533828,9164591,NULL,NULL,NULL,NULL),(10545,10539,0,'LSQ13do','LSQ',70.3165833333333,-15.6256944444444,NULL,NULL,'2013-01-11 03:25:37',56303.1428,19.8204,0.1383,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_snap_95791.gif',37538165033,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586533828,9164591,NULL,NULL,NULL,NULL),(10546,10546,1,'LSQ13dn','LSQ',197.188791666667,-16.9676666666667,NULL,NULL,'2013-01-03 06:40:08',56295.27788,19.2952,0.1452,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dn/LSQ13dn_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dn/LSQ13dn_snap_94701.gif',44009418377,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,687647162,10744486,NULL,NULL,NULL,NULL),(10547,10546,0,'LSQ13dn','LSQ',197.188708333333,-16.96775,NULL,NULL,'2013-01-03 07:57:20',56295.3314899998,18.9148,0.1415,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-13 11:29:05','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dn/LSQ13dn_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dn/LSQ13dn_snap_94702.gif',44009418377,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,687647162,10744486,NULL,NULL,NULL,NULL),(10548,10546,0,'LSQ13dn','LSQ',197.188791666667,-16.9676388888889,NULL,NULL,'2013-01-07 06:23:19',56299.2662,19.3829,0.1415,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-13 11:29:05','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dn/LSQ13dn_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dn/LSQ13dn_snap_94703.gif',44009418377,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,687647162,10744486,NULL,NULL,NULL,NULL),(10549,10546,0,'LSQ13dn','LSQ',197.188875,-16.9676666666667,NULL,NULL,'2013-01-07 07:36:36',56299.31709,19.2602,0.1074,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-13 11:29:05','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dn/LSQ13dn_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dn/LSQ13dn_snap_94704.gif',44009418377,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,687647162,10744486,NULL,NULL,NULL,NULL),(10550,10546,0,'LSQ13dn','LSQ',197.188916666667,-16.9676944444444,NULL,NULL,'2013-01-09 06:22:22',56301.2655400001,19.5391,0.0821,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-13 11:29:05','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dn/LSQ13dn_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dn/LSQ13dn_snap_94666.gif',44009418377,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,687647162,10744486,NULL,NULL,NULL,NULL),(10551,10546,0,'LSQ13dn','LSQ',197.188958333333,-16.9676944444444,NULL,NULL,'2013-01-09 07:48:01',56301.3250199999,19.5875,0.097,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-13 11:29:05','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dn/LSQ13dn_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dn/LSQ13dn_snap_94667.gif',44009418377,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,687647162,10744486,NULL,NULL,NULL,NULL),(10552,10552,1,'LSQ13dk','LSQ',162.77175,-19.0561944444444,NULL,NULL,'2013-01-05 06:50:02',56297.2847500001,20.1459,0.137,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dk/LSQ13dk_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dk/LSQ13dk_snap_94693.gif',41854614063,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653978344,10218411,NULL,NULL,NULL,NULL),(10553,10552,0,'LSQ13dk','LSQ',162.771666666667,-19.0561388888889,NULL,NULL,'2013-01-07 04:46:30',56299.1989600002,20.459,0.1748,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dk/LSQ13dk_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dk/LSQ13dk_snap_94694.gif',41854614063,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653978344,10218411,NULL,NULL,NULL,NULL),(10554,10552,0,'LSQ13dk','LSQ',162.771916666667,-19.0560833333333,NULL,NULL,'2013-01-07 06:49:51',56299.28462,20.358,0.1974,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dk/LSQ13dk_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dk/LSQ13dk_snap_94695.gif',41854614063,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653978344,10218411,NULL,NULL,NULL,NULL),(10555,10552,0,'LSQ13dk','LSQ',162.771708333333,-19.0561111111111,NULL,NULL,'2013-01-09 04:44:23',56301.1974999998,20.1032,0.165,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dk/LSQ13dk_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dk/LSQ13dk_snap_94660.gif',41854614063,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653978344,10218411,NULL,NULL,NULL,NULL),(10556,10552,0,'LSQ13dk','LSQ',162.771791666667,-19.0561388888889,NULL,NULL,'2013-01-09 06:43:44',56301.2803799999,20.7671,0.1515,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dk/LSQ13dk_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dk/LSQ13dk_snap_94661.gif',41854614063,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653978344,10218411,NULL,NULL,NULL,NULL),(10557,10552,0,'LSQ13dk','LSQ',162.771666666667,-19.0561388888889,NULL,NULL,'2013-01-11 05:00:28',56303.20866,20.4305,0.1495,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dk/LSQ13dk_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dk/LSQ13dk_snap_95771.gif',41854614063,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653978344,10218411,NULL,NULL,NULL,NULL),(10558,10558,1,'LSQ13dj','LSQ',159.891875,-16.4450277777778,NULL,NULL,'2013-01-05 06:50:02',56297.2847500001,19.3816,0.1232,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dj/LSQ13dj_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dj/LSQ13dj_snap_94692.gif',41833224827,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653644137,10213189,NULL,NULL,NULL,NULL),(10559,10558,0,'LSQ13dj','LSQ',159.891791666667,-16.4449722222222,NULL,NULL,'2013-01-09 04:44:23',56301.1974999998,19.4596,0.1463,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-13 12:09:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dj/LSQ13dj_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dj/LSQ13dj_snap_94658.gif',41833224827,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653644137,10213189,NULL,NULL,NULL,NULL),(10560,10558,0,'LSQ13dj','LSQ',159.891916666667,-16.4450833333333,NULL,NULL,'2013-01-09 06:43:44',56301.2803799999,19.5,0.1322,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-13 12:09:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dj/LSQ13dj_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dj/LSQ13dj_snap_94659.gif',41833224827,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653644137,10213189,NULL,NULL,NULL,NULL),(10561,10558,0,'LSQ13dj','LSQ',159.892,-16.445,NULL,NULL,'2013-01-11 05:00:28',56303.20866,19.5542,0.1322,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-13 12:09:20','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dj/LSQ13dj_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dj/LSQ13dj_snap_95790.gif',41833224827,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653644137,10213189,NULL,NULL,NULL,NULL),(10562,10562,1,'LSQ13ga','LSQ',166.772708333333,-23.8273055555556,NULL,NULL,'2013-01-08 05:13:24',56300.2176399999,20.9275,0.1434,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_snap_96119.gif',41842377387,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,653787146,10215424,NULL,NULL,NULL,NULL),(10563,10562,0,'LSQ13ga','LSQ',166.772708333333,-23.82725,NULL,NULL,'2013-01-08 08:03:27',56300.3357299999,21.004,0.1766,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_snap_96120.gif',41842377386,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,653787146,10215424,NULL,NULL,NULL,NULL),(10564,10562,0,'LSQ13ga','LSQ',166.772625,-23.8272777777778,NULL,NULL,'2013-01-10 05:08:20',56302.2141300002,20.6266,0.1466,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_snap_96013.gif',41842377387,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,653787146,10215424,NULL,NULL,NULL,NULL),(10565,10562,0,'LSQ13ga','LSQ',166.772625,-23.8272222222222,NULL,NULL,'2013-01-10 08:08:38',56302.3393299999,20.4725,0.1436,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_snap_96014.gif',41842377387,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,653787146,10215424,NULL,NULL,NULL,NULL),(10566,10562,0,'LSQ13ga','LSQ',166.772791666667,-23.8272222222222,NULL,NULL,'2013-01-12 05:07:36',56304.2136200001,20.1665,0.1933,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_snap_96334.gif',41842377386,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,653787146,10215424,NULL,NULL,NULL,NULL),(10567,10562,0,'LSQ13ga','LSQ',166.772708333333,-23.8272222222222,NULL,NULL,'2013-01-12 07:01:36',56304.2927799998,20.3885,0.1142,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_snap_96335.gif',41842377386,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,653787146,10215424,NULL,NULL,NULL,NULL),(10568,10568,1,'LSQ13fy','LSQ',160.588416666667,-23.8538333333333,NULL,NULL,'2012-12-31 05:16:54',56292.2200799999,19.9356,0.2105,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_snap_96100.gif',41632749654,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650511713,10164245,NULL,NULL,NULL,NULL),(10569,10568,0,'LSQ13fy','LSQ',160.5885,-23.8538055555556,NULL,NULL,'2012-12-31 07:50:45',56292.3269099998,19.5495,0.1623,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_snap_96101.gif',41632749654,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650511713,10164245,NULL,NULL,NULL,NULL),(10570,10568,0,'LSQ13fy','LSQ',160.588541666667,-23.85375,NULL,NULL,'2013-01-04 05:20:49',56296.22279,18.7122,0.1208,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_snap_96102.gif',41632749654,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650511713,10164245,NULL,NULL,NULL,NULL),(10571,10568,0,'LSQ13fy','LSQ',160.588541666667,-23.8538333333333,NULL,NULL,'2013-01-04 07:04:30',56296.2947999998,19.397,0.1399,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_snap_96103.gif',41632749654,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650511713,10164245,NULL,NULL,NULL,NULL),(10572,10568,0,'LSQ13fy','LSQ',160.5885,-23.8537777777778,NULL,NULL,'2013-01-06 05:10:15',56298.2154600001,18.7336,0.0702,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_snap_96104.gif',41632749654,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650511713,10164245,NULL,NULL,NULL,NULL),(10573,10568,0,'LSQ13fy','LSQ',160.588541666667,-23.85375,NULL,NULL,'2013-01-06 08:01:39',56298.3344800002,18.9846,0.0913,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_snap_96105.gif',41632749654,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650511713,10164245,NULL,NULL,NULL,NULL),(10574,10568,0,'LSQ13fy','LSQ',160.588541666667,-23.85375,NULL,NULL,'2013-01-08 05:10:01',56300.2152900002,18.8745,0.0557,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_snap_96106.gif',41632749654,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650511713,10164245,NULL,NULL,NULL,NULL),(10575,10568,0,'LSQ13fy','LSQ',160.588458333333,-23.85375,NULL,NULL,'2013-01-08 07:00:50',56300.2922499999,18.8788,0.0847,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_snap_96107.gif',41632749654,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650511713,10164245,NULL,NULL,NULL,NULL),(10576,10568,0,'LSQ13fy','LSQ',160.588541666667,-23.85375,NULL,NULL,'2013-01-10 05:04:57',56302.21178,18.962,0.0568,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_snap_96009.gif',41632749654,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650511713,10164245,NULL,NULL,NULL,NULL),(10577,10568,0,'LSQ13fy','LSQ',160.588541666667,-23.8537777777778,NULL,NULL,'2013-01-10 06:59:04',56302.29103,18.9447,0.0751,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_snap_96010.gif',41632749654,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650511713,10164245,NULL,NULL,NULL,NULL),(10578,10568,0,'LSQ13fy','LSQ',160.5885,-23.8537777777778,NULL,NULL,'2013-01-12 05:04:14',56304.2112799999,18.948,0.1004,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_snap_96336.gif',41632749654,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650511713,10164245,NULL,NULL,NULL,NULL),(10579,10568,0,'LSQ13fy','LSQ',160.588541666667,-23.8538055555556,NULL,NULL,'2013-01-12 07:33:49',56304.3151600002,18.7098,0.2043,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_snap_96337.gif',41632749654,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650511713,10164245,NULL,NULL,NULL,NULL),(10580,10580,1,'LSQ13fu','LSQ',186.445916666667,-28.2343055555556,NULL,NULL,'2013-01-08 05:45:55',56300.24022,15.934,0.0059,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_snap_96076.gif',43403591765,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,678181121,10596580,NULL,NULL,NULL,NULL),(10581,10580,0,'LSQ13fu','LSQ',186.445791666667,-28.2343333333333,NULL,NULL,'2013-01-08 07:19:29',56300.3051999998,15.9395,0.0062,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_snap_96077.gif',43403591765,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,678181121,10596580,NULL,NULL,NULL,NULL),(10582,10580,0,'LSQ13fu','LSQ',186.445916666667,-28.2343055555556,NULL,NULL,'2013-01-10 05:39:06',56302.2354899999,15.6859,0.0052,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_snap_96001.gif',43403591765,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,678181121,10596580,NULL,NULL,NULL,NULL),(10583,10580,0,'LSQ13fu','LSQ',186.445833333333,-28.2343333333333,NULL,NULL,'2013-01-10 07:15:57',56302.3027499998,15.6778,0.005,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_snap_96002.gif',43403591765,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,678181121,10596580,NULL,NULL,NULL,NULL),(10584,10580,0,'LSQ13fu','LSQ',186.445916666667,-28.2342777777778,NULL,NULL,'2013-01-12 05:29:41',56304.2289499999,15.4383,0.0066,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_snap_96380.gif',43403591765,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,678181121,10596580,NULL,NULL,NULL,NULL),(10585,10580,0,'LSQ13fu','LSQ',186.445875,-28.2342777777778,NULL,NULL,'2013-01-12 07:13:26',56304.301,15.4608,0.0044,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_snap_96381.gif',43403591765,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,678181121,10596580,NULL,NULL,NULL,NULL),(10586,10586,1,'LSQ13ft','LSQ',184.047708333333,-26.1165,NULL,NULL,'2013-01-06 05:34:07',56298.2320300001,17.4209,0.0376,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_snap_96073.gif',43416143131,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,678377236,10599644,NULL,NULL,NULL,NULL),(10587,10586,0,'LSQ13ft','LSQ',184.047666666667,-26.1165,NULL,NULL,'2013-01-06 07:12:32',56298.3003799999,16.9239,0.0966,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_snap_96074.gif',43416143131,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,678377236,10599644,NULL,NULL,NULL,NULL),(10588,10586,0,'LSQ13ft','LSQ',184.047541666667,-26.1165,NULL,NULL,'2013-01-08 07:10:58',56300.29929,16.9158,0.0404,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_snap_96075.gif',43416143131,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,678377236,10599644,NULL,NULL,NULL,NULL),(10589,10586,0,'LSQ13ft','LSQ',184.047625,-26.1165,NULL,NULL,'2013-01-10 05:20:09',56302.2223299998,16.9034,0.1053,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_snap_95999.gif',43416143131,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,678377236,10599644,NULL,NULL,NULL,NULL),(10590,10586,0,'LSQ13ft','LSQ',184.047625,-26.1165277777778,NULL,NULL,'2013-01-10 07:07:31',56302.2968899999,16.9895,0.0293,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_snap_96000.gif',43416143131,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,678377236,10599644,NULL,NULL,NULL,NULL),(10591,10586,0,'LSQ13ft','LSQ',184.048208333333,-26.1165833333333,NULL,NULL,'2013-01-12 05:12:46',56304.2171999998,17.4126,0.0228,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_snap_96330.gif',43416143130,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,678377236,10599644,NULL,NULL,NULL,NULL),(10592,10586,0,'LSQ13ft','LSQ',184.047708333333,-26.1165277777778,NULL,NULL,'2013-01-12 07:28:43',56304.3116100002,17.2806,0.06,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_snap_96331.gif',43416143131,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,678377236,10599644,NULL,NULL,NULL,NULL),(10593,10593,1,'LSQ13fp','LSQ',176.491625,-27.2271666666667,NULL,NULL,'2012-12-29 07:15:40',56290.3025500001,16.6299,0.0245,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_snap_96060.gif',41471449660,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647991400,10124865,NULL,NULL,NULL,NULL),(10594,10593,0,'LSQ13fp','LSQ',176.491791666667,-27.2271388888889,NULL,NULL,'2012-12-31 05:42:59',56292.2381899999,16.1581,0.015,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_snap_96061.gif',41471449660,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647991400,10124865,NULL,NULL,NULL,NULL),(10595,10593,0,'LSQ13fp','LSQ',176.491708333333,-27.2271666666667,NULL,NULL,'2012-12-31 07:13:22',56292.3009500001,16.2136,0.0122,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_snap_96062.gif',41471449660,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647991400,10124865,NULL,NULL,NULL,NULL),(10596,10593,0,'LSQ13fp','LSQ',176.491708333333,-27.2271111111111,NULL,NULL,'2013-01-04 05:25:54',56296.22633,15.4447,0.0082,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_snap_96063.gif',41471449660,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647991400,10124865,NULL,NULL,NULL,NULL),(10597,10593,0,'LSQ13fp','LSQ',176.491708333333,-27.2271388888889,NULL,NULL,'2013-01-04 07:58:36',56296.33237,15.4825,0.0072,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_snap_96064.gif',41471449660,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647991400,10124865,NULL,NULL,NULL,NULL),(10598,10593,0,'LSQ13fp','LSQ',176.491791666667,-27.2270833333333,NULL,NULL,'2013-01-06 05:13:48',56298.2179200002,15.2165,0.0045,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_snap_96065.gif',41471449660,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647991400,10124865,NULL,NULL,NULL,NULL),(10599,10593,0,'LSQ13fp','LSQ',176.49175,-27.2271388888889,NULL,NULL,'2013-01-06 05:17:09',56298.2202499998,15.2182,0.0049,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_snap_96066.gif',41471449660,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647991400,10124865,NULL,NULL,NULL,NULL),(10600,10593,0,'LSQ13fp','LSQ',176.491791666667,-27.2271111111111,NULL,NULL,'2013-01-08 05:08:19',56300.2141100001,15.0321,0.0034,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_snap_96067.gif',41471449660,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647991400,10124865,NULL,NULL,NULL,NULL),(10601,10593,0,'LSQ13fp','LSQ',176.491708333333,-27.2271666666667,NULL,NULL,'2013-01-08 08:05:09',56300.3369100001,14.9859,0.0039,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_snap_96068.gif',41471449660,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647991400,10124865,NULL,NULL,NULL,NULL),(10602,10593,0,'LSQ13fp','LSQ',176.49175,-27.2271388888889,NULL,NULL,'2013-01-10 05:03:13',56302.2105700001,14.8933,0.0033,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_snap_95991.gif',41471449660,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647991400,10124865,NULL,NULL,NULL,NULL),(10603,10593,0,'LSQ13fp','LSQ',176.491708333333,-27.2271388888889,NULL,NULL,'2013-01-10 08:10:20',56302.34051,14.8441,0.0028,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_snap_95992.gif',41471449660,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647991400,10124865,NULL,NULL,NULL,NULL),(10604,10593,0,'LSQ13fp','LSQ',176.49175,-27.2270833333333,NULL,NULL,'2013-01-12 05:02:30',56304.21007,14.699,0.0039,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_snap_96385.gif',41471449660,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647991400,10124865,NULL,NULL,NULL,NULL),(10605,10593,0,'LSQ13fp','LSQ',176.49175,-27.2271111111111,NULL,NULL,'2013-01-12 06:59:54',56304.2916000001,14.5593,0.0055,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_snap_96386.gif',41471449660,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647991400,10124865,NULL,NULL,NULL,NULL),(10606,10606,1,'LSQ13fn','LSQ',177.822041666667,-29.6114444444444,NULL,NULL,'2013-01-10 05:01:32',56302.2094000001,20.0867,0.1189,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fn/LSQ13fn_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fn/LSQ13fn_snap_95987.gif',41453071886,NULL,NULL,NULL,'2013-01-06 07:01:55',56298.293,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,647704248,10120378,NULL,NULL,NULL,NULL),(10607,10606,0,'LSQ13fn','LSQ',177.821958333333,-29.6114166666667,NULL,NULL,'2013-01-10 08:12:01',56302.3416800001,20.0992,0.1423,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-13 14:59:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fn/LSQ13fn_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fn/LSQ13fn_snap_95988.gif',41453071886,NULL,NULL,NULL,'2013-01-06 07:01:55',56298.293,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,647704248,10120378,NULL,NULL,NULL,NULL),(10608,10606,0,'LSQ13fn','LSQ',177.822,-29.6114722222222,NULL,NULL,'2013-01-12 05:00:48',56304.2089,19.8958,0.1599,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-13 14:59:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fn/LSQ13fn_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fn/LSQ13fn_snap_96327.gif',41453071886,NULL,NULL,NULL,'2013-01-06 07:01:55',56298.293,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,647704248,10120378,NULL,NULL,NULL,NULL),(10609,10606,0,'LSQ13fn','LSQ',177.822166666667,-29.6114166666667,NULL,NULL,'2013-01-12 06:58:13',56304.2904300001,19.8161,0.1616,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-13 14:59:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fn/LSQ13fn_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fn/LSQ13fn_snap_96328.gif',41453071886,NULL,NULL,NULL,'2013-01-06 07:01:55',56298.293,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,647704248,10120378,NULL,NULL,NULL,NULL),(10610,10610,1,'LSQ13fk','LSQ',74.1178333333333,-25.6731944444444,NULL,NULL,'2013-01-04 02:34:54',56296.1075800001,20.3662,0.1792,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_snap_95978.gif',37228569814,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581696403,9089006,NULL,NULL,NULL,NULL),(10611,10610,0,'LSQ13fk','LSQ',74.1178333333333,-25.6731944444444,NULL,NULL,'2013-01-04 04:45:27',56296.1982399998,19.7035,0.1521,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_snap_95979.gif',37228569814,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581696403,9089006,NULL,NULL,NULL,NULL),(10612,10610,0,'LSQ13fk','LSQ',74.1178333333333,-25.6732222222222,NULL,NULL,'2013-01-06 02:26:44',56298.1019000001,20.5241,0.1742,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_snap_95980.gif',37228569814,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581696403,9089006,NULL,NULL,NULL,NULL),(10613,10610,0,'LSQ13fk','LSQ',74.1179583333333,-25.6732777777778,NULL,NULL,'2013-01-06 04:35:05',56298.1910399999,20.1373,0.141,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_snap_95981.gif',37228569641,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581696400,9089006,NULL,NULL,NULL,NULL),(10614,10610,0,'LSQ13fk','LSQ',74.1177916666667,-25.6731944444444,NULL,NULL,'2013-01-08 02:19:31',56300.0968900002,19.8584,0.1402,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_snap_95982.gif',37228569814,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581696403,9089006,NULL,NULL,NULL,NULL),(10615,10610,0,'LSQ13fk','LSQ',74.117875,-25.67325,NULL,NULL,'2013-01-10 02:11:17',56302.09118,18.9565,0.0857,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_snap_95909.gif',37228569641,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581696400,9089006,NULL,NULL,NULL,NULL),(10616,10610,0,'LSQ13fk','LSQ',74.1179166666667,-25.6731944444444,NULL,NULL,'2013-01-10 04:24:22',56302.18359,19.9327,0.125,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_snap_95910.gif',37228569814,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581696403,9089006,NULL,NULL,NULL,NULL),(10617,10610,0,'LSQ13fk','LSQ',74.1179166666667,-25.6731944444444,NULL,NULL,'2013-01-12 02:20:16',56304.0974099999,19.6835,0.0984,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_snap_96313.gif',37228569814,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581696403,9089006,NULL,NULL,NULL,NULL),(10618,10618,1,'LSQ13fh','LSQ',54.7329583333333,-29.6147777777778,NULL,NULL,'2012-12-16 03:21:10',56277.1397099998,16.7212,0.1149,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fh/LSQ13fh_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fh/LSQ13fh_snap_95966.gif',38587434602,NULL,NULL,NULL,'2012-12-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602928665,9420760,NULL,NULL,NULL,NULL),(10619,10618,0,'LSQ13fh','LSQ',54.733125,-29.6145833333333,NULL,NULL,'2013-01-08 02:54:06',56300.1209100001,16.239,0.0358,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fh/LSQ13fh_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fh/LSQ13fh_snap_95967.gif',38587434602,NULL,NULL,NULL,'2012-12-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602928665,9420760,NULL,NULL,NULL,NULL),(10620,10618,0,'LSQ13fh','LSQ',54.7328333333333,-29.6149444444444,NULL,NULL,'2013-01-10 02:56:11',56302.1223599999,16.4564,0.0648,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fh/LSQ13fh_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fh/LSQ13fh_snap_95903.gif',38587434602,NULL,NULL,NULL,'2012-12-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602928665,9420760,NULL,NULL,NULL,NULL),(10621,10618,0,'LSQ13fh','LSQ',54.732875,-29.6147222222222,NULL,NULL,'2013-01-10 04:07:02',56302.1715600002,16.8302,0.0683,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fh/LSQ13fh_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fh/LSQ13fh_snap_95904.gif',38587434602,NULL,NULL,NULL,'2012-12-12 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602928665,9420760,NULL,NULL,NULL,NULL),(10622,10622,1,'LSQ13fg','LSQ',52.7803333333333,-29.7260833333333,NULL,NULL,'2013-01-06 01:30:06',56298.0625700001,20.9559,0.1524,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fg/LSQ13fg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fg/LSQ13fg_snap_95964.gif',38573776140,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602715252,9417425,NULL,NULL,NULL,NULL),(10623,10622,0,'LSQ13fg','LSQ',52.7804166666667,-29.726,NULL,NULL,'2013-01-08 02:54:06',56300.1209100001,20.5865,0.1249,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fg/LSQ13fg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fg/LSQ13fg_snap_95965.gif',38573776140,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602715252,9417425,NULL,NULL,NULL,NULL),(10624,10622,0,'LSQ13fg','LSQ',52.780375,-29.726,NULL,NULL,'2013-01-10 02:56:11',56302.1223599999,20.3713,0.1385,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fg/LSQ13fg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fg/LSQ13fg_snap_95901.gif',38573776140,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602715252,9417425,NULL,NULL,NULL,NULL),(10625,10622,0,'LSQ13fg','LSQ',52.7804166666667,-29.726,NULL,NULL,'2013-01-10 04:07:02',56302.1715600002,20.1163,0.1301,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fg/LSQ13fg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fg/LSQ13fg_snap_95902.gif',38573776140,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602715252,9417425,NULL,NULL,NULL,NULL),(10626,10626,1,'LSQ13ff','LSQ',52.9829583333333,-29.4225277777778,NULL,NULL,'2012-12-12 01:19:48',56273.0554200001,19.986,0.0898,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_history.html','transient',NULL,0.139,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_snap_95957.gif',38584578427,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602884037,9420063,NULL,NULL,NULL,NULL),(10627,10626,0,'LSQ13ff','LSQ',52.9827083333333,-29.4225833333333,NULL,NULL,'2012-12-16 01:21:24',56277.0565300002,19.915,0.0637,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_history.html','transient',NULL,0.139,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_snap_95958.gif',38584578427,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602884037,9420063,NULL,NULL,NULL,NULL),(10628,10626,0,'LSQ13ff','LSQ',52.98325,-29.4226944444444,NULL,NULL,'2012-12-25 01:47:21',56286.07455,20.3666,0.1843,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_history.html','transient',NULL,0.139,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_snap_95959.gif',38584578427,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602884037,9420063,NULL,NULL,NULL,NULL),(10629,10626,0,'LSQ13ff','LSQ',52.9832916666667,-29.4226666666667,NULL,NULL,'2012-12-29 01:55:12',56290.0800100002,20.1517,0.2125,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_history.html','transient',NULL,0.139,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_snap_95960.gif',38584578427,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602884037,9420063,NULL,NULL,NULL,NULL),(10630,10626,0,'LSQ13ff','LSQ',52.9832916666667,-29.4228055555556,NULL,NULL,'2013-01-04 01:36:45',56296.0671899999,21.538,0.2028,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_history.html','transient',NULL,0.139,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_snap_95961.gif',38584578427,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602884037,9420063,NULL,NULL,NULL,NULL),(10631,10626,0,'LSQ13ff','LSQ',52.9829583333333,-29.4227777777778,NULL,NULL,'2013-01-04 03:37:43',56296.1512000002,20.9421,0.1107,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_history.html','transient',NULL,0.139,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_snap_95962.gif',38584578427,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602884037,9420063,NULL,NULL,NULL,NULL),(10632,10626,0,'LSQ13ff','LSQ',52.98275,-29.4227222222222,NULL,NULL,'2013-01-06 03:31:01',56298.1465500002,21.4591,0.1572,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_history.html','transient',NULL,0.139,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_snap_95963.gif',38584578427,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602884037,9420063,NULL,NULL,NULL,NULL),(10633,10626,0,'LSQ13ff','LSQ',52.9828333333333,-29.4226388888889,NULL,NULL,'2013-01-10 02:56:11',56302.1223599999,20.809,0.1116,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_history.html','transient',NULL,0.139,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_snap_95899.gif',38584578427,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602884037,9420063,NULL,NULL,NULL,NULL),(10634,10626,0,'LSQ13ff','LSQ',52.9827916666667,-29.4227222222222,NULL,NULL,'2013-01-10 04:07:02',56302.1715600002,21.1469,0.1408,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_history.html','transient',NULL,0.139,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_snap_95900.gif',38584578427,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602884037,9420063,NULL,NULL,NULL,NULL),(10635,10635,1,'LSQ13fe','LSQ',54.080625,-29.7517777777778,NULL,NULL,'2012-12-12 01:19:48',56273.0554200001,22.5906,0.1935,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_snap_95949.gif',38584794846,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,602887419,9420115,NULL,NULL,NULL,NULL),(10636,10635,0,'LSQ13fe','LSQ',54.08075,-29.7518333333333,NULL,NULL,'2012-12-12 03:19:56',56273.1388500002,22.1413,0.2079,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_snap_95950.gif',38584794846,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,602887419,9420115,NULL,NULL,NULL,NULL),(10637,10635,0,'LSQ13fe','LSQ',54.0807916666667,-29.7517222222222,NULL,NULL,'2012-12-20 03:06:22',56281.1294300002,21.1733,0.1736,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_snap_95951.gif',38584794846,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,602887419,9420115,NULL,NULL,NULL,NULL),(10638,10635,0,'LSQ13fe','LSQ',54.0808333333333,-29.7517222222222,NULL,NULL,'2012-12-20 04:55:48',56281.20542,21.7167,0.1711,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_snap_95952.gif',38584794846,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,602887419,9420115,NULL,NULL,NULL,NULL),(10639,10635,0,'LSQ13fe','LSQ',54.080625,-29.7518055555556,NULL,NULL,'2012-12-22 03:27:38',56283.1442,21.007,0.168,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_snap_95953.gif',38584794846,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,602887419,9420115,NULL,NULL,NULL,NULL),(10640,10635,0,'LSQ13fe','LSQ',54.0806666666667,-29.7517777777778,NULL,NULL,'2012-12-23 01:46:31',56284.0739799999,21.5589,0.1878,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_snap_95954.gif',38584794846,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,602887419,9420115,NULL,NULL,NULL,NULL),(10641,10635,0,'LSQ13fe','LSQ',54.0804583333333,-29.7518333333333,NULL,NULL,'2013-01-04 01:36:45',56296.0671899999,21.0117,0.0505,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_snap_95955.gif',38584794846,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,602887419,9420115,NULL,NULL,NULL,NULL),(10642,10635,0,'LSQ13fe','LSQ',54.0808333333333,-29.75175,NULL,NULL,'2013-01-04 03:37:43',56296.1512000002,22.0237,0.1415,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_snap_95956.gif',38584794846,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,602887419,9420115,NULL,NULL,NULL,NULL),(10643,10635,0,'LSQ13fe','LSQ',54.0805416666667,-29.7517777777778,NULL,NULL,'2013-01-10 02:56:11',56302.1223599999,21.6551,0.0919,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_snap_95897.gif',38584794846,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,602887419,9420115,NULL,NULL,NULL,NULL),(10644,10635,0,'LSQ13fe','LSQ',54.0809166666667,-29.7517222222222,NULL,NULL,'2013-01-10 04:07:02',56302.1715600002,21.5777,0.1064,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fe/LSQ13fe_snap_95898.gif',38584794846,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,602887419,9420115,NULL,NULL,NULL,NULL),(10645,10645,1,'LSQ13fc','LSQ',78.76425,-34.5680277777778,NULL,NULL,'2013-01-06 02:50:29',56298.1184,20.0863,0.1982,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_snap_95934.gif',37276987739,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,582452933,9100827,NULL,NULL,NULL,NULL),(10646,10645,0,'LSQ13fc','LSQ',78.7640416666667,-34.5678611111111,NULL,NULL,'2013-01-06 04:58:54',56298.2075800002,19.947,0.1862,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_snap_95935.gif',37276987739,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,582452933,9100827,NULL,NULL,NULL,NULL),(10647,10645,0,'LSQ13fc','LSQ',78.764125,-34.5679166666667,NULL,NULL,'2013-01-08 02:43:23',56300.1134700002,20.3318,0.1773,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_snap_95936.gif',37276987739,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,582452933,9100827,NULL,NULL,NULL,NULL),(10648,10645,0,'LSQ13fc','LSQ',78.7640833333333,-34.5679166666667,NULL,NULL,'2013-01-10 02:35:06',56302.1077100001,20.0244,0.1586,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_snap_95893.gif',37276987739,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,582452933,9100827,NULL,NULL,NULL,NULL),(10649,10645,0,'LSQ13fc','LSQ',78.7641666666667,-34.5679444444444,NULL,NULL,'2013-01-10 04:48:10',56302.2001200002,20.1009,0.1576,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_snap_95894.gif',37276987739,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,582452933,9100827,NULL,NULL,NULL,NULL),(10650,10645,0,'LSQ13fc','LSQ',78.7640833333333,-34.5679444444444,NULL,NULL,'2013-01-12 02:44:06',56304.1139600002,20.2939,0.1414,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_snap_96300.gif',37276987739,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,582452933,9100827,NULL,NULL,NULL,NULL),(10651,10645,0,'LSQ13fc','LSQ',78.7640416666667,-34.5678888888889,NULL,NULL,'2013-01-12 04:49:16',56304.2008799999,20.0108,0.2022,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_snap_96301.gif',37276987739,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,582452933,9100827,NULL,NULL,NULL,NULL),(10652,10652,1,'LSQ13fb','LSQ',73.90425,-32.0217777777778,NULL,NULL,'2013-01-06 04:45:18',56298.1981299999,20.8452,0.1733,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_snap_95931.gif',37210488481,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581413882,9084591,NULL,NULL,NULL,NULL),(10653,10652,0,'LSQ13fb','LSQ',73.90425,-32.0216944444444,NULL,NULL,'2013-01-08 02:29:45',56300.1039999998,19.8553,0.2123,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_snap_95932.gif',37210488481,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581413882,9084591,NULL,NULL,NULL,NULL),(10654,10652,0,'LSQ13fb','LSQ',73.9042083333333,-32.0217222222222,NULL,NULL,'2013-01-08 04:41:33',56300.1955300001,19.9385,0.1233,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_snap_95933.gif',37210488481,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581413882,9084591,NULL,NULL,NULL,NULL),(10655,10652,0,'LSQ13fb','LSQ',73.9042083333333,-32.0216944444444,NULL,NULL,'2013-01-10 02:21:29',56302.0982599999,19.4388,0.1201,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_snap_95891.gif',37210488481,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581413882,9084591,NULL,NULL,NULL,NULL),(10656,10652,0,'LSQ13fb','LSQ',73.9042083333333,-32.0216944444444,NULL,NULL,'2013-01-10 04:34:34',56302.19068,19.2426,0.0874,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_snap_95892.gif',37210488481,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581413882,9084591,NULL,NULL,NULL,NULL),(10657,10652,0,'LSQ13fb','LSQ',73.90425,-32.0217222222222,NULL,NULL,'2013-01-12 02:30:28',56304.1044999999,19.2722,0.0916,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 18:20:01','2013-01-12 18:20:01','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_snap_96302.gif',37210488481,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581413882,9084591,NULL,NULL,NULL,NULL),(10658,10658,1,'LSQ13gz','LSQ',184.854041666667,-34.4328888888889,NULL,NULL,'2013-01-10 05:35:43',56302.2331400001,19.0601,0.0623,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 19:46:28','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13gz/LSQ13gz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13gz/LSQ13gz_snap_96560.gif',43442901111,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,678795329,10606177,NULL,NULL,NULL,NULL),(10659,10658,0,'LSQ13gz','LSQ',184.854083333333,-34.4328611111111,NULL,NULL,'2013-01-10 07:14:15',56302.3015700001,19.0455,0.0617,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 19:46:28','2013-01-12 19:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13gz/LSQ13gz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13gz/LSQ13gz_snap_96561.gif',43442901111,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,678795329,10606177,NULL,NULL,NULL,NULL),(10660,10658,0,'LSQ13gz','LSQ',184.854125,-34.4329166666667,NULL,NULL,'2013-01-12 05:22:55',56304.22425,19.1492,0.1282,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 19:46:28','2013-01-12 19:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13gz/LSQ13gz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13gz/LSQ13gz_snap_96509.gif',43442901110,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,678795329,10606177,NULL,NULL,NULL,NULL),(10661,10658,0,'LSQ13gz','LSQ',184.854083333333,-34.4328611111111,NULL,NULL,'2013-01-12 07:10:04',56304.2986599999,19.3476,0.059,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 19:46:28','2013-01-12 19:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13gz/LSQ13gz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13gz/LSQ13gz_snap_96510.gif',43442901111,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,678795329,10606177,NULL,NULL,NULL,NULL),(10662,10662,1,'LSQ13hq','LSQ',203.171458333333,-23.1677777777778,NULL,NULL,'2013-01-08 07:48:12',56300.3251499999,19.3269,0.0882,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 20:46:28','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hq/LSQ13hq_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hq/LSQ13hq_snap_96612.gif',43769262679,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,683894729,10685855,NULL,NULL,NULL,NULL),(10663,10662,0,'LSQ13hq','LSQ',203.171416666667,-23.1677222222222,NULL,NULL,'2013-01-10 07:44:47',56302.32277,19.4792,0.0806,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 20:46:28','2013-01-12 20:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hq/LSQ13hq_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hq/LSQ13hq_snap_96613.gif',43769262679,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,683894729,10685855,NULL,NULL,NULL,NULL),(10664,10662,0,'LSQ13hq','LSQ',203.171416666667,-23.1678055555556,NULL,NULL,'2013-01-12 08:13:13',56304.3425199999,19.116,0.0587,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 20:46:28','2013-01-12 20:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hq/LSQ13hq_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hq/LSQ13hq_snap_96602.gif',43769262679,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,683894729,10685855,NULL,NULL,NULL,NULL),(10665,10662,0,'LSQ13hq','LSQ',203.171416666667,-23.1677777777778,NULL,NULL,'2013-01-12 08:42:32',56304.3628799999,19.3548,0.0918,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 20:46:28','2013-01-12 20:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hq/LSQ13hq_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hq/LSQ13hq_snap_96603.gif',43769262679,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,683894729,10685855,NULL,NULL,NULL,NULL),(10666,10666,1,'LSQ13hm','LSQ',181.758,-25.6000555555556,NULL,NULL,'2012-12-25 07:28:11',56286.3112499998,15.6263,0.0334,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 20:46:28','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hm/LSQ13hm_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hm/LSQ13hm_snap_96590.gif',43357845176,NULL,NULL,NULL,'2012-12-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,677466330,10585411,NULL,NULL,NULL,NULL),(10667,10666,0,'LSQ13hm','LSQ',181.757333333333,-25.5995833333333,NULL,NULL,'2012-12-29 05:58:45',56290.24914,15.7073,0.0098,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 20:46:28','2013-01-12 20:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hm/LSQ13hm_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hm/LSQ13hm_snap_96591.gif',43357845125,NULL,NULL,NULL,'2012-12-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,677466330,10585411,NULL,NULL,NULL,NULL),(10668,10666,0,'LSQ13hm','LSQ',181.757291666667,-25.5996111111111,NULL,NULL,'2012-12-31 05:48:21',56292.2419099999,16.5181,0.0172,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 20:46:28','2013-01-12 20:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hm/LSQ13hm_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hm/LSQ13hm_snap_96592.gif',43357845125,NULL,NULL,NULL,'2012-12-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,677466330,10585411,NULL,NULL,NULL,NULL),(10669,10666,0,'LSQ13hm','LSQ',181.757416666667,-25.5995555555556,NULL,NULL,'2012-12-31 07:16:44',56292.3032900002,17.2316,0.0292,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 20:46:28','2013-01-12 20:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hm/LSQ13hm_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hm/LSQ13hm_snap_96593.gif',43357845125,NULL,NULL,NULL,'2012-12-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,677466330,10585411,NULL,NULL,NULL,NULL),(10670,10666,0,'LSQ13hm','LSQ',181.757375,-25.5995555555556,NULL,NULL,'2013-01-10 07:12:35',56302.3004100001,15.7918,0.0066,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 20:46:28','2013-01-12 20:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hm/LSQ13hm_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hm/LSQ13hm_snap_96594.gif',43357845125,NULL,NULL,NULL,'2012-12-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,677466330,10585411,NULL,NULL,NULL,NULL),(10671,10666,0,'LSQ13hm','LSQ',181.757416666667,-25.5996388888889,NULL,NULL,'2013-01-12 05:26:17',56304.2265900001,15.7292,0.0125,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 20:46:28','2013-01-12 20:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hm/LSQ13hm_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hm/LSQ13hm_snap_96535.gif',43357845125,NULL,NULL,NULL,'2012-12-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,677466330,10585411,NULL,NULL,NULL,NULL),(10672,10666,0,'LSQ13hm','LSQ',181.757458333333,-25.5995277777778,NULL,NULL,'2013-01-12 07:15:09',56304.3021900002,16.7614,0.025,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-12 20:46:28','2013-01-12 20:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hm/LSQ13hm_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13hm/LSQ13hm_snap_96536.gif',43357845125,NULL,NULL,NULL,'2012-12-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,677466330,10585411,NULL,NULL,NULL,NULL),(10673,10546,0,'LSQ13dn','pessto',197.188791667,-16.9676666667,NULL,NULL,'2013-01-13 07:11:59',56305.3,NULL,NULL,NULL,0.105,NULL,'Ia',NULL,'2013-01-13 11:29:04','2013-01-13 11:29:05','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,44009418377,'NTT','EFOSC2','Mattias Ergon','2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,687647162,10744486,NULL,NULL,NULL,NULL),(10674,10524,0,'LSQ13ds','pessto',152.524958333,-16.1156944444,NULL,NULL,'2013-01-13 07:11:59',56305.3,NULL,NULL,NULL,0.11,NULL,'Ia',NULL,'2013-01-13 11:36:50','2013-01-13 11:36:50','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41198398643,'NTT','EFOSC2','Mattias Ergon','2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,643724978,10058202,NULL,NULL,NULL,NULL),(10675,10558,0,'LSQ13dj','pessto',159.891875,-16.4450277778,NULL,NULL,'2013-01-13 07:11:59',56305.3,NULL,NULL,NULL,0.175,NULL,'Ia',NULL,'2013-01-13 12:09:20','2013-01-13 12:09:20','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41833224827,'NTT','EFOSC2','Mattias Ergon','2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653644137,10213189,NULL,NULL,NULL,NULL),(10676,8895,0,'LSQ12hxg','LSQ',62.9476666666667,-5.91905555555556,NULL,NULL,'2013-01-13 02:36:05',56305.1083999998,17.8317,0.0244,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_96676.gif',36962123763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(10677,8895,0,'LSQ12hxg','LSQ',62.947625,-5.919,NULL,NULL,'2013-01-13 03:58:20',56305.1655199998,17.9846,0.0327,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_96677.gif',36962123763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(10678,9049,0,'LSQ12hyr','LSQ',64.0625416666667,-10.95125,NULL,NULL,'2013-01-13 02:20:50',56305.0978100002,17.9709,0.0221,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_history.html','sn',NULL,0.045375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_snap_96703.gif',36980827673,NULL,NULL,NULL,'2012-10-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577825432,9028522,NULL,NULL,NULL,NULL),(10679,9180,0,'LSQ12hzo','LSQ',136.200333333333,18.6496111111111,NULL,NULL,'2013-01-13 04:17:43',56305.1789699998,20.5966,0.1213,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzo/LSQ12hzo_history.html','sn?',NULL,0.11231,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzo/LSQ12hzo_snap_96792.gif',63876968330,NULL,NULL,NULL,'2012-04-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,998077630,15594962,NULL,NULL,NULL,NULL),(10680,9180,0,'LSQ12hzo','LSQ',136.200291666667,18.6495,NULL,NULL,'2013-01-13 06:18:24',56305.26278,20.9412,0.1878,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzo/LSQ12hzo_history.html','sn?',NULL,0.11231,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzo/LSQ12hzo_snap_96793.gif',63876968330,NULL,NULL,NULL,'2012-04-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,998077630,15594962,NULL,NULL,NULL,NULL),(10681,9183,0,'LSQ12hzj','LSQ',149.801791666667,-9.00227777777778,NULL,NULL,'2013-01-13 03:20:21',56305.1391400001,16.8049,0.0075,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_snap_96752.gif',41335019974,NULL,NULL,NULL,'2012-12-05 05:54:14',56266.246,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645859687,10091557,NULL,NULL,NULL,NULL),(10682,9183,0,'LSQ12hzj','LSQ',149.801791666667,-9.00225,NULL,NULL,'2013-01-13 05:22:11',56305.2237399998,16.7712,0.0071,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_snap_96753.gif',41335019974,NULL,NULL,NULL,'2012-12-05 05:54:14',56266.246,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645859687,10091557,NULL,NULL,NULL,NULL),(10683,9197,0,'LSQ12hzh','LSQ',66.4479166666667,-8.60944444444444,NULL,NULL,'2013-01-13 02:17:28',56305.0954700001,19.7673,0.1358,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_snap_96758.gif',37473128013,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585517625,9148712,NULL,NULL,NULL,NULL),(10684,9386,0,'LSQ13b','LSQ',170.889666666667,-20.3368888888889,NULL,NULL,'2013-01-13 06:31:20',56305.27177,18.6794,0.0452,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_snap_96848.gif',41739726486,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,652183226,10190362,NULL,NULL,NULL,NULL),(10685,9389,0,'LSQ13l','LSQ',155.694666666667,-7.48619444444444,NULL,NULL,'2013-01-13 06:05:16',56305.2536599999,18.389,0.0541,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_snap_96849.gif',41246135636,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644470869,10069857,NULL,NULL,NULL,NULL),(10686,9389,0,'LSQ13l','LSQ',155.694708333333,-7.48616666666667,NULL,NULL,'2013-01-13 07:30:57',56305.3131599999,18.425,0.0558,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_snap_96850.gif',41246135636,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644470869,10069857,NULL,NULL,NULL,NULL),(10687,9397,0,'LSQ13h','LSQ',70.6754166666667,-14.6319444444444,NULL,NULL,'2013-01-13 01:58:48',56305.0825,20.5286,0.1602,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_snap_96845.gif',37544086754,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586626355,9166036,NULL,NULL,NULL,NULL),(10688,9397,0,'LSQ13h','LSQ',70.6752916666667,-14.6319722222222,NULL,NULL,'2013-01-13 04:01:43',56305.16787,20.5139,0.1775,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_snap_96846.gif',37544086545,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586626352,9166036,NULL,NULL,NULL,NULL),(10689,9582,0,'LSQ13ba','LSQ',162.662458333333,-10.8734444444444,NULL,NULL,'2013-01-13 08:03:07',56305.3355,18.7046,0.0363,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ba/LSQ13ba_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ba/LSQ13ba_snap_96669.gif',41784370026,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,652880781,10201262,NULL,NULL,NULL,NULL),(10690,9582,0,'LSQ13ba','LSQ',162.662458333333,-10.8734722222222,NULL,NULL,'2013-01-13 08:30:33',56305.3545599999,18.8072,0.0456,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ba/LSQ13ba_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ba/LSQ13ba_snap_96670.gif',41784370026,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,652880781,10201262,NULL,NULL,NULL,NULL),(10691,9584,0,'LSQ13ay','LSQ',149.695375,-7.59113888888889,NULL,NULL,'2013-01-13 05:16:27',56305.2197599998,19.9134,0.1436,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_snap_96667.gif',41333894671,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645842104,10091282,NULL,NULL,NULL,NULL),(10692,9593,0,'LSQ13ax','LSQ',146.896625,-7.40847222222222,NULL,NULL,'2013-01-13 03:12:57',56305.1340000001,19.3208,0.0778,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_snap_96787.gif',41326341537,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645724086,10089438,NULL,NULL,NULL,NULL),(10693,9593,0,'LSQ13ax','LSQ',146.896458333333,-7.40841666666667,NULL,NULL,'2013-01-13 05:14:46',56305.2185900002,19.4078,0.1232,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_snap_96788.gif',41326341537,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645724086,10089438,NULL,NULL,NULL,NULL),(10694,9596,0,'LSQ13at','LSQ',187.250875,-15.5085555555556,NULL,NULL,'2013-01-13 07:45:42',56305.3234100002,20.0673,0.0952,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13at/LSQ13at_snap_96789.gif',43045835690,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,672591182,10509237,NULL,NULL,NULL,NULL),(10695,9602,0,'LSQ13as','LSQ',178.838916666667,-13.9714722222222,NULL,NULL,'2013-01-13 05:04:18',56305.2113199998,19.1426,0.1169,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_snap_96664.gif',40967582261,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,640118472,10001851,NULL,NULL,NULL,NULL),(10696,9602,0,'LSQ13as','LSQ',178.838833333333,-13.9714722222222,NULL,NULL,'2013-01-13 07:03:19',56305.2939800001,19.1981,0.0805,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_snap_96665.gif',40967582261,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,640118472,10001851,NULL,NULL,NULL,NULL),(10697,9608,0,'LSQ13ag','LSQ',75.549625,-17.9771666666667,NULL,NULL,'2013-01-13 02:08:57',56305.0895500001,17.8775,0.0385,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_snap_96790.gif',37553411726,NULL,NULL,NULL,'2012-12-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,586772058,9168313,NULL,NULL,NULL,NULL),(10698,9608,0,'LSQ13ag','LSQ',75.549625,-17.9771388888889,NULL,NULL,'2013-01-13 04:11:53',56305.1749300002,17.9264,0.0595,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_snap_96791.gif',37553411726,NULL,NULL,NULL,'2012-12-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,586772058,9168313,NULL,NULL,NULL,NULL),(10699,9615,0,'LSQ13ae','LSQ',69.1567916666667,-18.6026111111111,NULL,NULL,'2013-01-13 01:55:24',56305.0801499998,19.6368,0.1008,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ae/LSQ13ae_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ae/LSQ13ae_snap_96648.gif',37364625948,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583822280,9122223,NULL,NULL,NULL,NULL),(10700,9617,0,'LSQ13ad','LSQ',54.2686666666667,-17.5793888888889,NULL,NULL,'2013-01-13 03:35:20',56305.1495400001,19.7143,0.0907,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ad/LSQ13ad_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ad/LSQ13ad_snap_96650.gif',38013957787,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,593968090,9280751,NULL,NULL,NULL,NULL),(10701,9713,0,'LSQ13bo','LSQ',161.640833333333,-17.6445277777778,NULL,NULL,'2013-01-13 04:23:07',56305.18273,21.0182,0.2086,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bo/LSQ13bo_history.html','sn nice',NULL,0.112181,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bo/LSQ13bo_snap_96744.gif',41860113198,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,654064268,10219754,NULL,NULL,NULL,NULL),(10702,9716,0,'LSQ13bn','LSQ',75.249625,-17.7400277777778,NULL,NULL,'2013-01-13 02:08:57',56305.0895500001,19.3017,0.0917,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_history.html','sn nice',NULL,0.056389,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_snap_96819.gif',37570931536,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587045805,9172590,NULL,NULL,NULL,NULL),(10703,9716,0,'LSQ13bn','LSQ',75.249625,-17.7399722222222,NULL,NULL,'2013-01-13 04:11:53',56305.1749300002,19.4285,0.1065,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_history.html','sn nice',NULL,0.056389,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_snap_96820.gif',37570931536,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587045805,9172590,NULL,NULL,NULL,NULL),(10704,9724,0,'LSQ13de','LSQ',55.0324166666667,-20.1698888888889,NULL,NULL,'2013-01-13 03:35:20',56305.1495400001,19.7519,0.1178,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13de/LSQ13de_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13de/LSQ13de_snap_96825.gif',38050214866,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594534607,9289603,NULL,NULL,NULL,NULL),(10705,9727,0,'LSQ13dd','LSQ',200.746083333333,-17.6015555555556,NULL,NULL,'2013-01-13 06:52:44',56305.28663,19.1329,0.0576,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dd/LSQ13dd_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dd/LSQ13dd_snap_96821.gif',43779846168,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,684060096,10688439,NULL,NULL,NULL,NULL),(10706,9727,0,'LSQ13dd','LSQ',200.746333333333,-17.6015,NULL,NULL,'2013-01-13 07:54:14',56305.3293300001,19.2103,0.054,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dd/LSQ13dd_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dd/LSQ13dd_snap_96822.gif',43779846168,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,684060096,10688439,NULL,NULL,NULL,NULL),(10707,9736,0,'LSQ13cz','LSQ',165.532166666667,-7.94680555555556,NULL,NULL,'2013-01-13 08:01:26',56305.33433,20.5841,0.1192,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_snap_96806.gif',40895593015,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,638993640,9984275,NULL,NULL,NULL,NULL),(10708,9736,0,'LSQ13cz','LSQ',165.532166666667,-7.94680555555556,NULL,NULL,'2013-01-13 08:28:52',56305.3533800002,20.3916,0.107,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_snap_96807.gif',40895593015,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,638993640,9984275,NULL,NULL,NULL,NULL),(10709,9744,0,'LSQ13cv','LSQ',144.436041666667,-10.6307777777778,NULL,NULL,'2013-01-13 02:49:22',56305.1176200002,19.7377,0.0752,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_snap_96804.gif',41307885070,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645435704,10084932,NULL,NULL,NULL,NULL),(10710,9744,0,'LSQ13cv','LSQ',144.436041666667,-10.6307777777778,NULL,NULL,'2013-01-13 04:51:18',56305.2023,19.6457,0.0634,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_snap_96805.gif',41307885070,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645435704,10084932,NULL,NULL,NULL,NULL),(10711,9750,0,'LSQ13cu','LSQ',67.093,-8.68972222222222,NULL,NULL,'2013-01-13 02:20:50',56305.0978100002,20.8393,0.1696,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cu/LSQ13cu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cu/LSQ13cu_snap_96766.gif',37473429797,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,585522340,9148786,NULL,NULL,NULL,NULL),(10712,9754,0,'LSQ13cn','LSQ',192.125041666667,-15.0681111111111,NULL,NULL,'2013-01-13 05:57:59',56305.2486100001,19.7354,0.0997,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cn/LSQ13cn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cn/LSQ13cn_snap_96762.gif',43962702759,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,686917230,10733081,NULL,NULL,NULL,NULL),(10713,9754,0,'LSQ13cn','LSQ',192.125041666667,-15.0680833333333,NULL,NULL,'2013-01-13 07:27:10',56305.31054,19.959,0.0952,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cn/LSQ13cn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cn/LSQ13cn_snap_96763.gif',43962702759,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,686917230,10733081,NULL,NULL,NULL,NULL),(10714,9756,0,'LSQ13cm','LSQ',193.145166666667,-15.7600555555556,NULL,NULL,'2013-01-13 05:57:59',56305.2486100001,20.0889,0.1459,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cm/LSQ13cm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cm/LSQ13cm_snap_96749.gif',43964652281,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,686947691,10733557,NULL,NULL,NULL,NULL),(10715,9756,0,'LSQ13cm','LSQ',193.145208333333,-15.7600555555556,NULL,NULL,'2013-01-13 07:27:10',56305.31054,19.6854,0.0842,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cm/LSQ13cm_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cm/LSQ13cm_snap_96750.gif',43964652281,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,686947691,10733557,NULL,NULL,NULL,NULL),(10716,9759,0,'LSQ13ci','LSQ',185.969166666667,-13.5924166666667,NULL,NULL,'2013-01-13 05:52:54',56305.2450799998,19.1902,0.0886,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ci/LSQ13ci_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ci/LSQ13ci_snap_96759.gif',43038948445,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,672483569,10507555,NULL,NULL,NULL,NULL),(10717,9759,0,'LSQ13ci','LSQ',185.969166666667,-13.5923888888889,NULL,NULL,'2013-01-13 07:45:42',56305.3234100002,19.452,0.0917,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ci/LSQ13ci_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ci/LSQ13ci_snap_96760.gif',43038948445,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,672483569,10507555,NULL,NULL,NULL,NULL),(10718,9721,0,'LSQ13ch','LSQ',188.205541666667,-15.9302777777778,NULL,NULL,'2013-01-13 07:45:42',56305.3234100002,19.7359,0.0954,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_snap_96764.gif',43931019431,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686422178,10725346,NULL,NULL,NULL,NULL),(10719,9771,0,'LSQ13cg','LSQ',184.313625,-14.3305833333333,NULL,NULL,'2013-01-13 07:23:49',56305.3082099999,19.7163,0.1162,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_snap_96745.gif',43082327557,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,673161368,10518146,NULL,NULL,NULL,NULL),(10720,9780,0,'LSQ13ce','LSQ',169.457875,-13.2120833333333,NULL,NULL,'2013-01-13 04:46:00',56305.1986199999,18.7727,0.0558,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_snap_96700.gif',41695045189,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651485081,10179454,NULL,NULL,NULL,NULL),(10721,9787,0,'LSQ13cc','LSQ',155.473791666667,-15.1203333333333,NULL,NULL,'2013-01-13 03:25:25',56305.1426599999,20.3609,0.125,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_snap_96732.gif',41655946567,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650874165,10169908,NULL,NULL,NULL,NULL),(10722,9787,0,'LSQ13cc','LSQ',155.473875,-15.1202777777778,NULL,NULL,'2013-01-13 05:27:16',56305.2272700001,20.7172,0.2076,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_snap_96733.gif',41655946567,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650874165,10169908,NULL,NULL,NULL,NULL),(10723,9793,0,'LSQ13cb','LSQ',155.630333333333,-12.0888333333333,NULL,NULL,'2013-01-13 03:25:25',56305.1426599999,19.8013,0.1509,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_history.html','sn nice',NULL,0.036025,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_snap_96726.gif',41825602641,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653525041,10211328,NULL,NULL,NULL,NULL),(10724,9793,0,'LSQ13cb','LSQ',155.630291666667,-12.0888333333333,NULL,NULL,'2013-01-13 05:27:16',56305.2272700001,19.1886,0.1204,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_history.html','sn nice',NULL,0.036025,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_snap_96727.gif',41825602641,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653525041,10211328,NULL,NULL,NULL,NULL),(10725,9803,0,'LSQ13by','LSQ',63.8447916666667,-12.0708333333333,NULL,NULL,'2013-01-13 02:19:09',56305.0966400001,19.866,0.1498,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13by/LSQ13by_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13by/LSQ13by_snap_96699.gif',36979384144,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577802877,9028169,NULL,NULL,NULL,NULL),(10726,9809,0,'LSQ13bx','LSQ',63.0634583333333,-16.2730833333333,NULL,NULL,'2013-01-13 02:24:13',56305.1001599999,19.9029,0.1272,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_snap_96795.gif',36870326957,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576098858,9001544,NULL,NULL,NULL,NULL),(10727,10511,0,'LSQ13dw','LSQ',137.761666666667,-2.48936111111111,NULL,NULL,'2013-01-13 02:58:44',56305.1241299999,20.6375,0.2062,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_snap_96834.gif',41086338785,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641974043,10030844,NULL,NULL,NULL,NULL),(10728,10524,0,'LSQ13ds','LSQ',152.524791666667,-16.1157222222222,NULL,NULL,'2013-01-13 05:25:34',56305.22609,19.4269,0.0818,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ds/LSQ13ds_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ds/LSQ13ds_snap_96644.gif',41198398641,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,643724978,10058202,NULL,NULL,NULL,NULL),(10729,10529,0,'LSQ13dr','LSQ',152.413083333333,-15.5310555555556,NULL,NULL,'2013-01-13 05:09:41',56305.2150599998,18.5544,0.0485,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dr/LSQ13dr_snap_96833.gif',41165095704,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643204620,10050072,NULL,NULL,NULL,NULL),(10730,10539,0,'LSQ13do','LSQ',70.3165833333333,-15.62575,NULL,NULL,'2013-01-13 01:57:06',56305.08133,20.2862,0.1511,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_snap_96678.gif',37538165033,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586533828,9164591,NULL,NULL,NULL,NULL),(10731,10539,0,'LSQ13do','LSQ',70.3165416666667,-15.6257222222222,NULL,NULL,'2013-01-13 04:00:02',56305.1666899999,20.152,0.18,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_snap_96679.gif',37538165033,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586533828,9164591,NULL,NULL,NULL,NULL),(10732,10558,0,'LSQ13dj','LSQ',159.891833333333,-16.4450555555556,NULL,NULL,'2013-01-13 04:21:26',56305.1815599999,19.6537,0.1353,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 14:46:29','2013-01-13 14:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dj/LSQ13dj_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dj/LSQ13dj_snap_96680.gif',41833224827,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653644137,10213189,NULL,NULL,NULL,NULL),(10734,10606,0,'LSQ13fn','pessto',177.822041667,-29.6114444444,NULL,NULL,'2013-01-13 06:14:23',56305.26,NULL,NULL,NULL,0.064,NULL,'IIn',NULL,'2013-01-13 14:59:00','2013-01-13 14:59:01','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,41453071886,'NTT','EFOSC2','J Sollerman F Taddia M Ergon','2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,647704248,10120378,NULL,NULL,NULL,NULL),(10735,10735,1,'LSQ13jg','LSQ',133.9975,15.8290277777778,NULL,NULL,'2013-01-09 04:38:57',56301.1937199999,18.9333,0.0909,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 20:46:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13jg/LSQ13jg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13jg/LSQ13jg_snap_97185.gif',63885435600,NULL,NULL,NULL,'2013-01-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,998209931,15597030,NULL,NULL,NULL,NULL),(10736,10735,0,'LSQ13jg','LSQ',133.9975,15.8291666666667,NULL,NULL,'2013-01-09 06:38:18',56301.2766,19.0639,0.0985,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 20:46:32','2013-01-13 20:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13jg/LSQ13jg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13jg/LSQ13jg_snap_97186.gif',63885435600,NULL,NULL,NULL,'2013-01-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,998209931,15597030,NULL,NULL,NULL,NULL),(10737,10735,0,'LSQ13jg','LSQ',133.9975,15.8291111111111,NULL,NULL,'2013-01-11 05:40:43',56303.23661,18.9978,0.1149,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 20:46:32','2013-01-13 20:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13jg/LSQ13jg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13jg/LSQ13jg_snap_97187.gif',63885435600,NULL,NULL,NULL,'2013-01-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,998209931,15597030,NULL,NULL,NULL,NULL),(10738,10735,0,'LSQ13jg','LSQ',133.997458333333,15.8288611111111,NULL,NULL,'2013-01-13 03:32:36',56305.1476400001,18.5011,0.121,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 20:46:32','2013-01-13 20:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13jg/LSQ13jg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13jg/LSQ13jg_snap_97100.gif',63885435603,NULL,NULL,NULL,'2013-01-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,998209931,15597030,NULL,NULL,NULL,NULL),(10739,10735,0,'LSQ13jg','LSQ',133.997541666667,15.8290277777778,NULL,NULL,'2013-01-13 05:34:23',56305.2322200001,18.3287,0.1004,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 20:46:32','2013-01-13 20:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13jg/LSQ13jg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13jg/LSQ13jg_snap_97101.gif',63885435600,NULL,NULL,NULL,'2013-01-07 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,998209931,15597030,NULL,NULL,NULL,NULL),(10740,10740,1,'LSQ13it','LSQ',198.97675,-13.0313611111111,NULL,NULL,'2013-01-07 08:49:48',56299.3679200001,19.3705,0.1791,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 20:46:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13it/LSQ13it_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13it/LSQ13it_snap_97170.gif',43997922844,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,687467544,10741680,NULL,NULL,NULL,NULL),(10741,10740,0,'LSQ13it','LSQ',198.97675,-13.03125,NULL,NULL,'2013-01-13 07:15:22',56305.3023399999,20.2505,0.1328,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 20:46:32','2013-01-13 20:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13it/LSQ13it_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13it/LSQ13it_snap_97074.gif',43997922847,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,687467544,10741680,NULL,NULL,NULL,NULL),(10742,10740,0,'LSQ13it','LSQ',198.977125,-13.0311111111111,NULL,NULL,'2013-01-13 08:08:40',56305.3393600001,20.4461,0.1234,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 20:46:32','2013-01-13 20:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13it/LSQ13it_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13it/LSQ13it_snap_97075.gif',43997922844,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,687467544,10741680,NULL,NULL,NULL,NULL),(10743,10743,1,'LSQ13ii','LSQ',151.968916666667,-15.5154166666667,NULL,NULL,'2013-01-05 05:02:44',56297.2102399999,19.923,0.1711,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 20:46:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ii/LSQ13ii_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ii/LSQ13ii_snap_97121.gif',41201910355,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643779849,10059060,NULL,NULL,NULL,NULL),(10744,10743,0,'LSQ13ii','LSQ',151.969,-15.5153888888889,NULL,NULL,'2013-01-09 05:25:02',56301.22572,19.8752,0.1541,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 20:46:32','2013-01-13 20:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ii/LSQ13ii_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ii/LSQ13ii_snap_97122.gif',41201910355,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643779849,10059060,NULL,NULL,NULL,NULL),(10745,10743,0,'LSQ13ii','LSQ',151.969,-15.5153055555556,NULL,NULL,'2013-01-13 03:07:52',56305.1304700002,19.2867,0.1086,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 20:46:32','2013-01-13 20:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ii/LSQ13ii_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ii/LSQ13ii_snap_97052.gif',41201910355,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643779849,10059060,NULL,NULL,NULL,NULL),(10746,10743,0,'LSQ13ii','LSQ',151.968958333333,-15.5153611111111,NULL,NULL,'2013-01-13 05:09:41',56305.2150599998,18.7562,0.1007,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 20:46:32','2013-01-13 20:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ii/LSQ13ii_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ii/LSQ13ii_snap_97053.gif',41201910355,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643779849,10059060,NULL,NULL,NULL,NULL),(10747,10747,1,'LSQ13ib','LSQ',198.674791666667,-18.7790555555556,NULL,NULL,'2013-01-13 06:52:44',56305.28663,19.694,0.1473,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 20:46:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ib/LSQ13ib_history.html','sn?',NULL,0.023089,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ib/LSQ13ib_snap_97038.gif',43797004950,NULL,NULL,NULL,'2013-01-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,684328202,10692628,NULL,NULL,NULL,NULL),(10748,10747,0,'LSQ13ib','LSQ',198.6745,-18.7788611111111,NULL,NULL,'2013-01-13 07:54:14',56305.3293300001,19.1917,0.1358,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-13 20:46:32','2013-01-13 20:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ib/LSQ13ib_history.html','sn?',NULL,0.023089,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ib/LSQ13ib_snap_97039.gif',43797004945,NULL,NULL,NULL,'2013-01-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,684328202,10692628,NULL,NULL,NULL,NULL),(10813,8107,0,'SN2012hr','CBET',95.41025,-59.71406,NULL,NULL,'2013-01-14 00:00:00',56306.5,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2000-01-01 00:00:00','2019-10-11 12:32:47',NULL,NULL,NULL,NULL,NULL,NULL,'https://farm9.staticflickr.com/8207/8278646369_3343fd733b_b.jpg',NULL,NULL,40382256344,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,630972755,9858949,NULL,NULL,NULL,NULL),(10814,8408,0,'LSQ12hqa','LSQ',160.241166666667,-21.7818611111111,NULL,NULL,'2013-01-14 03:46:14',56306.15711,19.449,0.1206,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_history.html','sn - nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hqa/LSQ12hqa_snap_97228.gif',41668171452,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,651065178,10172893,NULL,NULL,NULL,NULL),(10815,8686,0,'LSQ12hvj','LSQ',166.910875,-29.7114166666667,NULL,NULL,'2013-01-14 06:31:48',56306.2720900001,18.7334,0.0657,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_97324.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(10816,9251,0,'LSQ12hzu','LSQ',76.9711666666667,-20.9748333333333,NULL,NULL,'2013-01-14 02:34:30',56306.1072999998,19.1042,0.0747,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_97351.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(10817,9251,0,'LSQ12hzu','LSQ',76.971375,-20.9748611111111,NULL,NULL,'2013-01-14 04:37:47',56306.1929100002,18.7304,0.0868,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_97352.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(10818,9348,0,'LSQ12iak','LSQ',170.613083333333,-26.7129722222222,NULL,NULL,'2013-01-14 06:31:48',56306.2720900001,19.7895,0.2143,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iak/LSQ12iak_snap_97360.gif',41429437529,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,647334961,10114608,NULL,NULL,NULL,NULL),(10819,9477,0,'LSQ13ab','LSQ',168.104125,-21.9610555555556,NULL,NULL,'2013-01-14 05:22:04',56306.2236600001,16.7029,0.0091,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_97340.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(10820,9477,0,'LSQ13ab','LSQ',168.104,-21.9609722222222,NULL,NULL,'2013-01-14 07:09:14',56306.2980800001,17.5356,0.0229,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_97341.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(10821,9487,0,'LSQ13aa','LSQ',68.8429166666667,-23.6361666666667,NULL,NULL,'2013-01-14 03:25:42',56306.1428499999,19.2222,0.0905,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_snap_97195.gif',37317539555,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583086555,9110727,NULL,NULL,NULL,NULL),(10822,9487,0,'LSQ13aa','LSQ',68.8430416666667,-23.6362777777778,NULL,NULL,'2013-01-14 03:52:42',56306.1616000002,19.3758,0.0844,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_snap_97196.gif',37317539553,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583086555,9110727,NULL,NULL,NULL,NULL),(10823,10451,0,'LSQ13em','LSQ',164.653333333333,-22.8127222222222,NULL,NULL,'2013-01-14 07:09:14',56306.2980800001,20.4091,0.1391,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13em/LSQ13em_snap_97217.gif',41628312266,NULL,NULL,NULL,'2012-12-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650442379,10163162,NULL,NULL,NULL,NULL),(10824,10462,0,'LSQ13ej','LSQ',186.3765,-28.4399722222222,NULL,NULL,'2013-01-14 05:20:11',56306.2223499999,20.1141,0.173,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ej/LSQ13ej_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ej/LSQ13ej_snap_97213.gif',43403700564,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,678182821,10596606,NULL,NULL,NULL,NULL),(10825,10468,0,'LSQ13ei','LSQ',177.033666666667,-27.6066388888889,NULL,NULL,'2013-01-14 05:10:01',56306.2152999998,19.4369,0.1695,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_snap_97235.gif',41463471513,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,647866742,10122917,NULL,NULL,NULL,NULL),(10826,10468,0,'LSQ13ei','LSQ',177.033791666667,-27.6066111111111,NULL,NULL,'2013-01-14 07:36:40',56306.3171299999,19.2228,0.1343,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_snap_97236.gif',41463471513,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,647866742,10122917,NULL,NULL,NULL,NULL),(10827,10474,0,'LSQ13eh','LSQ',73.39525,-28.4290833333333,NULL,NULL,'2013-01-14 03:08:03',56306.1305999998,19.4246,0.0724,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_snap_97212.gif',37231969715,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581749526,9089836,NULL,NULL,NULL,NULL),(10828,10511,0,'LSQ13dw','LSQ',137.762083333333,-2.48969444444444,NULL,NULL,'2013-01-14 02:49:06',56306.1174400002,21.2066,0.1438,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_snap_97363.gif',41086338785,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641974043,10030844,NULL,NULL,NULL,NULL),(10829,10511,0,'LSQ13dw','LSQ',137.762041666667,-2.48961111111111,NULL,NULL,'2013-01-14 04:48:56',56306.20065,20.6264,0.0891,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_snap_97364.gif',41086338785,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641974043,10030844,NULL,NULL,NULL,NULL),(10830,10562,0,'LSQ13ga','LSQ',166.772666666667,-23.8273055555556,NULL,NULL,'2013-01-14 05:22:04',56306.2236600001,20.6256,0.1615,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_snap_97373.gif',41842377387,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,653787146,10215424,NULL,NULL,NULL,NULL),(10831,10562,0,'LSQ13ga','LSQ',166.772708333333,-23.82725,NULL,NULL,'2013-01-14 07:09:14',56306.2980800001,20.3878,0.133,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_snap_97374.gif',41842377386,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,653787146,10215424,NULL,NULL,NULL,NULL),(10832,10568,0,'LSQ13fy','LSQ',160.588625,-23.85375,NULL,NULL,'2013-01-14 03:46:14',56306.15711,19.0799,0.1074,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_snap_97284.gif',41632749769,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650511715,10164245,NULL,NULL,NULL,NULL),(10833,10568,0,'LSQ13fy','LSQ',160.5885,-23.85375,NULL,NULL,'2013-01-14 05:45:42',56306.2400799999,18.9438,0.0637,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_snap_97285.gif',41632749654,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650511713,10164245,NULL,NULL,NULL,NULL),(10834,10580,0,'LSQ13fu','LSQ',186.445916666667,-28.2342777777778,NULL,NULL,'2013-01-14 05:20:11',56306.2223499999,15.283,0.006,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_snap_97322.gif',43403591765,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,678181121,10596580,NULL,NULL,NULL,NULL),(10835,10580,0,'LSQ13fu','LSQ',186.445875,-28.2343888888889,NULL,NULL,'2013-01-14 07:17:43',56306.3039699998,15.2957,0.0068,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_snap_97323.gif',43403591765,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,678181121,10596580,NULL,NULL,NULL,NULL),(10836,10586,0,'LSQ13ft','LSQ',184.047666666667,-26.1164444444444,NULL,NULL,'2013-01-14 05:13:24',56306.21765,17.1373,0.034,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_snap_97282.gif',43416143131,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,678377236,10599644,NULL,NULL,NULL,NULL),(10837,10586,0,'LSQ13ft','LSQ',184.0475,-26.1165,NULL,NULL,'2013-01-14 07:33:16',56306.3147800001,16.9949,0.0537,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_snap_97283.gif',43416143131,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,678377236,10599644,NULL,NULL,NULL,NULL),(10838,10593,0,'LSQ13fp','LSQ',176.491708333333,-27.2271388888889,NULL,NULL,'2013-01-14 05:10:01',56306.2152999998,14.4358,0.0035,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_snap_97325.gif',41471449660,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647991400,10124865,NULL,NULL,NULL,NULL),(10839,10593,0,'LSQ13fp','LSQ',176.49175,-27.2271388888889,NULL,NULL,'2013-01-14 07:36:40',56306.3171299999,14.5796,0.0027,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_snap_97326.gif',41471449660,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647991400,10124865,NULL,NULL,NULL,NULL),(10840,10606,0,'LSQ13fn','LSQ',177.821958333333,-29.6114722222222,NULL,NULL,'2013-01-14 05:08:21',56306.2141399998,19.2514,0.106,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fn/LSQ13fn_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fn/LSQ13fn_snap_97274.gif',41453071886,NULL,NULL,NULL,'2013-01-06 07:01:55',56298.293,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,647704248,10120378,NULL,NULL,NULL,NULL),(10841,10606,0,'LSQ13fn','LSQ',177.822,-29.6114722222222,NULL,NULL,'2013-01-14 07:38:21',56306.3182999999,19.359,0.0743,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fn/LSQ13fn_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fn/LSQ13fn_snap_97275.gif',41453071886,NULL,NULL,NULL,'2013-01-06 07:01:55',56298.293,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,647704248,10120378,NULL,NULL,NULL,NULL),(10842,10610,0,'LSQ13fk','LSQ',74.1179166666667,-25.6731666666667,NULL,NULL,'2013-01-14 03:08:03',56306.1305999998,19.2193,0.0859,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_snap_97349.gif',37228569814,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581696403,9089006,NULL,NULL,NULL,NULL),(10843,10622,0,'LSQ13fg','LSQ',52.7804166666667,-29.726,NULL,NULL,'2013-01-14 01:14:18',56306.0515999999,20.1721,0.1163,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fg/LSQ13fg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fg/LSQ13fg_snap_97257.gif',38573776140,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602715252,9417425,NULL,NULL,NULL,NULL),(10844,10622,0,'LSQ13fg','LSQ',52.7804583333333,-29.726,NULL,NULL,'2013-01-14 03:11:32',56306.13301,20.0285,0.1125,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fg/LSQ13fg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fg/LSQ13fg_snap_97258.gif',38573776140,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602715252,9417425,NULL,NULL,NULL,NULL),(10845,10626,0,'LSQ13ff','LSQ',52.982625,-29.4226666666667,NULL,NULL,'2013-01-14 01:14:18',56306.0515999999,20.434,0.0968,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_history.html','transient',NULL,0.139,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_snap_97256.gif',38584578424,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602884037,9420063,NULL,NULL,NULL,NULL),(10846,10645,0,'LSQ13fc','LSQ',78.7640833333333,-34.5679444444444,NULL,NULL,'2013-01-14 01:52:11',56306.07791,19.8247,0.1788,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_snap_97254.gif',37276987739,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,582452933,9100827,NULL,NULL,NULL,NULL),(10847,10645,0,'LSQ13fc','LSQ',78.764125,-34.5679166666667,NULL,NULL,'2013-01-14 03:54:25',56306.16279,19.8973,0.1578,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_snap_97255.gif',37276987739,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,582452933,9100827,NULL,NULL,NULL,NULL),(10848,10652,0,'LSQ13fb','LSQ',73.9042083333333,-32.0216944444444,NULL,NULL,'2013-01-14 02:41:21',56306.1120500001,19.1193,0.0926,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 00:46:29','2013-01-15 00:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_snap_97251.gif',37210488481,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581413882,9084591,NULL,NULL,NULL,NULL),(10849,10849,1,'LSQ13ji','LSQ',55.854,-29.81275,NULL,NULL,'2012-12-31 01:52:58',56292.07846,19.5911,0.1592,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 16:46:29','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_snap_97473.gif',38584082382,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602876287,9419941,NULL,NULL,NULL,NULL),(10850,10849,0,'LSQ13ji','LSQ',55.8536666666667,-29.8128055555556,NULL,NULL,'2013-01-04 01:40:26',56296.0697499998,19.8813,0.0991,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 16:46:29','2013-01-15 16:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_snap_97474.gif',38584082369,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602876287,9419941,NULL,NULL,NULL,NULL),(10851,10849,0,'LSQ13ji','LSQ',55.85375,-29.8127222222222,NULL,NULL,'2013-01-04 03:41:25',56296.1537700002,19.6911,0.0844,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 16:46:29','2013-01-15 16:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_snap_97475.gif',38584082369,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602876287,9419941,NULL,NULL,NULL,NULL),(10852,10849,0,'LSQ13ji','LSQ',55.8537916666667,-29.8127222222222,NULL,NULL,'2013-01-06 01:33:47',56298.06513,19.5575,0.0617,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 16:46:29','2013-01-15 16:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_snap_97476.gif',38584082369,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602876287,9419941,NULL,NULL,NULL,NULL),(10853,10849,0,'LSQ13ji','LSQ',55.8538333333333,-29.8126944444444,NULL,NULL,'2013-01-06 03:34:43',56298.1491200002,19.6416,0.057,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 16:46:29','2013-01-15 16:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_snap_97477.gif',38584082369,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602876287,9419941,NULL,NULL,NULL,NULL),(10854,10849,0,'LSQ13ji','LSQ',55.8537083333333,-29.81275,NULL,NULL,'2013-01-08 02:50:26',56300.1183600002,19.3604,0.045,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 16:46:29','2013-01-15 16:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_snap_97478.gif',38584082369,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602876287,9419941,NULL,NULL,NULL,NULL),(10855,10849,0,'LSQ13ji','LSQ',55.853875,-29.8128055555556,NULL,NULL,'2013-01-08 02:57:47',56300.12347,19.4287,0.0793,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 16:46:29','2013-01-15 16:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_snap_97479.gif',38584082369,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602876287,9419941,NULL,NULL,NULL,NULL),(10856,10849,0,'LSQ13ji','LSQ',55.8537916666667,-29.81275,NULL,NULL,'2013-01-10 02:52:29',56302.1197899999,19.2273,0.0493,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 16:46:29','2013-01-15 16:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_snap_97480.gif',38584082369,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602876287,9419941,NULL,NULL,NULL,NULL),(10857,10849,0,'LSQ13ji','LSQ',55.8537916666667,-29.8126666666667,NULL,NULL,'2013-01-10 02:59:53',56302.1249199999,19.1143,0.0424,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 16:46:29','2013-01-15 16:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_snap_97481.gif',38584082369,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602876287,9419941,NULL,NULL,NULL,NULL),(10858,10849,0,'LSQ13ji','LSQ',55.8537916666667,-29.81275,NULL,NULL,'2013-01-14 01:18:00',56306.0541699999,19.1017,0.0363,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 16:46:29','2013-01-15 16:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_snap_97453.gif',38584082369,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602876287,9419941,NULL,NULL,NULL,NULL),(10859,10849,0,'LSQ13ji','LSQ',55.85375,-29.8127222222222,NULL,NULL,'2013-01-14 03:15:13',56306.1355699999,19.0378,0.0385,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-15 16:46:29','2013-01-15 16:46:29','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_snap_97454.gif',38584082369,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602876287,9419941,NULL,NULL,NULL,NULL),(10860,8877,0,'LSQ12hxn','LSQ',141.166625,22.4335833333333,NULL,NULL,'2013-01-15 06:27:58',56307.2694299999,20.1119,0.1381,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxn/LSQ12hxn_history.html','sn nice',NULL,0.07849,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxn/LSQ12hxn_snap_97560.gif',63715766096,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,995558845,15555606,NULL,NULL,NULL,NULL),(10861,8895,0,'LSQ12hxg','LSQ',62.9475833333333,-5.91902777777778,NULL,NULL,'2013-01-15 02:21:47',56307.0984700001,18.0345,0.0249,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_97561.gif',36962123763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(10862,8895,0,'LSQ12hxg','LSQ',62.947625,-5.91905555555556,NULL,NULL,'2013-01-15 03:47:18',56307.1578500001,17.9099,0.0248,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_history.html','sn nice',NULL,0.03879,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxg/LSQ12hxg_snap_97562.gif',36962123763,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577533183,9023955,NULL,NULL,NULL,NULL),(10863,8906,0,'LSQ12hwy','LSQ',151.071,-15.0929166666667,NULL,NULL,'2013-01-15 05:00:00',56307.2083399999,18.7731,0.0451,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_history.html','sn?',NULL,0.049834,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hwy/LSQ12hwy_snap_97559.gif',41190790322,NULL,NULL,NULL,'2012-11-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,643606098,10056345,NULL,NULL,NULL,NULL),(10864,8912,0,'LSQ12hvz','LSQ',59.6747916666667,-13.3243611111111,NULL,NULL,'2013-01-15 02:30:14',56307.1043400001,19.713,0.1152,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_snap_97528.gif',36893561548,NULL,NULL,NULL,'2012-11-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576461899,9007217,NULL,NULL,NULL,NULL),(10865,8912,0,'LSQ12hvz','LSQ',59.6747916666667,-13.3243611111111,NULL,NULL,'2013-01-15 03:49:00',56307.1590300002,19.7122,0.1194,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvz/LSQ12hvz_snap_97529.gif',36893561548,NULL,NULL,NULL,'2012-11-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576461899,9007217,NULL,NULL,NULL,NULL),(10866,9035,0,'LSQ12hyv','LSQ',63.7123333333333,-16.2175,NULL,NULL,'2013-01-15 02:11:36',56307.0913999998,20.2514,0.1695,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyv/LSQ12hyv_snap_97586.gif',36871504845,NULL,NULL,NULL,'2012-11-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,576117263,9001832,NULL,NULL,NULL,NULL),(10867,9049,0,'LSQ12hyr','LSQ',64.062625,-10.9515555555556,NULL,NULL,'2013-01-15 02:06:32',56307.08788,19.7978,0.0672,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_history.html','sn',NULL,0.045375,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyr/LSQ12hyr_snap_97587.gif',36980827675,NULL,NULL,NULL,'2012-10-14 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,577825432,9028522,NULL,NULL,NULL,NULL),(10868,9180,0,'LSQ12hzo','LSQ',136.200333333333,18.6495277777778,NULL,NULL,'2013-01-15 06:11:57',56307.2583099999,20.645,0.1354,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzo/LSQ12hzo_history.html','sn?',NULL,0.11231,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzo/LSQ12hzo_snap_97650.gif',63876968330,NULL,NULL,NULL,'2012-04-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,998077630,15594962,NULL,NULL,NULL,NULL),(10869,9183,0,'LSQ12hzj','LSQ',149.801916666667,-9.00230555555556,NULL,NULL,'2013-01-15 05:22:25',56307.2239100002,16.8635,0.0128,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzj/LSQ12hzj_snap_97722.gif',41335019974,NULL,NULL,NULL,'2012-12-05 05:54:14',56266.246,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645859687,10091557,NULL,NULL,NULL,NULL),(10870,9197,0,'LSQ12hzh','LSQ',66.44725,-8.60958333333333,NULL,NULL,'2013-01-15 02:03:10',56307.0855399999,19.7938,0.1115,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzh/LSQ12hzh_snap_97625.gif',37473128002,NULL,NULL,NULL,'2012-10-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,585517625,9148712,NULL,NULL,NULL,NULL),(10871,9386,0,'LSQ13b','LSQ',170.889708333333,-20.3369444444444,NULL,NULL,'2013-01-15 04:23:51',56307.1832400002,19.4984,0.0907,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_snap_97699.gif',41739726486,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,652183226,10190362,NULL,NULL,NULL,NULL),(10872,9386,0,'LSQ13b','LSQ',170.889666666667,-20.337,NULL,NULL,'2013-01-15 06:24:14',56307.2668400002,20.0961,0.1173,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13b/LSQ13b_snap_97700.gif',41739726486,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'AGN',NULL,0,NULL,0,652183226,10190362,NULL,NULL,NULL,NULL),(10873,9389,0,'LSQ13l','LSQ',155.694625,-7.48616666666667,NULL,NULL,'2013-01-15 03:29:11',56307.1452700002,18.4503,0.0518,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_snap_97696.gif',41246135636,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644470869,10069857,NULL,NULL,NULL,NULL),(10874,9389,0,'LSQ13l','LSQ',155.694666666667,-7.48616666666667,NULL,NULL,'2013-01-15 05:31:23',56307.23013,18.3623,0.0482,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13l/LSQ13l_snap_97697.gif',41246135636,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,644470869,10069857,NULL,NULL,NULL,NULL),(10875,9397,0,'LSQ13h','LSQ',70.6752083333333,-14.6319444444444,NULL,NULL,'2013-01-15 01:49:31',56307.0760599999,20.5557,0.1108,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13h/LSQ13h_snap_97706.gif',37544086545,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586626352,9166036,NULL,NULL,NULL,NULL),(10876,9577,0,'LSQ13bc','LSQ',133.823875,15.6191944444444,NULL,NULL,'2013-01-15 03:25:31',56307.14273,20.1659,0.1455,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bc/LSQ13bc_history.html','sn?',NULL,0.0708,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bc/LSQ13bc_snap_97556.gif',63884562161,NULL,NULL,NULL,'2012-04-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,998196283,15596816,NULL,NULL,NULL,NULL),(10877,9582,0,'LSQ13ba','LSQ',162.662416666667,-10.8735,NULL,NULL,'2013-01-15 06:06:32',56307.2545400001,18.6975,0.0417,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ba/LSQ13ba_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ba/LSQ13ba_snap_97552.gif',41784370026,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,652880781,10201262,NULL,NULL,NULL,NULL),(10878,9582,0,'LSQ13ba','LSQ',162.662458333333,-10.8735,NULL,NULL,'2013-01-15 07:32:46',56307.3144299998,18.7038,0.0415,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ba/LSQ13ba_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ba/LSQ13ba_snap_97553.gif',41784370026,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,652880781,10201262,NULL,NULL,NULL,NULL),(10879,9584,0,'LSQ13ay','LSQ',149.695375,-7.59119444444444,NULL,NULL,'2013-01-15 02:56:51',56307.1228200002,20.3673,0.1545,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ay/LSQ13ay_snap_97550.gif',41333894671,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645842104,10091282,NULL,NULL,NULL,NULL),(10880,9593,0,'LSQ13ax','LSQ',146.896625,-7.40838888888889,NULL,NULL,'2013-01-15 02:55:11',56307.1216600002,19.4895,0.0929,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_snap_97651.gif',41326341537,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645724086,10089438,NULL,NULL,NULL,NULL),(10881,9593,0,'LSQ13ax','LSQ',146.896541666667,-7.40844444444445,NULL,NULL,'2013-01-15 04:54:57',56307.2048300002,19.3735,0.102,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ax/LSQ13ax_snap_97652.gif',41326341537,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,645724086,10089438,NULL,NULL,NULL,NULL),(10882,9602,0,'LSQ13as','LSQ',178.838833333333,-13.9714166666667,NULL,NULL,'2013-01-15 05:12:04',56307.2167199999,19.257,0.0733,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_snap_97545.gif',40967582261,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,640118472,10001851,NULL,NULL,NULL,NULL),(10883,9602,0,'LSQ13as','LSQ',178.838791666667,-13.9714722222222,NULL,NULL,'2013-01-15 07:05:24',56307.2954199999,19.4125,0.0947,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13as/LSQ13as_snap_97546.gif',40967582261,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,640118472,10001851,NULL,NULL,NULL,NULL),(10884,9608,0,'LSQ13ag','LSQ',75.549625,-17.9771666666667,NULL,NULL,'2013-01-15 01:59:43',56307.0831399998,17.8827,0.0415,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_snap_97653.gif',37553411726,NULL,NULL,NULL,'2012-12-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,586772058,9168313,NULL,NULL,NULL,NULL),(10885,9608,0,'LSQ13ag','LSQ',75.549625,-17.9771388888889,NULL,NULL,'2013-01-15 04:05:51',56307.17074,17.9131,0.0416,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ag/LSQ13ag_snap_97654.gif',37553411726,NULL,NULL,NULL,'2012-12-26 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,586772058,9168313,NULL,NULL,NULL,NULL),(10886,9615,0,'LSQ13ae','LSQ',69.1568333333333,-18.6027222222222,NULL,NULL,'2013-01-15 01:46:09',56307.0737200002,20.4689,0.1547,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ae/LSQ13ae_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ae/LSQ13ae_snap_97530.gif',37364625948,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583822280,9122223,NULL,NULL,NULL,NULL),(10887,9615,0,'LSQ13ae','LSQ',69.1567916666667,-18.6028055555556,NULL,NULL,'2013-01-15 03:52:22',56307.1613699999,20.0235,0.117,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ae/LSQ13ae_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ae/LSQ13ae_snap_97531.gif',37364625948,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583822280,9122223,NULL,NULL,NULL,NULL),(10888,9617,0,'LSQ13ad','LSQ',54.268625,-17.5793888888889,NULL,NULL,'2013-01-15 02:52:09',56307.1195499999,19.6943,0.0846,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ad/LSQ13ad_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ad/LSQ13ad_snap_97526.gif',38013957787,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,593968090,9280751,NULL,NULL,NULL,NULL),(10889,9713,0,'LSQ13bo','LSQ',161.640875,-17.6445,NULL,NULL,'2013-01-15 04:17:05',56307.1785400002,21.1395,0.2129,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bo/LSQ13bo_history.html','sn nice',NULL,0.112181,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bo/LSQ13bo_snap_97616.gif',41860113198,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,654064268,10219754,NULL,NULL,NULL,NULL),(10890,9716,0,'LSQ13bn','LSQ',75.249625,-17.7400277777778,NULL,NULL,'2013-01-15 01:59:43',56307.0831399998,19.6624,0.1084,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_history.html','sn nice',NULL,0.056389,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_snap_97679.gif',37570931536,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587045805,9172590,NULL,NULL,NULL,NULL),(10891,9716,0,'LSQ13bn','LSQ',75.2496666666667,-17.7400277777778,NULL,NULL,'2013-01-15 04:05:51',56307.17074,19.4246,0.0879,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_history.html','sn nice',NULL,0.056389,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bn/LSQ13bn_snap_97680.gif',37570931536,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,587045805,9172590,NULL,NULL,NULL,NULL),(10892,9724,0,'LSQ13de','LSQ',55.032375,-20.1699166666667,NULL,NULL,'2013-01-15 02:52:09',56307.1195499999,20.1129,0.1156,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13de/LSQ13de_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13de/LSQ13de_snap_97684.gif',38050214866,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,594534607,9289603,NULL,NULL,NULL,NULL),(10893,9736,0,'LSQ13cz','LSQ',165.532125,-7.94677777777778,NULL,NULL,'2013-01-15 06:04:51',56307.25337,20.3405,0.1091,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_snap_97672.gif',40895593015,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,638993640,9984275,NULL,NULL,NULL,NULL),(10894,9736,0,'LSQ13cz','LSQ',165.532083333333,-7.94680555555556,NULL,NULL,'2013-01-15 07:34:29',56307.31562,20.0133,0.0846,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cz/LSQ13cz_snap_97673.gif',40895593015,NULL,NULL,NULL,'2012-12-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,638993640,9984275,NULL,NULL,NULL,NULL),(10895,9744,0,'LSQ13cv','LSQ',144.436,-10.6307222222222,NULL,NULL,'2013-01-15 02:49:12',56307.1175000002,19.6358,0.074,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_snap_97665.gif',41307885070,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645435704,10084932,NULL,NULL,NULL,NULL),(10896,9744,0,'LSQ13cv','LSQ',144.436083333333,-10.6306944444444,NULL,NULL,'2013-01-15 04:49:28',56307.20102,19.6434,0.0658,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cv/LSQ13cv_snap_97666.gif',41307885070,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,645435704,10084932,NULL,NULL,NULL,NULL),(10897,9754,0,'LSQ13cn','LSQ',192.12475,-15.0681111111111,NULL,NULL,'2013-01-15 05:55:15',56307.2467100001,19.12,0.0957,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cn/LSQ13cn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cn/LSQ13cn_snap_97633.gif',43962702759,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,686917230,10733081,NULL,NULL,NULL,NULL),(10898,9754,0,'LSQ13cn','LSQ',192.125083333333,-15.0681111111111,NULL,NULL,'2013-01-15 07:40:33',56307.3198299999,20.345,0.1623,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cn/LSQ13cn_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cn/LSQ13cn_snap_97634.gif',43962702759,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,686917230,10733081,NULL,NULL,NULL,NULL),(10899,9759,0,'LSQ13ci','LSQ',185.969125,-13.5923055555556,NULL,NULL,'2013-01-15 05:46:47',56307.24083,19.6475,0.1109,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ci/LSQ13ci_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ci/LSQ13ci_snap_97631.gif',43038948445,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,672483569,10507555,NULL,NULL,NULL,NULL),(10900,9759,0,'LSQ13ci','LSQ',185.969291666667,-13.5923611111111,NULL,NULL,'2013-01-15 07:43:54',56307.32216,17.9902,0.039,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ci/LSQ13ci_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ci/LSQ13ci_snap_97632.gif',43038948445,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,672483569,10507555,NULL,NULL,NULL,NULL),(10901,9721,0,'LSQ13ch','LSQ',188.205291666667,-15.9302777777778,NULL,NULL,'2013-01-15 05:46:47',56307.24083,17.7115,0.0271,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_snap_97629.gif',43931019431,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686422178,10725346,NULL,NULL,NULL,NULL),(10902,9721,0,'LSQ13ch','LSQ',188.205375,-15.9302222222222,NULL,NULL,'2013-01-15 07:43:54',56307.32216,19.2558,0.0849,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ch/LSQ13ch_snap_97630.gif',43931019431,NULL,NULL,NULL,'2012-07-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,686422178,10725346,NULL,NULL,NULL,NULL),(10903,9771,0,'LSQ13cg','LSQ',184.313583333333,-14.3305555555556,NULL,NULL,'2013-01-15 05:45:06',56307.23966,18.9574,0.1064,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_snap_97620.gif',43082327557,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,673161368,10518146,NULL,NULL,NULL,NULL),(10904,9771,0,'LSQ13cg','LSQ',184.313541666667,-14.3305833333333,NULL,NULL,'2013-01-15 07:21:30',56307.3065999998,19.2792,0.0949,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cg/LSQ13cg_snap_97621.gif',43082327557,NULL,NULL,NULL,'2012-06-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,673161368,10518146,NULL,NULL,NULL,NULL),(10905,9780,0,'LSQ13ce','LSQ',169.457916666667,-13.2120555555556,NULL,NULL,'2013-01-15 04:51:23',56307.20236,18.7922,0.0577,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_snap_97590.gif',41695045189,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651485081,10179454,NULL,NULL,NULL,NULL),(10906,9780,0,'LSQ13ce','LSQ',169.457916666667,-13.2120833333333,NULL,NULL,'2013-01-15 06:51:22',56307.2856800002,19.0755,0.0538,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ce/LSQ13ce_snap_97591.gif',41695045189,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,651485081,10179454,NULL,NULL,NULL,NULL),(10907,9787,0,'LSQ13cc','LSQ',155.47375,-15.1204166666667,NULL,NULL,'2013-01-15 03:14:55',56307.1353699998,20.8261,0.1742,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_snap_97610.gif',41655946567,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650874165,10169908,NULL,NULL,NULL,NULL),(10908,9787,0,'LSQ13cc','LSQ',155.473875,-15.1202777777778,NULL,NULL,'2013-01-15 05:17:21',56307.2203899999,20.5705,0.1615,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cc/LSQ13cc_snap_97611.gif',41655946567,NULL,NULL,NULL,'2012-12-21 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,650874165,10169908,NULL,NULL,NULL,NULL),(10909,9793,0,'LSQ13cb','LSQ',155.630333333333,-12.0888333333333,NULL,NULL,'2013-01-15 03:14:55',56307.1353699998,19.5934,0.1142,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_history.html','sn nice',NULL,0.036025,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_snap_97733.gif',41825602641,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653525041,10211328,NULL,NULL,NULL,NULL),(10910,9793,0,'LSQ13cb','LSQ',155.630291666667,-12.0888333333333,NULL,NULL,'2013-01-15 05:17:21',56307.2203899999,19.7886,0.1538,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_history.html','sn nice',NULL,0.036025,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13cb/LSQ13cb_snap_97734.gif',41825602641,NULL,NULL,NULL,'2012-12-24 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653525041,10211328,NULL,NULL,NULL,NULL),(10911,9799,0,'LSQ13bz','LSQ',74.9265833333333,-12.6089722222222,NULL,NULL,'2013-01-15 01:56:20',56307.08079,18.1401,0.0808,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bz/LSQ13bz_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bz/LSQ13bz_snap_97588.gif',37520793527,NULL,NULL,NULL,'2013-01-01 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,586262398,9160349,NULL,NULL,NULL,NULL),(10912,9809,0,'LSQ13bx','LSQ',63.0635416666667,-16.2730277777778,NULL,NULL,'2013-01-15 02:09:55',56307.0902200001,20.2089,0.1299,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bx/LSQ13bx_snap_97659.gif',36870326957,NULL,NULL,NULL,'2012-11-22 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,576098858,9001544,NULL,NULL,NULL,NULL),(10913,9838,0,'LSQ13bp','LSQ',166.447583333333,-17.1761944444444,NULL,NULL,'2013-01-15 06:20:51',56307.26449,19.9632,0.132,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bp/LSQ13bp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13bp/LSQ13bp_snap_97584.gif',41864381299,NULL,NULL,NULL,'2012-12-19 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,654130957,10220796,NULL,NULL,NULL,NULL),(10914,9899,0,'LSQ13dh','LSQ',65.8624166666667,-20.63825,NULL,NULL,'2013-01-15 01:35:57',56307.0666399999,19.4081,0.0989,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dh/LSQ13dh_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dh/LSQ13dh_snap_97525.gif',37323734068,NULL,NULL,NULL,'2013-01-05 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,583183344,9112239,NULL,NULL,NULL,NULL),(10915,10511,0,'LSQ13dw','LSQ',137.762041666667,-2.48958333333333,NULL,NULL,'2013-01-15 02:39:47',56307.1109699998,20.5697,0.1192,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dw/LSQ13dw_snap_97689.gif',41086338785,NULL,NULL,NULL,'2012-12-09 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,641974043,10030844,NULL,NULL,NULL,NULL),(10916,10524,0,'LSQ13ds','LSQ',152.524666666667,-16.1156388888889,NULL,NULL,'2013-01-15 03:13:14',56307.1341900001,19.1804,0.0623,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ds/LSQ13ds_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ds/LSQ13ds_snap_97521.gif',41198398641,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,643724978,10058202,NULL,NULL,NULL,NULL),(10917,10539,0,'LSQ13do','LSQ',70.3165833333333,-15.6257222222222,NULL,NULL,'2013-01-15 01:47:49',56307.0748800002,20.4665,0.1468,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_snap_97563.gif',37538165033,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586533828,9164591,NULL,NULL,NULL,NULL),(10918,10539,0,'LSQ13do','LSQ',70.3165416666667,-15.6257222222222,NULL,NULL,'2013-01-15 03:54:02',56307.1625299999,20.348,0.1175,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13do/LSQ13do_snap_97564.gif',37538165033,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,586533828,9164591,NULL,NULL,NULL,NULL),(10919,10552,0,'LSQ13dk','LSQ',162.771708333333,-19.0561388888889,NULL,NULL,'2013-01-15 04:15:23',56307.1773600001,20.3001,0.2072,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dk/LSQ13dk_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dk/LSQ13dk_snap_97515.gif',41854614063,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653978344,10218411,NULL,NULL,NULL,NULL),(10920,10552,0,'LSQ13dk','LSQ',162.77175,-19.0560555555556,NULL,NULL,'2013-01-15 06:15:47',56307.2609700002,20.8302,0.1687,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dk/LSQ13dk_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dk/LSQ13dk_snap_97516.gif',41854614063,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,653978344,10218411,NULL,NULL,NULL,NULL),(10921,10558,0,'LSQ13dj','LSQ',159.891916666667,-16.4450833333333,NULL,NULL,'2013-01-15 04:15:23',56307.1773600001,19.8092,0.1359,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dj/LSQ13dj_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dj/LSQ13dj_snap_97566.gif',41833224827,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653644137,10213189,NULL,NULL,NULL,NULL),(10922,10558,0,'LSQ13dj','LSQ',159.891916666667,-16.4449166666667,NULL,NULL,'2013-01-15 06:15:47',56307.2609700002,19.7315,0.1616,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dj/LSQ13dj_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13dj/LSQ13dj_snap_97567.gif',41833224827,NULL,NULL,NULL,'2013-01-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,653644137,10213189,NULL,NULL,NULL,NULL),(10923,10740,0,'LSQ13it','LSQ',198.976666666667,-13.0315555555556,NULL,NULL,'2013-01-15 06:58:34',56307.2906800001,20.7471,0.1632,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-16 21:46:28','2013-01-16 21:46:28','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13it/LSQ13it_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13it/LSQ13it_snap_97748.gif',43997922839,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,687467544,10741680,NULL,NULL,NULL,NULL),(10924,10924,1,'MASTERJ023036.19+291256.9','MASTER',37.65079,29.21581,NULL,NULL,'2013-01-15 00:00:00',56307,18.2,NULL,NULL,NULL,NULL,NULL,NULL,'2013-01-17 13:10:50','2019-10-11 14:10:04','http://www.astronomerstelegram.org/?read=4740','supernova',NULL,0,NULL,NULL,'http://master.sai.msu.ru/static/OT/023036.19291256.9.png',NULL,NULL,68637737286,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,1072464645,16757260,NULL,NULL,NULL,NULL),(10925,8686,0,'LSQ12hvj','LSQ',166.910875,-29.7113888888889,NULL,NULL,'2013-01-16 04:32:07',56308.18897,19.1281,0.1377,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_98220.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(10926,8686,0,'LSQ12hvj','LSQ',166.910916666667,-29.7113611111111,NULL,NULL,'2013-01-16 06:32:09',56308.2723300001,18.6137,0.0593,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hvj/LSQ12hvj_snap_98221.gif',41600019118,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,650000298,10156254,NULL,NULL,NULL,NULL),(10927,8949,0,'LSQ12hyd','LSQ',174.637875,-24.2079166666667,NULL,NULL,'2013-01-16 06:50:51',56308.2853199998,19.8497,0.0782,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hyd/LSQ12hyd_snap_98089.gif',41410841875,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647044404,10110068,NULL,NULL,NULL,NULL),(10928,8959,0,'LSQ12hxx','LSQ',49.9342916666667,-27.0071388888889,NULL,NULL,'2013-01-16 03:28:45',56308.1449699998,18.4955,0.0372,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_history.html','sn nice',NULL,0.069408,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxx/LSQ12hxx_snap_98131.gif',38551558325,NULL,NULL,NULL,'2012-12-12 02:34:04',56273.107,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602368098,9412001,NULL,NULL,NULL,NULL),(10929,8966,0,'LSQ12hxt','LSQ',56.841375,-31.2003611111111,NULL,NULL,'2013-01-16 02:55:47',56308.1220800001,19.7443,0.1702,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_98078.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(10930,8966,0,'LSQ12hxt','LSQ',56.841375,-31.2003611111111,NULL,NULL,'2013-01-16 03:11:37',56308.13307,19.3967,0.1258,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxt/LSQ12hxt_snap_98079.gif',38578234482,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602784913,9418514,NULL,NULL,NULL,NULL),(10931,8974,0,'LSQ12hxp','LSQ',67.4702916666667,-35.1992777777778,NULL,NULL,'2013-01-16 01:39:11',56308.0688800002,20.5741,0.1399,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_98081.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(10932,8974,0,'LSQ12hxp','LSQ',67.4703333333333,-35.1994444444444,NULL,NULL,'2013-01-16 02:28:38',56308.1032199999,20.0032,0.1047,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hxp/LSQ12hxp_snap_98082.gif',37693046919,NULL,NULL,NULL,'2012-10-23 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,588953858,9202404,NULL,NULL,NULL,NULL),(10933,9251,0,'LSQ12hzu','LSQ',76.9712083333333,-20.9748055555556,NULL,NULL,'2013-01-16 02:16:34',56308.0948399999,18.6341,0.0612,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_98244.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(10934,9251,0,'LSQ12hzu','LSQ',76.9712916666667,-20.9748611111111,NULL,NULL,'2013-01-16 04:22:21',56308.1821900001,18.6414,0.0661,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzu/LSQ12hzu_snap_98245.gif',37548507154,NULL,NULL,NULL,'2012-11-11 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,586695424,9167116,NULL,NULL,NULL,NULL),(10935,9257,0,'LSQ12hzs','LSQ',60.471625,-26.6639444444444,NULL,NULL,'2013-01-16 02:50:43',56308.1185599999,18.5587,0.0318,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_history.html','sn nice',NULL,0.07213,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_snap_98203.gif',38534445066,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602100704,9407823,NULL,NULL,NULL,NULL),(10936,9257,0,'LSQ12hzs','LSQ',60.4715833333333,-26.6639444444444,NULL,NULL,'2013-01-16 02:54:06',56308.1209100001,18.2807,0.0246,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_history.html','sn nice',NULL,0.07213,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12hzs/LSQ12hzs_snap_98204.gif',38534445066,NULL,NULL,NULL,'2012-12-20 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602100704,9407823,NULL,NULL,NULL,NULL),(10937,9352,0,'LSQ12iae','LSQ',63.30275,-30.7499444444444,NULL,NULL,'2013-01-16 02:37:06',56308.1091,18.573,0.0666,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_snap_98278.gif',37654344365,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588349130,9192955,NULL,NULL,NULL,NULL),(10938,9352,0,'LSQ12iae','LSQ',63.3026666666667,-30.7499722222222,NULL,NULL,'2013-01-16 04:00:06',56308.1667399998,18.5125,0.047,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ12iae/LSQ12iae_snap_98279.gif',37654344361,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,588349130,9192955,NULL,NULL,NULL,NULL),(10939,9477,0,'LSQ13ab','LSQ',168.104083333333,-21.961,NULL,NULL,'2013-01-16 06:44:06',56308.2806299999,17.5144,0.0176,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ab/LSQ13ab_snap_98237.gif',41711039210,NULL,NULL,NULL,'2012-12-18 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,651734987,10183359,NULL,NULL,NULL,NULL),(10940,9487,0,'LSQ13aa','LSQ',68.843,-23.6361666666667,NULL,NULL,'2013-01-16 01:51:03',56308.07712,19.432,0.1409,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_snap_97999.gif',37317539555,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583086555,9110727,NULL,NULL,NULL,NULL),(10941,9487,0,'LSQ13aa','LSQ',68.8429166666667,-23.6361666666667,NULL,NULL,'2013-01-16 03:51:28',56308.1607499998,19.385,0.1109,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13aa/LSQ13aa_snap_98000.gif',37317539555,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583086555,9110727,NULL,NULL,NULL,NULL),(10942,9498,0,'LSQ13v','LSQ',61.6492916666667,-27.5638888888889,NULL,NULL,'2013-01-16 02:32:02',56308.1055800002,19.7613,0.0974,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13v/LSQ13v_snap_97997.gif',38522804849,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,601918825,9404981,NULL,NULL,NULL,NULL),(10943,10447,0,'LSQ13es','LSQ',203.648333333333,-22.2406388888889,NULL,NULL,'2013-01-16 07:38:38',56308.3185000001,20.8616,0.2009,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13es/LSQ13es_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13es/LSQ13es_snap_98058.gif',43771398303,NULL,NULL,NULL,'2012-07-03 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,683928098,10686376,NULL,NULL,NULL,NULL),(10944,10462,0,'LSQ13ej','LSQ',186.376458333333,-28.4399166666667,NULL,NULL,'2013-01-16 07:08:13',56308.2973799999,20.0463,0.1738,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ej/LSQ13ej_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ej/LSQ13ej_snap_98044.gif',43403700564,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,678182821,10596606,NULL,NULL,NULL,NULL),(10945,10468,0,'LSQ13ei','LSQ',177.033875,-27.6066388888889,NULL,NULL,'2013-01-16 06:39:02',56308.2771100001,19.3155,0.1628,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ei/LSQ13ei_snap_98074.gif',41463471513,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,647866742,10122917,NULL,NULL,NULL,NULL),(10946,10474,0,'LSQ13eh','LSQ',73.3952083333333,-28.4290555555556,NULL,NULL,'2013-01-16 01:59:33',56308.0830299999,19.3327,0.0803,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_snap_98040.gif',37231969715,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581749526,9089836,NULL,NULL,NULL,NULL),(10947,10474,0,'LSQ13eh','LSQ',73.3952083333333,-28.4290833333333,NULL,NULL,'2013-01-16 04:05:18',56308.1703499998,19.4801,0.0925,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13eh/LSQ13eh_snap_98041.gif',37231969715,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581749526,9089836,NULL,NULL,NULL,NULL),(10948,10483,0,'LSQ13ef','LSQ',59.4137916666667,-29.9435555555556,NULL,NULL,'2013-01-16 02:52:23',56308.1197199998,19.4439,0.0865,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ef/LSQ13ef_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ef/LSQ13ef_snap_98061.gif',38532402435,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,602068788,9407324,NULL,NULL,NULL,NULL),(10949,10490,0,'LSQ13ed','LSQ',66.346625,-31.9113611111111,NULL,NULL,'2013-01-16 01:44:17',56308.0724200001,19.0473,0.1449,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_snap_98072.gif',37705971658,NULL,NULL,NULL,'2012-12-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589155807,9205559,NULL,NULL,NULL,NULL),(10950,10490,0,'LSQ13ed','LSQ',66.3466666666667,-31.9113055555556,NULL,NULL,'2013-01-16 03:44:43',56308.15606,19.2857,0.175,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ed/LSQ13ed_snap_98073.gif',37705971658,NULL,NULL,NULL,'2012-12-25 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,589155807,9205559,NULL,NULL,NULL,NULL),(10951,10562,0,'LSQ13ga','LSQ',166.772666666667,-23.8273055555556,NULL,NULL,'2013-01-16 06:44:06',56308.2806299999,21.0417,0.1532,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ga/LSQ13ga_snap_98288.gif',41842377387,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,653787146,10215424,NULL,NULL,NULL,NULL),(10952,10568,0,'LSQ13fy','LSQ',160.5885,-23.8538055555556,NULL,NULL,'2013-01-16 04:40:39',56308.1949,19.1984,0.1016,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_snap_98146.gif',41632749654,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650511713,10164245,NULL,NULL,NULL,NULL),(10953,10568,0,'LSQ13fy','LSQ',160.5885,-23.85375,NULL,NULL,'2013-01-16 06:40:44',56308.2782899998,18.8882,0.085,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_history.html','sn',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fy/LSQ13fy_snap_98147.gif',41632749654,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,650511713,10164245,NULL,NULL,NULL,NULL),(10954,10580,0,'LSQ13fu','LSQ',186.445916666667,-28.2342777777778,NULL,NULL,'2013-01-16 05:14:47',56308.2186099999,15.1294,0.0075,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_snap_98208.gif',43403591765,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,678181121,10596580,NULL,NULL,NULL,NULL),(10955,10580,0,'LSQ13fu','LSQ',186.445833333333,-28.2343333333333,NULL,NULL,'2013-01-16 07:08:13',56308.2973799999,15.1572,0.0036,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fu/LSQ13fu_snap_98209.gif',43403591765,NULL,NULL,NULL,'2013-01-08 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,678181121,10596580,NULL,NULL,NULL,NULL),(10956,10586,0,'LSQ13ft','LSQ',184.047541666667,-26.1165,NULL,NULL,'2013-01-16 04:55:50',56308.2054499998,17.5244,0.0426,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_snap_98142.gif',43416143131,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,678377236,10599644,NULL,NULL,NULL,NULL),(10957,10586,0,'LSQ13ft','LSQ',184.047541666667,-26.1165277777778,NULL,NULL,'2013-01-16 06:55:59',56308.2888799999,16.8042,0.0211,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ft/LSQ13ft_snap_98143.gif',43416143131,NULL,NULL,NULL,'2013-01-06 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,678377236,10599644,NULL,NULL,NULL,NULL),(10958,10593,0,'LSQ13fp','LSQ',176.491791666667,-27.2271388888889,NULL,NULL,'2013-01-16 04:38:53',56308.1936699999,14.4444,0.0067,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_snap_98217.gif',41471449660,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647991400,10124865,NULL,NULL,NULL,NULL),(10959,10593,0,'LSQ13fp','LSQ',176.491708333333,-27.2271388888889,NULL,NULL,'2013-01-16 06:39:02',56308.2771100001,14.3801,0.0023,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fp/LSQ13fp_snap_98218.gif',41471449660,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,647991400,10124865,NULL,NULL,NULL,NULL),(10960,10606,0,'LSQ13fn','LSQ',177.822,-29.6114444444444,NULL,NULL,'2013-01-16 06:37:20',56308.27593,19.2282,0.0782,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fn/LSQ13fn_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fn/LSQ13fn_snap_98137.gif',41453071886,NULL,NULL,NULL,'2013-01-06 07:01:55',56298.293,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,647704248,10120378,NULL,NULL,NULL,NULL),(10961,10610,0,'LSQ13fk','LSQ',74.1179166666667,-25.6731944444444,NULL,NULL,'2013-01-16 01:59:33',56308.0830299999,19.6682,0.1136,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_snap_98263.gif',37228569814,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581696403,9089006,NULL,NULL,NULL,NULL),(10962,10610,0,'LSQ13fk','LSQ',74.117875,-25.6731111111111,NULL,NULL,'2013-01-16 04:05:18',56308.1703499998,19.4291,0.1153,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fk/LSQ13fk_snap_98264.gif',37228569815,NULL,NULL,NULL,'2012-12-31 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,581696403,9089006,NULL,NULL,NULL,NULL),(10963,10622,0,'LSQ13fg','LSQ',52.7804583333333,-29.7260277777778,NULL,NULL,'2013-01-16 01:06:16',56308.0460199998,20.13,0.1155,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fg/LSQ13fg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fg/LSQ13fg_snap_98111.gif',38573776140,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602715252,9417425,NULL,NULL,NULL,NULL),(10964,10622,0,'LSQ13fg','LSQ',52.7804166666667,-29.7260277777778,NULL,NULL,'2013-01-16 03:02:32',56308.1267599999,19.9034,0.1378,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fg/LSQ13fg_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fg/LSQ13fg_snap_98112.gif',38573776140,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602715252,9417425,NULL,NULL,NULL,NULL),(10965,10626,0,'LSQ13ff','LSQ',52.983125,-29.4226666666667,NULL,NULL,'2013-01-16 01:06:16',56308.0460199998,20.5981,0.1072,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_history.html','transient',NULL,0.139,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_snap_98108.gif',38584578427,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602884037,9420063,NULL,NULL,NULL,NULL),(10966,10626,0,'LSQ13ff','LSQ',52.9825,-29.4225833333333,NULL,NULL,'2013-01-16 03:02:32',56308.1267599999,19.868,0.0913,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_history.html','transient',NULL,0.139,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ff/LSQ13ff_snap_98109.gif',38584578424,NULL,NULL,NULL,'2012-12-10 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602884037,9420063,NULL,NULL,NULL,NULL),(10967,10645,0,'LSQ13fc','LSQ',78.7640833333333,-34.5678611111111,NULL,NULL,'2013-01-16 01:35:47',56308.0665199999,20.0922,0.1842,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_history.html','hostless',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fc/LSQ13fc_snap_98104.gif',37276987739,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,582452933,9100827,NULL,NULL,NULL,NULL),(10968,10652,0,'LSQ13fb','LSQ',73.904125,-32.0218055555556,NULL,NULL,'2013-01-16 02:09:48',56308.0901500001,18.7551,0.0661,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_snap_98100.gif',37210488483,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581413882,9084591,NULL,NULL,NULL,NULL),(10969,10652,0,'LSQ13fb','LSQ',73.9042083333333,-32.0217222222222,NULL,NULL,'2013-01-16 04:15:35',56308.1774900001,19.0217,0.0922,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13fb/LSQ13fb_snap_98101.gif',37210488481,NULL,NULL,NULL,'2013-01-04 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,581413882,9084591,NULL,NULL,NULL,NULL),(10970,10849,0,'LSQ13ji','LSQ',55.8538333333333,-29.8127222222222,NULL,NULL,'2013-01-16 01:09:57',56308.0485800002,18.9805,0.0515,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 12:46:32','2013-01-17 12:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_history.html','sn nice',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ji/LSQ13ji_snap_98366.gif',38584082369,NULL,NULL,NULL,'2012-12-29 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,602876287,9419941,NULL,NULL,NULL,NULL),(10971,10971,1,'LSQ13kh','LSQ',47.9757083333333,-11.1221111111111,NULL,NULL,'2013-01-15 00:59:05',56307.04104,19.0238,0.0882,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 13:46:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kh/LSQ13kh_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kh/LSQ13kh_snap_97955.gif',37894704684,NULL,NULL,NULL,'2013-01-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592104760,9251636,NULL,NULL,NULL,NULL),(10972,10971,0,'LSQ13kh','LSQ',47.9757083333333,-11.1221388888889,NULL,NULL,'2013-01-15 02:44:26',56307.1141900001,19.9426,0.1336,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 13:46:32','2013-01-17 13:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kh/LSQ13kh_history.html','transient',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kh/LSQ13kh_snap_97956.gif',37894704684,NULL,NULL,NULL,'2013-01-13 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'VS',NULL,0,NULL,0,592104760,9251636,NULL,NULL,NULL,NULL),(10973,10973,1,'LSQ13ju','LSQ',75.3112083333333,-21.0721111111111,NULL,NULL,'2012-12-19 04:44:54',56280.1978500001,20.95,0.1842,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 13:46:32','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ju/LSQ13ju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ju/LSQ13ju_snap_97923.gif',37550080351,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586720005,9167500,NULL,NULL,NULL,NULL),(10974,10973,0,'LSQ13ju','LSQ',75.3110416666667,-21.0723055555556,NULL,NULL,'2013-01-03 02:51:13',56295.1189100002,20.6353,0.1477,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 13:46:32','2013-01-17 13:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ju/LSQ13ju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ju/LSQ13ju_snap_97924.gif',37550080351,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586720005,9167500,NULL,NULL,NULL,NULL),(10975,10973,0,'LSQ13ju','LSQ',75.311625,-21.0721944444444,NULL,NULL,'2013-01-05 04:41:09',56297.1952499999,20.7298,0.1529,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 13:46:32','2013-01-17 13:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ju/LSQ13ju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ju/LSQ13ju_snap_97925.gif',37550080351,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586720005,9167500,NULL,NULL,NULL,NULL),(10976,10973,0,'LSQ13ju','LSQ',75.31175,-21.0721666666667,NULL,NULL,'2013-01-09 02:26:14',56301.1015599999,20.8043,0.1687,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 13:46:32','2013-01-17 13:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ju/LSQ13ju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ju/LSQ13ju_snap_97926.gif',37550080348,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586720005,9167500,NULL,NULL,NULL,NULL),(10977,10973,0,'LSQ13ju','LSQ',75.3111666666667,-21.0720277777778,NULL,NULL,'2013-01-11 02:49:06',56303.1174400002,21.1896,0.205,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 13:46:32','2013-01-17 13:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ju/LSQ13ju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ju/LSQ13ju_snap_97927.gif',37550080351,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586720005,9167500,NULL,NULL,NULL,NULL),(10978,10973,0,'LSQ13ju','LSQ',75.3115,-21.0720833333333,NULL,NULL,'2013-01-13 02:08:57',56305.0895500001,20.4051,0.1197,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 13:46:32','2013-01-17 13:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ju/LSQ13ju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ju/LSQ13ju_snap_97928.gif',37550080351,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586720005,9167500,NULL,NULL,NULL,NULL),(10979,10973,0,'LSQ13ju','LSQ',75.3112916666667,-21.0719722222222,NULL,NULL,'2013-01-15 01:59:43',56307.0831399998,20.4257,0.1228,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 13:46:32','2013-01-17 13:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ju/LSQ13ju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ju/LSQ13ju_snap_97895.gif',37550080351,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586720005,9167500,NULL,NULL,NULL,NULL),(10980,10973,0,'LSQ13ju','LSQ',75.3112083333333,-21.0721666666667,NULL,NULL,'2013-01-15 04:05:51',56307.17074,20.3256,0.1225,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 13:46:32','2013-01-17 13:46:32','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ju/LSQ13ju_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13ju/LSQ13ju_snap_97896.gif',37550080351,NULL,NULL,NULL,'2012-12-15 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,586720005,9167500,NULL,NULL,NULL,NULL),(10981,10981,0,'LSQ13kn','LSQ',209.572833333333,-23.3713888888889,NULL,NULL,'2013-01-14 08:43:16',56306.36338,19.6851,0.0787,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 15:46:33','2019-10-12 20:41:36','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kn/LSQ13kn_history.html','sn nice',NULL,0.036592,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kn/LSQ13kn_snap_98440.gif',46509778739,NULL,NULL,NULL,'2012-07-28 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,726715292,11354926,NULL,NULL,NULL,NULL),(10982,10981,0,'LSQ13kn','LSQ',209.572833333333,-23.3714722222222,NULL,NULL,'2013-01-16 08:05:48',56308.3373699998,19.5667,0.0968,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 15:46:33','2013-01-17 15:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kn/LSQ13kn_history.html','sn nice',NULL,0.036592,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kn/LSQ13kn_snap_98406.gif',46509778739,NULL,NULL,NULL,'2012-07-28 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,726715292,11354926,NULL,NULL,NULL,NULL),(10983,10981,0,'LSQ13kn','LSQ',209.572791666667,-23.3714166666667,NULL,NULL,'2013-01-16 08:33:25',56308.3565500001,19.4986,0.0697,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 15:46:33','2013-01-17 15:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kn/LSQ13kn_history.html','sn nice',NULL,0.036592,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kn/LSQ13kn_snap_98407.gif',46509778739,NULL,NULL,NULL,'2012-07-28 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,726715292,11354926,NULL,NULL,NULL,NULL),(10984,10984,1,'LSQ13kk','LSQ',53.102125,-25.7376666666667,NULL,NULL,'2012-12-18 01:48:25',56279.0752900001,20.3625,0.1604,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 15:46:33','2019-10-11 14:10:04','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kk/LSQ13kk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kk/LSQ13kk_snap_98412.gif',38546681327,NULL,NULL,NULL,'2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602291895,9410810,NULL,NULL,NULL,NULL),(10985,10984,0,'LSQ13kk','LSQ',53.101875,-25.7376111111111,NULL,NULL,'2012-12-18 03:50:49',56279.16029,20.9907,0.1932,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 15:46:33','2013-01-17 15:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kk/LSQ13kk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kk/LSQ13kk_snap_98413.gif',38546681327,NULL,NULL,NULL,'2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602291895,9410810,NULL,NULL,NULL,NULL),(10986,10984,0,'LSQ13kk','LSQ',53.102125,-25.7376666666667,NULL,NULL,'2012-12-22 01:25:47',56283.0595800001,19.8021,0.2041,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 15:46:33','2013-01-17 15:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kk/LSQ13kk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kk/LSQ13kk_snap_98414.gif',38546681327,NULL,NULL,NULL,'2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602291895,9410810,NULL,NULL,NULL,NULL),(10987,10984,0,'LSQ13kk','LSQ',53.1019166666667,-25.7375833333333,NULL,NULL,'2012-12-22 03:27:38',56283.1442,20.7565,0.1717,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 15:46:33','2013-01-17 15:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kk/LSQ13kk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kk/LSQ13kk_snap_98415.gif',38546681327,NULL,NULL,NULL,'2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602291895,9410810,NULL,NULL,NULL,NULL),(10988,10984,0,'LSQ13kk','LSQ',53.1023333333333,-25.7375,NULL,NULL,'2013-01-14 01:14:18',56306.0515999999,20.1293,0.1216,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 15:46:33','2013-01-17 15:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kk/LSQ13kk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kk/LSQ13kk_snap_98416.gif',38546681327,NULL,NULL,NULL,'2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602291895,9410810,NULL,NULL,NULL,NULL),(10989,10984,0,'LSQ13kk','LSQ',53.1020833333333,-25.7375555555556,NULL,NULL,'2013-01-16 01:06:16',56308.0460199998,20.2046,0.1615,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 15:46:33','2013-01-17 15:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kk/LSQ13kk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kk/LSQ13kk_snap_98400.gif',38546681327,NULL,NULL,NULL,'2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602291895,9410810,NULL,NULL,NULL,NULL),(10990,10984,0,'LSQ13kk','LSQ',53.102,-25.7377222222222,NULL,NULL,'2013-01-16 03:02:32',56308.1267599999,20.5723,0.1656,'gr-LSQ',NULL,NULL,NULL,NULL,'2013-01-17 15:46:33','2013-01-17 15:46:33','http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kk/LSQ13kk_history.html','sn?',NULL,NULL,NULL,NULL,NULL,NULL,'http://portal.nersc.gov/project/lssn/test/ryan/adb/LSQ13kk/LSQ13kk_snap_98401.gif',38546681327,NULL,NULL,NULL,'2012-12-16 00:00:00',NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,602291895,9410810,NULL,NULL,NULL,NULL),(11050,8425,0,'SN2012hs','CHASE',147.311291666667,-47.9126666666667,NULL,NULL,'2012-12-15 16:19:12',56276.68,14.5,NULL,NULL,NULL,NULL,NULL,NULL,'2013-01-17 19:54:31','2013-01-17 19:54:31','NULL','supernova',NULL,0.006,NULL,NULL,'http://farm9.staticflickr.com/8496/8295289089_140340ff98_o.jpg',NULL,NULL,42076064057,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,657438500,10272476,NULL,NULL,NULL,NULL),(11071,8504,0,'CSS130118-105323+164635','CRTS-CSS',163.34421,16.77635,NULL,NULL,'2013-01-18 00:00:00',56310,13.69,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:47','2013-01-19 01:31:47','http://nesssi.cacr.caltech.edu/catalina/20130118/1301181150574139493.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130118/jpg/1301181150574139493.master.jpg',NULL,NULL,61200554057,NULL,NULL,NULL,'2012-12-10 13:26:07',56271.559814,'2013-01-19 01:31:47','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301181150574139493/1301181150574139493.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130118/1301181150574139493p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,956258657,14941541,NULL,NULL,NULL,NULL),(11072,11072,1,'CSS130117-105503+255352','CRTS-CSS',163.76098,25.89788,NULL,NULL,'2013-01-17 00:00:00',56309,18.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130117/1301171260534109021.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130117/jpg/1301171260534109021.master.jpg',NULL,NULL,60498275219,NULL,NULL,NULL,'2009-02-21 10:33:41',54883.440063,'2013-01-19 01:31:47','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301171260534109021/1301171260534109021.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130117/1301171260534109021p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,945285550,14770086,NULL,NULL,NULL,NULL),(11073,11073,1,'CSS130116-033901+234725','CRTS-CSS',54.7536,23.79015,NULL,NULL,'2013-01-16 00:00:00',56308,18.23,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130116/1301161230184124892.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130116/jpg/1301161230184124892.master.jpg',NULL,NULL,68040640931,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:47','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301161230184124892/1301161230184124892.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130116/1301161230184124892p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1063135014,16611484,NULL,NULL,NULL,NULL),(11074,11074,1,'CSS130112-111852-072810','CRTS-CSS',169.71738,-7.46958,NULL,NULL,'2013-01-12 00:00:00',56304,18.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130112/1301120070604117823.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130112/jpg/1301120070604117823.master.jpg',NULL,NULL,41015569970,NULL,NULL,NULL,'2011-03-13 11:31:10',55633.47998,'2013-01-19 01:31:47','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301120070604117823/1301120070604117823.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130112/1301120070604117823p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,640868280,10013566,NULL,NULL,NULL,NULL),(11076,11076,1,'CSS130108-091050+643808','CRTS-CSS',137.70665,64.63568,NULL,NULL,'2013-01-08 00:00:00',56300,18.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130108/1301081630234143254.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130108/jpg/1301081630234143254.master.jpg',NULL,NULL,62252555293,NULL,NULL,NULL,'2007-02-13 12:28:49',54144.52002,'2013-01-19 01:31:47','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301081630234143254/1301081630234143254.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130108/1301081630234143254p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,972696176,15198377,NULL,NULL,NULL,NULL),(11077,11077,1,'CSS130106-020405+193148','CRTS-CSS',31.01889,19.53,NULL,NULL,'2013-01-06 00:00:00',56298,18.04,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130106/1301061180114141191.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130106/jpg/1301061180114141191.master.jpg',NULL,NULL,68053361239,NULL,NULL,NULL,'2005-10-29 13:26:23',53672.559998,'2013-01-19 01:31:47','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301061180114141191/1301061180114141191.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130106/1301061180114141191p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1063333769,16614590,NULL,NULL,NULL,NULL),(11078,11078,1,'CSS130105-131252+265813','CRTS-CSS',198.21863,26.97022,NULL,NULL,'2013-01-05 00:00:00',56297,18.31,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130105/1301051260644124613.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130105/jpg/1301051260644124613.master.jpg',NULL,NULL,58718583333,NULL,NULL,NULL,'2005-03-01 10:33:34',53430.439987,'2013-01-19 01:31:47','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301051260644124613/1301051260644124613.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130105/1301051260644124613p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,917477864,14335591,NULL,NULL,NULL,NULL),(11079,11079,1,'CSS130105-113423+244438','CRTS-CSS',173.5979,24.74381,NULL,NULL,'2013-01-05 00:00:00',56297,17.66,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130105/1301051230574132403.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130105/jpg/1301051230574132403.master.jpg',NULL,NULL,60590186799,NULL,NULL,NULL,'2005-04-01 11:31:11',53461.479996,'2013-01-19 01:31:47','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301051230574132403/1301051230574132403.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130105/1301051230574132403p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,946721668,14792526,NULL,NULL,NULL,NULL),(11080,11080,1,'CSS130103-080252+162813','CRTS-CSS',120.71669,16.47033,NULL,NULL,'2013-01-03 00:00:00',56295,18.92,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130103/1301031150424151613.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130103/jpg/1301031150424151613.master.jpg',NULL,NULL,62669548088,NULL,NULL,NULL,'2011-11-22 10:33:30',55887.439941,'2013-01-19 01:31:47','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301031150424151613/1301031150424151613.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130103/1301031150424151613p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,979211688,15300182,NULL,NULL,NULL,NULL),(11081,11081,1,'CSS130103-082702-020234','CRTS-CSS',126.76005,-2.04277,NULL,NULL,'2013-01-03 00:00:00',56295,16.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130103/1301030010464118888.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130103/jpg/1301030010464118888.master.jpg',NULL,NULL,39221458457,NULL,NULL,NULL,'2012-04-21 13:26:07',56038.559814,'2013-01-19 01:31:47','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301030010464118888/1301030010464118888.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130103/1301030010464118888p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,612835288,9575551,NULL,NULL,NULL,NULL),(11082,11082,0,'CSS121212-103548+390028','CRTS-CSS',158.951,39.00775,NULL,NULL,'2012-12-12 00:00:00',56273,17.21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:47','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20121212/1212121380464142104.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121212/jpg/1212121380464142104.master.jpg',NULL,NULL,64117353984,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:47','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212121380464142104/1212121380464142104.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121212/1212121380464142104p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1001833656,15653650,NULL,NULL,NULL,NULL),(11083,11083,1,'CSS121211-040157+035721','CRTS-CSS',60.48894,3.95574,NULL,NULL,'2012-12-11 00:00:00',56272,18.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121211/1212111040224118793.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121211/jpg/1212111040224118793.master.jpg',NULL,NULL,65074552978,NULL,NULL,NULL,'2006-03-04 13:26:23',53798.559998,'2013-01-19 01:31:47','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212111040224118793/1212111040224118793.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121211/1212111040224118793p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,1016789890,15887342,NULL,NULL,NULL,NULL),(11084,11084,0,'CSS121210-064342+521234','CRTS-CSS',100.92453,52.20935,NULL,NULL,'2012-12-10 00:00:00',56271,17.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:47','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20121210/1212101520234135082.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121210/jpg/1212101520234135082.master.jpg',NULL,NULL,61493865456,NULL,NULL,NULL,'2012-10-10 13:26:07',56210.559814,'2013-01-19 01:31:47','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212101520234135082/1212101520234135082.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121210/1212101520234135082p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,960841647,15013150,NULL,NULL,NULL,NULL),(11085,11085,1,'CSS121210-112615+144039','CRTS-CSS',171.56149,14.67763,NULL,NULL,'2012-12-10 00:00:00',56271,17.97,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121210/1212101150604109404.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121210/jpg/1212101150604109404.master.jpg',NULL,NULL,60223028449,NULL,NULL,NULL,'2007-04-14 13:26:23',54204.559998,'2013-01-19 01:31:47','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212101150604109404/1212101150604109404.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121210/1212101150604109404p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,940984819,14702887,NULL,NULL,NULL,NULL),(11086,11086,0,'CSS121209-035417+363039','CRTS-CSS',58.57219,36.51075,NULL,NULL,'2012-12-09 00:00:00',56270,16.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:47','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20121209/1212091350184194219.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121209/jpg/1212091350184194219.master.jpg',NULL,NULL,68351541272,NULL,NULL,NULL,'2006-03-03 13:26:23',53797.559998,'2013-01-19 01:31:47','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212091350184194219/1212091350184194219.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121209/1212091350184194219p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1067992832,16687388,NULL,NULL,NULL,NULL),(11087,11087,1,'CSS121209-102348+202339','CRTS-CSS',155.95038,20.39404,NULL,NULL,'2012-12-09 00:00:00',56270,18.66,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121209/1212091210534111237.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121209/jpg/1212091210534111237.master.jpg',NULL,NULL,60940882405,NULL,NULL,NULL,'2006-01-04 11:31:10',53739.47998,'2013-01-19 01:31:48','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212091210534111237/1212091210534111237.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121209/1212091210534111237p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,952201287,14878145,NULL,NULL,NULL,NULL),(11088,11088,1,'CSS121207-090705+115032','CRTS-CSS',136.77163,11.84214,NULL,NULL,'2012-12-07 00:00:00',56268,18.56,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121207/1212071120484110619.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121207/jpg/1212071120484110619.master.jpg',NULL,NULL,63640857301,NULL,NULL,NULL,'2012-11-24 11:31:10',56255.47998,'2013-01-19 01:31:48','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212071120484110619/1212071120484110619.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121207/1212071120484110619p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,994388395,15537318,NULL,NULL,NULL,NULL),(11089,11089,0,'CSS121204-050130-134346','CRTS-CSS',75.37448,-13.72956,NULL,NULL,'2012-12-04 00:00:00',56265,16.38,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:48','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20121204/1212040120274106666.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121204/jpg/1212040120274106666.master.jpg',NULL,NULL,37527121091,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:48','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212040120274106666/1212040120274106666.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121204/1212040120274106666p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,586361267,9161894,NULL,NULL,NULL,NULL),(11090,11090,1,'CSS121203-112646+273727','CRTS-CSS',171.69318,27.62424,NULL,NULL,'2012-12-03 00:00:00',56264,18.01,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121203/1212031260564126571.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121203/jpg/1212031260564126571.master.jpg',NULL,NULL,60577846497,NULL,NULL,NULL,'2009-04-03 10:33:41',54924.440063,'2013-01-19 01:31:48','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212031260564126571/1212031260564126571.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121203/1212031260564126571p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,946528851,14789513,NULL,NULL,NULL,NULL),(11091,11091,0,'CSS121125-052126-165258','CRTS-CSS',80.35868,-16.88288,NULL,NULL,'2012-11-25 00:00:00',56256,16.29,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:48','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20121125/1211250150284101590.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121125/jpg/1211250150284101590.master.jpg',NULL,NULL,37409158003,NULL,NULL,NULL,'2006-11-01 11:31:15',54040.480042,'2013-01-19 01:31:48','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211250150284101590/1211250150284101590.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121125/1211250150284101590p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,584518093,9133095,NULL,NULL,NULL,NULL),(11092,11092,1,'CSS121124-215630-190601','CRTS-CSS',329.12607,-19.10026,NULL,NULL,'2012-11-24 00:00:00',56255,18.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121124/1211240181134110780.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121124/jpg/1211240181134110780.master.jpg',NULL,NULL,50873314484,NULL,NULL,NULL,'2012-10-09 13:26:07',56209.559814,'2013-01-19 01:31:48','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211240181134110780/1211240181134110780.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121124/1211240181134110780p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,794895538,12420242,NULL,NULL,NULL,NULL),(11093,11093,0,'CSS121120-025018+322440','CRTS-CSS',42.57339,32.41108,NULL,NULL,'2012-11-20 00:00:00',56251,17.03,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:48','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20121120/1211201320134127533.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121120/jpg/1211201320134127533.master.jpg',NULL,NULL,68680982283,NULL,NULL,NULL,'2010-11-08 10:33:30',55508.439941,'2013-01-19 01:31:48','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211201320134127533/1211201320134127533.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121120/1211201320134127533p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1073140348,16767817,NULL,NULL,NULL,NULL),(11094,11094,0,'CSS121120-015148+211622','CRTS-CSS',27.9488,21.27265,NULL,NULL,'2012-11-20 00:00:00',56251,18.46,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:48','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20121120/1211201210104124196.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121120/jpg/1211201210104124196.master.jpg',NULL,NULL,66910395369,NULL,NULL,NULL,'2009-01-17 10:33:41',54848.440063,'2013-01-19 01:31:48','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211201210104124196/1211201210104124196.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121120/1211201210104124196p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1045474927,16335545,NULL,NULL,NULL,NULL),(11095,11095,1,'CSS121114-102632+053508','CRTS-CSS',156.6337,5.58545,NULL,NULL,'2012-11-14 00:00:00',56245,17.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121114/1211141040564146287.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121114/jpg/1211141040564146287.master.jpg',NULL,NULL,61010446265,NULL,NULL,NULL,'2009-04-23 10:33:41',54944.440063,'2013-01-19 01:31:48','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211141040564146287/1211141040564146287.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121114/1211141040564146287p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,953288222,14895128,NULL,NULL,NULL,NULL),(11097,11097,1,'CSS121114-031022-261804','CRTS-CSS',47.59109,-26.30118,NULL,NULL,'2012-11-14 00:00:00',56245,18.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121114/1211140260164132316.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121114/jpg/1211140260164132316.master.jpg',NULL,NULL,38541380546,NULL,NULL,NULL,'2012-01-29 13:26:07',55955.559814,'2013-01-19 01:31:48','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211140260164132316/1211140260164132316.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121114/1211140260164132316p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,602209071,9409516,NULL,NULL,NULL,NULL),(11098,11098,1,'CSS121112-002624+163027','CRTS-CSS',6.5994,16.5076,NULL,NULL,'2012-11-12 00:00:00',56243,17.45,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121112/1211121150034142136.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121112/jpg/1211121150034142136.master.jpg',NULL,NULL,66744095450,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:48','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211121150034142136/1211121150034142136.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121112/1211121150034142136p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1042876491,16294945,NULL,NULL,NULL,NULL),(11099,11099,1,'CSS121112-004232+021732','CRTS-CSS',10.63192,2.29211,NULL,NULL,'2012-11-12 00:00:00',56243,19.25,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121112/1211121010044139995.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121112/jpg/1211121010044139995.master.jpg',NULL,NULL,66808718325,NULL,NULL,NULL,'2012-08-25 13:26:07',56164.559814,'2013-01-19 01:31:48','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211121010044139995/1211121010044139995.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121112/1211121010044139995p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1043886223,16310722,NULL,NULL,NULL,NULL),(11104,11104,1,'CSS121020-051457-130750','CRTS-CSS',78.73897,-13.13049,NULL,NULL,'2012-10-20 00:00:00',56220,18.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121020/1210200120284120600.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121020/jpg/1210200120284120600.master.jpg',NULL,NULL,37400268353,NULL,NULL,NULL,'2012-02-23 13:26:07',55980.559814,'2013-01-19 01:31:49','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210200120284120600/1210200120284120600.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121020/1210200120284120600p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,584379193,9130924,NULL,NULL,NULL,NULL),(11113,11113,0,'CSS120920-231013+303443','CRTS-CSS',347.55297,30.5785,NULL,NULL,'2012-09-20 00:00:00',56190,17.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:49','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120920/1209201291104150818.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120920/jpg/1209201291104150818.master.jpg',NULL,NULL,52064456512,NULL,NULL,NULL,'2012-08-12 13:26:07',56151.559814,'2013-01-19 01:31:49','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209201291104150818/1209201291104150818.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120920/1209201291104150818p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,813507133,12711048,NULL,NULL,NULL,NULL),(11114,11114,1,'CSS120919-235723-182711','CRTS-CSS',359.34494,-18.45311,NULL,NULL,'2012-09-19 00:00:00',56189,18.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120919/1209190181234125108.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120919/jpg/1209190181234125108.master.jpg',NULL,NULL,49533430306,NULL,NULL,NULL,'2011-11-30 13:26:07',55895.559814,'2013-01-19 01:31:49','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209190181234125108/1209190181234125108.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120919/1209190181234125108p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,773959848,12093122,NULL,NULL,NULL,NULL),(11116,11116,1,'CSS120917-164704+231612','CRTS-CSS',251.76645,23.26989,NULL,NULL,'2012-09-17 00:00:00',56187,18.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120917/1209171230834113314.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120917/jpg/1209171230834113314.master.jpg',NULL,NULL,56681709530,NULL,NULL,NULL,'2007-03-27 10:33:36',54186.440002,'2013-01-19 01:31:49','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209171230834113314/1209171230834113314.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120917/1209171230834113314p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,885651711,13838307,NULL,NULL,NULL,NULL),(11118,11118,1,'CSS120914-034406+102042','CRTS-CSS',56.02397,10.34491,NULL,NULL,'2012-09-14 00:00:00',56184,18.97,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120914/1209141090204129093.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120914/jpg/1209141090204129093.master.jpg',NULL,NULL,65195377290,NULL,NULL,NULL,'2006-10-22 11:31:15',54030.480042,'2013-01-19 01:31:49','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209141090204129093/1209141090204129093.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120914/1209141090204129093p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1018677770,15916840,NULL,NULL,NULL,NULL),(11122,11122,0,'CSS120718-214830-125021','CRTS-CSS',327.12622,-12.83925,NULL,NULL,'2012-07-18 00:00:00',56126,18.12,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120718/1207180121154125168.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120718/jpg/1207180121154125168.master.jpg',NULL,NULL,49775047098,NULL,NULL,NULL,'2005-06-29 11:31:10',53550.47998,'2013-01-19 01:31:50','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1207180121154125168/1207180121154125168.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120718/1207180121154125168p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,777735110,12152111,NULL,NULL,NULL,NULL),(11123,11123,1,'CSS120718-205852-025826','CRTS-CSS',314.71644,-2.97396,NULL,NULL,'2012-07-18 00:00:00',56126,15.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120718/1207180041124185000.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120718/jpg/1207180041124185000.master.jpg',NULL,NULL,50735667924,NULL,NULL,NULL,'2006-06-17 13:26:23',53903.559998,'2013-01-19 01:31:50','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1207180041124185000/1207180041124185000.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120718/1207180041124185000p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,792744811,12386637,NULL,NULL,NULL,NULL),(11124,11124,1,'CSS120619-110620+264642','CRTS-CSS',166.5814,26.77845,NULL,NULL,'2012-06-19 00:00:00',56097,19.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120619/1206191260544117222.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120619/jpg/1206191260544117222.master.jpg',NULL,NULL,60612941047,NULL,NULL,NULL,'2012-05-18 13:26:07',56065.559814,'2013-01-19 01:31:50','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206191260544117222/1206191260544117222.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120619/1206191260544117222p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,947077203,14798081,NULL,NULL,NULL,NULL),(11125,11125,1,'CSS120618-134617+324600','CRTS-CSS',206.56984,32.76675,NULL,NULL,'2012-06-18 00:00:00',56096,19.67,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120618/1206181320644122933.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120618/jpg/1206181320644122933.master.jpg',NULL,NULL,59184807170,NULL,NULL,NULL,'2012-06-10 13:26:07',56088.559814,'2013-01-19 01:31:50','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206181320644122933/1206181320644122933.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120618/1206181320644122933p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,924762612,14449415,NULL,NULL,NULL,NULL),(11126,11126,0,'CSS120618-133350+260807','CRTS-CSS',203.45672,26.13527,NULL,NULL,'2012-06-18 00:00:00',56096,18.61,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120618/1206181260664109870.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120618/jpg/1206181260664109870.master.jpg',NULL,NULL,58668438154,NULL,NULL,NULL,'2012-05-22 13:26:07',56069.559814,'2013-01-19 01:31:50','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206181260664109870/1206181260664109870.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120618/1206181260664109870p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,916694346,14323349,NULL,NULL,NULL,NULL),(11127,11127,0,'CSS120618-130234+272611','CRTS-CSS',195.64024,27.43648,NULL,NULL,'2012-06-18 00:00:00',56096,16.71,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120618/1206181260644127774.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120618/jpg/1206181260644127774.master.jpg',NULL,NULL,58697978889,NULL,NULL,NULL,'2012-06-10 13:26:07',56088.559814,'2013-01-19 01:31:50','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206181260644127774/1206181260644127774.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120618/1206181260644127774p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,917155920,14330561,NULL,NULL,NULL,NULL),(11128,11128,1,'CSS120616-153502+144656','CRTS-CSS',233.75891,14.78225,NULL,NULL,'2012-06-16 00:00:00',56094,19.84,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120616/1206161150814110505.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120616/jpg/1206161150814110505.master.jpg',NULL,NULL,59428294687,NULL,NULL,NULL,'2011-04-06 10:33:30',55657.439941,'2013-01-19 01:31:50','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206161150814110505/1206161150814110505.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120616/1206161150814110505p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,928567104,14508861,NULL,NULL,NULL,NULL),(11129,11129,1,'CSS120615-105400+182844','CRTS-CSS',163.5016,18.47881,NULL,NULL,'2012-06-15 00:00:00',56093,18.65,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120615/1206151180564122192.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120615/jpg/1206151180564122192.master.jpg',NULL,NULL,61159003941,NULL,NULL,NULL,'2007-02-08 13:26:23',54139.559998,'2013-01-19 01:31:50','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206151180564122192/1206151180564122192.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120615/1206151180564122192p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,955609436,14931397,NULL,NULL,NULL,NULL),(11130,11130,1,'CSS120612-115257+214248','CRTS-CSS',178.23886,21.71335,NULL,NULL,'2012-06-12 00:00:00',56090,18.16,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120612/1206121210604127753.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120612/jpg/1206121210604127753.master.jpg',NULL,NULL,61072599019,NULL,NULL,NULL,'2010-04-17 12:28:49',55303.52002,'2013-01-19 01:31:50','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206121210604127753/1206121210604127753.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120612/1206121210604127753p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,954259359,14910302,NULL,NULL,NULL,NULL),(11131,11131,1,'CSS120612-104831+215524','CRTS-CSS',162.12905,21.92328,NULL,NULL,'2012-06-12 00:00:00',56090,19.38,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120612/1206121210554127866.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120612/jpg/1206121210554127866.master.jpg',NULL,NULL,60984473258,NULL,NULL,NULL,'2010-02-17 10:33:41',55244.440063,'2013-01-19 01:31:50','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206121210554127866/1206121210554127866.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120612/1206121210554127866p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,952882394,14888787,NULL,NULL,NULL,NULL),(11132,11132,1,'CSS120611-145635+394104','CRTS-CSS',224.14479,39.68432,NULL,NULL,'2012-06-11 00:00:00',56089,19.08,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120611/1206111400624102259.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120611/jpg/1206111400624102259.master.jpg',NULL,NULL,60070991545,NULL,NULL,NULL,'2006-05-28 10:33:36',53883.440002,'2013-01-19 01:31:50','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206111400624102259/1206111400624102259.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120611/1206111400624102259p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,938609242,14665769,NULL,NULL,NULL,NULL),(11133,11133,1,'CSS120611-124020+155337','CRTS-CSS',190.08267,15.8936,NULL,NULL,'2012-06-11 00:00:00',56089,18.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120611/1206111150664126745.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120611/jpg/1206111150664126745.master.jpg',NULL,NULL,58887361258,NULL,NULL,NULL,'2006-03-25 10:33:36',53819.440002,'2013-01-19 01:31:50','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206111150664126745/1206111150664126745.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120611/1206111150664126745p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,920115019,14376797,NULL,NULL,NULL,NULL),(11135,11135,1,'CSS120608-170727+115705','CRTS-CSS',256.86125,11.95151,NULL,NULL,'2012-06-08 00:00:00',56086,18.56,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120608/1206081120904116691.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120608/jpg/1206081120904116691.master.jpg',NULL,NULL,56844832793,NULL,NULL,NULL,'2012-03-21 13:26:07',56007.559814,'2013-01-19 01:31:50','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206081120904116691/1206081120904116691.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120608/1206081120904116691p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,888200512,13878133,NULL,NULL,NULL,NULL),(11136,11136,1,'CSS120525-151329+145720','CRTS-CSS',228.37021,14.95569,NULL,NULL,'2012-05-25 00:00:00',56072,18.84,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120525/1205251150794114147.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120525/jpg/1205251150794114147.master.jpg',NULL,NULL,59572734188,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205251150794114147/1205251150794114147.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120525/1205251150794114147p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,930823971,14544124,NULL,NULL,NULL,NULL),(11137,11137,1,'CSS120524-103247+233628','CRTS-CSS',158.19694,23.60789,NULL,NULL,'2012-05-24 00:00:00',56071,18.44,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120524/1205241230524115253.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120524/jpg/1205241230524115253.master.jpg',NULL,NULL,60947160207,NULL,NULL,NULL,'2006-12-15 13:26:23',54084.559998,'2013-01-19 01:31:50','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205241230524115253/1205241230524115253.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120524/1205241230524115253p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,952299378,14879677,NULL,NULL,NULL,NULL),(11138,11138,1,'CSS120519-075615+440205','CRTS-CSS',119.06179,44.03471,NULL,NULL,'2012-05-19 00:00:00',56066,17.5,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120519/1205191430324126387.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120519/jpg/1205191430324126387.master.jpg',NULL,NULL,63558878151,NULL,NULL,NULL,'2012-04-27 13:26:07',56044.559814,'2013-01-19 01:31:50','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205191430324126387/1205191430324126387.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120519/1205191430324126387p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,993107471,15517304,NULL,NULL,NULL,NULL),(11139,11139,0,'CSS120516-143823+232055','CRTS-CSS',219.59784,23.34863,NULL,NULL,'2012-05-16 00:00:00',56063,17.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120516/1205161230724111724.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120516/jpg/1205161230724111724.master.jpg',NULL,NULL,59508051263,NULL,NULL,NULL,'2012-04-25 13:26:07',56042.559814,'2013-01-19 01:31:50','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205161230724111724/1205161230724111724.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120516/1205161230724111724p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,929813300,14528332,NULL,NULL,NULL,NULL),(11140,11140,1,'CSS120516-133455+233452','CRTS-CSS',203.7278,23.58124,NULL,NULL,'2012-05-16 00:00:00',56063,18.42,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120516/1205161230674115059.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120516/jpg/1205161230674115059.master.jpg',NULL,NULL,58802200713,NULL,NULL,NULL,'2012-02-21 10:33:30',55978.439941,'2013-01-19 01:31:51','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205161230674115059/1205161230674115059.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120516/1205161230674115059p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,918784386,14356006,NULL,NULL,NULL,NULL),(11141,11141,1,'CSS120516-094938+144535','CRTS-CSS',147.4094,14.75962,NULL,NULL,'2012-05-16 00:00:00',56063,18.92,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120516/1205161150514108827.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120516/jpg/1205161150514108827.master.jpg',NULL,NULL,60833900649,NULL,NULL,NULL,'2012-04-23 13:26:07',56040.559814,'2013-01-19 01:31:51','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205161150514108827/1205161150514108827.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120516/1205161150514108827p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,950529697,14852026,NULL,NULL,NULL,NULL),(11142,11142,1,'CSS120516-100524+131956','CRTS-CSS',151.35123,13.33235,NULL,NULL,'2012-05-16 00:00:00',56063,18.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120516/1205161120534130600.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120516/jpg/1205161120534130600.master.jpg',NULL,NULL,60846656822,NULL,NULL,NULL,'2011-04-05 11:31:10',55656.47998,'2013-01-19 01:31:51','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205161120534130600/1205161120534130600.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120516/1205161120534130600p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,950729012,14855140,NULL,NULL,NULL,NULL),(11143,11143,1,'CSS120501-152722+192749','CRTS-CSS',231.8404,19.46373,NULL,NULL,'2012-05-01 00:00:00',56048,19.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120501/1205011180804142223.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120501/jpg/1205011180804142223.master.jpg',NULL,NULL,59445428404,NULL,NULL,NULL,'2012-03-28 13:26:07',56014.559814,'2013-01-19 01:31:51','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205011180804142223/1205011180804142223.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120501/1205011180804142223p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,928834818,14513044,NULL,NULL,NULL,NULL),(11144,11144,1,'CSS120430-164142+291159','CRTS-CSS',250.42667,29.19976,NULL,NULL,'2012-04-30 00:00:00',56047,19.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120430/1204301290794121687.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120430/jpg/1204301290794121687.master.jpg',NULL,NULL,56228265760,NULL,NULL,NULL,'2012-04-02 13:26:07',56019.559814,'2013-01-19 01:31:51','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204301290794121687/1204301290794121687.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120430/1204301290794121687p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,878566652,13727603,NULL,NULL,NULL,NULL),(11145,11145,1,'CSS120427-131511+531654','CRTS-CSS',198.79648,53.28169,NULL,NULL,'2012-04-27 00:00:00',56044,18.56,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120427/1204271520454138340.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120427/jpg/1204271520454138340.master.jpg',NULL,NULL,57415598401,NULL,NULL,NULL,'2006-02-03 13:26:23',53769.559998,'2013-01-19 01:31:51','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204271520454138340/1204271520454138340.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120427/1204271520454138340p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,897118725,14017480,NULL,NULL,NULL,NULL),(11146,11146,1,'CSS120424-140216-112108','CRTS-CSS',210.56771,-11.35236,NULL,NULL,'2012-04-24 00:00:00',56041,18.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120424/1204240120744152086.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120424/jpg/1204240120744152086.master.jpg',NULL,NULL,43747577009,NULL,NULL,NULL,'2012-04-15 13:26:07',56032.559814,'2013-01-19 01:31:51','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204240120744152086/1204240120744152086.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120424/1204240120744152086p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,683555890,10680560,NULL,NULL,NULL,NULL),(11147,11147,1,'CSS120422-083746+522004','CRTS-CSS',129.44338,52.33446,NULL,NULL,'2012-04-22 00:00:00',56039,18.23,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120422/1204221520304126274.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120422/jpg/1204221520304126274.master.jpg',NULL,NULL,63500868190,NULL,NULL,NULL,'2007-01-27 13:26:23',54127.559998,'2013-01-19 01:31:51','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204221520304126274/1204221520304126274.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120422/1204221520304126274p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,992201065,15503141,NULL,NULL,NULL,NULL),(11155,11155,0,'CSS120416-104354+114017','CRTS-CSS',160.97393,11.67151,NULL,NULL,'2012-04-16 00:00:00',56033,12.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:51','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120416/1204161120574107039.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120416/jpg/1204161120574107039.master.jpg',NULL,NULL,61044875372,NULL,NULL,NULL,'2009-02-16 10:33:41',54878.440063,'2013-01-19 01:31:51','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204161120574107039/1204161120574107039.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120416/1204161120574107039p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,953826177,14903534,NULL,NULL,NULL,NULL),(11157,11157,1,'CSS120416-120240-095738','CRTS-CSS',180.66501,-9.96065,NULL,NULL,'2012-04-16 00:00:00',56033,18.21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120416/1204160090644123128.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120416/jpg/1204160090644123128.master.jpg',NULL,NULL,42967252129,NULL,NULL,NULL,'2006-04-30 13:26:23',53855.559998,'2013-01-19 01:31:51','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204160090644123128/1204160090644123128.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120416/1204160090644123128p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,671363314,10490051,NULL,NULL,NULL,NULL),(11158,11158,1,'CSS120402-114913+555513','CRTS-CSS',177.30567,55.92021,NULL,NULL,'2012-04-02 00:00:00',56019,19.62,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120402/1204021550384131537.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120402/jpg/1204021550384131537.master.jpg',NULL,NULL,61757194397,NULL,NULL,NULL,'2012-01-01 12:28:49',55927.52002,'2013-01-19 01:31:51','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204021550384131537/1204021550384131537.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120402/1204021550384131537p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,964956162,15077440,NULL,NULL,NULL,NULL),(11159,11159,1,'CSS120401-135211+462820','CRTS-CSS',208.04389,46.47226,NULL,NULL,'2012-04-01 00:00:00',56018,17.82,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120401/1204011460524120859.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120401/jpg/1204011460524120859.master.jpg',NULL,NULL,59240392220,NULL,NULL,NULL,'2012-02-12 13:26:07',55969.559814,'2013-01-19 01:31:51','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204011460524120859/1204011460524120859.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120401/1204011460524120859p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,925631128,14462986,NULL,NULL,NULL,NULL),(11160,11160,1,'CSS120401-100127+415736','CRTS-CSS',150.36368,41.9601,NULL,NULL,'2012-04-01 00:00:00',56018,17.68,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120401/1204011400424136005.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120401/jpg/1204011400424136005.master.jpg',NULL,NULL,64103597353,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:51','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204011400424136005/1204011400424136005.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120401/1204011400424136005p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1001618708,15650292,NULL,NULL,NULL,NULL),(11161,11161,1,'CSS120401-153635+330059','CRTS-CSS',234.14547,33.01628,NULL,NULL,'2012-04-01 00:00:00',56018,19.81,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120401/1204011320724136527.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120401/jpg/1204011320724136527.master.jpg',NULL,NULL,59884122457,NULL,NULL,NULL,'2011-06-13 13:26:07',55725.559814,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204011320724136527/1204011320724136527.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120401/1204011320724136527p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,935689413,14620147,NULL,NULL,NULL,NULL),(11163,11163,1,'CSS120329-124746+161051','CRTS-CSS',191.94081,16.18096,NULL,NULL,'2012-03-29 00:00:00',56015,19.97,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120329/1203291150674137948.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120329/jpg/1203291150674137948.master.jpg',NULL,NULL,58878898379,NULL,NULL,NULL,'2010-03-21 13:26:29',55276.560059,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203291150674137948/1203291150674137948.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120329/1203291150674137948p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,919982787,14374731,NULL,NULL,NULL,NULL),(11164,11164,1,'CSS120328-123356+233248','CRTS-CSS',188.48159,23.54678,NULL,NULL,'2012-03-28 00:00:00',56014,20.43,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120328/1203281230624117329.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120328/jpg/1203281230624117329.master.jpg',NULL,NULL,58612804644,NULL,NULL,NULL,'2008-12-06 10:33:41',54806.440063,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203281230624117329/1203281230624117329.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120328/1203281230624117329p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,915825072,14309766,NULL,NULL,NULL,NULL),(11165,11165,1,'CSS120328-152754+185519','CRTS-CSS',231.97392,18.92181,NULL,NULL,'2012-03-28 00:00:00',56014,19.46,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120328/1203281180804139974.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120328/jpg/1203281180804139974.master.jpg',NULL,NULL,59445372464,NULL,NULL,NULL,'2007-04-25 12:28:49',54215.52002,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203281180804139974/1203281180804139974.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120328/1203281180804139974p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,928833944,14513030,NULL,NULL,NULL,NULL),(11166,11166,0,'CSS120328-122417+185529','CRTS-CSS',186.07093,18.92481,NULL,NULL,'2012-03-28 00:00:00',56014,17.6,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120328/1203281180644135630.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120328/jpg/1203281180644135630.master.jpg',NULL,NULL,58860262623,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203281180644135630/1203281180644135630.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120328/1203281180644135630p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,919691603,14370181,NULL,NULL,NULL,NULL),(11167,11167,1,'CSS120328-152416+050318','CRTS-CSS',231.06534,5.05489,NULL,NULL,'2012-03-28 00:00:00',56014,18.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120328/1203281040834151830.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120328/jpg/1203281040834151830.master.jpg',NULL,NULL,56428741790,NULL,NULL,NULL,'2007-04-16 11:31:15',54206.480042,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203281040834151830/1203281040834151830.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120328/1203281040834151830p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,881699090,13776548,NULL,NULL,NULL,NULL),(11168,11168,1,'CSS120327-141750+052004','CRTS-CSS',214.45839,5.33436,NULL,NULL,'2012-03-27 00:00:00',56013,19.19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120327/1203271040774143775.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120327/jpg/1203271040774143775.master.jpg',NULL,NULL,58473398317,NULL,NULL,NULL,'2011-03-05 10:33:30',55625.439941,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203271040774143775/1203271040774143775.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120327/1203271040774143775p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,913646848,14275732,NULL,NULL,NULL,NULL),(11169,11169,1,'CSS120327-110520-015205','CRTS-CSS',166.33365,-1.8681,NULL,NULL,'2012-03-27 00:00:00',56013,17.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120327/1203270010604115428.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120327/jpg/1203270010604115428.master.jpg',NULL,NULL,40918957462,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203270010604115428/1203270010604115428.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120327/1203270010604115428p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,639358710,9989979,NULL,NULL,NULL,NULL),(11170,11170,1,'CSS120322-130213+143141','CRTS-CSS',195.556,14.52818,NULL,NULL,'2012-03-22 00:00:00',56008,18.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120322/1203221150684107839.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120322/jpg/1203221150684107839.master.jpg',NULL,NULL,59049539307,NULL,NULL,NULL,'2005-06-03 12:28:47',53524.519989,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203221150684107839/1203221150684107839.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120322/1203221150684107839p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,922649051,14416391,NULL,NULL,NULL,NULL),(11171,11171,1,'CSS120317-114744+031755','CRTS-CSS',176.93398,3.29868,NULL,NULL,'2012-03-17 00:00:00',56003,19.38,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120317/1203171040634108482.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120317/jpg/1203171040634108482.master.jpg',NULL,NULL,60193413444,NULL,NULL,NULL,'2009-11-16 10:33:41',55151.440063,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203171040634108482/1203171040634108482.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120317/1203171040634108482p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,940522085,14695657,NULL,NULL,NULL,NULL),(11172,11172,1,'CSS120315-130057+373511','CRTS-CSS',195.23838,37.58635,NULL,NULL,'2012-03-15 00:00:00',56001,18.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120315/1203151380564116199.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120315/jpg/1203151380564116199.master.jpg',NULL,NULL,59074189581,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203151380564116199/1203151380564116199.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120315/1203151380564116199p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,923034212,14422409,NULL,NULL,NULL,NULL),(11173,11173,0,'CSS120313-030852+171803','CRTS-CSS',47.21706,17.30089,NULL,NULL,'2012-03-13 00:00:00',55999,17.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120313/1203131180174105289.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120313/jpg/1203131180174105289.master.jpg',NULL,NULL,68174099658,NULL,NULL,NULL,'2012-02-25 13:26:07',55982.559814,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203131180174105289/1203131180174105289.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120313/1203131180174105289p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1065220307,16644067,NULL,NULL,NULL,NULL),(11174,11174,1,'CSS120301-133156+235405','CRTS-CSS',202.98299,23.90144,NULL,NULL,'2012-03-01 00:00:00',55987,19.08,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120301/1203011230674219852.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120301/jpg/1203011230674219852.master.jpg',NULL,NULL,58793874977,NULL,NULL,NULL,'2008-12-07 10:33:41',54807.440063,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203011230674219852/1203011230674219852.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120301/1203011230674219852p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,918654296,14353973,NULL,NULL,NULL,NULL),(11175,11175,0,'CSS120301-162036-102738','CRTS-CSS',245.15008,-10.46064,NULL,NULL,'2012-03-01 00:00:00',55987,16.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120301/1203010090874125669.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120301/jpg/1203010090874125669.master.jpg',NULL,NULL,45537177856,NULL,NULL,NULL,'2012-02-21 13:26:07',55978.559814,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203010090874125669/1203010090874125669.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120301/1203010090874125669p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,711518404,11117475,NULL,NULL,NULL,NULL),(11176,11176,1,'CSS120229-150641+044048','CRTS-CSS',226.66953,4.67999,NULL,NULL,'2012-02-29 00:00:00',55986,18.78,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120229/1202291040814137444.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120229/jpg/1202291040814137444.master.jpg',NULL,NULL,59331807168,NULL,NULL,NULL,'2009-04-01 10:33:41',54922.440063,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202291040814137444/1202291040814137444.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120229/1202291040814137444p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,927059487,14485304,NULL,NULL,NULL,NULL),(11177,11177,1,'CSS120225-113149+085941','CRTS-CSS',172.95314,8.99465,NULL,NULL,'2012-02-25 00:00:00',55982,19.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120225/1202251090624111413.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120225/jpg/1202251090624111413.master.jpg',NULL,NULL,60388788317,NULL,NULL,NULL,'2012-01-23 13:26:07',55949.559814,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202251090624111413/1202251090624111413.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120225/1202251090624111413p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,943574817,14743356,NULL,NULL,NULL,NULL),(11178,11178,1,'CSS120225-135902+021739','CRTS-CSS',209.75815,2.29419,NULL,NULL,'2012-02-25 00:00:00',55982,18.46,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120225/1202251010754143975.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120225/jpg/1202251010754143975.master.jpg',NULL,NULL,58414867109,NULL,NULL,NULL,'2008-04-05 10:33:41',54561.440063,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202251010754143975/1202251010754143975.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120225/1202251010754143975p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,912732298,14261442,NULL,NULL,NULL,NULL),(11179,11179,1,'CSS120224-134312+322634','CRTS-CSS',205.80111,32.44271,NULL,NULL,'2012-02-24 00:00:00',55981,19.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120224/1202241320634124271.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120224/jpg/1202241320634124271.master.jpg',NULL,NULL,59186310748,NULL,NULL,NULL,'2009-04-02 10:33:41',54923.440063,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202241320634124271/1202241320634124271.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120224/1202241320634124271p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,924786105,14449782,NULL,NULL,NULL,NULL),(11180,11180,0,'CSS120224-145405+220541','CRTS-CSS',223.52136,22.09461,NULL,NULL,'2012-02-24 00:00:00',55981,17.6,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:52','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120224/1202241210764144227.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120224/jpg/1202241210764144227.master.jpg',NULL,NULL,59526733232,NULL,NULL,NULL,'2009-01-30 10:33:41',54861.440063,'2013-01-19 01:31:52','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202241210764144227/1202241210764144227.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120224/1202241210764144227p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,930105206,14532893,NULL,NULL,NULL,NULL),(11181,11181,0,'CSS120224-094326-065336','CRTS-CSS',145.85713,-6.89331,NULL,NULL,'2012-02-24 00:00:00',55981,17.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120224/1202240070524129645.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120224/jpg/1202240070524129645.master.jpg',NULL,NULL,41322716235,NULL,NULL,NULL,'2011-04-28 13:26:07',55679.559814,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202240070524129645/1202240070524129645.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120224/1202240070524129645p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,645667441,10088553,NULL,NULL,NULL,NULL),(11182,11182,1,'CSS120223-095241+352001','CRTS-CSS',148.17191,35.33354,NULL,NULL,'2012-02-23 00:00:00',55980,19.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120223/1202231350444125102.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120223/jpg/1202231350444125102.master.jpg',NULL,NULL,64182535326,NULL,NULL,NULL,'2011-02-06 13:26:07',55598.559814,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202231350444125102/1202231350444125102.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120223/1202231350444125102p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1002852114,15669564,NULL,NULL,NULL,NULL),(11183,11183,0,'CSS120223-101223+334336','CRTS-CSS',153.0956,33.72667,NULL,NULL,'2012-02-23 00:00:00',55980,19.3,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-12-24 20:38:21','http://nesssi.cacr.caltech.edu/catalina/20120223/1202231320474151098.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120223/jpg/1202231320474151098.master.jpg',NULL,NULL,64079370825,NULL,NULL,NULL,'2007-02-09 10:33:36',54140.440002,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202231320474151098/1202231320474151098.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120223/1202231320474151098p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1001240169,15644377,NULL,NULL,NULL,NULL),(11184,11184,1,'CSS120222-084614+225502','CRTS-CSS',131.55931,22.91717,NULL,NULL,'2012-02-22 00:00:00',55979,19.27,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120222/1202221230444107847.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120222/jpg/1202221230444107847.master.jpg',NULL,NULL,63801080596,NULL,NULL,NULL,'2006-12-23 11:31:15',54092.480042,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202221230444107847/1202221230444107847.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120222/1202221230444107847p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,996891884,15576435,NULL,NULL,NULL,NULL),(11185,11185,1,'CSS120222-095634+180751','CRTS-CSS',149.1436,18.13096,NULL,NULL,'2012-02-22 00:00:00',55979,19.21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120222/1202221180514124105.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120222/jpg/1202221180514124105.master.jpg',NULL,NULL,60859484242,NULL,NULL,NULL,'2011-12-31 12:28:49',55926.52002,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202221180514124105/1202221180514124105.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120222/1202221180514124105p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,950929441,14858272,NULL,NULL,NULL,NULL),(11186,11186,0,'CSS120221-112052+513230','CRTS-CSS',170.21818,51.54173,NULL,NULL,'2012-02-21 00:00:00',55978,18.66,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120221/1202211520394112056.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120221/jpg/1202211520394112056.master.jpg',NULL,NULL,61796805311,NULL,NULL,NULL,'2012-01-01 11:31:10',55927.47998,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202211520394112056/1202211520394112056.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120221/1202211520394112056p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,965575082,15087110,NULL,NULL,NULL,NULL),(11187,11187,0,'CSS120219-112911+360021','CRTS-CSS',172.29665,36.00571,NULL,NULL,'2012-02-19 00:00:00',55976,18.31,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120219/1202191350514141588.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120219/jpg/1202191350514141588.master.jpg',NULL,NULL,60419217163,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202191350514141588/1202191350514141588.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120219/1202191350514141588p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,944050268,14750785,NULL,NULL,NULL,NULL),(11188,11188,0,'CSS120219-123935+163512','CRTS-CSS',189.89615,16.58673,NULL,NULL,'2012-02-19 00:00:00',55976,17.41,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120219/1202191150664141850.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120219/jpg/1202191150664141850.master.jpg',NULL,NULL,58884695482,NULL,NULL,NULL,'2011-11-28 13:26:07',55893.559814,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202191150664141850/1202191150664141850.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120219/1202191150664141850p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,920073366,14376146,NULL,NULL,NULL,NULL),(11189,11189,0,'CSS120218-111158+294206','CRTS-CSS',167.99312,29.70154,NULL,NULL,'2012-02-18 00:00:00',55975,18.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120218/1202181290534121521.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120218/jpg/1202181290534121521.master.jpg',NULL,NULL,60657526063,NULL,NULL,NULL,'2012-02-02 13:26:07',55959.559814,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202181290534121521/1202181290534121521.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120218/1202181290534121521p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,947773844,14808966,NULL,NULL,NULL,NULL),(11190,11190,1,'CSS120218-113445+211433','CRTS-CSS',173.68927,21.2426,NULL,NULL,'2012-02-18 00:00:00',55975,19.19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120218/1202181210594123955.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120218/jpg/1202181210594123955.master.jpg',NULL,NULL,61074937715,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202181210594123955/1202181210594123955.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120218/1202181210594123955p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,954295901,14910873,NULL,NULL,NULL,NULL),(11191,11191,1,'CSS120218-013618+114123','CRTS-CSS',24.07414,11.68959,NULL,NULL,'2012-02-18 00:00:00',55975,18.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120218/1202181120094104611.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120218/jpg/1202181120094104611.master.jpg',NULL,NULL,67528505547,NULL,NULL,NULL,'2005-09-23 13:26:23',53636.559998,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202181120094104611/1202181120094104611.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120218/1202181120094104611p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1055132899,16486451,NULL,NULL,NULL,NULL),(11192,11192,0,'CSS120211-033433+180440','CRTS-CSS',53.63924,18.07786,NULL,NULL,'2012-02-11 00:00:00',55968,18.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120211/1202111180194119491.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120211/jpg/1202111180194119491.master.jpg',NULL,NULL,68025480429,NULL,NULL,NULL,'2006-08-28 11:31:15',53975.480042,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202111180194119491/1202111180194119491.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120211/1202111180194119491p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1062898131,16607783,NULL,NULL,NULL,NULL),(11193,11193,1,'CSS120210-073508+394354','CRTS-CSS',113.7851,39.73173,NULL,NULL,'2012-02-10 00:00:00',55967,18.93,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120210/1202101400324103979.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120210/jpg/1202101400324103979.master.jpg',NULL,NULL,63610436175,NULL,NULL,NULL,'2010-03-16 12:28:49',55271.52002,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202101400324103979/1202101400324103979.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120210/1202101400324103979p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,993913065,15529891,NULL,NULL,NULL,NULL),(11194,11194,0,'CSS120210-151342+160607','CRTS-CSS',228.42423,16.10184,NULL,NULL,'2012-02-10 00:00:00',55967,18.25,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120210/1202101150794131422.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120210/jpg/1202101150794131422.master.jpg',NULL,NULL,59565394671,NULL,NULL,NULL,'2011-12-30 11:31:10',55925.47998,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202101150794131422/1202101150794131422.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120210/1202101150794131422p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,930709291,14542332,NULL,NULL,NULL,NULL),(11195,11195,1,'CSS120127-024237-144610','CRTS-CSS',40.6521,-14.76943,NULL,NULL,'2012-01-27 00:00:00',55953,18.92,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120127/1201270150154131595.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120127/jpg/1201270150154131595.master.jpg',NULL,NULL,38100355694,NULL,NULL,NULL,'2011-11-17 13:26:07',55882.559814,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201270150154131595/1201270150154131595.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120127/1201270150154131595p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,595318057,9301844,NULL,NULL,NULL,NULL),(11196,11196,1,'CSS120127-153128-042103','CRTS-CSS',232.86786,-4.35073,NULL,NULL,'2012-01-27 00:00:00',55953,18.95,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120127/1201270040834130467.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120127/jpg/1201270040834130467.master.jpg',NULL,NULL,45417484600,NULL,NULL,NULL,'2011-07-01 13:26:07',55743.559814,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201270040834130467/1201270040834130467.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120127/1201270040834130467p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,709648196,11088253,NULL,NULL,NULL,NULL),(11197,11197,0,'CSS120126-063845+672022','CRTS-CSS',99.68781,67.33957,NULL,NULL,'2012-01-26 00:00:00',55952,17.84,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120126/1201261660164154694.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120126/jpg/1201261660164154694.master.jpg',NULL,NULL,62149234112,NULL,NULL,NULL,'2007-10-20 10:33:41',54393.440063,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201261660164154694/1201261660164154694.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120126/1201261660164154694p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,971081783,15173152,NULL,NULL,NULL,NULL),(11198,11198,0,'CSS120126-014948+314450','CRTS-CSS',27.44875,31.74712,NULL,NULL,'2012-01-26 00:00:00',55952,17.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120126/1201261320094110231.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120126/jpg/1201261320094110231.master.jpg',NULL,NULL,67775012369,NULL,NULL,NULL,'2011-11-27 12:28:49',55892.52002,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201261320094110231/1201261320094110231.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120126/1201261320094110231p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1058984568,16546633,NULL,NULL,NULL,NULL),(11199,11199,1,'CSS120125-122038+321740','CRTS-CSS',185.15925,32.29438,NULL,NULL,'2012-01-25 00:00:00',55951,19.01,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120125/1201251320574121892.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120125/jpg/1201251320574121892.master.jpg',NULL,NULL,58769894698,NULL,NULL,NULL,'2012-01-09 13:26:07',55935.559814,'2013-01-19 01:31:53','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201251320574121892/1201251320574121892.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120125/1201251320574121892p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,918279604,14348118,NULL,NULL,NULL,NULL),(11200,11200,1,'CSS120125-124045+125321','CRTS-CSS',190.18683,12.88917,NULL,NULL,'2012-01-25 00:00:00',55951,19.34,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120125/1201251120674126894.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120125/jpg/1201251120674126894.master.jpg',NULL,NULL,58151413749,NULL,NULL,NULL,'2010-05-18 13:26:07',55334.559814,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201251120674126894/1201251120674126894.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120125/1201251120674126894p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,908615839,14197122,NULL,NULL,NULL,NULL),(11201,11201,1,'CSS120125-140617+003739','CRTS-CSS',211.57266,0.6275,NULL,NULL,'2012-01-25 00:00:00',55951,17.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120125/1201251010764111828.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120125/jpg/1201251010764111828.master.jpg',NULL,NULL,58404424083,NULL,NULL,NULL,'2007-03-13 12:28:49',54172.52002,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201251010764111828/1201251010764111828.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120125/1201251010764111828p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,912569126,14258892,NULL,NULL,NULL,NULL),(11202,11202,1,'CSS120123-114727+024325','CRTS-CSS',176.86219,2.72371,NULL,NULL,'2012-01-23 00:00:00',55949,19.33,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120123/1201231010634150043.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120123/jpg/1201231010634150043.master.jpg',NULL,NULL,60185139761,NULL,NULL,NULL,'2007-05-22 12:28:49',54242.52002,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201231010634150043/1201231010634150043.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120123/1201231010634150043p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,940392808,14693637,NULL,NULL,NULL,NULL),(11203,11203,1,'CSS120123-133657-030204','CRTS-CSS',204.2372,-3.03441,NULL,NULL,'2012-01-23 00:00:00',55949,18.92,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120123/1201230040734148678.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120123/jpg/1201230040734148678.master.jpg',NULL,NULL,43560473224,NULL,NULL,NULL,'2009-06-14 10:33:41',54996.440063,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201230040734148678/1201230040734148678.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120123/1201230040734148678p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,680632394,10634881,NULL,NULL,NULL,NULL),(11204,11204,1,'CSS120119-231949+212438','CRTS-CSS',349.95488,21.41067,NULL,NULL,'2012-01-19 00:00:00',55945,19.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120119/1201191211184129017.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120119/jpg/1201191211184129017.master.jpg',NULL,NULL,52508952695,NULL,NULL,NULL,'2011-12-29 13:26:07',55924.559814,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201191211184129017/1201191211184129017.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120119/1201191211184129017p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,820452385,12819568,NULL,NULL,NULL,NULL),(11205,11205,1,'CSS120118-105924+143218','CRTS-CSS',164.848,14.53827,NULL,NULL,'2012-01-18 00:00:00',55944,19.65,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120118/1201181150574105414.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120118/jpg/1201181150574105414.master.jpg',NULL,NULL,61148779910,NULL,NULL,NULL,'2006-11-16 10:33:36',54055.440002,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201181150574105414/1201181150574105414.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120118/1201181150574105414p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,955449686,14928901,NULL,NULL,NULL,NULL),(11206,11206,1,'CSS120113-134558+323143','CRTS-CSS',206.49131,32.52869,NULL,NULL,'2012-01-13 00:00:00',55939,19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120113/1201131320644119665.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120113/jpg/1201131320644119665.master.jpg',NULL,NULL,59184467052,NULL,NULL,NULL,'2007-01-08 12:28:49',54108.52002,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201131320644119665/1201131320644119665.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120113/1201131320644119665p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,924757297,14449332,NULL,NULL,NULL,NULL),(11207,11207,0,'CSS120113-075900+270957','CRTS-CSS',119.75196,27.16587,NULL,NULL,'2012-01-13 00:00:00',55939,18.71,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120113/1201131260394127203.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120113/jpg/1201131260394127203.master.jpg',NULL,NULL,64304309352,NULL,NULL,NULL,'2011-12-24 13:26:07',55919.559814,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201131260394127203/1201131260394127203.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120113/1201131260394127203p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1004754833,15699294,NULL,NULL,NULL,NULL),(11208,11208,1,'CSS120104-131903+160943','CRTS-CSS',199.76178,16.16201,NULL,NULL,'2012-01-04 00:00:00',55930,19.44,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120104/1201041150694132441.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120104/jpg/1201041150694132441.master.jpg',NULL,NULL,59013639826,NULL,NULL,NULL,'2006-04-25 12:28:49',53850.52002,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201041150694132441/1201041150694132441.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120104/1201041150694132441p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,922088122,14407626,NULL,NULL,NULL,NULL),(11209,11209,0,'CSS120103-230248+084809','CRTS-CSS',345.69821,8.80241,NULL,NULL,'2012-01-03 00:00:00',55929,18.06,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120103/1201031091224104671.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120103/jpg/1201031091224104671.master.jpg',NULL,NULL,52430955331,NULL,NULL,NULL,'2011-10-24 13:26:07',55858.559814,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201031091224104671/1201031091224104671.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120103/1201031091224104671p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,819233677,12800526,NULL,NULL,NULL,NULL),(11211,11211,1,'CSS111230-015105+050335','CRTS-CSS',27.77177,5.05977,NULL,NULL,'2011-12-30 00:00:00',55925,18.43,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111230/1112301040104138020.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111230/jpg/1112301040104138020.master.jpg',NULL,NULL,67028292145,NULL,NULL,NULL,'2010-10-03 13:26:07',55472.559814,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112301040104138020/1112301040104138020.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111230/1112301040104138020p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1047317064,16364329,NULL,NULL,NULL,NULL),(11212,11212,0,'CSS111229-100811+515057','CRTS-CSS',152.04408,51.84915,NULL,NULL,'2011-12-29 00:00:00',55924,14.16,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111229/1112291520354119881.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111229/jpg/1112291520354119881.master.jpg',NULL,NULL,63995128991,NULL,NULL,NULL,'2010-05-11 13:26:07',55327.559814,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112291520354119881/1112291520354119881.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111229/1112291520354119881p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,999923890,15623810,NULL,NULL,NULL,NULL),(11213,11213,0,'CSS111229-102909+460458','CRTS-CSS',157.28651,46.08268,NULL,NULL,'2011-12-29 00:00:00',55924,17.43,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111229/1112291460404116264.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111229/jpg/1112291460404116264.master.jpg',NULL,NULL,64135693196,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112291460404116264/1112291460404116264.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111229/1112291460404116264p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1002120206,15658128,NULL,NULL,NULL,NULL),(11214,11214,1,'CSS111229-104531+432538','CRTS-CSS',161.37863,43.4271,NULL,NULL,'2011-12-29 00:00:00',55924,18.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111229/1112291430434117574.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111229/jpg/1112291430434117574.master.jpg',NULL,NULL,64140343557,NULL,NULL,NULL,'2005-12-08 10:33:36',53712.440002,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112291430434117574/1112291430434117574.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111229/1112291430434117574p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1002192868,15659263,NULL,NULL,NULL,NULL),(11215,11215,0,'CSS111229-121455-042508','CRTS-CSS',183.73093,-4.41877,NULL,NULL,'2011-12-29 00:00:00',55924,19.43,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111229/1112290040664120037.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111229/jpg/1112290040664120037.master.jpg',NULL,NULL,43014148271,NULL,NULL,NULL,'2010-06-04 12:28:49',55351.52002,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112290040664120037/1112290040664120037.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111229/1112290040664120037p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,672096066,10501501,NULL,NULL,NULL,NULL),(11216,11216,1,'CSS111228-095421-011339','CRTS-CSS',148.58581,-1.22763,NULL,NULL,'2011-12-28 00:00:00',55923,18.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111228/1112280010534124058.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111228/jpg/1112280010534124058.master.jpg',NULL,NULL,41224783887,NULL,NULL,NULL,'2011-05-26 13:26:07',55707.559814,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112280010534124058/1112280010534124058.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111228/1112280010534124058p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,644137248,10064644,NULL,NULL,NULL,NULL),(11217,11217,0,'CSS111227-104742+021815','CRTS-CSS',161.92377,2.30427,NULL,NULL,'2011-12-27 00:00:00',55922,18.95,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111227/1112271010584136372.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111227/jpg/1112271010584136372.master.jpg',NULL,NULL,60277149986,NULL,NULL,NULL,'2011-06-06 13:26:07',55718.559814,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112271010584136372/1112271010584136372.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111227/1112271010584136372p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,941830468,14716101,NULL,NULL,NULL,NULL),(11218,11218,1,'CSS111225-140122+161705','CRTS-CSS',210.33996,16.28465,NULL,NULL,'2011-12-25 00:00:00',55920,18.03,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111225/1112251150734136050.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111225/jpg/1112251150734136050.master.jpg',NULL,NULL,58374833616,NULL,NULL,NULL,'2005-01-01 11:31:12',53371.480003,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112251150734136050/1112251150734136050.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111225/1112251150734136050p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,912106775,14251668,NULL,NULL,NULL,NULL),(11219,11219,1,'CSS111224-125356+014409','CRTS-CSS',193.4823,1.73572,NULL,NULL,'2011-12-24 00:00:00',55919,19.24,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:54','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111224/1112241010694129423.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111224/jpg/1112241010694129423.master.jpg',NULL,NULL,58098878942,NULL,NULL,NULL,'2009-12-15 10:33:41',55180.440063,'2013-01-19 01:31:54','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112241010694129423/1112241010694129423.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111224/1112241010694129423p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,907794983,14184296,NULL,NULL,NULL,NULL),(11220,11220,1,'CSS111130-085857+044130','CRTS-CSS',134.73828,4.69169,NULL,NULL,'2011-11-30 00:00:00',55895,18.8,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111130/1111301040484136988.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111130/jpg/1111301040484136988.master.jpg',NULL,NULL,63632168254,NULL,NULL,NULL,'2011-05-13 13:26:07',55694.559814,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111301040484136988/1111301040484136988.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111130/1111301040484136988p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,994252628,15535197,NULL,NULL,NULL,NULL),(11221,11221,0,'CSS111128-113705+152814','CRTS-CSS',174.27,15.4706,NULL,NULL,'2011-11-28 00:00:00',55893,17.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111128/1111281150614125119.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111128/jpg/1111281150614125119.master.jpg',NULL,NULL,60257192226,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111281150614125119/1111281150614125119.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111128/1111281150614125119p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,941518628,14711228,NULL,NULL,NULL,NULL),(11222,11222,1,'CSS111128-045837-054847','CRTS-CSS',74.65226,-5.81313,NULL,NULL,'2011-11-28 00:00:00',55893,18.55,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111128/1111280070274158322.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111128/jpg/1111280070274158322.master.jpg',NULL,NULL,36602072979,NULL,NULL,NULL,'2011-01-13 10:33:30',55574.439941,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111280070274158322/1111280070274158322.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111128/1111280070274158322p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,571907390,8936052,NULL,NULL,NULL,NULL),(11223,11223,1,'CSS111127-001754+134739','CRTS-CSS',4.47312,13.79419,NULL,NULL,'2011-11-27 00:00:00',55892,18.54,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111127/1111271120024141105.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111127/jpg/1111271120024141105.master.jpg',NULL,NULL,66759790492,NULL,NULL,NULL,'2011-09-26 11:31:10',55830.47998,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111271120024141105/1111271120024141105.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111127/1111271120024141105p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1043121726,16298776,NULL,NULL,NULL,NULL),(11224,11224,1,'CSS111123-090634+205014','CRTS-CSS',136.64282,20.83725,NULL,NULL,'2011-11-23 00:00:00',55888,19.46,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111123/1111231210464117038.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111123/jpg/1111231210464117038.master.jpg',NULL,NULL,63830383053,NULL,NULL,NULL,'2011-10-23 13:26:07',55857.559814,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111231210464117038/1111231210464117038.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111123/1111231210464117038p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,997349735,15583589,NULL,NULL,NULL,NULL),(11225,11225,0,'CSS111119-002254+135222','CRTS-CSS',5.72614,13.87289,NULL,NULL,'2011-11-19 00:00:00',55884,18.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111119/1111191120034144818.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111119/jpg/1111191120034144818.master.jpg',NULL,NULL,66757763152,NULL,NULL,NULL,'2005-10-02 10:33:36',53645.440002,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111191120034144818/1111191120034144818.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111119/1111191120034144818p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1043090049,16298282,NULL,NULL,NULL,NULL),(11226,11226,1,'CSS111116-010537-023351','CRTS-CSS',16.40219,-2.56422,NULL,NULL,'2011-11-16 00:00:00',55881,19.82,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111116/1111160010064104203.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111116/jpg/1111160010064104203.master.jpg',NULL,NULL,34555668801,NULL,NULL,NULL,'2008-11-08 10:33:41',54778.440063,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111160010064104203/1111160010064104203.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111116/1111160010064104203p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,539932325,8436442,NULL,NULL,NULL,NULL),(11227,11227,1,'CSS111030-095830+172735','CRTS-CSS',149.62393,17.45976,NULL,NULL,'2011-10-30 00:00:00',55864,19.43,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111030/1110301180524111833.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111030/jpg/1110301180524111833.master.jpg',NULL,NULL,60862850835,NULL,NULL,NULL,'2011-10-17 10:33:30',55851.439941,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110301180524111833/1110301180524111833.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111030/1110301180524111833p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,950982044,14859094,NULL,NULL,NULL,NULL),(11228,11228,1,'CSS111030-023613+085848','CRTS-CSS',39.0559,8.97996,NULL,NULL,'2011-10-30 00:00:00',55864,19.26,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111030/1110301090144110100.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111030/jpg/1110301090144110100.master.jpg',NULL,NULL,67954271798,NULL,NULL,NULL,'2011-10-17 13:26:07',55851.559814,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110301090144110100/1110301090144110100.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111030/1110301090144110100p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1061785496,16590398,NULL,NULL,NULL,NULL),(11229,11229,1,'CSS111028-104207+380946','CRTS-CSS',160.52866,38.16288,NULL,NULL,'2011-10-28 00:00:00',55862,18.58,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111028/1110281380464122093.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111028/jpg/1110281380464122093.master.jpg',NULL,NULL,64120110268,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110281380464122093/1110281380464122093.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111028/1110281380464122093p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1001876722,15654323,NULL,NULL,NULL,NULL),(11230,11230,1,'CSS111024-100409+354709','CRTS-CSS',151.03953,35.78588,NULL,NULL,'2011-10-24 00:00:00',55858,18.44,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111024/1110241350454133658.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111024/jpg/1110241350454133658.master.jpg',NULL,NULL,64068731306,NULL,NULL,NULL,'2011-04-29 13:26:07',55680.559814,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110241350454133658/1110241350454133658.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111024/1110241350454133658p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1001073926,15641780,NULL,NULL,NULL,NULL),(11231,11231,1,'CSS111022-100535+285908','CRTS-CSS',151.3963,28.98568,NULL,NULL,'2011-10-22 00:00:00',55856,18.69,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111022/1110221290484112027.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111022/jpg/1110221290484112027.master.jpg',NULL,NULL,64163286320,NULL,NULL,NULL,'2005-01-09 10:33:34',53379.439987,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110221290484112027/1110221290484112027.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111022/1110221290484112027p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1002551348,15664864,NULL,NULL,NULL,NULL),(11232,11232,0,'CSS111020-223647+202131','CRTS-CSS',339.19466,20.35867,NULL,NULL,'2011-10-20 00:00:00',55854,18.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111020/1110201211154112050.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111020/jpg/1110201211154112050.master.jpg',NULL,NULL,52410719516,NULL,NULL,NULL,'2007-06-23 13:26:29',54274.560059,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110201211154112050/1110201211154112050.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111020/1110201211154112050p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,818917492,12795585,NULL,NULL,NULL,NULL),(11233,11233,1,'CSS111018-160545+450130','CRTS-CSS',241.43913,45.02496,NULL,NULL,'2011-10-18 00:00:00',55852,17.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111018/1110181430644248816.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111018/jpg/1110181430644248816.master.jpg',NULL,NULL,59802842916,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110181430644248816/1110181430644248816.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111018/1110181430644248816p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,934419420,14600303,NULL,NULL,NULL,NULL),(11234,11234,0,'CSS111017-221651-031555','CRTS-CSS',334.21308,-3.26527,NULL,NULL,'2011-10-17 00:00:00',55851,17.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111017/1110170041194139877.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111017/jpg/1110170041194139877.master.jpg',NULL,NULL,49850378718,NULL,NULL,NULL,'2011-09-27 11:31:10',55831.47998,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110170041194139877/1110170041194139877.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111017/1110170041194139877p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,778912167,12170502,NULL,NULL,NULL,NULL),(11235,11235,0,'CSS111016-012615+174808','CRTS-CSS',21.56367,17.80215,NULL,NULL,'2011-10-16 00:00:00',55850,18.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2020-01-29 08:48:02','http://nesssi.cacr.caltech.edu/catalina/20111016/1110161180084108543.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111016/jpg/1110161180084108543.master.jpg',NULL,NULL,67422320777,NULL,NULL,NULL,'2011-01-26 13:26:07',55587.559814,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110161180084108543/1110161180084108543.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111016/1110161180084108543p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1053473762,16460527,NULL,NULL,NULL,NULL),(11236,11236,1,'CSS110930-071342+402826','CRTS-CSS',108.42621,40.474,NULL,NULL,'2011-09-30 00:00:00',55834,18.45,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110930/1109301400304127819.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110930/jpg/1109301400304127819.master.jpg',NULL,NULL,63597208139,NULL,NULL,NULL,'2007-03-17 10:33:36',54176.440002,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1109301400304127819/1109301400304127819.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110930/1109301400304127819p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,993706377,15526662,NULL,NULL,NULL,NULL),(11237,11237,1,'CSS110930-213006+033055','CRTS-CSS',322.52384,3.51516,NULL,NULL,'2011-09-30 00:00:00',55834,18.65,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110930/1109301041154116618.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110930/jpg/1109301041154116618.master.jpg',NULL,NULL,52140536820,NULL,NULL,NULL,'2011-09-20 13:26:07',55824.559814,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1109301041154116618/1109301041154116618.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110930/1109301041154116618p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,814695887,12729623,NULL,NULL,NULL,NULL),(11238,11238,0,'CSS110926-000156+065236','CRTS-CSS',0.48205,6.87665,NULL,NULL,'2011-09-26 00:00:00',55830,19.35,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:55','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110926/1109261070014122864.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110926/jpg/1109261070014122864.master.jpg',NULL,NULL,66613374410,NULL,NULL,NULL,'2011-07-02 13:26:07',55744.559814,'2013-01-19 01:31:55','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1109261070014122864/1109261070014122864.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110926/1109261070014122864p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,1040833975,16263030,NULL,NULL,NULL,NULL),(11239,11239,0,'CSS110923-042110+132804','CRTS-CSS',65.29162,13.4679,NULL,NULL,'2011-09-23 00:00:00',55827,17.45,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110923/1109231120234136074.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110923/jpg/1109231120234136074.master.jpg',NULL,NULL,65129417313,NULL,NULL,NULL,'2011-03-29 13:26:07',55649.559814,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1109231120234136074/1109231120234136074.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110923/1109231120234136074p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1017647145,15900736,NULL,NULL,NULL,NULL),(11240,11240,0,'CSS110920-004621-090928','CRTS-CSS',11.58785,-9.15769,NULL,NULL,'2011-09-20 00:00:00',55824,17.58,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110920/1109200090054128813.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110920/jpg/1109200090054128813.master.jpg',NULL,NULL,34562248769,NULL,NULL,NULL,'2006-09-19 11:31:15',53997.480042,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1109200090054128813/1109200090054128813.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110920/1109200090054128813p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,540035137,8438049,NULL,NULL,NULL,NULL),(11241,11241,1,'CSS110919-224602-160858','CRTS-CSS',341.5099,-16.14945,NULL,NULL,'2011-09-19 00:00:00',55823,19.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110919/1109190151184111644.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110919/jpg/1109190151184111644.master.jpg',NULL,NULL,50451705506,NULL,NULL,NULL,'2010-11-28 13:26:07',55528.559814,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1109190151184111644/1109190151184111644.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110919/1109190151184111644p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,788307898,12317310,NULL,NULL,NULL,NULL),(11242,11242,1,'CSS110918-164935+263347','CRTS-CSS',252.39671,26.56292,NULL,NULL,'2011-09-18 00:00:00',55822,18.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110918/1109181260824120853.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110918/jpg/1109181260824120853.master.jpg',NULL,NULL,56230142158,NULL,NULL,NULL,'2011-06-28 13:26:07',55740.559814,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1109181260824120853/1109181260824120853.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110918/1109181260824120853p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,878595971,13728062,NULL,NULL,NULL,NULL),(11243,11243,1,'CSS110703-152207+183731','CRTS-CSS',230.52742,18.62535,NULL,NULL,'2011-07-03 00:00:00',55745,20.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110703/1107031180794128821.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110703/jpg/1107031180794128821.master.jpg',NULL,NULL,59433429552,NULL,NULL,NULL,'2011-06-04 13:26:07',55716.559814,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1107031180794128821/1107031180794128821.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110703/1107031180794128821p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,928647336,14510114,NULL,NULL,NULL,NULL),(11244,11244,1,'CSS110702-014348+181252','CRTS-CSS',25.94926,18.21434,NULL,NULL,'2011-07-02 00:00:00',55744,18.6,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110702/1107021180094118167.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110702/jpg/1107021180094118167.master.jpg',NULL,NULL,66911848387,NULL,NULL,NULL,'2005-09-30 10:33:36',53643.440002,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1107021180094118167/1107021180094118167.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110702/1107021180094118167p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1045497631,16335900,NULL,NULL,NULL,NULL),(11245,11245,0,'CSS110701-122736+040950','CRTS-CSS',186.90158,4.16375,NULL,NULL,'2011-07-01 00:00:00',55743,19.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110701/1107011040674116917.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110701/jpg/1107011040674116917.master.jpg',NULL,NULL,58006496464,NULL,NULL,NULL,'2011-06-08 13:26:07',55720.559814,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1107011040674116917/1107011040674116917.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110701/1107011040674116917p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,906351507,14161742,NULL,NULL,NULL,NULL),(11246,11246,0,'CSS110624-124242+003354','CRTS-CSS',190.67681,0.56501,NULL,NULL,'2011-06-24 00:00:00',55736,19.08,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110624/1106241010684107404.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110624/jpg/1106241010684107404.master.jpg',NULL,NULL,57998913230,NULL,NULL,NULL,'2005-12-06 10:33:36',53710.440002,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106241010684107404/1106241010684107404.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110624/1106241010684107404p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,906233019,14159890,NULL,NULL,NULL,NULL),(11247,11247,0,'CSS110623-131919-045106','CRTS-CSS',199.82968,-4.85165,NULL,NULL,'2011-06-23 00:00:00',55735,18.29,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110623/1106230040724111069.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110623/jpg/1106230040724111069.master.jpg',NULL,NULL,43827827831,NULL,NULL,NULL,'2006-01-09 11:31:10',53744.47998,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106230040724111069/1106230040724111069.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110623/1106230040724111069p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,684809809,10700153,NULL,NULL,NULL,NULL),(11248,11248,1,'CSS110612-121430+175447','CRTS-CSS',183.62359,17.91319,NULL,NULL,'2011-06-12 00:00:00',55724,18.78,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110612/1106121180634112775.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110612/jpg/1106121180634112775.master.jpg',NULL,NULL,58127933240,NULL,NULL,NULL,'2005-01-09 10:33:34',53379.439987,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106121180634112775/1106121180634112775.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110612/1106121180634112775p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,908248956,14191389,NULL,NULL,NULL,NULL),(11249,11249,1,'CSS110612-115452+124123','CRTS-CSS',178.71573,12.68982,NULL,NULL,'2011-06-12 00:00:00',55724,18.54,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110612/1106121120634119163.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110612/jpg/1106121120634119163.master.jpg',NULL,NULL,60233388142,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106121120634119163/1106121120634119163.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110612/1106121120634119163p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,941146689,14705417,NULL,NULL,NULL,NULL),(11250,11250,1,'CSS110611-103736+351052','CRTS-CSS',159.39931,35.18118,NULL,NULL,'2011-06-11 00:00:00',55723,18.41,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110611/1106111350474117100.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110611/jpg/1106111350474117100.master.jpg',NULL,NULL,64053605955,NULL,NULL,NULL,'2005-01-15 13:26:23',53385.559998,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106111350474117100/1106111350474117100.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110611/1106111350474117100p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1000837593,15638087,NULL,NULL,NULL,NULL),(11252,11252,1,'CSS110525-150213+231553','CRTS-CSS',225.55527,23.26475,NULL,NULL,'2011-05-25 00:00:00',55706,19.67,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110525/1105251230744110738.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110525/jpg/1105251230744110738.master.jpg',NULL,NULL,59529171362,NULL,NULL,NULL,'2010-06-10 12:28:49',55357.52002,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105251230744110738/1105251230744110738.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110525/1105251230744110738p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,930143302,14533489,NULL,NULL,NULL,NULL),(11253,11253,0,'CSS110525-154951+144930','CRTS-CSS',237.46106,14.82502,NULL,NULL,'2011-05-25 00:00:00',55706,18.97,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110525/1105251150824111853.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110525/jpg/1105251150824111853.master.jpg',NULL,NULL,56538931350,NULL,NULL,NULL,'2006-09-19 10:33:36',53997.440002,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105251150824111853/1105251150824111853.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110525/1105251150824111853p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,883420802,13803450,NULL,NULL,NULL,NULL),(11254,11254,0,'CSS110514-145857+655408','CRTS-CSS',224.73547,65.90232,NULL,NULL,'2011-05-14 00:00:00',55695,16.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110514/1105141660354112704.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110514/jpg/1105141660354112704.master.jpg',NULL,NULL,57968523641,NULL,NULL,NULL,'2007-04-20 13:26:23',54210.559998,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105141660354112704/1105141660354112704.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110514/1105141660354112704p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,905758181,14152471,NULL,NULL,NULL,NULL),(11255,11255,1,'CSS110512-141256+290215','CRTS-CSS',213.2326,29.03761,NULL,NULL,'2011-05-12 00:00:00',55693,18.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110512/1105121290674113405.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110512/jpg/1105121290674113405.master.jpg',NULL,NULL,60058401391,NULL,NULL,NULL,'2005-04-01 10:33:34',53461.439987,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105121290674113405/1105121290674113405.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110512/1105121290674113405p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,938412521,14662695,NULL,NULL,NULL,NULL),(11256,11256,1,'CSS110507-131750-025717','CRTS-CSS',199.45846,-2.95464,NULL,NULL,'2011-05-07 00:00:00',55688,19.64,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110507/1105070040714143962.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110507/jpg/1105070040714143962.master.jpg',NULL,NULL,43093559940,NULL,NULL,NULL,'2006-05-19 11:31:15',53874.480042,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105070040714143962/1105070040714143962.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110507/1105070040714143962p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,673336874,10520888,NULL,NULL,NULL,NULL),(11257,11257,0,'CSS110504-101800-023241','CRTS-CSS',154.50169,-2.54484,NULL,NULL,'2011-05-04 00:00:00',55685,17.8,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110504/1105040010554104018.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110504/jpg/1105040010554104018.master.jpg',NULL,NULL,41217595911,NULL,NULL,NULL,'2007-11-11 12:28:49',54415.52002,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105040010554104018/1105040010554104018.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110504/1105040010554104018p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,644024936,10062889,NULL,NULL,NULL,NULL),(11258,11258,1,'CSS110503-090330-003218','CRTS-CSS',135.87541,-0.53847,NULL,NULL,'2011-05-03 00:00:00',55684,19.37,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110503/1105030010494139841.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110503/jpg/1105030010494139841.master.jpg',NULL,NULL,41071660992,NULL,NULL,NULL,'2008-05-03 10:33:41',54589.440063,'2013-01-19 01:31:56','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105030010494139841/1105030010494139841.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110503/1105030010494139841p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,641744703,10027260,NULL,NULL,NULL,NULL),(11259,11259,1,'CSS110502-064306+550437','CRTS-CSS',100.77381,55.07689,NULL,NULL,'2011-05-02 00:00:00',55683,18.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110502/1105021550224130765.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110502/jpg/1105021550224130765.master.jpg',NULL,NULL,61723536831,NULL,NULL,NULL,'2011-03-16 13:26:07',55636.559814,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105021550224130765/1105021550224130765.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110502/1105021550224130765p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,964430262,15069222,NULL,NULL,NULL,NULL),(11260,11260,0,'CSS110502-121422+335510','CRTS-CSS',183.59233,33.91931,NULL,NULL,'2011-05-02 00:00:00',55683,19.02,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110502/1105021350554101034.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110502/jpg/1105021350554101034.master.jpg',NULL,NULL,58756056959,NULL,NULL,NULL,'2005-12-08 13:26:23',53712.559998,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105021350554101034/1105021350554101034.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110502/1105021350554101034p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,918063389,14344740,NULL,NULL,NULL,NULL),(11261,11261,0,'CSS110501-144740+514105','CRTS-CSS',221.91479,51.68464,NULL,NULL,'2011-05-01 00:00:00',55682,18.36,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110501/1105011520504112888.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110501/jpg/1105011520504112888.master.jpg',NULL,NULL,59192227103,NULL,NULL,NULL,'2010-04-12 12:28:49',55298.52002,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105011520504112888/1105011520504112888.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110501/1105011520504112888p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,924878548,14451227,NULL,NULL,NULL,NULL),(11262,11262,1,'CSS110429-114025+223116','CRTS-CSS',175.1061,22.52104,NULL,NULL,'2011-04-29 00:00:00',55680,19.5,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110429/1104291210594142890.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110429/jpg/1104291210594142890.master.jpg',NULL,NULL,61076804560,NULL,NULL,NULL,'2011-04-08 13:26:07',55659.559814,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104291210594142890/1104291210594142890.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110429/1104291210594142890p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,954325071,14911329,NULL,NULL,NULL,NULL),(11263,11263,0,'CSS110427-130254+495229','CRTS-CSS',195.7263,49.87476,NULL,NULL,'2011-04-27 00:00:00',55678,16.03,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110427/1104271490474133022.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110427/jpg/1104271490474133022.master.jpg',NULL,NULL,59090802709,NULL,NULL,NULL,'2011-03-15 13:26:07',55635.559814,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104271490474133022/1104271490474133022.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110427/1104271490474133022p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,923293792,14426465,NULL,NULL,NULL,NULL),(11264,11264,0,'CSS110427-150634-101937','CRTS-CSS',226.64335,-10.32681,NULL,NULL,'2011-04-27 00:00:00',55678,19.62,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110427/1104270090804120222.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110427/jpg/1104270090804120222.master.jpg',NULL,NULL,46483819609,NULL,NULL,NULL,'2011-03-02 13:26:07',55622.559814,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104270090804120222/1104270090804120222.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110427/1104270090804120222p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,726309681,11348588,NULL,NULL,NULL,NULL),(11265,11265,0,'CSS110424-135532-023001','CRTS-CSS',208.8814,-2.50014,NULL,NULL,'2011-04-24 00:00:00',55675,18.9,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110424/1104240010754104018.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110424/jpg/1104240010754104018.master.jpg',NULL,NULL,43592684170,NULL,NULL,NULL,'2007-03-12 13:26:23',54171.559998,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104240010754104018/1104240010754104018.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110424/1104240010754104018p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,681135690,10642745,NULL,NULL,NULL,NULL),(11266,11266,0,'CSS110414-171419+435955','CRTS-CSS',258.57992,43.99868,NULL,NULL,'2011-04-14 00:00:00',55665,18.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110414/1104141430694136992.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110414/jpg/1104141430694136992.master.jpg',NULL,NULL,59659162994,NULL,NULL,NULL,'2009-04-22 12:28:49',54943.52002,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104141430694136992/1104141430694136992.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110414/1104141430694136992p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,932174421,14565225,NULL,NULL,NULL,NULL),(11267,11267,0,'CSS110413-164225+164928','CRTS-CSS',250.60467,16.82447,NULL,NULL,'2011-04-13 00:00:00',55664,17.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110413/1104131150874170907.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110413/jpg/1104131150874170907.master.jpg',NULL,NULL,56883966948,NULL,NULL,NULL,'2005-04-05 10:33:34',53465.439987,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104131150874170907/1104131150874170907.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110413/1104131150874170907p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,888811983,13887687,NULL,NULL,NULL,NULL),(11268,11268,1,'CSS110408-112155+242419','CRTS-CSS',170.47779,24.40525,NULL,NULL,'2011-04-08 00:00:00',55659,18.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110408/1104081230564126079.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110408/jpg/1104081230564126079.master.jpg',NULL,NULL,60581422276,NULL,NULL,NULL,'2005-01-09 10:33:34',53379.439987,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104081230564126079/1104081230564126079.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110408/1104081230564126079p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,946584723,14790386,NULL,NULL,NULL,NULL),(11269,11269,1,'CSS110406-150303+313155','CRTS-CSS',225.76068,31.5319,NULL,NULL,'2011-04-06 00:00:00',55657,19.1,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110406/1104061320694106837.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110406/jpg/1104061320694106837.master.jpg',NULL,NULL,60092437267,NULL,NULL,NULL,'2011-03-16 13:26:07',55636.559814,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104061320694106837/1104061320694106837.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110406/1104061320694106837p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,938944332,14671005,NULL,NULL,NULL,NULL),(11270,11270,0,'CSS110406-135058+261642','CRTS-CSS',207.74081,26.27839,NULL,NULL,'2011-04-06 00:00:00',55657,18.71,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110406/1104061260674111875.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110406/jpg/1104061260674111875.master.jpg',NULL,NULL,59997708274,NULL,NULL,NULL,'2006-02-27 12:28:49',53793.52002,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104061260674111875/1104061260674111875.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110406/1104061260674111875p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,937464191,14647877,NULL,NULL,NULL,NULL),(11271,11271,1,'CSS110404-090902+163354','CRTS-CSS',137.25911,16.5649,NULL,NULL,'2011-04-04 00:00:00',55655,19.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110404/1104041150484138263.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110404/jpg/1104041150484138263.master.jpg',NULL,NULL,63878148351,NULL,NULL,NULL,'2009-11-26 11:31:10',55161.47998,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104041150484138263/1104041150484138263.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110404/1104041150484138263p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,998096067,15595251,NULL,NULL,NULL,NULL),(11272,11272,1,'CSS110330-123801+463910','CRTS-CSS',189.50398,46.65289,NULL,NULL,'2011-03-30 00:00:00',55650,18.62,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110330/1103301460484119712.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110330/jpg/1103301460484119712.master.jpg',NULL,NULL,59114027024,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103301460484119712/1103301460484119712.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110330/1103301460484119712p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,923656672,14432135,NULL,NULL,NULL,NULL),(11273,11273,0,'CSS110328-125255+074652','CRTS-CSS',193.23008,7.78103,NULL,NULL,'2011-03-28 00:00:00',55648,19.16,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110328/1103281070694141533.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110328/jpg/1103281070694141533.master.jpg',NULL,NULL,58082654854,NULL,NULL,NULL,'2010-04-05 10:33:41',55291.440063,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103281070694141533/1103281070694141533.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110328/1103281070694141533p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,907541482,14180335,NULL,NULL,NULL,NULL),(11274,11274,0,'CSS110327-143650+230150','CRTS-CSS',219.20766,23.03067,NULL,NULL,'2011-03-27 00:00:00',55647,18.56,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110327/1103271230724108822.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110327/jpg/1103271230724108822.master.jpg',NULL,NULL,59505362868,NULL,NULL,NULL,'2009-06-17 12:28:49',54999.52002,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103271230724108822/1103271230724108822.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110327/1103271230724108822p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,929771294,14527676,NULL,NULL,NULL,NULL),(11275,11275,1,'CSS110327-094401+251523','CRTS-CSS',146.00589,25.2565,NULL,NULL,'2011-03-27 00:00:00',55647,18.69,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110327/1103271230484143622.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110327/jpg/1103271230484143622.master.jpg',NULL,NULL,64164930257,NULL,NULL,NULL,'2005-01-06 10:33:36',53376.440002,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103271230484143622/1103271230484143622.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110327/1103271230484143622p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1002577035,15665266,NULL,NULL,NULL,NULL),(11276,11276,0,'CSS110325-110751+185939','CRTS-CSS',166.96067,18.9942,NULL,NULL,'2011-03-25 00:00:00',55645,18.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110325/1103251180584134410.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110325/jpg/1103251180584134410.master.jpg',NULL,NULL,61165231711,NULL,NULL,NULL,'2011-03-14 13:26:07',55634.559814,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103251180584134410/1103251180584134410.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110325/1103251180584134410p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,955706745,14932917,NULL,NULL,NULL,NULL),(11277,11277,0,'CSS110310-073609+472716','CRTS-CSS',114.03756,47.45431,NULL,NULL,'2011-03-10 00:00:00',55630,18.47,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110310/1103101460294148007.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110310/jpg/1103101460294148007.master.jpg',NULL,NULL,63578689062,NULL,NULL,NULL,'2007-03-13 11:31:15',54172.480042,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103101460294148007/1103101460294148007.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110310/1103101460294148007p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,993417016,15522140,NULL,NULL,NULL,NULL),(11278,11278,0,'CSS110305-093342+304016','CRTS-CSS',143.42313,30.67105,NULL,NULL,'2011-03-05 00:00:00',55625,19.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110305/1103051290464145262.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110305/jpg/1103051290464145262.master.jpg',NULL,NULL,64209605396,NULL,NULL,NULL,'2007-01-28 13:26:23',54128.559998,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103051290464145262/1103051290464145262.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110305/1103051290464145262p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1003275084,15676173,NULL,NULL,NULL,NULL),(11279,11279,1,'CSS110301-043641+212136','CRTS-CSS',69.17285,21.36002,NULL,NULL,'2011-03-01 00:00:00',55621,18.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110301/1103011210244144773.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110301/jpg/1103011210244144773.master.jpg',NULL,NULL,65287003114,NULL,NULL,NULL,'2009-03-24 13:26:29',54914.560059,'2013-01-19 01:31:57','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103011210244144773/1103011210244144773.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110301/1103011210244144773p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1020109423,15939209,NULL,NULL,NULL,NULL),(11280,11280,1,'CSS110226-121737+255207','CRTS-CSS',184.40291,25.86859,NULL,NULL,'2011-02-26 00:00:00',55618,20.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110226/1102261260604109602.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110226/jpg/1102261260604109602.master.jpg',NULL,NULL,58647453826,NULL,NULL,NULL,'2006-05-30 10:33:36',53885.440002,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102261260604109602/1102261260604109602.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110226/1102261260604109602p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,916366466,14318226,NULL,NULL,NULL,NULL),(11281,11281,0,'CSS110225-031227+191506','CRTS-CSS',48.11062,19.25177,NULL,NULL,'2011-02-25 00:00:00',55617,17.62,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110225/1102251180174134438.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110225/jpg/1102251180174134438.master.jpg',NULL,NULL,68124577281,NULL,NULL,NULL,'2011-02-04 13:26:07',55596.559814,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102251180174134438/1102251180174134438.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110225/1102251180174134438p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1064446520,16631976,NULL,NULL,NULL,NULL),(11282,11282,1,'CSS110224-084748+295733','CRTS-CSS',131.94872,29.95906,NULL,NULL,'2011-02-24 00:00:00',55616,18.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110224/1102241290424127830.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110224/jpg/1102241290424127830.master.jpg',NULL,NULL,64384480657,NULL,NULL,NULL,'2011-01-26 13:26:07',55587.559814,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102241290424127830/1102241290424127830.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110224/1102241290424127830p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1006007510,15718867,NULL,NULL,NULL,NULL),(11283,11283,1,'CSS110223-133040+343817','CRTS-CSS',202.66475,34.63811,NULL,NULL,'2011-02-23 00:00:00',55615,17.84,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110223/1102231350604110103.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110223/jpg/1102231350604110103.master.jpg',NULL,NULL,59167079742,NULL,NULL,NULL,'2010-06-22 13:26:07',55369.559814,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102231350604110103/1102231350604110103.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110223/1102231350604110103p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,924485620,14445087,NULL,NULL,NULL,NULL),(11284,11284,1,'CSS110210-113056+222137','CRTS-CSS',172.73193,22.36022,NULL,NULL,'2011-02-10 00:00:00',55602,20.08,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110210/1102101210594143788.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110210/jpg/1102101210594143788.master.jpg',NULL,NULL,61128729988,NULL,NULL,NULL,'2011-01-10 13:26:07',55571.559814,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102101210594143788/1102101210594143788.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110210/1102101210594143788p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,955136406,14924006,NULL,NULL,NULL,NULL),(11285,11285,1,'CSS110208-104314-095352','CRTS-CSS',160.80638,-9.8979,NULL,NULL,'2011-02-08 00:00:00',55600,19.69,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110208/1102080090574128001.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110208/jpg/1102080090574128001.master.jpg',NULL,NULL,41795648203,NULL,NULL,NULL,'2010-04-14 13:26:07',55300.559814,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102080090574128001/1102080090574128001.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110208/1102080090574128001p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,653057003,10204015,NULL,NULL,NULL,NULL),(11286,11286,1,'CSS110206-123132+230544','CRTS-CSS',187.88374,23.09558,NULL,NULL,'2011-02-06 00:00:00',55598,18.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110206/1102061230624108216.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110206/jpg/1102061230624108216.master.jpg',NULL,NULL,58892950100,NULL,NULL,NULL,'2010-03-05 11:31:10',55260.47998,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102061230624108216/1102061230624108216.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110206/1102061230624108216p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,920202345,14378161,NULL,NULL,NULL,NULL),(11287,11287,1,'CSS110204-031013+065516','CRTS-CSS',47.55284,6.92125,NULL,NULL,'2011-02-04 00:00:00',55596,18.37,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110204/1102041070174118422.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110204/jpg/1102041070174118422.master.jpg',NULL,NULL,67976833020,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102041070174118422/1102041070174118422.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110204/1102041070174118422p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,1062138015,16595906,NULL,NULL,NULL,NULL),(11288,11288,1,'CSS110130-011755+211320','CRTS-CSS',19.47764,21.22232,NULL,NULL,'2011-01-30 00:00:00',55591,19.55,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110130/1101301210074122822.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110130/jpg/1101301210074122822.master.jpg',NULL,NULL,67437080246,NULL,NULL,NULL,'2011-01-03 13:26:07',55564.559814,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101301210074122822/1101301210074122822.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110130/1101301210074122822p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1053704378,16464130,NULL,NULL,NULL,NULL),(11289,11289,1,'CSS110129-034225-043530','CRTS-CSS',55.6025,-4.59155,NULL,NULL,'2011-01-29 00:00:00',55590,18.81,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110129/1101290040204119818.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110129/jpg/1101290040204119818.master.jpg',NULL,NULL,37001403227,NULL,NULL,NULL,'2005-10-08 11:31:10',53651.47998,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101290040204119818/1101290040204119818.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110129/1101290040204119818p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,578146925,9033545,NULL,NULL,NULL,NULL),(11290,11290,1,'CSS110128-070709+335300','CRTS-CSS',106.78842,33.88345,NULL,NULL,'2011-01-28 00:00:00',55589,17.92,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110128/1101281350324101650.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110128/jpg/1101281350324101650.master.jpg',NULL,NULL,63453016665,NULL,NULL,NULL,'2009-01-02 12:28:49',54833.52002,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101281350324101650/1101281350324101650.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110128/1101281350324101650p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,991453385,15491459,NULL,NULL,NULL,NULL),(11291,11291,0,'CSS110128-092739+284727','CRTS-CSS',141.91149,28.79088,NULL,NULL,'2011-01-28 00:00:00',55589,16,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110128/1101281290454112646.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110128/jpg/1101281290454112646.master.jpg',NULL,NULL,64202239823,NULL,NULL,NULL,'2009-04-19 11:31:10',54940.47998,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101281290454112646/1101281290454112646.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110128/1101281290454112646p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1003159997,15674374,NULL,NULL,NULL,NULL),(11292,11292,1,'CSS110128-111643+273419','CRTS-CSS',169.18067,27.57208,NULL,NULL,'2011-01-28 00:00:00',55589,18.06,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110128/1101281260554137473.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110128/jpg/1101281260554137473.master.jpg',NULL,NULL,60615448803,NULL,NULL,NULL,'2005-03-01 11:31:11',53430.479996,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101281260554137473/1101281260554137473.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110128/1101281260554137473p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,947116387,14798693,NULL,NULL,NULL,NULL),(11293,11293,1,'CSS110125-043139+112541','CRTS-CSS',67.913,11.42805,NULL,NULL,'2011-01-25 00:00:00',55586,18.96,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110125/1101251120244103162.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110125/jpg/1101251120244103162.master.jpg',NULL,NULL,65333450314,NULL,NULL,NULL,'2009-08-30 12:28:49',55073.52002,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101251120244103162/1101251120244103162.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110125/1101251120244103162p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1020835161,15950549,NULL,NULL,NULL,NULL),(11294,11294,0,'CSS110125-050738+071525','CRTS-CSS',76.90783,7.25683,NULL,NULL,'2011-01-25 00:00:00',55586,17.64,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110125/1101251070284140740.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110125/jpg/1101251070284140740.master.jpg',NULL,NULL,64608590880,NULL,NULL,NULL,'2011-01-08 13:26:07',55569.559814,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101251070284140740/1101251070284140740.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110125/1101251070284140740p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1009509232,15773581,NULL,NULL,NULL,NULL),(11295,11295,1,'CSS110114-110833-130715','CRTS-CSS',167.13839,-13.12094,NULL,NULL,'2011-01-14 00:00:00',55575,19.42,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110114/1101140120594113960.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110114/jpg/1101140120594113960.master.jpg',NULL,NULL,41811632956,NULL,NULL,NULL,'2010-06-03 13:26:07',55350.559814,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101140120594113960/1101140120594113960.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110114/1101140120594113960p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,653306764,10207918,NULL,NULL,NULL,NULL),(11296,11296,1,'CSS110113-095800+195703','CRTS-CSS',149.5,19.95082,NULL,NULL,'2011-01-13 00:00:00',55574,18.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110113/1101131210514104253.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110113/jpg/1101131210514104253.master.jpg',NULL,NULL,63698395418,NULL,NULL,NULL,'2006-12-23 13:26:23',54092.559998,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101131210514104253/1101131210514104253.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110113/1101131210514104253p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,995287428,15551366,NULL,NULL,NULL,NULL),(11297,11297,1,'CSS110113-090035+015650','CRTS-CSS',135.14712,1.94735,NULL,NULL,'2011-01-13 00:00:00',55574,18.42,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110113/1101131010494140457.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110113/jpg/1101131010494140457.master.jpg',NULL,NULL,63623378350,NULL,NULL,NULL,'2010-05-17 12:28:49',55333.52002,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101131010494140457/1101131010494140457.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110113/1101131010494140457p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,994115286,15533051,NULL,NULL,NULL,NULL),(11298,11298,0,'CSS110113-044530-072053','CRTS-CSS',71.37657,-7.34798,NULL,NULL,'2011-01-13 00:00:00',55574,15.06,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110113/1101130070264123135.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110113/jpg/1101130070264123135.master.jpg',NULL,NULL,37503927978,NULL,NULL,NULL,'2005-10-24 12:28:47',53667.519989,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101130070264123135/1101130070264123135.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110113/1101130070264123135p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,585998874,9156232,NULL,NULL,NULL,NULL),(11299,11299,1,'CSS110103-103548+215017','CRTS-CSS',158.95051,21.83798,NULL,NULL,'2011-01-03 00:00:00',55564,18.47,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110103/1101031210544131953.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110103/jpg/1101031210544131953.master.jpg',NULL,NULL,60992663342,NULL,NULL,NULL,'2010-12-11 13:26:07',55541.559814,'2013-01-19 01:31:58','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101031210544131953/1101031210544131953.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110103/1101031210544131953p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,953010364,14890786,NULL,NULL,NULL,NULL),(11300,11300,1,'CSS101214-104318+313513','CRTS-CSS',160.8259,31.58685,NULL,NULL,'2010-12-14 00:00:00',55544,18.42,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101214/1012141320504109859.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101214/jpg/1012141320504109859.master.jpg',NULL,NULL,60505344526,NULL,NULL,NULL,'2010-10-28 13:26:07',55497.559814,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1012141320504109859/1012141320504109859.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101214/1012141320504109859p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,945396008,14771812,NULL,NULL,NULL,NULL),(11301,11301,0,'CSS101208-090601+292033','CRTS-CSS',136.50292,29.34237,NULL,NULL,'2010-12-08 00:00:00',55538,16.51,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101208/1012081290434119905.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101208/jpg/1012081290434119905.master.jpg',NULL,NULL,64389728355,NULL,NULL,NULL,'2010-11-07 13:26:07',55507.559814,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1012081290434119905/1012081290434119905.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101208/1012081290434119905p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1006089505,15720148,NULL,NULL,NULL,NULL),(11302,11302,1,'CSS101208-051640+064754','CRTS-CSS',79.16874,6.79824,NULL,NULL,'2010-12-08 00:00:00',55538,17.81,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101208/1012081070284131034.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101208/jpg/1012081070284131034.master.jpg',NULL,NULL,64631030256,NULL,NULL,NULL,'2007-12-05 11:31:10',54439.47998,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1012081070284131034/1012081070284131034.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101208/1012081070284131034p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1009859847,15779060,NULL,NULL,NULL,NULL),(11303,11303,0,'CSS101203-091514+012216','CRTS-CSS',138.80981,1.37123,NULL,NULL,'2010-12-03 00:00:00',55533,17.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101203/1012031010504122216.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101203/jpg/1012031010504122216.master.jpg',NULL,NULL,60673236782,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1012031010504122216/1012031010504122216.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101203/1012031010504122216p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,948019324,14812801,NULL,NULL,NULL,NULL),(11304,11304,0,'CSS101115-225640+381044','CRTS-CSS',344.16757,38.17884,NULL,NULL,'2010-11-15 00:00:00',55515,18.12,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101115/1011151380994140667.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101115/jpg/1011151380994140667.master.jpg',NULL,NULL,55517508417,NULL,NULL,NULL,'2010-06-12 13:26:07',55359.559814,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011151380994140667/1011151380994140667.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101115/1011151380994140667p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,867461069,13554079,NULL,NULL,NULL,NULL),(11305,11305,1,'CSS101111-002928+151707','CRTS-CSS',7.36668,15.2853,NULL,NULL,'2010-11-11 00:00:00',55511,19.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101111/1011111150034118129.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101111/jpg/1011111150034118129.master.jpg',NULL,NULL,66747529523,NULL,NULL,NULL,'2006-10-22 12:28:49',54030.52002,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011111150034118129/1011111150034118129.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101111/1011111150034118129p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1042930148,16295783,NULL,NULL,NULL,NULL),(11306,11306,0,'CSS101103-090403+090528','CRTS-CSS',136.01278,9.09109,NULL,NULL,'2010-11-03 00:00:00',55503,18.72,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101103/1011031090484111611.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101103/jpg/1011031090484111611.master.jpg',NULL,NULL,63684091353,NULL,NULL,NULL,'2007-01-25 13:26:23',54125.559998,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011031090484111611/1011031090484111611.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101103/1011031090484111611p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,995063927,15547873,NULL,NULL,NULL,NULL),(11307,11307,0,'CSS101103-044445-221219','CRTS-CSS',71.1857,-22.20532,NULL,NULL,'2010-11-03 00:00:00',55503,18.59,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101103/1011030210244105562.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101103/jpg/1011030210244105562.master.jpg',NULL,NULL,37340807906,NULL,NULL,NULL,'2009-02-22 11:31:10',54884.47998,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011030210244105562/1011030210244105562.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101103/1011030210244105562p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,583450123,9116408,NULL,NULL,NULL,NULL),(11308,11308,0,'CSS101102-071716+452304','CRTS-CSS',109.3156,45.38435,NULL,NULL,'2010-11-02 00:00:00',55502,17.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101102/1011021460284108638.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101102/jpg/1011021460284108638.master.jpg',NULL,NULL,63577237416,NULL,NULL,NULL,'2005-03-14 10:33:34',53443.439987,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011021460284108638/1011021460284108638.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101102/1011021460284108638p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,993394334,15521786,NULL,NULL,NULL,NULL),(11309,11309,1,'CSS101102-020958-195345','CRTS-CSS',32.48986,-19.89597,NULL,NULL,'2010-11-02 00:00:00',55502,18.68,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101102/1011020210114134767.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101102/jpg/1011020210114134767.master.jpg',NULL,NULL,37925423362,NULL,NULL,NULL,'2010-10-14 13:26:07',55483.559814,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011020210114134767/1011020210114134767.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101102/1011020210114134767p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,592584740,9259136,NULL,NULL,NULL,NULL),(11310,11310,0,'CSS101030-230944+054156','CRTS-CSS',347.43157,5.69895,NULL,NULL,'2010-10-30 00:00:00',55499,16.55,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101030/1010301071234101194.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101030/jpg/1010301071234101194.master.jpg',NULL,NULL,51724632545,NULL,NULL,NULL,'2010-09-10 13:26:07',55449.559814,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010301071234101194/1010301071234101194.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101030/1010301071234101194p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,808197383,12628084,NULL,NULL,NULL,NULL),(11311,11311,0,'CSS101029-034043+010333','CRTS-CSS',55.18106,1.05928,NULL,NULL,'2010-10-29 00:00:00',55498,17.34,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101029/1010291010204113719.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101029/jpg/1010291010204113719.master.jpg',NULL,NULL,64982331586,NULL,NULL,NULL,'2010-10-11 13:26:07',55480.559814,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010291010204113719/1010291010204113719.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101029/1010291010204113719p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1015348931,15864827,NULL,NULL,NULL,NULL),(11312,11312,0,'CSS101028-011942+302449','CRTS-CSS',19.92593,30.41368,NULL,NULL,'2010-10-28 00:00:00',55497,19.29,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101028/1010281290074137474.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101028/jpg/1010281290074137474.master.jpg',NULL,NULL,67269248232,NULL,NULL,NULL,'2010-10-09 13:26:07',55478.559814,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010281290074137474/1010281290074137474.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101028/1010281290074137474p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,1051082003,16423156,NULL,NULL,NULL,NULL),(11313,11313,0,'CSS101028-031958-144708','CRTS-CSS',49.9896,-14.78553,NULL,NULL,'2010-10-28 00:00:00',55497,18.62,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101028/1010280150184125549.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101028/jpg/1010280150184125549.master.jpg',NULL,NULL,38081791521,NULL,NULL,NULL,'2009-12-17 13:26:29',55182.560059,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010280150184125549/1010280150184125549.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101028/1010280150184125549p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,595027992,9297312,NULL,NULL,NULL,NULL),(11314,11314,1,'CSS101019-175123+372421','CRTS-CSS',267.84699,37.40586,NULL,NULL,'2010-10-19 00:00:00',55488,16.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101019/1010191380774115803.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101019/jpg/1010191380774115803.master.jpg',NULL,NULL,56142192894,NULL,NULL,NULL,'2010-07-07 13:26:07',55384.559814,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010191380774115803/1010191380774115803.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101019/1010191380774115803p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,877221763,13706590,NULL,NULL,NULL,NULL),(11315,11315,0,'CSS101019-022415-155112','CRTS-CSS',36.06403,-15.85323,NULL,NULL,'2010-10-19 00:00:00',55488,18.66,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101019/1010190150134113452.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101019/jpg/1010190150134113452.master.jpg',NULL,NULL,37966038526,NULL,NULL,NULL,'2007-11-19 12:28:49',54423.52002,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010190150134113452/1010190150134113452.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101019/1010190150134113452p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,593219351,9269052,NULL,NULL,NULL,NULL),(11316,11316,1,'CSS101013-020630-080945','CRTS-CSS',31.62379,-8.16244,NULL,NULL,'2010-10-13 00:00:00',55482,20.01,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101013/1010130070124104320.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101013/jpg/1010130070124104320.master.jpg',NULL,NULL,35164870413,NULL,NULL,NULL,'2007-11-02 12:28:49',54406.52002,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010130070124104320/1010130070124104320.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101013/1010130070124104320p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,549451100,8585173,NULL,NULL,NULL,NULL),(11317,11317,0,'CSS101012-004005-063616','CRTS-CSS',10.02069,-6.60458,NULL,NULL,'2010-10-12 00:00:00',55481,19.8,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101012/1010120070044125126.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101012/jpg/1010120070044125126.master.jpg',NULL,NULL,34623270397,NULL,NULL,NULL,'2009-12-16 13:26:29',55181.560059,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010120070044125126/1010120070044125126.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101012/1010120070044125126p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,540988599,8452946,NULL,NULL,NULL,NULL),(11318,11318,0,'CSS101011-220427-075841','CRTS-CSS',331.11424,-7.97812,NULL,NULL,'2010-10-11 00:00:00',55480,17.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:31:59','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101011/1010110071174108849.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101011/jpg/1010110071174108849.master.jpg',NULL,NULL,49869839207,NULL,NULL,NULL,'2010-09-12 13:26:07',55451.559814,'2013-01-19 01:31:59','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010110071174108849/1010110071174108849.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101011/1010110071174108849p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,779216237,12175253,NULL,NULL,NULL,NULL),(11319,11319,0,'CSS101010-223813+352931','CRTS-CSS',339.55492,35.49207,NULL,NULL,'2010-10-10 00:00:00',55479,15.64,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101010/1010101351004150592.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101010/jpg/1010101351004150592.master.jpg',NULL,NULL,55463864926,NULL,NULL,NULL,'2006-10-02 10:33:36',54010.440002,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010101351004150592/1010101351004150592.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101010/1010101351004150592p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,866622889,13540982,NULL,NULL,NULL,NULL),(11320,11320,0,'CSS101003-032949+063255','CRTS-CSS',52.4521,6.54869,NULL,NULL,'2010-10-03 00:00:00',55472,17.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101003/1010031070194113030.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101003/jpg/1010031070194113030.master.jpg',NULL,NULL,65007748657,NULL,NULL,NULL,'2010-09-16 13:26:07',55455.559814,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010031070194113030/1010031070194113030.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101003/1010031070194113030p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1015746072,15871032,NULL,NULL,NULL,NULL),(11321,11321,0,'CSS100930-230549+033121','CRTS-CSS',346.45396,3.5225,NULL,NULL,'2010-09-30 00:00:00',55469,18.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100930/1009301041244110121.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100930/jpg/1009301041244110121.master.jpg',NULL,NULL,51695980109,NULL,NULL,NULL,'2007-10-14 11:31:10',54387.47998,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1009301041244110121/1009301041244110121.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100930/1009301041244110121p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,807749689,12621088,NULL,NULL,NULL,NULL),(11322,11322,0,'CSS100916-035656+083045','CRTS-CSS',59.23416,8.51253,NULL,NULL,'2010-09-16 00:00:00',55455,17.36,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100916/1009161090214101803.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100916/jpg/1009161090214101803.master.jpg',NULL,NULL,65226460561,NULL,NULL,NULL,'2010-03-13 13:26:29',55268.560059,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1009161090214101803/1009161090214101803.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100916/1009161090214101803p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1019163446,15924428,NULL,NULL,NULL,NULL),(11323,11323,1,'CSS100916-003551-160324','CRTS-CSS',8.96428,-16.05655,NULL,NULL,'2010-09-16 00:00:00',55455,16.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100916/1009160150044112016.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100916/jpg/1009160150044112016.master.jpg',NULL,NULL,35338384360,NULL,NULL,NULL,'2005-10-05 10:33:36',53648.440002,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1009160150044112016/1009160150044112016.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100916/1009160150044112016p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,552162255,8627535,NULL,NULL,NULL,NULL),(11324,11324,1,'CSS100912-223118+010516','CRTS-CSS',337.82639,1.08775,NULL,NULL,'2010-09-12 00:00:00',55451,18.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100912/1009121011214116857.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100912/jpg/1009121011214116857.master.jpg',NULL,NULL,52413048721,NULL,NULL,NULL,'2010-07-05 13:26:07',55382.559814,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1009121011214116857/1009121011214116857.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100912/1009121011214116857p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,818953886,12796154,NULL,NULL,NULL,NULL),(11325,11325,1,'CSS100911-004607+052100','CRTS-CSS',11.52775,5.34999,NULL,NULL,'2010-09-11 00:00:00',55450,19.27,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100911/1009111040054133182.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100911/jpg/1009111040054133182.master.jpg',NULL,NULL,66681277071,NULL,NULL,NULL,'2005-11-29 13:26:23',53703.559998,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1009111040054133182/1009111040054133182.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100911/1009111040054133182p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1041894954,16279608,NULL,NULL,NULL,NULL),(11326,11326,1,'CSS100910-231703+105809','CRTS-CSS',349.26193,10.96906,NULL,NULL,'2010-09-10 00:00:00',55449,18.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100910/1009101091244136375.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100910/jpg/1009101091244136375.master.jpg',NULL,NULL,51741614444,NULL,NULL,NULL,'2005-11-03 13:26:23',53677.559998,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1009101091244136375/1009101091244136375.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100910/1009101091244136375p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,808462725,12632230,NULL,NULL,NULL,NULL),(11327,11327,1,'CSS100619-234634+272346','CRTS-CSS',356.64287,27.39625,NULL,NULL,'2010-06-19 00:00:00',55366,19.56,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100619/1006191261154142735.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100619/jpg/1006191261154142735.master.jpg',NULL,NULL,52002332208,NULL,NULL,NULL,'2006-09-29 13:26:23',54007.559998,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006191261154142735/1006191261154142735.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100619/1006191261154142735p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,812536440,12695881,NULL,NULL,NULL,NULL),(11328,11328,1,'CSS100618-152341+185125','CRTS-CSS',230.92199,18.8569,NULL,NULL,'2010-06-18 00:00:00',55365,19.61,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100618/1006181180794136057.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100618/jpg/1006181180794136057.master.jpg',NULL,NULL,59442124040,NULL,NULL,NULL,'2009-05-13 13:26:29',54964.560059,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006181180794136057/1006181180794136057.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100618/1006181180794136057p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,928783188,14512237,NULL,NULL,NULL,NULL),(11329,11329,1,'CSS100617-224800+065725','CRTS-CSS',342.0009,6.95689,NULL,NULL,'2010-06-17 00:00:00',55364,18.98,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100617/1006171071214126085.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100617/jpg/1006171071214126085.master.jpg',NULL,NULL,52474624947,NULL,NULL,NULL,'2010-05-19 13:26:07',55335.559814,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006171071214126085/1006171071214126085.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100617/1006171071214126085p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,819916014,12811187,NULL,NULL,NULL,NULL),(11330,11330,1,'CSS100616-132357-193951','CRTS-CSS',200.98876,-19.66406,NULL,NULL,'2010-06-16 00:00:00',55363,16.74,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100616/1006160180694102054.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100616/jpg/1006160180694102054.master.jpg',NULL,NULL,43821094464,NULL,NULL,NULL,'2008-04-04 11:31:10',54560.47998,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006160180694102054/1006160180694102054.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100616/1006160180694102054p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,684704601,10698509,NULL,NULL,NULL,NULL),(11331,11331,0,'CSS100604-121133+471629','CRTS-CSS',182.88871,47.27473,NULL,NULL,'2010-06-04 00:00:00',55351,17.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100604/1006041460464125448.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100604/jpg/1006041460464125448.master.jpg',NULL,NULL,57178216963,NULL,NULL,NULL,'2005-04-12 10:33:34',53472.439987,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006041460464125448/1006041460464125448.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100604/1006041460464125448p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,893409640,13959525,NULL,NULL,NULL,NULL),(11332,11332,0,'CSS100525-160109+345042','CRTS-CSS',240.28714,34.84488,NULL,NULL,'2010-05-25 00:00:00',55341,17.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100525/1005251350714115578.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100525/jpg/1005251350714115578.master.jpg',NULL,NULL,59767899162,NULL,NULL,NULL,'2009-06-15 12:28:49',54997.52002,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005251350714115578/1005251350714115578.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100525/1005251350714115578p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,933873424,14591772,NULL,NULL,NULL,NULL),(11333,11333,1,'CSS100524-213501-003048','CRTS-CSS',323.75406,-0.51328,NULL,NULL,'2010-05-24 00:00:00',55340,16.46,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100524/1005240011164146595.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100524/jpg/1005240011164146595.master.jpg',NULL,NULL,49708957376,NULL,NULL,NULL,'2010-05-10 13:26:07',55326.559814,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005240011164146595/1005240011164146595.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100524/1005240011164146595p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,776702459,12135975,NULL,NULL,NULL,NULL),(11334,11334,0,'CSS100521-135046+192618','CRTS-CSS',207.69078,19.43839,NULL,NULL,'2010-05-21 00:00:00',55337,17.44,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100521/1005211180714134371.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100521/jpg/1005211180714134371.master.jpg',NULL,NULL,58330958832,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005211180714134371/1005211180714134371.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100521/1005211180714134371p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,911421231,14240956,NULL,NULL,NULL,NULL),(11335,11335,1,'CSS100516-151833+311931','CRTS-CSS',229.63759,31.3253,NULL,NULL,'2010-05-16 00:00:00',55332,19.58,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100516/1005161320714104287.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100516/jpg/1005161320714104287.master.jpg',NULL,NULL,59903492030,NULL,NULL,NULL,'2010-04-17 13:26:07',55303.559814,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005161320714104287/1005161320714104287.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100516/1005161320714104287p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,935992062,14624875,NULL,NULL,NULL,NULL),(11336,11336,1,'CSS100510-104643+031216','CRTS-CSS',161.67709,3.20438,NULL,NULL,'2010-05-10 00:00:00',55326,19.31,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100510/1005101040584103833.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100510/jpg/1005101040584103833.master.jpg',NULL,NULL,60275339161,NULL,NULL,NULL,'2010-04-15 13:26:07',55301.559814,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005101040584103833/1005101040584103833.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100510/1005101040584103833p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,941802174,14715658,NULL,NULL,NULL,NULL),(11337,11337,0,'CSS100505-130031+414444','CRTS-CSS',195.13097,41.74567,NULL,NULL,'2010-05-05 00:00:00',55321,18.26,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:00','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100505/1005051400544133814.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100505/jpg/1005051400544133814.master.jpg',NULL,NULL,59080911352,NULL,NULL,NULL,'2009-04-22 12:28:49',54943.52002,'2013-01-19 01:32:00','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005051400544133814/1005051400544133814.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100505/1005051400544133814p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,923139239,14424050,NULL,NULL,NULL,NULL),(11338,11338,1,'CSS100505-082457+070715','CRTS-CSS',126.23851,7.12085,NULL,NULL,'2010-05-05 00:00:00',55321,18.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100505/1005051070454130612.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100505/jpg/1005051070454130612.master.jpg',NULL,NULL,62570453459,NULL,NULL,NULL,'2009-05-16 11:31:10',54967.47998,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005051070454130612/1005051070454130612.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100505/1005051070454130612p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,977663335,15275989,NULL,NULL,NULL,NULL),(11339,11339,0,'CSS100412-084758+510841','CRTS-CSS',131.99157,51.14479,NULL,NULL,'2010-04-12 00:00:00',55298,17.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100412/1004121520304104992.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100412/jpg/1004121520304104992.master.jpg',NULL,NULL,64224256870,NULL,NULL,NULL,'2009-03-23 10:33:41',54913.440063,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1004121520304104992/1004121520304104992.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100412/1004121520304104992p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1003504013,15679750,NULL,NULL,NULL,NULL),(11340,11340,0,'CSS100411-093357+384836','CRTS-CSS',143.48684,38.80992,NULL,NULL,'2010-04-11 00:00:00',55297,17.69,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100411/1004111380424133800.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100411/jpg/1004111380424133800.master.jpg',NULL,NULL,64395133400,NULL,NULL,NULL,'2005-01-15 13:26:23',53385.559998,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1004111380424133800/1004111380424133800.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100411/1004111380424133800p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1006173959,15721468,NULL,NULL,NULL,NULL),(11341,11341,1,'CSS100410-153432+284746','CRTS-CSS',233.6345,28.79609,NULL,NULL,'2010-04-10 00:00:00',55296,19.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100410/1004101290744110897.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100410/jpg/1004101290744110897.master.jpg',NULL,NULL,59926526990,NULL,NULL,NULL,'2006-04-27 13:26:23',53852.559998,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1004101290744110897/1004101290744110897.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100410/1004101290744110897p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,936351984,14630499,NULL,NULL,NULL,NULL),(11342,11342,0,'CSS100409-093619+292101','CRTS-CSS',144.08033,29.35037,NULL,NULL,'2010-04-09 00:00:00',55295,18.41,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100409/1004091290464116616.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100409/jpg/1004091290464116616.master.jpg',NULL,NULL,64221472260,NULL,NULL,NULL,'2007-01-17 10:33:36',54117.440002,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1004091290464116616/1004091290464116616.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100409/1004091290464116616p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1003460504,15679070,NULL,NULL,NULL,NULL),(11343,11343,0,'CSS100409-150524+025835','CRTS-CSS',226.35015,2.97637,NULL,NULL,'2010-04-09 00:00:00',55295,18.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100409/1004091040814104323.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100409/jpg/1004091040814104323.master.jpg',NULL,NULL,59325406255,NULL,NULL,NULL,'2005-01-18 11:31:11',53388.479996,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1004091040814104323/1004091040814104323.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100409/1004091040814104323p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,926959472,14483741,NULL,NULL,NULL,NULL),(11344,11344,0,'CSS100409-152322+021901','CRTS-CSS',230.84102,2.31694,NULL,NULL,'2010-04-09 00:00:00',55295,18.11,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100409/1004091010834148007.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100409/jpg/1004091010834148007.master.jpg',NULL,NULL,56433050512,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1004091010834148007/1004091010834148007.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100409/1004091010834148007p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,881766414,13777600,NULL,NULL,NULL,NULL),(11345,11345,0,'CSS100404-112205+092644','CRTS-CSS',170.51936,9.44568,NULL,NULL,'2010-04-04 00:00:00',55290,18.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100404/1004041090614113948.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100404/jpg/1004041090614113948.master.jpg',NULL,NULL,60347441679,NULL,NULL,NULL,'2008-04-06 10:33:41',54562.440063,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1004041090614113948/1004041090614113948.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100404/1004041090614113948p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,942928776,14733262,NULL,NULL,NULL,NULL),(11346,11346,0,'CSS100321-115821+152011','CRTS-CSS',179.58616,15.33632,NULL,NULL,'2010-03-21 00:00:00',55276,15.21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100321/1003211150624122202.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100321/jpg/1003211150624122202.master.jpg',NULL,NULL,60238048324,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003211150624122202/1003211150624122202.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100321/1003211150624122202p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,941219505,14706554,NULL,NULL,NULL,NULL),(11347,11347,0,'CSS100320-083831+140039','CRTS-CSS',129.62964,14.01085,NULL,NULL,'2010-03-20 00:00:00',55275,19.08,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100320/1003201120464144037.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100320/jpg/1003201120464144037.master.jpg',NULL,NULL,63853045946,NULL,NULL,NULL,'2010-03-13 13:26:29',55268.560059,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003201120464144037/1003201120464144037.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100320/1003201120464144037p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,997703842,15589122,NULL,NULL,NULL,NULL),(11348,11348,0,'CSS100319-131830+442023','CRTS-CSS',199.62544,44.33969,NULL,NULL,'2010-03-19 00:00:00',55274,18.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100319/1003191430534129611.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100319/jpg/1003191430534129611.master.jpg',NULL,NULL,59307984549,NULL,NULL,NULL,'2005-03-11 10:33:34',53440.439987,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003191430534129611/1003191430534129611.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100319/1003191430534129611p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,926687258,14479488,NULL,NULL,NULL,NULL),(11349,11349,1,'CSS100319-135047+273814','CRTS-CSS',207.69637,27.63726,NULL,NULL,'2010-03-19 00:00:00',55274,18.3,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100319/1003191260674132739.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100319/jpg/1003191260674132739.master.jpg',NULL,NULL,59124206400,NULL,NULL,NULL,'2007-01-16 13:26:23',54116.559998,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003191260674132739/1003191260674132739.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100319/1003191260674132739p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,923815725,14434620,NULL,NULL,NULL,NULL),(11350,11350,1,'CSS100318-122954+470038','CRTS-CSS',187.47307,47.01062,NULL,NULL,'2010-03-18 00:00:00',55273,15.26,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100318/1003181460474129462.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100318/jpg/1003181460474129462.master.jpg',NULL,NULL,59068360811,NULL,NULL,NULL,'2010-02-20 13:26:29',55247.560059,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003181460474129462/1003181460474129462.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100318/1003181460474129462p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,922943137,14420986,NULL,NULL,NULL,NULL),(11351,11351,0,'CSS100318-151440+282521','CRTS-CSS',228.66506,28.42261,NULL,NULL,'2010-03-18 00:00:00',55273,18.31,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100318/1003181290724103394.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100318/jpg/1003181290724103394.master.jpg',NULL,NULL,59909329697,NULL,NULL,NULL,'2008-02-19 11:31:10',54515.47998,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003181290724103394/1003181290724103394.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100318/1003181290724103394p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,936083276,14626301,NULL,NULL,NULL,NULL),(11352,11352,1,'CSS100217-102913+404220','CRTS-CSS',157.30232,40.70548,NULL,NULL,'2010-02-17 00:00:00',55244,16.02,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100217/1002171400444123118.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100217/jpg/1002171400444123118.master.jpg',NULL,NULL,64149120122,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1002171400444123118/1002171400444123118.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100217/1002171400444123118p.html',NULL,NULL,0,'AGN',NULL,0,NULL,0,1002330001,15661406,NULL,NULL,NULL,NULL),(11353,11353,1,'CSS100217-111053+370948','CRTS-CSS',167.71951,37.16321,NULL,NULL,'2010-02-17 00:00:00',55244,19.34,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100217/1002171380484109521.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100217/jpg/1002171380484109521.master.jpg',NULL,NULL,60417826141,NULL,NULL,NULL,'2010-01-15 13:26:29',55211.560059,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1002171380484109521/1002171380484109521.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100217/1002171380484109521p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,944028533,14750445,NULL,NULL,NULL,NULL),(11354,11354,1,'CSS100217-124243+325205','CRTS-CSS',190.68031,32.86799,NULL,NULL,'2010-02-17 00:00:00',55244,19.96,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100217/1002171320594132636.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100217/jpg/1002171320594132636.master.jpg',NULL,NULL,58742366921,NULL,NULL,NULL,'2008-01-17 12:28:49',54482.52002,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1002171320594132636/1002171320594132636.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100217/1002171320594132636p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,917849483,14341398,NULL,NULL,NULL,NULL),(11355,11355,1,'CSS100215-140804+181149','CRTS-CSS',212.01749,18.19695,NULL,NULL,'2010-02-15 00:00:00',55242,20.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100215/1002151180734122272.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100215/jpg/1002151180734122272.master.jpg',NULL,NULL,59483654691,NULL,NULL,NULL,'2010-01-12 13:26:29',55208.560059,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1002151180734122272/1002151180734122272.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100215/1002151180734122272p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,929432104,14522376,NULL,NULL,NULL,NULL),(11356,11356,1,'CSS100214-030635+230620','CRTS-CSS',46.64744,23.10565,NULL,NULL,'2010-02-14 00:00:00',55241,19.01,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100214/1002141230164108008.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100214/jpg/1002141230164108008.master.jpg',NULL,NULL,67999733529,NULL,NULL,NULL,'2005-11-28 13:26:23',53702.559998,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1002141230164108008/1002141230164108008.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100214/1002141230164108008p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,1062495836,16601497,NULL,NULL,NULL,NULL),(11357,11357,1,'CSS100213-021444+161055','CRTS-CSS',33.68385,16.18206,NULL,NULL,'2010-02-13 00:00:00',55240,18.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100213/1002131150124125627.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100213/jpg/1002131150124125627.master.jpg',NULL,NULL,68075504078,NULL,NULL,NULL,'2009-10-14 12:28:49',55118.52002,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1002131150124125627/1002131150124125627.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100213/1002131150124125627p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1063679751,16619996,NULL,NULL,NULL,NULL),(11358,11358,1,'CSS100213-123835-065338','CRTS-CSS',189.64545,-6.89379,NULL,NULL,'2010-02-13 00:00:00',55240,18.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100213/1002130070674123400.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100213/jpg/1002130070674123400.master.jpg',NULL,NULL,43213306565,NULL,NULL,NULL,'2006-04-21 12:28:49',53846.52002,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1002130070674123400/1002130070674123400.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100213/1002130070674123400p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,675207915,10550123,NULL,NULL,NULL,NULL),(11359,11359,1,'CSS100116-002819+120626','CRTS-CSS',7.07742,12.10724,NULL,NULL,'2010-01-16 00:00:00',55212,18.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100116/1001161120034110404.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100116/jpg/1001161120034110404.master.jpg',NULL,NULL,66751919912,NULL,NULL,NULL,'2009-12-11 13:26:29',55176.560059,'2013-01-19 01:32:01','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1001161120034110404/1001161120034110404.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100116/1001161120034110404p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1042998748,16296855,NULL,NULL,NULL,NULL),(11360,11360,0,'CSS100112-130905+170422','CRTS-CSS',197.27185,17.07286,NULL,NULL,'2010-01-12 00:00:00',55208,16.6,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100112/1001121180684103058.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100112/jpg/1001121180684103058.master.jpg',NULL,NULL,59042315047,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1001121180684103058/1001121180684103058.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100112/1001121180684103058p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,922536172,14414627,NULL,NULL,NULL,NULL),(11361,11361,0,'CSS100108-101213-014900','CRTS-CSS',153.05528,-1.8167,NULL,NULL,'2010-01-08 00:00:00',55204,18.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100108/1001080010554115862.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100108/jpg/1001080010554115862.master.jpg',NULL,NULL,41265951373,NULL,NULL,NULL,'2009-12-16 13:26:29',55181.560059,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1001080010554115862/1001080010554115862.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100108/1001080010554115862p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,644780490,10074695,NULL,NULL,NULL,NULL),(11362,11362,0,'CSS091217-110637+341952','CRTS-CSS',166.65368,34.33101,NULL,NULL,'2009-12-17 00:00:00',55182,18.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20091217/912171350504107254.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091217/jpg/912171350504107254.master.jpg',NULL,NULL,60636974223,NULL,NULL,NULL,'2009-05-26 13:26:29',54977.560059,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/912171350504107254/912171350504107254.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091217/912171350504107254p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,947452722,14803948,NULL,NULL,NULL,NULL),(11363,11363,1,'CSS091215-042652+001219','CRTS-CSS',66.71874,0.20515,NULL,NULL,'2009-12-15 00:00:00',55180,19.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20091215/912151010244104656.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091215/jpg/912151010244104656.master.jpg',NULL,NULL,65029106039,NULL,NULL,NULL,'2006-11-19 11:31:15',54058.480042,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/912151010244104656/912151010244104656.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091215/912151010244104656p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1016079781,15876246,NULL,NULL,NULL,NULL),(11364,11364,0,'CSS091215-022038+022415','CRTS-CSS',35.15704,2.40408,NULL,NULL,'2009-12-15 00:00:00',55180,18.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20091215/912151010134138355.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091215/jpg/912151010134138355.master.jpg',NULL,NULL,66888555322,NULL,NULL,NULL,'2009-10-16 13:26:29',55120.560059,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/912151010134138355/912151010134138355.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091215/912151010134138355p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1045133676,16330213,NULL,NULL,NULL,NULL),(11365,11365,1,'CSS091127-092855+170214','CRTS-CSS',142.22766,17.03714,NULL,NULL,'2009-11-27 00:00:00',55162,19.35,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20091127/911271180494102724.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091127/jpg/911271180494102724.master.jpg',NULL,NULL,63729667697,NULL,NULL,NULL,'2009-11-11 13:26:29',55146.560059,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/911271180494102724/911271180494102724.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091127/911271180494102724p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,995776057,15559000,NULL,NULL,NULL,NULL),(11366,11366,1,'CSS091126-124351-003454','CRTS-CSS',190.96323,-0.58158,NULL,NULL,'2009-11-26 00:00:00',55161,16.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20091126/911260010684130868.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091126/jpg/911260010684130868.master.jpg',NULL,NULL,43167989290,NULL,NULL,NULL,'2007-12-20 11:31:10',54454.47998,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/911260010684130868/911260010684130868.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091126/911260010684130868p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,674499832,10539059,NULL,NULL,NULL,NULL),(11367,11367,0,'CSS091121-085600-051945','CRTS-CSS',133.99922,-5.32906,NULL,NULL,'2009-11-21 00:00:00',55156,18.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20091121/911210040484107252.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091121/jpg/911210040484107252.master.jpg',NULL,NULL,42150038779,NULL,NULL,NULL,'2009-10-27 13:26:29',55131.560059,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/911210040484107252/911210040484107252.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091121/911210040484107252p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,658594355,10290536,NULL,NULL,NULL,NULL),(11368,11368,0,'CSS091120-100525+511639','CRTS-CSS',151.35223,51.27742,NULL,NULL,'2009-11-20 00:00:00',55155,18.8,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20091120/911201520354108835.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091120/jpg/911201520354108835.master.jpg',NULL,NULL,63993961555,NULL,NULL,NULL,'2006-12-16 10:33:36',54085.440002,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/911201520354108835/911201520354108835.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091120/911201520354108835p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,999905649,15623525,NULL,NULL,NULL,NULL),(11369,11369,0,'CSS091119-001627+222610','CRTS-CSS',4.1107,22.43613,NULL,NULL,'2009-11-19 00:00:00',55154,17.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20091119/911191210024141794.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091119/jpg/911191210024141794.master.jpg',NULL,NULL,67454820159,NULL,NULL,NULL,'2005-10-05 11:31:10',53648.47998,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/911191210024141794/911191210024141794.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091119/911191210024141794p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1053981564,16468461,NULL,NULL,NULL,NULL),(11370,11370,0,'CSS091108-113307+244131','CRTS-CSS',173.28032,24.6919,NULL,NULL,'2009-11-08 00:00:00',55143,18.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20091108/911081230574130235.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091108/jpg/911081230574130235.master.jpg',NULL,NULL,60573616488,NULL,NULL,NULL,'2009-06-22 13:26:29',55004.560059,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/911081230574130235/911081230574130235.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091108/911081230574130235p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,946462757,14788480,NULL,NULL,NULL,NULL),(11371,11371,0,'CSS091023-030259-144902','CRTS-CSS',45.74587,-14.81719,NULL,NULL,'2009-10-23 00:00:00',55127,16.44,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20091023/910230150164225792.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091023/jpg/910230150164225792.master.jpg',NULL,NULL,38103952411,NULL,NULL,NULL,'2009-09-29 13:26:29',55103.560059,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/910230150164225792/910230150164225792.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091023/910230150164225792p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,595374256,9302722,NULL,NULL,NULL,NULL),(11372,11372,0,'CSS091020-221124-091244','CRTS-CSS',332.84829,-9.21232,NULL,NULL,'2009-10-20 00:00:00',55124,18.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20091020/910200091184135678.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091020/jpg/910200091184135678.master.jpg',NULL,NULL,49876808247,NULL,NULL,NULL,'2009-09-10 11:31:10',55084.47998,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/910200091184135678/910200091184135678.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091020/910200091184135678p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,779325128,12176955,NULL,NULL,NULL,NULL),(11373,11373,0,'CSS091018-091109+195945','CRTS-CSS',137.78835,19.99589,NULL,NULL,'2009-10-18 00:00:00',55122,19.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20091018/910181210474104326.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091018/jpg/910181210474104326.master.jpg',NULL,NULL,63832762032,NULL,NULL,NULL,'2009-02-14 13:26:29',54876.560059,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/910181210474104326/910181210474104326.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091018/910181210474104326p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,997386906,15584170,NULL,NULL,NULL,NULL),(11374,11374,1,'CSS091017-082858-003512','CRTS-CSS',127.24252,-0.58676,NULL,NULL,'2009-10-17 00:00:00',55121,18.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20091017/910170010464152062.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091017/jpg/910170010464152062.master.jpg',NULL,NULL,39218630127,NULL,NULL,NULL,'2009-04-20 13:26:29',54941.560059,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/910170010464152062/910170010464152062.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091017/910170010464152062p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,612791095,9574860,NULL,NULL,NULL,NULL),(11375,11375,1,'CSS091016-004842-055119','CRTS-CSS',12.1739,-5.8552,NULL,NULL,'2009-10-16 00:00:00',55120,19.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20091016/910160070054140630.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091016/jpg/910160070054140630.master.jpg',NULL,NULL,34536761285,NULL,NULL,NULL,'2009-09-24 12:28:49',55098.52002,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/910160070054140630/910160070054140630.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091016/910160070054140630p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,539636895,8431826,NULL,NULL,NULL,NULL),(11376,11376,0,'CSS091015-034944-031552','CRTS-CSS',57.43448,-3.26442,NULL,NULL,'2009-10-15 00:00:00',55119,15.5,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20091015/910150040214136986.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091015/jpg/910150040214136986.master.jpg',NULL,NULL,37007893266,NULL,NULL,NULL,'2009-09-24 13:26:29',55098.560059,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/910150040214136986/910150040214136986.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091015/910150040214136986p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,578248332,9035130,NULL,NULL,NULL,NULL),(11377,11377,1,'CSS130117-102518+332431','CRTS-CSS',156.3251,33.40861,NULL,NULL,'2013-01-17 00:00:00',56309,20.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130117/1301171320484141493.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130117/jpg/1301171320484141493.master.jpg',NULL,NULL,64086713911,NULL,NULL,NULL,'2013-01-05 13:26:07',56297.559814,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301171320484141493/1301171320484141493.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130117/1301171320484141493p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1001354904,15646170,NULL,NULL,NULL,NULL),(11378,11378,1,'CSS130113-081345+033721','CRTS-CSS',123.43791,3.62255,NULL,NULL,'2013-01-13 00:00:00',56305,16.93,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130113/1301131040444124691.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130113/jpg/1301131040444124691.master.jpg',NULL,NULL,62779250420,NULL,NULL,NULL,'2012-03-29 13:26:07',56015.559814,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301131040444124691/1301131040444124691.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130113/1301131040444124691p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,980925787,15326965,NULL,NULL,NULL,NULL),(11379,11379,1,'CSS130110-071427+404051','CRTS-CSS',108.61175,40.68085,NULL,NULL,'2013-01-10 00:00:00',56302,18.5,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:02','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130110/1301101400304128284.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130110/jpg/1301101400304128284.master.jpg',NULL,NULL,63596875468,NULL,NULL,NULL,'2012-12-10 13:26:07',56271.559814,'2013-01-19 01:32:02','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301101400304128284/1301101400304128284.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130110/1301101400304128284p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,993701179,15526580,NULL,NULL,NULL,NULL),(11380,11380,1,'CSS130109-124806+183503','CRTS-CSS',192.02409,18.58412,NULL,NULL,'2013-01-09 00:00:00',56301,19.64,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:03','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130109/1301091180664133645.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130109/jpg/1301091180664133645.master.jpg',NULL,NULL,58897411021,NULL,NULL,NULL,'2010-03-21 11:31:10',55276.47998,'2013-01-19 01:32:03','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301091180664133645/1301091180664133645.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130109/1301091180664133645p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,920272047,14379250,NULL,NULL,NULL,NULL),(11381,11381,1,'CSS130108-121254+054411','CRTS-CSS',183.22481,5.7363,NULL,NULL,'2013-01-08 00:00:00',56300,19.54,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:03','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130108/1301081070654101988.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130108/jpg/1301081070654101988.master.jpg',NULL,NULL,58026206617,NULL,NULL,NULL,'2011-02-09 13:26:07',55601.559814,'2013-01-19 01:32:03','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301081070654101988/1301081070654101988.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130108/1301081070654101988p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,906659478,14166554,NULL,NULL,NULL,NULL),(11382,11382,1,'CSS121208-134649+135454','CRTS-CSS',206.70435,13.91494,NULL,NULL,'2012-12-08 00:00:00',56269,18.71,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:03','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121208/1212081120734147885.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121208/jpg/1212081120734147885.master.jpg',NULL,NULL,58351074268,NULL,NULL,NULL,'2012-06-11 13:26:07',56089.559814,'2013-01-19 01:32:03','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212081120734147885/1212081120734147885.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121208/1212081120734147885p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,911735535,14245867,NULL,NULL,NULL,NULL),(11383,11383,1,'CSS121208-035617-305156','CRTS-CSS',59.06994,-30.86548,NULL,NULL,'2012-12-08 00:00:00',56269,18.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:03','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121208/1212080290194104068.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121208/jpg/1212080290194104068.master.jpg',NULL,NULL,38575434257,NULL,NULL,NULL,'2012-11-14 11:31:10',56245.47998,'2013-01-19 01:32:03','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212080290194104068/1212080290194104068.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121208/1212080290194104068p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,602741160,9417830,NULL,NULL,NULL,NULL),(11384,11384,1,'CSS121204-033907-064917','CRTS-CSS',54.78097,-6.82134,NULL,NULL,'2012-12-04 00:00:00',56265,18.56,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:03','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121204/1212040070204124265.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121204/jpg/1212040070204124265.master.jpg',NULL,NULL,36797495046,NULL,NULL,NULL,'2012-11-23 13:26:07',56254.559814,'2013-01-19 01:32:03','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212040070204124265/1212040070204124265.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121204/1212040070204124265p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,574960860,8983763,NULL,NULL,NULL,NULL),(11386,11386,1,'CSS121115-001907+403424','CRTS-CSS',4.78043,40.57331,NULL,NULL,'2012-11-15 00:00:00',56246,17.08,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:03','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121115/1211151400024128052.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121115/jpg/1211151400024128052.master.jpg',NULL,NULL,67120156905,NULL,NULL,NULL,'2012-10-25 13:26:07',56225.559814,'2013-01-19 01:32:03','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211151400024128052/1211151400024128052.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121115/1211151400024128052p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1048752451,16386757,NULL,NULL,NULL,NULL),(11387,11387,1,'CSS121113-012013+261040','CRTS-CSS',20.05353,26.17785,NULL,NULL,'2012-11-13 00:00:00',56244,20.36,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:03','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121113/1211131260074114017.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121113/jpg/1211131260074114017.master.jpg',NULL,NULL,67299275537,NULL,NULL,NULL,'2012-10-25 13:26:07',56225.559814,'2013-01-19 01:32:03','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211131260074114017/1211131260074114017.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121113/1211131260074114017p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1051551180,16430487,NULL,NULL,NULL,NULL),(11388,11388,1,'CSS121107-224411-225846','CRTS-CSS',341.04408,-22.97937,NULL,NULL,'2012-11-07 00:00:00',56238,18.42,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:03','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121107/1211070231124139883.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121107/jpg/1211070231124139883.master.jpg',NULL,NULL,50226087765,NULL,NULL,NULL,'2011-09-23 10:33:30',55827.439941,'2013-01-19 01:32:03','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211070231124139883/1211070231124139883.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121107/1211070231124139883p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,784782621,12262228,NULL,NULL,NULL,NULL),(11392,11392,1,'CSS121019-000956+171748','CRTS-CSS',2.48471,17.29676,NULL,NULL,'2012-10-19 00:00:00',56219,19.11,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:03','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121019/1210191180014206445.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121019/jpg/1210191180014206445.master.jpg',NULL,NULL,66711687582,NULL,NULL,NULL,'2012-06-17 10:33:30',56095.439941,'2013-01-19 01:32:03','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210191180014206445/1210191180014206445.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121019/1210191180014206445p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1042370118,16287033,NULL,NULL,NULL,NULL),(11393,11393,1,'CSS121014-033144+030737','CRTS-CSS',52.93503,3.12696,NULL,NULL,'2012-10-14 00:00:00',56214,19.27,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:03','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121014/1210141040194104716.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121014/jpg/1210141040194104716.master.jpg',NULL,NULL,64983416492,NULL,NULL,NULL,'2008-01-12 10:33:41',54477.440063,'2013-01-19 01:32:03','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210141040194104716/1210141040194104716.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121014/1210141040194104716p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,1015365882,15865091,NULL,NULL,NULL,NULL),(11396,11396,1,'CSS121009-025917-141610','CRTS-CSS',44.82264,-14.26955,NULL,NULL,'2012-10-09 00:00:00',56209,19.16,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:03','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121009/1210090150164136276.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121009/jpg/1210090150164136276.master.jpg',NULL,NULL,38105020280,NULL,NULL,NULL,'2011-10-18 12:28:49',55852.52002,'2013-01-19 01:32:03','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210090150164136276/1210090150164136276.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121009/1210090150164136276p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,595390941,9302983,NULL,NULL,NULL,NULL),(11400,11400,0,'CSS120926-035715-100944','CRTS-CSS',59.31411,-10.16221,NULL,NULL,'2012-09-26 00:00:00',56196,17.01,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','2019-10-11 20:38:49','http://nesssi.cacr.caltech.edu/catalina/20120926/1209260090214114228.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120926/jpg/1209260090214114228.master.jpg',NULL,NULL,37035555712,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209260090214114228/1209260090214114228.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120926/1209260090214114228p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,578680558,9041883,NULL,NULL,NULL,NULL),(11401,11401,1,'CSS120917-020030+233347','CRTS-CSS',30.1234,23.56319,NULL,NULL,'2012-09-17 00:00:00',56187,19.68,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120917/1209171230104117349.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120917/jpg/1209171230104117349.master.jpg',NULL,NULL,68051216292,NULL,NULL,NULL,'2007-09-19 13:26:29',54362.560059,'2013-01-19 01:32:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209171230104117349/1209171230104117349.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120917/1209171230104117349p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1063300254,16614066,NULL,NULL,NULL,NULL),(11403,11403,1,'CSS120915-211506-003116','CRTS-CSS',318.77618,-0.52114,NULL,NULL,'2012-09-15 00:00:00',56185,16.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120915/1209150011144164368.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120915/jpg/1209150011144164368.master.jpg',NULL,NULL,49670806280,NULL,NULL,NULL,'2012-08-25 13:26:07',56164.559814,'2013-01-19 01:32:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209150011144164368/1209150011144164368.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120915/1209150011144164368p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,776106348,12126661,NULL,NULL,NULL,NULL),(11404,11404,1,'CSS120914-011848+104312','CRTS-CSS',19.69881,10.72001,NULL,NULL,'2012-09-14 00:00:00',56184,19.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120914/1209141090074136361.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120914/jpg/1209141090074136361.master.jpg',NULL,NULL,67536416431,NULL,NULL,NULL,'2007-09-11 10:33:41',54354.440063,'2013-01-19 01:32:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209141090074136361/1209141090074136361.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120914/1209141090074136361p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1055256506,16488382,NULL,NULL,NULL,NULL),(11405,11405,1,'CSS120913-220645+044820','CRTS-CSS',331.68591,4.80559,NULL,NULL,'2012-09-13 00:00:00',56183,19.24,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120913/1209131041184139147.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120913/jpg/1209131041184139147.master.jpg',NULL,NULL,52197685345,NULL,NULL,NULL,'2005-12-25 13:26:23',53729.559998,'2013-01-19 01:32:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209131041184139147/1209131041184139147.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120913/1209131041184139147p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,815588833,12743575,NULL,NULL,NULL,NULL),(11406,11406,1,'CSS120913-223258-001255','CRTS-CSS',338.24225,-0.21519,NULL,NULL,'2012-09-13 00:00:00',56183,19.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120913/1209130011214144832.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120913/jpg/1209130011214144832.master.jpg',NULL,NULL,49460145912,NULL,NULL,NULL,'2007-10-31 10:33:41',54404.440063,'2013-01-19 01:32:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209130011214144832/1209130011214144832.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120913/1209130011214144832p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,772814779,12075230,NULL,NULL,NULL,NULL),(11407,11407,0,'CSS120812-221823+344509','CRTS-CSS',334.59514,34.75256,NULL,NULL,'2012-08-12 00:00:00',56151,15.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','2019-12-24 20:38:21','http://nesssi.cacr.caltech.edu/catalina/20120812/1208121350994133433.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120812/jpg/1208121350994133433.master.jpg',NULL,NULL,55483786767,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1208121350994133433/1208121350994133433.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120812/1208121350994133433p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,866934168,13545846,NULL,NULL,NULL,NULL),(11408,11408,1,'CSS120621-160555+350636','CRTS-CSS',241.47899,35.11008,NULL,NULL,'2012-06-21 00:00:00',56099,19.35,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120621/1206211350724121312.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120621/jpg/1206211350724121312.master.jpg',NULL,NULL,59766143697,NULL,NULL,NULL,'2012-01-30 12:28:49',55956.52002,'2013-01-19 01:32:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206211350724121312/1206211350724121312.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120621/1206211350724121312p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,933845995,14591343,NULL,NULL,NULL,NULL),(11409,11409,1,'CSS120621-232303+193153','CRTS-CSS',350.76353,19.53143,NULL,NULL,'2012-06-21 00:00:00',56099,19.8,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120621/1206211181204150735.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120621/jpg/1206211181204150735.master.jpg',NULL,NULL,52543528986,NULL,NULL,NULL,'2012-01-19 13:26:07',55945.559814,'2013-01-19 01:32:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206211181204150735/1206211181204150735.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120621/1206211181204150735p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,820992640,12828010,NULL,NULL,NULL,NULL),(11410,11410,1,'CSS120613-212655-012054','CRTS-CSS',321.72727,-1.34832,NULL,NULL,'2012-06-13 00:00:00',56091,18.29,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120613/1206130011154131139.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120613/jpg/1206130011154131139.master.jpg',NULL,NULL,49698574688,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206130011154131139/1206130011154131139.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120613/1206130011154131139p.html',NULL,NULL,0,'AGN',NULL,0,NULL,0,776540229,12133441,NULL,NULL,NULL,NULL),(11411,11411,1,'CSS120612-173245+094746','CRTS-CSS',263.18865,9.7962,NULL,NULL,'2012-06-12 00:00:00',56090,16.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120612/1206121090934157104.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120612/jpg/1206121090934157104.master.jpg',NULL,NULL,56094273715,NULL,NULL,NULL,'2011-06-23 13:26:07',55735.559814,'2013-01-19 01:32:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206121090934157104/1206121090934157104.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120612/1206121090934157104p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,876473026,13694891,NULL,NULL,NULL,NULL),(11412,11412,1,'CSS120530-185356+475831','CRTS-CSS',283.48243,47.97516,NULL,NULL,'2012-05-30 00:00:00',56077,16.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120530/1205301490684103562.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120530/jpg/1205301490684103562.master.jpg',NULL,NULL,54800149611,NULL,NULL,NULL,'2007-09-10 10:33:41',54353.440063,'2013-01-19 01:32:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205301490684103562/1205301490684103562.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120530/1205301490684103562p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,856252337,13378942,NULL,NULL,NULL,NULL),(11413,11413,1,'CSS120525-163702+430644','CRTS-CSS',249.25965,43.11212,NULL,NULL,'2012-05-25 00:00:00',56072,18.98,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120525/1205251430664113603.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120525/jpg/1205251430664113603.master.jpg',NULL,NULL,59847732143,NULL,NULL,NULL,'2007-03-19 10:33:36',54178.440002,'2013-01-19 01:32:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205251430664113603/1205251430664113603.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120525/1205251430664113603p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,935120814,14611262,NULL,NULL,NULL,NULL),(11414,11414,1,'CSS120525-151424+133244','CRTS-CSS',228.59949,13.54552,NULL,NULL,'2012-05-25 00:00:00',56072,18.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120525/1205251120814137249.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120525/jpg/1205251120814137249.master.jpg',NULL,NULL,59573289203,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205251120814137249/1205251120814137249.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120525/1205251120814137249p.html',NULL,NULL,0,'AGN',NULL,0,NULL,0,930832643,14544260,NULL,NULL,NULL,NULL),(11415,11415,1,'CSS120525-142031+121918','CRTS-CSS',215.13071,12.32164,NULL,NULL,'2012-05-25 00:00:00',56072,18.61,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120525/1205251120764116072.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120525/jpg/1205251120764116072.master.jpg',NULL,NULL,58351789197,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205251120764116072/1205251120764116072.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120525/1205251120764116072p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,911746706,14246042,NULL,NULL,NULL,NULL),(11416,11416,0,'CSS120428-072938+464728','CRTS-CSS',112.40715,46.79121,NULL,NULL,'2012-04-28 00:00:00',56045,18.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','2019-11-19 20:37:41','http://nesssi.cacr.caltech.edu/catalina/20120428/1204281460294127844.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120428/jpg/1204281460294127844.master.jpg',NULL,NULL,63581824942,NULL,NULL,NULL,'2012-04-02 13:26:07',56019.559814,'2013-01-19 01:32:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204281460294127844/1204281460294127844.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120428/1204281460294127844p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,993466014,15522906,NULL,NULL,NULL,NULL),(11417,11417,1,'CSS120427-091744+403207','CRTS-CSS',139.43495,40.5353,NULL,NULL,'2012-04-27 00:00:00',56044,18.95,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:04','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120427/1204271400394113864.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120427/jpg/1204271400394113864.master.jpg',NULL,NULL,64267054468,NULL,NULL,NULL,'2007-04-19 10:33:36',54209.440002,'2013-01-19 01:32:04','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204271400394113864/1204271400394113864.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120427/1204271400394113864p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1004172726,15690198,NULL,NULL,NULL,NULL),(11419,11419,1,'CSS120423-092427+100309','CRTS-CSS',141.1142,10.05259,NULL,NULL,'2012-04-23 00:00:00',56040,19.25,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120423/1204231090504125181.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120423/jpg/1204231090504125181.master.jpg',NULL,NULL,63638938745,NULL,NULL,NULL,'2012-04-13 13:26:07',56030.559814,'2013-01-19 01:32:05','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204231090504125181/1204231090504125181.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120423/1204231090504125181p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,994358417,15536850,NULL,NULL,NULL,NULL),(11420,11420,1,'CSS120420-125229-221428','CRTS-CSS',193.11925,-22.24109,NULL,NULL,'2012-04-20 00:00:00',56037,19.33,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120420/1204200210654105431.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120420/jpg/1204200210654105431.master.jpg',NULL,NULL,43976505193,NULL,NULL,NULL,'2009-04-18 10:33:41',54939.440063,'2013-01-19 01:32:05','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204200210654105431/1204200210654105431.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120420/1204200210654105431p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,687132893,10736451,NULL,NULL,NULL,NULL),(11421,11421,1,'CSS120417-125732+262854','CRTS-CSS',194.38337,26.48171,NULL,NULL,'2012-04-17 00:00:00',56034,19.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120417/1204171260634121477.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120417/jpg/1204171260634121477.master.jpg',NULL,NULL,58700500187,NULL,NULL,NULL,'2008-04-08 10:33:41',54564.440063,'2013-01-19 01:32:05','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204171260634121477/1204171260634121477.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120417/1204171260634121477p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,917195315,14331176,NULL,NULL,NULL,NULL),(11422,11422,1,'CSS120415-132442+125641','CRTS-CSS',201.17512,12.9447,NULL,NULL,'2012-04-15 00:00:00',56032,19.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120415/1204151120714126832.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120415/jpg/1204151120714126832.master.jpg',NULL,NULL,59020043217,NULL,NULL,NULL,'2005-01-15 10:33:34',53385.439987,'2013-01-19 01:32:05','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204151120714126832/1204151120714126832.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120415/1204151120714126832p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,922188175,14409190,NULL,NULL,NULL,NULL),(11423,11423,1,'CSS120402-163633+280306','CRTS-CSS',249.13823,28.05155,NULL,NULL,'2012-04-02 00:00:00',56019,19.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120402/1204021260814160993.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120402/jpg/1204021260814160993.master.jpg',NULL,NULL,56180911819,NULL,NULL,NULL,'2007-05-22 11:31:15',54242.480042,'2013-01-19 01:32:05','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204021260814160993/1204021260814160993.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120402/1204021260814160993p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,877826747,13716042,NULL,NULL,NULL,NULL),(11424,11424,1,'CSS120401-142437+284428','CRTS-CSS',216.15405,28.74108,NULL,NULL,'2012-04-01 00:00:00',56018,19.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120401/1204011290684108433.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120401/jpg/1204011290684108433.master.jpg',NULL,NULL,60059915215,NULL,NULL,NULL,'2012-01-29 13:26:07',55955.559814,'2013-01-19 01:32:05','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204011290684108433/1204011290684108433.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120401/1204011290684108433p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,938436175,14663065,NULL,NULL,NULL,NULL),(11425,11425,1,'CSS120328-124350+214312','CRTS-CSS',190.95933,21.71994,NULL,NULL,'2012-03-28 00:00:00',56014,20.19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120328/1203281210654134717.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120328/jpg/1203281210654134717.master.jpg',NULL,NULL,58904627628,NULL,NULL,NULL,'2006-04-26 10:33:36',53851.440002,'2013-01-19 01:32:05','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203281210654134717/1203281210654134717.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120328/1203281210654134717p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,920384806,14381012,NULL,NULL,NULL,NULL),(11426,11426,1,'CSS120328-104902-072440','CRTS-CSS',162.25742,-7.41111,NULL,NULL,'2012-03-28 00:00:00',56014,19.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120328/1203280070584118839.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120328/jpg/1203280070584118839.master.jpg',NULL,NULL,41798843456,NULL,NULL,NULL,'2012-03-15 13:26:07',56001.559814,'2013-01-19 01:32:05','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203280070584118839/1203280070584118839.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120328/1203280070584118839p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,653106929,10204795,NULL,NULL,NULL,NULL),(11427,11427,1,'CSS120327-140258+062928','CRTS-CSS',210.74251,6.4911,NULL,NULL,'2012-03-27 00:00:00',56013,20.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120327/1203271070754115152.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120327/jpg/1203271070754115152.master.jpg',NULL,NULL,58512276222,NULL,NULL,NULL,'2008-06-10 10:33:41',54627.440063,'2013-01-19 01:32:05','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203271070754115152/1203271070754115152.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120327/1203271070754115152p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,914254315,14285223,NULL,NULL,NULL,NULL),(11428,11428,1,'CSS120326-153831+260312','CRTS-CSS',234.62762,26.05331,NULL,NULL,'2012-03-26 00:00:00',56012,18.11,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120326/1203261260764111970.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120326/jpg/1203261260764111970.master.jpg',NULL,NULL,59916602573,NULL,NULL,NULL,'2012-01-23 13:26:07',55949.559814,'2013-01-19 01:32:05','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203261260764111970/1203261260764111970.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120326/1203261260764111970p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,936196915,14628076,NULL,NULL,NULL,NULL),(11429,11429,1,'CSS120324-101217-182411','CRTS-CSS',153.0723,-18.40295,NULL,NULL,'2012-03-24 00:00:00',56010,17.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120324/1203240180534128079.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120324/jpg/1203240180534128079.master.jpg',NULL,NULL,41145660529,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203240180534128079/1203240180534128079.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120324/1203240180534128079p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,642900945,10045327,NULL,NULL,NULL,NULL),(11430,11430,1,'CSS120322-121856+225707','CRTS-CSS',184.73211,22.95199,NULL,NULL,'2012-03-22 00:00:00',56008,19.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120322/1203221230614107477.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120322/jpg/1203221230614107477.master.jpg',NULL,NULL,58864488219,NULL,NULL,NULL,'2005-12-07 13:26:23',53711.559998,'2013-01-19 01:32:05','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203221230614107477/1203221230614107477.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120322/1203221230614107477p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,919757628,14371212,NULL,NULL,NULL,NULL),(11432,11432,1,'CSS120316-093919-173135','CRTS-CSS',144.82968,-17.52652,NULL,NULL,'2012-03-16 00:00:00',56002,18.71,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120316/1203160180504151498.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120316/jpg/1203160180504151498.master.jpg',NULL,NULL,42306501238,NULL,NULL,NULL,'2006-11-25 11:31:15',54064.480042,'2013-01-19 01:32:05','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203160180504151498/1203160180504151498.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120316/1203160180504151498p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,661039081,10328735,NULL,NULL,NULL,NULL),(11433,11433,1,'CSS120303-110254+442015','CRTS-CSS',165.72689,44.3376,NULL,NULL,'2012-03-03 00:00:00',55989,18.98,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120303/1203031430444127282.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120303/jpg/1203031430444127282.master.jpg',NULL,NULL,63942083892,NULL,NULL,NULL,'2009-11-08 10:33:41',55143.440063,'2013-01-19 01:32:05','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203031430444127282/1203031430444127282.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120303/1203031430444127282p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,999095060,15610860,NULL,NULL,NULL,NULL),(11435,11435,1,'CSS120229-143939+133220','CRTS-CSS',219.91233,13.53887,NULL,NULL,'2012-02-29 00:00:00',55986,19.45,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120229/1202291120774143126.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120229/jpg/1202291120774143126.master.jpg',NULL,NULL,59557780170,NULL,NULL,NULL,'2006-03-23 13:26:23',53817.559998,'2013-01-19 01:32:05','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202291120774143126/1202291120774143126.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120229/1202291120774143126p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,930590315,14540473,NULL,NULL,NULL,NULL),(11436,11436,1,'CSS120224-051549+303036','CRTS-CSS',78.95261,30.50991,NULL,NULL,'2012-02-24 00:00:00',55981,16.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120224/1202241290254205467.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120224/jpg/1202241290254205467.master.jpg',NULL,NULL,64951978952,NULL,NULL,NULL,'2011-11-02 13:26:07',55867.559814,'2013-01-19 01:32:05','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202241290254205467/1202241290254205467.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120224/1202241290254205467p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1014874671,15857416,NULL,NULL,NULL,NULL),(11437,11437,1,'CSS120224-040631-111944','CRTS-CSS',61.62826,-11.32898,NULL,NULL,'2012-02-24 00:00:00',55981,19.47,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:05','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120224/1202240120224143087.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120224/jpg/1202240120224143087.master.jpg',NULL,NULL,36986883481,NULL,NULL,NULL,'2011-12-31 13:26:07',55926.559814,'2013-01-19 01:32:05','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202240120224143087/1202240120224143087.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120224/1202240120224143087p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,577920054,9030000,NULL,NULL,NULL,NULL),(11438,11438,1,'CSS120223-132441-014851','CRTS-CSS',201.17181,-1.81413,NULL,NULL,'2012-02-23 00:00:00',55980,20.21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120223/1202230010724117826.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120223/jpg/1202230010724117826.master.jpg',NULL,NULL,43823696165,NULL,NULL,NULL,'2011-06-24 13:26:07',55736.559814,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202230010724117826/1202230010724117826.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120223/1202230010724117826p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,684745252,10699144,NULL,NULL,NULL,NULL),(11439,11439,1,'CSS120222-092356+234852','CRTS-CSS',140.98136,23.81435,NULL,NULL,'2012-02-22 00:00:00',55979,20.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120222/1202221230474123882.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120222/jpg/1202221230474123882.master.jpg',NULL,NULL,63714662406,NULL,NULL,NULL,'2005-12-28 10:33:36',53732.440002,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202221230474123882/1202221230474123882.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120222/1202221230474123882p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,995541600,15555337,NULL,NULL,NULL,NULL),(11440,11440,1,'CSS120212-045110+262638','CRTS-CSS',72.79155,26.44376,NULL,NULL,'2012-02-12 00:00:00',55969,18.29,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120212/1202121260244130202.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120212/jpg/1202121260244130202.master.jpg',NULL,NULL,64787565073,NULL,NULL,NULL,'2012-01-25 13:26:07',55951.559814,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202121260244130202/1202121260244130202.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120212/1202121260244130202p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1012305704,15817276,NULL,NULL,NULL,NULL),(11441,11441,1,'CSS120211-033019+150558','CRTS-CSS',52.58005,15.09942,NULL,NULL,'2012-02-11 00:00:00',55968,18.27,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120211/1202111150194115089.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120211/jpg/1202111150194115089.master.jpg',NULL,NULL,68017802642,NULL,NULL,NULL,'2012-01-20 12:28:49',55946.52002,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202111150194115089/1202111150194115089.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120211/1202111150194115089p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1062778166,16605908,NULL,NULL,NULL,NULL),(11442,11442,1,'CSS120201-110134+401951','CRTS-CSS',165.39283,40.33082,NULL,NULL,'2012-02-01 00:00:00',55958,19.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120201/1202011400464113207.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120201/jpg/1202011400464113207.master.jpg',NULL,NULL,63935591106,NULL,NULL,NULL,'2005-03-11 10:33:34',53440.439987,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202011400464113207/1202011400464113207.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120201/1202011400464113207p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,998993611,15609275,NULL,NULL,NULL,NULL),(11443,11443,1,'CSS120129-130707+333906','CRTS-CSS',196.78109,33.65163,NULL,NULL,'2012-01-29 00:00:00',55955,19.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120129/1201291320614144078.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120129/jpg/1201291320614144078.master.jpg',NULL,NULL,58672326748,NULL,NULL,NULL,'2009-04-02 10:33:41',54923.440063,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201291320614144078/1201291320614144078.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120129/1201291320614144078p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,916755105,14324298,NULL,NULL,NULL,NULL),(11444,11444,1,'CSS120129-042806-083014','CRTS-CSS',67.02382,-8.50375,NULL,NULL,'2012-01-29 00:00:00',55955,18.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120129/1201290090244146277.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120129/jpg/1201290090244146277.master.jpg',NULL,NULL,37473346853,NULL,NULL,NULL,'2010-12-10 10:33:30',55540.439941,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201290090244146277/1201290090244146277.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120129/1201290090244146277p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,585521044,9148766,NULL,NULL,NULL,NULL),(11445,11445,1,'CSS120126-120024+361839','CRTS-CSS',180.09889,36.31082,NULL,NULL,'2012-01-26 00:00:00',55952,19.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120126/1201261350544143066.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120126/jpg/1201261350544143066.master.jpg',NULL,NULL,58537832575,NULL,NULL,NULL,'2007-02-25 13:26:23',54156.559998,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201261350544143066/1201261350544143066.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120126/1201261350544143066p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,914653633,14291463,NULL,NULL,NULL,NULL),(11446,11446,1,'CSS120125-122132+313048','CRTS-CSS',185.38248,31.51326,NULL,NULL,'2012-01-25 00:00:00',55951,20,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120125/1201251320574108485.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120125/jpg/1201251320574108485.master.jpg',NULL,NULL,58761157267,NULL,NULL,NULL,'2010-04-07 12:28:49',55293.52002,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201251320574108485/1201251320574108485.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120125/1201251320574108485p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,918143082,14345985,NULL,NULL,NULL,NULL),(11447,11447,1,'CSS120125-132526+132849','CRTS-CSS',201.35745,13.48035,NULL,NULL,'2012-01-25 00:00:00',55951,19.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120125/1201251120714139073.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120125/jpg/1201251120714139073.master.jpg',NULL,NULL,59019370300,NULL,NULL,NULL,'2010-02-19 12:28:49',55246.52002,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201251120714139073/1201251120714139073.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120125/1201251120714139073p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,922177660,14409025,NULL,NULL,NULL,NULL),(11448,11448,0,'CSS120120-155326+114437','CRTS-CSS',238.35699,11.7436,NULL,NULL,'2012-01-20 00:00:00',55946,18.23,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2020-04-05 21:19:18','http://nesssi.cacr.caltech.edu/catalina/20120120/1201201120844113010.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120120/jpg/1201201120844113010.master.jpg',NULL,NULL,56598314366,NULL,NULL,NULL,'2006-05-11 13:26:23',53866.559998,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201201120844113010/1201201120844113010.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120120/1201201120844113010p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,884348661,13817947,NULL,NULL,NULL,NULL),(11449,11449,1,'CSS120118-100630+235622','CRTS-CSS',151.62629,23.93945,NULL,NULL,'2012-01-18 00:00:00',55944,20.16,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120118/1201181230504126426.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120118/jpg/1201181230504126426.master.jpg',NULL,NULL,63686811627,NULL,NULL,NULL,'2009-12-17 10:33:41',55182.440063,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201181230504126426/1201181230504126426.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120118/1201181230504126426p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,995106431,15548537,NULL,NULL,NULL,NULL),(11450,11450,1,'CSS120103-051831-240359','CRTS-CSS',79.631,-24.06629,NULL,NULL,'2012-01-03 00:00:00',55929,18.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120103/1201030230274123794.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120103/jpg/1201030230274123794.master.jpg',NULL,NULL,37131061802,NULL,NULL,NULL,'2011-11-01 13:26:07',55866.559814,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201030230274123794/1201030230274123794.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120103/1201030230274123794p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,580172840,9065200,NULL,NULL,NULL,NULL),(11451,11451,1,'CSS120102-225743+370308','CRTS-CSS',344.43053,37.05214,NULL,NULL,'2012-01-02 00:00:00',55928,16.82,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120102/1201021380994107226.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120102/jpg/1201021380994107226.master.jpg',NULL,NULL,55516134341,NULL,NULL,NULL,'2011-11-03 13:26:07',55868.559814,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201021380994107226/1201021380994107226.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120102/1201021380994107226p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,867439599,13553743,NULL,NULL,NULL,NULL),(11452,11452,1,'CSS120102-094929+305238','CRTS-CSS',147.3724,30.87727,NULL,NULL,'2012-01-02 00:00:00',55928,19.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120102/1201021290474146697.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120102/jpg/1201021290474146697.master.jpg',NULL,NULL,64218929703,NULL,NULL,NULL,'2007-12-06 11:31:10',54440.47998,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201021290474146697/1201021290474146697.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120102/1201021290474146697p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1003420776,15678449,NULL,NULL,NULL,NULL),(11453,11453,1,'CSS120101-150931+201558','CRTS-CSS',227.37757,20.26613,NULL,NULL,'2012-01-01 00:00:00',55927,19.82,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120101/1201011210774111284.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120101/jpg/1201011210774111284.master.jpg',NULL,NULL,59537958208,NULL,NULL,NULL,'2008-06-08 10:33:41',54625.440063,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201011210774111284/1201011210774111284.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120101/1201011210774111284p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,930280597,14535634,NULL,NULL,NULL,NULL),(11454,11454,1,'CSS111229-115456+272219','CRTS-CSS',178.73262,27.37194,NULL,NULL,'2011-12-29 00:00:00',55924,20.04,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111229/1112291260584131842.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111229/jpg/1112291260584131842.master.jpg',NULL,NULL,60591548145,NULL,NULL,NULL,'2005-04-01 10:33:34',53461.439987,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112291260584131842/1112291260584131842.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111229/1112291260584131842p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,946742939,14792858,NULL,NULL,NULL,NULL),(11455,11455,1,'CSS111228-012447-100545','CRTS-CSS',21.1946,-10.09597,NULL,NULL,'2011-12-28 00:00:00',55923,19.5,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111228/1112280090084117291.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111228/jpg/1112280090084117291.master.jpg',NULL,NULL,35278577001,NULL,NULL,NULL,'2011-10-16 12:28:49',55850.52002,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112280090084117291/1112280090084117291.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111228/1112280090084117291p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,551227765,8612933,NULL,NULL,NULL,NULL),(11457,11457,1,'CSS111127-002902+062408','CRTS-CSS',7.2603,6.40209,NULL,NULL,'2011-11-27 00:00:00',55892,19.37,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:06','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111127/1111271070034113062.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111127/jpg/1111271070034113062.master.jpg',NULL,NULL,66825033807,NULL,NULL,NULL,'2006-09-17 10:33:36',53995.440002,'2013-01-19 01:32:06','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111271070034113062/1111271070034113062.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111127/1111271070034113062p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1044141153,16314705,NULL,NULL,NULL,NULL),(11458,11458,1,'CSS111101-045338-215202','CRTS-CSS',73.40669,-21.86723,NULL,NULL,'2011-11-01 00:00:00',55866,19.74,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111101/1111010210254112004.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111101/jpg/1111010210254112004.master.jpg',NULL,NULL,37344720895,NULL,NULL,NULL,'2011-02-10 13:26:07',55602.559814,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111010210254112004/1111010210254112004.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111101/1111010210254112004p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,583511263,9117363,NULL,NULL,NULL,NULL),(11459,11459,1,'CSS111028-231737-023807','CRTS-CSS',349.40343,-2.63514,NULL,NULL,'2011-10-28 00:00:00',55862,19.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111028/1110280011254102820.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111028/jpg/1110280011254102820.master.jpg',NULL,NULL,49628486754,NULL,NULL,NULL,'2010-11-27 13:26:07',55527.559814,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110280011254102820/1110280011254102820.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111028/1110280011254102820p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,775445105,12116329,NULL,NULL,NULL,NULL),(11460,11460,1,'CSS111027-075959+211936','CRTS-CSS',119.99694,21.32674,NULL,NULL,'2011-10-27 00:00:00',55861,18.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111027/1110271210414133893.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111027/jpg/1110271210414133893.master.jpg',NULL,NULL,63768177067,NULL,NULL,NULL,'2005-10-12 13:26:23',53655.559998,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110271210414133893/1110271210414133893.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111027/1110271210414133893p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,996377766,15568402,NULL,NULL,NULL,NULL),(11461,11461,0,'CSS111021-183500+543315','CRTS-CSS',278.74804,54.55409,NULL,NULL,'2011-10-21 00:00:00',55855,18.14,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-12-24 20:38:21','http://nesssi.cacr.caltech.edu/catalina/20111021/1110211550594121474.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111021/jpg/1110211550594121474.master.jpg',NULL,NULL,52924737464,NULL,NULL,NULL,'2011-06-02 13:26:07',55714.559814,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110211550594121474/1110211550594121474.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111021/1110211550594121474p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,826949022,12921078,NULL,NULL,NULL,NULL),(11463,11463,1,'CSS110919-225934+103631','CRTS-CSS',344.89024,10.60865,NULL,NULL,'2011-09-19 00:00:00',55823,19.41,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110919/1109191091224136211.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110919/jpg/1109191091224136211.master.jpg',NULL,NULL,52444367213,NULL,NULL,NULL,'2009-08-27 10:33:41',55070.440063,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1109191091224136211/1109191091224136211.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110919/1109191091224136211p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,819443237,12803800,NULL,NULL,NULL,NULL),(11464,11464,1,'CSS110612-114819+150815','CRTS-CSS',177.07999,15.13758,NULL,NULL,'2011-06-12 00:00:00',55724,19.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110612/1106121150614113883.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110612/jpg/1106121150614113883.master.jpg',NULL,NULL,60253909525,NULL,NULL,NULL,'2008-03-03 10:33:41',54528.440063,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106121150614113883/1106121150614113883.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110612/1106121150614113883p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,941467336,14710427,NULL,NULL,NULL,NULL),(11465,11465,1,'CSS110603-163035-134225','CRTS-CSS',247.64611,-13.70685,NULL,NULL,'2011-06-03 00:00:00',55715,18.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110603/1106030120874113978.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110603/jpg/1106030120874113978.master.jpg',NULL,NULL,46122279772,NULL,NULL,NULL,'2007-04-15 13:26:23',54205.559998,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106030120874113978/1106030120874113978.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110603/1106030120874113978p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,720660621,11260322,NULL,NULL,NULL,NULL),(11466,11466,1,'CSS110525-144843+222652','CRTS-CSS',222.17995,22.44788,NULL,NULL,'2011-05-25 00:00:00',55706,19.51,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110525/1105251210754139550.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110525/jpg/1105251210754139550.master.jpg',NULL,NULL,59505749153,NULL,NULL,NULL,'2009-01-30 10:33:41',54861.440063,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105251210754139550/1105251210754139550.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110525/1105251210754139550p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,929777330,14527770,NULL,NULL,NULL,NULL),(11467,11467,1,'CSS110426-121815-181144','CRTS-CSS',184.56317,-18.19568,NULL,NULL,'2011-04-26 00:00:00',55677,19.47,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110426/1104260180644122337.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110426/jpg/1104260180644122337.master.jpg',NULL,NULL,43021540316,NULL,NULL,NULL,'2006-03-24 10:33:36',53818.440002,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104260180644122337/1104260180644122337.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110426/1104260180644122337p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,672211567,10503305,NULL,NULL,NULL,NULL),(11468,11468,1,'CSS110426-114918-182313','CRTS-CSS',177.32336,-18.38698,NULL,NULL,'2011-04-26 00:00:00',55677,19.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110426/1104260180614119649.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110426/jpg/1104260180614119649.master.jpg',NULL,NULL,40949268613,NULL,NULL,NULL,'2011-03-10 13:26:07',55630.559814,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104260180614119649/1104260180614119649.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110426/1104260180614119649p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,639832322,9997380,NULL,NULL,NULL,NULL),(11469,11469,1,'CSS110426-113920-120351','CRTS-CSS',174.83378,-12.0643,NULL,NULL,'2011-04-26 00:00:00',55677,19.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110426/1104260120624130098.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110426/jpg/1104260120624130098.master.jpg',NULL,NULL,40957444653,NULL,NULL,NULL,'2011-04-01 13:26:07',55652.559814,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104260120624130098/1104260120624130098.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110426/1104260120624130098p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,639960072,9999376,NULL,NULL,NULL,NULL),(11470,11470,1,'CSS110426-114158-083528','CRTS-CSS',175.49305,-8.59116,NULL,NULL,'2011-04-26 00:00:00',55677,18.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110426/1104260090624137455.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110426/jpg/1104260090624137455.master.jpg',NULL,NULL,41033429206,NULL,NULL,NULL,'2011-04-01 13:26:07',55652.559814,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104260090624137455/1104260090624137455.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110426/1104260090624137455p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,641147331,10017927,NULL,NULL,NULL,NULL),(11471,11471,0,'CSS110425-170117+231513','CRTS-CSS',255.3217,23.25358,NULL,NULL,'2011-04-25 00:00:00',55676,18.08,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-12-24 20:38:21','http://nesssi.cacr.caltech.edu/catalina/20110425/1104251230844112098.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110425/jpg/1104251230844112098.master.jpg',NULL,NULL,56674235899,NULL,NULL,NULL,'2011-04-14 13:26:07',55665.559814,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104251230844112098/1104251230844112098.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110425/1104251230844112098p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,885534935,13836483,NULL,NULL,NULL,NULL),(11472,11472,1,'CSS110408-125655+362240','CRTS-CSS',194.22935,36.37765,NULL,NULL,'2011-04-08 00:00:00',55659,19.56,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110408/1104081350584137229.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110408/jpg/1104081350584137229.master.jpg',NULL,NULL,59073187069,NULL,NULL,NULL,'2006-02-04 13:26:23',53770.559998,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104081350584137229/1104081350584137229.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110408/1104081350584137229p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,923018547,14422164,NULL,NULL,NULL,NULL),(11473,11473,1,'CSS110326-122937+323333','CRTS-CSS',187.40624,32.5593,NULL,NULL,'2011-03-26 00:00:00',55646,20.12,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110326/1103261320584123035.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110326/jpg/1103261320584123035.master.jpg',NULL,NULL,58772499672,NULL,NULL,NULL,'2011-03-01 11:31:10',55621.47998,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103261320584123035/1103261320584123035.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110326/1103261320584123035p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,918320307,14348754,NULL,NULL,NULL,NULL),(11474,11474,1,'CSS110324-101504+103708','CRTS-CSS',153.76845,10.61897,NULL,NULL,'2011-03-24 00:00:00',55644,19.55,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110324/1103241090554135108.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110324/jpg/1103241090554135108.master.jpg',NULL,NULL,60871285817,NULL,NULL,NULL,'2006-01-20 10:33:36',53755.440002,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103241090554135108/1103241090554135108.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110324/1103241090554135108p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,951113840,14861153,NULL,NULL,NULL,NULL),(11475,11475,1,'CSS110313-133337-175307','CRTS-CSS',203.40356,-17.88525,NULL,NULL,'2011-03-13 00:00:00',55633,17.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110313/1103130180704131543.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110313/jpg/1103130180704131543.master.jpg',NULL,NULL,43782677423,NULL,NULL,NULL,'2006-05-08 13:26:23',53863.559998,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103130180704131543/1103130180704131543.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110313/1103130180704131543p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,684104334,10689130,NULL,NULL,NULL,NULL),(11476,11476,1,'CSS110313-130445-021253','CRTS-CSS',196.1884,-2.21459,NULL,NULL,'2011-03-13 00:00:00',55633,20.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110313/1103130010704109438.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110313/jpg/1103130010704109438.master.jpg',NULL,NULL,43145824877,NULL,NULL,NULL,'2010-06-04 10:33:30',55351.439941,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103130010704109438/1103130010704109438.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110313/1103130010704109438p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,674153513,10533648,NULL,NULL,NULL,NULL),(11477,11477,1,'CSS110311-091704+103438','CRTS-CSS',139.26766,10.5773,NULL,NULL,'2011-03-11 00:00:00',55631,20.31,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110311/1103111090504132096.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110311/jpg/1103111090504132096.master.jpg',NULL,NULL,63652630697,NULL,NULL,NULL,'2011-02-04 13:26:07',55596.559814,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103111090504132096/1103111090504132096.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110311/1103111090504132096p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,994572354,15540193,NULL,NULL,NULL,NULL),(11478,11478,1,'CSS110302-125334-053143','CRTS-CSS',193.39062,-5.52858,NULL,NULL,'2011-03-02 00:00:00',55622,19.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:07','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110302/1103020040694102816.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110302/jpg/1103020040694102816.master.jpg',NULL,NULL,43136049020,NULL,NULL,NULL,'2010-04-04 11:31:10',55290.47998,'2013-01-19 01:32:07','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103020040694102816/1103020040694102816.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110302/1103020040694102816p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,674000765,10531261,NULL,NULL,NULL,NULL),(11479,11479,1,'CSS110301-141650+330147','CRTS-CSS',214.20702,33.02984,NULL,NULL,'2011-03-01 00:00:00',55621,20.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110301/1103011320664136360.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110301/jpg/1103011320664136360.master.jpg',NULL,NULL,60034241357,NULL,NULL,NULL,'2009-03-17 10:33:41',54907.440063,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103011320664136360/1103011320664136360.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110301/1103011320664136360p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,938035021,14656797,NULL,NULL,NULL,NULL),(11480,11480,1,'CSS110226-101947+282929','CRTS-CSS',154.94486,28.49144,NULL,NULL,'2011-02-26 00:00:00',55618,20.46,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110226/1102261290494105303.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110226/jpg/1102261290494105303.master.jpg',NULL,NULL,64036912059,NULL,NULL,NULL,'2006-01-05 11:31:10',53740.47998,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102261290494105303/1102261290494105303.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110226/1102261290494105303p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1000576750,15634011,NULL,NULL,NULL,NULL),(11481,11481,1,'CSS110212-151144-052227','CRTS-CSS',227.93287,-5.37415,NULL,NULL,'2011-02-12 00:00:00',55604,18.9,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110212/1102120040824106911.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110212/jpg/1102120040824106911.master.jpg',NULL,NULL,46448517482,NULL,NULL,NULL,'2009-01-31 13:26:29',54862.560059,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102120040824106911/1102120040824106911.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110212/1102120040824106911p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,725758085,11339970,NULL,NULL,NULL,NULL),(11482,11482,1,'CSS110207-095759-160101','CRTS-CSS',149.49587,-16.01698,NULL,NULL,'2011-02-07 00:00:00',55599,17.38,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110207/1102070150524121000.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110207/jpg/1102070150524121000.master.jpg',NULL,NULL,41195269257,NULL,NULL,NULL,'2005-12-25 10:33:36',53729.440002,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102070150524121000/1102070150524121000.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110207/1102070150524121000p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,643676082,10057438,NULL,NULL,NULL,NULL),(11483,11483,1,'CSS110115-003640+405143','CRTS-CSS',9.16834,40.86193,NULL,NULL,'2011-01-15 00:00:00',55576,17.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110115/1101151400034126054.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110115/jpg/1101151400034126054.master.jpg',NULL,NULL,67704849199,NULL,NULL,NULL,'2010-11-15 13:26:07',55515.559814,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101151400034126054/1101151400034126054.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110115/1101151400034126054p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1057888268,16529504,NULL,NULL,NULL,NULL),(11484,11484,1,'CSS110108-101613+262924','CRTS-CSS',154.05483,26.48989,NULL,NULL,'2011-01-08 00:00:00',55569,20.3,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110108/1101081260504117653.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110108/jpg/1101081260504117653.master.jpg',NULL,NULL,64025917385,NULL,NULL,NULL,'2009-05-24 12:28:49',54975.52002,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101081260504117653/1101081260504117653.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110108/1101081260504117653p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1000404959,15631327,NULL,NULL,NULL,NULL),(11485,11485,1,'CSS110103-045604+303433','CRTS-CSS',74.0179,30.57588,NULL,NULL,'2011-01-03 00:00:00',55564,17.35,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110103/1101031290244193081.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110103/jpg/1101031290244193081.master.jpg',NULL,NULL,64804774317,NULL,NULL,NULL,'2005-12-21 13:26:23',53725.559998,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101031290244193081/1101031290244193081.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110103/1101031290244193081p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,1012574598,15821478,NULL,NULL,NULL,NULL),(11486,11486,1,'CSS101213-010821-152608','CRTS-CSS',17.08718,-15.43569,NULL,NULL,'2010-12-13 00:00:00',55543,18.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101213/1012130150064120119.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101213/jpg/1012130150064120119.master.jpg',NULL,NULL,35431765229,NULL,NULL,NULL,'2005-10-24 10:33:36',53667.440002,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1012130150064120119/1012130150064120119.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101213/1012130150064120119p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,553621331,8650333,NULL,NULL,NULL,NULL),(11487,11487,1,'CSS101209-005735+210444','CRTS-CSS',14.39707,21.07885,NULL,NULL,'2010-12-09 00:00:00',55539,19.69,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101209/1012091210054124208.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101209/jpg/1012091210054124208.master.jpg',NULL,NULL,67615387689,NULL,NULL,NULL,'2005-10-08 10:33:36',53651.440002,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1012091210054124208/1012091210054124208.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101209/1012091210054124208p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1056490432,16507663,NULL,NULL,NULL,NULL),(11488,11488,1,'CSS101115-052434+001319','CRTS-CSS',81.14287,0.22195,NULL,NULL,'2010-11-15 00:00:00',55515,18.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101115/1011151010294107505.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101115/jpg/1011151010294107505.master.jpg',NULL,NULL,64459292416,NULL,NULL,NULL,'2010-11-01 13:26:07',55501.559814,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011151010294107505/1011151010294107505.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101115/1011151010294107505p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1007176444,15737131,NULL,NULL,NULL,NULL),(11489,11489,1,'CSS101114-010252+002740','CRTS-CSS',15.71507,0.46106,NULL,NULL,'2010-11-14 00:00:00',55514,19.82,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101114/1011141010064107249.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101114/jpg/1011141010064107249.master.jpg',NULL,NULL,66677545645,NULL,NULL,NULL,'2006-09-18 10:33:36',53996.440002,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011141010064107249/1011141010064107249.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101114/1011141010064107249p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,1041836650,16278697,NULL,NULL,NULL,NULL),(11490,11490,1,'CSS101106-041337+102055','CRTS-CSS',63.40421,10.3486,NULL,NULL,'2010-11-06 00:00:00',55506,19.67,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101106/1011061090234135036.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101106/jpg/1011061090234135036.master.jpg',NULL,NULL,65165505038,NULL,NULL,NULL,'2010-10-12 13:26:07',55481.559814,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011061090234135036/1011061090234135036.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101106/1011061090234135036p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1018211016,15909547,NULL,NULL,NULL,NULL),(11491,11491,1,'CSS101101-034352+154025','CRTS-CSS',55.96472,15.67365,NULL,NULL,'2010-11-01 00:00:00',55501,18.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101101/1011011150204123200.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101101/jpg/1011011150204123200.master.jpg',NULL,NULL,68021353544,NULL,NULL,NULL,'2010-10-19 13:26:07',55488.559814,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011011150204123200/1011011150204123200.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101101/1011011150204123200p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1062833649,16606775,NULL,NULL,NULL,NULL),(11492,11492,1,'CSS101011-200233-205500','CRTS-CSS',300.6365,-20.91672,NULL,NULL,'2010-10-11 00:00:00',55480,17.58,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101011/1010110211024156476.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101011/jpg/1010110211024156476.master.jpg',NULL,NULL,50811193189,NULL,NULL,NULL,'2008-10-30 12:28:49',54769.52002,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010110211024156476/1010110211024156476.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101011/1010110211024156476p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,793924893,12405076,NULL,NULL,NULL,NULL),(11493,11493,0,'CSS101007-233448-125038','CRTS-CSS',353.69815,-12.84397,NULL,NULL,'2010-10-07 00:00:00',55476,19.81,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101007/1010070121244121561.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101007/jpg/1010070121244121561.master.jpg',NULL,NULL,49570745877,NULL,NULL,NULL,'2010-09-10 10:33:30',55449.439941,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010070121244121561/1010070121244121561.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101007/1010070121244121561p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,774542904,12102232,NULL,NULL,NULL,NULL),(11494,11494,1,'CSS101003-031352+023954','CRTS-CSS',48.46828,2.66509,NULL,NULL,'2010-10-03 00:00:00',55472,19.11,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101003/1010031010184135661.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101003/jpg/1010031010184135661.master.jpg',NULL,NULL,64977870999,NULL,NULL,NULL,'2009-12-20 13:26:29',55185.560059,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010031010184135661/1010031010184135661.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101003/1010031010184135661p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1015279234,15863738,NULL,NULL,NULL,NULL),(11495,11495,1,'CSS101001-025125+251816','CRTS-CSS',42.85414,25.30447,NULL,NULL,'2010-10-01 00:00:00',55470,19.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101001/1010011230154142022.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101001/jpg/1010011230154142022.master.jpg',NULL,NULL,68602573488,NULL,NULL,NULL,'2010-09-14 13:26:07',55453.559814,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010011230154142022/1010011230154142022.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101001/1010011230154142022p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1071915210,16748675,NULL,NULL,NULL,NULL),(11496,11496,1,'CSS101001-050943+212929','CRTS-CSS',77.43001,21.49136,NULL,NULL,'2010-10-01 00:00:00',55470,18.54,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101001/1010011210274162919.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101001/jpg/1010011210274162919.master.jpg',NULL,NULL,65382026373,NULL,NULL,NULL,'2009-04-19 13:26:29',54940.560059,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010011210274162919/1010011210274162919.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101001/1010011210274162919p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,1021594162,15962408,NULL,NULL,NULL,NULL),(11497,11497,1,'CSS100705-132620-103120','CRTS-CSS',201.58373,-10.52226,NULL,NULL,'2010-07-05 00:00:00',55382,17.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:08','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100705/1007050090724111231.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100705/jpg/1007050090724111231.master.jpg',NULL,NULL,43869990576,NULL,NULL,NULL,'2008-04-24 13:26:29',54580.560059,'2013-01-19 01:32:08','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1007050090724111231/1007050090724111231.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100705/1007050090724111231p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,685468602,10710446,NULL,NULL,NULL,NULL),(11498,11498,1,'CSS100704-164404+254015','CRTS-CSS',251.01592,25.67082,NULL,NULL,'2010-07-04 00:00:00',55381,20.06,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100704/1007041260814105618.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100704/jpg/1007041260814105618.master.jpg',NULL,NULL,56232693116,NULL,NULL,NULL,'2006-05-11 13:26:23',53866.559998,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1007041260814105618/1007041260814105618.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100704/1007041260814105618p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,878635829,13728684,NULL,NULL,NULL,NULL),(11499,11499,1,'CSS100616-153417-035539','CRTS-CSS',233.5705,-3.92762,NULL,NULL,'2010-06-16 00:00:00',55363,17.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100616/1006160040844142308.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100616/jpg/1006160040844142308.master.jpg',NULL,NULL,45410087612,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006160040844142308/1006160040844142308.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100616/1006160040844142308p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,709532618,11086447,NULL,NULL,NULL,NULL),(11500,11500,1,'CSS100612-181902+342711','CRTS-CSS',274.75981,34.45315,NULL,NULL,'2010-06-12 00:00:00',55359,17.04,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100612/1006121350814122213.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100612/jpg/1006121350814122213.master.jpg',NULL,NULL,54247431141,NULL,NULL,NULL,'2010-05-23 13:26:07',55339.559814,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006121350814122213/1006121350814122213.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100612/1006121350814122213p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,847616111,13244001,NULL,NULL,NULL,NULL),(11501,11501,1,'CSS100612-133053+332258','CRTS-CSS',202.72152,33.38285,NULL,NULL,'2010-06-12 00:00:00',55359,18.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100612/1006121320624133575.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100612/jpg/1006121320624133575.master.jpg',NULL,NULL,59179758111,NULL,NULL,NULL,'2010-06-08 10:33:30',55355.439941,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006121320624133575/1006121320624133575.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100612/1006121320624133575p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,924683720,14448183,NULL,NULL,NULL,NULL),(11502,11502,1,'CSS100611-213147+200216','CRTS-CSS',322.94566,20.03788,NULL,NULL,'2010-06-11 00:00:00',55358,18.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100611/1006111211094112014.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100611/jpg/1006111211094112014.master.jpg',NULL,NULL,55148032960,NULL,NULL,NULL,'2006-10-22 12:28:49',54030.52002,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006111211094112014/1006111211094112014.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100611/1006111211094112014p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,861688015,13463875,NULL,NULL,NULL,NULL),(11503,11503,1,'CSS100610-165655-032616','CRTS-CSS',254.23091,-3.43772,NULL,NULL,'2010-06-10 00:00:00',55357,16.43,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100610/1006100040914187524.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100610/jpg/1006100040914187524.master.jpg',NULL,NULL,45227844560,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006100040914187524/1006100040914187524.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100610/1006100040914187524p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,706685071,11041954,NULL,NULL,NULL,NULL),(11504,11504,1,'CSS100531-150714-122258','CRTS-CSS',226.80872,-12.38291,NULL,NULL,'2010-05-31 00:00:00',55347,17.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100531/1005310120804134102.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100531/jpg/1005310120804134102.master.jpg',NULL,NULL,46662186543,NULL,NULL,NULL,'2010-05-16 13:26:07',55332.559814,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005310120804134102/1005310120804134102.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100531/1005310120804134102p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,729096664,11392135,NULL,NULL,NULL,NULL),(11505,11505,1,'CSS100407-092802+321644','CRTS-CSS',142.00669,32.27886,NULL,NULL,'2010-04-07 00:00:00',55293,20.16,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100407/1004071320444118377.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100407/jpg/1004071320444118377.master.jpg',NULL,NULL,64207182351,NULL,NULL,NULL,'2005-04-21 10:33:34',53481.439987,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1004071320444118377/1004071320444118377.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100407/1004071320444118377p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1003237224,15675581,NULL,NULL,NULL,NULL),(11506,11506,1,'CSS100319-150726+170853','CRTS-CSS',226.8568,17.14802,NULL,NULL,'2010-03-19 00:00:00',55274,19.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100319/1003191180784104664.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100319/jpg/1003191180784104664.master.jpg',NULL,NULL,59582871257,NULL,NULL,NULL,'2007-01-17 11:31:15',54117.480042,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003191180784104664/1003191180784104664.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100319/1003191180784104664p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,930982363,14546599,NULL,NULL,NULL,NULL),(11507,11507,1,'CSS100217-111001+362503','CRTS-CSS',167.50408,36.41747,NULL,NULL,'2010-02-17 00:00:00',55244,19.36,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100217/1002171350504148201.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100217/jpg/1002171350504148201.master.jpg',NULL,NULL,60418825068,NULL,NULL,NULL,'2009-12-17 13:26:29',55182.560059,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1002171350504148201/1002171350504148201.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100217/1002171350504148201p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,944044141,14750689,NULL,NULL,NULL,NULL),(11508,11508,1,'CSS100112-050754+275059','CRTS-CSS',76.97292,27.84968,NULL,NULL,'2010-01-12 00:00:00',55208,17.33,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100112/1001121260254191987.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100112/jpg/1001121260254191987.master.jpg',NULL,NULL,64904559492,NULL,NULL,NULL,'2007-10-19 10:33:41',54392.440063,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1001121260254191987/1001121260254191987.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100112/1001121260254191987p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,1014133742,15845839,NULL,NULL,NULL,NULL),(11509,11509,1,'CSS100112-130040+185009','CRTS-CSS',195.1651,18.83572,NULL,NULL,'2010-01-12 00:00:00',55208,20.35,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100112/1001121180674133895.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100112/jpg/1001121180674133895.master.jpg',NULL,NULL,59035725727,NULL,NULL,NULL,'2009-07-30 13:26:29',55042.560059,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1001121180674133895/1001121180674133895.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100112/1001121180674133895p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,922433214,14413018,NULL,NULL,NULL,NULL),(11510,11510,1,'CSS100112-124712+175651','CRTS-CSS',191.79942,17.94746,NULL,NULL,'2010-01-12 00:00:00',55208,18.9,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100112/1001121180664117609.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100112/jpg/1001121180664117609.master.jpg',NULL,NULL,58905017950,NULL,NULL,NULL,'2009-11-25 13:26:29',55160.560059,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1001121180664117609/1001121180664117609.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100112/1001121180664117609p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,920390905,14381107,NULL,NULL,NULL,NULL),(11511,11511,1,'CSS100108-042214+102805','CRTS-CSS',65.55724,10.46798,NULL,NULL,'2010-01-08 00:00:00',55204,20.06,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100108/1001081090244138097.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100108/jpg/1001081090244138097.master.jpg',NULL,NULL,65048700968,NULL,NULL,NULL,'2009-12-11 13:26:29',55176.560059,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1001081090244138097/1001081090244138097.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100108/1001081090244138097p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1016385952,15881030,NULL,NULL,NULL,NULL),(11512,11512,1,'CSS091217-095843+424818','CRTS-CSS',149.68,42.80497,NULL,NULL,'2009-12-17 00:00:00',55182,19.31,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20091217/912171430404106875.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091217/jpg/912171430404106875.master.jpg',NULL,NULL,64102643026,NULL,NULL,NULL,'2005-03-11 13:26:23',53440.559998,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/912171430404106875/912171430404106875.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091217/912171430404106875p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1001603797,15650059,NULL,NULL,NULL,NULL),(11513,11513,1,'CSS091117-005036-202111','CRTS-CSS',12.64904,-20.35305,NULL,NULL,'2009-11-17 00:00:00',55152,19.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20091117/911170210054133098.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091117/jpg/911170210054133098.master.jpg',NULL,NULL,35322438726,NULL,NULL,NULL,'2009-10-22 13:26:29',55126.560059,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/911170210054133098/911170210054133098.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091117/911170210054133098p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,551913105,8623642,NULL,NULL,NULL,NULL),(11514,11514,1,'CSS091117-002501-204312','CRTS-CSS',6.25451,-20.72012,NULL,NULL,'2009-11-17 00:00:00',55152,19.08,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20091117/911170210034128706.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091117/jpg/911170210034128706.master.jpg',NULL,NULL,35304668534,NULL,NULL,NULL,'2009-10-22 13:26:29',55126.560059,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/911170210034128706/911170210034128706.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091117/911170210034128706p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,551635445,8619303,NULL,NULL,NULL,NULL),(11515,11515,1,'CSS091116-080454+370751','CRTS-CSS',121.22584,37.13093,NULL,NULL,'2009-11-16 00:00:00',55151,17.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20091116/911161380354109438.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091116/jpg/911161380354109438.master.jpg',NULL,NULL,63437766892,NULL,NULL,NULL,'2009-10-26 13:26:29',55130.560059,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/911161380354109438/911161380354109438.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091116/911161380354109438p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,991215107,15487736,NULL,NULL,NULL,NULL),(11517,11517,1,'CSS130117-092058+032151','CRTS-CSS',140.24263,3.36424,NULL,NULL,'2013-01-17 00:00:00',56309,12.55,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:09','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130117/1301171040504112807.html','HPM LHS_267      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130117/jpg/1301171040504112807.master.jpg',NULL,NULL,60729363658,NULL,NULL,NULL,'2009-04-24 10:33:41',54945.440063,'2013-01-19 01:32:09','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301171040504112807/1301171040504112807.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130117/1301171040504112807p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,948896307,14826504,NULL,NULL,NULL,NULL),(11518,11518,1,'CSS130116-093206+275641','CRTS-CSS',143.02477,27.94469,NULL,NULL,'2013-01-16 00:00:00',56308,20.1,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:10','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130116/1301161260474144339.html','Unknown SDSS mag 21,4    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130116/jpg/1301161260474144339.master.jpg',NULL,NULL,64213627113,NULL,NULL,NULL,'2011-03-05 11:31:10',55625.47998,'2013-01-19 01:32:10','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301161260474144339/1301161260474144339.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130116/1301161260474144339p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1003337923,15677155,NULL,NULL,NULL,NULL),(11519,11519,1,'CSS130113-014024-113511','CRTS-CSS',25.09964,-11.58628,NULL,NULL,'2013-01-13 00:00:00',56305,19.03,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:10','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130113/1301130120094138246.html','Var 20,2      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130113/jpg/1301130120094138246.master.jpg',NULL,NULL,35098817747,NULL,NULL,NULL,'2006-12-22 13:26:23',54091.559998,'2013-01-19 01:32:10','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301130120094138246/1301130120094138246.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130113/1301130120094138246p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,548419027,8569047,NULL,NULL,NULL,NULL),(11520,11520,1,'CSS130113-060614-022258','CRTS-CSS',91.56,-2.38284,NULL,NULL,'2013-01-13 00:00:00',56305,18.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:10','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130113/1301130010334119217.html','Unknown mag >21     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130113/jpg/1301130010334119217.master.jpg',NULL,NULL,38670922686,NULL,NULL,NULL,'2012-03-22 13:26:07',56008.559814,'2013-01-19 01:32:10','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301130010334119217/1301130010334119217.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130113/1301130010334119217p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,604233166,9441143,NULL,NULL,NULL,NULL),(11521,11521,1,'CSS130110-092910+255806','CRTS-CSS',142.29199,25.96821,NULL,NULL,'2013-01-10 00:00:00',56302,14.4,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:10','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130110/1301101260464109475.html','HPM LHS_269      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130110/jpg/1301101260464109475.master.jpg',NULL,NULL,64197321569,NULL,NULL,NULL,'2009-04-19 10:33:41',54940.440063,'2013-01-19 01:32:10','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301101260464109475/1301101260464109475.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130110/1301101260464109475p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1003083149,15673174,NULL,NULL,NULL,NULL),(11522,11522,1,'CSS130110-085413-080511','CRTS-CSS',133.55469,-8.0865,NULL,NULL,'2013-01-10 00:00:00',56302,15.03,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:10','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130110/1301100070484108784.html','HPM LHS_254      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130110/jpg/1301100070484108784.master.jpg',NULL,NULL,42204546704,NULL,NULL,NULL,'2009-04-30 10:33:41',54951.440063,'2013-01-19 01:32:10','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301100070484108784/1301100070484108784.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130110/1301100070484108784p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,659446042,10303844,NULL,NULL,NULL,NULL),(11523,11523,1,'CSS130106-095512+174252','CRTS-CSS',148.80114,17.71437,NULL,NULL,'2013-01-06 00:00:00',56298,19.45,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:10','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130106/1301061180514114118.html','Unknown mag 21,0     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130106/jpg/1301061180514114118.master.jpg',NULL,NULL,60859442961,NULL,NULL,NULL,'2009-02-05 10:33:41',54867.440063,'2013-01-19 01:32:10','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301061180514114118/1301061180514114118.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130106/1301061180514114118p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,950928796,14858262,NULL,NULL,NULL,NULL),(11524,11524,1,'CSS130106-013658+093347','CRTS-CSS',24.24024,9.56306,NULL,NULL,'2013-01-06 00:00:00',56298,19.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:10','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130106/1301061090094117234.html','HPM 2MASS_J013656      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130106/jpg/1301061090094117234.master.jpg',NULL,NULL,67009417885,NULL,NULL,NULL,'2010-01-06 12:28:49',55202.52002,'2013-01-19 01:32:10','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301061090094117234/1301061090094117234.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130106/1301061090094117234p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1047022154,16359721,NULL,NULL,NULL,NULL),(11525,11525,1,'CSS130103-071358+495308','CRTS-CSS',108.49352,49.88554,NULL,NULL,'2013-01-03 00:00:00',56295,17.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:10','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130103/1301031490264148655.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130103/jpg/1301031490264148655.master.jpg',NULL,NULL,63387878435,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:10','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301031490264148655/1301031490264148655.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130103/1301031490264148655p.html',NULL,NULL,0,'AGN',NULL,0,NULL,0,990435600,15475556,NULL,NULL,NULL,NULL),(11527,11527,1,'CSS121220-110121+030012','CRTS-CSS',165.33587,3.00322,NULL,NULL,'2012-12-20 00:00:00',56281,12.84,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:10','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121220/1212201040594103839.html','HPM LHS_296      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121220/jpg/1212201040594103839.master.jpg',NULL,NULL,60327919069,NULL,NULL,NULL,'2009-05-15 10:33:41',54966.440063,'2013-01-19 01:32:10','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212201040594103839/1212201040594103839.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121220/1212201040594103839p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,942623735,14728495,NULL,NULL,NULL,NULL),(11530,11530,1,'CSS121212-025025+070218','CRTS-CSS',42.60218,7.03845,NULL,NULL,'2012-12-12 00:00:00',56273,19.46,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:10','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121212/1212121070164123828.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121212/jpg/1212121070164123828.master.jpg',NULL,NULL,67972680279,NULL,NULL,NULL,'2012-11-22 11:31:10',56253.47998,'2013-01-19 01:32:10','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212121070164123828/1212121070164123828.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121212/1212121070164123828p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1062073129,16594892,NULL,NULL,NULL,NULL),(11532,11532,1,'CSS121204-054618+001212','CRTS-CSS',86.57505,0.20332,NULL,NULL,'2012-12-04 00:00:00',56265,15.74,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:10','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121204/1212041010314105958.html','YSO mag 17,0     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121204/jpg/1212041010314105958.master.jpg',NULL,NULL,64434860613,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:10','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212041010314105958/1212041010314105958.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121204/1212041010314105958p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1006794697,15731167,NULL,NULL,NULL,NULL),(11533,11533,1,'CSS121204-060243-104736','CRTS-CSS',90.67776,-10.79332,NULL,NULL,'2012-12-04 00:00:00',56265,12.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:10','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121204/1212040090324112508.html','Mira mag 14     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121204/jpg/1212040090324112508.master.jpg',NULL,NULL,38889756313,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:10','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212040090324112508/1212040090324112508.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121204/1212040090324112508p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,607652442,9494569,NULL,NULL,NULL,NULL),(11534,11534,1,'CSS121125-102524+004251','CRTS-CSS',156.34873,0.71408,NULL,NULL,'2012-11-25 00:00:00',56256,17.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:10','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121125/1211251010564111427.html','HPM LHS_282      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121125/jpg/1211251010564111427.master.jpg',NULL,NULL,60737015499,NULL,NULL,NULL,'2009-02-19 10:33:41',54881.440063,'2013-01-19 01:32:10','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211251010564111427/1211251010564111427.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121125/1211251010564111427p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,949015867,14828372,NULL,NULL,NULL,NULL),(11535,11535,1,'CSS121124-084244+443224','CRTS-CSS',130.68288,44.54011,NULL,NULL,'2012-11-24 00:00:00',56255,12.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:10','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121124/1211241430354131229.html','HPM LHS_2041      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121124/jpg/1211241430354131229.master.jpg',NULL,NULL,64251416066,NULL,NULL,NULL,'2006-05-08 13:26:23',53863.559998,'2013-01-19 01:32:10','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211241430354131229/1211241430354131229.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121124/1211241430354131229p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1003928376,15686380,NULL,NULL,NULL,NULL),(11541,11541,1,'CSS121103-215656-015402','CRTS-CSS',329.2347,-1.90048,NULL,NULL,'2012-11-03 00:00:00',56234,12.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:11','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121103/1211030011184117219.html','HPM LHS_516      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121103/jpg/1211030011184117219.master.jpg',NULL,NULL,49827389935,NULL,NULL,NULL,'2011-11-19 13:26:07',55884.559814,'2013-01-19 01:32:11','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211030011184117219/1211030011184117219.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121103/1211030011184117219p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,778552967,12164890,NULL,NULL,NULL,NULL),(11542,11542,0,'CSS121016-013308+302259','CRTS-CSS',23.28538,30.38311,NULL,NULL,'2012-10-16 00:00:00',56216,18.98,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:11','2019-12-24 20:38:21','http://nesssi.cacr.caltech.edu/catalina/20121016/1210161290084140460.html','LPV M31 mag >21    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121016/jpg/1210161290084140460.master.jpg',NULL,NULL,67723592096,NULL,NULL,NULL,'2007-06-23 13:26:29',54274.560059,'2013-01-19 01:32:11','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210161290084140460/1210161290084140460.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121016/1210161290084140460p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1058181126,16534080,NULL,NULL,NULL,NULL),(11546,11546,1,'CSS121008-013257+302425','CRTS-CSS',23.23871,30.40685,NULL,NULL,'2012-10-08 00:00:00',56208,16.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:11','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121008/1210081290084139283.html','Nova (Nishiyama)      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121008/jpg/1210081290084139283.master.jpg',NULL,NULL,67767631929,NULL,NULL,NULL,'2012-09-27 13:26:07',56197.559814,'2013-01-19 01:32:11','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1210081290084139283/1210081290084139283.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121008/1210081290084139283p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1058869248,16544832,NULL,NULL,NULL,NULL),(11553,11553,1,'CSS120922-234318-241145','CRTS-CSS',355.82472,-24.19578,NULL,NULL,'2012-09-22 00:00:00',56192,12.52,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:11','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120922/1209220231174118379.html','HPM LHS_73      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120922/jpg/1209220231174118379.master.jpg',NULL,NULL,50004321573,NULL,NULL,NULL,'2011-11-02 13:26:07',55867.559814,'2013-01-19 01:32:11','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209220231174118379/1209220231174118379.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120922/1209220231174118379p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,781317524,12208086,NULL,NULL,NULL,NULL),(11554,11554,1,'CSS120922-221248-114256','CRTS-CSS',333.20006,-11.71561,NULL,NULL,'2012-09-22 00:00:00',56192,18.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:11','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120922/1209220121174144021.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120922/jpg/1209220121174144021.master.jpg',NULL,NULL,49864973952,NULL,NULL,NULL,'2012-09-14 13:26:07',56184.559814,'2013-01-19 01:32:11','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209220121174144021/1209220121174144021.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120922/1209220121174144021p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,779140218,12174065,NULL,NULL,NULL,NULL),(11558,11558,1,'CSS120917-223056+152357','CRTS-CSS',337.73379,15.39912,NULL,NULL,'2012-09-17 00:00:00',56187,17.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120917/1209171151174127289.html','HPM WD2228+151      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120917/jpg/1209171151174127289.master.jpg',NULL,NULL,52377242891,NULL,NULL,NULL,'2005-07-03 10:33:36',53554.440002,'2013-01-19 01:32:12','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209171151174127289/1209171151174127289.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120917/1209171151174127289p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,818394420,12787412,NULL,NULL,NULL,NULL),(11559,11559,1,'CSS120828-000010-215515','CRTS-CSS',0.04323,-21.92087,NULL,NULL,'2012-08-28 00:00:00',56167,17.02,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120828/1208280210014111715.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120828/jpg/1208280210014111715.master.jpg',NULL,NULL,34426986215,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1208280210014111715/1208280210014111715.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120828/1208280210014111715p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,537921659,8405025,NULL,NULL,NULL,NULL),(11560,11560,1,'CSS120813-163705-013211','CRTS-CSS',249.26955,-1.53646,NULL,NULL,'2012-08-13 00:00:00',56152,13.33,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120813/1208130010894127116.html','HPM PLX_3775      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120813/jpg/1208130010894127116.master.jpg',NULL,NULL,45166060556,NULL,NULL,NULL,'2011-06-22 13:26:07',55734.559814,'2013-01-19 01:32:12','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1208130010894127116/1208130010894127116.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120813/1208130010894127116p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,705719696,11026870,NULL,NULL,NULL,NULL),(11564,11564,1,'CSS120618-144707+043629','CRTS-CSS',221.77868,4.60812,NULL,NULL,'2012-06-18 00:00:00',56096,15.04,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120618/1206181040794128810.html','LPV       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120618/jpg/1206181040794128810.master.jpg',NULL,NULL,59336295414,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206181040794128810/1206181040794128810.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120618/1206181040794128810p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,927129615,14486400,NULL,NULL,NULL,NULL),(11565,11565,1,'CSS120618-230614+004135','CRTS-CSS',346.55669,0.69317,NULL,NULL,'2012-06-18 00:00:00',56096,19.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120618/1206181011244111034.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120618/jpg/1206181011244111034.master.jpg',NULL,NULL,51704303459,NULL,NULL,NULL,'2008-10-28 10:33:41',54767.440063,'2013-01-19 01:32:12','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206181011244111034/1206181011244111034.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120618/1206181011244111034p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,807879741,12623120,NULL,NULL,NULL,NULL),(11566,11566,1,'CSS120617-173203+164751','CRTS-CSS',263.01094,16.79743,NULL,NULL,'2012-06-17 00:00:00',56095,12.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120617/1206171150914202091.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120617/jpg/1206171150914202091.master.jpg',NULL,NULL,56812785769,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206171150914202091/1206171150914202091.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120617/1206171150914202091p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,887699777,13870309,NULL,NULL,NULL,NULL),(11567,11567,1,'CSS120616-225124+293946','CRTS-CSS',342.85086,29.66281,NULL,NULL,'2012-06-16 00:00:00',56094,15.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120616/1206161291084136687.html','HPM GJ_1275      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120616/jpg/1206161291084136687.master.jpg',NULL,NULL,51926748576,NULL,NULL,NULL,'2008-12-06 10:33:41',54806.440063,'2013-01-19 01:32:12','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206161291084136687/1206161291084136687.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120616/1206161291084136687p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,811355446,12677428,NULL,NULL,NULL,NULL),(11569,11569,1,'CSS120614-133652+454349','CRTS-CSS',204.21499,45.73018,NULL,NULL,'2012-06-14 00:00:00',56092,18.61,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120614/1206141460524107521.html','Unknown SDSS mag 19,1    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120614/jpg/1206141460524107521.master.jpg',NULL,NULL,59284911801,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206141460524107521/1206141460524107521.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120614/1206141460524107521p.html',NULL,NULL,0,'AGN',NULL,0,NULL,0,926326746,14473855,NULL,NULL,NULL,NULL),(11570,11570,1,'CSS120612-144052+191209','CRTS-CSS',220.21787,19.20259,NULL,NULL,'2012-06-12 00:00:00',56090,18.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120612/1206121180764135782.html','Comet C/2007_D1_LINEAR      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120612/jpg/1206121180764135782.master.jpg',NULL,NULL,59500613525,NULL,NULL,NULL,'2012-05-14 13:26:07',56061.559814,'2013-01-19 01:32:12','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206121180764135782/1206121180764135782.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120612/1206121180764135782p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,929697086,14526516,NULL,NULL,NULL,NULL),(11571,11571,0,'CSS120612-201734-033951','CRTS-CSS',304.39115,-3.66415,NULL,NULL,'2012-06-12 00:00:00',56090,14.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','2019-12-24 20:38:21','http://nesssi.cacr.caltech.edu/catalina/20120612/1206120041094189989.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120612/jpg/1206120041094189989.master.jpg',NULL,NULL,48026019076,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206120041094189989/1206120041094189989.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120612/1206120041094189989p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,750406548,11725102,NULL,NULL,NULL,NULL),(11572,11572,1,'CSS120611-110710+465625','CRTS-CSS',166.7921,46.94032,NULL,NULL,'2012-06-11 00:00:00',56089,19.5,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120611/1206111460424124541.html','SDSS mag 20,5     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120611/jpg/1206111460424124541.master.jpg',NULL,NULL,63915162332,NULL,NULL,NULL,'2007-06-28 13:26:29',54279.560059,'2013-01-19 01:32:12','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206111460424124541/1206111460424124541.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120611/1206111460424124541p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,998674411,15604287,NULL,NULL,NULL,NULL),(11573,11573,1,'CSS120609-103057+494443','CRTS-CSS',157.73619,49.74537,NULL,NULL,'2012-06-09 00:00:00',56087,15.41,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120609/1206091490384128250.html','HPM LHS 2277     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120609/jpg/1206091490384128250.master.jpg',NULL,NULL,64124271217,NULL,NULL,NULL,'2008-06-15 10:33:41',54632.440063,'2013-01-19 01:32:12','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206091490384128250/1206091490384128250.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120609/1206091490384128250p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,1001941737,15655339,NULL,NULL,NULL,NULL),(11574,11574,0,'CSS120608-164943+230458','CRTS-CSS',252.42788,23.08282,NULL,NULL,'2012-06-08 00:00:00',56086,17.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','2019-12-24 20:38:21','http://nesssi.cacr.caltech.edu/catalina/20120608/1206081230834108521.html','Unknown SDSS mag 19,2    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120608/jpg/1206081230834108521.master.jpg',NULL,NULL,56680362780,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206081230834108521/1206081230834108521.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120608/1206081230834108521p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,885630668,13837979,NULL,NULL,NULL,NULL),(11575,11575,1,'CSS120528-203432-171406','CRTS-CSS',308.63422,-17.23492,NULL,NULL,'2012-05-28 00:00:00',56075,18.93,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120528/1205280181064170937.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120528/jpg/1205280181064170937.master.jpg',NULL,NULL,50847133081,NULL,NULL,NULL,'2011-10-23 13:26:07',55857.559814,'2013-01-19 01:32:12','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205280181064170937/1205280181064170937.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120528/1205280181064170937p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,794486454,12413850,NULL,NULL,NULL,NULL),(11576,11576,0,'CSS120526-162637-241554','CRTS-CSS',246.65357,-24.26497,NULL,NULL,'2012-05-26 00:00:00',56073,14.9,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','2019-10-11 20:38:49','http://nesssi.cacr.caltech.edu/catalina/20120526/1205260230814129756.html','Supernova or Other',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120526/jpg/1205260230814129756.master.jpg',NULL,NULL,45770397095,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205260230814129756/1205260230814129756.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120526/1205260230814129756p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,715162454,11174413,NULL,NULL,NULL,NULL),(11577,11577,1,'CSS120526-161420-190649','CRTS-CSS',243.58451,-19.11352,NULL,NULL,'2012-05-26 00:00:00',56073,12.78,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120526/1205260180844119174.html','Supernova or Other',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120526/jpg/1205260180844119174.master.jpg',NULL,NULL,45440867255,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:12','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205260180844119174/1205260180844119174.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120526/1205260180844119174p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,710013550,11093961,NULL,NULL,NULL,NULL),(11578,11578,1,'CSS120526-165741-055625','CRTS-CSS',254.42072,-5.94016,NULL,NULL,'2012-05-26 00:00:00',56073,17.34,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:13','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120526/1205260070904186783.html','Var SDSS mag 19,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120526/jpg/1205260070904186783.master.jpg',NULL,NULL,45192892531,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:13','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205260070904186783/1205260070904186783.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120526/1205260070904186783p.html',NULL,NULL,0,'AGN',NULL,0,NULL,0,706138945,11033421,NULL,NULL,NULL,NULL),(11580,11580,1,'CSS120518-134233+325241','CRTS-CSS',205.63809,32.87797,NULL,NULL,'2012-05-18 00:00:00',56065,19.67,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:13','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120518/1205181320634128305.html','Unknown SDSS mag 21,8    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120518/jpg/1205181320634128305.master.jpg',NULL,NULL,59189707431,NULL,NULL,NULL,'2008-01-17 10:33:41',54482.440063,'2013-01-19 01:32:13','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205181320634128305/1205181320634128305.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120518/1205181320634128305p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,924839178,14450612,NULL,NULL,NULL,NULL),(11581,11581,0,'CSS120515-181239+460333','CRTS-CSS',273.16408,46.05925,NULL,NULL,'2012-05-15 00:00:00',56062,18.65,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:13','2019-12-24 20:38:21','http://nesssi.cacr.caltech.edu/catalina/20120515/1205151460694129221.html','Var mag 19,8     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120515/jpg/1205151460694129221.master.jpg',NULL,NULL,54763404004,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:13','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205151460694129221/1205151460694129221.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120515/1205151460694129221p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,855678187,13369971,NULL,NULL,NULL,NULL),(11583,11583,1,'CSS120427-083303+370601','CRTS-CSS',128.26128,37.10039,NULL,NULL,'2012-04-27 00:00:00',56044,17.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:13','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120427/1204271380374105813.html','HPM 2MASS_J083303      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120427/jpg/1204271380374105813.master.jpg',NULL,NULL,64373106367,NULL,NULL,NULL,'2009-01-30 10:33:41',54861.440063,'2013-01-19 01:32:13','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204271380374105813/1204271380374105813.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120427/1204271380374105813p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1005829786,15716090,NULL,NULL,NULL,NULL),(11588,11588,1,'CSS120401-154205+333536','CRTS-CSS',235.52122,33.59328,NULL,NULL,'2012-04-01 00:00:00',56018,20.03,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:13','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120401/1204011320724147446.html','Unknown SDSS mag 21,7    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120401/jpg/1204011320724147446.master.jpg',NULL,NULL,59891475126,NULL,NULL,NULL,'2011-03-28 12:28:49',55648.52002,'2013-01-19 01:32:13','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204011320724147446/1204011320724147446.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120401/1204011320724147446p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,935804298,14621942,NULL,NULL,NULL,NULL),(11589,11589,1,'CSS120330-154450-115323','CRTS-CSS',236.20894,-11.88962,NULL,NULL,'2012-03-30 00:00:00',56016,14.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:13','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120330/1203300120834156131.html','Var X-ray?      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120330/jpg/1203300120834156131.master.jpg',NULL,NULL,45601731056,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:13','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203300120834156131/1203300120834156131.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120330/1203300120834156131p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,712527047,11133235,NULL,NULL,NULL,NULL),(11592,11592,1,'CSS120321-114454+112629','CRTS-CSS',176.2257,11.44149,NULL,NULL,'2012-03-21 00:00:00',56007,20.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:13','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120321/1203211120624103836.html','Unknown SDSS mag 21,4    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120321/jpg/1203211120624103836.master.jpg',NULL,NULL,60240287572,NULL,NULL,NULL,'2010-03-12 10:33:41',55267.440063,'2013-01-19 01:32:13','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203211120624103836/1203211120624103836.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120321/1203211120624103836p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,941254493,14707101,NULL,NULL,NULL,NULL),(11593,11593,1,'CSS120317-125431+445932','CRTS-CSS',193.63022,44.99215,NULL,NULL,'2012-03-17 00:00:00',56003,13.93,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:13','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120317/1203171430524142064.html','HPM LHS_2650      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120317/jpg/1203171430524142064.master.jpg',NULL,NULL,59107607134,NULL,NULL,NULL,'2007-02-07 10:33:36',54138.440002,'2013-01-19 01:32:13','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203171430524142064/1203171430524142064.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120317/1203171430524142064p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,923556361,14430568,NULL,NULL,NULL,NULL),(11596,11596,1,'CSS120315-034314+320045','CRTS-CSS',55.80688,32.01257,NULL,NULL,'2012-03-15 00:00:00',56001,18.12,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:13','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120315/1203151320184121250.html','YSO 2MASS_J034313      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120315/jpg/1203151320184121250.master.jpg',NULL,NULL,68511068785,NULL,NULL,NULL,'2005-10-29 11:31:10',53672.47998,'2013-01-19 01:32:13','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203151320184121250/1203151320184121250.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120315/1203151320184121250p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1070485449,16726335,NULL,NULL,NULL,NULL),(11597,11597,1,'CSS120226-090954-205725','CRTS-CSS',137.47354,-20.95703,NULL,NULL,'2012-02-26 00:00:00',55983,18.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:13','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120226/1202260210474151452.html','Unknown mag >21     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120226/jpg/1202260210474151452.master.jpg',NULL,NULL,42352996002,NULL,NULL,NULL,'2011-01-14 13:26:07',55575.559814,'2013-01-19 01:32:13','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202260210474151452/1202260210474151452.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120226/1202260210474151452p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,661765562,10340086,NULL,NULL,NULL,NULL),(11598,11598,1,'CSS120226-091110-220212','CRTS-CSS',137.79226,-22.03678,NULL,NULL,'2012-02-26 00:00:00',55983,13.51,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:14','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120226/1202260210474119845.html','OH_IR IRAS_09089-2149      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120226/jpg/1202260210474119845.master.jpg',NULL,NULL,42325804946,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:14','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202260210474119845/1202260210474119845.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120226/1202260210474119845p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,661340702,10333448,NULL,NULL,NULL,NULL),(11599,11599,1,'CSS120222-013311+304011','CRTS-CSS',23.29669,30.66962,NULL,NULL,'2012-02-22 00:00:00',55979,17.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:14','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120222/1202221290084142231.html','Supernova or Other',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120222/jpg/1202221290084142231.master.jpg',NULL,NULL,67771097890,NULL,NULL,NULL,'2012-01-25 13:26:07',55951.559814,'2013-01-19 01:32:14','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202221290084142231/1202221290084142231.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120222/1202221290084142231p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1058923404,16545678,NULL,NULL,NULL,NULL),(11603,11603,1,'CSS120129-123133+495040','CRTS-CSS',187.88804,49.84451,NULL,NULL,'2012-01-29 00:00:00',55955,13.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:14','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120129/1201291490454131189.html','HPM LHS_2571      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120129/jpg/1201291490454131189.master.jpg',NULL,NULL,57239009509,NULL,NULL,NULL,'2007-02-07 11:31:15',54138.480042,'2013-01-19 01:32:14','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201291490454131189/1201291490454131189.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120129/1201291490454131189p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,894359523,13974367,NULL,NULL,NULL,NULL),(11604,11604,1,'CSS120129-140722+392348','CRTS-CSS',211.8425,39.39673,NULL,NULL,'2012-01-29 00:00:00',55955,14.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:14','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120129/1201291380614145815.html','HPM LHS_2861      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120129/jpg/1201291380614145815.master.jpg',NULL,NULL,59140165209,NULL,NULL,NULL,'2008-06-09 10:33:41',54626.440063,'2013-01-19 01:32:14','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201291380614145815/1201291380614145815.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120129/1201291380614145815p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,924065081,14438516,NULL,NULL,NULL,NULL),(11606,11606,1,'CSS120125-013339+305758','CRTS-CSS',23.41373,30.96617,NULL,NULL,'2012-01-25 00:00:00',55951,18.43,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:14','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120125/1201251290084153337.html','Var M33      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120125/jpg/1201251290084153337.master.jpg',NULL,NULL,67771141896,NULL,NULL,NULL,'2004-11-03 12:28:48',53312.52,'2013-01-19 01:32:14','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201251290084153337/1201251290084153337.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120125/1201251290084153337p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1058924092,16545688,NULL,NULL,NULL,NULL),(11609,11609,1,'CSS120123-115231-021638','CRTS-CSS',178.12981,-2.2772,NULL,NULL,'2012-01-23 00:00:00',55949,19.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:14','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120123/1201230010644109131.html','Unknown SDSS mag 20,6    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120123/jpg/1201230010644109131.master.jpg',NULL,NULL,40818631872,NULL,NULL,NULL,'2009-03-15 10:33:41',54905.440063,'2013-01-19 01:32:14','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201230010644109131/1201230010644109131.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120123/1201230010644109131p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,637791123,9965486,NULL,NULL,NULL,NULL),(11610,11610,1,'CSS120120-025538+141923','CRTS-CSS',43.90834,14.32314,NULL,NULL,'2012-01-20 00:00:00',55946,19.68,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:14','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120120/1201201150164103852.html','Unknown PQ mag 21,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120120/jpg/1201201150164103852.master.jpg',NULL,NULL,68168237584,NULL,NULL,NULL,'2009-10-21 12:28:49',55125.52002,'2013-01-19 01:32:14','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201201150164103852/1201201150164103852.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120120/1201201150164103852p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1065128712,16642636,NULL,NULL,NULL,NULL),(11611,11611,1,'CSS120119-090925+493921','CRTS-CSS',137.35455,49.65591,NULL,NULL,'2012-01-19 00:00:00',55945,15.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:14','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120119/1201191490334131246.html','HPM LHS_2112 SDSS mag 16,8   ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120119/jpg/1201191490334131246.master.jpg',NULL,NULL,64233100665,NULL,NULL,NULL,'2010-12-13 13:26:07',55543.559814,'2013-01-19 01:32:14','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201191490334131246/1201191490334131246.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120119/1201191490334131246p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1003642197,15681909,NULL,NULL,NULL,NULL),(11613,11613,1,'CSS120118-103942+203216','CRTS-CSS',159.92481,20.53766,NULL,NULL,'2012-01-18 00:00:00',55944,20.12,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:14','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120118/1201181210544116069.html','Unknown SDSS mag >22,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120118/jpg/1201181210544116069.master.jpg',NULL,NULL,61000045794,NULL,NULL,NULL,'2011-12-28 13:26:07',55923.559814,'2013-01-19 01:32:14','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201181210544116069/1201181210544116069.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120118/1201181210544116069p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,953125715,14892589,NULL,NULL,NULL,NULL),(11615,11615,1,'CSS120104-114721+474554','CRTS-CSS',176.83708,47.76502,NULL,NULL,'2012-01-04 00:00:00',55930,13.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:14','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120104/1201041460454138916.html','HPM LHS_2458 SDSS mag 13,8   ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120104/jpg/1201041460454138916.master.jpg',NULL,NULL,61754177724,NULL,NULL,NULL,'2006-02-03 13:26:23',53769.559998,'2013-01-19 01:32:14','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201041460454138916/1201041460454138916.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120104/1201041460454138916p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,964909026,15076703,NULL,NULL,NULL,NULL),(11616,11616,1,'CSS120104-124540+432011','CRTS-CSS',191.41475,43.33652,NULL,NULL,'2012-01-04 00:00:00',55930,14.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:14','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120104/1201041430514116028.html','HPM LHS_2626 SDSS mag 17,1   ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120104/jpg/1201041430514116028.master.jpg',NULL,NULL,59120496695,NULL,NULL,NULL,'2007-12-18 12:28:49',54452.52002,'2013-01-19 01:32:14','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201041430514116028/1201041430514116028.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120104/1201041430514116028p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,923757760,14433715,NULL,NULL,NULL,NULL),(11620,11620,1,'CSS111231-025819-134814','CRTS-CSS',44.57901,-13.80402,NULL,NULL,'2011-12-31 00:00:00',55926,19.61,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111231/1112310120164104369.html','Unknown PQ mag >21    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111231/jpg/1112310120164104369.master.jpg',NULL,NULL,38101426510,NULL,NULL,NULL,'2011-11-17 13:26:07',55882.559814,'2013-01-19 01:32:15','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112310120164104369/1112310120164104369.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111231/1112310120164104369p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,595334789,9302106,NULL,NULL,NULL,NULL),(11622,11622,1,'CSS111118-035125+365560','CRTS-CSS',57.8533,36.93332,NULL,NULL,'2011-11-18 00:00:00',55883,18.34,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111118/1111181380174107847.html','Unknown SDSS mag 22,7    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111118/jpg/1111181380174107847.master.jpg',NULL,NULL,68352020372,NULL,NULL,NULL,'2011-11-02 12:28:49',55867.52002,'2013-01-19 01:32:15','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111181380174107847/1111181380174107847.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111118/1111181380174107847p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1068000318,16687504,NULL,NULL,NULL,NULL),(11623,11623,1,'CSS111102-051400+300657','CRTS-CSS',78.49845,30.11582,NULL,NULL,'2011-11-02 00:00:00',55867,12.19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111102/1111021290254190624.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111102/jpg/1111021290254190624.master.jpg',NULL,NULL,64952795883,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111021290254190624/1111021290254190624.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111102/1111021290254190624p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1014887435,15857616,NULL,NULL,NULL,NULL),(11624,11624,1,'CSS111023-223448+354501','CRTS-CSS',338.69889,35.75019,NULL,NULL,'2011-10-23 00:00:00',55857,13.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111023/1110231351004159200.html','Mira SDSS mag 15,9    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111023/jpg/1110231351004159200.master.jpg',NULL,NULL,55456271372,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110231351004159200/1110231351004159200.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111023/1110231351004159200p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,866504240,13539128,NULL,NULL,NULL,NULL),(11625,11625,1,'CSS111021-233940-214221','CRTS-CSS',354.91463,-21.70597,NULL,NULL,'2011-10-21 00:00:00',55855,19.03,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111021/1110210211204114444.html','Unknown mag >21,5     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111021/jpg/1110210211204114444.master.jpg',NULL,NULL,50276104259,NULL,NULL,NULL,'2011-10-06 12:28:49',55840.52002,'2013-01-19 01:32:15','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110210211204114444/1110210211204114444.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111021/1110210211204114444p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,785564129,12274439,NULL,NULL,NULL,NULL),(11626,11626,1,'CSS111020-035432-043602','CRTS-CSS',58.6318,-4.60048,NULL,NULL,'2011-10-20 00:00:00',55854,19.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111020/1110200040214115179.html','Unknown PQ mag >21    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111020/jpg/1110200040214115179.master.jpg',NULL,NULL,37005512045,NULL,NULL,NULL,'2011-10-01 13:26:07',55835.559814,'2013-01-19 01:32:15','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110200040214115179/1110200040214115179.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111020/1110200040214115179p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,578211125,9034548,NULL,NULL,NULL,NULL),(11627,11627,0,'CSS111018-021430+342643','CRTS-CSS',33.62305,34.44531,NULL,NULL,'2011-10-18 00:00:00',55852,17.24,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','2020-01-19 08:44:58','http://nesssi.cacr.caltech.edu/catalina/20111018/1110181350104113460.html','Unknown DSS mag >21    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111018/jpg/1110181350104113460.master.jpg',NULL,NULL,68634849069,NULL,NULL,NULL,'2011-09-26 13:26:07',55830.559814,'2013-01-19 01:32:15','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110181350104113460/1110181350104113460.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111018/1110181350104113460p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1072419516,16756554,NULL,NULL,NULL,NULL),(11628,11628,1,'CSS111018-033313+312124','CRTS-CSS',53.30332,31.35658,NULL,NULL,'2011-10-18 00:00:00',55852,17.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111018/1110181320174103285.html','YSO IRAS_F03300+3111      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111018/jpg/1110181320174103285.master.jpg',NULL,NULL,68504593174,NULL,NULL,NULL,'2005-03-08 13:26:23',53437.559998,'2013-01-19 01:32:15','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110181320174103285/1110181320174103285.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111018/1110181320174103285p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1070384268,16724754,NULL,NULL,NULL,NULL),(11629,11629,1,'CSS111015-230609-055403','CRTS-CSS',346.53647,-5.90084,NULL,NULL,'2011-10-15 00:00:00',55849,19.54,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111015/1110150071234137016.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111015/jpg/1110150071234137016.master.jpg',NULL,NULL,49482113457,NULL,NULL,NULL,'2011-09-30 13:26:07',55834.559814,'2013-01-19 01:32:15','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110150071234137016/1110150071234137016.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111015/1110150071234137016p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,773158022,12080594,NULL,NULL,NULL,NULL),(11630,11630,1,'CSS111006-012422+402356','CRTS-CSS',21.09311,40.39894,NULL,NULL,'2011-10-06 00:00:00',55840,17.27,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111006/1110061400064119848.html','HPM EGGR_517 SDSS mag 16,9   ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111006/jpg/1110061400064119848.master.jpg',NULL,NULL,67886086675,NULL,NULL,NULL,'2006-06-17 13:26:23',53903.559998,'2013-01-19 01:32:15','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110061400064119848/1110061400064119848.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111006/1110061400064119848p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1060720104,16573751,NULL,NULL,NULL,NULL),(11631,11631,1,'CSS111003-055510-041034','CRTS-CSS',88.79152,-4.17617,NULL,NULL,'2011-10-03 00:00:00',55837,13.82,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111003/1110030040324144414.html','HPM HL_4      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111003/jpg/1110030040324144414.master.jpg',NULL,NULL,36519045816,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110030040324144414/1110030040324144414.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111003/1110030040324144414p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,570610090,8915782,NULL,NULL,NULL,NULL),(11632,11632,1,'CSS110923-223145-233246','CRTS-CSS',337.93808,-23.54615,NULL,NULL,'2011-09-23 00:00:00',55827,13.65,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110923/1109230231114129617.html','Mira       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110923/jpg/1109230231114129617.master.jpg',NULL,NULL,50205224296,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1109230231114129617/1109230231114129617.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110923/1109230231114129617p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,784456629,12257134,NULL,NULL,NULL,NULL),(11633,11633,1,'CSS110918-224836+043100','CRTS-CSS',342.15153,4.51678,NULL,NULL,'2011-09-18 00:00:00',55822,18.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110918/1109181041224123976.html','Comet 213P      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110918/jpg/1109181041224123976.master.jpg',NULL,NULL,51682568517,NULL,NULL,NULL,'2010-05-10 12:28:49',55326.52002,'2013-01-19 01:32:15','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1109181041224123976/1109181041224123976.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110918/1109181041224123976p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,807540133,12617814,NULL,NULL,NULL,NULL),(11634,11634,1,'CSS110703-221840-144032','CRTS-CSS',334.6676,-14.6756,NULL,NULL,'2011-07-03 00:00:00',55745,19.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110703/1107030151164136669.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110703/jpg/1107030151164136669.master.jpg',NULL,NULL,49758177996,NULL,NULL,NULL,'2007-09-03 13:26:29',54346.560059,'2013-01-19 01:32:15','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1107030151164136669/1107030151164136669.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110703/1107030151164136669p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,777471531,12147992,NULL,NULL,NULL,NULL),(11635,11635,1,'CSS110604-163911-235805','CRTS-CSS',249.79635,-23.96793,NULL,NULL,'2011-06-04 00:00:00',55716,13.19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110604/1106040230824154629.html','Mira SSS100804      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110604/jpg/1106040230824154629.master.jpg',NULL,NULL,45906710417,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106040230824154629/1106040230824154629.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110604/1106040230824154629p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,717292350,11207692,NULL,NULL,NULL,NULL),(11636,11636,1,'CSS110604-163138-215821','CRTS-CSS',247.9103,-21.97263,NULL,NULL,'2011-06-04 00:00:00',55716,12.84,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110604/1106040210844128759.html','Mira SSS100504      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110604/jpg/1106040210844128759.master.jpg',NULL,NULL,45908571653,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:15','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106040210844128759/1106040210844128759.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110604/1106040210844128759p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,717321432,11208147,NULL,NULL,NULL,NULL),(11637,11637,1,'CSS110430-091710+314309','CRTS-CSS',139.29103,31.71904,NULL,NULL,'2011-04-30 00:00:00',55681,19.31,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:16','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110430/1104301320434110403.html','Supernova or Other',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110430/jpg/1104301320434110403.master.jpg',NULL,NULL,64378968505,NULL,NULL,NULL,'2005-12-05 13:26:23',53709.559998,'2013-01-19 01:32:16','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104301320434110403/1104301320434110403.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110430/1104301320434110403p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,1005921382,15717521,NULL,NULL,NULL,NULL),(11641,11641,1,'CSS110427-132319+451053','CRTS-CSS',200.83124,45.1814,NULL,NULL,'2011-04-27 00:00:00',55678,15.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:16','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110427/1104271460514101819.html','Var SDSS mag 15,6    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110427/jpg/1104271460514101819.master.jpg',NULL,NULL,59280167382,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:16','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104271460514101819/1104271460514101819.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110427/1104271460514101819p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,926252615,14472697,NULL,NULL,NULL,NULL),(11643,11643,1,'CSS110411-205510-053447','CRTS-CSS',313.78987,-5.57968,NULL,NULL,'2011-04-11 00:00:00',55662,16.3,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:16','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110411/1104110041124106204.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110411/jpg/1104110041124106204.master.jpg',NULL,NULL,50740568204,NULL,NULL,NULL,'2010-11-16 13:26:07',55516.559814,'2013-01-19 01:32:16','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104110041124106204/1104110041124106204.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110411/1104110041124106204p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,792821378,12387834,NULL,NULL,NULL,NULL),(11644,11644,1,'CSS110329-133902-240114','CRTS-CSS',204.75724,-24.02056,NULL,NULL,'2011-03-29 00:00:00',55649,16.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:16','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110329/1103290230684131567.html','Var mag 17,7     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110329/jpg/1103290230684131567.master.jpg',NULL,NULL,43757401000,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:16','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103290230684131567/1103290230684131567.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110329/1103290230684131567p.html',NULL,NULL,0,'AGN',NULL,0,NULL,0,683709390,10682959,NULL,NULL,NULL,NULL),(11646,11646,1,'CSS110223-101305+084705','CRTS-CSS',153.27248,8.78464,NULL,NULL,'2011-02-23 00:00:00',55615,19.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:16','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110223/1102231090554106250.html','Unknown SDSS mag 21,0    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110223/jpg/1102231090554106250.master.jpg',NULL,NULL,60765009406,NULL,NULL,NULL,'2009-02-05 13:26:29',54867.560059,'2013-01-19 01:32:16','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102231090554106250/1102231090554106250.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110223/1102231090554106250p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,949453271,14835207,NULL,NULL,NULL,NULL),(11649,11649,1,'CSS110102-134553-125430','CRTS-CSS',206.47183,-12.90846,NULL,NULL,'2011-01-02 00:00:00',55563,19.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:16','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110102/1101020120734122317.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110102/jpg/1101020120734122317.master.jpg',NULL,NULL,43657032988,NULL,NULL,NULL,'2009-04-16 13:26:29',54937.560059,'2013-01-19 01:32:16','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101020120734122317/1101020120734122317.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110102/1101020120734122317p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,682141140,10658455,NULL,NULL,NULL,NULL),(11650,11650,1,'CSS101211-045630-205036','CRTS-CSS',74.12513,-20.84343,NULL,NULL,'2010-12-11 00:00:00',55541,19.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:16','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101211/1012110210254124854.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101211/jpg/1012110210254124854.master.jpg',NULL,NULL,37561063768,NULL,NULL,NULL,'2010-11-17 13:26:07',55517.559814,'2013-01-19 01:32:16','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1012110210254124854/1012110210254124854.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101211/1012110210254124854p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,586891621,9170181,NULL,NULL,NULL,NULL),(11651,11651,1,'CSS101202-034704+195112','CRTS-CSS',56.76532,19.85327,NULL,NULL,'2010-12-02 00:00:00',55532,16.71,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:16','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101202/1012021210204101666.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101202/jpg/1012021210204101666.master.jpg',NULL,NULL,68039583106,NULL,NULL,NULL,'2010-11-10 13:26:07',55510.559814,'2013-01-19 01:32:16','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1012021210204101666/1012021210204101666.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101202/1012021210204101666p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1063118486,16611226,NULL,NULL,NULL,NULL),(11653,11653,1,'CSS101127-215331-131846','CRTS-CSS',328.38067,-13.31291,NULL,NULL,'2010-11-27 00:00:00',55527,19.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:16','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101127/1011270121154113440.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101127/jpg/1011270121154113440.master.jpg',NULL,NULL,49773743775,NULL,NULL,NULL,'2010-11-09 13:26:07',55509.559814,'2013-01-19 01:32:16','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011270121154113440/1011270121154113440.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101127/1011270121154113440p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,777714746,12151792,NULL,NULL,NULL,NULL),(11655,11655,1,'CSS101108-055325-102730','CRTS-CSS',88.35434,-10.45838,NULL,NULL,'2010-11-08 00:00:00',55508,17.06,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:16','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101108/1011080090324123107.html','YSO       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101108/jpg/1011080090324123107.master.jpg',NULL,NULL,36729318180,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:16','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011080090324123107/1011080090324123107.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101108/1011080090324123107p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,573895596,8967118,NULL,NULL,NULL,NULL),(11657,11657,1,'CSS101103-033135-182811','CRTS-CSS',52.89758,-18.46966,NULL,NULL,'2010-11-03 00:00:00',55503,19.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101103/1011030180194118420.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101103/jpg/1011030180194118420.master.jpg',NULL,NULL,38006505244,NULL,NULL,NULL,'2005-01-19 13:26:23',53389.559998,'2013-01-19 01:32:17','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011030180194118420/1011030180194118420.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101103/1011030180194118420p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,593851644,9278931,NULL,NULL,NULL,NULL),(11658,11658,1,'CSS101031-082153+294513','CRTS-CSS',125.46903,29.75369,NULL,NULL,'2010-10-31 00:00:00',55500,19.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101031/1010311290404125624.html','Unknown SDSS mag >22,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101031/jpg/1010311290404125624.master.jpg',NULL,NULL,64357266141,NULL,NULL,NULL,'2010-10-14 13:26:07',55483.559814,'2013-01-19 01:32:17','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010311290404125624/1010311290404125624.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101031/1010311290404125624p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1005582283,15712223,NULL,NULL,NULL,NULL),(11659,11659,1,'CSS101031-054059-074802','CRTS-CSS',85.24514,-7.80057,NULL,NULL,'2010-10-31 00:00:00',55500,18.42,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101031/1010310070314111174.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101031/jpg/1010310070314111174.master.jpg',NULL,NULL,36732836047,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010310070314111174/1010310070314111174.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101031/1010310070314111174p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,573950563,8967977,NULL,NULL,NULL,NULL),(11665,11665,1,'CSS100620-211436-140006','CRTS-CSS',318.65081,-14.00168,NULL,NULL,'2010-06-20 00:00:00',55367,18.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100620/1006200121124103071.html','Unknown mag 19,7     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100620/jpg/1006200121124103071.master.jpg',NULL,NULL,50968451486,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006200121124103071/1006200121124103071.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100620/1006200121124103071p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,796382054,12443469,NULL,NULL,NULL,NULL),(11666,11666,1,'CSS100519-171557-074734','CRTS-CSS',258.98796,-7.79284,NULL,NULL,'2010-05-19 00:00:00',55335,12.81,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100519/1005190070924141578.html','Mira mag 14 IRAS 17132-0744   ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100519/jpg/1005190070924141578.master.jpg',NULL,NULL,45308630029,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005190070924141578/1005190070924141578.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100519/1005190070924141578p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,707947344,11061677,NULL,NULL,NULL,NULL),(11668,11668,1,'CSS100318-141352+341514','CRTS-CSS',213.46683,34.25391,NULL,NULL,'2010-03-18 00:00:00',55273,20.37,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100318/1003181350634106417.html','Var SDSS mag 21,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100318/jpg/1003181350634106417.master.jpg',NULL,NULL,60044875139,NULL,NULL,NULL,'2008-04-10 11:31:10',54566.47998,'2013-01-19 01:32:17','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003181350634106417/1003181350634106417.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100318/1003181350634106417p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,938201174,14659393,NULL,NULL,NULL,NULL),(11669,11669,1,'CSS100216-033242+311046','CRTS-CSS',53.1738,31.17956,NULL,NULL,'2010-02-16 00:00:00',55243,16.69,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100216/1002161320174102834.html','Var TTau cand     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100216/jpg/1002161320174102834.master.jpg',NULL,NULL,68504637235,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1002161320174102834/1002161320174102834.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100216/1002161320174102834p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1070384956,16724764,NULL,NULL,NULL,NULL),(11670,11670,1,'CSS100216-031850+330937','CRTS-CSS',49.7093,33.16015,NULL,NULL,'2010-02-16 00:00:00',55243,14.67,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100216/1002161320164145926.html','Supernova or Other',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100216/jpg/1002161320164145926.master.jpg',NULL,NULL,68702807449,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1002161320164145926/1002161320164145926.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100216/1002161320164145926p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1073481366,16773146,NULL,NULL,NULL,NULL),(11671,11671,1,'CSS100214-042006+244904','CRTS-CSS',65.02367,24.81787,NULL,NULL,'2010-02-14 00:00:00',55241,18.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100214/1002141230224152602.html','Var SDSS mag 21 LDN_1511   ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100214/jpg/1002141230224152602.master.jpg',NULL,NULL,64763868252,NULL,NULL,NULL,'2008-03-29 11:31:10',54554.47998,'2013-01-19 01:32:17','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1002141230224152602/1002141230224152602.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100214/1002141230224152602p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1011935441,15811491,NULL,NULL,NULL,NULL),(11672,11672,1,'CSS100206-051539+210334','CRTS-CSS',78.91157,21.05947,NULL,NULL,'2010-02-06 00:00:00',55233,17.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100206/1002061210274147147.html','Comet 31P      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100206/jpg/1002061210274147147.master.jpg',NULL,NULL,65397021285,NULL,NULL,NULL,'2009-09-30 13:26:29',55104.560059,'2013-01-19 01:32:17','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1002061210274147147/1002061210274147147.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100206/1002061210274147147p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1021828457,15966069,NULL,NULL,NULL,NULL),(11673,11673,1,'CSS100114-055813+024057','CRTS-CSS',89.55235,2.68257,NULL,NULL,'2010-01-14 00:00:00',55210,14.19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100114/1001141010324182496.html','Mira mag 15,0     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100114/jpg/1001141010324182496.master.jpg',NULL,NULL,64439425582,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1001141010324182496/1001141010324182496.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100114/1001141010324182496p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1006866024,15732281,NULL,NULL,NULL,NULL),(11675,11675,1,'CSS091215-060708-060335','CRTS-CSS',91.78363,-6.05978,NULL,NULL,'2009-12-15 00:00:00',55180,17.96,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20091215/912150070334159641.html','YSO mag 21     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091215/jpg/912150070334159641.master.jpg',NULL,NULL,38682969261,NULL,NULL,NULL,'2006-10-02 10:33:36',54010.440002,'2013-01-19 01:32:17','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/912150070334159641/912150070334159641.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091215/912150070334159641p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,604421394,9444084,NULL,NULL,NULL,NULL),(11676,11676,1,'CSS091120-004417+411854','CRTS-CSS',11.07004,41.31494,NULL,NULL,'2009-11-20 00:00:00',55155,17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:17','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20091120/911201400044145995.html','Nova M31 2009-11d     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091120/jpg/911201400044145995.master.jpg',NULL,NULL,67673432989,NULL,NULL,NULL,'2009-11-09 13:26:29',55144.560059,'2013-01-19 01:32:17','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/911201400044145995/911201400044145995.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091120/911201400044145995p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1057397390,16521834,NULL,NULL,NULL,NULL),(11678,11678,1,'CSS091117-211110-213729','CRTS-CSS',317.78973,-21.62473,NULL,NULL,'2009-11-17 00:00:00',55152,16.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20091117/911170211074120836.html','Supernova or Other',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20091117/jpg/911170211074120836.master.jpg',NULL,NULL,50911733587,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/911170211074120836/911170211074120836.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20091117/911170211074120836p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,795495837,12429622,NULL,NULL,NULL,NULL),(11681,11681,0,'MLS130118-044241+183500','CRTS-MLS',70.67127,18.5832,NULL,NULL,'2013-01-18 00:00:00',56310,16.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/MLS/20130118/1301181180634104058.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130118/jpg/1301181180634104058.master.jpg',NULL,NULL,65281102568,NULL,NULL,NULL,'2012-12-08 13:26:29',56269.560059,'2013-01-19 01:32:18','http://crts.caltech.edu/ATEL/MLS/1301181180634104058/1301181180634104058.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130118/1301181180634104058p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1020017227,15937769,NULL,NULL,NULL,NULL),(11682,11682,1,'MLS130118-095933+140721','CRTS-MLS',149.88764,14.12252,NULL,NULL,'2013-01-18 00:00:00',56310,19.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130118/1301181141354100655.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130118/jpg/1301181141354100655.master.jpg',NULL,NULL,60854554206,NULL,NULL,NULL,'2009-02-28 11:31:10',54890.47998,'2013-01-19 01:32:18','http://crts.caltech.edu/ATEL/MLS/1301181141354100655/1301181141354100655.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130118/1301181141354100655p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,950852409,14857068,NULL,NULL,NULL,NULL),(11683,11683,1,'MLS130118-124757-033958','CRTS-MLS',191.98605,-3.66619,NULL,NULL,'2013-01-18 00:00:00',56310,20.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130118/1301180031784111147.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130118/jpg/1301180031784111147.master.jpg',NULL,NULL,43107300959,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','http://crts.caltech.edu/ATEL/MLS/1301180031784111147/1301180031784111147.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130118/1301180031784111147p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,673551577,10524243,NULL,NULL,NULL,NULL),(11684,11684,1,'MLS130109-111903+045305','CRTS-MLS',169.76061,4.88479,NULL,NULL,'2013-01-09 00:00:00',56301,20.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130109/1301091041574108700.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130109/jpg/1301091041574108700.master.jpg',NULL,NULL,60360163157,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','http://crts.caltech.edu/ATEL/MLS/1301091041574108700/1301091041574108700.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130109/1301091041574108700p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,943127549,14736367,NULL,NULL,NULL,NULL),(11685,11685,1,'MLS130105-095514+131346','CRTS-MLS',148.80653,13.22956,NULL,NULL,'2013-01-05 00:00:00',56297,19.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130105/1301051131344103150.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130105/jpg/1301051131344103150.master.jpg',NULL,NULL,60825441354,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','http://crts.caltech.edu/ATEL/MLS/1301051131344103150/1301051131344103150.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130105/1301051131344103150p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,950397521,14849961,NULL,NULL,NULL,NULL),(11686,11686,1,'MLS130103-075307+235549','CRTS-MLS',118.27819,23.93027,NULL,NULL,'2013-01-03 00:00:00',56295,20.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130103/1301031241014102001.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130103/jpg/1301031241014102001.master.jpg',NULL,NULL,63754146258,NULL,NULL,NULL,'2006-11-02 13:26:23',54041.559998,'2013-01-19 01:32:18','http://crts.caltech.edu/ATEL/MLS/1301031241014102001/1301031241014102001.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130103/1301031241014102001p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,996158535,15564977,NULL,NULL,NULL,NULL),(11688,11688,1,'MLS130103-234733+061144','CRTS-MLS',356.88843,6.19556,NULL,NULL,'2013-01-03 00:00:00',56295,20.44,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130103/1301031053294111289.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130103/jpg/1301031053294111289.master.jpg',NULL,NULL,51562596224,NULL,NULL,NULL,'2012-10-21 13:26:29',56221.560059,'2013-01-19 01:32:18','http://crts.caltech.edu/ATEL/MLS/1301031053294111289/1301031053294111289.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130103/1301031053294111289p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,805665566,12588524,NULL,NULL,NULL,NULL),(11689,11689,1,'MLS130103-234931-061502','CRTS-MLS',357.37952,-6.25068,NULL,NULL,'2013-01-03 00:00:00',56295,19.18,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130103/1301030053294103567.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130103/jpg/1301030053294103567.master.jpg',NULL,NULL,49438349859,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','http://crts.caltech.edu/ATEL/MLS/1301030053294103567/1301030053294103567.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130103/1301030053294103567p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,772474216,12069909,NULL,NULL,NULL,NULL),(11690,11690,1,'MLS130103-143218-033215','CRTS-MLS',218.07338,-3.53756,NULL,NULL,'2013-01-03 00:00:00',56295,20.19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130103/1301030032024111858.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130103/jpg/1301030032024111858.master.jpg',NULL,NULL,43551225862,NULL,NULL,NULL,'2012-04-01 13:26:29',56018.560059,'2013-01-19 01:32:18','http://crts.caltech.edu/ATEL/MLS/1301030032024111858/1301030032024111858.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130103/1301030032024111858p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,680487904,10632623,NULL,NULL,NULL,NULL),(11691,11691,1,'MLS121209-093512+152855','CRTS-MLS',143.80069,15.48182,NULL,NULL,'2012-12-09 00:00:00',56270,20.78,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121209/1212091151294104835.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121209/jpg/1212091151294104835.master.jpg',NULL,NULL,63733767020,NULL,NULL,NULL,'2007-05-26 13:26:23',54246.559998,'2013-01-19 01:32:18','http://crts.caltech.edu/ATEL/MLS/1212091151294104835/1212091151294104835.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121209/1212091151294104835p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,995840109,15560001,NULL,NULL,NULL,NULL),(11693,11693,1,'MLS121120-034932+285955','CRTS-MLS',57.38213,28.99854,NULL,NULL,'2012-11-20 00:00:00',56251,19.38,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121120/1211201280474119466.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121120/jpg/1211201280474119466.master.jpg',NULL,NULL,68512101643,NULL,NULL,NULL,'2005-02-04 13:26:23',53405.559998,'2013-01-19 01:32:18','http://crts.caltech.edu/ATEL/MLS/1211201280474119466/1211201280474119466.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121120/1211201280474119466p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1070501588,16726587,NULL,NULL,NULL,NULL),(11694,11694,1,'MLS121120-034515+275442','CRTS-MLS',56.3121,27.91155,NULL,NULL,'2012-11-20 00:00:00',56251,20.45,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121120/1211201270474118749.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121120/jpg/1211201270474118749.master.jpg',NULL,NULL,68506784015,NULL,NULL,NULL,'2007-03-15 10:33:36',54174.440002,'2013-01-19 01:32:18','http://crts.caltech.edu/ATEL/MLS/1211201270474118749/1211201270474118749.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121120/1211201270474118749p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1070418500,16725289,NULL,NULL,NULL,NULL),(11695,11695,1,'MLS121120-002001+002228','CRTS-MLS',5.00528,0.37455,NULL,NULL,'2012-11-20 00:00:00',56251,19.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:18','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121120/1211201000054104291.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121120/jpg/1211201000054104291.master.jpg',NULL,NULL,66576284596,NULL,NULL,NULL,'2012-11-03 13:26:29',56234.560059,'2013-01-19 01:32:18','http://crts.caltech.edu/ATEL/MLS/1211201000054104291/1211201000054104291.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121120/1211201000054104291p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1040254446,16253975,NULL,NULL,NULL,NULL),(11697,11697,1,'MLS121115-080653+231239','CRTS-MLS',121.7198,23.21083,NULL,NULL,'2012-11-15 00:00:00',56246,19.71,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121115/1211151231044108208.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121115/jpg/1211151231044108208.master.jpg',NULL,NULL,63767801660,NULL,NULL,NULL,'2010-01-06 10:33:30',55202.439941,'2013-01-19 01:32:19','http://crts.caltech.edu/ATEL/MLS/1211151231044108208/1211151231044108208.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121115/1211151231044108208p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,996371900,15568310,NULL,NULL,NULL,NULL),(11698,11698,1,'MLS121114-024326+151603','CRTS-MLS',40.85958,15.26738,NULL,NULL,'2012-11-14 00:00:00',56245,20.31,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121114/1211141150374101693.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121114/jpg/1211141150374101693.master.jpg',NULL,NULL,68145141889,NULL,NULL,NULL,'2007-07-19 13:26:29',54300.560059,'2013-01-19 01:32:19','http://crts.caltech.edu/ATEL/MLS/1211141150374101693/1211141150374101693.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121114/1211141150374101693p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1064767842,16636997,NULL,NULL,NULL,NULL),(11699,11699,1,'MLS121112-074408+220011','CRTS-MLS',116.03431,22.00294,NULL,NULL,'2012-11-12 00:00:00',56243,19.35,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121112/1211121221004108927.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121112/jpg/1211121221004108927.master.jpg',NULL,NULL,63084834777,NULL,NULL,NULL,'2012-09-25 13:26:29',56195.560059,'2013-01-19 01:32:19','http://crts.caltech.edu/ATEL/MLS/1211121221004108927/1211121221004108927.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121112/1211121221004108927p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,985700543,15401570,NULL,NULL,NULL,NULL),(11700,11700,1,'MLS121112-083604+152852','CRTS-MLS',129.01754,15.481,NULL,NULL,'2012-11-12 00:00:00',56243,18.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121112/1211121151164106065.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121112/jpg/1211121151164106065.master.jpg',NULL,NULL,63851095547,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','http://crts.caltech.edu/ATEL/MLS/1211121151164106065/1211121151164106065.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121112/1211121151164106065p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,997673367,15588646,NULL,NULL,NULL,NULL),(11701,11701,1,'MLS121107-023752+160255','CRTS-MLS',39.46607,16.04851,NULL,NULL,'2012-11-07 00:00:00',56238,19.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121107/1211071150364115876.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121107/jpg/1211071150364115876.master.jpg',NULL,NULL,68142745719,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','http://crts.caltech.edu/ATEL/MLS/1211071150364115876/1211071150364115876.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121107/1211071150364115876p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1064730401,16636412,NULL,NULL,NULL,NULL),(11702,11702,1,'MLS121107-024432+141538','CRTS-MLS',41.13233,14.26069,NULL,NULL,'2012-11-07 00:00:00',56238,20.18,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121107/1211071140374103061.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121107/jpg/1211071140374103061.master.jpg',NULL,NULL,68148517640,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','http://crts.caltech.edu/ATEL/MLS/1211071140374103061/1211071140374103061.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121107/1211071140374103061p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1064820588,16637821,NULL,NULL,NULL,NULL),(11703,11703,1,'MLS121106-014106+080118','CRTS-MLS',25.27638,8.02171,NULL,NULL,'2012-11-06 00:00:00',56237,21.12,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121106/1211061080244107608.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121106/jpg/1211061080244107608.master.jpg',NULL,NULL,67024349367,NULL,NULL,NULL,'2005-10-29 12:28:47',53672.519989,'2013-01-19 01:32:19','http://crts.caltech.edu/ATEL/MLS/1211061080244107608/1211061080244107608.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121106/1211061080244107608p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1047255458,16363366,NULL,NULL,NULL,NULL),(11704,11704,1,'MLS121104-022459+220758','CRTS-MLS',36.24788,22.1329,NULL,NULL,'2012-11-04 00:00:00',56235,19.38,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121104/1211041220324106508.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121104/jpg/1211041220324106508.master.jpg',NULL,NULL,68105762086,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','http://crts.caltech.edu/ATEL/MLS/1211041220324106508/1211041220324106508.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121104/1211041220324106508p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1064152532,16627383,NULL,NULL,NULL,NULL),(11705,11705,1,'MLS121022-230039-060814','CRTS-MLS',345.1607,-6.13724,NULL,NULL,'2012-10-22 00:00:00',56222,20.61,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121022/1210220053184104618.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121022/jpg/1210220053184104618.master.jpg',NULL,NULL,49487483278,NULL,NULL,NULL,'2005-06-17 12:28:47',53538.519989,'2013-01-19 01:32:19','http://crts.caltech.edu/ATEL/MLS/1210220053184104618/1210220053184104618.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121022/1210220053184104618p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,773241926,12081905,NULL,NULL,NULL,NULL),(11708,11708,1,'MLS121014-001025+030007','CRTS-MLS',2.6032,3.00195,NULL,NULL,'2012-10-14 00:00:00',56214,20.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121014/1210141020034116006.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121014/jpg/1210141020034116006.master.jpg',NULL,NULL,66582504153,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','http://crts.caltech.edu/ATEL/MLS/1210141020034116006/1210141020034116006.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121014/1210141020034116006p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1040351627,16255494,NULL,NULL,NULL,NULL),(11709,11709,1,'MLS121010-010409+142517','CRTS-MLS',16.03711,14.42131,NULL,NULL,'2012-10-10 00:00:00',56210,20.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121010/1210101140154106605.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121010/jpg/1210101140154106605.master.jpg',NULL,NULL,67639525389,NULL,NULL,NULL,'2008-12-01 10:33:30',54801.439941,'2013-01-19 01:32:19','http://crts.caltech.edu/ATEL/MLS/1210101140154106605/1210101140154106605.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121010/1210101140154106605p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1056867584,16513556,NULL,NULL,NULL,NULL),(11711,11711,1,'MLS121009-003536+073811','CRTS-MLS',8.90171,7.63646,NULL,NULL,'2012-10-09 00:00:00',56209,21.26,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121009/1210091080094100818.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121009/jpg/1210091080094100818.master.jpg',NULL,NULL,66829837636,NULL,NULL,NULL,'2012-09-24 13:26:29',56194.560059,'2013-01-19 01:32:19','http://crts.caltech.edu/ATEL/MLS/1210091080094100818/1210091080094100818.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121009/1210091080094100818p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1044216213,16315878,NULL,NULL,NULL,NULL),(11712,11712,1,'MLS121008-005411+124603','CRTS-MLS',13.54781,12.76738,NULL,NULL,'2012-10-08 00:00:00',56208,20.47,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121008/1210081120134111293.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121008/jpg/1210081120134111293.master.jpg',NULL,NULL,67579959985,NULL,NULL,NULL,'2006-11-25 13:26:23',54064.559998,'2013-01-19 01:32:19','http://crts.caltech.edu/ATEL/MLS/1210081120134111293/1210081120134111293.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121008/1210081120134111293p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1055936874,16499013,NULL,NULL,NULL,NULL),(11713,11713,1,'MLS121008-013046+075038','CRTS-MLS',22.69072,7.84375,NULL,NULL,'2012-10-08 00:00:00',56208,20.1,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121008/1210081080214103832.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121008/jpg/1210081080214103832.master.jpg',NULL,NULL,67540662064,NULL,NULL,NULL,'2009-12-15 10:33:30',55180.439941,'2013-01-19 01:32:19','http://crts.caltech.edu/ATEL/MLS/1210081080214103832/1210081080214103832.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121008/1210081080214103832p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1055322844,16489419,NULL,NULL,NULL,NULL),(11715,11715,1,'MLS120919-221804-123821','CRTS-MLS',334.51483,-12.63915,NULL,NULL,'2012-09-19 00:00:00',56189,21.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120919/1209190123034105587.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120919/jpg/1209190123034105587.master.jpg',NULL,NULL,49748271971,NULL,NULL,NULL,'2011-09-24 13:26:29',55828.560059,'2013-01-19 01:32:19','http://crts.caltech.edu/ATEL/MLS/1209190123034105587/1209190123034105587.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120919/1209190123034105587p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,777316749,12145574,NULL,NULL,NULL,NULL),(11717,11717,1,'MLS120917-225836-080636','CRTS-MLS',344.64852,-8.11006,NULL,NULL,'2012-09-17 00:00:00',56187,20.71,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120917/1209170083164108431.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120917/jpg/1209170083164108431.master.jpg',NULL,NULL,50372481026,NULL,NULL,NULL,'2008-09-22 10:33:30',54731.439941,'2013-01-19 01:32:20','http://crts.caltech.edu/ATEL/MLS/1209170083164108431/1209170083164108431.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120917/1209170083164108431p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,787070016,12297969,NULL,NULL,NULL,NULL),(11718,11718,1,'MLS120917-235257-025629','CRTS-MLS',358.23858,-2.94133,NULL,NULL,'2012-09-17 00:00:00',56187,20.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120917/1209170023324104283.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120917/jpg/1209170023324104283.master.jpg',NULL,NULL,49403369764,NULL,NULL,NULL,'2008-11-02 10:33:30',54772.439941,'2013-01-19 01:32:20','http://crts.caltech.edu/ATEL/MLS/1209170023324104283/1209170023324104283.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120917/1209170023324104283p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,771927652,12061369,NULL,NULL,NULL,NULL),(11719,11719,1,'MLS120917-225755-002025','CRTS-MLS',344.48037,-0.3404,NULL,NULL,'2012-09-17 00:00:00',56187,20.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120917/1209170003194114012.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120917/jpg/1209170003194114012.master.jpg',NULL,NULL,49497719615,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','http://crts.caltech.edu/ATEL/MLS/1209170003194114012/1209170003194114012.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120917/1209170003194114012p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,773401868,12084404,NULL,NULL,NULL,NULL),(11720,11720,1,'MLS120914-025222+195311','CRTS-MLS',43.09317,19.88642,NULL,NULL,'2012-09-14 00:00:00',56184,20.67,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120914/1209141200384105234.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120914/jpg/1209141200384105234.master.jpg',NULL,NULL,68123007485,NULL,NULL,NULL,'2009-11-08 13:26:29',55143.560059,'2013-01-19 01:32:20','http://crts.caltech.edu/ATEL/MLS/1209141200384105234/1209141200384105234.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120914/1209141200384105234p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1064421991,16631593,NULL,NULL,NULL,NULL),(11721,11721,1,'MLS120618-140925-164732','CRTS-MLS',212.35557,-16.79234,NULL,NULL,'2012-06-18 00:00:00',56096,20.06,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120618/1206180161894110245.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120618/jpg/1206180161894110245.master.jpg',NULL,NULL,43646421676,NULL,NULL,NULL,'2009-04-24 13:26:29',54945.560059,'2013-01-19 01:32:20','http://crts.caltech.edu/ATEL/MLS/1206180161894110245/1206180161894110245.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120618/1206180161894110245p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,681975338,10655864,NULL,NULL,NULL,NULL),(11722,11722,1,'MLS120615-135718-123801','CRTS-MLS',209.32675,-12.63369,NULL,NULL,'2012-06-15 00:00:00',56093,20.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120615/1206150121904107524.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120615/jpg/1206150121904107524.master.jpg',NULL,NULL,43663718483,NULL,NULL,NULL,'2005-04-05 12:28:48',53465.520004,'2013-01-19 01:32:20','http://crts.caltech.edu/ATEL/MLS/1206150121904107524/1206150121904107524.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120615/1206150121904107524p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,682245601,10660087,NULL,NULL,NULL,NULL),(11723,11723,1,'MLS120615-135735-080633','CRTS-MLS',209.39694,-8.10907,NULL,NULL,'2012-06-15 00:00:00',56093,20.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120615/1206150081924112917.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120615/jpg/1206150081924112917.master.jpg',NULL,NULL,43698839814,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','http://crts.caltech.edu/ATEL/MLS/1206150081924112917/1206150081924112917.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120615/1206150081924112917p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,682794372,10668662,NULL,NULL,NULL,NULL),(11724,11724,1,'MLS120609-102937+122453','CRTS-MLS',157.40326,12.41463,NULL,NULL,'2012-06-09 00:00:00',56087,19.8,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120609/1206091121434107519.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120609/jpg/1206091121434107519.master.jpg',NULL,NULL,61173642328,NULL,NULL,NULL,'2011-11-01 13:26:29',55866.560059,'2013-01-19 01:32:20','http://crts.caltech.edu/ATEL/MLS/1206091121434107519/1206091121434107519.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120609/1206091121434107519p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,955838161,14934971,NULL,NULL,NULL,NULL),(11725,11725,1,'MLS120608-102919+111255','CRTS-MLS',157.33101,11.21515,NULL,NULL,'2012-06-08 00:00:00',56086,19.71,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120608/1206081111434107090.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120608/jpg/1206081111434107090.master.jpg',NULL,NULL,61038267448,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','http://crts.caltech.edu/ATEL/MLS/1206081111434107090/1206081111434107090.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120608/1206081111434107090p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,953722928,14901920,NULL,NULL,NULL,NULL),(11726,11726,1,'MLS120528-203937-091535','CRTS-MLS',309.9027,-9.25965,NULL,NULL,'2012-05-28 00:00:00',56075,19.92,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120528/1205280092844116211.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120528/jpg/1205280092844116211.master.jpg',NULL,NULL,50765345390,NULL,NULL,NULL,'2011-09-19 13:26:29',55823.560059,'2013-01-19 01:32:20','http://crts.caltech.edu/ATEL/MLS/1205280092844116211/1205280092844116211.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120528/1205280092844116211p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,793208521,12393883,NULL,NULL,NULL,NULL),(11727,11727,1,'MLS120522-151538+022616','CRTS-MLS',228.9073,2.43767,NULL,NULL,'2012-05-22 00:00:00',56069,20.59,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120522/1205221022124105651.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120522/jpg/1205221022124105651.master.jpg',NULL,NULL,56384869699,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','http://crts.caltech.edu/ATEL/MLS/1205221022124105651/1205221022124105651.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120522/1205221022124105651p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,881013589,13765837,NULL,NULL,NULL,NULL),(11728,11728,1,'MLS120522-131133-012219','CRTS-MLS',197.88936,-1.3719,NULL,NULL,'2012-05-22 00:00:00',56069,21.45,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120522/1205220011844114091.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120522/jpg/1205220011844114091.master.jpg',NULL,NULL,43091388481,NULL,NULL,NULL,'2011-04-01 12:28:49',55652.52002,'2013-01-19 01:32:20','http://crts.caltech.edu/ATEL/MLS/1205220011844114091/1205220011844114091.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120522/1205220011844114091p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,673302945,10520358,NULL,NULL,NULL,NULL),(11729,11729,1,'MLS120514-153601-153731','CRTS-MLS',234.00481,-15.62514,NULL,NULL,'2012-05-14 00:00:00',56061,19.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120514/1205140152094114943.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120514/jpg/1205140152094114943.master.jpg',NULL,NULL,46606095974,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','http://crts.caltech.edu/ATEL/MLS/1205140152094114943/1205140152094114943.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120514/1205140152094114943p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,728220249,11378441,NULL,NULL,NULL,NULL),(11730,11730,1,'MLS120514-120338-015447','CRTS-MLS',180.90953,-1.91297,NULL,NULL,'2012-05-14 00:00:00',56061,20.9,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120514/1205140011684103809.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120514/jpg/1205140011684103809.master.jpg',NULL,NULL,42964980590,NULL,NULL,NULL,'2011-04-26 10:33:30',55677.439941,'2013-01-19 01:32:20','http://crts.caltech.edu/ATEL/MLS/1205140011684103809/1205140011684103809.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120514/1205140011684103809p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,671327821,10489497,NULL,NULL,NULL,NULL),(11731,11731,1,'MLS120512-082752+282059','CRTS-MLS',126.96666,28.34977,NULL,NULL,'2012-05-12 00:00:00',56059,18.47,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120512/1205121281044103209.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120512/jpg/1205121281044103209.master.jpg',NULL,NULL,64350272232,NULL,NULL,NULL,'2011-05-28 13:26:29',55709.560059,'2013-01-19 01:32:20','http://crts.caltech.edu/ATEL/MLS/1205121281044103209/1205121281044103209.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120512/1205121281044103209p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1005473003,15710515,NULL,NULL,NULL,NULL),(11734,11734,1,'MLS120428-124152+050524','CRTS-MLS',190.4681,5.09004,NULL,NULL,'2012-04-28 00:00:00',56045,20.56,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120428/1204281041764112601.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120428/jpg/1204281041764112601.master.jpg',NULL,NULL,58224990426,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:20','http://crts.caltech.edu/ATEL/MLS/1204281041764112601/1204281041764112601.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120428/1204281041764112601p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,909765475,14215085,NULL,NULL,NULL,NULL),(11735,11735,1,'MLS120422-080911+300623','CRTS-MLS',122.29599,30.10639,NULL,NULL,'2012-04-22 00:00:00',56039,19.1,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120422/1204221290994117745.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120422/jpg/1204221290994117745.master.jpg',NULL,NULL,64346572626,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1204221290994117745/1204221290994117745.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120422/1204221290994117745p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1005415197,15709612,NULL,NULL,NULL,NULL),(11736,11736,1,'MLS120420-081726+194123','CRTS-MLS',124.36034,19.68983,NULL,NULL,'2012-04-20 00:00:00',56037,20.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120420/1204201201094103691.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120420/jpg/1204201201094103691.master.jpg',NULL,NULL,63815510542,NULL,NULL,NULL,'2008-12-07 10:33:30',54807.439941,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1204201201094103691/1204201201094103691.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120420/1204201201094103691p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,997117352,15579958,NULL,NULL,NULL,NULL),(11737,11737,1,'MLS120420-150007-121349','CRTS-MLS',225.02794,-12.23027,NULL,NULL,'2012-04-20 00:00:00',56037,20.11,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120420/1204200122044117942.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120420/jpg/1204200122044117942.master.jpg',NULL,NULL,46489680866,NULL,NULL,NULL,'2012-03-14 13:26:29',56000.560059,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1204200122044117942/1204200122044117942.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120420/1204200122044117942p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,726401263,11350019,NULL,NULL,NULL,NULL),(11738,11738,1,'MLS120420-131819-030941','CRTS-MLS',199.5781,-3.16136,NULL,NULL,'2012-04-20 00:00:00',56037,20.64,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120420/1204200021854101820.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120420/jpg/1204200021854101820.master.jpg',NULL,NULL,43828398108,NULL,NULL,NULL,'2006-05-09 12:28:49',53864.52002,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1204200021854101820/1204200021854101820.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120420/1204200021854101820p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,684818720,10700292,NULL,NULL,NULL,NULL),(11741,11741,1,'MLS120418-132802-033134','CRTS-MLS',202.00905,-3.52621,NULL,NULL,'2012-04-18 00:00:00',56035,20.98,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120418/1204180031874114335.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120418/jpg/1204180031874114335.master.jpg',NULL,NULL,43836758096,NULL,NULL,NULL,'2006-05-09 13:26:23',53864.559998,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1204180031874114335/1204180031874114335.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120418/1204180031874114335p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,684949345,10702333,NULL,NULL,NULL,NULL),(11743,11743,1,'MLS120401-133048-062230','CRTS-MLS',202.69884,-6.37503,NULL,NULL,'2012-04-01 00:00:00',56018,20.01,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120401/1204010051874101572.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120401/jpg/1204010051874101572.master.jpg',NULL,NULL,43877565039,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1204010051874101572/1204010051874101572.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120401/1204010051874101572p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,685586953,10712296,NULL,NULL,NULL,NULL),(11744,11744,1,'MLS120330-123540+035119','CRTS-MLS',188.9163,3.85532,NULL,NULL,'2012-03-30 00:00:00',56016,19.23,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120330/1203301031754108840.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120330/jpg/1203301031754108840.master.jpg',NULL,NULL,58231245072,NULL,NULL,NULL,'2011-04-02 13:26:29',55653.560059,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1203301031754108840/1203301031754108840.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120330/1203301031754108840p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,909863204,14216612,NULL,NULL,NULL,NULL),(11745,11745,1,'MLS120329-095455+144508','CRTS-MLS',148.72933,14.75214,NULL,NULL,'2012-03-29 00:00:00',56015,20.8,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120329/1203291141344110605.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120329/jpg/1203291141344110605.master.jpg',NULL,NULL,60822751080,NULL,NULL,NULL,'2007-11-07 13:26:29',54411.560059,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1203291141344110605/1203291141344110605.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120329/1203291141344110605p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,950355485,14849304,NULL,NULL,NULL,NULL),(11746,11746,1,'MLS120328-090241+195752','CRTS-MLS',135.66927,19.96457,NULL,NULL,'2012-03-28 00:00:00',56014,20.95,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120328/1203281201194108225.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120328/jpg/1203281201194108225.master.jpg',NULL,NULL,63833527701,NULL,NULL,NULL,'2006-11-02 11:31:10',54041.47998,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1203281201194108225/1203281201194108225.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120328/1203281201194108225p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,997398870,15584357,NULL,NULL,NULL,NULL),(11747,11747,1,'MLS120328-085636+142046','CRTS-MLS',134.15085,14.34613,NULL,NULL,'2012-03-28 00:00:00',56014,20.74,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120328/1203281141214104917.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120328/jpg/1203281141214104917.master.jpg',NULL,NULL,63874302054,NULL,NULL,NULL,'2010-02-13 13:26:29',55240.560059,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1203281141214104917/1203281141214104917.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120328/1203281141214104917p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,998035969,15594312,NULL,NULL,NULL,NULL),(11748,11748,1,'MLS120323-122425-070950','CRTS-MLS',186.10394,-7.16389,NULL,NULL,'2012-03-23 00:00:00',56009,20.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120323/1203230071724108058.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120323/jpg/1203230071724108058.master.jpg',NULL,NULL,43203053489,NULL,NULL,NULL,'2008-03-27 11:31:10',54552.47998,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1203230071724108058/1203230071724108058.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120323/1203230071724108058p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,675047710,10547620,NULL,NULL,NULL,NULL),(11749,11749,1,'MLS120322-095827+194305','CRTS-MLS',149.61425,19.71811,NULL,NULL,'2012-03-22 00:00:00',56008,19.58,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120322/1203221201314104774.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120322/jpg/1203221201314104774.master.jpg',NULL,NULL,63698371333,NULL,NULL,NULL,'2007-10-18 11:31:10',54391.47998,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1203221201314104774/1203221201314104774.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120322/1203221201314104774p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,995287052,15551360,NULL,NULL,NULL,NULL),(11750,11750,1,'MLS120321-105901+103640','CRTS-MLS',164.75474,10.61107,NULL,NULL,'2012-03-21 00:00:00',56007,20.34,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120321/1203211101514115536.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120321/jpg/1203211101514115536.master.jpg',NULL,NULL,61034441518,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1203211101514115536/1203211101514115536.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120321/1203211101514115536p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,953663148,14900986,NULL,NULL,NULL,NULL),(11751,11751,1,'MLS120321-104701+100808','CRTS-MLS',161.75326,10.13547,NULL,NULL,'2012-03-21 00:00:00',56007,20.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120321/1203211101484105898.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120321/jpg/1203211101484105898.master.jpg',NULL,NULL,61055943146,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1203211101484105898/1203211101484105898.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120321/1203211101484105898p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,953999111,14906236,NULL,NULL,NULL,NULL),(11752,11752,1,'MLS120321-120418+024708','CRTS-MLS',181.07642,2.78554,NULL,NULL,'2012-03-21 00:00:00',56007,20.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120321/1203211021684111150.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120321/jpg/1203211021684111150.master.jpg',NULL,NULL,57996444521,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1203211021684111150/1203211021684111150.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120321/1203211021684111150p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,906194445,14159288,NULL,NULL,NULL,NULL),(11753,11753,1,'MLS120317-114454+091107','CRTS-MLS',176.22423,9.18539,NULL,NULL,'2012-03-17 00:00:00',56003,18.92,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120317/1203171091624109184.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120317/jpg/1203171091624109184.master.jpg',NULL,NULL,60380746653,NULL,NULL,NULL,'2010-03-16 10:33:30',55271.439941,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1203171091624109184/1203171091624109184.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120317/1203171091624109184p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,943449166,14741393,NULL,NULL,NULL,NULL),(11754,11754,1,'MLS120317-113641+063735','CRTS-MLS',174.17279,6.6265,NULL,NULL,'2012-03-17 00:00:00',56003,21.23,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120317/1203171071614102468.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120317/jpg/1203171071614102468.master.jpg',NULL,NULL,60381685611,NULL,NULL,NULL,'2006-02-02 13:26:23',53768.559998,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1203171071614102468/1203171071614102468.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120317/1203171071614102468p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,943463837,14741622,NULL,NULL,NULL,NULL),(11755,11755,1,'MLS120316-101958+184415','CRTS-MLS',154.9931,18.73738,NULL,NULL,'2012-03-16 00:00:00',56002,20.6,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120316/1203161181374104743.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120316/jpg/1203161181374104743.master.jpg',NULL,NULL,60939170714,NULL,NULL,NULL,'2007-10-24 13:26:29',54397.560059,'2013-01-19 01:32:21','http://crts.caltech.edu/ATEL/MLS/1203161181374104743/1203161181374104743.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120316/1203161181374104743p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,952174542,14877727,NULL,NULL,NULL,NULL),(11757,11757,1,'MLS120316-110638+023644','CRTS-MLS',166.66016,2.61224,NULL,NULL,'2012-03-16 00:00:00',56002,19.42,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120316/1203161021554108476.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120316/jpg/1203161021554108476.master.jpg',NULL,NULL,60293850455,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1203161021554108476/1203161021554108476.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120316/1203161021554108476p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,942091413,14720178,NULL,NULL,NULL,NULL),(11758,11758,1,'MLS120315-104756+045425','CRTS-MLS',161.98312,4.90684,NULL,NULL,'2012-03-15 00:00:00',56001,22.01,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120315/1203151041504111209.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120315/jpg/1203151041504111209.master.jpg',NULL,NULL,61006798433,NULL,NULL,NULL,'2010-05-25 10:33:30',55341.439941,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1203151041504111209/1203151041504111209.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120315/1203151041504111209p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,953231225,14894237,NULL,NULL,NULL,NULL),(11759,11759,1,'MLS120315-104409+034123','CRTS-MLS',161.03767,3.68985,NULL,NULL,'2012-03-15 00:00:00',56001,21.06,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120315/1203151031494107829.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120315/jpg/1203151031494107829.master.jpg',NULL,NULL,60273847011,NULL,NULL,NULL,'2006-02-02 13:26:23',53768.559998,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1203151031494107829/1203151031494107829.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120315/1203151031494107829p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,941778859,14715294,NULL,NULL,NULL,NULL),(11760,11760,1,'MLS120315-114300-011007','CRTS-MLS',175.74817,-1.16854,NULL,NULL,'2012-03-15 00:00:00',56001,20.43,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120315/1203150011634113614.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120315/jpg/1203150011634113614.master.jpg',NULL,NULL,40806674270,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1203150011634113614/1203150011634113614.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120315/1203150011634113614p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,637604285,9962566,NULL,NULL,NULL,NULL),(11761,11761,1,'MLS120313-113505+001640','CRTS-MLS',173.77136,0.27774,NULL,NULL,'2012-03-13 00:00:00',55999,20.19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120313/1203131001614104838.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120313/jpg/1203131001614104838.master.jpg',NULL,NULL,60168193183,NULL,NULL,NULL,'2011-04-30 13:26:29',55681.560059,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1203131001614104838/1203131001614104838.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120313/1203131001614104838p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,940128018,14689500,NULL,NULL,NULL,NULL),(11762,11762,1,'MLS120304-025140+173932','CRTS-MLS',42.91499,17.65902,NULL,NULL,'2012-03-04 00:00:00',55990,17.96,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120304/1203041170384103430.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120304/jpg/1203041170384103430.master.jpg',NULL,NULL,68178347299,NULL,NULL,NULL,'2007-10-31 10:33:30',54404.439941,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1203041170384103430/1203041170384103430.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120304/1203041170384103430p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1065286676,16645104,NULL,NULL,NULL,NULL),(11763,11763,1,'MLS120301-104941+031730','CRTS-MLS',162.41987,3.29162,NULL,NULL,'2012-03-01 00:00:00',55987,19.27,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120301/1203011031504100595.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120301/jpg/1203011031504100595.master.jpg',NULL,NULL,60275267384,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1203011031504100595/1203011031504100595.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120301/1203011031504100595p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,941801052,14715641,NULL,NULL,NULL,NULL),(11764,11764,1,'MLS120225-080449+191228','CRTS-MLS',121.20271,19.20767,NULL,NULL,'2012-02-25 00:00:00',55982,20.62,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120225/1202251181074118356.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120225/jpg/1202251181074118356.master.jpg',NULL,NULL,63758513002,NULL,NULL,NULL,'2007-01-09 12:28:49',54109.52002,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1202251181074118356/1202251181074118356.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120225/1202251181074118356p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,996226765,15566043,NULL,NULL,NULL,NULL),(11765,11765,1,'MLS120225-093407+103726','CRTS-MLS',143.53017,10.62399,NULL,NULL,'2012-02-25 00:00:00',55982,20.93,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120225/1202251101314116850.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120225/jpg/1202251101314116850.master.jpg',NULL,NULL,60703495741,NULL,NULL,NULL,'2011-11-03 11:31:10',55868.47998,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1202251101314116850/1202251101314116850.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120225/1202251101314116850p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,948492120,14820189,NULL,NULL,NULL,NULL),(11766,11766,0,'MLS120225-151643-143838','CRTS-MLS',229.17868,-14.64393,NULL,NULL,'2012-02-25 00:00:00',55982,19.25,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/MLS/20120225/1202250142064112771.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120225/jpg/1202250142064112771.master.jpg',NULL,NULL,46674013242,NULL,NULL,NULL,'2006-03-05 11:31:10',53799.47998,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1202250142064112771/1202250142064112771.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120225/1202250142064112771p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,729281456,11395022,NULL,NULL,NULL,NULL),(11767,11767,1,'MLS120225-134515-064632','CRTS-MLS',206.31382,-6.77558,NULL,NULL,'2012-02-25 00:00:00',55982,20.81,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120225/1202250071904115058.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120225/jpg/1202250071904115058.master.jpg',NULL,NULL,43583153792,NULL,NULL,NULL,'2011-05-23 13:26:29',55704.560059,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1202250071904115058/1202250071904115058.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120225/1202250071904115058p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,680986778,10640418,NULL,NULL,NULL,NULL),(11768,11768,1,'MLS120224-104015+121023','CRTS-MLS',160.06451,12.17305,NULL,NULL,'2012-02-24 00:00:00',55981,19.97,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120224/1202241121454104078.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120224/jpg/1202241121454104078.master.jpg',NULL,NULL,61176543949,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1202241121454104078/1202241121454104078.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120224/1202241121454104078p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,955883499,14935679,NULL,NULL,NULL,NULL),(11769,11769,1,'MLS120223-100818+132621','CRTS-MLS',152.07349,13.43922,NULL,NULL,'2012-02-23 00:00:00',55980,20.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120223/1202231131374107560.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120223/jpg/1202231131374107560.master.jpg',NULL,NULL,60845763345,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1202231131374107560/1202231131374107560.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120223/1202231131374107560p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,950715052,14854922,NULL,NULL,NULL,NULL),(11770,11770,1,'MLS120223-104214+044328','CRTS-MLS',160.55757,4.7245,NULL,NULL,'2012-02-23 00:00:00',55980,21.33,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120223/1202231041494107875.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120223/jpg/1202231041494107875.master.jpg',NULL,NULL,61009508573,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1202231041494107875/1202231041494107875.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120223/1202231041494107875p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,953273571,14894899,NULL,NULL,NULL,NULL),(11771,11771,1,'MLS120223-110659+033442','CRTS-MLS',166.74501,3.57836,NULL,NULL,'2012-02-23 00:00:00',55980,19.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120223/1202231031544105552.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120223/jpg/1202231031544105552.master.jpg',NULL,NULL,60286671101,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1202231031544105552/1202231031544105552.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120223/1202231031544105552p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,941979235,14718425,NULL,NULL,NULL,NULL),(11772,11772,1,'MLS120211-085038+184029','CRTS-MLS',132.65699,18.67464,NULL,NULL,'2012-02-11 00:00:00',55968,20.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120211/1202111181174103278.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120211/jpg/1202111181174103278.master.jpg',NULL,NULL,63882664530,NULL,NULL,NULL,'2011-01-05 12:28:49',55566.52002,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1202111181174103278/1202111181174103278.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120211/1202111181174103278p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,998166633,15596353,NULL,NULL,NULL,NULL),(11773,11773,1,'MLS120211-024712+175746','CRTS-MLS',41.7994,17.96291,NULL,NULL,'2012-02-11 00:00:00',55968,19.52,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120211/1202111170374109192.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120211/jpg/1202111170374109192.master.jpg',NULL,NULL,68174573139,NULL,NULL,NULL,'2005-03-11 10:33:36',53440.440002,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1202111170374109192/1202111170374109192.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120211/1202111170374109192p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,1065227705,16644182,NULL,NULL,NULL,NULL),(11774,11774,1,'MLS120211-092738+153502','CRTS-MLS',141.9096,15.58389,NULL,NULL,'2012-02-11 00:00:00',55968,20.35,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120211/1202111151274105829.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120211/jpg/1202111151274105829.master.jpg',NULL,NULL,63733510169,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1202111151274105829/1202111151274105829.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120211/1202111151274105829p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,995836096,15559939,NULL,NULL,NULL,NULL),(11775,11775,1,'MLS120210-075930+194611','CRTS-MLS',119.87385,19.7696,NULL,NULL,'2012-02-10 00:00:00',55967,19.93,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120210/1202101201054105023.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120210/jpg/1202101201054105023.master.jpg',NULL,NULL,62622693597,NULL,NULL,NULL,'2006-12-12 11:31:10',54081.47998,'2013-01-19 01:32:22','http://crts.caltech.edu/ATEL/MLS/1202101201054105023/1202101201054105023.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120210/1202101201054105023p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,978479587,15288743,NULL,NULL,NULL,NULL),(11776,11776,1,'MLS120130-155638-175824','CRTS-MLS',239.16035,-17.97338,NULL,NULL,'2012-01-30 00:00:00',55956,19.67,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120130/1201300172124113099.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120130/jpg/1201300172124113099.master.jpg',NULL,NULL,45488206134,NULL,NULL,NULL,'2006-03-05 11:31:10',53799.47998,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1201300172124113099/1201300172124113099.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120130/1201300172124113099p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,710753220,11105519,NULL,NULL,NULL,NULL),(11777,11777,1,'MLS120130-134019-140028','CRTS-MLS',205.07769,-14.00779,NULL,NULL,'2012-01-30 00:00:00',55956,20.11,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120130/1201300131854101533.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120130/jpg/1201300131854101533.master.jpg',NULL,NULL,43656251105,NULL,NULL,NULL,'2011-04-12 13:26:29',55663.560059,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1201300131854101533/1201300131854101533.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120130/1201300131854101533p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,682128923,10658264,NULL,NULL,NULL,NULL),(11778,11778,1,'MLS120130-140053-110152','CRTS-MLS',210.22143,-11.03107,NULL,NULL,'2012-01-30 00:00:00',55956,21.08,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120130/1201300111914118107.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120130/jpg/1201300111914118107.master.jpg',NULL,NULL,43747350945,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1201300111914118107/1201300111914118107.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120130/1201300111914118107p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,683552358,10680505,NULL,NULL,NULL,NULL),(11779,11779,1,'MLS120127-090330+202037','CRTS-MLS',135.87627,20.34371,NULL,NULL,'2012-01-27 00:00:00',55953,20.34,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120127/1201271201194115601.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120127/jpg/1201271201194115601.master.jpg',NULL,NULL,63833435233,NULL,NULL,NULL,'2006-11-02 12:28:49',54041.52002,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1201271201194115601/1201271201194115601.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120127/1201271201194115601p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,997397425,15584334,NULL,NULL,NULL,NULL),(11780,11780,1,'MLS120127-081146+155505','CRTS-MLS',122.93963,15.91805,NULL,NULL,'2012-01-27 00:00:00',55953,19.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120127/1201271151104116575.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120127/jpg/1201271151104116575.master.jpg',NULL,NULL,62653237510,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1201271151104116575/1201271151104116575.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120127/1201271151104116575p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,978956836,15296200,NULL,NULL,NULL,NULL),(11781,11781,1,'MLS120126-075421+234644','CRTS-MLS',118.58775,23.77898,NULL,NULL,'2012-01-26 00:00:00',55952,19.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120126/1201261231024121869.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120126/jpg/1201261231024121869.master.jpg',NULL,NULL,63756942611,NULL,NULL,NULL,'2011-05-21 13:26:29',55702.560059,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1201261231024121869/1201261231024121869.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120126/1201261231024121869p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,996202228,15565659,NULL,NULL,NULL,NULL),(11782,11782,1,'MLS120126-081334+183447','CRTS-MLS',123.38978,18.5797,NULL,NULL,'2012-01-26 00:00:00',55952,19.44,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120126/1201261181094103580.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120126/jpg/1201261181094103580.master.jpg',NULL,NULL,63812424012,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1201261181094103580/1201261181094103580.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120126/1201261181094103580p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,997069125,15579205,NULL,NULL,NULL,NULL),(11784,11784,1,'MLS120120-080401+151513','CRTS-MLS',121.00332,15.25359,NULL,NULL,'2012-01-20 00:00:00',55946,18,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120120/1201201151084102466.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120120/jpg/1201201151084102466.master.jpg',NULL,NULL,62651383735,NULL,NULL,NULL,'2011-01-23 13:26:29',55584.560059,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1201201151084102466/1201201151084102466.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120120/1201201151084102466p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,978927870,15295747,NULL,NULL,NULL,NULL),(11785,11785,1,'MLS120120-012859+111527','CRTS-MLS',22.24383,11.25739,NULL,NULL,'2012-01-20 00:00:00',55946,19.64,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120120/1201201110214106308.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120120/jpg/1201201110214106308.master.jpg',NULL,NULL,67530279887,NULL,NULL,NULL,'2006-12-24 10:33:36',54093.440002,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1201201110214106308/1201201110214106308.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120120/1201201110214106308p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1055160623,16486884,NULL,NULL,NULL,NULL),(11786,11786,1,'MLS120119-075219+274911','CRTS-MLS',118.07762,27.81974,NULL,NULL,'2012-01-19 00:00:00',55945,20.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120119/1201191270984115943.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120119/jpg/1201191270984115943.master.jpg',NULL,NULL,64292393299,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1201191270984115943/1201191270984115943.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120119/1201191270984115943p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1004568645,15696385,NULL,NULL,NULL,NULL),(11788,11788,1,'MLS120104-075718+195732','CRTS-MLS',119.32624,19.95891,NULL,NULL,'2012-01-04 00:00:00',55930,20.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120104/1201041201054109301.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120104/jpg/1201041201054109301.master.jpg',NULL,NULL,62622353565,NULL,NULL,NULL,'2006-09-25 10:33:36',54003.440002,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1201041201054109301/1201041201054109301.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120104/1201041201054109301p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,978474274,15288660,NULL,NULL,NULL,NULL),(11789,11789,1,'MLS120104-095743+101704','CRTS-MLS',149.42725,10.28444,NULL,NULL,'2012-01-04 00:00:00',55930,20.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120104/1201041101374109034.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120104/jpg/1201041101374109034.master.jpg',NULL,NULL,60930070596,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1201041101374109034/1201041101374109034.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120104/1201041101374109034p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,952032353,14875505,NULL,NULL,NULL,NULL),(11790,11790,1,'MLS111227-071633+293258','CRTS-MLS',109.13724,29.54944,NULL,NULL,'2011-12-27 00:00:00',55922,20.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111227/1112271290894108355.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111227/jpg/1112271290894108355.master.jpg',NULL,NULL,63008450069,NULL,NULL,NULL,'2011-04-08 13:26:29',55659.560059,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1112271290894108355/1112271290894108355.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111227/1112271290894108355p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,984507032,15382922,NULL,NULL,NULL,NULL),(11791,11791,1,'MLS111227-080448+173647','CRTS-MLS',121.20054,17.61315,NULL,NULL,'2011-12-27 00:00:00',55922,20.59,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111227/1112271171084106284.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111227/jpg/1112271171084106284.master.jpg',NULL,NULL,62668009320,NULL,NULL,NULL,'2011-02-26 13:26:29',55618.560059,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1112271171084106284/1112271171084106284.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111227/1112271171084106284p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,979187645,15299806,NULL,NULL,NULL,NULL),(11792,11792,1,'MLS111227-124651-055601','CRTS-MLS',191.71148,-5.93361,NULL,NULL,'2011-12-27 00:00:00',55922,20.25,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111227/1112270051774107142.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111227/jpg/1112270051774107142.master.jpg',NULL,NULL,43126082332,NULL,NULL,NULL,'2005-03-04 13:26:23',53433.559998,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1112270051774107142/1112270051774107142.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111227/1112270051774107142p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,673845036,10528828,NULL,NULL,NULL,NULL),(11793,11793,1,'MLS111226-225156-023401','CRTS-MLS',342.98159,-2.56702,NULL,NULL,'2011-12-26 00:00:00',55921,19.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111226/1112260023184108659.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111226/jpg/1112260023184108659.master.jpg',NULL,NULL,49469737286,NULL,NULL,NULL,'2006-10-01 10:33:36',54009.440002,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1112260023184108659/1112260023184108659.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111226/1112260023184108659p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,772964645,12077572,NULL,NULL,NULL,NULL),(11794,11794,1,'MLS111225-113846+035506','CRTS-MLS',174.69192,3.91821,NULL,NULL,'2011-12-25 00:00:00',55920,20.4,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111225/1112251031624110260.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111225/jpg/1112251031624110260.master.jpg',NULL,NULL,60181611104,NULL,NULL,NULL,'2011-03-14 13:26:29',55634.560059,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1112251031624110260/1112251031624110260.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111225/1112251031624110260p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,940337673,14692776,NULL,NULL,NULL,NULL),(11796,11796,0,'MLS111130-032136+223346','CRTS-MLS',50.40201,22.56282,NULL,NULL,'2011-11-30 00:00:00',55895,17.61,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:23','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/MLS/20111130/1111301220444119707.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111130/jpg/1111301220444119707.master.jpg',NULL,NULL,68011486798,NULL,NULL,NULL,'2010-10-29 13:26:29',55498.560059,'2013-01-19 01:32:23','http://crts.caltech.edu/ATEL/MLS/1111301220444119707/1111301220444119707.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111130/1111301220444119707p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1062679481,16604366,NULL,NULL,NULL,NULL),(11797,11797,1,'MLS111129-012905+114913','CRTS-MLS',22.27183,11.82021,NULL,NULL,'2011-11-29 00:00:00',55894,20.29,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111129/1111291110214109479.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111129/jpg/1111291110214109479.master.jpg',NULL,NULL,67529991838,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1111291110214109479/1111291110214109479.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111129/1111291110214109479p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1055156122,16486814,NULL,NULL,NULL,NULL),(11798,11798,1,'MLS111129-012021+105810','CRTS-MLS',20.08897,10.96957,NULL,NULL,'2011-11-29 00:00:00',55894,19.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111129/1111291110194101989.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111129/jpg/1111291110194101989.master.jpg',NULL,NULL,67536675774,NULL,NULL,NULL,'2011-10-18 13:26:29',55852.560059,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1111291110194101989/1111291110194101989.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111129/1111291110194101989p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1055260558,16488446,NULL,NULL,NULL,NULL),(11800,11800,1,'MLS111127-033342+131632','CRTS-MLS',53.42561,13.27569,NULL,NULL,'2011-11-27 00:00:00',55892,19.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111127/1111271130494103793.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111127/jpg/1111271130494103793.master.jpg',NULL,NULL,68015451927,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1111271130494103793/1111271130494103793.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111127/1111271130494103793p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1062741436,16605334,NULL,NULL,NULL,NULL),(11801,11801,1,'MLS111127-022116+125551','CRTS-MLS',35.31798,12.93077,NULL,NULL,'2011-11-27 00:00:00',55892,20.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111127/1111271120324113719.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111127/jpg/1111271120324113719.master.jpg',NULL,NULL,66942029617,NULL,NULL,NULL,'2008-09-07 10:33:30',54716.439941,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1111271120324113719/1111271120324113719.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111127/1111271120324113719p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1045969212,16343268,NULL,NULL,NULL,NULL),(11802,11802,1,'MLS111126-071406+271059','CRTS-MLS',108.52549,27.18312,NULL,NULL,'2011-11-26 00:00:00',55891,19.24,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111126/1111261270904103014.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111126/jpg/1111261270904103014.master.jpg',NULL,NULL,63014476495,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1111261270904103014/1111261270904103014.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111126/1111261270904103014p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,984601195,15384393,NULL,NULL,NULL,NULL),(11803,11803,1,'MLS111123-000235+001552','CRTS-MLS',0.64656,0.26442,NULL,NULL,'2011-11-23 00:00:00',55888,20.33,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111123/1111231000014104311.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111123/jpg/1111231000014104311.master.jpg',NULL,NULL,66572939667,NULL,NULL,NULL,'2005-10-24 12:28:47',53667.519989,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1111231000014104311/1111231000014104311.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111123/1111231000014104311p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1040202182,16253159,NULL,NULL,NULL,NULL),(11804,11804,1,'MLS111116-004252+031300','CRTS-MLS',10.71529,3.21675,NULL,NULL,'2011-11-16 00:00:00',55881,20.23,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111116/1111161020104113217.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111116/jpg/1111161020104113217.master.jpg',NULL,NULL,66821753272,NULL,NULL,NULL,'2010-01-14 13:26:29',55210.560059,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1111161020104113217/1111161020104113217.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111116/1111161020104113217p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1044089894,16313904,NULL,NULL,NULL,NULL),(11805,11805,1,'MLS111103-105634+041319','CRTS-MLS',164.13977,4.22183,NULL,NULL,'2011-11-03 00:00:00',55868,20.33,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111103/1111031031524113881.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111103/jpg/1111031031524113881.master.jpg',NULL,NULL,60319658107,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1111031031524113881/1111031031524113881.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111103/1111031031524113881p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,942494657,14726479,NULL,NULL,NULL,NULL),(11806,11806,1,'MLS111102-105331+050450','CRTS-MLS',163.37833,5.08068,NULL,NULL,'2011-11-02 00:00:00',55867,20.67,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111102/1111021041514109546.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111102/jpg/1111021041514109546.master.jpg',NULL,NULL,60319112350,NULL,NULL,NULL,'2006-11-11 13:26:23',54050.559998,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1111021041514109546/1111021041514109546.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111102/1111021041514109546p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,942486130,14726345,NULL,NULL,NULL,NULL),(11807,11807,1,'MLS111031-020050+010720','CRTS-MLS',30.20791,1.12216,NULL,NULL,'2011-10-31 00:00:00',55865,20.4,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111031/1110311010284100817.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111031/jpg/1110311010284100817.master.jpg',NULL,NULL,67005689577,NULL,NULL,NULL,'2006-10-04 13:26:23',54012.559998,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1110311010284100817/1110311010284100817.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111031/1110311010284100817p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1046963899,16358810,NULL,NULL,NULL,NULL),(11808,11808,1,'MLS111030-103725+080534','CRTS-MLS',159.35237,8.09284,NULL,NULL,'2011-10-30 00:00:00',55864,19.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111030/1110301081474108069.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111030/jpg/1110301081474108069.master.jpg',NULL,NULL,61067363365,NULL,NULL,NULL,'2011-06-05 13:26:29',55717.560059,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1110301081474108069/1110301081474108069.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111030/1110301081474108069p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,954177552,14909024,NULL,NULL,NULL,NULL),(11809,11809,1,'MLS111029-230618-013254','CRTS-MLS',346.5769,-1.54835,NULL,NULL,'2011-10-29 00:00:00',55863,20.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111029/1110290013214111237.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111029/jpg/1110290013214111237.master.jpg',NULL,NULL,49508918861,NULL,NULL,NULL,'2006-10-02 12:28:49',54010.52002,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1110290013214111237/1110290013214111237.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111029/1110290013214111237p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,773576857,12087138,NULL,NULL,NULL,NULL),(11810,11810,1,'MLS111028-092534+134312','CRTS-MLS',141.39234,13.72012,NULL,NULL,'2011-10-28 00:00:00',55862,19.68,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111028/1110281131284110206.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111028/jpg/1110281131284110206.master.jpg',NULL,NULL,63857424791,NULL,NULL,NULL,'2011-05-24 13:26:29',55705.560059,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1110281131284110206/1110281131284110206.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111028/1110281131284110206p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,997772262,15590191,NULL,NULL,NULL,NULL),(11811,11811,1,'MLS111025-085546+165324','CRTS-MLS',133.94025,16.89011,NULL,NULL,'2011-10-25 00:00:00',55859,19.33,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111025/1110251161204208349.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111025/jpg/1110251161204208349.master.jpg',NULL,NULL,63885060106,NULL,NULL,NULL,'2011-01-05 12:28:49',55566.52002,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1110251161204208349/1110251161204208349.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111025/1110251161204208349p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,998204064,15596938,NULL,NULL,NULL,NULL),(11812,11812,1,'MLS111024-015106+091908','CRTS-MLS',27.77702,9.31902,NULL,NULL,'2011-10-24 00:00:00',55858,21.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111024/1110241090264111669.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111024/jpg/1110241090264111669.master.jpg',NULL,NULL,67056954661,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1110241090264111669/1110241090264111669.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111024/1110241090264111669p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1047764916,16371326,NULL,NULL,NULL,NULL),(11813,11813,1,'MLS111023-223806-033504','CRTS-MLS',339.52311,-3.58456,NULL,NULL,'2011-10-23 00:00:00',55857,19.98,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111023/1110230033144111963.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111023/jpg/1110230033144111963.master.jpg',NULL,NULL,50346098046,NULL,NULL,NULL,'2010-11-28 13:26:29',55528.560059,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1110230033144111963/1110230033144111963.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111023/1110230033144111963p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,786657781,12291527,NULL,NULL,NULL,NULL),(11814,11814,1,'MLS111022-081449+192315','CRTS-MLS',123.70389,19.38739,NULL,NULL,'2011-10-22 00:00:00',55856,20.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111022/1110221181094118433.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111022/jpg/1110221181094118433.master.jpg',NULL,NULL,63816312888,NULL,NULL,NULL,'2009-05-15 13:26:29',54966.560059,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1110221181094118433/1110221181094118433.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111022/1110221181094118433p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,997129888,15580154,NULL,NULL,NULL,NULL),(11815,11815,1,'MLS111022-004928+015715','CRTS-MLS',12.36711,1.95417,NULL,NULL,'2011-10-22 00:00:00',55856,20.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111022/1110221010124115499.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111022/jpg/1110221010124115499.master.jpg',NULL,NULL,66686702570,NULL,NULL,NULL,'2011-10-03 13:26:29',55837.560059,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1110221010124115499/1110221010124115499.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111022/1110221010124115499p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1041979727,16280933,NULL,NULL,NULL,NULL),(11816,11816,1,'MLS111020-035008+153926','CRTS-MLS',57.53317,15.65717,NULL,NULL,'2011-10-20 00:00:00',55854,20.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111020/1110201150524106831.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111020/jpg/1110201150524106831.master.jpg',NULL,NULL,65124058752,NULL,NULL,NULL,'2010-12-01 13:26:29',55531.560059,'2013-01-19 01:32:24','http://crts.caltech.edu/ATEL/MLS/1110201150524106831/1110201150524106831.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111020/1110201150524106831p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1017563418,15899428,NULL,NULL,NULL,NULL),(11817,11817,1,'MLS111019-014622+145108','CRTS-MLS',26.59088,14.85226,NULL,NULL,'2011-10-19 00:00:00',55853,20.45,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111019/1110191140244111083.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111019/jpg/1110191140244111083.master.jpg',NULL,NULL,66940606442,NULL,NULL,NULL,'2010-10-17 10:33:30',55486.439941,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1110191140244111083/1110191140244111083.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111019/1110191140244111083p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1045946975,16342921,NULL,NULL,NULL,NULL),(11818,11818,1,'MLS111019-220216-123633','CRTS-MLS',330.56601,-12.60923,NULL,NULL,'2011-10-19 00:00:00',55853,19.27,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111019/1110190123004106926.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111019/jpg/1110190123004106926.master.jpg',NULL,NULL,49749678359,NULL,NULL,NULL,'2011-09-24 12:28:49',55828.52002,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1110190123004106926/1110190123004106926.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111019/1110190123004106926p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,777338724,12145917,NULL,NULL,NULL,NULL),(11819,11819,1,'MLS111019-230046-081411','CRTS-MLS',345.19001,-8.23634,NULL,NULL,'2011-10-19 00:00:00',55853,20.65,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111019/1110190083174107101.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111019/jpg/1110190083174107101.master.jpg',NULL,NULL,49485595204,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1110190083174107101/1110190083174107101.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111019/1110190083174107101p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,773212425,12081444,NULL,NULL,NULL,NULL),(11820,11820,1,'MLS111018-035322+190349','CRTS-MLS',58.34371,19.06368,NULL,NULL,'2011-10-18 00:00:00',55852,19.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111018/1110181180524108549.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111018/jpg/1110181180524108549.master.jpg',NULL,NULL,67990550231,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1110181180524108549/1110181180524108549.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111018/1110181180524108549p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1062352347,16599255,NULL,NULL,NULL,NULL),(11821,11821,1,'MLS111018-230236-053124','CRTS-MLS',345.64937,-5.52321,NULL,NULL,'2011-10-18 00:00:00',55852,20.58,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111018/1110180053184113800.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111018/jpg/1110180053184113800.master.jpg',NULL,NULL,49523222797,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1110180053184113800/1110180053184113800.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111018/1110180053184113800p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,773800356,12090630,NULL,NULL,NULL,NULL),(11822,11822,1,'MLS111018-230738-051313','CRTS-MLS',346.90625,-5.22025,NULL,NULL,'2011-10-18 00:00:00',55852,20.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111018/1110180043204103071.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111018/jpg/1110180043204103071.master.jpg',NULL,NULL,49513223867,NULL,NULL,NULL,'2005-10-25 11:31:12',53668.480011,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1110180043204103071/1110180043204103071.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111018/1110180043204103071p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,773644122,12088189,NULL,NULL,NULL,NULL),(11823,11823,1,'MLS111003-002437-012122','CRTS-MLS',6.15519,-1.3561,NULL,NULL,'2011-10-03 00:00:00',55837,20.8,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111003/1110030010064111845.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111003/jpg/1110030010064111845.master.jpg',NULL,NULL,34401261410,NULL,NULL,NULL,'2006-12-26 13:26:23',54095.559998,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1110030010064111845/1110030010064111845.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111003/1110030010064111845p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,537519709,8398745,NULL,NULL,NULL,NULL),(11824,11824,1,'MLS111001-002408+073155','CRTS-MLS',6.03382,7.53202,NULL,NULL,'2011-10-01 00:00:00',55835,19.01,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111001/1110011070064113332.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111001/jpg/1110011070064113332.master.jpg',NULL,NULL,66826685352,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1110011070064113332/1110011070064113332.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111001/1110011070064113332p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,1044166958,16315108,NULL,NULL,NULL,NULL),(11825,11825,1,'MLS111001-235057-001403','CRTS-MLS',357.73784,-0.23425,NULL,NULL,'2011-10-01 00:00:00',55835,19.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111001/1110010003314111706.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111001/jpg/1110010003314111706.master.jpg',NULL,NULL,49393377134,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1110010003314111706/1110010003314111706.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111001/1110010003314111706p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,771771517,12058929,NULL,NULL,NULL,NULL),(11826,11826,1,'MLS110928-003544+013947','CRTS-MLS',8.93195,1.66297,NULL,NULL,'2011-09-28 00:00:00',55832,21.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110928/1109281010094110612.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110928/jpg/1109281010094110612.master.jpg',NULL,NULL,66590645043,NULL,NULL,NULL,'2009-12-13 11:31:10',55178.47998,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1109281010094110612/1109281010094110612.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110928/1109281010094110612p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1040478828,16257481,NULL,NULL,NULL,NULL),(11827,11827,0,'MLS110921-234531-075647','CRTS-MLS',356.3805,-7.94626,NULL,NULL,'2011-09-21 00:00:00',55825,19.36,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/MLS/20110921/1109210083274110019.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110921/jpg/1109210083274110019.master.jpg',NULL,NULL,49617475080,NULL,NULL,NULL,'2009-09-20 12:28:49',55094.52002,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1109210083274110019/1109210083274110019.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110921/1109210083274110019p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,775273048,12113641,NULL,NULL,NULL,NULL),(11828,11828,1,'MLS110919-235442+025617','CRTS-MLS',358.6766,2.93798,NULL,NULL,'2011-09-19 00:00:00',55823,19.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110919/1109191023324113300.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110919/jpg/1109191023324113300.master.jpg',NULL,NULL,51546962223,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1109191023324113300/1109191023324113300.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110919/1109191023324113300p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,805421284,12584707,NULL,NULL,NULL,NULL),(11829,11829,1,'MLS110918-233252-015838','CRTS-MLS',353.21802,-1.97728,NULL,NULL,'2011-09-18 00:00:00',55822,20.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110918/1109180013274102806.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110918/jpg/1109180013274102806.master.jpg',NULL,NULL,49421955524,NULL,NULL,NULL,'2011-06-25 11:31:10',55737.47998,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1109180013274102806/1109180013274102806.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110918/1109180013274102806p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,772218055,12065907,NULL,NULL,NULL,NULL),(11830,11830,0,'MLS110628-161930-055908','CRTS-MLS',244.87701,-5.98547,NULL,NULL,'2011-06-28 00:00:00',55740,18.96,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/MLS/20110628/1106280052264113622.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110628/jpg/1106280052264113622.master.jpg',NULL,NULL,45556733732,NULL,NULL,NULL,'2010-09-03 13:26:29',55442.560059,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1106280052264113622/1106280052264113622.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110628/1106280052264113622p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,711823964,11122249,NULL,NULL,NULL,NULL),(11831,11831,1,'MLS110607-140118-112401','CRTS-MLS',210.326,-11.40029,NULL,NULL,'2011-06-07 00:00:00',55719,18.65,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110607/1106070111924109417.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110607/jpg/1106070111924109417.master.jpg',NULL,NULL,43747450633,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1106070111924109417/1106070111924109417.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110607/1106070111924109417p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,683553916,10680529,NULL,NULL,NULL,NULL),(11832,11832,1,'MLS110603-135215-001421','CRTS-MLS',208.06358,-0.23908,NULL,NULL,'2011-06-03 00:00:00',55715,21.16,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110603/1106030001934116509.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110603/jpg/1106030001934116509.master.jpg',NULL,NULL,43608243694,NULL,NULL,NULL,'2009-03-24 13:26:29',54914.560059,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1106030001934116509/1106030001934116509.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110603/1106030001934116509p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,681378807,10646543,NULL,NULL,NULL,NULL),(11833,11833,1,'MLS110526-104421+082012','CRTS-MLS',161.08778,8.33657,NULL,NULL,'2011-05-26 00:00:00',55707,21.02,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110526/1105261081484111205.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110526/jpg/1105261081484111205.master.jpg',NULL,NULL,61066273295,NULL,NULL,NULL,'2010-05-25 13:26:29',55341.560059,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1105261081484111205/1105261081484111205.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110526/1105261081484111205p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,954160520,14908758,NULL,NULL,NULL,NULL),(11834,11834,0,'MLS110507-082649+202231','CRTS-MLS',126.70495,20.37535,NULL,NULL,'2011-05-07 00:00:00',55688,18.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/MLS/20110507/1105071201114115208.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110507/jpg/1105071201114115208.master.jpg',NULL,NULL,63819532644,NULL,NULL,NULL,'2011-01-23 13:26:29',55584.560059,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1105071201114115208/1105071201114115208.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110507/1105071201114115208p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,997180197,15580940,NULL,NULL,NULL,NULL),(11835,11835,0,'MLS110507-145837+022059','CRTS-MLS',224.65459,2.34974,NULL,NULL,'2011-05-07 00:00:00',55688,19.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/MLS/20110507/1105071022084103115.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110507/jpg/1105071022084103115.master.jpg',NULL,NULL,59327452539,NULL,NULL,NULL,'2007-04-26 11:31:10',54216.47998,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1105071022084103115/1105071022084103115.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110507/1105071022084103115p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,926991445,14484241,NULL,NULL,NULL,NULL),(11836,11836,1,'MLS110503-134315-070246','CRTS-MLS',205.81111,-7.04621,NULL,NULL,'2011-05-03 00:00:00',55684,19.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110503/1105030071904109835.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110503/jpg/1105030071904109835.master.jpg',NULL,NULL,43583962713,NULL,NULL,NULL,'2010-03-15 13:26:29',55270.560059,'2013-01-19 01:32:25','http://crts.caltech.edu/ATEL/MLS/1105030071904109835/1105030071904109835.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110503/1105030071904109835p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,680999417,10640615,NULL,NULL,NULL,NULL),(11837,11837,1,'MLS110503-134403-072313','CRTS-MLS',206.01449,-7.38701,NULL,NULL,'2011-05-03 00:00:00',55684,21.02,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110503/1105030071904103829.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110503/jpg/1105030071904103829.master.jpg',NULL,NULL,43583721794,NULL,NULL,NULL,'2005-03-09 13:26:23',53438.559998,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1105030071904103829/1105030071904103829.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110503/1105030071904103829p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,680995653,10640557,NULL,NULL,NULL,NULL),(11838,11838,1,'MLS110430-132800-102852','CRTS-MLS',201.99833,-10.48118,NULL,NULL,'2011-04-30 00:00:00',55681,17.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110430/1104300101854107440.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110430/jpg/1104300101854107440.master.jpg',NULL,NULL,43871506654,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1104300101854107440/1104300101854107440.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110430/1104300101854107440p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,685492291,10710817,NULL,NULL,NULL,NULL),(11839,11839,1,'MLS110405-113211-020148','CRTS-MLS',173.04469,-2.03001,NULL,NULL,'2011-04-05 00:00:00',55656,20.95,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110405/1104050011614102460.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110405/jpg/1104050011614102460.master.jpg',NULL,NULL,40831938786,NULL,NULL,NULL,'2010-03-13 13:26:29',55268.560059,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1104050011614102460/1104050011614102460.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110405/1104050011614102460p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,637999043,9968735,NULL,NULL,NULL,NULL),(11840,11840,1,'MLS110404-110052+101203','CRTS-MLS',165.21768,10.2008,NULL,NULL,'2011-04-04 00:00:00',55655,19.41,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110404/1104041101514107128.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110404/jpg/1104041101514107128.master.jpg',NULL,NULL,61033949846,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1104041101514107128/1104041101514107128.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110404/1104041101514107128p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,953655466,14900866,NULL,NULL,NULL,NULL),(11842,11842,1,'MLS110329-115737+021302','CRTS-MLS',179.40382,2.21718,NULL,NULL,'2011-03-29 00:00:00',55649,20.6,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110329/1103291021664101051.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110329/jpg/1103291021664101051.master.jpg',NULL,NULL,60130665601,NULL,NULL,NULL,'2011-03-06 13:26:29',55626.560059,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1103291021664101051/1103291021664101051.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110329/1103291021664101051p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,939541650,14680338,NULL,NULL,NULL,NULL),(11843,11843,1,'MLS110314-112615+105157','CRTS-MLS',171.56304,10.86591,NULL,NULL,'2011-03-14 00:00:00',55634,20.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110314/1103141111564100856.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110314/jpg/1103141111564100856.master.jpg',NULL,NULL,60341245443,NULL,NULL,NULL,'2007-11-07 13:26:29',54411.560059,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1103141111564100856/1103141111564100856.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110314/1103141111564100856p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,942831960,14731749,NULL,NULL,NULL,NULL),(11844,11844,1,'MLS110312-110709+154832','CRTS-MLS',166.78795,15.80893,NULL,NULL,'2011-03-12 00:00:00',55632,19.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110312/1103121151494111818.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110312/jpg/1103121151494111818.master.jpg',NULL,NULL,61144322153,NULL,NULL,NULL,'2009-02-15 13:26:29',54877.560059,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1103121151494111818/1103121151494111818.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110312/1103121151494111818p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,955380033,14927813,NULL,NULL,NULL,NULL),(11845,11845,1,'MLS110310-112922+295114','CRTS-MLS',172.34317,29.85385,NULL,NULL,'2011-03-10 00:00:00',55630,20.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110310/1103101291404111668.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110310/jpg/1103101291404111668.master.jpg',NULL,NULL,60658362371,NULL,NULL,NULL,'2008-11-21 13:26:29',54791.560059,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1103101291404111668/1103101291404111668.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110310/1103101291404111668p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,947786912,14809170,NULL,NULL,NULL,NULL),(11846,11846,1,'MLS110309-112638+134509','CRTS-MLS',171.6583,13.75246,NULL,NULL,'2011-03-09 00:00:00',55629,20.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110309/1103091131554110133.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110309/jpg/1103091131554110133.master.jpg',NULL,NULL,60228092789,NULL,NULL,NULL,'2007-02-26 13:26:23',54157.559998,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1103091131554110133/1103091131554110133.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110309/1103091131554110133p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,941063949,14704124,NULL,NULL,NULL,NULL),(11847,11847,1,'MLS110308-101449+123313','CRTS-MLS',153.70339,12.55357,NULL,NULL,'2011-03-08 00:00:00',55628,20.9,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110308/1103081121404110892.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110308/jpg/1103081121404110892.master.jpg',NULL,NULL,60837103185,NULL,NULL,NULL,'2010-04-13 10:33:30',55299.439941,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1103081121404110892/1103081121404110892.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110308/1103081121404110892p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,950579737,14852808,NULL,NULL,NULL,NULL),(11848,11848,1,'MLS110302-092241+101649','CRTS-MLS',140.67033,10.28027,NULL,NULL,'2011-03-02 00:00:00',55622,21.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110302/1103021101294111207.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110302/jpg/1103021101294111207.master.jpg',NULL,NULL,63650089829,NULL,NULL,NULL,'2010-02-17 10:33:30',55244.439941,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1103021101294111207/1103021101294111207.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110302/1103021101294111207p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,994532653,15539572,NULL,NULL,NULL,NULL),(11849,11849,1,'MLS110302-094259+074050','CRTS-MLS',145.74598,7.68047,NULL,NULL,'2011-03-02 00:00:00',55622,19.98,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110302/1103021081344102352.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110302/jpg/1103021081344102352.master.jpg',NULL,NULL,60892544139,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1103021081344102352/1103021081344102352.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110302/1103021081344102352p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,951446002,14866343,NULL,NULL,NULL,NULL),(11850,11850,1,'MLS110302-150523-161041','CRTS-MLS',226.34565,-16.17801,NULL,NULL,'2011-03-02 00:00:00',55622,21.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110302/1103020152024102270.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110302/jpg/1103020152024102270.master.jpg',NULL,NULL,46705497655,NULL,NULL,NULL,'2007-05-13 11:31:10',54233.47998,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1103020152024102270/1103020152024102270.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110302/1103020152024102270p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,729773400,11402709,NULL,NULL,NULL,NULL),(11851,11851,1,'MLS110301-092035+111205','CRTS-MLS',140.14466,11.20142,NULL,NULL,'2011-03-01 00:00:00',55621,20.3,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110301/1103011111284108076.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110301/jpg/1103011111284108076.master.jpg',NULL,NULL,63651284930,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1103011111284108076/1103011111284108076.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110301/1103011111284108076p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,994551327,15539864,NULL,NULL,NULL,NULL),(11852,11852,1,'MLS110226-110325+070631','CRTS-MLS',165.85282,7.10858,NULL,NULL,'2011-02-26 00:00:00',55618,20.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110226/1102261071534108892.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110226/jpg/1102261071534108892.master.jpg',NULL,NULL,60310470385,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1102261071534108892/1102261071534108892.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110226/1102261071534108892p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,942351099,14724235,NULL,NULL,NULL,NULL),(11853,11853,1,'MLS110225-104818+085623','CRTS-MLS',162.07357,8.93962,NULL,NULL,'2011-02-25 00:00:00',55617,21.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110225/1102251091494105615.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110225/jpg/1102251091494105615.master.jpg',NULL,NULL,61054613974,NULL,NULL,NULL,'2006-05-28 12:28:49',53883.52002,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1102251091494105615/1102251091494105615.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110225/1102251091494105615p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,953978343,14905911,NULL,NULL,NULL,NULL),(11854,11854,1,'MLS110225-131516-071914','CRTS-MLS',198.81585,-7.32049,NULL,NULL,'2011-02-25 00:00:00',55617,20.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110225/1102250071834104307.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110225/jpg/1102250071834104307.master.jpg',NULL,NULL,43883966119,NULL,NULL,NULL,'2010-12-09 13:26:29',55539.560059,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1102250071834104307/1102250071834104307.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110225/1102250071834104307p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,685686970,10713858,NULL,NULL,NULL,NULL),(11855,11855,1,'MLS110213-014203+112145','CRTS-MLS',25.51272,11.3626,NULL,NULL,'2011-02-13 00:00:00',55605,19.36,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110213/1102131110244107042.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110213/jpg/1102131110244107042.master.jpg',NULL,NULL,67042581532,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1102131110244107042/1102131110244107042.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110213/1102131110244107042p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1047540336,16367817,NULL,NULL,NULL,NULL),(11856,11856,1,'MLS110212-084550+170838','CRTS-MLS',131.45836,17.144,NULL,NULL,'2011-02-12 00:00:00',55604,20.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110212/1102121161174115256.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110212/jpg/1102121161174115256.master.jpg',NULL,NULL,63849118639,NULL,NULL,NULL,'2010-04-11 10:33:30',55297.439941,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1102121161174115256/1102121161174115256.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110212/1102121161174115256p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,997642478,15588163,NULL,NULL,NULL,NULL),(11857,11857,1,'MLS110211-091006+131404','CRTS-MLS',137.52657,13.23451,NULL,NULL,'2011-02-11 00:00:00',55603,20.16,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110211/1102111131244105159.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110211/jpg/1102111131244105159.master.jpg',NULL,NULL,63866525576,NULL,NULL,NULL,'2005-03-09 10:33:36',53438.440002,'2013-01-19 01:32:26','http://crts.caltech.edu/ATEL/MLS/1102111131244105159/1102111131244105159.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110211/1102111131244105159p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,997914462,15592413,NULL,NULL,NULL,NULL),(11858,11858,1,'MLS110210-101045+074134','CRTS-MLS',152.68905,7.69288,NULL,NULL,'2011-02-10 00:00:00',55602,19.27,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110210/1102101081404102104.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110210/jpg/1102101081404102104.master.jpg',NULL,NULL,60756925797,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1102101081404102104/1102101081404102104.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110210/1102101081404102104p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,949326965,14833233,NULL,NULL,NULL,NULL),(11859,11859,1,'MLS110208-115629-003653','CRTS-MLS',179.12269,-0.61461,NULL,NULL,'2011-02-08 00:00:00',55600,20.36,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110208/1102080001664106915.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110208/jpg/1102080001664106915.master.jpg',NULL,NULL,40805995521,NULL,NULL,NULL,'2005-02-09 11:31:11',53410.479996,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1102080001664106915/1102080001664106915.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110208/1102080001664106915p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,637593680,9962401,NULL,NULL,NULL,NULL),(11860,11860,1,'MLS110207-091009+155650','CRTS-MLS',137.53852,15.94732,NULL,NULL,'2011-02-07 00:00:00',55599,20.3,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110207/1102071151234113969.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110207/jpg/1102071151234113969.master.jpg',NULL,NULL,63859359916,NULL,NULL,NULL,'2011-01-12 10:33:30',55573.439941,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1102071151234113969/1102071151234113969.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110207/1102071151234113969p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,997802498,15590664,NULL,NULL,NULL,NULL),(11861,11861,1,'MLS110129-035607+192755','CRTS-MLS',59.02959,19.46538,NULL,NULL,'2011-01-29 00:00:00',55590,19.29,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110129/1101291180524117193.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110129/jpg/1101291180524117193.master.jpg',NULL,NULL,67990188253,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1101291180524117193/1101291180524117193.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110129/1101291180524117193p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,1062346691,16599167,NULL,NULL,NULL,NULL),(11863,11863,1,'MLS110117-104810+034548','CRTS-MLS',162.04075,3.76343,NULL,NULL,'2011-01-17 00:00:00',55578,20.26,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110117/1101171031504106016.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110117/jpg/1101171031504106016.master.jpg',NULL,NULL,60276281525,NULL,NULL,NULL,'2010-04-12 10:33:30',55298.439941,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1101171031504106016/1101171031504106016.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110117/1101171031504106016p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,941816898,14715889,NULL,NULL,NULL,NULL),(11864,11864,1,'MLS110115-101250+111711','CRTS-MLS',153.20973,11.2865,NULL,NULL,'2011-01-15 00:00:00',55576,20.59,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110115/1101151111404106403.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110115/jpg/1101151111404106403.master.jpg',NULL,NULL,60869148418,NULL,NULL,NULL,'2010-12-11 12:28:49',55541.52002,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1101151111404106403/1101151111404106403.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110115/1101151111404106403p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,951080444,14860631,NULL,NULL,NULL,NULL),(11865,11865,1,'MLS110114-080505+292140','CRTS-MLS',121.27107,29.36124,NULL,NULL,'2011-01-14 00:00:00',55575,20.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110114/1101141290994102752.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110114/jpg/1101141290994102752.master.jpg',NULL,NULL,64301132090,NULL,NULL,NULL,'2008-05-13 13:26:29',54599.560059,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1101141290994102752/1101141290994102752.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110114/1101141290994102752p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,1004705188,15698518,NULL,NULL,NULL,NULL),(11866,11866,1,'MLS110114-074706+233205','CRTS-MLS',116.7754,23.53477,NULL,NULL,'2011-01-14 00:00:00',55575,20.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110114/1101141231004121004.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110114/jpg/1101141231004121004.master.jpg',NULL,NULL,62612772005,NULL,NULL,NULL,'2010-12-26 13:26:29',55556.560059,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1101141231004121004/1101141231004121004.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110114/1101141231004121004p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,978324562,15286321,NULL,NULL,NULL,NULL),(11867,11867,1,'MLS110113-133923-063233','CRTS-MLS',204.84461,-6.54262,NULL,NULL,'2011-01-13 00:00:00',55574,20.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110113/1101130071894117655.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110113/jpg/1101130071894117655.master.jpg',NULL,NULL,43582380446,NULL,NULL,NULL,'2010-12-10 13:26:29',55540.560059,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1101130071894117655/1101130071894117655.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110113/1101130071894117655p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,680974694,10640229,NULL,NULL,NULL,NULL),(11868,11868,1,'MLS110110-105658+111548','CRTS-MLS',164.24054,11.26325,NULL,NULL,'2011-01-10 00:00:00',55571,20.23,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110110/1101101111504105094.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110110/jpg/1101101111504105094.master.jpg',NULL,NULL,61026021709,NULL,NULL,NULL,'2010-06-14 10:33:30',55361.439941,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1101101111504105094/1101101111504105094.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110110/1101101111504105094p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,953531589,14898931,NULL,NULL,NULL,NULL),(11869,11869,0,'MLS110105-022545+161256','CRTS-MLS',36.43668,16.21557,NULL,NULL,'2011-01-05 00:00:00',55566,18.52,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/MLS/20110105/1101051150334108740.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110105/jpg/1101051150334108740.master.jpg',NULL,NULL,68081821036,NULL,NULL,NULL,'2007-12-15 10:33:30',54449.439941,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1101051150334108740/1101051150334108740.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110105/1101051150334108740p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1063778453,16621538,NULL,NULL,NULL,NULL),(11872,11872,1,'MLS110102-071845+174038','CRTS-MLS',109.68777,17.67728,NULL,NULL,'2011-01-02 00:00:00',55563,18.98,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110102/1101021170974111410.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110102/jpg/1101021170974111410.master.jpg',NULL,NULL,63124358723,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1101021170974111410/1101021170974111410.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110102/1101021170974111410p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,986318105,15411220,NULL,NULL,NULL,NULL),(11873,11873,1,'MLS101213-084555+160828','CRTS-MLS',131.47779,16.14113,NULL,NULL,'2010-12-13 00:00:00',55543,22.02,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101213/1012131151184118372.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101213/jpg/1012131151184118372.master.jpg',NULL,NULL,63848816725,NULL,NULL,NULL,'2010-04-05 13:26:29',55291.560059,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1012131151184118372/1012131151184118372.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101213/1012131151184118372p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,997637761,15588090,NULL,NULL,NULL,NULL),(11874,11874,1,'MLS101212-005238+053040','CRTS-MLS',13.15884,5.51101,NULL,NULL,'2010-12-12 00:00:00',55542,19.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101212/1012121050134101789.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101212/jpg/1012121050134101789.master.jpg',NULL,NULL,66691825170,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1012121050134101789/1012121050134101789.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101212/1012121050134101789p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1042059768,16282183,NULL,NULL,NULL,NULL),(11875,11875,1,'MLS101209-040429+121731','CRTS-MLS',61.12127,12.29208,NULL,NULL,'2010-12-09 00:00:00',55539,20.47,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101209/1012091120564105209.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101209/jpg/1012091120564105209.master.jpg',NULL,NULL,65137809880,NULL,NULL,NULL,'2010-02-16 13:26:29',55243.560059,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1012091120564105209/1012091120564105209.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101209/1012091120564105209p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1017778279,15902785,NULL,NULL,NULL,NULL),(11876,11876,1,'MLS101208-085152+155343','CRTS-MLS',132.96839,15.89541,NULL,NULL,'2010-12-08 00:00:00',55538,20.84,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101208/1012081151194115244.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101208/jpg/1012081151194115244.master.jpg',NULL,NULL,63880317055,NULL,NULL,NULL,'2010-04-07 13:26:29',55293.560059,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1012081151194115244/1012081151194115244.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101208/1012081151194115244p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,998129953,15595780,NULL,NULL,NULL,NULL),(11877,11877,1,'MLS101205-084046+131142','CRTS-MLS',130.18961,13.19496,NULL,NULL,'2010-12-05 00:00:00',55535,20.78,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101205/1012051131184104298.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101205/jpg/1012051131184104298.master.jpg',NULL,NULL,63852852000,NULL,NULL,NULL,'2008-02-02 13:26:29',54498.560059,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1012051131184104298/1012051131184104298.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101205/1012051131184104298p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,997700812,15589075,NULL,NULL,NULL,NULL),(11878,11878,1,'MLS101201-041720+252926','CRTS-MLS',64.33363,25.49057,NULL,NULL,'2010-12-01 00:00:00',55531,19.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101201/1012011250544111260.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101201/jpg/1012011250544111260.master.jpg',NULL,NULL,68317110076,NULL,NULL,NULL,'2006-02-01 10:33:36',53767.440002,'2013-01-19 01:32:27','http://crts.caltech.edu/ATEL/MLS/1012011250544111260/1012011250544111260.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101201/1012011250544111260p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1067454844,16678981,NULL,NULL,NULL,NULL),(11879,11879,0,'MLS101127-013034+104027','CRTS-MLS',22.64042,10.67417,NULL,NULL,'2010-11-27 00:00:00',55527,19.24,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/MLS/20101127/1011271100214110617.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101127/jpg/1011271100214110617.master.jpg',NULL,NULL,67531448522,NULL,NULL,NULL,'2010-10-28 13:26:29',55497.560059,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1011271100214110617/1011271100214110617.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101127/1011271100214110617p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,1055178883,16487170,NULL,NULL,NULL,NULL),(11880,11880,1,'MLS101127-013210+081548','CRTS-MLS',23.04338,8.26334,NULL,NULL,'2010-11-27 00:00:00',55527,20.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101127/1011271080224111399.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101127/jpg/1011271080224111399.master.jpg',NULL,NULL,67538386991,NULL,NULL,NULL,'2010-10-30 13:26:29',55499.560059,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1011271080224111399/1011271080224111399.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101127/1011271080224111399p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1055287296,16488864,NULL,NULL,NULL,NULL),(11881,11881,1,'MLS101116-213112-133414','CRTS-MLS',322.80117,-13.57062,NULL,NULL,'2010-11-16 00:00:00',55516,18.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101116/1011160132914106221.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101116/jpg/1011160132914106221.master.jpg',NULL,NULL,50952992576,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1011160132914106221/1011160132914106221.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101116/1011160132914106221p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,796140509,12439695,NULL,NULL,NULL,NULL),(11882,11882,1,'MLS101028-021344+125638','CRTS-MLS',33.43317,12.94376,NULL,NULL,'2010-10-28 00:00:00',55497,19.68,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101028/1010281120314113527.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101028/jpg/1010281120314113527.master.jpg',NULL,NULL,66943320243,NULL,NULL,NULL,'2010-02-13 13:26:29',55240.560059,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1010281120314113527/1010281120314113527.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101028/1010281120314113527p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1045989378,16343584,NULL,NULL,NULL,NULL),(11883,11883,1,'MLS101028-014949+043547','CRTS-MLS',27.45257,4.59638,NULL,NULL,'2010-10-28 00:00:00',55497,19.67,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101028/1010281040264102897.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101028/jpg/1010281040264102897.master.jpg',NULL,NULL,67026292723,NULL,NULL,NULL,'2009-10-24 13:26:29',55128.560059,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1010281040264102897/1010281040264102897.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101028/1010281040264102897p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1047285823,16363840,NULL,NULL,NULL,NULL),(11884,11884,1,'MLS101017-015454+131027','CRTS-MLS',28.72681,13.17408,NULL,NULL,'2010-10-17 00:00:00',55486,21.14,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101017/1010171130264103166.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101017/jpg/1010171130264103166.master.jpg',NULL,NULL,66932473027,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1010171130264103166/1010171130264103166.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101017/1010171130264103166p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,1045819891,16340935,NULL,NULL,NULL,NULL),(11885,11885,1,'MLS101013-014222+000648','CRTS-MLS',25.59325,0.11323,NULL,NULL,'2010-10-13 00:00:00',55482,20.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101013/1010131000244101783.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101013/jpg/1010131000244101783.master.jpg',NULL,NULL,66981176392,NULL,NULL,NULL,'2008-10-22 13:26:29',54761.560059,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1010131000244101783/1010131000244101783.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101013/1010131000244101783p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1046580881,16352826,NULL,NULL,NULL,NULL),(11886,11886,1,'MLS100930-033208+181721','CRTS-MLS',53.03351,18.28905,NULL,NULL,'2010-09-30 00:00:00',55469,19.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100930/1009301170474115017.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100930/jpg/1009301170474115017.master.jpg',NULL,NULL,68026285552,NULL,NULL,NULL,'2010-03-13 13:26:29',55268.560059,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1009301170474115017/1009301170474115017.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100930/1009301170474115017p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1062910711,16607979,NULL,NULL,NULL,NULL),(11887,11887,1,'MLS100930-010839+002814','CRTS-MLS',17.16061,0.47063,NULL,NULL,'2010-09-30 00:00:00',55469,19.62,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100930/1009301000164107326.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100930/jpg/1009301000164107326.master.jpg',NULL,NULL,66648368194,NULL,NULL,NULL,'2009-10-24 11:31:10',55128.47998,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1009301000164107326/1009301000164107326.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100930/1009301000164107326p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,1041380753,16271574,NULL,NULL,NULL,NULL),(11888,11888,0,'MLS100905-230343-071354','CRTS-MLS',345.93036,-7.23172,NULL,NULL,'2010-09-05 00:00:00',55444,18.98,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/MLS/20100905/1009050073194107188.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100905/jpg/1009050073194107188.master.jpg',NULL,NULL,49492309250,NULL,NULL,NULL,'2007-10-30 13:26:29',54403.560059,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1009050073194107188/1009050073194107188.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100905/1009050073194107188p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,773317332,12083083,NULL,NULL,NULL,NULL),(11889,11889,1,'MLS100904-233721+004507','CRTS-MLS',354.33738,0.75183,NULL,NULL,'2010-09-04 00:00:00',55443,20.62,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100904/1009041003284115517.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100904/jpg/1009041003284115517.master.jpg',NULL,NULL,51577750881,NULL,NULL,NULL,'2006-11-15 13:26:23',54054.559998,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1009041003284115517/1009041003284115517.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100904/1009041003284115517p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,805902357,12592224,NULL,NULL,NULL,NULL),(11890,11890,1,'MLS100904-225125-015605','CRTS-MLS',342.85576,-1.93482,NULL,NULL,'2010-09-04 00:00:00',55443,19.26,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100904/1009040013184103903.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100904/jpg/1009040013184103903.master.jpg',NULL,NULL,49470165504,NULL,NULL,NULL,'2008-10-08 13:26:29',54747.560059,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1009040013184103903/1009040013184103903.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100904/1009040013184103903p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,772971336,12077677,NULL,NULL,NULL,NULL),(11891,11891,1,'MLS100901-224523-070002','CRTS-MLS',341.34384,-7.0006,NULL,NULL,'2010-09-01 00:00:00',55440,19.97,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100901/1009010073144107840.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100901/jpg/1009010073144107840.master.jpg',NULL,NULL,50389524016,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1009010073144107840/1009010073144107840.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100901/1009010073144107840p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,787336312,12302129,NULL,NULL,NULL,NULL),(11892,11892,1,'MLS100619-221052-103113','CRTS-MLS',332.71567,-10.52024,NULL,NULL,'2010-06-19 00:00:00',55366,20.02,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100619/1006190103044106934.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100619/jpg/1006190103044106934.master.jpg',NULL,NULL,49877669843,NULL,NULL,NULL,'2005-06-17 11:31:12',53538.480011,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1006190103044106934/1006190103044106934.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100619/1006190103044106934p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,779338591,12177165,NULL,NULL,NULL,NULL),(11893,11893,1,'MLS100615-155433-164314','CRTS-MLS',238.63752,-16.72058,NULL,NULL,'2010-06-15 00:00:00',55362,19.6,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100615/1006150162134118186.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100615/jpg/1006150162134118186.master.jpg',NULL,NULL,45470718326,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1006150162134118186/1006150162134118186.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100615/1006150162134118186p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,710479973,11101249,NULL,NULL,NULL,NULL),(11894,11894,0,'MLS100610-221543-092017','CRTS-MLS',333.92732,-9.33815,NULL,NULL,'2010-06-10 00:00:00',55357,18.56,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/MLS/20100610/1006100093064107238.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100610/jpg/1006100093064107238.master.jpg',NULL,NULL,49831307399,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1006100093064107238/1006100093064107238.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100610/1006100093064107238p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,778614178,12165846,NULL,NULL,NULL,NULL),(11895,11895,1,'MLS100610-221229-092622','CRTS-MLS',333.11973,-9.4395,NULL,NULL,'2010-06-10 00:00:00',55357,20.31,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100610/1006100093054104240.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100610/jpg/1006100093054104240.master.jpg',NULL,NULL,49862950965,NULL,NULL,NULL,'2006-11-16 10:33:36',54055.440002,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1006100093054104240/1006100093054104240.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100610/1006100093054104240p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,779108608,12173572,NULL,NULL,NULL,NULL),(11896,11896,1,'MLS100520-144413-124913','CRTS-MLS',221.05269,-12.82034,NULL,NULL,'2010-05-20 00:00:00',55336,19.58,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100520/1005200122014103851.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100520/jpg/1005200122014103851.master.jpg',NULL,NULL,46683755618,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1005200122014103851/1005200122014103851.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100520/1005200122014103851p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,729433681,11397401,NULL,NULL,NULL,NULL),(11897,11897,1,'MLS100511-121241+005850','CRTS-MLS',183.17254,0.98044,NULL,NULL,'2010-05-11 00:00:00',55327,21.11,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100511/1005111001704118437.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100511/jpg/1005111001704118437.master.jpg',NULL,NULL,57989022890,NULL,NULL,NULL,'2010-04-13 13:26:29',55299.560059,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1005111001704118437/1005111001704118437.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100511/1005111001704118437p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,906078482,14157476,NULL,NULL,NULL,NULL),(11898,11898,0,'MLS100505-125840-032643','CRTS-MLS',194.66529,-3.44531,NULL,NULL,'2010-05-05 00:00:00',55321,18.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/MLS/20100505/1005050031804115503.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100505/jpg/1005050031804115503.master.jpg',NULL,NULL,43148860566,NULL,NULL,NULL,'2006-05-19 10:33:36',53874.440002,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1005050031804115503/1005050031804115503.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100505/1005050031804115503p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,674200946,10534389,NULL,NULL,NULL,NULL),(11899,11899,1,'MLS100409-104506+081910','CRTS-MLS',161.27424,8.31958,NULL,NULL,'2010-04-09 00:00:00',55295,20.25,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100409/1004091081484111617.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100409/jpg/1004091081484111617.master.jpg',NULL,NULL,61066751521,NULL,NULL,NULL,'2005-02-09 13:26:23',53410.559998,'2013-01-19 01:32:28','http://crts.caltech.edu/ATEL/MLS/1004091081484111617/1004091081484111617.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100409/1004091081484111617p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,954167992,14908874,NULL,NULL,NULL,NULL),(11900,11900,1,'MLS100407-093835+142119','CRTS-MLS',144.64615,14.35532,NULL,NULL,'2010-04-07 00:00:00',55293,20.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100407/1004071141304103920.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100407/jpg/1004071141304103920.master.jpg',NULL,NULL,63721629043,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/1004071141304103920/1004071141304103920.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100407/1004071141304103920p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,995650453,15557038,NULL,NULL,NULL,NULL),(11901,11901,1,'MLS100318-120855-033744','CRTS-MLS',182.22887,-3.62899,NULL,NULL,'2010-03-18 00:00:00',55273,19.52,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100318/1003180031694110614.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100318/jpg/1003180031694110614.master.jpg',NULL,NULL,43011469952,NULL,NULL,NULL,'2009-12-20 13:26:29',55185.560059,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/1003180031694110614/1003180031694110614.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100318/1003180031694110614p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,672054218,10500847,NULL,NULL,NULL,NULL),(11902,11902,1,'MLS100315-073816+195257','CRTS-MLS',114.56642,19.88251,NULL,NULL,'2010-03-15 00:00:00',55270,21.18,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100315/1003151201004109563.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100315/jpg/1003151201004109563.master.jpg',NULL,NULL,63094224897,NULL,NULL,NULL,'2007-11-05 12:28:49',54409.52002,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/1003151201004109563/1003151201004109563.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100315/1003151201004109563p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,985847264,15403863,NULL,NULL,NULL,NULL),(11903,11903,1,'MLS100315-114953-002513','CRTS-MLS',177.4726,-0.4204,NULL,NULL,'2010-03-15 00:00:00',55270,19.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100315/1003150001654110066.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100315/jpg/1003150001654110066.master.jpg',NULL,NULL,40817094977,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/1003150001654110066/1003150001654110066.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100315/1003150001654110066p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,637767109,9965111,NULL,NULL,NULL,NULL),(11904,11904,1,'MLS100313-131349-062327','CRTS-MLS',198.45317,-6.39084,NULL,NULL,'2010-03-13 00:00:00',55268,20.6,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100313/1003130051834102077.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100313/jpg/1003130051834102077.master.jpg',NULL,NULL,43884421716,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/1003130051834102077/1003130051834102077.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100313/1003130051834102077p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,685694089,10713970,NULL,NULL,NULL,NULL),(11905,11905,1,'MLS100218-125902-072202','CRTS-MLS',194.75661,-7.36734,NULL,NULL,'2010-02-18 00:00:00',55245,20.31,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100218/1002180071804103168.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100218/jpg/1002180071804103168.master.jpg',NULL,NULL,43124432928,NULL,NULL,NULL,'2007-02-17 13:26:23',54148.559998,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/1002180071804103168/1002180071804103168.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100218/1002180071804103168p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,673819264,10528426,NULL,NULL,NULL,NULL),(11906,11906,1,'MLS100215-090526+125350','CRTS-MLS',136.35757,12.89719,NULL,NULL,'2010-02-15 00:00:00',55242,20.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100215/1002151121244118059.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100215/jpg/1002151121244118059.master.jpg',NULL,NULL,63863304469,NULL,NULL,NULL,'2008-12-30 13:26:29',54830.560059,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/1002151121244118059/1002151121244118059.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100215/1002151121244118059p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,997864132,15591627,NULL,NULL,NULL,NULL),(11907,11907,1,'MLS100215-150114-123607','CRTS-MLS',225.30739,-12.60181,NULL,NULL,'2010-02-15 00:00:00',55242,20.62,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100215/1002150122054108433.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100215/jpg/1002150122054108433.master.jpg',NULL,NULL,46661663003,NULL,NULL,NULL,'2007-05-12 13:26:23',54232.559998,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/1002150122054108433/1002150122054108433.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100215/1002150122054108433p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,729088484,11392007,NULL,NULL,NULL,NULL),(11908,11908,1,'MLS100213-112923+035256','CRTS-MLS',172.34701,3.88231,NULL,NULL,'2010-02-13 00:00:00',55240,20.81,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100213/1002131031594109229.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100213/jpg/1002131031594109229.master.jpg',NULL,NULL,60354375203,NULL,NULL,NULL,'2006-04-21 11:31:10',53846.47998,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/1002131031594109229/1002131031594109229.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100213/1002131031594109229p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,943037112,14734954,NULL,NULL,NULL,NULL),(11909,11909,1,'MLS100116-004355+052117','CRTS-MLS',10.97916,5.35482,NULL,NULL,'2010-01-16 00:00:00',55212,18.29,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100116/1001161040114108805.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100116/jpg/1001161040114108805.master.jpg',NULL,NULL,66812057982,NULL,NULL,NULL,'2007-01-27 13:26:23',54127.559998,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/1001161040114108805/1001161040114108805.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100116/1001161040114108805p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1043938405,16311537,NULL,NULL,NULL,NULL),(11910,11910,1,'MLS091215-010622+070910','CRTS-MLS',16.59327,7.15283,NULL,NULL,'2009-12-15 00:00:00',55180,18.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20091215/912151070164106825.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20091215/jpg/912151070164106825.master.jpg',NULL,NULL,67550054336,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/912151070164106825/912151070164106825.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20091215/912151070164106825p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1055469599,16491712,NULL,NULL,NULL,NULL),(11911,11911,0,'MLS091124-114019+030018','CRTS-MLS',175.07856,3.0051,NULL,NULL,'2009-11-24 00:00:00',55159,17.12,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/MLS/20091124/911241021624111250.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20091124/jpg/911241021624111250.master.jpg',NULL,NULL,60195525519,NULL,NULL,NULL,'2007-05-10 12:28:49',54230.52002,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/911241021624111250/911241021624111250.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20091124/911241021624111250p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,940555086,14696173,NULL,NULL,NULL,NULL),(11912,11912,1,'MLS091116-235519-054237','CRTS-MLS',358.8291,-5.71021,NULL,NULL,'2009-11-16 00:00:00',55151,18.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20091116/911160053304111578.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20091116/jpg/911160053304111578.master.jpg',NULL,NULL,49430190195,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/911160053304111578/911160053304111578.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20091116/911160053304111578p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,772346721,12067917,NULL,NULL,NULL,NULL),(11913,11913,1,'MLS130118-051059+171100','CRTS-MLS',77.74565,17.18341,NULL,NULL,'2013-01-18 00:00:00',56310,20.64,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130118/1301181160704131410.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130118/jpg/1301181160704131410.master.jpg',NULL,NULL,65406092510,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/1301181160704131410/1301181160704131410.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130118/1301181160704131410p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,1021970195,15968284,NULL,NULL,NULL,NULL),(11914,11914,1,'MLS130117-102133+082404','CRTS-MLS',155.38816,8.40108,NULL,NULL,'2013-01-17 00:00:00',56309,21.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130117/1301171081434116294.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130117/jpg/1301171081434116294.master.jpg',NULL,NULL,60764788688,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/1301171081434116294/1301171081434116294.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130117/1301171081434116294p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,949449823,14835153,NULL,NULL,NULL,NULL),(11915,11915,1,'MLS130117-101948+081830','CRTS-MLS',154.952,8.30821,NULL,NULL,'2013-01-17 00:00:00',56309,20.44,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130117/1301171081434111203.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130117/jpg/1301171081434111203.master.jpg',NULL,NULL,60764742551,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/1301171081434111203/1301171081434111203.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130117/1301171081434111203p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,949449102,14835142,NULL,NULL,NULL,NULL),(11916,11916,1,'MLS130109-110417+044401','CRTS-MLS',166.06987,4.73371,NULL,NULL,'2013-01-09 00:00:00',56301,20.81,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130109/1301091041544105975.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130109/jpg/1301091041544105975.master.jpg',NULL,NULL,60315633598,NULL,NULL,NULL,'2005-03-08 10:33:36',53437.440002,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/1301091041544105975/1301091041544105975.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130109/1301091041544105975p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,942431774,14725496,NULL,NULL,NULL,NULL),(11917,11917,1,'MLS130106-230011+063314','CRTS-MLS',345.04568,6.55387,NULL,NULL,'2013-01-06 00:00:00',56298,20.62,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130106/1301061073184100952.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130106/jpg/1301061073184100952.master.jpg',NULL,NULL,51712964470,NULL,NULL,NULL,'2012-12-11 11:31:10',56272.47998,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/1301061073184100952/1301061073184100952.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130106/1301061073184100952p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,808015069,12625235,NULL,NULL,NULL,NULL),(11918,11918,1,'MLS121210-094643+161127','CRTS-MLS',146.68062,16.19086,NULL,NULL,'2012-12-10 00:00:00',56271,21.12,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121210/1212101151314111644.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121210/jpg/1212101151314111644.master.jpg',NULL,NULL,63726613329,NULL,NULL,NULL,'2005-03-14 13:26:23',53443.559998,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/1212101151314111644/1212101151314111644.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121210/1212101151314111644p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,995728333,15558255,NULL,NULL,NULL,NULL),(11919,11919,1,'MLS121206-013934+095812','CRTS-MLS',24.89272,9.96996,NULL,NULL,'2012-12-06 00:00:00',56267,20.46,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121206/1212061100234103795.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121206/jpg/1212061100234103795.master.jpg',NULL,NULL,67012254702,NULL,NULL,NULL,'2005-09-29 13:26:23',53642.559998,'2013-01-19 01:32:29','http://crts.caltech.edu/ATEL/MLS/1212061100234103795/1212061100234103795.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121206/1212061100234103795p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1047066479,16360413,NULL,NULL,NULL,NULL),(11920,11920,1,'MLS121202-104854+065417','CRTS-MLS',162.22454,6.90467,NULL,NULL,'2012-12-02 00:00:00',56263,19.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121202/1212021071504104451.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121202/jpg/1212021071504104451.master.jpg',NULL,NULL,61064498927,NULL,NULL,NULL,'2005-06-17 13:26:23',53538.559998,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1212021071504104451/1212021071504104451.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121202/1212021071504104451p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,954132795,14908324,NULL,NULL,NULL,NULL),(11921,11921,1,'MLS121120-000400+050839','CRTS-MLS',1.00197,5.14404,NULL,NULL,'2012-11-20 00:00:00',56251,20.65,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121120/1211201040014111706.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121120/jpg/1211201040014111706.master.jpg',NULL,NULL,66627554938,NULL,NULL,NULL,'2012-10-20 10:33:30',56220.439941,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1211201040014111706/1211201040014111706.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121120/1211201040014111706p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1041055545,16266492,NULL,NULL,NULL,NULL),(11922,11922,1,'MLS121114-044918+115940','CRTS-MLS',72.32571,11.99435,NULL,NULL,'2012-11-14 00:00:00',56245,19.4,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121114/1211141120664101878.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121114/jpg/1211141120664101878.master.jpg',NULL,NULL,65439769439,NULL,NULL,NULL,'2006-11-25 10:33:36',54064.440002,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1211141120664101878/1211141120664101878.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121114/1211141120664101878p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1022496397,15976506,NULL,NULL,NULL,NULL),(11923,11923,1,'MLS121114-232618-040735','CRTS-MLS',351.57345,-4.12641,NULL,NULL,'2012-11-14 00:00:00',56245,20.5,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121114/1211140033254104008.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121114/jpg/1211140033254104008.master.jpg',NULL,NULL,49636768015,NULL,NULL,NULL,'2012-09-13 11:31:10',56183.47998,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1211140033254104008/1211140033254104008.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121114/1211140033254104008p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,775574500,12118351,NULL,NULL,NULL,NULL),(11924,11924,1,'MLS121106-021242+080641','CRTS-MLS',33.17534,8.1114,NULL,NULL,'2012-11-06 00:00:00',56237,20.6,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121106/1211061080314108334.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121106/jpg/1211061080314108334.master.jpg',NULL,NULL,67094034463,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1211061080314108334/1211061080314108334.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121106/1211061080314108334p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1048344288,16380379,NULL,NULL,NULL,NULL),(11925,11925,1,'MLS121104-024339+195200','CRTS-MLS',40.91376,19.86673,NULL,NULL,'2012-11-04 00:00:00',56235,20.58,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121104/1211041200364106049.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121104/jpg/1211041200364106049.master.jpg',NULL,NULL,68090779867,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1211041200364106049/1211041200364106049.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121104/1211041200364106049p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1063918435,16623725,NULL,NULL,NULL,NULL),(11926,11926,1,'MLS121104-023802+180217','CRTS-MLS',39.50819,18.03798,NULL,NULL,'2012-11-04 00:00:00',56235,19.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121104/1211041170354108885.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121104/jpg/1211041170354108885.master.jpg',NULL,NULL,68070254723,NULL,NULL,NULL,'2009-09-23 10:33:30',55097.439941,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1211041170354108885/1211041170354108885.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121104/1211041170354108885p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1063597730,16618714,NULL,NULL,NULL,NULL),(11927,11927,1,'MLS121103-023328+184529','CRTS-MLS',38.36537,18.75817,NULL,NULL,'2012-11-03 00:00:00',56234,20.24,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121103/1211031180344103946.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121103/jpg/1211031180344103946.master.jpg',NULL,NULL,68099256644,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1211031180344103946/1211031180344103946.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121103/1211031180344103946p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1064050885,16625795,NULL,NULL,NULL,NULL),(11928,11928,1,'MLS121023-010423+090830','CRTS-MLS',16.09412,9.14171,NULL,NULL,'2012-10-23 00:00:00',56223,20.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121023/1210231090154105825.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121023/jpg/1210231090154105825.master.jpg',NULL,NULL,67558328635,NULL,NULL,NULL,'2008-10-21 10:33:30',54760.439941,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1210231090154105825/1210231090154105825.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121023/1210231090154105825p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1055598884,16493732,NULL,NULL,NULL,NULL),(11929,11929,1,'MLS121021-005106+074407','CRTS-MLS',12.77386,7.73524,NULL,NULL,'2012-10-21 00:00:00',56221,20.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121021/1210211080124102508.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121021/jpg/1210211080124102508.master.jpg',NULL,NULL,66671027076,NULL,NULL,NULL,'2012-09-17 12:28:49',56187.52002,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1210211080124102508/1210211080124102508.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121021/1210211080124102508p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1041734798,16277106,NULL,NULL,NULL,NULL),(11930,11930,1,'MLS121014-221110-115203','CRTS-MLS',332.79005,-11.8676,NULL,NULL,'2012-10-14 00:00:00',56214,19.29,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121014/1210140113034101043.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121014/jpg/1210140113034101043.master.jpg',NULL,NULL,49864203193,NULL,NULL,NULL,'2012-10-05 12:28:49',56205.52002,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1210140113034101043/1210140113034101043.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121014/1210140113034101043p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,779128174,12173877,NULL,NULL,NULL,NULL),(11931,11931,1,'MLS121011-004952+000833','CRTS-MLS',12.46658,0.1425,NULL,NULL,'2012-10-11 00:00:00',56211,20.35,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121011/1210111000124102018.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121011/jpg/1210111000124102018.master.jpg',NULL,NULL,66672979373,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1210111000124102018/1210111000124102018.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121011/1210111000124102018p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,1041765302,16277582,NULL,NULL,NULL,NULL),(11932,11932,1,'MLS121011-004300-020352','CRTS-MLS',10.74815,-2.0644,NULL,NULL,'2012-10-11 00:00:00',56211,20.45,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121011/1210110010104101515.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121011/jpg/1210110010104101515.master.jpg',NULL,NULL,34580279656,NULL,NULL,NULL,'2008-09-24 12:28:49',54733.52002,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1210110010104101515/1210110010104101515.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121011/1210110010104101515p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,540316869,8442451,NULL,NULL,NULL,NULL),(11933,11933,1,'MLS121011-000703-011433','CRTS-MLS',1.76111,-1.24256,NULL,NULL,'2012-10-11 00:00:00',56211,19.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121011/1210110010024111614.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121011/jpg/1210110010024111614.master.jpg',NULL,NULL,34373869666,NULL,NULL,NULL,'2012-09-21 13:26:29',56191.560059,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1210110010024111614/1210110010024111614.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121011/1210110010024111614p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,537091713,8392058,NULL,NULL,NULL,NULL),(11934,11934,1,'MLS121009-010216+111509','CRTS-MLS',15.56481,11.25244,NULL,NULL,'2012-10-09 00:00:00',56209,20.84,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121009/1210091110154105701.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121009/jpg/1210091110154105701.master.jpg',NULL,NULL,67554604806,NULL,NULL,NULL,'2009-10-27 11:31:10',55131.47998,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1210091110154105701/1210091110154105701.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121009/1210091110154105701p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1055540700,16492823,NULL,NULL,NULL,NULL),(11935,11935,1,'MLS121009-001811+080553','CRTS-MLS',4.54492,8.09801,NULL,NULL,'2012-10-09 00:00:00',56209,20.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121009/1210091080054106978.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121009/jpg/1210091080054106978.master.jpg',NULL,NULL,66797655737,NULL,NULL,NULL,'2012-09-24 13:26:29',56194.560059,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1210091080054106978/1210091080054106978.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121009/1210091080054106978p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,1043713370,16308021,NULL,NULL,NULL,NULL),(11937,11937,1,'MLS121004-012016+071024','CRTS-MLS',20.06556,7.1734,NULL,NULL,'2012-10-04 00:00:00',56204,20.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121004/1210041070194108250.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121004/jpg/1210041070194108250.master.jpg',NULL,NULL,67574783185,NULL,NULL,NULL,'2011-11-17 13:26:29',55882.560059,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1210041070194108250/1210041070194108250.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121004/1210041070194108250p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1055855987,16497749,NULL,NULL,NULL,NULL),(11938,11938,1,'MLS120925-001131+100946','CRTS-MLS',2.87894,10.16291,NULL,NULL,'2012-09-25 00:00:00',56195,20.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120925/1209251100034105608.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120925/jpg/1209251100034105608.master.jpg',NULL,NULL,66792744852,NULL,NULL,NULL,'2010-01-06 10:33:30',55202.439941,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1209251100034105608/1209251100034105608.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120925/1209251100034105608p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1043636638,16306822,NULL,NULL,NULL,NULL),(11939,11939,1,'MLS120923-002638+020443','CRTS-MLS',6.66036,2.07871,NULL,NULL,'2012-09-23 00:00:00',56193,20.51,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120923/1209231010074114332.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120923/jpg/1209231010074114332.master.jpg',NULL,NULL,66601782330,NULL,NULL,NULL,'2011-10-22 13:26:29',55856.560059,'2013-01-19 01:32:30','http://crts.caltech.edu/ATEL/MLS/1209231010074114332/1209231010074114332.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120923/1209231010074114332p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1040652848,16260200,NULL,NULL,NULL,NULL),(11940,11940,1,'MLS120921-003533-022845','CRTS-MLS',8.8868,-2.47919,NULL,NULL,'2012-09-21 00:00:00',56191,19.45,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120921/1209210020094113377.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120921/jpg/1209210020094113377.master.jpg',NULL,NULL,34579106690,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1209210020094113377/1209210020094113377.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120921/1209210020094113377p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,540298542,8442164,NULL,NULL,NULL,NULL),(11941,11941,1,'MLS120917-005051+064958','CRTS-MLS',12.71243,6.8327,NULL,NULL,'2012-09-17 00:00:00',56187,21.18,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120917/1209171070124104672.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120917/jpg/1209171070124104672.master.jpg',NULL,NULL,66663423460,NULL,NULL,NULL,'2009-01-02 11:31:10',54833.47998,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1209171070124104672/1209171070124104672.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120917/1209171070124104672p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1041615991,16275249,NULL,NULL,NULL,NULL),(11942,11942,1,'MLS120917-004046+022705','CRTS-MLS',10.19355,2.45145,NULL,NULL,'2012-09-17 00:00:00',56187,21.34,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120917/1209171020104105011.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120917/jpg/1209171020104105011.master.jpg',NULL,NULL,66810247939,NULL,NULL,NULL,'2011-11-16 13:26:29',55881.560059,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1209171020104105011/1209171020104105011.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120917/1209171020104105011p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1043910124,16311095,NULL,NULL,NULL,NULL),(11943,11943,1,'MLS120917-225327-023404','CRTS-MLS',343.36082,-2.56783,NULL,NULL,'2012-09-17 00:00:00',56187,20.68,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120917/1209170023184112770.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120917/jpg/1209170023184112770.master.jpg',NULL,NULL,49514892859,NULL,NULL,NULL,'2011-12-26 13:26:29',55921.560059,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1209170023184112770/1209170023184112770.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120917/1209170023184112770p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,773670200,12088596,NULL,NULL,NULL,NULL),(11944,11944,1,'MLS120828-023841+135717','CRTS-MLS',39.67264,13.95473,NULL,NULL,'2012-08-28 00:00:00',56167,20.36,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120828/1208281130364114204.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120828/jpg/1208281130364114204.master.jpg',NULL,NULL,68148010601,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1208281130364114204/1208281130364114204.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120828/1208281130364114204p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1064812665,16637697,NULL,NULL,NULL,NULL),(11945,11945,1,'MLS120616-152552-134855','CRTS-MLS',231.4685,-13.8154,NULL,NULL,'2012-06-16 00:00:00',56094,20.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160132094107259.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120616/jpg/1206160132094107259.master.jpg',NULL,NULL,46660661659,NULL,NULL,NULL,'2012-05-27 13:26:29',56074.560059,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1206160132094107259/1206160132094107259.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160132094107259p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,729072838,11391763,NULL,NULL,NULL,NULL),(11946,11946,1,'MLS120616-140552-125407','CRTS-MLS',211.46797,-12.90189,NULL,NULL,'2012-06-16 00:00:00',56094,21.33,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160121924101589.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120616/jpg/1206160121924101589.master.jpg',NULL,NULL,43645233705,NULL,NULL,NULL,'2012-05-13 13:26:29',56060.560059,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1206160121924101589/1206160121924101589.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160121924101589p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,681956776,10655574,NULL,NULL,NULL,NULL),(11947,11947,1,'MLS120616-140742-092446','CRTS-MLS',211.92417,-9.4128,NULL,NULL,'2012-06-16 00:00:00',56094,20.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160091944106889.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120616/jpg/1206160091944106889.master.jpg',NULL,NULL,43748595693,NULL,NULL,NULL,'2006-04-09 13:26:23',53834.559998,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1206160091944106889/1206160091944106889.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160091944106889p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,683571807,10680809,NULL,NULL,NULL,NULL),(11948,11948,1,'MLS120609-102746+135310','CRTS-MLS',156.93973,13.886,NULL,NULL,'2012-06-09 00:00:00',56087,20.46,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120609/1206091131424115203.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120609/jpg/1206091131424115203.master.jpg',NULL,NULL,60953242140,NULL,NULL,NULL,'2008-02-24 13:26:29',54520.560059,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1206091131424115203/1206091131424115203.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120609/1206091131424115203p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,952394408,14881162,NULL,NULL,NULL,NULL),(11949,11949,1,'MLS120527-134316-004051','CRTS-MLS',205.81788,-0.68086,NULL,NULL,'2012-05-27 00:00:00',56074,20.58,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120527/1205270001914107297.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120527/jpg/1205270001914107297.master.jpg',NULL,NULL,43564090690,NULL,NULL,NULL,'2012-01-11 13:26:29',55937.560059,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1205270001914107297/1205270001914107297.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120527/1205270001914107297p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,680688917,10635764,NULL,NULL,NULL,NULL),(11950,11950,1,'MLS120523-123833+000212','CRTS-MLS',189.63565,0.03675,NULL,NULL,'2012-05-23 00:00:00',56070,20.93,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120523/1205231001764100983.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120523/jpg/1205231001764100983.master.jpg',NULL,NULL,58001249001,NULL,NULL,NULL,'2011-06-25 13:26:29',55737.560059,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1205231001764100983/1205231001764100983.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120523/1205231001764100983p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,906269515,14160461,NULL,NULL,NULL,NULL),(11951,11951,1,'MLS120519-081440+261758','CRTS-MLS',123.66529,26.29939,NULL,NULL,'2012-05-19 00:00:00',56066,19.43,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120519/1205191261034105426.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120519/jpg/1205191261034105426.master.jpg',NULL,NULL,64298368827,NULL,NULL,NULL,'2010-02-07 13:26:29',55234.560059,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1205191261034105426/1205191261034105426.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120519/1205191261034105426p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1004662012,15697843,NULL,NULL,NULL,NULL),(11952,11952,1,'MLS120517-152246-042148','CRTS-MLS',230.69265,-4.36344,NULL,NULL,'2012-05-17 00:00:00',56064,18.71,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120517/1205170042134116927.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120517/jpg/1205170042134116927.master.jpg',NULL,NULL,45427182307,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1205170042134116927/1205170042134116927.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120517/1205170042134116927p.html',NULL,NULL,0,'AGN',NULL,0,NULL,0,709799723,11090620,NULL,NULL,NULL,NULL),(11954,11954,1,'MLS120515-114338+005344','CRTS-MLS',175.9096,0.89563,NULL,NULL,'2012-05-15 00:00:00',56062,21.02,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120515/1205151001634115564.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120515/jpg/1205151001634115564.master.jpg',NULL,NULL,60141463908,NULL,NULL,NULL,'2007-02-23 10:33:36',54154.440002,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1205151001634115564/1205151001634115564.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120515/1205151001634115564p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,939710373,14682974,NULL,NULL,NULL,NULL),(11955,11955,1,'MLS120513-152859-155726','CRTS-MLS',232.24723,-15.95719,NULL,NULL,'2012-05-13 00:00:00',56060,19.81,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120513/1205130152084108456.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120513/jpg/1205130152084108456.master.jpg',NULL,NULL,46605125046,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1205130152084108456/1205130152084108456.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120513/1205130152084108456p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,728205078,11378204,NULL,NULL,NULL,NULL),(11956,11956,1,'MLS120513-141857-123255','CRTS-MLS',214.7384,-12.54857,NULL,NULL,'2012-05-13 00:00:00',56060,21.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120513/1205130121954107436.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120513/jpg/1205130121954107436.master.jpg',NULL,NULL,43641255714,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1205130121954107436/1205130121954107436.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120513/1205130121954107436p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,681894620,10654603,NULL,NULL,NULL,NULL),(11957,11957,1,'MLS120512-150316-112311','CRTS-MLS',225.81582,-11.38625,NULL,NULL,'2012-05-12 00:00:00',56059,21.23,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120512/1205120112064111292.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120512/jpg/1205120112064111292.master.jpg',NULL,NULL,46481922205,NULL,NULL,NULL,'2006-05-30 12:28:49',53885.52002,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1205120112064111292/1205120112064111292.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120512/1205120112064111292p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,726280034,11348125,NULL,NULL,NULL,NULL),(11958,11958,1,'MLS120512-163526-005215','CRTS-MLS',248.85647,-0.87088,NULL,NULL,'2012-05-12 00:00:00',56059,20.8,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120512/1205120002314106695.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120512/jpg/1205120002314106695.master.jpg',NULL,NULL,45164601782,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1205120002314106695/1205120002314106695.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120512/1205120002314106695p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,705696902,11026514,NULL,NULL,NULL,NULL),(11959,11959,1,'MLS120501-143207-153830','CRTS-MLS',218.03063,-15.64179,NULL,NULL,'2012-05-01 00:00:00',56048,21.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120501/1205010151954108372.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120501/jpg/1205010151954108372.master.jpg',NULL,NULL,46553692627,NULL,NULL,NULL,'2007-05-11 12:28:49',54231.52002,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1205010151954108372/1205010151954108372.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120501/1205010151954108372p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,727401447,11365647,NULL,NULL,NULL,NULL),(11960,11960,1,'MLS120430-163339+015416','CRTS-MLS',248.4113,1.90447,NULL,NULL,'2012-04-30 00:00:00',56047,20.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120430/1204301012304126994.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120430/jpg/1204301012304126994.master.jpg',NULL,NULL,56711023780,NULL,NULL,NULL,'2011-06-26 11:31:10',55738.47998,'2013-01-19 01:32:31','http://crts.caltech.edu/ATEL/MLS/1204301012304126994/1204301012304126994.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120430/1204301012304126994p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,886109746,13845464,NULL,NULL,NULL,NULL),(11961,11961,1,'MLS120428-153711-172956','CRTS-MLS',234.29667,-17.49879,NULL,NULL,'2012-04-28 00:00:00',56045,20.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120428/1204280172074128900.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120428/jpg/1204280172074128900.master.jpg',NULL,NULL,46603856563,NULL,NULL,NULL,'2005-03-12 13:26:23',53441.559998,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1204280172074128900/1204280172074128900.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120428/1204280172074128900p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,728185258,11377894,NULL,NULL,NULL,NULL),(11962,11962,1,'MLS120423-161538+095453','CRTS-MLS',243.90804,9.91467,NULL,NULL,'2012-04-23 00:00:00',56040,20.56,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120423/1204231102234103984.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120423/jpg/1204231102234103984.master.jpg',NULL,NULL,56456981142,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1204231102234103984/1204231102234103984.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120423/1204231102234103984p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,882140330,13783442,NULL,NULL,NULL,NULL),(11963,11963,1,'MLS120422-104140+054618','CRTS-MLS',160.41792,5.77169,NULL,NULL,'2012-04-22 00:00:00',56039,19.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120422/1204221051484105301.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120422/jpg/1204221051484105301.master.jpg',NULL,NULL,61008066696,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1204221051484105301/1204221051484105301.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120422/1204221051484105301p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,953251042,14894547,NULL,NULL,NULL,NULL),(11964,11964,1,'MLS120329-144100-110715','CRTS-MLS',220.25125,-11.12073,NULL,NULL,'2012-03-29 00:00:00',56015,20.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120329/1203290112014113246.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120329/jpg/1203290112014113246.master.jpg',NULL,NULL,46471514490,NULL,NULL,NULL,'2010-03-19 10:33:30',55274.439941,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1203290112014113246/1203290112014113246.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120329/1203290112014113246p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,726117413,11345584,NULL,NULL,NULL,NULL),(11965,11965,1,'MLS120329-124401-085437','CRTS-MLS',191.00458,-8.91028,NULL,NULL,'2012-03-29 00:00:00',56015,21.26,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120329/1203290091754116150.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120329/jpg/1203290091754116150.master.jpg',NULL,NULL,43165891851,NULL,NULL,NULL,'2010-04-14 10:33:30',55300.439941,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1203290091754116150/1203290091754116150.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120329/1203290091754116150p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,674467060,10538547,NULL,NULL,NULL,NULL),(11966,11966,1,'MLS120328-072528+231710','CRTS-MLS',111.36714,23.28625,NULL,NULL,'2012-03-28 00:00:00',56014,20.44,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120328/1203281230954113614.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120328/jpg/1203281230954113614.master.jpg',NULL,NULL,63086865435,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1203281230954113614/1203281230954113614.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120328/1203281230954113614p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,985732272,15402066,NULL,NULL,NULL,NULL),(11967,11967,1,'MLS120328-085457+183748','CRTS-MLS',133.73944,18.6299,NULL,NULL,'2012-03-28 00:00:00',56014,20.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120328/1203281181184104333.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120328/jpg/1203281181184104333.master.jpg',NULL,NULL,63882268877,NULL,NULL,NULL,'2011-01-05 12:28:49',55566.52002,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1203281181184104333/1203281181184104333.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120328/1203281181184104333p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,998160451,15596257,NULL,NULL,NULL,NULL),(11968,11968,1,'MLS120328-085953+144028','CRTS-MLS',134.97234,14.67431,NULL,NULL,'2012-03-28 00:00:00',56014,21.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120328/1203281141224110664.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120328/jpg/1203281141224110664.master.jpg',NULL,NULL,63874991542,NULL,NULL,NULL,'2005-03-09 12:28:48',53438.520004,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1203281141224110664/1203281141224110664.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120328/1203281141224110664p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,998046742,15594480,NULL,NULL,NULL,NULL),(11969,11969,1,'MLS120323-123242-043753','CRTS-MLS',188.17336,-4.63142,NULL,NULL,'2012-03-23 00:00:00',56009,20.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120323/1203230041744114326.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120323/jpg/1203230041744114326.master.jpg',NULL,NULL,43173380306,NULL,NULL,NULL,'2007-05-10 13:26:23',54230.559998,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1203230041744114326/1203230041744114326.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120323/1203230041744114326p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,674584067,10540376,NULL,NULL,NULL,NULL),(11970,11970,1,'MLS120321-104852+084813','CRTS-MLS',162.21726,8.80354,NULL,NULL,'2012-03-21 00:00:00',56007,21.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120321/1203211091494102573.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120321/jpg/1203211091494102573.master.jpg',NULL,NULL,61054394441,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1203211091494102573/1203211091494102573.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120321/1203211091494102573p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,953974913,14905858,NULL,NULL,NULL,NULL),(11971,11971,1,'MLS120315-104336+030148','CRTS-MLS',160.89866,3.02999,NULL,NULL,'2012-03-15 00:00:00',56001,21.6,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120315/1203151021494116492.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120315/jpg/1203151021494116492.master.jpg',NULL,NULL,60274125906,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1203151021494116492/1203151021494116492.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120315/1203151021494116492p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,941783217,14715362,NULL,NULL,NULL,NULL),(11972,11972,1,'MLS120315-104048+024859','CRTS-MLS',160.20087,2.81625,NULL,NULL,'2012-03-15 00:00:00',56001,21.4,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120315/1203151021494112746.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120315/jpg/1203151021494112746.master.jpg',NULL,NULL,60277406302,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1203151021494112746/1203151021494112746.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120315/1203151021494112746p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,941834473,14716163,NULL,NULL,NULL,NULL),(11973,11973,1,'MLS120313-111126+061216','CRTS-MLS',167.86,6.2045,NULL,NULL,'2012-03-13 00:00:00',55999,20.3,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120313/1203131051554112991.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120313/jpg/1203131051554112991.master.jpg',NULL,NULL,60306521163,NULL,NULL,NULL,'2012-02-23 11:31:10',55980.47998,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1203131051554112991/1203131051554112991.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120313/1203131051554112991p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,942289393,14723271,NULL,NULL,NULL,NULL),(11974,11974,1,'MLS120313-115316+044624','CRTS-MLS',178.31577,4.77336,NULL,NULL,'2012-03-13 00:00:00',55999,20.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120313/1203131041654107068.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120313/jpg/1203131041654107068.master.jpg',NULL,NULL,60192245641,NULL,NULL,NULL,'2011-05-01 13:26:29',55682.560059,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1203131041654107068/1203131041654107068.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120313/1203131041654107068p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,940503838,14695372,NULL,NULL,NULL,NULL),(11975,11975,1,'MLS120302-105251+073736','CRTS-MLS',163.2105,7.62672,NULL,NULL,'2012-03-02 00:00:00',55988,21.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120302/1203021081504100672.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120302/jpg/1203021081504100672.master.jpg',NULL,NULL,61030704695,NULL,NULL,NULL,'2005-05-10 10:33:36',53500.440002,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1203021081504100672/1203021081504100672.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120302/1203021081504100672p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,953604760,14900074,NULL,NULL,NULL,NULL),(11976,11976,1,'MLS120226-074646+183309','CRTS-MLS',116.69231,18.5526,NULL,NULL,'2012-02-26 00:00:00',55983,20.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120226/1202261181034104312.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120226/jpg/1202261181034104312.master.jpg',NULL,NULL,62620649899,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1202261181034104312/1202261181034104312.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120226/1202261181034104312p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,978447654,15288244,NULL,NULL,NULL,NULL),(11977,11977,1,'MLS120226-074530+141536','CRTS-MLS',116.37691,14.25989,NULL,NULL,'2012-02-26 00:00:00',55983,20.98,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120226/1202261141054105227.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120226/jpg/1202261141054105227.master.jpg',NULL,NULL,62645220391,NULL,NULL,NULL,'2008-02-11 12:28:49',54507.52002,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1202261141054105227/1202261141054105227.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120226/1202261141054105227p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,978831568,15294243,NULL,NULL,NULL,NULL),(11978,11978,1,'MLS120226-074041+140758','CRTS-MLS',115.17236,14.13271,NULL,NULL,'2012-02-26 00:00:00',55983,20.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120226/1202261141044101749.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120226/jpg/1202261141044101749.master.jpg',NULL,NULL,62632485080,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1202261141044101749/1202261141044101749.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120226/1202261141044101749p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,978632579,15291134,NULL,NULL,NULL,NULL),(11979,11979,1,'MLS120226-133718-134638','CRTS-MLS',204.32439,-13.77722,NULL,NULL,'2012-02-26 00:00:00',55983,21.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120226/1202260131844106054.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120226/jpg/1202260131844106054.master.jpg',NULL,NULL,43775382394,NULL,NULL,NULL,'2010-04-15 10:33:30',55301.439941,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1202260131844106054/1202260131844106054.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120226/1202260131844106054p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,683990349,10687349,NULL,NULL,NULL,NULL),(11980,11980,1,'MLS120226-125003-020535','CRTS-MLS',192.51075,-2.09313,NULL,NULL,'2012-02-26 00:00:00',55983,20.31,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120226/1202260011794101819.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120226/jpg/1202260011794101819.master.jpg',NULL,NULL,43116051794,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:32','http://crts.caltech.edu/ATEL/MLS/1202260011794101819/1202260011794101819.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120226/1202260011794101819p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,673688309,10526379,NULL,NULL,NULL,NULL),(11981,11981,1,'MLS120225-035116+205200','CRTS-MLS',57.81805,20.8666,NULL,NULL,'2012-02-25 00:00:00',55982,20.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120225/1202251210514104638.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120225/jpg/1202251210514104638.master.jpg',NULL,NULL,67992610431,NULL,NULL,NULL,'2009-12-11 13:26:29',55176.560059,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1202251210514104638/1202251210514104638.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120225/1202251210514104638p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1062384537,16599758,NULL,NULL,NULL,NULL),(11982,11982,1,'MLS120225-080648+192710','CRTS-MLS',121.70182,19.45275,NULL,NULL,'2012-02-25 00:00:00',55982,20.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120225/1202251181074121780.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120225/jpg/1202251181074121780.master.jpg',NULL,NULL,63758438022,NULL,NULL,NULL,'2010-04-07 10:33:30',55293.439941,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1202251181074121780/1202251181074121780.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120225/1202251181074121780p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,996225594,15566024,NULL,NULL,NULL,NULL),(11983,11983,1,'MLS120225-080348+184202','CRTS-MLS',120.9494,18.70046,NULL,NULL,'2012-02-25 00:00:00',55982,21.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120225/1202251181074106884.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120225/jpg/1202251181074106884.master.jpg',NULL,NULL,62621051383,NULL,NULL,NULL,'2010-01-07 10:33:30',55203.439941,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1202251181074106884/1202251181074106884.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120225/1202251181074106884p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,978453927,15288342,NULL,NULL,NULL,NULL),(11984,11984,1,'MLS120223-074424+204932','CRTS-MLS',116.0995,20.82554,NULL,NULL,'2012-02-23 00:00:00',55980,20.33,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120223/1202231211014105644.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120223/jpg/1202231211014105644.master.jpg',NULL,NULL,62618926190,NULL,NULL,NULL,'2010-04-05 10:33:30',55291.439941,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1202231211014105644/1202231211014105644.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120223/1202231211014105644p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,978420721,15287823,NULL,NULL,NULL,NULL),(11985,11985,1,'MLS120223-095322+094127','CRTS-MLS',148.34022,9.6907,NULL,NULL,'2012-02-23 00:00:00',55980,19.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120223/1202231091364117606.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120223/jpg/1202231091364117606.master.jpg',NULL,NULL,60928336333,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1202231091364117606/1202231091364117606.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120223/1202231091364117606p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,952005255,14875082,NULL,NULL,NULL,NULL),(11986,11986,1,'MLS120223-104025+070844','CRTS-MLS',160.10268,7.14562,NULL,NULL,'2012-02-23 00:00:00',55980,20.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120223/1202231071484111791.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120223/jpg/1202231071484111791.master.jpg',NULL,NULL,61065717523,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1202231071484111791/1202231071484111791.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120223/1202231071484111791p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,954151836,14908622,NULL,NULL,NULL,NULL),(11987,11987,1,'MLS120212-085626+221641','CRTS-MLS',134.10818,22.27812,NULL,NULL,'2012-02-12 00:00:00',55969,21.33,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120212/1202121221164111548.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120212/jpg/1202121221164111548.master.jpg',NULL,NULL,63822017220,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1202121221164111548/1202121221164111548.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120212/1202121221164111548p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,997219019,15581547,NULL,NULL,NULL,NULL),(11988,11988,1,'MLS120210-081453+233837','CRTS-MLS',123.7209,23.64365,NULL,NULL,'2012-02-10 00:00:00',55967,20.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120210/1202101231064115319.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120210/jpg/1202101231064115319.master.jpg',NULL,NULL,63765958306,NULL,NULL,NULL,'2005-12-05 11:31:12',53709.480011,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1202101231064115319/1202101231064115319.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120210/1202101231064115319p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,996343098,15567860,NULL,NULL,NULL,NULL),(11989,11989,1,'MLS120201-085823+180013','CRTS-MLS',134.59648,18.00374,NULL,NULL,'2012-02-01 00:00:00',55958,20.3,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120201/1202011171194114376.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120201/jpg/1202011171194114376.master.jpg',NULL,NULL,63884371137,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1202011171194114376/1202011171194114376.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120201/1202011171194114376p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,998193299,15596770,NULL,NULL,NULL,NULL),(11990,11990,1,'MLS120201-092032+123218','CRTS-MLS',140.13353,12.53825,NULL,NULL,'2012-02-01 00:00:00',55958,20.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120201/1202011121274110454.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120201/jpg/1202011121274110454.master.jpg',NULL,NULL,63856270619,NULL,NULL,NULL,'2006-01-02 11:31:12',53737.480011,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1202011121274110454/1202011121274110454.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120201/1202011121274110454p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,997754228,15589909,NULL,NULL,NULL,NULL),(11991,11991,1,'MLS120201-091958+121531','CRTS-MLS',139.99051,12.25868,NULL,NULL,'2012-02-01 00:00:00',55958,21.23,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120201/1202011121274105943.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120201/jpg/1202011121274105943.master.jpg',NULL,NULL,63637179936,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1202011121274105943/1202011121274105943.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120201/1202011121274105943p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,994330936,15536420,NULL,NULL,NULL,NULL),(11992,11992,1,'MLS120201-091349+120853','CRTS-MLS',138.45552,12.14802,NULL,NULL,'2012-02-01 00:00:00',55958,20.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120201/1202011121264103900.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120201/jpg/1202011121264103900.master.jpg',NULL,NULL,63642395470,NULL,NULL,NULL,'2010-02-15 10:33:30',55242.439941,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1202011121264103900/1202011121264103900.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120201/1202011121264103900p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,994412429,15537694,NULL,NULL,NULL,NULL),(11994,11994,1,'MLS120127-084400+214657','CRTS-MLS',131.00046,21.78254,NULL,NULL,'2012-01-27 00:00:00',55953,20.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120127/1201271221134102612.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120127/jpg/1201271221134102612.master.jpg',NULL,NULL,63796929664,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1201271221134102612/1201271221134102612.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120127/1201271221134102612p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,996827026,15575422,NULL,NULL,NULL,NULL),(11995,11995,1,'MLS120127-085402+133633','CRTS-MLS',133.50872,13.60923,NULL,NULL,'2012-01-27 00:00:00',55953,19.21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120127/1201271131214109811.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120127/jpg/1201271131214109811.master.jpg',NULL,NULL,63845399097,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1201271131214109811/1201271131214109811.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120127/1201271131214109811p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,997584360,15587255,NULL,NULL,NULL,NULL),(11996,11996,1,'MLS120127-121702-005206','CRTS-MLS',184.25645,-0.86844,NULL,NULL,'2012-01-27 00:00:00',55953,20.16,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120127/1201270001714203948.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120127/jpg/1201270001714203948.master.jpg',NULL,NULL,42958774611,NULL,NULL,NULL,'2010-05-11 13:26:29',55327.560059,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1201270001714203948/1201270001714203948.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120127/1201270001714203948p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,671230853,10487982,NULL,NULL,NULL,NULL),(11997,11997,1,'MLS120126-042313+212951','CRTS-MLS',65.80303,21.49738,NULL,NULL,'2012-01-26 00:00:00',55952,19.04,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120126/1201261210584120158.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120126/jpg/1201261210584120158.master.jpg',NULL,NULL,65246044553,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1201261210584120158/1201261210584120158.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120126/1201261210584120158p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,1019469446,15929210,NULL,NULL,NULL,NULL),(11998,11998,1,'MLS120119-075359+295455','CRTS-MLS',118.4962,29.91523,NULL,NULL,'2012-01-19 00:00:00',55945,21.31,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120119/1201191290964115471.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120119/jpg/1201191290964115471.master.jpg',NULL,NULL,63425512983,NULL,NULL,NULL,'2011-01-13 11:31:10',55574.47998,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1201191290964115471/1201191290964115471.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120119/1201191290964115471p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,991023640,15484744,NULL,NULL,NULL,NULL),(11999,11999,1,'MLS120111-042649+295216','CRTS-MLS',66.70326,29.87112,NULL,NULL,'2012-01-11 00:00:00',55937,18.66,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120111/1201111290544116723.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120111/jpg/1201111290544116723.master.jpg',NULL,NULL,68324935798,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1201111290544116723/1201111290544116723.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120111/1201111290544116723p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1067577121,16680892,NULL,NULL,NULL,NULL),(12000,12000,1,'MLS111228-073824+334919','CRTS-MLS',114.59903,33.82204,NULL,NULL,'2011-12-28 00:00:00',55923,20.9,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111228/1112281340894105537.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111228/jpg/1112281340894105537.master.jpg',NULL,NULL,63484037657,NULL,NULL,NULL,'2010-04-25 12:28:49',55311.52002,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1112281340894105537/1112281340894105537.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111228/1112281340894105537p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,991938088,15499032,NULL,NULL,NULL,NULL),(12001,12001,1,'MLS111227-100049+090351','CRTS-MLS',150.20621,9.06406,NULL,NULL,'2011-12-27 00:00:00',55922,21.26,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:33','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111227/1112271091384107532.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111227/jpg/1112271091384107532.master.jpg',NULL,NULL,60930657051,NULL,NULL,NULL,'2010-02-14 10:33:30',55241.439941,'2013-01-19 01:32:33','http://crts.caltech.edu/ATEL/MLS/1112271091384107532/1112271091384107532.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111227/1112271091384107532p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,952041516,14875648,NULL,NULL,NULL,NULL),(12003,12003,1,'MLS111126-092544+143534','CRTS-MLS',141.43348,14.59276,NULL,NULL,'2011-11-26 00:00:00',55891,20.95,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111126/1111261141274109471.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111126/jpg/1111261141274109471.master.jpg',NULL,NULL,63856106061,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1111261141274109471/1111261141274109471.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111126/1111261141274109471p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,997751657,15589869,NULL,NULL,NULL,NULL),(12004,12004,1,'MLS111126-121109+040534','CRTS-MLS',182.7873,4.09271,NULL,NULL,'2011-11-26 00:00:00',55891,20.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111126/1111261031694111982.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111126/jpg/1111261031694111982.master.jpg',NULL,NULL,58037948682,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1111261031694111982/1111261031694111982.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111126/1111261031694111982p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,906842948,14169421,NULL,NULL,NULL,NULL),(12005,12005,1,'MLS111124-021725+155542','CRTS-MLS',34.35592,15.92826,NULL,NULL,'2011-11-24 00:00:00',55889,21.41,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111124/1111241150314112731.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111124/jpg/1111241150314112731.master.jpg',NULL,NULL,68078934245,NULL,NULL,NULL,'2010-12-14 13:26:29',55544.560059,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1111241150314112731/1111241150314112731.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111124/1111241150314112731p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1063733347,16620833,NULL,NULL,NULL,NULL),(12006,12006,1,'MLS111117-004344+070516','CRTS-MLS',10.93456,7.0877,NULL,NULL,'2011-11-17 00:00:00',55882,21.18,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111117/1111171070114110041.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111117/jpg/1111171070114110041.master.jpg',NULL,NULL,66782051823,NULL,NULL,NULL,'2005-10-02 12:28:47',53645.519989,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1111171070114110041/1111171070114110041.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111117/1111171070114110041p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,1043469559,16304211,NULL,NULL,NULL,NULL),(12007,12007,1,'MLS111116-002739+030725','CRTS-MLS',6.91377,3.12368,NULL,NULL,'2011-11-16 00:00:00',55881,21.38,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111116/1111161020074114585.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111116/jpg/1111161020074114585.master.jpg',NULL,NULL,66596163437,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1111161020074114585/1111161020074114585.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111116/1111161020074114585p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1040565053,16258828,NULL,NULL,NULL,NULL),(12008,12008,1,'MLS111116-235318-001347','CRTS-MLS',358.32319,-0.22966,NULL,NULL,'2011-11-16 00:00:00',55881,20.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111116/1111160003324112003.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111116/jpg/1111160003324112003.master.jpg',NULL,NULL,49393948100,NULL,NULL,NULL,'2011-10-24 12:28:49',55858.52002,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1111160003324112003/1111160003324112003.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111116/1111160003324112003p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,771780439,12059069,NULL,NULL,NULL,NULL),(12009,12009,1,'MLS111103-034436+284902','CRTS-MLS',56.14977,28.81714,NULL,NULL,'2011-11-03 00:00:00',55868,20.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111103/1111031280464116645.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111103/jpg/1111031280464116645.master.jpg',NULL,NULL,68514124207,NULL,NULL,NULL,'2008-12-04 12:28:49',54804.52002,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1111031280464116645/1111031280464116645.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111103/1111031280464116645p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1070533190,16727081,NULL,NULL,NULL,NULL),(12010,12010,1,'MLS111102-030302+320300','CRTS-MLS',45.75866,32.04994,NULL,NULL,'2011-11-02 00:00:00',55867,21.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111102/1111021310374112726.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111102/jpg/1111021310374112726.master.jpg',NULL,NULL,68674511637,NULL,NULL,NULL,'2010-12-02 13:26:29',55532.560059,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1111021310374112726/1111021310374112726.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111102/1111021310374112726p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1073039244,16766238,NULL,NULL,NULL,NULL),(12011,12011,1,'MLS111102-031609+260748','CRTS-MLS',49.03665,26.12993,NULL,NULL,'2011-11-02 00:00:00',55867,21.06,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111102/1111021260414102590.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111102/jpg/1111021260414102590.master.jpg',NULL,NULL,68486039833,NULL,NULL,NULL,'2009-10-26 10:33:30',55130.439941,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1111021260414102590/1111021260414102590.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111102/1111021260414102590p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1070094372,16720224,NULL,NULL,NULL,NULL),(12012,12012,1,'MLS111101-022316+084857','CRTS-MLS',35.81743,8.81584,NULL,NULL,'2011-11-01 00:00:00',55866,20.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111101/1111011090334102347.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111101/jpg/1111011090334102347.master.jpg',NULL,NULL,66863533591,NULL,NULL,NULL,'2006-11-16 13:26:23',54055.559998,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1111011090334102347/1111011090334102347.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111101/1111011090334102347p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1044742712,16324104,NULL,NULL,NULL,NULL),(12013,12013,1,'MLS111031-021235+240238','CRTS-MLS',33.14683,24.04401,NULL,NULL,'2011-10-31 00:00:00',55865,21.25,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111031/1110311240294104364.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111031/jpg/1110311240294104364.master.jpg',NULL,NULL,68060572632,NULL,NULL,NULL,'2007-09-25 13:26:29',54368.560059,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1110311240294104364/1110311240294104364.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111031/1110311240294104364p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,1063446447,16616350,NULL,NULL,NULL,NULL),(12014,12014,1,'MLS111023-024225+091824','CRTS-MLS',40.60618,9.30655,NULL,NULL,'2011-10-23 00:00:00',55857,20.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111023/1110231090384109540.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111023/jpg/1110231090384109540.master.jpg',NULL,NULL,67963729310,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1110231090384109540/1110231090384109540.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111023/1110231090384109540p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1061933270,16592707,NULL,NULL,NULL,NULL),(12015,12015,1,'MLS111020-012014+023951','CRTS-MLS',20.05783,2.66427,NULL,NULL,'2011-10-20 00:00:00',55854,20.6,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111020/1110201020194107081.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111020/jpg/1110201020194107081.master.jpg',NULL,NULL,67513642581,NULL,NULL,NULL,'2009-11-16 13:26:29',55151.560059,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1110201020194107081/1110201020194107081.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111020/1110201020194107081p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1054900665,16482822,NULL,NULL,NULL,NULL),(12016,12016,1,'MLS111018-225837-053528','CRTS-MLS',344.65482,-5.59109,NULL,NULL,'2011-10-18 00:00:00',55852,21.41,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111018/1110180053174114851.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111018/jpg/1110180053174114851.master.jpg',NULL,NULL,49519641540,NULL,NULL,NULL,'2011-09-29 13:26:29',55833.560059,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1110180053174114851/1110180053174114851.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111018/1110180053174114851p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,773744399,12089756,NULL,NULL,NULL,NULL),(12017,12017,1,'MLS111003-005453+003728','CRTS-MLS',13.72195,0.62437,NULL,NULL,'2011-10-03 00:00:00',55837,20.84,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111003/1110031000134108456.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111003/jpg/1110031000134108456.master.jpg',NULL,NULL,66687509630,NULL,NULL,NULL,'2006-11-24 12:28:49',54063.52002,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1110031000134108456/1110031000134108456.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111003/1110031000134108456p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,1041992337,16281130,NULL,NULL,NULL,NULL),(12018,12018,1,'MLS110929-033739+224745','CRTS-MLS',54.41429,22.79593,NULL,NULL,'2011-09-29 00:00:00',55833,20.95,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110929/1109291230474101299.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110929/jpg/1109291230474101299.master.jpg',NULL,NULL,68044085997,NULL,NULL,NULL,'2008-11-20 11:31:10',54790.47998,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1109291230474101299/1109291230474101299.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110929/1109291230474101299p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,1063188843,16612325,NULL,NULL,NULL,NULL),(12019,12019,1,'MLS110929-083658+143313','CRTS-MLS',129.24149,14.55365,NULL,NULL,'2011-09-29 00:00:00',55833,20.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110929/1109291141164108538.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110929/jpg/1109291141164108538.master.jpg',NULL,NULL,63851384546,NULL,NULL,NULL,'2011-03-27 12:28:49',55647.52002,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1109291141164108538/1109291141164108538.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110929/1109291141164108538p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,997677883,15588716,NULL,NULL,NULL,NULL),(12020,12020,1,'MLS110928-003531+055242','CRTS-MLS',8.88016,5.87842,NULL,NULL,'2011-09-28 00:00:00',55832,21.41,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110928/1109281050094108197.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110928/jpg/1109281050094108197.master.jpg',NULL,NULL,66830178122,NULL,NULL,NULL,'2009-11-24 13:26:29',55159.560059,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1109281050094108197/1109281050094108197.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110928/1109281050094108197p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1044221533,16315961,NULL,NULL,NULL,NULL),(12021,12021,1,'MLS110928-002829+053848','CRTS-MLS',7.11965,5.64677,NULL,NULL,'2011-09-28 00:00:00',55832,20.52,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:34','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110928/1109281050074103719.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110928/jpg/1109281050074103719.master.jpg',NULL,NULL,66815787775,NULL,NULL,NULL,'2005-11-28 13:26:23',53702.559998,'2013-01-19 01:32:34','http://crts.caltech.edu/ATEL/MLS/1109281050074103719/1109281050074103719.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110928/1109281050074103719p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1043996683,16312448,NULL,NULL,NULL,NULL),(12022,12022,1,'MLS110923-225653-012636','CRTS-MLS',344.22227,-1.44324,NULL,NULL,'2011-09-23 00:00:00',55827,21.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110923/1109230013194111208.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110923/jpg/1109230013194111208.master.jpg',NULL,NULL,49517192389,NULL,NULL,NULL,'2011-01-14 13:26:29',55575.560059,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1109230013194111208/1109230013194111208.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110923/1109230013194111208p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,773706131,12089158,NULL,NULL,NULL,NULL),(12023,12023,1,'MLS110921-225423-055242','CRTS-MLS',343.59635,-5.87836,NULL,NULL,'2011-09-21 00:00:00',55825,21.02,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110921/1109210053164109506.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110921/jpg/1109210053164109506.master.jpg',NULL,NULL,49485266325,NULL,NULL,NULL,'2009-11-09 13:26:29',55144.560059,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1109210053164109506/1109210053164109506.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110921/1109210053164109506p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,773207286,12081363,NULL,NULL,NULL,NULL),(12024,12024,1,'MLS110921-232436-042433','CRTS-MLS',351.15158,-4.40929,NULL,NULL,'2011-09-21 00:00:00',55825,20.58,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110921/1109210043244113727.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110921/jpg/1109210043244113727.master.jpg',NULL,NULL,49640086572,NULL,NULL,NULL,'2005-10-01 12:28:47',53644.519989,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1109210043244113727/1109210043244113727.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110921/1109210043244113727p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,775626352,12119161,NULL,NULL,NULL,NULL),(12025,12025,1,'MLS110920-235338+061307','CRTS-MLS',358.40794,6.2187,NULL,NULL,'2011-09-20 00:00:00',55824,21.23,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110920/1109201053304112056.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110920/jpg/1109201053304112056.master.jpg',NULL,NULL,51567667487,NULL,NULL,NULL,'2011-01-14 13:26:29',55575.560059,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1109201053304112056/1109201053304112056.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110920/1109201053304112056p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,805744804,12589762,NULL,NULL,NULL,NULL),(12026,12026,1,'MLS110918-012716+102647','CRTS-MLS',21.81842,10.44649,NULL,NULL,'2011-09-18 00:00:00',55822,20.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110918/1109181100204107482.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110918/jpg/1109181100204107482.master.jpg',NULL,NULL,67544941531,NULL,NULL,NULL,'2006-11-20 10:33:36',54059.440002,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1109181100204107482/1109181100204107482.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110918/1109181100204107482p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1055389711,16490464,NULL,NULL,NULL,NULL),(12027,12027,1,'MLS110701-211626-153231','CRTS-MLS',319.10846,-15.54194,NULL,NULL,'2011-07-01 00:00:00',55743,20.98,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110701/1107010152854114617.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110701/jpg/1107010152854114617.master.jpg',NULL,NULL,50965289387,NULL,NULL,NULL,'2010-11-17 13:26:29',55517.560059,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1107010152854114617/1107010152854114617.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110701/1107010152854114617p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,796332646,12442697,NULL,NULL,NULL,NULL),(12028,12028,1,'MLS110628-202151-122513','CRTS-MLS',305.46279,-12.42039,NULL,NULL,'2011-06-28 00:00:00',55740,20.42,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110628/1106280122774122251.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110628/jpg/1106280122774122251.master.jpg',NULL,NULL,47933480725,NULL,NULL,NULL,'2010-06-24 13:26:29',55371.560059,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1106280122774122251/1106280122774122251.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110628/1106280122774122251p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,748960636,11702509,NULL,NULL,NULL,NULL),(12029,12029,1,'MLS110623-220322-131254','CRTS-MLS',330.8426,-13.21502,NULL,NULL,'2011-06-23 00:00:00',55735,20.14,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110623/1106230132984116274.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110623/jpg/1106230132984116274.master.jpg',NULL,NULL,49749146585,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1106230132984116274/1106230132984116274.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110623/1106230132984116274p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,777330415,12145787,NULL,NULL,NULL,NULL),(12030,12030,1,'MLS110623-215937-135957','CRTS-MLS',329.90235,-13.99915,NULL,NULL,'2011-06-23 00:00:00',55735,19.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110623/1106230132974101628.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110623/jpg/1106230132974101628.master.jpg',NULL,NULL,49781877367,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1106230132974101628/1106230132974101628.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110623/1106230132974101628p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,777841833,12153778,NULL,NULL,NULL,NULL),(12031,12031,1,'MLS110610-162253-064252','CRTS-MLS',245.71958,-6.71442,NULL,NULL,'2011-06-10 00:00:00',55722,20.82,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110610/1106100072264124381.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110610/jpg/1106100072264124381.master.jpg',NULL,NULL,45537887361,NULL,NULL,NULL,'2010-09-03 13:26:29',55442.560059,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1106100072264124381/1106100072264124381.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110610/1106100072264124381p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,711529490,11117648,NULL,NULL,NULL,NULL),(12032,12032,1,'MLS110609-233402+080922','CRTS-MLS',353.50954,8.15601,NULL,NULL,'2011-06-09 00:00:00',55721,21.02,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110609/1106091083254108096.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110609/jpg/1106091083254108096.master.jpg',NULL,NULL,51806815075,NULL,NULL,NULL,'2008-12-01 13:26:29',54801.560059,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1106091083254108096/1106091083254108096.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110609/1106091083254108096p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,809481485,12648148,NULL,NULL,NULL,NULL),(12033,12033,1,'MLS110608-203934-123353','CRTS-MLS',309.89141,-12.56481,NULL,NULL,'2011-06-08 00:00:00',55720,20.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110608/1106080122814114843.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110608/jpg/1106080122814114843.master.jpg',NULL,NULL,50971487866,NULL,NULL,NULL,'2010-10-29 13:26:29',55498.560059,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1106080122814114843/1106080122814114843.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110608/1106080122814114843p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,796429497,12444210,NULL,NULL,NULL,NULL),(12034,12034,1,'MLS110607-110617+091356','CRTS-MLS',166.57199,9.23236,NULL,NULL,'2011-06-07 00:00:00',55719,21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110607/1106071091534106907.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110607/jpg/1106071091534106907.master.jpg',NULL,NULL,60299392940,NULL,NULL,NULL,'2010-01-08 13:26:29',55204.560059,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1106071091534106907/1106071091534106907.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110607/1106071091534106907p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,942178014,14721531,NULL,NULL,NULL,NULL),(12035,12035,1,'MLS110604-105438+085141','CRTS-MLS',163.65698,8.86128,NULL,NULL,'2011-06-04 00:00:00',55716,21.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110604/1106041091504102899.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110604/jpg/1106041091504102899.master.jpg',NULL,NULL,61031807270,NULL,NULL,NULL,'2006-04-07 11:31:10',53832.47998,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1106041091504102899/1106041091504102899.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110604/1106041091504102899p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,953621988,14900343,NULL,NULL,NULL,NULL),(12036,12036,1,'MLS110531-095843+155310','CRTS-MLS',149.6811,15.88607,NULL,NULL,'2011-05-31 00:00:00',55712,20.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110531/1105311151344111070.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110531/jpg/1105311151344111070.master.jpg',NULL,NULL,60864727330,NULL,NULL,NULL,'2005-02-04 11:31:11',53405.479996,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1105311151344111070/1105311151344111070.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110531/1105311151344111070p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,951011364,14859552,NULL,NULL,NULL,NULL),(12037,12037,1,'MLS110526-151218-122322','CRTS-MLS',228.07484,-12.38939,NULL,NULL,'2011-05-26 00:00:00',55707,20.97,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110526/1105260122074116516.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110526/jpg/1105260122074116516.master.jpg',NULL,NULL,46664128113,NULL,NULL,NULL,'2005-05-14 10:33:36',53504.440002,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1105260122074116516/1105260122074116516.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110526/1105260122074116516p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,729127001,11392609,NULL,NULL,NULL,NULL),(12038,12038,1,'MLS110512-151008-072032','CRTS-MLS',227.53436,-7.34219,NULL,NULL,'2011-05-12 00:00:00',55693,20.04,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110512/1105120072104103837.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110512/jpg/1105120072104103837.master.jpg',NULL,NULL,46497467549,NULL,NULL,NULL,'2010-05-11 12:28:49',55327.52002,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1105120072104103837/1105120072104103837.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110512/1105120072104103837p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,726522930,11351920,NULL,NULL,NULL,NULL),(12039,12039,1,'MLS110508-083831+144052','CRTS-MLS',129.62829,14.6811,NULL,NULL,'2011-05-08 00:00:00',55689,21.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110508/1105081141174110609.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110508/jpg/1105081141174110609.master.jpg',NULL,NULL,63851294547,NULL,NULL,NULL,'2010-04-07 10:33:30',55293.439941,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1105081141174110609/1105081141174110609.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110508/1105081141174110609p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,997676477,15588694,NULL,NULL,NULL,NULL),(12040,12040,1,'MLS110508-144132-175253','CRTS-MLS',220.38332,-17.88144,NULL,NULL,'2011-05-08 00:00:00',55689,20.18,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110508/1105080171954111843.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110508/jpg/1105080171954111843.master.jpg',NULL,NULL,46679278795,NULL,NULL,NULL,'2010-06-19 13:26:29',55366.560059,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1105080171954111843/1105080171954111843.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110508/1105080171954111843p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,729363731,11396308,NULL,NULL,NULL,NULL),(12041,12041,1,'MLS110508-144532-165505','CRTS-MLS',221.38208,-16.91816,NULL,NULL,'2011-05-08 00:00:00',55689,20.59,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:35','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110508/1105080161974109449.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110508/jpg/1105080161974109449.master.jpg',NULL,NULL,46682107026,NULL,NULL,NULL,'2010-06-17 13:26:29',55364.560059,'2013-01-19 01:32:35','http://crts.caltech.edu/ATEL/MLS/1105080161974109449/1105080161974109449.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110508/1105080161974109449p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,729407922,11396998,NULL,NULL,NULL,NULL),(12042,12042,1,'MLS110508-130622-032705','CRTS-MLS',196.59358,-3.45127,NULL,NULL,'2011-05-08 00:00:00',55689,20.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110508/1105080031824119794.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110508/jpg/1105080031824119794.master.jpg',NULL,NULL,43139594839,NULL,NULL,NULL,'2010-02-19 12:28:49',55246.52002,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1105080031824119794/1105080031824119794.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110508/1105080031824119794p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,674056169,10532127,NULL,NULL,NULL,NULL),(12043,12043,1,'MLS110508-151438-015731','CRTS-MLS',228.66029,-1.95848,NULL,NULL,'2011-05-08 00:00:00',55689,20.24,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110508/1105080012124103927.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110508/jpg/1105080012124103927.master.jpg',NULL,NULL,45382025913,NULL,NULL,NULL,'2007-04-25 11:31:10',54215.47998,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1105080012124103927/1105080012124103927.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110508/1105080012124103927p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,709094154,11079596,NULL,NULL,NULL,NULL),(12044,12044,1,'MLS110428-121827-013008','CRTS-MLS',184.61352,-1.5022,NULL,NULL,'2011-04-28 00:00:00',55679,21.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110428/1104280011714111703.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110428/jpg/1104280011714111703.master.jpg',NULL,NULL,43008023090,NULL,NULL,NULL,'2005-03-09 12:28:48',53438.520004,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1104280011714111703/1104280011714111703.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110428/1104280011714111703p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,672000360,10500005,NULL,NULL,NULL,NULL),(12045,12045,1,'MLS110405-114403-052116','CRTS-MLS',176.01406,-5.35457,NULL,NULL,'2011-04-05 00:00:00',55656,20.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110405/1104050041634101486.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110405/jpg/1104050041634101486.master.jpg',NULL,NULL,40854303461,NULL,NULL,NULL,'2010-02-17 11:31:10',55244.47998,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1104050041634101486/1104050041634101486.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110405/1104050041634101486p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,638348491,9974195,NULL,NULL,NULL,NULL),(12046,12046,1,'MLS110405-113435-004250','CRTS-MLS',173.64737,-0.7138,NULL,NULL,'2011-04-05 00:00:00',55656,21.16,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110405/1104050001614106601.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110405/jpg/1104050001614106601.master.jpg',NULL,NULL,40831288246,NULL,NULL,NULL,'2007-02-17 13:26:23',54148.559998,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1104050001614106601/1104050001614106601.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110405/1104050001614106601p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,637988878,9968576,NULL,NULL,NULL,NULL),(12047,12047,1,'MLS110331-110548+161150','CRTS-MLS',166.44933,16.19729,NULL,NULL,'2011-03-31 00:00:00',55651,21.08,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110331/1103311151494117674.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110331/jpg/1103311151494117674.master.jpg',NULL,NULL,61144073431,NULL,NULL,NULL,'2009-02-15 13:26:29',54877.560059,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1103311151494117674/1103311151494117674.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110331/1103311151494117674p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,955376147,14927752,NULL,NULL,NULL,NULL),(12048,12048,1,'MLS110329-113223+032034','CRTS-MLS',173.09719,3.34272,NULL,NULL,'2011-03-29 00:00:00',55649,21.34,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110329/1103291031604101895.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110329/jpg/1103291031604101895.master.jpg',NULL,NULL,60174852200,NULL,NULL,NULL,'2005-05-13 12:28:48',53503.520004,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1103291031604101895/1103291031604101895.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110329/1103291031604101895p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,940232065,14691126,NULL,NULL,NULL,NULL),(12049,12049,1,'MLS110329-135128+000820','CRTS-MLS',207.86875,0.13893,NULL,NULL,'2011-03-29 00:00:00',55649,20.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110329/1103291001934102490.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110329/jpg/1103291001934102490.master.jpg',NULL,NULL,58388956534,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1103291001934102490/1103291001934102490.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110329/1103291001934102490p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,912327445,14255116,NULL,NULL,NULL,NULL),(12050,12050,1,'MLS110329-125038-020229','CRTS-MLS',192.659,-2.04143,NULL,NULL,'2011-03-29 00:00:00',55649,21.56,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110329/1103290011794102412.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110329/jpg/1103290011794102412.master.jpg',NULL,NULL,43116062913,NULL,NULL,NULL,'2010-05-10 13:26:29',55326.560059,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1103290011794102412/1103290011794102412.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110329/1103290011794102412p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,673688483,10526382,NULL,NULL,NULL,NULL),(12051,12051,1,'MLS110314-111117+100025','CRTS-MLS',167.82201,10.00693,NULL,NULL,'2011-03-14 00:00:00',55634,21.54,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110314/1103141101534104065.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110314/jpg/1103141101534104065.master.jpg',NULL,NULL,60300824982,NULL,NULL,NULL,'2008-11-06 13:26:29',54776.560059,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1103141101534104065/1103141101534104065.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110314/1103141101534104065p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,942200390,14721881,NULL,NULL,NULL,NULL),(12052,12052,1,'MLS110314-123354-063553','CRTS-MLS',188.47305,-6.59811,NULL,NULL,'2011-03-14 00:00:00',55634,21.25,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110314/1103140071744118000.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110314/jpg/1103140071744118000.master.jpg',NULL,NULL,43215560192,NULL,NULL,NULL,'2006-05-31 10:33:36',53886.440002,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1103140071744118000/1103140071744118000.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110314/1103140071744118000p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,675243128,10550673,NULL,NULL,NULL,NULL),(12053,12053,1,'MLS110313-113504+172428','CRTS-MLS',173.76678,17.40771,NULL,NULL,'2011-03-13 00:00:00',55633,20.67,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110313/1103131171544101658.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110313/jpg/1103131171544101658.master.jpg',NULL,NULL,61123827625,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1103131171544101658/1103131171544101658.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110313/1103131171544101658p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,955059806,14922809,NULL,NULL,NULL,NULL),(12054,12054,1,'MLS110313-135647-124432','CRTS-MLS',209.19376,-12.74215,NULL,NULL,'2011-03-13 00:00:00',55633,20.93,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110313/1103130121904106288.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110313/jpg/1103130121904106288.master.jpg',NULL,NULL,43663546867,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1103130121904106288/1103130121904106288.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110313/1103130121904106288p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,682242919,10660045,NULL,NULL,NULL,NULL),(12055,12055,1,'MLS110309-112701+122135','CRTS-MLS',171.75297,12.35985,NULL,NULL,'2011-03-09 00:00:00',55629,20.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110309/1103091121564107532.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110309/jpg/1103091121564107532.master.jpg',NULL,NULL,60229116922,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1103091121564107532/1103091121564107532.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110309/1103091121564107532p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,941079951,14704374,NULL,NULL,NULL,NULL),(12056,12056,1,'MLS110306-085951+175954','CRTS-MLS',134.96178,17.99841,NULL,NULL,'2011-03-06 00:00:00',55626,20.46,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110306/1103061171204110354.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110306/jpg/1103061171204110354.master.jpg',NULL,NULL,63884395506,NULL,NULL,NULL,'2010-05-13 10:33:30',55329.439941,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1103061171204110354/1103061171204110354.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110306/1103061171204110354p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,998193679,15596776,NULL,NULL,NULL,NULL),(12057,12057,1,'MLS110305-033534+210744','CRTS-MLS',53.89231,21.12895,NULL,NULL,'2011-03-05 00:00:00',55625,20.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110305/1103051210474107883.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110305/jpg/1103051210474107883.master.jpg',NULL,NULL,68047982422,NULL,NULL,NULL,'2007-10-31 13:26:29',54404.560059,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1103051210474107883/1103051210474107883.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110305/1103051210474107883p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1063249725,16613276,NULL,NULL,NULL,NULL),(12058,12058,1,'MLS110305-101255+110240','CRTS-MLS',153.22872,11.04431,NULL,NULL,'2011-03-05 00:00:00',55625,20.66,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110305/1103051111404103989.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110305/jpg/1103051111404103989.master.jpg',NULL,NULL,60869152582,NULL,NULL,NULL,'2007-01-10 11:31:10',54110.47998,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1103051111404103989/1103051111404103989.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110305/1103051111404103989p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,951080509,14860632,NULL,NULL,NULL,NULL),(12059,12059,1,'MLS110304-110829+075252','CRTS-MLS',167.12013,7.88105,NULL,NULL,'2011-03-04 00:00:00',55624,20.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110304/1103041081544104678.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110304/jpg/1103041081544104678.master.jpg',NULL,NULL,60311611383,NULL,NULL,NULL,'2008-01-20 13:26:29',54485.560059,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1103041081544104678/1103041081544104678.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110304/1103041081544104678p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,942368927,14724514,NULL,NULL,NULL,NULL),(12060,12060,1,'MLS110303-094103+140207','CRTS-MLS',145.26059,14.03533,NULL,NULL,'2011-03-03 00:00:00',55623,21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110303/1103031131314114256.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110303/jpg/1103031131314114256.master.jpg',NULL,NULL,60819981683,NULL,NULL,NULL,'2005-03-08 13:26:23',53437.559998,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1103031131314114256/1103031131314114256.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110303/1103031131314114256p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,950312213,14848628,NULL,NULL,NULL,NULL),(12061,12061,1,'MLS110302-141646-131039','CRTS-MLS',214.19016,-13.17753,NULL,NULL,'2011-03-02 00:00:00',55622,21.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110302/1103020131934120223.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110302/jpg/1103020131934120223.master.jpg',NULL,NULL,43640853425,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1103020131934120223/1103020131934120223.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110302/1103020131934120223p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,681888334,10654505,NULL,NULL,NULL,NULL),(12062,12062,1,'MLS110301-120600+011042','CRTS-MLS',181.49919,1.17839,NULL,NULL,'2011-03-01 00:00:00',55621,21.66,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:36','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110301/1103011011684101675.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110301/jpg/1103011011684101675.master.jpg',NULL,NULL,57983432243,NULL,NULL,NULL,'2005-02-09 11:31:11',53410.479996,'2013-01-19 01:32:36','http://crts.caltech.edu/ATEL/MLS/1103011011684101675/1103011011684101675.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110301/1103011011684101675p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,905991128,14156111,NULL,NULL,NULL,NULL),(12063,12063,1,'MLS110225-104105+125503','CRTS-MLS',160.26898,12.91753,NULL,NULL,'2011-02-25 00:00:00',55617,20.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110225/1102251121464112894.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110225/jpg/1102251121464112894.master.jpg',NULL,NULL,61177191066,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1102251121464112894/1102251121464112894.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110225/1102251121464112894p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,955893610,14935837,NULL,NULL,NULL,NULL),(12064,12064,1,'MLS110225-093736+125310','CRTS-MLS',144.39802,12.88619,NULL,NULL,'2011-02-25 00:00:00',55617,21.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110225/1102251121314118415.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110225/jpg/1102251121314118415.master.jpg',NULL,NULL,60818261901,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1102251121314118415/1102251121314118415.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110225/1102251121314118415p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,950285342,14848208,NULL,NULL,NULL,NULL),(12065,12065,1,'MLS110225-131246-075204','CRTS-MLS',198.19156,-7.86788,NULL,NULL,'2011-02-25 00:00:00',55617,20.84,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110225/1102250081824112604.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110225/jpg/1102250081824112604.master.jpg',NULL,NULL,43882802128,NULL,NULL,NULL,'2005-03-10 10:33:36',53439.440002,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1102250081824112604/1102250081824112604.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110225/1102250081824112604p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,685668783,10713574,NULL,NULL,NULL,NULL),(12066,12066,1,'MLS110213-014650+120625','CRTS-MLS',26.70743,12.10705,NULL,NULL,'2011-02-13 00:00:00',55605,20.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110213/1102131120254102723.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110213/jpg/1102131120254102723.master.jpg',NULL,NULL,67043920242,NULL,NULL,NULL,'2008-12-05 10:33:30',54805.439941,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1102131120254102723/1102131120254102723.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110213/1102131120254102723p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1047561253,16368144,NULL,NULL,NULL,NULL),(12067,12067,1,'MLS110213-014621+095954','CRTS-MLS',26.5886,9.99846,NULL,NULL,'2011-02-13 00:00:00',55605,20.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110213/1102131100254103282.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110213/jpg/1102131100254103282.master.jpg',NULL,NULL,67043791200,NULL,NULL,NULL,'2009-10-14 10:33:30',55118.439941,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1102131100254103282/1102131100254103282.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110213/1102131100254103282p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1047559237,16368113,NULL,NULL,NULL,NULL),(12068,12068,1,'MLS110211-123537-005004','CRTS-MLS',188.90254,-0.83456,NULL,NULL,'2011-02-11 00:00:00',55603,21.02,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110211/1102110001754104376.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110211/jpg/1102110001754104376.master.jpg',NULL,NULL,42984668388,NULL,NULL,NULL,'2010-02-13 13:26:29',55240.560059,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1102110001754104376/1102110001754104376.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110211/1102110001754104376p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,671635443,10494303,NULL,NULL,NULL,NULL),(12069,12069,1,'MLS110210-101522+090147','CRTS-MLS',153.84289,9.02972,NULL,NULL,'2011-02-10 00:00:00',55602,21.03,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110210/1102101091414105588.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110210/jpg/1102101091414105588.master.jpg',NULL,NULL,60765114181,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1102101091414105588/1102101091414105588.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110210/1102101091414105588p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,949454909,14835232,NULL,NULL,NULL,NULL),(12070,12070,1,'MLS110210-102056+083637','CRTS-MLS',155.23219,8.6104,NULL,NULL,'2011-02-10 00:00:00',55602,21.11,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110210/1102101081434113315.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110210/jpg/1102101081434113315.master.jpg',NULL,NULL,60764919398,NULL,NULL,NULL,'2005-03-11 11:31:11',53440.479996,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1102101081434113315/1102101081434113315.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110210/1102101081434113315p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,949451865,14835185,NULL,NULL,NULL,NULL),(12071,12071,1,'MLS110210-153025-163049','CRTS-MLS',232.60505,-16.51355,NULL,NULL,'2011-02-10 00:00:00',55602,20.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110210/1102100162074119622.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110210/jpg/1102100162074119622.master.jpg',NULL,NULL,46605433254,NULL,NULL,NULL,'2006-04-24 13:26:23',53849.559998,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1102100162074119622/1102100162074119622.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110210/1102100162074119622p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,728209894,11378279,NULL,NULL,NULL,NULL),(12072,12072,1,'MLS110208-094838+202854','CRTS-MLS',147.15723,20.48171,NULL,NULL,'2011-02-08 00:00:00',55600,21.84,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110208/1102081201294118345.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110208/jpg/1102081201294118345.master.jpg',NULL,NULL,63697218054,NULL,NULL,NULL,'2010-02-14 10:33:30',55241.439941,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1102081201294118345/1102081201294118345.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110208/1102081201294118345p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,995269032,15551078,NULL,NULL,NULL,NULL),(12073,12073,1,'MLS110207-094018+152353','CRTS-MLS',145.07337,15.39809,NULL,NULL,'2011-02-07 00:00:00',55599,20.45,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110207/1102071151304104820.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110207/jpg/1102071151304104820.master.jpg',NULL,NULL,63735404575,NULL,NULL,NULL,'2011-01-16 13:26:29',55577.560059,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1102071151304104820/1102071151304104820.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110207/1102071151304104820p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,995865696,15560401,NULL,NULL,NULL,NULL),(12074,12074,1,'MLS110126-111236+023555','CRTS-MLS',168.1519,2.59873,NULL,NULL,'2011-01-26 00:00:00',55587,21.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110126/1101261021564104825.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110126/jpg/1101261021564104825.master.jpg',NULL,NULL,60295475602,NULL,NULL,NULL,'2007-03-26 13:26:23',54185.559998,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1101261021564104825/1101261021564104825.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110126/1101261021564104825p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,942116806,14720575,NULL,NULL,NULL,NULL),(12075,12075,1,'MLS110114-235345+054129','CRTS-MLS',358.43684,5.69142,NULL,NULL,'2011-01-14 00:00:00',55575,20.46,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110114/1101141053304103833.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110114/jpg/1101141053304103833.master.jpg',NULL,NULL,51567189697,NULL,NULL,NULL,'2010-09-15 13:26:29',55454.560059,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1101141053304103833/1101141053304103833.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110114/1101141053304103833p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,805737339,12589645,NULL,NULL,NULL,NULL),(12076,12076,1,'MLS110113-041412+225050','CRTS-MLS',63.55038,22.84726,NULL,NULL,'2011-01-13 00:00:00',55574,18.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110113/1101131230554102341.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110113/jpg/1101131230554102341.master.jpg',NULL,NULL,65096145818,NULL,NULL,NULL,'2010-11-26 11:31:10',55526.47998,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1101131230554102341/1101131230554102341.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110113/1101131230554102341p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1017127278,15892613,NULL,NULL,NULL,NULL),(12077,12077,1,'MLS110113-042612+200041','CRTS-MLS',66.54869,20.01138,NULL,NULL,'2011-01-13 00:00:00',55574,20.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110113/1101131200594109172.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110113/jpg/1101131200594109172.master.jpg',NULL,NULL,65291073440,NULL,NULL,NULL,'2010-12-01 13:26:29',55531.560059,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1101131200594109172/1101131200594109172.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110113/1101131200594109172p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1020173022,15940203,NULL,NULL,NULL,NULL),(12078,12078,1,'MLS110111-105214+080434','CRTS-MLS',163.05754,8.07615,NULL,NULL,'2011-01-11 00:00:00',55572,21.54,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110111/1101111081504106035.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110111/jpg/1101111081504106035.master.jpg',NULL,NULL,61030052472,NULL,NULL,NULL,'2010-05-25 13:26:29',55341.560059,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1101111081504106035/1101111081504106035.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110111/1101111081504106035p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,953594569,14899915,NULL,NULL,NULL,NULL),(12079,12079,1,'MLS110111-104006+070812','CRTS-MLS',160.02427,7.13661,NULL,NULL,'2011-01-11 00:00:00',55572,21.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110111/1101111071484107695.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110111/jpg/1101111071484107695.master.jpg',NULL,NULL,61065684569,NULL,NULL,NULL,'2007-01-28 12:28:49',54128.52002,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1101111071484107695/1101111071484107695.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110111/1101111071484107695p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,954151321,14908614,NULL,NULL,NULL,NULL),(12080,12080,1,'MLS110111-122728-024240','CRTS-MLS',186.86854,-2.71103,NULL,NULL,'2011-01-11 00:00:00',55572,21.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110111/1101110021734107496.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110111/jpg/1101110021734107496.master.jpg',NULL,NULL,42996116888,NULL,NULL,NULL,'2005-03-09 10:33:36',53438.440002,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1101110021734107496/1101110021734107496.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110111/1101110021734107496p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,671814326,10497098,NULL,NULL,NULL,NULL),(12081,12081,1,'MLS110108-073738+344624','CRTS-MLS',114.40749,34.77341,NULL,NULL,'2011-01-08 00:00:00',55569,21.41,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110108/1101081350884103683.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110108/jpg/1101081350884103683.master.jpg',NULL,NULL,63469535410,NULL,NULL,NULL,'2007-05-11 13:26:23',54231.559998,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1101081350884103683/1101081350884103683.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110108/1101081350884103683p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,991711490,15495492,NULL,NULL,NULL,NULL),(12082,12082,1,'MLS110108-073144+343414','CRTS-MLS',112.93497,34.57046,NULL,NULL,'2011-01-08 00:00:00',55569,20.93,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110108/1101081340874127072.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110108/jpg/1101081340874127072.master.jpg',NULL,NULL,63469452920,NULL,NULL,NULL,'2007-12-21 13:26:29',54455.560059,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1101081340874127072/1101081340874127072.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110108/1101081340874127072p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,991710201,15495471,NULL,NULL,NULL,NULL),(12083,12083,1,'MLS110108-083648+254532','CRTS-MLS',129.2007,25.7588,NULL,NULL,'2011-01-08 00:00:00',55569,21.65,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:37','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110108/1101081251094116650.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110108/jpg/1101081251094116650.master.jpg',NULL,NULL,64317549087,NULL,NULL,NULL,'2010-12-07 12:28:49',55537.52002,'2013-01-19 01:32:37','http://crts.caltech.edu/ATEL/MLS/1101081251094116650/1101081251094116650.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110108/1101081251094116650p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1004961704,15702526,NULL,NULL,NULL,NULL),(12084,12084,1,'MLS110105-025534+141037','CRTS-MLS',43.88974,14.17705,NULL,NULL,'2011-01-05 00:00:00',55566,19.18,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110105/1101051140404101178.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110105/jpg/1101051140404101178.master.jpg',NULL,NULL,68168249451,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1101051140404101178/1101051140404101178.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110105/1101051140404101178p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,1065128897,16642639,NULL,NULL,NULL,NULL),(12085,12085,1,'MLS110105-024659+145915','CRTS-MLS',41.74406,14.98751,NULL,NULL,'2011-01-05 00:00:00',55566,20.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110105/1101051140384110791.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110105/jpg/1101051140384110791.master.jpg',NULL,NULL,68145893730,NULL,NULL,NULL,'2005-10-28 13:26:23',53671.559998,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1101051140384110791/1101051140384110791.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110105/1101051140384110791p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1064779589,16637181,NULL,NULL,NULL,NULL),(12086,12086,1,'MLS110104-233208-040032','CRTS-MLS',353.03395,-4.00882,NULL,NULL,'2011-01-04 00:00:00',55565,20.58,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110104/1101040033264103973.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110104/jpg/1101040033264103973.master.jpg',NULL,NULL,49416546144,NULL,NULL,NULL,'2005-10-25 13:26:23',53668.559998,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1101040033264103973/1101040033264103973.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110104/1101040033264103973p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,772133533,12064586,NULL,NULL,NULL,NULL),(12087,12087,1,'MLS101214-045857+165219','CRTS-MLS',74.73594,16.87198,NULL,NULL,'2010-12-14 00:00:00',55544,20.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101214/1012141160674116441.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101214/jpg/1012141160674116441.master.jpg',NULL,NULL,65491424378,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1012141160674116441/1012141160674116441.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101214/1012141160674116441p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1023303505,15989117,NULL,NULL,NULL,NULL),(12088,12088,1,'MLS101214-103705+100224','CRTS-MLS',159.26912,10.04004,NULL,NULL,'2010-12-14 00:00:00',55544,21.58,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101214/1012141101464105005.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101214/jpg/1012141101464105005.master.jpg',NULL,NULL,61046611584,NULL,NULL,NULL,'2009-02-22 10:33:30',54884.439941,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1012141101464105005/1012141101464105005.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101214/1012141101464105005p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,953853306,14903957,NULL,NULL,NULL,NULL),(12090,12090,1,'MLS101209-122524-042413','CRTS-MLS',186.34836,-4.40356,NULL,NULL,'2010-12-09 00:00:00',55539,19.21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101209/1012090041724113725.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101209/jpg/1012090041724113725.master.jpg',NULL,NULL,42992411326,NULL,NULL,NULL,'2008-04-12 12:28:49',54568.52002,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1012090041724113725/1012090041724113725.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101209/1012090041724113725p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,671756426,10496194,NULL,NULL,NULL,NULL),(12091,12091,1,'MLS101208-090510+173845','CRTS-MLS',136.29084,17.64595,NULL,NULL,'2010-12-08 00:00:00',55538,21.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101208/1012081171214107027.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101208/jpg/1012081171214107027.master.jpg',NULL,NULL,63876609485,NULL,NULL,NULL,'2010-05-13 11:31:10',55329.47998,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1012081171214107027/1012081171214107027.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101208/1012081171214107027p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,998072023,15594875,NULL,NULL,NULL,NULL),(12092,12092,1,'MLS101208-010208+125709','CRTS-MLS',15.53488,12.95259,NULL,NULL,'2010-12-08 00:00:00',55538,21.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101208/1012081120154117424.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101208/jpg/1012081120154117424.master.jpg',NULL,NULL,67586205732,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1012081120154117424/1012081120154117424.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101208/1012081120154117424p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1056034464,16500538,NULL,NULL,NULL,NULL),(12093,12093,1,'MLS101208-004439+113507','CRTS-MLS',11.16405,11.58531,NULL,NULL,'2010-12-08 00:00:00',55538,20.96,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101208/1012081110114110722.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101208/jpg/1012081110114110722.master.jpg',NULL,NULL,66739918568,NULL,NULL,NULL,'2010-09-02 13:26:29',55441.560059,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1012081110114110722/1012081110114110722.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101208/1012081110114110722p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1042811227,16293925,NULL,NULL,NULL,NULL),(12094,12094,1,'MLS101208-010316+104745','CRTS-MLS',15.81502,10.79597,NULL,NULL,'2010-12-08 00:00:00',55538,20.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101208/1012081100154117039.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101208/jpg/1012081100154117039.master.jpg',NULL,NULL,67554960449,NULL,NULL,NULL,'2006-11-27 12:28:49',54066.52002,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1012081100154117039/1012081100154117039.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101208/1012081100154117039p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1055546257,16492910,NULL,NULL,NULL,NULL),(12095,12095,1,'MLS101207-031057+131404','CRTS-MLS',47.73579,13.23432,NULL,NULL,'2010-12-07 00:00:00',55537,20.97,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101207/1012071130434103669.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101207/jpg/1012071130434103669.master.jpg',NULL,NULL,68160719436,NULL,NULL,NULL,'2007-11-18 12:28:49',54422.52002,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1012071130434103669/1012071130434103669.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101207/1012071130434103669p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1065011241,16640800,NULL,NULL,NULL,NULL),(12096,12096,1,'MLS101206-000137+053646','CRTS-MLS',0.40551,5.61279,NULL,NULL,'2010-12-06 00:00:00',55536,20.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101206/1012061050014103732.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101206/jpg/1012061050014103732.master.jpg',NULL,NULL,66626670068,NULL,NULL,NULL,'2009-09-18 13:26:29',55092.560059,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1012061050014103732/1012061050014103732.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101206/1012061050014103732p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1041041719,16266276,NULL,NULL,NULL,NULL),(12097,12097,1,'MLS101206-231832-032821','CRTS-MLS',349.63291,-3.47245,NULL,NULL,'2010-12-06 00:00:00',55536,20.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101206/1012060033234115871.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101206/jpg/1012060033234115871.master.jpg',NULL,NULL,49642698177,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1012060033234115871/1012060033234115871.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101206/1012060033234115871p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,775667159,12119799,NULL,NULL,NULL,NULL),(12098,12098,1,'MLS101205-025917+194413','CRTS-MLS',44.82116,19.73683,NULL,NULL,'2010-12-05 00:00:00',55535,22.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101205/1012051200404103966.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101205/jpg/1012051200404103966.master.jpg',NULL,NULL,68128954298,NULL,NULL,NULL,'2007-10-31 11:31:10',54404.47998,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1012051200404103966/1012051200404103966.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101205/1012051200404103966p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1064514910,16633045,NULL,NULL,NULL,NULL),(12099,12099,1,'MLS101203-013137+135510','CRTS-MLS',22.90367,13.91934,NULL,NULL,'2010-12-03 00:00:00',55533,20.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101203/1012031130214114839.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101203/jpg/1012031130214114839.master.jpg',NULL,NULL,67413256086,NULL,NULL,NULL,'2010-02-16 13:26:29',55243.560059,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1012031130214114839/1012031130214114839.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101203/1012031130214114839p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1053332126,16458314,NULL,NULL,NULL,NULL),(12100,12100,1,'MLS101201-034140+130403','CRTS-MLS',55.41571,13.06753,NULL,NULL,'2010-12-01 00:00:00',55531,20.97,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101201/1012011130504101017.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101201/jpg/1012011130504101017.master.jpg',NULL,NULL,65116330647,NULL,NULL,NULL,'2010-11-12 13:26:29',55512.560059,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1012011130504101017/1012011130504101017.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101201/1012011130504101017p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1017442666,15897541,NULL,NULL,NULL,NULL),(12101,12101,1,'MLS101128-020714+121933','CRTS-MLS',31.81027,12.32592,NULL,NULL,'2010-11-28 00:00:00',55528,20.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101128/1011281120294104632.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101128/jpg/1011281120294104632.master.jpg',NULL,NULL,66953157561,NULL,NULL,NULL,'2010-02-17 10:33:30',55244.439941,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1011281120294104632/1011281120294104632.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101128/1011281120294104632p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1046143086,16345985,NULL,NULL,NULL,NULL),(12102,12102,1,'MLS101128-010723+053940','CRTS-MLS',16.84634,5.66109,NULL,NULL,'2010-11-28 00:00:00',55528,21.27,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101128/1011281050164103886.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101128/jpg/1011281050164103886.master.jpg',NULL,NULL,66698065176,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1011281050164103886/1011281050164103886.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101128/1011281050164103886p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1042157268,16283707,NULL,NULL,NULL,NULL),(12103,12103,1,'MLS101127-012848+080006','CRTS-MLS',22.1986,8.00166,NULL,NULL,'2010-11-27 00:00:00',55527,20.58,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101127/1011271080214107055.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101127/jpg/1011271080214107055.master.jpg',NULL,NULL,67539147039,NULL,NULL,NULL,'2010-02-13 11:31:10',55240.47998,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1011271080214107055/1011271080214107055.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101127/1011271080214107055p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1055299172,16489049,NULL,NULL,NULL,NULL),(12104,12104,1,'MLS101127-225145-054348','CRTS-MLS',342.9371,-5.73004,NULL,NULL,'2010-11-27 00:00:00',55527,20.27,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:38','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101127/1011270053164111273.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101127/jpg/1011270053164111273.master.jpg',NULL,NULL,49517959798,NULL,NULL,NULL,'2005-09-30 12:28:47',53643.519989,'2013-01-19 01:32:38','http://crts.caltech.edu/ATEL/MLS/1011270053164111273/1011270053164111273.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101127/1011270053164111273p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,773718121,12089345,NULL,NULL,NULL,NULL),(12105,12105,1,'MLS101126-040502+173532','CRTS-MLS',61.26021,17.59216,NULL,NULL,'2010-11-26 00:00:00',55526,20.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101126/1011261170554203854.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101126/jpg/1011261170554203854.master.jpg',NULL,NULL,65158720879,NULL,NULL,NULL,'2010-03-17 13:26:29',55272.560059,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1011261170554203854/1011261170554203854.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101126/1011261170554203854p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1018105013,15907890,NULL,NULL,NULL,NULL),(12106,12106,1,'MLS101116-112447+041138','CRTS-MLS',171.1973,4.19377,NULL,NULL,'2010-11-16 00:00:00',55516,20.66,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101116/1011161031584110030.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101116/jpg/1011161031584110030.master.jpg',NULL,NULL,60363666349,NULL,NULL,NULL,'2006-02-20 13:26:23',53786.559998,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1011161031584110030/1011161031584110030.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101116/1011161031584110030p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,943182286,14737223,NULL,NULL,NULL,NULL),(12107,12107,1,'MLS101108-043235+131353','CRTS-MLS',68.14672,13.23129,NULL,NULL,'2010-11-08 00:00:00',55508,19.9,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101108/1011081130624103857.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101108/jpg/1011081130624103857.master.jpg',NULL,NULL,65467877436,NULL,NULL,NULL,'2007-12-19 11:31:10',54453.47998,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1011081130624103857/1011081130624103857.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101108/1011081130624103857p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1022935584,15983368,NULL,NULL,NULL,NULL),(12108,12108,1,'MLS101107-072545+192725','CRTS-MLS',111.43589,19.45691,NULL,NULL,'2010-11-07 00:00:00',55507,20.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101107/1011071180984134498.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101107/jpg/1011071180984134498.master.jpg',NULL,NULL,63148023298,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1011071180984134498/1011071180984134498.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101107/1011071180984134498p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,986687864,15416997,NULL,NULL,NULL,NULL),(12109,12109,1,'MLS101105-073035+334020','CRTS-MLS',112.64432,33.67227,NULL,NULL,'2010-11-05 00:00:00',55505,20.1,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101105/1011051340874102022.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101105/jpg/1011051340874102022.master.jpg',NULL,NULL,63474508504,NULL,NULL,NULL,'2007-12-21 11:31:10',54455.47998,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1011051340874102022/1011051340874102022.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101105/1011051340874102022p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,991789195,15496706,NULL,NULL,NULL,NULL),(12110,12110,1,'MLS101103-092644+150020','CRTS-MLS',141.68247,15.0056,NULL,NULL,'2010-11-03 00:00:00',55503,21.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101103/1011031141284114942.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101103/jpg/1011031141284114942.master.jpg',NULL,NULL,63855379820,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1011031141284114942/1011031141284114942.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101103/1011031141284114942p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,997740309,15589692,NULL,NULL,NULL,NULL),(12111,12111,1,'MLS101101-021039+153542','CRTS-MLS',32.66425,15.59495,NULL,NULL,'2010-11-01 00:00:00',55501,21.78,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101101/1011011150304106923.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101101/jpg/1011011150304106923.master.jpg',NULL,NULL,66948059300,NULL,NULL,NULL,'2009-11-18 13:26:29',55153.560059,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1011011150304106923/1011011150304106923.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101101/1011011150304106923p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1046063426,16344741,NULL,NULL,NULL,NULL),(12112,12112,1,'MLS101030-013655+070427','CRTS-MLS',24.22788,7.07413,NULL,NULL,'2010-10-30 00:00:00',55499,20.69,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101030/1010301070234108665.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101030/jpg/1010301070234108665.master.jpg',NULL,NULL,67015919752,NULL,NULL,NULL,'2009-10-15 13:26:29',55119.560059,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1010301070234108665/1010301070234108665.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101030/1010301070234108665p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1047123746,16361308,NULL,NULL,NULL,NULL),(12113,12113,1,'MLS101030-002641+072547','CRTS-MLS',6.6701,7.42966,NULL,NULL,'2010-10-30 00:00:00',55499,21.04,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101030/1010301070074114459.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101030/jpg/1010301070074114459.master.jpg',NULL,NULL,66826523355,NULL,NULL,NULL,'2006-10-23 13:26:23',54031.559998,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1010301070074114459/1010301070074114459.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101030/1010301070074114459p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1044164427,16315069,NULL,NULL,NULL,NULL),(12114,12114,1,'MLS101029-020338+045601','CRTS-MLS',30.90967,4.93365,NULL,NULL,'2010-10-29 00:00:00',55498,20.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101029/1010291040294107578.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101029/jpg/1010291040294107578.master.jpg',NULL,NULL,67071086833,NULL,NULL,NULL,'2009-10-17 10:33:30',55121.439941,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1010291040294107578/1010291040294107578.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101029/1010291040294107578p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1047985731,16374777,NULL,NULL,NULL,NULL),(12115,12115,1,'MLS101028-230514-023756','CRTS-MLS',346.30813,-2.63219,NULL,NULL,'2010-10-28 00:00:00',55497,20.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101028/1010280023214107971.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101028/jpg/1010280023214107971.master.jpg',NULL,NULL,49506327018,NULL,NULL,NULL,'2005-11-01 13:26:23',53675.559998,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1010280023214107971/1010280023214107971.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101028/1010280023214107971p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,773536359,12086505,NULL,NULL,NULL,NULL),(12116,12116,1,'MLS101017-024520+191132','CRTS-MLS',41.33213,19.19219,NULL,NULL,'2010-10-17 00:00:00',55486,20.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101017/1010171180374114764.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101017/jpg/1010171180374114764.master.jpg',NULL,NULL,68120674768,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1010171180374114764/1010171180374114764.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101017/1010171180374114764p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1064385543,16631024,NULL,NULL,NULL,NULL),(12117,12117,1,'MLS101017-015906+142658','CRTS-MLS',29.77554,14.44936,NULL,NULL,'2010-10-17 00:00:00',55486,21.19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101017/1010171140274106251.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101017/jpg/1010171140274106251.master.jpg',NULL,NULL,66961185147,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1010171140274106251/1010171140274106251.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101017/1010171140274106251p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,1046268517,16347945,NULL,NULL,NULL,NULL),(12118,12118,1,'MLS101014-043004+204025','CRTS-MLS',67.51674,20.67363,NULL,NULL,'2010-10-14 00:00:00',55483,20.92,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101014/1010141210594101815.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101014/jpg/1010141210594101815.master.jpg',NULL,NULL,65292849062,NULL,NULL,NULL,'2007-02-08 10:33:36',54139.440002,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1010141210594101815/1010141210594101815.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101014/1010141210594101815p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1020200766,15940636,NULL,NULL,NULL,NULL),(12119,12119,1,'MLS101014-021026+105435','CRTS-MLS',32.60707,10.9096,NULL,NULL,'2010-10-14 00:00:00',55483,20.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101014/1010141110304101018.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101014/jpg/1010141110304101018.master.jpg',NULL,NULL,67082887917,NULL,NULL,NULL,'2005-10-01 10:33:36',53644.440002,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1010141110304101018/1010141110304101018.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101014/1010141110304101018p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1048170123,16377658,NULL,NULL,NULL,NULL),(12120,12120,1,'MLS101010-233735+072913','CRTS-MLS',354.39646,7.48691,NULL,NULL,'2010-10-10 00:00:00',55479,20.69,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101010/1010101073264113798.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101010/jpg/1010101073264113798.master.jpg',NULL,NULL,51785456154,NULL,NULL,NULL,'2007-10-21 11:31:10',54394.47998,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1010101073264113798/1010101073264113798.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101010/1010101073264113798p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,809147752,12642933,NULL,NULL,NULL,NULL),(12121,12121,1,'MLS101009-005952+053039','CRTS-MLS',14.96855,5.51079,NULL,NULL,'2010-10-09 00:00:00',55478,21.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101009/1010091050144101793.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101009/jpg/1010091050144101793.master.jpg',NULL,NULL,66699050374,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1010091050144101793/1010091050144101793.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101009/1010091050144101793p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1042172662,16283947,NULL,NULL,NULL,NULL),(12122,12122,1,'MLS101001-041058+173618','CRTS-MLS',62.74068,17.60498,NULL,NULL,'2010-10-01 00:00:00',55470,20.25,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101001/1010011170564103899.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101001/jpg/1010011170564103899.master.jpg',NULL,NULL,65154028117,NULL,NULL,NULL,'2010-03-17 13:26:29',55272.560059,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1010011170564103899/1010011170564103899.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101001/1010011170564103899p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1018031689,15906745,NULL,NULL,NULL,NULL),(12123,12123,1,'MLS101001-004704+015944','CRTS-MLS',11.76721,1.99542,NULL,NULL,'2010-10-01 00:00:00',55470,21.52,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101001/1010011010114117008.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101001/jpg/1010011010114117008.master.jpg',NULL,NULL,66675749249,NULL,NULL,NULL,'2009-09-21 10:33:30',55095.439941,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1010011010114117008/1010011010114117008.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101001/1010011010114117008p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1041808582,16278259,NULL,NULL,NULL,NULL),(12124,12124,1,'MLS101001-225028-104111','CRTS-MLS',342.61546,-10.6865,NULL,NULL,'2010-10-01 00:00:00',55470,21.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:39','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101001/1010010103134102414.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101001/jpg/1010010103134102414.master.jpg',NULL,NULL,50377110696,NULL,NULL,NULL,'2009-11-18 13:26:29',55153.560059,'2013-01-19 01:32:39','http://crts.caltech.edu/ATEL/MLS/1010010103134102414/1010010103134102414.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101001/1010010103134102414p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,787142354,12299099,NULL,NULL,NULL,NULL),(12125,12125,1,'MLS101001-005016-023113','CRTS-MLS',12.5679,-2.52029,NULL,NULL,'2010-10-01 00:00:00',55470,20.95,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101001/1010010020124109786.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101001/jpg/1010010020124109786.master.jpg',NULL,NULL,34525880530,NULL,NULL,NULL,'2009-10-17 12:28:49',55121.52002,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1010010020124109786/1010010020124109786.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101001/1010010020124109786p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,539466883,8429170,NULL,NULL,NULL,NULL),(12126,12126,1,'MLS100930-010045+010019','CRTS-MLS',15.18618,1.00517,NULL,NULL,'2010-09-30 00:00:00',55469,20.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100930/1009301000154113391.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100930/jpg/1009301000154113391.master.jpg',NULL,NULL,66680802437,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009301000154113391/1009301000154113391.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100930/1009301000154113391p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,1041887538,16279492,NULL,NULL,NULL,NULL),(12127,12127,1,'MLS100929-213143-135133','CRTS-MLS',322.92948,-13.8591,NULL,NULL,'2010-09-29 00:00:00',55468,20.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100929/1009290132914104622.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100929/jpg/1009290132914104622.master.jpg',NULL,NULL,50888976347,NULL,NULL,NULL,'2005-06-17 10:33:36',53538.440002,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009290132914104622/1009290132914104622.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100929/1009290132914104622p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,795140255,12424066,NULL,NULL,NULL,NULL),(12128,12128,1,'MLS100916-030848+225124','CRTS-MLS',47.19815,22.85657,NULL,NULL,'2010-09-16 00:00:00',55455,21.36,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100916/1009161230414102731.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100916/jpg/1009161230414102731.master.jpg',NULL,NULL,67999987615,NULL,NULL,NULL,'2007-09-26 13:26:29',54369.560059,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009161230414102731/1009161230414102731.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100916/1009161230414102731p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1062499806,16601559,NULL,NULL,NULL,NULL),(12129,12129,1,'MLS100915-220215-103412','CRTS-MLS',330.56273,-10.56998,NULL,NULL,'2010-09-15 00:00:00',55454,21.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100915/1009150103024104994.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100915/jpg/1009150103024104994.master.jpg',NULL,NULL,49872712585,NULL,NULL,NULL,'2010-06-21 13:26:29',55368.560059,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009150103024104994/1009150103024104994.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100915/1009150103024104994p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,779261134,12175955,NULL,NULL,NULL,NULL),(12130,12130,1,'MLS100911-231018+051045','CRTS-MLS',347.57489,5.17926,NULL,NULL,'2010-09-11 00:00:00',55450,20.56,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100911/1009111043214118158.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100911/jpg/1009111043214118158.master.jpg',NULL,NULL,51725177922,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009111043214118158/1009111043214118158.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100911/1009111043214118158p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,808205905,12628217,NULL,NULL,NULL,NULL),(12131,12131,1,'MLS100905-234441+060913','CRTS-MLS',356.16891,6.15363,NULL,NULL,'2010-09-05 00:00:00',55444,20.65,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100905/1009051053284112328.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100905/jpg/1009051053284112328.master.jpg',NULL,NULL,51564360529,NULL,NULL,NULL,'2010-06-15 13:26:29',55362.560059,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009051053284112328/1009051053284112328.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100905/1009051053284112328p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,805693133,12588955,NULL,NULL,NULL,NULL),(12132,12132,1,'MLS100904-225021-040600','CRTS-MLS',342.58903,-4.10001,NULL,NULL,'2010-09-04 00:00:00',55443,22.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100904/1009040033164103906.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100904/jpg/1009040033164103906.master.jpg',NULL,NULL,49467121144,NULL,NULL,NULL,'2007-11-11 13:26:29',54415.560059,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009040033164103906/1009040033164103906.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100904/1009040033164103906p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,772923767,12076933,NULL,NULL,NULL,NULL),(12133,12133,1,'MLS100903-231848-040140','CRTS-MLS',349.702,-4.02785,NULL,NULL,'2010-09-03 00:00:00',55442,21.19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100903/1009030033234105431.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100903/jpg/1009030033234105431.master.jpg',NULL,NULL,49633852252,NULL,NULL,NULL,'2005-09-30 13:26:23',53643.559998,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009030033234105431/1009030033234105431.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100903/1009030033234105431p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,775528941,12117639,NULL,NULL,NULL,NULL),(12134,12134,1,'MLS100903-231023-022106','CRTS-MLS',347.59526,-2.35174,NULL,NULL,'2010-09-03 00:00:00',55442,21.33,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100903/1009030023224115498.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100903/jpg/1009030023224115498.master.jpg',NULL,NULL,49507226471,NULL,NULL,NULL,'2007-11-07 13:26:29',54411.560059,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009030023224115498/1009030023224115498.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100903/1009030023224115498p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,773550413,12086725,NULL,NULL,NULL,NULL),(12135,12135,1,'MLS100902-004457+104526','CRTS-MLS',11.23878,10.75711,NULL,NULL,'2010-09-02 00:00:00',55441,21.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100902/1009021100114117618.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100902/jpg/1009021100114117618.master.jpg',NULL,NULL,66774125458,NULL,NULL,NULL,'2007-11-07 12:28:49',54411.52002,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009021100114117618/1009021100114117618.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100902/1009021100114117618p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1043345710,16302276,NULL,NULL,NULL,NULL),(12136,12136,1,'MLS100902-225542-072119','CRTS-MLS',343.92559,-7.35538,NULL,NULL,'2010-09-02 00:00:00',55441,20.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020073174104364.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100902/jpg/1009020073174104364.master.jpg',NULL,NULL,50373045798,NULL,NULL,NULL,'2007-11-09 13:26:29',54413.560059,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009020073174104364/1009020073174104364.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020073174104364p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,787078840,12298106,NULL,NULL,NULL,NULL),(12137,12137,1,'MLS100902-225935-054050','CRTS-MLS',344.8957,-5.68049,NULL,NULL,'2010-09-02 00:00:00',55441,20.98,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020053184115077.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100902/jpg/1009020053184115077.master.jpg',NULL,NULL,49519592676,NULL,NULL,NULL,'2010-06-20 10:33:30',55367.439941,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009020053184115077/1009020053184115077.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020053184115077p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,773743635,12089744,NULL,NULL,NULL,NULL),(12138,12138,1,'MLS100902-233950-035927','CRTS-MLS',354.9585,-3.99095,NULL,NULL,'2010-09-02 00:00:00',55441,21.11,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020033284106997.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100902/jpg/1009020033284106997.master.jpg',NULL,NULL,49445397623,NULL,NULL,NULL,'2005-10-28 13:26:23',53671.559998,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009020033284106997/1009020033284106997.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020033284106997p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,772584337,12071630,NULL,NULL,NULL,NULL),(12139,12139,1,'MLS100902-224533-032733','CRTS-MLS',341.3889,-3.4591,NULL,NULL,'2010-09-02 00:00:00',55441,21.54,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020033154116804.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100902/jpg/1009020033154116804.master.jpg',NULL,NULL,49466315583,NULL,NULL,NULL,'2007-11-11 13:26:29',54415.560059,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009020033154116804/1009020033154116804.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020033154116804p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,772911180,12076737,NULL,NULL,NULL,NULL),(12140,12140,1,'MLS100902-223830-040508','CRTS-MLS',339.62314,-4.08542,NULL,NULL,'2010-09-02 00:00:00',55441,20.42,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020033144105577.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100902/jpg/1009020033144105577.master.jpg',NULL,NULL,50347920734,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009020033144105577/1009020033144105577.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020033144105577p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,786686261,12291972,NULL,NULL,NULL,NULL),(12141,12141,1,'MLS100902-223853-030946','CRTS-MLS',339.71968,-3.16276,NULL,NULL,'2010-09-02 00:00:00',55441,20.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020023154102234.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100902/jpg/1009020023154102234.master.jpg',NULL,NULL,50345367750,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009020023154102234/1009020023154102234.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020023154102234p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,786646371,12291349,NULL,NULL,NULL,NULL),(12142,12142,1,'MLS100902-231605-001856','CRTS-MLS',349.02075,-0.31563,NULL,NULL,'2010-09-02 00:00:00',55441,21.58,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020003234113567.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100902/jpg/1009020003234113567.master.jpg',NULL,NULL,49627041008,NULL,NULL,NULL,'2006-11-14 13:26:23',54053.559998,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009020003234113567/1009020003234113567.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020003234113567p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,775422515,12115976,NULL,NULL,NULL,NULL),(12143,12143,1,'MLS100901-021601+134912','CRTS-MLS',34.00328,13.82,NULL,NULL,'2010-09-01 00:00:00',55440,20.92,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100901/1009011130314112020.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100901/jpg/1009011130314112020.master.jpg',NULL,NULL,66942510419,NULL,NULL,NULL,'2010-02-13 10:33:41',55240.440063,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1009011130314112020/1009011130314112020.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100901/1009011130314112020p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1045976725,16343386,NULL,NULL,NULL,NULL),(12144,12144,1,'MLS100620-211921-143828','CRTS-MLS',319.83544,-14.64121,NULL,NULL,'2010-06-20 00:00:00',55367,20.47,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:40','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100620/1006200142874112292.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100620/jpg/1006200142874112292.master.jpg',NULL,NULL,50968998862,NULL,NULL,NULL,'2007-10-13 13:26:29',54386.560059,'2013-01-19 01:32:40','http://crts.caltech.edu/ATEL/MLS/1006200142874112292/1006200142874112292.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100620/1006200142874112292p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,796390607,12443603,NULL,NULL,NULL,NULL),(12145,12145,1,'MLS100618-203949-184849','CRTS-MLS',309.95428,-18.81369,NULL,NULL,'2010-06-18 00:00:00',55365,20.54,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100618/1006180182734123020.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100618/jpg/1006180182734123020.master.jpg',NULL,NULL,50851759552,NULL,NULL,NULL,'2007-10-15 13:26:29',54388.560059,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1006180182734123020/1006180182734123020.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100618/1006180182734123020p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,794558743,12414980,NULL,NULL,NULL,NULL),(12146,12146,1,'MLS100617-140447-152226','CRTS-MLS',211.19526,-15.37397,NULL,NULL,'2010-06-17 00:00:00',55364,18.26,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100617/1006170151894115698.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100617/jpg/1006170151894115698.master.jpg',NULL,NULL,43648242020,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1006170151894115698/1006170151894115698.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100617/1006170151894115698p.html',NULL,NULL,0,'AGN',NULL,0,NULL,0,682003781,10656309,NULL,NULL,NULL,NULL),(12147,12147,1,'MLS100610-150844-163231','CRTS-MLS',227.18215,-16.54207,NULL,NULL,'2010-06-10 00:00:00',55357,21.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100610/1006100162024116007.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100610/jpg/1006100162024116007.master.jpg',NULL,NULL,46701420434,NULL,NULL,NULL,'2005-04-02 11:31:11',53462.479996,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1006100162024116007/1006100162024116007.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100610/1006100162024116007p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,729709694,11401713,NULL,NULL,NULL,NULL),(12148,12148,1,'MLS100520-142726-125216','CRTS-MLS',216.86024,-12.87108,NULL,NULL,'2010-05-20 00:00:00',55336,21.21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100520/1005200121974102463.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100520/jpg/1005200121974102463.master.jpg',NULL,NULL,46675140952,NULL,NULL,NULL,'2007-05-09 12:28:49',54229.52002,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1005200121974102463/1005200121974102463.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100520/1005200121974102463p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,729299077,11395298,NULL,NULL,NULL,NULL),(12149,12149,1,'MLS100519-115713-050759','CRTS-MLS',179.30346,-5.13292,NULL,NULL,'2010-05-19 00:00:00',55335,20.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100519/1005190041664104312.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100519/jpg/1005190041664104312.master.jpg',NULL,NULL,40856806352,NULL,NULL,NULL,'2008-05-11 13:26:29',54597.560059,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1005190041664104312/1005190041664104312.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100519/1005190041664104312p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,638387599,9974806,NULL,NULL,NULL,NULL),(12150,12150,1,'MLS100517-131833-050108','CRTS-MLS',199.6371,-5.01876,NULL,NULL,'2010-05-17 00:00:00',55333,20.01,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100517/1005170041854106424.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100517/jpg/1005170041854106424.master.jpg',NULL,NULL,43827723797,NULL,NULL,NULL,'2005-03-18 13:26:23',53447.559998,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1005170041854106424/1005170041854106424.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100517/1005170041854106424p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,684808184,10700127,NULL,NULL,NULL,NULL),(12151,12151,1,'MLS100512-162221-071104','CRTS-MLS',245.5889,-7.18443,NULL,NULL,'2010-05-12 00:00:00',55328,20.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100512/1005120072264110303.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100512/jpg/1005120072264110303.master.jpg',NULL,NULL,45541639979,NULL,NULL,NULL,'2009-09-16 11:31:10',55090.47998,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1005120072264110303/1005120072264110303.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100512/1005120072264110303p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,711588124,11118564,NULL,NULL,NULL,NULL),(12152,12152,1,'MLS100510-090810+153612','CRTS-MLS',137.04218,15.60323,NULL,NULL,'2010-05-10 00:00:00',55326,20.98,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100510/1005101151234106914.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100510/jpg/1005101151234106914.master.jpg',NULL,NULL,63885553611,NULL,NULL,NULL,'2010-04-07 13:26:29',55293.560059,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1005101151234106914/1005101151234106914.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100510/1005101151234106914p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,998211775,15597058,NULL,NULL,NULL,NULL),(12153,12153,1,'MLS100509-145919-134947','CRTS-MLS',224.82782,-13.82972,NULL,NULL,'2010-05-09 00:00:00',55325,20.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100509/1005090132034105562.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100509/jpg/1005090132034105562.master.jpg',NULL,NULL,46691325602,NULL,NULL,NULL,'2010-03-16 13:26:29',55271.560059,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1005090132034105562/1005090132034105562.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100509/1005090132034105562p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,729551962,11399249,NULL,NULL,NULL,NULL),(12154,12154,1,'MLS100508-094850+120028','CRTS-MLS',147.20721,12.00772,NULL,NULL,'2010-05-08 00:00:00',55324,20.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100508/1005081121344101800.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100508/jpg/1005081121344101800.master.jpg',NULL,NULL,60894129072,NULL,NULL,NULL,'2007-03-09 13:26:23',54168.559998,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1005081121344101800/1005081121344101800.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100508/1005081121344101800p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,951470766,14866730,NULL,NULL,NULL,NULL),(12155,12155,1,'MLS100508-150214-160923','CRTS-MLS',225.5587,-16.15644,NULL,NULL,'2010-05-08 00:00:00',55324,20.61,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100508/1005080152024103113.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100508/jpg/1005080152024103113.master.jpg',NULL,NULL,46705013616,NULL,NULL,NULL,'2005-03-12 10:33:36',53441.440002,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1005080152024103113/1005080152024103113.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100508/1005080152024103113p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,729765837,11402591,NULL,NULL,NULL,NULL),(12156,12156,1,'MLS100505-113416+021855','CRTS-MLS',173.56751,2.31517,NULL,NULL,'2010-05-05 00:00:00',55321,20.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100505/1005051021614102226.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100505/jpg/1005051021614102226.master.jpg',NULL,NULL,60176560297,NULL,NULL,NULL,'2007-10-30 13:26:29',54403.560059,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1005051021614102226/1005051021614102226.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100505/1005051021614102226p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,940258754,14691543,NULL,NULL,NULL,NULL),(12157,12157,1,'MLS100505-124923-062351','CRTS-MLS',192.34509,-6.39757,NULL,NULL,'2010-05-05 00:00:00',55321,20.3,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100505/1005050051774102051.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100505/jpg/1005050051774102051.master.jpg',NULL,NULL,43129320081,NULL,NULL,NULL,'2007-05-09 12:28:49',54229.52002,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1005050051774102051/1005050051774102051.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100505/1005050051774102051p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,673895626,10529619,NULL,NULL,NULL,NULL),(12158,12158,1,'MLS100414-124153-072332','CRTS-MLS',190.47168,-7.39228,NULL,NULL,'2010-04-14 00:00:00',55300,20.68,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100414/1004140071764103161.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100414/jpg/1004140071764103161.master.jpg',NULL,NULL,43159037756,NULL,NULL,NULL,'2007-05-16 13:26:23',54236.559998,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1004140071764103161/1004140071764103161.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100414/1004140071764103161p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,674359964,10536874,NULL,NULL,NULL,NULL),(12159,12159,1,'MLS100412-094924+151831','CRTS-MLS',147.34929,15.30848,NULL,NULL,'2010-04-12 00:00:00',55298,21.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100412/1004121151324102440.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100412/jpg/1004121151324102440.master.jpg',NULL,NULL,60827150915,NULL,NULL,NULL,'2006-03-26 13:26:23',53820.559998,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1004121151324102440/1004121151324102440.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100412/1004121151324102440p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,950424233,14850378,NULL,NULL,NULL,NULL),(12160,12160,1,'MLS100412-094229+160424','CRTS-MLS',145.6229,16.07344,NULL,NULL,'2010-04-12 00:00:00',55298,21.23,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100412/1004121151304115264.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100412/jpg/1004121151304115264.master.jpg',NULL,NULL,63727010485,NULL,NULL,NULL,'2007-11-19 13:26:29',54423.560059,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1004121151304115264/1004121151304115264.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100412/1004121151304115264p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,995734538,15558352,NULL,NULL,NULL,NULL),(12161,12161,1,'MLS100412-123217-012237','CRTS-MLS',188.07182,-1.37688,NULL,NULL,'2010-04-12 00:00:00',55298,21.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100412/1004120011744110640.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100412/jpg/1004120011744110640.master.jpg',NULL,NULL,42998582437,NULL,NULL,NULL,'2007-11-20 13:26:29',54424.560059,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1004120011744110640/1004120011744110640.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100412/1004120011744110640p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,671852850,10497700,NULL,NULL,NULL,NULL),(12162,12162,1,'MLS100410-113650+051538','CRTS-MLS',174.20651,5.26054,NULL,NULL,'2010-04-10 00:00:00',55296,21.14,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100410/1004101041614115039.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100410/jpg/1004101041614115039.master.jpg',NULL,NULL,60171713014,NULL,NULL,NULL,'2007-05-18 13:26:23',54238.559998,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1004101041614115039/1004101041614115039.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100410/1004101041614115039p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,940183015,14690359,NULL,NULL,NULL,NULL),(12163,12163,1,'MLS100321-132110-061820','CRTS-MLS',200.29242,-6.3056,NULL,NULL,'2010-03-21 00:00:00',55276,21.33,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100321/1003210051854103106.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100321/jpg/1003210051854103106.master.jpg',NULL,NULL,43885218950,NULL,NULL,NULL,'2007-04-19 10:33:36',54209.440002,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1003210051854103106/1003210051854103106.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100321/1003210051854103106p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,685706546,10714164,NULL,NULL,NULL,NULL),(12164,12164,1,'MLS100319-110509+080010','CRTS-MLS',166.28651,8.0029,NULL,NULL,'2010-03-19 00:00:00',55274,21.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100319/1003191081534107424.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100319/jpg/1003191081534107424.master.jpg',NULL,NULL,60312787026,NULL,NULL,NULL,'2007-12-31 13:26:29',54465.560059,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1003191081534107424/1003191081534107424.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100319/1003191081534107424p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,942387297,14724801,NULL,NULL,NULL,NULL),(12165,12165,1,'MLS100217-014546+121527','CRTS-MLS',26.44257,12.25743,NULL,NULL,'2010-02-17 00:00:00',55244,20.35,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:41','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100217/1002171120244103805.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100217/jpg/1002171120244103805.master.jpg',NULL,NULL,66926013452,NULL,NULL,NULL,'2009-12-16 13:26:29',55181.560059,'2013-01-19 01:32:41','http://crts.caltech.edu/ATEL/MLS/1002171120244103805/1002171120244103805.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100217/1002171120244103805p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1045718960,16339358,NULL,NULL,NULL,NULL),(12166,12166,1,'MLS091219-021607+110712','CRTS-MLS',34.02913,11.12005,NULL,NULL,'2009-12-19 00:00:00',55184,20.24,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20091219/912191110314104218.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20091219/jpg/912191110314104218.master.jpg',NULL,NULL,67090628471,NULL,NULL,NULL,'2007-02-08 13:26:23',54139.559998,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/912191110314104218/912191110314104218.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20091219/912191110314104218p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1048291069,16379547,NULL,NULL,NULL,NULL),(12168,12168,1,'MLS091118-003528+053706','CRTS-MLS',8.86502,5.61824,NULL,NULL,'2009-11-18 00:00:00',55153,21.24,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20091118/911181050094103010.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20091118/jpg/911181050094103010.master.jpg',NULL,NULL,66812162956,NULL,NULL,NULL,'2006-10-19 11:31:10',54027.47998,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/911181050094103010/911181050094103010.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20091118/911181050094103010p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,1043940046,16311563,NULL,NULL,NULL,NULL),(12169,12169,1,'MLS091117-075116+192654','CRTS-MLS',117.81608,19.44838,NULL,NULL,'2009-11-17 00:00:00',55152,21.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20091117/911171181044126221.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20091117/jpg/911171181044126221.master.jpg',NULL,NULL,62625849360,NULL,NULL,NULL,'2005-10-06 13:26:23',53649.559998,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/911171181044126221/911171181044126221.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20091117/911171181044126221p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,978528896,15289514,NULL,NULL,NULL,NULL),(12170,12170,1,'MLS130118-045611+204506','CRTS-MLS',74.04602,20.75172,NULL,NULL,'2013-01-18 00:00:00',56310,18.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130118/1301181210654105454.html','RRLyrae mag 19,4     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130118/jpg/1301181210654105454.master.jpg',NULL,NULL,65462620760,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/1301181210654105454/1301181210654105454.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130118/1301181210654105454p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1022853449,15982085,NULL,NULL,NULL,NULL),(12171,12171,1,'MLS130118-090635+145802','CRTS-MLS',136.64683,14.96733,NULL,NULL,'2013-01-18 00:00:00',56310,21.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130118/1301181141234115578.html','Unknown mag >22,5     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130118/jpg/1301181141234115578.master.jpg',NULL,NULL,63872096067,NULL,NULL,NULL,'2012-03-28 12:28:49',56014.52002,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/1301181141234115578/1301181141234115578.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130118/1301181141234115578p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,998001501,15593773,NULL,NULL,NULL,NULL),(12172,12172,1,'MLS130118-233354-031127','CRTS-MLS',353.47671,-3.19085,NULL,NULL,'2013-01-18 00:00:00',56310,20.67,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130118/1301180023274101368.html','Unknown SDSS mag 21,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130118/jpg/1301180023274101368.master.jpg',NULL,NULL,49414492391,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/1301180023274101368/1301180023274101368.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130118/1301180023274101368p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,772101443,12064085,NULL,NULL,NULL,NULL),(12173,12173,1,'MLS130117-104205+090057','CRTS-MLS',160.51902,9.01581,NULL,NULL,'2013-01-17 00:00:00',56309,21.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130117/1301171091474105915.html','Unknown SDSS mag 22,7    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130117/jpg/1301171091474105915.master.jpg',NULL,NULL,61053819388,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/1301171091474105915/1301171091474105915.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130117/1301171091474105915p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,953965927,14905717,NULL,NULL,NULL,NULL),(12174,12174,1,'MLS130116-113739+024652','CRTS-MLS',174.41383,2.78118,NULL,NULL,'2013-01-16 00:00:00',56308,21.68,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130116/1301161021624109879.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130116/jpg/1301161021624109879.master.jpg',NULL,NULL,60186180736,NULL,NULL,NULL,'2009-05-28 13:26:29',54979.560059,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/1301161021624109879/1301161021624109879.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130116/1301161021624109879p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,940409074,14693891,NULL,NULL,NULL,NULL),(12175,12175,1,'MLS130115-030228+162141','CRTS-MLS',45.61723,16.36147,NULL,NULL,'2013-01-15 00:00:00',56307,21.55,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130115/1301151160414101925.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130115/jpg/1301151160414101925.master.jpg',NULL,NULL,68181298830,NULL,NULL,NULL,'2011-01-26 10:33:30',55587.439941,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/1301151160414101925/1301151160414101925.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130115/1301151160414101925p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1065332794,16645824,NULL,NULL,NULL,NULL),(12176,12176,1,'MLS130109-032737+201558','CRTS-MLS',51.90318,20.26611,NULL,NULL,'2013-01-09 00:00:00',56301,21.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130109/1301091200464111437.html','Unknown mag 22     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130109/jpg/1301091200464111437.master.jpg',NULL,NULL,68034824453,NULL,NULL,NULL,'2012-12-08 13:26:29',56269.560059,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/1301091200464111437/1301091200464111437.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130109/1301091200464111437p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1063044132,16610064,NULL,NULL,NULL,NULL),(12177,12177,1,'MLS130106-043337+274916','CRTS-MLS',68.40255,27.82112,NULL,NULL,'2013-01-06 00:00:00',56298,19.31,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130106/1301061270574117753.html','Unknown mag >22     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130106/jpg/1301061270574117753.master.jpg',NULL,NULL,64772566459,NULL,NULL,NULL,'2012-12-11 13:26:29',56272.560059,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/1301061270574117753/1301061270574117753.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130106/1301061270574117753p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1012071350,15813614,NULL,NULL,NULL,NULL),(12178,12178,1,'MLS130106-025117+164458','CRTS-MLS',42.82031,16.74943,NULL,NULL,'2013-01-06 00:00:00',56298,21.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130106/1301061160394108404.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130106/jpg/1301061160394108404.master.jpg',NULL,NULL,68176272466,NULL,NULL,NULL,'2011-01-05 11:31:10',55566.47998,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/1301061160394108404/1301061160394108404.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130106/1301061160394108404p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1065254257,16644597,NULL,NULL,NULL,NULL),(12179,12179,1,'MLS130105-045533+212610','CRTS-MLS',73.88687,21.43612,NULL,NULL,'2013-01-05 00:00:00',56297,20.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20130105/1301051210654125391.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20130105/jpg/1301051210654125391.master.jpg',NULL,NULL,65265693797,NULL,NULL,NULL,'2012-12-21 13:26:29',56282.560059,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/1301051210654125391/1301051210654125391.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20130105/1301051210654125391p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1019776465,15934007,NULL,NULL,NULL,NULL),(12180,12180,1,'MLS121213-095655+122107','CRTS-MLS',149.23035,12.35182,NULL,NULL,'2012-12-13 00:00:00',56274,21.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121213/1212131121364106432.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121213/jpg/1212131121364106432.master.jpg',NULL,NULL,60821785980,NULL,NULL,NULL,'2012-11-02 13:26:29',56233.560059,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/1212131121364106432/1212131121364106432.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121213/1212131121364106432p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,950340405,14849068,NULL,NULL,NULL,NULL),(12181,12181,1,'MLS121209-093952+151954','CRTS-MLS',144.96799,15.33169,NULL,NULL,'2012-12-09 00:00:00',56270,21.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121209/1212091151304102714.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121209/jpg/1212091151304102714.master.jpg',NULL,NULL,63735136734,NULL,NULL,NULL,'2012-02-29 13:26:29',55986.560059,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/1212091151304102714/1212091151304102714.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121209/1212091151304102714p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,995861511,15560336,NULL,NULL,NULL,NULL),(12182,12182,1,'MLS121208-034420+185339','CRTS-MLS',56.0818,18.89427,NULL,NULL,'2012-12-08 00:00:00',56269,20.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121208/1212081180504108542.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121208/jpg/1212081180504108542.master.jpg',NULL,NULL,68039440216,NULL,NULL,NULL,'2005-10-01 12:28:47',53644.519989,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/1212081180504108542/1212081180504108542.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121208/1212081180504108542p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1063116253,16611191,NULL,NULL,NULL,NULL),(12183,12183,1,'MLS121208-102000+094829','CRTS-MLS',154.99903,9.80803,NULL,NULL,'2012-12-08 00:00:00',56269,20.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121208/1212081101424100989.html','Unknown mag 22     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121208/jpg/1212081101424100989.master.jpg',NULL,NULL,60754399764,NULL,NULL,NULL,'2005-12-25 12:28:47',53729.519989,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/1212081101424100989/1212081101424100989.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121208/1212081101424100989p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,949287496,14832617,NULL,NULL,NULL,NULL),(12184,12184,1,'MLS121204-030629+155040','CRTS-MLS',46.62063,15.84435,NULL,NULL,'2012-12-04 00:00:00',56265,20.81,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121204/1212041150424108509.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121204/jpg/1212041150424108509.master.jpg',NULL,NULL,68180765687,NULL,NULL,NULL,'2006-01-22 12:28:47',53757.519989,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/1212041150424108509/1212041150424108509.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121204/1212041150424108509p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1065324463,16645694,NULL,NULL,NULL,NULL),(12185,12185,1,'MLS121202-040802+162819','CRTS-MLS',62.00834,16.47184,NULL,NULL,'2012-12-02 00:00:00',56263,19.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121202/1212021160564102705.html','Var mag 19,8     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121202/jpg/1212021160564102705.master.jpg',NULL,NULL,65152786470,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/1212021160564102705/1212021160564102705.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121202/1212021160564102705p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,1018012288,15906442,NULL,NULL,NULL,NULL),(12186,12186,1,'MLS121202-120519+020537','CRTS-MLS',181.32962,2.09354,NULL,NULL,'2012-12-02 00:00:00',56263,17.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:42','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121202/1212021011684113551.html','HPM? SDSS mag 17,8    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121202/jpg/1212021011684113551.master.jpg',NULL,NULL,57996032197,NULL,NULL,NULL,'2011-04-25 11:31:10',55676.47998,'2013-01-19 01:32:42','http://crts.caltech.edu/ATEL/MLS/1212021011684113551/1212021011684113551.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121202/1212021011684113551p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,906188003,14159187,NULL,NULL,NULL,NULL),(12187,12187,1,'MLS121120-033824+263225','CRTS-MLS',54.60114,26.54038,NULL,NULL,'2012-11-20 00:00:00',56251,21.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121120/1211201260464111146.html','Unknown SDSS mag 22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121120/jpg/1211201260464111146.master.jpg',NULL,NULL,68506390688,NULL,NULL,NULL,'2008-11-21 12:28:49',54791.52002,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1211201260464111146/1211201260464111146.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121120/1211201260464111146p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1070412354,16725193,NULL,NULL,NULL,NULL),(12188,12188,1,'MLS121120-031638+202904','CRTS-MLS',49.15953,20.48432,NULL,NULL,'2012-11-20 00:00:00',56251,20.82,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121120/1211201200434118091.html','Unknown mag >22     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121120/jpg/1211201200434118091.master.jpg',NULL,NULL,68005766405,NULL,NULL,NULL,'2011-11-30 12:28:49',55895.52002,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1211201200434118091/1211201200434118091.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121120/1211201200434118091p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1062590100,16602970,NULL,NULL,NULL,NULL),(12189,12189,1,'MLS121120-033236+190901','CRTS-MLS',53.1485,19.15038,NULL,NULL,'2012-11-20 00:00:00',56251,21.41,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121120/1211201180474113221.html','Unknown mag >22     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121120/jpg/1211201180474113221.master.jpg',NULL,NULL,68033621214,NULL,NULL,NULL,'2010-02-13 13:26:29',55240.560059,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1211201180474113221/1211201180474113221.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121120/1211201180474113221p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1063025331,16609770,NULL,NULL,NULL,NULL),(12190,12190,1,'MLS121120-000212+022049','CRTS-MLS',0.5491,2.34682,NULL,NULL,'2012-11-20 00:00:00',56251,20.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121120/1211201020014102561.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121120/jpg/1211201020014102561.master.jpg',NULL,NULL,66585746292,NULL,NULL,NULL,'2011-11-23 12:28:49',55888.52002,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1211201020014102561/1211201020014102561.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121120/1211201020014102561p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1040402285,16256285,NULL,NULL,NULL,NULL),(12191,12191,1,'MLS121117-022821+143326','CRTS-MLS',37.08953,14.55718,NULL,NULL,'2012-11-17 00:00:00',56248,20.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121117/1211171140344106535.html','Unknown MLS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121117/jpg/1211171140344106535.master.jpg',NULL,NULL,68066918011,NULL,NULL,NULL,'2006-09-25 10:33:36',54003.440002,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1211171140344106535/1211171140344106535.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121117/1211171140344106535p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1063545593,16617899,NULL,NULL,NULL,NULL),(12192,12192,1,'MLS121117-022331+121732','CRTS-MLS',35.87996,12.29224,NULL,NULL,'2012-11-17 00:00:00',56248,21.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121117/1211171120334106221.html','Unknown MLS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121117/jpg/1211171120334106221.master.jpg',NULL,NULL,66941138059,NULL,NULL,NULL,'2009-11-16 11:31:10',55151.47998,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1211171120334106221/1211171120334106221.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121117/1211171120334106221p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1045955282,16343051,NULL,NULL,NULL,NULL),(12193,12193,1,'MLS121115-024057+185712','CRTS-MLS',40.23828,18.95347,NULL,NULL,'2012-11-15 00:00:00',56246,20.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121115/1211151180364107076.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121115/jpg/1211151180364107076.master.jpg',NULL,NULL,68098777590,NULL,NULL,NULL,'2009-11-22 11:31:10',55157.47998,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1211151180364107076/1211151180364107076.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121115/1211151180364107076p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1064043399,16625678,NULL,NULL,NULL,NULL),(12194,12194,1,'MLS121115-025711+112343','CRTS-MLS',44.29681,11.39525,NULL,NULL,'2012-11-15 00:00:00',56246,19.44,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121115/1211151110414106451.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121115/jpg/1211151110414106451.master.jpg',NULL,NULL,67956711565,NULL,NULL,NULL,'2012-11-04 13:26:29',56235.560059,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1211151110414106451/1211151110414106451.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121115/1211151110414106451p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1061823618,16590994,NULL,NULL,NULL,NULL),(12195,12195,1,'MLS121113-080834+192510','CRTS-MLS',122.14214,19.41942,NULL,NULL,'2012-11-13 00:00:00',56244,19.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121113/1211131181084117939.html','RRLyrae mag 20,5     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121113/jpg/1211131181084117939.master.jpg',NULL,NULL,63758039348,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1211131181084117939/1211131181084117939.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121113/1211131181084117939p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,996219364,15565927,NULL,NULL,NULL,NULL),(12196,12196,1,'MLS121112-074113+230740','CRTS-MLS',115.30567,23.12774,NULL,NULL,'2012-11-12 00:00:00',56243,21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121112/1211121230994109658.html','Unknown SDSS mag 22,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121112/jpg/1211121230994109658.master.jpg',NULL,NULL,63086512857,NULL,NULL,NULL,'2010-11-10 11:31:10',55510.47998,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1211121230994109658/1211121230994109658.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121112/1211121230994109658p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,985726763,15401980,NULL,NULL,NULL,NULL),(12197,12197,1,'MLS121112-025337+133023','CRTS-MLS',43.40223,13.50627,NULL,NULL,'2012-11-12 00:00:00',56243,20.37,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121112/1211121130404106388.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121112/jpg/1211121130404106388.master.jpg',NULL,NULL,68140294004,NULL,NULL,NULL,'2005-10-29 13:26:23',53672.559998,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1211121130404106388/1211121130404106388.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121112/1211121130404106388p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1064692093,16635813,NULL,NULL,NULL,NULL),(12198,12198,1,'MLS121107-025350+161828','CRTS-MLS',43.45926,16.30774,NULL,NULL,'2012-11-07 00:00:00',56238,21.3,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121107/1211071160394101134.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121107/jpg/1211071160394101134.master.jpg',NULL,NULL,68180327749,NULL,NULL,NULL,'2012-11-04 13:26:29',56235.560059,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1211071160394101134/1211071160394101134.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121107/1211071160394101134p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1065317621,16645587,NULL,NULL,NULL,NULL),(12199,12199,1,'MLS121107-050558+130943','CRTS-MLS',76.49352,13.16207,NULL,NULL,'2012-11-07 00:00:00',56238,19.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121107/1211071130694104067.html','Var SDSS mag 21,6    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121107/jpg/1211071130694104067.master.jpg',NULL,NULL,65446874715,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1211071130694104067/1211071130694104067.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121107/1211071130694104067p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,1022607417,15978240,NULL,NULL,NULL,NULL),(12202,12202,1,'MLS121104-022033+090117','CRTS-MLS',35.13919,9.02143,NULL,NULL,'2012-11-04 00:00:00',56235,20.04,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121104/1211041090334104989.html','Var?       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121104/jpg/1211041090334104989.master.jpg',NULL,NULL,67084855574,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1211041090334104989/1211041090334104989.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121104/1211041090334104989p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,1048200868,16378138,NULL,NULL,NULL,NULL),(12203,12203,1,'MLS121017-033606+133636','CRTS-MLS',54.02509,13.61008,NULL,NULL,'2012-10-17 00:00:00',56217,20.78,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121017/1210171130494107766.html','Unknown SDSS mag >22,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121017/jpg/1210171130494107766.master.jpg',NULL,NULL,68015222121,NULL,NULL,NULL,'2011-11-27 13:26:29',55892.560059,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1210171130494107766/1210171130494107766.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121017/1210171130494107766p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1062737845,16605278,NULL,NULL,NULL,NULL),(12204,12204,1,'MLS121015-010755+113502','CRTS-MLS',16.9785,11.58394,NULL,NULL,'2012-10-15 00:00:00',56215,21.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121015/1210151110164113907.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121015/jpg/1210151110164113907.master.jpg',NULL,NULL,67553978087,NULL,NULL,NULL,'2007-02-09 13:26:23',54140.559998,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1210151110164113907/1210151110164113907.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121015/1210151110164113907p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1055530907,16492670,NULL,NULL,NULL,NULL),(12205,12205,1,'MLS121015-012509+103203','CRTS-MLS',21.2885,10.53412,NULL,NULL,'2012-10-15 00:00:00',56215,21.31,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121015/1210151100204111982.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121015/jpg/1210151100204111982.master.jpg',NULL,NULL,67543268779,NULL,NULL,NULL,'2012-02-11 13:26:29',55968.560059,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1210151100204111982/1210151100204111982.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121015/1210151100204111982p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1055363574,16490055,NULL,NULL,NULL,NULL),(12206,12206,1,'MLS121014-224935-064620','CRTS-MLS',342.39447,-6.77233,NULL,NULL,'2012-10-14 00:00:00',56214,20.59,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:43','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121014/1210140073154111969.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121014/jpg/1210140073154111969.master.jpg',NULL,NULL,50386953493,NULL,NULL,NULL,'2009-10-22 10:33:30',55126.439941,'2013-01-19 01:32:43','http://crts.caltech.edu/ATEL/MLS/1210140073154111969/1210140073154111969.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121014/1210140073154111969p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,787296148,12301502,NULL,NULL,NULL,NULL),(12207,12207,1,'MLS121010-041247+241117','CRTS-MLS',63.19544,24.1881,NULL,NULL,'2012-10-10 00:00:00',56210,20.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121010/1210101240544107534.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121010/jpg/1210101240544107534.master.jpg',NULL,NULL,68451098118,NULL,NULL,NULL,'2012-03-03 12:28:49',55989.52002,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1210101240544107534/1210101240544107534.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121010/1210101240544107534p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1069548408,16711693,NULL,NULL,NULL,NULL),(12209,12209,1,'MLS121009-004506+070503','CRTS-MLS',11.27586,7.08412,NULL,NULL,'2012-10-09 00:00:00',56209,21.1,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121009/1210091070114107961.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121009/jpg/1210091070114107961.master.jpg',NULL,NULL,66782002079,NULL,NULL,NULL,'2011-10-03 13:26:29',55837.560059,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1210091070114107961/1210091070114107961.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121009/1210091070114107961p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1043468782,16304199,NULL,NULL,NULL,NULL),(12210,12210,1,'MLS121004-002203+005219','CRTS-MLS',5.51073,0.87185,NULL,NULL,'2012-10-04 00:00:00',56204,17.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20121004/1210041000064115410.html','HPM SDSS mag 18,4    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20121004/jpg/1210041000064115410.master.jpg',NULL,NULL,66631118112,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1210041000064115410/1210041000064115410.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20121004/1210041000064115410p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1041111220,16267362,NULL,NULL,NULL,NULL),(12211,12211,1,'MLS120925-225600-013520','CRTS-MLS',344.0017,-1.5888,NULL,NULL,'2012-09-25 00:00:00',56195,16.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120925/1209250013194105964.html','HPM NLT_641-36      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120925/jpg/1209250013194105964.master.jpg',NULL,NULL,49517295478,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1209250013194105964/1209250013194105964.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120925/1209250013194105964p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,773707741,12089183,NULL,NULL,NULL,NULL),(12212,12212,1,'MLS120922-234209+063213','CRTS-MLS',355.53735,6.53686,NULL,NULL,'2012-09-22 00:00:00',56192,21.44,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120922/1209221073274100700.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120922/jpg/1209221073274100700.master.jpg',NULL,NULL,51561357476,NULL,NULL,NULL,'2011-11-02 13:26:29',55867.560059,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1209221073274100700/1209221073274100700.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120922/1209221073274100700p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,805646210,12588222,NULL,NULL,NULL,NULL),(12213,12213,1,'MLS120921-022803+241458','CRTS-MLS',37.01061,24.24951,NULL,NULL,'2012-09-21 00:00:00',56191,20.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120921/1209211240324105679.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120921/jpg/1209211240324105679.master.jpg',NULL,NULL,68086959939,NULL,NULL,NULL,'2007-09-25 11:31:10',54368.47998,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1209211240324105679/1209211240324105679.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120921/1209211240324105679p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1063858749,16622792,NULL,NULL,NULL,NULL),(12214,12214,1,'MLS120919-031234+180635','CRTS-MLS',48.14303,18.10973,NULL,NULL,'2012-09-19 00:00:00',56189,21.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120919/1209191170434111422.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120919/jpg/1209191170434111422.master.jpg',NULL,NULL,68170874440,NULL,NULL,NULL,'2011-11-15 13:26:29',55880.560059,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1209191170434111422/1209191170434111422.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120919/1209191170434111422p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1065169913,16643279,NULL,NULL,NULL,NULL),(12215,12215,1,'MLS120919-031136+164008','CRTS-MLS',47.9019,16.66898,NULL,NULL,'2012-09-19 00:00:00',56189,20.93,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120919/1209191160434106433.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120919/jpg/1209191160434106433.master.jpg',NULL,NULL,68172539963,NULL,NULL,NULL,'2011-11-23 13:26:29',55888.560059,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1209191160434106433/1209191160434106433.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120919/1209191160434106433p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1065195936,16643686,NULL,NULL,NULL,NULL),(12216,12216,1,'MLS120919-235252+012434','CRTS-MLS',358.21484,1.40941,NULL,NULL,'2012-09-19 00:00:00',56189,21.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120919/1209191013324105770.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120919/jpg/1209191013324105770.master.jpg',NULL,NULL,51555484277,NULL,NULL,NULL,'2011-12-29 13:26:29',55924.560059,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1209191013324105770/1209191013324105770.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120919/1209191013324105770p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,805554441,12586788,NULL,NULL,NULL,NULL),(12217,12217,1,'MLS120918-031643+153420','CRTS-MLS',49.1774,15.57229,NULL,NULL,'2012-09-18 00:00:00',56188,21.3,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120918/1209181150444106827.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120918/jpg/1209181150444106827.master.jpg',NULL,NULL,68154594180,NULL,NULL,NULL,'2011-11-18 13:26:29',55883.560059,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1209181150444106827/1209181150444106827.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120918/1209181150444106827p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1064915534,16639305,NULL,NULL,NULL,NULL),(12218,12218,1,'MLS120917-225010-013032','CRTS-MLS',342.54185,-1.50886,NULL,NULL,'2012-09-17 00:00:00',56187,20.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120917/1209170013174113188.html','Unknown SDSS mag 21,9    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120917/jpg/1209170013174113188.master.jpg',NULL,NULL,49470101307,NULL,NULL,NULL,'2007-11-12 13:26:29',54416.560059,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1209170013174113188/1209170013174113188.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120917/1209170013174113188p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,772970332,12077661,NULL,NULL,NULL,NULL),(12219,12219,1,'MLS120916-025727+150426','CRTS-MLS',44.36348,15.07375,NULL,NULL,'2012-09-16 00:00:00',56186,19.95,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120916/1209161140404118638.html','Unknown MLS mag 21,7    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120916/jpg/1209161140404118638.master.jpg',NULL,NULL,68168626188,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1209161140404118638/1209161140404118638.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120916/1209161140404118638p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1065134784,16642731,NULL,NULL,NULL,NULL),(12220,12220,1,'MLS120915-020741+121152','CRTS-MLS',31.91942,12.19783,NULL,NULL,'2012-09-15 00:00:00',56185,20.93,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120915/1209151120294103491.html','Unknown SDSS mag >22,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120915/jpg/1209151120294103491.master.jpg',NULL,NULL,67081873143,NULL,NULL,NULL,'2005-10-24 10:33:36',53667.440002,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1209151120294103491/1209151120294103491.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120915/1209151120294103491p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1048154267,16377410,NULL,NULL,NULL,NULL),(12221,12221,1,'MLS120915-230517-030255','CRTS-MLS',346.31917,-3.04856,NULL,NULL,'2012-09-15 00:00:00',56185,21.41,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120915/1209150023214102840.html','Unknown SDSS mag >22,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120915/jpg/1209150023214102840.master.jpg',NULL,NULL,49503526976,NULL,NULL,NULL,'2008-11-20 13:26:29',54790.560059,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1209150023214102840/1209150023214102840.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120915/1209150023214102840p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,773492609,12085822,NULL,NULL,NULL,NULL),(12222,12222,1,'MLS120828-025327+161849','CRTS-MLS',43.36448,16.31351,NULL,NULL,'2012-08-28 00:00:00',56167,21.66,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120828/1208281160394101280.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120828/jpg/1208281160394101280.master.jpg',NULL,NULL,68180313931,NULL,NULL,NULL,'2008-09-21 11:31:10',54730.47998,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1208281160394101280/1208281160394101280.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120828/1208281160394101280p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1065317405,16645584,NULL,NULL,NULL,NULL),(12223,12223,1,'MLS120619-202435-095030','CRTS-MLS',306.14657,-9.84164,NULL,NULL,'2012-06-19 00:00:00',56097,20.38,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120619/1206190102794140244.html','Var mag 20,5     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120619/jpg/1206190102794140244.master.jpg',NULL,NULL,47818163337,NULL,NULL,NULL,'2006-11-02 13:26:23',54041.559998,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1206190102794140244/1206190102794140244.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120619/1206190102794140244p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,747158802,11674356,NULL,NULL,NULL,NULL),(12224,12224,1,'MLS120617-212835-150023','CRTS-MLS',322.14533,-15.0063,NULL,NULL,'2012-06-17 00:00:00',56095,19.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120617/1206170142904103465.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120617/jpg/1206170142904103465.master.jpg',NULL,NULL,50886505157,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1206170142904103465/1206170142904103465.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120617/1206170142904103465p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,795101643,12423463,NULL,NULL,NULL,NULL),(12225,12225,1,'MLS120617-212001-142947','CRTS-MLS',320.00443,-14.49645,NULL,NULL,'2012-06-17 00:00:00',56095,21.14,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120617/1206170142884116054.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120617/jpg/1206170142884116054.master.jpg',NULL,NULL,50968326310,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1206170142884116054/1206170142884116054.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120617/1206170142884116054p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,796380098,12443439,NULL,NULL,NULL,NULL),(12226,12226,1,'MLS120616-142417-141643','CRTS-MLS',216.07254,-14.27852,NULL,NULL,'2012-06-16 00:00:00',56094,20.46,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160141944116892.html','RRLyrae       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120616/jpg/1206160141944116892.master.jpg',NULL,NULL,46544189499,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1206160141944116892/1206160141944116892.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160141944116892p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,727252960,11363327,NULL,NULL,NULL,NULL),(12227,12227,1,'MLS120616-152757-134038','CRTS-MLS',231.98563,-13.67716,NULL,NULL,'2012-06-16 00:00:00',56094,20.12,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:44','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160132094111136.html','Var? SDSS mag 21,3    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120616/jpg/1206160132094111136.master.jpg',NULL,NULL,46661027374,NULL,NULL,NULL,'2007-05-12 10:33:36',54232.440002,'2013-01-19 01:32:44','http://crts.caltech.edu/ATEL/MLS/1206160132094111136/1206160132094111136.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160132094111136p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,729078552,11391852,NULL,NULL,NULL,NULL),(12228,12228,1,'MLS120616-142513-133855','CRTS-MLS',216.30447,-13.6485,NULL,NULL,'2012-06-16 00:00:00',56094,21.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160131954108488.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120616/jpg/1206160131954108488.master.jpg',NULL,NULL,46540664168,NULL,NULL,NULL,'2012-06-10 13:26:29',56088.560059,'2013-01-19 01:32:45','http://crts.caltech.edu/ATEL/MLS/1206160131954108488/1206160131954108488.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160131954108488p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,727197877,11362466,NULL,NULL,NULL,NULL),(12229,12229,1,'MLS120616-141537-123521','CRTS-MLS',213.90385,-12.58925,NULL,NULL,'2012-06-16 00:00:00',56094,20.95,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160121944107936.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120616/jpg/1206160121944107936.master.jpg',NULL,NULL,43639607340,NULL,NULL,NULL,'2010-02-18 12:28:49',55245.52002,'2013-01-19 01:32:45','http://crts.caltech.edu/ATEL/MLS/1206160121944107936/1206160121944107936.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160121944107936p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,681868864,10654201,NULL,NULL,NULL,NULL),(12230,12230,1,'MLS120616-140345-101741','CRTS-MLS',210.93682,-10.29459,NULL,NULL,'2012-06-16 00:00:00',56094,18.67,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160101934110590.html','RRLyrae SDSS mag 19,7    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120616/jpg/1206160101934110590.master.jpg',NULL,NULL,43750546346,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','http://crts.caltech.edu/ATEL/MLS/1206160101934110590/1206160101934110590.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160101934110590p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,683602286,10681285,NULL,NULL,NULL,NULL),(12231,12231,1,'MLS120616-140554-103441','CRTS-MLS',211.47619,-10.57793,NULL,NULL,'2012-06-16 00:00:00',56094,20.65,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160101934104864.html','RRLyrae? SDSS mag 21,4    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120616/jpg/1206160101934104864.master.jpg',NULL,NULL,43750275073,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','http://crts.caltech.edu/ATEL/MLS/1206160101934104864/1206160101934104864.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120616/1206160101934104864p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,683598048,10681219,NULL,NULL,NULL,NULL),(12232,12232,1,'MLS120613-134351-063653','CRTS-MLS',205.96434,-6.61476,NULL,NULL,'2012-06-13 00:00:00',56091,15.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120613/1206130071904118785.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120613/jpg/1206130071904118785.master.jpg',NULL,NULL,43583128772,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','http://crts.caltech.edu/ATEL/MLS/1206130071904118785/1206130071904118785.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120613/1206130071904118785p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,680986387,10640412,NULL,NULL,NULL,NULL),(12233,12233,1,'MLS120611-134855-102555','CRTS-MLS',207.23077,-10.43187,NULL,NULL,'2012-06-11 00:00:00',56089,21.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120611/1206110101894108193.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120611/jpg/1206110101894108193.master.jpg',NULL,NULL,43703607419,NULL,NULL,NULL,'2006-05-04 13:26:23',53859.559998,'2013-01-19 01:32:45','http://crts.caltech.edu/ATEL/MLS/1206110101894108193/1206110101894108193.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120611/1206110101894108193p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,682868865,10669826,NULL,NULL,NULL,NULL),(12234,12234,1,'MLS120610-142734-150206','CRTS-MLS',216.89063,-15.0351,NULL,NULL,'2012-06-10 00:00:00',56088,19.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120610/1206100141954102862.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120610/jpg/1206100141954102862.master.jpg',NULL,NULL,46542816215,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','http://crts.caltech.edu/ATEL/MLS/1206100141954102862/1206100141954102862.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120610/1206100141954102862p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,727231503,11362992,NULL,NULL,NULL,NULL),(12235,12235,1,'MLS120608-140955-130550','CRTS-MLS',212.48015,-13.09723,NULL,NULL,'2012-06-08 00:00:00',56086,20.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120608/1206080131924118534.html','Unknown mag 22,1     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120608/jpg/1206080131924118534.master.jpg',NULL,NULL,43644484874,NULL,NULL,NULL,'2005-03-11 10:33:36',53440.440002,'2013-01-19 01:32:45','http://crts.caltech.edu/ATEL/MLS/1206080131924118534/1206080131924118534.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120608/1206080131924118534p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,681945076,10655391,NULL,NULL,NULL,NULL),(12236,12236,1,'MLS120530-083824+190516','CRTS-MLS',129.59839,19.0877,NULL,NULL,'2012-05-30 00:00:00',56077,20.42,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120530/1205301181144209934.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120530/jpg/1205301181144209934.master.jpg',NULL,NULL,63803916934,NULL,NULL,NULL,'2012-02-11 13:26:29',55968.560059,'2013-01-19 01:32:45','http://crts.caltech.edu/ATEL/MLS/1205301181144209934/1205301181144209934.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120530/1205301181144209934p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,996936202,15577128,NULL,NULL,NULL,NULL),(12237,12237,1,'MLS120530-202301-195504','CRTS-MLS',305.75622,-19.91783,NULL,NULL,'2012-05-30 00:00:00',56077,20.14,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120530/1205300202674119641.html','Var mag 21     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120530/jpg/1205300202674119641.master.jpg',NULL,NULL,50866775030,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','http://crts.caltech.edu/ATEL/MLS/1205300202674119641/1205300202674119641.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120530/1205300202674119641p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,794793359,12418646,NULL,NULL,NULL,NULL),(12238,12238,1,'MLS120527-135258-043001','CRTS-MLS',208.24321,-4.50023,NULL,NULL,'2012-05-27 00:00:00',56074,20.11,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120527/1205270041934115003.html','Unknown mag 21,0     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120527/jpg/1205270041934115003.master.jpg',NULL,NULL,43605691585,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','http://crts.caltech.edu/ATEL/MLS/1205270041934115003/1205270041934115003.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120527/1205270041934115003p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,681338931,10645920,NULL,NULL,NULL,NULL),(12239,12239,1,'MLS120526-160949+002753','CRTS-MLS',242.45392,0.46484,NULL,NULL,'2012-05-26 00:00:00',56073,20.43,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120526/1205261002254111919.html','Mira IRAS_13269-2329      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120526/jpg/1205261002254111919.master.jpg',NULL,NULL,56447122744,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','http://crts.caltech.edu/ATEL/MLS/1205261002254111919/1205261002254111919.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120526/1205261002254111919p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,881986292,13781035,NULL,NULL,NULL,NULL),(12240,12240,1,'MLS120523-125655+003840','CRTS-MLS',194.23003,0.64446,NULL,NULL,'2012-05-23 00:00:00',56070,21.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120523/1205231001804110830.html','Unknown SDSS mag 22,8    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120523/jpg/1205231001804110830.master.jpg',NULL,NULL,58089878293,NULL,NULL,NULL,'2007-04-25 10:33:36',54215.440002,'2013-01-19 01:32:45','http://crts.caltech.edu/ATEL/MLS/1205231001804110830/1205231001804110830.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120523/1205231001804110830p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,907654348,14182099,NULL,NULL,NULL,NULL),(12241,12241,1,'MLS120521-100318+092710','CRTS-MLS',150.8235,9.45275,NULL,NULL,'2012-05-21 00:00:00',56068,21.1,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120521/1205211091384112215.html','Unknown SDSS mag 22,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120521/jpg/1205211091384112215.master.jpg',NULL,NULL,60880534334,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','http://crts.caltech.edu/ATEL/MLS/1205211091384112215/1205211091384112215.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120521/1205211091384112215p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,951258348,14863411,NULL,NULL,NULL,NULL),(12242,12242,1,'MLS120521-131527-125039','CRTS-MLS',198.86405,-12.84424,NULL,NULL,'2012-05-21 00:00:00',56068,19.54,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120521/1205210121814102806.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120521/jpg/1205210121814102806.master.jpg',NULL,NULL,43997915498,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','http://crts.caltech.edu/ATEL/MLS/1205210121814102806/1205210121814102806.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120521/1205210121814102806p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,687467429,10741678,NULL,NULL,NULL,NULL),(12243,12243,1,'MLS120520-131040-093150','CRTS-MLS',197.66496,-9.5305,NULL,NULL,'2012-05-20 00:00:00',56067,20.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120520/1205200091814104175.html','Unknown 22      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120520/jpg/1205200091814104175.master.jpg',NULL,NULL,43844241743,NULL,NULL,NULL,'2009-03-31 13:26:29',54921.560059,'2013-01-19 01:32:45','http://crts.caltech.edu/ATEL/MLS/1205200091814104175/1205200091814104175.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120520/1205200091814104175p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,685066277,10704160,NULL,NULL,NULL,NULL),(12244,12244,1,'MLS120519-152746-012524','CRTS-MLS',231.9412,-1.42326,NULL,NULL,'2012-05-19 00:00:00',56066,20.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:45','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120519/1205190012154114943.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120519/jpg/1205190012154114943.master.jpg',NULL,NULL,45407033242,NULL,NULL,NULL,'2008-06-01 11:31:10',54618.47998,'2013-01-19 01:32:45','http://crts.caltech.edu/ATEL/MLS/1205190012154114943/1205190012154114943.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120519/1205190012154114943p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,709484894,11085701,NULL,NULL,NULL,NULL),(12245,12245,1,'MLS120516-155049-132041','CRTS-MLS',237.70479,-13.34473,NULL,NULL,'2012-05-16 00:00:00',56063,20.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120516/1205160132144122941.html','Unknown mag 22,5     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120516/jpg/1205160132144122941.master.jpg',NULL,NULL,45476000802,NULL,NULL,NULL,'2011-02-06 13:26:29',55598.560059,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1205160132144122941/1205160132144122941.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120516/1205160132144122941p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,710562512,11102539,NULL,NULL,NULL,NULL),(12246,12246,1,'MLS120513-123638-022745','CRTS-MLS',189.15631,-2.46256,NULL,NULL,'2012-05-13 00:00:00',56060,21.12,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120513/1205130021754113527.html','Unknown mag 22     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120513/jpg/1205130021754113527.master.jpg',NULL,NULL,43168989835,NULL,NULL,NULL,'2008-11-30 13:26:29',54800.560059,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1205130021754113527/1205130021754113527.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120513/1205130021754113527p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,674515466,10539304,NULL,NULL,NULL,NULL),(12247,12247,0,'MLS120512-152050-131328','CRTS-MLS',230.20663,-13.22458,NULL,NULL,'2012-05-12 00:00:00',56059,20.02,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-12-24 20:38:21','http://nesssi.cacr.caltech.edu/MLS/20120512/1205120132084119654.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120512/jpg/1205120132084119654.master.jpg',NULL,NULL,46658941882,NULL,NULL,NULL,'2005-05-12 10:33:36',53502.440002,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1205120132084119654/1205120132084119654.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120512/1205120132084119654p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,729045966,11391343,NULL,NULL,NULL,NULL),(12248,12248,1,'MLS120501-150924-084812','CRTS-MLS',227.35016,-8.80322,NULL,NULL,'2012-05-01 00:00:00',56048,20.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120501/1205010092084120495.html','Unknown mag 22     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120501/jpg/1205010092084120495.master.jpg',NULL,NULL,46496199986,NULL,NULL,NULL,'2006-04-02 13:26:23',53827.559998,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1205010092084120495/1205010092084120495.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120501/1205010092084120495p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,726503124,11351611,NULL,NULL,NULL,NULL),(12249,12249,1,'MLS120501-152619-073653','CRTS-MLS',231.5797,-7.61479,NULL,NULL,'2012-05-01 00:00:00',56048,20.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120501/1205010082134122518.html','Unknown mag >22     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120501/jpg/1205010082134122518.master.jpg',NULL,NULL,45393937841,NULL,NULL,NULL,'2011-05-06 13:26:29',55687.560059,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1205010082134122518/1205010082134122518.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120501/1205010082134122518p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,709280278,11082504,NULL,NULL,NULL,NULL),(12250,12250,1,'MLS120424-075839+244918','CRTS-MLS',119.66437,24.82153,NULL,NULL,'2012-04-24 00:00:00',56041,19.52,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120424/1204241241024118045.html','Unknown SDSS mag 19,6    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120424/jpg/1204241241024118045.master.jpg',NULL,NULL,64291949338,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1204241241024118045/1204241241024118045.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120424/1204241241024118045p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,1004561708,15696276,NULL,NULL,NULL,NULL),(12251,12251,1,'MLS120422-105152+062634','CRTS-MLS',162.96617,6.4428,NULL,NULL,'2012-04-22 00:00:00',56039,16.67,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120422/1204221051504117231.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120422/jpg/1204221051504117231.master.jpg',NULL,NULL,61027292586,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1204221051504117231/1204221051504117231.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120422/1204221051504117231p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,953551446,14899241,NULL,NULL,NULL,NULL),(12252,12252,1,'MLS120421-153424-051220','CRTS-MLS',233.59954,-5.20549,NULL,NULL,'2012-04-21 00:00:00',56038,20.36,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120421/1204210042164105745.html','Unknown mag 22     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120421/jpg/1204210042164105745.master.jpg',NULL,NULL,45419915913,NULL,NULL,NULL,'2009-03-27 13:26:29',54917.560059,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1204210042164105745/1204210042164105745.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120421/1204210042164105745p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,709686186,11088846,NULL,NULL,NULL,NULL),(12253,12253,1,'MLS120420-150102-123339','CRTS-MLS',225.2578,-12.5609,NULL,NULL,'2012-04-20 00:00:00',56037,20.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120420/1204200122044110349.html','Unknown mag 22     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120420/jpg/1204200122044110349.master.jpg',NULL,NULL,46661658805,NULL,NULL,NULL,'2010-05-09 11:31:10',55325.47998,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1204200122044110349/1204200122044110349.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120420/1204200122044110349p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,729088418,11392006,NULL,NULL,NULL,NULL),(12254,12254,1,'MLS120420-134538-095634','CRTS-MLS',206.40961,-9.94269,NULL,NULL,'2012-04-20 00:00:00',56037,17.14,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120420/1204200101894115401.html','Var mag 17,5     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120420/jpg/1204200101894115401.master.jpg',NULL,NULL,43690936222,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1204200101894115401/1204200101894115401.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120420/1204200101894115401p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,682670878,10666732,NULL,NULL,NULL,NULL),(12255,12255,1,'MLS120420-135711-090242','CRTS-MLS',209.29568,-9.04491,NULL,NULL,'2012-04-20 00:00:00',56037,20.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120420/1204200091924112851.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120420/jpg/1204200091924112851.master.jpg',NULL,NULL,43698519984,NULL,NULL,NULL,'2011-05-12 12:28:49',55693.52002,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1204200091924112851/1204200091924112851.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120420/1204200091924112851p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,682789374,10668583,NULL,NULL,NULL,NULL),(12256,12256,1,'MLS120418-092834+135358','CRTS-MLS',142.14241,13.89937,NULL,NULL,'2012-04-18 00:00:00',56035,21.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120418/1204181131284116071.html','Unknown SDSS mag 22,3    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120418/jpg/1204181131284116071.master.jpg',NULL,NULL,63855808499,NULL,NULL,NULL,'2005-03-09 12:28:48',53438.520004,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1204181131284116071/1204181131284116071.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120418/1204181131284116071p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,997747007,15589796,NULL,NULL,NULL,NULL),(12257,12257,1,'MLS120418-135413-045906','CRTS-MLS',208.55341,-4.98493,NULL,NULL,'2012-04-18 00:00:00',56035,21.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120418/1204180041934107703.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120418/jpg/1204180041934107703.master.jpg',NULL,NULL,43604346721,NULL,NULL,NULL,'2011-03-27 13:26:29',55647.560059,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1204180041934107703/1204180041934107703.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120418/1204180041934107703p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,681317917,10645592,NULL,NULL,NULL,NULL),(12258,12258,1,'MLS120331-131536-045337','CRTS-MLS',198.89803,-4.89351,NULL,NULL,'2012-03-31 00:00:00',56017,18.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120331/1203310041844107697.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120331/jpg/1203310041844107697.master.jpg',NULL,NULL,43830257867,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1203310041844107697/1203310041844107697.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120331/1203310041844107697p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,684847779,10700746,NULL,NULL,NULL,NULL),(12259,12259,1,'MLS120329-112021+010005','CRTS-MLS',170.08575,1.00141,NULL,NULL,'2012-03-29 00:00:00',56015,21.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120329/1203291001584113624.html','Unknown SDSS mag 22,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120329/jpg/1203291001584113624.master.jpg',NULL,NULL,60163769957,NULL,NULL,NULL,'2012-03-14 12:28:49',56000.52002,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1203291001584113624/1203291001584113624.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120329/1203291001584113624p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,940058905,14688420,NULL,NULL,NULL,NULL),(12260,12260,1,'MLS120328-155511-163813','CRTS-MLS',238.7952,-16.637,NULL,NULL,'2012-03-28 00:00:00',56014,20.51,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120328/1203280162134124100.html','Unknown SDSS mag 22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120328/jpg/1203280162134124100.master.jpg',NULL,NULL,45489589106,NULL,NULL,NULL,'2010-02-15 10:33:30',55242.439941,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1203280162134124100/1203280162134124100.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120328/1203280162134124100p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,710774829,11105856,NULL,NULL,NULL,NULL),(12261,12261,1,'MLS120328-122658-035515','CRTS-MLS',186.74093,-3.92083,NULL,NULL,'2012-03-28 00:00:00',56014,21.36,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120328/1203280031734107967.html','Unknown MLS mag 22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120328/jpg/1203280031734107967.master.jpg',NULL,NULL,42995486381,NULL,NULL,NULL,'2005-03-09 10:33:36',53438.440002,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1203280031734107967/1203280031734107967.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120328/1203280031734107967p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,671804474,10496944,NULL,NULL,NULL,NULL),(12262,12262,1,'MLS120323-122823-044047','CRTS-MLS',187.09415,-4.67975,NULL,NULL,'2012-03-23 00:00:00',56009,21.21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120323/1203230041734112313.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120323/jpg/1203230041734112313.master.jpg',NULL,NULL,43175478304,NULL,NULL,NULL,'2008-06-01 13:26:29',54618.560059,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1203230041734112313/1203230041734112313.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120323/1203230041734112313p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,674616848,10540888,NULL,NULL,NULL,NULL),(12263,12263,1,'MLS120317-114554+095349','CRTS-MLS',176.47349,9.89706,NULL,NULL,'2012-03-17 00:00:00',56003,19.81,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120317/1203171101614102401.html','Unknown SDSS mag 21,1    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120317/jpg/1203171101614102401.master.jpg',NULL,NULL,60380226956,NULL,NULL,NULL,'2008-04-13 12:28:49',54569.52002,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1203171101614102401/1203171101614102401.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120317/1203171101614102401p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,943441046,14741266,NULL,NULL,NULL,NULL),(12264,12264,1,'MLS120317-114437+095117','CRTS-MLS',176.15473,9.85474,NULL,NULL,'2012-03-17 00:00:00',56003,19.21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:46','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120317/1203171101614101827.html','Var? SDSS mag 20,1    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120317/jpg/1203171101614101827.master.jpg',NULL,NULL,60380605597,NULL,NULL,NULL,'2007-11-21 13:26:29',54425.560059,'2013-01-19 01:32:46','http://crts.caltech.edu/ATEL/MLS/1203171101614101827/1203171101614101827.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120317/1203171101614101827p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,943446962,14741358,NULL,NULL,NULL,NULL),(12265,12265,1,'MLS120315-105227+060502','CRTS-MLS',163.11277,6.0839,NULL,NULL,'2012-03-15 00:00:00',56001,21.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120315/1203151051504113464.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120315/jpg/1203151051504113464.master.jpg',NULL,NULL,61027142736,NULL,NULL,NULL,'2011-11-28 13:26:29',55893.560059,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1203151051504113464/1203151051504113464.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120315/1203151051504113464p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,953549105,14899204,NULL,NULL,NULL,NULL),(12266,12266,1,'MLS120313-115340+070429','CRTS-MLS',178.41487,7.07467,NULL,NULL,'2012-03-13 00:00:00',55999,21.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120313/1203131071654108344.html','Unknown SDSS mag >22,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120313/jpg/1203131071654108344.master.jpg',NULL,NULL,60162626522,NULL,NULL,NULL,'2010-04-15 10:33:30',55301.439941,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1203131071654108344/1203131071654108344.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120313/1203131071654108344p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,940041039,14688141,NULL,NULL,NULL,NULL),(12267,12267,1,'MLS120304-134119-090152','CRTS-MLS',205.33029,-9.03098,NULL,NULL,'2012-03-04 00:00:00',55990,20.6,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120304/1203040091884110893.html','Unknown mag 21,8     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120304/jpg/1203040091884110893.master.jpg',NULL,NULL,43584325955,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1203040091884110893/1203040091884110893.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120304/1203040091884110893p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,681005093,10640704,NULL,NULL,NULL,NULL),(12269,12269,1,'MLS120229-103319+053325','CRTS-MLS',158.32934,5.55699,NULL,NULL,'2012-02-29 00:00:00',55986,21.29,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120229/1202291051464102038.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120229/jpg/1202291051464102038.master.jpg',NULL,NULL,61012812422,NULL,NULL,NULL,'2010-02-19 10:33:30',55246.439941,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1202291051464102038/1202291051464102038.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120229/1202291051464102038p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,953325194,14895706,NULL,NULL,NULL,NULL),(12270,12270,1,'MLS120229-131410-104242','CRTS-MLS',198.54259,-10.71161,NULL,NULL,'2012-02-29 00:00:00',55986,19.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120229/1202290101814101862.html','Unknown MLS mag 20,8    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120229/jpg/1202290101814101862.master.jpg',NULL,NULL,43873251030,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1202290101814101862/1202290101814101862.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120229/1202290101814101862p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,685519547,10711242,NULL,NULL,NULL,NULL),(12271,12271,1,'MLS120225-093226+103035','CRTS-MLS',143.10753,10.50982,NULL,NULL,'2012-02-25 00:00:00',55982,20.68,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120225/1202251101314114842.html','Unknown SDSS mag 20,8    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120225/jpg/1202251101314114842.master.jpg',NULL,NULL,60703818100,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1202251101314114842/1202251101314114842.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120225/1202251101314114842p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,948497157,14820268,NULL,NULL,NULL,NULL),(12272,12272,1,'MLS120225-110116+015601','CRTS-MLS',165.31721,1.93358,NULL,NULL,'2012-02-25 00:00:00',55982,20.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120225/1202251011534116145.html','Unknown SDSS mag 22,4    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120225/jpg/1202251011534116145.master.jpg',NULL,NULL,60292031153,NULL,NULL,NULL,'2008-02-27 13:26:29',54523.560059,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1202251011534116145/1202251011534116145.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120225/1202251011534116145p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,942062986,14719734,NULL,NULL,NULL,NULL),(12273,12273,1,'MLS120224-102455+170011','CRTS-MLS',156.22785,17.00305,NULL,NULL,'2012-02-24 00:00:00',55981,21.51,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120224/1202241161394113366.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120224/jpg/1202241161394113366.master.jpg',NULL,NULL,60963267842,NULL,NULL,NULL,'2010-10-29 11:31:10',55498.47998,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1202241161394113366/1202241161394113366.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120224/1202241161394113366p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,952551060,14883610,NULL,NULL,NULL,NULL),(12274,12274,1,'MLS120223-104056+115058','CRTS-MLS',160.23438,11.84951,NULL,NULL,'2012-02-23 00:00:00',55980,20.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120223/1202231111464117926.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120223/jpg/1202231111464117926.master.jpg',NULL,NULL,61045488892,NULL,NULL,NULL,'2011-05-14 10:33:30',55695.439941,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1202231111464117926/1202231111464117926.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120223/1202231111464117926p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,953835763,14903683,NULL,NULL,NULL,NULL),(12275,12275,1,'MLS120223-131421-074402','CRTS-MLS',198.5876,-7.73377,NULL,NULL,'2012-02-23 00:00:00',55980,21.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120223/1202230081834114685.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120223/jpg/1202230081834114685.master.jpg',NULL,NULL,43882267296,NULL,NULL,NULL,'2011-04-30 13:26:29',55681.560059,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1202230081834114685/1202230081834114685.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120223/1202230081834114685p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,685660426,10713444,NULL,NULL,NULL,NULL),(12276,12276,1,'MLS120212-075007+181812','CRTS-MLS',117.53001,18.30326,NULL,NULL,'2012-02-12 00:00:00',55969,20.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120212/1202121171044127670.html','Var SDSS mag 20,7    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120212/jpg/1202121171044127670.master.jpg',NULL,NULL,62618461645,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1202121171044127670/1202121171044127670.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120212/1202121171044127670p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,978413463,15287710,NULL,NULL,NULL,NULL),(12277,12277,1,'MLS120201-091226+100757','CRTS-MLS',138.10984,10.13254,NULL,NULL,'2012-02-01 00:00:00',55958,21.8,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120201/1202011101264107143.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120201/jpg/1202011101264107143.master.jpg',NULL,NULL,63649175267,NULL,NULL,NULL,'2010-02-15 13:26:29',55242.560059,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1202011101264107143/1202011101264107143.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120201/1202011101264107143p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,994518363,15539349,NULL,NULL,NULL,NULL),(12278,12278,1,'MLS120130-135725-135840','CRTS-MLS',209.35597,-13.97784,NULL,NULL,'2012-01-30 00:00:00',55956,20.95,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120130/1201300131894102059.html','Unknown MLS mag 21,8    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120130/jpg/1201300131894102059.master.jpg',NULL,NULL,43675005057,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1201300131894102059/1201300131894102059.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120130/1201300131894102059p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,682421954,10662843,NULL,NULL,NULL,NULL),(12279,12279,1,'MLS120130-132429-063108','CRTS-MLS',201.12093,-6.51881,NULL,NULL,'2012-01-30 00:00:00',55956,20.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120130/1201300071854121263.html','Unknown MLS mag 22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120130/jpg/1201300071854121263.master.jpg',NULL,NULL,43878510183,NULL,NULL,NULL,'2007-02-25 13:26:23',54156.559998,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1201300071854121263/1201300071854121263.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120130/1201300071854121263p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,685601721,10712526,NULL,NULL,NULL,NULL),(12280,12280,1,'MLS120129-050427+261152','CRTS-MLS',76.11378,26.19779,NULL,NULL,'2012-01-29 00:00:00',55955,20.55,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120129/1201291260644107239.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120129/jpg/1201291260644107239.master.jpg',NULL,NULL,64778087352,NULL,NULL,NULL,'2011-03-10 12:28:49',55630.52002,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1201291260644107239/1201291260644107239.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120129/1201291260644107239p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1012157614,15814962,NULL,NULL,NULL,NULL),(12281,12281,1,'MLS120126-095225+152245','CRTS-MLS',148.10429,15.37914,NULL,NULL,'2012-01-26 00:00:00',55952,17.59,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120126/1201261151334103346.html','RRLyrae mag 18,3     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120126/jpg/1201261151334103346.master.jpg',NULL,NULL,60828524696,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1201261151334103346/1201261151334103346.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120126/1201261151334103346p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,950445698,14850714,NULL,NULL,NULL,NULL),(12282,12282,1,'MLS120120-075254+141332','CRTS-MLS',118.22691,14.22563,NULL,NULL,'2012-01-20 00:00:00',55946,20.1,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120120/1201201141074104116.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120120/jpg/1201201141074104116.master.jpg',NULL,NULL,62635583737,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1201201141074104116/1201201141074104116.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120120/1201201141074104116p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,978680995,15291890,NULL,NULL,NULL,NULL),(12283,12283,1,'MLS120119-112232+033523','CRTS-MLS',170.63475,3.58959,NULL,NULL,'2012-01-19 00:00:00',55945,21.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120119/1201191031584106070.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120119/jpg/1201191031584106070.master.jpg',NULL,NULL,60364301041,NULL,NULL,NULL,'2005-05-13 11:31:11',53503.479996,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1201191031584106070/1201191031584106070.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120119/1201191031584106070p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,943192203,14737378,NULL,NULL,NULL,NULL),(12284,12284,1,'MLS120118-080735+223434','CRTS-MLS',121.89758,22.57622,NULL,NULL,'2012-01-18 00:00:00',55944,20.92,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20120118/1201181221054119446.html','Unknown MLS mag 22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20120118/jpg/1201181221054119446.master.jpg',NULL,NULL,63769826434,NULL,NULL,NULL,'2006-10-31 13:26:23',54039.559998,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1201181221054119446/1201181221054119446.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20120118/1201181221054119446p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,996403538,15568805,NULL,NULL,NULL,NULL),(12285,12285,1,'MLS111227-111527+034201','CRTS-MLS',168.86111,3.70016,NULL,NULL,'2011-12-27 00:00:00',55922,21.34,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:47','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111227/1112271031564107204.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111227/jpg/1112271031564107204.master.jpg',NULL,NULL,60357999770,NULL,NULL,NULL,'2007-02-10 12:28:49',54141.52002,'2013-01-19 01:32:47','http://crts.caltech.edu/ATEL/MLS/1112271031564107204/1112271031564107204.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111227/1112271031564107204p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,943093746,14735839,NULL,NULL,NULL,NULL),(12286,12286,1,'MLS111226-054043+235248','CRTS-MLS',85.18029,23.88013,NULL,NULL,'2011-12-26 00:00:00',55921,19.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111226/1112261240734102770.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111226/jpg/1112261240734102770.master.jpg',NULL,NULL,64839498872,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1112261240734102770/1112261240734102770.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111226/1112261240734102770p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,1013117169,15829955,NULL,NULL,NULL,NULL),(12287,12287,1,'MLS111225-114237+101144','CRTS-MLS',175.65431,10.19562,NULL,NULL,'2011-12-25 00:00:00',55920,19.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111225/1112251101614107087.html','Var SDSS mag 21,2    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111225/jpg/1112251101614107087.master.jpg',NULL,NULL,60371278768,NULL,NULL,NULL,'2007-11-21 13:26:29',54425.560059,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1112251101614107087/1112251101614107087.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111225/1112251101614107087p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,943301230,14739081,NULL,NULL,NULL,NULL);
INSERT INTO `transientBucket` VALUES (12288,12288,1,'MLS111224-041258+255607','CRTS-MLS',63.24211,25.93525,NULL,NULL,'2011-12-24 00:00:00',55919,19.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111224/1112241250544118033.html','Supernova or Other',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111224/jpg/1112241250544118033.master.jpg',NULL,NULL,68320330032,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1112241250544118033/1112241250544118033.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111224/1112241250544118033p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,1067505156,16679768,NULL,NULL,NULL,NULL),(12289,12289,1,'MLS111216-072618+230001','CRTS-MLS',111.57684,23.00038,NULL,NULL,'2011-12-16 00:00:00',55911,16.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111216/1112161230964105184.html','HPM mag 16,1 LP_365-8    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111216/jpg/1112161230964105184.master.jpg',NULL,NULL,63090417881,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1112161230964105184/1112161230964105184.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111216/1112161230964105184p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,985787779,15402934,NULL,NULL,NULL,NULL),(12290,12290,1,'MLS111130-041026+183247','CRTS-MLS',62.60923,18.54649,NULL,NULL,'2011-11-30 00:00:00',55895,20.52,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111130/1111301180554102365.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111130/jpg/1111301180554102365.master.jpg',NULL,NULL,65106431347,NULL,NULL,NULL,'2007-01-10 10:33:36',54110.440002,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1111301180554102365/1111301180554102365.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111130/1111301180554102365p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1017287989,15895124,NULL,NULL,NULL,NULL),(12291,12291,1,'MLS111128-215855-102703','CRTS-MLS',329.73108,-10.45084,NULL,NULL,'2011-11-28 00:00:00',55893,21.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111128/1111280103014106309.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111128/jpg/1111280103014106309.master.jpg',NULL,NULL,49920110841,NULL,NULL,NULL,'2009-09-22 10:33:30',55096.439941,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1111280103014106309/1111280103014106309.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111128/1111280103014106309p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,780001731,12187527,NULL,NULL,NULL,NULL),(12292,12292,1,'MLS111124-021528+153313','CRTS-MLS',33.86521,15.55366,NULL,NULL,'2011-11-24 00:00:00',55889,21.23,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111124/1111241150314106649.html','Unknown SDSS mag 23,0    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111124/jpg/1111241150314106649.master.jpg',NULL,NULL,68074653236,NULL,NULL,NULL,'2006-11-27 13:26:23',54066.559998,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1111241150314106649/1111241150314106649.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111124/1111241150314106649p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1063666456,16619788,NULL,NULL,NULL,NULL),(12293,12293,1,'MLS111118-045900+120310','CRTS-MLS',74.74803,12.05289,NULL,NULL,'2011-11-18 00:00:00',55883,16.4,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111118/1111181120684103457.html','Unknown CSS111118      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111118/jpg/1111181120684103457.master.jpg',NULL,NULL,65440779096,NULL,NULL,NULL,'2010-12-05 13:26:29',55535.560059,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1111181120684103457/1111181120684103457.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111118/1111181120684103457p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1022512173,15976752,NULL,NULL,NULL,NULL),(12294,12294,1,'MLS111116-022548+171830','CRTS-MLS',36.45095,17.30828,NULL,NULL,'2011-11-16 00:00:00',55881,19.51,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111116/1111161160334108760.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111116/jpg/1111161160334108760.master.jpg',NULL,NULL,68078485298,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1111161160334108760/1111161160334108760.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111116/1111161160334108760p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,1063726332,16620723,NULL,NULL,NULL,NULL),(12295,12295,1,'MLS111101-053702+234454','CRTS-MLS',84.26019,23.74844,NULL,NULL,'2011-11-01 00:00:00',55866,20.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111101/1111011230724149170.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111101/jpg/1111011230724149170.master.jpg',NULL,NULL,64836428640,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1111011230724149170/1111011230724149170.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111101/1111011230724149170p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1013069197,15829206,NULL,NULL,NULL,NULL),(12296,12296,1,'MLS111101-020859+025406','CRTS-MLS',32.24396,2.90156,NULL,NULL,'2011-11-01 00:00:00',55866,21.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111101/1111011020304112816.html','Unknown SDSS mag 23,1    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111101/jpg/1111011020304112816.master.jpg',NULL,NULL,67061495315,NULL,NULL,NULL,'2010-02-16 13:26:29',55243.560059,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1111011020304112816/1111011020304112816.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111101/1111011020304112816p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1047835864,16372435,NULL,NULL,NULL,NULL),(12297,12297,1,'MLS111030-025654+183508','CRTS-MLS',44.22347,18.58544,NULL,NULL,'2011-10-30 00:00:00',55864,21.02,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111030/1110301180394102789.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111030/jpg/1110301180394102789.master.jpg',NULL,NULL,68176404432,NULL,NULL,NULL,'2011-02-08 13:26:29',55600.560059,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1110301180394102789/1110301180394102789.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111030/1110301180394102789p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1065256319,16644629,NULL,NULL,NULL,NULL),(12298,12298,1,'MLS111030-013600+072631','CRTS-MLS',24.00086,7.44195,NULL,NULL,'2011-10-30 00:00:00',55864,21.59,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111030/1110301070234114462.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111030/jpg/1110301070234114462.master.jpg',NULL,NULL,67015845134,NULL,NULL,NULL,'2010-10-30 13:26:29',55499.560059,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1110301070234114462/1110301070234114462.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111030/1110301070234114462p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1047122580,16361290,NULL,NULL,NULL,NULL),(12299,12299,1,'MLS111024-000325-012744','CRTS-MLS',0.8551,-1.46234,NULL,NULL,'2011-10-24 00:00:00',55858,16.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111024/1110240010014109158.html','HPM LP_584-54 SDSS mag 18,5   ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111024/jpg/1110240010014109158.master.jpg',NULL,NULL,34361171921,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1110240010014109158/1110240010014109158.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111024/1110240010014109158p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,536893311,8388957,NULL,NULL,NULL,NULL),(12300,12300,1,'MLS111019-041845+192036','CRTS-MLS',64.68626,19.34343,NULL,NULL,'2011-10-19 00:00:00',55853,20.47,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111019/1110191180574119659.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111019/jpg/1110191180574119659.master.jpg',NULL,NULL,65234738987,NULL,NULL,NULL,'2011-09-24 13:26:29',55828.560059,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1110191180574119659/1110191180574119659.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111019/1110191180574119659p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1019292796,15926449,NULL,NULL,NULL,NULL),(12301,12301,1,'MLS111003-000749+011159','CRTS-MLS',1.95268,1.19983,NULL,NULL,'2011-10-03 00:00:00',55837,21.27,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20111003/1110031010024101891.html','Unknown SDSS mag 22,3    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20111003/jpg/1110031010024101891.master.jpg',NULL,NULL,66587399148,NULL,NULL,NULL,'2007-09-04 11:31:10',54347.47998,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1110031010024101891/1110031010024101891.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20111003/1110031010024101891p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1040428111,16256689,NULL,NULL,NULL,NULL),(12302,12302,1,'MLS110929-004853+095416','CRTS-MLS',12.22203,9.90458,NULL,NULL,'2011-09-29 00:00:00',55833,21.11,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110929/1109291100124103208.html','Unknown SDSS mag 22,8    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110929/jpg/1109291100124103208.master.jpg',NULL,NULL,66659744771,NULL,NULL,NULL,'2010-12-08 13:26:29',55538.560059,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1109291100124103208/1109291100124103208.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110929/1109291100124103208p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1041558512,16274351,NULL,NULL,NULL,NULL),(12303,12303,1,'MLS110929-004428+103921','CRTS-MLS',11.1158,10.6557,NULL,NULL,'2011-09-29 00:00:00',55833,21.34,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110929/1109291100114115249.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110929/jpg/1109291100114115249.master.jpg',NULL,NULL,66773980217,NULL,NULL,NULL,'2009-12-18 13:26:29',55183.560059,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1109291100114115249/1109291100114115249.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110929/1109291100114115249p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1043343440,16302241,NULL,NULL,NULL,NULL),(12304,12304,1,'MLS110928-234923+055143','CRTS-MLS',357.34735,5.86199,NULL,NULL,'2011-09-28 00:00:00',55832,20.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110928/1109281053294108784.html','Unknown SDSS mag 22,0    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110928/jpg/1109281053294108784.master.jpg',NULL,NULL,51568992978,NULL,NULL,NULL,'2008-12-03 12:28:49',54803.52002,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1109281053294108784/1109281053294108784.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110928/1109281053294108784p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,805765515,12590086,NULL,NULL,NULL,NULL),(12305,12305,1,'MLS110927-035907+214734','CRTS-MLS',59.78014,21.79284,NULL,NULL,'2011-09-27 00:00:00',55831,20.8,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:48','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110927/1109271220524103029.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110927/jpg/1109271220524103029.master.jpg',NULL,NULL,67995957642,NULL,NULL,NULL,'2006-01-07 10:33:36',53742.440002,'2013-01-19 01:32:48','http://crts.caltech.edu/ATEL/MLS/1109271220524103029/1109271220524103029.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110927/1109271220524103029p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1062436838,16600575,NULL,NULL,NULL,NULL),(12306,12306,1,'MLS110927-042223+131107','CRTS-MLS',65.59437,13.18538,NULL,NULL,'2011-09-27 00:00:00',55831,21.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110927/1109271130604103032.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110927/jpg/1109271130604103032.master.jpg',NULL,NULL,65247322496,NULL,NULL,NULL,'2009-01-01 11:31:10',54832.47998,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1109271130604103032/1109271130604103032.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110927/1109271130604103032p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1019489414,15929522,NULL,NULL,NULL,NULL),(12308,12308,1,'MLS110919-233844+051734','CRTS-MLS',354.68165,5.29287,NULL,NULL,'2011-09-19 00:00:00',55823,19.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110919/1109191043284114220.html','Var?       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110919/jpg/1109191043284114220.master.jpg',NULL,NULL,51590922261,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1109191043284114220/1109191043284114220.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110919/1109191043284114220p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,806108160,12595440,NULL,NULL,NULL,NULL),(12309,12309,1,'MLS110702-215321-090104','CRTS-MLS',328.33555,-9.01777,NULL,NULL,'2011-07-02 00:00:00',55744,21.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110702/1107020093014112998.html','Unknown SDSS mag 22,9    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110702/jpg/1107020093014112998.master.jpg',NULL,NULL,49927313912,NULL,NULL,NULL,'2008-11-30 13:26:29',54800.560059,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1107020093014112998/1107020093014112998.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110702/1107020093014112998p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,780114279,12189285,NULL,NULL,NULL,NULL),(12310,12310,1,'MLS110702-215230-075210','CRTS-MLS',328.12613,-7.86954,NULL,NULL,'2011-07-02 00:00:00',55744,21.51,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110702/1107020083014115147.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110702/jpg/1107020083014115147.master.jpg',NULL,NULL,49928203259,NULL,NULL,NULL,'2010-12-15 13:26:29',55545.560059,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1107020083014115147/1107020083014115147.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110702/1107020083014115147p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,780128175,12189502,NULL,NULL,NULL,NULL),(12311,12311,1,'MLS110611-203917-160031','CRTS-MLS',309.82149,-16.00858,NULL,NULL,'2011-06-11 00:00:00',55723,20.54,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110611/1106110152774107405.html','Unknown SDSS mag 21,1    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110611/jpg/1106110152774107405.master.jpg',NULL,NULL,50976177923,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1106110152774107405/1106110152774107405.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110611/1106110152774107405p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,796502780,12445355,NULL,NULL,NULL,NULL),(12312,12312,1,'MLS110611-203553-161217','CRTS-MLS',308.96942,-16.2048,NULL,NULL,'2011-06-11 00:00:00',55723,20.8,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110611/1106110152764101663.html','Unknown MLS mag 21,7    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110611/jpg/1106110152764101663.master.jpg',NULL,NULL,50976402066,NULL,NULL,NULL,'2005-06-18 12:28:47',53539.519989,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1106110152764101663/1106110152764101663.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110611/1106110152764101663p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,796506282,12445410,NULL,NULL,NULL,NULL),(12313,12313,1,'MLS110609-160907-104013','CRTS-MLS',242.2777,-10.67027,NULL,NULL,'2011-06-09 00:00:00',55721,17.29,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110609/1106090102214105344.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110609/jpg/1106090102214105344.master.jpg',NULL,NULL,45580894047,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1106090102214105344/1106090102214105344.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110609/1106090102214105344p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,712201469,11128147,NULL,NULL,NULL,NULL),(12314,12314,1,'MLS110608-155719-193258','CRTS-MLS',239.32813,-19.54936,NULL,NULL,'2011-06-08 00:00:00',55720,20.72,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110608/1106080202094143259.html','Unknown SDSS mag 21,6    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110608/jpg/1106080202094143259.master.jpg',NULL,NULL,46578322200,NULL,NULL,NULL,'2010-06-11 10:33:30',55358.439941,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1106080202094143259/1106080202094143259.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110608/1106080202094143259p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,727786284,11371660,NULL,NULL,NULL,NULL),(12315,12315,1,'MLS110607-155506-174100','CRTS-MLS',238.77585,-17.68337,NULL,NULL,'2011-06-07 00:00:00',55719,20.26,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110607/1106070172114122695.html','Var SDSS mag 21,2    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110607/jpg/1106070172114122695.master.jpg',NULL,NULL,45487395505,NULL,NULL,NULL,'2007-05-26 10:33:36',54246.440002,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1106070172114122695/1106070172114122695.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110607/1106070172114122695p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,710740554,11105321,NULL,NULL,NULL,NULL),(12316,12316,1,'MLS110607-145414-142714','CRTS-MLS',223.5587,-14.45398,NULL,NULL,'2011-06-07 00:00:00',55719,20.47,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110607/1106070142014112997.html','Unknown MLS mag 21,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110607/jpg/1106070142014112997.master.jpg',NULL,NULL,46692664410,NULL,NULL,NULL,'2005-03-12 12:28:48',53441.520004,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1106070142014112997/1106070142014112997.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110607/1106070142014112997p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,729572881,11399576,NULL,NULL,NULL,NULL),(12318,12318,1,'MLS110526-151937-130602','CRTS-MLS',229.90333,-13.10058,NULL,NULL,'2011-05-26 00:00:00',55707,18.92,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110526/1105260132074127618.html','Var mag 19,6     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110526/jpg/1105260132074127618.master.jpg',NULL,NULL,46672252165,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1105260132074127618/1105260132074127618.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110526/1105260132074127618p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,729253940,11394592,NULL,NULL,NULL,NULL),(12319,12319,1,'MLS110523-134550-041125','CRTS-MLS',206.45758,-4.19038,NULL,NULL,'2011-05-23 00:00:00',55704,18.5,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110523/1105230031914102778.html','RRLyrae? SDSS mag 19,1    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110523/jpg/1105230031914102778.master.jpg',NULL,NULL,43620461763,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1105230031914102778/1105230031914102778.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110523/1105230031914102778p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,681569715,10649526,NULL,NULL,NULL,NULL),(12321,12321,1,'MLS110512-132349+013806','CRTS-MLS',200.95335,1.63507,NULL,NULL,'2011-05-12 00:00:00',55693,14.25,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110512/1105121011864108548.html','Mira SDSS mag 14,3    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110512/jpg/1105121011864108548.master.jpg',NULL,NULL,58050768364,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1105121011864108548/1105121011864108548.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110512/1105121011864108548p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,907043255,14172550,NULL,NULL,NULL,NULL),(12322,12322,1,'MLS110508-083823+171403','CRTS-MLS',129.59607,17.23404,NULL,NULL,'2011-05-08 00:00:00',55689,19.06,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110508/1105081161164113897.html','Unknown SDSS mag 19,9    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110508/jpg/1105081161164113897.master.jpg',NULL,NULL,63846017893,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1105081161164113897/1105081161164113897.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110508/1105081161164113897p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,997594029,15587406,NULL,NULL,NULL,NULL),(12323,12323,1,'MLS110329-085857+153855','CRTS-MLS',134.73543,15.64855,NULL,NULL,'2011-03-29 00:00:00',55649,21.21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110329/1103291151214108756.html','Unknown SDSS mag 23,3    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110329/jpg/1103291151214108756.master.jpg',NULL,NULL,63884811898,NULL,NULL,NULL,'2005-04-05 10:33:36',53465.440002,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1103291151214108756/1103291151214108756.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110329/1103291151214108756p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,998200185,15596877,NULL,NULL,NULL,NULL),(12324,12324,1,'MLS110329-120542+030133','CRTS-MLS',181.42532,3.02582,NULL,NULL,'2011-03-29 00:00:00',55649,21.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110329/1103291021684115823.html','Unknown SDSS mag 22,4    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110329/jpg/1103291021684115823.master.jpg',NULL,NULL,57993108983,NULL,NULL,NULL,'2009-03-27 13:26:29',54917.560059,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1103291021684115823/1103291021684115823.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110329/1103291021684115823p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,906142327,14158473,NULL,NULL,NULL,NULL),(12325,12325,1,'MLS110329-134206+003221','CRTS-MLS',205.52444,0.53921,NULL,NULL,'2011-03-29 00:00:00',55649,21.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110329/1103291001914110596.html','Unknown SDSS mag 22,9    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110329/jpg/1103291001914110596.master.jpg',NULL,NULL,58391188828,NULL,NULL,NULL,'2010-04-14 10:33:30',55300.439941,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1103291001914110596/1103291001914110596.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110329/1103291001914110596p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,912362325,14255661,NULL,NULL,NULL,NULL),(12326,12326,1,'MLS110310-111808+145747','CRTS-MLS',169.53311,14.96315,NULL,NULL,'2011-03-10 00:00:00',55630,20.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:49','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110310/1103101141534119027.html','Unknown SDSS mag 22,7    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110310/jpg/1103101141534119027.master.jpg',NULL,NULL,61118509424,NULL,NULL,NULL,'2008-03-05 12:28:49',54530.52002,'2013-01-19 01:32:49','http://crts.caltech.edu/ATEL/MLS/1103101141534119027/1103101141534119027.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110310/1103101141534119027p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,954976709,14921511,NULL,NULL,NULL,NULL),(12327,12327,1,'MLS110309-102441+134104','CRTS-MLS',156.16983,13.68434,NULL,NULL,'2011-03-09 00:00:00',55629,21.12,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110309/1103091131414110480.html','Unknown SDSS mag 22,0    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110309/jpg/1103091131414110480.master.jpg',NULL,NULL,60955572649,NULL,NULL,NULL,'2007-02-25 13:26:23',54156.559998,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1103091131414110480/1103091131414110480.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110309/1103091131414110480p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,952430822,14881731,NULL,NULL,NULL,NULL),(12328,12328,1,'MLS110309-114358+115901','CRTS-MLS',175.99371,11.9837,NULL,NULL,'2011-03-09 00:00:00',55629,21.37,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110309/1103091121604101143.html','Unknown SDSS mag 21,9    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110309/jpg/1103091121604101143.master.jpg',NULL,NULL,60242352733,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1103091121604101143/1103091121604101143.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110309/1103091121604101143p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,941286761,14707605,NULL,NULL,NULL,NULL),(12329,12329,1,'MLS110306-112120+070541','CRTS-MLS',170.33487,7.09479,NULL,NULL,'2011-03-06 00:00:00',55626,21.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110306/1103061071574108742.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110306/jpg/1103061071574108742.master.jpg',NULL,NULL,60393159770,NULL,NULL,NULL,'2010-04-10 13:26:29',55296.560059,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1103061071574108742/1103061071574108742.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110306/1103061071574108742p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,943643121,14744423,NULL,NULL,NULL,NULL),(12330,12330,1,'MLS110305-112359+042623','CRTS-MLS',170.99647,4.43985,NULL,NULL,'2011-03-05 00:00:00',55625,20.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110305/1103051041584101617.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110305/jpg/1103051041584101617.master.jpg',NULL,NULL,60360939715,NULL,NULL,NULL,'2011-01-26 13:26:29',55587.560059,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1103051041584101617/1103051041584101617.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110305/1103051041584101617p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,943139683,14736557,NULL,NULL,NULL,NULL),(12331,12331,1,'MLS110302-091501+101205','CRTS-MLS',138.75598,10.2015,NULL,NULL,'2011-03-02 00:00:00',55622,20.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110302/1103021101274108671.html','Unknown SDSS mag 23,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110302/jpg/1103021101274108671.master.jpg',NULL,NULL,63652093599,NULL,NULL,NULL,'2010-02-15 13:26:29',55242.560059,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1103021101274108671/1103021101274108671.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110302/1103021101274108671p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,994563962,15540061,NULL,NULL,NULL,NULL),(12332,12332,1,'MLS110302-152759-182858','CRTS-MLS',231.99401,-18.48286,NULL,NULL,'2011-03-02 00:00:00',55622,13.56,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110302/1103020182044130863.html','Var mag 13,5     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110302/jpg/1103020182044130863.master.jpg',NULL,NULL,46596152670,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1103020182044130863/1103020182044130863.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110302/1103020182044130863p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,728064885,11376013,NULL,NULL,NULL,NULL),(12333,12333,1,'MLS110301-121046+013259','CRTS-MLS',182.68987,1.54977,NULL,NULL,'2011-03-01 00:00:00',55621,21.27,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110301/1103011011694108629.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110301/jpg/1103011011694108629.master.jpg',NULL,NULL,57995177720,NULL,NULL,NULL,'2006-03-26 12:28:49',53820.52002,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1103011011694108629/1103011011694108629.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110301/1103011011694108629p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,906174651,14158978,NULL,NULL,NULL,NULL),(12334,12334,0,'MLS110301-135717-093239','CRTS-MLS',209.32015,-9.54406,NULL,NULL,'2011-03-01 00:00:00',55621,16.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-12-24 20:38:21','http://nesssi.cacr.caltech.edu/MLS/20110301/1103010091924104236.html','Supernova or Other',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110301/jpg/1103010091924104236.master.jpg',NULL,NULL,43700616483,NULL,NULL,NULL,'2007-06-11 13:26:23',54262.559998,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1103010091924104236/1103010091924104236.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110301/1103010091924104236p.html',NULL,NULL,0,'AGN',NULL,0,NULL,0,682822132,10669095,NULL,NULL,NULL,NULL),(12335,12335,1,'MLS110213-101123+183317','CRTS-MLS',152.84487,18.55463,NULL,NULL,'2011-02-13 00:00:00',55605,20.55,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110213/1102131181354102427.html','Unknown SDSS mag 21,2    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110213/jpg/1102131181354102427.master.jpg',NULL,NULL,60811492871,NULL,NULL,NULL,'2007-10-24 13:26:29',54397.560059,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1102131181354102427/1102131181354102427.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110213/1102131181354102427p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,950179576,14846555,NULL,NULL,NULL,NULL),(12336,12336,1,'MLS110211-124137-004415','CRTS-MLS',190.40401,-0.73742,NULL,NULL,'2011-02-11 00:00:00',55603,21.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110211/1102110001774105910.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110211/jpg/1102110001774105910.master.jpg',NULL,NULL,42983825183,NULL,NULL,NULL,'2010-05-10 10:33:30',55326.439941,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1102110001774105910/1102110001774105910.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110211/1102110001774105910p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,671622268,10494097,NULL,NULL,NULL,NULL),(12337,12337,1,'MLS110210-095317+100501','CRTS-MLS',148.32224,10.08348,NULL,NULL,'2011-02-10 00:00:00',55602,21.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110210/1102101101364105464.html','Unknown SDSS mag 21,6    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110210/jpg/1102101101364105464.master.jpg',NULL,NULL,60928239797,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1102101101364105464/1102101101364105464.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110210/1102101101364105464p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,952003746,14875058,NULL,NULL,NULL,NULL),(12338,12338,1,'MLS110208-093022+113015','CRTS-MLS',142.59023,11.50422,NULL,NULL,'2011-02-08 00:00:00',55600,21.33,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110208/1102081111304111627.html','Unknown MLS mag 22,3    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110208/jpg/1102081111304111627.master.jpg',NULL,NULL,63636786227,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1102081111304111627/1102081111304111627.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110208/1102081111304111627p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,994324784,15536324,NULL,NULL,NULL,NULL),(12339,12339,1,'MLS110207-014023+020639','CRTS-MLS',25.09557,2.11081,NULL,NULL,'2011-02-07 00:00:00',55599,17.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110207/1102071010244108862.html','Var SDSS mag 17,7    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110207/jpg/1102071010244108862.master.jpg',NULL,NULL,66987889399,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1102071010244108862/1102071010244108862.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110207/1102071010244108862p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,1046685771,16354465,NULL,NULL,NULL,NULL),(12340,12340,1,'MLS110207-151716-135735','CRTS-MLS',229.31638,-13.95959,NULL,NULL,'2011-02-07 00:00:00',55599,21.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110207/1102070132074102802.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110207/jpg/1102070132074102802.master.jpg',NULL,NULL,46673574490,NULL,NULL,NULL,'2010-05-09 10:33:30',55325.439941,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1102070132074102802/1102070132074102802.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110207/1102070132074102802p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,729274601,11394915,NULL,NULL,NULL,NULL),(12341,12341,1,'MLS110129-040307+173255','CRTS-MLS',60.77961,17.54856,NULL,NULL,'2011-01-29 00:00:00',55590,21.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110129/1101291170544103934.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110129/jpg/1101291170544103934.master.jpg',NULL,NULL,65157327781,NULL,NULL,NULL,'2005-11-30 10:33:36',53704.440002,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1101291170544103934/1101291170544103934.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110129/1101291170544103934p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1018083246,15907550,NULL,NULL,NULL,NULL),(12342,12342,1,'MLS110129-033152+163509','CRTS-MLS',52.96777,16.58584,NULL,NULL,'2011-01-29 00:00:00',55590,20.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110129/1101291160484106364.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110129/jpg/1101291160484106364.master.jpg',NULL,NULL,68029217188,NULL,NULL,NULL,'2007-03-14 13:26:23',54173.559998,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1101291160484106364/1101291160484106364.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110129/1101291160484106364p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1062956518,16608695,NULL,NULL,NULL,NULL),(12343,12343,1,'MLS110127-044240+240730','CRTS-MLS',70.66665,24.12513,NULL,NULL,'2011-01-27 00:00:00',55588,21.41,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110127/1101271240604107016.html','Unknown mag 22,5     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110127/jpg/1101271240604107016.master.jpg',NULL,NULL,64785324226,NULL,NULL,NULL,'2008-04-07 13:26:29',54563.560059,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1101271240604107016/1101271240604107016.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110127/1101271240604107016p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1012270691,15816729,NULL,NULL,NULL,NULL),(12344,12344,1,'MLS110127-012603+103955','CRTS-MLS',21.51338,10.66525,NULL,NULL,'2011-01-27 00:00:00',55588,21.23,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110127/1101271100204110244.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110127/jpg/1101271100204110244.master.jpg',NULL,NULL,67543324531,NULL,NULL,NULL,'2009-06-27 12:28:49',55009.52002,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1101271100204110244/1101271100204110244.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110127/1101271100204110244p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1055364445,16490069,NULL,NULL,NULL,NULL),(12345,12345,1,'MLS110125-035217+241513','CRTS-MLS',58.07137,24.25363,NULL,NULL,'2011-01-25 00:00:00',55586,21.14,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110125/1101251240504109430.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110125/jpg/1101251240504109430.master.jpg',NULL,NULL,67987737030,NULL,NULL,NULL,'2010-03-19 10:33:30',55274.439941,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1101251240504109430/1101251240504109430.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110125/1101251240504109430p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1062308391,16598568,NULL,NULL,NULL,NULL),(12346,12346,1,'MLS110113-133158-075800','CRTS-MLS',202.98975,-7.96679,NULL,NULL,'2011-01-13 00:00:00',55574,20.78,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:50','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110113/1101130081874111954.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110113/jpg/1101130081874111954.master.jpg',NULL,NULL,43863409814,NULL,NULL,NULL,'2010-12-10 13:26:29',55540.560059,'2013-01-19 01:32:50','http://crts.caltech.edu/ATEL/MLS/1101130081874111954/1101130081874111954.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110113/1101130081874111954p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,685365778,10708840,NULL,NULL,NULL,NULL),(12347,12347,1,'MLS110108-105709+002757','CRTS-MLS',164.28574,0.4658,NULL,NULL,'2011-01-08 00:00:00',55569,20.93,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110108/1101081001524106407.html','Unknown SDSS mag >22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110108/jpg/1101081001524106407.master.jpg',NULL,NULL,60289279796,NULL,NULL,NULL,'2010-12-01 10:33:30',55531.439941,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1101081001524106407/1101081001524106407.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110108/1101081001524106407p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,942019996,14719062,NULL,NULL,NULL,NULL),(12348,12348,1,'MLS110102-073040+241313','CRTS-MLS',112.66842,24.22041,NULL,NULL,'2011-01-02 00:00:00',55563,20.67,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20110102/1101021240964110297.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20110102/jpg/1101021240964110297.master.jpg',NULL,NULL,62957714800,NULL,NULL,NULL,'2007-11-02 12:28:49',54406.52002,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1101021240964110297/1101021240964110297.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20110102/1101021240964110297p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,983714293,15370535,NULL,NULL,NULL,NULL),(12349,12349,1,'MLS101214-103655+103225','CRTS-MLS',159.22878,10.54028,NULL,NULL,'2010-12-14 00:00:00',55544,21.21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101214/1012141101464112763.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101214/jpg/1012141101464112763.master.jpg',NULL,NULL,61047109168,NULL,NULL,NULL,'2007-03-11 12:28:49',54170.52002,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1012141101464112763/1012141101464112763.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101214/1012141101464112763p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,953861080,14904079,NULL,NULL,NULL,NULL),(12350,12350,1,'MLS101213-015656+095349','CRTS-MLS',29.23136,9.89708,NULL,NULL,'2010-12-13 00:00:00',55543,21.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101213/1012131100274102364.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101213/jpg/1012131100274102364.master.jpg',NULL,NULL,67053107407,NULL,NULL,NULL,'2009-11-19 12:28:49',55154.52002,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1012131100274102364/1012131100274102364.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101213/1012131100274102364p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1047704803,16370387,NULL,NULL,NULL,NULL),(12351,12351,1,'MLS101209-090054+200339','CRTS-MLS',135.22647,20.06083,NULL,NULL,'2010-12-09 00:00:00',55539,21.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101209/1012091201184110759.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101209/jpg/1012091201184110759.master.jpg',NULL,NULL,63833935673,NULL,NULL,NULL,'2009-04-30 13:26:29',54951.560059,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1012091201184110759/1012091201184110759.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101209/1012091201184110759p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,997405244,15584456,NULL,NULL,NULL,NULL),(12352,12352,1,'MLS101209-130910-073604','CRTS-MLS',197.2927,-7.60116,NULL,NULL,'2010-12-09 00:00:00',55539,20.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101209/1012090081814112750.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101209/jpg/1012090081814112750.master.jpg',NULL,NULL,43849657632,NULL,NULL,NULL,'2010-05-22 13:26:29',55338.560059,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1012090081814112750/1012090081814112750.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101209/1012090081814112750p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,685150900,10705482,NULL,NULL,NULL,NULL),(12353,12353,1,'MLS101206-024455+172336','CRTS-MLS',41.23108,17.39322,NULL,NULL,'2010-12-06 00:00:00',55536,21.55,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101206/1012061170374101158.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101206/jpg/1012061170374101158.master.jpg',NULL,NULL,68141211278,NULL,NULL,NULL,'2010-09-18 13:26:29',55457.560059,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1012061170374101158/1012061170374101158.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101206/1012061170374101158p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1064706426,16636037,NULL,NULL,NULL,NULL),(12354,12354,1,'MLS101206-000356+041459','CRTS-MLS',0.98499,4.24966,NULL,NULL,'2010-12-06 00:00:00',55536,21.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101206/1012061030014118162.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101206/jpg/1012061030014118162.master.jpg',NULL,NULL,66581056155,NULL,NULL,NULL,'2009-09-28 13:26:29',55102.560059,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1012061030014118162/1012061030014118162.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101206/1012061030014118162p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1040329002,16255140,NULL,NULL,NULL,NULL),(12355,12355,1,'MLS101206-001101+031110','CRTS-MLS',2.75523,3.18611,NULL,NULL,'2010-12-06 00:00:00',55536,21.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101206/1012061020034113403.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101206/jpg/1012061020034113403.master.jpg',NULL,NULL,66627799860,NULL,NULL,NULL,'2009-09-21 10:33:30',55095.439941,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1012061020034113403/1012061020034113403.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101206/1012061020034113403p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1041059372,16266552,NULL,NULL,NULL,NULL),(12356,12356,1,'MLS101202-034025+121814','CRTS-MLS',55.10476,12.30375,NULL,NULL,'2010-12-02 00:00:00',55532,20.56,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101202/1012021120504105478.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101202/jpg/1012021120504105478.master.jpg',NULL,NULL,65112701186,NULL,NULL,NULL,'2009-11-17 10:33:30',55152.439941,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1012021120504105478/1012021120504105478.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101202/1012021120504105478p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,1017385956,15896655,NULL,NULL,NULL,NULL),(12357,12357,1,'MLS101127-012654+075026','CRTS-MLS',21.72322,7.84051,NULL,NULL,'2010-11-27 00:00:00',55527,21.36,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101127/1011271080204103916.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101127/jpg/1011271080204103916.master.jpg',NULL,NULL,67572041304,NULL,NULL,NULL,'2006-07-21 10:33:36',53937.440002,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1011271080204103916/1011271080204103916.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101127/1011271080204103916p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1055813145,16497080,NULL,NULL,NULL,NULL),(12358,12358,1,'MLS101108-043519+134245','CRTS-MLS',68.83114,13.71258,NULL,NULL,'2010-11-08 00:00:00',55508,20.19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101108/1011081130624111977.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101108/jpg/1011081130624111977.master.jpg',NULL,NULL,65480467076,NULL,NULL,NULL,'2007-12-19 11:31:10',54453.47998,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1011081130624111977/1011081130624111977.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101108/1011081130624111977p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1023132298,15986442,NULL,NULL,NULL,NULL),(12359,12359,1,'MLS101108-021024+021312','CRTS-MLS',32.59848,2.21998,NULL,NULL,'2010-11-08 00:00:00',55508,20.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101108/1011081020314101081.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101108/jpg/1011081020314101081.master.jpg',NULL,NULL,67061018103,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1011081020314101081/1011081020314101081.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101108/1011081020314101081p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1047828407,16372318,NULL,NULL,NULL,NULL),(12360,12360,1,'MLS101106-020324+035426','CRTS-MLS',30.84873,3.90731,NULL,NULL,'2010-11-06 00:00:00',55506,21.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101106/1011061030294112093.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101106/jpg/1011061030294112093.master.jpg',NULL,NULL,67068575639,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1011061030294112093/1011061030294112093.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101106/1011061030294112093p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1047946494,16374163,NULL,NULL,NULL,NULL),(12361,12361,1,'MLS101106-011303+032253','CRTS-MLS',18.2624,3.38146,NULL,NULL,'2010-11-06 00:00:00',55506,20.61,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101106/1011061030174102458.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101106/jpg/1011061030174102458.master.jpg',NULL,NULL,66646695216,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1011061030174102458/1011061030174102458.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101106/1011061030174102458p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,1041354612,16271165,NULL,NULL,NULL,NULL),(12362,12362,1,'MLS101106-231739-052003','CRTS-MLS',349.41048,-5.3343,NULL,NULL,'2010-11-06 00:00:00',55506,20.36,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101106/1011060043234101475.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101106/jpg/1011060043234101475.master.jpg',NULL,NULL,49631547868,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1011060043234101475/1011060043234101475.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101106/1011060043234101475p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,775492935,12117077,NULL,NULL,NULL,NULL),(12363,12363,1,'MLS101106-232706-021905','CRTS-MLS',351.77501,-2.31793,NULL,NULL,'2010-11-06 00:00:00',55506,17.14,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101106/1011060023264114916.html','RRLyrae       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101106/jpg/1011060023264114916.master.jpg',NULL,NULL,49424460109,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1011060023264114916/1011060023264114916.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101106/1011060023264114916p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,772257189,12066518,NULL,NULL,NULL,NULL),(12364,12364,1,'MLS101106-232813-031151','CRTS-MLS',352.0528,-3.19748,NULL,NULL,'2010-11-06 00:00:00',55506,21.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101106/1011060023264100994.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101106/jpg/1011060023264100994.master.jpg',NULL,NULL,49415307366,NULL,NULL,NULL,'2010-10-09 10:33:30',55478.439941,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1011060023264100994/1011060023264100994.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101106/1011060023264100994p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,772114177,12064284,NULL,NULL,NULL,NULL),(12365,12365,1,'MLS101105-072334+245111','CRTS-MLS',110.89322,24.85308,NULL,NULL,'2010-11-05 00:00:00',55505,17.58,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101105/1011051240944126209.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101105/jpg/1011051240944126209.master.jpg',NULL,NULL,62960435592,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1011051240944126209/1011051240944126209.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101105/1011051240944126209p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,983756806,15371200,NULL,NULL,NULL,NULL),(12366,12366,1,'MLS101105-071645+225643','CRTS-MLS',109.1883,22.94533,NULL,NULL,'2010-11-05 00:00:00',55505,19.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101105/1011051230944105969.html','RRLyrae?       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101105/jpg/1011051230944105969.master.jpg',NULL,NULL,63111150008,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1011051230944105969/1011051230944105969.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101105/1011051230944105969p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,986111718,15407995,NULL,NULL,NULL,NULL),(12367,12367,1,'MLS101031-014746+120903','CRTS-MLS',26.94154,12.15095,NULL,NULL,'2010-10-31 00:00:00',55500,21.4,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:51','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101031/1010311120254104997.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101031/jpg/1010311120254104997.master.jpg',NULL,NULL,66925513380,NULL,NULL,NULL,'2007-02-07 13:26:23',54138.559998,'2013-01-19 01:32:51','http://crts.caltech.edu/ATEL/MLS/1010311120254104997/1010311120254104997.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101031/1010311120254104997p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1045711146,16339236,NULL,NULL,NULL,NULL),(12368,12368,1,'MLS101031-230013-091506','CRTS-MLS',345.05343,-9.25163,NULL,NULL,'2010-10-31 00:00:00',55500,21.74,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101031/1010310093164108297.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101031/jpg/1010310093164108297.master.jpg',NULL,NULL,50380905956,NULL,NULL,NULL,'2009-11-18 13:26:29',55153.560059,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1010310093164108297/1010310093164108297.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101031/1010310093164108297p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,787201655,12300025,NULL,NULL,NULL,NULL),(12369,12369,1,'MLS101031-230307-081518','CRTS-MLS',345.77763,-8.25493,NULL,NULL,'2010-10-31 00:00:00',55500,21.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101031/1010310083174107006.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101031/jpg/1010310083174107006.master.jpg',NULL,NULL,49489814013,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1010310083174107006/1010310083174107006.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101031/1010310083174107006p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,773278343,12082474,NULL,NULL,NULL,NULL),(12370,12370,1,'MLS101029-033343+224058','CRTS-MLS',53.42954,22.68271,NULL,NULL,'2010-10-29 00:00:00',55498,21.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101029/1010291220464113333.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101029/jpg/1010291220464113333.master.jpg',NULL,NULL,68041716384,NULL,NULL,NULL,'2008-09-25 10:33:30',54734.439941,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1010291220464113333/1010291220464113333.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101029/1010291220464113333p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1063151818,16611747,NULL,NULL,NULL,NULL),(12371,12371,1,'MLS101029-002846+021656','CRTS-MLS',7.19214,2.28229,NULL,NULL,'2010-10-29 00:00:00',55498,21.51,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101029/1010291020074101818.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101029/jpg/1010291020074101818.master.jpg',NULL,NULL,66604879464,NULL,NULL,NULL,'2006-01-28 13:26:23',53763.559998,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1010291020074101818/1010291020074101818.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101029/1010291020074101818p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,1040701241,16260956,NULL,NULL,NULL,NULL),(12372,12372,1,'MLS101029-230855+014429','CRTS-MLS',347.23078,1.74145,NULL,NULL,'2010-10-29 00:00:00',55498,20.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101029/1010291013224110627.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101029/jpg/1010291013224110627.master.jpg',NULL,NULL,51706351128,NULL,NULL,NULL,'2009-10-23 13:26:29',55127.560059,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1010291013224110627/1010291013224110627.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101029/1010291013224110627p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,807911736,12623620,NULL,NULL,NULL,NULL),(12374,12374,1,'MLS101013-034059+262321','CRTS-MLS',55.24771,26.38924,NULL,NULL,'2010-10-13 00:00:00',55482,20.21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101013/1010131260464109612.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101013/jpg/1010131260464109612.master.jpg',NULL,NULL,68506043621,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1010131260464109612/1010131260464109612.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101013/1010131260464109612p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,1070406931,16725108,NULL,NULL,NULL,NULL),(12375,12375,1,'MLS101013-032954+252252','CRTS-MLS',52.47627,25.381,NULL,NULL,'2010-10-13 00:00:00',55482,21.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101013/1010131250454110645.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101013/jpg/1010131250454110645.master.jpg',NULL,NULL,68489562215,NULL,NULL,NULL,'2009-11-22 10:33:30',55157.439941,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1010131250454110645/1010131250454110645.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101013/1010131250454110645p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1070149409,16721084,NULL,NULL,NULL,NULL),(12376,12376,1,'MLS101012-021747+234129','CRTS-MLS',34.44601,23.69137,NULL,NULL,'2010-10-12 00:00:00',55481,21.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101012/1010121230304115143.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101012/jpg/1010121230304115143.master.jpg',NULL,NULL,68057515380,NULL,NULL,NULL,'2006-11-01 13:26:23',54040.559998,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1010121230304115143/1010121230304115143.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101012/1010121230304115143p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,1063398677,16615604,NULL,NULL,NULL,NULL),(12377,12377,1,'MLS101012-032124+122845','CRTS-MLS',50.34913,12.47909,NULL,NULL,'2010-10-12 00:00:00',55481,14.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101012/1010121120464206285.html','HPM LHS_1537      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101012/jpg/1010121120464206285.master.jpg',NULL,NULL,68151271672,NULL,NULL,NULL,'2006-01-05 13:26:23',53740.559998,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1010121120464206285/1010121120464206285.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101012/1010121120464206285p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,1064863619,16638494,NULL,NULL,NULL,NULL),(12378,12378,1,'MLS101011-031541+250828','CRTS-MLS',48.92242,25.14098,NULL,NULL,'2010-10-11 00:00:00',55480,20.62,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101011/1010111250424104238.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101011/jpg/1010111250424104238.master.jpg',NULL,NULL,68000266941,NULL,NULL,NULL,'2006-11-15 10:33:36',54054.440002,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1010111250424104238/1010111250424104238.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101011/1010111250424104238p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,1062504170,16601627,NULL,NULL,NULL,NULL),(12379,12379,1,'MLS101011-020622+212206','CRTS-MLS',31.59128,21.36839,NULL,NULL,'2010-10-11 00:00:00',55480,21.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101011/1010111210284113665.html','Unknown SDSS mag 22,6    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101011/jpg/1010111210284113665.master.jpg',NULL,NULL,68053904649,NULL,NULL,NULL,'2009-10-26 13:26:29',55130.560059,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1010111210284113665/1010111210284113665.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101011/1010111210284113665p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1063342260,16614722,NULL,NULL,NULL,NULL),(12380,12380,1,'MLS101010-004547-025914','CRTS-MLS',11.44479,-2.98713,NULL,NULL,'2010-10-10 00:00:00',55479,20.66,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101010/1010100020114103812.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101010/jpg/1010100020114103812.master.jpg',NULL,NULL,34517085025,NULL,NULL,NULL,'2009-10-17 13:26:29',55121.560059,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1010100020114103812/1010100020114103812.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101010/1010100020114103812p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,539329453,8427022,NULL,NULL,NULL,NULL),(12381,12381,1,'MLS101009-012100+103556','CRTS-MLS',20.24967,10.59902,NULL,NULL,'2010-10-09 00:00:00',55478,21.64,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101009/1010091100194116022.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101009/jpg/1010091100194116022.master.jpg',NULL,NULL,67536490529,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1010091100194116022/1010091100194116022.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101009/1010091100194116022p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1055257664,16488401,NULL,NULL,NULL,NULL),(12382,12382,1,'MLS101009-232613-025509','CRTS-MLS',351.5557,-2.9193,NULL,NULL,'2010-10-09 00:00:00',55478,20.64,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101009/1010090023264106031.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101009/jpg/1010090023264106031.master.jpg',NULL,NULL,49636457062,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1010090023264106031/1010090023264106031.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101009/1010090023264106031p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,775569641,12118275,NULL,NULL,NULL,NULL),(12383,12383,1,'MLS101001-213111-103309','CRTS-MLS',322.79753,-10.55237,NULL,NULL,'2010-10-01 00:00:00',55470,20.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20101001/1010010102954106596.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20101001/jpg/1010010102954106596.master.jpg',NULL,NULL,49680809441,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1010010102954106596/1010010102954106596.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20101001/1010010102954106596p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,776262647,12129103,NULL,NULL,NULL,NULL),(12384,12384,1,'MLS100930-001157-034731','CRTS-MLS',2.98908,-3.79192,NULL,NULL,'2010-09-30 00:00:00',55469,21.06,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100930/1009300030034109125.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100930/jpg/1009300030034109125.master.jpg',NULL,NULL,34423140461,NULL,NULL,NULL,'2009-10-26 13:26:29',55130.560059,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1009300030034109125/1009300030034109125.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100930/1009300030034109125p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,537861569,8404087,NULL,NULL,NULL,NULL),(12385,12385,1,'MLS100929-212453-134405','CRTS-MLS',321.21919,-13.73466,NULL,NULL,'2010-09-29 00:00:00',55468,20.81,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100929/1009290132904107403.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100929/jpg/1009290132904107403.master.jpg',NULL,NULL,50955657697,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1009290132904107403/1009290132904107403.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100929/1009290132904107403p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,796182151,12440346,NULL,NULL,NULL,NULL),(12386,12386,1,'MLS100929-231542-031926','CRTS-MLS',348.92309,-3.32387,NULL,NULL,'2010-09-29 00:00:00',55468,19.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100929/1009290033224113680.html','Var?       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100929/jpg/1009290033224113680.master.jpg',NULL,NULL,49633520623,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1009290033224113680/1009290033224113680.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100929/1009290033224113680p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,775523759,12117558,NULL,NULL,NULL,NULL),(12387,12387,1,'MLS100917-025633+164504','CRTS-MLS',44.13914,16.75099,NULL,NULL,'2010-09-17 00:00:00',55456,21.41,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100917/1009171160404108575.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100917/jpg/1009171160404108575.master.jpg',NULL,NULL,68180132208,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:52','http://crts.caltech.edu/ATEL/MLS/1009171160404108575/1009171160404108575.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100917/1009171160404108575p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1065314565,16645540,NULL,NULL,NULL,NULL),(12388,12388,1,'MLS100916-023642+184010','CRTS-MLS',39.17375,18.66934,NULL,NULL,'2010-09-16 00:00:00',55455,21.31,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100916/1009161180354105422.html','Unknown mag 22,3     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100916/jpg/1009161180354105422.master.jpg',NULL,NULL,68069767541,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1009161180354105422/1009161180354105422.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100916/1009161180354105422p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1063590117,16618595,NULL,NULL,NULL,NULL),(12389,12389,1,'MLS100906-223034-042347','CRTS-MLS',337.64009,-4.39628,NULL,NULL,'2010-09-06 00:00:00',55445,19.1,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100906/1009060043124117486.html','Var MLS mag 19,8    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100906/jpg/1009060043124117486.master.jpg',NULL,NULL,50338607414,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1009060043124117486/1009060043124117486.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100906/1009060043124117486p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,786540740,12289699,NULL,NULL,NULL,NULL),(12390,12390,1,'MLS100905-204240-134327','CRTS-MLS',310.66596,-13.72414,NULL,NULL,'2010-09-05 00:00:00',55444,20.54,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100905/1009050132804112826.html','Var mag 21,5     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100905/jpg/1009050132804112826.master.jpg',NULL,NULL,50983604622,NULL,NULL,NULL,'2005-07-11 13:26:23',53562.559998,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1009050132804112826/1009050132804112826.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100905/1009050132804112826p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,796618822,12447169,NULL,NULL,NULL,NULL),(12391,12391,1,'MLS100905-222749-053313','CRTS-MLS',336.95458,-5.55353,NULL,NULL,'2010-09-05 00:00:00',55444,19.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100905/1009050053104119149.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100905/jpg/1009050053104119149.master.jpg',NULL,NULL,50336713436,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1009050053104119149/1009050053104119149.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100905/1009050053104119149p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,786511147,12289236,NULL,NULL,NULL,NULL),(12392,12392,1,'MLS100903-230915-015540','CRTS-MLS',347.3129,-1.92779,NULL,NULL,'2010-09-03 00:00:00',55442,21.26,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100903/1009030013224105426.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100903/jpg/1009030013224105426.master.jpg',NULL,NULL,49506791939,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1009030013224105426/1009030013224105426.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100903/1009030013224105426p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,773543624,12086619,NULL,NULL,NULL,NULL),(12393,12393,1,'MLS100902-213306-130358','CRTS-MLS',323.27311,-13.06598,NULL,NULL,'2010-09-02 00:00:00',55441,20.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020132914122418.html','HPM?       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100902/jpg/1009020132914122418.master.jpg',NULL,NULL,50885689682,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1009020132914122418/1009020132914122418.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020132914122418p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,795088901,12423264,NULL,NULL,NULL,NULL),(12394,12394,1,'MLS100902-213057-103732','CRTS-MLS',322.73937,-10.62561,NULL,NULL,'2010-09-02 00:00:00',55441,21.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020102954106244.html','Var mag 22,5     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100902/jpg/1009020102954106244.master.jpg',NULL,NULL,49680760745,NULL,NULL,NULL,'2005-10-31 10:33:36',53674.440002,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1009020102954106244/1009020102954106244.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020102954106244p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,776261886,12129091,NULL,NULL,NULL,NULL),(12395,12395,1,'MLS100902-233648-074408','CRTS-MLS',354.19878,-7.73557,NULL,NULL,'2010-09-02 00:00:00',55441,21.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020083254119406.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100902/jpg/1009020083254119406.master.jpg',NULL,NULL,49646275556,NULL,NULL,NULL,'2007-11-03 12:28:49',54407.52002,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1009020083254119406/1009020083254119406.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020083254119406p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,775723055,12120672,NULL,NULL,NULL,NULL),(12396,12396,1,'MLS100902-225846-072126','CRTS-MLS',344.69266,-7.35718,NULL,NULL,'2010-09-02 00:00:00',55441,20.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020073174104217.html','HPM?       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100902/jpg/1009020073174104217.master.jpg',NULL,NULL,49486193608,NULL,NULL,NULL,'2005-10-24 10:33:36',53667.440002,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1009020073174104217/1009020073174104217.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020073174104217p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,773221775,12081590,NULL,NULL,NULL,NULL),(12397,12397,1,'MLS100902-224357-013254','CRTS-MLS',340.98854,-1.5483,NULL,NULL,'2010-09-02 00:00:00',55441,21.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020013164111870.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100902/jpg/1009020013164111870.master.jpg',NULL,NULL,49475828820,NULL,NULL,NULL,'2007-09-04 13:26:29',54347.560059,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1009020013164111870/1009020013164111870.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100902/1009020013164111870p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,773059825,12079059,NULL,NULL,NULL,NULL),(12398,12398,1,'MLS100901-021604+133230','CRTS-MLS',34.01484,13.54177,NULL,NULL,'2010-09-01 00:00:00',55440,20.95,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100901/1009011130314107162.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100901/jpg/1009011130314107162.master.jpg',NULL,NULL,66944460988,NULL,NULL,NULL,'2010-02-13 13:26:29',55240.560059,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1009011130314107162/1009011130314107162.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100901/1009011130314107162p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1046007202,16343862,NULL,NULL,NULL,NULL),(12399,12399,1,'MLS100620-213227-150523','CRTS-MLS',323.11061,-15.08977,NULL,NULL,'2010-06-20 00:00:00',55367,17.1,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100620/1006200142904101805.html','Var 17,8      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100620/jpg/1006200142904101805.master.jpg',NULL,NULL,50886773163,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1006200142904101805/1006200142904101805.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100620/1006200142904101805p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,795105830,12423528,NULL,NULL,NULL,NULL),(12400,12400,1,'MLS100618-155913-194823','CRTS-MLS',239.80447,-19.80644,NULL,NULL,'2010-06-18 00:00:00',55365,20.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100618/1006180202104129897.html','Var? MLS mag 21,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100618/jpg/1006180202104129897.master.jpg',NULL,NULL,45442668291,NULL,NULL,NULL,'2006-02-25 10:33:36',53791.440002,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1006180202104129897/1006180202104129897.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100618/1006180202104129897p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,710041692,11094401,NULL,NULL,NULL,NULL),(12401,12401,1,'MLS100617-213348-142256','CRTS-MLS',323.44903,-14.38214,NULL,NULL,'2010-06-17 00:00:00',55364,21.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100617/1006170142914119207.html','Unknown mag 22     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100617/jpg/1006170142914119207.master.jpg',NULL,NULL,50889056442,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1006170142914119207/1006170142914119207.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100617/1006170142914119207p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,795141506,12424086,NULL,NULL,NULL,NULL),(12402,12402,1,'MLS100519-151759-030919','CRTS-MLS',229.49638,-3.15518,NULL,NULL,'2010-05-19 00:00:00',55335,15.66,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100519/1005190022134102227.html','Var mag 16,5     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100519/jpg/1005190022134102227.master.jpg',NULL,NULL,45370956398,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1005190022134102227/1005190022134102227.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100519/1005190022134102227p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,708921193,11076893,NULL,NULL,NULL,NULL),(12403,12403,1,'MLS100508-134155-124012','CRTS-MLS',205.47993,-12.67004,NULL,NULL,'2010-05-08 00:00:00',55324,19.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100508/1005080121874105610.html','Var MLS mag 20,2    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100508/jpg/1005080121874105610.master.jpg',NULL,NULL,43657843470,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1005080121874105610/1005080121874105610.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100508/1005080121874105610p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,682153804,10658653,NULL,NULL,NULL,NULL),(12404,12404,1,'MLS100506-144708-174240','CRTS-MLS',221.78162,-17.71099,NULL,NULL,'2010-05-06 00:00:00',55322,20.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100506/1005060171964113342.html','Unknown mag > 22    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100506/jpg/1005060171964113342.master.jpg',NULL,NULL,46695933509,NULL,NULL,NULL,'2008-05-03 13:26:29',54589.560059,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1005060171964113342/1005060171964113342.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100506/1005060171964113342p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,729623961,11400374,NULL,NULL,NULL,NULL),(12405,12405,1,'MLS100318-041128+224949','CRTS-MLS',62.86862,22.83016,NULL,NULL,'2010-03-18 00:00:00',55273,20.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/MLS/20100318/1003181230544101640.html','Var?       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/MLS/20100318/jpg/1003181230544101640.master.jpg',NULL,NULL,65095954177,NULL,NULL,NULL,'2006-03-04 10:33:36',53798.440002,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/MLS/1003181230544101640/1003181230544101640.find.jpg','http://nesssi.cacr.caltech.edu/MLS/20100318/1003181230544101640p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1017124284,15892566,NULL,NULL,NULL,NULL),(12407,3906,0,'SSS121120-023241-391756','CRTS-SSS',38.17061,-39.29878,NULL,NULL,'2012-11-20 00:00:00',56251,13.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:53','2013-01-19 01:32:53','http://nesssi.cacr.caltech.edu/SSS/20121120/1211200390154110816.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20121120/jpg/1211200390154110816.master.jpg',NULL,NULL,38623139310,NULL,NULL,NULL,'2012-10-16 13:26:29',56216.560059,'2013-01-19 01:32:53','http://crts.caltech.edu/ATEL/SSS/1211200390154110816/1211200390154110816.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20121120/1211200390154110816p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,603486551,9429477,NULL,NULL,NULL,NULL),(12408,12408,0,'SSS121118-003802-135139','CRTS-SSS',9.50729,-13.86097,NULL,NULL,'2012-11-18 00:00:00',56249,14.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:54','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/SSS/20121118/1211180130054102793.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20121118/jpg/1211180130054102793.master.jpg',NULL,NULL,35334047109,NULL,NULL,NULL,'2011-07-30 12:28:49',55772.52002,'2013-01-19 01:32:54','http://crts.caltech.edu/ATEL/SSS/1211180130054102793/1211180130054102793.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20121118/1211180130054102793p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,552094486,8626476,NULL,NULL,NULL,NULL),(12409,3027,0,'SSS121114-033336-360735','CRTS-SSS',53.40121,-36.12639,NULL,NULL,'2012-11-14 00:00:00',56245,12.08,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:54','2013-01-19 01:32:54','http://nesssi.cacr.caltech.edu/SSS/20121114/1211140350224101637.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20121114/jpg/1211140350224101637.master.jpg',NULL,NULL,38567734075,NULL,NULL,NULL,'2012-09-06 13:26:29',56176.560059,'2013-01-19 01:32:54','http://crts.caltech.edu/ATEL/SSS/1211140350224101637/1211140350224101637.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20121114/1211140350224101637p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,602620844,9415950,NULL,NULL,NULL,NULL),(12410,12410,1,'SSS121016-032640-313949','CRTS-SSS',51.66537,-31.66353,NULL,NULL,'2012-10-16 00:00:00',56216,19.4,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:54','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20121016/1210160310234105943.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20121016/jpg/1210160310234105943.master.jpg',NULL,NULL,38571663588,NULL,NULL,NULL,'2009-10-08 11:31:10',55112.47998,'2013-01-19 01:32:54','http://crts.caltech.edu/ATEL/SSS/1210160310234105943/1210160310234105943.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20121016/1210160310234105943p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,602682243,9416910,NULL,NULL,NULL,NULL),(12421,12421,0,'SSS120724-231448-433623','CRTS-SSS',348.69997,-43.60636,NULL,NULL,'2012-07-24 00:00:00',56132,13.92,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:54','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/SSS/20120724/1207240431284109622.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120724/jpg/1207240431284109622.master.jpg',NULL,NULL,50530501991,NULL,NULL,NULL,'2007-05-27 13:26:23',54247.559998,'2013-01-19 01:32:54','http://crts.caltech.edu/ATEL/SSS/1207240431284109622/1207240431284109622.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120724/1207240431284109622p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,789539093,12336548,NULL,NULL,NULL,NULL),(12422,12422,0,'SSS120723-212235-333355','CRTS-SSS',320.64701,-33.56518,NULL,NULL,'2012-07-23 00:00:00',56131,17.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:54','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/SSS/20120723/1207230331354107292.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120723/jpg/1207230331354107292.master.jpg',NULL,NULL,51477552483,NULL,NULL,NULL,'2012-07-07 13:26:29',56115.560059,'2013-01-19 01:32:54','http://crts.caltech.edu/ATEL/SSS/1207230331354107292/1207230331354107292.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120723/1207230331354107292p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,804336757,12567761,NULL,NULL,NULL,NULL),(12423,12423,1,'SSS120515-222111-400757','CRTS-SSS',335.29661,-40.13263,NULL,NULL,'2012-05-15 00:00:00',56062,17.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:54','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120515/1205150391324102333.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120515/jpg/1205150391324102333.master.jpg',NULL,NULL,50723299523,NULL,NULL,NULL,'2011-10-20 13:26:29',55854.560059,'2013-01-19 01:32:54','http://crts.caltech.edu/ATEL/SSS/1205150391324102333/1205150391324102333.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120515/1205150391324102333p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,792551555,12383618,NULL,NULL,NULL,NULL),(12425,12425,1,'SSS120429-053858-475836','CRTS-SSS',84.74313,-47.97661,NULL,NULL,'2012-04-29 00:00:00',56046,16.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:54','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120429/1204290470304105284.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120429/jpg/1204290470304105284.master.jpg',NULL,NULL,35709237136,NULL,NULL,NULL,'2012-02-14 13:26:29',55971.560059,'2013-01-19 01:32:54','http://crts.caltech.edu/ATEL/SSS/1204290470304105284/1204290470304105284.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120429/1204290470304105284p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,557956830,8718075,NULL,NULL,NULL,NULL),(12426,12426,0,'SSS120416-202355-482117','CRTS-SSS',305.98017,-48.35479,NULL,NULL,'2012-04-16 00:00:00',56033,16.11,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:54','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/SSS/20120416/1204160471064101103.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120416/jpg/1204160471064101103.master.jpg',NULL,NULL,51132542806,NULL,NULL,NULL,'2012-04-03 10:33:30',56020.439941,'2013-01-19 01:32:54','http://crts.caltech.edu/ATEL/SSS/1204160471064101103/1204160471064101103.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120416/1204160471064101103p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,798945981,12483530,NULL,NULL,NULL,NULL),(12428,12428,0,'SSS120413-125045-141608','CRTS-SSS',192.6884,-14.26887,NULL,NULL,'2012-04-13 00:00:00',56030,15.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/SSS/20120413/1204130150944126337.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120413/jpg/1204130150944126337.master.jpg',NULL,NULL,43971197295,NULL,NULL,NULL,'2012-01-03 13:26:29',55929.560059,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1204130150944126337/1204130150944126337.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120413/1204130150944126337p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,687049957,10735155,NULL,NULL,NULL,NULL),(12429,12429,1,'SSS120411-105223-355943','CRTS-SSS',163.0965,-35.99536,NULL,NULL,'2012-04-11 00:00:00',56028,18.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120411/1204110350684105798.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120411/jpg/1204110350684105798.master.jpg',NULL,NULL,42111130657,NULL,NULL,NULL,'2012-03-15 13:26:29',56001.560059,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1204110350684105798/1204110350684105798.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120411/1204110350684105798p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,657986416,10281037,NULL,NULL,NULL,NULL),(12430,12430,1,'SSS120330-125912-245637','CRTS-SSS',194.79805,-24.94353,NULL,NULL,'2012-03-30 00:00:00',56016,18.64,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120330/1203300250894119974.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120330/jpg/1203300250894119974.master.jpg',NULL,NULL,43305227377,NULL,NULL,NULL,'2006-08-17 13:26:23',53964.559998,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1203300250894119974/1203300250894119974.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120330/1203300250894119974p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,676644177,10572565,NULL,NULL,NULL,NULL),(12431,12431,0,'SSS120216-134128-320001','CRTS-SSS',205.36527,-32.00027,NULL,NULL,'2012-02-16 00:00:00',55973,16.61,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/SSS/20120216/1202160310894105700.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120216/jpg/1202160310894105700.master.jpg',NULL,NULL,46905778094,NULL,NULL,NULL,'2011-08-26 13:26:29',55799.560059,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1202160310894105700/1202160310894105700.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120216/1202160310894105700p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,732902782,11451605,NULL,NULL,NULL,NULL),(12432,12432,1,'SSS120204-122819-342726','CRTS-SSS',187.0793,-34.45733,NULL,NULL,'2012-02-04 00:00:00',55961,16.68,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120204/1202040350774136330.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120204/jpg/1202040350774136330.master.jpg',NULL,NULL,43440664901,NULL,NULL,NULL,'2008-01-22 13:26:29',54487.560059,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1202040350774136330/1202040350774136330.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120204/1202040350774136330p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,678760389,10605631,NULL,NULL,NULL,NULL),(12433,12433,0,'SSS111226-125715-172401','CRTS-SSS',194.31162,-17.40015,NULL,NULL,'2011-12-26 00:00:00',55921,17.58,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/SSS/20111226/1112260170934109620.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20111226/jpg/1112260170934109620.master.jpg',NULL,NULL,44018934977,NULL,NULL,NULL,'2008-12-30 13:26:29',54830.560059,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1112260170934109620/1112260170934109620.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20111226/1112260170934109620p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,687795859,10746810,NULL,NULL,NULL,NULL),(12434,12434,1,'SSS111220-030051-384553','CRTS-SSS',45.21231,-38.76465,NULL,NULL,'2011-12-20 00:00:00',55915,17.98,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20111220/1112200390184218822.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20111220/jpg/1112200390184218822.master.jpg',NULL,NULL,38642948963,NULL,NULL,NULL,'2011-11-15 13:26:29',55880.560059,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1112200390184218822/1112200390184218822.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20111220/1112200390184218822p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,603796077,9434313,NULL,NULL,NULL,NULL),(12435,12435,1,'SSS111127-215934-263955','CRTS-SSS',329.89258,-26.66518,NULL,NULL,'2011-11-27 00:00:00',55892,17.14,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20111127/1111270271484126594.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20111127/jpg/1111270271484126594.master.jpg',NULL,NULL,51421367736,NULL,NULL,NULL,'2011-07-02 10:33:30',55744.439941,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1111270271484126594/1111270271484126594.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20111127/1111270271484126594p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,803458870,12554044,NULL,NULL,NULL,NULL),(12436,12436,1,'SSS111126-031430-290153','CRTS-SSS',48.62699,-29.03145,NULL,NULL,'2011-11-26 00:00:00',55891,19.04,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20111126/1111260290224115853.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20111126/jpg/1111260290224115853.master.jpg',NULL,NULL,38543689906,NULL,NULL,NULL,'2011-10-20 10:33:30',55854.439941,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1111260290224115853/1111260290224115853.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20111126/1111260290224115853p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,602245154,9410080,NULL,NULL,NULL,NULL),(12437,12437,0,'SSS110923-050143-152325','CRTS-SSS',75.42946,-15.3902,NULL,NULL,'2011-09-23 00:00:00',55827,18.12,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/SSS/20110923/1109230150374109691.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110923/jpg/1109230150374109691.master.jpg',NULL,NULL,37524412454,NULL,NULL,NULL,'2011-03-26 13:26:29',55646.560059,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1109230150374109691/1109230150374109691.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110923/1109230150374109691p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,586318944,9161233,NULL,NULL,NULL,NULL),(12438,12438,1,'SSS110831-013230-282528','CRTS-SSS',23.12292,-28.42438,NULL,NULL,'2011-08-31 00:00:00',55804,18.43,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110831/1108310290114118359.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110831/jpg/1108310290114118359.master.jpg',NULL,NULL,38258850702,NULL,NULL,NULL,'2008-08-26 13:26:29',54704.560059,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1108310290114118359/1108310290114118359.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110831/1108310290114118359p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,597794542,9340539,NULL,NULL,NULL,NULL),(12439,12439,1,'SSS110823-211631-360516','CRTS-SSS',319.12874,-36.08784,NULL,NULL,'2011-08-23 00:00:00',55796,19.59,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110823/1108230351324103446.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110823/jpg/1108230351324103446.master.jpg',NULL,NULL,51478710509,NULL,NULL,NULL,'2011-06-29 13:26:29',55741.560059,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1108230351324103446/1108230351324103446.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110823/1108230351324103446p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,804354851,12568044,NULL,NULL,NULL,NULL),(12441,12441,1,'SSS110425-113409-230538','CRTS-SSS',173.53579,-23.09379,NULL,NULL,'2011-04-25 00:00:00',55676,18.97,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110425/1104250230814115577.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110425/jpg/1104250230814115577.master.jpg',NULL,NULL,41683038344,NULL,NULL,NULL,'2011-02-11 13:26:29',55603.560059,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1104250230814115577/1104250230814115577.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110425/1104250230814115577p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,651297474,10176523,NULL,NULL,NULL,NULL),(12442,12442,0,'SSS110408-095830-105315','CRTS-SSS',149.62588,-10.88752,NULL,NULL,'2011-04-08 00:00:00',55659,18.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/SSS/20110408/1104080110744116779.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110408/jpg/1104080110744116779.master.jpg',NULL,NULL,41326993259,NULL,NULL,NULL,'2009-04-18 10:33:30',54939.439941,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1104080110744116779/1104080110744116779.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110408/1104080110744116779p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,645734269,10089597,NULL,NULL,NULL,NULL),(12443,12443,0,'SSS110313-121626-431922','CRTS-SSS',184.10957,-43.32264,NULL,NULL,'2011-03-13 00:00:00',55633,14.19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/SSS/20110313/1103130430684136364.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110313/jpg/1103130430684136364.master.jpg',NULL,NULL,46710082319,NULL,NULL,NULL,'2010-07-04 13:26:29',55381.560059,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1103130430684136364/1103130430684136364.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110313/1103130430684136364p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,729845036,11403828,NULL,NULL,NULL,NULL),(12444,12444,1,'SSS110127-021409-242102','CRTS-SSS',33.53607,-24.35045,NULL,NULL,'2011-01-27 00:00:00',55588,16.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110127/1101270250164117644.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110127/jpg/1101270250164117644.master.jpg',NULL,NULL,37924351099,NULL,NULL,NULL,'2010-08-29 13:26:29',55437.560059,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1101270250164117644/1101270250164117644.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110127/1101270250164117644p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,592567985,9258874,NULL,NULL,NULL,NULL),(12445,12445,0,'SSS101006-011615-303245','CRTS-SSS',19.06091,-30.54595,NULL,NULL,'2010-10-06 00:00:00',55475,18.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/SSS/20101006/1010060310094124072.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20101006/jpg/1010060310094124072.master.jpg',NULL,NULL,34737195392,NULL,NULL,NULL,'2009-12-05 13:26:29',55170.560059,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1010060310094124072/1010060310094124072.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20101006/1010060310094124072p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,542768678,8480760,NULL,NULL,NULL,NULL),(12447,12447,0,'SSS100515-224057-070306','CRTS-SSS',340.23704,-7.05178,NULL,NULL,'2010-05-15 00:00:00',55331,17.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/SSS/20100515/1005150071694110062.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20100515/jpg/1005150071694110062.master.jpg',NULL,NULL,50395380439,NULL,NULL,NULL,'2009-10-09 13:26:29',55113.560059,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1005150071694110062/1005150071694110062.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20100515/1005150071694110062p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,787427819,12303559,NULL,NULL,NULL,NULL),(12448,12448,0,'SSS100508-210144-143830','CRTS-SSS',315.43377,-14.6418,NULL,NULL,'2010-05-08 00:00:00',55324,16.42,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:55','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/SSS/20100508/1005080151534122262.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20100508/jpg/1005080151534122262.master.jpg',NULL,NULL,50990030722,NULL,NULL,NULL,'2009-10-20 13:26:29',55124.560059,'2013-01-19 01:32:55','http://crts.caltech.edu/ATEL/SSS/1005080151534122262/1005080151534122262.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20100508/1005080151534122262p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,796719230,12448737,NULL,NULL,NULL,NULL),(12449,12449,1,'SSS130103-082255-191734','CRTS-SSS',125.72938,-19.29282,NULL,NULL,'2013-01-03 00:00:00',56295,17.72,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20130103/1301030190604126081.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20130103/jpg/1301030190604126081.master.jpg',NULL,NULL,42276580723,NULL,NULL,NULL,'2012-11-18 13:26:29',56249.560059,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1301030190604126081/1301030190604126081.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20130103/1301030190604126081p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,660571573,10321430,NULL,NULL,NULL,NULL),(12450,12450,1,'SSS121220-064922-331837','CRTS-SSS',102.34233,-33.31041,NULL,NULL,'2012-12-20 00:00:00',56281,17.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20121220/1212200330434127069.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20121220/jpg/1212200330434127069.master.jpg',NULL,NULL,39174735558,NULL,NULL,NULL,'2012-11-12 10:33:30',56243.439941,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1212200330434127069/1212200330434127069.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20121220/1212200330434127069p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,612105243,9564144,NULL,NULL,NULL,NULL),(12452,12452,1,'SSS121015-224255-372531','CRTS-SSS',340.72914,-37.42537,NULL,NULL,'2012-10-15 00:00:00',56215,19.16,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20121015/1210150371374111688.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20121015/jpg/1210150371374111688.master.jpg',NULL,NULL,50715637708,NULL,NULL,NULL,'2007-07-15 10:33:30',54296.439941,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1210150371374111688/1210150371374111688.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20121015/1210150371374111688p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,792431839,12381747,NULL,NULL,NULL,NULL),(12454,12454,1,'SSS120912-152107-231503','CRTS-SSS',230.28014,-23.25076,NULL,NULL,'2012-09-12 00:00:00',56182,18.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120912/1209120231074123333.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120912/jpg/1209120231074123333.master.jpg',NULL,NULL,46623336644,NULL,NULL,NULL,'2008-08-28 13:26:29',54706.560059,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1209120231074123333/1209120231074123333.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120912/1209120231074123333p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,728489635,11382650,NULL,NULL,NULL,NULL),(12455,12455,1,'SSS120908-160947-221415','CRTS-SSS',242.44585,-22.23757,NULL,NULL,'2012-09-08 00:00:00',56178,17.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120908/1209080231124175893.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120908/jpg/1209080231124175893.master.jpg',NULL,NULL,45436281655,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1209080231124175893/1209080231124175893.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120908/1209080231124175893p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,709941900,11092842,NULL,NULL,NULL,NULL),(12456,12456,1,'SSS120826-193017-495348','CRTS-SSS',292.56952,-49.89676,NULL,NULL,'2012-08-26 00:00:00',56165,17.03,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120826/1208260490974110681.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120826/jpg/1208260490974110681.master.jpg',NULL,NULL,51239279641,NULL,NULL,NULL,'2012-07-23 13:26:29',56131.560059,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1208260490974110681/1208260490974110681.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120826/1208260490974110681p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,800613744,12509589,NULL,NULL,NULL,NULL),(12457,12457,1,'SSS120814-225830-230345','CRTS-SSS',344.62615,-23.0624,NULL,NULL,'2012-08-14 00:00:00',56153,14.08,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120814/1208140231594115593.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120814/jpg/1208140231594115593.master.jpg',NULL,NULL,50218292144,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1208140231594115593/1208140231594115593.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120814/1208140231594115593p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,784660814,12260325,NULL,NULL,NULL,NULL),(12458,12458,1,'SSS120813-205906-280650','CRTS-SSS',314.773,-28.11389,NULL,NULL,'2012-08-13 00:00:00',56152,18.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120813/1208130271414102017.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120813/jpg/1208130271414102017.master.jpg',NULL,NULL,51492591398,NULL,NULL,NULL,'2005-08-24 13:26:23',53606.559998,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1208130271414102017/1208130271414102017.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120813/1208130271414102017p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,804571740,12571433,NULL,NULL,NULL,NULL),(12460,12460,1,'SSS120810-141755-383632','CRTS-SSS',214.48071,-38.60902,NULL,NULL,'2012-08-10 00:00:00',56149,17.3,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120810/1208100390854168373.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120810/jpg/1208100390854168373.master.jpg',NULL,NULL,46993432493,NULL,NULL,NULL,'2007-03-22 13:26:23',54181.559998,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1208100390854168373/1208100390854168373.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120810/1208100390854168373p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,734272382,11473005,NULL,NULL,NULL,NULL),(12461,12461,1,'SSS120809-144254-271653','CRTS-SSS',220.72482,-27.28134,NULL,NULL,'2012-08-09 00:00:00',56148,18.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120809/1208090270994122268.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120809/jpg/1208090270994122268.master.jpg',NULL,NULL,47025721611,NULL,NULL,NULL,'2011-09-06 10:33:30',55810.439941,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1208090270994122268/1208090270994122268.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120809/1208090270994122268p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,734776900,11480889,NULL,NULL,NULL,NULL),(12462,12462,1,'SSS120725-203513-541256','CRTS-SSS',308.80568,-54.21544,NULL,NULL,'2012-07-25 00:00:00',56133,18.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120725/1207250530944105074.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120725/jpg/1207250530944105074.master.jpg',NULL,NULL,51083495567,NULL,NULL,NULL,'2009-08-15 12:28:49',55058.52002,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1207250530944105074/1207250530944105074.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120725/1207250530944105074p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,798179618,12471556,NULL,NULL,NULL,NULL),(12463,12463,1,'SSS120707-124109-424254','CRTS-SSS',190.28895,-42.71507,NULL,NULL,'2012-07-07 00:00:00',56115,16.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120707/1207070430704152302.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120707/jpg/1207070430704152302.master.jpg',NULL,NULL,46765557283,NULL,NULL,NULL,'2012-05-28 13:26:29',56075.560059,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1207070430704152302/1207070430704152302.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120707/1207070430704152302p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,730711832,11417372,NULL,NULL,NULL,NULL),(12464,12464,1,'SSS120614-112125-211158','CRTS-SSS',170.35587,-21.19955,NULL,NULL,'2012-06-14 00:00:00',56092,19.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120614/1206140210804111908.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120614/jpg/1206140210804111908.master.jpg',NULL,NULL,41720887439,NULL,NULL,NULL,'2011-04-04 12:28:49',55655.52002,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1206140210804111908/1206140210804111908.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120614/1206140210804111908p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,651888866,10185763,NULL,NULL,NULL,NULL),(12465,12465,1,'SSS120522-135600-450247','CRTS-SSS',208.99871,-45.0465,NULL,NULL,'2012-05-22 00:00:00',56069,18.42,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120522/1205220450754169661.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120522/jpg/1205220450754169661.master.jpg',NULL,NULL,46796618413,NULL,NULL,NULL,'2006-06-03 13:26:23',53889.559998,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1205220450754169661/1205220450754169661.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120522/1205220450754169661p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,731197162,11424955,NULL,NULL,NULL,NULL),(12466,12466,0,'SSS120519-112355-115630','CRTS-SSS',170.97914,-11.94162,NULL,NULL,'2012-05-19 00:00:00',56066,17.52,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-12-24 20:38:21','http://nesssi.cacr.caltech.edu/SSS/20120519/1205190110844102046.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120519/jpg/1205190110844102046.master.jpg',NULL,NULL,40972229894,NULL,NULL,NULL,'2007-05-23 13:26:23',54243.559998,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1205190110844102046/1205190110844102046.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120519/1205190110844102046p.html',NULL,NULL,0,'AGN',NULL,0,NULL,0,640191092,10002985,NULL,NULL,NULL,NULL),(12467,12467,1,'SSS120425-103654-420407','CRTS-SSS',159.22598,-42.06859,NULL,NULL,'2012-04-25 00:00:00',56042,15.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120425/1204250410614110164.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120425/jpg/1204250410614110164.master.jpg',NULL,NULL,42129584551,NULL,NULL,NULL,'2012-03-23 13:26:29',56009.560059,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1204250410614110164/1204250410614110164.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120425/1204250410614110164p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,658274758,10285543,NULL,NULL,NULL,NULL),(12468,12468,1,'SSS120411-103035-315419','CRTS-SSS',157.644,-31.9052,NULL,NULL,'2012-04-11 00:00:00',56028,18.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120411/1204110310684106867.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120411/jpg/1204110310684106867.master.jpg',NULL,NULL,42001190863,NULL,NULL,NULL,'2007-04-05 10:33:36',54195.440002,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1204110310684106867/1204110310684106867.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120411/1204110310684106867p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,656268607,10254196,NULL,NULL,NULL,NULL),(12469,12469,1,'SSS120411-143202-293605','CRTS-SSS',218.00982,-29.60129,NULL,NULL,'2012-04-11 00:00:00',56028,19.02,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:56','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120411/1204110290964113646.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120411/jpg/1204110290964113646.master.jpg',NULL,NULL,47027776440,NULL,NULL,NULL,'2007-07-04 13:26:29',54285.560059,'2013-01-19 01:32:56','http://crts.caltech.edu/ATEL/SSS/1204110290964113646/1204110290964113646.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120411/1204110290964113646p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,734809006,11481390,NULL,NULL,NULL,NULL),(12470,12470,0,'SSS120216-092242-385744','CRTS-SSS',140.67639,-38.96232,NULL,NULL,'2012-02-16 00:00:00',55973,17.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-12-24 20:38:21','http://nesssi.cacr.caltech.edu/SSS/20120216/1202160390564171807.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120216/jpg/1202160390564171807.master.jpg',NULL,NULL,42897239457,NULL,NULL,NULL,'2012-01-11 13:26:29',55937.560059,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1202160390564171807/1202160390564171807.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120216/1202160390564171807p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,670269366,10472958,NULL,NULL,NULL,NULL),(12471,12471,1,'SSS120216-135528-312918','CRTS-SSS',208.86738,-31.48836,NULL,NULL,'2012-02-16 00:00:00',55973,17.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120216/1202160310904117259.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120216/jpg/1202160310904117259.master.jpg',NULL,NULL,46851255600,NULL,NULL,NULL,'2011-08-26 13:26:29',55799.560059,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1202160310904117259/1202160310904117259.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120216/1202160310904117259p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,732050868,11438294,NULL,NULL,NULL,NULL),(12472,12472,0,'SSS111126-203355-192925','CRTS-SSS',308.47972,-19.49034,NULL,NULL,'2011-11-26 00:00:00',55891,18.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-12-24 20:38:21','http://nesssi.cacr.caltech.edu/SSS/20111126/1111260191464112351.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20111126/jpg/1111260191464112351.master.jpg',NULL,NULL,50855678001,NULL,NULL,NULL,'2005-08-27 13:26:23',53609.559998,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1111260191464112351/1111260191464112351.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20111126/1111260191464112351p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,794619968,12415937,NULL,NULL,NULL,NULL),(12473,12473,1,'SSS110920-220224-312901','CRTS-SSS',330.60072,-31.48355,NULL,NULL,'2011-09-20 00:00:00',55824,19.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110920/1109200311434109476.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110920/jpg/1109200311434109476.master.jpg',NULL,NULL,50537394003,NULL,NULL,NULL,'2011-07-29 13:26:29',55771.560059,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1109200311434109476/1109200311434109476.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110920/1109200311434109476p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,789646781,12338230,NULL,NULL,NULL,NULL),(12474,12474,1,'SSS110828-205323-113130','CRTS-SSS',313.34514,-11.52503,NULL,NULL,'2011-08-28 00:00:00',55801,19.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110828/1108280111544111649.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110828/jpg/1108280111544111649.master.jpg',NULL,NULL,50759074577,NULL,NULL,NULL,'2009-05-11 13:26:29',54962.560059,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1108280111544111649/1108280111544111649.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110828/1108280111544111649p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,793110540,12392352,NULL,NULL,NULL,NULL),(12475,12475,0,'SSS110826-201029-144436','CRTS-SSS',302.62205,-14.74329,NULL,NULL,'2011-08-26 00:00:00',55799,18.78,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-12-24 20:38:21','http://nesssi.cacr.caltech.edu/SSS/20110826/1108260151474137475.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110826/jpg/1108260151474137475.master.jpg',NULL,NULL,47948993600,NULL,NULL,NULL,'2007-10-02 13:26:29',54375.560059,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1108260151474137475/1108260151474137475.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110826/1108260151474137475p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,749203025,11706297,NULL,NULL,NULL,NULL),(12476,12476,1,'SSS110723-230819-314824','CRTS-SSS',347.07752,-31.80663,NULL,NULL,'2011-07-23 00:00:00',55765,18.42,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110723/1107230311504105438.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110723/jpg/1107230311504105438.master.jpg',NULL,NULL,50158883885,NULL,NULL,NULL,'2008-05-31 10:33:30',54617.439941,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1107230311504105438/1107230311504105438.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110723/1107230311504105438p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,783732560,12245821,NULL,NULL,NULL,NULL),(12477,12477,1,'SSS110721-153717-141124','CRTS-SSS',234.31923,-14.19009,NULL,NULL,'2011-07-21 00:00:00',55763,18.19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110721/1107210151144142635.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110721/jpg/1107210151144142635.master.jpg',NULL,NULL,46593912021,NULL,NULL,NULL,'2011-05-15 13:26:29',55696.560059,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1107210151144142635/1107210151144142635.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110721/1107210151144142635p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,728029875,11375466,NULL,NULL,NULL,NULL),(12478,12478,1,'SSS110626-234126-314903','CRTS-SSS',355.35761,-31.81748,NULL,NULL,'2011-06-26 00:00:00',55738,19.44,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110626/1106260311544105461.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110626/jpg/1106260311544105461.master.jpg',NULL,NULL,50179020089,NULL,NULL,NULL,'2006-05-22 10:33:36',53877.440002,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1106260311544105461/1106260311544105461.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110626/1106260311544105461p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,784047188,12250737,NULL,NULL,NULL,NULL),(12480,12480,1,'SSS110526-204247-604523','CRTS-SSS',310.69686,-60.75643,NULL,NULL,'2011-05-26 00:00:00',55707,17.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110526/1105260610764132463.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110526/jpg/1105260610764132463.master.jpg',NULL,NULL,49184482497,NULL,NULL,NULL,'2005-07-18 13:26:23',53569.559998,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1105260610764132463/1105260610764132463.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110526/1105260610764132463p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,768507539,12007930,NULL,NULL,NULL,NULL),(12481,12481,1,'SSS110504-150155-400823','CRTS-SSS',225.47813,-40.1396,NULL,NULL,'2011-05-04 00:00:00',55685,17.52,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110504/1105040390894109135.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110504/jpg/1105040390894109135.master.jpg',NULL,NULL,47185971515,NULL,NULL,NULL,'2011-04-04 13:26:29',55655.560059,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1105040390894109135/1105040390894109135.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110504/1105040390894109135p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,737280804,11520012,NULL,NULL,NULL,NULL),(12482,12482,1,'SSS110429-182618-645337','CRTS-SSS',276.57649,-64.89352,NULL,NULL,'2011-04-29 00:00:00',55680,17.26,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110429/1104290650604139397.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110429/jpg/1104290650604139397.master.jpg',NULL,NULL,48935558197,NULL,NULL,NULL,'2011-04-03 13:26:29',55654.560059,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1104290650604139397/1104290650604139397.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110429/1104290650604139397p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,764618096,11947157,NULL,NULL,NULL,NULL),(12483,12483,1,'SSS110424-061226-205601','CRTS-SSS',93.10903,-20.93366,NULL,NULL,'2011-04-24 00:00:00',55675,18.4,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110424/1104240210444128021.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110424/jpg/1104240210444128021.master.jpg',NULL,NULL,39596952717,NULL,NULL,NULL,'2011-03-24 13:26:29',55644.560059,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1104240210444128021/1104240210444128021.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110424/1104240210444128021p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,618702386,9667224,NULL,NULL,NULL,NULL),(12484,12484,1,'SSS110423-122926-363936','CRTS-SSS',187.35691,-36.65993,NULL,NULL,'2011-04-23 00:00:00',55674,18.03,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110423/1104230370754146621.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110423/jpg/1104230370754146621.master.jpg',NULL,NULL,43271001027,NULL,NULL,NULL,'2005-12-25 13:26:23',53729.559998,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1104230370754146621/1104230370754146621.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110423/1104230370754146621p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,676109391,10564209,NULL,NULL,NULL,NULL),(12485,12485,1,'SSS110405-114137-272653','CRTS-SSS',175.40584,-27.44816,NULL,NULL,'2011-04-05 00:00:00',55656,19.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110405/1104050270794112679.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110405/jpg/1104050270794112679.master.jpg',NULL,NULL,41471934175,NULL,NULL,NULL,'2006-01-03 10:33:36',53738.440002,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1104050270794112679/1104050270794112679.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110405/1104050270794112679p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,647998971,10124983,NULL,NULL,NULL,NULL),(12486,12486,1,'SSS110314-102233-394343','CRTS-SSS',155.63738,-39.72864,NULL,NULL,'2011-03-14 00:00:00',55634,16.97,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110314/1103140390614116481.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110314/jpg/1103140390614116481.master.jpg',NULL,NULL,42132063275,NULL,NULL,NULL,'2011-01-25 13:26:29',55586.560059,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1103140390614116481/1103140390614116481.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110314/1103140390614116481p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,658313488,10286148,NULL,NULL,NULL,NULL),(12487,12487,1,'SSS110312-084128-231726','CRTS-SSS',130.36655,-23.29042,NULL,NULL,'2011-03-12 00:00:00',55632,16.98,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110312/1103120230614231857.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110312/jpg/1103120230614231857.master.jpg',NULL,NULL,42244897536,NULL,NULL,NULL,'2011-02-10 13:26:29',55602.560059,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1103120230614231857/1103120230614231857.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110312/1103120230614231857p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,660076524,10313695,NULL,NULL,NULL,NULL),(12488,12488,1,'SSS110131-124435-312441','CRTS-SSS',191.14533,-31.41138,NULL,NULL,'2011-01-31 00:00:00',55592,18.64,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110131/1101310310834117008.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110131/jpg/1101310310834117008.master.jpg',NULL,NULL,43476933333,NULL,NULL,NULL,'2010-07-20 13:26:29',55397.560059,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1101310310834117008/1101310310834117008.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110131/1101310310834117008p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,679327083,10614485,NULL,NULL,NULL,NULL),(12489,12489,0,'SSS110106-053121-201940','CRTS-SSS',82.83803,-20.32784,NULL,NULL,'2011-01-06 00:00:00',55567,16.74,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:57','2019-12-24 20:38:21','http://nesssi.cacr.caltech.edu/SSS/20110106/1101060210394131820.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110106/jpg/1101060210394131820.master.jpg',NULL,NULL,37435606332,NULL,NULL,NULL,'2005-08-16 10:33:36',53598.440002,'2013-01-19 01:32:57','http://crts.caltech.edu/ATEL/SSS/1101060210394131820/1101060210394131820.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110106/1101060210394131820p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,584931348,9139552,NULL,NULL,NULL,NULL),(12490,12490,0,'SSS101124-215637-632655','CRTS-SSS',329.15518,-63.44868,NULL,NULL,'2010-11-24 00:00:00',55524,16.59,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 20:38:49','http://nesssi.cacr.caltech.edu/SSS/20101124/1011240630764115180.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20101124/jpg/1011240630764115180.master.jpg',NULL,NULL,49342107597,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1011240630764115180/1011240630764115180.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20101124/1011240630764115180p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,770970431,12046412,NULL,NULL,NULL,NULL),(12491,12491,1,'SSS100813-233535-143730','CRTS-SSS',353.89749,-14.62495,NULL,NULL,'2010-08-13 00:00:00',55421,19.24,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20100813/1008130151724117806.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20100813/jpg/1008130151724117806.master.jpg',NULL,NULL,49565319780,NULL,NULL,NULL,'2006-05-18 13:26:23',53873.559998,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1008130151724117806/1008130151724117806.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20100813/1008130151724117806p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,774458121,12100908,NULL,NULL,NULL,NULL),(12492,12492,1,'SSS100717-213356-273140','CRTS-SSS',323.48159,-27.52784,NULL,NULL,'2010-07-17 00:00:00',55394,18.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20100717/1007170271454110069.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20100717/jpg/1007170271454110069.master.jpg',NULL,NULL,51465937175,NULL,NULL,NULL,'2010-05-14 11:31:10',55330.47998,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1007170271454110069/1007170271454110069.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20100717/1007170271454110069p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,804155268,12564926,NULL,NULL,NULL,NULL),(12493,12493,1,'SSS100704-193244-355606','CRTS-SSS',293.18237,-35.93487,NULL,NULL,'2010-07-04 00:00:00',55381,18.96,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20100704/1007040351214111969.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20100704/jpg/1007040351214111969.master.jpg',NULL,NULL,51161598034,NULL,NULL,NULL,'2005-07-05 13:26:23',53556.559998,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1007040351214111969/1007040351214111969.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20100704/1007040351214111969p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,799399969,12490624,NULL,NULL,NULL,NULL),(12494,12494,1,'SSS100607-221150-110360','CRTS-SSS',332.95816,-11.06663,NULL,NULL,'2010-06-07 00:00:00',55354,18.98,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20100607/1006070111634111815.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20100607/jpg/1006070111634111815.master.jpg',NULL,NULL,49864749777,NULL,NULL,NULL,'2010-05-08 11:31:10',55324.47998,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1006070111634111815/1006070111634111815.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20100607/1006070111634111815p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,779136715,12174011,NULL,NULL,NULL,NULL),(12495,12495,1,'SSS100604-122333-350645','CRTS-SSS',185.88814,-35.11257,NULL,NULL,'2010-06-04 00:00:00',55351,16.26,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20100604/1006040350774119232.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20100604/jpg/1006040350774119232.master.jpg',NULL,NULL,43260894597,NULL,NULL,NULL,'2010-05-10 10:33:30',55326.439941,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1006040350774119232/1006040350774119232.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20100604/1006040350774119232p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,675951478,10561741,NULL,NULL,NULL,NULL),(12496,12496,1,'SSS100511-100208-284015','CRTS-SSS',150.53423,-28.67076,NULL,NULL,'2010-05-11 00:00:00',55327,17.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20100511/1005110290674127837.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20100511/jpg/1005110290674127837.master.jpg',NULL,NULL,42825892570,NULL,NULL,NULL,'2007-02-09 11:31:10',54140.47998,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1005110290674127837/1005110290674127837.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20100511/1005110290674127837p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,669154571,10455540,NULL,NULL,NULL,NULL),(12497,12497,1,'SSS100505-094339-184143','CRTS-SSS',145.9145,-18.69526,NULL,NULL,'2010-05-05 00:00:00',55321,16.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20100505/1005050190694120811.html','SN/CV?',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20100505/jpg/1005050190694120811.master.jpg',NULL,NULL,42338923672,NULL,NULL,NULL,'2010-03-15 13:26:29',55270.560059,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1005050190694120811/1005050190694120811.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20100505/1005050190694120811p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,661545682,10336651,NULL,NULL,NULL,NULL),(12498,12498,1,'SSS121218-033126-643911','CRTS-SSS',52.85851,-64.65293,NULL,NULL,'2012-12-18 00:00:00',56279,14.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20121218/1212180650124226603.html','HPM 2MASS_J033125      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20121218/jpg/1212180650124226603.master.jpg',NULL,NULL,36471993908,NULL,NULL,NULL,'2008-03-01 13:26:29',54526.560059,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1212180650124226603/1212180650124226603.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20121218/1212180650124226603p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,569874904,8904295,NULL,NULL,NULL,NULL),(12499,12499,1,'SSS121218-034259-640808','CRTS-SSS',55.74435,-64.13545,NULL,NULL,'2012-12-18 00:00:00',56279,14.38,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20121218/1212180630134205931.html','HPM 2MASS_J034257      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20121218/jpg/1212180630134205931.master.jpg',NULL,NULL,36458911733,NULL,NULL,NULL,'2009-12-23 13:26:29',55188.560059,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1212180630134205931/1212180630134205931.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20121218/1212180630134205931p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,569670495,8901101,NULL,NULL,NULL,NULL),(12500,12500,1,'SSS121210-041027-533640','CRTS-SSS',62.61194,-53.61109,NULL,NULL,'2012-12-10 00:00:00',56271,11.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20121210/1212100530194109896.html','HPM LHS_22      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20121210/jpg/1212100530194109896.master.jpg',NULL,NULL,35809850071,NULL,NULL,NULL,'2011-01-30 13:26:29',55591.560059,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1212100530194109896/1212100530194109896.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20121210/1212100530194109896p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,559528907,8742639,NULL,NULL,NULL,NULL),(12501,12501,1,'SSS121119-042337-175143','CRTS-SSS',65.90608,-17.86206,NULL,NULL,'2012-11-19 00:00:00',56250,20.11,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20121119/1211190170324103247.html','Unknown mag 20,5     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20121119/jpg/1211190170324103247.master.jpg',NULL,NULL,37350567105,NULL,NULL,NULL,'2009-01-27 11:31:10',54858.47998,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1211190170324103247/1211190170324103247.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20121119/1211190170324103247p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,583602611,9118790,NULL,NULL,NULL,NULL),(12502,12502,1,'SSS121118-010739-185416','CRTS-SSS',16.91423,-18.90444,NULL,NULL,'2012-11-18 00:00:00',56249,19.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20121118/1211180190084113461.html','Unknown mag 20,5     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20121118/jpg/1211180190084113461.master.jpg',NULL,NULL,35391509379,NULL,NULL,NULL,'2009-07-19 10:33:30',55031.439941,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1211180190084113461/1211180190084113461.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20121118/1211180190084113461p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,552992334,8640505,NULL,NULL,NULL,NULL),(12503,12503,1,'SSS121024-032214-625918','CRTS-SSS',50.55849,-62.98841,NULL,NULL,'2012-10-24 00:00:00',56224,13.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20121024/1210240630124121009.html','HPM 2MASS_J032213      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20121024/jpg/1210240630124121009.master.jpg',NULL,NULL,36284131023,NULL,NULL,NULL,'2008-03-01 13:26:29',54526.560059,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1210240630124121009/1210240630124121009.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20121024/1210240630124121009p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,566939547,8858430,NULL,NULL,NULL,NULL),(12504,12504,1,'SSS120907-212318-611513','CRTS-SSS',320.82378,-61.25372,NULL,NULL,'2012-09-07 00:00:00',56177,12.92,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120907/1209070610794116740.html','HPM LHS_3663      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120907/jpg/1209070610794116740.master.jpg',NULL,NULL,49163472693,NULL,NULL,NULL,'2008-10-30 13:26:29',54769.560059,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1209070610794116740/1209070610794116740.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120907/1209070610794116740p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,768179260,12002800,NULL,NULL,NULL,NULL),(12505,12505,1,'SSS120907-210145-543736','CRTS-SSS',315.43637,-54.62669,NULL,NULL,'2012-09-07 00:00:00',56177,15.06,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120907/1209070550924127062.html','HPM 2MASS_J210145      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120907/jpg/1209070550924127062.master.jpg',NULL,NULL,50600142142,NULL,NULL,NULL,'2008-09-02 13:26:29',54711.560059,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1209070550924127062/1209070550924127062.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120907/1209070550924127062p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,790627220,12353550,NULL,NULL,NULL,NULL),(12507,12507,1,'SSS120903-005712-675609','CRTS-SSS',14.30118,-67.93572,NULL,NULL,'2012-09-03 00:00:00',56173,12.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120903/1209030670034109462.html','HPM LTT546      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120903/jpg/1209030670034109462.master.jpg',NULL,NULL,36317189780,NULL,NULL,NULL,'2006-11-16 13:26:23',54055.559998,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1209030670034109462/1209030670034109462.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120903/1209030670034109462p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,567456090,8866501,NULL,NULL,NULL,NULL),(12508,12508,1,'SSS120827-030934-135434','CRTS-SSS',47.38994,-13.90934,NULL,NULL,'2012-08-27 00:00:00',56166,17.67,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120827/1208270130244102523.html','HPM       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120827/jpg/1208270130244102523.master.jpg',NULL,NULL,38074980882,NULL,NULL,NULL,'2007-03-09 13:26:23',54168.559998,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1208270130244102523/1208270130244102523.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120827/1208270130244102523p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,594921576,9295649,NULL,NULL,NULL,NULL),(12509,12509,1,'SSS120826-023954-343837','CRTS-SSS',39.9758,-34.64354,NULL,NULL,'2012-08-26 00:00:00',56165,16.78,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120826/1208260350174121049.html','LPV 2MASS_J023954      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120826/jpg/1208260350174121049.master.jpg',NULL,NULL,38633075264,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:58','http://crts.caltech.edu/ATEL/SSS/1208260350174121049/1208260350174121049.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120826/1208260350174121049p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,603641801,9431903,NULL,NULL,NULL,NULL),(12510,12510,1,'SSS120814-221925-282323','CRTS-SSS',334.85221,-28.38984,NULL,NULL,'2012-08-14 00:00:00',56153,13.34,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120814/1208140291474131439.html','HPM LHS_3793      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120814/jpg/1208140291474131439.master.jpg',NULL,NULL,50547265948,NULL,NULL,NULL,'2007-12-10 13:26:29',54444.560059,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1208140291474131439/1208140291474131439.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120814/1208140291474131439p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,789801030,12340641,NULL,NULL,NULL,NULL),(12511,12511,1,'SSS120813-122355-275743','CRTS-SSS',185.97891,-27.96183,NULL,NULL,'2012-08-13 00:00:00',56152,15.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120813/1208130270844104263.html','HPM LHS_325a      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120813/jpg/1208130270844104263.master.jpg',NULL,NULL,43406618327,NULL,NULL,NULL,'2009-12-20 12:28:49',55185.52002,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1208130270844104263/1208130270844104263.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120813/1208130270844104263p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,678228411,10597318,NULL,NULL,NULL,NULL),(12512,12512,1,'SSS120810-225747-653725','CRTS-SSS',344.44746,-65.62363,NULL,NULL,'2012-08-10 00:00:00',56149,13.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120810/1208100650744113469.html','HPM       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120810/jpg/1208100650744113469.master.jpg',NULL,NULL,48758998340,NULL,NULL,NULL,'2009-09-28 13:26:29',55102.560059,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1208100650744113469/1208100650744113469.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120810/1208100650744113469p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,761859349,11904052,NULL,NULL,NULL,NULL),(12513,12513,1,'SSS120809-184207-555427','CRTS-SSS',280.52896,-55.90744,NULL,NULL,'2012-08-09 00:00:00',56148,12.34,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120809/1208090550824125941.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120809/jpg/1208090550824125941.master.jpg',NULL,NULL,49101988263,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1208090550824125941/1208090550824125941.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120809/1208090550824125941p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,767218566,11987790,NULL,NULL,NULL,NULL),(12514,12514,1,'SSS120721-200606-313353','CRTS-SSS',301.52459,-31.56459,NULL,NULL,'2012-07-21 00:00:00',56129,15.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120721/1207210311304119409.html','HPM LHS_3520      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120721/jpg/1207210311304119409.master.jpg',NULL,NULL,51330712822,NULL,NULL,NULL,'2007-11-13 13:26:29',54417.560059,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1207210311304119409/1207210311304119409.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120721/1207210311304119409p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,802042387,12531912,NULL,NULL,NULL,NULL),(12516,12516,0,'SSS120620-175123-605942','CRTS-SSS',267.84523,-60.99498,NULL,NULL,'2012-06-20 00:00:00',56098,18.43,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-12-24 20:38:21','http://nesssi.cacr.caltech.edu/SSS/20120620/1206200610664184016.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120620/jpg/1206200610664184016.master.jpg',NULL,NULL,44454737044,NULL,NULL,NULL,'2012-05-17 13:26:29',56064.560059,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1206200610664184016/1206200610664184016.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120620/1206200610664184016p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,694605266,10853207,NULL,NULL,NULL,NULL),(12517,12517,1,'SSS120610-232022-710537','CRTS-SSS',350.09237,-71.09372,NULL,NULL,'2012-06-10 00:00:00',56088,13.08,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120610/1206100710594121222.html','HPM LHS_3934      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120610/jpg/1206100710594121222.master.jpg',NULL,NULL,48392564040,NULL,NULL,NULL,'2009-07-09 12:28:49',55021.52002,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1206100710594121222/1206100710594121222.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120610/1206100710594121222p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,756133813,11814590,NULL,NULL,NULL,NULL),(12518,12518,1,'SSS120610-231939-645857','CRTS-SSS',349.91197,-64.9825,NULL,NULL,'2012-06-10 00:00:00',56088,14.55,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120610/1206100650754121333.html','HPM 2MASS_J231938      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120610/jpg/1206100650754121333.master.jpg',NULL,NULL,48731845676,NULL,NULL,NULL,'2007-12-30 13:26:29',54464.560059,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1206100650754121333/1206100650754121333.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120610/1206100650754121333p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,761435088,11897423,NULL,NULL,NULL,NULL),(12519,12519,1,'SSS120529-220947-562145','CRTS-SSS',332.44692,-56.36244,NULL,NULL,'2012-05-29 00:00:00',56076,14.4,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120529/1205290550974101509.html','HPM 2MASS_J220946      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120529/jpg/1205290550974101509.master.jpg',NULL,NULL,48705504599,NULL,NULL,NULL,'2006-11-18 13:26:23',54057.559998,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1205290550974101509/1205290550974101509.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120529/1205290550974101509p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,761023509,11890992,NULL,NULL,NULL,NULL),(12520,12520,1,'SSS120529-125450-502034','CRTS-SSS',193.71037,-50.34278,NULL,NULL,'2012-05-29 00:00:00',56076,14.71,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120529/1205290490654103603.html','HPM 2MASS_J125450      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120529/jpg/1205290490654103603.master.jpg',NULL,NULL,46734145276,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1205290490654103603/1205290490654103603.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120529/1205290490654103603p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,730221019,11409703,NULL,NULL,NULL,NULL),(12521,12521,1,'SSS120529-130529-440036','CRTS-SSS',196.37156,-44.00993,NULL,NULL,'2012-05-29 00:00:00',56076,12.55,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120529/1205290430734113379.html','LPV? mag 12,8     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120529/jpg/1205290430734113379.master.jpg',NULL,NULL,46758282841,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1205290430734113379/1205290430734113379.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120529/1205290430734113379p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,730598169,11415596,NULL,NULL,NULL,NULL),(12522,12522,1,'SSS120527-224611-690548','CRTS-SSS',341.54702,-69.09655,NULL,NULL,'2012-05-27 00:00:00',56074,14.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120527/1205270690634121325.html','HPM 2MASS_J224610      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120527/jpg/1205270690634121325.master.jpg',NULL,NULL,49321003735,NULL,NULL,NULL,'2007-10-21 13:26:29',54394.560059,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1205270690634121325/1205270690634121325.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120527/1205270690634121325p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,770640683,12041260,NULL,NULL,NULL,NULL),(12523,12523,1,'SSS120527-220409-695541','CRTS-SSS',331.03859,-69.92805,NULL,NULL,'2012-05-27 00:00:00',56074,12.62,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120527/1205270690614110243.html','HPM LHS_3751      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120527/jpg/1205270690614110243.master.jpg',NULL,NULL,49309876393,NULL,NULL,NULL,'2009-09-29 13:26:29',55103.560059,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1205270690614110243/1205270690614110243.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120527/1205270690614110243p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,770466818,12038544,NULL,NULL,NULL,NULL),(12524,12524,1,'SSS120527-222138-654731','CRTS-SSS',335.41004,-65.79185,NULL,NULL,'2012-05-27 00:00:00',56074,14.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120527/1205270650724110726.html','HPM 2MASS_J222136      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120527/jpg/1205270650724110726.master.jpg',NULL,NULL,49291319890,NULL,NULL,NULL,'2009-08-20 13:26:29',55063.560059,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1205270650724110726/1205270650724110726.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120527/1205270650724110726p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,770176873,12034013,NULL,NULL,NULL,NULL),(12525,12525,1,'SSS120527-210903-605743','CRTS-SSS',317.26291,-60.96194,NULL,NULL,'2012-05-27 00:00:00',56074,13.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120527/1205270610784126432.html','HPM       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120527/jpg/1205270610784126432.master.jpg',NULL,NULL,49189163879,NULL,NULL,NULL,'2006-10-01 13:26:23',54009.559998,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1205270610784126432/1205270610784126432.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120527/1205270610784126432p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,768580685,12009073,NULL,NULL,NULL,NULL),(12526,12526,1,'SSS120527-122341-481238','CRTS-SSS',185.92033,-48.21067,NULL,NULL,'2012-05-27 00:00:00',56074,12.38,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120527/1205270470654109018.html','HPM 2MASS_J122341      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120527/jpg/1205270470654109018.master.jpg',NULL,NULL,44570385532,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1205270470654109018/1205270470654109018.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120527/1205270470654109018p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,696412273,10881441,NULL,NULL,NULL,NULL),(12527,12527,1,'SSS120523-120850-450753','CRTS-SSS',182.20895,-45.13149,NULL,NULL,'2012-05-23 00:00:00',56070,12.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120523/1205230450654147430.html','Mira V389_Cen      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120523/jpg/1205230450654147430.master.jpg',NULL,NULL,46711585166,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1205230450654147430/1205230450654147430.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120523/1205230450654147430p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,729868518,11404195,NULL,NULL,NULL,NULL),(12528,12528,1,'SSS120518-121605-134007','CRTS-SSS',184.02003,-13.66869,NULL,NULL,'2012-05-18 00:00:00',56065,19.25,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120518/1205180130904105532.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120518/jpg/1205180130904105532.master.jpg',NULL,NULL,43069194559,NULL,NULL,NULL,'2007-07-11 13:26:29',54292.560059,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1205180130904105532/1205180130904105532.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120518/1205180130904105532p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,672956164,10514940,NULL,NULL,NULL,NULL),(12529,12529,1,'SSS120518-115449-124959','CRTS-SSS',178.70219,-12.83315,NULL,NULL,'2012-05-18 00:00:00',56065,18.78,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:32:59','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120518/1205180130874115850.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120518/jpg/1205180130874115850.master.jpg',NULL,NULL,40955813410,NULL,NULL,NULL,'2012-01-01 13:26:29',55927.560059,'2013-01-19 01:32:59','http://crts.caltech.edu/ATEL/SSS/1205180130874115850/1205180130874115850.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120518/1205180130874115850p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,639934584,9998977,NULL,NULL,NULL,NULL),(12530,12530,1,'SSS120517-090619-275831','CRTS-SSS',136.58001,-27.97538,NULL,NULL,'2012-05-17 00:00:00',56064,15.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120517/1205170270624108809.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120517/jpg/1205170270624108809.master.jpg',NULL,NULL,42901888567,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','http://crts.caltech.edu/ATEL/SSS/1205170270624108809/1205170270624108809.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120517/1205170270624108809p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,670342008,10474093,NULL,NULL,NULL,NULL),(12531,12531,1,'SSS120517-232252-073705','CRTS-SSS',350.71713,-7.61818,NULL,NULL,'2012-05-17 00:00:00',56064,18.61,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120517/1205170071744104093.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120517/jpg/1205170071744104093.master.jpg',NULL,NULL,49649923204,NULL,NULL,NULL,'2011-05-15 11:31:10',55696.47998,'2013-01-19 01:33:00','http://crts.caltech.edu/ATEL/SSS/1205170071744104093/1205170071744104093.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120517/1205170071744104093p.html',NULL,NULL,0,'AGN',NULL,0,NULL,0,775780050,12121563,NULL,NULL,NULL,NULL),(12532,12532,1,'SSS120515-112846-315848','CRTS-SSS',172.19069,-31.97997,NULL,NULL,'2012-05-15 00:00:00',56062,19.66,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120515/1205150310754105607.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120515/jpg/1205150310754105607.master.jpg',NULL,NULL,41591889326,NULL,NULL,NULL,'2006-01-31 13:26:23',53766.559998,'2013-01-19 01:33:00','http://crts.caltech.edu/ATEL/SSS/1205150310754105607/1205150310754105607.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120515/1205150310754105607p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,649873270,10154269,NULL,NULL,NULL,NULL),(12534,12534,1,'SSS120426-081632-063524','CRTS-SSS',124.13131,-6.58991,NULL,NULL,'2012-04-26 00:00:00',56043,19.02,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120426/1204260070624132119.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120426/jpg/1204260070624132119.master.jpg',NULL,NULL,39444280144,NULL,NULL,NULL,'2010-04-17 13:26:29',55303.560059,'2013-01-19 01:33:00','http://crts.caltech.edu/ATEL/SSS/1204260070624132119/1204260070624132119.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120426/1204260070624132119p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,616316877,9629951,NULL,NULL,NULL,NULL),(12535,12535,1,'SSS120419-134201-341506','CRTS-SSS',205.50249,-34.25153,NULL,NULL,'2012-04-19 00:00:00',56036,16.25,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120419/1204190330874101075.html','HPM WD_1339-340      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120419/jpg/1204190330874101075.master.jpg',NULL,NULL,46907732985,NULL,NULL,NULL,'2010-08-08 13:26:29',55416.560059,'2013-01-19 01:33:00','http://crts.caltech.edu/ATEL/SSS/1204190330874101075/1204190330874101075.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120419/1204190330874101075p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,732933327,11452083,NULL,NULL,NULL,NULL),(12536,12536,1,'SSS120412-094055-344341','CRTS-SSS',145.22814,-34.72804,NULL,NULL,'2012-04-12 00:00:00',56029,18.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120412/1204120350604154685.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120412/jpg/1204120350604154685.master.jpg',NULL,NULL,42865754322,NULL,NULL,NULL,'2005-12-18 10:33:36',53722.440002,'2013-01-19 01:33:00','http://crts.caltech.edu/ATEL/SSS/1204120350604154685/1204120350604154685.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120412/1204120350604154685p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,669777411,10465272,NULL,NULL,NULL,NULL),(12537,12537,1,'SSS120401-194427-100916','CRTS-SSS',296.11307,-10.15431,NULL,NULL,'2012-04-01 00:00:00',56018,11.74,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120401/1204010111454193422.html','Mira mag 13     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120401/jpg/1204010111454193422.master.jpg',NULL,NULL,47985377886,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','http://crts.caltech.edu/ATEL/SSS/1204010111454193422/1204010111454193422.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120401/1204010111454193422p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,749771529,11715180,NULL,NULL,NULL,NULL),(12539,12539,1,'SSS120330-074035-432556','CRTS-SSS',115.14772,-43.43213,NULL,NULL,'2012-03-30 00:00:00',56016,13.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120330/1203300430434148930.html','Var IRAS_07389-43      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120330/jpg/1203300430434148930.master.jpg',NULL,NULL,42670061551,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','http://crts.caltech.edu/ATEL/SSS/1203300430434148930/1203300430434148930.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120330/1203300430434148930p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,666719711,10417495,NULL,NULL,NULL,NULL),(12540,12540,1,'SSS120330-192306-381347','CRTS-SSS',290.77521,-38.22984,NULL,NULL,'2012-03-30 00:00:00',56016,17.97,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120330/1203300371174103000.html','Unknown mag >21     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120330/jpg/1203300371174103000.master.jpg',NULL,NULL,51232563952,NULL,NULL,NULL,'2011-10-16 13:26:29',55850.560059,'2013-01-19 01:33:00','http://crts.caltech.edu/ATEL/SSS/1203300371174103000/1203300371174103000.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120330/1203300371174103000p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,800508811,12507950,NULL,NULL,NULL,NULL),(12541,12541,1,'SSS120329-185136-445412','CRTS-SSS',282.90113,-44.9034,NULL,NULL,'2012-03-29 00:00:00',56015,12.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120329/1203290451014182605.html','Mira       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120329/jpg/1203290451014182605.master.jpg',NULL,NULL,51067184674,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','http://crts.caltech.edu/ATEL/SSS/1203290451014182605/1203290451014182605.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120329/1203290451014182605p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,797924760,12467574,NULL,NULL,NULL,NULL),(12543,12543,1,'SSS120205-053628-371456','CRTS-SSS',84.11687,-37.24902,NULL,NULL,'2012-02-05 00:00:00',55962,18.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120205/1202050370344114093.html','Unknown DSS mag >21    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120205/jpg/1202050370344114093.master.jpg',NULL,NULL,37097584244,NULL,NULL,NULL,'2011-09-05 13:26:29',55809.560059,'2013-01-19 01:33:00','http://crts.caltech.edu/ATEL/SSS/1202050370344114093/1202050370344114093.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120205/1202050370344114093p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,579649753,9057027,NULL,NULL,NULL,NULL),(12544,12544,1,'SSS120122-025302-391234','CRTS-SSS',43.25876,-39.20952,NULL,NULL,'2012-01-22 00:00:00',55948,18.65,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120122/1201220390174210061.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120122/jpg/1201220390174210061.master.jpg',NULL,NULL,38625738318,NULL,NULL,NULL,'2008-10-20 10:33:30',54759.439941,'2013-01-19 01:33:00','http://crts.caltech.edu/ATEL/SSS/1201220390174210061/1201220390174210061.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120122/1201220390174210061p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,603527161,9430111,NULL,NULL,NULL,NULL),(12545,12545,1,'SSS120119-111329-501921','CRTS-SSS',168.37201,-50.32245,NULL,NULL,'2012-01-19 00:00:00',55945,11.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20120119/1201190490564105985.html','Var CD-49_5949      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20120119/jpg/1201190490564105985.master.jpg',NULL,NULL,40025816568,NULL,NULL,NULL,'2007-01-29 13:26:23',54129.559998,'2013-01-19 01:33:00','http://crts.caltech.edu/ATEL/SSS/1201190490564105985/1201190490564105985.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20120119/1201190490564105985p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,625403383,9771927,NULL,NULL,NULL,NULL),(12546,11553,0,'SSS111213-234315-241019','CRTS-SSS',355.81136,-24.17183,NULL,NULL,'2011-12-13 00:00:00',55908,11.51,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','2013-01-19 01:33:00','http://nesssi.cacr.caltech.edu/SSS/20111213/1112130231654100457.html','HPM LHS 72     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20111213/jpg/1112130231654100457.master.jpg',NULL,NULL,50004328271,NULL,NULL,NULL,'2009-10-22 13:26:29',55126.560059,'2013-01-19 01:33:00','http://crts.caltech.edu/ATEL/SSS/1112130231654100457/1112130231654100457.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20111213/1112130231654100457p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,781317629,12208087,NULL,NULL,NULL,NULL),(12547,12547,0,'SSS111118-063505-435950','CRTS-SSS',98.77192,-43.99726,NULL,NULL,'2011-11-18 00:00:00',55883,16.38,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','2020-03-29 08:42:53','http://nesssi.cacr.caltech.edu/SSS/20111118/1111180430374107153.html','Unknown DSS mag >21,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20111118/jpg/1111180430374107153.master.jpg',NULL,NULL,42468528760,NULL,NULL,NULL,'2011-10-19 13:26:29',55853.560059,'2013-01-19 01:33:00','http://crts.caltech.edu/ATEL/SSS/1111180430374107153/1111180430374107153.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20111118/1111180430374107153p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,663570761,10368293,NULL,NULL,NULL,NULL),(12548,12548,1,'SSS111114-022728-420853','CRTS-SSS',36.8655,-42.14804,NULL,NULL,'2011-11-14 00:00:00',55879,18.82,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20111114/1111140410154101821.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20111114/jpg/1111140410154101821.master.jpg',NULL,NULL,38488503009,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:33:00','http://crts.caltech.edu/ATEL/SSS/1111140410154101821/1111140410154101821.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20111114/1111140410154101821p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,601382859,9396607,NULL,NULL,NULL,NULL),(12549,12549,1,'SSS111114-013129-401145','CRTS-SSS',22.87155,-40.1958,NULL,NULL,'2011-11-14 00:00:00',55879,18.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20111114/1111140390094101042.html','Unknown mag > 21,5    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20111114/jpg/1111140390094101042.master.jpg',NULL,NULL,38381627642,NULL,NULL,NULL,'2010-10-17 11:31:10',55486.47998,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1111140390094101042/1111140390094101042.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20111114/1111140390094101042p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,599712931,9370514,NULL,NULL,NULL,NULL),(12550,12550,1,'SSS111102-045137-581901','CRTS-SSS',72.90428,-58.31687,NULL,NULL,'2011-11-02 00:00:00',55867,15.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20111102/1111020570214102265.html','HPM 2MASS_J045137      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20111102/jpg/1111020570214102265.master.jpg',NULL,NULL,35967073618,NULL,NULL,NULL,'2007-10-13 13:26:29',54386.560059,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1111020570214102265/1111020570214102265.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20111102/1111020570214102265p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,561985525,8781023,NULL,NULL,NULL,NULL),(12551,12551,1,'SSS111029-004521-332947','CRTS-SSS',11.33904,-33.49636,NULL,NULL,'2011-10-29 00:00:00',55863,18.54,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20111029/1110290330054108003.html','HPM WD_0042-337      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20111029/jpg/1110290330054108003.master.jpg',NULL,NULL,34879372103,NULL,NULL,NULL,'2010-01-08 13:26:29',55204.560059,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1110290330054108003/1110290330054108003.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20111029/1110290330054108003p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,544990189,8515471,NULL,NULL,NULL,NULL),(12552,12552,1,'SSS111027-195604-341422','CRTS-SSS',299.01563,-34.23933,NULL,NULL,'2011-10-27 00:00:00',55861,16.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20111027/1110270331264101614.html','Unknown mag >21     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20111027/jpg/1110270331264101614.master.jpg',NULL,NULL,51178499395,NULL,NULL,NULL,'2011-09-26 13:26:29',55830.560059,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1110270331264101614/1110270331264101614.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20111027/1110270331264101614p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,799664053,12494750,NULL,NULL,NULL,NULL),(12553,12553,1,'SSS111017-205932-314637','CRTS-SSS',314.88435,-31.77689,NULL,NULL,'2011-10-17 00:00:00',55851,18.9,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20111017/1110170311364108538.html','Unknown mag >21     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20111017/jpg/1110170311364108538.master.jpg',NULL,NULL,51502730199,NULL,NULL,NULL,'2011-08-23 13:26:29',55796.560059,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1110170311364108538/1110170311364108538.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20111017/1110170311364108538p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,804730159,12573908,NULL,NULL,NULL,NULL),(12554,12554,1,'SSS111016-220416-564728','CRTS-SSS',331.0677,-56.79103,NULL,NULL,'2011-10-16 00:00:00',55850,17.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20111016/1110160570924124215.html','HPM 2MASS_J220411      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20111016/jpg/1110160570924124215.master.jpg',NULL,NULL,48719696378,NULL,NULL,NULL,'2010-11-02 13:26:29',55502.560059,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1110160570924124215/1110160570924124215.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20111016/1110160570924124215p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,761245255,11894457,NULL,NULL,NULL,NULL),(12555,12555,1,'SSS110829-222530-174421','CRTS-SSS',336.37649,-17.73912,NULL,NULL,'2011-08-29 00:00:00',55802,19.32,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110829/1108290171614104634.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110829/jpg/1108290171614104634.master.jpg',NULL,NULL,50236976917,NULL,NULL,NULL,'2010-07-19 10:33:30',55396.439941,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1108290171614104634/1108290171614104634.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110829/1108290171614104634p.html',NULL,NULL,1,'UNCLEAR',NULL,0,NULL,0,784952764,12264886,NULL,NULL,NULL,NULL),(12556,12556,1,'SSS110826-132434-331038','CRTS-SSS',201.1408,-33.17734,NULL,NULL,'2011-08-26 00:00:00',55799,16.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110826/1108260330854123002.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110826/jpg/1108260330854123002.master.jpg',NULL,NULL,46869863083,NULL,NULL,NULL,'2011-07-21 13:26:29',55763.560059,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1108260330854123002/1108260330854123002.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110826/1108260330854123002p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,732341610,11442837,NULL,NULL,NULL,NULL),(12557,12557,1,'SSS110731-014158-275316','CRTS-SSS',25.4899,-27.8877,NULL,NULL,'2011-07-31 00:00:00',55773,19.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110731/1107310270124103470.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110731/jpg/1107310270124103470.master.jpg',NULL,NULL,38267411475,NULL,NULL,NULL,'2008-02-08 13:26:29',54504.560059,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1107310270124103470/1107310270124103470.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110731/1107310270124103470p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,597928304,9342629,NULL,NULL,NULL,NULL),(12558,12558,1,'SSS110703-132157-214926','CRTS-SSS',200.48727,-21.82387,NULL,NULL,'2011-07-03 00:00:00',55745,18.71,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110703/1107030210944103967.html','Unknown mag 20     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110703/jpg/1107030210944103967.master.jpg',NULL,NULL,43812731674,NULL,NULL,NULL,'2007-05-14 13:26:23',54234.559998,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1107030210944103967/1107030210944103967.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110703/1107030210944103967p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,684573932,10696467,NULL,NULL,NULL,NULL),(12559,12559,1,'SSS110702-205325-223637','CRTS-SSS',313.35561,-22.61033,NULL,NULL,'2011-07-02 00:00:00',55744,19.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110702/1107020231454130926.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110702/jpg/1107020231454130926.master.jpg',NULL,NULL,50937848752,NULL,NULL,NULL,'2011-05-15 13:26:29',55696.560059,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1107020231454130926/1107020231454130926.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110702/1107020231454130926p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,795903886,12435998,NULL,NULL,NULL,NULL),(12561,12561,1,'SSS110625-185450-570445','CRTS-SSS',283.70935,-57.07926,NULL,NULL,'2011-06-25 00:00:00',55737,15.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110625/1106250570794153438.html','HPM       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110625/jpg/1106250570794153438.master.jpg',NULL,NULL,49122136857,NULL,NULL,NULL,'2006-09-16 10:33:36',53994.440002,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1106250570794153438/1106250570794153438.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110625/1106250570794153438p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,767533388,11992709,NULL,NULL,NULL,NULL),(12562,12562,1,'SSS110625-233333-390507','CRTS-SSS',353.38621,-39.08533,NULL,NULL,'2011-06-25 00:00:00',55737,19.69,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110625/1106250391394116805.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110625/jpg/1106250391394116805.master.jpg',NULL,NULL,49987624106,NULL,NULL,NULL,'2009-07-24 12:28:49',55036.52002,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1106250391394116805/1106250391394116805.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110625/1106250391394116805p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,781056626,12204009,NULL,NULL,NULL,NULL),(12563,12563,1,'SSS110625-100353-241648','CRTS-SSS',150.96992,-24.27991,NULL,NULL,'2011-06-25 00:00:00',55737,17.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110625/1106250250694133820.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110625/jpg/1106250250694133820.master.jpg',NULL,NULL,42280949121,NULL,NULL,NULL,'2011-05-09 13:26:29',55690.560059,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1106250250694133820/1106250250694133820.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110625/1106250250694133820p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,660639830,10322497,NULL,NULL,NULL,NULL),(12564,12564,1,'SSS110622-122106-320102','CRTS-SSS',185.27505,-32.01728,NULL,NULL,'2011-06-22 00:00:00',55734,19.18,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110622/1106220310804103970.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110622/jpg/1106220310804103970.master.jpg',NULL,NULL,43452679622,NULL,NULL,NULL,'2007-03-09 13:26:23',54168.559998,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1106220310804103970/1106220310804103970.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110622/1106220310804103970p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,678948119,10608564,NULL,NULL,NULL,NULL),(12565,12565,1,'SSS110525-192806-463143','CRTS-SSS',292.02538,-46.52859,NULL,NULL,'2011-05-25 00:00:00',55706,18.4,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110525/1105250471014167838.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110525/jpg/1105250471014167838.master.jpg',NULL,NULL,51251013939,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1105250471014167838/1105250471014167838.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110525/1105250471014167838p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,800797092,12512454,NULL,NULL,NULL,NULL),(12566,12566,1,'SSS110429-184510-635741','CRTS-SSS',281.29059,-63.96141,NULL,NULL,'2011-04-29 00:00:00',55680,13.69,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110429/1104290630654113506.html','HPM SCR_J1845-6357A      ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110429/jpg/1104290630654113506.master.jpg',NULL,NULL,48984380198,NULL,NULL,NULL,'2010-08-30 13:26:29',55438.560059,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1104290630654113506/1104290630654113506.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110429/1104290630654113506p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,765380940,11959077,NULL,NULL,NULL,NULL),(12568,12568,0,'SSS110422-142508-351056','CRTS-SSS',216.28247,-35.18218,NULL,NULL,'2011-04-22 00:00:00',55673,18.4,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-12-24 20:38:21','http://nesssi.cacr.caltech.edu/SSS/20110422/1104220350894126330.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110422/jpg/1104220350894126330.master.jpg',NULL,NULL,47008056488,NULL,NULL,NULL,'2006-03-26 10:33:36',53820.440002,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1104220350894126330/1104220350894126330.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110422/1104220350894126330p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,734500882,11476576,NULL,NULL,NULL,NULL),(12569,12569,1,'SSS110224-072836-404823','CRTS-SSS',112.14967,-40.80651,NULL,NULL,'2011-02-24 00:00:00',55616,18.35,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:01','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110224/1102240410434157291.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110224/jpg/1102240410434157291.master.jpg',NULL,NULL,42674867074,NULL,NULL,NULL,'2011-01-25 13:26:29',55586.560059,'2013-01-19 01:33:01','http://crts.caltech.edu/ATEL/SSS/1102240410434157291/1102240410434157291.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110224/1102240410434157291p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,666794798,10418668,NULL,NULL,NULL,NULL),(12570,12570,1,'SSS110127-095916-352936','CRTS-SSS',149.81539,-35.49334,NULL,NULL,'2011-01-27 00:00:00',55588,13.55,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:02','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110127/1101270350624125606.html','LPV       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110127/jpg/1101270350624125606.master.jpg',NULL,NULL,41969710971,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:33:02','http://crts.caltech.edu/ATEL/SSS/1101270350624125606/1101270350624125606.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110127/1101270350624125606p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,655776733,10246511,NULL,NULL,NULL,NULL),(12571,12571,1,'SSS110127-100028-341426','CRTS-SSS',150.11861,-34.2405,NULL,NULL,'2011-01-27 00:00:00',55588,19.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:02','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20110127/1101270330634101197.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20110127/jpg/1101270330634101197.master.jpg',NULL,NULL,41971961430,NULL,NULL,NULL,'2010-01-09 10:33:30',55205.439941,'2013-01-19 01:33:02','http://crts.caltech.edu/ATEL/SSS/1101270330634101197/1101270330634101197.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20110127/1101270330634101197p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,655811897,10247060,NULL,NULL,NULL,NULL),(12572,12572,1,'SSS101230-012815-365006','CRTS-SSS',22.06066,-36.83496,NULL,NULL,'2010-12-30 00:00:00',55560,18.68,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:02','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20101230/1012300370094113428.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20101230/jpg/1012300370094113428.master.jpg',NULL,NULL,38276662348,NULL,NULL,NULL,'2010-01-12 13:26:29',55208.560059,'2013-01-19 01:33:02','http://crts.caltech.edu/ATEL/SSS/1012300370094113428/1012300370094113428.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20101230/1012300370094113428p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,598072849,9344888,NULL,NULL,NULL,NULL),(12573,12573,1,'SSS101111-053915-295127','CRTS-SSS',84.81133,-29.85756,NULL,NULL,'2010-11-11 00:00:00',55511,19.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:02','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20101111/1011110290384105569.html','Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20101111/jpg/1011110290384105569.master.jpg',NULL,NULL,37157028634,NULL,NULL,NULL,'2010-04-18 13:26:29',55304.560059,'2013-01-19 01:33:02','http://crts.caltech.edu/ATEL/SSS/1011110290384105569/1011110290384105569.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20101111/1011110290384105569p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,580578572,9071540,NULL,NULL,NULL,NULL),(12574,12574,1,'SSS101018-030415-294760','CRTS-SSS',46.06051,-29.79992,NULL,NULL,'2010-10-18 00:00:00',55487,19.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:02','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20101018/1010180290214104995.html','Var       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20101018/jpg/1010180290214104995.master.jpg',NULL,NULL,38618820750,NULL,NULL,NULL,'2010-08-30 13:26:29',55438.560059,'2013-01-19 01:33:02','http://crts.caltech.edu/ATEL/SSS/1010180290214104995/1010180290214104995.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20101018/1010180290214104995p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,603419074,9428423,NULL,NULL,NULL,NULL),(12575,12575,1,'SSS100928-032432-522047','CRTS-SSS',51.13516,-52.34631,NULL,NULL,'2010-09-28 00:00:00',55467,14.4,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:02','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20100928/1009280510174100782.html','Supernova or Other',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20100928/jpg/1009280510174100782.master.jpg',NULL,NULL,37731861373,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:33:02','http://crts.caltech.edu/ATEL/SSS/1009280510174100782/1009280510174100782.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20100928/1009280510174100782p.html',NULL,NULL,0,'BS',NULL,0,NULL,0,589560333,9211880,NULL,NULL,NULL,NULL),(12576,12576,1,'SSS100512-162406-255834','CRTS-SSS',246.02541,-25.976,NULL,NULL,'2010-05-12 00:00:00',55328,18.3,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:02','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20100512/1005120251124109631.html','Var mag 21     ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20100512/jpg/1005120251124109631.master.jpg',NULL,NULL,45769734780,NULL,NULL,NULL,'2010-05-06 13:26:29',55322.560059,'2013-01-19 01:33:02','http://crts.caltech.edu/ATEL/SSS/1005120251124109631/1005120251124109631.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20100512/1005120251124109631p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,715152105,11174251,NULL,NULL,NULL,NULL),(12577,12577,1,'SSS100507-144833-401052','CRTS-SSS',222.13833,-40.18116,NULL,NULL,'2010-05-07 00:00:00',55323,12.24,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:02','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20100507/1005070390884107317.html','Var SSS mag 12,4    ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20100507/jpg/1005070390884107317.master.jpg',NULL,NULL,47218690750,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:33:02','http://crts.caltech.edu/ATEL/SSS/1005070390884107317/1005070390884107317.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20100507/1005070390884107317p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,737792042,11528000,NULL,NULL,NULL,NULL),(12578,12578,1,'SSS100505-093417-174421','CRTS-SSS',143.57164,-17.7392,NULL,NULL,'2010-05-05 00:00:00',55321,18.47,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-19 01:33:02','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/SSS/20100505/1005050170694105460.html','Var/Unknown       ',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/SSS/20100505/jpg/1005050170694105460.master.jpg',NULL,NULL,42308811762,NULL,NULL,NULL,NULL,NULL,'2013-01-19 01:33:02','http://crts.caltech.edu/ATEL/SSS/1005050170694105460/1005050170694105460.find.jpg','http://nesssi.cacr.caltech.edu/SSS/20100505/1005050170694105460p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,661075183,10329299,NULL,NULL,NULL,NULL),(18014,4868,1,'OGLE-2012-SN-006','OGLE',53.3949583333333,-74.3944722222222,NULL,NULL,'2012-10-07 20:09:35',56207.84,17.5,NULL,NULL,NULL,NULL,NULL,NULL,'2013-01-19 05:15:05','2019-10-11 14:10:04','http://ogle.astrouw.edu.pl/ogle4/transients/transients.html','supernova',NULL,0,NULL,NULL,'http://ogle.astrouw.edu.pl/ogle4/transients/transients.html',NULL,NULL,35520686641,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,555010728,8672042,NULL,NULL,NULL,NULL),(18015,4868,0,'OGLE-2012-SN-006','atel',53.3949583333,-74.3944722222,NULL,NULL,'2013-01-10 04:48:00',56302.2,NULL,NULL,NULL,0.06,NULL,'Ib peculiar',NULL,'2013-01-19 11:33:56','2013-01-19 11:33:56','http://www.astronomerstelegram.org/?read=4734',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35520686641,'duPont2.5m','WFCCD','Prieto',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,555010728,8672042,NULL,NULL,NULL,NULL),(18016,18016,1,'PSNJ13372046-2838568','TOCP',204.33525,-28.6491111111111,NULL,NULL,'2013-01-12 00:00:00',56304,17.8,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2013-01-19 14:16:09','2019-10-11 14:10:04','http://www.cbat.eps.harvard.edu/unconf/followups/J13372046-2838568.html','supernova',NULL,0,NULL,NULL,'http://farm9.staticflickr.com/8183/8382233938_69b805e899_h.jpg',NULL,NULL,46848823644,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,732012869,11437701,NULL,NULL,NULL,NULL),(18017,18017,0,'PSNJ17393154-8518381','TOCP',264.881416666667,-85.3105833333333,NULL,NULL,'2013-01-20 00:00:00',56312,17.7,NULL,'unfiltered',NULL,NULL,NULL,NULL,'2013-01-20 15:14:28','2019-10-12 20:41:36','http://www.cbat.eps.harvard.edu/unconf/followups/J17393154-8518381.html','supernova',NULL,0.008,NULL,NULL,'NULL',NULL,NULL,44028630864,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,687947357,10749177,NULL,NULL,NULL,NULL),(18018,18017,0,'PSNJ17393154-8518381','pessto',264.881416667,-85.3105833333,NULL,NULL,'2013-01-22 07:50:00',56314.3264,NULL,NULL,NULL,0.008,NULL,'IIP',NULL,'2013-01-22 10:01:54','2013-01-22 10:01:54','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,44028630864,'NTT','EFOSC2','Giorgos Leloudas',NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'NT',NULL,0,NULL,0,687947357,10749177,NULL,NULL,NULL,NULL),(18019,11054,1,'OGLE-2013-SN-011','pessto',71.7955,-64.0434722222,NULL,NULL,'2013-01-22 04:29:16',56314.187,NULL,NULL,NULL,0.05,NULL,'IIP',NULL,'2013-01-22 10:03:13','2019-10-11 14:10:04','http://www.astronomerstelegram.org/?read=NULL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,35876735402,'NTT','EFOSC2','Leloudas','2012-07-31 09:45:45',NULL,NULL,NULL,NULL,NULL,NULL,0,'SN',NULL,0,NULL,0,560573990,8758968,NULL,NULL,NULL,NULL),(18020,18020,1,'CSS130115-081249+461700','CRTS-CSS',123.20438,46.28339,NULL,NULL,'2013-01-15 00:00:00',56307,18.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:18','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130115/1301151460314123896.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130115/jpg/1301151460314123896.master.jpg',NULL,NULL,63531378390,NULL,NULL,NULL,'2007-04-14 10:33:36',54204.440002,'2013-01-22 16:45:18','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301151460314123896/1301151460314123896.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130115/1301151460314123896p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,992677787,15510590,NULL,NULL,NULL,NULL),(18021,18021,1,'CSS130115-020106+115502','CRTS-CSS',30.27614,11.91733,NULL,NULL,'2013-01-15 00:00:00',56307,18.44,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:18','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130115/1301151120114110654.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130115/jpg/1301151120114110654.master.jpg',NULL,NULL,67096306854,NULL,NULL,NULL,'2010-10-28 13:26:07',55497.559814,'2013-01-22 16:45:18','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301151120114110654/1301151120114110654.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130115/1301151120114110654p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1048379794,16380934,NULL,NULL,NULL,NULL),(18022,18022,1,'CSS130113-101554+045213','CRTS-CSS',153.97297,4.87015,NULL,NULL,'2013-01-13 00:00:00',56305,18.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:18','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130113/1301131040554137759.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130113/jpg/1301131040554137759.master.jpg',NULL,NULL,60793599685,NULL,NULL,NULL,'2005-01-13 10:33:34',53383.439987,'2013-01-22 16:45:18','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301131040554137759/1301131040554137759.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130113/1301131040554137759p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,949899995,14842187,NULL,NULL,NULL,NULL),(18023,18023,1,'CSS130113-120518-145601','CRTS-CSS',181.32586,-14.93363,NULL,NULL,'2013-01-13 00:00:00',56305,18.4,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:18','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130113/1301130150634137478.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130113/jpg/1301130150634137478.master.jpg',NULL,NULL,43058540509,NULL,NULL,NULL,'2012-04-16 13:26:07',56033.559814,'2013-01-22 16:45:18','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301130150634137478/1301130150634137478.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130113/1301130150634137478p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,672789695,10512338,NULL,NULL,NULL,NULL),(18025,18025,1,'CSS130109-120259+144638','CRTS-CSS',180.74497,14.77724,NULL,NULL,'2013-01-09 00:00:00',56301,19.24,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130109/1301091150634114188.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130109/jpg/1301091150634114188.master.jpg',NULL,NULL,58142818430,NULL,NULL,NULL,'2005-05-09 13:26:23',53499.559998,'2013-01-22 16:45:19','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301091150634114188/1301091150634114188.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130109/1301091150634114188p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,908481537,14195024,NULL,NULL,NULL,NULL),(18026,18026,1,'CSS130109-234723+071521','CRTS-CSS',356.84742,7.25585,NULL,NULL,'2013-01-09 00:00:00',56301,18.26,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130109/1301091071264128565.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130109/jpg/1301091071264128565.master.jpg',NULL,NULL,51563458326,NULL,NULL,NULL,'2005-12-02 13:26:23',53706.559998,'2013-01-22 16:45:19','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301091071264128565/1301091071264128565.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130109/1301091071264128565p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,805679036,12588734,NULL,NULL,NULL,NULL),(18027,18027,1,'CSS130108-092358+624800','CRTS-CSS',140.99312,62.80001,NULL,NULL,'2013-01-08 00:00:00',56300,18.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130108/1301081630244112050.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130108/jpg/1301081630244112050.master.jpg',NULL,NULL,62032763403,NULL,NULL,NULL,'2008-12-06 10:33:41',54806.440063,'2013-01-22 16:45:19','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301081630244112050/1301081630244112050.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130108/1301081630244112050p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,969261928,15144717,NULL,NULL,NULL,NULL),(18028,18028,1,'CSS130105-095837+361257','CRTS-CSS',149.6543,36.21584,NULL,NULL,'2013-01-05 00:00:00',56297,18.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130105/1301051350454137063.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130105/jpg/1301051350454137063.master.jpg',NULL,NULL,64071125229,NULL,NULL,NULL,'2011-04-29 10:33:30',55680.439941,'2013-01-22 16:45:19','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301051350454137063/1301051350454137063.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130105/1301051350454137063p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1001111331,15642364,NULL,NULL,NULL,NULL),(18029,18029,1,'CSS130103-143028+103648','CRTS-CSS',217.61863,10.61334,NULL,NULL,'2013-01-03 00:00:00',56295,19.12,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20130103/1301031090774135654.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20130103/jpg/1301031090774135654.master.jpg',NULL,NULL,59359419495,NULL,NULL,NULL,'2007-02-28 11:31:15',54159.480042,'2013-01-22 16:45:19','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1301031090774135654/1301031090774135654.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20130103/1301031090774135654p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,927490929,14492045,NULL,NULL,NULL,NULL),(18030,18030,1,'CSS121221-090700+314505','CRTS-CSS',136.75168,31.75134,NULL,NULL,'2012-12-21 00:00:00',56282,19.15,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121221/1212211320424112761.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121221/jpg/1212211320424112761.master.jpg',NULL,NULL,64379763074,NULL,NULL,NULL,'2012-12-10 10:33:30',56271.439941,'2013-01-22 16:45:19','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212211320424112761/1212211320424112761.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121221/1212211320424112761p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1005933798,15717715,NULL,NULL,NULL,NULL),(18031,18031,1,'CSS121220-105426+050222','CRTS-CSS',163.60918,5.03941,NULL,NULL,'2012-12-20 00:00:00',56281,20.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121220/1212201040594136782.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121220/jpg/1212201040594136782.master.jpg',NULL,NULL,60321759308,NULL,NULL,NULL,'2007-01-24 10:33:36',54124.440002,'2013-01-22 16:45:19','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212201040594136782/1212201040594136782.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121220/1212201040594136782p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,942527489,14726992,NULL,NULL,NULL,NULL),(18032,18032,1,'CSS121213-021824+163359','CRTS-CSS',34.59985,16.56628,NULL,NULL,'2012-12-13 00:00:00',56274,18.84,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121213/1212131150124142506.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121213/jpg/1212131150124142506.master.jpg',NULL,NULL,68075083802,NULL,NULL,NULL,'2012-12-06 12:28:49',56267.52002,'2013-01-22 16:45:19','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212131150124142506/1212131150124142506.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121213/1212131150124142506p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1063673184,16619893,NULL,NULL,NULL,NULL),(18033,18033,0,'CSS121212-104115+373323','CRTS-CSS',160.31432,37.55633,NULL,NULL,'2012-12-12 00:00:00',56273,18.08,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:19','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20121212/1212121380464115648.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121212/jpg/1212121380464115648.master.jpg',NULL,NULL,64119511666,NULL,NULL,NULL,'2010-06-07 13:26:07',55354.559814,'2013-01-22 16:45:19','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212121380464115648/1212121380464115648.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121212/1212121380464115648p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1001867369,15654177,NULL,NULL,NULL,NULL),(18034,18034,1,'CSS121212-021426+052309','CRTS-CSS',33.60746,5.38577,NULL,NULL,'2012-12-12 00:00:00',56273,17.54,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121212/1212121040124143985.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121212/jpg/1212121040124143985.master.jpg',NULL,NULL,67066494692,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:19','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212121040124143985/1212121040124143985.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121212/1212121040124143985p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1047913979,16373655,NULL,NULL,NULL,NULL),(18035,18035,1,'CSS121207-093835+112136','CRTS-CSS',144.64462,11.35988,NULL,NULL,'2012-12-07 00:00:00',56268,19.37,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121207/1212071120514101732.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121207/jpg/1212071120514101732.master.jpg',NULL,NULL,60888319952,NULL,NULL,NULL,'2006-10-20 13:26:23',54028.559998,'2013-01-22 16:45:19','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1212071120514101732/1212071120514101732.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121207/1212071120514101732p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,951379999,14865312,NULL,NULL,NULL,NULL),(18037,18037,1,'CSS121114-090202+101800','CRTS-CSS',135.50974,10.30003,NULL,NULL,'2012-11-14 00:00:00',56245,16.56,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121114/1211141090484136131.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121114/jpg/1211141090484136131.master.jpg',NULL,NULL,63673137319,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:19','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211141090484136131/1211141090484136131.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121114/1211141090484136131p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,994892770,15545199,NULL,NULL,NULL,NULL),(18039,18039,1,'CSS121113-091919+171410','CRTS-CSS',139.82785,17.236,NULL,NULL,'2012-11-13 00:00:00',56244,18.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121113/1211131180484106123.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121113/jpg/1211131180484106123.master.jpg',NULL,NULL,63858992505,NULL,NULL,NULL,'2012-05-16 13:26:07',56063.559814,'2013-01-22 16:45:19','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211131180484106123/1211131180484106123.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121113/1211131180484106123p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,997796757,15590574,NULL,NULL,NULL,NULL),(18040,18040,1,'CSS121112-024457+353043','CRTS-CSS',41.23707,35.51196,NULL,NULL,'2012-11-12 00:00:00',56243,17.4,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:19','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121112/1211121350134141376.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121112/jpg/1211121350134141376.master.jpg',NULL,NULL,68658225649,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:19','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211121350134141376/1211121350134141376.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121112/1211121350134141376p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,1072784775,16762262,NULL,NULL,NULL,NULL),(18041,18041,1,'CSS121112-020130+261539','CRTS-CSS',30.37368,26.26081,NULL,NULL,'2012-11-12 00:00:00',56243,19.8,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121112/1211121260104115636.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121112/jpg/1211121260104115636.master.jpg',NULL,NULL,68600617981,NULL,NULL,NULL,'2012-02-19 11:31:10',55976.47998,'2013-01-22 16:45:20','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211121260104115636/1211121260104115636.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121112/1211121260104115636p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1071884655,16748197,NULL,NULL,NULL,NULL),(18042,18042,1,'CSS121106-003304+312335','CRTS-CSS',8.26584,31.39314,NULL,NULL,'2012-11-06 00:00:00',56237,18.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20121106/1211061320034107388.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20121106/jpg/1211061320034107388.master.jpg',NULL,NULL,67376140631,NULL,NULL,NULL,'2005-10-25 10:33:36',53668.440002,'2013-01-22 16:45:20','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1211061320034107388/1211061320034107388.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20121106/1211061320034107388p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1052752197,16449253,NULL,NULL,NULL,NULL),(18050,18050,1,'CSS120919-152032+290030','CRTS-CSS',230.13136,29.00847,NULL,NULL,'2012-09-19 00:00:00',56189,17.66,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120919/1209191290734112890.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120919/jpg/1209191290734112890.master.jpg',NULL,NULL,59905683514,NULL,NULL,NULL,'2007-09-14 11:31:10',54357.47998,'2013-01-22 16:45:20','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209191290734112890/1209191290734112890.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120919/1209191290734112890p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,936026304,14625411,NULL,NULL,NULL,NULL),(18051,18051,1,'CSS120915-003303-064006','CRTS-CSS',8.26125,-6.6684,NULL,NULL,'2012-09-15 00:00:00',56185,19.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120915/1209150070034133708.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120915/jpg/1209150070034133708.master.jpg',NULL,NULL,34625922163,NULL,NULL,NULL,'2005-01-13 11:31:11',53383.479996,'2013-01-22 16:45:20','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209150070034133708/1209150070034133708.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120915/1209150070034133708p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,541030033,8453594,NULL,NULL,NULL,NULL),(18052,18052,1,'CSS120914-010533+084631','CRTS-CSS',16.38889,8.77522,NULL,NULL,'2012-09-14 00:00:00',56184,20.11,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120914/1209141090064105618.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120914/jpg/1209141090064105618.master.jpg',NULL,NULL,67558408751,NULL,NULL,NULL,'2011-11-27 11:31:10',55892.47998,'2013-01-22 16:45:20','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209141090064105618/1209141090064105618.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120914/1209141090064105618p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1055600136,16493752,NULL,NULL,NULL,NULL),(18053,18053,1,'CSS120914-215710+055647','CRTS-CSS',329.29128,5.94642,NULL,NULL,'2012-09-14 00:00:00',56184,15.95,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120914/1209141071174108926.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120914/jpg/1209141071174108926.master.jpg',NULL,NULL,52317136566,NULL,NULL,NULL,'2005-05-16 13:26:23',53506.559998,'2013-01-22 16:45:20','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1209141071174108926/1209141071174108926.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120914/1209141071174108926p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,817455258,12772738,NULL,NULL,NULL,NULL),(18055,18055,0,'CSS120620-135635+044652','CRTS-CSS',209.14702,4.78119,NULL,NULL,'2012-06-20 00:00:00',56098,17.5,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:20','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120620/1206201040754130670.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120620/jpg/1206201040754130670.master.jpg',NULL,NULL,58406204714,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:20','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206201040754130670/1206201040754130670.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120620/1206201040754130670p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,912596948,14259327,NULL,NULL,NULL,NULL),(18056,18056,1,'CSS120618-113316+250215','CRTS-CSS',173.3153,25.03738,NULL,NULL,'2012-06-18 00:00:00',56096,18.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120618/1206181230574132946.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120618/jpg/1206181230574132946.master.jpg',NULL,NULL,60571536883,NULL,NULL,NULL,'2005-05-10 13:26:23',53500.559998,'2013-01-22 16:45:20','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206181230574132946/1206181230574132946.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120618/1206181230574132946p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,946430263,14787972,NULL,NULL,NULL,NULL),(18057,18057,0,'CSS120614-140807+580308','CRTS-CSS',212.02786,58.05213,NULL,NULL,'2012-06-14 00:00:00',56092,17.69,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:20','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120614/1206141570424120999.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120614/jpg/1206141570424120999.master.jpg',NULL,NULL,57304103299,NULL,NULL,NULL,'2005-05-15 10:33:36',53505.440002,'2013-01-22 16:45:20','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206141570424120999/1206141570424120999.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120614/1206141570424120999p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,895376614,13990259,NULL,NULL,NULL,NULL),(18058,18058,1,'CSS120614-145703+485357','CRTS-CSS',224.26178,48.89904,NULL,NULL,'2012-06-14 00:00:00',56092,18.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120614/1206141490544113083.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120614/jpg/1206141490544113083.master.jpg',NULL,NULL,59941412114,NULL,NULL,NULL,'2007-04-26 13:26:23',54216.559998,'2013-01-22 16:45:20','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206141490544113083/1206141490544113083.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120614/1206141490544113083p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,936584564,14634133,NULL,NULL,NULL,NULL),(18059,18059,1,'CSS120614-140736+395925','CRTS-CSS',211.90185,39.99039,NULL,NULL,'2012-06-14 00:00:00',56092,19.34,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120614/1206141400594106740.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120614/jpg/1206141400594106740.master.jpg',NULL,NULL,59257826355,NULL,NULL,NULL,'2012-05-29 13:26:07',56076.559814,'2013-01-22 16:45:20','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206141400594106740/1206141400594106740.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120614/1206141400594106740p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,925903536,14467242,NULL,NULL,NULL,NULL),(18060,18060,1,'CSS120612-150150+113156','CRTS-CSS',225.45971,11.5321,NULL,NULL,'2012-06-12 00:00:00',56090,19.44,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:20','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120612/1206121120794103898.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120612/jpg/1206121120794103898.master.jpg',NULL,NULL,59375422610,NULL,NULL,NULL,'2008-12-30 10:33:41',54830.440063,'2013-01-22 16:45:20','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206121120794103898/1206121120794103898.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120612/1206121120794103898p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,927740978,14495952,NULL,NULL,NULL,NULL),(18061,18061,1,'CSS120610-165030+454419','CRTS-CSS',252.62313,45.7386,NULL,NULL,'2012-06-10 00:00:00',56088,18.62,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120610/1206101460644109240.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120610/jpg/1206101460644109240.master.jpg',NULL,NULL,59617079782,NULL,NULL,NULL,'2012-04-22 12:28:49',56039.52002,'2013-01-22 16:45:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1206101460644109240/1206101460644109240.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120610/1206101460644109240p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,931516871,14554951,NULL,NULL,NULL,NULL),(18062,18062,1,'CSS120530-154029+383518','CRTS-CSS',235.12133,38.58823,NULL,NULL,'2012-05-30 00:00:00',56077,18.84,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120530/1205301380684129929.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120530/jpg/1205301380684129929.master.jpg',NULL,NULL,60096625466,NULL,NULL,NULL,'2010-05-04 10:33:30',55320.439941,'2013-01-22 16:45:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205301380684129929/1205301380684129929.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120530/1205301380684129929p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,939009772,14672027,NULL,NULL,NULL,NULL),(18063,18063,1,'CSS120529-110444+574610','CRTS-CSS',166.18511,57.76938,NULL,NULL,'2012-05-29 00:00:00',56076,18.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120529/1205291570334115911.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120529/jpg/1205291570334115911.master.jpg',NULL,NULL,62006965307,NULL,NULL,NULL,'2010-03-18 13:26:29',55273.560059,'2013-01-22 16:45:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205291570334115911/1205291570334115911.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120529/1205291570334115911p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,968858832,15138419,NULL,NULL,NULL,NULL),(18064,18064,1,'CSS120528-122624-004253','CRTS-CSS',186.60116,-0.7148,NULL,NULL,'2012-05-28 00:00:00',56075,18.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120528/1205280010674125715.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120528/jpg/1205280010674125715.master.jpg',NULL,NULL,42991387678,NULL,NULL,NULL,'2005-03-13 10:33:34',53442.439987,'2013-01-22 16:45:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205280010674125715/1205280010674125715.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120528/1205280010674125715p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,671740432,10495944,NULL,NULL,NULL,NULL),(18065,18065,1,'CSS120525-172227+431634','CRTS-CSS',260.61148,43.27623,NULL,NULL,'2012-05-25 00:00:00',56072,18.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120525/1205251430694120110.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120525/jpg/1205251430694120110.master.jpg',NULL,NULL,59649088086,NULL,NULL,NULL,'2012-05-01 13:26:07',56048.559814,'2013-01-22 16:45:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205251430694120110/1205251430694120110.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120525/1205251430694120110p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,932017001,14562765,NULL,NULL,NULL,NULL),(18066,18066,0,'CSS120517-150603+412533','CRTS-CSS',226.51057,41.42575,NULL,NULL,'2012-05-17 00:00:00',56064,15.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120517/1205171400634128595.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120517/jpg/1205171400634128595.master.jpg',NULL,NULL,59970885202,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205171400634128595/1205171400634128595.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120517/1205171400634128595p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,937045081,14641329,NULL,NULL,NULL,NULL),(18067,18067,1,'CSS120515-150239+191451','CRTS-CSS',225.66096,19.24753,NULL,NULL,'2012-05-15 00:00:00',56062,18.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120515/1205151180784138953.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120515/jpg/1205151180784138953.master.jpg',NULL,NULL,59536221830,NULL,NULL,NULL,'2012-05-01 13:26:07',56048.559814,'2013-01-22 16:45:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205151180784138953/1205151180784138953.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120515/1205151180784138953p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,930253466,14535210,NULL,NULL,NULL,NULL),(18068,18068,1,'CSS120515-134044+193806','CRTS-CSS',205.18145,19.63489,NULL,NULL,'2012-05-15 00:00:00',56062,19.82,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120515/1205151180714144181.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120515/jpg/1205151180714144181.master.jpg',NULL,NULL,58799582216,NULL,NULL,NULL,'2012-04-16 10:33:30',56033.439941,'2013-01-22 16:45:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1205151180714144181/1205151180714144181.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120515/1205151180714144181p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,918743472,14355366,NULL,NULL,NULL,NULL),(18069,18069,1,'CSS120428-102244+370714','CRTS-CSS',155.68219,37.12058,NULL,NULL,'2012-04-28 00:00:00',56045,19.4,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120428/1204281380454105109.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120428/jpg/1204281380454105109.master.jpg',NULL,NULL,64072271235,NULL,NULL,NULL,'2012-03-30 13:26:07',56016.559814,'2013-01-22 16:45:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204281380454105109/1204281380454105109.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120428/1204281380454105109p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1001129238,15642644,NULL,NULL,NULL,NULL),(18070,18070,1,'CSS120425-174943+335724','CRTS-CSS',267.42779,33.95655,NULL,NULL,'2012-04-25 00:00:00',56042,18.48,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120425/1204251350794106704.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120425/jpg/1204251350794106704.master.jpg',NULL,NULL,56322773455,NULL,NULL,NULL,'2011-11-28 13:26:07',55893.559814,'2013-01-22 16:45:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204251350794106704/1204251350794106704.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120425/1204251350794106704p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,880043335,13750677,NULL,NULL,NULL,NULL),(18071,18071,1,'CSS120421-085111+032751','CRTS-CSS',132.79759,3.46406,NULL,NULL,'2012-04-21 00:00:00',56038,18.93,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120421/1204211040484113178.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120421/jpg/1204211040484113178.master.jpg',NULL,NULL,63628858335,NULL,NULL,NULL,'2007-01-09 13:26:23',54109.559998,'2013-01-22 16:45:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204211040484113178/1204211040484113178.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120421/1204211040484113178p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,994200911,15534389,NULL,NULL,NULL,NULL),(18072,18072,1,'CSS120420-131248+315317','CRTS-CSS',198.19805,31.88796,NULL,NULL,'2012-04-20 00:00:00',56037,19.02,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120420/1204201320614114045.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120420/jpg/1204201320614114045.master.jpg',NULL,NULL,58679432076,NULL,NULL,NULL,'2006-02-04 12:28:49',53770.52002,'2013-01-22 16:45:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204201320614114045/1204201320614114045.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120420/1204201320614114045p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,916866126,14326033,NULL,NULL,NULL,NULL),(18074,18074,1,'CSS120419-150533+243244','CRTS-CSS',226.38686,24.54564,NULL,NULL,'2012-04-19 00:00:00',56036,19.62,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120419/1204191230754136211.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120419/jpg/1204191230754136211.master.jpg',NULL,NULL,59408958696,NULL,NULL,NULL,'2009-09-23 10:33:41',55097.440063,'2013-01-22 16:45:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204191230754136211/1204191230754136211.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120419/1204191230754136211p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,928264979,14504140,NULL,NULL,NULL,NULL),(18078,18078,0,'CSS120411-114429+070346','CRTS-CSS',176.12252,7.06287,NULL,NULL,'2012-04-11 00:00:00',56028,17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120411/1204111070634123111.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120411/jpg/1204111070634123111.master.jpg',NULL,NULL,60152971570,NULL,NULL,NULL,'2012-03-17 13:26:07',56003.559814,'2013-01-22 16:45:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204111070634123111/1204111070634123111.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120411/1204111070634123111p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,939890180,14685784,NULL,NULL,NULL,NULL),(18079,18079,0,'CSS120401-121337+462902','CRTS-CSS',183.40567,46.48375,NULL,NULL,'2012-04-01 00:00:00',56018,15.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120401/1204011460464119919.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120401/jpg/1204011460464119919.master.jpg',NULL,NULL,59058817574,NULL,NULL,NULL,'2012-02-26 13:26:07',55983.559814,'2013-01-22 16:45:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204011460464119919/1204011460464119919.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120401/1204011460464119919p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,922794024,14418656,NULL,NULL,NULL,NULL),(18080,18080,1,'CSS120401-140711+222253','CRTS-CSS',211.79471,22.38152,NULL,NULL,'2012-04-01 00:00:00',56018,19.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120401/1204011210724143746.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120401/jpg/1204011210724143746.master.jpg',NULL,NULL,59474847183,NULL,NULL,NULL,'2008-04-29 10:33:41',54585.440063,'2013-01-22 16:45:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1204011210724143746/1204011210724143746.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120401/1204011210724143746p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,929294487,14520226,NULL,NULL,NULL,NULL),(18081,18081,0,'CSS120328-152302+071141','CRTS-CSS',230.75707,7.19479,NULL,NULL,'2012-03-28 00:00:00',56014,17.78,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:21','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120328/1203281070824134397.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120328/jpg/1203281070824134397.master.jpg',NULL,NULL,56412697259,NULL,NULL,NULL,'2005-01-18 10:33:34',53388.439987,'2013-01-22 16:45:21','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203281070824134397/1203281070824134397.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120328/1203281070824134397p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,881448394,13772631,NULL,NULL,NULL,NULL),(18082,18082,1,'CSS120325-085554+254237','CRTS-CSS',133.97451,25.71026,NULL,NULL,'2012-03-25 00:00:00',56011,18.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120325/1203251260444104852.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120325/jpg/1203251260444104852.master.jpg',NULL,NULL,64308054068,NULL,NULL,NULL,'2010-11-07 12:28:49',55507.52002,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203251260444104852/1203251260444104852.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120325/1203251260444104852p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1004813344,15700208,NULL,NULL,NULL,NULL),(18083,18083,1,'CSS120325-123816-150632','CRTS-CSS',189.56747,-15.10893,NULL,NULL,'2012-03-25 00:00:00',56011,18.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120325/1203250150664136435.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120325/jpg/1203250150664136435.master.jpg',NULL,NULL,43938254876,NULL,NULL,NULL,'2009-04-18 10:33:41',54939.440063,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203250150664136435/1203250150664136435.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120325/1203250150664136435p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,686535232,10727113,NULL,NULL,NULL,NULL),(18084,18084,1,'CSS120323-115546+503457','CRTS-CSS',178.94363,50.58248,NULL,NULL,'2012-03-23 00:00:00',56009,18.96,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120323/1203231490434144506.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120323/jpg/1203231490434144506.master.jpg',NULL,NULL,61799060578,NULL,NULL,NULL,'2007-02-07 12:28:49',54138.52002,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203231490434144506/1203231490434144506.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120323/1203231490434144506p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,965610321,15087661,NULL,NULL,NULL,NULL),(18085,18085,1,'CSS120322-171646+414301','CRTS-CSS',259.19268,41.71687,NULL,NULL,'2012-03-22 00:00:00',56008,17.92,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120322/1203221400724152974.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120322/jpg/1203221400724152974.master.jpg',NULL,NULL,59649778488,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203221400724152974/1203221400724152974.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120322/1203221400724152974p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,932027788,14562934,NULL,NULL,NULL,NULL),(18086,18086,1,'CSS120321-125020+063058','CRTS-CSS',192.58142,6.51607,NULL,NULL,'2012-03-21 00:00:00',56007,19.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120321/1203211070684117141.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120321/jpg/1203211070684117141.master.jpg',NULL,NULL,58074172305,NULL,NULL,NULL,'2011-04-23 13:26:07',55674.559814,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203211070684117141/1203211070684117141.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120321/1203211070684117141p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,907408942,14178264,NULL,NULL,NULL,NULL),(18087,18087,1,'CSS120313-105530+145239','CRTS-CSS',163.8745,14.87758,NULL,NULL,'2012-03-13 00:00:00',55999,19.5,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120313/1203131150574115737.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120313/jpg/1203131150574115737.master.jpg',NULL,NULL,61199681425,NULL,NULL,NULL,'2008-12-30 10:33:41',54830.440063,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203131150574115737/1203131150574115737.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120313/1203131150574115737p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,956245022,14941328,NULL,NULL,NULL,NULL),(18088,18088,1,'CSS120303-095246-160215','CRTS-CSS',148.19043,-16.03758,NULL,NULL,'2012-03-03 00:00:00',55989,18.02,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120303/1203030150524112736.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120303/jpg/1203030150524112736.master.jpg',NULL,NULL,41179221210,NULL,NULL,NULL,'2012-02-24 13:26:07',55981.559814,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203030150524112736/1203030150524112736.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120303/1203030150524112736p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,643425331,10053520,NULL,NULL,NULL,NULL),(18089,18089,1,'CSS120302-145707+051018','CRTS-CSS',224.27802,5.17175,NULL,NULL,'2012-03-02 00:00:00',55988,19.19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120302/1203021040804135302.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120302/jpg/1203021040804135302.master.jpg',NULL,NULL,59335348671,NULL,NULL,NULL,'2011-04-03 10:33:30',55654.439941,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1203021040804135302/1203021040804135302.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120302/1203021040804135302p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,927114822,14486169,NULL,NULL,NULL,NULL),(18091,18091,1,'CSS120224-100531-013042','CRTS-CSS',151.37944,-1.51161,NULL,NULL,'2012-02-24 00:00:00',55981,18.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120224/1202240010544124757.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120224/jpg/1202240010544124757.master.jpg',NULL,NULL,41233455488,NULL,NULL,NULL,'2011-02-05 13:26:07',55597.559814,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202240010544124757/1202240010544124757.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120224/1202240010544124757p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,644272742,10066761,NULL,NULL,NULL,NULL),(18093,18093,1,'CSS120202-122706+073001','CRTS-CSS',186.77554,7.50031,NULL,NULL,'2012-02-02 00:00:00',55959,19.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120202/1202021070664129118.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120202/jpg/1202021070664129118.master.jpg',NULL,NULL,58236440250,NULL,NULL,NULL,'2012-01-01 13:26:07',55927.559814,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202021070664129118/1202021070664129118.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120202/1202021070664129118p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,909944378,14217880,NULL,NULL,NULL,NULL),(18094,18094,1,'CSS120201-112525+251604','CRTS-CSS',171.35281,25.26771,NULL,NULL,'2012-02-01 00:00:00',55958,19.24,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120201/1202011230574141827.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120201/jpg/1202011230574141827.master.jpg',NULL,NULL,60581947229,NULL,NULL,NULL,'2011-12-28 13:26:07',55923.559814,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1202011230574141827/1202011230574141827.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120201/1202011230574141827p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,946592925,14790514,NULL,NULL,NULL,NULL),(18095,18095,1,'CSS120127-003939-071615','CRTS-CSS',9.91338,-7.27096,NULL,NULL,'2012-01-27 00:00:00',55953,17.35,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120127/1201270070044115659.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120127/jpg/1201270070044115659.master.jpg',NULL,NULL,34622155169,NULL,NULL,NULL,'2012-01-03 13:26:07',55929.559814,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201270070044115659/1201270070044115659.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120127/1201270070044115659p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,540971174,8452674,NULL,NULL,NULL,NULL),(18096,18096,0,'CSS120126-003431+302406','CRTS-CSS',8.62847,30.40173,NULL,NULL,'2012-01-26 00:00:00',55952,17.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120126/1201261290034138053.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120126/jpg/1201261290034138053.master.jpg',NULL,NULL,67367911862,NULL,NULL,NULL,'2011-11-24 13:26:07',55889.559814,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201261290034138053/1201261290034138053.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120126/1201261290034138053p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1052623622,16447244,NULL,NULL,NULL,NULL),(18097,18097,1,'CSS120126-142127-173046','CRTS-CSS',215.36393,-17.51281,NULL,NULL,'2012-01-26 00:00:00',55952,18.69,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120126/1201260180744150980.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120126/jpg/1201260180744150980.master.jpg',NULL,NULL,46553178954,NULL,NULL,NULL,'2011-06-22 13:26:07',55734.559814,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201260180744150980/1201260180744150980.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120126/1201260180744150980p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,727393421,11365522,NULL,NULL,NULL,NULL),(18098,18098,1,'CSS120125-122958+100407','CRTS-CSS',187.48964,10.06858,NULL,NULL,'2012-01-25 00:00:00',55951,19.9,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120125/1201251090674127372.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120125/jpg/1201251090674127372.master.jpg',NULL,NULL,58191278534,NULL,NULL,NULL,'2007-12-17 12:28:49',54451.52002,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201251090674127372/1201251090674127372.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120125/1201251090674127372p.html',NULL,NULL,1,'VS',NULL,0,NULL,0,909238727,14206855,NULL,NULL,NULL,NULL),(18099,18099,1,'CSS120123-111134+342829','CRTS-CSS',167.89123,34.47464,NULL,NULL,'2012-01-23 00:00:00',55949,19.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120123/1201231350504110090.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120123/jpg/1201231350504110090.master.jpg',NULL,NULL,60635822762,NULL,NULL,NULL,'2007-06-22 13:26:29',54273.560059,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201231350504110090/1201231350504110090.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120123/1201231350504110090p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,947434730,14803667,NULL,NULL,NULL,NULL),(18100,18100,0,'CSS120121-094613+195028','CRTS-CSS',146.55353,19.84116,NULL,NULL,'2012-01-21 00:00:00',55947,18.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120121/1201211210504102902.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120121/jpg/1201211210504102902.master.jpg',NULL,NULL,63744635332,NULL,NULL,NULL,'2011-12-25 13:26:07',55920.559814,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201211210504102902/1201211210504102902.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120121/1201211210504102902p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,996009927,15562655,NULL,NULL,NULL,NULL),(18101,18101,0,'CSS120118-025828+061125','CRTS-CSS',44.61597,6.19037,NULL,NULL,'2012-01-18 00:00:00',55944,16.33,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120118/1201181070164109690.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120118/jpg/1201181070164109690.master.jpg',NULL,NULL,67969793303,NULL,NULL,NULL,'2011-11-29 11:31:10',55894.47998,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201181070164109690/1201181070164109690.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120118/1201181070164109690p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1062028020,16594187,NULL,NULL,NULL,NULL),(18102,18102,1,'CSS120113-140859+255011','CRTS-CSS',212.24586,25.83643,NULL,NULL,'2012-01-13 00:00:00',55939,17.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20120113/1201131260694106174.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120113/jpg/1201131260694106174.master.jpg',NULL,NULL,60002312283,NULL,NULL,NULL,'2007-03-27 13:26:23',54186.559998,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201131260694106174/1201131260694106174.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120113/1201131260694106174p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,937536129,14649002,NULL,NULL,NULL,NULL),(18103,18103,0,'CSS120104-003320+034817','CRTS-CSS',8.33141,3.80483,NULL,NULL,'2012-01-04 00:00:00',55930,17.82,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120104/1201041040034112466.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120104/jpg/1201041040034112466.master.jpg',NULL,NULL,66816759857,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:22','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201041040034112466/1201041040034112466.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120104/1201041040034112466p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1044011872,16312685,NULL,NULL,NULL,NULL),(18104,18104,0,'CSS120103-124714-100347','CRTS-CSS',191.80974,-10.06301,NULL,NULL,'2012-01-03 00:00:00',55929,12.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20120103/1201030090684120517.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20120103/jpg/1201030090684120517.master.jpg',NULL,NULL,43118023678,NULL,NULL,NULL,'2011-06-30 13:26:07',55742.559814,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1201030090684120517/1201030090684120517.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20120103/1201030090684120517p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,673719119,10526861,NULL,NULL,NULL,NULL),(18105,18105,1,'CSS111231-044049+063112','CRTS-CSS',70.2043,6.51988,NULL,NULL,'2011-12-31 00:00:00',55926,18.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111231/1112311070254117349.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111231/jpg/1112311070254117349.master.jpg',NULL,NULL,65359915818,NULL,NULL,NULL,'2005-10-01 12:28:47',53644.519989,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112311070254117349/1112311070254117349.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111231/1112311070254117349p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,1021248684,15957010,NULL,NULL,NULL,NULL),(18106,18106,0,'CSS111231-145323+025743','CRTS-CSS',223.34586,2.96198,NULL,NULL,'2011-12-31 00:00:00',55926,16.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111231/1112311040804104408.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111231/jpg/1112311040804104408.master.jpg',NULL,NULL,59326560839,NULL,NULL,NULL,'2011-07-02 13:26:07',55744.559814,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112311040804104408/1112311040804104408.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111231/1112311040804104408p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,926977513,14484023,NULL,NULL,NULL,NULL),(18107,18107,0,'CSS111230-143658+163057','CRTS-CSS',219.23971,16.51573,NULL,NULL,'2011-12-30 00:00:00',55925,18.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111230/1112301150764143883.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111230/jpg/1112301150764143883.master.jpg',NULL,NULL,59552506080,NULL,NULL,NULL,'2011-06-28 12:28:49',55740.52002,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112301150764143883/1112301150764143883.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111230/1112301150764143883p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,930507907,14539186,NULL,NULL,NULL,NULL),(18108,18108,0,'CSS111228-103551+410959','CRTS-CSS',158.96249,41.16649,NULL,NULL,'2011-12-28 00:00:00',55923,17.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111228/1112281400444128867.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111228/jpg/1112281400444128867.master.jpg',NULL,NULL,64152949880,NULL,NULL,NULL,'2007-11-13 13:26:29',54417.560059,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112281400444128867/1112281400444128867.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111228/1112281400444128867p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1002389841,15662341,NULL,NULL,NULL,NULL),(18109,18109,1,'CSS111227-021338-110933','CRTS-CSS',33.40748,-11.15906,NULL,NULL,'2011-12-27 00:00:00',55922,18.18,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111227/1112270090124101221.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111227/jpg/1112270090124101221.master.jpg',NULL,NULL,35129231515,NULL,NULL,NULL,'2006-12-22 13:26:23',54091.559998,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112270090124101221/1112270090124101221.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111227/1112270090124101221p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,548894242,8576472,NULL,NULL,NULL,NULL),(18110,18110,0,'CSS111227-044803-040823','CRTS-CSS',72.01064,-4.1396,NULL,NULL,'2011-12-27 00:00:00',55922,18.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111227/1112270040264130157.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111227/jpg/1112270040264130157.master.jpg',NULL,NULL,36582023790,NULL,NULL,NULL,'2011-11-28 13:26:07',55893.559814,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112270040264130157/1112270040264130157.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111227/1112270040264130157p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,571594121,8931158,NULL,NULL,NULL,NULL),(18111,18111,0,'CSS111225-081044+402530','CRTS-CSS',122.68145,40.4249,NULL,NULL,'2011-12-25 00:00:00',55920,18.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111225/1112251400344119989.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111225/jpg/1112251400344119989.master.jpg',NULL,NULL,63553070442,NULL,NULL,NULL,'2009-12-13 10:33:41',55178.440063,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1112251400344119989/1112251400344119989.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111225/1112251400344119989p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,993016725,15515886,NULL,NULL,NULL,NULL),(18112,18112,1,'CSS111130-000253-280119','CRTS-CSS',0.72228,-28.02207,NULL,NULL,'2011-11-30 00:00:00',55895,19.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111130/1111300260014103252.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111130/jpg/1111300260014103252.master.jpg',NULL,NULL,34821201057,NULL,NULL,NULL,'2011-10-21 13:26:07',55855.559814,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111300260014103252/1111300260014103252.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111130/1111300260014103252p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,544081266,8501269,NULL,NULL,NULL,NULL),(18113,18113,0,'CSS111129-233448+244502','CRTS-CSS',353.70084,24.75043,NULL,NULL,'2011-11-29 00:00:00',55894,16.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111129/1111291231164135344.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111129/jpg/1111291231164135344.master.jpg',NULL,NULL,52000226499,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111291231164135344/1111291231164135344.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111129/1111291231164135344p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,812503539,12695367,NULL,NULL,NULL,NULL),(18114,18114,1,'CSS111124-044711+073557','CRTS-CSS',71.7939,7.59911,NULL,NULL,'2011-11-24 00:00:00',55889,18.81,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111124/1111241070264146997.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111124/jpg/1111241070264146997.master.jpg',NULL,NULL,65357527096,NULL,NULL,NULL,'2011-11-16 13:26:07',55881.559814,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111241070264146997/1111241070264146997.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111124/1111241070264146997p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1021211360,15956427,NULL,NULL,NULL,NULL),(18115,18115,1,'CSS111122-025206+071046','CRTS-CSS',43.02493,7.17931,NULL,NULL,'2011-11-22 00:00:00',55887,18.78,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111122/1111221070164127486.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111122/jpg/1111221070164127486.master.jpg',NULL,NULL,67972716751,NULL,NULL,NULL,'2011-11-03 13:26:07',55868.559814,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111221070164127486/1111221070164127486.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111122/1111221070164127486p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1062073699,16594901,NULL,NULL,NULL,NULL),(18117,18117,1,'CSS111118-181200+501930','CRTS-CSS',273.00034,50.32503,NULL,NULL,'2011-11-18 00:00:00',55883,18.19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111118/1111181490664163515.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111118/jpg/1111181490664163515.master.jpg',NULL,NULL,52938121477,NULL,NULL,NULL,'2005-05-15 10:33:36',53505.440002,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111181490664163515/1111181490664163515.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111118/1111181490664163515p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,827158148,12924346,NULL,NULL,NULL,NULL),(18118,18118,1,'CSS111118-074033+240900','CRTS-CSS',115.13648,24.15011,NULL,NULL,'2011-11-18 00:00:00',55883,18.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111118/1111181230384140281.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111118/jpg/1111181230384140281.master.jpg',NULL,NULL,62948667151,NULL,NULL,NULL,'2011-10-15 13:26:07',55849.559814,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111181230384140281/1111181230384140281.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111118/1111181230384140281p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,983572924,15368326,NULL,NULL,NULL,NULL),(18119,18119,0,'CSS111117-010555-122049','CRTS-CSS',16.47769,-12.34684,NULL,NULL,'2011-11-17 00:00:00',55882,16.93,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111117/1111170120064131084.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111117/jpg/1111170120064131084.master.jpg',NULL,NULL,35378620068,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111170120064131084/1111170120064131084.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111117/1111170120064131084p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,552790938,8637358,NULL,NULL,NULL,NULL),(18120,18120,0,'CSS111103-221719+353449','CRTS-CSS',334.33105,35.58038,NULL,NULL,'2011-11-03 00:00:00',55868,16.24,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111103/1111031350994156252.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111103/jpg/1111031350994156252.master.jpg',NULL,NULL,55483993874,NULL,NULL,NULL,'2009-11-22 10:33:41',55157.440063,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111031350994156252/1111031350994156252.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111103/1111031350994156252p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,866937404,13545896,NULL,NULL,NULL,NULL),(18121,18121,1,'CSS111103-021902-110027','CRTS-CSS',34.7577,-11.00749,NULL,NULL,'2011-11-03 00:00:00',55868,19.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111103/1111030090134103780.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111103/jpg/1111030090134103780.master.jpg',NULL,NULL,35118066373,NULL,NULL,NULL,'2008-11-02 10:33:41',54772.440063,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1111030090134103780/1111030090134103780.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111103/1111030090134103780p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,548719787,8573746,NULL,NULL,NULL,NULL),(18122,18122,0,'CSS111030-024850-080430','CRTS-CSS',42.20706,-8.07505,NULL,NULL,'2011-10-30 00:00:00',55864,18.74,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111030/1110300070154106463.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111030/jpg/1110300070154106463.master.jpg',NULL,NULL,37909799225,NULL,NULL,NULL,'2005-10-08 13:26:23',53651.559998,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110300070154106463/1110300070154106463.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111030/1110300070154106463p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,592340612,9255322,NULL,NULL,NULL,NULL),(18123,18123,1,'CSS111028-013833+222556','CRTS-CSS',24.63774,22.43226,NULL,NULL,'2011-10-28 00:00:00',55862,19.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:23','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111028/1110281210094139926.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111028/jpg/1110281210094139926.master.jpg',NULL,NULL,67391250975,NULL,NULL,NULL,'2011-09-30 13:26:07',55834.559814,'2013-01-22 16:45:23','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110281210094139926/1110281210094139926.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111028/1110281210094139926p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1052988296,16452942,NULL,NULL,NULL,NULL),(18124,18124,1,'CSS111027-021241-055634','CRTS-CSS',33.17246,-5.94282,NULL,NULL,'2011-10-27 00:00:00',55861,19.23,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111027/1110270070124134909.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111027/jpg/1110270070124134909.master.jpg',NULL,NULL,35142463792,NULL,NULL,NULL,'2011-02-08 13:26:07',55600.559814,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110270070124134909/1110270070124134909.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111027/1110270070124134909p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,549100996,8579703,NULL,NULL,NULL,NULL),(18125,18125,1,'CSS111026-025825+351907','CRTS-CSS',44.60245,35.31864,NULL,NULL,'2011-10-26 00:00:00',55860,18.55,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111026/1110261350144140084.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111026/jpg/1110261350144140084.master.jpg',NULL,NULL,68719241550,NULL,NULL,NULL,'2008-12-29 10:33:41',54829.440063,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110261350144140084/1110261350144140084.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111026/1110261350144140084p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,1073738149,16777158,NULL,NULL,NULL,NULL),(18126,18126,0,'CSS111024-095848+344703','CRTS-CSS',149.70123,34.78424,NULL,NULL,'2011-10-24 00:00:00',55858,15.71,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111024/1110241350454116949.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111024/jpg/1110241350454116949.master.jpg',NULL,NULL,64062542228,NULL,NULL,NULL,'2011-04-29 13:26:07',55680.559814,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110241350454116949/1110241350454116949.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111024/1110241350454116949p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1000977222,15640269,NULL,NULL,NULL,NULL),(18127,18127,1,'CSS111023-170618+383220','CRTS-CSS',256.57545,38.53894,NULL,NULL,'2011-10-23 00:00:00',55857,18.72,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111023/1110231380744134000.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111023/jpg/1110231380744134000.master.jpg',NULL,NULL,59627575494,NULL,NULL,NULL,'2007-02-26 13:26:23',54157.559998,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110231380744134000/1110231380744134000.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111023/1110231380744134000p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,931680867,14557513,NULL,NULL,NULL,NULL),(18128,18128,0,'CSS111023-201210-112158','CRTS-CSS',303.04196,-11.36604,NULL,NULL,'2011-10-23 00:00:00',55857,16.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20111023/1110230121074196339.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111023/jpg/1110230121074196339.master.jpg',NULL,NULL,48009461238,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110230121074196339/1110230121074196339.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111023/1110230121074196339p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,750147831,11721059,NULL,NULL,NULL,NULL),(18129,18129,1,'CSS111017-013448+161423','CRTS-CSS',23.6982,16.23967,NULL,NULL,'2011-10-17 00:00:00',55851,19.25,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20111017/1110171150094126930.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20111017/jpg/1110171150094126930.master.jpg',NULL,NULL,67425816849,NULL,NULL,NULL,'2011-09-20 13:26:07',55824.559814,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1110171150094126930/1110171150094126930.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20111017/1110171150094126930p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1053528388,16461381,NULL,NULL,NULL,NULL),(18130,18130,0,'CSS110924-013343+344837','CRTS-CSS',23.42892,34.81032,NULL,NULL,'2011-09-24 00:00:00',55828,15.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110924/1109241350074121359.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110924/jpg/1109241350074121359.master.jpg',NULL,NULL,67765247858,NULL,NULL,NULL,'2005-06-16 11:31:10',53537.47998,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1109241350074121359/1109241350074121359.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110924/1109241350074121359p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1058831997,16544249,NULL,NULL,NULL,NULL),(18131,18131,0,'CSS110918-002046+065605','CRTS-CSS',5.1916,6.93477,NULL,NULL,'2011-09-18 00:00:00',55822,18.61,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110918/1109181070024115267.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110918/jpg/1109181070024115267.master.jpg',NULL,NULL,66794679796,NULL,NULL,NULL,'2011-06-28 13:26:07',55740.559814,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1109181070024115267/1109181070024115267.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110918/1109181070024115267p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1043666871,16307294,NULL,NULL,NULL,NULL),(18132,18132,0,'CSS110918-224027+031158','CRTS-CSS',340.11426,3.19944,NULL,NULL,'2011-09-18 00:00:00',55822,17.3,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110918/1109181041214105836.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110918/jpg/1109181041214105836.master.jpg',NULL,NULL,52426721747,NULL,NULL,NULL,'2011-07-02 13:26:07',55744.559814,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1109181041214105836/1109181041214105836.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110918/1109181041214105836p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,819167527,12799492,NULL,NULL,NULL,NULL),(18133,18133,0,'CSS110918-225820+021730','CRTS-CSS',344.58458,2.29163,NULL,NULL,'2011-09-18 00:00:00',55822,16.51,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110918/1109181011234130569.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110918/jpg/1109181011234130569.master.jpg',NULL,NULL,51734389057,NULL,NULL,NULL,'2010-05-31 12:28:49',55347.52002,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1109181011234130569/1109181011234130569.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110918/1109181011234130569p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,808349829,12630466,NULL,NULL,NULL,NULL),(18134,18134,0,'CSS110918-211224-074852','CRTS-CSS',318.10114,-7.81447,NULL,NULL,'2011-09-18 00:00:00',55822,16.55,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110918/1109180071134113477.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110918/jpg/1109180071134113477.master.jpg',NULL,NULL,50791196972,NULL,NULL,NULL,'2011-07-03 13:26:07',55745.559814,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1109180071134113477/1109180071134113477.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110918/1109180071134113477p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,793612452,12400194,NULL,NULL,NULL,NULL),(18135,18135,1,'CSS110703-141741+082232','CRTS-CSS',214.42066,8.37568,NULL,NULL,'2011-07-03 00:00:00',55745,18.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110703/1107031070764142675.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110703/jpg/1107031070764142675.master.jpg',NULL,NULL,58497779865,NULL,NULL,NULL,'2011-03-14 13:26:07',55634.559814,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1107031070764142675/1107031070764142675.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110703/1107031070764142675p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,914027810,14281684,NULL,NULL,NULL,NULL),(18136,18136,0,'CSS110703-220042-081542','CRTS-CSS',330.1761,-8.26167,NULL,NULL,'2011-07-03 00:00:00',55745,18.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110703/1107030071174105491.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110703/jpg/1107030071174105491.master.jpg',NULL,NULL,49923676318,NULL,NULL,NULL,'2011-06-04 13:26:07',55716.559814,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1107030071174105491/1107030071174105491.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110703/1107030071174105491p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,780057442,12188397,NULL,NULL,NULL,NULL),(18137,18137,0,'CSS110702-232920+032309','CRTS-CSS',352.33391,3.38582,NULL,NULL,'2011-07-02 00:00:00',55744,15.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110702/1107021041264109182.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110702/jpg/1107021041264109182.master.jpg',NULL,NULL,51583514553,NULL,NULL,NULL,'2009-12-16 10:33:41',55181.440063,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1107021041264109182/1107021041264109182.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110702/1107021041264109182p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,805992414,12593631,NULL,NULL,NULL,NULL),(18138,18138,1,'CSS110701-014551+143502','CRTS-CSS',26.4605,14.58386,NULL,NULL,'2011-07-01 00:00:00',55743,18.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110701/1107011150104107901.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110701/jpg/1107011150104107901.master.jpg',NULL,NULL,66940678083,NULL,NULL,NULL,'2009-09-11 10:33:41',55085.440063,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1107011150104107901/1107011150104107901.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110701/1107011150104107901p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1045948095,16342938,NULL,NULL,NULL,NULL),(18139,18139,1,'CSS110701-014408+124812','CRTS-CSS',26.03328,12.80337,NULL,NULL,'2011-07-01 00:00:00',55743,17.87,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110701/1107011120104119909.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110701/jpg/1107011120104119909.master.jpg',NULL,NULL,66926020098,NULL,NULL,NULL,'2005-09-23 13:26:23',53636.559998,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1107011120104119909/1107011120104119909.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110701/1107011120104119909p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1045719064,16339360,NULL,NULL,NULL,NULL),(18140,18140,0,'CSS110630-121607-033431','CRTS-CSS',184.03003,-3.57524,NULL,NULL,'2011-06-30 00:00:00',55742,17.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110630/1106300040664124267.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110630/jpg/1106300040664124267.master.jpg',NULL,NULL,43016711889,NULL,NULL,NULL,'2011-03-24 12:28:49',55644.52002,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106300040664124267/1106300040664124267.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110630/1106300040664124267p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,672136123,10502126,NULL,NULL,NULL,NULL),(18141,18141,1,'CSS110628-220857+200440','CRTS-CSS',332.23951,20.0777,NULL,NULL,'2011-06-28 00:00:00',55740,18.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110628/1106281211124109922.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110628/jpg/1106281211124109922.master.jpg',NULL,NULL,52227442083,NULL,NULL,NULL,'2009-04-30 10:33:41',54951.440063,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106281211124109922/1106281211124109922.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110628/1106281211124109922p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,816053782,12750840,NULL,NULL,NULL,NULL),(18142,18142,1,'CSS110624-153755+070942','CRTS-CSS',234.47792,7.16164,NULL,NULL,'2011-06-24 00:00:00',55736,16.36,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110624/1106241070834132854.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110624/jpg/1106241070834132854.master.jpg',NULL,NULL,56413894690,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106241070834132854/1106241070834132854.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110624/1106241070834132854p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,881467104,13772923,NULL,NULL,NULL,NULL),(18143,18143,0,'CSS110613-154852+625749','CRTS-CSS',237.21562,62.96358,NULL,NULL,'2011-06-13 00:00:00',55725,17.6,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110613/1106131630404111710.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110613/jpg/1106131630404111710.master.jpg',NULL,NULL,57734138241,NULL,NULL,NULL,'2007-06-24 11:31:10',54275.47998,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106131630404111710/1106131630404111710.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110613/1106131630404111710p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,902095910,14095248,NULL,NULL,NULL,NULL),(18144,18144,0,'CSS110611-153318+273428','CRTS-CSS',233.32325,27.57445,NULL,NULL,'2011-06-11 00:00:00',55723,18.93,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:24','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110611/1106111260764139610.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110611/jpg/1106111260764139610.master.jpg',NULL,NULL,59918248440,NULL,NULL,NULL,'2010-04-17 12:28:49',55303.52002,'2013-01-22 16:45:24','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106111260764139610/1106111260764139610.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110611/1106111260764139610p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,936222631,14628478,NULL,NULL,NULL,NULL),(18145,18145,0,'CSS110609-133005+471011','CRTS-CSS',202.52118,47.1697,NULL,NULL,'2011-06-09 00:00:00',55721,13.18,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110609/1106091460514127317.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110609/jpg/1106091460514127317.master.jpg',NULL,NULL,59290377790,NULL,NULL,NULL,'2009-07-31 12:28:49',55043.52002,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106091460514127317/1106091460514127317.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110609/1106091460514127317p.html',NULL,NULL,0,'VS',NULL,0,NULL,0,926412152,14475189,NULL,NULL,NULL,NULL),(18146,18146,1,'CSS110609-135501+413655','CRTS-CSS',208.7543,41.61521,NULL,NULL,'2011-06-09 00:00:00',55721,19.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110609/1106091400584128136.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110609/jpg/1106091400584128136.master.jpg',NULL,NULL,59273833944,NULL,NULL,NULL,'2009-01-31 13:26:29',54862.560059,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106091400584128136/1106091400584128136.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110609/1106091400584128136p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,926153655,14471150,NULL,NULL,NULL,NULL),(18147,18147,1,'CSS110609-151412+204632','CRTS-CSS',228.55061,20.7756,NULL,NULL,'2011-06-09 00:00:00',55721,17.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110609/1106091210774115315.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110609/jpg/1106091210774115315.master.jpg',NULL,NULL,59414698313,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106091210774115315/1106091210774115315.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110609/1106091210774115315p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,928354661,14505541,NULL,NULL,NULL,NULL),(18148,18148,1,'CSS110608-214804+043448','CRTS-CSS',327.01485,4.57992,NULL,NULL,'2011-06-08 00:00:00',55720,18.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110608/1106081041174137140.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110608/jpg/1106081041174137140.master.jpg',NULL,NULL,52324229487,NULL,NULL,NULL,'2011-05-03 13:26:07',55684.559814,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106081041174137140/1106081041174137140.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110608/1106081041174137140p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,817566085,12774470,NULL,NULL,NULL,NULL),(18149,18149,1,'CSS110607-113123-075009','CRTS-CSS',172.84414,-7.83581,NULL,NULL,'2011-06-07 00:00:00',55719,19.72,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110607/1106070070614107631.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110607/jpg/1106070070614107631.master.jpg',NULL,NULL,41067810313,NULL,NULL,NULL,'2011-03-06 13:26:07',55626.559814,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106070070614107631/1106070070614107631.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110607/1106070070614107631p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,641684536,10026320,NULL,NULL,NULL,NULL),(18150,18150,1,'CSS110607-111706-020617','CRTS-CSS',169.2731,-2.10465,NULL,NULL,'2011-06-07 00:00:00',55719,18.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110607/1106070010614108286.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110607/jpg/1106070010614108286.master.jpg',NULL,NULL,41038788265,NULL,NULL,NULL,'2007-03-11 10:33:36',54170.440002,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106070010614108286/1106070010614108286.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110607/1106070010614108286p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,641231066,10019235,NULL,NULL,NULL,NULL),(18151,18151,0,'CSS110606-140915-011055','CRTS-CSS',212.31372,-1.18187,NULL,NULL,'2011-06-06 00:00:00',55718,18.8,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110606/1106060010764124342.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110606/jpg/1106060010764124342.master.jpg',NULL,NULL,43590823314,NULL,NULL,NULL,'2005-05-04 12:28:47',53494.519989,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106060010764124342/1106060010764124342.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110606/1106060010764124342p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,681106614,10642290,NULL,NULL,NULL,NULL),(18152,18152,0,'CSS110604-155919-074418','CRTS-CSS',239.83051,-7.73832,NULL,NULL,'2011-06-04 00:00:00',55716,17.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2020-02-19 21:21:21','http://nesssi.cacr.caltech.edu/catalina/20110604/1106040070854120186.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110604/jpg/1106040070854120186.master.jpg',NULL,NULL,45628529729,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106040070854120186/1106040070854120186.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110604/1106040070854120186p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,712945777,11139777,NULL,NULL,NULL,NULL),(18153,18153,0,'CSS110604-130707-011044','CRTS-CSS',196.77788,-1.1789,NULL,NULL,'2011-06-04 00:00:00',55716,15.8,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110604/1106040010704126932.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110604/jpg/1106040010704126932.master.jpg',NULL,NULL,43143375443,NULL,NULL,NULL,'2011-05-25 13:26:07',55706.559814,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106040010704126932/1106040010704126932.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110604/1106040010704126932p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,674115241,10533050,NULL,NULL,NULL,NULL),(18154,18154,0,'CSS110602-153001+245229','CRTS-CSS',232.50583,24.87474,NULL,NULL,'2011-06-02 00:00:00',55714,19.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110602/1106021230774137681.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110602/jpg/1106021230774137681.master.jpg',NULL,NULL,59416998720,NULL,NULL,NULL,'2009-03-22 13:26:29',54912.560059,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1106021230774137681/1106021230774137681.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110602/1106021230774137681p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,928390605,14506103,NULL,NULL,NULL,NULL),(18155,18155,1,'CSS110527-135427+305803','CRTS-CSS',208.61269,30.96741,NULL,NULL,'2011-05-27 00:00:00',55708,19.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110527/1105271290664147324.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110527/jpg/1105271290664147324.master.jpg',NULL,NULL,59127942051,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105271290664147324/1105271290664147324.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110527/1105271290664147324p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,923874094,14435532,NULL,NULL,NULL,NULL),(18156,18156,0,'CSS110527-134355+253253','CRTS-CSS',205.97898,25.54803,NULL,NULL,'2011-05-27 00:00:00',55708,19.47,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110527/1105271260674101879.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110527/jpg/1105271260674101879.master.jpg',NULL,NULL,59123617108,NULL,NULL,NULL,'2010-05-23 10:33:30',55339.439941,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105271260674101879/1105271260674101879.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110527/1105271260674101879p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,923806517,14434476,NULL,NULL,NULL,NULL),(18158,18158,1,'CSS110525-205007-035021','CRTS-CSS',312.52885,-3.83924,NULL,NULL,'2011-05-25 00:00:00',55706,18.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110525/1105250041124147194.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110525/jpg/1105250041124147194.master.jpg',NULL,NULL,50741519303,NULL,NULL,NULL,'2011-04-28 13:26:07',55679.559814,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105250041124147194/1105250041124147194.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110525/1105250041124147194p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,792836239,12388066,NULL,NULL,NULL,NULL),(18159,18159,0,'CSS110520-123125+290751','CRTS-CSS',187.85384,29.13082,NULL,NULL,'2011-05-20 00:00:00',55701,17.07,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110520/1105201290594110800.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110520/jpg/1105201290594110800.master.jpg',NULL,NULL,58775188988,NULL,NULL,NULL,'2011-03-05 13:26:07',55625.559814,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105201290594110800/1105201290594110800.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110520/1105201290594110800p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,918362327,14349411,NULL,NULL,NULL,NULL),(18160,18160,0,'CSS110512-134906+171400','CRTS-CSS',207.2746,17.23347,NULL,NULL,'2011-05-12 00:00:00',55693,17.38,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110512/1105121180714104146.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110512/jpg/1105121180714104146.master.jpg',NULL,NULL,58380481327,NULL,NULL,NULL,'2011-04-25 13:26:07',55676.559814,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105121180714104146/1105121180714104146.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110512/1105121180714104146p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,912195020,14253047,NULL,NULL,NULL,NULL),(18161,18161,0,'CSS110512-134903-280359','CRTS-CSS',207.26349,-28.06649,NULL,NULL,'2011-05-12 00:00:00',55693,16.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110512/1105120260674103467.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110512/jpg/1105120260674103467.master.jpg',NULL,NULL,46855711115,NULL,NULL,NULL,'2010-05-17 13:26:07',55333.559814,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105120260674103467/1105120260674103467.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110512/1105120260674103467p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,732120486,11439382,NULL,NULL,NULL,NULL),(18162,18162,0,'CSS110504-122228+374940','CRTS-CSS',185.61627,37.82764,NULL,NULL,'2011-05-04 00:00:00',55685,19.34,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110504/1105041380544116798.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110504/jpg/1105041380544116798.master.jpg',NULL,NULL,58585096671,NULL,NULL,NULL,'2008-02-19 10:33:41',54515.440063,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105041380544116798/1105041380544116798.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110504/1105041380544116798p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,915392135,14303002,NULL,NULL,NULL,NULL),(18163,18163,0,'CSS110504-121124+372552','CRTS-CSS',182.85037,37.43124,NULL,NULL,'2011-05-04 00:00:00',55685,19.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110504/1105041380534110947.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110504/jpg/1105041380534110947.master.jpg',NULL,NULL,58547157852,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105041380534110947/1105041380534110947.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110504/1105041380534110947p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,914799341,14293739,NULL,NULL,NULL,NULL),(18164,18164,1,'CSS110501-094825+204333','CRTS-CSS',147.1033,20.72589,NULL,NULL,'2011-05-01 00:00:00',55682,18.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110501/1105011210504111881.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110501/jpg/1105011210504111881.master.jpg',NULL,NULL,63697200728,NULL,NULL,NULL,'2006-05-11 10:33:36',53866.440002,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1105011210504111881/1105011210504111881.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110501/1105011210504111881p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,995268761,15551074,NULL,NULL,NULL,NULL),(18165,18165,1,'CSS110429-105026+182857','CRTS-CSS',162.60986,18.48258,NULL,NULL,'2011-04-29 00:00:00',55680,19.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:25','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110429/1104291180564125364.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110429/jpg/1104291180564125364.master.jpg',NULL,NULL,61160978079,NULL,NULL,NULL,'2006-05-03 12:28:49',53858.52002,'2013-01-22 16:45:25','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104291180564125364/1104291180564125364.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110429/1104291180564125364p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,955640282,14931879,NULL,NULL,NULL,NULL),(18166,18166,1,'CSS110429-143859+125116','CRTS-CSS',219.74676,12.85449,NULL,NULL,'2011-04-29 00:00:00',55680,19.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110429/1104291120774130563.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110429/jpg/1104291120774130563.master.jpg',NULL,NULL,59544351176,NULL,NULL,NULL,'2009-01-02 12:28:49',54833.52002,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104291120774130563/1104291120774130563.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110429/1104291120774130563p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,930380487,14537195,NULL,NULL,NULL,NULL),(18167,18167,0,'CSS110429-211759-023723','CRTS-CSS',319.49697,-2.62299,NULL,NULL,'2011-04-29 00:00:00',55680,18.89,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110429/1104290011144106641.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110429/jpg/1104290011144106641.master.jpg',NULL,NULL,49673229845,NULL,NULL,NULL,'2009-05-01 12:28:49',54952.52002,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104290011144106641/1104290011144106641.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110429/1104290011144106641p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,776144216,12127253,NULL,NULL,NULL,NULL),(18168,18168,1,'CSS110428-094544+410738','CRTS-CSS',146.43237,41.12721,NULL,NULL,'2011-04-28 00:00:00',55679,18.96,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110428/1104281400414125978.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110428/jpg/1104281400414125978.master.jpg',NULL,NULL,63972361139,NULL,NULL,NULL,'2011-01-08 11:31:10',55569.47998,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104281400414125978/1104281400414125978.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110428/1104281400414125978p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,999568142,15618252,NULL,NULL,NULL,NULL),(18169,18169,0,'CSS110427-120801+491333','CRTS-CSS',182.00451,49.22584,NULL,NULL,'2011-04-27 00:00:00',55678,18.82,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110427/1104271490444118661.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110427/jpg/1104271490444118661.master.jpg',NULL,NULL,57188540208,NULL,NULL,NULL,'2009-03-02 12:28:49',54892.52002,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104271490444118661/1104271490444118661.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110427/1104271490444118661p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,893570940,13962045,NULL,NULL,NULL,NULL),(18170,18170,0,'CSS110426-220452+124613','CRTS-CSS',331.21569,12.77029,NULL,NULL,'2011-04-26 00:00:00',55677,18.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110426/1104261121164126921.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110426/jpg/1104261121164126921.master.jpg',NULL,NULL,52256493064,NULL,NULL,NULL,'2010-11-11 13:26:07',55511.559814,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104261121164126921/1104261121164126921.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110426/1104261121164126921p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,816507704,12757932,NULL,NULL,NULL,NULL),(18171,18171,1,'CSS110425-135607+231520','CRTS-CSS',209.02851,23.25562,NULL,NULL,'2011-04-25 00:00:00',55676,19.09,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110425/1104251230694109750.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110425/jpg/1104251230694109750.master.jpg',NULL,NULL,59462594682,NULL,NULL,NULL,'2010-05-12 13:26:07',55328.559814,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104251230694109750/1104251230694109750.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110425/1104251230694109750p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,929103041,14517235,NULL,NULL,NULL,NULL),(18172,18172,0,'CSS110414-170342+324553','CRTS-CSS',255.92409,32.7646,NULL,NULL,'2011-04-14 00:00:00',55665,19.06,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110414/1104141320794138720.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110414/jpg/1104141320794138720.master.jpg',NULL,NULL,56352719821,NULL,NULL,NULL,'2011-01-27 13:26:07',55588.559814,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104141320794138720/1104141320794138720.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110414/1104141320794138720p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,880511247,13757988,NULL,NULL,NULL,NULL),(18173,18173,0,'CSS110414-145909+071804','CRTS-CSS',224.78856,7.30117,NULL,NULL,'2011-04-14 00:00:00',55665,15.81,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110414/1104141070804123992.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110414/jpg/1104141070804123992.master.jpg',NULL,NULL,59387953419,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104141070804123992/1104141070804123992.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110414/1104141070804123992p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,927936772,14499012,NULL,NULL,NULL,NULL),(18174,18174,0,'CSS110412-130254-040235','CRTS-CSS',195.72318,-4.04319,NULL,NULL,'2011-04-12 00:00:00',55663,18.62,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110412/1104120040704127317.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110412/jpg/1104120040704127317.master.jpg',NULL,NULL,43147375430,NULL,NULL,NULL,'2010-06-15 13:26:07',55362.559814,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104120040704127317/1104120040704127317.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110412/1104120040704127317p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,674177741,10534027,NULL,NULL,NULL,NULL),(18175,18175,1,'CSS110408-131037+381538','CRTS-CSS',197.6558,38.26059,NULL,NULL,'2011-04-08 00:00:00',55659,19.54,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110408/1104081380574122732.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110408/jpg/1104081380574122732.master.jpg',NULL,NULL,59304586625,NULL,NULL,NULL,'2006-01-11 10:33:36',53746.440002,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104081380574122732/1104081380574122732.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110408/1104081380574122732p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,926634166,14478658,NULL,NULL,NULL,NULL),(18176,18176,0,'CSS110405-092253+215916','CRTS-CSS',140.71923,21.98784,NULL,NULL,'2011-04-05 00:00:00',55656,16.31,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110405/1104051210484136574.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110405/jpg/1104051210484136574.master.jpg',NULL,NULL,63716527558,NULL,NULL,NULL,'2008-05-06 10:33:41',54592.440063,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104051210484136574/1104051210484136574.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110405/1104051210484136574p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,995570743,15555792,NULL,NULL,NULL,NULL),(18177,18177,1,'CSS110405-141104+011153','CRTS-CSS',212.76874,1.19808,NULL,NULL,'2011-04-05 00:00:00',55656,19.9,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110405/1104051010764122544.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110405/jpg/1104051010764122544.master.jpg',NULL,NULL,58401796454,NULL,NULL,NULL,'2011-01-30 13:26:07',55591.559814,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104051010764122544/1104051010764122544.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110405/1104051010764122544p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,912528069,14258251,NULL,NULL,NULL,NULL),(18178,18178,1,'CSS110402-131115+543404','CRTS-CSS',197.81259,54.56785,NULL,NULL,'2011-04-02 00:00:00',55653,18.31,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110402/1104021550424114003.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110402/jpg/1104021550424114003.master.jpg',NULL,NULL,57427538636,NULL,NULL,NULL,'2011-03-15 13:26:07',55635.559814,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1104021550424114003/1104021550424114003.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110402/1104021550424114003p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,897305291,14020395,NULL,NULL,NULL,NULL),(18179,18179,0,'CSS110330-153559+211843','CRTS-CSS',233.99481,21.31189,NULL,NULL,'2011-03-30 00:00:00',55650,19.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110330/1103301210794125313.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110330/jpg/1103301210794125313.master.jpg',NULL,NULL,59458172636,NULL,NULL,NULL,'2006-03-25 12:28:49',53819.52002,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103301210794125313/1103301210794125313.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110330/1103301210794125313p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,929033947,14516155,NULL,NULL,NULL,NULL),(18180,18180,1,'CSS110328-150718+265338','CRTS-CSS',226.82531,26.89378,NULL,NULL,'2011-03-28 00:00:00',55648,19.99,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110328/1103281260744127610.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110328/jpg/1103281260744127610.master.jpg',NULL,NULL,59898294342,NULL,NULL,NULL,'2007-02-25 12:28:49',54156.52002,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103281260744127610/1103281260744127610.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110328/1103281260744127610p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,935910849,14623607,NULL,NULL,NULL,NULL),(18181,18181,1,'CSS110325-111951-002144','CRTS-CSS',169.96243,-0.36227,NULL,NULL,'2011-03-25 00:00:00',55645,18.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110325/1103250010614139940.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110325/jpg/1103250010614139940.master.jpg',NULL,NULL,40819662930,NULL,NULL,NULL,'2005-12-02 10:33:36',53706.440002,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103250010614139940/1103250010614139940.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110325/1103250010614139940p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,637807233,9965738,NULL,NULL,NULL,NULL),(18182,18182,0,'CSS110316-142905+415445','CRTS-CSS',217.271,41.91241,NULL,NULL,'2011-03-16 00:00:00',55636,17.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110316/1103161400604128161.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110316/jpg/1103161400604128161.master.jpg',NULL,NULL,59947651582,NULL,NULL,NULL,'2010-06-23 13:26:07',55370.559814,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103161400604128161/1103161400604128161.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110316/1103161400604128161p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,936682055,14635657,NULL,NULL,NULL,NULL),(18183,18183,1,'CSS110312-093827+525806','CRTS-CSS',144.61048,52.96845,NULL,NULL,'2011-03-12 00:00:00',55632,19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110312/1103121520334134087.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110312/jpg/1103121520334134087.master.jpg',NULL,NULL,63967220108,NULL,NULL,NULL,'2009-01-31 10:33:41',54862.440063,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103121520334134087/1103121520334134087.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110312/1103121520334134087p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,999487814,15616997,NULL,NULL,NULL,NULL),(18184,18184,1,'CSS110310-030301-012439','CRTS-CSS',45.75382,-1.41078,NULL,NULL,'2011-03-10 00:00:00',55630,18.56,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110310/1103100010174116151.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110310/jpg/1103100010174116151.master.jpg',NULL,NULL,37849974664,NULL,NULL,NULL,'2005-01-16 11:31:11',53386.479996,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103100010174116151/1103100010174116151.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110310/1103100010174116151p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,591405854,9240716,NULL,NULL,NULL,NULL),(18185,18185,1,'CSS110309-132708+282620','CRTS-CSS',201.78492,28.43881,NULL,NULL,'2011-03-09 00:00:00',55629,20.29,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110309/1103091290644104724.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110309/jpg/1103091290644104724.master.jpg',NULL,NULL,58658004014,NULL,NULL,NULL,'2011-02-25 13:26:07',55617.559814,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103091290644104724/1103091290644104724.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110309/1103091290644104724p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,916531312,14320801,NULL,NULL,NULL,NULL),(18186,18186,0,'CSS110309-135547+211127','CRTS-CSS',208.94764,21.19074,NULL,NULL,'2011-03-09 00:00:00',55629,18.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:26','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110309/1103091210714125129.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110309/jpg/1103091210714125129.master.jpg',NULL,NULL,58319712004,NULL,NULL,NULL,'2007-03-10 11:31:15',54169.480042,'2013-01-22 16:45:26','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103091210714125129/1103091210714125129.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110309/1103091210714125129p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,911245500,14238210,NULL,NULL,NULL,NULL),(18187,18187,0,'CSS110308-133656+215742','CRTS-CSS',204.23166,21.96171,NULL,NULL,'2011-03-08 00:00:00',55628,17.95,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110308/1103081210694128465.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110308/jpg/1103081210694128465.master.jpg',NULL,NULL,58804001615,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103081210694128465/1103081210694128465.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110308/1103081210694128465p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,918812525,14356445,NULL,NULL,NULL,NULL),(18188,18188,1,'CSS110302-121911+183052','CRTS-CSS',184.79673,18.51439,NULL,NULL,'2011-03-02 00:00:00',55622,19.64,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110302/1103021180644127479.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110302/jpg/1103021180644127479.master.jpg',NULL,NULL,58862103780,NULL,NULL,NULL,'2010-05-08 11:31:10',55324.47998,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103021180644127479/1103021180644127479.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110302/1103021180644127479p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,919720371,14370630,NULL,NULL,NULL,NULL),(18189,18189,1,'CSS110302-124524-051313','CRTS-CSS',191.35028,-5.22021,NULL,NULL,'2011-03-02 00:00:00',55622,19.56,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110302/1103020040694108268.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110302/jpg/1103020040694108268.master.jpg',NULL,NULL,43176293321,NULL,NULL,NULL,'2010-06-15 13:26:07',55362.559814,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1103020040694108268/1103020040694108268.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110302/1103020040694108268p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,674629583,10541087,NULL,NULL,NULL,NULL),(18190,18190,1,'CSS110226-113725+324922','CRTS-CSS',174.35528,32.82285,NULL,NULL,'2011-02-26 00:00:00',55618,18.21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110226/1102261320544131285.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110226/jpg/1102261320544131285.master.jpg',NULL,NULL,60629240610,NULL,NULL,NULL,'2006-03-23 12:28:49',53817.52002,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102261320544131285/1102261320544131285.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110226/1102261320544131285p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,947331884,14802060,NULL,NULL,NULL,NULL),(18191,18191,1,'CSS110225-132210+285258','CRTS-CSS',200.54172,28.88286,NULL,NULL,'2011-02-25 00:00:00',55617,19.36,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110225/1102251290634109720.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110225/jpg/1102251290634109720.master.jpg',NULL,NULL,58712649632,NULL,NULL,NULL,'2008-12-07 10:33:41',54807.440063,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102251290634109720/1102251290634109720.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110225/1102251290634109720p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,917385150,14334142,NULL,NULL,NULL,NULL),(18192,18192,1,'CSS110223-103018+080347','CRTS-CSS',157.5749,8.06319,NULL,NULL,'2011-02-23 00:00:00',55615,18.16,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110223/1102231070564133502.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110223/jpg/1102231070564133502.master.jpg',NULL,NULL,61043757204,NULL,NULL,NULL,'2011-02-04 10:33:30',55596.439941,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102231070564133502/1102231070564133502.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110223/1102231070564133502p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,953808706,14903261,NULL,NULL,NULL,NULL),(18193,18193,1,'CSS110212-133216+070113','CRTS-CSS',203.06683,7.02025,NULL,NULL,'2011-02-12 00:00:00',55604,19.28,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110212/1102121070724121825.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110212/jpg/1102121070724121825.master.jpg',NULL,NULL,58947795369,NULL,NULL,NULL,'2009-01-19 12:28:49',54850.52002,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102121070724121825/1102121070724121825.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110212/1102121070724121825p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,921059302,14391551,NULL,NULL,NULL,NULL),(18194,18194,1,'CSS110212-131404+074013','CRTS-CSS',198.51686,7.67036,NULL,NULL,'2011-02-12 00:00:00',55604,19.69,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110212/1102121070714133319.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110212/jpg/1102121070714133319.master.jpg',NULL,NULL,58978966035,NULL,NULL,NULL,'2011-01-04 13:26:07',55565.559814,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102121070714133319/1102121070714133319.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110212/1102121070714133319p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,921546344,14399161,NULL,NULL,NULL,NULL),(18195,18195,1,'CSS110209-143913-005521','CRTS-CSS',219.80482,-0.92257,NULL,NULL,'2011-02-09 00:00:00',55601,18.85,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110209/1102090010794130412.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110209/jpg/1102090010794130412.master.jpg',NULL,NULL,43491205071,NULL,NULL,NULL,'2011-01-30 10:33:30',55591.439941,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102090010794130412/1102090010794130412.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110209/1102090010794130412p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,679550079,10617969,NULL,NULL,NULL,NULL),(18196,18196,1,'CSS110207-043746-190553','CRTS-CSS',69.44352,-19.09799,NULL,NULL,'2011-02-07 00:00:00',55599,18.39,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110207/1102070180244109718.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110207/jpg/1102070180244109718.master.jpg',NULL,NULL,37366175740,NULL,NULL,NULL,'2005-10-30 11:31:10',53673.47998,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102070180244109718/1102070180244109718.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110207/1102070180244109718p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,583846495,9122601,NULL,NULL,NULL,NULL),(18197,18197,0,'CSS110205-102656+182907','CRTS-CSS',156.73422,18.4854,NULL,NULL,'2011-02-05 00:00:00',55597,18.5,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110205/1102051180544128471.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110205/jpg/1102051180544128471.master.jpg',NULL,NULL,60995314047,NULL,NULL,NULL,'2011-01-26 13:26:07',55587.559814,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1102051180544128471/1102051180544128471.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110205/1102051180544128471p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,953051781,14891434,NULL,NULL,NULL,NULL),(18199,18199,1,'CSS110130-095426+445811','CRTS-CSS',148.60988,44.96966,NULL,NULL,'2011-01-30 00:00:00',55591,17.41,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110130/1101301430404147758.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110130/jpg/1101301430404147758.master.jpg',NULL,NULL,63978896698,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101301430404147758/1101301430404147758.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110130/1101301430404147758p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,999670260,15619847,NULL,NULL,NULL,NULL),(18200,18200,1,'CSS110124-103601+104234','CRTS-CSS',159.00433,10.70955,NULL,NULL,'2011-01-24 00:00:00',55585,18.65,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110124/1101241090574129503.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110124/jpg/1101241090574129503.master.jpg',NULL,NULL,61045249823,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101241090574129503/1101241090574129503.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110124/1101241090574129503p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,953832028,14903625,NULL,NULL,NULL,NULL),(18201,18201,1,'CSS110116-114913+382427','CRTS-CSS',177.30588,38.40739,NULL,NULL,'2011-01-16 00:00:00',55577,18.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110116/1101161380514121768.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110116/jpg/1101161380514121768.master.jpg',NULL,NULL,60456050197,NULL,NULL,NULL,'2010-05-21 13:26:07',55337.559814,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101161380514121768/1101161380514121768.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110116/1101161380514121768p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,944625784,14759777,NULL,NULL,NULL,NULL),(18202,18202,1,'CSS110116-112442+365842','CRTS-CSS',171.1742,36.97837,NULL,NULL,'2011-01-16 00:00:00',55577,18.42,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110116/1101161380494104920.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110116/jpg/1101161380494104920.master.jpg',NULL,NULL,60428198780,NULL,NULL,NULL,'2009-03-21 10:33:41',54911.440063,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101161380494104920/1101161380494104920.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110116/1101161380494104920p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,944190605,14752978,NULL,NULL,NULL,NULL),(18203,18203,1,'CSS110115-133506+182923','CRTS-CSS',203.77373,18.4896,NULL,NULL,'2011-01-15 00:00:00',55576,19.81,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110115/1101151180704125371.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110115/jpg/1101151180704125371.master.jpg',NULL,NULL,58845538060,NULL,NULL,NULL,'2005-01-01 12:28:48',53371.520004,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101151180704125371/1101151180704125371.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110115/1101151180704125371p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,919461532,14366586,NULL,NULL,NULL,NULL),(18204,18204,0,'CSS110114-091354-170039','CRTS-CSS',138.47521,-17.01092,NULL,NULL,'2011-01-14 00:00:00',55575,17.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110114/1101140180484163514.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110114/jpg/1101140180484163514.master.jpg',NULL,NULL,42373225901,NULL,NULL,NULL,'2006-01-31 10:33:36',53766.440002,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101140180484163514/1101140180484163514.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110114/1101140180484163514p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,662081654,10345025,NULL,NULL,NULL,NULL),(18207,18207,0,'CSS110108-105044+280049','CRTS-CSS',162.68416,28.01361,NULL,NULL,'2011-01-08 00:00:00',55569,18.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110108/1101081260534135780.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110108/jpg/1101081260534135780.master.jpg',NULL,NULL,60529360853,NULL,NULL,NULL,'2009-12-18 12:28:49',55183.52002,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101081260534135780/1101081260534135780.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110108/1101081260534135780p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,945771263,14777675,NULL,NULL,NULL,NULL),(18208,18208,0,'CSS110105-091911+394229','CRTS-CSS',139.79772,39.7081,NULL,NULL,'2011-01-05 00:00:00',55566,18.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:27','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20110105/1101051400394103098.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110105/jpg/1101051400394103098.master.jpg',NULL,NULL,64397419953,NULL,NULL,NULL,'2006-11-20 13:26:23',54059.559998,'2013-01-22 16:45:27','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101051400394103098/1101051400394103098.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110105/1101051400394103098p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1006209686,15722026,NULL,NULL,NULL,NULL),(18209,18209,1,'CSS110104-121834+065950','CRTS-CSS',184.64314,6.99726,NULL,NULL,'2011-01-04 00:00:00',55565,19.66,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110104/1101041070664219915.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110104/jpg/1101041070664219915.master.jpg',NULL,NULL,58205095786,NULL,NULL,NULL,'2009-02-01 13:26:29',54863.560059,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101041070664219915/1101041070664219915.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110104/1101041070664219915p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,909454621,14210228,NULL,NULL,NULL,NULL),(18210,18210,1,'CSS110104-233650-105925','CRTS-CSS',354.20702,-10.99031,NULL,NULL,'2011-01-04 00:00:00',55565,19.33,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110104/1101040091254103774.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110104/jpg/1101040091254103774.master.jpg',NULL,NULL,49618777468,NULL,NULL,NULL,'2010-11-30 13:26:07',55530.559814,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101040091254103774/1101040091254103774.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110104/1101040091254103774p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,775293397,12113959,NULL,NULL,NULL,NULL),(18211,18211,1,'CSS110103-090237+382708','CRTS-CSS',135.6529,38.45209,NULL,NULL,'2011-01-03 00:00:00',55564,19.6,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20110103/1101031380394131761.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20110103/jpg/1101031380394131761.master.jpg',NULL,NULL,64412598611,NULL,NULL,NULL,'2008-12-04 10:33:41',54804.440063,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1101031380394131761/1101031380394131761.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20110103/1101031380394131761p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1006446853,15725732,NULL,NULL,NULL,NULL),(18212,18212,0,'CSS101213-015021-214432','CRTS-CSS',27.58885,-21.74218,NULL,NULL,'2010-12-13 00:00:00',55543,18.16,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101213/1012130210104111544.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101213/jpg/1012130210104111544.master.jpg',NULL,NULL,35034164448,NULL,NULL,NULL,'2010-11-13 13:26:07',55513.559814,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1012130210104111544/1012130210104111544.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101213/1012130210104111544p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,547408819,8553262,NULL,NULL,NULL,NULL),(18213,18213,0,'CSS101211-101243+355402','CRTS-CSS',153.17794,35.90064,NULL,NULL,'2010-12-11 00:00:00',55541,16.64,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-11 20:38:49','http://nesssi.cacr.caltech.edu/catalina/20101211/1012111350464134032.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101211/jpg/1012111350464134032.master.jpg',NULL,NULL,64066848845,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1012111350464134032/1012111350464134032.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101211/1012111350464134032p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1001044513,15641320,NULL,NULL,NULL,NULL),(18214,18214,1,'CSS101211-104024+332134','CRTS-CSS',160.09824,33.35958,NULL,NULL,'2010-12-11 00:00:00',55541,18.83,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101211/1012111320494136424.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101211/jpg/1012111320494136424.master.jpg',NULL,NULL,64052830904,NULL,NULL,NULL,'2010-01-06 11:31:10',55202.47998,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1012111320494136424/1012111320494136424.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101211/1012111320494136424p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1000825482,15637898,NULL,NULL,NULL,NULL),(18215,18215,1,'CSS101210-013241+343809','CRTS-CSS',23.17204,34.63594,NULL,NULL,'2010-12-10 00:00:00',55540,17.72,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101210/1012101350074116323.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101210/jpg/1012101350074116323.master.jpg',NULL,NULL,67765101998,NULL,NULL,NULL,'2005-06-16 13:26:23',53537.559998,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1012101350074116323/1012101350074116323.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101210/1012101350074116323p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1058829718,16544214,NULL,NULL,NULL,NULL),(18216,18216,0,'CSS101210-045030-104417','CRTS-CSS',72.62422,-10.73806,NULL,NULL,'2010-12-10 00:00:00',55540,17.96,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101210/1012100090264109952.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101210/jpg/1012100090264109952.master.jpg',NULL,NULL,37492211080,NULL,NULL,NULL,'2010-11-16 13:26:07',55516.559814,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1012100090264109952/1012100090264109952.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101210/1012100090264109952p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,585815798,9153371,NULL,NULL,NULL,NULL),(18217,18217,1,'CSS101206-010931-101305','CRTS-CSS',17.38065,-10.21814,NULL,NULL,'2010-12-06 00:00:00',55536,18.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101206/1012060090074115654.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101206/jpg/1012060090074115654.master.jpg',NULL,NULL,35254860559,NULL,NULL,NULL,'2010-11-08 13:26:07',55508.559814,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1012060090074115654/1012060090074115654.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101206/1012060090074115654p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,550857196,8607143,NULL,NULL,NULL,NULL),(18218,18218,0,'CSS101203-085402+350312','CRTS-CSS',133.50923,35.05331,NULL,NULL,'2010-12-03 00:00:00',55533,18.96,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101203/1012031350404119449.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101203/jpg/1012031350404119449.master.jpg',NULL,NULL,64420623966,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1012031350404119449/1012031350404119449.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101203/1012031350404119449p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1006572249,15727691,NULL,NULL,NULL,NULL),(18219,18219,1,'CSS101128-025330+094536','CRTS-CSS',43.37624,9.76,NULL,NULL,'2010-11-28 00:00:00',55528,18.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101128/1011281090164116065.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101128/jpg/1011281090164116065.master.jpg',NULL,NULL,67965746643,NULL,NULL,NULL,'2006-09-30 10:33:36',54008.440002,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011281090164116065/1011281090164116065.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101128/1011281090164116065p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1061964791,16593199,NULL,NULL,NULL,NULL),(18220,18220,0,'CSS101128-033604+010604','CRTS-CSS',54.0147,1.1011,NULL,NULL,'2010-11-28 00:00:00',55528,17.78,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101128/1011281010204114579.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101128/jpg/1011281010204114579.master.jpg',NULL,NULL,64992226357,NULL,NULL,NULL,'2010-01-12 12:28:49',55208.52002,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011281010204114579/1011281010204114579.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101128/1011281010204114579p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1015503536,15867242,NULL,NULL,NULL,NULL),(18221,18221,1,'CSS101114-005725-005752','CRTS-CSS',14.35281,-0.96434,NULL,NULL,'2010-11-14 00:00:00',55514,17.88,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101114/1011140010064126302.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101114/jpg/1011140010064126302.master.jpg',NULL,NULL,34520693537,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011140010064126302/1011140010064126302.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101114/1011140010064126302p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,539385836,8427903,NULL,NULL,NULL,NULL),(18222,18222,0,'CSS101113-171837+414057','CRTS-CSS',259.65219,41.68263,NULL,NULL,'2010-11-13 00:00:00',55513,17.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101113/1011131400724139601.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101113/jpg/1011131400724139601.master.jpg',NULL,NULL,59649586569,NULL,NULL,NULL,'2010-10-19 13:26:07',55488.559814,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011131400724139601/1011131400724139601.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101113/1011131400724139601p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,932024790,14562887,NULL,NULL,NULL,NULL),(18223,18223,0,'CSS101113-030504-194039','CRTS-CSS',46.26484,-19.67744,NULL,NULL,'2010-11-13 00:00:00',55513,17.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101113/1011130180164101206.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101113/jpg/1011130180164101206.master.jpg',NULL,NULL,38056328245,NULL,NULL,NULL,'2009-11-10 12:28:49',55145.52002,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011130180164101206/1011130180164101206.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101113/1011130180164101206p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,594630128,9291095,NULL,NULL,NULL,NULL),(18224,18224,0,'CSS101110-082047+355337','CRTS-CSS',125.19755,35.89374,NULL,NULL,'2010-11-10 00:00:00',55510,18.18,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101110/1011101350374137703.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101110/jpg/1011101350374137703.master.jpg',NULL,NULL,64337915367,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011101350374137703/1011101350374137703.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101110/1011101350374137703p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1005279927,15707498,NULL,NULL,NULL,NULL),(18225,18225,0,'CSS101110-024837+072412','CRTS-CSS',42.15479,7.40328,NULL,NULL,'2010-11-10 00:00:00',55510,18.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101110/1011101070154125768.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101110/jpg/1011101070154125768.master.jpg',NULL,NULL,67972344499,NULL,NULL,NULL,'2006-11-13 12:28:49',54052.52002,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011101070154125768/1011101070154125768.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101110/1011101070154125768p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1062067882,16594810,NULL,NULL,NULL,NULL),(18226,18226,1,'CSS101108-003641-033660','CRTS-CSS',9.16973,-3.61663,NULL,NULL,'2010-11-08 00:00:00',55508,18.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101108/1011080040044131101.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101108/jpg/1011080040044131101.master.jpg',NULL,NULL,34593965820,NULL,NULL,NULL,'2005-09-24 11:31:10',53637.47998,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011080040044131101/1011080040044131101.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101108/1011080040044131101p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,540530715,8445792,NULL,NULL,NULL,NULL),(18227,18227,1,'CSS101107-032602-004948','CRTS-CSS',51.50831,-0.82999,NULL,NULL,'2010-11-07 00:00:00',55507,19.45,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101107/1011070010194233970.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101107/jpg/1011070010194233970.master.jpg',NULL,NULL,36813834632,NULL,NULL,NULL,'2005-01-16 13:26:23',53386.559998,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011070010194233970/1011070010194233970.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101107/1011070010194233970p.html',NULL,NULL,1,'NT',NULL,0,NULL,0,575216166,8987752,NULL,NULL,NULL,NULL),(18228,18228,1,'CSS101106-234106+032724','CRTS-CSS',355.27374,3.45666,NULL,NULL,'2010-11-06 00:00:00',55506,18.86,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101106/1011061041274110862.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101106/jpg/1011061041274110862.master.jpg',NULL,NULL,51605520030,NULL,NULL,NULL,'2008-11-07 12:28:49',54777.52002,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011061041274110862/1011061041274110862.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101106/1011061041274110862p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,806336250,12599003,NULL,NULL,NULL,NULL),(18229,18229,0,'CSS101105-002052+333935','CRTS-CSS',5.21755,33.65985,NULL,NULL,'2010-11-05 00:00:00',55505,18.16,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:28','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101105/1011051320024147567.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101105/jpg/1011051320024147567.master.jpg',NULL,NULL,67353534397,NULL,NULL,NULL,'2005-01-16 13:26:23',53386.559998,'2013-01-22 16:45:28','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011051320024147567/1011051320024147567.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101105/1011051320024147567p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1052398974,16443733,NULL,NULL,NULL,NULL),(18230,18230,0,'CSS101105-020703+205114','CRTS-CSS',31.76049,20.85394,NULL,NULL,'2010-11-05 00:00:00',55505,18.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101105/1011051210114114362.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101105/jpg/1011051210114114362.master.jpg',NULL,NULL,68055884604,NULL,NULL,NULL,'2010-10-30 11:31:10',55499.47998,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011051210114114362/1011051210114114362.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101105/1011051210114114362p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,1063373196,16615206,NULL,NULL,NULL,NULL),(18231,18231,1,'CSS101104-001051+214127','CRTS-CSS',2.71127,21.69082,NULL,NULL,'2010-11-04 00:00:00',55504,19.67,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20101104/1011041210014132134.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101104/jpg/1011041210014132134.master.jpg',NULL,NULL,67447785391,NULL,NULL,NULL,'2006-09-19 10:33:36',53997.440002,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011041210014132134/1011041210014132134.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101104/1011041210014132134p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1053871646,16466744,NULL,NULL,NULL,NULL),(18232,18232,0,'CSS101101-084515+274924','CRTS-CSS',131.3117,27.8232,NULL,NULL,'2010-11-01 00:00:00',55501,15.18,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101101/1011011260434138055.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101101/jpg/1011011260434138055.master.jpg',NULL,NULL,64322477075,NULL,NULL,NULL,'2010-06-11 13:26:07',55358.559814,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1011011260434138055/1011011260434138055.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101101/1011011260434138055p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1005038704,15703729,NULL,NULL,NULL,NULL),(18233,18233,0,'CSS101017-014532+253215','CRTS-CSS',26.38296,25.53758,NULL,NULL,'2010-10-17 00:00:00',55486,17.53,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101017/1010171260094102098.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101017/jpg/1010171260094102098.master.jpg',NULL,NULL,67713686124,NULL,NULL,NULL,'2009-11-19 10:33:41',55154.440063,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010171260094102098/1010171260094102098.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101017/1010171260094102098p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1058026345,16531661,NULL,NULL,NULL,NULL),(18234,18234,0,'CSS101013-024537-111239','CRTS-CSS',41.40497,-11.21095,NULL,NULL,'2010-10-13 00:00:00',55482,17.16,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101013/1010130090154101363.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101013/jpg/1010130090154101363.master.jpg',NULL,NULL,37873094168,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010130090154101363/1010130090154101363.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101013/1010130090154101363p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,591767096,9246360,NULL,NULL,NULL,NULL),(18235,18235,0,'CSS101012-223516-214154','CRTS-CSS',338.81862,-21.69836,NULL,NULL,'2010-10-12 00:00:00',55481,16.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20101012/1010120211144113147.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20101012/jpg/1010120211144113147.master.jpg',NULL,NULL,50258907993,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1010120211144113147/1010120211144113147.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20101012/1010120211144113147p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,785295437,12270241,NULL,NULL,NULL,NULL),(18237,18237,1,'CSS100930-023742+150347','CRTS-CSS',39.42535,15.06296,NULL,NULL,'2010-09-30 00:00:00',55469,19.38,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100930/1009301150144112871.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100930/jpg/1009301150144112871.master.jpg',NULL,NULL,68146945406,NULL,NULL,NULL,'2005-12-24 10:33:36',53728.440002,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1009301150144112871/1009301150144112871.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100930/1009301150144112871p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,1064796021,16637437,NULL,NULL,NULL,NULL),(18238,18238,1,'CSS100916-005129-173828','CRTS-CSS',12.86966,-17.64101,NULL,NULL,'2010-09-16 00:00:00',55455,18.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100916/1009160180054126884.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100916/jpg/1009160180054126884.master.jpg',NULL,NULL,35425324748,NULL,NULL,NULL,'2009-11-17 13:26:29',55152.560059,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1009160180054126884/1009160180054126884.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100916/1009160180054126884p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,553520699,8648760,NULL,NULL,NULL,NULL),(18239,18239,0,'CSS100911-232213-051908','CRTS-CSS',350.55556,-5.31899,NULL,NULL,'2010-09-11 00:00:00',55450,18.61,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100911/1009110041254104463.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100911/jpg/1009110041254104463.master.jpg',NULL,NULL,49633243088,NULL,NULL,NULL,'2005-10-11 10:33:36',53654.440002,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1009110041254104463/1009110041254104463.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100911/1009110041254104463p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,775519423,12117490,NULL,NULL,NULL,NULL),(18240,18240,1,'CSS100910-001539+271250','CRTS-CSS',3.91308,27.21389,NULL,NULL,'2010-09-10 00:00:00',55449,18.13,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100910/1009101260024128411.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100910/jpg/1009101260024128411.master.jpg',NULL,NULL,67242445502,NULL,NULL,NULL,'2010-06-02 13:26:07',55349.559814,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1009101260024128411/1009101260024128411.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100910/1009101260024128411p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1050663210,16416612,NULL,NULL,NULL,NULL),(18241,18241,1,'CSS100706-141532-094356','CRTS-CSS',213.88224,-9.7322,NULL,NULL,'2010-07-06 00:00:00',55383,17.12,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100706/1007060090764128700.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100706/jpg/1007060090764128700.master.jpg',NULL,NULL,43720843481,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1007060090764128700/1007060090764128700.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100706/1007060090764128700p.html',NULL,NULL,0,'UNCLEAR',NULL,0,NULL,0,683138179,10674034,NULL,NULL,NULL,NULL),(18242,18242,1,'CSS100705-154310+091934','CRTS-CSS',235.79254,9.32615,NULL,NULL,'2010-07-05 00:00:00',55382,20.11,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100705/1007051090844114842.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100705/jpg/1007051090844114842.master.jpg',NULL,NULL,56604552875,NULL,NULL,NULL,'2010-06-09 13:26:07',55356.559814,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1007051090844114842/1007051090844114842.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100705/1007051090844114842p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,884446138,13819470,NULL,NULL,NULL,NULL),(18243,18243,1,'CSS100705-232939+080029','CRTS-CSS',352.41055,8.00804,NULL,NULL,'2010-07-05 00:00:00',55382,19.08,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100705/1007051071254133856.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100705/jpg/1007051071254133856.master.jpg',NULL,NULL,51807371407,NULL,NULL,NULL,'2009-12-19 13:26:29',55184.560059,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1007051071254133856/1007051071254133856.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100705/1007051071254133856p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,809490178,12648284,NULL,NULL,NULL,NULL),(18244,18244,0,'CSS100616-171654+313351','CRTS-CSS',259.22532,31.56405,NULL,NULL,'2010-06-16 00:00:00',55363,18.92,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100616/1006161320804115382.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100616/jpg/1006161320804115382.master.jpg',NULL,NULL,56361105521,NULL,NULL,NULL,'2010-05-23 13:26:07',55339.559814,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006161320804115382/1006161320804115382.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100616/1006161320804115382p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,880642273,13760035,NULL,NULL,NULL,NULL),(18245,18245,0,'CSS100616-163318+114505','CRTS-CSS',248.32468,11.75135,NULL,NULL,'2010-06-16 00:00:00',55363,18.63,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100616/1006161120874112489.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100616/jpg/1006161120874112489.master.jpg',NULL,NULL,56742890947,NULL,NULL,NULL,'2008-05-05 12:28:49',54591.52002,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006161120874112489/1006161120874112489.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100616/1006161120874112489p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,886607671,13853244,NULL,NULL,NULL,NULL),(18246,18246,0,'CSS100613-204814-054813','CRTS-CSS',312.05642,-5.80361,NULL,NULL,'2010-06-13 00:00:00',55360,17.27,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100613/1006130071114181704.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100613/jpg/1006130071114181704.master.jpg',NULL,NULL,50738955872,NULL,NULL,NULL,'2010-06-05 13:26:07',55352.559814,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006130071114181704/1006130071114181704.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100613/1006130071114181704p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,792796185,12387440,NULL,NULL,NULL,NULL),(18247,18247,0,'CSS100610-154344-092834','CRTS-CSS',235.93298,-9.4761,NULL,NULL,'2010-06-10 00:00:00',55357,17.73,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100610/1006100090844144261.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100610/jpg/1006100090844144261.master.jpg',NULL,NULL,45616748119,NULL,NULL,NULL,'2010-05-04 13:26:07',55320.559814,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006100090844144261/1006100090844144261.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100610/1006100090844144261p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,712761689,11136901,NULL,NULL,NULL,NULL),(18248,18248,0,'CSS100609-155011+121642','CRTS-CSS',237.5464,12.27847,NULL,NULL,'2010-06-09 00:00:00',55356,17.69,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100609/1006091120844120598.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100609/jpg/1006091120844120598.master.jpg',NULL,NULL,56529127565,NULL,NULL,NULL,'2010-05-23 11:31:10',55339.47998,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006091120844120598/1006091120844120598.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100609/1006091120844120598p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,883267618,13801056,NULL,NULL,NULL,NULL),(18249,18249,0,'CSS100605-162852+262229','CRTS-CSS',247.2171,26.37473,NULL,NULL,'2010-06-05 00:00:00',55352,18.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100605/1006051260804124282.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100605/jpg/1006051260804124282.master.jpg',NULL,NULL,56184412256,NULL,NULL,NULL,'2006-09-17 10:33:36',53995.440002,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006051260804124282/1006051260804124282.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100605/1006051260804124282p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,877881441,13716897,NULL,NULL,NULL,NULL),(18250,18250,1,'CSS100603-133408+295137','CRTS-CSS',203.53132,29.86025,NULL,NULL,'2010-06-03 00:00:00',55350,18.22,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:29','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100603/1006031290644120885.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100603/jpg/1006031290644120885.master.jpg',NULL,NULL,59134928384,NULL,NULL,NULL,'2009-02-26 10:33:41',54888.440063,'2013-01-22 16:45:29','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006031290644120885/1006031290644120885.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100603/1006031290644120885p.html',NULL,NULL,0,'AGN',NULL,0,NULL,0,923983256,14437238,NULL,NULL,NULL,NULL),(18251,18251,1,'CSS100603-142927+113909','CRTS-CSS',217.36416,11.65246,NULL,NULL,'2010-06-03 00:00:00',55350,19.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100603/1006031120774105805.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100603/jpg/1006031120774105805.master.jpg',NULL,NULL,59358795363,NULL,NULL,NULL,'2008-05-02 10:33:41',54588.440063,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1006031120774105805/1006031120774105805.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100603/1006031120774105805p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,927481177,14491893,NULL,NULL,NULL,NULL),(18252,18252,0,'CSS100531-153447+020550','CRTS-CSS',233.69754,2.09713,NULL,NULL,'2010-05-31 00:00:00',55347,17.52,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100531/1005311010844137345.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100531/jpg/1005311010844137345.master.jpg',NULL,NULL,56404661121,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005311010844137345/1005311010844137345.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100531/1005311010844137345p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,881322830,13770669,NULL,NULL,NULL,NULL),(18253,18253,1,'CSS100519-224549+100159','CRTS-CSS',341.45377,10.033,NULL,NULL,'2010-05-19 00:00:00',55335,20.06,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100519/1005191091214128907.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100519/jpg/1005191091214128907.master.jpg',NULL,NULL,52465848295,NULL,NULL,NULL,'2007-06-19 10:33:36',54270.440002,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005191091214128907/1005191091214128907.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100519/1005191091214128907p.html',NULL,NULL,1,'AGN',NULL,0,NULL,0,819778879,12809044,NULL,NULL,NULL,NULL),(18254,18254,1,'CSS100519-141142-134719','CRTS-CSS',212.92385,-13.78868,NULL,NULL,'2010-05-19 00:00:00',55335,18.67,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100519/1005190120754106709.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100519/jpg/1005190120754106709.master.jpg',NULL,NULL,43653345944,NULL,NULL,NULL,'2006-02-24 13:26:23',53790.559998,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005190120754106709/1005190120754106709.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100519/1005190120754106709p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,682083530,10657555,NULL,NULL,NULL,NULL),(18255,18255,1,'CSS100516-154634+271419','CRTS-CSS',236.64068,27.23867,NULL,NULL,'2010-05-16 00:00:00',55332,19.75,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100516/1005161260774132329.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100516/jpg/1005161260774132329.master.jpg',NULL,NULL,59872527666,NULL,NULL,NULL,'2010-04-17 13:26:07',55303.559814,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005161260774132329/1005161260774132329.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100516/1005161260774132329p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,935508244,14617316,NULL,NULL,NULL,NULL),(18256,18256,0,'CSS100516-142856+201904','CRTS-CSS',217.234,20.31778,NULL,NULL,'2010-05-16 00:00:00',55332,19.44,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100516/1005161210744109926.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100516/jpg/1005161210744109926.master.jpg',NULL,NULL,59510108272,NULL,NULL,NULL,'2008-06-24 12:28:49',54641.52002,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005161210744109926/1005161210744109926.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100516/1005161210744109926p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,929845441,14528835,NULL,NULL,NULL,NULL),(18257,18257,1,'CSS100514-131034+455805','CRTS-CSS',197.64273,45.96818,NULL,NULL,'2010-05-14 00:00:00',55330,19.43,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100514/1005141460504111692.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100514/jpg/1005141460504111692.master.jpg',NULL,NULL,59099324552,NULL,NULL,NULL,'2010-04-11 13:26:07',55297.559814,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005141460504111692/1005141460504111692.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100514/1005141460504111692p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,923426946,14428546,NULL,NULL,NULL,NULL),(18258,18258,0,'CSS100513-155016+044334','CRTS-CSS',237.56674,4.7261,NULL,NULL,'2010-05-13 00:00:00',55329,18.49,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100513/1005131040854136966.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100513/jpg/1005131040854136966.master.jpg',NULL,NULL,56619709267,NULL,NULL,NULL,'2005-06-16 11:31:10',53537.47998,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005131040854136966/1005131040854136966.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100513/1005131040854136966p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,884682957,13823171,NULL,NULL,NULL,NULL),(18259,18259,0,'CSS100513-144343+035816','CRTS-CSS',220.92854,3.97118,NULL,NULL,'2010-05-13 00:00:00',55329,16.78,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100513/1005131040794117717.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100513/jpg/1005131040794117717.master.jpg',NULL,NULL,58258694914,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005131040794117717/1005131040794117717.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100513/1005131040794117717p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,910292108,14223314,NULL,NULL,NULL,NULL),(18260,18260,0,'CSS100512-085247+531406','CRTS-CSS',133.19699,53.23504,NULL,NULL,'2010-05-12 00:00:00',55328,18.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100512/1005121520304133272.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100512/jpg/1005121520304133272.master.jpg',NULL,NULL,63485575044,NULL,NULL,NULL,'2006-11-19 12:28:49',54058.52002,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005121520304133272/1005121520304133272.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100512/1005121520304133272p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,991962110,15499407,NULL,NULL,NULL,NULL),(18261,18261,0,'CSS100512-115735+244228','CRTS-CSS',179.39465,24.7077,NULL,NULL,'2010-05-12 00:00:00',55328,18.44,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100512/1005121230594128285.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100512/jpg/1005121230594128285.master.jpg',NULL,NULL,60533334174,NULL,NULL,NULL,'2006-02-27 10:33:36',53793.440002,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005121230594128285/1005121230594128285.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100512/1005121230594128285p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,945833346,14778646,NULL,NULL,NULL,NULL),(18262,18262,1,'CSS100509-115149+222851','CRTS-CSS',177.95217,22.4809,NULL,NULL,'2010-05-09 00:00:00',55325,18.94,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100509/1005091210604139795.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100509/jpg/1005091210604139795.master.jpg',NULL,NULL,61070866605,NULL,NULL,NULL,'2010-04-17 13:26:07',55303.559814,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005091210604139795/1005091210604139795.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100509/1005091210604139795p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,954232290,14909879,NULL,NULL,NULL,NULL),(18263,18263,0,'CSS100509-105637+201442','CRTS-CSS',164.15494,20.24496,NULL,NULL,'2010-05-09 00:00:00',55325,18.05,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100509/1005091210564106606.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100509/jpg/1005091210564106606.master.jpg',NULL,NULL,61168609550,NULL,NULL,NULL,'2010-04-09 10:33:41',55295.440063,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005091210564106606/1005091210564106606.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100509/1005091210564106606p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,955759524,14933742,NULL,NULL,NULL,NULL),(18264,18264,1,'CSS100508-123628+144745','CRTS-CSS',189.11522,14.7957,NULL,NULL,'2010-05-08 00:00:00',55324,19.61,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100508/1005081150664109930.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100508/jpg/1005081150664109930.master.jpg',NULL,NULL,58885077864,NULL,NULL,NULL,'2010-04-13 13:26:07',55299.559814,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005081150664109930/1005081150664109930.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100508/1005081150664109930p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,920079341,14376239,NULL,NULL,NULL,NULL),(18265,18265,0,'CSS100507-103404+383230','CRTS-CSS',158.51795,38.54178,NULL,NULL,'2010-05-07 00:00:00',55323,19.52,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100507/1005071380464123897.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100507/jpg/1005071380464123897.master.jpg',NULL,NULL,64118286354,NULL,NULL,NULL,'2010-02-17 11:31:10',55244.47998,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005071380464123897/1005071380464123897.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100507/1005071380464123897p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,1001848224,15653878,NULL,NULL,NULL,NULL),(18266,18266,1,'CSS100505-122952-080912','CRTS-CSS',187.46511,-8.15321,NULL,NULL,'2010-05-05 00:00:00',55321,17.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100505/1005050070674106140.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100505/jpg/1005050070674106140.master.jpg',NULL,NULL,43217562392,NULL,NULL,NULL,'2010-04-10 13:26:29',55296.560059,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1005050070674106140/1005050070674106140.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100505/1005050070674106140p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,675274412,10551162,NULL,NULL,NULL,NULL),(18267,18267,0,'CSS100412-075259+052930','CRTS-CSS',118.24537,5.49163,NULL,NULL,'2010-04-12 00:00:00',55298,17.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100412/1004121040434181465.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100412/jpg/1004121040434181465.master.jpg',NULL,NULL,62730399789,NULL,NULL,NULL,'2010-02-18 13:26:29',55245.560059,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1004121040434181465/1004121040434181465.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100412/1004121040434181465p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,980162496,15315039,NULL,NULL,NULL,NULL),(18268,18268,0,'CSS100409-154258+021653','CRTS-CSS',235.74326,2.28129,NULL,NULL,'2010-04-09 00:00:00',55295,16.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100409/1004091010844148312.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100409/jpg/1004091010844148312.master.jpg',NULL,NULL,56390125099,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1004091010844148312/1004091010844148312.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100409/1004091010844148312p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,881095704,13767120,NULL,NULL,NULL,NULL),(18269,18269,0,'CSS100409-153038+005242','CRTS-CSS',232.65652,0.87831,NULL,NULL,'2010-04-09 00:00:00',55295,17.55,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100409/1004091010834118847.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100409/jpg/1004091010834118847.master.jpg',NULL,NULL,56399894729,NULL,NULL,NULL,'2005-05-31 12:28:47',53521.519989,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1004091010834118847/1004091010834118847.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100409/1004091010834118847p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,881248355,13769505,NULL,NULL,NULL,NULL),(18270,18270,1,'CSS100409-135312+002031','CRTS-CSS',208.29981,0.34185,NULL,NULL,'2010-04-09 00:00:00',55295,19.21,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100409/1004091010754106753.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100409/jpg/1004091010754106753.master.jpg',NULL,NULL,58410104551,NULL,NULL,NULL,'2008-02-11 11:31:10',54507.47998,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1004091010754106753/1004091010754106753.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100409/1004091010754106753p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,912657883,14260279,NULL,NULL,NULL,NULL),(18271,18271,0,'CSS100408-093530+012832','CRTS-CSS',143.87506,1.47549,NULL,NULL,'2010-04-08 00:00:00',55294,17.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100408/1004081010524121675.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100408/jpg/1004081010524121675.master.jpg',NULL,NULL,60697150825,NULL,NULL,NULL,'2008-12-29 10:33:41',54829.440063,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1004081010524121675/1004081010524121675.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100408/1004081010524121675p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,948392981,14818640,NULL,NULL,NULL,NULL),(18272,18272,1,'CSS100405-043746+211138','CRTS-CSS',69.44008,21.19375,NULL,NULL,'2010-04-05 00:00:00',55291,18.65,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:30','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100405/1004051210244130526.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100405/jpg/1004051210244130526.master.jpg',NULL,NULL,65287075704,NULL,NULL,NULL,'2010-03-12 13:26:29',55267.560059,'2013-01-22 16:45:30','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1004051210244130526/1004051210244130526.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100405/1004051210244130526p.html',NULL,NULL,0,'ORPHAN',NULL,0,NULL,0,1020110557,15939227,NULL,NULL,NULL,NULL),(18273,18273,0,'CSS100405-115801-062931','CRTS-CSS',179.5049,-6.49184,NULL,NULL,'2010-04-05 00:00:00',55291,18.77,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100405/1004050070644127898.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100405/jpg/1004050070644127898.master.jpg',NULL,NULL,40840654536,NULL,NULL,NULL,'2010-03-13 13:26:29',55268.560059,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1004050070644127898/1004050070644127898.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100405/1004050070644127898p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,638135227,9970862,NULL,NULL,NULL,NULL),(18274,18274,0,'CSS100405-114456-050444','CRTS-CSS',176.23218,-5.07894,NULL,NULL,'2010-04-05 00:00:00',55291,17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100405/1004050040634107943.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100405/jpg/1004050040634107943.master.jpg',NULL,NULL,40854580747,NULL,NULL,NULL,'2006-01-29 12:28:49',53764.52002,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1004050040634107943/1004050040634107943.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100405/1004050040634107943p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,638352824,9974262,NULL,NULL,NULL,NULL),(18275,18275,1,'CSS100404-114112+151410','CRTS-CSS',175.2981,15.23622,NULL,NULL,'2010-04-04 00:00:00',55290,19.64,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100404/1004041150614117315.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100404/jpg/1004041150614117315.master.jpg',NULL,NULL,60261376575,NULL,NULL,NULL,'2006-04-02 10:33:36',53827.440002,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1004041150614117315/1004041150614117315.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100404/1004041150614117315p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,941584008,14712250,NULL,NULL,NULL,NULL),(18276,18276,1,'CSS100326-151957+221953','CRTS-CSS',229.98888,22.3315,NULL,NULL,'2010-03-26 00:00:00',55281,19.17,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100326/1003261210784136534.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100326/jpg/1003261210784136534.master.jpg',NULL,NULL,59421444914,NULL,NULL,NULL,'2009-09-22 13:26:29',55096.560059,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003261210784136534/1003261210784136534.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100326/1003261210784136534p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,928460076,14507188,NULL,NULL,NULL,NULL),(18277,18277,0,'CSS100321-121444+433652','CRTS-CSS',183.68216,43.61439,NULL,NULL,'2010-03-21 00:00:00',55276,19.04,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100321/1003211430494120023.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100321/jpg/1003211430494120023.master.jpg',NULL,NULL,59057832898,NULL,NULL,NULL,'2008-03-11 11:31:10',54536.47998,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003211430494120023/1003211430494120023.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100321/1003211430494120023p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,922778639,14418416,NULL,NULL,NULL,NULL),(18278,18278,0,'CSS100321-122448+320655','CRTS-CSS',186.19932,32.11526,NULL,NULL,'2010-03-21 00:00:00',55276,18.11,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100321/1003211320574117341.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100321/jpg/1003211320574117341.master.jpg',NULL,NULL,58767379409,NULL,NULL,NULL,'2006-05-06 10:33:36',53861.440002,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003211320574117341/1003211320574117341.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100321/1003211320574117341p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,918240303,14347504,NULL,NULL,NULL,NULL),(18279,18279,1,'CSS100321-110128+314449','CRTS-CSS',165.36569,31.74703,NULL,NULL,'2010-03-21 00:00:00',55276,16.7,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100321/1003211320514111504.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100321/jpg/1003211320514111504.master.jpg',NULL,NULL,60508246516,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003211320514111504/1003211320514111504.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100321/1003211320514111504p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,945441351,14772521,NULL,NULL,NULL,NULL),(18280,18280,1,'CSS100320-135108+133407','CRTS-CSS',207.78253,13.56852,NULL,NULL,'2010-03-20 00:00:00',55275,19.36,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100320/1003201120734136417.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100320/jpg/1003201120734136417.master.jpg',NULL,NULL,58341733028,NULL,NULL,NULL,'2010-02-19 13:26:29',55246.560059,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003201120734136417/1003201120734136417.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100320/1003201120734136417p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,911589578,14243587,NULL,NULL,NULL,NULL),(18281,18281,1,'CSS100320-123622+074737','CRTS-CSS',189.09218,7.79352,NULL,NULL,'2010-03-20 00:00:00',55275,18.92,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100320/1003201070674134658.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100320/jpg/1003201070674134658.master.jpg',NULL,NULL,58239944806,NULL,NULL,NULL,'2005-03-10 10:33:34',53439.439987,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003201070674134658/1003201070674134658.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100320/1003201070674134658p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,909999137,14218736,NULL,NULL,NULL,NULL),(18282,18282,1,'CSS100320-045348+003618','CRTS-CSS',73.4508,0.60498,NULL,NULL,'2010-03-20 00:00:00',55275,18.43,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100320/1003201010274111459.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100320/jpg/1003201010274111459.master.jpg',NULL,NULL,64617535875,NULL,NULL,NULL,'2010-02-18 13:26:29',55245.560059,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003201010274111459/1003201010274111459.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100320/1003201010274111459p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1009648998,15775765,NULL,NULL,NULL,NULL),(18283,18283,1,'CSS100318-134734+333104','CRTS-CSS',206.89327,33.51766,NULL,NULL,'2010-03-18 00:00:00',55273,19.76,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100318/1003181320644139367.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100318/jpg/1003181320644139367.master.jpg',NULL,NULL,59183139390,NULL,NULL,NULL,'2009-08-02 13:26:29',55045.560059,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003181320644139367/1003181320644139367.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100318/1003181320644139367p.html',NULL,NULL,1,'SN',NULL,0,NULL,0,924736552,14449008,NULL,NULL,NULL,NULL),(18284,18284,0,'CSS100317-092742+443437','CRTS-CSS',141.92589,44.57681,NULL,NULL,'2010-03-17 00:00:00',55272,18.79,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100317/1003171430384133703.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100317/jpg/1003171430384133703.master.jpg',NULL,NULL,64263687642,NULL,NULL,NULL,'2006-02-03 12:28:49',53769.52002,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003171430384133703/1003171430384133703.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100317/1003171430384133703p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1004120119,15689376,NULL,NULL,NULL,NULL),(18285,18285,1,'CSS100317-102731+401548','CRTS-CSS',156.88123,40.26344,NULL,NULL,'2010-03-17 00:00:00',55272,18.91,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100317/1003171400444111913.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100317/jpg/1003171400444111913.master.jpg',NULL,NULL,64151739901,NULL,NULL,NULL,'2008-03-05 10:33:41',54530.440063,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003171400444111913/1003171400444111913.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100317/1003171400444111913p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,1002370935,15662045,NULL,NULL,NULL,NULL),(18286,18286,0,'CSS100317-125924+275948','CRTS-CSS',194.85005,27.99654,NULL,NULL,'2010-03-17 00:00:00',55272,16.2,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100317/1003171260634141181.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100317/jpg/1003171260634141181.master.jpg',NULL,NULL,58699079437,NULL,NULL,NULL,'2010-02-17 13:26:29',55244.560059,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003171260634141181/1003171260634141181.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100317/1003171260634141181p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,917173116,14330829,NULL,NULL,NULL,NULL),(18287,18287,0,'CSS100317-123527+270403','CRTS-CSS',188.86329,27.06744,NULL,NULL,'2010-03-17 00:00:00',55272,17.51,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100317/1003171260614126522.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100317/jpg/1003171260614126522.master.jpg',NULL,NULL,58609451777,NULL,NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003171260614126522/1003171260614126522.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100317/1003171260614126522p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,915772684,14308948,NULL,NULL,NULL,NULL),(18288,18288,1,'CSS100317-151949+023120','CRTS-CSS',229.95603,2.5221,NULL,NULL,'2010-03-17 00:00:00',55272,18.52,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100317/1003171010824148041.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100317/jpg/1003171010824148041.master.jpg',NULL,NULL,56376910288,NULL,NULL,NULL,'2005-01-18 12:28:47',53388.519989,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003171010824148041/1003171010824148041.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100317/1003171010824148041p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,880889223,13763894,NULL,NULL,NULL,NULL),(18289,18289,1,'CSS100316-161320+331912','CRTS-CSS',243.33491,33.31991,NULL,NULL,'2010-03-16 00:00:00',55271,19.84,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100316/1003161320754141950.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100316/jpg/1003161320754141950.master.jpg',NULL,NULL,59784285656,NULL,NULL,NULL,'2009-09-28 13:26:29',55102.560059,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003161320754141950/1003161320754141950.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100316/1003161320754141950p.html',NULL,NULL,1,'ORPHAN',NULL,0,NULL,0,934129463,14595772,NULL,NULL,NULL,NULL),(18290,18290,1,'CSS100315-101242-015815','CRTS-CSS',153.17647,-1.97083,NULL,NULL,'2010-03-15 00:00:00',55270,19,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-11 14:10:04','http://nesssi.cacr.caltech.edu/catalina/20100315/1003150010554112410.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100315/jpg/1003150010554112410.master.jpg',NULL,NULL,41266170931,NULL,NULL,NULL,'2010-02-16 13:26:29',55243.560059,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003150010554112410/1003150010554112410.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100315/1003150010554112410p.html',NULL,NULL,0,'SN',NULL,0,NULL,0,644783920,10074748,NULL,NULL,NULL,NULL),(18291,18291,0,'CSS100313-112547-084941','CRTS-CSS',171.44463,-8.82816,NULL,NULL,'2010-03-13 00:00:00',55268,18.57,NULL,'R',NULL,NULL,NULL,NULL,'2013-01-22 16:45:31','2019-10-12 20:41:36','http://nesssi.cacr.caltech.edu/catalina/20100313/1003130090614136707.html','SN',NULL,NULL,NULL,NULL,'http://nesssi.cacr.caltech.edu/catalina/20100313/jpg/1003130090614136707.master.jpg',NULL,NULL,41008824195,NULL,NULL,NULL,'2010-02-16 13:26:29',55243.560059,'2013-01-22 16:45:31','http://voeventnet.caltech.edu/feeds/ATEL/CRTS/1003130090614136707/1003130090614136707.find.jpg','http://nesssi.cacr.caltech.edu/catalina/20100313/1003130090614136707p.html',NULL,NULL,0,'NT',NULL,0,NULL,0,640762878,10011919,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `transientBucket` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2020-05-13 20:04:29
